package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:apd:(业务表)进口代理付款融资表
*/
@Table("apd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Apd extends AbstractModule
{

        public Apd(){
            super();
        }

        public Apd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "apd";
        }

        //唯一编号
        private String inr ;
        //业务编号
        private String ownref ;
        //STL编号
        private String stlref ;
        //业务操作人员
        private String ownusr ;
        //所属机构
        private String ptyinr ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //申请代付期限
        private Integer payexpdat;
        //申请代付金额
        private BigDecimal payamt  = new BigDecimal("0.00");
        //融资类型
        private String fintyp ;
        //融资利率
        private BigDecimal finrat  = new BigDecimal("0.00");
        //信用证付款期限
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //所属实体
        private String etyinr ;
        //交单方式
        private String doctypcod ;
        //罚息利率
        private BigDecimal disrat  = new BigDecimal("0.00");
        //合同编号
        private String connum ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //所属落地机构
        private String bchcod ;
        //信用证/到单/汇出金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //信用证/到单/汇出币种
        private String cur ;
        //申请代付币种
        private String paycur ;
        //进口代付业务权责条款
        private String irfcnd ;
        //发票号/信用证号
        private String ref ;
        //父交易类型
        private String pnttyp ;
        //父交易编号
        private String pntinr ;
        //融资到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //合计币种
        private String totcur ;
        //合计金额
        private BigDecimal totamt  = new BigDecimal("0.00");
        //入账帐号
        private String accact ;
        //代付内容
        private String apldoc ;
        //父交易参号
        private String pntref ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //主交易附属表标志
        private String flags ;
        //贸易合同名称
        private String connam ;
        //信用证币别
        private String lrscur ;
        //信用证金额
        private BigDecimal lrsamt  = new BigDecimal("0.00");
        //信用证付款期限
        private String lrdate ;
        //代收发票号
        private String colref ;
        //汇款发票号
        private String payref ;
        //代付费率
        private BigDecimal opyrat  = new BigDecimal("0.00");
        //代付指示
        private String apdtip ;
        //出口商
        private String otyinr ;
        //进口商品
        private String inrgod ;
        //大写
        private String word ;
        //利息偿还方式
        @Column("lxchfd")
        private String lxchfs ;


































































































}