package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:apyctm:(系统表)报关单信息表
*/
@Table("apyctm")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Apyctm extends AbstractModule
{

        public Apyctm(){
            super();
        }

        public Apyctm(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "apyctm";
        }

        //内部编号
        private String inr ;
        //业务类型
        private String objtyp ;
        //业务编号
        private String objinr ;
        //报关单号
        private String atcnum ;
        //报关币种
        private String atccur ;
        //报关金额
        private BigDecimal atcamt  = new BigDecimal("0.00");
        //核注币种
        private String chkcur ;
        //核注金额
        private BigDecimal chkamt  = new BigDecimal("0.00");
        //修改标志
        private String modflg ;
        //进口日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date importdate;
        //贸易国
        private String loadingcountry ;
        //占用金额
        private BigDecimal totalamt  = new BigDecimal("0.00");




























}