package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:bcd:(业务表)进口代收表
*/
@Table("bcd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bcd extends AbstractModule
{

        public Bcd(){
            super();
        }

        public Bcd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "bcd";
        }

        //内部编号
        private String inr ;
        //业务申请号码
        private String ownref ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //代收币别
        private String occcur ;
        //代收金额
        private BigDecimal occamt  = new BigDecimal("0.00");
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //到单币别
        private String doccur ;
        //合同编号
        private String conno ;
        //到单金额
        private BigDecimal docamt  = new BigDecimal("0.00");
        //索偿金额
        private BigDecimal caoamt  = new BigDecimal("0.00");
        //索偿币别
        private String caocur ;
        //承兑金额
        private BigDecimal acpamt  = new BigDecimal("0.00");
        //承兑币别
        private String acpcur ;
        //承兑日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //提示日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date predat;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //单据状态
        private String docflg ;
        //所属落地机构
        private String bchcod ;
        //客户编号
        private String ptyinr ;
        //托收指示
        private String colins ;
        //实体机构编号
        private String etyinr ;
        //交单方式
        private String doctypcod ;
        //办理业务交易员编号
        private String ownusr ;
        //拒绝付款内容
        private String rejpaytxt ;
        //STL编号
        private String stlref ;
        //承兑到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //付款期限的天/月数Number of Days/Months for Maturity Period
        private String matpercnt ;
        //付款期限的类型（天/月）Days/Months or Years for Maturity Period
        private String matpertyp ;
        //发票号码
        private String invno ;
        //装船日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //申请事项
        private String apltyp ;
        //拒付结果
        private String refres ;
        //备注
        private String note ;
        //申请内容
        private String apltxt ;
        //收单日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rcvdat;
        //付款日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date paydat;
        //单据处理
        private String docgrd ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //现汇金额
        private BigDecimal fxamt  = new BigDecimal("0.00");
        //它汇金额
        private BigDecimal othamt  = new BigDecimal("0.00");
        //购汇金额
        private BigDecimal puramt  = new BigDecimal("0.00");
        //现汇账号
        private String fxact ;
        //它汇账号
        private String othact ;
        //购汇账号
        private String puract ;
        //是否现汇
        private String fxflg ;
        //是否它汇
        private String othflg ;
        //是否购汇
        private String purflg ;
        //申请结汇金额
        private BigDecimal jaccamt  = new BigDecimal("0.00");
        //申请结汇币种
        private String jacccur ;
        //汇出/入金额
        private BigDecimal remamt  = new BigDecimal("0.00");
        //汇出/入币别
        private String remcur ;
        //是否付汇
        private String fhflg ;
        //是否代付
        private String dfflg ;
        //资金来源
        private String zjly ;
        //网银购汇额度编号
        private String wyghedno ;
























































































































}