package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:bed:(业务表)出口信用证项下的单据表
*/
@Table("bed")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bed extends AbstractModule
{

        public Bed(){
            super();
        }

        public Bed(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "bed";
        }

        //内部编号
        private String inr ;
        //业务编号
        private String ownref ;
        //单据币别
        private String doccur ;
        //单据金额
        private BigDecimal docamt  = new BigDecimal("0.00");
        //寄单通知日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //单据到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //发票号码
        private String invno ;
        //银行业务编号
        private String stlref ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //单据寄往
        private String sndto ;
        //父交易类型
        private String pnttyp ;
        //父交易inr
        private String pntinr ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //银行手续费
        private BigDecimal bkcfee  = new BigDecimal("0.00");
        //办理业务交易员编号
        private String ownusr ;
        //客户编号
        private String ptyinr ;
        //所属落地机构
        private String bchcod ;
        //实体机构编号
        private String etyinr ;
        //收汇/无偿放单金额
        private BigDecimal ddamt  = new BigDecimal("0.00");
        //收汇/无偿放单币别
        private String ddcur ;
        //入账金额
        private BigDecimal accamt  = new BigDecimal("0.00");
        //入账币别
        private String acccur ;
        //入账帐号
        private String accno ;
        //拒付声明
        private String docins ;
        //单据类型
        private String doctyp ;
        //结汇牌价
        private BigDecimal exrate  = new BigDecimal("0.00");
        //国外银行扣费
        private BigDecimal fncfee  = new BigDecimal("0.00");
        //邮电费
        private BigDecimal ptcfee  = new BigDecimal("0.00");
        //通知号
        private String advno ;
        //本次出单币别
        private String opncur ;
        //本次出单金额
        private BigDecimal opnamt  = new BigDecimal("0.00");
        //出单后余额币别
        private String balcur ;
        //出单后余额
        private BigDecimal balamt  = new BigDecimal("0.00");
        //快递公司名称
        private String emsnam ;
        //快递编号
        private String emsnum ;
        //出单日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date docdat;
        //（总行端）(本次出单总金额/增加金额/减少金额)币别
        private String modcur ;
        //（总行端）本次出单总金额
        private BigDecimal clmamt  = new BigDecimal("0.00");
        //（总行端）增加金额
        private BigDecimal addamt  = new BigDecimal("0.00");
        //（总行端）减少金额
        private BigDecimal decamt  = new BigDecimal("0.00");
        //（总行端）Date of Shipment
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //（总行端）Other Date
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date othdat;
        //（总行端）申请日期Receive on
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rcvdat;
        //（总行端）交单日期Presented on
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date predat;
        //承兑币别
        private String acpcur ;
        //承兑金额
        private BigDecimal acpamt  = new BigDecimal("0.00");
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //(总行端)付款指示
        private String payinstxt ;
        //(总行端)承兑指示
        private String usadet ;
        //(总行端)附加条款
        private String addphr ;
        //父交易的STL编号
        private String pntref ;
        //付款期限
        private String tenor ;
        //业务币别
        private String isscur ;
        //业务金额
        private BigDecimal issamt  = new BigDecimal("0.00");
        //父交易业务编号
        private String pntstlref ;
        //单据信息
        private String docgrd ;
        //合并后期限
        private String tenors ;
        //（总行端）审单意见
        private String opinion ;
        //（总行端）审单日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date busdat;
        //(总行端)起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date interdat;
        //（总行端）偿付指示
        private String rembtxt ;
        //备注
        private String remark ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //单据目前业务状态
        private String docflg ;
        //装运日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date lzydat;
        //核销单编号
        private String bopno ;
        //原币入账
        private String isyrc ;
        //结汇入账
        private String isjrc ;
        //原币入账账号
        private String yrcno ;
        //结汇入账账号
        private String jrcno ;
        //信用证及修改份数
        private String isrep ;
        //信用证份数
        private String lfsno ;
        //不符点选项
        private String isadd ;
        //不符点内容
        private String bfdnote ;
        //不符点处置选项1
        private String bfds1 ;
        //不符点处置选项2
        private String bfds2 ;
        //交单申请
        private String bedtyp ;
        //其他单据信息
        private String othdoc ;
        //电提不符点
        private String bfdsno ;




































































































































































}