package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:bod:出口托收表
*/
@Table("bod")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bod extends AbstractModule
{

        public Bod(){
            super();
        }

        public Bod(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "bod";
        }

        //内部编号
        private String inr ;
        //业务编号
        private String ownref ;
        //客户编号
        private String ptyinr ;
        //业务关闭日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //托收日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //发票号码
        private String invno ;
        //托收金额
        private BigDecimal occamt  = new BigDecimal("0.00");
        //托收币种
        private String occcur ;
        //单据编号
        private String docref ;
        //单据金额
        private BigDecimal docamt  = new BigDecimal("0.00");
        //单据币种
        private String doccur ;
        //收汇金额
        private BigDecimal setamt  = new BigDecimal("0.00");
        //收汇币别
        private String setcur ;
        //入账金额
        private BigDecimal accamt  = new BigDecimal("0.00");
        //入账币种
        private String acccur ;
        //入账账号
        private String accno ;
        //结汇牌价
        private BigDecimal excrat  = new BigDecimal("0.00");
        //银行手续费
        private BigDecimal bakfee  = new BigDecimal("0.00");
        //邮电费
        private BigDecimal pstfee  = new BigDecimal("0.00");
        //快递公司名称
        private String emsnam ;
        //快递公司编号
        private String emsnum ;
        //预计到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date pstdat;
        //收单通知日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //单据到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //单据状态
        private String docflg ;
        //装船日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //提示日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date predat;
        //收单日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rcvdat;
        //交单条件
        private String doctypcod ;
        //该业务操作人员编号
        private String ownusr ;
        //实体机构编号
        private String etyinr ;
        //STL编号
        private String stlref ;
        //国外银行扣费
        private BigDecimal fbkfee  = new BigDecimal("0.00");
        //所属落地机构
        private String bchcod ;
        //付款期限的天/月数
        private Integer matpercnt;
        //付款期限的类型（天/月）
        private String matpertyp ;
        //核销单编号
        private String bopno ;
        //修改托收币别
        private String modcur ;
        //修改托收金额
        private BigDecimal modamt  = new BigDecimal("0.00");
        //变更到期日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date moddat;
        //申请内容
        private String apltxt ;
        //申请类型
        private String apltyp ;
        //单据及份数
        private String docgrd ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //入账账号2
        private String accnotwo ;
        //原币入账账号
        private String yrcno ;
        //结汇入账账号
        private String jrcno ;
        //原币入账
        private String isyrc ;
        //结汇入账
        private String isjrc ;
        //付款人承担费用
        private String givamt ;
        //不用做拒付等证书
        private String notlce ;














































































































}