package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:bpd:(业务表)转议付融资表
*/
@Table("bpd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bpd extends AbstractModule
{

        public Bpd(){
            super();
        }

        public Bpd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "bpd";
        }

        //内部编号
        private String inr ;
        //业务申请号码
        private String ownref ;
        //业务闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //预扣利息金额
        private BigDecimal intamt  = new BigDecimal("0.00");
        //押汇币别
        private String fftcur ;
        //押汇金额
        private BigDecimal fftamt  = new BigDecimal("0.00");
        //押汇期限日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //入账金额
        private BigDecimal accamt  = new BigDecimal("0.00");
        //入账账号
        private String accact ;
        //入账币别
        private String acccur ;
        //当日牌价
        private BigDecimal intrat  = new BigDecimal("0.00");
        //押汇协议编号
        private String advagrnum ;
        //所属落地机构
        private String bchcod ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //银行手续费
        private BigDecimal bnkfee  = new BigDecimal("0.00");
        //实体机构编号
        private String etyinr ;
        //付款期限
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //国外银行扣费
        private BigDecimal fncfee  = new BigDecimal("0.00");
        //申请押汇类型
        private String fintyp ;
        //预扣利息币种
        private String intcur ;
        //发票金额
        private BigDecimal invamt  = new BigDecimal("0.00");
        //发票币别
        private String invcur ;
        //押汇开立日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //业务所属操作员
        private String ownusr ;
        //父交易inr
        private String pntinr ;
        //押汇款项入账类型
        private String paytyp ;
        //父交易类型
        private String pnttyp ;
        //业务所属机构
        private String ptyinr ;
        //人民币账号
        private String rmbact ;
        //STL编号
        private String stlref ;
        //交单联系单编号
        private String cntdocnum ;
        //邮电费
        private BigDecimal pstfee  = new BigDecimal("0.00");
        //押汇起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date fftvaldat;
        //押汇余额
        private BigDecimal fftbanamt  = new BigDecimal("0.00");
        //偿还币种
        private String retcur ;
        //偿还金额
        private BigDecimal retamt  = new BigDecimal("0.00");
        //还款划转类型
        private String rettyp ;
        //企业备注
        private String note ;
        //单据金额
        private BigDecimal docamt  = new BigDecimal("0.00");
        //单据币种
        private String doccur ;
        //发票号
        private String invno ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //父交易STL编号
        private String pntref ;
        //信用证号
        private String lcref ;
        //申请/通知标志
        private String flg ;
        //权责条款
        private String rgtclu ;
        //押汇期限
        private Integer days;
        //dbchcod
        private String dbchcod ;
        //ibchcod
        private String ibchcod ;
        //执行利率
        private BigDecimal exerat  = new BigDecimal("0.00");
        //合同号
        private String conref ;
        //标志位
        private String flags ;
        //结汇入账单据
        private String jhrzbills ;
        //无法提交单据原因
        private String bilreason ;
        //付款期限（托收下）
        private String tenor ;
        //在押汇到期日偿还
        private String yret ;
        //还款期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date retdat;
        //不在在押汇到期日偿还
        private String nret ;
        //大写押汇金额
        private String dftamt ;
        //利率方式
        private String llsty ;
        //协商利率
        private BigDecimal xdrat  = new BigDecimal("0.00");
        //贵行公布利率
        private BigDecimal gbrat  = new BigDecimal("0.00");
        //基点
        private BigDecimal jdrat  = new BigDecimal("0.00");
        //计收利息方式
        private String jssty ;
        //其他方式收取
        private String qtnote ;
        //逾期追加利率
        private BigDecimal yqrat  = new BigDecimal("0.00");
        //出口押汇币种
        private String ttcur ;
        //出口押汇金额
        private BigDecimal ttamt  = new BigDecimal("0.00");
        //押汇手续费
        private BigDecimal yttrat  = new BigDecimal("0.00");
        //上述利息我已全部同意
        private String isagr ;
        //对代收行指示
        private String dsnot ;
        //押汇付款方式为XX项下出口押汇
        private String fkfs ;
        //融资类型
        private String ptytyp ;
        //外币押汇利率执行方式
        private String fcnytyp ;
        //协商利率
        private BigDecimal consrate  = new BigDecimal("0.00");
        //公布利率
        private BigDecimal postedrate  = new BigDecimal("0.00");
        //LIBOR/HIBOR
        private String lihibor ;
        //基点数值
        private Integer basnum;
        //人民币押汇利率方式
        private String cnyltyp ;
        //利率浮动周期
        private String ratcycle ;
        //月结息日
        private String ratday ;
        //利率其他约定
        private String othrat ;
        //市场利率报价时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date lrldat;
        //市场利率类型
        private String lrltyp ;
        //市场利率
        private BigDecimal lrlrat  = new BigDecimal("0.00");
        //BPs+/-
        private String bpsas ;
        //BPs值
        private Integer bpsnum;
        //实际执行年利率
        private BigDecimal trunll  = new BigDecimal("0.00");
        //罚息比例
        private BigDecimal disrat  = new BigDecimal("0.00");






















































































































































































}