package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:brd:(业务表)进口信用证项下的单据表
*/
@Table("brd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brd extends AbstractModule
{

        public Brd(){
            super();
        }

        public Brd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "brd";
        }

        //内部编号
        private String inr ;
        //到单金额
        private BigDecimal advamt  = new BigDecimal("0.00");
        //单据币别
        private String totcur ;
        //单据金额
        private BigDecimal totamt  = new BigDecimal("0.00");
        //STL编号
        private String stlref ;
        //实际索偿金额
        private BigDecimal relamt  = new BigDecimal("0.00");
        //收单日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rcvdat;
        //客户编号
        private String ptyinr ;
        //父交易类型
        private String pnttyp ;
        //父交易inr
        private String pntinr ;
        //操作人员编号
        private String ownusr ;
        //业务申请号码
        private String ownref ;
        //到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //实体机构编号
        private String etyinr ;
        //单证目前业务状态
        private String docflg ;
        //电提日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date disdat;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //所属落地机构
        private String bchcod ;
        //接收日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //到单币别
        private String advcur ;
        //申请事项
        private String apltyp ;
        //备注
        private String note ;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //申请内容(如在杂项申请之外遇到，请标记)
        private String apltxt ;
        //承兑日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //承兑到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date accdat;
        //承兑币别
        private String acpcur ;
        //承兑金额
        private BigDecimal acpamt  = new BigDecimal("0.00");
        //付款/无偿放单币别
        private String ddcur ;
        //付款/无偿放单金额
        private BigDecimal ddamt  = new BigDecimal("0.00");
        //拒付内容
        private String rejpaytxt ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //拒付结果
        private String refres ;
        //实际索偿币别
        private String relcur ;
        //授权类型（授权议付/承兑/付款通知）
        private String furide ;
        //合同号
        private String conno ;
        //进口信用证号
        private String lcref ;
        //父交易STL编号
        private String pntstlref ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //现汇金额
        private BigDecimal fxamt  = new BigDecimal("0.00");
        //它汇金额
        private BigDecimal othamt  = new BigDecimal("0.00");
        //购汇金额
        private BigDecimal puramt  = new BigDecimal("0.00");
        //现汇账号
        private String fxact ;
        //它汇账号
        private String othact ;
        //购汇账号
        private String puract ;
        //是否现汇
        private String fxflg ;
        //是否它汇
        private String othflg ;
        //是否购汇
        private String purflg ;
        //申请结汇金额
        private BigDecimal jaccamt  = new BigDecimal("0.00");
        //申请结汇币种
        private String jacccur ;
        //汇出/入金额
        private BigDecimal remamt  = new BigDecimal("0.00");
        //汇出/入币别
        private String remcur ;
        //是否押汇
        private String fhflg ;
        //是否代付
        private String dfflg ;
        //资金来源
        private String zjly ;
        //网银购汇额度编号
        private String wyghedno ;
        //处理方式
        private String advtyp ;
























































































































}