package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:bxd:保证金协议表
*/
@Table("bxd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bxd extends AbstractModule
{

        public Bxd(){
            super();
        }

        public Bxd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "bxd";
        }

        //主键
        private String inr ;
        //关联参号
        private String ref ;
        //保证金协议编号
        private String ownref ;
        //关联表名
        private String objtyp ;
        //关联主键
        private String objinr ;
        //主记录标识
        private String typ ;
        //甲方
        private String jf ;
        //甲方法人代表
        private String jffrdb ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方（单位）
        private String yf ;
        //乙方法人代表
        private String yffrdb ;
        //乙方自然人
        private String yfzrr ;
        //乙方(自然人)证件类型
        private String yfzjlx ;
        //乙方(自然人)证件号码
        private String yfzjhm ;
        //乙方收件单位地址
        private String yfdwdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方联系电话
        private String yflxdh ;
        //乙方联系人
        private String yflxr ;
        //指定代收人名称
        private String dsr ;
        //代收地址
        private String dsdz ;
        //代收邮政编码
        private String dsyzbm ;
        //代收联系电话
        private String dslxdh ;
        //乙方(自然人)收件人名称
        private String yfsjrmc ;
        //乙方(自然人)收件人地址
        private String yfsjrdz ;
        //乙方(自然人)邮政编码
        private String yfyzbm2 ;
        //乙方(自然人)联系电话
        private String yflxdh2 ;
        //乙方(自然人)指定代收人名称
        private String zddsrmc2 ;
        //乙方(自然人)代收人地址
        private String dsrdz2 ;
        //乙方(自然人)代收人邮编
        private String dsryb2 ;
        //乙方(自然人)代收人电话
        private String dsrdh2 ;
        //乙方传真号码
        private String yfczhm ;
        //乙方电子邮件
        private String yfdzyj ;
        //乙方手机号码
        private String yfsjhm ;
        //债务人
        private String zwr ;
        //合同名称
        private String htmc ;
        //合同编号
        private String htbh ;
        //业务种类
        private String ywzl ;
        //保证金比例
        private BigDecimal bzjbl  = new BigDecimal("0.00");
        //天数
        private Integer ts;
        //保证金账户
        private String bzjzh ;
        //币种
        private String cur ;
        //小写金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //存管约定
        private String cgyd ;
        //月数
        private Integer ys;
        //保证金起存日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bzjqcrq;
        //保证金到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bzjdqr;
        //月利率(千分之)
        private BigDecimal yll  = new BigDecimal("0.00");
        //年利率(百分之)
        private BigDecimal nll  = new BigDecimal("0.00");
        //计息约定
        private String jxyd ;
        //计息约定其他
        private String jxydqt ;
        //约定结息
        private String jsyd ;
        //约定结息其他
        private String jsydqt ;
        //X日内补足保证金
        private Integer bzbzjts;
        //违约金比例
        private BigDecimal wyjbl  = new BigDecimal("0.00");
        //争议解决方式
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //开庭地点
        private String ktdd ;
        //争议解决其他方式
        private String qtfs ;
        //补充条款
        private String bctk ;
        //业务所属机构
        private String ptyinr ;
        //所属落地机构号
        private String bchcod ;






























































































































}