package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:cpd:(业务表)汇款表
*/
@Table("cpd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpd extends AbstractModule
{

        public Cpd(){
            super();
        }

        public Cpd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cpd";
        }

        //内部编号
        private String inr ;
        //汇出日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //汇出/入币别
        private String remcur ;
        //汇出/入金额
        private BigDecimal remamt  = new BigDecimal("0.00");
        //业务所属机构
        private String ptyinr ;
        //业务申请号码
        private String ownref ;
        //它汇账号
        private String othact ;
        //发票号码
        private String invno ;
        //国外费用币别
        private String gfrcur ;
        //国外费用金额
        private BigDecimal gframt  = new BigDecimal("0.00");
        //手续费币别
        private String frecur ;
        //手续费金额
        private BigDecimal freamt  = new BigDecimal("0.00");
        //实体机构编号
        private String etyinr ;
        //STL编号
        private String stlref ;
        //费用承担方
        private String detchgcod ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //所属落地机构
        private String bchcod ;
        //主体标识码
        private String atccod ;
        //入账账号
        private String accno ;
        //BOP金额1
        private BigDecimal bopamt1  = new BigDecimal("0.00");
        //BOP金额2
        private BigDecimal bopamt2  = new BigDecimal("0.00");
        //BOP交易编号1
        private String bopcod1 ;
        //BOP交易编号2
        private String bopcod2 ;
        //BOP交易附言1
        private String bopinf1 ;
        //BOP交易附言2
        private String bopinf2 ;
        //是否为进口核销下付款
        private String cavpayflg ;
        //合同号码
        private String conno ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //外管局备案表号
        private String fmdno ;
        //现汇账号
        private String fxact ;
        //账号类型
        private String acttyp ;
        //现汇金额
        private BigDecimal fxamt  = new BigDecimal("0.00");
        //境内境外标志
        private String inoutflg ;
        //它汇金额
        private BigDecimal othamt  = new BigDecimal("0.00");
        //操作人员编号
        private String ownusr ;
        //付款选择
        private String paytyp ;
        //发电等级
        private String priority ;
        //购汇帐号
        private String puract ;
        //购汇金额
        private BigDecimal puramt  = new BigDecimal("0.00");
        //收款人帐号
        private String pyeact ;
        //收款人所在国家代码
        private String pyecry ;
        //汇款附言
        private String reminf ;
        //汇款类型
        private String rmttyp ;
        //最迟装船日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //进口核销/申报号码
        private String bopno ;
        //金额大写
        private String word ;
        //是否购汇
        private String purflg ;
        //是否它汇
        private String othflg ;
        //是否现汇
        private String fxflg ;
        //所附单据
        private String docattflg ;
        //所附其他单据名称
        private String docattoth ;
        //入账/实际汇出币种
        private String acccur ;
        //入账/实际汇出金额
        private BigDecimal accamt  = new BigDecimal("0.00");
        //业务类型
        private String cpttyp ;
        //付款性质
        private String paytyptxt ;
        //BOP币种1
        private String bopcur1 ;
        //BOP币种2
        private String bopcur2 ;
        //身份证号
        private String idcard ;
        //交易附言
        private String trsmak ;
        //报文输入界面类型
        private String swifttyp ;
        //联系人
        private String lnkman ;
        //汇率
        private BigDecimal rat  = new BigDecimal("0.00");
        //报关单经营单位代码
        private String bopcod ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //入账方式
        private String accfs ;
        //货物品名
        private String goodnam ;
        //资金性质
        private String funcha ;
        //影像资料包括
        private String imgin ;
        //来报日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date combrq;
        //申请结汇币种
        private String jacccur ;
        //申请结汇金额
        private BigDecimal jaccamt  = new BigDecimal("0.00");
        //人民币入账账号
        private String rmbact ;
        //单据及凭证
        private String doclst ;
        //说明（无法提供）
        private String doctxt ;
        //汇入汇款附言
        private String cptinf ;
        //其他资金性质
        private String other ;
        //现汇账户需单独购汇
        private String xhghchk ;
        //数据来源
        private String cpdres ;
        //收款人名称
        private String payeenameapp ;
        //收款行cnaps号
        private String cnapscodeapp ;
        //收款人开户行名称
        private String branchnameapp ;
        //收款人账号是否本行标志
        private String acctflag ;
        //付款人常驻国家名称
        private String countryname ;
        //申报标识
        private String remittype ;
        //是否需要进行外汇收支申报标识
        private String isapply ;
        //银行绑定号
        private String cusid ;
        //交易流水号
        private String transid ;
        //报文标识号
        private String msgid ;
        //通知选项
        private String noticetype ;
        //通知手机
        private String noticephone ;
        //通知邮件
        private String noticeemail ;
        //申请人姓名
        private String applicantname ;
        //联系人电话
        private String applicantphone ;
        //指定汇款日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date remitpaymentdate;
        //报文标识号
        private String msgref ;
        //对方行业务编号
        private String payeeentmarkno ;
        //标识该笔交易是否曾被退回
        private String isexist ;
        //汇款人名称
        private String paynam ;
        //付款账号
        private String payeract ;
        //汇入渠道来源标志
        private String kjhkflg ;
        //资金来源
        private String zjly ;
        //网银购汇额度编号
        private String wyghedno ;
        //自动人工审核标识
        private String autflg ;
        //guid
        private String guid ;
        //汇入已确认标着
        private String dty ;
        //预通知国结参号
        private String dstlref ;
        //付费账账号
        private String feeactno ;
        //统一社会信用代码
        private String socialcrdtcd ;
        //相应款项用途和描述
        private String fundpurposedescp ;
        //境内外汇款
        private String oversearemittype ;
        //收款性质
        private String payeetrantype ;
        //客户业务编号
        private String cusseq ;










































































































































































































































}