package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:des:
*/
@Table("des")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dec extends AbstractModule
{

        public Dec(){
            super();
        }

        public Dec(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "des";
        }

        //主键
        private String inr ;
        //关联业务类型
        private String objtyp ;
        //关联业务主键
        private String objinr ;
        //申报号码
        private String boprno ;
        //收款人名称
        private String payee ;
        //收款类型
        private String unitin ;
        //对公组织代码
        private String unitcode ;
        //身份证类型
        private String idnumbtyp ;
        //身份证号码
        private String idnumber ;
        //结算方式
        private String pqymethod ;
        //收入币种
        private String cur ;
        //收入金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //结汇汇率
        private BigDecimal decrat  = new BigDecimal("0.00");
        //结汇金额
        private BigDecimal amofsale  = new BigDecimal("0.00");
        //结汇账号
        private String saleact ;
        //现汇金额
        private BigDecimal aminfx  = new BigDecimal("0.00");
        //现汇账号
        private String fxact ;
        //其他金额
        private BigDecimal amofoth  = new BigDecimal("0.00");
        //其他账号
        private String othact ;
        //国内银行扣费币种
        private String bnkincur ;
        //国内银行扣费金额
        private BigDecimal bnkinamt  = new BigDecimal("0.00");
        //国外银行扣费币种
        private String bnkoutcur ;
        //国外银行扣费金额
        private BigDecimal bnkoutamt  = new BigDecimal("0.00");
        //付款人名称
        private String payer ;
        //付款人常驻国家（地区）名称
        private String crofpn ;
        //付款人常驻国家代码
        private String crofpc ;
        //申报日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date repdat;
        //是否为预收贷款或退款
        private String recerefund ;
        //是否为保税货物项下收入
        private String isgdinbond ;
        //外汇局批件号/备案表号/业务编号
        private String ref ;
        //收入类型（境外）
        private String inctyp ;
        //交易编码1
        private String bopcod1 ;
        //交易编码2
        private String bopcod2 ;
        //交易币种1
        private String bopcur1 ;
        //交易币种2
        private String bopcur2 ;
        //交易金额1
        private BigDecimal bopamt1  = new BigDecimal("0.00");
        //交易金额2
        private BigDecimal bopamt2  = new BigDecimal("0.00");
        //交易附言1
        private String boprmk1 ;
        //交易附言2
        private String boprmk2 ;
        //填报人名称
        private String reportnam ;
        //填报人电话
        private String reporttel ;
        //收账结汇日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date paydate;
        //需要结汇
        private String xhghchk ;


























































































}