package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:ded:(业务表)国内信用证表（卖方）
*/
@Table("ded")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ded extends AbstractModule
{

        public Ded(){
            super();
        }

        public Ded(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "ded";
        }

        //内部编号
        private String inr ;
        //STL编号
        private String stlref ;
        //装船日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //客户编号
        private String ptyinr ;
        //办理该业务交易员
        private String ownusr ;
        //业务编号
        private String ownref ;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //信用证类型
        private String lcrtyp ;
        //信用证币别
        private String lcccur ;
        //信用证金额
        private BigDecimal lccamt  = new BigDecimal("0.00");
        //发票号码
        private String invno ;
        //生效地
        private String expplc ;
        //到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //实体机构编号
        private String etyinr ;
        //业务关闭日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //修改次数
        private Integer amenbr;
        //最近一次修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedat;
        //所属落地机构
        private String bchcod ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //修改后有效期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expamedat;
        //修改后金额
        private BigDecimal lccameamt  = new BigDecimal("0.00");
        //修改后装船日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpamedat;
        //杂项申请类型
        private String apltyp ;
        //申请内容
        private String apltxt ;
        //付款期限Tenor
        private String tenor ;
        //最长期限天数Maximum Tenor
        private String tenmaxday ;
        //Usance Property
        private String usapro ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //付款期限
        private String tenorinf ;
        //信用证号
        private String lccref ;
        //通知/申请标志
        private String flg ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;






































































}