package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:did:(业务表)国内信用证表
*/
@Table("did")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Did extends AbstractModule
{

        public Did(){
            super();
        }

        public Did(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "did";
        }

        //内部编号
        private String inr ;
        //业务申请号
        private String ownref ;
        //信用证金额
        private BigDecimal issamt  = new BigDecimal("0.00");
        //信用证币别
        private String isscur ;
        //修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedat;
        //修改次数
        private Integer amenbr;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //参号
        private String stlref ;
        //申请\开证日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //合同编号
        private String conno ;
        //合同金额
        private BigDecimal conamt  = new BigDecimal("0.00");
        //有效地点
        private String expplc ;
        //合同币别
        private String concur ;
        //最迟货物装运/服务提供日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpdat;
        //分批装运货物/分次提供服务
        private String shppar ;
        //分期装运/提供服务
        private String shipment ;
        //转运标志
        private String shptrs ;
        //起运地
        private String shpfro ;
        //目的地
        private String shpto ;
        //溢价+
        private BigDecimal nomtop  = new BigDecimal("0.00");
        //折价-
        private BigDecimal nomton  = new BigDecimal("0.00");
        //保兑指示标志
        private String cnfflg ;
        //结束日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //业务办理人员
        private String ownusr ;
        //有效行
        private String avbwth ;
        //所属机构客户编号
        private String ptyinr ;
        //实体机构编号
        private String etyinr ;
        //可转让标志
        private String trfflg ;
        //假远期标志
        private String upsflg ;
        //目的港
        private String pordis ;
        //起运港
        private String porloa ;
        //贸易术语发生地
        private String trdtrmplc ;
        //贸易术语版本
        private String trdtrmver ;
        //国际惯例版本
        private String apprul ;
        //国际惯例版本内容
        private String apprultxt ;
        //开立方式
        private String issinf ;
        //所属落地机构
        private String bchcod ;
        //联系人
        private String likman ;
        //手机
        private String moble ;
        //e_mail
        private String email ;
        //有效行选择
        private String avbwths ;
        //贸易术语
        private String trdtrm ;
        //修改信用证寄送方式
        private String sndtyp ;
        //修改后有效期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expamedat;
        //修改后最迟货物装运/服务提供日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date shpamedat;
        //减额
        private BigDecimal decamt  = new BigDecimal("0.00");
        //增额
        private BigDecimal incamt  = new BigDecimal("0.00");
        //修改后金额
        private BigDecimal issameamt  = new BigDecimal("0.00");
        //修改后卸货港/目的航空港
        private String poramedis ;
        //修改后装运港/起运航空港
        private String porameloa ;
        //修改后货物起运地/货物接收地
        private String shpamefro ;
        //修改后最终目的地/运往.../交货地点
        private String shpameto ;
        //Details（进口信用证修改申请）
        private String details ;
        //进口信用证修改费用承担方
        private String chrgameby ;
        //办理指示
        private String avttyp ;
        //付款期限
        private String tenor ;
        //保兑币别
        private String cfmcur ;
        //保兑金额
        private BigDecimal cfmamt  = new BigDecimal("0.00");
        //是否溢短装
        private String nomflg ;
        //是否制定贸易术语版本
        private String trdflg ;
        //付款方式
        private String avbby ;
        //交单天数
        private String sedday ;
        //交单期起算日
        private String sstdat ;
        //交单期起算日内容
        private String sstdattxt ;
        //进口信用证保兑申请前手交易类型
        private String cfmflg ;
        //通知/申请标志
        private String flg ;
        //Additional Amount Covered(信用证转开申请）
        private String adlamt ;
        //shipment Period(进口信用证转开等)
        private String shppod ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //Presentation Period(开立申请)
        private String preper ;
        //信用证修改申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date creamedat;
        //indirect bchcod
        private String ibchcod ;
        //direct bchcod
        private String dbchcod ;
        //信用证类型
        private String lcrtyp ;
        //是否可保兑
        private String conflg ;
        //是否可议付
        private String negflg ;
        //货物运输或交货方式/服务方式
        private String tratyp ;
        //信用证开立方式
        private String cretyp ;
        //邮箱（受益人）
        private String email1 ;
        //服务提供地点
        private String trapla ;
        //可保兑
        private String cnfdet ;
        //可转让
        private String trndet ;
        //贸易方式
        private String trdmod ;
        //付款期限2
        private Integer prompt;
        //交单期限
        private String jdqx ;
















































































































































































}