package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:dxd:
*/
@Table("dxd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dxd extends AbstractModule
{

        public Dxd(){
            super();
        }

        public Dxd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "dxd";
        }

        //主键
        private String inr ;
        //合同编号
        private String ownref ;
        //甲方
        private String jf ;
        //甲方通讯地址
        private String zftxdz ;
        //甲方邮政编码
        private String zfyzbm ;
        //甲方电传
        private String zfdc ;
        //甲方联系电话
        private String jflxdh ;
        //甲方传真
        private String jfcz ;
        //乙方
        private String yf ;
        //乙方通讯地址
        private String yftxdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方电传
        private String yfdc ;
        //乙方联系电话
        private String yflxdh ;
        //乙方传真
        private String yfcz ;
        //代收人
        private String dsr ;
        //代收地址
        private String dsdz ;
        //代收邮政编码
        private String dsyzbm ;
        //代收联系电话
        private String dslxdh ;
        //代收传真
        private String dscz ;
        //代收电子邮件
        private String dsdzyj ;
        //代收手机号码
        private String dssjhm ;
        //待付申请书编号
        private String othref ;
        //业务归属
        private String ywgs ;
        //开证金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //英文币种
        private String cur ;
        //币种中文
        private String curzh ;
        //金额大写
        private String amtzh ;
        //融资利率
        private BigDecimal rzlv  = new BigDecimal("0.00");
        //逾期贷款利率
        private BigDecimal yqdklv  = new BigDecimal("0.00");
        //超过xxx借款
        private BigDecimal cgjk  = new BigDecimal("0.00");
        //负债超过xx万
        private BigDecimal fzcg  = new BigDecimal("0.00");
        //超过贷款
        private BigDecimal cgdk  = new BigDecimal("0.00");
        //超过xx债务
        private BigDecimal cgzw  = new BigDecimal("0.00");
        //股权股份超过xx变更
        private BigDecimal yfgqbg  = new BigDecimal("0.00");
        //资产流动与净值比例
        private String rldjz ;
        //资产负债率
        private BigDecimal rzcfz  = new BigDecimal("0.00");
        //资产流动率
        private BigDecimal rzcld  = new BigDecimal("0.00");
        //争议解决方式
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //开庭地点
        private String ktdd ;
        //其他争议解决方式
        private String qtzyjj ;
        //补充条款
        private String bctk ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方单位地址
        private String yfdwdz ;
        //乙方单位邮编
        private String yfdwyzbm ;
        //乙方单位联系电话
        private String yfdwlxdh ;
        //乙方单位联系人
        private String yfdwlxr ;
        //所属机构客户编号
        private String ptyinr ;
        //实体机构编号
        private String etyinr ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //关联信用证主键
        private String lidinr ;
        //归属银行
        private String bchcod ;
        //甲方机构
        private String jfptyinr ;
        //甲方所属实体
        private String jfetyinr ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //融资期限开始日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rzqxstr;
        //融资期限结束日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rzqxend;
        //业务归属描述1
        private String ywgs1 ;
        //业务归属描述2
        private String ywgs2 ;
        //业务归属描述3
        private String ywgs3 ;
        //负债超过xx万中文
        private String fzcgzh ;
        //超过xxx借款大写
        private String cgjkzh ;
        //超过条款中文
        private String cgdkzh ;
        //超过xx债务中文
        private String cgzwzh ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date today;
        //二次确认标识
        private String needconfim ;
        //银行确认标识
        private String amedbybank ;










































































































































}