package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:fcd:(业务表)外汇买卖表
*/
@Table("fcd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fcd extends AbstractModule
{

        public Fcd(){
            super();
        }

        public Fcd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "fcd";
        }

        //唯一编号
        private String inr ;
        //目标汇率
        private BigDecimal scbextrat  = new BigDecimal("0.00");
        //成交汇率
        private BigDecimal rat  = new BigDecimal("0.00");
        //客户编号
        private String ptyinr ;
        //经办人
        private String ownusr ;
        //业务申请编号
        private String ownref ;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //发票金额
        private BigDecimal invamt  = new BigDecimal("0.00");
        //实体机构编号
        private String etyinr ;
        //结束交割日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date endactday;
        //合同汇率
        private BigDecimal dcbextrat  = new BigDecimal("0.00");
        //原币
        private String cur ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //变换日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date cnvdat;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //开始交割日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date begactday;
        //所属落地机构
        private String bchcod ;
        //申请人名称
        private String aplnam ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //目标币别
        private String acccur ;
        //合同金额
        private BigDecimal conamt  = new BigDecimal("0.00");
        //合同编号
        private String conno ;
        //外币账号
        private String foract ;
        //手续费扣减账号
        private String frmact ;
        //发票号码
        private String invno ;
        //人民币账号
        private String rmbact ;
        //STL编号
        private String stlref ;
        //目标金额
        private BigDecimal accamt  = new BigDecimal("0.00");
        //单据及凭证
        private String doclst ;
        //单据缺少说明
        private String doctxt ;
        //附言
        private String note ;
        //用途
        private String purpose ;
        //支付方式
        private String payby ;
        //信用证号码/其他汇款方式/其他支付方式
        private String paybytxt ;
        //是否需批文
        private String ofcialdocflg ;
        //批文
        private String ofcialdoctxt ;
        //其他用途
        private String purposeoth ;
        //总协议书编号
        private String agrmntno ;
        //交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date trddat;
        //委托价格
        private BigDecimal agrprc  = new BigDecimal("0.00");
        //交易类型
        private String trdtyp ;
        //失效日
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date lmudat;
        //交割日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date actdat;
        //申请条款
        private String aplcnd ;
        //外汇买卖杂项申请业务类型
        private String fxttyp ;
        //申请内容
        private String aplinf ;
        //保证金比例
        private String engper ;
        //保证金帐号
        private String engact ;
        //手续费币别
        private String feecur ;
        //手续费金额
        private BigDecimal feeamt  = new BigDecimal("0.00");
        //手续费缴纳日期
        private String feechgat ;
        //手续费缴纳方式
        private String feechgby ;
        //成交价格
        private BigDecimal actprc  = new BigDecimal("0.00");
        //买入金额大写
        private String accword ;
        //卖出金额大写
        private String word ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //发票币种
        private String invcur ;
        //合同币种
        private String concur ;
        //交易方向
        private String trndir ;
        //购/套汇业务类型
        private String fxflg ;
        //掉期外汇买卖委托价格
        private BigDecimal agrprcd  = new BigDecimal("0.00");
        //掉期交割日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date actdatd;
        //掉期买入币种
        private String acccurd ;
        //掉期买入金额
        private BigDecimal accamtd  = new BigDecimal("0.00");
        //掉期卖出币种
        private String curd ;
        //掉期卖出金额
        private BigDecimal amtd  = new BigDecimal("0.00");
        //掉期保证金比例
        private String engperd ;
        //掉期入账账号
        private String foractd ;
        //掉期扣帐账号
        private String rmbactd ;
        //掉期保证金账号
        private String engactd ;
        //掉期成交价格
        private Integer actprcd;
        //掉期买入金额大写
        private String accwordd ;
        //掉期卖出金额大写
        private String wordd ;
        //掉期手续费币种
        private String feecurd ;
        //掉期手续费金额
        private BigDecimal feeamtd  = new BigDecimal("0.00");
        //是否当日收取手续费
        private String feechgflg ;
        //掉期是否当日收取手续费
        private String feechgflgd ;
        //dbchcod
        private String dbchcod ;
        //ibchcod
        private String ibchcod ;
        //扣帐币别
        private String actcur ;




































































































































































}