package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:fpd:购汇信息表
*/
@Table("fpd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fpd extends AbstractModule
{

        public Fpd(){
            super();
        }

        public Fpd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "fpd";
        }

        //主键
        private String inr ;
        //人民币付款账号
        private String cnycno ;
        //外币收款账号
        private String outcno ;
        //外币币种
        private String outcur ;
        //付款账户名称
        private String givnam ;
        //外币金额
        private BigDecimal outamt  = new BigDecimal("0.00");
        //售汇单位主体
        private String shbody ;
        //单位组织机构代码
        private String othcno ;
        //售汇交易性质
        private String trstyp ;
        //交易编码
        private String trscno ;
        //外汇局批件号/备案表号/业务编号
        private String obycno ;
        //售汇业务参号
        private String ownref ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //业务类型
        private String objtyp ;
        //业务主键
        private String objinr ;
        //业务名称
        private String objfrm ;
        //交易附言
        private String trstxt ;
        //操作员名称
        private String oprnam ;
        //联系电话
        private String tel ;
        //外汇账户开户行
        private String outadr ;
        //等值人民币金额
        private String cnnsel ;
        //外币金额
        private String outsel ;
        //资本项目
        private String cptals ;
        //卖出价
        private BigDecimal midrat  = new BigDecimal("0.00");
        //项目类型
        private String xmlx ;
        //归属机构
        private String bchcod ;
        //结汇类型
        private String stttyp ;
        //账户性质
        private String sttacttyp ;
        //收款人名称
        private String payeename ;
        //收款人开户行
        private String payeebank ;
        //结汇资金用途
        private String usage ;
        //详细用途
        private String usageinfo ;
        //客户机构主键
        private String ptyinr ;
        //实体inr
        private String etyinr ;








































































}