package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:fqd:(业务表)购汇信息表
*/
@Table("fqd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fqd extends AbstractModule
{

        public Fqd(){
            super();
        }

        public Fqd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "fqd";
        }

        //主键
        private String inr ;
        //客户号
        private String ecifno ;
        //业务参考号
        private String businessno ;
        //自助售汇额度申请参考号
        private String edbusno ;
        //营业机构号
        private String orgcode ;
        //营业机构名称
        private String orgname ;
        //售汇申请人名称1
        private String sjjy01 ;
        //售汇申请人名称2
        private String sjjy02 ;
        //人民币收款人名称1
        private String sjjy03 ;
        //人民币收款人名称2
        private String sjjy04 ;
        //币种
        private String currency ;
        //银行卖出货币
        private String mcbiz ;
        //银行卖出金额
        private BigDecimal bankmcje  = new BigDecimal("0.00");
        //人民币金额
        private BigDecimal rmbjz  = new BigDecimal("0.00");
        //售汇金额
        private BigDecimal jioyje  = new BigDecimal("0.00");
        //外币金额
        private BigDecimal amount  = new BigDecimal("0.00");
        //外币收款账号
        private String wbskno ;
        //人民币付款账号
        private String duifzh ;
        //售汇交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date salejyrq;
        //申报业务交易日期
        private String joy1rq ;
        //售汇申请交易结果
        private String shjiayjg ;
        //国际收支申报交易编码
        private String gjszsbno ;
        //申请人统一社会信用代码
        private String dihdig ;
        //外汇局批件号/备案表号/业务编号
        private String bangdh ;
        //汇率
        private BigDecimal cjiohl  = new BigDecimal("0.00");
        //外管局统计码
        private String projecttype ;
        //外汇账户开户机构号
        private String whzhkhjgh ;
        //填报人
        private String zhjnmc ;
        //填报人电话
        private String yyedzh ;
        //买入价
        private BigDecimal mairj  = new BigDecimal("0.00");
        //卖出价
        private BigDecimal maicj  = new BigDecimal("0.00");
        //平盘买入价
        private BigDecimal ppanmrj  = new BigDecimal("0.00");
        //平盘卖出价
        private BigDecimal ppanmcj  = new BigDecimal("0.00");
        //描述
        private String shibyy ;
        //归属机构
        private String bchcod ;
        //客户机构主键
        private String ptyinr ;
        //实体inr
        private String etyinr ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //修改时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date upddat;
        //摘要代码
        private String zhyomd ;
        //人民币客户帐号类型
        private String rmzhlx ;
        //前台流水号
        private String qantls ;
        //前台交易日期
        private String ynjyrq ;
        //交易柜员
        private String jio1gy ;
        //渠道号
        private String appid ;






























































































}