package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:fsd:(业务表)福费廷表
*/
@Table("fsd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fsd extends AbstractModule
{

        public Fsd(){
            super();
        }

        public Fsd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "fsd";
        }

        //内部编号
        private String inr ;
        //融资期限日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //国家代码
        private String stacty ;
        //发票让渡币别
        private String rdcur ;
        //发票让渡金额
        private BigDecimal rdamt  = new BigDecimal("0.00");
        //融资利率
        private BigDecimal ratcal  = new BigDecimal("0.00");
        //客户编号
        private String ptyinr ;
        //融资利息
        private BigDecimal perint  = new BigDecimal("0.00");
        //业务操作人员编号
        private String ownusr ;
        //业务编号
        private String ownref ;
        //其他费用币别
        private String othcur ;
        //其他费用金额
        private BigDecimal othamt  = new BigDecimal("0.00");
        //融资日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //基本汇率
        private BigDecimal irtcod  = new BigDecimal("0.00");
        //发票号码
        private String invno ;
        //发票币别
        private String invcur ;
        //发票金额
        private BigDecimal invamt  = new BigDecimal("0.00");
        //货物名称
        private String gdsnam ;
        //融资入账币别
        private String fincur ;
        //融资入账金额
        private BigDecimal finamt  = new BigDecimal("0.00");
        //融资到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //实体机构编号
        private String etyinr ;
        //交单日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date docdat;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //业务关闭日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //出运日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date crydat;
        //所属落地机构
        private String bchcod ;
        //入账账号
        private String accno ;
        //STL编号
        private String stlref ;
        //单据到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //父业务inr
        private String pntinr ;
        //父业务类型
        private String pnttyp ;
        //福费廷业务协议书编号
        private String agrmntno ;
        //融资帐号类型
        private String fintyp ;
        //权责条款
        private String rgtclu ;
        //公司参考号
        private String corref ;
        //融资期限
        private String disper ;
        //结汇牌价
        private BigDecimal exrate  = new BigDecimal("0.00");
        //父交易ref
        private String pntref ;
        //信用证类型
        private String lctyp ;
        //联系人
        private String linkman ;
        //电话
        private String tel ;
        //传真
        private String fax ;
        //ibchcod
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //票据号
        private String billno ;
        //宽限期
        private Integer othins;
        //申请书类型
        private String fsddocflg ;
        //计息周期
        private String bearper ;
        //合同号
        private String conref ;
        //申请买断币种
        private String brkcur ;
        //申请买断金额
        private BigDecimal brkamt  = new BigDecimal("0.00");
        //融资款入账类型
        private String enttyp ;
        //原币入账账号
        private String origno ;
        //结汇入账账号
        private String soexno ;
        //结汇入账单据
        private String soedoc ;
        //无法提交单据原因
        private String reason ;
        //申请法定代表人
        private String slepes ;
        //报价确认
        private String prisqr ;
        //报价确认意见
        private String prisyj ;
        //单据目前业务状态
        private String docflg ;
        //保兑币别
        private String concur ;
        //保兑金额
        private BigDecimal conamt  = new BigDecimal("0.00");
        //付款币别
        private String paycur ;
        //付款金额
        private BigDecimal payamt  = new BigDecimal("0.00");
        //保付币别
        private String acdcur ;
        //保付金额
        private BigDecimal acdamt  = new BigDecimal("0.00");
        //信用证币别
        private String lrscur ;
        //信用证金额
        private BigDecimal lrsamt  = new BigDecimal("0.00");
        //公司名称
        private String cornam ;
        //福费廷转卖费币种
        private String turcur ;
        //福费廷转卖费金额
        private BigDecimal turamt  = new BigDecimal("0.00");
        //福费廷手续费币种
        private String poucur ;
        //福费廷手续费金额
        private BigDecimal pouamt  = new BigDecimal("0.00");
        //费用合计币种
        private String totcur ;
        //费用合计金额
        private BigDecimal totamt  = new BigDecimal("0.00");




























































































































































}