package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:gid:保函表
*/
@Table("gid")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gid extends AbstractModule
{

        public Gid(){
            super();
        }

        public Gid(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "gid";
        }

        //唯一编号
        private String inr ;
        //修改发送类型
        private String sndtyp ;
        //客户编号
        private String ptyinr ;
        //业务申请号码
        private String ownref ;
        //受益人中文名称
        private String bennamcn ;
        //受益人中文地址
        private String benadrcn ;
        //保函币别
        private String lgcur ;
        //保函金额
        private BigDecimal lgamt  = new BigDecimal("0.00");
        //保函格式
        private String lgfmt ;
        //担保期限类型
        private String dbqxtyp ;
        //担保期限时间(起)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dbqxsjq;
        //担保期限时间(止)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dbqxsjz;
        //担保期限事件(起)
        private String dbqxshjq ;
        //担保期限事件(止)
        private String dbqxshjz ;
        //开立方式
        private String opntyp ;
        //文本格式
        private String txttyp ;
        //出具方式
        private String cjfs ;
        //受益人收件地址
        private String syrsjdz ;
        //受益人联系人信息
        private String syrlxrxx ;
        //保函到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bhdqdat;
        //反担保到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date fdbdqdat;
        //保证金币种
        private String bzjcur ;
        //保证金金额
        private BigDecimal bzjamt  = new BigDecimal("0.00");
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //到期日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //失效日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date lmudat;
        //保函类别
        private String lgtyp ;
        //保函草稿
        private String lgtxt ;
        //出具方式
        private String furtyp ;
        //实体机构编号
        private String etyinr ;
        //合约币别
        private String engcur ;
        //合约金额
        private BigDecimal engamt  = new BigDecimal("0.00");
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //合同号码
        private String conno ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //所属落地机构
        private String bchcod ;
        //保函使用规则
        private String apprul ;
        //生效日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date apldat;
        //修改次数
        private Integer amenbr;
        //修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedat;
        //STL编号
        private String stlref ;
        //业务操作人员编号
        private String ownusr ;
        //修改后失效日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date lmuamedat;
        //修改内容
        private String ametxt ;
        //修改费用承担人
        private String amefee ;
        //合约名称
        private String agrnam ;
        //保函通知号
        private String advref ;
        //生效期限
        private String stadat ;
        //失效期限
        private String enddat ;
        //保函适用规则OTH时文本
        private String apprultxt ;
        //办理方式
        private String trstyp ;
        //保函修改后金额
        private BigDecimal lgameamt  = new BigDecimal("0.00");
        //致兴业条款
        private String gittrstxt ;
        //flg
        private String flg ;
        //ibchocd
        private String ibchcod ;
        //dbchcod
        private String dbchcod ;
        //标志位
        private String flags ;
        //申请人中文名称
        private String aplnamcn ;
        //申请人中文地址
        private String apladrcn ;
        //企业扣款账号
        private String qykkzh ;
        //收费方式
        private String sffs ;
        //收费费率
        private BigDecimal sffl  = new BigDecimal("0.00");
        //开户金融账号
        private String khjrzh ;
        //开户金融机构
        private String khjrjg ;
        //出质人开立保函适用条款
        private String sytk ;
        //贸易融资综合授信协议编号
        private String myrzbh ;
        //争议解决方式
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //仲裁地点
        private String zcdd ;
        //担保保证金账户
        private String dbbzjzh ;
        //担保保证金账户名
        private String dbbzjzhm ;
        //保函保证金质押协议编号
        private String bhbzjzyxyref ;
        //合约名称英文
        private String enagrnam ;
        //合约金额
        private BigDecimal hyje  = new BigDecimal("0.00");
        //合约资金来源
        private String zjly ;
        //转开/转递行名称
        private String zkzdhmc ;
        //保函开立申请签字时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bhqzdat;
        //保函性质
        private String bhxz ;
        //开立方式2
        private String opntyp2 ;
        //被保证人甲乙方
        private String bbzrjyf ;
        //受益人甲乙方
        private String syrjyf ;
        //同期贷款利率上浮
        private BigDecimal dkllsf  = new BigDecimal("0.00");
        //开立保函业务保证金条款是否适用
        private String sfsy ;
        //保函保证金比率
        private BigDecimal bhbzjbl  = new BigDecimal("0.00");
        //保证金质押协议条款是否适用
        private String zyxysy ;
        //申请信贷证明的用途
        private String xdzmyt ;
        //信贷证明书是否使用光大统一格式
        private String xdzmsfty ;
        //《银行信贷证明书》格式
        private String xdzmsgs ;
        //招标书施工期限
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date zbssgqx;
        //项目所需资金来源
        private String xmsxzjly ;
        //出具银行信贷证明协议书编号
        private String xdzmxybh ;
        //保函语种
        private String wbtyp ;
        //保函增加金额
        private BigDecimal bhzjje  = new BigDecimal("0.00");
        //分离式保函协议编号
        private String flsbhbh ;
        //乙方为甲方出具保函其他条件
        private String cjbhtj ;
        //保证费用条款
        private String bzfytk ;
        //保函未出具赔付金额币种
        private String pfcur ;
        //保函未出具赔付金额
        private BigDecimal pfamt  = new BigDecimal("0.00");
        //逾期利率
        private BigDecimal yqll  = new BigDecimal("0.00");
        //通知期限
        private String tzqx ;
        //保函开立渠道
        private String issuetxt ;
        //是否生成保函查询码
        private String bhcxsf ;
        //正本退还期限
        private String zbthqx ;
        //合同份数
        private String htfs ;
        //合同其他约定事项
        private String htqtydsx ;
        //索偿付款账号
        private String scfkzh ;

        /**
        *   source:gid.@0000.script
        */
        public void test()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}























































































































































































































}