package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:gxd:保函协议表
*/
@Table("gxd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gxd extends AbstractModule
{

        public Gxd(){
            super();
        }

        public Gxd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "gxd";
        }

        //主键
        private String inr ;
        //关联参号
        private String ref ;
        //保函协议编号
        private String ownref ;
        //关联表名
        private String objtyp ;
        //关联主键
        private String objinr ;
        //所属落地机构
        private String bchcod ;
        //甲方
        private String jf ;
        //甲方住所
        private String jfzs ;
        //甲方法人代表
        private String jffrdb ;
        //乙方
        private String yf ;
        //乙方住所
        private String yfzs ;
        //乙方法人代表
        private String yffrdb ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方单位地址
        private String yfdwdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方联系电话
        private String yflxdh ;
        //乙方联系人
        private String yflxr ;
        //代收人
        private String dsr ;
        //代收地址
        private String dsdz ;
        //代收邮政编码
        private String dsyzbm ;
        //代收联系电话
        private String dslxdh ;
        //乙方传真号码
        private String yfczhm ;
        //乙方电子邮件
        private String yfdzyj ;
        //乙方手机号码
        private String yfsjhm ;
        //乙方微信号码
        private String yfwxhm ;
        //乙方QQ号码
        private String yfqqhm ;
        //乙方与受益人签订合同/文件日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date yfqdhtrq;
        //乙方产品/项目
        private String yfcp ;
        //受益人
        private String syr ;
        //受益人法定地址
        private String syrfddz ;
        //被担保人
        private String bdbr ;
        //被担保人法定地址
        private String bdbrfddz ;
        //担保币种
        @Column("bdcur")
        private String dbcur ;
        //担保金额
        private BigDecimal dbamt  = new BigDecimal("0.00");
        //担保币种(中文)
        private String dbcurcn ;
        //担保金额(大写)
        private String dbamtcn ;
        //保证期间(起)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bzqjq;
        //保证期间(止)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bzqjz;
        //费用描述
        private String fyms ;
        //计费方式
        private String jffs ;
        //一次性计收币种
        private String ycxcur ;
        //一次性计收金额
        private BigDecimal ycxamt  = new BigDecimal("0.00");
        //分期缴费第一期日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dyqrq;
        //分期缴费第一期币种
        private String dyqcur ;
        //分期缴费第一期金额
        private BigDecimal dyqamt  = new BigDecimal("0.00");
        //分期缴费第一期金额(大写)
        private String dyqamtcn ;
        //分期缴费第二期日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date deqre;
        //分期缴费第二期币种
        private String deqcur ;
        //分期缴费第二期金额
        private BigDecimal deqamt  = new BigDecimal("0.00");
        //分期缴费第二期金额(大写)
        private String deqamtcn ;
        //分期缴费其他
        private String qt ;
        //违约金比率日万分之X
        private BigDecimal wyjbl  = new BigDecimal("0.00");
        //逾期贷款固定日利率
        private BigDecimal yqdkll  = new BigDecimal("0.00");
        //争议解决方式
        @Column("zyjjs")
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //开庭地点
        private String ktdd ;
        //争议解决其他方式
        private String qtfs ;
        //补充条款
        private String bctk ;
        //保证金币种
        private String bzjcur ;
        //保证金金额(大写)
        private String bzjamtcn ;
        //保证金协议编号
        private String bzjxybh ;
        //保证金协议名称
        private String bzjxymc ;
        //反担保合同编号1
        private String fdbhtbh1 ;
        //反担保合同名称1
        private String fdbhtmc1 ;
        //反担保方式1
        private String fdbfs1 ;
        //反担保人1
        private String fdbr1 ;
        //反担保合同编号2
        private String fdbhtbh2 ;
        //反担保合同名称2
        private String fdbhtmc2 ;
        //反担保方式2
        private String fdbfs2 ;
        //反担保人2
        private String fdbr2 ;
















































































































































}