package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:ixd:
*/
@Table("ixd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ixd extends AbstractModule
{

        public Ixd(){
            super();
        }

        public Ixd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "ixd";
        }

        //主键
        private String inr ;
        //相关编号
        private String ref ;
        //业务主键
        private String objinr ;
        //业务表名
        private String objtyp ;
        //代付协议编号
        private String ownref ;
        //甲方
        private String jf ;
        //甲方住所
        private String jfzs ;
        //甲方法人代表/负责人
        private String jffrdb ;
        //乙方
        private String yf ;
        //乙方住所
        private String yfzs ;
        //乙方法人代表/负责人
        private String yffrdb ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方单位地址
        private String yfdwdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方联系电话
        private String yflxdh ;
        //乙方联系人
        private String yflxr ;
        //代收人
        private String dsr ;
        //代收地址
        private String dsdz ;
        //代收邮政编码
        private String dsyzbm ;
        //代收联系电话
        private String dslxdh ;
        //乙方传真号码
        private String yfczhm ;
        //乙方电子邮件
        private String yfdzyj ;
        //乙方手机号码
        private String yfsjhm ;
        //乙方微信号码
        private String yfwxhm ;
        //乙方QQ号码
        private String yfqqhm ;
        //代付其他先决条件
        private String dfqttj ;
        //本金偿还方式
        private String bjchfs ;
        //本金偿还其他方式
        private String bjchqtfs ;
        //利息偿还其他方式
        private String lxchqtfs ;
        //违约金比例
        private BigDecimal wyjbl  = new BigDecimal("0.00");
        //逾期贷款固定日利率
        private BigDecimal yqdkrll  = new BigDecimal("0.00");
        //申请金额超过X万元借款
        private BigDecimal cgjk  = new BigDecimal("0.00");
        //负债总额超过x万元
        private BigDecimal cgfz  = new BigDecimal("0.00");
        //向第三方提供超过X万元的贷款
        private BigDecimal cgdk  = new BigDecimal("0.00");
        //为第三方提供超过X万元的债务提供担保
        private BigDecimal cgzwdb  = new BigDecimal("0.00");
        //乙方股东、股权变更比例
        private BigDecimal yfgqbg  = new BigDecimal("0.00");
        //流动资产和资产净值比例
        private String ldzcjzbl ;
        //资产负债比例
        private BigDecimal zcfzbl  = new BigDecimal("0.00");
        //资产流动比例
        private BigDecimal zcldbl  = new BigDecimal("0.00");
        //争议解决方式
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //开庭地点
        private String ktdd ;
        //争议解决其他方式
        private String qtfs ;
        //补充条款
        private String bctk ;
        //合同编号1
        private String htbh1 ;
        //合同名称1
        private String htmc1 ;
        //担保方式1
        private String dbfs1 ;
        //担保人1
        private String dbr1 ;
        //合同编号2
        private String htbh2 ;
        //合同名称2
        private String htmc2 ;
        //担保方式2
        private String dbfs2 ;
        //担保人2
        private String dbr2 ;
        //合同编号3
        private String htbh3 ;
        //合同名称3
        private String htmc3 ;
        //担保方式3
        private String dbfs3 ;
        //担保人3
        private String dbr3 ;
        //融资属于第X种情况
        private String rzsy ;
        //额度授信总合同编号
        private String sxhtbh ;
        //额度授信总合同名称
        private String sxhtmc ;
        //授信额度折合人民币金额
        private long sxedrmbje ;
        //总授信效期起始日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date sxxqqsr;
        //总授信效期截止日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date sxxqjzr;
        //融资利率
        private long rzlv ;
        //融资起始日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rzqsr;
        //融资到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rzdqr;
        //甲方要求的财务状况范围
        private String jfyqdcwzkfw ;
        //利息偿还方式
        private String lxchfs ;










































































































































}