package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:jsd:
*/
@Table("jsd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jsd extends AbstractModule
{

        public Jsd(){
            super();
        }

        public Jsd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "jsd";
        }

        //业务主键
        private String inr ;
        //参考号
        private String ownref ;
        //归属银行
        private String bchcod ;
        //所属实体
        private String etyinr ;
        //业务所属机构
        private String ptyinr ;
        //关联系统业务编号
        private String stlref ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //买卖品种
        private String seltyp ;
        //买卖方向
        private String sfltyp ;
        //买入币种
        private String buycur ;
        //买入金额
        private BigDecimal buyamt  = new BigDecimal("0.00");
        //买入账号
        private String buycno ;
        //卖出金额币种
        private String selcur ;
        //卖出金额
        private BigDecimal selamt  = new BigDecimal("0.00");
        //卖出账号
        private String selcno ;
        //交割日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date givdat;
        //是否择期
        private String zqnsty ;
        //择期起始日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date zqndat;
        //即期T+n标志
        private String jqnmak ;
        //交割方式
        private String givsty ;
        //汇率模式
        private String matsty ;
        //委托汇率
        private BigDecimal deprat  = new BigDecimal("0.00");
        //"衍生交易总协议"编号
        private String zxycno ;
        //是否“综合授信协议”编号
        private String zshsty ;
        //“综合授信协议”编号
        private String zshcno ;
        //是否需要保证金并质押协议
        private String bzjsty ;
        //保证金账号
        private String bzjcno ;
        //保证金比例
        private BigDecimal bzjrat  = new BigDecimal("0.00");
        //外管局统计码
        private String wgjcno ;
        //远端买入
        private String ydbsty ;
        //远端卖出
        private String ybssty ;
        //远端汇率模式
        private String ydhsty ;
        //远端委托汇率
        private BigDecimal ydhmat  = new BigDecimal("0.00");
        //近端、远端交割账号不一致
        private String yjisxt ;
        //远端买入账号
        private String ybzcno ;
        //远端卖出账号
        private String ybrcno ;
        //远端买入币种
        private String ydbcur ;
        //业务状态
        private String ywztls ;
        //是否有“综合授信协议”编号
        private String sfyzsh ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //业务类型
        private String jsdtyp ;
        //交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //新交割日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date njgdat;
        //新择期起始日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date nzqdat;
        //违约金付款帐号
        private String wyjcno ;
        //违约金付款币种
        private String wyjcur ;
        //返还收益入账账号
        private String fsycno ;
        //返还收益币种
        private String fsycur ;
        //修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedat;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //远端卖出币种
        private String ybrcur ;
        //部分交割买入金额
        private BigDecimal sombuyamt  = new BigDecimal("0.00");
        //部分交割卖出金额
        private BigDecimal somselamt  = new BigDecimal("0.00");
        //新的买入账号
        private String newbuycno ;
        //新的卖出账号
        private String newselcno ;
        //业务处理状态
        private String paysta ;
        //已提前交割金额
        private BigDecimal payamt  = new BigDecimal("0.00");
        //交割次数
        private String paytim ;
        //新交割方式
        private String newgivsty ;
        //提前交割金额
        private BigDecimal sompayamt  = new BigDecimal("0.00");
        //盈利金额
        private BigDecimal getamt  = new BigDecimal("0.00");
        //损失金额
        private BigDecimal givamt  = new BigDecimal("0.00");
        //协议时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date getdat;
        //盈利
        private String getslt ;
        //损失
        private String givslt ;
        //审核日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date chkdat;
        //项目类型
        private String xmlx ;
        //客户类别
        private String khlb ;
        //质押协议编号
        private String bzjref ;
        //是否已签订衍生品交易保证金质押总协议
        private String bzjslt ;
        //违约利率
        private BigDecimal wyymat  = new BigDecimal("0.00");
        //差额交割参考汇率
        private BigDecimal fyrate  = new BigDecimal("0.00");
        //是否关联业务
        private String isreltrn ;
        //关联业务名称
        private String reltrnnam ;
        //关联业务编号
        private String reltrnref ;
        //关联业务保证金账号
        private String relbzjacc ;
        //关联业务质押协议编号
        private String relzyxybh ;
        //单位主体标识码
        private String acccod ;
        //交易附言
        private String jyfy ;
        //外汇局批件号/备案表号/业务编号
        private String whjpjh ;
        //是否勾选融资性保函/备用信用证业务
        private String ischotrn ;
        //融资保函编号
        private String rzxbhno ;
        //担保合同编号
        private String dbhtno ;
        //天数
        private String xdsjdat ;
















































































































































































}