package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:lxd:信用证协议表
*/
@Table("lxd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Lxd extends AbstractModule
{

        public Lxd(){
            super();
        }

        public Lxd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "lxd";
        }

        //主键
        private String inr ;
        //相关编号
        private String ref ;
        //协议编号
        private String ownref ;
        //关联业务表名称
        private String objtyp ;
        //业务表主键
        private String objinr ;
        //甲方
        private String jf ;
        //甲方住所
        private String jfzs ;
        //甲方法人
        private String jffr ;
        //乙方
        private String yf ;
        //乙方住所
        private String yfzs ;
        //乙方法人
        private String yffr ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方单位地址
        private String yfdwdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方联系电话
        private String yflxdh ;
        //乙方联系人
        private String yflxr ;
        //乙方代收人
        private String dsr ;
        //乙方代收地址
        private String dsdz ;
        //乙方代收邮政编码
        private String dsyzbm ;
        //乙方代收联系电话
        private String dslxdh ;
        //乙方传真号码
        private String yfczhm ;
        //乙方电子邮件
        private String yfdzyj ;
        //乙方手机号码
        private String yfsjhm ;
        //乙方微信号码
        private String yfwxhm ;
        //乙方QQ号码
        private String yfqqhm ;
        //信用证属于情况，二选一
        private String xyzqk ;
        //授信合同编号
        private String shhtbh ;
        //授信合同名称
        private String sxhtmc ;
        //授信合同金额，X亿X仟X佰X拾X万X仟
        private String shhtje ;
        //效期起始
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date xqqs;
        //效期终止
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date xqzz;
        //费用明细
        private String fymx ;
        //罚息率
        private BigDecimal fxl  = new BigDecimal("0.00");
        //乙方其他前提条件
        private String yfqtqttj ;
        //资产净值
        private String zcjz ;
        //资产负债比
        private BigDecimal zcfzb  = new BigDecimal("0.00");
        //资产流动比例
        private BigDecimal zcldbl  = new BigDecimal("0.00");
        //争议解决方式，三个选项
        private String zyjjfs ;
        //仲裁委员会
        private String czwyh ;
        //开庭地点
        private String ktdd ;
        //争议解决其他方式
        private String qtfs ;
        //补充条款
        private String bctk ;
        //合同编号1
        private String htbh1 ;
        //合同名称1
        private String htmc1 ;
        //担保方式1
        private String dbfs1 ;
        //担保人1
        private String dbr1 ;
        //合同编号2
        private String htbh2 ;
        //合同名称2
        private String htmc2 ;
        //担保方式2
        private String dbfs2 ;
        //担保人2
        private String dbr2 ;
        //合同编号3
        private String htbh3 ;
        //合同名称3
        private String htmc3 ;
        //担保方式3
        private String dbfs3 ;
        //担保人3
        private String dbr3 ;
















































































































}