package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:pdfmod:
*/
@Table("pdfmod")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pdfmod extends AbstractModule
{

        public Pdfmod(){
            super();
        }

        public Pdfmod(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "pdfmod";
        }

        //核心客户号
        @Module(getter = false, setter = false)
        private FieldHolder<String> cid = new FieldConstantHolder<>("");

        /**
        *   source:pdfmod.@0000.script
        */
        public void genePdfByTrn(String trnname,String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trnname))
			  return;
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			log.debug("{}","----------------"+data.values());
			String tempfile = pdfFile+".html";
			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfFile+".pdf");

			String logofile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtyLgnUrl(null);
			String signFile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySeaUrl(null);
			data.put("signfile",signFile);
			log.info("{}","logofile====="+logofile );
			log.info("{}","pdffile====="+pdffile );
			if(flg)
			{
			  String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			  log.info("{}","pdfPath===="+pdfPath);
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generatePdfFile",filnam,pdfPath,pdffile,data,logofile,stream);
			}
			else
			{
			  log.debug("{}","flg为false！");
			  log.debug("{}","stream:"+ stream);
			  if(pdfFile.equals("klbhsqsjcns")||pdfFile.equals("bzjzyxy"))
			    MdaUtils.invoke("com.brilliance.pdf.PDFMaker","generateStream",stream,tempfile,data);
			  else
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,data,logofile,stream);

			}
		}
        /**
        *   source:pdfmod.@0001.script
        */
        public void genePdfByTrnWithNoLogo(String trnname,String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}"," create PDF without logofile!");
			if(MdaUtils.isEmpty(trnname))
			  return;
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfFile+".pdf");

			String signFile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySeaUrl(null);
			data.put("signfile",signFile);
			log.info("{}","pdffile====="+pdffile );
			if(flg)
			{
			  String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			  log.info("{}","pdfPath===="+pdfPath);
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generatePdfFile",filnam,pdfPath,pdffile,data,"",stream);
			}
			else
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,data,"",stream);
		}
        /**
        *   source:pdfmod.@0003.script
        */
        public void generatorFreePdf(IStream stream,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),ctx.getTransName(),"PDF");
			String logofile ="";
			if(TRUE.equals(flg))
			  logofile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtyLgnUrl(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getNcid());
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","addPdfAttach",data,logofile,stream);
		}
        /**
        *   source:pdfmod.@0005.script
        */
        public void generatorPdfWithNoLogo(String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			genePdfByTrnWithNoLogo(ctx.getTransName(),filnam,pdfFile,stream,flg);
		}
        /**
        *   source:pdfmod.@0006.script
        */
        public void generatorSwiftPdf(String pdfName,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String trsnam=ctx.getTransName();
			Map<String,Object> data=Platform.getValueMap(ctx.getRoot(),trsnam,"DATA");
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			Map<String,String[]> dmap  = (Map<String,String[]>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraft",trsnam,data,cfgpath);
			log.info("{}","Draft data.size===="+dmap.size() );
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			if (flg)
			{
			  String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/swiftpdf/");
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftFile",dmap,stream,ctx.getTransName(),waterfilePath,pdfPath,pdfName);
			}
			else
			{
			  log.info("{}","waterfilePath==="+waterfilePath);
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath);
			}
		}
        /**
        *   source:pdfmod.@0007.script
        */
        public String getPDFTempFile()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return UUID.randomUUID().toString().replace("-","");
		}
        /**
        *   source:pdfmod.@0008.script
        */
        public void attachPrint(String srcFile,String desFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in attachPrint...");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","attachPrint",srcFile,desFile,ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName(),new Date());
		}
        /**
        *   source:pdfmod.@0009.script
        */
        public void attachPrintWithSign(String srcFile,String desFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in attachPrintWithSign ... ");
			String userName = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName();
			String logFile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySeaUrl("");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","attachPrintWithSign",srcFile,desFile,userName,new Date(),logFile);

		}
        /**
        *   source:pdfmod.@0010.script
        */
        public void attachPrintWithLostEffectSign(String srcFile,String desFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 根据PDF正本生成带失效签章的PDF文本
			  */
			log.debug("{}","attachPrintWithLostEffectSign...");
			log.debug("{}","in attachPrintWithSign ... ");
			String userName = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName();
			String logFile = this.getLostEffectSign();
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","printWithSign",srcFile,desFile,userName,new Date(),logFile);

		}
        /**
        *   source:pdfmod.@0011.script
        */
        public String dealPDFPath(String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","src filename = " + filename);
			int index = filename.indexOf("pdf");
			if(index > 0)
			  filename = filename.substring(index);
			log.debug("{}","filename = " + filename);
			index = filename.indexOf("\\");
			if(index > 0)
			{
			  filename = filename.replace("\\","/");
			}
			log.debug("{}","desc filename = " + filename);
			return filename;
		}
        /**
        *   source:pdfmod.@0012.script
        */
        public void setGenPdfOptions(boolean flg1, boolean flg2, boolean flg3,boolean flg4)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *
			  */
		}
        /**
        *   source:pdfmod.@0013.script
        */
        public String getLostEffectSign()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/loginfile/inval.png");
		}
        /**
        *   source:pdfmod.@0014.script
        */
        public void generatorStlSwfPdf(int count,String pdfName,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//收报文，解析
			String trsnam=ctx.getTransName();
			String filePath=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getDocpth();
			log.debug("{}","报文地址：" + filePath);
			String fileName=getSw2FileName(count);
			Map<String,String[]> dmap = null;
			//IStream stream=$sw0.getValue();
			
			if(MdaUtils.fileExists(filePath+"/"+fileName))
			{
			  dmap=(Map<String,String[]>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			  //Map<String,String[]> dmap  = (Map<String,String[]>)Platform.invoke("com.brilliance.swift.SwiftPacker","packDraft",trsnam,data,cfgpath);
			  log.info("{}","Draft data.size===="+dmap.size() );
			}
			else
			{
			  log.debug("{}",MdaUtils.getI18NString("pdfmod","CT000003")+count+MdaUtils.getI18NString("pdfmod","CT000004"));
			  return;
			}
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");

			if(fileName.endsWith(".pdf")||fileName.endsWith(".PDF"))
			{
			  MdaUtils.streamLoad(stream,filePath+"/"+fileName);
			}
			else
			{
			  if (flg)
			  {
			    String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/swiftpdf/");
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftFile",dmap,stream,ctx.getTransName(),waterfilePath,pdfPath,pdfName);
			  }
			  else
			  {
			    log.info("{}","waterfilePath==="+waterfilePath);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);
			  }
			}
		}
        /**
        *   source:pdfmod.@0015.script
        */
        public String getSw2FileName(int count)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getSf2fil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			if(count<0  ||  count>=files.length)
			  count=0;
			return files[count];
		}
        /**
        *   source:pdfmod.@0016.script
        */
        public void generatorStlPdf(int ass,String filnam,String pdfName,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//收报文，解析   国结面函
			String trsnam=ctx.getTransName();
			String filePath=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getDocpth();
			String fileName=getXmlFileName(ass);
			Map<String,Object> dmap = null;
			String logofile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtyLgnUrl(null);
			String signFile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtySeaUrl(null);
			//IStream stream=$sw0.getValue();
			if(MdaUtils.fileExists(filePath+"/"+fileName))
			{
			  dmap=(Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			  dmap.put("signfile",signFile);
			  log.info("{}","Draft data.size===="+dmap.size() );
			}
			else
			{
			  log.debug("{}",MdaUtils.getI18NString("pdfmod","CT000008"));
			  return;
			}
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");

			if(fileName.endsWith(".pdf")||fileName.endsWith(".PDF"))
			{
			  MdaUtils.streamLoad(stream,filePath+"/"+fileName);
			}
			else
			{
			  if(flg)
			  {
			    String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			    log.info("{}","pdfPath===="+pdfPath);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generatePdfFile",filnam,pdfPath,pdfName,dmap,logofile,stream);
			  }
			  else
			  {
			    // log.debug("stream:"+ stream);
			    String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			    MdaUtils.invoke("com.brilliance.doc.DocPacker","generateDoccsDocument",filePath,fileName,cfgpath,"",stream,"");
			    log.debug("{}","已生成面函文件！");
			  }
			}

		}
        /**
        *   source:pdfmod.@0017.script
        */
        public String getXmlFileCount(int ass)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			for(int i = 0; i < files.length;i++)
			{
			  if(files[i].indexOf(",")>0)
			  {
			    files[i] = files[i].substring(files[1].indexOf(",")+1);
			  }
			  else
			    break;
			}
			log.debug("{}",filename);
			return files[ass];
		}
        /**
        *   source:pdfmod.@0018.script
        */
        public String getXmlFile(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			if(type==null  ||  "".equals(type))
			  type="0";
			String[] files = filename.split(";");
			for(String file:files)
			{
			  if(file.indexOf(","+type)>0)
			  {
			    filename = file.substring(0,file.indexOf(","+type));
			    break;
			  }
			  else
			    filename = file;
			}
			log.debug("{}",filename);
			return filename;
		}
        /**
        *   source:pdfmod.@0019.script
        */
        public String getXmlFileName(int ass)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  获取xmfil文件
			  @ass：xmlfil文件的位置，
			  */
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			if(filename==null || "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			if(ass<0 || ass>=files.length)
			  return "";
			return files[ass];

			/*
			  //这里是在xmlfil这个字段中有类似“,0”的时候使用，来获取xmlfil文件的
			  String filename=$\\trnmod\\smh\\xmlfil.getValue();
			  String fil = "";
			  if(filename==null  ||  "".equals(filename))
			  return fil;
			  String[] files = filename.split(";");
			  if(ass<0  ||  ass>=files.length)
			  return fil;
			  String file = files[ass];
			  if(file.indexOf(",")>0)
			  {
			  fil = file.substring(0,file.indexOf(","));
			  }
			  else
			  fil = file;
			
			  log.debug("xmlfileNam:" + fil);
			  return fil;*/
		}
        /**
        *   source:pdfmod.@0020.script
        */
        public void attachPrintWithoutLogo(String srcFile,String desFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in attachPrint...");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","attachPrintWithoutLogo",srcFile,desFile,ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName(),new Date());
		}



        public void setCidHolder(FieldHolder<String> cid)
        {
           this.cid = (cid);
        }

        public void setCid(String cid)
        {
            this.cid.setValue(cid);
        }

        public String getCid()
        {
            return this.cid.getValue();
        }



}