package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:pxd:出口押汇协议表
*/
@Table("pxd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pxd extends AbstractModule
{

        public Pxd(){
            super();
        }

        public Pxd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "pxd";
        }

        //业务主键
        private String inr ;
        //关联编号
        private String ref ;
        //业务主键
        private String objinr ;
        //关联表名
        private String objtyp ;
        //出口押汇协议编号
        private String ownref ;
        //甲方
        private String jf ;
        //甲方住所
        private String jfzs ;
        //甲方法人代表
        private String jffrdb ;
        //乙方
        private String yf ;
        //乙方住所
        private String yfzs ;
        //乙方法人代表
        private String yffrdb ;
        //乙方单位名称
        private String yfdwmc ;
        //乙方单位地址
        private String yfdwdz ;
        //乙方邮政编码
        private String yfyzbm ;
        //乙方联系电话
        private String yflxdh ;
        //乙方联系人
        private String yflxr ;
        //指定代收人
        private String dsr ;
        //代收地址
        private String dsdz ;
        //代收邮政编码
        private String dsyzbm ;
        //代收联系电话
        private String dslxdh ;
        //乙方传真号码
        private String yfczhm ;
        //乙方电子邮件
        private String yfdzyj ;
        //乙方手机号码
        private String yfsjhm ;
        //乙方微信号码
        private String yfwxhm ;
        //乙方QQ号码
        private String yfqqhm ;
        //融资方式属于以下第X种情况
        private String syqk ;
        //额度授信协议编号
        private String sxhtbh ;
        //额度授信协议名称
        private String sxhtmc ;
        //授信额度金额
        private BigDecimal sxhtje  = new BigDecimal("0.00");
        //授信效期起始
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date xqqs;
        //授信效期终止
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date xqzz;
        //押汇付款方式为XX项下出口押汇
        private String fkfs ;
        //信用证号/贸易合同号(托收和汇款项下填写贸易合同号)
        private String xyzh ;
        //开证行/待收行
        private String kzh ;
        //押汇年利率
        private BigDecimal yhnll  = new BigDecimal("0.00");
        //用途
        private String yt ;
        //结息约定
        private String jxyd ;
        //结息其他方式
        private String jxqtfs ;
        //罚息率（逾期日利率）
        private BigDecimal fxl  = new BigDecimal("0.00");
        //股东、股权变更比例
        private BigDecimal gqbgbl  = new BigDecimal("0.00");
        //财务状况变动允许范围
        private String cwbdfw ;
        //乙方声明与承诺其他事项
        private String yfqtsx ;
        //争议解决方式（壹、贰、叁）
        private String zyjjfs ;
        //仲裁委员会
        private String zcwyh ;
        //开庭地点
        private String ktdd ;
        //争议解决其他方式
        private String qtfs ;
        //补充条款
        private String bctk ;
        //合同编号1
        private String htbh1 ;
        //合同名称1
        private String htmc1 ;
        //担保方式1
        private String dbfs1 ;
        //担保人1
        private String dbr1 ;
        //合同编号2
        private String htbh2 ;
        //合同名称2
        private String htmc2 ;
        //担保方式2
        private String dbfs2 ;
        //担保人2
        private String dbr2 ;
        //合同编号3
        private String htbh3 ;
        //合同名称3
        private String htmc3 ;
        //担保方式3
        private String dbfs3 ;
        //担保人3
        private String dbr3 ;
        //业务所属机构
        private String ptyinr ;
        //落地机构号
        private String bchcod ;






























































































































}