package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:rpd:(业务表)汇款表
*/
@Table("rpd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rpd extends AbstractModule
{

        public Rpd(){
            super();
        }

        public Rpd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "rpd";
        }

        //交易索引
        private String inr ;
        //交易参考号
        private String ownref ;
        //汇款类型
        private String orctyp ;
        //报文属性
        private String msgatr ;
        //代理行行号
        private String agtextkey ;
        //代理行账号
        private String agtact ;
        //起息日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //交易货币符号
        private String rptcur ;
        //交易金额
        private BigDecimal rptamt  = new BigDecimal("0.00");
        //付款人账号
        private String orcact ;
        //付款人行号
        private String orcextkey ;
        //付款人名称
        private String orcnam ;
        //付款人地址
        private String orcadr ;
        //付款人开户行账号
        private String oriact ;
        //付款人开户行行号
        private String oriextkey ;
        //付款人开户行名称
        private String orinam ;
        //中间清算行1-账号-接收直接
        private String actin1 ;
        //中间清算行1-行号-发起直接
        private String extkeyin1 ;
        //中间清算行1-名称
        private String namin1 ;
        //中间清算行2-账号-接收间接
        private String actin2 ;
        //中间清算行2-行号-发起间接
        private String extkeyin2 ;
        //中间清算行2-名称
        private String namin2 ;
        //中间清算行3-账号-接收直接1
        private String actin3 ;
        //中间清算行3-行号-发起直接1
        private String extkeyin3 ;
        //中间清算行3-名称
        private String namin3 ;
        //收款人开户行账号
        private String awiact ;
        //收款人开户行行号
        private String awiextkey ;
        //收款人开户行名称
        private String awinam ;
        //收款人账号
        private String pyeact ;
        //收款人行号
        private String pyeextkey ;
        //收款人名称
        private String pyenam ;
        //收款人地址
        private String pyeadr ;
        //汇款附言
        private String remcmt ;
        //发报行附言
        private String sedcmt ;
        //COV发报行附言
        private String covsedcmt ;
        //附加信息
        private String addmsg ;
        //原始货币符号
        private String pricur ;
        //原始金额
        private BigDecimal priamt  = new BigDecimal("0.00");
        //汇率
        private BigDecimal chgrat  = new BigDecimal("0.00");
        //费用承担方
        private String feerol ;
        //发报行收费货币符号
        private String sedfeecur ;
        //发报行收费金额
        private BigDecimal sedfee  = new BigDecimal("0.00");
        //收报行收费货币符号
        private String rcvfeecur ;
        //收报行收费金额
        private BigDecimal rcvfee  = new BigDecimal("0.00");
        //业务优先级
        private String proity ;
        //业务种类编码
        private String typcod ;
        //业务类型
        private String rpttyp ;
        //业务所属机构
        private String ptyinr ;
        //etyinr
        private String etyinr ;
        //所属落地机构
        private String bchcod ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //备注
        private String beizhu ;
        //相关参考号
        private String xgckha ;
        //支付业务参考号
        private String zfywck ;
        //支付相关参考号
        private String zfxgck ;
        //信息电发报行
        private String msgsed ;
        //业务类型
        private String objtyp ;
        //业务主键
        private String objinr ;
        //付款人地址3
        private String orcadr3 ;
        //付款人地址2
        private String orcadr2 ;
        //付款人地址4
        private String orcadr4 ;
        //付款人地址5
        private String orcadr5 ;
        //付款人地址6
        private String orcadr6 ;
        //付款人地址7
        private String orcadr7 ;
        //收款人地址2
        private String pyeadr2 ;
        //收款人地址3
        private String pyeadr3 ;
        //收款人地址4
        private String pyeadr4 ;
        //收款人地址5
        private String pyeadr5 ;
        //收款人地址6
        private String pyeadr6 ;
        //收款人地址7
        private String pyeadr7 ;
        //报文标识号
        private String bawbsh ;
        //附言1
        private String fuyan1 ;
        //附言2
        private String fuyan2 ;
        //附言3
        private String fuyan3 ;
        //附言4
        private String fuyan4 ;
        //致收款人银行附言1
        private String fuyns1 ;
        //致收款人银行附言2
        private String fuyns2 ;
        //致收款人银行附言3
        private String fuyns3 ;
        //致收款人银行附言4
        private String fuyns4 ;
        //明细业务总笔数
        private long mxywbs ;
        //明细业务金额
        private BigDecimal mxywje  = new BigDecimal("0.00");
        //明细业务标识号
        private String mxywsh ;
        //交易名
        private String frm ;
        //spt状态
        private String cip ;
        //清算编号
        private String sysno ;
        //bch的inr
        private String branchinr ;
        //营业机构号
        private String bchkeyinr ;
        //支付交易序号
        private String paynum ;




















































































































































































}