package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:shs:购汇额度申请业务表
*/
@Table("shs")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Shs extends AbstractModule
{

        public Shs(){
            super();
        }

        public Shs(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "shs";
        }

        //主键
        private String inr ;
        //业务所属机构
        private String ptyinr ;
        //实体机构编号
        private String etyinr ;
        //所属落地机构
        private String bchcod ;
        //业务参考号
        private String businessno ;
        //机构名称
        private String orgname ;
        //机构号
        private String orgcode ;
        //客户号
        private String ecifno ;
        //客户名称
        private String ecifname ;
        //客户外币账户
        private String cuswbzh ;
        //币种
        private String currency ;
        //金额
        private BigDecimal paysum  = new BigDecimal("0.00");
        //可购汇额度
        private BigDecimal cansaleed  = new BigDecimal("0.00");
        //已购金额(累计购汇金额)
        private BigDecimal havesale  = new BigDecimal("0.00");
        //已购未付金额
        private BigDecimal havegwfed  = new BigDecimal("0.00");
        //已付汇金额
        private BigDecimal yifhje  = new BigDecimal("0.00");
        //已结汇金额
        private BigDecimal yijhje  = new BigDecimal("0.00");
        //购汇性质(新)
        private String salexz ;
        //结购汇统计代码(新)
        private String jieshtjno ;
        //国际收支申报交易编码
        private String gjszsbno ;
        //国际收支申报交易编码(新)
        private String gjszsbnewno ;
        //付汇方式（新）
        private String paytype ;
        //外汇局批件号(新)
        private String whjno ;
        //最迟购汇日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date zcghdat;
        //影像id
        private String guid ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date applydat;
        //经办人姓名
        private String operatorname ;
        //经办人手机号
        private String operatortel ;
        //申请状态
        private String applystatus ;
        //额度操作标标识
        private String eduflag ;
        //是否结汇
        private String jiehsign ;
        //删除状态
        private String deleted ;
        //修改时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date upddat;
        //创建时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //备注
        private String remark ;
        //附言
        private String postscript ;
        //重新生效原因
        private String reores ;
        //最迟购汇日期(新)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date zcghnewdat;
        //退回原因
        private String backreason ;
        //人民币账号
        private String duifzh ;
        //客户外币账户名称
        private String cuswbzhname ;
        //交易性质
        private String jshno ;
        //渠道号
        private String appid ;
        //业务所属机构(银行)
        private String orginr ;
        //加解锁标识
        private String lockflag ;
        //结售汇统计代码
        private String jieshtjnol ;
        //购汇性质
        private String salexzl ;
        //申请类型
        private String applytyp ;
        //流水号
        private String serialnum ;
        //录入时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date enterdat;
        //外汇局批件号
        private String whjnol ;
        //付汇方式
        private String paytypel ;












































































































}