package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:spb:深圳分行国际业务审批表及真实性情况表
*/
@Table("spb")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Spb extends AbstractModule
{

        public Spb(){
            super();
        }

        public Spb(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "spb";
        }

        //主键
        private String inr ;
        //保函编号
        private String lgcode ;
        //合同编号
        private String concode ;
        //通知行
        private String advbank ;
        //保证金比例
        private BigDecimal bhbzjbl  = new BigDecimal("0.00");
        //保证金金额
        private BigDecimal cashamt  = new BigDecimal("0.00");
        //保证金账号
        private String cashaccount ;
        //贷款余额
        private BigDecimal dkamt  = new BigDecimal("0.00");
        //承兑汇票余额
        private BigDecimal cdhpamt  = new BigDecimal("0.00");
        //打包贷款余额
        private BigDecimal dbdkamt  = new BigDecimal("0.00");
        //进出口押汇余额
        private BigDecimal jckyhamt  = new BigDecimal("0.00");
        //保函余额
        private BigDecimal bhamt  = new BigDecimal("0.00");
        //开证余额
        private BigDecimal kzamt  = new BigDecimal("0.00");
        //其它融资余额
        private BigDecimal qtrzamt  = new BigDecimal("0.00");
        //逾期贷款及垫款余额
        private BigDecimal yqdkamt  = new BigDecimal("0.00");
        //授信总额
        private BigDecimal sxamt  = new BigDecimal("0.00");
        //额度批准文号
        private String edcode ;
        //额度类型及总额
        private String edamt ;
        //已使用额度
        private BigDecimal usedamt  = new BigDecimal("0.00");
        //可用余额
        private BigDecimal kyamt  = new BigDecimal("0.00");
        //已按总/分行信审会批复落实各项授信条件，并取得《额度启用通知书》。
        private String shenpi1 ;
        //上述填报内容正确无误
        private String shenpi2 ;
        //已按规定收取足额保证金。
        private String shenpi3 ;
        //自有保证金
        private String shenpi4 ;
        //第三方保证金
        private String shenpi5 ;
        //本笔业务有足够的可使用额度（附额度台账）。
        private String shenpi6 ;
        //本笔业务已提供分行要求的相关材料，手续齐备，项目背景/贸易背景真实。
        private String shenpi7 ;
        //以往履约记录良好，无不良记录。
        private String shenpi8 ;
        //保函手续费标准
        private String shenpi9 ;
        //保证金
        private String baozhengjin ;
        //付款账号
        private String fkaccount ;
        //收款账号
        private String skaccount ;
        //客户名称
        private String kehunam ;
        //贸易性质
        private String myxz ;
        //其他备注情况
        private String qtbzqk ;
        //业务情况描述
        private String ywqkms ;
        //支行意见
        private String zhyj ;
        //贸易融资专项额度总额
        private BigDecimal myrzzxamt  = new BigDecimal("0.00");
        //其中开证额度总额
        private BigDecimal qzkzedamt  = new BigDecimal("0.00");
        //其中保函额度总额
        private BigDecimal qzbhamt  = new BigDecimal("0.00");
        //银关保额度总额
        private BigDecimal ygbeamt  = new BigDecimal("0.00");
        //其它贸金融资额度总额
        private BigDecimal qtmjrzamt  = new BigDecimal("0.00");
        //当前日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date todate;


























































































}