package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:sxb:中投保授信审批表及真实性表
*/
@Table("sxb")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sxb extends AbstractModule
{

        public Sxb(){
            super();
        }

        public Sxb(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "sxb";
        }

        //主键
        private String inr ;
        //保函编号
        private String lgcode ;
        //合同编号
        private String concode1 ;
        //通知行
        private String advbank ;
        //保证金比例
        private BigDecimal zbhbzjbl  = new BigDecimal("0.00");
        //单位
        private String pany ;
        //批复呈报单位
        private String pifu0 ;
        //没有批复呈报单位
        private String pifu1 ;
        //客户名称
        private String ptynam ;
        //担保方式及担保内容
        private String dbtycon ;
        //一般风险综合授信额度启用
        private String type1 ;
        //一般风险单笔单批（首笔）
        private String type2 ;
        //一般风险授信额度项下业务的提款
        private String type3 ;
        //一般风险单笔单批（非首笔）
        private String type4 ;
        //申请业务品种
        private String objtyp ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //期限
        private String cpldattim ;
        //绿色信贷分类
        private String xindai0 ;
        //绿色信贷未分类
        private String xindai1 ;
        //绿色信贷分类结果
        private String xdresult ;
        //模式化标识
        private String mssign ;
        //模式化种类
        private String mskind ;
        //模式化项目
        private String msitem ;
        //模式化分层信息
        private String msinfo ;
        //适应涉及环境保护违法违规且尚未完成整改的企业信贷情况
        private String shiyong1 ;
        //不适应涉及环境保护违法违规且尚未完成整改的企业信贷情况
        private String shiyong2 ;
        //适用涉及安全生产违法违规且尚未完成整改的企业信贷情况
        private String shiyong3 ;
        //不适用涉及安全生产违法违规且尚未完成整改的企业信贷情况
        private String shiyong4 ;
        //适用涉及落后产能且尚未完成淘汰的企业信贷情况
        private String shiyong5 ;
        //不适用涉及落后产能且尚未完成淘汰的企业信贷情况
        private String shiyong6 ;
        //适用涉及职业病预防控制措施不达标且尚未完成整改的企业信贷情况
        private String shiyong7 ;
        //不适用涉及职业病预防控制措施不达标且尚未完成整改的企业信贷情况
        private String shiyong8 ;
        //授信用途
        private String sxtext ;
        //为固定资产贷款或项目融资贷款
        private String rzdk0 ;
        //未为固定资产贷款或项目融资贷款
        private String rzdk1 ;
        //贷款描述
        private String dktext ;
        //交易对手是关联企业
        private String glqy0 ;
        //交易对手不是关联企业
        private String glqy1 ;
        //关联企业描述
        private String gltext ;
        //是F51批发贸易类企业
        private String f51pf0 ;
        //不是F51批发贸易类企业
        private String f51pf1 ;
        //f51描述
        private String f51text ;
        //担保人黑名单
        private String dbhmd0 ;
        //不存在黑名单信息
        private String dbhmd1 ;
        //有借款人灰名单
        private String jkhmd0 ;
        //无借款人灰名单
        private String jkhmd1 ;
        //有担保人灰名单
        private String dbhui0 ;
        //无担保人灰名单
        private String dbhui1 ;
        //借款人灰名单措施
        private String jkhtext ;
        //担保人灰名单措施
        private String dbhtext ;
        //借款人预警
        private String jkyj0 ;
        //无借款人预警
        private String jkyj1 ;
        //借款人预警措施
        private String jkytext ;
        //担保人预警
        private String dbyj0 ;
        //无担保人预警
        private String dbyj1 ;
        //担保人预警措施
        private String dbytext ;
        //该客户是三农企业
        private String jysel1 ;
        //该客户不是三农企业
        private String jysel2 ;
        //经调查核实抵质押物状态正常，不存在包括但不限于查封、扣押、冻结等可能导致我行债权丧失或劣后于其他债权人债权的情况
        private String jysel3 ;
        //同意提款
        private String jysel4 ;
        //其他
        private String jysel5 ;
        //第二经营主责任人
        private String jysel6 ;
        //经营主负责人
        private String jysel10 ;
        //已确认抵质押物状态正常
        private String jysel7 ;
        //同意提款
        private String jysel8 ;
        //其他
        private String jysel9 ;
        //经营主责任人转授权
        private String fhbmsel1 ;
        //模式化相关信息
        private String fhbmsel2 ;
        //战略/重点客户
        private String fhbmsel3 ;
        //核准额度/风险资产
        private String fhbmsel4 ;
        //F51批发贸易类企业
        private String fhbmsel5 ;
        //其他
        private String fhbmsel6 ;
        //F51批发贸易类企业
        private String fhbmsel7 ;
        //批复/管理办法要求
        private String fhbmsel8 ;
        //其他
        private String fhbmsel9 ;
        //业务管理意见
        private String ywopion ;
        //信用审批意见
        private String xsopion ;
        //灰名单
        private String fhbmsel10 ;
        //征信预警
        private String fhbmsel11 ;
        //其他
        private String fhbmsel12 ;
        //风险管理部意见
        private String fxopion ;
        //经营主责任人
        private String fhldsel1 ;
        //固定资产或项目融资贷款
        private String fhldsel2 ;
        //批复/管理办法要求
        private String fhldsel3 ;
        //F51批发贸易类企业
        private String fhldsel4 ;
        //其他
        private String fhldsel5 ;
        //固定资产或项目融资贷款
        private String fhldsel6 ;
        //灰名单
        private String fhldsel10 ;
        //F51批发贸易类企业
        private String fhldsel11 ;
        //征信预警
        private String fhldsel7 ;
        //批复/管理办法要求
        private String fhldsel8 ;
        //其他
        private String fhldsel9 ;
        //业务行领导意见
        private String ywhopion ;
        //风险管理行领导意见
        private String fxhopion ;
        //客户名称
        private String kehunam1 ;
        //贸易性质
        private String myxz1 ;
        //其他备注情况
        private String qtbzqk1 ;
        //业务情况描述
        private String ywqkms1 ;
        //客户发生违法违规行为，已经或即将受到监管部门处罚
        private String kehuqk1 ;
        //客户高管存在违法违纪行为，已经或即将受到监管部门处罚
        private String kehuqk2 ;
        //其他异常情况，请说明
        private String kehuqk5 ;
        //客户在我行或它行授信出现不良或发生垫款
        private String kehuqk4 ;
        //客户被纳入人行、税务、海关等监管部门黑名单
        private String kehuqk3 ;
        //真实性日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date realdate;
        //经营机构第一负责人活授权人意见
        private String fzrsqryj ;
        //经办客户经理意见
        private String jbkhyj ;
        //其他
        private String qtyj ;
        //支行意见
        private String zhyj ;
        //机构名称
        private String papl1 ;
        //日期
        private String pcredate3 ;
        //月份
        private String pcredate2 ;
        //年份
        private String pcredate1 ;




































































































































































































































}