package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:tde:
*/
@Table("tde")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Tde extends AbstractModule
{

        public Tde(){
            super();
        }

        public Tde(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "tde";
        }

        //业务主键
        private String inr ;
        //收款日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date gathdat;
        //收款企业名称
        private String gathname ;
        //统一社会信用代码
        private String socialcrdtcd ;
        //收款金额合计
        private BigDecimal totalamt  = new BigDecimal("0.00");
        //货物贸易金额
        private BigDecimal tradeamt  = new BigDecimal("0.00");
        //预收货款金额
        private BigDecimal preamt  = new BigDecimal("0.00");
        //预收货款占合同金额比例
        private BigDecimal amtscale  = new BigDecimal("0.00");
        //预计_天后报关
        private String predays ;
        //物流状态
        private String transsta ;
        //报关经营单位名称
        private String servicenam ;
        //报关经营单位组织机构代码
        private String serviceorgcod ;
        //一般贸易金额
        private BigDecimal genamt  = new BigDecimal("0.00");
        //边境贸易金额
        private BigDecimal bjmyamt  = new BigDecimal("0.00");
        //进料加工金额
        private BigDecimal jljgamt  = new BigDecimal("0.00");
        //其他贸易金额
        private BigDecimal othtradeamt  = new BigDecimal("0.00");
        //海关特殊监管区域及保税监管场所进出境物流货物金额
        private BigDecimal custamt  = new BigDecimal("0.00");
        //离岸转手买卖金额
        private BigDecimal leaveamt  = new BigDecimal("0.00");
        //其他金额
        private BigDecimal otheramt  = new BigDecimal("0.00");
        //服务贸易金额
        private BigDecimal serviceamt  = new BigDecimal("0.00");
        //服务贸易交易编码
        private String servicecod ;
        //业务所属机构
        private String objinr ;
        //对象类型
        private String objtyp ;


















































}