package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:trd:(业务表)进口融资业务信息表
*/
@Table("trd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trd extends AbstractModule
{

        public Trd(){
            super();
        }

        public Trd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "trd";
        }

        //唯一编号
        private String inr ;
        //业务编号
        private String ownref ;
        //STL编号
        private String stlref ;
        //业务操作人员
        private String ownusr ;
        //所属机构
        private String ptyinr ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //融资类型
        private String fintyp ;
        //融资利率
        private BigDecimal finrat  = new BigDecimal("0.00");
        //信用证付款期限
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date expdat;
        //所属实体
        private String etyinr ;
        //合同编号
        private String connum ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //所属落地机构
        private String bchcod ;
        //押汇金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //押汇币种
        private String cur ;
        //罚息利率
        private BigDecimal disrat  = new BigDecimal("0.00");
        //押汇编号
        private String ref ;
        //父交易类型
        private String pnttyp ;
        //父交易编号
        private String pntinr ;
        //融资到期日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date matdat;
        //贸易合同名称
        private String connam ;
        //基准利率
        private BigDecimal intrat  = new BigDecimal("0.00");
        //名义利率
        private BigDecimal actrat  = new BigDecimal("0.00");
        //计息方式
        private String caltyp ;
        //调息方式
        private String arrrar ;
        //逾期计息方式
        private String ocaltp ;
        //押汇期限
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date trodat;
        //其他计息方式
        private String othtyp ;
        //调息方式数值
        private String arrnum ;
        //父交易参号
        private String pntref ;
        //大写
        private String word ;
        //押汇期限
        private String subday ;
        //贸易融资综合授信协议编号
        private String ftfinancing ;
        //授信额度
        private String credittyp ;
        //存单号
        private String cdno ;
        //外币押汇利率执行方式
        private String fcnytyp ;
        //协商利率
        private BigDecimal consrate  = new BigDecimal("0.00");
        //公布利率
        private BigDecimal postedrate  = new BigDecimal("0.00");
        //LIBOR/HIBOR
        private String lihibor ;
        //基点数值
        private Integer basnum;
        //人民币押汇利率方式
        private String cnyltyp ;
        //实际执行年利率
        private BigDecimal trunll  = new BigDecimal("0.00");
        //市场利率报价时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date lrldat;
        //市场利率类型
        private String lrltyp ;
        //市场利率
        private BigDecimal lrlrat  = new BigDecimal("0.00");
        //BPs+/-
        private String bpsas ;
        //BPs值
        private Integer bpsnum;
        //利率浮动周期
        private String ratcycle ;
        //利率其他约定
        private String othrat ;
        //月结息日
        private String ratday ;












































































































}