package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:trn:(系统表)业务流水表
*/
@Table("trn")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trn extends AbstractModule
{

        public Trn(){
            super();
        }

        public Trn(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "trn";
        }

        //唯一编号
        private String inr ;
        //参考号
        private String ownref ;
        //对象类型
        private String objtyp ;
        //对象编号
        private String objinr ;
        //业务描述
        private String objnam ;
        //申请订单编号
        private String ordinr ;
        //业务已授权状态
        private String relres ;
        //业务授权流程定义
        private String relreq ;
        //交易原始币种
        private String reloricur ;
        //交易原始金额
        private BigDecimal reloriamt  = new BigDecimal("0.00");
        //授权币种
        private String relcur ;
        //授权金额
        private BigDecimal relamt  = new BigDecimal("0.00");
        //企业客户主键
        private String ptyinr ;
        //企业客户实体主键
        private String etyinr ;
        //企业客户实体组主键
        private String etginr ;
        //企业客户名称
        private String nam ;
        //业务归属机构编号
        private String bchcod ;
        //相关系统业务编号
        private String stlref ;
        //业务归属机构
        private String optptyinr ;
        //经办实体
        private String optetyinr ;
        //经办实体组
        private String optetginr ;
        //复核授权信息
        private String nxtlev ;
        //后续授权信息
        private String nxtreq ;
        //创建用户
        private String iniusr ;
        //交易编码
        private String inifrm ;
        //交易创建时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date inidattim;
        //交易完成时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date cpldattim;
        //通知确认时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date cfmdattim;
        //业务状态
        private String sta ;
        //影像批次号
        private String imgref ;
        //交易原始流水号
        private String oriinr ;
        //业务流水类型
        private String ptytyp ;
        //操作流程计数器
        private Integer relstp;
        //当前流水的关联前手表主键
        private String srcinr ;
        //前手关联表名
        private String srctyp ;
        //交易类型
        private String modtyp ;
        //勾选标志
        private String flg ;
        //业务流水来源
        private String wfm ;
        //退回处理状态
        private String baksta ;
        //退回时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date bakdat;




















































































}