package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:wid:
*/
@Table("wid")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Wid extends AbstractModule
{

        public Wid(){
            super();
        }

        public Wid(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "wid";
        }

        //唯一编号
        private String inr ;
        //业务申请号码
        private String ownref ;
        //所属落地机构
        private String bchcod ;
        //申请日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //交易方向
        private String jyfx ;
        //期权方向
        private String qqfx ;
        //结售汇方向
        private String jshfx ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //执行价格
        private String zxamt ;
        //执行日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date zxdate;
        //期权费
        private BigDecimal qqfamt  = new BigDecimal("0.00");
        //浮动区间
        private BigDecimal fdqj  = new BigDecimal("0.00");
        //是否差额交割
        private String sfcejg ;
        //人民币账号
        private String cnyacc ;
        //外币账号
        private String fxacc ;
        //人民币保证金账号
        private String cnybacc ;
        //外币保证金账号
        private String fxbacc ;
        //综合授信协议
        private String zhsxxy ;
        //外管局统计码
        private String wgjtjm ;
        //外币清算国家或地区
        private String wbqsg ;
        //保证金比例
        private BigDecimal bzjbl  = new BigDecimal("0.00");
        //违约扣费账户
        private String wykfacc ;
        //逾期贷款利率
        private BigDecimal yqdkll  = new BigDecimal("0.00");
        //是否需要保证金并质押协议
        private String sfbzjxy ;
        //是否已签订年度保证金协议
        private String sfndbzjxy ;
        //dbchcod
        private String dbchcod ;
        //客户编号
        private String ptyinr ;
        //所属实体
        private String etyinr ;
        //STL编号
        private String stlref ;
        //通知日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date advdat;
        //修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedat;
        //期权类型
        private String qqtyp ;
        //期权费方向
        private String qqffx ;
        //衍生交易总协议
        private String ysjyzxy ;
        //期权费收取方式
        private String qqfsq ;
        //结汇执行汇率
        private BigDecimal jhzxhl  = new BigDecimal("0.00");
        //售汇执行汇率
        private BigDecimal shzxhl  = new BigDecimal("0.00");
        //开立日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date opndat;
        //交易后处理业务类型
        private String qqywlx ;
        //盈亏金额
        private BigDecimal ykje  = new BigDecimal("0.00");
        //盈亏
        private String yktyp ;
        //闭卷日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date clsdat;
        //业务状态
        private String sta ;
        //项目类型
        private String xmlx ;
        //客户类别
        private String khlb ;
        //保证金质押协议
        private String bzjzyxy ;
        //差额交割参考汇率
        private BigDecimal fyrate  = new BigDecimal("0.00");
        //关联业务名称
        private String reltrnnam ;
        //是否关联业务
        private String isreltrn ;
        //关联业务编号
        private String reltrnref ;
        //关联业务质押协议编号
        private String relzyxybh ;
        //关联保证金账号
        private String relbzjacc ;
        //是否保函或者信用证
        private String isbhorxyz ;
        //保函或者信用证业务编号
        private String bhorxyzref ;
        //担保合同编号
        private String dbhetongref ;
        //可选择的天数
        private String candat ;






















































































































}