package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AcdselVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Acd;
import com.ceb.gjjs.mda.manager.module.Acdp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Acdgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 预约开户信息查询
*/
@Transaction(vo= AcdselVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Acdsel extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Acdsel.class);

        //开始日期
        private Date stadat;
        //结束日期
        private Date stodat;
        //导出
        private IStream download = new StreamImpl();
        //归属机构
        private String ptynam;
        //查询
        private transient IControl serachs = new ControlImpl("serachs", "查询", this);
        //开户状态
        private String stu;
        //账户类型
        private String accounttype;
        //刷新
        private transient IControl resh = new ControlImpl("resh", "刷新", this);
		@BDGetter
		private Acdgrp acdgrp;

		@BDGetter
		private Acdp acdp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private ModuleList<Acd> acdlst;


		public Acdsel()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getAcdp().setAcdgrpHolder(()->this.getAcdgrp());
        }

        /**
        *   source:acdsel.@0000.script
        */
        @Rule(target="download",order=100)
        public boolean ruleDownloadN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream is=this.getDownload();
			is.setType("xls");

			List<Object[]>list=new ArrayList<Object[]>();
			String []tit=new String[15];
			//tit[0] = "备案业务编号";
			tit[0] = "业务参号";
			tit[1] = "企业名称";
			tit[2] = "企业联系方式";
			tit[3] = "统一社会信用代码";
			tit[4] = "法人/负责人联系方式";
			tit[5] = "财务负责人联系方式";
			tit[6] = "办理人联系方式";
			tit[7] = "大额交易核实人1联系方式";
			tit[8] = "大额交易核实人2联系方式";
			tit[9] = "账户类型";
			tit[10] = "是否需要开立外汇账户";
			tit[11] = "开户状态";
			tit[12] = "归属机构名称";
			tit[13] = "发送时间";
			tit[14] = "开户账号";
			list.add(tit);
			int len=this.getAcdlst().fullSize();
			log.debug("{}","数据条数：  "+len);
			for(int i=0;i<len;i++)
			{
			  String []lins=new String[15];
			  lins[0]=this.getAcdlst().getElement(i).getOwnref();
			  lins[1]=this.getAcdlst().getElement(i).getEntname();
			  lins[2]=this.getAcdlst().getElement(i).getEnttel();
			  lins[3]=this.getAcdlst().getElement(i).getSocialcrdtcd();
			  lins[4]=this.getAcdlst().getElement(i).getLegalrepresentative();
			  lins[5]=this.getAcdlst().getElement(i).getFinancialadmin();
			  lins[6]=this.getAcdlst().getElement(i).getTransactor();
			  lins[7]=this.getAcdlst().getElement(i).getTransverifier1();
			  lins[8]=this.getAcdlst().getElement(i).getTransverifier2();

			  lins[9]=MdaUtils.getCodetableLabel("accounttype",this.getAcdlst().getElement(i).getAccounttype());
			  lins[10]=MdaUtils.getCodetableLabel("openfea",this.getAcdlst().getElement(i).getOpenfea());
			  lins[11]=MdaUtils.getCodetableLabel("status",this.getAcdlst().getElement(i).getStatus());

			  lins[12]=this.getNamByCid(this.getAcdlst().getElement(i).getBchcod());

			  if(!MdaUtils.isEmpty(this.getAcdlst().getElement(i).getCredat()))
			    lins[13]=MdaUtils.format(this.getAcdlst().getElement(i).getCredat(),"yyyy/MM/dd HH:mm:ss");
			  else
			    lins[13]="";

			  if(MdaUtils.isEmpty(this.getAcdlst().getElement(i).getAccount()))
			    lins[14]="";
			  else
			    lins[14]=this.getAcdlst().getElement(i).getAccount();
			  list.add(lins);
			}

			String today = MdaUtils.format(MdaUtils.today(),"yyyyMMdd-HH_mm_ss");
			String fileName = "预约开户信息-"+today+".xls";
			try
			{
			  is.setName(new String(fileName.getBytes("GBK"),"GBK"));
			}
			catch(Exception e)
			{
			}

			MdaUtils.unloadExcel(list,is,false);


			return true;
        }

        /**
        *   source:acdsel.@0003.script
        */
        @Rule(target="resh",order=100)
        public boolean ruleReshN100(){
            IContext ctx = MdaEnv.getContext();
            
			doFresh("A");

			return true;
        }

        /**
        *   source:acdsel.@0004.script
        */
        @Rule(target="serachs",order=100)
        public boolean ruleSerachsN100(){
            IContext ctx = MdaEnv.getContext();
            
			doFresh("B");

			return true;
        }



        /**
        *   source:acdsel.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setStadat(MdaUtils.add(MdaUtils.today(),-15));
			this.setStodat(MdaUtils.today());
			
			

			List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this,"ptynam",bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			  this.setPtynam(bchcod.get(0).getValue());

			doFresh("A");

			return true;
        }


        /**
        *   source:acdsel.@0001.script
        */
        public void doFresh(String st)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Date sta=this.getStadat();
			Date sto=this.getStodat();
			if(MdaUtils.isEmpty(sta) || MdaUtils.isEmpty(sto))
			{
			  if(MdaUtils.isEmpty(sta))
			    ctx.setFieldError(this,"stadat",MdaUtils.getI18NString("acdsel","CT000046"));
			  else
			    ctx.setFieldError(this,"stodat",MdaUtils.getI18NString("acdsel","CT000047"));
			  return ;
			}

			MdaUtils.clear(this.getAcdlst());
			String ptynam=this.getPtynam();
			String sql="";

			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> entname =new Argument<String>("entname");
			Argument<String> enttel =new Argument<String>("enttel");
			Argument<String> socialcrdtcd =new Argument<String>("socialcrdtcd");
			Argument<Date> credat =new Argument<Date>("credat");
			Argument<String> legalrepresentative=new Argument<String>("legalrepresentative");
			Argument<String> financialadmin =new Argument<String>("financialadmin");
			Argument<String> transactor =new Argument<String>("transactor");
			Argument<String> transverifier1 =new Argument<String>("transverifier1");
			Argument<String> transverifier2 =new Argument<String>("transverifier2");
			Argument<String> accounttype =new Argument<String>("accounttype");
			Argument<String> openfea =new Argument<String>("openfea");
			Argument<String> bchcod =new Argument<String>("bchcod");
			Argument<String> status =new Argument<String>("status");
			Argument<String> account =new Argument<String>("account");
			sql="select inr,ownref,entname,account,enttel,socialcrdtcd,legalrepresentative,financialadmin,transactor,transverifier1,transverifier2,accounttype,openfea,status,bchcod,credat from acd where credat>=? AND credat<=? ";

			if("A".equals(st) || MdaUtils.isEmpty(this.getStu()))
			{
			  sql=sql+" and status is not null";
			}
			else
			{
			  sql=sql+" and status='"+this.getStu()+"'";
			}

			if(!"A".equals(st) && !MdaUtils.isEmpty(this.getAccounttype()))
			{
			  sql=sql+" and accounttype='"+this.getAccounttype()+"'";
			}

			String ptyinr=this.getSysmod().getPty().getInr();
			String lvl=this.getSysmod().getPty().getLvl();
			String  cid=this.getSysmod().getPty().getCid();
			if(!MdaUtils.isEmpty(this.getPtynam())&&!"ptynam".equals(ptyinr))   //获取机构主键和机构等级
			{
			  ptyinr=ptynam;
			  lvl=this.getSysmod().getBchmod().getBranchLvlByInr(ptyinr);
			  cid=this.getSysmod().getCidByInr(ptyinr);
			}
			log.debug("{}","ptyinr    lvl   cid="+ptyinr+ "   "+lvl+"   "+cid);

			if("0".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE p.cid=bchcod)";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+ " AND EXISTS (SELECT inr FROM pty p WHERE p.cid=bchcod and (p.cid='"+cid+"' or pntinr='"+cid+"'))";
			}
			else
			{
			  sql=sql+" AND bchcod='"+cid+"'";
			}

			sql=sql+" ORDER  BY credat DESC";
			log.debug("{}","[acdsel->search]查询的sql="+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getStadat(),GT),MdaUtils.sqlDate(this.getStodat(),LT));
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,entname,account,enttel,socialcrdtcd,legalrepresentative,financialadmin,transactor,transverifier1,transverifier2,accounttype,openfea,status,bchcod,credat);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getAcdlst().add(inr,ownref,entname,enttel,account,socialcrdtcd,legalrepresentative,financialadmin,transactor,transverifier1,transverifier2,accounttype,openfea,status,bchcod,credat);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:acdsel.@0005.script
        */
        public String getNamByCid(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(cid))
			{
			  return null;
			}
			Argument<String> nam=new Argument<String>("nam");
			ctx.getDaoSession().dbExecuteSQL("SELECT nam FROM pty WHERE cid='"+cid+"'");
			ctx.getDaoSession().dbFetchFields(nam);
			ctx.getDaoSession().dbCloseCursor();
			int e=ctx.getErrorCode();
			if(e==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(nam.value))
			  {

			    return nam.value;
			  }
			  else
			  {

			    return null;
			  }
			}
			else
			{
			  return null;
			}
		}













}