package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AnnalsVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tatp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.bo.Gitpush;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Eabp;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Ordmod;
import com.ceb.gjjs.mda.manager.module.Imgmod;
import com.ceb.gjjs.mda.manager.module.Tasgrp;
import com.ceb.gjjs.mda.manager.module.Eabgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 历史文件夹
*/
@Transaction(vo= AnnalsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Annals extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Annals.class);

        //通知书
        private String msg;
        //报文2
        private IStream sw2 = new StreamImpl();
        //docpth
        private String docpth;
        //display
        private String display;
        //报文0
        private IStream sw0 = new StreamImpl();
        //报文1
        private IStream sw1 = new StreamImpl();
        //报文3
        private IStream sw3 = new StreamImpl();
        //报文4
        private IStream sw4 = new StreamImpl();
        //面函0
        private IStream notice0 = new StreamImpl();
        //面函1
        private IStream notice1 = new StreamImpl();
        //面函2
        private IStream notice2 = new StreamImpl();
        //面函3
        private IStream notice3 = new StreamImpl();
        //面函文件
        private String xmlfil;
        //报文文件
        private String sf2fil;
        //NewField
        private String trnnam;
        //excel下载
        private IStream download = new StreamImpl();
        //e结算影像查阅
        private transient IControl dztimgviw = new ControlImpl("dztimgviw", "e结算影像查阅", this);
        //单证通业务流水编号
        private String trninr;
        //国结影像查阅
        private transient IControl stlimgviw = new ControlImpl("stlimgviw", "国结影像查阅", this);
        //影像唯一编号
        private String imginr;
        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);
        //原记录trninr
        private String oldtrn;
        //待办转历史
        private String histodo;
        //转回待办
        private transient IControl tobnkspt = new ControlImpl("tobnkspt", "转回待办", this);
        //电子保函文本
        private IStream dzbhwb = new StreamImpl();
        //进口信用证项下到单通知书
        private IStream jkxpdf = new StreamImpl();
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private ModuleList<Trn> trnlst;

		@BDGetter
		private Smh smh;

		@BDGetter
		private Trn trn;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Imgmod imgmod;

		@BDGetter
		private Ordmod ordmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Tatp tatp;

		@BDGetter
		private Tasgrp tasgrp;

		@BDGetter
		private Eabp eabp;

		@BDGetter
		private Eabgrp eabgrp;

		@BDGetter
		private Gitpush gitpush;


		public Annals()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getOrdmod().setTrnHolder(()->this.getTrn());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getTatp().setTasgrpHolder(()->this.getTasgrp());
           this.getEabp().setEabgrpHolder(()->this.getEabgrp());
        }

        /**
        *   source:annals.@0001.script
        */
        @Rule(target="btnmod.show",order=100)
        public boolean ruleBtnmodShowN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index < 0 )
			{
			  ctx.setMessage("提醒","请选择一笔业务 ！");
			  return false;
			}
			this.setTrninr(this.getTrnlst().getElement(index).getInr());
			log.debug("{}","trninr:" + this.getTrninr());
			
			//通知交易隐藏打印和下载按钮
			this.hanDPbutton(this.getTrninr());
			this.loadDataByInr(this.getTrninr());
			
			/*$trninr.setValue($trnlst[index]\\inr.getValue());
			  String trnNam = $trnlst[index]\\inifrm;
			  log.info("txt="+$rmkmod\\rmk\\txt.getValue());
			  $rmkmod\\otext.setValue($rmkmod\\rmk\\txt.getValue());
			  Platform.clear($trnnam);
			  Platform.clear($docpth);
			  Platform.clear($xmlfil);
			  Platform.clear($sf2fil);
			  $trnnam = $trnlst[index]\\inifrm;
			  Platform.invisible($notice0);
			  Platform.invisible($notice1);
			  Platform.invisible($notice2);
			  Platform.invisible($notice3);
			  Platform.invisible($sw0);
			  Platform.invisible($sw1);
			  Platform.invisible($sw2);
			  Platform.invisible($sw3);
			  Platform.invisible($sw4);
			  String tinr=$trnlst[index]\\inr;
			  //log.info("trn inr="+tinr );
			  Argument<String> inr=new Argument<String>("inr");
			  Argument<String> xmlfil=new Argument<String>("xmlfil");
			  Argument<String> sf2fil=new Argument<String>("sf2fil");
			  Argument<String> docpth=new Argument<String>("docpth");
			  Platform.dbExecuteSQL("SELECT inr,xmlfil,sf2fil,docpth FROM smh WHERE objtyp='trn' AND objinr='"+tinr+"'");
			  Platform.dbFetchFields(inr,xmlfil,sf2fil,docpth);
			  int error=Platform.errorCode();
			  Platform.dbCloseCursor();
			  if(error==NO_ERROR&&!Platform.isEmpty(docpth.value))
			  {
			  $docpth.setValue(docpth.value);
			  log.debug("sw2fil="+sf2fil.value);
			  if(!Platform.isEmpty(sf2fil.value))
			  {
			  $sf2fil.setValue(sf2fil.value);
			  String sw2fils = sf2fil.value;
			  String[] sw2fil = sw2fils.split(";");
			  for(int i=0;i<sw2fil.length;i++)
			  {
			  IDatafield id = Platform.getDatafield($\\,"sw"+i);
			  Platform.visible(id);
			  Platform.enable(id);
			  }
			  }
			  log.debug("xmlfils="+xmlfil.value);
			  if(!Platform.isEmpty(xmlfil.value))
			  {
			  $xmlfil.setValue(xmlfil.value);
			  String xmlfils =xmlfil.value;
			  String xmlNbm = null;
			  String img = null;
			  String filepath=Platform.catPath(Platform.getRootPath(),"data/attach.properties");
			  for(String xmlVal:xmlfils.split(";"))
			  {
			  if(xmlVal.indexOf(",")>0)
			  xmlNbm = xmlVal.substring(xmlVal.indexOf(",")+1);
			  if(xmlNbm==null)
			  xmlNbm="0";
			  img = Platform.getPropertyValue(filepath,trnNam+"."+xmlNbm+".img");
			  if(img==null||"".equals(img))
			  img = Platform.getPropertyValue(filepath,trnNam+".img");
			  if(img==null||"".equals(img))
			  img = Platform.getPropertyValue(filepath,"DefaultAdvImage");
			  log.debug("img="+img);
			  IDatafield id = Platform.getDatafield($\\,"notice"+xmlNbm);
			  ((IStream)id.getValue()).setValue(img);
			  Platform.visible(id);
			  Platform.enable(id);
			  }
			  }
			  }
			  Platform.setModified($notice0);
			  Platform.setModified($notice1);
			  Platform.setModified($notice2);
			  Platform.setModified($notice3);
			  Platform.setModified($sw0);
			  Platform.setModified($sw1);
			  Platform.setModified($sw2);
			  Platform.setModified($sw3);
			  Platform.setModified($sw4);
			  Platform.setModified($docpth);
			
			  //show it
			  //String filename="/data/dsp/"+$hislst[index]\\inr.getValue()+".zul";
			  String filename="/data/dsp/"+$trnlst[index]\\inr.getValue().substring(0,4)+"/"+$trnlst[index]\\inr.getValue()+".zul";
			    Platform.writeToSession("dspfile",$hislit[index]\\inr.getValue());//token，用来判断请求唯一性
			  log.info("session dspfile :"+Platform.readFromSession("dspfile"));
			 
			  $display.setValue("/dsp"+filename);
			  Platform.popupOnly($detail);
			  */

			return true;
        }

        /**
        *   source:annals.@0006.script
        */
        @Rule(target="trnlst",order=100)
        public boolean ruleTrnlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setDocpth(NULLSTR);
			this.setMsg(NULLSTR);
			MdaUtils.clear(this.getSw2());
			MdaUtils.clear(this.getBtnmod().getMsg());
			
			int index=0;
			if(index!=-1)
			{
			  String tinr=this.getTrnlst().getElement(index).getInr();
			  Argument<String> inr=new Argument<String>("inr");
			  Argument<String> xmlfil=new Argument<String>("xmlfil");
			  Argument<String> sf2fil=new Argument<String>("sf2fil");
			  Argument<String> docpth=new Argument<String>("docpth");
			  ctx.getDaoSession().dbExecuteSQL("SELECT inr,xmlfil,sf2fil,docpth FROM smh WHERE objtyp='trn' AND objinr= ? ",tinr);
			  ctx.getDaoSession().dbFetchFields(inr,xmlfil,sf2fil,docpth);

			  if(ctx.getErrorCode()== NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(xmlfil.value))
			    {
			      
			      this.setMsg(xmlfil.value.toString());
			    }
			    else
			    {
			      this.setMsg(NULLSTR);
			    }
			    this.setSf2fil( sf2fil.getValue());
			    this.setDocpth( docpth.getValue());
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}

			return true;
        }

        /**
        *   source:annals.@0008.script
        */
        @Rule(target="btnmod.msg",order=100)
        public boolean ruleBtnmodMsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  IStream is=$btnmod\\msg.getValue();
			  String filepath=$docpth.getValue();
			  String filename=$msg.getValue();
			  String cfgpath=Platform.catPath(Platform.getRootPath(),"etrade");
			  log.debug("filepath="+filepath);
			  log.debug("filename="+filename);
			  log.debug("cfgpath="+cfgpath);
			  Platform.clear($msg);
			  $sysmod.showNotice(filepath,filename,cfgpath,is);
			  */

			return true;
        }

        /**
        *   source:annals.@0012.script
        */
        @Rule(target="btnmod.search",order=100)
        public boolean ruleBtnmodSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date betdat =this.getBtnmod().getBegdat();
			Date enddat=this.getBtnmod().getEnddat();
			if(MdaUtils.diff(betdat,enddat)>0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000166"),MdaUtils.getI18NString("annals","CT000167"));
			  return true;
			}

			if(MdaUtils.isEmpty(this.getBtnmod().getYwwtyp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000177"),MdaUtils.getI18NString("annals","CT000178"));
			  return true;
			}
			fresh();

			return true;
        }

        /**
        *   source:annals.@0013.script
        */
        @Rule(target="sw0",order=100)
        public boolean ruleSw0N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 0 file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(0);
			IStream stream=this.getSw0();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:annals.@0014.script
        */
        @Rule(target="sw1",order=100)
        public boolean ruleSw1N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 1 file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(1);
			IStream stream=this.getSw1();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:annals.@0015.script
        */
        @Rule(target="sw2",order=100)
        public boolean ruleSw2N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 2 file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(2);
			IStream stream=this.getSw2();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:annals.@0016.script
        */
        @Rule(target="sw3",order=100)
        public boolean ruleSw3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 3 file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(3);
			IStream stream=this.getSw3();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:annals.@0017.script
        */
        @Rule(target="sw4",order=100)
        public boolean ruleSw4N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 4 file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(4);
			IStream stream=this.getSw4();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:annals.@0018.script
        */
        @Rule(target="notice0",order=100)
        public boolean ruleNotice0N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 0 file ...");
			IStream is=this.getNotice0();
			String filepath=this.getDocpth();
			String filename=getXmlFile("0");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=this.getTrnnam();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:annals.@0019.script
        */
        @Rule(target="notice1",order=100)
        public boolean ruleNotice1N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 1 file ...");
			IStream is=this.getNotice1();
			String filepath=this.getDocpth();
			String filename=getXmlFile("1");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=this.getTrnnam()+"1";
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:annals.@0020.script
        */
        @Rule(target="notice2",order=100)
        public boolean ruleNotice2N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 2 file ...");
			IStream is=this.getNotice2();
			String filepath=this.getDocpth();
			String filename=getXmlFile("2");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=this.getTrnnam();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:annals.@0021.script
        */
        @Rule(target="notice3",order=100)
        public boolean ruleNotice3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 3 file ...");
			IStream is=this.getNotice3();
			String filepath=this.getDocpth();
			String filename=getXmlFile("3");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=this.getTrnnam();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:annals.@0024.script
        */
        @Rule(target="btnmod.fresh",order=100)
        public boolean ruleBtnmodFreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBtnmod().getYwwtyp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000179"),MdaUtils.getI18NString("annals","CT000180"));
			  return false;
			}
			fresh();

			return true;
        }

        /**
        *   source:annals.@0029.script
        */
        @Rule(target="btnmod.table",order=100)
        public boolean ruleBtnmodTableN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into table..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			String ordinr = this.getTrnlst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getTrnlst().getElement(index).getInifrm(),"table",this.getBtnmod().getTable());

			return true;
        }

        /**
        *   source:annals.@0030.script
        */
        @Rule(target="btnmod.pdapldoc",order=100)
        public boolean ruleBtnmodPdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into pdapldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			String ordinr = this.getTrnlst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getTrnlst().getElement(index).getInifrm(),"pdapldoc",this.getBtnmod().getPdapldoc());

			return true;
        }

        /**
        *   source:annals.@0031.script
        */
        @Rule(target="btnmod.tdapldoc",order=100)
        public boolean ruleBtnmodTdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into tdapldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			String ordinr = this.getTrnlst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getTrnlst().getElement(index).getInifrm(),"tdapldoc",this.getBtnmod().getTdapldoc());

			return true;
        }

        /**
        *   source:annals.@0032.script
        */
        @Rule(target="btnmod.bot",order=100)
        public boolean ruleBtnmodBotN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into bot..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			String ordinr = this.getTrnlst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getTrnlst().getElement(index).getInifrm(),"bot",this.getBtnmod().getBot());

			return true;
        }

        /**
        *   source:annals.@0033.script
        */
        @Rule(target="btnmod.apldoc",order=100)
        public boolean ruleBtnmodApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请交易(hislst)
			log.info("{}","into apldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			String ordinr = this.getTrnlst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getTrnlst().getElement(index).getInifrm(),"apldoc",this.getBtnmod().getApldoc());

			return true;
        }

        /**
        *   source:annals.@0034.script
        */
        @Rule(target="btnmod.print",order=100)
        public boolean ruleBtnmodPrintN100(){
            IContext ctx = MdaEnv.getContext();
            
			//打印，通知交易用（hislit）
			log.info("{}","into print..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getTrnlst().getElement(index).getInr();
			this.getBtnmod().showAppPdfFile(trninr,
			  this.getTrnlst().getElement(index).getInifrm(),"print",this.getBtnmod().getPrint());

			return true;
        }

        /**
        *   source:annals.@0035.script
        */
        @Rule(target="btnmod.download",order=100)
        public boolean ruleBtnmodDownloadN100(){
            IContext ctx = MdaEnv.getContext();
            
			//下载，通知交易用（hislit）
			log.info("{}","into downl..." );
			int index=0;
			if(index<0){
			  ctx.setMessage("提醒","请选择一笔交易");
			return false;
			}
			String trninr = this.getTrnlst().getElement(index).getInr();
			this.getBtnmod().showAppPdfFile(trninr,
			this.getTrnlst().getElement(index).getInifrm(),"download",this.getBtnmod().getDownload());

			return true;
        }

        /**
        *   source:annals.@0036.script
        */
        @Rule(target="download",order=100)
        public boolean ruleDownloadN100(){
            IContext ctx = MdaEnv.getContext();
            
			List<Object[]> lst = new ArrayList<Object[]>();
			String tit[] = new String[6];
			tit[0] = "参考号";
			tit[1] = "币种";
			tit[2] = "金额";
			tit[3] = "客户名称";
			tit[4] = "交易类型";
			tit[5] = "时间";
			lst.add(tit);
			int len = this.getTrnlst().fullSize();
			log.debug("{}","len="+len);
			for(int i=0;i<len;i++)
			{
			  log.debug("{}",""+i);
			  String[] line = new String[6];
			  line[0] = this.getTrnlst().getElement(i).getOwnref();
			  line[1] = this.getTrnlst().getElement(i).getReloricur();
			  line[2] = this.getTrnlst().getElement(i).getReloriamt().toString();
			  line[3] = this.getTrnlst().getElement(i).getNam();
			  String inifrm = this.getTrnlst().getElement(i).getInifrm();
			  line[4] = MdaUtils.getCodetableLabel("trans",inifrm);
			  if(MdaUtils.isEmpty(this.getTrnlst().getElement(i).getInidattim()))
			    line[5] ="";
			  else
			    line[5] = MdaUtils.format(this.getTrnlst().getElement(i).getInidattim(),"yyyyMMdd HH:mm");
			  lst.add(line);
			}
			log.debug("{}","lst "+lst.size());
			IStream is=this.getDownload();
			is.setType("xls");
			String today = MdaUtils.format(MdaUtils.today(),"yyyyMMdd-HH:mm:ss");
			String fileName = "历史文件-"+today+".xls";
			try
			{
			  is.setName(new String(fileName.getBytes("GBK"),"GBK"));
			}
			catch(Exception e)
			{
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:annals.@0043.script
        */
        @Rule(target="dztimgviw",order=100)
        public boolean ruleDztimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}"," in imgviw....");
			ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("inr",this.getTrninr()));
			String trninr = this.getTrn().getOriinr();
			this.getImgmod().imgScan(trninr);
			log.debug("{}"," out imgviw....");

			return true;
        }

        /**
        *   source:annals.@0044.script
        */
        @Rule(target="stlimgviw",order=100)
        public boolean ruleStlimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("inr",this.getTrninr()));
			String imginr = this.getTrn().getImgref();
			log.debug("{}","imginr:" + imginr);
			this.getImgmod().stlImgScan(imginr);

			return true;
        }

        /**
        *   source:annals.@0045.script
        */
        @Rule(target="return",order=100)
        public boolean ruleReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.showMainPanel();

			return true;
        }

        /**
        *   source:annals.@0057.script
        */
        @Rule(target="trnlst",order=200)
        public boolean ruleTrnlstN200(){
            IContext ctx = MdaEnv.getContext();
            

			//列表双击时间或者界面点击字段连接时执行
			int index=0;
			log.debug("{}","evt DblClick bsplst ... index =" + index);
			if(index<0||index>=this.getTrnlst().fullSize())
			  return true;
			this.setTrninr(this.getTrnlst().getElement(index).getInr());
			log.debug("{}","trninr:" + this.getTrninr());
			
			//通知交易隐藏打印和下载按钮
			this.hanDPbutton(this.getTrninr());
			this.loadDataByInr(this.getTrninr());
			
			/*String trnNam = $trnlst[index]\\inifrm;
			  log.info("txt="+$rmkmod\\rmk\\txt.getValue());
			  $rmkmod\\otext.setValue($rmkmod\\rmk\\txt.getValue());
			  Platform.clear($trnnam);
			  Platform.clear($docpth);
			  Platform.clear($xmlfil);
			  Platform.clear($sf2fil);
			  $trnnam = $trnlst[index]\\inifrm;
			  Platform.invisible($notice0);
			  Platform.invisible($notice1);
			  Platform.invisible($notice2);
			  Platform.invisible($notice3);
			  Platform.invisible($sw0);
			  Platform.invisible($sw1);
			  Platform.invisible($sw2);
			  Platform.invisible($sw3);
			  Platform.invisible($sw4);
			  String tinr=$trnlst[index]\\inr;
			  //log.info("trn inr="+tinr );
			  Argument<String> inr=new Argument<String>("inr");
			  Argument<String> xmlfil=new Argument<String>("xmlfil");
			  Argument<String> sf2fil=new Argument<String>("sf2fil");
			  Argument<String> docpth=new Argument<String>("docpth");
			  Platform.dbExecuteSQL("SELECT inr,xmlfil,sf2fil,docpth FROM smh WHERE objtyp='trn' AND objinr='"+tinr+"'");
			  Platform.dbFetchFields(inr,xmlfil,sf2fil,docpth);
			  int error=Platform.errorCode();
			  Platform.dbCloseCursor();
			  if(error==NO_ERROR&&!Platform.isEmpty(docpth.value))
			  {
			  $docpth.setValue(docpth.value);
			  log.debug("sw2fil="+sf2fil.value);
			  if(!Platform.isEmpty(sf2fil.value))
			  {
			  $sf2fil.setValue(sf2fil.value);
			  String sw2fils = sf2fil.value;
			  String[] sw2fil = sw2fils.split(";");
			  for(int i=0;i<sw2fil.length;i++)
			  {
			  IDatafield id = Platform.getDatafield($\\,"sw"+i);
			  Platform.visible(id);
			  Platform.enable(id);
			  }
			  }
			  log.debug("xmlfils="+xmlfil.value);
			  if(!Platform.isEmpty(xmlfil.value))
			  {
			  $xmlfil.setValue(xmlfil.value);
			  String xmlfils =xmlfil.value;
			  String xmlNbm = null;
			  String img = null;
			  String filepath=Platform.catPath(Platform.getRootPath(),"data/attach.properties");
			  for(String xmlVal:xmlfils.split(";"))
			  {
			  if(xmlVal.indexOf(",")>0)
			  xmlNbm = xmlVal.substring(xmlVal.indexOf(",")+1);
			  if(xmlNbm==null)
			  xmlNbm="0";
			  img = Platform.getPropertyValue(filepath,trnNam+"."+xmlNbm+".img");
			  if(img==null||"".equals(img))
			  img = Platform.getPropertyValue(filepath,trnNam+".img");
			  if(img==null||"".equals(img))
			  img = Platform.getPropertyValue(filepath,"DefaultAdvImage");
			  log.debug("img="+img);
			  IDatafield id = Platform.getDatafield($\\,"notice"+xmlNbm);
			  ((IStream)id.getValue()).setValue(img);
			  Platform.visible(id);
			  Platform.enable(id);
			  }
			  }
			  }
			  Platform.setModified($notice0);
			  Platform.setModified($notice1);
			  Platform.setModified($notice2);
			  Platform.setModified($notice3);
			  Platform.setModified($sw0);
			  Platform.setModified($sw1);
			  Platform.setModified($sw2);
			  Platform.setModified($sw3);
			  Platform.setModified($sw4);
			  Platform.setModified($docpth);
			
			  String filename="/data/dsp/"+$trnlst[index]\\inr.getValue().substring(0,4)+"/"+$trnlst[index]\\inr.getValue()+".zul";
			  Platform.writeToSession("dspfile",$trnlst[index]\\inr.getValue());//token，用来判断请求唯一性
			  log.info("session dspfile :"+Platform.readFromSession("dspfile"));
			  $display.setValue("/dsp"+filename);
			  Platform.popupOnly($detail);*/

			return true;
        }

        /**
        *   source:annals.@0060.script
        */
        @Rule(target="btnmod.ywwtyp",order=100)
        public boolean ruleBtnmodYwwtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBtnmod().getYwwtyp()))
			{
			  if("2".equals(this.getBtnmod().getYwwtyp()))
			  {
			    this.getBtnmod().setCur(NULLSTR);
			    
			  }
			  fresh();
			}

			return true;
        }

        /**
        *   source:annals.@0061.script
        */
        @Rule(target="btnmod.trntyp",order=100)
        public boolean ruleBtnmodTrntypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String nohtyp= this.getBtnmod().getTrntyp();
			log.debug("{}","1111111111111111111111"+ nohtyp);

			if("1".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("jinkou"));
			}
			else if("2".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("chukou"));
			}
			else if("3".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("tuoshou"));
			}
			else if("4".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("tuochu"));
			}
			else if("10".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("huikuan"));
			}
			else if ("9".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("fufeit"));
			}
			else if("7".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("baohan"));
			}
			else if("8".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("gongg"));
			}
			else if("14".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("guomai"));
			}
			else if("15".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("maifang"));
			}
			else if ("21".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("waihuiji"));
			}
			else if ("22".equals(nohtyp))
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("waihuiren"));
			}
			else
			{
			  this.getBtnmod().setNohtyp(NULLSTR);
			  MdaUtils.setValues(this.getBtnmod(),"nohtyp",MdaUtils.getCodetable("nohtyp"));

			}
			


			return true;
        }

        /**
        *   source:annals.@0062.script
        */
        @Rule(target="tobnkspt",order=100)
        public boolean ruleTobnksptN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index < 0 )
			{
			  ctx.setMessage("提醒","请选择一笔业务 ！");
			  return false;
			}
			this.setTrninr(this.getTrnlst().getElement(index).getInr());
			log.debug("{}","trninr:" + this.getTrninr());
			String modtyp = this.getTrnlst().getElement(index).getModtyp();
			if(MdaUtils.isEmpty(modtyp)||(!"9".equals(modtyp)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000191"),MdaUtils.getI18NString("annals","CT000192"));
			  return false;
			}
			MdaUtils.clear(this.getTrnmod().getTrn());
			MdaUtils.clear(this.getTrn());
			MdaUtils.clear(this.getTrnmod().getSptchk());
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",this.getTrninr()));
			String srcinr = this.getTrnmod().getTrn().getSrcinr();
			if(!MdaUtils.isEmpty(srcinr))
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getSptchk(),new Argument("inr",srcinr));
			  if(MdaUtils.isEmpty(this.getTrnmod().getSptchk().getInr()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("annals","CT000213"),MdaUtils.getI18NString("annals","CT000214"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  this.getTrnmod().getSptchk().setSta("T");
			  ctx.getDaoSession().dbUpdate(this.getTrnmod().getSptchk());
			  ctx.getDaoSession().dbRead(this.getTrn(),new Argument("inr",this.getTrnmod().getSptchk().getScrtxt()));
			  if(MdaUtils.isEmpty(this.getTrnmod().getTrn().getInr()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("annals","CT000215"),MdaUtils.getI18NString("annals","CT000216"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  this.getTrn().setSta("W");
			  ctx.getDaoSession().dbUpdate(this.getTrn());
			  ctx.getDaoSession().dbDelete(this.getTrnmod().getTrn());
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000217"),MdaUtils.getI18NString("annals","CT000218"));
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getErrorCode();
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000221"),MdaUtils.getI18NString("annals","CT000222"));
			  return false;
			}
			fresh();

			return true;
        }

        /**
        *   source:annals.@0063.script
        */
        @Rule(target="dzbhwb",order=100)
        public boolean ruleDzbhwbN100(){
            IContext ctx = MdaEnv.getContext();
            
			String hth = this.getGitpush().getContractid();
			String pdfFile = this.getGitpush().getInr();
			if(MdaUtils.isEmpty(hth)||MdaUtils.isEmpty(pdfFile))
			{

			  ctx.setMessage(MdaUtils.getI18NString("annals","CT000224"),MdaUtils.getI18NString("annals","CT000225"));
			  return false;
			}
			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/szdzbh/pdf/"+pdfFile.substring(0,5)+"/"+pdfFile+".pdf");
			if(!MdaUtils.fileExists(pdffile))
			{
			  //调用接口下载
			  Object rtnVal = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","msg2cfca","msg2cfca",new Object[]{ pdfFile,hth});
			  if (rtnVal == null)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("annals","CT000226"),MdaUtils.getI18NString("annals","CT000227"));
			    return false;
			  }
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");//000000
			  if(!"000000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("annals","CT000228"),MdaUtils.getI18NString("annals","CT000229"));
			    return false;
			  }
			}
			MdaUtils.streamClear(this.getDzbhwb());
			IStream stream=this.getDzbhwb();
			log.info("{}","pdffile===="+pdffile);
			MdaUtils.streamLoad(stream,pdffile);
			stream.setType("pdf");
			String pdfnam = org.apache.commons.io.FilenameUtils.getName(pdffile);
			stream.setName(pdfnam);

			return true;
        }

        /**
        *   source:annals.@0064.script
        */
        @Rule(target="jkxpdf",order=100)
        public boolean ruleJkxpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1.查brdc获取交易的合同号
			String objinr = this.getTrnmod().getTrn().getObjinr();
			String sql="select hticontract from brdc where pntinr='"+objinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			Argument<String> hticontract = new Argument<String>("hticontract");
			ctx.getDaoSession().dbFetchFields(hticontract);
			ctx.getDaoSession().dbCloseCursor();
			String con = hticontract.value;
			if(MdaUtils.isEmpty(con))
			{
			  ctx.setMessage("提示","该笔业务无电子保函文本！");
			  return false;
			}

			String[] arr=con.split(",");
			String pdfFile="";
			for(int i=0;i<arr.length;i++)
			{
			  //pdfFile = Platform.catPath(Platform.getRootPath(),"/data/szdzbh/pdf/"+$brdgrp\\rec\\inr.getValue().substring(0,5)+"/"+$brdgrp\\rec\\inr.getValue()+".pdf");
			  pdfFile = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/brtdck/pdf/"+objinr+"/"+arr[i]+".pdf");
			  log.debug("{}","pdfFile======================================================="+pdfFile);
			  //判断文件是否存在，不存在则下载到服务器
			  if(!MdaUtils.fileExists(pdfFile))
			  {
			    //调用接口下载
			    Object rtnVal = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","msg3cfca","msg3cfca",new Object[]{ objinr,arr[i]});
			    if (rtnVal == null)
			    {
			      ctx.setMessage("提示","文件下载异常，请稍后重试！");
			      return false;
			    }
			    Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			    String errcod = (String)retMsg.get("errorCode");//000000
			    if(!"000000".equals(errcod))
			    {
			      ctx.setMessage("提示","接口调用异常，请稍后重试！");
			      return false;
			    }
			  }
			  MdaUtils.streamClear(this.getJkxpdf());
			  IStream stream=this.getJkxpdf();
			  log.info("{}","pdffile===="+pdfFile);
			  MdaUtils.streamLoad(stream,pdfFile);
			  stream.setType("pdf");
			  String pdfnam = org.apache.commons.io.FilenameUtils.getName(pdfFile);
			  stream.setName(pdfnam);
			}

			return true;
        }


        /**
        *   source:annals.@0038.script
        */
        @Check(target="btnmod.enddat",order=100)
        public boolean checkBtnmodEnddatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBtnmod().getEnddat()))
			  ctx.setFieldError(this,"btnmod.enddat",MdaUtils.getI18NString("annals","CT000088"));
			if (!MdaUtils.isEmpty(this.getBtnmod().getBegdat())&&!MdaUtils.isEmpty(this.getBtnmod().getEnddat()))
			{
			  if(MdaUtils.diff(this.getBtnmod().getEnddat(),this.getBtnmod().getBegdat())<0)
			  {
			    ctx.setFieldError(this,"btnmod.begdat",MdaUtils.getI18NString("annals","CT000090"));
			  }
			}

			return true;
        }

        /**
        *   source:annals.@0039.script
        */
        @Check(target="btnmod.begdat",order=100)
        public boolean checkBtnmodBegdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBtnmod().getBegdat()))
			  ctx.setFieldError(this,"btnmod.begdat",MdaUtils.getI18NString("annals","CT000089"));

			return true;
        }


        /**
        *   source:annals.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}"," in init 100 ");
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			
			log.debug("{}","trntyp的值为：" + this.getBtnmod().getTrntyp());
			this.getBtnmod().setYwwtyp("0");
			
			
			if("0".equals(ptytyp))
			{
			  // 银行端
			  
			  
			  this.getBtnmod().setPanel();
			  List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			  MdaUtils.setValues(this.getBtnmod(),"ptynam",bchcod);
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getBtnmod().setPtynam(bchcod.get(0).getValue());
			}
			else if("2".equals(ptytyp)  ||  "3".equals(ptytyp))
			{
			  // 企业端
			  this.getBtnmod().setCleintPanel();
			}
			else
			{
			  // 商行端
			  this.getBtnmod().setPanel();
			  
			  
			  
			  
			  
			}
			/*$btnmod\\begdat.setValue(Platform.add(Platform.today(),-15));
			  $btnmod\\enddat.setValue(Platform.today());
			  List<CodetableItem> items = Platform.getCodetable("trnsort");
			  Platform.setValues($btnmod\\trntyp,items);*/
			this.getBtnmod().setTrntyp("0");
			this.fresh();
			this.getBtnmod().setCur("USD");


			return true;
        }


        /**
        *   source:annals.@0009.script
        */
        public void fresh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTrnlst());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> oriinr =new Argument<String>("oriinr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> inifrm =new Argument<String>("inifrm");
			Argument<Date> inidattim =new Argument<Date>("inidattim");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> stlref =new Argument<String>("stlref");
			Argument<String> reloricur=new Argument<String>("reloricur");
			Argument<BigDecimal> reloriamt =new Argument<BigDecimal>("reloriamt");
			Argument<String> modtyp =new Argument<String>("modtyp");
			String sql="SELECT inr,ownref,inifrm,inidattim,nam,reloricur,reloriamt,stlref,oriinr,modtyp FROM trn WHERE sta='A' ";
			List objs = new ArrayList();  //查询参数
			
			String ptyinr = this.getSysmod().getPty().getInr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			String cid = this.getSysmod().getPty().getCid();
			String noteCodes = this.getSysmod().getFrmmod().getOpenedNotification(); // 已开通通知交易清单
			//机构类型申请类业务两条TRN（企业端流水+银行端流水），通知类业务一条TRN（在通知转历史时生成）
			String histo = this.getHistodo();
			// 机构数据隔离
			if("0".equals(ptytyp))
			{
			  //sql =sql+" and  oriinr is not null ";
			  if(!MdaUtils.isEmpty(this.getBtnmod().getPtynam()))
			  {
			    ptyinr =this.getBtnmod().getPtynam();
			    log.debug("{}","ptyinr    值="+ptyinr);
			    cid=this.getSysmod().getCidByInr(ptyinr);
			  }
			  if(TRUE.equals(histo))
			    sql = this.getSysmod().getBchmod().sdbGetBnkBranchSql(ptyinr,"optptyinr",sql,objs,cid);
			  else
			  {
			    sql = this.getSysmod().getBchmod().sdbGetBranchSql(ptyinr,"optptyinr",sql,objs,cid);
			  }
			}
			else
			{
			  //sql=sql + " AND ptyinr= ? AND(oriinr is null or modtyp='1') ";
			  sql=sql + " AND ptyinr= ? AND ptytyp=2 ";
			  objs.add(ptyinr);
			}

			//新增业务来源查询条件
			if(!MdaUtils.isEmpty(this.getBtnmod().getYwwtyp())&&!"0".equals(this.getBtnmod().getYwwtyp()))
			{
			  if("2".equals(this.getBtnmod().getYwwtyp()))
			  {
			    sql=sql +" AND wfm='D' ";
			  }
			  else
			  {
			    sql=sql +" AND wfm is null";
			  }
			}
			// 增加交易类型查询条件
			if(!MdaUtils.isEmpty(this.getBtnmod().getTrntyp())&&!"0".equals(this.getBtnmod().getTrntyp())&& MdaUtils.isEmpty(this.getBtnmod().getNohtyp()))
			{
			  log.debug("{}","trntyp 值 ="+this.getBtnmod().getTrntyp());
			  String[] trnlist=this.getSysmod().getTrnSortlist(this.getBtnmod().getTrntyp());
			  String list=this.getSysmod().toSqlString(trnlist);
			  sql=sql +" AND inifrm IN ("+list+")";
			}
			if(!MdaUtils.isEmpty(this.getBtnmod().getTrntyp())&&!MdaUtils.isEmpty(this.getBtnmod().getNohtyp()))
			{
			  String notype=this.getBtnmod().getNohtyp();
			  sql=sql+" AND inifrm ='"+notype+"'";
			}

			// 币种
			if(!MdaUtils.isEmpty(this.getBtnmod().getCur()))
			{
			  sql = sql +" AND reloricur = ? " ;
			  objs.add(this.getBtnmod().getCur());
			  if(!MdaUtils.isEmpty(this.getBtnmod().getMinamt()))
			  {
			    sql=sql+" AND reloriamt >= ?  ";
			    objs.add(this.getBtnmod().getMinamt());
			  }
			  if(!MdaUtils.isEmpty(this.getBtnmod().getMaxamt()))
			  {
			    sql=sql+" AND reloriamt <=? ";
			    objs.add(this.getBtnmod().getMaxamt());
			  }
			}
			// 关联系统参号
			if(!MdaUtils.isEmpty(this.getBtnmod().getStlref()))
			{
			  sql=sql+" AND stlref  like ? ";
			  objs.add("%"+this.getBtnmod().getStlref().toUpperCase()+"%");
			}
			// 业务参号
			if(!MdaUtils.isEmpty(this.getBtnmod().getOwnref()))
			{
			  String ownref1 = this.getBtnmod().getOwnref();
			  sql=sql+" AND ownref  like ? ";
			  objs.add( "%"+ownref1.toUpperCase()+"%");
			}
			if(!MdaUtils.isEmpty(this.getBtnmod().getBegdat()))
			{
			  sql = sql + " AND inidattim >= ? " ;
			  objs.add(MdaUtils.sqlDate(this.getBtnmod().getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getBtnmod().getEnddat()))
			{
			  sql = sql + " AND inidattim <= ? " ;
			  objs.add(MdaUtils.sqlDate(this.getBtnmod().getEnddat(),LT));
			}

			sql=sql + " ORDER BY inidattim DESC,cfmdattim DESC ";
			log.debug("{}","annals: executeSql =" + sql );

			if( objs.size()>0 )
			{
			  ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());
			}
			else
			{
			  ctx.getDaoSession().dbExecuteSQL(sql);
			}

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,stlref,inifrm,inidattim,nam,reloricur,reloriamt,oriinr,modtyp);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    // 根据电子交单控制进行过滤
			    String trnCode = inifrm.getValue();
			    String trnType = modtyp.getValue();
			    // 申请 +已开通通知交易
			    if("0".equals(trnType) || noteCodes.indexOf(trnCode)>= 0 )
			    {
			      this.getTrnlst().add(inr,ownref,stlref,inifrm,inidattim,nam,reloricur,reloriamt,oriinr,modtyp);
			    }
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:annals.@0022.script
        */
        public String getXmlFile(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=this.getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			if(type==null  ||  "".equals(type))
			  type="0";
			String[] files = filename.split(";");
			for(String file:files)
			{
			  if(file.indexOf(","+type)>0)
			  {
			    filename = file.substring(0,file.indexOf(","+type));
			    break;
			  }
			  else
			    filename = file;
			}
			log.debug("{}",filename);
			return filename;
		}
        /**
        *   source:annals.@0023.script
        */
        public String getSw2File(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=this.getSf2fil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			if(index<0  ||  index>=files.length)
			  index=0;
			return files[index];
		}
        /**
        *   source:annals.@0025.script
        */
        public boolean isApplied(String trnNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String profile=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/transaction.properties");
			if(!MdaUtils.fileExists(profile))
			  return false;
			String value=MdaUtils.getPropertyValue(profile,trnNam+"01");
			log.debug("{}","trnNam's value="+value);
			if(MdaUtils.isEmpty(value))
			  return false;
			return true;
		}
        /**
        *   source:annals.@0026.script
        */
        public void handleApplyTrans()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			int index=0;
			if(index<0||index>=this.getTrnlst().fullSize())
			  return;
			//remark
			/**
			
			  String trninr = getAppFilename($hislst[index]\\inr.getValue(),$hislst[index]\\ordinr.getValue(),$sysmod\\pty\\ptytyp.getValue());
			
			  String tfile = $\\sysmod.createFilename(trninr,"dra");
			  String frm = $hislst[index]\\inifrm.getValue();
			  log.info("dra FILE="+tfile+" Exist?"+ Platform.fileExists(tfile));
			  //if($trnmod.isTcoIgnore(frm)||!Platform.fileExists(tfile))
			  if(("litopn".equals(frm)||"litame".equals(frm)||"gitopn".equals(frm)||"gitame".equals(frm)||"littrs".equals(frm))&&Platform.fileExists(tfile))
			  {
			
			  Platform.visible($btnmod\\msg);
			  Platform.enable($btnmod\\msg);
			  }
			  else
			  Platform.invisible($btnmod\\msg);
			
			  String mfile = $\\sysmod.createFilename(trninr,"app");
			  log.info("app FILE="+mfile );
			  if(Platform.fileExists(mfile))
			  $btnmod.initAppButton($hislst[index]\\inifrm.getValue());
			  else
			  $btnmod.initAppButton("");
			
			  String filename="/data/dsp/"+$hislst[index]\\inr.getValue().substring(0,4)+"/"+$hislst[index]\\inr.getValue()+".zul";
			    Platform.writeToSession("dspfile",$hislit[index]\\inr.getValue());//token，用来判断请求唯一性
			  log.info("session dspfile :"+Platform.readFromSession("dspfile"));
			 
			  $display.setValue("/dsp"+filename);
			  Platform.popupOnly($detail);
			  */
		}
        /**
        *   source:annals.@0027.script
        */
        public String getAppFilename(String trninr,String ordinr,String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"0".equals(ptytyp))
			  return trninr;
			String sql = "SELECT t.inr FROM trn t,pty p WHERE t.ordinr='"+ordinr
			  +"' AND t.optptyinr=p.inr AND p.ptytyp in ('1','2','3')";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(!MdaUtils.isEmpty(inr.value))
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return trninr;
		}
        /**
        *   source:annals.@0046.script
        */
        public String getfrmintsc()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select trncod from tsc where notflg = 'X'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> trncod = new Argument<String> ("trncod");
			String frm="-";
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trncod);
			  if(ctx.getErrorCode()==NO_ERROR)
			    frm=frm+trncod.value+",";
			  else
			    break;
			}
			frm=frm+"-";
			ctx.getDaoSession().dbCloseCursor();
			log.info("{}","getfrmintsc frm="+frm);
			return frm;
		}
        /**
        *   source:annals.@0058.script
        */
        public void loadDataByInr(String trninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：根据选择的序号加载公共数据
			  */
			// 加载TRN
			MdaUtils.clear(this.getTrnmod().getTrn());
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",trninr));
			String ordinr = this.getTrnmod().getTrn().getOrdinr();
			String objtyp = this.getTrnmod().getTrn().getObjtyp();
			String objinr = this.getTrnmod().getTrn().getObjinr();
			//
			
			// 加载ORD
			ctx.getDaoSession().dbRead(this.getTrnmod().getOrdmod().getOrd(),new Argument("inr",ordinr));
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载RMK
			this.getRmkmod().loadRemarkByOrd(ordinr);
			// 初始化PDF数据
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载页面截图
			String inr0 = trninr;
			String inrStr = inr0.substring(0,4);
			String fileName = inr0+"."+"zul";
			Platform.writeToSession("dspfile",fileName);//token，用来判断请求唯一性
			log.info("{}","session dspfile :"+Platform.readFromSession("dspfile"));
			fileName = "/data/"+"dsp"+"/"+inrStr+"/"+fileName;
			log.debug("{}","filename路径为：" + fileName);
			/*java.io.File file = new java.io.File(path);
			  if (!file.getParentFile().exists())
			  {
			  file.getParentFile().mkdirs();
			  }
			  if (!file.exists())
			  {
			  try
			  {
			  file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			  log.error("*****  文件创建失败！");
			  log.error(e.toString());
			  }
			  }
			  */
			if("tas".equals(objtyp))
			{
			  log.info("{}","**** gen dsp file ***");
			  MdaUtils.clear(this.getTasgrp().getRec());
			  MdaUtils.clear(this.getTasgrp().getPty());
			  this.getTasgrp().setUserbinding(NULLSTR);
			  this.getTasgrp().setOpenaccount(NULLSTR);
			  this.getTasgrp().setInwardremit(NULLSTR);
			  this.getTasgrp().setOutwardremit(NULLSTR);
			  this.getTasgrp().setFinanceapplication(NULLSTR);
			  this.getTasgrp().setOpenguaraletter(NULLSTR);
			  ctx.getDaoSession().dbRead(this.getTasgrp().getRec(),new Argument("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getTasgrp().getPty(),new Argument<String>("cifno",EQ,this.getTasgrp().getRec().getCifno()));
			  if("A".equals(this.getTasgrp().getRec().getHandletyp()))
			  {
			    if (!MdaUtils.isEmpty(this.getTasgrp().getRec().getInr()))
			    {
			      String fun=this.getTasgrp().getRec().getFunctionts();
			      if(!MdaUtils.isEmpty(fun))
			      {
			        String[] funarr =fun.split("#");
			        for(int i=0;i<funarr.length;i++)
			        {
			          if("user_binding".equals(funarr[i]))
			            this.getTasgrp().setUserbinding(TRUE);
			          if("open_account".equals(funarr[i]))
			            this.getTasgrp().setOpenaccount(TRUE);
			          if("inward_remit".equals(funarr[i]))
			            this.getTasgrp().setInwardremit(TRUE);
			          if("outward_remit".equals(funarr[i]))
			            this.getTasgrp().setOutwardremit(TRUE);
			          if("finance_application".equals(funarr[i]))
			            this.getTasgrp().setFinanceapplication(TRUE);
			          if("open_guara_letter".equals(funarr[i]))
			            this.getTasgrp().setOpenguaraletter(TRUE);
			        }
			        // if(!TRUE.equals($tasgrp\\userbinding.getValue())&&TRUE.equals($tasgrp\\userbinding.getValue()))
			        //   fun+="user_binding";
			      }
			    }
			    List<CodetableItem> bchcod1 =this.getSysmod().getAndSetBchcodFlg(this.getTasgrp().getPty().getInr(),this.getTasgrp().getRec().getBchcod());
			    MdaUtils.setValues(this.getTasgrp().getRec(),"bchcod",bchcod1);
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    String zfilename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr,"zul");
			    ctx.saveDisplay(zfilename);
			  }
			}
			if("eab".equals(objtyp))
			{
			  MdaUtils.clear(this.getEabgrp().getRec());
			  MdaUtils.clear(this.getEabgrp().getPty());
			  ctx.getDaoSession().dbRead(this.getEabgrp().getRec(),new Argument("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getEabgrp().getPty(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));
			  if("A".equals(this.getEabgrp().getRec().getHandletyp()))
			  {
			    
			    List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodFlg(this.getEabgrp().getPty().getInr(),this.getEabgrp().getRec().getOwnbch());
			    MdaUtils.setValues(this.getEabgrp().getRec(),"ownbch",bchcod);
			    
			    
			    
			    
			    
			    
			    
			    

			    String zzfilename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr,"zul");
			    ctx.saveDisplay(zzfilename);
			  }
			}
			if("gid".equals(objtyp))
			{
			  MdaUtils.clear(this.getGitpush());
			  ctx.getDaoSession().dbRead(this.getGitpush(),new Argument<String>("objtyp",EQ,"trn"),new Argument<String>("objinr",EQ,trninr));
			  String hth = this.getGitpush().getContractid();
			  String pdfFile = this.getGitpush().getInr();
			  if(!MdaUtils.isEmpty(hth)&&!MdaUtils.isEmpty(pdfFile))
			  {
			    
			    
			  }
			}
			/*
			  需求编号：R22081176
			  投产日期：20230525
			  修改人：w42375
			  描述：1.判断交易，如果交易是brtdck并且是线上交易，才执行此逻辑。
			  */
			if("brd".equals(objtyp))
			{
			  String sql="select advtyp from brd where inr='"+objinr+"' ";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getErrorCode();
			  Argument<String> advtyp = new Argument<String>("advtyp");
			  ctx.getDaoSession().dbFetchFields(advtyp);
			  ctx.getDaoSession().dbCloseCursor();
			  if(!MdaUtils.isEmpty(advtyp) && "Y".equals(advtyp.value))
			  {
			    
			    
			  }
			  else
			  {
			    
			  }
			}
			this.setDisplay("/dsp"+fileName);

		}
        /**
        *   source:annals.@0059.script
        */
        public void hanDPbutton(String trninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in hanDPbuttopn...");
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",trninr));
			String trnNam = this.getTrnmod().getTrn().getInifrm();
			log.debug("{}","trnNam:" + trnNam);
			String[] trnlist=this.getSysmod().getTrnSortlist("18");
			String list=this.getSysmod().toSqlString(trnlist);
			log.debug("{}","trnlist:" + list);
			if(list.indexOf(trnNam)>0)
			{
			  log.debug("{}","隐藏按钮！");
			  
			  
			}
			else
			{
			  log.debug("{}","显示按钮！");
			  
			  

			}
			
			
		}









































}