package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AnthepVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 公共证实交易
*/
@Transaction(vo= AnthepVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Anthep extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Anthep.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private ModuleList<Spt> sptlist;


		public Anthep()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:anthep.@0000.script
        */
        @Rule(target="btnmod.submit",order=0)
        public boolean ruleBtnmodSubmitN0(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  this.getSysmod().getSpt().copyValue(this.getSptlist().get(index));
			  //String filename=$sptlst[index]\\inr.getValue()+".bak";
			  
			}

			return true;
        }

        /**
        *   source:anthep.@0002.script
        */
        @Rule(target="btnmod.fresh",order=100)
        public boolean ruleBtnmodFreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			String[] frms=new String[]{"fxropn","fxtopn","irfopn","irfopm"};
			//Platform.dbReadset($sptlist,new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","T"),new Argument<Object>("frm",IN,frms));
			ctx.getDaoSession().dbReadset(this.getSptlist(),new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","Z"),new Argument<Object>("dattim",DESC));
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:anthep.@0003.script
        */
        @Rule(target="sptlist",order=200)
        public boolean ruleSptlistN200(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  this.getSysmod().getSpt().copyValue(this.getSptlist().get(index));
			  //String filename=$sptlst[index]\\inr.getValue()+".bak";
			  
			}

			return true;
        }

        /**
        *   source:anthep.@0004.script
        */
        @Rule(target="btnmod.newitem",order=100)
        public boolean ruleBtnmodNewitemN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().setSig("Y");
			

			return true;
        }



        /**
        *   source:anthep.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			String[] frms=new String[]{"fxropn","fxtopn","irfopn","irfopm"};
			//Platform.dbReadset($sptlist,new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","T"),new Argument<Object>("frm",IN,frms));
			ctx.getDaoSession().dbReadset(this.getSptlist(),new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","Z"),new Argument<Object>("dattim",DESC));
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }






}