package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AptmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Aptp;
import com.ceb.gjjs.mda.manager.module.Sigtip;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代付银行端模板制作
*/
@Transaction(vo= AptmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Aptmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Aptmdl.class);

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Aptp aptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sigtip sigtip;

		@BDGetter
		private Rmkmod rmkmod;


		public Aptmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getAptp().setApdgrpHolder(()->this.getApdgrp());
           this.getMtabut().setRecHolder(()->this.getApdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.cur");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setCur(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Aptmdl.this.getApdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Aptmdl.this.getApdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.ownref");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.bchcod");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.inr");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setInr(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.ptyinr");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Aptmdl.this.getFieldPath("apdgrp.rec.stlref");}
 				public void setValue(String arg){Aptmdl.this.getApdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Aptmdl.this.getApdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:aptmdl.@0000.script
        */
        @Rule(target="aptp.select",order=100)
        public boolean ruleAptpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getAptp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage("提示","请先选中一条记录！");
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getAptp().getCidmod().getClipty(),new Argument("inr",this.getAptp().getCidmod().getClilst().getElement(index).getInr()));
			  this.getAptp().getBummod().getWrkmdl().setCidinr(this.getAptp().getCidmod().getClipty().getCid());
			  log.debug("{}","cidinr="+this.getAptp().getBummod().getWrkmdl().getCidinr());
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0002.script
        */
        @Rule(target="aptp.apdgrp.checked",order=100)
        public boolean ruleAptpApdgrpCheckedN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","execute  event bpdgrp checked  .......");
			String steps = "";
			if(MdaUtils.isEmpty(this.getApdgrp().getChecked()))
			{
			  steps = "0:进口代付申请;1:进口代付协议;4:模板信息";
			  //无保证金协议及保证金委托开户和扣划，设置flags标志位为0000
			  this.getApdgrp().getRec().setFlags("0000");
			  
			  MdaUtils.clear(this.getAptp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getAptp().getBxdmod().getMar());
			}
			else
			{
			  this.getApdgrp().getBxd().setCgyd("1");
			  ctx.postRule(this,"apdgrp.bxd.cgyd");
			  this.getApdgrp().getBxd().setJxyd("1");
			  ctx.postRule(this,"apdgrp.bxd.jxyd");
			  this.getApdgrp().getBxd().setJsyd("1");
			  ctx.postRule(this,"apdgrp.bxd.jsyd");
			  this.getApdgrp().getBxd().setZyjjfs("1");
			  ctx.postRule(this,"apdgrp.bxd.zyjjfs");
			  //有保证金协议及保证金委托开户和扣划，设置flags标志位为0001
			  this.getApdgrp().getRec().setFlags("0001");
			  
			  steps = "0:进口代付申请;1:进口代付协议;2:保证金协议;3:委托开户扣划;4:模板信息";
			}
			log.debug("{}","---------------------------flags="+this.getApdgrp().getRec().getFlags());
			this.getAptp().getStpmod().setPages(steps);
			this.getAptp().getStpmod().calcSteps();
			this.getAptp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:aptmdl.@0004.script
        */
        @Rule(target="aptp.apdgrp.ixd.rzsy",order=100)
        public boolean ruleAptpApdgrpIxdRzsyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getApdgrp().getIxd().getRzsy()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0005.script
        */
        @Rule(target="aptp.apdgrp.ixd.bjchfs",order=100)
        public boolean ruleAptpApdgrpIxdBjchfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getApdgrp().getIxd().getBjchfs()))
			{
			  
			  
			  
			}
			else
			{
			  this.getApdgrp().getIxd().setBjchqtfs(NULLSTR);
			  
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0006.script
        */
        @Rule(target="aptp.apdgrp.rec.lxchfs",order=100)
        public boolean ruleAptpApdgrpRecLxchfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getApdgrp().getRec().getLxchfs()))
			{
			  
			  
			  
			}
			else
			{
			  this.getApdgrp().getIxd().setLxchqtfs(NULLSTR);
			  
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0007.script
        */
        @Rule(target="aptp.apdgrp.ixd.zyjjfs",order=100)
        public boolean ruleAptpApdgrpIxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getApdgrp().getIxd().getZyjjfs()))
			{
			  this.getApdgrp().getIxd().setZcwyh(NULLSTR);
			  this.getApdgrp().getIxd().setKtdd(NULLSTR);
			  this.getApdgrp().getIxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(this.getApdgrp().getIxd().getZyjjfs()))
			{
			  this.getApdgrp().getIxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("3".equals(this.getApdgrp().getIxd().getZyjjfs()))
			{
			  this.getApdgrp().getIxd().setZcwyh(NULLSTR);
			  this.getApdgrp().getIxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0008.script
        */
        @Rule(target="aptp.consel",order=100)
        public boolean ruleAptpConselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getAptp().getTmplst());
			

			return true;
        }

        /**
        *   source:aptmdl.@0012.script
        */
        @Rule(target="aptp.chance",order=100)
        public boolean ruleAptpChanceN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","Star chance button...........");
			String fintyp =this.getAptp().getFintyp();

			if(MdaUtils.isEmpty(fintyp))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("aptmdl","CT000041"));
			  return true;
			}
			if("3".equals(fintyp))
			{
			  this.getApdgrp().getRec().setFintyp("3");
			  
			  
			  

			  this.getApdgrp().getRec().setDoctypcod(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrscur(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrsamt(new BigDecimal(0));
			  

			  
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  

			  
			  
			  
			  
			  
			  
			  
			  return true;
			}
			if("2".equals(fintyp))
			{
			  int index=0;
			  if(index<0||index>=this.getAptp().getTmplst().fullSize())
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("aptmdl","CT000043"));
			    return true;
			  }
			  String ref =this.getAptp().getTmplst().getElement(index).getRef();
			  this.getApdgrp().getRec().setFintyp("2");
			  
			  
			  

			  
			  

			  
			  this.getApdgrp().getRec().setLrscur(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrsamt(new BigDecimal(0));
			  

			  
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  
			  //数据处理
			  this.saveDate(ref,index);
			  this.setdoctypcod(ref,index);
			  
			  
			  
			  
			  
			  
			  
			}
			if("1".equals(fintyp))
			{
			  int index=0;
			  if(index<0||index>=this.getAptp().getTmplst().fullSize())
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("aptmdl","CT000046"));
			    return true;
			  }
			  String ref =this.getAptp().getTmplst().getElement(index).getRef();
			  this.getApdgrp().getRec().setFintyp("1");
			  
			  
			  

			  
			  
			  

			  
			  
			  

			  
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  

			  this.getApdgrp().getRec().setDoctypcod(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  
			  //数据处理
			  this.saveDate(ref,index);
			  this.setlrsamt(ref,index);
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:aptmdl.@0013.script
        */
        @Rule(target="aptp.fintyp",order=100)
        public boolean ruleAptpFintypN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getAptp().getTmplst());
			this.getAptp().setPntref(NULLSTR);
			
			
			String fintyp =this.getAptp().getFintyp();
			log.debug("{}","fintyp========="+fintyp);
			if("3".equals(fintyp))
			{
			  
			  
			  ctx.setMessage(MdaUtils.getI18NString("aptmdl","CT000050"),MdaUtils.getI18NString("aptmdl","CT000051"));
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:aptmdl.@0014.script
        */
        @Rule(target="aptp.queryref",order=100)
        public boolean ruleAptpQueryrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			String fintyp = this.getAptp().getFintyp();
			String pntref = this.getAptp().getPntref();
			String queryClause = null;
			//String queryLid ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM lid rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'lid' and s.objinr =rec.inr";
			String queryBrd  ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.advcur cur,rec.advamt amt,rec.advdat dat ,substr(s.adrblk,0,35) bennam FROM brd rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'brd' and s.objinr =rec.inr and rec.stlref not like '%RB%'";
			String queryBcd ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.doccur cur,rec.docamt amt,rec.rcvdat dat ,substr(s.adrblk,0,35) bennam FROM bcd rec,pts s WHERE  s.rol = 'drr' AND s.objtyp = 'bcd' and s.objinr =rec.inr";
			String queryCpd ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM cpd rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'cpd' and s.objinr =rec.inr";
			if("1".equals(fintyp))
			{
			  //信用证下代付业务
			  queryClause=queryBrd;
			  //queryClause=queryLid;
			}
			else if("2".equals(fintyp))
			{
			  //代收下代付业务
			  queryClause=queryBcd;

			}
			else if("3".equals(fintyp))
			{
			  //汇出汇款项下进口代付业务
			  queryClause=queryCpd;

			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("aptmdl","CT000052"));
			  return true;
			}
			// queryClause=queryClause+$\\sysmod.getSelection();
			//因为本次的交易只推送给企业端所以。。。。。。。。
			queryClause=queryClause+" AND rec.ptyinr='"+this.getAptp().getCidmod().getClipty().getInr()+"' AND  rec.clsdat is  null  AND rec.stlref IS NOT NULL";
			if(!MdaUtils.isEmpty(pntref))
			{
			  queryClause = queryClause + " AND rec.stlref LIKE '%" + pntref.toUpperCase() + "%'";
			}
			if("1".equals(fintyp))
			  queryClause = queryClause + " order by rec.advdat desc ";
			else if("2".equals(fintyp))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			MdaUtils.clear(this.getAptp().getTmplst());

			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);

			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			//表名
			Argument<String> nam = new Argument<String>("nam");

			while(true)
			{

			  ctx.getDaoSession().dbFetchFields(nam,trsinr,ref,dat,cur,amt,bennam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAptp().getTmplst().add(nam,trsinr,ref,dat,cur,amt,bennam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			


			return true;
        }

        /**
        *   source:aptmdl.@0018.script
        */
        @Rule(target="aptp.cidmod.clilst",order=100)
        public boolean ruleAptpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"aptp.select");

			return true;
        }

        /**
        *   source:aptmdl.@0019.script
        */
        @Rule(target="aptp.tmplst",order=100)
        public boolean ruleAptpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"aptp.chance");

			return true;
        }


        /**
        *   source:aptmdl.@0009.script
        */
        @Check(target="aptp.apdgrp.rec.amt",order=100)
        public boolean checkAptpApdgrpRecAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			// $sysmod.checkNumericField($yxygrp\\rec\\yhll,5);
			BigDecimal amt = this.getApdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getApdgrp().getRec().setAmt(amt);
			

			return true;
        }

        /**
        *   source:aptmdl.@0010.script
        */
        @Check(target="aptp.apdgrp.rec.payamt",order=100)
        public boolean checkAptpApdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getApdgrp().getRec().getPayamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getApdgrp().getRec().setPayamt(amt);
			

			return true;
        }

        /**
        *   source:aptmdl.@0011.script
        */
        @Check(target="aptp.apdgrp.ixd.yfczhm",order=100)
        public boolean checkAptpApdgrpIxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if( MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfczhm())  && MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfdzyj()) && MdaUtils.isEmpty(this.getApdgrp().getIxd())&& MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfwxhm())
			  && MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfqqhm()) )
			{
			  ctx.setFieldError(this,"apdgrp.ixd.yfczhm",MdaUtils.getI18NString("aptmdl","CT000040"));
			  return false;
			}

			return true;
        }


        /**
        *   source:aptmdl.@0001.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块aptmdl  init业务处理开始，ORDER编号:50");
			//定义步骤条
			this.getAptp().getStpmod().storePanel(this.getAptp().getAptmdlstep02(),this.getAptp().getAptmdlstep03(),this.getAptp().getAptmdlstep04(),this.getAptp().getAptmdlstep05(),this.getAptp().getAptmdlstep06());
			String steps = "0:进口代付申请;1:进口代付协议;4:模板信息";
			this.getAptp().getStpmod().setPages(steps);
			this.getAptp().getStpmod().calcSteps();


			return true;
        }

        /**
        *   source:aptmdl.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块bptmdl  init业务处理开始，ORDER编号:100");
			//初始化是否有保证金协议标志位
			
			this.getApdgrp().getRec().setFlags("0000");
			this.getAptp().getBummod().setModtyp("aptopn");
			this.getApdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			

			return true;
        }


        /**
        *   source:aptmdl.@0015.script
        */
        public void saveDate(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			this.getApdgrp().getRec().setAmt(this.getAptp().getTmplst().getElement(index).getAmt());
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getAmt()))
			{
			  
			}
			this.getApdgrp().getRec().setCur(this.getAptp().getTmplst().getElement(index).getCur());
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getCur()))
			{
			  
			}
			this.getApdgrp().getRec().setPntref(ref);
			log.debug("{}","2222save date  amt======"+this.getApdgrp().getRec().getAmt()+"pntref======="+this.getApdgrp().getRec().getPntref());
			
			
			
		}
        /**
        *   source:aptmdl.@0016.script
        */
        public void setdoctypcod(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select doctypcod from bcd where stlref='"+ref+"'";
			log.info("{}","最终执行的sql语句==========" + sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> doctypcod = new Argument<String>("doctypcod");
			ctx.getDaoSession().dbFetchFields(doctypcod);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			this.getApdgrp().getRec().setDoctypcod(doctypcod.value);
			
		}
        /**
        *   source:aptmdl.@0017.script
        */
        public void setlrsamt(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}"," setlrsamt ref==========="+ref+"index=========="+index);
			String sql="select isscur,issamt from lid,brd where brd.stlref ='"+ref+"' and brd.pntstlref=lid.stlref";
			log.info("{}","最终执行的sql语句==========" + sql);
			Argument<String> isscur = new Argument<String>("isscur");
			Argument<BigDecimal> issamt = new Argument<BigDecimal>("issamt");
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(isscur,issamt);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			this.getApdgrp().getRec().setLrscur(isscur.value);
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getLrscur()))
			{
			  
			}
			this.getApdgrp().getRec().setLrsamt(issamt.value);
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getLrsamt()))
			{
			  
			}
			log.info("{}","setlrsamt lrscur========"+this.getApdgrp().getRec().getLrscur()+"lrsamt============"+this.getApdgrp().getRec().getLrsamt());
			
			
		}








}