package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AptopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Aptp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代付申请综
*/
@Transaction(vo= AptopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Aptopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Aptopn.class);

        //信用证下币别
        private String lrscur;
        //信用证下金额
        private BigDecimal lrsamt = new BigDecimal("0.00");
        //信用证下申请期限
        private int lrsdat;
        //代收项下的币别
        private String colcur;
        //代收项下金额
        private BigDecimal colamt = new BigDecimal("0.00");
        //代收项下申请期限
        private int coldat;
        //汇款项下币别
        private String paycur;
        //汇款项下金额
        private BigDecimal payamt = new BigDecimal("0.00");
        //汇款项下申请期限
        private int paydat;
        //信用证下业务币别
        private String lrdcur;
        //信用证下业务金额
        private BigDecimal lrdamt = new BigDecimal("0.00");
        //代收下业务币别
        private String codcur;
        //代收下业务金额
        private BigDecimal codamt = new BigDecimal("0.00");
        //汇款下业务币别
        private String padcur;
        //汇款下业务金额
        private BigDecimal padamt = new BigDecimal("0.00");
        //折合人民币金额
        private String zhrmb;
        //发票号
        private String chargeref;
		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Aptp aptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Aptopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getAptp().setApdgrpHolder(()->this.getApdgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.paycur");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setPaycur(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getPaycur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.payamt");}
 				public void setValue(BigDecimal arg){Aptopn.this.getApdgrp().getRec().setPayamt(arg);}
 				public BigDecimal getValue(){return Aptopn.this.getApdgrp().getRec().getPayamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.ownref");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.bchcod");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.inr");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setInr(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.ptyinr");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Aptopn.this.getFieldPath("apdgrp.rec.stlref");}
 				public void setValue(String arg){Aptopn.this.getApdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Aptopn.this.getApdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getApdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("IF"));
        }

        /**
        *   source:aptopn.@0002.script
        */
        @Rule(target="aptp.stpmod.next",order=50)
        public boolean ruleAptpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getAptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			switch(panelidx)
			{
			  case 0:
			  log.info("{}","case0.........."+this.getAptp().getApdgrp().getAgree());
			  if(MdaUtils.isEmpty(this.getAptp().getApdgrp().getAgree()))
			  {
			    ctx.setFieldError(this,"aptp.apdgrp.agree",MdaUtils.getI18NString("aptopn","CT000373"));
			  }
			  return !MdaUtils.isEmpty(this.getAptp().getApdgrp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getApdgrp().getRec()) ;

			  case 2:
			  return ctx.checkAll(this.getApdgrp().getIxd());

			  case 3:
			  return ctx.checkAll(this.getApdgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getApdgrp().getMar());
			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:aptopn.@0005.script
        */
        @Rule(target="aptp.stpmod.gostep",order=50)
        public boolean ruleAptpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getAptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);
			//不能连跳多个步骤
			if((stepIdx-panelidx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("aptopn","CT000374"),MdaUtils.getI18NString("aptopn","CT000383"));
			  return false;
			}

			//从0跳到1时，若没勾选我同意，防止查询模版显示出来
			
			if((stepIdx==1)||(stepIdx == 2 && !ctx.checkAll(this.getApdgrp().getRec())))
			{
			  if(panelidx == 0 && MdaUtils.isEmpty(this.getAptp().getApdgrp().getAgree()))
			  {
			    
			  }
			  else
			  {
			    
			  }
			}
			else
			{
			  
			}
			

			if(panelidx>stepIdx)
			{
			  return true;
			}

			switch(panelidx)
			{
			  case 0:
			  log.info("{}","case0.........."+this.getAptp().getApdgrp().getAgree());
			  if(MdaUtils.isEmpty(this.getAptp().getApdgrp().getAgree()))
			  {
			    ctx.setFieldError(this,"aptp.apdgrp.agree",MdaUtils.getI18NString("aptopn","CT000384"));
			  }
			  return !MdaUtils.isEmpty(this.getAptp().getApdgrp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getApdgrp().getRec()) ;

			  case 2:
			  return ctx.checkAll(this.getApdgrp().getIxd());

			  case 3:
			  return ctx.checkAll(this.getApdgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getApdgrp().getMar());
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:aptopn.@0007.script
        */
        @Rule(target="mtabut.mail",order=200)
        public boolean ruleMtabutMailN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","执行mail，order[200]");
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("aptopnApp"+inr,"aptopn");
			this.getMtabut().setAttnames("aptopnApp"+inr+".pdf;aptopnDra"+inr+".pdf");
			log.debug("{}","执行完毕mail，order[200]");

			return true;
        }

        /**
        *   source:aptopn.@0008.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 数据保存
			  */
			log.info("{}","in sav200 .... ");
			this.getMtabut().getBusmod().dealFile();
			String flags = this.getApdgrp().getRec().getFlags();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  String objinr = this.getApdgrp().getRec().getInr();
			  ctx.getDaoSession().dbUpdate(this.getApdgrp().getRec());
			  this.getMtabut().UpdatePtsForBack(this.getApdgrp().getApl().getPts(),objinr);
			}
			else
			{
			  // 保存进口代付申请
			  this.getApdgrp().getRec().setInr(Platform.sdbCounter("apd"));
			  ctx.getDaoSession().dbInsert(this.getApdgrp().getRec());
			  // 代付申请人
			  String objinr = this.getApdgrp().getRec().getInr();
			  String objtyp ="apd";
			  this.getApdgrp().getApl().savpts(objinr,objtyp);
			  // 保存申请协议信息
			  this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getApdgrp().getIxd(),"ownref"),"DX");
			  this.getApdgrp().getIxd().setRef( this.getApdgrp().getRec().getOwnref());
			  this.getApdgrp().getIxd().setObjtyp( objtyp);
			  this.getApdgrp().getIxd().setObjinr( objinr);
			  this.getApdgrp().getIxd().setInr(Platform.sdbCounter("ixd"));
			  ctx.getDaoSession().dbInsert(this.getApdgrp().getIxd());
			  // 保存保证金协议
			  if("0001".equals(flags))
			  {
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getApdgrp().getBxd(),"ownref"),"BX");
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getApdgrp().getMar(),"ownref"),"JX");
			    this.getAptp().getBxdmod().saveBxdAndMar();
			  }

			}
			// 保存TRN表
			if(!this.getTrnmod().trnSetFromContract())
			{
			  return false;
			}
			// 保存界面截图
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			IPanel[] panels=this.getAptp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);


			return true;
        }

        /**
        *   source:aptopn.@0009.script
        */
        @Rule(target="mtabut.sav",order=190)
        public boolean ruleMtabutSavN190(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 检查及校验
			  */
			String flags =this.getApdgrp().getRec().getFlags();
			if("0001".equals(flags))
			{
			  //保证金协议参号为空则生成
			  if(!ctx.checkAll(this.getApdgrp()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("aptopn","CT000000"),MdaUtils.getI18NString("aptopn","CT000001"));
			    return false ;
			  }
			}
			else if("0000".equals(flags))
			{
			  if(!( ctx.checkAll(this.getApdgrp().getIxd())&& ctx.checkAll(this.getApdgrp().getRec())))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("aptopn","CT000002"),MdaUtils.getI18NString("aptopn","CT000003"));
			    return false;
			  }
			}


			return true;
        }

        /**
        *   source:aptopn.@0011.script
        */
        @Rule(target="aptp.fintyp",order=100)
        public boolean ruleAptpFintypN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getAptp().getTmplst());
			this.getAptp().setPntref(NULLSTR);
			
			
			String fintyp =this.getAptp().getFintyp();
			log.debug("{}","fintyp========="+fintyp);
			if("3".equals(fintyp))
			{
			  
			  
			  ctx.setMessage(MdaUtils.getI18NString("aptopn","CT000347"),MdaUtils.getI18NString("aptopn","CT000348"));
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:aptopn.@0012.script
        */
        @Rule(target="aptp.chance",order=100)
        public boolean ruleAptpChanceN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","Star chance button...........");
			String fintyp =this.getAptp().getFintyp();

			if(MdaUtils.isEmpty(fintyp))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("aptopn","CT000016"));
			  return true;
			}
			if("3".equals(fintyp))
			{
			  this.getApdgrp().getRec().setFintyp("3");
			  
			  
			  

			  this.getApdgrp().getRec().setDoctypcod(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrscur(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrsamt(new BigDecimal(0));
			  

			  
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  

			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(fintyp))
			{
			  int index=0;
			  if(index<0||index>=this.getAptp().getTmplst().fullSize())
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("aptopn","CT000337"));
			    return true;
			  }
			  String ref =this.getAptp().getTmplst().getElement(index).getRef();
			  this.getApdgrp().getRec().setFintyp("2");
			  
			  
			  

			  
			  

			  
			  this.getApdgrp().getRec().setLrscur(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setLrsamt(new BigDecimal(0));
			  

			  
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  
			  //数据处理
			  this.saveDate(ref,index);
			  this.setdoctypcod(ref,index);
			  
			  
			  
			  
			  
			  
			  
			}
			if("1".equals(fintyp))
			{
			  int index=0;
			  if(index<0||index>=this.getAptp().getTmplst().fullSize())
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("aptopn","CT000340"));
			    return true;
			  }
			  String ref =this.getAptp().getTmplst().getElement(index).getRef();
			  this.getApdgrp().getRec().setFintyp("1");
			  
			  
			  

			  
			  
			  

			  
			  
			  

			  
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  

			  this.getApdgrp().getRec().setDoctypcod(NULLSTR);
			  

			  
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  
			  //数据处理
			  this.saveDate(ref,index);
			  this.setlrsamt(ref,index);
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:aptopn.@0013.script
        */
        @Rule(target="aptp.consel",order=100)
        public boolean ruleAptpConselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getAptp().getTmplst());
			

			return true;
        }

        /**
        *   source:aptopn.@0014.script
        */
        @Rule(target="aptp.queryref",order=100)
        public boolean ruleAptpQueryrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			String fintyp = this.getAptp().getFintyp();
			String pntref = this.getAptp().getPntref();
			String queryClause = null;
			//String queryLid ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM lid rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'lid' and s.objinr =rec.inr";
			String queryBrd  ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.advcur cur,rec.advamt amt,rec.advdat dat ,substr(s.adrblk,0,35) bennam FROM brd rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'brd' and s.objinr =rec.inr and rec.stlref not like '%RB%' and docflg <> 'payment'";
			String queryBcd ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.doccur cur,rec.docamt amt,rec.rcvdat dat ,substr(s.adrblk,0,35) bennam FROM bcd rec,pts s WHERE  s.rol = 'drr' AND s.objtyp = 'bcd' and s.objinr =rec.inr and docflg <> 'payment'";
			String queryCpd ="SELECT s.objtyp nam, rec.inr trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM cpd rec,pts s WHERE  s.rol = 'ben' AND s.objtyp = 'cpd' and s.objinr =rec.inr";
			if("1".equals(fintyp))
			{
			  //信用证下代付业务
			  queryClause=queryBrd;
			  //queryClause=queryLid;
			}
			else if("2".equals(fintyp))
			{
			  //代收下代付业务
			  queryClause=queryBcd;

			}
			else if("3".equals(fintyp))
			{
			  //汇出汇款项下进口代付业务
			  queryClause=queryCpd;

			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("aptopn","CT000018"));
			  return true;
			}
			queryClause=queryClause+ctx.absGet(Sysmod.class).getSelection();
			if(!MdaUtils.isEmpty(pntref))
			{
			  queryClause = queryClause + " AND rec.stlref LIKE '%" + pntref.toUpperCase() + "%'";
			}
			if("1".equals(fintyp))
			  queryClause = queryClause + " order by rec.advdat desc ";
			else if("2".equals(fintyp))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			MdaUtils.clear(this.getAptp().getTmplst());

			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);

			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			//表名
			Argument<String> nam = new Argument<String>("nam");

			while(true)
			{

			  ctx.getDaoSession().dbFetchFields(nam,trsinr,ref,dat,cur,amt,bennam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAptp().getTmplst().add(nam,trsinr,ref,dat,cur,amt,bennam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			


			return true;
        }

        /**
        *   source:aptopn.@0015.script
        */
        @Rule(target="aptp.tmplst",order=100)
        public boolean ruleAptpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"aptp.chance");

			return true;
        }

        /**
        *   source:aptopn.@0025.script
        */
        @Rule(target="aptp.getixdref",order=100)
        public boolean ruleAptpGetixdrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getApdgrp().getIxd(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "DX");

			return true;
        }

        /**
        *   source:aptopn.@0028.script
        */
        @Rule(target="aptp.pdfbxd",order=100)
        public boolean ruleAptpPdfbxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getAptp().getPdfviw().callPDFComponent("","bxdopn","保证金协议",1);

			return true;
        }

        /**
        *   source:aptopn.@0029.script
        */
        @Rule(target="aptp.pdfmar",order=100)
        public boolean ruleAptpPdfmarN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getAptp().getPdfviw().callPDFComponent("","maropn","保证金委托开户及扣划",1);

			return true;
        }

        /**
        *   source:aptopn.@0033.script
        */
        @Rule(target="aptp.pdfapd",order=100)
        public boolean ruleAptpPdfapdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealPDFData();
			this.getAptp().getPdfviw().callPDFComponent("","aptopn","进口代付申请",1);

			return true;
        }

        /**
        *   source:aptopn.@0034.script
        */
        @Rule(target="aptp.pdfixd",order=100)
        public boolean ruleAptpPdfixdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getAptp().getPdfviw().callPDFComponent("","aptopn1","进口代付协议",1);

			return true;
        }

        /**
        *   source:aptopn.@0048.script
        */
        @Rule(target="mtabut.busmod.select",order=101)
        public boolean ruleMtabutBusmodSelectN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.control();
			
			

			return true;
        }

        /**
        *   source:aptopn.@0050.script
        */
        @Rule(target="aptp.apdgrp.checked3",order=100)
        public boolean ruleAptpApdgrpChecked3N100(){
            IContext ctx = MdaEnv.getContext();
            
			String checked=this.getAptp().getApdgrp().getChecked3();
			String steps=null;
			log.debug("{}","checked3="+checked);
			if(MdaUtils.isEmpty(checked))
			{
			  this.getApdgrp().getRec().setFlags("0000");
			  steps="0:声明及提示;1:进口代付申请;2:合同协议;5:合同展示";
			  
			  
			  MdaUtils.clear(this.getAptp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getAptp().getBxdmod().getMar());
			  MdaUtils.clear(this.getAptp().getBxdmod().getMxdlst());
			  MdaUtils.clear(this.getAptp().getBxdmod().getMxdbak());
			}
			else if(!MdaUtils.isEmpty(checked))
			{
			  this.getApdgrp().getRec().setFlags("0001");
			  steps="0:声明及提示;1:进口代付申请;2:合同协议;3:保证金协议;4:委托开户扣划;5:合同展示";

			  this.getAptp().getBxdmod().getMar().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			  log.debug("{}","mar_credat"+MdaUtils.sqlDate(MdaUtils.today(),GE));
			  
			  
			  
			  
			}
			
			
			
			log.debug("{}","标志位flags="+this.getApdgrp().getRec().getFlags());
			this.getAptp().getStpmod().setPages(steps);
			this.getAptp().getStpmod().calcSteps();
			this.getAptp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:aptopn.@0052.script
        */
        @Rule(target="aptp.stpmod.last",order=110)
        public boolean ruleAptpStpmodLastN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getAptp().getStpmod().getCuridx();
			log.info("{}","上一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter last 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter last 110!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:aptopn.@0053.script
        */
        @Rule(target="aptp.stpmod.next",order=110)
        public boolean ruleAptpStpmodNextN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getAptp().getStpmod().getCuridx();
			log.info("{}","下一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:aptopn.@0054.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			//提交210，保存要预览的pdf资源
			int cnt= 1;
			String labels = "进口代付申请书";
			String tempfiles = "A:aptopn";
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();
			/*
			  else
			  {
			  cnt = 4;
			  labels = "进口代付申请,进口代付协议,保证金协议,保证金委托开户及扣划申请";
			  tempfiles = "A:aptopn2,A:aptopn1,A:bxdopn,A:maropn";
			  }
			  */

			return true;
        }

        /**
        *   source:aptopn.@0056.script
        */
        @Rule(target="aptp.apdgrp.rec.payexpdat",order=100)
        public boolean ruleAptpApdgrpRecPayexpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getApdgrp().getRec().setMatdat(MdaUtils.add(this.getApdgrp().getRec().getCredat(),this.getApdgrp().getRec().getPayexpdat()));
			

			return true;
        }


        /**
        *   source:aptopn.@0020.script
        */
        @Check(target="apdgrp.rec.amt",order=100)
        public boolean checkApdgrpRecAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			// $sysmod.checkNumericField($yxygrp\\rec\\yhll,5);
			BigDecimal amt = this.getApdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getApdgrp().getRec().setAmt(amt);
			

			return true;
        }

        /**
        *   source:aptopn.@0022.script
        */
        @Check(target="apdgrp.rec.payamt",order=100)
        public boolean checkApdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getApdgrp().getRec().getPayamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getApdgrp().getRec().setPayamt(amt);
			

			return true;
        }

        /**
        *   source:aptopn.@0043.script
        */
        @Check(target="aptp.apdgrp.ixd.yfczhm",order=100)
        public boolean checkAptpApdgrpIxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if( MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfczhm())  && MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfdzyj()) && MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfsjhm())&& MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfwxhm())
			  && MdaUtils.isEmpty(this.getApdgrp().getIxd().getYfqqhm()) )
			{
			  ctx.setFieldError(this,"apdgrp.ixd.yfczhm",MdaUtils.getI18NString("aptopn","CT000362"));
			  return false;
			}

			return true;
        }

        /**
        *   source:aptopn.@0044.script
        */
        @Check(target="aptp.bxdmod.bxd.yfczhm",order=100)
        public boolean checkAptpBxdmodBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getApdgrp().getChecked()))
			{
			  if(MdaUtils.isEmpty(this.getAptp().getBxdmod().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getAptp().getBxdmod().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getAptp().getBxdmod().getBxd().getYfsjhm()))
			    ctx.setFieldError(this,"aptp.bxdmod.bxd.yfczhm",MdaUtils.getI18NString("aptopn","CT000363"));
			}

			return true;
        }

        /**
        *   source:aptopn.@0045.script
        */
        @Check(target="apdgrp.bxd.yfzrr",order=100)
        public boolean checkApdgrpBxdYfzrrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getApdgrp().getChecked3()))
			{
			  if(MdaUtils.isEmpty(this.getApdgrp().getBxd().getYf())&&MdaUtils.isEmpty(this.getApdgrp().getBxd().getYfzrr()))
			  {
			    ctx.setFieldError(this,"apdgrp.bxd.yf",MdaUtils.getI18NString("aptopn","CT000365"));
			  }
			  else
			  {
			    //乙方(自然人)信息
			    
			    
			    
			    //乙方(自然人)收件信息
			    
			    
			    
			    
			    //乙方(自然人)代收人信息
			    
			    
			    
			    
			    //乙方（单位）信息
			    
			    
			    //乙方（单位）收件信息
			    
			    
			    
			    
			    
			    //乙方（单位）代收人信息
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:aptopn.@0046.script
        */
        @Check(target="apdgrp.mar.wtklbzjzh",order=100)
        public boolean checkApdgrpMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getApdgrp().getChecked3()))
			{
			  if(MdaUtils.isEmpty(this.getApdgrp().getMar().getWtklbzjzh())&&MdaUtils.isEmpty(this.getApdgrp().getMar().getWtkhbzj()))
			    // Platform.error($margrp\\mar\\wtklbzjzh,#CT000366);
			  ctx.setMessage(MdaUtils.getI18NString("aptopn","CT000367"),MdaUtils.getI18NString("aptopn","CT000368"));
			}

			return true;
        }


        /**
        *   source:aptopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//第一个界面不允许查询模板
			
			
			log.debug("{}"," aptopn  init 100");
			// 2. 初始化字段 默认大写金额为灰显
			
			
			
			
			this.getApdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			{
			  this.getTrnmod().ordNew();
			}
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getApdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getApdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			this.getApdgrp().getRec().setCredat(MdaUtils.today());
			this.getApdgrp().setSubword("irfopn");


			return true;
        }

        /**
        *   source:aptopn.@0027.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","aptopn init业务处理开始，ORDER编号:90");
			this.getAptp().getStpmod().storePanel(this.getAptp().getAptopn02(),this.getAptp().getAptopn01(),this.getAptp().getAptopn03(),this.getAptp().getAptopn04(),this.getAptp().getAptopn05(),this.getAptp().getAptopn06());
			String steps="0:声明及提示;1:进口代付申请;2:合同协议;5:合同展示";
			String flags=this.getApdgrp().getRec().getFlags();
			log.debug("{}","标志位flags="+flags);
			
			
			this.loadTips();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  log.debug("{}","暂存或者退回");
			  this.control();
			  if("0001".equals(flags))
			  {
			    steps="0:声明及提示;1:进口代付申请;2:合同协议;3:保证金协议;4:委托开户扣划;5:合同展示";
			  }
			  else
			  {
			    this.getApdgrp().getRec().setFlags("0000");
			    
			  }
			}
			this.getApdgrp().setChecked1(TRUE);
			this.getApdgrp().setChecked2(TRUE);
			this.getApdgrp().setChecked4(TRUE);
			
			
			
			
			
			
			
			
			log.debug("{}","steps="+steps);
			this.getAptp().getStpmod().setPages(steps);
			this.getAptp().getStpmod().calcSteps();
			this.getAptp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:aptopn.@0010.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setZhrmb(this.getSysmod().covCnAmt(MdaUtils.parseDecimal(this.getApdgrp().getIxd().getSxedrmbje()),"CNY"));
			
			log.info("{}","Start dealPDFDate...............");
			String fintyp=this.getApdgrp().getRec().getFintyp();
			log.info("{}","dealPDFData fintyp.value ========="+fintyp);
			if("1".equals(fintyp))
			{
			  this.getApdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getApdgrp().getRec().setCur(NULLSTR);
			  this.setLrscur(this.getApdgrp().getRec().getPaycur());
			  this.setLrsamt(this.getApdgrp().getRec().getPayamt());
			  this.setLrsdat(this.getApdgrp().getRec().getPayexpdat());
			  this.setLrdcur(this.getApdgrp().getRec().getCur());
			  this.setLrdamt(this.getApdgrp().getRec().getAmt());
			  this.setColcur(NULLSTR);
			  this.setColamt(new BigDecimal(0));
			  this.setColdat(0);
			  this.setCodcur(NULLSTR);
			  this.setCodamt(new BigDecimal(0));
			  this.setPaycur(NULLSTR);
			  this.setPayamt(new BigDecimal(0));
			  this.setPaydat(0);
			  this.setPadcur(NULLSTR);
			  this.setPadamt(new BigDecimal(0));

			}
			if("2".equals(fintyp))
			{
			  this.setColcur(this.getApdgrp().getRec().getPaycur());
			  this.setColamt(this.getApdgrp().getRec().getPayamt());
			  this.setColdat(this.getApdgrp().getRec().getPayexpdat());
			  this.setCodcur(this.getApdgrp().getRec().getCur());
			  this.setCodamt(this.getApdgrp().getRec().getAmt());
			  this.setChargeref(this.getApdgrp().getRec().getColref());
			  this.setLrscur(NULLSTR);
			  this.setLrsamt(new BigDecimal(0));
			  this.setLrsdat(0);
			  this.setLrdcur(NULLSTR);
			  this.setLrdamt(new BigDecimal(0));
			  this.setPaycur(NULLSTR);
			  this.setPayamt(new BigDecimal(0));
			  this.setPaydat(0);
			  this.setPadcur(NULLSTR);
			  this.setPadamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setPntref(NULLSTR);
			  

			}
			if("3".equals(fintyp))
			{
			  this.setPaycur(this.getApdgrp().getRec().getPaycur());
			  this.setPayamt(this.getApdgrp().getRec().getPayamt());
			  this.setPaydat(this.getApdgrp().getRec().getPayexpdat());
			  this.setPadcur(this.getApdgrp().getRec().getCur());
			  this.setPadamt(this.getApdgrp().getRec().getAmt());
			  this.setChargeref(this.getApdgrp().getRec().getPayref());
			  this.setColcur(NULLSTR);
			  this.setColamt(new BigDecimal(0));
			  this.setColdat(0);
			  this.setCodcur(NULLSTR);
			  this.setCodamt(new BigDecimal(0));
			  this.setLrscur(NULLSTR);
			  this.setLrsamt(new BigDecimal(0));
			  this.setLrsdat(0);
			  this.setLrdcur(NULLSTR);
			  this.setLrdamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setPntref(NULLSTR);
			  
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			log.info("{}","lrscur.value======="+this.getLrscur()+"lrsamt.value====="+this.getLrsamt()+"lrsdat.value======="+this.getLrsdat());
			log.info("{}","colcur.value======="+this.getColcur()+"colamt.value====="+this.getColamt()+"paycur.value======="+this.getPaycur());
			log.info("{}","paycur.value======="+this.getPaycur()+"payamt.value====="+this.getPayamt()+"paydat.value======="+this.getPaydat());
		}
        /**
        *   source:aptopn.@0038.script
        */
        public void setdoctypcod(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select doctypcod from bcd where stlref='"+ref+"'";
			log.info("{}","最终执行的sql语句==========" + sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> doctypcod = new Argument<String>("doctypcod");
			ctx.getDaoSession().dbFetchFields(doctypcod);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			this.getApdgrp().getRec().setDoctypcod(doctypcod.value);
			
		}
        /**
        *   source:aptopn.@0039.script
        */
        public void setlrsamt(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}"," setlrsamt ref==========="+ref+"index=========="+index);
			String sql="select isscur,issamt from lid,brd where brd.stlref ='"+ref+"' and brd.pntstlref=lid.stlref";
			log.info("{}","最终执行的sql语句==========" + sql);
			Argument<String> isscur = new Argument<String>("isscur");
			Argument<BigDecimal> issamt = new Argument<BigDecimal>("issamt");
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(isscur,issamt);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			this.getApdgrp().getRec().setLrscur(isscur.value);
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getLrscur()))
			{
			  
			}
			this.getApdgrp().getRec().setLrsamt(issamt.value);
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getLrsamt()))
			{
			  
			}
			log.info("{}","setlrsamt lrscur========"+this.getApdgrp().getRec().getLrscur()+"lrsamt============"+this.getApdgrp().getRec().getLrsamt());
			
			
		}
        /**
        *   source:aptopn.@0040.script
        */
        public void saveDate(String ref,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			this.getApdgrp().getRec().setAmt(this.getAptp().getTmplst().getElement(index).getAmt());
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getAmt()))
			{
			  
			}
			this.getApdgrp().getRec().setCur(this.getAptp().getTmplst().getElement(index).getCur());
			if(!MdaUtils.isEmpty(this.getApdgrp().getRec().getCur()))
			{
			  
			}
			this.getApdgrp().getRec().setPntref(ref);
			log.debug("{}","2222save date  amt======"+this.getApdgrp().getRec().getAmt()+"pntref======="+this.getApdgrp().getRec().getPntref());
			
			
			
		}
        /**
        *   source:aptopn.@0042.script
        */
        public void control()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String fintyp =this.getApdgrp().getRec().getFintyp();
			if("3".equals(fintyp))
			{
			  
			  
			  

			  
			  

			  

			  
			  

			  
			  

			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(fintyp))
			{
			  
			  
			  

			  
			  

			  
			  

			  
			  

			  
			  

			  
			  

			  
			  
			  
			  
			  
			  
			}
			if("1".equals(fintyp))
			{
			  
			  
			  

			  

			  
			  
			  

			  
			  
			  

			  
			  

			  
			  

			  
			  
			  
			  

			}
		}
        /**
        *   source:aptopn.@0049.script
        */
        public void loadTips()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getApdgrp().getTips()))
			{
			  String tips="Tips:操作指引";
			  tips+=CR+"一、业务发起流程";
			  tips+=CR+"1、贵司应至少提交“进口代付申请书”和“进口代付协议”，并根据实际需要选择是否提交“保证金协议、保证金委托开户及扣划申请”。";
			  tips+=CR+"2、客户可以通过手工输入或调用历史模板快速编辑并提交业务申请； ";
			  tips+=CR+"二、申请书与合同/协议的修改流程 ";
			  tips+=CR+"1、贵司提交的申请书有任何不妥均须由贵司自行修改。届时银行将把申请交易退回单证通“退回文件夹”，由贵司进行修改； ";
			  tips+=CR+"2、贵司提交的合同/协议若需要修改，银行客户经理可代为修改，修改完毕将修改结果返回单证通“二次确认夹”供贵司确认后再行提交。";
			  this.getApdgrp().setTips(tips);
			  
			}
		}
























}