package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AutcntVO;

import com.ceb.gjjs.mda.manager.module.Cntgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Cntp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 主管解锁
*/
@Transaction(vo= AutcntVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Autcnt extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Autcnt.class);

		@BDGetter
		private Cntgrp cntgrp;

		@BDGetter
		private Cntp cntp;

		@BDGetter
		private Sysmod sysmod;


		public Autcnt()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCntp().setCntgrpHolder(()->this.getCntgrp());
        }

        /**
        *   source:autcnt.@0001.script
        */
        @Rule(target="cntp.save",order=100)
        public boolean ruleCntpSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getCntgrp().getUsrlst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("autcnt","CT000010"),MdaUtils.getI18NString("autcnt","CT000011"));
			  return true;
			}
			ctx.getDaoSession().dbBegin();
			//$cntgrp\\usr.copyValue($cntgrp\\usrlst[index]);
			ctx.getDaoSession().dbRead(this.getCntgrp().getUsr(),new Argument<String>("inr",this.getCntgrp().getUsrlst().getElement(index).getInr()));
			this.getCntgrp().getUsr().setFilcnt(0);
			this.getCntgrp().getUsr().setUsrflg("0");
			ctx.getDaoSession().dbUpdate(this.getCntgrp().getUsr());
			log.debug("{}","filcnt = "+this.getCntgrp().getUsr().getFilcnt());
			log.debug("{}","usrflg = "+this.getCntgrp().getUsr().getUsrflg());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("autcnt","CT000012"),MdaUtils.getI18NString("autcnt","CT000013"));
			loadUsr();

			return true;
        }



        /**
        *   source:autcnt.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//select * from  usr where filcnt='5'  order by lgnnam
			loadUsr();

			return true;
        }


        /**
        *   source:autcnt.@0003.script
        */
        public void loadUsr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCntgrp().getUsrlst());
			String sql = "SELECT inr,lgnnam,oprnam,usrflg FROM usr";
			sql += " WHERE otype = '2' AND usrflg = '2' AND filcnt = '5'";
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			  sql += " AND ptyinr IN(SELECT inr FROM pty WHERE ptytyp = '0')";
			else if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  sql += " AND ptyinr = '"+this.getSysmod().getPty().getInr()+"'";
			else
			  log.debug("{}","User "+this.getSysmod().getUsr().getLgnnam()+" shouldn't Do Trans autcnt!");
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> lgnnam = new Argument<String>("lgnnam");
			Argument<String> oprnam = new Argument<String>("oprnam");
			Argument<String> usrflg = new Argument<String>("usrflg");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,lgnnam,oprnam,usrflg);
			  if(ctx.getErrorCode() == NO_ERROR)
			    this.getCntgrp().getUsrlst().add(inr,lgnnam,oprnam,usrflg);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			log.debug("{}","usrlst Size = "+this.getCntgrp().getUsrlst().fullSize());
		}




}