package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.AuthenVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Txmmod;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Audgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 公共证实交易
*/
@Transaction(vo= AuthenVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Authen extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Authen.class);

        //$trnstm
        private IStream trnstm = new StreamImpl();
        //ptyinr
        private String ptyinr;
        //trnstm1
        private IStream trnstm1 = new StreamImpl();
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private ModuleList<Spt> sptlist;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Spt wrkspt;

		@BDGetter
		private Audgrp audgrp;

		@BDGetter
		private Txmmod rgtclu;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bedgrp bedgrp;


		public Authen()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getRgtclu().setTxmgrpHolder(new FieldConstantHolder<>("cfmclu"));
           this.getRgtclu().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Authen.this.getFieldPath("audgrp.aud.content");}
 				public void setValue(String arg){Authen.this.getAudgrp().getAud().setContent(arg);}
 				public String getValue(){return Authen.this.getAudgrp().getAud().getContent();}}
			 );
        }

        /**
        *   source:authen.@0000.script
        */
        @Rule(target="btnmod.submit",order=100)
        public boolean ruleBtnmodSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!accessRight())
			  return false;
			ctx.getDaoSession().dbBegin();
			this.getTrnmod().sigWrite("O","0");
			if(this.getSysmod().sptIsLoaded("B") || this.getSysmod().sptIsLoaded("P"))
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",this.getSysmod().getSpt().getScrtxt()));
			  if("B".equals(this.getTrnmod().getTrn().getSta()))
			  {
			    this.getTrnmod().getTrn().setSta("W");
			    ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			  }
			  else
			    trnSave();
			}
			else
			  trnSave();
			//save dsp file
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}","save apply file");
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),this.getAudgrp().getAud().getTyp(),"PDF");
			log.info("{}","data0 size" +data.size());
			String path=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/temp"),this.getTrnmod().getTrn().getInr().substring(0,4));
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			log.info("{}","path=" +data.size());
			String clsNam = "com.brilliance.swift.SwiftPacker";
			MdaUtils.invoke(clsNam,"saveDataToFile",data,path,this.getTrnmod().getTrn().getInr()+".app");
			setNoticeEntry();
			this.getTrnmod().getTrn().setOriinr(this.getWrkspt().getInr());
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			//save trndat
			String grptyp=this.getSysmod().getSpt().getObjtyp();
			if(!MdaUtils.isEmpty(grptyp))
			{
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			  IStream is=this.getTrnstm();
			  MdaUtils.saveData(mod,is);
			  MdaUtils.saveData(this.getAudgrp(),is);
			  if("bpd".equals(grptyp))
			  {
			    MdaUtils.saveData(this.getAfdgrp(),is);
			  }
			  this.getSysmod().streamSaveInSubdir(is,"trndata/"+this.getTrnmod().getTrn().getInr().substring(0,4),this.getTrnmod().getTrn().getInr()+".dat");
			}
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			{
			  this.getSysmod().getSpt().setSta("U");
			  this.getSysmod().getSpt().setScrpty(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setOprogninr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setPtyinr(this.getSysmod().getPty().getInr());
			  ctx.getDaoSession().dbUpdate(this.getSysmod().getSpt());
			}
			ctx.getDaoSession().dbCommit();
			MdaUtils.clear(this.getWrkspt());
			MdaUtils.clear(this.getSysmod().getSpt());
			ctx.setMessage(MdaUtils.getI18NString("authen","CT000082"),MdaUtils.getI18NString("authen","CT000083"));
			

			return true;
        }

        /**
        *   source:authen.@0001.script
        */
        @Rule(target="btnmod.search",order=0)
        public boolean ruleBtnmodSearchN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:authen.@0004.script
        */
        @Rule(target="btnmod.pend",order=100)
        public boolean ruleBtnmodPendN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!accessRight())
			  return false;
			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			{
			  this.getSysmod().getSpt().setSta("P");
			  this.getSysmod().getSpt().setPtyinr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setOprogninr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setOwnref(this.getAudgrp().getAud().getOwnref());
			  this.getSysmod().getSpt().setFrm("authen");
			  this.getSysmod().getSpt().setScr("I");
			  this.getSysmod().getSpt().setObjnam(MdaUtils.getI18NString("authen","CT000026"));
			  this.getSysmod().getSpt().setDattim(new Date());
			  this.getSysmod().getSpt().setInr(Platform.sdbCounter("spt"));
			  ctx.getDaoSession().dbInsert(this.getSysmod().getSpt());
			}
			else
			{

			  this.getSysmod().getSpt().setSta("P");
			  //if(!Platform.isEmpty($trnmod\\smh\\inr))
			  this.getSysmod().getSpt().setPtyinr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setOprogninr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getSpt().setScr("I");
			  this.getSysmod().getSpt().setDattim(new Date());
			  this.getSysmod().getSpt().setFrm("authen");
			  ctx.getDaoSession().dbUpdate(this.getSysmod().getSpt());
			}
			ctx.getDaoSession().dbCommit();
			IStream os=this.getTrnstm();
			String grptyp=this.getSysmod().getSpt().getObjtyp();
			//String modpath=Platform.getModuleType($rec)+"grp";
			MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp"),os);
			if("bpd".equals(grptyp))
			{
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),"afdgrp"),os);
			}
			MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),"audgrp"),os);
			//$sysmod.streamSaveInSubdir(os,$sysmod\\spt\\inr.getValue(),"bak");
			String filename = this.getSysmod().createFilename(this.getSysmod().getSpt().getInr(),"bak");
			MdaUtils.streamSave(os,filename);
			MdaUtils.clear(this.getSysmod().getSpt());
			

			return true;
        }

        /**
        *   source:authen.@0005.script
        */
        @Rule(target="btnmod.ok",order=100)
        public boolean ruleBtnmodOkN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  this.getAudgrp().getAud().setOwnref(this.getSptlist().getElement(index).getOwnref());
			  String subpty=this.getSptlist().getElement(index).getScrpty();
			  String clientid=this.getTrnmod().getCidFromInr(subpty);
			  String nam=this.getTrnmod().getPtyName(subpty);
			  this.getAudgrp().getAud().setClientid(clientid);
			  this.getAudgrp().getAud().setClientnam(nam);
			}
			
			
			
			

			return true;
        }

        /**
        *   source:authen.@0008.script
        */
        @Rule(target="audgrp.aud.typ",order=100)
        public boolean ruleAudgrpAudTypN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getAudgrp().getAud().setContent(NULLSTR);
			
			this.getRgtclu().setClstyp(this.getAudgrp().getAud().getTyp());
			
			/*
			  String typ = $audgrp\\aud\\typ.getValue();
			  log.info("typ="+typ );
			  /*
			  if("irfadv".equals(typ))
			  {
			  //load the date form database
			  $audgrp\\aud\\content.setValue("Such Written Demand Should Be Reached Our Bank Within The Validity Of This Tender Guarantee.");
			  }
			  else if("fxtdav".equals(typ))
			  {
			  //load the date form database
			  $audgrp\\aud\\content.setValue("fxtopn");
			  }
			  else
			  {
			  //load the date form database
			  $audgrp\\aud\\content.setValue("fxropn");
			  }
			  */
			/*
			  $audgrp\\aud\\content.setValue(getCfmCls(typ));
			  Platform.setModified($audgrp\\aud\\content);
			  */

			return true;
        }

        /**
        *   source:authen.@0009.script
        */
        @Rule(target="btnmod.msg",order=100)
        public boolean ruleBtnmodMsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  @@展示证实书
			  */
			IStream ms=this.getBtnmod().getMsg();
			if(MdaUtils.isEmpty(this.getAudgrp().getAud().getTyp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("authen","CT000106"),MdaUtils.getI18NString("authen","CT000107"));
			  log.debug("{}","typ is null return" );
			  return false;
			}
			String trn = this.getAudgrp().getAud().getTyp();
			log.info("{}","trn="+trn );
			//arg1:perportiese  arg2: arg3:pdfFile arf4:stream
			this.getSysmod().getPdfmod().genePdfByTrn(trn,"",trn,ms,false);

			return true;
        }

        /**
        *   source:authen.@0018.script
        */
        @Rule(target="btnmod.attach",order=100)
        public boolean ruleBtnmodAttachN100(){
            IContext ctx = MdaEnv.getContext();
            
			//popup mail panel
			this.getBtnmod().setSender("cdm@cib.com.cn");
			
			
			//generate PDF from app file
			this.getBtnmod().setAthnam(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			String trnnam=this.getAudgrp().getAud().getTyp();
			creatApplyPdfFile(trnnam+"App"+inr,trnnam);
			this.getBtnmod().setAthnam(trnnam+"App"+inr+".pdf");

			return true;
        }

        /**
        *   source:authen.@0021.script
        */
        @Rule(target="btnmod.sndmail",order=100)
        public boolean ruleBtnmodSndmailN100(){
            IContext ctx = MdaEnv.getContext();
            
			String mailadr=this.getBtnmod().getRecver();
			if(MdaUtils.isEmpty(mailadr))
			{
			  return false;
			}
			String[] mailadrs=mailadr.split("[,;]");
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			String attnames = this.getBtnmod().getAthnam();
			log.debug("{}","send mail attnam="+attnames);
			if(ctx.absGet(Sysmod.class).aplSendMail(mailadrs,attnames.split(";"),filepath,this.getBtnmod().getTitle(),this.getBtnmod().getContent()))
			{
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("authen","CT000131"),MdaUtils.getI18NString("authen","CT000132"));
			}

			return true;
        }

        /**
        *   source:authen.@0022.script
        */
        @Rule(target="btnmod.apldoc",order=100)
        public boolean ruleBtnmodApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream ms=this.getBtnmod().getApldoc();
			if(MdaUtils.isEmpty(this.getAudgrp().getAud().getTyp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("authen","CT000137"),MdaUtils.getI18NString("authen","CT000138"));
			  log.debug("{}","typ is null return" );
			  return false;
			}
			String trn = this.getAudgrp().getAud().getTyp();
			log.info("{}","trn="+trn );
			//arg1:perportiese  arg2: arg3:pdfFile arf4:stream
			this.getSysmod().getPdfmod().genePdfByTrn(trn,"",trn,ms,false);

			return true;
        }



        /**
        *   source:authen.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getAudgrp().getAud().setDate(MdaUtils.today());
			MdaUtils.setValues(this.getAudgrp().getAud(),"typ",MdaUtils.getCodetable("cfctyp"));

			return true;
        }

        /**
        *   source:authen.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getSysmod().sptIsLoaded("Z"))
			{
			  log.info("{}","spt inr="+this.getSysmod().getSpt().getInr());
			  String subpty=this.getSysmod().getSpt().getScrpty();
			  this.getAudgrp().getAud().setOwnref(ctx.absGet(Sysmod.class).getSpt().getOwnref());
			  String trnname=this.getSysmod().getSpt().getFrm();
			  //loadDataByOwnref(trnname);
			  String clientid=this.getTrnmod().getCidFromInr(subpty);
			  String nam=this.getTrnmod().getPtyName(subpty);
			  this.getAudgrp().getAud().setClientid(clientid);
			  this.getAudgrp().getAud().setClientnam(nam);
			  //load data from file
			
			  String grptyp=this.getSysmod().getSpt().getObjtyp();
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			  MdaUtils.clear(mod);
			  // 20150311 MOD BY DG
			  //String path=Platform.catPath(Platform.getRootPath(),"data/trndata");
			  //String filename=Platform.catPath(path,$sysmod\\spt\\scrtxt.getValue()+".dat");
			  String filename = ctx.absGet(Sysmod.class).createFilename(this.getSysmod().getSpt().getScrtxt(),"dat");
			  if(!MdaUtils.fileExists(filename))
			    return true;
			  IStream is=this.getTrnstm();
			  MdaUtils.streamLoad(is,filename);
			  MdaUtils.loadData(mod,is);
			  if("bpd".equals(grptyp))
			  {
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),"afdgrp"),is);
			  }

			  //....
			  IDatafield advdat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\advdat");
			  advdat.setValue(MdaUtils.today());
			  IDatafield opndat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\opndat");
			  opndat.setValue(MdaUtils.today());
			}
			else if(this.getSysmod().sptIsLoaded("P"))
			{
			  String grptyp=this.getSysmod().getSpt().getObjtyp();
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			  MdaUtils.clear(mod);
			  //String path=Platform.catPath(Platform.getRootPath(),"data/delete");
			  //String filename=Platform.catPath(path,$sysmod\\spt\\inr.getValue()+".bak");
			  String filename = this.getSysmod().createFilename(this.getSysmod().getSpt().getInr(),"bak");
			  if(!MdaUtils.fileExists(filename))
			    return true;
			  IStream is=this.getTrnstm();
			  MdaUtils.streamLoad(is,filename);
			  MdaUtils.loadData(mod,is);
			  if("bpd".equals(grptyp))
			  {
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),"afdgrp"),is);
			  }
			  MdaUtils.loadData(this.getAudgrp(),is);
			  //....
			  IDatafield advdat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\advdat");
			  advdat.setValue(MdaUtils.today());
			  IDatafield opndat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\opndat");
			  opndat.setValue(MdaUtils.today());
			}
			else if(this.getSysmod().sptIsLoaded("B"))
			{
			  String grptyp=this.getSysmod().getSpt().getObjtyp();
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			  MdaUtils.clear(mod);
			  // 20150311 MOD BY DG
			  //String path=Platform.catPath(Platform.getRootPath(),"data/trndata");
			  //String filename=Platform.catPath(path,$sysmod\\spt\\scrtxt.getValue()+".dat");
			  String filename = ctx.absGet(Sysmod.class).createFilename(this.getSysmod().getSpt().getScrtxt(),"dat");
			  if(!MdaUtils.fileExists(filename))
			    return true;
			  IStream is=this.getTrnstm();
			  MdaUtils.streamLoad(is,filename);
			  MdaUtils.loadData(mod,is);
			  MdaUtils.loadData(this.getAudgrp(),is);
			  if("bpd".equals(grptyp))
			  {
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),"afdgrp"),is);
			  }

			  IDatafield advdat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\advdat");
			  advdat.setValue(MdaUtils.today());
			  IDatafield opndat=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\opndat");
			  opndat.setValue(MdaUtils.today());
			}
			else
			{
			  if("Y".equals(this.getSysmod().getSig()))
			    this.getAudgrp().getAud().setNewitem("Y");
			  log.info("{}","flag="+this.getAudgrp().getAud().getNewitem());
			}
			
			
			

			return true;
        }


        /**
        *   source:authen.@0010.script
        */
        public void loadDataByOwnref(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:authen.@0011.script
        */
        public void setNoticeEntry()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","setNoticeEntry..." );
			String docpath=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),this.getTrnmod().getTrn().getInr().substring(0,4));
			String file=MdaUtils.catPath(docpath,this.getTrnmod().getTrn().getInr()+".app");
			if(MdaUtils.fileExists(file))
			{
			  this.getTrnmod().getSmh().setXmlfil(this.getTrnmod().getTrn().getInr()+".app");
			  this.getTrnmod().getSmh().setDocpth(docpath);
			  this.getTrnmod().getSmh().setOrdinr(this.getTrnmod().getTrn().getOrdinr());
			  this.getTrnmod().getSmh().setObjtyp("spt");
			  this.getTrnmod().getSmh().setDir("I");
			  this.getTrnmod().getSmh().setCreusr(this.getSysmod().getUsr().getInr());
			  this.getTrnmod().getSmh().setCredattim(new Date());
			  this.getTrnmod().getSmh().setMsgtyp("1");
			  this.getTrnmod().getSmh().setMsgsta("1");
			  this.getTrnmod().getSmh().setInr(Platform.sdbCounter("smh"));
			  this.getSysmod().sdbInsert(this.getTrnmod().getSmh());
			  this.getWrkspt().setSmhinr(this.getTrnmod().getSmh().getInr());
			}
			else
			  log.info("{}","the attachment is missing!");
			// $wrkspt\\ptyinr.setValue($trnmod\\trn\\subptyinr.getValue());
			this.getWrkspt().setPtyinr( this.getTrnmod().getTrn().getPtyinr());
			this.getWrkspt().setOprogninr(this.getSysmod().getPty().getInr());
			this.getWrkspt().setSta("W");
			this.getWrkspt().setScr("A");
			this.getWrkspt().setDattim(MdaUtils.today());
			this.getWrkspt().setOwnref(this.getTrnmod().getTrn().getOwnref());
			this.getWrkspt().setOrdinr(this.getTrnmod().getTrn().getOrdinr());
			this.getWrkspt().setObjnam("银行证实通知");
			this.getWrkspt().setObjtyp(this.getSysmod().getSpt().getObjtyp());
			String tmpstr=this.getSysmod().getSpt().getFrm();
			log.info("{}","inifrm="+tmpstr+",is new?"+this.getAudgrp().getAud().getNewitem());
			if(!MdaUtils.isEmpty(tmpstr))
			{
			  String nfrm=getAdvFrm(tmpstr.toLowerCase());
			  log.info("{}","nfrm="+nfrm);
			  if(!MdaUtils.isEmpty(nfrm))
			    this.getWrkspt().setFrm(nfrm);
			  else
			    this.getWrkspt().setFrm(this.getAudgrp().getAud().getTyp());
			}
			else if("Y".equals(this.getAudgrp().getAud().getNewitem()))
			{
			  log.info("{}","frm="+this.getAudgrp().getAud().getTyp());
			  this.getWrkspt().setFrm(this.getAudgrp().getAud().getTyp());
			  String obj=getAdvFrmObj(this.getAudgrp().getAud().getTyp());
			  log.info("{}","obj="+obj);
			  this.getWrkspt().setObjtyp(obj);
			  if(!MdaUtils.isEmpty(this.getPtyinr()))
			    this.getWrkspt().setPtyinr(this.getPtyinr());
			  else
			  {
			    String ptyinr=this.getTrnmod().getPtyFromCid(this.getAudgrp().getAud().getClientid(),new String[]{"1","2"});
			    this.getWrkspt().setPtyinr(ptyinr);
			  }
			}

			this.getWrkspt().setInr(Platform.sdbCounter("spt"));
			this.getSysmod().sdbInsert(this.getWrkspt());
			log.info("{}","create notice spt ok...inr="+this.getWrkspt().getInr());
			//copy file
			IStream is=this.getTrnstm();
			MdaUtils.streamClear(is);
			String grptyp=this.getSysmod().getSpt().getObjtyp();
			if(!MdaUtils.isEmpty(grptyp))
			{
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			  MdaUtils.saveData(mod,is);
			  if("bpd".equals(grptyp))
			  {
			    MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),"afdgrp"),is);
			  }
			  this.getSysmod().streamSaveInSubdir(is,this.getWrkspt().getInr(),"bak");
			}
			else
			{
			  grptyp=this.getWrkspt().getObjtyp();
			  log.info("{}","grptyp="+grptyp);
			}
		}
        /**
        *   source:authen.@0012.script
        */
        public String getAdvFrm(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("irfopn".equals(frm))
			{
			  return "irfadv";
			}
			if("fxtopn".equals(frm))
			{
			  return "fxtadv";
			}
			if("fxropn".equals(frm))
			{
			  return "fxradv";
			}
			if("fxtfre".equals(frm))
			{
			  return "fxffdv";
			}
			if("irfopm".equals(frm))
			{
			  return "irfadv";
			}
			if("fxfsll".equals(frm))
			{
			  return "fxfsdv";
			}
			if("fxfbuy".equals(frm))
			{
			  return "fxfbdv";
			}
			if("fncfre".equals(frm))
			{
			  return "fncadv";
			}
			return null;
		}
        /**
        *   source:authen.@0014.script
        */
        public String getCfmCls(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> txt=new Argument<String>("clstxt");
			String sql="SELECT clstxt FROM cls WHERE flg='4' AND typ='"+typ+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(txt);
			String cls = null;
			if(ctx.getErrorCode()==NO_ERROR)
			  cls =  txt.value;
			else
			  ctx.setMessage(MdaUtils.getI18NString("authen","CT000092"),MdaUtils.getI18NString("authen","CT000093"));
			ctx.getDaoSession().dbCloseCursor();
			return cls;
		}
        /**
        *   source:authen.@0015.script
        */
        public String getAdvFrmObj(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("irfadv".equals(frm))
			{
			  return "apd";
			}
			if("fxtadv".equals(frm))
			{
			  return "fcd";
			}
			if("fxradv".equals(frm))
			{
			  return "fcd";
			}
			if("fxfsdv".equals(frm))
			{
			  return "fcd";
			}
			if("fxfbdv".equals(frm))
			{
			  return "fcd";
			}
			if("fxfsds".equals(frm))
			{
			  return "fcd";
			}
			if("fxfbds".equals(frm))
			{
			  return "fcd";
			}
			if("fncadv".equals(frm))
			{
			  return "bpd";
			}
			if("fxtfre".equals(frm))
			{
			  return "fcd";
			}
			if("irfopm".equals(frm))
			{
			  return "apd";
			}
			return null;
		}
        /**
        *   source:authen.@0017.script
        */
        public boolean accessRight()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String logusrinr=this.getSysmod().getUsr().getInr();
			Argument<String> trn =new Argument<String>("trn");
			/*
			  String query="SELECT e.frm trn FROM usr a,usrrol b,rolpro d,modlst e WHERE "+
			  "b.usrinr=a.inr AND b.rolinr=d.rolinr AND d.frminr=e.inr AND e.ptytyp='0' AND"+
			  " a.inr='"+logusrinr+"' AND e.frm='combus'";
			  */
			String query="SELECT d.frminr trn FROM usr a,usrrol b,rol c,rolpro d WHERE b.usrinr=a.inr AND b.rolinr=c.inr AND b.rolinr=d.rolinr AND a.inr='"+logusrinr+"' AND trim(d.frminr)='combus'";
			ctx.getDaoSession().dbExecuteSQL(query);
			ctx.getDaoSession().dbFetchFields(trn);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_MORE_ROW)
			{
			  ctx.setMessage(MdaUtils.getI18NString("authen","CT000104"),MdaUtils.getI18NString("authen","CT000105"));
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}
        /**
        *   source:authen.@0020.script
        */
        public void creatApplyPdfFile(String filnam,String pdfTpl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//copy from mtabut,and modified Line2
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),pdfTpl,"PDF");
			String tplfile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfTpl+".pdf");
			String logofile = ctx.absGet(Sysmod.class).getEtyLgnUrl(null);
			log.info("{}","logofile="+logofile +"\ttplfile="+tplfile);
			String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			log.info("{}","path="+pdfPath);
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","createApplyPdfFile",filnam,pdfPath,tplfile,data,logofile);
		}
        /**
        *   source:authen.@0023.script
        */
        public void trnSave()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getTrn().setRelres("O");
			this.getTrnmod().getTrn().setRelreq("OA");
			this.getTrnmod().getTrn().setNxtreq("A");
			this.getTrnmod().getTrn().setNxtlev("1");
			this.getTrnmod().getTrn().setObjtyp("spt");
			this.getTrnmod().getTrn().setObjinr(this.getSysmod().getSpt().getInr());
			this.getTrnmod().getTrn().setObjnam(this.getSysmod().getSpt().getObjnam());
			this.getTrnmod().getTrn().setOrdinr(this.getSysmod().getSpt().getOrdinr());
			this.getTrnmod().getTrn().setPtyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setOwnref(this.getAudgrp().getAud().getOwnref());
			this.getTrnmod().getTrn().setNxtlev("1");
			this.getTrnmod().getTrn().setIniusr(this.getSysmod().getUsr().getInr());
			this.getTrnmod().getTrn().setInifrm(this.getAudgrp().getAud().getTyp());
			this.getTrnmod().getTrn().setInidattim(MdaUtils.today());
			this.getTrnmod().getTrn().setCfmdattim(MdaUtils.today());
			this.getTrnmod().getTrn().setOptptyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setEtyinr(this.getSysmod().getEty().getInr());
			this.getTrnmod().getTrn().setEtginr(this.getSysmod().getEtg().getInr());
			this.getTrnmod().getTrn().setBchcod(this.getSysmod().getPty().getCid());
			this.getTrnmod().getTrn().setOptetyinr(this.getSysmod().getEty().getInr());
			this.getTrnmod().getTrn().setOptetginr(this.getSysmod().getEtg().getInr());
			this.getTrnmod().getTrn().setSta("W");
			// $trnmod\\trn\\subptyinr.setValue($sysmod\\spt\\scrpty.getValue());
			this.getTrnmod().getTrn().setNam(this.getAudgrp().getAud().getTyp());
			this.getTrnmod().getTrn().setInr(Platform.sdbCounter("trn"));
			//$trnmod\\trn\\wfdinr.setValue($sysmod\\spt\\inr.getValue());
			ctx.getDaoSession().dbInsert(this.getTrnmod().getTrn());
		}
















}