package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BctacpVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Bctmod;
import com.ceb.gjjs.mda.manager.module.Wghmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Radgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代收承兑/付款/拒付
*/
@Transaction(vo= BctacpVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctacp extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctacp.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctmod bctmod;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Radgrp radgrp;

		@BDGetter
		private Wghmod wghmod;


		public Bctacp()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBctmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctmod().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getMtabut().setRecHolder(()->this.getBcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("IC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bctacp.this.getBcdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bctacp.this.getBcdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Bctacp.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bctacp.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.doccur");}
 				public void setValue(String arg){Bctacp.this.getBcdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bctacp.this.getBcdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.inr");}
 				public void setValue(String arg){Bctacp.this.getBcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bctacp.this.getBcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.ownref");}
 				public void setValue(String arg){Bctacp.this.getBcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bctacp.this.getBcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bctacp.this.getBcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bctacp.this.getBcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctacp.this.getFieldPath("bcdgrp.rec.stlref");}
 				public void setValue(String arg){Bctacp.this.getBcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bctacp.this.getBcdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bctacp.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getBcdgrp()) && ctx.checkAll(this.getAfdgrp())))
			{
			  return false;
			}
			//押汇校验
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			{
			  return false;
			}
			//代付校验
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			{
			  return false;
			}
			//售汇校验
			if("BCTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			{
			  if(!ctx.checkAll(this.getBctp().getFpdgrp()))
			  {
			    return false;
			  }
			}
			//网银购汇校验
			if(MdaUtils.isEmpty(this.getBcdgrp().getRec().getWyghedno())&&"2".equals(this.getBcdgrp().getRec().getZjly()))
			{
			  ctx.setMessage("E9999","资金来源填写有误，请重新勾选");
			  this.getBcdgrp().getRec().setZjly(NULLSTR);
			  
			  return false;
			}
			//if(!(Platform.checkAll($bcdgrp) && Platform.checkAll($afdgrp)&& Platform.checkAll($apdgrp\\rec)))
			//return false;
			this.dealpdf();

			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bcd");
			this.getAfdgrp().getRec().setObjinr(this.getBcdgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("2");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()))
			{
			  this.getTrdgrp().getRec().setInr(Platform.sdbCounter("trd"));
			  this.getTrdgrp().getRec().setAdvdat(this.getBcdgrp().getRec().getAdvdat());
			  this.getTrdgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());
			  this.getTrdgrp().getRec().setConnum(this.getBcdgrp().getRec().getConno());
			  this.getTrdgrp().getRec().setCredat(this.getAfdgrp().getRec().getCredat());
			  this.getTrdgrp().getRec().setEtyinr("00000000");
			  this.getTrdgrp().getRec().setPnttyp("bcd");
			  this.getTrdgrp().getRec().setPntinr(this.getBcdgrp().getRec().getInr());
			  this.getTrdgrp().getRec().setFintyp("1");
			  this.getTrdgrp().getRec().setPntref(this.getBcdgrp().getRec().getOwnref());
			  this.getTrdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			  ctx.getDaoSession().dbInsert(this.getTrdgrp().getRec());
			  /*if($\\sysmod.sptIsLoaded("B"))
			    {
			    Platform.dbRead($trdgrp\\rec,new Argument<String>("pntref",$bcdgrp\\rec\\ownref.getValue()));
			    Platform.dbUpdate($trdgrp\\rec);
			    }
			    else
			    {
			
			    }*/
			}
			else
			  log.info("{}","没有选择押汇");
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()))
			{
			  this.getApdgrp().getRec().setInr(Platform.sdbCounter("apd"));
			  this.getApdgrp().getRec().setPnttyp("bcd");
			  this.getApdgrp().getRec().setPntinr(this.getBcdgrp().getRec().getInr());
			  this.getApdgrp().getRec().setAdvdat(this.getBcdgrp().getRec().getAdvdat());
			  this.getApdgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());
			  this.getApdgrp().getRec().setConnum(this.getBcdgrp().getRec().getConno());
			  this.getApdgrp().getRec().setCredat(this.getAfdgrp().getRec().getCredat());
			  this.getApdgrp().getRec().setEtyinr("00000000");
			  this.getApdgrp().getRec().setAmt(this.getBcdgrp().getRec().getDocamt());
			  this.getApdgrp().getRec().setCur(this.getBcdgrp().getRec().getDoccur());
			  this.getApdgrp().getRec().setPtyinr(this.getBcdgrp().getRec().getPtyinr());
			  this.getApdgrp().getRec().setFintyp("1");
			  this.getApdgrp().getRec().setPntref(this.getBcdgrp().getRec().getOwnref());
			  this.getApdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			  ctx.getDaoSession().dbInsert(this.getApdgrp().getRec());
			  /*if($\\sysmod.sptIsLoaded("B"))
			    {
			    Platform.dbRead($apdgrp\\rec,new Argument<String>("pntinr",$bcdgrp\\rec\\inr.getValue()));
			    Platform.dbUpdate($apdgrp\\rec);
			    }
			    else
			    {
			
			    }*/
			}
			else
			  log.info("{}","没有选择同业代付");

			ctx.getDaoSession().dbUpdate(this.getBcdgrp().getRec());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());

			//购汇数据入库
			if("BCTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B") && !MdaUtils.isEmpty(this.getBctp().getFpdgrp().getRec().getInr()))
			    ctx.getDaoSession().dbUpdate(this.getBctp().getFpdgrp().getRec());
			  else
			  {
			    this.getBctp().getFpdgrp().getRec().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			    this.getBctp().getFpdgrp().getRec().setObjfrm(ctx.getTransName());
			    this.getBctp().getFpdgrp().getRec().setObjinr(this.getBcdgrp().getRec().getInr());
			    this.getBctp().getFpdgrp().getRec().setInr(Platform.sdbCounter("fpd"));
			    ctx.getDaoSession().dbInsert(this.getBctp().getFpdgrp().getRec());
			  }
			}

			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			//Platform.saveDisplay($bctp\\nbctp02,filename);
			IPanel[] panels=this.getBctp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );


			return true;
        }

        /**
        *   source:bctacp.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			this.getBctp().getPdfviw().callPDFComponent("","bctacp","对外付款/承兑通知书",1);

			return true;
        }

        /**
        *   source:bctacp.@0004.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String val=this.getAfdgrp().getRec().getOprtyp();
			// log.debug("in evt afdgrp.rec.oprtyp ... opttyp " + $afdgrp\\rec\\oprtyp.getValue());
			// $this.setSubPanelByOprtyp($afdgrp\\rec\\oprtyp.getValue());
			
			if("BCTSET".equals(val))
			{
			  this.getBctp().setTranspanel(this.getBctp().getBctp13());
			  
			  this.getAfdgrp().getRec().setOprval(NULLSTR);
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			  
			  
			  

			  
			}
			else     //清除购汇界面
			{
			  String steps = "0:进口代收承兑/付款/拒付申请";
			  
			  
			  

			  this.getBctp().getStpmod().setPages(steps);
			  this.getBctp().getStpmod().calcSteps();
			  this.getBctp().getStpmod().setStepBtnSta();
			}

			if("BCTACC".equals(val))
			{
			  this.getBctp().setTranspanel(this.getBctp().getBctp12());
			  
			  this.getAfdgrp().getRec().setOprval(NULLSTR);
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			  
			  
			  
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getTrn(),new Argument<String>("ownref",this.getBcdgrp().getRec().getOwnref()),new Argument<String>("inifrm","bctdav"),new Argument<String>("modtyp","1"));
			  String ordinr = ctx.absGet(Trnmod.class).getTrn().getOrdinr();
			  this.getBtnmod().initDocumentButton(ordinr);

			  

			  if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFxflg()))
			  {
			    this.getBctp().getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			    
			    
			    
			    this.getBctp().getBcdgrp().getRec().setFxact(NULLSTR);
			    
			    
			    
			    
			    
			  }

			  if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getPurflg()))
			  {
			    this.getBctp().getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			    
			    
			    
			    this.getBctp().getBcdgrp().getRec().setPuract(NULLSTR);
			    
			    
			    
			    
			    
			  }
			  if(TRUE.equals(this.getBcdgrp().getRec().getOthflg()))
			  {
			    this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			    
			    
			    
			    this.getBcdgrp().getRec().setOthact(NULLSTR);
			    
			    
			    
			    
			    
			  }

			  //付款界面内容
			  this.getBcdgrp().getRec().setFxflg(NULLSTR);
			  this.getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setFxact(NULLSTR);
			  this.getBcdgrp().getRec().setPurflg(NULLSTR);
			  this.getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setPuract(NULLSTR);
			  this.getBcdgrp().getRec().setOthflg(NULLSTR);
			  this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setOthact(NULLSTR);
			  this.getBcdgrp().getRec().setFhflg(NULLSTR);
			  this.getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getTrdgrp().getRec().setCur(NULLSTR);
			  this.getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getTrdgrp().getRec().setOpndat(null);
			  this.getBctp().getTrdgrp().getRec().setWord(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getTrdgrp().getRec().setTrodat(null);
			  this.getTrdgrp().getRec().setActrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setIntrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setArrrar(NULLSTR);
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			  this.getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			  this.getTrdgrp().getRec().setOcaltp(NULLSTR);
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBcdgrp().getRec().setDfflg(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  this.getApdgrp().getRec().setConnam(NULLSTR);
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  this.getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  this.getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getApdgrp().getRec().setAccact(NULLSTR);
			  this.getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setPayexpdat(0);
			  this.getApdgrp().getRec().setMatdat(null);
			  this.getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBcdgrp().getRec().setZjly(NULLSTR);
			  this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("BCTDOR".equals(val))
			{
			  this.getBctp().setTranspanel(this.getBctp().getBctp11());
			  
			  
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			  
			  
			  
			  //承兑界面内容
			
			  //付款界面内容
			  if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFxflg()))
			  {
			    this.getBctp().getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			    
			    
			    
			    this.getBctp().getBcdgrp().getRec().setFxact(NULLSTR);
			    
			    
			    
			    
			    
			  }

			  if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getPurflg()))
			  {
			    this.getBctp().getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			    
			    
			    
			    this.getBctp().getBcdgrp().getRec().setPuract(NULLSTR);
			    
			    
			    
			    
			    
			  }
			  if(TRUE.equals(this.getBcdgrp().getRec().getOthflg()))
			  {
			    this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			    
			    
			    
			    this.getBcdgrp().getRec().setOthact(NULLSTR);
			    
			    
			    
			    
			    
			  }

			  this.getBcdgrp().getRec().setFxflg(NULLSTR);
			  this.getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setFxact(NULLSTR);
			  this.getBcdgrp().getRec().setPurflg(NULLSTR);
			  this.getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setPuract(NULLSTR);
			  this.getBcdgrp().getRec().setOthflg(NULLSTR);
			  this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			  this.getBcdgrp().getRec().setOthact(NULLSTR);
			  this.getBcdgrp().getRec().setFhflg(NULLSTR);
			  this.getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getTrdgrp().getRec().setCur(NULLSTR);
			  this.getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getTrdgrp().getRec().setOpndat(null);
			  this.getBctp().getTrdgrp().getRec().setWord(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getTrdgrp().getRec().setTrodat(null);
			  this.getTrdgrp().getRec().setActrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setIntrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setArrrar(NULLSTR);
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			  this.getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			  this.getTrdgrp().getRec().setOcaltp(NULLSTR);
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBcdgrp().getRec().setDfflg(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  this.getApdgrp().getRec().setConnam(NULLSTR);
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  this.getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  this.getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getApdgrp().getRec().setAccact(NULLSTR);
			  this.getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setPayexpdat(0);
			  this.getApdgrp().getRec().setMatdat(null);
			  this.getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBcdgrp().getRec().setZjly(NULLSTR);
			  this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0006.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:bctacp.@0008.script
        */
        @Rule(target="bctp.actcancel",order=100)
        public boolean ruleBctpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:bctacp.@0009.script
        */
        @Rule(target="bctp.actsurel",order=100)
        public boolean ruleBctpActsurelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getBctp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000033"),MdaUtils.getI18NString("bctacp","CT000034"));
			  return true;
			}
			if("fx".equals(this.getBctp().getActchsflg()))
			{
			  this.getBcdgrp().getRec().setFxact(this.getBctp().getActlst().getElement(index).getAct());
			  
			}
			else if("pur".equals(this.getBctp().getActchsflg()))
			{
			  this.getBcdgrp().getRec().setPuract(this.getBctp().getActlst().getElement(index).getAct());
			  
			  ctx.postRule(this,"bcdgrp.rec.puract");
			}
			else if("oth".equals(this.getBctp().getActchsflg()))
			{
			  this.getBcdgrp().getRec().setOthact(this.getBctp().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0015.script
        */
        @Rule(target="bcdgrp.rec.fxamt",order=100)
        public boolean ruleBcdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBcdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBcdgrp().getRec().setFxamt(amt);
			


			return true;
        }

        /**
        *   source:bctacp.@0016.script
        */
        @Rule(target="bcdgrp.rec.othamt",order=100)
        public boolean ruleBcdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBcdgrp().getRec().getOthamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBcdgrp().getRec().setOthamt(amt);
			


			return true;
        }

        /**
        *   source:bctacp.@0017.script
        */
        @Rule(target="bcdgrp.rec.puramt",order=100)
        public boolean ruleBcdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBcdgrp().getRec().getPuramt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBcdgrp().getRec().setPuramt(amt);

			if("BCTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			{
			  this.getBctp().getFpdgrp().setCur(this.getBctp().getCur1());
			  this.getBctp().getFpdgrp().setAmt(this.getBcdgrp().getRec().getPuramt());
			  if(!TRUE.equals(this.getBctp().getFpdgrp().getRec().getCnnsel()))
			  {
			    this.getBctp().getFpdgrp().getRec().setOutcur(this.getBctp().getCur1());
			    this.getBctp().getFpdgrp().getRec().setOutamt(this.getBcdgrp().getRec().getPuramt());
			    
			    
			    
			  }
			  else
			    ctx.postRule(this,"bctp.fpdgrp.rec.cnnsel");

			  
			  
			}
			


			return true;
        }

        /**
        *   source:bctacp.@0018.script
        */
        @Rule(target="bctp.fxbut",order=100)
        public boolean ruleBctpFxbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().setActchsflg( "fx");
			this.getBctp().popupActchs();

			return true;
        }

        /**
        *   source:bctacp.@0019.script
        */
        @Rule(target="bctp.othbut",order=100)
        public boolean ruleBctpOthbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().setActchsflg( "oth");
			this.getBctp().popupActchs();

			return true;
        }

        /**
        *   source:bctacp.@0020.script
        */
        @Rule(target="bctp.purbut",order=100)
        public boolean ruleBctpPurbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().setActchsflg( "pur");
			this.getBctp().popupActchs();

			return true;
        }

        /**
        *   source:bctacp.@0021.script
        */
        @Rule(target="bctp.trdgrp.rec.arrrar",order=100)
        public boolean ruleBctpTrdgrpRecArrrarN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0022.script
        */
        @Rule(target="bctp.trdgrp.rec.caltyp",order=100)
        public boolean ruleBctpTrdgrpRecCaltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			}
			else if("3".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			
			


			return true;
        }

        /**
        *   source:bctacp.@0023.script
        */
        @Rule(target="bctp.trdgrp.rec.ocaltp",order=100)
        public boolean ruleBctpTrdgrpRecOcaltpN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getTrdgrp().getRec().getOcaltp()))
			{
			  
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0029.script
        */
        @Rule(target="bctp.pdftrd",order=100)
        public boolean ruleBctpPdftrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealpdf();
			this.getBctp().getPdfviw().callPDFComponent("","bctacpfh","押汇申请",1);

			return true;
        }

        /**
        *   source:bctacp.@0030.script
        */
        @Rule(target="bctp.pdfdfd",order=100)
        public boolean ruleBctpPdfdfdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().getPdfviw().callPDFComponent("","bctacpdf","同业代付申请",1);

			return true;
        }

        /**
        *   source:bctacp.@0031.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 0;
			String labels = "";
			String tempfiles = "";

			log.info("{}","初始cnt="+cnt);
			/*  if(!Platform.isEmpty($bcdgrp\\rec\\fxflg))
			  {
			  // cnt+=1;
			  // labels+="购汇申请书";
			  // tempfiles+="A:bctacpgh";
			  }*/
			if(!MdaUtils.isEmpty(this.getBcdgrp().getRec().getFhflg()))
			{
			  if(cnt!=0)
			  {
			    labels+=",进口代收押汇申请书";
			    tempfiles+=",A:bctacpfh";
			  }
			  else
			  {
			    labels+="进口代收押汇申请书";
			    tempfiles+="A:bctacpfh";
			  }
			  cnt+=1;
			  log.info("{}","押汇内cnt="+cnt);
			}
			if(!MdaUtils.isEmpty(this.getBcdgrp().getRec().getDfflg()))
			{
			  if(cnt!=0)
			  {
			    labels+=",进口代收同业代付申请书";
			    tempfiles+=",A:bctacpdf";
			  }
			  else
			  {
			    labels+="进口代收同业代付申请书";
			    tempfiles+="A:bctacpdf";
			  }
			  cnt+=1;
			  log.info("{}","代付内cnt="+cnt);
			}

			if("BCTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			{
			  if(cnt!=0)
			  {
			    labels += ",即期售汇申请书";
			    tempfiles += ",A:fptapn";
			  }
			  else
			  {
			    labels += "即期售汇申请书";
			    tempfiles += "A:fptapn";
			  }
			  cnt += 1;
			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:bctacp.@0036.script
        */
        @Rule(target="bctp.apdgrp.rec.lxchfs",order=100)
        public boolean ruleBctpApdgrpRecLxchfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tmp1 = this.getApdgrp().getRec().getLxchfs();
			this.getBctp().setJxfs(MdaUtils.getCodetableLabel("jxfs",tmp1));
			

			return true;
        }

        /**
        *   source:bctacp.@0041.script
        */
        @Rule(target="bctp.trdgrp.rec.trodat",order=100)
        public boolean ruleBctpTrdgrpRecTrodatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBcdgrp().getRec().getDfflg()))
			{
			  this.getApdgrp().getRec().setMatdat(this.getTrdgrp().getRec().getTrodat());
			  
			  
			}
			

			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat())&&!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			{
			  //SimpleDateFormat format = new java.text.SimpleDateFormat("yyyy-MM-dd");
			  Date date1 = this.getTrdgrp().getRec().getOpndat();
			  Date date2 = this.getTrdgrp().getRec().getTrodat();

			  long lday = (date2.getTime()-date1.getTime())/(24*60*60*1000);
			  this.getTrdgrp().getRec().setSubday(""+(int)lday);
			}
			else
			{
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			}
			
			//之前颠倒顺序填写的时候弹出报错，未能重现，因申请书展示需要，故注释
			/*if(!Platform.isEmpty($trdgrp\\rec\\opndat)&&!Platform.isEmpty($bctp\\subday))
			  {
			  Platform.clear($trdgrp\\rec\\opndat);
			  Platform.clear($bctp\\subday);
			
			  Platform.setModified($trdgrp\\rec\\opndat);
			  Platform.setModified($bctp\\subday);
			  }*/

			return true;
        }

        /**
        *   source:bctacp.@0052.script
        */
        @Rule(target="bcdgrp.rec.purflg",order=100)
        public boolean ruleBcdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			StringBuffer stepsB = new StringBuffer();
			String steps= "";
			steps = steps+stepsB.append("0:进口代付承兑/付款/拒付申请");

			String val=this.getAfdgrp().getRec().getOprtyp();
			if("BCTSET".equals(val))
			{
			  if(TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			  {
			    steps =steps+stepsB.append(";1:购汇申请");
			    

			    //初始化售汇界面
			    this.getBctp().getFpdgrp().getRec().setCredat(MdaUtils.today());
			    if(!MdaUtils.isEmpty(this.getBctp().getFpdgrp().getRec().getCredat()))
			    {
			      
			      
			    }
			    if(MdaUtils.isEmpty(this.getBctp().getFpdgrp().getRec().getGivnam()))
			      this.getBctp().getFpdgrp().getRec().setGivnam(this.getSysmod().getPty().getNam());

			    if(MdaUtils.isEmpty(this.getBctp().getFpdgrp().getRec().getOprnam()))
			      this.getBctp().getFpdgrp().getRec().setOprnam(this.getSysmod().getUsr().getOprnam());

			    if(MdaUtils.isEmpty(this.getBctp().getFpdgrp().getRec().getTel()))
			      this.getBctp().getFpdgrp().getRec().setTel(this.getSysmod().getUsr().getTel());

			    
			    
			    

			  }
			  else
			  {
			    
			  }
			}
			
			
			this.getBctp().getStpmod().setPages(steps);
			this.getBctp().getStpmod().calcSteps();
			this.getBctp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:bctacp.@0053.script
        */
        @Rule(target="bcdgrp.rec.puract",order=100)
        public boolean ruleBcdgrpRecPuractN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBcdgrp().getRec().getPuract()))
			{
			  if("BCTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			  {
			    this.getBctp().getFpdgrp().getRec().setCnycno(this.getBcdgrp().getRec().getPuract());
			    
			    
			  }
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0054.script
        */
        @Rule(target="bctp.stpmod.gostep",order=10)
        public boolean ruleBctpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            

			int curIdx=this.getBctp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getBctp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000101"),MdaUtils.getI18NString("bctacp","CT000102"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!(ctx.checkAll(this.getBcdgrp()) && ctx.checkAll(this.getAfdgrp())))
			    {
			      return false;
			    }
			    //押汇校验
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			    {
			      return false;
			    }
			    //代付校验
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    this.getBctp().getFpdgrp().setCur(this.getBctp().getCur1());
			    this.getBctp().getFpdgrp().setAmt(this.getBcdgrp().getRec().getPuramt());
			    
			    
			    this.getBctp().getFpdgrp().setMessage();
			    return true;
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getBctp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","gostep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:bctacp.@0055.script
        */
        @Rule(target="bctp.stpmod.next",order=10)
        public boolean ruleBctpStpmodNextN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getBctp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getBctp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000105"),MdaUtils.getI18NString("bctacp","CT000106"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!(ctx.checkAll(this.getBcdgrp()) && ctx.checkAll(this.getAfdgrp())))
			    {
			      return false;
			    }
			    //押汇校验
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			    {
			      return false;
			    }
			    //代付校验
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    this.getBctp().getFpdgrp().setCur(this.getBctp().getCur1());
			    this.getBctp().getFpdgrp().setAmt(this.getBcdgrp().getRec().getPuramt());
			    
			    
			    this.getBctp().getFpdgrp().setMessage();
			    return true;
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getBctp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","next Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:bctacp.@0056.script
        */
        @Rule(target="bctp.fpdgrp.fpdpdf",order=100)
        public boolean ruleBctpFpdgrpFpdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt=MdaUtils.parseDecimal(MdaUtils.format(this.getBctp().getFpdgrp().getRec().getOutamt(),"#0.00"));
			this.getBctp().getFpdgrp().getRec().setOutamt(amt);
			
			this.getBctp().getPdfviw().callPDFComponent("","fptapn","即期售汇申请书",1);

			return true;
        }

        /**
        *   source:bctacp.@0057.script
        */
        @Rule(target="bctp.stpmod.last",order=10)
        public boolean ruleBctpStpmodLastN10(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getBctp().getFpdgrp()))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:bctacp.@0058.script
        */
        @Rule(target="bctp.trdgrp.rec.credittyp",order=100)
        public boolean ruleBctpTrdgrpRecCredittypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getBctp().getTrdgrp().getRec().getCredittyp()))
			{
			  //Platform.setRequired($bctp\\trdgrp\\rec\\cdno);
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setCdno(NULLSTR);
			  //Platform.setNotRequired($bctp\\trdgrp\\rec\\cdno);
			  
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0059.script
        */
        @Rule(target="bctp.trdgrp.rec.fcnytyp",order=100)
        public boolean ruleBctpTrdgrpRecFcnytypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("2".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("3".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  
			  

			  
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}

			
			
			
			

			return true;
        }

        /**
        *   source:bctacp.@0060.script
        */
        @Rule(target="bctp.trdgrp.rec.cnyltyp",order=100)
        public boolean ruleBctpTrdgrpRecCnyltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  //Platform.enable($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  

			  //Platform.setRequired($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsnum);
			  

			  this.getBctp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  
			  
			}
			else if("2".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  //Platform.enable($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  
			  

			  //Platform.setRequired($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsnum);
			  
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setLrldat(null);
			  this.getBctp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBctp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setTrunll(new BigDecimal(0));

			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
			

			Calendar cal1 =  Calendar.getInstance();
			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			{
			  cal1.setTime(this.getTrdgrp().getRec().getOpndat());
			}
			int day = cal1.get(Calendar.DAY_OF_MONTH);
			cal1.set(Calendar.DATE,20);
			if(day < 20)
			{
			  cal1.add(Calendar.MONTH,-1);
			}
			Date date1 = cal1.getTime();
			this.getTrdgrp().getRec().setLrldat(date1);
			

			return true;
        }

        /**
        *   source:bctacp.@0063.script
        */
        @Rule(target="bctp.trdgrp.rec.cur",order=100)
        public boolean ruleBctpTrdgrpRecCurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("CNY".equals(this.getBctp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  
			  
			}
			else if(!MdaUtils.isEmpty(this.getBctp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			
			

			ctx.postRule(this,"bctp.trdgrp.rec.cnyltyp");
			ctx.postRule(this,"bctp.trdgrp.rec.fcnytyp");

			return true;
        }

        /**
        *   source:bctacp.@0064.script
        */
        @Rule(target="trdgrp.querat",order=100)
        public boolean ruleTrdgrpQueratN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getCur()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000107"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrldat()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000108"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrltyp()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000109"));
			}
			String year = "" + this.getTrdgrp().getRec().getLrldat().getYear();
			year = "" + (Integer.parseInt(year) + 1900);
			String month =  "" + this.getTrdgrp().getRec().getLrldat().getMonth();
			month = "" + (Integer.parseInt(month) + 1);
			String cur = this.getTrdgrp().getRec().getCur();

			log.info("{}","querat:  year = " + Integer.parseInt(year) + " month = " + month + " cur = " + cur);
			ctx.getDaoSession().dbRead(this.getRadgrp().getRat(),new Argument<Integer>("year",Integer.parseInt(year)),new Argument<String>("month",month),new Argument<String>("cur",cur));

			if("0".equals(this.getTrdgrp().getRec().getLrltyp())&&MdaUtils.isEmpty(this.getRadgrp().getRat().getOyrate()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000110"));
			}
			else if("1".equals(this.getTrdgrp().getRec().getLrltyp())&&MdaUtils.isEmpty(this.getRadgrp().getRat().getFyrate()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000111"));
			}

			if("0".equals(this.getTrdgrp().getRec().getLrltyp()))
			{
			  this.getTrdgrp().getRec().setLrlrat(this.getRadgrp().getRat().getOyrate());
			}
			else if("1".equals(this.getTrdgrp().getRec().getLrltyp()))
			{
			  this.getTrdgrp().getRec().setLrlrat(this.getRadgrp().getRat().getFyrate());
			}
			else
			{
			  this.getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:bctacp.@0065.script
        */
        @Rule(target="trdgrp.sumrat",order=100)
        public boolean ruleTrdgrpSumratN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($trdgrp\\rec\\bpsas.getValue()))
			  {
			  Platform.error($trdgrp\\querat,#CT000112);
			  Platform.clear($trdgrp\\rec\\trunll);
			  return;
			  }
			  if(Platform.isEmpty($trdgrp\\rec\\bpsnum.getValue()))
			  {
			  Platform.error($trdgrp\\querat,#CT000113);
			  Platform.clear($trdgrp\\rec\\trunll);
			  return;
			  }*/
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrldat()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("bctacp","CT000114"));
			  this.getTrdgrp().getRec().setTrunll(new BigDecimal(0));
			  return true;
			}

			BigDecimal lrlrat = this.getTrdgrp().getRec().getLrlrat();
			BigDecimal bpsnum = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getBpsnum(),"#0.0000"));
			bpsnum = bpsnum.multiply(new BigDecimal("0.01"));
			BigDecimal rate =new BigDecimal("0.00000");

			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getBpsas())||MdaUtils.isEmpty(this.getTrdgrp().getRec().getBpsnum()))
			{
			  rate = this.getTrdgrp().getRec().getLrlrat();
			}
			else
			{
			  if("0".equals(this.getTrdgrp().getRec().getBpsas()))
			  {
			    rate = lrlrat.add(bpsnum);
			  }
			  else
			  {
			    rate = lrlrat.subtract(bpsnum);
			  }
			}

			this.getTrdgrp().getRec().setTrunll(MdaUtils.parseDecimal(MdaUtils.format(rate,"#0.000000")));
			

			return true;
        }

        /**
        *   source:bctacp.@0066.script
        */
        @Rule(target="bctp.trdgrp.rec.opndat",order=100)
        public boolean ruleBctpTrdgrpRecOpndatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat())&&!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			{
			  //SimpleDateFormat format = new java.text.SimpleDateFormat("yyyy-MM-dd");
			  Date date1 = this.getTrdgrp().getRec().getOpndat();
			  Date date2 = this.getTrdgrp().getRec().getTrodat();

			  long lday = (date2.getTime()-date1.getTime())/(24*60*60*1000);
			  this.getTrdgrp().getRec().setSubday(""+(int)lday);
			}
			else
			{
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			}
			

			//市场利率查询日期
			if("CNY".equals(this.getTrdgrp().getRec().getCur()))
			{
			  Calendar cal1 =  Calendar.getInstance();
			  if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			  {
			    cal1.setTime(this.getTrdgrp().getRec().getOpndat());
			  }
			  int day = cal1.get(Calendar.DAY_OF_MONTH);
			  cal1.set(Calendar.DATE,20);
			  if(day < 20)
			  {
			    cal1.add(Calendar.MONTH,-1);
			  }
			  Date date1 = cal1.getTime();
			  this.getTrdgrp().getRec().setLrldat(date1);
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0067.script
        */
        @Rule(target="bctp.trdgrp.rec.trunll",order=100)
        public boolean ruleBctpTrdgrpRecTrunllN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBctp().getTrdgrp().getRec().getTrunll()))
			{
			  ctx.setFieldError(this,"bctp.trdgrp.rec.trunll",MdaUtils.getI18NString("bctacp","CT000115"));
			}

			return true;
        }

        /**
        *   source:bctacp.@0085.script
        */
        @Rule(target="bctp.bcdgrp.rec.zjly",order=100)
        public boolean ruleBctpBcdgrpRecZjlyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getWghmod().getShslst());
			if(MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("提示","请先选择归属机构");
			  return false;
			}
			String cid=this.getSysmod().getUsr().getCid();
			String bchcod=this.getAfdgrp().getRec().getBchcod();
			String caocur = this.getBcdgrp().getRec().getCaocur();
			MdaUtils.clear(this.getWghmod().getShslst());
			//查询pty
			String ptysql = "select inr,lvl from pty where cid = '"+bchcod+"'";
			Argument<String> inrs = new Argument<String>("inr");
			Argument<String> lvls = new Argument<String>("lvl");
			String inr="";
			String lvl="";
			ctx.getDaoSession().dbExecuteSQL(ptysql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inrs,lvls);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    inr = inrs.getValue();
			    lvl = lvls.getValue();
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			List argVal = new ArrayList();
			String sql="select businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag from shs where  jiehsign !='1' and havegwfed > 0 and applystatus ='3' ";
			sql = sql + " and ecifno = '"+cid+"'";
			sql = sql + " and currency = '"+caocur+"'";
			//机构隔离
			//分行--可以查看分行及分行以下机构的额度
			if("1".equals(lvl))
			{
			  sql = sql + " AND (bchcod in (select cid from pty where pntinr=bchcod) or bchcod= '"+bchcod+"' ) ";
			}
			//支行--可以查看分本支行的额度
			if("2".equals(lvl))
			{
			  sql = sql + " AND orginr= '"+inr+"' ";
			}
			sql = sql + " order by zcghdat asc";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			Argument<String> businessno = new Argument<String>("businessno");
			Argument<Date> applydat = new Argument<Date>("applydat");
			Argument<String> currency = new Argument<String>("currency");
			Argument<BigDecimal> havesale = new Argument<BigDecimal>("havesale");
			Argument<BigDecimal> havegwfed = new Argument<BigDecimal>("havegwfed");
			Argument<String> applystatus = new Argument<String>("applystatus");
			Argument<Date> zcghnewdat = new Argument<Date>("zcghnewdat");
			Argument<String> lockflag = new Argument<String>("lockflag");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getWghmod().getShslst().add(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			for(int i=0;i<this.getWghmod().getShslst().size();i++)
			{
			  ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),new Argument("edbusno",this.getWghmod().getShslst().getElement(i).getBusinessno()),new Argument("deleted","0"));
			  if(this.getWghmod().getShdlst().fullSize()>0)
			  {
			    StringBuffer str = new StringBuffer();
			    for(int j=0;j<this.getWghmod().getShdlst().fullSize();j++)
			    {
			      str.append(this.getWghmod().getShdlst().getElement(j).getBillnewno()+",");
			    }
			    if(!MdaUtils.isEmpty(str.toString()))
			    {
			      int len = str.toString().length();
			      this.getWghmod().getShslst().getElement(i).setRemark((str.toString()).substring(0,len - 1));
			    }
			  }
			}
			if("2".equals(this.getBctp().getBcdgrp().getRec().getZjly()))
			{
			  if(this.getWghmod().getShslst().size()>0)
			  {
			    
			    
			  }
			  else
			  {
			    ctx.setMessage("提示","没有符合条件网银购汇额度,请核实！");
			    this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			    this.getBcdgrp().getRec().setZjly("1");
			  }
			}
			else
			{
			  if(this.getWghmod().getShslst().size()>0)
			  {
			    if(MdaUtils.prompt("提示","已存在已购未付金额，是否使用"))
			    {
			      this.getBcdgrp().getRec().setZjly("1");
			      
			      this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			      
			      MdaUtils.clear(this.getWghmod().getShslst());
			      return false;
			    }
			    this.getBcdgrp().getRec().setZjly("2");
			    
			    
			  }
			  this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			}
			
			
			

			return true;
        }

        /**
        *   source:bctacp.@0090.script
        */
        @Rule(target="wghmod.choose",order=100)
        public boolean ruleWghmodChooseN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getWghmod().getShslst().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000125"),MdaUtils.getI18NString("bctacp","CT000126"));
			  return true;
			}
			String flg=this.getWghmod().getShslst().getElement(index).getLockflag();
			if("0".equals(flg))
			{
			  ctx.setMessage("提示","该笔额度已被锁定，请到国结解锁或选择其他额度");
			  return true;
			}

			String businessno=this.getWghmod().getShslst().getElement(index).getBusinessno();
			String rmbfkzh=this.getWghmod().getShslst().getElement(index).getDuifzh();
			this.getBcdgrp().getRec().setWyghedno(businessno);
			boolean ghcheckflg=ghcheck();
			if(!ghcheckflg)
			{
			  return true;
			}
			if(!fqdlstSearch(rmbfkzh,businessno))
			{
			  return false;
			}
			MdaUtils.clear(this.getWghmod().getShs());
			ctx.getDaoSession().dbRead(this.getWghmod().getShs(),new Argument<String>("businessno",businessno));
			
			
			

			return true;
        }

        /**
        *   source:bctacp.@0091.script
        */
        @Rule(target="wghmod.canel",order=100)
        public boolean ruleWghmodCanelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBcdgrp().getRec().setZjly("1");
			
			this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			MdaUtils.clear(this.getWghmod().getShslst());
			

			return true;
        }

        /**
        *   source:bctacp.@0093.script
        */
        @Rule(target="afdgrp.rec.bchcod",order=100)
        public boolean ruleAfdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().getBcdgrp().getRec().setZjly(NULLSTR);
			this.getBctp().getBcdgrp().getRec().setWyghedno(NULLSTR);
			
			

			return true;
        }


        /**
        *   source:bctacp.@0010.script
        */
        @Check(target="bctp.bcdgrp.rec.fxflg",order=100)
        public boolean checkBctpBcdgrpRecFxflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFxflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBctp().getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			  
			  
			  
			  this.getBctp().getBcdgrp().getRec().setFxact(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0011.script
        */
        @Check(target="bctp.bcdgrp.rec.purflg",order=100)
        public boolean checkBctpBcdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getPurflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBctp().getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			  
			  
			  
			  this.getBctp().getBcdgrp().getRec().setPuract(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0012.script
        */
        @Check(target="bctp.bcdgrp.rec.othflg",order=100)
        public boolean checkBctpBcdgrpRecOthflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBcdgrp().getRec().getOthflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			  
			  
			  
			  this.getBcdgrp().getRec().setOthact(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0013.script
        */
        @Check(target="bctp.bcdgrp.rec.fhflg",order=100)
        public boolean checkBctpBcdgrpRecFhflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  this.getTrdgrp().getRec().setOpndat(MdaUtils.today());
			  

			  //从维护的银行协议编号中取贸易融资综合协议编号
			  this.getBctp().getAgrp().qurAgrnum();
			  this.getTrdgrp().getRec().setFtfinancing(this.getBctp().getAgrp().getTfn());
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCur(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setOpndat(null);
			  this.getBctp().getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setTrodat(null);
			  this.getBctp().getTrdgrp().getRec().setFtfinancing(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCredittyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCdno(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  this.getBctp().getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBctp().setWord(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setLrldat(null);
			  this.getBctp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBctp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setOthrat(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setRatday(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setOthtyp(NULLSTR);

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  this.getBcdgrp().getRec().setDfflg(NULLSTR);
			  

			  

			  this.getBctp().getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setFintyp(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayexpdat(0);
			  this.getBctp().getApdgrp().getRec().setColref(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setDoctypcod(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayref(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setOpndat(null);
			  this.getBctp().getApdgrp().getRec().setMatdat(null);
			  this.getBctp().getApdgrp().setAplnam(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setConnam(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setAccact(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getBcdgrp().getRmi().getPts().setExtkey(NULLSTR);
			  this.getBcdgrp().getRmi().getPts().setAdrblk(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:bctacp.@0014.script
        */
        @Check(target="bctp.bcdgrp.rec.dfflg",order=100)
        public boolean checkBctpBcdgrpRecDfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBctp().getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setFintyp(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayexpdat(0);
			  this.getBctp().getApdgrp().getRec().setColref(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setDoctypcod(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setPayref(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setOpndat(null);
			  this.getBctp().getApdgrp().getRec().setMatdat(null);
			  this.getBctp().getApdgrp().setAplnam(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getBctp().getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setConnam(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setAccact(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getBcdgrp().getRmi().getPts().setExtkey(NULLSTR);
			  this.getBcdgrp().getRmi().getPts().setAdrblk(NULLSTR);
			  this.getBctp().getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0024.script
        */
        @Check(target="bctp.bcdgrp.rec.docamt",order=100)
        public boolean checkBctpBcdgrpRecDocamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//由于校验规则的变更，此处校验逻辑移至索赔金额下
			/*Boolean fxflg = TRUE.equals($bctp\\bcdgrp\\rec\\fxflg.getValue());
			  Boolean purflg = TRUE.equals($bctp\\bcdgrp\\rec\\purflg.getValue());
			  Boolean othflg = TRUE.equals($bctp\\bcdgrp\\rec\\othflg.getValue());
			  Boolean fhflg = TRUE.equals($bctp\\bcdgrp\\rec\\fhflg.getValue());
			  checkSumAmt(fxflg,purflg,othflg,fhflg);*/

			return true;
        }

        /**
        *   source:bctacp.@0026.script
        */
        @Check(target="bctp.afdgrp.rec.oprtyp",order=100)
        public boolean checkBctpAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			/* if(!Platform.isEmpty($afdgrp\\rec\\oprtyp)
			  &&"BCTDOR".equals($afdgrp\\rec\\oprtyp.getValue()))
			  {
			  Platform.visible($bctp\\rejectlabel);
			  Platform.visible($afdgrp\\rec\\oprval);
			  }
			  else
			  {
			  Platform.invisible($bctp\\rejectlabel);
			  Platform.invisible($afdgrp\\rec\\oprval);
			  }*/

			return true;
        }

        /**
        *   source:bctacp.@0027.script
        */
        @Check(target="bctp.trdgrp.rec.arrnum",order=100)
        public boolean checkBctpTrdgrpRecArrnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBctp().setArrnum1(this.getTrdgrp().getRec().getArrnum());
			  
			}
			else if ("2".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBctp().setArrnum2(this.getTrdgrp().getRec().getArrnum());
			  
			}
			else if ("3".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBctp().setArrnum3(this.getTrdgrp().getRec().getArrnum());
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0033.script
        */
        @Check(target="bctp.subday",order=100)
        public boolean checkBctpSubdayN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if(MdaUtils.isEmpty(this.getBctp().getSubday()))
			{
			  return true;
			}
			else
			{
			  int d1 = MdaUtils.parseInt(this.getBctp().getSubday());
			  this.getTrdgrp().getRec().setTrodat(MdaUtils.add(this.getTrdgrp().getRec().getOpndat(),d1));
			}
			
			ctx.postRule(this,"trdgrp.rec.trodat");

			return true;
        }

        /**
        *   source:bctacp.@0037.script
        */
        @Check(target="bctp.trdgrp.rec.amt",order=100)
        public boolean checkBctpTrdgrpRecAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBcdgrp().getRec().getCaoamt())||MdaUtils.isEmpty(this.getTrdgrp().getRec().getAmt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBcdgrp().getRec().getCaoamt();
			BigDecimal lamt = this.getTrdgrp().getRec().getAmt();
			if((this.getBcdgrp().getRec().getCaocur()==this.getTrdgrp().getRec().getCur())&&lamt.compareTo(camt)>0)
			{
			  ctx.setFieldError(this,"trdgrp.rec.amt",MdaUtils.getI18NString("bctacp","CT000067"));
			  this.getTrdgrp().getRec().setAmt(this.getBcdgrp().getRec().getCaoamt());
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0038.script
        */
        @Check(target="bctp.apdgrp.rec.payamt",order=100)
        public boolean checkBctpApdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBcdgrp().getRec().getCaoamt())||MdaUtils.isEmpty(this.getApdgrp().getRec().getPayamt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBcdgrp().getRec().getCaoamt();
			BigDecimal lamt = this.getApdgrp().getRec().getPayamt();
			BigDecimal yamt = this.getTrdgrp().getRec().getAmt();

			if((this.getApdgrp().getRec().getPaycur()==this.getTrdgrp().getRec().getCur())&&lamt.compareTo(yamt)>0)
			{
			  ctx.setFieldError(this,"apdgrp.rec.payamt",MdaUtils.getI18NString("bctacp","CT000072"));
			  this.getApdgrp().getRec().setPayamt(this.getTrdgrp().getRec().getAmt());
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0039.script
        */
        @Check(target="bctp.bcdgrp.rec.caoamt",order=100)
        public boolean checkBctpBcdgrpRecCaoamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			Boolean fxflg = TRUE.equals(this.getBctp().getBcdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getBctp().getBcdgrp().getRec().getPurflg());
			Boolean othflg = TRUE.equals(this.getBctp().getBcdgrp().getRec().getOthflg());
			Boolean fhflg = TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg());
			checkSumAmt(fxflg,purflg,othflg,fhflg);
			if(MdaUtils.isEmpty(this.getBcdgrp().getRec().getCaoamt())||MdaUtils.isEmpty(this.getBcdgrp().getRec().getDocamt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBcdgrp().getRec().getDocamt();
			BigDecimal lamt = this.getBcdgrp().getRec().getCaoamt();
			if(lamt.compareTo(camt)>0)
			{
			  ctx.setFieldError(this,"bcdgrp.rec.caoamt",MdaUtils.getI18NString("bctacp","CT000078"));
			  this.getBcdgrp().getRec().setCaoamt(this.getBcdgrp().getRec().getDocamt());
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0042.script
        */
        @Check(target="bctp.apdgrp.rec.matdat",order=100)
        public boolean checkBctpApdgrpRecMatdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBcdgrp().getRec().getFhflg()))
			{
			  this.getTrdgrp().getRec().setTrodat(this.getApdgrp().getRec().getMatdat());
			  
			}

			return true;
        }

        /**
        *   source:bctacp.@0049.script
        */
        @Check(target="bctp.trdgrp.rec.subday",order=100)
        public boolean checkBctpTrdgrpRecSubdayN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if(MdaUtils.isEmpty(this.getBctp().getTrdgrp().getRec().getSubday()))
			{
			  return true;
			}
			else
			{
			  int d1 = MdaUtils.parseInt(this.getBctp().getTrdgrp().getRec().getSubday());
			  int d2 = -d1;
			  if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			  {
			    this.getTrdgrp().getRec().setTrodat(MdaUtils.add(this.getTrdgrp().getRec().getOpndat(),d1));
			  }
			  else if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			  {
			    this.getTrdgrp().getRec().setOpndat(MdaUtils.add(this.getTrdgrp().getRec().getTrodat(),d2));
			  }
			}
			
			
			ctx.postRule(this,"trdgrp.rec.trodat");

			return true;
        }

        /**
        *   source:bctacp.@0069.script
        */
        @Check(target="bctp.bcdgrp.rec.caoamt",order=101)
        public boolean checkBctpBcdgrpRecCaoamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getBcdgrp().getRec(),"caoamt"));

			return true;
        }

        /**
        *   source:bctacp.@0070.script
        */
        @Check(target="bctp.bcdgrp.rec.fxamt",order=100)
        public boolean checkBctpBcdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getBcdgrp().getRec(),"fxamt"));

			return true;
        }

        /**
        *   source:bctacp.@0071.script
        */
        @Check(target="bctp.bcdgrp.rec.puramt",order=100)
        public boolean checkBctpBcdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getBcdgrp().getRec(),"puramt"));

			return true;
        }

        /**
        *   source:bctacp.@0072.script
        */
        @Check(target="bctp.bcdgrp.rec.othamt",order=100)
        public boolean checkBctpBcdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getBcdgrp().getRec(),"othamt"));

			return true;
        }

        /**
        *   source:bctacp.@0073.script
        */
        @Check(target="bctp.trdgrp.rec.amt",order=101)
        public boolean checkBctpTrdgrpRecAmtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"amt"));

			return true;
        }

        /**
        *   source:bctacp.@0074.script
        */
        @Check(target="bctp.apdgrp.rec.payamt",order=101)
        public boolean checkBctpApdgrpRecPayamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBctp().getApdgrp().getRec(),"payamt"));

			return true;
        }

        /**
        *   source:bctacp.@0075.script
        */
        @Check(target="bctp.trdgrp.rec.consrate",order=100)
        public boolean checkBctpTrdgrpRecConsrateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"consrate"));

			return true;
        }

        /**
        *   source:bctacp.@0076.script
        */
        @Check(target="bctp.trdgrp.rec.postedrate",order=100)
        public boolean checkBctpTrdgrpRecPostedrateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"postedrate"));

			return true;
        }

        /**
        *   source:bctacp.@0077.script
        */
        @Check(target="bctp.trdgrp.rec.basnum",order=100)
        public boolean checkBctpTrdgrpRecBasnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"basnum"));

			return true;
        }

        /**
        *   source:bctacp.@0078.script
        */
        @Check(target="bctp.trdgrp.rec.lrlrat",order=100)
        public boolean checkBctpTrdgrpRecLrlratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"lrlrat"));

			return true;
        }

        /**
        *   source:bctacp.@0079.script
        */
        @Check(target="bctp.trdgrp.rec.bpsnum",order=100)
        public boolean checkBctpTrdgrpRecBpsnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"bpsnum"));

			return true;
        }

        /**
        *   source:bctacp.@0080.script
        */
        @Check(target="bctp.trdgrp.rec.trunll",order=100)
        public boolean checkBctpTrdgrpRecTrunllN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"trunll"));

			return true;
        }

        /**
        *   source:bctacp.@0081.script
        */
        @Check(target="bctp.trdgrp.rec.disrat",order=100)
        public boolean checkBctpTrdgrpRecDisratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"disrat"));

			return true;
        }

        /**
        *   source:bctacp.@0082.script
        */
        @Check(target="bctp.trdgrp.rec.subday",order=110)
        public boolean checkBctpTrdgrpRecSubdayN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getBctp().getTrdgrp().getRec(),"subday"));

			return true;
        }

        /**
        *   source:bctacp.@0083.script
        */
        @Check(target="bctp.apdgrp.rec.payexpdat",order=100)
        public boolean checkBctpApdgrpRecPayexpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBctp().getApdgrp().getRec(),"payexpdat"));

			return true;
        }


        /**
        *   source:bctacp.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.showReadTet();
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBctp().setRejectlabel(MdaUtils.getI18NString("bctacp","CT000015"));
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("doctyps"));
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			}
			this.getBcdgrp().getApl().getPty().setNam(this.getSysmod().getPty().getNam());
			
			//  Platform.setRequired($bcdgrp\\rec\\fxact);
			IModule bcd = (IModule)ctx.restoreData("com.brilliance.bctacp.ref");
			if(!MdaUtils.isEmpty(bcd))
			  this.getBcdgrp().getRec().copyValue(bcd);

			this.getBcdgrp().getRec().setCaocur(this.getBcdgrp().getRec().getDoccur());
			this.getBctp().setTranspanel(this.getBctp().getBctp13());
			this.getBctp().setRejectlabel(MdaUtils.getI18NString("bctacp","CT000052"));
			

			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if((ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P"))&& !MdaUtils.isEmpty(this.getBcdgrp().getRec().getCaocur()))
			  {
			    //针对承兑，退回，暂存情况下承兑中预览信息做了优化
			
			    String sql = "SELECT ordinr FROM trn WHERE objtyp = 'bcd' AND modtyp = '1' AND inifrm = 'bctdav' AND ownref = '"+this.getBcdgrp().getRec().getOwnref()+"'";
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    log.info("{}","sql = "+sql);
			    Argument<String> ordinrtmp =new Argument<String>("ordinr");
			    ctx.getDaoSession().dbFetchFields(ordinrtmp);
			    String stlordinr = ordinrtmp.value;

			    log.info("{}","stlordinr = "+stlordinr);
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      log.info("{}","特殊情况判断：暂存/退回等");
			      MdaUtils.clear(this.getTrnmod().getApldoc().getPdfdoc());
			      this.getBtnmod().initDocumentButton(stlordinr);
			      
			      log.info("{}","pdfdoc.inr = "+this.getTrnmod().getApldoc().getPdfdoc().getInr());
			    }
			    else
			    {
			    }
			    ctx.getDaoSession().dbCloseCursor();
			    if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			    {
			      this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			    }

			    this.getBctp().setCur(this.getBcdgrp().getRec().getCaocur());
			    this.getBctp().setCur1(this.getBcdgrp().getRec().getCaocur());
			    this.getBctp().setCur2(this.getBcdgrp().getRec().getCaocur());
			    
			    
			    

			    //现汇判定
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFxflg()))
			    {
			      
			      
			      
			      
			      
			      
			      
			      
			    }
			    //购汇判定
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getPurflg()))
			    {
			      
			      
			      
			      
			      
			      
			      
			      
			    }
			    //它汇判定
			    if(TRUE.equals(this.getBcdgrp().getRec().getOthflg()))
			    {
			      
			      
			      
			      
			      
			      
			      
			      
			    }
			    //押汇判定
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()))
			    {
			      
			      
			      
			      
			      
			      
			      
			      
			      //Platform.enable($bctp\\trdgrp\\rec\\arrnum);
			      
			      
			      
			      
			      
			      
			      
			    }
			    //代付判定
			    if(TRUE.equals(this.getBctp().getBcdgrp().getRec().getDfflg()))
			    {
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      //Platform.enable($bctp\\apdgrp\\aplnam);
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			      
			    }

			    ctx.postRule(this,"afdgrp.rec.oprtyp");
			    ctx.postRule(this,"bcdgrp.rec.fxamt");
			    ctx.postRule(this,"bcdgrp.rec.othamt");
			    ctx.postRule(this,"bcdgrp.rec.puramt");
			    //Platform.postEventRule($bctp\\trdgrp\\rec\\arrrar,onChange,null);
			    if("1".equals(this.getTrdgrp().getRec().getArrrar()))
			    {
			      
			    }
			    else
			    {
			      
			    }
			    
			    ctx.postRule(this,"bctp.trdgrp.rec.caltyp");
			    ctx.postRule(this,"bctp.trdgrp.rec.ocaltp");
			  }

			  log.info("{}","特殊处理");
			  this.dealInit();
			  return true;
			}

			this.getBctp().setCur(this.getBcdgrp().getRec().getCaocur());
			this.getBctp().setCur1(this.getBcdgrp().getRec().getCaocur());
			this.getBctp().setCur2(this.getBcdgrp().getRec().getCaocur());
			this.getBcdgrp().getRec().setZjly(NULLSTR);
			this.getBcdgrp().getRec().setWyghedno(NULLSTR);
			this.getBcdgrp().getRec().setFxflg(NULLSTR);
			this.getBcdgrp().getRec().setPurflg(NULLSTR);
			this.getBcdgrp().getRec().setOthflg(NULLSTR);
			this.getBcdgrp().getRec().setFxamt(new BigDecimal(0));
			this.getBcdgrp().getRec().setFxact(NULLSTR);
			this.getBcdgrp().getRec().setPuramt(new BigDecimal(0));
			this.getBcdgrp().getRec().setPuract(NULLSTR);
			this.getBcdgrp().getRec().setOthamt(new BigDecimal(0));
			this.getBcdgrp().getRec().setOthact(NULLSTR);
			this.getBcdgrp().getRec().setFhflg(NULLSTR);
			this.getBcdgrp().getRec().setDfflg(NULLSTR);
			this.getBcdgrp().getRec().setCaoamt(new BigDecimal(0));
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			ctx.getDaoSession().dbRead(this.getBcdgrp().getDrr().getPts(),new Argument<String>("objinr",this.getBcdgrp().getRec().getInr()),new Argument<String>("objtyp","bcd"),new Argument<String>("rol","drr"));
			ctx.getDaoSession().dbRead(this.getBcdgrp().getDre().getPts(),new Argument<String>("objinr",this.getBcdgrp().getRec().getInr()),new Argument<String>("objtyp","bcd"),new Argument<String>("rol","dre"));
			ctx.getDaoSession().dbRead(this.getBcdgrp().getRmi().getPts(),new Argument<String>("objinr",this.getBcdgrp().getRec().getInr()),new Argument<String>("objtyp","bcd"),new Argument<String>("rol","rmi"));

			//承兑中预览信息所需
			
			String sql = "SELECT ordinr FROM trn WHERE objtyp = 'bcd' AND modtyp = '1' AND inifrm = 'bctdav' AND ownref = '"+this.getBcdgrp().getRec().getOwnref()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			log.info("{}","sql = "+sql);
			Argument<String> ordinrtmp =new Argument<String>("ordinr");
			ctx.getDaoSession().dbFetchFields(ordinrtmp);
			String stlordinr = ordinrtmp.value;

			log.info("{}","stlordinr = "+stlordinr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000092"),MdaUtils.getI18NString("bctacp","CT000093"));
			  this.getBtnmod().initDocumentButton(stlordinr);
			  MdaUtils.clear(this.getTrnmod().getApldoc().getPdfdoc());
			  
			  log.info("{}","pdfdoc.inr = "+this.getTrnmod().getApldoc().getPdfdoc().getInr());
			}
			else
			{
			}
			ctx.getDaoSession().dbCloseCursor();

			this.getBcdgrp().getRec().setCaocur(this.getBcdgrp().getRec().getDoccur());
			
			this.getBcdgrp().getRec().setFxflg("X");
			
			
			
			
			
			
			
			
			
			this.getAfdgrp().getRec().setOprtyp("BCTSET");
			
			//Platform.clear($bcdgrp\\rec\\ownref);
			BigDecimal amt = this.getBcdgrp().getRec().getDocamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBcdgrp().getRec().setDocamt(amt);
			
			//$afdgrp\\rec\\oprval.setValue("1");
			
			this.dealInit();

			return true;
        }

        /**
        *   source:bctacp.@0005.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    this.getAfdgrp().getRec().setBchcod(this.getBcdgrp().getRec().getBchcod());
			    
			  }
			  log.info("{}","bchcod="+this.getBcdgrp().getRec().getBchcod()+",bchcod="+this.getBcdgrp().getRec().getBchcod());
			}


			return true;
        }

        /**
        *   source:bctacp.@0051.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","bctsnd  init业务处理开始，order:90");
			//0、进口代收承兑/付款/拒付申请   1、购汇申请
			this.getBctp().getStpmod().storePanel(this.getBctp().getBcts1(),this.getBctp().getBcts2());
			String steps = "0:进口代收承兑/付款/拒付申请";
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  StringBuffer stepsB = new StringBuffer();
			  String stepss= "";
			  steps = stepss+stepsB.append("0:进口代收承兑/付款/拒付申请");

			  String val=this.getAfdgrp().getRec().getOprtyp();
			  if("BCTSET".equals(val))
			  {
			    if(TRUE.equals(this.getBcdgrp().getRec().getPurflg()))
			    {
			      steps =steps+stepsB.append(";1:购汇申请");
			      
			    }
			    else
			    {
			      
			    }
			  }
			}
			

			this.getBctp().getStpmod().setPages(steps);
			this.getBctp().getStpmod().calcSteps();
			this.getBctp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:bctacp.@0025.script
        */
        public void checkSumAmt(Boolean fxflg,Boolean purflg,Boolean othflg,Boolean fhflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","bctacp.docamtCheck start:");
			if(fxflg || purflg || othflg)
			{
			  BigDecimal sumamt = new BigDecimal("0");

			  if(fxflg)
			  {
			    sumamt = sumamt.add(this.getBcdgrp().getRec().getFxamt());
			    log.debug("{}","fxamt:" + this.getBcdgrp().getRec().getFxamt());
			    log.debug("{}","sumamt(fxamt):" + sumamt);
			  }
			  if(purflg)
			  {
			    sumamt = sumamt.add(this.getBcdgrp().getRec().getPuramt());
			    log.debug("{}","puramt:" + this.getBcdgrp().getRec().getPuramt());
			    log.debug("{}","sumamt(puramt):" + sumamt);
			  }
			  if(othflg)
			  {
			    sumamt = sumamt.add(this.getBcdgrp().getRec().getOthamt());
			    log.debug("{}","othamt:" + this.getBcdgrp().getRec().getOthamt());
			    log.debug("{}","sumamt(othamt):" + sumamt);
			  }
			  if(fhflg)
			  {
			    sumamt = sumamt.add(this.getTrdgrp().getRec().getAmt());
			    log.debug("{}","fhamt:" + this.getTrdgrp().getRec().getAmt());
			    log.debug("{}","sumamt(fhamt):" + sumamt);
			  }

			  if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getBcdgrp().getRec().getCaoamt()).compareTo(sumamt)!=0)
			    ctx.setFieldError(this,"bcdgrp.rec.caoamt",MdaUtils.getI18NString("bctacp","CT000056"));
			  log.debug("{}","caoamt:" + this.getBcdgrp().getRec().getCaoamt());
			  log.debug("{}","sumamt:" + sumamt);
			}
			log.debug("{}","bctacp.caoamtCheck end!");
		}
        /**
        *   source:bctacp.@0061.script
        */
        public void dealInit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//贸易融资授信协议编号
			//授信额度
			//利率其他约定
			if(!TRUE.equals(this.getBctp().getBcdgrp().getRec().getFhflg()))
			{
			  this.getBctp().getTrdgrp().getRec().setFtfinancing(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCredittyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setCdno(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setDisrat(new BigDecimal(0));

			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
			
			
			
			

			//风险授信额度
			if("2".equals(this.getBctp().getTrdgrp().getRec().getCredittyp()))
			{
			  //Platform.setRequired($bctp\\trdgrp\\rec\\cdno);
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setCdno(NULLSTR);
			  //Platform.setNotRequired($bctp\\trdgrp\\rec\\cdno);
			  
			}
			

			//押汇方式
			if("CNY".equals(this.getBctp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  
			  
			}
			else if(!MdaUtils.isEmpty(this.getBctp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  

			}
			
			

			//外币押汇方式
			if("1".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("2".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("3".equals(this.getBctp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  
			  

			  
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBctp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBctp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}

			
			
			
			

			//人民币押汇方式
			if("1".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  
			  //Platform.enable($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  
			  this.getBctp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  

			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsnum);
			  
			  
			}
			else if("2".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  
			  //Platform.enable($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  

			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($bctp\\trdgrp\\rec\\bpsnum);
			  
			}
			else
			{
			  this.getBctp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setLrldat(null);
			  this.getBctp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBctp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBctp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBctp().getTrdgrp().getRec().setTrunll(new BigDecimal(0));

			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
			
			
			//计收利息的方式
			if("2".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			}
			else if("3".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			
			
		}
        /**
        *   source:bctacp.@0062.script
        */
        public void dealpdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//lrlrat  trunll  consrate  postedrate  disrat
			BigDecimal rate = new BigDecimal("#0.000000");

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getLrlrat(),"#0.000000"));
			this.getTrdgrp().getRec().setLrlrat(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getTrunll(),"#0.000000"));
			this.getTrdgrp().getRec().setTrunll(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getConsrate(),"#0.000000"));
			this.getTrdgrp().getRec().setConsrate(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getPostedrate(),"#0.000000"));
			this.getTrdgrp().getRec().setPostedrate(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getDisrat(),"#0.000000"));
			this.getTrdgrp().getRec().setDisrat(rate);
			

			if("7".equals(this.getTrdgrp().getRec().getRatcycle()))
			{
			  this.getTrdgrp().setRatcyclend("√");
			}
			else
			{
			  this.getTrdgrp().setRatcyclend(NULLSTR);
			}

			//lcref=lidgrp\\\\rec\\\\stlref 信用证号码     rmipnam=brdgrp\\\\rmi\\\\pta\\\\nam 来单银行名称    ben=brdgrp\\\\ben\\\\pts\\\\adrblk 受益人
			
			//人民币押汇方式
			this.getBctp().getTrdgrp().setTrunll(NULLSTR);
			this.getBctp().getTrdgrp().setLrldat1(null);
			this.getBctp().getTrdgrp().setLrldat2(null);
			this.getBctp().getTrdgrp().setLrltyp(NULLSTR);
			this.getBctp().getTrdgrp().setLrlrat(NULLSTR);
			this.getBctp().getTrdgrp().setBpsas(NULLSTR);
			this.getBctp().getTrdgrp().setBpsnum(NULLSTR);

			StringBuffer trunll=new StringBuffer();
			StringBuffer lrltyp=new StringBuffer();
			StringBuffer lrlrat=new StringBuffer();
			StringBuffer bpsas=new StringBuffer();
			StringBuffer bpsnum=new StringBuffer();
			String conn = ",";
			String cc = null;
			BigDecimal bd = null;

			if("1".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  bd = this.getTrdgrp().getRec().getTrunll();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    trunll.append("");
			  else
			    trunll.append(bd);

			  cc = this.getBctp().getTrdgrp().getRec().getLrltyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="一年期";
			  else if("1".equals(cc))
			    cc="五年期";
			  lrltyp.append(cc).append(conn);

			  cc = this.getBctp().getTrdgrp().getRec().getLrlrat().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  lrlrat.append(cc).append(conn);

			  cc = this.getBctp().getTrdgrp().getRec().getBpsas();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="加";
			  else if("1".equals(cc))
			    cc="减";
			  bpsas.append(cc).append(conn);

			  cc = ""+this.getBctp().getTrdgrp().getRec().getBpsnum().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bpsnum.append(cc).append(conn);

			  this.getBctp().getTrdgrp().setLrldat1(this.getBctp().getTrdgrp().getRec().getLrldat());
			}
			else if("2".equals(this.getBctp().getTrdgrp().getRec().getCnyltyp()))
			{
			  bd = this.getTrdgrp().getRec().getTrunll();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    trunll.append("");
			  else
			    trunll.append(conn).append(bd);

			  cc = this.getBctp().getTrdgrp().getRec().getLrltyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="一年期";
			  else if("1".equals(cc))
			    cc="五年期";
			  lrltyp.append(conn).append(cc);

			  cc = this.getBctp().getTrdgrp().getRec().getLrlrat().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  lrlrat.append(conn).append(cc);

			  cc = this.getBctp().getTrdgrp().getRec().getBpsas();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="加";
			  else if("1".equals(cc))
			    cc="减";
			  bpsas.append(conn).append(cc);

			  cc = ""+this.getBctp().getTrdgrp().getRec().getBpsnum().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bpsnum.append(conn).append(cc);

			  this.getBctp().getTrdgrp().setLrldat2(this.getBctp().getTrdgrp().getRec().getLrldat());
			}

			this.getBctp().getTrdgrp().setTrunll(trunll.toString());
			this.getBctp().getTrdgrp().setLrltyp(lrltyp.toString());
			this.getBctp().getTrdgrp().setLrlrat(lrlrat.toString());
			this.getBctp().getTrdgrp().setBpsas(bpsas.toString());
			this.getBctp().getTrdgrp().setBpsnum(bpsnum.toString());
		}
        /**
        *   source:bctacp.@0068.script
        */
        public void showReadTet()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//外汇按金交易风险提示函
			String readtxt1=" 外汇按金交易风险提示函";
			readtxt1=readtxt1+CR;
			readtxt1=readtxt1+CR+"目前通过网络平台开展外汇按金交易未经批准；境内";
			readtxt1=readtxt1+CR+"个人跨境境外购房、直接进行跨境证券投资，相关外";
			readtxt1=readtxt1+CR+"汇业务属于资本项目项下业务，按照可兑换进程管理";
			readtxt1=readtxt1+CR+"，目前尚未明确开放。直接或间接开展、参与上述相";
			readtxt1=readtxt1+CR+"关外汇业务，涉嫌违规。请提高风险防范意识，谨防";
			readtxt1=readtxt1+CR+"财产损失。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"特此公告。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"中国光大银行";
			readtxt1=readtxt1+CR+"2019年3月27日";

			ctx.setMessage(MdaUtils.getI18NString("bctacp","CT000116"),readtxt1);

		}
        /**
        *   source:bctacp.@0088.script
        */
        public boolean getghref(String ghownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getWghmod().getShdlst());
			List argVal = new ArrayList();
			String sql=" where edbusno = ? and deleted = '0' order by inr  desc";
			argVal.add(ghownref);
			ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			return true;
		}
        /**
        *   source:bctacp.@0089.script
        */
        public boolean ghcheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*购汇额度校验*/
			if("2".equals(this.getBcdgrp().getRec().getZjly()))
			{
			  String ref=this.getBcdgrp().getRec().getWyghedno();
			  if(!getghref(ref))
			  {
			    return false;
			  }
			  int length=this.getWghmod().getShdlst().size();
			  log.debug("{}","长度"+length);
			  if(length>0)
			  {
			    for(int i=0;i<length;i++){
			      if(!MdaUtils.isEmpty(this.getWghmod().getShdlst().getElement(i).getBillnewno()))
			    {
			      String billnewno=this.getWghmod().getShdlst().getElement(i).getBillnewno();
			      String type=this.getWghmod().getShdlst().getElement(i).getBilltype();
			      if("2".equals(type)&&billnewno.equals(this.getBcdgrp().getRec().getConno()))
			      {
			        break;
			      }
			      else
			      {
			        if(i+1==length)
			        {
			          ctx.setMessage("提示","该笔申请合同号与所选网银购汇额度编号项下的合同号不一致，请加强审核！");
			          //return false;
			        }
			        continue;
			      }
			    }
			  }
			}
			else
			{
			  ctx.setMessage("提示","所选网银购汇额度编号项下合同号为空");
			  return false;
			}
			}
			return true;

		}
        /**
        *   source:bctacp.@0092.script
        */
        public boolean  fqdlstSearch(String rmbfkzh,String businessno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getWghmod().getFqdlst());
			List argVal = new ArrayList();
			String sql=" where duifzh = ? and edbusno = ? order by inr desc,credat desc";
			argVal.add(rmbfkzh);
			argVal.add(businessno);
			ctx.getDaoSession().dbReadset(this.getWghmod().getFqdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			if( this.getWghmod().getFqdlst().size()>0)
			{
			  log.info("{}","fqd账户类型"+this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			  this.getWghmod().setZhlx(this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			}
			ctx.getDaoSession().dbCloseCursor();
			
			
			return true;
		}














}