package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BctdocVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bctmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代收到单通知
*/
@Transaction(vo= BctdocVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctdoc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctdoc.class);

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctmod bctmod;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Bctdoc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBctmod().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bctdoc.this.getBcdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bctdoc.this.getBcdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.bchcod");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.doccur");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.inr");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.ownref");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctdoc.this.getFieldPath("bcdgrp.rec.stlref");}
 				public void setValue(String arg){Bctdoc.this.getBcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bctdoc.this.getBcdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bctdoc.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:bctdoc.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getBctp().getBctp02());

			return true;
        }













}