package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BctfreVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bctmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代收杂项处理
*/
@Transaction(vo= BctfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctfre.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctmod bctmod;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Bctfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBctmod().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getMtabut().setRecHolder(()->this.getBcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("IC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bctfre.this.getFieldPath("bcdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bctfre.this.getBcdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bctfre.this.getBcdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Bctfre.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bctfre.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("bcdgrp.rec.doccur");}
 				public void setValue(String arg){Bctfre.this.getBcdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bctfre.this.getBcdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Bctfre.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bctfre.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("bcdgrp.rec.ownref");}
 				public void setValue(String arg){Bctfre.this.getBcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bctfre.this.getBcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("bcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bctfre.this.getBcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bctfre.this.getBcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctfre.this.getFieldPath("bcdgrp.rec.stlref");}
 				public void setValue(String arg){Bctfre.this.getBcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bctfre.this.getBcdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bctfre.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBcdgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bcd");
			this.getAfdgrp().getRec().setObjinr(this.getBcdgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("1");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:bctfre.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","bctfre",stream,false );

			return true;
        }

        /**
        *   source:bctfre.@0004.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:bctfre.@0006.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().getPdfviw().callPDFComponent("","bctfre","进口代收杂项处理",1);

			return true;
        }

        /**
        *   source:bctfre.@0007.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "进口代收杂项处理";
			String tempfiles = "A:bctfre";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }



        /**
        *   source:bctfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			//List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			//  Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			//  if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			//    $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			IModule bcd = (IModule)ctx.restoreData("com.brilliance.bctfre.ref");
			if(!MdaUtils.isEmpty(bcd))
			  this.getBcdgrp().getRec().copyValue(bcd);
			
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			  this.getBcdgrp().getRec().setOwnref(NULLSTR);
			
			
			
			
			
			ctx.getDaoSession().dbRead(this.getBcdgrp().getDre().getPts(),new Argument<String>("objinr",this.getBcdgrp().getRec().getInr()),new Argument<String>("objtyp","bcd"),new Argument<String>("rol","dre"));
			
			
			
			ctx.getDaoSession().dbRead(this.getBcdgrp().getDrr().getPts(),new Argument<String>("objinr",this.getBcdgrp().getRec().getInr()),new Argument<String>("objtyp","bcd"),new Argument<String>("rol","drr"));
			
			
			
			//$bcdgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			return true;
        }

        /**
        *   source:bctfre.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    this.getAfdgrp().getRec().setBchcod(this.getBcdgrp().getRec().getBchcod());

			  }
			  log.info("{}","bchcod="+this.getBcdgrp().getRec().getBchcod()+",bchcod="+this.getBcdgrp().getRec().getBchcod());
			}
			

			return true;
        }













}