package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bctfre0VO;

import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代收杂项申请入口
*/
@Transaction(vo= Bctfre0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctfre0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctfre0.class);

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Bctfre0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bctfre0.@0001.script
        */
        @Rule(target="selp.sure",order=0)
        public boolean ruleSelpSureN0(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bcdgrp","bctfre");

			return true;
        }

        /**
        *   source:bctfre0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			// String queryClause = "SELECT bcd.inr trsinr,bcd.stlref ref,bcd.rcvdat dat,bcd.doccur cur,bcd.docamt amt,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM bcd,pts,adr,pta WHERE bcd.docflg = 'docadv' AND pts.rol = 'ben' AND pts.objtyp = 'bcd' AND pts.objinr = bcd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.rcvdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) bennam FROM bcd rec ,pts s "
			  +"WHERE  s.rol = 'drr' AND s.objtyp = 'bcd' AND s.objinr = rec.inr  "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:bctfre0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bcdgrp","bctfre"	);

			return true;
        }



        /**
        *   source:bctfre0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selbctfre"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//  String queryClause = "SELECT bcd.inr trsinr,bcd.stlref ref,bcd.rcvdat dat,bcd.doccur cur,bcd.docamt amt,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM bcd,pts,adr,pta WHERE bcd.docflg = 'docadv' AND pts.rol = 'ben' AND pts.objtyp = 'bcd' AND pts.objinr = bcd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.rcvdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) bennam FROM bcd rec ,pts s "
			  +"WHERE  s.rol = 'drr' AND s.objtyp = 'bcd' AND s.objinr = rec.inr  "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}