package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BctopnVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bctmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 商行进口代收申请
*/
@Transaction(vo= BctopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctopn.class);

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctmod bctmod;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Bctopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBctmod().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Bctopn.this.getBcdgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Bctopn.this.getBcdgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.bchcod");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.occcur");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.inr");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.ownref");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctopn.this.getFieldPath("bcdgrp.rec.stlref");}
 				public void setValue(String arg){Bctopn.this.getBcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bctopn.this.getBcdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("IC"));
        }

        /**
        *   source:bctopn.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBcdgrp().getRmi().getPts().getExtkey())&&MdaUtils.isEmpty(this.getBcdgrp().getRmi().getPts().getAdrblk()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("bctopn","CT000036"),MdaUtils.getI18NString("bctopn","CT000037"));
			  return false;
			}
			if(!(ctx.checkAll(this.getBcdgrp()) && ctx.checkAll(this.getBctp().getBnkrec())))
			  return false;
			this.getBcdgrp().getRec().setDocgrd(this.getBctp().getDocgrdm().encode());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getBcdgrp().getRec());
			  String objinr=this.getBcdgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getBcdgrp().getDre().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBcdgrp().getDrr().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBcdgrp().getRmi().getPts(),objinr);
			}
			else
			{
			  this.getBcdgrp().getRec().setInr(Platform.sdbCounter("bcd"));
			  ctx.getDaoSession().dbInsert(this.getBcdgrp().getRec());
			  String objinr = this.getBcdgrp().getRec().getInr();
			  String objtyp = "bcd";
			  this.getBcdgrp().getDre().savpts(objinr,objtyp);
			  this.getBcdgrp().getDrr().savpts(objinr,objtyp);
			  this.getBcdgrp().getRmi().savpts(objinr,objtyp);
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			this.getBcdgrp().setDocinf(this.getBctp().getDocgrdm().encodeTco());
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:bctopn.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBcdgrp().getRec().setDocgrd(this.getBctp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","bctopn",stream,false );

			return true;
        }

        /**
        *   source:bctopn.@0003.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBcdgrp().getRec().setDocgrd(this.getBctp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:bctopn.@0005.script
        */
        @Rule(target="bcdgrp.rec.doctypcod",order=100)
        public boolean ruleBcdgrpRecDoctypcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeDoctypcod();

			return true;
        }

        /**
        *   source:bctopn.@0009.script
        */
        @Rule(target="bctp.drep.sure",order=500)
        public boolean ruleBctpDrepSureN500(){
            IContext ctx = MdaEnv.getContext();
            
			//将当前申请客户处填写的信息带入交易下方的申请人信息栏位
			if(!MdaUtils.isEmpty(this.getBcdgrp().getDap().getPts().getExtkey()))
			{
			  this.getBcdgrp().getDre().getPts().setExtkey(this.getBcdgrp().getDap().getPts().getExtkey());
			  
			}
			if(!MdaUtils.isEmpty(this.getBcdgrp().getDap().getPts().getAdrblk()))
			{
			  this.getBcdgrp().getDre().getPts().setAdrblk(this.getBcdgrp().getDap().getPts().getAdrblk());
			  
			}

			return true;
        }

        /**
        *   source:bctopn.@0010.script
        */
        @Rule(target="bctp.bnkrec.bnkrecd.agbchrgby",order=100)
        public boolean ruleBctpBnkrecBnkrecdAgbchrgbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			//业务要求费用承担方传一句话过去
			String skr = "";
			String fkr = "";
			String fycd = "";
			if(MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && !MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  fkr = this.getBctp().getBnkrec().getBnkrecd().getRmichrgby();
			  fycd = "托收行托收费用由" + MdaUtils.getCodetableLabel("chrgby",fkr) + "承担。";
			  log.debug("{}","case1.fycd:" + fycd);
			}
			if(!MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  skr = this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby();
			  fycd = "贵行托收费用由" + MdaUtils.getCodetableLabel("chrgby",skr) + "承担。";
			  log.debug("{}","case2.fycd:" + fycd);
			}
			if(!MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && !MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  skr = this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby();
			  fkr = this.getBctp().getBnkrec().getBnkrecd().getRmichrgby();
			  fycd = "贵行托收费用由" + MdaUtils.getCodetableLabel("chrgby",skr) + "承担，托收行托收费用由" + MdaUtils.getCodetableLabel("chrgby",fkr) + "承担。";
			  log.debug("{}","case3.fycd:" + fycd);
			}
			this.getBctp().setFycd(fycd);
			

			log.debug("{}","收款人：" + skr);
			log.debug("{}","付款人：" + fkr);
			log.debug("{}","费用承担：" + fycd);
			log.debug("{}","bctopn.save200.fycd end!");

			return true;
        }

        /**
        *   source:bctopn.@0011.script
        */
        @Rule(target="bctp.bnkrec.bnkrecd.rmichrgby",order=100)
        public boolean ruleBctpBnkrecBnkrecdRmichrgbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			//业务要求费用承担方传一句话过去
			String skr = "";
			String fkr = "";
			String fycd = "";
			if(MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && !MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  fkr = this.getBctp().getBnkrec().getBnkrecd().getRmichrgby();
			  fycd = "托收行托收费用由" + MdaUtils.getCodetableLabel("chrgby",fkr) + "承担。";
			  log.debug("{}","case1.fycd:" + fycd);
			}
			if(!MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  skr = this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby();
			  fycd = "贵行托收费用由" + MdaUtils.getCodetableLabel("chrgby",skr) + "承担。";
			  log.debug("{}","case2.fycd:" + fycd);
			}
			if(!MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby()) && !MdaUtils.isEmpty(this.getBctp().getBnkrec().getBnkrecd().getRmichrgby()))
			{
			  skr = this.getBctp().getBnkrec().getBnkrecd().getAgbchrgby();
			  fkr = this.getBctp().getBnkrec().getBnkrecd().getRmichrgby();
			  fycd = "贵行托收费用由" + MdaUtils.getCodetableLabel("chrgby",skr) + "承担，托收行托收费用由" + MdaUtils.getCodetableLabel("chrgby",fkr) + "承担。";
			  log.debug("{}","case3.fycd:" + fycd);
			}
			this.getBctp().setFycd(fycd);
			

			log.debug("{}","收款人：" + skr);
			log.debug("{}","付款人：" + fkr);
			log.debug("{}","费用承担：" + fycd);
			log.debug("{}","bctopn.save200.fycd end!");

			return true;
        }


        /**
        *   source:bctopn.@0008.script
        */
        @Check(target="bctp.bcdgrp.rmi.pts.ref",order=100)
        public boolean checkBctpBcdgrpRmiPtsRefN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ref=(this.getBcdgrp().getRmi().getPts().getRef()).toString();
			if(ref.length()>16)
			{
			  ctx.setFieldError(this,"bcdgrp.rmi.pts.ref",MdaUtils.getI18NString("bctopn","CT000045"));
			}


			return true;
        }


        /**
        *   source:bctopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.setValues($bcdgrp\\rec\\doctypcod,Platform.getCodetable("doctypcod"));
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBctp().getDocgrdm().decode(this.getBcdgrp().getRec().getDocgrd());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBcdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBcdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			this.getBcdgrp().getRec().setCredat(MdaUtils.today());
			/*
			  if(!Platform.isEmpty(bchcod))
			  {
			  $bcdgrp\\rec\\bchcod.setValue((bchcod.get(0)).getValue());
			  }
			  Object o = Platform.restoreData("com.brilliance.bctopn.ref");
			  String ref = "";
			  if(Platform.isEmpty(o))
			  {
			  ref = $\\sysmod.getRefrence("IC");
			  $bcdgrp\\rec\\ownref.setValue(ref);
			  Platform.storeData("com.brilliance.bctopn.ref",ref);
			  }
			  else
			  {
			  $bcdgrp\\rec\\ownref.setValue(o.toString());
			  }
			  */
			this.getBcdgrp().getDap().initDap("bcd");
			this.getBcdgrp().getRec().setDoctypcod("2");
			//$bcdgrp\\rec\\matpertyp.setValue("1");
			this.getBcdgrp().getRec().setOcccur("USD");
			//Platform.disable($bcdgrp\\doctxt);
			
			return true;
        }

        /**
        *   source:bctopn.@0004.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			//Platform.setRequired($bcdgrp\\rmi\\pts\\adrblk);
			//Platform.setDescription($bcdgrp\\rmi\\pts\\adrblk,#CT000033);
			
			
			//Platform.setRequired($bcdgrp\\rec\\docgrd);
			//Platform.setDescription($bcdgrp\\rec\\docgrd,#CT000035);
			changeDoctypcod();
			/*String doctypcod = $bcdgrp\\rec\\doctypcod.getValue();
			  if("2".equals(doctypcod))
			  {
			  Platform.disable($bcdgrp\\rec\\matpercnt);
			  Platform.disable($bcdgrp\\rec\\matpertyp);
			  Platform.setNotRequired($bcdgrp\\rec\\matpercnt);
			  Platform.setNotRequired($bcdgrp\\rec\\matpertyp);
			  Platform.disable($bcdgrp\\doctxt);
			  }
			  else if("1".equals(doctypcod)  ||  "3".equals(doctypcod))
			  {
			  Platform.enable($bcdgrp\\rec\\matpercnt);
			  Platform.enable($bcdgrp\\rec\\matpertyp);
			  Platform.setRequired($bcdgrp\\rec\\matpercnt);
			  Platform.setRequired($bcdgrp\\rec\\matpertyp);
			  Platform.disable($bcdgrp\\doctxt);
			  }
			  else if("4".equals(doctypcod))
			  {
			  Platform.disable($bcdgrp\\rec\\matpercnt);
			  Platform.disable($bcdgrp\\rec\\matpertyp);
			  Platform.setNotRequired($bcdgrp\\rec\\matpercnt);
			  Platform.setNotRequired($bcdgrp\\rec\\matpertyp);
			  Platform.enable($bcdgrp\\doctxt);
			  }*/

			return true;
        }


        /**
        *   source:bctopn.@0006.script
        */
        public void changeDoctypcod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String doctypcod = this.getBcdgrp().getRec().getDoctypcod();
			if("2".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBcdgrp().getRec().setMatpercnt(NULLSTR);
			  this.getBcdgrp().getRec().setMatpertyp(NULLSTR);
			  
			  this.getBcdgrp().setDoctxt(NULLSTR);
			}
			else if("1".equals(doctypcod)  ||  "3".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBcdgrp().getRec().setMatpertyp("1");
			  
			  this.getBcdgrp().setDoctxt(NULLSTR);
			}
			else if("4".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBcdgrp().getRec().setMatpercnt(NULLSTR);
			  this.getBcdgrp().getRec().setMatpertyp(NULLSTR);
			  
			}
			
			
			
		}











}