package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BctsduVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bctmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代收面函制作
*/
@Transaction(vo= BctsduVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctsdu extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bctsdu.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctmod bctmod;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Bctsdu()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBctmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctmod().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bctsdu.this.getBcdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bctsdu.this.getBcdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.bchcod");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.doccur");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.inr");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.ownref");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bctsdu.this.getFieldPath("bcdgrp.rec.stlref");}
 				public void setValue(String arg){Bctsdu.this.getBcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bctsdu.this.getBcdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bctsdu.@0000.script
        */
        @Rule(target="mtabut.dft",order=100)
        public boolean ruleMtabutDftN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream =this.getMtabut().getDft();
			this.getSysmod().getPdfmod().generatorFreePdf(stream,this.getBcdgrp().getLogo());

			return true;
        }

        /**
        *   source:bctsdu.@0004.script
        */
        @Rule(target="bctp.add",order=100)
        public boolean ruleBctpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBctp().setTempvar(NULLSTR);
			String sdutyp= this.getBcdgrp().getSdutyp();
			ctx.getDaoSession().dbReadset(this.getBctp().getClslst(),new Argument<String>("typ",sdutyp),new Argument<String>("flg","8"),new Argument<Object>("status",NE,"0"));
			
			
			

			return true;
        }

        /**
        *   source:bctsdu.@0005.script
        */
        @Rule(target="bctp.clslst",order=100)
        public boolean ruleBctpClslstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0)
			  return false;
			this.getBctp().setTempvar(NULLSTR);
			this.getBctp().setTempvar(this.getBctp().getClslst().getElement(index).getClstxt());
			

			return true;
        }

        /**
        *   source:bctsdu.@0006.script
        */
        @Rule(target="bctp.ok",order=100)
        public boolean ruleBctpOkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBctp().getTempvar()))
			{
			  this.getBcdgrp().setDoctxt(NULLSTR);
			  this.getBcdgrp().setDoctxt(this.getBctp().getTempvar());
			  
			}
			

			return true;
        }


        /**
        *   source:bctsdu.@0003.script
        */
        @Check(target="bcdgrp.sdutyp",order=100)
        public boolean checkBcdgrpSdutypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sdutyp= this.getBcdgrp().getSdutyp();
			log.debug("{}","sdutyp=="+sdutyp);
			ctx.getDaoSession().dbRead(this.getBcdgrp().getCls(),new Argument<String>("typ",sdutyp),new Argument<String>("flg","8"),new Argument<String>("status","0"));
			this.getBcdgrp().setDoctxt(this.getBcdgrp().getCls().getClstxt());
			log.debug("{}","doctxt==="+this.getBcdgrp().getDoctxt());
			

			return true;
        }


        /**
        *   source:bctsdu.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBcdgrp().setSdutyp("bctsdu1");
			ctx.getDaoSession().dbRead(this.getBcdgrp().getCls(),new Argument<String>("typ","bctsdu1"),new Argument<String>("flg","8"),new Argument<String>("status","0"));
			this.getBcdgrp().setDoctxt(this.getBcdgrp().getCls().getClstxt());
			// Platform.setModified($bcdgrp\\doctxt);
			
			return true;
        }













}