package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BdtdraVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bdtp;
import com.ceb.gjjs.mda.manager.module.Bdtmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Bddgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证项下电提不符点
*/
@Transaction(vo= BdtdraVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtdra extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bdtdra.class);

		@BDGetter
		private Bddgrp bddgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Bdtmod bdtmod;

		@BDGetter
		private Bdtp bdtp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Bdtdra()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBdtp().setBddgrpHolder(()->this.getBddgrp());
           this.getBdtp().setDidgrpHolder(()->this.getDidgrp());
           this.getBdtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getBddgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Bdtdra.this.getBddgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Bdtdra.this.getBddgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.bchcod");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.advcur");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.inr");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setInr(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.ownref");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.ptyinr");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtdra.this.getFieldPath("bddgrp.rec.stlref");}
 				public void setValue(String arg){Bdtdra.this.getBddgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bdtdra.this.getBddgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bdtdra.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:bdtdra.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getBdtp().getBdtp03());

			return true;
        }












}