package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BdtfrdVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bdtp;
import com.ceb.gjjs.mda.manager.module.Bdtmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Bddgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证项下到单杂项申请
*/
@Transaction(vo= BdtfrdVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtfrd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bdtfrd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bddgrp bddgrp;

		@BDGetter
		private Bdtmod bdtmod;

		@BDGetter
		private Bdtp bdtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Didgrp didgrp;


		public Bdtfrd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBdtp().setBddgrpHolder(()->this.getBddgrp());
           this.getBdtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBdtp().setDidgrpHolder(()->this.getDidgrp());
           this.getMtabut().setRecHolder(()->this.getBddgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("bddgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Bdtfrd.this.getBddgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Bdtfrd.this.getBddgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("bddgrp.rec.advcur");}
 				public void setValue(String arg){Bdtfrd.this.getBddgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Bdtfrd.this.getBddgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Bdtfrd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bdtfrd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Bdtfrd.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bdtfrd.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("bddgrp.rec.ownref");}
 				public void setValue(String arg){Bdtfrd.this.getBddgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bdtfrd.this.getBddgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("bddgrp.rec.ptyinr");}
 				public void setValue(String arg){Bdtfrd.this.getBddgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bdtfrd.this.getBddgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtfrd.this.getFieldPath("bddgrp.rec.stlref");}
 				public void setValue(String arg){Bdtfrd.this.getBddgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bdtfrd.this.getBddgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bdtfrd.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBddgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bdd");
			this.getAfdgrp().getRec().setObjinr(this.getBddgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("1");
			this.getAfdgrp().getRec().setOprtyp("0");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:bdtfrd.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","bdtfrd",stream,false );

			return true;
        }

        /**
        *   source:bdtfrd.@0004.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:bdtfrd.@0005.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBdtp().getPdfviw().callPDFComponent("","bdtfrd","买方国内证寄单项下杂项处理申请书",1);

			return true;
        }



        /**
        *   source:bdtfrd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			this.getBdtp().setAplnam(this.getSysmod().getPty().getNam());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			
			
			
			
			
			
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  {
			    
			  }
			  return true;
			}
			IModule bdd = (IModule)ctx.restoreData("com.brilliance.bdtfrd.ref");
			if(!MdaUtils.isEmpty(bdd))
			  this.getBddgrp().getRec().copyValue(bdd);
			if(!MdaUtils.isEmpty(bchcod))
			  this.getAfdgrp().getRec().setBchcod((bchcod.get(0)).getValue());
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			ctx.getDaoSession().dbRead(this.getBddgrp().getApl().getPts(),new Argument<String>("objinr",this.getBddgrp().getRec().getInr()),new Argument<String>("objtyp","bdd"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getBddgrp().getBen().getPts(),new Argument<String>("objinr",this.getBddgrp().getRec().getInr()),new Argument<String>("objtyp","bdd"),new Argument<String>("rol","ben"));
			//$bddgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			return true;
        }

        /**
        *   source:bdtfrd.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBddgrp().getRec().getDbchcod()))
			      this.getAfdgrp().getRec().setBchcod(this.getBddgrp().getRec().getDbchcod());
			    else
			      this.getAfdgrp().getRec().setBchcod(this.getBddgrp().getRec().getBchcod());
			    
			  }
			  log.info("{}","bchcod="+this.getBddgrp().getRec().getBchcod());
			}


			return true;
        }












}