package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BdtfreVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Bddgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证杂项处理申请入口
*/
@Transaction(vo= BdtfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bdtfre.class);

		@BDGetter
		private Bddgrp bddgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Didgrp didgrp;


		public Bdtfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bdtfre.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //进口信用证记录
			  
			  
			  
			  
			  //queryClause = "SELECT did.inr trsinr,did.stlref ref,did.isscur cur,did.issamt amt,did.credat date,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM did,pts,adr,pta WHERE did.flg = '2' AND pts.rol = 'ben' AND pts.objtyp = 'did' AND pts.objinr = did.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM did rec,pts s WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'did' "
			    +"AND s.objinr = rec.inr"
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn1(queryClause);
			}
			else if("2".equals(seltyp))
			{
			  //进口信用证项下到单记录
			  
			  
			  
			  
			  // queryClause = "SELECT bdd.inr trsinr,bdd.stlref ref,bdd.advcur cur,bdd.advamt amt,bdd.rcvdat dat,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM bdd,pts,adr,pta WHERE bdd.docflg = 'docadv' AND pts.rol = 'ben' AND pts.objtyp = 'bdd' AND pts.objinr = bdd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause ="SELECT rec.inr trsinr,rec.stlref ref,rec.advcur cur,rec.advamt amt,rec.rcvdat dat,substr(s.adrblk,0,35) bennam "
			    +"FROM bdd rec,pts s  WHERE rec.docflg ='docadv' "
			    +"AND s.objtyp = 'bdd' AND s.rol = 'ben' AND s.objinr=rec.inr"
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}
			else if("3".equals(seltyp))
			{
			  //国内证
			  
			  
			  
			  
			  if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			    return true;
			  else
			  {
			    queryClause ="SELECT rec.inr trsinr,rec.ownref ref,rec.isscur cur,rec.issamt amt,rec.credat dat,substr(s.adrblk,0,35) bennam "
			      +"FROM did rec,pts s WHERE rec.cretyp='Z' "
			      +"AND s.objtyp = 'did' AND s.rol = 'ben' AND s.objinr=rec.inr"
			      +" AND rec.etyinr='"+this.getSysmod().getEty().getInr()+"'"
			      +" AND  rec.clsdat is  null  AND rec.ownref IS NOT NULL and rec.stlref is not null";
			    this.getSelp().queryBtn3(queryClause);
			  }
			}
			else if("4".equals(seltyp))
			{
			  //国内证单据
			  
			  
			  
			  
			  if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			    return true;
			  else
			  {
			    queryClause ="SELECT rec.inr trsinr,rec.stlref ref,rec.advcur cur,rec.advamt amt,rec.advdat dat,substr(s.adrblk,0,35) bennam "
			      +"FROM bdd rec,did,pts s WHERE rec.pnttyp='did' and rec.pntinr=did.inr and did.cretyp='Z' "
			      +"AND s.objtyp = 'bdd' AND s.rol = 'ben' AND s.objinr=rec.inr"
			      +" AND rec.etyinr='"+this.getSysmod().getEty().getInr()+"'"
			      +" AND  rec.clsdat is  null  AND rec.stlref IS NOT NULL";
			    this.getSelp().queryBtn4(queryClause);
			  }
			}
			
			
			
			

			return true;
        }

        /**
        *   source:bdtfre.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))
			{
			  //进口信用证记录
			  this.getSelp().sureBtn1("didgrp","bdtfrc");
			}
			else if("2".equals(seltyp))
			{
			  //进口信用证到单记录
			  this.getSelp().sureBtn("bddgrp","bdtfrd");
			}
			else if("3".equals(seltyp))
			{
			  //自主开立国内证
			  if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			    return true;
			  else
			    this.getSelp().sureBtn3("didgrp","bdtdfr");
			}
			else if("4".equals(seltyp))
			{
			  //自主开立国内证单据
			  if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			    return true;
			  else
			    this.getSelp().sureBtn4("bddgrp","bdtdfd");
			}

			return true;
        }

        /**
        *   source:bdtfre.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bddgrp","bdtfrd");

			return true;
        }

        /**
        *   source:bdtfre.@0004.script
        */
        @Rule(target="selp.tmplst1",order=100)
        public boolean ruleSelpTmplst1N100(){
            IContext ctx = MdaEnv.getContext();
            
			//进口信用证记录
			this.getSelp().sureBtn1("didgrp","bdtfrc");

			return true;
        }



        /**
        *   source:bdtfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.setValues($selp\\seltyp,Platform.getCodetable("selbdtfre"));
			List<CodetableItem> seltyp = new ArrayList<CodetableItem>();
			if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  seltyp.add(new CodetableItem("买方证记录","1"));
			  seltyp.add(new CodetableItem("买方证下到单记录","2"));
			  seltyp.add(new CodetableItem("自主开立国内证证下杂项","3"));
			  seltyp.add(new CodetableItem("自主开立国内证单下杂项","4"));
			}
			else
			{
			  seltyp.add(new CodetableItem("买方证记录","1"));
			  seltyp.add(new CodetableItem("买方证下到单记录","2"));
			}
			MdaUtils.setValues(this.getSelp(),"seltyp",seltyp);
			this.getSelp().setSeltyp("1");
			//String queryClause = "SELECT lirec.inr trsinr,lirec.stlref ref,lirec.isscur cur,lirec.issamt amt,lirec.credat dat,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM did,pts,adr,pta WHERE lirec.flg = '2' AND pts.rol = 'ben' AND pts.objtyp = 'did' AND pts.objinr = lirec.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			
			
			
			
			
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat ,substr(s.adrblk,0,35) bennam FROM did rec,pts s WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'did' "
			  +"AND s.objinr = rec.inr"
			  +ctx.absGet(Sysmod.class).getSelection();
			// +" WHERE rec.stlref is not null ";
			//+"and rec.ptyinr='"+$sysmod\\pty\\inr+"'";
			this.getSelp().queryBtn1(queryClause);

			return true;
        }








}