package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BdtsndVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bdtp;
import com.ceb.gjjs.mda.manager.module.Bdtmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Bddgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 国内证承兑/付款/拒付
*/
@Transaction(vo= BdtsndVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtsnd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bdtsnd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bddgrp bddgrp;

		@BDGetter
		private Bdtmod bdtmod;

		@BDGetter
		private Bdtp bdtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Bdtsnd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBdtp().setBddgrpHolder(()->this.getBddgrp());
           this.getBdtp().setDidgrpHolder(()->this.getDidgrp());
           this.getBdtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getBddgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Bdtsnd.this.getBddgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Bdtsnd.this.getBddgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.advcur");}
 				public void setValue(String arg){Bdtsnd.this.getBddgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Bdtsnd.this.getBddgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Bdtsnd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bdtsnd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.inr");}
 				public void setValue(String arg){Bdtsnd.this.getBddgrp().getRec().setInr(arg);}
 				public String getValue(){return Bdtsnd.this.getBddgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.ownref");}
 				public void setValue(String arg){Bdtsnd.this.getBddgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bdtsnd.this.getBddgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.ptyinr");}
 				public void setValue(String arg){Bdtsnd.this.getBddgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bdtsnd.this.getBddgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtsnd.this.getFieldPath("bddgrp.rec.stlref");}
 				public void setValue(String arg){Bdtsnd.this.getBddgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bdtsnd.this.getBddgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bdtsnd.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getBddgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			log.info("{}","sav200开始================" );
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bdd");
			this.getAfdgrp().getRec().setObjinr(this.getBddgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("1");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			log.info("{}", "sav200入库结束================" );
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:bdtsnd.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			//if("docadv".equals(docflg))
			//  $\\sysmod.generatorPdf("","bdtsnd0",stream,false );
			if("disadv".equals(this.getBddgrp().getRec().getDocflg()))
			  ctx.absGet(Sysmod.class).generatorPdf("","bdtsnd1",stream,false );
			else
			  ctx.absGet(Sysmod.class).generatorPdf("","bdtsnd0",stream,false );

			return true;
        }

        /**
        *   source:bdtsnd.@0005.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeOprTyp();

			return true;
        }

        /**
        *   source:bdtsnd.@0008.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }



        /**
        *   source:bdtsnd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);

			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(!(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T")))
			{
			  IModule bdd = (IModule)ctx.restoreData("com.brilliance.bdtsnd.ref");
			  if(!MdaUtils.isEmpty(bdd))
			    this.getBddgrp().getRec().copyValue(bdd);
			}
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  }
			  else
			  {
			    this.getAfdgrp().getRec().setBchcod(this.getBddgrp().getRec().getBchcod());
			  }
			}
			String stlref = this.getBddgrp().getRec().getStlref();
			if(MdaUtils.isEmpty(stlref))
			  return true;
			List<CodetableItem> oprtyp =null;
			//if("docadv".equals($bddgrp\\rec\\docflg.getValue()))
			//{
			//oprtyp 对应的码表 IB apltyp   RB aplinf
			//if(stlref.indexOf("IB")>=0)
			//oprtyp = Platform.getCodetable("apltyp");
			//else if(stlref.indexOf("RB")>=0)
			//oprtyp = Platform.getCodetable("aplinf");
			//Platform.setValues($afdgrp\\rec\\oprval,Platform.getCodetable("refres"));
			//}
			if("disadv".equals(this.getBddgrp().getRec().getDocflg()))
			{
			  oprtyp = MdaUtils.getCodetable("disdoc1");
			}
			else
			{
			  oprtyp = MdaUtils.getCodetable("apltyp6");
			  MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			}
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",oprtyp);
			log.debug("{}","docflg "+this.getBddgrp().getRec().getDocflg()+"\tstlref"+stlref);
			changeOprTyp();
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			this.getBdtp().setRejectlabel(MdaUtils.getI18NString("bdtsnd","CT000022"));
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			this.getAfdgrp().getRec().setOwnref(this.getBddgrp().getRec().getStlref());
			if(MdaUtils.isEmpty(this.getBddgrp().getRec().getRelcur()))
			  this.getBddgrp().getRec().setRelcur(this.getBddgrp().getRec().getAdvcur());
			if(MdaUtils.isEmpty(this.getBddgrp().getRec().getRelcur()))
			  this.getBddgrp().getRec().setRelamt(this.getBddgrp().getRec().getAdvamt());
			ctx.getDaoSession().dbRead(this.getBddgrp().getApl().getPts(),new Argument<String>("objinr",this.getBddgrp().getRec().getInr()),new Argument<String>("objtyp","bdd"),new Argument<String>("rol","apl"));
			ctx.getErrorCode();
			log.info("{}","========== message apl =========="+this.getBddgrp().getRec().getInr());
			ctx.getDaoSession().dbRead(this.getBddgrp().getBen().getPts(),new Argument<String>("objinr",this.getBddgrp().getRec().getInr()),new Argument<String>("objtyp","bdd"),new Argument<String>("rol","ben"));
			ctx.getErrorCode();
			String seltyp = (ctx.restoreData("com.brilliance.bdtsnd.seltyp")).toString();
			this.getAfdgrp().getRec().setOprtyp(oprtyp.get(0).getValue());

			return true;
        }

        /**
        *   source:bdtsnd.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$didgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBddgrp().getRec().getDbchcod()))
			      this.getAfdgrp().getRec().setBchcod(this.getBddgrp().getRec().getDbchcod());
			    else
			    {
			      this.getAfdgrp().getRec().setBchcod(this.getBddgrp().getRec().getBchcod());
			      this.getBddgrp().getRec().setDbchcod(this.getBddgrp().getRec().getBchcod());
			    }
			    
			  }
			  log.info("{}","bchcod="+this.getBddgrp().getRec().getBchcod());
			}


			return true;
        }


        /**
        *   source:bdtsnd.@0006.script
        */
        public void changeOprTyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String val = this.getAfdgrp().getRec().getOprtyp();
			if("disadv".equals(this.getBddgrp().getRec().getDocflg()))
			{
			  
			  
			}
			else if("bdtDCR".equals(val)  ||  "BXTDCR".equals(val))
			{
			  
			  
			  if(MdaUtils.isEmpty(this.getAfdgrp().getRec().getOprval()))
			    this.getAfdgrp().getRec().setOprval("1");
			}
			else
			{
			  
			  
			  this.getAfdgrp().getRec().setOprval(NULLSTR);
			}
			
			
		}










}