package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BdtudpVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bdtp;
import com.ceb.gjjs.mda.manager.module.Bdtmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Bddgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证开证远期承兑通知
*/
@Transaction(vo= BdtudpVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtudp extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bdtudp.class);

		@BDGetter
		private Bddgrp bddgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Bdtmod bdtmod;

		@BDGetter
		private Bdtp bdtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;


		public Bdtudp()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBdtp().setBddgrpHolder(()->this.getBddgrp());
           this.getBdtp().setDidgrpHolder(()->this.getDidgrp());
           this.getBdtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.acpamt");}
 				public void setValue(BigDecimal arg){Bdtudp.this.getBddgrp().getRec().setAcpamt(arg);}
 				public BigDecimal getValue(){return Bdtudp.this.getBddgrp().getRec().getAcpamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.bchcod");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.acpcur");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setAcpcur(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getAcpcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.inr");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setInr(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.ownref");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.ptyinr");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bdtudp.this.getFieldPath("bddgrp.rec.stlref");}
 				public void setValue(String arg){Bdtudp.this.getBddgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bdtudp.this.getBddgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBddgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bdtudp.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:bdtudp.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getBdtp().getBdtp06());

			
			
			

			return true;
        }

        /**
        *   source:bdtudp.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}