package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetaccVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证项下单据承兑通知
*/
@Transaction(vo= BetaccVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betacc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betacc.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Betacc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.acpamt");}
 				public void setValue(BigDecimal arg){Betacc.this.getBedgrp().getRec().setAcpamt(arg);}
 				public BigDecimal getValue(){return Betacc.this.getBedgrp().getRec().getAcpamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.acpcur");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setAcpcur(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getAcpcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betacc.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Betacc.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Betacc.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:betacc.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:betacc.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getBetp().getBetp09());

			return true;
        }

        /**
        *   source:betacc.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }












}