package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetchkVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代理审单申请
*/
@Transaction(vo= BetchkVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betchk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betchk.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Betchk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("BK"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.opnamt");}
 				public void setValue(BigDecimal arg){Betchk.this.getBedgrp().getRec().setOpnamt(arg);}
 				public BigDecimal getValue(){return Betchk.this.getBedgrp().getRec().getOpnamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.opncur");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setOpncur(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getOpncur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betchk.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Betchk.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Betchk.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:betchk.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getLedgrp()) && ctx.checkAll(this.getBedgrp()) && ctx.checkAll(this.getBetp().getBnkrec())))
			  return false;
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());
			else
			{
			  this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			  this.getBedgrp().getRec().setPnttyp("led");
			  this.getBedgrp().getRec().setPntinr(this.getLedgrp().getRec().getInr());
			  ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			  this.getBedgrp().getApl().copyValues(this.getBedgrp().getDap());
			  this.getBedgrp().getBeb().copyValues(this.getBedgrp().getDap());
			  this.getBedgrp().getDre().copyValues(this.getLedgrp().getIsb());
			  this.getBedgrp().getOth().copyValues(this.getLedgrp().getIsb());
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:betchk.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tenors=null;
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenor()))
			{
			  tenors=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			  if("U".equals(this.getLedgrp().getRec().getTenor()))
			  {
			    if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenmaxday()))
			      tenors+=" "+this.getLedgrp().getRec().getTenmaxday()+" Days ";
			    if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getUsapro()))
			      tenors+=MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			    log.debug("{}","tenors ,u"+tenors);
			  }
			}
			log.debug("{}","tenors===="+tenors);
			this.getBedgrp().getRec().setTenors(tenors);
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","betchk",stream,false );

			return true;
        }

        /**
        *   source:betchk.@0003.script
        */
        @Rule(target="ledgrp.rec.tenor",order=100)
        public boolean ruleLedgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			{
			  this.getLedgrp().getRec().setTenmaxday(NULLSTR);
			  
			  
			  this.getLedgrp().getRec().setUsapro(NULLSTR);
			  
			  
			}
			else if("U".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			  
			  this.getLedgrp().getRec().setUsapro("1");
			  
			}

			return true;
        }

        /**
        *   source:betchk.@0009.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:betchk.@0014.script
        */
        @Rule(target="betp.getled",order=100)
        public boolean ruleBetpGetledN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("lccref",this.getLedgrp().getRec().getLccref()));
			int rt = ctx.getErrorCode();
			if(rt==NO_MORE_ROW)
			  ctx.setMessage(MdaUtils.getI18NString("betchk","CT000038"),MdaUtils.getI18NString("betchk","CT000039"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","isb"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getBen().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","ben"));
			
			
			
			
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:betchk.@0011.script
        */
        @Check(target="ledgrp.rec.lccamt",order=100)
        public boolean checkLedgrpRecLccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getOpnamt()))
			  return true;
			if((this.getLedgrp().getRec().getLccamt()).compareTo(this.getBedgrp().getRec().getOpnamt())<0)
			  ctx.setFieldError(this,"ledgrp.rec.lccamt",MdaUtils.getI18NString("betchk","CT000030"));

			return true;
        }

        /**
        *   source:betchk.@0012.script
        */
        @Check(target="bedgrp.rec.opnamt",order=100)
        public boolean checkBedgrpRecOpnamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getLccamt()))
			  return true;
			if((this.getBedgrp().getRec().getOpnamt()).compareTo(this.getLedgrp().getRec().getLccamt())>0)
			  ctx.setFieldError(this,"ledgrp.rec.lccamt",MdaUtils.getI18NString("betchk","CT000031"));

			return true;
        }


        /**
        *   source:betchk.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			//处理单据
			this.getBetp().getDocgrdm().decode(this.getBedgrp().getRec().getDocgrd());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBedgrp().getRec().setBchcod(bchcod.get(0).getValue());
			//Platform.setValues($ledgrp\\rec\\usapro,Platform.getCodetable("usapro"));
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			this.getBedgrp().getRec().setCredat(MdaUtils.today());
			
			this.getLedgrp().getRec().setLcccur("USD");
			this.getBedgrp().getRec().setOpncur("USD");
			this.getBedgrp().getRec().setBalcur("USD");
			this.getLedgrp().getRec().setTenor("S");
			
			
			
			this.getBedgrp().getDap().initDap("bed");
			//$bedgrp\\beb.copyValues($bedgrp\\dap);
			
			return true;
        }

        /**
        *   source:betchk.@0013.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			}
			else if("U".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			}

			return true;
        }












}