package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetddvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业预审单通知
*/
@Transaction(vo= BetddvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betddv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betddv.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Betddv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Betddv.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Betddv.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betddv.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Betddv.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Betddv.this.getBedgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:betddv.@0002.script
        */
        @Rule(target="betp.adv",order=100)
        public boolean ruleBetpAdvN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt betddv.betp.adv ...  ");
			

			return true;
        }

        /**
        *   source:betddv.@0005.script
        */
        @Rule(target="betp.return",order=100)
        public boolean ruleBetpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:betddv.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck(this.getBetp().getBetddv());


			return true;
        }

        /**
        *   source:betddv.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			
			ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument("objtyp","bed"),new Argument("objinr",this.getBedgrp().getRec().getInr()),new Argument("rol","isb"));
			
			

			return true;
        }

        /**
        *   source:betddv.@0006.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }












}