package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetpreVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Premod;
import com.ceb.gjjs.mda.manager.module.Pregrp;
import com.ceb.gjjs.mda.manager.module.Prep;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业制单(模板查询)
*/
@Transaction(vo= BetpreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betpre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betpre.class);

		@BDGetter
		private Pregrp pregrp;

		@BDGetter
		private Premod premod;

		@BDGetter
		private Prep prep;

		@BDGetter
		private Sysmod sysmod;


		public Betpre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPremod().setPregrpHolder(()->this.getPregrp());
           this.getPrep().setPregrpHolder(()->this.getPregrp());
        }

        /**
        *   source:betpre.@0001.script
        */
        @Rule(target="prep.search",order=100)
        public boolean rulePrepSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPrep().loadMdlLst();

			return true;
        }

        /**
        *   source:betpre.@0002.script
        */
        @Rule(target="prep.delete",order=100)
        public boolean rulePrepDeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getPregrp().getMdllst().fullSize();
			if( index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("betpre","CT000032"),MdaUtils.getI18NString("betpre","CT000033"));
			  return false;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("betpre","CT000034"),MdaUtils.getI18NString("betpre","CT000035")))
			  return false;
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getPregrp().getBilmdl(),new Argument<String>("inr",this.getPregrp().getMdllst().getElement(index).getInr()));
			ctx.getDaoSession().dbDelete(this.getPregrp().getBilmdl());
			//NOTICE：对应文件未删除；若删除，则可能造成基于此的银行制单企业制单不能展示
			ctx.getDaoSession().dbCommit();
			this.getPrep().loadMdlLst();
			ctx.setMessage(MdaUtils.getI18NString("betpre","CT000036"),MdaUtils.getI18NString("betpre","CT000037"));

			return true;
        }

        /**
        *   source:betpre.@0003.script
        */
        @Rule(target="prep.modify",order=100)
        public boolean rulePrepModifyN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getPregrp().getMdllst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("betpre","CT000038"),MdaUtils.getI18NString("betpre","CT000039"));
			  return false;
			}
			ctx.getDaoSession().dbRead(this.getPregrp().getBilmdl(),new Argument<String>("inr",this.getPregrp().getMdllst().getElement(index).getInr()));
			ctx.storeData("com.brilliance.betpre.modinfo",this.getPregrp().getBilmdl());
			

			return true;
        }

        /**
        *   source:betpre.@0004.script
        */
        @Rule(target="prep.add",order=100)
        public boolean rulePrepAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.restoreData("com.brilliance.betfre.modinfo");
			MdaUtils.clear(this.getPregrp().getBilmdl());
			

			return true;
        }



        /**
        *   source:betpre.@0005.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPrep().setModtyp("0");
			this.getPrep().loadMdlLst();

			return true;
        }







}