package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Betpre1VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Premod;
import com.ceb.gjjs.mda.manager.module.Pregrp;
import com.ceb.gjjs.mda.manager.module.Prep;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代客制模板
*/
@Transaction(vo= Betpre1VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betpre1 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betpre1.class);

		@BDGetter
		private Pregrp pregrp;

		@BDGetter
		private Premod premod;

		@BDGetter
		private Prep prep;

		@BDGetter
		private Sysmod sysmod;


		public Betpre1()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPremod().setPregrpHolder(()->this.getPregrp());
           this.getPrep().setPregrpHolder(()->this.getPregrp());
        }

        /**
        *   source:betpre1.@0002.script
        */
        @Rule(target="pregrp.bilmdl.owned",order=100)
        public boolean rulePregrpBilmdlOwnedN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getPregrp().getBilmdl().getOwned()))
			{
			  this.getPregrp().getPty().setNcid(NULLSTR);
			  
			  this.getPregrp().getPty().setNam(NULLSTR);
			  
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:betpre1.@0003.script
        */
        @Rule(target="prep.cancel",order=100)
        public boolean rulePrepCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPregrp().getBilmdl());
			MdaUtils.clear(this.getPregrp().getPty());
			

			return true;
        }

        /**
        *   source:betpre1.@0004.script
        */
        @Rule(target="prep.selmdl",order=100)
        public boolean rulePrepSelmdlN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","selmdl=====");
			Object[] obj = (Object[])MdaUtils.getEventData();
			IStream stream = this.getPrep().getSelmdl();
			upLoad(stream,obj);

			return true;
        }

        /**
        *   source:betpre1.@0008.script
        */
        @Rule(target="prep.nxt",order=100)
        public boolean rulePrepNxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getPregrp()))
			  return false;
			log.debug("{}","bilmdl inr======="+this.getPregrp().getBilmdl().getInr());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/pdf");
			String filWhlNam = filPath+"/"+ this.getPregrp().getBilmdl().getInr() +".pdf";
			if(!MdaUtils.fileExists(filWhlNam))
			{
			  ctx.setMessage(MdaUtils.getI18NString("betpre1","CT000016"),MdaUtils.getI18NString("betpre1","CT000017"));
			  return true;
			}
			ctx.storeData("com.brilliance.betpre1.bilmdl",this.getPregrp().getBilmdl());
			

			return true;
        }

        /**
        *   source:betpre1.@0010.script
        */
        @Rule(target="pregrp.pty.ncid",order=100)
        public boolean rulePregrpPtyNcidN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ncid = this.getPregrp().getPty().getNcid();
			MdaUtils.clear(this.getPregrp().getPty());
			ctx.getDaoSession().dbRead(this.getPregrp().getPty(),new Argument<String>("ncid",ncid));
			int errorCode = ctx.getErrorCode();
			log.debug("{}","errorCode===="+errorCode);
			if( errorCode == NO_ERROR)
			{
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("betpre1","CT000018"),MdaUtils.getI18NString("betpre1","CT000019"));
			}
			/*
			  String sql = "SELECT * FROM pty WHERE ncid = '" + $pregrp\\pty\\ncid.getValue() + "'";
			  Platform.dbExecuteSQL(sql);
			  log.debug("sql========="+sql);
			  Platform.dbFetchFields(new Argument<String>("inr"),new Argument<String>("nam"));
			  if(Platform.errorCode() == NO_ERROR)
			  Platform.setModified($pregrp\\pty\\nam);
			  else
			  Platform.message(#CT000020,#CT000021);
			  Platform.dbCloseCursor();
			  */

			return true;
        }



        /**
        *   source:betpre1.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.betpre.modinfo");
			IModule mdl1 = (IModule)ctx.restoreData("com.brilliance.betpre2.bilmdl");
			if(!MdaUtils.isEmpty(mdl1) && MdaUtils.isEmpty(mdl))
			{
			  log.debug("{}","betpre2不为空，betpre为空=======后面取消回退");
			  this.getPregrp().getBilmdl().copyValue(mdl1);
			}
			else if(MdaUtils.isEmpty(mdl))
			{
			  log.debug("{}","新建==========");
			  this.getPregrp().getBilmdl().setInr(this.getPrep().getInr());
			  this.getPregrp().getBilmdl().setModtyp("1");
			  this.getPregrp().getBilmdl().setOwned("0");
			  this.getPregrp().getBilmdl().setStatus("0");
			}
			else
			{
			  log.debug("{}","修改==========");
			  this.getPregrp().getBilmdl().copyValue(mdl);
			}

			if("0".equals(this.getPregrp().getBilmdl().getOwned()))
			{
			  this.getPregrp().getPty().setNcid(NULLSTR);
			  
			  this.getPregrp().getPty().setNam(NULLSTR);
			  
			}
			else
			{
			  
			  
			}
			
			log.debug("{}","mdlinr=======" + this.getPregrp().getBilmdl().getInr());

			return true;
        }


        /**
        *   source:betpre1.@0006.script
        */
        public void upLoad(IStream stream,Object[] obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String pdfNam = obj[1].toString();
			int index = pdfNam.indexOf(".");
			String postfix = pdfNam.substring(index + 1);
			if(postfix.equals("pdf"))
			{
			  String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/"+postfix);
			  String filWhlNam = filPath+"/"+ this.getPregrp().getBilmdl().getInr() +".pdf";
			  if(MdaUtils.fileExists(filWhlNam))
			    MdaUtils.fileDelete(filWhlNam);
			  MdaUtils.streamSave(stream,filWhlNam);
			  log.debug("{}","filWhlNam========"+filWhlNam);
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("betpre1","CT000010"),MdaUtils.getI18NString("betpre1","CT000011"));
			  return;
			}
			ctx.setMessage(MdaUtils.getI18NString("betpre1","CT000012"),MdaUtils.getI18NString("betpre1","CT000013"));
		}





}