package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Betpre2VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Premod;
import com.ceb.gjjs.mda.manager.module.Pregrp;
import com.ceb.gjjs.mda.manager.module.Prep;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业制单(模板域赋值)
*/
@Transaction(vo= Betpre2VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betpre2 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betpre2.class);

		@BDGetter
		private Pregrp pregrp;

		@BDGetter
		private Premod premod;

		@BDGetter
		private Prep prep;

		@BDGetter
		private Sysmod sysmod;


		public Betpre2()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPremod().setPregrpHolder(()->this.getPregrp());
           this.getPrep().setPregrpHolder(()->this.getPregrp());
        }

        /**
        *   source:betpre2.@0001.script
        */
        @Rule(target="prep.cancel",order=100)
        public boolean rulePrepCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("com.brilliance.betpre2.bilmdl",this.getPregrp().getBilmdl());
			

			return true;
        }

        /**
        *   source:betpre2.@0003.script
        */
        @Rule(target="prep.sav",order=100)
        public boolean rulePrepSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			String filePath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			String fileName = this.getPregrp().getBilmdl().getInr()+".properties";
			log.debug("{}","sav bilmdl inr ===== "+this.getPregrp().getBilmdl().getInr());
			log.debug("{}","df Show Begin==========");
			Map<String,String> data = new HashMap<String,String>();
			int i = 0;
			for(;i < this.getPregrp().getDflst().fullSize();i++)
			{
			  data.put(this.getPregrp().getDflst().getElement(i).getDfnam(),this.getPregrp().getDflst().getElement(i).getDesrip());
			  log.debug("{}","dfnam========"+this.getPregrp().getDflst().getElement(i).getDfnam());
			  log.debug("{}","desrip======="+this.getPregrp().getDflst().getElement(i).getDesrip());
			}
			log.debug("{}","df Show End==========");
			MdaUtils.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",data,filePath,fileName);
			if(MdaUtils.fileExists(filePath + "/" +fileName) && i == this.getPregrp().getDflst().fullSize())
			{
			  this.getPregrp().getBilmdl().setFiltyp("pdf");
			  this.getPregrp().getBilmdl().setCredattim(MdaUtils.today());
			  this.getPregrp().getBilmdl().setOprinr(this.getSysmod().getUsr().getInr());
			  this.getPregrp().getBilmdl().setOprnam(this.getSysmod().getUsr().getOprnam());
			  this.getPregrp().getBilmdl().setFilurl(this.getPregrp().getBilmdl().getInr());
			  this.getPregrp().getBilmdl().setPdfurl(this.getPregrp().getBilmdl().getInr());
			  this.getPregrp().getBilmdl().setTyp("0");
			  ctx.getDaoSession().dbBegin();
			  ctx.getDaoSession().dbInsert(this.getPregrp().getBilmdl());
			  ctx.getDaoSession().dbCommit();
			  log.debug("{}","保存成功！");
			  ctx.setMessage(MdaUtils.getI18NString("betpre2","CT000024"),MdaUtils.getI18NString("betpre2","CT000025"));
			}
			else if(!MdaUtils.fileExists(filePath + "/" +fileName))
			  ctx.setMessage(MdaUtils.getI18NString("betpre2","CT000026"),MdaUtils.getI18NString("betpre2","CT000027"));
			else if(i != this.getPregrp().getDflst().fullSize())
			  ctx.setMessage(MdaUtils.getI18NString("betpre2","CT000028"),MdaUtils.getI18NString("betpre2","CT000029"));
			else
			  ctx.setMessage(MdaUtils.getI18NString("betpre2","CT000030"),MdaUtils.getI18NString("betpre2","CT000031"));
			

			return true;
        }

        /**
        *   source:betpre2.@0004.script
        */
        @Rule(target="prep.previewmdl",order=100)
        public boolean rulePrepPreviewmdlN100(){
            IContext ctx = MdaEnv.getContext();
            
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/pdf");
			String filNam = filPath + "/" + this.getPregrp().getBilmdl().getInr()+".pdf";
			log.debug("{}","filName======="+filNam);
			Map<String,String> df = new HashMap<String,String>();
			int i = 0;
			for(;i < this.getPregrp().getDflst().fullSize();i++)
			  df.put(this.getPregrp().getDflst().getElement(i).getDfnam(),this.getPregrp().getDflst().getElement(i).getDesrip());
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",filNam,df,"",this.getPrep().getPreviewmdl());

			return true;
        }



        /**
        *   source:betpre2.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPregrp().getBilmdl().copyValue((IModule)ctx.restoreData("com.brilliance.betpre1.bilmdl"));
			log.debug("{}","bilmdl inr value===="+this.getPregrp().getBilmdl().getInr());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/pdf");
			List<String> df = (List<String>)MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","getPDFFields",filPath,this.getPregrp().getBilmdl().getInr()+".pdf");
			log.debug("{}","df size="+df.size());
			Argument<String> dfnam = new Argument<String>("dfnam");
			for(String field:df)
			{
			  dfnam.value = field;
			  log.debug("{}",field+" to "+dfnam.value);
			  this.getPregrp().getDflst().add(dfnam);
			}

			return true;
        }







}