package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetrgfVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代理出单申请
*/
@Transaction(vo= BetrgfVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betrgf extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betrgf.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Betrgf()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("BP"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.opnamt");}
 				public void setValue(BigDecimal arg){Betrgf.this.getBedgrp().getRec().setOpnamt(arg);}
 				public BigDecimal getValue(){return Betrgf.this.getBedgrp().getRec().getOpnamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.opncur");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setOpncur(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getOpncur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgf.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Betrgf.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Betrgf.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:betrgf.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getLedgrp()) && ctx.checkAll(this.getBedgrp())))
			  return false;
			// insert docgrd
			BigDecimal lcc=this.getBetp().getVals(this.getLedgrp().getRec().getLccamt());
			this.getLedgrp().getRec().setLccamt(lcc);
			BigDecimal opn=this.getBetp().getVals(this.getBedgrp().getRec().getOpnamt());
			this.getBedgrp().getRec().setOpnamt(opn);
			BigDecimal bal=this.getBetp().getVals(this.getBedgrp().getRec().getBalamt());
			this.getBedgrp().getRec().setBalamt(bal);

			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());
			String tenorinf = null;
			String tenorlab = MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			if("S".equalsIgnoreCase(this.getLedgrp().getRec().getTenor()))
			  tenorinf = tenorlab;
			else if("U".equalsIgnoreCase(this.getLedgrp().getRec().getTenor()))
			  tenorinf = tenorlab+" "+this.getLedgrp().getRec().getTenmaxday()
			  +" Days "+MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			this.getLedgrp().getRec().setTenorinf(tenorinf);
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());
			else
			{
			  this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			  this.getBedgrp().getRec().setPnttyp("led");
			  this.getBedgrp().getRec().setPntinr(this.getLedgrp().getRec().getInr());
			  ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			this.getBedgrp().setDocinf(this.getBetp().getDocgrdm().encodeTco());
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.debug("{}","docgrd "+this.getBedgrp().getRec().getDocgrd());

			return true;
        }

        /**
        *   source:betrgf.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tenors=null;
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenor()))
			{
			  tenors=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			  if("U".equals(this.getLedgrp().getRec().getTenor()))
			  {
			    if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenmaxday()))
			      tenors+=" "+this.getLedgrp().getRec().getTenmaxday()+" Days ";
			    if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getUsapro()))
			      tenors+=MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			    log.debug("{}","tenors ,u"+tenors);
			  }
			}
			log.debug("{}","tenors===="+tenors);
			this.getBedgrp().getRec().setTenors(tenors);
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","betrgf",stream,false );

			return true;
        }

        /**
        *   source:betrgf.@0003.script
        */
        @Rule(target="ledgrp.rec.tenor",order=100)
        public boolean ruleLedgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			{
			  this.getLedgrp().getRec().setTenmaxday(NULLSTR);
			  
			  
			  this.getLedgrp().getRec().setUsapro(NULLSTR);
			  
			  
			}
			else if("U".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			  
			  this.getLedgrp().getRec().setUsapro("1");
			  
			}

			return true;
        }

        /**
        *   source:betrgf.@0007.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:betrgf.@0012.script
        */
        @Rule(target="betp.getled",order=100)
        public boolean ruleBetpGetledN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("lccref",this.getLedgrp().getRec().getLccref()));
			int rt = ctx.getErrorCode();
			if(rt==NO_MORE_ROW)
			  ctx.setMessage(MdaUtils.getI18NString("betrgf","CT000029"),MdaUtils.getI18NString("betrgf","CT000030"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","isb"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getBen().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","ben"));
			
			
			
			
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:betrgf.@0013.script
        */
        @Rule(target="ledgrp.rec.lcccur",order=100)
        public boolean ruleLedgrpRecLcccurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getLcccur()))
			{
			  this.getBedgrp().getRec().setOpncur(this.getLedgrp().getRec().getLcccur());
			  this.getBedgrp().getRec().setBalcur(this.getLedgrp().getRec().getLcccur());
			  
			  
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:betrgf.@0014.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "代理出单申请";
			String tempfiles = "A:betrgf";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:betrgf.@0015.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getBetp().getDocgrdm().encode());
			//IStream stream=$mtabut\\apldoc.getValue();
			BigDecimal lcc=this.getBetp().getVals(this.getLedgrp().getRec().getLccamt());
			this.getLedgrp().getRec().setLccamt(lcc);
			

			BigDecimal opn=this.getBetp().getVals(this.getBedgrp().getRec().getOpnamt());
			this.getBedgrp().getRec().setOpnamt(opn);
			

			BigDecimal bal=this.getBetp().getVals(this.getBedgrp().getRec().getBalamt());
			this.getBedgrp().getRec().setBalamt(bal);
			

			this.getBetp().getPdfviw().callPDFComponent("","betrgf","代理出单申请",1);

			return true;
        }


        /**
        *   source:betrgf.@0009.script
        */
        @Check(target="ledgrp.rec.lccamt",order=100)
        public boolean checkLedgrpRecLccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getOpnamt()))
			  return true;
			if((this.getLedgrp().getRec().getLccamt()).compareTo(this.getBedgrp().getRec().getOpnamt())<0)
			  ctx.setFieldError(this,"ledgrp.rec.lccamt",MdaUtils.getI18NString("betrgf","CT000026"));

			return true;
        }

        /**
        *   source:betrgf.@0010.script
        */
        @Check(target="bedgrp.rec.opnamt",order=100)
        public boolean checkBedgrpRecOpnamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getLccamt()))
			  return true;
			if((this.getBedgrp().getRec().getOpnamt()).compareTo(this.getLedgrp().getRec().getLccamt())>0)
			  ctx.setFieldError(this,"bedgrp.rec.opnamt",MdaUtils.getI18NString("betrgf","CT000028"));

			return true;
        }

        /**
        *   source:betrgf.@0016.script
        */
        @Check(target="betp.ledgrp.rec.lccamt",order=100)
        public boolean checkBetpLedgrpRecLccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBetp().getLedgrp().getRec(),"lccamt"));

			return true;
        }

        /**
        *   source:betrgf.@0017.script
        */
        @Check(target="betp.bedgrp.rec.opnamt",order=100)
        public boolean checkBetpBedgrpRecOpnamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBetp().getBedgrp().getRec(),"opnamt"));

			return true;
        }

        /**
        *   source:betrgf.@0018.script
        */
        @Check(target="betp.ledgrp.rec.tenmaxday",order=100)
        public boolean checkBetpLedgrpRecTenmaxdayN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getBetp().getLedgrp().getRec(),"tenmaxday"));

			return true;
        }

        /**
        *   source:betrgf.@0019.script
        */
        @Check(target="betp.bnkrec.cmcrecd.lccnum",order=100)
        public boolean checkBetpBnkrecCmcrecdLccnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getBetp().getBnkrec().getCmcrecd(),"lccnum"));

			return true;
        }


        /**
        *   source:betrgf.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBetp().getDocgrdm().decode(this.getBedgrp().getRec().getDocgrd());

			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBedgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getLcccur()))
			  {
			    
			    
			  }
			  return true;
			}
			this.getBedgrp().getRec().setCredat(MdaUtils.today());
			
			this.getLedgrp().getRec().setLcccur("USD");
			this.getBedgrp().getRec().setOpncur("USD");
			this.getBedgrp().getRec().setBalcur("USD");
			this.getLedgrp().getRec().setTenor("S");
			
			
			//Platform.clear($ledgrp\\rec\\tenmaxday);
			//Platform.disable($ledgrp\\rec\\tenmaxday);
			//Platform.clear($ledgrp\\rec\\usapro);
			//Platform.disable($ledgrp\\rec\\usapro);
			
			this.getBedgrp().getDap().initDap("bed");
			this.getBetp().getBnkrec().getCmcrecd().setSndins("0");

			return true;
        }

        /**
        *   source:betrgf.@0011.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			}
			else if("U".equals(this.getLedgrp().getRec().getTenor()))
			{
			  
			  
			}

			return true;
        }












}