package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BetrggVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业出口议付预审单申请
*/
@Transaction(vo= BetrggVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betrgg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Betrgg.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Betrgg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("BP"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Betrgg.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Betrgg.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Betrgg.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Betrgg.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Betrgg.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:betrgg.@0001.script
        */
        @Rule(target="betp.getled",order=100)
        public boolean ruleBetpGetledN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBetp().getLedlst());
			String sql="SELECT distinct rec.stlref stlref, s.adrblk apltxt,rec.advdat FROM led rec,pts s WHERE  rec.ptyinr = '" + this.getSysmod().getPty().getInr()+ "' and rec.inr=s.objinr and s.objtyp='led'  and s.rol='apl'";
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getStlref()))
			{
			  sql=sql+" and rec.stlref like '%"+this.getLedgrp().getRec().getStlref()+"%'   ";
			}
			sql=sql+"order by rec.advdat desc";
			ctx.getDaoSession().dbExecuteSQL(sql);
			log.debug("{}","ExecuteSQL========="+sql);
			Argument<String> stlref = new Argument<String>("stlref");
			Argument<String> apltxt = new Argument<String>("apltxt");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(stlref,apltxt);
			  log.debug("{}","dbfetch stlref....");
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getBetp().getLedlst().add(stlref,apltxt);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			


			return true;
        }

        /**
        *   source:betrgg.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			// $betp\\bchcod = $sysmod.valueToLabel($bedgrp\\rec\\bchcod.getValue());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","betrgg",stream,false );

			return true;
        }

        /**
        *   source:betrgg.@0003.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if( !ctx.checkAll(this.getBedgrp()))
			  return false;

			BigDecimal docamt= MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getDocamt(),"#0.00"));
			this.getBedgrp().getRec().setDocamt(docamt);

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());
			else
			{
			  this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			  if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getInr()))
			  {
			    this.getBedgrp().getRec().setPnttyp("led");
			    this.getBedgrp().getRec().setPntinr(this.getLedgrp().getRec().getInr());
			  }
			  else
			  {

			  }
			  ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			  // 保存开证行
			  this.getBedgrp().getIsb().copyValues( this.getLedgrp().getIsb());
			  this.getBedgrp().getIsb().getPts().setRef( this.getLedgrp().getRec().getLccref());
			  this.getBedgrp().getIsb().savpts(this.getBedgrp().getRec().getInr(),"bed");
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;

			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:betrgg.@0004.script
        */
        @Rule(target="betp.cho",order=100)
        public boolean ruleBetpChoN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getBetp().getLedlst().fullSize();
			if(index < 0  ||  index > len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("betrgg","CT000038"),MdaUtils.getI18NString("betrgg","CT000039"));
			  return true;
			}
			MdaUtils.clear(this.getLedgrp().getRec());
			MdaUtils.clear(this.getLedgrp().getIsb().getPts());
			MdaUtils.clear(this.getLedgrp().getBen().getPts());
			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("stlref",this.getBetp().getLedlst().getElement(index).getStlref()));
			ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","isb"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getBen().getPts(),new Argument<String>("objtyp","led"),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("rol","ben"));
			/*if(!Platform.isEmpty($ledgrp\\rec\\stlref))
			  {
			  Platform.disable($ledgrp\\rec\\stlref);
			  }*/
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getBchcod()))
			{

			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			  log.debug("{}","led bchcod========"+this.getLedgrp().getRec().getBchcod());
			  
			  this.getBedgrp().getRec().setBchcod(this.getLedgrp().getRec().getBchcod());
			  log.debug("{}","bed bchcod======="+this.getBedgrp().getRec().getBchcod());
			  
			}
			else
			{
			  
			  
			}
			this.getBedgrp().getRec().setDoccur(this.getLedgrp().getRec().getLcccur());
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:betrgg.@0005.script
        */
        @Rule(target="betp.ext",order=100)
        public boolean ruleBetpExtN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:betrgg.@0009.script
        */
        @Rule(target="ledgrp.rec.stlref",order=100)
        public boolean ruleLedgrpRecStlrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getStlref()))
			{
			  
			  
			  
			  
			  
			  this.getLedgrp().getIsb().getPts().setExtkey(NULLSTR);
			  this.getLedgrp().getIsb().getPts().setAdrblk(NULLSTR);
			  this.getLedgrp().getRec().setLccref(NULLSTR);
			}
			
			
			
			
			

			return true;
        }

        /**
        *   source:betrgg.@0016.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream =$mtabut\\apldoc.getValue();
			BigDecimal docamt=this.getBetp().getVals(this.getBedgrp().getRec().getDocamt());
			this.getBedgrp().getRec().setDocamt(docamt);
			
			this.getBetp().getPdfviw().callPDFComponent("","betrgg","企业出口议付预审单申请",1);

			return true;
        }

        /**
        *   source:betrgg.@0018.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "出口议付预审单申请书";
			String tempfiles = "A:betrgg";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }


        /**
        *   source:betrgg.@0019.script
        */
        @Check(target="bedgrp.rec.docamt",order=100)
        public boolean checkBedgrpRecDocamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//if(!Platform.isEmpty($bedgrp\\rec\\docamt))
			//{
			/*String str=(String)$bedgrp\\rec\\docamt.getValue();
			  String js="-";
			  //Pattern pattern=Pattern.compile(js);
			  // matcher = pattern.matcher(str);
			  //if(str.contains("-"))
			  if(js.equalse(str.substring(0,1).trim()))
			  {
			  Platform.error($bedgrp\\rec\\docamt,#CT000042);
			  }
			  */
			/*
			  BigDecimal str=$bedgrp\\rec\\docamt.getValue();
			  BigDecimal js=Platform.parseDecimal(0.00);
			  if(str.compareTo(js)<0)
			  {
			  Platform.error($bedgrp\\rec\\docamt,#CT000046);
			  }
			  }
			  Platform.setModified($bedgrp\\rec\\docamt);*/

			return true;
        }

        /**
        *   source:betrgg.@0022.script
        */
        @Check(target="betp.bedgrp.rec.docamt",order=100)
        public boolean checkBetpBedgrpRecDocamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBetp().getBedgrp().getRec(),"docamt"));

			return true;
        }


        /**
        *   source:betrgg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBetp().getDocgrdm().decode(this.getBedgrp().getRec().getDocgrd());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			this.getBedgrp().getRec().setCredat(MdaUtils.today());
			
			//Platform.disable($bedgrp\\rec\\bchcod);
			//Platform.setModified($bedgrp\\rec\\bchcod);
			this.contrl();
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBedgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			  {
			    
			  }
			  else
			  {
			    this.getBedgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  }
			  
			  return true;
			}
			
			this.getBedgrp().setDocinf("预审单申请");


			return true;
        }


        /**
        *   source:betrgg.@0015.script
        */
        public void contrl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			if(!MdaUtils.isEmpty(this.getLedgrp().getIsb().getPts().getExtkey()))
			{
			  
			  
			}
			/*if(!Platform.isEmpty($ledgrp\\rec\\stlref))
			  {
			  Platform.disable($ledgrp\\rec\\stlref);
			  }
			  */
			if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getLccref()))
			{
			  
			}
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getDoccur()))
			{
			  
			}
			
			
			
			
		}










}