package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BettplVO;

import com.ceb.gjjs.mda.manager.module.Tplgrp;
import com.ceb.gjjs.mda.manager.module.Tplmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tplp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代客制单(我的制单列表)
*/
@Transaction(vo= BettplVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bettpl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bettpl.class);

		@BDGetter
		private Tplgrp tplgrp;

		@BDGetter
		private Tplmod tplmod;

		@BDGetter
		private Tplp tplp;

		@BDGetter
		private Sysmod sysmod;


		public Bettpl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTplmod().setTplgrpHolder(()->this.getTplgrp());
           this.getTplp().setTplgrpHolder(()->this.getTplgrp());
        }

        /**
        *   source:bettpl.@0000.script
        */
        @Rule(target="tplp.add",order=100)
        public boolean ruleTplpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getTplgrp().getBilmdl());
			

			return true;
        }

        /**
        *   source:bettpl.@0001.script
        */
        @Rule(target="tplp.sure",order=100)
        public boolean ruleTplpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getTplgrp().getBillst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bettpl","CT000004"),MdaUtils.getI18NString("bettpl","CT000005"));
			  return true;
			}
			this.getTplgrp().getBilmdl().copyValue(this.getTplgrp().getBillst().getElement(index));
			ctx.storeData("com.brilliance.bettpl.bilmdl",this.getTplgrp().getBilmdl());
			

			return true;
        }



        /**
        *   source:bettpl.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			loadBil();

			return true;
        }


        /**
        *   source:bettpl.@0002.script
        */
        public void loadBil()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTplgrp().getBillst());
			ctx.getDaoSession().dbReadset(this.getTplgrp().getBillst(),new Argument<String>("oprinr",ctx.absGet(Sysmod.class).getUsr().getInr()),new Argument<String>("typ","1"));
			/*String sql = "SELECT * FROM bilmdl WHERE oprinr = '" + $\\sysmod\\usr\\inr + "'";
			  Platform.dbExecuteSQL(sql);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> ref = new Argument<String>("ref");
			  Argument<String> oprinr = new Argument<String>("oprinr");
			  Argument<String> oprnam = new Argument<String>("oprnam");
			  Argument<String> owned = new Argument<String>("owned");
			  Argument<String> modtyp = new Argument<String>("modtyp");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> ptynam = new Argument<String>("ptynam");
			  Argument<Date> credattim = new Argument<Date>("credattim");
			  Argument<String> status = new Argument<String>("status");
			  while(true)
			  {
			  Platform.dbFetchFields(inr,nam,ref,oprinr,oprnam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  $tplgrp\\billst.add(inr,nam,ref,oprinr,oprnam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  else
			  break;
			  }
			  Platform.dbCloseCursor();
			  */
			
		}





}