package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bettpl2VO;

import com.ceb.gjjs.mda.manager.module.Tplgrp;
import com.ceb.gjjs.mda.manager.module.Tplmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tplp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代客制单(所制单据列表)
*/
@Transaction(vo= Bettpl2VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bettpl2 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bettpl2.class);

		@BDGetter
		private Tplgrp tplgrp;

		@BDGetter
		private Tplmod tplmod;

		@BDGetter
		private Tplp tplp;

		@BDGetter
		private Sysmod sysmod;


		public Bettpl2()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTplmod().setTplgrpHolder(()->this.getTplgrp());
           this.getTplp().setTplgrpHolder(()->this.getTplgrp());
        }

        /**
        *   source:bettpl2.@0002.script
        */
        @Rule(target="tplp.ivnflg",order=100)
        public boolean ruleTplpIvnflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getIvnflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setIvninr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0003.script
        */
        @Rule(target="tplp.tdflg",order=100)
        public boolean ruleTplpTdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getTdflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setTdinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0004.script
        */
        @Rule(target="tplp.kydflg",order=100)
        public boolean ruleTplpKydflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getKydflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setKydinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0005.script
        */
        @Rule(target="tplp.kysjflg",order=100)
        public boolean ruleTplpKysjflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getKysjflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setKysjinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0006.script
        */
        @Rule(target="tplp.qtysdjflg",order=100)
        public boolean ruleTplpQtysdjflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getQtysdjflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setQtysdjinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0007.script
        */
        @Rule(target="tplp.bdflg",order=100)
        public boolean ruleTplpBdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getBdflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setBdinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0008.script
        */
        @Rule(target="tplp.zxdflg",order=100)
        public boolean ruleTplpZxdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getZxdflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setZxdinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0009.script
        */
        @Rule(target="tplp.zctzflg",order=100)
        public boolean ruleTplpZctzflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getZctzflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setZctzinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0010.script
        */
        @Rule(target="tplp.slzflg",order=100)
        public boolean ruleTplpSlzflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getSlzflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setSlzinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0011.script
        */
        @Rule(target="tplp.cdzflg",order=100)
        public boolean ruleTplpCdzflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getCdzflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setCdzinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0012.script
        */
        @Rule(target="tplp.syrzmflg",order=100)
        public boolean ruleTplpSyrzmflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getSyrzmflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setSyrzminr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0013.script
        */
        @Rule(target="tplp.qtdjflg",order=100)
        public boolean ruleTplpQtdjflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getTplp().getQtdjflg()))
			{
			  
			}
			else
			{
			  
			  this.getTplp().setQtdjinr(NULLSTR);
			}

			return true;
        }

        /**
        *   source:bettpl2.@0015.script
        */
        @Rule(target="tplp.sure",order=100)
        public boolean ruleTplpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getTplgrp().getBillst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bettpl2","CT000002"),MdaUtils.getI18NString("bettpl2","CT000003"));
			  return true;
			}
			MdaUtils.clear(this.getTplgrp().getBilmdl());
			this.getTplgrp().getBilmdl().copyValue(this.getTplgrp().getBillst().getElement(index));
			String seltyp = this.getTplp().getSeltyp();
			String inr = this.getTplgrp().getBilmdl().getInr();

			if("1".equals(seltyp))
			  this.getTplp().setIvninr(inr);
			else if("2".equals(seltyp))
			  this.getTplp().setTdinr(inr);
			else if("3".equals(seltyp))
			  this.getTplp().setKydinr(inr);
			else if("4".equals(seltyp))
			  this.getTplp().setKysjinr(inr);
			else if("5".equals(seltyp))
			  this.getTplp().setQtysdjinr(inr);
			else if("6".equals(seltyp))
			  this.getTplp().setBdinr(inr);
			else if("7".equals(seltyp))
			  this.getTplp().setZxdinr(inr);
			else if("8".equals(seltyp))
			  this.getTplp().setZctzinr(inr);
			else if("9".equals(seltyp))
			  this.getTplp().setSlzinr(inr);
			else if("10".equals(seltyp))
			  this.getTplp().setCdzinr(inr);
			else if("11".equals(seltyp))
			  this.getTplp().setSyrzminr(inr);
			else if("12".equals(seltyp))
			  this.getTplp().setQtdjinr(inr);
			

			return true;
        }

        /**
        *   source:bettpl2.@0016.script
        */
        @Rule(target="tplp.ivnsel",order=100)
        public boolean ruleTplpIvnselN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","ivnsel======");
			this.getTplp().setSeltyp("1");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0017.script
        */
        @Rule(target="tplp.tdsel",order=100)
        public boolean ruleTplpTdselN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","tdsel======");
			this.getTplp().setSeltyp("2");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0018.script
        */
        @Rule(target="tplp.kydsel",order=100)
        public boolean ruleTplpKydselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("3");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0019.script
        */
        @Rule(target="tplp.kysjsel",order=100)
        public boolean ruleTplpKysjselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("4");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0020.script
        */
        @Rule(target="tplp.qtysdjsel",order=100)
        public boolean ruleTplpQtysdjselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("5");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0021.script
        */
        @Rule(target="tplp.bdsel",order=100)
        public boolean ruleTplpBdselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("6");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0022.script
        */
        @Rule(target="tplp.zxdsel",order=100)
        public boolean ruleTplpZxdselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("7");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0023.script
        */
        @Rule(target="tplp.zctzsel",order=100)
        public boolean ruleTplpZctzselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("8");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0024.script
        */
        @Rule(target="tplp.slzsel",order=100)
        public boolean ruleTplpSlzselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("9");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0025.script
        */
        @Rule(target="tplp.cdzsel",order=100)
        public boolean ruleTplpCdzselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("10");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0026.script
        */
        @Rule(target="tplp.syrzmsel",order=100)
        public boolean ruleTplpSyrzmselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("11");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0027.script
        */
        @Rule(target="tplp.qtdjsel",order=100)
        public boolean ruleTplpQtdjselN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplp().setSeltyp("12");
			loadMdl();

			return true;
        }

        /**
        *   source:bettpl2.@0028.script
        */
        @Rule(target="tplp.cancel",order=100)
        public boolean ruleTplpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:bettpl2.@0029.script
        */
        @Rule(target="tplp.nxt",order=100)
        public boolean ruleTplpNxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Enter nxt=======");
			String[] flg = new String[]{"ivn","td","kyd","kysj","qtysdj","bd","zxd","zctz","slz","cdz","syrzm","qtdj"};
			String[] docNam = new String[]{MdaUtils.getI18NString("bettpl2","CT000006"),MdaUtils.getI18NString("bettpl2","CT000084"),MdaUtils.getI18NString("bettpl2","CT000085"),MdaUtils.getI18NString("bettpl2","CT000086"),MdaUtils.getI18NString("bettpl2","CT000087"),MdaUtils.getI18NString("bettpl2","CT000088"),MdaUtils.getI18NString("bettpl2","CT000089"),MdaUtils.getI18NString("bettpl2","CT000090"),MdaUtils.getI18NString("bettpl2","CT000091"),MdaUtils.getI18NString("bettpl2","CT000092"),MdaUtils.getI18NString("bettpl2","CT000093"),MdaUtils.getI18NString("bettpl2","CT000094")};
			List<CodetableItem> seltyp = new ArrayList<CodetableItem>();
			String[] inrs = new String[flg.length];
			String message = "";
			for( int i = 0; i < flg.length; i++ )
			{
			  IDatafield dfflg = MdaDriver.getDatafield(this.getTplp(),flg[i]+"flg");
			  IDatafield dfinr = MdaDriver.getDatafield(this.getTplp(),flg[i]+"inr");
			  if(TRUE.equals(dfflg.getValue()))
			  {
			    seltyp.add(new CodetableItem(docNam[i],String.valueOf(i)));
			    if(MdaUtils.isEmpty(dfinr.getValue()))
			      message += " "+docNam[i];
			    else
			      inrs[i] = (String)dfinr.getValue();
			  }
			  /*
			    //新增判断模板是否存在
			    String files = Platform.catPath(Platform.getRootPath(),"data/bilmdl/dfFile");
			    if(!Platform.fileExists(files+"/"+inrs[Integer.valueOf(seltyp.get(i).getValue())]+".properties"))
			    {
			    Platform.message(#CT000097,#CT000098);
			    log.info("文件"+files+"/"+inrs[Integer.valueOf(seltyp.get(i).getValue())]+".properties不存在！");
			    return;
			    }
			    */

			}
			if(seltyp.size() == 0)
			{
			  log.debug("{}","未选择单据类型");
			  ctx.setMessage(MdaUtils.getI18NString("bettpl2","CT000105"),MdaUtils.getI18NString("bettpl2","CT000106"));
			  return true;
			}
			if(!"".equals(message))
			{
			  log.debug("{}","未选择模板"+message);
			  ctx.setMessage(MdaUtils.getI18NString("bettpl2","CT000107"),MdaUtils.getI18NString("bettpl2","CT000120")+message+MdaUtils.getI18NString("bettpl2","CT000121"));
			  return true;
			}
			ctx.storeData("bettpl2.doctbl",seltyp);
			ctx.storeData("bettpl2.docinrs",inrs);
			ctx.storeData("com.brilliance.bettpl2.ledtmp",this.getTplgrp().getLedtmp());
			ctx.storeData("com.brilliance.bettpl2.pty",this.getTplgrp().getPty());
			
			log.debug("{}","Quit nxt=======");

			return true;
        }



        /**
        *   source:bettpl2.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplgrp().getLedtmp().copyValue((IModule)ctx.restoreData("com.brilliance.bettpl1.ledtmp"));
			this.getTplgrp().getPty().copyValue((IModule)ctx.restoreData("com.brilliance.bettpl1.pty"));
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:bettpl2.@0014.script
        */
        public void loadMdl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","loadmdl==========="+this.getTplp().getSeltyp());
			MdaUtils.clear(this.getTplgrp().getBillst());
			ctx.getDaoSession().dbReadset(this.getTplgrp().getBillst(),new Argument<String>("modtyp",this.getTplp().getSeltyp()),new Argument<String>("typ","0"));
			/*
			  String sql = "SELECT * FROM bilmdl WHERE modtyp = '" + modtyp + "'";
			  Platform.dbExecuteSQL(sql);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> owned = new Argument<String>("owned");
			  Argument<String> modtyp = new Argument<String>("modtyp");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> ptynam = new Argument<String>("ptynam");
			  Argument<Date> credattim = new Argument<Date>("credattim");
			  Argument<String> status = new Argument<String>("status");
			  while(true)
			  {
			  Platform.dbFetchFields(inr,nam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  $tplgrp\\billst.add(inr,nam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  else
			  break;
			  }
			  Platform.dbCloseCursor();
			  */
			
			
		}





}