package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bettpl3VO;

import com.ceb.gjjs.mda.manager.module.Tplgrp;
import com.ceb.gjjs.mda.manager.module.Tplmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tplp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代客制单(所制单据域赋值)
*/
@Transaction(vo= Bettpl3VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bettpl3 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bettpl3.class);

		@BDGetter
		private Tplgrp tplgrp;

		@BDGetter
		private Tplmod tplmod;

		@BDGetter
		private Tplp tplp;

		@BDGetter
		private Sysmod sysmod;


		public Bettpl3()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTplmod().setTplgrpHolder(()->this.getTplgrp());
           this.getTplp().setTplgrpHolder(()->this.getTplgrp());
        }

        /**
        *   source:bettpl3.@0001.script
        */
        @Rule(target="tplp.seltyp",order=100)
        public boolean ruleTplpSeltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			//shwProperty();
			enCode(this.getTplgrp().getSeltyp());
			deCode(this.getTplp().getSeltyp());
			this.getTplgrp().setSeltyp(this.getTplp().getSeltyp());

			return true;
        }

        /**
        *   source:bettpl3.@0003.script
        */
        @Rule(target="tplp.sav",order=200)
        public boolean ruleTplpSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  log.debug("Enter sav========");
			  String year = Platform.format(Platform.today(),"yy");
			  String inrPrefix = Platform.format(Platform.dbCounter("bilmdl"+year),"00000000");
			  String[] inrs = (String[])$tplp\\selinrs.getValue();
			  int index = Integer.valueOf($tplgrp\\seltyp.getValue());
			  Platform.dbRead($tplgrp\\bilmdl,new Argument<String>("inr",inrs[index]));
			  String inr = $tplgrp\\bilmdl\\inr.getValue();
			  String typ = $tplgrp\\bilmdl\\modtyp.getValue();
			  Platform.clear($tplgrp\\bilmdl);
			  Platform.dbBegin();
			  Map<String,Object> df = new HashMap<String,Object>();
			  for(int i = 0;i < $tplgrp\\mdltmp.fullSize(); i++)
			  df.put($tplgrp\\mdltmp[i]\\dfnam.getValue(),$tplgrp\\mdltmp[i]\\desrip.getValue());
			  String filPath = Platform.catPath(Platform.getRootPath(),"data/bilmdl/docFile");
			  Platform.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",df,filPath,inrPrefix+".properties");
			  Platform.clear($tplgrp\\mdltmp);
			  $tplgrp\\bilmdl\\inr.setValue(inrPrefix);
			  $tplgrp\\bilmdl\\ptyinr.setValue($tplgrp\\pty\\inr.getValue());
			  $tplgrp\\bilmdl\\nam.setValue("");
			  $tplgrp\\bilmdl\\filtyp.setValue("");
			  $tplgrp\\bilmdl\\credattim.setValue(Platform.today());
			  $tplgrp\\bilmdl\\status.setValue("1");
			  $tplgrp\\bilmdl\\modtyp.setValue(typ);
			  $tplgrp\\bilmdl\\owned.setValue("1");
			  $tplgrp\\bilmdl\\ptynam.setValue($tplgrp\\pty\\nam.getValue());
			  $tplgrp\\bilmdl\\ref.setValue($tplgrp\\ledtmp\\ref.getValue());
			  $tplgrp\\bilmdl\\oprinr.setValue($sysmod\\usr\\inr.getValue());
			  $tplgrp\\bilmdl\\oprnam.setValue($sysmod\\usr\\oprnam.getValue());
			  $tplgrp\\bilmdl\\filurl.setValue("");
			  $tplgrp\\bilmdl\\pdfurl.setValue(inr);
			  $tplgrp\\bilmdl\\typ.setValue("1");
			  Platform.dbInsert($tplgrp\\bilmdl);
			  Platform.dbCommit();
			  Platform.chain("bettpl");
			  log.debug("Quit sav========");
			  */

			return true;
        }

        /**
        *   source:bettpl3.@0004.script
        */
        @Rule(target="tplp.preview",order=100)
        public boolean ruleTplpPreviewN100(){
            IContext ctx = MdaEnv.getContext();
            
			String[] inrs = (String[])this.getTplp().getSelinrs();
			Map<String,Object> df = new HashMap<String,Object>();
			int index = Integer.valueOf(this.getTplgrp().getSeltyp());
			for(int i = 0;i < this.getTplgrp().getMdltmp().fullSize(); i++)
			  df.put(this.getTplgrp().getMdltmp().getElement(i).getDfkey(),this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/pdf");
			String pdfPath = filPath + "/" + inrs[index]+".pdf";
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdfPath,df,"",this.getTplp().getPreview());

			return true;
        }

        /**
        *   source:bettpl3.@0010.script
        */
        @Rule(target="tplp.sav",order=100)
        public boolean ruleTplpSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			//enCode当前显示的List
			enCode(this.getTplp().getSeltyp());
			String year = MdaUtils.format(MdaUtils.today(),"yy");
			List<CodetableItem> seltyp = (List<CodetableItem>)this.getTplp().getSeltbl();
			String[] inrs = (String[])this.getTplp().getSelinrs();
			ctx.getDaoSession().dbBegin();
			for(int j = 0; j < seltyp.size(); j++)
			{
			  String inrPrefix = MdaUtils.format(ctx.getDaoSession().dbCounter("bilmdl"+year),"00000000");
			  //读出依托模板数据库记录
			  ctx.getDaoSession().dbRead(this.getTplgrp().getBilmdl(),new Argument<String>("inr",inrs[Integer.valueOf(seltyp.get(j).getValue())]));
			  String inr = this.getTplgrp().getBilmdl().getInr();
			  String typ = this.getTplgrp().getBilmdl().getModtyp();
			  MdaUtils.clear(this.getTplgrp().getBilmdl());
			  deCode(seltyp.get(j).getValue());
			  log.debug("{}","第"+j+"个encode的文件inr的值为"+inrs[Integer.valueOf(seltyp.get(j).getValue())]+", seltyp在数组中的位置为"+seltyp.get(j).getValue());
			  Map<String,Object> df = new HashMap<String,Object>();
			  for(int i = 0;i < this.getTplgrp().getMdltmp().fullSize(); i++)
			    df.put(this.getTplgrp().getMdltmp().getElement(i).getDfnam(),this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			  String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/docFile");
			  MdaUtils.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",df,filPath,inrPrefix+".properties");
			  MdaUtils.clear(this.getTplgrp().getMdltmp());
			  this.getTplgrp().getBilmdl().setInr(inrPrefix);
			  this.getTplgrp().getBilmdl().setPtyinr(this.getTplgrp().getPty().getInr());
			  this.getTplgrp().getBilmdl().setNam(seltyp.get(j).getLabel());
			  this.getTplgrp().getBilmdl().setFiltyp("properties");
			  this.getTplgrp().getBilmdl().setCredattim(MdaUtils.today());
			  this.getTplgrp().getBilmdl().setStatus("1");
			  this.getTplgrp().getBilmdl().setModtyp(typ);
			  this.getTplgrp().getBilmdl().setOwned("1");
			  this.getTplgrp().getBilmdl().setPtynam(this.getTplgrp().getPty().getNam());
			  this.getTplgrp().getBilmdl().setRef(this.getTplgrp().getLedtmp().getRef());
			  this.getTplgrp().getBilmdl().setOprinr(this.getSysmod().getUsr().getInr());
			  this.getTplgrp().getBilmdl().setOprnam(this.getSysmod().getUsr().getOprnam());
			  this.getTplgrp().getBilmdl().setFilurl(this.getTplgrp().getBilmdl().getInr());
			  this.getTplgrp().getBilmdl().setPdfurl(inr);
			  this.getTplgrp().getBilmdl().setTyp("1");
			  ctx.getDaoSession().dbInsert(this.getTplgrp().getBilmdl());
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("bettpl3","CT000000"),MdaUtils.getI18NString("bettpl3","CT000001"));
			

			return true;
        }

        /**
        *   source:bettpl3.@0011.script
        */
        @Rule(target="tplp.cancel",order=100)
        public boolean ruleTplpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:bettpl3.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplgrp().getLedtmp().copyValue((IModule)ctx.restoreData("com.brilliance.bettpl2.ledtmp"));
			this.getTplgrp().getPty().copyValue((IModule)ctx.restoreData("com.brilliance.bettpl2.pty"));
			List<CodetableItem> seltyp = (List<CodetableItem>)ctx.restoreData("bettpl2.doctbl");
			this.getTplp().setSeltbl(seltyp);
			MdaUtils.setValues(this.getTplp(),"seltyp",seltyp);
			this.getTplp().setSelinrs(ctx.restoreData("bettpl2.docinrs"));
			String[] inrs = (String[])this.getTplp().getSelinrs();

			//新增判断模板是否存在
			String files = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			if(!MdaUtils.fileExists(files+"/"+inrs[Integer.valueOf(seltyp.get(0).getValue())]+".properties"))
			{
			  ctx.setMessage(MdaUtils.getI18NString("bettpl3","CT000016"),MdaUtils.getI18NString("bettpl3","CT000017"));
			  log.info("{}","文件"+files+"/"+inrs[Integer.valueOf(seltyp.get(0).getValue())]+".properties不存在！");
			  return true;
			}
			//
			for(int i = 0; i < seltyp.size(); i++)
			{
			  readProperty1(inrs[Integer.valueOf(seltyp.get(i).getValue())]);
			  //enCode(String.valueOf(i));
			  enCode(seltyp.get(i).getValue());
			  log.debug("{}","第"+i+"个encode的文件inr的值为"+inrs[Integer.valueOf(seltyp.get(i).getValue())]+", seltyp在数组中的位置为"+seltyp.get(i).getValue());
			}
			this.getTplgrp().setSeltyp(seltyp.get(0).getValue());
			this.getTplp().setSeltyp(this.getTplgrp().getSeltyp());
			//readProperty(inrs[Integer.valueOf($tplgrp\\seltyp.getValue())]);
			deCode(this.getTplgrp().getSeltyp());
			/*
			  Platform.clear($tplgrp\\mdltmp);
			  String filPath = Platform.catPath(Platform.getRootPath(),"data/bilmdl/dfFile");
			  Map<String,Object> df = (Map<String,Object>)Platform.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inrs[Integer.valueOf($tplp\\seltyp.getValue())]+".properties");
			  Argument<String> dfnam = new Argument<String>("dfnam");
			  Argument<String> dfkey = new Argument<String>("dfkey");
			  for(Object key:df.keySet())
			  {
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  $tplgrp\\mdltmp.add(dfnam,dfkey);
			  }
			  */

			return true;
        }


        /**
        *   source:bettpl3.@0002.script
        */
        public void shwPropertyBakBak()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","Enter shwProperty=======");
			String[] inrs = (String[])this.getTplp().getSelinrs();
			log.debug("{}","inrs size======="+inrs.length);
			Map<String,Object> df = new HashMap<String,Object>();
			int index = Integer.valueOf(this.getTplgrp().getSeltyp());
			log.debug("{}","index======="+index);
			log.debug("{}","mdltmp 清空前 size======="+this.getTplgrp().getMdltmp().fullSize());
			for(int i = 0;i < this.getTplgrp().getMdltmp().fullSize(); i++)
			{
			  df.put(this.getTplgrp().getMdltmp().getElement(index).getDfnam(),this.getTplgrp().getMdltmp().getElement(index).getDesrip());
			  log.debug("{}",this.getTplgrp().getMdltmp().getElement(index).getDfnam()+" to "+this.getTplgrp().getMdltmp().getElement(index).getDesrip());
			}
			log.debug("{}","df size======="+df.size());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/docFile");
			log.debug("{}","filPath======="+filPath);
			MdaUtils.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",filPath,inrs[index]+".properties");
			log.debug("{}","filName======="+inrs[index]+".properties");
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			log.debug("{}","mdltmp 清空后 size======="+this.getTplgrp().getMdltmp().fullSize());
			filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			log.debug("{}","filPath======="+filPath);
			df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inrs[Integer.valueOf(this.getTplp().getSeltyp())]+".properties");
			log.debug("{}","filName======="+inrs[Integer.valueOf(this.getTplp().getSeltyp())]+".properties");
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> dfkey = new Argument<String>("dfkey");
			for(Object key:df.keySet())
			{
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  log.debug("{}",df.get(key)+" to "+dfnam.value);
			  log.debug("{}","key======"+dfkey.value);
			  this.getTplgrp().getMdltmp().add(dfnam);
			  log.debug("{}","mdltmp size====="+this.getTplgrp().getMdltmp().fullSize());
			}
			
			log.debug("{}","Quit shwProperty=======");
		}
        /**
        *   source:bettpl3.@0005.script
        */
        public void shwPropertyBak()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","Enter shwProperty=======");
			String[] inrs = (String[])this.getTplp().getSelinrs();
			log.debug("{}","inrs size======="+inrs.length);
			int index = Integer.valueOf(this.getTplgrp().getSeltyp());
			log.debug("{}","index======="+index);
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			log.debug("{}","mdltmp 清空后 size======="+this.getTplgrp().getMdltmp().fullSize());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			log.debug("{}","filPath======="+filPath);
			Map<String,Object> df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inrs[Integer.valueOf(this.getTplp().getSeltyp())]+".properties");
			log.debug("{}","filName======="+inrs[Integer.valueOf(this.getTplp().getSeltyp())]+".properties");
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> dfkey = new Argument<String>("dfkey");
			for(Object key:df.keySet())
			{
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  log.debug("{}",df.get(key)+" to "+dfnam.value);
			  log.debug("{}","key======"+dfkey.value);
			  this.getTplgrp().getMdltmp().add(dfnam,dfkey);
			  log.debug("{}","mdltmp size====="+this.getTplgrp().getMdltmp().fullSize());
			}
			
			log.debug("{}","Quit shwProperty=======");
		}
        /**
        *   source:bettpl3.@0006.script
        */
        public void shwProperty()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","Enter shwProperty=======");
			String[] inrs = (String[])this.getTplp().getSelinrs();
			int index = Integer.valueOf(this.getTplgrp().getSeltyp());
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			Map<String,Object> df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inrs[Integer.valueOf(this.getTplp().getSeltyp())]+".properties");
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> dfkey = new Argument<String>("dfkey");
			for(Object key:df.keySet())
			{
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  this.getTplgrp().getMdltmp().add(dfnam,dfkey);
			}
			
			log.debug("{}","Quit shwProperty=======");
		}
        /**
        *   source:bettpl3.@0007.script
        */
        public void enCode(String index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer sb=new StringBuffer();
			String conn="";
			for(int i=0;i<this.getTplgrp().getMdltmp().fullSize();i++)
			{
			  if(MdaUtils.isEmpty(this.getTplgrp().getMdltmp().getElement(i).getDesrip()))
			    this.getTplgrp().getMdltmp().getElement(i).setDesrip("");
			  sb.append(conn).append(this.getTplgrp().getMdltmp().getElement(i).getDfkey());
			  conn = ":=:";
			  sb.append(conn).append(this.getTplgrp().getMdltmp().getElement(i).getDfnam());
			  sb.append(conn).append(this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			}
			sb.append("@@@");
			String[] flg = new String[]{"ivn","td","kyd","kysj","qtysdj","bd","zxd","zctz","slz","cdz","syrzm","qtdj"};
			IDatafield doc = MdaDriver.getDatafield(this.getTplgrp(),flg[Integer.valueOf(index)]+"doc");
			doc.setValue(sb.toString());
			log.debug("{}","第"+index+"个域"+flg[Integer.valueOf(index)]+"doc存储的单据信息为"+sb);
		}
        /**
        *   source:bettpl3.@0008.script
        */
        public void deCode(String index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			String[] flg = new String[]{"ivn","td","kyd","kysj","qtysdj","bd","zxd","zctz","slz","cdz","syrzm","qtdj"};
			IDatafield doc = MdaDriver.getDatafield(this.getTplgrp(),flg[Integer.valueOf(index)]+"doc");
			String value = (String)doc.getValue();
			log.debug("{}","decode:"+value);
			if(MdaUtils.isEmpty(value))
			  return;
			String[] values = value.split(":=:");
			int size = values.length/3;
			values[values.length - 1]=values[values.length - 1].replaceAll("@@@","");
			log.debug("{}","Replace = "+values[values.length - 1]);
			for(int i = this.getTplgrp().getMdltmp().fullSize(); i < size; i++)
			  this.getTplgrp().getMdltmp().add();
			for(int i = 0; i < size; i++)
			{
			  this.getTplgrp().getMdltmp().getElement(i).setDfkey( values[i*3]);
			  this.getTplgrp().getMdltmp().getElement(i).setDfnam( values[i*3+1]);
			  this.getTplgrp().getMdltmp().getElement(i).setDesrip( values[i*3+2]);
			  log.debug("{}","dfkey value = "+values[i*3]+",dfnam value = "+values[i*3+1]+",desrip value = "+values[i*3+2]);
			}
			
		}
        /**
        *   source:bettpl3.@0009.script
        */
        public void readProperty(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			if(!MdaUtils.fileExists(filPath+"/"+inr+".properties"))
			{
			  ctx.setMessage(MdaUtils.getI18NString("bettpl3","CT000004"),MdaUtils.getI18NString("bettpl3","CT000005"));
			  log.info("{}","文件"+filPath+"/"+inr+".properties不存在！");
			}
			Map<String,Object> df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inr+".properties");
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> dfkey = new Argument<String>("dfkey");
			for(Object key:df.keySet())
			{
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  this.getTplgrp().getMdltmp().add(dfnam,dfkey);
			}
		}
        /**
        *   source:bettpl3.@0013.script
        */
        public void readProperty1(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");

			Map<String,Object> df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,inr+".properties");
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> dfkey = new Argument<String>("dfkey");
			for(Object key:df.keySet())
			{
			  dfnam.value = (String)df.get(key);
			  dfkey.value = key.toString();
			  this.getTplgrp().getMdltmp().add(dfnam,dfkey);
			}
		}





}