package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bettpl4VO;

import com.ceb.gjjs.mda.manager.module.Tplgrp;
import com.ceb.gjjs.mda.manager.module.Tplmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tplp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 代客制单(域赋值)
*/
@Transaction(vo= Bettpl4VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bettpl4 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bettpl4.class);

		@BDGetter
		private Tplgrp tplgrp;

		@BDGetter
		private Tplmod tplmod;

		@BDGetter
		private Tplp tplp;

		@BDGetter
		private Sysmod sysmod;


		public Bettpl4()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTplmod().setTplgrpHolder(()->this.getTplgrp());
           this.getTplp().setTplgrpHolder(()->this.getTplgrp());
        }

        /**
        *   source:bettpl4.@0001.script
        */
        @Rule(target="tplp.preview",order=100)
        public boolean ruleTplpPreviewN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Enter preview=======");
			//pdf的property文件
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/dfFile");
			log.debug("{}","filPath======="+filPath);
			Map<String,Object> pdf = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,this.getTplgrp().getBilmdl().getPdfurl()+".properties");
			Map<String,Object> df = new HashMap<String,Object>();
			for(int i = 0;i < this.getTplgrp().getMdltmp().fullSize(); i++)
			{
			  df.put(this.getTplgrp().getMdltmp().getElement(i).getDfnam(),this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			  log.debug("{}",this.getTplgrp().getMdltmp().getElement(i).getDfnam()+" == "+this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			}
			Map<String,Object> newPdf = new HashMap<String,Object>();
			for(Object key:pdf.keySet())
			{
			  newPdf.put(key.toString(),df.get(pdf.get(key)));
			  log.debug("{}",key.toString()+" to "+pdf.get(key)+" to "+df.get(pdf.get(key)));
			}
			log.debug("{}","newPdf size======="+newPdf.size());
			filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/pdf");
			log.debug("{}","filPath======="+filPath);
			//Platform.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",filPath,inrs[index]+".properties");
			String pdfPath = filPath + "/" + this.getTplgrp().getBilmdl().getPdfurl()+".pdf";
			log.debug("{}","filName======="+pdfPath);
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdfPath,newPdf,"",this.getTplp().getPreview());
			log.debug("{}","Quit preview=======");

			return true;
        }

        /**
        *   source:bettpl4.@0002.script
        */
        @Rule(target="tplp.sav",order=100)
        public boolean ruleTplpSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Enter sav========");
			Map<String,Object> df = new HashMap<String,Object>();
			for(int i = 0;i < this.getTplgrp().getMdltmp().fullSize(); i++)
			  df.put(this.getTplgrp().getMdltmp().getElement(i).getDfnam(),this.getTplgrp().getMdltmp().getElement(i).getDesrip());
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/docFile");
			MdaUtils.invoke("com.brilliance.swift.SwiftPacker","saveDataToFile",df,filPath,this.getTplgrp().getBilmdl().getInr()+".properties");
			MdaUtils.clear(this.getTplgrp().getMdltmp());
			
			log.debug("{}","Quit sav========");

			return true;
        }

        /**
        *   source:bettpl4.@0003.script
        */
        @Rule(target="tplp.cancel",order=100)
        public boolean ruleTplpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:bettpl4.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTplgrp().getBilmdl().copyValue((IModule)ctx.restoreData("com.brilliance.bettpl.bilmdl"));
			//int x = Integer.valueOf($tplgrp\\bilmdl\\modtyp.getValue()) + 1;
			//log.debug("xxxxxxx===="+x);
			this.getTplp().setAlldocnam(MdaUtils.getCodetableLabel("docclstyp",this.getTplgrp().getBilmdl().getModtyp()));
			String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/bilmdl/docFile");
			String filNam = this.getTplgrp().getBilmdl().getInr() + ".properties";
			Map<String,Object> df = (Map<String,Object>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filPath,filNam);
			Argument<String> dfnam = new Argument<String>("dfnam");
			Argument<String> desrip = new Argument<String>("desrip");
			for(Object key:df.keySet())
			{
			  dfnam.value = key.toString();
			  desrip.value = (String)df.get(key);
			  log.debug("{}",dfnam.value+" == "+desrip.value);
			  this.getTplgrp().getMdltmp().add(dfnam,desrip);
			}

			return true;
        }







}