package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BilchkVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* (银行端)代理审单
*/
@Transaction(vo= BilchkVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bilchk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bilchk.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Spt wrkspt;


		public Bilchk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bilchk.@0000.script
        */
        @Rule(target="mtabut.submit",order=100)
        public boolean ruleMtabutSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!accessRight())
			  return true;
			ctx.getDaoSession().dbBegin();
			ctx.absGet(Trnmod.class).sigWrite("O","0");
			ctx.absGet(Trnmod.class).getTrn().setRelres("O");
			ctx.absGet(Trnmod.class).getTrn().setRelreq("OA");
			ctx.absGet(Trnmod.class).getTrn().setNxtreq("A");
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("1");
			ctx.absGet(Trnmod.class).getTrn().setObjtyp(this.getSysmod().getSpt().getObjtyp());
			ctx.absGet(Trnmod.class).getTrn().setObjinr(this.getSysmod().getSpt().getObjinr());
			this.getTrnmod().getTrn().setObjnam(this.getSysmod().getSpt().getObjnam());
			ctx.absGet(Trnmod.class).getTrn().setOrdinr(this.getSysmod().getSpt().getOrdinr());
			ctx.absGet(Trnmod.class).getTrn().setPtyinr(this.getSysmod().getPty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setOwnref(this.getSysmod().getSpt().getOwnref());
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("1");
			ctx.absGet(Trnmod.class).getTrn().setIniusr(this.getSysmod().getUsr().getInr());
			ctx.absGet(Trnmod.class).getTrn().setInifrm(ctx.getTransName());
			ctx.absGet(Trnmod.class).getTrn().setInidattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getTrn().setCfmdattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getTrn().setOptptyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setEtyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setEtginr(this.getSysmod().getEtg().getInr());
			ctx.absGet(Trnmod.class).getTrn().setBchcod(ctx.absGet(Sysmod.class).getPty().getCid());
			ctx.absGet(Trnmod.class).getTrn().setOptetyinr(this.getSysmod().getEty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setOptetginr(this.getSysmod().getEtg().getInr());
			ctx.absGet(Trnmod.class).getTrn().setSta("W");
			// $\\trnmod\\trn\\oritrninr = $\\sysmod\\spt\\oritrninr ;
			ctx.absGet(Trnmod.class).getTrn().setNam("todo...");
			ctx.absGet(Trnmod.class).getTrn().setInr(Platform.sdbCounter("trn"));
			ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getTrn());
			//save dsp file
			String trninr=this.getTrnmod().getTrn().getInr();
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			//save the xml files,fileneme:$\\trnmod\\trn\\inr.properties
			String grptyp=ctx.absGet(Sysmod.class).getSpt().getObjtyp();
			IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			IStream is=ctx.absGet(Mtabut.class).getTrnstm();
			MdaUtils.saveData(mod,is);
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			if(!MdaUtils.isEmpty(grp))
			{
			  log.info("{}","saveData---grp2="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp),is);
			}
			// 20150311 MOD BY DG
			ctx.absGet(Sysmod.class).streamSaveInSubdir(is,"trndata/"+trninr.substring(0,4),trninr+".dat");

			createAppFile("betcdv",trninr);
			createAppFile("betcdv1",trninr+"1");
			setNoticeEntry(trninr+".app,0;"+trninr+"1.app,1;"+trninr+".app,2");
			//save trndat
			this.getTrnmod().getTrn().setOriinr(this.getWrkspt().getInr());
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  ctx.getDaoSession().dbDelete(ctx.absGet(Sysmod.class).getSpt());
			}
			ctx.getDaoSession().dbCommit();
			//
			this.getBetp().encodeApl();
			ctx.setMessage(MdaUtils.getI18NString("bilchk","CT000004"),MdaUtils.getI18NString("bilchk","CT000005"));
			

			return true;
        }

        /**
        *   source:bilchk.@0003.script
        */
        @Rule(target="mtabut.table",order=100)
        public boolean ruleMtabutTableN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream ms=this.getMtabut().getTable();
			String trn = "betcdv";
			log.info("{}","trn="+trn );
			log.info("{}","TO Execute genePdfByTrn..." );
			String tenor=null;
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			  tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			else
			{
			  if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenmaxday()))
			  {
			    tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor()) +
			      " "+this.getLedgrp().getRec().getTenmaxday()+" Days "+MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			  }
			}
			this.getBedgrp().setTenors(tenor);
			//arg1:perportiese  arg2: arg3:pdfFile arf4:stream
			this.getSysmod().getPdfmod().genePdfByTrn(trn,"",trn,ms,false);

			return true;
        }

        /**
        *   source:bilchk.@0005.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream ms=this.getMtabut().getApldoc();
			String trn = "betcdv";
			log.info("{}","TO Execute genePdfByTrn..." );
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getAddamt()))
			  this.getBedgrp().setAdded("CHARGES TO BE ADDED	:");
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getDecamt()))
			  this.getBedgrp().setDeducted("CHARGES TO BE DEDUCTED	:");
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getMatdat()))
			  this.getBedgrp().setMatlab("MATURITY DATE          :");
			String tenor=null;
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			  tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			else
			{
			  if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenmaxday()))
			  {
			    tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor()) +
			      " "+this.getLedgrp().getRec().getTenmaxday()+" Days "+MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			  }
			}
			this.getBedgrp().setTenors(tenor);
			//arg1:perportiese  arg2: arg3:pdfFile arf4:stream
			this.getBetp().encodeApl();
			this.getSysmod().getPdfmod().genePdfByTrn(trn+"1","",trn+"1",ms,false);

			return true;
        }

        /**
        *   source:bilchk.@0007.script
        */
        @Rule(target="bedgrp.rec.doccur",order=100)
        public boolean ruleBedgrpRecDoccurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getAddamt())   ||   !MdaUtils.isEmpty(this.getBedgrp().getRec().getDecamt()))
			{
			  BigDecimal tmpamt=(this.getBedgrp().getRec().getDocamt()).add(this.getBedgrp().getRec().getAddamt());
			  BigDecimal balamt=tmpamt.subtract(this.getBedgrp().getRec().getDecamt());
			  this.getBedgrp().getRec().setClmamt(balamt);
			  
			}

			return true;
        }

        /**
        *   source:bilchk.@0008.script
        */
        @Rule(target="betp.add",order=100)
        public boolean ruleBetpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBetp().getDocgrdm().getDocgrd().add();
			

			return true;
        }

        /**
        *   source:bilchk.@0009.script
        */
        @Rule(target="betp.del",order=100)
        public boolean ruleBetpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size=this.getBetp().getDocgrdm().getDocgrd().fullSize();
			//  log.info(#CT000006+size);
			if(size>0)
			{
			  boolean delflag=false;
			  for(int i=0;i<size;i++ )
			  {
			    if("X".equals(this.getBetp().getDocgrdm().getDocgrd().getElement(i).getModflg()))
			    {
			      delflag=true;
			      this.getBetp().getDocgrdm().getDocgrd().remove(i);
			      size=this.getBetp().getDocgrdm().getDocgrd().fullSize();
			      i--;
			    }
			  }
			  
			  if (!delflag)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bilchk","CT000007"),MdaUtils.getI18NString("bilchk","CT000008"));
			  }
			}

			return true;
        }

        /**
        *   source:bilchk.@0011.script
        */
        @Rule(target="mtabut.rembtbl",order=200)
        public boolean ruleMtabutRembtblN200(){
            IContext ctx = MdaEnv.getContext();
            
			IStream ms=this.getMtabut().getRembtbl();
			String trn = "betcdv";
			log.info("{}","TO Execute genePdfByTrn..." );
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getAddamt()))
			  this.getBedgrp().setAdded("CHARGES TO BE ADDED	:");
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getDecamt()))
			  this.getBedgrp().setDeducted("CHARGES TO BE DEDUCTED	:");
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getMatdat()))
			  this.getBedgrp().setMatlab("MATURITY DATE    :");
			String tenor=null;
			if("S".equals(this.getLedgrp().getRec().getTenor()))
			  tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor());
			else
			{
			  if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getTenmaxday()))
			  {
			    tenor=MdaUtils.getCodetableLabel("tenor",this.getLedgrp().getRec().getTenor()) +
			      " "+this.getLedgrp().getRec().getTenmaxday()+" Days "+MdaUtils.getCodetableLabel("usapro",this.getLedgrp().getRec().getUsapro());
			  }
			}
			this.getBedgrp().setTenors(tenor);
			//arg1:perportiese  arg2: arg3:pdfFile arf4:stream
			
			this.getSysmod().getPdfmod().genePdfByTrn(trn,"",trn+"2",ms,false);

			return true;
        }



        /**
        *   source:bilchk.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getBetp().getDocgrdm().decode(this.getBedgrp().getRec().getDocgrd());
			/*
			  if(!Platform.isEmpty($sysmod\\spt\\inr))
			  {
			  log.info("spt inr="+$sysmod\\spt\\inr.getValue());
			  String subpty=$sysmod\\spt\\scrpty.getValue();
			  //$audgrp\\aud\\ownref.setValue($\\sysmod\\spt\\ownref.getValue());
			  String trnname=$sysmod\\spt\\frm.getValue();
			  //loadDataByOwnref(trnname);
			  String clientid=$trnmod.getCidFromInr(subpty);
			  String nam=$trnmod.getPtyName(subpty);
			  //$audgrp\\aud\\clientid.setValue(clientid);
			  //$audgrp\\aud\\clientnam.setValue(nam);
			  //load data from file
			  String grptyp=$sysmod\\spt\\objtyp.getValue();
			  IModule mod=Platform.getModule($\\,grptyp+"grp");
			  Platform.clear(mod);
			  String path=Platform.catPath(Platform.getRootPath(),"data/trndata");
			  String filename=Platform.catPath(path,$sysmod\\spt\\scrtxt.getValue()+".dat");
			  if(!Platform.fileExists(filename))
			  return;
			  //IStream is=$trnstm.getValue();
			  Platform.streamLoad(is,filename);
			  Platform.loadData(mod,is);
			  //....
			  IDatafield advdat=Platform.getDatafield($\\,grptyp+"grp\\\\rec\\\\advdat");
			  advdat.setValue(Platform.today());
			  }
			  */
			log.info("{}","init in root order 100");
			this.getBedgrp().getRec().setDoccur(this.getBedgrp().getRec().getOpncur());
			this.getBedgrp().getRec().setDocamt(this.getBedgrp().getRec().getOpnamt());
			this.getBedgrp().getRec().setModcur(this.getBedgrp().getRec().getOpncur());
			this.getBedgrp().getRec().setClmamt(this.getBedgrp().getRec().getOpnamt());
			this.getBedgrp().getRec().setDocdat(MdaUtils.today());
			this.getBedgrp().getRec().setRcvdat(MdaUtils.today());
			this.getBedgrp().getRec().setPredat(this.getBedgrp().getCmcrecd().getPrsnton());
			if(!MdaUtils.isEnabled(this.getBedgrp().getRec(),"opndat"))
			{
			  
			}

			return true;
        }


        /**
        *   source:bilchk.@0001.script
        */
        public void setNoticeEntry(String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","setNoticeEntry..." );

			String docpath=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),filename.substring(0,4));
			//generate spt record
			this.getTrnmod().getSmh().setXmlfil(filename);
			this.getTrnmod().getSmh().setDocpth(docpath);
			this.getTrnmod().getSmh().setOrdinr(this.getTrnmod().getTrn().getOrdinr());
			this.getTrnmod().getSmh().setObjtyp("spt");
			this.getTrnmod().getSmh().setDir("I");
			this.getTrnmod().getSmh().setCreusr(this.getSysmod().getUsr().getInr());
			this.getTrnmod().getSmh().setCredattim(new Date());
			this.getTrnmod().getSmh().setMsgtyp("1");
			this.getTrnmod().getSmh().setMsgsta("1");
			this.getTrnmod().getSmh().setInr(Platform.sdbCounter("smh"));
			this.getSysmod().sdbInsert(ctx.absGet(Trnmod.class).getSmh());
			this.getWrkspt().setSmhinr(this.getTrnmod().getSmh().getInr());
			this.getWrkspt().setPtyinr(this.getTrnmod().getTrn().getPtyinr());
			this.getWrkspt().setOprogninr(this.getSysmod().getPty().getInr());
			this.getWrkspt().setSta("W");
			this.getWrkspt().setScr("A");
			this.getWrkspt().setDattim(MdaUtils.today());
			this.getWrkspt().setOwnref(this.getTrnmod().getTrn().getOwnref());
			this.getWrkspt().setOrdinr(this.getTrnmod().getTrn().getOrdinr());
			this.getWrkspt().setObjnam("代理审单通知");
			this.getWrkspt().setObjtyp(this.getSysmod().getSpt().getObjtyp());
			this.getWrkspt().setFrm("betcdv");

			this.getWrkspt().setInr(Platform.sdbCounter("spt"));
			this.getSysmod().sdbInsert(this.getWrkspt());
			log.info("{}","create notice spt ok...inr="+this.getWrkspt().getInr());
			String sourcefile=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"dat");
			String targetfile=this.getSysmod().createFilename(this.getWrkspt().getInr(),"bak");
			MdaUtils.fileCopy(sourcefile,targetfile);
		}
        /**
        *   source:bilchk.@0004.script
        */
        public void createAppFile(String cfgfile,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","save apply file");
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),cfgfile,"PDF");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),filename.substring(0,4));
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			String clsNam = "com.brilliance.swift.SwiftPacker";
			MdaUtils.invoke(clsNam,"saveDataToFile",data,path,filename+".app");
		}
        /**
        *   source:bilchk.@0010.script
        */
        public boolean accessRight()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String logusrinr=this.getSysmod().getUsr().getInr();
			Argument<String> trn =new Argument<String>("trn");
			/*
			  String query="SELECT e.frm trn FROM usr a,usrrol b,rolpro d,modlst e WHERE "+
			  "b.usrinr=a.inr AND b.rolinr=d.rolinr AND d.frminr=e.inr AND e.ptytyp='0' AND"+
			  " a.inr='"+logusrinr+"' AND e.frm='combus'";
			  */
			String query="SELECT d.frminr trn FROM usr a,usrrol b,rol c,rolpro d WHERE b.usrinr=a.inr AND b.rolinr=c.inr AND b.rolinr=d.rolinr AND a.inr='"+logusrinr+"' AND trim(d.frminr)='combus'";
			ctx.getDaoSession().dbExecuteSQL(query);
			ctx.getDaoSession().dbFetchFields(trn);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_MORE_ROW)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bilchk","CT000009"),MdaUtils.getI18NString("bilchk","CT000010"));
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}











}