package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bilchk0VO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* (银行端)代理审单查询
*/
@Transaction(vo= Bilchk0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bilchk0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bilchk0.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private ModuleList<Spt> sptlst;


		public Bilchk0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bilchk0.@0000.script
        */
        @Rule(target="sptlst",order=200)
        public boolean ruleSptlstN200(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  // $sysmod\\spt.copyValue($sptlst.get(index));
			  //String filename=$sptlst[index]\\inr.getValue()+".bak";
			
			  ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument("inr",this.getSptlst().getElement(index).getInr()));
			  
			}

			return true;
        }

        /**
        *   source:bilchk0.@0004.script
        */
        @Rule(target="btnmod.submit",order=100)
        public boolean ruleBtnmodSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  this.getSysmod().getSpt().copyValue(this.getSptlst().get(index));
			  //String filename=$sptlst[index]\\inr.getValue()+".bak";
			  
			}

			return true;
        }

        /**
        *   source:bilchk0.@0005.script
        */
        @Rule(target="btnmod.fresh",order=100)
        public boolean ruleBtnmodFreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			//Platform.dbReadset($sptlist,new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","T"),new Argument<Object>("frm",IN,frms));
			ctx.getDaoSession().dbReadset(this.getSptlst(),new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","H"),new Argument<Object>("dattim",DESC));
			// Platform.dbCloseCursor();
			

			return true;
        }



        /**
        *   source:bilchk0.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			//Platform.dbReadset($sptlist,new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","T"),new Argument<Object>("frm",IN,frms));
			ctx.getDaoSession().dbReadset(this.getSptlst(),new Argument<String>("oprogninr",ptyinr),new Argument<String>("sta","H"),new Argument<Object>("dattim",DESC));
			// Platform.dbCloseCursor();
			

			return true;
        }






}