package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BmtameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Bmtmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bmdgrp;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Bmtp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方证项下改单通知
*/
@Transaction(vo= BmtameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bmtame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bmtame.class);

		@BDGetter
		private Bmdgrp bmdgrp;

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Bmtmod bmtmod;

		@BDGetter
		private Bmtp bmtp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Bmtame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBmtmod().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtmod().setDedgrpHolder(()->this.getDedgrp());
           this.getBmtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBmtp().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtp().setDedgrpHolder(()->this.getDedgrp());
           this.getBmtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bmtame.this.getBmdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bmtame.this.getBmdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.bchcod");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.doccur");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.inr");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.ownref");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtame.this.getFieldPath("bmdgrp.rec.stlref");}
 				public void setValue(String arg){Bmtame.this.getBmdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bmtame.this.getBmdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBmdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bmtame.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:bmtame.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck(this.getBmtp().getBmtp15());

			return true;
        }












}