package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BmtdisVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Bmtmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bmdgrp;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Bmtp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方国内证不符点通知
*/
@Transaction(vo= BmtdisVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bmtdis extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bmtdis.class);

		@BDGetter
		private Bmdgrp bmdgrp;

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Bmtmod bmtmod;

		@BDGetter
		private Bmtp bmtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Bmtdis()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBmtmod().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtmod().setDedgrpHolder(()->this.getDedgrp());
           this.getBmtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBmtp().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtp().setDedgrpHolder(()->this.getDedgrp());
           this.getBmtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Bmtdis.this.getBmdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Bmtdis.this.getBmdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.bchcod");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.doccur");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.inr");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.ownref");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtdis.this.getFieldPath("bmdgrp.rec.stlref");}
 				public void setValue(String arg){Bmtdis.this.getBmdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bmtdis.this.getBmdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBmdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }














}