package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BnkchkVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Notmod;
import com.ceb.gjjs.mda.bo.Grn;
import com.ceb.gjjs.mda.manager.module.Wrnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行审核中
*/
@Transaction(vo= BnkchkVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bnkchk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bnkchk.class);

        //刷新
        private transient IControl refresh = new ControlImpl("refresh", "刷新", this);
        //查看
        private transient IControl detail = new ControlImpl("detail", "查看", this);
        //display
        private String display;
        //excel下载
        private IStream download = new StreamImpl();
        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);
        //业务流水编号
        private String trninr;
        //temp stream
        private IStream temstm = new StreamImpl();
        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);
        //国结退回
        private String bakflg;
        //业务来源
        private String baktyp;
        //业务来源描述
        private String baktyplab;
        //退回
        private transient IControl retbak = new ControlImpl("retbak", "退回", this);
        //操作方式
        private String opensta;
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private ModuleList<Trn> chklst;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trn wrktrn;

		@BDGetter
		private Grn wrkgrn;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Swmmod swmmod;

		@BDGetter
		private Wrnmod wrnmod;

		@BDGetter
		private Notmod notmod;


		public Bnkchk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bnkchk.@0001.script
        */
        @Rule(target="detail",order=100)
        public boolean ruleDetailN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getChklst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000415"),MdaUtils.getI18NString("bnkchk","CT000416"));
			  return true;
			}
			String refname = this.getChklst().getElement(index).getOwnref();
			log.debug("{}","bnkchk.query start,and ownref is:" + refname);
			String trninr1 = this.getChklst().getElement(index).getInr();
			if(!"0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  this.setTrninr(trninr1);
			}
			else
			{
			  //银行端待办夹提交业务会新产生一条trn,取之前的trninr来关联影像信息
			  this.setTrninr(this.getChklst().getElement(index).getOriinr());
			}

			if(MdaUtils.isEmpty(this.getTrninr()))
			{
			  this.setTrninr(getAppFilename(this.getChklst().getElement(index).getInr(),this.getChklst().getElement(index).getOrdinr(),this.getSysmod().getPty().getPtytyp()));
			}
			log.debug("{}","trninr=" +this.getTrninr());
			this.loadDataByInr(this.getTrninr());
			if("W".equals(this.getChklst().getElement(index).getBaksta()))
			{
			  
			}
			else
			{
			  
			}
			
			//$opensta.setValue("O");
			

			return true;
        }

        /**
        *   source:bnkchk.@0002.script
        */
        @Rule(target="refresh",order=100)
        public boolean ruleRefreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.debug("{}","ptytyp=  "+ptytyp);
			MdaUtils.clear(this.getChklst());

			String ptyinr=this.getSysmod().getPty().getInr();
			if("0".equals(ptytyp))
			{
			  doFresh();
			}
			else if("1".equals(ptytyp))
			{
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("ptytyp","1"),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			else
			{
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("ptytyp","2"),new Argument<String>("ptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			

			return true;
        }

        /**
        *   source:bnkchk.@0004.script
        */
        @Rule(target="chklst",order=1000)
        public boolean ruleChklstN1000(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getChklst().fullSize())
			  return true;

			String refname = this.getChklst().getElement(index).getOwnref();
			log.debug("{}","bnkchk.chklst onDblClick start,ownref is:" + refname);
			//remark
			String trninr1 = this.getChklst().getElement(index).getInr();
			if(!"0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  this.setTrninr(trninr1);
			}
			else
			{
			  //银行端待办夹提交业务会新产生一条trn,取之前的trninr来关联影像信息
			  this.setTrninr(this.getChklst().getElement(index).getOriinr());
			}

			if(MdaUtils.isEmpty(this.getTrninr()))
			{
			  this.setTrninr(getAppFilename(this.getChklst().getElement(index).getInr(),this.getChklst().getElement(index).getOrdinr(),this.getSysmod().getPty().getPtytyp()));
			}
			
			log.debug("{}","trninr=" +this.getTrninr());
			this.loadDataByInr(this.getTrninr());
			//$opensta.setValue("O");
			
			/*
			  Platform.clear($rmkmod\\otext);
			  Platform.clear($rmkmod\\ntext);
			  Platform.dbRead($rmkmod\\rmk,new Argument<String>("trninr",$trninr.getValue()));
			  $rmkmod\\otext.setValue($rmkmod\\rmk\\txt.getValue());
			  Platform.setModified($rmkmod\\otext);
			  String trninr = getAppFilename($chklst[index]\\inr.getValue(),$chklst[index]\\ordinr.getValue(),$sysmod\\pty\\ptytyp.getValue());
			  String tfile = $\\sysmod.createFilename(trninr,"dra");
			  String frm = $chklst[index]\\inifrm.getValue();
			  log.info("dra FILE="+tfile );
			  if(!("litopn".equals(frm)||"litame".equals(frm)||"gitopn".equals(frm)||"gitame".equals(frm)||"littrs".equals(frm)))
			  {
			  Platform.invisible($btnmod\\msg);
			  }
			  else
			  {
			  log.info("file "+tfile+" exists..." );
			  Platform.visible($btnmod\\msg);
			  }
			  if("litopn".equals(frm)|| "litame".equals(frm) || "gitopn".equals(frm) || refname.startsWith("OR"))
			  {
			  Platform.enable($btnmod\\msg);
			  Platform.visible($btnmod\\msg);
			  }
			  else
			  {
			  Platform.disable($btnmod\\msg);
			  Platform.invisible($btnmod\\msg);
			  }
			  Platform.setModified($btnmod\\msg);
			  String mfile = $\\sysmod.createFilename(trninr,"app");
			  log.info("app FILE="+mfile );
			  if(Platform.fileExists(mfile))
			  $btnmod.initAppButton($chklst[index]\\inifrm.getValue());
			  else
			  $btnmod.initAppButton("");
			  Platform.writeToSession("dspfile",$chklst[index]\\inr.getValue());//token，用来判断请求唯一性
			  log.info("session dspfile :"+Platform.readFromSession("dspfile"));
			  String filename="/data/dsp/"+$chklst[index]\\inr.getValue().substring(0,4)+"/"+$chklst[index]\\inr.getValue()+".zul";
			  $display.setValue("/dsp"+filename);
			  Platform.visible($btnmod\\apldoc);
			  Platform.setModified($btnmod\\apldoc);
			  Platform.showPanel($details);*/

			return true;
        }

        /**
        *   source:bnkchk.@0005.script
        */
        @Rule(target="btnmod.msg",order=100)
        public boolean ruleBtnmodMsgN100(){
            IContext ctx = MdaEnv.getContext();
            

			log.info("{}","into msg..." );
			int index=-1;
			index=0;
			if(index!=-1)
			{

			  String fpath=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),this.getChklst().getElement(index).getInr().substring(0,4));
			  String tfile=this.getChklst().getElement(index).getInr()+".dra";
			  log.info("{}", fpath+"\\"+tfile);
			  String trnname=this.getChklst().getElement(index).getInifrm();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(fpath,tfile)))
			  {
			    log.info("{}","to show the file..." );
			    IStream stream=this.getBtnmod().getMsg();
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadDraftDataFromFile",fpath,tfile);
			    log.info("{}","filenam="+tfile);
			    Map<String,String[]> dmap  = (Map<String,String[]>) data;
			    String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,trnname,waterfilePath);
			  }
			  else
			  {
			    //todo
			    ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000034"),MdaUtils.getI18NString("bnkchk","CT000035"));
			  }
			}

			return true;
        }

        /**
        *   source:bnkchk.@0006.script
        */
        @Rule(target="btnmod.apldoc",order=100)
        public boolean ruleBtnmodApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into apldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getChklst().getElement(index).getInr();
			String ordinr = this.getChklst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			/*if("bptopl".equals($chklst[index]\\inifrm.getValue()))
			  {
			  String inifrm=$chklst[index]\\inifrm.getValue()+"1";
			  $btnmod.showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  inifrm,"apldoc",$btnmod\\apldoc.getValue());
			  }
			  else
			  {*/
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getChklst().getElement(index).getInifrm(),"apldoc",this.getBtnmod().getApldoc());
			//}
			
			return true;
        }

        /**
        *   source:bnkchk.@0007.script
        */
        @Rule(target="btnmod.search",order=100)
        public boolean ruleBtnmodSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date betdat =this.getBtnmod().getBegdat();
			Date enddat=this.getBtnmod().getEnddat();
			if(MdaUtils.diff(betdat,enddat)>0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000169"),MdaUtils.getI18NString("bnkchk","CT000170"));
			  return true;
			}

			doFresh();

			return true;
        }

        /**
        *   source:bnkchk.@0008.script
        */
        @Rule(target="btnmod.history",order=100)
        public boolean ruleBtnmodHistoryN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  String inr=this.getChklst().getElement(index).getInr();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",inr));
			  if(!MdaUtils.isEmpty(this.getTrnmod().getTrn().getOwnref()))
			  {
			    if(this.getTrnmod().getTrn().getOwnref().startsWith("WP") || this.getTrnmod().getTrn().getOwnref().startsWith("EQ"))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000082"),MdaUtils.getI18NString("bnkchk","CT000083"));
			      return true;
			    }
			  }
			  //201709 增加确认操作提示
			  if(MdaUtils.prompt("",MdaUtils.getI18NString("bnkchk","CT000084")))
			    return true;
			  this.getTrnmod().getTrn().setSta("A");
			  this.getTrnmod().getTrn().setCfmdattim(MdaUtils.today());
			  ctx.getDaoSession().dbBegin();
			  ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			  ctx.getDaoSession().dbCommit();
			  ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000085"),MdaUtils.getI18NString("bnkchk","CT000091"));
			  MdaUtils.showMainPanel();
			  freshss();
			}

			return true;
        }

        /**
        *   source:bnkchk.@0010.script
        */
        @Rule(target="btnmod.bot",order=100)
        public boolean ruleBtnmodBotN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into bot..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getChklst().getElement(index).getInr();
			String ordinr = this.getChklst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getChklst().getElement(index).getInifrm(),"bot",this.getBtnmod().getBot());

			return true;
        }

        /**
        *   source:bnkchk.@0011.script
        */
        @Rule(target="btnmod.tdapldoc",order=100)
        public boolean ruleBtnmodTdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into tdapldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getChklst().getElement(index).getInr();
			String ordinr = this.getChklst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getChklst().getElement(index).getInifrm(),"tdapldoc",this.getBtnmod().getTdapldoc());

			return true;
        }

        /**
        *   source:bnkchk.@0012.script
        */
        @Rule(target="btnmod.pdapldoc",order=100)
        public boolean ruleBtnmodPdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into pdapldoc..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getChklst().getElement(index).getInr();
			String ordinr = this.getChklst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getChklst().getElement(index).getInifrm(),"pdapldoc",this.getBtnmod().getPdapldoc());

			return true;
        }

        /**
        *   source:bnkchk.@0013.script
        */
        @Rule(target="btnmod.table",order=100)
        public boolean ruleBtnmodTableN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","into table..." );
			int index=-1;
			index=0;
			if(index==-1)
			  return true;
			String trninr = this.getChklst().getElement(index).getInr();
			String ordinr = this.getChklst().getElement(index).getOrdinr();
			String ptytyp = this.getSysmod().getPty().getPtytyp();
			this.getBtnmod().showAppPdfFile(getAppFilename(trninr,ordinr,ptytyp),
			  this.getChklst().getElement(index).getInifrm(),"table",this.getBtnmod().getTable());

			return true;
        }

        /**
        *   source:bnkchk.@0016.script
        */
        @Rule(target="download",order=100)
        public boolean ruleDownloadN100(){
            IContext ctx = MdaEnv.getContext();
            
			List<Object[]> lst = new ArrayList<Object[]>();
			String tit[] = new String[6];
			tit[0] = "参考号";
			tit[1] = "币种";
			tit[2] = "金额";
			tit[3] = "客户名称";
			tit[4] = "交易类型";
			tit[5] = "时间";
			lst.add(tit);
			int len = this.getChklst().fullSize();
			log.debug("{}","len="+len);
			for(int i=0;i<len;i++)
			{
			  log.debug("{}",""+i);
			  String[] line = new String[6];
			  line[0] = this.getChklst().getElement(i).getOwnref();
			  line[1] = this.getChklst().getElement(i).getReloricur();
			  line[2] = this.getChklst().getElement(i).getReloriamt().toString();
			  line[3] = this.getChklst().getElement(i).getNam();
			  String frm = this.getChklst().getElement(i).getInifrm();
			  line[4] = MdaUtils.getCodetableLabel("trans",frm);
			  if(MdaUtils.isEmpty(this.getChklst().getElement(i).getInidattim()))
			    line[5] ="";
			  else
			    line[5] = MdaUtils.format(this.getChklst().getElement(i).getInidattim(),"yyyyMMdd HH:mm");
			  lst.add(line);
			}
			log.debug("{}","lst "+lst.size());
			IStream is=this.getDownload();
			is.setType("xls");
			String today = MdaUtils.format(MdaUtils.today(),"yyyyMMdd-HH:mm:ss");
			String fileName = "银行审核中文件-"+today+".xls";
			try
			{
			  is.setName(new String(fileName.getBytes("GBK"),"GBK"));
			}
			catch(Exception e)
			{
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:bnkchk.@0017.script
        */
        @Rule(target="imgviw",order=100)
        public boolean ruleImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}"," in imgviw....");
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().imgScans(this.getTrninr());
			log.debug("{}"," out imgviw....");

			return true;
        }

        /**
        *   source:bnkchk.@0019.script
        */
        @Rule(target="btnmod.back",order=500)
        public boolean ruleBtnmodBackN500(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int index = -1;
			  if(index<0||index>=$chklst.fullSize())
			  {
			  index=Platform.getSelectedRowIndex($chklst);
			  if(index<0||index>=$chklst.fullSize())
			  {
			  Platform.message("",#CT000129);
			  return;
			  }
			  }
			
			  Platform.clear($wrktrn);
			  String trninr = $chklst[index]\\inr.getValue();
			  Platform.dbRead($wrktrn,new Argument<String>("inr",trninr));
			  if("D".equals($wrktrn\\wfm.getValue()))
			  {
			  if(!"cptapl".equals($wrktrn\\inifrm.getValue()))
			  {
			  Platform.message(#CT000130,#CT000131);
			  return false;
			  }
			  Platform.clear($cpdgrp\\rec);
			  Platform.dbRead($cpdgrp\\rec,new Argument("inr",$wrktrn\\objinr.getValue()));
			
			  if("A".equals($cpdgrp\\rec\\dty.getValue()))
			  {
			  if(Platform.prompt(#CT000141,#CT000142))
			  return;
			  }
			  else
			  {
			  if(Platform.prompt(#CT000145,#CT000146))
			  return;
			  }
			
			  Platform.dbBegin();
			
			  String inr = $wrktrn\\inr.getValue();
			  Map sendMap = new HashMap();
			
			  String ptytyp = $\\sysmod\\pty\\ptytyp.getValue();
			  String ownref =$wrktrn\\ownref.getValue();
			  String thly = "";
			  String msgref = "";
			  String transid="";
			  String xmltyp="";
			  sendMap.put("TransId",ownref);
			  sendMap.put("Reason",thly);
			  sendMap.put("SendTime",Platform.format(Platform.today(),"yyyyMMddHHmmss"));
			  sendMap.put("ImgStatusAll","");
			  sendMap.put("buscod",ownref);
			  sendMap.put("djcod",ownref);
			  sendMap.put("inr",$wrktrn\\objinr.getValue());
			  log.debug("cpd inr is :"+$cpdgrp\\rec\\inr.getValue());
			  transid=$cpdgrp\\rec\\transid.getValue();
			  msgref = $cpdgrp\\rec\\msgref.getValue();
			  if("cptapl".equals($wrktrn\\inifrm.getValue()))
			  {
			  xmltyp="SFS118";
			  }
			  if("cptopn".equals($wrktrn\\inifrm.getValue()))
			  {
			  xmltyp="SFS113";
			  sendMap.put("OutBankStatus","");
			  }
			  //银行退回
			  sendMap.put("TransStatus","06");
			  sendMap.put("TransId",transid);
			  sendMap.put("MsgNo",xmltyp);
			  sendMap.put("code",xmltyp);
			  sendMap.put(" EntMarkNo",$cpdgrp\\rec\\stlref.getValue());
			  $sysmod.setImageMapSwi(sendMap);
			  $sysmod.setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,"");
			  $swmmod.storeSWM(xmltyp,$trnmod\\trn\\objinr.getValue(),$trnmod\\trn\\objtyp.getValue(),sendMap);
			
			  //相关数据表数据更新
			  String scrtrninr=$wrktrn\\oriinr.getValue();
			  log.debug("[bnkchk->back] selected trninr="+trninr+",scrtrninr="+scrtrninr );
			  String ordinr=$wrktrn\\ordinr.getValue();
			
			  if(!Platform.isEmpty(scrtrninr))
			  {
			  //更新企业端那条记录的银行审核中状态为->
			  $trnmod.sdbRead($trnmod\\trn,scrtrninr);
			  $trnmod\\trn\\sta.setValue("A");
			  Platform.dbUpdate($trnmod\\trn);
			
			  ordinr=$trnmod\\trn\\ordinr.getValue();
			  log.debug("trn inr="+$wrktrn\\inr.getValue()+",ordinr="+ordinr);
			  }
			  else
			  {
			  log.warn("更新错误！找不到企业端业务记录");
			  return false;
			  }
			
			  $trnmod\\ordmod.updateOrd(ordinr,"E","15",$rmkmod\\ntext.getValue());
			
			  $wrktrn\\cpldattim.setValue(Platform.today());
			  $wrktrn\\sta.setValue("A");
			  Platform.dbUpdate($wrktrn);
			
			  //更新历史备注
			  if(Platform.isEmpty($rmkmod\\rmk\\inr))
			  $rmkmod.loadRemarkByOrd(ordinr);
			  String txt=" 该笔业务国结已确认,E结算直接返回单一窗口入账回值！";
			  if(!Platform.isEmpty($rmkmod\\ntext))
			  {
			  txt=txt+"; 下一步提示："+$rmkmod\\ntext.getValue();
			  }
			  $rmkmod\\ntext.setValue(txt);
			  $rmkmod.updateRmk("15");
			  Platform.clear($rmkmod\\ntext);
			  Platform.clear($rmkmod\\otext);
			  Platform.clear($rmkmod\\rmk);
			  if(Platform.errorCode() == ERROR_SQL)
			  {
			  Platform.message(#CT000189,#CT000190);
			  Platform.dbRollback();
			  return false;
			  }
			  Platform.dbCommit();
			  Platform.showMainPanel();
			  fresh();
			  }
			  else
			  {
			  if(Platform.prompt("",#CT000191))
			  return;
			  if(Platform.prompt("",#CT000192))
			  return;
			
			  int errorcode=-1;
			  String ordinr=null;
			  String scrtrninr=null;
			
			  Platform.clear($sysmod\\spt);
			  //$sysmod\\spt.copyValue($bsplst.get(index));
			  Platform.dbBegin();
			  //
			  scrtrninr=$wrktrn\\oriinr.getValue();
			  log.debug("[bnkchk->back] selected trninr="+trninr+",scrtrninr="+scrtrninr );
			  ordinr=$wrktrn\\ordinr.getValue();
			
			  if(!Platform.isEmpty(scrtrninr))
			  {
			  //更新企业端那条记录的银行审核中状态为->退回
			  $trnmod.sdbRead($trnmod\\trn,scrtrninr);
			  $trnmod\\trn\\sta.setValue("B");
			  Platform.dbUpdate($trnmod\\trn);
			
			  ordinr=$trnmod\\trn\\ordinr.getValue();
			  log.debug("trn inr="+$wrktrn\\inr.getValue()+",ordinr="+ordinr);
			  }
			  else
			  {
			  log.warn("更新错误！找不到企业端业务记录");
			  return false;
			  }
			
			  Platform.dbDelete($trnmod\\usrsig,new Argument("ownref",$wrktrn\\ownref.getValue()),new Argument("trninr",scrtrninr));
			  //delete dat file
			  $trnmod\\ordmod.updateOrd(ordinr,"B","7",$\\rmkmod\\ntext.getValue());
			  if(!backSptToSubPty())
			  {
			  Platform.dbRollback();
			  Platform.message(#CT000193,#CT000194);
			  return false;
			  }
			  $wrktrn\\cpldattim.setValue(Platform.today());
			  $wrktrn\\sta.setValue("B");
			  Platform.dbUpdate($wrktrn);
			  //update remark
			  $rmkmod.updateRmk("7");
			  Platform.dbCommit();
			  Platform.message(#CT000195,#CT000196);
			  Platform.showMainPanel();
			  doFresh();
			  }
			  */

			return true;
        }

        /**
        *   source:bnkchk.@0021.script
        */
        @Rule(target="return",order=100)
        public boolean ruleReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.closePanel($details);
			//$opensta.setValue("S");
			MdaUtils.showMainPanel();

			return true;
        }

        /**
        *   source:bnkchk.@0031.script
        */
        @Rule(target="bakflg",order=100)
        public boolean ruleBakflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBakflg()))
			{
			  
			}
			else
			{
			  
			}
			
			this.doFresh();

			return true;
        }

        /**
        *   source:bnkchk.@0033.script
        */
        @Rule(target="btnmod.dyckth",order=100)
        public boolean ruleBtnmodDyckthN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","银行授权退回");
			if(MdaUtils.isEmpty(this.getBtnmod().getThly()))
			{
			  ctx.setFieldError(this,"btnmod.thly",MdaUtils.getI18NString("bnkchk","CT000249"));
			  return false;
			}
			ctx.getDaoSession().dbBegin();

			String inr = this.getWrktrn().getInr();
			Map sendMap = new HashMap();

			String ptytyp = ctx.absGet(Sysmod.class).getPty().getPtytyp();
			String ownref =this.getWrktrn().getOwnref();
			String thly = this.getBtnmod().getThly();
			String msgref = "";
			String transid="";
			String xmltyp="";
			String stl="";
			sendMap.put("Reason",thly);
			sendMap.put("SendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss"));
			sendMap.put("ImgStatusAll","");
			sendMap.put("buscod",ownref);
			sendMap.put("djcod",ownref);
			sendMap.put("inr",this.getWrktrn().getObjinr());
			if("cpd".equals(this.getWrktrn().getObjtyp()))
			{
			  MdaUtils.clear(this.getCpdgrp().getRec());
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getRec(),new Argument("inr",this.getWrktrn().getObjinr()));
			  log.debug("{}","cpd inr is :"+this.getCpdgrp().getRec().getInr());
			  transid=this.getCpdgrp().getRec().getTransid();
			  msgref = this.getCpdgrp().getRec().getMsgref();
			  if("cptapl".equals(this.getWrktrn().getInifrm()))
			  {
			    xmltyp="SFS118";
			    stl=this.getCpdgrp().getRec().getDstlref();
			  }
			  if("cptopn".equals(this.getWrktrn().getInifrm()))
			  {
			    xmltyp="SFS113";
			    stl=this.getCpdgrp().getRec().getStlref();
			    sendMap.put("OutBankStatus","");
			  }
			}
			//银行退回
			sendMap.put("TransStatus","05");
			sendMap.put("TransId",transid);
			sendMap.put("MsgNo",xmltyp);
			sendMap.put("code",xmltyp);
			sendMap.put("EntMarkNo",stl);
			this.getSysmod().setImageMapSwi(sendMap);
			this.getSysmod().setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);
			this.getSwmmod().storeSWM(xmltyp,this.getWrktrn().getObjinr(),this.getWrktrn().getObjtyp(),sendMap);

			//相关数据表数据更新
			updateTRN();
			String ordinr=this.getWrktrn().getOrdinr();
			ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","trn"));
			String wfsinr=this.getTrnmod().getWfmmod().getWfs().getInr();
			log.info("{}","deleted wfsinr="+wfsinr);
			if(!MdaUtils.isEmpty(wfsinr))
			  ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr));
			log.info("{}","delete wfes OK!");
			if(!MdaUtils.isEmpty(this.getTrnmod().getWfmmod().getWfs().getInr()))
			  ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfs());

			ctx.getDaoSession().dbDelete(this.getTrnmod().getUsrsig(),new Argument("ownref",this.getWrktrn().getOwnref()),new Argument("trninr",inr));

			this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","11",this.getRmkmod().getNtext());

			//更新历史备注
			if(MdaUtils.isEmpty(this.getRmkmod().getRmk().getInr()))
			  this.getRmkmod().loadRemarkByOrd(ordinr);
			String txt="退回原因："+this.getBtnmod().getThly();
			if(!MdaUtils.isEmpty(this.getRmkmod().getNtext()))
			{
			  txt=txt+"; 下一步提示："+this.getRmkmod().getNtext();
			}
			this.getRmkmod().setNtext(txt);
			this.getRmkmod().updateRmk("7");
			this.getRmkmod().setNtext(NULLSTR);
			this.getRmkmod().setOtext(NULLSTR);
			MdaUtils.clear(this.getRmkmod().getRmk());
			if(ctx.getErrorCode() == ERROR_SQL)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000250"),MdaUtils.getI18NString("bnkchk","CT000251"));
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getDaoSession().dbCommit();
			this.getBtnmod().setThly(NULLSTR);
			MdaUtils.clear(this.getWrktrn());
			MdaUtils.clear(this.getTrnmod().getTrn());
			MdaUtils.showMainPanel();
			this.doFresh();

			return true;
        }

        /**
        *   source:bnkchk.@0034.script
        */
        @Rule(target="retbak",order=100)
        public boolean ruleRetbakN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = -1;
			if(index<0||index>=this.getChklst().fullSize())
			{
			  index=0;
			  if(index<0||index>=this.getChklst().fullSize())
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("bnkchk","CT000384"));
			    return true;
			  }
			}

			MdaUtils.clear(this.getWrktrn());
			String trninr = this.getChklst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getWrktrn(),new Argument<String>("inr",trninr));
			if(!MdaUtils.isEmpty(this.getWrktrn().getWfm()))
			{
			  if("D".equals(this.getWrktrn().getWfm()))
			  {
			    
			  }
			  else if("G".equals(this.getWrktrn().getWfm()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000385"),MdaUtils.getI18NString("bnkchk","CT000386"));
			    return false;
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000387"),MdaUtils.getI18NString("bnkchk","CT000388"));
			    return false;
			  }
			}
			else
			{
			  if(MdaUtils.prompt("",MdaUtils.getI18NString("bnkchk","CT000389")))
			    return true;

			  int errorcode=-1;
			  String ordinr=null;
			  String scrtrninr=null;
			  MdaUtils.clear(this.getSysmod().getSpt());

			  ctx.getDaoSession().dbBegin();

			  scrtrninr=this.getWrktrn().getOriinr();
			  log.debug("{}","[bnkchk->back] selected trninr="+trninr+",scrtrninr="+scrtrninr );
			  ordinr=this.getWrktrn().getOrdinr();
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  if(!MdaUtils.isEmpty(scrtrninr))
			  {
			    //更新企业端那条记录的银行审核中状态为->退回
			    this.getTrnmod().sdbRead(this.getTrnmod().getTrn(),scrtrninr);
			    this.getTrnmod().getTrn().setSta("B");
			    ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());

			    ordinr=this.getTrnmod().getTrn().getOrdinr();
			    log.debug("{}","trn inr="+this.getWrktrn().getInr()+",ordinr="+ordinr);
			  }
			  else
			  {
			    log.warn("{}","更新错误！找不到企业端业务记录");
			    return false;
			  }

			  ctx.getDaoSession().dbDelete(this.getTrnmod().getUsrsig(),new Argument("ownref",this.getWrktrn().getOwnref()),new Argument("trninr",scrtrninr));

			  this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","7",ctx.absGet(Rmkmod.class).getNtext());
			  //更新历史备注
			  if(MdaUtils.isEmpty(this.getRmkmod().getRmk().getInr()))
			    this.getRmkmod().loadRemarkByOrd(ordinr);
			  this.getRmkmod().updateRmk("7");

			  //更新trn
			  this.getWrktrn().setCpldattim(MdaUtils.today());
			  this.getWrktrn().setSta("B");
			  ctx.getDaoSession().dbUpdate(this.getWrktrn());

			  //生成spt
			  if(!backSptToSubPty())
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000390"),MdaUtils.getI18NString("bnkchk","CT000391"));
			    return false;
			  }

			  ctx.getDaoSession().dbCommit();
			  MdaUtils.clear(this.getWrktrn());
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  MdaUtils.clear(this.getSysmod().getSpt());
			  ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000392"),MdaUtils.getI18NString("bnkchk","CT000393"));
			  MdaUtils.showMainPanel();
			  doFresh();
			}

			return true;
        }

        /**
        *   source:bnkchk.@0035.script
        */
        @Rule(target="btnmod.back",order=1200)
        public boolean ruleBtnmodBackN1200(){
            IContext ctx = MdaEnv.getContext();
            
			int index = -1;
			if(index<0||index>=this.getChklst().fullSize())
			{
			  index=0;
			  if(index<0||index>=this.getChklst().fullSize())
			  {
			    ctx.setMessage("提示",MdaUtils.getI18NString("bnkchk","CT000394"));
			    return true;
			  }
			}

			MdaUtils.clear(this.getWrktrn());
			String trninr = this.getChklst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getWrktrn(),new Argument<String>("inr",trninr));
			if(!MdaUtils.isEmpty(this.getWrktrn().getWfm())&&(!"G".equals(this.getWrktrn().getWfm()))&&(!"M".equals(this.getWrktrn().getWfm())))
			{
			  if("D".equals(this.getWrktrn().getWfm()))
			  {
			    
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bnkchk","CT000395"),MdaUtils.getI18NString("bnkchk","CT000396"));
			    return false;
			  }
			}
			else
			{
			  if("G".equals(this.getWrktrn().getWfm())&&MdaUtils.prompt("提示",MdaUtils.getI18NString("bnkchk","CT000397")))
			    return true;
			  else if( MdaUtils.prompt("提示",MdaUtils.getI18NString("bnkchk","CT000398")))
			    return true;
			  int errorcode=-1;
			  String ordinr=null;
			  String scrtrninr=null;
			  MdaUtils.clear(this.getSysmod().getSpt());

			  ctx.getDaoSession().dbBegin();

			  scrtrninr=this.getWrktrn().getOriinr();
			  log.debug("{}","[bnkchk->back] selected trninr="+trninr+",scrtrninr="+scrtrninr );
			  ordinr=this.getWrktrn().getOrdinr();
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  if(!MdaUtils.isEmpty(scrtrninr))
			  {
			    //更新企业端那条记录的银行审核中状态为->退回
			    this.getTrnmod().sdbRead(this.getTrnmod().getTrn(),scrtrninr);
			    this.getTrnmod().getTrn().setSta("B");
			    //$trnmod\\trn\\bakref.setValue($wrktrn\\bakref.getValue());
			    this.getTrnmod().getTrn().setBaksta("B");
			    ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());

			    //判断交易为汇入汇出
			    if("cptopn".equals(this.getTrnmod().getTrn().getInifrm()) || "cptapi".equals(this.getTrnmod().getTrn().getInifrm()))
			    {
			      MdaUtils.clear(this.getNotmod().getPty());
			      ctx.getDaoSession().dbRead(this.getNotmod().getPty(),new Argument<String>("inr",this.getTrnmod().getTrn().getPtyinr()));
			      String cid = this.getNotmod().getPty().getCid();
			      // 判断开关
			      boolean flg=this.getNotmod().checkSwitch(cid);
			      log.debug("{}","cid:"+cid+"flg:"+flg);
			      if(flg)
			      {
			        this.getNotmod().msgtask(cid,this.getTrnmod().getTrn(),"3","5392","J",null,"Y");
			      }
			    }

			    ordinr=this.getTrnmod().getTrn().getOrdinr();
			    log.debug("{}","trn inr="+this.getWrktrn().getInr()+",ordinr="+ordinr);
			  }
			  else if("G".equals(this.getWrktrn().getWfm()))
			  {
			    log.debug("{}","合作平台业务退回  ：trn inr="+this.getWrktrn().getInr()+",ordinr="+ordinr);
			  }
			  else
			  {
			    log.warn("{}","更新错误！找不到企业端业务记录");
			    return false;
			  }

			  ctx.getDaoSession().dbDelete(this.getTrnmod().getUsrsig(),new Argument("ownref",this.getWrktrn().getOwnref()),new Argument("trninr",scrtrninr));

			  this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","7",ctx.absGet(Rmkmod.class).getNtext());
			  //更新历史备注
			  if(MdaUtils.isEmpty(this.getRmkmod().getRmk().getInr()))
			    this.getRmkmod().loadRemarkByOrd(ordinr);
			  this.getRmkmod().updateRmk("7");

			  //更新trn
			  this.getWrktrn().setCpldattim(MdaUtils.today());
			  this.getWrktrn().setSta("B");
			  if("G".equals(this.getWrktrn().getWfm()))
			    this.getWrktrn().setSta("G");
			  this.getWrktrn().setBaksta("R");
			  ctx.getDaoSession().dbUpdate(this.getWrktrn());

			  //高新投业务
			  if("G".equals(this.getWrktrn().getWfm()))
			  {
			    ctx.getDaoSession().dbRead(this.getWrkgrn(),new Argument("objinr",this.getWrktrn().getInr()));
			    this.getWrkgrn().setGidsta("OB");
			    this.getWrkgrn().setRettyp("F");
			    ctx.getDaoSession().dbUpdate(this.getWrkgrn());
			    //更新img guid，便于重新提交操作。
			    ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument("trninr",this.getWrktrn().getInr()));
			    if(!MdaUtils.isEmpty(this.getTrnmod().getItfmod().getImgmod().getImg().getInr()))
			    {
			      String uuidtoken = UUID.randomUUID().toString().replace("-", "");
			      log.debug("{}","[bnkchk->back->backHTIToSubPty] new guid=" +uuidtoken);
			      this.getTrnmod().getItfmod().getImgmod().getImg().setGuid(uuidtoken);
			      ctx.getDaoSession().dbUpdate(this.getTrnmod().getItfmod().getImgmod().getImg());
			    }

			  }
			  else
			  {
			    //生成spt
			    if(!backSptToSubPty())
			    {
			      ctx.getDaoSession().dbRollback();
			      ctx.setMessage("提示","退回失败！");
			      return false;
			    }
			  }

			  ctx.getDaoSession().dbCommit();
			  MdaUtils.clear(this.getWrktrn());
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  MdaUtils.clear(this.getSysmod().getSpt());
			  ctx.setMessage("提示","退回成功！");
			  MdaUtils.showMainPanel();
			  doFresh();
			}

			return true;
        }



        /**
        *   source:bnkchk.@0000.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  //自动转历史
			  auto2History();
			  //in stl
			  String ptytyp=$sysmod\\pty\\ptytyp.getValue();
			  log.debug("ptytyp=  "+ptytyp);
			  String ptyinr=$sysmod\\pty\\inr.getValue();
			  //String etyinr=$sysmod\\pty\\etyinr.getValue();
			  //String lvl=$sysmod\\pty\\lvl.getValue();
			  Platform.invisible($btnmod\\back);
			  if("0".equals(ptytyp))
			  {
			  Platform.visible($btnmod\\back);
			  Platform.visible($btnmod\\history);
			  $btnmod.setPanel();
			  $btnmod\\trntyp.setValue("0");
			  List<CodetableItem> bchcod=$sysmod.getBranchList($sysmod\\pty\\cid.getValue());
			  Platform.setValues($btnmod\\ptynam,bchcod);
			  if(!Platform.isEmpty(bchcod))
			  $btnmod\\ptynam.setValue(bchcod.get(0).getValue());
			
			  //初始化列表
			  doFresh();
			  }
			  else if("1".equals(ptytyp))
			  {
			  $btnmod.initQurtPanel();
			  Platform.dbReadset($chklst,new Argument<String>("ptytyp","1"),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			
			  }
			  else
			  {
			  Platform.visible($btnmod\\history);
			  $btnmod.initQurtPanel();
			  Platform.dbReadset($chklst,new Argument<String>("ptytyp","2"),new Argument<String>("ptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			
			  }
			  Platform.setModified($chklst);
			  */

			return true;
        }

        /**
        *   source:bnkchk.@0029.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//自动转历史
			//auto2History();
			
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.debug("{}","ptytyp=  "+ptytyp);
			String ptyinr=this.getSysmod().getPty().getInr();

			this.initBakchk(ptytyp);
			if("0".equals(ptytyp))
			{
			  
			  this.getBtnmod().setPanel();
			  this.getBtnmod().setTrntyp("0");
			  List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			  MdaUtils.setValues(this.getBtnmod(),"ptynam",bchcod);
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getBtnmod().setPtynam(bchcod.get(0).getValue());

			  //初始化列表
			  doFresh();
			}
			else if("1".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("ptytyp","1"),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));

			}
			else
			{
			  
			  this.getBtnmod().initQurtPanel();
			  //只查看交易不去更新list
			  if(!"S".equals(this.getOpensta()))
			  {
			    ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("ptytyp","2"),new Argument<String>("ptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  }
			}
			


			return true;
        }


        /**
        *   source:bnkchk.@0009.script
        */
        public void fresh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String etyinr=this.getSysmod().getPty().getEtyinr();
			String sql=null;
			if("0".equals(ptytyp))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  /*
			    //Platform.dbReadset($hislst,new Argument<String>("sta","A"),new Argument<String>("optptyinr",ptyinr),new Argument<Object>("cfmdattim",DESC));
			    List<CodetableItem> bchcod=$sysmod.getBranchList($sysmod\\pty\\cid.getValue());
			    Platform.setValues($btnmod\\ptynam,bchcod);
			    if(!Platform.isEmpty(bchcod))
			    $btnmod\\ptynam.setValue(bchcod.get(0).getValue());
			    */
			  //
			  if("2".equals(lvl))
			    ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  else if("1".equals(lvl))
			  {
			    String[] brhlist=this.getSysmod().getLowBch(this.getSysmod().getPty().getCid());
			    ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<Object>("optptyinr",IN,brhlist),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  }
			  else
			  {
			    //to fix as head
			    String[] brhlist=this.getSysmod().getLowBch(Platform.headBchcod());
			    ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<Object>("optptyinr",IN,brhlist),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  }
			  //Platform.dbReadset($chklst,new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			if("2".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			if("3".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			if("1".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			}
			
		}
        /**
        *   source:bnkchk.@0014.script
        */
        public String getAppFilename(String trninr,String ordinr,String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"0".equals(ptytyp))
			  return trninr;
			String sql = "SELECT t.inr FROM trn t,pty p WHERE t.ordinr='"+ordinr
			  +"' AND t.optptyinr=p.inr AND p.ptytyp in ('1','2','3')";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(!MdaUtils.isEmpty(inr.value))
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return trninr;
		}
        /**
        *   source:bnkchk.@0015.script
        */
        public void auto2History()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//申请类业务没有返回通知的话21天自动转历史
			Argument<String> inr= new Argument<String>("inr");
			ctx.getDaoSession().dbBegin();
			String sql="SELECT inr FROM trn WHERE sta='R' AND inidattim<? ";
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(MdaUtils.add(MdaUtils.today(),-21),LT));
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr);
			  if(ctx.getErrorCode()== NO_ERROR)
			  {
			    //log.info("inr="+inr.value);
			    ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",inr.value));
			    this.getTrnmod().getTrn().setSta("A");
			    //$trnmod\\trn\\cfmdattim.setValue(Platform.today());
			    ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbCommit();
			MdaUtils.clear(this.getTrnmod().getTrn());
			return;
		}
        /**
        *   source:bnkchk.@0020.script
        */
        public boolean backSptToSubPty()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getSysmod().getSpt().setSta("B");
			this.getSysmod().getSpt().setOprogninr(this.getTrnmod().getTrn().getPtyinr());
			//$sysmod\\spt\\smhinr.setValue($sysmod\\spt\\smhinr.getValue());
			this.getSysmod().getSpt().setSmhinr("");
			this.getSysmod().getSpt().setPtyinr(this.getTrnmod().getTrn().getPtyinr());
			this.getSysmod().getSpt().setOprusrinr("0");//银行审核中退回标志，后期如果用到oprusrinr，建议新增字段存放这个标志
			this.getSysmod().getSpt().setObjtyp(this.getTrnmod().getTrn().getObjtyp());
			this.getSysmod().getSpt().setObjinr(this.getTrnmod().getTrn().getObjinr());
			this.getSysmod().getSpt().setOwnref(this.getTrnmod().getTrn().getOwnref());
			this.getSysmod().getSpt().setFrm(this.getTrnmod().getTrn().getInifrm());
			this.getSysmod().getSpt().setDattim(new Date());
			this.getSysmod().getSpt().setOrdinr(this.getTrnmod().getTrn().getOrdinr());
			String ptytyp=this.getSysmod().getOrderOwnnerTyp(this.getTrnmod().getTrn().getOrdinr());
			if("3".equals(ptytyp))
			  this.getSysmod().getSpt().setScr("S");
			else
			  this.getSysmod().getSpt().setScr("I");
			log.debug("{}","[bnkchk->back->backSptToSubPty]Order submit ptytyp="+ptytyp);
			this.getSysmod().getSpt().setScrtxt(this.getTrnmod().getTrn().getInr());
			this.getSysmod().getSpt().setScrpty(this.getSysmod().getPty().getInr());

			this.getSysmod().getSpt().setObjnam(this.getTrnmod().getTrn().getObjnam());

			this.getSysmod().getSpt().setNam(this.getTrnmod().getTrn().getNam());
			this.getSysmod().getSpt().setTrnamt(this.getTrnmod().getTrn().getReloriamt());
			this.getSysmod().getSpt().setTrncur(this.getTrnmod().getTrn().getReloricur());

			//如果有影像信息，退回时应该存影像批次号
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg(),new Argument("trninr",this.getTrnmod().getTrn().getInr()));
			log.debug("{}","[bnkchk->back->backSptToSubPty]imgref=" +this.getSysmod().getSpt().getImgref());
			this.getSysmod().getSpt().setImgref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			this.getSysmod().getSpt().setInr(Platform.sdbCounter("spt"));
			ctx.getDaoSession().dbInsert(this.getSysmod().getSpt());

			//数据文件回滚
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"dat");
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("bnkchk","CT000137"));
			  log.debug("{}","[bnkchk->back->backSptToSubPty]业务数据丢失！请联系管理员。["+filename+"]");
			  return false;
			}
			String tarfile=this.getSysmod().createFilename(this.getSysmod().getSpt().getInr(),"bak");
			MdaUtils.fileCopy(filename,tarfile);
			return true;
		}
        /**
        *   source:bnkchk.@0025.script
        */
        public void doFresh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptyinr=this.getSysmod().getPty().getInr();
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String sql="";
			log.debug("{}","ptytyp=  "+ptytyp);
			MdaUtils.clear(this.getChklst());
			String ptynam=this.getBtnmod().getPtynam();

			String lvl=null;
			String cid=null;
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> oriinr =new Argument<String>("oriinr");
			Argument<String> wfm =new Argument<String>("wfm");
			Argument<String> baksta =new Argument<String>("baksta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> inifrm =new Argument<String>("inifrm");
			Argument<Date> inidattim =new Argument<Date>("inidattim");
			Argument<Date> bakdat =new Argument<Date>("bakdat");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> reloricur=new Argument<String>("reloricur");
			Argument<BigDecimal> reloriamt =new Argument<BigDecimal>("reloriamt");

			sql="SELECT inr,wfm,baksta,ownref,inifrm,inidattim,bakdat,nam,reloricur,reloriamt,oriinr FROM trn t WHERE sta='R' ";
			String con=" ";

			if("0".equals(ptytyp))
			{
			  //业务来源
			  if(!MdaUtils.isEmpty(this.getBaktyp()) && !"0".equals(this.getBaktyp()))
			  {
			    if("1".equals(this.getBaktyp()))  //阳关e结算
			    {
			      sql=sql+" AND wfm is null";
			    }
			    else if("2".equals(this.getBaktyp())) //单一窗口
			    {
			      sql=sql+" AND wfm ='D'";
			    }
			    else if("3".equals(this.getBaktyp())) //深圳电子保函
			    {
			      sql=sql+" AND wfm ='G'";
			    }
			    else
			    {
			    }
			  }

			  //国结退回业务
			  if(TRUE.equals(this.getBakflg()))
			  {
			    sql=sql+" AND baksta='W'";
			  }
			  else
			  {
			    sql=sql+" AND(baksta is null or baksta='R')";
			  }

			  String trntyp = this.getBtnmod().getTrntyp();
			  sql=sql+" AND ptytyp='0'";
			  sql=sql+" AND inidattim>=? AND inidattim<=?";

			  log.debug("{}","ptyinr    ptynam="+ptyinr+ "   "+ptynam);
			  if(!MdaUtils.isEmpty(this.getBtnmod().getPtynam())&&!"ptynam".equals(ptyinr))   //获取机构主键和机构等级
			  {
			    log.debug("{}","ptyinr    1="+ptyinr);
			    ptyinr=ptynam;
			    lvl=this.getSysmod().getBchmod().getBranchLvlByInr(ptyinr);
			    cid=this.getSysmod().getCidByInr(ptyinr);
			    log.debug("{}","ptyinr    2="+ptyinr);
			  }
			  else
			  {
			    lvl=this.getSysmod().getPty().getLvl();
			    cid=this.getSysmod().getPty().getCid();
			  }
			  log.debug("{}","ptyinr    lvl   cid="+ptyinr+ "   "+lvl+"   "+cid);

			  if(!MdaUtils.isEmpty(this.getBtnmod().getTrntyp())&&!"0".equals(this.getBtnmod().getTrntyp()))
			  {
			    log.debug("{}","trntyp 值 ="+this.getBtnmod().getTrntyp());
			    String[] trnlist=this.getSysmod().getTrnSortlist(this.getBtnmod().getTrntyp());
			    String list=this.getSysmod().toSqlString(trnlist);
			    sql=sql+con+"AND inifrm IN ("+list+")";
			  }

			  if("0".equals(lvl))
			  {
			    sql=sql+con+"AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr or t.optptyinr='"+ptyinr+"')";
			  }
			  else if("1".equals(lvl))
			  {
			    sql=sql+con+ "AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr and (p.inr='"+ptyinr+"' or pntinr='"+cid+"'))";//or optptyinr='"+ptyinr+"'))";
			  }
			  else
			  {
			    sql=sql+con+ "AND optptyinr='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+con+ " AND ptytyp='2' AND ptyinr='"+ptyinr+"'";
			}

			sql=sql+" ORDER  BY inidattim DESC";
			log.debug("{}","[bnkchk->search]查询的sql="+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getBtnmod().getBegdat(),GT),MdaUtils.sqlDate(this.getBtnmod().getEnddat(),LT));
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,wfm,baksta,bakdat,ownref,inifrm,inidattim,nam,reloricur,reloriamt,oriinr);
			  if(ctx.getErrorCode()==NO_ERROR)
			    this.getChklst().add(inr,ownref,wfm,baksta,bakdat,inifrm,inidattim,nam,reloricur,reloriamt,oriinr);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:bnkchk.@0027.script
        */
        public void loadDataByInr(String trninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：根据选择的序号加载公共数据
			  */
			// 加载TRN
			MdaUtils.clear(this.getTrnmod().getTrn());
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",trninr));
			String ordinr = this.getTrnmod().getTrn().getOrdinr();
			// 加载ORD
			ctx.getDaoSession().dbRead(this.getTrnmod().getOrdmod().getOrd(),new Argument("inr",ordinr));
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载RMK
			this.getRmkmod().loadRemarkByOrd(ordinr);
			// 初始化PDF数据
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载页面截图
			String inr0 = trninr;
			String inrStr = inr0.substring(0,4);
			String fileName = inr0+"."+"zul";
			Platform.writeToSession("dspfile",inr0);//token，用来判断请求唯一性
			log.info("{}","session dspfile :"+Platform.readFromSession("dspfile"));
			fileName = "/data/"+"dsp"+"/"+inrStr+"/"+fileName;
			log.debug("{}","filename路径为：" + fileName);
			this.setDisplay("/dsp"+fileName);

		}
        /**
        *   source:bnkchk.@0028.script
        */
        public void freshss()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.debug("{}","ptytyp=  "+ptytyp);
			String ptyinr=this.getSysmod().getPty().getInr();
			String sql=null;
			if("2".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("ptytyp","2"),new Argument<String>("ptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  //Platform.dbReadset($chklst,new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  
			}
			if("3".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  
			}
			if("1".equals(ptytyp))
			{
			  this.getBtnmod().initQurtPanel();
			  ctx.getDaoSession().dbReadset(this.getChklst(),new Argument<String>("optptyinr",ptyinr),new Argument<String>("sta","R"),new Argument<Object>("inidattim",DESC));
			  
			}
			if("0".equals(ptytyp))
			{
			  doFresh();
			}
		}
        /**
        *   source:bnkchk.@0030.script
        */
        public void initBakchk(String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			
			if("0".equals(ptytyp))
			{
			  this.setBaktyplab(MdaUtils.getI18NString("bnkchk","CT000205"));
			}
			else
			{
			  
			  
			  
			  
			}
		}
        /**
        *   source:bnkchk.@0032.script
        */
        public void updateTRN()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTrnmod().getTrn());
			if(!MdaUtils.isEmpty(this.getWrktrn().getOriinr()))
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",this.getWrktrn().getOriinr()));
			  this.getTrnmod().getTrn().setSta("A");
			  ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			}

			this.getWrktrn().setSta("A");
			ctx.getDaoSession().dbUpdate(this.getWrktrn());
		}

























}