package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotdcrVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收项下单据拒付通知
*/
@Transaction(vo= BotdcrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botdcr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botdcr.class);

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Botdcr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botdcr.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botdcr.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botdcr.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botdcr.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Botdcr.this.getBodgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Botdcr.this.getBodgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.occcur");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botdcr.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botdcr.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botdcr.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:botdcr.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:botdcr.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getBotp().getBotp06());

			return true;
        }

        /**
        *   source:botdcr.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:botdcr.@0003.script
        */
        @Init(order=150)
        public boolean	init150(){
            IContext ctx = MdaEnv.getContext();
            
			String docflg = this.getBodgrp().getRec().getDocflg();
			this.getBodgrp().getRec().setDocflg(NULLSTR);
			log.debug("{}","in botdcr.init:docflg=" + docflg);

			String tempdocflg = "";

			int len = 25;
			if (docflg.length() < len)
			  tempdocflg = docflg;
			else if (docflg.length() < len * 2)
			  tempdocflg = docflg.substring(0, len) + CR + docflg.substring(len, docflg.length());
			else
			  tempdocflg = docflg.substring(0, len) + CR + docflg.substring(len,len*2) + CR + docflg.substring(len*2, docflg.length());

			log.debug("{}","in botdcr.init:tempdocflg=" + tempdocflg + ",and tempdocflg.length()=" + tempdocflg.length());
			if(tempdocflg.length()>60)
			{
			  tempdocflg = tempdocflg.substring(0, 60);
			  log.debug("{}","tempdocflg after substring(0,60)=" + tempdocflg);
			}
			this.getBodgrp().getRec().setDocflg(tempdocflg);
			
			log.debug("{}","the end of botdcr.init:docflg=" + this.getBodgrp().getRec().getDocref());

			return true;
        }











}