package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotdftVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收汇票制作
*/
@Transaction(vo= BotdftVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botdft extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botdft.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Botdft()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botdft.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botdft.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botdft.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botdft.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botdft.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botdft.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botdft.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Botdft.this.getBodgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Botdft.this.getBodgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.doccur");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botdft.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botdft.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botdft.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
        }



        /**
        *   source:botdft.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getBodgrp().getCls(),new Argument<String>("typ","botdft"),new Argument<String>("flg","8"));
			this.getBodgrp().getDocdft().setCls(this.getBodgrp().getCls().getClstxt());

			return true;
        }











}