package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotfreVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收杂项处理申请
*/
@Transaction(vo= BotfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botfre.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Botfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botfre.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botfre.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botfre.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botfre.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botfre.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botfre.this.getBodgrp().getDat();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botfre.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getModtenorday();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Botfre.this.getBodgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Botfre.this.getBodgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Botfre.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botfre.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.rec.occcur");}
 				public void setValue(String arg){Botfre.this.getBodgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Botfre.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Botfre.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botfre.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botfre.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botfre.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botfre.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botfre.this.getBodgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:botfre.@0001.script
        */
        @Rule(target="bodgrp.rec.apltyp",order=100)
        public boolean ruleBodgrpRecApltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String apltyp = this.getBodgrp().getRec().getApltyp();
			this.getBodgrp().getRec().setModcur(this.getBodgrp().getRec().getOcccur());
			
			if("1".equals(apltyp))
			{
			  
			  
			  
			  
			  
			}
			else if("2".equals(apltyp))
			{
			  
			  
			  
			  
			  
			  this.getBodgrp().getRec().setApltxt("We Apply to Amend the Collection Amount To " + this.getBodgrp().getRec().getModcur() + this.getBodgrp().getRec().getModamt() + ".");
			  
			}
			else if("3".equals(apltyp))
			{
			  
			  
			  
			  
			  
			  this.getBodgrp().getRec().setApltxt("We Agree to Amend the Collection Amount To " + this.getBodgrp().getRec().getModcur() + this.getBodgrp().getRec().getModamt() + ".");
			  
			}
			else if("6".equals(apltyp)  ||  "7".equals(apltyp))
			{
			  
			  
			  String modtenor = this.getBotp().getModtenor();
			  if("S".equals(modtenor))
			  {
			    
			    this.getBotp().setModtenorday("");
			    
			    
			    this.getBodgrp().getRec().setApltxt("We Apply and Agree to Change Payment Conditions to Documents Against Sight Payment.");
			    
			  }
			  else if("D".equals(modtenor))
			  {
			    
			    this.getBotp().setModtenorday("At     Days After ");
			    
			    
			    this.getBodgrp().getRec().setApltxt("We Apply and Agree to Change Payment Conditions to Documents Against Deferred Payment " + this.getBotp().getModtenorday() + ".");
			    
			  }
			  else if("A".equals(modtenor))
			  {
			    
			    this.getBotp().setModtenorday("At     Days After ");
			    
			    
			    this.getBodgrp().getRec().setApltxt("We Apply and Agree to Change Payment Conditions to Documents Against Acceptance " + this.getBotp().getModtenorday() + ".");
			    
			  }
			  else if("M".equals(modtenor))
			  {
			    this.getBotp().setModtenorday("");
			    
			    
			    
			  }
			  
			}
			else if("8".equals(apltyp))
			{
			  
			  
			  
			  
			  
			  String dateStr = MdaUtils.format(this.getBodgrp().getRec().getModdat(),"yyyy/MM/dd");
			  this.getBodgrp().getRec().setApltxt("We Apply to Change the Maturity Date to " + dateStr + ".");
			  
			}
			else if("9".equals(apltyp))
			{
			  
			  
			  
			  
			  
			  String dateStr = MdaUtils.format(this.getBodgrp().getRec().getModdat(),"yyyy/MM/dd");
			  this.getBotp().getBodgrp().getRec().setApltxt("We Agree to Change the Maturity Date to " + dateStr + ".");
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  if("4".equals(apltyp))
			  {
			    this.getBodgrp().getRec().setApltxt("We Apply to Release to the Beneficiary Free of Payment.");
			  }
			  else if("5".equals(apltyp))
			  {
			    this.getBodgrp().getRec().setApltxt("We Agree to Release to the Beneficiary Free of Payment.");
			  }
			  else if("10".equals(apltyp))
			  {
			    this.getBodgrp().getRec().setApltxt("We Apply to Return the Documents Bank to Us.");
			  }
			  else if("11".equals(apltyp))
			  {
			    this.getBodgrp().getRec().setApltxt("We Agree to Return the Documents Bank to Us.");
			  }
			  
			}

			return true;
        }

        /**
        *   source:botfre.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBodgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;

			if(!MdaUtils.isEmpty(this.getBotp().getDat()))
			{
			  this.getBotp().setDayss(MdaUtils.format(this.getBotp().getDat(),"yyyy 年 MM 月 dd 日"));
			}
			else
			{
			  this.getBotp().setDayss(NULLSTR);
			}

			BigDecimal occamt = MdaUtils.parseDecimal(MdaUtils.format(this.getBodgrp().getRec().getOccamt(),"#0.00"));
			this.getBodgrp().getRec().setOccamt(occamt);
			if(!MdaUtils.isEmpty(this.getBotp().getAmt()))
			{
			  BigDecimal amt=MdaUtils.parseDecimal(MdaUtils.format(this.getBodgrp().getAmt(),"#0.00"));
			  this.getBodgrp().setAmt(amt);
			}

			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bod");
			this.getAfdgrp().getRec().setObjinr(this.getBodgrp().getRec().getInr());
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:botfre.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","botfre",stream,false );

			return true;
        }

        /**
        *   source:botfre.@0007.script
        */
        @Rule(target="botp.modtenor",order=100)
        public boolean ruleBotpModtenorN100(){
            IContext ctx = MdaEnv.getContext();
            
			String typ=this.getBotp().getModtenor();
			if("1".equals(typ))
			{
			  
			}
			else
			{
			  
			}
			this.getBotp().setModtenorday(NULLSTR);
			
			//
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp4",oprtyp);
			if("18".equals(oprtyp) || "19".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBotp().getModtenor()))
			  {
			    oprtxt = descriptipn + "为" + MdaUtils.getCodetableLabel("modtenor1",this.getBotp().getModtenor());
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }
			}

			return true;
        }

        /**
        *   source:botfre.@0008.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeOprtyp(true);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp4",oprtyp);
			if(!"0".equals(oprtyp))
			{
			  oprtxt = descriptipn;
			  this.getAfdgrp().getRec().setOprtxt(oprtxt);
			}
			else
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			this.getBotp().setModtenorday(NULLSTR);
			this.getBotp().setAmt(new BigDecimal(0));
			this.getBotp().setModtenor(NULLSTR);
			this.getBotp().setDat(null);
			
			
			
			
			

			return true;
        }

        /**
        *   source:botfre.@0011.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:botfre.@0014.script
        */
        @Rule(target="botp.amt",order=100)
        public boolean ruleBotpAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请或同意修改单据金额
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp4",oprtyp);
			if("16".equals(oprtyp) || "17".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBotp().getCur()) && !MdaUtils.isEmpty(this.getBotp().getAmt()))
			  {
			    oprtxt = descriptipn + "为" + this.getBodgrp().getCur() + this.getBodgrp().getAmt();
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }
			}

			return true;
        }

        /**
        *   source:botfre.@0015.script
        */
        @Rule(target="botp.dat",order=100)
        public boolean ruleBotpDatN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请修改变更到期日
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp4",oprtyp);
			if("12".equals(oprtyp) || "13".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBotp().getDat()))
			  {
			    oprtxt = descriptipn + "为" + MdaUtils.format(this.getBotp().getDat(),"yyyy/MM/dd");
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }
			}

			return true;
        }

        /**
        *   source:botfre.@0016.script
        */
        @Rule(target="botp.modtenorday",order=100)
        public boolean ruleBotpModtenordayN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请或同意修改交单条件
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp4",oprtyp);
			if("18".equals(oprtyp) || "19".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBotp().getModtenorday()) && !MdaUtils.isEmpty(this.getBotp().getModtenor()))
			  {
			    oprtxt = descriptipn + "为" + MdaUtils.getCodetableLabel("modtenor1",this.getBotp().getModtenor())
			      + this.getBotp().getModtenorday();
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }

			}

			return true;
        }

        /**
        *   source:botfre.@0017.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "出口托收杂项处理申请书";
			String tempfiles = "A:botfre";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:botfre.@0018.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream = $mtabut\\apldoc.getValue();
			if(!MdaUtils.isEmpty(this.getBotp().getDat()))
			{
			  this.getBotp().setDayss(MdaUtils.format(this.getBotp().getDat(),"yyyy 年 MM 月 dd 日"));
			  
			}
			else
			  this.getBotp().setDayss(NULLSTR);

			BigDecimal occ=getVals(this.getBodgrp().getRec().getOccamt());
			this.getBodgrp().getRec().setOccamt(occ);
			

			if(!MdaUtils.isEmpty(this.getBotp().getAmt()))
			{
			  BigDecimal amt=getVals(this.getBodgrp().getAmt());
			  this.getBodgrp().setAmt(amt);
			  
			}
			this.getBotp().getPdfviw().callPDFComponent("","botfre","出口托收杂项处理申请书",1);

			return true;
        }


        /**
        *   source:botfre.@0020.script
        */
        @Check(target="botp.amt",order=100)
        public boolean checkBotpAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBotp(),"amt"));

			return true;
        }


        /**
        *   source:botfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			//List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			// Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			//if(!Platform.isEmpty(bchcod)&&!$sysmod.sptIsLoaded("B")&&!$sysmod.sptIsLoaded("P"))
			//  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			if(this.getSysmod().sptIsLoaded("B")  ||  this.getSysmod().sptIsLoaded("P")  ||  this.getSysmod().sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			IModule bod = (IModule)ctx.restoreData("com.brilliance.botfre.ref");
			if(!MdaUtils.isEmpty(bod))
			  this.getBodgrp().getRec().copyValue(bod);

			//if(!"1".equals($sysmod\\pty\\ptytyp.getValue()))
			//Platform.clear($bodgrp\\rec\\ownref);
			
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			//Platform.disable($bodgrp\\rec\\stlref);
			//Platform.disable($bodgrp\\rec\\invno);
			//Platform.disable($bodgrp\\rec\\occcur);
			//Platform.disable($bodgrp\\rec\\occamt);
			ctx.getDaoSession().dbRead(this.getBodgrp().getDre().getPts(),new Argument<String>("objinr",this.getBodgrp().getRec().getInr()),new Argument<String>("objtyp","bod"),new Argument<String>("rol","dre"));
			//Platform.disable($bodgrp\\dre\\pts\\extkey);
			//Platform.disable($bodgrp\\dre\\pts\\adrblk);
			//Platform.disable($botp\\drep\\sel);
			ctx.getDaoSession().dbRead(this.getBodgrp().getClb().getPts(),new Argument<String>("objinr",this.getBodgrp().getRec().getInr()),new Argument<String>("objtyp","bod"),new Argument<String>("rol","clb"));
			//Platform.disable($bodgrp\\clb\\pts\\extkey);
			//Platform.disable($bodgrp\\clb\\pts\\adrblk);
			//Platform.disable($botp\\clbp\\sel);
			this.getAfdgrp().getRec().setOprtyp("0");

			return true;
        }

        /**
        *   source:botfre.@0009.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            

			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    this.getAfdgrp().getRec().setBchcod(this.getBodgrp().getRec().getBchcod());
			  }
			  log.info("{}","bchcod="+this.getBodgrp().getRec().getBchcod()+",bchcod="+this.getBodgrp().getRec().getBchcod());
			}
			
			//Platform.setValues($botp\\modtenor,Platform.getCodetable("modtenor"));
			MdaUtils.setValues(this.getBotp(),"modtenor",MdaUtils.getCodetable("modtenor1"));
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp4"));
			
			
			
			
			
			
			
			
			
			
			changeOprtyp(false);

			return true;
        }


        /**
        *   source:botfre.@0010.script
        */
        public void changeOprtyp(boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp=this.getAfdgrp().getRec().getOprtyp();
			//16- 申请修改托收金额
			if("16".equals(oprtyp)  ||  "17".equals(oprtyp))
			{
			  this.getBotp().setCur(this.getBodgrp().getRec().getOcccur());
			  
			  
			  
			  
			  
			  
			  this.getBodgrp().setComlab(MdaUtils.getI18NString("botfre","CT000010"));
			  
			  
			  
			  if(flg)
			  {
			    this.getBotp().setDat(null);
			    this.getBotp().setModtenor(NULLSTR);
			    this.getBotp().setModtenorday(NULLSTR);
			  }
			}
			//12- 申请修改变更到期日
			if("12".equals(oprtyp)  ||  "13".equals(oprtyp))
			{
			  
			  
			  
			  this.getBodgrp().setComlab(MdaUtils.getI18NString("botfre","CT000011"));
			  
			  
			  
			  
			  
			  if(flg)
			  {
			    this.getBotp().setModtenorday(NULLSTR);
			    this.getBotp().setAmt(new BigDecimal(0));
			    this.getBotp().setCur(NULLSTR);
			    this.getBotp().setModtenor(NULLSTR);
			  }
			}
			//18- 申请修改交单条件
			if("18".equals(oprtyp)  ||  "19".equals(oprtyp))
			{
			  
			  
			  
			  
			  
			  this.getBodgrp().setComlab(MdaUtils.getI18NString("botfre","CT000012"));
			  
			  
			  
			  
			  if(flg)
			  {
			    //Platform.clear($botp\\modtenor);
			    //Platform.clear($botp\\modtenorday);
			    this.getBotp().setAmt(new BigDecimal(0));
			    this.getBotp().setCur(NULLSTR);
			    this.getBotp().setDat(null);
			  }
			}
			if ("0".equals(oprtyp)  ||  "14".equals(oprtyp)  ||  "15".equals(oprtyp)  ||  "10".equals(oprtyp)  ||  "11".equals(oprtyp))
			{
			  
			  
			  
			  
			  
			  
			  if(flg)
			  {
			    this.getBotp().setCur(NULLSTR);
			    this.getBotp().setAmt(new BigDecimal(0));
			    this.getBotp().setModtenor(NULLSTR);
			    this.getBotp().setModtenorday(NULLSTR);
			    this.getBotp().setDat(null);
			    this.getBodgrp().setComlab(NULLSTR);
			  }
			}
		}
        /**
        *   source:botfre.@0019.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}









}