package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Botfre0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收杂项申请查询入口
*/
@Transaction(vo= Botfre0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botfre0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botfre0.class);

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Botfre0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:botfre0.@0001.script
        */
        @Rule(target="selp.sure",order=0)
        public boolean ruleSelpSureN0(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bodgrp","botfre");

			return true;
        }

        /**
        *   source:botfre0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//  String queryClause = "SELECT bod.inr trsinr,bod.stlref ref,bod.rcvdat dat,bod.doccur cur,bod.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bod,pts,adr,pta WHERE bod.docflg = 'docadv' AND pts.rol = 'drr' AND pts.objtyp = 'bod' AND pts.objinr = bod.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause="SELECT rec.inr trsinr,rec.stlref ref,rec.rcvdat dat,rec.occcur cur,rec.occamt amt ,s.adrblk bennam"
			  +" FROM bod rec,pts s WHERE  s.objinr=rec.inr AND s.objtyp='bod' AND s.rol='dre'"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:botfre0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bodgrp","botfre");

			return true;
        }



        /**
        *   source:botfre0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selbotfre"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//  String queryClause = "SELECT bod.inr trsinr,bod.stlref ref,bod.rcvdat dat,bod.doccur cur,bod.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bod,pts,adr,pta WHERE bod.docflg = 'docadv' AND pts.rol = 'drr' AND pts.objtyp = 'bod' AND pts.objinr = bod.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause="SELECT rec.inr trsinr,rec.stlref ref,rec.rcvdat dat,rec.occcur cur,rec.occamt amt ,s.adrblk bennam"
			  +" FROM bod rec,pts s WHERE s.objinr=rec.inr AND s.objtyp='bod' AND s.rol='dre' "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}