package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收申请
*/
@Transaction(vo= BotopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botopn.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Botopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botopn.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botopn.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botopn.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botopn.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botopn.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botopn.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botopn.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Botopn.this.getBodgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Botopn.this.getBodgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.occcur");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botopn.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botopn.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botopn.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
        }

        /**
        *   source:botopn.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBodgrp().getClb().getPts().getExtkey())&&MdaUtils.isEmpty(this.getBodgrp().getClb().getPts().getAdrblk()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("botopn","CT000019"),MdaUtils.getI18NString("botopn","CT000020"));
			  return false;
			}
			if(!(ctx.checkAll(this.getBodgrp()) && ctx.checkAll(this.getBotp().getBnkrec())))
			  return false;
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getBodgrp().getRec());
			  String objinr=this.getBodgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getDrr().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getDre().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getClb().getPts(),objinr);
			}
			else
			{
			  this.getBodgrp().getRec().setInr(Platform.sdbCounter("bod"));
			  ctx.getDaoSession().dbInsert(this.getBodgrp().getRec());
			  String objinr = this.getBodgrp().getRec().getInr();
			  String objtyp = "bod";
			  this.getBodgrp().getDrr().savpts(objinr,objtyp);
			  this.getBodgrp().getDre().savpts(objinr,objtyp);
			  this.getBodgrp().getClb().savpts(objinr,objtyp);
			}
			this.getBodgrp().setDocinf(this.getBotp().getDocgrdm().encodeTco());
			if(!this.getTrnmod().trnSetFromContract())
			  return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:botopn.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","botopn",stream,false );

			return true;
        }

        /**
        *   source:botopn.@0003.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:botopn.@0004.script
        */
        @Rule(target="mtabut.done",order=100)
        public boolean ruleMtabutDoneN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBodgrp().getBodlst());
			

			return true;
        }

        /**
        *   source:botopn.@0005.script
        */
        @Rule(target="mtabut.sav1",order=100)
        public boolean ruleMtabutSav1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().setFlg("X");
			//$mtabut\\sav.invokeEventRules(ctx,evt);
			if(!ctx.postRule(this,"mtabut.sav"))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:botopn.@0006.script
        */
        @Rule(target="mtabut.sav1",order=200)
        public boolean ruleMtabutSav1N200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getBodlst().add();
			int index=this.getBodgrp().getBodlst().fullSize() - 1;
			this.getBodgrp().getBodlst().getElement(index).copyValue(this.getBodgrp().getRec());
			
			ctx.setMessage(MdaUtils.getI18NString("botopn","CT000015"),MdaUtils.getI18NString("botopn","CT000016"));
			this.getTrnmod().ordNew();
			this.getBodgrp().getRec().setOcccur("USD");
			this.getBodgrp().getRec().setOccamt(new BigDecimal(0));
			
			
			MdaUtils.clear(this.getBotp().getDocgrdm().getDocgrd());
			
			this.getBodgrp().getRec().setOwnref(NULLSTR);
			this.getSysmod().setFlg(NULLSTR);
			

			return true;
        }

        /**
        *   source:botopn.@0009.script
        */
        @Rule(target="bodgrp.rec.doctypcod",order=100)
        public boolean ruleBodgrpRecDoctypcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBotp().changeDoctypcod();

			return true;
        }

        /**
        *   source:botopn.@0014.script
        */
        @Rule(target="botp.drrp.sure",order=500)
        public boolean ruleBotpDrrpSureN500(){
            IContext ctx = MdaEnv.getContext();
            
			//将当前申请客户处填写的信息带入交易下方的申请人信息栏位
			if(!MdaUtils.isEmpty(this.getBodgrp().getDap().getPts().getExtkey()))
			{
			  this.getBodgrp().getDrr().getPts().setExtkey(this.getBodgrp().getDap().getPts().getExtkey());
			  
			}
			if(!MdaUtils.isEmpty(this.getBodgrp().getDap().getPts().getAdrblk()))
			{
			  this.getBodgrp().getDrr().getPts().setAdrblk(this.getBodgrp().getDap().getPts().getAdrblk());
			  
			}

			return true;
        }



        /**
        *   source:botopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBotp().getDocgrdm().decode(this.getBodgrp().getRec().getDocgrd());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBodgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBodgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(this.getSysmod().sptIsLoaded("B")  ||  this.getSysmod().sptIsLoaded("P"))
			  return true;
			this.getBodgrp().getRec().setCredat(MdaUtils.today());
			this.getBodgrp().getRec().setOcccur("USD");
			this.getBodgrp().getDap().initDap("bod");
			MdaUtils.setValues(this.getBodgrp().getRec(),"doctypcod",MdaUtils.getCodetable("doctypcod"));
			this.getBodgrp().getRec().setDoctypcod("2");
			//$bodgrp\\rec\\matpertyp.setValue("1");
			//Platform.disable($bodgrp\\mixdet);
			
			return true;
        }

        /**
        *   source:botopn.@0008.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in botp\botp01....");
			
			
			
			
			//Platform.setRequired($bodgrp\\clb\\pts\\adrblk);
			//Platform.setDescription($bodgrp\\clb\\pts\\adrblk,#CT000034);
			//$botp.changeDoctypcod();
			
			this.getBotp().changeDoctypcod();
			/*
			  String doctypcod = $bodgrp\\rec\\doctypcod.getValue();
			  log.debug("doctypcod Value========="+doctypcod);
			  if("2".equals(doctypcod))
			  {
			  Platform.disable($bodgrp\\rec\\matpercnt);
			  Platform.disable($bodgrp\\rec\\matpertyp);
			  Platform.setNotRequired($bodgrp\\rec\\matpercnt);
			  Platform.setNotRequired($bodgrp\\rec\\matpertyp);
			  Platform.disable($bodgrp\\mixdet);
			  }
			  else if("1".equals(doctypcod)  ||  "3".equals(doctypcod))
			  {
			  Platform.enable($bodgrp\\rec\\matpercnt);
			  Platform.enable($bodgrp\\rec\\matpertyp);
			  Platform.setRequired($bodgrp\\rec\\matpercnt);
			  Platform.setRequired($bodgrp\\rec\\matpertyp);
			  Platform.disable($bodgrp\\mixdet);
			  }
			  else if("4".equals(doctypcod))
			  {
			  Platform.disable($bodgrp\\rec\\matpercnt);
			  Platform.disable($bodgrp\\rec\\matpertyp);
			  Platform.setNotRequired($bodgrp\\rec\\matpercnt);
			  Platform.setNotRequired($bodgrp\\rec\\matpertyp);
			  Platform.enable($bodgrp\\mixdet);
			  }*/

			return true;
        }











}