package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotopsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收-交单
*/
@Transaction(vo= BotopsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botops extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botops.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Botops()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botops.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botops.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botops.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botops.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botops.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botops.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botops.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Botops.this.getBodgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Botops.this.getBodgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.occcur");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botops.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botops.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botops.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
        }

        /**
        *   source:botops.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getBodgrp()) && ctx.checkAll(this.getBotp().getBnkrec())))
			  return false;
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());

			BigDecimal occ = MdaUtils.parseDecimal(MdaUtils.format(this.getBodgrp().getRec().getOccamt(),"#0.00"));
			this.getBodgrp().getRec().setOccamt(occ);

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getBodgrp().getRec());
			  String objinr=this.getBodgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getDrr().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getDre().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBodgrp().getClb().getPts(),objinr);
			}
			else
			{
			  this.getBodgrp().getRec().setInr(Platform.sdbCounter("bod"));
			  ctx.getDaoSession().dbInsert(this.getBodgrp().getRec());
			  String objinr = this.getBodgrp().getRec().getInr();
			  String objtyp = "bod";
			  this.getBodgrp().getDrr().savpts(objinr,objtyp);
			  this.getBodgrp().getDre().savpts(objinr,objtyp);
			  this.getBodgrp().getClb().savpts(objinr,objtyp);
			}
			this.getBodgrp().setDocinf(this.getBotp().getDocgrdm().encodeTco());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:botops.@0002.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:botops.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","botops",stream,false );

			return true;
        }

        /**
        *   source:botops.@0004.script
        */
        @Rule(target="bodgrp.rec.doctypcod",order=100)
        public boolean ruleBodgrpRecDoctypcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBotp().changeDoctypcod();

			return true;
        }

        /**
        *   source:botops.@0009.script
        */
        @Rule(target="botp.bnkrec.agbchrgby",order=100)
        public boolean ruleBotpBnkrecAgbchrgbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String chgby = this.getBotp().getBnkrec().getAgbchrgby();
			if("1".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setAgbchrgby("1");
			  this.getBotp().getBnkrec().getBnkrecd().setAgbmstfee(NULLSTR);
			}
			else if ("2".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setAgbchrgby("2");
			  this.getBotp().getBnkrec().getBnkrecd().setAgbmstfee(NULLSTR);
			}
			else if ("3".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setAgbchrgby("2");
			  this.getBotp().getBnkrec().getBnkrecd().setAgbmstfee( "X" );
			}


			return true;
        }

        /**
        *   source:botops.@0010.script
        */
        @Rule(target="botp.bnkrec.rmichrgby",order=100)
        public boolean ruleBotpBnkrecRmichrgbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String chgby = this.getBotp().getBnkrec().getRmichrgby();
			if("1".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setRmichrgby("1");
			  this.getBotp().getBnkrec().getBnkrecd().setRmimstfee(NULLSTR);
			}
			else if ("2".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setRmichrgby("2");
			  this.getBotp().getBnkrec().getBnkrecd().setRmimstfee(NULLSTR);
			}
			else if ("3".equals(chgby))
			{
			  this.getBotp().getBnkrec().getBnkrecd().setRmichrgby("2");
			  this.getBotp().getBnkrec().getBnkrecd().setRmimstfee( "X" );
			}


			return true;
        }

        /**
        *   source:botops.@0012.script
        */
        @Rule(target="bodgrp.rec.isyrc",order=100)
        public boolean ruleBodgrpRecIsyrcN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBodgrp().getRec().getIsyrc()))
			{
			  
			  
			  
			  this.getBodgrp().getRec().setIsjrc("");
			  
			}
			else
			{
			  this.getBodgrp().getRec().setYrcno(NULLSTR);
			  
			  
			  
			  
			}
			
			//Platform.setModified($bodgrp\\rec\\jrcno);
			
			
			
			//Platform.setModified($botp\\jslact);
			
			return true;
        }

        /**
        *   source:botops.@0013.script
        */
        @Rule(target="bodgrp.rec.isjrc",order=100)
        public boolean ruleBodgrpRecIsjrcN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBodgrp().getRec().getIsjrc()))
			{
			  
			  
			  
			  this.getBodgrp().getRec().setIsyrc("");
			  
			}
			else
			{
			  this.getBodgrp().getRec().setJrcno(NULLSTR);
			  
			  
			  
			  
			}
			//Platform.setModified($bodgrp\\rec\\yrcno);
			
			
			
			//Platform.setModified($botp\\yslact);
			

			return true;
        }

        /**
        *   source:botops.@0014.script
        */
        @Rule(target="bodgrp.rec.givamt",order=100)
        public boolean ruleBodgrpRecGivamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($bodgrp\\rec\\givamt.getValue()))
			  {
			  $bodgrp\\rec\\notlce.setValue("");
			  }
			  Platform.setModified($bodgrp\\rec\\givamt);
			  Platform.setModified($bodgrp\\rec\\notlce);
			  */

			return true;
        }

        /**
        *   source:botops.@0015.script
        */
        @Rule(target="bodgrp.rec.notlce",order=100)
        public boolean ruleBodgrpRecNotlceN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(TRUE.equals($bodgrp\\rec\\notlce.getValue()))
			  {
			  $bodgrp\\rec\\givamt.setValue("");
			  }
			  Platform.setModified($bodgrp\\rec\\givamt);
			  Platform.setModified($bodgrp\\rec\\notlce);
			  */

			return true;
        }

        /**
        *   source:botops.@0016.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "客户交单业务委托书";
			String tempfiles = "A:botops";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:botops.@0017.script
        */
        @Rule(target="botp.yslact",order=100)
        public boolean ruleBotpYslactN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cur =this.getBodgrp().getRec().getOcccur();
			this.getBotp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:botops.@0019.script
        */
        @Rule(target="botp.actmod.actslt",order=100)
        public boolean ruleBotpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getBotp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("botops","CT000011"),MdaUtils.getI18NString("botops","CT000012"));
			  return false;
			}
			String rmbact=this.getBotp().getActmod().getActlst().getElement(index).getAct();
			if(TRUE.equals(this.getBodgrp().getRec().getIsyrc()))
			{
			  this.getBodgrp().getRec().setYrcno(rmbact);
			  
			}
			if(TRUE.equals(this.getBodgrp().getRec().getIsjrc()))
			{
			  this.getBodgrp().getRec().setJrcno(rmbact);
			  
			}
			

			return true;
        }

        /**
        *   source:botops.@0021.script
        */
        @Rule(target="botp.jslact",order=100)
        public boolean ruleBotpJslactN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBotp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:botops.@0022.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());
			//IStream stream=$mtabut\\apldoc.getValue();
			BigDecimal occamt =getVals(this.getBodgrp().getRec().getOccamt());
			this.getBodgrp().getRec().setOccamt(occamt);
			
			this.getBotp().getPdfviw().callPDFComponent("","botops","客户交单业务委托书",1);

			return true;
        }

        /**
        *   source:botops.@0023.script
        */
        @Rule(target="mtabut.busmod.save",order=10)
        public boolean ruleMtabutBusmodSaveN10(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().getRec().setDocgrd(this.getBotp().getDocgrdm().encode());

			return true;
        }


        /**
        *   source:botops.@0025.script
        */
        @Check(target="bodgrp.rec.occamt",order=100)
        public boolean checkBodgrpRecOccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal doc=this.getBodgrp().getRec().getOccamt();
			if(!MdaUtils.isEmpty(doc))
			{
			  BigDecimal js=MdaUtils.parseDecimal(0.00);
			  if(doc.compareTo(js)<0)
			  {
			    this.getBodgrp().getRec().setOccamt(new BigDecimal(0));
			    ctx.setFieldError(this,"bodgrp.rec.occamt",MdaUtils.getI18NString("botops","CT000016"));
			  }
			}
			

			return true;
        }

        /**
        *   source:botops.@0027.script
        */
        @Check(target="botp.bodgrp.rec.occamt",order=100)
        public boolean checkBotpBodgrpRecOccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBotp().getBodgrp().getRec(),"occamt"));

			return true;
        }

        /**
        *   source:botops.@0028.script
        */
        @Check(target="botp.bodgrp.rec.matpercnt",order=100)
        public boolean checkBotpBodgrpRecMatpercntN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBotp().getBodgrp().getRec(),"matpercnt"));

			return true;
        }


        /**
        *   source:botops.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			this.getBotp().getDocgrdm().decode(this.getBodgrp().getRec().getDocgrd());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBodgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			  this.getBodgrp().getRec().setBchcod(bchcod.get(0).getValue());

			if(MdaUtils.isEmpty(this.getBodgrp().getRec().getIsyrc()))
			{
			  
			  
			  
			}
			if(MdaUtils.isEmpty(this.getBodgrp().getRec().getIsjrc()))
			{
			  
			  
			  
			}
			if(!MdaUtils.isEmpty(this.getBodgrp().getApl().getPty().getNam()))
			{
			  
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			this.getBodgrp().getRec().setCredat(MdaUtils.today());
			this.getBodgrp().getRec().setOcccur("USD");
			this.getBodgrp().getDap().initDap("bod");
			//20180103收款人栏位应自动赋值当前单证通客户的客户信息
			this.getBodgrp().getDrr().copyValues(this.getBodgrp().getDap());
			log.debug("{}","message"+this.getBodgrp().getDrr().getPts().getNam());
			this.getBodgrp().getDrr().getPts().setRol("drr");
			//
			MdaUtils.setValues(this.getBodgrp().getRec(),"doctypcod",MdaUtils.getCodetable("doctypcod"));
			this.getBodgrp().getRec().setDoctypcod("2");
			this.getBodgrp().getApl().getPty().setNam(this.getSysmod().getPty().getNam());
			
			//$bodgrp\\rec\\matpertyp.setValue("1");
			//Platform.disable($bodgrp\\mixdet);
			

			return true;
        }

        /**
        *   source:botops.@0005.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			//$botp.changeDoctypcod();
			String doctypcod = this.getBodgrp().getRec().getDoctypcod();
			log.debug("{}","doctypcod Value========="+doctypcod);
			if("2".equals(doctypcod))
			{
			  
			  
			  
			  
			  
			}
			else if("1".equals(doctypcod)  ||  "3".equals(doctypcod))
			{
			  
			  
			  
			  
			  
			}
			else if("4".equals(doctypcod))
			{
			  
			  
			  
			  
			  
			}

			return true;
        }


        /**
        *   source:botops.@0026.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}









}