package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotrplVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收通知（回复商行）
*/
@Transaction(vo= BotrplVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botrpl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botrpl.class);

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Botrpl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botrpl.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botrpl.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botrpl.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botrpl.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.occamt");}
 				public void setValue(BigDecimal arg){Botrpl.this.getBodgrp().getRec().setOccamt(arg);}
 				public BigDecimal getValue(){return Botrpl.this.getBodgrp().getRec().getOccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.occcur");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setOcccur(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getOcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botrpl.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botrpl.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botrpl.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:botrpl.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:botrpl.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getBotp().getBotp03());

			return true;
        }











}