package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BotsduVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Botmod;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口托收面函制作
*/
@Transaction(vo= BotsduVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botsdu extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Botsdu.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botmod botmod;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Botsdu()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBotmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.cur");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().setCur(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getCur();}}
			 );
           this.getBotp().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.amt");}
 				public void setValue(BigDecimal arg){Botsdu.this.getBodgrp().setAmt(arg);}
 				public BigDecimal getValue(){return Botsdu.this.getBodgrp().getAmt();}}
			 );
           this.getBotp().setModtenorHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.modtenor");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().setModtenor(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getModtenor();}}
			 );
           this.getBotp().setModtenordayHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.modtenorday");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().setModtenorday(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getModtenorday();}}
			 );
           this.getBotp().setDatHolder( new FieldHolder<Date>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.dat");}
 				public void setValue(Date arg){Botsdu.this.getBodgrp().setDat(arg);}
 				public Date getValue(){return Botsdu.this.getBodgrp().getDat();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Botsdu.this.getBodgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Botsdu.this.getBodgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.bchcod");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.doccur");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.inr");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setInr(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.ownref");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.ptyinr");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Botsdu.this.getFieldPath("bodgrp.rec.stlref");}
 				public void setValue(String arg){Botsdu.this.getBodgrp().getRec().setStlref(arg);}
 				public String getValue(){return Botsdu.this.getBodgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getBodgrp().getRec());
        }

        /**
        *   source:botsdu.@0000.script
        */
        @Rule(target="mtabut.dft",order=100)
        public boolean ruleMtabutDftN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream =this.getMtabut().getDft();
			ctx.absGet(Sysmod.class).getPdfmod().generatorFreePdf(stream,this.getBodgrp().getLogo());

			return true;
        }

        /**
        *   source:botsdu.@0004.script
        */
        @Rule(target="botp.qita",order=100)
        public boolean ruleBotpQitaN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBotp().setTempvar(NULLSTR);
			String typ=this.getBodgrp().getSdutyp();
			ctx.getDaoSession().dbReadset(this.getBotp().getClslst(),new Argument<String>("typ",typ),new Argument<String>("flg","8"),new Argument<Object>("status",NE,"0"));
			
			
			

			return true;
        }

        /**
        *   source:botsdu.@0005.script
        */
        @Rule(target="botp.ok",order=100)
        public boolean ruleBotpOkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBotp().getTempvar()))
			{
			  this.getBodgrp().getDocdft().setCls(NULLSTR);
			  this.getBodgrp().getDocdft().setCls(this.getBotp().getTempvar());
			  
			}
			

			return true;
        }

        /**
        *   source:botsdu.@0006.script
        */
        @Rule(target="botp.clslst",order=100)
        public boolean ruleBotpClslstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0)
			  return false;
			this.getBotp().setTempvar(NULLSTR);
			this.getBotp().setTempvar(this.getBotp().getClslst().getElement(index).getClstxt());
			

			return true;
        }


        /**
        *   source:botsdu.@0003.script
        */
        @Check(target="bodgrp.sdutyp",order=100)
        public boolean checkBodgrpSdutypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sdutyp = this.getBodgrp().getSdutyp();
			ctx.getDaoSession().dbRead(this.getBodgrp().getCls(),new Argument<String>("typ",sdutyp),new Argument<String>("flg","8"),new Argument<String>("status","0"));
			this.getBodgrp().getDocdft().setCls(this.getBodgrp().getCls().getClstxt());
			

			return true;
        }


        /**
        *   source:botsdu.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBodgrp().setSdutyp("botsdu1");
			ctx.getDaoSession().dbRead(this.getBodgrp().getCls(),new Argument<String>("typ","botsdu1"),new Argument<String>("flg","8"),new Argument<String>("status","0"));
			this.getBodgrp().getDocdft().setCls(this.getBodgrp().getCls().getClstxt());

			return true;
        }











}