package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptaplVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证寄单项下来证押汇申请
*/
@Transaction(vo= BptaplVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptapl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptapl.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bodgrp bodgrp;


		public Bptapl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bptapl.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bptapl.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bptapl.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bptapl.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptapl.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptapl.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptapl.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptapl.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptapl.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptapl.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptapl.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptapl.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptapl.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Bptapl.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bptapl.this.getBedgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("PD"));
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
        }

        /**
        *   source:bptapl.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			String flags =this.getBpdgrp().getRec().getFlags();
			String objinr =null;
			String objtyp = "bpd";
			log.debug("{}","在matbut模块sav按钮order[200]，flags="+flags);
			//删除模板
			this.getMtabut().getBusmod().dealFile();
			String scr=ctx.absGet(Sysmod.class).getSpt().getScr();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")||(ctx.absGet(Sysmod.class).sptIsLoaded("T")&&"S".equals(scr)))
			{
			  ctx.getDaoSession().dbUpdate(this.getBpdgrp().getRec());
			  objinr = this.getBpdgrp().getRec().getInr();
			  log.debug("{}","objinr=="+objinr );
			  this.getMtabut().UpdatePtsForBack(this.getBpdgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBpdgrp().getApl().getPts(),objinr);
			  ctx.getDaoSession().dbUpdate(this.getBpdgrp().getPxd());
			  if("0001".equals(flags))
			  {
			    this.getBptp().getBxdmod().updBxdAndMar();
			  }

			}
			else
			{
			  log.debug("{}","在bedgrp---rec--inr="+this.getBedgrp().getRec().getInr());
			  if(MdaUtils.isEmpty(this.getBedgrp().getRec().getInr())  && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getPnttyp()) && !"cpd".equals(this.getBpdgrp().getRec().getPnttyp()))
			  {
			    this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			    ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			  }
			  this.getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			  objinr = this.getBpdgrp().getRec().getInr();
			  //父交易业务类型为汇款
			  log.debug("{}","pnttyp="+this.getBpdgrp().getRec().getPnttyp());
			  if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getPnttyp()) && "cpd".equals(this.getBpdgrp().getRec().getPnttyp()))
			  {
			    this.getBpdgrp().getRec().setPntref(this.getBpdgrp().getIsb().getPts().getRef());
			    this.getBptp().setPtytyp("CPD");
			  }
			  else
			  {
			    this.getBptp().setPtytyp("BED");
			    this.getBpdgrp().getRec().setPntinr(this.getBedgrp().getRec().getInr());
			    this.getBpdgrp().getRec().setPnttyp("bed");
			    this.getBpdgrp().getRec().setPntref(this.getBedgrp().getRec().getStlref());
			  }
			  log.debug("{}","bpd inr=="+this.getBpdgrp().getRec().getInr() );
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getRec());
			  //保存dap关联关系
			
			  this.getBpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getBpdgrp().getDap().getPts().setObjinr(objinr);
			  this.getBpdgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getDap().getPts());
			  //保存apl，isb关联关系
			  this.getBpdgrp().getApl().savpts(objinr,objtyp);
			  this.getBpdgrp().getIsb().savpts(objinr,objtyp);
			  //保存出口押汇协议pxd
			  //出口押汇协议参号为空则生成
			  this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getBpdgrp().getPxd(),"ownref"),"YX");
			  this.dealPxd(objinr,objtyp);
			  // 保存保证金协议
			  if("0001".equals(flags))
			  {
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getBpdgrp().getBxd(),"ownref"),"BX");
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getBpdgrp().getMar(),"ownref"),"JX");
			    this.getBptp().getBxdmod().saveBxdAndMar();
			  }
			}
			//处理出口押汇申请中 入账账号
			this.dealPDFData();

			//保存trn流水记录
			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getBptp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:bptapl.@0016.script
        */
        @Rule(target="mtabut.mail",order=200)
        public boolean ruleMtabutMailN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","执行mail，order[200]");
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("bptaplApp"+inr,"bptapl");
			//$mtabut.creatTcoPdfFile("yxyopnDra"+inr);
			this.getMtabut().setAttnames("bptaplApp"+inr+".pdf;bptaplDra"+inr+".pdf");
			log.debug("{}","执行完毕mail，order[200]");

			return true;
        }

        /**
        *   source:bptapl.@0021.script
        */
        @Rule(target="bptp.bxdmod.getbxdref",order=100)
        public boolean ruleBptpBxdmodGetbxdrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getBpdgrp().getBxd(),"ownref");
			this.getMtabut().getRefrence( ownref,  "JX");

			return true;
        }

        /**
        *   source:bptapl.@0025.script
        */
        @Rule(target="bptp.stpmod.next",order=50)
        public boolean ruleBptpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getBptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getBptp().getAgree()))
			    ctx.setFieldError(this,"bptp.agree",MdaUtils.getI18NString("bptapl","CT000111"));
			  return !MdaUtils.isEmpty(this.getBptp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getBpdgrp().getRec()) ;

			  case 2:
			  return ctx.checkAll(this.getBpdgrp().getPxd());

			  case 3:
			  return ctx.checkAll(this.getBpdgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getBpdgrp().getMar());

			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:bptapl.@0026.script
        */
        @Rule(target="bptp.stpmod.gostep",order=50)
        public boolean ruleBptpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getBptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引panelidx="+stepIdx);
			if(stepIdx==1)
			{
			  
			}
			else
			{
			  
			}
			
			if(panelidx>stepIdx)
			  return true;
			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getBptp().getAgree()))
			    ctx.setFieldError(this,"bptp.agree",MdaUtils.getI18NString("bptapl","CT000109"));
			  return !MdaUtils.isEmpty(this.getBptp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getBpdgrp().getRec()) ;

			  case 2:
			  return ctx.checkAll(this.getBpdgrp().getPxd());

			  case 3:
			  return ctx.checkAll(this.getBpdgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getBpdgrp().getMar());

			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:bptapl.@0033.script
        */
        @Rule(target="mtabut.sav",order=190)
        public boolean ruleMtabutSavN190(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *检查及校验
			  */
			if(!(ctx.checkAll(this.getBpdgrp())&&this.getBptp().getBxdmod().checkMxdlst()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000062"),MdaUtils.getI18NString("bptapl","CT000063"));
			  return false;
			}

			/*
			  String flags =$bpdgrp\\rec\\flags.getValue();
			  log.debug("在matbut模块sav按钮order[190]，flags="+flags);
			  if("0011".equals(flags))
			  {//勾选签约提示，保证金相关业务
			  if(!(Platform.checkAll($bpdgrp)&&$bptp\\bxdmod.checkMxdlst()))
			  {
			  Platform.message(#CT000064,#CT000065);
			  return false;
			  }
			  }
			  else if("0001".equals(flags))
			  {//勾选签约提示
			  if(!( Platform.checkAll($bpdgrp\\rec)&& Platform.checkAll($bpdgrp\\pxd)))
			  {
			  Platform.message(#CT000086,#CT000087);
			  return false;
			  }
			  }
			  else if("0000".equals(flags))
			  {
			  if(!Platform.checkAll($bpdgrp\\rec))
			  {
			  Platform.message(#CT000105,#CT000106);
			  return false;
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:bptapl.@0034.script
        */
        @Rule(target="bptp.actcancel",order=100)
        public boolean ruleBptpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:bptapl.@0035.script
        */
        @Rule(target="bptp.actsure",order=100)
        public boolean ruleBptpActsureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getBptp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000070"),MdaUtils.getI18NString("bptapl","CT000071"));
			  return true;
			}
			this.getBpdgrp().getRec().setRmbact(this.getBptp().getActlst().getElement(index).getAct());
			
			

			return true;
        }

        /**
        *   source:bptapl.@0037.script
        */
        @Rule(target="bptp.actselect",order=100)
        public boolean ruleBptpActselectN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBptp().popupActchs();

			return true;
        }

        /**
        *   source:bptapl.@0041.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size = this.getBptp().getBxdmod().getMxdlst().fullSize();
			if(size>4)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000078"),MdaUtils.getI18NString("bptapl","CT000079"));
			  return false;
			}
			this.getBptp().getBxdmod().getMxdlst().add();
			

			return true;
        }

        /**
        *   source:bptapl.@0042.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int count = 0;
			int selidx=-1;
			for(int i=0;i<this.getBptp().getBxdmod().getMxdlst().fullSize();i++)
			{
			  if("X".equals(this.getBptp().getBxdmod().getMxdlst().getElement(i).getModflg()))
			  {
			    ++count;
			    selidx = i;
			  }
			}
			if(count>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000082"),MdaUtils.getI18NString("bptapl","CT000083"));
			  return true;
			}
			int select= selidx;
			if(select<0)
			  select = 0;
			if(select < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000134"),MdaUtils.getI18NString("bptapl","CT000135"));
			  return true;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("bptapl","CT000136"),MdaUtils.getI18NString("bptapl","CT000137")))
			  return true;

			if(!MdaUtils.isEmpty(this.getBptp().getBxdmod().getMxdlst().getElement(select).getInr()))
			{
			  log.debug("{}","src mxdbat inr:"+this.getBptp().getBxdmod().getMxdbak().size());
			  this.getBptp().getBxdmod().getMxdbak().add(this.getBptp().getBxdmod().getMxdlst().getElement(select));
			  log.debug("{}","mxdbak inr:"+this.getBptp().getBxdmod().getMxdbak().size());
			}
			this.getBptp().getBxdmod().getMxdlst().remove(select);
			

			return true;
        }

        /**
        *   source:bptapl.@0044.script
        */
        @Rule(target="mtabut.busmod.select",order=200)
        public boolean ruleMtabutBusmodSelectN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","bedgrp rec stlref"+this.getBedgrp().getRec().getStlref());
			String flg = this.getBpdgrp().getFlg();
			log.debug("{}","mtabut.busmod.select[200],flg="+flg);
			if("S".equals(flg))
			{
			  log.debug("{}","bedinr="+this.getBedgrp().getRec().getInr());
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getIsb().getPts(),new Argument<String>("objtyp","bed"),new Argument<String>("rol","isb"),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()));
			  ctx.getDaoSession().dbRead(this.getBedgrp().getApl().getPts(),new Argument<String>("objtyp","bed"),new Argument<String>("rol","apl"),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()));
			}
			String  flags=this.getBpdgrp().getRec().getFlags();
			if("0001".equals(flags))
			{
			  this.getBptp().setChecked3(TRUE);
			  
			  log.debug("{}","选择模板后清除保证金委托扣划表内容");
			  this.getBpdgrp().getMar().setCur(NULLSTR);
			  this.getBpdgrp().getMar().setAmt(new BigDecimal(0));
			  MdaUtils.clear(this.getBpdgrp().getMxdlst());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMxdbak());
			}
			ctx.postRule(this,"bptp.checked3");

			return true;
        }

        /**
        *   source:bptapl.@0046.script
        */
        @Rule(target="bptp.pdfbpd",order=50)
        public boolean ruleBptpPdfbpdN50(){
            IContext ctx = MdaEnv.getContext();
            
			dealPDFData();

			return true;
        }

        /**
        *   source:bptapl.@0058.script
        */
        @Rule(target="bptp.checked3",order=100)
        public boolean ruleBptpChecked3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","执行  event bptp checked3  .......");
			String steps = null;
			if(MdaUtils.isEmpty(this.getBptp().getChecked3()))
			{//无保证金相关业务，设置flags标志位为0000
			  steps = "0:业务提示;1:出口押汇申请;2:出口押汇协议;5:合同展示";
			  this.getBpdgrp().getRec().setFlags("0000");
			  
			  
			  MdaUtils.clear(this.getBptp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMar());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMxdlst());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMxdbak());
			  
			  
			}
			else
			{
			  //有保证金，设置flags标志位为0001
			  this.getBpdgrp().getRec().setFlags("0001");
			  steps = "0:业务提示;1:出口押汇申请;2:出口押汇协议;3:保证金协议;4:委托开户扣划;5:合同展示";
			  this.getBpdgrp().getMar().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			  
			  

			  
			  
			  

			  
			  
			  

			  
			  

			}
			log.debug("{}","标志位flags="+this.getBpdgrp().getRec().getFlags());
			
			
			
			this.getBptp().getStpmod().setPages(steps);
			this.getBptp().getStpmod().calcSteps();
			this.getBptp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:bptapl.@0059.script
        */
        @Rule(target="bptp.stpmod.last",order=110)
        public boolean ruleBptpStpmodLastN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getBptp().getStpmod().getCuridx();
			log.info("{}","上一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter last 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter last 110!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:bptapl.@0060.script
        */
        @Rule(target="bptp.stpmod.next",order=110)
        public boolean ruleBptpStpmodNextN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getBptp().getStpmod().getCuridx();
			log.info("{}","下一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:bptapl.@0061.script
        */
        @Rule(target="bptp.stpmod.next",order=80)
        public boolean ruleBptpStpmodNextN80(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getIsb().getPts().getRef()))
			{
			  String aplref=this.getBpdgrp().getIsb().getPts().getRef();
			  this.getBpdgrp().getPxd().setXyzh(aplref);
			  
			}

			return true;
        }


        /**
        *   source:bptapl.@0047.script
        */
        @Check(target="bptp.bpdgrp.rec.fftamt",order=100)
        public boolean checkBptpBpdgrpRecFftamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","camt="+this.getBedgrp().getRec().getDocamt()+";tamt="+this.getBpdgrp().getRec().getFftamt());
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getDocamt())||
			  MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftamt()))
			return true;
			BigDecimal camt=this.getBedgrp().getRec().getDocamt();
			BigDecimal tamt=this.getBpdgrp().getRec().getFftamt();

			if(camt.compareTo(tamt)<0)
			{
			log.debug("{}","error");
			ctx.setFieldError(this,"bptp.bpdgrp.rec.fftamt","押汇金额不得大于发票金额");
			}

			return true;
        }

        /**
        *   source:bptapl.@0048.script
        */
        @Check(target="bptp.bpdgrp.rec.rmbact",order=100)
        public boolean checkBptpBpdgrpRecRmbactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBptp().getBpdgrp().getRec().getRmbact()))
			{
			  String lengt=this.getBpdgrp().getRec().getRmbact();
			  if(lengt.length()>18||lengt.length()<18)
			    ctx.setFieldError(this,"bpdgrp.rec.rmbact",MdaUtils.getI18NString("bptapl","CT000090"));
			}

			return true;
        }

        /**
        *   source:bptapl.@0050.script
        */
        @Check(target="bpdgrp.rec.fftvaldat",order=100)
        public boolean checkBpdgrpRecFftvaldatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftvaldat())||MdaUtils.isEmpty(this.getBpdgrp().getRec().getCredat()))
			  return true;
			Date fftvaldat=this.getBpdgrp().getRec().getFftvaldat();
			Date credat=this.getBpdgrp().getRec().getCredat();
			if(MdaUtils.diff(fftvaldat,credat)<0)
			{
			  ctx.setFieldError(this,"bpdgrp.rec.fftvaldat",MdaUtils.getI18NString("bptapl","CT000097"));
			}

			return true;
        }

        /**
        *   source:bptapl.@0054.script
        */
        @Check(target="bpdgrp.bxd.yfczhm",order=100)
        public boolean checkBpdgrpBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBpdgrp().getChecked()))
			{
			  if(MdaUtils.isEmpty(this.getBpdgrp().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getBpdgrp().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getBpdgrp().getBxd().getYfsjhm()))
			    ctx.setFieldError(this,"bpdgrp.bxd.yfczhm",MdaUtils.getI18NString("bptapl","CT000098"));
			}

			return true;
        }

        /**
        *   source:bptapl.@0055.script
        */
        @Check(target="bpdgrp.bxd.yfzrr",order=100)
        public boolean checkBpdgrpBxdYfzrrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBpdgrp().getChecked()))
			{
			  if(MdaUtils.isEmpty(this.getBpdgrp().getBxd().getYf())&&MdaUtils.isEmpty(this.getBpdgrp().getBxd().getYfzrr()))
			  {
			    ctx.setFieldError(this,"bpdgrp.bxd.yf",MdaUtils.getI18NString("bptapl","CT000100"));
			  }
			  else
			  {
			    //乙方(自然人)信息
			    
			    
			    
			    //乙方(自然人)收件信息
			    
			    
			    
			    
			    //乙方(自然人)代收人信息
			    
			    
			    
			    
			    //乙方（单位）信息
			    
			    
			    //乙方（单位）收件信息
			    
			    
			    
			    
			    
			    //乙方（单位）代收人信息
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:bptapl.@0056.script
        */
        @Check(target="bpdgrp.mar.wtklbzjzh",order=100)
        public boolean checkBpdgrpMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBpdgrp().getChecked()))
			{
			  if(MdaUtils.isEmpty(this.getBpdgrp().getMar().getWtklbzjzh())&&MdaUtils.isEmpty(this.getBpdgrp().getMar().getWtkhbzj()))
			    ctx.setMessage(MdaUtils.getI18NString("bptapl","CT000101"),MdaUtils.getI18NString("bptapl","CT000102"));
			}

			return true;
        }

        /**
        *   source:bptapl.@0057.script
        */
        @Check(target="bptp.bpdgrp.rec.jhrzbills",order=100)
        public boolean checkBptpBpdgrpRecJhrzbillsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String typ = this.getBpdgrp().getRec().getPaytyp();
			if("1".equals(typ))
			{
			  if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getJhrzbills())&&MdaUtils.isEmpty(this.getBpdgrp().getRec().getBilreason()))
			    ctx.setFieldError(this,"bpdgrp.rec.jhrzbills",MdaUtils.getI18NString("bptapl","CT000107"));

			}

			return true;
        }


        /**
        *   source:bptapl.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			log.debug("{}","bptapl  init业务处理开始，ORDER编号:100");
			//默认消失掉模板查询交易
			
			

			this.getBpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			

			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			MdaUtils.setValues(this.getBpdgrp().getRec(),"paytyp",MdaUtils.getCodetable("acctyp"));
			//if(Platform.isEmpty($bpdgrp\\rec\\paytyp))
			// $bpdgrp\\rec\\paytyp.setValue("1");
			String flg =null;
			if(MdaUtils.isEmpty(this.getBpdgrp().getFlg()))
			{
			  IModule bed=(IModule)ctx.restoreData("com.brilliance.bptapl.ref");
			  if(!MdaUtils.isEmpty(bed))
			  {
			    this.getBedgrp().getRec().copyValue(bed);
			    this.getBpdgrp().setFlg("S");// select
			    this.getBptp().setPtytyp("BED");
			    log.debug("{}","is select");
			  }
			  else
			  {
			    IModule cpd=(IModule)ctx.restoreData("com.brilliance.bptapl.cpd.ref");
			    if(!MdaUtils.isEmpty(cpd))
			    {
			      this.getBpdgrp().getRec().setPnttyp("cpd");
			      log.debug("{}","汇款 "+this.getBpdgrp().getRec().getPnttyp());
			      this.getBptp().setPtytyp("CPD");
			      this.getBpdgrp().setFlg("N");// new
			    }
			    else
			    {
			      this.getBpdgrp().setFlg("N");// new
			      this.getBptp().setPtytyp("BED");
			      log.debug("{}","is new");
			    }
			  }
			  List<CodetableItem> yhfkfs= this.getBptp().getYhfkfsCodeTable(this.getBptp().getPtytyp());
			  MdaUtils.setValues(this.getBpdgrp().getPxd(),"fkfs",yhfkfs);
			  
			}
			else
			  log.debug("{}","is return "+this.getBpdgrp().getFlg());
			flg = this.getBpdgrp().getFlg();
			if("S".equals(flg))
			{
			  log.debug("{}","bedinr="+this.getBedgrp().getRec().getInr());
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getIsb().getPts(),new Argument<String>("objtyp","bed"),new Argument<String>("rol","isb"),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()));
			  ctx.getDaoSession().dbRead(this.getBedgrp().getApl().getPts(),new Argument<String>("objtyp","bed"),new Argument<String>("rol","apl"),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()));

			  
			  
			  
			  
			  if(MdaUtils.isEmpty(this.getBpdgrp().getIsb().getPts().getRef()))
			    this.getBpdgrp().getIsb().getPts().setRef(this.getBedgrp().getRec().getPntref());
			  log.debug("{}","bkref="+this.getBpdgrp().getIsb().getPts().getRef());
			  
			  
			  
			  //若带入单据，则灰显单据数据，不允许修改
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			}
			else if("N".equals(flg) && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getPnttyp()) && "cpd".equals(this.getBpdgrp().getRec().getPnttyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			this.getBptp().getRgtclu().setClstyp("bptapl");
			//申请日期处理
			this.getBpdgrp().getRec().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;

			this.getBpdgrp().getRec().setFftcur(this.getBedgrp().getRec().getDoccur());
			this.getBpdgrp().getApl().getPty().setNcid(this.getSysmod().getPty().getNcid());
			this.getBpdgrp().getApl().getPty().setNam(this.getSysmod().getPty().getNam());
			this.getBpdgrp().getApl().getPts().setExtkey(this.getSysmod().getPty().getNcid());
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getRgtclu()))
			{
			  ctx.getDaoSession().dbRead(this.getBptp().getRgtclu().getCls(),new Argument<String>("inr",this.getBptp().getRgtclu().readDefaultClsInr("bptapl")));
			  this.getBpdgrp().getRec().setRgtclu(this.getBptp().getRgtclu().getCls().getClstxt());
			}


			return true;
        }

        /**
        *   source:bptapl.@0032.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","bptapl  init业务处理开始，ORDER编号:90");
			//定义步骤条
			this.getBptp().getStpmod().storePanel(this.getBptp().getBptapn10(),this.getBptp().getBptapl01(),this.getBptp().getBptapn07(),this.getBptp().getBptapn08(),this.getBptp().getBptapn09(),this.getBptp().getBptapl03());
			String steps = "0:业务提示;1:出口押汇申请;2:出口押汇协议;5:合同展示";
			String flags=this.getBpdgrp().getRec().getFlags();
			log.debug("{}","标志位flags="+flags);
			//初始隐藏保证金，开户及扣划申请PDF按钮
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  log.debug("{}","暂存或者退回");
			  this.getBptp().initPaytyp();

			  if("0000".equals(flags))
			  {
			    // steps = "0:业务提示;1:出口押汇申请;2:出口押汇协议;5:合同展示";
			    
			    

			    
			    
			  }
			  else if("0001".equals(flags))
			  {
			    steps = "0:业务提示;1:出口押汇申请;2:出口押汇协议;3:保证金协议;4:委托开户扣划;5:合同展示";
			    
			    

			    
			    
			    

			    
			    
			    
			  }
			}
			else
			{
			  //new，初始化flags标志位
			  this.getBpdgrp().getRec().setFlags("0000");
			  
			  this.getBptp().loadTips();
			}
			
			

			this.getBptp().setChecked1(TRUE);
			this.getBptp().setChecked2(TRUE);
			this.getBptp().setChecked4(TRUE);
			
			
			
			
			
			

			log.debug("{}","steps="+steps);
			this.getBptp().getStpmod().setPages(steps);
			this.getBptp().getStpmod().calcSteps();
			this.getBptp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:bptapl.@0002.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据押汇款项入账类型（1：结汇:2：原币划转）处理入账账号
			String credat = MdaUtils.format(MdaUtils.today(),"yyyy年MM月dd日");
			this.getBptp().setCredat(credat);
			this.getBptp().setRmbact(NULLSTR);
			this.getBptp().setRmaact(NULLSTR);
			if (!MdaUtils.isEmpty(this.getBpdgrp().getRec().getPaytyp()))
			{
			  if("1".equals(this.getBpdgrp().getRec().getPaytyp()))
			    this.getBptp().setRmbact(this.getBpdgrp().getRec().getRmbact());
			  else if("2".equals(this.getBpdgrp().getRec().getPaytyp()))
			    this.getBptp().setRmaact(this.getBpdgrp().getRec().getRmbact());
			}
		}
        /**
        *   source:bptapl.@0019.script
        */
        public void dealPxd(String objinr,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**处理出口押汇协议
			  objinr：业务数据inr
			  objtyp:业务表名*/
			log.debug("{}","dealPxd处理开始    ");
			this.getBpdgrp().getPxd().setInr(Platform.sdbCounter("pxd"));
			this.getBpdgrp().getPxd().setObjinr(objinr);
			this.getBpdgrp().getPxd().setObjtyp(objtyp);
			ctx.getDaoSession().dbInsert(this.getBpdgrp().getPxd());
		}










}