package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptcfmVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口押汇合同要素修改
*/
@Transaction(vo= BptcfmVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptcfm extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptcfm.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bodgrp bodgrp;


		public Bptcfm()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bptcfm.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bptcfm.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcfm.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bptcfm.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bptcfm.this.getBpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("PD"));
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
        }

        /**
        *   source:bptcfm.@0001.script
        */
        @Rule(target="mtabut.bnkcfm",order=200)
        public boolean ruleMtabutBnkcfmN200(){
            IContext ctx = MdaEnv.getContext();
            
			String flags =this.getBpdgrp().getRec().getFlags();
			log.debug("{}","在matbut模块bnkcfm按钮order[200]，flags="+flags);
			ctx.getDaoSession().dbUpdate(this.getBpdgrp().getPxd());
			if("0001".equals(flags))
			{
			  ctx.getDaoSession().dbUpdate(this.getBpdgrp().getBxd());
			}
			//保存trn
			ctx.absGet(Trnmod.class).setTrnForSecondConfirm();
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getBptp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);


			return true;
        }

        /**
        *   source:bptcfm.@0002.script
        */
        @Rule(target="mtabut.bnkcfm",order=190)
        public boolean ruleMtabutBnkcfmN190(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *检查及校验
			  */
			String flags =this.getBpdgrp().getRec().getFlags();
			log.debug("{}","在matbut模块bnkcfm按钮order[190]，flags="+flags);
			if("0001".equals(flags))
			{//有保证金相关业务
			  if(!ctx.checkAll(this.getBpdgrp().getPxd())&&!ctx.checkAll(this.getBpdgrp().getBxd()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bptcfm","CT000004"),MdaUtils.getI18NString("bptcfm","CT000005"));
			    return false;
			  }
			}
			else if("0000".equals(flags))
			{//无保证金相关业务
			  if(! ctx.checkAll(this.getBpdgrp().getPxd()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bptcfm","CT000006"),MdaUtils.getI18NString("bptcfm","CT000007"));
			    return false;
			  }
			}


			return true;
        }



        /**
        *   source:bptcfm.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String  objinr=(String)ctx.restoreData("com.brilliance.bptcfm.inr");
			log.debug("{}","bpd.inr =" + objinr);
			if(!MdaUtils.isEmpty(objinr))
			{
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getRec(),new Argument<String>("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getPxd(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp","bpd"));
			  //定义步骤条
			  this.getBptp().getStpmod().storePanel(this.getBptp().getBptcfmstep01(),this.getBptp().getBptcfmstep02(),this.getBptp().getBptcfmstep03());
			  String steps="0:出口押汇协议;2:合同展示";
			  String flags=this.getBpdgrp().getRec().getFlags();
			  //签订了保证金协议
			  if("0001".equals(flags))
			  {
			    ctx.getDaoSession().dbRead(this.getBpdgrp().getBxd(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp","bpd"));
			    //Platform.visible($bptp\\pdfbxd);
			    steps = "0:出口押汇协议;1:保证金协议;2:合同展示";
			  }
			  else if("0000".equals(flags))
			  {
			    steps = "0:出口押汇协议;2:合同展示";
			    
			  }
			  this.getBptp().getStpmod().setPages(steps);
			  this.getBptp().getStpmod().calcSteps();
			  //隐藏出口押汇协议界面上是否签订保证金勾选项
			  
			}

			return true;
        }












}