package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptcrfVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 偿还出口押汇通知
*/
@Transaction(vo= BptcrfVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptcrf extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptcrf.class);

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Bptmod bptmod;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Ledgrp ledgrp;


		public Bptcrf()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBptmod().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBptmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bptcrf.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bptcrf.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptcrf.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bptcrf.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bptcrf.this.getBpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:bptcrf.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:bptcrf.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels ="";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getBptp().getBptp07());

			return true;
        }

        /**
        *   source:bptcrf.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }













}