package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sigtip;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口押汇模板推送
*/
@Transaction(vo= BptmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptmdl.class);

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sigtip sigtip;


		public Bptmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bptmdl.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bptmdl.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptmdl.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bptmdl.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bptmdl.this.getBpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("PD"));
        }

        /**
        *   source:bptmdl.@0001.script
        */
        @Rule(target="bpdgrp.checked",order=100)
        public boolean ruleBpdgrpCheckedN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","execute  event bpdgrp checked  .......");
			String steps = null;
			if(MdaUtils.isEmpty(this.getBpdgrp().getChecked()))
			{
			  steps = "0:出口押汇申请;1:出口押汇协议;4:保存模板";
			  //无保证金协议及保证金委托开户和扣划，设置flags标志位为0000
			  this.getBpdgrp().getRec().setFlags("0000");
			  MdaUtils.clear(this.getBptp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMar());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMxdlst());
			  MdaUtils.clear(this.getBptp().getBxdmod().getMxdbak());
			}
			else
			{
			  this.getBpdgrp().getBxd().setCgyd("1");
			  ctx.postRule(this,"bpdgrp.bxd.cgyd");
			  this.getBpdgrp().getBxd().setJxyd("1");
			  ctx.postRule(this,"bpdgrp.bxd.jxyd");
			  this.getBpdgrp().getBxd().setJsyd("1");
			  ctx.postRule(this,"bpdgrp.bxd.jsyd");
			  this.getBpdgrp().getBxd().setZyjjfs("1");
			  ctx.postRule(this,"bpdgrp.bxd.zyjjfs");
			  //有保证金协议及保证金委托开户和扣划，设置flags标志位为0001
			  this.getBpdgrp().getRec().setFlags("0001");

			  steps = "0:出口押汇申请;1:出口押汇协议;2:保证金协议;3:委托开户扣划;4:保存模板";
			}
			log.debug("{}","标志位flags="+this.getBpdgrp().getRec().getFlags());
			
			this.getBptp().getStpmod().setPages(steps);
			this.getBptp().getStpmod().calcSteps();
			this.getBptp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:bptmdl.@0003.script
        */
        @Rule(target="bptp.ptytyp",order=100)
        public boolean ruleBptpPtytypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getBptp().getPtytyp();
			if("BOD".equals(ptytyp))
			{
			  
			  
			  
			  
			  
			  //灰显开证行
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  //显示待收行
			  
			  
			  
			  
			  this.getBptp().getBummod().setModtyp("bptapn");

			}
			else if("BED".equals(ptytyp)||"CPD".equals(ptytyp))
			{
			  
			  
			  
			  
			  
			  //灰显代收行
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  //显示开证行
			  
			  
			  
			  
			  
			  
			  this.getBptp().getBummod().setModtyp("bptapl");

			}
			

			return true;
        }

        /**
        *   source:bptmdl.@0011.script
        */
        @Rule(target="bptp.select",order=100)
        public boolean ruleBptpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getBptp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage("提示","请先选中一条记录！");
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getBptp().getCidmod().getClipty(),new Argument("cid",this.getBptp().getCidmod().getClilst().getElement(index).getCid()));
			  this.getBptp().getBummod().getWrkmdl().setCidinr(this.getBptp().getCidmod().getClipty().getCid());
			  log.debug("{}","cidinr="+this.getBptp().getBummod().getWrkmdl().getCidinr());
			  this.getBpdgrp().setAplnam(this.getBptp().getCidmod().getClipty().getNam());
			  
			}


			return true;
        }

        /**
        *   source:bptmdl.@0012.script
        */
        @Rule(target="bptp.cidmod.clilst",order=100)
        public boolean ruleBptpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"bptp.select");

			return true;
        }

        /**
        *   source:bptmdl.@0014.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size = this.getBptp().getBxdmod().getMxdlst().fullSize();
			if(size>7)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptmdl","CT000004"),MdaUtils.getI18NString("bptmdl","CT000005"));
			  return false;
			}
			this.getBptp().getBxdmod().getMxdlst().add();
			

			return true;
        }

        /**
        *   source:bptmdl.@0015.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int select = 0;
			if(select < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptmdl","CT000006"),MdaUtils.getI18NString("bptmdl","CT000007"));
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getBptp().getBxdmod().getMxdlst().getElement(select).getInr()))
			  {
			    log.debug("{}","src mxdbat inr:"+this.getBptp().getBxdmod().getMxdbak().size());
			    this.getBptp().getBxdmod().getMxdbak().add(this.getBptp().getBxdmod().getMxdlst().getElement(select));
			    log.debug("{}","mxdbak inr:"+this.getBptp().getBxdmod().getMxdbak().size());
			  }
			  this.getBptp().getBxdmod().getMxdlst().remove(select);
			}
			

			return true;
        }

        /**
        *   source:bptmdl.@0016.script
        */
        @Rule(target="bptp.actsure",order=100)
        public boolean ruleBptpActsureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getBptp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptmdl","CT000010"),MdaUtils.getI18NString("bptmdl","CT000011"));
			  return true;
			}
			this.getBpdgrp().getRec().setRmbact(this.getBptp().getActlst().getElement(index).getAct());
			
			

			return true;
        }

        /**
        *   source:bptmdl.@0018.script
        */
        @Rule(target="bptp.actselect",order=100)
        public boolean ruleBptpActselectN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBptp().popupActchs2();

			return true;
        }

        /**
        *   source:bptmdl.@0020.script
        */
        @Rule(target="bptp.stpmod.gostep",order=50)
        public boolean ruleBptpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getBptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			switch(panelidx)
			{
			  case 0:
			  return ctx.checkAll(this.getBpdgrp().getRec()) ;

			  case 1:
			  return ctx.checkAll(this.getBpdgrp().getPxd());

			  case 2:
			  return ctx.checkAll(this.getBpdgrp().getBxd()) ;

			  case 3:
			  return  ctx.checkAll(this.getBpdgrp().getMar());
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:bptmdl.@0021.script
        */
        @Rule(target="bptp.stpmod.next",order=50)
        public boolean ruleBptpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getBptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			switch(panelidx)
			{
			  case 0:
			  return ctx.checkAll(this.getBpdgrp().getRec()) ;

			  case 1:
			  return ctx.checkAll(this.getBpdgrp().getPxd());

			  case 2:
			  return ctx.checkAll(this.getBpdgrp().getBxd()) ;

			  case 3:
			  return  ctx.checkAll(this.getBpdgrp().getMar());
			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:bptmdl.@0026.script
        */
        @Rule(target="bptp.actcancel",order=100)
        public boolean ruleBptpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }


        /**
        *   source:bptmdl.@0019.script
        */
        @Check(target="bptp.bpdgrp.rec.rmbact",order=100)
        public boolean checkBptpBpdgrpRecRmbactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBptp().getBpdgrp().getRec().getRmbact()))
			{
			  String lengt=this.getBpdgrp().getRec().getRmbact();
			  if(lengt.length()>18||lengt.length()<18)
			    ctx.setFieldError(this,"bpdgrp.rec.rmbact",MdaUtils.getI18NString("bptmdl","CT000012"));
			}

			return true;
        }

        /**
        *   source:bptmdl.@0022.script
        */
        @Check(target="bpdgrp.rec.fftvaldat",order=100)
        public boolean checkBpdgrpRecFftvaldatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftvaldat())||MdaUtils.isEmpty(this.getBpdgrp().getRec().getCredat()))
			  return true;
			Date fftvaldat=this.getBpdgrp().getRec().getFftvaldat();
			Date credat=this.getBpdgrp().getRec().getCredat();
			if(!MdaUtils.isEmpty(fftvaldat) && !MdaUtils.isEmpty(credat) && MdaUtils.diff(fftvaldat,credat)<0)
			{
			  ctx.setFieldError(this,"bpdgrp.rec.fftvaldat",MdaUtils.getI18NString("bptmdl","CT000016"));
			}

			return true;
        }

        /**
        *   source:bptmdl.@0023.script
        */
        @Check(target="bptp.bpdgrp.pxd.yhnll",order=100)
        public boolean checkBptpBpdgrpPxdYhnllN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal yhnl=this.getBpdgrp().getPxd().getYhnll();
			BigDecimal handrel=new BigDecimal(100);
			if(yhnl.compareTo(handrel)>0)
			{
			  ctx.setFieldError(this,"bpdgrp.pxd.yhnll",MdaUtils.getI18NString("bptmdl","CT000017"));
			}


			return true;
        }

        /**
        *   source:bptmdl.@0024.script
        */
        @Check(target="bptp.bpdgrp.pxd.fxl",order=100)
        public boolean checkBptpBpdgrpPxdFxlN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal yhnl=this.getBpdgrp().getPxd().getFxl();
			BigDecimal handrel=new BigDecimal(100);
			if(yhnl.compareTo(handrel)>0)
			{
			  ctx.setFieldError(this,"bpdgrp.pxd.fxl",MdaUtils.getI18NString("bptmdl","CT000018"));
			}


			return true;
        }

        /**
        *   source:bptmdl.@0025.script
        */
        @Check(target="bptp.bpdgrp.pxd.gqbgbl",order=100)
        public boolean checkBptpBpdgrpPxdGqbgblN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal yhnl=this.getBpdgrp().getPxd().getGqbgbl();
			BigDecimal handrel=new BigDecimal(100);
			if(yhnl.compareTo(handrel)>0)
			{
			  ctx.setFieldError(this,"bpdgrp.pxd.gqbgbl",MdaUtils.getI18NString("bptmdl","CT000019"));
			}


			return true;
        }


        /**
        *   source:bptmdl.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块bptmdl  init业务处理开始，ORDER编号:100");
			//初始化是否有保证金协议标志位
			this.getBpdgrp().getRec().setFlags("0000");
			//初始化申请日期
			this.getBpdgrp().getRec().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			//初始化申请押汇种类
			this.getBptp().setPtytyp("BED");
			ctx.postRule(this,"bptp.ptytyp");
			this.getBpdgrp().getPxd().setSyqk("1");
			ctx.postRule(this,"bpdgrp.pxd.syqk");
			List<CodetableItem> yhfkfs= this.getBptp().getYhfkfsCodeTable(this.getBptp().getPtytyp());
			MdaUtils.setValues(this.getBpdgrp().getPxd(),"fkfs",yhfkfs);
			
			this.getBpdgrp().getPxd().setFkfs("1");
			ctx.postRule(this,"bpdgrp.pxd.fkfs");
			this.getBpdgrp().getPxd().setJxyd("1");
			ctx.postRule(this,"bpdgrp.pxd.jxyd");
			this.getBpdgrp().getPxd().setZyjjfs("1");
			ctx.postRule(this,"bpdgrp.pxd.zyjjfs");

			return true;
        }

        /**
        *   source:bptmdl.@0013.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块bptmdl  init业务处理开始，ORDER编号:90");
			//定义步骤条
			this.getBptp().getStpmod().storePanel(this.getBptp().getBptmdlstep02(),this.getBptp().getBptmdlstep03(),this.getBptp().getBptmdlstep04(),this.getBptp().getBptmdlstep05(),this.getBptp().getBptmdlstep06());
			String steps = "0:出口押汇申请;1:出口押汇协议;4:保存模板";
			this.getBptp().getStpmod().setPages(steps);
			this.getBptp().getStpmod().calcSteps();


			return true;
        }













}