package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptopnVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 议付/托收押汇申请
*/
@Transaction(vo= BptopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptopn.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Bodgrp bodgrp;


		public Bptopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bptopn.@0001.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))
			{
			  //出口信用证寄单记录
			  this.getSelp().sureBtn("bedgrp","bptopl");
			}
			else if("2".equals(seltyp))
			{
			  //出口托收寄单记录
			  this.getSelp().sureBtn1("bodgrp","bptopc");
			}

			return true;
        }

        /**
        *   source:bptopn.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //出口信用证寄单记录
			  
			  
			  //queryClause = "SELECT bed.inr trsinr,bed.stlref ref,bed.advdat dat,bed.doccur cur,bed.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bed,pts,adr,pta WHERE bed.docflg = 'docadv' AND pts.rol = 'apl' AND pts.objtyp = 'bed' AND pts.objinr = bed.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  //201712
			  //queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam  FROM bed  rec,pts s WHERE  (rec.DOCFLG = 'docadv' or rec.DOCFLG='accept' or rec.DOCFLG = 'hodrej') AND  s.objtyp = 'bpd' AND s.rol = 'apl' AND s.objinr=rec.inr"
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam  FROM bed  rec,pts s WHERE  (rec.DOCFLG = 'docadv' or rec.DOCFLG='accept' or rec.DOCFLG = 'hodrej') AND  s.objtyp = 'bed' AND s.rol = 'apl' AND s.objinr=rec.inr AND rec.stlref NOT LIKE '%BX%'"
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}
			else if("2".equals(seltyp))
			{
			  //出口托收寄单记录
			  
			  
			  //queryClause = "SELECT bod.inr trsinr,bod.stlref ref,bod.rcvdat dat,bod.doccur cur,bod.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bod,pts,adr,pta WHERE bod.docflg = 'docadv' AND pts.rol = 'drr' AND pts.objtyp = 'bod' AND pts.objinr = bod.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.rcvdat dat,rec.occcur cur,rec.occamt amt,substr(s.adrblk,0,35) aplnam  FROM bod rec,pts s WHERE  (rec.DOCFLG = 'docadv' or rec.DOCFLG='accept' or rec.DOCFLG = 'hodrej') AND  s.objtyp = 'bod' AND s.rol = 'drr' AND s.objinr=rec.inr"
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn1(queryClause);
			}
			
			

			return true;
        }

        /**
        *   source:bptopn.@0003.script
        */
        @Rule(target="selp.newapply",order=100)
        public boolean ruleSelpNewapplyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			MdaUtils.clear(this.getLedgrp().getRec());
			MdaUtils.clear(this.getBedgrp().getRec());
			if("1".equals(seltyp))
			{
			  
			}
			else if("2".equals(seltyp))
			{
			  //出口托收寄单记录
			  
			}
			else if("3".equals(seltyp))
			{
			  //汇款
			  this.getBedgrp().getRec().setPnttyp("cpd");
			  ctx.storeData("com.brilliance.bptopl.cpd.ref",this.getBedgrp().getRec());
			  
			}

			return true;
        }

        /**
        *   source:bptopn.@0004.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			//出口信用证寄单记录
			this.getSelp().sureBtn("bedgrp","bptopl");

			return true;
        }

        /**
        *   source:bptopn.@0005.script
        */
        @Rule(target="selp.tmplst1",order=100)
        public boolean ruleSelpTmplst1N100(){
            IContext ctx = MdaEnv.getContext();
            
			//出口托收寄单记录
			this.getSelp().sureBtn1("bodgrp","bptopc");

			return true;
        }



        /**
        *   source:bptopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selbptopn"));
			this.getSelp().setSeltyp("1");
			
			
			//将查询语句输入selp层的Argument类型控件queryClause字段
			// String queryClause = "SELECT bed.inr trsinr,bed.stlref ref,bed.advdat dat,bed.doccur cur,bed.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bed,pts,adr,pta WHERE bed.docflg = 'docadv' AND pts.rol = 'apl' AND pts.objtyp = 'bed' AND pts.objinr = bed.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			//201712
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam FROM bed rec,pts s WHERE  (rec.docflg = 'docadv' or rec.docflg = 'accept' or rec.docflg = 'hodrej') AND  s.objtyp = 'bpd' AND s.rol = 'apl' AND s.objinr=rec.inr"
			/*  String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam FROM bed rec,pts s WHERE  (rec.docflg = 'docadv' or rec.docflg = 'accept' or rec.docflg = 'hodrej') AND  s.objtyp = 'bed' AND s.rol = 'apl' AND s.objinr=rec.inr "
			  +$\\sysmod.getSelection();*/
			//业务人员需要查询出的STLREF不需要BX的
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam FROM bed rec,pts s WHERE  (rec.docflg = 'docadv' or rec.docflg = 'accept' or rec.docflg = 'hodrej') AND  s.objtyp = 'bed' AND s.rol = 'apl' AND s.objinr=rec.inr AND rec.stlref NOT LIKE '%BX%'"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }









}