package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BptrpnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 偿还出口押汇申请
*/
@Transaction(vo= BptrpnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptrpn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptrpn.class);

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bptmod bptmod;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Bptrpn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBptmod().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBptmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("CP"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.retamt");}
 				public void setValue(BigDecimal arg){Bptrpn.this.getBpdgrp().getRec().setRetamt(arg);}
 				public BigDecimal getValue(){return Bptrpn.this.getBpdgrp().getRec().getRetamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.retcur");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setRetcur(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getRetcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptrpn.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bptrpn.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bptrpn.this.getBpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bptrpn.@0004.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","sav200入库================");
			if(!ctx.checkAll(this.getBpdgrp().getRec()))
			  return false;

			BigDecimal retamt =this.getBptp().getVals(this.getBpdgrp().getRec().getRetamt());
			this.getBpdgrp().getRec().setRetamt(retamt);

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getBpdgrp().getRec());
			else
			{
			  log.info("{}","sav200入库开始================");
			  if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getInr()))
			  {
			    this.getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			    ctx.getDaoSession().dbInsert(this.getBpdgrp().getRec());
			  }
			  else
			    ctx.getDaoSession().dbUpdate(this.getBpdgrp().getRec());
			  String objinr=this.getBpdgrp().getRec().getInr();
			  this.getBpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getBpdgrp().getDap().getPts().setObjinr(objinr);
			  this.getBpdgrp().getDap().getPts().setObjtyp( "bpd");
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getDap().getPts());
			  log.info("{}","sav200入库结束================");
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================");

			return true;
        }

        /**
        *   source:bptrpn.@0005.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","bptrpn",stream,false );

			return true;
        }

        /**
        *   source:bptrpn.@0007.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt bptrpn.mtabut.imgtp.images ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:bptrpn.@0009.script
        */
        @Rule(target="bpdgrp.rec.matdat",order=100)
        public boolean ruleBpdgrpRecMatdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!Platform.isEmpty($bpdgrp\\rec\\matdat))
			  {
			  Platform.enable($bpdgrp\\rec\\yret);
			  Platform.enable($bpdgrp\\rec\\nret);
			  }
			  else
			  {
			  Platform.clear($bpdgrp\\rec\\yret);
			  Platform.clear($bpdgrp\\rec\\nret);
			  Platform.disable($bpdgrp\\rec\\yret);
			  Platform.disable($bpdgrp\\rec\\nret);
			  }
			  Platform.setModified($bpdgrp\\rec\\yret);
			  Platform.setModified($bpdgrp\\rec\\nret);
			  */

			return true;
        }

        /**
        *   source:bptrpn.@0010.script
        */
        @Rule(target="bpdgrp.rec.yret",order=100)
        public boolean ruleBpdgrpRecYretN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBpdgrp().getRec().getYret()))
			{
			  this.getBpdgrp().getRec().setNret("");
			  this.getBpdgrp().getRec().setRetdat(this.getBpdgrp().getRec().getMatdat());
			  
			  
			  
			  
			}
			else
			{
			  this.getBpdgrp().getRec().setNret("X");
			  
			  
			  
			  this.getBptp().setHuktis("提前还款已与银行事前沟通确认！");

			}

			
			
			
			

			return true;
        }

        /**
        *   source:bptrpn.@0011.script
        */
        @Rule(target="bpdgrp.rec.nret",order=100)
        public boolean ruleBpdgrpRecNretN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBpdgrp().getRec().getNret()))
			{
			  this.getBpdgrp().getRec().setYret("");
			  
			  
			  
			  this.getBptp().setHuktis("提前还款已与银行事前沟通确认！");
			}

			else
			{
			  this.getBpdgrp().getRec().setYret("X");
			  this.getBpdgrp().getRec().setRetdat(this.getBpdgrp().getRec().getMatdat());
			  this.getBptp().setHuktis(NULLSTR);
			  
			  
			  
			}
			
			
			
			

			return true;
        }

        /**
        *   source:bptrpn.@0015.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "偿还出口押汇/贴现申请";
			String tempfiles = "A:bptrpn";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:bptrpn.@0016.script
        */
        @Rule(target="bptp.actselect",order=100)
        public boolean ruleBptpActselectN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBptp().getActchs());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			ctx.getDaoSession().dbReadset(this.getBptp().getActlst(),new Argument<String>("cur",this.getBpdgrp().getRec().getRetcur()),new Argument<String>("ptyinr",ptyinr));
			
			

			return true;
        }

        /**
        *   source:bptrpn.@0018.script
        */
        @Rule(target="bptp.actcancel",order=100)
        public boolean ruleBptpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:bptrpn.@0019.script
        */
        @Rule(target="bptp.actsure",order=100)
        public boolean ruleBptpActsureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getBptp().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bptrpn","CT000026"),MdaUtils.getI18NString("bptrpn","CT000027"));
			  return false;
			}
			this.getBpdgrp().getRec().setRmbact(this.getBptp().getActlst().getElement(index).getAct());
			
			

			return true;
        }

        /**
        *   source:bptrpn.@0021.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream=$mtabut\\apldoc.getValue();
			BigDecimal retamt =this.getBptp().getVals(this.getBpdgrp().getRec().getRetamt());
			this.getBpdgrp().getRec().setRetamt(retamt);
			
			this.getBptp().getPdfviw().callPDFComponent("","bptrpn","偿还出口押汇申请书",1);

			return true;
        }


        /**
        *   source:bptrpn.@0001.script
        */
        @Check(target="bptp.bpdgrp.rec.fftbanamt",order=100)
        public boolean checkBptpBpdgrpRecFftbanamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  BigDecimal fftbanamt = $bptp\\bpdgrp\\rec\\fftbanamt.getValue();
			  BigDecimal fftamt = $bptp\\bpdgrp\\rec\\fftamt.getValue();
			  if(fftbanamt.compareTo(fftamt)>0)
			  {
			  Platform.error($bptp\\bpdgrp\\rec\\fftbanamt,#CT000000);
			  }
			  */

			return true;
        }

        /**
        *   source:bptrpn.@0002.script
        */
        @Check(target="bptp.bpdgrp.rec.matdat",order=100)
        public boolean checkBptpBpdgrpRecMatdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			    if(Platform.diff($bptp\\bpdgrp\\rec\\matdat.getValue(),$bptp\\bpdgrp\\rec\\credat.getValue())>0)
			    {
			      Platform.error($bptp\\bpdgrp\\rec\\matdat,#CT000001);
			    }
			    */
			  
			return true;
        }

        /**
        *   source:bptrpn.@0003.script
        */
        @Check(target="bpdgrp.rec.retamt",order=100)
        public boolean checkBpdgrpRecRetamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal fftamt=this.getBpdgrp().getRec().getFftamt();
			BigDecimal retamt=this.getBpdgrp().getRec().getRetamt();
			if(retamt.compareTo(fftamt)<0)
			{
			  ctx.setFieldError(this,"bpdgrp.rec.retamt",MdaUtils.getI18NString("bptrpn","CT000002"));
			  return true;
			}
			BigDecimal js=MdaUtils.parseDecimal(0.00);
			if(retamt.compareTo(js)<0)
			{
			  this.getBpdgrp().getRec().setRetamt(new BigDecimal(0));
			  ctx.setFieldError(this,"bpdgrp.rec.retamt",MdaUtils.getI18NString("bptrpn","CT000043"));
			  return true;
			}
			

			return true;
        }

        /**
        *   source:bptrpn.@0017.script
        */
        @Check(target="bpdgrp.rec.rmbact",order=100)
        public boolean checkBpdgrpRecRmbactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBptp().getBpdgrp().getRec().getRmbact()))
			{
			  /*String lengt=$bpdgrp\\rec\\rmbact.getValue();
			    if(lengt.length()<13||lengt.length()>19)
			    {
			    Platform.error($bpdgrp\\rec\\rmbact,#CT000022);
			    return false;
			    }
			    */
			  Pattern pattern=Pattern.compile("[0-9]*");
			  String rmbact=this.getBpdgrp().getRec().getRmbact();
			  if(!pattern.matcher(rmbact).matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.rec.rmbact",MdaUtils.getI18NString("bptrpn","CT000023"));
			  }
			}

			return true;
        }

        /**
        *   source:bptrpn.@0020.script
        */
        @Check(target="bpdgrp.rec.retdat",order=10)
        public boolean checkBpdgrpRecRetdatN10(){
            IContext ctx = MdaEnv.getContext();
            
			Date mat =this.getBpdgrp().getRec().getMatdat();
			Date ret =this.getBpdgrp().getRec().getRetdat();
			Date cre =this.getBpdgrp().getRec().getCredat();
			if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getMatdat()) && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getRetdat()))
			{
			  if(MdaUtils.diff(ret,mat)>0)
			  {
			    ctx.setFieldError(this,"bpdgrp.rec.retdat",MdaUtils.getI18NString("bptrpn","CT000028"));
			    return true;
			  }
			}
			if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getRetdat()) && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getCredat()))
			{
			  if(MdaUtils.diff(ret,cre)<0)
			  {
			    ctx.setFieldError(this,"bpdgrp.rec.retdat",MdaUtils.getI18NString("bptrpn","CT000046"));
			    return true;
			  }
			}

			return true;
        }

        /**
        *   source:bptrpn.@0022.script
        */
        @Check(target="bpdgrp.rec.docamt",order=100)
        public boolean checkBpdgrpRecDocamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal  docamt=this.getBpdgrp().getRec().getDocamt();
			if(!MdaUtils.isEmpty(docamt))
			{
			  BigDecimal js=MdaUtils.parseDecimal(0.00);
			  if(docamt.compareTo(js)<0)
			  {
			    ctx.setFieldError(this,"bpdgrp.rec.docamt",MdaUtils.getI18NString("bptrpn","CT000031"));
			  }
			}
			

			return true;
        }

        /**
        *   source:bptrpn.@0023.script
        */
        @Check(target="bpdgrp.rec.fftamt",order=100)
        public boolean checkBpdgrpRecFftamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal fftamt=this.getBpdgrp().getRec().getFftamt();
			BigDecimal docamt=this.getBpdgrp().getRec().getDocamt();
			if(fftamt.compareTo(docamt)>0)
			{
			  ctx.setFieldError(this,"bpdgrp.rec.fftamt",MdaUtils.getI18NString("bptrpn","CT000037"));
			  return true;
			}
			if(!MdaUtils.isEmpty(fftamt))
			{
			  BigDecimal js=MdaUtils.parseDecimal(0.00);
			  if(fftamt.compareTo(js)<0)
			  {
			    ctx.setFieldError(this,"bpdgrp.rec.fftamt",MdaUtils.getI18NString("bptrpn","CT000038"));
			    return true;
			  }
			}
			

			return true;
        }

        /**
        *   source:bptrpn.@0024.script
        */
        @Check(target="bptp.bpdgrp.rec.retamt",order=100)
        public boolean checkBptpBpdgrpRecRetamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBptp().getBpdgrp().getRec(),"retamt"));

			return true;
        }


        /**
        *   source:bptrpn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			this.getBpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBpdgrp().getRec().setBchcod(bchcod.get(0).getValue());

			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getYret())&&MdaUtils.isEmpty(this.getBpdgrp().getRec().getNret()))
			{
			  this.getBpdgrp().getRec().setYret("X");
			  
			  
			}
			String flg =null;
			if(MdaUtils.isEmpty(this.getBpdgrp().getFlg()))
			{
			  IModule bpd = (IModule)ctx.restoreData("com.brilliance.bptrpn.ref");
			  if(!MdaUtils.isEmpty(bpd))
			  {
			    this.getBpdgrp().getRec().copyValue(bpd);
			    this.getBpdgrp().setFlg("S");// select
			    log.debug("{}","is select");
			  }
			  else
			  {
			    this.getBpdgrp().setFlg("N");// new
			    log.debug("{}","is new");
			  }
			}
			else
			  log.debug("{}","is return "+this.getBpdgrp().getFlg());
			flg = this.getBpdgrp().getFlg();
			if("S".equals(flg))
			{
			  String ref=this.getBpdgrp().getRec().getStlref();
			  if("FN".equals(ref.substring(0,2)))
			  {
			    this.getBpdgrp().getRec().setDocamt(this.getBpdgrp().getRec().getFftamt());
			    this.getBpdgrp().getRec().setDoccur(this.getBpdgrp().getRec().getFftcur());
			  }
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			this.getBptp().getRgtclu().setClstyp("bptrpn");

			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getNret()))
			{
			  this.getBpdgrp().getRec().setYret("X");
			  this.getBpdgrp().getRec().setRetdat(this.getBpdgrp().getRec().getMatdat());
			  
			  
			  
			  
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			this.getBpdgrp().getRec().setCredat(MdaUtils.today());
			this.getBpdgrp().getRec().setRetcur("USD");
			this.getBpdgrp().getRec().setRettyp("1");
			// Platform.clear($bpdgrp\\rec\\ownref);
			this.getBpdgrp().getRec().setRetamt(new BigDecimal(0));
			this.getBpdgrp().getRec().setRmbact(NULLSTR);
			this.getBpdgrp().getRec().setNote(NULLSTR);
			this.getBpdgrp().getDap().initDap("bpd");
			if(MdaUtils.isEmpty(this.getBpdgrp().getApl().getPts().getInr()))
			{
			  this.getBpdgrp().getApl().copyValues(this.getBpdgrp().getDap());
			  this.getBpdgrp().getApl().getPts().setRol("apl");
			  this.getBpdgrp().getApl().getPty().setNam(this.getSysmod().getPty().getNam());
			}
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftcur()))
			  this.getBpdgrp().getRec().setFftcur("USD");
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getDoccur()))
			  this.getBpdgrp().getRec().setDoccur("USD");
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getRgtclu()))
			{
			  //Platform.dbRead($bptp\\rgtclu\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","bptrpn"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getBptp().getRgtclu().getCls(),new Argument<String>("inr",this.getBptp().getRgtclu().readDefaultClsInr("bptrpn")));
			  this.getBpdgrp().getRec().setRgtclu(this.getBptp().getRgtclu().getCls().getClstxt());
			}

			return true;
        }

        /**
        *   source:bptrpn.@0006.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getBpdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    //$bpdgrp\\rec\\bchcod.setValue($bpdgrp\\rec\\ibchcod.getValue());
			  {
			    if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getIbchcod()))
			      this.getBpdgrp().getRec().setBchcod(this.getBpdgrp().getRec().getIbchcod());
			    else
			    {
			      this.getBpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getBpdgrp().getRec().setIbchcod(this.getBpdgrp().getRec().getBchcod());
			    }
			    //Platform.setModified($bpdgrp\\rec\\bchcod);
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getDbchcod()))
			      this.getBpdgrp().getRec().setBchcod(this.getBpdgrp().getRec().getDbchcod());
			    
			    //Platform.disable($bpdgrp\\rec\\bchcod);
			  }
			  log.info("{}","bchocd="+this.getBpdgrp().getRec().getBchcod()+",dbchocd="+this.getBpdgrp().getRec().getDbchcod()+",ibchcod="+this.getBpdgrp().getRec().getIbchcod());
			}


			return true;
        }













}