package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Bptrpn0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 偿还出口押汇申请
*/
@Transaction(vo= Bptrpn0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptrpn0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bptrpn0.class);

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Bptrpn0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bptrpn0.@0001.script
        */
        @Rule(target="selp.sure",order=0)
        public boolean ruleSelpSureN0(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bpdgrp","bptrpn");

			return true;
        }

        /**
        *   source:bptrpn0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT bpd.inr trsinr,bpd.stlref ref,bpd.fftcur cur,bpd.fftamt amt,bpd.opndat dat,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bpd,pts,adr,pta WHERE bpd.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'bpd' AND pts.objinr = bpd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT rec.inr trsinr,stlref ref,fftcur cur,fftamt amt,rec.credat dat,substr(s.adrblk,0,35) aplnam  "
			  +"FROM bpd rec,pts s WHERE rec.stlref IS NOT null AND (rec.flg IS NULL OR rec.flg <>'3') AND  s.objtyp = 'bpd' AND s.rol = 'apl' AND s.objinr=rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:bptrpn0.@0005.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("bpdgrp","bptrpn");

			return true;
        }

        /**
        *   source:bptrpn0.@0006.script
        */
        @Rule(target="selp.newapply",order=100)
        public boolean ruleSelpNewapplyN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBpdgrp());
			

			return true;
        }



        /**
        *   source:bptrpn0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selbptrpn"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT bpd.inr trsinr,bpd.stlref ref,bpd.fftcur cur,bpd.fftamt amt,bpd.opndat dat,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bpd,pts,adr,pta WHERE bpd.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'bpd' AND pts.objinr = bpd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT rec.inr trsinr,stlref ref,fftcur cur,fftamt amt,rec.credat dat,substr(s.adrblk,0,35) aplnam  "
			  +"FROM bpd rec,pts s WHERE rec.stlref IS NOT null AND (rec.flg IS NULL OR rec.flg <>'3') AND  s.objtyp = 'bpd' AND s.rol = 'apl' AND s.objinr=rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}