package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BpttrsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Bptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 转议付申请
*/
@Transaction(vo= BpttrsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bpttrs extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bpttrs.class);

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Bptmod bptmod;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Ledgrp ledgrp;


		public Bpttrs()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBptmod().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBptmod().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("EF"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bpttrs.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bpttrs.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bpttrs.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bpttrs.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bpttrs.this.getBpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:bpttrs.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getBpdgrp()))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getBpdgrp().getRec());
			  String objinr = this.getBpdgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getBpdgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getBpdgrp().getApl().getPts(),objinr);
			}
			else
			{
			  this.getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getRec());
			  String objinr = this.getBpdgrp().getRec().getInr();
			  String objtyp = "bpd";
			  this.getBpdgrp().getApl().savpts(objinr,objtyp);
			  this.getBpdgrp().getIsb().savpts(objinr,objtyp);
			  this.getBpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getBpdgrp().getDap().getPts().setObjinr(objinr);
			  this.getBpdgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getDap().getPts());
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:bpttrs.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","bpttrs",stream,false );

			return true;
        }



        /**
        *   source:bpttrs.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",bchcod);
			MdaUtils.setValues(this.getBpdgrp().getRec(),"paytyp",MdaUtils.getCodetable("acctyp"));
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			else
			{
			  this.getBpdgrp().getRec().setPaytyp("2");
			  this.getBpdgrp().getRec().setCredat(MdaUtils.today());
			  this.getBpdgrp().getRec().setInvcur("USD");
			  this.getBpdgrp().getRec().setFftcur("USD");
			}

			return true;
        }













}