package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BrtdckVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Brtmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Brtp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Brdgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证项下到单通知
*/
@Transaction(vo= BrtdckVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brtdck extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Brtdck.class);

		@BDGetter
		private Brdgrp brdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Brtmod brtmod;

		@BDGetter
		private Brtp brtp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;

		@BDGetter
		private Btnmod btnmod;


		public Brtdck()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrtmod().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtmod().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setApdgrpHolder(()->this.getApdgrp());
           this.getBrtp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBrtp().setPrefixdfHolder(new FieldConstantHolder<>("DF"));
           this.getBrtp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Brtdck.this.getBrdgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Brtdck.this.getBrdgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.bchcod");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.advcur");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.inr");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setInr(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.ownref");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.ptyinr");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtdck.this.getFieldPath("brdgrp.rec.stlref");}
 				public void setValue(String arg){Brtdck.this.getBrdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Brtdck.this.getBrdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBrdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:brtdck.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:brtdck.@0008.script
        */
        @Rule(target="brtp.pdfbrd",order=100)
        public boolean ruleBrtpPdfbrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1.查brdc获取交易的合同号
			
			ctx.getDaoSession().dbRead(this.getBrdgrp().getBrdc(),new Argument<String>("pntinr",this.getBrdgrp().getRec().getInr()));
			if(MdaUtils.isEmpty(this.getBrdgrp().getBrdc().getHticontract()))
			{
			  ctx.setMessage("提示","该笔业务无电子保函文本！");
			  return false;
			}
			String hticontract = this.getBrdgrp().getBrdc().getHticontract();
			String[] arr=hticontract.split(",");
			String pdfFile="";
			for(int i=0;i<arr.length;i++)
			{
			  //pdfFile = Platform.catPath(Platform.getRootPath(),"/data/szdzbh/pdf/"+$brdgrp\\rec\\inr.getValue().substring(0,5)+"/"+$brdgrp\\rec\\inr.getValue()+".pdf");
			  pdfFile = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/brtdck/pdf/"+this.getBrdgrp().getRec().getInr()+"/"+arr[i]+".pdf");
			  log.debug("{}","pdfFile======================================================="+pdfFile);
			  //判断文件是否存在，不存在则下载到服务器
			  if(!MdaUtils.fileExists(pdfFile))
			  {
			    //调用接口下载
			    Object rtnVal = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","msg3cfca","msg3cfca",new Object[]{ this.getBrdgrp().getRec().getInr(),arr[i]});
			    if (rtnVal == null)
			    {
			      ctx.setMessage("提示","文件下载异常，请稍后重试！");
			      return false;
			    }
			    Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			    String errcod = (String)retMsg.get("errorCode");//000000
			    if(!"000000".equals(errcod))
			    {
			      ctx.setMessage("提示","接口调用异常，请稍后重试！");
			      return false;
			    }
			  }
			  MdaUtils.streamClear(this.getBrtp().getPdfbrd());
			  IStream stream=this.getBrtp().getPdfbrd();
			  log.info("{}","pdffile===="+pdfFile);
			  MdaUtils.streamLoad(stream,pdfFile);
			  stream.setType("pdf");
			  String pdfnam = org.apache.commons.io.FilenameUtils.getName(pdfFile);
			  stream.setName(pdfnam);
			}

			return true;
        }



        /**
        *   source:brtdck.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getBrtp().getBrtp05());

			/*
			  需求编号：R22081176
			  投产日期：20230525
			  修改人：w42375
			  描述：1.判断交易，如果交易是线上交易，显示按钮。
			  */
			if("Y".equals(this.getBrdgrp().getRec().getAdvtyp()))
			{
			  //显示按钮
			  
			}
			else
			{
			  //隐藏按钮
			  
			}


			return true;
        }

        /**
        *   source:brtdck.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:brtdck.@0004.script
        */
        @Init(order=110)
        public boolean	init110(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  需求编号：R22081176
			  投产日期：20230525
			  修改人：w42375
			  描述：1.判断交易，如果交易是brtdck并且是线上交易，才执行此逻辑。
			  2.增加按钮：承付/拒付通知书
			  3.判断是否已经下载影像
			  4.如果没有下载则下载影像，并且增加水印.
			
			  Platform.dbRead($trnmod\\itfmod\\imgmod\\img,new Argument<String>("inr",$trnmod\\smh\\creusr.getValue()));
			  Platform.dbRead($brdgrp\\rec,new Argument<String>("stlref",$trnmod\\itfmod\\imgmod\\img\\ownref.getValue()));
			  String imgref = $trnmod\\itfmod\\imgmod\\img\\imgref.getValue();
			  String objtyp = $trnmod\\itfmod\\imgmod\\img\\objtyp.getValue();
			  log.debug("objtyp==================================================================="+objtyp);
			  String ownref = $trnmod\\itfmod\\imgmod\\img\\ownref.getValue();
			  log.debug("ownref==================================================================="+ownref);
			  Date date = $trnmod\\itfmod\\imgmod\\img\\credat.getValue();
			  String trncod = $trnmod\\itfmod\\imgmod\\img\\inifrm.getValue();
			  log.debug("trncod==================================================================="+trncod);
			  String yngyjg = $trnmod\\itfmod\\imgmod\\img\\bchcod.getValue();
			  log.debug("yngyjg==================================================================="+yngyjg);
			  String nam = $trnmod\\itfmod\\imgmod\\img\\lgnnam.getValue();
			  log.debug("nam==================================================================="+nam);
			  String transName = Platform.getTransName();
			  String advtyp = $brdgrp\\rec\\advtyp.getValue();
			  //如果交易是brtdck并且是线上交易
			  log.debug("transName==================================================================="+transName);
			  log.debug("advtyp==================================================================="+advtyp);
			  log.debug("imgref==================================================================="+$trnmod\\itfmod\\imgmod\\img\\imgref.getValue());
			  if(!Platform.isEmpty(transName) && "brtdck".equals(transName.toLowerCase()) && !Platform.isEmpty($trnmod\\itfmod\\imgmod\\img\\imgref.getValue()))
			  {
			  String fileName = Platform.catPath(Platform.getRootPath(),"/cfg/img.properties");
			  String appId = Platform.getPropertyValue(fileName,"appId");
			  String netId = Platform.getPropertyValue(fileName,"netId");
			  String gdate = Platform.format(date, "yyyyMMdd");
			  String operId = nam;
			  //2.显示按钮
			  Platform.enable($brtp\\pdfbrd);
			  //3.判断是否已经下载影像
			  log.debug("stlref111==================================================================="+$brdgrp\\rec\\stlref.getValue());
			  //Platform.dbRead($trnmod\\itfmod\\imgmod\\tblbil,new Argument<String>("djcod",ownref));
			  Platform.dbReadset($brtp\\tbllst,new Argument<String>("djcod",ownref));
			  log.debug("tbllst==================================================================="+$brtp\\tbllst.fullSize());
			  log.debug("stlref222==================================================================="+ownref);
			  Platform.errorCode();
			  //为空的话说明还没有下载影像
			  if($brtp\\tbllst.fullSize()==0)
			  {
			  //4.下载影像
			  log.debug("开始下载影像--------------------------------------------------------------------------------------------");
			  String cls="com.brilliance.eibs.main.Client";
			  Object resMsg = Platform.invoke(cls,"scall","download","download", new Object[]{netId,appId,gdate,operId,imgref,trncod,ownref,yngyjg});
			  log.debug("下载影像结束--------------------------------------------------------------------------------------------");
			  if((Boolean)Platform.invoke(resMsg,"isSuccess"))
			  {
			  //5.给影像pdf加水印
			  log.debug("开始加水印--------------------------------------------------------------------------------------------");
			  $this.addWater();
			  log.debug("加水印结束--------------------------------------------------------------------------------------------");
			  }
			  }
			  }
			  else
			  {
			  //隐藏按钮
			  Platform.invisible($brtp\\pdfbrd);
			  }*/
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			String a = MdaUtils.getPropertyValue(filepath,"brtdck."+0);
			String b = MdaUtils.getPropertyValue(filepath,"brtdck.0.img");
			log.debug("{}","filepath=================================================="+filepath);
			log.debug("{}","message1=================================================="+a);
			log.debug("{}","message2=================================================="+b);

			return true;
        }


        /**
        *   source:brtdck.@0006.script
        */
        public void addWater()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//String fpath=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"temp");
			//查tblbil表获取文件名。
			log.debug("{}","djcod====================================================="+this.getBrdgrp().getRec().getStlref());
			ctx.getDaoSession().dbReadset(this.getBrtp().getTbllst(),new Argument<String>("djcod",this.getBrdgrp().getRec().getStlref()));
			ctx.getErrorCode();
			//循环lst，获取文件路径和文件名。
			Map<String,String>  dmap = new HashMap<String,String>();
			for(int i=0;i<this.getBrtp().getTbllst().fullSize();i++)
			{
			  String fileName = this.getBrtp().getTbllst().getElement(i).getFilpth();
			  int index = fileName.lastIndexOf("/");
			  String pdfPath = fileName.substring(0,index);
			  String pdfName = fileName.substring(index+1);
			  //如果文件存在，并且是pdf\\PDF
			  if(MdaUtils.fileExists(MdaUtils.catPath(pdfPath,pdfName)) && (pdfName.endsWith(".pdf") || pdfName.endsWith(".PDF")))
			  {
			    log.info("{}","to show the file..." );
			    dmap.put(this.getBrtp().getTbllst().getElement(i).getFilpth(),this.getBrtp().getTbllst().getElement(i).getFilpth());
			  }
			}
			if(dmap.size()>0)
			{
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","PDFAddWatermark",dmap,"copy",300,600,60,0.2);
			}
		}














}