package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BrtfrdVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Brtmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Brtp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Brdgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证项下到单杂项申请
*/
@Transaction(vo= BrtfrdVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brtfrd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Brtfrd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Brdgrp brdgrp;

		@BDGetter
		private Brtmod brtmod;

		@BDGetter
		private Brtp brtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Brtfrd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrtmod().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtmod().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setApdgrpHolder(()->this.getApdgrp());
           this.getBrtp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBrtp().setPrefixdfHolder(new FieldConstantHolder<>("DF"));
           this.getBrtp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getMtabut().setRecHolder(()->this.getBrdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Brtfrd.this.getFieldPath("brdgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Brtfrd.this.getBrdgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Brtfrd.this.getBrdgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("brdgrp.rec.advcur");}
 				public void setValue(String arg){Brtfrd.this.getBrdgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Brtfrd.this.getBrdgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Brtfrd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Brtfrd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Brtfrd.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Brtfrd.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("brdgrp.rec.ownref");}
 				public void setValue(String arg){Brtfrd.this.getBrdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Brtfrd.this.getBrdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("brdgrp.rec.ptyinr");}
 				public void setValue(String arg){Brtfrd.this.getBrdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Brtfrd.this.getBrdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtfrd.this.getFieldPath("brdgrp.rec.stlref");}
 				public void setValue(String arg){Brtfrd.this.getBrdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Brtfrd.this.getBrdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:brtfrd.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBrdgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("brd");
			this.getAfdgrp().getRec().setObjinr(this.getBrdgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("1");
			this.getAfdgrp().getRec().setOprtyp("0");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:brtfrd.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","brtfrd",stream,false );

			return true;
        }

        /**
        *   source:brtfrd.@0004.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:brtfrd.@0006.script
        */
        @Rule(target="brtp.return",order=100)
        public boolean ruleBrtpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:brtfrd.@0007.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "进口信用证项下到单杂项申请";
			String tempfiles = "A:brtfrd";
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }



        /**
        *   source:brtfrd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			// List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			// Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			
			
			
			
			
			
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			IModule brd = (IModule)ctx.restoreData("com.brilliance.brtfrd.ref");
			if(!MdaUtils.isEmpty(brd))
			  this.getBrdgrp().getRec().copyValue(brd);
			// if(!Platform.isEmpty(bchcod))
			//   $afdgrp\\rec\\bchcod.setValue((bchcod.get(0)).getValue());
			this.getBrdgrp().getDap().initDap("brd");
			this.getBrdgrp().getApl().copyValues(this.getBrdgrp().getDap());
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument<String>("objinr",this.getBrdgrp().getRec().getInr()),new Argument<String>("objtyp","brd"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument<String>("objinr",this.getBrdgrp().getRec().getInr()),new Argument<String>("objtyp","brd"),new Argument<String>("rol","ben"));
			//$brdgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			return true;
        }

        /**
        *   source:brtfrd.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getDbchcod()))
			      this.getAfdgrp().getRec().setBchcod(this.getBrdgrp().getRec().getDbchcod());
			    else
			      this.getAfdgrp().getRec().setBchcod(this.getBrdgrp().getRec().getBchcod());
			    
			  }
			  log.info("{}","bchcod="+this.getBrdgrp().getRec().getBchcod());
			}


			return true;
        }















}