package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BrtsndVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Brtmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Brtp;
import com.ceb.gjjs.mda.manager.module.Wghmod;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Brdgrp;
import com.ceb.gjjs.mda.manager.module.Radgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证承兑/付款/拒付
*/
@Transaction(vo= BrtsndVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brtsnd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Brtsnd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Brdgrp brdgrp;

		@BDGetter
		private Brtmod brtmod;

		@BDGetter
		private Brtp brtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Radgrp radgrp;

		@BDGetter
		private Wghmod wghmod;


		public Brtsnd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBrtmod().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtmod().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtp().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setApdgrpHolder(()->this.getApdgrp());
           this.getBrtp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBrtp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBrtp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getMtabut().setRecHolder(()->this.getBrdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.advamt");}
 				public void setValue(BigDecimal arg){Brtsnd.this.getBrdgrp().getRec().setAdvamt(arg);}
 				public BigDecimal getValue(){return Brtsnd.this.getBrdgrp().getRec().getAdvamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.advcur");}
 				public void setValue(String arg){Brtsnd.this.getBrdgrp().getRec().setAdvcur(arg);}
 				public String getValue(){return Brtsnd.this.getBrdgrp().getRec().getAdvcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Brtsnd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Brtsnd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.inr");}
 				public void setValue(String arg){Brtsnd.this.getBrdgrp().getRec().setInr(arg);}
 				public String getValue(){return Brtsnd.this.getBrdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.ownref");}
 				public void setValue(String arg){Brtsnd.this.getBrdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Brtsnd.this.getBrdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.ptyinr");}
 				public void setValue(String arg){Brtsnd.this.getBrdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Brtsnd.this.getBrdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Brtsnd.this.getFieldPath("brdgrp.rec.stlref");}
 				public void setValue(String arg){Brtsnd.this.getBrdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Brtsnd.this.getBrdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:brtsnd.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","message--贸易融资综合授信协议编号：" + this.getTrdgrp().getRec().getFtfinancing());
			if(!(ctx.checkAll(this.getBrdgrp()) && ctx.checkAll(this.getAfdgrp())))
			{
			  return false;
			}
			//押汇校验
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			{
			  return false;
			}
			//代付校验
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			{
			  return false;
			}
			//售汇校验
			if("BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			{
			  if(!ctx.checkAll(this.getBrtp().getFpdgrp()))
			  {
			    return false;
			  }
			}
			//网银购汇校验
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getWyghedno())&&"2".equals(this.getBrdgrp().getRec().getZjly()))
			{
			  ctx.setMessage("E9999","资金来源填写有误，请重新勾选");
			  this.getBrdgrp().getRec().setZjly(NULLSTR);
			  
			  return false;
			}
			BigDecimal adv=MdaUtils.parseDecimal(MdaUtils.format(this.getBrdgrp().getRec().getAdvamt(),"#0.00"));
			this.getBrdgrp().getRec().setAdvamt(adv);

			BigDecimal pay=MdaUtils.parseDecimal(MdaUtils.format(this.getApdgrp().getRec().getPayamt(),"#0.00"));
			this.getApdgrp().getRec().setPayamt(pay);

			this.dealpdf();

			log.info("{}","sav200开始================" );
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("brd");
			this.getAfdgrp().getRec().setObjinr(this.getBrdgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("1");
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()))
			{
			  String trdinr = this.getTrdgrp().getRec().getInr();
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")||!MdaUtils.isEmpty(trdinr))
			  {
			    ctx.getDaoSession().dbUpdate(this.getTrdgrp().getRec());
			  }
			  else
			  {
			    this.getTrdgrp().getRec().setInr(Platform.sdbCounter("trd"));
			    this.getTrdgrp().getRec().setAdvdat(this.getBrdgrp().getRec().getAdvdat());
			    this.getTrdgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());
			    this.getTrdgrp().getRec().setConnum(this.getLidgrp().getRec().getConno());
			    this.getTrdgrp().getRec().setCredat(this.getAfdgrp().getRec().getCredat());
			    this.getTrdgrp().getRec().setEtyinr("00000000");
			    this.getTrdgrp().getRec().setPnttyp("brd");
			    this.getTrdgrp().getRec().setPntinr(this.getBrdgrp().getRec().getInr());
			    this.getTrdgrp().getRec().setFintyp("1");
			    this.getTrdgrp().getRec().setPntref(this.getBrdgrp().getRec().getOwnref());
			    this.getTrdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			    ctx.getDaoSession().dbInsert(this.getTrdgrp().getRec());
			  }
			}
			else
			  log.info("{}","没有选择押汇");
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()))
			{
			  String apdinr = this.getApdgrp().getRec().getInr();
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")||!MdaUtils.isEmpty(apdinr))
			  {
			    ctx.getDaoSession().dbUpdate(this.getApdgrp().getRec());
			  }
			  else
			  {
			    this.getApdgrp().getRec().setInr(Platform.sdbCounter("apd"));
			    this.getApdgrp().getRec().setPnttyp("brd");
			    this.getApdgrp().getRec().setPntinr(this.getBrdgrp().getRec().getInr());
			    this.getApdgrp().getRec().setAdvdat(this.getBrdgrp().getRec().getAdvdat());
			    this.getApdgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());
			    this.getApdgrp().getRec().setConnum(this.getLidgrp().getRec().getConno());
			    this.getApdgrp().getRec().setCredat(this.getAfdgrp().getRec().getCredat());
			    this.getApdgrp().getRec().setEtyinr("00000000");
			    this.getApdgrp().getRec().setAmt(this.getBrdgrp().getRec().getAdvamt());
			    this.getApdgrp().getRec().setCur(this.getBrdgrp().getRec().getAdvcur());
			    this.getApdgrp().getRec().setPtyinr(this.getBrdgrp().getRec().getPtyinr());
			    this.getApdgrp().getRec().setFintyp("1");
			    this.getApdgrp().getRec().setPntref(this.getBrdgrp().getRec().getOwnref());
			    this.getApdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			    ctx.getDaoSession().dbInsert(this.getApdgrp().getRec());
			  }
			}
			else
			  log.info("{}","没有选择同业代付");

			ctx.getDaoSession().dbUpdate(this.getBrdgrp().getRec());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());

			//购汇数据入库
			if("BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B") && !MdaUtils.isEmpty(this.getBrtp().getFpdgrp().getRec().getInr()))
			    ctx.getDaoSession().dbUpdate(this.getBrtp().getFpdgrp().getRec());
			  else
			  {
			    this.getBrtp().getFpdgrp().getRec().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			    this.getBrtp().getFpdgrp().getRec().setObjfrm(ctx.getTransName());
			    this.getBrtp().getFpdgrp().getRec().setObjinr(this.getBrdgrp().getRec().getInr());
			    this.getBrtp().getFpdgrp().getRec().setInr(Platform.sdbCounter("fpd"));
			    ctx.getDaoSession().dbInsert(this.getBrtp().getFpdgrp().getRec());
			  }
			}
			log.info("{}","message--贸易融资综合授信协议编号：" + this.getTrdgrp().getRec().getFtfinancing());
			log.info("{}", "sav200入库结束================" );
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getBrtp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			//Platform.saveDisplay($brtp\\nbrtp01,filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:brtsnd.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			//if("docadv".equals(docflg))
			//  $\\sysmod.generatorPdf("","brtsnd0",stream,false );
			if("disadv".equals(this.getBrdgrp().getRec().getDocflg()))
			  ctx.absGet(Sysmod.class).generatorPdf("","brtsnd1",stream,false );
			else
			  ctx.absGet(Sysmod.class).generatorPdf("","brtsnd0",stream,false );

			return true;
        }

        /**
        *   source:brtsnd.@0005.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeOprTyp();
			if(!"BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()))
			{
			  String steps = "0:承兑/付款/拒付";
			  
			  
			  

			  this.getBrtp().getStpmod().setPages(steps);
			  this.getBrtp().getStpmod().calcSteps();
			  this.getBrtp().getStpmod().setStepBtnSta();

			  //if(Platform.isEmpty($brtp\\fpdgrp\\rec\\inr))
			  //Platform.clear($brtp\\fpdgrp\\rec);
			  //Platform.setModified($brtp\\fpdgrp\\rec);
			}

			return true;
        }

        /**
        *   source:brtsnd.@0008.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:brtsnd.@0012.script
        */
        @Rule(target="brtp.fxbut",order=100)
        public boolean ruleBrtpFxbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrtp().setActchsflg( "fx");
			this.getBrtp().popupActchs();

			return true;
        }

        /**
        *   source:brtsnd.@0013.script
        */
        @Rule(target="brdgrp.rec.fxamt",order=100)
        public boolean ruleBrdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBrdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBrdgrp().getRec().setFxamt(amt);
			


			return true;
        }

        /**
        *   source:brtsnd.@0014.script
        */
        @Rule(target="brdgrp.rec.othamt",order=100)
        public boolean ruleBrdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBrdgrp().getRec().getOthamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBrdgrp().getRec().setOthamt(amt);
			


			return true;
        }

        /**
        *   source:brtsnd.@0015.script
        */
        @Rule(target="brdgrp.rec.puramt",order=100)
        public boolean ruleBrdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getBrdgrp().getRec().getPuramt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getBrdgrp().getRec().setPuramt(amt);

			if("BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			{
			  this.getBrtp().getFpdgrp().setCur(this.getBrtp().getCur1());
			  this.getBrtp().getFpdgrp().setAmt(this.getBrdgrp().getRec().getPuramt());
			  if(!TRUE.equals(this.getBrtp().getFpdgrp().getRec().getCnnsel()))
			  {
			    this.getBrtp().getFpdgrp().getRec().setOutcur(this.getBrtp().getCur1());
			    this.getBrtp().getFpdgrp().getRec().setOutamt(this.getBrdgrp().getRec().getPuramt());
			    
			    
			    
			  }
			  else
			    ctx.postRule(this,"brtp.fpdgrp.rec.cnnsel");

			  
			  
			}
			


			return true;
        }

        /**
        *   source:brtsnd.@0016.script
        */
        @Rule(target="brtp.othbut",order=100)
        public boolean ruleBrtpOthbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrtp().setActchsflg( "oth");
			this.getBrtp().popupActchs();

			return true;
        }

        /**
        *   source:brtsnd.@0017.script
        */
        @Rule(target="brtp.purbut",order=100)
        public boolean ruleBrtpPurbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrtp().setActchsflg( "pur");
			this.getBrtp().popupActchs();

			return true;
        }

        /**
        *   source:brtsnd.@0022.script
        */
        @Rule(target="brtp.actsurel",order=100)
        public boolean ruleBrtpActsurelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getBrtp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000058"),MdaUtils.getI18NString("brtsnd","CT000059"));
			  return true;
			}
			if("fx".equals(this.getBrtp().getActchsflg()))
			{
			  this.getBrdgrp().getRec().setFxact(this.getBrtp().getActlst().getElement(index).getAct());
			  
			}
			else if("pur".equals(this.getBrtp().getActchsflg()))
			{
			  this.getBrdgrp().getRec().setPuract(this.getBrtp().getActlst().getElement(index).getAct());
			  
			  ctx.postRule(this,"brdgrp.rec.puract");
			}
			else if("oth".equals(this.getBrtp().getActchsflg()))
			{
			  this.getBrdgrp().getRec().setOthact(this.getBrtp().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0023.script
        */
        @Rule(target="brtp.actcancel",order=100)
        public boolean ruleBrtpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:brtsnd.@0027.script
        */
        @Rule(target="brtp.trdgrp.rec.arrrar",order=100)
        public boolean ruleBrtpTrdgrpRecArrrarN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0028.script
        */
        @Rule(target="brtp.trdgrp.rec.caltyp",order=100)
        public boolean ruleBrtpTrdgrpRecCaltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			}
			else if("3".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			
			


			return true;
        }

        /**
        *   source:brtsnd.@0029.script
        */
        @Rule(target="brtp.trdgrp.rec.ocaltp",order=100)
        public boolean ruleBrtpTrdgrpRecOcaltpN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getTrdgrp().getRec().getOcaltp()))
			{
			  
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0030.script
        */
        @Rule(target="brtp.pdftrd",order=100)
        public boolean ruleBrtpPdftrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal adv=MdaUtils.parseDecimal(MdaUtils.format(this.getBrdgrp().getRec().getAdvamt(),"#0.00"));
			this.getBrdgrp().getRec().setAdvamt(adv);
			

			BigDecimal pay=MdaUtils.parseDecimal(MdaUtils.format(this.getApdgrp().getRec().getPayamt(),"#0.00"));
			this.getApdgrp().getRec().setPayamt(pay);
			

			this.dealpdf();

			this.getBrtp().getPdfviw().callPDFComponent("","brtsndfh","押汇申请",1);

			return true;
        }

        /**
        *   source:brtsnd.@0036.script
        */
        @Rule(target="brtp.pdfdfd",order=100)
        public boolean ruleBrtpPdfdfdN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal adv=MdaUtils.parseDecimal(MdaUtils.format(this.getBrdgrp().getRec().getAdvamt(),"#0.00"));
			this.getBrdgrp().getRec().setAdvamt(adv);
			

			BigDecimal pay=MdaUtils.parseDecimal(MdaUtils.format(this.getApdgrp().getRec().getPayamt(),"#0.00"));
			this.getApdgrp().getRec().setPayamt(pay);
			

			this.getBrtp().getPdfviw().callPDFComponent("","brtsnddf","同业代付申请",1);

			return true;
        }

        /**
        *   source:brtsnd.@0043.script
        */
        @Rule(target="brtp.apdgrp.rec.lxchfs",order=100)
        public boolean ruleBrtpApdgrpRecLxchfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tmp1 = this.getApdgrp().getRec().getLxchfs();
			this.getBrtp().setJxfs(MdaUtils.getCodetableLabel("jxfs",tmp1));
			

			return true;
        }

        /**
        *   source:brtsnd.@0047.script
        */
        @Rule(target="brtp.trdgrp.rec.trodat",order=100)
        public boolean ruleBrtpTrdgrpRecTrodatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getDfflg()))
			{
			  this.getApdgrp().getRec().setMatdat(this.getTrdgrp().getRec().getTrodat());
			  
			}

			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat())&&!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			{
			  //SimpleDateFormat format = new java.text.SimpleDateFormat("yyyy-MM-dd");
			  Date date1 = this.getTrdgrp().getRec().getOpndat();
			  Date date2 = this.getTrdgrp().getRec().getTrodat();

			  long lday = (date2.getTime()-date1.getTime())/(24*60*60*1000);
			  this.getTrdgrp().getRec().setSubday(""+(int)lday);
			}
			else
			{
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			}
			

			//倒序输入时报错，未能重现，因PDF展示需要，注释此段
			/*if(!Platform.isEmpty($trdgrp\\rec\\opndat)&&!Platform.isEmpty($brtp\\subday))
			  {
			  Platform.clear($trdgrp\\rec\\opndat);
			  Platform.clear($brtp\\subday);
			
			  Platform.setModified($trdgrp\\rec\\opndat);
			  Platform.setModified($brtp\\subday);
			  }*/

			return true;
        }

        /**
        *   source:brtsnd.@0051.script
        */
        @Rule(target="brtp.viwusdoc",order=100)
        public boolean ruleBrtpViwusdocN100(){
            IContext ctx = MdaEnv.getContext();
            
			String filepath="/pdf/";
			log.info("{}","filepath ="+filepath);
			String filename=filepath+ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getPdffilnam();
			log.info("{}","filename ="+filename);
			if(!MdaUtils.isEmpty(filepath))
			{
			  this.getBrtp().getPdfviw().showPDF(filepath,"到单面函",0);
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000144"),MdaUtils.getI18NString("brtsnd","CT000145")+this.getBrdgrp().getRec().getStlref()+MdaUtils.getI18NString("brtsnd","CT000146"));
			}

			return true;
        }

        /**
        *   source:brtsnd.@0061.script
        */
        @Rule(target="brdgrp.rec.purflg",order=100)
        public boolean ruleBrdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			StringBuffer stepsB = new StringBuffer();
			String steps= "";
			steps = steps+stepsB.append("0:承兑/付款/拒付");

			String val=this.getAfdgrp().getRec().getOprtyp();
			if("BRTSET".equals(val))
			{
			  if(TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			  {
			    steps =steps+stepsB.append(";1:购汇申请");
			    
			    this.getBrtp().getFpdgrp().setMessage();
			    //初始化售汇界面
			    /*$brtp\\fpdgrp\\rec\\credat.setValue(Platform.today());
			      if(!Platform.isEmpty($brtp\\fpdgrp\\rec\\credat))
			      {
			      Platform.disable($brtp\\fpdgrp\\rec\\credat);
			      Platform.setModified($brtp\\fpdgrp\\rec\\credat);
			      }
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\givnam))
			      $brtp\\fpdgrp\\rec\\givnam.setValue($sysmod\\pty\\nam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\oprnam))
			      $brtp\\fpdgrp\\rec\\oprnam.setValue($sysmod\\usr\\oprnam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\tel))
			      $brtp\\fpdgrp\\rec\\tel.setValue($sysmod\\usr\\tel.getValue());
			
			      Platform.setModified($brtp\\fpdgrp\\rec\\givnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\oprnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\tel);
			      */
			  }
			  else
			  {
			    
			  }
			}
			
			
			this.getBrtp().getStpmod().setPages(steps);
			this.getBrtp().getStpmod().calcSteps();
			this.getBrtp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:brtsnd.@0062.script
        */
        @Rule(target="brtp.stpmod.gostep",order=10)
        public boolean ruleBrtpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            

			int curIdx=this.getBrtp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getBrtp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000190"),MdaUtils.getI18NString("brtsnd","CT000191"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!(ctx.checkAll(this.getBrdgrp()) && ctx.checkAll(this.getAfdgrp())))
			    {
			      return false;
			    }
			    //押汇校验
			    if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			    {
			      return false;
			    }
			    //代付校验
			    if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    this.getBrtp().getFpdgrp().setCur(this.getBrtp().getCur1());
			    this.getBrtp().getFpdgrp().setAmt(this.getBrdgrp().getRec().getPuramt());
			    
			    
			    this.getBrtp().getFpdgrp().setMessage();
			    return true;
			    /*
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\givnam))
			      $brtp\\fpdgrp\\rec\\givnam.setValue($sysmod\\pty\\nam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\oprnam))
			      $brtp\\fpdgrp\\rec\\oprnam.setValue($sysmod\\usr\\oprnam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\tel))
			      $brtp\\fpdgrp\\rec\\tel.setValue($sysmod\\usr\\tel.getValue());
			
			      Platform.setModified($brtp\\fpdgrp\\rec\\givnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\oprnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\tel);
			
			      if(!TRUE.equals($brtp\\fpdgrp\\rec\\cnnsel.getValue()))
			      {
			      $brtp\\fpdgrp\\rec\\outsel.setValue("X");
			      Platform.setModified($brtp\\fpdgrp\\rec\\outsel);
			
			      Platform.disable($brtp\\fpdgrp\\rec\\outamt);
			      Platform.setModified($brtp\\fpdgrp\\rec\\outamt);
			      }
			      Platform.disable($brtp\\fpdgrp\\rec\\outcno);
			      Platform.setModified($brtp\\fpdgrp\\rec\\outcno);
			
			      $brtp\\fpdgrp\\rec\\credat.setValue(Platform.today());
			      if(!Platform.isEmpty($brtp\\fpdgrp\\rec\\credat))
			      {
			      Platform.disable($brtp\\fpdgrp\\rec\\credat);
			      Platform.setModified($brtp\\fpdgrp\\rec\\credat);
			      }
			
			      if("5".equals($brtp\\fpdgrp\\rec\\shbody.getValue()))
			      Platform.enable($brtp\\fpdgrp\\rec\\othcno);
			      else
			      Platform.disable($brtp\\fpdgrp\\rec\\othcno);
			      Platform.setModified($brtp\\fpdgrp\\rec\\othcno);
			      Platform.setModified($brtp\\fpdgrp\\rec\\shbody);
			      */
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getBrtp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","gostep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:brtsnd.@0063.script
        */
        @Rule(target="brtp.stpmod.next",order=10)
        public boolean ruleBrtpStpmodNextN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getBrtp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getBrtp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000202"),MdaUtils.getI18NString("brtsnd","CT000203"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!(ctx.checkAll(this.getBrdgrp()) && ctx.checkAll(this.getAfdgrp())))
			    {
			      return false;
			    }
			    //押汇校验
			    if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()) && !ctx.checkAll(this.getTrdgrp()))
			    {
			      return false;
			    }
			    //代付校验
			    if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()) && !ctx.checkAll(this.getApdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    this.getBrtp().getFpdgrp().setCur(this.getBrtp().getCur1());
			    this.getBrtp().getFpdgrp().setAmt(this.getBrdgrp().getRec().getPuramt());
			    
			    
			    this.getBrtp().getFpdgrp().setMessage();
			    return true;
			    /*
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\givnam))
			      $brtp\\fpdgrp\\rec\\givnam.setValue($sysmod\\pty\\nam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\oprnam))
			      $brtp\\fpdgrp\\rec\\oprnam.setValue($sysmod\\usr\\oprnam.getValue());
			
			      if(Platform.isEmpty($brtp\\fpdgrp\\rec\\tel))
			      $brtp\\fpdgrp\\rec\\tel.setValue($sysmod\\usr\\tel.getValue());
			
			      Platform.setModified($brtp\\fpdgrp\\rec\\givnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\oprnam);
			      Platform.setModified($brtp\\fpdgrp\\rec\\tel);
			
			      if(!TRUE.equals($brtp\\fpdgrp\\rec\\cnnsel.getValue()))
			      {
			      $brtp\\fpdgrp\\rec\\outsel.setValue("X");
			      Platform.setModified($brtp\\fpdgrp\\rec\\outsel);
			      }
			
			      $brtp\\fpdgrp\\rec\\credat.setValue(Platform.today());
			      if(!Platform.isEmpty($brtp\\fpdgrp\\rec\\credat))
			      {
			      Platform.disable($brtp\\fpdgrp\\rec\\credat);
			      Platform.setModified($brtp\\fpdgrp\\rec\\credat);
			      }
			
			      if("5".equals($brtp\\fpdgrp\\rec\\shbody.getValue()))
			      Platform.enable($brtp\\fpdgrp\\rec\\othcno);
			      else
			      Platform.disable($brtp\\fpdgrp\\rec\\othcno);
			      Platform.setModified($brtp\\fpdgrp\\rec\\othcno);
			      Platform.setModified($brtp\\fpdgrp\\rec\\shbody);
			      */
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getBrtp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","gostep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:brtsnd.@0064.script
        */
        @Rule(target="brtp.stpmod.last",order=10)
        public boolean ruleBrtpStpmodLastN10(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getBrtp().getFpdgrp()))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:brtsnd.@0065.script
        */
        @Rule(target="brtp.fpdgrp.fpdpdf",order=100)
        public boolean ruleBrtpFpdgrpFpdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt=MdaUtils.parseDecimal(MdaUtils.format(this.getBrtp().getFpdgrp().getRec().getOutamt(),"#0.00"));
			this.getBrtp().getFpdgrp().getRec().setOutamt(amt);
			
			this.getBrtp().getPdfviw().callPDFComponent("","fptapn","即期售汇申请书",1);

			return true;
        }

        /**
        *   source:brtsnd.@0066.script
        */
        @Rule(target="mtabut.sav",order=220)
        public boolean ruleMtabutSavN220(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 0;
			String labels = "";
			String tempfiles = "";

			if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getFhflg()))
			{
			  if(cnt!=0)
			  {
			    labels += ",押汇申请书";
			    tempfiles += ",A:brtsndfh";
			  }
			  else
			  {
			    labels += "押汇申请书";
			    tempfiles += "A:brtsndfh";
			  }
			  cnt+=1;

			}
			if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getDfflg()))
			{
			  if(cnt!=0)
			  {
			    labels += ",代付申请书";
			    tempfiles += ",A:brtsnddf";
			  }
			  else
			  {
			    labels += "代付申请书";
			    tempfiles += "A:brtsnddf";
			  }
			  cnt += 1;
			}
			if("BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			{
			  if(cnt!=0)
			  {
			    labels += ",即期售汇申请书";
			    tempfiles += ",A:fptapn";
			  }
			  else
			  {
			    labels += "即期售汇申请书";
			    tempfiles += "A:fptapn";
			  }
			  cnt += 1;
			}
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:brtsnd.@0067.script
        */
        @Rule(target="brdgrp.rec.puract",order=100)
        public boolean ruleBrdgrpRecPuractN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getPuract()))
			{
			  if("BRTSET".equals(this.getAfdgrp().getRec().getOprtyp()) && TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			  {
			    this.getBrtp().getFpdgrp().getRec().setCnycno(this.getBrdgrp().getRec().getPuract());
			    
			    
			  }
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0068.script
        */
        @Rule(target="brtp.trdgrp.rec.credittyp",order=100)
        public boolean ruleBrtpTrdgrpRecCredittypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getBrtp().getTrdgrp().getRec().getCredittyp()))
			{
			  //Platform.setRequired($brtp\\trdgrp\\rec\\cdno);
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setCdno(NULLSTR);
			  //Platform.setNotRequired($brtp\\trdgrp\\rec\\cdno);
			  
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0070.script
        */
        @Rule(target="brtp.trdgrp.rec.fcnytyp",order=100)
        public boolean ruleBrtpTrdgrpRecFcnytypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("2".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("3".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  
			  

			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}

			
			
			
			

			return true;
        }

        /**
        *   source:brtsnd.@0071.script
        */
        @Rule(target="brtp.trdgrp.rec.cnyltyp",order=100)
        public boolean ruleBrtpTrdgrpRecCnyltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  //Platform.enable($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  

			  //Platform.setRequired($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsnum);
			  

			  
			  this.getBrtp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  
			}
			else if("2".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  //Platform.enable($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  
			  

			  //Platform.setRequired($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsnum);
			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setLrldat(null);
			  this.getBrtp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBrtp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setTrunll(new BigDecimal(0));

			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
			

			Calendar cal1 =  Calendar.getInstance();
			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			{
			  cal1.setTime(this.getTrdgrp().getRec().getOpndat());
			}
			int day = cal1.get(Calendar.DAY_OF_MONTH);
			cal1.set(Calendar.DATE,20);
			if(day < 20)
			{
			  cal1.add(Calendar.MONTH,-1);
			}
			Date date1 = cal1.getTime();
			this.getTrdgrp().getRec().setLrldat(date1);
			

			return true;
        }

        /**
        *   source:brtsnd.@0072.script
        */
        @Rule(target="brtp.trdgrp.rec.cur",order=100)
        public boolean ruleBrtpTrdgrpRecCurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("CNY".equals(this.getBrtp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  
			  
			}
			else if(!MdaUtils.isEmpty(this.getBrtp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			
			

			ctx.postRule(this,"brtp.trdgrp.rec.cnyltyp");
			ctx.postRule(this,"brtp.trdgrp.rec.fcnytyp");

			return true;
        }

        /**
        *   source:brtsnd.@0075.script
        */
        @Rule(target="trdgrp.querat",order=100)
        public boolean ruleTrdgrpQueratN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getCur()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000215"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrldat()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000216"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrltyp()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000217"));
			}
			String year = "" + this.getTrdgrp().getRec().getLrldat().getYear();
			year = "" + (Integer.parseInt(year) + 1900);
			String month =  "" + this.getTrdgrp().getRec().getLrldat().getMonth();
			month = "" + (Integer.parseInt(month) + 1);
			String cur = this.getTrdgrp().getRec().getCur();

			log.info("{}","querat:  year = " + Integer.parseInt(year) + " month = " + month + " cur = " + cur);
			ctx.getDaoSession().dbRead(this.getRadgrp().getRat(),new Argument<Integer>("year",Integer.parseInt(year)),new Argument<String>("month",month),new Argument<String>("cur",cur));

			if("0".equals(this.getTrdgrp().getRec().getLrltyp())&&MdaUtils.isEmpty(this.getRadgrp().getRat().getOyrate()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000218"));
			}
			else if("1".equals(this.getTrdgrp().getRec().getLrltyp())&&MdaUtils.isEmpty(this.getRadgrp().getRat().getFyrate()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000219"));
			}

			if("0".equals(this.getTrdgrp().getRec().getLrltyp()))
			{
			  this.getTrdgrp().getRec().setLrlrat(this.getRadgrp().getRat().getOyrate());
			}
			else if("1".equals(this.getTrdgrp().getRec().getLrltyp()))
			{
			  this.getTrdgrp().getRec().setLrlrat(this.getRadgrp().getRat().getFyrate());
			}
			else
			{
			  this.getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:brtsnd.@0076.script
        */
        @Rule(target="trdgrp.sumrat",order=100)
        public boolean ruleTrdgrpSumratN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($trdgrp\\rec\\bpsas.getValue()))
			  {
			  Platform.error($trdgrp\\querat,#CT000229);
			  Platform.clear($trdgrp\\rec\\trunll);
			  return;
			  }
			
			  if(Platform.isEmpty($trdgrp\\rec\\bpsnum.getValue()))
			  {
			  Platform.error($trdgrp\\querat,#CT000230);
			  Platform.clear($trdgrp\\rec\\trunll);
			  return;
			  }
			  */
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getLrldat()))
			{
			  ctx.setFieldError(this,"trdgrp.querat",MdaUtils.getI18NString("brtsnd","CT000231"));
			  this.getTrdgrp().getRec().setTrunll(new BigDecimal(0));
			  return true;
			}

			BigDecimal lrlrat = this.getTrdgrp().getRec().getLrlrat();
			BigDecimal bpsnum = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getBpsnum(),"#0.0000"));
			bpsnum = bpsnum.multiply(new BigDecimal("0.01"));
			BigDecimal rate =new BigDecimal("0.00000");
			if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getBpsas())||MdaUtils.isEmpty(this.getTrdgrp().getRec().getBpsnum()))
			{
			  rate = this.getTrdgrp().getRec().getLrlrat();
			}
			else
			{

			  if("0".equals(this.getTrdgrp().getRec().getBpsas()))
			  {
			    rate = lrlrat.add(bpsnum);
			  }
			  else
			  {
			    rate = lrlrat.subtract(bpsnum);
			  }
			}
			this.getTrdgrp().getRec().setTrunll(MdaUtils.parseDecimal(MdaUtils.format(rate,"#0.000000")));
			

			return true;
        }

        /**
        *   source:brtsnd.@0077.script
        */
        @Rule(target="brtp.trdgrp.rec.opndat",order=100)
        public boolean ruleBrtpTrdgrpRecOpndatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat())&&!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			{
			  //SimpleDateFormat format = new java.text.SimpleDateFormat("yyyy-MM-dd");
			  Date date1 = this.getTrdgrp().getRec().getOpndat();
			  Date date2 = this.getTrdgrp().getRec().getTrodat();

			  long lday = (date2.getTime()-date1.getTime())/(24*60*60*1000);
			  this.getTrdgrp().getRec().setSubday(""+(int)lday);
			}
			else
			{
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			}
			

			//市场利率查询日期
			if("CNY".equals(this.getTrdgrp().getRec().getCur()))
			{
			  Calendar cal1 =  Calendar.getInstance();
			  if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			  {
			    cal1.setTime(this.getTrdgrp().getRec().getOpndat());
			  }
			  int day = cal1.get(Calendar.DAY_OF_MONTH);
			  cal1.set(Calendar.DATE,20);
			  if(day < 20)
			  {
			    cal1.add(Calendar.MONTH,-1);
			  }
			  Date date1 = cal1.getTime();
			  this.getTrdgrp().getRec().setLrldat(date1);
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0078.script
        */
        @Rule(target="brtp.trdgrp.rec.trunll",order=100)
        public boolean ruleBrtpTrdgrpRecTrunllN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBrtp().getTrdgrp().getRec().getTrunll()))
			{
			  ctx.setFieldError(this,"brtp.trdgrp.rec.trunll",MdaUtils.getI18NString("brtsnd","CT000232"));
			}


			return true;
        }

        /**
        *   source:brtsnd.@0092.script
        */
        @Rule(target="brdgrp.rec.zjly",order=100)
        public boolean ruleBrdgrpRecZjlyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("提示","请先选择归属机构");
			  return false;
			}
			String cid=this.getSysmod().getUsr().getCid();
			String bchcod=this.getAfdgrp().getRec().getBchcod();
			String advcur = this.getBrdgrp().getRec().getAdvcur();
			MdaUtils.clear(this.getWghmod().getShslst());
			//查询pty
			String ptysql = "select inr,lvl from pty where cid = '"+bchcod+"'";
			Argument<String> inrs = new Argument<String>("inr");
			Argument<String> lvls = new Argument<String>("lvl");
			String inr="";
			String lvl="";
			ctx.getDaoSession().dbExecuteSQL(ptysql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inrs,lvls);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    inr = inrs.getValue();
			    lvl = lvls.getValue();
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			List argVal = new ArrayList();
			String sql="select businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag from shs where  jiehsign !='1' and havegwfed > 0 and applystatus ='3' ";
			sql = sql + " and ecifno = '"+cid+"'";
			sql = sql + " and currency = '"+advcur+"'";
			//机构隔离
			//分行--可以查看分行及分行以下机构的额度
			if("1".equals(lvl))
			{
			  sql = sql + " AND (bchcod in (select cid from pty where pntinr=bchcod) or bchcod= '"+bchcod+"' ) ";
			}
			//支行--可以查看分本支行的额度
			if("2".equals(lvl))
			{
			  sql = sql + " AND orginr= '"+inr+"' ";
			}
			sql = sql + " order by zcghdat asc";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			Argument<String> businessno = new Argument<String>("businessno");
			Argument<Date> applydat = new Argument<Date>("applydat");
			Argument<String> currency = new Argument<String>("currency");
			Argument<BigDecimal> havesale = new Argument<BigDecimal>("havesale");
			Argument<BigDecimal> havegwfed = new Argument<BigDecimal>("havegwfed");
			Argument<String> applystatus = new Argument<String>("applystatus");
			Argument<Date> zcghnewdat = new Argument<Date>("zcghnewdat");
			Argument<String> lockflag = new Argument<String>("lockflag");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getWghmod().getShslst().add(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			for(int i=0;i<this.getWghmod().getShslst().size();i++)
			{
			  ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),new Argument("edbusno",this.getWghmod().getShslst().getElement(i).getBusinessno()),new Argument("deleted","0"));
			  if(this.getWghmod().getShdlst().fullSize()>0)
			  {
			    StringBuffer str = new StringBuffer();
			    for(int j=0;j<this.getWghmod().getShdlst().fullSize();j++)
			    {
			      str.append(this.getWghmod().getShdlst().getElement(j).getBillnewno()+",");
			    }
			    if(!MdaUtils.isEmpty(str.toString()))
			    {
			      int len = str.toString().length();
			      this.getWghmod().getShslst().getElement(i).setRemark((str.toString()).substring(0,len - 1));
			    }
			  }
			}
			//自有资金
			if("1".equals(this.getBrdgrp().getRec().getZjly()))
			{
			  if(this.getWghmod().getShslst().size()>0)
			  {
			    if(MdaUtils.prompt("提示","已存在已购未付金额，是否使用"))
			    {
			      this.getBrdgrp().getRec().setZjly("1");
			      
			      this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			      
			      return false;
			    }
			    this.getBrdgrp().getRec().setZjly("2");
			    
			    
			  }
			}
			else
			{
			  if(this.getWghmod().getShslst().size()==0)
			  {
			    ctx.setMessage("提示","没有符合条件网银购汇额度,请核实！");
			    this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			    this.getBrdgrp().getRec().setZjly("1");
			    this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			  }
			  else
			  {
			    
			  }
			}
			
			
			

			return true;
        }

        /**
        *   source:brtsnd.@0097.script
        */
        @Rule(target="wghmod.choose",order=100)
        public boolean ruleWghmodChooseN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getWghmod().getShslst().size();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000249"),MdaUtils.getI18NString("brtsnd","CT000250"));
			  return true;
			}
			String flg=this.getWghmod().getShslst().getElement(index).getLockflag();
			if("0".equals(flg))
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000251"),MdaUtils.getI18NString("brtsnd","CT000252"));
			  return true;
			}
			String businessno=this.getWghmod().getShslst().getElement(index).getBusinessno();
			String rmbfkzh=this.getWghmod().getShslst().getElement(index).getDuifzh();
			this.getBrdgrp().getRec().setWyghedno(businessno);
			boolean ghcheckflg=ghcheck();
			if(!ghcheckflg)
			{
			  return false;
			}
			if(!fqdlstSearch(rmbfkzh,businessno))
			{
			  return false;
			}
			MdaUtils.clear(this.getWghmod().getShs());
			ctx.getDaoSession().dbRead(this.getWghmod().getShs(),new Argument<String>("businessno",businessno));
			
			
			

			return true;
        }

        /**
        *   source:brtsnd.@0099.script
        */
        @Rule(target="wghmod.canel",order=100)
        public boolean ruleWghmodCanelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrdgrp().getRec().setZjly("1");
			
			this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			MdaUtils.clear(this.getWghmod().getShslst());
			

			return true;
        }

        /**
        *   source:brtsnd.@0100.script
        */
        @Rule(target="afdgrp.rec.bchcod",order=100)
        public boolean ruleAfdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBrdgrp().getRec().setZjly(NULLSTR);
			this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			
			

			return true;
        }


        /**
        *   source:brtsnd.@0018.script
        */
        @Check(target="brtp.brdgrp.rec.fxflg",order=100)
        public boolean checkBrtpBrdgrpRecFxflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFxflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBrtp().getBrdgrp().getRec().setFxamt(new BigDecimal(0));
			  
			  
			  
			  this.getBrtp().getBrdgrp().getRec().setFxact(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0019.script
        */
        @Check(target="brdgrp.rec.othflg",order=100)
        public boolean checkBrdgrpRecOthflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBrdgrp().getRec().getOthflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBrdgrp().getRec().setOthamt(new BigDecimal(0));
			  
			  
			  
			  this.getBrdgrp().getRec().setOthact(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0020.script
        */
        @Check(target="brtp.brdgrp.rec.purflg",order=100)
        public boolean checkBrtpBrdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getPurflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBrtp().getBrdgrp().getRec().setPuramt(new BigDecimal(0));
			  
			  
			  
			  this.getBrtp().getBrdgrp().getRec().setPuract(NULLSTR);
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0021.script
        */
        @Check(target="brtp.brdgrp.rec.fhflg",order=100)
        public boolean checkBrtpBrdgrpRecFhflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  if(MdaUtils.isEmpty(this.getTrdgrp().getRec().getFtfinancing()))
			  {
			    this.getTrdgrp().getRec().setFtfinancing(this.getLidgrp().getRec().getMyrzbh());
			  }
			  
			  this.getTrdgrp().getRec().setOpndat(MdaUtils.today());
			  

			  //从维护的银行协议编号中取贸易融资综合协议编号
			  this.getBrtp().getAgrp().qurAgrnum();
			  this.getTrdgrp().getRec().setFtfinancing(this.getBrtp().getAgrp().getTfn());
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCur(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setOpndat(null);
			  this.getBrtp().getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setTrodat(null);
			  this.getBrtp().getTrdgrp().getRec().setFtfinancing(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCredittyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCdno(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  this.getBrtp().getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrtp().setWord(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setLrldat(null);
			  this.getBrtp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBrtp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setOthrat(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setRatday(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setOthtyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setTrunll(new BigDecimal(0));

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  this.getBrdgrp().getRec().setDfflg(NULLSTR);
			  

			  this.getBrtp().getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setFintyp(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayexpdat(0);
			  this.getBrtp().getApdgrp().getRec().setColref(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setDoctypcod(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayref(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setOpndat(null);
			  this.getBrtp().getApdgrp().getRec().setMatdat(null);
			  this.getBrtp().getApdgrp().setAplnam(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setConnam(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setAccact(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getBrdgrp().getRmi().getPts().setExtkey(NULLSTR);
			  this.getBrdgrp().getRmi().getPts().setAdrblk(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:brtsnd.@0024.script
        */
        @Check(target="brtp.brdgrp.rec.dfflg",order=100)
        public boolean checkBrtpBrdgrpRecDfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getBrtp().getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setFintyp(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayexpdat(0);
			  this.getBrtp().getApdgrp().getRec().setColref(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setDoctypcod(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setPayref(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setOpndat(null);
			  this.getBrtp().getApdgrp().getRec().setMatdat(null);
			  this.getBrtp().getApdgrp().setAplnam(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getBrtp().getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setConnam(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setAccact(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getBrdgrp().getRmi().getPts().setExtkey(NULLSTR);
			  this.getBrdgrp().getRmi().getPts().setAdrblk(NULLSTR);
			  this.getBrtp().getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0034.script
        */
        @Check(target="brtp.brdgrp.rec.advamt",order=100)
        public boolean checkBrtpBrdgrpRecAdvamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//判断主体更改为索赔金额，故此处逻辑也移至索赔金额处
			/*Boolean fxflg = TRUE.equals($brtp\\brdgrp\\rec\\fxflg.getValue());
			  Boolean purflg = TRUE.equals($brtp\\brdgrp\\rec\\purflg.getValue());
			  Boolean othflg = TRUE.equals($brtp\\brdgrp\\rec\\othflg.getValue());
			  Boolean fhflg = TRUE.equals($brtp\\brdgrp\\rec\\fhflg.getValue());
			  checkSumAmt(fxflg,purflg,othflg,fhflg);*/

			return true;
        }

        /**
        *   source:brtsnd.@0042.script
        */
        @Check(target="brtp.trdgrp.rec.arrnum",order=100)
        public boolean checkBrtpTrdgrpRecArrnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBrtp().setArrnum1(this.getTrdgrp().getRec().getArrnum());
			  
			}
			else if ("2".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBrtp().setArrnum2(this.getTrdgrp().getRec().getArrnum());
			  
			}
			else if ("3".equals(this.getTrdgrp().getRec().getArrrar()))
			{
			  this.getBrtp().setArrnum3(this.getTrdgrp().getRec().getArrnum());
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0044.script
        */
        @Check(target="brtp.brdgrp.rec.relamt",order=100)
        public boolean checkBrtpBrdgrpRecRelamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			Boolean fxflg = TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getBrtp().getBrdgrp().getRec().getPurflg());
			Boolean othflg = TRUE.equals(this.getBrtp().getBrdgrp().getRec().getOthflg());
			Boolean fhflg = TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg());
			checkSumAmt(fxflg,purflg,othflg,fhflg);
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelamt())||MdaUtils.isEmpty(this.getBrdgrp().getRec().getAdvamt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBrdgrp().getRec().getAdvamt();
			BigDecimal lamt = this.getBrdgrp().getRec().getRelamt();
			if(lamt.compareTo(camt)>0)
			{
			  ctx.setFieldError(this,"brdgrp.rec.relamt",MdaUtils.getI18NString("brtsnd","CT000089"));
			}

			return true;
        }

        /**
        *   source:brtsnd.@0045.script
        */
        @Check(target="brtp.trdgrp.rec.amt",order=100)
        public boolean checkBrtpTrdgrpRecAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelamt())||MdaUtils.isEmpty(this.getTrdgrp().getRec().getAmt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBrdgrp().getRec().getRelamt();
			BigDecimal lamt = this.getTrdgrp().getRec().getAmt();
			if((this.getBrdgrp().getRec().getRelcur()==this.getTrdgrp().getRec().getCur())&&lamt.compareTo(camt)>0)
			{
			  ctx.setFieldError(this,"trdgrp.rec.amt",MdaUtils.getI18NString("brtsnd","CT000091"));
			  this.getTrdgrp().getRec().setAmt(this.getBrdgrp().getRec().getRelamt());
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0046.script
        */
        @Check(target="brtp.apdgrp.rec.payamt",order=100)
        public boolean checkBrtpApdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelamt())||MdaUtils.isEmpty(this.getApdgrp().getRec().getPayamt()))
			{
			  return true;
			}
			BigDecimal camt = this.getBrdgrp().getRec().getRelamt();
			BigDecimal lamt = this.getApdgrp().getRec().getPayamt();
			BigDecimal yamt = this.getTrdgrp().getRec().getAmt();
			if((this.getApdgrp().getRec().getPaycur()==this.getTrdgrp().getRec().getCur())&&lamt.compareTo(yamt)>0)
			{
			  ctx.setFieldError(this,"apdgrp.rec.payamt",MdaUtils.getI18NString("brtsnd","CT000104"));
			  this.getApdgrp().getRec().setPayamt(this.getTrdgrp().getRec().getAmt());
			  
			}


			return true;
        }

        /**
        *   source:brtsnd.@0048.script
        */
        @Check(target="brtp.apdgrp.rec.matdat",order=100)
        public boolean checkBrtpApdgrpRecMatdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getFhflg()))
			{
			  this.getTrdgrp().getRec().setTrodat(this.getApdgrp().getRec().getMatdat());
			  
			}

			return true;
        }

        /**
        *   source:brtsnd.@0058.script
        */
        @Check(target="brtp.trdgrp.rec.subday",order=100)
        public boolean checkBrtpTrdgrpRecSubdayN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if(MdaUtils.isEmpty(this.getBrtp().getTrdgrp().getRec().getSubday()))
			{
			  return true;
			}
			else
			{
			  int d1 = MdaUtils.parseInt(this.getBrtp().getTrdgrp().getRec().getSubday());
			  int d2 = -d1;
			  if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getOpndat()))
			  {
			    this.getTrdgrp().getRec().setTrodat(MdaUtils.add(this.getTrdgrp().getRec().getOpndat(),d1));
			  }
			  else if(!MdaUtils.isEmpty(this.getTrdgrp().getRec().getTrodat()))
			  {
			    this.getTrdgrp().getRec().setOpndat(MdaUtils.add(this.getTrdgrp().getRec().getTrodat(),d2));
			  }
			}
			
			
			ctx.postRule(this,"trdgrp.rec.trodat");

			return true;
        }

        /**
        *   source:brtsnd.@0079.script
        */
        @Check(target="brtp.brdgrp.rec.relamt",order=101)
        public boolean checkBrtpBrdgrpRecRelamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getBrdgrp().getRec(),"relamt"));

			return true;
        }

        /**
        *   source:brtsnd.@0080.script
        */
        @Check(target="brtp.brdgrp.rec.fxamt",order=100)
        public boolean checkBrtpBrdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getBrdgrp().getRec(),"fxamt"));

			return true;
        }

        /**
        *   source:brtsnd.@0081.script
        */
        @Check(target="brtp.brdgrp.rec.puramt",order=100)
        public boolean checkBrtpBrdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getBrdgrp().getRec(),"puramt"));

			return true;
        }

        /**
        *   source:brtsnd.@0082.script
        */
        @Check(target="brtp.brdgrp.rec.othamt",order=100)
        public boolean checkBrtpBrdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getBrdgrp().getRec(),"othamt"));

			return true;
        }

        /**
        *   source:brtsnd.@0083.script
        */
        @Check(target="brtp.trdgrp.rec.amt",order=101)
        public boolean checkBrtpTrdgrpRecAmtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"amt"));

			return true;
        }

        /**
        *   source:brtsnd.@0084.script
        */
        @Check(target="brtp.apdgrp.rec.payamt",order=101)
        public boolean checkBrtpApdgrpRecPayamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getBrtp().getApdgrp().getRec(),"payamt"));

			return true;
        }

        /**
        *   source:brtsnd.@0085.script
        */
        @Check(target="brtp.trdgrp.rec.consrate",order=100)
        public boolean checkBrtpTrdgrpRecConsrateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"consrate"));

			return true;
        }

        /**
        *   source:brtsnd.@0087.script
        */
        @Check(target="brtp.trdgrp.rec.basnum",order=100)
        public boolean checkBrtpTrdgrpRecBasnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"basnum"));

			return true;
        }

        /**
        *   source:brtsnd.@0088.script
        */
        @Check(target="brtp.trdgrp.rec.lrlrat",order=100)
        public boolean checkBrtpTrdgrpRecLrlratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"lrlrat"));

			return true;
        }

        /**
        *   source:brtsnd.@0089.script
        */
        @Check(target="brtp.trdgrp.rec.bpsnum",order=100)
        public boolean checkBrtpTrdgrpRecBpsnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"bpsnum"));

			return true;
        }

        /**
        *   source:brtsnd.@0090.script
        */
        @Check(target="brtp.trdgrp.rec.trunll",order=100)
        public boolean checkBrtpTrdgrpRecTrunllN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"trunll"));

			return true;
        }

        /**
        *   source:brtsnd.@0091.script
        */
        @Check(target="brtp.trdgrp.rec.disrat",order=100)
        public boolean checkBrtpTrdgrpRecDisratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"disrat"));

			return true;
        }

        /**
        *   source:brtsnd.@0086.script
        */
        @Check(target="brtp.trdgrp.rec.postedrate",order=100)
        public boolean checkBrtpTrdgrpRecPostedrateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getBrtp().getTrdgrp().getRec(),"postedrate"));

			return true;
        }


        /**
        *   source:brtsnd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			this.getBrtp().getApdgrp().setAplnam(this.getSysmod().getPty().getNam());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());

			if(!(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T")))
			{
			  IModule brd = (IModule)ctx.restoreData("com.brilliance.brtsnd.ref");
			  if(!MdaUtils.isEmpty(brd))
			  {
			    this.getBrdgrp().getRec().copyValue(brd);
			    // 加载信用证信息
			    ctx.getDaoSession().dbRead(this.getLidgrp().getRec(),new Argument("stlref", this.getBrdgrp().getRec().getPntstlref()));
			    log.debug("{}","stlref= " +this.getLidgrp().getRec().getStlref());
			    ctx.getErrorCode();
			  }

			}
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  }
			  else
			  {
			    this.getAfdgrp().getRec().setBchcod(this.getBrdgrp().getRec().getBchcod());
			  }
			}
			String stlref = this.getBrdgrp().getRec().getStlref();
			if(MdaUtils.isEmpty(stlref))
			  return true;
			List<CodetableItem> oprtyp =null;
			//if("docadv".equals($brdgrp\\rec\\docflg.getValue()))
			//{
			//oprtyp 对应的码表 IB apltyp   RB aplinf
			//if(stlref.indexOf("IB")>=0)
			//oprtyp = Platform.getCodetable("apltyp");
			//else if(stlref.indexOf("RB")>=0)
			//oprtyp = Platform.getCodetable("aplinf");
			//Platform.setValues($afdgrp\\rec\\oprval,Platform.getCodetable("refres"));
			//}
			if("disadv".equals(this.getBrdgrp().getRec().getDocflg()))
			{
			  //IB disdoc RB disdocs
			  this.getAfdgrp().setTitle(MdaUtils.getI18NString("brtsnd","CT000022"));
			  //   if(stlref.indexOf("IB")>=0)
			  oprtyp = MdaUtils.getCodetable("disdoc");
			  //    else if(stlref.indexOf("RB")>=0)
			  //     oprtyp = Platform.getCodetable("disdocs");
			  MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			  this.getBrtp().setTranspanel(this.getBrtp().getBrtp09());
			}
			else
			{
			  //oprtyp 对应的码表 IB apltyp   RB aplinf
			  this.getAfdgrp().setTitle(MdaUtils.getI18NString("brtsnd","CT000028"));
			  //    if(stlref.indexOf("IB")>=0)
			  oprtyp = MdaUtils.getCodetable("apltyp");
			  //    else if(stlref.indexOf("RB")>=0)
			  //      oprtyp = Platform.getCodetable("aplinf");
			  MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			  this.getBrtp().setTranspanel(this.getBrtp().getBrtp11());

			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  {

			  }
			  else
			  {
			    this.getBrtp().setCur(this.getBrdgrp().getRec().getRelcur());
			    this.getBrtp().setCur1(this.getBrdgrp().getRec().getRelcur());
			    this.getBrtp().setCur2(this.getBrdgrp().getRec().getRelcur());
			    MdaUtils.setValues(this.getApdgrp().getRec(),"lxchfs",MdaUtils.getCodetable("jxfs"));
			    this.getBrdgrp().getRec().setFxflg("X");
			  }
			}
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",oprtyp);
			log.debug("{}","docflg "+this.getBrdgrp().getRec().getDocflg()+"\tstlref"+stlref);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //针对承兑，退回，暂存情况下承兑中预览信息做了优化
			
			  String sql = "SELECT ordinr FROM trn WHERE objtyp = 'brd' AND modtyp = '1' AND inifrm = 'brtdck' AND ownref = '"+this.getBrdgrp().getRec().getOwnref()+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  log.info("{}","sql = "+sql);
			  Argument<String> ordinrtmp =new Argument<String>("ordinr");
			  ctx.getDaoSession().dbFetchFields(ordinrtmp);
			  String stlordinr = ordinrtmp.value;

			  log.info("{}","stlordinr = "+stlordinr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.info("{}","特殊情况判断：暂存/退回等");
			    this.getBtnmod().initDocumentButton(stlordinr);
			    MdaUtils.clear(this.getTrnmod().getApldoc().getPdfdoc());
			    
			    log.info("{}","pdfdoc.inr = "+this.getTrnmod().getApldoc().getPdfdoc().getInr());
			  }
			  else
			  {
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  if((ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P"))&& !MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelcur()))
			  {
			    this.getBrtp().setCur(this.getBrdgrp().getRec().getRelcur());
			    this.getBrtp().setCur1(this.getBrdgrp().getRec().getRelcur());
			    this.getBrtp().setCur2(this.getBrdgrp().getRec().getRelcur());
			    
			    
			    

			  }
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  {
			    ctx.getDaoSession().dbRead(this.getLidgrp().getRec(),new Argument("stlref", this.getBrdgrp().getRec().getPntstlref()));
			    log.debug("{}","加载显示信用证信息= " +this.getLidgrp().getRec().getStlref()+",con"+this.getLidgrp().getRec().getConno());
			    ctx.getErrorCode();
			    
			    
			  }
			  //现汇判定
			  if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFxflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  //购汇判定
			  if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getPurflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  //它汇判定
			  if(TRUE.equals(this.getBrdgrp().getRec().getOthflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  //押汇判定
			  if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  //代付判定
			  if(TRUE.equals(this.getBrtp().getBrdgrp().getRec().getDfflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    //Platform.enable($brtp\\apdgrp\\aplnam);
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			  }

			  Modules.postDefaultRule(this,"trdgrp");
			  ctx.postRule(this,"afdgrp.rec.oprtyp");
			  //Platform.postEventRule($trdgrp\\rec\\arrrar,onChange,null);
			
			  ctx.postRule(this,"trdgrp.rec.caltyp");
			  ctx.postRule(this,"trdgrp.rec.ocaltp");
			  ctx.postRule(this,"brdgrp.rec.fxamt");
			  ctx.postRule(this,"brdgrp.rec.othamt");
			  ctx.postRule(this,"brdgrp.rec.puramt");
			  this.dealInit();
			  return true;
			}
			//$brtp\\rejectlabel.setValue("1");
			
			
			
			changeOprTyp();
			this.getBrdgrp().getRec().setZjly(NULLSTR);
			this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			this.getBrdgrp().getRec().setFhflg(NULLSTR);
			this.getBrdgrp().getRec().setDfflg(NULLSTR);
			this.getBrdgrp().getRec().setPurflg(NULLSTR);
			this.getBrdgrp().getRec().setPuramt(new BigDecimal(0));
			this.getBrdgrp().getRec().setOthflg(NULLSTR);
			this.getBrdgrp().getRec().setOthamt(new BigDecimal(0));
			this.getBrdgrp().getRec().setPuract(NULLSTR);
			this.getBrdgrp().getRec().setOthact(NULLSTR);
			this.getBrdgrp().getRec().setFxamt(new BigDecimal(0));
			this.getBrdgrp().getRec().setFxact(NULLSTR);
			//承兑中预览信息所需
			
			String sql = "SELECT ordinr FROM trn WHERE objtyp = 'brd' AND modtyp = '1' AND inifrm = 'brtdck' AND ownref = '"+this.getBrdgrp().getRec().getOwnref()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			log.info("{}","sql = "+sql);
			Argument<String> ordinrtmp =new Argument<String>("ordinr");
			ctx.getDaoSession().dbFetchFields(ordinrtmp);
			String stlordinr = ordinrtmp.value;

			log.info("{}","stlordinr = "+stlordinr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("brtsnd","CT000037"),MdaUtils.getI18NString("brtsnd","CT000160"));
			  this.getBtnmod().initDocumentButton(stlordinr);
			  MdaUtils.clear(this.getTrnmod().getApldoc().getPdfdoc());
			  
			  log.info("{}","pdfdoc.inr = "+this.getTrnmod().getApldoc().getPdfdoc().getInr());
			}
			else
			{
			}
			ctx.getDaoSession().dbCloseCursor();

			this.getBrtp().setRejectlabel(MdaUtils.getI18NString("brtsnd","CT000161"));

			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			this.getAfdgrp().getRec().setOwnref(this.getBrdgrp().getRec().getStlref());
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelcur()))
			  this.getBrdgrp().getRec().setRelcur(this.getBrdgrp().getRec().getAdvcur());
			if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getRelcur()))
			  this.getBrdgrp().getRec().setRelamt(this.getBrdgrp().getRec().getAdvamt());
			ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","apl"));
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","ben"));
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getBrdgrp().getRmi().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","rmi"));
			ctx.getErrorCode();
			log.info("{}","pdfdoc ownref="+this.getTrnmod().getApldoc().getPdfdoc().getOwnref());
			ctx.getErrorCode();
			this.getAfdgrp().getRec().setOprtyp("BRTSET");
			String seltyp = (ctx.restoreData("com.brilliance.brtsnd.seltyp")).toString();
			//$afdgrp\\rec\\oprtyp.setValue(oprtyp.get(1).getValue());
			
			this.dealInit();

			return true;
        }

        /**
        *   source:brtsnd.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBrdgrp().getRec().getDbchcod()))
			      this.getAfdgrp().getRec().setBchcod(this.getBrdgrp().getRec().getDbchcod());
			    else
			    {
			      this.getAfdgrp().getRec().setBchcod(this.getBrdgrp().getRec().getBchcod());
			      this.getBrdgrp().getRec().setDbchcod(this.getBrdgrp().getRec().getBchcod());
			    }
			    
			  }
			  log.info("{}","bchcod="+this.getBrdgrp().getRec().getBchcod());
			}


			return true;
        }

        /**
        *   source:brtsnd.@0060.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","brtsnd  init业务处理开始，order:90");
			//0、进口承兑/付款/拒付申请   1、购汇申请
			this.getBrtp().getStpmod().storePanel(this.getBrtp().getBrds2(),this.getBrtp().getBrds3());
			//String steps = "0:进口承兑/付款/拒付申请";
			String steps = "0:承兑/付款/拒付";
			
			

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{

			  StringBuffer stepsB = new StringBuffer();
			  String stepss= "";
			  steps = stepss+stepsB.append("0:承兑/付款/拒付");

			  String val=this.getAfdgrp().getRec().getOprtyp();
			  if("BRTSET".equals(val))
			  {
			    if(TRUE.equals(this.getBrdgrp().getRec().getPurflg()))
			    {
			      steps =steps+stepsB.append(";1:购汇申请");
			      
			    }
			    else
			    {
			      
			    }
			  }
			}
			else
			{
			  this.getBrdgrp().getRec().setZjly("1");
			  
			}
			

			this.getBrtp().getStpmod().setPages(steps);
			this.getBrtp().getStpmod().calcSteps();
			this.getBrtp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:brtsnd.@0006.script
        */
        public void changeOprTyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String val=this.getAfdgrp().getRec().getOprtyp();
			// log.debug("in evt afdgrp.rec.oprtyp ... opttyp " + $afdgrp\\rec\\oprtyp.getValue());
			// $this.setSubPanelByOprtyp($afdgrp\\rec\\oprtyp.getValue());
			
			if("BRTSET".equals(val))
			{
			  this.getBrtp().setTranspanel(this.getBrtp().getBrtp11());
			  
			  
			  
			  
			  
			  this.getAfdgrp().getRec().setOprval(NULLSTR);
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			if("BRTUDP".equals(val))
			{
			  this.getBrtp().setTranspanel(this.getBrtp().getBrtp10());
			  this.getAfdgrp().getRec().setOprval(NULLSTR);
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			  

			  //付款界面内容
			  this.getBrdgrp().getRec().setFxflg(NULLSTR);
			  this.getBrdgrp().getRec().setFxamt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setFxact(NULLSTR);
			  this.getBrdgrp().getRec().setPurflg(NULLSTR);
			  this.getBrdgrp().getRec().setPuramt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setPuract(NULLSTR);
			  this.getBrdgrp().getRec().setOthflg(NULLSTR);
			  this.getBrdgrp().getRec().setOthamt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setOthact(NULLSTR);
			  this.getBrdgrp().getRec().setFhflg(NULLSTR);
			  this.getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getTrdgrp().getRec().setCur(NULLSTR);
			  this.getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getTrdgrp().getRec().setOpndat(null);
			  this.getTrdgrp().getRec().setWord(NULLSTR);
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getTrdgrp().getRec().setTrodat(null);
			  this.getTrdgrp().getRec().setActrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setIntrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setArrrar(NULLSTR);
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			  this.getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			  this.getTrdgrp().getRec().setOcaltp(NULLSTR);
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrdgrp().getRec().setDfflg(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  this.getApdgrp().getRec().setConnam(NULLSTR);
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  this.getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  this.getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getApdgrp().getRec().setAccact(NULLSTR);
			  this.getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setPayexpdat(0);
			  this.getApdgrp().getRec().setMatdat(null);
			  this.getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  MdaUtils.clear(this.getBrdgrp().getRmi());
			  this.getBrtp().getRmip().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getBrtp().getRmip().getPtspta().getPts().setAdrblk(NULLSTR);
			  this.getBrdgrp().getRec().setZjly(NULLSTR);
			  this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("BRTDCR".equals(val))
			{
			  this.getBrtp().setTranspanel(this.getBrtp().getBrtp09());
			  
			  
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);

			  
			  

			  
			  

			  //付款界面内容
			  
			  
			  
			  
			  
			  
			  

			  this.getBrdgrp().getRec().setFxflg(NULLSTR);
			  this.getBrdgrp().getRec().setFxamt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setFxact(NULLSTR);
			  this.getBrdgrp().getRec().setPurflg(NULLSTR);
			  this.getBrdgrp().getRec().setPuramt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setPuract(NULLSTR);
			  this.getBrdgrp().getRec().setOthflg(NULLSTR);
			  this.getBrdgrp().getRec().setOthamt(new BigDecimal(0));
			  this.getBrdgrp().getRec().setOthact(NULLSTR);
			  this.getBrdgrp().getRec().setFhflg(NULLSTR);
			  this.getTrdgrp().getRec().setOwnref(NULLSTR);
			  this.getTrdgrp().getRec().setCur(NULLSTR);
			  this.getTrdgrp().getRec().setAmt(new BigDecimal(0));
			  this.getTrdgrp().getRec().setOpndat(null);
			  this.getTrdgrp().getRec().setWord(NULLSTR);
			  this.getTrdgrp().getRec().setSubday(NULLSTR);
			  this.getTrdgrp().getRec().setTrodat(null);
			  this.getTrdgrp().getRec().setActrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setIntrat(new BigDecimal(0));
			  this.getTrdgrp().getRec().setArrrar(NULLSTR);
			  this.getTrdgrp().getRec().setArrnum(NULLSTR);
			  this.getTrdgrp().getRec().setCaltyp(NULLSTR);
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			  this.getTrdgrp().getRec().setOcaltp(NULLSTR);
			  this.getTrdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrdgrp().getRec().setDfflg(NULLSTR);
			  this.getApdgrp().getRec().setOwnref(NULLSTR);
			  this.getApdgrp().getRec().setConnam(NULLSTR);
			  this.getApdgrp().getRec().setColref(NULLSTR);
			  this.getApdgrp().getRec().setInrgod(NULLSTR);
			  this.getApdgrp().getRec().setOtyinr(NULLSTR);
			  this.getApdgrp().getRec().setPayref(NULLSTR);
			  this.getApdgrp().getRec().setPaycur(NULLSTR);
			  this.getApdgrp().getRec().setPayamt(new BigDecimal(0));
			  this.getApdgrp().getRec().setLrdate(NULLSTR);
			  this.getApdgrp().getRec().setAccact(NULLSTR);
			  this.getApdgrp().getRec().setApdtip(NULLSTR);
			  this.getApdgrp().getRec().setFinrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setWord(NULLSTR);
			  this.getApdgrp().getRec().setPayexpdat(0);
			  this.getApdgrp().getRec().setMatdat(null);
			  this.getApdgrp().getRec().setLxchfs(NULLSTR);
			  this.getApdgrp().getRec().setOpyrat(new BigDecimal(0));
			  this.getApdgrp().getRec().setDisrat(new BigDecimal(0));
			  this.getBrtp().getRmip().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getBrtp().getRmip().getPtspta().getPts().setAdrblk(NULLSTR);
			  this.getBrdgrp().getRec().setZjly(NULLSTR);
			  this.getBrdgrp().getRec().setWyghedno(NULLSTR);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
		}
        /**
        *   source:brtsnd.@0035.script
        */
        public void checkSumAmt(Boolean fxflg,Boolean purflg,Boolean othflg,Boolean fhflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","brtsnd.relamtCheck start:");
			if(fxflg || purflg || othflg || fhflg)
			{
			  BigDecimal sumamt = new BigDecimal("0");

			  if(fxflg)
			  {
			    sumamt = sumamt.add(this.getBrdgrp().getRec().getFxamt());
			    log.debug("{}","fxamt:" + this.getBrdgrp().getRec().getFxamt());
			    log.debug("{}","sumamt(fxamt):" + sumamt);
			  }
			  if(purflg)
			  {
			    sumamt = sumamt.add(this.getBrdgrp().getRec().getPuramt());
			    log.debug("{}","puramt:" + this.getBrdgrp().getRec().getPuramt());
			    log.debug("{}","sumamt(puramt):" + sumamt);
			  }
			  if(othflg)
			  {
			    sumamt = sumamt.add(this.getBrdgrp().getRec().getOthamt());
			    log.debug("{}","othamt:" + this.getBrdgrp().getRec().getOthamt());
			    log.debug("{}","sumamt(othamt):" + sumamt);
			  }
			  if(fhflg)
			  {
			    sumamt = sumamt.add(this.getTrdgrp().getRec().getAmt());
			    log.debug("{}","fhamt:" + this.getTrdgrp().getRec().getAmt());
			    log.debug("{}","sumamt(fhamt):" + sumamt);
			  }

			  if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getBrdgrp().getRec().getRelamt()).compareTo(sumamt)!=0)
			    ctx.setFieldError(this,"brdgrp.rec.relamt",MdaUtils.getI18NString("brtsnd","CT000085"));
			  log.debug("{}","relamt:" + this.getBrdgrp().getRec().getRelamt());
			  log.debug("{}","sumamt:" + sumamt);
			}
			log.debug("{}","brtsnd.relamtCheck end!");
		}
        /**
        *   source:brtsnd.@0069.script
        */
        public void dealInit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//贸易融资授信协议编号
			//授信额度
			//利率其他约定
			if(!TRUE.equals(this.getBrtp().getBrdgrp().getRec().getFhflg()))
			{
			  this.getBrtp().getTrdgrp().getRec().setFtfinancing(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCredittyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setCdno(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setDisrat(new BigDecimal(0));

			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
			
			
			
			

			//风险授信额度
			if("2".equals(this.getBrtp().getTrdgrp().getRec().getCredittyp()))
			{
			  //Platform.setRequired($brtp\\trdgrp\\rec\\cdno);
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setCdno(NULLSTR);
			  //Platform.setNotRequired($brtp\\trdgrp\\rec\\cdno);
			  
			}
			

			//押汇方式
			if("CNY".equals(this.getBrtp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  
			  
			}
			else if(!MdaUtils.isEmpty(this.getBrtp().getTrdgrp().getRec().getCur()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setFcnytyp(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  
			  

			  
			  
			}
			
			

			//外币押汇方式
			if("1".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("2".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}
			else if("3".equals(this.getBrtp().getTrdgrp().getRec().getFcnytyp()))
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  
			  

			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setConsrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setPostedrate(new BigDecimal(0));
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setLihibor(NULLSTR);
			  
			  

			  this.getBrtp().getTrdgrp().getRec().setBasnum(0);
			  
			  
			}

			
			
			
			

			//人民币押汇方式
			if("1".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  
			  //Platform.enable($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  
			  this.getBrtp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  

			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsnum);
			  
			  
			  
			}
			else if("2".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  
			  //Platform.enable($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  
			  
			  

			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\lrldat);
			  
			  
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsas);
			  //Platform.setRequired($brtp\\trdgrp\\rec\\bpsnum);
			  
			  
			}
			else
			{
			  this.getBrtp().getTrdgrp().getRec().setCnyltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setLrldat(null);
			  this.getBrtp().getTrdgrp().getRec().setLrltyp(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setLrlrat(new BigDecimal(0));
			  this.getBrtp().getTrdgrp().getRec().setBpsas(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setBpsnum(0);
			  this.getBrtp().getTrdgrp().getRec().setRatcycle(NULLSTR);
			  this.getBrtp().getTrdgrp().getRec().setTrunll(new BigDecimal(0));

			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
			
			
			//计收利息的方式
			if("2".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);
			}
			else if("3".equals(this.getTrdgrp().getRec().getCaltyp()))
			{
			  

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			else
			{
			  
			  this.getTrdgrp().getRec().setOthtyp(NULLSTR);

			  
			  this.getTrdgrp().getRec().setRatday(NULLSTR);
			}
			
			
		}
        /**
        *   source:brtsnd.@0073.script
        */
        public void dealpdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//lrlrat  trunll  consrate  postedrate  disrat
			BigDecimal rate = new BigDecimal("#0.000000");

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getLrlrat(),"#0.000000"));
			this.getTrdgrp().getRec().setLrlrat(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getTrunll(),"#0.000000"));
			this.getTrdgrp().getRec().setTrunll(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getConsrate(),"#0.000000"));
			this.getTrdgrp().getRec().setConsrate(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getPostedrate(),"#0.000000"));
			this.getTrdgrp().getRec().setPostedrate(rate);
			

			rate = MdaUtils.parseDecimal(MdaUtils.format(this.getTrdgrp().getRec().getDisrat(),"#0.000000"));
			this.getTrdgrp().getRec().setDisrat(rate);
			

			if("7".equals(this.getTrdgrp().getRec().getRatcycle()))
			{
			  this.getTrdgrp().setRatcyclend("√");
			}
			else
			{
			  this.getTrdgrp().setRatcyclend(NULLSTR);
			}

			//lcref=lidgrp\\\\rec\\\\stlref 信用证号码     rmipnam=brdgrp\\\\rmi\\\\pta\\\\nam 来单银行名称    ben=brdgrp\\\\ben\\\\pts\\\\adrblk 受益人
			
			//人民币押汇方式
			this.getBrtp().getTrdgrp().setTrunll(NULLSTR);
			this.getBrtp().getTrdgrp().setLrldat1(null);
			this.getBrtp().getTrdgrp().setLrldat2(null);
			this.getBrtp().getTrdgrp().setLrltyp(NULLSTR);
			this.getBrtp().getTrdgrp().setLrlrat(NULLSTR);
			this.getBrtp().getTrdgrp().setBpsas(NULLSTR);
			this.getBrtp().getTrdgrp().setBpsnum(NULLSTR);

			StringBuffer trunll=new StringBuffer();
			StringBuffer lrltyp=new StringBuffer();
			StringBuffer lrlrat=new StringBuffer();
			StringBuffer bpsas=new StringBuffer();
			StringBuffer bpsnum=new StringBuffer();
			String conn = ",";
			String cc = null;
			BigDecimal bd = null;

			if("1".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  bd = this.getTrdgrp().getRec().getTrunll();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    trunll.append("");
			  else
			    trunll.append(bd);

			  cc = this.getBrtp().getTrdgrp().getRec().getLrltyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="一年期";
			  else if("1".equals(cc))
			    cc="五年期";
			  lrltyp.append(cc).append(conn);

			  cc = this.getBrtp().getTrdgrp().getRec().getLrlrat().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  lrlrat.append(cc).append(conn);

			  cc = this.getBrtp().getTrdgrp().getRec().getBpsas();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="加";
			  else if("1".equals(cc))
			    cc="减";
			  bpsas.append(cc).append(conn);

			  cc = ""+this.getBrtp().getTrdgrp().getRec().getBpsnum().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bpsnum.append(cc).append(conn);

			  this.getBrtp().getTrdgrp().setLrldat1(this.getBrtp().getTrdgrp().getRec().getLrldat());
			}
			else if("2".equals(this.getBrtp().getTrdgrp().getRec().getCnyltyp()))
			{
			  bd = this.getTrdgrp().getRec().getTrunll();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    trunll.append("");
			  else
			    trunll.append(conn).append(bd);

			  cc = this.getBrtp().getTrdgrp().getRec().getLrltyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="一年期";
			  else if("1".equals(cc))
			    cc="五年期";
			  lrltyp.append(conn).append(cc);

			  cc = this.getBrtp().getTrdgrp().getRec().getLrlrat().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  lrlrat.append(conn).append(cc);

			  cc = this.getBrtp().getTrdgrp().getRec().getBpsas();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  else if("0".equals(cc))
			    cc="加";
			  else if("1".equals(cc))
			    cc="减";
			  bpsas.append(conn).append(cc);

			  cc = ""+this.getBrtp().getTrdgrp().getRec().getBpsnum().toString();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bpsnum.append(conn).append(cc);

			  this.getBrtp().getTrdgrp().setLrldat2(this.getBrtp().getTrdgrp().getRec().getLrldat());
			}

			this.getBrtp().getTrdgrp().setTrunll(trunll.toString());
			this.getBrtp().getTrdgrp().setLrltyp(lrltyp.toString());
			this.getBrtp().getTrdgrp().setLrlrat(lrlrat.toString());
			this.getBrtp().getTrdgrp().setBpsas(bpsas.toString());
			this.getBrtp().getTrdgrp().setBpsnum(bpsnum.toString());
		}
        /**
        *   source:brtsnd.@0095.script
        */
        public boolean ghcheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*购汇额度校验*/
			if("2".equals(this.getBrdgrp().getRec().getZjly()))
			{
			  String ref=this.getBrdgrp().getRec().getWyghedno();
			  log.info("{}","购汇校验"+ref);
			  getghref(ref);
			  int length=this.getWghmod().getShdlst().size();
			  log.debug("{}","长度"+length);
			  if(length>0)
			  {
			    for(int i=0;i<length;i++){
			      if(!MdaUtils.isEmpty(this.getWghmod().getShdlst().getElement(i).getBillnewno()))
			    {
			      String billnewno=this.getWghmod().getShdlst().getElement(i).getBillnewno();
			      String type=this.getWghmod().getShdlst().getElement(i).getBilltype();
			      if("2".equals(type)&&billnewno.equals(this.getBrdgrp().getRec().getConno()))
			      {
			        break;
			      }
			      else
			      {
			        if(i+1==length)
			        {
			          ctx.setMessage("提示","该笔申请合同号与所选网银购汇额度编号项下的合同号不一致，请加强审核！");
			          //return false;
			        }
			        continue;
			      }
			    }

			  }
			}
			else
			{
			  ctx.setMessage("提示","所选网银购汇额度编号项下合同号为空");
			  return false;
			}
			}
			return true;

		}
        /**
        *   source:brtsnd.@0096.script
        */
        public boolean getghref(String ghownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","购汇列表"+ghownref);
			MdaUtils.clear(this.getWghmod().getShdlst());
			List argVal = new ArrayList();
			String sql=" where edbusno = ? and deleted = '0' order by inr  desc";
			argVal.add(ghownref);
			ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			return true ;
		}
        /**
        *   source:brtsnd.@0098.script
        */
        public boolean  fqdlstSearch(String rmbfkzh,String businessno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getWghmod().getFqdlst());
			List argVal = new ArrayList();
			String sql=" where duifzh = ? and edbusno = ? order by inr desc,credat desc";
			argVal.add(rmbfkzh);
			argVal.add(businessno);
			ctx.getDaoSession().dbReadset(this.getWghmod().getFqdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			if(this.getWghmod().getFqdlst().size()>0)
			{
			  log.info("{}","fqd账户类型"+this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			  this.getWghmod().setZhlx(this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			}
			ctx.getDaoSession().dbCloseCursor();
			
			
			return true;
		}















}