package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.BxtdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口押汇生效通知
*/
@Transaction(vo= BxtdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bxtdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Bxtdav.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Ledgrp ledgrp;


		public Bxtdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Bxtdav.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Bxtdav.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Bxtdav.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Bxtdav.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Bxtdav.this.getBpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
        }



        /**
        *   source:bxtdav.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in getImgRef");
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			ctx.absGet(Mtabut.class).getImgtp().setTrninr(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getTrninr());
			this.getBptp().setDztimgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			
			
			log.debug("{}","trninr=" + ctx.absGet(Mtabut.class).getImgtp().getTrninr());
			log.debug("{}","end getImgRef,dztimgref:" + this.getBptp().getDztimgref());

			return true;
        }

        /**
        *   source:bxtdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getBptp().getBxtdavstep01());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			log.info("{}","bchcod:"+this.getBpdgrp().getRec().getBchcod());
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getBpdgrp().getRec().setBchcod(bchcod.get(0).getValue());


			return true;
        }












}