package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.ChkameVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Wrnmod;
import com.ceb.gjjs.mda.manager.module.Bsplst;
import com.ceb.gjjs.mda.manager.module.Pdfviw;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.manager.module.Chkmod;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 交割方式审核
*/
@Transaction(vo= ChkameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Chkame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Chkame.class);

        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);
        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);
        //证实书
        private transient IControl apls = new ControlImpl("apls", "证实书", this);
        //已复核业务
        private String bnkchk;
        //交割方式审核
        private IPanel chkpan;
        //业务流水编号
        private String trninr;
        //temstm
        private IStream temstm = new StreamImpl();
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private ModuleList<Bsplst> bsplst;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Chkmod chkmod;

		@BDGetter
		private ModuleList<Spt> tdolst;

		@BDGetter
		private Trn wrktrn;

		@BDGetter
		private Spt wrkspt;

		@BDGetter
		private Wrnmod wrnmod;

		@BDGetter
		private Pdfviw pdfviw;

		@BDGetter
		private Msg msg;

		@BDGetter
		private Spt chkspt;

		@BDGetter
		private Smh smh;


		public Chkame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:chkame.@0002.script
        */
        @Rule(target="btnmod.back",order=100)
        public boolean ruleBtnmodBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = -1;
			int count = 0;
			for(int i=0;i<this.getBsplst().fullSize();i++)
			{
			  if(!"X".equals(this.getBsplst().getElement(i).getSelflg()))
			    continue;
			  else
			  {
			    index=i;
			    count++;
			  }
			  if(count>1)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000038"),MdaUtils.getI18NString("chkame","CT000039"));
			    return true;
			  }
			  if(this.getTrnmod().isFinancingTransaction(this.getBsplst().getElement(i).getFrm(),"2"))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000040"),MdaUtils.getI18NString("chkame","CT000041"));
			    return true;
			  }
			}

			if(index<0  ||  index>=this.getBsplst().fullSize())
			{
			  index=0;
			  log.debug("{}","index    =  "+index);
			  if(index<0  ||  index>=this.getBsplst().fullSize())
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000042"),MdaUtils.getI18NString("chkame","CT000043"));
			    return true;
			  }
			}
			if(MdaUtils.prompt("提示",MdaUtils.getI18NString("chkame","CT000044")))
			  return true;
			int errorcode=-1;
			String ordinr=null;
			String scr=null;
			log.debug("{}","[bnkspt->back]index="+index);
			MdaUtils.clear(this.getSysmod().getSpt());
			String sptlstinr = this.getBsplst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument<String>("inr",sptlstinr));
			ctx.getDaoSession().dbBegin();
			scr=this.getSysmod().getSpt().getScr();
			log.info("{}","[bnkspt->back]scr="+scr+",spt.inr="+this.getSysmod().getSpt().getInr());
			ordinr=this.getSysmod().getSpt().getInr();
			log.debug("{}","[bnkspt->back] spt.srctxt="+this.getSysmod().getSpt().getScrtxt());
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getScrtxt()))
			{
			  this.getTrnmod().sdbRead(this.getWrktrn(),this.getSysmod().getSpt().getScrtxt());
			  this.getWrktrn().setSta("B");
			  ctx.getDaoSession().dbUpdate(this.getWrktrn());
			  log.info("{}","platform.dbRead run NO_ERROR!");
			  ordinr=this.getWrktrn().getOrdinr();
			  log.info("{}","trn inr="+this.getWrktrn().getInr()+",ordinr="+ordinr);

			  String trninr=this.getSysmod().getSpt().getScrtxt();

			  if(!MdaUtils.isEmpty(this.getRmkmod().getRmk().getTrninr()) && trninr.equals(this.getRmkmod().getRmk().getTrninr()))
			  {
			    //已带入，无需再次载入
			  }
			  else
			  {
			    this.getRmkmod().setOtext(NULLSTR);
			    this.getRmkmod().setNtext(NULLSTR);
			    ctx.getDaoSession().dbRead(this.getRmkmod().getRmk(),new Argument<String>("trninr",trninr));
			    this.getRmkmod().setOtext(this.getRmkmod().getRmk().getTxt());
			  }

			  
			  
			}
			else
			  return false;
			String inr=this.getWrktrn().getInr();
			ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","trn"));
			String wfsinr=this.getTrnmod().getWfmmod().getWfs().getInr();
			log.info("{}","deleted wfsinr="+wfsinr);
			ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr));
			log.info("{}","delete wfes OK!");
			ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfs());
			ctx.getDaoSession().dbDelete(this.getTrnmod().getUsrsig(),new Argument("ownref",this.getWrktrn().getOwnref()),new Argument("trninr",inr));

			MdaUtils.clear(this.getWrnmod().getWrn());
			//有复核的业务删除复核记录
			ctx.getDaoSession().dbRead(this.getWrnmod().getWrn(),new Argument<Object>("inr",this.getSysmod().getSpt().getWrninr()));
			if(!MdaUtils.isEmpty(this.getWrnmod().getWrn().getInr()))
			{
			  ctx.getDaoSession().dbDelete(this.getWrnmod().getWrn());
			}
			//delete dat file
			this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","11",this.getRmkmod().getNtext());
			backSptToSubPty();
			ctx.getDaoSession().dbDelete(this.getSysmod().getSpt());
			//update remark
			this.getRmkmod().updateRmk("7");
			ctx.getDaoSession().dbCommit();
			MdaUtils.showMainPanel();
			refresh(false);

			return true;
        }

        /**
        *   source:chkame.@0004.script
        */
        @Rule(target="btnmod.fresh",order=100)
        public boolean ruleBtnmodFreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			refresh(false);

			return true;
        }

        /**
        *   source:chkame.@0005.script
        */
        @Rule(target="btnmod.search",order=100)
        public boolean ruleBtnmodSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date betdat=this.getBtnmod().getBegdat();
			Date enddat =this.getBtnmod().getEnddat();
			if(MdaUtils.diff(betdat,enddat)>0)
			{
			  ctx.setFieldError(this,"btnmod.begdat",MdaUtils.getI18NString("chkame","CT000046"));
			  return true;
			}
			refresh(true);

			return true;
        }

        /**
        *   source:chkame.@0006.script
        */
        @Rule(target="btnmod.show",order=100)
        public boolean ruleBtnmodShowN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index =-1;
			int count=0;
			for(int i=0;i<this.getBsplst().fullSize();i++)
			{
			  if("X".equals(this.getBsplst().getElement(i).getSelflg()))
			  {
			    index=i;
			    count++;
			  }
			}
			if(count>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("chkame","CT000051"),MdaUtils.getI18NString("chkame","CT000052"));
			  return true;
			}
			//index=Platform.getSelectedRowIndex($bsplst);
			log.debug("{}","in evt btnmod.show ... index =" +index);
			if(index<0  ||  index>=this.getBsplst().fullSize())
			{
			  index=0;
			  if(index<0||index>=this.getBsplst().fullSize())
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000053"),MdaUtils.getI18NString("chkame","CT000054"));
			    return true;
			  }
			}
			if(!this.getTrnmod().accessRight(this.getSysmod().getUsr().getInr(),this.getBsplst().getElement(index).getFrm()))
			{
			  log.debug("{}","提示: 无权限访问该交易");
			  return true;
			}
			getBsplst(index);

			if("jsd".equals(this.getSysmod().getSpt().getObjtyp()))
			{
			  //$chkpan.setValue($jstchk);
			}
			else
			{
			  //$chkpan.setValue($witchk);
			}

			if("F".equals(this.getWrnmod().getWrn().getSta()))
			{
			  this.getChkmod().pdfValue(this.getSysmod().getSpt().getObjtyp());
			}
			showDetailPanel(index);

			return true;
        }

        /**
        *   source:chkame.@0009.script
        */
        @Rule(target="return",order=100)
        public boolean ruleReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.showMainPanel();

			return true;
        }

        /**
        *   source:chkame.@0010.script
        */
        @Rule(target="imgviw",order=100)
        public boolean ruleImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}"," in imgviw....");
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().imgScans(this.getTrninr());

			return true;
        }

        /**
        *   source:chkame.@0011.script
        */
        @Rule(target="apls",order=100)
        public boolean ruleAplsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getChkmod().pdfValue(this.getSysmod().getSpt().getObjtyp());
			if("jsd".equals(this.getSysmod().getSpt().getObjtyp()))
			  this.getPdfviw().callPDFComponent("","chkame1","人民币与外汇衍生品交割方式修改指令证实书",0);
			else
			  this.getPdfviw().callPDFComponent("","chkame2","人民币与外汇期权交割方式修改指令证实书",0);

			return true;
        }

        /**
        *   source:chkame.@0012.script
        */
        @Rule(target="btnmod.submit",order=100)
        public boolean ruleBtnmodSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!this.getTrnmod().accessRight(this.getSysmod().getUsr().getInr(),this.getSysmod().getSpt().getFrm()))
			{
			  log.debug("{}","提示: 无权限访问该交易");
			  return false;
			}

			if(MdaUtils.prompt(MdaUtils.getI18NString("chkame","CT000210"),MdaUtils.getI18NString("chkame","CT000211")))
			{
			  return false;
			}

			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(this.getWrnmod().getWrn().getInr())||!"F".equals(this.getWrnmod().getWrn().getSta()))
			{
			  if("jsd".equals(this.getSysmod().getSpt().getObjtyp()))
			  {
			    if("0".equals(this.getChkmod().getJsdgrp().getRec().getNewgivsty()) && MdaUtils.isEmpty(this.getChkmod().getJsdgrp().getRec().getGivslt()) && MdaUtils.isEmpty(this.getChkmod().getJsdgrp().getRec().getGetslt()))
			    {
			      ctx.setFieldError(this,"chkmod.jsdgrp.rec.getslt",MdaUtils.getI18NString("chkame","CT000212"));
			      return false;
			    }
			  }
			  if("wid".equals(this.getSysmod().getSpt().getObjtyp()))
			  {
			    if("0".equals(this.getChkmod().getWidgrp().getRec().getSfcejg()) && (MdaUtils.isEmpty(this.getChkmod().getWidgrp().getRec().getYktyp()) || MdaUtils.isEmpty(this.getChkmod().getWidgrp().getRec().getYkje())))
			    {
			      ctx.setFieldError(this,"chkmod.widgrp.rec.yktyp",MdaUtils.getI18NString("chkame","CT000213"));
			      return false;
			    }
			  }
			  submitReviewed();
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000214"),MdaUtils.getI18NString("chkame","CT000215"));
			    return false;
			  }
			  else
			  {
			    ctx.getDaoSession().dbCommit();
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000216"),MdaUtils.getI18NString("chkame","CT000217"));
			    MdaUtils.showMainPanel();
			    refresh(false);
			  }
			}
			else
			{
			  this.getChkmod().pdfValueS(this.getSysmod().getSpt().getObjtyp());

			  String owninr=this.getWrnmod().getWrn().getOwninr();
			  if(owninr.equals(this.getSysmod().getUsr().getInr())&&"F".equals(this.getWrnmod().getWrn().getSta()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000218"),MdaUtils.getI18NString("chkame","CT000219"));
			    return false;
			  }
			  if("2".equals(this.getSysmod().getTransLevel(this.getSysmod().getPty().getCid())))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("chkame","CT000220"),MdaUtils.getI18NString("chkame","CT000221"));
			    return false;
			  }

			  String scr=this.getSysmod().getSpt().getScr();
			  log.info("{}","scr="+scr +",sptinr="+this.getSysmod().getSpt().getInr() );
			  String objtyp=this.getSysmod().getSpt().getObjtyp();
			  String objinr=this.getSysmod().getSpt().getObjinr();
			  String ptyinr=this.getSysmod().getSpt().getPtyinr();
			  String ownref=this.getSysmod().getSpt().getOwnref();
			  log.info("{}","ownref=" +ownref+"   ptyinr=" +ptyinr+"   objinr=" +objinr);

			  log.info("{}",this.getSysmod().getSpt().getScrtxt());
			  this.getTrnmod().sdbRead(this.getWrktrn(),this.getSysmod().getSpt().getScrtxt());
			  String ordinr =this.getWrktrn().getOrdinr();
			  log.info("{}","trn inr="+this.getWrktrn().getInr()+",ordinr="+ordinr);

			  trnSave();

			  this.getTrnmod().sigWrite("O","B");
			  this.getTrnmod().getOrdmod().updateOrd(ordinr,"E","12", this.getRmkmod().getNtext());
			  this.getRmkmod().updateRmk("14");

			  setSpt(objtyp);

			  ctx.getDaoSession().dbDelete(this.getSysmod().getSpt());

			  MdaUtils.clear(this.getWrnmod().getWrn());
			  MdaUtils.clear(this.getSmh());
			  MdaUtils.clear(this.getSysmod().getSpt());
			  MdaUtils.clear(this.getChkspt());
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  MdaUtils.clear(this.getWrktrn());

			  /*if(Platform.errorCode()!= NO_ERROR)
			    {
			    Platform.dbRollback();
			    Platform.message(#CT000238,#CT000239);
			    return false;
			    }
			    else
			    {
			    */
			  ctx.getDaoSession().dbCommit();
			  ctx.setMessage(MdaUtils.getI18NString("chkame","CT000264"),MdaUtils.getI18NString("chkame","CT000302"));
			  MdaUtils.showMainPanel();
			  refresh(false);
			  //}
			}

			return true;
        }

        /**
        *   source:chkame.@0016.script
        */
        @Rule(target="bnkchk",order=100)
        public boolean ruleBnkchkN100(){
            IContext ctx = MdaEnv.getContext();
            
			refresh(false);

			return true;
        }

        /**
        *   source:chkame.@0017.script
        */
        @Rule(target="bsplst",order=200)
        public boolean ruleBsplstN200(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 列表双击时间或者界面点击字段连接时执行
			  */
			for(int i=0;i<this.getBsplst().fullSize();i++)
			{
			  if("X".equals(this.getBsplst().getElement(i).getSelflg()))
			  {
			    this.getBsplst().getElement(i).setSelflg("");
			    
			  }
			}
			int index=0;
			log.debug("{}","evt DblClick bsplst ... index =" + index);
			if(index<0||index>=this.getBsplst().fullSize())
			  return true;

			if(!this.getTrnmod().accessRight(this.getSysmod().getUsr().getInr(),this.getBsplst().getElement(index).getFrm()))
			{
			  log.debug("{}","提示: 无权限访问该交易");
			  return true;
			}

			getBsplst(index);

			if("jsd".equals(this.getSysmod().getSpt().getObjtyp()))
			{
			  //$chkpan.setValue($jstchk);
			}
			else
			{
			  //$chkpan.setValue($witchk);
			}

			if("F".equals(this.getWrnmod().getWrn().getSta()))
			  this.getChkmod().pdfValue(this.getSysmod().getSpt().getObjtyp());
			showDetailPanel(index);

			return true;
        }

        /**
        *   source:chkame.@0018.script
        */
        @Rule(target="chkmod.jsdgrp.rec.getslt",order=100)
        public boolean ruleChkmodJsdgrpRecGetsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getChkmod().getJsdgrp().getRec().getGetslt()))
			{
			  
			  
			  
			  
			  this.getChkmod().getJsdgrp().getRec().setGivslt(NULLSTR);
			  ctx.postRule(this,"chkmod.jsdgrp.rec.givslt");
			}
			else
			{
			  this.getChkmod().getJsdgrp().getRec().setGetamt(new BigDecimal(0));
			  this.getChkmod().getJsdgrp().getRec().setGetdat(null);
			  
			  

			  
			  
			}

			
			
			

			return true;
        }

        /**
        *   source:chkame.@0019.script
        */
        @Rule(target="chkmod.jsdgrp.rec.givslt",order=100)
        public boolean ruleChkmodJsdgrpRecGivsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getChkmod().getJsdgrp().getRec().getGivslt()))
			{
			  
			  

			  this.getChkmod().getJsdgrp().getRec().setGetslt(NULLSTR);
			  ctx.postRule(this,"chkmod.jsdgrp.rec.getslt");
			}
			else
			{
			  this.getChkmod().getJsdgrp().getRec().setGivamt(new BigDecimal(0));
			  
			  
			}
			
			

			return true;
        }



        /**
        *   source:chkame.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","init chkame..");

			MdaUtils.clear(this.getBsplst());
			String ptyinr=this.getSysmod().getPty().getInr();
			String lvl=this.getSysmod().getPty().getLvl();
			String ptytyp=ctx.absGet(Sysmod.class).getPty().getPtytyp();
			if("0".equals(ptytyp))
			{
			  this.getBtnmod().setBegdat(MdaUtils.add(MdaUtils.today(),-15));
			  this.getBtnmod().setEnddat(MdaUtils.today());

			  this.getBtnmod().setSptlev1(MdaUtils.getI18NString("chkame","CT000030"));
			  MdaUtils.setValues(this.getBtnmod(),"trntyp",MdaUtils.getCodetable("chkamm"));
			  this.getBtnmod().setSptlev("2");
			  log.info("{}","pty-cid   = " + this.getSysmod().getPty().getCid());
			  List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			  log.info("{}","bchcod-size  = " + bchcod.size());
			  MdaUtils.setValues(this.getBtnmod(),"ptynam",bchcod);
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getBtnmod().setPtynam(bchcod.get(0).getValue());
			  log.info("{}","      $btnmod-----ptynam = " + this.getBtnmod().getPtynam());
			}
			else
			  this.getBtnmod().initQurtPanel();

			refresh(false);
			log.info("{}","init chkame end..");

			return true;
        }


        /**
        *   source:chkame.@0001.script
        */
        public void refresh(boolean usrCaulse)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			MdaUtils.clear(this.getBsplst());
			String ptyinr=this.getSysmod().getPty().getInr();
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String lvl=this.getSysmod().getTransLevel(this.getSysmod().getPty().getCid());
			log.info("{}","ptyinr  = " + ptyinr + "-----ptytyp  = " + ptytyp + "----- lvl  = " + lvl);

			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> objnam =new Argument<String>("objnam");
			Argument<String> frm=new Argument<String>("frm");
			Argument<String> nxtlev=new Argument<String>("nxtlev");
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> ordinr =new Argument<String>("ordinr");
			Argument<String> scrtxt =new Argument<String>("scrtxt");
			Argument<String> trncur =new Argument<String>("trncur");
			Argument<BigDecimal> trnamt =new Argument<BigDecimal>("trnamt");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> relreq =new Argument<String>("relreq");
			Argument<String> relres =new Argument<String>("relres");
			Argument<String> objtyp = new Argument<String>("objtyp");
			Argument<String> objinr = new Argument<String>("objinr");
			//String sql="SELECT inr,ownref,objnam,cfmdattim,sta FROM trn WHERE sta='A' AND ptyinr='"+ptyinr+"'";
			String sql="SELECT s.inr,s.ownref,s.objnam,s.frm,s.nxtlev,s.dattim,s.ordinr,s.scrtxt,s.trncur,s.trnamt,pty.nam,s.relreq,s.relres,s.objtyp,s.objinr FROM pty,spt s"
			  +" WHERE scr='S' AND sta='M' AND s.ptyinr=pty.inr";
			if(usrCaulse)
			{
			  sql = sql+" AND dattim>=? AND dattim<=?";
			}
			String con=" ";

			//交易状态
			if(!"2".equals(this.getBtnmod().getSptlev()) && MdaUtils.isEmpty(this.getBnkchk()))
			{
			  sql =sql+" and s.nxtlev='"+this.getBtnmod().getSptlev()+"'";
			}

			if("0".equals(ptytyp))
			{
			  String pinr=this.getBtnmod().getPtynam();
			  log.info("{}","ptynam   = " + pinr);
			  String cid=this.getSysmod().getCidByInr(pinr);
			  if("0".equals(lvl))
			  {
			    String lev=this.getSysmod().getTransLevel(cid);
			    if("0".equals(lev))
			    {
			      sql=sql+con+ "AND EXISTS (SELECT inr FROM pty WHERE  oprogninr=inr AND ptytyp='0' or oprogninr='"+this.getBtnmod().getPtynam()+"')";
			    }
			    else if("1".equals(lev))
			    {
			      sql=sql+con+ "AND EXISTS (SELECT inr FROM pty WHERE  oprogninr=inr AND ptytyp='0' AND pntinr='"+cid+"' or oprogninr='"+this.getBtnmod().getPtynam()+"')";

			    }
			    else
			    {
			      sql=sql+con+ "AND oprogninr='"+this.getBtnmod().getPtynam()+"'";
			    }
			  }
			  else if("1".equals(lvl))
			  {
			    String lev=this.getSysmod().getTransLevel(cid);
			    if("1".equals(lev))
			    {
			      sql=sql+con+ "AND EXISTS (SELECT inr FROM pty WHERE  oprogninr=inr AND ptytyp='0' AND pntinr='"+cid+"' or oprogninr='"+this.getBtnmod().getPtynam()+"')";
			    }
			    else
			    {
			      sql=sql+con+ "AND oprogninr='"+this.getBtnmod().getPtynam()+"'";
			    }
			  }
			  else
			  {
			    sql=sql+con+ "AND oprogninr='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+con+ "AND ptyinr='"+ptyinr+"'";
			}

			if(!MdaUtils.isEmpty(this.getBtnmod().getTrntyp()))
			{
			  sql=sql+con+"AND frm = '"+this.getBtnmod().getTrntyp()+"'";
			}

			//已复核标志
			if(!MdaUtils.isEmpty(this.getBnkchk()))
			{
			  sql =sql+" AND EXISTS (SELECT inr FROM wrn WHERE wrninr=inr AND owninr='"+this.getSysmod().getUsr().getInr()+"' AND sta='F' )";
			}
			else
			{
			  sql =sql+" AND NOT EXISTS (SELECT inr FROM wrn WHERE wrninr=inr AND owninr='"+this.getSysmod().getUsr().getInr()+"'  AND sta='F')";
			}

			sql=sql+con+"ORDER BY dattim DESC";
			if(usrCaulse)
			{
			  ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getBtnmod().getBegdat(),GT),MdaUtils.sqlDate(this.getBtnmod().getEnddat(),LT));
			}
			else
			{
			  ctx.getDaoSession().dbExecuteSQL(sql);
			}
			log.info("{}","do sql end..");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,objnam,frm,dattim,ordinr,nxtlev,scrtxt,trncur,trnamt,nam,relreq,relres,objtyp,objinr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {

			    this.getBsplst().add(inr,ownref,objnam,frm,dattim,ordinr,nxtlev,scrtxt,trncur,trnamt,nam,relreq,relres,objtyp,objinr);
			  }
			  else
			    break;
			}
			log.info("{}","add list  end..");
			ctx.getDaoSession().dbCloseCursor();
			
			this.getRmkmod().setOtext(NULLSTR);
			this.getRmkmod().setNtext(NULLSTR);
		}
        /**
        *   source:chkame.@0007.script
        */
        public void getBsplst(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sptinr = this.getBsplst().getElement(index).getInr();
			MdaUtils.clear(this.getSysmod().getSpt());
			MdaUtils.clear(this.getWrnmod().getWrn());
			ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument<Object>("inr",sptinr));
			ctx.getDaoSession().dbRead(this.getWrnmod().getWrn(),new Argument<Object>("inr",this.getSysmod().getSpt().getWrninr()));
		}
        /**
        *   source:chkame.@0008.script
        */
        public void showDetailPanel(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in showDetailPanel .... index= " + index);
			//业务编号关联影像信息
			String sptinr = this.getBsplst().getElement(index).getInr();
			String trninr=this.getBsplst().getElement(index).getScrtxt();
			String ordinr = this.getBsplst().getElement(index).getOrdinr();
			this.setTrninr(trninr);
			
			MdaUtils.clear(this.getSysmod().getSpt());
			ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument<Object>("inr",sptinr ));
			log.info("{}","trninr=" +this.getTrninr()+",index=" + index + ",sptinr" + sptinr+",ordinr="+ordinr);
			//加载备注信息
			this.getRmkmod().loadRemarkByOrd(ordinr);
			//初始化按钮
			this.getBtnmod().initDocumentButton(ordinr);
			// 报文草稿按钮显示
			
			//加载数据
			this.getChkmod().loadMessage(this.getSysmod().getSpt().getObjtyp(),this.getWrnmod().getWrn().getSta());

			log.info("{}",this.getChkpan());
			
		}
        /**
        *   source:chkame.@0013.script
        */
        public void submitReviewed()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ordinr=this.getSysmod().getSpt().getOrdinr(); // 订单号
			String objinr=this.getSysmod().getSpt().getInr();  // 业务表主键
			String ptyinr=this.getSysmod().getSpt().getPtyinr();   // 企业客户PTY主键
			String owninr=this.getSysmod().getUsr().getInr();    //操作员主键
			String frm=this.getSysmod().getSpt().getFrm();     // 交易代码
			
			log.info("{}","sptinr="+this.getSysmod().getSpt().getInr()+",frm="+ frm +",ptyinr="+ptyinr+",ordinr="+ordinr);

			// 业务流程处理
			this.getWrnmod().getWrn().setInr(Platform.sdbCounter("wrn"));
			this.getWrnmod().getWrn().setOwninr(owninr);
			this.getWrnmod().getWrn().setPtyinr(ptyinr);
			this.getWrnmod().getWrn().setSptinr(objinr);
			this.getWrnmod().getWrn().setSta("F");
			this.getWrnmod().getWrn().setFdodat(MdaUtils.today());
			this.getWrnmod().getWrn().setWrnfrm(frm);
			ctx.getDaoSession().dbInsert(this.getWrnmod().getWrn());

			// 更新待办记录
			//String nxtlev=$sysmod\\spt\\nxtlev.getValue()+1;
			int nxtlev=MdaUtils.parseInt(this.getSysmod().getSpt().getNxtlev())+ 1;
			log.debug("{}","值nxtlev     ="+nxtlev);
			this.getSysmod().getSpt().setWrninr(this.getWrnmod().getWrn().getInr());
			this.getSysmod().getSpt().setNxtlev(String.valueOf(nxtlev));
			ctx.getDaoSession().dbUpdate(this.getSysmod().getSpt());
			// 记录ORE操作信息
			this.getTrnmod().getOrdmod().updateOrd(this.getSysmod().getSpt().getOrdinr(),"E","11",this.getRmkmod().getNtext());
			// 更新交易备注信息
			this.getRmkmod().updateRmk("13");

			//更新业务表
			if("jsd".equals(this.getSysmod().getSpt().getObjtyp()))
			  ctx.getDaoSession().dbUpdate(this.getChkmod().getJsdgrp().getRec());
			else
			  ctx.getDaoSession().dbUpdate(this.getChkmod().getWidgrp().getRec());
		}
        /**
        *   source:chkame.@0014.script
        */
        public void trnSave()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 银行端的业务流水
			  */
			this.getTrnmod().getTrn().setOwnref(this.getWrktrn().getOwnref());
			this.getTrnmod().getTrn().setInifrm(this.getWrktrn().getInifrm());
			this.getTrnmod().getTrn().setOrdinr(this.getWrktrn().getOrdinr());
			this.getTrnmod().getTrn().setOriinr(this.getWrktrn().getInr());
			this.getTrnmod().getTrn().setObjnam(this.getWrktrn().getObjnam());
			this.getTrnmod().getTrn().setObjtyp(this.getWrktrn().getObjtyp());
			this.getTrnmod().getTrn().setObjinr(this.getWrktrn().getObjinr());
			this.getTrnmod().getTrn().setReloricur(this.getWrktrn().getReloricur());
			this.getTrnmod().getTrn().setReloriamt(this.getWrktrn().getReloriamt());
			this.getTrnmod().getTrn().setRelcur(this.getWrktrn().getRelcur());
			this.getTrnmod().getTrn().setRelamt(this.getWrktrn().getRelamt());
			this.getTrnmod().getTrn().setNam(this.getWrktrn().getNam());
			this.getTrnmod().getTrn().setIniusr( this.getSysmod().getUsr().getInr());
			this.getTrnmod().getTrn().setPtyinr( this.getWrktrn().getPtyinr());
			this.getTrnmod().getTrn().setEtyinr( this.getWrktrn().getEtyinr());
			this.getTrnmod().getTrn().setEtginr(this.getWrktrn().getEtginr());
			this.getTrnmod().getTrn().setCpldattim(MdaUtils.today());
			this.getTrnmod().getTrn().setBchcod(this.getWrktrn().getBchcod());
			this.getTrnmod().getTrn().setOptptyinr(this.getWrktrn().getOptptyinr());
			this.getTrnmod().getTrn().setOptetyinr(this.getWrktrn().getOptetyinr());
			this.getTrnmod().getTrn().setOptetginr(this.getWrktrn().getOptetginr());
			this.getTrnmod().getTrn().setInidattim(this.getWrktrn().getInidattim());
			this.getTrnmod().getTrn().setModtyp( this.getWrktrn().getModtyp());
			this.getTrnmod().getTrn().setPtytyp( "0");
			String inifrm=this.getWrktrn().getInifrm();
			log.info("{}","inifrm="+inifrm );
			this.getTrnmod().loadPtyaut(inifrm);
			String relreq=this.getTrnmod().getPtyaut().getFlg();
			log.info("{}","flag="+relreq);
			if(MdaUtils.isEmpty(relreq))
			{
			  relreq = "O";
			}
			this.getTrnmod().getTrn().setRelreq(relreq);
			this.getTrnmod().getTrn().setRelres(relreq.substring(0,1));
			int len=relreq.length();
			this.getTrnmod().getTrn().setNxtlev("");
			this.getTrnmod().getTrn().setNxtreq("");
			this.getTrnmod().getTrn().setSta("A");

			this.getTrnmod().getTrn().setInr(Platform.sdbCounter("trn"));

			ctx.getDaoSession().dbInsert(this.getTrnmod().getTrn());

			this.getWrktrn().setSta("A");
			ctx.getDaoSession().dbUpdate(this.getWrktrn());

			String target=null;
			String rootpath=ctx.getEnvConfig().getRootPath();
			String filename = this.getSysmod().createFilename(this.getWrktrn().getInr(),"zul");
			target = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}", "filename="+filename+",and target="+target);
			MdaUtils.fileCopy(filename,target);

			String sfile = ctx.absGet(Sysmod.class).createFilename(this.getWrktrn().getInr(),"dra");
			String tfile = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"dra");
			if(MdaUtils.fileExists(sfile))
			  MdaUtils.fileCopy(sfile,tfile);

			String sappfile = ctx.absGet(Sysmod.class).createFilename(this.getWrktrn().getInr(),"app");
			String tappfile = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"app");
			if(MdaUtils.fileExists(sappfile))
			  MdaUtils.fileCopy(sappfile,tappfile);
		}
        /**
        *   source:chkame.@0015.script
        */
        public void backSptToSubPty()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWrkspt().setSta("B");
			this.getWrkspt().setOprogninr(this.getSysmod().getSpt().getOprogninr());
			this.getWrkspt().setSmhinr(this.getSysmod().getSpt().getSmhinr());
			this.getWrkspt().setPtyinr(this.getSysmod().getSpt().getPtyinr());
			this.getWrkspt().setOprusrinr(this.getWrktrn().getIniusr());
			this.getWrkspt().setObjtyp(this.getWrktrn().getObjtyp());
			this.getWrkspt().setObjinr(this.getWrktrn().getObjinr());
			this.getWrkspt().setOwnref(this.getWrktrn().getOwnref());
			this.getWrkspt().setFrm(this.getWrktrn().getInifrm());
			this.getWrkspt().setDattim(new Date());
			this.getWrkspt().setOrdinr(this.getWrktrn().getOrdinr());
			String ptytyp=this.getSysmod().getOrderOwnnerTyp(this.getWrktrn().getOrdinr());
			if("3".equals(ptytyp))
			  this.getWrkspt().setScr("S");
			else
			  this.getWrkspt().setScr("I");
			log.debug("{}","oerder sub ptytyp="+ptytyp);
			this.getWrkspt().setScrtxt(this.getWrktrn().getInr());
			this.getWrkspt().setScrpty(this.getSysmod().getPty().getInr());
			//$wrkspt\\nam.setValue($wrkspt\\nam.getValue());
			this.getWrkspt().setObjnam(this.getWrktrn().getObjnam());
			//201710退回时存trncur,trnamt,nam,供退回夹展示列表
			this.getWrkspt().setNam(this.getWrktrn().getNam());
			this.getWrkspt().setTrnamt(this.getWrktrn().getReloriamt());
			this.getWrkspt().setTrncur(this.getWrktrn().getReloricur());
			//如果有影像信息，退回时应该存影像批次号
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument("trninr",this.getWrktrn().getInr()));
			log.debug("{}","imgref=" +this.getWrkspt().getImgref());
			this.getWrkspt().setImgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			this.getWrkspt().setInr(Platform.sdbCounter("spt"));
			ctx.getDaoSession().dbInsert(this.getWrkspt());
			//get the dat
			
			String filename=this.getSysmod().createFilename(this.getWrktrn().getInr(),"dat");
			log.debug("{}",filename);
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("chkame","CT000223"));
			  return;
			}

			String tarfile=this.getSysmod().createFilename(this.getWrkspt().getInr(),"bak");
			log.debug("{}","tarfile path="+tarfile);
			IStream ts=this.getTemstm();
			MdaUtils.streamLoad(ts,filename);
			MdaUtils.streamSave(ts,tarfile);
		}
        /**
        *   source:chkame.@0021.script
        */
        public void setBankWorkFlow(String argtyp,String arginr,String argfrm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getWfmmod().getWfs().setObjtyp(argtyp);
			this.getTrnmod().getWfmmod().getWfs().setObjinr(arginr);
			this.getTrnmod().getWfmmod().getWfs().setWfstxt(this.getTrnmod().getTrnService(argfrm));
			this.getTrnmod().getWfmmod().getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfs());

			ctx.getDaoSession().dbRead(this.getMsg(),new Argument<Object>("frm",argfrm));
			String inrs=this.getMsg().getInr();

			log.debug("{}","msg inr is  :"+inrs);
			String tels=this.getMsg().getMobile();
			if("X".equals(this.getMsg().getEmlflg())&&!MdaUtils.isEmpty(this.getMsg().getEml()))//邮件工作流
			{
			  addWfe("E","W",inrs,"N");
			}

			if("X".equals(this.getMsg().getMsgflg())&&!MdaUtils.isEmpty(this.getMsg().getMobile()))//短信工作流
			{
			  tels = tels.replaceAll(";",",");
			  String[] tel = tels.split(",");
			  for(String t:tel)
			  {
			    addWfe("M","W",inrs,t);
			  }
			}
			log.info("{}","OUT setworkflow ");
		}
        /**
        *   source:chkame.@0022.script
        */
        public void addWfe(String argsvr,String argsta,String inrs,String t)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getWfmmod().getWfe().setWfsinr(this.getTrnmod().getWfmmod().getWfs().getInr());
			this.getTrnmod().getWfmmod().getWfe().setSrv(argsvr);
			this.getTrnmod().getWfmmod().getWfe().setSta(argsta);
			this.getTrnmod().getWfmmod().getWfe().setDattim(new Date());
			this.getTrnmod().getWfmmod().getWfe().setManflg("0");
			this.getTrnmod().getWfmmod().getWfe().setSrvtxt(inrs);

			this.getTrnmod().getWfmmod().getWfe().setTardattim(new Date());

			if(!"N".equals(t))
			{
			  this.getTrnmod().getWfmmod().getWfe().setTxt(t);
			}

			String inr=Platform.sdbCounter("wfe");
			log.debug("{}","wfe inr is "+inr);
			this.getTrnmod().getWfmmod().getWfe().setInr(inr);
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfe());
			MdaUtils.clear(this.getTrnmod().getWfmmod().getWfe());
		}
        /**
        *   source:chkame.@0028.script
        */
        public void setSpt(String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			log.info("{}","in chkame.createSpt...");
			MdaUtils.clear(this.getChkspt());

			this.getChkspt().setPtyinr(this.getSysmod().getSpt().getPtyinr());
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getOprogninr()))
			  this.getChkspt().setOprogninr(this.getSysmod().getSpt().getOprogninr());

			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getOwnref()))
			{
			  this.getChkspt().setOwnref(this.getSysmod().getSpt().getOwnref());
			}
			else
			{
			  if("jsd".equals(objtyp))
			    this.getChkspt().setOwnref(this.getChkmod().getJsdgrp().getRec().getOwnref());
			  else
			    this.getChkspt().setOwnref(this.getChkmod().getWidgrp().getRec().getOwnref());
			}

			this.getChkspt().setObjtyp(objtyp);
			this.getChkspt().setObjinr(this.getSysmod().getSpt().getObjinr());
			this.getChkspt().setTrnamt(this.getSysmod().getSpt().getTrnamt());
			this.getChkspt().setTrncur(this.getSysmod().getSpt().getTrncur());

			String namspt=ctx.absGet(Trnmod.class).getPtyName(this.getChkspt().getPtyinr());
			this.getChkspt().setNam(namspt);

			this.getChkspt().setScr("A");
			this.getChkspt().setSta("T");

			this.getChkspt().setDattim(MdaUtils.today());
			this.getChkspt().setInr(Platform.sdbCounter("spt"));

			String ownref="";
			String stlref="";
			if("jsd".equals(objtyp))
			{
			  this.getChkmod().getJsdgrp().getRec().setPaysta("0");
			  this.getChkmod().getJsdgrp().getRec().setGivsty(this.getChkmod().getJsdgrp().getRec().getNewgivsty());
			  ctx.getDaoSession().dbUpdate(this.getChkmod().getJsdgrp().getRec());

			  this.getChkspt().setFrm("jstsev");
			  ownref=this.getChkmod().getJsdgrp().getRec().getOwnref();
			  stlref=this.getChkmod().getJsdgrp().getRec().getStlref();
			}
			else
			{
			  this.getChkmod().getWidgrp().getRec().setSta("1");
			  ctx.getDaoSession().dbUpdate(this.getChkmod().getWidgrp().getRec());

			  this.getChkspt().setFrm("witmav");
			  ownref=this.getChkmod().getWidgrp().getRec().getOwnref();
			  stlref=this.getChkmod().getWidgrp().getRec().getStlref();
			}

			setSMH(objtyp,ownref,stlref);   //存smh表
			
			this.getChkspt().setSmhinr(this.getSmh().getInr());
			ctx.getDaoSession().dbInsert(this.getChkspt());
			setBankWorkFlow("spt",this.getChkspt().getInr(),this.getChkspt().getFrm()); //邮件及短信
			
			log.debug("{}","SAV SPT {inr:" + this.getChkspt().getInr() +",objinr:" + this.getChkspt().getObjinr() + ",objtyp:"+ this.getChkspt().getObjtyp() + ",smhinr:"+ this.getChkspt().getSmhinr() + "}") ;
			// 保存 数据文件
			MdaUtils.clear(this.getTemstm());
			IStream os = this.getTemstm();

			IModule mod= MdaDriver.getModule(this,this.getChkmod(),objtyp+"grp");
			MdaUtils.saveData(mod,os);
			String fileName = ctx.absGet(Sysmod.class).createFilename(this.getChkspt().getInr(),"bak");
			MdaUtils.streamSave(os,fileName);
			log.debug("{}","out submit ... ");

		}
        /**
        *   source:chkame.@0029.script
        */
        public void setSMH(String objtyp,String ownref,String stlref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 存储SMH记录
			  */
			log.info("{}","smh insert...");

			this.getSmh().setObjtyp(objtyp);
			log.debug("{}","smh..objtyp"+this.getSmh().getObjtyp());

			this.getSmh().setObjinr(this.getChkspt().getObjinr());

			this.getSmh().setMsgtyp("1");
			this.getSmh().setMsgsta("1");

			//String docpath=Platform.catPath(Platform.getRootPath(),"data/backup/arc");
			//docpath=Platform.catPath(docpath,Platform.format(Platform.today(),"yyyyMMdd"));
			//log.debug("arc");
			//$smh\\docpth.setValue(docpath);
			//$smh\\dir.setValue("I");
			ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument("trninr",this.getWrktrn().getInr()));
			if(MdaUtils.isEmpty(this.getTrnmod().getItfmod().getImgmod().getImg().getInr()))
			{
			  this.getSmh().setCreusr("");
			}
			else
			{
			  this.getSmh().setCreusr(this.getTrnmod().getItfmod().getImgmod().getImg().getInr());
			}
			this.getSmh().setResnum("");
			this.getSmh().setCredattim(MdaUtils.today());
			this.getSmh().setInr(Platform.sdbCounter("smh"));
			this.getSmh().setF20(ownref);
			this.getSmh().setF21(stlref);
			log.debug("{}","f20==============="+ownref);
			log.debug("{}","f21==============="+stlref);
			ctx.getDaoSession().dbInsert(this.getSmh());
			log.info("{}","setSMH...end");

		}






















}