package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.ComadvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Comgrp;
import com.ceb.gjjs.mda.manager.module.Comp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Commod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 公共报文通知
*/
@Transaction(vo= ComadvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Comadv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Comadv.class);

        //转通知
        private transient IControl trans = new ControlImpl("trans", "转通知", this);
        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);
        //附件
        private transient IControl attachment = new ControlImpl("attachment", "附件", this);
        //刷新
        private transient IControl refresh = new ControlImpl("refresh", "刷新", this);
		@BDGetter
		private Commod commod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Comgrp comgrp;

		@BDGetter
		private Comp comp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Comadv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCommod().setComgrpHolder(()->this.getComgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Comadv.this.getComgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Comadv.this.getComgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.bchcod");}
 				public void setValue(String arg){Comadv.this.getComgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Comadv.this.getComgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.cur");}
 				public void setValue(String arg){Comadv.this.getComgrp().getRec().setCur(arg);}
 				public String getValue(){return Comadv.this.getComgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.inr");}
 				public void setValue(String arg){Comadv.this.getComgrp().getRec().setInr(arg);}
 				public String getValue(){return Comadv.this.getComgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.ownref");}
 				public void setValue(String arg){Comadv.this.getComgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Comadv.this.getComgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("comgrp.rec.ptyinr");}
 				public void setValue(String arg){Comadv.this.getComgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Comadv.this.getComgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Comadv.this.getFieldPath("commod.comgrp.rec.stlref");}
 				public void setValue(String arg){Comadv.this.getCommod().getComgrp().getRec().setStlref(arg);}
 				public String getValue(){return Comadv.this.getCommod().getComgrp().getRec().getStlref();}}
			 );
           this.getComp().setComgrpHolder(()->this.getComgrp());
           this.getMtabut().setRecHolder(()->this.getComgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:comadv.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:comadv.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getComp().getComp02());

			return true;
        }

        /**
        *   source:comadv.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }














}