package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CommarVO;

import com.ceb.gjjs.mda.manager.module.Marp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Marmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保证金委托扣划申请
*/
@Transaction(vo= CommarVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Commar extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Commar.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Margrp margrp;

		@BDGetter
		private Marmod marmod;

		@BDGetter
		private Marp marp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Commar()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMarmod().setMargrpHolder(()->this.getMargrp());
           this.getMarp().setMargrpHolder(()->this.getMargrp());
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Commar.this.getFieldPath("margrp.mar.bchcod");}
 				public void setValue(String arg){Commar.this.getMargrp().getMar().setBchcod(arg);}
 				public String getValue(){return Commar.this.getMargrp().getMar().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Commar.this.getFieldPath("margrp.mar.inr");}
 				public void setValue(String arg){Commar.this.getMargrp().getMar().setInr(arg);}
 				public String getValue(){return Commar.this.getMargrp().getMar().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Commar.this.getFieldPath("margrp.mar.ref");}
 				public void setValue(String arg){Commar.this.getMargrp().getMar().setRef(arg);}
 				public String getValue(){return Commar.this.getMargrp().getMar().getRef();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Commar.this.getFieldPath("margrp.mar.ptyinr");}
 				public void setValue(String arg){Commar.this.getMargrp().getMar().setPtyinr(arg);}
 				public String getValue(){return Commar.this.getMargrp().getMar().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Commar.this.getFieldPath("margrp.mar.ref");}
 				public void setValue(String arg){Commar.this.getMargrp().getMar().setRef(arg);}
 				public String getValue(){return Commar.this.getMargrp().getMar().getRef();}}
			 );
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new java.math.BigDecimal("0")));
           this.getMtabut().setRecHolder(()->this.getMargrp().getMar());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("MZ"));
        }

        /**
        *   source:commar.@0000.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","commar",stream,false );

			return true;
        }

        /**
        *   source:commar.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getMargrp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("commar","CT000016"),MdaUtils.getI18NString("commar","CT000017"));
			  return false;
			}
			if(!this.getMarp().checkMxdlist())
			{
			  log.debug("{}","mxdlist check error!");
			  return false;
			}

			if(MdaUtils.isEmpty(this.getMargrp().getMar().getInr()))
			{
			  //$margrp\\bxd\\inr.setValue(Platform.sdbCounter("bxd"));
			  this.getMargrp().getMar().setInr(Platform.sdbCounter("mar"));

			  //$margrp\\bxd\\objtyp.setValue("mar");
			  //$margrp\\bxd\\objinr.setValue($margrp\\mar\\inr.getValue());
			  //$margrp\\mar\\stlref.setValue();
			
			  //Platform.dbInsert($margrp\\bxd);
			  ctx.getDaoSession().dbInsert(this.getMargrp().getMar());
			}
			else
			{
			  //$margrp\\bxd\\objtyp.setValue("mar");
			  //$margrp\\bxd\\objinr.setValue($margrp\\mar\\inr.getValue());
			
			  //Platform.dbUpdate($margrp\\bxd);
			  ctx.getDaoSession().dbUpdate(this.getMargrp().getMar());
			}

			//保证金账户扣划信息入库
			int size=this.getMargrp().getMxdlst().fullSize();
			for(int i=0;i<size;i++)
			{
			  if(MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getInr()))
			  {
			    this.getMargrp().getMxd().copyValue(this.getMargrp().getMxdlst().get(i));
			    this.getMargrp().getMxd().setInr(Platform.sdbCounter("mxd"));
			    this.getMargrp().getMxd().setObjtyp("mar");
			    this.getMargrp().getMxd().setObjinr(this.getMargrp().getMxd().getInr());
			    ctx.getDaoSession().dbInsert(this.getMargrp().getMxd());
			  }
			  else
			  {
			    log.info("{}","update mxd");
			    ctx.getDaoSession().dbUpdate(this.getMargrp().getMxdlst().getElement(i));
			  }
			}

			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:commar.@0003.script
        */
        @Rule(target="margrp.dap.pts.adrblk",order=100)
        public boolean ruleMargrpDapPtsAdrblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMarp().getAplp().refreshApl(this.getMargrp());

			return true;
        }

        /**
        *   source:commar.@0004.script
        */
        @Rule(target="mtabut.getref",order=200)
        public boolean ruleMtabutGetrefN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","ownref"+this.getMargrp().getMar().getOwnref());
			log.debug("{}","prefix"+this.getMtabut().getPrefix());
			this.getMargrp().getMar().setRef(this.getMargrp().getMar().getOwnref());
			

			return true;
        }



        /**
        *   source:commar.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getMargrp().getMar(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getMargrp().getMar().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			String seltyp= (ctx.restoreData("com.brilliance.commar.seltyp")).toString();
			IModule rec = (IModule)ctx.restoreData("com.brilliance.commar.ref");
			
			if("0".equals(seltyp))
			{// 新建
			  this.getMargrp().getMar().setRef(NULLSTR);
			  
			}
			else if("1".equals(seltyp)  ||  "2".equals(seltyp))
			{
			  if(!MdaUtils.isEmpty(rec))
			    this.getLidgrp().getRec().copyValue(rec);
			  this.getMargrp().getMar().setRef(this.getLidgrp().getRec().getStlref());
			}
			else
			{
			  if(!MdaUtils.isEmpty(rec))
			    this.getGidgrp().getRec().copyValue(rec);
			  this.getMargrp().getMar().setRef(this.getGidgrp().getRec().getStlref());
			}
			//  $margrp\\mar\\marcur1.setValue("USD");
			//$margrp\\mar\\marcur2.setValue("USD");
			//$margrp\\mar\\marcur3.setValue("USD");
			//$margrp\\mar\\credat.setValue(Platform.today());
			//$margrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			return true;
        }












}