package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Commar0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gidgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保证金委托扣划申请查询入口
*/
@Transaction(vo= Commar0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Commar0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Commar0.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Gidgrp gidgrp;


		public Commar0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:commar0.@0000.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //信用证记录
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.issamt as amt,rec.isscur as cur,s.adrblk as bennam FROM lid rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='lid' and s.rol='ben'"
			    +ctx.absGet(Sysmod.class).getSelection();
			}
			else if("2".equals(seltyp))
			{
			  //保函记录
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.lgamt as amt,rec.lgcur as cur,s.adrblk as bennam FROM gid rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='gid' and s.rol='ben' "
			    +ctx.absGet(Sysmod.class).getSelection();
			}

			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:commar0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp)  ||  "2".equals(seltyp))
			{

			  this.getSelp().sureBtn("lidgrp","commar");
			}
			else
			{
			  this.getSelp().sureBtn("gidgrp","commar");
			}
			ctx.storeData("com.brilliance.commar.seltyp",seltyp);

			return true;
        }

        /**
        *   source:commar0.@0003.script
        */
        @Rule(target="selp.newapply",order=100)
        public boolean ruleSelpNewapplyN100(){
            IContext ctx = MdaEnv.getContext();
            

			ctx.storeData("com.brilliance.commar.seltyp","0");
			

			return true;
        }

        /**
        *   source:commar0.@0004.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp)  ||  "2".equals(seltyp))
			{

			  this.getSelp().sureBtn("lidgrp","commar");
			}
			else
			{
			  this.getSelp().sureBtn("gidgrp","commar");
			}
			ctx.storeData("com.brilliance.commar.seltyp",seltyp);

			return true;
        }



        /**
        *   source:commar0.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selcommar"));
			this.getSelp().setSeltyp("1");
			String queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.issamt as amt,rec.isscur as cur,s.adrblk as bennam FROM lid rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='lid' and s.rol='ben'"
			  +ctx.absGet(Sysmod.class).getSelection();
			// WHERE ptyinr='"+$sysmod\\pty\\inr.getValue()+"'";
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}