package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.ComselVO;

import com.ceb.gjjs.mda.manager.module.Custme;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Gid;
import com.ceb.gjjs.mda.manager.module.Trncpd;
import com.ceb.gjjs.mda.manager.module.Benpage;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.manager.module.Sptall;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Cpd;
import com.ceb.gjjs.mda.manager.module.Ptsplst;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.manager.module.Gidtapag;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pts;
import com.ceb.gjjs.mda.bo.Ptr;
import com.ceb.gjjs.mda.bo.Payee;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rellst;
import com.ceb.gjjs.mda.manager.module.Gidpage;
import com.ceb.gjjs.mda.bo.Bopcod;
import com.ceb.gjjs.mda.bo.Ptl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 公共查询
*/
@Transaction(vo= ComselVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Comsel extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Comsel.class);

        //待授权
        private transient IControl trnsel = new ControlImpl("trnsel", "待授权", this);
        //退回夹查询
        private transient IControl baksel = new ControlImpl("baksel", "退回夹查询", this);
        //待办查询
        private transient IControl todosel = new ControlImpl("todosel", "待办查询", this);
        //过程查询
        private transient IControl stagesel = new ControlImpl("stagesel", "过程查询", this);
        //历史查询
        private transient IControl hissel = new ControlImpl("hissel", "历史查询", this);
        //银行处理中
        private transient IControl bnksel = new ControlImpl("bnksel", "银行处理中", this);
        //审核中(银行处理中+历史)
        private transient IControl bnkhis = new ControlImpl("bnkhis", "审核中(银行处理中+历史)", this);
        //受益人查询
        private transient IControl bensel = new ControlImpl("bensel", "受益人查询", this);
        //代理行查询
        private transient IControl agtsel = new ControlImpl("agtsel", "代理行查询", this);
        //开始
        private Date begdat;
        //截止日期
        private Date enddat;
        //交易编码
        private transient IControl bopsel = new ControlImpl("bopsel", "交易编码", this);
        //常用账户
        private transient IControl accsel = new ControlImpl("accsel", "常用账户", this);
        //币种
        private String cur;
        //机构编码
        private String extkey;
        //受益人
        private String nam;
        //交易编码
        private String frmcod;
        //排序
        private String order;
        //收款人保存
        private transient IControl payeesav = new ControlImpl("payeesav", "收款人保存", this);
        //受益人账号
        private String pyeact;
        //签约查询
        private transient IControl sigsel = new ControlImpl("sigsel", "签约查询", this);
        //签约状态
        private String sigsta;
        //客户签约版本
        private String cusver;
        //最新版本
        private String newestver;
        //手机银行版本
        private String mbver;
        //退回到汇入查询
        private transient IControl reback = new ControlImpl("reback", "退回到汇入查询", this);
        //保函详情查询
        private transient IControl giddsel = new ControlImpl("giddsel", "保函详情查询", this);
        //保函状态查询
        private transient IControl gidssel = new ControlImpl("gidssel", "保函状态查询", this);
        //申请开始时间
        private Date bendat;
        //业务编号
        private String ownref;
        //业务品种
        private String lgtyp;
        //保函编号
        private String stlref;
        //保函业务状态
        private String gidsta;
        //开立日期开始时间
        private Date obendat;
        //开立日期结束时间
        private Date oenddat;
        //客户地址等信息查询
        private transient IControl custinfo = new ControlImpl("custinfo", "客户地址等信息查询", this);
        //收款人删除
        private transient IControl payeedel = new ControlImpl("payeedel", "收款人删除", this);
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private ModuleList<Trn> trnlist;

		@BDGetter
		private ModuleList<Spt> sptlist;

		@BDGetter
		private ModuleList<Rellst> rellst;

		@BDGetter
		private ModuleList<Pty> ptylst;

		@BDGetter
		private ModuleList<Pta> ptalst;

		@BDGetter
		private ModuleList<Ptr> ptrlst;

		@BDGetter
		private ModuleList<Adr> adrlst;

		@BDGetter
		private ModuleList<Benpage> benpage;

		@BDGetter
		private ModuleList<Cpd> cpdlst;

		@BDGetter
		private ModuleList<Pts> ptslst;

		@BDGetter
		private ModuleList<Sptall> sptall;

		@BDGetter
		private ModuleList<Trncpd> trnhis;

		@BDGetter
		private ModuleList<Act> actlst;

		@BDGetter
		private ModuleList<Bopcod> bopcod;

		@BDGetter
		private ModuleList<Ptsplst> ptsplst;

		@BDGetter
		private Pty pty;

		@BDGetter
		private ModuleList<Usr> usrlst;

		@BDGetter
		private Payee payee;

		@BDGetter
		private ModuleList<Payee> payeelst;

		@BDGetter
		private Payee payeeold;

		@BDGetter
		private Ptl ptl;

		@BDGetter
		private Trn trn;

		@BDGetter
		private Spt spt;

		@BDGetter
		private Cpd cpd;

		@BDGetter
		private Adr adr;

		@BDGetter
		private Pta pta;

		@BDGetter
		private Adr adrold;

		@BDGetter
		private Pty ptyold;

		@BDGetter
		private Pta ptaold;

		@BDGetter
		private Gid gid;

		@BDGetter
		private ModuleList<Gid> gidlst;

		@BDGetter
		private ModuleList<Gidpage> gidpage;

		@BDGetter
		private ModuleList<Gidtapag> gidtapag;

		@BDGetter
		private ModuleList<Trn> trnlst;

		@BDGetter
		private Custme custme;

		@BDGetter
		private Ptr ptr;


		public Comsel()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:comsel.@0000.script
        */
        @Rule(target="baksel",order=100)
        public boolean ruleBakselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getSptall());
			String ptyinr=this.getSysmod().getPty().getInr();
			String ptytyp=this.getSysmod().getPty().getPtytyp();

			List objs = new ArrayList();
			//String sql="SELECT inr,ownref,trncur,trnamt,nam as objnam,frm,dattim,ptyinr,ordinr,scrtxt FROM spt WHERE  sta=? ";
			//汇款交易:收款人信息(LEFT JOIN)
			String sql="FROM m1,m2 " ;
			sql +=  " LEFT JOIN m3 with m2.objinr = m3.inr AND m2.objtyp='cpd'";
			//交易对手
			sql +=  " LEFT JOIN m4 with m4.objtyp='cpd' AND m4.objinr=m3.inr AND m4.rol='ben'  ";
			//用户获取oid
			sql = sql + " LEFT JOIN m5 with m5.inr=m2.iniusr  ";
			sql += " WHERE m1.sta='B' AND m1.scrtxt = m2.inr ";
			sql=sql+" AND m1.ptyinr=? ";
			objs.add(ptyinr);
			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  sql = sql +" AND m1.dattim >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql = sql +" AND m1.dattim <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}
			if(!MdaUtils.isEmpty(this.getFrmcod()))
			{
			  sql += " AND m2.inifrm =? ";
			  objs.add(this.getFrmcod());
			}
			else
			{
			  sql += " AND (m2.inifrm ='cptopn' or m2.inifrm='cptapi')";
			}
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  sql = sql+" ORDER BY m1.dattim  ASC ";
			}
			else
			{
			  sql = sql+" ORDER BY m1.dattim  DESC ";
			}
			//sql=sql+" ORDER BY dattim DESC";
			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getSptlist(),this.getTrnlist(),this.getCpdlst(),this.getPtslst(),this.getUsrlst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000084"),MdaUtils.getI18NString("comsel","CT000085"));
			  return false;
			}
			this.getSptall().setFullSize(this.getSptlist().fullSize());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> objnam =new Argument<String>("objnam");
			Argument<String> frm =new Argument<String>("frm");
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> trncur =new Argument<String>("trncur");
			Argument<BigDecimal> trnamt =new Argument<BigDecimal>("trnamt");
			Argument<String> ptyinr0 = new Argument<String>("ptyinr");
			Argument<String> ordinr = new Argument<String>("ordinr");
			Argument<String> scrtxt = new Argument<String>("scrtxt");
			Argument<String> wfm = new Argument<String>("wfm");
			Argument<String> iniusr = new Argument<String>("iniusr");
			Argument<String> pyeblk =new Argument<String>("pyeblk");
			for(int i=0; i<this.getSptlist().size(); i++)
			{
			  inr.setValue(this.getSptlist().getElement(i).getInr());
			  ownref.setValue(this.getSptlist().getElement(i).getOwnref());
			  objnam.setValue(this.getSptlist().getElement(i).getNam());
			  frm.setValue(this.getSptlist().getElement(i).getFrm());
			  dattim.setValue(this.getSptlist().getElement(i).getDattim());
			  trncur.setValue(this.getSptlist().getElement(i).getTrncur());
			  trnamt.setValue(this.getSptlist().getElement(i).getTrnamt());
			  ptyinr0.setValue(this.getSptlist().getElement(i).getPtyinr());
			  ordinr.setValue(this.getSptlist().getElement(i).getOrdinr());
			  scrtxt.setValue(this.getSptlist().getElement(i).getScrtxt());
			  wfm.setValue(this.getTrnlist().getElement(i).getWfm());
			  iniusr.setValue(this.getUsrlst().getElement(i).getOid());
			  pyeblk.setValue(this.getPtslst().getElement(i).getAdrblk());
			  this.getSptall().add(inr,ownref,objnam,frm,dattim,trncur,ptyinr0,trnamt,ordinr,scrtxt,wfm,iniusr,this.getCpdlst().getElement(i).getPyeact(),pyeblk,this.getCpdlst().getElement(i).getPayeract(),this.getCpdlst().getElement(i).getPaynam());
			}
			

			return true;
        }

        /**
        *   source:comsel.@0001.script
        */
        @Rule(target="trnsel",order=100)
        public boolean ruleTrnselN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();
			this.getRellst().setPaging(true);  // 这里必须要设置UI为可分页的ModuleLis
			
			List objs = new ArrayList();
			String sql="FROM m1 " ;
			//汇款交易:收款人信息(LEFT JOIN)
			sql = sql + " LEFT JOIN m2 with m1.objinr = m2.inr AND m1.objtyp='cpd'";
			//交易对手
			sql = sql + " LEFT JOIN m3 with m3.objtyp='cpd' AND m3.objinr=m2.inr AND m3.rol='ben'  ";
			//用户获取oid
			sql = sql + " LEFT JOIN m4 with m4.inr=m1.iniusr  ";
			sql = sql+"WHERE m1.sta='W' AND m1.ptytyp= ? ";
			objs.add(ptytyp);
			sql = sql + " AND m1.ptyinr= ? " ;
			objs.add(ptyinr);

			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  sql = sql +" AND m1.inidattim >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql = sql +" AND m1.inidattim <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}
			if(!MdaUtils.isEmpty(this.getFrmcod()))
			{
			  sql += " AND m1.inifrm =? ";
			  objs.add(this.getFrmcod());
			}
			else
			{
			  sql += " AND (m1.inifrm ='cptopn' or m1.inifrm='cptapi')";
			}
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  sql = sql+" ORDER BY m1.inidattim  ASC ";
			}
			else
			{
			  sql = sql+" ORDER BY m1.inidattim  DESC ";
			}

			log.debug("{}","after query trn=="+sql);

			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getTrnlist(),this.getCpdlst(),this.getPtslst(),this.getUsrlst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000088"),MdaUtils.getI18NString("comsel","CT000089"));
			  return false;
			}
			log.info("{}","size :"+this.getTrnlist().size()+" fullsize:"+this.getTrnlist().fullSize()+"  paging:"+this.getTrnlist().isPaging()+" page:"+this.getTrnlist().getPage());

			this.getRellst().setFullSize(this.getTrnlist().fullSize());
			//SELECT trn.inr as inr,trn.sta as sta,trn.ownref as ownref,reloricur as cur,reloriamt as amt,trn.nam as objnam,trn.inifrm as inifrm,trn.relres as relres,
			//trn.inidattim as inidattim, trn.nxtlev as nxtlev,trn.ordinr as ordinr,c.pyeact as pyeact,p.adrblk as pyeblk
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> sta =new Argument<String>("sta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> reloricur =new Argument<String>("cur");
			Argument<BigDecimal> reloriamt =new Argument<BigDecimal>("amt");
			Argument<String> objnam =new Argument<String>("objnam");
			Argument<String> inifrm =new Argument<String>("inifrm");
			Argument<String> nxtlev =new Argument<String>("nxtlev");
			Argument<Date> inidattim =new Argument<Date>("inidattim");
			Argument<String> ordinr =new Argument<String>("ordinr");
			Argument<String> relres =new Argument<String>("relres");
			Argument<String> pyeact =new Argument<String>("pyeact");
			Argument<String> pyeblk =new Argument<String>("pyeblk");
			Argument<String> iniusr =new Argument<String>("iniusr");
			for(int i=0; i<this.getTrnlist().size(); i++)
			{
			  objnam.setValue(this.getTrnlist().getElement(i).getNam());
			  pyeblk.setValue(this.getPtslst().getElement(i).getAdrblk());
			  reloricur.setValue(this.getTrnlist().getElement(i).getReloricur());
			  reloriamt.setValue(this.getTrnlist().getElement(i).getReloriamt());
			  iniusr.setValue(this.getUsrlst().getElement(i).getOid());
			  this.getRellst().add(this.getTrnlist().getElement(i).getInr(),this.getTrnlist().getElement(i).getOwnref(),objnam,this.getTrnlist().getElement(i).getInifrm(),this.getTrnlist().getElement(i).getInidattim(),iniusr,this.getCpdlst().getElement(i).getPyeact(),pyeblk,this.getTrnlist().getElement(i).getNxtlev(),this.getTrnlist().getElement(i).getSta(),this.getTrnlist().getElement(i).getWfm(),reloricur,reloriamt,this.getCpdlst().getElement(i).getPayeract(),this.getCpdlst().getElement(i).getPaynam());
			}
			

			return true;
        }

        /**
        *   source:comsel.@0002.script
        */
        @Rule(target="todosel",order=100)
        public boolean ruleTodoselN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:comsel.@0003.script
        */
        @Rule(target="stagesel",order=100)
        public boolean ruleStageselN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:comsel.@0004.script
        */
        @Rule(target="bnksel",order=100)
        public boolean ruleBnkselN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:comsel.@0005.script
        */
        @Rule(target="hissel",order=100)
        public boolean ruleHisselN100(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }

        /**
        *   source:comsel.@0006.script
        */
        @Rule(target="bnkhis",order=100)
        public boolean ruleBnkhisN100(){
            IContext ctx = MdaEnv.getContext();
            
			//历史和银行处理中
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();

			List objs = new ArrayList();
			String sql="FROM m1 " ;
			//汇款交易:收款人信息(LEFT JOIN)
			sql = sql + " LEFT JOIN m2 with m1.objinr = m2.inr AND m1.objtyp='cpd'";
			//交易对手
			sql = sql + " LEFT JOIN m3 with m3.objtyp='cpd' AND m3.objinr=m2.inr AND m3.rol='ben'  ";
			//用户获取oid
			sql = sql + " LEFT JOIN m4 with m4.inr=m1.iniusr  ";
			//交易对手
			sql = sql+"WHERE (m1.sta='A' or m1.sta='R') AND m1.ptytyp= ? ";
			objs.add(ptytyp);
			sql = sql + " AND m1.ptyinr= ? " ;
			objs.add(ptyinr);

			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  sql = sql +" AND m1.inidattim >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql = sql +" AND m1.inidattim <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}
			if(!MdaUtils.isEmpty(this.getFrmcod()))
			{
			  sql += " AND m1.inifrm =? ";
			  objs.add(this.getFrmcod());
			}
			else
			{
			  sql += " AND (m1.inifrm ='cptopn' or m1.inifrm='cptapi')";
			}
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  sql = sql+" ORDER BY m1.inidattim ASC ,m1.cfmdattim DESC ";
			}
			else
			{
			  sql = sql+" ORDER BY m1.inidattim  DESC ,m1.cfmdattim DESC ";
			}
			log.debug("{}","after query trn=="+sql);

			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getTrnlist(),this.getCpdlst(),this.getPtslst(),this.getUsrlst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000086"),MdaUtils.getI18NString("comsel","CT000087"));
			  return false;
			}
			this.getTrnhis().setFullSize(this.getTrnlist().fullSize());
			Argument<String> pyeblk =new Argument<String>("pyeblk");
			Argument<String> iniusr =new Argument<String>("iniusr");
			for(int i=0; i<this.getTrnlist().size(); i++)
			{
			  pyeblk.setValue(this.getPtslst().getElement(i).getAdrblk());
			  iniusr.setValue(this.getUsrlst().getElement(i).getOid());
			  this.getTrnhis().add(this.getTrnlist().getElement(i).getInr(),this.getTrnlist().getElement(i).getOwnref(),this.getTrnlist().getElement(i).getStlref(),this.getTrnlist().getElement(i).getModtyp(),this.getTrnlist().getElement(i).getNam(),
			    this.getTrnlist().getElement(i).getInifrm(),this.getTrnlist().getElement(i).getInidattim(),this.getCpdlst().getElement(i).getPyeact(),pyeblk,this.getTrnlist().getElement(i).getNxtlev(),this.getTrnlist().getElement(i).getSta(),this.getTrnlist().getElement(i).getWfm(),this.getTrnlist().getElement(i).getReloricur(),this.getTrnlist().getElement(i).getReloriamt(),this.getTrnlist().getElement(i).getWfm(),iniusr,this.getTrnlist().getElement(i).getCfmdattim(),this.getTrnlist().getElement(i).getStlref(),this.getCpdlst().getElement(i).getPayeract(),this.getCpdlst().getElement(i).getPaynam());
			}
			

			return true;
        }

        /**
        *   source:comsel.@0007.script
        */
        @Rule(target="bensel",order=100)
        public boolean ruleBenselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBenpage());

			String ptyinr=this.getSysmod().getPty().getInr();
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.debug("{}","ptyinr的值："+ptyinr+"ptytyp的值："+ptytyp);

			List objs = new ArrayList();
			String sql="FROM m1,m2,m3,m4 " ;
			sql += " LEFT JOIN m5 with m5.inr = m3.inr ";
			sql += "WHERE m4.ptrtyp = '3' AND m1.inr = m4.preptyinr AND m3.ptyinr = m1.inr AND m2.inr = m3.objinr AND m4.nxtptyinr = ? ";
			objs.add(ptyinr);
			log.debug("{}","查询条件:"+this.getPayee().getPyeact());
			if(!MdaUtils.isEmpty(this.getPayee().getPyeact()))
			{
			  sql += " AND m5.pyeact = ? ";
			  objs.add(this.getPayee().getPyeact());
			}
			log.debug("{}","查询条件nam:"+this.getNam());
			if(!MdaUtils.isEmpty(this.getNam()))
			{
			  sql += " AND m2.adr LIKE ? ";
			  objs.add("%"+this.getNam()+"%");
			}
			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getPtylst(),this.getAdrlst(),this.getPtalst(),this.getPtrlst(),this.getPayeelst()},new CacheOption(0, true),sql,objs.toArray());
			log.debug("{}","sql语句："+sql);
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000153"),MdaUtils.getI18NString("comsel","CT000154"));
			  return false;
			}
			this.getBenpage().setFullSize(this.getPtylst().fullSize());
			log.info("{}","数据列size :"+this.getPtylst().fullSize());
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> engnam = new Argument<String>("engnam");
			Argument<String> benadr = new Argument<String>("benadr");
			Argument<String> bentel = new Argument<String>("bentel");
			Argument<String> benfax = new Argument<String>("benfax");
			Argument<String> pyecry = new Argument<String>("pyecry");
			Argument<String> ctydes = new Argument<String>("ctydes");
			Argument<String> pyeact = new Argument<String>("pyeact");
			Argument<String> acwnam = new Argument<String>("acwnam");
			Argument<String> swtcod = new Argument<String>("swtcod");
			Argument<String> rcpnam = new Argument<String>("rcpnam");
			Argument<String> rcpswtcod = new Argument<String>("rcpswtcod");
			Argument<String> rcpact = new Argument<String>("rcpact");
			Argument<String> isenable = new Argument<String>("isenable");
			Argument<String> rcpswtnam = new Argument<String>("rcpswtnam");
			Argument<String> swtnam = new Argument<String>("swtnam");
			for(int i=0; i<this.getPayeelst().size(); i++)
			{
			  pyecry.setValue(this.getPayeelst().getElement(i).getPyecry());
			  log.debug("{}","pyecry值："+this.getPayeelst().getElement(i).getPyecry());
			  ctydes.setValue(this.getPayeelst().getElement(i).getCtydes());
			  pyeact.setValue(this.getPayeelst().getElement(i).getPyeact());
			  acwnam.setValue(this.getPayeelst().getElement(i).getAcwnam());
			  swtcod.setValue(this.getPayeelst().getElement(i).getSwtcod());
			  rcpnam.setValue(this.getPayeelst().getElement(i).getRcpnam());
			  rcpswtcod.setValue(this.getPayeelst().getElement(i).getRcpswtcod());
			  rcpact.setValue(this.getPayeelst().getElement(i).getRcpact());
			  swtnam.setValue(this.getPayeelst().getElement(i).getSwtnam());
			  rcpswtnam.setValue(this.getPayeelst().getElement(i).getRcpswtnam());
			  isenable.setValue(this.getPayeelst().getElement(i).getIsenable());
			  log.debug("{}","adr的值"+this.getAdrlst().getElement(i).getAdr());
			  bennam.setValue(this.getPtylst().getElement(i).getNam());
			  benadr.setValue(this.getAdrlst().getElement(i).getAdr());
			  bentel.setValue(this.getAdrlst().getElement(i).getTel());
			  benfax.setValue(this.getAdrlst().getElement(i).getFax());

			  this.getBenpage().add(bennam,benadr,bentel,benfax,pyecry,ctydes,pyeact,acwnam,swtcod,rcpnam,rcpswtcod,rcpact,isenable,swtnam,rcpswtnam);
			}
			

			return true;
        }

        /**
        *   source:comsel.@0008.script
        */
        @Rule(target="agtsel",order=100)
        public boolean ruleAgtselN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getErrorCode();
			String ptyinr=this.getSysmod().getPty().getInr();
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			ctx.getDaoSession().dbRead(this.getPty(),new Argument("cid","08350000"));
			//IN ( SELECT inr FROM pty WHERE cid = '08350000')
			List objs = new ArrayList();
			String sql="WHERE m4.ptrtyp = '4' AND m1.inr = m4.preptyinr AND m3.ptyinr = m1.inr AND m2.inr = m3.objinr AND m4.nxtptyinr =? ";
			objs.add(this.getPty().getInr());
			if(!MdaUtils.isEmpty(this.getExtkey()))
			{
			  sql += " AND (m1.ncid LIKE ? OR m2.extkey LIKE ?)";
			  objs.add("%"+this.getExtkey()+"%");
			  objs.add("%"+this.getExtkey()+"%");
			}
			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getPtylst(),this.getAdrlst(),this.getPtalst(),this.getPtrlst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000066"),MdaUtils.getI18NString("comsel","CT000067"));
			  return false;
			}
			//$ptsplst.clear();  // 因为clear时会重置fullSize，所以一定要setFullSize之前
			this.getPtsplst().setFullSize(this.getPtylst().fullSize());
			for(int i=0; i<this.getPtylst().size(); i++)
			{
			  this.getPtsplst().add(this.getPtylst().getElement(i).getNam(),this.getPtylst().getElement(i).getEngnam(),this.getPtylst().getElement(i).getNcid(),this.getAdrlst().getElement(i).getAdr(),this.getAdrlst().getElement(i).getEnadr(),this.getAdrlst().getElement(i).getExtkey());
			}
			

			return true;
        }

        /**
        *   source:comsel.@0019.script
        */
        @Rule(target="accsel",order=100)
        public boolean ruleAccselN100(){
            IContext ctx = MdaEnv.getContext();
            

			ctx.getErrorCode();
			MdaUtils.clear(this.getActlst());
			String ptyinr=this.getSysmod().getPty().getInr();
			String cur = this.getCur();
			if(MdaUtils.isEmpty(cur))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new CacheOption(0, true),new Argument<String>("ptyinr",ptyinr));

			}
			else
			  ctx.getDaoSession().dbReadset(this.getActlst(),new CacheOption(0, true),new Argument<String>("cur",cur),new Argument<String>("ptyinr",ptyinr));
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000070"),MdaUtils.getI18NString("comsel","CT000071"));
			  return false;
			}
			

			return true;
        }

        /**
        *   source:comsel.@0020.script
        */
        @Rule(target="bopsel",order=100)
        public boolean ruleBopselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getBopcod());
			ctx.getDaoSession().dbReadset(this.getBopcod(),new Argument<String>("sta","A"));
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000078"),MdaUtils.getI18NString("comsel","CT000079"));
			  return false;
			}
			

			return true;
        }

        /**
        *   source:comsel.@0027.script
        */
        @Rule(target="payeesav",order=100)
        public boolean rulePayeesavN100(){
            IContext ctx = MdaEnv.getContext();
            
			//校验
			if(MdaUtils.isEmpty(this.getPayee().getPyeact()))
			{
			  ctx.setMessage("E9999","收款人账户为空，请维护该信息。");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getPayee().getAcwnam()))
			{
			  ctx.setMessage("E9999","收款人开户行名称为空，请维护该信息。");
			  return false;
			}
			/* if(Platform.isEmpty($payee\\swtcod.getValue()))
			  {
			  Platform.message("E9999","收款人开户行地址为空，请维护该信息。");
			  return false;
			  }*/
			if(MdaUtils.isEmpty(this.getPayee().getIsenable()))
			{
			  ctx.setMessage("E9999","是否停用为空，请维护该信息。");
			  return false;
			}
			ctx.getErrorCode();

			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getPayeeold());
			ctx.getDaoSession().dbRead(this.getPayeeold(),new Argument("pyeact",this.getPayee().getPyeact()));
			if(MdaUtils.isEmpty(this.getPayeeold().getInr()))
			{
			  //保存
			  //pty
			  String ptyinr = Platform.sdbCounter("pty");
			  this.getPty().setInr(ptyinr);
			  log.debug("{}","pty的id："+ptyinr);
			  this.getPty().setNam(this.getPayee().getPyenam());
			  this.getPty().setPtytyp("4");
			  this.getPty().setStatus("0");
			  log.debug("{}","pty数据："+this.getPayee().getPyenam());
			  ctx.getDaoSession().dbInsert(this.getPty());

			  //adr
			  String adrinr = Platform.sdbCounter("adr");
			  this.getAdr().setInr(adrinr);
			  log.debug("{}","adr的id："+adrinr);
			  this.getAdr().setAdr(this.getPayee().getAdr());
			  this.getAdr().setEnadr(this.getPayee().getAdr());
			  log.debug("{}","adr数据："+this.getPayee().getAdr());
			  ctx.getDaoSession().dbInsert(this.getAdr());

			  //pta
			  String ptainr = Platform.sdbCounter("pta");
			  log.debug("{}","pta的id："+ptainr);
			  this.getPta().setInr(ptainr);
			  this.getPta().setNam(this.getPayee().getPyenam());
			  this.getPta().setObjinr(this.getAdr().getInr());
			  //$pta\\objkey.setValue($adr\\extkey.getValue());
			  this.getPta().setPtyinr(this.getPty().getInr());
			  this.getPta().setPtytyp("4");
			  log.debug("{}","pta数据："+this.getAdr().getInr()+"*************"+this.getPayee().getPyenam());
			  ctx.getDaoSession().dbInsert(this.getPta());

			  //payee
			  this.getPayee().setCreatetime(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getPayee().getIsenable()))
			  {
			    this.getPayee().setIsenable("Y");//默认启用
			  }
			  this.getPayee().setCid(this.getSysmod().getPty().getCid());
			  log.debug("{}","cid数据"+this.getSysmod().getPty().getCid());
			  this.getPayee().setInr(ptainr);
			  log.debug("{}","inr数据"+ptainr);
			  ctx.getDaoSession().dbInsert(this.getPayee());

			  //ptr
			  this.getSysmod().getPtr().setInr(Platform.sdbCounter("ptr"));
			  this.getSysmod().getPtr().setPreptyinr(ptyinr);
			  if("1".equals(this.getPty().getPtytyp()))
			    this.getSysmod().getPtr().setNxtptyinr(this.getSysmod().getPty().getInr());
			  else
			    this.getSysmod().getPtr().setNxtptyinr(this.getSysmod().getPty().getInr());
			  this.getSysmod().getPtr().setPtrtyp("3");
			  this.getSysmod().getPtr().setDes("");
			  ctx.getDaoSession().dbInsert(this.getSysmod().getPtr());

			}
			else
			{
			  //修改
			  //adr
			  MdaUtils.clear(this.getPtaold());
			  ctx.getDaoSession().dbRead(this.getPtaold(),new Argument("inr",this.getPayeeold().getInr()));
			  MdaUtils.clear(this.getAdrold());
			  ctx.getDaoSession().dbRead(this.getAdrold(),new Argument("inr",this.getPtaold().getObjinr()));
			  this.getAdrold().setAdr(this.getPayee().getAdr());
			  log.debug("{}","adrold地址："+this.getAdrold().getAdr()+"***"+this.getAdrold().getInr());
			  this.getAdrold().setEnadr(this.getPayee().getAdr());
			  ctx.getDaoSession().dbUpdate(this.getAdrold());
			  //pta
			  this.getPtaold().setNam(this.getPayee().getPyenam());
			  ctx.getDaoSession().dbUpdate(this.getPtaold());
			  //pty
			  MdaUtils.clear(this.getPtyold());
			  ctx.getDaoSession().dbRead(this.getPtyold(),new Argument("inr",this.getPtaold().getPtyinr()));
			  this.getPtyold().setNam(this.getPayee().getPyenam());
			  log.debug("{}","ptyold的名字"+this.getPtyold().getNam()+"---"+this.getPtyold().getInr());
			  ctx.getDaoSession().dbUpdate(this.getPtyold());

			  //payee
			  this.getPayeeold().setPyenam(this.getPayee().getPyenam());
			  this.getPayeeold().setAdr(this.getPayee().getAdr());
			  this.getPayeeold().setPyecry(this.getPayee().getPyecry());
			  this.getPayeeold().setCtydes(this.getPayee().getCtydes());
			  this.getPayeeold().setPyeact(this.getPayee().getPyeact());
			  this.getPayeeold().setAcwnam(this.getPayee().getAcwnam());
			  this.getPayeeold().setSwtcod(this.getPayee().getSwtcod());
			  this.getPayeeold().setSwtnam(this.getPayee().getSwtnam());
			  this.getPayeeold().setRcpnam(this.getPayee().getRcpnam());
			  this.getPayeeold().setRcpswtcod(this.getPayee().getRcpswtcod());
			  this.getPayeeold().setRcpswtnam(this.getPayee().getRcpswtnam());
			  this.getPayeeold().setRcpact(this.getPayee().getRcpact());
			  this.getPayeeold().setIsenable(this.getPayee().getIsenable());
			  this.getPayeeold().setUpdatetime(MdaUtils.today());
			  this.getPayeeold().setUpdatename(MdaEnv.getLoginUser());
			  this.getPayeeold().setCid(this.getSysmod().getPty().getCid());
			  ctx.getDaoSession().dbUpdate(this.getPayeeold());
			}
			ctx.getDaoSession().dbCommit();

			return true;
        }

        /**
        *   source:comsel.@0029.script
        */
        @Rule(target="sigsel",order=100)
        public boolean ruleSigselN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getErrorCode();
			String ver = this.getSysmod().getPty().getVer();
			if(MdaUtils.isEmpty(ver))ver = "1";
			MdaUtils.clear(this.getPtl());
			ctx.getDaoSession().dbRead(this.getPtl(),new Argument("newest","Y"));
			log.info("{}","ptl ver:"+this.getPtl().getVer()+" :"+this.getPtl().getNewest());
			String newest = this.getPtl().getVer();
			if(MdaUtils.isEmpty(newest))
			  newest="1";
			this.setBegdat(this.getSysmod().getPty().getBegdat());
			this.setSigsta("0");
			this.setCusver(ver);
			this.setNewestver(newest);
			this.setMbver("2");
			
			
			
			
			

			return true;
        }

        /**
        *   source:comsel.@0030.script
        */
        @Rule(target="reback",order=100)
        public boolean ruleRebackN100(){
            IContext ctx = MdaEnv.getContext();
            

			/**
			  手机银行
			  */
			String sptinr = (String)ctx.restoreData("sptinr");
			if(MdaUtils.isEmpty(sptinr) )
			{
			  ctx.setMessage("E1111","请输入请求参数!");
			  return false;
			}
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getSpt());
			MdaUtils.clear(this.getTrn());
			MdaUtils.clear(this.getCpd());
			ctx.getDaoSession().dbRead(this.getSpt(),new Argument("inr",sptinr),new Argument("ptyinr",this.getSysmod().getPty().getInr()));
			if(MdaUtils.isEmpty(this.getSpt().getInr()))
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E1111","该笔业务已被处理，不要重复操作!");
			  return false;
			}
			String trninr = this.getSpt().getScrtxt();
			ctx.getDaoSession().dbRead(this.getTrn(),new Argument("inr",trninr));
			if(MdaUtils.isEmpty(this.getTrn().getInr()))
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E1111","该笔业务已被处理，不要重复操作!");
			  return false;
			}
			ctx.getDaoSession().dbRead(this.getCpd(),new Argument("inr",this.getTrn().getObjinr()));
			if(MdaUtils.isEmpty(this.getCpd().getInr()))
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E1111","该笔业务已被处理，不要重复操作!");
			  return false;
			}
			log.info("{}","sptinr : "+sptinr+"   trninr: "+this.getTrn().getInr()+" cpdinr: "+this.getCpd().getInr());

			this.getTrn().setSta("X");
			ctx.getDaoSession().dbUpdate(this.getTrn());
			this.getCpd().setDty("O");
			ctx.getDaoSession().dbUpdate(this.getCpd());
			ctx.getDaoSession().dbDelete(this.getSpt());
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E1111","数据库异常，请重试");
			}
			else
			  ctx.setMessage("00000","退回成功");

			return true;
        }

        /**
        *   source:comsel.@0031.script
        */
        @Rule(target="giddsel",order=100)
        public boolean ruleGiddselN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();
			this.getRellst().setPaging(true);  // 这里必须要设置UI为可分页的ModuleLis
			
			List objs = new ArrayList();
			String sql="FROM m1,m2 " ;
			sql = sql + " LEFT JOIN m3 with m3.objinr = m2.inr and m3.rol = 'ben' and m3.objtyp = 'gid' ";
			sql = sql + " where m1.objinr=m2.inr and m1.ownref=m2.ownref ";
			sql = sql + " and m2.clsdat is null and m1.sta = 'A' and m1.modtyp = '0' and m1.ptytyp = '2' ";
			sql = sql + " and m1.oriinr is null  and m1.inifrm='gitapn' and m1.objtyp='gid'  ";
			//机构隔离
			sql = sql + " AND m2.ptyinr= ? " ;
			objs.add(ptyinr);

			//申请时间
			if(!MdaUtils.isEmpty(this.getBendat()))
			{
			  sql = sql +" AND m2.credat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBendat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql = sql +" AND m2.credat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}

			//开立日期
			if(!MdaUtils.isEmpty(this.getObendat()))
			{
			  sql = sql +" AND m2.opndat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getObendat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getOenddat()))
			{
			  sql = sql +" AND m2.opndat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getOenddat(),LT));
			}

			//业务品种
			if(!MdaUtils.isEmpty(this.getLgtyp()))
			{
			  String str = this.getLgtyp();
			  //根据逗号分隔，组合SQL语句
			  List<String> split = Arrays.asList(str.split(","));
			  String sqlstr = "";
			  if(split != null && split.size() > 0)
			  {
			    for (String s : split)
			    {
			      sqlstr=sqlstr+"'"+s+"',";
			    }
			  }
			  String str1 = sqlstr.substring(0,sqlstr.length() - 1);
			  sql = sql +" AND m2.lgtyp in ("+ str1 +") ";
			  //objs.add($lgtyp.getValue());
			}

			//业务编号
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql +" AND m2.ownref LIKE ? ";
			  objs.add("%"+this.getOwnref()+"%");
			}
			//保函编号
			if(!MdaUtils.isEmpty(this.getStlref()))
			{
			  sql = sql +" AND m2.stlref LIKE ? ";
			  objs.add("%"+this.getStlref()+"%");
			}
			//排序
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  sql = sql +" ORDER BY m2.credat  ASC ";
			}
			else
			{
			  sql = sql +" ORDER BY m2.credat  DESC ";
			}

			log.debug("{}","详情 == "+sql);
			log.debug("{}","参数=== "+"ptytyp:"+ptytyp+"----"+"ptyinr:"+ ptyinr+"时间"+this.getBendat()+this.getEnddat()+"品种"+this.getLgtyp()+"业务号"+this.getOwnref()+"保函号"+this.getStlref());

			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getTrnlst(),this.getGidlst(),this.getPtslst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000276"),MdaUtils.getI18NString("comsel","CT000277"));
			  return false;
			}

			log.info("{}","size :"+this.getGidlst().size());

			this.getGidtapag().setFullSize(this.getGidlst().fullSize());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> sta =new Argument<String>("sta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> lgcur =new Argument<String>("lgcur");
			Argument<BigDecimal> lgamt =new Argument<BigDecimal>("lgamt");
			Argument<String> matdat =new Argument<String>("matdat");
			Argument<Date> opndat =new Argument<Date>("opndat");
			Argument<String> bennam =new Argument<String>("bennam");
			Argument<String> stlref =new Argument<String>("stlref");
			Argument<String> lgtyp =new Argument<String>("lgtyp");
			Argument<Date> credat =new Argument<Date>("credat");

			for(int i=0; i<this.getGidlst().size(); i++)
			{
			  inr.setValue(this.getGidlst().getElement(i).getInr());
			  ownref.setValue(this.getGidlst().getElement(i).getOwnref());
			  lgcur.setValue(this.getGidlst().getElement(i).getLgcur());
			  lgamt.setValue(this.getGidlst().getElement(i).getLgamt());
			  //matdat.setValue($gidlst[i]\\matdat.getValue());
			  if(!MdaUtils.isEmpty(this.getGidlst().getElement(i).getLmudat()))
			  {
			    Date lmudat = this.getGidlst().getElement(i).getLmudat();
			    matdat.setValue(MdaUtils.format(lmudat,"yyyy-MM-dd"));
			  }
			  else if(!MdaUtils.isEmpty(this.getGidlst().getElement(i).getDbqxsjz()))
			  {
			    Date lmudat = this.getGidlst().getElement(i).getDbqxsjz();
			    matdat.setValue(MdaUtils.format(lmudat,"yyyy-MM-dd"));
			  }
			  else
			  {
			    matdat.setValue("敞口");
			  }

			  stlref.setValue(this.getGidlst().getElement(i).getStlref());
			  lgtyp.setValue(this.getGidlst().getElement(i).getLgtyp());
			  opndat.setValue(this.getGidlst().getElement(i).getOpndat());
			  bennam.setValue(this.getPtslst().getElement(i).getAdrblk());
			  sta.setValue("已开立");
			  credat.setValue(this.getGidlst().getElement(i).getCredat());

			  this.getGidtapag().add(inr,sta,ownref,lgcur,lgamt,matdat,opndat,bennam,stlref,lgtyp,credat);
			}
			

			return true;
        }

        /**
        *   source:comsel.@0032.script
        */
        @Rule(target="gidssel",order=100)
        public boolean ruleGidsselN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();
			this.getRellst().setPaging(true);  // 这里必须要设置UI为可分页的ModuleLis
			
			List objs = new ArrayList();
			String sql="FROM m1 " ;
			sql = sql + " left join m2 with m2.oriinr = m1.inr and m2.objtyp=m1.objtyp and m2.objinr=m1.objinr and m2.ptytyp='0' ";
			sql = sql + " left join m3 with m1.objinr=m3.inr and m1.ownref=m3.ownref ";
			sql = sql + " left join m4 with m3.inr = m4.objinr and m4.rol = 'ben' and m4.objtyp = 'gid' ";
			sql = sql + " where (m1.sta != 'W' and m1.sta != 'X' and m1.sta != 'J') ";
			sql = sql + " and m1.modtyp = '0' and m1.ptytyp = '2' and m1.oriinr is null and m1.inifrm='gitapn' and m1.objtyp='gid' ";  //机构隔离
			sql = sql + " AND m3.ptyinr= ? " ;
			objs.add(ptyinr);

			if(!MdaUtils.isEmpty(this.getBendat()))
			{
			  sql = sql +" AND m3.credat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBendat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql = sql +" AND m3.credat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}
			//业务品种
			if(!MdaUtils.isEmpty(this.getLgtyp()))
			{
			  String str = this.getLgtyp();
			  //根据逗号分隔，组合SQL语句
			  List<String> split = Arrays.asList(str.split(","));
			  String sqlstr = "";
			  if(split != null && split.size() > 0)
			  {
			    for (String s : split)
			    {
			      sqlstr=sqlstr+"'"+s+"',";
			    }
			  }
			  String str1 = sqlstr.substring(0,sqlstr.length() - 1);
			  sql = sql +" AND m3.lgtyp in ("+ str1 +") ";
			  //objs.add($lgtyp.getValue());
			}
			//业务编号
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql +" AND m3.ownref LIKE ? ";
			  objs.add("%"+this.getOwnref()+"%");
			}
			//保函编号
			if(!MdaUtils.isEmpty(this.getStlref()))
			{
			  sql = sql +" AND m3.stlref LIKE ? ";
			  objs.add("%"+this.getStlref()+"%");
			}
			//业务状态
			if(!MdaUtils.isEmpty(this.getGidsta()))
			{
			  String gidstas = this.getGidsta();
			  //根据逗号分隔，组合SQL语句
			  sql = sql + " AND( ";
			  List<String> list = new ArrayList(Arrays.asList(gidstas.split(",")));
			  String sqlstr1 = "";
			  String resultstr = "";
			  boolean flag = false;
			  boolean flag1 = false;
			  if(list != null && list.size() > 0)
			  {
			    if(list.contains("R") || list.contains("R1"))
			    {
			      flag = true;
			    }
			    if(list.contains("R") && list.contains("R1"))
			    {
			      flag1 = true;
			    }
			    if(flag1)
			    {
			      sql = sql +" m1.sta = 'R' ";
			    }
			    for (int i = list.size() - 1; i >= 0; i--)
			    {
			      if("R".equals(list.get(i)))
			      {
			        list.remove(list.get(i));
			        if(!flag1)
			        {
			          sql = sql + " (m1.sta = 'R' AND m2.sta = 'R') ";
			        }
			      }
			      else if("R1".equals(list.get(i)))
			      {
			        list.remove(list.get(i));
			        if(!flag1)
			        {
			          sql = sql + " ((m1.sta = 'R' AND m2.sta != 'R') or (m1.sta = 'R' AND m2.sta is null)) ";
			        }
			      }
			    }
			  }
			  if(flag && (list.contains("A") || list.contains("B")))
			  {
			    sql = sql + " or ";
			  }
			  if(list != null && list.size() > 0)
			  {
			    for(String s:list)
			    {
			      sqlstr1=sqlstr1+"'"+s+"',";
			    }
			    resultstr = sqlstr1.substring(0,sqlstr1.length() - 1);
			    sql = sql +" m1.sta in ("+ resultstr +") ";
			  }
			  sql = sql + ")";
			}

			//排序
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  sql = sql +" ORDER BY m3.credat  ASC ";
			}
			else
			{
			  sql = sql +" ORDER BY m3.credat  DESC ";
			}

			log.debug("{}","状态 == "+sql);
			log.debug("{}","参数=== "+"ptytyp:"+ptytyp+"----"+"ptyinr:"+ ptyinr+"时间"+this.getBendat()+this.getEnddat()+"品种"+this.getLgtyp()+"业务号"+this.getOwnref()+"保函号"+this.getStlref());
			log.debug("{}","sql参数===="+objs.toString());
			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getTrnlst(),this.getTrnlist(),this.getGidlst(),this.getPtslst()},new CacheOption(0, true),sql,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000274"),MdaUtils.getI18NString("comsel","CT000275"));
			  return false;
			}

			log.info("{}","size :"+this.getGidlst().size());

			this.getGidpage().setFullSize(this.getGidlst().fullSize());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> sta =new Argument<String>("sta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> lgcur =new Argument<String>("lgcur");
			Argument<BigDecimal> lgamt =new Argument<BigDecimal>("lgamt");
			Argument<Date> credat =new Argument<Date>("credat");
			Argument<String> bennam =new Argument<String>("bennam");
			Argument<String> stlref =new Argument<String>("stlref");
			Argument<String> lgtyp =new Argument<String>("lgtyp");
			Argument<String> matdat =new Argument<String>("matdat");//保函到期日
			Argument<Date> opndat =new Argument<Date>("opndat");//开立日期
			
			for(int i=0; i<this.getGidlst().size(); i++)
			{
			  inr.setValue(this.getGidlst().getElement(i).getInr());
			  ownref.setValue(this.getGidlst().getElement(i).getOwnref());
			  lgcur.setValue(this.getGidlst().getElement(i).getLgcur());
			  lgamt.setValue(this.getGidlst().getElement(i).getLgamt());
			  stlref.setValue(this.getGidlst().getElement(i).getStlref());
			  credat.setValue(this.getGidlst().getElement(i).getCredat());
			  bennam.setValue(this.getPtslst().getElement(i).getAdrblk());
			  lgtyp.setValue(this.getGidlst().getElement(i).getLgtyp());
			  opndat.setValue(this.getGidlst().getElement(i).getOpndat());
			  //保函到期日
			  if(!MdaUtils.isEmpty(this.getGidlst().getElement(i).getLmudat()))
			  {
			    Date lmudat = this.getGidlst().getElement(i).getLmudat();
			    matdat.setValue(MdaUtils.format(lmudat,"yyyy-MM-dd"));
			  }
			  else if(!MdaUtils.isEmpty(this.getGidlst().getElement(i).getDbqxsjz()))
			  {
			    Date lmudat = this.getGidlst().getElement(i).getDbqxsjz();
			    matdat.setValue(MdaUtils.format(lmudat,"yyyy-MM-dd"));
			  }
			  else
			  {
			    matdat.setValue("敞口");
			  }
			  //返回状态做判断
			  if(!MdaUtils.isEmpty(this.getTrnlst().getElement(i).getSta()))
			  {
			    if("A".equals(this.getTrnlst().getElement(i).getSta()))
			    {
			      sta.setValue("已开立");
			    }
			    if("B".equals(this.getTrnlst().getElement(i).getSta()))
			    {
			      sta.setValue("已退回");
			    }
			    if("R".equals(this.getTrnlst().getElement(i).getSta()))
			    {
			      if("R".equals(this.getTrnlist().getElement(i).getSta()))
			      {
			        sta.setValue("已通过");
			      }
			      else
			      {
			        sta.setValue("处理中");
			      }
			      if(MdaUtils.isEmpty(this.getTrnlist().getElement(i).getSta()))
			      {
			        sta.setValue("处理中");
			      }
			    }
			  }

			  this.getGidpage().add(inr,sta,ownref,lgcur,lgamt,credat,bennam,stlref,lgtyp,matdat,opndat);
			}
			

			return true;
        }

        /**
        *   source:comsel.@0033.script
        */
        @Rule(target="custinfo",order=100)
        public boolean ruleCustinfoN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cid=this.getSysmod().getPty().getCid();
			String ptyinr=this.getSysmod().getPty().getInr();
			log.debug("{}","客户号：--------"+cid+"ptyinr:-------"+ptyinr);
			String sql="select a.adr adr,a.enadr enadr,a.tel tel from adr a, pta pa where a.enadr is not null and pa.objinr = a.inr and pa.ptyinr='"+ptyinr+"' order by pa.inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.getDaoSession().dbCloseCursor();
			  ctx.setMessage(MdaUtils.getI18NString("comsel","CT000297"),MdaUtils.getI18NString("comsel","CT000298"));
			  return false;
			}
			Argument<String> adr =new Argument<String>("adr");
			Argument<String> enadr =new Argument<String>("enadr");
			Argument<String> tel =new Argument<String>("tel");
			MdaUtils.clear(this.getCustme());
			ctx.getDaoSession().dbFetchFields(adr,enadr,tel);
			log.debug("{}","adr....."+adr.value+"enadr----"+enadr.value+"tel::::"+tel.value);
			int errorCode = ctx.getErrorCode();
			log.info("{}","errorCode=-="+errorCode);
			if(errorCode == NO_ERROR)
			{
			  this.getCustme().setAdrs(adr.value);
			  this.getCustme().setEnadr(enadr.value);
			  this.getCustme().setTel(tel.value);
			}
			ctx.getDaoSession().dbCloseCursor();
			this.getCustme().setNams(this.getSysmod().getPty().getNam());
			this.getCustme().setEngnam(this.getSysmod().getPty().getEngnam());
			this.getCustme().setCidcode(cid);
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:comsel.@0034.script
        */
        @Rule(target="payeedel",order=100)
        public boolean rulePayeedelN100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","账号："+this.getPayee().getPyeact());
			ctx.getDaoSession().dbBegin();

			//Platform.clear($payee);
			ctx.getDaoSession().dbRead(this.getPayee(),new Argument("pyeact",this.getPayee().getPyeact()));
			log.debug("{}","查询到的账户："+this.getPayee().getPyeact());
			if(MdaUtils.isEmpty(this.getPayee().getPyeact()))
			{
			  ctx.setMessage("E9999","收款人账户可能不存在，请检查该信息");
			  return false;
			}
			//删除
			//adr
			//Platform.clear($pta);
			ctx.getDaoSession().dbRead(this.getPta(),new Argument("inr",this.getPayee().getInr()));

			//Platform.clear($adr);
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument("inr",this.getPta().getObjinr()));
			ctx.getDaoSession().dbDelete(this.getAdr());

			//pty
			//Platform.clear($pty);
			ctx.getDaoSession().dbRead(this.getPty(),new Argument("inr",this.getPta().getPtyinr()));
			ctx.getDaoSession().dbDelete(this.getPty());
			//ptr
			
			ctx.getDaoSession().dbRead(this.getPtr(),new Argument("preptyinr",this.getPta().getPtyinr()));
			ctx.getDaoSession().dbDelete(this.getPtr());
			//pta
			ctx.getDaoSession().dbDelete(this.getPta());

			//payee
			ctx.getDaoSession().dbDelete(this.getPayee());
			ctx.getDaoSession().dbCommit();

			return true;
        }















































































}