package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptapiVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇入汇款确认申请
*/
@Transaction(vo= CptapiVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptapi extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptapi.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Cptapi()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptapi.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptapi.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapi.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptapi.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptapi.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
        }

        /**
        *   source:cptapi.@0003.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			{
			  this.getCptp().getDecgrp().getRec().setBopcur1(NULLSTR);
			  this.getCptp().getDecgrp().getRec().setBopamt1(new BigDecimal(0));
			  this.getCptp().getDecgrp().getRec().setBoprmk1(NULLSTR);
			  
			  
			  
			}
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			{
			  this.getCptp().getDecgrp().getRec().setBopcur2(NULLSTR);
			  this.getCptp().getDecgrp().getRec().setBopamt2(new BigDecimal(0));
			  this.getCptp().getDecgrp().getRec().setBoprmk2(NULLSTR);
			  
			  
			  
			}
			//付款界面校验
			if("Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  boolean fkcheck=fukuanCheck();
			  if(!fkcheck)
			  {
			    return false;
			  }
			}

			if(!ctx.checkAll(this.getCpdgrp().getRec()))
			{
			  log.warn("{}","申请页面校验未通过，退出");
			  return false;
			}
			String objinr = "";
			String objtyp = "cpd";

			if(!ctx.checkAll(this.getCpdgrp()))
			  return false;

			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getInr()))
			{
			  ctx.setMessage("E9999","参数错误,未找到对应记录!");
			  return false;
			}
			if(Platform.isFromApp())
			{
			  String steps = "0:汇入确认申请";

			  if("1".equals(this.getCptp().getCpdgrp().getRec().getRemittype())||"2".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			  {
			    steps =steps+";1:申报申请";

			  }
			  if(TRUE.equals(this.getCptp().getDecgrp().getRec().getXhghchk()))
			  {
			    steps =steps+";2:结汇申请";
			  }
			  if("Z".equals(this.getCptp().getCpdgrp().getRec().getKjhkflg()))
			  {
			    steps =steps+";4:收款说明";
			  }
			  steps =steps+";3:申请书展示";
			  this.getCptp().getStpmod().setPages(steps);
			  this.getCptp().getStpmod().calcSteps();
			  this.getCptp().getStpmod().setStepBtnSta();
			}
			String cpdinr = this.getCpdgrp().getRec().getInr();
			/*String lcknam = $sysmod\\usr\\cid.getValue()+$sysmod\\usr\\oid.getValue();
			  LockInfo lockinf=Platform.dbLock(lcknam,"cpd"+cpdinr);
			  if(Platform.errorCode()==ERROR_LOCKED)
			  {
			  Platform.message("E9999","该笔业务已经被其他用户锁定！");
			  return false;
			  }*/
			//重新读一下cpd
			if(!this.getSysmod().sptIsLoaded("B")&&!"O".equals(this.getCpdgrp().getRec().getDty()))
			{
			  ctx.setMessage("E9999","该笔业务已被他人处理,请重新查询 ");
			  log.info("{}","state changed "+this.getCpdgrp().getRec().getOwnref());
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("E9999","归属机构必输，请联系银行维护");
			  return false;
			}

			if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getInr())&&!MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getInr())&&!MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getInr()))
			{
			  this.getCpdgrp().getRec().setDty("A");
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getCptp().getSpdgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getCptp().getDecgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getCptp().getCpdgrp().getTde());
			}
			else
			{

			  this.getCptp().getSpdgrp().getRec().setInr(Platform.sdbCounter("spd"));
			  this.getCptp().getDecgrp().getRec().setInr(Platform.sdbCounter("dec"));
			  this.getCptp().getCpdgrp().getTde().setInr(Platform.sdbCounter("tde"));
			  this.getCpdgrp().getRec().setDty("A");
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			  objinr = this.getCpdgrp().getRec().getInr();

			  this.getCptp().getSpdgrp().getRec().setObjtyp(objtyp);
			  this.getCptp().getSpdgrp().getRec().setObjinr(objinr);
			  this.getCptp().getDecgrp().getRec().setObjtyp(objtyp);
			  this.getCptp().getDecgrp().getRec().setObjinr(objinr);
			  this.getCptp().getCpdgrp().getTde().setObjtyp(objtyp);
			  this.getCptp().getCpdgrp().getTde().setObjinr(objinr);
			  ctx.getDaoSession().dbInsert(this.getCptp().getCpdgrp().getTde());
			  ctx.getDaoSession().dbInsert(this.getCptp().getSpdgrp().getRec());
			  ctx.getDaoSession().dbInsert(this.getCptp().getDecgrp().getRec());

			}
			this.getTrnmod().getItfmod().getImgmod().setImgref(this.getCptp().getCpdgrp().getRec().getOwnref());

			this.flgs();
			this.fksmflg();
			if(!this.getTrnmod().trnSetFromContract()) return false;
			MdaEnv.setLocale(Locale.SIMPLIFIED_CHINESE);
			List<CodetableItem> codeitem1=new ArrayList<CodetableItem>();
			if(Platform.isFromApp())
			{
			  codeitem1=this.getBopCod("I");
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod1",codeitem1);
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod2",codeitem1);
			  MdaUtils.setValues(this.getCptp().getCpdgrp().getTde(),"servicecod",codeitem1);
			}
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getCptp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			codeitem1=null;
			if(Platform.isFromApp())
			{
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod1",codeitem1);
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod2",codeitem1);
			  MdaUtils.setValues(this.getCptp().getCpdgrp().getTde(),"servicecod",codeitem1);
			}
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cptapi.@0004.script
        */
        @Rule(target="cptp.stpmod.next",order=100)
        public boolean ruleCptpStpmodNextN100(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getCptp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getCptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			return true;
        }

        /**
        *   source:cptapi.@0005.script
        */
        @Rule(target="cptp.stpmod.gostep",order=10)
        public boolean ruleCptpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getCptp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getCptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			switch(panelidx)
			{
			  case 0:
			  {
			    if(!ctx.checkAll(this.getCpdgrp()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000005"),MdaUtils.getI18NString("cptapi","CT000006"));
			      return false;
			    }
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getCptp().getSpdgrp()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000007"),MdaUtils.getI18NString("cptapi","CT000008"));
			      return false;
			    }
			  }
			  case 2:
			  {
			    if(!ctx.checkAll(this.getCptp().getDecgrp()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000009"),MdaUtils.getI18NString("cptapi","CT000010"));
			      return false;
			    }
			  }
			  case 3:
			  {
			  }
			}

			switch(stepIdx)
			{
			  case 0:
			  {
			    if(!ctx.checkAll(this.getCpdgrp()))
			    {
			      return false;
			    }
			    this.initapipdf();
			    this.dealcpdgrp();
			    return true;
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getCptp().getSpdgrp()))
			    {
			      return false;
			    }
			    this.initapipdf();
			    this.dealcpdgrp();
			    return true;
			  }
			  case 2:
			  {
			    if(!ctx.checkAll(this.getCptp().getDecgrp()))
			    {
			      return false;
			    }
			    this.initapipdf();
			    this.dealcpdgrp();
			    return true;
			  }
			  case 3:
			  {
			    this.initapipdf();
			    this.dealcpdgrp();
			    return true;
			  }
			}

			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:cptapi.@0006.script
        */
        @Rule(target="cptp.cpdgrp.rec.remittype",order=100)
        public boolean ruleCptpCpdgrpRecRemittypeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  this.getCptp().getCpdgrp().getRec().setInoutflg("out");
			}
			else if("2".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  this.getCptp().getCpdgrp().getRec().setInoutflg("in");
			}
			
			this.dealStpmod();

			return true;
        }

        /**
        *   source:cptapi.@0008.script
        */
        @Rule(target="cptp.cpdgrp.rec.xhghchk",order=100)
        public boolean ruleCptpCpdgrpRecXhghchkN100(){
            IContext ctx = MdaEnv.getContext();
            

			//$this.dealStpmod();
			
			return true;
        }

        /**
        *   source:cptapi.@0010.script
        */
        @Rule(target="cptp.pdspdpdf",order=100)
        public boolean ruleCptpPdspdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptjhpd","即期结汇申请书",1);

			return true;
        }

        /**
        *   source:cptapi.@0011.script
        */
        @Rule(target="cptp.tdspdpdf",order=100)
        public boolean ruleCptpTdspdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptjhtd","即期结汇申请书",1);

			return true;
        }

        /**
        *   source:cptapi.@0012.script
        */
        @Rule(target="cptp.pddecinpdf",order=100)
        public boolean ruleCptpPddecinpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptinpd","境内收入申报单",1);

			return true;
        }

        /**
        *   source:cptapi.@0013.script
        */
        @Rule(target="cptp.tddecinpdf",order=100)
        public boolean ruleCptpTddecinpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptintd","境内收入申报单",1);

			return true;
        }

        /**
        *   source:cptapi.@0014.script
        */
        @Rule(target="cptp.pddecoutpdf",order=100)
        public boolean ruleCptpPddecoutpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptoutpd","涉外收入申报单",1);

			return true;
        }

        /**
        *   source:cptapi.@0015.script
        */
        @Rule(target="cptp.tddecoutpdf",order=100)
        public boolean ruleCptpTddecoutpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getCptp().getPdfviw().callPDFComponent("","cptouttd","涉外收入申报单",1);

			return true;
        }

        /**
        *   source:cptapi.@0018.script
        */
        @Rule(target="cptp.spdgrp.rec.chkcny",order=100)
        public boolean ruleCptpSpdgrpRecChkcnyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getCptp().getSpdgrp().getRec().getChkcny())&&(!MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getCur()))&&(!MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getAmt())))
			{
			  if(!MdaUtils.isEmpty(this.getCptp().getSpdgrp().getCurrat().getMidrat()))
			  {
			    BigDecimal outamt=this.getCptp().getSpdgrp().getRec().getAmt().multiply(this.getCptp().getSpdgrp().getCurrat().getMidrat());
			    this.getCptp().getSpdgrp().getRec().setCnyamt(MdaUtils.parseDecimal(MdaUtils.format(outamt,"#0.00")));
			  }
			}
			else
			{
			  this.getCptp().getSpdgrp().getRec().setCnyamt(new BigDecimal(0));
			  if(TRUE.equals(this.getCptp().getSpdgrp().getRec().getChkcny())&&MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getCur())||MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getAmt()))
			  {
			    ctx.setFieldError(this,"cptp.spdgrp.rec.cnyamt",MdaUtils.getI18NString("cptapi","CT000002"));
			  }
			}
			

			return true;
        }

        /**
        *   source:cptapi.@0019.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			//提交210，保存要预览的pdf资源
			int cnt = 2;
			String labels = "";
			String tempfiles = "";
			if("1".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  //涉外申报
			  labels += "涉外申报（普打）,涉外申报（套打）";
			  tempfiles = "A:cptoutpd,A:cptouttd";
			}
			else if("2".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  //境内申报
			  labels += "境内申报（普打）,境内申报（套打）";
			  tempfiles = "A:cptinpd,A:cptintd";
			}

			if(TRUE.equals(this.getCptp().getDecgrp().getRec().getXhghchk())&&("T".equals(this.getCptp().getSpdgrp().getActnosta())))
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemittype()))
			    labels += ",";
			  cnt += 2;
			  labels += "即期结汇（普打）,即期结汇（套打）";
			  if(MdaUtils.isEmpty(tempfiles))
			  {
			    tempfiles += "A:cptjhpd,A:cptjhtd";
			  }
			  else
			  {
			    tempfiles += ",A:cptjhpd,A:cptjhtd";
			  }

			}
			if("Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  cnt += 1;
			  labels += ",跨境业务人民币结算收款说明";
			  tempfiles += ",A:fksmsqs";
			}
			log.info("{}","lables====="+labels);
			log.info("{}","tempfiles====="+tempfiles);
			log.info("{}","cnt====="+cnt);
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:cptapi.@0021.script
        */
        @Rule(target="cptp.decgrp.rec.bopcod1",order=100)
        public boolean ruleCptpDecgrpRecBopcod1N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($cptp\\decgrp\\rec\\bopcod1.getValue()))
			  {
			  $cptp\\decgrp\\rec\\bopcur1.setValue($cptp\\decgrp\\rec\\cur.getValue());
			  }
			  else
			  {
			  Platform.clear($cptp\\decgrp\\rec\\bopcur1);
			  Platform.setModified($cptp\\decgrp\\rec\\bopcur1);
			  }
			  */
			if(!Platform.isFromApp()&&"Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  String bopcod1 =this.getCptp().getDecgrp().getRec().getBopcod1();
			  String bopcod2 =this.getCptp().getDecgrp().getRec().getBopcod2();

			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    if(bopcod1.startsWith("2"))
			    {

			      this.getCpdgrp().getTde().setServicecod(bopcod1);
			      this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt1());

			    }
			    if(!bopcod1.startsWith("2"))
			    {
			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			      {
			        if(!bopcod2.startsWith("2"))
			        {
			          this.getCpdgrp().getTde().setServicecod(NULLSTR);
			          this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			        }
			        else
			        {
			          
			          
			          this.getCpdgrp().getTde().setServicecod(bopcod2);
			          this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt2());

			        }
			      }
			      else
			      {
			        this.getCpdgrp().getTde().setServicecod(NULLSTR);
			        this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			      }
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      if(!bopcod2.startsWith("2"))
			      {
			        this.getCpdgrp().getTde().setServicecod(NULLSTR);
			        this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			      }
			      else
			      {

			        this.getCpdgrp().getTde().setServicecod(bopcod2);
			        this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt2());

			      }
			    }
			    else
			    {
			      this.getCpdgrp().getTde().setServicecod(NULLSTR);
			      this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			    }
			  }
			  
			  
			}


			return true;
        }

        /**
        *   source:cptapi.@0022.script
        */
        @Rule(target="cptp.decgrp.rec.bopcod2",order=100)
        public boolean ruleCptpDecgrpRecBopcod2N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($cptp\\decgrp\\rec\\bopcod2.getValue()))
			  {
			  $cptp\\decgrp\\rec\\bopcur2.setValue($cptp\\decgrp\\rec\\cur.getValue());
			  }
			  else
			  {
			  Platform.clear($cptp\\decgrp\\rec\\bopcur2);
			  Platform.setModified($cptp\\decgrp\\rec\\bopcur2);
			  }
			  */
			if(!Platform.isFromApp()&&"Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  String bopcod2 =this.getCptp().getDecgrp().getRec().getBopcod2();
			  String bopcod1 =this.getCptp().getDecgrp().getRec().getBopcod1();
			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    if(bopcod2.startsWith("2"))
			    {

			      this.getCpdgrp().getTde().setServicecod(bopcod2);
			      this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			    }
			    if(!bopcod2.startsWith("2"))
			    {
			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			      {

			        if(!bopcod1.startsWith("2"))
			        {
			          this.getCpdgrp().getTde().setServicecod(NULLSTR);
			          this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			        }
			        else
			        {

			          this.getCpdgrp().getTde().setServicecod(bopcod1);
			          this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			        }

			      }
			      else
			      {
			        this.getCpdgrp().getTde().setServicecod(NULLSTR);
			        this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			      }

			    }

			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			    {

			      if(!bopcod1.startsWith("2"))
			      {
			        this.getCpdgrp().getTde().setServicecod(NULLSTR);
			        this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			      }
			      else
			      {

			        this.getCpdgrp().getTde().setServicecod(bopcod1);
			        this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			      }

			    }
			    else
			    {
			      this.getCpdgrp().getTde().setServicecod(NULLSTR);
			      this.getCpdgrp().getTde().setServiceamt(new BigDecimal(0));

			    }
			  }
			  
			  
			}

			return true;
        }

        /**
        *   source:cptapi.@0023.script
        */
        @Rule(target="cptp.cpdgrp.rec.inoutflg",order=100)
        public boolean ruleCptpCpdgrpRecInoutflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  if("in".equals(this.getCptp().getCpdgrp().getRec().getInoutflg()))
			  {
			    this.getCptp().getCpdgrp().getRec().setRemittype("2");
			  }
			  else if("out".equals(this.getCptp().getCpdgrp().getRec().getInoutflg()))
			  {
			    this.getCptp().getCpdgrp().getRec().setRemittype("1");
			  }
			  
			  this.dealStpmod();
			}

			return true;
        }

        /**
        *   source:cptapi.@0024.script
        */
        @Rule(target="mtabut.sel1",order=100)
        public boolean ruleMtabutSel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCty().setEngnam(NULLSTR);
			
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			//Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:cptapi.@0025.script
        */
        @Rule(target="cptp.search",order=100)
        public boolean ruleCptpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			String sql = "SELECT * FROM cty ";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getCty().getEngnam()))
			{
			  String nam = this.getCpdgrp().getCty().getEngnam().toUpperCase();
			  sql = sql+" WHERE alpcod like '%"+nam+"%' or cod like '%"+nam+"%' or engnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%' or chnnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%'";
			}
			sql = sql+" ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ctylst len="+this.getCpdgrp().getCtylst().fullSize());
			if(MdaUtils.isEmpty(this.getCpdgrp().getCtylst())  ||  this.getCpdgrp().getCtylst().fullSize()<=0)
			{
			  sql = "SELECT * FROM cty  WHERE numcod like '%"+this.getCpdgrp().getCty().getEngnam() +"%'";
			  sql = sql+" ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			

			return true;
        }

        /**
        *   source:cptapi.@0026.script
        */
        @Rule(target="cptp.sure",order=100)
        public boolean ruleCptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000013"),MdaUtils.getI18NString("cptapi","CT000014"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().getRec().setCountryname(this.getCpdgrp().getCtylst().getElement(index).getChnnam());
			
			
			

			return true;
        }

        /**
        *   source:cptapi.@0027.script
        */
        @Rule(target="cptp.spdgrp.rec.spdtyp",order=100)
        public boolean ruleCptpSpdgrpRecSpdtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getCptp().getSpdgrp().getRec().getSpdtyp()))
			{
			  this.getCptp().getSpdgrp().getRec().setSpdtyp(NULLSTR);
			  
			  ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000015"),MdaUtils.getI18NString("cptapi","CT000016"));
			}

			return true;
        }

        /**
        *   source:cptapi.@0028.script
        */
        @Rule(target="cptp.decgrp.rec.unitin",order=100)
        public boolean ruleCptpDecgrpRecUnitinN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getCptp().getDecgrp().getRec().getUnitin()))
			{
			  this.getCptp().getDecgrp().getRec().setUnitin(NULLSTR);
			  
			  ctx.setMessage(MdaUtils.getI18NString("cptapi","CT000017"),MdaUtils.getI18NString("cptapi","CT000018"));
			}


			return true;
        }

        /**
        *   source:cptapi.@0029.script
        */
        @Rule(target="cptp.decgrp.rec.xhghchk",order=100)
        public boolean ruleCptpDecgrpRecXhghchkN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($cptp\\decgrp\\rec\\xhghchk.getValue()))
			  {
			  Platform.enable($cptp\\decgrp\\rec\\amofsale);
			  Platform.enable($cptp\\decgrp\\rec\\saleact);
			  }
			  else
			  {
			  Platform.clear($cptp\\decgrp\\rec\\amofsale);
			  Platform.clear($cptp\\decgrp\\rec\\saleact);
			  Platform.disable($cptp\\decgrp\\rec\\amofsale);
			  Platform.disable($cptp\\decgrp\\rec\\saleact);
			  }
			  Platform.setModified($cptp\\decgrp\\rec\\amofsale);
			  Platform.setModified($cptp\\decgrp\\rec\\saleact);
			  */
			this.dealStpmod();

			return true;
        }

        /**
        *   source:cptapi.@0041.script
        */
        @Rule(target="cptp.cpdgrp.rec.remittype",order=101)
        public boolean ruleCptpCpdgrpRecRemittypeN101(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","onchange时件填报说明---101开始");
			//涉外收入申报填报说明
			if("1".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  
			  
			  
			  

			  
			  
			  
			  //结汇账号/现汇账号/其他账号
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			//境内收入申报填报说明
			else if("2".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  //结汇账号/现汇账号/其他账号
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  //结汇账号/现汇账号/其他账号
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			log.info("{}","onchange时件填报说明---101结束");

			return true;
        }

        /**
        *   source:cptapi.@0042.script
        */
        @Rule(target="cptp.cpdgrp.tde.transsta",order=100)
        public boolean ruleCptpCpdgrpTdeTransstaN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().getCpdgrp().getTde().setGenamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setBjmyamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setJljgamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setOthtradeamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setCustamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setLeaveamt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setOtheramt(new BigDecimal(0));
			this.getCptp().getCpdgrp().getTde().setServicenam(NULLSTR);
			this.getCptp().getCpdgrp().getTde().setServiceorgcod(NULLSTR);
			
			
			
			
			
			
			
			
			
			this.getCptp().getCpdgrp().getTde().setServiceorgcod(NULLSTR);
			
			
			String bopcod2 =this.getCptp().getDecgrp().getRec().getBopcod2();
			String bopcod1 =this.getCptp().getDecgrp().getRec().getBopcod1();
			if( !MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getTranssta()))
			{
			  
			}
			else
			{
			  
			}
			if("2".equals(this.getCptp().getCpdgrp().getTde().getTranssta())||"3".equals(this.getCptp().getCpdgrp().getTde().getTranssta()))
			{
			  
			  
			  
			  
			  this.getCptp().getCpdgrp().getTde().setServiceorgcod(ctx.absGet(Sysmod.class).getPty().getAtccod());
			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getPayee()))
			  {
			    this.getCptp().getCpdgrp().getTde().setServicenam(this.getCptp().getDecgrp().getRec().getPayee());

			  }
			  else
			  {
			    this.getCptp().getCpdgrp().getTde().setServicenam(this.getSysmod().getPty().getNam());

			  }

			  if("121010".equals(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    
			    this.getCptp().getCpdgrp().getTde().setGenamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			  }
			  if("121010".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    
			    this.getCptp().getCpdgrp().getTde().setGenamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			  }

			  if("121080".equals(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    this.getCptp().getCpdgrp().getTde().setBjmyamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			    
			  }
			  if("121080".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    
			    this.getCptp().getCpdgrp().getTde().setBjmyamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			  }
			  if("121020".equals(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    
			    this.getCptp().getCpdgrp().getTde().setJljgamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			  }
			  if("121020".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    

			    this.getCptp().getCpdgrp().getTde().setJljgamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			  }
			  if(!"121020".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121020".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    if(!"121080".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121080".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      if(!"121010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121010".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			      {
			        if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2())&&!bopcod2.startsWith("2"))
			        {
			          this.getCptp().getCpdgrp().getTde().setOthtradeamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			        }
			        if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1())&&!bopcod1.startsWith("2"))
			        {
			          this.getCptp().getCpdgrp().getTde().setOthtradeamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			        }
			        
			      }

			    }
			  }

			}
			if("4".equals(this.getCptp().getCpdgrp().getTde().getTranssta()))
			{

			  if("121030".equals(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    this.getCptp().getCpdgrp().getTde().setCustamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			    
			  }
			  if("121030".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    this.getCptp().getCpdgrp().getTde().setCustamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			    
			  }
			  if("122010".equals(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    this.getCptp().getCpdgrp().getTde().setLeaveamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			    
			  }
			  if("122010".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    this.getCptp().getCpdgrp().getTde().setLeaveamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			    
			  }
			  if(!"122010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"122010".equals(this.getCptp().getDecgrp().getRec().getBopcod2())
			    &&!"121030".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121030".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2())&&!bopcod2.startsWith("2"))
			    {
			      this.getCptp().getCpdgrp().getTde().setOtheramt(this.getCptp().getDecgrp().getRec().getBopamt2());
			    }
			    if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1())&&!bopcod1.startsWith("2"))
			    {
			      this.getCptp().getCpdgrp().getTde().setOtheramt(this.getCptp().getDecgrp().getRec().getBopamt1());
			    }
			    
			  }
			}

			//计算货物贸易金额
			this.getCpdgrp().getTde().setTradeamt(sumTradeamt()) ;
			
			
			
			
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:cptapi.@0044.script
        */
        @Rule(target="cptp.decgrp.rec.recerefund",order=100)
        public boolean ruleCptpDecgrpRecRecerefundN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  if("1".equals(this.getCptp().getDecgrp().getRec().getRecerefund()))
			  {
			    
			    
			    
			    this.getCptp().getCpdgrp().getTde().setPreamt(this.getCpdgrp().getRec().getRemamt());
			    
			    
			    
			  }
			  else
			  {
			    
			    
			    
			    this.getCptp().getCpdgrp().getTde().setPredays(NULLSTR);
			    this.getCptp().getCpdgrp().getTde().setAmtscale(new BigDecimal(0));
			    this.getCptp().getCpdgrp().getTde().setPreamt(new BigDecimal(0));
			    
			    
			    

			  }
			  
			  
			  
			}


			return true;
        }

        /**
        *   source:cptapi.@0045.script
        */
        @Rule(target="cptp.fksmsqs",order=100)
        public boolean ruleCptpFksmsqsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.fksmflg();
			this.getCptp().getPdfviw().callPDFComponent("","fksmsqs","跨境业务人民币结算收款说明",1);

			return true;
        }

        /**
        *   source:cptapi.@0055.script
        */
        @Rule(target="cptp.decgrp.rec.bopamt1",order=100)
        public boolean ruleCptpDecgrpRecBopamt1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp()&&"Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  String bopcod1 =this.getCptp().getDecgrp().getRec().getBopcod1();

			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    if(bopcod1.startsWith("2"))
			    {
			      
			      
			      this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt1());
			    }
			  }
			  
			  
			}

			return true;
        }

        /**
        *   source:cptapi.@0056.script
        */
        @Rule(target="cptp.decgrp.rec.bopamt2",order=100)
        public boolean ruleCptpDecgrpRecBopamt2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp()&&"Z".equals(this.getCpdgrp().getRec().getKjhkflg()))
			{
			  String bopcod2 =this.getCptp().getDecgrp().getRec().getBopcod2();

			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    if(bopcod2.startsWith("2"))
			    {
			      
			      
			      this.getCpdgrp().getTde().setServiceamt(this.getCptp().getDecgrp().getRec().getBopamt2());
			    }
			  }
			  
			  
			}

			return true;
        }


        /**
        *   source:cptapi.@0036.script
        */
        @Check(target="cptp.decgrp.rec.bnkinamt",order=100)
        public boolean checkCptpDecgrpRecBnkinamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getDecgrp().getRec(),"bnkinamt"));

			return true;
        }

        /**
        *   source:cptapi.@0037.script
        */
        @Check(target="cptp.decgrp.rec.bnkoutamt",order=100)
        public boolean checkCptpDecgrpRecBnkoutamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getDecgrp().getRec(),"bnkoutamt"));

			return true;
        }

        /**
        *   source:cptapi.@0038.script
        */
        @Check(target="cptp.decgrp.rec.bopamt1",order=100)
        public boolean checkCptpDecgrpRecBopamt1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getDecgrp().getRec(),"bopamt1"));

			return true;
        }

        /**
        *   source:cptapi.@0039.script
        */
        @Check(target="cptp.decgrp.rec.bopamt2",order=100)
        public boolean checkCptpDecgrpRecBopamt2N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getDecgrp().getRec(),"bopamt2"));

			return true;
        }

        /**
        *   source:cptapi.@0047.script
        */
        @Check(target="cptp.cpdgrp.tde.serviceamt",order=100)
        public boolean checkCptpCpdgrpTdeServiceamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServiceamt()))
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getServicecod()))
			  {
			    ctx.setFieldError(this,"cpdgrp.tde.serviceamt","服务贸易金额和服务贸易交易编码同时为空或同时不为空");
			  }
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServicecod()))
			  {
			    ctx.setFieldError(this,"cpdgrp.tde.serviceamt","服务贸易金额和服务贸易交易编码同时为空或同时不为空");
			  }
			}

			return true;
        }


        /**
        *   source:cptapi.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","cptapi  init业务处理开始，ORDER编号:100");
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			if(!ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  if(Platform.isFromApp())
			  {
			    String cpdinr=(String)ctx.restoreData("cpdinr");
			    log.info("{}","1 cpdinr "+cpdinr);
			    if(MdaUtils.isEmpty(cpdinr))
			    {
			      ctx.setMessage("E9999","参数为空");
			      log.info("{}","2 cpdinr "+cpdinr);
			      return false;
			    }
			    else
			    {
			      ctx.getDaoSession().dbRead(this.getCpdgrp().getRec(),new Argument<String>("inr",cpdinr),new Argument<String>("ptyinr",this.getSysmod().getPty().getInr()));
			      if(ctx.getErrorCode() != NO_ERROR || MdaUtils.isEmpty(this.getCpdgrp().getRec().getInr()))
			      {
			        ctx.setMessage("E9999","参数不合法 ");
			        log.info("{}","3 cpdinr "+cpdinr);
			        return false;
			      }
			    }
			  }
			  else
			  {
			    IModule mdl = (IModule)ctx.restoreData("com.brilliance.cptapi.ref");
			    if(!MdaUtils.isEmpty(mdl))
			      this.getCpdgrp().getRec().copyValue(mdl);
			  }
			}
			log.info("{}","cpdinr"+this.getCpdgrp().getRec().getInr());

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    //初始化机构
			    List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			    MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			    log.info("{}","spt ordinr :"+this.getSysmod().getSpt().getOrdinr());
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			    this.dealStpmod();
			    this.dealTedgrp();
			  }
			  return true;
			}
			//初始化机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			}
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getCpdgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			ctx.getDaoSession().dbRead(this.getCptp().getSpdgrp().getCurrat(),new Argument("cur",this.getCpdgrp().getRec().getRemcur()));

			this.actamt();
			this.dealStpmod();
			this.dealTedgrp();

			return true;
        }

        /**
        *   source:cptapi.@0002.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","cptapi  init业务处理开始，order:90");
			this.dealStpmod();
			ctx.postRule(this,"cptp.cpdgrp.rec.remittype");

			return true;
        }

        /**
        *   source:cptapi.@0032.script
        */
        @Init(order=120)
        public boolean	init120(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  List<CodetableItem> codeitem1=this.getBopCod("I");
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod1",codeitem1);
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"bopcod2",codeitem1);
			  MdaUtils.setValues(this.getCptp().getCpdgrp().getTde(),"servicecod",codeitem1);
			}
			

			return true;
        }


        /**
        *   source:cptapi.@0001.script
        */
        public void flgs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//申请书展示
			//针对>7的码表在申请书展示转化
			this.getResultForList();
			//结汇
			//等值人民币、外币
			if(TRUE.equals(this.getCptp().getSpdgrp().getRec().getChkcny()))
			{
			  this.getCptp().getSpdgrp().setSpdamttyp("2");
			  this.getCptp().getSpdgrp().setSpdamt(this.getCptp().getSpdgrp().getRec().getCnyamt());
			}
			else
			{
			  this.getCptp().getSpdgrp().setSpdamttyp("1");
			  this.getCptp().getSpdgrp().setSpdamt(this.getCptp().getSpdgrp().getRec().getAmt());
			}
			String time = MdaUtils.format(this.getCptp().getSpdgrp().getRec().getCredat(),"yyyyMMdd");
			this.getCptp().getSpdgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			this.getCptp().getSpdgrp().setSpdamt(this.amtformat(this.getCptp().getSpdgrp().getSpdamt()));

			//申报
			time = MdaUtils.format(this.getCptp().getDecgrp().getRec().getRepdat(),"yyyy-MM-dd");
			this.getCptp().getDecgrp().setRepdat(time);
			//$cptp\\decgrp\\rec\\repdat.setValue(Platform.parseDate(time,"yyyyMMdd"));
			time = MdaUtils.format(this.getCptp().getDecgrp().getRec().getPaydate(),"yyyy-MM-dd");
			this.getCptp().getDecgrp().setPaydate(time);
			//$cptp\\decgrp\\rec\\paydate.setValue(Platform.parseDate(time,"yyyyMMdd"));
			
			this.getCptp().getDecgrp().getRec().setAmt(this.amtformat(this.getCptp().getDecgrp().getRec().getAmt()));
			this.getCptp().getDecgrp().getRec().setAmofsale(this.amtformat(this.getCptp().getDecgrp().getRec().getAmofsale()));
			this.getCptp().getDecgrp().getRec().setAminfx(this.amtformat(this.getCptp().getDecgrp().getRec().getAminfx()));
			this.getCptp().getDecgrp().getRec().setAmofoth(this.amtformat(this.getCptp().getDecgrp().getRec().getAmofoth()));
			this.getCptp().getDecgrp().getRec().setBnkinamt(this.amtformat(this.getCptp().getDecgrp().getRec().getBnkinamt()));
			this.getCptp().getDecgrp().getRec().setBnkoutamt(this.amtformat(this.getCptp().getDecgrp().getRec().getBnkoutamt()));
			this.getCptp().getDecgrp().getRec().setBopamt1(this.amtformat(this.getCptp().getDecgrp().getRec().getBopamt1()));
			this.getCptp().getDecgrp().getRec().setBopamt2(this.amtformat(this.getCptp().getDecgrp().getRec().getBopamt2()));

		}
        /**
        *   source:cptapi.@0007.script
        */
        public void dealStpmod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//步骤条刷新
			//0、汇入汇款性质确认申请  1、结汇申请 2、申报申请 3、申请书展示
			this.getCptp().getStpmod().storePanel(this.getCptp().getCptapi1(),this.getCptp().getCptapi2(),this.getCptp().getCptapi3(),this.getCptp().getCptapi4(),this.getCptp().getCptapi5());
			String steps = "0:汇入确认申请";

			if("1".equals(this.getCptp().getCpdgrp().getRec().getRemittype())||"2".equals(this.getCptp().getCpdgrp().getRec().getRemittype()))
			{
			  steps =steps+";1:申报申请";
			}
			if(TRUE.equals(this.getCptp().getDecgrp().getRec().getXhghchk()))
			{
			  steps =steps+";2:结汇申请";
			}
			if("Z".equals(this.getCptp().getCpdgrp().getRec().getKjhkflg()))
			{
			  steps =steps+";4:收款说明";
			}
			steps =steps+";3:申请书展示";

			
			this.initapipdf();
			this.dealcpdgrp();

			this.getCptp().getStpmod().setPages(steps);
			this.getCptp().getStpmod().calcSteps();
			this.getCptp().getStpmod().setStepBtnSta();
		}
        /**
        *   source:cptapi.@0009.script
        */
        public void dealcpdgrp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//汇入确认
			
			
			
			
			
			
			
			
			
			//Platform.disable($cpdgrp\\rec\\pyecry);
			
			
			
			
			
			
			
			
			
			
			
			

			//结汇
			
			//Platform.disable($cptp\\spdgrp\\rec\\trncod);
			//Platform.disable($cptp\\spdgrp\\rec\\trndes);
			
			
			
			
			
			
			//Platform.setModified($cptp\\spdgrp\\rec\\trncod);
			//Platform.setModified($cptp\\spdgrp\\rec\\trndes);
			
			
			
			
			
			
			

			//申报
			
			//Platform.disable($cptp\\decgrp\\rec\\unitcode);
			
			
			
			
			
			
			
			/*if(TRUE.equals($cptp\\decgrp\\rec\\xhghchk.getValue()))
			  {
			  Platform.enable($cptp\\decgrp\\rec\\amofsale);
			  Platform.enable($cptp\\decgrp\\rec\\saleact);
			  }
			  else
			  {
			  Platform.clear($cptp\\decgrp\\rec\\amofsale);
			  Platform.clear($cptp\\decgrp\\rec\\saleact);
			  Platform.disable($cptp\\decgrp\\rec\\amofsale);
			  Platform.disable($cptp\\decgrp\\rec\\saleact);
			  }*/
			//Platform.disable($cptp\\decgrp\\rec\\payer);
			
			
			//Platform.disable($cptp\\decgrp\\rec\\recerefund);
			

			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			//Platform.setModified($cptp\\decgrp\\rec\\reportnam);
			
			
			
			
			
			
			
		}
        /**
        *   source:cptapi.@0016.script
        */
        public void initapipdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//结汇
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getCptp().getSpdgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			if(MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getTrncod()))
			{
			  this.getCptp().getSpdgrp().getRec().setTrncod(this.getCptp().getDecgrp().getRec().getBopcod1());
			}
			if(MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getTrndes()))
			{
			  this.getCptp().getSpdgrp().getRec().setTrndes(this.getCptp().getDecgrp().getRec().getBoprmk1());
			}
			//$cptp\\spdgrp\\rec\\cur.setValue($cpdgrp\\rec\\remcur.getValue());
			//$cptp\\spdgrp\\rec\\amt.setValue($cptp\\decgrp\\rec\\amofsale.getValue());
			this.getCptp().getSpdgrp().getRec().setSptcno(this.getCpdgrp().getRec().getFmdno());
			this.getCptp().getSpdgrp().getRec().setPtycno(this.getSysmod().getPty().getAtccod());
			//$cptp\\spdgrp\\rec\\zbjbennam.setValue($cpdgrp\\rec\\payeenameapp.getValue());
			if(MdaUtils.isEmpty(this.getCptp().getSpdgrp().getRec().getLnknam()))
			{
			  this.getCptp().getSpdgrp().getRec().setLnknam(this.getSysmod().getPty().getNam());
			}

			//申报
			this.getCptp().getDecgrp().getRec().setPayee(this.getSysmod().getPty().getNam());
			time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getCptp().getDecgrp().getRec().setRepdat(MdaUtils.parseDate(time,"yyyyMMdd"));
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getUnitin()))
			{
			  this.getCptp().getDecgrp().getRec().setUnitin("1");
			}
			this.getCptp().getDecgrp().getRec().setUnitcode(this.getSysmod().getPty().getAtccod());
			this.getCptp().getDecgrp().getRec().setCur(this.getCpdgrp().getRec().getRemcur());
			this.getCptp().getDecgrp().getRec().setAmt(this.getCpdgrp().getRec().getRemamt());
			this.getCptp().getDecgrp().getRec().setBopcur1(this.getCpdgrp().getRec().getRemcur());
			this.getCptp().getDecgrp().getRec().setBopcur2(this.getCpdgrp().getRec().getRemcur());
			/*
			  if(TRUE.equals($cptp\\decgrp\\rec\\xhghchk.getValue()))
			  {
			  $cptp\\decgrp\\rec\\decrat.setValue($cptp\\spdgrp\\currat\\midrat.getValue());
			  }
			  else
			  {
			  Platform.clear($cptp\\decgrp\\rec\\decrat);
			  }*/
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getAmofsale())&&MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getAminfx())&&MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getAmofoth()))
			{
			  this.getCptp().getDecgrp().getRec().setAmofsale(this.getCptp().getDecgrp().getRec().getAmt());
			}
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBnkoutcur()))
			{
			  this.getCptp().getDecgrp().getRec().setBnkoutcur(this.getCpdgrp().getRec().getGfrcur());
			}
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBnkoutamt()))
			{
			  this.getCptp().getDecgrp().getRec().setBnkoutamt(this.getCpdgrp().getRec().getGframt());
			}
			String cpdpayer = this.getCpdgrp().getRec().getPaynam();
			if(!MdaUtils.isEmpty(cpdpayer)&&cpdpayer.length()>100)
			  this.getCptp().getDecgrp().getRec().setPayer(cpdpayer.substring(0, 100));
			else
			  this.getCptp().getDecgrp().getRec().setPayer(cpdpayer);
			this.getCptp().getDecgrp().getRec().setCrofpc(this.getCpdgrp().getRec().getPyecry());
			this.getCptp().getDecgrp().getRec().setCrofpn(this.getCpdgrp().getRec().getCountryname());
			/*if("A".equals($cpdgrp\\rec\\payeetrantype.getValue()))
			  {
			  $cptp\\decgrp\\rec\\recerefund.setValue("1");
			  }
			  else
			  {
			  $cptp\\decgrp\\rec\\recerefund.setValue("2");
			  }*/
			this.getCptp().getDecgrp().getRec().setRef(this.getCpdgrp().getRec().getFmdno());

			if("1".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"inctyp",MdaUtils.getCodetable("inctyp"));
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"recerefund",MdaUtils.getCodetable("recerefund"));

			}
			else if("2".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"inctyp",MdaUtils.getCodetable("inctyp1"));
			  MdaUtils.setValues(this.getCptp().getDecgrp().getRec(),"recerefund",MdaUtils.getCodetable("sf"));

			}
			else
			{
			  this.getCptp().getDecgrp().getRec().setInctyp(NULLSTR);
			}
			if(MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getReportnam()))
			{
			  this.getCptp().getDecgrp().getRec().setReportnam(this.getSysmod().getUsr().getOprnam());
			}
			//付款说明申请书
			if("Z".equals(this.getCptp().getCpdgrp().getRec().getKjhkflg()))
			{
			  

			}
			else
			{

			  
			}
			//结汇申请书
			if(TRUE.equals(this.getCptp().getDecgrp().getRec().getXhghchk())&&("T".equals(this.getCptp().getSpdgrp().getActnosta())))
			{
			  
			  
			}
			else
			{
			  
			  
			}
			//申报申请书
			if("1".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  
			  
			  
			  
			}
			else if("2".equals(this.getCpdgrp().getRec().getRemittype()))
			{
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
		}
        /**
        *   source:cptapi.@0020.script
        */
        public BigDecimal amtformat(BigDecimal amt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			return amt;
		}
        /**
        *   source:cptapi.@0031.script
        */
        public List<CodetableItem> getBopCod(String direction)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//交易编码下拉
			List<CodetableItem> items = new ArrayList<CodetableItem>();
			String selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'I' ";
			if ("I".equals(direction))
			{
			  selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'I' ";
			}
			if ("O".equals(direction))
			{
			  selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'O' ";
			}

			/*if(!Platform.isEmpty($cptp\\decgrp\\rec\\bopcod1.getValue()))
			  {
			  String codOrTxt = $cptp\\decgrp\\rec\\bopcod1.getValue();
			  selCodlst = selCodlst + " AND (cod LIKE '%"+ codOrTxt +"%' OR txt LIKE '%"+ codOrTxt +"%')";
			  }
			  */
			ctx.getDaoSession().dbExecuteSQL(selCodlst);
			ctx.getErrorCode();
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> dir = new Argument<String>("dir");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> txt = new Argument<String>("txt");
			Argument<String> typ = new Argument<String>("typ");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,dir,sta,txt,typ);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem c = new CodetableItem(cod.value.trim() + "-" + txt.value,cod.value);
			    items.add(c);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return items;
		}
        /**
        *   source:cptapi.@0033.script
        */
        public String getStringForTable(String s)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//用于把大于6的码表转成字符串进行显示（之后会改jar包）
			String result = "";
			if(s==null || s.trim().equals(""))
			{
			  return result;
			}

			int num = Integer.parseInt(s);
			num--;
			for(int i=0;i<num;i++){
			  result+=",";
			}
			result+="√";
			return result;
		}
        /**
        *   source:cptapi.@0034.script
        */
        public void getResultForList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String s1 = this.getStringForTable(this.getCptp().getDecgrp().getRec().getPqymethod());
			this.getCptp().getDecgrp().setMethodslst(s1);

			String s2 = this.getStringForTable(this.getCptp().getDecgrp().getRec().getInctyp());
			this.getCptp().getDecgrp().setPayttrlst(s2);

			String s3 = this.getStringForTable(this.getCptp().getSpdgrp().getRec().getSpdtyp());
			this.getCptp().getSpdgrp().setSpdtyplst(s3);

			String s4 = this.getStringForTable(this.getCptp().getSpdgrp().getRec().getUseoff());
			this.getCptp().getSpdgrp().setUseofflst(s4);

		}
        /**
        *   source:cptapi.@0035.script
        */
        public void actamt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//处理业务账号，金额  ，申请书在initapipdf处理
			//是否生成结汇申请书
			String str = "O";
			String actno = "";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPyeact())&&(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur())))
			{
			  actno = this.getCpdgrp().getRec().getPyeact().substring(4,6);
			  log.info("{}","pyeact:" + this.getCpdgrp().getRec().getPyeact() +  " actno: "+ actno );
			  if("01".equals(actno))
			  {
			    if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			    {
			      //当报文的汇入币种为人民币，而收款人账号的5、6位为01时）（例子：35000180809881937），
			      //自动勾选其他金额，并将填写其他金额，不生成“结汇申请书”。
			      //其他金额
			      str = "F";
			      this.getCptp().getDecgrp().getRec().setAmofoth(this.getCpdgrp().getRec().getRemamt());
			      this.getCptp().getDecgrp().getRec().setOthact(this.getCpdgrp().getRec().getPyeact());
			      this.getCptp().getSpdgrp().getRec().setCur(NULLSTR);
			      this.getCptp().getSpdgrp().getRec().setAmt(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setAmofsale(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setSaleact(NULLSTR);
			      this.getCptp().getDecgrp().getRec().setAminfx(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setFxact(NULLSTR);
			      
			      
			      
			      
			      
			      
			      this.getCptp().getDecgrp().getRec().setXhghchk(NULLSTR);
			      
			      this.getCptp().getDecgrp().getRec().setDecrat(new BigDecimal(0));
			    }
			    else
			    {
			      //当报文的汇入币种为外币，而收款人账号的5、6位为01时）（例子：35000180809881937），
			      //自动勾选结汇，显示结汇汇率，并将填写结汇金额，不可勾选“购汇”选项，但是不生成“结汇申请书”。
			      //结汇，（直接结汇），无结汇界面，不生成“结汇申请书
			      str = "F";
			      this.getCptp().getDecgrp().getRec().setAmofsale(this.getCpdgrp().getRec().getRemamt());
			      this.getCptp().getDecgrp().getRec().setSaleact(this.getCpdgrp().getRec().getPyeact());
			      this.getCptp().getDecgrp().getRec().setDecrat(this.getCptp().getSpdgrp().getCurrat().getMidrat());
			      this.getCptp().getSpdgrp().getRec().setCur(this.getCpdgrp().getRec().getRemcur());
			      this.getCptp().getSpdgrp().getRec().setAmt(this.getCpdgrp().getRec().getRemamt());
			      this.getCptp().getDecgrp().getRec().setAminfx(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setFxact(NULLSTR);
			      this.getCptp().getDecgrp().getRec().setAmofoth(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setOthact(NULLSTR);
			      
			      
			      
			      
			      
			      
			      
			      this.getCptp().getDecgrp().getRec().setXhghchk(NULLSTR);
			    }
			  }
			  else
			  {
			    if(!"CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			    {
			      //当报文的汇入币种为外币，而收款人账号的5、6位非01时）（例子：35001488000056107），
			      //自动勾选现汇,并将填写现汇金额，勾选项“银行代办结汇”，生成“结汇申请书”。
			      //现汇,(现汇下结汇)生成“结汇申请书”。
			      str = "T";
			      this.getCptp().getDecgrp().getRec().setAminfx(this.getCpdgrp().getRec().getRemamt());
			      this.getCptp().getDecgrp().getRec().setFxact(this.getCpdgrp().getRec().getPyeact());
			      this.getCptp().getSpdgrp().getRec().setCur(this.getCpdgrp().getRec().getRemcur());
			      this.getCptp().getSpdgrp().getRec().setAmt(this.getCpdgrp().getRec().getRemamt());
			      this.getCptp().getDecgrp().getRec().setAmofsale(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setSaleact(NULLSTR);
			      this.getCptp().getDecgrp().getRec().setAmofoth(new BigDecimal(0));
			      this.getCptp().getDecgrp().getRec().setOthact(NULLSTR);
			      
			      
			      
			      
			      
			      
			      
			      //$cptp\\decgrp\\rec\\xhghchk.setValue("X");
			      this.getCptp().getDecgrp().getRec().setDecrat(new BigDecimal(0));

			    }

			  }

			}
			this.getCptp().getSpdgrp().setActnosta(str);
		}
        /**
        *   source:cptapi.@0043.script
        */
        public void dealTedgrp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			
			
			
			
			
			
			
			
			
			
			
			
			String bopcod2 =this.getCptp().getDecgrp().getRec().getBopcod2();
			String bopcod1 =this.getCptp().getDecgrp().getRec().getBopcod1();
			if("Z".equals(this.getCptp().getCpdgrp().getRec().getKjhkflg())&&!ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sptIsLoaded("B"))
			{
			  
			  this.getCpdgrp().getTde().setGathdat(MdaUtils.today());
			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getPayee()))
			  {
			    this.getCpdgrp().getTde().setGathname(this.getCptp().getDecgrp().getRec().getPayee());

			  }
			  else
			  {
			    this.getCpdgrp().getTde().setGathname(this.getSysmod().getPty().getNam());
			  }
			  this.getCpdgrp().getTde().setSocialcrdtcd(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getCifno());
			  this.getCpdgrp().getTde().setTotalamt(this.getCpdgrp().getRec().getRemamt());
			  
			  
			  
			}
			if(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sptIsLoaded("B")&&"Z".equals(this.getCptp().getCpdgrp().getRec().getKjhkflg()))
			{

			  
			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			  {
			    if(bopcod2.startsWith("2"))
			    {
			      
			      
			    }
			  }
			  if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			  {
			    if(bopcod1.startsWith("2"))
			    {
			      
			      
			    }
			  }
			  if("1".equals(this.getCptp().getDecgrp().getRec().getRecerefund()))
			  {
			    
			    
			    
			    
			    
			    
			  }
			  if("2".equals(this.getCpdgrp().getTde().getTranssta())||"3".equals(this.getCpdgrp().getTde().getTranssta()))
			  {
			    
			    
			    
			    
			    if("121010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())||"121010".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      
			    }

			    if("121080".equals(this.getCptp().getDecgrp().getRec().getBopcod1())||"121080".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      
			    }
			    if("121020".equals(this.getCptp().getDecgrp().getRec().getBopcod1())||"121020".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      
			    }
			    if(!"121020".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121020".equals(this.getCptp().getDecgrp().getRec().getBopcod2())
			      &&!"121080".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121080".equals(this.getCptp().getDecgrp().getRec().getBopcod2())
			    &&!"121010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121010".equals(this.getCptp().getDecgrp().getRec().getBopcod2())
			    )
			    {

			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			      {
			        if(!bopcod1.startsWith("2"))
			        {
			          
			        }
			      }
			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			      {
			        if(!bopcod2.startsWith("2"))
			        {
			          
			        }
			      }

			    }
			  }
			  if("4".equals(this.getCpdgrp().getTde().getTranssta()))
			  {
			    if("121030".equals(this.getCptp().getDecgrp().getRec().getBopcod1())||"121030".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      
			    }
			    if("122010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())||"122010".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {
			      
			    }
			    if(!"122010".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"122010".equals(this.getCptp().getDecgrp().getRec().getBopcod2())
			      &&!"121030".equals(this.getCptp().getDecgrp().getRec().getBopcod1())&&!"121030".equals(this.getCptp().getDecgrp().getRec().getBopcod2()))
			    {

			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod1()))
			      {
			        if(!bopcod1.startsWith("2"))
			        {
			          
			        }
			      }
			      if(!MdaUtils.isEmpty(this.getCptp().getDecgrp().getRec().getBopcod2()))
			      {
			        if(!bopcod2.startsWith("2"))
			        {
			          
			        }
			      }
			    }
			  }
			}

			
			
			
			
			
			
			
			
			
			
			

		}
        /**
        *   source:cptapi.@0046.script
        */
        public void fksmflg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//付款说明
			if(!MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getTranssta()))
			{
			  if("2".equals(this.getCptp().getCpdgrp().getTde().getTranssta()))
			  {
			    this.getCptp().getCpdgrp().setTranssta("1");
			  }
			  if("3".equals(this.getCptp().getCpdgrp().getTde().getTranssta()))
			  {
			    this.getCptp().getCpdgrp().setTranssta("2");
			  }
			}
		}
        /**
        *   source:cptapi.@0049.script
        */
        public BigDecimal sumTradeamt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal sumamt = new BigDecimal("0");
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getGenamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getGenamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getBjmyamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getBjmyamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getPreamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getPreamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getJljgamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getJljgamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getOthtradeamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getOthtradeamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getCustamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getCustamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getLeaveamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getLeaveamt());

			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getOtheramt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getOtheramt());

			}
			return sumamt;

		}
        /**
        *   source:cptapi.@0051.script
        */
        public boolean fukuanCheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//统一社会信用代码
			if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getSocialcrdtcd()))
			{
			  ctx.setMessage("E9999","收款说明中统一社会信用代码必输");
			  return false;
			}

			//服务贸易金额
			if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServiceamt()))
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getServicecod()))
			  {

			    ctx.setMessage("E9999","收款说明中服务贸易金额和服务贸易交易编码同时为空或同时不为空");
			    return false;

			  }
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServicecod()))
			  {

			    ctx.setMessage("E9999","收款说明中服务贸易金额和服务贸易交易编码同时为空或同时不为空");
			    return false;

			  }
			}
			//贸易金额
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getTranssta())&&!"1".equals(this.getCpdgrp().getTde().getTranssta()))
			{
			  //计算货物贸易金额
			  BigDecimal tradeamt=sumTradeamt();
			  BigDecimal ntradeamt=this.getCpdgrp().getTde().getTradeamt();
			  if(tradeamt.compareTo(ntradeamt) != 0)
			  {
			    ctx.setMessage("E9999","收款说明中货物贸易金额填写有误，货物贸易金额等于预收货款金额与各交易金额之和");
			    return false;
			  }
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getTranssta())&&!MdaUtils.isEmpty(this.getCpdgrp().getTde().getPreamt()))
			{
			  BigDecimal preamt=this.getCpdgrp().getTde().getPreamt();
			  BigDecimal ptradeamt=this.getCpdgrp().getTde().getTradeamt();
			  if(preamt.compareTo(ptradeamt) != 0)
			  {
			    ctx.setMessage("E9999","收款说明中货物贸易金额填写有误，货物贸易金额等于预收货款金额与各交易金额之和");
			    return false;
			  }
			}

			//收款合计
			BigDecimal sumamt = new BigDecimal("0");
			BigDecimal totalamt=this.getCpdgrp().getTde().getTotalamt();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getTradeamt()))
			{
			  sumamt=sumamt.add(this.getCpdgrp().getTde().getTradeamt());
			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getServiceamt()))
			{
			  sumamt= sumamt.add(this.getCpdgrp().getTde().getServiceamt());
			}
			if(totalamt.compareTo(sumamt) != 0)
			{
			  ctx.setMessage("E9999","收款说明中收款金额合计与货物贸易金额、服务贸易金额之和不等");
			  return false;
			}

			//预收款
			if("1".equals(this.getCptp().getDecgrp().getRec().getRecerefund()))
			{
			  if(MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getPreamt()))
			  {
			    ctx.setMessage("E9999","收款说明中选则预收款后，预收货款金额必输");
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getAmtscale()))
			  {
			    ctx.setMessage("E9999","收款说明中选则预收款后，预收货款占合同比例必输");
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getCptp().getCpdgrp().getTde().getPredays()))
			  {
			    ctx.setMessage("E9999","收款说明中选则预收款后，预计报关时间必输");
			    return false;
			  }
			}
			//物流状态
			if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getTranssta()))
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getTde().getTradeamt()))
			  {

			    ctx.setMessage("E9999","收款说明中货物贸易金额和物流状态同时为空或同时不为空");
			    return false;

			  }
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getTradeamt()))
			  {

			    ctx.setMessage("E9999","收款说明中货物贸易金额和物流状态同时为空或同时不为空");
			    return false;

			  }
			}
			//报关经营单位
			if("2".equals(this.getCpdgrp().getTde().getTranssta())||"3".equals(this.getCpdgrp().getTde().getTranssta()))
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServicenam()))
			  {

			    ctx.setMessage("E9999","收款说明中物流状态选择人民币或外币报关时，报关单经营单位名称必输");
			    return false;

			  }

			  if(MdaUtils.isEmpty(this.getCpdgrp().getTde().getServiceorgcod()))
			  {

			    ctx.setMessage("E9999","收款说明中物流状态选择人民币或外币报关时，报关单经营单位名称必输");
			    return false;

			  }
			}

			return true;
		}








}