package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Cptapi0VO;

import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇入确认申请入口交易
*/
@Transaction(vo= Cptapi0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptapi0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptapi0.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Cptapi0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:cptapi0.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String queryClause = "select rec.inr as trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,s.dattim dat,p.adrblk bennam FROM spt s "
			  +" LEFT JOIN cpd rec ON s.objinr = rec.inr AND s.objtyp='cpd' "
			  +" LEFT JOIN pts p ON p.objtyp='cpd' AND p.objinr=rec .inr AND p.rol='ben'  where s.frm = 'cptyub'  and rec.dty = 'O' "
			  + $\\sysmod.getSelection();
			  */

			if(Platform.isFromApp())
			{
			  log.info("{}","手机端");
			  return this.getSelp().queryBtnApp();
			}
			else
			{
			  String queryClause = "select rec.inr as trsinr,rec.kjhkflg kjhkflg,rec.stlref ref,rec.remcur cur,rec.remamt amt,rec.advdat dat,p.adrblk aplnam FROM cpd rec,pts p  "
			    +" where rec.dty = 'O' AND p.rol = 'apl' AND p.objtyp = 'cpd' AND p.objinr = rec.inr "
			    + ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			  log.info("{}","PC端");
			}


			return true;
        }

        /**
        *   source:cptapi0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("cpdgrp","cptapi");

			return true;
        }

        /**
        *   source:cptapi0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("cpdgrp","cptapi");

			return true;
        }



        /**
        *   source:cptapi0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.setValues($selp\\seltyp,Platform.getCodetable("sellitame"));
			//$selp\\seltyp.setValue("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			/*
			  String queryClause = "select rec.inr as trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,s.dattim dat,p.adrblk bennam FROM spt s "
			  +" LEFT JOIN cpd rec ON s.objinr = rec.inr AND s.objtyp='cpd' "
			  +" LEFT JOIN pts p ON p.objtyp='cpd' AND p.objinr=rec .inr AND p.rol='ben'  where s.frm = 'cptyub' and rec.dty = 'O' "
			  + $\\sysmod.getSelection();
			  */
			String queryClause = "select rec.inr as trsinr,rec.kjhkflg kjhkflg,rec.stlref ref,rec.remcur cur,rec.remamt amt,rec.advdat dat,p.adrblk aplnam FROM cpd rec,pts p  "
			  +" where rec.dty = 'O' AND p.rol = 'apl' AND p.objtyp = 'cpd' AND p.objinr = rec.inr "
			  + ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }






}