package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptaplVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇入汇款性质确认申请交易
*/
@Transaction(vo= CptaplVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptapl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptapl.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Swmmod swmmod;


		public Cptapl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptapl.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptapl.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptapl.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptapl.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptapl.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
        }

        /**
        *   source:cptapl.@0005.script
        */
        @Rule(target="cptp.stpmod.next",order=50)
        public boolean ruleCptpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getCpdgrp().getRec()))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:cptapl.@0006.script
        */
        @Rule(target="cptp.rmbbut",order=100)
        public boolean ruleCptpRmbbutN100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getCptp().getActmod().setAct("CNY");


			return true;
        }

        /**
        *   source:cptapl.@0007.script
        */
        @Rule(target="cptp.cancel",order=100)
        public boolean ruleCptpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptapl.@0009.script
        */
        @Rule(target="cptp.stpmod.next",order=80)
        public boolean ruleCptpStpmodNextN80(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:cptapl.@0011.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cptinf=this.getCpdgrp().getRec().getCptinf();
			IStream stream=this.getMtabut().getApldoc();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getCptinf()))
			{
			  //		IStream stream=$mtabut\\apldoc.getValue();
			  ctx.absGet(Sysmod.class).generatorPdf("","cptapl",stream,false);
			}
			else
			{
			  ctx.absGet(Sysmod.class).generatorPdf("","cptapl1",stream,false);
			}


			return true;
        }

        /**
        *   source:cptapl.@0019.script
        */
        @Rule(target="mtabut.sel1",order=100)
        public boolean ruleMtabutSel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCty().setEngnam(NULLSTR);
			
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			//Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:cptapl.@0020.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($cpdgrp\\rec\\bchcod))
			  {
			  Platform.message(#CT000020,#CT000021);
			  return false;
			  }*/

			if(!ctx.checkAll(this.getCpdgrp().getRec()))
			{
			  log.warn("{}","申请页面校验未通过，退出");
			  return false;
			}
			String objinr = "";

			if(!ctx.checkAll(this.getCpdgrp()))
			  return false;
			if(!MdaUtils.isEmpty(this.getTrnmod().getTrninr()))
			{
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			}
			else
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    objinr = this.getCpdgrp().getRec().getInr();
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getApl().getPts(),objinr);
			  }
			  else
			  {
			    this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getRec());
			    objinr = this.getCpdgrp().getRec().getInr();
			    String objtyp = "cpd";
			    this.getCpdgrp().getApl().savpts(objinr,objtyp);
			  }
			}

			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cptapl.@0022.script
        */
        @Rule(target="mtabut.returnd",order=100)
        public boolean ruleMtabutReturndN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","汇入授权退回");
			this.getMtabut().setThly("尊敬的客户，该笔业务需要调整，请修改或发起新业务后提交审核!");
			//Platform.clear($dtrn);
			//Platform.dbRead($dtrn,new Argument<String>("inr",$trnmod\\trninr.getValue()));
			/*
			  String inr = $cpdgrp\\rec\\inr.getValue();
			  Map sendMap = new HashMap();
			  sendMap.put("MsgNo","SFS118");
			  sendMap.put("inr",inr);
			  sendMap.put("code","SFS118");
			  sendMap.put("EntMarkNo",$cpdgrp\\rec\\stlref.getValue());
			  $mtabut\\swimap.setValue(sendMap);
			  */
			
			log.info("{}","sw back end !");

			return true;
        }

        /**
        *   source:cptapl.@0023.script
        */
        @Rule(target="mtabut.backswi",order=150)
        public boolean ruleMtabutBackswiN150(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.setMessage(MdaUtils.getI18NString("cptapl","CT000026"),MdaUtils.getI18NString("cptapl","CT000027"));
			ctx.getDaoSession().dbBegin();
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",this.getTrnmod().getTrninr()));
			String frm=this.getTrnmod().getTrn().getInifrm();
			String ownref =this.getTrnmod().getTrn().getOwnref();
			String thly =this.getMtabut().getThly();
			String msgref = this.getCpdgrp().getRec().getMsgref();
			Map sendMap = new HashMap();
			sendMap.put("TransId",this.getCpdgrp().getRec().getTransid());
			sendMap.put("OutBankStatus","");
			sendMap.put("Reason",thly);
			sendMap.put("SendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss"));
			sendMap.put("ImgStatusAll","");
			sendMap.put("buscod",ownref);
			sendMap.put("djcod",ownref);
			//企业退回
			sendMap.put("TransStatus","02");
			if("cptapl".equals(frm))
			{
			  sendMap.put("MsgNo","SFS118");
			  sendMap.put("inr",this.getTrnmod().getTrn().getObjinr());
			  sendMap.put("code","SFS118");
			  sendMap.put("EntMarkNo",this.getCpdgrp().getRec().getDstlref());
			  this.getSysmod().setImageMapSwi(sendMap);
			  this.getSysmod().setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);
			  this.getSwmmod().storeSWM("SFS118",this.getTrnmod().getTrn().getObjinr(),this.getTrnmod().getTrn().getObjtyp(),sendMap);
			}
			else
			{
			  sendMap.put("MsgNo","SFS113");
			  sendMap.put("inr",this.getTrnmod().getTrn().getObjinr());
			  sendMap.put("code","SFS113");
			  sendMap.put("OutBankStatus","");
			  this.getSysmod().setImageMapSwi(sendMap);
			  this.getSysmod().setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);
			  this.getSwmmod().storeSWM("SFS113",this.getTrnmod().getTrn().getObjinr(),this.getTrnmod().getTrn().getObjtyp(),sendMap);
			}

			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","snap file is :"+filename);
			ctx.saveDisplay(filename);
			//$sysmod.insOpeLog($trnmod\\trn\\objtyp.getValue(),$trnmod\\trn\\ownref.getValue());
			this.getTrnmod().getTrn().setSta("A");
			this.getTrnmod().getTrn().setWfm("D");
			this.getTrnmod().getTrn().setPtyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setOptptyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setOptetyinr(this.getSysmod().getEty().getInr());
			this.getTrnmod().getTrn().setOptetginr(this.getSysmod().getEtg().getInr());
			this.getTrnmod().getTrn().setCpldattim( MdaUtils.today());
			this.getTrnmod().getTrn().setNxtreq("");

			ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());

			String ordinr=this.getTrnmod().getTrn().getOrdinr();
			this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","8",this.getRmkmod().getNtext());
			String txt= "" ;
			this.getRmkmod().getRmk().setOrdinr(ordinr);
			String userName = ctx.absGet(Sysmod.class).getLoginUserName();
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String roleName = "企业用户";
			if("0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  roleName = "银行柜员";
			}
			txt =roleName + userName + " " + time + " 业务退回单一窗口,退回原因："+this.getMtabut().getThly();
			if(!MdaUtils.isEmpty(this.getRmkmod().getNtext()))
			{
			  txt= txt+ CR + this.getRmkmod().getNtext();
			}
			this.getRmkmod().getRmk().setTxt(txt);
			this.getRmkmod().getRmk().setFlg("");
			this.getRmkmod().getRmk().setTrninr(this.getTrnmod().getTrn().getInr());
			this.getRmkmod().getRmk().setDattim(new Date());
			this.getRmkmod().getRmk().setInr(Platform.sdbCounter("rmk"));
			ctx.getDaoSession().dbInsert(this.getRmkmod().getRmk());
			log.info("{}","新建退回备注：inr = " + this.getRmkmod().getRmk().getInr()+",备注内容="+txt);

			if(ctx.getErrorCode() == ERROR_SQL)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptapl","CT000030"),MdaUtils.getI18NString("cptapl","CT000031"));
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getDaoSession().dbCommit();
			this.getMtabut().setThly(NULLSTR);
			

			return true;
        }

        /**
        *   source:cptapl.@0024.script
        */
        @Rule(target="cptp.actmod.actslt",order=100)
        public boolean ruleCptpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCptp().getActmod().getActlst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptapl","CT000042"),MdaUtils.getI18NString("cptapl","CT000043"));
			  return true;
			}
			this.getCpdgrp().getRec().setRmbact(this.getCptp().getActmod().getActlst().getElement(index).getAct());
			
			

			return true;
        }

        /**
        *   source:cptapl.@0026.script
        */
        @Rule(target="cpdgrp.rec.jaccamt",order=100)
        public boolean ruleCpdgrpRecJaccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getJaccamt()))
			{
			  if("JPY".equals(this.getCpdgrp().getRec().getJacccur()))
			  {
			    BigDecimal amt1 = this.getCpdgrp().getRec().getJaccamt();
			    amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0"));
			    this.getCpdgrp().getRec().setJaccamt(amt1);
			    
			  }
			}

			return true;
        }

        /**
        *   source:cptapl.@0027.script
        */
        @Rule(target="cpdgrp.rec.jacccur",order=100)
        public boolean ruleCpdgrpRecJacccurN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"cpdgrp.rec.jaccamt");

			return true;
        }

        /**
        *   source:cptapl.@0030.script
        */
        @Rule(target="mtabut.imgviw",order=100)
        public boolean ruleMtabutImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}"," in imgviw....");
			this.getTrnmod().getItfmod().getImgmod().imgScans(this.getTrnmod().getTrninr());

			return true;
        }


        /**
        *   source:cptapl.@0028.script
        */
        @Check(target="cpdgrp.rec.jaccamt",order=100)
        public boolean checkCpdgrpRecJaccamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getCpdgrp().getRec().getAccfs()))
			{
			  BigDecimal jac=this.getCpdgrp().getRec().getJaccamt();
			  BigDecimal rem=this.getCpdgrp().getRec().getRemamt();
			  BigDecimal chk=MdaUtils.parseDecimal("0.00");
			  if(!MdaUtils.isEmpty(jac))
			  {
			    if((jac.compareTo(rem)>0))
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.jaccamt",MdaUtils.getI18NString("cptapl","CT000050"));
			      return false;
			    }
			    if(!(jac.compareTo(chk)>0))
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.jaccamt",MdaUtils.getI18NString("cptapl","CT000051"));
			      return false;
			    }
			  }
			}
			

			return true;
        }

        /**
        *   source:cptapl.@0029.script
        */
        @Check(target="cpdgrp.rec.jacccur",order=100)
        public boolean checkCpdgrpRecJacccurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getCpdgrp().getRec().getAccfs())&&"CNY".equals(this.getCpdgrp().getRec().getJacccur()))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.jacccur",MdaUtils.getI18NString("cptapl","CT000055"));
			  return false;
			}

			return true;
        }

        /**
        *   source:cptapl.@0031.script
        */
        @Check(target="cpdgrp.rec.rmbact",order=100)
        public boolean checkCpdgrpRecRmbactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getCpdgrp().getRec().getAccfs()))
			{
			  String rmbact=this.getCpdgrp().getRec().getRmbact();
			  if(MdaUtils.isEmpty(rmbact))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("cptapl","CT000077"),MdaUtils.getI18NString("cptapl","CT000078"));
			    return false;
			  }
			  else
			  {
			    if(rmbact.length()<6)
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.rmbact",MdaUtils.getI18NString("cptapl","CT000079"));
			      return false;
			    }
			    String act=rmbact.substring(4,6);
			    if(!"01".equals(act))
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.rmbact",MdaUtils.getI18NString("cptapl","CT000080"));
			      return false;
			    }
			  }
			}

			return true;
        }


        /**
        *   source:cptapl.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","init cptapl ="+this.getCpdgrp().getRec().getRemcur());
			//归属机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			
			//ord
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			IModule cpd = (IModule)ctx.restoreData("com.brilliance.cptapl.ref");
			if(!MdaUtils.isEmpty(cpd))
			{
			  this.getCpdgrp().getRec().copyValue(cpd);
			  String inrs=(String)ctx.restoreData("com.brilliance.inr.ref");
			  this.getTrnmod().setTrninr(inrs);
			  log.debug("{}","trninr  is  :"+inrs);
			}
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P") || ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //使用退回功能时判断
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			//初始化汇款方式限制
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getTransid()))
			{
			  this.getCpdgrp().getRec().setTransid(this.getCpdgrp().getRec().getOwnref());
			  
			}

			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			

			this.getCpdgrp().getRec().setBopcur1(this.getCpdgrp().getRec().getRemcur());
			this.getCpdgrp().getRec().setBopcur2(this.getCpdgrp().getRec().getRemcur());

			this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			log.debug("{}","pty inr==="+this.getSysmod().getPty().getInr());
			log.debug("{}","aplnam==="+this.getCpdgrp().getAplnam());
			this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			
			

			this.getCpdgrp().setOprnam(this.getSysmod().getUsr().getOprnam());
			

			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getCpdres()))
			{
			  this.getCpdgrp().getRec().setCpdres("D");
			}

			
			
			if("2".equals(this.getCpdgrp().getRec().getAccfs()))
			{
			  this.getCpdgrp().getRec().setJacccur(this.getCpdgrp().getRec().getRemcur());
			  this.getCpdgrp().getRec().setRmbact(this.getCpdgrp().getRec().getPyeact());
			  
			  //Platform.enable($cpdgrp\\rec\\rmbact);
			  
			  
			  //Platform.enable($cptp\\rmbbut);
			  
			  
			  

			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }











}