package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptfreVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇出汇款杂项处理申请
*/
@Transaction(vo= CptfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptfre.class);

        //模板文本
        private String fixtxt1;
        //模板文本2
        private String fixtxt2;
        //模板文本3
        private String fixtxt3;
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Cptfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptfre.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptfre.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptfre.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptfre.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptfre.this.getCpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:cptfre.@0001.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setOprtxt();
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","cptfre",stream,false );

			return true;
        }

        /**
        *   source:cptfre.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getCpdgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;

			BigDecimal rem=MdaUtils.parseDecimal(MdaUtils.format(this.getCpdgrp().getRec().getRemamt(),"#0.00"));
			this.getCpdgrp().getRec().setRemamt(rem);

			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("cpd");
			this.getAfdgrp().getRec().setObjinr(this.getCpdgrp().getRec().getInr());
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			setOprtxt();
			this.getCptp().setDataForSPT();
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;

			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:cptfre.@0004.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt afdgrp.rec.oprtyp ... opttyp " + this.getAfdgrp().getRec().getOprtyp());
			//  $this.setSubPanelByOprtyp($afdgrp\\rec\\oprtyp.getValue());
			
			if("1".equals(this.getAfdgrp().getRec().getOprtyp()))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre04());
			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(this.getAfdgrp().getRec().getOprtyp()))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre02());
			  
			  
			  
			  
			  
			  
			}
			if("3".equals(this.getAfdgrp().getRec().getOprtyp()))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre03());
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:cptfre.@0012.script
        */
        @Rule(target="cptp.retflg",order=100)
        public boolean ruleCptpRetflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","onchange retflg");
			if(MdaUtils.isEmpty(this.getCptp().getRetflg()))
			{
			  this.getCptp().setRetflg2( "X");
			}
			else
			{
			  this.getCptp().setRetflg2(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:cptfre.@0013.script
        */
        @Rule(target="cptp.retflg2",order=100)
        public boolean ruleCptpRetflg2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCptp().getRetflg2()))
			{
			  this.getCptp().setRetflg( "X");

			}
			else
			{
			  this.getCptp().setRetflg(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:cptfre.@0014.script
        */
        @Rule(target="cptp.return",order=100)
        public boolean ruleCptpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptfre.@0015.script
        */
        @Rule(target="cptp.afdgrp.rec.bchcod",order=100)
        public boolean ruleCptpAfdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  this.getCpdgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());

			return true;
        }

        /**
        *   source:cptfre.@0016.script
        */
        @Rule(target="mtabut.ped",order=150)
        public boolean ruleMtabutPedN150(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setDataForSPT();

			return true;
        }

        /**
        *   source:cptfre.@0017.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setOprtxt();
			BigDecimal rem=MdaUtils.parseDecimal(MdaUtils.format(this.getCpdgrp().getRec().getRemamt(),"#0.00"));
			this.getCpdgrp().getRec().setRemamt(rem);
			
			this.getCptp().getPdfviw().callPDFComponent("","cptfre","汇出汇款杂项申请",1);

			return true;
        }

        /**
        *   source:cptfre.@0018.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "汇出汇款杂项申请";
			String tempfiles = "A:cptfre";
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }



        /**
        *   source:cptfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in init  cptfre ... ") ;
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("oprtyp"));
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			// 设置申请书初始化值
			this.setFixTxt();
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			
			
			
			
			
			
			
			
			
			
			
			
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getOprtyp()))
			  {
			    this.setSubPanelByOprtyp(this.getAfdgrp().getRec().getOprtyp());
			    this.getCptp().getDataForSPT();
			  }
			  return true;
			}
			IModule cpd = (IModule)ctx.restoreData("com.brilliance.cptfre.ref");
			if(!MdaUtils.isEmpty(cpd))
			  this.getCpdgrp().getRec().copyValue(cpd);
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			  this.getAfdgrp().getRec().setBchcod(this.getCpdgrp().getRec().getBchcod());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getCpdgrp().getBen().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","ben"));
			this.getCpdgrp().getRec().setOwnref(NULLSTR);
			this.getAfdgrp().getRec().setOprtyp("1");
			this.getCptp().setRetflg( "X");
			// setSubPanelByOprtyp($afdgrp\\rec\\oprtyp.getValue());
			this.getCptp().setFresubtp(this.getCptp().getCptfre04());


			return true;
        }


        /**
        *   source:cptfre.@0003.script
        */
        public void setSubPanelByOprtyp(String opttyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			if("1".equals(opttyp))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre04());
			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(opttyp))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre02());
			  
			  
			  
			  
			  
			  
			}
			if("3".equals(opttyp))
			{
			  this.getCptp().setFresubtp(this.getCptp().getCptfre03());
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
			
			
			
		}
        /**
        *   source:cptfre.@0006.script
        */
        public void setOprtxt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in cptfre.setOprtxt ...  ");
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			// 修改
			this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			this.getCptp().setOprtxt(NULLSTR);
			StringBuffer sb = new StringBuffer("");
			StringBuffer sb2= new StringBuffer("");
			if("1".equals(oprtyp))
			{
			  sb.append("【 √ 】Amendment 更正" + CR);
			  sb.append("Regarding the above Telegraphic Transfer, please amend the beneficiary information or payment message against the following information：请贵行根据以下正确资料修改上述汇款收款人资料或付款明细（附言）："+CR);
			  if(MdaUtils.isEmpty(this.getCptp().getIntbic()))
			    sb.append("Intermediary Bank name & Address （代理行名称及地址）：SWIFT BIC   "  + CR );
			  else
			    sb.append("Intermediary Bank name & Address （代理行名称及地址）：SWIFT BIC   " + this.getCptp().getIntbic() + CR );

			  if(MdaUtils.isEmpty(this.getCptp().getBenbic()))
			    sb.append("Beneficiary’s Bank name & Address （收款行名称及地址）：SWIFT BIC   "+CR);
			  else
			    sb.append("Beneficiary’s Bank name & Address （收款行名称及地址）：SWIFT BIC   "+ this.getCptp().getBenbic() +CR);

			  if(MdaUtils.isEmpty(this.getCptp().getBenacc()))
			    sb.append("Beneficiary’s Account, Name & Address（收款人账号、名称及地址）：A/C" +CR );
			  else
			    sb.append("Beneficiary’s Account, Name & Address（收款人账号、名称及地址）：A/C"+this.getCptp().getBenacc() +CR );

			  if(MdaUtils.isEmpty(this.getCptp().getMessage()))
			    sb.append("Message（附言）：" +CR);
			  else
			    sb.append("Message（附言）："+ this.getCptp().getMessage() +CR);

			  if(MdaUtils.isEmpty(this.getCptp().getOthers()))
			    sb.append("Others (其他) ：" +CR);
			  else
			    sb.append("Others (其他) ："+this.getCptp().getOthers() +CR);

			  sb.append("If the funds have not been returned to your bank, please send authenticated cable to amend the above beneficiary information.如果汇款未被退回，请贵行发送电文更正以上收款信息。"+CR);
			  sb.append("If the funds have been returned to your bank, please issue a fresh payment according the above beneficiary information：如果汇款已被退回，请贵行根据以上收款信息重新付汇：" +CR);
			  sb2 = sb2.append("Amendment：" + CR);

			  if(MdaUtils.isEmpty(this.getCptp().getIntbic()))
			    sb2 = sb2.append("Intermediary Bank:");
			  else
			    sb2 = sb2.append("Intermediary Bank:" + this.getCptp().getIntbic() +";" );

			  if(MdaUtils.isEmpty(this.getCptp().getBenbic()))
			    sb2 = sb2.append("Beneficiary’s Bank:" );
			  else
			    sb2 = sb2.append("Beneficiary’s Bank:" + this.getCptp().getBenbic() +";");

			  if(MdaUtils.isEmpty(this.getCptp().getBenbic()))
			    sb2 = sb2.append("Beneficiary’s Account");
			  else
			    sb2 = sb2.append("Beneficiary’s Account"+this.getCptp().getBenacc() +";");

			  if(MdaUtils.isEmpty(this.getCptp().getMessage()))
			    sb2 = sb2.append("Message:" );
			  else
			    sb2 = sb2.append("Message:" +this.getCptp().getMessage() +";");

			  if(MdaUtils.isEmpty(this.getCptp().getOthers()))
			    sb2 = sb2.append("Others:" );
			  else
			    sb2 = sb2.append("Others:" +this.getCptp().getOthers() +";");

			  if(!MdaUtils.isEmpty(this.getCptp().getRetflg()))
			  {
			    if(MdaUtils.isEmpty(this.getCptp().getAcc()))
			    {
			      sb.append(" （√）Pay original remitting amount, debit the difference from my/our company account. 按原汇款金额再汇，差额从本人/本公司账户扣收      账户：" + CR);
			      sb2 = sb2.append("account:"  );
			    }
			    else
			    {
			      sb.append(" （√）Pay original remitting amount, debit the difference from my/our company account. 按原汇款金额再汇，差额从本人/本公司账户扣收      账户" + this.getCptp().getAcc()  +CR);
			      sb2 = sb2.append("account:" + this.getCptp().getAcc() +";" );
			    }
			  }
			  else
			  {
			    sb.append(" （  ）Pay original remitting amount, debit the difference from my/our company account. 按原汇款金额再汇，差额从本人/本公司账户扣收" +CR);
			  }
			  if(!MdaUtils.isEmpty(this.getCptp().getRetflg2()))
			  {
			    sb2 = sb2.append("（√）Pay the returned amount" );
			    sb.append(" （√）Pay the returned amount. 按退回金额再汇。");
			  }
			  else
			  {
			    sb.append(" （  ）Pay the returned amount. 按退回金额再汇。");
			  }
			  sb.append( CR);

			  if(!MdaUtils.isEmpty(this.getFixtxt2()))
			    sb.append(this.getFixtxt2());

			  if(!MdaUtils.isEmpty(this.getFixtxt3()))
			    sb.append(this.getFixtxt3());
			}
			// 查询
			else if("2".equals(oprtyp))
			{
			  sb2 = sb2.append("Enquiry：" + CR);

			  if(!MdaUtils.isEmpty(this.getCptp().getInftxt()))
			    sb2.append(this.getCptp().getInftxt()+CR );

			  if(!MdaUtils.isEmpty(this.getFixtxt1()))
			    sb.append(this.getFixtxt1());
			  sb.append("【 √ 】Enquiry 查询" +CR);
			  sb.append("Please make an investigation on the above Telegraphic Transfer, the enquiry for the purpose of 请贵行查询上述电汇，查询事项为：");

			  if(!MdaUtils.isEmpty(this.getCptp().getInftxt()))
			    sb.append(this.getCptp().getInftxt()+CR );
			  if(!MdaUtils.isEmpty(this.getFixtxt3()))
			    sb.append(this.getFixtxt3());
			}
			// 取消
			else if("3".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getFixtxt1()))
			    sb.append(this.getFixtxt1());
			  if(!MdaUtils.isEmpty(this.getFixtxt2()))
			    sb.append(this.getFixtxt2());
			  sb.append("【 √ 】Cancellation 取消"+CR);
			  sb2 = sb2.append("Cancellation：" + CR);
			  if(!MdaUtils.isEmpty(this.getCptp().getRetflg()))
			  {
			    sb2 = sb2.append("cancel the above Telegraphic Transfer;" );
			    sb.append(" (√) If the funds have not been returned to your bank, please send authenticated cable to cancel the above Telegraphic Transfer.如果汇款未被退回，请贵行发送电文安排取消上述汇款。"+CR);
			  }
			  else
			  {
			    sb2 = sb2.append("return the back funds to my original remitting account." );
			    sb.append(" ( ) If the funds have not been returned to your bank, please send authenticated cable to cancel the above Telegraphic Transfer.如果汇款未被退回，请贵行发送电文安排取消上述汇款。"+CR);

			  }
			  if(!MdaUtils.isEmpty(this.getCptp().getRetflg2()))
			  {
			    sb.append(" (√) If the funds have been returned to your bank, please return the back funds to my original remitting account. 如果汇款已被退回，请贵行将退回款项退回至本人/本公司的原汇款账户。"+CR);

			  }
			  else
			  {
			    sb.append(" ( ) If the funds have been returned to your bank, please return the back funds to my original remitting account. 如果汇款已被退回，请贵行将退回款项退回至本人/本公司的原汇款账户。"+CR);

			  }
			}
			this.getCptp().setOprtxt(sb.toString());
			if(sb2.length() > 650 )
			{
			  this.getAfdgrp().getRec().setOprtxt(sb2.substring(0,650));
			}
			else
			{
			  this.getAfdgrp().getRec().setOprtxt(sb2.toString());
			}
			// log.debug("oprtxt=" + sb.toString());
			
		}
        /**
        *   source:cptfre.@0010.script
        */
        public void setFixTxt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer sb1 = new StringBuffer("") ;
			sb1.append("【    】Amendment 更正" + CR );
			sb1.append("Regarding the above Telegraphic Transfer, please amend the beneficiary information or payment message against the following information：请贵行根据以下正确资料修改上述汇款收款人资料或付款明细（附言）：" + CR);
			sb1.append("Intermediary Bank name & Address （代理行名称及地址）：SWIFT BIC                                   "+ CR );
			sb1.append("                                                                                                    " +CR);
			sb1.append("Beneficiary’s Bank name & Address （收款行名称及地址）：SWIFT BIC                                   " + CR);
			sb1.append("                                                                                                    "+CR);
			sb1.append("Beneficiary’s Account, Name & Address（收款人账号、名称及地址）：A/C                                 " +CR);
			sb1.append("                                                                                                    "+CR);
			sb1.append("Message（附言）：                                                                                  "+CR);
			sb1.append("Others (其他) ：                                                                                                    "+CR);
			sb1.append("If the funds have not been returned to your bank, please send authenticated cable to amend the above beneficiary information.如果汇款未被退回，请贵行发送电文更正以上收款信息。"+CR);
			sb1.append(" （  ）Pay original remitting amount, debit the difference from my/our company account. 按原汇款金额再汇，差额从本人/本公司账户扣收_____________________________。"+CR);
			sb1.append(" （  ）Pay the returned amount. 按退回金额再汇。" +CR);
			this.setFixtxt1(sb1.toString());
			StringBuffer sb2 = new StringBuffer("");
			sb2.append("【    】Enquiry 查询"+CR);
			sb2.append("Please make an investigation on the above Telegraphic Transfer, the enquiry for the purpose of 请贵行查询上述电汇，查询事项为：                                                                            "+CR);
			this.setFixtxt2(sb2.toString());

			StringBuffer sb3 = new StringBuffer("");
			sb3.append("【    】Cancellation 取消"+CR);
			sb3.append(" （  ）If the funds have not been returned to your bank, please send authenticated cable to cancel the above Telegraphic Transfer.如果汇款未被退回，请贵行发送电文安排取消上述汇款。"+CR);
			this.setFixtxt3(sb3.toString());
		}











}