package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Cptfre0VO;

import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇出汇款杂项申请查询入口
*/
@Transaction(vo= Cptfre0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptfre0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptfre0.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Cptfre0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:cptfre0.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,"
			  +"rec.credat dat,s.adrblk bennam FROM cpd rec,pts s "
			  +"WHERE  s.rol = 'ben' AND s.objtyp = 'cpd' "
			  +"AND s.objinr = rec.inr " + ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:cptfre0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("cpdgrp","cptfre");

			return true;
        }

        /**
        *   source:cptfre0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("cpdgrp","cptfre");

			return true;
        }



        /**
        *   source:cptfre0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> ctbitm = new ArrayList<CodetableItem>();
			ctbitm.add(new CodetableItem("汇出汇款","1"));
			MdaUtils.setValues(this.getSelp(),"seltyp",ctbitm);
			this.getSelp().setSeltyp("1");

			//将查询语句输入selp层的Argument类型控件queryClause字段
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,"
			  +"rec.opndat dat,s.adrblk bennam FROM cpd rec,pts s "
			  +"WHERE  s.rol = 'ben' AND s.objtyp = 'cpd' "
			  +"AND s.objinr = rec.inr " + ctx.absGet(Sysmod.class).getSelection();
			if(MdaUtils.isEmpty(this.getSelp().getRef()))
			{
			  queryClause = queryClause + " AND (stlref like '%OR%' or stlref like '%OT%' ) "  ;
			}
			else
			{
			  queryClause = queryClause  + " AND stlref = '" + this.getSelp().getRef() +"'";
			}
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}