package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CpthycVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Parmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 待办海运费支付查询
*/
@Transaction(vo= CpthycVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpthyc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cpthyc.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Parmod parmod;


		public Cpthyc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cpthyc.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cpthyc.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyc.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cpthyc.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cpthyc.this.getCpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:cpthyc.@0002.script
        */
        @Rule(target="cptp.hyccom",order=100)
        public boolean ruleCptpHyccomN100(){
            IContext ctx = MdaEnv.getContext();
            
			String chkresult = this.getParmod().hyfTimeControl();
			if (!MdaUtils.isEmpty(chkresult))
			{
			  ctx.setMessage("提示",chkresult+"允许经办，当前时间不能进行经办");
			  return true;
			}
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			int length = this.getCptp().getHyimp().fullSize();
			if(index < 0 || index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyc","CT000000"),MdaUtils.getI18NString("cpthyc","CT000001"));
			  return true;
			}

			String inr = this.getCptp().getHyimp().getElement(index).getInr(); //取到选中记录的inr号
			log.debug("{}","===============hyno"+inr);
			String filename = this.getSysmod().creatHyFileName(inr);
			if(!MdaUtils.fileExists(filename))
			{
			  log.error("{}","未找到序列化文件！");
			  return true;
			}
			IStream is=this.getCptp().getHystm();
			MdaUtils.streamClear(is);
			MdaUtils.streamLoad(is,filename);
			MdaUtils.loadData(this.getCpdgrp(),is);

			// 封装数据，用于页面跳转数据初始化
			IModule rec = MdaDriver.getModule(this,ctx.getRoot(),"cpdgrp\\rec");
			IModule apl = MdaDriver.getModule(this,ctx.getRoot(),"cpdgrp\\apl\\pts");
			IModule ben = MdaDriver.getModule(this,ctx.getRoot(),"cpdgrp\\ben\\pts");
			IModule acw = MdaDriver.getModule(this,ctx.getRoot(),"cpdgrp\\acw\\pts");

			ctx.storeData("com.brilliance.cpthyf.rec",rec);
			ctx.storeData("com.brilliance.cpthyf.apl",apl);
			ctx.storeData("com.brilliance.cpthyf.ben",ben);
			ctx.storeData("com.brilliance.cpthyf.acw",acw);

			ctx.storeData("com.brilliance.tmpHydataNo",inr); // 临时文件编号
			// 页面跳转
			

			return true;
        }

        /**
        *   source:cpthyc.@0003.script
        */
        @Rule(target="cptp.hycsel",order=100)
        public boolean ruleCptpHycselN100(){
            IContext ctx = MdaEnv.getContext();
            
			String hyno = this.getCptp().getHyno();
			String hyimpno = this.getCptp().getHyimpno();
			//log.debug("hyno,hyimpno==============="+hyno+hyimpno);
			getBackLogHY(hyno,hyimpno);

			return true;
        }



        /**
        *   source:cpthyc.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setHyno(NULLSTR);
			this.getCptp().setHyimpno(NULLSTR);
			String hyno = this.getCptp().getHyno();
			String hyimpno = this.getCptp().getHyimpno();
			log.debug("{}","hyno,hyimpno==============="+hyno+","+hyimpno);
			getBackLogHY(hyno,hyimpno);

			return true;
        }


        /**
        *   source:cpthyc.@0000.script
        */
        public /**
* 根据有无业务参号和海运费批量导入批次号查询待办海运费
* @owno 序号
* @impno 批次号
*/
void getBackLogHY(String owno,String impno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCptp().getHyimp());
			String sql = "select a.inr,a.ownref as hyimpno ,a.smhinr as hyno from spt a where a.sta='H' and a.oprusrinr = '" + this.getSysmod().getPty().getInr()+"' ";
			// 封装查询结果集
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> hyimpno = new Argument<String>("hyimpno");
			Argument<String> hyno = new Argument<String>("hyno");

			// 无无业务参号和海运费批量导入批次号，查询所有待办海运费
			if(MdaUtils.isEmpty(owno) && MdaUtils.isEmpty(impno))
			{
			  sql =sql + " order by a.inr desc";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,hyimpno,hyno);
			    if(ctx.getErrorCode()== NO_ERROR)
			    {
			      String filename = this.getSysmod().creatHyFileName(inr.getValue());
			      //log.debug(filename);
			      if(!MdaUtils.fileExists(filename))
			      {
			        log.error("{}","未找到序列化文件！");
			        continue;
			      }
			      IStream is=this.getCptp().getHystm();
			      MdaUtils.streamClear(is);
			      MdaUtils.streamLoad(is,filename);
			      MdaUtils.loadData(this.getCpdgrp(),is);
			      this.loadList(inr,hyimpno,hyno);

			    }
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			// 有业务参号或海运费批量导入批次号，根据业务参号或海运费批量导入批次号查询所有待办海运费
			else
			{
			  if(!MdaUtils.isEmpty(owno) && MdaUtils.isEmpty(impno))
			  {
			    sql =sql+" and a.smhinr like '%"+owno+"%' order by a.inr desc";
			  }
			  if(!MdaUtils.isEmpty(impno) && MdaUtils.isEmpty(owno))
			  {
			    sql =sql+" and a.ownref like '%"+impno+"%' order by a.inr desc";
			  }
			  if(!MdaUtils.isEmpty(owno) && !MdaUtils.isEmpty(impno))
			    sql =sql+" and a.smhinr like '%"+owno+"%' and a.ownref like '%" + impno+"%' order by a.inr desc";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,hyimpno,hyno);
			    if(ctx.getErrorCode()== NO_ERROR)
			    {
			      String filename = this.getSysmod().creatHyFileName(inr.getValue());
			      //log.debug(filename);
			      if(!MdaUtils.fileExists(filename))
			      {
			        log.error("{}","未找到序列化文件！");
			        continue;
			      }
			      IStream is=this.getCptp().getHystm();
			      MdaUtils.streamClear(is);
			      MdaUtils.streamLoad(is,filename);
			      MdaUtils.loadData(this.getCpdgrp(),is);
			      this.loadList(inr,hyimpno,hyno);

			    }
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			
		}
        /**
        *   source:cpthyc.@0006.script
        */
        public void loadList(Argument<String> inr,Argument<String> hyimpno,Argument<String> hyno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> remcur = new Argument<String>("remcur");
			Argument<BigDecimal> remamt = new Argument<BigDecimal>("remamt");
			Argument<BigDecimal> fxamt = new Argument<BigDecimal>("fxamt");
			Argument<String> fxact = new Argument<String>("fxact");
			Argument<BigDecimal> puramt = new Argument<BigDecimal>("puramt");
			Argument<String> puract = new Argument<String>("puract");
			Argument<String> paynam = new Argument<String>("paynam");
			Argument<String> payadd = new Argument<String>("payadd");
			Argument<String> opnkey = new Argument<String>("opnkey");
			Argument<String> opnnam = new Argument<String>("opnnam");
			Argument<String> opnadd = new Argument<String>("opnadd");
			Argument<String> payeenameapp = new Argument<String>("payeenameapp");
			Argument<String> pyeact = new Argument<String>("pyeact");
			Argument<String> payeeadd = new Argument<String>("payeeadd");
			Argument<String> detchgcod = new Argument<String>("detchgcod");
			Argument<String> pyecry = new Argument<String>("pyecry");
			Argument<String> paytyp = new Argument<String>("paytyp");
			Argument<String> paytyptxt = new Argument<String>("paytyptxt");
			Argument<String> bopcod1 = new Argument<String>("bopcod1");
			Argument<BigDecimal> bopamt1 = new Argument<BigDecimal>("bopamt1");
			Argument<String> bopinf1 = new Argument<String>("bopinf1");
			Argument<String> conno = new Argument<String>("conno");
			String det = "";
			String paytyptmp = "";
			String txttmp = "";
			det = this.getCpdgrp().getRec().getDetchgcod();
			if("APPLICANT".equals(det))
			  det="汇款人OUR";
			else if("BENEFICIARY".equals(det))
			  det="收款人BEN";
			else if("SHA".equals(det))
			  det="共同SHA";

			paytyptmp = this.getCpdgrp().getRec().getPaytyp();
			if("Advance Payment".equals(paytyptmp))
			  paytyptmp="A-预付款";
			else if("Payment Against Delivery".equals(paytyptmp))
			  paytyptmp="P-货到付款";
			else if("Refund".equals(paytyptmp))
			  paytyptmp="R-退款";
			else if("Others".equals(paytyptmp))
			  paytyptmp="O-其他";

			txttmp = this.getCpdgrp().getRec().getPaytyptxt();
			if("X".equals(txttmp))
			  txttmp="X-保税区";
			else if("E".equals(txttmp))
			  txttmp="E-出口加工区";
			else if("D".equals(txttmp))
			  txttmp="D-钻石交易所";
			else if("A".equals(txttmp))
			  txttmp="A-其他特殊经济区";
			else if("M".equals(txttmp))
			  txttmp="M-深加工结转";
			else if("O".equals(txttmp))
			  txttmp="O-其他";
			remcur.setValue(this.getCpdgrp().getRec().getRemcur());
			remamt.setValue(this.getCpdgrp().getRec().getRemamt());
			fxamt.setValue(this.getCpdgrp().getRec().getFxamt());
			fxact.setValue(this.getCpdgrp().getRec().getFxact());
			puramt.setValue(this.getCpdgrp().getRec().getPuramt());
			puract.setValue(this.getCpdgrp().getRec().getPuract());
			paynam.setValue(this.getCpdgrp().getApl().getPts().getNam());
			payadd.setValue(this.getCpdgrp().getApl().getPts().getAdr());
			opnkey.setValue(this.getCpdgrp().getAcw().getPts().getExtkey());
			opnnam.setValue(this.getCpdgrp().getAcw().getPts().getNam());
			opnadd.setValue(this.getCpdgrp().getAcw().getPts().getAdr());
			payeenameapp.setValue(this.getCpdgrp().getBen().getPts().getNam());
			pyeact.setValue(this.getCpdgrp().getBen().getPts().getAct());
			payeeadd.setValue(this.getCpdgrp().getBen().getPts().getAdr());
			detchgcod.setValue(det);
			pyecry.setValue(this.getCpdgrp().getRec().getPyecry());
			paytyp.setValue(paytyptmp);
			paytyptxt.setValue(txttmp);
			bopcod1.setValue(this.getCpdgrp().getRec().getBopcod1());
			bopamt1.setValue(this.getCpdgrp().getRec().getBopamt1());
			bopinf1.setValue(this.getCpdgrp().getRec().getBopinf1());
			conno.setValue(this.getCpdgrp().getRec().getConno());
			this.getCptp().getHyimp().add(inr,remcur,remamt,fxamt,fxact,puramt,puract,paynam,payadd,opnkey,opnnam,opnadd,payeenameapp,pyeact,
			  payeeadd,detchgcod,pyecry,paytyp,paytyptxt,bopcod1,bopamt1,bopinf1,conno,hyno,hyimpno);
		}










}