package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CpthydVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 批量海运费导入
*/
@Transaction(vo= CpthydVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpthyd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cpthyd.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Btnmod btnmod;


		public Cpthyd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cpthyd.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cpthyd.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyd.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cpthyd.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cpthyd.this.getCpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:cpthyd.@0002.script
        */
        @Rule(target="cptp.hyimpt",order=100)
        public boolean ruleCptpHyimptN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","hyimp =====");
			MdaUtils.clear(this.getCptp().getHyimp());
			List<String[]> list = new ArrayList<String[]>();
			IStream is = this.getCptp().getHyimpt();
			String fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/excel_imp.properties");
			int sheetIndex = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"dbbagt_sheetIndex"));
			int rowOffset = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"rowOffset"));
			int rowMax = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"rowMax"));
			int columnOffset = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"columnOffset"));
			int columnCount = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"columnCount"));
			int rowCountLimited = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"maxRow"));
			log.debug("{}","sheetIndex="+sheetIndex);
			log.debug("{}","rowOffset="+rowOffset);
			log.debug("{}","rowMax="+rowMax);
			log.debug("{}","columnOffset="+columnOffset);
			log.debug("{}","columnCount="+columnCount);
			int recode = MdaUtils.loadExcel(list,is,sheetIndex,rowOffset,rowMax,columnOffset,columnCount);
			log.info("{}","recode为：=====" + recode );
			if(MdaUtils.isEmpty(list))
			{
			  log.debug("{}","list is null");
			}
			if(recode==-1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000000"),MdaUtils.getI18NString("cpthyd","CT000001"));
			  return true;
			}
			if(recode==-2)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000002"),MdaUtils.getI18NString("cpthyd","CT000003"));
			  return true;
			}
			if(MdaUtils.isEmpty(list))
			{
			  log.debug("{}","list is null");
			}
			log.debug("{}","list.size="+list.size());
			Argument<String> remcur = new Argument<String>("remcur");
			Argument<BigDecimal> remamt = new Argument<BigDecimal>("remamt");
			Argument<BigDecimal> fxamt = new Argument<BigDecimal>("fxamt");
			Argument<String> fxact = new Argument<String>("fxact");
			//Argument<BigDecimal> puramt = new Argument<BigDecimal>("puramt");
			//Argument<String> puract = new Argument<String>("puract");
			Argument<String> paynam = new Argument<String>("paynam");
			Argument<String> payadd = new Argument<String>("payadd");
			Argument<String> opnkey = new Argument<String>("opnkey");
			Argument<String> opnnam = new Argument<String>("opnnam");
			Argument<String> opnadd = new Argument<String>("opnadd");
			Argument<String> payeenameapp = new Argument<String>("payeenameapp");
			Argument<String> pyeact = new Argument<String>("pyeact");
			Argument<String> payeeadd = new Argument<String>("payeeadd");
			Argument<String> detchgcod = new Argument<String>("detchgcod");
			Argument<String> pyecry = new Argument<String>("pyecry");
			Argument<String> paytyp = new Argument<String>("paytyp");
			Argument<String> paytyptxt = new Argument<String>("paytyptxt");
			Argument<String> bopcod1 = new Argument<String>("bopcod1");
			Argument<BigDecimal> bopamt1 = new Argument<BigDecimal>("bopamt1");
			Argument<String> bopinf1 = new Argument<String>("bopinf1");
			Argument<String> conno = new Argument<String>("conno");

			int cnt = 0;
			int all=0;
			StringBuffer errlog= new StringBuffer();
			int errcnt=0;
			int errflg=1;
			String[] ss = null;
			String paytyptmp = "" ;
			String checkcur = "USD/HKD/JPY/EUR/GBP/SGD/NZD/SEK/CHF/CAD/AUD/KRW/NOK/MOP/THB/DKK";
			String ramt ="";
			String famt ="";
			String pamt ="";
			String oamt ="";
			String bamt1 ="";
			BigDecimal ramtb = new BigDecimal(0);
			BigDecimal famtb = new BigDecimal(0);
			BigDecimal pamtb = new BigDecimal(0);
			BigDecimal bamtb1 = new BigDecimal(0);
			String sql = "";
			String det ="";
			for(int i=1;i<list.size();i++)
			{
			  int len = i+1;
			  errflg=1;
			  ss = list.get(i);
			  MdaUtils.clear(fxamt);
			  MdaUtils.clear(fxact);
			  //Platform.clear(puramt);
			  //Platform.clear(puract);
			  if(MdaUtils.isEmpty(ss))
			  {
			    continue;
			  }
			  // 校验这一行导入内容是否为空
			  StringBuffer cont = new StringBuffer();
			  for(String s:ss)
			  {
			    if(s==null)s="";
			    cont.append(s);
			  }
			  if(cont.toString().isEmpty())
			  {
			    continue;
			  }
			  log.debug("{}","开始校验数据===============");
			  if(checkcur.indexOf(ss[0])<0 || MdaUtils.isEmpty(ss[0]))
			  {
			    errlog.append("第"+len+"行错误,"+ss[0]+"不是合法币种,请重新上传！");
			    errflg=0;
			  }
			  remcur.setValue(ss[0].trim());
			  if( MdaUtils.isEmpty(ss[1]))
			  {
			    remamt.setValue(new BigDecimal(0));
			    errlog.append("第"+len+"行错误,汇款金额不能为空,请重新上传！");
			    errflg=0;
			  }
			  else
			  {
			    ramtb = MdaUtils.parseDecimal(MdaUtils.format(MdaUtils.parseDecimal(ss[1].replaceAll(",","")),"#0.00"));
			    remamt.setValue(ramtb);
			  }
			  if(!MdaUtils.isEmpty(ss[2]))
			  {
			    famtb = MdaUtils.parseDecimal(MdaUtils.format(MdaUtils.parseDecimal(ss[2].replaceAll(",","")),"#0.00"));
			    // 现汇金额，购汇金额都不为空，汇款金额=现汇金额+购汇金额
			    if(!MdaUtils.isEmpty(ss[4]))
			    {
			      pamtb = MdaUtils.parseDecimal(MdaUtils.format(MdaUtils.parseDecimal(ss[4].replaceAll(",","")),"#0.00"));
			      if(ramtb.compareTo(famtb.add(pamtb)) != 0)
			      {
			        errlog.append("第"+len+"行错误,现汇金额+购汇金额不等于汇款金额,请重新上传！");
			        errflg=0;
			      }
			    }
			    // 现汇金额不为空，购汇金额为空，汇款金额=现汇金额
			    else
			    {
			      if( ramtb.compareTo(famtb) != 0 )
			      {
			        errlog.append("第"+len+"行错误,现汇金额不等于汇款金额,请重新上传！");
			        errflg=0;
			      }
			    }

			    // 现汇金额不为空，现汇账号不能为空
			    if(MdaUtils.isEmpty(ss[3]) )
			    {
			      errlog.append("第"+len+"行错误,现汇账号不能为空,请重新上传！");
			      errflg=0;
			    }
			    fxamt.setValue(famtb);
			    fxact.setValue(ss[3].trim());
			  }
			  // 现汇金额为空，现汇账号应为空
			  else
			  {
			    if(!MdaUtils.isEmpty(ss[3]))
			    {
			      errlog.append("第"+len+"行错误,现汇账号应为空,请重新上传！");
			      errflg=0;
			    }
			  }

			  if(MdaUtils.isEmpty(ss[4]))
			  {
			    errlog.append("第"+len+"行错误,汇款人名称不能为空,请重新上传！");
			    errflg=0;
			  }
			  paynam.setValue(ss[4].trim());
			  if(MdaUtils.isEmpty(ss[5]))
			  {
			    errlog.append("第"+len+"行错误,汇款人地址不能为空,请重新上传！");
			    errflg=0;
			  }
			  payadd.setValue(ss[5].trim());

			  if(MdaUtils.isEmpty(ss[6]))
			  {
			    errlog.append("第"+len+"行错误,收款人接收银行swiftcode不能为空,请重新上传！");
			    errflg=0;
			  }
			  else
			  {
			    opnnam.setValue(ss[7].trim());
			    opnadd.setValue(ss[8].trim());
			  }
			  opnkey.setValue(ss[6].trim());
			  if(MdaUtils.isEmpty(ss[9]))
			  {
			    errlog.append("第"+len+"行错误,收款人名称不能为空,请重新上传！");
			    errflg=0;
			  }
			  payeenameapp.setValue(ss[9].trim());
			  if(MdaUtils.isEmpty(ss[10]))
			  {
			    errlog.append("第"+len+"行错误,收款人账号不能为空,请重新上传！");
			    errflg=0;
			  }
			  pyeact.setValue(ss[10].trim());
			  if(MdaUtils.isEmpty(ss[11]))
			  {
			    errlog.append("第"+len+"行错误,收款人地址不能为空,请重新上传！");
			    errflg=0;
			  }
			  payeeadd.setValue(ss[11].trim());
			  if(MdaUtils.isEmpty(ss[12]))
			  {
			    errlog.append("第"+len+"行错误,费用承担方不能为空,请重新上传！");
			    errflg=0;
			  }
			  detchgcod.setValue(ss[12]);
			  if(MdaUtils.isEmpty(ss[13]))
			  {
			    errlog.append("第"+len+"行错误,收款人常驻国家/地区代码不能为空,请重新上传！");
			    errflg=0;
			  }
			  pyecry.setValue(ss[13].trim());
			  if(MdaUtils.isEmpty(ss[14]))
			  {
			    errlog.append("第"+len+"行错误,付款类型不能为空,请重新上传！");
			    errflg=0;
			  }
			  paytyp.setValue(ss[14]);
			  if(MdaUtils.isEmpty(ss[15]))
			  {
			    errlog.append("第"+len+"行错误,付汇性质不能为空,请重新上传！");
			    errflg=0;
			  }

			  paytyptxt.setValue(ss[15].trim());
			  if(MdaUtils.isEmpty(ss[16]))
			  {
			    errlog.append("第"+len+"行错误,交易编码不能为空,请重新上传！");
			    errflg=0;
			  }
			  else
			  {
			    bopcod1.setValue(ss[16].trim().substring(0,6));
			  }

			  if(MdaUtils.isEmpty(ss[17]))
			  {
			    errlog.append("第"+len+"行错误,相应金额不能为空,请重新上传！");
			    errflg=0;
			  }
			  else
			  {
			    bamtb1 = MdaUtils.parseDecimal(MdaUtils.format(MdaUtils.parseDecimal(ss[17].replaceAll(",","")),"#0.00"));
			    if(ramtb.compareTo(bamtb1) != 0)
			    {
			      errlog.append("第"+len+"行错误,相应金额不等于汇款金额,请重新上传！");
			      errflg=0;
			    }
			  }

			  bopamt1.setValue(bamtb1);
			  if(MdaUtils.isEmpty(ss[18]))
			  {
			    errlog.append("第"+len+"行错误,交易附言不能为空,请重新上传！");
			    errflg=0;
			  }
			  bopinf1.setValue(ss[18].trim());

			  if(!MdaUtils.isEmpty(ss[19]))
			  {
			    if(ss[19].trim().length()>128)
			    {
			      errlog.append("第"+len+"行错误,"+"合同号不能超过128位！");
			      errflg=0;
			    }
			  }
			  conno.setValue(ss[19].trim());
			  all++;

			  if(errflg>0 && cnt<rowCountLimited)
			  {
			    cnt++;
			    // 海运费信息导入批量导入列表
			    log.debug("{}","插入列表==============");
			    this.getCptp().getHyimp().add(remcur,remamt,fxamt,fxact,paynam,payadd,opnkey,opnnam,opnadd,payeenameapp,pyeact,
			      payeeadd,detchgcod,pyecry,paytyp,paytyptxt,bopcod1,bopamt1,bopinf1,conno);
			  }
			  else
			  {
			    log.info("{}","cpthyd-no-cnt-errflg-cnt-rowCountLimited"+errcnt+" "+errflg+" "+cnt+" "+rowCountLimited);
			    errcnt++;
			  }
			}

			if(all>rowCountLimited)
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000004"),MdaUtils.getI18NString("cpthyd","CT000005")+rowCountLimited+MdaUtils.getI18NString("cpthyd","CT000006"));
			
			if(errcnt>0 && cnt<rowCountLimited)
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000007"),MdaUtils.getI18NString("cpthyd","CT000008") + cnt + MdaUtils.getI18NString("cpthyd","CT000009") + errcnt + MdaUtils.getI18NString("cpthyd","CT000010") + errlog.toString());
			else if(errcnt>0 && cnt == rowCountLimited)
			{
			  if("".equals(errlog.toString().trim()))
			    ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000011"),MdaUtils.getI18NString("cpthyd","CT000012") + cnt + MdaUtils.getI18NString("cpthyd","CT000013") + errcnt + MdaUtils.getI18NString("cpthyd","CT000014"));
			  else
			    ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000015"),MdaUtils.getI18NString("cpthyd","CT000016") + cnt + MdaUtils.getI18NString("cpthyd","CT000017") + errcnt + MdaUtils.getI18NString("cpthyd","CT000018") + errlog.toString());
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000019"),MdaUtils.getI18NString("cpthyd","CT000020")+cnt+MdaUtils.getI18NString("cpthyd","CT000021"));
			


			return true;
        }

        /**
        *   source:cpthyd.@0003.script
        */
        @Rule(target="cptp.hydload",order=100)
        public boolean ruleCptpHydloadN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream os = this.getCptp().getHydload();
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/hyftmp.xlsx");

			if(!MdaUtils.fileExists(fileName))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000056"),MdaUtils.getI18NString("cpthyd","CT000057"));
			  log.error("{}",fileName+"文件不存在");
			  return false;
			}
			MdaUtils.streamLoad(os,fileName);
			os.setType("xlsx");
			os.setName("海运费批量导入模板.xlsx");

			return true;
        }

        /**
        *   source:cpthyd.@0004.script
        */
        @Rule(target="cptp.hysure",order=100)
        public boolean ruleCptpHysureN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getCptp().getHyimp().fullSize()<=0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000071"),MdaUtils.getI18NString("cpthyd","CT000072"));
			  return true;
			}

			int count = 0;
			String bchcod =this.getCpdgrp().getRec().getBchcod();
			Date credat = this.getCpdgrp().getRec().getCredat();
			String rmttyp = this.getCpdgrp().getRec().getRmttyp();
			String priority = this.getCpdgrp().getRec().getPriority();
			String aplnam = this.getCpdgrp().getAplnam();
			String apltel = this.getCpdgrp().getApltel();
			String impno = getImpNo(this.getCpdgrp().getRec().getBchcod());
			String det = "";
			String paytyptmp ="";
			for(int i=this.getCptp().getHyimp().fullSize()-(int)1;i>=0;i--)
			{
			  // 暂存交易数据
			  log.debug("{}","暂存数据==============");
			  bchcod = this.getCpdgrp().getRec().getBchcod();
			  MdaUtils.clear(this.getCpdgrp());
			  

			  this.getCpdgrp().getRec().setCredat(credat);
			  this.getCpdgrp().getRec().setRmttyp(rmttyp);
			  this.getCpdgrp().getRec().setPriority(priority);
			  this.getCpdgrp().getRec().setApplicantname(aplnam);
			  this.getCpdgrp().getRec().setApplicantphone(apltel);
			  // 设置公组织代码和报关单代码
			
			  this.getCpdgrp().getRec().setBopcod(this.getSysmod().getPty().getBopcod());
			  // 基础信息
			  this.getCpdgrp().getRec().setBchcod(bchcod);
			  this.getCpdgrp().getRec().setRemcur(this.getCptp().getHyimp().getElement(i).getRemcur());
			  this.getCpdgrp().getRec().setRemamt(this.getCptp().getHyimp().getElement(i).getRemamt());
			  if(!MdaUtils.isEmpty(this.getCptp().getHyimp().getElement(i).getFxact()))
			  {
			    this.getCpdgrp().getRec().setFxflg(TRUE);
			    this.getCpdgrp().getRec().setFxact(this.getCptp().getHyimp().getElement(i).getFxact());
			    this.getCpdgrp().getRec().setFxamt(this.getCptp().getHyimp().getElement(i).getFxamt());
			  }
			  if(!MdaUtils.isEmpty(this.getCptp().getHyimp().getElement(i).getPuract()))
			  {
			    this.getCpdgrp().getRec().setPurflg(TRUE);
			    this.getCpdgrp().getRec().setPuract(this.getCptp().getHyimp().getElement(i).getPuract());
			    this.getCpdgrp().getRec().setPuramt(this.getCptp().getHyimp().getElement(i).getPuramt());
			  }

			  det = this.getCptp().getHyimp().getElement(i).getDetchgcod().trim();
			  if("汇款人OUR".equals(det))
			    det="APPLICANT";
			  else if("收款人BEN".equals(det))
			    det="BENEFICIARY";
			  else if("共同SHA".equals(det))
			    det="SHA";
			  this.getCpdgrp().getRec().setDetchgcod(det);
			  this.getCpdgrp().getRec().setPyecry(this.getCptp().getHyimp().getElement(i).getPyecry());
			  paytyptmp = this.getCptp().getHyimp().getElement(i).getPaytyp().substring(0,1);
			  if("A".equals(paytyptmp))
			    paytyptmp="Advance Payment";
			  else if("P".equals(paytyptmp))
			    paytyptmp="Payment Against Delivery";
			  else if("R".equals(paytyptmp))
			    paytyptmp="Refund";
			  else if("O".equals(paytyptmp))
			    paytyptmp="Others";
			  this.getCpdgrp().getRec().setPaytyp(paytyptmp);
			  this.getCpdgrp().getRec().setPaytyptxt(this.getCptp().getHyimp().getElement(i).getPaytyptxt().substring(0,1));
			  this.getCpdgrp().getRec().setBopcod1(this.getCptp().getHyimp().getElement(i).getBopcod1());
			  this.getCpdgrp().getRec().setBopamt1(this.getCptp().getHyimp().getElement(i).getBopamt1());
			  this.getCpdgrp().getRec().setBopinf1(this.getCptp().getHyimp().getElement(i).getBopinf1());
			  this.getCpdgrp().getRec().setConno(this.getCptp().getHyimp().getElement(i).getConno());

			  // 汇款人
			  this.getCpdgrp().getApl().getPts().setNam(this.getCptp().getHyimp().getElement(i).getPaynam());
			  this.getCpdgrp().getApl().getPts().setAdrblk(this.getCptp().getHyimp().getElement(i).getPaynam()+" "+this.getCptp().getHyimp().getElement(i).getPayadd());
			  this.getCpdgrp().getApl().getPts().setAdr(this.getCptp().getHyimp().getElement(i).getPayadd());
			  this.getCpdgrp().getApl().getPts().setRol("apl");

			  // 收款人
			  this.getCpdgrp().getBen().getPts().setNam(this.getCptp().getHyimp().getElement(i).getPayeenameapp());
			  this.getCpdgrp().getBen().getPts().setAdrblk(this.getCptp().getHyimp().getElement(i).getPayeenameapp() + " " + this.getCptp().getHyimp().getElement(i).getPayeeadd());
			  this.getCpdgrp().getBen().getPts().setAdr(this.getCptp().getHyimp().getElement(i).getPayeeadd());
			  this.getCpdgrp().getBen().getPts().setAct(this.getCptp().getHyimp().getElement(i).getPyeact());
			  this.getCpdgrp().getBen().getPts().setRol("ben");

			  // 收款人开户行
			  if(!MdaUtils.isEmpty(this.getCptp().getHyimp().getElement(i).getOpnnam()))
			  {
			    this.getCpdgrp().getAcw().getPts().setNam(this.getCptp().getHyimp().getElement(i).getOpnnam());
			  }
			  if(!MdaUtils.isEmpty(this.getCptp().getHyimp().getElement(i).getOpnadd()))
			  {
			    this.getCpdgrp().getAcw().getPts().setAdrblk(this.getCptp().getHyimp().getElement(i).getOpnnam()+" "+ this.getCptp().getHyimp().getElement(i).getOpnadd());
			    this.getCpdgrp().getAcw().getPts().setAdr(this.getCptp().getHyimp().getElement(i).getOpnadd());
			  }
			  this.getCpdgrp().getAcw().getPts().setExtkey(this.getCptp().getHyimp().getElement(i).getOpnkey());
			  this.getCpdgrp().getAcw().getPts().setRol("acw");

			  // 设置收款银行代理行信息
			  //$cpdgrp\\rcp\\pts\\rol.setValue("rcp");
			  //$cpdgrp\\rcp\\pts\\extkey.setValue($cptp\\hyimp[i]\\extkey.getValue());
			
			  String sptinr = Platform.sdbCounter("spt");
			  IStream os=this.getCptp().getHystm();
			  MdaUtils.streamClear(os);
			  MdaUtils.saveData(this.getCpdgrp(),os);
			  String exlname1 = this.getSysmod().creatHyFileName(sptinr);
			  //log.debug("filename======="+exlname1);
			
			  ctx.getDaoSession().dbBegin();
			  String hyno = getHyNo();
			  this.getSysmod().getSpt().setInr(sptinr);
			  this.getSysmod().getSpt().setDattim(credat);
			  this.getSysmod().getSpt().setSmhinr(hyno);
			  this.getSysmod().getSpt().setFrm(ctx.getTransName());
			  this.getSysmod().getSpt().setSta("H");
			  this.getSysmod().getSpt().setOwnref(impno);
			  this.getSysmod().getSpt().setTrnamt(this.getCptp().getHyimp().getElement(i).getRemamt());
			  this.getSysmod().getSpt().setTrncur(this.getCptp().getHyimp().getElement(i).getRemcur());
			  this.getSysmod().getSpt().setOprusrinr(this.getSysmod().getPty().getInr());
			  ctx.getDaoSession().dbInsert(this.getSysmod().getSpt());
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			  }
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    ctx.getDaoSession().dbCommit();

			    ;
			    MdaUtils.streamSave(os,exlname1);
			  }
			  count++;
			  //log.debug("==================count"+count);
			}
			MdaUtils.clear(this.getSysmod().getSpt());
			ctx.setMessage(MdaUtils.getI18NString("cpthyd","CT000073"),MdaUtils.getI18NString("cpthyd","CT000074")+count+MdaUtils.getI18NString("cpthyd","CT000075"));
			
			MdaUtils.clear(this.getCptp().getHyimp());

			return true;
        }



        /**
        *   source:cpthyd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod =null;
			this.getCpdgrp().getRec().setRmttyp("0");
			log.debug("{}","rmttyp:" +this.getCpdgrp().getRec().getRmttyp());
			this.getCpdgrp().setWtranfer("√");
			
			
			
			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			this.getCptp().setTopub("√");
			MdaUtils.clear(this.getCptp().getHyimp());
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  bchcod = new ArrayList<CodetableItem>();
			  bchcod.add(new CodetableItem(this.getSysmod().getPty().getNam(),this.getSysmod().getPty().getCid()));
			  this.getCpdgrp().setEpsptynam(NULLSTR);
			  this.getCpdgrp().setTempnam(NULLSTR);
			  this.getCpdgrp().setEpsptyinr(NULLSTR);
			  
			  this.getCpdgrp().setLabel("From:");
			  
			  
			}
			else
			{
			  // 如果是企业端登录还按原来处理
			  bchcod = this.getSysmod().getAndSetBchcodvals();
			  // 初始化汇款人信息
			  this.getCpdgrp().getDap().initDap("cpd");
			  this.getCpdgrp().getApl().getPts().copyValue(this.getCpdgrp().getDap().getPts());
			  this.getCpdgrp().getApl().getAdr().copyValue(this.getCpdgrp().getDap().getAdr());
			  this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			  this.getCpdgrp().getApl().getPts().setRol("apl");
			  
			  
			  
			}
			this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			
			
			
			
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			this.getCpdgrp().getRec().setPriority("Normal");
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			// 查询对公组织代码和报关单代码
			this.getCpdgrp().getRec().setAtccod(this.getSysmod().getPty().getAtccod());
			this.getCpdgrp().getRec().setBopcod(this.getSysmod().getPty().getBopcod());


			return true;
        }


        /**
        *   source:cpthyd.@0001.script
        */
        public String getImpNo(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @ptyinr 当前登录用户所属机构国结机构号
			  * @return 申请类交易的参号(格式：业务种类+核心机构号+申请时间+单证通系统的流水号，如HY35500908170001)。
			  */

			String sql = "select  p.idc from pty p,cpd c where p.cid = c.bchcod and c.bchcod = '" + bchcod +"'";
			Argument<String> idc = new Argument<String>("idc");
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(idc);
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();

			String impno = "HY" + idc.getValue() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			impno = impno + MdaUtils.format(ctx.getDaoSession().dbCounter("HY"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			return impno;

		}
        /**
        *   source:cpthyd.@0007.script
        */
        public String getHyNo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String hyno = MdaUtils.format(MdaUtils.today(),"MMdd");
			hyno = hyno + MdaUtils.format(ctx.getDaoSession().dbCounter("HY"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			return hyno;
		}









}