package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CpthyfVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Parmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bengrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 单笔海运费支付
*/
@Transaction(vo= CpthyfVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpthyf extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cpthyf.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Bengrp bengrp;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Parmod parmod;


		public Cpthyf()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cpthyf.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cpthyf.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cpthyf.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cpthyf.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cpthyf.this.getCpdgrp().getRec().getBchcod();}}
			 );
        }

        /**
        *   source:cpthyf.@0004.script
        */
        @Rule(target="cptp.cpdgrp.rec.fxflg",order=100)
        public boolean ruleCptpCpdgrpRecFxflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  //1:True
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  else
			  {
			    this.getCptp().getCpdgrp().getRec().setFxamt(new BigDecimal(0));
			    
			    
			    
			    this.getCptp().getCpdgrp().getRec().setFxact(NULLSTR);
			    
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:cpthyf.@0005.script
        */
        @Rule(target="cptp.cpdgrp.rec.purflg",order=100)
        public boolean ruleCptpCpdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  //1:True
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			    if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg()))
			    {
			      
			      
			      
			    }
			    this.getCptp().getFpdgrp().setMessage();
			  }
			  else
			  {
			    this.getCptp().getCpdgrp().getRec().setPuramt(new BigDecimal(0));
			    
			    this.getCptp().getCpdgrp().getRec().setPuract(NULLSTR);
			    
			    
			    
			    
			    
			    
			  }
			  
			}

			return true;
        }

        /**
        *   source:cpthyf.@0006.script
        */
        @Rule(target="cptp.fxbut",order=100)
        public boolean ruleCptpFxbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setActchsflg( "fx");
			this.getCptp().popupActchs();

			return true;
        }

        /**
        *   source:cpthyf.@0007.script
        */
        @Rule(target="cptp.purbut",order=100)
        public boolean ruleCptpPurbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setActchsflg( "pur");
			this.getCptp().popupActchs();

			return true;
        }

        /**
        *   source:cpthyf.@0008.script
        */
        @Rule(target="mtabut.sel1",order=100)
        public boolean ruleMtabutSel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCty().setEngnam(NULLSTR);
			
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			//Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:cpthyf.@0010.script
        */
        @Rule(target="cptp.cpdgrp.rec.pyecry",order=100)
        public boolean ruleCptpCpdgrpRecPyecryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//添加功能：可在国家代码框里直接输入国家代码然后会自动带入中文
			String sql = "";
			String nam = this.getCpdgrp().getRec().getPyecry();
			log.info("{}","国家或地区代码为：" +nam );
			if(!MdaUtils.isEmpty(nam))
			{
			  sql = "select alpcod,chnnam from cty where alpcod = '"+ nam +"'";
			  // or cod like '%"+ nam +"%' or numcod like '%"+ nam +"%'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			log.info("{}","执行的SQL为："+ sql);
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			ctx.getDaoSession().dbFetchFields(alpcod,chnnam);
			int error = ctx.getErrorCode();
			if(error == NO_ERROR)
			{
			  this.getCpdgrp().getRec().setPyecry(alpcod.value);
			  this.getCpdgrp().setCtydes(chnnam.value);
			}
			else
			{
			  if(!Platform.isFromApp())
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.pyecry",MdaUtils.getI18NString("cpthyf","CT000008"));
			    this.getCpdgrp().setCtydes(NULLSTR);
			    //Platform.setModified($cpdgrp\\ctydes);
			  }
			  else
			  {
			    ctx.setMessage("E9999","请输入正解的国家或地区代码或该地区国家未维护");
			  }
			  log.info("{}","错误代码error为：" + error);
			}
			ctx.getDaoSession().dbCloseCursor();
			
			

			return true;
        }

        /**
        *   source:cpthyf.@0011.script
        */
        @Rule(target="cpdgrp.rec.remcur",order=50)
        public boolean ruleCpdgrpRecRemcurN50(){
            IContext ctx = MdaEnv.getContext();
            
			//境内汇款不做人民币
			if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			{
			  if(!Platform.isFromApp())
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.remcur",MdaUtils.getI18NString("cpthyf","CT000011"));
			    this.getCpdgrp().getRec().setRemcur(NULLSTR);
			    
			  }
			  else
			  {
			    ctx.setMessage("E9999","线上境内汇款不支持人民币类的业务");
			  }
			  return false;
			}

			//除境外人民币，其它情况购汇、现汇不灰显
			
			
			
			

			this.getCpdgrp().getRec().setBopcur1(this.getCpdgrp().getRec().getRemcur());
			

			Boolean fxflg = TRUE.equals(this.getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCpdgrp().getRec().getPurflg());
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()))
			{
			  if(!fxflg && purflg)
			  {
			    this.getCpdgrp().getRec().setPuramt(this.getCpdgrp().getRec().getRemamt());
			    
			    
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			      ctx.postRule(this,"cptp.cpdgrp.rec.puramt");  //触发购汇金额变动事件
			  }
			}

			return true;
        }

        /**
        *   source:cpthyf.@0013.script
        */
        @Rule(target="cpdgrp.rec.puramt",order=100)
        public boolean ruleCpdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCpdgrp().getRec().getPuramt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt);
			

			Boolean fxflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg());
			checkSumAmt(fxflg,purflg);


			return true;
        }

        /**
        *   source:cpthyf.@0015.script
        */
        @Rule(target="mtabut.invchk",order=100)
        public boolean ruleMtabutInvchkN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ownref=this.getCpdgrp().getRec().getOwnref();
			// 校验发票
			boolean checkresult = true;
			
			
			checkresult = this.invCheckList(ownref);
			if (checkresult)
			{
			  String tranname = ctx.getTransName();
			  StringBuffer args=new StringBuffer();
			  args.append("waishu_chayan");
			  args.append("|");
			  args.append(tranname);
			  args.append("|");
			  args.append(ownref);
			  // 调用核验接口
			  Object resMsg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","waishu_chayan","waishu_chayan",new Object[]{args.toString()});
			  String content = (String)MdaUtils.invoke(resMsg,"getContent");
			  if (!MdaUtils.isEmpty(content))
			  {
			    // ERR0009本批次没有需要查验的发票
			    if (!content.startsWith("0000000") && !content.startsWith("ERR0009"))
			    {
			      
			      
			      log.info("{}","发票核验失败："+content);
			      ctx.setMessage("提示","发票核验失败，请稍后重试！");
			      return true;
			    }
			  }
			  ctx.setMessage("提示","调用发票核验成功，在发票列表查看核验结果");
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:cpthyf.@0016.script
        */
        @Rule(target="mtabut.sav",order=190)
        public boolean ruleMtabutSavN190(){
            IContext ctx = MdaEnv.getContext();
            
			this.setAdrblk();
			if(!ctx.checkAll(this.getCpdgrp()))
			{
			  ctx.setMessage("R9999","业务要素校验不通过");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getAtccod()))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.atccod","主体标识码不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getApl().getPts().getNam()))
			{
			  ctx.setFieldError(this,"cpdgrp.apl.pts.nam","汇款人名称不能为空");
			  return false;
			}
			String ownref=this.getCpdgrp().getRec().getOwnref();
			this.getCpdgrp().getRec().setAutflg("1");
			
			this.getCpdgrp().setIsskip("N");
			

			// 校验发票必须上传
			Argument<Integer> invnum =new Argument<Integer>("invnum");
			String invsql="SELECT count(*) invnum FROM inv WHERE ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(invsql);
			log.info("{}","校验发票必须上传："+ctx.getErrorCode());
			if (ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(invnum);
			  ctx.getDaoSession().dbCloseCursor();
			  if (invnum.value==0)
			  {
			    ctx.setMessage("提示","请先上传发票");
			    return false;
			  }
			}
			else
			{
			  ctx.setMessage("提示","查询数据失败");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			if (!this.delRepeatInv(false))
			{
			  ctx.setMessage("提示","发票重复上传，请确认");
			  return false;
			}
			//Platform.dbBegin();
			// 核验查询结果
			// 校验是否在发票核验中、查询失败或异常跳过发票核验
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvchk());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvchk(),new Argument("ownref",ownref));
			ctx.getErrorCode();
			if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvchk().getInr()))
			{
			  ctx.setMessage("提示","请先进行发票核验！");
			  return false;
			}
			if ("00".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			{
			  ctx.setMessage("提示","发票核验中，请稍后重试！");
			  return false;
			}
			else if ("0".equals(this.getCpdgrp().getInvs().getInvchk().getResult())||"9".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			{
			  // 校验发票是否都核验完成
			  Argument<Integer> invsupnum =new Argument<Integer>("invsupnum");
			  String invsupsql="SELECT count(*) invsupnum FROM invsup WHERE ownref='"+ownref+"' and state is null";
			  ctx.getDaoSession().dbExecuteSQL(invsupsql);
			  log.info("{}","校验发票是否都核验完成："+ctx.getErrorCode());
			  if (ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(invsupnum);
			    ctx.getDaoSession().dbCloseCursor();
			    if (invsupnum.value>0)
			    {
			      ctx.setMessage("提示","请先进行发票核验！");
			      return false;
			    }
			  }
			  else
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    ctx.setMessage("提示","查询数据失败");
			    return false;
			  }
			  if(MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000052"),MdaUtils.getI18NString("cpthyf","CT000053")))
			  {
			    return false;
			  }
			  else
			  {
			    this.getCpdgrp().setIsskip("Y");
			    
			    this.getCpdgrp().getRec().setAutflg("2");
			    
			    this.getCpdgrp().getInvs().getInvchk().setMantype("2");
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInvchk());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      ctx.setMessage("提示","更新数据失败");
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			  }
			}
			else
			{
			  // 核验发票状态、 核验发票一致性、 核验发票次数
			  // 汇款币种
			  String remcur=this.getCpdgrp().getRec().getRemcur();
			  // 汇款纳税人识别号
			  String actcod=this.getCpdgrp().getRec().getAtccod();

			  ctx.getDaoSession().dbReadset(this.getCpdgrp().getInvs().getInvsuplst(),new Argument<String>("ownref",ownref),new Argument<Object>("invinr",ASC));
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    ctx.setMessage("提示","查询数据失败");
			    return false;
			  }

			  Boolean chkstate = true;
			  Boolean chktax = true;
			  Boolean chkremcur = true;
			  Boolean chkgdname = true;
			  Boolean checkorder = true;
			  List<String> taxList = new ArrayList();
			  List<String> saletaxList = new ArrayList();
			  taxList.add(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getPurchasertaxno());
			  saletaxList.add(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getSalestaxno());
			  StringBuffer chkres = null;
			  log.info("{}","发票状态是否正常");
			  if (this.getCpdgrp().getInvs().getInvsuplst().size()==0)
			  {
			    ctx.setMessage("提示","请先进行发票核验！");
			    return false;
			  }
			  for(int i=0; i<this.getCpdgrp().getInvs().getInvsuplst().size(); i++)
			  {
			    // 发票状态是否正常
			    if (!"0".equals(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getState()))
			    {
			      log.info("{}","发票状态异常"+this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getState()+":"+this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getInvinr());
			      MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			      ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument("inr",this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getInvinr()));
			      this.getCpdgrp().getInvs().getInv().setCheckresult("发票状态异常");
			      ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			      if(ctx.getErrorCode()!=NO_ERROR)
			      {
			        ctx.setMessage("提示","更新数据失败");
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			      chkstate = false;
			      this.getCptp().getInvl().getInvlst().getElement(i).setCheckresult("发票状态异常");
			      
			      
			      continue;
			    }
			    // 校验销方信息是否一致
			    if (!saletaxList.contains(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getSalestaxno()))
			    {
			      saletaxList.add(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getSalestaxno());
			    }
			    // 校验发票抬头信息是否一致
			    if (!taxList.contains(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getPurchasertaxno()))
			    {
			      taxList.add(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getPurchasertaxno());
			    }
			    chkres = new StringBuffer();
			    // 校验主体标识码和发票的纳税人识别号是否一致
			    if (i==0 && (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getPurchasertaxno())||!actcod.equals(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getPurchasertaxno().substring(8,17))))
			    {
			      chkres.append("主体标识码和发票的纳税人识别号信息不一致;");
			      chktax = false;
			    }
			    else if (i!=0 && !this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getPurchasertaxno().equals(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getPurchasertaxno()))
			    {
			      chkres.append("发票抬头信息不一致;");
			    }
			    else if (!remcur.equals(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getGfrcur()))
			    {
			      // 发票币种与汇款币种是否一致
			      chkres.append("汇款币种与发票币种信息不一致;");
			      chkremcur = false;
			    }
			    else if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getRemarks())||!this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getRemarks().contains("运费"))
			    {
			      // 校验发票的货物或应税劳务、服务名称信息是否包含“运费”
			      chkres.append("发票用途不是运费;");
			      chkgdname = false;
			    }
			    else if (i==0 && (MdaUtils.isEmpty(this.getCpdgrp().getBen().getPts().getNam())||!this.ignorechnen(this.getCpdgrp().getBen().getPts().getNam()).equals(this.ignorechnen(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getSalesname()))))
			    {
			      chkres.append("收款人名称与发票销售方名称不一致;");
			    }
			    else if (i!=0 && !this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getSalestaxno().equals(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getSalestaxno()))
			    {
			      chkres.append("发票销售方信息不一致;");
			    }
			    else if ((!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getChecktotal())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getChecktotal())>1)
			      ||(!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getCheckown())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getCheckown())>1)
			      ||(!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getCheckother())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getCheckother())>1)
			      ||(!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitortotal())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitortotal())>1)
			      ||(!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitorown())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitorown())>1)
			      ||(!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitorother())&&Integer.valueOf(this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getMonitorother())>1))
			      {
			        // 校验核验次数
			        checkorder = false;
			        chkres.append("非首次查验或被监控过;");
			      }
			      MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			      ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument("inr",this.getCpdgrp().getInvs().getInvsuplst().getElement(i).getInvinr()));
			      if (MdaUtils.isEmpty(chkres.toString()))
			      {
			        this.getCpdgrp().getInvs().getInv().setCheckresult("核验成功");
			        
			      }
			      else
			      {
			        this.getCpdgrp().getInvs().getInv().setCheckresult(chkres.toString());
			        
			      }
			      this.getCptp().getInvl().getInvlst().getElement(i).setCheckresult(this.getCpdgrp().getInvs().getInv().getCheckresult());
			      
			      ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			      if(ctx.getErrorCode()!=NO_ERROR)
			      {
			        ctx.setMessage("提示","更新数据失败");
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			    }
			    log.info("{}","发票列表循环结束");
			    if (!chkstate)
			    {
			      ctx.setMessage("提示","发票状态异常");
			      return false;
			    }
			    // 发票信息不一致，提交标识
			    Boolean invinfoconsi = false;
			    if (taxList.size()>1)
			    {

			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000054"),MdaUtils.getI18NString("cpthyf","CT000055")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    else if (!chktax)
			    {
			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000056"),MdaUtils.getI18NString("cpthyf","CT000057")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    else if (!chkremcur)
			    {
			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000058"),MdaUtils.getI18NString("cpthyf","CT000059")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    else if (!chkgdname)
			    {
			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000060"),MdaUtils.getI18NString("cpthyf","CT000061")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    else if (MdaUtils.isEmpty(this.getCpdgrp().getBen().getPts().getNam()) || !this.ignorechnen(this.getCpdgrp().getBen().getPts().getNam()).equals(this.ignorechnen(this.getCpdgrp().getInvs().getInvsuplst().getElement(0).getSalesname())))
			    {
			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000175"),MdaUtils.getI18NString("cpthyf","CT000176")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    else if (saletaxList.size()>1)
			    {
			      if(!MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000177"),MdaUtils.getI18NString("cpthyf","CT000178")))
			      {
			        invinfoconsi = true;
			      }
			      else
			      {
			        return false;
			      }
			    }
			    // 发票信息不一致
			    if (invinfoconsi)
			    {
			      this.getCpdgrp().getRec().setAutflg("3");
			      
			      this.getCpdgrp().getInvs().getInvchk().setMantype("3");
			      ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInvchk());
			      if(ctx.getErrorCode()!=NO_ERROR)
			      {
			        ctx.setMessage("提示","更新数据失败");
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			    }
			    // 核验次数
			    if (!checkorder && !invinfoconsi)
			    {
			      this.getCpdgrp().getRec().setAutflg("4");
			      
			      this.getCpdgrp().getInvs().getInvchk().setMantype("4");
			      ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInvchk());
			      if(ctx.getErrorCode()!=NO_ERROR)
			      {
			        ctx.setMessage("提示","更新数据失败");
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			    }
			  }
			  if ("1".equals(this.getCpdgrp().getRec().getAutflg()))
			  {
			    String chkresult = this.getParmod().hyfTimeControl();
			    if (!MdaUtils.isEmpty(chkresult))
			    {
			      ctx.setMessage("提示",chkresult+"允许申请，当前时间不能进行申请");
			      return false;
			    }
			  }
			
			return true;
        }

        /**
        *   source:cpthyf.@0025.script
        */
        @Rule(target="cpdgrp.rec.fxamt",order=100)
        public boolean ruleCpdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			Boolean fxflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg());
			checkSumAmt(fxflg,purflg);

			return true;
        }

        /**
        *   source:cpthyf.@0032.script
        */
        @Rule(target="cptp.sure",order=100)
        public boolean ruleCptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000074"),MdaUtils.getI18NString("cpthyf","CT000075"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(index).getCod());
			this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(index).getChnnam());
			
			
			

			return true;
        }

        /**
        *   source:cpthyf.@0033.script
        */
        @Rule(target="cptp.search",order=100)
        public boolean ruleCptpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			String sql = "SELECT * FROM cty ";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getCty().getEngnam()))
			{
			  String nam = this.getCpdgrp().getCty().getEngnam().toUpperCase();
			  sql = sql+" WHERE alpcod like '%"+nam+"%' or cod like '%"+nam+"%' or engnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%' or chnnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%'";
			}
			sql = sql+" ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ctylst len="+this.getCpdgrp().getCtylst().fullSize());
			if(MdaUtils.isEmpty(this.getCpdgrp().getCtylst())  ||  this.getCpdgrp().getCtylst().fullSize()<=0)
			{
			  sql = "SELECT * FROM cty  WHERE numcod like '%"+this.getCpdgrp().getCty().getEngnam() +"%'";
			  sql = sql+" ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			

			return true;
        }

        /**
        *   source:cpthyf.@0036.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(Platform.isFromApp())
			{
			  String sptinr=(String)ctx.restoreData("__sptinr");
			  log.info("{}","__sptinr"+sptinr);
			  if(!MdaUtils.isEmpty(sptinr)&&MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			  {
			    ctx.setMessage("E9999","未找到对应的交易信息或您无权访问该笔交易");
			    return false;
			  }
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("E9999","业务归属行为空，请先维护该信息。");
			  return false;
			}
			String objinr = "";
			if (!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()))
			{
			  String ownref = this.getCpdgrp().getRec().getOwnref();
			  Argument<BigDecimal> amtsum =new Argument<BigDecimal>("amtsum");
			  String invsql="SELECT sum(gframt) amtsum FROM invsup WHERE ownref='"+ownref+"'";
			  ctx.getDaoSession().dbExecuteSQL(invsql);
			  log.info("{}","汇款金额校验=======："+ctx.getErrorCode());
			  if (ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(amtsum);
			    ctx.getDaoSession().dbCloseCursor();
			    if (this.getCpdgrp().getRec().getRemamt().compareTo(new BigDecimal(String.valueOf(amtsum.value)))==1)
			    {
			      ctx.setMessage("提示","汇款金额需小于等于发票总金额，请检查汇款金额及发票列表外币金额");
			      return false;
			    }
			  }
			  else
			  {
			    if (ctx.getErrorCode()==NO_MORE_ROW)
			    {
			      ctx.setMessage("提示","汇款金额需小于等于发票总金额，请检查汇款金额及发票列表外币金额");
			      ctx.getDaoSession().dbCloseCursor();
			      return false;
			    }
			    else
			    {
			      ctx.setMessage("提示","查询数据失败");
			      ctx.getDaoSession().dbCloseCursor();
			      return false;
			    }

			  }
			}

			if(!MdaUtils.isEmpty(this.getTrnmod().getTrninr()))
			{
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			}
			else
			{
			  BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			  amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			  this.getCpdgrp().getRec().setFxamt(amt);

			  BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			  amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			  this.getCpdgrp().getRec().setPuramt(amt1);

			  BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			  amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			  this.getCpdgrp().getRec().setRemamt(amt2);

			  BigDecimal amt4 = this.getCpdgrp().getRec().getBopamt1();
			  amt4 = MdaUtils.parseDecimal(MdaUtils.format(amt4,"#0.00"));
			  this.getCpdgrp().getRec().setBopamt1(amt4);
			  this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));

			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    objinr = this.getCpdgrp().getRec().getInr();
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getApl().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getBen().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getAcw().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getRcp().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getPay().getPts(),objinr);
			  }
			  else
			  {
			    this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getRec());
			    objinr = this.getCpdgrp().getRec().getInr();
			    String objtyp = "cpd";
			    this.getCpdgrp().getApl().savpts(objinr,objtyp);
			    this.getCpdgrp().getBen().savpts(objinr,objtyp);
			    this.getCpdgrp().getAcw().savpts(objinr,objtyp);
			    this.getCpdgrp().getRcp().savpts(objinr,objtyp);
			    //$cpdgrp\\pay.savpts(objinr,objtyp);
			    //直接申请行
			    this.getCpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			    this.getCpdgrp().getDap().getPts().setObjinr(objinr);
			    this.getCpdgrp().getDap().getPts().setObjtyp("cpd");
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getDap().getPts());
			    //如果是商行，要把商行信息作为转递申请人存储
			    if("1".equals(this.getSysmod().getPty().getPtytyp()))
			    {
			      this.getCpdgrp().getTrp().savTrp(objtyp,objinr);
			    }
			  }

			  //$sysmod.generatorPdf($trnmod\\trn\\inr.getValue(),"remitapplys",$mtabut\\tdapldoc.getValue(),true);
			  this.getCptp().encode();
			  // 讲受益人的国别信息转换为2为代码
			  if(! MdaUtils.isEmpty(this.getCpdgrp().getRec().getPyecry()))
			  {
			    log.debug("{}","in 国别转换为2位数: pyecry=  " + this.getCpdgrp().getRec().getPyecry() );
			    String cty = this.getCpdgrp().getRec().getPyecry();
			    for(int k=0;k<this.getCpdgrp().getCtylst().fullSize();k++)
			    {
			      if(cty.equals(this.getCpdgrp().getCtylst().getElement(k).getAlpcod()))
			      {
			        this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(k).getChnnam());
			        this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(k).getCod());
			        break;
			      }
			    }
			  }
			  log.debug("{}"," 2位国别码为： cod =" + this.getCpdgrp().getCod() + ", ctydes=" + this.getCpdgrp().getCtydes()) ;

			}
			/*
			  String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			  filename=Platform.catPath(Platform.getRootPath(),filename);
			  */
			if(!this.getTrnmod().trnSetFromContract()) return false;
			log.info("{}","locale:"+ctx.getLocale().toString());
			MdaEnv.setLocale(Locale.SIMPLIFIED_CHINESE);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			//IPanel[] panels=$cptp\\stpmod.getAllPanelsName();
			//Platform.saveDisplay(panels,filename);
			ctx.saveDisplay(filename);

			// 删除待办海运费SPT表临时数据
			log.debug("{}","--删除spt临时数据");
			MdaUtils.clear(this.getCpdgrp().getSpt());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getSpt(),new Argument("imgref",this.getCpdgrp().getRec().getOwnref()),new Argument("sta","H").or(new Argument("sta","I")));
			log.debug("{}","========sptinr:"+this.getCpdgrp().getSpt().getInr());
			if(!MdaUtils.isEmpty(this.getCpdgrp().getSpt().getInr()))
			{
			  //String delsptinr = $cpdgrp\\spt\\inr.getValue();
			  //String fileName = $sysmod.creatHyFileName(inr.getValue());
			  ////log.debug(fileName);
			  //if(Platform.fileExists(filename))
			  // Platform.fileDelete(filename);
			  ctx.getDaoSession().dbDelete(this.getCpdgrp().getSpt());
			}

			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cpthyf.@0037.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			//提交210，保存要预览的pdf资源
			if(MdaUtils.isEmpty(this.getTrnmod().getTrninr()))
			{
			  int cnt = 1;
			  String labels = "申请书";
			  String tempfiles;
			  //境内
			  tempfiles = "A:cpthyf";

			  this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			  this.getTrnmod().getApldoc().generatorAllPDF();
			}
			// 设置生成报文信息
			String fmdno=this.getCpdgrp().getRec().getFmdno();
			if (MdaUtils.isEmpty(fmdno))
			{
			  this.getCpdgrp().getRec().setFmdno("N/A");
			  
			}
			String conno=this.getCpdgrp().getRec().getConno();
			if (MdaUtils.isEmpty(conno))
			{
			  this.getCpdgrp().getRec().setConno("N/A");
			  
			}


			return true;
        }

        /**
        *   source:cpthyf.@0038.script
        */
        @Rule(target="mtabut.imgviw",order=100)
        public boolean ruleMtabutImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}"," in imgviw....");
			this.getTrnmod().getItfmod().getImgmod().imgScans(this.getTrnmod().getTrninr());

			return true;
        }

        /**
        *   source:cpthyf.@0039.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt1);
			

			BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt2);
			

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));
			

			this.setAdrblk();
			this.getCptp().getPdfviw().callPDFComponent("","cpthyf","境内汇款申请书",1);

			return true;
        }

        /**
        *   source:cpthyf.@0041.script
        */
        @Rule(target="cptp.invl.invref",order=100)
        public boolean ruleCptpInvlInvrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 刷新发票列表
			String ownrefbus=this.getCpdgrp().getRec().getOwnref();
			this.getCptp().getInvl().qureyInvlst(ownrefbus);
			int length = this.getCptp().getInvl().getInvlst().fullSize();
			if (length == 0)
			{
			  ctx.setMessage("提示","请先上传发票");
			  return false;
			}
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvlst());
			String ownref=this.getCpdgrp().getRec().getOwnref();
			List selObjs=new ArrayList();
			selObjs.add("0");
			selObjs.add("2");
			ctx.getDaoSession().dbReadset(this.getCpdgrp().getInvs().getInvlst(),new Argument<String>("ownref",ownref),new Argument<Object>("ocrres",IN,selObjs.toArray()));
			// 发票识别中
			boolean invocr = false;
			if(this.getCpdgrp().getInvs().getInvlst().size()>0)
			{
			  ctx.setMessage("提示","发票识别中");
			  invocr = true;
			}
			else
			{
			  // 校验是否在发票核验中
			  MdaUtils.clear(this.getCpdgrp().getInvs().getInvchk());
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvchk(),new Argument<String>("ownref",ownref));
			  if ("00".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			  {
			    ctx.setMessage("提示","发票核验中");
			  }
			}
			this.invInversion(ownref, invocr);

			return true;
        }

        /**
        *   source:cpthyf.@0042.script
        */
        @Rule(target="cptp.invl.upinv",order=100)
        public boolean ruleCptpInvlUpinvN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ownref=this.getCpdgrp().getRec().getOwnref();
			Argument<Integer> invnum =new Argument<Integer>("invnum");
			String invsql="SELECT count(*) invnum FROM inv WHERE ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(invsql);
			if (ctx.getErrorCode()!=NO_ERROR)
			{
			  log.info("{}","发票上传："+ctx.getErrorCode());
			  ctx.getDaoSession().dbCloseCursor();
			  return true;
			}
			ctx.getDaoSession().dbFetchFields(invnum);
			ctx.getDaoSession().dbCloseCursor();
			if (invnum.value>=255)
			{
			  ctx.setMessage("提示","最多允许上传255张发票，已经超过限制");
			  return true;
			}

			IStream is = this.getCptp().getInvl().getUpinv();

			String filenam=is.getName();
			log.info("{}","上传文件名称："+filenam);
			if (MdaUtils.isEmpty(filenam) || !filenam.contains("."))
			{
			  ctx.setMessage("提示","只能上传pdf、jpg、jpeg、rar、zip类型文件");
			  return true;
			}
			int typindex = filenam.lastIndexOf(".");
			String typfilenam = filenam.substring(0,typindex);
			String typnam = filenam.substring(typindex+1);
			List<String> typeList = new ArrayList<String>();
			typeList.add("pdf");
			typeList.add("jpg");
			typeList.add("jpeg");
			typeList.add("rar");
			typeList.add("zip");
			if (!typeList.contains(typnam.toLowerCase()))
			{
			  ctx.setMessage("提示","只能上传pdf、jpg、jpeg、rar、zip类型文件");
			  return true;
			}
			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String finfile = MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img"),date);
			if (!MdaUtils.fileExists(finfile))
			{
			  java.io.File f = null;
			  f = new java.io.File(finfile);
			  boolean bool = f.mkdir();
			  if(!bool)
			  {
			    log.debug("{}",finfile+" crtead Failed!");
			  }
			}
			String objtyp = MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec());
			String targetFile = MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img"),ownref),filenam);
			String datetime = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");
			String toFile = MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img"),datetime);
			java.io.File[] files = null;
			MdaUtils.streamSave(is,targetFile);
			Long fileSize = MdaUtils.fileSize(targetFile);
			int filelength = 0;
			if ("rar".equals(typnam.toLowerCase()) || "zip".equals(typnam.toLowerCase()))
			{
			  if (fileSize > 31457280)
			  {
			    ctx.setMessage("提示","压缩包大小不能超过30M");
			    return true;
			  }
			  if ("rar".equals(typnam.toLowerCase()))
			  {
			    MdaUtils.invoke("com.brilliance.base.utils.CompressRarUtil","unrarFile",targetFile,toFile);
			  }
			  else
			  {
			    MdaUtils.invoke("com.brilliance.base.utils.CompressUtil","unzipFile",targetFile,toFile);
			  }
			  java.io.File openFile = new java.io.File(toFile);
			  files = openFile.listFiles();
			  if (files.length==0)
			  {
			    ctx.setMessage("提示","压缩包中内容不能为空");
			    return true;
			  }

			  for(java.io.File file:files)
			  {
			    if (file.isDirectory())
			    {
			      java.io.File[] firstfiles = file.listFiles();
			      if (firstfiles.length!=0)
			      {
			        filelength = filelength + firstfiles.length;
			        for(java.io.File firstfile:firstfiles)
			        {
			          if(firstfile.isFile())
			          {
			            String fileName = firstfile.getName();
			            int typeindex = fileName.lastIndexOf(".");
			            String typenam = fileName.substring(typeindex+1);
			            if (!typeList.contains(typenam.toLowerCase()))
			            {
			              ctx.setMessage("提示","压缩包一层文件夹中只能包含pdf、jpg、jpeg类型文件");
			              return true;
			            }
			            if (file.length()>3145728)
			            {
			              ctx.setMessage("提示","单个文件大小不能超过3M");
			              return true;
			            }
			            filelength = filelength + 1;
			          }
			          else
			          {
			            ctx.setMessage("提示","压缩包一层文件夹中只能包含pdf、jpg、jpeg类型文件");
			            return true;
			          }
			        }
			      }
			    }
			    else if(file.isFile())
			    {
			      String fileName = file.getName();
			      int typeindex = fileName.lastIndexOf(".");
			      String typenam = fileName.substring(typeindex+1);
			      if (!typeList.contains(typenam.toLowerCase()))
			      {
			        ctx.setMessage("提示","压缩包中只能包含一层文件夹、pdf、jpg、jpeg类型文件");
			        return true;
			      }
			      if (file.length()>3145728)
			      {
			        ctx.setMessage("提示","单个文件大小不能超过3M");
			        return true;
			      }
			      filelength = filelength + 1;
			    }
			    else
			    {
			      ctx.setMessage("提示","压缩包中只能包含一层文件夹、pdf、jpg、jpeg类型文件");
			      return true;
			    }
			  }
			}
			else
			{
			  if (fileSize > 3145728)
			  {
			    ctx.setMessage("提示","单个文件大小不能超过3M");
			    return true;
			  }
			  java.io.File openFile = new java.io.File(targetFile);
			  files = new java.io.File[1];
			  files[0] = openFile;
			  filelength = filelength + 1;
			}
			if (invnum.value+filelength>255)
			{
			  ctx.setMessage("提示","最多允许上传255张发票，已经超过限制");
			  return true;
			}
			ctx.getDaoSession().dbBegin();
			String imgref = this.saveImg(ownref,objtyp);
			int tblcnt=0;
			String cls="com.brilliance.eibs.main.Client";
			Object rtnVal = MdaUtils.invoke(cls,"scall","gettblinr","gettblinr",new Object[]{filelength});
			Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			String errcod = (String)retMsg.get("errorCode");
			if("00000".equals(errcod))
			{
			  Object objm = retMsg.get("tblcnt");
			  tblcnt = Integer.parseInt(objm.toString());
			}
			if(!"00000".equals(errcod)||tblcnt<=0)
			{
			  ctx.getDaoSession().dbRollback();
			  return true;
			}
			for(java.io.File file:files)
			{
			  if (file.isDirectory())
			  {
			    java.io.File[] firstfiles = file.listFiles();
			    if (firstfiles.length!=0)
			    {
			      filelength = filelength + firstfiles.length;
			      for(java.io.File firstfile:firstfiles)
			      {
			        String fileName = firstfile.getName();
			        fileName = this.stringToUTF8String(fileName);
			        int typeindex = fileName.lastIndexOf(".");
			        String typefilenam = fileName.substring(0,typeindex);
			        String typenam = fileName.substring(typeindex+1);
			        String uuid = UUID.randomUUID().toString().replace("-", "");
			        String alsfile = uuid+"."+typenam;
			        firstfile.renameTo(new java.io.File(MdaUtils.catPath(finfile,alsfile)));
			        this.saveSingleInv(typenam,typefilenam,ownref,alsfile,tblcnt,imgref,objtyp);
			        tblcnt=tblcnt+1;

			      }
			    }
			  }
			  else if(file.isFile())
			  {
			    String fileName = file.getName();
			    fileName = this.stringToUTF8String(fileName);
			    int typeindex = fileName.lastIndexOf(".");
			    String typefilenam = fileName.substring(0,typeindex);
			    String typenam = fileName.substring(typeindex+1);
			    String uuid = UUID.randomUUID().toString().replace("-", "");
			    String alsfile = uuid+"."+typenam;
			    file.renameTo(new java.io.File(MdaUtils.catPath(finfile,alsfile)));
			    this.saveSingleInv(typenam,typefilenam,ownref,alsfile,tblcnt,imgref,objtyp);
			    tblcnt=tblcnt+1;
			  }
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","保存数据失败");
			  ctx.getDaoSession().dbRollback();
			  return true;
			}
			this.getCptp().getInvl().qureyInvlst(ownref);
			ctx.setMessage("提示","上传发票成功，在发票列表查看识别结果");
			
			

			return true;
        }

        /**
        *   source:cpthyf.@0043.script
        */
        @Rule(target="cptp.invl.detailview",order=100)
        public boolean ruleCptpInvlDetailviewN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看发票详情
			int index = -1;
			int count = 0;
			for(int i=0;i<this.getCptp().getInvl().getInvlst().fullSize();i++)
			{
			  if("X".equals(this.getCptp().getInvl().getInvlst().getElement(i).getSelflg()))
			  {
			    index=i;
			    ++count;
			  }
			}
			if(count>1)
			{
			  ctx.setMessage("提醒","不能同时查看多笔业务");
			  return true;
			}
			if(count==0)
			{
			  ctx.setMessage("提醒",MdaUtils.getI18NString("cpthyf","CT000163"));
			  return true;
			}
			if(index<0||index>=this.getCptp().getInvl().getInvlst().fullSize())
			{
			  index=0;
			  if(index<0||index>=this.getCptp().getInvl().getInvlst().fullSize())
			  {
			    ctx.setMessage("提醒",MdaUtils.getI18NString("cpthyf","CT000164"));
			    return true;
			  }
			}
			String indinr=this.getCptp().getInvl().getInvlst().getElement(index).getInr();
			if(MdaUtils.isEmpty(indinr))
			{
			  ctx.setMessage("提醒","请刷新重试！");
			  return false;
			}

			invDetail(indinr);

			return true;
        }

        /**
        *   source:cpthyf.@0044.script
        */
        @Rule(target="cptp.invl.invdel",order=100)
        public boolean ruleCptpInvlInvdelN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 批量删除发票
			int lstsize = this.getCptp().getInvl().getInvlst().fullSize();
			int count = 0;
			List<String> inrs = new ArrayList<String>();
			for (int i=0;i<lstsize;i++)
			{
			  if(!"X".equals(this.getCptp().getInvl().getInvlst().getElement(i).getSelflg()))
			  {
			    continue;
			  }
			  if(++count>50)
			  {
			    ctx.setMessage("提示","一次不能删除50笔以上的发票");
			    return false;
			  }
			  inrs.add(this.getCptp().getInvl().getInvlst().getElement(i).getInr());
			}
			// 发票列表删除
			if(count==0)
			{
			  ctx.setMessage("提示","请选择记录 ！");
			  return false;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("cpthyf","CT000092"),MdaUtils.getI18NString("cpthyf","CT000093")))
			{
			  return false;
			}
			for (int i=0;i<inrs.size();i++)
			{
			  this.delinv(inrs.get(i),"1","","","","",0);
			}
			ctx.setMessage("提示","删除成功！");

			return true;
        }

        /**
        *   source:cpthyf.@0064.script
        */
        @Rule(target="cptp.invl.invsav",order=100)
        public boolean ruleCptpInvlInvsavN100(){
            IContext ctx = MdaEnv.getContext();
            
			if (!this.invlstBtnContol())
			{
			  return true;
			}
			if(!ctx.checkAll(this.getCptp().getInvl().getInvdet()))
			{
			  ctx.setMessage("R9999","业务要素校验不通过");
			  return true;
			}
			String indinr=this.getCptp().getInvl().getInvdet().getInr();
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvsup());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvsup(),new Argument<String>("invinr",indinr));

			if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsup().getInr()))
			{
			  ctx.setMessage("提示","发票未识别，请识别完成后修改");
			  return false;
			}
			MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument<String>("ownref",this.getCpdgrp().getRec().getOwnref()),new Argument<String>("invoicecode",this.getCptp().getInvl().getInvdet().getInvoicecode()),new Argument<String>("invoicenumber",this.getCptp().getInvl().getInvdet().getInvoicenumber()),new Argument<String>("checkcode",this.getCptp().getInvl().getInvdet().getCheckcode()),new Argument<String>("inr",NE,indinr));
			if (!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInv().getInr()))
			{
			  ctx.setMessage("提示","已存在相同发票号码、发票代码、校验码后六位发票");
			  return false;
			}
			MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument<String>("inr",indinr));
			BigDecimal invamt = this.getCptp().getInvl().getInvdet().getInvamt();
			invamt = MdaUtils.parseDecimal(MdaUtils.format(invamt,"#0.00"));
			this.getCpdgrp().getInvs().getInv().setInvoicecode(this.getCptp().getInvl().getInvdet().getInvoicecode());
			this.getCpdgrp().getInvs().getInv().setInvoicenumber(this.getCptp().getInvl().getInvdet().getInvoicenumber());
			this.getCpdgrp().getInvs().getInv().setBillingdate(this.getCptp().getInvl().getInvdet().getBillingdate());
			this.getCpdgrp().getInvs().getInv().setCheckcode(this.getCptp().getInvl().getInvdet().getCheckcode());
			this.getCpdgrp().getInvs().getInv().setInvamt(invamt);
			
			
			
			
			
			if (!MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsup().getState()))
			{
			  this.getCpdgrp().getInvs().getInv().setCheckresult("核验成功");
			}
			else
			{
			  this.getCpdgrp().getInvs().getInv().setCheckresult("识别完成");
			}
			
			BigDecimal gframt = this.getCptp().getInvl().getInvdet().getGframt();
			gframt = MdaUtils.parseDecimal(MdaUtils.format(gframt,"#0.00"));
			this.getCpdgrp().getInvs().getInvsup().setGframt(gframt);
			this.getCpdgrp().getInvs().getInvsup().setGfrcur(this.getCptp().getInvl().getInvdet().getGfrcur());
			this.getCpdgrp().getInvs().getInvsup().setRemarks(this.getCptp().getInvl().getInvdet().getRemarks());
			this.getCpdgrp().getInvs().getInvsup().setPurchasername(this.getCptp().getInvl().getInvdet().getPurchasername());
			this.getCpdgrp().getInvs().getInvsup().setSalesname(this.getCptp().getInvl().getInvdet().getSalesname());
			this.getCpdgrp().getInvs().getInvsup().setSalestaxno(this.getCptp().getInvl().getInvdet().getSalestaxno());
			this.getCpdgrp().getInvs().getInvsup().setPurchasertaxno(this.getCptp().getInvl().getInvdet().getPurchasertaxno());
			
			
			
			
			
			
			

			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			log.info("{}","更新发票信息："+ctx.getErrorCode());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","更新数据失败！");
			  return true;
			}
			ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInvsup());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","更新数据失败！");
			  return true;
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","更新数据失败！");
			  return true;
			}
			ctx.setMessage("提示","保存成功");
			this.getCptp().getInvl().qureyInvlst(this.getCpdgrp().getInvs().getInv().getOwnref());
			

			return true;
        }

        /**
        *   source:cpthyf.@0075.script
        */
        @Rule(target="cptp.actsurel",order=100)
        public boolean ruleCptpActsurelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCptp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000147"),MdaUtils.getI18NString("cpthyf","CT000148"));
			  return true;
			}
			if("fx".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setFxact(this.getCptp().getActlst().getElement(index).getAct());
			  
			}
			else if("pur".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setPuract(this.getCptp().getActlst().getElement(index).getAct());
			  
			  ctx.postRule(this,"cpdgrp.rec.puract");
			}
			else if("oth".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setOthact(this.getCptp().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:cpthyf.@0076.script
        */
        @Rule(target="cptp.actcancel",order=100)
        public boolean ruleCptpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cpthyf.@0078.script
        */
        @Rule(target="cptp.invl.invlst",order=100)
        public boolean ruleCptpInvlInvlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 发票列表超链接
			int index = 0;
			if(index<0||index>=this.getCptp().getInvl().getInvlst().fullSize())
			  return true;
			String indinr=this.getCptp().getInvl().getInvlst().getElement(index).getInr();
			invDetail(indinr);

			return true;
        }

        /**
        *   source:cpthyf.@0084.script
        */
        @Rule(target="mtabut.ped",order=900)
        public boolean ruleMtabutPedN900(){
            IContext ctx = MdaEnv.getContext();
            
			//log.debug("===========pedflg"+$sysmod\\pedflg.getValue());
			if(MdaUtils.isEmpty(this.getSysmod().getPedflg()))
			{
			  log.debug("{}","===========SptInr="+this.getSysmod().getTmpdata());
			  if(!MdaUtils.isEmpty(this.getSysmod().getTmpdata()))
			  {
			    MdaUtils.clear(this.getCpdgrp().getSpt());
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getSpt(),new Argument("inr", this.getSysmod().getTmpdata()));
			    ctx.getDaoSession().dbBegin();
			    this.getCpdgrp().getSpt().setSta("I");
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getSpt());
			    if(ctx.getErrorCode() == NO_ERROR)
			      ctx.getDaoSession().dbCommit();
			    else
			      ctx.getDaoSession().dbRollback();
			  }
			}

			return true;
        }

        /**
        *   source:cpthyf.@0086.script
        */
        @Rule(target="mtabut.sav",order=1210)
        public boolean ruleMtabutSavN1210(){
            IContext ctx = MdaEnv.getContext();
            
			String autflg = this.getCpdgrp().getRec().getAutflg();
			if ("1".equals(autflg))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000157"),MdaUtils.getI18NString("cpthyf","CT000158"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000159"),MdaUtils.getI18NString("cpthyf","CT000160"));
			}
			

			return true;
        }

        /**
        *   source:cpthyf.@0088.script
        */
        @Rule(target="cptp.invl.timer",order=100)
        public boolean ruleCptpInvlTimerN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 自动刷新发票列表
			int length = this.getCptp().getInvl().getInvlst().fullSize();
			if (length == 0)
			{
			  return true;
			}
			if (!MdaUtils.isEmpty(this.getCpdgrp().getRec().getOwnref()))
			{
			  boolean checkres = true;
			  String ownref=this.getCpdgrp().getRec().getOwnref();
			  List selObjs=new ArrayList();
			  selObjs.add("0");
			  selObjs.add("2");
			  ctx.getDaoSession().dbReadset(this.getCpdgrp().getInvs().getInvlst(),new Argument<String>("ownref",ownref),new Argument<Object>("ocrres",IN,selObjs.toArray()));
			  // 发票识别中
			  boolean invocr = false;
			  if(this.getCpdgrp().getInvs().getInvlst().size()>0)
			  {
			    invocr = true;
			  }
			  else
			  {
			    // 校验是否在发票核验中
			    MdaUtils.clear(this.getCpdgrp().getInvs().getInvchk());
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvchk(),new Argument<String>("ownref",ownref));
			    if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvchk().getInr()))
			    {
			      
			      
			      checkres = this.delRepeatInv(true);
			      if (!checkres)
			      {
			        ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000161"),MdaUtils.getI18NString("cpthyf","CT000162"));
			      }
			    }
			    else if (!"00".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			    {
			      Argument<String> inr =new Argument<String>("inr");
			      String querysql = "select inr from invsup where ownref='"+ownref+"' and state is null";
			      ctx.getDaoSession().dbExecuteSQL(querysql);
			      ctx.getDaoSession().dbFetchFields(inr);
			      ctx.getDaoSession().dbCloseCursor();
			      if (!MdaUtils.isEmpty(inr.value))
			      {
			        checkres = this.delRepeatInv(true);
			        if (!checkres)
			        {
			          ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000169"),MdaUtils.getI18NString("cpthyf","CT000170"));
			        }
			      }
			      // 控制核验完成后不再执行
			      
			      
			    }
			  }
			  this.getCptp().getInvl().qureyInvlst(ownref);
			  if (!invocr)
			  {
			    this.invInversion(ownref, invocr);
			  }
			}

			return true;
        }

        /**
        *   source:cpthyf.@0090.script
        */
        @Rule(target="cptp.invl.refdisplay",order=100)
        public boolean ruleCptpInvlRefdisplayN100(){
            IContext ctx = MdaEnv.getContext();
            
			int length = this.getCptp().getInvl().getInvlst().fullSize();
			if (length == 0)
			{
			  return true;
			}
			// 刷新多张发票反显信息
			StringBuffer invnos = new StringBuffer();
			if (!MdaUtils.isEmpty(this.getCptp().getInvl().getInvlst().getElement(0).getInvoicenumber()))
			{
			  // 发票号长度128最多6张发票拼接，拼接使用"/"
			  for(int i=0; i<length && i<6; i++)
			  {
			    if (MdaUtils.isEmpty(this.getCptp().getInvl().getInvlst().getElement(i).getInvoicenumber()))
			    {
			      continue;
			    }
			    if (i != 0)
			    {
			      invnos.append("/");
			    }
			    invnos.append(this.getCptp().getInvl().getInvlst().getElement(i).getInvoicenumber());
			  }
			  this.getCpdgrp().getRec().setInvno(invnos.toString());
			  
			}
			String ownref=this.getCpdgrp().getRec().getOwnref();
			Argument<BigDecimal> amtsum =new Argument<BigDecimal>("amtsum");
			String invsql="SELECT sum(gframt) amtsum FROM invsup WHERE ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(invsql);
			if (ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(amtsum);
			  this.getCpdgrp().getRec().setRemamt(new BigDecimal(String.valueOf(amtsum.value)));
			  
			}
			ctx.getDaoSession().dbCloseCursor();
			this.changeAmt();

			return true;
        }

        /**
        *   source:cpthyf.@0092.script
        */
        @Rule(target="cptp.invl.selall",order=100)
        public boolean ruleCptpInvlSelallN100(){
            IContext ctx = MdaEnv.getContext();
            
			boolean selall = true;
			log.debug("{}","selall");
			int cursize = this.getCptp().getInvl().getInvlst().size();
			int selidx = 0;
			int realidx = this.getCptp().getInvl().getInvlst().getRealIndex(selidx);
			int pages = this.getCptp().getInvl().getInvlst().getPage();
			int pagesize = this.getCptp().getInvl().getInvlst().getPageSize();
			int begin = pagesize * ( pages - 1 );
			int end = begin+cursize;
			for(int i=begin;i<end;i++)
			{
			  if(!"X".equals(this.getCptp().getInvl().getInvlst().getElement(i).getSelflg()))
			  {
			    selall=false;
			    this.getCptp().getInvl().getInvlst().getElement(i).setSelflg("X");
			  }
			}
			if(selall)
			{
			  for(int i=begin;i<end;i++)
			  {
			    this.getCptp().getInvl().getInvlst().getElement(i).setSelflg("");
			  }
			}
			

			return true;
        }


        /**
        *   source:cpthyf.@0009.script
        */
        @Check(target="cptp.cpdgrp.rec.pyecry",order=100)
        public boolean checkCptpCpdgrpRecPyecryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String pyecry = this.getCpdgrp().getRec().getPyecry();
			if (!MdaUtils.isEmpty(pyecry))
			{
			  String sql = "select alpcod from cty where alpcod = '" + pyecry +"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> alpcod = new Argument<String>("alpcod");
			  ctx.getDaoSession().dbFetchFields(alpcod);
			  int error = ctx.getErrorCode();
			  if(error != NO_ERROR)
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.pyecry",MdaUtils.getI18NString("cpthyf","CT000009"));
			    log.info("{}","error+++" + error);
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}


			return true;
        }

        /**
        *   source:cpthyf.@0012.script
        */
        @Check(target="cptp.cpdgrp.rec.puramt",order=100)
        public boolean checkCptpCpdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"puramt"));

			return true;
        }

        /**
        *   source:cpthyf.@0021.script
        */
        @Check(target="cptp.cpdgrp.rec.remamt",order=100)
        public boolean checkCptpCpdgrpRecRemamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"remamt"));
			this.changeAmt();

			return true;
        }

        /**
        *   source:cpthyf.@0024.script
        */
        @Check(target="cptp.cpdgrp.rec.fxamt",order=100)
        public boolean checkCptpCpdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if (!MdaUtils.isEmpty(this.getCptp().getCpdgrp().getRec().getFxamt()))
			{
			  this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"fxamt"));
			}

			return true;
        }

        /**
        *   source:cpthyf.@0052.script
        */
        @Check(target="cptp.cpdgrp.rec.bopinf1",order=100)
        public boolean checkCptpCpdgrpRecBopinf1N100(){
            IContext ctx = MdaEnv.getContext();
            
			String bopcod1 = this.getCpdgrp().getBopcod();
			String bopinf1 = this.getCpdgrp().getRec().getBopinf1();
			log.info("{}","交易附言校验："+bopcod1+";"+bopinf1);
			if (MdaUtils.isEmpty(bopcod1)||MdaUtils.isEmpty(bopinf1))
			{
			  return true;
			}

			//110 交易编码为“222011涉及我国出口的海洋货运服务”，但交易附言包含“进口/空运/陆运/佣金/货款/代理/客运/租（但不包含‘人员’）/速遣费/滞期费”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222011-")  && (Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-进口-空运-陆运-佣金-货款-代理-客运-速遣费-滞期费-") ||(!Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-人员-") && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-租-") )  ))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000126"));
			  //return false;
			}

			//111 交易编码为“222012涉及我国进口的海洋货运服务”，但交易附言包含“出口/空运/陆运/佣金/货款/代理/客运/租（但不包含‘人员’）/速遣费/滞期费”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222012-")  && (Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-出口-空运-陆运-佣金-货款-代理-客运-速遣费-滞期费-") ||(!Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-人员-") && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-租-"))   ))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000127"));
			  //return false;
			}

			//112 交易编码为“222013不涉及我国进出口的海洋货运服务”，但交易附言包含“空运/陆运/港口/仓储/装卸/搬运/引航/牵引/导航/检/修/使%费/客运”。
			//由于%不确定暂时先注释
			//    if (Platform.indexGt(bopcod1,"-222013-")  && Platform.containsValue(bopinf1,"-空运-陆运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-使%费-客运-"))
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222013-")  && (Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-空运-陆运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-客运-") || Platform.isALLChinese(this.insteadPercent(bopinf1,"使","费"))))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000128"));
			  //return false;
			}

			//113 交易编码为“222014海运客运”，但交易附言包含“空运/陆运/出口/进口”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222014-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-空运-陆运-出口-进口-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000129"));
			  //return false;
			}

			//114 交易编码为“222019其他海运服务”，但交易附言包含“其他/空运/陆运/速遣/清关/入渔/滞/运费/保险/修”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222019-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-空运-陆运-速遣-清关-入渔-滞-保险-修-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000130"));
			  //return false;
			}

			//115 交易编码为“222021涉及我国出口的空中货运服务”，但交易附言包含“进口/海运/陆运/佣金/货款/代理/客运/租”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222021-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-进口-海运-陆运-佣金-货款-代理-客运-租-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000131"));
			  //return false;
			}

			//116 交易编码为“222022涉及我国进口的空中货运服务”，但交易附言包含“出口/海运/陆运/佣金/货款/代理/客运/租”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222022-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-出口-海运-陆运-佣金-货款-代理-客运-租-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000132"));
			  //return false;
			}

			//117交易编码为“222023不涉及我国进出口的空中货运服务”，但交易附言包含“海运/陆运/港口/仓储/装卸/搬运/引航/牵引/导航/检/修/使%费/客运”。
			//由于%不确定暂时先注释
			// if (Platform.indexGt(bopcod1,"-222023-")  && Platform.containsValue(bopinf1,"-海运-陆运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-使%费-客运-"))
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222023-")  && (Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-海运-陆运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-客运-") || Platform.isALLChinese(this.insteadPercent(bopinf1,"使","费"))))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000133"));
			  //return false;
			}
			//118交易编码为“222024空运客运”，但交易附言包含“海运/陆运/出口/进口”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222024-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-海运-陆运-出口-进口-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000134"));
			  //return false;
			}
			//119交易编码为“222029其他空运服务”，但交易附言包含“海运/陆运/速遣/清关/滞/运费/保险/修”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222029-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-海运-陆运-速遣-清关-滞-保险-修-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000135"));
			  //return false;
			}
			//120交易编码为“222031涉及我国出口的其他运输方式货运服务”，但交易附言包含“进口/海运/空运/佣金/货款/代理/客运/租”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222031-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-进口-海运-空运-佣金-货款-代理-客运-租-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000136"));
			  //return false;
			}
			//121交易编码为“222032涉及我国进口的其他运输方式货运服务”，但交易附言包含“出口/海运/空运/佣金/货款/代理/客运/租”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222032-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-出口-海运-空运-佣金-货款-代理-客运-租-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000137"));
			  //return false;
			}

			//122交易编码为“222033不涉及我国进出口的其他运输方式货运服务”，但交易附言包含“海运/空运/港口/仓储/装卸/搬运/引航/牵引/导航/检/修/使%费/客运”。
			//由于%不确定暂时先注释
			//if (Platform.indexGt(bopcod1,"-222033-")  && Platform.containsValue(bopinf1,"-海运-空运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-使%费-客运-"))
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222033-")  && (Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-海运-空运-港口-仓储-装卸-搬运-引航-牵引-导航-检-修-客运-")  || Platform.isALLChinese(this.insteadPercent(bopinf1,"使","费"))))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000138"));
			  //return false;
			}
			//123交易编码为“222034其他运输方式客运”，但交易附言包含“海运/空运/出口/进口”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222034-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-海运-空运-出口-进口-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000139"));
			  //return false;
			}
			//124交易编码为“222039其他运输方式的其他服务”，但交易附言包含“空运/海运/速遣/入渔/滞/运费/保险/快递/修”。
			//   if (Platform.indexGt($cpdgrp\\bopcod,"-222039-")  && (!Platform.containsValue($cpdgrp\\rec\\bopinf1,"-运费-") || Platform.containsValue($cpdgrp\\rec\\bopinf1,"-空运-海运-速遣-入渔-滞-运费-保险-快递-修-")))
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222039-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-空运-海运-速遣-入渔-滞-运费-保险-快递-修-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000140"));
			  //return false;
			}
			//125交易编码为“222040邮政及寄递服务”，但交易附言包含“电信/电子/通讯/通信”。
			if (Platform.indexGt(MdaDriver.getDatafield(this.getCpdgrp(),"bopcod"),"-222040-")  && Platform.containsValue(MdaDriver.getDatafield(this.getCpdgrp().getRec(),"bopinf1"),"-电信-电子-通讯-通信-"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopinf1",MdaUtils.getI18NString("cpthyf","CT000141"));
			  //return false;
			}
			log.info("{}","交易附言校验结束");

			return true;
        }

        /**
        *   source:cpthyf.@0054.script
        */
        @Check(target="cptp.rcpp.ptspta.pts.adrblk",order=100)
        public boolean checkCptpRcppPtsptaPtsAdrblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getCpdgrp().getRcp().getPts(),"adrblk"),140);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getRcpp().getPtspta().getPts(),"adrblk"));

			return true;
        }

        /**
        *   source:cpthyf.@0055.script
        */
        @Check(target="cptp.acwp.ptspta.pts.adr",order=100)
        public boolean checkCptpAcwpPtsptaPtsAdrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getCptp().getAcwp().getPtspta().getPts(),"adrblk"),100);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getAcwp().getPtspta().getPts(),"adr"));

			return true;
        }

        /**
        *   source:cpthyf.@0057.script
        */
        @Check(target="cptp.cpdgrp.rec.bopamt1",order=100)
        public boolean checkCptpCpdgrpRecBopamt1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if (!MdaUtils.isEmpty(this.getCptp().getCpdgrp().getRec().getBopamt1()))
			{
			  this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"bopamt1"));
			}

			return true;
        }

        /**
        *   source:cpthyf.@0069.script
        */
        @Check(target="cptp.aplp.ptspta.pts.nam",order=100)
        public boolean checkCptpAplpPtsptaPtsNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.checkMaxLength(MdaDriver.getDatafield(this.getCptp().getAplp().getPtspta().getPts(),"nam"),60);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getAplp().getPtspta().getPts(),"nam"));

			return true;
        }

        /**
        *   source:cpthyf.@0071.script
        */
        @Check(target="cptp.aplp.ptspta.pts.adr",order=100)
        public boolean checkCptpAplpPtsptaPtsAdrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.checkMaxLength(MdaDriver.getDatafield(this.getCptp().getAplp().getPtspta().getPts(),"adr"),70);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getAplp().getPtspta().getPts(),"adr"));

			return true;
        }

        /**
        *   source:cpthyf.@0072.script
        */
        @Check(target="cptp.benp.ptspta.pts.nam",order=100)
        public boolean checkCptpBenpPtsptaPtsNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.checkMaxLength(MdaDriver.getDatafield(this.getCptp().getBenp().getPtspta().getPts(),"nam"),60);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getBenp().getPtspta().getPts(),"nam"));

			return true;
        }

        /**
        *   source:cpthyf.@0073.script
        */
        @Check(target="cptp.benp.ptspta.pts.adr",order=100)
        public boolean checkCptpBenpPtsptaPtsAdrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.checkMaxLength(MdaDriver.getDatafield(this.getCptp().getBenp().getPtspta().getPts(),"adr"),70);
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getBenp().getPtspta().getPts(),"adr"));

			return true;
        }

        /**
        *   source:cpthyf.@0074.script
        */
        @Check(target="cptp.acwp.ptspta.pts.nam",order=100)
        public boolean checkCptpAcwpPtsptaPtsNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.namadrCheck(MdaDriver.getDatafield(this.getCptp().getAcwp().getPtspta().getPts(),"nam"));

			return true;
        }

        /**
        *   source:cpthyf.@0087.script
        */
        @Check(target="cptp.invl.invdet.purchasertaxno",order=100)
        public boolean checkCptpInvlInvdetPurchasertaxnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			String taxno = this.getCptp().getInvl().getInvdet().getPurchasertaxno();
			if (!MdaUtils.isEmpty(taxno) && taxno.length() != 18)
			{
			  ctx.setFieldError(this,"cptp.invl.invdet.purchasertaxno","长度需为18位");
			}

			return true;
        }


        /**
        *   source:cpthyf.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String chkresult = this.getParmod().hyfTimeControl();
			if (!MdaUtils.isEmpty(chkresult))
			{
			  ctx.setMessage("提示",chkresult+"允许申请，当前时间不能进行申请");
			  
			  return true;
			}
			if(!Platform.isFromApp())
			{
			  this.showReadTet();
			}
			log.debug("{}","init cpthyf ="+this.getCpdgrp().getRec().getRemcur());
			//归属机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			
			// 费用承担方默认为OUR
			this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			
			
			// 是否保税货物默认否不可修改
			this.getCpdgrp().getRec().setCavpayflg("N");
			
			
			String conno = this.getCpdgrp().getRec().getConno();
			// 合同号
			if ("N/A".equals(conno))
			{
			  this.getCpdgrp().getRec().setConno("");
			  
			}
			// 设置付汇性质码表
			MdaUtils.setValues(this.getCpdgrp().getRec(),"paytyptxt",MdaUtils.getCodetable("hyfpaytyptxt"));
			//ord
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			IModule rec = (IModule)ctx.restoreData("com.brilliance.cpthyf.rec");
			if(!MdaUtils.isEmpty(rec))
			{
			  this.getCpdgrp().getRec().copyValue(rec);
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getFxflg());
			    this.getCpdgrp().getRec().setFxflg("X");

			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getPurflg());
			    this.getCpdgrp().getRec().setPurflg("X");
			  }

			  String cur=this.getCpdgrp().getRec().getRemcur();
			  this.getCptp().setCur1(cur);
			  this.getCptp().setCur(cur);
			  this.getCpdgrp().getRec().setBopcur1(cur);
			  this.getCpdgrp().setBopcod(this.getCpdgrp().getRec().getBopcod1());
			}

			IModule apl = (IModule)ctx.restoreData("com.brilliance.cpthyf.apl");
			if(!MdaUtils.isEmpty(apl))
			  this.getCpdgrp().getApl().getPts().copyValue(apl);

			IModule ben = (IModule)ctx.restoreData("com.brilliance.cpthyf.ben");
			if(!MdaUtils.isEmpty(ben))
			{
			  this.getCpdgrp().getBen().getPts().copyValue(ben);
			  this.getCpdgrp().getRec().setPyeact(this.getCpdgrp().getBen().getPts().getAct());
			}

			IModule acw = (IModule)ctx.restoreData("com.brilliance.cpthyf.acw");
			if(!MdaUtils.isEmpty(acw))
			{
			  this.getCpdgrp().getAcw().getPts().copyValue(acw);
			  if (MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getNam())||MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getAdr()))
			  {
			    this.getCptp().getAcwp().setExtkey(this.getCpdgrp().getAcw().getPts().getExtkey());
			    
			    this.getCptp().getAcwp().refreshAcw("init");
			  }
			}
			String tmpHydataNo = (String)ctx.restoreData("com.brilliance.tmpHydataNo");
			//log.debug("=================tmpHydataNo"+tmpHydataNo);
			
			IModule cpd = (IModule)ctx.restoreData("com.brilliance.cpthyf.ref");
			if(!MdaUtils.isEmpty(cpd))
			{
			  this.getCpdgrp().getRec().copyValue(cpd);
			  String trninr=(String)ctx.restoreData("com.brilliance.inr.ref");
			  this.getTrnmod().setTrninr(trninr);
			  log.debug("{}","trninr  is   :"+this.getTrnmod().getTrninr());
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getFxflg());
			    this.getCpdgrp().getRec().setFxflg("X");

			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getPurflg());
			    this.getCpdgrp().getRec().setPurflg("X");
			  }

			  this.getCptp().setCptlab("单笔业务申请");
			  String cur=this.getCpdgrp().getRec().getRemcur();
			  this.getCptp().setCur1(cur);
			  this.getCptp().setCur(cur);
			  this.getCpdgrp().getRec().setBopcur1(cur);
			  this.getCpdgrp().getRec().setRmttyp("0");

			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getTransid()))
			  {
			    this.getCpdgrp().getRec().setTransid(this.getCpdgrp().getRec().getOwnref());
			    
			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt())&&!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			  {
			    String amt = this.getSysmod().covCnAmt(this.getCpdgrp().getRec().getRemamt(),this.getCpdgrp().getRec().getRemcur());
			    this.getCpdgrp().getRec().setWord(amt);
			  }
			  return true;
			}
			
			
			
			
			
			
			this.getCptp().setCptlab("单笔业务申请");

			//汇款方式默认为电汇，不允许修改
			
			
			
			this.getCpdgrp().getRec().setCavpayflg("N");
			
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P") || ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //使用退回功能时判断
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }

			  //log.debug("$cpdgrp\\rec\\remcur.getValue()="+$cpdgrp\\rec\\remcur.getValue());
			  if((ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P"))&& !MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			  {
			    //log.debug("B/P 状态下的remcur "+$cpdgrp\\rec\\remcur.getValue());
			    this.getCptp().setCur(this.getCpdgrp().getRec().getRemcur());
			    this.getCptp().setCur1(this.getCpdgrp().getRec().getRemcur());
			    
			    
			    ctx.postRule(this,"cpdgrp.rec.remcur");
			    ctx.postRule(this,"cptp.cpdgrp.rec.fxflg");
			    ctx.postRule(this,"cptp.cpdgrp.rec.purflg");
			  }

			  if( !MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopamt1()))
			  {
			    BigDecimal amt1 = this.getCpdgrp().getRec().getBopamt1();
			    amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			    this.getCpdgrp().getRec().setBopamt1(amt1);
			    
			  }

			  // 查询发票列表数据
			  this.getCptp().setTopub("√");
			  this.getCptp().getInvl().qureyInvlst(this.getCpdgrp().getRec().getOwnref());
			  return true;
			}
			//初始化汇款方式限制
			if(!Platform.isFromApp())
			{
			  if(!"D".equals(this.getCpdgrp().getRec().getCpdres()))
			    this.getCpdgrp().getRec().setFxflg("X");
			}
			// 生成业务编号
			String hyOwnref = getOwnRef();
			if(!MdaUtils.isEmpty(tmpHydataNo))
			{
			  // 从cpthyc跳转带来的数据判断是否是第一次进入cpthyf，是：页面显示新的业务编号，spt表临时数据添加业务编号 ；否：页面显示spt表保存的业务编号
			  this.getSysmod().setTmpdata(tmpHydataNo);
			  String selSql = "select imgref from spt where inr = '"+ tmpHydataNo +"'";
			  Argument<String> imgref = new Argument<String>("imgref"); //临时数据，临时用imgref存
			  ctx.getDaoSession().dbExecuteSQL(selSql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(imgref);
			    if(ctx.getErrorCode() != NO_ERROR)
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();

			  ctx.getDaoSession().dbBegin();
			  log.debug("{}","===========hyOwnref"+imgref.getValue());
			  if(MdaUtils.isEmpty(imgref.getValue()))
			  {
			    this.getCpdgrp().getRec().setOwnref(hyOwnref);
			    
			    MdaUtils.clear(this.getCpdgrp().getSpt());
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getSpt(),new Argument("inr", tmpHydataNo));
			    //log.debug("==========inr"+$cpdgrp\\spt\\inr.getValue());
			    this.getCpdgrp().getSpt().setImgref(hyOwnref);
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getSpt());
			    if(ctx.getErrorCode() == NO_ERROR)
			      ctx.getDaoSession().dbCommit();
			    else
			      ctx.getDaoSession().dbRollback();
			  }
			  else
			  {
			    this.getCpdgrp().getRec().setOwnref(imgref.getValue());
			    
			  }

			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getOwnref()))
			{
			  this.getCpdgrp().getRec().setOwnref(hyOwnref);
			  
			}
			log.info("{}","sysmod-pty-init2:"+this.getSysmod().getPty().getCid());
			// 初始化发票列表
			this.getCptp().getInvl().qureyInvlst(this.getCpdgrp().getRec().getOwnref());
			ctx.postRule(this,"cptp.cpdgrp.rec.fxflg");
			ctx.postRule(this,"cptp.cpdgrp.rec.purflg");
			this.getCpdgrp().getRec().setAtccod(this.getSysmod().getPty().getAtccod());
			
			
			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			
			
			log.debug("{}","初始化直接申请人pts========");
			this.getCpdgrp().getDap().initDap("cpd");
			if(MdaUtils.isEmpty(this.getCpdgrp().getApl().getPts().getNam()))
			{
			  this.getCpdgrp().getApl().copyValues(this.getCpdgrp().getDap());
			}
			this.getCpdgrp().getApl().getPts().setRol("apl");
			this.getCpdgrp().getRec().setRmttyp("0");
			this.getCpdgrp().setWtranfer("√");
			this.getCpdgrp().getRec().setInoutflg("in");
			this.getCpdgrp().getRec().setPriority("Normal");
			if(!MdaUtils.isEmpty(this.getSysmod().getPty().getActtyp()))
			  this.getCptp().setActtyp(this.getSysmod().getPty().getActtyp());
			else
			  this.getCptp().setActtyp("1");
			
			
			//disable常用账户选择按钮
			
			this.getCpdgrp().setCtydes(NULLSTR);
			this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			log.debug("{}","aplnam==="+this.getCpdgrp().getAplnam());
			this.getCpdgrp().setApltel(this.getCpdgrp().getDap().getAdr().getTel());
			
			

			this.getCpdgrp().setOprnam(this.getSysmod().getUsr().getOprnam());
			

			// 汇款人类型默认对公
			this.getCptp().setTopub("√");
			// 付款类型默认其他
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getPaytyp()))
			  this.getCpdgrp().getRec().setPaytyp("Others");
			// 付汇性质默认空
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getPaytyptxt()))
			{
			  this.getCpdgrp().getRec().setPaytyptxt(NULLSTR);
			  
			}
			if(!Platform.isFromApp())
			{
			  MdaUtils.clear(this.getCpdgrp().getCtylst());
			  String sql = "SELECT * FROM cty ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> cod = new Argument<String>("cod");
			  Argument<String> alpcod = new Argument<String>("alpcod");
			  Argument<String> numcod = new Argument<String>("numcod");
			  Argument<String> chnnam = new Argument<String>("chnnam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  int i=0;
			  while(true)
			  {
			    i++;
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  log.debug("{}","ctylst.size = "+ this.getCpdgrp().getCtylst().size());
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			ctx.postRule(this,"cpdgrp.rec.remcur");
			
			int lstsize = this.getCptp().getInvl().getInvlst().fullSize();
			if (lstsize==0)
			{
			  
			  
			}

			return true;
        }


        /**
        *   source:cpthyf.@0002.script
        */
        public void showReadTet()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//外汇按金交易风险提示函
			String readtxt1=" 外汇按金交易风险提示函";
			readtxt1=readtxt1+CR;
			readtxt1=readtxt1+CR+"目前通过网络平台开展外汇按金交易未经批准；境内";
			readtxt1=readtxt1+CR+"个人跨境境外购房、直接进行跨境证券投资，相关外";
			readtxt1=readtxt1+CR+"汇业务属于资本项目项下业务，按照可兑换进程管理";
			readtxt1=readtxt1+CR+"，目前尚未明确开放。直接或间接开展、参与上述相";
			readtxt1=readtxt1+CR+"关外汇业务，涉嫌违规。请提高风险防范意识，谨防";
			readtxt1=readtxt1+CR+"财产损失。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"特此公告。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"中国光大银行";
			readtxt1=readtxt1+CR+"2019年3月27日";

			ctx.setMessage(MdaUtils.getI18NString("cpthyf","CT000001"),readtxt1);

		}
        /**
        *   source:cpthyf.@0003.script
        */
        public String getOwnRef()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getMtabut().getRec(),"ownref");
			log.debug("{}","***ownref****"+ownref);
			String prefix = "";
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  prefix = this.getMtabut().getPrefix() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getMtabut().getPrefix()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");

			}
			return prefix;
		}
        /**
        *   source:cpthyf.@0019.script
        */
        public void checkSumAmt(Boolean fxflg,Boolean purflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","cpthyf.remamtCheck start:");
			if(fxflg || purflg)
			{
			  BigDecimal sumamt = new BigDecimal("0");

			  if(fxflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getFxamt());
			    log.debug("{}","fxamt:" + this.getCpdgrp().getRec().getFxamt());
			    log.debug("{}","sumamt(fxamt):" + sumamt);
			  }
			  if(purflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getPuramt());
			    log.debug("{}","puramt:" + this.getCpdgrp().getRec().getPuramt());
			    log.debug("{}","sumamt(puramt):" + sumamt);
			  }
			  log.debug("{}","remamt:" + this.getCpdgrp().getRec().getRemamt());
			  log.debug("{}","sumamt:" + sumamt);

			  if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getCpdgrp().getRec().getRemamt()).compareTo(sumamt)!=0)
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.remamt",MdaUtils.getI18NString("cpthyf","CT000071"));
			  }
			}
			log.debug("{}","cpthyf.remamtCheck end!");
		}
        /**
        *   source:cpthyf.@0020.script
        */
        public void checkAndSetAmt2(BigDecimal amt ,String amtname1,String amtname2)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal remamt = this.getCpdgrp().getRec().getRemamt();
			BigDecimal setamt = remamt.subtract(amt);
			setamt = MdaUtils.parseDecimal(MdaUtils.format(setamt,"#0.00"));
			if(remamt.compareTo(amt) < 0)
			{
			  if("fxamt".equals(amtname1))
			    ctx.setFieldError(this,"cpdgrp.rec.fxamt",MdaUtils.getI18NString("cpthyf","CT000072"));
			  else if("puramt".equals(amtname1))
			    ctx.setFieldError(this,"cpdgrp.rec.puramt",MdaUtils.getI18NString("cpthyf","CT000073"));
			}
			else
			{
			  if("fxamt".equals(amtname2))
			    this.getCpdgrp().getRec().setFxamt(setamt);
			  else if("puramt".equals(amtname2))
			    this.getCpdgrp().getRec().setPuramt(setamt);
			}
		}
        /**
        *   source:cpthyf.@0030.script
        */
        public void saveSingleInv(String filetype,String filenam,String ownref,String alsnam,int tblcnt,String imgref,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String tblcnts = "" + tblcnt;
			// 保存影像表
			log.info("{}","保存影像表1："+filenam+":"+alsnam);
			String lognam=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getLgnnam();

			this.getSysmod().getItfmod().getImgmod().insertTblbil(alsnam, filenam, ownref, imgref, ctx.getTransName(), lognam, objtyp, tblcnt);
			log.info("{}","保存发票表："+filenam+":"+alsnam);

			// 保存发票表
			MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			this.getCpdgrp().getInvs().getInv().setInr(String.valueOf(ctx.getDaoSession().dbCounter("inv")));
			this.getCpdgrp().getInvs().getInv().setOwnref(ownref);
			this.getCpdgrp().getInvs().getInv().setTblbilinr(tblcnt);
			this.getCpdgrp().getInvs().getInv().setOcrres("0");
			this.getCpdgrp().getInvs().getInv().setAlsnam(filenam + "." + filetype);
			ctx.getDaoSession().dbInsert(this.getCpdgrp().getInvs().getInv());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","保存数据失败");
			  ctx.getDaoSession().dbRollback();
			}
		}
        /**
        *   source:cpthyf.@0031.script
        */
        public boolean invCheckList(String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 校验是否在发票核验中
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvchk());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvchk(),new Argument<String>("ownref",ownref));
			if ("00".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			{
			  ctx.setMessage("提示","发票核验中，请稍后重试");
			  return false;
			}

			// 校验发票必须上传
			Argument<Integer> invnum =new Argument<Integer>("invnum");
			String invsql="SELECT count(*) invnum FROM inv WHERE ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(invsql);
			log.info("{}","校验发票必须上传："+ctx.getErrorCode());
			if (ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(invnum);
			  ctx.getDaoSession().dbCloseCursor();
			  if (invnum.value==0)
			  {
			    ctx.setMessage("提示","请先上传发票");
			    return false;
			  }
			}
			else
			{
			  ctx.setMessage("提示","查询数据失败");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			int fullsize = this.getCptp().getInvl().getInvlst().fullSize();
			if (fullsize>255)
			{
			  ctx.setMessage("提示","最多允许255张发票已经超过限制，请删除多余发票");
			  return false;
			}
			if (!this.delRepeatInv(true))
			{
			  ctx.setMessage("提示","发票重复上传，请确认");
			  return false;
			}
			// 校验是否有未识别的发票
			ctx.getDaoSession().dbReadset(this.getCpdgrp().getInvs().getInvlst(),new Argument<String>("ownref",ownref));
			log.info("{}","校验是否有未识别的发票："+ctx.getErrorCode());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","查询数据失败");
			  return false;
			}
			Boolean checkresult = false;
			ctx.getDaoSession().dbBegin();
			for(int i=0; i<this.getCpdgrp().getInvs().getInvlst().size(); i++)
			{
			  log.info("{}","发票状态是否正常："+this.getCpdgrp().getInvs().getInvlst().getElement(i).getInr());
			  // 发票状态是否正常
			  if (!"1".equals(this.getCpdgrp().getInvs().getInvlst().getElement(i).getOcrres()))
			  {
			    MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			    //$cpdgrp\\invs\\inv.copyValue($cpdgrp\\invs\\invlst.get(i));
			    this.getCpdgrp().getInvs().getInv().setInr(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInr());
			    this.getCpdgrp().getInvs().getInv().setOwnref(ownref);
			    this.getCpdgrp().getInvs().getInv().setOcrres(this.getCpdgrp().getInvs().getInvlst().getElement(i).getOcrres());
			    this.getCpdgrp().getInvs().getInv().setAlsnam(this.getCpdgrp().getInvs().getInvlst().getElement(i).getAlsnam());
			    this.getCpdgrp().getInvs().getInv().setTblbilinr(this.getCpdgrp().getInvs().getInvlst().getElement(i).getTblbilinr());
			    this.getCpdgrp().getInvs().getInv().setInvoicecode(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode());
			    this.getCpdgrp().getInvs().getInv().setInvoicenumber(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber());
			    this.getCpdgrp().getInvs().getInv().setCheckcode(this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode());
			    this.getCpdgrp().getInvs().getInv().setBillingdate(this.getCpdgrp().getInvs().getInvlst().getElement(i).getBillingdate());
			    this.getCpdgrp().getInvs().getInv().setInvamt(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvamt());
			    this.getCpdgrp().getInvs().getInv().setCheckresult("发票未识别");
			    this.getCptp().getInvl().getInvlst().getElement(i).setCheckresult("发票未识别");
			    
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      ctx.setMessage("提示","更新发票数据失败");
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			    checkresult=true;
			    continue;
			  }
			  if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode())
			    ||MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber())
			  ||MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode())
			  ||MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getBillingdate()))
			  {
			    MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			    this.getCpdgrp().getInvs().getInv().copyValue(this.getCpdgrp().getInvs().getInvlst().get(i));
			    this.getCpdgrp().getInvs().getInv().setInr(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInr());
			    this.getCpdgrp().getInvs().getInv().setOwnref(ownref);
			    this.getCpdgrp().getInvs().getInv().setAlsnam(this.getCpdgrp().getInvs().getInvlst().getElement(i).getAlsnam());
			    this.getCpdgrp().getInvs().getInv().setOcrres(this.getCpdgrp().getInvs().getInvlst().getElement(i).getOcrres());
			    this.getCpdgrp().getInvs().getInv().setTblbilinr(this.getCpdgrp().getInvs().getInvlst().getElement(i).getTblbilinr());
			    this.getCpdgrp().getInvs().getInv().setInvoicecode(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode());
			    this.getCpdgrp().getInvs().getInv().setInvoicenumber(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber());
			    this.getCpdgrp().getInvs().getInv().setCheckcode(this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode());
			    this.getCpdgrp().getInvs().getInv().setBillingdate(this.getCpdgrp().getInvs().getInvlst().getElement(i).getBillingdate());
			    this.getCpdgrp().getInvs().getInv().setInvamt(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvamt());
			    this.getCpdgrp().getInvs().getInv().setCheckresult("发票号码、发票代码、开票日期、校验码后六位不能为空");
			    this.getCptp().getInvl().getInvlst().getElement(i).setCheckresult("发票号码、发票代码、开票日期、校验码后六位不能为空");
			    
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      ctx.setMessage("提示","更新发票数据失败");
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			    checkresult=true;
			  }
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","更新发票数据失败");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			if (checkresult)
			{
			  ctx.setMessage("提示","发票未识别或发票信息异常，请检查发票列表");
			  return false;
			}
			return true;
		}
        /**
        *   source:cpthyf.@0045.script
        */
        public boolean delinv(String inr,String opttype,String filetype,String filenam,String ownref,String alsnam,int tblcnt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// opttype:1删除发票 2替换发票
			MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument<String>("inr",inr));
			int tblbilinr=this.getCpdgrp().getInvs().getInv().getTblbilinr();

			ctx.getDaoSession().dbBegin();
			// 删除发票
			ctx.getDaoSession().dbDelete(this.getCpdgrp().getInvs().getInvsup(),new Argument<String>("invinr",inr));
			log.info("{}","删除发票信息："+ctx.getErrorCode());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","删除数据失败");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getDaoSession().dbDelete(this.getCpdgrp().getInvs().getInv(),new Argument<String>("inr",inr));
			log.info("{}","删除发票信息："+ctx.getErrorCode());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage("提示","删除数据失败");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getDaoSession().dbCommit();
			MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInv(),new Argument<Integer>("tblbilinr",tblbilinr));
			// 多张发票多删除再删除影像表
			if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInv().getInr()))
			{
			  // 删除影像
			  ctx.getDaoSession().dbExecuteSQL("delete from tblbil where inr="+tblbilinr);
			  ctx.getDaoSession().dbCloseCursor();
			  log.info("{}","删除发票信息："+ctx.getErrorCode());
			  if(ctx.getErrorCode()==NO_ERROR)
			    log.debug("{}","删除影像数据成功");
			  else
			  {
			    ctx.setMessage("提示","删除影像数据失败");
			    return false;
			  }
			}
			this.getCptp().getInvl().qureyInvlst(this.getCpdgrp().getRec().getOwnref());
			return true;
		}
        /**
        *   source:cpthyf.@0048.script
        */
        public boolean invlstBtnContol()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ownref=this.getCpdgrp().getRec().getOwnref();
			// 校验是否在发票核验中
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvchk());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvchk(),new Argument<String>("ownref",ownref));
			if ("00".equals(this.getCpdgrp().getInvs().getInvchk().getResult()))
			{
			  ctx.setMessage("提示","发票核验中，不能操作按钮");
			  return false;
			}
			return true;
		}
        /**
        *   source:cpthyf.@0049.script
        */
        public String saveImg(String ownref,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String imgref = this.getMtabut().getImgtp().getDztimgref();
			if(MdaUtils.isEmpty(imgref))
			{
			  imgref = this.getMtabut().getImgtp().getImageReference();
			  this.getTrnmod().getItfmod().getImgmod().setImgref(imgref);
			  
			  this.getTrnmod().getItfmod().getImgmod().setOwnref(ownref);
			  
			}
			String uuidtoken = UUID.randomUUID().toString().replace("-", "").toUpperCase();
			ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument("imgref",imgref ),new Argument("ownref",ownref));
			if(MdaUtils.isEmpty(this.getTrnmod().getItfmod().getImgmod().getImg().getInr()))
			{
			  this.getTrnmod().getItfmod().getImgmod().getImg().setOwnref( ownref);
			  this.getTrnmod().getItfmod().getImgmod().getImg().setImgref( imgref);
			  this.getTrnmod().getItfmod().getImgmod().getImg().setCredat( MdaUtils.today());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setInifrm( ctx.getTransName());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setLgnnam( ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getLgnnam());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setCnt(1);
			  this.getTrnmod().getItfmod().getImgmod().getImg().setOptdattim( MdaUtils.today());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setObjtyp( objtyp);
			  this.getTrnmod().getItfmod().getImgmod().getImg().setFtysuc("Z00238");
			  this.getTrnmod().getItfmod().getImgmod().getImg().setTrninr(this.getTrnmod().getTrn().getInr());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setObjinr(this.getTrnmod().getTrn().getObjinr());
			  this.getTrnmod().getItfmod().getImgmod().getImg().setGuid(uuidtoken);
			  this.getTrnmod().getItfmod().getImgmod().getImg().setInr(MdaUtils.format(ctx.getDaoSession().dbCounter("img"),"00000000"));
			  ctx.getDaoSession().dbInsert(this.getTrnmod().getItfmod().getImgmod().getImg());
			  log.debug("{}","保存影像操作记录成功，img.inr="+this.getTrnmod().getItfmod().getImgmod().getImg().getInr() +",img.ownref="+ ownref+",img.imgref="+imgref+ctx.getErrorCode());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    ctx.setMessage("提示","保存数据失败");
			    ctx.getDaoSession().dbRollback();
			  }
			}
			return imgref;
		}
        /**
        *   source:cpthyf.@0051.script
        */
        public void setAdrblk()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 设置汇款人名址
			String apladrblk = "";
			String apladr = this.getCpdgrp().getApl().getPts().getAdr();
			String aplname = this.getCpdgrp().getApl().getPts().getNam();
			if(!MdaUtils.isEmpty(apladr) && !MdaUtils.isEmpty(aplname))
			{
			  apladrblk = aplname + CR + apladr;
			}
			else if(MdaUtils.isEmpty(apladr) && !MdaUtils.isEmpty(aplname))
			{
			  apladrblk = aplname;
			}
			else
			{
			  apladrblk = apladr ;
			}
			log.info("{}","设置汇款人名址："+aplname+"="+apladr+"="+apladrblk);
			if(!MdaUtils.isEmpty(apladrblk))
			{
			  this.getCpdgrp().getApl().getPts().setAdrblk(apladrblk);
			  
			}
			log.info("{}","设置汇款人名址："+this.getCpdgrp().getApl().getPts().getAdrblk());
			// 设置收款人名址
			String benadrblk = "";
			String benadr = this.getCpdgrp().getBen().getPts().getAdr();
			String benname = this.getCpdgrp().getBen().getPts().getNam();
			if(!MdaUtils.isEmpty(benadr) && !MdaUtils.isEmpty(benname))
			{
			  benadrblk = benname + CR + benadr;
			}
			else if(MdaUtils.isEmpty(benadr) && !MdaUtils.isEmpty(benname))
			{
			  benadrblk = benname;
			}
			else
			{
			  benadrblk = benadr ;
			}
			if(!MdaUtils.isEmpty(benadrblk))
			{
			  this.getCpdgrp().getBen().getPts().setAdrblk(benadrblk);
			  
			}
			// 设置收款人开户行名址
			String bakadrblk = "";
			String bakadr = this.getCptp().getAcwp().getPtspta().getPts().getAdr();
			String bakname = this.getCptp().getAcwp().getPtspta().getPts().getNam();
			if(!MdaUtils.isEmpty(bakadr) && !MdaUtils.isEmpty(bakname))
			{
			  bakadrblk = bakname + CR + bakadr;
			}
			else if(MdaUtils.isEmpty(bakadr) && !MdaUtils.isEmpty(bakname))
			{
			  bakadrblk = bakname;
			}
			else
			{
			  bakadrblk = bakadr ;
			}
			if(!MdaUtils.isEmpty(bakadrblk))
			{
			  this.getCpdgrp().getAcw().getPts().setAdrblk(bakadrblk);
			  
			}
			this.getCpdgrp().getRec().setBopcod1(this.getCpdgrp().getBopcod());
			
			// 金额大写
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()) && !MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			{
			  String amt = this.getSysmod().covCnAmt(this.getCpdgrp().getRec().getRemamt(),this.getCpdgrp().getRec().getRemcur());
			  this.getCpdgrp().getRec().setWord(amt);
			  
			}
		}
        /**
        *   source:cpthyf.@0053.script
        */
        public String insteadPercent(String start , String first, String last)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String bb = "";
			int  shi = start.indexOf(first);
			int fei = start.indexOf(last);
			int length = first.length();
			if (shi >= 0 && fei >= 0 && fei - shi > length)
			{
			  shi = shi + length;
			  bb  = start.substring(shi, fei);

			}
			return bb;
		}
        /**
        *   source:cpthyf.@0061.script
        */
        public void changeAmt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean fxflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg());
			log.debug("{}","fxflg:" + fxflg + ",purflg:" + purflg);
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()) && (fxflg || purflg))
			{
			  //选中其中一个
			  BigDecimal remamt = this.getCpdgrp().getRec().getRemamt();
			  if(fxflg && !purflg)
			  {
			    this.getCpdgrp().getRec().setFxamt(remamt);
			    
			  }
			  if(!fxflg && purflg)
			  {
			    this.getCpdgrp().getRec().setPuramt(remamt);
			    
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			      ctx.postRule(this,"cptp.cpdgrp.rec.puramt");  //触发购汇金额变动事件
			  }

			  //选中其中两个
			  if(fxflg && purflg)
			  {
			    
			    
			    if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()) && !MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			      checkAndSetAmt2(this.getCpdgrp().getRec().getPuramt(),"puramt","fxamt");
			    else if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()) && MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			      checkAndSetAmt2(this.getCpdgrp().getRec().getFxamt(),"fxamt","puramt");
			  }

			  
			  
			  

			  checkSumAmt(fxflg,purflg);
			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()))
			{
			  BigDecimal remamt = this.getCpdgrp().getRec().getRemamt();
			  this.getCpdgrp().getRec().setBopamt1(remamt);
			  
			}
		}
        /**
        *   source:cpthyf.@0070.script
        */
        public void namadrCheck(IDatafield<String> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String content = field.getValue();
			if(!MdaUtils.isEmpty(content))
			{
			  if (Platform.containsValue(field,"-'-`-~-!-@-#-\u0024-%-^-&-*-_-=-+-[-]-{-}-\\-;-'-:-<->-?-/-,-.-"))
			  {
			    ctx.setFieldError(field,"不能包含有除（），。、之外的标点符号");
			  }
			  if (content.contains("-"))
			  {
			    ctx.setFieldError(field,"不能包含有除（），。、之外的标点符号");
			  }
			}
		}
        /**
        *   source:cpthyf.@0077.script
        */
        public void saveBengrp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 收款人名称重复不保存
			String bennam = this.getCpdgrp().getBen().getPts().getNam();
			String ptyinr = this.getSysmod().getPty().getInr();
			String selClause = "SELECT b.inr FROM pty b,ptr d WHERE b.ptytyp = '4' AND b.nam='"+bennam+"'AND b.inr = d.preptyinr AND d.nxtptyinr='"+ptyinr+"'";
			ctx.getDaoSession().dbExecuteSQL(selClause);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorCode = ctx.getErrorCode();
			if(errorCode!=NO_MORE_ROW)
			{
			  log.info("{}","收款人名称重复======");
			  ctx.getDaoSession().dbCloseCursor();
			  return;
			}
			ctx.getDaoSession().dbCloseCursor();
			//Platform.dbRead($bengrp\\pty,new Argument("nam",bennam),new Argument("ptytyp","4"),new Argument("status","0"));
			//if (!Platform.isEmpty($bengrp\\pty\\inr.getValue()))
			//{
			//  log.info("收款人名称重复======");
			//  return;
			//}
			//保存收款人
			//pty
			this.getBengrp().getPty().setInr(NULLSTR);
			this.getBengrp().getPty().setInr(Platform.sdbCounter("pty"));
			this.getBengrp().getPty().setNam(bennam);
			//$bengrp\\pty\\cid.setValue($bengrp\\pty\\extkey.getValue());
			//$bengrp\\pty\\ncid.setValue($bengrp\\pty\\extkey.getValue());
			this.getBengrp().getPty().setPtytyp("4");
			this.getBengrp().getPty().setStatus("0");
			ctx.getDaoSession().dbInsert(this.getBengrp().getPty());
			ctx.getErrorCode();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","保存收款人数据失败！");
			  return;
			}
			//adr
			this.getBengrp().getAdr().setInr(Platform.sdbCounter("adr"));
			this.getBengrp().getAdr().setAdr(this.getCpdgrp().getBen().getPts().getAdr());
			ctx.getDaoSession().dbInsert(this.getBengrp().getAdr());
			ctx.getErrorCode();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","保存收款人数据失败！");
			  return;
			}
			//pta
			this.getBengrp().getPta().setInr(Platform.sdbCounter("pta"));
			this.getBengrp().getPta().setNam(this.getBengrp().getPty().getEngnam());
			this.getBengrp().getPta().setObjinr(this.getBengrp().getAdr().getInr());
			//$bengrp\\pta\\objkey.setValue($bengrp\\adr\\extkey.getValue());
			this.getBengrp().getPta().setPtyinr(this.getBengrp().getPty().getInr());
			this.getBengrp().getPta().setPtytyp("4");
			//$bengrp\\pta\\ptyextkey.setValue($bengrp\\pty\\extkey.getValue());
			ctx.getDaoSession().dbInsert(this.getBengrp().getPta());
			ctx.getErrorCode();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","保存收款人数据失败！");
			  return;
			}
			//ptr
			this.getBengrp().getPtr().setInr(Platform.sdbCounter("ptr"));
			this.getBengrp().getPtr().setPreptyinr(this.getBengrp().getPty().getInr());
			this.getBengrp().getPtr().setNxtptyinr(ptyinr);
			this.getBengrp().getPtr().setPtrtyp("3");
			this.getBengrp().getPtr().setDes("");
			ctx.getDaoSession().dbInsert(this.getBengrp().getPtr());
			ctx.getErrorCode();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","保存收款人数据失败！");
			  return;
			}
		}
        /**
        *   source:cpthyf.@0079.script
        */
        public void invDetail(String indinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 发票详情
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> invoicecode =new Argument<String>("invoicecode");
			Argument<String> invoicenumber =new Argument<String>("invoicenumber");
			Argument<Date> billingdate =new Argument<Date>("billingdate");
			Argument<String> checkresult =new Argument<String>("checkresult");
			Argument<BigDecimal> invamt =new Argument<BigDecimal>("invamt");
			Argument<String> checkcode =new Argument<String>("checkcode");
			Argument<BigDecimal> gframt =new Argument<BigDecimal>("gframt");
			Argument<String> gfrcur =new Argument<String>("gfrcur");
			Argument<String> remarks =new Argument<String>("remarks");
			Argument<String> purchasername =new Argument<String>("purchasername");
			Argument<String> purchasertaxno =new Argument<String>("purchasertaxno");
			Argument<String> salesname =new Argument<String>("salesname");
			Argument<String> salestaxno =new Argument<String>("salestaxno");
			Argument<String> state =new Argument<String>("state");
			//查询发票信息
			String sql="SELECT inv.inr,inv.invoicecode,inv.invoicenumber,inv.billingdate,inv.checkresult,inv.invamt,inv.checkcode,isp.gframt,isp.gfrcur,"
			  +"isp.remarks,isp.purchasername,isp.purchasertaxno,isp.salesname,isp.state,isp.salestaxno from inv inv LEFT JOIN invsup isp ON isp.invinr=inv.inr where inv.inr='"+indinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(inr,invoicecode,invoicenumber,billingdate,invamt,checkcode,gframt,gfrcur,remarks,purchasername,purchasertaxno,salesname,state,salestaxno);
			int errorCode = ctx.getErrorCode();
			if(errorCode != NO_ERROR)
			{
			  ctx.setMessage("提示","查询数据失败");
			  ctx.getDaoSession().dbCloseCursor();
			  return;
			}
			ctx.getDaoSession().dbCloseCursor();
			MdaUtils.clear(this.getCptp().getInvl().getInvdet());
			
			this.getCptp().getInvl().getInvdet().setInr(inr.value);
			
			this.getCptp().getInvl().getInvdet().setCheckcode(checkcode.value);
			
			this.getCptp().getInvl().getInvdet().setInvoicecode(invoicecode.value);
			
			this.getCptp().getInvl().getInvdet().setInvoicenumber(invoicenumber.value);
			
			this.getCptp().getInvl().getInvdet().setBillingdate(billingdate.value);
			
			this.getCptp().getInvl().getInvdet().setInvamt(invamt.value);
			
			this.getCptp().getInvl().getInvdet().setGframt(gframt.value);
			
			this.getCptp().getInvl().getInvdet().setGfrcur(gfrcur.value);
			

			this.getCptp().getInvl().getInvdet().setRemarks(remarks.value);
			

			this.getCptp().getInvl().getInvdet().setPurchasername(purchasername.value);
			

			this.getCptp().getInvl().getInvdet().setPurchasertaxno(purchasertaxno.value);
			

			this.getCptp().getInvl().getInvdet().setSalesname(salesname.value);
			
			this.getCptp().getInvl().getInvdet().setSalestaxno(salestaxno.value);
			
			// 发票状态
			String stateval=state.value;
			if ("0".equals(stateval))
			{
			  stateval="正常";
			}
			else if ("1".equals(stateval))
			{
			  stateval="失控";
			}
			else if ("2".equals(stateval))
			{
			  stateval="作废";
			}
			else if ("3".equals(stateval))
			{
			  stateval="红冲";
			}
			else if ("4".equals(stateval))
			{
			  stateval="异常";
			}
			else
			{
			  stateval="";
			}
			this.getCptp().getInvl().getInvdet().setState(stateval);
			
		}
        /**
        *   source:cpthyf.@0082.script
        */
        public void getCpdgrpSpt(String sptInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String selSptSql = "select inr,dattim,smhinr,frm,sta,ownref,trnamt,trncur,oprusrinr,imgref from spt where inr = '" + sptInr + "'";
			Argument<String> inr = new Argument<String>("inr");
			Argument<Date> dattim = new Argument<Date>("dattim");
			Argument<String> smhinr = new Argument<String>("smhinr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<BigDecimal> trnamt = new Argument<BigDecimal>("trnamt");
			Argument<String> trncur = new Argument<String>("trncur");
			Argument<String> oprusrinr = new Argument<String>("oprusrinr");
			Argument<String> imgref = new Argument<String>("imgref");
			ctx.getDaoSession().dbExecuteSQL(selSptSql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,dattim,smhinr,frm,sta,ownref,trnamt,trncur,oprusrinr,imgref);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getCpdgrp().getSpt().setInr(inr.getValue());
			    //slog.debug("============inr,sinr="+inr.getValue()+$cpdgrp\\spt\\inr.getValue());
			    this.getCpdgrp().getSpt().setDattim(dattim.getValue());
			    this.getCpdgrp().getSpt().setSmhinr(smhinr.getValue());
			    this.getCpdgrp().getSpt().setFrm(frm.getValue());
			    this.getCpdgrp().getSpt().setSta(sta.getValue());
			    this.getCpdgrp().getSpt().setOwnref(ownref.getValue());
			    this.getCpdgrp().getSpt().setTrnamt(trnamt.getValue());
			    this.getCpdgrp().getSpt().setTrncur(trncur.getValue());
			    this.getCpdgrp().getSpt().setOprusrinr(oprusrinr.getValue());
			    this.getCpdgrp().getSpt().setImgref(imgref.getValue());
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:cpthyf.@0085.script
        */
        public String stringToUTF8String(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if (!MdaUtils.isEmpty(str))
			{
			  return str;
			}
			try
			{
			  if (str.equals(new String(str.getBytes("GB2312"), "GB2312")))
			  {
			    str = new String(str.getBytes("GB2312"), "utf-8");
			    return str;
			  }
			}
			catch (Exception exception)
			{
			}
			try
			{
			  if (str.equals(new String(str.getBytes("ISO-8859-1"), "ISO-8859-1")))
			  {
			    str = new String(str.getBytes("ISO-8859-1"), "utf-8");
			    return str;
			  }
			}
			catch (Exception exception1)
			{
			}
			try
			{
			  if (str.equals(new String(str.getBytes("GBK"), "GBK")))
			  {
			    str = new String(str.getBytes("GBK"), "utf-8");
			    return str;
			  }
			}
			catch (Exception exception3)
			{
			}
			return str;
		}
        /**
        *   source:cpthyf.@0089.script
        */
        public void invInversion(String ownref, boolean invocr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 首张发票反显收款人名称；币种（备注信息）、提取所有发票金额（备注信息）合计反显汇款金额、发票号
			String indinr=this.getCptp().getInvl().getInvlst().getElement(0).getInr();
			if (MdaUtils.isEmpty(indinr))
			{
			  return;
			}
			BigDecimal remamt=this.getCpdgrp().getRec().getRemamt();
			String remcur=this.getCpdgrp().getRec().getRemcur();
			String pyeact=this.getCpdgrp().getRec().getPyeact();
			// 收款人
			String bennam=this.getCptp().getBenp().getPtspta().getPts().getNam();
			// 发票号
			String invno=this.getCpdgrp().getRec().getInvno();
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvsup());
			ctx.getDaoSession().dbRead(this.getCpdgrp().getInvs().getInvsup(),new Argument<String>("invinr",indinr));

			if (MdaUtils.isEmpty(bennam) && !MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvsup().getSalesname()))
			{
			  this.getCptp().getBenp().getPtspta().getPts().setNam(this.getCpdgrp().getInvs().getInvsup().getSalesname());
			  
			}
			if (!invocr && MdaUtils.isEmpty(invno))
			{
			  StringBuffer invnos = new StringBuffer();
			  if (!MdaUtils.isEmpty(this.getCptp().getInvl().getInvlst().getElement(0).getInvoicenumber()))
			  {
			    // 发票号长度128最多6张发票拼接，拼接使用"/"
			    int length = this.getCptp().getInvl().getInvlst().fullSize();
			    for(int i=0; i<length && i<6; i++)
			    {
			      if (MdaUtils.isEmpty(this.getCptp().getInvl().getInvlst().getElement(i).getInvoicenumber()))
			      {
			        continue;
			      }
			      if (i != 0)
			      {
			        invnos.append("/");
			      }
			      invnos.append(this.getCptp().getInvl().getInvlst().getElement(i).getInvoicenumber());
			    }
			    this.getCpdgrp().getRec().setInvno(invnos.toString());
			    
			  }

			}
			if (!invocr && remamt.compareTo(BigDecimal.ZERO) == 0)
			{
			  Argument<BigDecimal> amtsum =new Argument<BigDecimal>("amtsum");
			  String invsql="SELECT sum(gframt) amtsum FROM invsup WHERE ownref='"+ownref+"'";
			  ctx.getDaoSession().dbExecuteSQL(invsql);
			  log.info("{}","反显汇款金额："+ctx.getErrorCode());
			  if (ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(amtsum);
			    this.getCpdgrp().getRec().setRemamt(new BigDecimal(String.valueOf(amtsum.value)));
			    
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			String gfrcur = this.getCpdgrp().getInvs().getInvsup().getGfrcur();
			if (MdaUtils.isEmpty(remcur) && !MdaUtils.isEmpty(gfrcur))
			{
			  this.getCpdgrp().getRec().setRemcur(gfrcur);
			  
			  this.getCptp().setCur(gfrcur);
			  
			  this.getCptp().setCur1(gfrcur);
			  
			  this.getCpdgrp().getRec().setBopcur1(gfrcur);
			  
			}
			this.changeAmt();
		}
        /**
        *   source:cpthyf.@0091.script
        */
        public boolean delRepeatInv(boolean trancon)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean checkres = true;
			String ownref = this.getCpdgrp().getRec().getOwnref();
			MdaUtils.clear(this.getCpdgrp().getInvs().getInvlst());
			ctx.getDaoSession().dbReadset(this.getCpdgrp().getInvs().getInvlst(),new Argument<String>("ownref",ownref));
			Map<String,String> checkmap = new HashMap<String,String>();
			if (trancon)
			{
			  ctx.getDaoSession().dbBegin();
			}
			for(int i = 0; i < this.getCpdgrp().getInvs().getInvlst().size(); i++)
			{
			  if (MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode())
			    ||MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber())
			  ||MdaUtils.isEmpty(this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode()))
			  {
			    continue;
			  }
			  else if(checkmap.containsKey(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode()+this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber()+this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode()))
			  {
			    checkres = false;
			    if (trancon)
			    {
			      MdaUtils.clear(this.getCpdgrp().getInvs().getInv());
			      this.getCpdgrp().getInvs().getInv().copyValue(this.getCpdgrp().getInvs().getInvlst().getElement(i));
			      this.getCpdgrp().getInvs().getInv().setCheckresult("已存在相同发票号码、发票代码、校验码后六位发票");
			      ctx.getDaoSession().dbUpdate(this.getCpdgrp().getInvs().getInv());
			    }
			  }
			  else
			  {
			    checkmap.put(this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicecode()+this.getCpdgrp().getInvs().getInvlst().getElement(i).getInvoicenumber()+this.getCpdgrp().getInvs().getInvlst().getElement(i).getCheckcode(),this.getCpdgrp().getInvs().getInvlst().getElement(i).getInr());
			  }
			}
			if (trancon)
			{
			  ctx.getDaoSession().dbCommit();
			}
			return checkres;
		}
        /**
        *   source:cpthyf.@0093.script
        */
        public String ignorechnen(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if (MdaUtils.isEmpty(str))
			  return str;
			str = str.replaceAll("（","(");
			str = str.replaceAll("）",")");
			return str;
		}
        /**
        *   source:cpthyf.@0094.script
        */
        public void checkMaxLength(IDatafield<String> field, int maxlenth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String content = field.getValue();
			if(!MdaUtils.isEmpty(content))
			{
			  if (content.length() > maxlenth)
			  {
			    ctx.setFieldError(field,"长度不能超过"+maxlenth+"个字符");
			  }
			}
		}











}