package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptimpVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Cptmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 批量汇出汇款申请
*/
@Transaction(vo= CptimpVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptimp extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptimp.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptmod cptmod;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Cptimp()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptmod().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptimp.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptimp.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptimp.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptimp.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptimp.this.getCpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:cptimp.@0008.script
        */
        @Rule(target="cptp.cpdgrp.rec.paytyp",order=100)
        public boolean ruleCptpCpdgrpRecPaytypN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:cptimp.@0009.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000004"),MdaUtils.getI18NString("cptimp","CT000005"));
			  return false;
			}
			String objinr = "";
			if(MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getExtkey()) && MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getAdrblk()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000006"),MdaUtils.getI18NString("cptimp","CT000007"));
			  return false;
			}
			if(!ctx.checkAll(this.getCpdgrp()))
			{
			  log.debug("{}",this.getCpdgrp().getRec().getOwnref()+"校验不通过");
			  return false;
			}
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  objinr = this.getCpdgrp().getRec().getInr();
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getApl().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getBen().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getAcw().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getRcp().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getPay().getPts(),objinr);
			}
			else
			{
			  this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			  ctx.getDaoSession().dbInsert(this.getCpdgrp().getRec());
			  objinr = this.getCpdgrp().getRec().getInr();
			  String objtyp = "cpd";
			  this.getCpdgrp().getApl().savpts(objinr,objtyp);
			  this.getCpdgrp().getBen().savpts(objinr,objtyp);
			  this.getCpdgrp().getAcw().savpts(objinr,objtyp);
			  this.getCpdgrp().getRcp().savpts(objinr,objtyp);
			  this.getCpdgrp().getPay().savpts(objinr,objtyp);
			  //直接申请行
			  this.getCpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getCpdgrp().getDap().getPts().setObjinr(objinr);
			  this.getCpdgrp().getDap().getPts().setObjtyp("cpd");
			  ctx.getDaoSession().dbInsert(this.getCpdgrp().getDap().getPts());
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getCpdgrp().getTrp().savTrp(objtyp,objinr);
			  }
			}
			//报关单入库
			int size=this.getCpdgrp().getApyctmlst().fullSize();
			for(int i=0;i<size;i++)
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getApyctmlst().getElement(i).getAtcnum()))
			  {
			    this.getCpdgrp().getApyctm().copyValue(this.getCpdgrp().getApyctmlst().get(i));
			    this.getCpdgrp().getApyctm().setInr(Platform.sdbCounter("apyctm"));
			    this.getCpdgrp().getApyctm().setObjtyp("cpd");
			    this.getCpdgrp().getApyctm().setObjinr(objinr);
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getApyctm());
			  }
			}
			//$sysmod.generatorPdf($trnmod\\trn\\inr.getValue(),"remitapplys",$mtabut\\tdapldoc.getValue(),true);
			if(!this.getTrnmod().trnSetFromContract()) return false;
			// 如果是银行端代做的交易就直接经办
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  this.getTrnmod().getTrn().setRelreq("0");
			  this.getTrnmod().getTrn().setOptptyinr(this.getCpdgrp().getEpsptyinr());
			  log.debug("{}","sav1 relreq"+this.getTrnmod().getTrn().getRelreq());
			  String ptyname=this.getTrnmod().getPtyName(this.getCpdgrp().getEpsptyinr());
			  log.info("{}","ptynam="+ptyname);
			  if(!MdaUtils.isEmpty(ptyname))
			  {
			    this.getTrnmod().getTrn().setObjnam(this.getTrnmod().getTrn().getReloricur()+""+this.getTrnmod().getTrn().getReloriamt()+"/"+ptyname);
			  }
			  else
			  {
			    this.getTrnmod().getTrn().setObjnam(this.getTrnmod().getTrn().getReloricur()+""+this.getTrnmod().getTrn().getReloriamt());
			  }
			}
			this.getCptp().encode();
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cptimp.@0010.script
        */
        @Rule(target="mtabut.sel",order=100)
        public boolean ruleMtabutSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000008"),MdaUtils.getI18NString("cptimp","CT000009"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(index).getCod());
			
			

			return true;
        }

        /**
        *   source:cptimp.@0011.script
        */
        @Rule(target="mtabut.sel1",order=100)
        public boolean ruleMtabutSel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCty().setEngnam(NULLSTR);
			
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			//Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:cptimp.@0012.script
        */
        @Rule(target="mtabut.batimp",order=100)
        public boolean ruleMtabutBatimpN100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","batimp =====");
			MdaUtils.clear(this.getCpdgrp().getImplst());
			if(MdaUtils.isEmpty(this.getCpdgrp().getApl().getPts().getExtkey()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000019"),MdaUtils.getI18NString("cptimp","CT000020"));
			  return true;
			}
			List<String[]> list = new ArrayList<String[]>();
			List<String[]> implist = new ArrayList<String[]>();// 导入列表
			IStream is = this.getMtabut().getBatimp();
			String fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/excel_imp.properties");
			int sheetIndex = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"sheetIndex"));
			int rowOffset = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"rowOffset"));
			int rowMax = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"rowMax"));
			int columnOffset = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"columnOffset"));
			int columnCount = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"columnCount"));
			int rowCountLimited = Integer.valueOf(MdaUtils.getPropertyValue(fileName,"rowCountLimited"));
			log.debug("{}","sheetIndex="+sheetIndex);
			log.debug("{}","rowOffset="+rowOffset);
			log.debug("{}","rowMax="+rowMax);
			log.debug("{}","columnOffset="+columnOffset);
			log.debug("{}","columnCount="+columnCount);
			int recode = MdaUtils.loadExcel(list,is,sheetIndex,rowOffset,rowMax,columnOffset,columnCount);
			log.info("{}","recode为：=====" + recode );
			if(MdaUtils.isEmpty(list))
			{
			  log.debug("{}","list is null");
			}
			if(recode==-1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000021"),MdaUtils.getI18NString("cptimp","CT000022"));
			  //recode = 0;
			  return true;
			}
			if(recode==-2)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000023"),MdaUtils.getI18NString("cptimp","CT000024"));
			  //recode = 0;
			  return true;
			}
			if(MdaUtils.isEmpty(list))
			{
			  log.debug("{}","list is null");
			}
			log.debug("{}","list.size="+list.size());
			Argument<String> acttyp = new Argument<String>("acttyp");
			Argument<String> fxact = new Argument<String>("fxact");
			Argument<String> puract = new Argument<String>("puract");
			Argument<String> othact = new Argument<String>("othact"); //  其他账号
			Argument<String> remcur = new Argument<String>("remcur");
			Argument<BigDecimal> remamt = new Argument<BigDecimal>("remamt");
			Argument<String> cuscod = new Argument<String>("cuscod");
			Argument<String> pyenam = new Argument<String>("pyenam");
			Argument<String> acwnam = new Argument<String>("acwnam");
			Argument<String> swtcod = new Argument<String>("swtcod");
			Argument<String> pyeact = new Argument<String>("pyeact");
			Argument<String> rcpnam = new Argument<String>("rcpnam");
			Argument<String> rcpswtcod = new Argument<String>("rcpswtcod");
			Argument<String> rcpact = new Argument<String>("rcpact");
			Argument<String> detchgcod = new Argument<String>("detchgcod");
			Argument<String> pyecry = new Argument<String>("pyecry");
			Argument<String> inoutflg = new Argument<String>("inoutflg");
			Argument<String> invno = new Argument<String>("invno");
			Argument<String> conno = new Argument<String>("conno");
			Argument<String> supno = new Argument<String>("supno");
			Argument<String> paytyp = new Argument<String>("paytyp");
			Argument<String> paytyptxt = new Argument<String>("paytyptxt");
			Argument<String> reminf = new Argument<String>("reminf");
			Argument<String> cavpayflg = new Argument<String>("cavpayflg");
			Argument<String> fmdno = new Argument<String>("fmdno");
			Argument<String> bopcod1 = new Argument<String>("bopcod1");
			Argument<BigDecimal> bopamt1 = new Argument<BigDecimal>("bopamt1");
			Argument<String> bopcur1 = new Argument<String>("bopcur1");
			Argument<String> bopinf1 = new Argument<String>("bopinf1");
			Argument<String> remark = new Argument<String>("remark");
			Argument<String> ownref = new Argument<String>("ownref");
			int cnt = 0;
			int all=0;
			StringBuffer errlog= new StringBuffer();
			int errcnt=0;
			int errflg=1;
			StringBuffer cont = null ;
			int sslen  =0 ;
			String[] ss = null;
			String intmp = "" ;
			String det = "";
			String paytyptmp = "" ;
			String paytxt = "" ;
			String bopamt ="";
			String checkcur = "CNY/USD/EUR/JPY/HKD/GBP/SGD/CAD/AUD/CHF/SEK/NZD/KRW";
			String amt ="";
			String cavtmp ="" ;
			// StringBuffer  line = new StringBuffer("");
			for(int i=1;i<list.size();i++)
			{
			  bopamt ="";
			  bopamt1.setValue(new BigDecimal(0));
			  errflg=1;
			  ss = list.get(i);
			  if(MdaUtils.isEmpty(ss))
			  {
			    continue;
			  }
			  sslen = ss.length;
			  // 校验这一行导入内容是否为空
			  cont = new StringBuffer();
			  // line = "";
			  for(String s:ss)
			  {
			    if(s==null)s="";
			    cont.append(s);
			    // line = line+s+"|";
			  }
			  // log.debug(cont);
			  if(cont.toString().isEmpty())
			  {
			    //log.debug("imp null line");
			    continue;
			  }
			  // log.debug(line);
			  //加入全角空格校验
			  if("普通".equals(ss[0].trim()) || "".equals(ss[0].trim()) || "　".equals(ss[0].trim()))
			    acttyp.setValue("1");
			  else if("NRA".equals(ss[0].trim()))
			    acttyp.setValue("2");
			  else if("FTA".equals(ss[0].trim()))
			    acttyp.setValue("3");
			  else if("FTN".equals(ss[0].trim()))
			    acttyp.setValue("4");
			  else if("FTE".equals(ss[0].trim()))
			    acttyp.setValue("5");
			  else if("FTU".equals(ss[0].trim()))
			    acttyp.setValue("6");
			  else
			  {
			    //  errlog=errlog+"第"+i+"行错误,"+ss[0]+"不是合法账号类型！";
			    errlog.append("第"+i+"行错误,"+ss[0]+"不是合法账号类型！");
			    errflg=0;
			  }
			  if(MdaUtils.isEmpty(ss[1]) && MdaUtils.isEmpty(ss[2]) && MdaUtils.isEmpty(ss[3]))
			  {
			    // errlog=errlog+"第"+i+"行错误,"+"现汇账号、购汇账号及其他账号不能全为空！";
			    errlog.append("第"+i+"行错误,"+"现汇账号和购汇账号不能全为空！");
			    errflg=0;
			  }
			  fxact.setValue(ss[1].trim());
			  puract.setValue(ss[2].trim());
			  othact.setValue(ss[3].trim());
			  // String checkcur = "CNY/USD/EUR/JPY/HKD/GBP/SGD/CAD/AUD/CHF/SEK/NZD";
			  if(checkcur.indexOf(ss[4])<0 || "".equals(ss[4].trim()))
			  {
			    //  errlog=errlog+"第"+i+"行错误,"+ss[4]+"不是合法币种！";
			    errlog.append("第"+i+"行错误,"+ss[4]+"不是合法币种！");
			    errflg=0;
			  }
			  remcur.setValue(ss[4].trim());
			  amt = ss[5];
			  log.debug("{}","amt-"+amt);
			  if( amt!=null && !amt.trim().equals(""))
			  {
			    amt = amt.replaceAll(",","");
			    remamt.setValue(MdaUtils.parseDecimal(MdaUtils.format(MdaUtils.parseDecimal(amt),"#0.00")));
			    ss[5]=MdaUtils.format(MdaUtils.parseDecimal(amt),"#0.00");
			  }
			  else
			  {
			    remamt.setValue(new BigDecimal(0));
			  }
			  //客户号6
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getPts().getExtkey()))
			    cuscod.setValue(this.getCpdgrp().getApl().getPts().getExtkey());
			  else
			    cuscod.setValue(" ");
			  if(MdaUtils.isEmpty(ss[6]))
			  {
			    // errlog=errlog+"第"+i+"行错误,"+"收款人名称不能为空！";
			    errlog.append("第"+i+"行错误,"+"收款人名称不能为空！");
			    errflg=0;
			  }
			  pyenam.setValue(ss[6].trim());
			  if(MdaUtils.isEmpty(ss[7]) && MdaUtils.isEmpty(ss[8]))
			  {
			    //errlog=errlog+"第"+i+"行错误,"+"收款人开户行及其SWIFT CODE不能全为空！";
			    errlog.append("第"+i+"行错误,"+"收款人开户行及其SWIFT CODE不能全为空！");
			    errflg=0;
			  }
			  acwnam.setValue(ss[7].trim());
			  swtcod.setValue(ss[8].trim());
			  if(MdaUtils.isEmpty(ss[9]))
			  {
			    // errlog=errlog+"第"+i+"行错误,"+"收款人账号不能为空！";
			    errlog.append("第"+i+"行错误,"+"收款人账号不能为空！");
			    errflg=0;
			  }
			  pyeact.setValue(ss[9].trim());
			  rcpnam.setValue(ss[10].trim());
			  rcpswtcod.setValue(ss[11].trim());
			  rcpact.setValue(ss[12].trim());
			  if(MdaUtils.isEmpty(ss[13]))
			  {
			    // errlog=errlog+"第"+i+"行错误,"+"费用承担方不能为空！";
			    errlog.append("第"+i+"行错误,"+"费用承担方不能为空！");
			    errflg=0;
			  }
			  if(ss[13]!=null && !ss[13].trim().equals(""))
			  {
			    det = ss[13].trim();
			    if("OUR".equals(det))
			      detchgcod.setValue("APPLICANT");
			    else if("BEN".equals(det))
			      detchgcod.setValue("BENEFICIARY");
			    else if("SHA".equals(det))
			      detchgcod.setValue("SHA");
			  }
			  else
			  {
			    detchgcod.setValue("SHA");
			  }
			  if(MdaUtils.isEmpty(ss[14]))
			  {
			    // errlog=errlog+"第"+i+"行错误,"+"收款人国别不能为空！";
			    errlog.append("第"+i+"行错误,"+"收款人国别不能为空！");
			    errflg=0;
			  }
			  pyecry.setValue(ss[14].trim());
			  //  String intmp = ss[15].trim();
			  intmp = ss[15].trim();
			  if(intmp.indexOf("境内")>=0)
			  {
			    intmp="in";
			  }
			  else if(intmp.indexOf("境外")>=0)
			  {
			    intmp="out";
			  }
			  inoutflg.setValue(intmp);
			  paytyptmp = "" ;
			  if(ss[16]!=null && !ss[16].trim().equals(""))
			  {
			    paytyptmp = ss[16].trim().substring(0,1) ;
			  }
			  if("A".equals(paytyptmp))
			    paytyptmp="Advance Payment";
			  else if("P".equals(paytyptmp))
			    paytyptmp="Payment Against Delivery";
			  else if("R".equals(paytyptmp))
			    paytyptmp="Refund";
			  else if("O".equals(paytyptmp))
			    paytyptmp="Others";
			  paytyp.setValue(paytyptmp);
			  paytxt = "" ;
			  if(ss[17]!=null && !ss[17].trim().equals(""))
			  {
			    paytxt = ss[17].trim().substring(0,1) ;
			  }
			  paytyptxt.setValue(paytxt);
			  reminf.setValue(ss[18].trim());

			  cavtmp = ss[19].trim();
			  if(!MdaUtils.isEmpty(cavtmp))
			  {
			    if(cavtmp.indexOf("Y")>=0)
			    {
			      cavtmp="Y";
			    }
			    else if(cavtmp.indexOf("N")>=0)
			    {
			      cavtmp="N";
			    }
			  }
			  cavpayflg.setValue(cavtmp);
			  if(ss[20].trim().length()>128||ss[21].trim().length()>128)
			  {
			    errlog.append("第"+i+"行错误,"+"发票号或合同号不能超过128位！");
			    errflg=0;
			  }
			  invno.setValue(ss[20].trim());
			  conno.setValue(ss[21].trim());
			  supno.setValue(ss[22].trim());
			  fmdno.setValue(ss[23].trim());
			  bopcod1.setValue(ss[24].trim());
			  bopamt = ss[25];
			  log.debug("{}","bopamt1===================="+bopamt1.getValue());
			  if( bopamt!=null && !bopamt.trim().equals(""))
			  {
			    bopamt = bopamt.replaceAll(",","");
			    bopamt1.setValue(new BigDecimal(bopamt));
			  }
			  /*
			    else
			    {
			    bopamt1.setValue(new BigDecimal(0));
			    }
			    */
			  bopcur1.setValue(ss[26].trim());
			  bopinf1.setValue(ss[27].trim());
			  remark.setValue(ss[28].trim());
			  all++;
			  if(errflg>0 && cnt<rowCountLimited)
			  {
			    String[] sb=new String [30];
			    for(int n=0;n<30;n++)
			    {
			      if(n==6)
			        sb[n]=this.getCpdgrp().getApl().getPts().getExtkey();
			      else if(n<6)
			        sb[n]=ss[n];
			      else if(n>6)
			      {
			        if(n==13)
			          sb[n]=ss[10];
			        else if(n==14)
			          sb[n]=ss[11];
			        else if(n==15)
			          sb[n]=ss[12];
			        else if(n==11)
			          sb[n]=ss[13];
			        else if(n==12)
			          sb[n]=ss[14];
			        else
			          sb[n]=ss[n - 1];
			      }
			    }
			    implist.add(sb);
			    this.getCpdgrp().getRec().setOwnref(NULLSTR);
			    this.getMtabut().getRef();
			    ownref.value=this.getCpdgrp().getRec().getOwnref();
			    this.getCpdgrp().getImplst().add(ownref,acttyp,fxact,puract,othact,remcur,remamt,cuscod,pyenam,acwnam,swtcod,pyeact,rcpnam,rcpswtcod,rcpact,detchgcod,pyecry,inoutflg,paytyp,paytyptxt,reminf,cavpayflg,invno,conno,supno,fmdno,bopcod1,bopamt1,bopcur1,bopinf1,remark);
			    log.info("{}","cptimp-ok-cnt"+cnt);
			    cnt ++;
			  }
			  else
			  {
			    log.info("{}","cptimp-no-cnt-errflg-cnt-rowCountLimited"+errcnt+" "+errflg+" "+cnt+" "+rowCountLimited);
			    errcnt++;
			  }
			}
			if(all>rowCountLimited)
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000047"),MdaUtils.getI18NString("cptimp","CT000048")+rowCountLimited+MdaUtils.getI18NString("cptimp","CT000049"));
			MdaUtils.clear(this.getMtabut().getBatimp());
			this.getCpdgrp().setImplstobj(null);
			this.getCpdgrp().setImplstobj(implist);
			
			if(errcnt>0 && cnt<rowCountLimited)
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000054"),MdaUtils.getI18NString("cptimp","CT000055") + cnt + MdaUtils.getI18NString("cptimp","CT000056") + errcnt + MdaUtils.getI18NString("cptimp","CT000057") + errlog.toString());
			else if(errcnt>0 && cnt == rowCountLimited)
			{
			  if("".equals(errlog.toString().trim()))
			    ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000058"),MdaUtils.getI18NString("cptimp","CT000059") + cnt + MdaUtils.getI18NString("cptimp","CT000061") + errcnt + MdaUtils.getI18NString("cptimp","CT000152"));
			  else
			    ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000153"),MdaUtils.getI18NString("cptimp","CT000154") + cnt + MdaUtils.getI18NString("cptimp","CT000155") + errcnt + MdaUtils.getI18NString("cptimp","CT000156") + errlog.toString());
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000157"),MdaUtils.getI18NString("cptimp","CT000158")+cnt+MdaUtils.getI18NString("cptimp","CT000159"));
			
			
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:cptimp.@0013.script
        */
        @Rule(target="mtabut.pdapldoc",order=100)
        public boolean ruleMtabutPdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.mtabut.pdapldoc ... ");
			this.getCptp().encode();
			IStream stream=this.getMtabut().getPdapldoc();
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  ctx.absGet(Sysmod.class).generatorPdf("","cptopn1",stream,false );
			}
			else
			{
			  ctx.absGet(Sysmod.class).generatorPdf("","cptopn",stream,false );
			}

			return true;
        }

        /**
        *   source:cptimp.@0014.script
        */
        @Rule(target="mtabut.mail",order=100)
        public boolean ruleMtabutMailN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("cptopnApp"+inr,"cptopn");
			this.getMtabut().creatTcoPdfFile("cptopnDra"+inr);
			this.getMtabut().setAttnames("cptopnApp"+inr+".pdf;cptopnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:cptimp.@0015.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","报关单开始");
			this.getCpdgrp().getApyctmlst().add();
			
			//Platform.clear($cpdgrp\\apyctm\\);
			log.debug("{}","报关单结束");

			return true;
        }

        /**
        *   source:cptimp.@0016.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size=this.getCpdgrp().getApyctmlst().fullSize();
			//  log.info(#CT000010+size);
			if(size>0)
			{
			  boolean delflag=false;
			  for(int i=0;i<size;i++ )
			  {
			    if("X".equals(this.getCpdgrp().getApyctmlst().getElement(i).getModflg()))
			    {
			      delflag=true;
			      this.getCpdgrp().getApyctmlst().remove(i);
			      size=this.getCpdgrp().getApyctmlst().fullSize();
			      i--;
			    }
			  }
			  
			  if (!delflag)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000011"),MdaUtils.getI18NString("cptimp","CT000012"));
			  }
			}

			return true;
        }

        /**
        *   source:cptimp.@0017.script
        */
        @Rule(target="mtabut.done",order=100)
        public boolean ruleMtabutDoneN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCpdlst());
			

			return true;
        }

        /**
        *   source:cptimp.@0018.script
        */
        @Rule(target="mtabut.tdapldoc",order=100)
        public boolean ruleMtabutTdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			IStream stream=this.getMtabut().getTdapldoc();
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  ctx.absGet(Sysmod.class).getPdfmod().generatorPdfWithNoLogo("","tcptopn1",stream,false);
			}
			else
			{
			  ctx.absGet(Sysmod.class).getPdfmod().generatorPdfWithNoLogo("","tcptopn",stream,false );
			}

			return true;
        }

        /**
        *   source:cptimp.@0019.script
        */
        @Rule(target="mtabut.bot",order=100)
        public boolean ruleMtabutBotN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			IStream stream =this.getMtabut().getBot();
			ctx.absGet(Sysmod.class).generatorPdf("","remitdoc",stream,false );

			return true;
        }

        /**
        *   source:cptimp.@0020.script
        */
        @Rule(target="cpdgrp.rec.remcur",order=100)
        public boolean ruleCpdgrpRecRemcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getRec().setBopcur1(this.getCpdgrp().getRec().getRemcur());
			this.getCpdgrp().getRec().setBopcur2(this.getCpdgrp().getRec().getRemcur());
			
			

			return true;
        }

        /**
        *   source:cptimp.@0021.script
        */
        @Rule(target="cpdgrp.rec.atccod",order=100)
        public boolean ruleCpdgrpRecAtccodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getAtccod()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setIdcard(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0022.script
        */
        @Rule(target="cpdgrp.rec.idcard",order=100)
        public boolean ruleCpdgrpRecIdcardN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getIdcard()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setAtccod(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0025.script
        */
        @Rule(target="cptp.search",order=100)
        public boolean ruleCptpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			String sql = "SELECT * FROM cty ";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getCty().getEngnam()))
			  sql = sql+" WHERE alpcod like '%"+this.getCpdgrp().getCty().getEngnam()+"%'";
			sql = sql+" ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ctylst len="+this.getCpdgrp().getCtylst().fullSize());
			if(MdaUtils.isEmpty(this.getCpdgrp().getCtylst())  ||  this.getCpdgrp().getCtylst().fullSize()<=0)
			{
			  sql = "SELECT * FROM cty  WHERE numcod like '%"+this.getCpdgrp().getCty().getEngnam()+"%'";
			  sql = sql+" ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			

			return true;
        }

        /**
        *   source:cptimp.@0026.script
        */
        @Rule(target="cptp.sure",order=100)
        public boolean ruleCptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000031"),MdaUtils.getI18NString("cptimp","CT000032"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(index).getCod());
			
			

			return true;
        }

        /**
        *   source:cptimp.@0027.script
        */
        @Rule(target="mtabut.sav1",order=100)
        public boolean ruleMtabutSav1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getEpsptyinr()))
			  {
			    ctx.setMessage("提示","请先选择代办企业客户。");
			    return true;
			  }
			  if(!this.getCpdgrp().getTempnam().equals(this.getCpdgrp().getEpsptynam()))
			  {
			    ctx.setMessage("提示","代办企业客户名称与您选择的不符，请重新选择。");
			    return true;
			  }
			}

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));

			log.debug("{}","批量提交"+this.getCpdgrp().getImplst().fullSize()+"笔");
			if(this.getCpdgrp().getImplst().fullSize()<=0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000039"),MdaUtils.getI18NString("cptimp","CT000040"));
			  return true;
			}
			int count = 0;
			String cty ="" ;
			String det ="" ;
			this.getSysmod().setFlg("X");
			this.getSysmod().setAuthflg("X");
			MdaUtils.clear(this.getCpdgrp().getTrnlst());
			log.debug("{}","0-50");
			boolean isOK = ctx.postRule(this,"mtabut.sav");
			if(!isOK) return false;
			log.debug("{}","for 0-"+this.getCpdgrp().getImplst().fullSize());
			String bchcod = "" ;
			//20140917
			// for(int i=0;i< $cpdgrp\\implst.fullSize();i++)
			for(int i=this.getCpdgrp().getImplst().fullSize()-(int)1;i>=0;i--)
			{

			  bchcod = this.getCpdgrp().getRec().getBchcod();
			  MdaUtils.clear(this.getCpdgrp().getRec());
			  MdaUtils.clear(this.getCpdgrp().getApl().getPts());
			  MdaUtils.clear(this.getCpdgrp().getBen().getPts());
			  MdaUtils.clear(this.getCpdgrp().getAcw().getPts());
			  MdaUtils.clear(this.getCpdgrp().getRcp().getPts());
			  MdaUtils.clear(this.getCpdgrp().getPay().getPts());
			  this.getCpdgrp().setCtydes(NULLSTR);
			  this.getCptp().setActtyp(NULLSTR);
			  MdaUtils.clear(ctx.absGet(Trnmod.class).getTrn());
			  MdaUtils.clear(this.getTrnmod().getApldoc());
			  initCpdrec();
			  // 为了保证报文里面M8=sysmod\\\\pty\\\\ncid值正确先临时设定当前pty的ncid是申请人的ncid
			  // 在循环处理结束后还原
			  this.getSysmod().getPty().setNcid(this.getCpdgrp().getDap().getPty().getNcid());
			  this.getSysmod().getPty().setCid(this.getCpdgrp().getDap().getPty().getNcid());
			  
			  
			  
			  this.getCptp().setActtyp(this.getCpdgrp().getImplst().getElement(i).getActtyp());
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getImplst().getElement(i).getFxact()))
			  {
			    this.getCpdgrp().getRec().setFxflg(TRUE);
			    this.getCpdgrp().getRec().setFxact(this.getCpdgrp().getImplst().getElement(i).getFxact());
			    this.getCpdgrp().getRec().setFxamt(this.getCpdgrp().getImplst().getElement(i).getRemamt());
			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getImplst().getElement(i).getPuract()))
			  {
			    this.getCpdgrp().getRec().setPurflg(TRUE);
			    this.getCpdgrp().getRec().setPuract(this.getCpdgrp().getImplst().getElement(i).getPuract());
			    this.getCpdgrp().getRec().setPuramt(this.getCpdgrp().getImplst().getElement(i).getRemamt());
			  }
			  // TODO 导入的表格中仅有其他账号，对应的金额和币种没有
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getImplst().getElement(i).getOthact()))
			  {
			    this.getCpdgrp().getRec().setOthflg(TRUE);
			    this.getCpdgrp().getRec().setOthact(this.getCpdgrp().getImplst().getElement(i).getOthact());
			    this.getCpdgrp().getRec().setOthamt(new BigDecimal(0.00));
			  }

			  // 设置公组织代码和报关单代码
			  this.getCpdgrp().getRec().setAtccod(this.getSysmod().getPty().getAtccod());
			  this.getCpdgrp().getRec().setBopcod(this.getSysmod().getPty().getBopcod());
			  log.debug("{}","i="+i);
			  log.debug("{}",this.getCpdgrp().getImplst().getElement(i).getFxact());
			  log.debug("{}","fxact="+this.getCpdgrp().getRec().getFxact());
			  log.debug("{}","fxflg="+this.getCpdgrp().getRec().getFxflg());
			  log.debug("{}","puract="+this.getCpdgrp().getRec().getPuract());
			  log.debug("{}","purflg="+this.getCpdgrp().getRec().getPurflg());
			  this.getCpdgrp().getRec().setBchcod(bchcod);
			  this.getCpdgrp().getRec().setRemcur(this.getCpdgrp().getImplst().getElement(i).getRemcur());
			  this.getCpdgrp().getRec().setRemamt(this.getCpdgrp().getImplst().getElement(i).getRemamt());
			  // String amt = $sysmod.covCnAmt($cpdgrp\\rec\\remamt.getValue(),$cpdgrp\\rec\\remcur.getValue());
			  // $cpdgrp\\rec\\word.setValue(amt);
			  this.getCpdgrp().getRec().setWord(this.getSysmod().covCnAmt(this.getCpdgrp().getRec().getRemamt(),this.getCpdgrp().getRec().getRemcur()));
			  this.getCpdgrp().getBen().getPts().setNam(this.getCpdgrp().getImplst().getElement(i).getPyenam());
			  this.getCpdgrp().getBen().getPts().setAdrblk(this.getCpdgrp().getImplst().getElement(i).getPyenam());
			  this.getCpdgrp().getBen().getPts().setRol("ben");
			  this.getCpdgrp().getAcw().getPts().setNam(this.getCpdgrp().getImplst().getElement(i).getAcwnam());
			  this.getCpdgrp().getAcw().getPts().setAdrblk(this.getCpdgrp().getImplst().getElement(i).getAcwnam());
			  this.getCpdgrp().getAcw().getPts().setExtkey(this.getCpdgrp().getImplst().getElement(i).getSwtcod());
			  this.getCpdgrp().getAcw().getPts().setRol("acw");
			  this.getCpdgrp().getRec().setPyeact(this.getCpdgrp().getImplst().getElement(i).getPyeact());
			  this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getImplst().getElement(i).getPyecry());
			  // 设置收款银行代理行信息
			  this.getCpdgrp().getRcp().getPts().setRol("rcp");
			  this.getCpdgrp().getRcp().getPts().setNam(this.getCpdgrp().getImplst().getElement(i).getRcpnam());
			  this.getCpdgrp().getRcp().getPts().setAdrblk(this.getCpdgrp().getImplst().getElement(i).getRcpnam());
			  this.getCpdgrp().getRcp().getPts().setExtkey(this.getCpdgrp().getImplst().getElement(i).getRcpswtcod());
			  this.getCpdgrp().getRcp().getPts().setRef(this.getCpdgrp().getImplst().getElement(i).getRcpact());

			  cty = this.getCpdgrp().getRec().getPyecry();
			  log.debug("{}","pyecry= " + cty );
			  for(int k=0;k<this.getCpdgrp().getCtylst().fullSize();k++)
			  {
			    if(cty.equals(this.getCpdgrp().getCtylst().getElement(k).getAlpcod()))
			    {
			      this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(k).getChnnam());
			      this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(k).getCod());
			      break;
			    }
			  }

			  log.debug("{}","cpdgrp.cod = " + this.getCpdgrp().getCod() );
			  this.getCpdgrp().getRec().setInoutflg(this.getCpdgrp().getImplst().getElement(i).getInoutflg());
			  this.getCpdgrp().getRec().setInvno(this.getCpdgrp().getImplst().getElement(i).getInvno());
			  this.getCpdgrp().getRec().setConno(this.getCpdgrp().getImplst().getElement(i).getConno());
			  this.getRmkmod().setNtext("供应商编号："+this.getCpdgrp().getImplst().getElement(i).getSupno());
			  det = this.getCpdgrp().getImplst().getElement(i).getDetchgcod();
			  if("BEN".equalsIgnoreCase(det))
			  {
			    this.getCpdgrp().getRec().setDetchgcod("BENEFICIARY");
			  }
			  else if("OUR".equalsIgnoreCase(det))
			  {
			    this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			  }
			  else
			    this.getCpdgrp().getRec().setDetchgcod(det);
			  //  设置对应的新增字段值
			  this.getCpdgrp().getRec().setPaytyp(this.getCpdgrp().getImplst().getElement(i).getPaytyp());
			  this.getCpdgrp().getRec().setPaytyptxt(this.getCpdgrp().getImplst().getElement(i).getPaytyptxt());
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getInoutflg()) && "out".equals(this.getCpdgrp().getRec().getInoutflg()))
			  {
			    this.getCptp().setPaytyptxt(NULLSTR);
			  }
			  else
			  {
			    this.getCptp().setPaytyptxt(this.getCpdgrp().getRec().getPaytyptxt());
			  }
			  this.getCpdgrp().getRec().setReminf(this.getCpdgrp().getImplst().getElement(i).getReminf());
			  this.getCpdgrp().getRec().setCavpayflg(this.getCpdgrp().getImplst().getElement(i).getCavpayflg());
			  this.getCpdgrp().getRec().setFmdno(this.getCpdgrp().getImplst().getElement(i).getFmdno());
			  this.getCpdgrp().getRec().setBopcod1(this.getCpdgrp().getImplst().getElement(i).getBopcod1());
			  this.getCpdgrp().getRec().setBopamt1(this.getCpdgrp().getImplst().getElement(i).getBopamt1());
			  this.getCpdgrp().getRec().setBopcur1(this.getCpdgrp().getImplst().getElement(i).getBopcur1());
			  this.getCpdgrp().getRec().setBopinf1(this.getCpdgrp().getImplst().getElement(i).getBopinf1());

			  this.getCpdgrp().getRec().setOwnref(this.getCpdgrp().getImplst().getElement(i).getOwnref());
			  // 设置影像信息
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getImplst().getElement(i).getImgref()))
			  {
			    this.getTrnmod().getItfmod().getImgmod().setImgref( this.getCpdgrp().getImplst().getElement(i).getImgref());
			    this.getTrnmod().getItfmod().getImgmod().setOwnref( this.getCpdgrp().getImplst().getElement(i).getOwnref());
			  }
			  else
			  {
			    this.getTrnmod().getItfmod().getImgmod().setImgref(NULLSTR);
			    this.getTrnmod().getItfmod().getImgmod().setOwnref(NULLSTR);
			  }

			  if(ctx.postRule(this,"mtabut.sav")
			    &&ctx.postRule(this,"mtabut.sav"))
			  {
			    log.debug("{}",this.getCpdgrp().getRec().getOwnref()+" 提交成功");
			    count++;
			    if("R".equals(ctx.absGet(Trnmod.class).getTrn().getSta()))
			    {
			      this.getCpdgrp().getTrnlst().add();
			      int k = this.getCpdgrp().getTrnlst().fullSize() - 1;
			      this.getCpdgrp().getTrnlst().getElement(k).copyValue(ctx.absGet(Trnmod.class).getTrn());
			      log.debug("{}","add trn inr="+ctx.absGet(Trnmod.class).getTrn().getInr());
			    }
			  }
			  else
			  {
			    log.debug("{}",this.getCpdgrp().getRec().getOwnref()+" 提交失败");
			  }
			  this.getTrnmod().ordNew();
			}
			// 还原sysmod\\\\pty\\\\ncid
			log.debug("{}","ncid before"+this.getSysmod().getPty().getNcid());
			ctx.getDaoSession().dbRead(this.getSysmod().getPty(),new Argument("inr",this.getSysmod().getPty().getInr()));
			log.debug("{}","ncid after"+this.getSysmod().getPty().getNcid());
			// 如果是银行端代做的不数字签名
			String needSign = (String)Platform.getLoginData("needSign");
			log.info("{}","needSign "+needSign);//数字签名放开
			if(!MdaUtils.isEmpty(needSign) &&"yes".equals(needSign))
			{
			  if(!"0".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    // 如果trnlst大于0 那么批量授权签字
			    if(this.getCpdgrp().getTrnlst().fullSize()>0)
			      signatureMuti();
			    //如果签字取消那么返回
			    if("Y".equals(this.getTrnmod().getSigmod().getFlg()))
			    {
			      log.debug("{}","批量签字取消 ");
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			  }
			}
			Object signresult = ctx.restoreData("sigresult");
			if(!MdaUtils.isEmpty(signresult))
			{
			  log.debug("{}","批量签字取消 ");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			if(ctx.postRule(this,"mtabut.sav"))
			{
			  this.getSysmod().setFlg(NULLSTR);
			  this.getSysmod().setAuthflg(NULLSTR);
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000041"),MdaUtils.getI18NString("cptimp","CT000042")+count+MdaUtils.getI18NString("cptimp","CT000043"));
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0030.script
        */
        @Rule(target="trnmod.sigmod.signall",order=100)
        public boolean ruleTrnmodSigmodSignallN100(){
            IContext ctx = MdaEnv.getContext();
            
			//光大银行签名逻辑
			//lxy 20190315
			String trans =this.getTrnmod().getTrn().getInifrm();
			String trannam = "批量汇出汇款";

			/*
			  if(Platform.isEmpty(MdaUtils.getEventData()))
			  {
			  return;
			  }
			  String signdata = MdaUtils.getEventData().toString();
			  log.debug("MdaUtils.getEventdata.length="+signdata.length());
			  String[] signs = signdata.split("\\r\\n--------\\r\\n");// 签字返回结果
			  */
			String result="";
			String signdata="";
			List<String> items = new ArrayList<String>();
			List<String> item = new ArrayList<String>();
			BigDecimal samt =new BigDecimal(0);
			for(int i=0;i<this.getCpdgrp().getTrnlst().fullSize();i++)
			{
			  String ownref = this.getCpdgrp().getTrnlst().getElement(i).getOwnref();
			  BigDecimal amt = this.getCpdgrp().getTrnlst().getElement(i).getReloriamt();
			  if(MdaUtils.isEmpty(amt))
			    amt = new BigDecimal(0);
			  String cur = this.getCpdgrp().getTrnlst().getElement(i).getReloricur();
			  // signdata= ownref+","+amt+","+cur+","+signdata;
			  samt = samt.add(amt);
			  //signdata= ownref+","+amt+","+cur+","+signdata;
			  item.add("ownref|s|业务参号|"+ownref+",CUR|s|币种|"+cur+",amt|s|金额|"+amt);
			  // log.debug("signdata="+signdata);
			}
			/*result = (String)Platform.invoke("client:","sign",signdata);
			  if(result == ""||result == null)
			  {
			  return false;
			  }
			  */
			items.add("count|s|总笔数|"+this.getCpdgrp().getTrnlst().fullSize());
			items.add("Aamt|s|总金额|"+samt);
			items.addAll(item);
			/* result = (String)Platform.invoke("client:","sign",signdata);
			  if(result == ""||result == null)
			  {
			  return false;
			  }
			  */
			String utilcls = "com.brilliance.etrade.signature.SigUtils";
			String plain = (String)MdaUtils.invoke(utilcls,"getSignXML",new Object[]{trannam,items,false});

			String CN = (String)Platform.getLoginData("CN");
			String algorithm = (String)Platform.getLoginData("algorithm");
			String signinput = CN+";"+plain;
			log.info("{}","signinput :"+signinput);
			result = (String)MdaUtils.invoke("client:","sign",signinput);

			log.info("{}","sign algorithm :"+algorithm);
			log.info("{}","sign result :"+result);
			if("SHA1".equals(algorithm))
			{
			  if(MdaUtils.isEmpty(result))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000174"),MdaUtils.getI18NString("cptimp","CT000175"));
			    return false;
			  }
			}
			java.security.cert.X509Certificate cert = (java.security.cert.X509Certificate)Platform.getLoginData("CERT");

			Map parmap = (Map)MdaUtils.invoke(utilcls,"parseSigndata",new Object[]{result});
			Boolean verifed = (Boolean)MdaUtils.invoke(utilcls,"verify",new Object[]{cert,algorithm,parmap});
			log.info("{}","verifed :"+verifed);
			if("SM3".equals(algorithm))
			{
			  verifed = true;
			}

			if(verifed)
			{
			  for(int i=0;i<this.getCpdgrp().getTrnlst().fullSize();i++)
			  {
			    this.getTrnmod().getSigmod().getSig().setFrm(this.getCpdgrp().getTrnlst().getElement(i).getInifrm());
			    this.getTrnmod().getSigmod().getSig().setUsr(MdaEnv.getLoginUser());
			    this.getTrnmod().getSigmod().getSig().setAct("1");
			    this.getTrnmod().getSigmod().getSig().setObjinr(this.getCpdgrp().getTrnlst().getElement(i).getInr());
			    this.getTrnmod().getSigmod().getSig().setSig(result);
			    this.getTrnmod().getSigmod().getSig().setCur(this.getCpdgrp().getTrnlst().getElement(i).getRelcur());
			    this.getTrnmod().getSigmod().getSig().setAmt(this.getCpdgrp().getTrnlst().getElement(i).getRelamt());
			    this.getTrnmod().getSigmod().getSig().setOwnref(this.getCpdgrp().getTrnlst().getElement(i).getOwnref());
			    this.getTrnmod().getSigmod().getSig().setSigdate(new Date());
			    this.getTrnmod().getSigmod().getSig().setObjtyp("trn");
			    this.getTrnmod().getSigmod().getSig().setOrdinr(this.getCpdgrp().getTrnlst().getElement(i).getOrdinr());
			    this.getTrnmod().getSigmod().getSig().setHash("***??***");
			    this.getTrnmod().getSigmod().getSig().setInr(Platform.sdbCounter(this.getTrnmod().getSigmod().getSig()));
			    ctx.getDaoSession().dbInsert(this.getTrnmod().getSigmod().getSig());
			  }
			}
			else
			{
			  log.info("{}","******签名验证失败!******");
			  ctx.storeData("sigresult","100104");
			}
			this.getTrnmod().getSigmod().setFlg(NULLSTR);
			

			return true;
        }

        /**
        *   source:cptimp.@0031.script
        */
        @Rule(target="cptp.download",order=100)
        public boolean ruleCptpDownloadN100(){
            IContext ctx = MdaEnv.getContext();
            

			IStream is=this.getCptp().getDownload();
			is.setType("xls");
			is.setName("汇出汇款批量下载"+MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			List<Object[]> lst = new ArrayList<Object[]>();
			String tit[] = new String[30];
			tit[0] = "帐号类型";
			tit[1] = "现汇帐号";
			tit[2] = "购汇帐号";
			tit[3] = "其他帐号";
			tit[4] = "付款币种";
			tit[5] = "付款金额";
			tit[6] = "客户代码";
			tit[7] = "收款人名称";
			tit[8] = "收款人开户行";
			tit[9] = "SWIFT CODE";
			tit[10] = "收款人帐号";
			tit[11] = "费用承担方";
			tit[12] = "国别";
			tit[13] = "收款银行之代理行";
			tit[14] = "收款银行之代理行SWIFT CODE";
			tit[15] = "收款银行在其代理行账号";
			tit[16] = "汇款类型";
			tit[17] = "付款选择";
			tit[18] = "付款性质";
			tit[19] = "汇款附言";
			tit[20] = "是否为保税货物项下付款";
			tit[21] = "发票号";
			tit[22] = "合同号";
			tit[23] = "供应商编号";
			tit[24] = "外汇局批件号/备案表号/业务编号";
			tit[25] = "交易编码";
			tit[26] = "相关金额";
			tit[27] = "相关币种";
			tit[28] = "交易附言";
			tit[29]= "备注";
			lst.add(tit);
			for(int i=0;i<this.getCpdgrp().getImplst().fullSize();i++)
			{
			  String[] line = new String[30];
			  line[0] = MdaUtils.getCodetableLabel("acttyp",this.getCpdgrp().getImplst().getElement(i).getActtyp());
			  line[1] = this.getCpdgrp().getImplst().getElement(i).getFxact();
			  line[2] = this.getCpdgrp().getImplst().getElement(i).getPuract();
			  line[3] = this.getCpdgrp().getImplst().getElement(i).getOthact();
			  line[4] =this.getCpdgrp().getImplst().getElement(i).getRemcur();
			  line[5] = String.valueOf(this.getCpdgrp().getImplst().getElement(i).getRemamt());
			  line[6] = this.getCpdgrp().getImplst().getElement(i).getCuscod();
			  line[7] = this.getCpdgrp().getImplst().getElement(i).getPyenam();
			  line[8] = this.getCpdgrp().getImplst().getElement(i).getAcwnam();
			  line[9] = this.getCpdgrp().getImplst().getElement(i).getSwtcod();
			  line[10] = this.getCpdgrp().getImplst().getElement(i).getPyeact();
			  line[11] = MdaUtils.getCodetableLabel("detchgcod",this.getCpdgrp().getImplst().getElement(i).getDetchgcod());
			  line[12] = this.getCpdgrp().getImplst().getElement(i).getPyecry();
			  line[13] = this.getCpdgrp().getImplst().getElement(i).getRcpnam();
			  line[14] = this.getCpdgrp().getImplst().getElement(i).getRcpswtcod();
			  line[15] = this.getCpdgrp().getImplst().getElement(i).getRcpact();
			  line[16] = MdaUtils.getCodetableLabel("inoutflg",this.getCpdgrp().getImplst().getElement(i).getInoutflg());
			  line[17] = MdaUtils.getCodetableLabel("paytyp",this.getCpdgrp().getImplst().getElement(i).getPaytyp());
			  line[18] = MdaUtils.getCodetableLabel("paytyptxt",this.getCpdgrp().getImplst().getElement(i).getPaytyptxt());
			  line[19] = this.getCpdgrp().getImplst().getElement(i).getReminf();
			  line[20] = MdaUtils.getCodetableLabel("cavpayflg",this.getCpdgrp().getImplst().getElement(i).getCavpayflg());
			  line[21] = this.getCpdgrp().getImplst().getElement(i).getInvno();
			  line[22] = this.getCpdgrp().getImplst().getElement(i).getConno();
			  line[23] = this.getCpdgrp().getImplst().getElement(i).getSupno();
			  line[24] = this.getCpdgrp().getImplst().getElement(i).getFmdno();
			  line[25] = this.getCpdgrp().getImplst().getElement(i).getBopcod1();
			  line[26] = String.valueOf(this.getCpdgrp().getImplst().getElement(i).getBopamt1());
			  line[27] = this.getCpdgrp().getImplst().getElement(i).getBopcur1();
			  line[28] = this.getCpdgrp().getImplst().getElement(i).getBopinf1();
			  line[29] =  this.getCpdgrp().getImplst().getElement(i).getRemark();
			  lst.add(line);
			}
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:cptimp.@0032.script
        */
        @Rule(target="cpdgrp.epsptyinr",order=100)
        public boolean ruleCpdgrpEpsptyinrN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*log.debug("epsptyinr="+$cpdgrp\\epsptyinr);
			  List<CodetableItem> bchcod = $sysmod.getBchcod($cpdgrp\\epsptyinr.getValue(),"2");
			  Platform.setValues($cpdgrp\\rec\\bchcod,bchcod);
			  if(bchcod.size()>0)
			  $cpdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  Platform.setModified($cpdgrp\\rec\\bchcod);
			  */

			return true;
        }

        /**
        *   source:cptimp.@0033.script
        */
        @Rule(target="cptp.sel",order=100)
        public boolean ruleCptpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getEpslst());
			// 如果不是银行端直接返回
			if(!"0".equals(this.getSysmod().getPty().getPtytyp()))
			  return false;
			log.debug("{}","ptytyp="+this.getSysmod().getPty().getPtytyp());
			String sql="SELECT inr, nam,engnam FROM pty WHERE ptytyp='2'";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getEpsptynam()))
			{
			  sql=sql+" AND (ncid like'%"+this.getCpdgrp().getEpsptynam()+"%' OR nam like '%"+this.getCpdgrp().getEpsptynam()+"%' )";
			}
			sql=sql+" ORDER BY inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam,inr,engnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			    this.getCpdgrp().getEpslst().add(nam,inr,engnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			

			return true;
        }

        /**
        *   source:cptimp.@0034.script
        */
        @Rule(target="cptp.sure1",order=100)
        public boolean ruleCptpSure1N100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index<0)
			  return true;
			this.getCpdgrp().setEpsptyinr(this.getCpdgrp().getEpslst().getElement(index).getInr());
			this.getCpdgrp().setEpsptynam(this.getCpdgrp().getEpslst().getElement(index).getNam());
			this.getCpdgrp().setTempnam(this.getCpdgrp().getEpslst().getElement(index).getNam());
			
			
			log.debug("{}","sel "+this.getCpdgrp().getEpsptyinr()+"="+this.getCpdgrp().getEpsptynam());
			/* List<CodetableItem> bchcod = $sysmod.getBchcod($cpdgrp\\epsptyinr.getValue(),"2");
			  Platform.setValues($cpdgrp\\rec\\bchcod,bchcod);
			  if(bchcod.size()>0)
			  $cpdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  Platform.setModified($cpdgrp\\rec\\bchcod);*/
			log.debug("{}","epsptynam="+this.getCpdgrp().getEpsptynam());
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getEpsptyinr()))
			  {
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPty(),new Argument("inr",this.getCpdgrp().getEpsptyinr()));
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPts(),new Argument("extkey",this.getCpdgrp().getApl().getPty().getNcid()));
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPta(),new Argument("ptyinr",this.getCpdgrp().getApl().getPty().getInr()));
			    ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getAdr(),new Argument("inr",this.getCpdgrp().getApl().getPta().getObjinr()));
			    
			    
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getPty().getAtccod()))
			      this.getCpdgrp().getRec().setAtccod(this.getCpdgrp().getApl().getPty().getAtccod());
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getPty().getBopcod()))
			      this.getCpdgrp().getRec().setBopcod(this.getCpdgrp().getApl().getPty().getBopcod());
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getAdr().getTel()))
			      this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getPty().getNam()))
			      this.getCpdgrp().setAplnam(this.getCpdgrp().getApl().getPty().getNam());
			    
			    
			    
			    
			    Argument<String> nam =new Argument<String>("nam");
			    Argument<String> cid =new Argument<String>("cid");
			    List<CodetableItem> bchcod = new ArrayList<CodetableItem>();
			    String sql="select nxtpty.nam,nxtpty.cid from ptr,pty nxtpty where ptr.ptrtyp in ('0','1') and ptr.preptyinr='"+this.getCpdgrp().getEpsptyinr()+"' and ptr.nxtptyinr=nxtpty.inr";
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    log.info("{}","cptimp-bchcod-sql-"+sql);
			    int cnt=0;
			    while(true)
			    {
			      ctx.getDaoSession().dbFetchFields(nam,cid);
			      int err=ctx.getErrorCode();
			      if(err==NO_ERROR)
			      {
			        bchcod.add(new CodetableItem(nam.value,cid.value));
			        log.info("{}","cptimp - bchcod - nam "+nam.value+" - "+cid.value+" - "+cnt);
			        cnt++;
			      }
			      else
			      {
			        if(cnt==0)
			          break;
			        else
			        {
			          log.info("{}","cptimp-cnt "+cnt);
			          this.getCpdgrp().getRec().setBchcod(NULLSTR);
			          MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			          
			          break;
			        }
			      }
			    }
			    ctx.getDaoSession().dbCloseCursor();
			  }
			}
			

			return true;
        }

        /**
        *   source:cptimp.@0035.script
        */
        @Rule(target="cptp.cancel",order=100)
        public boolean ruleCptpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptimp.@0037.script
        */
        @Rule(target="cpdgrp.epsptynam",order=100)
        public boolean ruleCpdgrpEpsptynamN100(){
            IContext ctx = MdaEnv.getContext();
            
			/* log.debug("epsptynam="+$cpdgrp\\epsptynam);
			  if("0".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  if(!Platform.isEmpty($cpdgrp\\epsptyinr))
			  {
			  Platform.dbRead($cpdgrp\\apl\\pty,new Argument("inr",$cpdgrp\\epsptyinr.getValue()));
			  Platform.dbRead($cpdgrp\\apl\\pts,new Argument("extkey",$cpdgrp\\apl\\pty\\ncid.getValue()));
			  Platform.setModified($cpdgrp\\apl\\pts\\extkey);
			  Platform.setModified($cpdgrp\\apl\\pts\\adrblk);
			  Argument<String> nam =new Argument<String>("nam");
			  Argument<String> cid =new Argument<String>("cid");
			  List<CodetableItem> bchcod = new ArrayList<CodetableItem>();
			  Platform.dbExecuteSQL("select nxtpty.nam,nxtpty.cid from pty prepty,ptr,pty nxtpty where ptr.ptrtyp in ('0','1') and ptr.preptyinr='"+$cpdgrp\\apl\\pty\\inr.getValue()+"' and ptr.nxtptyinr=nxtpty.inr");
			  while(true)
			  {
			  Platform.dbFetchFields(nam,cid);
			  int err=Platform.errorCode();
			  if(err==NO_ERROR)
			  bchcod.add(new CodetableItem(nam.value,cid.value));
			  else
			  break;
			  }
			  Platform.dbCloseCursor();
			  $cpdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  Platform.setModified($cpdgrp\\rec\\bchcod);
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:cptimp.@0040.script
        */
        @Rule(target="cptp.imgbtn",order=100)
        public boolean ruleCptpImgbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.cptp.imgbtn ... ");
			int idx =0;
			if(idx < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000134"),MdaUtils.getI18NString("cptimp","CT000135"));
			  return false;
			}

			//判断影像功能是否开通
			String cid="";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getPts().getExtkey()))
			  cid =this.getCpdgrp().getApl().getPts().getExtkey();
			String frm =ctx.getTransName();
			IDatafield<String> bchField = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"bchcod");
			String bch = bchField.getValue();
			log.debug("{}","bch=" +bchField.getValue());
			if(MdaUtils.isEmpty(bch))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000136"),MdaUtils.getI18NString("cptimp","CT000137"));
			  return false;
			}
			boolean result = ctx.absGet(Trnmod.class).getItfmod().getImgmod().judgingImageOpen(cid,frm,bch);
			if(!result)
			{
			  return false;
			}
			log.debug("{}"," ownref=" + this.getCpdgrp().getImplst().getElement(idx).getOwnref());
			this.getCpdgrp().getImplst().getElement(idx).setImgref(this.getCpdgrp().getImplst().getElement(idx).getOwnref());
			this.getCpdgrp().getImplst().getElement(idx).setImgflg("√");
			
			String ownref = this.getCpdgrp().getImplst().getElement(idx).getOwnref();
			String imgref = ownref ;
			this.getTrnmod().getItfmod().getImgmod().callImageComponent("ImageUpload",ownref,imgref,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),"cpd" );

			return true;
        }

        /**
        *   source:cptimp.@0042.script
        */
        @Rule(target="cptp.apldocbtn",order=100)
        public boolean ruleCptpApldocbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.cptp.apldocbtn ....");
			int idx =0;
			if(idx < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000132"),MdaUtils.getI18NString("cptimp","CT000133"));
			  return false;
			}
			this.getCptp().encode();
			String rmttyp=this.getCpdgrp().getRec().getRmttyp();
			String bchcod = this.getCpdgrp().getRec().getBchcod();
			Date credat = this.getCpdgrp().getRec().getCredat();
			String periority=this.getCpdgrp().getRec().getPriority();
			this.getCptp().setCpdFromCimp(this.getCpdgrp().getImplst().getElement(idx));
			this.getCptp().setActtyp(this.getCpdgrp().getImplst().getElement(idx).getActtyp());
			
			IStream stream = this.getCptp().getApldocbtn();
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  ctx.absGet(Sysmod.class).generatorPdf("","tcptopn1",stream,false );
			}
			else
			{
			  ctx.absGet(Sysmod.class).generatorPdf("","tcptopn",stream,false );
			}
			this.getCpdgrp().getRec().setRmttyp(rmttyp);
			this.getCpdgrp().getRec().setBchcod(bchcod);
			this.getCpdgrp().getRec().setCredat(credat);
			this.getCpdgrp().getRec().setPriority(periority);
			
			
			
			

			return true;
        }

        /**
        *   source:cptimp.@0045.script
        */
        @Rule(target="cptp.return",order=100)
        public boolean ruleCptpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptimp.@0047.script
        */
        @Rule(target="cptp.aplp.sure",order=1000)
        public boolean ruleCptpAplpSureN1000(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().setApltel(NULLSTR);
			if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getAdr().getTel()))
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			

			return true;
        }

        /**
        *   source:cptimp.@0050.script
        */
        @Rule(target="cptp.apldocs",order=100)
        public boolean ruleCptpApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.cptp.apldocbtn ....");
			int idx =0;
			if(idx < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptimp","CT000168"),MdaUtils.getI18NString("cptimp","CT000169"));
			  return false;
			}
			this.getCptp().encode();
			String rmttyp=this.getCpdgrp().getRec().getRmttyp();
			String bchcod = this.getCpdgrp().getRec().getBchcod();
			Date credat = this.getCpdgrp().getRec().getCredat();
			String periority=this.getCpdgrp().getRec().getPriority();
			this.getCptp().setCpdFromCimp(this.getCpdgrp().getImplst().getElement(idx));
			this.getCptp().setActtyp(this.getCpdgrp().getImplst().getElement(idx).getActtyp());
			
			this.getCpdgrp().getRec().setBchcod(bchcod);
			this.getCpdgrp().getRec().setCredat(credat);
			this.getCpdgrp().getRec().setRmttyp(rmttyp);
			this.getCpdgrp().getRec().setPriority(periority);
			
			
			
			
			IStream stream = this.getCptp().getApldocbtn();
			log.debug("{}","落地机构："+ bchcod);
			log.debug("{}","日期："+ credat);

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));
			

			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn1","境内汇款申请书",1);
			  //$\\sysmod.generatorPdf("","tcptopn1",stream,false );
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn","境外汇款申请书",1);
			  //$\\sysmod.generatorPdf("","tcptopn",stream,false );
			}

			return true;
        }

        /**
        *   source:cptimp.@0051.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[210]:in cptimp pdf");
			int cnt = 1;
			String labels = "申请书";
			String tempfiles;
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  //境内
			  tempfiles = "A:cptopn1";
			}
			else
			{
			  //境外
			  tempfiles = "A:cptopn";
			}
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();
			log.debug("{}","[210]:out cptimp pdf");

			return true;
        }

        /**
        *   source:cptimp.@0052.script
        */
        @Rule(target="mtabut.pdapldocs",order=100)
        public boolean ruleMtabutPdapldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.mtabut.pdapldoc ... ");
			this.getCptp().encode();
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptimp.@0053.script
        */
        @Rule(target="mtabut.tdapldocs",order=100)
        public boolean ruleMtabutTdapldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.mtabut.tdapldoc ... ");
			this.getCptp().encode();
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptimp.@0054.script
        */
        @Rule(target="mtabut.bots",order=100)
        public boolean ruleMtabutBotsN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt cptimp.mtabut.botapldoc ... ");
			this.getCptp().encode();
			this.getCptp().getPdfviw().callPDFComponent("","remitdoc","报关单信息",1);

			return true;
        }


        /**
        *   source:cptimp.@0004.script
        */
        @Check(target="cptp.cpdgrp.rec.fxflg",order=100)
        public boolean checkCptpCpdgrpRecFxflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getCptp().getCpdgrp().getRec().setFxamt(new BigDecimal(0));
			  
			  
			  this.getCptp().getCpdgrp().getRec().setFxact(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0005.script
        */
        @Check(target="cptp.cpdgrp.rec.purflg",order=100)
        public boolean checkCptpCpdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getCptp().getCpdgrp().getRec().setPuramt(new BigDecimal(0));
			  
			  
			  this.getCptp().getCpdgrp().getRec().setPuract(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0006.script
        */
        @Check(target="cpdgrp.rec.othflg",order=100)
        public boolean checkCpdgrpRecOthflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1:True
			if(TRUE.equals(this.getCpdgrp().getRec().getOthflg()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setOthamt(new BigDecimal(0));
			  
			  
			  this.getCpdgrp().getRec().setOthact(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:cptimp.@0007.script
        */
        @Check(target="cpdgrp.rec.remamt",order=100)
        public boolean checkCpdgrpRecRemamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","金额校验");
			BigDecimal sumamt =new BigDecimal("0");
			//汇款金额
			if(TRUE.equals(this.getCpdgrp().getRec().getFxflg()))
			{
			  sumamt = sumamt.add(this.getCpdgrp().getRec().getFxamt());
			  //log.debug("fxamt=="+fxamt);
			  //log.debug("sumamt=="+sumamt);
			}
			if(TRUE.equals(this.getCpdgrp().getRec().getPurflg()))
			  sumamt = sumamt.add(this.getCpdgrp().getRec().getPuramt());
			if(TRUE.equals(this.getCpdgrp().getRec().getOthflg()))
			  sumamt = sumamt.add(this.getCpdgrp().getRec().getOthamt());
			//log.debug("sumamt===="+sumamt);
			if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getCpdgrp().getRec().getRemamt()).compareTo(sumamt)!=0)
			{
			  log.debug("{}","金额校验不通过！");
			  ctx.setFieldError(this,"cpdgrp.rec.remamt",MdaUtils.getI18NString("cptimp","CT000003"));
			}

			return true;
        }


        /**
        *   source:cptimp.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod =null;
			this.getCpdgrp().getRec().setRmttyp("0");
			log.debug("{}","rmttyp:" +this.getCpdgrp().getRec().getRmttyp());
			this.getCpdgrp().setWtranfer("√");
			//Platform.setModified($cpdgrp\\wtranfer);
			
			
			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			this.getCptp().setTopub("√");
			
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  bchcod = new ArrayList<CodetableItem>();
			  bchcod.add(new CodetableItem(this.getSysmod().getPty().getNam(),this.getSysmod().getPty().getCid()));
			  this.getCpdgrp().setEpsptynam(NULLSTR);
			  this.getCpdgrp().setTempnam(NULLSTR);
			  this.getCpdgrp().setEpsptyinr(NULLSTR);
			  
			  this.getCpdgrp().setLabel("From:");
			  
			  
			  
			}
			else
			{
			  // 如果是企业端登录还按原来处理
			  bchcod = this.getSysmod().getAndSetBchcodvals();
			  // 初始化汇款人信息
			  this.getCpdgrp().getDap().initDap("cpd");
			  this.getCpdgrp().getApl().getPts().copyValue(this.getCpdgrp().getDap().getPts());
			  this.getCpdgrp().getApl().getAdr().copyValue(this.getCpdgrp().getDap().getAdr());
			  this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			  this.getCpdgrp().getApl().getPts().setRol("apl");
			  
			  
			  
			  
			}
			this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			
			
			
			
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			this.getCpdgrp().getRec().setPriority("Normal");
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			// 查询对公组织代码和报关单代码
			this.getCpdgrp().getRec().setAtccod(this.getSysmod().getPty().getAtccod());
			this.getCpdgrp().getRec().setBopcod(this.getSysmod().getPty().getBopcod());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  return true;
			}
			
			
			
			
			
			
			
			
			
			
			
			MdaUtils.clear(this.getCpdgrp().getImplst());
			//initCpdrec();
			// 初始化国家信息-- 批量汇款国别信息由表格导入，界面不需要再选择
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			ctx.getDaoSession().dbReadset(this.getCpdgrp().getCtylst());
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			


			return true;
        }


        /**
        *   source:cptimp.@0028.script
        */
        public void initCpdrec()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			
			
			log.info("{}","初始化直接申请人pts========");
			// 如果是银行端代做的交易按选择的pty初始化
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  this.getCpdgrp().getDap().initDapByPtyinr("cpd",this.getCpdgrp().getEpsptyinr());
			}
			else
			{
			  this.getCpdgrp().getDap().initDap("cpd");
			}
			this.getCpdgrp().getApl().getPts().copyValue(this.getCpdgrp().getDap().getPts());
			this.getCpdgrp().getApl().getPts().setRol("apl");
			this.getCpdgrp().getRec().setRemcur("USD");
			this.getCpdgrp().getRec().setRmttyp("0");
			this.getCpdgrp().getRec().setInoutflg("out");
			this.getCpdgrp().getRec().setPriority("Normal");
			this.getCpdgrp().getRec().setBopcur1("USD");
			this.getCpdgrp().getRec().setBopcur2("USD");
			//Platform.setRequired($cpdgrp\\apl\\pts\\extkey);
			
			//Platform.setRequired($cpdgrp\\ben\\pts\\extkey);
			
			//Platform.setRequired($cpdgrp\\acw\\pts\\extkey);
			//Platform.setRequired($cpdgrp\\acw\\pts\\adrblk);
			this.getCpdgrp().getRec().setPaytyp("Others");
			this.getCpdgrp().getRec().setPaytyptxt("6");
			this.getCpdgrp().getRec().setCavpayflg("N");
			this.getCpdgrp().getRec().setDetchgcod("SHA");
			
			
			//Platform.disable($cpdgrp\\rec\\fxact);
			//Platform.disable($cpdgrp\\rec\\fxamt);
			
			
			this.getCpdgrp().getRec().setBopcur1("USD");
			this.getCpdgrp().getRec().setBopcur2("USD");
			this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			log.debug("{}","pty inr==="+this.getSysmod().getPty().getInr());
			log.debug("{}","aplnam==="+this.getCpdgrp().getAplnam());
			
			if(MdaUtils.isEmpty(this.getCpdgrp().getApltel()) && !MdaUtils.isEmpty(this.getCpdgrp().getApl().getAdr().getTel()))
			{
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			  
			}
			//$cpdgrp\\rec\\fxflg.setValue("X");
					}
        /**
        *   source:cptimp.@0029.script
        */
        public void signatureMuti()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","invoke cptimp signature muti...");
			this.getTrnmod().getSigmod().getSig().setSig(NULLSTR);
			String frame=this.getCpdgrp().getTrnlst().getElement(0).getInifrm();
			String usr=this.getSysmod().getUsr().getOprnam();
			int size = this.getCpdgrp().getTrnlst().fullSize();
			frame=MdaUtils.getCodetableLabel("trans",frame);
			StringBuffer sig = new StringBuffer("");
			String con = "";
			String ownref = "" ;
			String camt = "" ;
			for(int i=0;i<size;i++)
			{
			  ownref=this.getCpdgrp().getTrnlst().getElement(i).getOwnref();
			  camt=null;
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getTrnlst().getElement(i).getReloriamt()))
			  {
			    camt=this.getCpdgrp().getTrnlst().getElement(i).getReloricur()+this.getCpdgrp().getTrnlst().getElement(i).getReloriamt().toString();
			  }
			  else
			  {
			    camt=this.getCpdgrp().getTrnlst().getElement(i).getRelcur()+this.getCpdgrp().getTrnlst().getElement(i).getRelamt().toString();
			  }
			  // sig = sig+con+"交易名称："+frame+"\\r\\n参考号："+ownref+"\\r\\n币种金额："+camt+"\\r\\n操作员："+usr;
			  sig.append(con+"交易名称："+frame+"\r\n参考号："+ownref+"\r\n币种金额："+camt+"\r\n操作员："+usr );
			  con = "\r\n--------\r\n";
			}
			this.getTrnmod().getSigmod().getSig().setSig(sig.toString());
			log.debug("{}","sig="+this.getTrnmod().getSigmod().getSig().getSig());
			this.getTrnmod().getSigmod().setFlg(NULLSTR);
			
			
			
			
			this.getTrnmod().getSigmod().setFlg("Y");
			
		}









}