package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.manager.module.Wghmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Tdemod;
import com.ceb.gjjs.mda.manager.module.Cptmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇出汇款申请
*/
@Transaction(vo= CptopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptopn.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptmod cptmod;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Swmmod swmmod;

		@BDGetter
		private Wghmod wghmod;

		@BDGetter
		private Tdemod tdemod;


		public Cptopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptmod().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptopn.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptopn.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptopn.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptopn.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptopn.this.getCpdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:cptopn.@0007.script
        */
        @Rule(target="cptp.cpdgrp.rec.paytyp",order=100)
        public boolean ruleCptpCpdgrpRecPaytypN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if("4".equals($cptp\\cpdgrp\\rec\\paytyp.getValue()))
			  {
			  Platform.enable($cptp\\cpdgrp\\rec\\paytyptxt);
			  }
			  else
			  {
			  Platform.disable($cptp\\cpdgrp\\rec\\paytyptxt);
			  }*/

			return true;
        }

        /**
        *   source:cptopn.@0008.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(Platform.isFromApp())
			{
			  String sptinr=(String)ctx.restoreData("__sptinr");
			  log.info("{}","__sptinr"+sptinr);
			  if(!MdaUtils.isEmpty(sptinr)&&MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			  {
			    ctx.setMessage("E9999","未找到对应的交易信息或您无权访问该笔交易");
			    return false;
			  }
			}
			//拼接开户行名址和代理行名址信息
			if(Platform.isFromApp())
			{
			  this.getCpdgrp().getRcp().getPts().setAdrblk(this.getCpdgrp().getRcp().getPts().getNam()+"\n"+this.getCpdgrp().getRcp().getPts().getAdr());
			  this.getCpdgrp().getAcw().getPts().setAdrblk(this.getCpdgrp().getAcw().getPts().getNam()+"\n"+this.getCpdgrp().getAcw().getPts().getAdr());
			}

			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("E9999","业务归属行为空，请先维护该信息。");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getWyghedno())&&"2".equals(this.getCpdgrp().getRec().getZjly()))
			{
			  this.getCpdgrp().getRec().setZjly(NULLSTR);
			  
			  ctx.setMessage("E9999","资金来源填写有误，请重新勾选资金来源");
			  return false;
			}
			String objinr = "";
			if(MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getExtkey()) && MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getAdrblk()))
			{
			  ctx.setMessage("E9999","收款行信息至少输入一项！");
			  return false;
			}
			for(int i = 0; i < this.getCpdgrp().getApyctmlst().size(); i++)
			{
			  if(!this.getCptp().checkIllegalAmt(MdaDriver.getDatafield(this.getCpdgrp().getApyctmlst().getElement(i),"totalamt")))
			  {
			    ctx.setMessage("E9999","占用金额输入不合法！");
			    return false;
			  }
			  if(!this.getCptp().checkIllegalAmt(MdaDriver.getDatafield(this.getCpdgrp().getApyctmlst().getElement(i),"atcamt")))
			  {
			    ctx.setMessage("E9999","单据金额输入不合法！");
			    return false;
			  }
			}
			/*手机端校验*/
			boolean checkflg=true;
			if(Platform.isFromApp())
			{
			  log.info("{}","手机端校验开始"+checkflg);
			  checkflg=cptopnCheck();
			  log.info("{}","手机端校验结束"+checkflg);
			}
			if(checkflg==false)
			{
			  return false;
			}
			if(!MdaUtils.isEmpty(this.getTrnmod().getTrninr()))
			{
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			}
			else
			{
			  if(!ctx.checkAll(this.getCpdgrp()))
			  {
			    ctx.setMessage("R9999","业务要素校验不通过");
			    return false;
			  }
			  if(Platform.isFromApp()&&TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    getOwnref();
			    log.debug("{}",this.getCptp().getFpdgrp().getRec().getOwnref());
			  }
			  boolean checkpur=true;
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    if(Platform.isFromApp())
			    {
			      checkpur=checkpurflg();
			    }
			    if(checkpur==false)
			    {
			      return false;
			    }
			    if(!ctx.checkAll(this.getCptp().getFpdgrp()))
			    {
			      return false;
			    }
			  }
			  if(Platform.isFromApp()&&TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    String steps = "0:汇出汇款申请";
			    steps =steps+";1:购汇申请";
			    
			    
			    this.getCptp().getStpmod().setPages(steps);
			    this.getCptp().getStpmod().calcSteps();
			    this.getCptp().getStpmod().setStepBtnSta();
			  }
			  if( Platform.isFromApp())
			  {
			    if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			    { //境内汇款时，收款人可以输入中文
			      this.getCptp().setChagepan(this.getCptp().getChnadr());
			      
			      this.getCptp().setChangeapl(this.getCptp().getAplcnptap());
			      

			    }
			    else
			    {
			      this.getCptp().setChagepan(this.getCptp().getEnadr());
			      
			      this.getCptp().setChangeapl(this.getCptp().getAplenptap());
			      

			    }
			  }
			  BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			  amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			  this.getCpdgrp().getRec().setFxamt(amt);

			  BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			  amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			  this.getCpdgrp().getRec().setPuramt(amt1);

			  BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			  amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			  this.getCpdgrp().getRec().setRemamt(amt2);

			  BigDecimal amt3 = this.getCpdgrp().getRec().getOthamt();
			  amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			  this.getCpdgrp().getRec().setOthamt(amt3);

			  BigDecimal amt4 = this.getCpdgrp().getRec().getBopamt1();
			  amt4 = MdaUtils.parseDecimal(MdaUtils.format(amt4,"#0.00"));
			  this.getCpdgrp().getRec().setBopamt1(amt4);

			  BigDecimal amt5 = this.getCpdgrp().getRec().getBopamt2();
			  amt5 = MdaUtils.parseDecimal(MdaUtils.format(amt5,"#0.00"));
			  this.getCpdgrp().getRec().setBopamt2(amt5);

			  this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));

			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    objinr = this.getCpdgrp().getRec().getInr();
			    ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getApl().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getBen().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getAcw().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getRcp().getPts(),objinr);
			    this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getPay().getPts(),objinr);
			  }
			  else
			  {
			    this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getRec());
			    objinr = this.getCpdgrp().getRec().getInr();
			    String objtyp = "cpd";
			    this.getCpdgrp().getApl().savpts(objinr,objtyp);
			    this.getCpdgrp().getBen().savpts(objinr,objtyp);
			    this.getCpdgrp().getAcw().savpts(objinr,objtyp);
			    this.getCpdgrp().getRcp().savpts(objinr,objtyp);
			    this.getCpdgrp().getPay().savpts(objinr,objtyp);
			    //直接申请行
			    this.getCpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			    this.getCpdgrp().getDap().getPts().setObjinr(objinr);
			    this.getCpdgrp().getDap().getPts().setObjtyp("cpd");
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getDap().getPts());
			    //如果是商行，要把商行信息作为转递申请人存储
			    if("1".equals(this.getSysmod().getPty().getPtytyp()))
			    {
			      this.getCpdgrp().getTrp().savTrp(objtyp,objinr);
			    }
			  }
			  //报关单入库
			  int size=this.getCpdgrp().getApyctmlst().fullSize();
			  log.debug("{}","message"+size);
			  for(int i=0;i<size;i++)
			  {
			    log.debug("{}","apyctmlst******"+this.getCpdgrp().getApyctmlst().getElement(i).getAtcnum());
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getApyctmlst().getElement(i).getAtcnum()))
			    {

			      this.getCpdgrp().getApyctm().copyValue(this.getCpdgrp().getApyctmlst().get(i));
			      this.getCpdgrp().getApyctm().setInr(Platform.sdbCounter("apyctm"));
			      this.getCpdgrp().getApyctm().setObjtyp("cpd");
			      this.getCpdgrp().getApyctm().setObjinr(objinr);
			      ctx.getDaoSession().dbInsert(this.getCpdgrp().getApyctm());
			    }
			  }
			  //$sysmod.generatorPdf($trnmod\\trn\\inr.getValue(),"remitapplys",$mtabut\\tdapldoc.getValue(),true);
			  this.getCptp().encode();
			  // 讲受益人的国别信息转换为2为代码
			  if(! MdaUtils.isEmpty(this.getCpdgrp().getRec().getPyecry()))
			  {
			    log.debug("{}","in 国别转换为2位数: pyecry=  " + this.getCpdgrp().getRec().getPyecry() );
			    String cty = this.getCpdgrp().getRec().getPyecry();
			    for(int k=0;k<this.getCpdgrp().getCtylst().fullSize();k++)
			    {
			      if(cty.equals(this.getCpdgrp().getCtylst().getElement(k).getAlpcod()))
			      {
			        this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(k).getChnnam());
			        this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(k).getCod());
			        break;
			      }
			    }
			  }
			  log.debug("{}"," 2位国别码为： cod =" + this.getCpdgrp().getCod() + ", ctydes=" + this.getCpdgrp().getCtydes()) ;

			  //购汇数据入库
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    if(ctx.absGet(Sysmod.class).sptIsLoaded("B") && !MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getInr()))
			      ctx.getDaoSession().dbUpdate(this.getCptp().getFpdgrp().getRec());
			    else
			    {
			      this.getCptp().getFpdgrp().getRec().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			      this.getCptp().getFpdgrp().getRec().setObjfrm(ctx.getTransName());
			      this.getCptp().getFpdgrp().getRec().setObjinr(this.getCpdgrp().getRec().getInr());
			      this.getCptp().getFpdgrp().getRec().setInr(Platform.sdbCounter("fpd"));
			      ctx.getDaoSession().dbInsert(this.getCptp().getFpdgrp().getRec());
			    }
			  }
			}
			/*
			  String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			  filename=Platform.catPath(Platform.getRootPath(),filename);
			  */
			if(!this.getTrnmod().trnSetFromContract()) return false;
			log.info("{}","locale:"+ctx.getLocale().toString());
			MdaEnv.setLocale(Locale.SIMPLIFIED_CHINESE);
			List<CodetableItem> codeitem1=new ArrayList<CodetableItem>();
			if(Platform.isFromApp())
			{
			  codeitem1=this.getBopCod("I");
			  MdaUtils.setValues(this.getCptp().getFpdgrp().getRec(),"trscno",codeitem1);
			}
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			IPanel[] panels=this.getCptp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			if(Platform.isFromApp())
			{
			  codeitem1=null;
			  MdaUtils.setValues(this.getCptp().getFpdgrp().getRec(),"trscno",codeitem1);
			}
			//Platform.saveDisplay($cptp\\cptp01,filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cptopn.@0009.script
        */
        @Rule(target="mtabut.sel",order=100)
        public boolean ruleMtabutSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000081"),MdaUtils.getI18NString("cptopn","CT000082"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(index).getCod());
			
			

			return true;
        }

        /**
        *   source:cptopn.@0010.script
        */
        @Rule(target="mtabut.sel1",order=100)
        public boolean ruleMtabutSel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCty().setEngnam(NULLSTR);
			
			
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			//Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			String sql = "SELECT * FROM cty ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			int i=0;
			while(true)
			{
			  i++;
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			log.debug("{}","i="+i);
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:cptopn.@0011.script
        */
        @Rule(target="mtabut.sav1",order=100)
        public boolean ruleMtabutSav1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().setFlg("X");
			if(!ctx.postRule(this,"mtabut.sav"))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:cptopn.@0012.script
        */
        @Rule(target="mtabut.pdapldoc",order=100)
        public boolean ruleMtabutPdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt1);
			

			BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt2);
			

			BigDecimal amt3 = this.getCpdgrp().getRec().getOthamt();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getCpdgrp().getRec().setOthamt(amt3);
			

			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptopn.@0013.script
        */
        @Rule(target="mtabut.mail",order=100)
        public boolean ruleMtabutMailN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("cptopnApp"+inr,"litopn");
			this.getMtabut().creatTcoPdfFile("cptopnDra"+inr);
			this.getMtabut().setAttnames("cptopnApp"+inr+".pdf;cptopnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:cptopn.@0014.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","报关单开始");
			this.getCpdgrp().getApyctmlst().add();
			
			//Platform.clear($cpdgrp\\apyctm\\);
			log.info("{}","报关单结束");

			return true;
        }

        /**
        *   source:cptopn.@0015.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size=this.getCpdgrp().getApyctmlst().fullSize();
			//  log.info(#CT000050+size);
			if(size>0)
			{
			  boolean delflag=false;
			  for(int i=0;i<size;i++ )
			  {
			    if("X".equals(this.getCpdgrp().getApyctmlst().getElement(i).getModflg()))
			    {
			      delflag=true;
			      this.getCpdgrp().getApyctmlst().remove(i);
			      size=this.getCpdgrp().getApyctmlst().fullSize();
			      i--;
			    }
			  }
			  
			  if (!delflag)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000051"),MdaUtils.getI18NString("cptopn","CT000055"));
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0017.script
        */
        @Rule(target="mtabut.sav1",order=200)
        public boolean ruleMtabutSav1N200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.dbRead($cpdgrp\\rec.copyValue($module),new Argument<String>("inr",$cpdgrp\\rec\\inr));
			this.getCpdgrp().getCpdlst().add();
			int index=this.getCpdgrp().getCpdlst().fullSize() - 1;
			this.getCpdgrp().getCpdlst().getElement(index).copyValue(this.getCpdgrp().getRec());
			
			ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000077"),MdaUtils.getI18NString("cptopn","CT000078"));
			this.getTrnmod().ordNew();
			//$cpdgrp\\rec\\ownref.setValue($\\sysmod.getRefrence("OR"));
			//Platform.setModified($cpdgrp\\rec\\ownref);
			this.getCpdgrp().getRec().setRemamt(new BigDecimal(0));
			
			this.getCpdgrp().getRec().setWord(NULLSTR);
			
			this.getCpdgrp().getRec().setBopamt1(new BigDecimal(0));
			
			this.getCpdgrp().getRec().setBopamt2(new BigDecimal(0));
			
			this.getSysmod().setFlg(NULLSTR);
			this.getCpdgrp().getRec().setFxflg(NULLSTR);
			
			this.getCpdgrp().getRec().setFxamt(new BigDecimal(0));
			
			
			this.getCpdgrp().getRec().setFxact(NULLSTR);
			
			
			
			this.getCpdgrp().getRec().setOwnref(NULLSTR);
			
			this.getCpdgrp().getRec().setPurflg(NULLSTR);
			
			this.getCpdgrp().getRec().setPuramt(new BigDecimal(0));
			
			
			this.getCpdgrp().getRec().setPuract(NULLSTR);
			
			
			
			this.getCpdgrp().getRec().setOthflg(NULLSTR);
			
			this.getCpdgrp().getRec().setOthamt(new BigDecimal(0));
			
			
			this.getCpdgrp().getRec().setOthact(NULLSTR);
			
			
			
			MdaUtils.clear(this.getCpdgrp().getApyctmlst());
			

			return true;
        }

        /**
        *   source:cptopn.@0018.script
        */
        @Rule(target="mtabut.done",order=100)
        public boolean ruleMtabutDoneN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCpdlst());
			

			return true;
        }

        /**
        *   source:cptopn.@0001.script
        */
        @Rule(target="cpdgrp.rec.remcur",order=50)
        public boolean ruleCpdgrpRecRemcurN50(){
            IContext ctx = MdaEnv.getContext();
            
			//境内汇款不做人民币
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			  {
			    if(!Platform.isFromApp())
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.remcur",MdaUtils.getI18NString("cptopn","CT000615"));
			      this.getCpdgrp().getRec().setRemcur(NULLSTR);
			      
			    }
			    else
			    {
			      ctx.setMessage("E9999","线上境内汇款不支持人民币类的业务");
			    }
			    return false;
			  }
			}

			//除境外人民币，其它情况购汇、现汇不灰显
			
			
			
			
			//清空资金来源与网银购汇额度编号
			this.getCpdgrp().getRec().setZjly(NULLSTR);
			this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			
			

			this.getCpdgrp().getRec().setBopcur1(this.getCpdgrp().getRec().getRemcur());
			this.getCpdgrp().getRec().setBopcur2(this.getCpdgrp().getRec().getRemcur());
			
			
			if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			  {
			    //境外选择人民币时，默认其它金额
			    this.getCpdgrp().getRec().setFxflg("");
			    
			    this.getCpdgrp().getRec().setPurflg("");
			    
			    this.getCpdgrp().getRec().setOthflg("X");
			    
			    
			    
			    //境外选择人民币时，收款人可输入中文
			    //$cptp\\chagepan.setValue($cptp\\chnadr);
			    //Platform.setModified($cptp\\chagepan);
			  }
			  else
			  {
			    //$cptp\\chagepan.setValue($cptp\\enadr);
			    //Platform.setModified($cptp\\chagepan);
			  }
			  ctx.postRule(this,"cpdgrp.rec.fxflg");
			  ctx.postRule(this,"cpdgrp.rec.purflg");
			  ctx.postRule(this,"cpdgrp.rec.othflg");
			  ctx.postRule(this,"cptp.cpdgrp.rec.remamt");
			}

			Boolean fxflg = TRUE.equals(this.getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCpdgrp().getRec().getPurflg());
			Boolean othflg = TRUE.equals(this.getCpdgrp().getRec().getOthflg());
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt()))
			{
			  if(!fxflg && purflg && !othflg)
			  {
			    this.getCpdgrp().getRec().setPuramt(this.getCpdgrp().getRec().getRemamt());
			    
			    
			    if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			      ctx.postRule(this,"cptp.cpdgrp.rec.puramt");  //触发购汇金额变动事件
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0019.script
        */
        @Rule(target="mtabut.tdapldoc",order=100)
        public boolean ruleMtabutTdapldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt1);
			

			BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt2);
			

			BigDecimal amt3 = this.getCpdgrp().getRec().getOthamt();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getCpdgrp().getRec().setOthamt(amt3);
			

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));
			

			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptopn.@0020.script
        */
        @Rule(target="mtabut.bot",order=100)
        public boolean ruleMtabutBotN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			this.getCptp().getPdfviw().callPDFComponent("","remitdoc","报关单信息",1);

			return true;
        }

        /**
        *   source:cptopn.@0021.script
        */
        @Rule(target="cptp.apldoc",order=100)
        public boolean ruleCptpApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getAtccod()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setIdcard(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0022.script
        */
        @Rule(target="cpdgrp.cpdlst",order=1000)
        public boolean ruleCpdgrpCpdlstN1000(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getIdcard()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setAtccod(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0021.script
        */
        @Rule(target="cpdgrp.rec.atccod",order=100)
        public boolean ruleCpdgrpRecAtccodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getAtccod()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setIdcard(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0022.script
        */
        @Rule(target="cpdgrp.rec.idcard",order=100)
        public boolean ruleCpdgrpRecIdcardN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getIdcard()))
			{
			  
			}
			else
			{
			  this.getCpdgrp().getRec().setAtccod(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0025.script
        */
        @Rule(target="cptp.search",order=100)
        public boolean ruleCptpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCtylst());
			String sql = "SELECT * FROM cty ";
			if(!MdaUtils.isEmpty(this.getCpdgrp().getCty().getEngnam()))
			{
			  String nam = this.getCpdgrp().getCty().getEngnam().toUpperCase();
			  sql = sql+" WHERE alpcod like '%"+nam+"%' or cod like '%"+nam+"%' or engnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%' or chnnam like '%"+this.getCpdgrp().getCty().getEngnam()+"%'";
			}
			sql = sql+" ORDER BY alpcod";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> numcod = new Argument<String>("numcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ctylst len="+this.getCpdgrp().getCtylst().fullSize());
			if(MdaUtils.isEmpty(this.getCpdgrp().getCtylst())  ||  this.getCpdgrp().getCtylst().fullSize()<=0)
			{
			  sql = "SELECT * FROM cty  WHERE numcod like '%"+this.getCpdgrp().getCty().getEngnam() +"%'";
			  sql = sql+" ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			

			return true;
        }

        /**
        *   source:cptopn.@0026.script
        */
        @Rule(target="cptp.sure",order=100)
        public boolean ruleCptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCpdgrp().getCtylst().fullSize();
			if(index < 0   ||   index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000094"),MdaUtils.getI18NString("cptopn","CT000096"));
			  return true;
			}
			this.getCpdgrp().getRec().setPyecry(this.getCpdgrp().getCtylst().getElement(index).getAlpcod());
			this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(index).getCod());
			this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(index).getChnnam());
			
			
			

			return true;
        }

        /**
        *   source:cptopn.@0027.script
        */
        @Rule(target="cpdgrp.rec.remamt",order=100)
        public boolean ruleCpdgrpRecRemamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCpdgrp().getRec().getRemamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt);
			

			return true;
        }

        /**
        *   source:cptopn.@0032.script
        */
        @Rule(target="cptp.fxbut",order=100)
        public boolean ruleCptpFxbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setActchsflg( "fx");
			this.getCptp().popupActchs();

			return true;
        }

        /**
        *   source:cptopn.@0033.script
        */
        @Rule(target="cptp.purbut",order=100)
        public boolean ruleCptpPurbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setActchsflg( "pur");
			this.getCptp().popupActchs();

			return true;
        }

        /**
        *   source:cptopn.@0034.script
        */
        @Rule(target="cptp.othbut",order=100)
        public boolean ruleCptpOthbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().setActchsflg( "oth");
			this.getCptp().popupActchs();

			return true;
        }

        /**
        *   source:cptopn.@0035.script
        */
        @Rule(target="cptp.actsurel",order=100)
        public boolean ruleCptpActsurelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getCptp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000099"),MdaUtils.getI18NString("cptopn","CT000100"));
			  return true;
			}
			if("fx".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setFxact(this.getCptp().getActlst().getElement(index).getAct());
			  
			}
			else if("pur".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setPuract(this.getCptp().getActlst().getElement(index).getAct());
			  
			  ctx.postRule(this,"cpdgrp.rec.puract");
			}
			else if("oth".equals(this.getCptp().getActchsflg()))
			{
			  this.getCpdgrp().getRec().setOthact(this.getCptp().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:cptopn.@0036.script
        */
        @Rule(target="cptp.actcancel",order=100)
        public boolean ruleCptpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptopn.@0050.script
        */
        @Rule(target="cptp.aplp.sure",order=1000)
        public boolean ruleCptpAplpSureN1000(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().setApltel(NULLSTR);
			if(!MdaUtils.isEmpty(this.getCpdgrp().getApl().getAdr().getTel()))
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			

			return true;
        }

        /**
        *   source:cptopn.@0051.script
        */
        @Rule(target="cptp.cpdgrp.apltel",order=100)
        public boolean ruleCptpCpdgrpApltelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getApltel()) && !MdaUtils.isEmpty(this.getCpdgrp().getApl().getAdr().getTel()))
			{
			  this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0062.script
        */
        @Rule(target="cptp.cpdgrp.rec.inoutflg",order=100)
        public boolean ruleCptpCpdgrpRecInoutflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//人民币不能做境内汇款
			if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			{
			  if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			  {
			    if(!Platform.isFromApp())
			    {
			      ctx.setFieldError(this,"cpdgrp.rec.inoutflg",MdaUtils.getI18NString("cptopn","CT000616"));
			      this.getCpdgrp().getRec().setInoutflg(NULLSTR);
			      
			    }
			    else
			    {
			      ctx.setMessage("E9999","线上境内汇款不支持人民币类的业务");
			    }
			    return false;
			  }
			}

			//除境外人民币，其它情况购汇、现汇不灰显
			
			
			
			
			if("CNY".equals(this.getCpdgrp().getRec().getRemcur()))
			{
			  if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			  {
			    //选择人民币境外时，收款人不能输入中文
			    this.getCptp().setChagepan(this.getCptp().getEnadr());
			    
			    this.getCptp().setChangeapl(this.getCptp().getAplenptap());
			    
			    //选择人民币境外时，默认其它金额
			    this.getCpdgrp().getRec().setFxflg("");
			    
			    this.getCpdgrp().getRec().setPurflg("");
			    
			    this.getCpdgrp().getRec().setOthflg("X");
			    
			    
			    
			  }
			}
			else
			{
			  if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			  {
			    //境外选择其它币种时，收款人不能输入中文
			    this.getCptp().setChagepan(this.getCptp().getEnadr());
			    
			    this.getCptp().setChangeapl(this.getCptp().getAplenptap());
			    
			    //币种为人民币之外的情况 ，选择境外
			  }
			}
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{ //境内汇款时，收款人可以输入中文
			  this.getCptp().setChagepan(this.getCptp().getChnadr());
			  
			  this.getCptp().setChangeapl(this.getCptp().getAplcnptap());
			  
			  this.getCpdgrp().getRec().setPyecry("CHN");
			  
			  this.getCpdgrp().setCtydes("中华人民共和国");
			  
			  this.getCpdgrp().setCod("CN");
			}
			else
			{
			  this.getCptp().setChagepan(this.getCptp().getEnadr());
			  
			  this.getCptp().setChangeapl(this.getCptp().getAplenptap());
			  
			  this.getCpdgrp().getRec().setPaytyptxt(NULLSTR);
			  
			  
			}

			//指定名址框语言类型
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getAplp().setLanguage("0");
			  this.getCptp().getBenp().setLanguage("0");
			}
			else if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getAplp().setLanguage("1");
			  this.getCptp().getBenp().setLanguage("1");
			}

			ctx.postRule(this,"cpdgrp.rec.fxflg");
			ctx.postRule(this,"cpdgrp.rec.purflg");
			ctx.postRule(this,"cpdgrp.rec.othflg");
			ctx.postRule(this,"cpdgrp.rec.remamt");

			return true;
        }

        /**
        *   source:cptopn.@0063.script
        */
        @Rule(target="cpdgrp.rec.fxamt",order=100)
        public boolean ruleCpdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			


			return true;
        }

        /**
        *   source:cptopn.@0064.script
        */
        @Rule(target="cpdgrp.rec.puramt",order=100)
        public boolean ruleCpdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getCpdgrp().getRec().getPuramt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt);

			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			{
			  this.getCptp().getFpdgrp().setCur(this.getCptp().getCur1());
			  this.getCptp().getFpdgrp().setAmt(this.getCptp().getCpdgrp().getRec().getPuramt());
			  if(!TRUE.equals(this.getCptp().getFpdgrp().getRec().getCnnsel()))
			  {
			    this.getCptp().getFpdgrp().getRec().setOutamt(this.getCptp().getCpdgrp().getRec().getPuramt());
			    this.getCptp().getFpdgrp().getRec().setOutcur(this.getCptp().getCur1());
			    
			    
			    
			  }
			  else
			    ctx.postRule(this,"cptp.fpdgrp.rec.cnnsel");

			  
			  
			}

			


			return true;
        }

        /**
        *   source:cptopn.@0065.script
        */
        @Rule(target="cpdgrp.rec.othamt",order=100)
        public boolean ruleCpdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			BigDecimal amt = this.getCpdgrp().getRec().getOthamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setOthamt(amt);
			


			return true;
        }

        /**
        *   source:cptopn.@0066.script
        */
        @Rule(target="cpdgrp.rec.bopamt1",order=100)
        public boolean ruleCpdgrpRecBopamt1N100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCpdgrp().getRec().getBopamt1();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setBopamt1(amt);
			compTo();
			


			return true;
        }

        /**
        *   source:cptopn.@0067.script
        */
        @Rule(target="cpdgrp.rec.bopamt2",order=100)
        public boolean ruleCpdgrpRecBopamt2N100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCpdgrp().getRec().getBopamt2();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setBopamt2(amt);

			compTo();
			

			return true;
        }

        /**
        *   source:cptopn.@0070.script
        */
        @Rule(target="cptp.cpdgrp.rec.pyecry",order=100)
        public boolean ruleCptpCpdgrpRecPyecryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//添加功能：可在国家代码框里直接输入国家代码然后会自动带入中文
			String sql = "";
			String nam = this.getCpdgrp().getRec().getPyecry();
			log.info("{}","国家或地区代码为：" +nam );
			if(!MdaUtils.isEmpty(nam))
			{
			  sql = "select alpcod,chnnam from cty where alpcod = '"+ nam +"'";
			  // or cod like '%"+ nam +"%' or numcod like '%"+ nam +"%'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			log.info("{}","执行的SQL为："+ sql);
			Argument<String> alpcod = new Argument<String>("alpcod");
			Argument<String> chnnam = new Argument<String>("chnnam");
			ctx.getDaoSession().dbFetchFields(alpcod,chnnam);
			int error = ctx.getErrorCode();
			if(error == NO_ERROR)
			{
			  this.getCpdgrp().getRec().setPyecry(alpcod.value);
			  this.getCpdgrp().setCtydes(chnnam.value);
			}
			else
			{
			  if(!Platform.isFromApp())
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.pyecry",MdaUtils.getI18NString("cptopn","CT000576"));
			    this.getCpdgrp().setCtydes(NULLSTR);
			    //Platform.setModified($cpdgrp\\ctydes);
			  }
			  else
			  {
			    ctx.setMessage("E9999","请输入正解的国家或地区代码或该地区国家未维护");
			  }
			  log.info("{}","错误代码error为：" + error);
			}
			ctx.getDaoSession().dbCloseCursor();
			
			

			return true;
        }

        /**
        *   source:cptopn.@0074.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			//提交210，保存要预览的pdf资源
			if(MdaUtils.isEmpty(this.getTrnmod().getTrninr()))
			{
			  int cnt = 3;
			  String labels = "普打申请书,套打申请书,报关单";
			  String tempfiles;
			  if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			  {
			    //境内
			    tempfiles = "A:cptopn1,A:tcptopn1,A:remitdoc";
			  }
			  else
			  {
			    //境外
			    tempfiles = "A:cptopn,A:tcptopn,A:remitdoc";
			  }

			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg())||TRUE.equals(this.getCptp().getCpdgrp().getRec().getXhghchk()))
			  {
			    cnt += 1;
			    labels += ",即期售汇申请书";
			    tempfiles += ",A:fptapn";
			  }
			  this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			  this.getTrnmod().getApldoc().generatorAllPDF();
			}

			return true;
        }

        /**
        *   source:cptopn.@0075.script
        */
        @Rule(target="mtabut.pdapldocs",order=100)
        public boolean ruleMtabutPdapldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt1);
			

			BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt2);
			

			BigDecimal amt3 = this.getCpdgrp().getRec().getOthamt();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getCpdgrp().getRec().setOthamt(amt3);
			

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));
			

			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptopn.@0076.script
        */
        @Rule(target="mtabut.tdapldocs",order=100)
        public boolean ruleMtabutTdapldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			BigDecimal amt = this.getCpdgrp().getRec().getFxamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCpdgrp().getRec().setFxamt(amt);
			

			BigDecimal amt1 = this.getCpdgrp().getRec().getPuramt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getCpdgrp().getRec().setPuramt(amt1);
			

			BigDecimal amt2 = this.getCpdgrp().getRec().getRemamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getCpdgrp().getRec().setRemamt(amt2);
			

			BigDecimal amt3 = this.getCpdgrp().getRec().getOthamt();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getCpdgrp().getRec().setOthamt(amt3);
			

			this.getCptp().setDassy(MdaUtils.format(this.getCpdgrp().getRec().getCredat(),"yyyy 年 MM 月 dd 日"));
			

			IStream stream=this.getMtabut().getTdapldoc();

			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","tcptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptopn.@0077.script
        */
        @Rule(target="mtabut.bots",order=100)
        public boolean ruleMtabutBotsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().encode();
			this.getCptp().getPdfviw().callPDFComponent("","remitdoc","报关单信息",1);

			return true;
        }

        /**
        *   source:cptopn.@0078.script
        */
        @Rule(target="cptp.pdfviw.agree",order=100)
        public boolean ruleCptpPdfviwAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCptp().getPdfviw().getChk()))
			{
			  ctx.setFieldError(this,"cptp.pdfviw.chk",MdaUtils.getI18NString("cptopn","CT000601"));
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:cptopn.@0080.script
        */
        @Rule(target="cptp.pdfviw.cancel",order=100)
        public boolean ruleCptpPdfviwCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:cptopn.@0081.script
        */
        @Rule(target="cptp.cpdgrp.rec.rmttyp",order=100)
        public boolean ruleCptpCpdgrpRecRmttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","rmttyp:" + this.getCpdgrp().getRec().getRmttyp());
			if("0".equals(this.getCpdgrp().getRec().getRmttyp()))
			{
			  this.getCpdgrp().setWtranfer("√");
			  this.getCpdgrp().setMtranfer(NULLSTR);
			  this.getCpdgrp().setDtranfer(NULLSTR);
			}
			/*log.debug("rmttyp:" + $cpdgrp\\rec\\rmttyp.getValue());
			  if("0".equals($cpdgrp\\rec\\rmttyp.getValue()))
			  {
			  $cpdgrp\\wtranfer.setValue("√");
			  Platform.clear($cpdgrp\\mtranfer);
			  Platform.clear($cpdgrp\\dtranfer);
			  }
			  else if ("1".equals($cpdgrp\\rec\\rmttyp.getValue()))
			  {
			  $cpdgrp\\dtranfer.setValue("√");
			  Platform.clear($cpdgrp\\mtranfer);
			  Platform.clear($cpdgrp\\wtranfer);
			  }
			  else if("2".equals($cpdgrp\\rec\\rmttyp.getValue()))
			  {
			  $cpdgrp\\mtranfer.setValue("√");
			  Platform.clear($cpdgrp\\dtranfer);
			  Platform.clear($cpdgrp\\wtranfer);
			
			  }*/

			return true;
        }

        /**
        *   source:cptopn.@0082.script
        */
        @Rule(target="mtabut.csche",order=100)
        public boolean ruleMtabutCscheN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn1","境内汇款申请书",1);
			}
			else
			{
			  this.getCptp().getPdfviw().callPDFComponent("","cptopn","境外汇款申请书",1);
			}

			return true;
        }

        /**
        *   source:cptopn.@0083.script
        */
        @Rule(target="mtabut.draftmsg",order=100)
        public boolean ruleMtabutDraftmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().getPdfviw().callSwiftPDFComponent("","cptopn","汇款草稿",1);

			return true;
        }

        /**
        *   source:cptopn.@0003.script
        */
        @Rule(target="cptp.cpdgrp.rec.fxflg",order=100)
        public boolean ruleCptpCpdgrpRecFxflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  //1:True
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getFxflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  else
			  {
			    this.getCptp().getCpdgrp().getRec().setFxamt(new BigDecimal(0));
			    
			    
			    this.getCptp().getCpdgrp().getRec().setFxact(NULLSTR);
			    
			    
			    
			    
			    
			    
			    this.getCpdgrp().getRec().setXhghchk(NULLSTR);
			    
			    ctx.postRule(this,"cpdgrp.rec.xhghchk");
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0004.script
        */
        @Rule(target="cptp.cpdgrp.rec.purflg",order=100)
        public boolean ruleCptpCpdgrpRecPurflgN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getXhghchk()))
			{
			  this.getCptp().getCpdgrp().getRec().setPurflg(NULLSTR);
			  
			  if(Platform.isFromApp())
			  {
			    ctx.setMessage("E9999","已经现汇购汇，无须再购汇");
			  }
			  else
			  {
			    ctx.setFieldError(this,"cptp.cpdgrp.rec.purflg",MdaUtils.getI18NString("cptopn","CT000086"));
			  }

			  return false;
			}
			//1:True
			String steps = "0:汇出汇款申请";
			

			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			{
			  steps =steps+";1:购汇申请";
			  

			  
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puramt);
			  
			  
			  
			  
			  
			  
			  

			  this.getCptp().getFpdgrp().setMessage();

			}
			else
			{
			  

			  this.getCptp().getCpdgrp().getRec().setPuramt(new BigDecimal(0));
			  
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puramt);
			  this.getCptp().getCpdgrp().getRec().setPuract(NULLSTR);
			  
			  
			  
			  
			  
			  
			}
			
			

			this.getCptp().getStpmod().setPages(steps);
			this.getCptp().getStpmod().calcSteps();
			this.getCptp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:cptopn.@0005.script
        */
        @Rule(target="cpdgrp.rec.othflg",order=100)
        public boolean ruleCpdgrpRecOthflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  //1:True
			  if(TRUE.equals(this.getCpdgrp().getRec().getOthflg()))
			  {
			    
			    
			    
			    
			    
			    
			    
			    
			  }
			  else
			  {
			    this.getCpdgrp().getRec().setOthamt(new BigDecimal(0));
			    
			    
			    this.getCpdgrp().getRec().setOthact(NULLSTR);
			    
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0087.script
        */
        @Rule(target="cptp.fpdgrp.rec.cptals",order=100)
        public boolean ruleCptpFpdgrpRecCptalsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getCptp().getFpdgrp().getRec().getCptals()))
			{
			  
			}
			else
			{
			  
			}

			

			return true;
        }

        /**
        *   source:cptopn.@0088.script
        */
        @Rule(target="cptp.stpmod.gostep",order=10)
        public boolean ruleCptpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getCptp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getCptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000619"),MdaUtils.getI18NString("cptopn","CT000620"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!ctx.checkAll(this.getCpdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			    {
			      this.getCptp().getFpdgrp().setCur(this.getCptp().getCur1());
			      this.getCptp().getFpdgrp().setAmt(this.getCpdgrp().getRec().getPuramt());
			      this.getCptp().getFpdgrp().setXhghchk(NULLSTR);
			      
			      
			      
			      this.getCptp().getFpdgrp().setMessage();
			      
			    }
			    else if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getXhghchk()))
			    {
			      this.getCptp().getFpdgrp().setCur(this.getCptp().getCur());
			      this.getCptp().getFpdgrp().setAmt(this.getCpdgrp().getRec().getFxamt());
			      this.getCptp().getFpdgrp().setXhghchk(this.getCpdgrp().getRec().getXhghchk());
			      
			      
			      
			      this.getCptp().getFpdgrp().setMessage();
			      
			      
			      
			    }

			    //刷新购汇金额
			    if(TRUE.equals(this.getCptp().getFpdgrp().getRec().getOutsel()))
			    {
			      ctx.postRule(this,"cptp.fpdgrp.rec.outsel");
			    }
			    else if(TRUE.equals(this.getCptp().getFpdgrp().getRec().getCnnsel()))
			    {
			      ctx.postRule(this,"cptp.fpdgrp.rec.cnnsel");
			    }

			    //compTo();
			    return true;
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getCptp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","gostep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:cptopn.@0089.script
        */
        @Rule(target="cpdgrp.rec.puract",order=100)
        public boolean ruleCpdgrpRecPuractN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuract()))
			{
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    this.getCptp().getFpdgrp().getRec().setCnycno(this.getCpdgrp().getRec().getPuract());
			    
			    
			  }
			}
			

			return true;
        }

        /**
        *   source:cptopn.@0091.script
        */
        @Rule(target="cptp.stpmod.next",order=100)
        public boolean ruleCptpStpmodNextN100(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getCptp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getCptp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000625"),MdaUtils.getI18NString("cptopn","CT000626"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!ctx.checkAll(this.getCpdgrp()))
			    {
			      return false;
			    }
			    //初始化售汇界面
			    if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			    {
			      this.getCptp().getFpdgrp().setCur(this.getCptp().getCur1());
			      this.getCptp().getFpdgrp().setAmt(this.getCpdgrp().getRec().getPuramt());
			      this.getCptp().getFpdgrp().setXhghchk(NULLSTR);
			      
			      
			      
			      this.getCptp().getFpdgrp().setMessage();
			      
			    }
			    else if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getXhghchk()))
			    {
			      this.getCptp().getFpdgrp().setCur(this.getCptp().getCur());
			      this.getCptp().getFpdgrp().setAmt(this.getCpdgrp().getRec().getFxamt());
			      this.getCptp().getFpdgrp().setXhghchk(this.getCpdgrp().getRec().getXhghchk());
			      
			      
			      
			      this.getCptp().getFpdgrp().setMessage();
			      
			      
			      
			    }

			    //刷新购汇金额
			    if(TRUE.equals(this.getCptp().getFpdgrp().getRec().getOutsel()))
			    {
			      ctx.postRule(this,"cptp.fpdgrp.rec.outsel");
			    }
			    else if(TRUE.equals(this.getCptp().getFpdgrp().getRec().getCnnsel()))
			    {
			      ctx.postRule(this,"cptp.fpdgrp.rec.cnnsel");
			    }
			    //compTo();
			    return true;
			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getCptp().getFpdgrp()))
			    {
			      return false;
			    }
			    return true;
			  }
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:cptopn.@0092.script
        */
        @Rule(target="cptp.fpdgrp.fpdpdf",order=100)
        public boolean ruleCptpFpdgrpFpdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal amt = this.getCptp().getFpdgrp().getRec().getOutamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getCptp().getFpdgrp().getRec().setOutamt(amt);
			

			this.getCptp().getPdfviw().callPDFComponent("","fptapn","即期售汇申请书",1);


			return true;
        }

        /**
        *   source:cptopn.@0093.script
        */
        @Rule(target="mtabut.busmod.select",order=110)
        public boolean ruleMtabutBusmodSelectN110(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"cpdgrp.rec.fxflg");
			ctx.postRule(this,"cpdgrp.rec.purflg");
			ctx.postRule(this,"cpdgrp.rec.othflg");

			return true;
        }

        /**
        *   source:cptopn.@0094.script
        */
        @Rule(target="cptp.stpmod.last",order=10)
        public boolean ruleCptpStpmodLastN10(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getCptp().getFpdgrp()))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:cptopn.@0095.script
        */
        @Rule(target="cptp.cpdgrp.rec.xhghchk",order=100)
        public boolean ruleCptpCpdgrpRecXhghchkN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPurflg()))
			{
			  this.getCptp().getCpdgrp().getRec().setXhghchk(NULLSTR);
			  
			  if(!Platform.isFromApp())
			  {
			    ctx.setFieldError(this,"cptp.cpdgrp.rec.xhghchk",MdaUtils.getI18NString("cptopn","CT000635"));
			  }
			  else
			  {
			    ctx.setMessage("E9999","已经购汇，无须再现汇购汇!");
			  }
			  return false;
			}

			//1:True
			String steps = "0:汇出汇款申请";
			

			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getXhghchk()))
			{
			  steps =steps+";1:购汇申请";
			  

			  //Platform.enable($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.enable($cptp\\cpdgrp\\rec\\puract);
			  //Platform.setRequired($cptp\\cpdgrp\\rec\\puract);
			  //Platform.setRequired($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.setDescription($cptp\\cpdgrp\\rec\\puract,#CT000636);
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puract);
			  //Platform.enable($cptp\\purbut);
			  //Platform.setModified($cptp\\purbut);
			
			  this.getCptp().getFpdgrp().setMessage();

			}
			else
			{
			  

			  //Platform.clear($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.disable($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.clear($cptp\\cpdgrp\\rec\\puract);
			  //Platform.disable($cptp\\cpdgrp\\rec\\puract);
			  //Platform.setNotRequired($cptp\\cpdgrp\\rec\\puract);
			  //Platform.setNotRequired($cptp\\cpdgrp\\rec\\puramt);
			  //Platform.setModified($cptp\\cpdgrp\\rec\\puract);
			  //Platform.disable($cptp\\purbut);
			  //Platform.setModified($cptp\\purbut);
			}
			//Platform.setModified($cptp\\cpdgrp\\rec\\puramt);
			

			this.getCptp().getStpmod().setPages(steps);
			this.getCptp().getStpmod().calcSteps();
			this.getCptp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:cptopn.@0096.script
        */
        @Rule(target="cptp.actmod.rmb",order=100)
        public boolean ruleCptpActmodRmbN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:cptopn.@0097.script
        */
        @Rule(target="cptp.accbtn",order=100)
        public boolean ruleCptpAccbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCptp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:cptopn.@0098.script
        */
        @Rule(target="cptp.actmod.actslt",order=100)
        public boolean ruleCptpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getCptp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000637"),MdaUtils.getI18NString("cptopn","CT000638"));
			  return false;
			}
			String rmbact=this.getCptp().getActmod().getActlst().getElement(index).getAct();
			this.getCptp().getFpdgrp().getRec().setCnycno(rmbact);
			
			

			return true;
        }

        /**
        *   source:cptopn.@0101.script
        */
        @Rule(target="mtabut.returnd",order=100)
        public boolean ruleMtabutReturndN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","汇出授权退回");
			this.getMtabut().setThly("尊敬的客户，该笔业务需要调整，请修改或发起新业务后提交审核!");
			//Platform.clear($dtrn);
			//Platform.dbRead($dtrn,new Argument<String>("inr",$trnmod\\trninr.getValue()));
			/*
			  String inr = $cpdgrp\\rec\\inr.getValue();
			  Map sendMap = new HashMap();
			  sendMap.put("MsgNo","SFS112");
			  sendMap.put("inr",inr);
			  sendMap.put("code","SFS112");
			  $mtabut\\swimap.setValue(sendMap);
			  */
			
			log.info("{}","sw back end !");

			return true;
        }

        /**
        *   source:cptopn.@0104.script
        */
        @Rule(target="mtabut.backswi",order=150)
        public boolean ruleMtabutBackswiN150(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000695"),MdaUtils.getI18NString("cptopn","CT000696"));
			ctx.getDaoSession().dbBegin();
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",this.getTrnmod().getTrninr()));
			String frm=this.getTrnmod().getTrn().getInifrm();
			String ownref =this.getTrnmod().getTrn().getOwnref();
			String thly =this.getMtabut().getThly();
			String msgref = this.getCpdgrp().getRec().getMsgref();
			Map sendMap = new HashMap();
			sendMap.put("TransId",this.getCpdgrp().getRec().getTransid());
			sendMap.put("OutBankStatus","");
			sendMap.put("Reason",thly);
			sendMap.put("SendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss"));
			sendMap.put("ImgStatusAll","");
			sendMap.put("buscod",ownref);
			sendMap.put("djcod",ownref);

			//企业退回
			sendMap.put("TransStatus","02");
			if("cptapl".equals(frm))
			{
			  sendMap.put("MsgNo","SFS118");
			  sendMap.put("inr",this.getTrnmod().getTrn().getObjinr());
			  sendMap.put("code","SFS118");
			  sendMap.put(" EntMarkNo",this.getTrnmod().getTrn().getStlref());
			  this.getSysmod().setImageMapSwi(sendMap);
			  this.getSysmod().setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);

			  this.getSwmmod().storeSWM("SFS118",this.getTrnmod().getTrn().getObjinr(),this.getTrnmod().getTrn().getObjtyp(),sendMap);
			}
			else
			{
			  sendMap.put("MsgNo","SFS113");
			  sendMap.put("inr",this.getTrnmod().getTrn().getObjinr());
			  sendMap.put("code","SFS113");
			  sendMap.put("OutBankStatus","");
			  this.getSysmod().setImageMapSwi(sendMap);
			  this.getSysmod().setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);

			  this.getSwmmod().storeSWM("SFS113",this.getTrnmod().getTrn().getObjinr(),this.getTrnmod().getTrn().getObjtyp(),sendMap);
			}

			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","snap file is :"+filename);
			ctx.saveDisplay(filename);
			//$sysmod.insOpeLog($trnmod\\trn\\objtyp.getValue(),$trnmod\\trn\\ownref.getValue());
			this.getTrnmod().getTrn().setSta("A");
			this.getTrnmod().getTrn().setWfm("D");
			this.getTrnmod().getTrn().setPtyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setOptptyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getTrn().setOptetyinr(this.getSysmod().getEty().getInr());
			this.getTrnmod().getTrn().setOptetginr(this.getSysmod().getEtg().getInr());
			this.getTrnmod().getTrn().setCpldattim( MdaUtils.today());
			this.getTrnmod().getTrn().setNxtreq("");

			ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());

			String ordinr=this.getTrnmod().getTrn().getOrdinr();
			this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","8",this.getRmkmod().getNtext());
			String txt= "" ;
			this.getRmkmod().getRmk().setOrdinr(ordinr);
			String userName = ctx.absGet(Sysmod.class).getLoginUserName();
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String roleName = "企业用户";
			if("0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  roleName = "银行柜员";
			}
			txt =roleName + userName + " " + time + " 业务退回单一窗口,退回原因："+this.getMtabut().getThly();
			if(!MdaUtils.isEmpty(this.getRmkmod().getNtext()))
			{
			  txt= txt+ CR + this.getRmkmod().getNtext();
			}
			this.getRmkmod().getRmk().setTxt(txt);
			this.getRmkmod().getRmk().setFlg("");
			this.getRmkmod().getRmk().setTrninr(this.getTrnmod().getTrn().getInr());
			this.getRmkmod().getRmk().setDattim(new Date());
			this.getRmkmod().getRmk().setInr(Platform.sdbCounter("rmk"));
			ctx.getDaoSession().dbInsert(this.getRmkmod().getRmk());
			log.info("{}","新建退回备注：inr = " + this.getRmkmod().getRmk().getInr()+",备注内容="+txt);

			if(ctx.getErrorCode() == ERROR_SQL)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000703"),MdaUtils.getI18NString("cptopn","CT000704"));
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			ctx.getDaoSession().dbCommit();
			this.getMtabut().setThly(NULLSTR);
			

			return true;
        }

        /**
        *   source:cptopn.@0105.script
        */
        @Rule(target="mtabut.imgviw",order=100)
        public boolean ruleMtabutImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}"," in imgviw....");
			this.getTrnmod().getItfmod().getImgmod().imgScans(this.getTrnmod().getTrninr());

			return true;
        }

        /**
        *   source:cptopn.@0110.script
        */
        @Rule(target="cptp.cpdgrp.rec.othamt",order=100)
        public boolean ruleCptpCpdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"othamt"));

			return true;
        }

        /**
        *   source:cptopn.@0123.script
        */
        @Rule(target="cptp.cpdgrp.rec.inoutflg",order=102)
        public boolean ruleCptpCpdgrpRecInoutflgN102(){
            IContext ctx = MdaEnv.getContext();
            
			if("in".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  //境内汇款申请书个别字段填报说明
			  //申报号码
			  

			  //汇款币种及金额
			  
			  

			  //购汇金额
			  
			  //其他金额
			  
			  //账号
			  
			  
			  
			  //汇款附言
			  
			  //国内外费用承担方
			  
			  //收款人常驻国家（地区）名称
			  
			  

			  //交易编码1
			  
			  //交易编码2
			  
			  //相应币种及金额1
			  
			  
			  //相应币种及金额2
			  
			  
			  //本笔款项是否为保税货物项下付款
			  
			  //外汇局批件号/备案表号/业务编号
			  
			  //付汇性质
			  

			  //汇款人名称及地址
			  

			  //收款人名称及地址
			  

			  //交易附言1
			  
			  //交易附言2
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  //境外汇款申请书个别字段填报说明
			  //申报号码
			  
			  //汇款币种及金额
			  
			  
			  //购汇金额
			  
			  //其他金额
			  
			  //账号
			  
			  
			  
			  //汇款附言
			  
			  //国内外费用承担方
			  
			  //收款人常驻国家（地区）名称及代码
			  
			  
			  //交易编码1
			  
			  //交易编码2
			  
			  //相应币种及金额1
			  
			  
			  //相应币种及金额2
			  
			  
			  //交易附言1
			  
			  //交易附言2
			  
			  //外汇局批件号/备案表号/业务编号
			  

			  //汇款人名称及地址
			  

			  //收款人名称及地址
			  

			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  
			  
			  

			}
			//收款银行之代理行名称及地址
			
			
			//收款人开户银行名称及地址
			
			
			//本笔款项是否为保税货物项下付款
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:cptopn.@0137.script
        */
        @Rule(target="cptp.cpdgrp.rec.zjly",order=100)
        public boolean ruleCptpCpdgrpRecZjlyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBchcod()))
			{
			  ctx.setMessage("提示","请先选择归属机构");
			  return false;
			}
			//如果是网银购汇
			MdaUtils.clear(this.getWghmod().getShslst());
			String cid=this.getSysmod().getUsr().getCid();
			String bchcod=this.getCpdgrp().getRec().getBchcod();
			//查询pty
			String ptysql = "select inr,lvl from pty where cid = '"+bchcod+"'";
			Argument<String> inrs = new Argument<String>("inr");
			Argument<String> lvls = new Argument<String>("lvl");
			String inr="";
			String lvl="";
			ctx.getDaoSession().dbExecuteSQL(ptysql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inrs,lvls);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    inr = inrs.getValue();
			    lvl = lvls.getValue();
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			List argVal = new ArrayList();
			String sql="select businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag from shs where  jiehsign !='1' and havegwfed > 0 and applystatus ='3' ";
			sql = sql + " and ecifno = '"+cid+"'";
			//机构隔离
			//分行--可以查看分行及分行以下机构的额度
			if("1".equals(lvl))
			{
			  sql = sql + " AND (bchcod in (select cid from pty where pntinr=bchcod) or bchcod= '"+bchcod+"' ) ";
			}
			//支行--可以查看分本支行的额度
			if("2".equals(lvl))
			{
			  sql = sql + " AND orginr= '"+inr+"' ";
			}
			sql = sql + " order by zcghdat asc";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			Argument<String> businessno = new Argument<String>("businessno");
			Argument<Date> applydat = new Argument<Date>("applydat");
			Argument<String> currency = new Argument<String>("currency");
			Argument<BigDecimal> havesale = new Argument<BigDecimal>("havesale");
			Argument<BigDecimal> havegwfed = new Argument<BigDecimal>("havegwfed");
			Argument<String> applystatus = new Argument<String>("applystatus");
			Argument<Date> zcghnewdat = new Argument<Date>("zcghnewdat");
			Argument<String> lockflag = new Argument<String>("lockflag");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getWghmod().getShslst().add(businessno,applydat,currency,havesale,havegwfed,applystatus,zcghnewdat,lockflag);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			for(int i=0;i<this.getWghmod().getShslst().size();i++)
			{
			  ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),new Argument("edbusno",this.getWghmod().getShslst().getElement(i).getBusinessno()),new Argument("deleted","0"));
			  if(this.getWghmod().getShdlst().fullSize()>0)
			  {
			    StringBuffer str = new StringBuffer();
			    for(int j=0;j<this.getWghmod().getShdlst().fullSize();j++)
			    {
			      str.append(this.getWghmod().getShdlst().getElement(j).getBillnewno()+",");
			    }
			    if(!MdaUtils.isEmpty(str.toString()))
			    {
			      int len = str.toString().length();
			      this.getWghmod().getShslst().getElement(i).setRemark((str.toString()).substring(0,len - 1));
			    }
			  }
			}

			if("2".equals(this.getCpdgrp().getRec().getZjly()))
			{
			  if(this.getWghmod().getShslst().size()>0)
			  {
			    
			  }
			  else
			  {
			    ctx.setMessage("提示","没有符合条件网银购汇额度,请核实！");
			    this.getCpdgrp().getRec().setZjly("1");
			  }
			}
			else
			{
			  if(this.getWghmod().getShslst().size()>0)
			  {
			    if(MdaUtils.prompt(MdaUtils.getI18NString("cptopn","CT000818"),MdaUtils.getI18NString("cptopn","CT000819")))
			    {
			      this.getCpdgrp().getRec().setZjly("1");
			      MdaUtils.clear(this.getWghmod().getShslst());
			      this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			      
			      
			      return false;
			    }
			    this.getCpdgrp().getRec().setZjly("2");
			    
			    
			  }
			  this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			}
			
			
			

			return true;
        }

        /**
        *   source:cptopn.@0138.script
        */
        @Rule(target="wghmod.choose",order=100)
        public boolean ruleWghmodChooseN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getWghmod().getShslst().size();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000808"),MdaUtils.getI18NString("cptopn","CT000809"));
			  return true;
			}
			String flg=this.getWghmod().getShslst().getElement(index).getLockflag();
			if("0".equals(flg))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000810"),MdaUtils.getI18NString("cptopn","CT000811"));
			  return true;
			}
			String businessno=this.getWghmod().getShslst().getElement(index).getBusinessno();
			String rmbfkzh=this.getWghmod().getShslst().getElement(index).getDuifzh();
			this.getCpdgrp().getRec().setWyghedno(businessno);
			if(!ghcheck())
			{
			  this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			  return true;
			}
			if(!fqdlstSearch(rmbfkzh,businessno))
			{
			  return false;
			}
			this.getCpdgrp().getRec().setWyghedno(businessno);
			MdaUtils.clear(this.getWghmod().getShs());
			ctx.getDaoSession().dbRead(this.getWghmod().getShs(),new Argument<String>("businessno",businessno));
			
			
			

			return true;
        }

        /**
        *   source:cptopn.@0139.script
        */
        @Rule(target="wghmod.canel",order=100)
        public boolean ruleWghmodCanelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getRec().setZjly("1");
			
			this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			MdaUtils.clear(this.getWghmod().getShslst());
			

			return true;
        }

        /**
        *   source:cptopn.@0143.script
        */
        @Rule(target="cptp.cpdgrp.rec.bchcod",order=100)
        public boolean ruleCptpCpdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getRec().setZjly(NULLSTR);
			this.getCpdgrp().getRec().setWyghedno(NULLSTR);
			
			

			return true;
        }

        /**
        *   source:cptopn.@0156.script
        */
        @Rule(target="cptp.benp.sure",order=200)
        public boolean ruleCptpBenpSureN200(){
            IContext ctx = MdaEnv.getContext();
            
			if("cptopn".equals(ctx.getTransName()))
			{
			  MdaUtils.clear(this.getTdemod().getPayee());
			  log.info("{}","ptyinr汇出"+this.getCptp().getBenp().getPtspta().getPta().getInr());
			  ctx.getDaoSession().dbRead(this.getTdemod().getPayee(),new Argument<String>("inr",this.getCptp().getBenp().getPtspta().getPta().getInr()));
			  //收款账号
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getPyeact()))
			  {
			    this.getCpdgrp().getRec().setPyeact(this.getTdemod().getPayee().getPyeact());
			  }
			  //代理行
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getRcpnam())||!MdaUtils.isEmpty(this.getTdemod().getPayee().getRcpswtcod()))
			  {
			    this.getCptp().getRcpp().getPtspta().getPts().setAdrblk(this.getTdemod().getPayee().getRcpnam()+"\n"+this.getTdemod().getPayee().getRcpswtcod());
			  }
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getRcpswtnam()))
			  {
			    this.getCptp().getRcpp().getPtspta().getPts().setExtkey(this.getTdemod().getPayee().getRcpswtnam());

			  }
			  // 开户行
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getAcwnam())||!MdaUtils.isEmpty(this.getTdemod().getPayee().getSwtcod()))
			  {
			    this.getCptp().getAcwp().getPtspta().getPts().setAdrblk(this.getTdemod().getPayee().getAcwnam()+"\n"+this.getTdemod().getPayee().getSwtcod());
			  }
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getSwtnam()))
			  {
			    this.getCptp().getAcwp().getPtspta().getPts().setExtkey(this.getTdemod().getPayee().getSwtnam());
			  }
			  //代理行账号
			  if(!MdaUtils.isEmpty(this.getTdemod().getPayee().getRcpact()))
			  {
			    this.getCpdgrp().getRcp().getPts().setRef(this.getTdemod().getPayee().getRcpact());

			  }
			  log.info("{}","测试0"+this.getCpdgrp().getRec().getPyeact());
			  log.info("{}","测试0"+this.getCptp().getRcpp().getPtspta().getPts().getAdrblk());
			  
			  
			  
			  
			  
			  
			}

			return true;
        }


        /**
        *   source:cptopn.@0037.script
        */
        @Check(target="cpdgrp.rcp.pts.ref",order=100)
        public boolean checkCpdgrpRcpPtsRefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRcp().getPts().getRef()))
			{
			  String ref = this.getCpdgrp().getRcp().getPts().getRef();
			  if( ref.length()>34)
			  {
			    ctx.setFieldError(this,"cpdgrp.rcp.pts.ref",MdaUtils.getI18NString("cptopn","CT000104"));
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0038.script
        */
        @Check(target="cpdgrp.rcp.pts.extkey",order=100)
        public boolean checkCpdgrpRcpPtsExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRcp().getPts().getExtkey()))
			{
			  String extkey = this.getCpdgrp().getRcp().getPts().getExtkey();
			  if(extkey.length()>11)
			  {
			    ctx.setFieldError(this,"cpdgrp.rcp.pts.extkey",MdaUtils.getI18NString("cptopn","CT000109"));
			  }
			}

			return true;
        }

        /**
        *   source:cptopn.@0041.script
        */
        @Check(target="cptp.cpdgrp.rec.bopcod1",order=100)
        public boolean checkCptpCpdgrpRecBopcod1N100(){
            IContext ctx = MdaEnv.getContext();
            
			String bopcod1 = this.getCpdgrp().getRec().getBopcod1();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod1()) && !bopcod1.matches("\\d{6}"))
			{
			  ctx.setFieldError(this,"cpdgrp.rec.bopcod1",MdaUtils.getI18NString("cptopn","CT000115"));
			  return false;
			}

			/*  if(Platform.isEmpty($cpdgrp\\rec\\bopcod1))
			  {
			  Platform.error($cpdgrp\\rec\\bopcod1,#CT000793);
			  return false;
			  }
			  */

			return true;
        }

        /**
        *   source:cptopn.@0042.script
        */
        @Check(target="cptp.cpdgrp.rec.bopcod2",order=100)
        public boolean checkCptpCpdgrpRecBopcod2N100(){
            IContext ctx = MdaEnv.getContext();
            
			String bopcod2 = this.getCpdgrp().getRec().getBopcod2();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod2()) )
			{
			  
			  
			  if(!bopcod2.matches("\\d{6}"))
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.bopcod2",MdaUtils.getI18NString("cptopn","CT000117"));
			    return false;
			  }
			}
			else
			{
			  
			  
			  this.getCpdgrp().getRec().setBopamt2(new BigDecimal(0));
			  this.getCpdgrp().getRec().setBopinf2(NULLSTR);
			  
			  
			}


			return true;
        }

        /**
        *   source:cptopn.@0049.script
        */
        @Check(target="cpdgrp.rec.remamt",order=100)
        public boolean checkCpdgrpRecRemamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			Boolean fxflg = TRUE.equals(this.getCpdgrp().getRec().getFxflg());
			Boolean purflg = TRUE.equals(this.getCpdgrp().getRec().getPurflg());
			Boolean othflg = TRUE.equals(this.getCpdgrp().getRec().getOthflg());
			checkSumAmt(fxflg,purflg,othflg);

			return true;
        }

        /**
        *   source:cptopn.@0061.script
        */
        @Check(target="cptp.cpdgrp.rec.othact",order=100)
        public boolean checkCptpCpdgrpRecOthactN100(){
            IContext ctx = MdaEnv.getContext();
            
			String othact=this.getCptp().getCpdgrp().getRec().getOthact();
			if(!MdaUtils.isEmpty(othact) && othact.length()>21)
			{
			  ctx.setFieldError(this,"cptp.cpdgrp.rec.othact",MdaUtils.getI18NString("cptopn","CT000515"));
			}

			return true;
        }

        /**
        *   source:cptopn.@0071.script
        */
        @Check(target="cptp.cpdgrp.rec.pyecry",order=100)
        public boolean checkCptpCpdgrpRecPyecryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String pyecry = this.getCpdgrp().getRec().getPyecry();
			String sql = "select alpcod from cty where alpcod = '" + pyecry +"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> alpcod = new Argument<String>("alpcod");
			ctx.getDaoSession().dbFetchFields(alpcod);
			int error = ctx.getErrorCode();
			if(error != NO_ERROR)
			{
			  ctx.setFieldError(this,"cpdgrp.rec.pyecry",MdaUtils.getI18NString("cptopn","CT000592"));
			  log.info("{}","error+++" + error);
			}
			ctx.getDaoSession().dbCloseCursor();


			return true;
        }

        /**
        *   source:cptopn.@0084.script
        */
        @Check(target="cptp.cpdgrp.rec.inoutflg",order=101)
        public boolean checkCptpCpdgrpRecInoutflgN101(){
            IContext ctx = MdaEnv.getContext();
            
			//“汇款类型”为“境外”，“汇款币种”为“CNY”时，金额仅能选取“其他金额”
			/*if("out".equals($cpdgrp\\rec\\inoutflg.getValue())&&"CNY".equals($cpdgrp\\rec\\remcur.getValue()))
			  {
			  if(!"X".equals($cpdgrp\\rec\\othflg.getValue()))
			  {
			  Platform.error($cpdgrp\\rec\\othflg,#CT000608);
			  }
			  else if("X".equals($cpdgrp\\rec\\purflg.getValue())||"X".equals($cpdgrp\\rec\\fxflg.getValue())||("X".equals($cpdgrp\\rec\\purflg.getValue())&&"X".equals($cpdgrp\\rec\\fxflg.getValue())))
			  {
			  Platform.error($cpdgrp\\rec\\othflg,#CT000609);
			  }
			  }*/

			return true;
        }

        /**
        *   source:cptopn.@0085.script
        */
        @Check(target="cptp.cpdgrp.rec.remcur",order=100)
        public boolean checkCptpCpdgrpRecRemcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			//“汇款类型”为“境外”，“汇款币种”为“CNY”时，金额仅能选取“其他金额”
			/* if("out".equals($cpdgrp\\rec\\inoutflg.getValue())&&"CNY".equals($cpdgrp\\rec\\remcur.getValue()))
			  {
			  if(!"X".equals($cpdgrp\\rec\\othflg.getValue()))
			  {
			  Platform.error($cpdgrp\\rec\\othflg,#CT000610);
			  }
			  else if("X".equals($cpdgrp\\rec\\purflg.getValue())||"X".equals($cpdgrp\\rec\\fxflg.getValue())||("X".equals($cpdgrp\\rec\\purflg.getValue())&&"X".equals($cpdgrp\\rec\\fxflg.getValue())))
			  {
			  Platform.error($cpdgrp\\rec\\othflg,#CT000611);
			  }
			  }*/

			return true;
        }

        /**
        *   source:cptopn.@0111.script
        */
        @Check(target="cptp.cpdgrp.rec.remamt",order=100)
        public boolean checkCptpCpdgrpRecRemamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"remamt"));

			return true;
        }

        /**
        *   source:cptopn.@0112.script
        */
        @Check(target="cptp.cpdgrp.rec.fxamt",order=100)
        public boolean checkCptpCpdgrpRecFxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"fxamt"));

			return true;
        }

        /**
        *   source:cptopn.@0113.script
        */
        @Check(target="cptp.cpdgrp.rec.puramt",order=100)
        public boolean checkCptpCpdgrpRecPuramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"puramt"));

			return true;
        }

        /**
        *   source:cptopn.@0114.script
        */
        @Check(target="cptp.cpdgrp.rec.othamt",order=100)
        public boolean checkCptpCpdgrpRecOthamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"othamt"));

			return true;
        }

        /**
        *   source:cptopn.@0115.script
        */
        @Check(target="cptp.cpdgrp.rec.bopamt1",order=100)
        public boolean checkCptpCpdgrpRecBopamt1N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($cptp\\cpdgrp\\rec\\bopamt1))
			  {
			  Platform.error($cpdgrp\\rec\\bopamt1,#CT000794);
			  return false;
			  }
			  */
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"bopamt1"));

			return true;
        }

        /**
        *   source:cptopn.@0116.script
        */
        @Check(target="cptp.cpdgrp.rec.bopamt2",order=100)
        public boolean checkCptpCpdgrpRecBopamt2N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"bopamt2"));

			return true;
        }

        /**
        *   source:cptopn.@0129.script
        */
        @Check(target="cptp.cpdgrp.rec.bopinf1",order=100)
        public boolean checkCptpCpdgrpRecBopinf1N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($cptp\\cpdgrp\\rec\\bopinf1))
			  {
			  Platform.error($cptp\\cpdgrp\\rec\\bopinf1,#CT000795);
			  return false;
			  }
			  */

			return true;
        }

        /**
        *   source:cptopn.@0130.script
        */
        @Check(target="cptp.cpdgrp.rec.invno",order=100)
        public boolean checkCptpCpdgrpRecInvnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($cptp\\cpdgrp\\rec\\invno))
			  {
			  Platform.error($cptp\\cpdgrp\\rec\\invno,#CT000796);
			  return false;
			  }
			  */

			return true;
        }

        /**
        *   source:cptopn.@0131.script
        */
        @Check(target="cptp.cpdgrp.rec.conno",order=100)
        public boolean checkCptpCpdgrpRecConnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($cptp\\cpdgrp\\rec\\conno))
			  {
			  Platform.error($cptp\\cpdgrp\\rec\\conno,#CT000797);
			  return false;
			  }
			  */

			return true;
        }


        /**
        *   source:cptopn.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!Platform.isFromApp())
			{
			  this.showReadTet();
			}
			log.debug("{}","init cptopn ="+this.getCpdgrp().getRec().getRemcur());
			//归属机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			

			//ord
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			IModule cpd = (IModule)ctx.restoreData("com.brilliance.cptopn.ref");
			if(!MdaUtils.isEmpty(cpd))
			{
			  this.getCpdgrp().getRec().copyValue(cpd);
			  String trninr=(String)ctx.restoreData("com.brilliance.inr.ref");
			  this.getTrnmod().setTrninr(trninr);
			  log.debug("{}","trninr  is   :"+this.getTrnmod().getTrninr());
			  this.setDisale();
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getFxflg());
			    this.getCpdgrp().getRec().setFxflg("X");

			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getPurflg());
			    this.getCpdgrp().getRec().setPurflg("X");
			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getOthamt()))
			  {
			    log.debug("{}","标识测试"+this.getCpdgrp().getRec().getOthflg());
			    this.getCpdgrp().getRec().setOthflg("X");
			  }

			  this.getCptp().setCptlab("跨境汇款申请");
			  String cur=this.getCpdgrp().getRec().getRemcur();
			  this.getCptp().setCur1(cur);
			  this.getCptp().setCur(cur);
			  this.getCptp().setCur2(cur);
			  this.getCpdgrp().getRec().setBopcur1(cur);
			  this.getCpdgrp().getRec().setBopcur2(cur);
			  //if(Platform.isEmpty($cpdgrp\\rec\\rmttyp))
			  //{
			  this.getCpdgrp().getRec().setRmttyp("0");
			  /*}
			    else
			    {
			    if(!"1".equals($cpdgrp\\rec\\rmttyp.getValue())&&!"2".equals($cpdgrp\\rec\\rmttyp.getValue())&&!"3".equals($cpdgrp\\rec\\rmttyp.getValue())&&!"0".equals($cpdgrp\\rec\\rmttyp.getValue()))
			    {
			    if("01".equals($cpdgrp\\rec\\rmttyp.getValue()))
			    $cpdgrp\\rec\\rmttyp.setValue("0");
			    else if ("02".equals($cpdgrp\\rec\\rmttyp.getValue()))
			    $cpdgrp\\rec\\rmttyp.setValue("1");
			    else if ("03".equals($cpdgrp\\rec\\rmttyp.getValue()))
			    $cpdgrp\\rec\\rmttyp.setValue("2");
			    else
			    $cpdgrp\\rec\\rmttyp.setValue("3");
			    }
			    }*/
			  
			  this.getCpdgrp().getRec().setInoutflg("out");

			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getTransid()))
			  {
			    this.getCpdgrp().getRec().setTransid(this.getCpdgrp().getRec().getOwnref());
			    
			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemamt())&&!MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			  {
			    String amt = this.getSysmod().covCnAmt(this.getCpdgrp().getRec().getRemamt(),this.getCpdgrp().getRec().getRemcur());
			    this.getCpdgrp().getRec().setWord(amt);
			  }
			  this.setApyctm("cpd",this.getCpdgrp().getRec().getInr());
			  return true;
			}

			
			
			
			
			
			
			
			
			
			
			this.getCptp().setCptlab("汇出汇款申请");

			
			
			//汇款方式默认为电汇，不允许修改
			
			//Platform.setModified($cpdgrp\\rec\\rmttyp);
			
			

			// 增加汇款类型的处理
			if("out".equals(this.getCpdgrp().getRec().getInoutflg()))
			{
			  this.getCpdgrp().getRec().setPaytyptxt(NULLSTR);
			  
			  
			}

			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P") || ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //使用退回功能时判断
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }

			  //log.debug("$cpdgrp\\rec\\remcur.getValue()="+$cpdgrp\\rec\\remcur.getValue());
			  if((ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P"))&& !MdaUtils.isEmpty(this.getCpdgrp().getRec().getRemcur()))
			  {
			    //log.debug("B/P 状态下的remcur "+$cpdgrp\\rec\\remcur.getValue());
			    this.getCptp().setCur(this.getCpdgrp().getRec().getRemcur());
			    this.getCptp().setCur1(this.getCpdgrp().getRec().getRemcur());
			    this.getCptp().setCur2(this.getCpdgrp().getRec().getRemcur());
			    
			    
			    
			    ctx.postRule(this,"cpdgrp.rec.inoutflg");
			    ctx.postRule(this,"cpdgrp.rec.remcur");
			    ctx.postRule(this,"cpdgrp.rec.fxflg");
			    ctx.postRule(this,"cpdgrp.rec.purflg");
			    ctx.postRule(this,"cpdgrp.rec.othflg");
			  }

			  if( !MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopamt1()))
			  {
			    BigDecimal amt1 = this.getCpdgrp().getRec().getBopamt1();
			    amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			    this.getCpdgrp().getRec().setBopamt1(amt1);
			    

			    BigDecimal amt2 = this.getCpdgrp().getRec().getBopamt2();
			    amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			    this.getCpdgrp().getRec().setBopamt2(amt2);
			    
			    //log.debug("B/P 状态下的bopamt1="+$cpdgrp\\rec\\bopamt1.getValue());
			  }

			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getIdcard()))
			  {
			    this.getCptp().setToper("√");
			    
			  }
			  if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getAtccod()))
			  {
			    this.getCptp().setTopub("√");
			    
			  }

			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			    ctx.postRule(this,"cptp.fpdgrp.rec.cptals");

			  return true;
			}
			//初始化汇款方式限制
			if(!Platform.isFromApp())
			{
			  if(!"D".equals(this.getCpdgrp().getRec().getCpdres()))
			    this.getCpdgrp().getRec().setFxflg("X");
			}
			ctx.postRule(this,"cpdgrp.rec.fxflg");
			ctx.postRule(this,"cpdgrp.rec.purflg");
			ctx.postRule(this,"cpdgrp.rec.othflg");

			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			
			//Platform.disable($cpdgrp\\rec\\ownref);
			// 查询对公组织代码和报关单代码
			this.getCpdgrp().getRec().setAtccod(this.getSysmod().getPty().getAtccod());
			this.getCptp().setTopub("√");
			this.getCpdgrp().getRec().setBopcod(this.getSysmod().getPty().getBopcod());
			log.debug("{}","初始化直接申请人pts========");
			this.getCpdgrp().getDap().initDap("cpd");
			//$cpdgrp\\apl\\pts.copyValue($cpdgrp\\dap\\pts);
			//$cpdgrp\\apl\\adr.copyValue($cpdgrp\\dap\\adr);
			this.getCpdgrp().getApl().copyValues(this.getCpdgrp().getDap());
			this.getCpdgrp().getApl().getPts().setRol("apl");
			//申请人修改为英文
			log.debug("{}","第一行：" +this.getCpdgrp().getApl().getPty().getEngnam() );
			this.getCptp().getAplp().getPtspta().getPts().setAdrblk(this.getCpdgrp().getApl().getPty().getEngnam() + CR + this.getCpdgrp().getApl().getAdr().getEnadr());
			//$cptp\\aplp\\ptspta\\pts\\adrblk=$cpdgrp\\apl\\pty\\engnam.getValue() + CR + $\\sysmod\\pty\\engnam.getValue();
			
			//$cpdgrp\\apl\\pts\\rol.setValue("apl");
			this.getCpdgrp().getRec().setRemcur("USD");
			this.getCpdgrp().getRec().setRmttyp("0");
			this.getCpdgrp().setWtranfer("√");
			this.getCpdgrp().getRec().setInoutflg("out");
			this.getCpdgrp().getRec().setPaytyptxt(NULLSTR);
			
			
			this.getCpdgrp().getRec().setPriority("Normal");
			this.getCpdgrp().getRec().setBopcur1("USD");
			this.getCpdgrp().getRec().setBopcur2("USD");
			if(!MdaUtils.isEmpty(this.getSysmod().getPty().getActtyp()))
			  this.getCptp().setActtyp(this.getSysmod().getPty().getActtyp());
			else
			  this.getCptp().setActtyp("1");
			//Platform.setRequired($cpdgrp\\apl\\pts\\extkey);
			
			//Platform.setRequired($cpdgrp\\acw\\pts\\extkey);
			//Platform.setRequired($cpdgrp\\acw\\pts\\adrblk);
			this.getCpdgrp().getRec().setPaytyp("Others");
			//$cpdgrp\\rec\\paytyptxt.setValue("6");
			this.getCptp().setPaytyptxt(NULLSTR);
			this.getCpdgrp().getRec().setCavpayflg("N");
			this.getCpdgrp().getRec().setDetchgcod("SHA");
			
			
			//disable常用账户选择按钮
			
			
			//Platform.disable($cpdgrp\\rec\\fxact);
			//Platform.disable($cpdgrp\\rec\\fxamt);
			
			
			//Platform.setRequired($cptp\\acwp\\ptspta\\pts\\adrblk);
			this.getCpdgrp().getRec().setBopcur1("USD");
			this.getCpdgrp().getRec().setBopcur2("USD");
			this.getCptp().setCur("USD");
			this.getCptp().setCur1("USD");
			this.getCptp().setCur2("USD");
			this.getCpdgrp().setCtydes(NULLSTR);
			this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			
			log.debug("{}","pty inr==="+this.getSysmod().getPty().getInr());
			log.debug("{}","aplnam==="+this.getCpdgrp().getAplnam());
			this.getCpdgrp().setApltel(this.getCpdgrp().getApl().getAdr().getTel());
			
			

			this.getCpdgrp().setOprnam(this.getSysmod().getUsr().getOprnam());
			
			if(!Platform.isFromApp())
			{
			  MdaUtils.clear(this.getCpdgrp().getCtylst());
			  //Platform.dbReadset($cpdgrp\\ctylst,new Argument<String>("engnam",OR));
			  String sql = "SELECT * FROM cty ORDER BY alpcod";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> cod = new Argument<String>("cod");
			  Argument<String> alpcod = new Argument<String>("alpcod");
			  Argument<String> numcod = new Argument<String>("numcod");
			  Argument<String> chnnam = new Argument<String>("chnnam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  int i=0;
			  while(true)
			  {
			    i++;
			    ctx.getDaoSession().dbFetchFields(inr,cod,alpcod,numcod,chnnam,engnam);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      this.getCpdgrp().getCtylst().add(inr,cod,alpcod,numcod,chnnam,engnam);
			    else
			      break;
			  }
			  log.debug("{}","ctylst.size = "+ this.getCpdgrp().getCtylst().size());
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			ctx.postRule(this,"cpdgrp.rec.inoutflg");
			ctx.postRule(this,"cpdgrp.rec.remcur");
			


			return true;
        }

        /**
        *   source:cptopn.@0086.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","cptopn  init业务处理开始，order:90");
			//0、进口承兑/付款/拒付申请   1、购汇申请
			this.getCptp().getStpmod().storePanel(this.getCptp().getCpt01(),this.getCptp().getCpt02());
			//String steps = "0:进口承兑/付款/拒付申请";
			String steps = "0:汇出汇款申请";
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			  {
			    steps =steps+";1:购汇申请";
			    
			  }
			  else
			  {
			    
			  }
			}
			
			this.getCptp().getStpmod().setPages(steps);
			this.getCptp().getStpmod().calcSteps();
			this.getCptp().getStpmod().setStepBtnSta();
			ctx.postRule(this,"cptp.cpdgrp.rec.inoutflg");


			return true;
        }

        /**
        *   source:cptopn.@0121.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			//初始化ownref
			log.debug("{}","prefix"+this.getMtabut().getPrefix());
			if(Platform.isFromApp()&&MdaUtils.isEmpty(this.getCpdgrp().getRec().getOwnref()))
			{
			  if("ZX".equals(this.getMtabut().getPrefix()))
			    return false;
			  else
			    getref1();
			}

			return true;
        }


        /**
        *   source:cptopn.@0044.script
        */
        public void checkAndSetAmt2(BigDecimal amt ,String amtname1,String amtname2)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal remamt = this.getCpdgrp().getRec().getRemamt();
			BigDecimal setamt = remamt.subtract(amt);
			setamt = MdaUtils.parseDecimal(MdaUtils.format(setamt,"#0.00"));
			if(remamt.compareTo(amt) < 0)
			{
			  if("fxamt".equals(amtname1))
			    ctx.setFieldError(this,"cpdgrp.rec.fxamt",MdaUtils.getI18NString("cptopn","CT000483"));
			  else if("puramt".equals(amtname1))
			    ctx.setFieldError(this,"cpdgrp.rec.puramt",MdaUtils.getI18NString("cptopn","CT000484"));
			  else if("othamt".equals(amtname1))
			    ctx.setFieldError(this,"cpdgrp.rec.othamt",MdaUtils.getI18NString("cptopn","CT000485"));
			}
			else
			{
			  if("fxamt".equals(amtname2))
			    this.getCpdgrp().getRec().setFxamt(setamt);
			  else if("puramt".equals(amtname2))
			    this.getCpdgrp().getRec().setPuramt(setamt);
			  else if("othamt".equals(amtname2))
			    this.getCpdgrp().getRec().setOthamt(setamt);
			}
		}
        /**
        *   source:cptopn.@0045.script
        */
        public void checkAndSetAmt3(BigDecimal amt1 ,BigDecimal amt2 ,String amtname1 ,String amtname2 ,String amtname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","cptopn.checkAndSetAmt3 start:");
			log.debug("{}","amt1:" + amt1 + ",amtname1:" + amtname1);
			log.debug("{}","amt2:" + amt2 + ",amtname2:" + amtname2);
			log.debug("{}","amtname:" + amtname);

			BigDecimal remamt = this.getCpdgrp().getRec().getRemamt();
			BigDecimal sum = amt1.add(amt2);
			BigDecimal setamt = remamt.subtract(sum);
			setamt = MdaUtils.parseDecimal(MdaUtils.format(setamt,"#0.00"));
			if(remamt.compareTo(sum) < 0)
			{
			  if("fxamt".equals(amtname1) && "puramt".equals(amtname2))
			    ctx.setFieldError(this,"cpdgrp.rec.fxamt",MdaUtils.getI18NString("cptopn","CT000486"));
			  else if("fxamt".equals(amtname1) && "othamt".equals(amtname2))
			    ctx.setFieldError(this,"cpdgrp.rec.fxamt",MdaUtils.getI18NString("cptopn","CT000487"));
			  else if("puramt".equals(amtname1) && "othamt".equals(amtname2))
			    ctx.setFieldError(this,"cpdgrp.rec.puramt",MdaUtils.getI18NString("cptopn","CT000488"));
			}
			else
			{
			  if("fxamt".equals(amtname))
			    this.getCpdgrp().getRec().setFxamt(setamt);
			  else if("puramt".equals(amtname))
			    this.getCpdgrp().getRec().setPuramt(setamt);
			  else if("othamt".equals(amtname))
			    this.getCpdgrp().getRec().setOthamt(setamt);
			}
			log.debug("{}","fxamt:" + this.getCpdgrp().getRec().getFxamt());
			log.debug("{}","puramt:" + this.getCpdgrp().getRec().getPuramt());
			log.debug("{}","othamt:" + this.getCpdgrp().getRec().getOthamt());
			log.debug("{}","cptopn.checkAndSetAmt3 end!");
		}
        /**
        *   source:cptopn.@0047.script
        */
        public void geneBGDPdf(String trnname , String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trnname))
			  return;
			Map<String,Object> data = new HashMap<String,Object>();
			// 对报关单单独进行处理
			int size = this.getCpdgrp().getApyctmlst().size();
			Object[] atcnum = new Object[size];
			Object[] atccur = new Object[size];
			Object[] atcamt = new Object[size];
			Object[] chkcur = new Object[size];
			Object[] chkamt = new Object[size];
			for(int i=0 ;i<size;i++)
			{
			  atcnum[i] = this.getCpdgrp().getApyctmlst().getElement(i).getAtcnum();
			  atccur[i] = this.getCpdgrp().getApyctmlst().getElement(i).getAtccur();
			  atcamt[i] = this.getCpdgrp().getApyctmlst().getElement(i).getAtcamt();
			  chkcur[i] = this.getCpdgrp().getApyctmlst().getElement(i).getChkcur();
			  chkamt[i] = this.getCpdgrp().getApyctmlst().getElement(i).getChkamt();
			}
			data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			data.put("atcnum.f",atcnum);
			data.put("atccur.f",atccur);
			data.put("atcamt.f",atcamt);
			data.put("chkcur.f",chkcur);
			data.put("chkamt.f",chkamt);

			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfFile+".pdf");
			String logofile = this.getSysmod().getEtyLgnUrl(null);
			String signFile = this.getSysmod().getEtySeaUrl(null);
			data.put("signfile",signFile);
			log.info("{}","logofile====="+logofile );
			log.info("{}","pdffile====="+pdffile );
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,data,logofile,stream);

		}
        /**
        *   source:cptopn.@0048.script
        */
        public void checkSumAmt(Boolean fxflg,Boolean purflg,Boolean othflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","cptopn.remamtCheck start:");
			if(fxflg || purflg || othflg)
			{
			  BigDecimal sumamt = new BigDecimal("0");

			  if(fxflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getFxamt());
			    log.debug("{}","fxamt:" + this.getCpdgrp().getRec().getFxamt());
			    log.debug("{}","sumamt(fxamt):" + sumamt);
			  }
			  if(purflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getPuramt());
			    log.debug("{}","puramt:" + this.getCpdgrp().getRec().getPuramt());
			    log.debug("{}","sumamt(puramt):" + sumamt);
			  }
			  if(othflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getOthamt());
			    log.debug("{}","othamt:" + this.getCpdgrp().getRec().getOthamt());
			    log.debug("{}","sumamt(othamt):" + sumamt);
			  }
			  log.debug("{}","remamt:" + this.getCpdgrp().getRec().getRemamt());
			  log.debug("{}","sumamt:" + sumamt);

			  if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getCpdgrp().getRec().getRemamt()).compareTo(sumamt)!=0)
			  {
			    ctx.setFieldError(this,"cpdgrp.rec.remamt",MdaUtils.getI18NString("cptopn","CT000505"));
			  }
			}
			log.debug("{}","cptopn.remamtCheck end!");
		}
        /**
        *   source:cptopn.@0090.script
        */
        public void compTo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal bop1=this.getCpdgrp().getRec().getBopamt1();
			BigDecimal bop2=this.getCpdgrp().getRec().getBopamt2();
			if(TRUE.equals(this.getCptp().getCpdgrp().getRec().getPurflg()))
			{
			  if(!MdaUtils.isEmpty(bop1) && !MdaUtils.isEmpty(bop2))
			  {
			    if(bop2.compareTo(bop1)>0)
			    {
			      this.getCptp().getFpdgrp().getRec().setTrscno(this.getCpdgrp().getRec().getBopcod2());
			      this.getCptp().getFpdgrp().getRec().setTrstxt(this.getCpdgrp().getRec().getBopinf2());
			    }
			    else
			    {
			      this.getCptp().getFpdgrp().getRec().setTrscno(this.getCpdgrp().getRec().getBopcod1());
			      this.getCptp().getFpdgrp().getRec().setTrstxt(this.getCpdgrp().getRec().getBopinf1());
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(bop2))
			    {
			      this.getCptp().getFpdgrp().getRec().setTrscno(this.getCpdgrp().getRec().getBopcod2());
			      this.getCptp().getFpdgrp().getRec().setTrstxt(this.getCpdgrp().getRec().getBopinf2());
			    }
			    else
			    {
			      this.getCptp().getFpdgrp().getRec().setTrscno(this.getCpdgrp().getRec().getBopcod1());
			      this.getCptp().getFpdgrp().getRec().setTrstxt(this.getCpdgrp().getRec().getBopinf1());
			    }
			  }
			}
			
			
		}
        /**
        *   source:cptopn.@0099.script
        */
        public void setDisale()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.disable($cpdgrp\\rec\\bchcod);
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			
			
			

			
			
			

			
			
			

			ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","apl"));
			
			
			

			ctx.getDaoSession().dbRead(this.getCpdgrp().getAcw().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","acw"));
			
			
			

			ctx.getDaoSession().dbRead(this.getCpdgrp().getRcp().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","rcp"));
			
			
			

			ctx.getDaoSession().dbRead(this.getCpdgrp().getPay().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","pay"));
			
			
			

			this.getCptp().setChagepan(this.getCptp().getChnadr());
			
			ctx.getDaoSession().dbRead(this.getCpdgrp().getBen().getPts(),new Argument<String>("objinr",this.getCpdgrp().getRec().getInr()),new Argument<String>("objtyp","cpd"),new Argument<String>("rol","ben"));
			
			
			

			
			
			
			
			
			

			this.getCpdgrp().setCtydes(this.getCpdgrp().getRec().getCountryname());

			/*if("T".equals($cpdgrp\\rec\\cavpayflg.getValue().trim()))
			  $cpdgrp\\rec\\cavpayflg.setValue("Y");
			  else if("F".equals($cpdgrp\\rec\\cavpayflg.getValue().trim()))
			  $cpdgrp\\rec\\cavpayflg.setValue("N");
			  else
			  $cpdgrp\\rec\\cavpayflg.setValue("");*/
			

			
			
			
			
			/*if("OUR".equals($cpdgrp\\rec\\detchgcod.getValue().trim()))  //费用承担方
			  $cpdgrp\\rec\\detchgcod.setValue("APPLICANT");
			  else if("BEN".equals($cpdgrp\\rec\\detchgcod.getValue().trim()))
			  $cpdgrp\\rec\\detchgcod.setValue("BENEFICIARY");
			  else
			  $cpdgrp\\rec\\detchgcod.setValue("SHA");*/
			

			
			
			
			
			
			
			
			

			this.getCpdgrp().setCtydes(this.getCpdgrp().getRec().getCountryname());

			this.getCpdgrp().setAplnam(this.getSysmod().getPty().getNam());
			

			this.getCpdgrp().setOprnam(this.getCpdgrp().getRec().getApplicantname());
			

			this.getCpdgrp().setApltel(this.getCpdgrp().getRec().getApplicantphone());
			

			
			

			
			
			
			
			
			
			
			
			
		}
        /**
        *   source:cptopn.@0102.script
        */
        public void cpdSavSingleW()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*发送回执给单一窗口
			  Map map = new HashMap();
			  map.put("cod","SFS122");
			  $sysmod.setSwHeaderMap("SFS112","",map,$cptp\\cpdgrp\\rec\\msgref.getValue());
			  Map rst = $sysmod.retSW("SFS112",map,null);
			  //判断处理结果，给出提示
			  String code = (String) rst.get("code");
			  if(Platform.isEmpty(code))
			  {
			  Platform.message(#CT000657,#CT000658);
			  return false;
			  }
			  else
			  {
			  if("999999".equals(code))
			  {
			  String des = (String) rst.get("des");
			  Platform.message(#CT000659,des);
			  return false;
			  }
			  }
			  /*
			  //转历史
			  String objinr = $cptp\\cpdgrp\\rec\\inr.getValue();
			  String objtyp = "cpd";
			  $trnmod.goHistory(objinr,objtyp,Platform.getTransName(),$cptp\\cpt01);
			  //上传影像
			  String cibBranchID = $sysmod\\pty\\cid.getValue().substring(0,2);
			  String cibOrgID = $sysmod\\pty\\cid.getValue().substring(2);
			  Platform.dbRead($\\trnmod\\itfmod\\imgmod\\img,new Argument("trninr",$trnmod\\bnktrn\\inr.getValue()));
			  Boolean result=$\\trnmod\\itfmod\\imgmod.uploadImages($\\trnmod\\itfmod\\imgmod\\img\\ownref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\imgref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\guid.getValue(),cibBranchID,cibOrgID);
			  log.info("upload result=" +result);
			  if(!result)
			  {
			  log.debug("#######");
			  Platform.dbRollback();
			  Platform.message(#CT000660,#CT000661);
			  return false;
			  }
			  //提交入库
			  Platform.dbCommit();
			  errCode = Platform.errorCode();
			  if(errCode!= NO_ERROR)
			  {
			  Platform.message(#CT000662,#CT000663);
			  return false;
			  }
			  Platform.message(#CT000664,#CT000665);
			  */
			//Platform.returnToCaller();
					}
        /**
        *   source:cptopn.@0103.script
        */
        public void cpdBackSingleW()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  //发送回执给单一窗口
			  Map map = new HashMap();
			  map.put("cod","SFS122");
			  $sysmod.setSwHeaderMap("SFS112","",map,$cptp\\cpdgrp\\rec\\msgref.getValue());
			  Map rst = $sysmod.retSW("SFS112",map,null);
			  //判断处理结果，给出提示
			  String code = (String) rst.get("code");
			  if(Platform.isEmpty(code))
			  {
			  Platform.message(#CT000684,#CT000685);
			  return false;
			  }
			  else
			  {
			  if("999999".equals(code))
			  {
			  String des = (String) rst.get("des");
			  Platform.message(#CT000686,des);
			  return false;
			  }
			  }
			
			  //转历史
			  String objinr = $cptp\\cpdgrp\\rec\\inr.getValue();
			  String objtyp = "cpd";
			  $trnmod.goHistory(objinr,objtyp,Platform.getTransName(),$cptp\\cpt01);
			  /*
			  //上传影像
			  String cibBranchID = $sysmod\\pty\\cid.getValue().substring(0,2);
			  String cibOrgID = $sysmod\\pty\\cid.getValue().substring(2);
			  Platform.dbRead($\\trnmod\\itfmod\\imgmod\\img,new Argument("trninr",$trnmod\\bnktrn\\inr.getValue()));
			  Boolean result=$\\trnmod\\itfmod\\imgmod.uploadImages($\\trnmod\\itfmod\\imgmod\\img\\ownref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\imgref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\guid.getValue(),cibBranchID,cibOrgID);
			  log.info("upload result=" +result);
			  if(!result)
			  {
			  log.debug("#######");
			  Platform.dbRollback();
			  Platform.message(#CT000687,#CT000688);
			  return false;
			  }
			  //提交入库
			  Platform.dbCommit();
			  errCode = Platform.errorCode();
			  if(errCode!= NO_ERROR)
			  {
			  Platform.message(#CT000689,#CT000690);
			  return false;
			  }
			  Platform.message(#CT000691,#CT000692);
			  */
			//atform.returnToCaller();
			
		}
        /**
        *   source:cptopn.@0106.script
        */
        public void setApyctm(String objtyp,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCpdgrp().getApyctmlst());
			String sql = "SELECT inr,atcnum,importdate,loadingcountry,atccur,atcamt,totalamt FROM apyctm where objtyp='"+objtyp+"' and objinr='"+objinr+"' ORDER BY inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> atcnum = new Argument<String>("atcnum");
			Argument<Date> importdate = new Argument<Date>("importdate");
			Argument<String> loadingcountry = new Argument<String>("loadingcountry");
			Argument<String> atccur = new Argument<String>("atccur");
			Argument<BigDecimal> atcamt = new Argument<BigDecimal>("atcamt");
			Argument<BigDecimal> totalamt = new Argument<BigDecimal>("totalamt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,atcnum,importdate,loadingcountry,atccur,atcamt,totalamt);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getCpdgrp().getApyctmlst().add(inr,atcnum,importdate,loadingcountry,atccur,atcamt,totalamt);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			int i=this.getCpdgrp().getApyctmlst().size();
			log.debug("{}","apyctmlst.size = "+ i);
			if(i>0)
			{
			  for(int j=0;j<i;j++)
			  {
			    
			    
			    
			    
			    
			    
			    
			  }
			}
			
			
			
		}
        /**
        *   source:cptopn.@0107.script
        */
        public void showReadTet()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//外汇按金交易风险提示函
			String readtxt1=" 外汇按金交易风险提示函";
			readtxt1=readtxt1+CR;
			readtxt1=readtxt1+CR+"目前通过网络平台开展外汇按金交易未经批准；境内";
			readtxt1=readtxt1+CR+"个人跨境境外购房、直接进行跨境证券投资，相关外";
			readtxt1=readtxt1+CR+"汇业务属于资本项目项下业务，按照可兑换进程管理";
			readtxt1=readtxt1+CR+"，目前尚未明确开放。直接或间接开展、参与上述相";
			readtxt1=readtxt1+CR+"关外汇业务，涉嫌违规。请提高风险防范意识，谨防";
			readtxt1=readtxt1+CR+"财产损失。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"特此公告。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"中国光大银行";
			readtxt1=readtxt1+CR+"2019年3月27日";

			ctx.setMessage(MdaUtils.getI18NString("cptopn","CT000705"),readtxt1);

		}
        /**
        *   source:cptopn.@0119.script
        */
        public void getOwnref()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IDatafield ownref = MdaDriver.getDatafield(this.getCptp().getFpdgrp().getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = "FP" + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("FP"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			  // $cptp\\fpdgrp\\rec\\ownref.setValue(prefix);
			  //  Platform.setModified($cptp\\fpdgrp\\rec\\ownref);
			}
		}
        /**
        *   source:cptopn.@0120.script
        */
        public void getref1()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getMtabut().getRec(),"ownref");
			log.debug("{}","***ownref****"+ownref);
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getMtabut().getPrefix() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getMtabut().getPrefix()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}
        /**
        *   source:cptopn.@0124.script
        */
        public boolean cptopnCheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","手机端业务要素校验");
			/*代理行校验*/
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRcp().getPts().getExtkey()))
			{
			  String extkey = this.getCpdgrp().getRcp().getPts().getExtkey();
			  if(extkey.length()>11)
			  {
			    ctx.setMessage("E9999","收款行的代理行SWIFT CODE不能超过11位");
			    return false;
			  }
			}
			/*代理行账号校验*/
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRcp().getPts().getRef()))
			{
			  String ref = this.getCpdgrp().getRcp().getPts().getRef();
			  if( ref.length()>34)
			  {
			    ctx.setMessage("E9999","收款行在其代理行账号不能超过34位");
			    return false;
			  }
			}

			/*金额总和校验*/
			boolean fxflg = TRUE.equals(this.getCpdgrp().getRec().getFxflg());
			boolean purflg = TRUE.equals(this.getCpdgrp().getRec().getPurflg());
			boolean othflg = TRUE.equals(this.getCpdgrp().getRec().getOthflg());
			boolean xhghchk= TRUE.equals(this.getCpdgrp().getRec().getXhghchk());
			String cur=this.getCpdgrp().getRec().getRemcur();
			if(MdaUtils.isEmpty(cur))
			{
			  ctx.setMessage("E9999","汇款币种不能为空");
			  return false;
			}
			if(purflg&&xhghchk)
			{
			  ctx.setMessage("E9999","现汇购汇标识和购汇标识不可以同时勾选");
			  return false;
			}
			if(purflg||xhghchk)
			{
			  if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getOutsel()) && MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getCnnsel()))
			  {
			    ctx.setMessage("E9999","请在等值人民币金额与外币金额中二选一！");
			    return false;
			  }
			}
			if(fxflg)
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxact())||MdaUtils.isEmpty(this.getCpdgrp().getRec().getFxamt()))
			  {
			    ctx.setMessage("E9999","勾选现汇账号标识，则现汇账号、现汇金额必输");
			    return false;
			  }
			  if(!cur.equals(this.getCptp().getCur()))
			  {
			    ctx.setMessage("E9999","现汇币种需和汇款币种一致");
			    return false;
			  }
			}
			if(purflg)
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuract())||MdaUtils.isEmpty(this.getCpdgrp().getRec().getPuramt()))
			  {
			    ctx.setMessage("E9999","勾选是否购汇标识，则购汇账号、购汇金额必输");
			    return false;
			  }
			  if(!cur.equals(this.getCptp().getCur1()))
			  {
			    ctx.setMessage("E9999","购汇币种需和汇款币种一致");
			    return false;
			  }
			}
			if(othflg)
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getOthact())||MdaUtils.isEmpty(this.getCpdgrp().getRec().getOthamt()))
			  {
			    ctx.setMessage("E9999","勾选其他账号标识，则其他账号、其他金额必输");
			    return false;
			  }
			  if(!cur.equals(this.getCptp().getCur2()))
			  {
			    ctx.setMessage("E9999","其他金额币种需和汇款币种一致");
			    return false;
			  }
			}
			boolean sumamt=sumamtcheck(fxflg,purflg,othflg);
			if(!sumamt)
			{
			  ctx.setMessage("E9999","子项金额之和须等于汇款总额！");
			  return false;
			}
			/*交易编码，金额校验*/
			String bopcod1 = this.getCpdgrp().getRec().getBopcod1();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod1()) && !bopcod1.matches("\\d{6}"))
			{
			  ctx.setMessage("E9999","交易编码只能是6位数字");
			  return false;
			}
			String bopcod2 = this.getCpdgrp().getRec().getBopcod2();
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod2()) && !bopcod2.matches("\\d{6}"))
			{
			  ctx.setMessage("E9999","交易编码只能是6位数字");
			  return false;
			}
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod2()))
			{
			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopamt2()))
			  {
			    ctx.setMessage("E9999","交易编码2不为空则交易金额2必输");
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopinf2()))
			  {
			    ctx.setMessage("E9999","交易编码2不为空则交易附言2必输");
			    return false;
			  }
			}
			boolean bopamt1= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"bopamt1"));
			if(!bopamt1)
			{
			  ctx.setMessage("E9999","交易金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}
			boolean bopamt2= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"bopamt2"));
			if(!bopamt2)
			{
			  ctx.setMessage("E9999","交易金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}

			boolean fxamt= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"fxamt"));
			if(!fxamt)
			{
			  ctx.setMessage("E9999","现汇金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}
			boolean puramt= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"puramt"));
			if(!puramt)
			{
			  ctx.setMessage("E9999","购汇金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}
			boolean othamt= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"othamt"));
			if(!othamt)
			{
			  ctx.setMessage("E9999","其他金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}
			String othact=this.getCptp().getCpdgrp().getRec().getOthact();
			if(!MdaUtils.isEmpty(othact) && othact.length()>21)
			{
			  ctx.setMessage("E9999","其他账号长度超过21位");
			  return false;
			}
			boolean pyecry= checkpyecry();
			if(!pyecry)
			{
			  ctx.setMessage("E9999","请输入正确的国家或地区代码,或该地区国家未维护");
			  return false;
			}
			boolean remamt= checkBopamt(MdaDriver.getDatafield(this.getCptp().getCpdgrp().getRec(),"remamt"));
			if(!remamt)
			{
			  ctx.setMessage("E9999","汇款金额不合法，非负数且不超过15整数及2位小数");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getPyeact()))
			{
			  ctx.setMessage("E9999","收款人账号为必输");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCpdgrp().getApltel()))
			{
			  ctx.setMessage("E9999","联系人电话为必输");
			  return false;
			}
			/*交易编码1校验*/
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopcod1()))
			{
			  ctx.setMessage("E9999","交易编码1为必输");
			  return false;
			}
			/*交易金额1校验*/
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopamt1()))
			{
			  ctx.setMessage("E9999","交易金额1为必输");
			  return false;
			}
			/*交易附言1校验*/
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getBopinf1()))
			{
			  ctx.setMessage("E9999","交易附言1为必输");
			  return false;
			}
			/*合同号校验*/
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getConno()))
			{
			  ctx.setMessage("E9999","合同号为必输");
			  return false;
			}
			/*发票号校验*/
			if(MdaUtils.isEmpty(this.getCpdgrp().getRec().getInvno()))
			{
			  ctx.setMessage("E9999","发票号为必输");
			  return false;
			}
			return true;		}
        /**
        *   source:cptopn.@0125.script
        */
        public boolean checkBopamt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（17，2）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,2})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  amt = field.getValue().toString();
			  log.info("{}","amt "+amt);

			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			return bool;
		}
        /**
        *   source:cptopn.@0126.script
        */
        public boolean checkpyecry()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg=true;
			String pyecry = this.getCpdgrp().getRec().getPyecry();
			String sql = "select alpcod from cty where alpcod = '" + pyecry +"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> alpcod = new Argument<String>("alpcod");
			ctx.getDaoSession().dbFetchFields(alpcod);
			int error = ctx.getErrorCode();
			if(error != NO_ERROR)
			{

			  log.info("{}","error+++" + error);
			  flg=false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return flg;
		}
        /**
        *   source:cptopn.@0127.script
        */
        public boolean sumamtcheck(boolean fxflg,boolean purflg,boolean othflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg=true;
			if(fxflg || purflg || othflg)
			{
			  BigDecimal sumamt = new BigDecimal("0");
			  if(fxflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getFxamt());
			  }
			  if(purflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getPuramt());

			  }
			  if(othflg)
			  {
			    sumamt = sumamt.add(this.getCpdgrp().getRec().getOthamt());

			  }
			  log.debug("{}","remamt:" + this.getCpdgrp().getRec().getRemamt());
			  log.debug("{}","sumamt:" + sumamt);
			  if(sumamt.compareTo(new BigDecimal("0"))!=0 && (this.getCpdgrp().getRec().getRemamt()).compareTo(sumamt)!=0)
			  {
			    flg=false;
			  }
			}
			return flg;
		}
        /**
        *   source:cptopn.@0128.script
        */
        public boolean checkpurflg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*购汇校验*/
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getOwnref()))
			{
			  ctx.setMessage("E9999","售汇业务编号不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getCnycno()))
			{
			  ctx.setMessage("E9999","人民币付款账号不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getOutcur())||MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getOutamt()))
			{
			  ctx.setMessage("E9999","外币币种或金额不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getOthcno()))
			{
			  ctx.setMessage("E9999","主体标识码不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getXmlx()))
			{
			  ctx.setMessage("E9999","项目类型不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getXmlx()))
			{
			  ctx.setMessage("E9999","项目类型不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getShbody()))
			{
			  ctx.setMessage("E9999","售汇单位主体不能为空");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getCptp().getFpdgrp().getRec().getTrscno()))
			{
			  ctx.setMessage("E9999","交易编码不能为空");
			  return false;
			}
			return true;
		}
        /**
        *   source:cptopn.@0140.script
        */
        public boolean  fqdlstSearch(String rmbfkzh,String businessno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getWghmod().getFqdlst());
			List argVal = new ArrayList();
			String sql=" where duifzh = ? and edbusno = ? order by inr desc,credat desc";
			argVal.add(rmbfkzh);
			argVal.add(businessno);
			ctx.getDaoSession().dbReadset(this.getWghmod().getFqdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			if(this.getWghmod().getFqdlst().size()>0)
			{
			  log.info("{}","fqd账户类型"+this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			  this.getWghmod().setZhlx(this.getWghmod().getFqdlst().getElement(0).getRmzhlx());
			}
			ctx.getDaoSession().dbCloseCursor();
			
			
			return true;
		}
        /**
        *   source:cptopn.@0141.script
        */
        public boolean getghref(String ghownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","购汇列表"+ghownref);
			MdaUtils.clear(this.getWghmod().getShdlst());
			List argVal = new ArrayList();
			String sql=" where edbusno = ? and deleted = '0' order by inr  desc";
			argVal.add(ghownref);
			ctx.getDaoSession().dbReadset(this.getWghmod().getShdlst(),sql,argVal.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  log.debug("{}","数据库操作异常！");
			  ctx.setMessage("提示","数据库异常，请联系管理员");
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			return true ;
		}
        /**
        *   source:cptopn.@0142.script
        */
        public boolean ghcheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*购汇额度校验*/
			String ref=this.getCpdgrp().getRec().getWyghedno();
			log.info("{}","购汇校验"+ref);
			getghref(ref);
			int length=this.getWghmod().getShdlst().size();
			log.info("{}","长度"+length);
			if(length>0)
			{
			  /*校验币种*/
			  String sql = "SELECT currency FROM shs where businessno='" + ref + "'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getErrorCode();
			  Argument<String> currency = new Argument<String>("currency");
			  ctx.getDaoSession().dbFetchFields(currency);
			  int err = ctx.getErrorCode();
			  ctx.getDaoSession().dbCloseCursor();
			  boolean yn = false;
			  if(err == NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(currency.value))
			    {
			      String currencyValue = currency.value;
			      log.debug("{}","currencyValue=" + currencyValue);
			      log.debug("{}","remcur=" + this.getCpdgrp().getRec().getRemcur());
			      if(!currencyValue.equals(this.getCpdgrp().getRec().getRemcur()))
			      {
			        ctx.setMessage("提示","界面选择的汇款币种与所选网银购汇额度编号项下的币种不一致");
			        return false;
			      }
			      else
			      {
			        for(int i=0;i<length;i++)
			        {
			          if(!MdaUtils.isEmpty(this.getWghmod().getShdlst().getElement(i).getBillnewno()))
			          {
			            log.debug("{}","准备校验界面输入发票号/合同号");
			            String billnewno=this.getWghmod().getShdlst().getElement(i).getBillnewno();
			            String type=this.getWghmod().getShdlst().getElement(i).getBilltype();
			            if(billnewno.equals(this.getCpdgrp().getRec().getInvno()) || billnewno.equals(this.getCpdgrp().getRec().getConno()))
			            {
			              yn=true;
			              break;
			            }

			          }
			        }
			        if(!yn)
			        {
			          ctx.setMessage("提示","该笔申请合同号、发票号与所选网银购汇额度编号项下的合同号、发票号不一致，请加强审核");
			        }
			      }
			    }
			    else
			    {
			      ctx.setMessage("提示","获取所选网银购汇额度编号项下的币种信息失败");
			      return false;
			    }
			  }
			  else
			  {
			    log.error("{}","cptopn0142:查询shs表时数据库异常");
			    ctx.setMessage("E9999","数据库异常，请联系管理员！");
			    return false;
			  }
			}
			else
			{
			  ctx.setMessage("提示","所选网银购汇额度编号项下合同号为空");
			  return false;
			}
			return true;
		}
        /**
        *   source:cptopn.@0144.script
        */
        public List<CodetableItem> getBopCod(String direction)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//交易编码下拉
			List<CodetableItem> items = new ArrayList<CodetableItem>();
			String selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'I' ";
			if ("I".equals(direction))
			{
			  selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'I' ";
			}
			if ("O".equals(direction))
			{
			  selCodlst = "SELECT inr,cod,dir,sta,txt,typ FROM bopcod WHERE dir = 'O' ";
			}

			/*if(!Platform.isEmpty($cptp\\decgrp\\rec\\bopcod1.getValue()))
			  {
			  String codOrTxt = $cptp\\decgrp\\rec\\bopcod1.getValue();
			  selCodlst = selCodlst + " AND (cod LIKE '%"+ codOrTxt +"%' OR txt LIKE '%"+ codOrTxt +"%')";
			  }
			  */
			ctx.getDaoSession().dbExecuteSQL(selCodlst);
			ctx.getErrorCode();
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> dir = new Argument<String>("dir");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> txt = new Argument<String>("txt");
			Argument<String> typ = new Argument<String>("typ");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,dir,sta,txt,typ);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem c = new CodetableItem(cod.value.trim() + "-" + txt.value,cod.value);
			    items.add(c);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return items;
		}












}