package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptopsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Cptmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 商行端汇出汇款Swift输入界面
*/
@Transaction(vo= CptopsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptops extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptops.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptmod cptmod;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Afdgrp afdgrp;


		public Cptops()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptmod().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptops.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptops.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptops.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptops.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptops.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
        }

        /**
        *   source:cptops.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Enter sav200======");
			String objinr = "";
			if(MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getExtkey()) && MdaUtils.isEmpty(this.getCpdgrp().getAcw().getPts().getAdrblk()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("cptops","CT000004"),MdaUtils.getI18NString("cptops","CT000005"));
			  return false;
			}
			if(!ctx.checkAll(this.getCpdgrp()))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  objinr = this.getCpdgrp().getRec().getInr();
			  ctx.getDaoSession().dbUpdate(this.getCpdgrp().getRec());
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getApl().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getBen().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getAcw().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getRcp().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getCpdgrp().getPay().getPts(),objinr);
			}
			else
			{
			  this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			  ctx.getDaoSession().dbInsert(this.getCpdgrp().getRec());
			  objinr=this.getCpdgrp().getRec().getInr();
			  String objtyp = "cpd";
			  this.getCpdgrp().getApl().savpts(objinr,objtyp);
			  this.getCpdgrp().getBen().savpts(objinr,objtyp);
			  this.getCpdgrp().getAcw().savpts(objinr,objtyp);
			  this.getCpdgrp().getRcp().savpts(objinr,objtyp);
			  this.getCpdgrp().getPay().savpts(objinr,objtyp);
			  //直接申请行
			  this.getCpdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getCpdgrp().getDap().getPts().setObjinr(objinr);
			  ctx.getDaoSession().dbInsert(this.getCpdgrp().getDap().getPts());
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getCpdgrp().getTrp().getPts().setInr(Platform.sdbCounter("pts"));
			    this.getCpdgrp().getTrp().getPts().setObjinr(objinr);
			    ctx.getDaoSession().dbInsert(this.getCpdgrp().getTrp().getPts());
			  }
			}
			//$sysmod.generatorPdf($trnmod\\trn\\inr.getValue(),"remitapplys",$mtabut\\tdapldoc.getValue(),true);
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:cptops.@0002.script
        */
        @Rule(target="mtabut.done",order=100)
        public boolean ruleMtabutDoneN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getCpdgrp().getCpdlst());
			

			return true;
        }

        /**
        *   source:cptops.@0003.script
        */
        @Rule(target="mtabut.sav1",order=200)
        public boolean ruleMtabutSav1N200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getCpdlst().add();
			int index=this.getCpdgrp().getCpdlst().fullSize() - 1;
			this.getCpdgrp().getCpdlst().getElement(index).copyValue(this.getCpdgrp().getRec());
			
			ctx.setMessage(MdaUtils.getI18NString("cptops","CT000000"),MdaUtils.getI18NString("cptops","CT000001"));
			this.getTrnmod().ordNew();
			//Platform.clear($cpdgrp\\rec\\remcur);
			// Platform.setModified($cpdgrp\\rec\\remcur);
			this.getCpdgrp().getRec().setRemamt(new BigDecimal(0));
			
			//Platform.clear($cpdgrp\\rec\\acccur);
			//Platform.setModified($cpdgrp\\rec\\acccur);
			this.getCpdgrp().getRec().setAccamt(new BigDecimal(0));
			
			this.getCpdgrp().getRec().setRat(new BigDecimal(0));
			
			this.getCpdgrp().getRec().setOwnref(NULLSTR);
			
			this.getSysmod().setFlg(NULLSTR);
			log.info("{}","All end flg===================" + this.getSysmod().getFlg());

			return true;
        }

        /**
        *   source:cptops.@0004.script
        */
        @Rule(target="mtabut.sav1",order=100)
        public boolean ruleMtabutSav1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().setFlg("X");
			if(!ctx.postRule(this,"mtabut.sav"))
			{
			  return false;
			}

			return true;
        }

        /**
        *   source:cptops.@0005.script
        */
        @Rule(target="cpdgrp.rec.swifttyp",order=100)
        public boolean ruleCpdgrpRecSwifttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeSwifttyp();

			return true;
        }

        /**
        *   source:cptops.@0006.script
        */
        @Rule(target="cpdgrp.rec.remcur",order=100)
        public boolean ruleCpdgrpRecRemcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getCpdgrp().getRec().setAcccur(this.getCpdgrp().getRec().getRemcur());
			

			return true;
        }

        /**
        *   source:cptops.@0009.script
        */
        @Rule(target="cpdgrp.rec.detchgcod",order=100)
        public boolean ruleCpdgrpRecDetchgcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getDetchgcod()))
			{
			  this.getCpdgrp().getRec().setGfrcur(NULLSTR);
			  this.getCpdgrp().getRec().setGframt(new BigDecimal(0));
			}
			
			

			return true;
        }

        /**
        *   source:cptops.@0010.script
        */
        @Rule(target="cpdgrp.rec.gframt",order=100)
        public boolean ruleCpdgrpRecGframtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getCpdgrp().getRec().getGframt()))
			  this.getCpdgrp().getRec().setDetchgcod(NULLSTR);
			

			return true;
        }



        /**
        *   source:cptops.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",bchcod);
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return false;
			// Platform.clear($cpdgrp\\rec);
			if(!MdaUtils.isEmpty(bchcod))
			  this.getCpdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			this.getCpdgrp().getRec().setSwifttyp("1");
			this.getCpdgrp().getRec().setCredat(MdaUtils.today());
			
			
			log.info("{}","初始化直接申请人pts========");
			this.getCpdgrp().getDap().initDap("cpd");
			this.getCpdgrp().getApl().copyValues(this.getCpdgrp().getDap());
			//$cpdgrp\\apl\\pts\\rol.setValue("apl");
			this.getCpdgrp().getRec().setRemcur("USD");
			this.getCpdgrp().getRec().setAcccur("USD");
			
			
			
			
			
			//$cpdgrp\\rec\\detchgcod.setValue("APPLICANT");
			//$cpdgrp\\rec\\frecur.setValue("USD");
			//$cpdgrp\\rec\\gfrcur.setValue("USD");
			
			return true;
        }

        /**
        *   source:cptops.@0008.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			changeSwifttyp();

			return true;
        }


        /**
        *   source:cptops.@0007.script
        */
        public void changeSwifttyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("2".equals(this.getCpdgrp().getRec().getSwifttyp()))
			{
			  
			  
			  this.getCpdgrp().getRec().setAcccur(NULLSTR);
			  
			  
			  this.getCpdgrp().getRec().setAccamt(new BigDecimal(0));
			  
			  this.getCpdgrp().getRec().setRat(new BigDecimal(0));
			  
			  this.getCpdgrp().getRec().setReminf(NULLSTR);
			  
			  
			  this.getCpdgrp().getRec().setDetchgcod(NULLSTR);
			  
			  this.getCpdgrp().getRec().setFrecur(NULLSTR);
			  
			  this.getCpdgrp().getRec().setFreamt(new BigDecimal(0));
			  
			  this.getCpdgrp().getRec().setGfrcur(NULLSTR);
			  
			  this.getCpdgrp().getRec().setGframt(new BigDecimal(0));
			}
			else
			{
			  
			  this.getCpdgrp().getRec().setAcccur("USD");
			  
			  
			  
			  
			  
			  
			  
			  this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			  
			  this.getCpdgrp().getRec().setFrecur("USD");
			  
			  
			  this.getCpdgrp().getRec().setGfrcur("USD");
			  
			}
			
			
			
			
			
			
			
			
			
		}









}