package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptoutVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Cptmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇出汇款通知
*/
@Transaction(vo= CptoutVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptout extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptout.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptmod cptmod;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Btnmod btnmod;


		public Cptout()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptmod().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.accamt");}
 				public void setValue(BigDecimal arg){Cptout.this.getCpdgrp().getRec().setAccamt(arg);}
 				public BigDecimal getValue(){return Cptout.this.getCpdgrp().getRec().getAccamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.acccur");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setAcccur(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getAcccur();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptout.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptout.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptout.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:cptout.@0002.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:cptout.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "汇出汇款通知";
			String tempfiles="A:cptout";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo1();
			labels =  cntLabel.get("label") +labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			if(MdaUtils.isEmpty(labels)&&MdaUtils.isEmpty(tempfiles))
			{
			  cntLabel.put("label",",");
			  cntLabel.put("tempfile",",");
			  //label = ",";
			  //tempfile = ",";
			}
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getCptp().getCptp02());

			return true;
        }

        /**
        *   source:cptout.@0003.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }












}