package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.CptyubVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Cptmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 汇入汇款预通知
*/
@Transaction(vo= CptyubVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptyub extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Cptyub.class);

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptmod cptmod;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Cptyub()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCptmod().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.remcur");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setRemcur(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getRemcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.remamt");}
 				public void setValue(BigDecimal arg){Cptyub.this.getCpdgrp().getRec().setRemamt(arg);}
 				public BigDecimal getValue(){return Cptyub.this.getCpdgrp().getRec().getRemamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.ownref");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.bchcod");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.inr");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Cptyub.this.getFieldPath("cpdgrp.rec.stlref");}
 				public void setValue(String arg){Cptyub.this.getCpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Cptyub.this.getCpdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OR"));
           this.getMtabut().setRecHolder(()->this.getCpdgrp().getRec());
        }



        /**
        *   source:cptyub.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();
			
			
			
			

			return true;
        }

        /**
        *   source:cptyub.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getCptp().getCptyub());

			return true;
        }











}