package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Db2usr0VO;

import com.ceb.gjjs.mda.manager.module.Ptygrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Usrmod;
import com.ceb.gjjs.mda.manager.module.Usrgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Usrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 操作员分配
*/
@Transaction(vo= Db2usr0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Db2usr0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Db2usr0.class);

		@BDGetter
		private Usrgrp usrgrp;

		@BDGetter
		private Ptygrp ptygrp;

		@BDGetter
		private Usrmod usrmod;

		@BDGetter
		private Usrp usrp;

		@BDGetter
		private Sysmod sysmod;


		public Db2usr0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getUsrmod().setUsrgrpHolder(()->this.getUsrgrp());
           this.getUsrmod().setPtygrpHolder(()->this.getPtygrp());
           this.getUsrp().setUsrgrpHolder(()->this.getUsrgrp());
           this.getUsrp().setPtygrpHolder(()->this.getPtygrp());
        }

        /**
        *   source:db2usr0.@0003.script
        */
        @Rule(target="usrp.sel",order=100)
        public boolean ruleUsrpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			/*
			  if($usrgrp\\usrlst.fullSize() == 0)
			  {
			  Platform.message(#CT000020,#CT000021);
			  return;
			  }
			  */
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000022"),MdaUtils.getI18NString("db2usr0","CT000023"));
			  return false;
			}
			MdaUtils.clear(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(index).getInr()));
			//$usrgrp\\usr\\pwd.setValue(Platform.encryptPassword($usrgrp\\usr\\pwd.getValue()));
			

			return true;
        }

        /**
        *   source:db2usr0.@0004.script
        */
        @Rule(target="usrp.selusr",order=100)
        public boolean ruleUsrpSelusrN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsralllst().fullSize();
			if( index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000002"),MdaUtils.getI18NString("db2usr0","CT000003"));
			  return true;
			}
			MdaUtils.clear(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsralllst().getElement(index).getInr()));
			

			return true;
        }

        /**
        *   source:db2usr0.@0005.script
        */
        @Rule(target="usrp.submitopr",order=100)
        public boolean ruleUsrpSubmitoprN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsralllst().fullSize();
			/*
			  if($usrgrp\\usralllst.fullSize() == 0)
			  {
			  Platform.message(#CT000005,#CT000006);
			  return;
			  }
			  */
			log.info("{}","usralllst取到符合条件的记录条数========" + length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000007"),MdaUtils.getI18NString("db2usr0","CT000008"));
			  return false;
			}
			this.getUsrgrp().getUsrlst().add(this.getUsrgrp().getUsralllst().get(index));
			this.getUsrgrp().getUsralllst().remove(index);
			
			
			/*
			  Platform.clear($usrgrp\\usr);
			  Platform.dbRead($usrgrp\\usr,new Argument<String>("inr",$usrgrp\\usralllst[index]\\inr));
			  $usrgrp\\usr\\ptyinr.setValue($ptygrp\\pty\\inr.getValue());
			  Platform.dbBegin();
			  Platform.dbUpdate($usrgrp\\usr);
			  Platform.dbCommit();
			  //Platform.chain("db2usr");
			  refreshUserLst();
			  */

			return true;
        }

        /**
        *   source:db2usr0.@0006.script
        */
        @Rule(target="usrp.deleteopr",order=100)
        public boolean ruleUsrpDeleteoprN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			/*
			  if($usrgrp\\usrlst.fullSize() == 0)
			  {
			  Platform.message(#CT000010,#CT000011);
			  return;
			  }
			  */
			log.info("{}","usrlst取到符合条件的记录条数========" + length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000012"),MdaUtils.getI18NString("db2usr0","CT000013"));
			  return true;
			}
			this.getUsrgrp().getUsralllst().add(this.getUsrgrp().getUsrlst().get(index));
			this.getUsrgrp().getUsrlst().remove(index);
			
			
			/*
			  Platform.clear($usrgrp\\usr);
			  Platform.dbRead($usrgrp\\usr,new Argument<String>("inr",$usrgrp\\usrlst[index]\\inr.getValue()));
			  $usrgrp\\usr\\ptyinr.setValue("");
			  Platform.dbBegin();
			  Platform.dbUpdate($usrgrp\\usr);
			  Platform.dbCommit();
			  refreshUserLst();
			  */

			return true;
        }

        /**
        *   source:db2usr0.@0008.script
        */
        @Rule(target="usrp.saveUsr",order=100)
        public boolean ruleUsrpSaveUsrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getUsrp().getPwd1()))
			{
			  ctx.setFieldError(this,"usrp.pwd1",MdaUtils.getI18NString("db2usr0","CT000049"));
			  return true;
			}
			if(!ctx.checkAll(this.getUsrp()))
			  return false;
			ctx.getDaoSession().dbBegin();
			this.getUsrgrp().getUsr().setPwd(this.getUsrp().getPwd2());
			this.getUsrgrp().getUsr().setFilcnt(0);
			this.getUsrgrp().getUsr().setUsrflg("0");
			ctx.getDaoSession().dbUpdate(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbCommit();
			//Platform.message(#CT000050,#CT000057);
			ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000058"),MdaUtils.getI18NString("db2usr0","CT000158"));
			//refreshUserLst();
			

			return true;
        }

        /**
        *   source:db2usr0.@0009.script
        */
        @Rule(target="usrp.back",order=0)
        public boolean ruleUsrpBackN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:db2usr0.@0010.script
        */
        @Rule(target="usrp.submit",order=100)
        public boolean ruleUsrpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			log.debug("{}","ptygrp ptyinr = "+this.getPtygrp().getPty().getInr());
			log.debug("{}","sysmod ptyinr = "+this.getSysmod().getPty().getInr());
			for(int i = 0; i< this.getUsrgrp().getUsrlst().fullSize(); i++)
			{
			  MdaUtils.clear(this.getUsrgrp().getUsr());
			  ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(i).getInr()));
			  String ptyinr = this.getPtygrp().getPty().getInr();
			  if(!ptyinr.equals(this.getUsrgrp().getUsr().getPtyinr()))
			  {
			    log.debug("{}","Assign usr inr = "+this.getUsrgrp().getUsr().getInr()+", ptyinr = "+this.getUsrgrp().getUsr().getPtyinr());
			    this.getUsrgrp().getUsr().setPtyinr(ptyinr);
			    ctx.getDaoSession().dbUpdate(this.getUsrgrp().getUsr());
			    ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getUsr().getInr()));
			    savUseraut("trsque");
			    savUseraut("xpthis");
			    savUseraut("dbipsw");
			  }

			}
			for(int i = 0; i < this.getUsrgrp().getUsralllst().fullSize(); i++)
			{
			  MdaUtils.clear(this.getUsrgrp().getUsr());
			  ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsralllst().getElement(i).getInr()));
			  String sysPtyinr = this.getSysmod().getPty().getInr();
			  if(!sysPtyinr.equals(this.getUsrgrp().getUsr().getPtyinr()))
			  {
			    log.debug("{}","Getback usr inr ==== "+this.getUsrgrp().getUsr().getInr());
			    this.getUsrgrp().getUsr().setPtyinr(sysPtyinr);
			    ctx.getDaoSession().dbUpdate(this.getUsrgrp().getUsr());
			    ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getUsr().getInr()));
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000015"),MdaUtils.getI18NString("db2usr0","CT000016"));
			//Platform.chain("db2usr");
			refreshUserLst();
			getUsr("gly");
			getUsr("zg");

			return true;
        }

        /**
        *   source:db2usr0.@0011.script
        */
        @Rule(target="usrp.auth",order=100)
        public boolean ruleUsrpAuthN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000017"),MdaUtils.getI18NString("db2usr0","CT000018"));
			  return true;
			}
			log.debug("{}","Auth Selected USR inr = "+this.getUsrgrp().getUsrlst().getElement(index).getInr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(index).getInr()));
			//Platform.popup($usrp\\autconfig);
			String sysPtyinr = this.getSysmod().getPty().getInr();
			String usrPtyinr = this.getUsrgrp().getUsr().getPtyinr();
			if(sysPtyinr.equals(usrPtyinr))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000049"),MdaUtils.getI18NString("db2usr0","CT000050"));
			  return true;
			}
			
			
			loadModLst();
			readLst();
			MdaUtils.setValues(this.getUsrgrp().getAut(),"oflg",MdaUtils.getCodetable("noneflg"));
			MdaUtils.setValues(this.getUsrgrp().getAut(),"bflg",MdaUtils.getCodetable("noneflg"));

			return true;
        }

        /**
        *   source:db2usr0.@0012.script
        */
        @Rule(target="usrp.rtn",order=100)
        public boolean ruleUsrpRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getUsrgrp().getUsr());
			

			return true;
        }

        /**
        *   source:db2usr0.@0013.script
        */
        @Rule(target="usrp.savaut",order=200)
        public boolean ruleUsrpSavautN200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.dbBegin();
			  //删除旧的记录
			  Platform.dbDelete($usrgrp\\usraut,new Argument<String>("objinr",$usrgrp\\usr\\inr.getValue()),new Argument<String>("objtyp","usr"));
			  //新增记录
			  for(int i=0;i<$usrgrp\\autlst.fullSize();i++)
			  {
			  String flg1 = $usrgrp\\autlst[i]\\oflg.getValue();
			  String flg2 = $usrgrp\\autlst[i]\\bflg.getValue();
			  String lvl = $usrgrp\\autlst[i]\\aflg.getValue();
			  if(!("".equals(flg1) && "".equals(flg2) && ("0".equals(lvl)  ||  "".equals(lvl))))
			  {
			  $usrgrp\\usraut\\inr.setValue(Platform.sdbCounter("usraut"));
			  log.info("usraut.inr:"+$usrgrp\\usraut\\inr.getValue());
			  $usrgrp\\usraut\\objinr.setValue($usrgrp\\usr\\inr.getValue());
			  $usrgrp\\usraut\\objtyp.setValue("usr");
			  $usrgrp\\usraut\\ptyinr.setValue($sysmod\\pty\\inr.getValue());
			  $usrgrp\\usraut\\frm.setValue(($usrgrp\\autlst[i]\\trsinr.getValue()).trim());
			  //有：0  没有：1
			  log.info("flg1:"+$usrgrp\\autlst[i]\\oflg.getValue());
			  log.info("flg2:"+$usrgrp\\autlst[i]\\bflg.getValue());
			  if(TRUE.equals(flg1))
			  $usrgrp\\usraut\\flg1.setValue("0");
			  else
			  $usrgrp\\usraut\\flg1.setValue("1");
			  if(TRUE.equals(flg2))
			  $usrgrp\\usraut\\flg2.setValue("0");
			  else
			  $usrgrp\\usraut\\flg2.setValue("1");
			  $usrgrp\\usraut\\lvl.setValue(lvl);
			  $usrgrp\\usraut\\cur.setValue("USD");
			  $usrgrp\\usraut\\amt.setValue($usrgrp\\autlst[i]\\amt.getValue());
			  Platform.dbInsert($usrgrp\\usraut);
			  }
			  }
			  Platform.dbUpdate($usrgrp\\usr);
			  Platform.dbCommit();
			  Platform.message(#CT000037,#CT000038);
			  Platform.closePanel($usrp\\autconfig);
			  */

			return true;
        }

        /**
        *   source:db2usr0.@0017.script
        */
        @Rule(target="usrgrp.usrlst",order=100)
        public boolean ruleUsrgrpUsrlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			/*
			  if($usrgrp\\usrlst.fullSize() == 0)
			  {
			  Platform.message(#CT000043,#CT000044);
			  return;
			  }
			  */
			log.info("{}","usrlst取到符合条件的记录条数========" + length);
			if( index<0   ||   index >= length)
			{
			  //Platform.message(#CT000045,#CT000046);
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000047"),MdaUtils.getI18NString("db2usr0","CT000048"));
			  return false;
			}
			MdaUtils.clear(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(index).getInr()));
			//$usrgrp\\usr\\pwd.setValue(Platform.encryptPassword($usrgrp\\usr\\pwd.getValue()));
			

			return true;
        }

        /**
        *   source:db2usr0.@0019.script
        */
        @Rule(target="usrgrp.autlst",order=100)
        public boolean ruleUsrgrpAutlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getUsrgrp().getAutlst().fullSize();
			this.getUsrgrp().getAut().copyValue(this.getUsrgrp().getAutlst().getElement(index));
			setAtuLvl();

			return true;
        }

        /**
        *   source:db2usr0.@0020.script
        */
        @Rule(target="usrp.savaut",order=100)
        public boolean ruleUsrpSavautN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getUsrgrp().getUsraut());
			String frm = this.getUsrgrp().getAut().getTrsinr().trim();
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsraut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getUsr().getInr()));
			log.debug("{}","submit usraut inr = "+this.getUsrgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getUsrgrp().getUsr().getInr());
			if(MdaUtils.isEmpty(this.getUsrgrp().getUsraut().getInr()))
			{
			  this.getUsrgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			  this.getUsrgrp().getUsraut().setObjtyp("usr");
			  this.getUsrgrp().getUsraut().setFrm(frm);
			  this.getUsrgrp().getUsraut().setObjinr(this.getUsrgrp().getUsr().getInr());
			  this.getUsrgrp().getUsraut().setPtyinr(this.getUsrgrp().getUsr().getPtyinr());
			  this.getUsrgrp().getUsraut().setFlg1(this.getUsrgrp().getAut().getOflg());
			  this.getUsrgrp().getUsraut().setFlg2(this.getUsrgrp().getAut().getBflg());
			  this.getUsrgrp().getUsraut().setLvl(this.getUsrgrp().getAut().getAflg());
			  ctx.getDaoSession().dbInsert(this.getUsrgrp().getUsraut());
			  log.debug("{}","Insert usraut inr = "+this.getUsrgrp().getUsraut().getInr());
			}
			else if("1".equals(this.getUsrgrp().getAut().getOflg())&&"1".equals(this.getUsrgrp().getAut().getBflg())&&"0".equals(this.getUsrgrp().getAut().getAflg()))
			{
			  log.debug("{}","Delete usraut inr = "+this.getUsrgrp().getUsraut().getInr());
			  if(MdaUtils.prompt(MdaUtils.getI18NString("db2usr0","CT000053"),MdaUtils.getI18NString("db2usr0","CT000054")))
			    return true;
			  ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut());
			}
			else
			{
			  this.getUsrgrp().getUsraut().setFlg1(this.getUsrgrp().getAut().getOflg());
			  this.getUsrgrp().getUsraut().setFlg2(this.getUsrgrp().getAut().getBflg());
			  this.getUsrgrp().getUsraut().setLvl(this.getUsrgrp().getAut().getAflg());
			  ctx.getDaoSession().dbUpdate(this.getUsrgrp().getUsraut());
			  log.debug("{}","Update usraut inr = "+this.getUsrgrp().getUsraut().getInr());
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000055"),MdaUtils.getI18NString("db2usr0","CT000056"));
			loadModLst();
			readLst();

			return true;
        }

        /**
        *   source:db2usr0.@0022.script
        */
        @Rule(target="usrp.setgly",order=100)
        public boolean ruleUsrpSetglyN100(){
            IContext ctx = MdaEnv.getContext();
            
			//设置为管理员
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000071"),MdaUtils.getI18NString("db2usr0","CT000072"));
			  return true;
			}
			MdaUtils.clear(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(index).getInr()));
			String sysPtyinr = this.getSysmod().getPty().getInr();
			String usrPtyinr = this.getUsrgrp().getUsr().getPtyinr();
			if(sysPtyinr.equals(usrPtyinr))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000073"),MdaUtils.getI18NString("db2usr0","CT000074"));
			  return true;
			}
			if((this.getUsrgrp().getUsr().getInr()).equals(this.getUsrgrp().getGly().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000079"),this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000080"));
			  return true;
			}
			if((this.getUsrgrp().getUsr().getInr()).equals(this.getUsrgrp().getZg().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000081"),this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000082"));
			  return true;
			}
			String message = null;
			if(MdaUtils.isEmpty(this.getUsrgrp().getGly().getInr()))
			  message = MdaUtils.getI18NString("db2usr0","CT000109")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000110");
			else
			  message = MdaUtils.getI18NString("db2usr0","CT000111")+this.getUsrgrp().getGly().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000112")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000113");
			if(MdaUtils.prompt(MdaUtils.getI18NString("db2usr0","CT000114"),message))
			  return true;
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getUsrgrp().getUsraut());
			ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getGly().getInr()),new Argument<String>("frm","dbmaut"));
			MdaUtils.clear(this.getUsrgrp().getUsraut());
			ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getGly().getInr()),new Argument<String>("frm","dbmopr"));
			ctx.getDaoSession().dbCommit();
			savUseraut("dbmaut");
			savUseraut("dbmopr");
			savUseraut("autcnt");
			ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000149"),MdaUtils.getI18NString("db2usr0","CT000150")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000151")+this.getPtygrp().getPty().getExtkey()+MdaUtils.getI18NString("db2usr0","CT000152"));
			log.debug("{}","新增管理员gly = "+this.getUsrgrp().getUsr().getInr());
			//$usrgrp\\usrlst.remove(index);
			//$usrgrp\\usrlst.add($usrgrp\\gly);
			MdaUtils.clear(this.getUsrgrp().getGly());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getGly(),new Argument<String>("inr",this.getUsrgrp().getUsr().getInr()));
			
			//Platform.setModified($usrgrp\\usrlst);
			
			return true;
        }

        /**
        *   source:db2usr0.@0023.script
        */
        @Rule(target="usrp.setzg",order=100)
        public boolean ruleUsrpSetzgN100(){
            IContext ctx = MdaEnv.getContext();
            
			//设置为主管
			int index = 0;
			int length = this.getUsrgrp().getUsrlst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000075"),MdaUtils.getI18NString("db2usr0","CT000076"));
			  return true;
			}
			MdaUtils.clear(this.getUsrgrp().getUsr());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsr(),new Argument<String>("inr",this.getUsrgrp().getUsrlst().getElement(index).getInr()));
			String sysPtyinr = this.getSysmod().getPty().getInr();
			String usrPtyinr = this.getUsrgrp().getUsr().getPtyinr();
			if(sysPtyinr.equals(usrPtyinr))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000077"),MdaUtils.getI18NString("db2usr0","CT000078"));
			  return true;
			}
			if((this.getUsrgrp().getUsr().getInr()).equals(this.getUsrgrp().getZg().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000083"),this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000084"));
			  return true;
			}
			if((this.getUsrgrp().getUsr().getInr()).equals(this.getUsrgrp().getGly().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000085"),this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000086"));
			  return true;
			}
			String message = null;
			if(MdaUtils.isEmpty(this.getUsrgrp().getZg().getInr()))
			  message = MdaUtils.getI18NString("db2usr0","CT000139")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000140");
			else
			  message = MdaUtils.getI18NString("db2usr0","CT000141")+this.getUsrgrp().getZg().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000142")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000143");
			if(MdaUtils.prompt(MdaUtils.getI18NString("db2usr0","CT000144"),message))
			  return true;
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getUsrgrp().getUsraut());
			ctx.getDaoSession().dbDelete(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getGly().getInr()),new Argument<String>("frm","sysaut"));
			ctx.getDaoSession().dbCommit();
			savUseraut("sysaut");
			ctx.setMessage(MdaUtils.getI18NString("db2usr0","CT000153"),MdaUtils.getI18NString("db2usr0","CT000154")+this.getUsrgrp().getUsr().getLgnnam()+MdaUtils.getI18NString("db2usr0","CT000155")+this.getPtygrp().getPty().getExtkey()+MdaUtils.getI18NString("db2usr0","CT000156"));
			log.debug("{}","新增主管zg = "+this.getUsrgrp().getUsr().getInr());
			//$usrgrp\\usrlst.remove(index);
			//$usrgrp\\usrlst.add($usrgrp\\zg);
			MdaUtils.clear(this.getUsrgrp().getZg());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getZg(),new Argument<String>("inr",this.getUsrgrp().getUsr().getInr()));
			
			//Platform.setModified($usrgrp\\usrlst);
			
			return true;
        }


        /**
        *   source:db2usr0.@0002.script
        */
        @Check(target="usrp.pwd2",order=100)
        public boolean checkUsrpPwd2N100(){
            IContext ctx = MdaEnv.getContext();
            
			String oldpwd = this.getUsrp().getPwd1();
			String newpwd = this.getUsrp().getPwd2();
			if(!oldpwd.equals(newpwd))
			  ctx.setFieldError(this,"usrp.pwd2",MdaUtils.getI18NString("db2usr0","CT000004"));

			return true;
        }


        /**
        *   source:db2usr0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPtygrp().copyValues((IModule)ctx.restoreData("com.brilliance.ptygrp"));
			//Platform.disable($ptygrp\\pta\\ptyextkey);
			//Platform.disable($usrgrp\\usr\\lgnnam);
			log.info("{}","pty inr=" +this.getPtygrp().getPty().getInr()+" pta.ptyinr="+this.getPtygrp().getPta().getPtyinr());
			refreshUserLst();
			getUsr("gly");
			getUsr("zg");

			return true;
        }

        /**
        *   source:db2usr0.@0001.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			this.getUsrp().setPwd1(NULLSTR);
			this.getUsrp().setPwd2(NULLSTR);
			
			

			return true;
        }

        /**
        *   source:db2usr0.@0016.script
        */
        @Init(order=100)
        public boolean	init100R2(){
            IContext ctx = MdaEnv.getContext();
            
			loadModLst();
			readLst();

			return true;
        }


        /**
        *   source:db2usr0.@0007.script
        */
        public void refreshUserLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getUsrgrp().getUsrlst());
			ctx.getDaoSession().dbReadset(this.getUsrgrp().getUsrlst(),new Argument<String>("ptyinr",this.getPtygrp().getPty().getInr()),new Argument<String>("otype","2"),new Argument<String>("usrflg","0"));
			
			/*
			  Platform.clear($usrgrp\\usralllst);
			  String queryClause = "SELECT inr,lgnnam,ptynam,usrflg "
			  +"FROM usr WHERE ptyinr ='"+$sysmod\\pty\\inr+"' AND cid = '"+$sysmod\\pty\\cid+"'";
			  log.info(queryClause);
			  Platform.dbExecuteSQL(queryClause);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> lgnnam = new Argument<String>("lgnnam");
			  Argument<String> ptynam = new Argument<String>("ptynam");
			  Argument<String> usrflg = new Argument<String>("usrflg");
			  while(true)
			  {
			  Platform.dbFetchFields(inr,lgnnam,ptynam,ptynam,usrflg);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  {
			  $usrgrp\\usralllst.add(inr,lgnnam,ptynam,ptynam,usrflg);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  */
			ctx.getDaoSession().dbReadset(this.getUsrgrp().getUsralllst(),new Argument<String>("ptyinr",this.getSysmod().getPty().getInr()),new Argument<String>("otype","2"));
			
		}
        /**
        *   source:db2usr0.@0014.script
        */
        public void loadModLstbak()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除数据列表
			MdaUtils.clear(this.getUsrgrp().getModlstlst());
			//数据库中仅保存没有权限的交易，所以此处采用左连接后，应该判断ptyinr为空。
			String sql = "SELECT m.inr,m.frm,m.nam,m.trntyp FROM modlst m";
			sql+=" left outer join";
			//sql+=" (select * FROM ptymod WHERE ptyinr='"+$sysmod\\pty\\inr+"') p on m.frm=p.frm";
			//sql+=" WHERE m.modtyp in('0','1') and m.ptytyp='"+$sysmod\\pty\\ptytyp.getValue()+"' and p.ptyinr is null";
			sql+=" (SELECT * FROM ptymod WHERE ptyinr IN(SELECT inr FROM pty WHERE cid IN(SELECT ncid FROM usr WHERE ptyinr = '"+this.getPtygrp().getPty().getInr()+"'))) p on m.frm=p.frm";
			sql+=" WHERE m.modtyp in('0','1') and m.ptytyp='"+this.getPtygrp().getPty().getPtytyp()+"' and p.ptyinr is null";
			sql+=" order by m.trntyp";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,frm,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getUsrgrp().getModlstlst().add(inr,frm,nam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:db2usr0.@0015.script
        */
        public void readLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getUsrgrp().getAutlst());
			String sql ="";
			//根据此机构所具有的交易权限，读取操作员的权限信息
			for(int i=0;i<this.getUsrgrp().getModlstlst().fullSize();i++)
			{
			  //sql = "SELECT case flg1 when '1' then '' else 'X' end oflg, case flg2 when '1' then '' else 'X' end bflg,lvl aflg,amt ";
			  sql = "SELECT u.flg1 oflg,u.flg2 bflg,u.lvl aflg,u.amt amt";
			  sql += " FROM usraut u";
			  sql += " WHERE u.objinr='"+this.getUsrgrp().getUsr().getInr()+"' AND u.objtyp='usr' AND ptyinr='"+this.getUsrgrp().getUsr().getPtyinr()+"' AND frm='"+this.getUsrgrp().getModlstlst().getElement(i).getFrm()+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> oflg = new Argument<String>("oflg");
			  Argument<String> bflg = new Argument<String>("bflg");
			  Argument<String> aflg = new Argument<String>("aflg");
			  Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			  //Argument<String> trsnam = new Argument<String>("trsnam",$oprgrp\\modlstlst[i]\\nam.getValue());
			  //Argument<String> trsinr = new Argument<String>("trsinr",$oprgrp\\modlstlst[i]\\frm.getValue());
			  Argument<String> trsnam = new Argument<String>("trsnam");
			  Argument<String> trsinr = new Argument<String>("trsinr");
			  ctx.getDaoSession().dbFetchFields(trsinr,trsnam,oflg,bflg,aflg,amt);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode != NO_ERROR)
			  {
			    oflg.value = null;
			    bflg.value = null;
			    aflg.value = null;
			  }
			  trsinr.value = this.getUsrgrp().getModlstlst().getElement(i).getFrm();
			  trsnam.value = this.getUsrgrp().getModlstlst().getElement(i).getNam();
			  this.getUsrgrp().getAutlst().add(trsinr,trsnam,oflg,bflg,aflg,amt);
			  ctx.getDaoSession().dbCloseCursor();
			}
			
		}
        /**
        *   source:db2usr0.@0018.script
        */
        public void setAtuLvl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String frm = this.getUsrgrp().getAut().getTrsinr().trim();
			ctx.getDaoSession().dbRead(this.getUsrgrp().getPtyaut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","pty"),new Argument<String>("objinr",this.getSysmod().getUsr().getPtyinr()));
			log.debug("{}","传入的查询条件frm = "+frm+"，机构号 = "+this.getSysmod().getUsr().getPtyinr());
			log.debug("{}","ptyaut inr = "+this.getUsrgrp().getPtyaut().getInr()+",复核权限"+this.getUsrgrp().getPtyaut().getChkflg()+"，授权级别"+this.getUsrgrp().getPtyaut().getLvl());
			//经办
			if(MdaUtils.isEmpty(this.getUsrgrp().getAut().getOflg()))
			  this.getUsrgrp().getAut().setOflg("1");
			//复核
			if("1".equals(this.getUsrgrp().getPtyaut().getChkflg()))
			{
			  
			  this.getUsrgrp().getAut().setBflg(NULLSTR);
			}
			else if(MdaUtils.isEmpty(this.getUsrgrp().getAut().getBflg()))
			  this.getUsrgrp().getAut().setBflg("1");
			//授权
			if("0".equals(this.getUsrgrp().getPtyaut().getLvl()))
			{
			  
			  this.getUsrgrp().getAut().setAflg(NULLSTR);
			}
			else
			{
			  
			  MdaUtils.setValues(this.getUsrgrp().getAut(),"aflg",MdaUtils.getCodetable("aflg"+this.getUsrgrp().getPtyaut().getLvl()));
			  log.debug("{}","传入码表的名称为"+"aflg"+this.getUsrgrp().getPtyaut().getLvl());
			  if(MdaUtils.isEmpty(this.getUsrgrp().getAut().getAflg()))
			    this.getUsrgrp().getAut().setAflg("0");
			}
			
			
			
			
		}
        /**
        *   source:db2usr0.@0021.script
        */
        public void loadModLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除数据列表
			MdaUtils.clear(this.getUsrgrp().getModlstlst());
			String objinr = this.getSysmod().getPty().getInr();
			String objtyp = "pty";
			/*
			  if("1".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //商行维护的是其及下属企业的业务授权模式
			  objinr = $sysmod\\pty\\etyinr.getValue();
			  objtyp = "ety";
			  }
			  else if("2".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //本行企业维护的是自身的业务授权模式
			  objinr = $sysmod\\pty\\inr.getValue();
			  objtyp = "pty";
			  }
			  */
			//数据库中仅保存没有权限的交易，所以此处采用左连接后，应该判断ptyinr为空。
			String sql = "SELECT inr,frm,nam FROM modlst WHERE modtyp IN('0','1') AND ptytyp='"+this.getSysmod().getPty().getPtytyp()+"' AND frm IN(SELECT DISTINCT(frm) FROM ptyaut WHERE objinr='"+objinr+"' and objtyp = '"+objtyp+"') ORDER BY trntyp";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,frm,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getUsrgrp().getModlstlst().add(inr,frm,nam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:db2usr0.@0024.script
        */
        public void savUseraut(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getUsrgrp().getUsraut());
			ctx.getDaoSession().dbRead(this.getUsrgrp().getUsraut(),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getUsrgrp().getUsr().getInr()),new Argument<String>("frm",frm));
			if(MdaUtils.isEmpty(this.getUsrgrp().getUsraut().getInr()))
			{
			  ctx.getDaoSession().dbBegin();
			  this.getUsrgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			  this.getUsrgrp().getUsraut().setPtyinr(this.getUsrgrp().getUsr().getPtyinr());
			  this.getUsrgrp().getUsraut().setObjinr(this.getUsrgrp().getUsr().getInr());
			  this.getUsrgrp().getUsraut().setObjtyp("usr");
			  this.getUsrgrp().getUsraut().setFrm(frm);
			  this.getUsrgrp().getUsraut().setFlg1("0");
			  this.getUsrgrp().getUsraut().setFlg2("1");
			  this.getUsrgrp().getUsraut().setLvl("5");
			  this.getUsrgrp().getUsraut().setCur("USD");
			  this.getUsrgrp().getUsraut().setAmt(new BigDecimal("0"));
			  ctx.getDaoSession().dbInsert(this.getUsrgrp().getUsraut());
			  ctx.getDaoSession().dbCommit();
			  log.debug("{}","Insert USRAUT inr = "+this.getUsrgrp().getUsraut().getInr()+", usrinr = "+this.getUsrgrp().getUsraut().getObjinr());
			}
			log.debug("{}",this.getUsrgrp().getUsr().getInr()+" NOT Insert USRAUT frm = "+frm);
		}
        /**
        *   source:db2usr0.@0025.script
        */
        public void getUsr(String rol)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//二级客户管理员配置了dbmaut、dbmopr交易；主管配置了sysaut交易
			String frm = null;
			IModule rolModule = MdaDriver.getModule(this,this.getUsrgrp(),rol);
			if("zg".equals(rol))
			  frm = "sysaut";
			else if("gly".equals(rol))
			  frm = "dbmopr";
			//Platform.clear($usrgrp\\gly);
			String sql = "SELECT inr FROM usr WHERE ptyinr = '"+this.getPtygrp().getPty().getInr()+"' AND inr IN (SELECT objinr FROM usraut WHERE frm = '"+frm+"')";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			ctx.getDaoSession().dbRead(rolModule,new Argument<String>("inr",inr.value));
			log.debug("{}","getUsr rol = "+rol+", usrinr = "+((MdaDriver.getDatafield(rolModule,"inr")).getValue()));
			ctx.getDaoSession().dbCloseCursor();
		}






}