package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbbmsgVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bmsp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行端申请类交易短信订阅
*/
@Transaction(vo= DbbmsgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbbmsg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbbmsg.class);

        //交易说明
        private String note;
		@BDGetter
		private Bmsp bmsp;

		@BDGetter
		private Sysmod sysmod;


		public Dbbmsg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:dbbmsg.@0000.script
        */
        @Rule(target="bmsp.search",order=100)
        public boolean ruleBmspSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			query();

			return true;
        }

        /**
        *   source:dbbmsg.@0002.script
        */
        @Rule(target="bmsp.next",order=100)
        public boolean ruleBmspNextN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","*************下一步功能******************");
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getBmsp().getPtylst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbbmsg","CT000010"),MdaUtils.getI18NString("dbbmsg","CT000011"));
			}
			else
			{
			  MdaUtils.clear(this.getBmsp().getPty());
			  ctx.getDaoSession().dbRead(this.getBmsp().getPty(),new Argument<String>("inr",this.getBmsp().getPtylst().getElement(index).getInr()));
			  msgsel();
			  
			}
			log.info("{}","*************下一步功能结束******************");

			return true;
        }

        /**
        *   source:dbbmsg.@0003.script
        */
        @Rule(target="bmsp.sav",order=100)
        public boolean ruleBmspSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","**********************短信订阅开通控制保存功能***********************");
			ctx.getDaoSession().dbBegin();
			String phone="";
			int length = this.getBmsp().getMsglst().fullSize();
			Argument<String> phonum =new Argument<String>("phonum");
			String sql="SELECT phonum FROM adr,pta,pty where pty.inr='"+this.getBmsp().getPty().getInr()+"' and pty.inr=pta.ptyinr and adr.inr=pta.objinr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode() ;
			log.info("{}","查询phonum语句 ="+sql);
			log.info("{}","errCod ="+errCod);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(phonum);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    phone=phonum.value;
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			for(int index = 0;index < length;index++)
			{
			  if("X".equals(this.getBmsp().getMsglst().getElement(index).getMsgflg()))
			  {
			    MdaUtils.clear(this.getBmsp().getMsg());
			    this.getBmsp().getMsg().setInr(Platform.sdbCounter("msg"));
			    this.getBmsp().getMsg().setPtyinr(this.getBmsp().getPty().getInr());
			    this.getBmsp().getMsg().setFrm(this.getBmsp().getMsglst().getElement(index).getFrm());
			    this.getBmsp().getMsg().setNam(this.getBmsp().getMsglst().getElement(index).getNam());
			    this.getBmsp().getMsg().setMsgflg(this.getBmsp().getMsglst().getElement(index).getMsgflg());
			    this.getBmsp().getMsg().setMobile(phone);
			    ctx.getDaoSession().dbInsert(this.getBmsp().getMsg());
			    log.debug("{}","**************新增*************"+index);
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbbmsg","CT000002"),MdaUtils.getI18NString("dbbmsg","CT000003"));
			msgsel();
			
			
			log.info("{}","**********************短信订阅开通控制保存功能结束***********************");

			return true;
        }

        /**
        *   source:dbbmsg.@0004.script
        */
        @Rule(target="bmsp.all",order=100)
        public boolean ruleBmspAllN100(){
            IContext ctx = MdaEnv.getContext();
            
			boolean selall = true;
			log.debug("{}","selall");
			int cursize = this.getBmsp().getMsglst().size();
			int selidx = 0;
			int realidx = this.getBmsp().getMsglst().getRealIndex(selidx);
			int pages = this.getBmsp().getMsglst().getPage();
			int pagesize = this.getBmsp().getMsglst().getPageSize();
			log.debug("{}","cursize="+cursize);
			log.debug("{}","sel idx="+selidx);
			log.debug("{}","realidx="+realidx);
			log.debug("{}","pages="+pages);
			log.debug("{}","pagesize="+pagesize);
			int begin = pagesize * ( pages - 1 );
			int end = begin+cursize;
			log.debug("{}","begin="+begin);
			log.debug("{}","end="+end);
			for(int i=begin;i<end;i++)
			{
			  if(!"X".equals(this.getBmsp().getMsglst().getElement(i).getMsgflg()))
			  {
			    selall=false;
			    this.getBmsp().getMsglst().getElement(i).setMsgflg("X");
			  }
			}
			if(selall)
			{
			  for(int i=begin;i<end;i++)
			  {
			    this.getBmsp().getMsglst().getElement(i).setMsgflg("");
			  }
			}
			

			return true;
        }

        /**
        *   source:dbbmsg.@0005.script
        */
        @Rule(target="bmsp.savalt",order=100)
        public boolean ruleBmspSavaltN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","*************查看及修改界面修改功能******************");
			ctx.getDaoSession().dbBegin();
			int length = this.getBmsp().getMsglst().fullSize();
			for(int index = 0;index < length;index++)
			{
			  if(!"X".equals(this.getBmsp().getMsglst().getElement(index).getMsgflg()))
			  {
			    MdaUtils.clear(this.getBmsp().getMsg());
			    ctx.getDaoSession().dbRead(this.getBmsp().getMsg(),new Argument<String>("inr",this.getBmsp().getMsglst().getElement(index).getInr()));
			    ctx.getDaoSession().dbDelete(this.getBmsp().getMsg());
			    log.debug("{}","**************修改*************"+index);
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbbmsg","CT000008"),MdaUtils.getI18NString("dbbmsg","CT000009"));
			msgsel();
			log.info("{}","*************查看及修改界面修改功能结束******************");

			return true;
        }

        /**
        *   source:dbbmsg.@0007.script
        */
        @Rule(target="bmsp.add",order=100)
        public boolean ruleBmspAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			amsgsel();
			
			

			return true;
        }



        /**
        *   source:dbbmsg.@0009.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			query();

			return true;
        }


        /**
        *   source:dbbmsg.@0001.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","*************初始界面查询******************");
			MdaUtils.clear(this.getBmsp().getPtylst());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> cid =new Argument<String>("cid");
			Argument<String> engnam =new Argument<String>("engnam");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> brhlvl =new Argument<String>("brhlvl");
			Argument<String> lvl =new Argument<String>("lvl");
			String sql="SELECT inr,cid,engnam,nam,brhlvl,lvl FROM pty WHERE ptytyp = '0' ";
			if(!MdaUtils.isEmpty(this.getBmsp().getCidnam()))
			  sql=sql+" and (cid like '%"+this.getBmsp().getCidnam()+"%' or nam like '%"+this.getBmsp().getCidnam()+"%')";

			if("1".equals(this.getSysmod().getPty().getBrhlvl()))
			  log.info("{}","read all Pty:"+sql );
			else if("2".equals(this.getSysmod().getPty().getBrhlvl()))
			{
			  sql=sql+" and substr(pty.cid,1,2) = '"+this.getSysmod().getPty().getCid().substring(0,2)+"' ";
			  log.info("{}","read 分行Pty:"+sql );
			}
			else if("3".equals(this.getSysmod().getPty().getBrhlvl()) || "4".equals(this.getSysmod().getPty().getBrhlvl()) )
			{
			  sql=sql+" and pty.inr='"+this.getSysmod().getPty().getInr()+"' ";
			  log.info("{}","read  支行 Pty:"+sql );
			}

			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode() ;
			log.info("{}","查询语句 ="+sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cid,engnam,nam,brhlvl,lvl);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    this.getBmsp().getPtylst().add(inr,cid,engnam,nam,brhlvl,lvl);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			log.info("{}","*************初始界面查询结束******************");
		}
        /**
        *   source:dbbmsg.@0006.script
        */
        public void msgsel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getBmsp().getMsglst());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ptyinr =new Argument<String>("ptyinr");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> frm =new Argument<String>("frm");
			Argument<String> msgflg =new Argument<String>("msgflg");
			String sql="SELECT inr,nam,frm,msgflg,ptyinr FROM msg where msgflg='X' and ptyinr='"+this.getBmsp().getPty().getInr()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode() ;
			this.getBmsp().setAllfrm(NULLSTR);
			String all="";
			log.info("{}","查询已开通业务的语句 ="+sql);
			log.info("{}","查询已开通业务的语句errCodchk ="+errCod);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam,frm,msgflg,ptyinr);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    this.getBmsp().getMsglst().add(inr,nam,frm,msgflg,ptyinr);
			    all=all+"'"+frm.value+"',";
			  }
			  else
			    break;
			}
			all=all+"'dbmacc','dbbrlc','anthep','xpmsam','xpmfaq','queusr','quevlm','dbbrat'"
			  +",'betdft','bctsdu','rptqur','betpre','botsdu','ersfre','betdoc','botdft','dbcact','bettpl','bxtsdu'";
			this.getBmsp().setAllfrm(all);
			log.debug("{}","allfrm===="+this.getBmsp().getAllfrm());
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbbmsg.@0008.script
        */
        public void amsgsel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getBmsp().getMsglst());
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> frm =new Argument<String>("frm");
			String sql="SELECT distinct nam,substr(frm,0,6) frm FROM modlst where modtyp='0' and ptytyp!='0' and substr(frm,0,6) not in ("+this.getBmsp().getAllfrm()+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode();
			log.info("{}","点击新增的查询语句 ="+sql);
			log.info("{}","errCod ="+errCod);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam,frm);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    this.getBmsp().getMsglst().add(nam,frm);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}




}