package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbcactVO;

import com.ceb.gjjs.mda.manager.module.Actgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Actp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 常用账户维护
*/
@Transaction(vo= DbcactVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbcact extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbcact.class);

		@BDGetter
		private Actgrp actgrp;

		@BDGetter
		private Actp actp;

		@BDGetter
		private Sysmod sysmod;


		public Dbcact()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getActp().setActgrpHolder(()->this.getActgrp());
        }



        /**
        *   source:dbcact.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getActp().getActlst());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			ctx.getDaoSession().dbReadset(this.getActp().getActlst(),new Argument<String>("ptyinr",ptyinr));
			

			return true;
        }

        /**
        *   source:dbcact.@0002.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getActgrp().getRec().getOpnbchinr());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getActgrp().getRec(),"opnbchinr",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{

			  log.info("{}","bchocd="+this.getActgrp().getRec().getOpnbchinr());
			}

			return true;
        }






}