package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbipswVO;

import com.ceb.gjjs.mda.manager.module.Pswgrp;
import com.ceb.gjjs.mda.manager.module.Pswmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Pswp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 登录人修改密码
*/
@Transaction(vo= DbipswVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbipsw extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbipsw.class);

		@BDGetter
		private Pswgrp pswgrp;

		@BDGetter
		private Pswmod pswmod;

		@BDGetter
		private Pswp pswp;

		@BDGetter
		private Sysmod sysmod;


		public Dbipsw()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getPswmod().setPswgrpHolder(()->this.getPswgrp());
           this.getPswp().setPswgrpHolder(()->this.getPswgrp());
        }

        /**
        *   source:dbipsw.@0004.script
        */
        @Rule(target="pswp.submit",order=100)
        public boolean rulePswpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getSysmod().getUsr().getNotesid())&&!"95561".equals(this.getSysmod().getUsr().getNotesid())&&"2".equals(this.getSysmod().getUsr().getOtype()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbipsw","CT000018"),MdaUtils.getI18NString("dbipsw","CT000019"));
			  return true;
			}
			log.debug("{}","oldpws = "+MdaUtils.isEmpty(this.getPswgrp().getOldpws())+", "+this.getPswgrp().getOldpws());
			log.debug("{}","newpws = "+MdaUtils.isEmpty(this.getPswgrp().getNewpws())+", "+this.getPswgrp().getNewpws());
			log.debug("{}","cfmpws = "+MdaUtils.isEmpty(this.getPswgrp().getCfmpws())+", "+this.getPswgrp().getCfmpws());
			log.debug("{}","checkAll = "+ctx.checkAll(this.getPswgrp()));
			//if(!Platform.checkAll($pswgrp))
			if(MdaUtils.isEmpty(this.getPswgrp().getOldpws()))
			  ctx.setFieldError(this,"pswgrp.oldpws",MdaUtils.getI18NString("dbipsw","CT000020"));
			if(MdaUtils.isEmpty(this.getPswgrp().getNewpws()))
			  ctx.setFieldError(this,"pswgrp.newpws",MdaUtils.getI18NString("dbipsw","CT000021"));
			if(!ctx.checkAll(this.getPswgrp()))
			  return true;
			this.getPswgrp().getUsr().setInr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbRead(this.getPswgrp().getUsr(),new Argument<String>("inr",this.getPswgrp().getUsr().getInr()));
			String oldpws=null;
			String cfmpws=null;
			String newpws= null;
			String password=null;
			if(!MdaUtils.isEmpty(this.getPswgrp().getOldpws()))
			  oldpws= this.getPswgrp().getOldpws().trim();
			if(!MdaUtils.isEmpty(this.getPswgrp().getCfmpws()))
			  cfmpws= this.getPswgrp().getCfmpws().trim();
			if(!MdaUtils.isEmpty(this.getPswgrp().getNewpws()))
			  newpws= this.getPswgrp().getNewpws().trim();
			if(!MdaUtils.isEmpty(this.getPswgrp().getUsr().getPwd()))
			  password=this.getPswgrp().getUsr().getPwd().trim();
			if(oldpws!=null && password !=null && !oldpws.equals(password))
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbipsw","CT000030"),MdaUtils.getI18NString("dbipsw","CT000031"));
			  this.getPswgrp().setOldpws(NULLSTR);
			  this.getPswgrp().setNewpws(NULLSTR);
			  this.getPswgrp().setCfmpws(NULLSTR);
			  
			  
			  
			  return true;
			}
			if(cfmpws!=null && newpws!=null && oldpws!=null && cfmpws.equals(password))
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbipsw","CT000051"),MdaUtils.getI18NString("dbipsw","CT000052"));
			  return false;
			}
			this.getPswgrp().getUsr().setPwd(newpws);
			//$pswgrp\\usr\\updtim.setValue(Platform.today());
			//$pswgrp\\usr\\valdat.setValue(Platform.today());
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbUpdate(this.getPswgrp().getUsr());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbipsw","CT000057"),MdaUtils.getI18NString("dbipsw","CT000058"));

			return true;
        }


        /**
        *   source:dbipsw.@0005.script
        */
        @Check(target="pswgrp.cfmpws",order=100)
        public boolean checkPswgrpCfmpwsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getPswgrp().getNewpws()))
			  return true;
			if(!(this.getPswgrp().getNewpws()).equals(this.getPswgrp().getCfmpws()))
			  ctx.setFieldError(this,"pswgrp.cfmpws",MdaUtils.getI18NString("dbipsw","CT000046"));

			return true;
        }


        /**
        *   source:dbipsw.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPswgrp().getUsr().setLgnnam(this.getSysmod().getUsr().getLgnnam());
			this.getPswgrp().setOldpws(NULLSTR);
			this.getPswgrp().setCfmpws(NULLSTR);
			this.getPswgrp().setNewpws(NULLSTR);

			return true;
        }







}