package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbmautVO;

import com.ceb.gjjs.mda.manager.module.Autmod;
import com.ceb.gjjs.mda.manager.module.Autgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Autp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Authgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业业务授权模式定制
*/
@Transaction(vo= DbmautVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbmaut extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbmaut.class);

		@BDGetter
		private Autgrp autgrp;

		@BDGetter
		private Autmod autmod;

		@BDGetter
		private Autp autp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Authgrp authgrp;


		public Dbmaut()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getAutmod().setAutgrpHolder(()->this.getAutgrp());
           this.getAutp().setAutgrpHolder(()->this.getAutgrp());
        }

        /**
        *   source:dbmaut.@0009.script
        */
        @Rule(target="autp.submitamt",order=100)
        public boolean ruleAutpSubmitamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//2018.1.3 应业务人员需求，删除主管授权
			//1.对于修改过的，而又未经过主管审核的数据，是存储在临时文件中的，需要从临时文件读取
			//TODO
			//增加待授权记录
			ctx.getDaoSession().dbBegin();
			this.getAuthgrp().getAuth().setInr(Platform.sdbCounter("auth"));
			this.getAuthgrp().getAuth().setDattim(MdaUtils.today());
			this.getAuthgrp().getAuth().setUsrinr(this.getSysmod().getUsr().getInr());
			int index = 0;
			String subject = "业务授权模式定制";
			this.getAuthgrp().getAuth().setSub(subject);
			this.getAuthgrp().getAuth().setPtyinr(this.getAutp().getClipty().getInr());
			this.getAuthgrp().getAuth().setFrm("dbmaut");
			//$authgrp\\auth\\sta.setValue("W");
			this.getAuthgrp().getAuth().setSta("D");
			//$authgrp\\auth\\filenam.setValue(fileName);
			//$authgrp\\auth\\objinr.setValue($oprgrp\\usr\\inr.getValue());
			boolean result=false;
			if(index<0||index>this.getAutgrp().getModlstlst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000029"),MdaUtils.getI18NString("dbmaut","CT000030"));
			  return true;
			}
			else
			{
			  this.getAuthgrp().getAuth().setObjtyp(this.getAutgrp().getModlstlst().getElement(index).getFrm());
			  this.getAuthgrp().getAuth().setDtl(this.getAutgrp().getModlstlst().getElement(index).getNam());
			  ctx.getDaoSession().dbInsert(this.getAuthgrp().getAuth());
			  ctx.getDaoSession().dbCommit();
			  int errorCode =  ctx.getErrorCode();
			  if(errorCode==NO_ERROR)
			  {
			    addToShwaut();
			    //保存display文件
			    String fileName="/data/grant/dbmaut/dsp/"+this.getAuthgrp().getAuth().getInr()+".zul";
			    fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),fileName);
			    log.info("{}","filename is "+fileName);
			    ctx.saveDisplay(fileName);
			    /*
			      //保存数据文件
			      IStream os = $autp\\stream.getValue();
			      Platform.saveData($autgrp,os);
			      if(Platform.isEmpty(os))
			      log.warn("dbmaut:Stream os is empty");
			      String fileName = $authgrp\\auth\\inr.getValue()+".dat";
			      $sysmod.streamSaveInSubdir(os,"grant/dbmaut/dat/",fileName);
			      Platform.saveData($autp,os);
			      if(Platform.isEmpty(os))
			      log.warn("dbmaut:Stream os is empty");
			      fileName = $authgrp\\auth\\inr.getValue()+"autp.dat";
			      $sysmod.streamSaveInSubdir(os,"grant/dbmaut/dat/",fileName);
			      //保存display文件
			      fileName="/data/grant/dbmaut/dsp/"+$authgrp\\auth\\inr.getValue()+".zul";
			      fileName=Platform.catPath(Platform.getRootPath(),fileName);
			      log.info("filename is "+fileName);
			      Platform.saveDisplay($autp\\shwamt,fileName);
			      //提示
			      Platform.message("提示",#CT000052);
			      Platform.disable($autp\\submitamt);
			      }
			      else
			      {
			      log.error("业务授权模式定制失败:errorCode["+errorCode+"]");
			      Platform.message("错误",#CT000053);
			      return false;
			      */
			  }
			  String frmNam = this.getAutgrp().getModlst().getNam().trim();
			  log.debug("{}","所选交易为：" + frmNam);
			  int cnt = this.getAutgrp().getModlstlst().fullSize();
			  log.debug("{}","modlst大小为：" + cnt);
			  if("所有交易".equals(frmNam))
			  {
			    for(int i=1;i<cnt;i++)
			    {
			      result=updatePtyaut(this.getAutgrp().getModlstlst().getElement(i).getFrm());
			      if(!result)
			        break;
			    }
			  }
			  else
			  {
			    result=updatePtyaut(this.getAutgrp().getModlst().getFrm());
			  }
			}
			if(result)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000054"),MdaUtils.getI18NString("dbmaut","CT000055"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000056"),MdaUtils.getI18NString("dbmaut","CT000057"));
			}

			return true;
        }

        /**
        *   source:dbmaut.@0010.script
        */
        @Rule(target="autgrp.ptyaut.lvl",order=100)
        public boolean ruleAutgrpPtyautLvlN100(){
            IContext ctx = MdaEnv.getContext();
            
			for(int j = 0;j<=9;j++)
			  MdaUtils.clear(MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(j)));
			int lvl = Integer.valueOf(this.getAutgrp().getPtyaut().getLvl());
			if( lvl == 0)
			{
			  this.getAutp().setAuttyp("0");
			  
			}
			else
			{
			  
			  this.getAutp().setAmt0(new BigDecimal("0"));
			  (MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(2*lvl - 1))).setValue(new BigDecimal("999999999999999.99"));
			}
			for(int i = 1 ; i < lvl*2; i += 2 )
			{
			  IDatafield tmp = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i));
			  
			}
			for(int i = lvl*2 + 1 ; i < 10; i += 2 )
			{
			  IDatafield tmp = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i));
			  
			}
			if( lvl != 0)
			{
			  IDatafield tmp = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(lvl*2 - 1));
			  
			}
			for(int j = 0;j<=9;j++)
			{
			  
			}

			return true;
        }

        /**
        *   source:dbmaut.@0011.script
        */
        @Rule(target="autgrp.modlstlst",order=100)
        public boolean ruleAutgrpModlstlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *根据是否有授权记录，来判断定制信息是从序列化文件读取还是从数据库读取
			  */
			//1.判断是否有待授权记录
			//2.如果没有待授权记录，从数据库读取数据
			if(!isWaitingGrant())
			{
			  readInfoFromDB();
			  
			}
			//3.如果有待授权记录，从序列化文件读取.暂时不从文件读取，仅给客户提示信息
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000027"),MdaUtils.getI18NString("dbmaut","CT000028"));
			  
			}


			return true;
        }

        /**
        *   source:dbmaut.@0018.script
        */
        @Rule(target="autp.submitamt",order=200)
        public boolean ruleAutpSubmitamtN200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  $autgrp\\ptyaut\\frm.setValue($autgrp\\modlst\\nam.getValue());
			  String chkflg = $autgrp\\ptyaut\\chkflg.getValue();
			  int lvl = Integer.valueOf($autgrp\\ptyaut\\lvl.getValue());
			  //没有授权
			  if(lvl==0)
			  {
			  $autgrp\\shwaut.add();
			  int index=$autgrp\\shwaut.fullSize() - 1;
			  $autgrp\\shwaut[index].copyValue($autgrp\\ptyaut);
			  Platform.setModified($autgrp\\shwaut);
			  }
			  //有授权
			  else
			  {
			  for(int i = 0;i < lvl*2 ;i = i + 2 )
			  {
			  IDatafield lowamt = Platform.getDatafield($autp,"amt"+String.valueOf(i));
			  $autgrp\\ptyaut\\lowamt.setValue(new BigDecimal(String.valueOf(lowamt.getValue())));
			  IDatafield uppamt = Platform.getDatafield($autp,"amt"+String.valueOf(i+1));
			  $autgrp\\ptyaut\\uppamt.setValue(new BigDecimal(String.valueOf(uppamt.getValue())));
			  $autgrp\\shwaut.add();
			  int index=$autgrp\\shwaut.fullSize() - 1;
			  $autgrp\\shwaut[index].copyValue($autgrp\\ptyaut);
			  log.debug("Add to SHWAMT index = "+index);
			  Platform.setModified($autgrp\\shwaut);
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:dbmaut.@0020.script
        */
        @Rule(target="autp.select",order=100)
        public boolean ruleAutpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getAutp().getClilst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000044"),MdaUtils.getI18NString("dbmaut","CT000045"));
			  return true;
			}
			else
			{
			  MdaUtils.clear(this.getAutp().getClipty());
			  ctx.getDaoSession().dbRead(this.getAutp().getClipty(),new Argument("cid",this.getAutp().getClilst().getElement(index).getCid()));
			  loadModLst();
			  MdaUtils.clear(this.getAutgrp().getShwaut());
			  String sql = "SELECT distinct m.nam frm,p.chkflg chkflg,p.lvl lvl,p.lowamt lowamt,p.uppamt uppamt,p.inr FROM ptyaut p,modlst m,pty WHERE p.objtyp='pty' and p.objinr='"+this.getAutp().getClipty().getInr()+"' and pty.inr='"+this.getAutp().getClipty().getInr()+"' and pty.ptytyp=m.ptytyp and m.frm=p.frm order by p.inr desc ";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> frm = new Argument<String>("frm");
			  Argument<String> chkflg = new Argument<String>("chkflg");
			  Argument<String> lvl = new Argument<String>("lvl");
			  Argument<String> lowamt = new Argument<String>("lowamt");
			  Argument<String> uppamt = new Argument<String>("uppamt");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(frm,chkflg,lvl,lowamt,uppamt);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			    {
			      this.getAutgrp().getShwaut().add(frm,chkflg,lvl,lowamt,uppamt);
			    }
			    else
			    {
			      break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  
			  
			  //Platform.setValues($autgrp\\ptyaut\\chkflg,Platform.getCodetable("noneflgb"));
			  //Platform.setModified($autgrp\\ptyaut\\chkflg);
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:dbmaut.@0022.script
        */
        @Rule(target="autp.search",order=100)
        public boolean ruleAutpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","******业务权限模式定制 - 搜索*******");
			frush(1);

			/*Platform.clear($autp\\clilst);
			  String sql = "SELECT distinct clipty.cid cid,clipty.nam nam,clipty.engnam engnam FROM pty bchpty,pty clipty,ptr WHERE bchpty.inr = ptr.nxtptyinr and ptr.ptrtyp in ('0','1') and ptr.preptyinr=clipty.inr and bchpty.ptytyp='0' ";
			  if("1".equals($sysmod\\pty\\brhlvl.getValue()))
			  log.info("read all clientPty:"+sql );
			  else if("2".equals($sysmod\\pty\\brhlvl.getValue()))
			  {
			  sql=sql+" and substr(bchpty.cid,1,2) = '"+$sysmod\\pty\\cid.getValue().substring(0,2)+"' ";
			  log.info("read 分行 clientPty:"+sql );
			  }
			  else if("3".equals($sysmod\\pty\\brhlvl.getValue()) || "4".equals($sysmod\\pty\\brhlvl.getValue()) )
			  {
			  sql=sql+" and bchpty.inr='"+$sysmod\\pty\\inr.getValue()+"' ";
			  log.info("read  clientPty:"+sql );
			  }
			  if(!Platform.isEmpty($autp\\cid))
			  sql=sql+" and clipty.cid='"+$autp\\cid.getValue()+"'";
			  Platform.dbExecuteSQL(sql);
			  Argument<String> cid = new Argument<String>("cid");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> nam = new Argument<String>("nam");
			  int cnt=0;
			  while(true)
			  {
			  Platform.dbFetchFields(cid,nam,engnam);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  {
			  $autp\\clilst.add(cid,nam,engnam);
			  cnt++;
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  Platform.setModified($autp\\clilst);
			  if(cnt==0)
			  Platform.message(#CT000046,#CT000047);
			  */

			return true;
        }


        /**
        *   source:dbmaut.@0005.script
        */
        @Check(target="autp.auttyp",order=100)
        public boolean checkAutpAuttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String lvl = this.getAutgrp().getPtyaut().getLvl();
			if( lvl!=null&&(!"0".equals(lvl)) && "0".equals(this.getAutp().getAuttyp()))
			{
			  ctx.setFieldError(this,"autp.auttyp",MdaUtils.getI18NString("dbmaut","CT000014"));
			}

			return true;
        }

        /**
        *   source:dbmaut.@0006.script
        */
        @Check(target="autp.amt3",order=0)
        public boolean checkAutpAmt3N0(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAutp().getAmt3()))
			{
			  return true;
			}
			BigDecimal amt3 = this.getAutp().getAmt3();
			if(MdaUtils.isEmpty(this.getAutp().getAmt1()))
			{
			  ctx.setFieldError(this,"autp.amt3",MdaUtils.getI18NString("dbmaut","CT000018"));
			}
			else
			{
			  BigDecimal amt1 = this.getAutp().getAmt1();
			  if(amt1.compareTo(amt3) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt3",MdaUtils.getI18NString("dbmaut","CT000019"));
			  }
			}
			if(MdaUtils.isEmpty(this.getAutp().getAmt5()))
			{
			  return true;
			}
			else
			{
			  BigDecimal amt5 = this.getAutp().getAmt5();
			  if(amt3.compareTo(amt5) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt3",MdaUtils.getI18NString("dbmaut","CT000020"));
			  }
			}

			return true;
        }

        /**
        *   source:dbmaut.@0007.script
        */
        @Check(target="autp.amt5",order=0)
        public boolean checkAutpAmt5N0(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAutp().getAmt5()))
			{
			  return true;
			}
			BigDecimal amt5 = this.getAutp().getAmt5();
			if(MdaUtils.isEmpty(this.getAutp().getAmt3()))
			{
			  ctx.setFieldError(this,"autp.amt5",MdaUtils.getI18NString("dbmaut","CT000021"));
			}
			else
			{
			  BigDecimal amt3 = this.getAutp().getAmt3();
			  if(amt3.compareTo(amt5) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt5",MdaUtils.getI18NString("dbmaut","CT000022"));
			  }
			}
			if(MdaUtils.isEmpty(this.getAutp().getAmt7()))
			{
			  return true;
			}
			else
			{
			  BigDecimal amt7 = this.getAutp().getAmt7();
			  if(amt5.compareTo(amt7) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt5",MdaUtils.getI18NString("dbmaut","CT000023"));
			  }
			}

			return true;
        }

        /**
        *   source:dbmaut.@0008.script
        */
        @Check(target="autp.amt7",order=0)
        public boolean checkAutpAmt7N0(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAutp().getAmt7()))
			{
			  return true;
			}
			BigDecimal amt7 = this.getAutp().getAmt7();
			if(MdaUtils.isEmpty(this.getAutp().getAmt5()))
			{
			  ctx.setFieldError(this,"autp.amt7",MdaUtils.getI18NString("dbmaut","CT000024"));
			}
			else
			{
			  BigDecimal amt5 = this.getAutp().getAmt5();
			  if(amt5.compareTo(amt7) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt7",MdaUtils.getI18NString("dbmaut","CT000025"));
			  }
			}
			if(MdaUtils.isEmpty(this.getAutp().getAmt9()))
			{
			  return true;
			}
			else
			{
			  BigDecimal amt9 = this.getAutp().getAmt9();
			  if(amt7.compareTo(amt9) >= 0)
			  {
			    ctx.setFieldError(this,"autp.amt7",MdaUtils.getI18NString("dbmaut","CT000026"));
			  }
			}

			return true;
        }


        /**
        *   source:dbmaut.@0021.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			String ptyinr=this.getSysmod().getPty().getInr();
			List<CodetableItem>bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this.getAutp(),"ptynam",bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			{
			  this.getAutp().setPtynam(bchcod.get(0).getValue());
			}
			
			frush(0);

			/*
			  String sql = "SELECT distinct clipty.cid cid,clipty.nam nam,clipty.engnam engnam FROM pty bchpty,pty clipty,ptr WHERE bchpty.inr = ptr.nxtptyinr and ptr.ptrtyp in ('0','1') and ptr.preptyinr=clipty.inr and bchpty.ptytyp='0' ";
			  if("1".equals($sysmod\\pty\\brhlvl.getValue()))
			  log.info("read all clientPty:"+sql );
			  else if("2".equals($sysmod\\pty\\brhlvl.getValue()))
			  {
			  sql=sql+" and substr(bchpty.cid,1,2) = '"+$sysmod\\pty\\cid.getValue().substring(0,2)+"' ";
			  log.info("read 分行 clientPty:"+sql );
			  }
			  else if("3".equals($sysmod\\pty\\brhlvl.getValue()) || "4".equals($sysmod\\pty\\brhlvl.getValue()))
			  {
			  sql=sql+" and bchpty.inr='"+$sysmod\\pty\\inr.getValue()+"' ";
			  log.info("read  clientPty:"+sql );
			  }
			  Platform.dbExecuteSQL(sql);
			  Argument<String> cid = new Argument<String>("cid");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> nam = new Argument<String>("nam");
			  while(true)
			  {
			  Platform.dbFetchFields(cid,nam,engnam);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  {
			  $autp\\clilst.add(cid,nam,engnam);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  Platform.setModified($autp\\clilst);
			  */

			return true;
        }


        /**
        *   source:dbmaut.@0012.script
        */
        public void loadModLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getAutgrp().getModlstlst());
			String sql = "SELECT m.inr,m.frm,m.nam,m.trntyp FROM modlst m LEFT OUTER JOIN";
			sql += " (SELECT * FROM ptymod WHERE ptyinr='"+this.getAutp().getClipty().getInr()+"'";
			if("3".equals(this.getAutp().getClipty().getPtytyp()))
			  sql += " OR ptyinr = (SELECT nxtptyinr FROM ptr WHERE ptrtyp = '2' AND preptyinr = '"+this.getAutp().getClipty().getInr()+"')";
			sql += ") p ON m.frm=p.frm";
			//modtyp='0',表示只有申请类交易需要进行业务授权模式定制
			sql += " WHERE m.modtyp='0' AND m.ptytyp='"+this.getAutp().getClipty().getPtytyp()+"' AND p.ptyinr IS NULL ORDER BY m.trntyp";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> nam = new Argument<String>("nam");
			this.getAutgrp().getModlstlst().add();
			this.getAutgrp().getModlstlst().getElement(0).setFrm("");
			this.getAutgrp().getModlstlst().getElement(0).setNam("所有交易");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,frm,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    //去掉入口交易
			    if((frm.value).length() < 7 && !"-bdtfre-brtfre-letfre-detfre-".contains(frm.value))
			      this.getAutgrp().getModlstlst().add(inr,frm,nam);
			  }
			  else if(errorCode == NO_MORE_ROW)
			  {
			    break;
			  }
			  else
			  {
			    log.error("{}","errorCode:"+errorCode);
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmaut.@0015.script
        */
        public boolean isWaitingGrant()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//判断当前交易是否有待授权记录
			int index = 0;
			ctx.getDaoSession().dbRead(this.getAuthgrp().getAuth(),new Argument<String>("objtyp",this.getAutgrp().getModlstlst().getElement(index).getFrm()),new Argument<String>("ptyinr",this.getSysmod().getPty().getInr()),new Argument<String>("sta","W"));
			int errorCode=ctx.getErrorCode();
			if(errorCode==NO_MORE_ROW)
			{
			  log.debug("{}","no record is waiting to be granted!");
			  return false;
			}
			else
			{
			  log.debug("{}","Record is waiting to be granted!");
			  return true;
			}
		}
        /**
        *   source:dbmaut.@0016.script
        */
        public void readInfoFromDB()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int j = 0;j<=9;j++)
			{
			  MdaUtils.clear(MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(j)));
			  
			}
			int index = 0;
			int length = this.getAutgrp().getModlstlst().fullSize();
			this.getAutgrp().getModlst().copyValue(this.getAutgrp().getModlstlst().getElement(index));
			
			MdaUtils.clear(this.getAutgrp().getPtyautlst());
			String objinr = this.getSysmod().getPty().getInr();
			String objtyp = "pty";
			/*
			  if("1".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //商行维护的是其及下属企业的业务授权模式
			  objinr = $sysmod\\pty\\etyinr.getValue();
			  objtyp = "ety";
			  }
			  else if("2".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //本行企业维护的是自身的业务授权模式
			  objinr = $sysmod\\pty\\inr.getValue();
			  objtyp = "pty";
			  }
			  */
			String queryClause = "SELECT * FROM ptyaut WHERE objtyp = '" + objtyp + "' AND objinr = '" + objinr + "' AND frm = '"+ this.getAutgrp().getModlst().getFrm() +"' ORDER BY lowamt";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> chkflg = new Argument<String>("chkflg");
			Argument<String> lvl = new Argument<String>("lvl");
			Argument<String> flg1 = new Argument<String>("flg1");
			Argument<String> flg2 = new Argument<String>("flg2");
			Argument<BigDecimal> lowamt = new Argument<BigDecimal>("lowamt");
			Argument<BigDecimal> uppamt = new Argument<BigDecimal>("uppamt");
			int i = 0 ;
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(chkflg,lvl,flg1,flg2,lowamt,uppamt);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAutgrp().getPtyautlst().add(chkflg,lvl,flg1,flg2,lowamt,uppamt);
			    this.getAutgrp().getPtyaut().setChkflg(chkflg.value);
			    this.getAutgrp().getPtyaut().setLvl(lvl.value);
			    this.getAutgrp().getPtyaut().setFlg1(flg1.value);
			    this.getAutgrp().getPtyaut().setFlg2(flg2.value);
			    (MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i))).setValue(lowamt.value);
			    (MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i+1))).setValue(uppamt.value);
			  }
			  else if(errorCode == NO_MORE_ROW)
			  {
			    if(i == 0)
			    {
			      //没有记录
			      this.getAutgrp().getPtyaut().setChkflg("1");
			      this.getAutgrp().getPtyaut().setLvl("0");
			      this.getAutp().setAuttyp("0");
			    }
			    for(int j = i;j<=9;j++)
			    {
			      //(Platform.getDatafield($autp,"amt"+String.valueOf(j))).setValue(new BigDecimal(""));
			      MdaUtils.clear(MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(j)));
			      
			    }
			    break;
			  }
			  else
			  {
			    break;
			  }
			  i += 2;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			
			String getflg1 = this.getAutgrp().getPtyaut().getFlg1();
			String getflg2 = this.getAutgrp().getPtyaut().getFlg2();
			if("0".equals(getflg1) && "1".equals(getflg2))
			{
			  this.getAutp().setAuttyp("1");
			}
			else if("1".equals(getflg1) && "0".equals(getflg2))
			{
			  this.getAutp().setAuttyp("2");
			}
			else
			{
			  this.getAutp().setAuttyp("0");
			}
			if("0".equals(this.getAutgrp().getPtyaut().getLvl()))
			{
			  
			}
			else
			{
			  
			}
			
			for(int j = 0;j<=9;j++)
			{
			  
			}
		}
        /**
        *   source:dbmaut.@0017.script
        */
        public void readInfoFromFile()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//TODO
					}
        /**
        *   source:dbmaut.@0019.script
        */
        public void addToShwaut()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getAutgrp().getShwaut());
			this.getAutgrp().getPtyaut().setFrm(this.getAutgrp().getModlst().getNam());
			String chkflg = this.getAutgrp().getPtyaut().getChkflg();
			int lvl = Integer.valueOf(this.getAutgrp().getPtyaut().getLvl());
			//没有授权
			if(lvl==0)
			{
			  this.getAutgrp().getShwaut().add();
			  int index=this.getAutgrp().getShwaut().fullSize() - 1;
			  this.getAutgrp().getShwaut().getElement(index).copyValue(this.getAutgrp().getPtyaut());
			  
			}
			//有授权
			else
			{
			  for(int i = 0;i < lvl*2 ;i = i + 2 )
			  {
			    IDatafield lowamt = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i));
			    this.getAutgrp().getPtyaut().setLowamt(new BigDecimal(String.valueOf(lowamt.getValue())));
			    IDatafield uppamt = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i+1));
			    this.getAutgrp().getPtyaut().setUppamt(new BigDecimal(String.valueOf(uppamt.getValue())));
			    this.getAutgrp().getShwaut().add();
			    int index=this.getAutgrp().getShwaut().fullSize() - 1;
			    this.getAutgrp().getShwaut().getElement(index).copyValue(this.getAutgrp().getPtyaut());
			    log.debug("{}","Add to SHWAMT index = "+index);
			    
			  }
			}
		}
        /**
        *   source:dbmaut.@0023.script
        */
        public boolean updatePtyaut(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbBegin();
			String objinr = this.getAutp().getClipty().getInr();
			String objtyp = "pty";
			ctx.getDaoSession().dbDelete(this.getAutgrp().getPtyaut(),new Argument<String>("objinr",objinr),new Argument<String>("frm",frm),new Argument<String>("objtyp",objtyp));
			this.getAutgrp().getPtyaut().setObjtyp(objtyp);
			this.getAutgrp().getPtyaut().setObjinr(objinr);
			this.getAutgrp().getPtyaut().setFrm(frm);
			this.getAutgrp().getPtyaut().setCur("USD");
			String chkflg = this.getAutgrp().getPtyaut().getChkflg();
			log.info("{}","lvl:"+this.getAutgrp().getPtyaut().getLvl());
			int lvl = Integer.valueOf(this.getAutgrp().getPtyaut().getLvl());
			String flg = "O";
			//是否复核
			if("0".equals(chkflg))
			  flg = flg + "B";
			//没有授权
			if(lvl==0)
			{
			  this.getAutgrp().getPtyaut().setInr(Platform.sdbCounter("ptyaut"));
			  this.getAutgrp().getPtyaut().setFlg(flg);
			  ctx.getDaoSession().dbInsert(this.getAutgrp().getPtyaut());
			}
			//有授权
			else
			{
			  String auttyp = this.getAutp().getAuttyp();
			  //不可跨级完全授权
			  this.getAutgrp().getPtyaut().setFlg1("1");
			  this.getAutgrp().getPtyaut().setFlg2("0");
			  for(int i = 0;i < lvl*2 ;i = i + 2 )
			  {
			    flg = flg + "A";
			    this.getAutgrp().getPtyaut().setFlg(flg);
			    this.getAutgrp().getPtyaut().setInr(Platform.sdbCounter("ptyaut"));
			    IDatafield lowamt = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i));
			    this.getAutgrp().getPtyaut().setLowamt(new BigDecimal(String.valueOf(lowamt.getValue())));
			    IDatafield uppamt = MdaDriver.getDatafield(this.getAutp(),"amt"+String.valueOf(i+1));
			    this.getAutgrp().getPtyaut().setUppamt(new BigDecimal(String.valueOf(uppamt.getValue())));
			    ctx.getDaoSession().dbInsert(this.getAutgrp().getPtyaut());
			    log.debug("{}","Insert ptyaut inr = "+this.getAutgrp().getPtyaut().getInr()+", typ = "+objtyp);
			  }
			}
			ctx.getDaoSession().dbCommit();
			int errorCode=ctx.getErrorCode();
			if(errorCode==NO_ERROR)
			{
			  //Platform.message(#CT000048,#CT000049);
			  return true;
			}
			else
			{
			  //Platform.message(#CT000050,#CT000051);
			  return false;
			}
		}
        /**
        *   source:dbmaut.@0024.script
        */
        public void frush(int ischk)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getAutp().getClilst());
			String ptych="";
			String ptyyh="";
			int cnt=0;

			String sql="select distinct ch.cid cid,ch.nam nam,ch.engnam engnam from pty ch,ptr p where ch.inr=p.preptyinr and p.ptrtyp in ('0','1') and ch.ptytyp='2'";
			//输入企业客户cid
			if(!MdaUtils.isEmpty(this.getAutp().getCid()))
			{
			  ptych=getinrByCid(this.getAutp().getCid());
			  if(MdaUtils.isEmpty(ptych))
			  {
			    ctx.setFieldError(this,"autp.ptynam",MdaUtils.getI18NString("dbmaut","CT000068"));
			    return;
			  }
			  else
			    sql=sql+" and ch.cid='"+this.getAutp().getCid()+"'";

			}
			//机构隔离
			if(!MdaUtils.isEmpty(this.getAutp().getPtynam()))
			  ptyyh=this.getAutp().getPtynam();
			else
			  ptyyh=this.getSysmod().getPty().getInr();

			String cids=this.getSysmod().getCidByInr(ptyyh);
			String lvl=this.getSysmod().getTransLevel(cids);
			if("0".equals(lvl))
			{
			  sql=sql+" and exists(select inr from pty yh where yh.inr = p.nxtptyinr and yh.ptytyp='0' )";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+" and  EXISTS (select inr from pty yh where yh.inr = p.nxtptyinr AND yh.ptytyp='0' AND (yh.pntinr='"+cids+"' or p.nxtptyinr='"+ptyyh+"'))";
			}
			else
			{
			  sql=sql+" and  p.nxtptyinr='"+ptyyh+"'";
			}

			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> cid = new Argument<String>("cid");
			Argument<String> engnam = new Argument<String>("engnam");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cid,nam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAutp().getClilst().add(cid,nam,engnam);
			    cnt++;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			if(ischk==1 && cnt==0)
			{
			  if(!MdaUtils.isEmpty(this.getAutp().getCid()))
			    ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000069"),MdaUtils.getI18NString("dbmaut","CT000084"));
			  else
			    ctx.setMessage(MdaUtils.getI18NString("dbmaut","CT000085"),MdaUtils.getI18NString("dbmaut","CT000086"));
			}
		}
        /**
        *   source:dbmaut.@0025.script
        */
        public String getinrByCid(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(cid))
			{
			  return null;
			}
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM pty WHERE ptytyp=2 and cid='"+cid+"'");
			ctx.getDaoSession().dbFetchFields(inr);
			int e=ctx.getErrorCode();
			if(e==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(inr.value))
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    return inr.value;
			  }
			  else
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    return null;
			  }
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return null;
			}
		}






}