package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DbmbntVO;

import com.ceb.gjjs.mda.manager.module.Nttp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 通知开通/关闭控制
*/
@Transaction(vo= DbmbntVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbmbnt extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbmbnt.class);

        //交易说明
        private String note;
		@BDGetter
		private Nttp nttp;

		@BDGetter
		private Sysmod sysmod;


		public Dbmbnt()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:dbmbnt.@0001.script
        */
        @Rule(target="nttp.sav",order=100)
        public boolean ruleNttpSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","***************新增保存功能******************");
			int length = this.getNttp().getTsclst1().fullSize();
			log.info("{}","size of tsclst1 is ="+length);
			ctx.getDaoSession().dbBegin();
			for(int index = 0;index < length;index++)
			{
			  MdaUtils.clear(this.getNttp().getTsc());
			  if("X".equals(this.getNttp().getTsclst1().getElement(index).getNotflg()))
			  {
			    this.getNttp().getTsc().setInr(Platform.sdbCounter("tsc"));
			    this.getNttp().getTsc().setNotflg("X");
			    if(!"X".equals(this.getNttp().getTsclst1().getElement(index).getImgflg()))
			    {
			      this.getNttp().getTsc().setImgflg("");
			    }
			    else
			    {
			      this.getNttp().getTsc().setImgflg("X");
			    }
			    this.getNttp().getTsc().setTrnnam(this.getNttp().getTsclst1().getElement(index).getTrnnam());
			    this.getNttp().getTsc().setTrncod(this.getNttp().getTsclst1().getElement(index).getTrncod());
			    ctx.getDaoSession().dbInsert(this.getNttp().getTsc());
			    log.debug("{}","**************开通更新*************"+index+" "+this.getNttp().getTsclst1().getElement(index).getTrnnam());
			  }
			  log.debug("{}","****************"+this.getNttp().getTsclst1().getElement(index).getTrnnam());
			  log.debug("{}","****************"+this.getNttp().getTsclst1().getElement(index).getTrncod());
			  log.debug("{}","****************"+this.getNttp().getTsclst1().getElement(index).getNotflg());
			  log.debug("{}","****************"+this.getNttp().getTsclst1().getElement(index).getImgflg());
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbmbnt","CT000000"),MdaUtils.getI18NString("dbmbnt","CT000001"));
			
			log.info("{}","*************保存功能结束******************");

			return true;
        }

        /**
        *   source:dbmbnt.@0003.script
        */
        @Rule(target="nttp.allchs",order=100)
        public boolean ruleNttpAllchsN100(){
            IContext ctx = MdaEnv.getContext();
            
			boolean selall = true;
			log.debug("{}","selall");
			int cursize = this.getNttp().getTsclst().size();
			int selidx = 0;
			int realidx = this.getNttp().getTsclst().getRealIndex(selidx);
			int pages = this.getNttp().getTsclst().getPage();
			int pagesize = this.getNttp().getTsclst().getPageSize();
			log.debug("{}","cursize="+cursize);
			log.debug("{}","sel idx="+selidx);
			log.debug("{}","realidx="+realidx);
			log.debug("{}","pages="+pages);
			log.debug("{}","pagesize="+pagesize);
			int begin = pagesize * ( pages - 1 );
			int end = begin+cursize;
			log.debug("{}","begin="+begin);
			log.debug("{}","end="+end);
			for(int i=begin;i<end;i++)
			{
			  if(!"X".equals(this.getNttp().getTsclst().getElement(i).getNotflg()) || !"X".equals(this.getNttp().getTsclst().getElement(i).getImgflg()))
			  {
			    selall=false;
			    this.getNttp().getTsclst().getElement(i).setNotflg("X");
			    this.getNttp().getTsclst().getElement(i).setImgflg("X");
			  }
			}
			if(selall)
			{
			  for(int i=begin;i<end;i++)
			  {
			    this.getNttp().getTsclst().getElement(i).setNotflg("");
			    this.getNttp().getTsclst().getElement(i).setImgflg("");
			  }
			}
			

			return true;
        }

        /**
        *   source:dbmbnt.@0005.script
        */
        @Rule(target="nttp.add",order=100)
        public boolean ruleNttpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			//tscsel();
			//Platform.closePanel($nttp\\notsea);
			//Platform.popup($nttp\\notctr);
			tscssl();
			

			return true;
        }

        /**
        *   source:dbmbnt.@0006.script
        */
        @Rule(target="nttp.alt",order=100)
        public boolean ruleNttpAltN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","*************修改功能******************");
			ctx.getDaoSession().dbBegin();
			int length = this.getNttp().getTsclst().fullSize();
			for(int index = 0;index < length;index++)
			{
			  if(!"X".equals(this.getNttp().getTsclst().getElement(index).getNotflg()))
			  {
			    MdaUtils.clear(this.getNttp().getTsc());
			    ctx.getDaoSession().dbRead(this.getNttp().getTsc(),new Argument<String>("inr",this.getNttp().getTsclst().getElement(index).getInr()));
			    ctx.getDaoSession().dbDelete(this.getNttp().getTsc());
			    log.debug("{}","**************删除*************"+index);
			  }
			  if("X".equals(this.getNttp().getTsclst().getElement(index).getNotflg()))
			  {
			    MdaUtils.clear(this.getNttp().getTsc());
			    ctx.getDaoSession().dbRead(this.getNttp().getTsc(),new Argument<String>("inr",this.getNttp().getTsclst().getElement(index).getInr()));
			    this.getNttp().getTsc().setImgflg(this.getNttp().getTsclst().getElement(index).getImgflg());
			    ctx.getDaoSession().dbUpdate(this.getNttp().getTsc());
			    log.debug("{}","**************修改*************"+index);
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbmbnt","CT000002"),MdaUtils.getI18NString("dbmbnt","CT000003"));
			trnsea();
			log.info("{}","*************修改功能结束******************");

			return true;
        }

        /**
        *   source:dbmbnt.@0008.script
        */
        @Rule(target="nttp.rebck",order=100)
        public boolean ruleNttpRebckN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			trnsea();

			return true;
        }

        /**
        *   source:dbmbnt.@0009.script
        */
        @Rule(target="nttp.refsh",order=100)
        public boolean ruleNttpRefshN100(){
            IContext ctx = MdaEnv.getContext();
            
			tscssl();
			//tscsel();
			
			return true;
        }

        /**
        *   source:dbmbnt.@0010.script
        */
        @Rule(target="nttp.refshs",order=100)
        public boolean ruleNttpRefshsN100(){
            IContext ctx = MdaEnv.getContext();
            
			trnsea();

			return true;
        }

        /**
        *   source:dbmbnt.@0011.script
        */
        @Rule(target="nttp.allsel",order=100)
        public boolean ruleNttpAllselN100(){
            IContext ctx = MdaEnv.getContext();
            
			boolean selall = true;
			log.debug("{}","selall");
			int cursize = this.getNttp().getTsclst1().size();
			int selidx = 0;
			int realidx = this.getNttp().getTsclst1().getRealIndex(selidx);
			int pages = this.getNttp().getTsclst1().getPage();
			int pagesize = this.getNttp().getTsclst1().getPageSize();
			log.debug("{}","cursize="+cursize);
			log.debug("{}","sel idx="+selidx);
			log.debug("{}","realidx="+realidx);
			log.debug("{}","pages="+pages);
			log.debug("{}","pagesize="+pagesize);
			int begin = pagesize * ( pages - 1 );
			int end = begin+cursize;
			log.debug("{}","begin="+begin);
			log.debug("{}","end="+end);
			for(int i=begin;i<end;i++)
			{
			  if(!"X".equals(this.getNttp().getTsclst1().getElement(i).getNotflg()) || !"X".equals(this.getNttp().getTsclst1().getElement(i).getImgflg()))
			  {
			    selall=false;
			    this.getNttp().getTsclst1().getElement(i).setNotflg("X");
			    this.getNttp().getTsclst1().getElement(i).setImgflg("X");
			  }
			}
			if(selall)
			{
			  for(int i=begin;i<end;i++)
			  {
			    this.getNttp().getTsclst1().getElement(i).setNotflg("");
			    this.getNttp().getTsclst1().getElement(i).setImgflg("");
			  }
			}
			

			return true;
        }



        /**
        *   source:dbmbnt.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			trnsea();

			return true;
        }


        /**
        *   source:dbmbnt.@0000.script
        */
        public void tscsel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","***************新增查询开始****************");
			Argument<String> trnnam =new Argument<String>("trnnam");
			Argument<String> trncod =new Argument<String>("trncod");
			String sql="SELECT nam trnnam,frm trncod FROM modlst where modtyp='1' and frm not in ("+this.getNttp().getCtrcod()+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode() ;
			log.info("{}","查询语句 ="+sql);
			if(errCod==NO_ERROR)
			{
			  MdaUtils.clear(this.getNttp().getTsclst());
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(trnnam,trncod);
			    int errCod1 = ctx.getErrorCode();
			    if(errCod1==NO_ERROR)
			    {
			      this.getNttp().getTsclst().add(trnnam,trncod);
			      log.debug("{}","while 交易名称"+trnnam.value+" \t代码"+trncod.value);
			    }
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			log.info("{}","***************新增查询结束****************");
		}
        /**
        *   source:dbmbnt.@0004.script
        */
        public void trnsea()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getNttp().getTsclst());
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> trnnam =new Argument<String>("trnnam");
			Argument<String> trncod =new Argument<String>("trncod");
			Argument<String> notflg =new Argument<String>("notflg");
			Argument<String> imgflg =new Argument<String>("imgflg");
			String sql="SELECT inr,trnnam,trncod,notflg,imgflg FROM tsc ";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode();
			log.info("{}","已开通业务的查询语句 ="+sql);
			log.info("{}","errCod ="+errCod);
			String trans="";
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,trnnam,trncod,notflg,imgflg);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    trans=trans+"'"+trncod.value+"',";
			    this.getNttp().getTsclst().add(inr,trnnam,trncod,notflg,imgflg);
			  }
			  else
			    break;
			}
			trans=trans+"' '";
			this.getNttp().setCtrcod(trans);
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmbnt.@0007.script
        */
        public void tscssl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","***************新增查询开始****************");
			Argument<String> trnnam =new Argument<String>("trnnam");
			Argument<String> trncod =new Argument<String>("trncod");
			String sql="SELECT nam trnnam,frm trncod FROM modlst where modtyp='1' and frm not in ("+this.getNttp().getCtrcod()+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errCod =  ctx.getErrorCode() ;
			log.info("{}","查询语句 ="+sql);
			if(errCod==NO_ERROR)
			{
			  MdaUtils.clear(this.getNttp().getTsclst1());
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(trnnam,trncod);
			    int errCod1 = ctx.getErrorCode();
			    if(errCod1==NO_ERROR)
			    {
			      this.getNttp().getTsclst1().add(trnnam,trncod);
			      log.debug("{}","while 交易名称"+trnnam.value+" \t代码"+trncod.value);
			    }
			    else
			      break;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			log.info("{}","***************新增查询结束****************");
		}




}