package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Dbmbpr0VO;

import com.ceb.gjjs.mda.manager.module.Bprgrp;
import com.ceb.gjjs.mda.manager.module.Bprmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bprp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行操作员绑定
*/
@Transaction(vo= Dbmbpr0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbmbpr0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbmbpr0.class);

		@BDGetter
		private Bprgrp bprgrp;

		@BDGetter
		private Bprmod bprmod;

		@BDGetter
		private Bprp bprp;

		@BDGetter
		private Sysmod sysmod;


		public Dbmbpr0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBprmod().setBprgrpHolder(()->this.getBprgrp());
           this.getBprp().setBprgrpHolder(()->this.getBprgrp());
        }

        /**
        *   source:dbmbpr0.@0004.script
        */
        @Rule(target="bprp.addallrol",order=100)
        public boolean ruleBprpAddallrolN100(){
            IContext ctx = MdaEnv.getContext();
            
			for(int i = 0 ; i < this.getBprgrp().getRollst().fullSize(); i++)
			{
			  this.getBprgrp().getSelrol().add(this.getBprgrp().getRollst().get(i));
			  this.getBprgrp().getRollst().remove(i);
			  i--;
			}
			
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0005.script
        */
        @Rule(target="bprp.delallrol",order=100)
        public boolean ruleBprpDelallrolN100(){
            IContext ctx = MdaEnv.getContext();
            
			for(int i = 0 ; i < this.getBprgrp().getSelrol().fullSize(); i++)
			{
			  this.getBprgrp().getRollst().add(this.getBprgrp().getSelrol().get(i));
			  this.getBprgrp().getSelrol().remove(i);
			  i--;
			}
			
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0006.script
        */
        @Rule(target="bprp.rtn",order=100)
        public boolean ruleBprpRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.chain("dbmbpr");
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0007.script
        */
        @Rule(target="bprgrp.rollst",order=0)
        public boolean ruleBprgrpRollstN0(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			this.getBprgrp().getSelrol().add(this.getBprgrp().getRollst().get(index));
			this.getBprgrp().getRollst().remove(index);
			
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0008.script
        */
        @Rule(target="bprgrp.selrol",order=0)
        public boolean ruleBprgrpSelrolN0(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			this.getBprgrp().getRollst().add(this.getBprgrp().getSelrol().get(index));
			this.getBprgrp().getSelrol().remove(index);
			
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0009.script
        */
        @Rule(target="bprp.search",order=100)
        public boolean ruleBprpSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			//如果条件为空，则全部读取
			/*
			  if(Platform.isEmpty($bprp\\selno))
			  {
			  Platform.dbReadset($bprgrp\\ptylst,new Argument<String>("ptytyp","0"));
			  }
			  else
			  {
			  Platform.dbReadset($bprgrp\\ptylst,Argument.or(new Argument<Object>("cid",LIKE,$bprp\\selno.getValue()),new Argument<Object>("nam",LIKE,$bprp\\selno.getValue())),new Argument<String>("ptytyp","0"));
			  }
			
			  Platform.setModified($bprgrp\\ptylst);
			  */
			bchSearch();

			return true;
        }

        /**
        *   source:dbmbpr0.@0010.script
        */
        @Rule(target="bprp.selpty",order=100)
        public boolean ruleBprpSelptyN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getBprgrp().getPtylst().fullSize();
			if(this.getBprgrp().getPtylst().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmbpr0","CT000048"),MdaUtils.getI18NString("dbmbpr0","CT000049"));
			  return true;
			}
			log.info("{}","ptylst取到符合条件的记录条数========" + length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmbpr0","CT000050"),MdaUtils.getI18NString("dbmbpr0","CT000051"));
			  return true;
			}
			ctx.getDaoSession().dbRead(this.getBprgrp().getPty(),new Argument<String>("inr",this.getBprgrp().getPtylst().getElement(index).getInr()));
			
			log.info("{}","nam="+this.getBprgrp().getPty().getNam()+" value="+this.getBprgrp().getPty().getInr());
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0011.script
        */
        @Rule(target="bprp.sel",order=0)
        public boolean ruleBprpSelN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0015.script
        */
        @Rule(target="bprp.grant",order=100)
        public boolean ruleBprpGrantN100(){
            IContext ctx = MdaEnv.getContext();
            
			//授权之前需要重新读取数据，防止主管修改数据后提交
			loadData();
			ctx.getDaoSession().dbBegin();
			//如果是新增用户，只要修改状态即可
			if("I".equals(this.getBprgrp().getUsr().getStat()))
			{
			  this.getBprgrp().getUsr().setStat(null);
			  ctx.getDaoSession().dbUpdate(this.getBprgrp().getUsr());
			}
			//如果是修改用户信息，需要把序列化文件中的数据替换数据库中的数据
			else if("U".equals(this.getBprgrp().getUsr().getStat()))
			{
			  this.getBprgrp().getUsr().setStat(null);
			  ctx.getDaoSession().dbUpdate(this.getBprgrp().getUsr());
			  for(int i = 0; i < this.getBprgrp().getSelrol().fullSize(); i++)
			  {
			    //添加新记录
			    if(!existusrRol(this.getBprgrp().getSelrol().getElement(i).getInr()))
			    {
			      this.getBprgrp().getUsrrol().setInr(Platform.sdbCounter("usrrol"));
			      this.getBprgrp().getUsrrol().setUsrinr(this.getBprgrp().getUsr().getInr());
			      this.getBprgrp().getUsrrol().setRolinr(this.getBprgrp().getSelrol().getElement(i).getInr());
			      this.getBprgrp().getUsrrol().setRolnam(this.getBprgrp().getSelrol().getElement(i).getRolnam());
			      this.getBprgrp().getUsrrol().setPtyinr(this.getBprgrp().getPty().getInr());
			      log.info("{}","ins "+this.getBprgrp().getUsrrol().getUsrinr()+" rol "+this.getBprgrp().getUsrrol().getRolinr());
			      ctx.getDaoSession().dbInsert(this.getBprgrp().getUsrrol());
			    }
			  }
			  for(int i = 0; i < this.getBprgrp().getRollst().fullSize(); i++)
			  {
			    //删除已有记录
			    if(existusrRol(this.getBprgrp().getRollst().getElement(i).getInr()))
			    {
			      ctx.getDaoSession().dbRead(this.getBprgrp().getUsrrol(),new Argument<String>("rolinr",this.getBprgrp().getRollst().getElement(i).getInr()),new Argument<String>("usrinr",this.getBprgrp().getUsr().getInr()));
			      log.info("{}","del "+this.getBprgrp().getUsrrol().getUsrinr()+" rol "+this.getBprgrp().getUsrrol().getRolinr());
			      ctx.getDaoSession().dbDelete(this.getBprgrp().getUsrrol());
			    }
			  }
			}
			//删除授权任务
			IModule auth = (IModule)ctx.restoreData("com.brilliance.sysaut.auth");
			this.getBprgrp().getAuth().copyValue(auth);
			ctx.getDaoSession().dbDelete(this.getBprgrp().getAuth());
			ctx.getDaoSession().dbCommit();
			

			return true;
        }

        /**
        *   source:dbmbpr0.@0017.script
        */
        @Rule(target="bprp.submit",order=100)
        public boolean ruleBprpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *auth:对于新增的数据，标志位为A,对于修改的数据，标志位为U,修改后的数据存储在序列化文件里。
			  *usr、usrrol:管理员保存以后，只是把文件序列化，并不真正存入数据库。待主管授权后，才真正入库。
			  */
			/*//
			log.debug("{}","dbmopr0 checkgrp = "+ctx.checkAll(this.getBprgrp()));
			if(!ctx.checkAll(this.getBprgrp()))
			return false;
			log.debug("{}","Not return!");
			this.getBprgrp().getUsr().setFilcnt(0);
			this.getBprgrp().getUsr().setUsrflg("0");
			log.debug("{}","pwd is null?"+MdaUtils.isEmpty(this.getBprp().getPwd()));
			this.getBprgrp().getUsr().setPtyinr(this.getBprgrp().getPty().getInr());
			this.getBprgrp().getUsr().setPtynam(this.getBprgrp().getPty().getNam());
			this.getBprgrp().getUsr().setCid(this.getBprgrp().getPty().getCid());
			//$bprgrp\\usr\\ncid.setValue($bprgrp\\pty\\cid.getValue());
			//授权列表的标题
			ctx.getDaoSession().dbBegin();
			String subject = "";
			String fileName = "";
			if(MdaUtils.isEmpty(this.getBprgrp().getUsr().getInr()))
			{
			// */
			/*
			  if(usrIsExist($bprgrp\\usr\\lgnnam.getValue()))
			  {
			  Platform.message(#CT000066,#CT000067);
			  return;
			  }
			  */
			/*//
			this.getBprgrp().getUsr().setUsrflg("0");
			this.getBprgrp().getUsr().setStat("I");
			this.getBprgrp().getUsr().setOtype("2");
			subject = "新增银行端操作员"+this.getBprgrp().getUsr().getLgnnam();
			}
			else
			{
			subject = "修改银行端操作员"+this.getBprgrp().getUsr().getLgnnam();
			this.getBprgrp().getUsr().setStat("U");
			}
			// */
			/*
			  //20160713 增加NOTESID唯一性校验
			  Platform.dbExecuteSQL("SELECT count(*) cnt FROM usr u,pty p WHERE u.ptyinr=p.inr AND ptytyp='0' AND u.usrflg<>'1' AND u.lgnnam != ? AND u.notesid = ? ",$bprgrp\\usr\\lgnnam.getValue(),$bprgrp\\usr\\notesid.getValue());
			  Argument<Integer> cnt = new Argument<Integer>("cnt");
			  Platform.dbFetchFields(cnt);
			  int errorCode=Platform.errorCode();
			  Platform.dbCloseCursor();
			  if(errorCode==NO_ERROR)
			  {
			  if(cnt.value.compareTo(Integer.valueOf(1))>=0)  //if(cnt.value.intValue()>=1)
			  {
			  Platform.message(#CT000068,#CT000090);
			  return;
			  }
			  }
			  */
			/*//
			//增加授权记录
			this.getBprgrp().getAuth().setInr(Platform.sdbCounter("auth"));
			this.getBprgrp().getAuth().setDattim(MdaUtils.today());
			this.getBprgrp().getAuth().setUsrinr(this.getSysmod().getUsr().getInr());
			this.getBprgrp().getAuth().setSub(subject);
			this.getBprgrp().getAuth().setPtyinr(this.getSysmod().getPty().getInr());
			this.getBprgrp().getAuth().setFrm("dbmbpr0");
			this.getBprgrp().getAuth().setSta("W");
			this.getBprgrp().getAuth().setFilenam(fileName);
			this.getBprgrp().getAuth().setObjinr(this.getBprgrp().getUsr().getInr());
			this.getBprgrp().getAuth().setObjtyp("usr");
			ctx.getDaoSession().dbInsert(this.getBprgrp().getAuth());
			log.debug("{}","Insert auth inr = "+this.getBprgrp().getAuth().getInr());
			ctx.getDaoSession().dbCommit();
			//序列化grp下的所有数据
			MdaUtils.clear(this.getBprgrp().getPtylst());
			IStream os = this.getBprp().getBprstm();
			MdaUtils.clear(os);
			MdaUtils.saveData(this.getBprgrp(),os);
			if(MdaUtils.isEmpty(os))
			log.warn("{}","dbmbpr0:Stream os is empty");
			fileName = this.getBprgrp().getAuth().getInr()+".dat";
			this.getSysmod().streamSaveInSubdir(os,"grant/dbmbpr0/dat",fileName);
			//保存display文件
			fileName = "/data/grant/dbmbpr0/dsp/"+this.getBprgrp().getAuth().getInr()+".zul";
			fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),fileName);
			ctx.saveDisplay(fileName);
			ctx.setMessage("",MdaUtils.getI18NString("dbmbpr0","CT000091"));
			
			//*/
			
			return true;
        }

        /**
        *   source:dbmbpr0.@0019.script
        */
        @Rule(target="bprp.get",order=100)
        public boolean ruleBprpGetN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($bprgrp\\usr\\notesid))
			  {
			  Platform.error($bprgrp\\usr\\notesid,#CT000086);
			  return;
			  }*/

			String usrinfo =(String)MdaUtils.invoke("com.brilliance.base.utils.LdapUtilsImpl","getLdapUser",this.getBprgrp().getUsr().getNotesid());
			//Platform.prompt(#CT000087,""+usrinfo);
			log.debug("{}","usrinfo:" + usrinfo);
			if (!MdaUtils.isEmpty(usrinfo))
			{
			  String[] arry=usrinfo.split("\\|");
			  log.debug("{}",""+arry.length);
			  this.getBprgrp().getUsr().setNotesid(arry[0]);
			  this.getBprgrp().getUsr().setOprnam(arry[2]);
			  this.getBprgrp().getUsr().setDepnam(arry[3]);
			  this.getBprgrp().getUsr().setLgnnam(arry[0]);
			  
			  
			  
			  
			  MdaUtils.prompt(MdaUtils.getI18NString("dbmbpr0","CT000089"),""+usrinfo);
			}
			else
			  MdaUtils.prompt(MdaUtils.getI18NString("dbmbpr0","CT000090"),""+usrinfo);

			return true;
        }

        /**
        *   source:dbmbpr0.@0022.script
        */
        @Rule(target="bprp.submit",order=80)
        public boolean ruleBprpSubmitN80(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getBprgrp()))
			  return false;
			log.debug("{}","Not return!");
			this.getBprgrp().getUsr().setFilcnt(0);
			this.getBprgrp().getUsr().setUsrflg("0");
			log.debug("{}","pwd is null?"+MdaUtils.isEmpty(this.getBprp().getPwd()));
			this.getBprgrp().getUsr().setPtyinr(this.getBprgrp().getPty().getInr());
			this.getBprgrp().getUsr().setPtynam(this.getBprgrp().getPty().getNam());
			this.getBprgrp().getUsr().setCid(this.getBprgrp().getPty().getCid());
			if(MdaUtils.isEmpty(this.getBprgrp().getUsr().getInr()))
			{

			  this.getBprgrp().getUsr().setUsrflg("0");
			  this.getBprgrp().getUsr().setStat("I");
			  this.getBprgrp().getUsr().setOtype("2");

			}
			else
			{
			  this.getBprgrp().getUsr().setStat("U");
			}
			boolean result = true;
			result = grantDbmbpr0();
			if(result)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmbpr0","CT000110"),MdaUtils.getI18NString("dbmbpr0","CT000111"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmbpr0","CT000112"),MdaUtils.getI18NString("dbmbpr0","CT000113"));
			}
			

			return true;
        }



        /**
        *   source:dbmbpr0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			// Platform.invisible($bprp\\sel);
			Object usr = ctx.restoreData("com.brilliance.dbmbpr0.usrinr");
			if(!MdaUtils.isEmpty(usr))
			{
			  ctx.getDaoSession().dbRead(this.getBprgrp().getUsr(),new Argument<String>("inr",usr.toString()));
			  
			  
			  
			  ctx.getDaoSession().dbRead(this.getBprgrp().getPty(),new Argument<String>("inr",this.getBprgrp().getUsr().getPtyinr()));
			  
			}
			else
			{
			  
			  
			  
			}
			/*
			  loadData();
			  //如果用户是新增的或者修改过的，而且没有经过授权，那么不能再做变更
			  if(!Platform.isEmpty($bprgrp\\usr\\stat))
			  {
			  log.info("user.otype"+$sysmod\\usr\\otype);
			  //如果是主管，显示授权按钮,并且disable所有输入域
			  if("1".equals($sysmod\\usr\\otype.getValue()))
			  {
			  Platform.invisible($bprp\\submit);
			  Platform.visible($bprp\\grant);
			  Platform.disable($bprgrp\\usr\\lgnnam);
			  Platform.disable($bprp\\pwd);
			  Platform.disable($bprp\\repwd);
			  Platform.disable($bprgrp\\usr\\oprnam);
			  Platform.disable($bprgrp\\usr\\eml);
			  Platform.disable($bprgrp\\pty\\nam);
			  Platform.invisible($bprp\\sel);
			  Platform.disable($bprgrp\\usr\\tel);
			  Platform.disable($bprgrp\\usr\\mob);
			  }
			  else
			  {
			  //如果是管理员，提示不能修改
			  Platform.message(#CT000053,#CT000054);
			  Platform.disable($bprp\\submit);
			  }
			  */
			readLRol();
			readRRol();

			return true;
        }

        /**
        *   source:dbmbpr0.@0001.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.dbReadset($bprgrp\\ptylst,new Argument<String>("ptytyp","0"));
			  Platform.setModified($bprgrp\\ptylst);
			  */
			bchSearch();


			return true;
        }


        /**
        *   source:dbmbpr0.@0012.script
        */
        public void readLRol()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT rol.inr inr,rol.rolnam rolnam FROM rol,pty WHERE "
			  +"rol.flg = '0' AND pty.inr = rol.ptyinr AND pty.ptytyp = '0' AND rol.inr "
			  +"NOT IN (SELECT rolinr FROM usrrol WHERE ptyinr = '"
			  + this.getBprgrp().getUsr().getPtyinr() + "' AND usrinr = '" + this.getBprgrp().getUsr().getInr() + "')";
			//String sql = "SELECT rol.inr inr,rol.rolnam rolnam FROM rol WHERE rol.flg = '0' AND rol.inr NOT IN (SELECT rolinr FROM usrrol WHERE ptyinr = '" + $bprgrp\\usr\\ptyinr.getValue() + "' AND usrinr = '" + $bprgrp\\usr\\inr.getValue() + "')";
			if("1".equals(this.getSysmod().getPty().getBrhlvl()))  //分行
			{
			  sql += " AND rol.rolnam NOT IN('管理员','参数维护','分行参数员','电子保函参数维护','电子保函处理')";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> rolnam = new Argument<String>("rolnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,rolnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getBprgrp().getRollst().add(inr,rolnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmbpr0.@0013.script
        */
        public void readRRol()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT rol.inr inr,rol.rolnam rolnam FROM rol,pty WHERE rol.flg = '0' AND pty.inr = rol.ptyinr AND pty.ptytyp = '0' AND rol.inr IN (SELECT rolinr FROM usrrol WHERE ptyinr = '" + this.getBprgrp().getUsr().getPtyinr() + "' AND usrinr = '" + this.getBprgrp().getUsr().getInr() + "')";
			//String sql = "SELECT rol.inr inr,rol.rolnam rolnam FROM rol WHERE rol.flg = '0' AND rol.inr IN (SELECT rolinr FROM usrrol WHERE ptyinr = '" + $bprgrp\\usr\\ptyinr.getValue() + "' AND usrinr = '" + $bprgrp\\usr\\inr.getValue() + "')";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> rolnam = new Argument<String>("rolnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,rolnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getBprgrp().getSelrol().add(inr,rolnam);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmbpr0.@0014.script
        */
        public boolean existusrRol(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg = false;
			String sql = "SELECT inr FROM usrrol WHERE usrinr = '"
			  + this.getBprgrp().getUsr().getInr() + "' AND ptyinr = '"
			  + this.getBprgrp().getUsr().getPtyinr() + "' AND rolinr = '" + rolinr + "'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(inr.value != null)
			{
			  //已存在
			  log.info("{}","rol value" +rolinr+inr.value);
			  flg = true;
			}
			else if(inr.value == null)
			{
			  //不存在
			  flg = false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return flg;
		}
        /**
        *   source:dbmbpr0.@0016.script
        */
        public void loadData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//如果是新增的数据，正常处理，读取数据库；如果是更新过的数据，用从序列化文件读取最新的数据
			if((!MdaUtils.isEmpty(this.getBprgrp().getUsr().getStat()))&&("U".equals(this.getBprgrp().getUsr().getStat())))
			{
			  String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/dbmbpr0/" +this.getBprgrp().getUsr().getInr()+".dat");
			  if(!MdaUtils.fileExists(filename))
			  {
			    log.error("{}","dbmbpr0:未找到序列化文件！");
			    return ;
			  }
			  IStream is=this.getBprp().getBprstm();
			  log.info("{}","streamLoad...");
			  MdaUtils.streamLoad(is,filename);
			  log.info("{}","loadData...");
			  MdaUtils.loadData(this.getBprgrp(),is);
			  log.info("{}","loadData OK...");
			}
			else
			{
			  readLRol();
			  readRRol();
			}
		}
        /**
        *   source:dbmbpr0.@0018.script
        */
        public boolean usrIsExist(String lgnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbExecuteSQL("SELECT u.lgnnam lgnnam from usr u,pty p where u.ptyinr=p.inr and ptytyp='0' and u.lgnnam=?",lgnam);
			Argument<String> lgnnam = new Argument<String>("lgnnam");
			ctx.getDaoSession().dbFetchFields(lgnnam);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			if(errorCode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:dbmbpr0.@0020.script
        */
        public boolean grantDbmbpr0()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbBegin();
			//如果是新增用户，只要修改状态即可
			if("I".equals(this.getBprp().getBprgrp().getUsr().getStat()))
			{
			  //新增用户
			  this.getBprp().getBprgrp().getUsr().setInr(Platform.sdbCounter("usr"));
			  this.getBprp().getBprgrp().getUsr().setPwd("pkKner19T1G/kibOr4kfy7Wymbg=");
			  this.getBprp().getBprgrp().getUsr().setStat(null);
			  //Platform.dbUpdate($grant\\bprgrp\\usr);
			  ctx.getDaoSession().dbInsert(this.getBprp().getBprgrp().getUsr());
			  log.debug("{}","Insert Usr inr = "+this.getBprp().getBprgrp().getUsr().getInr()+", pwd = "+this.getBprp().getBprgrp().getUsr().getPwd());
			}
			else if("U".equals(this.getBprp().getBprgrp().getUsr().getStat()))
			{
			  //修改用户
			  log.debug("{}","Update Usr inr = "+this.getBprp().getBprgrp().getUsr().getInr());
			  this.getBprp().getBprgrp().getUsr().setStat(null);
			  ctx.getDaoSession().dbUpdate(this.getBprp().getBprgrp().getUsr());
			}
			ctx.getDaoSession().dbCommit();
			ctx.getDaoSession().dbBegin();
			log.debug("{}","Selected rol size = "+this.getBprp().getBprgrp().getSelrol().fullSize());
			for(int i = 0; i < this.getBprp().getBprgrp().getSelrol().fullSize(); i++)
			{
			  if(!existUsrRol(this.getBprp().getBprgrp().getSelrol().getElement(i).getInr()))
			  {
			    //保存右侧选中角色
			    MdaUtils.clear(this.getBprp().getBprgrp().getUsrrol());
			    this.getBprp().getBprgrp().getUsrrol().setInr(Platform.sdbCounter("usrrol"));
			    this.getBprp().getBprgrp().getUsrrol().setUsrinr(this.getBprp().getBprgrp().getUsr().getInr());
			    this.getBprp().getBprgrp().getUsrrol().setRolinr(this.getBprp().getBprgrp().getSelrol().getElement(i).getInr());
			    this.getBprp().getBprgrp().getUsrrol().setRolnam(this.getBprp().getBprgrp().getSelrol().getElement(i).getRolnam());
			    this.getBprp().getBprgrp().getUsrrol().setPtyinr(this.getBprp().getBprgrp().getPty().getInr());
			    ctx.getDaoSession().dbInsert(this.getBprp().getBprgrp().getUsrrol());
			    log.debug("{}","Insert Usr inr = "+this.getBprp().getBprgrp().getUsrrol().getUsrinr()+", rolinr = "+this.getBprp().getBprgrp().getUsrrol().getRolinr());
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.getDaoSession().dbBegin();
			log.debug("{}","Not selected Rol size = "+this.getBprp().getBprgrp().getRollst().fullSize());
			for(int i = 0; i < this.getBprp().getBprgrp().getRollst().fullSize(); i++)
			{
			  if(existUsrRol(this.getBprp().getBprgrp().getRollst().getElement(i).getInr()))
			  {
			    //删除左侧未选中角色
			    MdaUtils.clear(this.getBprp().getBprgrp().getUsrrol());
			    ctx.getDaoSession().dbRead(this.getBprp().getBprgrp().getUsrrol(),new Argument<String>("rolinr",this.getBprp().getBprgrp().getRollst().getElement(i).getInr()),new Argument<String>("usrinr",this.getBprp().getBprgrp().getUsr().getInr()));
			    ctx.getDaoSession().dbDelete(this.getBprp().getBprgrp().getUsrrol());
			    log.debug("{}","Delete Usr inr = "+this.getBprp().getBprgrp().getUsrrol().getUsrinr()+", rolinr = "+this.getBprp().getBprgrp().getUsrrol().getRolinr());
			  }
			  log.debug("{}","Not Deal With rol inr = "+this.getBprp().getBprgrp().getRollst().getElement(i).getInr());
			}
			ctx.getDaoSession().dbCommit();
			//existDbipsw();
			return true;
		}
        /**
        *   source:dbmbpr0.@0021.script
        */
        public void existDbipsw()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","existDbipsw开始！");
			String sql = "SELECT inr FROM usrrol WHERE rolinr = '00000006' AND usrinr = '"+this.getBprp().getBprgrp().getUsr().getInr()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			//if(inr.value != null)
			ctx.getDaoSession().dbCloseCursor();
			if(!MdaUtils.isEmpty(inr.value))
			{
			  //已存在
			  log.debug("{}","Trans dbipsw Has Exsited for usr = "+this.getBprp().getBprgrp().getUsr().getInr());
			  return;
			}
			MdaUtils.clear(this.getBprp().getBprgrp().getUsrrol());
			this.getBprp().getBprgrp().getUsrrol().setInr(Platform.sdbCounter("usrrol"));
			this.getBprp().getBprgrp().getUsrrol().setUsrinr(this.getBprp().getBprgrp().getUsr().getInr());
			this.getBprp().getBprgrp().getUsrrol().setRolinr("00000006");
			this.getBprp().getBprgrp().getUsrrol().setRolnam("银行端登录人修改密码");
			this.getBprp().getBprgrp().getUsrrol().setPtyinr(this.getBprp().getBprgrp().getPty().getInr());
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbInsert(this.getBprp().getBprgrp().getUsrrol());
			log.debug("{}","existDbipsw开始Commit！");
			ctx.getDaoSession().dbCommit();
			log.debug("{}","Insert trans dbipsw usrrol inr = "+this.getBprp().getBprgrp().getUsrrol().getInr());
		}
        /**
        *   source:dbmbpr0.@0023.script
        */
        public void bchSearch()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getBprgrp().getPtylst());
			String sql = "SELECT p.cid cid,p.nam nam,p.inr inr FROM pty p  WHERE ptytyp='0' ";
			if(!MdaUtils.isEmpty(this.getBprp().getSelno()))
			  sql += " AND p.cid LIKE '%" + this.getBprp().getSelno() + "%'";
			if("1".equals(this.getSysmod().getPty().getBrhlvl()))  //分行
			{
			  sql += " AND( p.cid = '" + this.getSysmod().getPty().getCid() + "' or p.pntinr = '" + this.getSysmod().getPty().getCid() + "')";
			}
			else if("2".equals(this.getSysmod().getPty().getBrhlvl()))  //支行
			{
			  sql += " AND p.cid = '" + this.getSysmod().getPty().getCid() + "'";
			}

			sql += " ORDER BY p.inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> cid = new Argument<String>("cid");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> inr = new Argument<String>("inr");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cid,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getBprgrp().getPtylst().add(inr,cid,nam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmbpr0.@0024.script
        */
        public boolean existUsrRol(String rolinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg = false;
			String sql = "SELECT inr FROM usrrol WHERE usrinr = '"
			  + this.getBprp().getBprgrp().getUsr().getInr() + "' AND ptyinr = '"
			  + this.getBprp().getBprgrp().getUsr().getPtyinr() + "' AND rolinr = '" + rolinr + "'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			//if(inr.value != null)
			if(!MdaUtils.isEmpty(inr.value))
			{
			  //已存在
			  log.debug("{}","Rolinr = " +rolinr+", inr.value = "+inr.value+" Has Exsited for usr = "+this.getBprp().getBprgrp().getUsr().getInr());
			  flg = true;
			}
			ctx.getDaoSession().dbCloseCursor();
			return flg;
		}





}