package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Dbmopr0VO;

import com.ceb.gjjs.mda.manager.module.Oprmod;
import com.ceb.gjjs.mda.manager.module.Grant;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ptyopn;
import com.ceb.gjjs.mda.manager.module.Oprgrp;
import com.ceb.gjjs.mda.manager.module.Oprp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 企业操作员权限设置
*/
@Transaction(vo= Dbmopr0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dbmopr0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Dbmopr0.class);

		@BDGetter
		private Oprgrp oprgrp;

		@BDGetter
		private Oprmod oprmod;

		@BDGetter
		private Oprp oprp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Grant grant;

		@BDGetter
		private Ptyopn ptyopn;


		public Dbmopr0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getOprmod().setOprgrpHolder(()->this.getOprgrp());
           this.getOprp().setOprgrpHolder(()->this.getOprgrp());
        }

        /**
        *   source:dbmopr0.@0001.script
        */
        @Rule(target="oprp.submit",order=200)
        public boolean ruleOprpSubmitN200(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *管理员保存以后，只是把文件序列化，并不真正存入数据库。待主管授权后，才真正入库。
			  */
			//序列化当前页面的数据
			//授权列表的标题
			/*if("1".equals($oprgrp\\opraut\\oflg.getValue())&&"1".equals($oprgrp\\opraut\\bflg.getValue())&&"0".equals($oprgrp\\opraut\\aflg.getValue())&&Platform.prompt(#CT000020,#CT000033))
			  return;
			  String subject = "";
			  String fileName = "";
			  int index=Platform.getSelectedRowIndex($oprgrp\\oprautlst);
			  // 修改生产BUG 如果未选择复核的交易,则提示无法保存业务 20170707
			  if( index < 0)
			  {
			  Platform.message(#CT000034,#CT000036);
			  return;
			  }
			  subject =#CT000045+$oprgrp\\usr\\lgnnam.getValue();
			  //$oprgrp\\usr\\stat.setValue("U");
			  //先清空错误编号
			  Platform.errorCode();
			  Platform.dbBegin();
			  //更新usr表标志位
			  //Platform.dbUpdate($oprgrp\\usr);
			  //增加授权记录
			  $oprgrp\\auth\\inr.setValue(Platform.sdbCounter("auth"));
			  $oprgrp\\auth\\dattim.setValue(Platform.today());
			  $oprgrp\\auth\\usrinr.setValue($sysmod\\usr\\inr.getValue());
			  $oprgrp\\auth\\sub.setValue(subject);
			  $oprgrp\\auth\\ptyinr.setValue($sysmod\\pty\\inr.getValue());
			  $oprgrp\\auth\\frm.setValue("dbmopr0");
			  $oprgrp\\auth\\sta.setValue("W");
			  $oprgrp\\auth\\filenam.setValue(fileName);
			  $oprgrp\\auth\\objinr.setValue($oprgrp\\usr\\inr.getValue());
			  $oprgrp\\auth\\objtyp.setValue("usr");
			  $oprgrp\\auth\\dtl.setValue($oprgrp\\oprautlst[index]\\trsnam.getValue());
			  Platform.dbInsert($oprgrp\\auth);
			  Platform.dbCommit();
			  if(Platform.errorCode()==NO_ERROR)
			  {
			  //序列化文件中的数据状态
			  IStream os=$oprp\\stream.getValue();
			  Platform.saveData($oprgrp,os);
			  if(Platform.isEmpty(os))
			  log.warn("dbmopr0:Stream os is empty");
			  fileName = $oprgrp\\auth\\inr.getValue()+".dat";
			  $sysmod.streamSaveInSubdir(os,"grant/dbmopr0/dat",fileName);
			  //保存display文件
			  fileName = "/data/grant/dbmopr0/dsp/"+$oprgrp\\auth\\inr.getValue()+".zul";
			  fileName=Platform.catPath(Platform.getRootPath(),fileName);
			  Platform.saveDisplay($oprp\\usrautlst,fileName);
			  //提示
			  Platform.message("",#CT000046);
			  //Platform.disable($oprp\\submit);
			  }
			  else
			  Platform.message(#CT000053,#CT000054);
			  //Platform.returnToCaller();
			  */

			return true;
        }

        /**
        *   source:dbmopr0.@0002.script
        */
        @Rule(target="oprp.rtn",order=100)
        public boolean ruleOprpRtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.chain("dbmopr");
			

			return true;
        }

        /**
        *   source:dbmopr0.@0004.script
        */
        @Rule(target="oprp.grant",order=100)
        public boolean ruleOprpGrantN100(){
            IContext ctx = MdaEnv.getContext();
            
			//授权前，先重新从文件复原数据，防止主管修改数据
			restoreFromFile();
			ctx.getDaoSession().dbBegin();
			//删除旧的记录
			ctx.getDaoSession().dbDelete(this.getOprgrp().getUsraut(),new Argument<String>("objinr",this.getOprgrp().getUsr().getInr()),new Argument<String>("objtyp","usr"));
			//新增记录
			for(int i=0;i<this.getOprgrp().getOprautlst().fullSize();i++)
			{
			  String flg1 = this.getOprgrp().getOprautlst().getElement(i).getOflg();
			  String flg2 = this.getOprgrp().getOprautlst().getElement(i).getBflg();
			  String lvl = this.getOprgrp().getOprautlst().getElement(i).getAflg();
			  if(!("".equals(flg1) && "".equals(flg2) && ("0".equals(lvl)  ||  "".equals(lvl))))
			  {
			    this.getOprgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			    log.info("{}","usraut.inr:"+this.getOprgrp().getUsraut().getInr());
			    this.getOprgrp().getUsraut().setObjinr(this.getOprgrp().getUsr().getInr());
			    this.getOprgrp().getUsraut().setObjtyp("usr");
			    this.getOprgrp().getUsraut().setPtyinr(this.getSysmod().getPty().getInr());
			    this.getOprgrp().getUsraut().setFrm(this.getOprgrp().getOprautlst().getElement(i).getTrsinr());
			    //有：0  没有：1
			    log.info("{}","flg1:"+this.getOprgrp().getOprautlst().getElement(i).getOflg());
			    log.info("{}","flg2:"+this.getOprgrp().getOprautlst().getElement(i).getBflg());
			    if(MdaUtils.isEmpty(flg1))
			    {
			      this.getOprgrp().getUsraut().setFlg1("1");
			    }
			    else
			    {
			      this.getOprgrp().getUsraut().setFlg1("0");
			    }
			    if(MdaUtils.isEmpty(flg2))
			    {
			      this.getOprgrp().getUsraut().setFlg2("1");
			    }
			    else
			    {
			      this.getOprgrp().getUsraut().setFlg2("0");
			    }
			    this.getOprgrp().getUsraut().setLvl(lvl);
			    this.getOprgrp().getUsraut().setCur("USD");
			    this.getOprgrp().getUsraut().setAmt(this.getOprgrp().getOprautlst().getElement(i).getAmt());
			    ctx.getDaoSession().dbInsert(this.getOprgrp().getUsraut());
			  }
			}
			//修改usr表stat
			this.getOprgrp().getUsr().setStat(null);
			ctx.getDaoSession().dbUpdate(this.getOprgrp().getUsr());
			//删除授权记录
			IModule auth = (IModule)ctx.restoreData("com.brilliance.sysaut.auth");
			this.getOprgrp().getAuth().copyValue(auth);
			ctx.getDaoSession().dbDelete(this.getOprgrp().getAuth());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000025"),MdaUtils.getI18NString("dbmopr0","CT000026"));
			

			return true;
        }

        /**
        *   source:dbmopr0.@0006.script
        */
        @Rule(target="oprgrp.oprautlst",order=100)
        public boolean ruleOprgrpOprautlstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getOprgrp().getOprautlst().fullSize();
			this.getOprgrp().getOpraut().copyValue(this.getOprgrp().getOprautlst().getElement(index));
			setAtuLvl();

			return true;
        }

        /**
        *   source:dbmopr0.@0008.script
        */
        @Rule(target="oprp.submit",order=100)
        public boolean ruleOprpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			//此部分代码已经移到300
			/*
			  Platform.clear($oprgrp\\usraut);
			  String frm = $oprgrp\\opraut\\trsinr.getValue().trim();
			  if("brtfre".equals(frm))
			  {
			  savUsraut("brtfre");
			  savUsraut("brtfrc");
			  savUsraut("brtfrd");
			  }
			  else if("letfre".equals(frm))
			  {
			  savUsraut("letfre");
			  savUsraut("letfrc");
			  savUsraut("letfrd");
			  }
			  else if("bptopn".equals(frm))
			  {
			  savUsraut("bptopn");
			  savUsraut("bptopl");
			  savUsraut("bptopc");
			  }
			  else
			  savUsraut(frm);
			  Platform.message(#CT000027,#CT000028);
			  $oprp.loadModLst();
			  readLst();
			  */

			return true;
        }

        /**
        *   source:dbmopr0.@0012.script
        */
        @Rule(target="oprp.submit",order=300)
        public boolean ruleOprpSubmitN300(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  *操作员权限配置
			  */
			//序列化当前页面的数据
			//授权列表的标题
			if("1".equals(this.getOprgrp().getOpraut().getOflg())&&"1".equals(this.getOprgrp().getOpraut().getBflg())&&"0".equals(this.getOprgrp().getOpraut().getAflg())&&MdaUtils.prompt(MdaUtils.getI18NString("dbmopr0","CT000063"),MdaUtils.getI18NString("dbmopr0","CT000064")))
			  return true;
			String subject =MdaUtils.getI18NString("dbmopr0","CT000065")+this.getOprgrp().getUsr().getLgnnam();
			int index=0;

			if( index < 0 || index >= this.getOprgrp().getOprautlst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000066"),MdaUtils.getI18NString("dbmopr0","CT000067"));
			  return true;
			}

			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();

			//增加配置记录
			this.getOprgrp().getAuth().setInr(Platform.sdbCounter("auth"));
			this.getOprgrp().getAuth().setDattim(MdaUtils.today());
			this.getOprgrp().getAuth().setUsrinr(this.getSysmod().getUsr().getInr());
			this.getOprgrp().getAuth().setSub(subject);
			this.getOprgrp().getAuth().setPtyinr(this.getSysmod().getPty().getInr());
			this.getOprgrp().getAuth().setFrm("dbmopr0");
			//$oprgrp\\auth\\sta.setValue("W");
			//$oprgrp\\auth\\filenam.setValue(fileName);
			this.getOprgrp().getAuth().setObjinr(this.getOprgrp().getUsr().getInr());
			this.getOprgrp().getAuth().setObjtyp("usr");
			this.getOprgrp().getAuth().setDtl(this.getOprgrp().getOprautlst().getElement(index).getTrsnam());
			//Platform.dbInsert($oprgrp\\auth);
			
			boolean result = true;
			String frm="";
			if(index==0)
			{
			  for(int i=1;i<this.getOprgrp().getOprautlst().fullSize();i++)
			  {
			    //frm=getFrm($oprgrp\\oprautlst[i]\\nam.getValue());
			    frm = this.getOprgrp().getOprautlst().getElement(i).getTrsinr().trim();
			    log.debug("{}","frm   1值  ："+frm);
			    result = saveUsrautByFrm(frm);
			  }
			}
			else
			{
			  //frm=getFrm($oprgrp\\oprautlst[index]\\nam.getValue());
			  frm = this.getOprgrp().getOprautlst().getElement(index).getTrsinr().trim();
			  log.debug("{}","frm   2值  ："+frm);
			  result = saveUsrautByFrm(frm);
			}

			if(result)
			{
			  //重置授权记录的标志位
			  log.debug("{}","插入inr["+this.getOprgrp().getAuth().getInr()+"]的授权记录!");
			  this.getOprgrp().getAuth().setSta("D");
			  ctx.getDaoSession().dbInsert(this.getOprgrp().getAuth());
			  //Platform.dbUpdate($oprgrp\\auth);
			}
			else
			{
			  return false;
			}

			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.debug("{}","授权成功,主键inr= "+this.getOprgrp().getAuth().getInr());
			  ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000068"),MdaUtils.getI18NString("dbmopr0","CT000069"));
			  readLst();
			}
			else
			{
			  log.info("{}","error when delete auth record!");
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000070"),MdaUtils.getI18NString("dbmopr0","CT000116"));
			  return false;
			}


			return true;
        }

        /**
        *   source:dbmopr0.@0017.script
        */
        @Rule(target="oprp.reset",order=100)
        public boolean ruleOprpResetN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","dbmopr0 重置操作员权限！   ");
			boolean bool = MdaUtils.prompt(MdaUtils.getI18NString("dbmopr0","CT000073"),MdaUtils.getI18NString("dbmopr0","CT000074"));
			if(bool)
			{
			  return true;
			}
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getOprp().getOprgrp().getUsrautlst());
			ctx.getDaoSession().dbReadset(this.getOprp().getOprgrp().getUsrautlst(),new Argument<String>("objinr",this.getOprp().getOprgrp().getUsr().getInr()));
			for(int i = 0; i < this.getOprp().getOprgrp().getUsrautlst().size(); i++)
			{
			  this.getOprp().getOprgrp().getUsraut().copyValue(this.getOprp().getOprgrp().getUsrautlst().getElement(i));
			  ctx.getDaoSession().dbDelete(this.getOprp().getOprgrp().getUsraut(),new Argument<String>("objinr",this.getOprp().getOprgrp().getUsr().getInr()));
			}
			ctx.getDaoSession().dbCommit();

			MdaUtils.clear(this.getOprp().getOprgrp().getUsrautlst());
			ctx.getDaoSession().dbReadset(this.getOprp().getOprgrp().getUsrautlst(),new Argument<String>("objinr",this.getOprp().getOprgrp().getUsr().getInr()));
			if(this.getOprp().getOprgrp().getUsrautlst().size()==0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000079"),MdaUtils.getI18NString("dbmopr0","CT000080"));
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("dbmopr0","CT000081"),MdaUtils.getI18NString("dbmopr0","CT000082"));
			}
			readLst();

			return true;
        }



        /**
        *   source:dbmopr0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getOprgrp().getUsr().copyValue((IModule)ctx.restoreData("com.brilliance.dbmopr0.usr"));
			loadModLst();
			readLst();
			/**
			  *以下处理暂不执行，拟增加已提交指令查询功能以弥补此功能
			  */
			/*
			  //判断stat的值，如果为U，则表示数据已经更新，但是没有授权，需要从序列化文件中读取
			  if(Platform.isEmpty($oprgrp\\usr\\stat))
			  {
			  //stat为空，说明用户正常，不需进入主管授权流程
			  $oprp.loadModLst();
			  readLst();
			  }
			  else
			  {
			  restoreFromFile();
			  //如果是管理员，则不允许其修改数据
			  if("0".equals($sysmod\\usr\\otype.getValue()))
			  {
			  Platform.disable($oprp\\submit);
			  Platform.message(#CT000018,#CT000019);
			  }
			  }
			  //Platform.disable($oprgrp\\usr\\lgnnam);
			  //Platform.disable($oprgrp\\usr\\oprnam);
			  //Platform.invisible($oprp\\grant);
			  //根据用户类型，显示“保存”或者“授权”
			  if("1".equals($sysmod\\usr\\otype.getValue()))
			  {
			  //主管
			  Platform.invisible($oprp\\submit);
			  Platform.visible($oprp\\grant);
			  Platform.disable($oprp\\usrautlst);
			  }
			  else
			  {
			  //非主管
			  Platform.visible($oprp\\submit);
			  Platform.invisible($oprp\\grant);
			  //Platform.enable($oprp\\usrautlst);
			  }
			  */

			return true;
        }

        /**
        *   source:dbmopr0.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getOprgrp().getOpraut(),"oflg",MdaUtils.getCodetable("noneflg"));
			MdaUtils.setValues(this.getOprgrp().getOpraut(),"bflg",MdaUtils.getCodetable("noneflg"));

			return true;
        }


        /**
        *   source:dbmopr0.@0003.script
        */
        public void readLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getOprgrp().getOprautlst());
			String sql ="";
			//根据此机构所具有的交易权限，读取操作员的权限信息
			this.getOprgrp().getOprautlst().add();
			this.getOprgrp().getOprautlst().getElement(0).setTrsnam("所有交易");
			for(int i=0;i<this.getOprgrp().getModlstlst().fullSize();i++)
			{
			  //sql = "SELECT case flg1 when '1' then '' else 'X' end oflg, case flg2 when '1' then '' else 'X' end bflg,lvl aflg,amt ";
			  sql = "SELECT u.flg1 oflg,u.flg2 bflg,u.lvl aflg,u.amt amt";
			  sql += " FROM usraut u";
			  sql += " WHERE u.objinr='"+this.getOprgrp().getUsr().getInr()+"' AND u.objtyp='usr' AND ptyinr='"+this.getOprgrp().getUsr().getPtyinr()+"' AND frm='"+this.getOprgrp().getModlstlst().getElement(i).getFrm()+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> oflg = new Argument<String>("oflg");
			  Argument<String> bflg = new Argument<String>("bflg");
			  Argument<String> aflg = new Argument<String>("aflg");
			  Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			  //Argument<String> trsnam = new Argument<String>("trsnam",$oprgrp\\modlstlst[i]\\nam.getValue());
			  //Argument<String> trsinr = new Argument<String>("trsinr",$oprgrp\\modlstlst[i]\\frm.getValue());
			  Argument<String> trsnam = new Argument<String>("trsnam");
			  Argument<String> trsinr = new Argument<String>("trsinr");
			  ctx.getDaoSession().dbFetchFields(trsinr,trsnam,oflg,bflg,aflg,amt);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode != NO_ERROR)
			  {
			    oflg.value = null;
			    bflg.value = null;
			    aflg.value = null;
			  }
			  trsinr.value = this.getOprgrp().getModlstlst().getElement(i).getFrm();
			  trsnam.value = this.getOprgrp().getModlstlst().getElement(i).getNam();
			  this.getOprgrp().getOprautlst().add(trsinr,trsnam,oflg,bflg,aflg,amt);
			  ctx.getDaoSession().dbCloseCursor();
			}
			
		}
        /**
        *   source:dbmopr0.@0005.script
        */
        public void restoreFromFile()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/grant/dbmopr0/" +this.getOprgrp().getUsr().getInr()+".dat");
			if(!MdaUtils.fileExists(filename))
			{
			  log.error("{}","dbmopr0:未找到序列化文件！");
			  return;
			}
			IStream is=this.getOprp().getStream();
			log.debug("{}","streamLoad...");
			MdaUtils.streamLoad(is,filename);
			log.debug("{}","loadData...");
			MdaUtils.loadData(this.getOprgrp(),is);
			log.debug("{}","loadData OK...");
		}
        /**
        *   source:dbmopr0.@0009.script
        */
        public void setAtuLvl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String frm = null;
			if(!MdaUtils.isEmpty(this.getOprgrp().getOpraut().getTrsinr()))
			{
			  frm = this.getOprgrp().getOpraut().getTrsinr().trim();
			  ctx.getDaoSession().dbRead(this.getOprgrp().getPtyaut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","pty"),new Argument<String>("objinr",this.getSysmod().getUsr().getPtyinr()));
			}
			else
			{
			  //用户选中的是所有交易，系统给默认值
			  this.getOprgrp().getPtyaut().setChkflg("0");
			  this.getOprgrp().getPtyaut().setLvl("5");
			}

			log.debug("{}","传入的查询条件frm = "+frm+"，机构号 = "+this.getSysmod().getUsr().getPtyinr());
			log.debug("{}","ptyaut inr = "+this.getOprgrp().getPtyaut().getInr()+",复核权限"+this.getOprgrp().getPtyaut().getChkflg()+"，授权级别"+this.getOprgrp().getPtyaut().getLvl());
			//经办
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getOflg()))
			  this.getOprgrp().getOpraut().setOflg("1");
			//复核
			if("1".equals(this.getOprgrp().getPtyaut().getChkflg()))
			{
			  
			  this.getOprgrp().getOpraut().setBflg(NULLSTR);
			}
			else
			{
			  
			  if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getBflg()))
			    this.getOprgrp().getOpraut().setBflg("1");
			}
			//授权
			if("0".equals(this.getOprgrp().getPtyaut().getLvl()))
			{
			  
			  this.getOprgrp().getOpraut().setAflg(NULLSTR);
			}
			else
			{
			  

			  MdaUtils.setValues(this.getOprgrp().getOpraut(),"aflg",MdaUtils.getCodetable("aflg"+this.getOprgrp().getPtyaut().getLvl()));
			  if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getAflg()))
			    this.getOprgrp().getOpraut().setAflg("0");

			  /* if(Platform.isEmpty($oprgrp\\opraut\\aflg))
			    {
			    $oprgrp\\opraut\\aflg.setValue("0");
			    Platform.setModified($oprgrp\\opraut\\aflg);
			    Platform.setValues($oprgrp\\opraut\\aflg,Platform.getCodetable("aflg"+$oprgrp\\opraut\\aflg.getValue()));
			    log.debug("传入码表的名称为"+"aflg"+$oprgrp\\ptyaut\\lvl.getValue());
			    }
			    else
			    {
			    Platform.setValues($oprgrp\\opraut\\aflg,Platform.getCodetable("aflg"+$oprgrp\\ptyaut\\lvl.getValue()));
			    }*/

			  log.debug("{}","传入码表的名称为"+"aflg"+this.getOprgrp().getPtyaut().getLvl());
			}
			
			
			
			
		}
        /**
        *   source:dbmopr0.@0010.script
        */
        public void savUsraut(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getOprgrp().getUsraut());
			ctx.getDaoSession().dbRead(this.getOprgrp().getUsraut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getOprgrp().getUsr().getInr()));
			log.debug("{}","submit usraut inr = "+this.getOprgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getOprgrp().getUsr().getInr());
			this.getOprgrp().getUsraut().setFlg1(this.getOprgrp().getOpraut().getOflg());
			this.getOprgrp().getUsraut().setFlg2(this.getOprgrp().getOpraut().getBflg());
			this.getOprgrp().getUsraut().setLvl(this.getOprgrp().getOpraut().getAflg());
			if(MdaUtils.isEmpty(this.getOprgrp().getUsraut().getInr()))
			{
			  this.getOprgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			  this.getOprgrp().getUsraut().setObjtyp("usr");
			  this.getOprgrp().getUsraut().setFrm(frm);
			  this.getOprgrp().getUsraut().setObjinr(this.getOprgrp().getUsr().getInr());
			  this.getOprgrp().getUsraut().setPtyinr(this.getOprgrp().getUsr().getPtyinr());
			  ctx.getDaoSession().dbInsert(this.getOprgrp().getUsraut());
			  log.debug("{}","Insert usraut inr = "+this.getOprgrp().getUsraut().getInr());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getOprgrp().getUsraut());
			  log.debug("{}","Update usraut inr = "+this.getOprgrp().getUsraut().getInr());
			}
			ctx.getDaoSession().dbCommit();
		}
        /**
        *   source:dbmopr0.@0011.script
        */
        public void loadModLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除数据列表
			MdaUtils.clear(this.getOprgrp().getModlstlst());
			String objinr = this.getSysmod().getPty().getInr();
			String objtyp = "pty";
			/*
			  if("1".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //商行维护的是其及下属企业的业务授权模式
			  objinr = $sysmod\\pty\\etyinr.getValue();
			  objtyp = "ety";
			  }
			  else if("2".equals($sysmod\\pty\\ptytyp.getValue()))
			  {
			  //本行企业维护的是自身的业务授权模式
			  objinr = $sysmod\\pty\\inr.getValue();
			  objtyp = "pty";
			  }
			  */
			//数据库中仅保存没有权限的交易，所以此处采用左连接后，应该判断ptyinr为空。
			/*
			  String sql = "SELECT inr,frm,nam FROM modlst";
			  sql += " WHERE modtyp IN('0','1') AND ptytyp='"+$sysmod\\pty\\ptytyp;
			  sql += "' AND frm IN";
			  sql += "(SELECT DISTINCT(frm) FROM ptyaut WHERE objinr='"+objinr+"' and objtyp = '"+objtyp+"')";
			  sql += " ORDER BY trntyp";
			  */
			MdaUtils.clear(this.getPtyopn());
			ctx.getDaoSession().dbRead(this.getPtyopn(),new Argument<String>("ptycid",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getCid()));
			String sql = "SELECT m.inr,m.frm,m.nam,m.trntyp FROM modlst m LEFT OUTER JOIN";
			sql += " (SELECT * FROM ptymod WHERE ptyinr='"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr()+"'";
			if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  sql += " OR ptyinr = (SELECT nxtptyinr FROM ptr WHERE ptrtyp = '2' AND preptyinr = '"+this.getSysmod().getPty().getInr()+"')";
			sql += ") p ON m.frm=p.frm";
			//modtyp='0',表示只有申请类交易需要进行业务授权模式定制
			//  sql += " WHERE m.modtyp='0' AND m.ptytyp='"+$sysmod\\pty\\ptytyp.getValue()+"' AND p.ptyinr IS NULL ORDER BY m.trntyp";
			// 增加过滤非菜单交易的数据
			sql += " WHERE m.modtyp='0' AND m.ptytyp='"+this.getSysmod().getPty().getPtytyp()+"' AND trim(m.trntyp) is not null AND trim(m.fintyp) IS NULL AND p.ptyinr IS NULL ORDER BY m.trntyp";

			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,frm,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    if ((MdaUtils.isEmpty(this.getPtyopn().getInr())||!"1".equals(this.getPtyopn().getSignsta()))&&("cpthyf".equals(frm.value)||"cpthyc".equals(frm.value)||"cpthyd".equals(frm.value)))
			    {
			      continue;
			    }
			    this.getOprgrp().getModlstlst().add(inr,frm,nam);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:dbmopr0.@0014.script
        */
        public boolean saveUsrautByFrm(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean result = true;
			if("brtfre".equals(frm))
			{
			  if(!savUsrautS("brtfre"))
			    result= false;
			  if(!savUsrautS("brtfrc"))
			    result= false;
			  //return false;
			  if(!savUsrautS("brtfrd"))
			    result= false;
			  //return false;
			}
			else if("letfre".equals(frm))
			{
			  if(!savUsrautS("letfre"))
			    result= false;
			  if(!savUsrautS("letfrc"))
			    result= false;
			  if(!savUsrautS("letfrd"))
			    result= false;
			}
			else if ("bdtfre".equals(frm))
			{
			  if (!savUsrautS("bdtfre"))
			    result= false;
			  //result= false;
			  if (!savUsrautS("bdtfrc"))
			    result= false;
			  //return false;
			  if (!savUsrautS("bdtfrd"))
			    result= false;
			  //return false;
			  if (!savUsrautS("bdtdfr"))
			    result= false;
			  //return false;
			  if (!savUsrautS("bdtdfd"))
			    result= false;
			  // return false;
			}
			else if ("detfre".equals(frm))
			{
			  if (!savUsrautS("detfre"))
			    result= false;
			  //return false;
			  if (!savUsrautS("detfrc"))
			    result= false;
			  //return false;
			  if (!savUsrautS("detfrd"))
			    result= false;
			  //return false;
			}
			else if("bptopn".equals(frm))
			{
			  if(!savUsrautS("bptopn"))
			    result= false;
			  //return false;
			  if(!savUsrautS("bptopl"))
			    result= false;
			  //return false;
			  if(!savUsrautS("bptopc"))
			    result= false;
			  //return false;
			}
			else if("bptapn0".equals(frm))
			{
			  if(!savUsrautS("bptapn0"))
			    result= false;
			  //return false;
			  if(!savUsrautS("bptapl"))
			    result= false;
			  //result= false;
			  if(!savUsrautS("bptapn"))
			    result= false;
			  //result= false;
			}
			else
			{
			  result = savUsrautS(frm);
			}
			return result;
		}
        /**
        *   source:dbmopr0.@0015.script
        */
        public String getFrm(String nam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(nam))
			  return null;
			String modfrm = null;
			String sql = "SELECT frm FROM modlst m WHERE m.nam='"+nam+"' and m.modtyp='0' AND m.ptytyp='"+this.getSysmod().getPty().getPtytyp()+"' AND trim(m.trntyp) is not null";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> frm=new Argument<String>("frm");
			ctx.getDaoSession().dbFetchFields(frm);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(frm.value))
			  {
			    modfrm = frm.value;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ptytyp  :"+this.getSysmod().getPty().getPtytyp());
			log.info("{}","getFrm-modfrm  = " + modfrm);
			return modfrm;
		}
        /**
        *   source:dbmopr0.@0016.script
        */
        public boolean savUsrautS(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in savUsraut ... frm =  " + frm );
			boolean result = true;
			MdaUtils.clear(this.getOprgrp().getUsraut());
			ctx.getDaoSession().dbRead(this.getOprgrp().getUsraut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getOprgrp().getUsr().getInr()));
			int errorCode=ctx.getErrorCode();
			log.debug("{}","errorCode = " + errorCode );
			if(errorCode==NO_MORE_ROW)
			  log.info("{}","no usraut record found!");
			else if(errorCode!=NO_ERROR)
			  return false;
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getOflg()))
			  this.getOprgrp().getOpraut().setOflg("1");
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getBflg()))
			  this.getOprgrp().getOpraut().setBflg("1");
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getAflg()))
			  this.getOprgrp().getOpraut().setAflg("0");
			if(MdaUtils.isEmpty(this.getOprgrp().getUsraut().getInr()))
			{
			  this.getOprgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			  this.getOprgrp().getUsraut().setObjtyp("usr");
			  this.getOprgrp().getUsraut().setFrm(frm);
			  this.getOprgrp().getUsraut().setObjinr(this.getOprgrp().getUsr().getInr());
			  this.getOprgrp().getUsraut().setPtyinr(this.getOprgrp().getUsr().getPtyinr());
			  this.getOprgrp().getUsraut().setFlg1(this.getOprgrp().getOpraut().getOflg());
			  this.getOprgrp().getUsraut().setFlg2(this.getOprgrp().getOpraut().getBflg());
			  this.getOprgrp().getUsraut().setLvl(this.getOprgrp().getOpraut().getAflg());
			  ctx.getDaoSession().dbInsert(this.getOprgrp().getUsraut());
			  if(ctx.getErrorCode()!=NO_ERROR)
			    result= false;
			  else
			  {
			    result= true;
			    log.debug("{}","Insert usraut inr = "+this.getOprgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getOprgrp().getUsr().getInr());
			  }
			}
			else
			{
			  this.getOprgrp().getUsraut().setFlg1(this.getOprgrp().getOpraut().getOflg());
			  this.getOprgrp().getUsraut().setFlg2(this.getOprgrp().getOpraut().getBflg());
			  this.getOprgrp().getUsraut().setLvl(this.getOprgrp().getOpraut().getAflg());
			  ctx.getDaoSession().dbUpdate(this.getOprgrp().getUsraut());
			  if(ctx.getErrorCode()!=NO_ERROR)
			  {
			    log.debug("{}","update error:  "+ctx.getErrorCode());
			    result= false;
			  }
			  else
			  {
			    result= true;
			    log.debug("{}","Update usraut inr = "+this.getOprgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getOprgrp().getUsr().getInr());
			  }
			}
			return result;
		}







}