package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Detmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Detp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方国内信用证修改通知
*/
@Transaction(vo= DetameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detame.class);

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Detmod detmod;

		@BDGetter
		private Detp detp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Detame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDetmod().setDedgrpHolder(()->this.getDedgrp());
           this.getDetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDetp().setDedgrpHolder(()->this.getDedgrp());
           this.getDetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Detame.this.getDedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Detame.this.getDedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.bchcod");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.lcccur");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getLcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.inr");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setInr(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.stlref");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.ptyinr");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detame.this.getFieldPath("dedgrp.rec.stlref");}
 				public void setValue(String arg){Detame.this.getDedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detame.this.getDedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:detame.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:detame.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getDetp().getDetp03());

			

			return true;
        }

        /**
        *   source:detame.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}