package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetcanVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Detmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Detp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方信用证开证撤销通知
*/
@Transaction(vo= DetcanVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detcan extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detcan.class);

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Detmod detmod;

		@BDGetter
		private Detp detp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Detcan()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDetmod().setDedgrpHolder(()->this.getDedgrp());
           this.getDetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDetp().setDedgrpHolder(()->this.getDedgrp());
           this.getDetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.bchcod");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.inr");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setInr(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.ownref");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.ptyinr");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.stlref");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Detcan.this.getDedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Detcan.this.getDedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Detcan.this.getFieldPath("dedgrp.rec.lcccur");}
 				public void setValue(String arg){Detcan.this.getDedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Detcan.this.getDedgrp().getRec().getLcccur();}}
			 );
        }













}