package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetfrcVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Detmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Detp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方信用证来证项下杂项处理
*/
@Transaction(vo= DetfrcVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detfrc extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detfrc.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Detmod detmod;

		@BDGetter
		private Detp detp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Detfrc()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDetmod().setDedgrpHolder(()->this.getDedgrp());
           this.getDetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDetp().setDedgrpHolder(()->this.getDedgrp());
           this.getDetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LE"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Detfrc.this.getFieldPath("dedgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Detfrc.this.getDedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Detfrc.this.getDedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("dedgrp.rec.lcccur");}
 				public void setValue(String arg){Detfrc.this.getDedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Detfrc.this.getDedgrp().getRec().getLcccur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Detfrc.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Detfrc.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Detfrc.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Detfrc.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("dedgrp.rec.ownref");}
 				public void setValue(String arg){Detfrc.this.getDedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Detfrc.this.getDedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("dedgrp.rec.ptyinr");}
 				public void setValue(String arg){Detfrc.this.getDedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Detfrc.this.getDedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrc.this.getFieldPath("dedgrp.rec.stlref");}
 				public void setValue(String arg){Detfrc.this.getDedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detfrc.this.getDedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:detfrc.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getDedgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			log.info("{}","sav200开始================" );
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("ded");
			this.getAfdgrp().getRec().setObjinr(this.getDedgrp().getRec().getInr());
			this.getAfdgrp().getRec().setApytyp("2");
			this.getAfdgrp().getRec().setOprtyp(this.getAfdgrp().getRec().getOprtyp());
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			log.info("{}", "sav200入库结束================" );
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:detfrc.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","oprtyp=="+this.getAfdgrp().getRec().getOprtyp());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","detfrc",stream,false );

			return true;
        }

        /**
        *   source:detfrc.@0004.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:detfrc.@0005.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp1",oprtyp);
			if(!"0".equals(oprtyp))
			{
			  oprtxt = descriptipn;
			  this.getAfdgrp().getRec().setOprtxt(oprtxt);
			}
			log.debug("{}","oprtyp===="+oprtyp+"descriptipn======"+descriptipn);
			

			return true;
        }

        /**
        *   source:detfrc.@0006.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "卖方证下杂项杂项处理申请书";
			String tempfiles = "A:detfrc";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:detfrc.@0007.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream =this.getMtabut().getApldoc();
			this.getDetp().getPdfviw().callPDFComponent("","detfrc","卖方证下杂项处理申请书",1);

			return true;
        }



        /**
        *   source:detfrc.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp1"));
			/*List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			  Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			  if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			  {
			  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  $dedgrp\\rec\\bchcod.setValue($afdgrp\\rec\\bchcod.getValue());
			  }*/
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  {
			    
			  }

			  
			  this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			  
			  
			  this.getAfdgrp().getRec().setOprtyp("0");
			  
			  
			  
			  return true;
			}
			IModule ded = (IModule)ctx.restoreData("com.brilliance.detfrc.ref");
			if(!MdaUtils.isEmpty(ded))
			  this.getDedgrp().getRec().copyValue(ded);

			//if(!"1".equals($sysmod\\pty\\ptytyp.getValue()))
			//Platform.clear($dedgrp\\rec\\ownref);
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			else
			  this.getAfdgrp().getRec().setBchcod(this.getDedgrp().getRec().getBchcod());
			if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			{
			  
			}

			
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			
			
			this.getAfdgrp().getRec().setOprtyp("0");
			ctx.getDaoSession().dbRead(this.getDedgrp().getApl().getPts(),new Argument<String>("objinr",this.getDedgrp().getRec().getInr()),new Argument<String>("objtyp","ded"),new Argument<String>("rol","apl"));
			
			
			

			return true;
        }

        /**
        *   source:detfrc.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  log.info("bchcod="+$afdgrp\\rec\\bchcod);
			  List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			  Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			  if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			  $dedgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  {
			  if("3".equals($sysmod\\pty\\ptytyp.getValue()))
			  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  else
			  $afdgrp\\rec\\bchcod.setValue($dedgrp\\rec\\bchcod.getValue());
			  }
			  Platform.disable($afdgrp\\rec\\bchcod);
			  */

			return true;
        }











}