package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetfrdVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Bmtmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bmdgrp;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Bmtp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方证杂项处理申请
*/
@Transaction(vo= DetfrdVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detfrd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detfrd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bmdgrp bmdgrp;

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Bmtmod bmtmod;

		@BDGetter
		private Bmtp bmtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Detfrd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBmtmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBmtmod().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtmod().setDedgrpHolder(()->this.getDedgrp());
           this.getBmtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBmtp().setBmdgrpHolder(()->this.getBmdgrp());
           this.getBmtp().setDedgrpHolder(()->this.getDedgrp());
           this.getMtabut().setRecHolder(()->this.getBmdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LE"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Detfrd.this.getFieldPath("bmdgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Detfrd.this.getBmdgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Detfrd.this.getBmdgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Detfrd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Detfrd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("bmdgrp.rec.doccur");}
 				public void setValue(String arg){Detfrd.this.getBmdgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Detfrd.this.getBmdgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Detfrd.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Detfrd.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("bmdgrp.rec.ownref");}
 				public void setValue(String arg){Detfrd.this.getBmdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Detfrd.this.getBmdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("bmdgrp.rec.ptyinr");}
 				public void setValue(String arg){Detfrd.this.getBmdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Detfrd.this.getBmdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detfrd.this.getFieldPath("bmdgrp.rec.stlref");}
 				public void setValue(String arg){Detfrd.this.getBmdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detfrd.this.getBmdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:detfrd.@0003.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			// oprtypChange();
			
			return true;
        }

        /**
        *   source:detfrd.@0004.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBmdgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			log.info("{}","sav200开始================" );
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bmd");
			this.getAfdgrp().getRec().setObjinr(this.getBmdgrp().getRec().getInr());
			if("3".equals(this.getAfdgrp().getRec().getApytyp()))
			{
			  this.getAfdgrp().getRec().setOprval(this.getBmdgrp().getCur()+this.getBmdgrp().getAmt());
			}
			else if("5".equals(this.getAfdgrp().getRec().getApytyp()))
			{
			  this.getAfdgrp().getRec().setOprval(MdaUtils.format(this.getBmdgrp().getDat(),"yyMMdd"));
			}
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			log.info("{}", "sav200入库结束================" );
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================");

			return true;
        }

        /**
        *   source:detfrd.@0005.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","detfrd",stream,false );

			return true;
        }

        /**
        *   source:detfrd.@0010.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:detfrd.@0012.script
        */
        @Rule(target="bmdgrp.amt",order=100)
        public boolean ruleBmdgrpAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			oprtypChange();

			return true;
        }

        /**
        *   source:detfrd.@0013.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "卖方证寄单下杂项处理申请书";
			String tempfiles = "A:detfrd";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:detfrd.@0014.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream =$mtabut\\apldoc.getValue();
			this.getBmtp().getPdfviw().callPDFComponent("","detfrd","卖方证寄单下杂项处理申请书",1);

			return true;
        }



        /**
        *   source:detfrd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			
			
			
			
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			
			
			
			
			
			
			
			

			//if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			//{
			//  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			// $bmdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			//  }
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }

			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  {
			    
			  }
			  return true;
			}
			IModule bmd = (IModule)ctx.restoreData("com.brilliance.detfrd.ref");
			if(!MdaUtils.isEmpty(bmd))
			  this.getBmdgrp().getRec().copyValue(bmd);

			//if(!"1".equals($sysmod\\pty\\ptytyp.getValue()))
			//Platform.clear($bmdgrp\\rec\\ownref);
			
			ctx.getDaoSession().dbRead(this.getBmdgrp().getApl().getPts(),new Argument<String>("objinr",this.getBmdgrp().getRec().getInr()),new Argument<String>("objtyp","bmd"),new Argument<String>("rol","apl"));
			this.getAfdgrp().getRec().setOprtyp("0");

			if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			else
			{
			  this.getAfdgrp().getRec().setBchcod(this.getBmdgrp().getRec().getBchcod());
			  log.info("{}","bchcod="+this.getBmdgrp().getRec().getBchcod());
			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  {
			    
			  }
			}

			//Platform.disable($bmdgrp\\cur);
			//Platform.disable($bmdgrp\\amt);
			//Platform.disable($bmdgrp\\dat);
			//$bmdgrp\\cur.setValue("USD");
			
			return true;
        }

        /**
        *   source:detfrd.@0007.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp2"));
			oprtypInit();
			/*log.debug("bchcod Value ======"+$afdgrp\\rec\\bchcod.getValue());
			  log.info("bchcod="+$afdgrp\\rec\\bchcod);
			  List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			  Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			  //$bmdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  if(Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			  {
			  if("3".equals($sysmod\\pty\\ptytyp.getValue()))
			  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  else
			  $afdgrp\\rec\\bchcod.setValue($bmdgrp\\rec\\bchcod.getValue());
			  log.info("bchcod="+$bmdgrp\\rec\\bchcod.getValue());
			  }
			  Platform.disable($afdgrp\\rec\\bchcod);
			  */

			return true;
        }


        /**
        *   source:detfrd.@0008.script
        */
        public void oprtypChange()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			if("0".equals(oprtyp))
			{
			  //无操作
			  
			  
			  
			  
			  this.getBmdgrp().setOprlabel(NULLSTR);
			  this.getBmdgrp().setCur(NULLSTR);
			  this.getBmdgrp().setAmt(new BigDecimal(0));
			  this.getBmdgrp().setDat(null);
			}
			else if("8".equals(oprtyp))
			{
			  //申请修改单据金额
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000013"));
			  
			  this.getBmdgrp().setCur(this.getBmtp().getBmdgrp().getRec().getDoccur());
			  
			  
			  
			  this.getBmdgrp().setDat(null);
			  this.getAfdgrp().getRec().setOprtxt("We Apply to Amend the Document Amount to " + this.getBmdgrp().getCur() + this.getBmdgrp().getAmt() + ".");
			}
			else if("9".equals(oprtyp))
			{
			  //同意修改单据金额
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000014"));
			  
			  this.getBmdgrp().setCur(this.getBmtp().getBmdgrp().getRec().getDoccur());
			  
			  
			  
			  this.getBmdgrp().setDat(null);
			  this.getAfdgrp().getRec().setOprtxt("We Agree to Amend the Document Amount to " + this.getBmdgrp().getCur() + this.getBmdgrp().getAmt() + ".");
			}
			else if("12".equals(oprtyp))
			{
			  //申请变更到期日
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000015"));
			  
			  
			  
			  
			  this.getBmdgrp().setCur(NULLSTR);
			  this.getBmdgrp().setAmt(new BigDecimal(0));
			  Date dat = this.getBmdgrp().getDat();
			  if(MdaUtils.isEmpty(dat))
			    dat = new Date();
			  String dateStr = MdaUtils.format(dat,"yyyy/MM/dd");
			  this.getAfdgrp().getRec().setOprtxt("We Apply to Change the Maturity Date to " + dateStr + ".");
			}
			else if("13".equals(oprtyp))
			{
			  //同意变更到期日
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000016"));
			  
			  
			  
			  
			  this.getBmdgrp().setCur(NULLSTR);
			  this.getBmdgrp().setAmt(new BigDecimal(0));
			  Date dat = this.getBmdgrp().getDat();
			  if(MdaUtils.isEmpty(dat))
			    dat = new Date();
			  String dateStr = MdaUtils.format(dat,"yyyy/MM/dd");
			  this.getAfdgrp().getRec().setOprtxt("We Agree to Change the Maturity Date to " + dateStr + ".");
			}
			else
			{
			  
			  
			  
			  
			  this.getBmdgrp().setOprlabel(NULLSTR);
			  this.getBmdgrp().setCur(NULLSTR);
			  this.getBmdgrp().setAmt(new BigDecimal(0));
			  this.getBmdgrp().setDat(null);
			  if("10".equals(oprtyp))
			  {
			    //申请退单
			    this.getAfdgrp().getRec().setOprtxt("We Apply to Return the Documents to the Beneficiary.");
			  }
			  else if("11".equals(oprtyp))
			  {
			    //同意退单
			    this.getAfdgrp().getRec().setOprtxt("We Agree to Return the Documents to the Beneficiary.");
			  }
			  else if("14".equals(oprtyp))
			  {
			    //申请无偿放单
			    this.getAfdgrp().getRec().setOprtxt("We Apply to Release to the Applicant Free of Payment.");
			  }
			  else if("15".equals(oprtyp))
			  {
			    //同意无偿放单
			    this.getAfdgrp().getRec().setOprtxt("We Agree to Release to the Applicant Free of Payment.");
			  }
			}
			
			
			
			
			
		}
        /**
        *   source:detfrd.@0009.script
        */
        public void oprtypInit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			if("0".equals(oprtyp))
			{
			  //无操作
			  
			  
			  
			  
			}
			else if("8".equals(oprtyp)  ||  "9".equals(oprtyp))
			{
			  //申请/同意修改单据金额
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000023"));
			  
			  this.getBmdgrp().setCur(this.getBmtp().getBmdgrp().getRec().getDoccur());
			  
			  
			  
			}
			else if("12".equals(oprtyp)  ||  "13".equals(oprtyp))
			{
			  //申请/同意变更到期日
			  this.getBmdgrp().setOprlabel(MdaUtils.getI18NString("detfrd","CT000024"));
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
			
		}










}