package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetfreVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bmdgrp;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方信用证杂项处理申请入口
*/
@Transaction(vo= DetfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detfre.class);

		@BDGetter
		private Bmdgrp bmdgrp;

		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Detfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:detfre.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			log.info("{}","seltyp=="+ seltyp);
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  
			  
			  //queryClause = "SELECT ded.inr trsinr,ded.stlref ref,ded.advdat dat,ded.lcccur cur,ded.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM ded,pts,adr,pta WHERE ded.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'ded' AND pts.objinr = ded.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM ded rec,pts s WHERE s.rol = 'apl' "
			    +"AND s.objtyp = 'ded' AND s.objinr = rec.inr "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}
			else if("2".equals(seltyp))
			{
			  //出口信用证寄单通知
			  
			  
			  //queryClause = "SELECT bmd.inr trsinr,bmd.stlref ref,bmd.advdat dat,bmd.doccur cur,bmd.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bmd,pts,adr,pta WHERE bmd.docflg = 'docadv' AND pts.rol = 'apl' AND pts.objtyp = 'bmd' AND pts.objinr = bmd.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  //"WHERE docflg = 'docadv'";
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam  "
			    +"FROM bmd rec,pts s WHERE s.rol = 'apl' AND s.objtyp = 'bmd' AND s.objinr = rec.inr "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn1(queryClause);
			}
			
			

			return true;
        }

        /**
        *   source:detfre.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  this.getSelp().sureBtn("dedgrp","detfrc");
			}
			else if("2".equals(seltyp))
			{
			  //出口信用证寄单通知
			  this.getSelp().sureBtn1("bmdgrp","detfrd");
			}

			return true;
        }

        /**
        *   source:detfre.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			//出口信用证来证通知
			this.getSelp().sureBtn("dedgrp","detfrc");

			return true;
        }

        /**
        *   source:detfre.@0004.script
        */
        @Rule(target="selp.tmplst1",order=100)
        public boolean ruleSelpTmplst1N100(){
            IContext ctx = MdaEnv.getContext();
            
			//出口信用证寄单通知
			this.getSelp().sureBtn1("bmdgrp","detfrd");

			return true;
        }



        /**
        *   source:detfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("seldetfre"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT ded.inr trsinr,ded.stlref ref,ded.advdat dat,ded.lcccur cur,ded.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM ded,pts,adr,pta WHERE ded.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'ded' AND pts.objinr = ded.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			
			
			
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM ded rec,pts s WHERE s.rol = 'apl' "
			  +"AND s.objtyp = 'ded' AND s.objinr = rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }








}