package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DetopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Detmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Dedgrp;
import com.ceb.gjjs.mda.manager.module.Detp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 卖方信用证来证通知
*/
@Transaction(vo= DetopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Detopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Detopn.class);

        //test stream
        private IStream tesstm = new StreamImpl();
		@BDGetter
		private Dedgrp dedgrp;

		@BDGetter
		private Detmod detmod;

		@BDGetter
		private Detp detp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Detopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDetmod().setDedgrpHolder(()->this.getDedgrp());
           this.getDetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDetp().setDedgrpHolder(()->this.getDedgrp());
           this.getDetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Detopn.this.getDedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Detopn.this.getDedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.bchcod");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.lcccur");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getLcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.inr");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setInr(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.ownref");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.ptyinr");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Detopn.this.getFieldPath("dedgrp.rec.stlref");}
 				public void setValue(String arg){Detopn.this.getDedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Detopn.this.getDedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:detopn.@0008.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:detopn.@0009.script
        */
        @Rule(target="detp.xptslt",order=100)
        public boolean ruleDetpXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDetp().getXptqna().setRef(this.getDedgrp().getRec().getStlref());
			log.debug("{}","ref="+this.getDetp().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getDetp().getXptqna());
			

			return true;
        }



        /**
        *   source:detopn.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());
			/*
			  *由于灰显的部分无法拷贝，业务人员要求放开
			  *2010-03-01
			  Platform.disable($dedgrp\\rec\\stlref);
			  Platform.disable($dedgrp\\rec\\lccref);
			  Platform.disable($dedgrp\\rec\\opndat);
			  Platform.disable($dedgrp\\rec\\expdat);
			  Platform.disable($dedgrp\\rec\\shpdat);
			  Platform.disable($dedgrp\\ben\\pts\\extkey);
			  Platform.disable($dedgrp\\ben\\pts\\adrblk);
			  Platform.disable($detp\\benp\\sel);
			  Platform.disable($dedgrp\\isb\\pts\\extkey);
			  Platform.disable($dedgrp\\isb\\pts\\adrblk);
			  Platform.disable($detp\\isbp\\sel);
			  */
			
			
			

			return true;
        }

        /**
        *   source:detopn.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getDetp().getDetp02());

			return true;
        }

        /**
        *   source:detopn.@0010.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }












}