package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DitameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Ditp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ditmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证修改申请
*/
@Transaction(vo= DitameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditame.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Ditmod ditmod;

		@BDGetter
		private Ditp ditp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Ditame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDitp().setDidgrpHolder(()->this.getDidgrp());
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("DC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.issameamt");}
 				public void setValue(BigDecimal arg){Ditame.this.getDidgrp().getRec().setIssameamt(arg);}
 				public BigDecimal getValue(){return Ditame.this.getDidgrp().getRec().getIssameamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.bchcod");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.isscur");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.inr");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setInr(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.ownref");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.ptyinr");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditame.this.getFieldPath("didgrp.rec.stlref");}
 				public void setValue(String arg){Ditame.this.getDidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Ditame.this.getDidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:ditame.@0003.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","sav200开始,trnmod bchcod = "+this.getTrnmod().getBchcod());
			if(!ctx.checkAll(this.getDidgrp()))
			  return false;
			this.method();
			//校验界面内容
			if(MdaUtils.isEmpty(this.getDidgrp().getMben().getPts().getAdrblk())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getExpamedat())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamedat())&&
			  MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamefro())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getShpameto())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getIncamt())&&
			MdaUtils.isEmpty(this.getDidgrp().getRec().getDecamt())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getDetails()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("ditame","CT000104"),MdaUtils.getI18NString("ditame","CT000105"));
			  return false;
			}

			BigDecimal iss=MdaUtils.parseDecimal(MdaUtils.format(this.getDidgrp().getRec().getIssamt(),"#0.00"));
			this.getDidgrp().getRec().setIssamt(iss);

			//更新原记录
			ctx.getDaoSession().dbUpdate(this.getDidgrp().getRec());
			//Platform.dbUpdate($didgrp\\blk);
			String objinr = this.getDidgrp().getRec().getInr();
			String objtyp = "did";
			if(this.getSysmod().sptIsLoaded("B"))
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getMben().getPts(),objinr);
			else
			  this.getDidgrp().getMben().savpts(objinr,objtyp);
			//trnBegin-->
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束!" );

			return true;
        }

        /**
        *   source:ditame.@0004.script
        */
        @Rule(target="didgrp.rec.incamt",order=100)
        public boolean ruleDidgrpRecIncamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","incamt的default校验==============");
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getIncamt()))
			{
			  BigDecimal tmp2 = this.getDidgrp().getRec().getIncamt();
			  log.info("{}",tmp2.longValue()+">0?"+(tmp2.longValue()>0));
			  if(tmp2.doubleValue()>0)
			  {
			    this.getDidgrp().getRec().setDecamt(new BigDecimal(0));
			    this.getDidgrp().getRec().setIssameamt(tmp2.add(this.getDidgrp().getRec().getIssamt()));
			  }
			  else
			  {
			    this.getDidgrp().getRec().setDecamt(new BigDecimal(0));
			    this.getDidgrp().getRec().setIssameamt(this.getDidgrp().getRec().getIssamt());
			  }
			  
			  
			  
			}
			else if(MdaUtils.isEmpty(this.getDidgrp().getRec().getDecamt())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getIncamt()))
			{
			  this.getDidgrp().getRec().setIssameamt(this.getDidgrp().getRec().getIssamt());
			  
			}

			return true;
        }

        /**
        *   source:ditame.@0005.script
        */
        @Rule(target="didgrp.rec.decamt",order=100)
        public boolean ruleDidgrpRecDecamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","decamt的default校验==============");
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getDecamt()))
			{
			  BigDecimal tmp = (this.getDidgrp().getRec().getIssamt()).subtract(this.getDidgrp().getRec().getDecamt());
			  log.info("{}",tmp.longValue()+">0?"+(tmp.longValue()>0));
			  if(tmp.doubleValue()>0)
			  {
			    this.getDidgrp().getRec().setIssameamt(tmp);
			  }
			  else
			  {
			    this.getDidgrp().getRec().setIncamt(new BigDecimal(0));
			    this.getDidgrp().getRec().setIssameamt(this.getDidgrp().getRec().getIssamt());
			    ctx.setFieldError(this,"didgrp.rec.decamt",MdaUtils.getI18NString("ditame","CT000065"));
			    this.getDidgrp().getRec().setDecamt(new BigDecimal(0));
			  }
			  
			  
			  
			}
			else if(MdaUtils.isEmpty(this.getDidgrp().getRec().getDecamt())&&MdaUtils.isEmpty(this.getDidgrp().getRec().getIncamt()))
			{
			  this.getDidgrp().getRec().setIssameamt(this.getDidgrp().getRec().getIssamt());
			  
			}

			return true;
        }

        /**
        *   source:ditame.@0006.script
        */
        @Rule(target="mtabut.apldoc",order=120)
        public boolean ruleMtabutApldocN120(){
            IContext ctx = MdaEnv.getContext();
            

			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","ditame",stream,false );

			return true;
        }

        /**
        *   source:ditame.@0007.script
        */
        @Rule(target="didgrp.rec.amenbr",order=100)
        public boolean ruleDidgrpRecAmenbrN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:ditame.@0011.script
        */
        @Rule(target="mtabut.mail",order=150)
        public boolean ruleMtabutMailN150(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("ditameApp"+inr,"ditame");
			this.getMtabut().creatTcoPdfFile("ditameDra"+inr);
			this.getMtabut().setAttnames("ditameApp"+inr+".pdf;ditameDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:ditame.@0012.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:ditame.@0028.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.method();
			BigDecimal iss=MdaUtils.parseDecimal(MdaUtils.format(this.getDidgrp().getRec().getIssamt(),"#0.00"));
			this.getDidgrp().getRec().setIssamt(iss);
			
			this.getDitp().getPdfviw().callPDFComponent("","ditame","买方证修改",1);

			return true;
        }

        /**
        *   source:ditame.@0030.script
        */
        @Rule(target="mtabut.sftdra",order=100)
        public boolean ruleMtabutSftdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getPdfviw().callSwiftPDFComponent("","ditame","买方证修改",1);

			return true;
        }

        /**
        *   source:ditame.@0031.script
        */
        @Rule(target="mtabut.draftmsg",order=100)
        public boolean ruleMtabutDraftmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getPdfviw().callSwiftPDFComponent("","ditame","买方证修改",1);

			return true;
        }

        /**
        *   source:ditame.@0032.script
        */
        @Rule(target="mtabut.csche",order=100)
        public boolean ruleMtabutCscheN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getPdfviw().callPDFComponent("","ditame","买方证修改",1);

			return true;
        }

        /**
        *   source:ditame.@0036.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "国内买方信用证修改申请";
			String tempfiles = "A:ditame";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }


        /**
        *   source:ditame.@0001.script
        */
        @Check(target="didgrp.rec.shpamedat",order=100)
        public boolean checkDidgrpRecShpamedatN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","shpamedat的check校验======");
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamedat()))
			  return true;
			/*
			  if(Platform.diff($didgrp\\rec\\shpamedat.getValue(),$didgrp\\rec\\expdat.getValue())<0)
			  Platform.error($didgrp\\rec\\shpamedat,#CT000040);
			  else if(!Platform.isEmpty($didgrp\\rec\\expamedat) && Platform.diff($didgrp\\rec\\shpamedat.getValue(),$didgrp\\rec\\expamedat.getValue())>0)
			  */
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getExpamedat()) && MdaUtils.diff(this.getDidgrp().getRec().getShpamedat(),this.getDidgrp().getRec().getExpamedat())>0)
			  ctx.setFieldError(this,"didgrp.rec.shpamedat",MdaUtils.getI18NString("ditame","CT000041"));

			return true;
        }

        /**
        *   source:ditame.@0002.script
        */
        @Check(target="didgrp.rec.expamedat",order=100)
        public boolean checkDidgrpRecExpamedatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getExpamedat()))
			  return true;
			/*
			  if(Platform.isEmpty($didgrp\\rec\\shpamedat) && Platform.isEmpty($didgrp\\rec\\shpdat))
			  return;
			  else if(Platform.isEmpty($didgrp\\rec\\shpamedat) && (Platform.diff($didgrp\\rec\\shpdat.getValue(), $didgrp\\rec\\expamedat.getValue())>0))
			  */
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamedat()) && (MdaUtils.diff(this.getDidgrp().getRec().getExpamedat(),this.getDidgrp().getRec().getShpamedat())<0))
			  ctx.setFieldError(this,"didgrp.rec.expamedat",MdaUtils.getI18NString("ditame","CT000042"));
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getCredat()))
			  return true;
			if(MdaUtils.diff(this.getDidgrp().getRec().getExpamedat(),this.getDidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"didgrp.rec.expamedat",MdaUtils.getI18NString("ditame","CT000047"));


			return true;
        }

        /**
        *   source:ditame.@0040.script
        */
        @Check(target="ditp.didgrp.rec.incamt",order=100)
        public boolean checkDitpDidgrpRecIncamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"incamt"));

			return true;
        }

        /**
        *   source:ditame.@0041.script
        */
        @Check(target="ditp.didgrp.rec.decamt",order=100)
        public boolean checkDitpDidgrpRecDecamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"decamt"));

			return true;
        }


        /**
        *   source:ditame.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			

			
			
			
			
			
			
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			
			
			//补充
			
			
			//--
			
			
			
			
			
			
			
			
			
			
			
			if(this.getSysmod().sptIsLoaded("B")  ||   this.getSysmod().sptIsLoaded("P")  ||  this.getSysmod().sptIsLoaded("T"))
			{
			  if(this.getSysmod().sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  return true;
			}
			//
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.ditame.ref");
			if(!MdaUtils.isEmpty(mdl))
			  this.getDidgrp().getRec().copyValue(mdl);
			//Platform.dbRead($didgrp\\blk,new Argument<String>("inr",$didgrp\\rec\\inr));
			ctx.getDaoSession().dbRead(this.getDidgrp().getApl().getPts(),new Argument<String>("objinr",this.getDidgrp().getRec().getInr()),new Argument<String>("objtyp","did"),new Argument<String>("rol","apl"));
			//Platform.errorCode();
			//$didgrp\\dap.initDap("did");
			//$didgrp\\apl.copyValues($didgrp\\dap);
			//$didgrp\\apl\\pts\\rol.setValue("apl");
			log.debug("{}","inr++++++++++++++++++++++++++++++++="+this.getDidgrp().getRec().getInr());
			if(MdaUtils.isEmpty(this.getDidgrp().getApl().getPts().getRef()))
			  this.getDidgrp().getApl().getPts().setRef(this.getDidgrp().getRec().getStlref());
			this.getDidgrp().getRec().setCreamedat(MdaUtils.today());
			this.getDidgrp().getRec().setAmenbr(this.getDidgrp().getRec().getAmenbr()+1);
			//Platform.clear($didgrp\\rec\\ownref);
			
			ctx.getDaoSession().dbRead(this.getDidgrp().getBen().getPts(),new Argument<String>("objinr",this.getDidgrp().getRec().getInr()),new Argument<String>("objtyp","did"),new Argument<String>("rol","ben"));
			//Platform.setValues($didgrp\\rec\\sndtyp,Platform.getCodetable("sndtyp"));
			this.getDidgrp().getRec().setSndtyp("1");

			this.getDidgrp().getRec().setIssameamt(this.getDidgrp().getRec().getIssamt());
			//Platform.setValues($didgrp\\rec\\chrgameby,Platform.getCodetable("chrgameby"));
			this.getDidgrp().getRec().setChrgameby("1");

			//Platform.disable($didgrp\\apl\\pts\\adrblk);
			this.getDidgrp().getApl().getPty().setNam(ctx.absGet(Sysmod.class).getPty().getNam());

			this.getDidgrp().getRec().setExpamedat(null);
			this.getDidgrp().getRec().setShpamedat(null);
			this.getDidgrp().getRec().setShpamefro(NULLSTR);
			this.getDidgrp().getRec().setPorameloa(NULLSTR);
			this.getDidgrp().getRec().setPoramedis(NULLSTR);
			this.getDidgrp().getRec().setShpameto(NULLSTR);
			this.getDidgrp().getRec().setIncamt(new BigDecimal(0));
			this.getDidgrp().getRec().setDecamt(new BigDecimal(0));
			this.getDidgrp().getRec().setDetails(NULLSTR);
			//$didgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			//激活修改后受益人栏位
			
			//Platform.setModified($didgrp\\mben\\pts\\adrblk);
			//补充：
			
			
			//---
			
			
			
			

			return true;
        }

        /**
        *   source:ditame.@0010.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getDidgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getDidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$didgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getIbchcod()))
			      this.getDidgrp().getRec().setBchcod(this.getDidgrp().getRec().getIbchcod());
			    else
			    {
			      this.getDidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getDidgrp().getRec().setIbchcod(this.getDidgrp().getRec().getBchcod());
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getDbchcod()))
			      this.getDidgrp().getRec().setBchcod(this.getDidgrp().getRec().getDbchcod());
			    else
			      this.getDidgrp().getRec().setDbchcod(this.getDidgrp().getRec().getBchcod());
			    
			  }
			  log.info("{}","bchocd="+this.getDidgrp().getRec().getBchcod()+",dbchocd="+this.getDidgrp().getRec().getDbchcod()+",ibchcod="+this.getDidgrp().getRec().getIbchcod());
			}


			return true;
        }


        /**
        *   source:ditame.@0026.script
        */
        public void catchMbenInfo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String det = " ";
			log.info("{}","extkey=这是检测"+this.getDidgrp().getMben().getPts().getExtkey());
			log.info("{}","adrblk="+this.getDidgrp().getMben().getPts().getAdrblk());
			log.info("{}","进入判断2"+this.getDidgrp().getMben().getPts().getExtkey());
			det="修改后受益人："+this.getDidgrp().getMben().getPts().getExtkey()+"\r\n"+this.getDidgrp().getMben().getPts().getAdrblk();
			this.getDidgrp().getBlk().setAmetxt(det);
			
		}
        /**
        *   source:ditame.@0039.script
        */
        public void method()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String dets = " ";
			//补充
			this.getDitp().getMbenp().cutField(MdaDriver.getDatafield(this.getDidgrp().getMben().getPts(),"adrblk"),this.getDidgrp().getMben().getPts().getNam(),this.getDidgrp().getMben().getPts().getAdr(),null);
			if((!MdaUtils.isEmpty(this.getDidgrp().getMben().getPts().getExtkey()))||(!MdaUtils.isEmpty(this.getDidgrp().getMben().getPts().getAdrblk())))
			{

			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="修改后受益人："+this.getDidgrp().getMben().getPts().getExtkey()+"\r\n"+this.getDidgrp().getMben().getPts().getAdrblk();

			  }
			  else
			  {
			    if(MdaUtils.isEmpty(this.getDidgrp().getMben().getPts().getExtkey()))
			    {
			      dets="修改后受益人："+this.getDidgrp().getMben().getPts().getAdrblk();

			    }
			    else
			    {
			      dets="修改后受益人："+this.getDidgrp().getMben().getPts().getExtkey()+"\r\n"+this.getDidgrp().getMben().getPts().getAdrblk();

			    }
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);
			

			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getExpamedat()))
			{
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			    dets="修改后有效期："+MdaUtils.format(this.getDidgrp().getRec().getExpamedat(),"yyyy 年 MM 月 dd 日");
			  else
			  {
			    dets=dets+"\r\n"+"修改后有效期："+MdaUtils.format(this.getDidgrp().getRec().getExpamedat(),"yyyy 年 MM 月 dd 日");
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);
			

			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamedat()))
			{
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="修改后最迟装运期："+MdaUtils.format(this.getDidgrp().getRec().getShpamedat(),"yyyy 年 MM 月 dd 日");
			  }
			  else
			  {
			    dets=dets+"\r\n"+"修改后最迟装运期："+MdaUtils.format(this.getDidgrp().getRec().getShpamedat(),"yyyy 年 MM 月 dd 日");
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);

			if (!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpamefro()))
			{
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="修改后起运地："+(this.getDidgrp().getRec().getShpamefro());
			  }
			  else
			  {
			    dets = (this.getDidgrp().getBlk().getAmetxt()+"\r\n" +"修改后起运地："+(this.getDidgrp().getRec().getShpamefro()));
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);

			if (!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpameto()))
			{
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="修改后目的地："+(this.getDidgrp().getRec().getShpameto());
			  }
			  else
			  {
			    dets = (this.getDidgrp().getBlk().getAmetxt()+"\r\n" +"修改后目的地："+(this.getDidgrp().getRec().getShpameto()));
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);

			BigDecimal inctmp = this.getDidgrp().getRec().getIncamt();
			BigDecimal dectmp = this.getDidgrp().getRec().getDecamt();

			if(inctmp.longValue()>0||dectmp.longValue()>0)
			{
			  if(inctmp.longValue()>0)
			  {
			    ctx.postRule(this,"didgrp.rec.incamt");
			  }
			  if(dectmp.longValue()>0)
			  {
			    ctx.postRule(this,"didgrp.rec.decamt");
			  }

			  BigDecimal issame=MdaUtils.parseDecimal(MdaUtils.format(this.getDidgrp().getRec().getIssameamt(),"#0.00"));
			  this.getDidgrp().getRec().setIssameamt(issame);
			  
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="修改后金额："+(this.getDidgrp().getRec().getIsscur())+" "+(this.getDidgrp().getRec().getIssameamt());
			  }
			  else
			  {
			    dets = (this.getDidgrp().getBlk().getAmetxt()+"\r\n" +"修改后金额："+(this.getDidgrp().getRec().getIsscur())+" "+(this.getDidgrp().getRec().getIssameamt()));
			  }
			  
			}
			this.getDidgrp().getBlk().setAmetxt(dets);
			log.info("{}","ametxt="+this.getDidgrp().getBlk().getAmetxt());

			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getDetails()))
			{
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getAmetxt()))
			  {
			    dets="其他修改细节："+(this.getDidgrp().getRec().getDetails());
			  }
			  else
			  {
			    dets=(this.getDidgrp().getBlk().getAmetxt())+"\r\n" + "其他修改细节: " +(this.getDidgrp().getRec().getDetails());
			  }
			}
			this.getDidgrp().getBlk().setAmetxt(dets);
			log.info("{}","ametxt="+this.getDidgrp().getBlk().getAmetxt());
					}









}