package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Ditame0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证修改选择
*/
@Transaction(vo= Ditame0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditame0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditame0.class);

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Ditame0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:ditame0.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			//  +"rec.credat dat FROM did rec  WHERE 1=1 "+$\\sysmod.getSelection();
			String queryClause = " ";
			if("2".equals(this.getSelp().getSeltyp()))
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  {
			    queryClause = "SELECT rec.inr trsinr,rec.ownref ref,rec.isscur cur,rec.issamt amt,"
			      +"rec.credat dat,s.adrblk bennam,rec.cretyp cretyp FROM did rec,pts s "
			      +"WHERE rec.flg ='0' AND s.rol = 'ben' AND s.objtyp = 'did' "
			      +"AND s.objinr = rec.inr AND rec.etyinr='"+this.getSysmod().getEty().getInr()+"'"
			      +" AND  rec.clsdat is  null  AND rec.stlref IS NOT NULL";
			  }
			}
			else
			{
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			    +"rec.opndat dat,s.adrblk bennam,rec.cretyp cretyp FROM did rec,pts s "
			    +"WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'did' "
			    +"AND s.objinr = rec.inr " + ctx.absGet(Sysmod.class).getSelection();
			}
			this.getSelp().queryBtn2(queryClause);

			return true;
        }

        /**
        *   source:ditame0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst2().fullSize();
			log.info("{}","size of tmplst2 is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ditame0","CT000007"),MdaUtils.getI18NString("ditame0","CT000008"));
			  return true;
			}

			String cretyp =  this.getSelp().getTmplst2().getElement(index).getCretyp() ;
			log.info("{}"," ditame0-cretyp- "+"Z".equals(cretyp));
			if ("Z".equals(cretyp))
			  this.getSelp().sureBtn2("didgrp","ditdam");
			else
			  this.getSelp().sureBtn2("didgrp","ditame");

			return true;
        }

        /**
        *   source:ditame0.@0003.script
        */
        @Rule(target="selp.tmplst2",order=200)
        public boolean ruleSelpTmplst2N200(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst2().fullSize();
			log.info("{}","size of tmplst2 is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ditame0","CT000011"),MdaUtils.getI18NString("ditame0","CT000012"));
			  return true;
			}
			String cretyp =  this.getSelp().getTmplst2().getElement(index).getCretyp() ;
			log.info("{}"," ditame0-cretyp- "+"Z".equals(cretyp));
			if ("Z".equals(cretyp))
			  this.getSelp().sureBtn2("didgrp","ditdam");
			else
			  this.getSelp().sureBtn2("didgrp","ditame");

			return true;
        }



        /**
        *   source:ditame0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			// Platform.setValues($selp\\seltyp,Platform.getCodetable("selditame"));
			// $selp\\seltyp.setValue("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			// +"rec.credat dat FROM did rec  WHERE 1=1 "+$\\sysmod.getSelection();
			// "WHERE stlref is not null and trim(stlref)<>'' ";
			//+"and rec.ptyinr='"+$sysmod\\pty\\inr+"'";
			List<CodetableItem> seltyp = new ArrayList<CodetableItem>();
			if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  seltyp.add(new CodetableItem("委托开立国内证","1"));
			  seltyp.add(new CodetableItem("自主开立国内证","2"));
			}
			else
			{
			  seltyp.add(new CodetableItem("国内买方信用证","1"));
			}
			MdaUtils.setValues(this.getSelp(),"seltyp",seltyp);
			this.getSelp().setSeltyp("1");
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			  +"rec.opndat dat,s.adrblk bennam FROM did rec,pts s "
			  +"WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'did' "
			  +"AND s.objinr = rec.inr " + ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn2(queryClause);

			return true;
        }







}