package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DitdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Ditp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ditmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证开立通知
*/
@Transaction(vo= DitdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditdav.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Ditmod ditmod;

		@BDGetter
		private Ditp ditp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Ditdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDitp().setDidgrpHolder(()->this.getDidgrp());
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Ditdav.this.getDidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Ditdav.this.getDidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.bchcod");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.isscur");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.inr");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setInr(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.ownref");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.ptyinr");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdav.this.getFieldPath("didgrp.rec.stlref");}
 				public void setValue(String arg){Ditdav.this.getDidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Ditdav.this.getDidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:ditdav.@0002.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			//#CT000001
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:ditdav.@0003.script
        */
        @Rule(target="mtabut.notice",order=0)
        public boolean ruleMtabutNoticeN0(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrnmod().getSmh().getInr()))
			{
			  String not=this.getTrnmod().getSmh().getXmlfil();
			  //Platform.invoke(object,methodName,arguments)
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("ditdav","CT000003"));
			}

			return true;
        }



        /**
        *   source:ditdav.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());
			//只有商行客户才能看到edit按钮
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			}
			else
			{
			  
			}

			//灰显部分无法拷贝，业务人员要求放开
			// 2010-03-01
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			//补充：
			
			
			
			


			return true;
        }

        /**
        *   source:ditdav.@0001.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getDap().getPts().getRef()))
			{
			  this.getDidgrp().getDap().getPts().setRef(this.getDidgrp().getRec().getStlref());
			  
			}
			

			return true;
        }

        /**
        *   source:ditdav.@0004.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getDitp().getDitp04());

			return true;
        }

        /**
        *   source:ditdav.@0005.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}