package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DitdopVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Ditp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ditmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 国内信用证开立（商行自主开立）
*/
@Transaction(vo= DitdopVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditdop extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditdop.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Ditmod ditmod;

		@BDGetter
		private Ditp ditp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Ditdop()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDitp().setDidgrpHolder(()->this.getDidgrp());
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("DC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.isscur");}
 				public void setValue(String arg){Ditdop.this.getDidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Ditdop.this.getDidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Ditdop.this.getDidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Ditdop.this.getDidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.ownref");}
 				public void setValue(String arg){Ditdop.this.getDidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ditdop.this.getDidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.bchcod");}
 				public void setValue(String arg){Ditdop.this.getDidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ditdop.this.getDidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.inr");}
 				public void setValue(String arg){Ditdop.this.getDidgrp().getRec().setInr(arg);}
 				public String getValue(){return Ditdop.this.getDidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("sysmod.pty.inr");}
 				public void setValue(String arg){Ditdop.this.getSysmod().getPty().setInr(arg);}
 				public String getValue(){return Ditdop.this.getSysmod().getPty().getInr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditdop.this.getFieldPath("didgrp.rec.stlref");}
 				public void setValue(String arg){Ditdop.this.getDidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Ditdop.this.getDidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:ditdop.@0010.script
        */
        @Rule(target="didgrp.rec.apprul",order=100)
        public boolean ruleDidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getDidgrp().getRec().getApprul()))
			{
			  
			  this.getDidgrp().getRec().setApprultxt(NULLSTR);
			  //$didgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getDidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:ditdop.@0011.script
        */
        @Rule(target="didgrp.rec.avbby",order=100)
        public boolean ruleDidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getDidgrp().getRec().getAvbby();
			if("1".equals(avbby))
			{
			  //即期
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  this.getDitp().getNegp().getPtspta().getPts().setExtkey(NULLSTR);
			  
			  
			  
			  
			  
			  this.getDitp().getNegp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			}
			if("2".equals(avbby))
			{

			  
			  this.getDidgrp().getBlk().setDefdet("运输单据装运日/货物收据签发日/出库单签发日后   天");
			  
			  
			  this.getDitp().getNegp().getPtspta().getPts().setExtkey(NULLSTR);
			  
			  
			  this.getDitp().getNegp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			}
			if("3".equals(avbby))
			{
			  
			  
			  
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:ditdop.@0012.script
        */
        @Rule(target="didgrp.rec.avbwths",order=100)
        public boolean ruleDidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getDidgrp().getRec().getAvbwths()))
			{
			  
			  this.getDidgrp().getRec().setAvbwth(NULLSTR);
			  //$didgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getDidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:ditdop.@0014.script
        */
        @Rule(target="didgrp.rec.cnfflg",order=100)
        public boolean ruleDidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getDidgrp().getRec().getCnfflg())  ||  "2".equals(this.getDidgrp().getRec().getCnfflg()))
			  this.getDidgrp().getBlk().setCnfdet("If confirmed,confirm charges are for beneficiary's account.");
			else
			  this.getDidgrp().getBlk().setCnfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:ditdop.@0015.script
        */
        @Rule(target="didgrp.rec.concur",order=100)
        public boolean ruleDidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getConcur()))
			{
			  return true;
			}
			this.getDidgrp().getRec().setIsscur(this.getDidgrp().getRec().getConcur());
			

			return true;
        }

        /**
        *   source:ditdop.@0016.script
        */
        @Rule(target="didgrp.rec.nomflg",order=100)
        public boolean ruleDidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getDidgrp().getRec().getNomflg()))
			{
			  //勾选
			  // Platform.setRequired($didgrp\\rec\\nomtop);
			  // Platform.setRequired($didgrp\\rec\\nomton);
			  
			  
			}
			else
			{
			  
			  
			}
			this.getDidgrp().getRec().setNomtop(new BigDecimal(0));
			this.getDidgrp().getRec().setNomton(new BigDecimal(0));
			
			

			return true;
        }

        /**
        *   source:ditdop.@0017.script
        */
        @Rule(target="didgrp.rec.sstdat",order=100)
        public boolean ruleDidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getDidgrp().getRec().getSstdat()))
			{
			  
			  this.getDidgrp().getRec().setSstdattxt(NULLSTR);
			  //$didgrp\\rec\\sstdattxt.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",this.getDidgrp().getRec().getSstdat()));
			}
			

			return true;
        }

        /**
        *   source:ditdop.@0018.script
        */
        @Rule(target="didgrp.rec.trdflg",order=100)
        public boolean ruleDidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getDidgrp().getRec().getTrdflg()))
			{
			  //Platform.setRequired($didgrp\\rec\\trdtrmver);
			  
			  this.getDidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2000");
			}
			else
			{
			  this.getDidgrp().getRec().setTrdtrmver(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:ditdop.@0019.script
        */
        @Rule(target="didgrp.rec.trfflg",order=100)
        public boolean ruleDidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getDidgrp().getRec().getTrfflg()))
			  this.getDidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			else
			  this.getDidgrp().getBlk().setTrfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:ditdop.@0020.script
        */
        @Rule(target="didgrp.rec.upsflg",order=100)
        public boolean ruleDidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getDidgrp().getRec().getUpsflg()))
			  this.getDidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getDidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:ditdop.@0022.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.checkAll(this.getDidgrp()))
			  ctx.setMessage(MdaUtils.getI18NString("ditdop","CT000009"),MdaUtils.getI18NString("ditdop","CT000010"));

			return true;
        }

        /**
        *   source:ditdop.@0023.script
        */
        @Rule(target="mtabut.ped",order=200)
        public boolean ruleMtabutPedN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  String typ=ctx.getTransName().substring(0,2);
			  String ptyname=this.getTrnmod().getPtyName(ctx.absGet(Sysmod.class).getPty().getInr());
			  this.getSysmod().getSpt().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			  this.getSysmod().getSpt().setObjinr("");
			  this.getSysmod().getSpt().setObjnam(this.getDidgrp().getRec().getIsscur()+this.getDidgrp().getRec().getIssamt()+"/"+ptyname);
			  this.getSysmod().getSpt().setNam(this.getDidgrp().getRec().getIsscur()+this.getDidgrp().getRec().getIssamt()+"/"+ptyname);
			}

			return true;
        }

        /**
        *   source:ditdop.@0032.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getDidgrp()))
			{
			  log.warn("{}","页面校验未通过，退出！");
			  return false;
			}

			log.info("{}","页面校验完成");
			//处理货描
			lcrgods();
			//处理其他单据
			adlcnds();
			//将页面上需要组合的值赋值到数据库字段中 Begin=========
			//将页面上需要组合的值赋值到数据库字段中 End=========
			//将Module数据入库 Begin==========
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getDidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getDidgrp().getBlk());
			  String objinr = this.getDidgrp().getRec().getInr();
			  //申请人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getApl().getPts(),objinr);
			  //受益人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getBen().getPts(),objinr);
			  //通知行
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getAdv().getPts(),objinr);
			  //付款人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getDre().getPts(),objinr);
			  //议付行
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getNeg().getPts(),objinr);
			  //保兑行
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getCon().getPts(),objinr);
			  //转让行
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getAdt().getPts(),objinr);
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getDidgrp().getRec().setIbchcod(this.getDidgrp().getRec().getBchcod());
			  else
			    this.getDidgrp().getRec().setDbchcod(this.getDidgrp().getRec().getBchcod());
			  this.getDidgrp().getRec().setInr(Platform.sdbCounter("did"));
			  this.getDidgrp().getRec().setFlg("0");
			  ctx.getDaoSession().dbInsert(this.getDidgrp().getRec());
			  String objinr = this.getDidgrp().getRec().getInr();
			  this.getDidgrp().getBlk().setInr(objinr);
			  ctx.getDaoSession().dbInsert(this.getDidgrp().getBlk());
			  String objtyp = "did";
			  //申请人
			  this.getDidgrp().getApl().savpts(objinr,objtyp);
			  //受益人
			  this.getDidgrp().getBen().savpts(objinr,objtyp);
			  //通知行
			  this.getDidgrp().getAdv().savpts(objinr,objtyp);
			  //付款人
			  this.getDidgrp().getDre().savpts(objinr,objtyp);
			  //议付行
			  this.getDidgrp().getNeg().savpts(objinr,objtyp);
			  //保兑行
			  this.getDidgrp().getCon().savpts(objinr,objtyp);
			  //转让行
			  this.getDidgrp().getAdt().savpts(objinr,objtyp);
			  //直接申请行
			  this.getDidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getDidgrp().getDap().getPts().setObjinr(objinr);
			  this.getDidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getDidgrp().getDap().getPts());
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getDidgrp().getDap().savTrp(objtyp,objinr);
			  }
			}
			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:ditdop.@0033.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().setCredat(NULLSTR);
			String credat = MdaUtils.format(this.getDidgrp().getRec().getCredat(),"yyyy年MM月dd日");
			this.getDitp().setCredat(credat);
			this.getDitp().setExpdat(NULLSTR);
			String expdat = MdaUtils.format(this.getDidgrp().getRec().getExpdat(),"yyyy年MM月dd日");
			this.getDitp().setExpdat(expdat);
			this.getDitp().setShpdat(NULLSTR);
			String shpdat = MdaUtils.format(this.getDidgrp().getRec().getShpdat(),"yyyy年MM月dd日");
			this.getDitp().setShpdat(shpdat);
			this.getDitp().setNegflg(NULLSTR);
			this.getDitp().setPayflg(NULLSTR);
			this.getDitp().setAdtflg(NULLSTR);
			this.getDitp().setConflg(NULLSTR);
			if("3".equals(this.getDidgrp().getRec().getAvbby()))
			{
			  this.getDitp().setNegflg("以下银行可议付");
			}
			else if("1".equals(this.getDidgrp().getRec().getAvbby()))
			{
			  this.getDitp().setNegflg("不可议付");
			  this.getDitp().setPayflg("即期");
			}
			else if("2".equals(this.getDidgrp().getRec().getAvbby()))
			{
			  this.getDitp().setNegflg("不可议付");
			  this.getDitp().setPayflg("远期");
			}
			if("X".equals(this.getDidgrp().getRec().getTrndet()))
			{
			  this.getDitp().setAdtflg("可转让");
			}
			else
			{
			  this.getDitp().setAdtflg("不可转让");
			}
			if("X".equals(this.getDidgrp().getRec().getCnfdet()))
			{
			  this.getDitp().setConflg("可保兑");
			}
			else
			{
			  this.getDitp().setConflg("不可保兑");
			}
			IStream stream=this.getMtabut().getApldoc();
			// 添加开证申请人说明
			ctx.absGet(Sysmod.class).generatorPdf("","ditdop",stream,false );

			return true;
        }

        /**
        *   source:ditdop.@0034.script
        */
        @Rule(target="mtabut.busmod.select",order=200)
        public boolean ruleMtabutBusmodSelectN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDidgrp().getRec().setOwnref(NULLSTR);
			

			return true;
        }


        /**
        *   source:ditdop.@0005.script
        */
        @Check(target="didgrp.agree",order=100)
        public boolean checkDidgrpAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(TRUE.equals(this.getDidgrp().getAgree())))
			{
			  ctx.setFieldError(this,"didgrp.agree",MdaUtils.getI18NString("ditdop","CT000003"));
			  return true;
			}

			return true;
        }

        /**
        *   source:ditdop.@0006.script
        */
        @Check(target="didgrp.rec.expdat",order=100)
        public boolean checkDidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getDidgrp().getRec().getExpdat()))
			  return true;
			if(MdaUtils.diff(this.getDidgrp().getRec().getExpdat(),this.getDidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"didgrp.rec.expdat",MdaUtils.getI18NString("ditdop","CT000004"));

			return true;
        }

        /**
        *   source:ditdop.@0007.script
        */
        @Check(target="didgrp.rec.issamt",order=100)
        public boolean checkDidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getDidgrp().getRec().getConamt()))
			  return true;
			BigDecimal camt = this.getDidgrp().getRec().getConamt();
			BigDecimal lamt = this.getDidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"didgrp.rec.issamt",MdaUtils.getI18NString("ditdop","CT000005"));

			return true;
        }

        /**
        *   source:ditdop.@0008.script
        */
        @Check(target="didgrp.rec.nomton",order=100)
        public boolean checkDidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getDidgrp().getRec().getNomflg()))
			  return true;
			//int类型修改为BigDecimal
			BigDecimal nomton = this.getDidgrp().getRec().getNomton();
			//if(nomton.compareTo(new BigDecimal(50))>0  ||  nomton.compareTo(new BigDecimal(0))<0)
			//无小数位的Numberic类型为Integer
			// if(nomton>50  ||  nomton<0)
			//  Platform.error($didgrp\\rec\\nomton,#CT000006);
			
			return true;
        }

        /**
        *   source:ditdop.@0009.script
        */
        @Check(target="didgrp.rec.shpdat",order=100)
        public boolean checkDidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getShpdat()))
			  return true;
			Date shpdat = this.getDidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getDidgrp().getRec().getExpdat())>0)
			  ctx.setFieldError(this,"didgrp.rec.shpdat",MdaUtils.getI18NString("ditdop","CT000007"));

			return true;
        }

        /**
        *   source:ditdop.@0035.script
        */
        @Check(target="ditp.didgrp.rec.issinf",order=100)
        public boolean checkDitpDidgrpRecIssinfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getIssinf()))
			{
			  ctx.setFieldError(this,"didgrp.rec.issinf",MdaUtils.getI18NString("ditdop","CT000012"));
			}

			return true;
        }


        /**
        *   source:ditdop.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getDidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getDidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			getAdv();
			this.getDidgrp().getRec().setCretyp("Z");
			if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getPreper()))
			{
			  this.getDidgrp().getBlk().setPreper("运输单据签发日起（）天");
			}
			this.getDidgrp().getDap().initDap("did");
			this.getDidgrp().getApl().copyValues(this.getDidgrp().getDap());
			this.getDidgrp().getApl().getPts().setExtkey(this.getSysmod().getPty().getExtkey());
			this.getDidgrp().getApl().getPts().setRol("apl");
			this.getDidgrp().getRec().setConcur("CNY");
			this.getDidgrp().getRec().setIsscur("CNY");
			this.getDidgrp().getRec().setCredat(MdaUtils.today());
			
			
			
			
			this.getDidgrp().getRec().setNomflg(FALSE);
			this.getDidgrp().getRec().setShppar("2");
			this.getDidgrp().getRec().setShptrs("2");
			this.getDidgrp().getRec().setAvbby("1");
			MdaUtils.setValues(this.getDidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg"));
			this.getDidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			this.getDidgrp().getBlk().setLcrdoc("1.（  ）税务部门统一印制/监制的正本  增值税专用发票（包括发票联和抵扣联）□  普通税务发票□ 注明信用证号码及合同号码。\r\n2.（  ）全套海运□  河运□提单，正本____份，副本 _____份，收货人______________________________________, 注明运费已付□ ／未付□ 。\r\n3.（  ）航空运单，收货人______________________________________, 注明运费已付□／未付□。\r\n4.（  ）铁路□ 公路□运单，收货人___________________________________________________ ,  注明运费已付□/未付□ 。 \r\n5.（  ）邮政收据， 收货人______________________________________________, 注明运费已付。\r\n6.（  ）正本货物收据， 显示申请人为收货人，应由申请人出具。\r\n7.（  ）正本出库单， 显示申请人为收货人。\r\n8.（  ）保险单正本_____份， 副本 ____份， 投保金额_____________元，投保险别_______ 、 ____________________。\r\n9.（  ）装箱单_______份，注明每一包装件内货物数量及每件的毛、净重。\r\n10.（  ）其他单据。");
			this.getDidgrp().getBlk().setAdlcnd("1.（  ）单据必须自运输单据签发日起______天内提交（不能晚于信用证有效期）。\r\n2.（  ）税务发票出具日期、发货日期早于信用证开立日期不接受。\r\n3.（  ）货物数量及信用证金额均可有上□下□_____%的浮动范围。\r\n4.（  ）开证行以外的所有银行费用由受益人承担。\r\n5.（  ）其他: ");
			this.getDidgrp().getRec().setSedday("21");
			this.getDidgrp().getRec().setSstdat("1");
			this.getDidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getDidgrp().getRec().setPreper("单据必须在装运日期后21天，但在信用证有效期内。");
			//Platform.enable($didgrp\\rec\\preper);
			this.getDidgrp().getRec().setApprul("1");
			this.getDidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			this.getDidgrp().setAgree(TRUE);
			this.getDitp().setAplnam(this.getSysmod().getPty().getNam());
			//Platform.disable($rmkmod\\otext);
			if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getDitp().getOpncls().getCls(),new Argument<String>("inr",this.getDitp().getOpncls().readDefaultClsInr("ditopn")));
			  this.getDidgrp().getBlk().setRgtcls(this.getDitp().getOpncls().getCls().getClstxt());
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getRgtcls()))
			  {
			    this.getDidgrp().getBlk().setRgtcls("             开立国内信用证申请人承诺书（背面）\r\n 兴业银行股份有限公司            分行：\r\n 我单位与____________________签订购销合同，现请贵行按我单位开证申请书内容开出不可撤销跟单信用证，为此我单位愿承诺如下：\r\n （）本项申请是根据本单位与贵行签订的编号为_____________的《国内信用证融资主协议》而提出。本申请书项下的信用证业务在各方面均须遵守《国内信用证融资主协议》的条款和条件以及本开证申请人承诺书中的条款和条件，并且：\r\n （）占用贵行授予本单位的国内信用证开证额度_________；\r\n （）已于本单位在贵行处开立的账号为_______________________的保证金专户中存入开证金额的  %的保证金，即开证保证金金额为(小写)___________人民币(大写)________________；\r\n （）其他担保：____________。\r\n     一、我单位愿遵守中国人民银行《国内信用证结算办法》及国家有关法规，同意贵行依据《国内信用证结算办法》及国家有关法规办理该信用证项下一切事宜，并同意承担由此产生的一切责任。\r\n     二、我单位保证按时向贵行支付信用证项下的货款、手续费、利息及一切费用等。\r\n     三、我单位保证在贵行认为单证表面相符的条件下，贵行有权主动办理确认到期付款/对外付款，并从我单位在贵行开立的任何账户中扣款。\r\n     四、贵行对由于任何电报、信函或单据邮寄过程中发生延误、遗失所造成的后果，或者电讯传递过程中发生的差错，不承担责任。\r\n     五、我单位在收到贵行开出的信用证、修改书副本通知后，保证及时与原申请书核对，如有不符之处，保证在接到通知之日起两个工作日内通知贵行。如未通知，视为正确无误。\r\n     六、如因申请书字迹不清或词意含混而引起的一切后果由我单位负责。\r\n     七、该信用证如需修改，由我单位向贵行提出书面申请和信用证修改申请人承诺书，并提交受益人同意修改的书面证明，由贵行根据具体情况确定能否办理修改。\r\n     八、我单位在贵行存入的该信用证项下的保证金按信用证及信用证结算的有关规定，贵行需向信用证受益人付款时，贵行有权将我单位开证保证金优先用于支付信用证项下款项。\r\n     本申请书与国内信用证融资主协议的内容构成本单位办理本申请书项下国内信用证业务不可分割的组成部分。");
			  }
			}
			this.getDidgrp().setAploth(FALSE);
			this.getDidgrp().setAplothtxt(" （）买方国内信用证到单\r\n （）买方国内信用证付款\r\n （）买方国内信用证承兑\r\n （）买方国内信用证拒付\r\n");
			this.getDidgrp().getRec().setIssinf(NULLSTR);

			return true;
        }


        /**
        *   source:ditdop.@0000.script
        */
        public void adlcnds()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtvalue="";
			Object adlcnd = this.getDidgrp().getBlk().getAdlcnd();
			Object nomton = this.getDidgrp().getRec().getNomton();
			Object nomflg = this.getDidgrp().getRec().getNomflg();
			Object nomtop = this.getDidgrp().getRec().getNomtop();
			// log.debug("nomflg=="+nomflg.toString());
			// log.debug("nomflg=="+nomflg);
			if(!MdaUtils.isEmpty(nomflg)&&TRUE.equals(nomflg.toString()))
			{
			  rtvalue= "+Quantity And Amount ";
			  if(!MdaUtils.isEmpty(nomtop))
			    rtvalue+=nomtop.toString()+" PERCENT More ";
			  if(!MdaUtils.isEmpty(nomton))
			  {
			    if(!MdaUtils.isEmpty(nomtop))
			      rtvalue+= " Or ";
			    rtvalue+=nomton.toString()+" PERCENT Less";
			  }
			  rtvalue+=" Are Allowed";
			}
			if(!MdaUtils.isEmpty(adlcnd))
			  if(rtvalue==null   ||   "".equals(rtvalue) )
			rtvalue=adlcnd.toString();
			else
			rtvalue+= CR+adlcnd.toString();
			else
			rtvalue=rtvalue;
			this.getDidgrp().setSwfd(rtvalue) ;
		}
        /**
        *   source:ditdop.@0001.script
        */
        public void lcrgods()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String returnvalue="";
			Object lcrgod = this.getDidgrp().getBlk().getLcrgod();
			Object trdtrm = this.getDidgrp().getRec().getTrdtrm();
			Object trdtrmplc = this.getDidgrp().getRec().getTrdtrmplc();
			Object trdtrmver = this.getDidgrp().getRec().getTrdtrmver();
			if(!MdaUtils.isEmpty(lcrgod))
			  returnvalue=lcrgod.toString()+CR;
			if(!MdaUtils.isEmpty(trdtrm))
			  returnvalue+="+Trade Terms: "+trdtrm.toString();
			if(!MdaUtils.isEmpty(trdtrmplc))
			  returnvalue+=" "+trdtrmplc.toString();
			if(!MdaUtils.isEmpty(trdtrmver))
			  returnvalue+=" "+trdtrmver.toString();
			this.getDidgrp().setSwfa(returnvalue.trim());
		}
        /**
        *   source:ditdop.@0031.script
        */
        public void getAdv()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","in getAdv()...");
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getBchcod()))
			{
			  String sql= "select pty.extkey extkey,adr.adr adrblk FROM pty,adr,pta WHERE pty.cid='"+this.getDidgrp().getRec().getBchcod()+"' and pty.inr=pta.ptyinr and adr.inr=pta.objinr";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getErrorCode();
			  log.debug("{}","sql===================" + sql);
			  Argument<String> extkey = new Argument<String>("extkey");
			  Argument<String> adrblk = new Argument<String>("adrblk");
			  ctx.getDaoSession().dbFetchFields(extkey,adrblk);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getDitp().getAdvp().getPtspta().getPts().setExtkey(extkey.value);
			    this.getDitp().getAdvp().getPtspta().getPts().setAdrblk(adrblk.value);
			    
			    
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
		}









}