package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DitmavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Ditp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ditmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方国内信用证修改通知
*/
@Transaction(vo= DitmavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditmav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditmav.class);

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Ditmod ditmod;

		@BDGetter
		private Ditp ditp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Ditmav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDitp().setDidgrpHolder(()->this.getDidgrp());
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getDidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Ditmav.this.getDidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Ditmav.this.getDidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.bchcod");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.isscur");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.inr");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setInr(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.ownref");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.ptyinr");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditmav.this.getFieldPath("didgrp.rec.stlref");}
 				public void setValue(String arg){Ditmav.this.getDidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Ditmav.this.getDidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:ditmav.@0002.script
        */
        @Rule(target="mtabut.edit",order=100)
        public boolean ruleMtabutEditN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			}

			return true;
        }



        /**
        *   source:ditmav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getDitp().getDitp05());

			return true;
        }

        /**
        *   source:ditmav.@0003.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}