package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.DitopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Ditp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ditmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Didgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 买方信用证开立
*/
@Transaction(vo= DitopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ditopn.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Didgrp didgrp;

		@BDGetter
		private Ditmod ditmod;

		@BDGetter
		private Ditp ditp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Ditopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getDitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getDitp().setDidgrpHolder(()->this.getDidgrp());
           this.getMtabut().setRecHolder(()->this.getDidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("DC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.isscur");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Ditopn.this.getDidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Ditopn.this.getDidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.ownref");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.bchcod");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.inr");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setInr(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.ptyinr");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ditopn.this.getFieldPath("didgrp.rec.stlref");}
 				public void setValue(String arg){Ditopn.this.getDidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Ditopn.this.getDidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:ditopn.@0014.script
        */
        @Rule(target="didgrp.rec.avbby",order=100)
        public boolean ruleDidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getDidgrp().getRec().getAvbby();
			if("1".equals(avbby))
			{
			  //即期
			  this.getDidgrp().getBlk().setDefdet("（）货物装运日/服务交付日后____天。\r\n（）见单后____天。\r\n（）货物收据签发日/服务提供日后____天。\r\n（）其他____");
			  
			  
			  

			  //补充“付款方式”与“付款期限”间的关系
			  this.getDidgrp().getRec().setPrompt(0);
			  
			  
			}
			else
			{
			  
			  
			  

			  //补充
			  
			}


			return true;
        }

        /**
        *   source:ditopn.@0015.script
        */
        @Rule(target="didgrp.rec.concur",order=100)
        public boolean ruleDidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getIssinf()))
			{
			  ctx.setFieldError(this,"didgrp.rec.issinf",MdaUtils.getI18NString("ditopn","CT000018"));
			}

			return true;
        }

        /**
        *   source:ditopn.@0017.script
        */
        @Rule(target="didgrp.rec.trdflg",order=100)
        public boolean ruleDidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getDidgrp().getRec().getTrdflg()))
			{
			  //Platform.setRequired($didgrp\\rec\\trdtrmver);
			  
			  this.getDidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2000");
			}
			else
			{
			  this.getDidgrp().getRec().setTrdtrmver(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0018.script
        */
        @Rule(target="mtabut.ped",order=200)
        public boolean ruleMtabutPedN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  String typ=ctx.getTransName().substring(0,2);
			  String ptyname=this.getTrnmod().getPtyName(ctx.absGet(Sysmod.class).getPty().getInr());
			  this.getSysmod().getSpt().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			  this.getSysmod().getSpt().setObjinr("");
			  this.getSysmod().getSpt().setObjnam(this.getDidgrp().getRec().getIsscur()+this.getDidgrp().getRec().getIssamt()+"/"+ptyname);
			  this.getSysmod().getSpt().setNam(this.getDidgrp().getRec().getIsscur()+this.getDidgrp().getRec().getIssamt()+"/"+ptyname);
			}

			return true;
        }

        /**
        *   source:ditopn.@0020.script
        */
        @Rule(target="didgrp.rec.upsflg",order=100)
        public boolean ruleDidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getDidgrp().getRec().getUpsflg()))
			  this.getDidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getDidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:ditopn.@0021.script
        */
        @Rule(target="didgrp.rec.avbwths",order=100)
        public boolean ruleDidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getDidgrp().getRec().getAvbwths()))
			{
			  
			  this.getDidgrp().getRec().setAvbwth(NULLSTR);
			  //$didgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getDidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0022.script
        */
        @Rule(target="didgrp.rec.apprul",order=100)
        public boolean ruleDidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getDidgrp().getRec().getApprul()))
			{
			  
			  this.getDidgrp().getRec().setApprultxt(NULLSTR);
			  //$didgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getDidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0023.script
        */
        @Rule(target="didgrp.rec.sstdat",order=100)
        public boolean ruleDidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getDidgrp().getRec().getSstdat()))
			{
			  
			  this.getDidgrp().getRec().setSstdattxt(NULLSTR);
			  //$didgrp\\rec\\sstdattxt.setValue("");
			}
			else
			{
			  
			  this.getDidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",this.getDidgrp().getRec().getSstdat()));
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0025.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.checkAll(this.getDidgrp()))
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000169"),MdaUtils.getI18NString("ditopn","CT000170"));

			return true;
        }

        /**
        *   source:ditopn.@0026.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream=$mtabut\\apldoc.getValue();
			// 添加开证申请人说明
			//$this.dealPDFData();
			this.getDitp().getPdfviw().callPDFComponent("","ditopn","国内买方证开立",1);
			//$\\sysmod.generatorPdf("","ditopn",stream,false );
			
			return true;
        }

        /**
        *   source:ditopn.@0005.script
        */
        @Rule(target="didgrp.rec.bchcod",order=100)
        public boolean ruleDidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getDidgrp().getRec().getConamt()))
			  return true;
			BigDecimal camt = this.getDidgrp().getRec().getConamt();
			BigDecimal lamt = this.getDidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"didgrp.rec.issamt",MdaUtils.getI18NString("ditopn","CT000000"));

			return true;
        }

        /**
        *   source:ditopn.@0030.script
        */
        @Rule(target="didgrp.rec.trfflg",order=100)
        public boolean ruleDidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getDidgrp().getRec().getTrfflg()))
			{
			  this.getDidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			  
			  
			}
			else
			  this.getDidgrp().getBlk().setTrfdet(NULLSTR);
			
			
			

			return true;
        }

        /**
        *   source:ditopn.@0031.script
        */
        @Rule(target="didgrp.rec.cnfflg",order=100)
        public boolean ruleDidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getDidgrp().getRec().getCnfflg())  ||  "2".equals(this.getDidgrp().getRec().getCnfflg()))
			  this.getDidgrp().getBlk().setCnfdet("If confirmed,confirm charges are for beneficiary's account.");
			else
			  this.getDidgrp().getBlk().setCnfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:ditopn.@0013.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getDidgrp()))
			{
			  log.warn("{}","页面校验未通过，退出！");
			  return false;
			}

			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getTrapla())||((MdaUtils.isEmpty(this.getDidgrp().getRec().getShpfro()))&&(MdaUtils.isEmpty(this.getDidgrp().getRec().getShpto()))))
			{
			  if((!MdaUtils.isEmpty(this.getDidgrp().getRec().getTrapla()))||((!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpfro()))&&(!MdaUtils.isEmpty(this.getDidgrp().getRec().getShpto()))))
			  {
			    log.info("{}","起运地/目的地与服务地点项校验通过");
			  }
			  else
			  {
			    ctx.setFieldError(this,"didgrp.rec.trapla",MdaUtils.getI18NString("ditopn","CT000062"));
			    return false;
			  }
			}

			log.info("{}","页面校验完成");

			//补充
			this.getDitp().getAplp().cutField(MdaDriver.getDatafield(this.getDitp().getAplp().getPtspta().getPts(),"adrblk"),this.getDitp().getAplp().getPtspta().getPts().getNam(),this.getDitp().getAplp().getPtspta().getPts().getBakcode(),this.getDitp().getAplp().getPtspta().getPts().getAdr());
			this.getDitp().getBenp().cutField(MdaDriver.getDatafield(this.getDitp().getBenp().getPtspta().getPts(),"adrblk"),this.getDitp().getBenp().getPtspta().getPts().getNam(),this.getDitp().getBenp().getPtspta().getPts().getBakcode(),this.getDitp().getBenp().getPtspta().getPts().getAdr());
			this.getDitp().getNegp().cutField(MdaDriver.getDatafield(this.getDitp().getNegp().getPtspta().getPts(),"adrblk"),this.getDitp().getNegp().getPtspta().getPts().getNam(),this.getDitp().getNegp().getPtspta().getPts().getBakcode(),this.getDitp().getNegp().getPtspta().getPts().getAdr());
			this.getDitp().getAdvp().cutField(MdaDriver.getDatafield(this.getDitp().getAdvp().getPtspta().getPts(),"adrblk"),this.getDitp().getAdvp().getPtspta().getPts().getNam(),this.getDitp().getAdvp().getPtspta().getPts().getBakcode(),this.getDitp().getAdvp().getPtspta().getPts().getAdr());
			this.getDitp().getAdtp().cutField(MdaDriver.getDatafield(this.getDitp().getAdtp().getPtspta().getPts(),"adrblk"),this.getDitp().getAdtp().getPtspta().getPts().getNam(),this.getDitp().getAdtp().getPtspta().getPts().getBakcode(),this.getDitp().getAdtp().getPtspta().getPts().getAdr());
			this.getDitp().getConp().cutField(MdaDriver.getDatafield(this.getDitp().getConp().getPtspta().getPts(),"adrblk"),this.getDitp().getConp().getPtspta().getPts().getNam(),this.getDitp().getConp().getPtspta().getPts().getBakcode(),this.getDitp().getConp().getPtspta().getPts().getAdr());

			//处理货描
			lcrgods();
			//处理其他单据
			adlcnds();
			//将页面上需要组合的值赋值到数据库字段中 Begin=========
			//将页面上需要组合的值赋值到数据库字段中 End=========
			//将Module数据入库 Begin==========
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getDidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getDidgrp().getBlk());
			  String objinr = this.getDidgrp().getRec().getInr();
			  //申请人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getApl().getPts(),objinr);
			  //受益人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getBen().getPts(),objinr);
			  //通知行
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getAdv().getPts(),objinr);
			  //付款人
			  this.getMtabut().UpdatePtsForBack(this.getDidgrp().getDre().getPts(),objinr);
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getDidgrp().getRec().setIbchcod(this.getDidgrp().getRec().getBchcod());
			  else
			    this.getDidgrp().getRec().setDbchcod(this.getDidgrp().getRec().getBchcod());
			  this.getDidgrp().getRec().setInr(Platform.sdbCounter("did"));
			  this.getDidgrp().getRec().setFlg("0");

			  ctx.getDaoSession().dbInsert(this.getDidgrp().getRec());
			  String objinr = this.getDidgrp().getRec().getInr();
			  this.getDidgrp().getBlk().setInr(objinr);
			  ctx.getDaoSession().dbInsert(this.getDidgrp().getBlk());
			  String objtyp = "did";
			  //申请人
			  this.getDidgrp().getApl().savpts(objinr,objtyp);
			  //受益人
			  this.getDidgrp().getBen().savpts(objinr,objtyp);
			  //通知行
			  this.getDidgrp().getAdv().savpts(objinr,objtyp);
			  //付款人
			  this.getDidgrp().getDre().savpts(objinr,objtyp);
			  //直接申请行
			  this.getDidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getDidgrp().getDap().getPts().setObjinr(objinr);
			  this.getDidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getDidgrp().getDap().getPts());
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getDidgrp().getDap().savTrp(objtyp,objinr);
			  }
			}

			dealPDFData();
			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:ditopn.@0035.script
        */
        @Rule(target="didgrp.rec.nomflg",order=100)
        public boolean ruleDidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getDidgrp().getRec().getNomflg()))
			{
			  //勾选
			  // Platform.setRequired($didgrp\\rec\\nomtop);
			  // Platform.setRequired($didgrp\\rec\\nomton);
			  
			  
			}
			else
			{
			  this.getDidgrp().getRec().setNomtop(new BigDecimal(0));
			  this.getDidgrp().getRec().setNomton(new BigDecimal(0));
			  
			  

			  //将“信用证的最大金额”调为原来的”信用证金额“
			  this.getDidgrp().setMaximum(this.getDidgrp().getRec().getIssamt());
			  
			}

			
			

			return true;
        }

        /**
        *   source:ditopn.@0036.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBankInfo();
			this.getDitp().getPdfviw().callPDFComponent("","ditopn","买方证申请",1);

			return true;
        }

        /**
        *   source:ditopn.@0040.script
        */
        @Rule(target="ditp.aplbut",order=100)
        public boolean ruleDitpAplbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().popupActchs();

			return true;
        }

        /**
        *   source:ditopn.@0041.script
        */
        @Rule(target="ditp.actcancel",order=100)
        public boolean ruleDitpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:ditopn.@0042.script
        */
        @Rule(target="ditp.actsurel",order=100)
        public boolean ruleDitpActsurelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getDitp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000039"),MdaUtils.getI18NString("ditopn","CT000040"));
			  return true;
			}
			else
			{
			  this.getDidgrp().getApl().getPts().setAct(this.getDitp().getActlst().getElement(index).getAct());
			  this.getDidgrp().getApl().getPts().setBak(this.getDitp().getActlst().getElement(index).getOpnbchnam());
			  
			  
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0044.script
        */
        @Rule(target="ditp.didgrp.rec.shppar",order=100)
        public boolean ruleDitpDidgrpRecShpparN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getDidgrp().getRec().getShppar()))
			{
			  
			  
			}
			else
			{
			  this.getDidgrp().getBlk().setPardet(NULLSTR);
			  
			  
			}
			

			return true;
        }

        /**
        *   source:ditopn.@0045.script
        */
        @Rule(target="ditp.aplp.sel",order=100)
        public boolean ruleDitpAplpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getAplp().getPtspta().getPts().setAct(NULLSTR);
			this.getDitp().getAplp().getPtspta().getPts().setBak(NULLSTR);

			
			

			return true;
        }

        /**
        *   source:ditopn.@0046.script
        */
        @Rule(target="ditp.benp.sel",order=100)
        public boolean ruleDitpBenpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getBenp().getPtspta().getPts().setAct(NULLSTR);
			this.getDitp().getBenp().getPtspta().getPts().setBak(NULLSTR);

			
			

			return true;
        }

        /**
        *   source:ditopn.@0047.script
        */
        @Rule(target="ditp.benp.ptspta.pts.extkey",order=100)
        public boolean ruleDitpBenpPtsptaPtsExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getBenp().getPtspta().getPts().setAct(NULLSTR);
			this.getDitp().getBenp().getPtspta().getPts().setBak(NULLSTR);

			
			

			return true;
        }

        /**
        *   source:ditopn.@0048.script
        */
        @Rule(target="ditp.aplp.ptspta.pts.extkey",order=100)
        public boolean ruleDitpAplpPtsptaPtsExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDitp().getAplp().getPtspta().getPts().setAct(NULLSTR);
			this.getDitp().getAplp().getPtspta().getPts().setBak(NULLSTR);

			
			

			return true;
        }

        /**
        *   source:ditopn.@0050.script
        */
        @Rule(target="mtabut.busmod.select",order=110)
        public boolean ruleMtabutBusmodSelectN110(){
            IContext ctx = MdaEnv.getContext();
            
			
			if("1".equals(this.getDidgrp().getRec().getConflg()))
			{
			  
			  
			  
			}
			else
			{
			  this.getDidgrp().getCon().getPts().setExtkey(NULLSTR);
			  this.getDidgrp().getCon().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			}
			
			
			
			if("1".equals(this.getDitp().getDidgrp().getRec().getNegflg()))
			{
			  
			  
			  
			}
			else
			{
			  this.getDidgrp().getNeg().getPts().setExtkey(NULLSTR);
			  this.getDidgrp().getNeg().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			}
			
			
			
			if("2".equals(this.getDidgrp().getRec().getTrfflg()))
			{
			  
			  
			  
			}
			else
			{
			  this.getDidgrp().getAdt().getPts().setExtkey(NULLSTR);
			  this.getDidgrp().getAdt().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			}
			
			
			

			ctx.postRule(this,"didgrp.rec.apprul");
			ctx.postRule(this,"didgrp.rec.avbby");
			ctx.postRule(this,"didgrp.rec.avbwths");
			ctx.postRule(this,"didgrp.rec.bchcod");
			ctx.postRule(this,"didgrp.rec.cnfflg");
			ctx.postRule(this,"didgrp.rec.concur");
			ctx.postRule(this,"didgrp.rec.nomflg");
			//Platform.postEventRule($didgrp\\rec\\sstdat,onChange,null);
			ctx.postRule(this,"didgrp.rec.shppar");
			ctx.postRule(this,"didgrp.rec.trdflg");
			ctx.postRule(this,"didgrp.rec.upsflg");
			ctx.postRule(this,"ditp.actcancel");
			ctx.postRule(this,"ditp.actsurel");
			ctx.postRule(this,"ditp.aplbut");

			return true;
        }

        /**
        *   source:ditopn.@0052.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "国内买方信用证开立申请";
			String tempfiles = "A:ditopn";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:ditopn.@0053.script
        */
        @Rule(target="ditp.benp.ptspta.pts.adrblk",order=100)
        public boolean ruleDitpBenpPtsptaPtsAdrblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDitp().getBenp().getPtspta().getPts().getExtkey()))
			{
			  String[] res = this.getDitp().getBenp().getPtspta().getPts().getAdrblk().split("\n",2);
			  this.getDidgrp().getBen().getPty().setNam(res[0]);
			  
			  if(res.length==2)
			  {
			    this.getDidgrp().getBen().getAdr().setAdr(res[1]);
			    
			  }
			}

			return true;
        }

        /**
        *   source:ditopn.@0065.script
        */
        @Rule(target="ditp.didgrp.capital",order=100)
        public boolean ruleDitpDidgrpCapitalN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getMaximum()))
			{
			  return true;
			}
			String amt=this.getSysmod().covCnAmt(this.getDidgrp().getMaximum(),this.getDidgrp().getRec().getIsscur());
			this.getDidgrp().setCapital(amt);
			

			return true;
        }

        /**
        *   source:ditopn.@0038.script
        */
        @Rule(target="ditp.didgrp.rec.negflg",order=100)
        public boolean ruleDitpDidgrpRecNegflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getDitp().getDidgrp().getRec().getNegflg()))
			{
			  //Platform.enable($didgrp\\neg\\pts\\extkey);
			  //Platform.enable($didgrp\\neg\\pts\\adrblk);
			  //Platform.enable($ditp\\negp\\sel);
			  
			  
			  
			  
			}
			else
			{
			  //Platform.clear($didgrp\\neg\\pts\\extkey);
			  // Platform.clear($didgrp\\neg\\pts\\adrblk);
			  // Platform.disable($didgrp\\neg\\pts\\extkey);
			  // Platform.disable($didgrp\\neg\\pts\\adrblk);
			  // Platform.disable($ditp\\negp\\sel);
			
			  this.getDitp().getNegp().getPtspta().getPts().setBakcode(NULLSTR);
			  this.getDitp().getNegp().getPtspta().getPts().setNam(NULLSTR);
			  this.getDitp().getNegp().getPtspta().getPts().setAdr(NULLSTR);

			  
			  
			  
			  
			}
			// Platform.setModified($didgrp\\neg\\pts\\extkey);
			// Platform.setModified($didgrp\\neg\\pts\\adrblk);
			//Platform.setModified($ditp\\negp\\sel);
			
			
			
			
			

			return true;
        }

        /**
        *   source:ditopn.@0039.script
        */
        @Rule(target="ditp.didgrp.rec.trfflg",order=100)
        public boolean ruleDitpDidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getDidgrp().getRec().getTrfflg()))
			{
			  //Platform.enable($didgrp\\adt\\pts\\extkey);
			  //Platform.enable($didgrp\\adt\\pts\\adrblk);
			  //Platform.enable($ditp\\adtp\\sel);
			  
			  
			  
			  
			}
			else
			{
			  // Platform.clear($didgrp\\adt\\pts\\extkey);
			  // Platform.clear($didgrp\\adt\\pts\\adrblk);
			  // Platform.disable($didgrp\\adt\\pts\\extkey);
			  // Platform.disable($didgrp\\adt\\pts\\adrblk);
			  // Platform.disable($ditp\\adtp\\sel);
			
			  this.getDitp().getAdtp().getPtspta().getPts().setBakcode(NULLSTR);
			  this.getDitp().getAdtp().getPtspta().getPts().setNam(NULLSTR);
			  this.getDitp().getAdtp().getPtspta().getPts().setAdr(NULLSTR);

			  
			  
			  
			  
			}
			// Platform.setModified($didgrp\\adt\\pts\\extkey);
			// Platform.setModified($didgrp\\adt\\pts\\adrblk);
			//Platform.setModified($ditp\\adtp\\sel);
			
			
			
			
			

			return true;
        }

        /**
        *   source:ditopn.@0037.script
        */
        @Rule(target="didgrp.rec.conflg",order=100)
        public boolean ruleDidgrpRecConflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getDidgrp().getRec().getConflg()))
			{
			  //Platform.enable($didgrp\\con\\pts\\extkey);
			  // Platform.enable($didgrp\\con\\pts\\adrblk);
			  // Platform.enable($ditp\\conp\\sel);
			
			  
			  
			  
			  
			}
			else
			{
			  // Platform.clear($didgrp\\con\\pts\\extkey);
			  // Platform.clear($didgrp\\con\\pts\\adrblk);
			  // Platform.disable($didgrp\\con\\pts\\extkey);
			  //  Platform.disable($didgrp\\con\\pts\\adrblk);
			  //Platform.disable($ditp\\conp\\sel);
			
			  this.getDitp().getConp().getPtspta().getPts().setBakcode(NULLSTR);
			  this.getDitp().getConp().getPtspta().getPts().setNam(NULLSTR);
			  this.getDitp().getConp().getPtspta().getPts().setAdr(NULLSTR);

			  
			  
			  
			  
			}
			// Platform.setModified($didgrp\\con\\pts\\extkey);
			// Platform.setModified($didgrp\\con\\pts\\adrblk);
			// Platform.setModified($ditp\\conp\\sel);
			
			
			
			
			

			return true;
        }

        /**
        *   source:ditopn.@0073.script
        */
        @Rule(target="ditp.didgrp.rec.nomton",order=100)
        public boolean ruleDitpDidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"nomton"));

			return true;
        }

        /**
        *   source:ditopn.@0076.script
        */
        @Rule(target="didgrp.blk.preper",order=100)
        public boolean ruleDidgrpBlkPreperN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDidgrp().getRec().setJdqx(NULLSTR);
			String s=this.getDidgrp().getBlk().getPreper();
			if(!MdaUtils.isEmpty(this.getDidgrp().getBlk().getPreper()))
			{
			  this.getDidgrp().getRec().setJdqx("单据必须自货物装运日/服务提供日后"+s+"天内提交，但不得迟于信用证有效期");
			  
			}
			else
			{
			  this.getDidgrp().getRec().setJdqx("单据必须自货物装运日/服务提供日后   天内提交，但不得迟于信用证有效期");
			  
			}

			return true;
        }


        /**
        *   source:ditopn.@0006.script
        */
        @Check(target="didgrp.rec.expdat",order=100)
        public boolean checkDidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getDidgrp().getRec().getExpdat()))
			  return true;
			if(MdaUtils.diff(this.getDidgrp().getRec().getExpdat(),this.getDidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"didgrp.rec.expdat",MdaUtils.getI18NString("ditopn","CT000001"));

			return true;
        }

        /**
        *   source:ditopn.@0007.script
        */
        @Check(target="didgrp.rec.issamt",order=100)
        public boolean checkDidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(Platform.isEmpty($didgrp\\rec\\issamt)   ||   Platform.isEmpty($didgrp\\rec\\conamt))
			  {
			  Platform.message(#CT000002,#CT000065);
			  return;
			  }
			
			  BigDecimal camt = $didgrp\\rec\\conamt.getValue();
			  BigDecimal lamt = $didgrp\\rec\\issamt.getValue();
			  if(lamt.compareTo(camt)>0)
			  Platform.error($didgrp\\rec\\issamt,#CT000066);
			  */

			return true;
        }

        /**
        *   source:ditopn.@0008.script
        */
        @Check(target="didgrp.rec.shpdat",order=100)
        public boolean checkDidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getShpdat()))
			  return true;
			Date shpdat = this.getDidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getDidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getDidgrp().getRec().getExpdat())>0)
			  ctx.setFieldError(this,"didgrp.rec.shpdat",MdaUtils.getI18NString("ditopn","CT000003"));

			return true;
        }

        /**
        *   source:ditopn.@0009.script
        */
        @Check(target="didgrp.rec.nomton",order=100)
        public boolean checkDidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!TRUE.equals($didgrp\\rec\\nomflg.getValue()))
			  {
			  Platform.message(#CT000004,#CT000063);
			  return;
			  }
			
			  BigDecimal nomton = $didgrp\\rec\\nomton.getValue();
			  */
			//if(nomton.compareTo(new BigDecimal(50))>0  ||  nomton.compareTo(new BigDecimal(0))<0)
			//无小数位的Numberic类型为Integer
			// if(nomton>50  ||  nomton<0)
			//  Platform.error($didgrp\\rec\\nomton,#CT000064);
			
			return true;
        }

        /**
        *   source:ditopn.@0010.script
        */
        @Check(target="didgrp.agree",order=100)
        public boolean checkDidgrpAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(TRUE.equals(this.getDidgrp().getAgree())))
			{
			  ctx.setFieldError(this,"didgrp.agree",MdaUtils.getI18NString("ditopn","CT000005"));
			  return true;
			}

			return true;
        }

        /**
        *   source:ditopn.@0015.script
        */
        @Check(target="ditp.didgrp.rec.issinf",order=100)
        public boolean checkDitpDidgrpRecIssinfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getDidgrp().getRec().getIssinf()))
			{
			  ctx.setFieldError(this,"didgrp.rec.issinf",MdaUtils.getI18NString("ditopn","CT000018"));
			}

			return true;
        }

        /**
        *   source:ditopn.@0051.script
        */
        @Check(target="ditp.didgrp.rec.nomtop",order=100)
        public boolean checkDitpDidgrpRecNomtopN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!TRUE.equals($didgrp\\rec\\nomflg.getValue()))
			  return;
			
			  BigDecimal nomtop = $didgrp\\rec\\nomtop.getValue();
			  */
			//if(nomtop>50  ||  nomtop<0) nomtop为int类型时
			// Platform.error($didgrp\\rec\\nomtop,#CT000049);
			
			return true;
        }

        /**
        *   source:ditopn.@0064.script
        */
        @Check(target="ditp.didgrp.rec.prompt",order=100)
        public boolean checkDitpDidgrpRecPromptN100(){
            IContext ctx = MdaEnv.getContext();
            
			//校验当付款方式为远期付款时，付款期限的值是否正确
			int day=this.getDidgrp().getRec().getPrompt();
			String payMethod=this.getDidgrp().getRec().getAvbby();

			if("2".equals(payMethod) && (day>366 || day<=0))
			{
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000069"),MdaUtils.getI18NString("ditopn","CT000070"));
			}

			return true;
        }

        /**
        *   source:ditopn.@0068.script
        */
        @Check(target="ditp.didgrp.rec.nomtop",order=50)
        public boolean checkDitpDidgrpRecNomtopN50(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal number=this.getDitp().getDidgrp().getRec().getNomtop();
			String str=number.toString();
			if(str.contains("-"))
			{
			  this.getDitp().getDidgrp().getRec().setNomtop(new BigDecimal(0));
			  
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000073"),MdaUtils.getI18NString("ditopn","CT000074"));
			  return true;
			}

			//判断number是不是0
			if(number.compareTo(BigDecimal.ZERO)==0)
			{
			  return true;
			}
			String intnum=str;
			String pointnum="";

			if(str!=null && str.contains("."))
			{
			  //截取小数点前面的整数
			  intnum=str.substring(0,str.indexOf("."));
			  //获取小数点后的数字
			  pointnum=str.substring(intnum.length()+1,str.length());
			}

			if(intnum.length()>3 || pointnum.length()>5)
			{
			  this.getDitp().getDidgrp().getRec().setNomtop(new BigDecimal(0));
			  
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000083"),MdaUtils.getI18NString("ditopn","CT000084"));

			}

			return true;
        }

        /**
        *   source:ditopn.@0069.script
        */
        @Check(target="ditp.didgrp.rec.nomton",order=50)
        public boolean checkDitpDidgrpRecNomtonN50(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal number=this.getDitp().getDidgrp().getRec().getNomton();
			String str=number.toString();
			if(str.contains("-"))
			{
			  this.getDitp().getDidgrp().getRec().setNomton(new BigDecimal(0));
			  
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000075"),MdaUtils.getI18NString("ditopn","CT000076"));
			  return true;
			}
			//判断number是不是0
			if(number.compareTo(BigDecimal.ZERO)==0)
			{
			  return true;
			}

			String intnum=str;
			String pointnum="";

			if(str!=null && str.contains("."))
			{
			  //截取小数点前面的整数
			  intnum=str.substring(0,str.indexOf("."));
			  //获取小数点后的数字
			  pointnum=str.substring(intnum.length()+1,str.length());
			}

			if(intnum.length()>3 || pointnum.length()>5)
			{
			  this.getDitp().getDidgrp().getRec().setNomton(new BigDecimal(0));
			  
			  ctx.setMessage(MdaUtils.getI18NString("ditopn","CT000081"),MdaUtils.getI18NString("ditopn","CT000082"));

			}

			return true;
        }

        /**
        *   source:ditopn.@0071.script
        */
        @Check(target="ditp.didgrp.rec.issamt",order=100)
        public boolean checkDitpDidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"issamt"));

			return true;
        }

        /**
        *   source:ditopn.@0072.script
        */
        @Check(target="ditp.didgrp.rec.nomtop",order=110)
        public boolean checkDitpDidgrpRecNomtopN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"nomtop"));

			return true;
        }

        /**
        *   source:ditopn.@0074.script
        */
        @Check(target="ditp.didgrp.blk.preper",order=110)
        public boolean checkDitpDidgrpBlkPreperN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getDitp().getDidgrp().getBlk(),"preper"));

			return true;
        }

        /**
        *   source:ditopn.@0075.script
        */
        @Check(target="ditp.didgrp.rec.prompt",order=110)
        public boolean checkDitpDidgrpRecPromptN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getDitp().getDidgrp().getRec(),"prompt"));

			return true;
        }


        /**
        *   source:ditopn.@0011.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getDidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getDidgrp().getRec().setBchcod(bchcod.get(0).getValue());

			
			
			
			
			
			
			
			
			
			
			
			
			//  Platform.disable($didgrp\\blk\\word);
			
			
			
			
			// Platform.disable($didgrp\\neg\\pts\\adrblk);
			//补充：
			
			
			
			
			
			
			
			
			
			
			
			

			//----
			
			//Platform.disable($didgrp\\con\\pts\\adrblk);
			
			// Platform.disable($didgrp\\adt\\pts\\adrblk);
			
			
			
			//Platform.setRequired($didgrp\\apl\\pts\\adrblk);
			//Platform.setRequired($didgrp\\ben\\pts\\adrblk);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  
			  if("1".equals(this.getDidgrp().getRec().getConflg()))
			  {
			    
			    
			    
			  }
			  else
			  {
			    this.getDidgrp().getCon().getPts().setExtkey(NULLSTR);
			    this.getDidgrp().getCon().getPts().setAdrblk(NULLSTR);
			    
			    
			    
			  }
			  
			  
			  
			  if("1".equals(this.getDitp().getDidgrp().getRec().getNegflg()))
			  {
			    
			    
			    
			  }
			  else
			  {
			    this.getDidgrp().getNeg().getPts().setExtkey(NULLSTR);
			    this.getDidgrp().getNeg().getPts().setAdrblk(NULLSTR);
			    
			    
			    
			  }
			  
			  
			  
			  if("2".equals(this.getDidgrp().getRec().getTrfflg()))
			  {
			    
			    
			    
			  }
			  else
			  {
			    this.getDidgrp().getAdt().getPts().setExtkey(NULLSTR);
			    this.getDidgrp().getAdt().getPts().setAdrblk(NULLSTR);
			    
			    
			    
			  }
			  
			  
			  

			  ctx.postRule(this,"didgrp.rec.apprul");
			  ctx.postRule(this,"didgrp.rec.avbby");
			  ctx.postRule(this,"didgrp.rec.avbwths");
			  ctx.postRule(this,"didgrp.rec.bchcod");
			  ctx.postRule(this,"didgrp.rec.cnfflg");
			  ctx.postRule(this,"didgrp.rec.concur");
			  ctx.postRule(this,"didgrp.rec.nomflg");
			  //Platform.postEventRule($didgrp\\rec\\sstdat,onChange,null);
			  ctx.postRule(this,"didgrp.rec.shppar");
			  ctx.postRule(this,"didgrp.rec.trdflg");
			  ctx.postRule(this,"didgrp.rec.upsflg");
			  ctx.postRule(this,"ditp.actcancel");
			  ctx.postRule(this,"ditp.actsurel");
			  ctx.postRule(this,"ditp.aplbut");
			  ctx.postRule(this,"didgrp.rec.negflg");
			  ctx.postRule(this,"didgrp.rec.trfflg");
			  ctx.postRule(this,"didgrp.rec.conflg");
			  return true;
			}
			//Platform.clear($didgrp\\rec);
			//Platform.clear($didgrp\\blk);
			this.getDidgrp().getRec().setOwnref(NULLSTR);
			this.getDidgrp().getRec().setNomtop(new BigDecimal(0));
			this.getDidgrp().getRec().setNomton(new BigDecimal(0));
			this.getDidgrp().getRec().setAvbwth(NULLSTR);
			this.getDidgrp().getBlk().setDefdet(NULLSTR);
			this.getDidgrp().getBlk().setMixdet(NULLSTR);
			this.getDidgrp().getRec().setIsscur(NULLSTR);
			this.getDidgrp().getRec().setTrdtrmver(NULLSTR);
			this.getDidgrp().getRec().setSstdattxt(NULLSTR);
			this.getDidgrp().getRec().setApprultxt(NULLSTR);
			this.getDidgrp().getBlk().setWord(NULLSTR);
			this.getDidgrp().getApl().getPts().setAct(NULLSTR);
			this.getDidgrp().getApl().getPts().setBak(NULLSTR);
			this.getDidgrp().getBen().getPts().setAct(NULLSTR);
			this.getDidgrp().getBen().getPts().setBak(NULLSTR);
			this.getDidgrp().getRec().setIssinf(NULLSTR);
			this.getDidgrp().getRec().setIssamt(new BigDecimal(0));
			this.getDidgrp().getRec().setExpdat(null);
			this.getDidgrp().getRec().setExpplc(NULLSTR);
			this.getDidgrp().getRec().setNegflg(NULLSTR);
			this.getDidgrp().getRec().setTrfflg(NULLSTR);
			this.getDidgrp().getRec().setConflg(NULLSTR);
			this.getDitp().setAplnam(NULLSTR);
			this.getDidgrp().getBen().getPts().setExtkey(NULLSTR);
			this.getDidgrp().getBen().getPts().setAdrblk(NULLSTR);
			this.getDidgrp().getAdv().getPts().setExtkey(NULLSTR);
			this.getDidgrp().getAdv().getPts().setAdrblk(NULLSTR);
			this.getDidgrp().getNeg().getPts().setExtkey(NULLSTR);
			this.getDidgrp().getNeg().getPts().setAdrblk(NULLSTR);
			this.getDidgrp().getCon().getPts().setExtkey(NULLSTR);
			this.getDidgrp().getCon().getPts().setAdrblk(NULLSTR);
			this.getDidgrp().getAdt().getPts().setExtkey(NULLSTR);
			this.getDidgrp().getAdt().getPts().setAdrblk(NULLSTR);
			this.getDidgrp().getRec().setJdqx(NULLSTR);
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  return true;
			}
			this.getDidgrp().getDap().initDap("did");

			//委托开立初始化
			if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  this.getDidgrp().getRec().setCretyp("W");
			  this.getDitp().setIssbaninf(ctx.absGet(Sysmod.class).getPty().getExtkey());
			}
			else
			{
			  //当为空时查询不到，此处下方注释与查询条件不匹配
			  //不能为NULL,否则修改查询查不到
			  //$didgrp\\rec\\cretyp.setValue("");
			  this.getDidgrp().getApl().copyValues(this.getDidgrp().getDap());
			}

			log.debug("{}","message"+this.getDidgrp().getApl().getPts().getNam());
			this.getDidgrp().getApl().getPts().setRol("apl");
			this.getDidgrp().getRec().setConcur("CNY");
			this.getDidgrp().getRec().setIsscur("CNY");
			this.getDidgrp().getRec().setCredat(MdaUtils.today());
			//Platform.setRequired($didgrp\\apl\\pts\\extkey);
			//Platform.setDescription($didgrp\\apl\\pts\\extkey, #CT000015);
			//Platform.setRequired($didgrp\\apl\\pts\\adrblk);
			//Platform.setRequired($didgrp\\ben\\pts\\adrblk);
			//Platform.setDescription($didgrp\\apl\\pts\\adrblk,#CT000016);
			//Platform.setRequired($didgrp\\ben\\pts\\extkey);
			//Platform.setRequired($didgrp\\ben\\pts\\adrblk);
			//Platform.setDescription($didgrp\\ben\\pts\\adrblk,#CT000017);
			this.getDidgrp().getRec().setNomflg(FALSE);
			this.getDidgrp().getRec().setShppar("2");
			this.getDidgrp().getRec().setShptrs("2");
			this.getDidgrp().getRec().setAvbby("1");
			
			MdaUtils.setValues(this.getDidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg3"));
			this.getDidgrp().getBlk().setDefdet("（）货物装运日/服务交付日后____天。\r\n（）见单后____天。\r\n（）货物收据签发日/服务提供日后____天。\r\n（）其他____");
			
			this.getDidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			this.getDidgrp().getBlk().setLcrdoc("1.（ ）税务部门统一监制的正本[]增值税普通发票（发票联）/[]增值税专用发票（包括发票联和抵扣联）/[]行业发票/[]专用发票。发票备注栏显示信用证号和合同号；2. （ ）全套运输单据：[]提单/[]铁路运单/[]公路运单/[]航空运单，正本__份，副本__份，收货人为____，注明运费[]已付/[]未付；\r\n3.（ ）[]邮政收据/[]快递收据，收货人为____，注明运费[]已付/[]未付；\r\n4.（ ）开证申请人出具的正本货物收据，收货人为开证申请人； \r\n5.（ ）正本出库单，收货人为开证申请人，签发人为____；\r\n6.（ ）全套保险单，正本__份，副本__份，投保金额为____，投保险种为____；\r\n7.（ ）正本装箱单一式____份，注明每一包装内货物数量及毛、净重；\r\n8.（ ）其他单据：");
			this.getDidgrp().getBlk().setAdlcnd("1.（ ）发票出具日期早于信用证开立日期[]可接受/[]不可接受。\r\n2.（ ）货物数量及信用证金额均可有上下___%的浮动范围。\r\n3.（ ）开证行以外的所有银行费用由受益人承担。 ");
			this.getDidgrp().getRec().setSedday("21");
			this.getDidgrp().getRec().setSstdat("1");
			this.getDidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getDidgrp().getRec().setPreper("单据必须在装运日期后21天，但在信用证有效期内。");
			this.getDidgrp().getRec().setJdqx("单据必须自货物装运日/服务提供日后   天内提交，但不得迟于信用证有效期");
			
			//Platform.enable($didgrp\\rec\\preper);
			
			this.getDidgrp().getRec().setApprul("1");
			this.getDidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			this.getDidgrp().setAgree(TRUE);
			this.getDitp().setAplnam(this.getSysmod().getPty().getNam());
			//Platform.disable($rmkmod\\otext);
			if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getDitp().getOpncls().getCls(),new Argument<String>("inr",this.getDitp().getOpncls().readDefaultClsInr("ditopn")));
			  this.getDidgrp().getBlk().setRgtcls(this.getDitp().getOpncls().getCls().getClstxt());
			  if(MdaUtils.isEmpty(this.getDidgrp().getBlk().getRgtcls()))
			  {
			    this.getDidgrp().getBlk().setRgtcls("             开立国内信用证申请人承诺书（背面）\r\n 中国光大银行股份有限公司            分行：\r\n 我单位与____________________签订购销合同，现请贵行按我单位开证申请书内容开出不可撤销跟单信用证，为此我单位愿承诺如下：\r\n （）本项申请是根据本单位与贵行签订的编号为_____________的《国内信用证融资主协议》而提出。本申请书项下的信用证业务在各方面均须遵守《国内信用证融资主协议》的条款和条件以及本开证申请人承诺书中的条款和条件，并且：\r\n （）占用贵行授予本单位的国内信用证开证额度_________；\r\n （）已于本单位在贵行处开立的账号为_______________________的保证金专户中存入开证金额的  %的保证金，即开证保证金金额为(小写)___________人民币(大写)________________；\r\n （）其他担保：____________。\r\n     一、我单位愿遵守中国人民银行《国内信用证结算办法》及国家有关法规，同意贵行依据《国内信用证结算办法》及国家有关法规办理该信用证项下一切事宜，并同意承担由此产生的一切责任。\r\n     二、我单位保证按时向贵行支付信用证项下的货款、手续费、利息及一切费用等。\r\n     三、我单位保证在贵行认为单证表面相符的条件下，贵行有权主动办理确认到期付款/对外付款，并从我单位在贵行开立的任何账户中扣款。\r\n     四、贵行对由于任何电报、信函或单据邮寄过程中发生延误、遗失所造成的后果，或者电讯传递过程中发生的差错，不承担责任。\r\n     五、我单位在收到贵行开出的信用证、修改书副本通知后，保证及时与原申请书核对，如有不符之处，保证在接到通知之日起两个工作日内通知贵行。如未通知，视为正确无误。\r\n     六、如因申请书字迹不清或词意含混而引起的一切后果由我单位负责。\r\n     七、该信用证如需修改，由我单位向贵行提出书面申请和信用证修改申请人承诺书，并提交受益人同意修改的书面证明，由贵行根据具体情况确定能否办理修改。\r\n     八、我单位在贵行存入的该信用证项下的保证金按信用证及信用证结算的有关规定，贵行需向信用证受益人付款时，贵行有权将我单位开证保证金优先用于支付信用证项下款项。\r\n     本申请书与国内信用证融资主协议的内容构成本单位办理本申请书项下国内信用证业务不可分割的组成部分。");
			  }
			}
			this.getDidgrp().setAploth(FALSE);
			this.getDidgrp().setAplothtxt(" （）买方国内信用证到单\r\n （）买方国内信用证付款\r\n （）买方国内信用证承兑\r\n （）买方国内信用证拒付\r\n");
			
			
			
			
			
			
			
			this.getDidgrp().getRec().setIssinf(NULLSTR);

			return true;
        }


        /**
        *   source:ditopn.@0000.script
        */
        public void lcrgods()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String returnvalue="";
			Object lcrgod = this.getDidgrp().getBlk().getLcrgod();
			Object trdtrm = this.getDidgrp().getRec().getTrdtrm();
			Object trdtrmplc = this.getDidgrp().getRec().getTrdtrmplc();
			Object trdtrmver = this.getDidgrp().getRec().getTrdtrmver();
			if(!MdaUtils.isEmpty(lcrgod))
			  returnvalue=lcrgod.toString()+CR;
			if(!MdaUtils.isEmpty(trdtrm))
			  returnvalue+="+Trade Terms: "+trdtrm.toString();
			if(!MdaUtils.isEmpty(trdtrmplc))
			  returnvalue+=" "+trdtrmplc.toString();
			if(!MdaUtils.isEmpty(trdtrmver))
			  returnvalue+=" "+trdtrmver.toString();
			this.getDidgrp().setSwfa(returnvalue.trim());
		}
        /**
        *   source:ditopn.@0001.script
        */
        public void adlcnds()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtvalue="";
			Object adlcnd = this.getDidgrp().getBlk().getAdlcnd();
			Object nomton = this.getDidgrp().getRec().getNomton();
			Object nomflg = this.getDidgrp().getRec().getNomflg();
			Object nomtop = this.getDidgrp().getRec().getNomtop();
			// log.debug("nomflg=="+nomflg.toString());
			// log.debug("nomflg=="+nomflg);
			if(!MdaUtils.isEmpty(nomflg)&&TRUE.equals(nomflg.toString()))
			{
			  rtvalue= "+Quantity And Amount ";
			  if(!MdaUtils.isEmpty(nomtop))
			    rtvalue+=nomtop.toString()+" PERCENT More ";
			  if(!MdaUtils.isEmpty(nomton))
			  {
			    if(!MdaUtils.isEmpty(nomtop))
			      rtvalue+= " Or ";
			    rtvalue+=nomton.toString()+" PERCENT Less";
			  }
			  rtvalue+=" Are Allowed";
			}
			if(!MdaUtils.isEmpty(adlcnd))
			  if(rtvalue==null   ||   "".equals(rtvalue) )
			rtvalue=adlcnd.toString();
			else
			rtvalue+= CR+adlcnd.toString();
			else
			rtvalue=rtvalue;
			this.getDidgrp().setSwfd(rtvalue) ;
		}
        /**
        *   source:ditopn.@0034.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getDidgrp().setApltitle("开证申请人申明");
			log.debug("{}","aploth="+this.getDidgrp().getAploth());

			if(TRUE.equals(this.getDidgrp().getAploth()))
			{
			  this.getDidgrp().setAplothpdftxt("\r\n"+this.getDidgrp().getAplothtxt());
			  this.getDidgrp().setAplothtxttip("\r\n           同时提交国内证下其它申请");
			}
			else
			{
			  this.getDidgrp().setAplothpdftxt(NULLSTR);
			  this.getDidgrp().setAplothtxttip(NULLSTR);
			}
			log.debug("{}","aplothpdftxt"+this.getDidgrp().getAplothpdftxt());
		}
        /**
        *   source:ditopn.@0070.script
        */
        public void getBankInfo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//补充
			this.getDitp().getNegp().cutField(MdaDriver.getDatafield(this.getDitp().getNegp().getPtspta().getPts(),"adrblk"),this.getDitp().getNegp().getPtspta().getPts().getNam(),this.getDitp().getNegp().getPtspta().getPts().getBakcode(),this.getDitp().getNegp().getPtspta().getPts().getAdr());
			this.getDitp().getAdvp().cutField(MdaDriver.getDatafield(this.getDitp().getAdvp().getPtspta().getPts(),"adrblk"),this.getDitp().getAdvp().getPtspta().getPts().getNam(),this.getDitp().getAdvp().getPtspta().getPts().getBakcode(),this.getDitp().getAdvp().getPtspta().getPts().getAdr());
			this.getDitp().getAdtp().cutField(MdaDriver.getDatafield(this.getDitp().getAdtp().getPtspta().getPts(),"adrblk"),this.getDitp().getAdtp().getPtspta().getPts().getNam(),this.getDitp().getAdtp().getPtspta().getPts().getBakcode(),this.getDitp().getAdtp().getPtspta().getPts().getAdr());
			this.getDitp().getConp().cutField(MdaDriver.getDatafield(this.getDitp().getConp().getPtspta().getPts(),"adrblk"),this.getDitp().getConp().getPtspta().getPts().getNam(),this.getDitp().getConp().getPtspta().getPts().getBakcode(),this.getDitp().getConp().getPtspta().getPts().getAdr());		}









}