package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.EabopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Eabp;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Eabgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 账户绑定
*/
@Transaction(vo= EabopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Eabopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Eabopn.class);

		@BDGetter
		private Eabgrp eabgrp;

		@BDGetter
		private Eabp eabp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Swmmod swmmod;


		public Eabopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getEabp().setEabgrpHolder(()->this.getEabgrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:eabopn.@0000.script
        */
        @Rule(target="eabp.save",order=100)
        public boolean ruleEabpSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getEabgrp().getRec().getOwnbch()))
			{
			  ctx.setFieldError(this,"eabgrp.rec.ownbch",MdaUtils.getI18NString("eabopn","CT000013"));
			  return false;
			}
			if(!MdaUtils.isEmpty(this.getEabgrp().getRec().getReason()))
			{
			  this.getEabgrp().getRec().setReason(NULLSTR);
			  
			}
			if(!ctx.checkAll(this.getEabgrp()))
			{
			  return false;
			}

			if(MdaUtils.prompt(MdaUtils.getI18NString("eabopn","CT000014"),MdaUtils.getI18NString("eabopn","CT000015")))
			{
			  return false;
			}
			String cifno = this.getEabgrp().getRec().getIdno();
			if(!ctx.absGet(Sysmod.class).judgeSWFunctions("user_binding",cifno,""))
			{
			  ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000016"),MdaUtils.getI18NString("eabopn","CT000017"));
			  return false;
			}
			//新增信息
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbReadset(this.getEabgrp().getPtylst(),new Argument<String>("cifno",this.getEabgrp().getRec().getIdno()),new Argument<Date>("epcdat",ISNULL));
			if(this.getEabgrp().getPtylst().size()<=0){
			  // $eabgrp\\rec\\handletyp.setValue("A");
			//$eabgrp\\rec\\result.setValue("02");
			//$eabgrp\\rec\\reason.setValue("未开通阳光E结算，请联系我行核实是否签约阳光E结算!");
			ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000018"),MdaUtils.getI18NString("eabopn","CT000029"));
			ctx.getDaoSession().dbRollback();
			return false;
			}
			else
			{
			this.getEabgrp().getRec().setCredat(MdaUtils.today());
			this.getEabgrp().getRec().setHandletyp("A");
			this.getEabgrp().getRec().setResult("01");
			if(MdaUtils.isEmpty(this.getEabgrp().getRec().getInr()))
			{
			  this.getEabgrp().getRec().setInr(Platform.sdbCounter("eab"));
			  ctx.getDaoSession().dbInsert(this.getEabgrp().getRec());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getEabgrp().getRec());
			}
			//更新swinfo,不应出现没有swinfo的情况。
			ctx.getDaoSession().dbRead(this.getEabgrp().getSwinfo(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));
			ctx.getDaoSession().dbRead(this.getEabgrp().getPty(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));

			this.getEabgrp().getSwinfo().setCid(this.getEabgrp().getPty().getCid());
			this.getEabgrp().getSwinfo().setBdsta("1");
			this.getEabgrp().getSwinfo().setBddate(MdaUtils.today());
			this.getEabgrp().getSwinfo().setEsta("1");
			this.getEabgrp().getSwinfo().setEdate(this.getEabgrp().getPty().getEpodat());
			this.getEabgrp().getSwinfo().setCidptyinr(this.getEabgrp().getPty().getInr());
			ctx.getDaoSession().dbUpdate(this.getEabgrp().getSwinfo());
			}
			if(!MdaUtils.isEmpty(this.getEabgrp().getRec().getOwnbch()))
			{
			String bchcod =this.getEabgrp().getRec().getOwnbch();
			MdaUtils.clear(ctx.absGet(Sysmod.class).getBch());
			ctx.getDaoSession().dbRead(ctx.absGet(Sysmod.class).getBch(),new Argument<String>("cid",bchcod),new Argument<String>("ptytyp","0"));
			}
			String optptyinr = this.getTrnmod().getBnktrn().getOptptyinr();
			if(!MdaUtils.isEmpty(this.getSysmod().getBch().getInr()))
			optptyinr = this.getSysmod().getBch().getInr();
			//更新默认归属机构
			/*Platform.clear($swmmod\\ptr);
			Platform.dbRead($swmmod\\ptr,new Argument<String>("ptrtyp","0"),new Argument<String>("preptyinr",$eabgrp\\pty\\inr.getValue()),new Argument<String>("nxtptyinr",optptyinr));
			$swmmod\\ptr\\issinglew.setValue("1");
			Platform.dbUpdate($swmmod\\ptr);
			*/
			MdaUtils.clear(this.getSwmmod().getPtrlst());
			ctx.getDaoSession().dbReadset(this.getSwmmod().getPtrlst(),new Argument<String>("preptyinr",this.getEabgrp().getPty().getInr()));
			for(int i = 0; i < this.getSwmmod().getPtrlst().size(); i++)
			{
			if(optptyinr.equals(this.getSwmmod().getPtrlst().getElement(i).getNxtptyinr()))
			  this.getSwmmod().getPtrlst().getElement(i).setIssinglew("1");
			else
			  this.getSwmmod().getPtrlst().getElement(i).setIssinglew("2");
			ctx.getDaoSession().dbUpdate(this.getSwmmod().getPtrlst().getElement(i));
			}
			String objinr1 = this.getEabgrp().getRec().getInr();
			String objtyp1 = "eab";

			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String userName = this.getSysmod().getLoginUserName();
			String txt=time+",银行柜员:"+userName+"经办,";
			this.getTrnmod().goHistory(objinr1,objtyp1,ctx.getTransName(),this.getEabp().getMainp(),txt);
			Map map = new HashMap();
			map.put("CusId",this.getEabgrp().getRec().getCusid());
			map.put("Result",this.getEabgrp().getRec().getResult());
			map.put("Reason",this.getEabgrp().getRec().getReason());
			ctx.absGet(Sysmod.class).setSwHeaderMap("SFS102","",map,this.getEabgrp().getRec().getMsgref());
			this.getSwmmod().storeSWM("SFS102",this.getEabgrp().getRec().getInr(),"eab",map);
			/*Map res = $sysmod.retSW("SFS102",map,null);
			String code = (String)res.get("code");
			if(Platform.isEmpty(code))
			{
			log.error("接口调用失败！");
			Platform.message(#CT000030,#CT000035);
			Platform.dbRollback();
			return false;
			}
			else
			{
			if(!"000000".equals(code))
			{
			String des = (String) res.get("des");
			log.error("接口调用失败:"+des);
			Platform.message(#CT000036,des);
			Platform.dbRollback();
			return false;
			}
			}
			*/
			ctx.getDaoSession().dbCommit();
			int errCode = ctx.getErrorCode();
			if(errCode!= NO_ERROR)
			{
			ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000037"),MdaUtils.getI18NString("eabopn","CT000125"));
			return false;
			}
			ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000126"),MdaUtils.getI18NString("eabopn","CT000130"));
			


			return true;
        }

        /**
        *   source:eabopn.@0001.script
        */
        @Rule(target="eabp.exit",order=100)
        public boolean ruleEabpExitN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:eabopn.@0003.script
        */
        @Rule(target="eabgrp.rec.result",order=100)
        public boolean ruleEabgrpRecResultN100(){
            IContext ctx = MdaEnv.getContext();
            
			String result = this.getEabgrp().getRec().getResult();
			if("01".equals(result))
			{
			  this.getEabgrp().getRec().setReason(NULLSTR);
			  
			  
			  
			}
			else
			{
			  
			  
			  
			}


			return true;
        }

        /**
        *   source:eabopn.@0004.script
        */
        @Rule(target="eabp.backsw",order=100)
        public boolean ruleEabpBackswN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(Platform.isEmpty($eabgrp\\rec\\ownbch.getValue()))
			  {
			  Platform.error($eabgrp\\rec\\ownbch,#CT000111);
			  return false;
			  }*/

			if(MdaUtils.prompt(MdaUtils.getI18NString("eabopn","CT000112"),MdaUtils.getI18NString("eabopn","CT000113")))
			{
			  return false;
			}
			if(MdaUtils.isEmpty(this.getEabgrp().getRec().getReason()))
			{
			  ctx.setFieldError(this,"eabgrp.rec.reason",MdaUtils.getI18NString("eabopn","CT000114"));
			  return false;
			}
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			this.getEabgrp().getRec().setResult("02");
			if(MdaUtils.isEmpty(this.getEabgrp().getRec().getInr()))
			{
			  this.getEabgrp().getRec().setInr(Platform.sdbCounter("eab"));
			  ctx.getDaoSession().dbInsert(this.getEabgrp().getRec());
			}
			ctx.getDaoSession().dbUpdate(this.getEabgrp().getRec());
			if(!MdaUtils.isEmpty(this.getEabgrp().getRec().getOwnbch()))
			{
			  String bchcod =this.getEabgrp().getRec().getOwnbch();
			  MdaUtils.clear(ctx.absGet(Sysmod.class).getBch());
			  ctx.getDaoSession().dbRead(ctx.absGet(Sysmod.class).getBch(),new Argument<String>("cid",bchcod),new Argument<String>("ptytyp","0"));
			}

			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String userName = this.getSysmod().getLoginUserName();
			String txt=time+",银行柜员:"+userName+"退回,退回原因："+this.getEabgrp().getRec().getReason();
			this.getTrnmod().goHistory(this.getEabgrp().getRec().getInr(),"eab",ctx.getTransName(),this.getEabp().getMainp(),txt);
			//根据处理结果返回单一窗口
			Map map = new HashMap();
			map.put("code","SFS102");
			this.getSysmod().setSwHeaderMap("SFS102","",map,this.getEabgrp().getRec().getMsgref());
			map.put("CusId",this.getEabgrp().getRec().getCusid());
			map.put("Result",this.getEabgrp().getRec().getResult());
			map.put("Reason",this.getEabgrp().getRec().getReason());
			/*Map rst = $sysmod.retSW("SFS102",map,null);
			  //判断处理结果，给出提示
			  String code = (String) rst.get("code");
			  if(Platform.isEmpty(code))
			  {
			  Platform.message(#CT000115,#CT000116);
			  Platform.dbRollback();
			  return false;
			  }
			  else
			  {
			  if(!"000000".equals(code))
			  {
			  String des = (String) rst.get("des");
			  Platform.message(#CT000117,des);
			  Platform.dbRollback();
			  return false;
			  }
			  }*/
			this.getSwmmod().storeSWM("SFS102",this.getEabgrp().getRec().getInr(),"eab",map);
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000118"),MdaUtils.getI18NString("eabopn","CT000119"));
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("eabopn","CT000120"),MdaUtils.getI18NString("eabopn","CT000128"));
			}
			

			return true;
        }



        /**
        *   source:eabopn.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			IModule eab = (IModule)ctx.restoreData("com.brilliance.eabopn.ref");
			if(!MdaUtils.isEmpty(eab))
			  this.getEabgrp().getRec().copyValue(eab);

			// List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			// Platform.setValues($eabgrp\\rec\\ownbch,bchcod);
			
			this.getEabgrp().getRec().setCredat(MdaUtils.today());
			

			log.info("{}","idno========================"+this.getEabgrp().getRec().getIdno());
			ctx.getDaoSession().dbRead(this.getEabgrp().getPty(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));
			//读取单一窗口综合信息
			ctx.getDaoSession().dbRead(this.getEabgrp().getSwinfo(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));

			/* String sql="select cid ,inr  from pty where cifno  ='"+$eabgrp\\rec\\idno.getValue()+"'";
			  Platform.dbExecuteSQL(sql);
			  Argument<String> cid =new Argument<String>("cid");
			  Argument<String> inr =new Argument<String>("inr");
			  log.info("cid========================="+cid.value);
			  while(true)
			  {
			  Platform.dbFetchFields(cid,inr);
			  if(Platform.errorCode()==NO_ERROR)
			  {
			  $eabgrp\\rec\\cusid.setValue(cid.value);
			  List<CodetableItem> bchcod =$sysmod.getAndSetBchcod(inr.value);
			  Platform.setValues($eabgrp\\rec\\ownbch,bchcod);
			
			  }
			
			  else
			  break;
			  }
			  // $eabgrp\\rec\\cusid.setValue($sysmod\\pty\\cid.getValue());
			
			  Platform.dbCloseCursor();
			  */
			this.getEabgrp().getRec().setCusid(this.getEabgrp().getPty().getCid());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodFlg(this.getEabgrp().getPty().getInr(),this.getEabgrp().getRec().getOwnbch());

			MdaUtils.setValues(this.getEabgrp().getRec(),"ownbch",bchcod);
			/*
			  String sql="select functionts from tas where cifno  ='"+$eabgrp\\rec\\idno.getValue()+"'";
			  Platform.dbExecuteSQL(sql);
			  int errorCode=Platform.errorCode();
			  if(errorCode!= NO_ERROR)
			  {
			  $eabgrp\\rec\\yesno.setValue("02");
			
			  return false;
			  }
			  Argument<String> functionts =new Argument<String>("functionts");
			  Platform.dbFetchFields(functionts);
			
			  String fc=functionts.value;
			  Platform.dbCloseCursor();
			  int index=-1;
			  if(fc.indexOf("user_binding")>-1)
			  {
			  $eabgrp\\rec\\yesno.setValue("01");
			  }
			  else
			  {
			  $eabgrp\\rec\\yesno.setValue("02");
			  }
			  */
			
			
			
			//Platform.disable($eabgrp\\rec\\reason);
			
			// Platform.disable($eabgrp\\rec\\ownbch);
			
			
			String objinr = this.getEabgrp().getRec().getInr();
			String objtyp = "eab";
			MdaUtils.clear(this.getTrnmod().getBnktrn());
			ctx.getDaoSession().dbRead(this.getTrnmod().getBnktrn(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp));


			return true;
        }









}