package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.ErsshwVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ersp;
import com.ceb.gjjs.mda.manager.module.Ersgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 报文信息展示
*/
@Transaction(vo= ErsshwVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ersshw extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Ersshw.class);

		@BDGetter
		private Ersgrp ersgrp;

		@BDGetter
		private Ersp ersp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;


		public Ersshw()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getErsp().setErsHolder(()->this.getErsgrp().getRec());
           this.getMtabut().setRecHolder(()->this.getErsgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("EQ"));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Ersshw.this.getFieldPath("ersgrp.rec.ownref");}
 				public void setValue(String arg){Ersshw.this.getErsgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Ersshw.this.getErsgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Ersshw.this.getFieldPath("ersgrp.rec.bchcod");}
 				public void setValue(String arg){Ersshw.this.getErsgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Ersshw.this.getErsgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ersshw.this.getFieldPath("ersgrp.rec.inr");}
 				public void setValue(String arg){Ersshw.this.getErsgrp().getRec().setInr(arg);}
 				public String getValue(){return Ersshw.this.getErsgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Ersshw.this.getFieldPath("ersgrp.rec.ptyinr");}
 				public void setValue(String arg){Ersshw.this.getErsgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Ersshw.this.getErsgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:ersshw.@0001.script
        */
        @Rule(target="ersp.exi",order=100)
        public boolean ruleErspExiN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:ersshw.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.ersshw.ref");
			if(!MdaUtils.isEmpty(mdl))
			{
			  this.getErsgrp().getRec().copyValue(mdl);
			}

			return true;
        }









}