package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FeqcxsVO;

import com.ceb.gjjs.mda.manager.module.Cxsgrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Cxstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 额度申请重新生效
*/
@Transaction(vo= FeqcxsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Feqcxs extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Feqcxs.class);

		@BDGetter
		private Cxsgrp cxsgrp;

		@BDGetter
		private Cxstp cxstp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Mtabut mtabut;


		public Feqcxs()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getCxstp().setCxsgrpHolder(()->this.getCxsgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxsgrp.rec.currency");}
 				public void setValue(String arg){Feqcxs.this.getCxsgrp().getRec().setCurrency(arg);}
 				public String getValue(){return Feqcxs.this.getCxsgrp().getRec().getCurrency();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxstp.cxsgrp.rec.paysum");}
 				public void setValue(BigDecimal arg){Feqcxs.this.getCxstp().getCxsgrp().getRec().setPaysum(arg);}
 				public BigDecimal getValue(){return Feqcxs.this.getCxstp().getCxsgrp().getRec().getPaysum();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxsgrp.rec.businessno");}
 				public void setValue(String arg){Feqcxs.this.getCxsgrp().getRec().setBusinessno(arg);}
 				public String getValue(){return Feqcxs.this.getCxsgrp().getRec().getBusinessno();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxsgrp.rec.bchcod");}
 				public void setValue(String arg){Feqcxs.this.getCxsgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Feqcxs.this.getCxsgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxsgrp.rec.inr");}
 				public void setValue(String arg){Feqcxs.this.getCxsgrp().getRec().setInr(arg);}
 				public String getValue(){return Feqcxs.this.getCxsgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Feqcxs.this.getFieldPath("cxsgrp.rec.ptyinr");}
 				public void setValue(String arg){Feqcxs.this.getCxsgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Feqcxs.this.getCxsgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getCxsgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:feqcxs.@0000.script
        */
        @Rule(target="cxstp.save",order=100)
        public boolean ruleCxstpSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			//校验参数，重新生效的情况下，最迟购汇日期
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			//20230420 增加操作历史
			/*Platform.dbRead($cxsgrp\\old,new Argument<String>("businessno",$cxstp\\businessno.getValue()));
			  //20230420 增加操作历史
			  $cxsgrp\\old\\businessno.setValue($cxsgrp\\old\\inr.getValue());
			  $cxsgrp\\old\\inr=Platform.sdbCounter("shs");
			  $cxsgrp\\old\\upddat.setValue(null);
			  $cxsgrp\\old\\deleted.setValue("1");
			  $cxsgrp\\old\\credat.setValue(Platform.today());*/
			if("0".equals(this.getCxstp().getJiehsign())&&"1".equals(this.getCxstp().getEduflag()))
			{
			  if(MdaUtils.diff(MdaUtils.parseDate(time,"yyyyMMdd"),this.getCxstp().getZcghdat())>0)
			  {
			    ctx.setMessage("E9999","最迟购汇日期不能小于系统当前时间");
			    return false;
			  }
			  if(this.getCxsgrp().getShdlst().fullSize()==0)
			  {
			    ctx.setMessage("E9999","单据信息不能为空");
			    return false;
			  }
			  //最迟购汇日期<=单据中的最迟付汇日期中的最大值
			  Date date=MdaUtils.parseDate(time,"yyyyMMdd");
			  for(int i = 0; i < this.getCxsgrp().getShdlst().size(); i++){
			    if(MdaUtils.diff(this.getCxsgrp().getShdlst().getElement(i).getZcfhdat(),date)>0)
			  {
			    date=this.getCxsgrp().getShdlst().getElement(i).getZcfhdat();
			  }
			  else
			  {
			    date=date;
			  }
			}
			if(MdaUtils.diff(this.getCxstp().getZcghdat(),date)>0)
			{
			  ctx.setMessage("E9999","最迟购汇日期不能大于单据信息中最晚的最迟付汇日期");
			  return false;
			}
			}
			//开启事务
			ctx.getDaoSession().dbBegin();
			//加载shs
			MdaUtils.clear(this.getCxsgrp().getRec());
			ctx.getDaoSession().dbRead(this.getCxsgrp().getRec(),new Argument<String>("ecifno",this.getCxstp().getEcifno()),new Argument<String>("businessno",this.getCxstp().getBusinessno()));
			ctx.getErrorCode();
			log.debug("{}","业务参考号："+this.getCxsgrp().getRec().getBusinessno());
			log.debug("{}","客户号："+this.getCxsgrp().getRec().getEcifno());
			if(MdaUtils.isEmpty(this.getCxsgrp().getRec().getInr()))
			{
			ctx.setMessage("E9999","无此业务参考号，请核实相关信息");
			return false;
			}
			//加载trn
			MdaUtils.clear(ctx.absGet(Trnmod.class).getTrn());
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getTrn(),new Argument<String>("ownref",this.getCxsgrp().getRec().getBusinessno()));
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrn().getInr()))
			{
			ctx.setMessage("E9999","无此业务信息，请核实相关信息");
			return false;
			}
			//加载ord
			MdaUtils.clear(ctx.absGet(Trnmod.class).getOrdmod().getOrd());
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getOrdmod().getOrd(),new Argument<String>("objinr",this.getCxsgrp().getRec().getInr()),new Argument<String>("objtyp","shs"));
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr()))
			{
			ctx.setMessage("E9999","无此订单信息，请核实相关信息");
			return false;
			}
			//当请求为删除或者重新生效且不是结汇的状态下，逻辑删除原本的单据信息
			if("3".equals(this.getCxstp().getEduflag())||("0".equals(this.getCxstp().getJiehsign())&&"1".equals(this.getCxstp().getEduflag())))
			{
			//删除旧的单据表
			delbill(this.getCxsgrp().getRec().getBusinessno());
			}
			//重新生效逻辑处理
			if("1".equals(this.getCxstp().getEduflag()))
			{
			if(!"4".equals(this.getCxsgrp().getRec().getApplystatus()))
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E9999","该业务状态下，不能发起重新生效申请");
			  return false;
			}
			if("0".equals(this.getCxstp().getJiehsign()))
			{
			  //更新单据表信息
			  for(int i=0;i<this.getCxsgrp().getShdlst().fullSize();i++)
			  {
			    this.getCxsgrp().getShd().setInr(Platform.sdbCounter("shd"));
			    this.getCxsgrp().getShd().setDeleted("0");
			    this.getCxsgrp().getShd().setEdbusno(this.getCxsgrp().getRec().getBusinessno());
			    this.getCxsgrp().getShd().setBillno(this.getCxsgrp().getShdlst().getElement(i).getBillno());
			    this.getCxsgrp().getShd().setBillnewno(this.getCxsgrp().getShdlst().getElement(i).getBillno());
			    this.getCxsgrp().getShd().setBilltype(this.getCxsgrp().getShdlst().getElement(i).getBilltype());
			    this.getCxsgrp().getShd().setZcfhdat(this.getCxsgrp().getShdlst().getElement(i).getZcfhdat());
			    this.getCxsgrp().getShd().setZcfhnewdat(this.getCxsgrp().getShdlst().getElement(i).getZcfhdat());
			    this.getCxsgrp().getShd().setBillsum(this.getCxsgrp().getShdlst().getElement(i).getBillsum());
			    this.getCxsgrp().getShd().setCredat(MdaUtils.today());
			    //20230420
			    this.getCxsgrp().getShd().setSerialnum(this.getCxstp().getSerialnum());
			    this.getCxsgrp().getShd().setEnterdat(this.getCxstp().getEnterdat());
			    ctx.getDaoSession().dbInsert(this.getCxsgrp().getShd());
			    if(ctx.getErrorCode()!= NO_ERROR)
			    {
			      ctx.getDaoSession().dbRollback();
			      ctx.setMessage("E9999","数据库处理异常，单据信息保存失败");
			      return false;
			    }
			  }
			}
			//20230420
			this.getCxsgrp().getRec().setApplytyp("1");
			this.getCxsgrp().getRec().setSerialnum(this.getCxstp().getSerialnum());
			this.getCxsgrp().getRec().setEnterdat(this.getCxstp().getEnterdat());
			log.debug("{}","serialnum========================================================"+this.getCxstp().getSerialnum());
			log.debug("{}","enterdat========================================================"+this.getCxstp().getEnterdat());
			//业务表shs数据更新，重新生效时进行更新，作废，删除不做更新
			//将业务表状态改为待审核
			this.getCxsgrp().getRec().setApplystatus("1");
			//是否结汇
			this.getCxsgrp().getRec().setJiehsign(this.getCxstp().getJiehsign());
			//最迟购汇日期
			this.getCxsgrp().getRec().setZcghdat(this.getCxstp().getZcghdat());
			this.getCxsgrp().getRec().setZcghnewdat(this.getCxstp().getZcghdat());
			//重新生效原因
			this.getCxsgrp().getRec().setReores(this.getCxstp().getReores());
			//将trn表的状态改为W，resreq=O，relres=NULL，nxtreq=O，nxtlev=NULL，单岗审核
			ctx.absGet(Trnmod.class).getTrn().setSta("w");
			ctx.absGet(Trnmod.class).getTrn().setRelreq("O");
			ctx.absGet(Trnmod.class).getTrn().setRelres("");
			ctx.absGet(Trnmod.class).getTrn().setNxtreq("O");
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("");
			//对于ord，更新状态，交易处理中。
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setSta("E");
			}
			//作废逻辑处理
			else if("2".equals(this.getCxstp().getEduflag()))
			{
			//已购未付金额havegwfed必须等于0才能操作
			BigDecimal camt = this.getCxsgrp().getRec().getHavegwfed();
			if(camt.compareTo(new BigDecimal(0.00))>0)
			{
			  ctx.setMessage("E9999","已购未付金额大于0，不可作废");
			  return false;
			}
			//if("2".equals($cxsgrp\\rec\\applystatus.getValue())||"3".equals($cxsgrp\\rec\\applystatus.getValue())||"4".equals($cxsgrp\\rec\\applystatus.getValue()))
			if("4".equals(this.getCxsgrp().getRec().getApplystatus()))
			{
			  //更新业务表的状态为待审核
			  this.getCxsgrp().getRec().setApplystatus("1");
			  //重置业务表的更新时间
			  this.getCxsgrp().getRec().setUpddat(MdaUtils.today());
			  //20230420
			  this.getCxsgrp().getRec().setApplytyp("2");
			  //将trn表的状态改为W，resreq=O，relres=NULL，nxtreq=O，nxtlev=NULL，单岗审核
			  ctx.absGet(Trnmod.class).getTrn().setSta("w");
			  ctx.absGet(Trnmod.class).getTrn().setRelreq("O");
			  ctx.absGet(Trnmod.class).getTrn().setRelres("");
			  ctx.absGet(Trnmod.class).getTrn().setNxtreq("O");
			  ctx.absGet(Trnmod.class).getTrn().setNxtlev("");
			  //对于ord，更新状态，交易处理中。
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setSta("E");
			}
			else
			{
			  ctx.setMessage("E9999","已作废或目前业务状态下不能作废");
			  return false;
			}
			}
			else
			//删除逻辑处理
			{
			//1.更新额度表deleted=1;
			//增加一层校验，如果额度的状态不是退回修改，则返回错误
			if(!"2".equals(this.getCxsgrp().getRec().getApplystatus()))
			{
			  ctx.setMessage("E9999","数据不能删除");
			  return false;
			}
			this.getCxsgrp().getRec().setDeleted("1");

			//修改trn表状态为删除
			ctx.absGet(Trnmod.class).getTrn().setSta("x");
			//更新业务表的状态为作废
			this.getCxsgrp().getRec().setApplystatus("6");
			//对于ord，更新状态，拒绝。
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setSta("R");
			}
			//影像落地
			//给接口传入网银影像guid，由接口去进行判断并插入tblbil表
			if(!MdaUtils.isEmpty(this.getCxstp().getGuid()))
			{
			String ownref =this.getCxsgrp().getRec().getBusinessno();
			String imgref = ownref;
			String objtyp = MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec());
			String guid=this.getCxstp().getGuid();
			//重新生效的情况下，需要必传影像批次号，且与额度申请的影像批次号一致
			this.getCxsgrp().getRec().setGuid(guid);
			log.debug("{}","ownref："+ownref+"      imgref:"+imgref+"      objtyp:"+objtyp+"      guid:"+guid);
			if(!MdaUtils.isEmpty(guid))
			{
			  String cls="com.brilliance.eibs.main.Client";
			  Object rtnVal = MdaUtils.invoke(cls,"scall","ENTMBdownload","ENTMBdownload",new Object[]{ownref,imgref,"1001","GJ01",guid,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp,MdaUtils.format(new Date(),"yyyyMMdd")});
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  Boolean errcod = (Boolean)retMsg.get("issuccess");
			  if(!errcod)
			  {
			    log.error("{}","APP img down error！");
			    ctx.setMessage("E9999","影像下载失败");
			    return false;
			  }
			}
			}
			//更新操作的表数据 ，数据落地
			//重置业务表的更新时间
			this.getCxsgrp().getRec().setUpddat(MdaUtils.today());
			//更新trn
			ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}
			//业务表shs数据更新
			//额度操作标识
			this.getCxsgrp().getRec().setEduflag(this.getCxstp().getEduflag());
			//20230420 增加操作历史
			//Platform.dbInsert($cxsgrp\\old);
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}

			ctx.getDaoSession().dbUpdate(this.getCxsgrp().getRec());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}

			//ord表
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setInidattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setStadattim(MdaUtils.today());
			//订单表更新
			ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getOrdmod().getOrd());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}
			//对于ore，新增。
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setInr(Platform.sdbCounter("ore"));
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setTyp(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getSta());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setWaitim((long)0);
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setFrm(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getFrm());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setPtyinr(ctx.absGet(Trnmod.class).getTrn().getPtyinr());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setBegdattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setEnddattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setObjinr(this.getCxsgrp().getRec().getInr());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setTxt("订单操作");
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setTyp(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getSta());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setObjtyp("shs");
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setOrdinr(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr());
			//待定
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setAction("11");
			ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getOrdmod().getOre());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}
			//提交事务
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			ctx.getDaoSession().dbRollback();
			ctx.setMessage("E9999","数据库处理异常");
			return false;
			}
			else
			{
			ctx.setMessage("00000","申请提交成功");
			}

			return true;
        }




        /**
        *   source:feqcxs.@0001.script
        */
        public void delbill(String busno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCxsgrp().getShdolst());
			ctx.getDaoSession().dbReadset(this.getCxsgrp().getShdolst(),new Argument<String>("edbusno",busno),new Argument<String>("deleted","0"));
			ctx.getErrorCode();
			for(int i=0;i<this.getCxsgrp().getShdolst().fullSize();i++)
			{
			  //判断单据编码新旧值，如果一样不做处理，如果不一样则将旧值赋给新值(说明e结算做修改，e结算修改的不能作为历史记录)
			  if(!this.getCxsgrp().getShdolst().getElement(i).getBillno().equals(this.getCxsgrp().getShdolst().getElement(i).getBillnewno()))
			  {
			    this.getCxsgrp().getShdolst().getElement(i).setBillnewno(this.getCxsgrp().getShdolst().getElement(i).getBillno());
			  }
			  //判断最迟付汇日期旧值，如果一样不做处理，如果不一样则将旧值赋给新值(说明e结算做修改，e结算修改的不能作为历史记录)
			  if(!this.getCxsgrp().getShdolst().getElement(i).getZcfhdat().equals(this.getCxsgrp().getShdolst().getElement(i).getZcfhnewdat()))
			  {
			    this.getCxsgrp().getShdolst().getElement(i).setZcfhnewdat(this.getCxsgrp().getShdolst().getElement(i).getZcfhdat());
			  }
			  //20230420
			  if("1".equals(this.getCxstp().getEduflag()) && "0".equals(this.getCxstp().getJiehsign()))
			  {
			    this.getCxsgrp().getShdolst().getElement(i).setDeleted("2");
			  }
			  else
			  {
			    this.getCxsgrp().getShdolst().getElement(i).setDeleted("1");
			  }

			  /*Platform.clear($cxsgrp\\shd);
			    $cxsgrp\\shd\\inr=$cxsgrp\\shdolst[i]\\inr;
			    $cxsgrp\\shd\\edbusno.setValue($cxsgrp\\shdolst[i]\\edbusno.getValue());
			    $cxsgrp\\shd\\upddat.setValue(Platform.today());
			    $cxsgrp\\shd\\billtype.setValue($cxsgrp\\shdolst[i]\\billtype.getValue());
			    $cxsgrp\\shd\\billnewno.setValue($cxsgrp\\shdolst[i]\\billnewno.getValue());
			    $cxsgrp\\shd\\billno.setValue($cxsgrp\\shdolst[i]\\billno.getValue());
			    $cxsgrp\\shd\\billsum.setValue($cxsgrp\\shdolst[i]\\billsum.getValue());
			    $cxsgrp\\shd\\zcfhdat.setValue($cxsgrp\\shdolst[i]\\zcfhdat.getValue());
			    $cxsgrp\\shd\\zcfhnewdat.setValue($cxsgrp\\shdolst[i]\\zcfhnewdat.getValue());
			    $cxsgrp\\shd\\credat.setValue($cxsgrp\\shdolst[i]\\credat.getValue());*/
			  ctx.getDaoSession().dbUpdate(this.getCxsgrp().getShdolst().getElement(i));
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return;
			  }
			}
		}








}