package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FeqopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Feqgrp;
import com.ceb.gjjs.mda.manager.module.Fqtp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 购汇额度申请交易
*/
@Transaction(vo= FeqopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Feqopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Feqopn.class);

		@BDGetter
		private Feqgrp feqgrp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Fqtp fqtp;

		@BDGetter
		private Trnmod trnmod;


		public Feqopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FQ"));
           this.getMtabut().setRecHolder(()->this.getFeqgrp().getRec());
           this.getFqtp().setFeqgrpHolder(()->this.getFeqgrp());
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.currency");}
 				public void setValue(String arg){Feqopn.this.getFeqgrp().getRec().setCurrency(arg);}
 				public String getValue(){return Feqopn.this.getFeqgrp().getRec().getCurrency();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.businessno");}
 				public void setValue(String arg){Feqopn.this.getFeqgrp().getRec().setBusinessno(arg);}
 				public String getValue(){return Feqopn.this.getFeqgrp().getRec().getBusinessno();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.bchcod");}
 				public void setValue(String arg){Feqopn.this.getFeqgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Feqopn.this.getFeqgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.inr");}
 				public void setValue(String arg){Feqopn.this.getFeqgrp().getRec().setInr(arg);}
 				public String getValue(){return Feqopn.this.getFeqgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.ptyinr");}
 				public void setValue(String arg){Feqopn.this.getFeqgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Feqopn.this.getFeqgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Feqopn.this.getFieldPath("feqgrp.rec.paysum");}
 				public void setValue(BigDecimal arg){Feqopn.this.getFeqgrp().getRec().setPaysum(arg);}
 				public BigDecimal getValue(){return Feqopn.this.getFeqgrp().getRec().getPaysum();}}
			 );
        }











}