package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FftapnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fstmod;
import com.ceb.gjjs.mda.manager.module.Fsdgrp;
import com.ceb.gjjs.mda.manager.module.Fstp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷业务申请
*/
@Transaction(vo= FftapnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fftapn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fftapn.class);

        //承兑行标志
        private String acbflg;
        //付款行标志位
        private String payflg;
        //保兑行标志位
        private String conflg;
        //保付行标志位
        private String accflg;
        //原币标志位
        private String oriflg;
        //结汇标志位
        private String soeflg;
		@BDGetter
		private Fsdgrp fsdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Fstmod fstmod;

		@BDGetter
		private Fstp fstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Fftapn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFstmod().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstmod().setBedgrpHolder(()->this.getBedgrp());
           this.getFstp().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstp().setBedgrpHolder(()->this.getBedgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FF"));
           this.getMtabut().setRecHolder(()->this.getFsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.brkcur");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setBrkcur(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getBrkcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.brkamt");}
 				public void setValue(BigDecimal arg){Fftapn.this.getFsdgrp().getRec().setBrkamt(arg);}
 				public BigDecimal getValue(){return Fftapn.this.getFsdgrp().getRec().getBrkamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.ownref");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.bchcod");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.inr");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftapn.this.getFieldPath("fsdgrp.rec.stlref");}
 				public void setValue(String arg){Fftapn.this.getFsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fftapn.this.getFsdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:fftapn.@0015.script
        */
        @Rule(target="fstp.fsdgrp.rec.enttyp",order=100)
        public boolean ruleFstpFsdgrpRecEnttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","STart..................");
			log.info("{}","enttyp.value==========="+this.getFsdgrp().getRec().getEnttyp());
			if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getEnttyp()))
			{
			  
			  
			}
			else
			{
			  if("1".equals(this.getFsdgrp().getRec().getEnttyp()))
			  {
			    log.info("{}","enttyp===========111111111111111");
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    this.getFsdgrp().getRec().setOrigno(NULLSTR);
			    
			    
			    
			    
			  }
			  else if ("2".equals(this.getFsdgrp().getRec().getEnttyp()))
			  {
			    log.info("{}","enttyp===========2222222222222222222");
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    this.getFsdgrp().getRec().setSoexno(NULLSTR);
			    this.getFsdgrp().getRec().setSoedoc(NULLSTR);
			    this.getFsdgrp().getRec().setReason(NULLSTR);
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:fftapn.@0021.script
        */
        @Rule(target="fstp.sqspdf",order=100)
        public boolean ruleFstpSqspdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags();
			String pdfName = "" ;
			// 非信用证
			if("2".equals(this.getFsdgrp().getRec().getLctyp()))
			{
			  pdfName = "fftapn1" ;
			}
			else
			{
			  // 信用证
			  pdfName ="fftapn";
			}
			this.getFstp().getPdfviw().callPDFComponent("",pdfName,"福费廷业务申请书",1);

			return true;
        }

        /**
        *   source:fftapn.@0024.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Start save 200");
			this.getMtabut().getBusmod().dealFile();
			if(!(ctx.checkAll(this.getBedgrp()) && ctx.checkAll(this.getFsdgrp().getRec())))
			  return false;

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getFsdgrp().getRec());
			  String objinr = this.getFsdgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getAcb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getCon().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getPay().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getAcc().getPts(),objinr);
			}
			else
			{
			  log.debug("{}","---------fsdgrp--rec--inr-------------"+this.getFsdgrp().getRec().getInr());
			  if(MdaUtils.isEmpty(this.getBedgrp().getRec().getInr()))
			  {
			    this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			    ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			  }
			  this.getFsdgrp().getRec().setInr(Platform.sdbCounter("fsd"));
			  this.getFsdgrp().getRec().setPnttyp( "bed");
			  this.getFsdgrp().getRec().setPntinr( this.getBedgrp().getRec().getInr());
			  this.getFsdgrp().getRec().setPntref( this.getBedgrp().getRec().getStlref());
			  this.getFsdgrp().getRec().setFincur(this.getBedgrp().getRec().getAcpcur());
			  this.getFsdgrp().getRec().setFinamt(this.getBedgrp().getRec().getAcpamt());
			  if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getFincur())||MdaUtils.isEmpty(this.getFsdgrp().getRec().getFinamt()))
			  {
			    ctx.setMessage("提示","融资币种,金额不能为空！");
			    return false;
			  }
			  ctx.getDaoSession().dbInsert(this.getFsdgrp().getRec());
			  String objinr = this.getFsdgrp().getRec().getInr();
			  String objtyp = "fsd";
			  //isb
			  this.getFsdgrp().getIsb().savpts(objinr,objtyp);
			  //acp
			  this.getFsdgrp().getAcb().savpts(objinr,objtyp);
			  //直接申请人
			  this.getFsdgrp().getDap().getPts().setInr( Platform.sdbCounter("pts"));
			  this.getFsdgrp().getDap().getPts().setObjinr( objinr);
			  this.getFsdgrp().getDap().getPts().setObjtyp( objtyp);
			  ctx.getDaoSession().dbInsert(this.getFsdgrp().getDap().getPts());
			  //con
			  this.getFsdgrp().getCon().savpts(objinr,objtyp);
			  //pay
			  this.getFsdgrp().getPay().savpts(objinr,objtyp);
			  //acc
			  this.getFsdgrp().getAcc().savpts(objinr,objtyp);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getIsb().getPts().getRef()))
			{
			  this.getFstp().setYwlx("BED");
			}
			else
			{
			  this.getFstp().setYwlx(NULLSTR);
			}

			//保存TRN流水
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);


			return true;
        }

        /**
        *   source:fftapn.@0031.script
        */
        @Rule(target="fstp.actcancel",order=100)
        public boolean ruleFstpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:fftapn.@0032.script
        */
        @Rule(target="fstp.actsure",order=100)
        public boolean ruleFstpActsureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getFstp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fftapn","CT000036"),MdaUtils.getI18NString("fftapn","CT000037"));
			  return true;
			}
			if("2".equals(this.getFsdgrp().getRec().getEnttyp()))
			{
			  this.getFsdgrp().getRec().setOrigno(this.getFstp().getActlst().getElement(index).getAct());
			}
			else if("1".equals(this.getFsdgrp().getRec().getEnttyp()))
			{
			  this.getFsdgrp().getRec().setSoexno(this.getFstp().getActlst().getElement(index).getAct());
			}
			
			
			

			return true;
        }

        /**
        *   source:fftapn.@0033.script
        */
        @Rule(target="fstp.actselect",order=100)
        public boolean ruleFstpActselectN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().popupActchs();

			return true;
        }

        /**
        *   source:fftapn.@0035.script
        */
        @Rule(target="fstp.actselect1",order=100)
        public boolean ruleFstpActselect1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().popupActchs();

			return true;
        }

        /**
        *   source:fftapn.@0037.script
        */
        @Rule(target="fstp.jhsqspdf",order=100)
        public boolean ruleFstpJhsqspdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().getPdfviw().callPDFComponent("","jhsqs","结汇申请书",0);

			return true;
        }

        /**
        *   source:fftapn.@0044.script
        */
        @Rule(target="fstp.fsdgrp.rec.lctyp",order=100)
        public boolean ruleFstpFsdgrpRecLctypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getFstp().getFsdgrp().getRec().getLctyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(this.getFstp().getFsdgrp().getRec().getLctyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:fftapn.@0063.script
        */
        @Rule(target="mtabut.busmod.save",order=100)
        public boolean ruleMtabutBusmodSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().getBusmod().setTmplr(this.getFstp().getFsdgrp().getRec().getLctyp());

			return true;
        }

        /**
        *   source:fftapn.@0064.script
        */
        @Rule(target="mtabut.busmod.select",order=101)
        public boolean ruleMtabutBusmodSelectN101(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","Star select order 101");
			ctx.postRule(this,"fsdgrp.rec.enttyp");

			return true;
        }


        /**
        *   source:fftapn.@0036.script
        */
        @Check(target="fsdgrp.rec.rgtclu",order=100)
        public boolean checkFsdgrpRecRgtcluN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","chech rgtclu ..."  );
			log.debug("{}","rgtclu:" + this.getFsdgrp().getRec().getRgtclu());
			

			return true;
        }

        /**
        *   source:fftapn.@0050.script
        */
        @Check(target="fsdgrp.rec.concur",order=100)
        public boolean checkFsdgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getCon().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fftapn.@0051.script
        */
        @Check(target="fsdgrp.rec.conamt",order=100)
        public boolean checkFsdgrpRecConamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getCon().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fftapn.@0052.script
        */
        @Check(target="fsdgrp.rec.acdamt",order=100)
        public boolean checkFsdgrpRecAcdamtN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcc().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			


			return true;
        }

        /**
        *   source:fftapn.@0053.script
        */
        @Check(target="fsdgrp.rec.acdcur",order=100)
        public boolean checkFsdgrpRecAcdcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcc().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fftapn.@0054.script
        */
        @Check(target="fsdgrp.rec.payamt",order=100)
        public boolean checkFsdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getPay().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fftapn.@0055.script
        */
        @Check(target="fsdgrp.rec.paycur",order=100)
        public boolean checkFsdgrpRecPaycurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getPay().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fftapn.@0072.script
        */
        @Check(target="fstp.fsdgrp.rec.origno",order=100)
        public boolean checkFstpFsdgrpRecOrignoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getRec().getOrigno()))
			{
			  if(this.getFsdgrp().getRec().getOrigno().length()!=18)
			  {
			    ctx.setFieldError(this,"fsdgrp.rec.origno",MdaUtils.getI18NString("fftapn","CT000137"));
			  }
			}

			return true;
        }

        /**
        *   source:fftapn.@0073.script
        */
        @Check(target="fstp.fsdgrp.rec.soexno",order=100)
        public boolean checkFstpFsdgrpRecSoexnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getRec().getSoexno()))
			{
			  if(this.getFsdgrp().getRec().getSoexno().length()!=18)
			  {
			    ctx.setFieldError(this,"fsdgrp.rec.soexno",MdaUtils.getI18NString("fftapn","CT000138"));
			  }
			}

			return true;
        }


        /**
        *   source:fftapn.@0004.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			
			MdaUtils.setValues(this.getFsdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getFsdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			
			
			
			
			
			
			
			
			
			

			if(!MdaUtils.isEmpty(this.getFsdgrp().getTmpsta()))
			{
			  log.info("{}","enter tmpsta...............");
			  if(!MdaUtils.isEmpty(this.getFstp().getIsbp().getPtspta().getPts().getExtkey()))
			  {
			    
			    
			  }
			  if(!MdaUtils.isEmpty(this.getFsdgrp().getIsb().getPts().getRef()))
			  {
			    
			  }
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getIsscur()))
			  {
			    
			  }
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getIssamt()))
			  {
			    
			  }
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getStlref()))
			  {
			    
			  }
			}
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			{
			  ctx.absGet(Trnmod.class).ordNew();
			}
			ctx.postRule(this,"fsdgrp.rec.enttyp");
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  return true;
			}
			//查询是否有签订协议
			this.qurFydOwnrefAndSlepes();

			String sure = (String)ctx.restoreData("com.brilliance.fftapn0.sure");
			if(!MdaUtils.isEmpty(sure))
			{
			  this.getFsdgrp().setTmpsta(sure);
			  log.info("{}","tmpsta.value======================="+this.getFsdgrp().getTmpsta());
			  IModule bed = (IModule)ctx.restoreData("com.brilliance.fftapn.ref");
			  this.getFsdgrp().getRec().setLctyp("1");
			  
			  
			  this.lrMandtory();
			  if(!MdaUtils.isEmpty(bed))
			  {
			    this.getBedgrp().getRec().copyValue(bed);
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getAcpcur()))
			    {
			      this.getBedgrp().getRec().setAcpcur(this.getBedgrp().getRec().getDoccur());
			      
			    }
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getAcpamt()))
			    {
			      this.getBedgrp().getRec().setAcpamt(this.getBedgrp().getRec().getDocamt());
			      
			    }
			    ctx.getDaoSession().dbRead(this.getFsdgrp().getIsb().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","isb"));
			    ctx.getDaoSession().dbRead(this.getFsdgrp().getAcb().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","acb"));
			    if(!MdaUtils.isEmpty(this.getFstp().getIsbp().getPtspta().getPts().getExtkey()))
			    {
			      
			      
			      
			      
			    }
			    if(!MdaUtils.isEmpty(this.getFstp().getAcbp().getPtspta().getPts().getExtkey()))
			    {
			      
			      
			      
			      
			    }
			    this.getFsdgrp().getIsb().getPts().setRef(this.getBedgrp().getRec().getPntref());
			    
			    
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getIsscur()))
			    {
			      this.getBedgrp().getRec().setIsscur(this.getBedgrp().getRec().getDoccur());
			      
			    }
			    
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getIssamt()))
			    {
			      this.getBedgrp().getRec().setIssamt(this.getBedgrp().getRec().getDocamt());
			      
			    }
			    
			    if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getStlref()))
			    {
			      
			      
			    }
			    
			  }
			}

			//赋值申请人名称,后面再取
			this.getFsdgrp().getApl().getPts().setNam(this.getSysmod().getPty().getNam());
			this.getFsdgrp().getRec().setCredat(MdaUtils.today());
			

			this.getFstp().getRgtclu().setClstyp("fftapn");
			if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getRgtclu()))
			{
			  //Platform.dbRead($fstp\\rgtclu\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fftopn"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFstp().getRgtclu().getCls(),new Argument<String>("inr",this.getFstp().getRgtclu().readDefaultClsInr("fftapn")));
			  this.getFsdgrp().getRec().setRgtclu(this.getFstp().getRgtclu().getCls().getClstxt());
			}
			this.getBedgrp().setAplnam(this.getSysmod().getPty().getNam());
			this.getFstp().setYwlx("BED");
			


			return true;
        }

        /**
        *   source:fftapn.@0011.script
        */
        @Init(order=102)
        public boolean	init102(){
            IContext ctx = MdaEnv.getContext();
            
			//  定义步骤条
			this.getFstp().getStpmod().storePanel(this.getFstp().getFftapn02());
			String steps = "0:业务申请";
			this.getFstp().getStpmod().setPages(steps);
			this.getFstp().getStpmod().calcSteps();
			this.getFstp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:fftapn.@0001.script
        */
        public boolean fxySigned()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getFsdgrp().getFxylst());
			String whsql =  " where ptyinr = ? and yxqqsr is null and yxqzzr is null ";
			ctx.getDaoSession().dbReadset(this.getFsdgrp().getFxylst(),whsql,this.getSysmod().getPty().getInr());
			int size = this.getFsdgrp().getFxylst().size();
			if(size >0)
			  return true;
			Date dat = new Date();
			ctx.getDaoSession().dbReadset(this.getFsdgrp().getFxylst(),new Argument("ptyinr",EQ,this.getSysmod().getPty().getInr()).and(new Argument("yxqqsr",LE,dat)).and(new Argument("yxqzzr",GE,dat)));
			size = this.getFsdgrp().getFxylst().size();
			if(size >0)
			  return true;
			return false;
		}
        /**
        *   source:fftapn.@0002.script
        */
        public boolean fxyctr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select count(inr) cnt from fxy where ptyinr='"+this.getSysmod().getPty().getInr()+"' and bchcod='"+this.getFsdgrp().getRec().getBchcod()+"' and yxqqsr <=? and yxqzzr>=? ";
			log.debug("{}","sql-"+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getFsdgrp().getRec().getCredat(),LT),MdaUtils.sqlDate(this.getFsdgrp().getRec().getCredat(),GT));
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			ctx.getDaoSession().dbCloseCursor();
			if(cnt.value==1)
			{
			  return true;
			}
			else
			{
			  log.debug("{}","fxyctr-false-cnt="+cnt.value);
			  return false;
			}
		}
        /**
        *   source:fftapn.@0018.script
        */
        public void qurFydOwnrefAndSlepes()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//协议编号查询
			Date today =MdaUtils.today();
			String queryClause = " select rec.ownref,rec.slepes from fyd rec  where rec.effdat　<= ? and rec.losdat>=? and rec.ptyinr="+this.getSysmod().getPty().getInr()+"";
			ctx.getDaoSession().dbExecuteSQL(queryClause,MdaUtils.sqlDate(today,LT),MdaUtils.sqlDate(today,GT));
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> slepes = new Argument<String>("slepes");
			ctx.getDaoSession().dbFetchFields(ownref,slepes);
			ctx.getDaoSession().dbCloseCursor();
			int errorCode = ctx.getErrorCode();
			if(errorCode == NO_ERROR)
			{
			  this.getFsdgrp().getRec().setAgrmntno(ownref.getValue());
			  this.getFsdgrp().getRec().setSlepes(slepes.getValue());
			  
			  
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("fftapn","CT000016"));
			}

		}
        /**
        *   source:fftapn.@0043.script
        */
        public void lrMandtory()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
		}
        /**
        *   source:fftapn.@0070.script
        */
        public void flags()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcb().getPts().getAdrblk()))
			{
			  this.setAcbflg("√");
			}
			else
			{
			  this.setAcbflg(NULLSTR);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getCon().getPts().getAdrblk()))
			{
			  this.setConflg("√");
			}
			else
			{
			  this.setConflg(NULLSTR);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getPay().getPts().getAdrblk()))
			{
			  this.setPayflg("√");
			}
			else
			{
			  this.setPayflg(NULLSTR);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcc().getPts().getAdrblk()))
			{
			  this.setAccflg("√");
			}
			else
			{
			  this.setAccflg(NULLSTR);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getRec().getOrigno()))
			{
			  this.setOriflg("√");
			}
			else
			{
			  this.setOriflg(NULLSTR);
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getRec().getSoexno()))
			{
			  this.setSoeflg("√");
			}
			else
			{
			  this.setSoeflg(NULLSTR);
			}
		}















}