package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Fftapn0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷申请交易入口
*/
@Transaction(vo= Fftapn0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fftapn0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fftapn0.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Fftapn0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:fftapn0.@0001.script
        */
        @Rule(target="selp.newapply",order=100)
        public boolean ruleSelpNewapplyN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("com.brilliance.fftapn0.newapply","0");
			MdaUtils.clear(this.getBedgrp());
			

			return true;
        }

        /**
        *   source:fftapn0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//应业务人员需求，过滤掉BX的记录
			String queryClause ="";
			if("1".equals(this.getSelp().getSeltyp()))
			{
			  queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) bennam  FROM bed rec,pts s WHERE "
			    +"rec.docflg ='docadv' AND s.objtyp = 'bed' AND s.rol = 'apl' AND s.objinr=rec.inr  AND rec.stlref NOT LIKE '%BX%' AND upper(tenor) !='SIGHT' "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}


			return true;
        }

        /**
        *   source:fftapn0.@0005.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("com.brilliance.fftapn0.sure","1");
			this.getSelp().sureBtn("bedgrp","fftapn");

			return true;
        }



        /**
        *   source:fftapn0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selfftopn"));
			this.getSelp().setSeltyp("1");
			//String queryClause = "SELECT bed.inr trsinr,bed.stlref ref,bed.advdat dat,bed.doccur cur,bed.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bed,pts,adr,pta WHERE bed.docflg = 'docadv' AND pts.rol = 'apl' AND pts.objtyp = 'bed' AND pts.objinr = bed.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) bennam  FROM bed rec,pts s WHERE "
			  +"rec.docflg ='docadv' AND s.objtyp = 'bed' AND s.rol = 'apl' AND s.objinr=rec.inr AND rec.stlref NOT LIKE '%BX%' AND upper(tenor) !='SIGHT'"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}