package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FftdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fstmod;
import com.ceb.gjjs.mda.manager.module.Fsdgrp;
import com.ceb.gjjs.mda.manager.module.Fstp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷通知
*/
@Transaction(vo= FftdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fftdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fftdav.class);

		@BDGetter
		private Fsdgrp fsdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Fstmod fstmod;

		@BDGetter
		private Fstp fstp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fftdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFstmod().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstmod().setBedgrpHolder(()->this.getBedgrp());
           this.getFstp().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstp().setBedgrpHolder(()->this.getBedgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.finamt");}
 				public void setValue(BigDecimal arg){Fftdav.this.getFsdgrp().getRec().setFinamt(arg);}
 				public BigDecimal getValue(){return Fftdav.this.getFsdgrp().getRec().getFinamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.bchcod");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.fincur");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setFincur(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getFincur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.inr");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.ownref");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftdav.this.getFieldPath("fsdgrp.rec.stlref");}
 				public void setValue(String arg){Fftdav.this.getFsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fftdav.this.getFsdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFsdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:fftdav.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:fftdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels="";
			String tempfiles="";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label");
			tempfiles = cntLabel.get("tempfile");
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getFstp().getFftp03());

			return true;
        }

        /**
        *   source:fftdav.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}