package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FftopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fstmod;
import com.ceb.gjjs.mda.manager.module.Fsdgrp;
import com.ceb.gjjs.mda.manager.module.Fstp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷申请
*/
@Transaction(vo= FftopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fftopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fftopn.class);

		@BDGetter
		private Fsdgrp fsdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Fstmod fstmod;

		@BDGetter
		private Fstp fstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Fftopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFstmod().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstmod().setBedgrpHolder(()->this.getBedgrp());
           this.getFstp().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstp().setBedgrpHolder(()->this.getBedgrp());
           this.getMtabut().setRecHolder(()->this.getFsdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FF"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.invamt");}
 				public void setValue(BigDecimal arg){Fftopn.this.getFsdgrp().getRec().setInvamt(arg);}
 				public BigDecimal getValue(){return Fftopn.this.getFsdgrp().getRec().getInvamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.bchcod");}
 				public void setValue(String arg){Fftopn.this.getFsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fftopn.this.getFsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.invcur");}
 				public void setValue(String arg){Fftopn.this.getFsdgrp().getRec().setInvcur(arg);}
 				public String getValue(){return Fftopn.this.getFsdgrp().getRec().getInvcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.inr");}
 				public void setValue(String arg){Fftopn.this.getFsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fftopn.this.getFsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.ownref");}
 				public void setValue(String arg){Fftopn.this.getFsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fftopn.this.getFsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("fsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fftopn.this.getFsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fftopn.this.getFsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fftopn.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Fftopn.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fftopn.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:fftopn.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getFsdgrp())&&ctx.checkAll(this.getBedgrp())))
			  return false;

			BigDecimal iss = MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getIssamt(),"#0.00"));
			BigDecimal acp= MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getAcpamt(),"#0.00"));
			this.getBedgrp().getRec().setIssamt(iss);
			this.getBedgrp().getRec().setAcpamt(acp);
			/**
			  if(!fxyctr())
			  {
			  if(Platform.prompt(#CT000034,#CT000035))
			  return false ;
			  }
			  **/
			log.debug("{}","rgtclu:" + this.getFsdgrp().getRec().getRgtclu());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getFsdgrp().getRec());
			  String objinr = this.getFsdgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getFsdgrp().getAcb().getPts(),objinr);
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getBedgrp().getRec().getInr()))
			  {
			    this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			    ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());
			  }
			  this.getFsdgrp().getRec().setInr(Platform.sdbCounter("fsd"));
			  this.getFsdgrp().getRec().setPnttyp( "bed");
			  this.getFsdgrp().getRec().setPntinr( this.getBedgrp().getRec().getInr());
			  this.getFsdgrp().getRec().setPntref( this.getBedgrp().getRec().getStlref());
			  this.getFsdgrp().getRec().setFincur(this.getBedgrp().getRec().getAcpcur());
			  this.getFsdgrp().getRec().setFinamt(this.getBedgrp().getRec().getAcpamt());
			  if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getInvcur())||MdaUtils.isEmpty(this.getFsdgrp().getRec().getInvamt()))
			  {
			    ctx.setMessage("提示","融资币种,金额不能为空！");
			    return false;
			  }
			  ctx.getDaoSession().dbInsert(this.getFsdgrp().getRec());
			  String objinr = this.getFsdgrp().getRec().getInr();
			  String objtyp = "fsd";
			  //isb
			  this.getFsdgrp().getIsb().savpts(objinr,objtyp);
			  //acp
			  this.getFsdgrp().getAcb().savpts(objinr,objtyp);
			  //直接申请人
			  this.getFsdgrp().getDap().getPts().setInr( Platform.sdbCounter("pts"));
			  this.getFsdgrp().getDap().getPts().setObjinr( objinr);
			  this.getFsdgrp().getDap().getPts().setObjtyp( objtyp);
			  ctx.getDaoSession().dbInsert(this.getFsdgrp().getDap().getPts());
			}
			if(!MdaUtils.isEmpty(this.getFsdgrp().getIsb().getPts().getRef()))
			{
			  this.getFstp().setYwlx("BED");
			}
			else
			{
			  this.getFstp().setYwlx(NULLSTR);
			}
			this.dealPDFData();
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			
			log.debug("{}","rgtclu:" + this.getFsdgrp().getRec().getRgtclu());
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:fftopn.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            

			// 特殊字段处理
			this.dealPDFData();

			IStream stream=this.getMtabut().getApldoc();
			String pdfName = "" ;
			// 非信用证
			if("2".equals(this.getFsdgrp().getRec().getFsddocflg()))
			{
			  pdfName = "fftopn1" ;
			}
			else
			{
			  // 信用证
			  pdfName ="fftopn";
			}
			//$\\sysmod.generatorPdf("",pdfName,stream,false );
			this.getFstp().getPdfviw().callPDFComponent("",pdfName,"福费廷申请书",1);

			return true;
        }

        /**
        *   source:fftopn.@0016.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "申请书";
			String tempfiles;
			// 非信用证
			//if("2".equals($fsdgrp\\rec\\fsddocflg.getValue()))
			if("2".equals(this.getFsdgrp().getRec().getLctyp()))
			{
			  tempfiles = "A:fftopn1" ;
			}
			else
			{
			  // 信用证
			  tempfiles ="A:fftopn";
			}
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:fftopn.@0017.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			// 特殊字段处理
			this.dealPDFData();
			BigDecimal iss = MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getIssamt(),"#0.00"));
			BigDecimal acp= MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getAcpamt(),"#0.00"));
			this.getBedgrp().getRec().setIssamt(iss);
			this.getBedgrp().getRec().setAcpamt(acp);
			
			

			//IStream stream=$mtabut\\apldoc.getValue();
			String pdfName = "" ;
			// 非信用证
			//if("2".equals($fsdgrp\\rec\\fsddocflg.getValue()))
			if("2".equals(this.getFsdgrp().getRec().getLctyp()))
			{
			  pdfName = "fftopn1" ;
			}
			else
			{
			  // 信用证
			  pdfName ="fftopn";
			}
			//$\\sysmod.generatorPdf("",pdfName,stream,false );
			this.getFstp().getPdfviw().callPDFComponent("",pdfName,"福费廷申请书",1);

			return true;
        }


        /**
        *   source:fftopn.@0010.script
        */
        @Check(target="fsdgrp.rec.conref",order=100)
        public boolean checkFsdgrpRecConrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if( !Platform.isEmpty( $fsdgrp\\rec\\conref))
			  Platform.error($fsdgrp\\rec\\conref,#CT000019);
			  */

			return true;
        }

        /**
        *   source:fftopn.@0015.script
        */
        @Check(target="fsdgrp.rec.rgtclu",order=100)
        public boolean checkFsdgrpRecRgtcluN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","chech rgtclu ..."  );
			log.debug("{}","rgtclu:" + this.getFsdgrp().getRec().getRgtclu());
			

			return true;
        }

        /**
        *   source:fftopn.@0021.script
        */
        @Check(target="fstp.bedgrp.rec.issamt",order=100)
        public boolean checkFstpBedgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getFstp().getBedgrp().getRec(),"issamt"));

			return true;
        }

        /**
        *   source:fftopn.@0022.script
        */
        @Check(target="fstp.bedgrp.rec.acpamt",order=100)
        public boolean checkFstpBedgrpRecAcpamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getFstp().getBedgrp().getRec(),"acpamt"));

			return true;
        }

        /**
        *   source:fftopn.@0023.script
        */
        @Check(target="fstp.fsdgrp.rec.invamt",order=100)
        public boolean checkFstpFsdgrpRecInvamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getFstp().getFsdgrp().getRec(),"invamt"));

			return true;
        }

        /**
        *   source:fftopn.@0024.script
        */
        @Check(target="fstp.fsdgrp.rec.ratcal",order=100)
        public boolean checkFstpFsdgrpRecRatcalN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getFstp().getFsdgrp().getRec(),"ratcal"));

			return true;
        }

        /**
        *   source:fftopn.@0025.script
        */
        @Check(target="fstp.fsdgrp.rec.bearper",order=100)
        public boolean checkFstpFsdgrpRecBearperN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getFstp().getFsdgrp().getRec(),"bearper"));

			return true;
        }

        /**
        *   source:fftopn.@0026.script
        */
        @Check(target="fstp.fsdgrp.rec.othins",order=100)
        public boolean checkFstpFsdgrpRecOthinsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getFstp().getFsdgrp().getRec(),"othins"));

			return true;
        }


        /**
        *   source:fftopn.@0000.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getFsdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getFsdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  ctx.absGet(Trnmod.class).ordNew();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return false;

			//Platform.setRequired($lidgrp\\ben\\pts\\extkey);
			
			

			
			this.getFsdgrp().getRec().setLctyp("1");
			
			this.getFsdgrp().getRec().setCredat(MdaUtils.today());
			IModule bed = (IModule)ctx.restoreData("com.brilliance.fftopn.ref");
			if(!MdaUtils.isEmpty(bed))
			{
			  this.getBedgrp().getRec().copyValue(bed);
			  if(MdaUtils.isEmpty(this.getBedgrp().getRec().getAcpcur()))
			    this.getBedgrp().getRec().setAcpcur(this.getBedgrp().getRec().getDoccur());
			  if(MdaUtils.isEmpty(this.getBedgrp().getRec().getAcpamt()))
			    this.getBedgrp().getRec().setAcpamt(this.getBedgrp().getRec().getDocamt());
			  ctx.getDaoSession().dbRead(this.getFsdgrp().getIsb().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","isb"));
			  ctx.getDaoSession().dbRead(this.getFsdgrp().getAcb().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","acb"));
			}
			else
			{
			  this.getBedgrp().getRec().setIsscur("USD");
			  this.getBedgrp().getRec().setAcpcur("USD");
			}
			if(MdaUtils.isEmpty(this.getFsdgrp().getIsb().getPts().getRef()))
			  this.getFsdgrp().getIsb().getPts().setRef(this.getBedgrp().getRec().getPntref());
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getIsscur()))
			  this.getBedgrp().getRec().setIsscur(this.getBedgrp().getRec().getDoccur());
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getIssamt()))
			  this.getBedgrp().getRec().setIssamt(this.getBedgrp().getRec().getDocamt());
			this.getFsdgrp().getRec().setFintyp("1");
			this.getBedgrp().setAplnam(this.getSysmod().getPty().getNam());
			this.getFstp().getRgtclu().setClstyp("fftopn");
			if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getRgtclu()))
			{
			  //Platform.dbRead($fstp\\rgtclu\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fftopn"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFstp().getRgtclu().getCls(),new Argument<String>("inr",this.getFstp().getRgtclu().readDefaultClsInr("fftopn")));
			  this.getFsdgrp().getRec().setRgtclu(this.getFstp().getRgtclu().getCls().getClstxt());
			}

			String seltyp = (String)ctx.restoreData("com.brilliance.fftopn0.seltyp");
			//业务类型 默认为信用证下
			this.getFstp().setYwlx("BED");
			
			if(!MdaUtils.isEmpty(seltyp))
			{
			  this.getFsdgrp().getRec().setFsddocflg(seltyp);
			  if("1".equals(seltyp))
			  {
			    //信用证下 BED，非信用证下 空
			    this.getFstp().setYwlx("BED");
			    
			    log.debug("{}","fftopn.init.seltyp1,ywlx:" + this.getFstp().getYwlx());

			    
			    

			    
			    
			    
			  }
			  else if( "2".equals(seltyp))
			  {
			    //信用证下 BED，非信用证下 空
			    this.getFstp().setYwlx("");
			    
			    log.debug("{}","fftopn.init.seltyp1,ywlx: !");

			    
			    
			    
			    
			    
			    

			  }
			}
			if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getOthins()))
			  this.getFsdgrp().getRec().setOthins(0);


			return true;
        }

        /**
        *   source:fftopn.@0003.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			//Platform.invisible($fsdgrp\\rec\\conref);
			

			//Platform.setModified($fsdgrp\\rec\\conref);
			


			return true;
        }

        /**
        *   source:fftopn.@0012.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T")))
			{
			  if(this.fxySigned())
			  {
			    ctx.setMessage(MdaUtils.getI18NString("fftopn","CT000041"),MdaUtils.getI18NString("fftopn","CT000042"));
			    
			    return false;
			  }
			}

			return true;
        }


        /**
        *   source:fftopn.@0011.script
        */
        public boolean fxyctr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select count(inr) cnt from fxy where ptyinr='"+this.getSysmod().getPty().getInr()+"' and bchcod='"+this.getFsdgrp().getRec().getBchcod()+"' and yxqqsr <=? and yxqzzr>=? ";
			log.debug("{}","sql-"+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getFsdgrp().getRec().getCredat(),LT),MdaUtils.sqlDate(this.getFsdgrp().getRec().getCredat(),GT));
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			ctx.getDaoSession().dbCloseCursor();
			if(cnt.value==1)
			{
			  return true;
			}
			else
			{
			  log.debug("{}","fxyctr-false-cnt="+cnt.value);
			  return false;
			}
		}
        /**
        *   source:fftopn.@0013.script
        */
        public boolean fxySigned()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getFsdgrp().getFxylst());
			String whsql =  " where ptyinr = ? and yxqqsr is null and yxqzzr is null ";
			ctx.getDaoSession().dbReadset(this.getFsdgrp().getFxylst(),whsql,this.getSysmod().getPty().getInr());
			int size = this.getFsdgrp().getFxylst().size();
			if(size >0)
			  return true;
			Date dat = new Date();
			ctx.getDaoSession().dbReadset(this.getFsdgrp().getFxylst(),new Argument("ptyinr",EQ,this.getSysmod().getPty().getInr()).and(new Argument("yxqqsr",LE,dat)).and(new Argument("yxqzzr",GE,dat)));
			size = this.getFsdgrp().getFxylst().size();
			if(size >0)
			  return true;
			return false;
		}
        /**
        *   source:fftopn.@0014.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 公共方法，在具体生成PDF模板
			
			//设置1：原币入账账号2：结汇入账账号
			if("1".equals(this.getFsdgrp().getRec().getFintyp()))
			{
			  this.getFstp().setAccno1(this.getFsdgrp().getRec().getAccno());
			  this.getFstp().setAccno2(NULLSTR);
			  
			}
			else
			{
			  this.getFstp().setAccno2(this.getFsdgrp().getRec().getAccno());
			  this.getFstp().setAccno1(NULLSTR);
			  
			}

		}









}