package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FncadvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Fncmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Fncp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 贸易融资杂项通知
*/
@Transaction(vo= FncadvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fncadv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fncadv.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Fncmod fncmod;

		@BDGetter
		private Fncp fncp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fncadv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFncmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getFncmod().setBpdgrpHolder(()->this.getBpdgrp());
           this.getFncp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getFncp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("ZX"));
        }



        /**
        *   source:fncadv.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("fnctyp"));
			
			
			
			
			
			
			
			
			//
			this.getTrnmod().noticeAck(this.getFncp().getFncp02());

			return true;
        }











}