package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FncfreVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Fncmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Fncp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口押汇杂项申请
*/
@Transaction(vo= FncfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fncfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fncfre.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Fncmod fncmod;

		@BDGetter
		private Fncp fncp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fncfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFncmod().setBpdgrpHolder(()->this.getBpdgrp());
           this.getFncmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getFncp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getFncp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("bpdgrp.rec.stlref");}
 				public void setValue(String arg){Fncfre.this.getBpdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fncfre.this.getBpdgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fncfre.this.getFieldPath("bpdgrp.rec.fftamt");}
 				public void setValue(BigDecimal arg){Fncfre.this.getBpdgrp().getRec().setFftamt(arg);}
 				public BigDecimal getValue(){return Fncfre.this.getBpdgrp().getRec().getFftamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Fncfre.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fncfre.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("bpdgrp.rec.fftcur");}
 				public void setValue(String arg){Fncfre.this.getBpdgrp().getRec().setFftcur(arg);}
 				public String getValue(){return Fncfre.this.getBpdgrp().getRec().getFftcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Fncfre.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fncfre.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Fncfre.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fncfre.this.getBpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fncfre.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fncfre.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fncfre.this.getBpdgrp().getRec().getPtyinr();}}
			 );
           this.getMtabut().setRecHolder(()->this.getBpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("ZX"));
        }

        /**
        *   source:fncfre.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getBpdgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftamt()))
			{
			  BigDecimal fftamt=MdaUtils.parseDecimal(MdaUtils.format(this.getBpdgrp().getRec().getFftamt(),"#0.00"));
			  this.getBpdgrp().getRec().setFftamt(fftamt);
			}

			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getInr()))
			{
			  this.getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			  this.getBpdgrp().getRec().setFlg("3");
			  ctx.getDaoSession().dbInsert(this.getBpdgrp().getRec());
			}
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp( "bpd");
			this.getAfdgrp().getRec().setObjinr( this.getBpdgrp().getRec().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			String objinr = this.getBpdgrp().getRec().getInr();
			String objtyp = "bpd";
			//apl
			this.getBpdgrp().getApl().savRolPts(objinr,objtyp,"apl");
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:fncfre.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","fncfre",stream,false );

			return true;
        }

        /**
        *   source:fncfre.@0003.script
        */
        @Rule(target="afdgrp.rec.oprtyp",order=100)
        public boolean ruleAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			if("0".equals(oprtyp))
			{
			  
			  //Platform.setNotRequired($bpdgrp\\rec\\fftcur);
			  
			}
			else
			{
			  
			  //Platform.setRequired($bpdgrp\\rec\\fftcur);
			  
			  
			  
			}
			// 杂项申请交易不允许修改申请人信息
			// Platform.setRequired($bpdgrp\\apl\\pts\\adrblk);
			//  Platform.setDescription($bpdgrp\\apl\\pts\\adrblk,#CT000017);
			
			return true;
        }

        /**
        *   source:fncfre.@0005.script
        */
        @Rule(target="mtabut.getref",order=200)
        public boolean ruleMtabutGetrefN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getAfdgrp().getRec().getOwnref()))
			{
			  String prefix = "ZX" + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("ZX"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  this.getAfdgrp().getRec().setOwnref(prefix);
			  
			}

			return true;
        }

        /**
        *   source:fncfre.@0008.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//IStream stream =$mtabut\\apldoc.getValue();
			BigDecimal fftamt=MdaUtils.parseDecimal(MdaUtils.format(this.getBpdgrp().getRec().getFftamt(),"#0.00"));
			this.getBpdgrp().getRec().setFftamt(fftamt);
			
			this.getFncp().getPdfviw().callPDFComponent("","fncfre","出口押汇杂项处理申请书",1);

			return true;
        }

        /**
        *   source:fncfre.@0009.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "出口押汇杂项处理申请书";
			String tempfiles = "A:fncfre";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }



        /**
        *   source:fncfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  ctx.absGet(Trnmod.class).ordNew();
			// List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			// Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("fnctyp"));
			//if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			//  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			
			String flg =null;
			if(MdaUtils.isEmpty(this.getBpdgrp().getFlg()))
			{
			  IModule bpd = (IModule)ctx.restoreData("com.brilliance.fncfre.ref");
			  if(!MdaUtils.isEmpty(bpd))
			  {
			    this.getBpdgrp().getRec().copyValue(bpd);
			    this.getBpdgrp().setFlg("S");// select
			    log.debug("{}","is select");
			  }
			  else
			  {
			    this.getBpdgrp().setFlg("N");// new
			    log.debug("{}","is new");
			  }
			}
			else
			  log.debug("{}","is return "+this.getBpdgrp().getFlg());
			flg = this.getBpdgrp().getFlg();
			if("S".equals(flg))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getApl().getPts(),new Argument<String>("objinr",this.getBpdgrp().getRec().getInr()),new Argument<String>("objtyp","bpd"),new Argument<String>("rol","apl"));
			}
			else
			  
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			if(MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftcur()))
			  this.getBpdgrp().getRec().setFftcur("USD");
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			this.getAfdgrp().getRec().setOprtyp("0");
			this.getBpdgrp().getApl().getPts().setNam(this.getSysmod().getPty().getNam());
			this.getFncp().getRgtclu().setClstyp("fncfre");

			if(!"1".equals(this.getSysmod().getPty().getPtytyp()))
			  this.getBpdgrp().getRec().setOwnref(NULLSTR);

			if(MdaUtils.isEmpty(this.getAfdgrp().getRgtclu()))
			{
			  //Platform.dbRead($fncp\\rgtclu\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fncfre"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFncp().getRgtclu().getCls(),new Argument<String>("inr",this.getFncp().getRgtclu().readDefaultClsInr("fncfre")));
			  this.getAfdgrp().setRgtclu(this.getFncp().getRgtclu().getCls().getClstxt());
			}

			return true;
        }

        /**
        *   source:fncfre.@0006.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getIbchcod()))
			    {
			      this.getAfdgrp().getRec().setBchcod(this.getBpdgrp().getRec().getIbchcod());
			      
			    }
			    else
			    {
			      this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getBpdgrp().getRec().setIbchcod(this.getAfdgrp().getRec().getBchcod());
			      
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getDbchcod()))
			    {
			      this.getAfdgrp().getRec().setBchcod(this.getBpdgrp().getRec().getDbchcod());
			      
			    }
			    else
			      if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getBchcod()))
			    {
			      this.getAfdgrp().getRec().setBchcod(this.getBpdgrp().getRec().getBchcod());
			      
			    }
			    else
			    {
			      this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      
			    }

			  }
			  log.info("{}","bchcod="+this.getBpdgrp().getRec().getBchcod()+",dbchcod="+this.getBpdgrp().getRec().getDbchcod());
			}
			else
			{
			  
			}

			return true;
        }











}