package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FpdsllVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fpdgrp;
import com.ceb.gjjs.mda.manager.module.Fpdp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 即期结汇申请
*/
@Transaction(vo= FpdsllVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fpdsll extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fpdsll.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Fpdgrp fpdgrp;

		@BDGetter
		private Fpdp fpdp;

		@BDGetter
		private Rmkmod rmkmod;


		public Fpdsll()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.outcur");}
 				public void setValue(String arg){Fpdsll.this.getFpdgrp().getRec().setOutcur(arg);}
 				public String getValue(){return Fpdsll.this.getFpdgrp().getRec().getOutcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.outamt");}
 				public void setValue(BigDecimal arg){Fpdsll.this.getFpdgrp().getRec().setOutamt(arg);}
 				public BigDecimal getValue(){return Fpdsll.this.getFpdgrp().getRec().getOutamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.ownref");}
 				public void setValue(String arg){Fpdsll.this.getFpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fpdsll.this.getFpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.bchcod");}
 				public void setValue(String arg){Fpdsll.this.getFpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fpdsll.this.getFpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.objinr");}
 				public void setValue(String arg){Fpdsll.this.getFpdgrp().getRec().setObjinr(arg);}
 				public String getValue(){return Fpdsll.this.getFpdgrp().getRec().getObjinr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fpdsll.this.getFieldPath("fpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fpdsll.this.getFpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fpdsll.this.getFpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getFpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FP"));
           this.getFpdp().setFpdgrpHolder(()->this.getFpdgrp());
        }

        /**
        *   source:fpdsll.@0004.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(ctx.checkAll(this.getFpdgrp())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fpdsll","CT000005"),MdaUtils.getI18NString("fpdsll","CT000006"));
			  return false;
			}
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")||(ctx.absGet(Sysmod.class).sptIsLoaded("T")))
			{
			  ctx.getDaoSession().dbUpdate(this.getFpdgrp().getRec());
			}
			else
			{
			  this.getFpdgrp().getRec().setInr(Platform.sdbCounter("fpd"));
			  ctx.getDaoSession().dbInsert(this.getFpdgrp().getRec());
			  String objinr = this.getFpdgrp().getRec().getInr();
			  String objtyp = "fpd";
			  log.info("{}", "sav200入库结束================" );
			}
			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:fpdsll.@0006.script
        */
        @Rule(target="mtabut.sav",order=220)
        public boolean ruleMtabutSavN220(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "即期结汇申请书";
			String tempfiles = "A:fpdsll";
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:fpdsll.@0007.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFpdp().getPdfviw().callPDFComponent("","fpdsll","即期结汇申请",1);

			return true;
        }


        /**
        *   source:fpdsll.@0001.script
        */
        @Check(target="fpdp.fpdgrp.rec.outcur",order=100)
        public boolean checkFpdpFpdgrpRecOutcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFpdp().getFpdgrp().getRec().getOutcur())&&"CNY".equals(this.getFpdp().getFpdgrp().getRec().getOutcur()))
			{
			  ctx.setFieldError(this,"fpdp.fpdgrp.rec.outcur",MdaUtils.getI18NString("fpdsll","CT000002"));
			  return false;
			}

			return true;
        }

        /**
        *   source:fpdsll.@0008.script
        */
        @Check(target="fpdp.fpdgrp.rec.shbody",order=100)
        public boolean checkFpdpFpdgrpRecShbodyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFpdp().getFpdgrp().getRec().getShbody()))
			{
			  if("1".equals(this.getFpdp().getFpdgrp().getRec().getShbody())||"2".equals(this.getFpdp().getFpdgrp().getRec().getShbody()))
			  {
			    ctx.setFieldError(this,"fpdp.fpdgrp.rec.shbody",MdaUtils.getI18NString("fpdsll","CT000009"));
			    return false;
			  }
			}

			return true;
        }


        /**
        *   source:fpdsll.@0005.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getFpdgrp().getRec(),"bchcod",bchcod);
			this.getFpdgrp().getRec().setOutsel(TRUE);//兼容购汇check rule不报错
			if(MdaUtils.isEmpty(this.getFpdgrp().getRec().getGivnam()))
			  this.getFpdgrp().getRec().setGivnam(ctx.absGet(Sysmod.class).getPty().getNam());

			if(MdaUtils.isEmpty(this.getFpdgrp().getRec().getOprnam()))
			  this.getFpdgrp().getRec().setOprnam(ctx.absGet(Sysmod.class).getUsr().getOprnam());

			if(MdaUtils.isEmpty(this.getFpdgrp().getRec().getTel()))
			{
			  ctx.getDaoSession().dbRead(this.getFpdgrp().getPta(),new Argument<String>("ptyinr",ctx.absGet(Sysmod.class).getPty().getInr()));
			  ctx.getDaoSession().dbRead(this.getFpdgrp().getAdr(),new Argument<String>("inr",this.getFpdgrp().getPta().getObjinr()));
			  this.getFpdgrp().getRec().setTel(this.getFpdgrp().getAdr().getTel());
			}

			
			
			

			this.getFpdgrp().getRec().setCredat(MdaUtils.today());
			if(!MdaUtils.isEmpty(this.getFpdgrp().getRec().getCredat()))
			{
			  
			  
			}

			this.getFpdgrp().getRec().setOthcno(ctx.absGet(Sysmod.class).getPty().getAtccod());
			
			
			

			return true;
        }









}