package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FqtopnVO;

import com.ceb.gjjs.mda.manager.module.Fqdgrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ghtp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 购汇申请
*/
@Transaction(vo= FqtopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fqtopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fqtopn.class);

		@BDGetter
		private Fqdgrp fqdgrp;

		@BDGetter
		private Ghtp ghtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Btnmod btnmod;


		public Fqtopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMtabut().setRecHolder(()->this.getFqdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("GS"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.jioyje");}
 				public void setValue(BigDecimal arg){Fqtopn.this.getFqdgrp().getRec().setJioyje(arg);}
 				public BigDecimal getValue(){return Fqtopn.this.getFqdgrp().getRec().getJioyje();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.bchcod");}
 				public void setValue(String arg){Fqtopn.this.getFqdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fqtopn.this.getFqdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.currency");}
 				public void setValue(String arg){Fqtopn.this.getFqdgrp().getRec().setCurrency(arg);}
 				public String getValue(){return Fqtopn.this.getFqdgrp().getRec().getCurrency();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.inr");}
 				public void setValue(String arg){Fqtopn.this.getFqdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fqtopn.this.getFqdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.businessno");}
 				public void setValue(String arg){Fqtopn.this.getFqdgrp().getRec().setBusinessno(arg);}
 				public String getValue(){return Fqtopn.this.getFqdgrp().getRec().getBusinessno();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fqtopn.this.getFieldPath("fqdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fqtopn.this.getFqdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fqtopn.this.getFqdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }












}