package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FstmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fsdgrp;
import com.ceb.gjjs.mda.manager.module.Fstp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷申请书模板推送交易
*/
@Transaction(vo= FstmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fstmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fstmdl.class);

		@BDGetter
		private Fsdgrp fsdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Fstp fstp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fstmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFstp().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstp().setBedgrpHolder(()->this.getBedgrp());
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fstmdl.this.getFieldPath("fsdgrp.rec.inr");}
 				public void setValue(String arg){Fstmdl.this.getFsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fstmdl.this.getFsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fstmdl.this.getFieldPath("fsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fstmdl.this.getFsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fstmdl.this.getFsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fstmdl.this.getFieldPath("fsdgrp.rec.stlref");}
 				public void setValue(String arg){Fstmdl.this.getFsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fstmdl.this.getFsdgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fstmdl.this.getFieldPath("bedgrp.rec.isscur");}
 				public void setValue(String arg){Fstmdl.this.getBedgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Fstmdl.this.getBedgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fstmdl.this.getFieldPath("bedgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Fstmdl.this.getBedgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Fstmdl.this.getBedgrp().getRec().getIssamt();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFsdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:fstmdl.@0000.script
        */
        @Rule(target="fstp.select",order=100)
        public boolean ruleFstpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getFstp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("fstmdl","CT000000"),MdaUtils.getI18NString("fstmdl","CT000001"));
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getFstp().getCidmod().getClipty(),new Argument("cid",this.getFstp().getCidmod().getClilst().getElement(index).getCid()));
			  this.getFstp().getBummod().getWrkmdl().setCidinr(this.getFstp().getCidmod().getClipty().getCid());
			  
			}


			return true;
        }

        /**
        *   source:fstmdl.@0009.script
        */
        @Rule(target="fstp.actselect",order=100)
        public boolean ruleFstpActselectN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().popupActchs();

			return true;
        }

        /**
        *   source:fstmdl.@0010.script
        */
        @Rule(target="fstp.actcancel",order=100)
        public boolean ruleFstpActcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:fstmdl.@0011.script
        */
        @Rule(target="fstp.actselect1",order=100)
        public boolean ruleFstpActselect1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().popupActchs();

			return true;
        }

        /**
        *   source:fstmdl.@0012.script
        */
        @Rule(target="fstp.actsure",order=100)
        public boolean ruleFstpActsureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getFstp().getActlst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fstmdl","CT000010"),MdaUtils.getI18NString("fstmdl","CT000011"));
			  return true;
			}
			if("2".equals(this.getFsdgrp().getRec().getEnttyp()))
			{
			  this.getFsdgrp().getRec().setOrigno(this.getFstp().getActlst().getElement(index).getAct());
			}
			else if("1".equals(this.getFsdgrp().getRec().getEnttyp()))
			{
			  this.getFsdgrp().getRec().setSoexno(this.getFstp().getActlst().getElement(index).getAct());
			}
			
			
			

			return true;
        }

        /**
        *   source:fstmdl.@0013.script
        */
        @Rule(target="fstp.fsdgrp.rec.enttyp",order=100)
        public boolean ruleFstpFsdgrpRecEnttypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","STart..................");
			log.info("{}","enttyp.value==========="+this.getFsdgrp().getRec().getEnttyp());
			if(MdaUtils.isEmpty(this.getFsdgrp().getRec().getEnttyp()))
			{
			  
			  
			}
			else
			{
			  if("1".equals(this.getFsdgrp().getRec().getEnttyp()))
			  {
			    log.info("{}","enttyp===========111111111111111");
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    this.getFsdgrp().getRec().setOrigno(NULLSTR);
			    
			    
			    
			    
			  }
			  else if ("2".equals(this.getFsdgrp().getRec().getEnttyp()))
			  {
			    log.info("{}","enttyp===========2222222222222222222");
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    
			    this.getFsdgrp().getRec().setSoexno(NULLSTR);
			    this.getFsdgrp().getRec().setSoedoc(NULLSTR);
			    this.getFsdgrp().getRec().setReason(NULLSTR);
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:fstmdl.@0014.script
        */
        @Rule(target="fstp.fsdgrp.rec.lctyp",order=100)
        public boolean ruleFstpFsdgrpRecLctypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getFstp().getFsdgrp().getRec().getLctyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if("2".equals(this.getFstp().getFsdgrp().getRec().getLctyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:fstmdl.@0021.script
        */
        @Rule(target="fstp.bummod.save",order=100)
        public boolean ruleFstpBummodSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFstp().getBummod().setTmplr(this.getFstp().getFsdgrp().getRec().getLctyp());

			return true;
        }

        /**
        *   source:fstmdl.@0022.script
        */
        @Rule(target="fstp.cidmod.clilst",order=100)
        public boolean ruleFstpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"fstp.select");

			return true;
        }


        /**
        *   source:fstmdl.@0015.script
        */
        @Check(target="fsdgrp.rec.acdamt",order=100)
        public boolean checkFsdgrpRecAcdamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcc().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fstmdl.@0016.script
        */
        @Check(target="fsdgrp.rec.acdcur",order=100)
        public boolean checkFsdgrpRecAcdcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getAcc().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fstmdl.@0017.script
        */
        @Check(target="fsdgrp.rec.conamt",order=100)
        public boolean checkFsdgrpRecConamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getCon().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fstmdl.@0018.script
        */
        @Check(target="fsdgrp.rec.concur",order=100)
        public boolean checkFsdgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getCon().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fstmdl.@0019.script
        */
        @Check(target="fsdgrp.rec.payamt",order=100)
        public boolean checkFsdgrpRecPayamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getPay().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:fstmdl.@0020.script
        */
        @Check(target="fsdgrp.rec.paycur",order=100)
        public boolean checkFsdgrpRecPaycurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getFsdgrp().getPay().getPts().getExtkey()))
			{
			  
			  
			  
			}
			else
			{
			  
			}
			

			return true;
        }


        /**
        *   source:fstmdl.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//为推送交易赋值
			this.getFstp().getBummod().setModtyp("fftapn");
			//  定义步骤条
			this.getFstp().getStpmod().storePanel(this.getFstp().getFstmdl03(),this.getFstp().getFstmdl05());
			String steps = "0:申请书推送模板;1:模板信息";
			this.getFstp().getStpmod().setPages(steps);
			this.getFstp().getStpmod().calcSteps();
			this.getFstp().getStpmod().setStepBtnSta();

			
			
			
			
			
			

			return true;
        }










}