package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FxfbuyVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fctmod;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Fctp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期购汇申请
*/
@Transaction(vo= FxfbuyVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fxfbuy extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fxfbuy.class);

		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Fctmod fctmod;

		@BDGetter
		private Fctp fctp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Fxfbuy()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFctmod().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setChkdocflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.chkdocflg");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setChkdocflg(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getChkdocflg();}}
			 );
           this.getFctp().setFxclsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.fxcls");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setFxcls(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getFxcls();}}
			 );
           this.getFctp().setToHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.to");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setTo(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getTo();}}
			 );
           this.getFctp().setImpdflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.impdflg");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setImpdflg(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getImpdflg();}}
			 );
           this.getFctp().setBelgfeeHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.belgfee");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setBelgfee(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getBelgfee();}}
			 );
           this.getFctp().setTrnitsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.trnits");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setTrnits(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getTrnits();}}
			 );
           this.getFctp().setPurothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.puroth");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPuroth(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPuroth();}}
			 );
           this.getFctp().setPaybylcHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybylc");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybylc(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybylc();}}
			 );
           this.getFctp().setPaybylcrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybylcref");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybylcref(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybylcref();}}
			 );
           this.getFctp().setPaybycolHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybycol");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybycol(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybycol();}}
			 );
           this.getFctp().setPaybyforactHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybyforact");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybyforact(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybyforact();}}
			 );
           this.getFctp().setPaybyremHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybyrem");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybyrem(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybyrem();}}
			 );
           this.getFctp().setPaybyremtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybyremtyp");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybyremtyp(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybyremtyp();}}
			 );
           this.getFctp().setPaybyremtypothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybyremtypoth");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybyremtypoth(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybyremtypoth();}}
			 );
           this.getFctp().setPaybyothflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.paybyothflg");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPaybyothflg(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPaybyothflg();}}
			 );
           this.getFctp().setPwtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.fxicnd.pwtyp");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getFxicnd().setPwtyp(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getFxicnd().getPwtyp();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FU"));
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.ownref");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.inr");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.acccur");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setAcccur(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getAcccur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.bchcod");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.accamt");}
 				public void setValue(BigDecimal arg){Fxfbuy.this.getFcdgrp().getRec().setAccamt(arg);}
 				public BigDecimal getValue(){return Fxfbuy.this.getFcdgrp().getRec().getAccamt();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxfbuy.this.getFieldPath("fcdgrp.rec.stlref");}
 				public void setValue(String arg){Fxfbuy.this.getFcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fxfbuy.this.getFcdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:fxfbuy.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getFcdgrp()))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getFcdgrp().getRec());
			else
			{
			  this.getFcdgrp().getRec().setInr(Platform.sdbCounter("fcd"));
			  this.getFcdgrp().getRec().setTrndir("1");
			  this.getFcdgrp().getRec().setCur("CNY");
			  this.getFcdgrp().getRec().setActdat(this.getFcdgrp().getRec().getBegactday());
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getRec());
			  String objinr = this.getFcdgrp().getRec().getInr();
			  String objtyp = "fcd";
			  //申请人
			  this.getFcdgrp().getApl().savpts(objinr,objtyp);
			  //直接申请人
			  this.getFcdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getFcdgrp().getDap().getPts().setObjinr(objinr);
			  this.getFcdgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getDap().getPts());
			  //商行存转递申请人
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getFcdgrp().getTrp().savTrp("fcd",objinr);
			  }
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:fxfbuy.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","fxfbuy",stream,false );

			return true;
        }

        /**
        *   source:fxfbuy.@0006.script
        */
        @Rule(target="fcdgrp.apl.pts.nam",order=100)
        public boolean ruleFcdgrpAplPtsNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isModified(this.getFcdgrp().getDap().getPts(),"nam"))
			  this.getFcdgrp().getApl().getPts().setNam(this.getFcdgrp().getDap().getPts().getNam());

			return true;
        }

        /**
        *   source:fxfbuy.@0007.script
        */
        @Rule(target="fcdgrp.rec.trdtyp",order=100)
        public boolean ruleFcdgrpRecTrdtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String trdtyp = this.getFcdgrp().getRec().getTrdtyp();
			if("1".equals(trdtyp))
			{
			  // 非择期交易
			  
			  
			  
			  this.getFcdgrp().getRec().setCnvdat(null);
			  this.getFcdgrp().getRec().setEndactday(null);
			  
			  
			}
			else if("2".equals(trdtyp))
			{
			  //择期交易
			  
			  
			  
			  this.getFcdgrp().getRec().setBegactday(null);
			  
			}


			return true;
        }

        /**
        *   source:fxfbuy.@0008.script
        */
        @Rule(target="fctp.pwtyp",order=100)
        public boolean ruleFctpPwtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getFctp().getPwtyp()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:fxfbuy.@0009.script
        */
        @Rule(target="fcdgrp.rec.ofcialdocflg",order=100)
        public boolean ruleFcdgrpRecOfcialdocflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getFcdgrp().getRec().getOfcialdocflg()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:fxfbuy.@0010.script
        */
        @Rule(target="fctp.puroth",order=100)
        public boolean ruleFctpPurothN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getFctp().getPuroth()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }


        /**
        *   source:fxfbuy.@0011.script
        */
        @Check(target="fcdgrp.rec.trddat",order=100)
        public boolean checkFcdgrpRecTrddatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getFcdgrp().getRec().getTrddat()))
			  return true;
			Date trddat = this.getFcdgrp().getRec().getTrddat();
			if(!MdaUtils.isEmpty(this.getFcdgrp().getRec().getBegactday()) && MdaUtils.diff(trddat,this.getFcdgrp().getRec().getBegactday())>0)
			  ctx.setFieldError(this,"fcdgrp.rec.trddat",MdaUtils.getI18NString("fxfbuy","CT000043"));
			else if(MdaUtils.diff(trddat,this.getFcdgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"fcdgrp.rec.trddat",MdaUtils.getI18NString("fxfbuy","CT000044"));

			return true;
        }

        /**
        *   source:fxfbuy.@0012.script
        */
        @Check(target="fcdgrp.rec.lmudat",order=100)
        public boolean checkFcdgrpRecLmudatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getFcdgrp().getRec().getLmudat()))
			  return true;
			Date lmudat = this.getFcdgrp().getRec().getLmudat();
			if(!MdaUtils.isEmpty(this.getFcdgrp().getRec().getBegactday()) && MdaUtils.diff(lmudat,this.getFcdgrp().getRec().getBegactday())<0)
			  ctx.setFieldError(this,"fcdgrp.rec.lmudat",MdaUtils.getI18NString("fxfbuy","CT000046"));

			return true;
        }


        /**
        *   source:fxfbuy.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  ctx.absGet(Trnmod.class).ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getFcdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getFcdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			log.info("{}","BrandNew==init==============");
			this.getFcdgrp().getDap().initDap("fcd");
			this.getFcdgrp().getApl().copyValues(this.getFcdgrp().getDap());
			this.getFcdgrp().getRec().setCredat(MdaUtils.today());
			
			
			this.getFcdgrp().getRec().setFxflg("1");
			this.getFcdgrp().getRec().setTrdtyp("1");
			
			
			this.getFcdgrp().getRec().setAcccur("USD");
			this.getFcdgrp().getRec().setConcur("USD");
			this.getFcdgrp().getRec().setInvcur("USD");
			
			this.getFcdgrp().getRec().setOfcialdocflg("1");
			this.getFctp().setPwtyp("1");
			this.getFctp().setImpdflg(TRUE);
			
			
			//$fcdgrp\\rec\\aplcnd.setValue(#CT000042);
			this.getFctp().getAplcnd().setClstyp("fxfbuy");
			if(MdaUtils.isEmpty(this.getFcdgrp().getRec().getAplcnd()))
			{
			  //Platform.dbRead($fctp\\aplcnd\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fxfbuy"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFctp().getAplcnd().getCls(),new Argument<String>("inr",this.getFctp().getAplcnd().readDefaultClsInr("fxfbuy")));
			  this.getFcdgrp().getRec().setAplcnd(this.getFctp().getAplcnd().getCls().getClstxt());
			}

			return true;
        }










}