package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FxffdvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fctmod;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Fctp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 外汇买卖杂项通知
*/
@Transaction(vo= FxffdvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fxffdv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fxffdv.class);

		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Fctmod fctmod;

		@BDGetter
		private Fctp fctp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fxffdv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFctmod().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setChkdocflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.chkdocflg");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setChkdocflg(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getChkdocflg();}}
			 );
           this.getFctp().setToHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.to");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setTo(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getTo();}}
			 );
           this.getFctp().setImpdflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.impdflg");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setImpdflg(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getImpdflg();}}
			 );
           this.getFctp().setBelgfeeHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.belgfee");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setBelgfee(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getBelgfee();}}
			 );
           this.getFctp().setTrnitsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.trnits");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setTrnits(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getTrnits();}}
			 );
           this.getFctp().setPurothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.puroth");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPuroth(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPuroth();}}
			 );
           this.getFctp().setPaybylcHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybylc");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybylc(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybylc();}}
			 );
           this.getFctp().setPaybylcrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybylcref");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybylcref(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybylcref();}}
			 );
           this.getFctp().setPaybycolHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybycol");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybycol(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybycol();}}
			 );
           this.getFctp().setPaybyforactHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybyforact");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybyforact(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybyforact();}}
			 );
           this.getFctp().setPaybyremHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybyrem");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybyrem(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybyrem();}}
			 );
           this.getFctp().setPaybyremtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybyremtyp");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybyremtyp(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybyremtyp();}}
			 );
           this.getFctp().setPaybyremtypothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybyremtypoth");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybyremtypoth(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybyremtypoth();}}
			 );
           this.getFctp().setPaybyothflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.paybyothflg");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPaybyothflg(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPaybyothflg();}}
			 );
           this.getFctp().setPwtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.pwtyp");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setPwtyp(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getPwtyp();}}
			 );
           this.getFctp().setFxclsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.fxicnd.fxcls");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getFxicnd().setFxcls(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getFxicnd().getFxcls();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.accamt");}
 				public void setValue(BigDecimal arg){Fxffdv.this.getFcdgrp().getRec().setAccamt(arg);}
 				public BigDecimal getValue(){return Fxffdv.this.getFcdgrp().getRec().getAccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.bchcod");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.acccur");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setAcccur(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getAcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.inr");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.ownref");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxffdv.this.getFieldPath("fcdgrp.rec.stlref");}
 				public void setValue(String arg){Fxffdv.this.getFcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fxffdv.this.getFcdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }



        /**
        *   source:fxffdv.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			//Platform.disable($fcdgrp\\rec\\conno);
			
			
			this.getTrnmod().noticeAck(this.getFctp().getFctp12());

			return true;
        }










}