package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FxisllVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fctmod;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Fctp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 即期结汇申请
*/
@Transaction(vo= FxisllVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fxisll extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fxisll.class);

        //交易方向
        private String jyfx;
		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Fctmod fctmod;

		@BDGetter
		private Fctp fctp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Fxisll()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFctmod().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setChkdocflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.chkdocflg");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setChkdocflg(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getChkdocflg();}}
			 );
           this.getFctp().setFxclsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.fxcls");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setFxcls(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getFxcls();}}
			 );
           this.getFctp().setToHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.to");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setTo(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getTo();}}
			 );
           this.getFctp().setImpdflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.impdflg");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setImpdflg(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getImpdflg();}}
			 );
           this.getFctp().setBelgfeeHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.belgfee");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setBelgfee(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getBelgfee();}}
			 );
           this.getFctp().setTrnitsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.trnits");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setTrnits(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getTrnits();}}
			 );
           this.getFctp().setPurothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.puroth");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPuroth(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPuroth();}}
			 );
           this.getFctp().setPaybylcHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybylc");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybylc(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybylc();}}
			 );
           this.getFctp().setPaybylcrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybylcref");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybylcref(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybylcref();}}
			 );
           this.getFctp().setPaybycolHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybycol");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybycol(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybycol();}}
			 );
           this.getFctp().setPaybyforactHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybyforact");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybyforact(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybyforact();}}
			 );
           this.getFctp().setPaybyremHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybyrem");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybyrem(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybyrem();}}
			 );
           this.getFctp().setPaybyremtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybyremtyp");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybyremtyp(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybyremtyp();}}
			 );
           this.getFctp().setPaybyremtypothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybyremtypoth");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybyremtypoth(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybyremtypoth();}}
			 );
           this.getFctp().setPaybyothflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.paybyothflg");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPaybyothflg(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPaybyothflg();}}
			 );
           this.getFctp().setPwtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.fxicnd.pwtyp");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getFxicnd().setPwtyp(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getFxicnd().getPwtyp();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FS"));
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.ownref");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.inr");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.acccur");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setAcccur(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getAcccur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.bchcod");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.accamt");}
 				public void setValue(BigDecimal arg){Fxisll.this.getFcdgrp().getRec().setAccamt(arg);}
 				public BigDecimal getValue(){return Fxisll.this.getFcdgrp().getRec().getAccamt();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxisll.this.getFieldPath("fcdgrp.rec.stlref");}
 				public void setValue(String arg){Fxisll.this.getFcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fxisll.this.getFcdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:fxisll.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getFcdgrp()))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getFcdgrp().getRec());
			else
			{
			  this.getFcdgrp().getRec().setInr(Platform.sdbCounter("fcd"));
			  if(TRUE.equals(this.getFctp().getChkdocflg()))
			    this.getFcdgrp().getRec().setDoclst(MdaUtils.getI18NString("fxisll","CT000000") + CR +this.getFcdgrp().getRec().getDoclst());
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getRec());
			  String objinr = this.getFcdgrp().getRec().getInr();
			  String objtyp = "fcd";
			  //申请人
			  this.getFcdgrp().getApl().savpts(objinr,objtyp);
			  //直接申请人
			  this.getFcdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getFcdgrp().getDap().getPts().setObjtyp(objtyp);
			  this.getFcdgrp().getDap().getPts().setObjinr(objinr);
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getDap().getPts());
			  //商行要存转递申请人
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getFcdgrp().getTrp().savTrp(objtyp,objinr);
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:fxisll.@0002.script
        */
        @Rule(target="fcdgrp.apl.pts.nam",order=100)
        public boolean ruleFcdgrpAplPtsNamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isModified(this.getFcdgrp().getDap().getPts(),"nam"))
			{
			  this.getFcdgrp().getApl().getPts().setNam(this.getFcdgrp().getDap().getPts().getNam());
			}

			return true;
        }

        /**
        *   source:fxisll.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","fxisll",stream,false );

			return true;
        }

        /**
        *   source:fxisll.@0005.script
        */
        @Rule(target="fctp.forbut",order=100)
        public boolean ruleFctpForbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFctp().setActchsflg( "for");
			String cur = this.getFcdgrp().getRec().getAcccur();
			this.getFctp().popupActchs(cur);
			

			return true;
        }

        /**
        *   source:fxisll.@0006.script
        */
        @Rule(target="fctp.rmbbut",order=100)
        public boolean ruleFctpRmbbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFctp().setActchsflg( "rmb");
			this.getFctp().popupActchs("CNY");
			

			return true;
        }

        /**
        *   source:fxisll.@0007.script
        */
        @Rule(target="fctp.sursel",order=100)
        public boolean ruleFctpSurselN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getFctp().getActlst().fullSize();
			log.debug("{}","message len = "+len);
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("fxisll","CT000031"),MdaUtils.getI18NString("fxisll","CT000032"));
			  return true;
			}
			if("for".equals(this.getFctp().getActchsflg()))
			{
			  log.debug("{}","message in for");
			  this.getFctp().getFcdgrp().getRec().setForact(this.getFctp().getActlst().getElement(index).getAct());
			  
			}
			else if("rmb".equals(this.getFctp().getActchsflg()))
			{
			  log.debug("{}","message in rmb");
			  this.getFctp().getFcdgrp().getRec().setRmbact(this.getFctp().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:fxisll.@0008.script
        */
        @Rule(target="fctp.cancel",order=100)
        public boolean ruleFctpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:fxisll.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setJyfx("0");
			
			log.debug("{}","jyfx========="+this.getJyfx());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  ctx.absGet(Trnmod.class).ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getFcdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getFcdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return true;
			this.getFcdgrp().getDap().initDap("fcd");
			this.getFcdgrp().getApl().copyValues(this.getFcdgrp().getDap());
			
			this.getFcdgrp().getRec().setCredat(MdaUtils.today());
			this.getFcdgrp().getRec().setFxflg("0");
			
			this.getFcdgrp().getRec().setAcccur("USD");
			this.getFctp().getAplcnd().setClstyp("fxisll");
			if(MdaUtils.isEmpty(this.getFcdgrp().getRec().getAplcnd()))
			{
			  //Platform.dbRead($fctp\\aplcnd\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fxisll"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFctp().getAplcnd().getCls(),new Argument<String>("inr",this.getFctp().getAplcnd().readDefaultClsInr("fxisll")));
			  this.getFcdgrp().getRec().setAplcnd(this.getFctp().getAplcnd().getCls().getClstxt());
			}

			return true;
        }











}