package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FxtfreVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fctmod;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Fctp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 外汇买卖杂项申请
*/
@Transaction(vo= FxtfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fxtfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fxtfre.class);

		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Fctmod fctmod;

		@BDGetter
		private Fctp fctp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Fxtfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFctmod().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setChkdocflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.chkdocflg");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setChkdocflg(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getChkdocflg();}}
			 );
           this.getFctp().setToHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.to");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setTo(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getTo();}}
			 );
           this.getFctp().setImpdflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.impdflg");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setImpdflg(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getImpdflg();}}
			 );
           this.getFctp().setBelgfeeHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.belgfee");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setBelgfee(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getBelgfee();}}
			 );
           this.getFctp().setTrnitsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.trnits");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setTrnits(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getTrnits();}}
			 );
           this.getFctp().setPurothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.puroth");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPuroth(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPuroth();}}
			 );
           this.getFctp().setPaybylcHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybylc");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybylc(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybylc();}}
			 );
           this.getFctp().setPaybylcrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybylcref");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybylcref(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybylcref();}}
			 );
           this.getFctp().setPaybycolHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybycol");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybycol(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybycol();}}
			 );
           this.getFctp().setPaybyforactHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybyforact");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybyforact(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybyforact();}}
			 );
           this.getFctp().setPaybyremHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybyrem");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybyrem(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybyrem();}}
			 );
           this.getFctp().setPaybyremtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybyremtyp");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybyremtyp(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybyremtyp();}}
			 );
           this.getFctp().setPaybyremtypothHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybyremtypoth");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybyremtypoth(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybyremtypoth();}}
			 );
           this.getFctp().setPaybyothflgHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.paybyothflg");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPaybyothflg(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPaybyothflg();}}
			 );
           this.getFctp().setPwtypHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.pwtyp");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setPwtyp(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getPwtyp();}}
			 );
           this.getFctp().setFxclsHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.fxicnd.fxcls");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getFxicnd().setFxcls(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getFxicnd().getFxcls();}}
			 );
           this.getMtabut().setRecHolder(()->this.getFcdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FX"));
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.ptyinr");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.ownref");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.inr");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setInr(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.acccur");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setAcccur(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getAcccur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.bchcod");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.accamt");}
 				public void setValue(BigDecimal arg){Fxtfre.this.getFcdgrp().getRec().setAccamt(arg);}
 				public BigDecimal getValue(){return Fxtfre.this.getFcdgrp().getRec().getAccamt();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fxtfre.this.getFieldPath("fcdgrp.rec.stlref");}
 				public void setValue(String arg){Fxtfre.this.getFcdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Fxtfre.this.getFcdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:fxtfre.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","sav200开始================" );
			if(!ctx.checkAll(this.getFcdgrp()))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getFcdgrp().getRec());
			else
			{
			  this.getFcdgrp().getRec().setInr(Platform.sdbCounter("fcd"));
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getRec());
			  String objinr=this.getFcdgrp().getRec().getInr();
			  this.getFcdgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getFcdgrp().getDap().getPts().setObjinr(objinr);
			  this.getFcdgrp().getDap().getPts().setObjtyp("fcd");
			  ctx.getDaoSession().dbInsert(this.getFcdgrp().getDap().getPts());
			  log.info("{}", "sav200入库结束================" );
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:fxtfre.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","fxtfre",stream,false );

			return true;
        }



        /**
        *   source:fxtfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			{
			  this.getTrnmod().ordNew();
			}
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getFcdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getFcdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			this.getFcdgrp().getDap().initDap("fcd");
			this.getFcdgrp().getApl().copyValues(this.getFcdgrp().getDap());
			this.getFcdgrp().getRec().setCredat(MdaUtils.today());
			
			this.getFcdgrp().getRec().setAcccur("USD");
			this.getFcdgrp().getRec().setFxttyp("1");
			this.getFctp().getAplcnd().setClstyp("fxtfre");
			if(MdaUtils.isEmpty(this.getFcdgrp().getRec().getAplcnd()))
			{
			  //Platform.dbRead($fctp\\aplcnd\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","fxtfre"),new Argument<String>("status","0"));
			  ctx.getDaoSession().dbRead(this.getFctp().getAplcnd().getCls(),new Argument<String>("inr",this.getFctp().getAplcnd().readDefaultClsInr("fxtfre")));
			  this.getFcdgrp().getRec().setAplcnd(this.getFctp().getAplcnd().getCls().getClstxt());
			}

			return true;
        }











}