package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FytcfmVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Fytp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fydgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷合同要素修改
*/
@Transaction(vo= FytcfmVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fytcfm extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fytcfm.class);

		@BDGetter
		private Fydgrp fydgrp;

		@BDGetter
		private Fytp fytp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fytcfm()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFytp().setFydgrpHolder(()->this.getFydgrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fytcfm.this.getFieldPath("fydgrp.rec.ownref");}
 				public void setValue(String arg){Fytcfm.this.getFydgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fytcfm.this.getFydgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fytcfm.this.getFieldPath("fydgrp.rec.bchcod");}
 				public void setValue(String arg){Fytcfm.this.getFydgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fytcfm.this.getFydgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytcfm.this.getFieldPath("fydgrp.rec.inr");}
 				public void setValue(String arg){Fytcfm.this.getFydgrp().getRec().setInr(arg);}
 				public String getValue(){return Fytcfm.this.getFydgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytcfm.this.getFieldPath("fydgrp.rec.ptyinr");}
 				public void setValue(String arg){Fytcfm.this.getFydgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fytcfm.this.getFydgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getFydgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("FY"));
        }

        /**
        *   source:fytcfm.@0000.script
        */
        @Rule(target="fytp.fydgrp.rec.hanway",order=100)
        public boolean ruleFytpFydgrpRecHanwayN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getFydgrp().getRec().getHanway()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else if ("3".equals(this.getFydgrp().getRec().getHanway()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:fytcfm.@0002.script
        */
        @Rule(target="mtabut.bnkcfm",order=200)
        public boolean ruleMtabutBnkcfmN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","在matbut模块bnkcfm按钮order[200].......");
			//检查及校验
			if(!( ctx.checkAll(this.getFydgrp().getRec())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("fytcfm","CT000028"),MdaUtils.getI18NString("fytcfm","CT000029"));
			  return false;
			}
			ctx.getDaoSession().dbUpdate(this.getFydgrp().getRec());
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getFytp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			//保存trn
			ctx.absGet(Trnmod.class).setTrnForSecondConfirm();

			return true;
        }

        /**
        *   source:fytcfm.@0004.script
        */
        @Rule(target="fytp.xgpdf",order=100)
        public boolean ruleFytpXgpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFytp().getPdfviw().callPDFComponent("","fytxy","福费廷协议",1);

			return true;
        }


        /**
        *   source:fytcfm.@0003.script
        */
        @Check(target="fytp.fydgrp.rec.faxnum",order=100)
        public boolean checkFytpFydgrpRecFaxnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(  MdaUtils.isEmpty(this.getFydgrp().getRec().getRcvnum()) && MdaUtils.isEmpty(this.getFydgrp().getRec().getFaxnum())&& MdaUtils.isEmpty(this.getFydgrp().getRec().getWecnum())
			  && MdaUtils.isEmpty(this.getFydgrp().getRec().getEmails()) && MdaUtils.isEmpty(this.getFydgrp().getRec().getQqsnum()) )
			{
			  ctx.setFieldError(this,"fytp.fydgrp.rec.rcvnum",MdaUtils.getI18NString("fytcfm","CT000030"));
			  return false;
			}

			return true;
        }


        /**
        *   source:fytcfm.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String  objinr=(String)ctx.restoreData("com.brilliance.fytcfm.inr");
			if(!MdaUtils.isEmpty(objinr))
			{
			  ctx.getDaoSession().dbRead(this.getFydgrp().getRec(),new Argument<String>("inr",objinr));
			  //定义步骤条
			  this.getFytp().getStpmod().storePanel(this.getFytp().getFytcfm02(),this.getFytp().getFytcfm05());
			  String steps = "0:福费廷协议;1:合同展示";
			  this.getFytp().getStpmod().setPages(steps);
			  this.getFytp().getStpmod().calcSteps();
			  this.getFytp().getStpmod().setStepBtnSta();
			}

			return true;
        }









}