package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FytdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sigtip;
import com.ceb.gjjs.mda.manager.module.Fytp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fydgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费廷协议生效通知
*/
@Transaction(vo= FytdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fytdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fytdav.class);

		@BDGetter
		private Fydgrp fydgrp;

		@BDGetter
		private Fytp fytp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sigtip sigtip;


		public Fytdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFytp().setFydgrpHolder(()->this.getFydgrp());
           this.getMtabut().setRecHolder(()->this.getFydgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytdav.this.getFieldPath("fydgrp.rec.ptyinr");}
 				public void setValue(String arg){Fytdav.this.getFydgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fytdav.this.getFydgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytdav.this.getFieldPath("fydgrp.rec.inr");}
 				public void setValue(String arg){Fytdav.this.getFydgrp().getRec().setInr(arg);}
 				public String getValue(){return Fytdav.this.getFydgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fytdav.this.getFieldPath("fydgrp.rec.bchcod");}
 				public void setValue(String arg){Fytdav.this.getFydgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fytdav.this.getFydgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Fytdav.this.getFieldPath("fydgrp.rec.ownref");}
 				public void setValue(String arg){Fytdav.this.getFydgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Fytdav.this.getFydgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:fytdav.@0003.script
        */
        @Rule(target="fytp.xypdf",order=100)
        public boolean ruleFytpXypdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			dealPDF("","fytxy","福费廷协议申请",0);

			return true;
        }



        /**
        *   source:fytdav.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in getImgRef");
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			ctx.absGet(Mtabut.class).getImgtp().setTrninr(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getTrninr());
			this.getFytp().setDztimgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			
			
			log.debug("{}","trninr=" + ctx.absGet(Mtabut.class).getImgtp().getTrninr());
			log.debug("{}","fytadv.getImgRef end!dztimgref:" + this.getFytp().getDztimgref());

			return true;
        }

        /**
        *   source:fytdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck(this.getFytp().getFytdav03());


			return true;
        }


        /**
        *   source:fytdav.@0002.script
        */
        public void dealPDF(String filnam,String pdfFile,String pdfTitle,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *功能：预览PDF
			  */
			log.debug("{}","执行"+pdfFile+"PDF标题="+pdfTitle+"order[100]");
			IStream stream=this.getFytp().getTmpstm();
			MdaUtils.clear(stream);
			ctx.absGet(Sysmod.class).generatorPdf(filnam,pdfFile,stream,false);
			String filename = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Sysmod.class).getPDFTmpfile(),"pdf");
			log.debug("{}","filename="+filename);
			MdaUtils.streamSave(stream,filename);
			int index=filename.indexOf("pdf");
			if(index>0)
			  filename=filename.substring(index);
			log.debug("{}","filename="+filename);
			index=filename.indexOf("\\");
			if(index>0)
			{
			  filename=filename.replace("\\", "/");
			}
			log.debug("{}","filename="+filename);
			this.getFytp().getPdfviw().showPDF(filename,pdfTitle,action);
			log.debug("{}","执行"+pdfFile+"完毕，PDF标题="+pdfTitle+"order[100]");
		}








}