package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.FytmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Fytp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Fydgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 福费协议模板推送
*/
@Transaction(vo= FytmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fytmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Fytmdl.class);

		@BDGetter
		private Fydgrp fydgrp;

		@BDGetter
		private Fytp fytp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Fytmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getFytp().setFydgrpHolder(()->this.getFydgrp());
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Fytmdl.this.getFieldPath("fydgrp.rec.bchcod");}
 				public void setValue(String arg){Fytmdl.this.getFydgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Fytmdl.this.getFydgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytmdl.this.getFieldPath("fydgrp.rec.inr");}
 				public void setValue(String arg){Fytmdl.this.getFydgrp().getRec().setInr(arg);}
 				public String getValue(){return Fytmdl.this.getFydgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Fytmdl.this.getFieldPath("fydgrp.rec.ptyinr");}
 				public void setValue(String arg){Fytmdl.this.getFydgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Fytmdl.this.getFydgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getFydgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:fytmdl.@0000.script
        */
        @Rule(target="fytp.select",order=100)
        public boolean ruleFytpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getFytp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("fytmdl","CT000000"),MdaUtils.getI18NString("fytmdl","CT000001"));
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getFytp().getCidmod().getClipty(),new Argument("cid",this.getFytp().getCidmod().getClilst().getElement(index).getCid()));
			  this.getFytp().getBummod().getWrkmdl().setCidinr(this.getFytp().getCidmod().getClipty().getCid());
			  
			}


			return true;
        }

        /**
        *   source:fytmdl.@0008.script
        */
        @Rule(target="fytp.fydgrp.rec.hanway",order=100)
        public boolean ruleFytpFydgrpRecHanwayN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getFydgrp().getRec().getHanway()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else if ("3".equals(this.getFydgrp().getRec().getHanway()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:fytmdl.@0010.script
        */
        @Rule(target="fytp.cidmod.clilst",order=100)
        public boolean ruleFytpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"fytp.select");

			return true;
        }


        /**
        *   source:fytmdl.@0009.script
        */
        @Check(target="fytp.fydgrp.rec.faxnum",order=100)
        public boolean checkFytpFydgrpRecFaxnumN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(  MdaUtils.isEmpty(this.getFydgrp().getRec().getRcvnum()) && MdaUtils.isEmpty(this.getFydgrp().getRec().getFaxnum())&& MdaUtils.isEmpty(this.getFydgrp().getRec().getWecnum())
			  && MdaUtils.isEmpty(this.getFydgrp().getRec().getEmails()) && MdaUtils.isEmpty(this.getFydgrp().getRec().getQqsnum()) )
			{
			  ctx.setFieldError(this,"fytp.fydgrp.rec.rcvnum",MdaUtils.getI18NString("fytmdl","CT000047"));
			  return false;
			}

			return true;
        }


        /**
        *   source:fytmdl.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getFytp().getBummod().setModtyp("fytopn");

			//  定义步骤条
			//  $bptp\\stpmod.storePanel($bptp\\bptapn01,$bptp\\bptapn10,$bptp\\bptapn07,$bptp\\bptapn08,$bptp\\bptapn09,$bptp\\bptapl03);
			//String steps = "0:出口押汇申请;1:签约提示";
			this.getFytp().getStpmod().storePanel(this.getFytp().getFytmdl05(),this.getFytp().getFytmdl08());
			String steps = "0:协议推送模板;1:模板信息";
			this.getFytp().getStpmod().setPages(steps);
			this.getFytp().getStpmod().calcSteps();
			this.getFytp().getStpmod().setStepBtnSta();

			return true;
        }









}