package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函修改申请
*/
@Transaction(vo= GitameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitame.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitame.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitame.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitame.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitame.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitame.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitame.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			log.debug("{}","bchcod Value===="+this.getGidgrp().getRec().getBchcod());
			if(!ctx.checkAll(this.getGidgrp()))
			  return false;
			this.getGidgrp().getRec().setDbqxsjz(this.getGidgrp().getEnddat());
			ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			this.getGidgrp().getGib().setLgtxt(this.getGidgrp().getLgtxtc());
			ctx.getDaoSession().dbUpdate(this.getGidgrp().getGib());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:gitame.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getAmefee()))
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getApl().getPty().getNam());
			}
			else
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getBen().getPty().getNam());
			}

			//$this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","gitame","保函修改申请书",1);
			/*
			  IStream stream=$mtabut\\apldoc.getValue();
			  $\\sysmod.generatorPdf("","gitame",stream,false );
			  */

			return true;
        }

        /**
        *   source:gitame.@0004.script
        */
        @Rule(target="gidgrp.rec.amenbr",order=100)
        public boolean ruleGidgrpRecAmenbrN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:gitame.@0006.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:gitame.@0008.script
        */
        @Rule(target="gitp.gidgrp.ckrq",order=100)
        public boolean ruleGitpGidgrpCkrqN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getCkrq()))
			{
			  this.getGidgrp().setEnddat(null);
			  
			  
			  
			}
			else
			{
			  
			  
			}

			return true;
        }

        /**
        *   source:gitame.@0010.script
        */
        @Rule(target="gitp.gidgrp.zbth",order=100)
        public boolean ruleGitpGidgrpZbthN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getZbth()))
			{
			  this.getGidgrp().setLgtxtc(this.getGidgrp().getGib().getLgtxt());
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().setLgtxtc(NULLSTR);
			  
			  
			  

			}

			return true;
        }

        /**
        *   source:gitame.@0014.script
        */
        @Rule(target="gitp.stpmod.next",order=50)
        public boolean ruleGitpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getGitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getGidgrp().getAgree()))
			    ctx.setFieldError(this,"gidgrp.agree",MdaUtils.getI18NString("gitame","CT000023"));
			  return !MdaUtils.isEmpty(this.getGidgrp().getAgree());

			  case 1:
			  {
			    return ctx.checkAll(this.getGidgrp().getRec()) ;
			  }
			}
			/*
			  int curIdx = $gitp\\stpmod\\curidx;
			  log.info("下一步curIdx========="+curIdx);
			  if(curIdx==1)
			  {
			  log.info("enter next 110=========1");
			  Platform.visible($mtabut\\busmod\\seltemplate);
			  }
			  else
			  {
			  log.info("enter next 110!!!!!!!!!!!!=========1");
			  Platform.invisible($mtabut\\busmod\\seltemplate);
			  }
			  Platform.setModified($mtabut\\busmod\\seltemplate);
			  */
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:gitame.@0015.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "保函修改申请书";
			String tempfiles = "A:gitame";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:gitame.@0017.script
        */
        @Rule(target="gitp.gidgrp.rec.bhzjje",order=100)
        public boolean ruleGitpGidgrpRecBhzjjeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getGidgrp().getRec().setLgamt(this.getGitp().getGidgrp().getBhybje().add(this.getGitp().getGidgrp().getRec().getBhzjje()));
			

			return true;
        }

        /**
        *   source:gitame.@0018.script
        */
        @Rule(target="gitp.pdfbhxg",order=100)
        public boolean ruleGitpPdfbhxgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getAmefee()))
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getApl().getPty().getNam());
			}
			else
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getBen().getPty().getNam());
			}

			//$this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","gitame","保函修改申请书",1);

			return true;
        }

        /**
        *   source:gitame.@0020.script
        */
        @Rule(target="mtabut.gitameapl",order=100)
        public boolean ruleMtabutGitameaplN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getAmefee()))
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getApl().getPty().getNam());
			}
			else
			{
			  this.getGidgrp().setChiclgamefee(this.getGidgrp().getBen().getPty().getNam());
			}

			//$this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","gitame","保函修改申请书",1);
			/*
			  IStream stream=$mtabut\\apldoc.getValue();
			  $\\sysmod.generatorPdf("","gitame",stream,false );
			  */

			return true;
        }


        /**
        *   source:gitame.@0019.script
        */
        @Check(target="gitp.gidgrp.rec.bhzjje",order=100)
        public boolean checkGitpGidgrpRecBhzjjeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getLgcur()))
			{
			  BigDecimal bhzjje = this.getGitp().getGidgrp().getRec().getBhzjje();
			  bhzjje = bhzjje.setScale(0,BigDecimal.ROUND_DOWN);
			  this.getGitp().getGidgrp().getRec().setBhzjje(bhzjje);
			  
			}

			return true;
        }

        /**
        *   source:gitame.@0021.script
        */
        @Check(target="gitp.gidgrp.rec.bhzjje",order=101)
        public boolean checkGitpGidgrpRecBhzjjeN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"bhzjje"));

			return true;
        }

        /**
        *   source:gitame.@0023.script
        */
        @Check(target="gitp.gidgrp.rec.sffl",order=110)
        public boolean checkGitpGidgrpRecSfflN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"sffl"));

			return true;
        }


        /**
        *   source:gitame.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitame  init业务处理开始，ORDER编号:100");
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //IModule gid = (IModule)Platform.restoreData("com.brilliance.gitame.ref");
			  //if(!Platform.isEmpty(gid))
			  //  $gidgrp\\rec.copyValue(gid);
			
			  
			  this.getGidgrp().getRec().setAmedat(MdaUtils.today());
			  
			  
			  
			   //
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  //Platform.clear($gidgrp\\rec\\bhzjje);
			  if(MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getDbqxsjz()))//敞口日期
			  {
			    this.getGitp().getGidgrp().setCkrq("X");
			    
			    
			    
			  }
			  else
			  {
			    this.getGitp().getGidgrp().setCkrq("");
			    
			    
			    
			  }
			  ctx.getDaoSession().dbRead(this.getGidgrp().getGib(),new Argument<String>("inr",this.getGidgrp().getRec().getInr()));
			  if("1".equals(this.getGitp().getGidgrp().getRec().getOpntyp()))//开立方式    保函正本
			  {
			    
			    
			    
			    
			    
			    this.getGidgrp().setZbth("1");
			    //保函草稿
			    this.getGidgrp().setLgtxtc(this.getGidgrp().getGib().getLgtxt());
			  }
			  else
			  {
			    
			    
			    
			    
			  }

			  if("2".equals(this.getGitp().getGidgrp().getRec().getBhxz())||"3".equals(this.getGitp().getGidgrp().getRec().getBhxz()))
			  {
			    
			  }
			  log.info("{}","message-----gidgrp-rec-sffs---"+this.getGidgrp().getRec().getSffs());
			  
			  //Platform.setRequired($gidgrp\\rec\\amefee);
			  
			  //Platform.setRequired($gidgrp\\rec\\sffl);
			  

			  return true;
			}

			IModule gid = (IModule)ctx.restoreData("com.brilliance.gitame.ref");
			if(!MdaUtils.isEmpty(gid))
			  this.getGidgrp().getRec().copyValue(gid);
			log.info("{}","message-----gidgrp-rec-inr-----"+this.getGidgrp().getRec().getInr());
			ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument<String>("objinr",this.getGidgrp().getRec().getInr()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument<String>("objinr",this.getGidgrp().getRec().getInr()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","apl"));

			
			this.getGidgrp().getRec().setAmedat(MdaUtils.today());
			
			
			
			 //
			
			
			
			
			
			
			
			
			
			
			this.getGidgrp().getRec().setBhzjje(new BigDecimal(0));
			this.getGidgrp().setBhybje(this.getGidgrp().getRec().getLgamt());

			if(MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getDbqxsjz()))//敞口日期
			{
			  this.getGitp().getGidgrp().setCkrq("X");
			  
			  
			  
			}
			else
			{
			  this.getGitp().getGidgrp().setCkrq("");
			  
			  
			  
			}
			//log.info("lgtxt -----  = " + $gidgrp\\rec\\lgtxt.getValue());
			//$gidgrp\\lgtxtc.setValue($gidgrp\\rec\\lgtxt.getValue());
			//Platform.setModified($gidgrp\\lgtxtc);
			ctx.getDaoSession().dbRead(this.getGidgrp().getGib(),new Argument<String>("inr",this.getGidgrp().getRec().getInr()));
			if("1".equals(this.getGitp().getGidgrp().getRec().getOpntyp()))//开立方式    保函正本
			{
			  
			  
			  
			  
			  
			  this.getGidgrp().setZbth("1");
			  //保函草稿
			  this.getGidgrp().setLgtxtc(this.getGidgrp().getGib().getLgtxt());
			}
			else
			{
			  
			  
			  
			  
			}

			if("2".equals(this.getGitp().getGidgrp().getRec().getBhxz())||"3".equals(this.getGitp().getGidgrp().getRec().getBhxz()))
			{
			  
			}
			log.info("{}","message-----gidgrp-rec-sffs---"+this.getGidgrp().getRec().getSffs());
			
			//Platform.setRequired($gidgrp\\rec\\amefee);
			
			//Platform.setRequired($gidgrp\\rec\\sffl);
			

			//$gidgrp\\rec\\amefee.setValue("1");
			this.getGidgrp().getRec().setAmenbr(this.getGidgrp().getRec().getAmenbr()+1);
			this.getGidgrp().getApl().getPty().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			this.getGidgrp().getApl().getPts().setExtkey(this.getSysmod().getPty().getNcid());

			this.getGidgrp().getRec().setAmetxt(NULLSTR);
			ctx.getDaoSession().dbRead(this.getGidgrp().getGib(),new Argument<String>("inr", EQ, this.getGidgrp().getRec().getInr()));
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  this.getGidgrp().setLgtxtc(this.getGidgrp().getGib().getLgtxt());
			}
			ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument<String>("objinr",this.getGidgrp().getRec().getInr()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPty(),new Argument<String>("inr",this.getGidgrp().getBen().getPts().getPtyinr()));
			//Platform.dbRead($gidgrp\\ben\\pty,new Argument<String>("cid",$gidgrp\\rec\\bchcod.getValue()));
			//log.info("message-----ben-pty-inr-----"+$gidgrp\\ben\\pty\\inr.getValue());
			//$gidgrp\\ben.initPtyRole("gid",$gidgrp\\ben\\pty\\inr.getValue(),"ben");
			//$gidgrp\\ben.initBen("gid",$gidgrp\\ben\\pty\\inr.getValue());
			log.info("{}","message-----sysmod-pty---------"+ctx.absGet(Sysmod.class).getPty().getInr()+"-----------"+this.getGidgrp().getApl().getPty().getInr()+"------"+this.getGidgrp().getBen().getPty().getInr());
			log.info("{}","message-----ben-pty-engnam-----"+this.getGidgrp().getBen().getPty().getEngnam());
			log.info("{}","message-----ben-pty-bennamcn-----"+this.getGidgrp().getRec().getBennamcn());
			//$gidgrp\\ben\\pts\\rol.setValue("ben");
			
			/*
			  if(Platform.isEmpty($sysmod\\spt\\ordinr))
			  $trnmod.ordNew();
			  if($\\sysmod.sptIsLoaded("B")  ||  $\\sysmod.sptIsLoaded("P")  ||  $\\sysmod.sptIsLoaded("T"))
			  return;
			  IModule gid = (IModule)Platform.restoreData("com.brilliance.gitame.ref");
			  if(!Platform.isEmpty(gid))
			  $gidgrp\\rec.copyValue(gid);
			  Platform.disable($gidgrp\\rec\\amedat);
			  $gidgrp\\rec\\amedat.setValue(Platform.today());
			  // Platform.clear($gidgrp\\rec\\ownref);
			  Platform.disable($gidgrp\\rec\\stlref);
			  Platform.disable($gidgrp\\rec\\lgcur);
			  Platform.disable($gidgrp\\rec\\lgamt);
			  Platform.dbRead($gidgrp\\ben\\pts,new Argument<String>("objinr",$gidgrp\\rec\\inr.getValue()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			  Platform.dbRead($gidgrp\\apl\\pts,new Argument<String>("objinr",$gidgrp\\rec\\inr.getValue()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","apl"));
			  Platform.disable($gidgrp\\ben\\pts\\extkey);
			  Platform.disable($gidgrp\\ben\\pts\\adrblk);
			  $gidgrp\\apl\\pty\\nam.setValue($\\sysmod\\pty\\nam.getValue());
			  Platform.disable($gidgrp\\apl\\pty\\nam);
			  // Platform.setValues($gidgrp\\rec\\sndtyp,Platform.getCodetable("lgsndtyp"));
			  $gidgrp\\rec\\sndtyp.setValue("1");
			  //Platform.setValues($gidgrp\\rec\\amefee,Platform.getCodetable("lgamefee"));
			  $gidgrp\\rec\\amefee.setValue("1");
			  $gidgrp\\rec\\amenbr.setValue($gidgrp\\rec\\amenbr.getValue()+1);
			  $gidgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			  $gidgrp\\apl\\pts\\extkey.setValue($sysmod\\pty\\ncid.getValue());
			  Platform.setDescription($gidgrp\\rec\\sndtyp,#CT000013);
			  Platform.setDescription($gidgrp\\rec\\ametxt,#CT000014);
			  Platform.setDescription($gidgrp\\rec\\amefee,#CT000015) ;
			  Platform.setRequired($gidgrp\\rec\\sndtyp);
			  Platform.setRequired($gidgrp\\rec\\ametxt);
			  Platform.setRequired($gidgrp\\rec\\amefee);
			
			  Platform.clear($gidgrp\\rec\\ametxt);
			  */

			return true;
        }

        /**
        *   source:gitame.@0005.script
        */
        @Init(order=110)
        public boolean	init110(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitame  init业务处理开始，ORDER编号:110");
			log.info("{}","bchcod="+this.getGidgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$gidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getIbchcod()))
			      this.getGidgrp().getRec().setBchcod(this.getGidgrp().getRec().getIbchcod());
			    else
			    {
			      this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getGidgrp().getRec().setIbchcod(this.getGidgrp().getRec().getBchcod());
			    }
			  }
			  else
			  {
			    this.getGidgrp().getRec().setBchcod(this.getGidgrp().getRec().getDbchcod());
			    
			  }
			  log.info("{}","bchocd="+this.getGidgrp().getRec().getBchcod()+",dbchocd="+this.getGidgrp().getRec().getDbchcod()+",ibchcod="+this.getGidgrp().getRec().getIbchcod());
			}

			return true;
        }

        /**
        *   source:gitame.@0009.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitame  init业务处理开始，ORDER编号:90");
			//0、保函开立申明   1、保函修改申请
			this.getGitp().getStpmod().storePanel(this.getGitp().getGitame03(),this.getGitp().getGitame02());
			String steps = "0:保函开立申明;1:保函开立申请";
			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();

			return true;
        }










}