package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Gitame0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gidgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函修改申请选择
*/
@Transaction(vo= Gitame0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitame0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitame0.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Gitame0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:gitame0.@0001.script
        */
        @Rule(target="selp.sure",order=0)
        public boolean ruleSelpSureN0(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("gidgrp","gitame");

			return true;
        }

        /**
        *   source:gitame0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.lgcur cur,rec.lgamt amt,rec.opndat dat,substr(s.adrblk,0,35) bennam FROM gid rec,pts s WHERE rec.stlref is not NULL AND rec.clsdat is NULL AND substr(rec.stlref,0,2) = 'LG' AND s.rol = 'ben' AND s.objtyp = 'gid' AND s.objinr = rec.inr"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:gitame0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("gidgrp","gitame");

			return true;
        }



        /**
        *   source:gitame0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selgitame"));
			this.getSelp().setSeltyp("1");
			//String queryClause = "SELECT gid.inr trsinr,gid.stlref ref,gid.lgcur cur,gid.lgamt amt,gid.opndat dat,pts.nam bennam,adr.adr benadr,adr.tel bentel,adr.fax benfax FROM gid,pts,adr,pta WHERE gid.flg = '2' AND pts.rol = 'ben' AND pts.objtyp = 'gid' AND pts.objinr = gid.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.lgcur cur,rec.lgamt amt,rec.opndat dat,substr(s.adrblk,0,35) bennam FROM gid rec,pts s WHERE rec.stlref is not NULL AND rec.clsdat is NULL AND substr(rec.stlref,6,2) = 'LG' AND s.rol = 'ben' AND s.objtyp = 'gid' AND s.objinr = rec.inr"
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.lgcur cur,rec.lgamt amt,rec.opndat dat,substr(s.adrblk,0,35) bennam FROM gid rec,pts s WHERE rec.stlref is not NULL AND substr(rec.stlref,6,2) = 'LG' AND s.rol = 'ben' AND s.objtyp = 'gid' AND s.objinr = rec.inr"
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.lgcur cur,rec.lgamt amt,rec.opndat dat,substr(s.adrblk,0,35)  bennam,b.lgtxt FROM pts s， gid rec left outer join gib b on  rec.inr = b.inr WHERE rec.stlref is not NULL AND substr(rec.stlref,0,2) = 'LG' AND s.rol = 'ben' AND s.objtyp = 'gid' AND s.objinr = rec.inr"

			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}