package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitapnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函开立申请（综）
*/
@Transaction(vo= GitapnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitapn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitapn.class);

        //保函
        private String lgtypflg1;
        //备用信用证
        private String lgtypflg2;
        //开立方式1
        private String opntypflg1;
        //开立方式2
        private String opntypflg2;
        //保函文本格式1
        private String txttypflg1;
        //保函文本格式2
        private String txttypflg2;
        //出具方式1
        private String cjfsflg1;
        //出具方式2
        private String cjfsflg2;
        //出具方式3
        private String cjfsflg3;
        //出具方式4
        private String cjfsflg4;
        //所属落地机构中文
        private String bchcodcn;
        //申请人中文名址
        private String adrblkcn;
        //受益人中文名址
        private String benadrblkcn;
        //保函适用方式
        private String apprul;
        //保函类型
        private String lgtyp;
		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitapn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitapn.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitapn.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitapn.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitapn.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitapn.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitapn.@0023.script
        */
        @Rule(target="gitp.sigtip.checked",order=100)
        public boolean ruleGitpSigtipCheckedN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Execute  event--- sigtip---checked  .......");
			/*
			
			  if(Platform.isEmpty($gitp\\sigtip\\checked))
			  {
			  steps = "0:本人申请声明;1:保函开立申请;2:签约提示";
			  Platform.clear($gidgrp);
			  Platform.clear($gitp\\bxdmod\\bxd);
			  Platform.clear($gitp\\bxdmod\\mar);
			  }
			  else
			  {
			  steps = "0:本人申请声明;1:保函开立申请;2:签约提示;3:保函合同开立;6:合同展示";
			  }
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  $gitp\\stpmod.setStepBtnSta();
			  */
			String steps = "";
			this.dealStpmod();


			return true;
        }

        /**
        *   source:gitapn.@0025.script
        */
        @Rule(target="gitp.stpmod.gostep",order=50)
        public boolean ruleGitpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getGitp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getGitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitapn","CT000054"),MdaUtils.getI18NString("gitapn","CT000058"));
			  return false;
			}

			//可以跳到申请界面--显示查询面板   ||  从申请界面跳往其他界面失败  -- 不隐藏查询面板
			if(((stepIdx==1)&&!MdaUtils.isEmpty(this.getGitp().getGidgrp().getAgree()))||((stepIdx == 2||stepIdx == 0) && !ctx.checkAll(this.getGidgrp().getRec())))
			{
			  /*
			    //从0跳到1时，若没勾选我同意，防止查询模版显示出来
			    if(panelidx == 0 && Platform.isEmpty($gitp\\gidgrp\\agree))
			    Platform.invisible($mtabut\\busmod\\seltemplate);
			    else
			    Platform.visible($mtabut\\busmod\\seltemplate);
			    */
			  
			}
			else
			{
			  
			}
			

			/*if(curIdx>stepIdx) //往上一步
			  return;
			  */

			
			
			
			
			
			
			

			Boolean bool = false;
			if("2".equals(this.getGidgrp().getRec().getOpntyp()))		//开立方式为电开时   不需要校验开立行
			{
			  bool = ctx.checkAll(this.getGidgrp().getRec())&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getBenp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getAdvp().getPtspta().getPts());
			}
			else
			{
			  bool = ctx.checkAll(this.getGidgrp().getRec())&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getBenp().getPtspta().getPts());
			}
			//分离式保函--保函性质（融资、非融资）
			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			{
			  bool = bool && ctx.checkAll(this.getGitp().getSecp().getPtspta().getPts());
			}

			log.debug("{}","从case1跳转 --" +stepIdx +"---结果："+bool );
			//0、保函开立申明   1、保函开立申请   2、信贷基本情况   3、银行信贷证明  4、分离式保函开立协议 5、保证金质押协议  6、申请人承诺书   7、申请书展示
			switch(panelidx)
			{

			  case 0:
			  if(MdaUtils.isEmpty(this.getGidgrp().getAgree()))
			    ctx.setFieldError(this,"gidgrp.agree",MdaUtils.getI18NString("gitapn","CT000059"));
			  return !MdaUtils.isEmpty(this.getGidgrp().getAgree());

			  case 1:
			  {

			    return bool&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPty());
			  }

			  case 2:
			  {
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());
			  }

			  case 3:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());

			  }
			  case 4:
			  {
			    
			    
			    
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr())&&ctx.checkAll(this.getGidgrp().getSec().getPty())&&ctx.checkAll(this.getGidgrp().getSec().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());

			  }

			  case 5:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());
			  }
			  case 6:
			  {
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr());
			  }
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:gitapn.@0027.script
        */
        @Rule(target="gitp.stpmod.next",order=50)
        public boolean ruleGitpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getGitp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getGitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			
			
			
			
			
			
			

			Boolean bool = false;
			if("2".equals(this.getGidgrp().getRec().getOpntyp()))		//开立方式为电开时   不需要校验开立行
			{
			  bool = ctx.checkAll(this.getGidgrp().getRec())&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getBenp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getAdvp().getPtspta().getPts());
			}
			else
			{
			  bool = ctx.checkAll(this.getGidgrp().getRec())&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getBenp().getPtspta().getPts());
			}
			//分离式保函--保函性质（融资、非融资）
			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			{
			  bool = bool && ctx.checkAll(this.getGitp().getSecp().getPtspta().getPts());
			}

			switch(panelidx)
			{

			  case 0:
			  if(MdaUtils.isEmpty(this.getGidgrp().getAgree()))
			    ctx.setFieldError(this,"gidgrp.agree",MdaUtils.getI18NString("gitapn","CT000055"));
			  return !MdaUtils.isEmpty(this.getGidgrp().getAgree());

			  case 1:
			  {

			    return bool&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPty());
			  }

			  case 2:
			  {
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());
			  }

			  case 3:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());

			  }
			  case 4:
			  {
			    
			    
			    
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr())&&ctx.checkAll(this.getGidgrp().getSec().getPty())&&ctx.checkAll(this.getGidgrp().getSec().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());

			  }

			  case 5:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());
			  }
			  case 6:
			  {
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr());
			  }
			}
			log.debug("{}","next Order[50] 执行完毕");

			/*
			  switch(panelidx)
			  {
			  case 0:
			  if(Platform.isEmpty($gidgrp\\agree))
			  Platform.error($gidgrp\\agree,#CT000079);
			  return !Platform.isEmpty($gidgrp\\agree);
			
			  case 1:
			  {
			  return Platform.checkAll($gidgrp\\rec) ;
			  }
			
			  case 2:
			  {
			  if("10".equals($gidgrp\\rec\\lgtyp.getValue()))
			  {
			  Platform.setRequired($gidgrp\\ben\\pty\\nam);
			  Platform.setRequired($gidgrp\\rec\\zbssgqx);
			  }
			  return Platform.checkAll($gidgrp\\rec);
			  }
			
			  case 3:
			  return Platform.checkAll($gidgrp\\rec);
			
			  case 4:
			  return Platform.checkAll($gidgrp\\rec);
			
			  case 5:
			  return Platform.checkAll($gidgrp\\rec);
			
			  case 6:
			  return Platform.checkAll($gidgrp\\rec);
			
			  }
			
			  */
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:gitapn.@0034.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            

			String flags=this.getGidgrp().getRec().getFlags();
			log.info("{}","在matbut模块下sav按钮order[200]，flags="+flags );
			//删除模板
			this.getMtabut().getBusmod().dealFile();
			//PDF勾选重载
			this.flags2();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")||(ctx.absGet(Sysmod.class).sptIsLoaded("T")))
			{
			  ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			  String objinr=this.getGidgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getApl().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getBen().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getAdv().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getSec().getPts(),objinr);   //新加  被保证人
			
			  /*
			    Platform.dbUpdate($gidgrp\\gxd);
			    if("0011".equals(flags))   //勾选保证金和委托扣划
			    {
			    $gitp\\bxdmod.updBxdAndMar();
			    }
			    */
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getGidgrp().getRec().setIbchcod(this.getGidgrp().getRec().getBchcod());
			  else
			    this.getGidgrp().getRec().setDbchcod(this.getGidgrp().getRec().getBchcod());
			  this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getRec());
			  String objinr = this.getGidgrp().getRec().getInr();
			  String objtyp = "gid";

			  this.getGidgrp().getBen().savpts(objinr,objtyp);
			  this.getGidgrp().getApl().savpts(objinr,objtyp);
			  this.getGidgrp().getAdv().savpts(objinr,objtyp);
			  this.getGidgrp().getCtr().savpts(objinr,objtyp);
			  this.getGidgrp().getSec().savpts(objinr,objtyp);

			  this.getGidgrp().getGib().setInr(this.getGidgrp().getRec().getInr());
			  this.getGidgrp().getGib().setPtyinr(this.getGidgrp().getRec().getPtyinr());
			  this.getGidgrp().getGib().setLgtyp(this.getGidgrp().getRec().getLgtyp());
			  this.getGidgrp().getGib().setWbtyp(this.getGidgrp().getRec().getWbtyp());
			  this.getGidgrp().getGib().setLgtxt(this.getGidgrp().getRec().getLgtxt());
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getGib());

			  this.getGidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getGidgrp().getDap().getPts().setObjinr(objinr);
			  this.getGidgrp().getDap().getPts().setObjtyp("gid");
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getDap().getPts());
			  log.info("{}", "sav200入库结束================" );

			  //处理保函协议gxd
			  /*
			    $mtabut.getRefrence($gidgrp\\gxd\\ownref,"HX");
			    $this.dealGxd(objinr,objtyp);
			    */
			  // 保存保证金协议
			  /*
			    if("0011".equals(flags))
			    {
			    $mtabut.getRefrence($gidgrp\\bxd\\ownref,"BX");
			    $mtabut.getRefrence($gidgrp\\mar\\ownref,"JX");
			    $gitp\\bxdmod.saveBxdAndMar();
			    }
			    */
			}
			//处理出口押汇申请中 入账账号
			this.dealPDFData();
			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getGitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:gitapn.@0058.script
        */
        @Rule(target="mtabut.sav",order=190)
        public boolean ruleMtabutSavN190(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 检查及校验
			  */
			if(!(ctx.checkAll(this.getGidgrp())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitapn","CT000036"),MdaUtils.getI18NString("gitapn","CT000037"));
			  return false;
			}

			/*
			  String flags =$gidgrp\\rec\\flags.getValue();
			  log.debug("在matbut模块下sav按钮order[190]，flags="+flags);
			  if("0011".equals(flags))
			  {//勾选签约提示，保证金相关业务
			  $mtabut.getRefrence($gidgrp\\gxd\\ownref,"JX");
			  if(!(Platform.checkAll($gidgrp)&&$gitp\\bxdmod.checkMxdlst()))
			  {
			  Platform.message(#CT000038,#CT000039);
			  return false;
			  }
			  }
			  else if("0000".equals(flags)||"0001".equals(flags))  //新申请或者勾选了我同意
			  {
			  if(!(Platform.checkAll($gidgrp\\rec)&& Platform.checkAll($gidgrp\\gxd)))
			  {
			  Platform.message(#CT000056,#CT000057);
			  return false;
			  }
			  }*/

			return true;
        }

        /**
        *   source:gitapn.@0067.script
        */
        @Rule(target="mtabut.ped",order=900)
        public boolean ruleMtabutPedN900(){
            IContext ctx = MdaEnv.getContext();
            
			String flags = this.getGidgrp().getRec().getFlags();
			log.debug("{}","pen-----flags----" + flags);

			return true;
        }

        /**
        *   source:gitapn.@0069.script
        */
        @Rule(target="mtabut.busmod.select",order=101)
        public boolean ruleMtabutBusmodSelectN101(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitapn  bummod-select业务处理开始，ORDER编号:101");
			// $gitp\\stpmod.storePanel($gitp\\gitapnstep01,$gitp\\gitapnstep02,$gitp\\gitapnstep04,$gitp\\gitapnstep05,$gitp\\gitapnstep06,$gitp\\gitapnstep07);
			String flags=this.getGidgrp().getRec().getFlags();
			log.debug("{}","标志位flags="+flags);
			/*
			  if("0000".equals(flags))
			  {
			  steps = "0:保函开立申明;1:保函开立申请;2:保函合同开立;5:合同展示;";
			  Platform.invisible($gitp\\pdfbxd);
			  Platform.invisible($gitp\\pdfmar);
			  }
			  else if("0011".equals(flags))  //已勾选在线办理保证金
			  {
			  steps =  "0:保函开立申明;1:保函开立申请;2:保函合同开立;3:保证金协议;4:委托开户扣划;5:合同展示";
			  $gitp\\gidgrp\\bzjchk.setValue("X");
			  Platform.setModified($gitp\\gidgrp\\bzjchk);
			  Platform.visible($gitp\\pdfbxd);
			  Platform.visible($gitp\\pdfmar);
			  }
			  else
			  {
			  Platform.invisible($gitp\\pdfbxd);
			  Platform.invisible($gitp\\pdfmar);
			  }
			
			  initMainCtl();
			  */

			this.dealStpmod();
			this.reloadRule();
			//初始化申请日期
			this.getGidgrp().getRec().setApldat(MdaUtils.today());
			this.getGidgrp().getRec().setCredat(MdaUtils.today());
			
			
			//清理前业务编号
			this.getGidgrp().getRec().setOwnref(NULLSTR);
			//初始化申请人
			this.getGidgrp().getApl().getPts().setNam(this.getSysmod().getPty().getNam());
			
			//Platform.disable($gitp\\aplp\\ptspta\\pts\\nam);  //本人申请声明申请人灰显
			
			
			
			if("2".equals(this.getGidgrp().getRec().getOpntyp()))  //开立方式 为电开时     通知行为必输项
			{
			  
			}
			//司法诉讼地址
			
			//索偿付款账号
			if("9".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  
			  if("X".equals(this.getGitp().getGidgrp().getHzzsbh()))
			  {
			    
			  }
			  else
			  {
			    this.getGitp().getGidgrp().getRec().setScfkzh(NULLSTR);
			    
			    
			  }
			}
			else
			{
			  
			  this.getGitp().getGidgrp().getRec().setScfkzh(NULLSTR);
			  
			  
			}

			//初始化机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());

			return true;
        }

        /**
        *   source:gitapn.@0076.script
        */
        @Rule(target="gitp.pdfgid",order=100)
        public boolean ruleGitpPdfgidN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getGitp().getPdfviw().callPDFComponent("","gitapn","保函开立申请",1);

			return true;
        }

        /**
        *   source:gitapn.@0087.script
        */
        @Rule(target="gitp.gidgrp.gxd.ownref",order=100)
        public boolean ruleGitpGidgrpGxdOwnrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getGxd().getOwnref()))
			{
			  this.getGidgrp().getBxd().setHtbh(this.getGitp().getGidgrp().getGxd().getOwnref());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setHtbh(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0097.script
        */
        @Rule(target="gitp.gidgrp.bzjchk",order=100)
        public boolean ruleGitpGidgrpBzjchkN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  log.debug("execute  event bzjchk checked  .......");
			  String steps = "";
			  if(Platform.isEmpty($gitp\\gidgrp\\bzjchk))
			  {
			  steps = "0:保函开立申明;1:保函开立申请;2:保函合同开立;5:合同展示";
			  //有签约提示，无保证金，设置flags标志位为0001
			  $gidgrp\\rec\\flags.setValue("0000");
			  Platform.setModified($gidgrp\\rec\\flags);
			  Platform.clear($gitp\\bxdmod\\bxd);
			  Platform.clear($gitp\\bxdmod\\mar);
			  Platform.invisible($gitp\\pdfbxd);
			  Platform.invisible($gitp\\pdfmar);
			  }
			  else
			  {
			  //有签约提示，有保证金，设置flags标志位为0011
			  $gidgrp\\rec\\flags.setValue("0011");
			  Platform.setModified($gidgrp\\rec\\flags);
			  steps = "0:保函开立申明;1:保函开立申请;2:保函合同开立;3:保证金协议;4:委托开户扣划;5:合同展示";
			  $gidgrp\\bzjchk.setValue("X");
			  Platform.setModified($gidgrp\\bzjchk);
			  Platform.visible($gitp\\pdfbxd);
			  Platform.visible($gitp\\pdfmar);
			  }
			  log.debug("---------------------------flags="+$gidgrp\\rec\\flags.getValue());
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  $gitp\\stpmod.setStepBtnSta();*/

			return true;
        }

        /**
        *   source:gitapn.@0098.script
        */
        @Rule(target="gitp.gidgrp.rec.bzjcur",order=100)
        public boolean ruleGitpGidgrpRecBzjcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\rec\\bzjcur))
			  {
			  String bzjcur= $gidgrp\\rec\\bzjcur.getValue();
			  $gidgrp\\gxd\\bzjcur.setValue(bzjcur);
			  Platform.setModified($gidgrp\\gxd\\bzjcur);
			  $gidgrp\\bxd\\cur.setValue(bzjcur);
			  Platform.setModified($gidgrp\\bxd\\cur);
			  Platform.disable($gidgrp\\gxd\\bzjcur);
			  if(!Platform.isEmpty($gidgrp\\rec\\bzjamt))
			  {
			  String bzjamtcn = $sysmod.covCnAmt($gidgrp\\rec\\bzjamt.getValue(),$gidgrp\\rec\\bzjcur.getValue());
			  $gidgrp\\gxd\\bzjamtcn.setValue(bzjamtcn);
			  Platform.setModified($gidgrp\\gxd\\bzjamtcn);
			  $gidgrp\\bxd\\amt.setValue($gidgrp\\rec\\bzjamt.getValue());
			  Platform.setModified($gidgrp\\bxd\\amt);
			  }
			  Platform.setRequired($gidgrp\\rec\\bzjamt);
			  }
			  else
			  {
			  Platform.setNotRequired($gidgrp\\rec\\bzjamt);
			  }*/

			return true;
        }

        /**
        *   source:gitapn.@0099.script
        */
        @Rule(target="gitp.gidgrp.rec.bzjamt",order=100)
        public boolean ruleGitpGidgrpRecBzjamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\rec\\bzjamt))  //金额不为空
			  {
			  if(!Platform.isEmpty($gidgrp\\rec\\bzjcur))  //币种不为空
			  {
			  String bzjamtcn = $sysmod.covCnAmt($gidgrp\\rec\\bzjamt.getValue(),$gidgrp\\rec\\bzjcur.getValue());
			  $gidgrp\\gxd\\bzjamtcn.setValue(bzjamtcn);
			  Platform.setModified($gidgrp\\gxd\\bzjamtcn);
			  $gidgrp\\bxd\\amt.setValue($gidgrp\\rec\\bzjamt.getValue());
			  Platform.setModified($gidgrp\\bxd\\amt);
			  }
			  Platform.setRequired($gidgrp\\rec\\bzjcur);
			  }
			  else
			  {
			  Platform.setNotRequired($gidgrp\\rec\\bzjcur);
			  Platform.clear($gidgrp\\gxd\\bzjamtcn);
			  Platform.setModified($gidgrp\\gxd\\bzjamtcn);
			  Platform.clear($gidgrp\\bxd\\amt);
			  Platform.setModified($gidgrp\\bxd\\amt);
			
			  }*/

			return true;
        }

        /**
        *   source:gitapn.@0100.script
        */
        @Rule(target="gitp.stpmod.last",order=110)
        public boolean ruleGitpStpmodLastN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getGitp().getStpmod().getCuridx();
			log.info("{}","上一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter last 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter last 110!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:gitapn.@0101.script
        */
        @Rule(target="gitp.gidgrp.bhcnschk",order=100)
        public boolean ruleGitpGidgrpBhcnschkN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","execute  event bhcnschk checked  .......");
			this.dealStpmod();
			/*
			  String steps = "";
			  if(Platform.isEmpty($gitp\\gidgrp\\bhcnschk))
			  {
			  steps = "0:保函开立申明;1:保函开立申请;7:合同展示";
			  //有签约提示，无保函承诺书，设置flags标志位为0001
			  $gidgrp\\rec\\flags.setValue("0000");
			  Platform.setModified($gidgrp\\rec\\flags);
			  //Platform.clear($gitp\\bxdmod\\bxd);
			  //Platform.clear($gitp\\bxdmod\\mar);
			  //Platform.invisible($gitp\\pdfbxd);
			  //Platform.invisible($gitp\\pdfmar);
			  }
			  else
			  {
			  //有签约提示，有保函承诺书，设置flags标志位为0011
			  $gidgrp\\rec\\flags.setValue("0011");
			  Platform.setModified($gidgrp\\rec\\flags);
			  steps = "0:保函开立申明;1:保函开立申请;6:申请人承诺书;7:合同展示";
			  $gidgrp\\bhcnschk.setValue("X");
			  Platform.setModified($gidgrp\\bhcnschk);
			  //Platform.visible($gitp\\pdfbxd);
			  //Platform.visible($gitp\\pdfmar);
			  }
			  log.debug("---------------------------flags="+$gidgrp\\rec\\flags.getValue());
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  $gitp\\stpmod.setStepBtnSta();
			
			  */

			return true;
        }

        /**
        *   source:gitapn.@0102.script
        */
        @Rule(target="gidgrp.bzjzyxy",order=100)
        public boolean ruleGidgrpBzjzyxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealStpmod();
			/*
			  log.debug("execute  event bzjzyxy checked  .......");
			  String steps = "";
			  StringBuffer stepsB = new StringBuffer();
			  stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");
			
			  if("10".equals($gidgrp\\rec\\lgtyp.getValue()))  //银行信贷证明
			  {
			  stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");
			  Platform.visible($gitp\\pdfxdzm);
			  Platform.visible($gitp\\pdfxdxy);
			  }
			  else
			  {
			  Platform.invisible($gitp\\pdfxdzm);
			  Platform.invisible($gitp\\pdfxdxy);
			  }
			
			  if("X".equals( $gidgrp\\bzjzyxy.getValue()))//已勾选保证金质押协议
			  {
			  //有签约提示，有保证金质押协议，设置flags标志位为0011
			  $gidgrp\\rec\\flags.setValue("0011");
			  Platform.setModified($gidgrp\\rec\\flags);
			  stepsB = stepsB.append("4:保证金质押协议;");
			  Platform.visible($gitp\\pdfzyxy);
			  }
			  else
			  {
			  //有签约提示，无保证金质押协议，设置flags标志位为0001
			  $gidgrp\\rec\\flags.setValue("0001");
			  Platform.setModified($gidgrp\\rec\\flags);
			  Platform.invisible($gitp\\pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("");
			  Platform.setModified($gidgrp\\bzjzyxy);
			  }
			
			  if("X".equals($gidgrp\\bhcnschk.getValue()))  //已勾选在线办理申请人承诺书
			  {
			  stepsB = stepsB.append("5:申请人承诺书;");
			  }
			  String stepss= "";
			  steps = stepss+stepsB.append("6:合同展示");
			
			  log.debug("---------------------------flags="+$gidgrp\\rec\\flags.getValue());
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  $gitp\\stpmod.setStepBtnSta();
			  */

			return true;
        }

        /**
        *   source:gitapn.@0104.script
        */
        @Rule(target="gitp.gidgrp.rec.bhxz",order=100)
        public boolean ruleGitpGidgrpRecBhxzN100(){
            IContext ctx = MdaEnv.getContext();
            
			//银行信贷证明（10）   保函分离式协议（2、3）
			if("10".equals(this.getGidgrp().getRec().getLgtyp())&&("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz())))
			{
			  this.getGidgrp().getRec().setBhxz(NULLSTR);
			  
			  ctx.setFieldError(this,"gidgrp.rec.bhxz",MdaUtils.getI18NString("gitapn","CT000101"));
			}

			//保函申请担保期限止
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjq()) && !MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjz()) && MdaUtils.diff(this.getGidgrp().getRec().getDbqxsjz(),this.getGidgrp().getRec().getDbqxsjq())<0)
			{
			  this.getGidgrp().getRec().setBhxz(NULLSTR);
			  
			  ctx.setFieldError(this,"gidgrp.rec.bhxz",MdaUtils.getI18NString("gitapn","CT000102"));
			}

			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			{
			  //不展示PDF
			
			  //被担保人编号和地址
			  
			  
			  
			  

			  
			  
			  
			  
			}
			else
			{
			  

			  //被担保人编号和地址
			  
			  this.getGitp().getSecp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getSecp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  
			  

			  this.getGidgrp().getRec().setBbzrjyf(NULLSTR);
			  this.getGidgrp().getRec().setSyrjyf(NULLSTR);
			  
			  
			  
			  
			  
			  
			}

			this.dealStpmod();

			return true;
        }

        /**
        *   source:gitapn.@0105.script
        */
        @Rule(target="gitp.pdfbhkl",order=100)
        public boolean ruleGitpPdfbhklN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags2();
			if("X".equals(this.getGidgrp().getBhcnschk()))  //已勾选在线办理申请人承诺书
			{
			  this.getGitp().getPdfviw().callPDFComponent("","klbhsqsjcns","保函开立申请书暨承诺书",1);
			}
			else
			{
			  this.getGitp().getPdfviw().callPDFComponent("","bhklsqs","保函开立申请书",1);
			}


			return true;
        }

        /**
        *   source:gitapn.@0106.script
        */
        @Rule(target="gitp.pdfzyxy",order=100)
        public boolean ruleGitpPdfzyxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","bzjzyxy","保证金质押协议",1);

			return true;
        }

        /**
        *   source:gitapn.@0107.script
        */
        @Rule(target="gitp.pdfxdzm",order=100)
        public boolean ruleGitpPdfxdzmN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","yhxdsq","信贷证明申请",1);

			return true;
        }

        /**
        *   source:gitapn.@0108.script
        */
        @Rule(target="gitp.pdfxdxy",order=100)
        public boolean ruleGitpPdfxdxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags2();
			this.getGitp().getPdfviw().callPDFComponent("","yhxdxy","信贷证明协议",1);

			return true;
        }

        /**
        *   source:gitapn.@0110.script
        */
        @Rule(target="gitp.gidgrp.nedbzj",order=100)
        public boolean ruleGitpGidgrpNedbzjN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getNedbzj()))  //是否需要保证金
			{
			  
			  
			  
			  //Platform.disable($gidgrp\\rec\\sfsy);
			  
			  
			  
			  
			  
			  this.getGidgrp().setBzjzyxy(NULLSTR);
			  this.getGidgrp().getRec().setDbbzjzhm(NULLSTR);
			  this.getGidgrp().getRec().setDbbzjzh(NULLSTR);
			  this.getGidgrp().getRec().setSfsy(NULLSTR);
			  this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  //Platform.setRequired($gidgrp\\rec\\sfsy);
			  this.getGidgrp().getRec().setSfsy(NULLSTR);
			  
			}

			//处理是否有保证金的情况下对业务流程中保证金质押协议的影响
			this.dealStpmod();
			/*
			  StringBuffer stepsB = new StringBuffer();
			  stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");
			  if("10".equals($gidgrp\\rec\\lgtyp.getValue()))						//银行信贷证明
			  {
			  stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");
			  Platform.visible($gitp\\pdfxdzm);
			  Platform.visible($gitp\\pdfxdxy);
			  }
			  else
			  {
			  Platform.invisible($gitp\\pdfxdzm);
			  Platform.invisible($gitp\\pdfxdxy);
			  }
			
			  if(!Platform.isEmpty($gidgrp\\bzjzyxy.getValue()))  //已勾选保证金质押协议
			  {
			  stepsB = stepsB.append("4:保证金质押协议;");
			  Platform.visible($gitp\\pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("X");
			  $gidgrp\\rec\\flags.setValue("0011");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  Platform.setModified($gidgrp\\rec\\flags);
			  }
			  else
			  {
			  Platform.invisible($gitp\\pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("");
			  $gidgrp\\rec\\flags.setValue("0001");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  Platform.setModified($gidgrp\\rec\\flags);
			  }
			
			  if("X".equals($gidgrp\\bhcnschk.getValue()))  //已勾选在线办理申请人承诺书
			  {
			  stepsB = stepsB.append("5:申请人承诺书;");
			  $gidgrp\\bhcnschk.setValue("X");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  else
			  {
			  $gidgrp\\bhcnschk.setValue("");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  String stepss= "";
			  String steps = stepss+stepsB.append("6:合同展示");
			
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  $gitp\\stpmod.setStepBtnSta();
			  */

			return true;
        }

        /**
        *   source:gitapn.@0111.script
        */
        @Rule(target="gitp.gidgrp.rec.apprul",order=100)
        public boolean ruleGitpGidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getGidgrp().getRec().getApprul()))  //保函选用其他规则
			{
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setApprultxt(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0112.script
        */
        @Rule(target="gitp.gidgrp.rec.opntyp2",order=100)
        public boolean ruleGitpGidgrpRecOpntyp2N100(){
            IContext ctx = MdaEnv.getContext();
            
			//分离式保函不能做转开
			if(("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))&&("2".equals(this.getGidgrp().getRec().getOpntyp2())))
			{
			  ctx.setFieldError(this,"gidgrp.rec.opntyp2",MdaUtils.getI18NString("gitapn","CT000107"));
			  this.getGidgrp().getRec().setOpntyp2(NULLSTR);
			  
			}

			//处理转开转递行，信开不能做转递
			if("2".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  
			  
			}
			else if("3".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  if("2".equals(this.getGidgrp().getRec().getOpntyp()))  //1、信开2、电开（信开就只有直开、转开）
			  {
			    
			    
			  }
			  else if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			  {
			    ctx.setFieldError(this,"gidgrp.rec.opntyp2",MdaUtils.getI18NString("gitapn","CT000108"));
			    this.getGidgrp().getRec().setOpntyp2(NULLSTR);
			    

			    
			    
			  }
			  else
			  {
			    
			    
			  }
			}
			else
			{
			  this.getGidgrp().getRec().setZkzdhmc(NULLSTR);
			  
			  
			  
			}

			//处理保函性质，转开不能做分离式保函
			if("2".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  
			}
			else
			{
			  
			}


			return true;
        }

        /**
        *   source:gitapn.@0113.script
        */
        @Rule(target="gidgrp.rec.bbzrjyf",order=100)
        public boolean ruleGidgrpRecBbzrjyfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getBbzrjyf()))  //被保证人甲乙方
			{
			  this.getGidgrp().getRec().setSyrjyf("2");
			  
			}
			else
			{
			  this.getGidgrp().getRec().setSyrjyf("1");
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0114.script
        */
        @Rule(target="gidgrp.rec.syrjyf",order=100)
        public boolean ruleGidgrpRecSyrjyfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getSyrjyf()))
			{
			  this.getGidgrp().getRec().setBbzrjyf("2");
			  
			}
			else
			{
			  this.getGidgrp().getRec().setBbzrjyf("1");
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0115.script
        */
        @Rule(target="gitp.gidgrp.ckrq",order=100)
        public boolean ruleGitpGidgrpCkrqN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getCkrq()))
			{
			  this.getGidgrp().getRec().setDbqxsjz(null);
			  
			  
			  

			  this.getGidgrp().setDxzhi(NULLSTR);
			  
			}
			else
			{
			  
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0116.script
        */
        @Rule(target="gitp.gidgrp.rec.sytk",order=100)
        public boolean ruleGitpGidgrpRecSytkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getSytk()))
			{
			  
			  
			}
			else if("2".equals(this.getGidgrp().getRec().getSytk())||"3".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().getRec().setMyrzbh(NULLSTR);
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setMyrzbh(NULLSTR);
			  
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0117.script
        */
        @Rule(target="gitp.gidgrp.rec.zyjjfs",order=100)
        public boolean ruleGitpGidgrpRecZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getGidgrp().getRec().getZyjjfs()))
			{
			  
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setZcwyh(NULLSTR);
			  
			  
			  

			  this.getGidgrp().getRec().setZcdd(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0118.script
        */
        @Rule(target="gitp.gidgrp.rec.sfsy",order=100)
        public boolean ruleGitpGidgrpRecSfsyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getSfsy()))  //选不适用后  原录入的保证金账户信息被清除，若想再次使用，必须到申请界面录入
			{
			  
			  
			  
			  
			  
			  
			  //处理申请界面
			  this.getGidgrp().setNedbzj("X");
			  
			}
			else
			{
			  this.getGidgrp().setNedbzj(NULLSTR);
			  this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  this.getGidgrp().getRec().setDbbzjzhm(NULLSTR);
			  this.getGidgrp().getRec().setDbbzjzh(NULLSTR);
			  this.getGidgrp().setBzjzyxy(NULLSTR);
			  
			  
			  
			  
			  
			  //Platform.disable($gidgrp\\rec\\bhbzjbl);
			  
			  
			  
			  
			  
			  
			  

			}

			return true;
        }

        /**
        *   source:gitapn.@0119.script
        */
        @Rule(target="gitp.gidgrp.rec.zyxysy",order=100)
        public boolean ruleGitpGidgrpRecZyxysyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getZyxysy()))
			{
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setBhbzjzyxyref(NULLSTR);
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0121.script
        */
        @Rule(target="gitp.gidgrp.rec.xdzmsfty",order=100)
        public boolean ruleGitpGidgrpRecXdzmsftyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getXdzmsfty())&&"2".equals(this.getGidgrp().getRec().getXdzmsfty()))
			{
			  this.getGidgrp().getRec().setLgtxt(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0122.script
        */
        @Rule(target="gitp.gidgrp.rec.wbtyp",order=100)
        public boolean ruleGitpGidgrpRecWbtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			//保函规范文本信息带入
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgtyp())&&!MdaUtils.isEmpty(this.getGidgrp().getRec().getWbtyp()))
			{
			  ctx.getDaoSession().dbRead(this.getGidgrp().getGit(),new Argument<String>("guatyp",this.getGidgrp().getRec().getLgtyp()),new Argument<String>("wbtyp",this.getGidgrp().getRec().getWbtyp()));
			  this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGit().getGuatxt());
			  
			  

			}
			else
			{
			  this.getGidgrp().getRec().setLgtxt(NULLSTR);
			  
			  
			}

			//带入中文名称
			if("1".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getAplp().getPtspta().getPts().setAdrblk( this.getGidgrp().getApl().getPty().getNam() + CR + this.getGidgrp().getApl().getAdr().getAdr());
			  log.info("{}","message1-----wbtyp");
			  this.getGidgrp().setWbtyp("CN");
			  
			  
			}
			else if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getAplp().getPtspta().getPts().setAdrblk( this.getGidgrp().getApl().getPty().getEngnam() + CR + this.getGidgrp().getApl().getAdr().getEnadr());
			  log.info("{}","message2-----wbtyp");
			  this.getGidgrp().setWbtyp("EN");
			  
			  
			}
			else
			{
			  this.getGidgrp().setWbtyp("");
			  
			  
			}
			
			
			
			

			return true;
        }

        /**
        *   source:gitapn.@0126.script
        */
        @Rule(target="gidgrp.rec.lgtyp",order=50)
        public boolean ruleGidgrpRecLgtypN50(){
            IContext ctx = MdaEnv.getContext();
            
			//保函规范文本信息带入
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgtyp())&&!MdaUtils.isEmpty(this.getGidgrp().getRec().getWbtyp()))
			{
			  ctx.getDaoSession().dbRead(this.getGidgrp().getGit(),new Argument("guatyp",this.getGidgrp().getRec().getLgtyp()),new Argument("wbtyp",this.getGidgrp().getRec().getWbtyp()));
			  log.info("{}","message------------"+ctx.getErrorCode());
			  this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGit().getGuatxt());
			  
			  log.info("{}","message----------"+this.getGidgrp().getGit().getGuatxt());
			  log.info("{}","message----------"+this.getGidgrp().getRec().getLgtxt());
			  
			}
			else
			{
			  this.getGidgrp().getRec().setLgtxt(NULLSTR);
			  
			  
			}

			this.dealStpmod();
			/* //银行信贷
			  if("10".equals($gidgrp\\rec\\lgtyp.getValue()))
			  {
			  StringBuffer stepsB = new StringBuffer();
			
			  stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");
			
			  stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");//银行信贷证明
			  Platform.visible($pdfxdzm);
			  Platform.visible($pdfxdxy);
			
			  if(!Platform.isEmpty($gidgrp\\bzjzyxy.getValue()))  //已勾选保证金质押协议
			  {
			  stepsB = stepsB.append("4:保证金质押协议;");
			  Platform.visible($pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("X");
			  $gidgrp\\rec\\flags.setValue("0011");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  Platform.setModified($gidgrp\\rec\\flags);
			  }
			  else
			  {
			  Platform.invisible($pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("");
			  $gidgrp\\rec\\flags.setValue("0001");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  Platform.setModified($gidgrp\\rec\\flags);
			  }
			
			  if("X".equals($gidgrp\\bhcnschk.getValue()))  //已勾选在线办理申请人承诺书
			  {
			  stepsB = stepsB.append("5:申请人承诺书;");
			  $gidgrp\\bhcnschk.setValue("X");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  else
			  {
			  $gidgrp\\bhcnschk.setValue("");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  String stepss= "";
			  String steps = stepss+stepsB.append("6:合同展示");
			
			  $stpmod.setPages(steps);
			  $stpmod.calcSteps();
			  $stpmod.setStepBtnSta();
			  }
			  else
			  {
			  StringBuffer stepsB = new StringBuffer();
			
			  stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");
			  Platform.invisible($pdfxdzm);
			  Platform.invisible($pdfxdxy);
			
			  //stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");//无银行信贷证明
			
			  String flags=$gidgrp\\rec\\flags.getValue();
			  if("0011".equals(flags))  //已勾选保证金质押协议
			  {
			  stepsB = stepsB.append("4:保证金质押协议;");
			  Platform.visible($pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("X");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  }
			  else
			  {
			  Platform.invisible($pdfzyxy);
			  $gidgrp\\bzjzyxy.setValue("");
			  Platform.setModified( $gidgrp\\bzjzyxy);
			  }
			
			  if("X".equals($gidgrp\\bhcnschk.getValue()))  //已勾选在线办理申请人承诺书
			  {
			  stepsB = stepsB.append("5:申请人承诺书;");
			  $gidgrp\\bhcnschk.setValue("X");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  else
			  {
			  $gidgrp\\bhcnschk.setValue("");
			  Platform.setModified( $gidgrp\\bhcnschk);
			  }
			  String stepss= "";
			  String steps = stepss+stepsB.append("6:合同展示");
			
			  $stpmod.setPages(steps);
			  $stpmod.calcSteps();
			  $stpmod.setStepBtnSta();
			  }
			  */


			return true;
        }

        /**
        *   source:gitapn.@0128.script
        */
        @Rule(target="gitp.gidgrp.rec.lgtyp",order=20)
        public boolean ruleGitpGidgrpRecLgtypN20(){
            IContext ctx = MdaEnv.getContext();
            
			//银行信贷证明（10）   保函分离式协议（2、3）
			if("10".equals(this.getGidgrp().getRec().getLgtyp())&&("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz())))
			{
			  this.getGidgrp().getRec().setLgtyp(NULLSTR);
			  
			  ctx.setFieldError(this,"gidgrp.rec.lgtyp",MdaUtils.getI18NString("gitapn","CT000099"));
			}

			return true;
        }

        /**
        *   source:gitapn.@0146.script
        */
        @Rule(target="mtabut.swfbtn",order=100)
        public boolean ruleMtabutSwfbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getWbtyp()))
			{
			  ctx.setMessage("提示","请选择保函文本语言!");
			  return false;
			}
			else if("1".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getPdfviw().callPDFComponent("","lgtxt","保函草稿",1);
			}
			else if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getPdfviw().callSwiftPDFComponent("",ctx.getTransName(),"保函草稿",1);
			}

			return true;
        }

        /**
        *   source:gitapn.@0149.script
        */
        @Rule(target="gidgrp.rec.lgtyp",order=100)
        public boolean ruleGidgrpRecLgtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.getGidgrp().setLgtyp("");
			  return true;
			}
			int lgtyp = Integer.parseInt(this.getGidgrp().getRec().getLgtyp());
			log.info("{}","gidgrp --rec -- lgtyp  -- value ="  +  lgtyp);
			switch(lgtyp)
			{
			  case 1:
			  this.getGidgrp().setLgtyp("A");
			  break;
			  case 2:
			  this.getGidgrp().setLgtyp("B");
			  break;
			  case 3:
			  this.getGidgrp().setLgtyp("C");
			  break;
			  case 4:
			  this.getGidgrp().setLgtyp("J");
			  break;
			  case 5:
			  this.getGidgrp().setLgtyp("G");
			  break;
			  case 6:
			  this.getGidgrp().setLgtyp("W");
			  break;
			  case 7:
			  this.getGidgrp().setLgtyp("Z");
			  break;
			  case 8:
			  this.getGidgrp().setLgtyp("D");
			  break;
			  case 9:
			  this.getGidgrp().setLgtyp("F");
			  break;
			  case 10:
			  this.getGidgrp().setLgtyp("V");
			  break;
			}
			
			log.info("{}","gidgrp -- lgtyp  -- value ="  +  this.getGidgrp().getLgtyp());

			return true;
        }

        /**
        *   source:gitapn.@0150.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			//提交210，保存要预览的pdf资源
			StringBuffer labels = new StringBuffer();
			StringBuffer tempfiles = new StringBuffer();
			int cnt = 0;

			if("X".equals(this.getGidgrp().getBhcnschk()))						//是否含承诺书
			{
			  labels = labels.append("保函开立申请书暨承诺书");
			  tempfiles =  tempfiles.append("A:klbhsqsjcns");
			  cnt++;
			}
			else
			{
			  labels = labels.append("保函开立申请");
			  tempfiles =  tempfiles.append("A:bhklsqs");
			  cnt++;
			}

			if("10".equals(this.getGidgrp().getRec().getLgtyp()))						//银行信贷证明
			{
			  labels = labels.append(",信贷基本情况,银行信贷证明");
			  tempfiles =  tempfiles.append(",A:yhxdsq,A:yhxdxy");
			  cnt+=2;
			}

			/*
			  if("2".equals($gidgrp\\rec\\bhxz.getValue())||"3".equals($gidgrp\\rec\\bhxz.getValue()))  //分离式保函开立协议
			  {
			  labels = labels.append(",保函开立协议");
			  tempfiles =  tempfiles.append(",A:gitapnst09");
			  cnt++;
			  }
			  */

			if(!MdaUtils.isEmpty(this.getGidgrp().getBzjzyxy()))  //已勾选保证金质押协议
			{
			  labels = labels.append(",保证金质押协议");
			  tempfiles =  tempfiles.append(",A:bzjzyxy");
			  cnt++;
			}

			if("1".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  labels = labels.append(",保函开立申请报文草稿");
			  tempfiles =  tempfiles.append(",A:lgtxt");
			  cnt++;
			}
			else if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  labels = labels.append(",保函开立申请报文草稿");
			  tempfiles =  tempfiles.append(",S:lgtxt");
			  cnt++;
			}

			String label = labels.toString();
			String tempfile = tempfiles.toString();
			this.getTrnmod().getApldoc().setPDFInfo(cnt,label,tempfile);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:gitapn.@0156.script
        */
        @Rule(target="gitp.stpmod.next",order=110)
        public boolean ruleGitpStpmodNextN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getGitp().getStpmod().getCuridx();
			log.info("{}","下一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:gitapn.@0158.script
        */
        @Rule(target="gitp.sel",order=100)
        public boolean ruleGitpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getWbtyp())||MdaUtils.isEmpty(this.getGidgrp().getRec().getLgtyp()))
			{
			  ctx.setFieldError(this,"gitp.gidgrp.rec.lgtyp",MdaUtils.getI18NString("gitapn","CT000072"));
			  return false;
			}
			MdaUtils.clear(this.getGidgrp().getGidlst());

			String selClause = "SELECT rec.inr trninr, rec.ownref ownref, rec.lgtyp lgtyp, rec.wbtyp wbtyp, trim(dbms_lob.substr(b.lgtxt,8000)) as lgtxt FROM pts s， gid rec left outer join gib b on  rec.inr = b.inr WHERE substr(rec.stlref,0,2) = 'LG' AND lgtxt is not NULL AND s.rol = 'ben' AND s.objtyp = 'gid' AND s.objinr = rec.inr AND rec.lgtyp ='" + this.getGidgrp().getRec().getLgtyp() + "' AND rec.wbtyp = '" + this.getGidgrp().getRec().getWbtyp() + "'" ;
			ctx.getDaoSession().dbExecuteSQL(selClause);
			ctx.getErrorCode();
			log.debug("{}","selgib的sql===================" + selClause);
			Argument<String> trninr = new Argument<String>("trninr");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> lgtyp = new Argument<String>("lgtyp");
			Argument<String> wbtyp = new Argument<String>("wbtyp");
			Argument<String> lgtxt = new Argument<String>("lgtxt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trninr,ownref,lgtyp,wbtyp,lgtxt);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getGidgrp().getGidlst().add(trninr,ownref,lgtyp,wbtyp,lgtxt);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			


			return true;
        }

        /**
        *   source:gitapn.@0159.script
        */
        @Rule(target="gitp.sure",order=100)
        public boolean ruleGitpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in sure...");
			int index = 0;
			int length = this.getGidgrp().getGidlst().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitapn","CT000077"),MdaUtils.getI18NString("gitapn","CT000078"));
			  return true;
			}
			log.debug("{}",this.getGidgrp().getGidlst().getElement(index).getLgtxt());
			this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGidlst().getElement(index).getLgtxt());
			
			

			return true;
        }

        /**
        *   source:gitapn.@0160.script
        */
        @Rule(target="gitp.cancel",order=100)
        public boolean ruleGitpCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:gitapn.@0161.script
        */
        @Rule(target="mtabut.mail",order=100)
        public boolean ruleMtabutMailN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("gitapnApp"+inr,"gitapn");
			this.getMtabut().creatTcoPdfFile("gitapnDra"+inr);
			this.getMtabut().setAttnames("gitapnApp"+inr+".pdf;gitapnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:gitapn.@0162.script
        */
        @Rule(target="mtabut.csche",order=100)
        public boolean ruleMtabutCscheN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flags2();
			if("X".equals(this.getGidgrp().getBhcnschk()))  //已勾选在线办理申请人承诺书
			{
			  this.getGitp().getPdfviw().callPDFComponent("","klbhsqsjcns","保函开立申请书暨承诺书",1);
			}
			else
			{
			  this.getGitp().getPdfviw().callPDFComponent("","bhklsqs","保函开立申请书",1);
			}

			return true;
        }

        /**
        *   source:gitapn.@0163.script
        */
        @Rule(target="mtabut.draftmsg",order=100)
        public boolean ruleMtabutDraftmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getPdfviw().callSwiftPDFComponent("",ctx.getTransName(),"保函草稿",1);
			}
			else
			{
			  this.getGitp().getPdfviw().callPDFComponent("","lgtxt","保函草稿",1);
			}

			return true;
        }

        /**
        *   source:gitapn.@0174.script
        */
        @Rule(target="gitp.stpmod.last",order=50)
        public boolean ruleGitpStpmodLastN50(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getGitp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getGitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			
			
			
			
			
			
			

			Boolean bool = ctx.checkAll(this.getGidgrp().getRec())&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getBenp().getPtspta().getPts())&&ctx.checkAll(this.getGitp().getAdvp().getPtspta().getPts());
			//分离式保函--保函性质（融资、非融资）
			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			{
			  bool = bool && ctx.checkAll(this.getGitp().getSecp().getPtspta().getPts());
			}

			switch(panelidx)
			{

			  case 0:
			  if(MdaUtils.isEmpty(this.getGidgrp().getAgree()))
			    ctx.setFieldError(this,"gidgrp.agree",MdaUtils.getI18NString("gitapn","CT000098"));
			  return !MdaUtils.isEmpty(this.getGidgrp().getAgree());

			  case 1:
			  {

			    return bool&&ctx.checkAll(this.getGitp().getAplp().getPtspta().getPty());
			  }

			  case 2:
			  {
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());
			  }

			  case 3:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());

			  }
			  case 4:
			  {
			    
			    
			    
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr())&&ctx.checkAll(this.getGidgrp().getSec().getPty())&&ctx.checkAll(this.getGidgrp().getSec().getAdr())&&ctx.checkAll(this.getGidgrp().getBen().getPty());

			  }

			  case 5:
			  {
			    
			    
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr())&&ctx.checkAll(this.getGidgrp().getIsb().getPty())&&ctx.checkAll(this.getGidgrp().getIsb().getAdr());
			  }
			  case 6:
			  {
			    
			    
			    return ctx.checkAll(this.getGidgrp().getApl().getPty())&&ctx.checkAll(this.getGidgrp().getApl().getAdr());
			  }
			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:gitapn.@0177.script
        */
        @Rule(target="gitp.benp.ptspta.pts.adrblk",order=100)
        public boolean ruleGitpBenpPtsptaPtsAdrblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGitp().getBenp().getPtspta().getPts().getExtkey()))
			{
			  //String[] res = $gitp\\benp\\ptspta\\pts\\adrblk.getValue().split("\\n\\r",2);
			  String[] res = this.getGitp().getBenp().getPtspta().getPts().getAdrblk().split("\n",2);
			  log.info("{}","res length :" + res.length);
			  this.getGidgrp().getBen().getPty().setNam(res[0]);
			  
			  if(res.length==2)
			  {
			    this.getGidgrp().getBen().getAdr().setAdr(res[1]);
			    
			  }
			  log.info("{}","nam :" + this.getGidgrp().getBen().getPty().getNam());
			  log.info("{}","adr :" + this.getGidgrp().getBen().getAdr().getAdr());
			}

			return true;
        }

        /**
        *   source:gitapn.@0178.script
        */
        @Rule(target="gitp.aplp.sure",order=110)
        public boolean ruleGitpAplpSureN110(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGitp().getAplp().getPtspta().getPts().setAdrblk(this.getGitp().getAplp().getPtspta().getPty().getEngnam() + CR + this.getGitp().getAplp().getPtspta().getAdr().getEnadr());
			}

			return true;
        }

        /**
        *   source:gitapn.@0179.script
        */
        @Rule(target="gitp.aplp.ptslst",order=110)
        public boolean ruleGitpAplpPtslstN110(){
            IContext ctx = MdaEnv.getContext();
            
			String adrblk = "";
			if("2".equals(this.getGitp().getGidgrp().getRec().getWbtyp()))
			{
			  if(MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEngnam())&&MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEnadr()))
			    adrblk = "";
			  else if(!MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEngnam())&&MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEnadr()))
			    adrblk = this.getGitp().getAplp().getPtsp().getEngnam();
			  else if(MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEngnam())&&!MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getEnadr()))
			    adrblk = this.getGitp().getAplp().getPtsp().getEnadr();
			  else
			    adrblk = this.getGitp().getAplp().getPtsp().getEngnam() + CR + this.getGitp().getAplp().getPtsp().getEnadr();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getNam())&&MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getAdr()))
			    adrblk = "";
			  else if(!MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getNam())&&MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getAdr()))
			    adrblk = this.getGitp().getAplp().getPtsp().getNam();
			  else if(MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getNam())&&!MdaUtils.isEmpty(this.getGitp().getAplp().getPtsp().getAdr()))
			    adrblk = this.getGitp().getAplp().getPtsp().getAdr();
			  else
			    adrblk = this.getGitp().getAplp().getPtsp().getNam() + CR + this.getGitp().getAplp().getPtsp().getAdr();
			}
			this.getGitp().getAplp().setAdrblk(adrblk);

			return true;
        }

        /**
        *   source:gitapn.@0183.script
        */
        @Rule(target="gitp.gidgrp.rec.bhcxsf",order=100)
        public boolean ruleGitpGidgrpRecBhcxsfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("Y".equals(this.getGitp().getGidgrp().getRec().getBhcxsf()))
			{
			  this.getGidgrp().setBhcxsf1("√");
			  this.getGidgrp().setBhcxsf2("");
			}
			else
			{
			  this.getGidgrp().setBhcxsf1("");
			  this.getGidgrp().setBhcxsf2("√");
			}
			
			

			return true;
        }

        /**
        *   source:gitapn.@0184.script
        */
        @Rule(target="gitp.gidgrp.test",order=100)
        public boolean ruleGitpGidgrpTestN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cls  = "com.brilliance.eibs.main.Client";
			String v1 = "netcus";
			String v2 = "20200114";
			MdaUtils.invoke(cls,"scall","sgnwinclient","sgnwinclient",new Object[]{v1,v2});

			return true;
        }


        /**
        *   source:gitapn.@0004.script
        */
        @Check(target="gitp.gidgrp.rec.lgcur",order=100)
        public boolean checkGitpGidgrpRecLgcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getLgcur()))
			{
			  BigDecimal lgamt = this.getGitp().getGidgrp().getRec().getLgamt();
			  String lgamt1 = lgamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  lgamt = MdaUtils.parseDecimal(lgamt1);
			  this.getGitp().getGidgrp().getRec().setLgamt(lgamt);
			  
			}
			/*
			  if(Platform.isEmpty($gitp\\gidgrp\\rec\\lgcur))
			  {
			  Platform.error($gitp\\gidgrp\\rec\\lgcur,#CT000016);
			
			  return false;
			  }
			  */

			return true;
        }

        /**
        *   source:gitapn.@0005.script
        */
        @Check(target="gitp.gidgrp.rec.lgamt",order=100)
        public boolean checkGitpGidgrpRecLgamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal lgamt = this.getGitp().getGidgrp().getRec().getLgamt();
			int num = lgamt.signum();
			if(num<0)
			{
			  ctx.setFieldError(this,"gidgrp.rec.lgamt",MdaUtils.getI18NString("gitapn","CT000015"));
			  this.getGitp().getGidgrp().getRec().setLgamt(new BigDecimal(0));
			  
			  return true;
			}
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getLgcur()))
			{
			  String lgamt1 = lgamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  lgamt = MdaUtils.parseDecimal(lgamt1);
			  this.getGitp().getGidgrp().getRec().setLgamt(lgamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0164.script
        */
        @Check(target="gitp.gidgrp.rec.engamt",order=100)
        public boolean checkGitpGidgrpRecEngamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal engamt = this.getGitp().getGidgrp().getRec().getEngamt();
			int num = engamt.signum();
			if(num<0)
			{
			  ctx.setFieldError(this,"gidgrp.rec.engamt",MdaUtils.getI18NString("gitapn","CT000081"));
			  this.getGitp().getGidgrp().getRec().setEngamt(new BigDecimal(0));
			  
			  return true;
			}
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getEngcur()))
			{
			  String engamt1 = engamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  engamt = MdaUtils.parseDecimal(engamt1);
			  this.getGitp().getGidgrp().getRec().setEngamt(engamt);
			  
			}


			return true;
        }

        /**
        *   source:gitapn.@0165.script
        */
        @Check(target="gitp.gidgrp.rec.dkllsf",order=100)
        public boolean checkGitpGidgrpRecDkllsfN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal dkllsf = this.getGitp().getGidgrp().getRec().getDkllsf();
			int num = dkllsf.signum();
			if(num<0)
			{
			  this.getGitp().getGidgrp().getRec().setDkllsf(new BigDecimal(0));
			  
			  ctx.setFieldError(this,"gidgrp.rec.dkllsf",MdaUtils.getI18NString("gitapn","CT000083"));
			  return true;
			}

			return true;
        }

        /**
        *   source:gitapn.@0166.script
        */
        @Check(target="gitp.gidgrp.rec.bhbzjbl",order=100)
        public boolean checkGitpGidgrpRecBhbzjblN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal bhbzjbl = this.getGitp().getGidgrp().getRec().getBhbzjbl();
			int num = bhbzjbl.signum();
			if(num<0)
			{
			  this.getGitp().getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  
			  ctx.setFieldError(this,"gidgrp.rec.bhbzjbl",MdaUtils.getI18NString("gitapn","CT000084"));
			  return true;
			}

			return true;
        }

        /**
        *   source:gitapn.@0167.script
        */
        @Check(target="gitp.gidgrp.rec.sffl",order=100)
        public boolean checkGitpGidgrpRecSfflN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal sffl = this.getGitp().getGidgrp().getRec().getSffl();
			int num = sffl.signum();
			if(num<0)
			{
			  this.getGitp().getGidgrp().getRec().setSffl(new BigDecimal(0));
			  
			  ctx.setFieldError(this,"gidgrp.rec.sffl",MdaUtils.getI18NString("gitapn","CT000085"));
			  return true;
			}

			return true;
        }

        /**
        *   source:gitapn.@0169.script
        */
        @Check(target="gitp.gidgrp.rec.engcur",order=100)
        public boolean checkGitpGidgrpRecEngcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getEngcur()))
			{
			  BigDecimal engamt = this.getGitp().getGidgrp().getRec().getEngamt();
			  String engamt1 = engamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  engamt = MdaUtils.parseDecimal(engamt1);
			  this.getGitp().getGidgrp().getRec().setEngamt(engamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0170.script
        */
        @Check(target="gitp.gidgrp.rec.bzjcur",order=100)
        public boolean checkGitpGidgrpRecBzjcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getBzjcur()))
			{
			  BigDecimal bzjamt = this.getGitp().getGidgrp().getRec().getBzjamt();
			  String bzjamt1 = bzjamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  bzjamt = MdaUtils.parseDecimal(bzjamt1);
			  this.getGitp().getGidgrp().getRec().setLgamt(bzjamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0171.script
        */
        @Check(target="gitp.gidgrp.rec.bzjamt",order=100)
        public boolean checkGitpGidgrpRecBzjamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getBzjcur()))
			{
			  BigDecimal bzjamt = this.getGitp().getGidgrp().getRec().getBzjamt();
			  String bzjamt1 = bzjamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  bzjamt = MdaUtils.parseDecimal(bzjamt1);
			  this.getGitp().getGidgrp().getRec().setLgamt(bzjamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0172.script
        */
        @Check(target="gitp.gidgrp.rec.pfcur",order=100)
        public boolean checkGitpGidgrpRecPfcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getPfcur()))
			{
			  BigDecimal pfamt = this.getGitp().getGidgrp().getRec().getPfamt();
			  String pfamt1 = pfamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  pfamt = MdaUtils.parseDecimal(pfamt1);
			  this.getGitp().getGidgrp().getRec().setPfamt(pfamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0173.script
        */
        @Check(target="gitp.gidgrp.rec.pfamt",order=100)
        public boolean checkGitpGidgrpRecPfamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getGitp().getGidgrp().getRec().getPfcur()))
			{
			  BigDecimal pfamt = this.getGitp().getGidgrp().getRec().getPfamt();
			  String pfamt1 = pfamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  pfamt = MdaUtils.parseDecimal(pfamt1);
			  this.getGitp().getGidgrp().getRec().setPfamt(pfamt);
			  
			}

			return true;
        }

        /**
        *   source:gitapn.@0185.script
        */
        @Check(target="gitp.gidgrp.rec.engamt",order=101)
        public boolean checkGitpGidgrpRecEngamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"engamt"));

			return true;
        }

        /**
        *   source:gitapn.@0186.script
        */
        @Check(target="gitp.gidgrp.rec.lgamt",order=101)
        public boolean checkGitpGidgrpRecLgamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"lgamt"));

			return true;
        }

        /**
        *   source:gitapn.@0189.script
        */
        @Check(target="gitp.gidgrp.rec.sffl",order=110)
        public boolean checkGitpGidgrpRecSfflN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"sffl"));

			return true;
        }

        /**
        *   source:gitapn.@0190.script
        */
        @Check(target="gitp.gidgrp.rec.bhbzjbl",order=110)
        public boolean checkGitpGidgrpRecBhbzjblN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"bhbzjbl"));

			return true;
        }

        /**
        *   source:gitapn.@0191.script
        */
        @Check(target="gitp.gidgrp.rec.dkllsf",order=110)
        public boolean checkGitpGidgrpRecDkllsfN110(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getGitp().getGidgrp().getRec(),"dkllsf"));

			return true;
        }


        /**
        *   source:gitapn.@0021.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitapn  init业务处理开始，ORDER编号:200");
			//默认消失掉模板查询交易
			
			//Platform.disable($gidgrp\\rec\\ownref);
			this.getGidgrp().getRec().setApldat(MdaUtils.today());
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			//本人申请界面勾选
			
			
			this.getGidgrp().setBaohanchk("X");
			this.getGidgrp().setYxchk("X");
			
			

			this.getGitp().loadTips();

			//初始化机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			}
			

			//界面默认数据初始化
			String time =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getGidgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			

			this.getGidgrp().getApl().getPty().setNam(this.getSysmod().getPty().getNam());
			log.debug("{}","message------------------"+this.getSysmod().getPty().getNam());
			
			

			
			

			//$gidgrp\\rec\\lgfmt.setValue("1");
			//$gidgrp\\rec\\opntyp.setValue("2");
			//$gidgrp\\rec\\txttyp.setValue("1");
			//$gidgrp\\rec\\apprul.setValue("1");
			
			//通知行编号和地址
			//Platform.enable($gitp\\advp\\ptspta\\pts\\extkey);
			//Platform.enable($gitp\\advp\\ptspta\\pts\\adrblk);
			//Platform.setRequired($gitp\\advp\\ptspta\\pts\\extkey);
			//Platform.setRequired($gitp\\advp\\ptspta\\pts\\adrblk);
			
			
			
			if("2".equals(this.getGidgrp().getRec().getOpntyp()))  //开立方式  电开时     通知行为必输项
			{
			  
			}

			//司法诉讼地址
			

			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getGidgrp().getApl().initDap("gid");
			  this.getGidgrp().getApl().getPts().setRol("apl");
			  //log.info("message--------------"+$\\sysmod\\pty\\inr.getValue()+"-----------"+$gidgrp\\apl\\pty\\inr.getValue()+"------"+$gidgrp\\apl\\pta\\objinr.getValue());
			  ctx.getDaoSession().dbRead(this.getGidgrp().getIsb().getPty(),new Argument<String>("cid",this.getGidgrp().getRec().getBchcod()));
			  this.getGidgrp().getIsb().initIsb("gid",this.getGidgrp().getIsb().getPty().getInr());
			  //log.info("message--------------"+$\\sysmod\\pty\\inr.getValue()+"-----------"+$gidgrp\\isb\\pty\\inr.getValue()+"------"+$gidgrp\\isb\\pta\\objinr.getValue());
			  this.getGidgrp().getIsb().getPts().setRol("isb");
			  //onChangeOpntyp();
			
			  //
			  //保函开立界面初始化
			  //
			
			  //被担保人编号和地址
			  
			  this.getGitp().getSecp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getSecp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  
			  

			  //申请界面保证金
			  
			  
			  
			  
			  this.getGidgrp().setBzjzyxy(NULLSTR);
			  
			  
			  //Platform.disable($gidgrp\\rec\\sfsy);
			  //承诺书界面保证金
			  

			  //担保期限
			  this.getGidgrp().getRec().setDbqxsjq(MdaUtils.parseDate(time,"yyyyMMdd"));
			  String conTime = this.getGitp().covTime(MdaUtils.format(this.getGitp().getGidgrp().getRec().getDbqxsjq(),"yyyy-MM-dd"),"yyyy-MM-dd");
			  this.getGitp().getGidgrp().setDxqi(conTime);
			  
			  this.getGidgrp().getRec().setDbqxsjz(null);
			  
			  this.getGitp().getGidgrp().setCkrq("X");

			  //甲乙方
			  this.getGidgrp().getRec().setBbzrjyf(NULLSTR);
			  this.getGidgrp().getRec().setSyrjyf(NULLSTR);
			  
			  
			  
			  
			  
			  

			  //从维护的银行协议编号中取贸易融资综合协议编号
			  this.getGitp().getAgrp().qurAgrnum();
			  this.getGidgrp().getRec().setMyrzbh(this.getGitp().getAgrp().getTfn());
			  

			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{

			  //被担保人编号和地址
			  if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			  {
			    
			  }
			  else
			  {
			    
			    this.getGitp().getSecp().getPtspta().getPts().setExtkey(NULLSTR);
			    
			    
			    
			    
			  }

			  //申请界面保证金
			  if(MdaUtils.isEmpty(this.getGidgrp().getNedbzj()))
			  {
			    
			    
			    
			    
			    this.getGidgrp().setBzjzyxy(NULLSTR);
			    
			    
			    //Platform.disable($gidgrp\\rec\\sfsy);
			    //承诺书界面保证金
			    
			  }
			  else
			  {
			    
			    
			    
			    
			    //保证金质押协议勾选处理（待处理）
			    //Platform.clear($gidgrp\\bzjzyxy);
			    //Platform.setModified($gidgrp\\bzjzyxy);
			    //Platform.disable($gidgrp\\bzjzyxy);
			    //Platform.disable($gidgrp\\rec\\sfsy);
			    //承诺书界面保证金
			    if(MdaUtils.isEmpty(this.getGidgrp().getRec().getBhbzjbl()))
			    {
			      
			    }
			  }

			  //担保期限
			  if(MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjz()))
			  {
			    this.getGitp().getGidgrp().setCkrq("X");
			    
			  }

			  //甲乙方
			  if(MdaUtils.isEmpty(this.getGidgrp().getRec().getBbzrjyf())&&MdaUtils.isEmpty(this.getGidgrp().getRec().getSyrjyf()))
			  {
			    
			    
			    
			    
			  }
			  else
			  {
			    
			    
			    
			    
			  }

			  //保证金质押协议主合同
			  if("2".equals(this.getGidgrp().getRec().getSytk())||"3".equals(this.getGidgrp().getRec().getSytk()))
			  {
			    
			  }
			  else
			  {
			    
			  }

			  //保证金质押协议争议解决方式
			  if("2".equals(this.getGidgrp().getRec().getZyjjfs()))
			  {
			    
			    
			  }
			  else
			  {
			    
			    
			  }

			  //保函保证金质押协议编号(待处理    清理协议内容)
			  if("2".equals(this.getGidgrp().getRec().getZyxysy()))
			  {
			    
			  }

			  //带入中、英文合约名称
			  if("1".equals(this.getGidgrp().getRec().getWbtyp()))
			  {
			    this.getGidgrp().setWbtyp("CN");
			    
			    
			  }
			  else if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			  {
			    this.getGidgrp().setWbtyp("EN");
			    
			    
			  }
			  else
			  {
			    this.getGidgrp().setWbtyp("");
			    
			    
			  }
			  
			  
			  

			  //保函性质
			  if(("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))&&"2".equals(this.getGidgrp().getRec().getOpntyp2()))
			  {
			    this.getGidgrp().getRec().setOpntyp2(NULLSTR);
			    
			  }

			  //开立方式1
			  if("1".equals(this.getGidgrp().getRec().getOpntyp()))  //1、信开2、电开（信开就只有直开）
			  {
			    
			  }
			  else
			  {
			    this.getGidgrp().getRec().setCjfs(NULLSTR);
			    
			    
			  }

			  //开立方式2
			  if("2".equals(this.getGidgrp().getRec().getOpntyp2())||"3".equals(this.getGidgrp().getRec().getOpntyp2()))  //1、直开2、转开3、转递
			  {
			    
			    
			  }
			  else
			  {
			    this.getGidgrp().getRec().setZkzdhmc(NULLSTR);
			    
			    
			    
			  }

			  //开立方式2  处理保函性质，转开不能做分离式保函
			  if("2".equals(this.getGidgrp().getRec().getOpntyp2()))
			  {
			    
			  }
			  else
			  {
			    
			  }

			  /*
			    if("1".equals($gidgrp\\rec\\opntyp.getValue()))  //1、信开2、电开（信开就只有直开）
			    {
			    $gidgrp\\rec\\opntyp2.setValue("1");
			    Platform.setModified($gidgrp\\rec\\opntyp2);
			    Platform.disable($gidgrp\\rec\\opntyp2);
			    Platform.setNotRequired($gidgrp\\rec\\opntyp2);
			
			    Platform.enable($gidgrp\\rec\\cjfs);
			    }
			    else
			    {
			    Platform.enable($gidgrp\\rec\\opntyp2);
			    Platform.setRequired($gidgrp\\rec\\opntyp2);
			
			    Platform.clear($gidgrp\\rec\\cjfs);
			    Platform.setModified($gidgrp\\rec\\cjfs);
			    Platform.disable($gidgrp\\rec\\cjfs);
			    }
			
			    //1、直开2、转开3、转递
			    if("1".equals($gidgrp\\rec\\opntyp2.getValue()))
			    {
			    Platform.clear($gidgrp\\rec\\zkzdhmc);
			    Platform.setModified($gidgrp\\rec\\zkzdhmc);
			    Platform.disable($gidgrp\\rec\\zkzdhmc);
			    Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			    }
			    else
			    {
			    Platform.enable($gidgrp\\rec\\zkzdhmc);
			    Platform.setRequired($gidgrp\\rec\\zkzdhmc);
			    }
			    */
			}
			//索偿付款账号
			if("9".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  
			  if("X".equals(this.getGitp().getGidgrp().getHzzsbh()))
			  {
			    
			  }
			  else
			  {
			    this.getGitp().getGidgrp().getRec().setScfkzh(NULLSTR);
			    
			    
			  }
			}
			else
			{
			  this.getGitp().getGidgrp().setHzzsbh(NULLSTR);
			  
			  
			  this.getGitp().getGidgrp().getRec().setScfkzh(NULLSTR);
			  
			  
			}

			//大写金额
			
			
			
			//大写比例
			
			//企业扣款收费方式
			
			//Platform.setRequired($gidgrp\\rec\\sffl);
			//是否生成保函查询码
			if("Y".equals(this.getGidgrp().getRec().getBhcxsf()))
			{
			  this.getGidgrp().setBhcxsf1("√");
			  this.getGidgrp().setBhcxsf2("");
			}
			else
			{
			  this.getGidgrp().getRec().setBhcxsf("N");
			  this.getGidgrp().setBhcxsf1("");
			  this.getGidgrp().setBhcxsf2("√");
			}
			
			
			

			//初始化控制电子保函渠道
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getOpntyp())&&"2".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setIssuetxt(NULLSTR);
			  
			  
			  
			}
			//Platform.disable($gidgrp\\rec\\lgtxt);
			/*
			  Platform.invisible($mtabut\\busmod\\seltemplate);
			  Platform.setModified($mtabut\\busmod\\seltemplate);
			
			  Platform.disable($gidgrp\\rec\\ownref);
			  $gidgrp\\rec\\apldat.setValue(Platform.today());
			  if(Platform.isEmpty($sysmod\\spt\\ordinr))
			  $trnmod.ordNew();
			
			  //本人申请界面勾选
			  Platform.disable($gidgrp\\baohanchk);
			  Platform.disable($gidgrp\\xieyichk);
			  Platform.disable($gidgrp\\yxchk);
			  $gidgrp\\baohanchk.setValue("X");
			  $gidgrp\\xieyichk.setValue("X");
			  $gidgrp\\yxchk.setValue("X");
			  Platform.setModified($gidgrp\\baohanchk);
			  Platform.setModified($gidgrp\\xieyichk);
			  Platform.setModified($gidgrp\\yxchk);
			
			  $gitp.loadTips();
			
			  //初始化机构
			  List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			  Platform.setValues($gidgrp\\rec\\bchcod,bchcod);
			  Platform.setValues($gidgrp\\gxd\\bchcod,bchcod);
			  Platform.disable($gidgrp\\gxd\\bchcod);
			  Platform.setValues($gidgrp\\gxd\\jf,bchcod);
			  Platform.disable($gidgrp\\gxd\\jf);
			  Platform.setValues($gitp\\bxdmod\\bxd\\jf,bchcod);
			  Platform.disable($gitp\\bxdmod\\bxd\\jf);
			  if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			  {
			  $gidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			  $gidgrp\\gxd\\bchcod.setValue(bchcod.get(0).getValue());
			  $gidgrp\\gxd\\jf.setValue(bchcod.get(0).getValue());
			  $gitp\\bxdmod\\bxd\\jf.setValue(bchcod.get(0).getValue());
			  }
			
			  //保证金初始化
			  $gitp\\bxdmod\\bxd\\htmc.setValue("开立银行保函协议");
			  Platform.setModified($gitp\\bxdmod\\bxd\\htmc);
			  Platform.disable($gitp\\bxdmod\\bxd\\htmc);
			
			  $gitp\\bxdmod\\bxd\\ywzl.setValue("2");
			  Platform.setModified($gitp\\bxdmod\\bxd\\htmc);
			  Platform.disable($gitp\\bxdmod\\bxd\\ywzl);
			
			  //申请界面初始化
			  Platform.setRequired($gidgrp\\apl\\pts\\adrblk);
			  Platform.setRequired($gidgrp\\ben\\pts\\adrblk);
			  Platform.setDescription($gidgrp\\apl\\pts\\adrblk,#CT000023);
			  Platform.setDescription($gitp\\benp\\ptspta\\pts\\adrblk,#CT000024);
			  Platform.setDescription($gitp\\advp\\ptspta\\pts\\adrblk,#CT000034);
			  Platform.setDescription($gitp\\ctrp\\ptspta\\pts\\adrblk,#CT000035);
			
			  Platform.disable($gidgrp\\rec\\ownref);   //单证通编号
			  Platform.disable($gidgrp\\rec\\credat);   //申请日期
			  Platform.disable($gidgrp\\apl\\pts\\extkey);  //申请人
			  Platform.disable($gidgrp\\apl\\pts\\adrblk);  //申请人名址
			  Platform.disable($gidgrp\\rec\\dbqxsjq);  //担保时间起
			  Platform.disable($gidgrp\\rec\\dbqxsjz);  //担保时间止
			  Platform.disable($gidgrp\\rec\\dbqxshjq);  //担保事件起
			  Platform.disable($gidgrp\\rec\\dbqxshjz);  //担保事件止
			  Platform.disable($gidgrp\\rec\\apprultxt);  //担保事件止
			  Platform.disable($gidgrp\\rec\\fdbdqdat);   //反担保日期灰显
			  Platform.disable($gitp\\ctrp\\ptspta\\pts\\adrblk);
			  Platform.disable($gitp\\ctrp\\ptspta\\pts\\extkey);
			
			  //合同界面初始化
			  Platform.disable($gidgrp\\gxd\\ownref);  //包含合同编号
			  Platform.disable($gidgrp\\gxd\\jf);
			  Platform.disable($gidgrp\\gxd\\dyqrq);
			  Platform.disable($gidgrp\\gxd\\dyqcur);
			  Platform.disable($gidgrp\\gxd\\dyqamtcn);
			  Platform.disable($gidgrp\\gxd\\deqre);
			  Platform.disable($gidgrp\\gxd\\deqcur);
			  Platform.disable($gidgrp\\gxd\\deqamtcn);
			  Platform.disable($gidgrp\\gxd\\qt);
			  Platform.disable($gidgrp\\gxd\\zcwyh);  //争议解决方式下方三个栏位灰显
			  Platform.disable($gidgrp\\gxd\\ktdd);
			  Platform.disable($gidgrp\\gxd\\qtfs);
			  Platform.disable($gidgrp\\gxd\\bzjcur);  //协议保证金币种灰显
			  Platform.disable($gidgrp\\gxd\\bzjamtcn);   //协议保证金大写金额灰显
			  Platform.disable($gidgrp\\bxd\\cur);    //保证金申请界面保证金币种灰显
			  Platform.disable($gidgrp\\bxd\\amt);   //保证金申请界面保证金额灰显
			
			  if($\\sysmod.sptIsLoaded("B")  ||  $\\sysmod.sptIsLoaded("P")  ||  $\\sysmod.sptIsLoaded("T"))
			  {
			  initMainCtl();
			  onChangeOpntyp();
			  return;
			  }
			  else
			  {
			  //界面默认数据初始化
			  String time =Platform.format(Platform.today(),"yyyyMMdd");
			  $gidgrp\\rec\\credat.setValue(Platform.parseDate(time ,"yyyyMMdd"));
			  Platform.disable($gidgrp\\rec\\credat);
			
			  $gidgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			  Platform.disable($gidgrp\\apl\\pts\\nam);
			  Platform.disable($gidgrp\\rec\\apprultxt);
			
			  $gidgrp\\rec\\lgfmt.setValue("1");
			  $gidgrp\\rec\\opntyp.setValue("2");
			  $gidgrp\\rec\\txttyp.setValue("1");
			  $gidgrp\\rec\\apprul.setValue("1");
			
			  //出具方式关联控制
			  List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			  cjfs.add(new CodetableItem("由你行委托XX银行通知受益人","3"));
			  cjfs.add(new CodetableItem(" 由你行委托XX银行开出反担保","4"));
			  Platform.setValues($gidgrp\\rec\\cjfs,cjfs);
			  $gidgrp\\rec\\cjfs.setValue("3");
			  Platform.setModified($gidgrp\\rec\\cjfs);
			  //受益人收件地址
			  //受益人联系人信息
			  Platform.setNotRequired($gidgrp\\rec\\syrsjdz);
			  Platform.setNotRequired($gidgrp\\rec\\syrlxrxx);
			  Platform.disable($gidgrp\\rec\\syrsjdz);
			  Platform.disable($gidgrp\\rec\\syrlxrxx);
			
			  Platform.setNotRequired($gidgrp\\rec\\bhdqdat);//保函到期日
			  Platform.setNotRequired($gidgrp\\rec\\syrsjdz);  //受益人收件地址
			
			  //通知行编号和地址
			  Platform.enable($gitp\\advp\\ptspta\\pts\\extkey);
			  Platform.enable($gitp\\advp\\ptspta\\pts\\adrblk);
			  Platform.setRequired($gitp\\advp\\ptspta\\pts\\extkey);
			  Platform.setRequired($gitp\\advp\\ptspta\\pts\\adrblk);
			
			  //反担保行编号和地址
			  Platform.setNotRequired($gitp\\ctrp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($gitp\\ctrp\\ptspta\\pts\\extkey);
			  Platform.disable($gitp\\ctrp\\ptspta\\pts\\extkey);
			  Platform.disable($gitp\\ctrp\\ptspta\\pts\\adrblk);
			
			  Platform.disable($gidgrp\\rec\\fdbdqdat);  //反担保到期日
			  Platform.setNotRequired($gidgrp\\rec\\fdbdqdat);
			
			  //保函期限类型关联控制
			  $gidgrp\\rec\\dbqxtyp.setValue("1");
			  Platform.enable($gidgrp\\rec\\dbqxsjq);
			  Platform.enable($gidgrp\\rec\\dbqxsjz);
			  Platform.setRequired($gidgrp\\rec\\dbqxsjq);
			  Platform.setRequired($gidgrp\\rec\\dbqxsjz);
			  Platform.disable($gidgrp\\rec\\dbqxshjq);
			  Platform.disable($gidgrp\\rec\\dbqxshjz);
			  Platform.clear($gidgrp\\rec\\dbqxshjq);
			  Platform.clear($gidgrp\\rec\\dbqxshjz);
			  Platform.setModified($gidgrp\\rec\\dbqxshjq);
			  Platform.setModified($gidgrp\\rec\\dbqxshjz);
			  Platform.setNotRequired($gidgrp\\rec\\dbqxshjq);
			  Platform.setNotRequired($gidgrp\\rec\\dbqxshjz);
			
			  $gidgrp\\apl.initDap("gid");
			  $gidgrp\\apl\\pts\\rol.setValue("apl");
			  onChangeOpntyp();
			
			  }*/

			return true;
        }

        /**
        *   source:gitapn.@0029.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  List<CodetableItem> jffs =  new ArrayList<CodetableItem>();
			  jffs.add(new CodetableItem("壹","1"));
			  jffs.add(new CodetableItem("贰","2"));
			  Platform.setValues($gidgrp\\gxd\\jffs,jffs);
			
			  List<CodetableItem> zyjjfs =  new ArrayList<CodetableItem>();
			  zyjjfs.add(new CodetableItem("壹","1"));
			  zyjjfs.add(new CodetableItem("贰","2"));
			  zyjjfs.add(new CodetableItem("叁","3"));
			  Platform.setValues($gidgrp\\gxd\\zyjjfs,zyjjfs);
			  */

			return true;
        }

        /**
        *   source:gitapn.@0033.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","gitapn  init业务处理开始，ORDER编号:90");
			//0、保函开立申明   1、保函开立申请   2、信贷基本情况   3、银行信贷证明  4、分离式保函开立协议 5、保证金质押协议  6、申请人承诺书   7、申请书展示
			this.getGitp().getStpmod().storePanel(this.getGitp().getGitapnst01(),this.getGitp().getGitapnst02(),this.getGitp().getGitapnst05(),this.getGitp().getGitapnst06(),this.getGitp().getGitapnst09(),this.getGitp().getGitapnst03(),this.getGitp().getGitapnst04(),this.getGitp().getGitapnst07());
			String steps = "0:保函开立申明;1:保函开立申请;7:合同展示";
			

			String flags=this.getGidgrp().getRec().getFlags();
			log.debug("{}","标志位flags="+flags);

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  StringBuffer stepsB = new StringBuffer();
			  stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");

			  if("10".equals(this.getGidgrp().getRec().getLgtyp()))  //银行信贷证明
			  {
			    stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");
			    
			    
			  }
			  else
			  {
			    
			    
			  }
			  if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))  //分离式保函开立协议
			  {
			    stepsB = stepsB.append("4:保函开立协议;");
			  }

			  if("0011".equals(flags))  //已勾选保证金质押协议
			  {
			    stepsB = stepsB.append("5:保证金协议;");
			    
			    this.getGidgrp().setBzjzyxy("X");
			    
			  }
			  else
			  {
			    
			    this.getGidgrp().setBzjzyxy("");
			    
			  }

			  if("X".equals(this.getGidgrp().getBhcnschk()))  //已勾选在线办理申请人承诺书
			  {
			    stepsB = stepsB.append("6:申请人承诺书;");
			    this.getGidgrp().setBhcnschk("X");
			    
			  }
			  else
			  {
			    this.getGidgrp().setBhcnschk("");
			    
			  }
			  String stepss= "";
			  steps = stepss+stepsB.append("7:合同展示");
			}
			else
			{ //new申请
			  this.getGidgrp().getRec().setFlags("0000");
			  
			  
			  
			  
			}

			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();

			/*
			  {
			  log.debug("gitapn  init业务处理开始，ORDER编号:90");
			  $gitp\\stpmod.storePanel($gitp\\gitapnstep01,$gitp\\gitapnstep02,$gitp\\gitapnstep04,$gitp\\gitapnstep05,$gitp\\gitapnstep06,$gitp\\gitapnstep07);
			  String steps = "0:保函开立申明;1:保函开立申请;2:保函合同开立;5:合同展示;";
			  Platform.invisible($gitp\\pdfbxd);
			  Platform.invisible($gitp\\pdfmar);
			  String flags=$gidgrp\\rec\\flags.getValue();
			  log.debug("标志位flags="+flags);
			
			  if($\\sysmod.sptIsLoaded("B")  ||  $\\sysmod.sptIsLoaded("P")  ||  $\\sysmod.sptIsLoaded("T"))
			  {
			  if("0011".equals(flags))  //已勾选在线办理保证金
			  {
			  steps =  "0:保函开立申明;1:保函开立申请;2:保函合同开立;3:保证金协议;4:委托开户扣划;5:合同展示";
			  $gitp\\gidgrp\\bzjchk.setValue("X");
			  Platform.setModified($gitp\\gidgrp\\bzjchk);
			  $gitp\\gidgrp\\checked.setValue("X");
			  Platform.setModified($gitp\\gidgrp\\checked);
			  Platform.visible($gitp\\pdfbxd);
			  Platform.visible($gitp\\pdfmar);
			  }
			  }
			  else
			  { //new申请
			  $gidgrp\\rec\\flags.setValue("0000");
			  Platform.setModified($gidgrp\\rec\\flags);
			  Platform.invisible($gitp\\pdfbxd);
			  Platform.invisible($gitp\\pdfmar);
			  }
			
			  $gitp\\stpmod.setPages(steps);
			  $gitp\\stpmod.calcSteps();
			  }*/

			return true;
        }


        /**
        *   source:gitapn.@0022.script
        */
        public void onChangeOpntyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","onChangeOpntyp=="+this.getGidgrp().getRec().getOpntyp());
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  
			  
			  //Platform.disable($gitp\\advp\\ptspta\\pts\\extkey);
			  //Platform.disable($gitp\\advp\\ptspta\\pts\\adrblk); 放开通知行相关
			  //Platform.disable($gitp\\advp\\sel);
			  
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setFurtyp(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
		}
        /**
        *   source:gitapn.@0035.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ="";
			log.debug("{}","message"+this.getGidgrp().getRec().getOpntyp());
			log.debug("{}","opntyp="+this.getGidgrp().getRec().getOpntyp());
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  typ=MdaUtils.getCodetableLabel("furtyp",this.getGidgrp().getRec().getFurtyp());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getGidgrp().getAdv().getPts().getNam()))
			    typ="由贵行委托"+this.getGidgrp().getAdv().getPts().getNam()+"银行（SWIFT NO."+this.getGidgrp().getAdv().getPts().getExtkey()+"英文全称"+this.getGidgrp().getAdv().getPts().getAdrblk()+")通知受益人。";
			}
			this.getGidgrp().setTyp(typ);
		}
        /**
        *   source:gitapn.@0059.script
        */
        public void dealGxd(String objinr,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**处理保函开立协议
			  objinr：业务数据inr
			  objtyp:业务表名*/
			log.debug("{}","dealGxd处理开始    ");
			this.getGidgrp().getGxd().setInr(Platform.sdbCounter("gxd"));
			this.getGidgrp().getGxd().setObjinr(objinr);
			this.getGidgrp().getGxd().setObjtyp(objtyp);
			ctx.getDaoSession().dbInsert(this.getGidgrp().getGxd());
		}
        /**
        *   source:gitapn.@0071.script
        */
        public void initMainCtl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//由暂存，模板界面进入保函申请，界面控件初始化
			//开立方式
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			  cjfs.add(new CodetableItem("由你行经本申请人交受益人","1"));
			  cjfs.add(new CodetableItem("由你行直接邮寄受益人","2"));
			  MdaUtils.setValues(this.getGidgrp().getRec(),"cjfs",cjfs);
			  
			}
			else if("2".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			  cjfs.add(new CodetableItem("由你行委托XX银行通知受益人","3"));
			  cjfs.add(new CodetableItem("由你行委托XX银行开出反担保","4"));
			  MdaUtils.setValues(this.getGidgrp().getRec(),"cjfs",cjfs);
			  
			}

			//出具方式
			if("2".equals(this.getGidgrp().getRec().getCjfs()))  //出具方式选2
			{
			   //受益人收件地址
			  //受益人联系人信息
			  //保函到期日
			
			  //反担保行编号和地址
			  
			  
			  this.getGitp().getCtrp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getCtrp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  //通知行编号和地址
			  
			  
			  this.getGitp().getAdvp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getAdvp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  this.getGidgrp().getRec().setFdbdqdat(null);   //反担保到期日
			  
			  
			  

			}
			else if("3".equals(this.getGidgrp().getRec().getCjfs()))
			{
			  //保函到期日
			
			  this.getGidgrp().getRec().setSyrsjdz(NULLSTR);   //受益人收件地址
			  
			  
			  
			  this.getGidgrp().getRec().setSyrlxrxx(NULLSTR);   //受益人联系人信息
			  
			  
			  

			  //通知行编号和地址
			  
			  
			  
			  

			  //反担保行编号和地址
			  
			  
			  this.getGitp().getCtrp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getCtrp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  this.getGidgrp().getRec().setFdbdqdat(null);  //反担保到期日
			  
			  
			  

			}
			else if("4".equals(this.getGidgrp().getRec().getCjfs()))
			{
			  //保函到期日
			  //反担保到期日
			  //保函到期日
			  //反担保到期日
			
			  //反担保行编号和地址
			  
			  
			  
			  

			  //通知行编号和地址
			  
			  
			  this.getGitp().getAdvp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getAdvp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  this.getGidgrp().getRec().setSyrsjdz(NULLSTR);   //受益人收件地址
			  
			  
			  
			  this.getGidgrp().getRec().setSyrlxrxx(NULLSTR);   //受益人联系人信息
			  
			  
			  

			  ctx.getDaoSession().dbRead(this.getGidgrp().getGit(),new Argument("guatyp","10"));
			  this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGit().getGuatxt());
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setSyrsjdz(NULLSTR);   //受益人收件地址
			  
			  
			  
			  this.getGidgrp().getRec().setSyrlxrxx(NULLSTR);   //受益人联系人信息
			  
			  
			  

			  //保函到期日
			
			  //反担保行编号和地址
			  
			  
			  this.getGitp().getCtrp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getCtrp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  //通知行编号和地址
			  
			  
			  this.getGitp().getAdvp().getPtspta().getPts().setExtkey(NULLSTR);
			  this.getGitp().getAdvp().getPtspta().getPts().setAdrblk(NULLSTR);
			  
			  
			  
			  

			  this.getGidgrp().getRec().setFdbdqdat(null);   //反担保到期日
			  
			  
			  
			}

			//担保规则
			if("4".equals(this.getGidgrp().getRec().getApprul()))
			{
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setApprultxt(NULLSTR);
			  
			  
			  
			}
			//担保期限类型
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxtyp()))
			{
			  
			  
			  this.getGidgrp().getRec().setDbqxsjq(null);
			  this.getGidgrp().getRec().setDbqxsjz(null);
			  
			  
			  
			  

			  
			  
			  this.getGidgrp().getRec().setDbqxshjq(NULLSTR);
			  this.getGidgrp().getRec().setDbqxshjz(NULLSTR);
			  
			  
			  
			  
			}
			else
			{
			  if("1".equals(this.getGidgrp().getRec().getDbqxtyp()))
			  {
			    
			    
			    
			    

			    
			    
			    this.getGidgrp().getRec().setDbqxshjq(NULLSTR);
			    this.getGidgrp().getRec().setDbqxshjz(NULLSTR);
			    
			    
			    
			    
			  }
			  else if("2".equals(this.getGidgrp().getRec().getDbqxtyp()))
			  {
			    
			    
			    
			    

			    
			    
			    this.getGidgrp().getRec().setDbqxsjq(null);
			    this.getGidgrp().getRec().setDbqxsjz(null);
			    
			    
			    
			    
			  }
			}

			//受益人中文名称
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getBennamcn()))
			{
			  String bennamcn= this.getGitp().getGidgrp().getRec().getBennamcn();
			  this.getGidgrp().getGxd().setSyr(bennamcn);
			  
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setSyr(NULLSTR);
			  
			}

			//保证金币种
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getBzjcur()))
			{
			  String bzjcur= this.getGitp().getGidgrp().getRec().getBzjcur();
			  this.getGidgrp().getGxd().setBzjcur(bzjcur);
			  
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setBzjcur(NULLSTR);
			  
			}

			//保证金金额
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getBzjamt()))
			{
			  String bzjamtcn = this.getSysmod().covCnAmt(this.getGidgrp().getRec().getBzjamt(),this.getGidgrp().getRec().getBzjcur());
			  this.getGidgrp().getGxd().setBzjamtcn(bzjamtcn);
			  
			  this.getGidgrp().getBxd().setAmt(this.getGidgrp().getRec().getBzjamt());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setBzjamtcn(NULLSTR);
			  this.getGidgrp().getBxd().setAmt(new BigDecimal(0));
			}

			//计费方式
			if("1".equals(this.getGidgrp().getGxd().getJffs()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getGidgrp().getGxd().getJffs()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			//争议解决方式
			if("1".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}

			//保函币种
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getLgcur()))
			{
			  String lgcur= this.getGitp().getGidgrp().getRec().getLgcur();
			  this.getGidgrp().getGxd().setDbcur(lgcur);
			  
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setDbcur(NULLSTR);
			  
			}

			//保函金额
			if(!MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getLgamt()))
			{
			  BigDecimal lgamt= this.getGitp().getGidgrp().getRec().getLgamt();
			  this.getGidgrp().getGxd().setDbamt(lgamt);
			  
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setDbamt(new BigDecimal(0));
			  
			}
		}
        /**
        *   source:gitapn.@0075.script
        */
        public void flgs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//申请人中文名称和地址
			String adrblkcn = this.getGidgrp().getRec().getAplnamcn()+this.getGidgrp().getRec().getApladrcn();
			log.debug("{}","-----------申请人中文名称和地址:" + adrblkcn);
			this.setAdrblkcn(adrblkcn);
			

			//受益人中文名称和地址
			String benadrblkcn = this.getGidgrp().getRec().getBennamcn()+this.getGidgrp().getRec().getBenadrcn();
			log.debug("{}","------------受益人中文名称和地址:" + benadrblkcn);
			this.setBenadrblkcn(benadrblkcn);
			

			//保函适用方式
			if("1".equals(this.getGidgrp().getRec().getApprul()))
			{
			  this.setApprul("URDG");
			}
			else if("2".equals(this.getGidgrp().getRec().getApprul()))
			{
			  this.setApprul("ISPR");
			}
			else if("3".equals(this.getGidgrp().getRec().getApprul()))
			{
			  this.setApprul("NONE");
			}
			else if("4".equals(this.getGidgrp().getRec().getApprul()))
			{
			  this.setApprul("OTHER");
			}

			//保函类型
			if("1".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("投标保函");
			}
			else if("2".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("履约保函");
			}
			else if("3".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("履约保函");
			}
			else if("4".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("预付款保函");
			}
			else if("5".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("付款保函");
			}
			else if("6".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("借款保函");
			}
			else if("7".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("融资租赁保函");
			}
			else if("8".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("现汇偿还的补偿贸易保函");
			}
			else if("9".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("留置金保函");
			}
			else if("10".equals(this.getGidgrp().getRec().getLgtyp()))
			{
			  this.setLgtyp("其他");
			}
			/*
			  //保函类型
			  if("1".equals($gidgrp\\rec\\lgfmt.getValue()))
			  {
			  $lgtypflg1.setValue("√");
			  Platform.clear($lgtypflg2);
			  }
			  else if("2".equals($gidgrp\\rec\\lgfmt.getValue()))
			  {
			  $lgtypflg2.setValue("√");
			  Platform.clear($lgtypflg1);
			  }
			  */
			/*
			  //开立方式
			  if("1".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  $opntypflg1.setValue("√");
			  Platform.clear($opntypflg2);
			  }
			  else if("2".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  $opntypflg2.setValue("√");
			  Platform.clear($opntypflg1);
			  }
			  */
			/*
			  //保函文本格式
			  if("1".equals($gidgrp\\rec\\txttyp.getValue()))
			  {
			  $txttypflg1.setValue("√");
			  Platform.clear($txttypflg2);
			  }
			  else if("2".equals($gidgrp\\rec\\txttyp.getValue()))
			  {
			  $txttypflg2.setValue("√");
			  Platform.clear($txttypflg1);
			  }*/
			/*
			  //出具方式
			  if("1".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  $cjfsflg1.setValue("√");
			  Platform.clear($cjfsflg2);
			  Platform.clear($cjfsflg3);
			  Platform.clear($cjfsflg4);
			  }
			  else if("2".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  $cjfsflg2.setValue("√");
			  Platform.clear($cjfsflg1);
			  Platform.clear($cjfsflg3);
			  Platform.clear($cjfsflg4);
			  }
			  else if("3".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  $cjfsflg3.setValue("√");
			  Platform.clear($cjfsflg2);
			  Platform.clear($cjfsflg1);
			  Platform.clear($cjfsflg4);
			  }
			
			  else if("4".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  $cjfsflg4.setValue("√");
			  Platform.clear($cjfsflg2);
			  Platform.clear($cjfsflg3);
			  Platform.clear($cjfsflg1);
			  }
			  */
		}
        /**
        *   source:gitapn.@0124.script
        */
        public void flags2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//保函格式
			if("1".equals(this.getGidgrp().getRec().getLgfmt()))
			{
			  this.getGidgrp().setChkbhgs1("√");
			  this.getGidgrp().setChkbhgs2(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getLgfmt()))
			{
			  this.getGidgrp().setChkbhgs2("√");
			  this.getGidgrp().setChkbhgs1(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setChkbhgs2(NULLSTR);
			  this.getGidgrp().setChkbhgs1(NULLSTR);
			}

			//开出方式1
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  this.getGidgrp().setChkkcfs11("√");
			  this.getGidgrp().setChkkcfs12(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  this.getGidgrp().setChkkcfs12("√");
			  this.getGidgrp().setChkkcfs11(NULLSTR);
			}

			//开出方式2
			if("1".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setChkkcfs21("√");
			  this.getGidgrp().setChkkcfs22(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setChkkcfs22("√");
			  this.getGidgrp().setChkkcfs21(NULLSTR);
			}

			//出具方式
			if("1".equals(this.getGidgrp().getRec().getCjfs()))
			{
			  this.getGidgrp().setChkcjfs1("√");
			  this.getGidgrp().setChkcjfs2(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getCjfs()))
			{
			  this.getGidgrp().setChkcjfs2("√");
			  this.getGidgrp().setChkcjfs1(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setChkcjfs2(NULLSTR);
			  this.getGidgrp().setChkcjfs1(NULLSTR);
			}

			//保证金条款是否适用
			if("1".equals(this.getGidgrp().getRec().getSfsy()))
			{
			  this.getGidgrp().setBzjsy1("√");
			  this.getGidgrp().setBzjbsy1(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getSfsy()))
			{
			  this.getGidgrp().setBzjbsy1("√");
			  this.getGidgrp().setBzjsy1(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setBzjbsy1(NULLSTR);
			  this.getGidgrp().setBzjsy1(NULLSTR);
			}

			//质押协议是否适用
			if("1".equals(this.getGidgrp().getRec().getZyxysy()))
			{
			  this.getGidgrp().setZyxysy1("√");
			  this.getGidgrp().setZyxybsy1(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getZyxysy()))
			{
			  this.getGidgrp().setZyxybsy1("√");
			  this.getGidgrp().setZyxysy1(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setZyxybsy1(NULLSTR);
			  this.getGidgrp().setZyxysy1(NULLSTR);
			}

			//信贷证明书是否使用光大统一格式
			if("1".equals(this.getGidgrp().getRec().getXdzmsfty()))
			{
			  this.getGidgrp().setYhxdxysy1("√");
			  this.getGidgrp().setYhxdxybsy1(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getXdzmsfty()))
			{
			  this.getGidgrp().setYhxdxybsy1("√");
			  this.getGidgrp().setYhxdxysy1(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setYhxdxybsy1(NULLSTR);
			  this.getGidgrp().setYhxdxysy1(NULLSTR);
			}

			//质押协议主合同
			if("1".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().setZht1("√");
			  this.getGidgrp().setZht2(NULLSTR);
			  this.getGidgrp().setZht3(NULLSTR);
			}
			else if("2".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().setZht2("√");
			  this.getGidgrp().setZht1(NULLSTR);
			  this.getGidgrp().setZht3(NULLSTR);
			}
			else if("3".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().setZht3("√");
			  this.getGidgrp().setZht1(NULLSTR);
			  this.getGidgrp().setZht2(NULLSTR);
			}
			else
			{
			  this.getGidgrp().setZht1(NULLSTR);
			  this.getGidgrp().setZht2(NULLSTR);
			  this.getGidgrp().setZht3(NULLSTR);
			}
		}
        /**
        *   source:gitapn.@0125.script
        */
        public void dealStpmod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer stepsB = new StringBuffer();
			stepsB = stepsB.append("0:保函开立申明;1:保函开立申请;");
			if("10".equals(this.getGidgrp().getRec().getLgtyp()))						//银行信贷证明
			{
			  stepsB = stepsB.append("2:信贷基本情况;3:银行信贷证明;");
			  
			  
			}
			else
			{
			  
			  
			  this.dealxdzm();  //信贷证明
			}

			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))  //分离式保函开立协议
			{
			  stepsB = stepsB.append("4:保函开立协议;");
			}
			else
			{
			  this.dealbhxy();  //分离式保函开立协议
			}

			if(!MdaUtils.isEmpty(this.getGidgrp().getBzjzyxy()))  //已勾选保证金质押协议
			{
			  stepsB = stepsB.append("5:保证金协议;");
			  
			  this.getGidgrp().setBzjzyxy("X");
			  this.getGidgrp().getRec().setFlags("0011");
			  
			  
			}
			else
			{
			  
			  this.getGidgrp().setBzjzyxy("");
			  this.getGidgrp().getRec().setFlags("0001");
			  
			  

			  this.dealzyxy();  //保证金质押协议
			}

			if("X".equals(this.getGidgrp().getBhcnschk()))  //已勾选在线办理申请人承诺书
			{
			  stepsB = stepsB.append("6:申请人承诺书;");
			  this.getGidgrp().setBhcnschk("X");
			  
			}
			else
			{
			  this.getGidgrp().setBhcnschk("");
			  

			  this.dealcns();   //承诺书
			}
			String stepss= "";
			String steps = stepss+stepsB.append("7:合同展示");

			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();
		}
        /**
        *   source:gitapn.@0129.script
        */
        public void dealbhxy()  //处理分离式保函协议      界面移除时数据清理
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getGidgrp().getRec().setBzjcur(NULLSTR);
			this.getGidgrp().getRec().setBzjamt(new BigDecimal(0));
			this.getGidgrp().getRec().setCjbhtj(NULLSTR);
			this.getGidgrp().getRec().setBzfytk(NULLSTR);
			this.getGidgrp().getRec().setPfcur(NULLSTR);
			this.getGidgrp().getRec().setPfamt(new BigDecimal(0));
			this.getGidgrp().getRec().setYqll(new BigDecimal(0));
			this.getGidgrp().getRec().setTzqx(NULLSTR);
			this.getGidgrp().getRec().setZbthqx(NULLSTR);
			this.getGidgrp().getRec().setHtfs(NULLSTR);

			
			
			
			
			
			
			
			
			
			

			this.dealmyrz();   //贸易融资综合授信协议编号
			this.dealzyjjfs();  //争议解决方式
			this.dealbbzr();   //被保证人
			
		}
        /**
        *   source:gitapn.@0130.script
        */
        public void dealzyxy()  //保证金质押协议
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.dealsytk();   ////出质人开立保函适用条款
			this.dealmyrz();   //贸易融资综合授信协议编号
			this.dealzyjjfs();  //争议解决方式
					}
        /**
        *   source:gitapn.@0131.script
        */
        public void dealcns()   //承诺书
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getGidgrp().getNedbzj()))  //是否需要保证金
			{
			  
			  
			  
			  //Platform.disable($gidgrp\\rec\\sfsy);
			  
			  
			  
			  
			  
			  this.getGidgrp().setBzjzyxy(NULLSTR);
			  this.getGidgrp().getRec().setDbbzjzhm(NULLSTR);
			  this.getGidgrp().getRec().setDbbzjzh(NULLSTR);
			  this.getGidgrp().getRec().setSfsy(NULLSTR);
			  this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  //Platform.setRequired($gidgrp\\rec\\sfsy);
			  this.getGidgrp().getRec().setSfsy(NULLSTR);
			  

			  
			  this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  
			}

			this.getGidgrp().getRec().setDkllsf(new BigDecimal(0));
			this.getGidgrp().getRec().setSfsy(NULLSTR);
			this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			this.getGidgrp().getRec().setZyxysy(NULLSTR);
			this.getGidgrp().getRec().setBhbzjzyxyref(NULLSTR);
			
			
			
			
			
			

			this.dealmyrz();   //贸易融资综合授信协议编号
					}
        /**
        *   source:gitapn.@0132.script
        */
        public void dealxdzm()  //银行信贷证明
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getGidgrp().getRec().setXdzmyt(NULLSTR);
			this.getGidgrp().getRec().setXdzmsfty(NULLSTR);
			this.getGidgrp().getRec().setZbssgqx(null);
			
			
			
		}
        /**
        *   source:gitapn.@0133.script
        */
        public void dealbbzr()   //被保证人
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz())))
			{
			  this.getGidgrp().getSec().getPty().setNam(NULLSTR);
			  this.getGidgrp().getSec().getPty().setFddbr(NULLSTR);
			  this.getGidgrp().getSec().getAdr().setAdr(NULLSTR);
			  this.getGidgrp().getSec().getAdr().setFax(NULLSTR);
			  this.getGidgrp().getSec().getAdr().setTel(NULLSTR);
			  this.getGidgrp().getSec().getAdr().setPobzip(NULLSTR);

			  
			  
			  
			  
			  
			  
			}
		}
        /**
        *   source:gitapn.@0134.script
        */
        public void dealzyjjfs()    //争议解决方式
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!("2".equals(this.getGidgrp().getRec().getBhxz())&&"3".equals(this.getGidgrp().getRec().getBhxz()))&&MdaUtils.isEmpty(this.getGidgrp().getBzjzyxy()))
			{
			  this.getGidgrp().getRec().setZyjjfs(NULLSTR);
			  this.getGidgrp().getRec().setZcwyh(NULLSTR);
			  this.getGidgrp().getRec().setZcdd(NULLSTR);

			  
			  
			  

			  
			  
			  
			}
		}
        /**
        *   source:gitapn.@0135.script
        */
        public void dealmyrz()   //贸易融资综合授信协议编号
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))&&MdaUtils.isEmpty(this.getGidgrp().getBhcnschk())&&MdaUtils.isEmpty(this.getGidgrp().getBzjzyxy()))
			{
			  this.getGidgrp().getRec().setMyrzbh(NULLSTR);
			  
			}
		}
        /**
        *   source:gitapn.@0144.script
        */
        public String covCnPercent(BigDecimal per)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将数字转化为大写
			if (per == null)
			{
			  return "";
			}
			String strPer = per.toString();
			String[] number = { "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖" };
			String[] radices = { "仟", "", "拾", "佰" };
			String[] bigRadices = { "", "万", "亿", "万亿", "亿亿" };
			int idx = strPer.indexOf(".");
			String sInt = "";
			String sFlt = "";
			if(-1 == idx)
			{
			  sInt = strPer;
			  sFlt = "00";
			}
			else
			{
			  sInt = strPer.substring(0, idx);
			  sFlt = strPer.substring(idx + 1);
			  if( 1 == sFlt.length())
			  {
			    sFlt = sFlt + "0";
			  }
			}

			String cn = "百分之";
			int zeroC = 0;
			int len = sInt.length();
			for (int i = 0; i < len; i++) {
			  if (sInt.charAt(i) == '0')
			{
			  zeroC++;
			}
			else
			{
			  if (zeroC > 0)
			  {
			    cn = cn + "零";
			    zeroC = 0;
			  }
			  cn = cn + number[(sInt.charAt(i) - '1')];
			  cn = cn + radices[((len - i) % 4)];
			}
			if (((len - i) % 4 == 1) && (zeroC < 4))
			  cn = cn + bigRadices[((len - i) / 4)];
			}
			if (sFlt.equals("00"))
			{
			cn = cn + "整";
			}
			else
			{
			cn = cn + "点";
			if (!sFlt.substring(0, 1).equals("0"))
			  cn = cn + number[(sFlt.charAt(0) - '1')];
			else
			  cn = cn + "零";
			if (!sFlt.substring(1, 2).equals("0"))
			  cn = cn + number[(sFlt.charAt(1) - '1')];
			}
			return cn;
		}
        /**
        *   source:gitapn.@0155.script
        */
        public void reloadRule()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//保函适用规则
			if("4".equals(this.getGidgrp().getRec().getApprul()))
			{
			  
			}
			else
			{
			  
			}

			//保函性质
			if(("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))&&"2".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().getRec().setOpntyp2(NULLSTR);
			  
			}

			//开立方式1
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))  //1、信开2、电开（信开就只有直开）
			{
			  
			}
			else
			{
			  this.getGidgrp().getRec().setCjfs(NULLSTR);
			  
			  
			}

			//开立方式2
			if("2".equals(this.getGidgrp().getRec().getOpntyp2())||"3".equals(this.getGidgrp().getRec().getOpntyp2()))  //1、直开2、转开3、转递
			{
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setZkzdhmc(NULLSTR);
			  
			  
			  
			}

			//开立方式2  处理保函性质，转开不能做分离式保函
			if("2".equals(this.getGidgrp().getRec().getOpntyp2()))
			{
			  
			}
			else
			{
			  
			}

			/*
			  //开立方式
			  if("1".equals($gidgrp\\rec\\opntyp.getValue()))  //1、信开2、电开（信开就只有直开）
			  {
			  $gidgrp\\rec\\opntyp2.setValue("1");
			  Platform.setModified($gidgrp\\rec\\opntyp2);
			  Platform.disable($gidgrp\\rec\\opntyp2);
			  Platform.setNotRequired($gidgrp\\rec\\opntyp2);
			
			  Platform.enable($gidgrp\\rec\\cjfs);
			  }
			  else
			  {
			  Platform.enable($gidgrp\\rec\\opntyp2);
			  Platform.setRequired($gidgrp\\rec\\opntyp2);
			
			  Platform.clear($gidgrp\\rec\\cjfs);
			  Platform.setModified($gidgrp\\rec\\cjfs);
			  Platform.disable($gidgrp\\rec\\cjfs);
			  }
			
			  if("1".equals($gidgrp\\rec\\opntyp2.getValue()))  //1、直开2、转开3、转递
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			  }
			  else
			  {
			  Platform.enable($gidgrp\\rec\\zkzdhmc);
			  Platform.setRequired($gidgrp\\rec\\zkzdhmc);
			  }
			  */

			//被担保人编号和地址、分属甲乙方
			if("2".equals(this.getGidgrp().getRec().getBhxz())||"3".equals(this.getGidgrp().getRec().getBhxz()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  //名址信息
			  
			  this.getGitp().getSecp().getPtspta().getPts().setExtkey(NULLSTR);
			  
			  
			  
			  
			  //甲乙方
			  
			  
			  
			  
			}

			//申请界面保证金
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getDbbzjzhm())&&MdaUtils.isEmpty(this.getGidgrp().getRec().getDbbzjzh()))
			{
			  
			  
			  
			  
			  this.getGidgrp().setBzjzyxy(NULLSTR);
			  
			  
			  //Platform.disable($gidgrp\\rec\\sfsy);
			  //承诺书界面保证金
			  this.getGidgrp().getRec().setBhbzjbl(new BigDecimal(0));
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  //保证金质押协议勾选处理（待处理）
			  //Platform.clear($gidgrp\\bzjzyxy);
			  //Platform.setModified($gidgrp\\bzjzyxy);
			  //Platform.disable($gidgrp\\bzjzyxy);
			  //Platform.disable($gidgrp\\rec\\sfsy);
			  //承诺书界面保证金
			  if(MdaUtils.isEmpty(this.getGidgrp().getRec().getBhbzjbl()))
			  {
			    
			  }
			  else
			  {
			    
			  }
			  //保证金质押协议
			  if(MdaUtils.isEmpty(this.getGidgrp().getRec().getFlags()))
			  {
			    
			  }
			  else
			  {
			    
			  }
			}

			//担保期限，敞口处理
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjz()))
			{
			  this.getGitp().getGidgrp().setCkrq("X");
			  
			}
			else
			{
			  this.getGitp().getGidgrp().setCkrq("");
			  
			  

			}

			//保证金质押协议主合同
			if("2".equals(this.getGidgrp().getRec().getSytk())||"3".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().getRec().setMyrzbh(NULLSTR);
			  
			  
			  
			}
			else
			{
			  
			}

			//保证金质押协议争议解决方式
			if("2".equals(this.getGidgrp().getRec().getZyjjfs()))
			{
			  
			  
			}
			else
			{
			  
			  
			}

			//保函保证金质押协议编号(待处理    清理协议内容)
			if("2".equals(this.getGidgrp().getRec().getZyxysy()))
			{
			  
			}

		}
        /**
        *   source:gitapn.@0157.script
        */
        public void test()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:gitapn.@0168.script
        */
        public void dealsytk()   //出质人开立保函适用条款
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("1".equals(this.getGidgrp().getRec().getSytk()))
			{
			  this.getGidgrp().getRec().setMyrzbh(NULLSTR);
			  
			  
			}

			this.getGidgrp().getRec().setSytk(NULLSTR);
			
		}
        /**
        *   source:gitapn.@0182.script
        */
        public String covCnPermillage(BigDecimal per)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将数字转化为大写
			if (per == null)
			{
			  return "";
			}
			String strPer = per.toString();
			String[] number = { "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖" };
			String[] radices = { "仟", "", "拾", "佰" };
			String[] bigRadices = { "", "万", "亿", "万亿", "亿亿" };
			int idx = strPer.indexOf(".");
			String sInt = "";
			String sFlt = "";
			if(-1 == idx)
			{
			  sInt = strPer;
			  sFlt = "00";
			}
			else
			{
			  sInt = strPer.substring(0, idx);
			  sFlt = strPer.substring(idx + 1);
			  if( 1 == sFlt.length())
			  {
			    sFlt = sFlt + "0";
			  }
			}

			String cn = "千分之";
			int zeroC = 0;
			int len = sInt.length();
			for (int i = 0; i < len; i++) {
			  if (sInt.charAt(i) == '0')
			{
			  zeroC++;
			}
			else
			{
			  if (zeroC > 0)
			  {
			    cn = cn + "零";
			    zeroC = 0;
			  }
			  cn = cn + number[(sInt.charAt(i) - '1')];
			  cn = cn + radices[((len - i) % 4)];
			}
			if (((len - i) % 4 == 1) && (zeroC < 4))
			  cn = cn + bigRadices[((len - i) / 4)];
			}
			if (sFlt.equals("00"))
			{
			cn = cn + "整";
			}
			else
			{
			cn = cn + "点";
			if (!sFlt.substring(0, 1).equals("0"))
			  cn = cn + number[(sFlt.charAt(0) - '1')];
			else
			  cn = cn + "零";
			if (!sFlt.substring(1, 2).equals("0"))
			  cn = cn + number[(sFlt.charAt(1) - '1')];
			}
			return cn;
		}
























}