package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitaszVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 电子保函修改
*/
@Transaction(vo= GitaszVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitasz extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitasz.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitasz()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("DG"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitasz.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitasz.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitasz.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitasz.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitasz.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitasz.@0002.script
        */
        @Rule(target="gitp.sztmod.save",order=200)
        public boolean ruleGitpSztmodSaveN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getGidgrp()))
			{
			  return false;
			}

			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getStlref()))
			{
			  ctx.setFieldError(this,"gidgrp.rec.stlref",MdaUtils.getI18NString("gitasz","CT000000"));
			  return false;
			}

			ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getGidgrp().getSzgit());
			this.getGidgrp().getSpb().setInr(this.getGidgrp().getRec().getInr());
			this.getGidgrp().getSxb().setInr(this.getGidgrp().getRec().getInr());
			//合作平台区分 ZTB：中投保
			String cpno = this.getSysmod().getCpno();
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  //申请书处理
			  this.ztbdeal();
			  //处理业务逻辑
			  if(MdaUtils.isEmpty(this.getGidgrp().getSxb().getInr()))
			  {
			    ctx.getDaoSession().dbInsert(this.getGidgrp().getSxb());
			  }
			  else
			  {
			    ctx.getDaoSession().dbUpdate(this.getGidgrp().getSxb());
			  }
			}
			else
			{
			  //申请书处理
			  this.flgs();
			  //处理业务逻辑
			  if(MdaUtils.isEmpty(this.getGidgrp().getSpb().getInr()))
			  {
			    ctx.getDaoSession().dbInsert(this.getGidgrp().getSpb());
			  }
			  else
			  {
			    ctx.getDaoSession().dbUpdate(this.getGidgrp().getSpb());
			  }
			}

			MdaUtils.clear(this.getTrnmod().getTrn());
			this.getTrnmod().getTrn().copyValue(this.getGitp().getSztmod().getGidtrn());

			String filename = this.getSysmod().createFilename(this.getGitp().getSztmod().getGidtrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			IPanel[] panels=this.getGitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);

			log.debug("{}","order 200 over");


			return true;
        }

        /**
        *   source:gitasz.@0003.script
        */
        @Rule(target="gitp.sztmod.save",order=210)
        public boolean ruleGitpSztmodSaveN210(){
            IContext ctx = MdaEnv.getContext();
            
			String cpno = this.getSysmod().getCpno();
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgameamt()))
			  {
			    //保函增减额 增额有审批表，减额没有
			    log.debug("{}","lgameamt："+this.getGidgrp().getRec().getLgameamt()+"******"+"lgamt:"+this.getGidgrp().getRec().getLgamt());
			    if(this.getGidgrp().getRec().getLgameamt().compareTo(this.getGidgrp().getRec().getLgamt())>0)
			    {
			      int cnt = 2;
			      String labels = "授信使用审批意见表,贸金金融业务真实性情况表";
			      String tempfiles = "A:gitobj1,A:gitobj2";
			      this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			      this.getTrnmod().getApldoc().generatorAllPDF();
			    }
			  }
			}
			else
			{
			  int cnt = 1;
			  String labels = "贸金业务审批表";
			  String tempfiles = "A:gitasz";
			  this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			  this.getTrnmod().getApldoc().generatorAllPDF();
			}


			return true;
        }

        /**
        *   source:gitasz.@0004.script
        */
        @Rule(target="gitp.gitasminf",order=100)
        public boolean ruleGitpGitasminfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getGitp().getPdfviw().callPDFComponent("","gitasz","贸金业务审批表",1);

			return true;
        }

        /**
        *   source:gitasz.@0006.script
        */
        @Rule(target="gitp.compar",order=100)
        public boolean ruleGitpComparN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String f0 = "/C:/etc/投标保函.docx";
			  String f1 = "/C:/etc/投标保函模板.docx";
			  $gitp.compareWord(f0,f1);
			  */

			return true;
        }

        /**
        *   source:gitasz.@0009.script
        */
        @Rule(target="gitp.gitasreal",order=100)
        public boolean ruleGitpGitasrealN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getGitp().getPdfviw().callPDFComponent("","gitosz2","贸金金融业务真实性情况表",1);

			return true;
        }

        /**
        *   source:gitasz.@0010.script
        */
        @Rule(target="gitp.gitaztbreal",order=100)
        public boolean ruleGitpGitaztbrealN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.ztbdeal();
			this.getGitp().getPdfviw().callPDFComponent("","gitobj2","贸金金融业务真实性情况表",1);

			return true;
        }

        /**
        *   source:gitasz.@0012.script
        */
        @Rule(target="gitp.gitaztbspb",order=100)
        public boolean ruleGitpGitaztbspbN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.ztbdeal();
			this.getGitp().getPdfviw().callPDFComponent("","gitobj1","授信使用审批意见表",1);

			return true;
        }

        /**
        *   source:gitasz.@0013.script
        */
        @Rule(target="gitp.stpmod.save",order=100)
        public boolean ruleGitpStpmodSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			//申请书处理
			this.ztbdeal();
			//处理业务逻辑
			if(MdaUtils.isEmpty(this.getGidgrp().getSxb().getInr()))
			{
			  this.getGidgrp().getSxb().setInr(this.getGidgrp().getRec().getInr());
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getSxb());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getGidgrp().getSxb());
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","数据库异常，请联系管理员！");
			  return false;
			}
			else
			{
			  ctx.setMessage("提示","提交成功");
			}

			return true;
        }

        /**
        *   source:gitasz.@0014.script
        */
        @Rule(target="gitp.selpdf",order=100)
        public boolean ruleGitpSelpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","pdf====上传pdf===selpdf========================================");
			Object[] obj = (Object[])MdaUtils.getEventData();
			IStream stream = this.getGitp().getSelpdf();
			upLoad(stream,obj,"1");

			return true;
        }



        /**
        *   source:gitasz.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","init gitasz order 100 start");
			IModule gid = (IModule)ctx.restoreData("com.brilliance.gitasz.ref");
			this.dealBasicInfo();

			if(!MdaUtils.isEmpty(gid))
			{
			  this.getGidgrp().getRec().copyValue(gid);
			  String inr=this.getGidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getGidgrp().getSzgit(),new Argument<String>("inr",inr));
			  this.getGitp().getSztmod().setPtbusino(this.getGidgrp().getSzgit().getPtbusino()); //高新投业务号，必须
			  //电子章
			  
			  //申请人
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","apl"));
			  
			  
			  

			  //受益人
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			  
			  
			  

			  String inrs=(String)ctx.restoreData("com.brilliance.inr.ref");
			  this.getGitp().getSztmod().setTrninr(inrs);//流水号主键
			  this.getGitp().getSztmod().setOwnref(this.getGidgrp().getRec().getOwnref());//业务参号
			  log.debug("{}","trninr  is  :"+inrs);
			  MdaUtils.clear(this.getGitp().getSztmod().getGidtrn());
			  MdaUtils.clear(this.getGitp().getSztmod().getGrn());
			  ctx.getDaoSession().dbRead(this.getGitp().getSztmod().getGidtrn(),new Argument<String>("inr",inrs));
			  ctx.getDaoSession().dbRead(this.getGitp().getSztmod().getGrn(),new Argument<String>("objinr",inrs));
			  String cpno = this.getGitp().getSztmod().getGrn().getSrc();
			  if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			  {
			    ctx.getDaoSession().dbRead(this.getGidgrp().getSxb(),new Argument<String>("inr",inr));
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getGitp().getSztmod().getGidtrn().getOrdinr());
			    
			    log.debug("{}","gitasz刷新**");
			  }
			  else
			  {
			    if(!"O".equals(this.getGitp().getSztmod().getGrn().getRettyp())) //退回业务
			    {
			      ctx.getDaoSession().dbRead(this.getGidgrp().getSpb(),new Argument<String>("inr",inr));

			      this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getGitp().getSztmod().getGidtrn().getOrdinr());
			    }
			  }
			}
			//初始化机构
			//$gidgrp\\bchcod.setValue($gidgrp\\rec\\bchcod.getValue());
			this.getGidgrp().setBchcod(this.getGidgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getBchcod(this.getGidgrp().getRec().getPtyinr(),"2");
			MdaUtils.setValues(this.getGidgrp(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			{
			  this.getGidgrp().setBchcod(bchcod.get(0).getValue());
			}
			this.getGidgrp().getRec().setAmedat(MdaUtils.today());
			log.debug("{}","gitasz init 页面分配");
			String steps = "";
			String src = this.getGitp().getSztmod().getGrn().getSrc();
			this.getSysmod().setCpno(src);
			log.debug("{}","平台类型："+src);
			//HTI: 高新投 ZTB: 中投保
			if(!MdaUtils.isEmpty(src) && "ZTB".equals(src))
			{
			  //支行经办权限展示上传文件按钮
			  if("OO".equals(this.getGitp().getSztmod().getGrn().getGidsta()))
			  {
			    if("1".equals(this.getGitp().getSztmod().getSzusraut().getAflg()) && "0".equals(this.getGitp().getSztmod().getSzusraut().getBflg()))
			    {
			      MdaUtils.isVisible(this.getGitp(),"selpdf");
			    }
			    else
			    {
			      
			    }
			  }
			  else
			  {
			    
			  }
			  
			  
			  if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgameamt()))
			  {
			    //保函增减额 增额有审批表，减额没有
			    log.debug("{}","lgameamt："+this.getGidgrp().getRec().getLgameamt()+"******"+"lgamt:"+this.getGidgrp().getRec().getLgamt());
			    if(this.getGidgrp().getRec().getLgameamt().compareTo(this.getGidgrp().getRec().getLgamt())>0)
			    {
			      this.getGitp().getStpmod().storePanel(this.getGitp().getGitasz(),this.getGitp().getGitshouxin(),this.getGitp().getGitaztbapp());
			      steps = "0:保函修改申请;1:补录信息;2:合同展示";
			    }
			    else
			    {
			      this.getGitp().getStpmod().storePanel(this.getGitp().getGitasz());
			      steps = "0:保函修改申请";
			    }
			  }
			}
			else
			{
			  this.getGitp().getStpmod().storePanel(this.getGitp().getGitasz(),this.getGitp().getGitasz1());
			  steps = "0:保函修改申请;1:补录信息";
			  
			}
			log.debug("{}","steps:"+steps);
			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:gitasz.@0008.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }


        /**
        *   source:gitasz.@0001.script
        */
        public void dealBasicInfo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
			
			

			
			
			
			
			
			
			

			this.getGidgrp().getRec().setAmedat(MdaUtils.today());

		}
        /**
        *   source:gitasz.@0005.script
        */
        public void flgs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgameamt()))
			{
			  //保函修改的增减额
			  if(this.getGidgrp().getRec().getLgameamt().compareTo(this.getGidgrp().getRec().getLgamt())>0)
			  {
			    this.getGidgrp().setBhzjetyp("1");
			    this.getGidgrp().setBhzje(this.getGidgrp().getRec().getLgameamt().subtract(this.getGidgrp().getRec().getLgamt()));
			  }
			  else
			  {
			    this.getGidgrp().setBhzjetyp("2");
			    this.getGidgrp().setBhzje(this.getGidgrp().getRec().getLgamt().subtract(this.getGidgrp().getRec().getLgameamt()));
			  }
			}
			String shenpi = "";
			//shenpi4与shenpi5是互斥选项
			
			if("X".equals(this.getGidgrp().getSpb().getShenpi1()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi2()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi3()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi4()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi5()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi6()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi7()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi8()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi9()))
			{
			  shenpi = shenpi + "√";
			}
			this.getGidgrp().setShenp(shenpi);

			BigDecimal amt = this.getGidgrp().getBhzje();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getGidgrp().setBhzje(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getRec().getLgamt(),"#0.00"));
			this.getGidgrp().getRec().setLgamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getRec().getLgameamt(),"#0.00"));
			this.getGidgrp().getRec().setLgameamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getRec().getBzjamt(),"#0.00"));
			this.getGidgrp().getRec().setBzjamt(amt);

			//amt = Platform.parseDecimal(Platform.format($gidgrp\\spb\\edamt.getValue(),"#0.00"));
			//$gidgrp\\spb\\edamt.setValue(amt);
			
			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getMyrzzxamt(),"#0.00"));
			this.getGidgrp().getSpb().setMyrzzxamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getQzkzedamt(),"#0.00"));
			this.getGidgrp().getSpb().setQzkzedamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getQtmjrzamt(),"#0.00"));
			this.getGidgrp().getSpb().setQtmjrzamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getQzkzedamt(),"#0.00"));
			this.getGidgrp().getSpb().setQzkzedamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getQzbhamt(),"#0.00"));
			this.getGidgrp().getSpb().setQzbhamt(amt);

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getYgbeamt(),"#0.00"));
			this.getGidgrp().getSpb().setYgbeamt(amt);
		}
        /**
        *   source:gitasz.@0011.script
        */
        public void ztbdeal()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getLgameamt()))
			{
			  //保函修改的增减额
			  if(this.getGidgrp().getRec().getLgameamt().compareTo(this.getGidgrp().getRec().getLgamt())>0)
			  {
			    this.getGidgrp().setBhzjetyp("1");
			  }
			  else
			  {
			    this.getGidgrp().setBhzjetyp("2");
			  }
			}
			String type = "";
			if("X".equals(this.getGidgrp().getSxb().getType1()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType2()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType3()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType4()))
			{
			  type = type + "√";
			}
			this.getGidgrp().setType(type);

			String shiyong = "";
			if("X".equals(this.getGidgrp().getSxb().getShiyong1()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong2()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong3()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong4()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong5()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong6()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong7()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong8()))
			{
			  shiyong = shiyong + "√";
			}
			this.getGidgrp().setShiyong(shiyong);

			String jysel = "";
			if("X".equals(this.getGidgrp().getSxb().getJysel1()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel2()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel3()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel4()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel5()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel6()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel7()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel8()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel9()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel10()))
			{
			  jysel = jysel + "√";
			}
			this.getGidgrp().setJysel(jysel);

			String fhbmsel = "";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel1()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel2()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel3()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel4()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel5()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel6()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel7()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel8()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel9()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel10()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel11()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel12()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			this.getGidgrp().setFhbmsel(fhbmsel);

			String fhldsel = "";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel1()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel2()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel3()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel4()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel5()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel6()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel7()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel8()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel9()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel10()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel11()))
			{
			  fhldsel = fhldsel + "√";
			}
			this.getGidgrp().setFhldsel(fhldsel);

			String kehuqk = "";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk1()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk2()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk3()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk4()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk5()))
			{
			  kehuqk = kehuqk + "√";
			}
			this.getGidgrp().setKehuqk(kehuqk);

			BigDecimal amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSxb().getAmt(),"#0.00"));
			this.getGidgrp().getSxb().setAmt(amt);
		}
        /**
        *   source:gitasz.@0015.script
        */
        public void upLoad(IStream stream,Object[] obj,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","进入方法");
			String nam = this.getSysmod().getUsr().getOprnam();
			log.debug("{}","登录用户："+nam);
			String pdfNam = obj[1].toString();
			int index = pdfNam.indexOf(".");
			log.info("{}","源文件名========"+pdfNam);
			String postfix = pdfNam.substring(index + 1);
			log.info("{}","后缀名========"+postfix);
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");

			String indexnew = MdaUtils.format(ctx.getDaoSession().dbCounter("tblcnt"),"000000000");
			log.debug("{}","自增值："+ctx.getDaoSession().dbCounter("tblcnt")+"新文件名："+indexnew);
			String alsnam = indexnew +"."+ postfix;
			if("pdf".equals(postfix) || "doc".equals(postfix) || "docx".equals(postfix))
			{
			  String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/szdzbh/fatd/" + time +"/" + alsnam);
			  if(MdaUtils.fileExists(filPath))
			    MdaUtils.fileDelete(filPath);
			  MdaUtils.streamSave(stream,filPath);
			  String ownref = this.getGitp().getSztmod().getOwnref();
			  String msgref = ownref;
			  log.info("{}","文件地址："+filPath+"ownref:"+ownref+"msgref:"+msgref);
			  String cls = "com.brilliance.eibs.main.Client";
			  Object rtnVal = MdaUtils.invoke(cls,"scall","instblbil","instblbil",new Object[]{ownref,msgref,ctx.getTransName(),alsnam,pdfNam,postfix,filPath,nam});
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  Boolean errcod = (Boolean)retMsg.get("issuccess");
			  if(!errcod)
			  {
			    log.error("{}","文件上传失败！");
			    ctx.setMessage("提示","文件上传失败");
			    return;
			  }
			  else
			  {
			    ctx.setMessage("提示","文件上传成功");
			  }
			}
			else
			{
			  ctx.setMessage("提示","请上传pdf、doc、docx格式文件");
			}
		}








}