package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitcanVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函注销通知
*/
@Transaction(vo= GitcanVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitcan extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitcan.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitcan()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitcan.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitcan.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcan.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitcan.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitcan.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitcan.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:gitcan.@0001.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck(this.getGitp().getGitp09());

			return true;
        }

        /**
        *   source:gitcan.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:gitcan.@0003.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","inr============="+this.getGidgrp().getRec().getInr());
			ctx.getDaoSession().dbRead(this.getGidgrp().getIsb().getPts(),new Argument<String>("objinr",this.getGidgrp().getRec().getInr()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","isb"));
			ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument<String>("objinr",this.getGidgrp().getRec().getInr()),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));

			return true;
        }










}