package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitcfmVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gidgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函合同要素修改
*/
@Transaction(vo= GitcfmVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitcfm extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitcfm.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;


		public Gitcfm()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gitp.gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitcfm.this.getGitp().getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitcfm.this.getGitp().getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitcfm.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitcfm.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitcfm.this.getGidgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
        }



        /**
        *   source:gitcfm.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield objinr=(IDatafield)ctx.restoreData("com.brilliance.gitcfm.inr");
			if(!MdaUtils.isEmpty(objinr))
			{
			  ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument<String>("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getGxd(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp","bpd"));
			  //定义步骤条
			  this.getGitp().getStpmod().storePanel(this.getGitp().getGitcfmstep01(),this.getGitp().getGitcfmstep02());
			  String steps=null;
			  String flags=this.getGidgrp().getRec().getFlags();
			  //签订了保证金协议
			  if("0001".equals(flags))
			  {
			    ctx.getDaoSession().dbRead(this.getGidgrp().getGxd(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp","gid"));
			    steps = "0:保函协议;1:保证金协议";
			  }
			  else if("0000".equals(flags))
			  {
			    steps = "0:保函协议";
			  }
			  this.getGitp().getStpmod().setPages(steps);
			  this.getGitp().getStpmod().calcSteps();
			  //隐藏出口押汇协议界面上是否签订保证金勾选项
			  

			}

			return true;
        }

        /**
        *   source:gitcfm.@0001.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> jffs =  new ArrayList<CodetableItem>();
			jffs.add(new CodetableItem("壹","1"));
			jffs.add(new CodetableItem("贰","2"));
			MdaUtils.setValues(this.getGidgrp().getGxd(),"jffs",jffs);

			List<CodetableItem> zyjjfs =  new ArrayList<CodetableItem>();
			zyjjfs.add(new CodetableItem("壹","1"));
			zyjjfs.add(new CodetableItem("贰","2"));
			zyjjfs.add(new CodetableItem("叁","3"));
			MdaUtils.setValues(this.getGidgrp().getGxd(),"zyjjfs",zyjjfs);


			return true;
        }








}