package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函开立通知
*/
@Transaction(vo= GitdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitdav.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitdav.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitdav.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitdav.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitdav.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitdav.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitdav.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:gitdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if("gitosz".equals(this.getTrnmod().getTrn().getInifrm()))
			{
			  List<CodetableItem> tratype = MdaUtils.getCodetable("tratype");
			  MdaUtils.setValues(this.getGidgrp().getRec(),"lgtyp",tratype);
			}

			String labels = "";
			String tempfiles="";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getGitp().getGitp04());

			return true;
        }

        /**
        *   source:gitdav.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();
			if(!MdaUtils.isEmpty(this.getGidgrp().getGitpush().getContractid()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:gitdav.@0003.script
        */
        @Init(order=500)
        public boolean	init500(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			if(!"0".equals(ptytyp))
			{
			  if(!MdaUtils.isEmpty(this.getTrnmod().getAdvtrninr())&&!MdaUtils.isEmpty(this.getGidgrp().getGitpush().getInr()))
			  {
			    ctx.getDaoSession().dbBegin();
			    this.getGidgrp().getGitpush().setObjinr(this.getTrnmod().getAdvtrninr());
			    this.getGidgrp().getGitpush().setObjtyp("trn");
			    ctx.getDaoSession().dbUpdate(this.getGidgrp().getGitpush());
			    ctx.getDaoSession().dbCommit();
			  }
			}

			return true;
        }










}