package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitimgVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.bo.Grn;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Tblcnt;
import com.ceb.gjjs.mda.bo.Gidattach;
import com.ceb.gjjs.mda.bo.Addimg;
import com.ceb.gjjs.mda.bo.Tblbil;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Sztmod;
import com.ceb.gjjs.mda.bo.Addtmp;
import com.ceb.gjjs.mda.manager.module.Gidgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函影像追加
*/
@Transaction(vo= GitimgVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitimg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitimg.class);

        //业务状态
        private String sta;
        //业务参考号
        private String ownref;
        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);
        //查询
        private transient IControl query = new ControlImpl("query", "查询", this);
        //同意
        private transient IControl agree = new ControlImpl("agree", "同意", this);
        //拒绝
        private transient IControl refuse = new ControlImpl("refuse", "拒绝", this);
        //拒绝原因
        private String reason;
        //影像测试
        private transient IControl tsttbl = new ControlImpl("tsttbl", "影像测试", this);
        //资料补充通知查询
        private transient IControl addsel = new ControlImpl("addsel", "资料补充通知查询", this);
        //业务参号
        private String ownref1;
        //是否本人
        private String myself;
        //查询
        private transient IControl addfind = new ControlImpl("addfind", "查询", this);
        //开始日期
        private Date begdat;
        //截止日期
        private Date enddat;
        //开始日期
        private Date begdat1;
        //结束日期
        private Date enddat1;
        //机构名称
        private String ptynam;
		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Addimg addimg;

		@BDGetter
		private ModuleList<Addimg> addimglst;

		@BDGetter
		private Tblbil tblbil;

		@BDGetter
		private ModuleList<Tblbil> tblbilst;

		@BDGetter
		private Grn grn;

		@BDGetter
		private Tblcnt tblcnt;

		@BDGetter
		private Sztmod sztmod;

		@BDGetter
		private ModuleList<Addtmp> addtmp;

		@BDGetter
		private ModuleList<Gidattach> gidattac;

		@BDGetter
		private Gidattach gidattach;


		public Gitimg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new java.math.BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getSztmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitimg.this.getFieldPath("gidgrp.rec.ownusr");}
 				public void setValue(String arg){Gitimg.this.getGidgrp().getRec().setOwnusr(arg);}
 				public String getValue(){return Gitimg.this.getGidgrp().getRec().getOwnusr();}}
			 );
        }

        /**
        *   source:gitimg.@0002.script
        */
        @Rule(target="query",order=100)
        public boolean ruleQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.requery();
			if("1".equals(this.getSta())||("2".equals(this.getSta())))
			{
			  
			  
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:gitimg.@0003.script
        */
        @Rule(target="refuse",order=100)
        public boolean ruleRefuseN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","gitimg refuse start:");
			int index = 0;
			int size = this.getAddtmp().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000020"),MdaUtils.getI18NString("gitimg","CT000021"));
			  return false;
			}
			if("1".equals(this.getAddtmp().getElement(index).getSta())||("2".equals(this.getAddtmp().getElement(index).getSta())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000022"),MdaUtils.getI18NString("gitimg","CT000023"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getReason()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000040"),MdaUtils.getI18NString("gitimg","CT000041"));
			  return false;
			}

			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getAddimg(),new Argument<String>("inr",this.getAddtmp().getElement(index).getInr()));
			if(!MdaUtils.isEmpty(this.getAddtmp().getElement(index).getAttachno()))
			{
			  MdaUtils.clear(this.getGidattach());
			  ctx.getDaoSession().dbRead(this.getGidattach(),new Argument<String>("attachno",this.getAddtmp().getElement(index).getAttachno()));
			}
			this.getAddimg().setSta("2");
			this.getAddimg().setReason(this.getReason());
			ctx.getDaoSession().dbUpdate(this.getAddimg());
			this.getGidattach().setSta("R");
			ctx.getDaoSession().dbUpdate(this.getGidattach());
			//给高新投回执
			ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument("ownref",this.getAddtmp().getElement(index).getOwnref()));
			ctx.getDaoSession().dbRead(this.getGidgrp().getSzgit(),new Argument("inr",this.getGidgrp().getRec().getInr()));
			String frm="gitimg";
			String msgref= this.getGidgrp().getSzgit().getMsgref();
			String ptbusino = this.getGidgrp().getSzgit().getPtbusino();
			String msgno = "EBH108";
			log.info("{}","msgref = " + msgref + " , ptbusino = " + ptbusino + " , ownref = " + this.getAddtmp().getElement(index).getOwnref());
			Map sendMap = new HashMap();
			sendMap.put("ptbusino",ptbusino);
			sendMap.put("bkbusino",this.getAddtmp().getElement(index).getOwnref());
			sendMap.put("result","1");
			sendMap.put("reason",this.getReason());
			this.getSysmod().setSzHeaderMap(msgno,"",sendMap,msgref);
			this.getSztmod().insertEbhmsg(msgno,this.getGidgrp().getRec().getInr(),"gid",frm,sendMap);
			log.info("{}","gitimg refuse add img");

			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000076"),MdaUtils.getI18NString("gitimg","CT000077"));
			  return false;
			}
			ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000086"),MdaUtils.getI18NString("gitimg","CT000087"));
			MdaUtils.clear(this.getAddtmp());
			this.requery();

			return true;
        }

        /**
        *   source:gitimg.@0004.script
        */
        @Rule(target="agree",order=100)
        public boolean ruleAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","gitimg agree start:");
			int index = 0;
			int size = this.getAddtmp().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000024"),MdaUtils.getI18NString("gitimg","CT000025"));
			  return false;
			}
			if("1".equals(this.getAddtmp().getElement(index).getSta())||("2".equals(this.getAddtmp().getElement(index).getSta())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000042"),MdaUtils.getI18NString("gitimg","CT000043"));
			  return false;
			}
			String msgtrninr = null;
			MdaUtils.clear(this.getAddimg());
			MdaUtils.clear(this.getGidgrp().getRec());
			MdaUtils.clear(this.getGidgrp().getApl().getPty());
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getAddimg(),new Argument<String>("inr",this.getAddtmp().getElement(index).getInr()));
			ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument<String>("ownref",this.getAddimg().getOwnref()));
			ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPty(),new Argument<String>("inr",this.getGidgrp().getRec().getPtyinr()));
			if(!MdaUtils.isEmpty(this.getAddtmp().getElement(index).getAttachno()))
			{
			  MdaUtils.clear(this.getGidattach());
			  ctx.getDaoSession().dbRead(this.getGidattach(),new Argument<String>("attachno",this.getAddtmp().getElement(index).getAttachno()));
			}
			String trninr = this.getAddimg().getTrninr();
			MdaUtils.clear(this.getTrnmod().getTrn());
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",trninr));
			String trnsta = this.getTrnmod().getTrn().getSta();
			if(!("R".equals(trnsta)||"G".equals(trnsta)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000048"),MdaUtils.getI18NString("gitimg","CT000049"));
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			String lvl = ctx.absGet(Sysmod.class).getPty().getLvl();
			MdaUtils.clear(this.getGrn());
			ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objtyp","trn"),new Argument<String>("objinr",trninr));
			String cpno = this.getGrn().getSrc();
			log.debug("{}","平台类型为：" + cpno);
			if(MdaUtils.isEmpty(this.getAddimg().getUsrinr()))
			{
			  if(!"2".equals(lvl) && !"ZTB".equals(cpno))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000050"),MdaUtils.getI18NString("gitimg","CT000051"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  this.getAddimg().setUsrinr(this.getSysmod().getUsr().getInr());
			  this.getAddimg().setSta("4");
			}
			else//第二次审核
			{
			  if(!"1".equals(lvl))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000068"),MdaUtils.getI18NString("gitimg","CT000069"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			  String ownref = this.getAddimg().getOwnref();
			  String ownrefCP = this.getAddimg().getImgref();
			  String guid = this.getAddimg().getGuid();

			  log.info("{}","trninr :"+trninr);
			  MdaUtils.clear(this.getGrn());
			  MdaUtils.clear(this.getTrnmod().getItfmod().getImgmod().getImg());
			  ctx.getDaoSession().dbRead(this.getGrn(),new Argument("objinr",trninr),new Argument("objtyp","trn"));
			  ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument<String>("trninr",trninr));
			  String baksta = this.getTrnmod().getTrn().getBaksta();
			  String gidsta = this.getGrn().getGidsta();
			  String imgref = this.getTrnmod().getItfmod().getImgmod().getImg().getImgref();
			  log.debug("{}","trninr :"+imgref+"   ,baksta :"+baksta+"  ,gidsta :"+gidsta);
			  log.debug("{}","src imgref :"+trninr+"  , new imgref :"+ownrefCP+"  ,ownref :"+ownref);
			  if("R".equals(trnsta))
			  {//业务已提交ecm，且在国结端，此时需要组t63报文，国结端做绑定
			    msgtrninr = Platform.sdbCounter("trn");
			    this.getAddimg().setMsgtrninr(msgtrninr);
			    //上传影像平台
			    String cibBranchID = this.getSysmod().getPty().getCid().substring(0,2);
			    String cibOrgID = this.getSysmod().getPty().getCid().substring(2);
			    Boolean result=ctx.absGet(Trnmod.class).getItfmod().getImgmod().uploadImages(ownref,ownrefCP,guid,cibBranchID,cibOrgID);
			    log.info("{}","国结业务处理中upload img result=" +result);
			    if(!result)
			    {
			      log.debug("{}","#######");
			      ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000070"),MdaUtils.getI18NString("gitimg","CT000071"));
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			    //组 T63报文
			    String trnname=ctx.getTransName().toLowerCase();
			    /*
			      * 生成STL系统XML报文头
			      */
			    Map<String,Object> head= new HashMap<String,Object>();
			    head.put("FTYTOO","Z00001");               //数据接收
			    head.put("FTYSUC","Z00238");				       //数据来源
			    head.put("FTYNUM", msgtrninr);                //系统唯一编号
			    head.put("MSGTYP", "T63");  //报文类型
			    head.put("BUSTYP","GI");  //业务类型
			    head.put("FTYTYP","ADD");   //申请类型
			    head.put("CREDAT", MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd"));      //业务创建日期
			    head.put("RESNUM","");                  //操作员
			    head.put("REFERENCE",ownrefCP);              //业务编号
			    head.put("OWNEXTKEY",this.getTrnmod().getTrn().getBchcod());           //落地机构号
			    if(MdaUtils.isEmpty(this.getGidgrp().getApl().getPty().getCid()))
			    {
			      if("ZTB".equals(cpno))
			      {
			        head.put("CLIENT","2000173677");
			      }
			      else
			      {
			        head.put("CLIENT","2402530342");
			      }
			    }
			    else
			    {
			      head.put("CLIENT",this.getGidgrp().getApl().getPty().getCid());               //核心客户号
			    }
			    head.put("IMGID", guid);
			    if(this.packxmlfile(head,trnname,msgtrninr))
			    {
			      //模拟mgrtsk发报至国结
			      log.info("{}","pack xmlfile success");
			    }
			    else
			    {
			      log.error("{}","生成T63报文异常");
			      ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000072"),MdaUtils.getI18NString("gitimg","CT000073"));
			      ctx.getDaoSession().dbRollback();
			      return false ;
			    }

			  }
			  else if("G".equals(trnsta))
			  {
			    //业务未提交国结，未上传ecm，此时只需要简单的关联img表即可。
			    String cls="com.brilliance.eibs.main.Client";
			    Object rtnVal = MdaUtils.invoke(cls,"scall","gxtblbil","gxtblbil",new Object[]{ownref,ownrefCP,imgref});    // 判断接口是否调用成功
			    if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			    {
			      Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			      String errcod = (String)retMsg.get("errorCode");
			      if("900000".equals(errcod))
			      {
			        ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000141"),MdaUtils.getI18NString("gitimg","CT000142"));
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			      else if("999999".equals(errcod))
			      {
			        ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000143"),MdaUtils.getI18NString("gitimg","CT000144"));
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			    }
			    else
			    {
			      //提示调用错误
			      ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000176"),MdaUtils.getI18NString("gitimg","CT000177"));
			      ctx.getDaoSession().dbRollback();
			      return false;
			    }
			    /*if("R".equals(baksta))
			      {//业务已提交ecm，但被国结退回，此时需要使用原业务批次号，做影像添加操作
			      if(!$trnmod\\itfmod\\imgmod.reuploadImageToCMSS(trninr))
			      {
			      Platform.message(#CT000192,#CT000193);
			      Platform.dbRollback();
			      return false ;
			      }
			      }*/
			  }

			  //给高新投回执
			  ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument("ownref",this.getAddtmp().getElement(index).getOwnref()));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getSzgit(),new Argument("inr",this.getGidgrp().getRec().getInr()));
			  String frm=this.getTrnmod().getTrn().getInifrm();
			  String msgref= this.getGidgrp().getSzgit().getMsgref();
			  String ptbusino = this.getGidgrp().getSzgit().getPtbusino();
			  String msgno = "EBH108";
			  log.info("{}","msgref = " + msgref + " , ptbusino = " + ptbusino + " , ownref = " + this.getAddtmp().getElement(index).getOwnref());
			  Map sendMap = new HashMap();
			  sendMap.put("ptbusino",ptbusino);
			  sendMap.put("bkbusino",this.getAddtmp().getElement(index).getOwnref());
			  sendMap.put("result","0");
			  sendMap.put("reason","成功补录影像");
			  this.getSysmod().setSzHeaderMap(msgno,"",sendMap,msgref);
			  this.getSztmod().insertEbhmsg(msgno,this.getTrnmod().getTrn().getObjinr(),this.getTrnmod().getTrn().getObjtyp(),frm,sendMap);
			  log.info("{}","gitimg agree add img");
			  this.getAddimg().setSta("1");
			  this.getAddimg().setUsrinr2(this.getSysmod().getUsr().getInr());
			  if(!MdaUtils.isEmpty(this.getGidattach().getInr()))
			  {
			    this.getGidattach().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getGidattach());
			  }

			}

			ctx.getDaoSession().dbUpdate(this.getAddimg());
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000194"),MdaUtils.getI18NString("gitimg","CT000195"));
			  return false;
			}
			if(!MdaUtils.isEmpty(msgtrninr))
			{
			  this.doHandle(msgtrninr);
			}
			ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000208"),MdaUtils.getI18NString("gitimg","CT000209"));
			this.requery();

			return true;
        }

        /**
        *   source:gitimg.@0005.script
        */
        @Rule(target="show",order=100)
        public boolean ruleShowN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","gitimg refuse start:");
			int index = 0;
			int size = this.getAddtmp().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000026"),MdaUtils.getI18NString("gitimg","CT000027"));
			  return false;
			}

			//直接调用影像控件
			log.debug("{}","in imgScan ... ");
			//log.debug("trninr=" +trninr);
			//Platform.dbRead($img,new Argument("trninr",trninr));
			String ownref = this.getAddtmp().getElement(index).getOwnref();
			//String imgref = ownref + "CP" + $addtmp[index]\\cnt.getValue();
			String imgref = this.getAddtmp().getElement(index).getImgref();
			String objtyp = "gitosz";

			ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument("ownref",ownref));
			String uuidtoken = this.getTrnmod().getItfmod().getImgmod().getImg().getGuid();
			if(MdaUtils.isEmpty(this.getTrnmod().getItfmod().getImgmod().getImg().getImgref()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitimg","CT000028"),MdaUtils.getI18NString("gitimg","CT000029"));
			  return false;
			}
			log.debug("{}","ownref=" +ownref);
			log.debug("{}","imgref=" +imgref);
			//boolean result= $trnmod\\itfmod\\imgmod.callImageComponent("ImageScan",ownref,imgref,Platform.getTransName(),$\\sysmod\\usr\\lgnnam.getValue(),objtyp);
			Platform.writeToSession("djcod",imgref);//影像批次号
			Platform.writeToSession("buscod",ownref);//业务参号
			//uuidtoken = UUID.randomUUID().toString().replace("-", "");
			Platform.writeToSession("uuidtoken",uuidtoken);//token，用来判断请求唯一性
			Object msg = null;
			msg = MdaUtils.invoke("client:","ImageScan","",ownref,imgref,"",uuidtoken);


			return true;
        }

        /**
        *   source:gitimg.@0006.script
        */
        @Rule(target="tsttbl",order=100)
        public boolean ruleTsttblN100(){
            IContext ctx = MdaEnv.getContext();
            

			String filename = "00e0fc27c50042ffbe6da8cc201939e3.pdf";
			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String srcPath = MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"pdf"),filename);
			String destPath = MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img"),date),filename);
			log.info("{}", "trans file filename ="+srcPath);
			if(!MdaUtils.fileExists(destPath))
			{
			  ctx.setMessage("Error",MdaUtils.getI18NString("gitimg","CT000107"));
			}
			if(!MdaUtils.fileExists(srcPath))
			{
			  ctx.setMessage("Error",MdaUtils.getI18NString("gitimg","CT000108"));
			  return true;
			}
			else
			{
			  MdaUtils.invoke("com.cib.window.util.WindowsFileUtil","copyFileToOtherFile",srcPath,destPath);

			}

			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getTblcnt(),new Argument("typ","tblbills"));
			log.info("{}","tblcnt val数 ：" + this.getTblcnt().getVal());
			int val = MdaUtils.parseInt(this.getTblcnt().getVal());
			val = val + 1;
			this.getTblcnt().setVal(""+val);
			log.info("{}","tblcnt val数 ：" + this.getTblcnt().getVal());
			ctx.getDaoSession().dbUpdate(this.getTblcnt());
			//$tblbil\\inr.setValue($tblcnt\\val.getValue());
			this.getTblbil().setInr("99999999");
			this.getTblbil().setFilnam("test20210104");
			ctx.getDaoSession().dbInsert(this.getTblbil());
			ctx.getDaoSession().dbCommit();

			return true;
        }

        /**
        *   source:gitimg.@0007.script
        */
        @Rule(target="addfind",order=100)
        public boolean ruleAddfindN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.addqry();

			return true;
        }

        /**
        *   source:gitimg.@0009.script
        */
        @Rule(target="addsel",order=100)
        public boolean ruleAddselN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBegdat1()))
			{
			  this.setBegdat1(MdaUtils.add(MdaUtils.today(),-15));
			}
			if(MdaUtils.isEmpty(this.getEnddat1()))
			{
			  this.setEnddat1(MdaUtils.today());
			}
			
			
			this.addqry();
			

			return true;
        }

        /**
        *   source:gitimg.@0010.script
        */
        @Rule(target="sztmod.returnsel",order=100)
        public boolean ruleSztmodReturnselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.showMainPanel();

			return true;
        }



        /**
        *   source:gitimg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this,"ptynam",bchcod);

			if("1".equals(this.getSysmod().getPty().getLvl()))
			{
			  this.setPtynam(this.getSysmod().getPty().getInr());
			}
			else
			{
			  if(!MdaUtils.isEmpty(bchcod))
			    this.setPtynam(bchcod.get(0).getValue());
			}

			if(MdaUtils.isEmpty(this.getBegdat()))
			{
			  this.setBegdat(MdaUtils.add(MdaUtils.today(),-15));
			}
			if(MdaUtils.isEmpty(this.getEnddat()))
			{
			  this.setEnddat(MdaUtils.today());
			}
			
			
			String lvl = ctx.absGet(Sysmod.class).getPty().getLvl();

			if("2".equals(lvl))
			{
			  this.setSta("3");
			}
			else if("1".equals(lvl))
			{
			  this.setSta("4");
			}
			else
			{
			  this.setSta("9");
			}
			this.requery();

			return true;
        }


        /**
        *   source:gitimg.@0001.script
        */
        public void requery()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			MdaUtils.clear(this.getAddtmp());

			String lvl=this.getSysmod().getPty().getLvl();
			String ptyinr=this.getSysmod().getPty().getInr();
			String cid=this.getSysmod().getPty().getCid();

			String sql = "select a.inr inr, a.ownref ownref,a.sta sta, a.cnt cnt, a.credat credat, a.imgref imgref,a.trninr trninr,"
			  +" a.usrinr usrinr,a.attachno attachno,b.muser muser,b.gidsta gidsta,b.inifrm inifrm from addimg a   "
			  +" left join gidattach b on a.attachno =b.attachno "
			  +" left join trn t on t.inr = a.trninr where 1 = 1 ";

			if("9".equals(this.getSta()))
			{
			}

			else if(!MdaUtils.isEmpty(this.getSta()))
			{
			  sql = sql + "and a.sta = " + this.getSta();
			}

			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql + "and a.ownref = " + this.getOwnref();
			}
			List objs = new ArrayList();
			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  sql +=" AND a.credat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  sql +=" AND a.credat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			}
			//机构隔离
			if(!MdaUtils.isEmpty(this.getPtynam()))   //获取机构主键和机构等级
			{
			  ptyinr=this.getPtynam();
			  lvl=this.getSysmod().getBchmod().getBranchLvlByInr(ptyinr);
			  cid=this.getSysmod().getCidByInr(ptyinr);
			  if("1".equals(this.getSysmod().getPty().getLvl()))
			  {
			    ptyinr=this.getSysmod().getPty().getInr();
			    lvl=this.getSysmod().getPty().getLvl();
			    cid=this.getSysmod().getPty().getCid();
			  }
			  log.debug("{}","ptyinr is:"+ptyinr);
			}

			if("0".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr)";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr and (p.inr='"+ptyinr+"' or pntinr='"+cid+"'))";
			}
			else
			{
			  sql=sql+" AND optptyinr='"+ptyinr+"'";
			}
			log.info("{}","end sql gitimg = "+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());

			Argument<String> inr = new Argument<String>("inr");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> sta = new Argument<String>("sta");
			Argument<BigDecimal> cnt = new Argument<BigDecimal>("cnt");
			Argument<String> credat = new Argument<String>("credat");
			Argument<String> imgref = new Argument<String>("imgref");
			Argument<String> usrinr = new Argument<String>("usrinr");
			Argument<String> attachno = new Argument<String>("attachno");
			Argument<String> muser = new Argument<String>("muser");
			Argument<String> gidsta = new Argument<String>("gidsta");
			Argument<String> inifrm = new Argument<String>("inifrm");
			Argument<String> trninr = new Argument<String>("trninr");

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,sta,cnt,credat,imgref,usrinr,attachno,muser,gidsta,inifrm,trninr);

			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAddtmp().add(inr,ownref,sta,cnt,credat,imgref,usrinr,attachno,muser,gidsta,inifrm,trninr);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:gitimg.@0008.script
        */
        public void addqry()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getGidattac());

			String lvl=this.getSysmod().getPty().getLvl();
			String ptyinr=this.getSysmod().getPty().getInr();
			String cid=this.getSysmod().getPty().getCid();

			String sql = " select g.inr, g.attachno, g.attachinfo, g.muser, g.userinr, g.sta, g.credat, g.upddat, g.ownref, g.ptbusino, g.objinr, g.objtyp, g.gidsta, g.inifrm from gidattach g ";
			sql += " left join trn t on g.objinr = t.objinr where 1=1";

			if(TRUE.equals(this.getMyself()))
			{
			  String user = MdaEnv.getLoginUser();
			  sql +=" and g.muser like '%"+user+"%'";
			}
			if(!MdaUtils.isEmpty(this.getOwnref1()))
			{
			  sql +=" and g.ownref like '%"+this.getOwnref1()+"%'";
			}
			List objs = new ArrayList();
			if(!MdaUtils.isEmpty(this.getBegdat1()))
			{
			  sql +=" AND g.credat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat1(),GT));
			}
			if(!MdaUtils.isEmpty(this.getEnddat1()))
			{
			  sql +=" AND g.credat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat1(),LT));
			}
			//机构隔离
			if(!MdaUtils.isEmpty(this.getPtynam()))   //获取机构主键和机构等级
			{
			  ptyinr=this.getPtynam();
			  lvl=this.getSysmod().getBchmod().getBranchLvlByInr(ptyinr);
			  cid=this.getSysmod().getCidByInr(ptyinr);
			  if("1".equals(this.getSysmod().getPty().getLvl()))
			  {
			    ptyinr=this.getSysmod().getPty().getInr();
			    lvl=this.getSysmod().getPty().getLvl();
			    cid=this.getSysmod().getPty().getCid();
			  }
			  log.debug("{}","ptyinr is:"+ptyinr);
			}

			if("0".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr)";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr and (p.inr='"+ptyinr+"' or pntinr='"+cid+"'))";
			}
			else
			{
			  sql=sql+" AND optptyinr='"+ptyinr+"'";
			}
			sql +="order by g.credat desc,g.ownref";
			log.debug("{}","execs :"+sql);
			ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> attachno = new Argument<String>("attachno");
			Argument<String> attachinfo = new Argument<String>("attachinfo");
			Argument<String> muser = new Argument<String>("muser");
			Argument<Date> credat = new Argument<Date>("credat");
			Argument<Date> upddat = new Argument<Date>("upddat");
			Argument<String> userinr = new Argument<String>("userinr");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> objinr = new Argument<String>("objinr");
			Argument<String> objtyp = new Argument<String>("objtyp");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> ptbusino = new Argument<String>("ptbusino");
			Argument<String> gidsta = new Argument<String>("gidsta");
			Argument<String> inifrm = new Argument<String>("inifrm");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,attachno,attachinfo,muser,userinr,sta,credat,upddat,ownref,ptbusino,objinr,objtyp,gidsta,inifrm);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getGidattac().add(inr,attachno,attachinfo,muser,userinr,sta,credat,upddat,ownref,ptbusino,objinr,objtyp,gidsta,inifrm);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			//if($gidattac.size()<=0)
			// Platform.message(#CT000122,#CT000123);
					}
        /**
        *   source:gitimg.@0011.script
        */
        public boolean packxmlfile(Map<String,Object> head,String trnname,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 组装 XML报文
			  */
			log.debug("{}"," in sysmod.packXmlFile ...") ;
			boolean success = false ;                 //影像批次号
			
			Map<String,Object> body = Platform.getValueMap(ctx.getRoot(),trnname,"DATA");
			Object[] args = null;
			String interfaceName = "" ;
			String transactinName ="" ;

			interfaceName = "dztstlxmlpack" ;
			transactinName ="dztstlxmlpack" ;
			args = new Object[]{trnname,filename,head,body};

			Map<String,Object> retMsg = this.getTrnmod().getItfmod().scallInterface(interfaceName,transactinName,args);
			if(Platform.isNoError(retMsg))
			{
			  return true;
			}
			else
			{
			  return false ;
			}
		}
        /**
        *   source:gitimg.@0012.script
        */
        public void doHandle(String fnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//在propertier文件中读取文件路径
			String profileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/dztpath.properties");
			log.debug("{}","文件路径配置文件：" + profileName);
			String localPath = MdaUtils.getPropertyValue(profileName,"DZTDZJDOUTPATH");
			String targetPath = MdaUtils.getPropertyValue(profileName,"DZTDZJDFINPATH");
			String fileName = fnam+".xml";
			String locFilNam = localPath+"/"+fileName;
			log.debug("{}","报文源路径:"+locFilNam );
			String tarFilNam = targetPath+"/"+fnam+".ok";
			log.debug("{}","报文目标路径:" + targetPath);
			java.io.File f = new java.io.File(tarFilNam);
			String errcod = "";
			if(MdaUtils.fileExists(locFilNam))
			{
			  boolean isSuccess = MdaUtils.fileMove(locFilNam,targetPath);
			  log.debug("{}","isSuccess:" + isSuccess);
			  if(isSuccess)
			  {
			    try
			    {
			      f.createNewFile();
			      if(MdaUtils.fileExists(tarFilNam))
			      {
			        errcod = "00000";
			      }
			    }
			    catch(Exception e)
			    {
			      errcod = "0";
			      e.printStackTrace();
			    }
			  }
			  else
			  {
			    errcod = "0";
			    log.debug("{}","移动文件失败！");
			  }
			}
			else
			{
			  errcod = "0";
			  log.debug("{}","报文不存在！");
			}
		}































}