package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函开立申请及合同模板推送
*/
@Transaction(vo= GitmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitmdl.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitmdl.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitmdl.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitmdl.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitmdl.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitmdl.this.getGidgrp().getRec().getStlref();}}
			 );
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
        }

        /**
        *   source:gitmdl.@0000.script
        */
        @Rule(target="gitp.select",order=100)
        public boolean ruleGitpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getGitp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage("提示","请先选中一条记录！");
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getGitp().getCidmod().getClipty(),new Argument("cid",this.getGitp().getCidmod().getClilst().getElement(index).getCid()));
			  this.getGitp().getBummod().getWrkmdl().setCidinr(this.getGitp().getCidmod().getClipty().getCid());
			  log.debug("{}","cidinr="+this.getGitp().getBummod().getWrkmdl().getCidinr());
			  this.getGidgrp().setAplnam(this.getGitp().getCidmod().getClipty().getNam());
			  this.getGidgrp().getApl().getPts().setExtkey(this.getGitp().getBummod().getWrkmdl().getCidinr());
			  this.getGidgrp().getApl().getPts().setAdrblk(this.getGitp().getCidmod().getClipty().getEngnam());
			  
			  
			  

			}

			return true;
        }

        /**
        *   source:gitmdl.@0025.script
        */
        @Rule(target="gitp.gidgrp.checked",order=100)
        public boolean ruleGitpGidgrpCheckedN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","execute  event bpdgrp checked  .......");
			String steps = "";
			if(MdaUtils.isEmpty(this.getGidgrp().getChecked()))
			{
			  steps = "0:保函开立申请;1:保函合同开立;4:保存模板";
			  //无保证金协议及保证金委托开户和扣划，设置flags标志位为0000
			  this.getGidgrp().getRec().setFlags("0000");
			  
			  MdaUtils.clear(this.getGitp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getGitp().getBxdmod().getMar());
			}
			else
			{
			  this.getGidgrp().getBxd().setCgyd("1");
			  ctx.postRule(this,"gidgrp.bxd.cgyd");
			  this.getGidgrp().getBxd().setJxyd("1");
			  ctx.postRule(this,"gidgrp.bxd.jxyd");
			  this.getGidgrp().getBxd().setJsyd("1");
			  ctx.postRule(this,"gidgrp.bxd.jsyd");
			  this.getGidgrp().getBxd().setZyjjfs("1");
			  ctx.postRule(this,"gidgrp.bxd.zyjjfs");
			  //有保证金协议及保证金委托开户和扣划，设置flags标志位为0011
			  this.getGidgrp().getRec().setFlags("0011");
			  
			  steps = "0:保函开立申请;1:保函合同开立;2:保证金协议;3:委托开户扣划;4:保存模板";
			}
			log.debug("{}","---------------------------flags="+this.getGidgrp().getRec().getFlags());
			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:gitmdl.@0026.script
        */
        @Rule(target="gitp.gidgrp.rec.bzjcur",order=100)
        public boolean ruleGitpGidgrpRecBzjcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBzjcur()))
			{
			  String bzjcur= this.getGidgrp().getRec().getBzjcur();
			  this.getGidgrp().getGxd().setBzjcur(bzjcur);
			  
			  this.getGidgrp().getBxd().setCur(bzjcur);
			  
			  
			  if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBzjamt()))
			  {
			    String bzjamtcn = this.getSysmod().covCnAmt(this.getGidgrp().getRec().getBzjamt(),this.getGidgrp().getRec().getBzjcur());
			    this.getGidgrp().getGxd().setBzjamtcn(bzjamtcn);
			    
			    this.getGidgrp().getBxd().setAmt(this.getGidgrp().getRec().getBzjamt());
			    
			  }
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:gitmdl.@0027.script
        */
        @Rule(target="gitp.gidgrp.rec.bzjamt",order=100)
        public boolean ruleGitpGidgrpRecBzjamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBzjamt()))  //金额不为空
			{
			  if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBzjcur()))  //币种不为空
			  {
			    String bzjamtcn = this.getSysmod().covCnAmt(this.getGidgrp().getRec().getBzjamt(),this.getGidgrp().getRec().getBzjcur());
			    this.getGidgrp().getGxd().setBzjamtcn(bzjamtcn);
			    
			    this.getGidgrp().getBxd().setAmt(this.getGidgrp().getRec().getBzjamt());
			    
			  }
			  
			}
			else
			{
			  
			  this.getGidgrp().getGxd().setBzjamtcn(NULLSTR);
			  
			  this.getGidgrp().getBxd().setAmt(new BigDecimal(0));
			  

			}

			return true;
        }



        /**
        *   source:gitmdl.@0001.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块gitmdl  init业务处理开始，ORDER编号:50");
			//定义步骤条
			this.getGitp().getStpmod().storePanel(this.getGitp().getGitmdlstep02(),this.getGitp().getGitmdlstep03(),this.getGitp().getGitmdlstep04(),this.getGitp().getGitmdlstep05(),this.getGitp().getGitmdlstep06());
			String steps = "0:保函开立申请;1:保函合同开立;4:保存模板";
			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();


			return true;
        }

        /**
        *   source:gitmdl.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","模块gitmdl  init业务处理开始，ORDER编号:100");
			//初始化是否有保证金协议标志位
			this.getGidgrp().getRec().setFlags("0000");

			this.getGitp().getBummod().setModtyp("gitapn");
			
			

			this.getGitp().loadTips();

			//保证金初始化
			this.getGitp().getBxdmod().getBxd().setHtmc("开立银行保函协议");
			
			

			this.getGitp().getBxdmod().getBxd().setYwzl("2");
			
			

			//申请界面初始化
			
			
			
			
			
			

			   //单证通编号
			   //申请日期
			  //申请人
			  //申请人名址
			  //担保时间起
			  //担保时间止
			  //担保事件起
			  //担保事件止
			  //担保事件止
			   //反担保日期灰显
			
			

			//合同界面初始化
			  //包含合同编号
			
			
			
			
			
			
			
			
			  //争议解决方式下方三个栏位灰显
			
			
			  //协议保证金币种灰显
			   //协议保证金大写金额灰显
			    //保证金申请界面保证金币种灰显
			   //保证金申请界面保证金额灰显
			
			this.getGidgrp().getRec().setLgfmt("1");
			this.getGidgrp().getRec().setOpntyp("2");
			this.getGidgrp().getRec().setTxttyp("1");
			this.getGidgrp().getRec().setApprul("1");

			//出具方式关联控制
			List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			cjfs.add(new CodetableItem("由你行委托XX银行通知受益人","3"));
			cjfs.add(new CodetableItem(" 由你行委托XX银行开出反担保","4"));
			MdaUtils.setValues(this.getGidgrp().getRec(),"cjfs",cjfs);
			this.getGidgrp().getRec().setCjfs("3");
			
			//受益人收件地址
			//受益人联系人信息
			
			
			
			

			//保函到期日
			  //受益人收件地址
			
			//通知行编号和地址
			
			
			
			

			//反担保行编号和地址
			
			
			
			

			  //反担保到期日
			

			//保函期限类型关联控制
			this.getGidgrp().getRec().setDbqxtyp("1");
			
			
			
			
			
			
			this.getGidgrp().getRec().setDbqxshjq(NULLSTR);
			this.getGidgrp().getRec().setDbqxshjz(NULLSTR);
			
			
			
			

			this.getGidgrp().getApl().initDap("gid");
			this.getGidgrp().getApl().getPts().setRol("apl");

			this.getGidgrp().getBen().initDap("gid");
			this.getGidgrp().getBen().getPts().setRol("ben");


			return true;
        }

        /**
        *   source:gitmdl.@0015.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> jffs =  new ArrayList<CodetableItem>();
			jffs.add(new CodetableItem("壹","1"));
			jffs.add(new CodetableItem("贰","2"));
			MdaUtils.setValues(this.getGidgrp().getGxd(),"jffs",jffs);

			List<CodetableItem> zyjjfs =  new ArrayList<CodetableItem>();
			zyjjfs.add(new CodetableItem("壹","1"));
			zyjjfs.add(new CodetableItem("贰","2"));
			zyjjfs.add(new CodetableItem("叁","3"));
			MdaUtils.setValues(this.getGidgrp().getGxd(),"zyjjfs",zyjjfs);


			return true;
        }









}