package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函开立申请
*/
@Transaction(vo= GitopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitopn.class);

        //保函类型
        private String bhlx;
		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gitopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitopn.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitopn.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitopn.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gitopn.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gitopn.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gitopn.@0001.script
        */
        @Rule(target="gidgrp.rec.apldat",order=100)
        public boolean ruleGidgrpRecApldatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getApldat()))
			{
			  this.getGidgrp().getRec().setStadat("");
			  
			}

			return true;
        }

        /**
        *   source:gitopn.@0002.script
        */
        @Rule(target="gidgrp.rec.lmudat",order=100)
        public boolean ruleGidgrpRecLmudatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getLmudat()))
			{
			  this.getGidgrp().getRec().setEnddat("");
			  
			}

			return true;
        }

        /**
        *   source:gitopn.@0003.script
        */
        @Rule(target="gidgrp.rec.opntyp",order=100)
        public boolean ruleGidgrpRecOpntypN100(){
            IContext ctx = MdaEnv.getContext();
            
			onChangeOpntyp();

			return true;
        }

        /**
        *   source:gitopn.@0004.script
        */
        @Rule(target="gidgrp.rec.apprul",order=100)
        public boolean ruleGidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getGidgrp().getRec().getApprul()))
			{
			  this.getGidgrp().getRec().setApprultxt("");
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("lgapprul",this.getGidgrp().getRec().getApprul()));
			  
			  
			}

			return true;
        }

        /**
        *   source:gitopn.@0005.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getGidgrp()))
			  return false;
			//Platform.dbBegin();
			log.info("{}","sav200开始================" );
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			  String objinr=this.getGidgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getBen().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getGidgrp().getAdv().getPts(),objinr);
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getGidgrp().getRec().setIbchcod(this.getGidgrp().getRec().getBchcod());
			  else
			    this.getGidgrp().getRec().setDbchcod(this.getGidgrp().getRec().getBchcod());
			  this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getRec());
			  String objinr = this.getGidgrp().getRec().getInr();
			  String objtyp = "gid";
			  //ben
			  this.getGidgrp().getBen().savpts(objinr,objtyp);
			  //2017 存apl，合同开立使用
			  this.getGidgrp().getApl().savpts(objinr,objtyp);
			  //adv
			  this.getGidgrp().getAdv().savpts(objinr,objtyp);
			  this.getGidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getGidgrp().getDap().getPts().setObjinr(objinr);
			  this.getGidgrp().getDap().getPts().setObjtyp("gid");
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getDap().getPts());
			  log.info("{}", "sav200入库结束================" );
			}

			this.dealPDFData();
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:gitopn.@0006.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            

			this.dealPDFData();
			IStream stream=this.getMtabut().getApldoc();
			MdaUtils.streamClear(stream);
			ctx.absGet(Sysmod.class).generatorPdf("","gitopn",stream,false );

			return true;
        }

        /**
        *   source:gitopn.@0008.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.checkAll(this.getGidgrp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitopn","CT000031"),MdaUtils.getI18NString("gitopn","CT000032"));
			}

			return true;
        }

        /**
        *   source:gitopn.@0017.script
        */
        @Rule(target="gidgrp.rec.lgtyp",order=100)
        public boolean ruleGidgrpRecLgtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","czq===================");
			//String sql="SELECT guatxt FROM git WHERE guatyp='"+$gidgrp\\rec\\lgtyp.getValue()+"' and etyinr='"+$sysmod\\pty\\inr.getValue()+"'";
			//Platform.dbRead($gidgrp\\git,new Argument("etyinr",$sysmod\\pty\\inr.getValue()),new Argument("guatyp",$gidgrp\\rec\\lgtyp.getValue()));
			this.getGidgrp().getRec().setLgtxt(NULLSTR);
			ctx.getDaoSession().dbRead(this.getGidgrp().getGit(),new Argument("guatyp",this.getGidgrp().getRec().getLgtyp()));
			this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGit().getGuatxt());
			

			return true;
        }

        /**
        *   source:gitopn.@0019.script
        */
        @Rule(target="mtabut.mail",order=100)
        public boolean ruleMtabutMailN100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("gitopnApp"+inr,"gitopn");
			this.getMtabut().creatTcoPdfFile("gitopnDra"+inr);
			this.getMtabut().setAttnames("gitopnApp"+inr+".pdf;gitopnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:gitopn.@0020.script
        */
        @Rule(target="mtabut.xptslt",order=100)
        public boolean ruleMtabutXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getXptqna());
			this.getMtabut().getXptqna().setRef(this.getGidgrp().getRec().getOwnref());
			log.debug("{}","ref="+this.getMtabut().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getMtabut().getXptqna());
			

			return true;
        }

        /**
        *   source:gitopn.@0022.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:gitopn.@0027.script
        */
        @Rule(target="gitp.gidgrp.rec.furtyp",order=100)
        public boolean ruleGitpGidgrpRecFurtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","furtyp onchange,furtyp:" + this.getGidgrp().getRec().getFurtyp());
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getFurtyp()) && "3".equals(this.getGidgrp().getRec().getFurtyp()))
			{
			  //通知行栏位 亮显，可编辑
			  
			  
			}
			else
			{
			  //通知行栏位 灰显，不可编辑
			  
			  
			}
			
			

			return true;
        }


        /**
        *   source:gitopn.@0016.script
        */
        @Check(target="gidgrp.rec.lmudat",order=100)
        public boolean checkGidgrpRecLmudatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getCredat())&&!MdaUtils.isEmpty(this.getGidgrp().getRec().getLmudat())&&MdaUtils.diff(this.getGidgrp().getRec().getLmudat(),this.getGidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"gidgrp.rec.lmudat",MdaUtils.getI18NString("gitopn","CT000034"));
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getApldat())&&!MdaUtils.isEmpty(this.getGidgrp().getRec().getLmudat())&&MdaUtils.diff(this.getGidgrp().getRec().getLmudat(),this.getGidgrp().getRec().getApldat())<0)
			  ctx.setFieldError(this,"gidgrp.rec.lmudat",MdaUtils.getI18NString("gitopn","CT000208"));

			return true;
        }

        /**
        *   source:gitopn.@0023.script
        */
        @Check(target="gitp.gidgrp.rec.apldat",order=100)
        public boolean checkGitpGidgrpRecApldatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getApldat()) && !MdaUtils.isEmpty(this.getGidgrp().getRec().getCredat()) && (MdaUtils.diff(this.getGidgrp().getRec().getApldat(),this.getGidgrp().getRec().getCredat())<0))
			{
			  log.debug("{}",MdaUtils.diff(this.getGidgrp().getRec().getApldat(),this.getGidgrp().getRec().getCredat()));
			  ctx.setFieldError(this,"gidgrp.rec.apldat",MdaUtils.getI18NString("gitopn","CT000041"));
			}

			return true;
        }

        /**
        *   source:gitopn.@0025.script
        */
        @Check(target="gidgrp.agree",order=100)
        public boolean checkGidgrpAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(TRUE.equals(this.getGidgrp().getAgree())))
			{
			  ctx.setFieldError(this,"gidgrp.agree",MdaUtils.getI18NString("gitopn","CT000042"));
			  return true;
			}

			return true;
        }


        /**
        *   source:gitopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			
			

			this.getGidgrp().getRec().setApldat(MdaUtils.today());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  onChangeOpntyp();
			  return true;
			}
			else
			{
			  String time =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  this.getGidgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			  
			  this.getGidgrp().getApl().getPts().setNam(this.getSysmod().getPty().getNam());
			  
			  //$gidgrp\\rec\\agrnam.setValue($sysmod\\pty\\nam.getValue());
			  this.getGidgrp().getRec().setLgcur("USD");
			  this.getGidgrp().getRec().setLgtyp("1");
			  ctx.getDaoSession().dbRead(this.getGidgrp().getGit(),new Argument("guatyp",this.getGidgrp().getRec().getLgtyp()));
			  this.getGidgrp().getRec().setLgtxt(this.getGidgrp().getGit().getGuatxt());
			  this.getGidgrp().getRec().setOpntyp("2");
			  this.getGidgrp().getRec().setFurtyp("1");
			  this.getGidgrp().getRec().setEngcur("USD");
			  this.getGidgrp().getRec().setApprul("1");
			  this.getGidgrp().setAgree(TRUE);
			  // Platform.clear($gidgrp\\agree);
			  this.getGidgrp().getRec().setApprultxt("URDG");
			  
			  this.getGidgrp().getApl().initDap("gid");
			  this.getGidgrp().getApl().getPts().setRol("apl");
			  onChangeOpntyp();
			}

			return true;
        }

        /**
        *   source:gitopn.@0021.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			this.getGidgrp().setAgree(TRUE);
			this.setBhlx("Irrevocable");

			return true;
        }


        /**
        *   source:gitopn.@0012.script
        */
        public void onChangeOpntyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","onChangeOpntyp=="+this.getGidgrp().getRec().getOpntyp());
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  
			  
			  //Platform.disable($gitp\\advp\\ptspta\\pts\\extkey);
			  //Platform.disable($gitp\\advp\\ptspta\\pts\\adrblk); 放开通知行相关
			  //Platform.disable($gitp\\advp\\sel);
			  
			  
			  
			  
			}
			else
			{
			  this.getGidgrp().getRec().setFurtyp(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
		}
        /**
        *   source:gitopn.@0035.script
        */
        public void dealPDFData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ="";
			log.debug("{}","message"+this.getGidgrp().getRec().getOpntyp());
			log.debug("{}","opntyp="+this.getGidgrp().getRec().getOpntyp());
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))
			{
			  typ=MdaUtils.getCodetableLabel("furtyp",this.getGidgrp().getRec().getFurtyp());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getGidgrp().getAdv().getPts().getNam()))
			    typ="由贵行委托"+this.getGidgrp().getAdv().getPts().getNam()+"银行（SWIFT NO."+this.getGidgrp().getAdv().getPts().getExtkey()+"英文全称"+this.getGidgrp().getAdv().getPts().getAdrblk()+")通知受益人。";
			}
			this.getGidgrp().setTyp(typ);
		}









}