package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitoszVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Sztmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 深圳电子保函开立
*/
@Transaction(vo= GitoszVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitosz extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitosz.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sztmod sztmod;


		public Gitosz()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getGitp().getGidgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gitosz.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gitosz.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.szgit.ptbusino");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getSzgit().setPtbusino(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getSzgit().getPtbusino();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getSztmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitosz.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitosz.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitosz.this.getGidgrp().getRec().getOwnref();}}
			 );
        }

        /**
        *   source:gitosz.@0002.script
        */
        @Rule(target="gitp.pdfbhklspb",order=100)
        public boolean ruleGitpPdfbhklspbN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.flgs();
			this.getGitp().getPdfviw().callPDFComponent("","gitosz1","贸金业务审批表",1);
			log.debug("{}","============shenpi1"+this.getGidgrp().getSpb().getShenpi1());
			log.debug("{}","============shenpi2"+this.getGidgrp().getSpb().getShenpi2());

			return true;
        }

        /**
        *   source:gitosz.@0003.script
        */
        @Rule(target="gitp.pdfzsxqkb",order=100)
        public boolean ruleGitpPdfzsxqkbN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getGitp().getPdfviw().callPDFComponent("","gitosz2","贸金金融业务真实性情况表",1);

			return true;
        }

        /**
        *   source:gitosz.@0005.script
        */
        @Rule(target="gitp.sztmod.save",order=200)
        public boolean ruleGitpSztmodSaveN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getGidgrp()))
			{
			  return false;
			}

			String busino = "EBH101";
			String busiid = this.getGidgrp().getSzgit().getMsgref();
			String filebusitype = "13";
			ctx.getDaoSession().dbRead(this.getGitp().getEbhfat(),new Argument<String>("busino",busino),new Argument<String>("busiid",busiid),new Argument<String>("filebusitype",filebusitype));
			if(MdaUtils.isEmpty(this.getGitp().getEbhfat().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000100"),MdaUtils.getI18NString("gitosz","CT000101"));
			  return false;
			}
			String cpno = this.getSysmod().getCpno();
			String typ = this.getGitp().getEbhfat().getDoctyp();
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  List<String> list = new ArrayList<String>();
			  list.add("docx");
			  list.add("doc");
			  if(!(list.contains(typ)))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000102"),"合作平台格式文本为" + typ + "类型，不允许提交！");
			    return false;
			  }
			}
			else
			{
			  if(!"docx".equals(typ))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000103"),"高新投格式文本为" + typ + "类型，不允许提交！");
			    return false;
			  }
			}

			if(this.getGitp().secupdat(this.getGidgrp().getSzgit().getSeccifno()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000106"),MdaUtils.getI18NString("gitosz","CT000138"));
			  return false;
			}

			//高新投全部为非分离式保函，
			if("0".equals(this.getGidgrp().getSzgit().getIsfinancee()))
			{
			  this.getGidgrp().getRec().setBhxz("1");
			}
			else
			{
			  this.getGidgrp().getRec().setBhxz("2");
			}

			//如果转开国结手动
			/*
			  if("0".equals($gidgrp\\szgit\\istrasopen.getValue()))
			  {
			  $gidgrp\\szgit\\sstfsta.setValue("2");
			  }
			  else
			  {
			  $gidgrp\\szgit\\sstfsta.setValue("1");
			  }
			  */
			//国结传"1"是自动处理，现国结不支持自动处理，
			this.getGidgrp().getSzgit().setSstfsta("2");

			ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getGidgrp().getSzgit());
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  //申请书处理
			  this.ztbdeal();
			  //处理业务逻辑
			  if(MdaUtils.isEmpty(this.getGidgrp().getSxb().getInr()))
			  {
			    this.getGidgrp().getSxb().setInr(this.getGidgrp().getRec().getInr());
			    ctx.getDaoSession().dbInsert(this.getGidgrp().getSxb());
			  }
			  else
			  {
			    ctx.getDaoSession().dbUpdate(this.getGidgrp().getSxb());
			  }
			}
			else
			{
			  //申请书处理
			  this.flgs();
			  //处理业务逻辑
			  if(MdaUtils.isEmpty(this.getGidgrp().getSpb().getInr()))
			  {
			    this.getGidgrp().getSpb().setInr(this.getGidgrp().getRec().getInr());
			    ctx.getDaoSession().dbInsert(this.getGidgrp().getSpb());
			  }
			  else
			  {
			    ctx.getDaoSession().dbUpdate(this.getGidgrp().getSpb());
			  }
			}

			MdaUtils.clear(this.getTrnmod().getTrn());
			this.getTrnmod().getTrn().copyValue(this.getGitp().getSztmod().getGidtrn());

			String filename = this.getSysmod().createFilename(this.getGitp().getSztmod().getGidtrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			IPanel[] panels=this.getGitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);

			log.debug("{}","order 200 over");

			return true;
        }

        /**
        *   source:gitosz.@0006.script
        */
        @Rule(target="gitp.gidgrp.spb.shenpi4",order=100)
        public boolean ruleGitpGidgrpSpbShenpi4N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGitp().getGidgrp().getSpb().getShenpi4()))
			{
			  this.getGitp().getGidgrp().getSpb().setShenpi5("");
			  
			}


			return true;
        }

        /**
        *   source:gitosz.@0007.script
        */
        @Rule(target="gitp.gidgrp.spb.shenpi5",order=100)
        public boolean ruleGitpGidgrpSpbShenpi5N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGitp().getGidgrp().getSpb().getShenpi5()))
			{
			  this.getGitp().getGidgrp().getSpb().setShenpi4("");
			  
			}


			return true;
        }

        /**
        *   source:gitosz.@0008.script
        */
        @Rule(target="gitp.sztmod.save",order=210)
        public boolean ruleGitpSztmodSaveN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 2;
			String labels = "";
			String tempfiles = "";
			String cpno = this.getSysmod().getCpno();
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  labels = "授信使用审批意见表,贸金金融业务真实性情况表";
			  tempfiles = "A:gitobj1,A:gitobj2";
			}
			else
			{
			  labels = "贸金业务审批表,贸金金融业务真实性情况表";
			  tempfiles = "A:gitosz1,A:gitosz2";
			}
			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:gitosz.@0009.script
        */
        @Rule(target="gitp.compar",order=100)
        public boolean ruleGitpComparN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!"Y".equals(this.getGidgrp().getSzgit().getIsstandardtext()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000042"),MdaUtils.getI18NString("gitosz","CT000043"));
			  return true;
			}

			//高新投保函格式
			String busino = "EBH101";
			String busiid = this.getGidgrp().getSzgit().getMsgref();
			String filebusitype = "13";
			ctx.getDaoSession().dbRead(this.getGitp().getEbhfat(),new Argument<String>("busino",busino),new Argument<String>("busiid",busiid),new Argument<String>("filebusitype",filebusitype));

			//标准格式文本
			String wbinr = this.getGidgrp().getSzgit().getTextcode();
			ctx.getDaoSession().dbRead(this.getGitp().getGsdgrp().getGsd(),new Argument<String>("wbinr",wbinr));
			log.info("{}","filnam1:"+this.getGitp().getEbhfat().getFilnam() + " , filnam2:"+this.getGitp().getGsdgrp().getGsd().getFilenam());

			if(MdaUtils.isEmpty(this.getGitp().getGidgrp().getSzgit().getTextcode()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000036"),MdaUtils.getI18NString("gitosz","CT000037"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getGitp().getGsdgrp().getGsd().getWbnam()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000038"),MdaUtils.getI18NString("gitosz","CT000039"));
			  return true;
			}

			if(MdaUtils.isEmpty(this.getGitp().getEbhfat().getCredat()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000056"),MdaUtils.getI18NString("gitosz","CT000057"));
			  return true;
			}

			//文件路径
			String f0 = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/szdzbh/fatdir/" + this.getGitp().getEbhfat().getCredat() + "/" +this.getGitp().getEbhfat().getFilnam())+ ".docx");
			String f1 = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/szdzbh/bilmdl/" +this.getGitp().getGsdgrp().getGsd().getFilenam()));
			log.info("{}","grn-inr:"+this.getGitp().getSztmod().getGrn().getInr());
			log.info("{}","f0:"+f0);
			log.info("{}","f1:"+f1);

			//文件比对及结果
			String fileName = this.getGitp().makeCompareWord(this.getGitp().getSztmod().getGidtrn().getInr(),f0,f1);
			log.info("{}","filename:"+fileName);

			//比对结果展示
			String inrStr = this.getGitp().getSztmod().getGidtrn().getInr().substring(0,4);
			String filename = this.getGitp().getSztmod().getGidtrn().getInr()+".html";
			String htmlsrc = "/bank/pdf/html/"+inrStr+"/"+filename;
			log.info("{}","htmlsrc:"+htmlsrc);

			MdaUtils.invoke("client:","bhcompare",htmlsrc);


			return true;
        }

        /**
        *   source:gitosz.@0010.script
        */
        @Rule(target="gitp.stafortxt",order=100)
        public boolean ruleGitpStafortxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:gitosz.@0011.script
        */
        @Rule(target="gitp.stawebtext",order=100)
        public boolean ruleGitpStawebtextN100(){
            IContext ctx = MdaEnv.getContext();
            
			//标准保函格式文本
			String wbinr = this.getGidgrp().getSzgit().getTextcode();
			ctx.getDaoSession().dbRead(this.getGitp().getGsdgrp().getGsd(),new Argument<String>("wbinr",wbinr));
			log.info("{}","标准格式文本filnam:"+this.getGitp().getGsdgrp().getGsd().getWbnam());

			if(MdaUtils.isEmpty(this.getGitp().getGsdgrp().getGsd().getWbnam()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitosz","CT000096"),MdaUtils.getI18NString("gitosz","CT000097"));
			  return true;
			}

			//source  docx原目标路径
			//target  转换后html路径
			String source = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/szdzbh/bilmdl/" +this.getGitp().getGsdgrp().getGsd().getFilenam()));
			String target = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/pdf/bilhtml/" + this.getGidgrp().getSzgit().getTextcode() + ".html"));
			log.info("{}","stawebtext source:"+source);
			log.info("{}","stawebtext target:"+target);
			MdaUtils.invoke("com.brilliance.utils.WordCompareUtil","docx2html",source,target);

			String htmlsrc = "/bank/pdf/bilhtml/"+this.getGidgrp().getSzgit().getTextcode() + ".html";
			MdaUtils.invoke("client:","bhcompare",htmlsrc);
			

			return true;
        }

        /**
        *   source:gitosz.@0012.script
        */
        @Rule(target="gitp.gxtwebtxt",order=100)
        public boolean ruleGitpGxtwebtxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//高新投保函格式文本
			String busino = "EBH101";
			String busiid = this.getGidgrp().getSzgit().getMsgref();
			String filebusitype = "13";
			ctx.getDaoSession().dbRead(this.getGitp().getEbhfat(),new Argument<String>("busino",busino),new Argument<String>("busiid",busiid),new Argument<String>("filebusitype",filebusitype));

			/*
			  if(Platform.isEmpty($gitp\\gidgrp\\szgit\\textcode.getValue()))
			  {
			  Platform.message(#CT000098,#CT000099);
			  return;
			  }
			  */

			//source  docx原目标路径
			//target  转换后html路径
			String source = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/szdzbh/fatdir/" + this.getGitp().getEbhfat().getCredat() + "/" +this.getGitp().getEbhfat().getFilnam()+".docx"));
			String target = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/pdf/fathtml/" + this.getGitp().getEbhfat().getCredat() + "/"  + this.getGitp().getGidgrp().getSzgit().getInr() + ".html"));
			log.info("{}","gxtwebtxt source:"+source);
			log.info("{}","gxtwebtxt target:"+target);
			MdaUtils.invoke("com.brilliance.utils.WordCompareUtil","docx2html",source,target);

			String htmlsrc = "/bank/pdf/fathtml/" + this.getGitp().getEbhfat().getCredat() + "/" +this.getGitp().getGidgrp().getSzgit().getInr() + ".html";
			MdaUtils.invoke("client:","bhcompare",htmlsrc);
			

			return true;
        }

        /**
        *   source:gitosz.@0016.script
        */
        @Rule(target="gitp.gitaztbreal",order=100)
        public boolean ruleGitpGitaztbrealN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.ztbdeal();
			this.getGitp().getPdfviw().callPDFComponent("","gitobj2","贸金金融业务真实性情况表",1);

			return true;
        }

        /**
        *   source:gitosz.@0017.script
        */
        @Rule(target="gitp.gitaztbspb",order=100)
        public boolean ruleGitpGitaztbspbN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.ztbdeal();
			this.getGitp().getPdfviw().callPDFComponent("","gitobj1","贸金业务审批表",1);
			log.debug("{}","============fhldsel1"+this.getGidgrp().getSxb().getFhldsel1());
			log.debug("{}","============fhldsel"+this.getGidgrp().getFhldsel());

			return true;
        }

        /**
        *   source:gitosz.@0020.script
        */
        @Rule(target="gitp.stpmod.save",order=100)
        public boolean ruleGitpStpmodSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			//申请书处理
			this.ztbdeal();
			//处理业务逻辑
			if(MdaUtils.isEmpty(this.getGidgrp().getSxb().getInr()))
			{
			  this.getGidgrp().getSxb().setInr(this.getGidgrp().getRec().getInr());
			  ctx.getDaoSession().dbInsert(this.getGidgrp().getSxb());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getGidgrp().getSxb());
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("提示","数据库异常，请联系管理员！");
			  return false;
			}
			else
			{
			  ctx.setMessage("提示","提交成功");
			}

			return true;
        }

        /**
        *   source:gitosz.@0021.script
        */
        @Rule(target="gitp.selpdf",order=100)
        public boolean ruleGitpSelpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","pdf====上传pdf===selpdf========================================");
			Object[] obj = (Object[])MdaUtils.getEventData();
			IStream stream = this.getGitp().getSelpdf();
			upLoad(stream,obj,"1");

			return true;
        }



        /**
        *   source:gitosz.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}","init gitosz start");
			IModule gid = (IModule)ctx.restoreData("com.brilliance.gitosz.ref");
			if(!MdaUtils.isEmpty(gid))
			{
			  this.getGidgrp().getRec().copyValue(gid);
			  String inr=this.getGidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getGidgrp().getSzgit(),new Argument<String>("inr",inr));
			  this.getGitp().getSztmod().setPtbusino(this.getGidgrp().getSzgit().getPtbusino()); //高新投业务号，必须
			  //申请人
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","apl"));
			  
			  
			  

			  //被担保人
			  ctx.getDaoSession().dbRead(this.getGidgrp().getSec().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","sec"));
			  
			  
			  

			  //受益人
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			  
			  
			  

			  String inrs=(String)ctx.restoreData("com.brilliance.inr.ref");
			  this.getGitp().getSztmod().setTrninr(inrs);//流水号主键
			  log.debug("{}","trninr  is  :"+inrs);
			  MdaUtils.clear(this.getGitp().getSztmod().getGidtrn());
			  MdaUtils.clear(this.getGitp().getSztmod().getGrn());
			  ctx.getDaoSession().dbRead(this.getGitp().getSztmod().getGidtrn(),new Argument<String>("inr",inrs));
			  ctx.getDaoSession().dbRead(this.getGitp().getSztmod().getGrn(),new Argument<String>("objtyp","trn"),new Argument<String>("objinr",inrs));
			  log.info("{}","init grn-inr:"+this.getGitp().getSztmod().getGrn().getInr()+", gidtrn-inr : " + this.getGitp().getSztmod().getGidtrn().getInr());
			  String cpno = this.getGitp().getSztmod().getGrn().getSrc();
			  if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			  {
			    ctx.getDaoSession().dbRead(this.getGidgrp().getSxb(),new Argument<String>("inr",inr));
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSztmod().getGidtrn().getOrdinr());
			    
			    log.debug("{}","sxb刷新**");
			  }
			  else
			  {
			    if(!"O".equals(this.getGitp().getSztmod().getGrn().getRettyp())) //退回业务
			    {
			      ctx.getDaoSession().dbRead(this.getGidgrp().getSpb(),new Argument<String>("inr",inr));

			      this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSztmod().getGidtrn().getOrdinr());
			    }
			  }

			  //初始化机构
			  this.getGidgrp().setBchcod(this.getGidgrp().getRec().getBchcod());
			  List<CodetableItem> bchcod =this.getSysmod().getBchcod(this.getGidgrp().getRec().getPtyinr(),"2");
			  MdaUtils.setValues(this.getGidgrp(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(bchcod))
			  {
			    this.getGidgrp().setBchcod(bchcod.get(0).getValue());
			  }

			  if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getCjfs()))
			  {
			    this.getGidgrp().getRec().setCjfs(this.getGidgrp().getRec().getCjfs().trim());
			  }

			  this.getGidgrp().getSpb().setKehunam(this.getGidgrp().getApl().getPts().getNam());

			}

			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			// Platform.disable($gidgrp\\szgit\\sffs);
			// Platform.disable($gidgrp\\rec\\sffl);
			
			
			
			
			
			
			
			
			
			//Platform.disable($gidgrp\\rec\\bhdqdat);
			
			

			this.getGidgrp().getRec().setLgcur("CNY");
			this.getGidgrp().getSzgit().setPoundagecur("CNY");
			this.getGidgrp().getSzgit().setLanguage("CN");
			this.getGidgrp().getSzgit().setIsdiscreted("0");//是否分离式保函 默认是 客户不可修改
			this.getGidgrp().getSzgit().setIsfinancee("1");//是否融资类保函 默认否  客户不可修改
			
			//保函文本对比结果选择
			if("0".equals(this.getGidgrp().getSzgit().getIsstandardtext()))
			{
			  
			}
			else
			{
			  
			  this.getGidgrp().getSzgit().setTxtyon("3");
			  
			}
			this.getGitp().getSztmod().setPtbusino(this.getGidgrp().getSzgit().getPtbusino());
			this.getGitp().getSztmod().setMsgref(this.getGidgrp().getSzgit().getMsgref());
			this.getGitp().getSztmod().setUsrinr(this.getSysmod().getUsr().getInr());
			log.info("{}","gitosz msgref :" + this.getSztmod().getMsgref());
			

			log.debug("{}","gitapn  init页面分配处理");
			String steps = "";
			String src = this.getGitp().getSztmod().getGrn().getSrc();
			ctx.getDaoSession().dbRead(this.getSztmod().getSzusraut(),new Argument<String>("usrinr",this.getGitp().getSztmod().getUsrinr()));
			this.getSysmod().setCpno(src);
			log.debug("{}","平台类型：" + src );
			//有值且ZTB是中投保  	否则高新投
			if(!MdaUtils.isEmpty(src) && "ZTB".equals(src))
			{
			  //支行经办权限展示上传文件按钮
			  if("OO".equals(this.getGitp().getSztmod().getGrn().getGidsta()))
			  {
			    if("1".equals(this.getSztmod().getSzusraut().getAflg()) && "0".equals(this.getSztmod().getSzusraut().getBflg()))
			    {
			      MdaUtils.isVisible(this.getGitp(),"selpdf");
			    }
			    else
			    {
			      
			    }
			  }
			  else
			  {
			    
			  }
			  
			  
			  this.getGitp().getStpmod().storePanel(this.getGitp().getGitapnst11(),this.getGitp().getGitshouxin(),this.getGitp().getGitaztbapp());
			  steps = "0:保函开立申请;1:补录信息;2:合同展示";
			}
			else
			{
			  //0、保函开立申请    1、审批表和真实性表  2、申请书展示
			  this.getGitp().getStpmod().storePanel(this.getGitp().getGitapnst11(),this.getGitp().getGitapnst12(),this.getGitp().getGitapnst13());
			  steps = "0:保函开立申请;1:补录信息;2:合同展示";
			  
			}
			log.debug("{}","steps:"+steps);
			this.getGitp().getStpmod().setPages(steps);
			this.getGitp().getStpmod().calcSteps();
			this.getGitp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:gitosz.@0001.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }


        /**
        *   source:gitosz.@0004.script
        */
        public void flgs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"0"为转开保函
			if("0".equals(this.getGidgrp().getSzgit().getIstrasopen()))
			{
			  this.getGidgrp().setCount1(NULLSTR);
			  this.getGidgrp().setBhsxamt1(new BigDecimal(0));
			  this.getGidgrp().setCount2(this.getGidgrp().getSzgit().getFeeaccount());
			  this.getGidgrp().setBhsxamt2(this.getGidgrp().getSzgit().getPoundageamt());
			}
			else
			{
			  this.getGidgrp().setCount2(NULLSTR);
			  this.getGidgrp().setBhsxamt2(new BigDecimal(0));
			  this.getGidgrp().setCount1(this.getGidgrp().getSzgit().getFeeaccount());
			  this.getGidgrp().setBhsxamt1(this.getGidgrp().getSzgit().getPoundageamt());
			}
			String time = MdaUtils.format(this.getGidgrp().getRec().getMatdat(),"yyyyMMdd");
			this.getGidgrp().getRec().setMatdat(MdaUtils.parseDate(time,"yyyyMMdd"));

			//高新投客户未签约，系统无该客户信息，加在组报的时候
			//$gidgrp\\cid.setValue("2403455142");
			
			String shenpi = "";
			//shenpi4与shenpi5是互斥选项
			
			if("X".equals(this.getGidgrp().getSpb().getShenpi1()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi2()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi3()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi4()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi5()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi6()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi7()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi8()))
			{
			  shenpi = shenpi + "√";
			}
			shenpi = shenpi + ",";
			if("X".equals(this.getGidgrp().getSpb().getShenpi9()))
			{
			  shenpi = shenpi + "√";
			}

			this.getGidgrp().setShenp(shenpi);

			BigDecimal amt = this.getGidgrp().getSpb().getDkamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getGidgrp().getSpb().setDkamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getDbdkamt(),"#0.00"));
			this.getGidgrp().getSpb().setDbdkamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getBhamt(),"#0.00"));
			this.getGidgrp().getSpb().setBhamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getQtrzamt(),"#0.00"));
			this.getGidgrp().getSpb().setQtrzamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getSxamt(),"#0.00"));
			this.getGidgrp().getSpb().setSxamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getUsedamt(),"#0.00"));
			this.getGidgrp().getSpb().setUsedamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getCdhpamt(),"#0.00"));
			this.getGidgrp().getSpb().setCdhpamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getJckyhamt(),"#0.00"));
			this.getGidgrp().getSpb().setJckyhamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getKzamt(),"#0.00"));
			this.getGidgrp().getSpb().setKzamt(amt);
			

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getYqdkamt(),"#0.00"));
			this.getGidgrp().getSpb().setYqdkamt(amt);
			

			/*额度类型及总额(类型待定)
			  amt = Platform.parseDecimal(Platform.format($gidgrp\\spb\\edamt.getValue(),"#0.00"));
			  $gidgrp\\spb\\edamt.setValue(amt);
			  Platform.setModified($gidgrp\\spb\\edamt);
			  */

			amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSpb().getKyamt(),"#0.00"));
			this.getGidgrp().getSpb().setKyamt(amt);
			
		}
        /**
        *   source:gitosz.@0015.script
        */
        public void ztbdeal()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"0"为转开保函
			if("0".equals(this.getGidgrp().getSzgit().getIstrasopen()))
			{
			  this.getGidgrp().setCount1(NULLSTR);
			  this.getGidgrp().setBhsxamt1(new BigDecimal(0));
			  this.getGidgrp().setCount2(this.getGidgrp().getSzgit().getFeeaccount());
			  this.getGidgrp().setBhsxamt2(this.getGidgrp().getSzgit().getPoundageamt());
			}
			else
			{
			  this.getGidgrp().setCount2(NULLSTR);
			  this.getGidgrp().setBhsxamt2(new BigDecimal(0));
			  this.getGidgrp().setCount1(this.getGidgrp().getSzgit().getFeeaccount());
			  this.getGidgrp().setBhsxamt1(this.getGidgrp().getSzgit().getPoundageamt());
			}
			String time = MdaUtils.format(this.getGidgrp().getRec().getMatdat(),"yyyyMMdd");
			this.getGidgrp().getRec().setMatdat(MdaUtils.parseDate(time,"yyyyMMdd"));

			String type = "";
			if("X".equals(this.getGidgrp().getSxb().getType1()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType2()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType3()))
			{
			  type = type + "√";
			}
			type = type + ",";
			if("X".equals(this.getGidgrp().getSxb().getType4()))
			{
			  type = type + "√";
			}
			this.getGidgrp().setType(type);

			String shiyong = "";
			if("X".equals(this.getGidgrp().getSxb().getShiyong1()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong2()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong3()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong4()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong5()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong6()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong7()))
			{
			  shiyong = shiyong + "√";
			}
			shiyong = shiyong + ",";
			if("X".equals(this.getGidgrp().getSxb().getShiyong8()))
			{
			  shiyong = shiyong + "√";
			}
			this.getGidgrp().setShiyong(shiyong);

			String jysel = "";
			if("X".equals(this.getGidgrp().getSxb().getJysel1()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel2()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel3()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel4()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel5()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel6()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel7()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel8()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel9()))
			{
			  jysel = jysel + "√";
			}
			jysel = jysel + ",";
			if("X".equals(this.getGidgrp().getSxb().getJysel10()))
			{
			  jysel = jysel + "√";
			}
			this.getGidgrp().setJysel(jysel);

			String fhbmsel = "";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel1()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel2()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel3()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel4()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel5()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel6()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel7()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel8()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel9()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel10()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel11()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			fhbmsel = fhbmsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhbmsel12()))
			{
			  fhbmsel = fhbmsel + "√";
			}
			this.getGidgrp().setFhbmsel(fhbmsel);

			String fhldsel = "";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel1()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel2()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel3()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel4()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel5()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel6()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel7()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel8()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel9()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel10()))
			{
			  fhldsel = fhldsel + "√";
			}
			fhldsel = fhldsel + ",";
			if("X".equals(this.getGidgrp().getSxb().getFhldsel11()))
			{
			  fhldsel = fhldsel + "√";
			}
			this.getGidgrp().setFhldsel(fhldsel);

			String kehuqk = "";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk1()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk2()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk3()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk4()))
			{
			  kehuqk = kehuqk + "√";
			}
			kehuqk = kehuqk + ",";
			if("X".equals(this.getGidgrp().getSxb().getKehuqk5()))
			{
			  kehuqk = kehuqk + "√";
			}
			this.getGidgrp().setKehuqk(kehuqk);

			String pifu = "";
			if("X".equals(this.getGidgrp().getSxb().getPifu0()))
			{
			  pifu = pifu + "√";
			}
			pifu = pifu + ",";
			if("X".equals(this.getGidgrp().getSxb().getPifu1()))
			{
			  pifu = pifu + "√";
			}
			this.getGidgrp().setPifu(pifu);

			String xindai = "";
			if("X".equals(this.getGidgrp().getSxb().getXindai0()))
			{
			  xindai = xindai + "√";
			}
			xindai = xindai + ",";
			if("X".equals(this.getGidgrp().getSxb().getXindai1()))
			{
			  xindai = xindai + "√";
			}
			this.getGidgrp().setXindai(xindai);

			String rzdk = "";
			if("X".equals(this.getGidgrp().getSxb().getRzdk0()))
			{
			  rzdk = rzdk + "√";
			}
			rzdk = rzdk + ",";
			if("X".equals(this.getGidgrp().getSxb().getRzdk1()))
			{
			  rzdk = rzdk + "√";
			}
			this.getGidgrp().setRzdk(rzdk);

			String glqy = "";
			if("X".equals(this.getGidgrp().getSxb().getGlqy0()))
			{
			  glqy = glqy + "√";
			}
			glqy = glqy + ",";
			if("X".equals(this.getGidgrp().getSxb().getGlqy1()))
			{
			  glqy = glqy + "√";
			}
			this.getGidgrp().setGlqy(glqy);

			String f51pf = "";
			if("X".equals(this.getGidgrp().getSxb().getF51pf0()))
			{
			  f51pf = f51pf + "√";
			}
			f51pf = f51pf + ",";
			if("X".equals(this.getGidgrp().getSxb().getF51pf1()))
			{
			  f51pf = f51pf + "√";
			}
			this.getGidgrp().setF51pf(f51pf);

			String dbhmd = "";
			if("X".equals(this.getGidgrp().getSxb().getDbhmd0()))
			{
			  dbhmd = dbhmd + "√";
			}
			dbhmd = dbhmd + ",";
			if("X".equals(this.getGidgrp().getSxb().getDbhmd1()))
			{
			  dbhmd = dbhmd + "√";
			}
			this.getGidgrp().setDbhmd(dbhmd);

			String jkhmd = "";
			if("X".equals(this.getGidgrp().getSxb().getJkhmd0()))
			{
			  jkhmd = jkhmd + "√";
			}
			jkhmd = jkhmd + ",";
			if("X".equals(this.getGidgrp().getSxb().getJkhmd1()))
			{
			  jkhmd = jkhmd + "√";
			}
			this.getGidgrp().setJkhmd(jkhmd);

			String dbhui = "";
			if("X".equals(this.getGidgrp().getSxb().getDbhui0()))
			{
			  dbhui = dbhui + "√";
			}
			dbhui = dbhui + ",";
			if("X".equals(this.getGidgrp().getSxb().getDbhui1()))
			{
			  dbhui = dbhui + "√";
			}
			this.getGidgrp().setDbhui(dbhui);

			String jkyj = "";
			if("X".equals(this.getGidgrp().getSxb().getJkyj0()))
			{
			  jkyj = jkyj + "√";
			}
			jkyj = jkyj + ",";
			if("X".equals(this.getGidgrp().getSxb().getJkyj1()))
			{
			  jkyj = jkyj + "√";
			}
			this.getGidgrp().setJkyj(jkyj);

			String dbyj = "";
			if("X".equals(this.getGidgrp().getSxb().getDbyj0()))
			{
			  dbyj = dbyj + "√";
			}
			dbyj = dbyj + ",";
			if("X".equals(this.getGidgrp().getSxb().getDbyj1()))
			{
			  dbyj = dbyj + "√";
			}
			this.getGidgrp().setDbyj(dbyj);

			BigDecimal amt = MdaUtils.parseDecimal(MdaUtils.format(this.getGidgrp().getSxb().getAmt(),"#0.00"));
			this.getGidgrp().getSxb().setAmt(amt);
			
		}
        /**
        *   source:gitosz.@0022.script
        */
        public void upLoad(IStream stream,Object[] obj,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","进入方法");
			String nam = this.getSysmod().getUsr().getOprnam();
			log.debug("{}","登录用户名："+nam);
			String pdfNam = obj[1].toString();
			int index = pdfNam.indexOf(".");
			log.info("{}","源文件名========"+pdfNam);
			String postfix = pdfNam.substring(index + 1);
			log.info("{}","后缀名========"+postfix);
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");

			String indexnew = MdaUtils.format(ctx.getDaoSession().dbCounter("tblcnt"),"000000000");
			log.debug("{}","自增值："+ctx.getDaoSession().dbCounter("tblcnt")+"新文件名："+indexnew);
			String alsnam = indexnew +"."+ postfix;
			if("pdf".equals(postfix) || "doc".equals(postfix) || "docx".equals(postfix))
			{
			  String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/szdzbh/fatd/" + time +"/" + alsnam);
			  if(MdaUtils.fileExists(filPath))
			    MdaUtils.fileDelete(filPath);
			  MdaUtils.streamSave(stream,filPath);
			  String ownref = this.getSztmod().getOwnref();
			  String msgref = ownref;
			  log.info("{}","文件地址："+filPath+"ownref:"+ownref+"msgref:"+msgref);
			  String cls = "com.brilliance.eibs.main.Client";
			  Object rtnVal = MdaUtils.invoke(cls,"scall","instblbil","instblbil",new Object[]{ownref,msgref,ctx.getTransName(),alsnam,pdfNam,postfix,filPath,nam});
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  Boolean errcod = (Boolean)retMsg.get("issuccess");
			  if(!errcod)
			  {
			    log.error("{}","文件上传失败！");
			    ctx.setMessage("提示","文件上传失败");
			    return;
			  }
			  else
			  {
			    ctx.setMessage("提示","文件上传成功");
			  }
			}
			else
			{
			  ctx.setMessage("提示","请上传pdf、doc、docx格式文件");
			}
		}









}