package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GitsndVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Wrnmod;
import com.ceb.gjjs.mda.bo.Grn;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Sttp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Imgmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函收妥交易
*/
@Transaction(vo= GitsndVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitsnd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gitsnd.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Sttp sttp;

		@BDGetter
		private Wrnmod wrnmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Imgmod imgmod;

		@BDGetter
		private Trn trn;

		@BDGetter
		private Grn grn;


		public Gitsnd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new java.math.BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getSttp().setGidgrpHolder(()->this.getGidgrp());
        }

        /**
        *   source:gitsnd.@0000.script
        */
        @Rule(target="sttp.sel",order=100)
        public boolean ruleSttpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.refresh();
			/*if(Platform.isEmpty($sttp\\begdat))
			  {
			  $sttp\\begdat.setValue(Platform.add(Platform.today(),-15));
			  }
			  if(Platform.isEmpty($sttp\\enddat))
			  {
			  $sttp\\enddat.setValue(Platform.today());
			  }
			  Platform.setModified($sttp\\begdat);
			  Platform.setModified($sttp\\enddat);
			
			  Platform.clear($sttp\\gidlst);
			  String sql = "select g1.inr as inr,g1.ownref as ownref,g1.lgtyp as lgtyp,g1.lgamt as lgamt,t.nam as nam,g1.bennamcn as bennamcn,g1.opndat as opndat,g1.ptyinr as ptyinr "+
			  "from gid g1,trn t,grn g2 "+
			  "where g1.inr=t.objinr "+
			  "and g2.objinr=t.inr "+
			  "and g2.objtyp='trn' "+
			  "and t.wfm='G' "+
			  "and (t.sta='R' or t.sta='A') "+
			  "and g2.gidsta='OF'";
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> ownref = new Argument<String>("ownref");
			  Argument<String> lgtyp = new Argument<String>("lgtyp");
			  Argument<BigDecimal> lgamt = new Argument<BigDecimal>("lgamt");
			  Argument<String> aplnamcn = new Argument<String>("nam");
			  Argument<String> bennamcn = new Argument<String>("bennamcn");
			  Argument<Date> opndat = new Argument<Date>("opndat");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Date querybdat = $sttp\\begdat.getValue();
			  Date queryedat = $sttp\\enddat.getValue();
			  String querytyp = $sttp\\lgtyp.getValue();
			  List objs = new ArrayList();  //查询参数
			
			  if(Platform.isEmpty($sttp\\begdat.getValue())||Platform.isEmpty($sttp\\enddat.getValue()))
			  {
			  Platform.message(#CT000004,#CT000005);
			  return false;
			  }
			  else
			  {
			  sql = sql + " and g1.opndat >= ? and g1.opndat <= ?";
			  objs.add(Platform.sqlDate($sttp\\begdat.getValue(),GT));
			  objs.add(Platform.sqlDate($sttp\\enddat.getValue(),LT));
			  }
			
			  if(!Platform.isEmpty($sttp\\lgtyp.getValue()))
			  {
			  sql = sql + " and g1.lgtyp = ?";
			  objs.add($sttp\\lgtyp.getValue());
			  }
			
			  if( objs.size()>0 )
			  {
			  Platform.dbExecuteSQL(sql,objs.toArray());
			  }
			  else
			  {
			  Platform.dbExecuteSQL(sql);
			  }
			  log.info("sql objs = " + objs.toArray());
			  while(true)
			  {
			  Platform.dbFetchFields(inr,ownref,lgtyp,lgamt,aplnamcn,bennamcn,opndat,ptyinr);
			  if(Platform.errorCode()==NO_ERROR)
			  {
			  $sttp\\gidlst.add(inr,ownref,lgtyp,lgamt,aplnamcn,bennamcn,opndat,ptyinr);
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  Platform.setModified($sttp\\gidlst);
			  */

			return true;
        }

        /**
        *   source:gitsnd.@0002.script
        */
        @Rule(target="sttp.inf",order=100)
        public boolean ruleSttpInfN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000000"),MdaUtils.getI18NString("gitsnd","CT000001"));
			  return true;
			}
			//trn.objinr=gid.inr
			//Platform.dbBegin();
			String gidinr = this.getSttp().getGidtmp().getElement(index).getInr();
			MdaUtils.clear(this.getTrn());
			ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("objinr",gidinr),new Argument<String>("wfm","G"));
			this.getSttp().setEsig(this.getSttp().getGidtmp().getElement(index).getEsig());
			//Platform.dbCloseCursor();
			log.info("{}","trninr================================"+this.getTrn().getInr());

			
			//通知交易隐藏打印和下载按钮
			this.hanDPbutton(this.getTrn().getInr());
			this.loadDataByInr(this.getTrn().getInr(),gidinr);
			
			//getBsplst(index);
			//showDetailPanel(index);
			

			return true;
        }

        /**
        *   source:gitsnd.@0005.script
        */
        @Rule(target="sttp.dztimgviw",order=100)
        public boolean ruleSttpDztimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}"," in imgviw....");
			//Platform.dbRead($trn,new Argument<String>("inr",$trninr.getValue()));
			String trninr = this.getTrn().getOriinr();
			this.getImgmod().imgScan(trninr);
			log.debug("{}"," out imgviw....");

			return true;
        }

        /**
        *   source:gitsnd.@0006.script
        */
        @Rule(target="sttp.stlimgviw",order=100)
        public boolean ruleSttpStlimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.dbRead($trn,new Argument<String>("inr",$trninr.getValue()));
			String imginr = this.getTrn().getImgref();
			log.debug("{}","imginr:"+imginr);
			this.getImgmod().stlImgScan(imginr);


			return true;
        }

        /**
        *   source:gitsnd.@0009.script
        */
        @Rule(target="sttp.back",order=100)
        public boolean ruleSttpBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:gitsnd.@0010.script
        */
        @Rule(target="sttp.selpdf",order=100)
        public boolean ruleSttpSelpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","pdf====selpdf========================================");
			ctx.getDaoSession().dbRead(this.getSttp().getGidsta(),new Argument("ownref",this.getTrnmod().getTrn().getOwnref()),new Argument("selpdftyp","2"));
			if(!MdaUtils.isEmpty(this.getSttp().getGidsta().getInr()))
			{
			  if(MdaUtils.prompt(MdaUtils.getI18NString("gitsnd","CT000022"),MdaUtils.getI18NString("gitsnd","CT000023")))
			  {
			    return false;
			  }
			}
			Object[] obj = (Object[])MdaUtils.getEventData();
			IStream stream = this.getSttp().getSelpdf();
			upLoad(stream,obj,"1");

			return true;
        }

        /**
        *   source:gitsnd.@0012.script
        */
        @Rule(target="sttp.noti",order=100)
        public boolean ruleSttpNotiN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.prompt(MdaUtils.getI18NString("gitsnd","CT000012"),MdaUtils.getI18NString("gitsnd","CT000013")))
			{
			  return false;
			}
			//交易编码
			String frm=this.getTrn().getInifrm();
			//关联流水号
			String msgref= this.getSttp().getGidgrp().getSzgit().getMsgref();
			log.info("{}","关联流水号" + msgref);
			String msgno="EBH112";
			String inr= this.getSttp().getGidgrp().getRec().getInr();
			Map sendMap = new HashMap();
			//平台参号
			sendMap.put("ptbusino",this.getSttp().getGidgrp().getSzgit().getPtbusino());
			//业务申请号码（银行业务编号）
			sendMap.put("bkbusino",this.getSttp().getGidgrp().getRec().getOwnref());
			//保函金额
			sendMap.put("currency",this.getSttp().getGidgrp().getRec().getLgamt());
			//申请人名称
			ctx.getDaoSession().dbRead(this.getSttp().getGidgrp().getApl().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","apl"));
			sendMap.put("agentcorpname",this.getSttp().getGidgrp().getApl().getPts().getNam());
			//受益人名称
			ctx.getDaoSession().dbRead(this.getSttp().getGidgrp().getBen().getPts(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","gid"),new Argument<String>("rol","ben"));
			sendMap.put("beneficiary",this.getSttp().getGidgrp().getBen().getPts().getNam());
			//保函有效期（到期日）
			sendMap.put("deadline",MdaUtils.format(this.getSttp().getGidgrp().getRec().getBhdqdat(),"yyyyMMdd"));
			log.info("{}","files message = " + sendMap);
			ctx.getDaoSession().dbBegin();

			ctx.absGet(Sysmod.class).setSzHeaderMap(msgno,"",sendMap,msgref);
			this.insertEbhmsg(msgno,this.getSttp().getGidgrp().getRec().getInr(),"gid",frm,sendMap);

			ctx.getDaoSession().dbRead(this.getGrn(),new Argument("objinr",this.getTrn().getInr()),new Argument("objtyp","trn"));
			this.getGrn().setGidsta("OG"); //OG保函收妥完成
			ctx.getDaoSession().dbUpdate(this.getGrn());

			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000014"),MdaUtils.getI18NString("gitsnd","CT000015"));
			  return false;
			}
			ctx.getDaoSession().dbCommit();

			ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000024"),MdaUtils.getI18NString("gitsnd","CT000025"));
			
			
			log.debug("{}","业务通知成功！");

			return true;
        }

        /**
        *   source:gitsnd.@0014.script
        */
        @Rule(target="sttp.kudpdf",order=100)
        public boolean ruleSttpKudpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","pdf===kudpdf=========================================");
			ctx.getDaoSession().dbRead(this.getSttp().getGidsta(),new Argument("ownref",this.getTrnmod().getTrn().getOwnref()),new Argument("selpdftyp","2"));
			if(!MdaUtils.isEmpty(this.getSttp().getGidsta().getInr()))
			{
			  if(MdaUtils.prompt(MdaUtils.getI18NString("gitsnd","CT000018"),MdaUtils.getI18NString("gitsnd","CT000019")))
			  {
			    return false;
			  }
			}
			Object[] obj = (Object[])MdaUtils.getEventData();
			IStream stream = this.getSttp().getKudpdf();
			upLoad(stream,obj,"2");

			return true;
        }

        /**
        *   source:gitsnd.@0017.script
        */
        @Rule(target="sttp.ddzbh",order=100)
        public boolean ruleSttpDdzbhN100(){
            IContext ctx = MdaEnv.getContext();
            

			String trninr = this.getTrn().getInr();
			if(!MdaUtils.isEmpty(trninr))
			{
			  MdaUtils.clear(this.getSttp().getGitpush());
			  ctx.getDaoSession().dbRead(this.getSttp().getGitpush(),new Argument<String>("objinr",this.getTrn().getObjinr()),new Argument<String>("objtyp","gid"),new Argument<String>("trans",this.getTrn().getInifrm()));
			  if(MdaUtils.isEmpty(this.getSttp().getGitpush().getInr()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000040"),MdaUtils.getI18NString("gitsnd","CT000041"));
			    return false;
			  }
			  MdaUtils.streamClear(this.getSttp().getDdzbh());
			  IStream stream=this.getSttp().getDdzbh();
			  String pdfFile = this.getSttp().getGitpush().getInr();
			  String pdffile = "";
			  String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  String fileName = pdfFile+time;
			  Argument<String> src = new Argument<String>("src");
			  String sql  = " SELECT src FROM grn WHERE objinr = "+trninr+" and objtyp = 'trn' ";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(src);
			  String cpno = "";
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    cpno = src.value;
			  }
			  ctx.getDaoSession().dbCloseCursor();

			  if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			  {
			    pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/bjztb/send/"+time+"/"+fileName+".pdf");
			  }
			  else
			  {
			    pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/szdzbh/pdf/"+pdfFile.substring(0,5)+"/"+pdfFile+".pdf");
			  }
			  log.info("{}","pdffile===="+pdffile);
			  MdaUtils.streamLoad(stream,pdffile);
			  stream.setType("pdf");
			  String pdfnam = org.apache.commons.io.FilenameUtils.getName(pdffile);
			  stream.setName(pdfnam);
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000062"),MdaUtils.getI18NString("gitsnd","CT000063"));
			  return false;
			}

			return true;
        }

        /**
        *   source:gitsnd.@0018.script
        */
        @Rule(target="sttp.sdzbh",order=100)
        public boolean ruleSttpSdzbhN100(){
            IContext ctx = MdaEnv.getContext();
            
			String trninr = this.getTrn().getInr();

			MdaUtils.clear(this.getSttp().getGitpush());
			ctx.getDaoSession().dbRead(this.getSttp().getGitpush(),new Argument<String>("objinr",this.getTrn().getObjinr()),new Argument<String>("objtyp","gid"),new Argument<String>("trans",this.getTrn().getInifrm()));
			if(MdaUtils.isEmpty(this.getSttp().getGitpush().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000056"),MdaUtils.getI18NString("gitsnd","CT000057"));
			  return false;
			}
			else
			{
			  String sta = this.getSttp().getGitpush().getSta();
			  if(!MdaUtils.isEmpty(sta)&&(sta.equals("W")||sta.equals("R")))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000058"),MdaUtils.getI18NString("gitsnd","CT000059"));
			    return false;
			  }
			  // if(!sta.equals("E"))
			  //{
			  //Platform.message(#CT000066,#CT000067);
			  if(MdaUtils.prompt(MdaUtils.getI18NString("gitsnd","CT000068"),MdaUtils.getI18NString("gitsnd","CT000069")))
			    return false;
			  //}
			  ctx.getErrorCode();
			  ctx.getDaoSession().dbBegin();
			  this.getSttp().getGitpush().setSta("W");
			  this.getSttp().getGitpush().setMuser(MdaEnv.getLoginUser());
			  this.getSttp().getGitpush().setUserinr(ctx.absGet(Sysmod.class).getUsr().getInr());
			  this.getSttp().getGitpush().setUpddat(MdaUtils.today());
			  this.getSttp().getGitpush().setCnt(0);
			  ctx.getDaoSession().dbUpdate(this.getSttp().getGitpush());
			  ctx.getDaoSession().dbCommit();
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000072"),MdaUtils.getI18NString("gitsnd","CT000073"));
			  }
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000074"),MdaUtils.getI18NString("gitsnd","CT000075"));
			}

			return true;
        }



        /**
        *   source:gitsnd.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            //
			List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this.getSttp(),"ptynam",bchcod);

			if("1".equals(this.getSysmod().getPty().getLvl()))
			{
			  this.getSttp().setPtynam(this.getSysmod().getPty().getInr());
			}
			else
			{
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getSttp().setPtynam(bchcod.get(0).getValue());
			}

			if(MdaUtils.isEmpty(this.getSttp().getBegdat()))
			{
			  this.getSttp().setBegdat(MdaUtils.add(MdaUtils.today(),-15));
			}
			if(MdaUtils.isEmpty(this.getSttp().getEnddat()))
			{
			  this.getSttp().setEnddat(MdaUtils.today());
			}
			
			
			this.refresh();

			return true;
        }


        /**
        *   source:gitsnd.@0007.script
        */
        public void hanDPbutton(String trninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in hanDPbuttopn...");
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",trninr));
			String trnNam = this.getTrnmod().getTrn().getInifrm();
			log.debug("{}","trnNam:" + trnNam);
			String[] trnlist=this.getSysmod().getTrnSortlist("18");
			String list=this.getSysmod().toSqlString(trnlist);
			log.debug("{}","trnlist:" + list);
			if(list.indexOf(trnNam)>0)
			{
			  log.debug("{}","隐藏按钮！");
			  
			  
			}
			else
			{
			  log.debug("{}","显示按钮！");
			  
			  

			}
			
			
			//判断是否是中投保平台
			MdaUtils.clear(this.getGrn());
			ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objtyp","trn"),new Argument<String>("objinr",trninr));
			String cpno1 = this.getGrn().getSrc();
			log.debug("{}","收妥平台类型："+cpno1);
			if(!MdaUtils.isEmpty(cpno1) && "ZTB".equals(cpno1))
			{
			  //中投保隐藏 包含扫描件 和 快递扫描件
			  log.debug("{}","***不显示扫描件***");
			  
			  
			  
			  
			  
			  
			}
		}
        /**
        *   source:gitsnd.@0008.script
        */
        public void loadDataByInr(String trninr,String gidinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：根据选择的序号加载公共数据
			  */
			// 加载TRN
			MdaUtils.clear(this.getTrnmod().getTrn());
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",trninr));
			String ordinr = this.getTrnmod().getTrn().getOrdinr();
			String objtyp = this.getTrnmod().getTrn().getObjtyp();
			String objinr = this.getTrnmod().getTrn().getObjinr();
			log.info("{}","ordinr="+ordinr+",objtyp="+objtyp+",objinr="+objinr);
			// 加载ORD
			ctx.getDaoSession().dbRead(this.getTrnmod().getOrdmod().getOrd(),new Argument("inr",ordinr));
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载RMK
			this.getRmkmod().loadRemarkByOrd(ordinr);
			// 初始化PDF数据
			this.getBtnmod().initDocumentButton(ordinr);
			// 加载页面截图
			String inr0 = trninr;
			String inrStr = inr0.substring(0,4);
			String fileName = inr0+"."+"zul";
			fileName = "/data/"+"dsp"+"/"+inrStr+"/"+fileName;
			log.info("{}","filename路径为：" + fileName);

			//$sttp\\display.setValue("/dsp"+fileName);
			MdaUtils.clear(this.getSttp().getGidgrp().getRec());
			ctx.getDaoSession().dbRead(this.getSttp().getGidgrp().getRec(),new Argument("inr",gidinr));
			ctx.getDaoSession().dbRead(this.getSttp().getGidgrp().getSzgit(),new Argument("inr",this.getSttp().getGidgrp().getRec().getInr()));
			
		}
        /**
        *   source:gitsnd.@0011.script
        */
        public void upLoad(IStream stream,Object[] obj,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","进入方法");
			String pdfNam = obj[1].toString();
			int index = pdfNam.indexOf(".");
			log.info("{}","源文件名========"+pdfNam);
			String postfix = pdfNam.substring(index + 1);
			log.info("{}","后缀名========"+postfix);
			String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String alsnam = "";
			if("1".equals(typ))
			{
			  alsnam = this.getGidgrp().getRec().getOwnref() + "_TZ_" + pdfNam;
			}
			else
			{
			  alsnam = this.getGidgrp().getRec().getOwnref() + "_KD_" + pdfNam;
			}
			if(postfix.equals("pdf"))
			{
			  String filPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/szdzbh/bilsnd/" + time +"/" + alsnam);

			  if(MdaUtils.fileExists(filPath))
			    MdaUtils.fileDelete(filPath);
			  MdaUtils.streamSave(stream,filPath);
			  log.info("{}","filWhlNam========"+filPath);
			  ctx.getDaoSession().dbBegin();
			  ctx.getDaoSession().dbRead(this.getSttp().getGidsta(),new Argument("ownref",this.getTrnmod().getTrn().getOwnref()),new Argument("selpdftyp",typ));
			  if(MdaUtils.isEmpty(this.getSttp().getGidsta().getInr()))
			  {
			    this.getSttp().getGidsta().setPdfp(filPath);
			    this.getSttp().getGidsta().setInr(Platform.sdbCounter("gidsta"));
			    this.getSttp().getGidsta().setTrninr(this.getTrn().getInr());
			    this.getSttp().getGidsta().setGidinr(this.getGidgrp().getRec().getInr());
			    this.getSttp().getGidsta().setOwnref(this.getGidgrp().getRec().getOwnref());
			    this.getSttp().getGidsta().setGidsta("未通知");
			    this.getSttp().getGidsta().setSelpdftyp(typ);
			    this.getSttp().getGidsta().setPdfname(pdfNam);
			    this.getSttp().getGidsta().setFilenam(alsnam);
			    ctx.getDaoSession().dbInsert(this.getSttp().getGidsta());
			  }
			  else
			  {
			    this.getSttp().getGidsta().setPdfp(filPath);
			    this.getSttp().getGidsta().setPdfname(pdfNam);
			    this.getSttp().getGidsta().setFilenam(alsnam);
			    ctx.getDaoSession().dbUpdate(this.getSttp().getGidsta());
			  }

			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000006"),MdaUtils.getI18NString("gitsnd","CT000007"));
			  return;
			}
			ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000008"),MdaUtils.getI18NString("gitsnd","CT000009"));
		}
        /**
        *   source:gitsnd.@0013.script
        */
        public void insertEbhmsg(String msgcod,String srcinr,String objtyp,String frm,Map msgcontent)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//msgcod :SFSXXX
			//srcinr:原业务 inr
			//msgcontent:实际报文内容
			//EBH102
			String msgid = (String)msgcontent.get("msgid");
			msgid = msgcod+msgid;
			log.info("{}","msg filename :"+msgid);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"ebhmsg"),datstr);
			String inr = Platform.sdbCounter("ebhsnd");
			path = MdaUtils.catPath(path,msgid+".dat");
			log.info("{}","path="+path);
			msgcontent.put("filepath",path);
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(msgcontent);
			log.info("{}","ebhsnd :"+sendContent);

			//平台不支持List<Map>,转接口处理并生成dat文件
			String cls="com.brilliance.eibs.main.Client";
			Object rtnVal = MdaUtils.invoke(cls,"scall","szebh112","szebh112",new Object[]{msgcontent});    // 判断接口是否调用成功
			if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			{
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("gitsnd","CT000034"),MdaUtils.getI18NString("gitsnd","CT000035"));
			  return ;
			}

			//回执文件记录
			MdaUtils.clear(this.getSttp().getEbhsnd());
			this.getSttp().getEbhsnd().setInr(inr);
			//$ebhsnd\\cnt.setValue();
			this.getSttp().getEbhsnd().setCredat(MdaUtils.today());
			//$ebhsnd\\mandate.setValue();
			this.getSttp().getEbhsnd().setMsgcod(msgcod);
			this.getSttp().getEbhsnd().setObjinr(srcinr);
			this.getSttp().getEbhsnd().setObjtyp(objtyp);
			this.getSttp().getEbhsnd().setMsgpath(path);
			//$ebhsnd\\senddate.setValue();
			this.getSttp().getEbhsnd().setSta("W");
			this.getSttp().getEbhsnd().setTrans(frm);
			//$ebhsnd\\muser.setValue();
			ctx.getDaoSession().dbInsert(this.getSttp().getEbhsnd());
			log.debug("{}","ebhsnd inr is"+this.getSttp().getEbhsnd().getInr() + "  errorcode = " + ctx.getErrorCode());
			ctx.getDaoSession().dbReadset(this.getSttp().getGidstalst(),new Argument("ownref",this.getSttp().getGidgrp().getRec().getOwnref()));

			//附件文件
			Map senddMap = new HashMap();
			int n = 0;
			String gidtxt = "";
			String pdfname= "";
			String filenam= "";
			String pdfdatpath = "";
			for (int i = 0; i < this.getSttp().getGidstalst().size(); i++)
			{
			  n= i+ 1;
			  gidtxt = (String)MdaUtils.invoke("com.brilliance.utils.WordCompareUtil","createFileBase64Byte",this.getSttp().getGidstalst().getElement(i).getPdfp());
			  senddMap = new HashMap();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setSzHeaderMap("EBH202","",senddMap,this.getSttp().getGidgrp().getSzgit().getMsgref());
			  pdfname = this.getSttp().getGidstalst().getElement(i).getPdfname();
			  filenam = this.getSttp().getGidstalst().getElement(i).getFilenam();
			  pdfdatpath = this.chgsnddat(msgid,n,pdfname,filenam,gidtxt,senddMap);

			  MdaUtils.clear(this.getSttp().getEbhsnd());
			  this.getSttp().getEbhsnd().setInr(Platform.sdbCounter("ebhsnd"));
			  //$ebhsnd\\cnt.setValue();
			  this.getSttp().getEbhsnd().setCredat(MdaUtils.today());
			  //$ebhsnd\\mandate.setValue();
			  this.getSttp().getEbhsnd().setMsgcod("EBH202");
			  this.getSttp().getEbhsnd().setObjinr(srcinr);
			  this.getSttp().getEbhsnd().setObjtyp(objtyp);
			  this.getSttp().getEbhsnd().setMsgpath(pdfdatpath);
			  //$ebhsnd\\senddate.setValue();
			  this.getSttp().getEbhsnd().setSta("W");
			  this.getSttp().getEbhsnd().setTrans(frm);
			  //$ebhsnd\\muser.setValue();
			  ctx.getDaoSession().dbInsert(this.getSttp().getEbhsnd());
			  log.debug("{}","ebhsnd inr is"+this.getSttp().getEbhsnd().getInr());
			}
		}
        /**
        *   source:gitsnd.@0015.script
        */
        public String chgsnddat(String busiid,int n,String pdfname,String filenam,String gidtxt,Map senddMap )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			senddMap.put("busiid",busiid);
			senddMap.put("busino","EBH112");
			senddMap.put("totalrec","2");
			senddMap.put("nowrec",n);
			senddMap.put("filename",filenam);
			senddMap.put("busifilename",pdfname);
			senddMap.put("filetype","PDF");
			senddMap.put("filebusitype","15");
			senddMap.put("file",gidtxt);

			String msgid = (String)senddMap.get("msgid");
			msgid = "EBH202"+msgid;
			log.info("{}","msg filename :"+msgid);
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(senddMap);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"ebhmsg"),datstr);
			String inr = Platform.sdbCounter("ebhsnd");
			path = MdaUtils.catPath(path,msgid+".dat");
			java.io.File file = new java.io.File(path);
			if (!file.getParentFile().exists())
			{
			  file.getParentFile().mkdirs();
			}
			if (!file.exists())
			{
			  try
			  {
			    file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			    log.error("{}","*****  文件创建失败！");
			    log.error("{}",e.toString());
			  }
			}
			MdaUtils.saveContent(sendContent,path,"utf-8");

			return path;
		}
        /**
        *   source:gitsnd.@0016.script
        */
        public void refresh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getSttp().getGidtmp());
			String lvl=this.getSysmod().getPty().getLvl();
			String ptyinr=this.getSysmod().getPty().getInr();
			String cid=this.getSysmod().getPty().getCid();
			String usrinr=this.getSysmod().getUsr().getInr();
			//Platform.dbBegin();
			/*String sql = "select g1.inr as inr,g1.ownref as ownref,g1.lgtyp as lgtyp,g1.lgamt as lgamt,t.nam as nam,g1.bennamcn as bennamcn,g1.opndat as opndat,g1.ptyinr as ptyinr "+
			  "from gid g1,trn t,grn g2 "+
			  "where g1.inr=t.objinr "+
			  "and g2.objinr=t.inr "+
			  "and g2.objtyp='trn' "+
			  "and t.wfm='G' "+
			  "and (t.sta='R' or t.sta='A') "+
			  "and g2.gidsta='OF'";
			  */
			String sql = "select g1.inr      as inr,"+
			  "  g1.ownref   as ownref,"+
			  "  g1.lgtyp    as lgtyp,"+
			  "  g1.lgamt    as lgamt,"+
			  "  g1.stlref    as stlref,"+
			  "  t.nam       as aplnamcn,"+
			  "  g1.bennamcn as bennamcn,"+
			  "  g1.opndat   as opndat,"+
			  "  g1.ptyinr   as ptyinr1,"+
			  "  sz.esig       as esig,"+
			  "  g2.gidsta       as gidsta,"+
			  //"  p.inr       as gitpushinr,"+
			  //"  p.sta       as dsta,"+
			  //"  e.inr       as ebhsndinr,"+
			  //"  e.sta       as sndsta,"+
			  "  t.inifrm    as inifrm "+
			  " from gid g1, szgit sz,trn t, grn g2"+
			  //" left join gitpush p on p.objinr=t.objinr and p.objtyp=t.objtyp and p.trans=t.inifrm"+
			  //" left join ebhsnd e on e.objinr=t.objinr and e.objtyp=t.objtyp and e.trans=t.inirm and e.msgcod ='EBH113'"+
			  " where g1.inr=sz.inr and g1.inr = t.objinr"+
			  "  and t.objtyp='gid'"+
			  "  and g2.objinr = t.inr"+
			  "  and g2.objtyp = 'trn'"+
			  "  and t.wfm = 'G'"+
			  "  and (t.sta = 'R' or t.sta = 'A')"+
			  "  and g2.gidsta in ('OF','OS','OG','OZ')";
			//Argument<String> trninr = new Argument<String>("trninr");
			List objs = new ArrayList();
			if(!MdaUtils.isEmpty(this.getSttp().getBegdat()))
			{
			  sql +=" AND t.inidattim >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getSttp().getBegdat(),GT));
			}
			if(!MdaUtils.isEmpty(this.getSttp().getEnddat()))
			{
			  sql +=" AND t.inidattim <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getSttp().getEnddat(),LT));
			}
			if(!MdaUtils.isEmpty(this.getSttp().getLgtyp()))
			{
			  sql +="  AND g1.lgtyp = ? ";
			  objs.add(this.getSttp().getLgtyp());
			}
			//机构隔离
			if(!MdaUtils.isEmpty(this.getSttp().getPtynam()))   //获取机构主键和机构等级
			{
			  ptyinr=this.getSttp().getPtynam();
			  lvl=this.getSysmod().getBchmod().getBranchLvlByInr(ptyinr);
			  cid=this.getSysmod().getCidByInr(ptyinr);
			  if("1".equals(this.getSysmod().getPty().getLvl()))
			  {
			    ptyinr=this.getSysmod().getPty().getInr();
			    lvl=this.getSysmod().getPty().getLvl();
			    cid=this.getSysmod().getPty().getCid();
			  }
			  log.debug("{}","ptyinr is:"+ptyinr);
			}
			if("0".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr)";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr and (p.inr='"+ptyinr+"' or pntinr='"+cid+"'))";
			}
			else
			{
			  sql=sql+" AND optptyinr='"+ptyinr+"'";
			}
			sql +="  order by t.inr desc";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> lgtyp = new Argument<String>("lgtyp");
			Argument<BigDecimal> lgamt = new Argument<BigDecimal>("lgamt");
			Argument<String> aplnamcn = new Argument<String>("aplnamcn");
			Argument<String> bennamcn = new Argument<String>("bennamcn");
			Argument<Date> opndat = new Argument<Date>("opndat");
			Argument<String> ptyinr1 = new Argument<String>("ptyinr1");
			Argument<String> gitpushinr = new Argument<String>("gitpushinr");
			Argument<String> dsta = new Argument<String>("dsta");
			Argument<String> ebhsndinr = new Argument<String>("ebhsndinr");
			Argument<String> sndsta = new Argument<String>("sndsta");
			Argument<String> inifrm = new Argument<String>("inifrm");
			Argument<String> esig = new Argument<String>("esig");
			Argument<String> gidsta = new Argument<String>("gidsta");
			Argument<String> stlref = new Argument<String>("stlref");

			ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());
			while(true)
			{
			  //Platform.dbFetchFields(inr,ownref,lgtyp,lgamt,aplnamcn,bennamcn,opndat,ptyinr,gitpushinr,dsta,ebhsndinr,sndsta,inifrm);
			  ctx.getDaoSession().dbFetchFields(inr,ownref,lgtyp,lgamt,aplnamcn,bennamcn,opndat,ptyinr1,esig,gidsta,inifrm,stlref);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getSttp().getGidtmp().add(inr,ownref,lgtyp,lgamt,aplnamcn,bennamcn,opndat,ptyinr1,esig,gidsta,inifrm,stlref);
			  }
			  else
			  {
			    break;
			  }
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}











}