package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GittrsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Busmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函转开/转递申请
*/
@Transaction(vo= GittrsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gittrs extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gittrs.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Busmod busmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gittrs()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gittrs.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gittrs.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gittrs.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gittrs.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gittrs.this.getGidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:gittrs.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","sav200开始================" );
			if(!ctx.checkAll(this.getGidgrp()))
			  return false;
			this.getGidgrp().getRec().setDbchcod(this.getGidgrp().getRec().getBchcod());
			ctx.getDaoSession().dbUpdate(this.getGidgrp().getRec());
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:gittrs.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String typ="";
			  log.debug("message"+$gidgrp\\rec\\opntyp);
			  log.debug("opntyp="+$gidgrp\\rec\\opntyp.getValue());
			  if("1".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  typ=Platform.getCodetableLabel("furtyp",$gidgrp\\rec\\furtyp.getValue());
			  }
			  else
			  {
			  if(!Platform.isEmpty($gidgrp\\adv\\pts\\nam))
			  typ="由贵行委托"+$gidgrp\\adv\\pts\\nam.getValue()+"银行（SWIFT NO."+$gidgrp\\adv\\pts\\extkey.getValue()+"英文全称"+$gidgrp\\adv\\pts\\adrblk+")通知受益人。";
			  }
			  $gidgrp\\typ.setValue(typ);
			  */
			IStream stream=this.getMtabut().getApldoc();
			log.info("{}","  gittrs pdf" );
			ctx.absGet(Sysmod.class).generatorPdf("","gittrs",stream,false );

			return true;
        }

        /**
        *   source:gittrs.@0003.script
        */
        @Rule(target="mtabut.xptslt",order=100)
        public boolean ruleMtabutXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getXptqna());
			this.getMtabut().getXptqna().setRef(this.getGidgrp().getRec().getOwnref());
			log.debug("{}","ref="+this.getMtabut().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getMtabut().getXptqna());
			

			return true;
        }



        /**
        *   source:gittrs.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(this.getSysmod().sptIsLoaded("B")  ||  this.getSysmod().sptIsLoaded("P"))
			  return true;
			else
			{
			  Argument<String> objinr=new Argument<String>("objinr",this.getGidgrp().getRec().getInr());
			  Argument<String> objtyp=new Argument<String>("objtyp","gid");
			  Argument<String> rol=new Argument<String>("rol","apl");
			  // Platform.disable($gidgrp\\rec\\bchcod);
			  
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),objtyp,objinr,rol);
			  ctx.getErrorCode();
			  
			  
			  
			  rol.setValue("ben");
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),objtyp,objinr,rol);
			  ctx.getErrorCode();
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  rol.setValue("adv");
			  ctx.getDaoSession().dbRead(this.getGidgrp().getAdv().getPts(),objtyp,objinr,rol);
			  ctx.getErrorCode();
			  
			  
			  
			  
			  
			  
			  
			  
			  //Platform.dbRead($gitp\\rgtclu\\cls,new Argument<String>("flg","3"),new Argument<String>("typ","gittrs"),new Argument<String>("status","0"));
			  //$gidgrp\\rec\\gittrstxt.setValue($gitp\\rgtclu\\cls\\clstxt.getValue());
			
			  ctx.getDaoSession().dbRead(this.getGitp().getRgtclu().getCls(),new Argument<String>("inr",this.getGitp().getRgtclu().readDefaultClsInr("gittrs")));
			  this.getGidgrp().getRec().setGittrstxt(this.getGitp().getRgtclu().getCls().getClstxt());
			  
			}
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getTrstyp()))
			  this.getGidgrp().getRec().setTrstyp("1");
			this.getGidgrp().getTrp().getPts().setNam(this.getSysmod().getPty().getNam());

			return true;
        }

        /**
        *   source:gittrs.@0005.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }











}