package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GittskVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.bo.Fzgit;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 电子保函task
*/
@Transaction(vo= GittskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gittsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gittsk.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Trn wrktrn;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private ModuleList<Trn> trnlst;

		@BDGetter
		private ModuleList<Spt> sptlst;

		@BDGetter
		private Smh smh;

		@BDGetter
		private ModuleList<Fzgit> fzgitlst;


		public Gittsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gittsk.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gittsk.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gittsk.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gittsk.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gittsk.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
        }




        /**
        *   source:gittsk.@0000.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  1.限制mgttsk只在一台服务器上运行，可在transaction.properties中配置服务ip
			  2.在配置文件中配置isServer判断是服务器上还是本地运行
			  3.本地测试暂时将此屏蔽掉,后面需要放开
			  */

			/**
			  //指定服务器处理后台服务
			  String proFilPth = Platform.catPath(Platform.getRootPath(),"/data/transaction.properties");
			  String isServer = Platform.getPropertyValue(proFilPth,"isServer");
			  log.debug("isServer=" + isServer);
			  if("1".equals(isServer))
			  {
			  String webserver = (String)java.lang.System.getProperty("weblogic.management.server");
			  log.info("weblogic.management.server："+webserver);
			  String workserver =Platform.getPropertyValue(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"transaction.properties"),"mgrtskworkserver");
			  if(Platform.isEmpty(workserver))
			  return;
			  if(!webserver.contains(workserver))
			  return;
			  }
			  */
			//判断是否在浮动IP的机器上执行
			Object obj = MdaUtils.invoke("com.cib.window.util.NetworkUtil","checkwork");
			if(!(boolean)obj)
			  return ;

			Thread current=Thread.currentThread();
			log.debug("{}","mgrtsk service 被执行...线程id:["+current.getId()+"]");
			this.handleMsg();
			this.receive();
			this.sendMSG();
			state.sleep();
			log.debug("{}","mgrtsk service 退出...线程id:["+current.getId()+"]");
		}
        /**
        *   source:gittsk.@0001.script
        */
        public void setBankWorkFlow(String argtyp,String arginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getWfmmod().getWfs().setObjtyp(argtyp);
			this.getTrnmod().getWfmmod().getWfs().setObjinr(arginr);
			this.getTrnmod().getWfmmod().getWfs().setWfstxt(this.getTrnmod().getTrnService("gitofz"));
			this.getTrnmod().getWfmmod().getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfs());
			String svrstr=this.getTrnmod().getWfmmod().getWfs().getWfstxt();
			log.info("{}","svrstr="+this.getTrnmod().getWfmmod().getWfs().getWfstxt());
			//for test svrstr="SPF";
			int len=svrstr.length();
			int i=0;
			while(i<len)
			{
			  String svr=svrstr.substring(i,i+1);
			  log.debug("{}","svr"+i+":"+svr );
			  //Platform.message("","in workflow :server is "+svr);
			  if("S".equals(svr))
			  {
			    String flg=this.getTrnmod().getTrn().getRelreq();
			    if(MdaUtils.isEmpty(flg))
			    {
			      log.warn("{}","relreq in trn is empty!");
			      flg=this.getTrnmod().getPtyaut().getFlg();
			    }
			    if("O".equals(flg))
			    {
			      //#CT000004
			      addWfe("S","W");
			      i++;
			    }
			    else
			    {
			      addWfe("S","O");
			      i++;
			    }
			  }
			  if("P".equals(svr))
			  {
			    addWfe("P","O");
			    i++;
			  }
			  if("E".equals(svr))
			  {
			    addWfe("E","O");
			    i++;
			  }
			  if("M".equals(svr))
			  {
			    addWfe("M","O");
			    i++;
			  }
			  if("T".equals(svr))
			  {
			    addWfe("T","W");
			    i++;
			  }
			  if("N".equals(svr))
			  {
			    addWfe("N","O");
			    i++;
			  }
			  if("F".equals(svr))
			  {
			    addWfe("F","O");
			    i++;
			  }
			  if("(".equals(svr)  ||  ")".equals(svr))
			  {
			    i++;
			  }
			}
			log.info("{}","OUT setworkflow ");
		}
        /**
        *   source:gittsk.@0002.script
        */
        public void trnSave()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 银行端的业务流水
			  */
			this.getTrnmod().getTrn().setOwnref(this.getWrktrn().getOwnref());
			this.getTrnmod().getTrn().setInifrm(this.getWrktrn().getInifrm());
			this.getTrnmod().getTrn().setOrdinr(this.getWrktrn().getOrdinr());
			this.getTrnmod().getTrn().setOriinr(this.getWrktrn().getInr());
			this.getTrnmod().getTrn().setObjnam(this.getWrktrn().getObjnam());
			this.getTrnmod().getTrn().setObjtyp(this.getWrktrn().getObjtyp());
			this.getTrnmod().getTrn().setObjinr(this.getWrktrn().getObjinr());
			this.getTrnmod().getTrn().setReloricur(this.getWrktrn().getReloricur());
			this.getTrnmod().getTrn().setReloriamt(this.getWrktrn().getReloriamt());
			this.getTrnmod().getTrn().setRelcur(this.getWrktrn().getRelcur());
			this.getTrnmod().getTrn().setRelamt(this.getWrktrn().getRelamt());
			this.getTrnmod().getTrn().setNam(this.getWrktrn().getNam());
			this.getTrnmod().getTrn().setIniusr( this.getSysmod().getUsr().getInr());
			this.getTrnmod().getTrn().setPtyinr( this.getWrktrn().getPtyinr());
			this.getTrnmod().getTrn().setEtyinr( this.getWrktrn().getEtyinr());
			this.getTrnmod().getTrn().setEtginr(this.getWrktrn().getEtginr());
			this.getTrnmod().getTrn().setCpldattim(MdaUtils.today());
			this.getTrnmod().getTrn().setBchcod(this.getWrktrn().getBchcod());
			this.getTrnmod().getTrn().setOptptyinr(this.getWrktrn().getOptptyinr());
			this.getTrnmod().getTrn().setOptetyinr(this.getWrktrn().getOptetyinr());
			this.getTrnmod().getTrn().setOptetginr(this.getWrktrn().getOptetginr());
			this.getTrnmod().getTrn().setInidattim(this.getWrktrn().getInidattim());
			this.getTrnmod().getTrn().setModtyp( this.getWrktrn().getModtyp());
			this.getTrnmod().getTrn().setPtytyp( "0");
			/* if(!Platform.isEmpty($wrktrn\\wfm))
			  {
			  $trnmod\\trn\\wfm =$wrktrn\\wfm;
			  }
			  */
			String inifrm=this.getWrktrn().getInifrm();
			log.info("{}","inifrm="+inifrm );
			this.getTrnmod().loadPtyaut(inifrm);
			String relreq=this.getTrnmod().getPtyaut().getFlg();
			log.info("{}","flag="+relreq);
			if(MdaUtils.isEmpty(relreq))
			{
			  relreq = "O";
			}
			this.getTrnmod().getTrn().setRelreq(relreq);
			this.getTrnmod().getTrn().setRelres(relreq.substring(0,1));
			int len=relreq.length();
			if(len==1)
			{
			  this.getTrnmod().getTrn().setNxtlev("");
			  this.getTrnmod().getTrn().setNxtreq("");
			  this.getTrnmod().getTrn().setSta("R");
			}
			if(len>=2)
			{
			  String nxtreq=relreq.substring(1,2);
			  if("B".equals(nxtreq))
			  {
			    this.getTrnmod().getTrn().setNxtlev("0");
			  }
			  else
			  {
			    this.getTrnmod().getTrn().setNxtlev("1");
			  }
			  this.getTrnmod().getTrn().setNxtreq(nxtreq);
			  this.getTrnmod().getTrn().setSta("W");
			}

			this.getTrnmod().getTrn().setInr(Platform.sdbCounter("trn"));

			ctx.getDaoSession().dbInsert(this.getTrnmod().getTrn());
			String target=null;
			String rootpath=ctx.getEnvConfig().getRootPath();
			String filename = this.getSysmod().createFilename(this.getWrktrn().getInr(),"zul");
			target = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}", "filename="+filename+",and target="+target);
			MdaUtils.fileCopy(filename,target);

			String sfile = ctx.absGet(Sysmod.class).createFilename(this.getWrktrn().getInr(),"dra");
			String tfile = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"dra");
			if(MdaUtils.fileExists(sfile))
			  MdaUtils.fileCopy(sfile,tfile);

			String sappfile = ctx.absGet(Sysmod.class).createFilename(this.getWrktrn().getInr(),"app");
			String tappfile = ctx.absGet(Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"app");
			if(MdaUtils.fileExists(sappfile))
			  MdaUtils.fileCopy(sappfile,tappfile);

		}
        /**
        *   source:gittsk.@0003.script
        */
        public void addWfe(String argsvr,String argsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getWfmmod().getWfe().setWfsinr(this.getTrnmod().getWfmmod().getWfs().getInr());
			this.getTrnmod().getWfmmod().getWfe().setSrv(argsvr);
			this.getTrnmod().getWfmmod().getWfe().setSta(argsta);
			this.getTrnmod().getWfmmod().getWfe().setDattim(new Date());
			this.getTrnmod().getWfmmod().getWfe().setManflg("0");
			//for test
			//$wfe\\tardattim.setValue($wfe\\dattim.getValue());
			this.getTrnmod().getWfmmod().getWfe().setTardattim(new Date());
			String trnname=ctx.getTransName();
			String tvalue=null;
			if("P".equals(argsvr))
			{
			  String argpty=this.getTrnmod().getPtysFromCid(this.getTrnmod().getBchcod());
			  //String trncode=trnname+$wft\\dir.getValue()+"2";
			  String clityp=this.getSysmod().getPty().getPtytyp();
			  String clilev=null;
			  if("1".equals(clityp)  ||  "2".equals(clityp))
			  {
			    clilev="1";
			  }
			  if("3".equals(clityp))
			  {
			    clilev="2";
			  }
			  String trncode=trnname+"0"+clilev;
			  log.info("{}","trncod="+trncode);
			  String filename="transaction.properties";
			  filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			  log.info("{}", "properties filename="+filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("gittsk","CT000005"));
			    return;
			  }
			  else
			  {
			    log.info("{}","trncode "+trncode);
			    tvalue=MdaUtils.getPropertyValue(filename,trncode);
			    log.info("{}","wfe.srvtxt="+tvalue);
			  }
			  this.getTrnmod().getWfmmod().getWfe().setSrvtxt(argpty);
			  this.getTrnmod().getWfmmod().getWfe().setTxt(tvalue);
			}
			if("T".equals(argsvr))
			{
			  if(!MdaUtils.isEmpty(this.getWrktrn().getInr()))
			  {
			    String filename=getNewFilenameForBack(this.getWrktrn().getInr());
			    if(!MdaUtils.isEmpty(filename))
			      this.getTrnmod().getWfmmod().getWfe().setSrvtxt(filename);
			    else
			      this.getTrnmod().getWfmmod().getWfe().setSrvtxt(this.getWrktrn().getInr());
			  }
			}
			String inr=Platform.sdbCounter("wfe");
			log.debug("{}","wfe inr is "+inr);
			this.getTrnmod().getWfmmod().getWfe().setInr(inr);
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfe());
			MdaUtils.clear(this.getTrnmod().getWfmmod().getWfe());
		}
        /**
        *   source:gittsk.@0004.script
        */
        public String getNewFilenameForBack(String wrktrninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *
			  *获取从银行端业务处理中退回后重新提交生成的新的报文文件
			  *
			  */
			String filename="";
			String sql = "SELECT srvtxt FROM wfe WHERE SRV='S' AND wfsinr=(SELECT max(inr)  FROM wfs WHERE objtyp='trn' AND objinr='"+wrktrninr+"' )";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> srvtxt = new Argument<String>("srvtxt");
			ctx.getDaoSession().dbFetchFields(srvtxt);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			if(errorCode == NO_ERROR && !MdaUtils.isEmpty(srvtxt.value))
			  filename=srvtxt.value.trim();
			log.debug("{}","SQL===["+sql+"]\r\nNew XML File is "+filename);
			return filename;
		}
        /**
        *   source:gittsk.@0005.script
        */
        public void convertValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int apprul = Integer.parseInt(this.getGidgrp().getRec().getApprul());
			switch(apprul)
			{
			  case 1:
			  this.getGidgrp().setFapprul("URDG");
			  break;
			  case 2:
			  this.getGidgrp().setFapprul("URCG");
			  break;
			  case 3:
			  this.getGidgrp().setFapprul("NONE");
			  break;
			  case 4:
			  this.getGidgrp().setFapprul("OTHR");
			  break;
			}
			log.info("{}","gidgrp --reapprulc ="  +  apprul + " "+this.getGidgrp().getFapprul());
			int lgtyp = Integer.parseInt(this.getGidgrp().getRec().getLgtyp());

			switch(lgtyp)
			{
			  case 1:
			  this.getGidgrp().setLgtyp("A");
			  break;
			  case 2:
			  this.getGidgrp().setLgtyp("B");
			  break;
			  case 3:
			  this.getGidgrp().setLgtyp("C");
			  break;
			  case 4:
			  this.getGidgrp().setLgtyp("J");
			  break;
			  case 5:
			  this.getGidgrp().setLgtyp("G");
			  break;
			  case 6:
			  this.getGidgrp().setLgtyp("W");
			  break;
			  case 7:
			  this.getGidgrp().setLgtyp("Z");
			  break;
			  case 8:
			  this.getGidgrp().setLgtyp("D");
			  break;
			  case 9:
			  this.getGidgrp().setLgtyp("F");
			  break;
			  case 10:
			  this.getGidgrp().setLgtyp("V");
			  break;
			}
			log.info("{}","gidgrp --rec -- lgtyp  -- value ="  +  lgtyp+"   "+ this.getGidgrp().getLgtyp()  );
			if("1".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGidgrp().setWbtyp("CN");
			}
			else if("2".equals(this.getGidgrp().getRec().getWbtyp()))
			{
			  this.getGidgrp().setWbtyp("EN");
			}
			log.info("{}","gidgrp --rec -- wbtyp  -- value ="  +  this.getGidgrp().getRec().getWbtyp()+"   "+ this.getGidgrp().getWbtyp()  );
			if(MdaUtils.isEmpty(this.getGitp().getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setDopntyp2("");
			  return;
			}
			if("1".equals(this.getGitp().getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setDopntyp2("OL");
			}
			else if("2".equals(this.getGitp().getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setDopntyp2("OT");
			}
			else if("3".equals(this.getGitp().getGidgrp().getRec().getOpntyp2()))
			{
			  this.getGidgrp().setDopntyp2("OC");
			}
			log.info("{}","gidgrp --rec -- opntyp2  -- value ="  +  this.getGidgrp().getRec().getOpntyp2()+"   "+ this.getGidgrp().getDopntyp2()  );
		}
        /**
        *   source:gittsk.@0006.script
        */
        public void sendMSG()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","**** gittsk sendMSG  ****");
			MdaUtils.clear(this.getFzgitlst());
			ctx.getDaoSession().dbReadset(this.getFzgitlst(),new Argument<String>("sta","T"));
			log.info("{}","**** gittsk sendMSG  **** size "+this.getFzgitlst().size());
			for(int i = 0;i<this.getFzgitlst().size();i++)
			{
			  String smhinr = this.getFzgitlst().getElement(i).getSmhinr();
			  log.info("{}","fzgit inr / smhinr :"+this.getFzgitlst().getElement(i).getInr()+" / "+this.getSmh().getInr());
			  MdaUtils.clear(this.getSmh());
			  ctx.getDaoSession().dbRead(this.getSmh(),new Argument<String>("inr",smhinr));
			  String docpth = this.getSmh().getDocpth();
			  String xmlfil = this.getSmh().getXmlfil();
			  if(MdaUtils.isEmpty(xmlfil))
			  {
			    log.error("{}","never shoud come in here !");
			    continue;
			  }
			  String[] pdfnams = xmlfil.split(",");
			  String pdfnam = pdfnams[0].replace("xml", "pdf");
			  log.info("{}","pdfnam :"+pdfnam);
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  MdaUtils.invoke("com.brilliance.doc.DocPacker","createXmlPdfFile",docpth,pdfnam,docpth,xmlfil,cfgpath,cfgpath,"qz.png");
			  log.info("{}","gen pdf name :"+docpth +" "+pdfnam +" cfgpath  "+cfgpath);
			  //生成通知报文
			  Map inmap = new HashMap();
			  //面函
			  inmap.put("docpth",docpth);
			  inmap.put("pdfnam",pdfnam);
			  String objinr = this.getFzgitlst().getElement(i).getInr();
			  String trninr = this.getFzgitlst().getElement(i).getTrninr();
			  MdaUtils.clear(this.getGidgrp().getRec());
			  MdaUtils.clear(this.getGidgrp().getApl().getPts());
			  MdaUtils.clear(this.getGidgrp().getBen().getPts());
			  MdaUtils.clear(this.getGidgrp().getFzgit());
			  ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument<String>("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",objinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",objinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getFzgit(),new Argument<String>("inr",objinr));
			  String a20=this.getGidgrp().getRec().getStlref();
			  Date a31C=this.getGidgrp().getRec().getCredat();//开立日
			  Date a31F=this.getGidgrp().getRec().getCredat();
			  Date a31H=this.getGidgrp().getRec().getLmudat();
			  int lgtyp = Integer.parseInt(this.getGidgrp().getRec().getLgtyp());
			  switch(lgtyp)
			  {
			    case 1:
			    this.getGidgrp().setLgtyp("A");
			    break;
			    case 2:
			    this.getGidgrp().setLgtyp("B");
			    break;
			    case 3:
			    this.getGidgrp().setLgtyp("C");
			    break;
			    case 4:
			    this.getGidgrp().setLgtyp("J");
			    break;
			    case 5:
			    this.getGidgrp().setLgtyp("G");
			    break;
			    case 6:
			    this.getGidgrp().setLgtyp("W");
			    break;
			    case 7:
			    this.getGidgrp().setLgtyp("Z");
			    break;
			    case 8:
			    this.getGidgrp().setLgtyp("D");
			    break;
			    case 9:
			    this.getGidgrp().setLgtyp("F");
			    break;
			    case 10:
			    this.getGidgrp().setLgtyp("V");
			    break;
			  }
			  String a32N=this.getGidgrp().getLgtyp();
			  String a32BCUR=this.getGidgrp().getRec().getLgcur();
			  BigDecimal bhamt = this.getGidgrp().getRec().getLgamt();
			  String a32BAMT=bhamt.toString();
			  String a50=this.getGidgrp().getApl().getPts().getAdrblk();
			  String a59=this.getGidgrp().getBen().getPts().getAdrblk();
			  String a57ABIC=this.getGidgrp().getAdv().getPts().getExtkey();
			  String a57AADR=this.getGidgrp().getAdv().getPts().getAdrblk();
			  String aM1= this.getGidgrp().getRec().getOwnref();
			  BigDecimal lgamt =  this.getFzgitlst().getElement(i).getLgfee();
			  String lgfee=lgamt.toString();
			  String applyno =  this.getFzgitlst().getElement(i).getApplyno();
			  // String orderno ="LGFZ"+Platform.format(Platform.today(),"yyyyMMddHHmmssSSS")+objinr;
			  inmap.put("a20",a20);
			  inmap.put("a31C",MdaUtils.format(a31C,"yyyy-MM-dd"));
			  inmap.put("a31F",MdaUtils.format(a31F,"yyyy-MM-dd"));
			  inmap.put("a31H",MdaUtils.format(a31H,"yyyy-MM-dd"));
			  inmap.put("a32N",a32N);
			  inmap.put("a32BCUR",a32BCUR);
			  inmap.put("a32BAMT",a32BAMT);
			  inmap.put("a50",a50);
			  inmap.put("a59",a59);
			  inmap.put("a57ABIC",a57ABIC);
			  inmap.put("a57AADR",a57AADR);
			  inmap.put("aM1",aM1);
			  inmap.put("lgfee",lgfee);
			  inmap.put("lgfeecur",this.getFzgitlst().getElement(i).getLgfeecur());
			  inmap.put("applyno",applyno);
			  inmap.put("orderno",aM1);
			  inmap.put("trninr",trninr);
			  try
			  {
			    Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","fzgitservice","fzgitservice",new Object[]{inmap});
			    // 判断接口是否调用成功
			    Boolean success = (Boolean) MdaUtils.invoke(obj,"isSuccess") ;
			    log.debug("{}","success=" + success);
			    if (!success )
			    {
			      String retCode = (String) MdaUtils.invoke(obj,"getReturnCode");
			      Object content = MdaUtils.invoke(obj,"getContent") ;
			      log.error("{}","ResultMsg.content = "  + content ) ;
			      log.debug("{}","调用接口平台调用失败。 { isSuccess = " +success ) ;
			      continue;
			    }
			    else
			    {
			      String content = MdaUtils.invoke(obj,"getContent").toString() ;
			      if("true".equals(content.substring(0,5).trim()))
			      {
			        log.debug("{}","调用接口平台成功。 { isSuccess = " +success ) ;
			        //启事务更新fzgit状态。
			        ctx.getErrorCode();
			        ctx.getDaoSession().dbBegin();
			        MdaUtils.clear(this.getGidgrp().getFzgit());
			        this.getGidgrp().getFzgit().copyValue(this.getFzgitlst().getElement(i));
			        this.getGidgrp().getFzgit().setSta("Z");//终结状态
			        ctx.getDaoSession().dbUpdate(this.getGidgrp().getFzgit());
			        ctx.getDaoSession().dbCommit();
			      }
			      else
			      {
			        log.error("{}","ResultMsg.content = "  + content ) ;
			        log.debug("{}","接口调用返回失败。 { 错误码： " +content.substring(5,10) +"，错误 原因：" + content.substring(10).trim() ) ;
			        continue;
			      }
			    }
			  }
			  catch(Exception e)
			  {
			    ctx.getErrorCode();
			    log.error("{}","errormsg:" + e.getMessage());
			    continue;
			  }
			}
		}
        /**
        *   source:gittsk.@0007.script
        */
        public void receive()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();

			MdaUtils.clear(this.getTrnlst());
			ctx.getDaoSession().dbReadset(this.getTrnlst(),new Argument<String>("sta","f"));
			log.info("{}","**** gittsk receive  **** size "+this.getTrnlst().size());
			for(int i=0;i<this.getTrnlst().fullSize();i++)
			{
			  MdaUtils.clear(this.getWrktrn());
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  MdaUtils.clear(this.getGidgrp().getRec());
			  MdaUtils.clear(this.getSysmod().getPty());
			  MdaUtils.clear(this.getGidgrp().getFzgit());
			  String objtyp = this.getTrnlst().getElement(i).getObjtyp();
			  String objinr = this.getTrnlst().getElement(i).getObjinr();
			  String ordinr = this.getTrnlst().getElement(i).getOrdinr();
			  String trninr = this.getTrnlst().getElement(i).getInr();

			  ctx.getDaoSession().dbRead(this.getWrktrn(),new Argument<String>("inr",trninr));
			  this.getTrnmod().getTrn().copyValue(this.getWrktrn());
			  ctx.getDaoSession().dbRead(this.getGidgrp().getRec(),new Argument<String>("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getSysmod().getPty(),new Argument<String>("inr",this.getGidgrp().getRec().getPtyinr()));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getFzgit(),new Argument<String>("inr",objinr));
			  //初始化参与者信息
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",objinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",objinr));
			  
			  
			  MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			  log.info("{}","gittsk i|trninr|objinr :"+i+"|"+trninr+"|"+objtyp+"|"+objinr );

			  //报文发送成功处理业务逻辑
			  ctx.getErrorCode();
			  ctx.getDaoSession().dbBegin();
			  //更新业务表
			  log.info("{}","sav200开始================" );
			  //提交210，保存要预览的pdf资源
			  /*StringBuffer labels = new StringBuffer();
			    StringBuffer tempfiles = new StringBuffer();
			    int cnt = 0;
			
			    labels = labels.append("保函开立申请");
			    tempfiles =  tempfiles.append("A:bhklsqs");
			    cnt++;
			
			    if("1".equals($gidgrp\\rec\\wbtyp.getValue()))
			    {
			    labels = labels.append(",保函开立申请报文草稿");
			    tempfiles =  tempfiles.append(",A:lgtxt");
			    cnt++;
			    }
			    else if("2".equals($gidgrp\\rec\\wbtyp.getValue()))
			    {
			    labels = labels.append(",保函开立申请报文草稿");
			    tempfiles =  tempfiles.append(",S:lgtxt");
			    cnt++;
			    }
			
			    String label = labels.toString();
			    String tempfile = tempfiles.toString();
			    $trnmod\\apldoc.setPDFInfo(cnt,label,tempfile);
			    $trnmod\\apldoc.generatorAllPDF();
			    if(!Platform.isEmpty($\\trnmod\\apldoc\\pdfdoc\\doccnt.getValue()))
			    {
			    $\\trnmod\\apldoc.setPDFFromContract();
			    }
			    log.info( "生成pdf结束================" );
			    String filename = $sysmod.createFilename($trnmod\\trn\\inr.getValue(),"zul");
			    log.info("filename is "+filename);
			    Platform.saveDisplay($gitp\\gitp08,filename);
			    log.info( "生成快照结束================" );
			    */
			  //生成业务报文
			  String trnname = "gitofz";
			  String msgname = ctx.absGet(Trnmod.class).getTcoMsgName("gitofz");
			  boolean success = ctx.absGet(Trnmod.class).getItfmod().packXmlFile(msgname,this.getWrktrn().getInr());
			  log.info("{}", "生成报文结束================" );
			  /*
			    log.info("开始保存申请文件");
			    String pdfConPath =Platform.catPath(Platform.getRootPath(),"/etrade/messageconfig/"+trnname);
			    //需要保存一下担保信息
			    Map<String,Object> data = new HashMap<String,Object>();
			    data=Platform.getValueMap($\\,trnname,"PDF");
			    //log.info("data0 size" +data.size());
			    if(Platform.isEmpty(data.get("OPRBCHCOD")))
			    data.put("OPRBCHCOD",$\\trnmod\\bchcod.getValue());
			    log.info("trn inr="+$\\trnmod\\trn\\inr);
			    String path=Platform.catPath(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"temp"),$\\trnmod\\trn\\inr.getValue().substring(0,4));
			    log.info("path="+path);
			    String cfgpath=Platform.catPath(Platform.getRootPath(),"cfg");
			    String clsNam = "com.brilliance.swift.SwiftPacker";
			    Platform.invoke(clsNam,"saveDataToFile",data,path,$\\trnmod\\trn\\inr.getValue()+".app");
			    Map<String,Object> dat=Platform.getValueMap($\\,msgname,"DATA");
			    Platform.invoke(clsNam,"packDataToFile",msgname,dat,cfgpath,path,$\\trnmod\\trn\\inr.getValue()+".dra");
			    log.info( "生成.app.dra结束================" );
			    */
			  //工作流
			  this.setBankWorkFlow("trn",this.getWrktrn().getInr());
			  log.info("{}", "生成工作流结束================" );
			  //转业务处理中
			  this.getWrktrn().setSta("R");
			  log.info("{}", "trn转业务处理中结束================" );
			  ctx.getDaoSession().dbUpdate(this.getWrktrn());
			  ctx.getDaoSession().dbCommit();
			  int  errCode = ctx.getErrorCode();
			  if(errCode!= NO_ERROR)
			  {
			    log.error("{}","数据库异常，请联系管理员");
			    continue;
			  }
			  log.info("{}","提交成功!");
			  //更新国结数据库状态。TODO
			}
		}
        /**
        *   source:gittsk.@0008.script
        */
        public void handleMsg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","**** gittsk handleMsg  **** ");
			Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","fzdzbh","fzdzbh",new Object[]{});
		}












}