package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.GxtdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Gitmod;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保函协议生效通知
*/
@Transaction(vo= GxtdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gxtdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Gxtdav.class);

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Gitmod gitmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Gxtdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getGitmod().setGidgrpHolder(()->this.getGidgrp());
           this.getMtabut().setRecHolder(()->this.getGidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LG"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.lgcur");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setLgcur(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getLgcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.lgamt");}
 				public void setValue(BigDecimal arg){Gxtdav.this.getGidgrp().getRec().setLgamt(arg);}
 				public BigDecimal getValue(){return Gxtdav.this.getGidgrp().getRec().getLgamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gxtdav.this.getFieldPath("gidgrp.rec.stlref");}
 				public void setValue(String arg){Gxtdav.this.getGidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Gxtdav.this.getGidgrp().getRec().getStlref();}}
			 );
        }



        /**
        *   source:gxtdav.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in getImgRef");
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			ctx.absGet(Mtabut.class).getImgtp().setTrninr(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getTrninr());
			this.getGitp().setDztimgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			
			
			log.debug("{}","trninr=" + ctx.absGet(Mtabut.class).getImgtp().getTrninr());
			log.debug("{}","end getImgRef,dztimgref:" + this.getGitp().getDztimgref());

			return true;
        }

        /**
        *   source:gxtdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck(this.getGitp().getGxtdavstep01());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			log.info("{}","bchcod:"+this.getGidgrp().getRec().getBchcod());
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getGidgrp().getRec().setBchcod(bchcod.get(0).getValue());


			return true;
        }










}