package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.IrfadvVO;

import com.ceb.gjjs.mda.manager.module.Aptmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Aptp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口代付业务成交证实书
*/
@Transaction(vo= IrfadvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Irfadv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Irfadv.class);

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Aptmod aptmod;

		@BDGetter
		private Aptp aptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Irfadv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getAptmod().setApdgrpHolder(()->this.getApdgrp());
           this.getAptp().setApdgrpHolder(()->this.getApdgrp());
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.payamt");}
 				public void setValue(BigDecimal arg){Irfadv.this.getApdgrp().getRec().setPayamt(arg);}
 				public BigDecimal getValue(){return Irfadv.this.getApdgrp().getRec().getPayamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.bchcod");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.paycur");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setPaycur(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getPaycur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.inr");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setInr(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.ownref");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.ptyinr");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Irfadv.this.getFieldPath("apdgrp.rec.stlref");}
 				public void setValue(String arg){Irfadv.this.getApdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Irfadv.this.getApdgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setRecHolder(()->this.getApdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:irfadv.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			
			

			return true;
        }



        /**
        *   source:irfadv.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			//
			
			this.getTrnmod().noticeAck(this.getAptp().getAptp03());

			return true;
        }

        /**
        *   source:irfadv.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			{
			  log.info("{}","ownref="+this.getSysmod().getSpt().getFrm());
			  ctx.getDaoSession().dbRead(this.getApdgrp().getRec(),new Argument<String>("ownref",this.getSysmod().getSpt().getOwnref()));
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			this.getMtabut().getImgtp().getImgRef();
			log.info("{}",this.getApdgrp().getRec().getPayexpdat());

			return true;
        }










}