package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期未交割结售汇账号修改申请
*/
@Transaction(vo= JstameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstame.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstame.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstame.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstame.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstame.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstame.this.getJsdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:jstame.@0004.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getJsdgrp()))
			{
			  log.warn("{}","申请页面校验未通过，退出");
			  return false;
			}

			this.getJsdgrp().getRec().setNewbuycno(this.getJsdgrp().getBuycnn());
			this.getJsdgrp().getRec().setNewselcno(this.getJsdgrp().getSelcnn());
			ctx.getDaoSession().dbUpdate(this.getJsdgrp().getRec());

			if(!this.getTrnmod().trnSetFromContract())return false;
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:jstame.@0005.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "不可撤销跟单信用证转让委托书";
			String tempfiles = "A:jstame";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }



        /**
        *   source:jstame.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getJsdgrp().getRec(),"bchcod",bchcod);

			this.getJsdgrp().getRec().setAmedat(MdaUtils.today());

			
			

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			}

			IModule jsd = (IModule)ctx.restoreData("com.brilliance.jstame.ref");
			if(!MdaUtils.isEmpty(jsd))
			  this.getJsdgrp().getRec().copyValue(jsd);

			//$jstp\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			ctx.getDaoSession().dbRead(this.getJsdgrp().getApl().getPts(),new Argument<String>("objinr",this.getJsdgrp().getRec().getInr()),new Argument<String>("objtyp","jsd"),new Argument<String>("rol","apl"));


			return true;
        }










}