package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Jstame0VO;

import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期未交割结售汇账号修改申请入口
*/
@Transaction(vo= Jstame0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstame0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstame0.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Jstame0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:jstame0.@0000.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("jsdgrp","jstame");

			return true;
        }

        /**
        *   source:jstame0.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			flush();

			return true;
        }

        /**
        *   source:jstame0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
              //人民币与外汇期权业务交易
			this.getSelp().sureBtn("jsdgrp","jstame");

			return true;
        }



        /**
        *   source:jstame0.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().setJsdtyp("2");
			
			

			List<CodetableItem> ct=new ArrayList<CodetableItem>();
			ct.add(new CodetableItem("远期结汇","6"));
			ct.add(new CodetableItem("远期售汇","7"));
			MdaUtils.setValues(this.getSelp(),"seltyp",ct);
			

			flush();

			return true;
        }


        /**
        *   source:jstame0.@0004.script
        */
        public void flush()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT rec.inr trsinr,rec.stlref ref,rec.cur cur,rec.amt amt,"
			  +"rec.opndat dat,substr(s.adrblk,0,35) aplnam FROM jsd rec,pts s "
			  +"WHERE s.rol = 'apl' AND s.objtyp = 'jsd' AND s.objinr = rec.inr "
			  + ctx.absGet(Sysmod.class).getSelection();

			sql=sql+" and rec.ywztls='"+this.getSelp().getJsdtyp()+"'";

			if(!MdaUtils.isEmpty(this.getSelp().getSeltyp()))
			{
			  sql=sql+" and rec.seltyp='"+this.getSelp().getSeltyp()+"'";
			}
			else
			{
			  sql=sql+" and rec.seltyp in (6,7)";
			}

			this.getSelp().queryBtn(sql);
		}





}