package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstamvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期未交割结售汇账号修改通知
*/
@Transaction(vo= JstamvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstamv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstamv.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstamv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstamv.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstamv.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstamv.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstamv.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstamv.this.getJsdgrp().getRec().getStlref();}}
			 );
        }












}