package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 大额结售汇签约申请通知
*/
@Transaction(vo= JstdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstdav.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstdav.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstdav.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstdav.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstdav.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstdav.this.getJsdgrp().getRec().getStlref();}}
			 );
        }



        /**
        *   source:jstdav.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			
			
			
			

			return true;
        }

        /**
        *   source:jstdav.@0001.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());

			
			
			

			return true;
        }

        /**
        *   source:jstdav.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			setPdfValue();

			String labels = "";
			String tempfiles="";

			String sel=this.getJsdgrp().getRec().getSeltyp().trim();
			log.debug("{}","sel zhi：" +sel);
			if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  labels = "人民币与外汇衍生产品业务交易证实书-掉期";
			  tempfiles = "A:jstdav3";
			}
			else if("4".equals(sel) || "5".equals(sel))
			{
			  labels = "T+1/T+2 即期结售汇业务交易证实书";
			  tempfiles = "A:jstdav1";
			}
			else if("6".equals(sel) || "7".equals(sel))
			{
			  labels = "人民币与外汇衍生产品业务交易证实书-远期";
			  tempfiles = "A:jstdav2";
			}
			else
			{
			  labels = "";
			  tempfiles = "";
			}

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo1();
			labels =  cntLabel.get("label") +labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			if(MdaUtils.isEmpty(labels)&&MdaUtils.isEmpty(tempfiles))
			{
			  labels = ",";
			  tempfiles = ",";
			}
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getJstp().getJstda());

			return true;
        }


        /**
        *   source:jstdav.@0003.script
        */
        public void setPdfValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("CNY".equals(this.getJsdgrp().getRec().getBuycur()))
			  this.getJsdgrp().setRmbamt(this.getJsdgrp().getRec().getBuyamt());
			else if("CNY".equals(this.getJsdgrp().getRec().getSelcur()))
			  this.getJsdgrp().setRmbamt(this.getJsdgrp().getRec().getSelamt());
			else
			  this.getJsdgrp().setRmbamt(new BigDecimal("0.00"));

			BigDecimal rmb=this.getJsdgrp().getRmbamt();
			rmb=MdaUtils.parseDecimal(MdaUtils.format(rmb,"#0.00"));
			this.getJsdgrp().setRmbamt(rmb);

			BigDecimal amt=this.getJsdgrp().getRec().getAmt();
			amt=MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);

			BigDecimal amt1=this.getJsdgrp().getRec().getBuyamt();
			amt1=MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getJsdgrp().getRec().setBuyamt(amt1);

			BigDecimal amt2=this.getJsdgrp().getRec().getSelamt();
			amt2=MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getJsdgrp().getRec().setSelamt(amt2);

			String bzjedu="";
			if(!MdaUtils.isEmpty(this.getJsdgrp().getEduamt()))
			{
			  bzjedu=MdaUtils.format(this.getJsdgrp().getEduamt(),"#0.00");
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getBzjmat()))
			    bzjedu=bzjedu+"  /  "+MdaUtils.format(this.getJsdgrp().getBzjmat(),"#0.00")+" %";
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getBzjmat()))
			    bzjedu=MdaUtils.format(this.getJsdgrp().getBzjmat(),"#0.00")+" %";
			}
			if(!MdaUtils.isEmpty(bzjedu))
			  this.getJsdgrp().setBzjedu(bzjedu);
			/* 拼接关联保证金账号/质押协议编号字段*/
			String bzjzyxy="";
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())||!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			{
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy=this.getJsdgrp().getRec().getRelbzjacc()+"/";
			  }
			  if(MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy="/"+this.getJsdgrp().getRec().getRelzyxybh();
			  }
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy=this.getJsdgrp().getRec().getRelbzjacc()+"/"+this.getJsdgrp().getRec().getRelzyxybh();
			  }
			  this.getJsdgrp().setBzjzyxy(bzjzyxy);
			}
			else
			{
			  this.getJsdgrp().setBzjzyxy(bzjzyxy);
			}
			/**/
			if(MdaUtils.isEmpty(this.getJsdgrp().getPtynam()))
			{
			  this.getJsdgrp().setPtynam(this.getTrnmod().getPtyName(this.getJsdgrp().getRec().getPtyinr()));
			}

			if(MdaUtils.isEmpty(this.getJsdgrp().getNam()))
			{
			  String inr=this.getTrnmod().getPtysFromCid(this.getJsdgrp().getRec().getBchcod());
			  this.getJsdgrp().setNam(this.getTrnmod().getPtyName(inr));
			}

			String nams="";
			String nas=getPtyNameFromIdc(this.getJsdgrp().getJzzcid());
			if(MdaUtils.isEmpty(nas))
			{
			  nams=this.getJsdgrp().getNam();
			}
			else
			{
			  nams=nas;
			}

			String sfl=this.getJsdgrp().getRec().getSfltyp().trim();
			if("1".equals(sfl))
			{
			  this.getJsdgrp().setWaynam(this.getJsdgrp().getPtynam());
			  this.getJsdgrp().setRmbnam(nams);
			  //$jsdgrp\\rmbamt.setValue($jsdgrp\\rec\\selamt.getValue());
			}
			else
			{
			  this.getJsdgrp().setWaynam(nams);
			  this.getJsdgrp().setRmbnam(this.getJsdgrp().getPtynam());
			  //$jsdgrp\\rmbamt.setValue($jsdgrp\\rec\\buyamt.getValue());
			}
			if("1".equals(this.getJsdgrp().getRec().getGivsty()) && ("4".equals(this.getJsdgrp().getRec().getSeltyp()) || "6".equals(this.getJsdgrp().getRec().getSeltyp())))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getSelcno());
			}
			else
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			    this.getJstp().setKctcno(this.getJsdgrp().getRec().getSelcno());
			  else
			    this.getJstp().setKctcno(this.getJsdgrp().getRec().getBuycno());
			}

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getYdhmat()))
			{
			  BigDecimal rmmamt=amt.multiply(this.getJsdgrp().getRec().getYdhmat());
			  rmmamt=MdaUtils.parseDecimal(MdaUtils.format(rmmamt,"#0.00"));
			  this.getJsdgrp().setRmmamt(rmmamt);
			}
		}
        /**
        *   source:jstdav.@0004.script
        */
        public String getPtyNameFromIdc(String idc)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(idc))
			{
			  return null;
			}
			String ptyName = "" ;

			String sql="SELECT nam FROM pty WHERE idc='"+idc+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> nam=new Argument<String>("nam");
			ctx.getDaoSession().dbFetchFields(nam);
			int errorcode=ctx.getErrorCode();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ptyName = nam.getValue();
			}
			ctx.getDaoSession().dbCloseCursor();
			return ptyName;
		}








}