package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 大额结售汇签约申请
*/
@Transaction(vo= JstopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstopn.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstopn.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstopn.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstopn.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstopn.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstopn.this.getJsdgrp().getRec().getAmt();}}
			 );
        }

        /**
        *   source:jstopn.@0002.script
        */
        @Rule(target="jsdgrp.rec.bzjsty",order=10)
        public boolean ruleJsdgrpRecBzjstyN10(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","jstopn  保证金业务处理开始，order:10");

			this.getJstp().getStpmod().storePanel(this.getJstp().getJstopn1(),this.getJstp().getJstopn2(),this.getJstp().getJstopn3());
			String steps = "0:条款确认;1:大额结售汇";

			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			{
			  
			  
			  
			  
			  
			  /*是否业务关联*/
			  this.getJsdgrp().getRec().setIsreltrn(FALSE);
			  this.getJsdgrp().getRec().setIschotrn(FALSE);
			  
			  
			  
			  this.getJsdgrp().getRec().setReltrnref(NULLSTR);
			  this.getJsdgrp().getRec().setReltrnnam(NULLSTR);
			  this.getJsdgrp().getRec().setRelbzjacc(NULLSTR);
			  this.getJsdgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getJsdgrp().getRec().setRzxbhno(NULLSTR);
			  this.getJsdgrp().getRec().setDbhtno(NULLSTR);
			  
			  
			  
			  
			  
			  
			  if(!TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			  {
			    steps =steps+";2:保证金质押协议";
			    
			    
			    
			  }
			  else
			  {
			    
			    
			    
			  }
			}
			else
			{
			  
			  
			  this.getJsdgrp().getRec().setBzjcno(NULLSTR);
			  this.getJsdgrp().getRec().setBzjrat(new BigDecimal(0));
			  
			  

			  this.getJsdgrp().getRec().setBzjslt(NULLSTR);
			  this.getJsdgrp().getRec().setBzjref(NULLSTR);
			  
			  

			  
			}
			
			
			
			
			
			/* 修改*/
			
			
			
			
			
			
			
			
			ctx.postRule(this,"jstp.zxjmod.zxj.jshsty");
			ctx.postRule(this,"jstp.zxjmod.zxj.zyjsty");

			this.getJstp().getStpmod().setPages(steps);
			this.getJstp().getStpmod().calcSteps();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:jstopn.@0003.script
        */
        @Rule(target="jstp.pdfviw.agree",order=100)
        public boolean ruleJstpPdfviwAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			{
			  ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstopn","CT000001"));
			  return true;
			}
			
			this.getJstp().getStpmod().nextStep();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:jstopn.@0004.script
        */
        @Rule(target="jstp.pdfviw.cancel",order=100)
        public boolean ruleJstpPdfviwCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:jstopn.@0005.script
        */
        @Rule(target="jsdgrp.rec.seltyp",order=100)
        public boolean ruleJsdgrpRecSeltypN100(){
            IContext ctx = MdaEnv.getContext();
            

			String sel=this.getJsdgrp().getRec().getSeltyp();
			if("6".equals(sel)||"4".equals(sel))
			{
			  MdaUtils.setValues(this.getJsdgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp1"));
			}
			else
			{
			  MdaUtils.setValues(this.getJsdgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp"));
			}
			if("4".equals(sel)||"5".equals(sel))
			{
			  this.getJstp().setTranspanel(this.getJstp().getJstp02());
			  this.getJsdgrp().getRec().setZxycno(NULLSTR);
			  
			  
			  
			  

			}
			if("3".equals(sel)||"6".equals(sel)||"7".equals(sel))
			{
			  this.getJstp().setTranspanel(this.getJstp().getJstp01());

			}

			
			//买卖方向
			if("3".equals(sel))
			{
			  //Platform.clear($jsdgrp\\rec\\sfltyp);
			  
			}
			else
			{
			  
			  if("4".equals(sel) || "6".equals(sel))
			    this.getJsdgrp().getRec().setSfltyp("0");
			  else if("5".equals(sel) || "7".equals(sel))
			    this.getJsdgrp().getRec().setSfltyp("1");
			  else
			    this.getJsdgrp().getRec().setSfltyp(NULLSTR);
			}
			

			//是否择期
			if("6".equals(sel) || "7".equals(sel) || "3".equals(sel))
			{
			  
			}
			else
			{
			  this.getJsdgrp().getRec().setZqnsty("1");
			  
			}
			

			//即期T+n标志
			if("4".equals(sel) || "5".equals(sel))
			{
			  this.getJsdgrp().getRec().setGivdat(this.getJsdgrp().getRec().getCredat());
			  
			  
			  

			}
			else
			{
			  

			  
			  this.getJsdgrp().getRec().setJqnmak(NULLSTR);
			  
			}
			
			

			if("3".equals(sel))
			{
			  
			  this.getJstp().setYddat("输入项为远端交割日，近端交割日为交易当天!");
			}
			else
			{
			  this.getJstp().setYddat(NULLSTR);
			  
			}
			

			//交割方式
			if("6".equals(sel) || "7".equals(sel))
			{
			  
			  
			}
			else if("4".equals(sel) || "5".equals(sel) || "3".equals(sel))
			{
			  
			  this.getJsdgrp().getRec().setGivsty("1");
			  
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setGivsty(NULLSTR);
			  
			}
			

			ctx.postRule(this,"jsdgrp.rec.sfltyp");     //买入卖出金额
			ctx.postRule(this,"jsdgrp.rec.zqnsty");     //择期起始日期
			
			


			return true;
        }

        /**
        *   source:jstopn.@0007.script
        */
        @Rule(target="jsdgrp.rec.sfltyp",order=100)
        public boolean ruleJsdgrpRecSfltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sfl=this.getJsdgrp().getRec().getSfltyp();
			if("1".equals(sfl))  //买入
			{
			  //卖出信息
			  this.getJstp().setSelmax(NULLSTR);
			  this.getJsdgrp().getRec().setSelcur(NULLSTR);
			  this.getJsdgrp().getRec().setSelcur("CNY");
			  this.getJsdgrp().getRec().setSelamt(new BigDecimal(0));
			  //Platform.clear($jsdgrp\\rec\\selcno);
			  
			  
			  //Platform.setNotRequired($jsdgrp\\rec\\selcno);
			  
			  
			  //Platform.disable($jsdgrp\\rec\\selcno);
			  //Platform.disable($jstp\\jslcno);
			
			  //买入信息
			  
			  if("CNY".equals(this.getJsdgrp().getRec().getBuycur()))
			    this.getJsdgrp().getRec().setBuycur(NULLSTR);

			  
			  //Platform.enable($jsdgrp\\rec\\buycno);
			  
			  
			  //Platform.setRequired($jsdgrp\\rec\\buycno);
			  //Platform.enable($jstp\\jbycno);
			
			  ctx.postRule(this,"jsdgrp.rec.buycur");     //买入金额币种
			}
			else if("0".equals(sfl))   //卖出
			{
			  //买入信息
			  this.getJstp().setBuymax(NULLSTR);
			  this.getJsdgrp().getRec().setBuycur(NULLSTR);
			  this.getJsdgrp().getRec().setBuycur("CNY");
			  this.getJsdgrp().getRec().setBuyamt(new BigDecimal(0));
			  //Platform.clear($jsdgrp\\rec\\buycno);
			  
			  
			  //Platform.setNotRequired($jsdgrp\\rec\\buycno);
			  
			  
			  //Platform.disable($jsdgrp\\rec\\buycno);
			  //Platform.disable($jstp\\jbycno);
			
			  //卖出信息
			  
			  if("CNY".equals(this.getJsdgrp().getRec().getSelcur()))
			    this.getJsdgrp().getRec().setSelcur(NULLSTR);

			  
			  //Platform.enable($jsdgrp\\rec\\selcno);
			  
			  
			  //Platform.setRequired($jsdgrp\\rec\\selcno);
			  //Platform.enable($jstp\\jslcno);
			
			  ctx.postRule(this,"jsdgrp.rec.selcur");
			}
			else
			{
			  //买入信息
			  this.getJstp().setBuymax(NULLSTR);
			  this.getJsdgrp().getRec().setBuycur(NULLSTR);
			  this.getJsdgrp().getRec().setBuyamt(new BigDecimal(0));
			  //Platform.clear($jsdgrp\\rec\\buycno);
			  
			  
			  //Platform.setNotRequired($jsdgrp\\rec\\buycno);
			  
			  
			  //Platform.disable($jsdgrp\\rec\\buycno);
			  //Platform.disable($jstp\\jbycno);
			
			  //卖出信息
			  this.getJstp().setSelmax(NULLSTR);
			  this.getJsdgrp().getRec().setSelcur(NULLSTR);
			  this.getJsdgrp().getRec().setSelamt(new BigDecimal(0));
			  //Platform.clear($jsdgrp\\rec\\selcno);
			  
			  
			  //Platform.setNotRequired($jsdgrp\\rec\\selcno);
			  
			  
			  //Platform.disable($jsdgrp\\rec\\selcno);
			  //Platform.disable($jstp\\jslcno);
			}
			
			

			
			
			//Platform.setModified($jsdgrp\\rec\\selcno);
			
			
			//Platform.setModified($jsdgrp\\rec\\buycno);
			
			//掉期
			if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  
			  
			  //Platform.enable($jsdgrp\\rec\\yjisxt);
			  if("1".equals(sfl))
			  {
			    this.getJsdgrp().getRec().setYbssty("X");
			    this.getJsdgrp().getRec().setYdbsty(NULLSTR);
			  }
			  else if("0".equals(sfl))
			  {
			    this.getJsdgrp().getRec().setYdbsty("X");
			    this.getJsdgrp().getRec().setYbssty(NULLSTR);
			  }
			  else
			  {
			    this.getJsdgrp().getRec().setYdbsty(NULLSTR);
			    this.getJsdgrp().getRec().setYbssty(NULLSTR);
			  }
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setYdhsty(NULLSTR);
			  
			  this.getJsdgrp().getRec().setYjisxt(NULLSTR);
			  
			  this.getJsdgrp().getRec().setYdbsty(NULLSTR);
			  this.getJsdgrp().getRec().setYbssty(NULLSTR);
			}
			
			
			
			

			ctx.postRule(this,"jsdgrp.rec.ydhsty");     //远端委托汇率
			ctx.postRule(this,"jsdgrp.rec.yjisxt");     //近端，远端账号是否一致
			

			return true;
        }

        /**
        *   source:jstopn.@0009.script
        */
        @Rule(target="jsdgrp.rec.givdat",order=100)
        public boolean ruleJsdgrpRecGivdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date giv=this.getJsdgrp().getRec().getGivdat();
			Date cre=this.getJsdgrp().getRec().getCredat();
			if(!MdaUtils.isEmpty(giv) && !MdaUtils.isEmpty(cre))
			{
			  ctx.setFieldError(this,"jsdgrp.rec.givdat",MdaUtils.getI18NString("jstopn","CT000038"));
			}

			return true;
        }

        /**
        *   source:jstopn.@0013.script
        */
        @Rule(target="jsdgrp.rec.zqnsty",order=100)
        public boolean ruleJsdgrpRecZqnstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getJsdgrp().getRec().getZqnsty()))
			{
			  
			  
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setZqndat(null);
			  
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0014.script
        */
        @Rule(target="jsdgrp.rec.matsty",order=100)
        public boolean ruleJsdgrpRecMatstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getJsdgrp().getRec().getMatsty()))
			{
			  
			  
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setDeprat(new BigDecimal(0));
			  
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0015.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");

			if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			{
			  ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstopn","CT000152"));
			  log.warn("{}","请确认接受上述所有条款，退出");
			  return false;
			}

			if(!ctx.checkAll(this.getJsdgrp().getRec()))
			{
			  log.warn("{}","申请页面校验未通过，退出");
			  return false;
			}
			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()) && !TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  if(!ctx.checkAll(this.getJstp().getZxjmod()))
			  {
			    log.warn("{}","保证金质押页面校验未通过，退出");
			    return false;
			  }
			}
			changeValue();

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  String objinr=this.getJsdgrp().getRec().getInr();
			  ctx.getDaoSession().dbUpdate(this.getJsdgrp().getRec());
			  this.getMtabut().UpdatePtsForBack(this.getJsdgrp().getApl().getPts(),objinr);
			}
			else
			{
			  this.getJsdgrp().getRec().setInr(Platform.sdbCounter("jsd"));
			  this.getJsdgrp().getRec().setPaytim("0");
			  this.getJsdgrp().getRec().setPaysta("0");
			  this.getJsdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(this.getJsdgrp().getRec());

			  this.getJsdgrp().getApl().savpts(this.getJsdgrp().getRec().getInr(),"jsd");   //存申请人信息
			}

			//保证金数据入库
			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()) && !TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  setBzjValue();

			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B") && !MdaUtils.isEmpty(this.getJstp().getZxjmod().getZxj().getInr()))
			    ctx.getDaoSession().dbUpdate(this.getJstp().getZxjmod().getZxj());
			  else
			  {
			    this.getJstp().getZxjmod().getZxj().setPtyinr(this.getSysmod().getPty().getInr());
			    this.getJstp().getZxjmod().getZxj().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			    this.getJstp().getZxjmod().getZxj().setZxjfrm(ctx.getTransName());
			    this.getJstp().getZxjmod().getZxj().setObjinr(this.getJsdgrp().getRec().getInr());
			    this.getJstp().getZxjmod().getZxj().setInr(Platform.sdbCounter("zxj"));
			    ctx.getDaoSession().dbInsert(this.getJstp().getZxjmod().getZxj());
			  }
			}

			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			IPanel[] panels=this.getJstp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			//Platform.saveDisplay($cptp\\cptp01,filename);
			log.info("{}", "sav200结束================" );


			return true;
        }

        /**
        *   source:jstopn.@0016.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "人民币与外汇衍生产品业务交易指令";
			String tempfiles = "";
			if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  tempfiles = "A:jstopn1";
			}
			else if("4".equals(this.getJsdgrp().getRec().getSeltyp())||"5".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  tempfiles = "A:jstopn2";
			}
			else
			{
			  tempfiles = "A:jstopn";
			}
			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()) && !TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  cnt += 1;
			  labels = labels+",人民币与外汇衍生产品保证金质押协议";
			  if("4".equals(this.getJsdgrp().getRec().getSeltyp())||"5".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    tempfiles =tempfiles+ ",A:zxjopn1";
			  }
			  else
			  {
			    tempfiles =tempfiles+ ",A:zxjopn";
			  }

			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:jstopn.@0017.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeValues();
			if("4".equals(this.getJsdgrp().getRec().getSeltyp())||"5".equals(this.getJsdgrp().getRec().getSeltyp()))
			  this.getJstp().getPdfviw().callPDFComponent("","jstopn2","人民币与外汇衍生产品业务交易指令",0);
			else if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJstp().getPdfviw().callPDFComponent("","jstopn1","人民币与外汇衍生产品业务交易指令",0);
			}
			else
			  this.getJstp().getPdfviw().callPDFComponent("","jstopn","人民币与外汇衍生产品业务交易指令",0);


			return true;
        }

        /**
        *   source:jstopn.@0018.script
        */
        @Rule(target="jsdgrp.rec.ydhsty",order=100)
        public boolean ruleJsdgrpRecYdhstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getJsdgrp().getRec().getYdhsty()))
			{
			  
			  
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setYdhmat(new BigDecimal(0));
			  
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0019.script
        */
        @Rule(target="jsdgrp.rec.yjisxt",order=100)
        public boolean ruleJsdgrpRecYjisxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			{
			  this.getJsdgrp().getRec().setYdbcur(this.getJsdgrp().getRec().getSelcur());
			  this.getJsdgrp().getRec().setYbrcur(this.getJsdgrp().getRec().getBuycur());
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getJsdgrp().getRec().setYdbcur(NULLSTR);
			  this.getJsdgrp().getRec().setYbrcur(NULLSTR);
			  
			  
			  this.getJsdgrp().getRec().setYbzcno(NULLSTR);
			  this.getJsdgrp().getRec().setYbrcno(NULLSTR);
			  
			  
			  
			  
			}
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:jstopn.@0020.script
        */
        @Rule(target="jstp.jbycno",order=100)
        public boolean ruleJstpJbycnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			

			String cur=this.getJsdgrp().getRec().getBuycur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstopn.@0021.script
        */
        @Rule(target="jstp.jslcno",order=100)
        public boolean ruleJstpJslcnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			

			String cur=this.getJsdgrp().getRec().getSelcur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstopn.@0022.script
        */
        @Rule(target="jstp.ybycno",order=100)
        public boolean ruleJstpYbycnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			

			String cur=this.getJsdgrp().getRec().getYdbcur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstopn.@0023.script
        */
        @Rule(target="jstp.rmbcno",order=100)
        public boolean ruleJstpRmbcnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			

			String cur=this.getJsdgrp().getRec().getYbrcur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstopn.@0024.script
        */
        @Rule(target="jsdgrp.rec.buycur",order=100)
        public boolean ruleJsdgrpRecBuycurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBuycur()) && !"CNY".equals(this.getJsdgrp().getRec().getBuycur()))
			{
			  //Platform.enable($jstp\\jbycno);
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCur()) && !this.getJsdgrp().getRec().getCur().equals(this.getJsdgrp().getRec().getBuycur()))
			    this.getJsdgrp().getRec().setBuycno(NULLSTR);
			  this.getJsdgrp().getRec().setCur(this.getJsdgrp().getRec().getBuycur());
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    
			  }
			}
			else
			{
			  //Platform.disable($jstp\\jbycno);
			  this.getJsdgrp().getRec().setCur(NULLSTR);
			  this.getJsdgrp().getRec().setYjisxt(NULLSTR);
			  
			}
			//Platform.setModified($jstp\\jbycno);
			
			

			ctx.postRule(this,"jsdgrp.rec.yjisxt");     //近端，远端账号是否一致
			
			return true;
        }

        /**
        *   source:jstopn.@0025.script
        */
        @Rule(target="jsdgrp.rec.selcur",order=100)
        public boolean ruleJsdgrpRecSelcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSelcur()) && !"CNY".equals(this.getJsdgrp().getRec().getSelcur()))
			{
			  //Platform.enable($jstp\\jslcno);
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCur()) && !this.getJsdgrp().getRec().getCur().equals(this.getJsdgrp().getRec().getSelcur()))
			    this.getJsdgrp().getRec().setSelcno(NULLSTR);
			  this.getJsdgrp().getRec().setCur(this.getJsdgrp().getRec().getSelcur());
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    
			  }
			}
			else
			{
			  //Platform.disable($jstp\\jslcno);
			  this.getJsdgrp().getRec().setCur(NULLSTR);

			  this.getJsdgrp().getRec().setYjisxt(NULLSTR);
			  
			}
			//Platform.setModified($jstp\\jslcno);
			
			

			ctx.postRule(this,"jsdgrp.rec.yjisxt");     //近端，远端账号是否一致
			
			return true;
        }

        /**
        *   source:jstopn.@0026.script
        */
        @Rule(target="jsdgrp.rec.buyamt",order=100)
        public boolean ruleJsdgrpRecBuyamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBuyamt()))
			  this.getJsdgrp().getRec().setAmt(this.getJsdgrp().getRec().getBuyamt());
			else
			  this.getJsdgrp().getRec().setAmt(new BigDecimal(0));
			

			return true;
        }

        /**
        *   source:jstopn.@0029.script
        */
        @Rule(target="jstp.stpmod.next",order=10)
        public boolean ruleJstpStpmodNextN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000071"),MdaUtils.getI18NString("jstopn","CT000072"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstopn","CT000073"));
			      return false;
			    }

			  }
			  case 1:
			  return ctx.checkAll(this.getJsdgrp().getRec());

			  case 2:
			  return ctx.checkAll(this.getJstp().getZxjmod());
			  /*
			    case 1:
			    {
			    if(!Platform.checkAll($jsdgrp\\rec))
			    {
			    return false;
			    }
			    }
			    case 2:
			    {
			    if(!Platform.checkAll($jstp\\zxjmod))
			    {
			    return false;
			    }
			    }
			    */
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstopn.@0030.script
        */
        @Rule(target="jstp.stpmod.last",order=10)
        public boolean ruleJstpStpmodLastN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000077"),MdaUtils.getI18NString("jstopn","CT000078"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstopn","CT000079"));
			      return false;
			    }

			  }
			  case 1:
			  return ctx.checkAll(this.getJsdgrp().getRec());

			  case 2:
			  return ctx.checkAll(this.getJstp().getZxjmod());
			  /*{
			    if(!Platform.checkAll($jsdgrp\\rec))
			    {
			    return false;
			    }
			    }
			    case 2:
			    {
			    if(!Platform.checkAll($jstp\\zxjmod))
			    {
			    return false;
			    }
			    }*/
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstopn.@0031.script
        */
        @Rule(target="jstp.stpmod.gostep",order=10)
        public boolean ruleJstpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000092"),MdaUtils.getI18NString("jstopn","CT000093"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstopn","CT000094"));
			      return false;
			    }
			  }
			  case 1:
			  return ctx.checkAll(this.getJsdgrp().getRec());

			  case 2:
			  return ctx.checkAll(this.getJstp().getZxjmod());
			  /*
			    case 1:
			    {
			    if(!Platform.checkAll($jsdgrp\\rec))
			    {
			    return false;
			    }
			    }
			    case 2:
			    {
			    if(!Platform.checkAll($jstp\\zxjmod))
			    {
			    return false;
			    }
			    }
			    */
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstopn.@0032.script
        */
        @Rule(target="jsdgrp.rec.bchcod",order=100)
        public boolean ruleJsdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBchcod()))
			{
			  ctx.getDaoSession().dbRead(this.getJsdgrp().getIsb().getPty(),new Argument<String>("cid",this.getJsdgrp().getRec().getBchcod()));
			  ctx.getDaoSession().dbRead(this.getJsdgrp().getIsb().getPta(),new Argument<String>("ptyinr",this.getJsdgrp().getIsb().getPty().getInr()));
			  ctx.getDaoSession().dbRead(this.getJsdgrp().getIsb().getAdr(),new Argument<String>("inr",this.getJsdgrp().getIsb().getPta().getObjinr()));
			}
			else
			{
			  MdaUtils.clear(this.getJsdgrp().getIsb().getPty());
			  MdaUtils.clear(this.getJsdgrp().getIsb().getPta());
			  MdaUtils.clear(this.getJsdgrp().getIsb().getAdr());
			}
			
			
			

			//Platform.postEventRule($jsdgrp\\rec\\bzjsty,onChange,null);     //加载质权人信息
			
			return true;
        }

        /**
        *   source:jstopn.@0034.script
        */
        @Rule(target="jstp.zxjmod.zxj.jshsty",order=100)
        public boolean ruleJstpZxjmodZxjJshstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getJstp().getZxjmod().getZxj().getJshsty()))
			{
			  if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh()) && !MdaUtils.isEmpty(this.getJsdgrp().getRec().getZshcno()))
			  {
			    
			    this.getJstp().getZxjmod().getZxj().setMrzcno(this.getJsdgrp().getRec().getZshcno());
			  }
			  else
			  {
			    
			    this.getJstp().getZxjmod().getZxj().setMrzcno(NULLSTR);
			  }
			}
			else
			{
			  
			  this.getJstp().getZxjmod().getZxj().setMrzcno(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0035.script
        */
        @Rule(target="jsdgrp.rec.sfyzsh",order=100)
        public boolean ruleJsdgrpRecSfyzshN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh()))
			{
			  
			  
			  this.getJsdgrp().getRec().setZshcno(this.getJstp().getAgrp().getCcl());
			  /*是否业务关联*/
			  this.getJsdgrp().getRec().setIsreltrn(FALSE);
			  this.getJsdgrp().getRec().setIschotrn(FALSE);
			  
			  
			  
			  this.getJsdgrp().getRec().setReltrnref(NULLSTR);
			  this.getJsdgrp().getRec().setReltrnnam(NULLSTR);
			  this.getJsdgrp().getRec().setRelbzjacc(NULLSTR);
			  this.getJsdgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getJsdgrp().getRec().setRzxbhno(NULLSTR);
			  this.getJsdgrp().getRec().setDbhtno(NULLSTR);
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  this.getJsdgrp().getRec().setZshcno(NULLSTR);
			  
			}
			
			/*修改*/
			
			
			
			
			
			
			
			
			ctx.postRule(this,"jstp.zxjmod.zxj.jshsty");

			return true;
        }

        /**
        *   source:jstopn.@0036.script
        */
        @Rule(target="jstp.actmod.actslt",order=100)
        public boolean ruleJstpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getJstp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000105"),MdaUtils.getI18NString("jstopn","CT000106"));
			  return false;
			}
			String sfl=this.getJsdgrp().getRec().getSfltyp();
			if("CNY".equals(this.getJstp().getActmod().getActlst().getElement(index).getCur()))
			{
			  if ("0".equals(sfl))
			  {
			    this.getJsdgrp().getRec().setBuycno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			    
			  }
			  else
			  {
			    this.getJsdgrp().getRec().setSelcno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			    
			  }
			}
			else
			{
			  if ("1".equals(sfl))
			  {
			    this.getJsdgrp().getRec().setBuycno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			    
			  }
			  else
			  {
			    this.getJsdgrp().getRec().setSelcno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			    
			  }
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0037.script
        */
        @Rule(target="jstp.actmod.yd",order=100)
        public boolean ruleJstpActmodYdN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getJstp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000137"),MdaUtils.getI18NString("jstopn","CT000138"));
			  return false;
			}

			this.getJsdgrp().getRec().setYbzcno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			

			

			return true;
        }

        /**
        *   source:jstopn.@0038.script
        */
        @Rule(target="jstp.actmod.rmb",order=100)
        public boolean ruleJstpActmodRmbN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getJstp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000131"),MdaUtils.getI18NString("jstopn","CT000132"));
			  return false;
			}

			this.getJsdgrp().getRec().setYbrcno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			

			

			return true;
        }

        /**
        *   source:jstopn.@0039.script
        */
        @Rule(target="jsdgrp.rec.selamt",order=100)
        public boolean ruleJsdgrpRecSelamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSelamt()))
			  this.getJsdgrp().getRec().setAmt(this.getJsdgrp().getRec().getSelamt());
			else
			  this.getJsdgrp().getRec().setAmt(new BigDecimal(0));
			

			return true;
        }

        /**
        *   source:jstopn.@0040.script
        */
        @Rule(target="jstp.zxjmod.zxjopp",order=100)
        public boolean ruleJstpZxjmodZxjoppN100(){
            IContext ctx = MdaEnv.getContext();
            
			setBzjValues();
			if("4".equals(this.getJsdgrp().getRec().getSeltyp())||"5".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJstp().getPdfviw().callPDFComponent("","zxjopn1","人民币与外汇衍生产品保证金质押协议",1);
			}
			else
			{
			  this.getJstp().getPdfviw().callPDFComponent("","zxjopn","人民币与外汇衍生产品保证金质押协议",1);
			}

			return true;
        }

        /**
        *   source:jstopn.@0041.script
        */
        @Rule(target="mtabut.busmod.select",order=200)
        public boolean ruleMtabutBusmodSelectN200(){
            IContext ctx = MdaEnv.getContext();
            

			this.getJsdgrp().getRec().setCredat(MdaUtils.today());
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCredat()))
			{
			  
			  
			}

			ctx.postRule(this,"jsdgrp.rec.seltyp");   //买卖品种
			ctx.postRule(this,"jsdgrp.rec.sfyzsh");   //买卖方向
			ctx.postRule(this,"jsdgrp.rec.bzjsty");  //保证金
			ctx.postRule(this,"jsdgrp.rec.matsty");  //汇率模式
			
			if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			{
			  ctx.postRule(this,"jsdgrp.rec.buycur");
			  ctx.postRule(this,"jsdgrp.rec.buyamt");
			}
			if("0".equals(this.getJsdgrp().getRec().getSfltyp()))
			{
			  ctx.postRule(this,"jsdgrp.rec.selcur");
			  ctx.postRule(this,"jsdgrp.rec.selamt");
			}

			if(!TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			{
			  ctx.postRule(this,"jsdgrp.rec.bchcod");
			}


			return true;
        }

        /**
        *   source:jstopn.@0047.script
        */
        @Rule(target="jsdgrp.rec.jqnmak",order=100)
        public boolean ruleJsdgrpRecJqnmakN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getJsdgrp().getRec().getJqnmak()))
			{
			  this.getJsdgrp().getRec().setGivdat(MdaUtils.add(this.getJsdgrp().getRec().getCredat(),1));
			}
			if("2".equals(this.getJsdgrp().getRec().getJqnmak()))
			{
			  this.getJsdgrp().getRec().setGivdat(MdaUtils.add(this.getJsdgrp().getRec().getCredat(),2));
			}

			

			return true;
        }

        /**
        *   source:jstopn.@0050.script
        */
        @Rule(target="jsdgrp.rec.zshcno",order=100)
        public boolean ruleJsdgrpRecZshcnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getZshcno()))
			  ctx.postRule(this,"jstp.zxjmod.zxj.jshsty");

			return true;
        }

        /**
        *   source:jstopn.@0051.script
        */
        @Rule(target="jstp.jsdgrp.rec.xmlx",order=100)
        public boolean ruleJstpJsdgrpRecXmlxN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJstp().getJsdgrp().getRec().getXmlx())&&!MdaUtils.isEmpty(this.getJstp().getJsdgrp().getRec().getKhlb()))
			{
			  this.getJstp().getJsdgrp().getRec().setWgjcno(this.getJstp().getJsdgrp().getRec().getXmlx()+this.getJstp().getJsdgrp().getRec().getKhlb());
			}
			else
			{
			  this.getJstp().getJsdgrp().getRec().setWgjcno(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0052.script
        */
        @Rule(target="jstp.jsdgrp.rec.khlb",order=100)
        public boolean ruleJstpJsdgrpRecKhlbN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJstp().getJsdgrp().getRec().getXmlx())&&!MdaUtils.isEmpty(this.getJstp().getJsdgrp().getRec().getKhlb()))
			{
			  this.getJstp().getJsdgrp().getRec().setWgjcno(this.getJstp().getJsdgrp().getRec().getXmlx()+this.getJstp().getJsdgrp().getRec().getKhlb());
			}
			else
			{
			  this.getJstp().getJsdgrp().getRec().setWgjcno(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:jstopn.@0053.script
        */
        @Rule(target="jsdgrp.rec.bzjslt",order=100)
        public boolean ruleJsdgrpRecBzjsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","jstopn  保证金业务处理开始，order:10");

			this.getJstp().getStpmod().storePanel(this.getJstp().getJstopn1(),this.getJstp().getJstopn2(),this.getJstp().getJstopn3());
			String steps = "0:条款确认;1:大额结售汇";
			if(!TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  steps =steps+";2:保证金质押协议";
			  
			  
			  this.getJsdgrp().getRec().setBzjref(NULLSTR);
			  
			}
			else
			{
			  
			  
			  
			}
			
			
			

			this.getJstp().getStpmod().setPages(steps);
			this.getJstp().getStpmod().calcSteps();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:jstopn.@0062.script
        */
        @Rule(target="jsdgrp.rec.isreltrn",order=100)
        public boolean ruleJsdgrpRecIsreltrnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getJstp().getStpmod().storePanel(this.getJstp().getJstopn1(),this.getJstp().getJstopn2(),this.getJstp().getJstopn3());
			String steps = "0:条款确认;1:大额结售汇";
			if(TRUE.equals(this.getJsdgrp().getRec().getIsreltrn()))
			{
			  
			  
			  
			  
			  
			  
			  /*融资担保编号*/
			  this.getJsdgrp().getRec().setIschotrn(FALSE);
			  this.getJsdgrp().getRec().setRzxbhno(NULLSTR);
			  this.getJsdgrp().getRec().setDbhtno(NULLSTR);
			  
			  
			  
			  /*是否有授信协议编号  */
			  this.getJsdgrp().getRec().setSfyzsh(FALSE);
			  this.getJsdgrp().getRec().setZshcno(NULLSTR);
			  
			  /*是否有保证金质押协议*/
			  this.getJsdgrp().getRec().setBzjsty(FALSE);
			  this.getJsdgrp().getRec().setBzjcno(NULLSTR);
			  this.getJsdgrp().getRec().setBzjrat(new BigDecimal(0));
			  
			  
			  this.getJsdgrp().getRec().setBzjslt(NULLSTR);
			  this.getJsdgrp().getRec().setBzjref(NULLSTR);
			  
			  
			  
			}
			else
			{
			  
			  
			  this.getJsdgrp().getRec().setReltrnref(NULLSTR);
			  this.getJsdgrp().getRec().setReltrnnam(NULLSTR);
			  this.getJsdgrp().getRec().setRelbzjacc(NULLSTR);
			  this.getJsdgrp().getRec().setRelzyxybh(NULLSTR);
			  
			  
			  
			  
			}
			
			

			
			
			
			
			
			

			
			
			
			
			
			
			
			this.getJstp().getStpmod().setPages(steps);
			this.getJstp().getStpmod().calcSteps();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:jstopn.@0067.script
        */
        @Rule(target="jstp.pdfviw.jump",order=100)
        public boolean ruleJstpPdfviwJumpN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getJstp().getStpmod().nextStep();
			this.getJstp().getStpmod().setStepBtnSta();
			this.getJstp().getPdfviw().setChk(TRUE);
			
			MdaUtils.setValues(this.getJstp().getJsdgrp().getRec(),"seltyp",MdaUtils.getCodetable("sel1"));

			return true;
        }

        /**
        *   source:jstopn.@0068.script
        */
        @Rule(target="jstp.tukmod.pdfviw.chk1",order=100)
        public boolean ruleJstpTukmodPdfviwChk1N100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if(TRUE.equals(this.getJstp().getTukmod().getPdfviw().getChk1()))
			{
			  
			  

			}
			else
			{
			  
			  

			}
			


			return true;
        }

        /**
        *   source:jstopn.@0069.script
        */
        @Rule(target="jsdgrp.rec.ischotrn",order=100)
        public boolean ruleJsdgrpRecIschotrnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getJstp().getStpmod().storePanel(this.getJstp().getJstopn1(),this.getJstp().getJstopn2(),this.getJstp().getJstopn3());
			String steps = "0:条款确认;1:大额结售汇";
			if(TRUE.equals(this.getJsdgrp().getRec().getIschotrn()))
			{
			  this.getJsdgrp().getRec().setRzxbhno(NULLSTR);
			  this.getJsdgrp().getRec().setDbhtno(NULLSTR);
			  
			  
			  
			  //选项三
			  this.getJsdgrp().getRec().setIsreltrn(FALSE);
			  
			  
			  this.getJsdgrp().getRec().setReltrnref(NULLSTR);
			  this.getJsdgrp().getRec().setReltrnnam(NULLSTR);
			  this.getJsdgrp().getRec().setRelbzjacc(NULLSTR);
			  this.getJsdgrp().getRec().setRelzyxybh(NULLSTR);
			  
			  
			  
			  
			  //选项四
			  /*是否有授信协议编号  */
			  this.getJsdgrp().getRec().setSfyzsh(FALSE);
			  this.getJsdgrp().getRec().setZshcno(NULLSTR);
			  
			  /*是否有保证金质押协议*/
			  this.getJsdgrp().getRec().setBzjsty(FALSE);
			  this.getJsdgrp().getRec().setBzjcno(NULLSTR);
			  this.getJsdgrp().getRec().setBzjrat(new BigDecimal(0));
			  
			  
			  this.getJsdgrp().getRec().setBzjslt(NULLSTR);
			  this.getJsdgrp().getRec().setBzjref(NULLSTR);
			  
			  
			  
			}
			else
			{
			  this.getJsdgrp().getRec().setRzxbhno(NULLSTR);
			  this.getJsdgrp().getRec().setDbhtno(NULLSTR);
			  
			  
			  
			}
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			this.getJstp().getStpmod().setPages(steps);
			this.getJstp().getStpmod().calcSteps();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:jstopn.@0008.script
        */
        @Check(target="jsdgrp.rec.givdat",order=100)
        public boolean checkJsdgrpRecGivdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date giv=this.getJsdgrp().getRec().getGivdat();
			Date cre=this.getJsdgrp().getRec().getCredat();

			if(!MdaUtils.isEmpty(giv) && !MdaUtils.isEmpty(cre))
			{
			  String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  String gdate = MdaUtils.format(this.getJsdgrp().getRec().getGivdat(),"yyyyMMdd");
			  if(!date.equals(gdate))
			  {
			    if(MdaUtils.diff(giv,cre)<0)
			    {
			      ctx.setFieldError(this,"jsdgrp.rec.givdat",MdaUtils.getI18NString("jstopn","CT000009"));
			      return false;
			    }
			  }
			  else
			  {
			    if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    {
			      ctx.setFieldError(this,"jsdgrp.rec.givdat",MdaUtils.getI18NString("jstopn","CT000202"));
			      return false;
			    }
			  }
			}

			return true;
        }

        /**
        *   source:jstopn.@0028.script
        */
        @Check(target="jsdgrp.rec.zqndat",order=100)
        public boolean checkJsdgrpRecZqndatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date zqn=this.getJsdgrp().getRec().getZqndat();
			Date cre=this.getJsdgrp().getRec().getCredat();
			Date giv=this.getJsdgrp().getRec().getGivdat();

			if(!MdaUtils.isEmpty(zqn) && !MdaUtils.isEmpty(cre))
			{
			  if(MdaUtils.diff(zqn,cre)==0 || MdaUtils.diff(zqn,cre)<0)
			  {
			    ctx.setFieldError(this,"jsdgrp.rec.zqndat",MdaUtils.getI18NString("jstopn","CT000040"));
			    return false;
			  }
			}

			if(!MdaUtils.isEmpty(zqn) && !MdaUtils.isEmpty(giv))
			{
			  if(MdaUtils.diff(zqn,giv)==0 || MdaUtils.diff(zqn,giv)>0)
			  {
			    ctx.setFieldError(this,"jsdgrp.rec.zqndat",MdaUtils.getI18NString("jstopn","CT000161"));
			    return false;
			  }
			}

			

			return true;
        }

        /**
        *   source:jstopn.@0042.script
        */
        @Check(target="jsdgrp.rec.buycur",order=100)
        public boolean checkJsdgrpRecBuycurN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sfl=this.getJsdgrp().getRec().getSfltyp();
			if("1".equals(sfl) && "CNY".equals(this.getJsdgrp().getRec().getBuycur()))
			{
			  ctx.setFieldError(this,"jsdgrp.rec.buycur",MdaUtils.getI18NString("jstopn","CT000139"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jstopn.@0043.script
        */
        @Check(target="jsdgrp.rec.selcur",order=100)
        public boolean checkJsdgrpRecSelcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sfl=this.getJsdgrp().getRec().getSfltyp();
			if("0".equals(sfl) && "CNY".equals(this.getJsdgrp().getRec().getSelcur()))
			{
			  ctx.setFieldError(this,"jsdgrp.rec.selcur",MdaUtils.getI18NString("jstopn","CT000148"));
			  return false;
			}

			return true;
        }

        /**
        *   source:jstopn.@0056.script
        */
        @Check(target="jstp.jsdgrp.rec.buyamt",order=100)
        public boolean checkJstpJsdgrpRecBuyamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"buyamt"));

			return true;
        }

        /**
        *   source:jstopn.@0057.script
        */
        @Check(target="jstp.jsdgrp.rec.selamt",order=100)
        public boolean checkJstpJsdgrpRecSelamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"selamt"));

			return true;
        }

        /**
        *   source:jstopn.@0058.script
        */
        @Check(target="jstp.jsdgrp.rec.deprat",order=100)
        public boolean checkJstpJsdgrpRecDepratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"deprat"));

			return true;
        }

        /**
        *   source:jstopn.@0059.script
        */
        @Check(target="jstp.jsdgrp.rec.wyymat",order=100)
        public boolean checkJstpJsdgrpRecWyymatN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"wyymat"));

			return true;
        }

        /**
        *   source:jstopn.@0060.script
        */
        @Check(target="jstp.jsdgrp.rec.ydhmat",order=100)
        public boolean checkJstpJsdgrpRecYdhmatN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"ydhmat"));

			return true;
        }

        /**
        *   source:jstopn.@0061.script
        */
        @Check(target="jstp.jsdgrp.rec.bzjrat",order=100)
        public boolean checkJstpJsdgrpRecBzjratN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getJstp().getJsdgrp().getRec(),"bzjrat"));

			return true;
        }

        /**
        *   source:jstopn.@0063.script
        */
        @Check(target="jsdgrp.rec.relbzjacc",order=100)
        public boolean checkJsdgrpRecRelbzjaccN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getIsreltrn()))
			{
			  if(MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    ctx.setFieldError(this,"jsdgrp.rec.relbzjacc",MdaUtils.getI18NString("jstopn","CT000208"));
			    return false;
			  }
			}

			return true;
        }

        /**
        *   source:jstopn.@0064.script
        */
        @Check(target="jsdgrp.rec.relzyxybh",order=100)
        public boolean checkJsdgrpRecRelzyxybhN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getIsreltrn()))
			{
			  if(MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    ctx.setFieldError(this,"jsdgrp.rec.relzyxybh",MdaUtils.getI18NString("jstopn","CT000209"));
			    return false;
			  }
			}


			return true;
        }

        /**
        *   source:jstopn.@0070.script
        */
        @Check(target="jstp.zxjmod.zxj.bzjxyt",order=100)
        public boolean checkJstpZxjmodZxjBzjxytN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			{
			  if(MdaUtils.isEmpty(this.getJstp().getZxjmod().getZxj().getBzjxyt()))
			  {
			    ctx.setFieldError(this,"jstp.zxjmod.zxj.bzjxyt",MdaUtils.getI18NString("jstopn","CT000217"));
			    return false;
			  }
			}

			return true;
        }

        /**
        *   source:jstopn.@0071.script
        */
        @Check(target="jstp.jsdgrp.rec.seltyp",order=100)
        public boolean checkJstpJsdgrpRecSeltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJstp().getJsdgrp().getRec().getSeltyp()))
			{
			  ctx.setFieldError(this,"jsdgrp.rec.seltyp",MdaUtils.getI18NString("jstopn","CT000219"));
			  return false;
			}

			return true;
        }


        /**
        *   source:jstopn.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getJsdgrp().getRec(),"bchcod",bchcod);
			//$jsdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			

			//获取订单
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			//自动获取申请人及申请日期
			if(MdaUtils.isEmpty(this.getJstp().getNam()))
			  this.getJstp().setNam(this.getSysmod().getPty().getNam());
			
			

			this.getJsdgrp().getRec().setCredat(MdaUtils.today());
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCredat()))
			{
			  
			  
			}

			//String txt="    由于非贵行原因导致本交易未能完全履行的，贵行有权对未履约交易部分主动进行平仓。由此产生的损失，全部由我司承担，贵行有权直接从我司在贵行开立的保证金账户或任何其他人民币/外汇账户中扣划该损失。如我司资金余额不足，则按照银行垫款处理，按照同期逾期贷款利率计收利息，并按照同期逾期贷款利率                                           计收罚息。";
			//$jstp\\tstxt.setValue(txt);
			
			ctx.postRule(this,"jsdgrp.rec.seltyp");   //买卖品种
			ctx.postRule(this,"jsdgrp.rec.sfyzsh");   //买卖方向
			ctx.postRule(this,"jsdgrp.rec.bzjsty");  //保证金
			ctx.postRule(this,"jsdgrp.rec.matsty");  //汇率模式
			//退回，暂存判断
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B") || ctx.absGet(Sysmod.class).sptIsLoaded("P") || ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  //使用退回功能时判断
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  if("4".equals(this.getJsdgrp().getRec().getSeltyp())||"5".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    this.getJstp().setTranspanel(this.getJstp().getJstp02());
			    MdaUtils.setValues(this.getJsdgrp().getRec(),"seltyp",MdaUtils.getCodetable("sel1"));

			  }
			  else
			  {
			    this.getJstp().setTranspanel(this.getJstp().getJstp01());
			    MdaUtils.setValues(this.getJsdgrp().getRec(),"seltyp",MdaUtils.getCodetable("sel2"));
			  }
			  
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			  {
			    ctx.postRule(this,"jsdgrp.rec.buycur");
			    ctx.postRule(this,"jsdgrp.rec.buyamt");

			    if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBuycur()) && !MdaUtils.isEmpty(this.getJsdgrp().getRec().getBuyamt()))
			    {
			      String buymax = ctx.absGet(Sysmod.class).covCnAmt(this.getJsdgrp().getRec().getBuyamt(),this.getJsdgrp().getRec().getBuycur());
			      this.getJstp().setBuymax(buymax);
			      
			      log.debug("{}","押汇大写金额="+buymax);
			    }
			  }
			  if("0".equals(this.getJsdgrp().getRec().getSfltyp()))
			  {
			    ctx.postRule(this,"jsdgrp.rec.selcur");
			    ctx.postRule(this,"jsdgrp.rec.selamt");

			    if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSelcur()) && !MdaUtils.isEmpty(this.getJsdgrp().getRec().getSelamt()))
			    {
			      String selmax = ctx.absGet(Sysmod.class).covCnAmt(this.getJsdgrp().getRec().getSelamt(),this.getJsdgrp().getRec().getSelcur());
			      this.getJstp().setSelmax(selmax);
			      
			      log.debug("{}","押汇大写金额="+selmax);
			    }
			  }

			  if(!TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			  {
			    ctx.postRule(this,"jsdgrp.rec.bchcod");
			  }

			  return true;
			}

			log.debug("{}","初始化直接申请人pts========");
			this.getJsdgrp().getDap().initDap("jsd");
			this.getJsdgrp().getApl().copyValues(this.getJsdgrp().getDap());

			this.getJsdgrp().getApl().getPts().setRol("apl");
			

			//从维护的银行协议编号中取“衍生交易总协议”、“综合授信协议”
			this.getJstp().getAgrp().qurAgrnum();
			this.getJsdgrp().getRec().setZxycno(this.getJstp().getAgrp().getNma());
			


			return true;
        }


        /**
        *   source:jstopn.@0044.script
        */
        public void changeValues()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);
			

			BigDecimal amt1 = this.getJsdgrp().getRec().getDeprat();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.000000"));
			this.getJsdgrp().getRec().setDeprat(amt1);
			

			BigDecimal amt2 = this.getJsdgrp().getRec().getYdhmat();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.000000"));
			this.getJsdgrp().getRec().setYdhmat(amt2);
			

			BigDecimal amt3 = this.getJsdgrp().getRec().getBzjrat();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getJsdgrp().getRec().setBzjrat(amt3);
			

			BigDecimal amt4 = this.getJsdgrp().getRec().getWyymat();
			amt4 = MdaUtils.parseDecimal(MdaUtils.format(amt4,"#0.00"));
			this.getJsdgrp().getRec().setWyymat(amt4);
			

			String sel=this.getJsdgrp().getRec().getSeltyp();
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSeltyp()))//买卖品种转换
			{
			  if("4".equals(sel))
			    this.getJstp().setDselty("1");
			  else if("5".equals(sel))
			    this.getJstp().setDselty("2");
			  else if("3".equals(sel))
			    this.getJstp().setDselty("3");
			  else if("6".equals(sel))
			    this.getJstp().setDselty("4");
			  else
			    this.getJstp().setDselty("5");
			}
			else
			  this.getJstp().setDselty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfltyp()))//买卖方向转换
			{
			  String sfl=this.getJsdgrp().getRec().getSfltyp();
			  if("1".equals(sfl))
			    this.getJstp().setDsflty("1");
			  else
			    this.getJstp().setDsflty("2");
			}
			else
			  this.getJstp().setDsflty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getGivsty()))//交割方式转换
			{
			  String giv=this.getJsdgrp().getRec().getGivsty();
			  if("0".equals(giv))
			    this.getJstp().setDgivty("1");
			  else
			    this.getJstp().setDgivty("2");
			}
			else
			  this.getJstp().setDgivty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getZqnsty()) && ("6".equals(sel) || "7".equals(sel)))//是否择期转换
			{
			  String zqn=this.getJsdgrp().getRec().getZqnsty();
			  if("0".equals(zqn))
			    this.getJstp().setDzqnty("1");
			  else
			    this.getJstp().setDzqnty("2");
			}
			else
			  this.getJstp().setDzqnty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJstp().getSelmax()))//金额大写转换
			this.getJstp().setMaxs(this.getJstp().getSelmax());
			else if(!MdaUtils.isEmpty(this.getJstp().getBuymax()))
			  this.getJstp().setMaxs(this.getJstp().getBuymax());
			else
			  this.getJstp().setMaxs(NULLSTR);
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getKhlb()))
			{
			  String kulb=this.getJsdgrp().getRec().getKhlb();
			  if("1".equals(kulb))
			    this.getJstp().setJspkhlb("1");
			  else if("2".equals(kulb))
			    this.getJstp().setJspkhlb("2");
			  else if("3".equals(kulb))
			    this.getJstp().setJspkhlb("3");
			  else
			    this.getJstp().setJspkhlb("4");
			}
			else
			{
			  this.getJstp().setJspkhlb(NULLSTR);
			}
			
			
			
			//是否择期转换
			  //金额大写转换
			
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfltyp()))//买卖方向
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			  {
			    this.getJstp().setDybcno(this.getJsdgrp().getRec().getBuycno());
			    this.getJstp().setDrmcno(this.getJsdgrp().getRec().getSelcno());
			    if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			    {
			      this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbrcno());
			      this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbzcno());
			    }
			    else
			    {
			      this.getJstp().setDqycno(NULLSTR);
			      this.getJstp().setDqrcno(NULLSTR);
			    }
			  }
			  else
			  {
			    this.getJstp().setDrmcno(this.getJsdgrp().getRec().getBuycno());
			    this.getJstp().setDybcno(this.getJsdgrp().getRec().getSelcno());
			    if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			    {
			      this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbrcno());
			      this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbzcno());
			    }
			    else
			    {
			      this.getJstp().setDqycno(NULLSTR);
			      this.getJstp().setDqrcno(NULLSTR);
			    }
			  }
			}
			else
			{
			  this.getJstp().setDrmcno(NULLSTR);
			  this.getJstp().setDybcno(NULLSTR);
			  this.getJstp().setDqycno(NULLSTR);
			  this.getJstp().setDqrcno(NULLSTR);
			}
			
			
			
			

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjcno()))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getBzjcno());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJstp().getDrmcno()))
			    this.getJstp().setKctcno(this.getJstp().getDrmcno());
			  else
			    this.getJstp().setKctcno(this.getJstp().getDybcno());
			}
			

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCur()))
			  this.getJstp().setCurcty(MdaUtils.getCodetableLabel("curnam",this.getJsdgrp().getRec().getCur()));
			else
			  this.getJstp().setCurcty(NULLSTR);
			

			if(TRUE.equals(this.getJsdgrp().getRec().getIsreltrn()))
			{
			  this.getJstp().setDbzj("3");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getIschotrn()))
			{
			  this.getJstp().setDbzj("4");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfyzsh()))
			{
			  this.getJstp().setDbzj("1");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjsty()))
			{
			  this.getJstp().setDbzj("2");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh())&&TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			{
			  this.getJstp().setDbzj("1、2");
			}
			else
			{
			  this.getJstp().setDbzj("");
			}
			

			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()) && !TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  this.getJstp().setBzjcno(this.getJsdgrp().getZxj().getBzjxyt());
			}
			else
			{
			  this.getJstp().setBzjcno(this.getJsdgrp().getRec().getBzjref());
			}
			
		}
        /**
        *   source:jstopn.@0046.script
        */
        public void changeValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);

			BigDecimal amt1 = this.getJsdgrp().getRec().getDeprat();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.000000"));
			this.getJsdgrp().getRec().setDeprat(amt1);

			BigDecimal amt2 = this.getJsdgrp().getRec().getYdhmat();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.000000"));
			this.getJsdgrp().getRec().setYdhmat(amt2);

			BigDecimal amt3 = this.getJsdgrp().getRec().getBzjrat();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.00"));
			this.getJsdgrp().getRec().setBzjrat(amt3);

			BigDecimal amt4 = this.getJsdgrp().getRec().getWyymat();
			amt4 = MdaUtils.parseDecimal(MdaUtils.format(amt4,"#0.00"));
			this.getJsdgrp().getRec().setWyymat(amt4);

			String sel=this.getJsdgrp().getRec().getSeltyp();
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSeltyp()))//买卖品种转换
			{
			  if("4".equals(sel))
			    this.getJstp().setDselty("1");
			  else if("5".equals(sel))
			    this.getJstp().setDselty("2");
			  else if("3".equals(sel))
			    this.getJstp().setDselty("3");
			  else if("6".equals(sel))
			    this.getJstp().setDselty("4");
			  else
			    this.getJstp().setDselty("5");
			}
			else
			  this.getJstp().setDselty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfltyp()))//买卖方向转换
			{
			  String sfl=this.getJsdgrp().getRec().getSfltyp();
			  if("1".equals(sfl))
			    this.getJstp().setDsflty("1");
			  else
			    this.getJstp().setDsflty("2");
			}
			else
			  this.getJstp().setDsflty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getGivsty()))//交割方式转换
			{
			  String giv=this.getJsdgrp().getRec().getGivsty();
			  if("0".equals(giv))
			    this.getJstp().setDgivty("1");
			  else
			    this.getJstp().setDgivty("2");
			}
			else
			  this.getJstp().setDgivty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getZqnsty()) && ("6".equals(sel) || "7".equals(sel)))//是否择期转换
			{
			  String zqn=this.getJsdgrp().getRec().getZqnsty();
			  if("0".equals(zqn))
			    this.getJstp().setDzqnty("1");
			  else
			    this.getJstp().setDzqnty("2");
			}
			else
			  this.getJstp().setDzqnty(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJstp().getSelmax()))//金额大写转换
			this.getJstp().setMaxs(this.getJstp().getSelmax());
			else if(!MdaUtils.isEmpty(this.getJstp().getBuymax()))
			  this.getJstp().setMaxs(this.getJstp().getBuymax());
			else
			  this.getJstp().setMaxs(NULLSTR);

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfltyp()))//买卖方向
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			  {
			    this.getJstp().setDybcno(this.getJsdgrp().getRec().getBuycno());
			    this.getJstp().setDrmcno(this.getJsdgrp().getRec().getSelcno());
			    if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			    {
			      this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbrcno());
			      this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbzcno());
			    }
			    else
			    {
			      this.getJstp().setDqycno(NULLSTR);
			      this.getJstp().setDqrcno(NULLSTR);
			    }
			  }
			  else
			  {
			    this.getJstp().setDrmcno(this.getJsdgrp().getRec().getBuycno());
			    this.getJstp().setDybcno(this.getJsdgrp().getRec().getSelcno());
			    if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			    {
			      this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbrcno());
			      this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbzcno());
			    }
			    else
			    {
			      this.getJstp().setDqycno(NULLSTR);
			      this.getJstp().setDqrcno(NULLSTR);
			    }
			  }
			}
			else
			{
			  this.getJstp().setDrmcno(NULLSTR);
			  this.getJstp().setDybcno(NULLSTR);
			  this.getJstp().setDqycno(NULLSTR);
			  this.getJstp().setDqrcno(NULLSTR);
			}

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjcno()))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getBzjcno());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJstp().getDrmcno()))
			    this.getJstp().setKctcno(this.getJstp().getDrmcno());
			  else
			    this.getJstp().setKctcno(this.getJstp().getDybcno());
			}

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getCur()))
			  this.getJstp().setCurcty(MdaUtils.getCodetableLabel("curnam",this.getJsdgrp().getRec().getCur()));
			else
			  this.getJstp().setCurcty(NULLSTR);

			if(TRUE.equals(this.getJsdgrp().getRec().getIsreltrn()))
			{
			  this.getJstp().setDbzj("3");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getIschotrn()))
			{
			  this.getJstp().setDbzj("4");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getSfyzsh()))
			{
			  this.getJstp().setDbzj("1");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjsty()))
			{
			  this.getJstp().setDbzj("2");
			}
			else if(TRUE.equals(this.getJsdgrp().getRec().getSfyzsh())&&TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			{
			  this.getJstp().setDbzj("1、2");
			}
			else
			{
			  this.getJstp().setDbzj("");
			}

			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()) && !TRUE.equals(this.getJsdgrp().getRec().getBzjslt()))
			{
			  this.getJstp().setBzjcno(this.getJsdgrp().getZxj().getBzjxyt());
			}
			else
			{
			  this.getJstp().setBzjcno(this.getJsdgrp().getRec().getBzjref());
			}
		}
        /**
        *   source:jstopn.@0048.script
        */
        public void setBzjValues()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("1".equals(this.getJstp().getZxjmod().getZxj().getJshsty()))
			{
			  this.getJstp().getZxjmod().setYsjyzxy1(this.getJsdgrp().getRec().getZxycno());
			  this.getJstp().getZxjmod().setZhsxxy(this.getJsdgrp().getRec().getZshcno());
			  this.getJstp().getZxjmod().setYsjyzxy2(NULLSTR);
			}
			else if("2".equals(this.getJstp().getZxjmod().getZxj().getJshsty()))
			{
			  this.getJstp().getZxjmod().setYsjyzxy2(this.getJsdgrp().getRec().getZxycno());
			  this.getJstp().getZxjmod().setYsjyzxy1(NULLSTR);
			  this.getJstp().getZxjmod().setZhsxxy(NULLSTR);
			}
			else
			{
			  this.getJstp().getZxjmod().setYsjyzxy2(NULLSTR);
			  this.getJstp().getZxjmod().setYsjyzxy1(NULLSTR);
			  this.getJstp().getZxjmod().setZhsxxy(NULLSTR);
			}

			
			
			
		}
        /**
        *   source:jstopn.@0049.script
        */
        public void setBzjValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("1".equals(this.getJstp().getZxjmod().getZxj().getJshsty()))
			{
			  this.getJstp().getZxjmod().setYsjyzxy1(this.getJsdgrp().getRec().getZxycno());
			  this.getJstp().getZxjmod().setZhsxxy(this.getJsdgrp().getRec().getZshcno());
			  this.getJstp().getZxjmod().setYsjyzxy2(NULLSTR);
			}
			else if("2".equals(this.getJstp().getZxjmod().getZxj().getJshsty()))
			{
			  this.getJstp().getZxjmod().setYsjyzxy2(this.getJsdgrp().getRec().getZxycno());
			  this.getJstp().getZxjmod().setYsjyzxy1(NULLSTR);
			  this.getJstp().getZxjmod().setZhsxxy(NULLSTR);
			}
			else
			{
			  this.getJstp().getZxjmod().setYsjyzxy2(NULLSTR);
			  this.getJstp().getZxjmod().setYsjyzxy1(NULLSTR);
			  this.getJstp().getZxjmod().setZhsxxy(NULLSTR);
			}

		}
        /**
        *   source:jstopn.@0065.script
        */
        public void getCurValues(String cur )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String cls="com.brilliance.eibs.main.Client";
			BigDecimal  midrat = new BigDecimal(0);

			Object rtnVal = MdaUtils.invoke(cls,"scall","getcurHL","getcurHL",new Object[]{cur});    // 判断接口是否调用成功
			if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			{
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");
			  if("900000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000211"),MdaUtils.getI18NString("jstopn","CT000212"));
			  }
			  else if("999999".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000213"),MdaUtils.getI18NString("jstopn","CT000214"));
			  }
			  else
			  {
			    Object objm = retMsg.get("midrat");
			    midrat = (BigDecimal)objm;
			  }
			}
			else
			{
			  //提示调用错误
			  ctx.setMessage(MdaUtils.getI18NString("jstopn","CT000215"),MdaUtils.getI18NString("jstopn","CT000216"));
			}
			this.getJsdgrp().getRec().setFyrate(midrat);
			
		}








}