package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstpavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期结售汇提前部分交割申请通知
*/
@Transaction(vo= JstpavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstpav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstpav.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstpav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstpav.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstpav.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstpav.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstpav.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstpav.this.getJsdgrp().getRec().getStlref();}}
			 );
        }



        /**
        *   source:jstpav.@0003.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			
			
			
			

			return true;
        }

        /**
        *   source:jstpav.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getJstp().getJstpav1());

			return true;
        }

        /**
        *   source:jstpav.@0005.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());

			
			
			

			return true;
        }










}