package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Jstpay0VO;

import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 远期结售汇提前部分交割申请入口
*/
@Transaction(vo= Jstpay0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstpay0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstpay0.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Jstpay0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:jstpay0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			flush();

			return true;
        }

        /**
        *   source:jstpay0.@0003.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			sureJsd("jstpay");

			return true;
        }

        /**
        *   source:jstpay0.@0004.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			//人民币与外汇期权业务交易
			sureJsd("jstpay");

			return true;
        }



        /**
        *   source:jstpay0.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"jsdtyp",MdaUtils.getCodetable("ywztls"));
			this.getSelp().setJsdtyp("2");
			
			

			List<CodetableItem> ct=new ArrayList<CodetableItem>();
			ct.add(new CodetableItem("远期结汇","6"));
			ct.add(new CodetableItem("远期售汇","7"));
			MdaUtils.setValues(this.getSelp(),"seltyp",ct);
			

			flush();

			return true;
        }


        /**
        *   source:jstpay0.@0000.script
        */
        public void flush()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT rec.inr trsinr,rec.stlref ref,rec.cur cur,rec.amt amt,"
			  +"rec.opndat dat,substr(s.adrblk,0,35) aplnam FROM jsd rec,pts s "
			  +"WHERE s.rol = 'apl' AND s.objtyp = 'jsd' AND s.objinr = rec.inr "
			  +" AND rec.paysta IS NOT NULL "+ ctx.absGet(Sysmod.class).getSelection();

			sql=sql+" and rec.ywztls='"+this.getSelp().getJsdtyp()+"'";

			if(!MdaUtils.isEmpty(this.getSelp().getSeltyp()))
			{
			  sql=sql+" and rec.seltyp='"+this.getSelp().getSeltyp()+"'";
			}
			else
			{
			  sql=sql+" and rec.seltyp in (6,7)";
			}

			this.getSelp().queryBtn(sql);
		}
        /**
        *   source:jstpay0.@0005.script
        */
        public void sureJsd(String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000072"),MdaUtils.getI18NString("jstpay0","CT000073"));
			  return;
			}

			ctx.getDaoSession().dbRead(this.getJsdgrp().getRec(),new Argument<String>("inr",this.getSelp().getTmplst().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			log.debug("{}","zqnsty  值： "+this.getJsdgrp().getRec().getZqnsty());
			String sta=this.getJsdgrp().getRec().getPaysta().trim();
			log.debug("{}","paysta  值:"+sta);

			if("0".equals(sta))
			{
			  /*
			    if("1".equals($jsdgrp\\rec\\zqnsty.getValue()))
			    {
			    Platform.message(#CT000074,#CT000075);
			    flush();
			    }
			    else
			    {*/
			  ctx.storeData("com.brilliance."+ toTrs +".ref",this.getJsdgrp().getRec());
			  
			  //}
			}
			else if("1".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000076"),MdaUtils.getI18NString("jstpay0","CT000077"));
			  flush();
			}
			else if("2".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000110"),MdaUtils.getI18NString("jstpay0","CT000111"));
			  flush();
			}
			else if("3".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000112"),MdaUtils.getI18NString("jstpay0","CT000113"));
			  flush();
			}
			else if("4".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000114"),MdaUtils.getI18NString("jstpay0","CT000115"));
			  flush();
			}
			else if("5".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000116"),MdaUtils.getI18NString("jstpay0","CT000117"));
			  //return;
			  flush();
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstpay0","CT000122"),MdaUtils.getI18NString("jstpay0","CT000123"));
			  flush();
			}
		}





}