package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstsetVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 大额结售汇修改\交割\平仓
*/
@Transaction(vo= JstsetVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstset extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstset.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Jstset()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstset.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstset.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstset.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstset.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstset.this.getJsdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:jstset.@0002.script
        */
        @Rule(target="jstp.pdfviw.agree",order=100)
        public boolean ruleJstpPdfviwAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			{
			  ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstset","CT000000"));
			  return true;
			}
			
			this.getJstp().getStpmod().nextStep();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:jstset.@0003.script
        */
        @Rule(target="jstp.tukmod.pdfviw.cancel",order=100)
        public boolean ruleJstpTukmodPdfviwCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:jstset.@0006.script
        */
        @Rule(target="jsdgrp.djgdat",order=100)
        public boolean ruleJsdgrpDjgdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getDjgdat()))
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000020"),MdaUtils.getI18NString("jstset","CT000021"));

			return true;
        }

        /**
        *   source:jstset.@0008.script
        */
        @Rule(target="jsdgrp.rec.jsdtyp",order=100)
        public boolean ruleJsdgrpRecJsdtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			//改期&&输入最小获利期望
			if("1".equals(this.getJstp().getJsdgrp().getRec().getJsdtyp())&&"2".equals(this.getJsdgrp().getMatsty()))
			{
			  
			  
			}
			else
			{
			  
			  this.getJsdgrp().setDeprat(new BigDecimal(0));
			  
			}
			

			if("1".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  
			  this.getJsdgrp().setDjgsty(NULLSTR);
			  

			  
			  
			  if("0".equals(this.getJsdgrp().getRec().getZqnsty()))
			  {
			    
			    
			  }
			  else
			  {
			    
			    this.getJsdgrp().setDzqdat(null);
			    
			  }
			}
			else
			{
			  if("3".equals(this.getJsdgrp().getRec().getJsdtyp()))
			  {
			    if("6".equals(this.getJsdgrp().getRec().getSeltyp()) || "7".equals(this.getJsdgrp().getRec().getSeltyp()))
			    {
			      
			      

			      //Platform.enable($jsdgrp\\rec\\newgivsty);
			      //Platform.setRequired($jsdgrp\\rec\\newgivsty);
			      /*if("0".equals($jsdgrp\\rec\\givsty.getValue()))
			        $jsdgrp\\rec\\newgivsty.setValue("1");
			        else
			        $jsdgrp\\rec\\newgivsty.setValue("0");
			        */
			    }
			    else
			    {
			      ctx.setFieldError(this,"jsdgrp.rec.jsdtyp",MdaUtils.getI18NString("jstset","CT000034"));
			      this.getJsdgrp().getRec().setJsdtyp(NULLSTR);
			    }
			  }
			  else
			  {
			    if("0".equals(this.getJsdgrp().getRec().getJsdtyp()))
			    {
			      Date giv=this.getJsdgrp().getRec().getGivdat();
			      Date ame=this.getJsdgrp().getRec().getAmedat();
			      if((MdaUtils.diff(giv,ame)>0 || MdaUtils.diff(giv,ame)==0) && "1".equals(this.getJsdgrp().getRec().getZqnsty()))
			      {
			        ctx.setFieldError(this,"jsdgrp.rec.jsdtyp",MdaUtils.getI18NString("jstset","CT000076"));
			        this.getJsdgrp().getRec().setJsdtyp(NULLSTR);
			      }
			    }
			    
			    this.getJsdgrp().setDjgsty(NULLSTR);
			    
			  }

			  
			  
			  this.getJsdgrp().setDzqdat(null);
			  this.getJsdgrp().setDjgdat(null);
			  
			  
			}
			
			
			
			

			return true;
        }

        /**
        *   source:jstset.@0009.script
        */
        @Rule(target="jsdgrp.rec.seltyp",order=100)
        public boolean ruleJsdgrpRecSeltypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getJsdgrp().getRec().getSeltyp()) || "5".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJsdgrp().getRec().setWyjcur("CNY");
			  this.getJsdgrp().getRec().setFsycur("CNY");
			  
			  
			}
			else
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:jstset.@0010.script
        */
        @Rule(target="jstp.stpmod.last",order=10)
        public boolean ruleJstpStpmodLastN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000038"),MdaUtils.getI18NString("jstset","CT000039"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstset","CT000040"));
			      return false;
			    }

			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getJsdgrp()))
			    {
			      return false;
			    }
			  }
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstset.@0011.script
        */
        @Rule(target="jstp.stpmod.next",order=10)
        public boolean ruleJstpStpmodNextN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000041"),MdaUtils.getI18NString("jstset","CT000042"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstset","CT000043"));
			      return false;
			    }

			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getJsdgrp()))
			    {
			      return false;
			    }
			  }
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstset.@0012.script
        */
        @Rule(target="jstp.jbycno",order=100)
        public boolean ruleJstpJbycnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			

			String cur=this.getJsdgrp().getRec().getWyjcur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstset.@0013.script
        */
        @Rule(target="jstp.jslcno",order=100)
        public boolean ruleJstpJslcnoN100(){
            IContext ctx = MdaEnv.getContext();
            

			
			
			

			
			
			

			String cur=this.getJsdgrp().getRec().getFsycur();
			this.getJstp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:jstset.@0014.script
        */
        @Rule(target="jstp.actmod.yd",order=100)
        public boolean ruleJstpActmodYdN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getJstp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000046"),MdaUtils.getI18NString("jstset","CT000047"));
			  return false;
			}

			this.getJsdgrp().getRec().setFsycno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			

			

			return true;
        }

        /**
        *   source:jstset.@0015.script
        */
        @Rule(target="jstp.actmod.actslt",order=100)
        public boolean ruleJstpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getJstp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000058"),MdaUtils.getI18NString("jstset","CT000059"));
			  return false;
			}

			this.getJsdgrp().getRec().setWyjcno(this.getJstp().getActmod().getActlst().getElement(index).getAct());
			

			

			return true;
        }

        /**
        *   source:jstset.@0016.script
        */
        @Rule(target="jsdgrp.dzqdat",order=100)
        public boolean ruleJsdgrpDzqdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getJsdgrp().getDjgdat()))
			{
			  ctx.setFieldError(this,"jsdgrp.djgdat",MdaUtils.getI18NString("jstset","CT000063"));
			  this.getJsdgrp().setDzqdat(null);
			}
			
			

			return true;
        }

        /**
        *   source:jstset.@0017.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getJsdgrp()))
			{
			  log.warn("{}","申请页面校验未通过，退出");
			  return false;
			}

			changeValue();

			//改期&&委托汇率非空
			if("1".equals(this.getJstp().getJsdgrp().getRec().getJsdtyp())&&!MdaUtils.isEmpty(this.getJsdgrp().getDeprat()))
			{
			  //原业务掉期存远端委托汇率，非掉期存委托汇率
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    this.getJsdgrp().getRec().setYdhmat(this.getJsdgrp().getDeprat());
			  }
			  else
			  {
			    this.getJsdgrp().getRec().setDeprat(this.getJsdgrp().getDeprat());
			  }
			}

			if("0".equals(this.getJsdgrp().getRec().getJsdtyp()))
			  this.getJsdgrp().getRec().setPaysta("2");
			else  if("1".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  this.getJsdgrp().getRec().setPaysta("3");
			  this.getJsdgrp().getRec().setNjgdat(this.getJsdgrp().getDjgdat());
			  this.getJsdgrp().getRec().setNzqdat(this.getJsdgrp().getDzqdat());
			}
			else  if("2".equals(this.getJsdgrp().getRec().getJsdtyp()))
			  this.getJsdgrp().getRec().setPaysta("4");
			else
			{
			  this.getJsdgrp().getRec().setPaysta("5");
			  this.getJsdgrp().getRec().setNewgivsty(this.getJsdgrp().getDjgsty());
			}

			ctx.getDaoSession().dbUpdate(this.getJsdgrp().getRec());

			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);

			IPanel[] panels=this.getJstp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			//Platform.saveDisplay($cptp\\cptp01,filename);
			log.info("{}", "sav200结束================" );


			return true;
        }

        /**
        *   source:jstset.@0018.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "";
			String tempfiles = "";

			if("0".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  cnt = 0;
			  labels = "";
			  tempfiles = "";
			}
			else  if("1".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  labels = "人民币与外汇衍生产品业务交割期限调整申请书";
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    tempfiles = "A:jstset12";
			  else
			    tempfiles = "A:jstset11";
			}
			else  if("2".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  labels = "人民币与外汇衍生产品业务平仓申请书";
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    tempfiles = "A:jstset22";
			  else
			    tempfiles = "A:jstset21";
			}
			else
			{
			  labels = "人民币与外汇衍生品交割方式修改申请书";
			  tempfiles = "A:jstset3";
			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:jstset.@0019.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			changeValues();

			if("0".equals(this.getJsdgrp().getRec().getJsdtyp()) || MdaUtils.isEmpty(this.getJsdgrp().getRec().getJsdtyp()))
			  return true;
			else  if("1".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    this.getJstp().getPdfviw().callPDFComponent("","jstset12","人民币与外汇衍生产品业务交割期限调整申请书",0);
			  else
			    this.getJstp().getPdfviw().callPDFComponent("","jstset11","人民币与外汇衍生产品业务交割期限调整申请书",0);
			}
			else  if("2".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    this.getJstp().getPdfviw().callPDFComponent("","jstset22","人民币与外汇衍生产品业务平仓申请书",0);
			  else
			    this.getJstp().getPdfviw().callPDFComponent("","jstset21","人民币与外汇衍生产品业务平仓申请书",0);
			}
			else
			  this.getJstp().getPdfviw().callPDFComponent("","jstset3","人民币与外汇衍生品交割方式修改申请书",0);


			return true;
        }

        /**
        *   source:jstset.@0022.script
        */
        @Rule(target="jstp.stpmod.gostep",order=10)
        public boolean ruleJstpStpmodGostepN10(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getJstp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getJstp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if((stepIdx-curIdx)>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset","CT000089"),MdaUtils.getI18NString("jstset","CT000090"));
			  return false;
			}
			switch(panelidx)
			{
			  case 0:
			  {
			    if(!TRUE.equals(this.getJstp().getPdfviw().getChk()))
			    {
			      ctx.setFieldError(this,"jstp.pdfviw.chk",MdaUtils.getI18NString("jstset","CT000091"));
			      return false;
			    }

			  }
			  case 1:
			  {
			    if(!ctx.checkAll(this.getJsdgrp()))
			    {
			      return false;
			    }
			  }
			}
			log.debug("{}","nextep Order[10] 执行完毕");

			return true;
        }

        /**
        *   source:jstset.@0023.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }


        /**
        *   source:jstset.@0005.script
        */
        @Check(target="jsdgrp.djgdat",order=100)
        public boolean checkJsdgrpDjgdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getJsdgrp().getDjgdat()) && !MdaUtils.isEmpty(this.getJsdgrp().getRec().getAmedat()))
			{
			  Date djg = this.getJsdgrp().getDjgdat();
			  Date ame = this.getJsdgrp().getRec().getAmedat();

			  String cdjg=MdaUtils.format(djg,"yyyyMMdd");
			  String came=MdaUtils.format(ame,"yyyyMMdd");

			  if(!cdjg.equals(came))
			  {
			    if(MdaUtils.diff(djg,ame)<0)  //方法出现bug
			    {
			      ctx.setFieldError(this,"jsdgrp.djgdat",MdaUtils.getI18NString("jstset","CT000019"));
			      return false;
			    }
			  }
			}

			return true;
        }

        /**
        *   source:jstset.@0007.script
        */
        @Check(target="jsdgrp.dzqdat",order=100)
        public boolean checkJsdgrpDzqdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date nzq=this.getJsdgrp().getDzqdat();
			Date ame=this.getJsdgrp().getRec().getAmedat();
			Date njg=this.getJsdgrp().getDjgdat();

			if(!MdaUtils.isEmpty(nzq) && !MdaUtils.isEmpty(ame) && !MdaUtils.isEmpty(njg))
			{
			  if(MdaUtils.diff(nzq,ame)<0 || MdaUtils.diff(nzq,ame)==0)
			  {
			    ctx.setFieldError(this,"jsdgrp.dzqdat",MdaUtils.getI18NString("jstset","CT000029"));
			    return false;
			  }
			  else
			  {
			    if(MdaUtils.diff(nzq,njg)>0 || MdaUtils.diff(nzq,njg)==0)
			    {
			      ctx.setFieldError(this,"jsdgrp.dzqdat",MdaUtils.getI18NString("jstset","CT000030"));
			      return false;
			    }
			  }
			}

			return true;
        }


        /**
        *   source:jstset.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getJsdgrp().getRec(),"bchcod",bchcod);

			
			
			
			ctx.postRule(this,"jsdgrp.rec.jsdtyp");
			ctx.postRule(this,"jsdgrp.rec.seltyp");
			
			
			//改期&&输入最小获利期望
			if("1".equals(this.getJstp().getJsdgrp().getRec().getJsdtyp())&&"2".equals(this.getJsdgrp().getMatsty()))
			{
			  
			  
			}
			if(MdaUtils.isEmpty(this.getJstp().getNam()))
			  this.getJstp().setNam(this.getSysmod().getPty().getNam());
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  this.getJsdgrp().getRec().setAmedat(MdaUtils.today());

			  //if($\\sysmod.sptIsLoaded("P") && Platform.isEmpty($trnmod\\apldoc\\pdfdoc\\inr))
			  //{
			  //}
			  return true;
			}

			IModule jsd = (IModule)ctx.restoreData("com.brilliance.jstset.ref");
			if(!MdaUtils.isEmpty(jsd))
			  this.getJsdgrp().getRec().copyValue(jsd);
			this.getJsdgrp().getRec().setAmedat(MdaUtils.today());
			this.getJsdgrp().getRec().setJsdtyp(NULLSTR);
			this.getJsdgrp().getRec().setGetamt(new BigDecimal(0));
			this.getJsdgrp().getRec().setGivamt(new BigDecimal(0));
			this.getJsdgrp().getRec().setGetslt(NULLSTR);
			this.getJsdgrp().getRec().setGivslt(NULLSTR);

			//掉期时取远端委托汇率模式，其他取委托汇率模式
			if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJsdgrp().setMatsty(this.getJsdgrp().getRec().getYdhsty());
			}
			else
			{
			  this.getJsdgrp().setMatsty(this.getJsdgrp().getRec().getMatsty());
			}

			ctx.getDaoSession().dbRead(this.getJsdgrp().getApl().getPts(),new Argument<String>("objinr",this.getJsdgrp().getRec().getInr()),new Argument<String>("objtyp","jsd"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getJsdgrp().getZxj(),new Argument<String>("objinr",this.getJsdgrp().getRec().getInr()),new Argument<String>("objtyp","jsd"));


			return true;
        }

        /**
        *   source:jstset.@0001.script
        */
        @Init(order=10)
        public boolean	init10(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","jstame   初始化开始，order:10");
			this.getJstp().getStpmod().storePanel(this.getJstp().getJstopn1(),this.getJstp().getJstset1());
			String steps = "0:条款确认;1:交易后处理";

			this.getJstp().getStpmod().setPages(steps);
			this.getJstp().getStpmod().calcSteps();
			this.getJstp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:jstset.@0020.script
        */
        public void changeValues()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);
			

			BigDecimal amt1 = this.getJsdgrp().getRec().getDeprat();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.000000"));
			this.getJsdgrp().getRec().setDeprat(amt1);
			

			BigDecimal amt3 = this.getJsdgrp().getRec().getBzjrat();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.0"));
			this.getJsdgrp().getRec().setBzjrat(amt3);
			

			BigDecimal amt4 = this.getJsdgrp().getDeprat();
			amt4 = MdaUtils.parseDecimal(MdaUtils.format(amt4,"#0.000000"));
			this.getJsdgrp().setDeprat(amt4);
			

			String sel=this.getJsdgrp().getRec().getSeltyp();
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSeltyp()))//买卖品种转换
			{
			  if("4".equals(sel))
			    this.getJstp().setDselty("1");
			  else if("5".equals(sel))
			    this.getJstp().setDselty("2");
			  else if("3".equals(sel))
			    this.getJstp().setDselty("3");
			  else if("6".equals(sel))
			    this.getJstp().setDselty("4");
			  else
			    this.getJstp().setDselty("5");
			}
			else
			  this.getJstp().setDselty(NULLSTR);

			if("3".equals(sel))  //买卖方向转换
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			    this.getJstp().setDsflty("1");
			  else
			    this.getJstp().setDsflty("2");

			  this.getJstp().setDgivty(NULLSTR);
			}
			else
			{
			  this.getJstp().setDsflty(NULLSTR);

			  //交割方式转换
			  if("0".equals(this.getJsdgrp().getRec().getGivsty()))
			    this.getJstp().setDgivty("1");
			  else
			    this.getJstp().setDgivty("2");

			  if("3".equals(this.getJsdgrp().getRec().getJsdtyp()))
			  {  //新交割方式转换
			    if("0".equals(this.getJsdgrp().getDjgsty()))
			      this.getJstp().setDnewgivty("1");
			    else if("1".equals(this.getJsdgrp().getDjgsty()))
			      this.getJstp().setDnewgivty("2");
			    else
			      this.getJstp().setDnewgivty(NULLSTR);
			  }
			  else
			  {
			    if("0".equals(this.getJsdgrp().getRec().getNewgivsty()))
			      this.getJstp().setDnewgivty("1");
			    else if("1".equals(this.getJsdgrp().getRec().getNewgivsty()))
			      this.getJstp().setDnewgivty("2");
			    else
			      this.getJstp().setDnewgivty(NULLSTR);
			  }
			  

			  if("6".equals(sel) || "7".equals(sel))//是否择期转换
			  {
			    if("0".equals(this.getJsdgrp().getRec().getZqnsty()))
			      this.getJstp().setDzqnty("1");
			    else
			      this.getJstp().setDzqnty("2");
			  }
			  else
			    this.getJstp().setDzqnty(NULLSTR);
			}
			String max = ctx.absGet(Sysmod.class).covCnAmt(this.getJsdgrp().getRec().getAmt(),this.getJsdgrp().getRec().getCur());
			this.getJstp().setMaxs(max);  //金额大写转换
			
			
			
			
			//是否择期转换
			  //金额大写转换
			
			if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			{
			  this.getJstp().setDybcno(this.getJsdgrp().getRec().getBuycno());
			  this.getJstp().setDrmcno(this.getJsdgrp().getRec().getSelcno());
			  if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			  {
			    this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbrcno());
			    this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbzcno());
			  }
			  else
			  {
			    this.getJstp().setDqycno(NULLSTR);
			    this.getJstp().setDqrcno(NULLSTR);
			  }
			}
			else
			{
			  this.getJstp().setDrmcno(this.getJsdgrp().getRec().getBuycno());
			  this.getJstp().setDybcno(this.getJsdgrp().getRec().getSelcno());
			  if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			  {
			    this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbrcno());
			    this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbzcno());
			  }
			  else
			  {
			    this.getJstp().setDqycno(NULLSTR);
			    this.getJstp().setDqrcno(NULLSTR);
			  }
			}
			
			
			
			

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjcno()))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getBzjcno());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJstp().getDrmcno()))
			    this.getJstp().setKctcno(this.getJstp().getDrmcno());
			  else
			    this.getJstp().setKctcno(this.getJstp().getDybcno());
			}
			

			this.getJstp().setCurcty(MdaUtils.getCodetableLabel("curnam",this.getJsdgrp().getRec().getCur()));
			

			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			  this.getJstp().setDbzj("1");
			else
			  this.getJstp().setDbzj("2");
			
		}
        /**
        *   source:jstset.@0021.script
        */
        public void changeValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);

			BigDecimal amt1 = this.getJsdgrp().getRec().getDeprat();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.000000"));
			this.getJsdgrp().getRec().setDeprat(amt1);

			BigDecimal amt3 = this.getJsdgrp().getRec().getBzjrat();
			amt3 = MdaUtils.parseDecimal(MdaUtils.format(amt3,"#0.0"));
			this.getJsdgrp().getRec().setBzjrat(amt3);

			String sel=this.getJsdgrp().getRec().getSeltyp();
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSeltyp()))//买卖品种转换
			{
			  if("4".equals(sel))
			    this.getJstp().setDselty("1");
			  else if("5".equals(sel))
			    this.getJstp().setDselty("2");
			  else if("3".equals(sel))
			    this.getJstp().setDselty("3");
			  else if("6".equals(sel))
			    this.getJstp().setDselty("4");
			  else
			    this.getJstp().setDselty("5");
			}
			else
			  this.getJstp().setDselty(NULLSTR);

			if("3".equals(sel))  //买卖方向转换
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			    this.getJstp().setDsflty("1");
			  else
			    this.getJstp().setDsflty("2");

			  this.getJstp().setDgivty(NULLSTR);
			}
			else
			{
			  this.getJstp().setDsflty(NULLSTR);

			  if("0".equals(this.getJsdgrp().getRec().getGivsty()))//交割方式转换
			  {
			    this.getJstp().setDgivty("1");
			  }
			  else
			    this.getJstp().setDgivty("2");

			  if("3".equals(this.getJsdgrp().getRec().getJsdtyp()))
			  {
			    if("0".equals(this.getJsdgrp().getDjgsty()))  //交割方式转换
			    this.getJstp().setDnewgivty("1");
			    else if("1".equals(this.getJsdgrp().getDjgsty()))
			      this.getJstp().setDnewgivty("2");
			    else
			      this.getJstp().setDnewgivty(NULLSTR);
			  }
			  else
			  {
			    if("0".equals(this.getJsdgrp().getRec().getNewgivsty()))
			      this.getJstp().setDnewgivty("1");
			    else if("1".equals(this.getJsdgrp().getRec().getNewgivsty()))
			      this.getJstp().setDnewgivty("2");
			    else
			      this.getJstp().setDnewgivty(NULLSTR);
			  }

			  if("6".equals(sel) || "7".equals(sel))//是否择期转换
			  {
			    if("0".equals(this.getJsdgrp().getRec().getZqnsty()))
			      this.getJstp().setDzqnty("1");
			    else
			      this.getJstp().setDzqnty("2");
			  }
			  else
			    this.getJstp().setDzqnty(NULLSTR);
			}
			String max = ctx.absGet(Sysmod.class).covCnAmt(this.getJsdgrp().getRec().getAmt(),this.getJsdgrp().getRec().getCur());
			this.getJstp().setMaxs(max);  //金额大写转换
			
			if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			{
			  this.getJstp().setDybcno(this.getJsdgrp().getRec().getBuycno());
			  this.getJstp().setDrmcno(this.getJsdgrp().getRec().getSelcno());
			  if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			  {
			    this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbrcno());
			    this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbzcno());
			  }
			  else
			  {
			    this.getJstp().setDqycno(NULLSTR);
			    this.getJstp().setDqrcno(NULLSTR);
			  }
			}
			else
			{
			  this.getJstp().setDrmcno(this.getJsdgrp().getRec().getBuycno());
			  this.getJstp().setDybcno(this.getJsdgrp().getRec().getSelcno());
			  if(TRUE.equals(this.getJsdgrp().getRec().getYjisxt()))
			  {
			    this.getJstp().setDqrcno(this.getJsdgrp().getRec().getYbrcno());
			    this.getJstp().setDqycno(this.getJsdgrp().getRec().getYbzcno());
			  }
			  else
			  {
			    this.getJstp().setDqycno(NULLSTR);
			    this.getJstp().setDqrcno(NULLSTR);
			  }
			}

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getBzjcno()))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getBzjcno());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJstp().getDrmcno()))
			    this.getJstp().setKctcno(this.getJstp().getDrmcno());
			  else
			    this.getJstp().setKctcno(this.getJstp().getDybcno());
			}

			this.getJstp().setCurcty(MdaUtils.getCodetableLabel("curnam",this.getJsdgrp().getRec().getCur()));

			if(TRUE.equals(this.getJsdgrp().getRec().getBzjsty()))
			  this.getJstp().setDbzj("1");
			else
			  this.getJstp().setDbzj("2");
		}








}