package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Jstset0VO;

import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 大额结售汇修改\交割\平仓入口
*/
@Transaction(vo= Jstset0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstset0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstset0.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Jstset0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:jstset0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			flushs();

			return true;
        }

        /**
        *   source:jstset0.@0003.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			sureJsd("jstset");
			//$selp.sureBtn("jsdgrp","jstset");
			
			return true;
        }

        /**
        *   source:jstset0.@0004.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
              //人民币与外汇期权业务交易
			sureJsd("jstset");
			//$selp.sureBtn("jsdgrp","jstset");
			
			return true;
        }



        /**
        *   source:jstset0.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"jsdtyp",MdaUtils.getCodetable("ywztls"));
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("sel2"));
			flushs();


			return true;
        }


        /**
        *   source:jstset0.@0005.script
        */
        public void flushs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT rec.inr trsinr,rec.stlref ref,rec.cur cur,rec.amt amt,"
			  +"rec.opndat dat,substr(s.adrblk,0,35) aplnam FROM jsd rec,pts s "
			  +"WHERE s.rol = 'apl' AND s.objtyp = 'jsd' AND s.objinr = rec.inr "
			  +" AND rec.paysta IS NOT NULL "+ ctx.absGet(Sysmod.class).getSelection();

			if(!MdaUtils.isEmpty(this.getSelp().getJsdtyp()))
			{
			  if("2".equals(this.getSelp().getJsdtyp()))
			    sql=sql+" and (rec.ywztls='2' or rec.ywztls='i')";
			  else
			    sql=sql+" and rec.ywztls='"+this.getSelp().getJsdtyp()+"'";
			}
			else
			{
			  sql=sql+" and (rec.ywztls='2' or rec.ywztls='i' or rec.ywztls='3')";
			}

			if(!MdaUtils.isEmpty(this.getSelp().getSeltyp()))
			{
			  sql=sql+" and rec.seltyp='"+this.getSelp().getSeltyp()+"'";
			}
			else
			{
			  sql=sql+" and rec.seltyp in (3,6,7)";
			}

			this.getSelp().queryBtn(sql);
		}
        /**
        *   source:jstset0.@0006.script
        */
        public void sureJsd(String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000114"),MdaUtils.getI18NString("jstset0","CT000115"));
			  return;
			}

			ctx.getDaoSession().dbRead(this.getJsdgrp().getRec(),new Argument<String>("inr",this.getSelp().getTmplst().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			log.debug("{}","zqnsty  值： "+this.getJsdgrp().getRec().getZqnsty());
			String sta=this.getJsdgrp().getRec().getPaysta().trim();
			log.debug("{}","paysta  值:"+sta);

			if("0".equals(sta))
			{
			  ctx.storeData("com.brilliance."+ toTrs +".ref",this.getJsdgrp().getRec());
			  
			}
			else if("1".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000116"),MdaUtils.getI18NString("jstset0","CT000117"));
			  flushs();
			}
			else if("2".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000118"),MdaUtils.getI18NString("jstset0","CT000119"));
			  flushs();
			}
			else if("3".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000120"),MdaUtils.getI18NString("jstset0","CT000121"));
			  flushs();
			}
			else if("4".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000122"),MdaUtils.getI18NString("jstset0","CT000123"));
			  flushs();
			}
			else if("5".equals(sta))
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000124"),MdaUtils.getI18NString("jstset0","CT000125"));
			  //return;
			  flushs();
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("jstset0","CT000126"),MdaUtils.getI18NString("jstset0","CT000127"));
			  flushs();
			}
		}





}