package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.JstsevVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Jsdgrp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Jstmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Jstp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 大额结售汇修改\交割\平仓通知
*/
@Transaction(vo= JstsevVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstsev extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Jstsev.class);

		@BDGetter
		private Jsdgrp jsdgrp;

		@BDGetter
		private Jstmod jstmod;

		@BDGetter
		private Jstp jstp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Jsdgrp bpdf;

		@BDGetter
		private Jsdgrp spdf;


		public Jstsev()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getJstmod().setJsdgrpHolder(()->this.getJsdgrp());
           this.getJstp().setJsdgrpHolder(()->this.getJsdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("JS"));
           this.getMtabut().setRecHolder(()->this.getJsdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.cur");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setCur(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Jstsev.this.getJsdgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Jstsev.this.getJsdgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.ownref");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.bchcod");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.inr");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setInr(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.ptyinr");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Jstsev.this.getFieldPath("jsdgrp.rec.stlref");}
 				public void setValue(String arg){Jstsev.this.getJsdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Jstsev.this.getJsdgrp().getRec().getStlref();}}
			 );
        }



        /**
        *   source:jstsev.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();
			
			
			
			

			return true;
        }

        /**
        *   source:jstsev.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			setPdfValue();

			String labels = "";
			String tempfiles = "";
			if("0".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  labels = "";
			  tempfiles = "";
			}
			else  if("1".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  labels = "人民币与外汇衍生产品业务交割期限调整证实书";
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			  {
			    tempfiles = "A:jstsev2";
			    if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			      this.getBpdf().copyValues(this.getJsdgrp());
			    else
			      this.getSpdf().copyValues(this.getJsdgrp());
			  }
			  else
			  {
			    tempfiles = "A:jstsev1";
			    if("6".equals(this.getJsdgrp().getRec().getSeltyp()))
			      this.getBpdf().copyValues(this.getJsdgrp());
			    else
			      this.getSpdf().copyValues(this.getJsdgrp());
			  }
			}
			else  if("2".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  labels = "人民币与外汇衍生产品业务平仓证实书";
			  if("3".equals(this.getJsdgrp().getRec().getSeltyp()))
			    tempfiles = "A:jstsev3";
			  else
			    tempfiles = "A:jstsev4";
			}
			else
			{
			  labels = "人民币与外汇衍生品交割方式修改指令证实书";
			  tempfiles = "A:chkame1";
			}

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo1();
			labels =  cntLabel.get("label") +labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			if(MdaUtils.isEmpty(labels)&&MdaUtils.isEmpty(tempfiles))
			{
			  labels=",";
			  tempfiles=",";
			}
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getJstp().getJstsev0());

			return true;
        }

        /**
        *   source:jstsev.@0003.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());

			
			
			

			return true;
        }


        /**
        *   source:jstsev.@0002.script
        */
        public void setPdfValue()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getJsdgrp().getRec().setAmt(amt);
			

			BigDecimal amt1 = this.getJsdgrp().getRec().getGivamt();
			amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			this.getJsdgrp().getRec().setGivamt(amt1);
			

			BigDecimal amt2 = this.getJsdgrp().getRec().getGetamt();
			amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			this.getJsdgrp().getRec().setGetamt(amt2);
			
			/* pdf新增栏位*/
			String bzjedu="";
			if(!MdaUtils.isEmpty(this.getJsdgrp().getEduamt()))
			{
			  bzjedu=MdaUtils.format(this.getJsdgrp().getEduamt(),"#0.00");
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getBzjmat()))
			    bzjedu=bzjedu+"  /  "+MdaUtils.format(this.getJsdgrp().getBzjmat(),"#0.00")+" %";
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getBzjmat()))
			    bzjedu=MdaUtils.format(this.getJsdgrp().getBzjmat(),"#0.00")+" %";
			}
			if(!MdaUtils.isEmpty(bzjedu))
			  this.getJsdgrp().setBzjedu(bzjedu);

			String bzjzyxy="";
			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())||!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			{
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy=this.getJsdgrp().getRec().getRelbzjacc()+"/";
			  }
			  if(MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy="/"+this.getJsdgrp().getRec().getRelzyxybh();
			  }
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelbzjacc())&&!MdaUtils.isEmpty(this.getJsdgrp().getRec().getRelzyxybh()))
			  {
			    bzjzyxy=this.getJsdgrp().getRec().getRelbzjacc()+"/"+this.getJsdgrp().getRec().getRelzyxybh();
			  }
			  this.getJsdgrp().setBzjzyxy(bzjzyxy);
			}
			else
			{
			  this.getJsdgrp().setBzjzyxy(bzjzyxy);
			}
			/**/
			if("0".equals(this.getJsdgrp().getRec().getZqnsty()))
			{
			  this.getJsdgrp().setDty("2");
			  this.getJsdgrp().setZdat(this.getJsdgrp().getRec().getGivdat());
			}
			else
			{
			  this.getJsdgrp().setDty(this.getJsdgrp().getRec().getZqnsty());
			  this.getJsdgrp().setGdat(this.getJsdgrp().getRec().getGivdat());
			}

			if("0".equals(this.getJsdgrp().getRec().getSfltyp()))
			  this.getJsdgrp().setDsf("2");
			else
			  this.getJsdgrp().setDsf(this.getJsdgrp().getRec().getSfltyp());

			if(MdaUtils.isEmpty(this.getJsdgrp().getPtynam()))
			{
			  this.getJsdgrp().setPtynam(this.getTrnmod().getPtyName(this.getJsdgrp().getRec().getPtyinr()));
			}

			if(MdaUtils.isEmpty(this.getJsdgrp().getNam()))
			{
			  String inr=this.getTrnmod().getPtysFromCid(this.getJsdgrp().getRec().getBchcod());
			  this.getJsdgrp().setNam(this.getTrnmod().getPtyName(inr));
			}

			if("1".equals(this.getJsdgrp().getRec().getGivsty()) && ("4".equals(this.getJsdgrp().getRec().getSeltyp()) || "6".equals(this.getJsdgrp().getRec().getSeltyp())))
			{
			  this.getJstp().setKctcno(this.getJsdgrp().getRec().getSelcno());
			}
			else
			{
			  if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			    this.getJstp().setKctcno(this.getJsdgrp().getRec().getSelcno());
			  else
			    this.getJstp().setKctcno(this.getJsdgrp().getRec().getBuycno());
			}

			if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getSeltyp()))//买卖品种转换
			{
			  String sel=this.getJsdgrp().getRec().getSeltyp();
			  if("4".equals(sel))
			    this.getJstp().setDselty("1");
			  else if("5".equals(sel))
			    this.getJstp().setDselty("2");
			  else if("3".equals(sel))
			    this.getJstp().setDselty("3");
			  else if("6".equals(sel))
			    this.getJstp().setDselty("4");
			  else
			    this.getJstp().setDselty("5");
			}

			if("6".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJsdgrp().setYqjmat(this.getJsdgrp().getJddmat());
			  this.getJsdgrp().setYqsmat(new BigDecimal(0));
			}
			else if("7".equals(this.getJsdgrp().getRec().getSeltyp()))
			{
			  this.getJsdgrp().setYqsmat(this.getJsdgrp().getJddmat());
			  this.getJsdgrp().setYqjmat(new BigDecimal(0));
			}
			else
			{
			  this.getJsdgrp().setYqsmat(new BigDecimal(0));
			  this.getJsdgrp().setYqjmat(new BigDecimal(0));
			}

			if("2".equals(this.getJsdgrp().getRec().getJsdtyp()))
			{
			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getGetamt()) && MdaUtils.isEmpty(this.getJsdgrp().getRec().getGivamt()))
			  {
			    this.getJstp().setRmbcno(new ControlImpl(this.getJsdgrp().getRec().toString(),"fsycno",null));
			    this.getJsdgrp().getRec().setGetslt("X");
			    this.getJsdgrp().setGetdat(this.getJsdgrp().getRec().getChkdat());
			  }

			  if(MdaUtils.isEmpty(this.getJsdgrp().getRec().getGetamt()) && !MdaUtils.isEmpty(this.getJsdgrp().getRec().getGivamt()))
			  {
			    this.getJsdgrp().getRec().setGivslt("X");
			    this.getJsdgrp().setGisdat(this.getJsdgrp().getRec().getChkdat());
			  }
			}		}










}