package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetameVO;

import com.ceb.gjjs.mda.manager.module.Letmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Letp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口来证修改通知
*/
@Transaction(vo= LetameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letame.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Letmod letmod;

		@BDGetter
		private Letp letp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Letame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLetp().setLedgrpHolder(()->this.getLedgrp());
           this.getLetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Letame.this.getLedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Letame.this.getLedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.bchcod");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.lcccur");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getLcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.inr");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setInr(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.ptyinr");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letame.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letame.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letame.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letame.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:letame.@0001.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles="";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getLetp().getLetp03());

			return true;
        }

        /**
        *   source:letame.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:letame.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(	MdaUtils.isEmpty(this.getLedgrp().getRec().getExpamedat()))
			{
			  this.getLedgrp().setFindat(this.getLedgrp().getRec().getExpdat());
			}
			else
			{
			  this.getLedgrp().setFindat(this.getLedgrp().getRec().getExpamedat());
			}
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getShpamedat()))
			{
			  this.getLedgrp().setFshdat(this.getLedgrp().getRec().getShpdat());
			}
			else
			{
			  this.getLedgrp().setFshdat(this.getLedgrp().getRec().getShpamedat());
			}

			return true;
        }











}