package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetatdVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Latmod;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Latp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-交单
*/
@Transaction(vo= LetatdVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letatd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letatd.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Latmod latmod;

		@BDGetter
		private Latp latp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Letatd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLatmod().setBedgrpHolder(()->this.getBedgrp());
           this.getLatmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLatp().setBedgrpHolder(()->this.getBedgrp());
           this.getLatp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Letatd.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Letatd.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Letatd.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Letatd.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Letatd.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letatd.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Letatd.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letatd.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Letatd.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Letatd.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Letatd.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letatd.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letatd.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letatd.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letatd.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letatd.@0000.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");

			this.getBedgrp().getRec().setOthdoc(this.getLatp().getDocgrdm().getOthdoc());
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());

			BigDecimal docamt= MdaUtils.parseDecimal(MdaUtils.format(this.getBedgrp().getRec().getDocamt(),"#0.00"));
			this.getBedgrp().getRec().setDocamt(docamt);

			if(!(ctx.checkAll(this.getBedgrp())&& ctx.checkAll(this.getLatp().getBnkrec())))
			  return false;

			log.debug("{}",this.getBedgrp().getRec().getDocgrd());
			log.debug("{}","ccss="+this.getBedgrp().getIsb().getPts().getAdrblk());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());
			else
			{
			  this.getBedgrp().getRec().setInr(Platform.sdbCounter("bed"));
			  this.getBedgrp().getRec().setPtyinr(this.getLedgrp().getRec().getPtyinr());
			  //$bedgrp\\rec\\bchcod.setValue($ledgrp\\rec\\bchcod.getValue());
			  this.getBedgrp().getRec().setStlref(this.getLedgrp().getRec().getStlref());
			  this.getBedgrp().getRec().setPntinr(this.getLedgrp().getRec().getInr());
			  this.getBedgrp().getRec().setBedtyp("1");
			  //$lztgrp\\rec\\objinr.setValue($lztgrp\\rec\\inr.getValue());
			  //$ladgrp\\rec\\ownusr.setValue($sysmod\\usr\\inr.getValue());
			  log.debug("{}","docgrd= "+this.getBedgrp().getRec().getDocgrd());
			  ctx.getDaoSession().dbInsert(this.getBedgrp().getRec());

			  /*$afdgrp\\rec\\inr.setValue(Platform.sdbCounter("afd"));
			    $afdgrp\\rec\\objtyp.setValue("bed");
			    $afdgrp\\rec\\objinr.setValue($bedgrp\\rec\\inr.getValue());
			    $afdgrp\\rec\\ownusr.setValue($sysmod\\usr\\inr.getValue());
			    $afdgrp\\rec\\bchcod.setValue($bedgrp\\rec\\bchcod.getValue());
			    $afdgrp\\rec\\stlref.setValue($bedgrp\\rec\\stlref.getValue());
			    Platform.dbInsert($afdgrp\\rec);
			    */
			}
			this.getBedgrp().setDocinf(this.getLatp().getDocgrdm().encodeTco());
			if(!this.getTrnmod().trnSetFromContract())return false;
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:letatd.@0001.script
        */
        @Rule(target="bedgrp.rec.bfds1",order=100)
        public boolean ruleBedgrpRecBfds1N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(TRUE.equals($bedgrp\\rec\\bfds1.getValue()))
			  {
			  $bedgrp\\rec\\bfds2.setValue("");
			  }
			  Platform.setModified($bedgrp\\rec\\bfds1);
			  Platform.setModified($bedgrp\\rec\\bfds2);
			  */

			return true;
        }

        /**
        *   source:letatd.@0002.script
        */
        @Rule(target="bedgrp.rec.bfds2",order=100)
        public boolean ruleBedgrpRecBfds2N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($bedgrp\\rec\\bfds2.getValue()))
			  {
			  $bedgrp\\rec\\bfds1.setValue("");
			  }
			  Platform.setModified($bedgrp\\rec\\bfds1);
			  Platform.setModified($bedgrp\\rec\\bfds2);
			  */

			return true;
        }

        /**
        *   source:letatd.@0008.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","letatd",stream,false );

			return true;
        }

        /**
        *   source:letatd.@0009.script
        */
        @Rule(target="bedgrp.rec.isyrc",order=100)
        public boolean ruleBedgrpRecIsyrcN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBedgrp().getRec().getIsyrc()))
			{
			  
			  
			  this.getBedgrp().getRec().setJrcno(NULLSTR);
			  
			  
			  
			  
			  this.getBedgrp().getRec().setIsjrc("");
			}
			else
			{
			  this.getBedgrp().getRec().setYrcno(NULLSTR);
			  
			  
			  
			}
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:letatd.@0010.script
        */
        @Rule(target="bedgrp.rec.isjrc",order=100)
        public boolean ruleBedgrpRecIsjrcN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBedgrp().getRec().getIsjrc()))
			{
			  
			  
			  this.getBedgrp().getRec().setYrcno(NULLSTR);
			  
			  
			  
			  
			  this.getBedgrp().getRec().setIsyrc("");
			}
			else
			{
			  this.getBedgrp().getRec().setJrcno(NULLSTR);
			  
			  
			  
			}
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:letatd.@0013.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:letatd.@0015.script
        */
        @Rule(target="bedgrp.isb.pts.adrblk",order=100)
        public boolean ruleBedgrpIsbPtsAdrblkN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($bedgrp\\isb\\pts\\adrblk))
			  {
			  log.debug($bedgrp\\isb\\pts\\adrblk.getValue());
			  $bedgrp\\rec\\sndto.setValue($bedgrp\\isb\\pts\\adrblk.getValue());
			  }
			  Platform.setModified($bedgrp\\rec\\sndto);
			  */

			return true;
        }

        /**
        *   source:letatd.@0017.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "客户交单业务委托书";
			String tempfiles = "A:letatd";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:letatd.@0018.script
        */
        @Rule(target="latp.yslact",order=100)
        public boolean ruleLatpYslactN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cur=this.getLedgrp().getRec().getLcccur();
			this.getLatp().getActmod().setAct(cur);

			return true;
        }

        /**
        *   source:letatd.@0019.script
        */
        @Rule(target="latp.jslact",order=100)
        public boolean ruleLatpJslactN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLatp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:letatd.@0020.script
        */
        @Rule(target="latp.actmod.actslt",order=100)
        public boolean ruleLatpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getLatp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("letatd","CT000010"),MdaUtils.getI18NString("letatd","CT000011"));
			  return false;
			}
			//String rmbact=$latp\\actmod\\actlst[index]\\act.getValue();
			if(TRUE.equals(this.getBedgrp().getRec().getIsyrc()))
			{
			  this.getBedgrp().getRec().setYrcno(this.getLatp().getActmod().getActlst().getElement(index).getAct());
			  
			}
			if(TRUE.equals(this.getBedgrp().getRec().getIsjrc()))
			{
			  this.getBedgrp().getRec().setJrcno(this.getLatp().getActmod().getActlst().getElement(index).getAct());
			  
			}
			

			return true;
        }

        /**
        *   source:letatd.@0021.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			//IStream stream=$mtabut\\apldoc.getValue();
			BigDecimal docamt=this.getLatp().getVals(this.getBedgrp().getRec().getDocamt());
			this.getBedgrp().getRec().setDocamt(docamt);
			
			this.getLatp().getPdfviw().callPDFComponent("","letatd","出口融资申请书",1);

			return true;
        }


        /**
        *   source:letatd.@0011.script
        */
        @Check(target="bedgrp.rec.lzydat",order=100)
        public boolean checkBedgrpRecLzydatN100(){
            IContext ctx = MdaEnv.getContext();
            
			//if(Platform.isEmpty($bedgrp\\rec\\credat)||Platform.isEmpty($ledgrp\\rec\\expdat)||Platform.isEmpty($bedgrp\\rec\\lzydat))
			// return;
			// if(Platform.diff($bedgrp\\rec\\lzydat.getValue(),$bedgrp\\rec\\credat.getValue())<0)
			//Platform.error($bedgrp\\rec\\lzydat,#CT000001);
			//if(Platform.diff($bedgrp\\rec\\lzydat.getValue(),$ledgrp\\rec\\expdat.getValue())>0)
			//Platform.error($bedgrp\\rec\\lzydat,#CT000003);
			
			return true;
        }

        /**
        *   source:letatd.@0022.script
        */
        @Check(target="bedgrp.rec.lfsno",order=100)
        public boolean checkBedgrpRecLfsnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getLfsno()))
			{
			  String str=this.getBedgrp().getRec().getLfsno();
			  String js="\\d{1,}";
			  Pattern pattern=Pattern.compile(js);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bedgrp.rec.lfsno",MdaUtils.getI18NString("letatd","CT000015"));
			    this.getBedgrp().getRec().setLfsno(NULLSTR);
			  }
			}
			

			return true;
        }

        /**
        *   source:letatd.@0023.script
        */
        @Check(target="bedgrp.rec.docamt",order=100)
        public boolean checkBedgrpRecDocamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal doc=this.getBedgrp().getRec().getDocamt();
			BigDecimal lcc=this.getLedgrp().getRec().getLccamt();
			if(!MdaUtils.isEmpty(doc))
			{
			  BigDecimal js=MdaUtils.parseDecimal(0.00);
			  if(doc.compareTo(js)<0)
			  {
			    this.getBedgrp().getRec().setDocamt(new BigDecimal(0));
			    ctx.setFieldError(this,"bedgrp.rec.docamt",MdaUtils.getI18NString("letatd","CT000018"));
			  }

			  if(doc.compareTo(lcc)>0)
			  {
			    ctx.setFieldError(this,"bedgrp.rec.docamt",MdaUtils.getI18NString("letatd","CT000022"));
			  }
			}
			

			return true;
        }

        /**
        *   source:letatd.@0025.script
        */
        @Check(target="bedgrp.rec.docgrd",order=100)
        public boolean checkBedgrpRecDocgrdN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*$bedgrp\\rec\\docgrd.setValue($latp\\docgrdm.encode());
			  String value=$bedgrp\\rec\\docgrd.getValue();
			  if(!Platform.isEmpty($bedgrp\\rec\\docgrd))
			  {
			  //String[] values=value.split(",");
			  //int size=values.length/2;
			  int size=$latp\\docgrdm\\docgrd.fullSize();
			  String js="\\\\d{1,5)";
			  Pattern p=Pattern.compile(js);
			  for(int i=0;i<size;i++)
			  {
			  if(!Platform.isEmpty($latp\\docgrdm\\docgrd[i]\\doctyp))
			  {
			  Matcher m=p.matcher($latp\\docgrdm\\docgrd[i]\\doctyp.getValue());
			  if(!m.matches())
			  {
			  Platform.error($latp\\docgrdm\\docgrd[i]\\doctyp,#CT000028);
			  return false;
			  }
			  }
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:letatd.@0026.script
        */
        @Check(target="bedgrp.rec.yrcno",order=100)
        public boolean checkBedgrpRecYrcnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getYrcno()))
			{
			  String lengt=this.getBedgrp().getRec().getYrcno();
			  if(lengt.length()<13||lengt.length()>22)
			  {
			    ctx.setFieldError(this,"bedgrp.rec.yrcno",MdaUtils.getI18NString("letatd","CT000037"));
			    return false;
			  }
			  Pattern pattern=Pattern.compile("[0-9]*");
			  String rmbact=this.getBedgrp().getRec().getYrcno();
			  if(!pattern.matcher(rmbact).matches())
			  {
			    ctx.setFieldError(this,"bedgrp.rec.yrcno",MdaUtils.getI18NString("letatd","CT000038"));
			  }
			}

			return true;
        }

        /**
        *   source:letatd.@0027.script
        */
        @Check(target="bedgrp.rec.jrcno",order=100)
        public boolean checkBedgrpRecJrcnoN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getJrcno()))
			{
			  String lengt=this.getBedgrp().getRec().getJrcno();
			  if(lengt.length()<13||lengt.length()>22)
			  {
			    ctx.setFieldError(this,"bedgrp.rec.jrcno",MdaUtils.getI18NString("letatd","CT000041"));
			    return false;
			  }
			  Pattern pattern=Pattern.compile("[0-9]*");
			  String rmbact=this.getBedgrp().getRec().getJrcno();
			  if(!pattern.matcher(rmbact).matches())
			  {
			    ctx.setFieldError(this,"bedgrp.rec.jrcno",MdaUtils.getI18NString("letatd","CT000042"));
			  }
			}

			return true;
        }


        /**
        *   source:letatd.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLatp().getDocgrdm().decode(this.getBedgrp().getRec().getDocgrd());
			
			
			
			
			
			
			
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			if(!TRUE.equals(this.getBedgrp().getRec().getIsrep()))
			{
			  
			  
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  
			  if(TRUE.equals(this.getBedgrp().getRec().getIsjrc()))
			  {
			    
			    
			    
			  }
			  if(TRUE.equals(this.getBedgrp().getRec().getIsyrc()))
			  {
			    
			    
			    
			  }
			  if(!TRUE.equals(this.getBedgrp().getRec().getIsyrc())&&!TRUE.equals(this.getBedgrp().getRec().getIsjrc()))
			  {
			    
			    
			    
			    
			    
			    
			  }

			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			  {
			    
			  }
			  if(TRUE.equals(this.getBedgrp().getRec().getIsrep()))
			  {
			    
			  }

			  
			  
			  return true;
			}
			IModule led = (IModule)ctx.restoreData("com.brilliance.letatd.ref");
			if(!MdaUtils.isEmpty(led))
			  this.getLedgrp().getRec().copyValue(led);

			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			this.getBedgrp().getRec().setBchcod(this.getLedgrp().getRec().getBchcod()) ;
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			{
			  
			}
			

			ctx.getDaoSession().dbRead(this.getBedgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));
			
			
			this.getBedgrp().setAplnam(this.getSysmod().getPty().getNam());

			//$latp\\docgrdm.decode($bedgrp\\rec\\docgrd.getValue());
			
			this.getBedgrp().getRec().setDoccur(this.getLedgrp().getRec().getLcccur());
			

			//Platform.disable($bedgrp\\rec\\bfdnote);
			
			
			
			
			//Platform.disable($bedgrp\\rec\\lfsno);
			
			log.info("{}","default rule execute...");
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getCredat()))
			{
			  this.getBedgrp().getRec().setCredat(MdaUtils.today());
			  
			}
			this.getSysmod().setTrntiltle(ctx.getTransName());
			log.debug("{}","Trntiltle="+this.getSysmod().getTrntiltle());

			return true;
        }











}