package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetateVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Latmod;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Latp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-交单审核
*/
@Transaction(vo= LetateVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letate extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letate.class);

        //单证通业务流水编号
        private String trninr;
		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Latmod latmod;

		@BDGetter
		private Latp latp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Spt wrkspt;

		@BDGetter
		private Trn wrktrn;


		public Letate()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLatmod().setBedgrpHolder(()->this.getBedgrp());
           this.getLatmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLatp().setLedgrpHolder(()->this.getLedgrp());
           this.getLatp().setBedgrpHolder(()->this.getBedgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Letate.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Letate.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Letate.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Letate.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Letate.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letate.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Letate.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letate.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Letate.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Letate.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Letate.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letate.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letate.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letate.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letate.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letate.@0001.script
        */
        @Rule(target="bedgrp.rec.isadd",order=100)
        public boolean ruleBedgrpRecIsaddN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBedgrp().getRec().getIsadd()))
			{
			  
			  
			}
			else
			{
			  this.getBedgrp().getRec().setBfdnote(NULLSTR);
			  
			  
			}
			

			return true;
        }

        /**
        *   source:letate.@0003.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","letatd",stream,false );

			return true;
        }

        /**
        *   source:letate.@0004.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:letate.@0005.script
        */
        @Rule(target="latp.savse",order=100)
        public boolean ruleLatpSavseN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!accessRight())
			  return false;

			if(!(ctx.checkAll(this.getBedgrp())&& ctx.checkAll(this.getLatp().getBnkrec())))
			  return false;

			ctx.getDaoSession().dbBegin();

			MdaUtils.clear(this.getWrktrn());
			ctx.getDaoSession().dbRead(this.getWrktrn(),new Argument<String>("objinr",this.getSysmod().getSpt().getObjinr()),new Argument<String>("inifrm","letatd"));
			log.debug("{}","objinr=   "+this.getSysmod().getSpt().getObjinr());
			log.debug("{}","inr=  "+this.getWrktrn().getInr());
			if(MdaUtils.isEmpty(this.getWrktrn()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("letate","CT000000"),MdaUtils.getI18NString("letate","CT000001"));
			  return false;
			}
			String inr=this.getWrktrn().getInr();
			ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),new Argument<String>("objinr",inr),new Argument<String>("objtyp","trn"));
			String wfsinr=this.getTrnmod().getWfmmod().getWfs().getInr();
			log.info("{}","deleted wfsinr="+wfsinr);
			ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr));
			log.info("{}","delete wfes OK!");
			ctx.getDaoSession().dbDelete(this.getTrnmod().getWfmmod().getWfs());
			ctx.getDaoSession().dbDelete(this.getTrnmod().getUsrsig(),new Argument("ownref",this.getWrktrn().getOwnref()),new Argument("trninr",inr));

			ctx.getDaoSession().dbRead(this.getTrnmod().getItfmod().getImgmod().getImg(),new Argument<String>("trninr",this.getWrktrn().getInr()));
			ctx.getDaoSession().dbDelete(this.getWrktrn());

			ctx.absGet(Trnmod.class).sigWrite("O","0");
			ctx.absGet(Trnmod.class).getTrn().setRelres("O");
			ctx.absGet(Trnmod.class).getTrn().setRelreq("OA");
			ctx.absGet(Trnmod.class).getTrn().setNxtreq("A");
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("1");
			//Platform.dbRead( $sysmod\\spt ,new Argument<String>("objinr",$bedgrp\\rec\\inr.getValue()),new Argument<String>("frm","letatd"));
			//Platform.errorCode();
			ctx.absGet(Trnmod.class).getTrn().setObjtyp(this.getSysmod().getSpt().getObjtyp());
			ctx.absGet(Trnmod.class).getTrn().setObjinr(this.getSysmod().getSpt().getObjinr());
			ctx.absGet(Trnmod.class).getTrn().setObjnam(this.getSysmod().getSpt().getObjnam());
			ctx.absGet(Trnmod.class).getTrn().setOrdinr(this.getSysmod().getSpt().getOrdinr());
			ctx.absGet(Trnmod.class).getTrn().setPtyinr(this.getSysmod().getPty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setOwnref(this.getSysmod().getSpt().getOwnref());
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("1");
			ctx.absGet(Trnmod.class).getTrn().setIniusr(this.getSysmod().getUsr().getInr());
			ctx.absGet(Trnmod.class).getTrn().setInifrm(ctx.getTransName());
			ctx.absGet(Trnmod.class).getTrn().setInidattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getTrn().setCfmdattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getTrn().setOptptyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setPtytyp(ctx.absGet(Sysmod.class).getPty().getPtytyp());
			ctx.absGet(Trnmod.class).getTrn().setEtyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setEtginr(this.getSysmod().getEtg().getInr());
			ctx.absGet(Trnmod.class).getTrn().setBchcod(ctx.absGet(Sysmod.class).getPty().getCid());
			ctx.absGet(Trnmod.class).getTrn().setOptetyinr(this.getSysmod().getEty().getInr());
			ctx.absGet(Trnmod.class).getTrn().setOptetginr(this.getSysmod().getEtg().getInr());
			ctx.absGet(Trnmod.class).getTrn().setSta("W");
			//$\\trnmod\\trn\\subptyinr.setValue($\\sysmod\\spt\\scrpty.getValue());
			//$\\trnmod\\trn\\srctyp.setValue("spt");
			ctx.absGet(Trnmod.class).getTrn().setNam(this.getTrnmod().getPtyName(this.getSysmod().getSpt().getPtyinr()));
			log.info("{}","cur="+this.getTrnmod().getCur()+",amt="+this.getTrnmod().getAmt());
			ctx.absGet(Trnmod.class).getTrn().setReloricur(this.getTrnmod().getCur());
			ctx.absGet(Trnmod.class).getTrn().setReloriamt(this.getTrnmod().getAmt());
			ctx.absGet(Trnmod.class).getTrn().setRelcur("USD");
			if(!this.getTrnmod().setReleaseAmout())
			{
			  return false;
			}
			ctx.absGet(Trnmod.class).getTrn().setInr(Platform.sdbCounter("trn"));
			ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getTrn());
			//}
			String trninr=ctx.absGet(Trnmod.class).getTrn().getInr();

			if(!TRUE.equals(this.getBedgrp().getRec().getIsadd()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("letate","CT000020"),MdaUtils.getI18NString("letate","CT000021"));
			  return false;
			}

			this.getBedgrp().getRec().setBedtyp("2");
			ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());

			this.getBedgrp().setDocinf(this.getLatp().getDocgrdm().encodeTco());
			//if(!$trnmod.trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(ctx.absGet(Trnmod.class).getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			String grptyp=ctx.absGet(Sysmod.class).getSpt().getObjtyp();
			IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp");
			IStream is=ctx.absGet(Mtabut.class).getTrnstm();
			MdaUtils.saveData(mod,is);
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			if(!MdaUtils.isEmpty(grp))
			{
			  log.info("{}","saveData---grp2="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp),is);
			}
			ctx.absGet(Sysmod.class).streamSaveInSubdir(is,"trndata/"+trninr.substring(0,4),trninr+".dat");
			//createAppFile("betcdv",trninr);
			//createAppFile("betcdv1",trninr+"1");
			//setNoticeEntry(trninr+".app,0;"+trninr+"1.app,1;"+trninr+".app,2");
			
			ctx.absGet(Trnmod.class).getTrn().setOriinr(this.getSysmod().getSpt().getInr());
			log.debug("{}","inr    2"+ctx.absGet(Trnmod.class).getTrn().getInr());
			ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			this.getWrkspt().setPtyinr(this.getSysmod().getSpt().getPtyinr());
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			{
			  ctx.getDaoSession().dbDelete(this.getSysmod().getSpt());
			}

			return true;
        }

        /**
        *   source:letate.@0007.script
        */
        @Rule(target="latp.savse",order=1000)
        public boolean ruleLatpSavseN1000(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()==ERROR_SQL)
			{
			  ctx.setMessage(MdaUtils.getI18NString("letate","CT000010"),MdaUtils.getI18NString("letate","CT000011"));
			  return false;
			}

			if(!"X".equals(ctx.absGet(Sysmod.class).getFlg()))
			{
			  log.debug("{}","提交成功。返回主页面:"+ctx.absGet(Sysmod.class).getFlg());
			  ctx.setMessage(MdaUtils.getI18NString("letate","CT000012"),MdaUtils.getI18NString("letate","CT000013"));
			  
			}

			return true;
        }

        /**
        *   source:letate.@0008.script
        */
        @Rule(target="latp.savse",order=200)
        public boolean ruleLatpSavseN200(){
            IContext ctx = MdaEnv.getContext();
            
			String ordinr=this.getTrnmod().getTrn().getOrdinr();
			this.getTrnmod().getOrdmod().updateOrd(ordinr,"B","11",this.getRmkmod().getNtext());

			//生成spt记录
			this.getWrkspt().setFrm(ctx.getTransName());
			String argpty=this.getTrnmod().getPtysFromCid(ctx.absGet(Trnmod.class).getBchcod());
			this.getWrkspt().setOprogninr(argpty);
			this.getWrkspt().setObjnam(ctx.absGet(Trnmod.class).getTrn().getObjnam());
			this.getWrkspt().setNam(ctx.absGet(Trnmod.class).getTrn().getNam());
			log.debug("{}","数据   objinr= :"+this.getWrkspt().getObjnam());
			this.getWrkspt().setObjtyp(ctx.absGet(Trnmod.class).getTrn().getObjtyp());
			this.getWrkspt().setObjinr(ctx.absGet(Trnmod.class).getTrn().getObjinr());
			this.getWrkspt().setOwnref(ctx.absGet(Trnmod.class).getTrn().getOwnref());
			this.getWrkspt().setDattim(MdaUtils.today());
			this.getWrkspt().setScr("S");
			this.getWrkspt().setScrtxt(ctx.absGet(Trnmod.class).getTrn().getInr());
			this.getWrkspt().setScrpty(ctx.absGet(Trnmod.class).getTrn().getOptptyinr());
			//$wrkspt\\ptyinr.setValue($trnmod\\trn\\ptyinr.getValue());
			this.getWrkspt().setOrdinr(ctx.absGet(Trnmod.class).getTrn().getOrdinr());
			this.getWrkspt().setTrncur(ctx.absGet(Trnmod.class).getTrn().getReloricur());
			this.getWrkspt().setTrnamt(ctx.absGet(Trnmod.class).getTrn().getReloriamt());
			this.getWrkspt().setInr(Platform.sdbCounter("spt"));
			this.getWrkspt().setSta("B");
			this.getWrkspt().setOprusrinr("");
			this.getWrkspt().setSmhinr("");
			// 存储银行端复核级别
			String transName = this.getWrkspt().getFrm();
			if(ctx.absGet(Trnmod.class).isFinancingTransaction(this.getWrkspt().getFrm(),"2"))
			{
			  this.getWrkspt().setNxtfrm( ctx.absGet(Trnmod.class).getNextFrameToBank(ctx.absGet(Sysmod.class).getSpt().getFrm()));
			  this.getWrkspt().setRelreq( ctx.absGet(Trnmod.class).getReleaseMethodForBank(ctx.absGet(Sysmod.class).getSpt().getFrm(),argpty,ctx.absGet(Sysmod.class).getSpt().getNxtfrm()));
			  this.getWrkspt().setNxtreq( "O");
			}
			log.info("{}","1:  "+this.getWrkspt().getOprogninr());
			ctx.getDaoSession().dbInsert(this.getWrkspt());
			String filename = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Trnmod.class).getTrn().getInr(),"dat");
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("letate","CT000017"));
			  return true;
			}
			String tarfile = this.getSysmod().createFilename(this.getWrkspt().getInr(),"bak");
			MdaUtils.fileCopy(filename,tarfile);

			//更新影像表信息
			this.getTrnmod().getItfmod().getImgmod().getImg().setTrninr(this.getWrkspt().getScrtxt());
			this.getTrnmod().getItfmod().getImgmod().getImg().setInifrm(ctx.getTransName());
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getItfmod().getImgmod().getImg());
			this.getRmkmod().updateRmk("12");

			return true;
        }

        /**
        *   source:letate.@0009.script
        */
        @Rule(target="latp.isbp.sure",order=100)
        public boolean ruleLatpIsbpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if("bed".equals($latp\\isbp\\belongto.getValue()))
			  {
			  }
			  */

			return true;
        }

        /**
        *   source:letate.@0010.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			//IStream stream=$mtabut\\apldoc.getValue();
			BigDecimal docamt=this.getLatp().getVals(this.getBedgrp().getRec().getDocamt());
			this.getBedgrp().getRec().setDocamt(docamt);
			
			this.getLatp().getPdfviw().callPDFComponent("","letate","出口融资申请书",1);

			return true;
        }

        /**
        *   source:letate.@0012.script
        */
        @Rule(target="latp.dztlyx",order=100)
        public boolean ruleLatpDztlyxN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查阅
			log.debug("{}"," trninr....  :" +this.getTrninr());
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().imgScans(this.getTrninr());

			return true;
        }



        /**
        *   source:letate.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String ordinr=this.getSysmod().getSpt().getOrdinr();
			//加载备注信息
			this.getRmkmod().loadRemarkByOrd(ordinr);
			
			

			//业务编号关联影像信息
			String trninr=this.getSysmod().getSpt().getScrtxt();
			//Platform.dbRead($trnmod\\itfmod\\imgmod\\img,new Argument<String>("trninr",trninr));
			this.setTrninr(trninr);
			
			log.info("{}","trninr=" +this.getTrninr() +",ordinr="+ordinr);

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			  MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			  {
			    
			  }
			  

			  this.getLatp().getDocgrdm().decode1(this.getBedgrp().getRec().getDocgrd());
			  this.getLatp().latdis();
			  if(!TRUE.equals(this.getBedgrp().getRec().getIsadd()))
			  {
			    
			  }
			  return true;
			}
			IModule bed = (IModule)ctx.restoreData("com.brilliance.letate.ref");
			if(!MdaUtils.isEmpty(bed))
			  this.getBedgrp().getRec().copyValue(bed);

			List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			{
			  
			}
			

			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("inr",this.getBedgrp().getRec().getPntinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance.letate.ref",this.getLedgrp().getRec());
			IModule led = (IModule)ctx.restoreData("com.brilliance.letate.ref");
			if(!MdaUtils.isEmpty(led))
			  this.getLedgrp().getRec().copyValue(led);

			ctx.getDaoSession().dbRead(this.getBedgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));
			this.getBedgrp().setAplnam(this.getSysmod().getPty().getNam());

			//$bedgrp\\rec\\docgrd.setValue("1,5,2,8,3,7,4,9");
			this.getLatp().getDocgrdm().decode1(this.getBedgrp().getRec().getDocgrd());
			
			this.getLatp().getDocgrdm().setOthdoc(this.getBedgrp().getRec().getOthdoc());
			

			log.info("{}","default rule execute...");
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getCredat()))
			{
			  this.getBedgrp().getRec().setCredat(MdaUtils.today());
			  
			}
			this.getLatp().latdis();
			


			return true;
        }


        /**
        *   source:letate.@0006.script
        */
        public boolean accessRight()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String logusrinr=this.getSysmod().getUsr().getInr();
			Argument<String> trn =new Argument<String>("trn");
			/*
			  String query="SELECT e.frm trn FROM usr a,usrrol b,rolpro d,modlst e WHERE "+
			  "b.usrinr=a.inr AND b.rolinr=d.rolinr AND d.frminr=e.inr AND e.ptytyp='0' AND"+
			  " a.inr='"+logusrinr+"' AND e.frm='combus'";
			  */
			String query="SELECT d.frminr trn FROM usr a,usrrol b,rol c,rolpro d WHERE b.usrinr=a.inr AND b.rolinr=c.inr AND b.rolinr=d.rolinr AND a.inr='"+logusrinr+"' AND trim(d.frminr)='combus'";
			ctx.getDaoSession().dbExecuteSQL(query);
			ctx.getDaoSession().dbFetchFields(trn);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_MORE_ROW)
			{
			  ctx.setMessage(MdaUtils.getI18NString("letate","CT000008"),MdaUtils.getI18NString("letate","CT000009"));
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}












}