package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetatrVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-交单审核入口
*/
@Transaction(vo= LetatrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letatr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letatr.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private ModuleList<Spt> sptlst;


		public Letatr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:letatr.@0000.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			//String seltyp=$selp\\seltyp.getValue();
			//if("2".equals(seltyp))
			//{
			int index=0;
			if(index!=-1)
			{
			  ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument("inr",this.getSptlst().getElement(index).getInr()));
			}
			selsure("bedgrp","letate");


			return true;
        }

        /**
        *   source:letatr.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sql=null;
			String inrs=ctx.absGet(Sysmod.class).getPty().getInr();
			String ptyinr=this.getSelp().getPtynam();
			if(!MdaUtils.isEmpty(this.getSelp().getPtynam()))
			{
			  inrs = ptyinr;
			}
			log.debug("{}","inrs= "+inrs);
			MdaUtils.clear(this.getSysmod().getPty());
			ctx.getDaoSession().dbRead(this.getSysmod().getPty(),new Argument<String>("inr",inrs));
			String lvl=this.getSysmod().getPty().getLvl();
			String cid=this.getSysmod().getPty().getCid();
			querySerch(lvl,cid,inrs,sql);
			/* if(Platform.isEmpty($selp\\ref))
			  {
			  Platform.clear($sptlst);
			  Platform.dbReadset($sptlst,new Argument<String>("oprogninr",inrs),new Argument<String>("sta","T"),new Argument<String>("frm","letatd"),new Argument<Object>("dattim",DESC));
			  //Platform.dbReadset($sptlst,new Argument<String>("sta","T"),new Argument<String>("frm","letatd"),new Argument<Object>("dattim",DESC));
			  }
			  else
			  {
			  Platform.clear($sptlst);
			  sql="SELECT distinct inr,objinr,ownref,dattim,trncur,trnamt,objnam from spt WHERE oprogninr='"+inrs+"' and sta='T' and frm='letatd' AND ownref LIKE '%" + $selp\\ref.getValue() + "%' order by dattim desc";
			  //sql="SELECT distinct inr,objinr,ownref,dattim,trncur,trnamt,objnam from spt WHERE sta='T' and frm='letatd' AND ownref LIKE '%" + $selp\\ref.getValue() + "%' order by dattim desc";
			  log.debug("ptyinr= "+ptyinr);
			  //Platform.dbReadset($sptlst,new Argument<String>("ownref",ownref),new Argument<String>("sta","T"),new Argument<String>("frm","letatd"),new Argument<Object>("dattim",DESC));
			  Platform.dbExecuteSQL(sql);
			  int tmp = Platform.errorCode();
			  log.info("最终执行的queryClause语句==========" + sql);
			  Argument<String> inr = new Argument<String>("inr");
			  Argument<String> objinr = new Argument<String>("objinr");
			  Argument<String> ownref = new Argument<String>("ownref");
			  Argument<Date> dattim = new Argument<Date>("dattim");
			  Argument<String> trncur = new Argument<String>("trncur");
			  Argument<BigDecimal> trnamt = new Argument<BigDecimal>("trnamt");
			  Argument<String> objnam = new Argument<String>("objnam");
			
			  while(true)
			  {
			  Platform.dbFetchFields(inr,objinr,ownref,dattim,trncur,trnamt,objnam);
			  int errorCode = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  {
			  $sptlst.add(inr,objinr,ownref,dattim,trncur,trnamt,objnam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			  break;
			  }
			  else
			  {
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  }
			  Platform.setModified($sptlst);*/

			return true;
        }

        /**
        *   source:letatr.@0002.script
        */
        @Rule(target="sptlst",order=100)
        public boolean ruleSptlstN100(){
            IContext ctx = MdaEnv.getContext();
              //出口信用证来证交单
			int index=0;
			if(index!=-1)
			{
			  ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument("inr",this.getSptlst().getElement(index).getInr()));
			}
			selsure("bedgrp","letate");
			//$selp.sureBtn00("ledgrp","letate");
			
			return true;
        }



        /**
        *   source:letatr.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			MdaUtils.setValues(this.getSelp(),"ptynam",bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			  this.getSelp().setPtynam(bchcod.get(0).getValue());
			/*Platform.setValues($selp\\seltyp,Platform.getCodetable("selletatr"));
			  $selp\\seltyp.setValue("2");
			  //将查询语句输入selp层的Argument类型控件queryClause字段
			  //String queryClause = "SELECT led.inr trsinr,led.stlref ref,led.advdat dat,led.lcccur cur,led.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM led,pts,adr,pta WHERE led.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'led' AND pts.objinr = led.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  Platform.visible($selp\\tmplst);
			  Platform.invisible($selp\\tmplst1);
			  String queryClause="SELECT distinct rec.inr trsinr,rec.pntinr pinr,rec.stlref ref,rec.credat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam "
			  +"FROM bed rec,pts s,led ld WHERE s.rol = 'apl' AND s.objtyp = 'led' AND s.objinr = ld.inr AND rec.pntinr=ld.inr AND rec.stlref not like '%BX%' AND rec.bedtyp='1' "
			  +$\\sysmod.getSelection();
			  $selp.queryBtn00(queryClause);
			  */

			return true;
        }

        /**
        *   source:letatr.@0004.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			String inrs=this.getSysmod().getPty().getInr();
			String lvl=this.getSysmod().getPty().getLvl();
			String cid=this.getSysmod().getPty().getCid();
			String sql=null;
			querySerch(lvl,cid,inrs,sql);

			//Platform.dbReadset($sptlst,new Argument<String>("oprogninr",inr),new Argument<String>("sta","T"),new Argument<String>("frm","letatd"),new Argument<Object>("dattim",DESC));
			

			return true;
        }


        /**
        *   source:letatr.@0006.script
        */
        public void selsure(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSptlst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("letatr","CT000014"),MdaUtils.getI18NString("letatr","CT000015"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(this,ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getSptlst().getElement(index).getObjinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:letatr.@0007.script
        */
        public void querySerch(String lvl,String cid,String inrs,String sql)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getSptlst());
			log.debug("{}","lvl,cid,inrs    ="+lvl+"   " +cid+"   "+inrs);
			sql="SELECT distinct inr,objinr,ownref,dattim,trncur,trnamt,objnam from spt WHERE sta='T' and frm='letatd'";
			if("0".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=INR AND ptytyp='0' or oprogninr='"+inrs+"')";
			}
			else if("1".equals(lvl))
			{
			  sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=INR AND ptytyp='0' AND pntinr='"+cid+"' or oprogninr='"+inrs+"')";
			}
			else
			{
			  sql=sql+" AND oprogninr='"+inrs+"'";
			}
			if(!MdaUtils.isEmpty(this.getSelp().getRef()))
			{
			  sql = sql + " AND ownref LIKE '%" + this.getSelp().getRef() + "%'";
			}
			sql = sql + "  order by dattim desc ";

			ctx.getDaoSession().dbExecuteSQL(sql);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的sql语句==========" + sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> objinr = new Argument<String>("objinr");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<Date> dattim = new Argument<Date>("dattim");
			Argument<String> trncur = new Argument<String>("trncur");
			Argument<BigDecimal> trnamt = new Argument<BigDecimal>("trnamt");
			Argument<String> objnam = new Argument<String>("objnam");

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,objinr,ownref,dattim,trncur,trnamt,objnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getSptlst().add(inr,objinr,ownref,dattim,trncur,trnamt,objnam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();

			
		}







}