package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetatsVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Latmod;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Latp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-交单审核不符点确认
*/
@Transaction(vo= LetatsVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letats extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letats.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Latmod latmod;

		@BDGetter
		private Latp latp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trn wrktrn;


		public Letats()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLatmod().setBedgrpHolder(()->this.getBedgrp());
           this.getLatmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLatp().setLedgrpHolder(()->this.getLedgrp());
           this.getLatp().setBedgrpHolder(()->this.getBedgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("OC"));
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Letats.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Letats.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Letats.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Letats.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Letats.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letats.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.bchcod");}
 				public void setValue(String arg){Letats.this.getBedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letats.this.getBedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.inr");}
 				public void setValue(String arg){Letats.this.getBedgrp().getRec().setInr(arg);}
 				public String getValue(){return Letats.this.getBedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Letats.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letats.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letats.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letats.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letats.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letats.@0000.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			IStream stream=this.getMtabut().getApldoc();
			this.getLatp().getPdfviw().callPDFComponent("","letats","出口融资申请书",1);
			ctx.absGet(Sysmod.class).generatorPdf("","letats",stream,false );

			return true;
        }

        /**
        *   source:letats.@0001.script
        */
        @Rule(target="bedgrp.rec.bfds1",order=100)
        public boolean ruleBedgrpRecBfds1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBedgrp().getRec().getBfds1()))
			{
			  if(TRUE.equals(this.getBedgrp().getRec().getBfds1()))
			  {
			    this.getBedgrp().getRec().setBfds2("");
			  }
			}
			
			

			return true;
        }

        /**
        *   source:letats.@0002.script
        */
        @Rule(target="bedgrp.rec.bfds2",order=100)
        public boolean ruleBedgrpRecBfds2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getBedgrp().getRec().getBfds2()))
			{
			  this.getBedgrp().getRec().setBfds1("");
			  this.getLatp().setBfdset(this.getLatp().getBfdsure());
			  
			  
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:letats.@0003.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!(ctx.checkAll(this.getBedgrp())&& ctx.checkAll(this.getLatp().getBnkrec())))
			  return false;

			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getBfds1())&&MdaUtils.isEmpty(this.getBedgrp().getRec().getBfds2()))
			{
			  ctx.setFieldError(this,"bedgrp.rec.bfds1",MdaUtils.getI18NString("letats","CT000001"));
			  return false;
			}
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			//if($\\sysmod.sptIsLoaded("B"))
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getInr()))
			{
			  this.getBedgrp().getRec().setBedtyp("3");
			  ctx.getDaoSession().dbUpdate(this.getBedgrp().getRec());
			  /*if(!Platform.isEmpty($sysmod\\spt\\scrtxt))
			    {
			    Platform.clear($wrktrn);
			    Platform.dbRead($wrktrn,new Argument<String>("inr",$sysmod\\spt\\scrtxt.getValue()),new Argument<String>("inifrm","letate"));
			    if(!Platform.isEmpty($wrktrn\\inr))
			    {
			    log.debug("inr  1=   "+$wrktrn\\inr.getValue());
			    Platform.dbDelete($wrktrn);
			    }
			    }*/
			}
			/*else
			  {
			  $bedgrp\\rec\\inr.setValue(Platform.sdbCounter("bed"));
			  $bedgrp\\rec\\ptyinr.setValue($ledgrp\\rec\\ptyinr.getValue());
			  //$bedgrp\\rec\\bchcod.setValue($ledgrp\\rec\\bchcod.getValue());
			  $bedgrp\\rec\\stlref.setValue($ledgrp\\rec\\stlref.getValue());
			  $bedgrp\\rec\\pntinr.setValue($ledgrp\\rec\\inr.getValue());
			  $bedgrp\\rec\\bedtyp.setValue("1");
			  //$lztgrp\\rec\\objinr.setValue($lztgrp\\rec\\inr.getValue());
			  //$ladgrp\\rec\\ownusr.setValue($sysmod\\usr\\inr.getValue());
			  Platform.dbInsert($bedgrp\\rec);
			
			  /*$afdgrp\\rec\\inr.setValue(Platform.sdbCounter("afd"));
			  $afdgrp\\rec\\objtyp.setValue("bed");
			  $afdgrp\\rec\\objinr.setValue($bedgrp\\rec\\inr.getValue());
			  $afdgrp\\rec\\ownusr.setValue($sysmod\\usr\\inr.getValue());
			  $afdgrp\\rec\\bchcod.setValue($bedgrp\\rec\\bchcod.getValue());
			  $afdgrp\\rec\\stlref.setValue($bedgrp\\rec\\stlref.getValue());
			  Platform.dbInsert($afdgrp\\rec);
			  }*/
			this.getBedgrp().setDocinf(this.getLatp().getDocgrdm().encodeTco());
			if(!this.getTrnmod().trnSetFromContract())return false;
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:letats.@0005.script
        */
        @Rule(target="mtabut.ped",order=100)
        public boolean ruleMtabutPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());

			return true;
        }

        /**
        *   source:letats.@0011.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "客户交单业务委托书";
			String tempfiles = "A:letats";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:letats.@0012.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBedgrp().getRec().setDocgrd(this.getLatp().getDocgrdm().encode());
			BigDecimal docamt=this.getLatp().getVals(this.getBedgrp().getRec().getDocamt());
			this.getBedgrp().getRec().setDocamt(docamt);
			
			this.getLatp().getPdfviw().callPDFComponent("","letats","出口融资申请书",1);
			//$\\sysmod.generatorPdf("","letats",stream,false );
			
			return true;
        }



        /**
        *   source:letats.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  this.getLatp().getBchcod();
			  this.getLatp().latdis();
			  
			  
			  this.getLatp().getDocgrdm().decode1(this.getBedgrp().getRec().getDocgrd());
			  if(TRUE.equals(this.getBedgrp().getRec().getBfds2()))
			  {
			    this.getLatp().setBfdset(this.getLatp().getBfdsure());
			    
			    
			  }
			  else
			  {
			    this.getLatp().setBfdset(this.getLatp().getRmks());
			    
			  }

			  if(!MdaUtils.isEmpty(ctx.absGet(Rmkmod.class).getOtext()))
			  {
			     // 处理历史备注信息
			    
			  }
			  
			  return true;
			}
			IModule bed = (IModule)ctx.restoreData("com.brilliance.letats.ref");
			if(!MdaUtils.isEmpty(bed))
			  this.getBedgrp().getRec().copyValue(bed);

			//IModule led = Platform.getModule($\\,$ledgrp\\rec);
			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("inr",this.getBedgrp().getRec().getPntinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance.letats.ref",this.getLedgrp().getRec());
			IModule led = (IModule)ctx.restoreData("com.brilliance.letats.ref");
			if(!MdaUtils.isEmpty(led))
			  this.getLedgrp().getRec().copyValue(led);

			ctx.getDaoSession().dbRead(this.getBedgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));
			this.getBedgrp().setAplnam(this.getSysmod().getPty().getNam());

			this.getLatp().getBchcod();

			this.getLatp().getDocgrdm().decode1(this.getBedgrp().getRec().getDocgrd());
			
			this.getLatp().getDocgrdm().setOthdoc(this.getBedgrp().getRec().getOthdoc());
			

			log.info("{}","default rule execute...");
			if(MdaUtils.isEmpty(this.getBedgrp().getRec().getCredat()))
			{
			  this.getBedgrp().getRec().setCredat(MdaUtils.today());
			  
			}
			this.getLatp().latdis();

			this.getLatp().setBfdset(this.getLatp().getRmks());
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt()))
			  MdaUtils.clear(this.getSysmod().getSpt());
			ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("frm","letate"));
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			{
			  this.getTrnmod().ordNew();
			}
			else
			{
			  String ordinr=this.getSysmod().getSpt().getOrdinr();
			  log.debug("{}","ordinr=:  "+ordinr);
			  //加载备注信息
			  this.getRmkmod().loadRemarkByOrd(ordinr);
			}
			
			

			
			

			return true;
        }












}