package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetcanVO;

import com.ceb.gjjs.mda.manager.module.Letmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Letp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证注销通知
*/
@Transaction(vo= LetcanVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letcan extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letcan.class);

        //test stream
        private IStream tesstm = new StreamImpl();
		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Letmod letmod;

		@BDGetter
		private Letp letp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Letcan()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLetp().setLedgrpHolder(()->this.getLedgrp());
           this.getLetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.lccamt");}
 				public void setValue(BigDecimal arg){Letcan.this.getLedgrp().getRec().setLccamt(arg);}
 				public BigDecimal getValue(){return Letcan.this.getLedgrp().getRec().getLccamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.bchcod");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.lcccur");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setLcccur(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getLcccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.inr");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setInr(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.ownref");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.ptyinr");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letcan.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letcan.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letcan.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letcan.@0008.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:letcan.@0009.script
        */
        @Rule(target="letp.xptslt",order=100)
        public boolean ruleLetpXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLetp().getXptqna().setRef(this.getLedgrp().getRec().getStlref());
			log.debug("{}","ref="+this.getLetp().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getLetp().getXptqna());
			

			return true;
        }



        /**
        *   source:letcan.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());
			/*
			  *由于灰显的部分无法拷贝，业务人员要求放开
			  *2010-03-01
			  Platform.disable($ledgrp\\rec\\stlref);
			  Platform.disable($ledgrp\\rec\\lccref);
			  Platform.disable($ledgrp\\rec\\opndat);
			  Platform.disable($ledgrp\\rec\\expdat);
			  Platform.disable($ledgrp\\rec\\shpdat);
			  Platform.disable($ledgrp\\ben\\pts\\extkey);
			  Platform.disable($ledgrp\\ben\\pts\\adrblk);
			  Platform.disable($letp\\benp\\sel);
			  Platform.disable($ledgrp\\isb\\pts\\extkey);
			  Platform.disable($ledgrp\\isb\\pts\\adrblk);
			  Platform.disable($letp\\isbp\\sel);
			  */
			

			return true;
        }

        /**
        *   source:letcan.@0007.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "出口信用证注销通知";
			String tempfiles="A:letcan";

			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().noticeAck(this.getLetp().getLetp04());

			return true;
        }

        /**
        *   source:letcan.@0010.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:letcan.@0011.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:letcan.@0012.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));
			ctx.getDaoSession().dbRead(this.getLedgrp().getApl().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","apl"));

			return true;
        }












}