package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetfrdVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Betmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证寄单项下杂项处理申请
*/
@Transaction(vo= LetfrdVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letfrd extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letfrd.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Betmod betmod;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Letfrd()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getBetmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetmod().setBedgrpHolder(()->this.getBedgrp());
           this.getBetmod().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getBedgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LE"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letfrd.this.getFieldPath("bedgrp.rec.docamt");}
 				public void setValue(BigDecimal arg){Letfrd.this.getBedgrp().getRec().setDocamt(arg);}
 				public BigDecimal getValue(){return Letfrd.this.getBedgrp().getRec().getDocamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("afdgrp.rec.bchcod");}
 				public void setValue(String arg){Letfrd.this.getAfdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letfrd.this.getAfdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("bedgrp.rec.doccur");}
 				public void setValue(String arg){Letfrd.this.getBedgrp().getRec().setDoccur(arg);}
 				public String getValue(){return Letfrd.this.getBedgrp().getRec().getDoccur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("afdgrp.rec.inr");}
 				public void setValue(String arg){Letfrd.this.getAfdgrp().getRec().setInr(arg);}
 				public String getValue(){return Letfrd.this.getAfdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("bedgrp.rec.ownref");}
 				public void setValue(String arg){Letfrd.this.getBedgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letfrd.this.getBedgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("bedgrp.rec.ptyinr");}
 				public void setValue(String arg){Letfrd.this.getBedgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letfrd.this.getBedgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letfrd.this.getFieldPath("bedgrp.rec.stlref");}
 				public void setValue(String arg){Letfrd.this.getBedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letfrd.this.getBedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letfrd.@0004.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getBedgrp()) && ctx.checkAll(this.getAfdgrp())))
			  return false;
			log.info("{}","sav200开始================" );
			this.getAfdgrp().getRec().setInr(Platform.sdbCounter("afd"));
			this.getAfdgrp().getRec().setObjtyp("bed");
			this.getAfdgrp().getRec().setObjinr(this.getBedgrp().getRec().getInr());
			if("3".equals(this.getAfdgrp().getRec().getApytyp()))
			{
			  this.getAfdgrp().getRec().setOprval(this.getBedgrp().getCur()+this.getBedgrp().getAmt());
			}
			else if("5".equals(this.getAfdgrp().getRec().getApytyp()))
			{
			  this.getAfdgrp().getRec().setOprval(MdaUtils.format(this.getBedgrp().getDat(),"yyMMdd"));
			}
			this.getAfdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			ctx.getDaoSession().dbInsert(this.getAfdgrp().getRec());
			log.info("{}", "sav200入库结束================" );
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================");

			return true;
        }

        /**
        *   source:letfrd.@0005.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","letfrd",stream,false );

			return true;
        }

        /**
        *   source:letfrd.@0010.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in  images 50 ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:letfrd.@0013.script
        */
        @Rule(target="betp.afdgrp.rec.bchcod",order=100)
        public boolean ruleBetpAfdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  this.getBedgrp().getRec().setBchcod(this.getAfdgrp().getRec().getBchcod());

			return true;
        }

        /**
        *   source:letfrd.@0014.script
        */
        @Rule(target="betp.afdgrp.rec.oprtyp",order=100)
        public boolean ruleBetpAfdgrpRecOprtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			oprtypInit();
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp2",oprtyp);
			if(!"0".equals(oprtyp))
			{
			  oprtxt = descriptipn;
			  this.getAfdgrp().getRec().setOprtxt(oprtxt);
			}
			

			return true;
        }

        /**
        *   source:letfrd.@0016.script
        */
        @Rule(target="betp.bedgrp.amt",order=100)
        public boolean ruleBetpBedgrpAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请或同意修改单据金额
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp2",oprtyp);
			if("8".equals(oprtyp) || "9".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBetp().getBedgrp().getCur()) && !MdaUtils.isEmpty(this.getBetp().getBedgrp().getAmt()))
			  {
			    oprtxt = descriptipn + "为" + this.getBetp().getBedgrp().getCur()+ this.getBetp().getBedgrp().getAmt();
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }
			}

			return true;
        }

        /**
        *   source:letfrd.@0017.script
        */
        @Rule(target="betp.bedgrp.dat",order=100)
        public boolean ruleBetpBedgrpDatN100(){
            IContext ctx = MdaEnv.getContext();
            
			//申请修改变更到期日
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			String oprtxt="";
			String descriptipn = MdaUtils.getCodetableLabel("apltyp2",oprtyp);
			if("12".equals(oprtyp) || "13".equals(oprtyp))
			{
			  if(!MdaUtils.isEmpty(this.getBetp().getBedgrp().getDat()))
			  {
			    oprtxt = descriptipn + "为" + MdaUtils.format(this.getBetp().getBedgrp().getDat(),"yyyy/MM/dd");
			    this.getAfdgrp().getRec().setOprtxt(oprtxt);
			    
			  }
			}

			return true;
        }

        /**
        *   source:letfrd.@0019.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getBetp().getPdfviw().callPDFComponent("","letfrd","出口寄单项下杂项处理申请书",1);

			return true;
        }

        /**
        *   source:letfrd.@0020.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "出口寄单项下杂项处理申请书";
			String tempfiles = "A:letatd";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }



        /**
        *   source:letfrd.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			log.debug("{}","in init 100 ");
			// List<CodetableItem> bchcod =$sysmod.getAndSetBchcodvals();
			// Platform.setValues($afdgrp\\rec\\bchcod,bchcod);
			// if(!Platform.isEmpty(bchcod)&&!$\\sysmod.sptIsLoaded("B")&&!$\\sysmod.sptIsLoaded("P"))
			//  $afdgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			
			
			
			
			
			this.getAfdgrp().getRec().setCredat(MdaUtils.today());
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getAfdgrp().getRec().getBchcod()))
			  {
			    
			  }
			  
			  this.oprtypInitForSPT();
			  return true;
			}
			IModule bed = (IModule)ctx.restoreData("com.brilliance.letfrd.ref");
			if(!MdaUtils.isEmpty(bed))
			  this.getBedgrp().getRec().copyValue(bed);

			//if(!"1".equals($sysmod\\pty\\ptytyp.getValue()))
			//Platform.clear($bedgrp\\rec\\ownref);
			
			this.getAfdgrp().getRec().setBchcod(this.getBedgrp().getRec().getBchcod()) ;
			//Platform.disable($afdgrp\\rec\\bchcod);
			ctx.getDaoSession().dbRead(this.getBedgrp().getApl().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getBedgrp().getBen().getPts(),new Argument<String>("objinr",this.getBedgrp().getRec().getInr()),new Argument<String>("objtyp","bed"),new Argument<String>("rol","ben"));
			this.getAfdgrp().getRec().setOprtyp("0");
			//Platform.disable($bedgrp\\cur);
			//Platform.disable($bedgrp\\amt);
			//Platform.disable($bedgrp\\dat);
			//$bedgrp\\cur.setValue("USD");
			
			return true;
        }

        /**
        *   source:letfrd.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp2"));
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			oprtypInit();
			log.debug("{}","bchcod Value ======"+this.getAfdgrp().getRec().getBchcod());
			log.info("{}","bchcod="+this.getAfdgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getAfdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			  else
			    this.getAfdgrp().getRec().setBchcod(this.getBedgrp().getRec().getBchcod());
			  log.info("{}","bchcod="+this.getBedgrp().getRec().getBchcod());
			}
			

			return true;
        }


        /**
        *   source:letfrd.@0009.script
        */
        public void oprtypInit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			/* if("0".equals(oprtyp))
			  {
			  //无操作
			  Platform.invisible($bedgrp\\oprlabel);
			  Platform.invisible($bedgrp\\cur);
			  Platform.invisible($bedgrp\\amt);
			  Platform.invisible($bedgrp\\dat);
			  }
			  else if("8".equals(oprtyp)  ||  "9".equals(oprtyp))
			  */
			if("8".equals(oprtyp)  ||  "9".equals(oprtyp))
			{
			  //申请/同意修改单据金额
			  this.getBedgrp().setOprlabel(MdaUtils.getI18NString("letfrd","CT000023"));
			  
			  this.getBedgrp().setCur(this.getBetp().getBedgrp().getRec().getDoccur());
			  
			  
			  
			}
			else if("12".equals(oprtyp)  ||  "13".equals(oprtyp))
			{
			  //申请/同意变更到期日
			  this.getBedgrp().setOprlabel(MdaUtils.getI18NString("letfrd","CT000024"));
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  this.getAfdgrp().getRec().setOprtxt(NULLSTR);
			}
			this.getBedgrp().setDat(null);
			this.getBedgrp().setAmt(new BigDecimal(0));
			
			
			
			
			
		}
        /**
        *   source:letfrd.@0018.script
        */
        public void oprtypInitForSPT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			if("8".equals(oprtyp)  ||  "9".equals(oprtyp))
			{
			  //申请/同意修改单据金额
			  
			  
			  
			  
			}
			else if("12".equals(oprtyp)  ||  "13".equals(oprtyp))
			{
			  //申请/同意变更到期日
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
		}










}