package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetfreVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证杂项处理申请入口
*/
@Transaction(vo= LetfreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letfre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letfre.class);

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Letfre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:letfre.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			log.info("{}","seltyp=="+ seltyp);
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  
			  
			  //queryClause = "SELECT led.inr trsinr,led.stlref ref,led.advdat dat,led.lcccur cur,led.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM led,pts,adr,pta WHERE led.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'led' AND pts.objinr = led.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM led rec,pts s WHERE s.rol = 'apl' "
			    +"AND s.objtyp = 'led' AND s.objinr = rec.inr "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}
			else if("2".equals(seltyp))
			{
			  //出口信用证寄单通知
			  
			  
			  //queryClause = "SELECT bed.inr trsinr,bed.stlref ref,bed.advdat dat,bed.doccur cur,bed.docamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM bed,pts,adr,pta WHERE bed.docflg = 'docadv' AND pts.rol = 'apl' AND pts.objtyp = 'bed' AND pts.objinr = bed.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  //"WHERE docflg = 'docadv'";
			  queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.doccur cur,rec.docamt amt,substr(s.adrblk,0,35) aplnam  "
			    +"FROM bed rec,pts s WHERE s.rol = 'apl' AND s.objtyp = 'bed' AND s.objinr = rec.inr AND rec.stlref not like '%BX%' "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn1(queryClause);
			}
			
			

			return true;
        }

        /**
        *   source:letfre.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  this.getSelp().sureBtn("ledgrp","letfrc");
			}
			else if("2".equals(seltyp))
			{
			  //出口信用证寄单通知
			  this.getSelp().sureBtn1("bedgrp","letfrd");
			}

			return true;
        }

        /**
        *   source:letfre.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
              //出口信用证来证通知
			this.getSelp().sureBtn("ledgrp","letfrc");


			return true;
        }

        /**
        *   source:letfre.@0004.script
        */
        @Rule(target="selp.tmplst1",order=100)
        public boolean ruleSelpTmplst1N100(){
            IContext ctx = MdaEnv.getContext();
               //出口信用证寄单通知
			this.getSelp().sureBtn1("bedgrp","letfrd");


			return true;
        }



        /**
        *   source:letfre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selletfre"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT led.inr trsinr,led.stlref ref,led.advdat dat,led.lcccur cur,led.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM led,pts,adr,pta WHERE led.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'led' AND pts.objinr = led.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			
			
			String queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM led rec,pts s WHERE s.rol = 'apl' "
			  +"AND s.objtyp = 'led' AND s.objinr = rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }








}