package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetzreVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Lzdgrp;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-转让信用证入口
*/
@Transaction(vo= LetzreVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letzre extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letzre.class);

		@BDGetter
		private Lzdgrp lzdgrp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Sysmod sysmod;


		public Letzre()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:letzre.@0001.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  sureLed("ledgrp","letzrr");
			}


			return true;
        }

        /**
        *   source:letzre.@0002.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
              //出口信用证来证通知
			sureLed("ledgrp","letzrr");


			return true;
        }

        /**
        *   source:letzre.@0003.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String seltyp = this.getSelp().getSeltyp();
			log.info("{}","seltyp=="+ seltyp);
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //出口信用证来证通知
			  //queryClause = "SELECT led.inr trsinr,led.stlref ref,led.advdat dat,led.lcccur cur,led.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM led,pts,adr,pta WHERE led.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'led' AND pts.objinr = led.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			  queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM led rec,pts s WHERE s.rol = 'apl' "
			    +"AND s.objtyp = 'led' AND s.objinr = rec.inr "
			    +ctx.absGet(Sysmod.class).getSelection();
			  this.getSelp().queryBtn(queryClause);
			}
			


			return true;
        }



        /**
        *   source:letzre.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selletzrr"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT led.inr trsinr,led.stlref ref,led.advdat dat,led.lcccur cur,led.lccamt amt,pts.nam aplnam,adr.adr apladr,adr.tel apltel,adr.fax aplfax FROM led,pts,adr,pta WHERE led.flg = '2' AND pts.rol = 'apl' AND pts.objtyp = 'led' AND pts.objinr = led.inr AND pta.inr = pts.ptainr AND adr.inr = pta.objinr";
			String queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM led rec,pts s WHERE s.rol = 'apl' "
			  +"AND s.objtyp = 'led' AND s.objinr = rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }


        /**
        *   source:letzre.@0005.script
        */
        public void sureLed(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("letzre","CT000000"),MdaUtils.getI18NString("letzre","CT000001"));
			  return;
			}
			String lcrtyp="IRREVOCABLE TRANSFERABLE";
			//String str=Platform.dbRead($ledgrp\\rec\\lcrtyp,new Argument<String>("inr",$selp\\tmplst[index]\\trsinr.getValue()));
			//String con=Platform.dbRead($ledgrp\\rec\\convey,new Argument<String>("inr",$selp\\tmplst[index]\\trsinr.getValue()));
			ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("inr",this.getSelp().getTmplst().getElement(index).getTrsinr()));
			String str=this.getLedgrp().getRec().getLcrtyp();
			if(!lcrtyp.equals(str))
			{
			  ctx.setMessage(MdaUtils.getI18NString("letzre","CT000002"),MdaUtils.getI18NString("letzre","CT000003"));
			  //Platform.showMainPanel();
			  flush();
			  //return false;
			}
			else if("1".equals(this.getLedgrp().getRec().getConvey()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("letzre","CT000004"),MdaUtils.getI18NString("letzre","CT000005"));
			  flush();
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			else
			{
			  IModule grp = MdaDriver.getModule(this,ctx.getRoot(),grpNam+"\\rec");
			  ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getSelp().getTmplst().getElement(index).getTrsinr()));
			  ctx.getErrorCode();

			  ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			  
			}
		}
        /**
        *   source:letzre.@0006.script
        */
        public void flush()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String queryClause = "SELECT distinct rec.inr trsinr,rec.stlref ref,rec.advdat dat,rec.lcccur cur,rec.lccamt amt,substr(s.adrblk,0,35) aplnam FROM led rec,pts s WHERE s.rol = 'apl' "
			  +"AND s.objtyp = 'led' AND s.objinr = rec.inr "
			  +ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);
		}







}