package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetzrnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Lztmod;
import com.ceb.gjjs.mda.manager.module.Lztp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Lzdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-转让信用证通知
*/
@Transaction(vo= LetzrnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letzrn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letzrn.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Lzdgrp lzdgrp;

		@BDGetter
		private Lztmod lztmod;

		@BDGetter
		private Lztp lztp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Letzrn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLztmod().setLzdgrpHolder(()->this.getLzdgrp());
           this.getLztmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLztp().setLzdgrpHolder(()->this.getLzdgrp());
           this.getLztp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getLzdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrn.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letzrn.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letzrn.this.getLedgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrn.this.getFieldPath("lzdgrp.rec.ptyinr");}
 				public void setValue(String arg){Letzrn.this.getLzdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letzrn.this.getLzdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrn.this.getFieldPath("lzdgrp.rec.objinr");}
 				public void setValue(String arg){Letzrn.this.getLzdgrp().getRec().setObjinr(arg);}
 				public String getValue(){return Letzrn.this.getLzdgrp().getRec().getObjinr();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrn.this.getFieldPath("lzdgrp.rec.bchcod");}
 				public void setValue(String arg){Letzrn.this.getLzdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letzrn.this.getLzdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrn.this.getFieldPath("lzdgrp.rec.ownref");}
 				public void setValue(String arg){Letzrn.this.getLzdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letzrn.this.getLzdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
        }



        /**
        *   source:letzrn.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:letzrn.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck( this.getLztp().getLetzrn());

			return true;
        }











}