package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LetzrrVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Lztmod;
import com.ceb.gjjs.mda.manager.module.Lztp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Lzdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口信用证来证-转让信用证
*/
@Transaction(vo= LetzrrVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Letzrr extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Letzrr.class);

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Lzdgrp lzdgrp;

		@BDGetter
		private Lztmod lztmod;

		@BDGetter
		private Lztp lztp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Letzrr()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLztmod().setLzdgrpHolder(()->this.getLzdgrp());
           this.getLztmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLztp().setLzdgrpHolder(()->this.getLzdgrp());
           this.getLztp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setRecHolder(()->this.getLzdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.zrrcur");}
 				public void setValue(String arg){Letzrr.this.getLzdgrp().getRec().setZrrcur(arg);}
 				public String getValue(){return Letzrr.this.getLzdgrp().getRec().getZrrcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.zrramt");}
 				public void setValue(BigDecimal arg){Letzrr.this.getLzdgrp().getRec().setZrramt(arg);}
 				public BigDecimal getValue(){return Letzrr.this.getLzdgrp().getRec().getZrramt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.ownref");}
 				public void setValue(String arg){Letzrr.this.getLzdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Letzrr.this.getLzdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.bchcod");}
 				public void setValue(String arg){Letzrr.this.getLzdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Letzrr.this.getLzdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.inr");}
 				public void setValue(String arg){Letzrr.this.getLzdgrp().getRec().setInr(arg);}
 				public String getValue(){return Letzrr.this.getLzdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("lzdgrp.rec.ptyinr");}
 				public void setValue(String arg){Letzrr.this.getLzdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Letzrr.this.getLzdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Letzrr.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Letzrr.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Letzrr.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:letzrr.@0002.script
        */
        @Rule(target="lzdgrp.rec.isrep",order=100)
        public boolean ruleLzdgrpRecIsrepN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLzdgrp().getRec().getIsrep()))
			{
			  this.getLzdgrp().getRec().setNotrep("");
			  
			}
			else
			{
			  
			}
			


			return true;
        }

        /**
        *   source:letzrr.@0003.script
        */
        @Rule(target="lzdgrp.rec.notrep",order=100)
        public boolean ruleLzdgrpRecNotrepN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLzdgrp().getRec().getNotrep()))
			{
			  this.getLzdgrp().getRec().setIsrep("");
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:letzrr.@0004.script
        */
        @Rule(target="lzdgrp.rec.isalt",order=100)
        public boolean ruleLzdgrpRecIsaltN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLzdgrp().getRec().getIsalt()))
			{
			  
			  
			  
			  
			  
			  
			  
			  //Platform.enable($lzdgrp\\rec\\qtdata);
			}
			else
			{
			  this.getLzdgrp().getRec().setDjjamt(new BigDecimal(0));
			  this.getLzdgrp().getRec().setSlnumb(NULLSTR);
			  this.getLzdgrp().getRec().setShpdat(null);
			  this.getLzdgrp().getRec().setExpplc(NULLSTR);
			  this.getLzdgrp().getRec().setExpdat(null);
			  this.getLzdgrp().getRec().setPrepers18(NULLSTR);
			  this.getLzdgrp().getRec().setTbblmt(NULLSTR);
			  //Platform.clear($lzdgrp\\rec\\qtdata);
			
			  this.getLzdgrp().getRec().setDjjamt(this.getLedgrp().getRec().getDjjamt());
			  this.getLzdgrp().getRec().setSlnumb(this.getLedgrp().getRec().getSlnumb());
			  this.getLzdgrp().getRec().setShpdat(this.getLedgrp().getRec().getShpdat());
			  this.getLzdgrp().getRec().setExpdat(this.getLedgrp().getRec().getExpdat());
			  this.getLzdgrp().getRec().setExpplc(this.getLedgrp().getRec().getExpplc());
			  this.getLzdgrp().getRec().setPrepers18(this.getLedgrp().getRec().getPrepers18());
			  this.getLzdgrp().getRec().setTbblmt(this.getLedgrp().getRec().getTbblmt());

			  
			  
			  
			  
			  
			  
			  
			  //Platform.disable($lzdgrp\\rec\\qtdata);
			}
			
			
			
			
			
			
			
			//Platform.setModified($lzdgrp\\rec\\qtdata);
			
			return true;
        }

        /**
        *   source:letzrr.@0005.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!(ctx.checkAll(this.getLzdgrp())))
			{
			  log.warn("{}","页面校验未通过，退出");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getLzdgrp().getRec().getIsrep())&&MdaUtils.isEmpty(this.getLzdgrp().getRec().getNotrep()))
			{
			  ctx.setFieldError(this,"lzdgrp.rec.isrep",MdaUtils.getI18NString("letzrr","CT000014"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getLzdgrp().getRec().getSm2())&&MdaUtils.isEmpty(this.getLzdgrp().getRec().getSm3()))
			{
			  ctx.setFieldError(this,"lzdgrp.rec.sm2",MdaUtils.getI18NString("letzrr","CT000015"));
			  return false;
			}
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLzdgrp().getRec());
			}
			else
			{
			  /*
			    if(Platform.isEmpty($ledgrp\\rec\\inr))
			    {
			    Platform.dbRead($ledgrp\\rec,new Argument<String>("stlref",$ledgrp\\rec\\stlref.getValue()),new Argument<String>("lccref",$ledgrp\\rec\\lccref.getValue()));
			    }
			    if("1".equals($ledgrp\\rec\\convey.getValue()))
			    {
			    Platform.message(#CT000030,#CT000031);
			    return false;
			    }
			    else
			    {*/
			  this.getLzdgrp().getRec().setInr(Platform.sdbCounter("lzd"));
			  this.getLzdgrp().getRec().setObjinr(this.getLedgrp().getRec().getInr());
			  this.getLzdgrp().getRec().setStlref(this.getLedgrp().getRec().getStlref());
			  this.getLzdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			  ctx.getDaoSession().dbInsert(this.getLzdgrp().getRec());

			  this.getLedgrp().getRec().setConvey("1");
			  ctx.getDaoSession().dbUpdate(this.getLedgrp().getRec());
			  //}
			}

			if(!this.getTrnmod().trnSetFromContract())return false;
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:letzrr.@0006.script
        */
        @Rule(target="lzdgrp.rec.zrramm",order=100)
        public boolean ruleLzdgrpRecZrrammN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getLcccur())||MdaUtils.isEmpty(this.getLedgrp().getRec().getLccamt()))
			{
			  ctx.setFieldError(this,"lzdgrp.rec.zrramm",MdaUtils.getI18NString("letzrr","CT000004"));
			  this.getLzdgrp().getRec().setZrramm(NULLSTR);
			}
			else
			{
			  this.getLzdgrp().getRec().setZrrcur(this.getLedgrp().getRec().getLcccur());
			  this.getLzdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());
			  if("3".equals(this.getLzdgrp().getRec().getZrramm()))
			  {
			    //Platform.enable($lztgrp\\rec\\zrcur);
			    //$lztgrp\\rec\\zrcur.setValue($lztgrp\\rec\\lzzcur.getValue());
			    
			    
			  }
			  else
			  {
			    //Platform.clear($lztgrp\\rec\\zrcur);
			    //Platform.clear($lztgrp\\rec\\zramt);
			    this.getLzdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());
			    
			    
			  }
			}
			
			
			

			return true;
        }

        /**
        *   source:letzrr.@0007.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","letzrr",stream,false );

			return true;
        }

        /**
        *   source:letzrr.@0009.script
        */
        @Rule(target="lzdgrp.rec.sm2",order=100)
        public boolean ruleLzdgrpRecSm2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLzdgrp().getRec().getSm2()))
			{
			  this.getLzdgrp().getRec().setSm3("");
			}
			
			

			return true;
        }

        /**
        *   source:letzrr.@0010.script
        */
        @Rule(target="lzdgrp.rec.sm3",order=100)
        public boolean ruleLzdgrpRecSm3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLzdgrp().getRec().getSm3()))
			{
			  this.getLzdgrp().getRec().setSm2("");
			}
			
			

			return true;
        }

        /**
        *   source:letzrr.@0013.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "不可撤销跟单信用证转让委托书";
			String tempfiles = "A:letzrr";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }


        /**
        *   source:letzrr.@0008.script
        */
        @Check(target="lzdgrp.rec.zrramt",order=100)
        public boolean checkLzdgrpRecZrramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getLzdgrp().getRec().getZrramm())&&MdaUtils.isEmpty(this.getLzdgrp().getRec().getZrramt()))
			{
			  ctx.setFieldError(this,"lzdgrp.rec.zrramm",MdaUtils.getI18NString("letzrr","CT000001"));
			  return true;
			}

			BigDecimal camt = this.getLedgrp().getRec().getLccamt();
			BigDecimal lamt = this.getLzdgrp().getRec().getZrramt();
			if(camt.compareTo(lamt)<0)
			  ctx.setFieldError(this,"lzdgrp.rec.zrramt",MdaUtils.getI18NString("letzrr","CT000009"));

			return true;
        }

        /**
        *   source:letzrr.@0012.script
        */
        @Check(target="lzdgrp.rec.zrramm",order=100)
        public boolean checkLzdgrpRecZrrammN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!"3".equals($lzdgrp\\rec\\zramm.getValue())&&!($ledgrp\\rec\\lccamt.getValue().equals($lzdgrp\\rec\\zramt.getValue())))
			  {
			  Platform.error($lzdgrp\\rec\\zramm,#CT000033);
			  }*/

			return true;
        }


        /**
        *   source:letzrr.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getLzdgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getLzdgrp().getRec().getBchcod()))
			  {
			    
			  }
			  
			  this.getLztp().disLzt();
			  if("3".equals(this.getLzdgrp().getRec().getZrramm()))
			  {
			    
			    
			  }
			  return true;
			}

			IModule led = (IModule)ctx.restoreData("com.brilliance.letzrr.ref");
			if(!MdaUtils.isEmpty(led))
			  this.getLedgrp().getRec().copyValue(led);

			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLzdgrp().getRec(),"bchcod",bchcod);
			this.getLzdgrp().getRec().setBchcod(this.getLedgrp().getRec().getBchcod()) ;
			if(!MdaUtils.isEmpty(this.getLzdgrp().getRec().getBchcod()))
			{
			  
			}
			

			this.getLzdgrp().setAplnam(this.getSysmod().getPty().getNam());

			//Platform.dbRead($lzdgrp\\apl\\pts,new Argument<String>("objinr",$ledgrp\\rec\\inr.getValue()),new Argument<String>("objtyp","led"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getLzdgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));

			String lcrtyp="IRREVOCABLE TRANSFERABLE";
			String str=this.getLedgrp().getRec().getLcrtyp();
			log.info("{}","lcrtyp:  "+str);
			//Pattern pattern=Pattern.compile(lcrtyp);
			//Matcher matcher = pattern.matcher(str);
			// if(!($\\sysmod.sptIsLoaded("B")  ||  $\\sysmod.sptIsLoaded("P")  ||  $\\sysmod.sptIsLoaded("T")))
			//{
			if(!lcrtyp.equals(str))
			{
			  ctx.setMessage(MdaUtils.getI18NString("letzrr","CT000020"),MdaUtils.getI18NString("letzrr","CT000021"));
			  
			}

			this.getLzdgrp().getRec().setDjjamt(this.getLedgrp().getRec().getDjjamt());
			this.getLzdgrp().getRec().setSlnumb(this.getLedgrp().getRec().getSlnumb());
			this.getLzdgrp().getRec().setShpdat(this.getLedgrp().getRec().getShpdat());
			this.getLzdgrp().getRec().setExpdat(this.getLedgrp().getRec().getExpdat());
			this.getLzdgrp().getRec().setExpplc(this.getLedgrp().getRec().getExpplc());
			this.getLzdgrp().getRec().setPrepers18(this.getLedgrp().getRec().getPrepers18());
			this.getLzdgrp().getRec().setTbblmt(this.getLedgrp().getRec().getTbblmt());

			this.getLzdgrp().getRec().setZrrcur(this.getLedgrp().getRec().getLcccur());
			this.getLzdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());

			this.getLztp().disLzt();
			this.getSysmod().setTrntiltle(ctx.getTransName());
			log.debug("{}","Trntiltle="+this.getSysmod().getTrntiltle());


			return true;
        }











}