package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证修改申请
*/
@Transaction(vo= LitameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litame.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.issameamt");}
 				public void setValue(BigDecimal arg){Litame.this.getLidgrp().getRec().setIssameamt(arg);}
 				public BigDecimal getValue(){return Litame.this.getLidgrp().getRec().getIssameamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litame.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litame.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litame.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litame.@0003.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","sav200开始,trnmod bchcod = "+this.getTrnmod().getBchcod());
			if(!ctx.checkAll(this.getLidgrp()))
			  return false;

			//对页面内容进行校验,增加校验
			if((MdaUtils.isEmpty(this.getLidgrp().getMben().getPts().getAdrblk()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getExpamedat()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamedat()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamefro()))&&
			  (MdaUtils.isEmpty(this.getLidgrp().getRec().getPorameloa()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getPoramedis()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpameto()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getIncamt()))&&
			(MdaUtils.isEmpty(this.getLidgrp().getRec().getDecamt()))&&(MdaUtils.isEmpty(this.getLidgrp().getBlk().getAddgod()))&&(MdaUtils.isEmpty(this.getLidgrp().getBlk().getOthamedet()))&&(MdaUtils.isEmpty(this.getLidgrp().getBlk().getAmetxt())))
			{
			  ctx.setMessage(MdaUtils.getI18NString("litame","CT000066"),MdaUtils.getI18NString("litame","CT000067"));
			  return false;
			}

			//更新原记录
			ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());
			String objinr = this.getLidgrp().getRec().getInr();
			String objtyp = "lid";
			String lccgod = this.getLidgrp().getBlk().getLcrgod()+this.getLitp().getAddgod();
			this.getLidgrp().getBlk().setLcrgod(lccgod);
			if(this.getSysmod().sptIsLoaded("B"))
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getMben().getPts(),objinr);
			else
			  this.getLidgrp().getMben().savpts(objinr,objtyp);
			//trnBegin-->
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束!" );

			return true;
        }

        /**
        *   source:litame.@0004.script
        */
        @Rule(target="lidgrp.rec.incamt",order=100)
        public boolean ruleLidgrpRecIncamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","incamt的default校验==============");
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getIncamt()))
			{
			  this.getLidgrp().getRec().setDecamt(new BigDecimal("0"));
			  BigDecimal tmp = (this.getLidgrp().getRec().getIssamt()).add(this.getLidgrp().getRec().getIncamt());
			  this.getLitp().setTepaam(tmp);
			  this.getLidgrp().getRec().setIssameamt(tmp);
			  
			  
			  
			}
			else if(MdaUtils.isEmpty(this.getLidgrp().getRec().getDecamt())&&MdaUtils.isEmpty(this.getLidgrp().getRec().getIncamt()))
			{
			  this.getLidgrp().getRec().setIssameamt(this.getLidgrp().getRec().getIssamt());
			  this.getLitp().setTepaam(new BigDecimal("0"));
			  
			  
			}

			return true;
        }

        /**
        *   source:litame.@0005.script
        */
        @Rule(target="lidgrp.rec.decamt",order=100)
        public boolean ruleLidgrpRecDecamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","decamt的default校验==============");

			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getDecamt()))
			{
			  this.getLidgrp().getRec().setIncamt(new BigDecimal("0"));
			  this.getLitp().setTepaam(new BigDecimal("0"));
			  BigDecimal tmp = (this.getLidgrp().getRec().getIssamt()).subtract(this.getLidgrp().getRec().getDecamt());
			  log.info("{}",tmp.longValue()+">0?"+(tmp.longValue()>0));
			  if(tmp.doubleValue()>0)
			  {
			    this.getLidgrp().getRec().setIssameamt(tmp);
			  }
			  else
			  {
			    this.getLidgrp().getRec().setDecamt(new BigDecimal(0));
			    ctx.setFieldError(this,"lidgrp.rec.decamt",MdaUtils.getI18NString("litame","CT000051"));
			  }
			  //$litp\\tepaam.setValue($lidgrp\\rec\\issameamt.getValue());
			  
			  
			  
			  
			}
			else if(MdaUtils.isEmpty(this.getLidgrp().getRec().getDecamt())&&MdaUtils.isEmpty(this.getLidgrp().getRec().getIncamt()))
			{
			  this.getLidgrp().getRec().setIssameamt(this.getLidgrp().getRec().getIssamt());
			  
			}

			return true;
        }

        /**
        *   source:litame.@0006.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            

			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","litame",stream,false );

			return true;
        }

        /**
        *   source:litame.@0007.script
        */
        @Rule(target="lidgrp.rec.amenbr",order=100)
        public boolean ruleLidgrpRecAmenbrN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:litame.@0011.script
        */
        @Rule(target="mtabut.mail",order=150)
        public boolean ruleMtabutMailN150(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("litameApp"+inr,"litame");
			this.getMtabut().creatTcoPdfFile("litameDra"+inr);
			this.getMtabut().setAttnames("litameApp"+inr+".pdf;litameDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:litame.@0013.script
        */
        @Rule(target="mtabut.imgtp.images",order=50)
        public boolean ruleMtabutImgtpImagesN50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in evt litame.mtabut.imgtp.images ... ");
			log.debug("{}","imgref=" +this.getSysmod().getSpt().getImgref());
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getImgref()) && MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			{
			  this.getMtabut().getImgtp().getImageReference();
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getMtabut().getImgtp().getDztimgref()))
			  {
			    this.getMtabut().getImgtp().setDztimgref(this.getSysmod().getSpt().getImgref());
			  }
			}
			log.debug("{}","生成的影像批次号为：" + this.getMtabut().getImgtp().getDztimgref());

			return true;
        }

        /**
        *   source:litame.@0015.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litame","信用证修改",1);

			return true;
        }

        /**
        *   source:litame.@0016.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 2;
			String labels = "进口信用证修改申请,进口信用证修改报文草稿";
			String tempfiles = "A:litame,S:litame";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();

			return true;
        }

        /**
        *   source:litame.@0022.script
        */
        @Rule(target="mtabut.sftdra",order=100)
        public boolean ruleMtabutSftdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callSwiftPDFComponent("","litame","信用证修改",1);

			return true;
        }

        /**
        *   source:litame.@0023.script
        */
        @Rule(target="mtabut.csche",order=100)
        public boolean ruleMtabutCscheN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litame","信用证修改",1);

			return true;
        }

        /**
        *   source:litame.@0024.script
        */
        @Rule(target="mtabut.draftmsg",order=100)
        public boolean ruleMtabutDraftmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callSwiftPDFComponent("","litame","信用证修改",1);

			return true;
        }

        /**
        *   source:litame.@0028.script
        */
        @Rule(target="litp.lidgrp.flbz",order=100)
        public boolean ruleLitpLidgrpFlbzN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getFlbz()))
			{
			  
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAddfee(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:litame.@0029.script
        */
        @Rule(target="litp.lidgrp.sxf",order=100)
        public boolean ruleLitpLidgrpSxfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getSxf()))
			{
			  
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAmefee(new BigDecimal(0));
			}
			

			return true;
        }

        /**
        *   source:litame.@0030.script
        */
        @Rule(target="litp.tipurl",order=100)
        public boolean ruleLitpTipurlN100(){
            IContext ctx = MdaEnv.getContext();
            
			String url="";
			MdaUtils.invoke("client:","opentab",url);

			return true;
        }


        /**
        *   source:litame.@0001.script
        */
        @Check(target="lidgrp.rec.shpamedat",order=100)
        public boolean checkLidgrpRecShpamedatN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","shpamedat的check校验======");
			this.getLitp().setAmeshpflg("1");
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamedat())&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamedat())))
			{
			  this.getLitp().setAmeshpflg("2");
			  return true;
			}
			/*
			  if(Platform.diff($lidgrp\\rec\\shpamedat.getValue(),$lidgrp\\rec\\expdat.getValue())<0)
			  Platform.error($lidgrp\\rec\\shpamedat,#CT000000);
			  else if(!Platform.isEmpty($lidgrp\\rec\\expamedat) && Platform.diff($lidgrp\\rec\\shpamedat.getValue(),$lidgrp\\rec\\expamedat.getValue())>0)
			  */
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpamedat()) && MdaUtils.diff(this.getLidgrp().getRec().getShpamedat(),this.getLidgrp().getRec().getExpamedat())>0)
			{
			  ctx.setFieldError(this,"lidgrp.rec.shpamedat",MdaUtils.getI18NString("litame","CT000001"));
			  this.getLitp().setAmeshpflg("1");
			}
			

			return true;
        }

        /**
        *   source:litame.@0002.script
        */
        @Check(target="lidgrp.rec.expamedat",order=100)
        public boolean checkLidgrpRecExpamedatN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().setAmeshpflg("1");
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getExpamedat())&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamedat())))
			{
			  this.getLitp().setAmeshpflg("2");
			  return true;
			}
			/*
			  if(Platform.isEmpty($lidgrp\\rec\\shpamedat) && Platform.isEmpty($lidgrp\\rec\\shpdat))
			  return;
			  else if(Platform.isEmpty($lidgrp\\rec\\shpamedat) && (Platform.diff($lidgrp\\rec\\shpdat.getValue(), $lidgrp\\rec\\expamedat.getValue())>0))
			  */
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getShpamedat()) && (MdaUtils.diff(this.getLidgrp().getRec().getExpamedat(),this.getLidgrp().getRec().getShpamedat())<0))
			{
			  ctx.setFieldError(this,"lidgrp.rec.expamedat",MdaUtils.getI18NString("litame","CT000035"));
			  this.getLitp().setAmeshpflg("1");
			}
			

			return true;
        }

        /**
        *   source:litame.@0018.script
        */
        @Check(target="litp.lidgrp.rec.incamt",order=100)
        public boolean checkLitpLidgrpRecIncamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIncamt()))
			{
			  this.getLitp().setAmeincflg("2");
			  return true;
			}
			else
			{
			  this.getLitp().setAmeincflg("1");
			  this.getLitp().setAmedecflg("2");
			}
			
			

			return true;
        }

        /**
        *   source:litame.@0019.script
        */
        @Check(target="litp.lidgrp.rec.decamt",order=100)
        public boolean checkLitpLidgrpRecDecamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getDecamt()))
			{
			  this.getLitp().setAmedecflg("2");
			  return true;
			}
			else
			{
			  this.getLitp().setAmedecflg("1");
			  this.getLitp().setAmeincflg("2");
			}

			
			

			return true;
        }

        /**
        *   source:litame.@0020.script
        */
        @Check(target="litp.lidgrp.blk.addgod",order=100)
        public boolean checkLitpLidgrpBlkAddgodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getAddgod()))
			{
			  this.getLitp().setAmegodflg("2");
			  return true;
			}
			else
			{
			  this.getLitp().setAmegodflg("1");
			}
			

			return true;
        }

        /**
        *   source:litame.@0031.script
        */
        @Check(target="litp.lidgrp.rec.incamt",order=101)
        public boolean checkLitpLidgrpRecIncamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"incamt"));

			return true;
        }

        /**
        *   source:litame.@0032.script
        */
        @Check(target="litp.lidgrp.rec.decamt",order=101)
        public boolean checkLitpLidgrpRecDecamtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"incamt"));

			return true;
        }

        /**
        *   source:litame.@0033.script
        */
        @Check(target="litp.lidgrp.rec.amefee",order=100)
        public boolean checkLitpLidgrpRecAmefeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"amefee"));

			return true;
        }

        /**
        *   source:litame.@0034.script
        */
        @Check(target="litp.lidgrp.rec.addfee",order=100)
        public boolean checkLitpLidgrpRecAddfeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"addfee"));

			return true;
        }


        /**
        *   source:litame.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			
			
			
			if(this.getSysmod().sptIsLoaded("B"))
			{
			  
			  
			}
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.litame.ref");
			if(!MdaUtils.isEmpty(mdl))
			  this.getLidgrp().getRec().copyValue(mdl);
			log.info("{}","lidinr"+this.getLidgrp().getRec().getInr());
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","apl"));
			//Platform.errorCode();
			//$lidgrp\\dap.initDap("lid");
			//$lidgrp\\apl.copyValues($lidgrp\\dap);
			//$lidgrp\\apl\\pts\\rol.setValue("apl");
			if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPts().getRef()))
			  this.getLidgrp().getApl().getPts().setRef(this.getLidgrp().getRec().getStlref());
			this.getLidgrp().getRec().setCreamedat(MdaUtils.today());
			//Platform.clear($lidgrp\\rec\\ownref);
			
			
			
			
			
			ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","ben"));
			//Platform.setValues($lidgrp\\rec\\sndtyp,Platform.getCodetable("sndtyp"));
			
			
			
			
			
			
			//Platform.setValues($lidgrp\\rec\\chrgameby,Platform.getCodetable("chrgameby"));
			
			if(this.getSysmod().sptIsLoaded("B")  ||   this.getSysmod().sptIsLoaded("P")  ||  this.getSysmod().sptIsLoaded("T"))
			{
			  if(this.getSysmod().sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  Modules.postDefaultRule(this,"lidgrp");
			  ctx.postRule(this,"lidgrp.rec.incamt");
			  ctx.postRule(this,"lidgrp.rec.decamt");
			  return true;
			}
			//Platform.disable($lidgrp\\apl\\pts\\adrblk);
			ctx.getDaoSession().dbRead(this.getLidgrp().getBlk(),new Argument<String>("inr",this.getLidgrp().getRec().getInr()));
			this.getLidgrp().getRec().setSndtyp("1");
			this.getLidgrp().getRec().setChrgameby("1");
			this.getLidgrp().getApl().getPty().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			this.getLidgrp().getRec().setAmenbr(this.getLidgrp().getRec().getAmenbr()+1);
			this.getLidgrp().getRec().setIssameamt(this.getLidgrp().getRec().getIssamt());
			this.getLidgrp().getRec().setExpamedat(null);
			this.getLidgrp().getRec().setShpamedat(null);
			this.getLidgrp().getRec().setShpamefro(NULLSTR);
			this.getLidgrp().getRec().setPorameloa(NULLSTR);
			this.getLidgrp().getRec().setPoramedis(NULLSTR);
			this.getLidgrp().getRec().setShpameto(NULLSTR);
			this.getLidgrp().getRec().setIncamt(new BigDecimal(0));
			this.getLidgrp().getRec().setDecamt(new BigDecimal(0));
			this.getLidgrp().getBlk().setAddgod(NULLSTR);
			this.getLidgrp().getBlk().setOthamedet(NULLSTR);
			//$lidgrp\\apl\\pts\\nam.setValue($sysmod\\pty\\nam.getValue());
			
			return true;
        }

        /**
        *   source:litame.@0010.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getLidgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getIbchcod()))
			      this.getLidgrp().getRec().setBchcod(this.getLidgrp().getRec().getIbchcod());
			    else
			    {
			      this.getLidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getLidgrp().getRec().setIbchcod(this.getLidgrp().getRec().getBchcod());
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getDbchcod()))
			      this.getLidgrp().getRec().setBchcod(this.getLidgrp().getRec().getDbchcod());
			    else
			      this.getLidgrp().getRec().setDbchcod(this.getLidgrp().getRec().getBchcod());
			    
			  }

			  log.info("{}","bchocd="+this.getLidgrp().getRec().getBchcod()+",dbchocd="+this.getLidgrp().getRec().getDbchcod()+",ibchcod="+this.getLidgrp().getRec().getIbchcod());
			}
			ctx.postRule(this,"lidgrp.flbz");
			ctx.postRule(this,"lidgrp.sxf");

			return true;
        }











}