package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Litame0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证修改选择
*/
@Transaction(vo= Litame0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litame0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litame0.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Litame0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:litame0.@0001.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			//  +"rec.credat dat FROM lid rec  WHERE 1=1 "+$\\sysmod.getSelection();
			
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			  +"rec.opndat dat,s.adrblk bennam FROM lid rec,pts s "
			  +"WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'lid' AND s.objinr = rec.inr "
			  + ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:litame0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("lidgrp","litame");

			return true;
        }

        /**
        *   source:litame0.@0003.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("lidgrp","litame");

			return true;
        }



        /**
        *   source:litame0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("sellitame"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			// +"rec.credat dat FROM lid rec  WHERE 1=1 "+$\\sysmod.getSelection();
			// "WHERE stlref is not null and trim(stlref)<>'' ";
			//+"and rec.ptyinr='"+$sysmod\\pty\\inr+"'";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,"
			  +"rec.opndat dat,s.adrblk bennam FROM lid rec,pts s "
			  +"WHERE rec.flg in('1','2') AND s.rol = 'ben' AND s.objtyp = 'lid' "
			  +"AND s.objinr = rec.inr " + ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}