package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitapnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 开立进口信用证申请（综）
*/
@Transaction(vo= LitapnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litapn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litapn.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litapn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litapn.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litapn.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litapn.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litapn.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litapn.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litapn.@0001.script
        */
        @Rule(target="lidgrp.bxd.cgyd",order=100)
        public boolean ruleLidgrpBxdCgydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cgyd=this.getLidgrp().getBxd().getCgyd();
			if("1".equals(cgyd))
			{
			  this.getLidgrp().getBxd().setYs(0);
			  this.getLidgrp().getBxd().setBzjqcrq(null);
			  this.getLidgrp().getBxd().setBzjdqr(null);
			  
			  
			  
			}
			else if("2".equals(cgyd))
			{
			  
			  
			  
			  
			  
			  

			  
			  
			  
			}
			
			
			


			return true;
        }

        /**
        *   source:litapn.@0002.script
        */
        @Rule(target="lidgrp.bxd.jsyd",order=100)
        public boolean ruleLidgrpBxdJsydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jsyd=this.getLidgrp().getBxd().getJsyd();
			if(!MdaUtils.isEmpty(jsyd))
			{
			  if("5".equals(jsyd))
			  {
			    
			    
			    
			  }
			  else
			  {
			    this.getLidgrp().getBxd().setJsydqt(NULLSTR);
			    
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0003.script
        */
        @Rule(target="lidgrp.bxd.jxyd",order=100)
        public boolean ruleLidgrpBxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jxyd=this.getLidgrp().getBxd().getJxyd();
			log.debug("{}","计息约定："+jxyd);
			if("1".equals(jxyd))
			{//月利率
			  this.getLidgrp().getBxd().setNll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(jxyd))
			{//年利率
			  this.getLidgrp().getBxd().setYll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(jxyd))
			{//其他约定
			  this.getLidgrp().getBxd().setNll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setYll(new BigDecimal(0));
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litapn.@0004.script
        */
        @Rule(target="lidgrp.bxd.zyjjfs",order=100)
        public boolean ruleLidgrpBxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String zyjjfs=this.getLidgrp().getBxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getLidgrp().getBxd().setZcwyh(NULLSTR);
			  this.getLidgrp().getBxd().setKtdd(NULLSTR);
			  this.getLidgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  
			  
			  this.getLidgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getLidgrp().getBxd().setZcwyh(NULLSTR);
			  this.getLidgrp().getBxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litapn.@0005.script
        */
        @Rule(target="lidgrp.lxd.xyzqk",order=100)
        public boolean ruleLidgrpLxdXyzqkN100(){
            IContext ctx = MdaEnv.getContext();
            
			String xyzqk=this.getLidgrp().getLxd().getXyzqk();
			log.debug("{}","信用证属于情况:"+xyzqk);
			if("1".equals(xyzqk))
			{
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			else if("2".equals(xyzqk))
			{
			  this.getLidgrp().getLxd().setShhtbh(NULLSTR);
			  this.getLidgrp().getLxd().setSxhtmc(NULLSTR);
			  this.getLidgrp().getLxd().setShhtje(NULLSTR);
			  this.getLidgrp().getLxd().setXqqs(null);
			  this.getLidgrp().getLxd().setXqzz(null);

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			
			
			
			
			

			return true;
        }

        /**
        *   source:litapn.@0006.script
        */
        @Rule(target="lidgrp.lxd.zyjjfs",order=100)
        public boolean ruleLidgrpLxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String zyjjfs=this.getLidgrp().getLxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getLidgrp().getLxd().setCzwyh(NULLSTR);
			  this.getLidgrp().getLxd().setKtdd(NULLSTR);
			  this.getLidgrp().getLxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  
			  
			  this.getLidgrp().getLxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getLidgrp().getLxd().setCzwyh(NULLSTR);
			  this.getLidgrp().getLxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litapn.@0008.script
        */
        @Rule(target="lidgrp.rec.apprul",order=100)
        public boolean ruleLidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  //$lidgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getLidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:litapn.@0009.script
        */
        @Rule(target="lidgrp.rec.avbby",order=100)
        public boolean ruleLidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getLidgrp().getRec().getAvbby();
			log.debug("{}","on evt .onChange事件 .litapn.avbby...  avbby =" + avbby);
			if("1".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			}
			else if("2".equals(avbby))
			{
			  if(MdaUtils.isEmpty(this.getLidgrp().getUsapro())||"O".equals(this.getLidgrp().getUsapro()))
			  {
			    
			    
			    
			  }
			  else
			  {
			    
			  }
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  

			}
			else if("3".equals(avbby))
			{

			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  
			  
			  

			}
			else if("4".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");

			}
			else if("5".equals(avbby))
			{
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  

			}

			
			
			Modules.postDefaultRule(this,"lidgrp.blk.defdet");

			return true;
        }

        /**
        *   source:litapn.@0010.script
        */
        @Rule(target="lidgrp.rec.avbwths",order=100)
        public boolean ruleLidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  this.getLidgrp().getRec().setAvbwth(NULLSTR);
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:litapn.@0011.script
        */
        @Rule(target="lidgrp.rec.cnfflg",order=100)
        public boolean ruleLidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )  //MAY ADD
			this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for beneficiary's account.");
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )  //CONFIRM
			this.getLidgrp().getBlk().setCnfdet("confirm charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setCnfdet(NULLSTR);

			

			return true;
        }

        /**
        *   source:litapn.@0012.script
        */
        @Rule(target="lidgrp.rec.concur",order=100)
        public boolean ruleLidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			{
			  return true;
			}
			this.getLidgrp().getRec().setIsscur(this.getLidgrp().getRec().getConcur());
			

			return true;
        }

        /**
        *   source:litapn.@0013.script
        */
        @Rule(target="lidgrp.rec.nomflg",order=100)
        public boolean ruleLidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			{
			  //勾选
			  // Platform.setRequired($lidgrp\\rec\\nomtop);
			  // Platform.setRequired($lidgrp\\rec\\nomton);
			  
			  
			}
			else
			{
			  
			  
			}
			this.getLidgrp().getRec().setNomtop(0);
			this.getLidgrp().getRec().setNomton(0);
			
			

			return true;
        }

        /**
        *   source:litapn.@0014.script
        */
        @Rule(target="lidgrp.rec.sstdat",order=100)
        public boolean ruleLidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sstdat=this.getLidgrp().getRec().getSstdat();
			String sedday =this.getLidgrp().getRec().getSedday();
			String str1="Documents To Be Presented ";
			String str2=null;
			if(MdaUtils.isEmpty(sedday))
			{
			  str2="" ;
			}
			else
			{
			  str2="Within " + sedday + " Days";
			}
			if("3".equals(sstdat))
			{
			  this.getLidgrp().getRec().setSstdattxt("");
			  
			  
			  
			}
			else
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",sstdat));
			}
			
			this.getLidgrp().getRec().setPreper(str1+str2+" After The Date Of " + this.getLidgrp().getRec().getSstdattxt() + ",But Within The Validity Of The Credit.");
			log.debug("{}","----------sstdattxt----------"+this.getLidgrp().getRec().getSstdattxt());
			

			return true;
        }

        /**
        *   source:litapn.@0015.script
        */
        @Rule(target="lidgrp.rec.tenor",order=100)
        public boolean ruleLidgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tenor = this.getLidgrp().getRec().getTenor() ;
			if(!MdaUtils.isModified(this.getLidgrp().getBlk(),"dftat") && "S".equals(this.getLidgrp().getRec().getTenor()))
			{
			  this.getLidgrp().getBlk().setDftat("sight for 100 pct of the invoice value");
			}
			if("S".equals(tenor))
			{
			  this.getLidgrp().getRec().setUpsflg(NULLSTR);
			  
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			  

			  this.getLitp().getLidgrp().setTedays(0);
			  
			  

			  this.getLitp().getLidgrp().setUsapro(NULLSTR);
			  
			  
			}
			else if("U".equals(tenor))
			{
			  
			  
			  
			  
			  
			  

			}
			
			
			
			

			//即期远期，avbby对应码表不同
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);


			return true;
        }

        /**
        *   source:litapn.@0016.script
        */
        @Rule(target="lidgrp.rec.trdflg",order=100)
        public boolean ruleLidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getTrdflg()))
			{
			  this.getLidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2010");
			}
			else
			{
			  this.getLidgrp().getRec().setTrdtrmver(NULLSTR);
			}
			
			

			return true;
        }

        /**
        *   source:litapn.@0017.script
        */
        @Rule(target="lidgrp.rec.trfflg",order=100)
        public boolean ruleLidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getLidgrp().getRec().getTrfflg()))
			  this.getLidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setTrfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litapn.@0018.script
        */
        @Rule(target="lidgrp.rec.upsflg",order=100)
        public boolean ruleLidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			  this.getLidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litapn.@0034.script
        */
        @Rule(target="litp.lidgrp.rec.bchcod",order=100)
        public boolean ruleLitpLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:litapn.@0035.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//处理货描
			lcrgods();
			//处理其他单据
			adlcnds();
			String flags =this.getLidgrp().getRec().getMarginflg();
			String objinr =null;
			String objtyp = "lid";
			//删除模板
			this.getMtabut().getBusmod().dealFile();
			String scr=ctx.absGet(Sysmod.class).getSpt().getScr();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());
			  objinr =this.getLidgrp().getRec().getInr();
			  log.debug("{}","objinr=="+objinr );
			  //申请人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getApl().getPts(),objinr);
			  //收益人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getBen().getPts(),objinr);
			  //通知行
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getAdv().getPts(),objinr);
			  //付款人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getDre().getPts(),objinr);

			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getLxd());
			  if("0001".equals(flags))
			  {
			    this.getLitp().getBxdmod().updBxdAndMar();
			  }
			}
			else
			{
			  log.debug("{}","objinr=="+objinr );
			  this.getLidgrp().getRec().setInr(Platform.sdbCounter("lid"));
			  objinr =this.getLidgrp().getRec().getInr();
			  this.getLidgrp().getRec().setFlg("0");
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getRec());

			  this.getLidgrp().getBlk().setInr(objinr);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getBlk());

			  //申请人
			  this.getLidgrp().getApl().savpts(objinr,objtyp);
			  //受益人
			  this.getLidgrp().getBen().savpts(objinr,objtyp);
			  //通知行
			  this.getLidgrp().getAdv().savpts(objinr,objtyp);
			  //付款人
			  this.getLidgrp().getDre().savpts(objinr,objtyp);
			  //直接申请行
			  this.getLidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getLidgrp().getDap().getPts().setObjinr(objinr);
			  this.getLidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getDap().getPts());

			  //处理信用证协议lxd
			  this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getLidgrp().getLxd(),"ownref"),"LX");
			  deallxd(objinr,objtyp);
			  // 保存保证金协议
			  if("0001".equals(flags))
			  {
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getLidgrp().getBxd(),"ownref"),"JX");
			    this.getMtabut().getRefrence(MdaDriver.getDatafield(this.getLidgrp().getMar(),"ownref"),"MZ");
			    this.getLitp().getBxdmod().saveBxdAndMar();
			  }
			}
			//保存trn流水记录
			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getLitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:litapn.@0036.script
        */
        @Rule(target="mtabut.sav",order=190)
        public boolean ruleMtabutSavN190(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 检查及校验
			  */
			//校验保证金申请扣划账号
			if(!this.getLitp().getBxdmod().checkMxdlst())
			{
			  ctx.setMessage(MdaUtils.getI18NString("litapn","CT000016"),MdaUtils.getI18NString("litapn","CT000017"));
			  return false;
			}

			if(!ctx.checkAll(this.getLidgrp()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("litapn","CT000018"),MdaUtils.getI18NString("litapn","CT000019"));
			  return false;
			}

			return true;
        }

        /**
        *   source:litapn.@0047.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size = this.getLitp().getBxdmod().getMxdlst().fullSize();
			if(size>4)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litapn","CT000022"),MdaUtils.getI18NString("litapn","CT000023"));
			  return false;
			}
			this.getLitp().getBxdmod().getMxdlst().add();
			

			return true;
        }

        /**
        *   source:litapn.@0048.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int count = 0;
			int selidx=-1;
			for(int i=0;i<this.getLitp().getBxdmod().getMxdlst().fullSize();i++)
			{
			  if("X".equals(this.getLitp().getBxdmod().getMxdlst().getElement(i).getModflg()))
			  {
			    ++count;
			    selidx = i;
			  }
			}
			if(count>1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litapn","CT000026"),MdaUtils.getI18NString("litapn","CT000027"));
			  return true;
			}
			int select= selidx;
			if(select<0)
			  select = 0;
			if(select < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litapn","CT000129"),MdaUtils.getI18NString("litapn","CT000130"));
			  return true;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("litapn","CT000131"),MdaUtils.getI18NString("litapn","CT000132")))
			  return true;

			if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getMxdlst().getElement(select).getInr()))
			{
			  log.debug("{}","src mxdbat inr:"+this.getLitp().getBxdmod().getMxdbak().size());
			  this.getLitp().getBxdmod().getMxdbak().add(this.getLitp().getBxdmod().getMxdlst().getElement(select));
			  log.debug("{}","mxdbak inr:"+this.getLitp().getBxdmod().getMxdbak().size());
			}
			this.getLitp().getBxdmod().getMxdlst().remove(select);
			

			return true;
        }

        /**
        *   source:litapn.@0049.script
        */
        @Rule(target="litp.pdflid",order=100)
        public boolean ruleLitpPdflidN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litapn","信用证申请",1);

			return true;
        }

        /**
        *   source:litapn.@0050.script
        */
        @Rule(target="litp.pdflxd",order=100)
        public boolean ruleLitpPdflxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litapn1","信用证合同",1);

			return true;
        }

        /**
        *   source:litapn.@0051.script
        */
        @Rule(target="litp.pdfbxd",order=100)
        public boolean ruleLitpPdfbxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","bxdpdf","保证金协议",1);

			return true;
        }

        /**
        *   source:litapn.@0052.script
        */
        @Rule(target="litp.pdfmar",order=100)
        public boolean ruleLitpPdfmarN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","marpdf","委托开户及扣划申请",1);

			return true;
        }

        /**
        *   source:litapn.@0053.script
        */
        @Rule(target="litp.stpmod.gostep",order=50)
        public boolean ruleLitpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getLitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引panelidx="+stepIdx);
			if(stepIdx==1)
			{
			  
			}
			else
			{
			  
			}
			

			if(panelidx>stepIdx)
			  return true;
			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getLidgrp().getAgree()))
			    ctx.setFieldError(this,"lidgrp.agree",MdaUtils.getI18NString("litapn","CT000058"));
			  return !MdaUtils.isEmpty(this.getLidgrp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getLidgrp().getRec())&&ctx.checkAll(this.getLidgrp().getApl())&&ctx.checkAll(this.getLidgrp().getBen()) ;

			  case 2:
			  return ctx.checkAll(this.getLidgrp().getLxd());

			  case 3:
			  return ctx.checkAll(this.getLidgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getLidgrp().getMar());
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:litapn.@0056.script
        */
        @Rule(target="litp.lidgrp.rec.issdra",order=100)
        public boolean ruleLitpLidgrpRecIssdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLitp().getLidgrp().getRec().getIssdra()))
			{
			  this.getLitp().getLidgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  
			  //弹出草稿申请列表
			  //Platform.popup();
			}

			return true;
        }

        /**
        *   source:litapn.@0057.script
        */
        @Rule(target="litp.moddraft",order=100)
        public boolean ruleLitpModdraftN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getModdraft()))
			{
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:litapn.@0060.script
        */
        @Rule(target="litp.stpmod.next",order=50)
        public boolean ruleLitpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getLitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);
			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getLidgrp().getAgree()))
			    ctx.setFieldError(this,"lidgrp.agree",MdaUtils.getI18NString("litapn","CT000056"));
			  return !MdaUtils.isEmpty(this.getLidgrp().getAgree());

			  case 1:
			  return ctx.checkAll(this.getLidgrp().getRec())&&ctx.checkAll(this.getLidgrp().getApl())&&ctx.checkAll(this.getLidgrp().getBen()) ;

			  case 2:
			  return ctx.checkAll(this.getLidgrp().getLxd());

			  case 3:
			  return ctx.checkAll(this.getLidgrp().getBxd()) ;

			  case 4:
			  return  ctx.checkAll(this.getLidgrp().getMar());
			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:litapn.@0061.script
        */
        @Rule(target="mtabut.busmod.select",order=200)
        public boolean ruleMtabutBusmodSelectN200(){
            IContext ctx = MdaEnv.getContext();
            

			this.getLidgrp().setChecked1(TRUE);
			this.getLidgrp().setChecked2(TRUE);
			String  flags=this.getLidgrp().getRec().getMarginflg();
			log.debug("{}","flags="+flags);
			if("0001".equals(flags))
			{
			  this.getLidgrp().setChecked3(TRUE);
			  
			  log.debug("{}","选择模板后清除保证金委托扣划表内容");
			  this.getLidgrp().getMar().setCur(NULLSTR);
			  this.getLidgrp().getMar().setAmt(new BigDecimal(0));
			  MdaUtils.clear(this.getLidgrp().getMxdlst());
			  MdaUtils.clear(this.getLitp().getBxdmod().getMxdbak());
			}
			ctx.postRule(this,"litp.lidgrp.checked3");
			String tenor=this.getLidgrp().getRec().getTenor();
			log.debug("{}","tenor="+tenor);
			log.debug("{}","avbby="+this.getLidgrp().getRec().getAvbby());
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);


			return true;
        }

        /**
        *   source:litapn.@0065.script
        */
        @Rule(target="litp.lidgrp.checked3",order=100)
        public boolean ruleLitpLidgrpChecked3N100(){
            IContext ctx = MdaEnv.getContext();
            
			String checked=this.getLitp().getLidgrp().getChecked3();
			String steps=null;
			log.debug("{}","checked3="+checked);
			if(MdaUtils.isEmpty(checked))
			{
			  this.getLidgrp().getRec().setMarginflg("0000");
			  steps="0:声明及提示;1:开证申请;2:合同协议;5:合同展示";
			  
			  
			  MdaUtils.clear(this.getLitp().getBxdmod().getBxd());
			  MdaUtils.clear(this.getLitp().getBxdmod().getMar());
			  MdaUtils.clear(this.getLitp().getBxdmod().getMxdlst());
			  MdaUtils.clear(this.getLitp().getBxdmod().getMxdbak());

			  
			  
			}
			else if(!MdaUtils.isEmpty(checked))
			{
			  this.getLidgrp().getRec().setMarginflg("0001");
			  steps="0:声明及提示;1:开证申请;2:合同协议;3:保证金协议;4:委托开户扣划;5:合同展示";

			  this.getLitp().getBxdmod().getMar().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			  log.debug("{}","mar_credat"+MdaUtils.sqlDate(MdaUtils.today(),GE));
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			}
			
			
			
			log.debug("{}","标志位flags="+this.getLidgrp().getRec().getMarginflg());
			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:litapn.@0083.script
        */
        @Rule(target="litp.stpmod.last",order=110)
        public boolean ruleLitpStpmodLastN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getLitp().getStpmod().getCuridx();
			log.info("{}","上一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter last 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter last 110!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:litapn.@0084.script
        */
        @Rule(target="litp.stpmod.next",order=110)
        public boolean ruleLitpStpmodNextN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getLitp().getStpmod().getCuridx();
			log.info("{}","下一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			return true;
        }


        /**
        *   source:litapn.@0041.script
        */
        @Check(target="lidgrp.rec.expdat",order=100)
        public boolean checkLidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()))
			  return true;
			Date expdat=this.getLidgrp().getRec().getExpdat();
			Date credat=this.getLidgrp().getRec().getCredat();
			log.debug("{}","expdat="+expdat);
			log.debug("{}","credat"+credat);
			if(MdaUtils.diff(expdat,credat)<0)
			  ctx.setFieldError(this,"lidgrp.rec.expdat",MdaUtils.getI18NString("litapn","CT000006"));

			return true;
        }

        /**
        *   source:litapn.@0042.script
        */
        @Check(target="lidgrp.rec.issamt",order=100)
        public boolean checkLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getConamt()))
			  return true;
			BigDecimal camt = this.getLidgrp().getRec().getConamt();
			BigDecimal lamt = this.getLidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"lidgrp.rec.issamt",MdaUtils.getI18NString("litapn","CT000007"));

			return true;
        }

        /**
        *   source:litapn.@0043.script
        */
        @Check(target="lidgrp.rec.nomton",order=100)
        public boolean checkLidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			  return true;
			int nomton = this.getLidgrp().getRec().getNomton();
			//if(nomton.compareTo(new BigDecimal(50))>0  ||  nomton.compareTo(new BigDecimal(0))<0)
			//无小数位的Numberic类型为Integer
			if(nomton>50  ||  nomton<0)
			  ctx.setFieldError(this,"lidgrp.rec.nomton",MdaUtils.getI18NString("litapn","CT000008"));

			return true;
        }

        /**
        *   source:litapn.@0044.script
        */
        @Check(target="lidgrp.rec.shpdat",order=100)
        public boolean checkLidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpdat()))
			  return true;
			Date shpdat = this.getLidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getLidgrp().getRec().getExpdat())>0)
			  ctx.setFieldError(this,"lidgrp.rec.shpdat",MdaUtils.getI18NString("litapn","CT000009"));

			return true;
        }

        /**
        *   source:litapn.@0045.script
        */
        @Check(target="lidgrp.usapro",order=100)
        public boolean checkLidgrpUsaproN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","check usapro .. ");
			if("U".equals(this.getLidgrp().getRec().getTenor()) && MdaUtils.isEmpty(this.getLidgrp().getUsapro()))
			  ctx.setFieldError(this,"lidgrp.usapro",MdaUtils.getI18NString("litapn","CT000011"));

			return true;
        }

        /**
        *   source:litapn.@0054.script
        */
        @Check(target="litp.lidgrp.lxd.yfczhm",order=100)
        public boolean checkLitpLidgrpLxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfczhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfdzyj())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfsjhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfwxhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfqqhm()))
			{
			  ctx.setFieldError(this,"litp.lidgrp.lxd.yfczhm",MdaUtils.getI18NString("litapn","CT000029"));

			}
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfczhm()))
			{
			  String str=this.getLitp().getLidgrp().getLxd().getYfczhm();
			  String regEX="(0?\\d{2,3}\\-)?[1-9]\\d{6,7}(\\-\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfczhm",MdaUtils.getI18NString("litapn","CT000098"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0062.script
        */
        @Check(target="lidgrp.bxd.yfczhm",order=100)
        public boolean checkLidgrpBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  log.debug("{}","传真号码、电邮地址、手机号码必须填写一个！");
			  if(MdaUtils.isEmpty(this.getLidgrp().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getLidgrp().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getLidgrp().getBxd().getYfsjhm()))
			    ctx.setFieldError(this,"lidgrp.bxd.yfczhm",MdaUtils.getI18NString("litapn","CT000048"));

			  if(!MdaUtils.isEmpty(this.getLidgrp().getBxd().getYfczhm()))
			  {
			    String str=this.getLidgrp().getBxd().getYfczhm();
			    String regEX="(0?\\d{2,3}\\-)?[1-9]\\d{6,7}(\\-\\d{1,4})?";
			    Pattern pattern = Pattern.compile(regEX);
			    Matcher matcher = pattern.matcher(str);
			    if(!matcher.matches())
			    {
			      ctx.setFieldError(this,"lidgrp.bxd.yfczhm",MdaUtils.getI18NString("litapn","CT000119"));
			    }
			  }
			}


			return true;
        }

        /**
        *   source:litapn.@0063.script
        */
        @Check(target="lidgrp.bxd.yfzrr",order=100)
        public boolean checkLidgrpBxdYfzrrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  log.debug("{}","乙方单位与乙方自然人必填其中一项");
			  if(MdaUtils.isEmpty(this.getLidgrp().getBxd().getYf())&&MdaUtils.isEmpty(this.getLidgrp().getBxd().getYfzrr()))
			  {
			    ctx.setFieldError(this,"lidgrp.bxd.yf",MdaUtils.getI18NString("litapn","CT000050"));
			  }
			  else
			  {
			    //乙方(自然人)信息
			    
			    
			    
			    //乙方(自然人)收件信息
			    
			    
			    
			    
			    //乙方(自然人)代收人信息
			    
			    
			    
			    
			    //乙方（单位）信息
			    
			    
			    //乙方（单位）收件信息
			    
			    
			    
			    
			    
			    //乙方（单位）代收人信息
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0064.script
        */
        @Check(target="lidgrp.mar.wtklbzjzh",order=100)
        public boolean checkLidgrpMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  log.debug("{}","委托开立保证金账户、委托扣划保证金必须填写一个               ");
			  if(MdaUtils.isEmpty(this.getLidgrp().getMar().getWtklbzjzh())&&MdaUtils.isEmpty(this.getLidgrp().getMar().getWtkhbzj()))
			    ctx.setMessage(MdaUtils.getI18NString("litapn","CT000053"),MdaUtils.getI18NString("litapn","CT000054"));
			}

			return true;
        }

        /**
        *   source:litapn.@0067.script
        */
        @Check(target="litp.lidgrp.lxd.yfyzbm",order=100)
        public boolean checkLitpLidgrpLxdYfyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLidgrp().getLxd().getYfyzbm()))
			{
			  String str=this.getLidgrp().getLxd().getYfyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfyzbm",MdaUtils.getI18NString("litapn","CT000092"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0068.script
        */
        @Check(target="litp.lidgrp.lxd.dsyzbm",order=100)
        public boolean checkLitpLidgrpLxdDsyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getDsyzbm()))
			{
			  String str=this.getLidgrp().getLxd().getDsyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.dsyzbm",MdaUtils.getI18NString("litapn","CT000093"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0069.script
        */
        @Check(target="litp.lidgrp.lxd.yfqqhm",order=100)
        public boolean checkLitpLidgrpLxdYfqqhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfqqhm()) )
			{
			  String str=this.getLidgrp().getLxd().getYfqqhm();
			  String regEX="[1-9][0-9]{4,9}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfqqhm",MdaUtils.getI18NString("litapn","CT000097"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0070.script
        */
        @Check(target="litp.lidgrp.lxd.yfsjhm",order=100)
        public boolean checkLitpLidgrpLxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfsjhm()))
			{
			  String str=this.getLitp().getLidgrp().getLxd().getYfsjhm();
			  String regEX="[1][3,4,5,7,8][0-9]{9}";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfsjhm",MdaUtils.getI18NString("litapn","CT000103"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0071.script
        */
        @Check(target="litp.lidgrp.lxd.yflxdh",order=100)
        public boolean checkLitpLidgrpLxdYflxdhN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($litp\\lidgrp\\lxd\\yflxdh))
			  {
			  String str=$litp\\lidgrp\\lxd\\yflxdh.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\lidgrp\\lxd\\yflxdh,#CT000104);
			  }
			  }*/

			return true;
        }

        /**
        *   source:litapn.@0072.script
        */
        @Check(target="litp.lidgrp.lxd.dslxdh",order=100)
        public boolean checkLitpLidgrpLxdDslxdhN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($litp\\lidgrp\\lxd\\dslxdh))
			  {
			  String str=$litp\\lidgrp\\lxd\\dslxdh.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\lidgrp\\lxd\\dslxdh,#CT000105);
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:litapn.@0073.script
        */
        @Check(target="litp.bxdmod.bxd.yfyzbm",order=100)
        public boolean checkLitpBxdmodBxdYfyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfyzbm()))
			  {
			    String str=this.getLitp().getBxdmod().getBxd().getYfyzbm();
			    String regEX="^[0-9]{6}";
			    Pattern pattern=Pattern.compile(regEX);
			    Matcher matcher = pattern.matcher(str);
			    if(!matcher.matches())
			    {
			      ctx.setFieldError(this,"litp.bxdmod.bxd.yfyzbm",MdaUtils.getI18NString("litapn","CT000107"));
			    }
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0074.script
        */
        @Check(target="litp.bxdmod.bxd.yflxdh",order=100)
        public boolean checkLitpBxdmodBxdYflxdhN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($lidgrp\\checked3))
			  {
			  if(!Platform.isEmpty($litp\\bxdmod\\bxd\\yflxdh))
			  {
			  String str=$litp\\bxdmod\\bxd\\yflxdh.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\bxdmod\\bxd\\yflxdh,#CT000108);
			  }
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:litapn.@0075.script
        */
        @Check(target="litp.bxdmod.bxd.dslxdh",order=100)
        public boolean checkLitpBxdmodBxdDslxdhN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($lidgrp\\checked3))
			  {
			  if(!Platform.isEmpty($litp\\bxdmod\\bxd\\dslxdh))
			  {
			  String str=$litp\\bxdmod\\bxd\\dslxdh.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\bxdmod\\bxd\\dslxdh,#CT000109);
			  }
			  }
			  }*/

			return true;
        }

        /**
        *   source:litapn.@0076.script
        */
        @Check(target="litp.bxdmod.bxd.yflxdh2",order=100)
        public boolean checkLitpBxdmodBxdYflxdh2N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($lidgrp\\checked3))
			  {
			  if(!Platform.isEmpty($litp\\bxdmod\\bxd\\yflxdh2))
			  {
			  String str=$litp\\bxdmod\\bxd\\yflxdh2.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\bxdmod\\bxd\\yflxdh2,#CT000110);
			  }
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:litapn.@0077.script
        */
        @Check(target="litp.bxdmod.bxd.dsrdh2",order=100)
        public boolean checkLitpBxdmodBxdDsrdh2N100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($lidgrp\\checked3))
			  {
			  if(!Platform.isEmpty($litp\\bxdmod\\bxd\\dsrdh2))
			  {
			  String str=$litp\\bxdmod\\bxd\\dsrdh2.getValue();
			  String regEX="(0?\\\\d{2,3}\\\\-)?[1-9]\\\\d{6,7}(\\\\-\\\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			  Platform.error($litp\\bxdmod\\bxd\\dsrdh2,#CT000112);
			  }
			  }
			  }*/

			return true;
        }

        /**
        *   source:litapn.@0078.script
        */
        @Check(target="litp.bxdmod.bxd.yfsjhm",order=100)
        public boolean checkLitpBxdmodBxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfsjhm()))
			{
			  String str=this.getLitp().getBxdmod().getBxd().getYfsjhm();
			  String regEX="[1][3,4,5,7,8][0-9]{9}";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.bxdmod.bxd.yfsjhm",MdaUtils.getI18NString("litapn","CT000115"));
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0079.script
        */
        @Check(target="litp.bxdmod.bxd.dsyzbm",order=100)
        public boolean checkLitpBxdmodBxdDsyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getDsyzbm()))
			  {
			    String str=this.getLitp().getBxdmod().getBxd().getDsyzbm();
			    String regEX="^[0-9]{6}";
			    Pattern pattern=Pattern.compile(regEX);
			    Matcher matcher = pattern.matcher(str);
			    if(!matcher.matches())
			    {
			      ctx.setFieldError(this,"litp.bxdmod.bxd.dsyzbm",MdaUtils.getI18NString("litapn","CT000120"));
			    }
			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0080.script
        */
        @Check(target="litp.bxdmod.bxd.yfyzbm2",order=100)
        public boolean checkLitpBxdmodBxdYfyzbm2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfyzbm2()))
			  {
			    String str=this.getLitp().getBxdmod().getBxd().getYfyzbm2();
			    String regEX="^[0-9]{6}";
			    Pattern pattern=Pattern.compile(regEX);
			    Matcher matcher = pattern.matcher(str);
			    if(!matcher.matches())
			    {
			      ctx.setFieldError(this,"litp.bxdmod.bxd.yfyzbm2",MdaUtils.getI18NString("litapn","CT000123"));
			    }

			  }
			}

			return true;
        }

        /**
        *   source:litapn.@0081.script
        */
        @Check(target="litp.bxdmod.bxd.dsryb2",order=100)
        public boolean checkLitpBxdmodBxdDsryb2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getDsryb2()))
			  {
			    String str=this.getLitp().getBxdmod().getBxd().getDsryb2();
			    String regEX="^[0-9]{6}";
			    Pattern pattern=Pattern.compile(regEX);
			    Matcher matcher = pattern.matcher(str);
			    if(!matcher.matches())
			    {
			      ctx.setFieldError(this,"litp.bxdmod.bxd.dsryb2",MdaUtils.getI18NString("litapn","CT000124"));
			    }

			  }
			}

			return true;
        }


        /**
        *   source:litapn.@0000.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","litapn  init业务处理开始，ORDER编号:90");
			//定义步骤条
			this.getLitp().getStpmod().storePanel(this.getLitp().getLitstp1bd(),this.getLitp().getLitstp2bd(),this.getLitp().getLitstp4bd(),this.getLitp().getLitstp5bd(),this.getLitp().getLitstp6bd(),this.getLitp().getLitapn02());
			String  steps="0:声明及提示;1:开证申请;2:合同协议;5:合同展示";
			String flags=this.getLidgrp().getRec().getMarginflg();
			log.debug("{}","标志位flags="+flags);
			//初始化隐藏保证金，开户及扣划申请PDF
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if("0000".equals(flags))
			  {
			    //steps="0:声明及提示;1:开证申请;2:合同协议;5:合同展示";
			    
			    
			    
			    
			  }
			  else  if("0001".equals(flags))
			  {
			    steps="0:声明及提示;1:开证申请;2:合同协议;3:保证金协议;4:委托开户扣划;5:合同展示";
			    
			    

			    
			    
			    
			    
			    
			    
			  }
			}
			else
			{
			  //new，初始化flags标志位
			  this.getLidgrp().getRec().setMarginflg("0000");
			  
			  steps="0:声明及提示;1:开证申请;2:合同协议;5:合同展示";
			  this.getLitp().loadTips();
			}
			this.getLidgrp().setChecked1(TRUE);
			this.getLidgrp().setChecked2(TRUE);
			this.getLidgrp().setChecked4(TRUE);
			
			
			
			
			
			
			
			
			log.debug("{}","steps="+steps);
			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:litapn.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","litapn  init业务处理开始，ORDER编号:100");
			//默认消失掉模板查询交易
			
			

			
			String tenor =this.getLidgrp().getRec().getTenor();
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getLidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			
			
			
			
			
			
			
			
			
			
			
			

			
			
			
			

			//申请日期特殊处理，获取当天0时0分0秒
			log.debug("{}","今天="+MdaUtils.sqlDate(MdaUtils.today(),GE));
			this.getLidgrp().getRec().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			this.getLidgrp().getDap().initDap("lid");
			this.getLidgrp().getApl().copyValues(this.getLidgrp().getDap());
			log.debug("{}","message"+this.getLidgrp().getApl().getPts().getNam());
			this.getLidgrp().getApl().getPts().setRol("apl");
			this.getLidgrp().getRec().setConcur("USD");
			this.getLidgrp().getRec().setIsscur("USD");
			this.getLidgrp().getRec().setNomflg(FALSE);
			this.getLidgrp().getRec().setIssinf("1");
			// $lidgrp\\rec\\shppar.setValue("2");
			// $lidgrp\\rec\\shptrs.setValue("2");
			this.getLidgrp().getRec().setTrfflg("1");
			// $lidgrp\\rec\\upsflg.setValue("2");
			this.getLidgrp().getRec().setCnfflg("3");
			this.getLidgrp().getRec().setAvbwths("1");
			this.getLidgrp().getRec().setAvbwth("ANY BANK");
			this.getLidgrp().getRec().setAvbby("0");
			this.getLidgrp().getRec().setTrdtrm("CFR");
			this.getLidgrp().getRec().setTrdflg(FALSE);
			//Platform.setValues($lidgrp\\rec\\trfflg,Platform.getCodetable("trfflg"));
			this.getLidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			// $lidgrp\\rec\\sedday.setValue("21");
			this.getLidgrp().getRec().setSstdat("1");
			this.getLidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getLidgrp().getRec().setPreper("Documents To Be Presented  After The Date Of SHIPMENT ,But Within The Validity Of The Credit.");
			this.getLidgrp().getRec().setApprul("1");
			this.getLidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			// $lidgrp\\agree.setValue(TRUE);
			this.getLitp().setAplnam(this.getSysmod().getPty().getNam());
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getLitp().getOpncls().getCls(),new Argument<String>("inr",this.getLitp().getOpncls().readDefaultClsInr("litapn")));
			  this.getLidgrp().getBlk().setRgtcls(this.getLitp().getOpncls().getCls().getClstxt());
			}

			return true;
        }


        /**
        *   source:litapn.@0037.script
        */
        public void deallxd(String objinr,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**处理信用证协议
			  objinr：业务数据inr
			  objtyp:业务表名*/
			log.debug("{}","dealLxd处理开始    ");
			this.getLidgrp().getLxd().setInr(Platform.sdbCounter("lxd"));
			this.getLidgrp().getLxd().setObjinr(objinr);
			this.getLidgrp().getLxd().setObjtyp(objtyp);
			ctx.getDaoSession().dbInsert(this.getLidgrp().getLxd());
		}
        /**
        *   source:litapn.@0038.script
        */
        public void adlcnds()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtvalue="";
			Object adlcnd = this.getLidgrp().getBlk().getAdlcnd();
			Object nomton = this.getLidgrp().getRec().getNomton();
			Object nomflg = this.getLidgrp().getRec().getNomflg();
			Object nomtop = this.getLidgrp().getRec().getNomtop();
			// log.debug("nomflg=="+nomflg.toString());
			// log.debug("nomflg=="+nomflg);
			if(!MdaUtils.isEmpty(nomflg)&&TRUE.equals(nomflg.toString()))
			{
			  rtvalue= "+Quantity And Amount ";
			  if(!MdaUtils.isEmpty(nomtop))
			    rtvalue+=nomtop.toString()+" PERCENT More ";
			  if(!MdaUtils.isEmpty(nomton))
			  {
			    if(!MdaUtils.isEmpty(nomtop))
			      rtvalue+= " Or ";
			    rtvalue+=nomton.toString()+" PERCENT Less";
			  }
			  rtvalue+=" Are Allowed";
			}
			if(!MdaUtils.isEmpty(adlcnd))
			  if(rtvalue==null   ||   "".equals(rtvalue) )
			rtvalue=adlcnd.toString();
			else
			rtvalue+= CR+adlcnd.toString();
			else
			rtvalue=rtvalue;
			this.getLidgrp().setSwfd(rtvalue) ;
		}
        /**
        *   source:litapn.@0039.script
        */
        public void lcrgods()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String returnvalue="";
			Object lcrgod = this.getLidgrp().getBlk().getLcrgod();
			Object trdtrm = this.getLidgrp().getRec().getTrdtrm();
			Object trdtrmplc = this.getLidgrp().getRec().getTrdtrmplc();
			Object trdtrmver = this.getLidgrp().getRec().getTrdtrmver();
			if(!MdaUtils.isEmpty(lcrgod))
			  returnvalue=lcrgod.toString()+CR;
			if(!MdaUtils.isEmpty(trdtrm))
			  returnvalue+="+Trade Terms: "+trdtrm.toString();
			if(!MdaUtils.isEmpty(trdtrmplc))
			  returnvalue+=" "+trdtrmplc.toString();
			if(!MdaUtils.isEmpty(trdtrmver))
			  returnvalue+=" "+trdtrmver.toString();
			this.getLidgrp().setSwfa(returnvalue.trim());
		}









}