package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitcanVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证开证撤销通知
*/
@Transaction(vo= LitcanVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litcan extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litcan.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Litcan()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litcan.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litcan.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litcan.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litcan.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litcan.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litcan.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:litcan.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getLitp().getLitp06());

			return true;
        }

        /**
        *   source:litcan.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:litcan.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            

			//通知行、受益人未赋值，建议从单证通数据库里根据信用证号调取相关数据
			//如开立申请不是在单证通发起的，这两个栏位可赋空值
			Argument<String> extkey =new Argument<String>("extkey");
			Argument<String> adrblk =new Argument<String>("adrblk");

			//sql :SELECT pts.* FROM pts,lid WHERE lid.stlref='08101LC17000118F' AND lid.inr=pts.objinr AND pts.objtyp='lid' AND pts.rol='adv';
			//sql :SELECT * FROM pts WHERE objinr=(SELECT inr FROM lid WHERE stlref='08101LC17000118F') AND objtyp='lid' AND rol='adv';
			String sql = "SELECT pts.extkey,pts.adrblk FROM pts,lid WHERE lid.inr=pts.objinr AND pts.objtyp='lid' AND pts.rol='adv' ";
			sql = sql + " AND lid.stlref='"+ this.getLidgrp().getRec().getStlref() +"' ";
			log.debug("{}","sql " + sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(extkey,adrblk);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getLidgrp().getAdv().getPts().setExtkey(extkey.value);
			    this.getLidgrp().getAdv().getPts().setAdrblk(adrblk.value);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();

			sql = "SELECT pts.extkey,pts.adrblk FROM pts,lid WHERE lid.stlref=? AND lid.inr=pts.objinr AND pts.objtyp='lid' AND pts.rol='ben' ";
			ctx.getDaoSession().dbExecuteSQL(sql,this.getLidgrp().getRec().getStlref());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(extkey,adrblk);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getLidgrp().getBen().getPts().setExtkey(extkey.value);
			    this.getLidgrp().getBen().getPts().setAdrblk(adrblk.value);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();

			//使用dbRead
			//Platform.dbRead($lidgrp\\adv\\pts,new Argument<String>("objinr", $lidgrp\\rec\\inr.getValue(),new Argument<String>("objtyp", "lid"),new Argument<String>("rol", "adv");
			//Platform.dbRead($lidgrp\\ben\\pts,new Argument<String>("objinr", $lidgrp\\rec\\inr.getValue(),new Argument<String>("objtyp", "lid"),new Argument<String>("rol", "ben");
			
			return true;
        }

        /**
        *   source:litcan.@0004.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","ben"));
			ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument<String>("objinr",this.getLidgrp().getRec().getInr()),new Argument<String>("objtyp","lid"),new Argument<String>("rol","adv"));

			return true;
        }











}