package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证开立通知
*/
@Transaction(vo= LitdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litdav.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litdav.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litdav.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litdav.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litdav.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litdav.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litdav.@0002.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			//#CT000001
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:litdav.@0003.script
        */
        @Rule(target="mtabut.notice",order=0)
        public boolean ruleMtabutNoticeN0(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrnmod().getSmh().getInr()))
			{
			  String not=this.getTrnmod().getSmh().getXmlfil();
			  //Platform.invoke(object,methodName,arguments)
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("litdav","CT000003"));
			}

			return true;
        }



        /**
        *   source:litdav.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","ptytyp===================="+this.getSysmod().getPty().getPtytyp());
			//只有商行客户才能看到edit按钮
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			}
			else
			{
			  
			}
			/*
			  *灰显部分无法拷贝，业务人员要求放开
			  *2010-03-01
			  Platform.disable($lidgrp\\rec\\advdat);
			  Platform.disable($lidgrp\\rec\\stlref);
			  Platform.disable($lidgrp\\dap\\pts\\ref);
			  Platform.disable($lidgrp\\rec\\opndat);
			  Platform.disable($lidgrp\\rec\\expdat);
			  Platform.disable($lidgrp\\rec\\tenor);
			  Platform.disable($lidgrp\\rec\\isscur);
			  Platform.disable($lidgrp\\rec\\issamt);
			  Platform.disable($lidgrp\\rec\\conno);
			  Platform.disable($lidgrp\\adv\\pts\\extkey);
			  Platform.disable($lidgrp\\adv\\pts\\adrblk);
			  Platform.disable($litp\\advp\\sel);
			  Platform.disable($lidgrp\\ben\\pts\\extkey);
			  Platform.disable($lidgrp\\ben\\pts\\adrblk);
			  Platform.disable($litp\\benp\\sel);
			  */

			return true;
        }

        /**
        *   source:litdav.@0001.script
        */
        @Init(order=300)
        public boolean	init300(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getDap().getPts().getRef()))
			{
			  this.getLidgrp().getDap().getPts().setRef(this.getLidgrp().getRec().getStlref());
			  
			}
			

			return true;
        }

        /**
        *   source:litdav.@0004.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			String labels = "";
			String tempfiles =  "";
			//获取需要存表的pdf或草稿名
			Map<String,String> cntLabel = ctx.absGet(Trnmod.class).getPDFInfo();
			labels = cntLabel.get("label") + labels;
			tempfiles = cntLabel.get("tempfile") + tempfiles;
			String[] strs = labels.split(",");
			int cnt = strs.length;
			log.debug("{}","labels=====" + labels);
			log.debug("{}","tempfiles====" + tempfiles);
			log.debug("{}","cnt ======"+ cnt);
			ctx.absGet(Trnmod.class).getApldoc().setPDFInfo(cnt,labels,tempfiles);

			this.getTrnmod().noticeAck(this.getLitp().getLitp04());

			return true;
        }

        /**
        *   source:litdav.@0005.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}