package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitmdlVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 信用证合同协议模板推送
*/
@Transaction(vo= LitmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litmdl.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litmdl.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litmdl.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litmdl.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litmdl.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litmdl.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litmdl.@0004.script
        */
        @Rule(target="litp.select",order=100)
        public boolean ruleLitpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			{
			  int index=0;
			  if(index<0||index>=this.getLitp().getCidmod().getClilst().fullSize())
			  {
			    ctx.setMessage(MdaUtils.getI18NString("litmdl","CT000003"),MdaUtils.getI18NString("litmdl","CT000004"));
			    return true;
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(this.getLitp().getCidmod().getClipty(),new Argument("cid",this.getLitp().getCidmod().getClilst().getElement(index).getCid()));
			    this.getLitp().getBummod().getWrkmdl().setCidinr(this.getLitp().getCidmod().getClipty().getCid());
			    
			    loadApl(this.getLitp().getCidmod().getClipty().getInr());
			  }

			}

			return true;
        }

        /**
        *   source:litmdl.@0005.script
        */
        @Rule(target="litp.lidgrp.checked",order=100)
        public boolean ruleLitpLidgrpCheckedN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","execute  event lidgrp checked  .......");
			String steps = "";
			if(MdaUtils.isEmpty(this.getLidgrp().getChecked()))
			{
			  steps = "0:信用证申请;1:信用证协议;4:保存模板";
			  //无保证金协议及保证金委托开户和扣划，设置flags标志位为0000
			  this.getLidgrp().getRec().setMarginflg("0000");
			  
			  MdaUtils.clear(this.getLidgrp().getBxd());
			  MdaUtils.clear(this.getLidgrp().getMar());
			}
			else
			{
			  this.getLidgrp().getBxd().setCgyd("1");
			  ctx.postRule(this,"lidgrp.bxd.cgyd");
			  this.getLidgrp().getBxd().setJxyd("1");
			  ctx.postRule(this,"lidgrp.bxd.jxyd");
			  this.getLidgrp().getBxd().setJsyd("1");
			  ctx.postRule(this,"lidgrp.bxd.jsyd");
			  this.getLidgrp().getBxd().setZyjjfs("1");
			  ctx.postRule(this,"lidgrp.bxd.zyjjfs");
			  //有保证金协议及保证金委托开户和扣划，设置flags标志位为0001
			  this.getLidgrp().getRec().setMarginflg("0001");
			  
			  this.getLidgrp().getMar().setCredat(MdaUtils.today());
			  
			  steps = "0:信用证申请;1:信用证协议;2:保证金协议;3:委托开户扣划;4:保存模板";
			}
			log.debug("{}","flags="+this.getLidgrp().getRec().getMarginflg());
			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:litmdl.@0006.script
        */
        @Rule(target="litp.cidmod.clilst",order=100)
        public boolean ruleLitpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"litp.select");

			return true;
        }

        /**
        *   source:litmdl.@0008.script
        */
        @Rule(target="lidgrp.bxd.cgyd",order=100)
        public boolean ruleLidgrpBxdCgydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cgyd=this.getLidgrp().getBxd().getCgyd();
			if("1".equals(cgyd))
			{
			  this.getLidgrp().getBxd().setYs(0);
			  this.getLidgrp().getBxd().setBzjqcrq(null);
			  this.getLidgrp().getBxd().setBzjdqr(null);
			  
			  
			  
			}
			else if("2".equals(cgyd))
			{
			  
			  
			  
			  
			  
			  
			}
			
			
			


			return true;
        }

        /**
        *   source:litmdl.@0009.script
        */
        @Rule(target="lidgrp.bxd.jsyd",order=100)
        public boolean ruleLidgrpBxdJsydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jsyd=this.getLidgrp().getBxd().getJsyd();
			if(!MdaUtils.isEmpty(jsyd))
			{
			  if("5".equals(jsyd))
			  {
			    
			    
			  }
			  else
			  {
			    this.getLidgrp().getBxd().setJsydqt(NULLSTR);
			    
			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0010.script
        */
        @Rule(target="lidgrp.bxd.jxyd",order=100)
        public boolean ruleLidgrpBxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jxyd=this.getLidgrp().getBxd().getJxyd();
			log.debug("{}","计息约定："+jxyd);
			if("1".equals(jxyd))
			{//月利率
			  this.getLidgrp().getBxd().setNll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(jxyd))
			{//年利率
			  this.getLidgrp().getBxd().setYll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(jxyd))
			{//其他约定
			  this.getLidgrp().getBxd().setNll(new BigDecimal(0));
			  this.getLidgrp().getBxd().setYll(new BigDecimal(0));
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litmdl.@0011.script
        */
        @Rule(target="lidgrp.bxd.zyjjfs",order=100)
        public boolean ruleLidgrpBxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String zyjjfs=this.getLidgrp().getBxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getLidgrp().getBxd().setZcwyh(NULLSTR);
			  this.getLidgrp().getBxd().setKtdd(NULLSTR);
			  this.getLidgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  this.getLidgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getLidgrp().getBxd().setZcwyh(NULLSTR);
			  this.getLidgrp().getBxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litmdl.@0012.script
        */
        @Rule(target="lidgrp.lxd.xyzqk",order=100)
        public boolean ruleLidgrpLxdXyzqkN100(){
            IContext ctx = MdaEnv.getContext();
            
			String xyzqk=this.getLidgrp().getLxd().getXyzqk();
			log.debug("{}","信用证属于情况:"+xyzqk);
			if("1".equals(xyzqk))
			{
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			}
			else if("2".equals(xyzqk))
			{
			  this.getLidgrp().getLxd().setShhtbh(NULLSTR);
			  this.getLidgrp().getLxd().setSxhtmc(NULLSTR);
			  this.getLidgrp().getLxd().setShhtje(NULLSTR);
			  this.getLidgrp().getLxd().setXqqs(null);
			  this.getLidgrp().getLxd().setXqzz(null);

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			
			
			
			
			

			return true;
        }

        /**
        *   source:litmdl.@0013.script
        */
        @Rule(target="lidgrp.lxd.zyjjfs",order=100)
        public boolean ruleLidgrpLxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String zyjjfs=this.getLidgrp().getLxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getLidgrp().getLxd().setCzwyh(NULLSTR);
			  this.getLidgrp().getLxd().setKtdd(NULLSTR);
			  this.getLidgrp().getLxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  this.getLidgrp().getLxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getLidgrp().getLxd().setCzwyh(NULLSTR);
			  this.getLidgrp().getLxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:litmdl.@0014.script
        */
        @Rule(target="lidgrp.rec.apprul",order=100)
        public boolean ruleLidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  //$lidgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getLidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:litmdl.@0015.script
        */
        @Rule(target="lidgrp.rec.avbby",order=100)
        public boolean ruleLidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getLidgrp().getRec().getAvbby();
			log.debug("{}","on evt .onChange事件 .litapn.avbby...  avbby =" + avbby);
			if("1".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			}
			else if("2".equals(avbby))
			{
			  if(MdaUtils.isEmpty(this.getLidgrp().getUsapro())||"O".equals(this.getLidgrp().getUsapro()))
			  {
			    
			    
			    
			  }
			  else
			  {
			    
			  }
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  

			}
			else if("3".equals(avbby))
			{

			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  
			  
			  

			}
			else if("4".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");

			}
			else if("5".equals(avbby))
			{
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  

			}

			
			
			Modules.postDefaultRule(this,"lidgrp.blk.defdet");

			return true;
        }

        /**
        *   source:litmdl.@0016.script
        */
        @Rule(target="lidgrp.rec.avbwths",order=100)
        public boolean ruleLidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  this.getLidgrp().getRec().setAvbwth(NULLSTR);
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:litmdl.@0017.script
        */
        @Rule(target="lidgrp.rec.bchcod",order=100)
        public boolean ruleLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:litmdl.@0018.script
        */
        @Rule(target="lidgrp.rec.cnfflg",order=100)
        public boolean ruleLidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )  //MAY ADD
			this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for beneficiary's account.");
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )  //CONFIRM
			this.getLidgrp().getBlk().setCnfdet("confirm charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setCnfdet(NULLSTR);

			

			return true;
        }

        /**
        *   source:litmdl.@0019.script
        */
        @Rule(target="lidgrp.rec.concur",order=100)
        public boolean ruleLidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			{
			  return true;
			}
			this.getLidgrp().getRec().setIsscur(this.getLidgrp().getRec().getConcur());
			

			return true;
        }

        /**
        *   source:litmdl.@0020.script
        */
        @Rule(target="lidgrp.rec.nomflg",order=100)
        public boolean ruleLidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			{
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
			this.getLidgrp().getRec().setNomtop(0);
			this.getLidgrp().getRec().setNomton(0);
			
			

			return true;
        }

        /**
        *   source:litmdl.@0021.script
        */
        @Rule(target="mtabut.mail",order=200)
        public boolean ruleMtabutMailN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("litopnApp"+inr,"litopn");
			this.getMtabut().creatTcoPdfFile("litopnDra"+inr);
			this.getMtabut().setAttnames("litopnApp"+inr+".pdf;litopnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:litmdl.@0033.script
        */
        @Rule(target="lidgrp.rec.sstdat",order=100)
        public boolean ruleLidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			String sstdat=this.getLidgrp().getRec().getSstdat();
			String sedday =this.getLidgrp().getRec().getSedday();
			String str1="Documents To Be Presented ";
			String str2=null;
			if(MdaUtils.isEmpty(sedday))
			{
			  str2="" ;
			}
			else
			{
			  str2="Within " + sedday + " Days";
			}
			if("3".equals(sstdat))
			{
			  this.getLidgrp().getRec().setSstdattxt("");
			  
			  
			  
			}
			else
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",sstdat));
			}
			
			this.getLidgrp().getRec().setPreper(str1+str2+" After The Date Of " + this.getLidgrp().getRec().getSstdattxt() + ",But Within The Validity Of The Credit.");
			log.debug("{}","----------sstdattxt----------"+this.getLidgrp().getRec().getSstdattxt());
			

			return true;
        }

        /**
        *   source:litmdl.@0034.script
        */
        @Rule(target="lidgrp.rec.tenor",order=100)
        public boolean ruleLidgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tenor = this.getLidgrp().getRec().getTenor() ;
			if(!MdaUtils.isModified(this.getLidgrp().getBlk(),"dftat") && "S".equals(this.getLidgrp().getRec().getTenor()))
			{
			  this.getLidgrp().getBlk().setDftat("sight for 100 pct of the invoice value");
			}
			if("S".equals(tenor))
			{
			  this.getLidgrp().getRec().setUpsflg(NULLSTR);
			  
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			  

			  this.getLitp().getLidgrp().setTedays(0);
			  
			  

			  this.getLitp().getLidgrp().setUsapro(NULLSTR);
			  
			  
			}
			else if("U".equals(tenor))
			{
			  
			  
			  
			  
			  
			  

			}
			
			
			
			

			//即期远期，avbby对应码表不同
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);


			return true;
        }

        /**
        *   source:litmdl.@0035.script
        */
        @Rule(target="lidgrp.rec.trdflg",order=100)
        public boolean ruleLidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getTrdflg()))
			{
			  this.getLidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2010");
			}
			else
			{
			  this.getLidgrp().getRec().setTrdtrmver(NULLSTR);
			}
			
			

			return true;
        }

        /**
        *   source:litmdl.@0036.script
        */
        @Rule(target="lidgrp.rec.trfflg",order=100)
        public boolean ruleLidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getLidgrp().getRec().getTrfflg()))
			  this.getLidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setTrfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litmdl.@0037.script
        */
        @Rule(target="lidgrp.rec.upsflg",order=100)
        public boolean ruleLidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			  this.getLidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litmdl.@0040.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size = this.getLitp().getBxdmod().getMxdlst().fullSize();
			if(size>7)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litmdl","CT000016"),MdaUtils.getI18NString("litmdl","CT000017"));
			  return false;
			}
			this.getLitp().getBxdmod().getMxdlst().add();
			


			return true;
        }

        /**
        *   source:litmdl.@0041.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int select = 0;
			if(select < 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litmdl","CT000020"),MdaUtils.getI18NString("litmdl","CT000021"));
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getLitp().getBxdmod().getMxdlst().getElement(select).getInr()))
			  {
			    log.debug("{}","src mxdbat inr:"+this.getLitp().getBxdmod().getMxdbak().size());
			    this.getLitp().getBxdmod().getMxdbak().add(this.getLitp().getBxdmod().getMxdlst().getElement(select));
			    log.debug("{}","mxdbak inr:"+this.getLitp().getBxdmod().getMxdbak().size());
			  }
			  this.getLitp().getBxdmod().getMxdlst().remove(select);
			}
			

			return true;
        }

        /**
        *   source:litmdl.@0042.script
        */
        @Rule(target="litp.stpmod.next",order=50)
        public boolean ruleLitpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int panelidx=$litp\\stpmod\\panelidx.getValue();
			  log.debug("当前面板索引panelidx="+panelidx);
			  switch(panelidx)
			  {
			  case 0:
			  return Platform.checkAll($lidgrp\\rec) ;
			
			  case 1:
			  return Platform.checkAll($lidgrp\\lxd);
			
			  case 2:
			  return Platform.checkAll($lidgrp\\bxd) ;
			
			  case 3:
			  return  Platform.checkAll($lidgrp\\mar);
			  }
			  log.debug("next Order[50] 执行完毕");
			  */

			return true;
        }

        /**
        *   source:litmdl.@0043.script
        */
        @Rule(target="litp.stpmod.gostep",order=50)
        public boolean ruleLitpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  int panelidx=$litp\\stpmod\\panelidx.getValue();
			  log.debug("当前面板索引panelidx="+panelidx);
			  switch(panelidx)
			  {
			  case 0:
			  return Platform.checkAll($lidgrp\\rec) ;
			
			  case 1:
			  return Platform.checkAll($lidgrp\\lxd);
			
			  case 2:
			  return Platform.checkAll($lidgrp\\bxd) ;
			
			  case 3:
			  return  Platform.checkAll($lidgrp\\mar);
			  }
			  log.debug("gostep Order[50] 执行完毕");
			  */

			return true;
        }

        /**
        *   source:litmdl.@0046.script
        */
        @Rule(target="litp.lidgrp.rec.issdra",order=100)
        public boolean ruleLitpLidgrpRecIssdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLitp().getLidgrp().getRec().getIssdra()))
			{
			  this.getLitp().getLidgrp().getRec().setOwnref(NULLSTR);
			  
			  
			  
			  //弹出草稿申请列表
			  //Platform.popup();
			}

			return true;
        }

        /**
        *   source:litmdl.@0047.script
        */
        @Rule(target="litp.moddraft",order=100)
        public boolean ruleLitpModdraftN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getModdraft()))
			{
			  
			}
			else
			{
			  
			}
			

			return true;
        }


        /**
        *   source:litmdl.@0038.script
        */
        @Check(target="litp.lidgrp.lxd.yfsjhm",order=100)
        public boolean checkLitpLidgrpLxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfsjhm()))
			{
			  String str=this.getLitp().getLidgrp().getLxd().getYfsjhm();
			  String regEX="[1][3,4,5,7,8][0-9]{9}";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfsjhm",MdaUtils.getI18NString("litmdl","CT000010"));
			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0039.script
        */
        @Check(target="litp.bxdmod.bxd.yfczhm",order=100)
        public boolean checkLitpBxdmodBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getChecked()))
			{
			  if(MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getLitp().getBxdmod().getBxd().getYfsjhm()))
			  {
			    ctx.setFieldError(this,"litp.bxdmod.bxd.yfczhm",MdaUtils.getI18NString("litmdl","CT000011"));

			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0051.script
        */
        @Check(target="litp.lidgrp.lxd.yfyzbm",order=100)
        public boolean checkLitpLidgrpLxdYfyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLidgrp().getLxd().getYfyzbm()))
			{
			  String str=this.getLidgrp().getLxd().getYfyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfyzbm",MdaUtils.getI18NString("litmdl","CT000042"));
			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0052.script
        */
        @Check(target="litp.lidgrp.lxd.dsyzbm",order=100)
        public boolean checkLitpLidgrpLxdDsyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getDsyzbm()))
			{
			  String str=this.getLidgrp().getLxd().getDsyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.dsyzbm",MdaUtils.getI18NString("litmdl","CT000043"));
			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0053.script
        */
        @Check(target="litp.lidgrp.lxd.yfczhm",order=100)
        public boolean checkLitpLidgrpLxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfczhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfdzyj())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfsjhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfwxhm())&&MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfqqhm()))
			{
			  ctx.setFieldError(this,"litp.lidgrp.lxd.yfczhm",MdaUtils.getI18NString("litmdl","CT000048"));
			}
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfczhm()))
			{
			  String str=this.getLitp().getLidgrp().getLxd().getYfczhm();
			  String regEX="(0?\\d{2,3}\\-)?[1-9]\\d{6,7}(\\-\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfczhm",MdaUtils.getI18NString("litmdl","CT000049"));
			  }
			}

			return true;
        }

        /**
        *   source:litmdl.@0054.script
        */
        @Check(target="litp.lidgrp.lxd.yfqqhm",order=100)
        public boolean checkLitpLidgrpLxdYfqqhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLitp().getLidgrp().getLxd().getYfqqhm()) )
			{
			  String str=this.getLidgrp().getLxd().getYfqqhm();
			  String regEX="[1-9][0-9]{4,9}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"litp.lidgrp.lxd.yfqqhm",MdaUtils.getI18NString("litmdl","CT000050"));
			  }
			}

			return true;
        }


        /**
        *   source:litmdl.@0001.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			//  定义步骤条
			this.getLitp().getStpmod().storePanel(this.getLitp().getLitmdl07(),this.getLitp().getLitmdl05(),this.getLitp().getLitmdl09(),this.getLitp().getLitmdl11(),this.getLitp().getLitmdl12());
			String steps = "0:信用证申请;1:信用证协议;4:保存模板";
			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:litmdl.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//为推送交易赋值
			this.getLitp().getBummod().setModtyp("litapn");
			this.getLidgrp().getRec().setMarginflg("0000");
			//信用证申请赋初值
			
			String tenor =this.getLidgrp().getRec().getTenor();
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);
			
			
			
			
			
			
			
			
			
			
			
			
			
			this.getLidgrp().getDap().initDap("lid");
			this.getLidgrp().getApl().copyValues(this.getLidgrp().getDap());
			log.debug("{}","message"+this.getLidgrp().getApl().getPts().getNam());
			this.getLidgrp().getApl().getPts().setRol("apl");
			this.getLidgrp().getRec().setConcur("USD");
			this.getLidgrp().getRec().setIsscur("USD");

			this.getLidgrp().getRec().setCredat(MdaUtils.sqlDate(MdaUtils.today(),GE));
			
			
			
			
			this.getLidgrp().getRec().setNomflg(FALSE);
			this.getLidgrp().getRec().setIssinf("1");
			// $lidgrp\\rec\\shppar.setValue("2");
			//$lidgrp\\rec\\shptrs.setValue("2");
			this.getLidgrp().getRec().setTrfflg("1");
			//$lidgrp\\rec\\upsflg.setValue("2");
			this.getLidgrp().getRec().setCnfflg("3");
			this.getLidgrp().getRec().setAvbwths("1");
			this.getLidgrp().getRec().setAvbwth("ANY BANK");
			this.getLidgrp().getRec().setAvbby("0");
			this.getLidgrp().getRec().setTrdtrm("CFR");
			this.getLidgrp().getRec().setTrdflg(FALSE);
			//Platform.setValues($lidgrp\\rec\\trfflg,Platform.getCodetable("trfflg"));
			this.getLidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			//$lidgrp\\rec\\sedday.setValue("21");
			this.getLidgrp().getRec().setSstdat("1");
			this.getLidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getLidgrp().getRec().setPreper("Documents To Be Presented After The Date Of SHIPMENT ,But Within The Validity Of The Credit.");
			this.getLidgrp().getRec().setApprul("1");
			this.getLidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			this.getLitp().setAplnam(this.getSysmod().getPty().getNam());
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getLitp().getOpncls().getCls(),new Argument<String>("inr",this.getLitp().getOpncls().readDefaultClsInr("litapn")));
			  this.getLidgrp().getBlk().setRgtcls(this.getLitp().getOpncls().getCls().getClstxt());
			}

			//信用证合同开立界面下拉框赋初值
			this.getLidgrp().getLxd().setXyzqk("1");
			ctx.postRule(this,"lidgrp.lxd.xyzqk");
			this.getLidgrp().getLxd().setZyjjfs("1");
			ctx.postRule(this,"lidgrp.lxd.zyjjfs");

			return true;
        }


        /**
        *   source:litmdl.@0050.script
        */
        public void loadApl(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPty(),new Argument<String>("inr",ptyinr));
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPta(),new Argument<String>("ptyinr",ptyinr));
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getAdr(),new Argument<String>("inr",this.getLidgrp().getApl().getPta().getObjinr()));
			this.getLidgrp().getApl().getPts().setRol("apl");
			this.getLidgrp().getApl().getPts().setPtyinr(this.getLidgrp().getApl().getPty().getInr());
			this.getLidgrp().getApl().getPts().setObjtyp("lid");
			this.getLidgrp().getApl().getPts().setNam(this.getLidgrp().getApl().getPty().getEngnam());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPty().getEngnam())&&MdaUtils.isEmpty(this.getLidgrp().getApl().getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getLidgrp().getApl().getPty().getEngnam())&&MdaUtils.isEmpty(this.getLidgrp().getApl().getAdr().getAdr()))
			  adrblk = this.getLidgrp().getApl().getPty().getEngnam();
			else if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPty().getEngnam())&&!MdaUtils.isEmpty(this.getLidgrp().getApl().getAdr().getAdr()))
			  adrblk = this.getLidgrp().getApl().getAdr().getAdr();
			else
			  adrblk = this.getLidgrp().getApl().getPty().getEngnam() + CR + this.getLidgrp().getApl().getAdr().getAdr();
			this.getLidgrp().getApl().getPts().setAdrblk(adrblk);
			this.getLidgrp().getApl().getPts().setExtkey(this.getLidgrp().getApl().getPty().getExtkey());
			this.getLidgrp().getApl().getPts().setRef("");
			this.getLidgrp().getApl().getPts().setPtainr(this.getLidgrp().getApl().getPta().getInr());
		}









}