package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证开立申请
*/
@Transaction(vo= LitopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litopn.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litopn.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litopn.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litopn.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litopn.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litopn.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litopn.@0013.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getLidgrp()))
			{
			  log.warn("{}","1页面校验未通过，退出！");
			  return false;
			}
			if((!MdaUtils.isEmpty(this.getLidgrp().getRec().getBzjgh())&&(!"".equals(this.getLidgrp().getRec().getBzjgh())))&&(!ctx.checkAll(this.getLitp().getFpdgrp().getRec())))
			{
			  log.warn("{}","2页面校验未通过，退出！");
			  return false;
			}

			log.info("{}","页面校验完成");
			//处理货描
			lcrgods();
			//处理其他单据
			adlcnds();
			//将页面上需要组合的值赋值到数据库字段中 Begin=========
			//将页面上需要组合的值赋值到数据库字段中 End=========
			//将Module数据入库 Begin==========
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());

			  String objinr = this.getLidgrp().getRec().getInr();
			  //申请人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getApl().getPts(),objinr);
			  //受益人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getBen().getPts(),objinr);
			  //通知行
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getAdv().getPts(),objinr);
			  //付款人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getDre().getPts(),objinr);
			  //转通知行
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getTdb().getPts(),objinr);
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getLidgrp().getRec().setIbchcod(this.getLidgrp().getRec().getBchcod());
			  else
			    this.getLidgrp().getRec().setDbchcod(this.getLidgrp().getRec().getBchcod());
			  this.getLidgrp().getRec().setInr(Platform.sdbCounter("lid"));
			  this.getLidgrp().getRec().setFlg("0");
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getRec());
			  String objinr = this.getLidgrp().getRec().getInr();
			  this.getLidgrp().getBlk().setInr(objinr);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getBlk());
			  String objtyp = "lid";

			  //申请人
			  this.getLidgrp().getApl().savpts(objinr,objtyp);
			  //受益人
			  this.getLidgrp().getBen().savpts(objinr,objtyp);
			  //通知行
			  this.getLidgrp().getAdv().savpts(objinr,objtyp);
			  //付款人
			  this.getLidgrp().getDre().savpts(objinr,objtyp);
			  //直接申请行
			  this.getLidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getLidgrp().getDap().getPts().setObjinr(objinr);
			  this.getLidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getDap().getPts());
			  //转通知行
			  this.getLidgrp().getTdb().savpts(objinr,objtyp);
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getLidgrp().getDap().savTrp(objtyp,objinr);
			  }
			}
			if(TRUE.equals(this.getLidgrp().getRec().getBzjgh()))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")&&(!MdaUtils.isEmpty(this.getLitp().getFpdgrp().getRec().getInr())))
			  {
			    this.getLitp().getFpdgrp().getRec().setObjinr(this.getLidgrp().getRec().getInr());
			    ctx.getDaoSession().dbUpdate(this.getLitp().getFpdgrp().getRec());
			  }
			  else
			  {
			    this.getLitp().getFpdgrp().getRec().setObjfrm(ctx.getTransName());
			    this.getLitp().getFpdgrp().getRec().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			    this.getLitp().getFpdgrp().getRec().setObjinr(this.getLidgrp().getRec().getInr());
			    this.getLitp().getFpdgrp().getRec().setInr(Platform.sdbCounter("fpd"));
			    ctx.getDaoSession().dbInsert(this.getLitp().getFpdgrp().getRec());
			  }
			}

			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			IPanel[] panels=this.getLitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			// Platform.saveDisplay($litp\\litp01,filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:litopn.@0014.script
        */
        @Rule(target="lidgrp.rec.avbby",order=100)
        public boolean ruleLidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getLidgrp().getRec().getAvbby();
			log.debug("{}","on evt.litopn.avbby...  avbby =" + avbby);
			if("1".equals(avbby))
			{
			  //$lidgrp\\rec\\avbwths.setValue("2");
			  //$lidgrp\\rec\\avbwth.setValue("ISSUING BANK");
			  // Platform.clear($lidgrp\\blk\\defdet);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  // Platform.enable($lidgrp\\blk\\dftat);
			  //  Platform.setRequired($lidgrp\\blk\\dftat);
			  
			  
			  //Platform.enable($lidgrp\\dre\\pts\\extkey);
			  //Platform.enable($lidgrp\\dre\\pts\\adrblk);
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			}
			else if("2".equals(avbby))
			{
			  // $lidgrp\\rec\\avbwths.setValue("1");
			  // Platform.enable($lidgrp\\rec\\avbwth);
			  
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  // Platform.clear($lidgrp\\blk\\dftat);
			  
			  //Platform.clear($lidgrp\\dre\\pts\\extkey);
			  // Platform.clear($lidgrp\\dre\\pts\\adrblk);
			  
			  
			  
			  
			  // Platform.disable($lidgrp\\dre\\pts\\extkey);
			  // Platform.disable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("3".equals(avbby))
			{
			  // $lidgrp\\rec\\avbwths.setValue("1");
			  // Platform.enable($lidgrp\\rec\\avbwth);
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  
			  //   Platform.clear($lidgrp\\blk\\dftat);
			  //Platform.clear($lidgrp\\dre\\pts\\extkey);
			  //Platform.clear($lidgrp\\dre\\pts\\adrblk);
			  //  Platform.disable($lidgrp\\blk\\dftat);
			  
			  // Platform.setNotRequired($lidgrp\\blk\\dftat);
			  //Platform.disable($lidgrp\\dre\\pts\\extkey);
			  // Platform.disable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("4".equals(avbby))
			{
			  // $lidgrp\\rec\\avbwths.setValue("1");
			  // Platform.enable($lidgrp\\rec\\avbwth);
			  // Platform.clear($lidgrp\\blk\\defdet);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  //  Platform.enable($lidgrp\\blk\\dftat);
			  
			  //  Platform.setNotRequired($lidgrp\\blk\\dftat);
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			  // Platform.enable($lidgrp\\dre\\pts\\extkey);
			  // Platform.enable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("5".equals(avbby))
			{
			  // $lidgrp\\rec\\avbwths.setValue("3");
			  //$lidgrp\\rec\\avbwth.setValue("ADVISING BANK");
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  // Platform.enable($lidgrp\\blk\\dftat);
			  
			  // Platform.setNotRequired($lidgrp\\blk\\dftat);
			  
			  //Platform.enable($lidgrp\\dre\\pts\\extkey);
			  //Platform.enable($lidgrp\\dre\\pts\\adrblk);
			}
			// Platform.setModified($lidgrp\\rec\\avbwths);
			// Platform.setModified($lidgrp\\rec\\avbwth);
			
			
			//  Platform.setModified($lidgrp\\blk\\dftat);
			// Platform.setModified($lidgrp\\dre\\pts\\extkey);
			// Platform.setModified($lidgrp\\dre\\pts\\adrblk);
			Modules.postDefaultRule(this,"lidgrp.blk.defdet");

			return true;
        }

        /**
        *   source:litopn.@0015.script
        */
        @Rule(target="lidgrp.rec.concur",order=100)
        public boolean ruleLidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			{
			  return true;
			}
			this.getLidgrp().getRec().setIsscur(this.getLidgrp().getRec().getConcur());
			Modules.postDefaultRule(this,"lidgrp.blk.word");
			

			return true;
        }

        /**
        *   source:litopn.@0016.script
        */
        @Rule(target="lidgrp.rec.nomflg",order=100)
        public boolean ruleLidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			{
			  //勾选
			  // Platform.setRequired($lidgrp\\rec\\nomtop);
			  // Platform.setRequired($lidgrp\\rec\\nomton);
			  
			  
			}
			else
			{
			  this.getLidgrp().getRec().setNomtop(0);
			  this.getLidgrp().getRec().setNomton(0);
			  
			  
			}

			
			

			return true;
        }

        /**
        *   source:litopn.@0017.script
        */
        @Rule(target="lidgrp.rec.trdflg",order=100)
        public boolean ruleLidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getTrdflg()))
			{
			  //Platform.setRequired($lidgrp\\rec\\trdtrmver);
			  
			  this.getLidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2010");
			}
			else
			{
			  this.getLidgrp().getRec().setTrdtrmver(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:litopn.@0018.script
        */
        @Rule(target="mtabut.ped",order=200)
        public boolean ruleMtabutPedN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  String typ=ctx.getTransName().substring(0,2);
			  String ptyname=this.getTrnmod().getPtyName(ctx.absGet(Sysmod.class).getPty().getInr());
			  this.getSysmod().getSpt().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			  this.getSysmod().getSpt().setObjinr("");
			  this.getSysmod().getSpt().setObjnam(this.getLidgrp().getRec().getIsscur()+this.getLidgrp().getRec().getIssamt()+"/"+ptyname);
			  this.getSysmod().getSpt().setNam(this.getLidgrp().getRec().getIsscur()+this.getLidgrp().getRec().getIssamt()+"/"+ptyname);
			}

			return true;
        }

        /**
        *   source:litopn.@0021.script
        */
        @Rule(target="lidgrp.rec.avbwths",order=100)
        public boolean ruleLidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("5".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  this.getLidgrp().getRec().setAvbwth(NULLSTR);
			  
			  
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  
			  
			  this.getLidgrp().getRec().setAvbwth("CONFIRMING BANK");
			  if("3".equals(this.getLidgrp().getRec().getCnfflg()))
			  {
			    ctx.setFieldError(this,"lidgrp.rec.avbwths",MdaUtils.getI18NString("litopn","CT000228"));
			  }
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			  if(!"3".equals(this.getLidgrp().getRec().getCnfflg()))
			  {
			    ctx.setFieldError(this,"lidgrp.rec.avbwths",MdaUtils.getI18NString("litopn","CT000243"));
			  }
			  
			  
			}
			

			return true;
        }

        /**
        *   source:litopn.@0022.script
        */
        @Rule(target="lidgrp.rec.apprul",order=100)
        public boolean ruleLidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  

			  //$lidgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  
			  //$lidgrp\\rec\\apprultxt.setValue(Platform.getCodetableLabel("apprul",$lidgrp\\rec\\apprul.getValue()));
			}
			

			return true;
        }

        /**
        *   source:litopn.@0023.script
        */
        @Rule(target="lidgrp.rec.sstdat",order=100)
        public boolean ruleLidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getLidgrp().getRec().getSstdat()))
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(NULLSTR);
			  //$lidgrp\\rec\\sstdattxt.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",this.getLidgrp().getRec().getSstdat()));
			}
			

			return true;
        }

        /**
        *   source:litopn.@0025.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}"," check tenor =" + this.getLidgrp().getRec().getTenor());
			/*
			  if("U".equals($lidgrp\\rec\\tenor.getValue()) )
			  {
			  if( Platform.isEmpty($litp\\tedays ) )
			  {
			  log.debug(" check err tedays "  );
			  Platform.error($litp\\tedays,#CT000169);
			  Platform.setModified($litp\\tedays);
			  return false ;
			  }
			  if( Platform.isEmpty($litp\\usapro ) )
			  {
			  Platform.error($litp\\usapro,#CT000170);
			  Platform.setModified($litp\\usapro );
			  return false  ;
			  }
			  }
			  */
			if(ctx.checkAll(this.getLidgrp())  )
			  ctx.setMessage(MdaUtils.getI18NString("litopn","CT000220"),MdaUtils.getI18NString("litopn","CT000221"));
			log.debug("{}"," check end....  ");


			return true;
        }

        /**
        *   source:litopn.@0005.script
        */
        @Rule(target="lidgrp.rec.bchcod",order=100)
        public boolean ruleLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:litopn.@0030.script
        */
        @Rule(target="lidgrp.rec.trfflg",order=100)
        public boolean ruleLidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getLidgrp().getRec().getTrfflg()))
			  this.getLidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setTrfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litopn.@0031.script
        */
        @Rule(target="lidgrp.rec.cnfflg",order=100)
        public boolean ruleLidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )
			{  //MAY ADD
			  if("1".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for Applicant's account.");
			  }
			  if("2".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for Beneficiary's account.");
			  }
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )
			{ //CONFIRM
			  if("1".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("confirm charges are for Applicant's account.");
			  }
			  if("2".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("confirm charges are for Beneficiary's account.");
			  }
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  this.getLidgrp().getBlk().setCnfdet(NULLSTR);
			  this.getLidgrp().getRec().setConchrgby(NULLSTR);
			  this.getLidgrp().getCon().getPts().setAdrblk(NULLSTR);
			  this.getLidgrp().getCon().getPts().setExtkey(NULLSTR);
			}
			
			
			
			

			return true;
        }

        /**
        *   source:litopn.@0035.script
        */
        @Rule(target="mtabut.mail",order=200)
        public boolean ruleMtabutMailN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("litopnApp"+inr,"litopn");
			this.getMtabut().creatTcoPdfFile("litopnDra"+inr);
			this.getMtabut().setAttnames("litopnApp"+inr+".pdf;litopnDra"+inr+".pdf");

			return true;
        }

        /**
        *   source:litopn.@0043.script
        */
        @Rule(target="mtabut.sftdra",order=50)
        public boolean ruleMtabutSftdraN50(){
            IContext ctx = MdaEnv.getContext();
            
			lcrgods();
			adlcnds();

			return true;
        }

        /**
        *   source:litopn.@0044.script
        */
        @Rule(target="mtabut.xptslt",order=100)
        public boolean ruleMtabutXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  //0818测试代码
			  if(!Platform.isEmpty($lidgrp\\rec\\ownref.getValue()))
			  {
			
			  //上传
			
			  String transaction=Platform.getTransName();
			  String ownref=$lidgrp\\rec\\ownref.getValue();
			  String regcod=$lidgrp\\rec\\ownref.getValue();
			  String usr=$sysmod\\usr\\depnam.getValue();
			  Platform.invoke("client:","ImageUpload",transaction,ownref,regcod,usr);
			  }
			  else
			  {
			
			  //查询
			  log.debug("image query ... ");
			  Map<String,Object> data1 = new HashMap<String,Object>();
			  data1.put("occurdate","2017-10-25");
			  data1.put("downloadpath","/weblogic/webapps/resource/img/"+Platform.format(Platform.today(),"yyyyMMdd"));
			  data1.put("needannotation","0");
			  data1.put("needthumbnail","0");
			  List<Map<String,Object> > conditionList = new  ArrayList<Map<String,Object> >();
			  Map<String,Object> data2 = new HashMap<String,Object>();
			  Map<String,Object> data3 = new HashMap<String,Object>();
			  data2.put("propertyname","OwnRef");
			  data2.put("propertyvalue","08101LA17000004");
			  data3.put("propertyname","ImageRegID");
			  data3.put("propertyvalue","08101LA17000004");
			  conditionList.add(data2);
			  conditionList.add(data3);
			  List<String> propertylist = new  ArrayList<String>();
			  propertylist.add("FlowID");
			  propertylist.add("CibBranchID");
			  propertylist.add("CibOrgID");
			  propertylist.add("CibOperID");
			  data1.put("propertylist",propertylist);
			  data1.put("conditionList",conditionList);
			  String cls="com.brilliance.eibs.main.Client";
			  Object resMsg = Platform.invoke(cls,"scall","dzticmquery","dzticmquery", new Object[]{data1});
			  if((Boolean)Platform.invoke(resMsg,"isSuccess"))
			  {
			  Object content = (Object)Platform.invoke(resMsg,"getContent") ;
			  String isSuc = content.toString().substring(0,5);  //前5位是true 或者 false，表示成功失败，后面20位是错误码
			  log.debug("(content:" + content.toString() + ",isSuc:" + isSuc +")");
			  if("true ".equals(isSuc))
			  {
			  //通过ICM API 接口下载成功后，调用影像控件进行展示
			  String transaction=Platform.getTransName();
			  String ownref="08101LA17000004";
			  String regcod="08101LA17000004";
			  String usr=$sysmod\\usr\\depnam.getValue();
			
			  Platform.invoke("client:","ImageScan",transaction,ownref,regcod,usr);
			
			  return true;
			  }
			  else
			  {
			  Platform.message(#CT000199,#CT000200);
			  return;
			  }
			  }
			  }
			  */
			MdaUtils.clear(this.getMtabut().getXptqna());
			this.getMtabut().getXptqna().setRef(this.getLidgrp().getRec().getOwnref());
			log.debug("{}","ref="+this.getMtabut().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getMtabut().getXptqna());
			


			return true;
        }

        /**
        *   source:litopn.@0054.script
        */
        @Rule(target="lidgrp.rec.tenor",order=100)
        public boolean ruleLidgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isModified(this.getLidgrp().getBlk(),"dftat") && "S".equals(this.getLidgrp().getRec().getTenor()))
			{
			  this.getLidgrp().getBlk().setDftat("sight for 100 pct of the invoice value");
			}
			if("S".equals(this.getLidgrp().getRec().getTenor()))
			{
			  this.getLidgrp().getRec().setAvbby("5");
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  // Platform.enable($lidgrp\\blk\\dftat);
			  
			  // Platform.setNotRequired($lidgrp\\blk\\dftat);
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:litopn.@0062.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 2;
			String labels = "进口信用证开立申请,进口信用证开立报文草稿";
			String tempfiles = "A:litopn,S:litopn";
			if(TRUE.equals(this.getLidgrp().getRec().getBzjgh()))
			{
			  cnt = 3;
			  labels = "进口信用证开立申请,保证金购汇申请,进口信用证开立报文草稿";
			  tempfiles = "A:litopn,A:fptapn,S:litopn";
			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:litopn.@0063.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			//获取Value取对应的Label值
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","litopn",stream,false );

			return true;
        }

        /**
        *   source:litopn.@0065.script
        */
        @Rule(target="litp.lidgrp.rec.conchrgby",order=100)
        public boolean ruleLitpLidgrpRecConchrgbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )
			{  //MAY ADD
			  if("1".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for Applicant's account.");
			  }
			  if("2".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for Beneficiary's account.");
			  }
			}
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )
			{ //CONFIRM
			  if("1".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("confirm charges are for Applicant's account.");
			  }
			  if("2".equals(this.getLidgrp().getRec().getConchrgby()) )
			  {
			    this.getLidgrp().getBlk().setCnfdet("confirm charges are for Beneficiary's account.");
			  }
			}
			

			return true;
        }

        /**
        *   source:litopn.@0067.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litopn","信用证申请",1);

			return true;
        }

        /**
        *   source:litopn.@0069.script
        */
        @Rule(target="mtabut.sftdra",order=100)
        public boolean ruleMtabutSftdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callSwiftPDFComponent("","litopn","信用证申请",1);

			return true;
        }

        /**
        *   source:litopn.@0070.script
        */
        @Rule(target="mtabut.csche",order=100)
        public boolean ruleMtabutCscheN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","litopn","信用证申请",1);

			return true;
        }

        /**
        *   source:litopn.@0071.script
        */
        @Rule(target="mtabut.draftmsg",order=100)
        public boolean ruleMtabutDraftmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callSwiftPDFComponent("","litopn","信用证申请",1);

			return true;
        }

        /**
        *   source:litopn.@0072.script
        */
        @Rule(target="litp.lidgrp.rec.trdtrm",order=100)
        public boolean ruleLitpLidgrpRecTrdtrmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("7".equals(this.getLidgrp().getRec().getTrdtrm()))
			{
			  
			  this.getLidgrp().getRec().setOthtrdtrm(NULLSTR);
			  
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  //$lidgrp\\rec\\othtrdtrm.setValue(Platform.getCodetableLabel("trdtrm",$lidgrp\\rec\\trdtrm.getValue()));
			  this.getLidgrp().getRec().setOthtrdtrm(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:litopn.@0076.script
        */
        @Rule(target="mtabut.busmod.select",order=110)
        public boolean ruleMtabutBusmodSelectN110(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  

			}
			else
			{
			  
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			}
			
			ctx.postRule(this,"lidgrp.rec.avbby");
			ctx.postRule(this,"lidgrp.rec.bchcod");
			//Platform.postEventRule($lidgrp\\rec\\cnfflg,onChange,null);
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )
			{  //MAY ADD
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )
			{ //CONFIRM
			  
			  
			  
			  
			  
			  
			}
			else
			{
			}
			
			
			
			
			ctx.postRule(this,"lidgrp.rec.concur");
			ctx.postRule(this,"lidgrp.rec.nomflg");
			ctx.postRule(this,"lidgrp.rec.tenor");
			ctx.postRule(this,"lidgrp.rec.trdflg");
			//Platform.postEventRule($lidgrp\\rec\\trfflg,onChange,null);
			//Platform.postEventRule($lidgrp\\rec\\upsflg,onChange,null);
			if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			{
			}
			else
			{
			}
			ctx.postRule(this,"lidgrp.rec.conchrgby");
			//Platform.postEventRule($lidgrp\\rec\\trdtrm,onChange,null);
			if("7".equals(this.getLidgrp().getRec().getTrdtrm()))
			{
			  
			  
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setOthtrdtrm(MdaUtils.getCodetableLabel("trdtrm",this.getLidgrp().getRec().getTrdtrm()));
			  
			}
			
			Modules.postDefaultRule(this,"lidgrp.blk.defdet");
			Modules.postDefaultRule(this,"lidgrp.blk.dftat");
			Modules.postDefaultRule(this,"lidgrp.blk.word");
			Modules.postDefaultRule(this,"lidgrp.rec.apprultxt");
			Modules.postDefaultRule(this,"lidgrp.rec.avbby");
			//Platform.postEventRule($lidgrp\\rec\\avbwths,onChange,null);
			if("5".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  

			  
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  
			  this.getLidgrp().getRec().setAvbwth("CONFIRMING BANK");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			  
			}
			Modules.postDefaultRule(this,"lidgrp.rec.credat");
			Modules.postDefaultRule(this,"lidgrp.rec.preper");
			Modules.postDefaultRule(this,"lidgrp.rec.sstdattxt");
			if("3".equals(this.getLidgrp().getRec().getSstdat()))
			{
			  

			}
			else
			{
			  

			}
			
			Modules.postDefaultRule(this,"lidgrp");
			Modules.postDefaultRule(this,"lidgrp.usapro");
			Modules.postDefaultRule(this,"litp.nodra");
			//保证金协议条款相关
			if((MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzhm())||"".equals(this.getLidgrp().getRec().getDbbzjzhm()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzh())||"".equals(this.getLidgrp().getRec().getDbbzjzh())))
			{
			  this.getLidgrp().setNedbzj("");
			  this.getLidgrp().getRec().setBzjbl(new BigDecimal(0));
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("");
			  
			  this.getLidgrp().setChkbzj2("√");
			  
			  
			  this.getLidgrp().getRec().setBzjgh(NULLSTR);
			  
			}
			else
			{
			  this.getLidgrp().setNedbzj("X");
			  
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("√");
			  
			  this.getLidgrp().setChkbzj2("");
			  
			  
			}
			if(TRUE.equals(this.getLidgrp().getRec().getBzjgh()))
			{
			  
			}
			else
			{
			  
			}

			//
			this.getLitp().getStpmod().storePanel(this.getLitp().getLitopn01(),this.getLitp().getFpdopn01());
			String steps = "0:信用证开立";
			if((!MdaUtils.isEmpty(this.getLidgrp().getRec().getBzjgh())||(!"".equals(this.getLidgrp().getRec().getBzjgh())))&&!"CNY".equals(this.getLitp().getLidgrp().getRec().getIsscur()))
			{
			  steps = "0:信用证开立;1:保证金购汇";
			}

			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:litopn.@0077.script
        */
        @Rule(target="litp.lidgrp.nedbzj",order=100)
        public boolean ruleLitpLidgrpNedbzjN100(){
            IContext ctx = MdaEnv.getContext();
            
			if((!MdaUtils.isEmpty(this.getLidgrp().getNedbzj())||(!"".equals(this.getLidgrp().getNedbzj()))))
			{
			  
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("√");
			  
			  this.getLidgrp().setChkbzj2("");
			  
			  
			}
			else
			{
			  
			  
			  
			  this.getLidgrp().getRec().setDbbzjzhm(NULLSTR);
			  this.getLidgrp().getRec().setDbbzjzh(NULLSTR);
			  this.getLidgrp().getRec().setBzjbl(new BigDecimal(0));
			  
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("");
			  
			  this.getLidgrp().setChkbzj2("√");
			  
			  this.getLidgrp().getRec().setBzjgh("");
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:litopn.@0081.script
        */
        @Rule(target="litp.lidgrp.rec.bzjgh",order=100)
        public boolean ruleLitpLidgrpRecBzjghN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Litopn  init业务处理开始，ORDER编号:90");
			String steps = "";

			if((!MdaUtils.isEmpty(this.getLidgrp().getNedbzj())||(!"".equals(this.getLidgrp().getNedbzj())))&&(!MdaUtils.isEmpty(this.getLidgrp().getRec().getBzjgh())||(!"".equals(this.getLidgrp().getRec().getBzjgh())))&&!"CNY".equals(this.getLitp().getLidgrp().getRec().getIsscur()))
			{
			  steps = "0:信用证开立;1:保证金购汇";

			  //处理保证金购汇
			  this.dealbzjgh();
			}
			else
			{
			  
			  steps = "0:信用证开立";
			}

			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();


			return true;
        }

        /**
        *   source:litopn.@0082.script
        */
        @Rule(target="litp.stpmod.gostep",order=50)
        public boolean ruleLitpStpmodGostepN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getLitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);
			if(1==stepIdx)
			{
			  this.dealbzjgh();
			}

			switch(panelidx)
			{
			  case 0:
			  {
			    return ctx.checkAll(this.getLidgrp());
			  }
			  case 1:
			  {
			    return ctx.checkAll(this.getLitp().getFpdgrp().getRec());
			  }
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:litopn.@0083.script
        */
        @Rule(target="litp.stpmod.next",order=50)
        public boolean ruleLitpStpmodNextN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getLitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);
			if(1==stepIdx)
			{
			  this.dealbzjgh();
			}

			switch(panelidx)
			{
			  case 0:
			  {
			    return ctx.checkAll(this.getLidgrp());
			  }
			  case 1:
			  {
			    return ctx.checkAll(this.getLitp().getFpdgrp().getRec());
			  }
			}

			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:litopn.@0084.script
        */
        @Rule(target="litp.stpmod.last",order=50)
        public boolean ruleLitpStpmodLastN50(){
            IContext ctx = MdaEnv.getContext();
            
			int panelidx=this.getLitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			switch(panelidx)
			{
			  case 0:
			  {
			    return ctx.checkAll(this.getLidgrp());
			  }
			  case 1:
			  {
			    return ctx.checkAll(this.getLitp().getFpdgrp().getRec());
			  }
			}
			log.debug("{}","gostep Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:litopn.@0085.script
        */
        @Rule(target="litp.stpmod.next",order=110)
        public boolean ruleLitpStpmodNextN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getLitp().getStpmod().getCuridx();
			log.info("{}","下一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter next 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter next 110!!!!!!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:litopn.@0086.script
        */
        @Rule(target="litp.stpmod.last",order=110)
        public boolean ruleLitpStpmodLastN110(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx = this.getLitp().getStpmod().getCuridx();
			log.info("{}","上一步curIdx========="+curIdx);
			if(curIdx==1)
			{
			  log.info("{}","enter last 110=========1");
			  
			}
			else
			{
			  log.info("{}","enter last 110!!!!!!!=========1");
			  
			}
			

			return true;
        }

        /**
        *   source:litopn.@0088.script
        */
        @Rule(target="litp.lidgrp.rec.issamt",order=100)
        public boolean ruleLitpLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if((!Platform.isEmpty($lidgrp\\rec\\issamt.getValue())||(!"".equals($lidgrp\\rec\\issamt.getValue())))&&(!Platform.isEmpty($lidgrp\\rec\\bzjbl.getValue())||(!"".equals($lidgrp\\rec\\bzjbl.getValue()))))
			  {
			  //获取保证金购汇金额
			  BigDecimal outamt = $lidgrp\\rec\\issamt.getValue();
			  BigDecimal bzjbl = $lidgrp\\rec\\bzjbl.getValue();
			  outamt = outamt.multiply(bzjbl).divide(new BigDecimal(100));
			  $litp\\fpdgrp\\rec\\outamt.setValue(outamt);
			  $litp\\fpdgrp\\cur.setValue($litp\\lidgrp\\rec\\isscur.getValue());
			  $litp\\fpdgrp\\amt.setValue(outamt);
			  }*/

			return true;
        }

        /**
        *   source:litopn.@0089.script
        */
        @Rule(target="litp.lidgrp.rec.bzjbl",order=100)
        public boolean ruleLitpLidgrpRecBzjblN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealbzjghamt();

			return true;
        }

        /**
        *   source:litopn.@0092.script
        */
        @Rule(target="litp.fpdgrp.fpdpdf",order=100)
        public boolean ruleLitpFpdgrpFpdpdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getPdfviw().callPDFComponent("","fptapn","信用证申请",1);

			return true;
        }

        /**
        *   source:litopn.@0093.script
        */
        @Rule(target="lidgrp.rec.upsflg",order=100)
        public boolean ruleLidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			  this.getLidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litopn.@0095.script
        */
        @Rule(target="litp.lidgrp.rec.isscur",order=100)
        public boolean ruleLitpLidgrpRecIsscurN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealbzjghamt();

			return true;
        }

        /**
        *   source:litopn.@0096.script
        */
        @Rule(target="litp.lidgrp.rec.dbbzjzh",order=100)
        public boolean ruleLitpLidgrpRecDbbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getFpdgrp().getRec().setOutcno(this.getLidgrp().getRec().getDbbzjzh());
			

			return true;
        }

        /**
        *   source:litopn.@0097.script
        */
        @Rule(target="litp.lidgrp.blk.lcrgod",order=100)
        public boolean ruleLitpLidgrpBlkLcrgodN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String[] god = $litp\\lidgrp\\blk\\lcrgod.getValue().split("\\\\n");
			  log.info("god 行数 ：" + god.length);
			  if(god.length > 18)
			  {
			  StringBuffer god1 = new StringBuffer();
			  StringBuffer god2 = new StringBuffer();
			  for(int i = 0; i < 18; i++ )
			  {
			  god1 = god1.append(god[i]).append(CR);
			  }
			  for(int j = 18; j < god.length; j++)
			  {
			  god2 = god2.append(god[j]).append(CR);
			  }
			  $lidgrp\\lcrgod1.setValue(god1.toString());
			  $lidgrp\\lcrgod2.setValue(god2.toString());
			  log.info("货描上半部分"+$lidgrp\\lcrgod1.getValue());
			  log.info("货描下半部分"+$lidgrp\\lcrgod2.getValue());
			  }
			  */

			return true;
        }

        /**
        *   source:litopn.@0098.script
        */
        @Rule(target="litp.accbtn",order=100)
        public boolean ruleLitpAccbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:litopn.@0099.script
        */
        @Rule(target="litp.actmod.actslt",order=100)
        public boolean ruleLitpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getLitp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("litopn","CT000244"),MdaUtils.getI18NString("litopn","CT000245"));
			  return false;
			}
			String rmbact=this.getLitp().getActmod().getActlst().getElement(index).getAct();
			this.getLitp().getFpdgrp().getRec().setCnycno(rmbact);
			
			

			return true;
        }

        /**
        *   source:litopn.@0101.script
        */
        @Rule(target="litp.tipurl",order=100)
        public boolean ruleLitpTipurlN100(){
            IContext ctx = MdaEnv.getContext();
            
			String url="";
			MdaUtils.invoke("client:","opentab",url);

			return true;
        }

        /**
        *   source:litopn.@0102.script
        */
        @Rule(target="lidgrp.rec.nomtop",order=100)
        public boolean ruleLidgrpRecNomtopN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getNomtop()))
			  ctx.postRule(this,"litp.lidgrp.rec.bzjbl");

			return true;
        }

        /**
        *   source:litopn.@0105.script
        */
        @Rule(target="litp.testbtn",order=100)
        public boolean ruleLitpTestbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLidgrp().getRec(),"conamt"));

			return true;
        }


        /**
        *   source:litopn.@0007.script
        */
        @Check(target="lidgrp.rec.isscur",order=100)
        public boolean checkLidgrpRecIsscurN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}",MdaUtils.getI18NString("litopn","CT000000"));
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIsscur())  ||  MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			  return true;
			String isscur = this.getLidgrp().getRec().getIsscur();
			String concur = this.getLidgrp().getRec().getConcur();
			if(!isscur.equals(concur))
			  ctx.setFieldError(this,"lidgrp.rec.isscur",MdaUtils.getI18NString("litopn","CT000033"));

			return true;
        }

        /**
        *   source:litopn.@0008.script
        */
        @Check(target="lidgrp.rec.issamt",order=100)
        public boolean checkLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getConamt()))
			  return true;
			BigDecimal camt = this.getLidgrp().getRec().getConamt();
			BigDecimal lamt = this.getLidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"lidgrp.rec.issamt",MdaUtils.getI18NString("litopn","CT000001"));
			this.dealbzjghamt();

			return true;
        }

        /**
        *   source:litopn.@0009.script
        */
        @Check(target="lidgrp.rec.expdat",order=100)
        public boolean checkLidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()))
			  return true;
			if(MdaUtils.diff(this.getLidgrp().getRec().getExpdat(),this.getLidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"lidgrp.rec.expdat",MdaUtils.getI18NString("litopn","CT000002"));

			return true;
        }

        /**
        *   source:litopn.@0010.script
        */
        @Check(target="lidgrp.rec.shpdat",order=100)
        public boolean checkLidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpdat()))
			{
			  this.getLitp().setShpdatflg("2");
			  return true;
			}
			Date shpdat = this.getLidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getLidgrp().getRec().getExpdat())>0)
			{
			  ctx.setFieldError(this,"lidgrp.rec.shpdat",MdaUtils.getI18NString("litopn","CT000003"));
			  this.getLitp().setShpdatflg("1");
			}
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()) && MdaUtils.diff(this.getLidgrp().getRec().getCredat(),shpdat)>0)
			{
			  ctx.setFieldError(this,"lidgrp.rec.shpdat",MdaUtils.getI18NString("litopn","CT000239"));
			  this.getLitp().setShpdatflg("1");
			}
			

			return true;
        }

        /**
        *   source:litopn.@0011.script
        */
        @Check(target="lidgrp.rec.nomton",order=100)
        public boolean checkLidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			  return true;
			int nomton = this.getLidgrp().getRec().getNomton();
			//if(nomton.compareTo(new BigDecimal(50))>0  ||  nomton.compareTo(new BigDecimal(0))<0)
			//无小数位的Numberic类型为Integer
			if(nomton>50  ||  nomton<0)
			  ctx.setFieldError(this,"lidgrp.rec.nomton",MdaUtils.getI18NString("litopn","CT000006"));

			return true;
        }

        /**
        *   source:litopn.@0012.script
        */
        @Check(target="lidgrp.agree",order=100)
        public boolean checkLidgrpAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(TRUE.equals(this.getLidgrp().getAgree())))
			{
			  ctx.setFieldError(this,"lidgrp.agree",MdaUtils.getI18NString("litopn","CT000094"));
			  return true;
			}

			return true;
        }

        /**
        *   source:litopn.@0052.script
        */
        @Check(target="lidgrp.tedays",order=100)
        public boolean checkLidgrpTedaysN100(){
            IContext ctx = MdaEnv.getContext();
            
			// log.debug("check tedays .. ");
			// if("U".equals($lidgrp\\rec\\tenor.getValue()) && Platform.isEmpty($lidgrp\\tedays ))
			//   Platform.error($lidgrp\\tedays,#CT000203);
			this.getSysmod().checkInotZ(MdaDriver.getDatafield(this.getLidgrp(),"tedays"));

			return true;
        }

        /**
        *   source:litopn.@0053.script
        */
        @Check(target="lidgrp.usapro",order=100)
        public boolean checkLidgrpUsaproN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","check usapro .. ");
			if("U".equals(this.getLidgrp().getRec().getTenor()) && MdaUtils.isEmpty(this.getLidgrp().getUsapro()))
			  ctx.setFieldError(this,"lidgrp.usapro",MdaUtils.getI18NString("litopn","CT000205"));

			return true;
        }

        /**
        *   source:litopn.@0066.script
        */
        @Check(target="litp.lidgrp.rec.shppod",order=100)
        public boolean checkLitpLidgrpRecShppodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShppod()))
			{
			  this.getLitp().setShppodflg("2");
			  return true;
			}
			else
			{
			  this.getLitp().setShppodflg("1");
			}
			

			return true;
        }

        /**
        *   source:litopn.@0075.script
        */
        @Check(target="litp.lidgrp.rec.nomtop",order=100)
        public boolean checkLitpLidgrpRecNomtopN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			  return true;
			int nomtop = this.getLidgrp().getRec().getNomtop();
			if(nomtop>50  ||  nomtop<0)
			  ctx.setFieldError(this,"lidgrp.rec.nomtop",MdaUtils.getI18NString("litopn","CT000233"));

			return true;
        }

        /**
        *   source:litopn.@0106.script
        */
        @Check(target="litp.lidgrp.rec.conamt",order=100)
        public boolean checkLitpLidgrpRecConamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"conamt"));

			return true;
        }

        /**
        *   source:litopn.@0107.script
        */
        @Check(target="litp.lidgrp.rec.issamt",order=100)
        public boolean checkLitpLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"issamt"));

			return true;
        }

        /**
        *   source:litopn.@0112.script
        */
        @Check(target="litp.lidgrp.rec.bzjbl",order=100)
        public boolean checkLitpLidgrpRecBzjblN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"bzjbl"));

			return true;
        }

        /**
        *   source:litopn.@0113.script
        */
        @Check(target="litp.lidgrp.rec.invoicefe",order=100)
        public boolean checkLitpLidgrpRecInvoicefeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"invoicefe"));

			return true;
        }

        /**
        *   source:litopn.@0114.script
        */
        @Check(target="litp.lidgrp.rec.sxfee",order=100)
        public boolean checkLitpLidgrpRecSxfeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"sxfee"));

			return true;
        }

        /**
        *   source:litopn.@0115.script
        */
        @Check(target="litp.lidgrp.rec.cdfee",order=100)
        public boolean checkLitpLidgrpRecCdfeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"cdfee"));

			return true;
        }

        /**
        *   source:litopn.@0116.script
        */
        @Check(target="litp.lidgrp.rec.sedday",order=100)
        public boolean checkLitpLidgrpRecSeddayN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalSAmt(MdaDriver.getDatafield(this.getLitp().getLidgrp().getRec(),"sedday"));

			return true;
        }


        /**
        *   source:litopn.@0006.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.showReadTet();
			
			//String url="http://www.cebbank.com/site/fwjgml34/21976041/index.html";
			//$litp\\tipurl.setValue(url);
			//$litp\\tipurl.setValue("链接");
			/*
			  $lidgrp\\rec\\tenor.setValue("S");
			  if("S".equals($lidgrp\\rec\\tenor.getValue())&&"4".equals($lidgrp\\rec\\avbby.getValue()))
			  {
			  $lidgrp\\blk\\dftat.setValue("sight for 100 pct of the invoice value");
			  log.debug("dftat........."+$lidgrp\\blk\\dftat.getValue());
			  Platform.setModified($lidgrp\\blk\\dftat);
			  }
			  */
			
			String tenor =this.getLidgrp().getRec().getTenor();
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getLidgrp().getRec().setBchcod(bchcod.get(0).getValue());

			  //从维护的银行协议编号中取贸易融资综合协议编号
			  this.getLitp().getAgrp().qurAgrnum();
			  this.getLidgrp().getRec().setMyrzbh(this.getLitp().getAgrp().getTfn());
			  
			}

			//Platform.clear($lidgrp\\rec);
			//Platform.clear($lidgrp\\blk);
			//Platform.disable($lidgrp\\rec\\ownref);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			//Platform.setRequired($lidgrp\\ben\\pts\\extkey);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  //Platform.postEventRule($lidgrp\\rec\\apprul,onChange,null);
			  if("6".equals(this.getLidgrp().getRec().getApprul()))
			  {
			    
			    

			  }
			  else
			  {
			    
			    
			    this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  }
			  
			  ctx.postRule(this,"lidgrp.rec.avbby");
			  ctx.postRule(this,"lidgrp.rec.bchcod");
			  //Platform.postEventRule($lidgrp\\rec\\cnfflg,onChange,null);
			  if("1".equals(this.getLidgrp().getRec().getCnfflg()) )
			  {  //MAY ADD
			    
			    
			    
			    
			    
			    
			  }
			  else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )
			  { //CONFIRM
			    
			    
			    
			    
			    
			    
			  }
			  else
			  {
			  }
			  
			  
			  
			  
			  ctx.postRule(this,"lidgrp.rec.concur");
			  ctx.postRule(this,"lidgrp.rec.nomflg");
			  ctx.postRule(this,"lidgrp.rec.tenor");
			  ctx.postRule(this,"lidgrp.rec.trdflg");
			  //Platform.postEventRule($lidgrp\\rec\\trfflg,onChange,null);
			  //Platform.postEventRule($lidgrp\\rec\\upsflg,onChange,null);
			  if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			  {
			  }
			  else
			  {
			  }
			  ctx.postRule(this,"lidgrp.rec.conchrgby");
			  //Platform.postEventRule($lidgrp\\rec\\trdtrm,onChange,null);
			  if("7".equals(this.getLidgrp().getRec().getTrdtrm()))
			  {
			    
			    
			    //$lidgrp\\rec\\avbwth.setValue("");
			  }
			  else
			  {
			    
			    this.getLidgrp().getRec().setOthtrdtrm(MdaUtils.getCodetableLabel("trdtrm",this.getLidgrp().getRec().getTrdtrm()));
			    
			  }
			  
			  Modules.postDefaultRule(this,"lidgrp.blk.defdet");
			  Modules.postDefaultRule(this,"lidgrp.blk.dftat");
			  Modules.postDefaultRule(this,"lidgrp.blk.word");
			  Modules.postDefaultRule(this,"lidgrp.rec.apprultxt");
			  Modules.postDefaultRule(this,"lidgrp.rec.avbby");
			  //Platform.postEventRule($lidgrp\\rec\\avbwths,onChange,null);
			  if("5".equals(this.getLidgrp().getRec().getAvbwths()))
			  {
			    

			    
			    //$lidgrp\\rec\\avbwth.setValue("");
			  }
			  else if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			  {
			    
			    
			    this.getLidgrp().getRec().setAvbwth("CONFIRMING BANK");
			  }
			  else
			  {
			    
			    this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			    
			  }
			  Modules.postDefaultRule(this,"lidgrp.rec.credat");
			  Modules.postDefaultRule(this,"lidgrp.rec.preper");
			  Modules.postDefaultRule(this,"lidgrp.rec.sstdattxt");
			  if("3".equals(this.getLidgrp().getRec().getSstdat()))
			  {
			    

			  }
			  else
			  {
			    

			  }
			  
			  Modules.postDefaultRule(this,"lidgrp");
			  Modules.postDefaultRule(this,"lidgrp.usapro");
			  Modules.postDefaultRule(this,"litp.nodra");
			  //保证金协议相关
			  if((MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzhm())||"".equals(this.getLidgrp().getRec().getDbbzjzhm()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzh())||"".equals(this.getLidgrp().getRec().getDbbzjzh())))
			  {
			    this.getLidgrp().setNedbzj("");
			    this.getLidgrp().getRec().setBzjbl(new BigDecimal(0));
			    
			    
			    
			    
			    
			    this.getLidgrp().setChkbzj1("");
			    
			    this.getLidgrp().setChkbzj2("√");
			    
			    this.getLidgrp().getRec().setBzjgh("");
			    
			    
			  }
			  else
			  {
			    this.getLidgrp().setNedbzj("X");
			    
			    
			    
			    
			    
			    this.getLidgrp().setChkbzj1("√");
			    
			    this.getLidgrp().setChkbzj2("");
			    
			    
			    if(TRUE.equals(this.getLidgrp().getRec().getBzjgh()))
			    {
			      
			    }
			  }
			  return true;
			}
			this.getLidgrp().getDap().initDap("lid");
			this.getLidgrp().getApl().copyValues(this.getLidgrp().getDap());
			this.getLitp().getAplp().getPtspta().getPts().setAdrblk( this.getLidgrp().getApl().getPty().getEngnam() + CR + this.getLidgrp().getApl().getAdr().getEnadr());
			
			log.debug("{}","message"+this.getLidgrp().getApl().getPts().getNam());
			this.getLidgrp().getApl().getPts().setRol("apl");
			this.getLidgrp().getRec().setConcur("USD");
			this.getLidgrp().getRec().setIsscur("USD");
			this.getLidgrp().getRec().setCredat(MdaUtils.today());
			//Platform.setRequired($lidgrp\\apl\\pts\\extkey);
			//Platform.setDescription($lidgrp\\apl\\pts\\extkey, #CT000172);
			this.getLidgrp().getRec().setNomflg(FALSE);
			this.getLidgrp().getRec().setIssinf("1");
			this.getLidgrp().getRec().setShppar("2");
			this.getLidgrp().getRec().setShptrs("2");
			this.getLidgrp().getRec().setTrfflg("1");
			this.getLidgrp().getRec().setUpsflg("2");
			this.getLidgrp().getRec().setCnfflg("3");
			this.getLidgrp().getRec().setAvbwths("1");
			this.getLidgrp().getRec().setAvbwth("ANY BANK");
			this.getLidgrp().getRec().setAvbby("4");
			this.getLidgrp().getRec().setTrdtrm("1");
			this.getLidgrp().getRec().setTrdtrm("CFR");
			this.getLidgrp().getRec().setTrdflg(FALSE);
			MdaUtils.setValues(this.getLidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg"));
			this.getLidgrp().getBlk().setFeetxt("ALL BANKING CHARGES OUTSIDE THE ISSUING BANK ARE FOR BENEFICIARY'S ACCOUNT.");
			this.getLidgrp().getRec().setSedday("21");
			this.getLidgrp().getRec().setSstdat("1");
			this.getLidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getLidgrp().getRec().setPreper("Documents To Be Presented Within 21 Days After The Date Of SHIPMENT ,But Within The Validity Of The Credit.");
			//Platform.enable($lidgrp\\rec\\preper);
			this.getLidgrp().getRec().setApprul("1");
			//$lidgrp\\rec\\apprultxt.setValue("UCP LATEST VERSION");
			// $lidgrp\\agree.setValue(FALSE);
			this.getLidgrp().setAgree(TRUE);
			this.getLitp().setAplnam(this.getSysmod().getPty().getNam());
			//Platform.disable($rmkmod\\otext);
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getLitp().getOpncls().getCls(),new Argument<String>("inr",this.getLitp().getOpncls().readDefaultClsInr("litopn")));
			  this.getLidgrp().getBlk().setRgtcls(this.getLitp().getOpncls().getCls().getClstxt());
			}
			//保证金协议相关
			if((MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzhm())||"".equals(this.getLidgrp().getRec().getDbbzjzhm()))&&(MdaUtils.isEmpty(this.getLidgrp().getRec().getDbbzjzh())||"".equals(this.getLidgrp().getRec().getDbbzjzh())))
			{
			  this.getLidgrp().setNedbzj("");
			  this.getLidgrp().getRec().setBzjbl(new BigDecimal(0));
			  
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("");
			  
			  this.getLidgrp().setChkbzj2("√");
			  
			  
			}
			else
			{
			  this.getLidgrp().setNedbzj("X");
			  
			  
			  
			  
			  
			  this.getLidgrp().setChkbzj1("√");
			  
			  this.getLidgrp().setChkbzj2("");
			  
			}

			return true;
        }

        /**
        *   source:litopn.@0080.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","Litopn  init业务处理开始，ORDER编号:90");
			this.getLitp().getStpmod().storePanel(this.getLitp().getLitopn01(),this.getLitp().getFpdopn01());
			String steps = "0:信用证开立";

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if((!MdaUtils.isEmpty(this.getLidgrp().getRec().getBzjgh())||(!"".equals(this.getLidgrp().getRec().getBzjgh())))&&!"CNY".equals(this.getLitp().getLidgrp().getRec().getIsscur()))
			  {
			    steps = "0:信用证开立;1:保证金购汇";
			  }
			}
			this.getLitp().getStpmod().setPages(steps);
			this.getLitp().getStpmod().calcSteps();
			this.getLitp().getStpmod().setStepBtnSta();

			return true;
        }


        /**
        *   source:litopn.@0036.script
        */
        public void lcrgods()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String returnvalue="";
			Object lcrgod = this.getLidgrp().getBlk().getLcrgod();
			Object trdtrm = this.getLidgrp().getRec().getTrdtrm();
			Object trdtrmplc = this.getLidgrp().getRec().getTrdtrmplc();
			Object trdtrmver = this.getLidgrp().getRec().getTrdtrmver();
			if(!MdaUtils.isEmpty(lcrgod))
			  returnvalue=lcrgod.toString()+CR;
			if(!MdaUtils.isEmpty(trdtrm))
			{
			  //20190517 贸易术语显示label
			  returnvalue+="+Trade Terms: "+MdaUtils.getCodetableLabel("trdtrm",trdtrm.toString());
			}
			if(!MdaUtils.isEmpty(trdtrmplc))
			  returnvalue+=" "+trdtrmplc.toString();
			if(!MdaUtils.isEmpty(trdtrmver))
			  returnvalue+=" "+trdtrmver.toString();
			this.getLidgrp().setSwfa(returnvalue.trim());
		}
        /**
        *   source:litopn.@0037.script
        */
        public void adlcnds()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtvalue="";
			Object adlcnd = this.getLidgrp().getBlk().getAdlcnd();
			Object nomton = this.getLidgrp().getRec().getNomton();
			Object nomflg = this.getLidgrp().getRec().getNomflg();
			Object nomtop = this.getLidgrp().getRec().getNomtop();
			// log.debug("nomflg=="+nomflg.toString());
			// log.debug("nomflg=="+nomflg);
			if(!MdaUtils.isEmpty(nomflg)&&TRUE.equals(nomflg.toString()))
			{
			  rtvalue= "+Quantity And Amount ";
			  if(!MdaUtils.isEmpty(nomtop))
			    rtvalue+=nomtop.toString()+" PERCENT More ";
			  if(!MdaUtils.isEmpty(nomton))
			  {
			    if(!MdaUtils.isEmpty(nomtop))
			      rtvalue+= " Or ";
			    rtvalue+=nomton.toString()+" PERCENT Less";
			  }
			  rtvalue+=" Are Allowed";
			}
			if(!MdaUtils.isEmpty(adlcnd))
			  if(rtvalue==null   ||   "".equals(rtvalue) )
			rtvalue=adlcnd.toString();
			else
			rtvalue+= CR+adlcnd.toString();
			else
			rtvalue=rtvalue;
			this.getLidgrp().setSwfd(rtvalue) ;
		}
        /**
        *   source:litopn.@0079.script
        */
        public String covCnPercent(BigDecimal per)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将数字转化为大写
			if (per == null)
			{
			  return "";
			}
			String strPer = per.toString();
			String[] number = { "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖" };
			String[] radices = { "仟", "", "拾", "佰" };
			String[] bigRadices = { "", "万", "亿", "万亿", "亿亿" };
			int idx = strPer.indexOf(".");
			String sInt = "";
			String sFlt = "";
			if(-1 == idx)
			{
			  sInt = strPer;
			  sFlt = "00";
			}
			else
			{
			  sInt = strPer.substring(0, idx);
			  sFlt = strPer.substring(idx + 1);
			  if( 1 == sFlt.length())
			  {
			    sFlt = sFlt + "0";
			  }
			}

			String cn = "百分之";
			int zeroC = 0;
			int len = sInt.length();
			for (int i = 0; i < len; i++) {
			  if (sInt.charAt(i) == '0')
			{
			  zeroC++;
			}
			else
			{
			  if (zeroC > 0)
			  {
			    cn = cn + "零";
			    zeroC = 0;
			  }
			  cn = cn + number[(sInt.charAt(i) - '1')];
			  cn = cn + radices[((len - i) % 4)];
			}
			if (((len - i) % 4 == 1) && (zeroC < 4))
			  cn = cn + bigRadices[((len - i) / 4)];
			}
			if (sFlt.equals("00"))
			{
			cn = cn + "整";
			}
			else
			{
			cn = cn + "点";
			if (!sFlt.substring(0, 1).equals("0"))
			  cn = cn + number[(sFlt.charAt(0) - '1')];
			else
			  cn = cn + "零";
			if (!sFlt.substring(1, 2).equals("0"))
			  cn = cn + number[(sFlt.charAt(1) - '1')];
			}
			return cn;
		}
        /**
        *   source:litopn.@0087.script
        */
        public void dealbzjgh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getLitp().getFpdgrp().setMessage();

			  
			  this.getLitp().getFpdgrp().getRec().setCredat(MdaUtils.today());
			  this.getLitp().getFpdgrp().getRec().setOutcno(this.getLidgrp().getRec().getDbbzjzh());
			  
			  
			  this.dealbzjghamt();
			}

			//Platform.setNotRequired($litp\\fpdgrp\\rec\\cnycno);
			
			

			/*
			  if("5".equals($litp\\fpdgrp\\rec\\shbody.getValue()))
			  Platform.enable($litp\\fpdgrp\\rec\\othcno);
			  else
			  Platform.disable($litp\\fpdgrp\\rec\\othcno);
			  */
		}
        /**
        *   source:litopn.@0094.script
        */
        public void dealbzjghamt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if((!MdaUtils.isEmpty(this.getLidgrp().getRec().getIssamt())||(!"".equals(this.getLidgrp().getRec().getIssamt())))&&(!MdaUtils.isEmpty(this.getLidgrp().getRec().getBzjbl())||(!"".equals(this.getLidgrp().getRec().getBzjbl())))&&!MdaUtils.isEmpty(this.getLidgrp().getRec().getIsscur()))
			{
			  //获取保证金购汇金额
			  BigDecimal outamt = this.getLidgrp().getRec().getIssamt();
			  BigDecimal bzjbl = this.getLidgrp().getRec().getBzjbl();
			  if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getNomtop()))
			  {
			    int top=this.getLidgrp().getRec().getNomtop();
			    outamt=outamt.multiply(bzjbl).divide(new BigDecimal(10000)).multiply(new BigDecimal(100+top));
			  }
			  else
			  {
			    outamt = outamt.multiply(bzjbl).divide(new BigDecimal(100));
			  }
			  this.getLitp().getFpdgrp().setCur(this.getLitp().getLidgrp().getRec().getIsscur());
			  this.getLitp().getFpdgrp().setAmt(outamt);

			  if(TRUE.equals(this.getLitp().getFpdgrp().getRec().getCnnsel()))
			  {
			    ctx.postRule(this,"litp.fpdgrp.rec.cnnsel");
			  }
			  else
			  {
			    ctx.postRule(this,"litp.fpdgrp.rec.outsel");
			  }
			}
		}
        /**
        *   source:litopn.@0103.script
        */
        public void showReadTet()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//外汇按金交易风险提示函
			String readtxt1=" 外汇按金交易风险提示函";
			readtxt1=readtxt1+CR;
			readtxt1=readtxt1+CR+"目前通过网络平台开展外汇按金交易未经批准；境内";
			readtxt1=readtxt1+CR+"个人跨境境外购房、直接进行跨境证券投资，相关外";
			readtxt1=readtxt1+CR+"汇业务属于资本项目项下业务，按照可兑换进程管理";
			readtxt1=readtxt1+CR+"，目前尚未明确开放。直接或间接开展、参与上述相";
			readtxt1=readtxt1+CR+"关外汇业务，涉嫌违规。请提高风险防范意识，谨防";
			readtxt1=readtxt1+CR+"财产损失。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"特此公告。";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"";
			readtxt1=readtxt1+CR+"中国光大银行";
			readtxt1=readtxt1+CR+"2019年3月27日";

			ctx.setMessage(MdaUtils.getI18NString("litopn","CT000246"),readtxt1);

		}









}