package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LitpegVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 信用证草稿开立申请
*/
@Transaction(vo= LitpegVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litpeg extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Litpeg.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Litpeg()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Litpeg.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Litpeg.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Litpeg.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Litpeg.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Litpeg.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:litpeg.@0012.script
        */
        @Rule(target="lidgrp.rec.apprul",order=100)
        public boolean ruleLidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			  //$lidgrp\\rec\\apprultxt.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getLidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:litpeg.@0013.script
        */
        @Rule(target="lidgrp.rec.avbby",order=100)
        public boolean ruleLidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String avbby = this.getLidgrp().getRec().getAvbby();
			log.debug("{}","on evt.litopn.avbby...  avbby =" + avbby);
			if("1".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			}
			else if("2".equals(avbby))
			{
			  
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  
			}
			else if("3".equals(avbby))
			{
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  
			  
			}
			else if("4".equals(avbby))
			{
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  MdaUtils.resetModified(this.getLidgrp().getBlk(),"defdet");
			}
			else if("5".equals(avbby))
			{
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  

			}
			
			
			Modules.postDefaultRule(this,"lidgrp.blk.defdet");

			return true;
        }

        /**
        *   source:litpeg.@0014.script
        */
        @Rule(target="lidgrp.rec.avbwths",order=100)
        public boolean ruleLidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  this.getLidgrp().getRec().setAvbwth(NULLSTR);
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:litpeg.@0015.script
        */
        @Rule(target="lidgrp.rec.bchcod",order=100)
        public boolean ruleLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:litpeg.@0016.script
        */
        @Rule(target="lidgrp.rec.cnfflg",order=100)
        public boolean ruleLidgrpRecCnfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCnfflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getCnfflg()) )  //MAY ADD
			this.getLidgrp().getBlk().setCnfdet("if confirmed,confirm charges are for beneficiary's account.");
			else if("2".equals(this.getLidgrp().getRec().getCnfflg()) )  //CONFIRM
			this.getLidgrp().getBlk().setCnfdet("confirm charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setCnfdet(NULLSTR);

			

			return true;
        }

        /**
        *   source:litpeg.@0017.script
        */
        @Rule(target="lidgrp.rec.concur",order=100)
        public boolean ruleLidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			{
			  return true;
			}
			this.getLidgrp().getRec().setIsscur(this.getLidgrp().getRec().getConcur());
			

			return true;
        }

        /**
        *   source:litpeg.@0018.script
        */
        @Rule(target="lidgrp.rec.nomflg",order=100)
        public boolean ruleLidgrpRecNomflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			{
			  //勾选
			  
			  
			}
			else
			{
			  
			  
			}
			this.getLidgrp().getRec().setNomtop(0);
			this.getLidgrp().getRec().setNomton(0);
			
			

			return true;
        }

        /**
        *   source:litpeg.@0019.script
        */
        @Rule(target="lidgrp.rec.sstdat",order=100)
        public boolean ruleLidgrpRecSstdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getLidgrp().getRec().getSstdat()))
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(NULLSTR);
			}
			else
			{
			  
			  this.getLidgrp().getRec().setSstdattxt(MdaUtils.getCodetableLabel("sstdat",this.getLidgrp().getRec().getSstdat()));
			}
			

			return true;
        }

        /**
        *   source:litpeg.@0020.script
        */
        @Rule(target="lidgrp.rec.tenor",order=100)
        public boolean ruleLidgrpRecTenorN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isModified(this.getLidgrp().getBlk(),"dftat") && "S".equals(this.getLidgrp().getRec().getTenor()))
			{
			  this.getLidgrp().getBlk().setDftat("sight for 100 pct of the invoice value");
			}


			return true;
        }

        /**
        *   source:litpeg.@0021.script
        */
        @Rule(target="lidgrp.rec.trdflg",order=100)
        public boolean ruleLidgrpRecTrdflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLidgrp().getRec().getTrdflg()))
			{
			  //Platform.setRequired($lidgrp\\rec\\trdtrmver);
			  
			  this.getLidgrp().getRec().setTrdtrmver("AS PER INCOTERMS 2010");
			}
			else
			{
			  this.getLidgrp().getRec().setTrdtrmver(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:litpeg.@0022.script
        */
        @Rule(target="lidgrp.rec.trfflg",order=100)
        public boolean ruleLidgrpRecTrfflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getTrfflg()))
			  return true;
			if("2".equals(this.getLidgrp().getRec().getTrfflg()))
			  this.getLidgrp().getBlk().setTrfdet("This LC could be transferred by the advising bank.Transfer charges are for beneficiary's account.");
			else
			  this.getLidgrp().getBlk().setTrfdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litpeg.@0023.script
        */
        @Rule(target="lidgrp.rec.upsflg",order=100)
        public boolean ruleLidgrpRecUpsflgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getUpsflg()))
			  return true;
			if("1".equals(this.getLidgrp().getRec().getUpsflg()))
			  this.getLidgrp().getBlk().setUpsdet("This LC is payable at sight. The acceptance fees and finance interests that caused are for applicant’s account.");
			else
			  this.getLidgrp().getBlk().setUpsdet(NULLSTR);
			

			return true;
        }

        /**
        *   source:litpeg.@0030.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            

			log.debug("{}"," check tenor =" + this.getLidgrp().getRec().getTenor());
			if(ctx.checkAll(this.getLidgrp())  )
			  ctx.setMessage(MdaUtils.getI18NString("litpeg","CT000011"),MdaUtils.getI18NString("litpeg","CT000012"));
			log.debug("{}"," check end....  ");


			return true;
        }

        /**
        *   source:litpeg.@0031.script
        */
        @Rule(target="mtabut.ped",order=200)
        public boolean ruleMtabutPedN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  String typ=ctx.getTransName().substring(0,2);
			  String ptyname=this.getTrnmod().getPtyName(ctx.absGet(Sysmod.class).getPty().getInr());
			  this.getSysmod().getSpt().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			  this.getSysmod().getSpt().setObjinr("");
			  this.getSysmod().getSpt().setObjnam(this.getLidgrp().getRec().getIsscur()+this.getLidgrp().getRec().getIssamt()+"/"+ptyname);
			  this.getSysmod().getSpt().setNam(this.getLidgrp().getRec().getIsscur()+this.getLidgrp().getRec().getIssamt()+"/"+ptyname);
			}

			return true;
        }

        /**
        *   source:litpeg.@0032.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!ctx.checkAll(this.getLidgrp()))
			{
			  log.warn("{}","页面校验未通过，退出！");
			  return false;
			}

			log.info("{}","页面校验完成");
			//处理货描
			lcrgods();
			//处理其他单据
			adlcnds();
			//将页面上需要组合的值赋值到数据库字段中 Begin=========
			//将页面上需要组合的值赋值到数据库字段中 End=========
			//将Module数据入库 Begin==========
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());
			  String objinr = this.getLidgrp().getRec().getInr();
			  //申请人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getApl().getPts(),objinr);
			  //受益人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getBen().getPts(),objinr);
			  //通知行
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getAdv().getPts(),objinr);
			  //付款人
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getDre().getPts(),objinr);
			}
			else
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			    this.getLidgrp().getRec().setIbchcod(this.getLidgrp().getRec().getBchcod());
			  else
			    this.getLidgrp().getRec().setDbchcod(this.getLidgrp().getRec().getBchcod());
			  this.getLidgrp().getRec().setInr(Platform.sdbCounter("lid"));
			  this.getLidgrp().getRec().setFlg("0");
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getRec());
			  String objinr = this.getLidgrp().getRec().getInr();
			  this.getLidgrp().getBlk().setInr(objinr);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getBlk());
			  String objtyp = "lid";
			  //申请人
			  this.getLidgrp().getApl().savpts(objinr,objtyp);
			  //受益人
			  this.getLidgrp().getBen().savpts(objinr,objtyp);
			  //通知行
			  this.getLidgrp().getAdv().savpts(objinr,objtyp);
			  //付款人
			  this.getLidgrp().getDre().savpts(objinr,objtyp);
			  //直接申请行
			  this.getLidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getLidgrp().getDap().getPts().setObjinr(objinr);
			  this.getLidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getDap().getPts());
			  //如果是商行，要把商行信息作为转递申请人存储
			  if("1".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    this.getLidgrp().getDap().savTrp(objtyp,objinr);
			  }
			}
			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }


        /**
        *   source:litpeg.@0024.script
        */
        @Check(target="lidgrp.agree",order=100)
        public boolean checkLidgrpAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(TRUE.equals(this.getLidgrp().getAgree())))
			{
			  ctx.setFieldError(this,"lidgrp.agree",MdaUtils.getI18NString("litpeg","CT000003"));
			  return true;
			}

			return true;
        }

        /**
        *   source:litpeg.@0025.script
        */
        @Check(target="lidgrp.rec.expdat",order=100)
        public boolean checkLidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()))
			  return true;
			if(MdaUtils.diff(this.getLidgrp().getRec().getExpdat(),this.getLidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"lidgrp.rec.expdat",MdaUtils.getI18NString("litpeg","CT000004"));

			return true;
        }

        /**
        *   source:litpeg.@0026.script
        */
        @Check(target="lidgrp.rec.issamt",order=100)
        public boolean checkLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getConamt()))
			  return true;
			BigDecimal camt = this.getLidgrp().getRec().getConamt();
			BigDecimal lamt = this.getLidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"lidgrp.rec.issamt",MdaUtils.getI18NString("litpeg","CT000005"));

			return true;
        }

        /**
        *   source:litpeg.@0027.script
        */
        @Check(target="lidgrp.rec.nomton",order=100)
        public boolean checkLidgrpRecNomtonN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!TRUE.equals(this.getLidgrp().getRec().getNomflg()))
			  return true;
			int nomton = this.getLidgrp().getRec().getNomton();
			//if(nomton.compareTo(new BigDecimal(50))>0  ||  nomton.compareTo(new BigDecimal(0))<0)
			//无小数位的Numberic类型为Integer
			if(nomton>50  ||  nomton<0)
			  ctx.setFieldError(this,"lidgrp.rec.nomton",MdaUtils.getI18NString("litpeg","CT000006"));

			return true;
        }

        /**
        *   source:litpeg.@0028.script
        */
        @Check(target="lidgrp.rec.shpdat",order=100)
        public boolean checkLidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpdat()))
			  return true;
			Date shpdat = this.getLidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getLidgrp().getRec().getExpdat())>0)
			  ctx.setFieldError(this,"lidgrp.rec.shpdat",MdaUtils.getI18NString("litpeg","CT000007"));

			return true;
        }

        /**
        *   source:litpeg.@0029.script
        */
        @Check(target="lidgrp.usapro",order=100)
        public boolean checkLidgrpUsaproN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","check usapro .. ");
			if("U".equals(this.getLidgrp().getRec().getTenor()) && MdaUtils.isEmpty(this.getLidgrp().getUsapro()))
			  ctx.setFieldError(this,"lidgrp.usapro",MdaUtils.getI18NString("litpeg","CT000008"));

			return true;
        }


        /**
        *   source:litpeg.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			String tenor =this.getLidgrp().getRec().getTenor();
			List<CodetableItem> avbbytbl = this.getLitp().getAvbbyCodeTable(tenor);
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",avbbytbl);
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getLidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			
			
			
			
			
			
			
			
			
			
			
			
			
			

			
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			this.getLidgrp().getDap().initDap("lid");
			this.getLidgrp().getApl().copyValues(this.getLidgrp().getDap());
			log.debug("{}","message"+this.getLidgrp().getApl().getPts().getNam());
			this.getLidgrp().getApl().getPts().setRol("apl");
			this.getLidgrp().getRec().setConcur("USD");
			this.getLidgrp().getRec().setIsscur("USD");
			this.getLidgrp().getRec().setCredat(MdaUtils.today());
			
			
			
			
			this.getLidgrp().getRec().setNomflg(FALSE);
			this.getLidgrp().getRec().setIssinf("1");
			this.getLidgrp().getRec().setShppar("2");
			this.getLidgrp().getRec().setShptrs("2");
			this.getLidgrp().getRec().setTrfflg("1");
			this.getLidgrp().getRec().setUpsflg("2");
			this.getLidgrp().getRec().setCnfflg("3");
			this.getLidgrp().getRec().setAvbwths("1");
			this.getLidgrp().getRec().setAvbwth("ANY BANK");
			this.getLidgrp().getRec().setAvbby("4");
			this.getLidgrp().getRec().setTrdtrm("CFR");
			this.getLidgrp().getRec().setTrdflg(FALSE);
			MdaUtils.setValues(this.getLidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg"));
			this.getLidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			this.getLidgrp().getRec().setSedday("21");
			this.getLidgrp().getRec().setSstdat("1");
			this.getLidgrp().getRec().setSstdattxt("SHIPMENT");
			this.getLidgrp().getRec().setPreper("Documents To Be Presented Within 21 Days After The Date Of SHIPMENT ,But Within The Validity Of The Credit.");
			this.getLidgrp().getRec().setApprul("1");
			this.getLidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			this.getLidgrp().setAgree(TRUE);
			this.getLitp().setAplnam(this.getSysmod().getPty().getNam());
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getRgtcls()))
			{
			  ctx.getDaoSession().dbRead(this.getLitp().getOpncls().getCls(),new Argument<String>("inr",this.getLitp().getOpncls().readDefaultClsInr("litopn")));
			  this.getLidgrp().getBlk().setRgtcls(this.getLitp().getOpncls().getCls().getClstxt());
			}


			return true;
        }


        /**
        *   source:litpeg.@0033.script
        */
        public void lcrgods()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//处理货物描述
			String returnvalue="";
			Object lcrgod = this.getLidgrp().getBlk().getLcrgod();
			Object trdtrm = this.getLidgrp().getRec().getTrdtrm();
			Object trdtrmplc = this.getLidgrp().getRec().getTrdtrmplc();
			Object trdtrmver = this.getLidgrp().getRec().getTrdtrmver();
			if(!MdaUtils.isEmpty(lcrgod))
			  returnvalue=lcrgod.toString()+CR;
			if(!MdaUtils.isEmpty(trdtrm))
			  returnvalue+="+Trade Terms: "+trdtrm.toString();
			if(!MdaUtils.isEmpty(trdtrmplc))
			  returnvalue+=" "+trdtrmplc.toString();
			if(!MdaUtils.isEmpty(trdtrmver))
			  returnvalue+=" "+trdtrmver.toString();
			this.getLidgrp().setSwfa(returnvalue.trim());
		}
        /**
        *   source:litpeg.@0034.script
        */
        public void adlcnds()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//处理其他单据
			String rtvalue="";
			Object adlcnd = this.getLidgrp().getBlk().getAdlcnd();
			Object nomton = this.getLidgrp().getRec().getNomton();
			Object nomflg = this.getLidgrp().getRec().getNomflg();
			Object nomtop = this.getLidgrp().getRec().getNomtop();
			// log.debug("nomflg=="+nomflg.toString());
			// log.debug("nomflg=="+nomflg);
			if(!MdaUtils.isEmpty(nomflg)&&TRUE.equals(nomflg.toString()))
			{
			  rtvalue= "+Quantity And Amount ";
			  if(!MdaUtils.isEmpty(nomtop))
			    rtvalue+=nomtop.toString()+" PERCENT More ";
			  if(!MdaUtils.isEmpty(nomton))
			  {
			    if(!MdaUtils.isEmpty(nomtop))
			      rtvalue+= " Or ";
			    rtvalue+=nomton.toString()+" PERCENT Less";
			  }
			  rtvalue+=" Are Allowed";
			}
			if(!MdaUtils.isEmpty(adlcnd))
			  if(rtvalue==null   ||   "".equals(rtvalue) )
			rtvalue=adlcnd.toString();
			else
			rtvalue+= CR+adlcnd.toString();
			else
			rtvalue=rtvalue;
			this.getLidgrp().setSwfd(rtvalue) ;
		}









}