package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LittdvVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 转递/保兑信用证通知
*/
@Transaction(vo= LittdvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Littdv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Littdv.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Afdgrp afdgrp;


		public Littdv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Littdv.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Littdv.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littdv.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Littdv.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Littdv.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:littdv.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:littdv.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getLitp().getLitp07());

			return true;
        }

        /**
        *   source:littdv.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}