package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LittrtVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证转递申请(商行特有)
*/
@Transaction(vo= LittrtVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Littrt extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Littrt.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;


		public Littrt()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Littrt.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Littrt.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Littrt.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Littrt.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Littrt.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:littrt.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(false==ctx.checkAll(this.getLidgrp()))
			  return false;
			this.getLidgrp().setTrsflg("1");
			log.info("{}",MdaUtils.getI18NString("littrt","CT000009") );
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getRec());
			  ctx.getDaoSession().dbUpdate(this.getLidgrp().getBlk());
			  String objinr = this.getLidgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getAdv().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getAplb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getApl().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getBen().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getDre().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getRmb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getLidgrp().getTdb().getPts(),objinr);
			}
			else
			{
			  this.getLidgrp().getRec().setDbchcod(this.getLidgrp().getRec().getBchcod());
			  String lidinr = Platform.sdbCounter("lid");
			  this.getLidgrp().getRec().setInr(lidinr);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getRec());
			  this.getLidgrp().getBlk().setInr(lidinr);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getBlk());
			  String objinr = this.getLidgrp().getRec().getInr();
			  String objtyp = "lid";
			  this.getLidgrp().getAdv().savpts(objinr,objtyp);
			  this.getLidgrp().getAplb().savpts(objinr,objtyp);
			  this.getLidgrp().getApl().savpts(objinr,objtyp);
			  this.getLidgrp().getBen().savpts(objinr,objtyp);
			  this.getLidgrp().getDre().savpts(objinr,objtyp);
			  this.getLidgrp().getRmb().savpts(objinr,objtyp);
			  this.getLidgrp().getTdb().savpts(objinr,objtyp);
			  this.getLidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getLidgrp().getDap().getPts().setObjinr(objinr);
			  this.getLidgrp().getDap().getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getLidgrp().getDap().getPts());
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);

			return true;
        }

        /**
        *   source:littrt.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","littrt",stream,false );

			return true;
        }

        /**
        *   source:littrt.@0004.script
        */
        @Rule(target="lidgrp.rec.concur",order=100)
        public boolean ruleLidgrpRecConcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getConcur()))
			{
			  this.getLidgrp().getRec().setIsscur(this.getLidgrp().getRec().getConcur());
			  
			}

			return true;
        }

        /**
        *   source:littrt.@0005.script
        */
        @Rule(target="lidgrp.rec.apprul",order=100)
        public boolean ruleLidgrpRecApprulN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("6".equals(this.getLidgrp().getRec().getApprul()))
			{
			  
			  this.getLidgrp().getRec().setApprultxt(NULLSTR);
			}
			else
			{
			  
			  this.getLidgrp().getRec().setApprultxt(MdaUtils.getCodetableLabel("apprul",this.getLidgrp().getRec().getApprul()));
			}
			

			return true;
        }

        /**
        *   source:littrt.@0006.script
        */
        @Rule(target="lidgrp.rec.avbby",order=100)
        public boolean ruleLidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().avbbyChange(this.getLidgrp().getRec().getAvbby());

			return true;
        }

        /**
        *   source:littrt.@0007.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.checkAll(this.getLidgrp()))
			  ctx.setMessage(MdaUtils.getI18NString("littrt","CT000031"),MdaUtils.getI18NString("littrt","CT000032"));

			return true;
        }

        /**
        *   source:littrt.@0011.script
        */
        @Rule(target="lidgrp.rec.avbwths",order=100)
        public boolean ruleLidgrpRecAvbwthsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("4".equals(this.getLidgrp().getRec().getAvbwths()))
			{
			  
			  this.getLidgrp().getRec().setAvbwth(NULLSTR);
			  //$lidgrp\\rec\\avbwth.setValue("");
			}
			else
			{
			  
			  this.getLidgrp().getRec().setAvbwth(MdaUtils.getCodetableLabel("avbwths",this.getLidgrp().getRec().getAvbwths()));
			}
			

			return true;
        }

        /**
        *   source:littrt.@0016.script
        */
        @Rule(target="mtabut.xptslt",order=100)
        public boolean ruleMtabutXptsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMtabut().getXptqna());
			this.getMtabut().getXptqna().setRef(this.getLidgrp().getRec().getOwnref());
			log.debug("{}","ref="+this.getMtabut().getXptqna().getRef());
			ctx.storeData("com.brilliance.xptlst.ref",this.getMtabut().getXptqna());
			

			return true;
        }

        /**
        *   source:littrt.@0017.script
        */
        @Rule(target="lidgrp.rec.bchcod",order=100)
        public boolean ruleLidgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:littrt.@0018.script
        */
        @Rule(target="litp.advp.sure",order=500)
        public boolean ruleLitpAdvpSureN500(){
            IContext ctx = MdaEnv.getContext();
            
			//将当前申请客户处填写的信息带入交易下方的申请人信息栏位
			if(!MdaUtils.isEmpty(this.getLidgrp().getDap().getPts().getExtkey()))
			{
			  this.getLidgrp().getApl().getPts().setExtkey(this.getLidgrp().getDap().getPts().getExtkey());
			  
			}
			if(!MdaUtils.isEmpty(this.getLidgrp().getDap().getPts().getAdrblk()))
			{
			  this.getLidgrp().getApl().getPts().setAdrblk(this.getLidgrp().getDap().getPts().getAdrblk());
			  
			}

			return true;
        }


        /**
        *   source:littrt.@0003.script
        */
        @Check(target="lidgrp.rec.issamt",order=100)
        public boolean checkLidgrpRecIssamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getIssamt())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getConamt()))
			{
			  return true;
			}
			BigDecimal camt = this.getLidgrp().getRec().getConamt();
			BigDecimal lamt = this.getLidgrp().getRec().getIssamt();
			if(lamt.compareTo(camt)>0)
			  ctx.setFieldError(this,"lidgrp.rec.issamt",MdaUtils.getI18NString("littrt","CT000030"));

			return true;
        }

        /**
        *   source:littrt.@0012.script
        */
        @Check(target="lidgrp.rec.shpdat",order=100)
        public boolean checkLidgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getShpdat()))
			  return true;
			Date shpdat = this.getLidgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()) && MdaUtils.diff(shpdat,this.getLidgrp().getRec().getExpdat())>0)
			  ctx.setFieldError(this,"lidgrp.rec.shpdat",MdaUtils.getI18NString("littrt","CT000033"));

			return true;
        }

        /**
        *   source:littrt.@0013.script
        */
        @Check(target="lidgrp.rec.expdat",order=100)
        public boolean checkLidgrpRecExpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLidgrp().getRec().getCredat())   ||   MdaUtils.isEmpty(this.getLidgrp().getRec().getExpdat()))
			  return true;
			if(MdaUtils.diff(this.getLidgrp().getRec().getExpdat(),this.getLidgrp().getRec().getCredat())<0)
			  ctx.setFieldError(this,"lidgrp.rec.expdat",MdaUtils.getI18NString("littrt","CT000035"));

			return true;
        }


        /**
        *   source:littrt.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getLidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg1"));
			
			this.getLitp().initTrscom("littrt");

			return true;
        }

        /**
        *   source:littrt.@0009.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			this.getLitp().avbbyChange(this.getLidgrp().getRec().getAvbby());

			return true;
        }











}