package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LoddspVO;

import com.ceb.gjjs.mda.manager.module.Bctp;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Trdgrp;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Betp;
import com.ceb.gjjs.mda.manager.module.Fcdgrp;
import com.ceb.gjjs.mda.manager.module.Fstp;
import com.ceb.gjjs.mda.manager.module.Botp;
import com.ceb.gjjs.mda.manager.module.Apdgrp;
import com.ceb.gjjs.mda.manager.module.Bcdgrp;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.manager.module.Letp;
import com.ceb.gjjs.mda.manager.module.Bodgrp;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Fctp;
import com.ceb.gjjs.mda.manager.module.Fsdgrp;
import com.ceb.gjjs.mda.manager.module.Gidgrp;
import com.ceb.gjjs.mda.manager.module.Gitp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.manager.module.Bpdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.manager.module.Cptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;
import com.ceb.gjjs.mda.manager.module.Sgdgrp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Marp;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Comgrp;
import com.ceb.gjjs.mda.manager.module.Comp;
import com.ceb.gjjs.mda.manager.module.Bptp;
import com.ceb.gjjs.mda.manager.module.Brtp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Brdgrp;
import com.ceb.gjjs.mda.bo.Cls;
import com.ceb.gjjs.mda.manager.module.Sgtp;
import com.ceb.gjjs.mda.manager.module.Bedgrp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 密码更改
*/
@Transaction(vo= LoddspVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Loddsp extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Loddsp.class);

        //保存文件
        private transient IControl savedsp = new ControlImpl("savedsp", "保存文件", this);
        //
        private IStream grpdata = new StreamImpl();
        //更换密码
        private transient IControl changepwd = new ControlImpl("changepwd", "更换密码", this);
        //一期文件路径
        private String path;
        //
        private String lidcls;
		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Brdgrp brdgrp;

		@BDGetter
		private Brtp brtp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Letp letp;

		@BDGetter
		private Bedgrp bedgrp;

		@BDGetter
		private Betp betp;

		@BDGetter
		private Bcdgrp bcdgrp;

		@BDGetter
		private Bctp bctp;

		@BDGetter
		private Bodgrp bodgrp;

		@BDGetter
		private Botp botp;

		@BDGetter
		private Bpdgrp bpdgrp;

		@BDGetter
		private Bptp bptp;

		@BDGetter
		private Fcdgrp fcdgrp;

		@BDGetter
		private Fctp fctp;

		@BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private Gitp gitp;

		@BDGetter
		private Sgdgrp sgdgrp;

		@BDGetter
		private Sgtp sgtp;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Cptp cptp;

		@BDGetter
		private Comgrp comgrp;

		@BDGetter
		private Comp comp;

		@BDGetter
		private Fsdgrp fsdgrp;

		@BDGetter
		private Fstp fstp;

		@BDGetter
		private ModuleList<Usr> usrlst;

		@BDGetter
		private Margrp margrp;

		@BDGetter
		private Marp marp;

		@BDGetter
		private Cls cls;

		@BDGetter
		private Apdgrp apdgrp;

		@BDGetter
		private Trdgrp trdgrp;


		public Loddsp()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new java.math.BigDecimal("0")));
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBrtp().setBrdgrpHolder(()->this.getBrdgrp());
           this.getBrtp().setLidgrpHolder(()->this.getLidgrp());
           this.getBrtp().setApdgrpHolder(()->this.getApdgrp());
           this.getBrtp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBrtp().setPrefixdfHolder(new FieldConstantHolder<>("DF"));
           this.getBrtp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getLetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBetp().setLedgrpHolder(()->this.getLedgrp());
           this.getBetp().setBedgrpHolder(()->this.getBedgrp());
           this.getBctp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBctp().setBcdgrpHolder(()->this.getBcdgrp());
           this.getBctp().setApdgrpHolder(()->this.getApdgrp());
           this.getBctp().setTrdgrpHolder(()->this.getTrdgrp());
           this.getBctp().setPrefixdfHolder(new FieldConstantHolder<>("IF"));
           this.getBctp().setPrefixtrHolder(new FieldConstantHolder<>("TR"));
           this.getBotp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getBotp().setBodgrpHolder(()->this.getBodgrp());
           this.getBotp().setModtenordayHolder(new FieldConstantHolder<>(""));
           this.getBotp().setModtenorHolder(new FieldConstantHolder<>(""));
           this.getBotp().setDatHolder(new FieldConstantHolder<>(new java.util.Date()));
           this.getBotp().setAmtHolder(new FieldConstantHolder<>(new java.math.BigDecimal("0")));
           this.getBotp().setCurHolder(new FieldConstantHolder<>(""));
           this.getBptp().setBedgrpHolder(()->this.getBedgrp());
           this.getBptp().setBodgrpHolder(()->this.getBodgrp());
           this.getBptp().setBpdgrpHolder(()->this.getBpdgrp());
           this.getBptp().setLedgrpHolder(()->this.getLedgrp());
           this.getFctp().setFcdgrpHolder(()->this.getFcdgrp());
           this.getFctp().setTrnitsHolder(new FieldConstantHolder<>(""));
           this.getFctp().setToHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPwtypHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPurothHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybyremtypothHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybyremtypHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybyremHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybyothflgHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybylcrefHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybylcHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybyforactHolder(new FieldConstantHolder<>(""));
           this.getFctp().setPaybycolHolder(new FieldConstantHolder<>(""));
           this.getFctp().setImpdflgHolder(new FieldConstantHolder<>(""));
           this.getFctp().setFxclsHolder(new FieldConstantHolder<>(""));
           this.getFctp().setChkdocflgHolder(new FieldConstantHolder<>(""));
           this.getFctp().setBelgfeeHolder(new FieldConstantHolder<>(""));
           this.getGitp().setGidgrpHolder(()->this.getGidgrp());
           this.getSgtp().setSgdgrpHolder(()->this.getSgdgrp());
           this.getSgtp().setLidgrpHolder(()->this.getLidgrp());
           this.getCptp().setCpdgrpHolder(()->this.getCpdgrp());
           this.getCptp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getComp().setComgrpHolder(()->this.getComgrp());
           this.getFstp().setFsdgrpHolder(()->this.getFsdgrp());
           this.getFstp().setBedgrpHolder(()->this.getBedgrp());
           this.getMarp().setMargrpHolder(()->this.getMargrp());
        }

        /**
        *   source:loddsp.@0000.script
        */
        @Rule(target="savedsp",order=100)
        public boolean ruleSavedspN100(){
            IContext ctx = MdaEnv.getContext();
            
			String clsnam = "com.brilliance.swift.TaskDataUtil";
			String cfgfil = "cfgtrf/trans.ini";
			String path = this.getPath();
			if(MdaUtils.isEmpty(path))
			  path="/weblogic/webapps/resource/task";
			log.debug("{}","path="+path);
			if(!MdaUtils.fileExists(path))
			{
			  this.setPath(NULLSTR);
			  
			  
			  ctx.setMessage("操作提示","一期文件路径"+path+"不存在");
			  return true;
			}
			List<CodetableItem> l = getBchcod();
			MdaUtils.setValues(this.getAfdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getLidgrp().getRec(),"issinf",MdaUtils.getCodetable("issinf"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"shppar",MdaUtils.getCodetable("allowed"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"shptrs",MdaUtils.getCodetable("allowed"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"trfflg",MdaUtils.getCodetable("trfflg"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbwths",MdaUtils.getCodetable("avbwths"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"avbby",MdaUtils.getCodetable("avbby"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"upsflg",MdaUtils.getCodetable("allowed"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"cnfflg",MdaUtils.getCodetable("confrm"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"trdtrm",MdaUtils.getCodetable("trdtrm"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"sstdat",MdaUtils.getCodetable("sstdat"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"apprul",MdaUtils.getCodetable("apprul"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"sndtyp",MdaUtils.getCodetable("sndtyp"));
			MdaUtils.setValues(this.getLidgrp().getRec(),"chrgameby",MdaUtils.getCodetable("chrgameby"));
			MdaUtils.setValues(this.getBrdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getLedgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getBcdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getBodgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getBpdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getFsdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getGidgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getGidgrp().getRec(),"lgtyp",MdaUtils.getCodetable("lgtyp"));
			MdaUtils.setValues(this.getGidgrp().getRec(),"apprul",MdaUtils.getCodetable("lgapprul"));
			MdaUtils.setValues(this.getGidgrp().getRec(),"opntyp",MdaUtils.getCodetable("lgopntyp"));
			MdaUtils.setValues(this.getGidgrp().getRec(),"furtyp",MdaUtils.getCodetable("furtyp"));
			MdaUtils.setValues(this.getSgdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getCpdgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getCpdgrp().getRec(),"priority",MdaUtils.getCodetable("priority"));
			MdaUtils.setValues(this.getCpdgrp().getRec(),"paytyp",MdaUtils.getCodetable("paytyp"));
			MdaUtils.setValues(this.getCpdgrp().getRec(),"paytyptxt",MdaUtils.getCodetable("paytyptxt"));
			MdaUtils.setValues(this.getCpdgrp().getRec(),"cavpayflg",MdaUtils.getCodetable("cavpayflg"));
			MdaUtils.setValues(this.getComgrp().getRec(),"bchcod",l);
			MdaUtils.setValues(this.getComgrp().getRec(),"pnttyp",MdaUtils.getCodetable("pnttyp"));
			MdaUtils.setValues(this.getMargrp().getMar(),"bchcod",l);
			// insert cls
			this.getCls().setInr(Platform.sdbCounter("cls"));
			String txt = "我公司已办妥一切进口手续，现请贵行按我公司申请书内容（见上面英文）开出不可撤销跟单信用证。我公司声明如下：";
			txt = txt+"\r\n    一、我公司同意贵行依照国际商会现行有效的《跟单信用证统一惯例》（UCP）或《UCP关于电子交单的附则》（EUCP）及相关规则，包括但不限于《跟单信用证项下银行间偿付统一规则》（URR） 办理该信用证项下一切事宜，并同意承担由此产生的一切责任。 ";
			txt = txt+"\r\n    二、我公司保证在贵行规定的时间内向贵行支付该证项下的应付货款、手续费（包括国外受益人拒绝承担的有关银行费用）、利息及相关费用等所需的外汇和人民币资金。在我公司未按时偿还贵行垫款的情况下，有权依法扣押及变卖、拍卖单据项下的货物，我公司绝无异议，并全力予以配合。 ";
			txt = txt+"\r\n    三、我公司同意贵行按单据表面上与信用证条款相符的原则及现行有效的《跟单信用证统一惯例》的规定进行审单，做出付款/承兑/拒付的决定。我公司保证：当贵行认为单据无不符点时，我公司当在贵行付款通知书规定的时间内办理赎单手续，否则贵行有权主动从我公司帐户中扣款；当贵行认为单据有不符点时，我公司当在贵行不符点通知书规定的时间内对不符点做出接受与否的决定并以书面通知，由贵行办理对外付款/承兑/拒付。如我公司未能在规定的时间内通知贵行，贵行有权在现行有效的《跟单信用证统一惯例》规定的时间内对外拒付。";
			txt = txt+"\r\n    四、我公司同意贵行享有现行有效的《跟单信用证统一惯例》所规定的免责事项，即：单据有效性的免责、讯息传递的免责、不可抗力及被指示银行行为的免责。 ";
			txt = txt+"\r\n    五、该信用证如需修改，由我公司向贵行提出书面申请，由贵行认可后办理修改。我公司确认所有修改当由信用证受益人接受后才能生效。 ";
			txt = txt+"\r\n    六、如因申请书字迹不清或词意含混而引起的一切后果由我公司负责。 ";
			this.getCls().setClstxt(txt);
			this.getCls().setDat(MdaUtils.today());
			this.getCls().setEtyinr("00000000");
			this.getCls().setEtginr("00000000");
			this.getCls().setFlg("3");
			this.getCls().setPtyinr(this.getSysmod().getPty().getInr());
			this.getCls().setOwnertyp("0");
			this.getCls().setTyp("litopn");
			this.getCls().setStatus("0");
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbInsert(this.getCls());
			log.debug("{}","etyinr="+this.getSysmod().getPty().getEtyinr());
			log.debug("{}","etyinr="+this.getSysmod().getEty().getInr());
			log.debug("{}","cls="+this.getLidcls());
			ctx.getDaoSession().dbRead(this.getLitp().getOpncls().getCls(),new Argument<String>("inr",this.getLitp().getOpncls().readDefaultClsInr("litopn")));
			this.setLidcls(this.getLitp().getOpncls().getCls().getClstxt());
			/*Platform.dbRead($sysmod\\ety,new Argument("inr",$sysmod\\pty\\etyinr.getValue()));
			  if(!Platform.isEmpty($sysmod\\ety\\inr))
			  {
			  String sea = $sysmod\\ety\\sealrl.getValue();
			  if(sea!=null)sea=sea.replace("qz.gif","qz.png");
			  $sysmod\\ety\\sealrl.setValue(sea);
			  Platform.dbUpdate($sysmod\\ety);
			  }*/
			ctx.getDaoSession().dbCommit();
			MdaUtils.invoke(clsnam,"loadTaskData",cfgfil,new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					saveDisplay(paramVarArgs);
					return null;
				}
			},path);

			return true;
        }

        /**
        *   source:loddsp.@0006.script
        */
        @Rule(target="changepwd",order=100)
        public boolean ruleChangepwdN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getUsrlst());
			ctx.getDaoSession().dbReadset(this.getUsrlst(),new Argument<Object>("inr",DESC),new Argument<Object>("pwd",ISNOTNULL));
			int cnt = this.getUsrlst().fullSize();
			log.debug("{}","find"+cnt+"usr");
			String pwd = null;
			String newpwd = null;
			ctx.getDaoSession().dbBegin();
			for(int i=0;i<cnt;i++)
			{
			  log.debug("{}","inr="+this.getUsrlst().getElement(i).getInr());
			  pwd = this.getUsrlst().getElement(i).getPwd();
			  newpwd = changePWD(pwd);
			  if(MdaUtils.isEmpty(newpwd))
			    continue;
			  this.getUsrlst().getElement(i).setPwd(newpwd);
			  ctx.getDaoSession().dbUpdate(this.getUsrlst().getElement(i));
			  if(i%100==0)
			  {
			    ctx.getDaoSession().dbCommit();
			    log.debug("{}","Commit =====");
			    ctx.getDaoSession().dbBegin();
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage("操作提示","密码转换完毕");

			return true;
        }



        /**
        *   source:loddsp.@0008.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setPath(NULLSTR);
			
			

			return true;
        }


        /**
        *   source:loddsp.@0001.script
        */
        public Object saveDisplay(Object... obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","begin saveDisplay");
			HashMap<String,Object> data = (HashMap<String,Object>)obj[0];
			if(data==null||data.size()==0)
			{
			  log.info("{}","data is null");
			  return null;
			}
			else if(!MdaUtils.isEmpty(data.get("endSaveDsp")))
			{
			  log.debug("{}","last smh="+data.get("smhinr"));
			  ctx.setMessage("save display",data.get("endSaveDsp").toString());
			  return null;
			}
			String tskinr = obj[3].toString();
			String sql = "SELECT objinr,frm FROM trntdotsk WHERE tskinr='"+tskinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> trninr = new Argument<String>("objinr");
			Argument<String> frm = new Argument<String>("frm");
			ctx.getDaoSession().dbFetchFields(trninr,frm);
			String inr = null;
			String trnname = null;
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  inr = trninr.value;
			  trnname = frm.value;
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return null;
			}
			String status = data.get("status").toString();
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbBegin();
			if(!MdaUtils.isEmpty(data.get("newfrm")))
			{
			  trnname = data.get("newfrm").toString();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument("inr",inr));
			  this.getTrnmod().getTrn().setInifrm(trnname);
			  ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			}
			if(isApplied(trnname))
			{
			  saveApplyFile(trnname,inr,(Map)obj[4]);
			  if("litopn".equals(trnname)||"litame".equals(trnname)
			    ||"gitopn".equals(trnname)||"gitame".equals(trnname))
			  {
			    saveDraftFile(trnname,inr,(Map)obj[4]);
			  }
			}
			else
			{
			  if(!MdaUtils.isEmpty(data.get("smhinr")))
			  {
			    String smhinr = data.get("smhinr").toString();
			    log.debug("{}","smhinr="+smhinr);
			    // 处理通知附件
			    String xmlfil = null;
			    if(data.get("xmlfil")!=null)
			      xmlfil = data.get("xmlfil").toString();
			    String sw2fil = null;
			    if(data.get("sw2fil")!=null)
			    {
			      sw2fil = data.get("sw2fil").toString();
			    }
			    // adv insert smh
			    MdaUtils.clear(this.getTrnmod().getSmh());
			    this.getTrnmod().getSmh().setInr(smhinr);
			    if("7".equals(status))
			    {
			      this.getTrnmod().getSmh().setObjtyp("spt");
			    }
			    else
			    {
			      this.getTrnmod().getSmh().setObjtyp("trn");
			    }
			    this.getTrnmod().getSmh().setObjinr(inr);
			    this.getTrnmod().getSmh().setDocpth(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/swiftIn/arc/"+obj[2]));
			    this.getTrnmod().getSmh().setXmlfil(xmlfil);
			    this.getTrnmod().getSmh().setSf2fil(sw2fil);
			    ctx.getDaoSession().dbInsert(this.getTrnmod().getSmh());
			    if("7".equals(status))
			    {
			      ctx.getDaoSession().dbRead(this.getTrnmod().getSptchk(),new Argument("inr",inr));
			      this.getTrnmod().getSptchk().setSmhinr(this.getTrnmod().getSmh().getInr());
			      ctx.getDaoSession().dbUpdate(this.getTrnmod().getSptchk());
			    }
			  }
			}

			String modpath = obj[1].toString();
			if(modpath.startsWith("comp"))
			{
			  modpath = "comgrp";
			}
			else
			{
			  int idx = modpath.indexOf("\\");
			  idx--;
			  idx--;
			  modpath = modpath.substring(0,idx)+"dgrp";
			}
			// insert bus table
			//Platform.invoke($\\,"save"+"lid",data);
			log.debug("{}","modpath="+modpath);
			if("7".equals(status))
			{
			  IStream os = this.getGrpdata();
			  IModule grp = MdaDriver.getModule(this,ctx.getRoot(),modpath);
			  MdaUtils.clear(grp);
			  String docflg = null;
			  if("brtdck".equals(trnname)||"betsnd".equals(trnname)||"bctdav".equals(trnname)||"botdav".equals(trnname))
			  {
			    docflg="docadv";
			  }
			  else if("brtdra".equals(trnname)||"betdis".equals(trnname))
			  {
			    docflg="disadv";
			  }
			  else if("bctset".equals(trnname)||"brtpay".equals(trnname)||"betset".equals(trnname)||"botset".equals(trnname))
			  {
			    docflg="payment";
			  }
			  else if("brtudp".equals(trnname)||"bctacc".equals(trnname)||"botacc".equals(trnname)||"betacc".equals(trnname))
			  {
			    docflg="accept";
			  }
			  else if("bctdor".equals(trnname)||"botdcr".equals(trnname)||"betdck".equals(trnname))
			  {
			    docflg="retrej";
			  }
			  data.put(modpath+"\\rec\\docflg",docflg);
			  log.debug("{}",trnname+" "+modpath+"\\rec\\docflg="+docflg);
			  setModuleContent(data,modpath);
			  MdaUtils.saveData(grp,os);
			  //$sysmod.streamSaveInSubdir(os,inr,"bak");
			  String filename = this.getSysmod().createFilename(inr,"bak");
			  MdaUtils.streamSave(os,filename);
			}
			else
			{
			  setModuleContent(data,"");
			  if("brtsnd".equals(trnname))
			  {
			    if("docadv".equals(this.getBrdgrp().getRec().getDocflg()))
			    {
			      MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp"));
			      MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			      if(MdaUtils.isEmpty(this.getAfdgrp().getRec().getOprval()))
			      {
			        
			      }
			      else
			      {
			        
			      }
			    }
			    else if("disadv".equals(this.getBrdgrp().getRec().getDocflg()))
			    {
			      MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("disdoc"));
			    }
			  }
			  else if("bctacp".equals(trnname))
			  {
			    MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("doctyps"));
			    MdaUtils.setValues(this.getAfdgrp().getRec(),"oprval",MdaUtils.getCodetable("refres"));
			    if(MdaUtils.isEmpty(this.getAfdgrp().getRec().getOprval()))
			    {
			      
			    }
			    else
			    {
			      
			    }
			  }
			  else if("letfrc".equals(trnname))
			  {
			    MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp1"));
			  }
			  else if("letfrd".equals(trnname))
			  {
			    MdaUtils.setValues(this.getAfdgrp().getRec(),"oprtyp",MdaUtils.getCodetable("apltyp2"));
			    oprtypInit();
			  }
			  else if("litopn".equals(trnname))
			  {
			    this.getLidgrp().getBlk().setRgtcls(this.getLidcls());
			  }
			  
			  //String uri = "/data/dsp/"+inr+".zul";
			  //String zulFileName = Platform.catPath( Platform.getRootPath( ), uri);
			  String zulFileName = this.getSysmod().createFilename(inr,"zul");
			  log.info("{}",zulFileName);
			  ctx.saveDisplay(zulFileName);
			}
			ctx.getDaoSession().dbCommit();
			return null;
		}
        /**
        *   source:loddsp.@0002.script
        */
        public void saveApplyFile(String trnname,String trninr,Map data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","save apply file");
			//String path=Platform.catPath(Platform.getRootPath(),"data/temp");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),trninr.substring(0,4));
			log.info("{}","path=" +data.size());
			String clsNam = "com.brilliance.swift.SwiftPacker";
			MdaUtils.invoke(clsNam,"saveDataToFile",data,path,trninr+".app");
		}
        /**
        *   source:loddsp.@0003.script
        */
        public void setModuleContent(HashMap<String,Object> data,String modpath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(String key:data.keySet())
			{
			  if("xmlfil".equals(key)  ||  "sw2fil".equals(key)  ||  "smhinr".equals(key)  ||  "newfrm".equals(key))
			    continue;
			  if("m8".equals(key))
			  {
			    if(MdaUtils.isEmpty(data.get(key))  ||  MdaUtils.isEmpty(modpath))
			      continue;
			    String ptyinr = this.getTrnmod().getPtysFromCid(data.get(key).toString());
			    IDatafield p = MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\rec\\ptyinr");
			    if(p!=null&&!MdaUtils.isEmpty(ptyinr))
			      p.setValue(ptyinr);
			    IDatafield e = MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\rec\\etyinr");
			    if(e!=null)
			      e.setValue("00000000");
			    e = MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\rec\\flg");
			    if(e!=null)
			      e.setValue("2");
			    continue;
			  }
			  log.debug("{}","path="+key+"\tvalue"+data.get(key));
			  IDatafield df = MdaDriver.getDatafield(ctx.getRoot(),key.toString());
			  if(df!=null&&!MdaUtils.isEmpty(data.get(key)))
			    df.setValue(data.get(key));
			}
		}
        /**
        *   source:loddsp.@0004.script
        */
        public boolean reloadDataByArg(String argtyp,String arg,String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IModule module=MdaDriver.getModule(this,ctx.getRoot(),argtyp+"grp\\rec");
			ctx.getDaoSession().dbRead(module,new Argument<String>(arg,value));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  IDatafield field=MdaDriver.getDatafield(module,"inr");
			  log.info("{}","reloadData succeed,and the inr="+field.getValue());
			  return true;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","cannot find the corresponding reference in DZT!");
			  }
			  else
			  {
			    log.info("{}","error in looking the ....");
			  }
			  return false;
			}
		}
        /**
        *   source:loddsp.@0005.script
        */
        public boolean savelid(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return true;
		}
        /**
        *   source:loddsp.@0007.script
        */
        public String changePWD(String pwd)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(pwd))
			  return pwd;
			Object o = MdaUtils.invoke("com.brilliance.etrade.auth.impl.PrivateDB","decode",pwd);
			if(MdaUtils.isEmpty(o))
			  return pwd;
			String newpwd = MdaUtils.encryptPassword(o.toString());
			log.debug("{}","pwd="+pwd+"\tto"+newpwd);
			return newpwd;
		}
        /**
        *   source:loddsp.@0009.script
        */
        public List<CodetableItem> getBchcod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			// pty表ptytyp字段标识1：商行机构2：本行企业；(3：商行下属企业，但只能提交给商行)
			String query="SELECT pty.cid cid,pty.nam nam FROM pty WHERE ptytyp='0'";
			ctx.getDaoSession().dbExecuteSQL(query);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> cid = new Argument<String>("cid");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam,cid);
			  if(ctx.getErrorCode()==NO_ERROR)
			    bchcod.add(new CodetableItem(nam.value,cid.value));
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:loddsp.@0010.script
        */
        public void saveDraftFile(String trnname,String trninr,Map data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","save draft file");
			String msgname = ctx.absGet(Trnmod.class).getTcoMsgName(trnname);
			String clsNam = "com.brilliance.swift.SwiftPacker";
			// 20150310 MOD BY DG
			//String path=Platform.catPath(Platform.getRootPath(),"data/temp");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),trninr.substring(0,4));
			log.info("{}","path=" +data.size());
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			MdaUtils.invoke(clsNam,"packDataToFile",msgname,data,cfgpath,path,trninr+".dra");
		}
        /**
        *   source:loddsp.@0011.script
        */
        public boolean isApplied(String trnNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String profile=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/transaction.properties");
			if(!MdaUtils.fileExists(profile))
			  return false;
			String value=MdaUtils.getPropertyValue(profile,trnNam+"01");
			log.debug("{}","trnNam's value="+value);
			if(MdaUtils.isEmpty(value))
			  return false;
			return true;
		}
        /**
        *   source:loddsp.@0012.script
        */
        public void oprtypInit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String oprtyp = this.getAfdgrp().getRec().getOprtyp();
			if("0".equals(oprtyp))
			{
			  //无操作
			  
			  
			  
			  
			}
			else if("8".equals(oprtyp)  ||  "9".equals(oprtyp))
			{
			  //申请/同意修改单据金额
			  this.getBedgrp().setOprlabel(MdaUtils.getI18NString("loddsp","CT000010"));
			  
			  this.getBedgrp().setCur(this.getBetp().getBedgrp().getRec().getDoccur());
			  
			  
			  
			}
			else if("12".equals(oprtyp)  ||  "13".equals(oprtyp))
			{
			  //申请/同意变更到期日
			  this.getBedgrp().setOprlabel(MdaUtils.getI18NString("loddsp","CT000011"));
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			}
			
			
			
			
		}











































}