package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LttdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Lttp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ltdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Lttmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 出口转让信用证通知
*/
@Transaction(vo= LttdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Lttdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Lttdav.class);

		@BDGetter
		private Ltdgrp ltdgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Lttmod lttmod;

		@BDGetter
		private Lttp lttp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Lttdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLttmod().setLtdgrpHolder(()->this.getLtdgrp());
           this.getLttmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLttp().setLtdgrpHolder(()->this.getLtdgrp());
           this.getLttp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getLtdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.zrrcur");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setZrrcur(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getZrrcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.zrramt");}
 				public void setValue(BigDecimal arg){Lttdav.this.getLtdgrp().getRec().setZrramt(arg);}
 				public BigDecimal getValue(){return Lttdav.this.getLtdgrp().getRec().getZrramt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.ownref");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.bchcod");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.inr");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setInr(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.ptyinr");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lttdav.this.getFieldPath("ltdgrp.rec.stlref");}
 				public void setValue(String arg){Lttdav.this.getLtdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Lttdav.this.getLtdgrp().getRec().getStlref();}}
			 );
        }



        /**
        *   source:lttdav.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }

        /**
        *   source:lttdav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getTrnmod().noticeAck( this.getLttp().getLttdav());

			return true;
        }

        /**
        *   source:lttdav.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			
			
			

			
			

			return true;
        }











}