package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LttopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Lttp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Ltdgrp;
import com.ceb.gjjs.mda.manager.module.Ledgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Lttmod;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 来证转让信用证
*/
@Transaction(vo= LttopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Lttopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Lttopn.class);

		@BDGetter
		private Ltdgrp ltdgrp;

		@BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private Lttmod lttmod;

		@BDGetter
		private Lttp lttp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Lttopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLttmod().setLtdgrpHolder(()->this.getLtdgrp());
           this.getLttmod().setLedgrpHolder(()->this.getLedgrp());
           this.getLttp().setLtdgrpHolder(()->this.getLtdgrp());
           this.getLttp().setLedgrpHolder(()->this.getLedgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LT"));
           this.getMtabut().setRecHolder(()->this.getLtdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.zrrcur");}
 				public void setValue(String arg){Lttopn.this.getLtdgrp().getRec().setZrrcur(arg);}
 				public String getValue(){return Lttopn.this.getLtdgrp().getRec().getZrrcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.zrramt");}
 				public void setValue(BigDecimal arg){Lttopn.this.getLtdgrp().getRec().setZrramt(arg);}
 				public BigDecimal getValue(){return Lttopn.this.getLtdgrp().getRec().getZrramt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.ownref");}
 				public void setValue(String arg){Lttopn.this.getLtdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Lttopn.this.getLtdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.bchcod");}
 				public void setValue(String arg){Lttopn.this.getLtdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Lttopn.this.getLtdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.inr");}
 				public void setValue(String arg){Lttopn.this.getLtdgrp().getRec().setInr(arg);}
 				public String getValue(){return Lttopn.this.getLtdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ltdgrp.rec.ptyinr");}
 				public void setValue(String arg){Lttopn.this.getLtdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Lttopn.this.getLtdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lttopn.this.getFieldPath("ledgrp.rec.stlref");}
 				public void setValue(String arg){Lttopn.this.getLedgrp().getRec().setStlref(arg);}
 				public String getValue(){return Lttopn.this.getLedgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:lttopn.@0001.script
        */
        @Rule(target="ltdgrp.rec.isalt",order=100)
        public boolean ruleLtdgrpRecIsaltN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLtdgrp().getRec().getIsalt()))
			{
			  
			  
			  
			  
			  
			  
			  
			  //Platform.enable($lzdgrp\\rec\\qtdata);
			}
			else
			{
			  this.getLtdgrp().getRec().setDjjamt(new BigDecimal(0));
			  this.getLtdgrp().getRec().setSlnumb(NULLSTR);
			  this.getLtdgrp().getRec().setShpdat(null);
			  this.getLtdgrp().getRec().setExpplc(NULLSTR);
			  this.getLtdgrp().getRec().setExpdat(null);
			  this.getLtdgrp().getRec().setPrepers18(NULLSTR);
			  this.getLtdgrp().getRec().setTbblmt(NULLSTR);
			  //Platform.clear($lzdgrp\\rec\\qtdata);
			
			  this.getLtdgrp().getRec().setDjjamt(this.getLedgrp().getRec().getDjjamt());
			  this.getLtdgrp().getRec().setSlnumb(this.getLedgrp().getRec().getSlnumb());
			  this.getLtdgrp().getRec().setShpdat(this.getLedgrp().getRec().getShpdat());
			  this.getLtdgrp().getRec().setExpdat(this.getLedgrp().getRec().getExpdat());
			  this.getLtdgrp().getRec().setExpplc(this.getLedgrp().getRec().getExpplc());
			  this.getLtdgrp().getRec().setPrepers18(this.getLedgrp().getRec().getPrepers18());
			  this.getLtdgrp().getRec().setTbblmt(this.getLedgrp().getRec().getTbblmt());

			  
			  
			  
			  
			  
			  
			  
			  //Platform.disable($lzdgrp\\rec\\qtdata);
			}
			
			
			
			
			
			
			
			//Platform.setModified($lzdgrp\\rec\\qtdata);
			
			return true;
        }

        /**
        *   source:lttopn.@0002.script
        */
        @Rule(target="ltdgrp.rec.isrep",order=100)
        public boolean ruleLtdgrpRecIsrepN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLtdgrp().getRec().getIsrep()))
			{
			  this.getLtdgrp().getRec().setNotrep("");
			  
			}
			else
			{
			  
			}
			


			return true;
        }

        /**
        *   source:lttopn.@0003.script
        */
        @Rule(target="ltdgrp.rec.notrep",order=100)
        public boolean ruleLtdgrpRecNotrepN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLtdgrp().getRec().getNotrep()))
			{
			  this.getLtdgrp().getRec().setIsrep("");
			  
			}
			else
			{
			  
			}
			

			return true;
        }

        /**
        *   source:lttopn.@0004.script
        */
        @Rule(target="ltdgrp.rec.sm2",order=100)
        public boolean ruleLtdgrpRecSm2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLtdgrp().getRec().getSm2()))
			{
			  this.getLtdgrp().getRec().setSm3("");
			}
			
			

			return true;
        }

        /**
        *   source:lttopn.@0005.script
        */
        @Rule(target="ltdgrp.rec.sm3",order=100)
        public boolean ruleLtdgrpRecSm3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getLtdgrp().getRec().getSm3()))
			{
			  this.getLtdgrp().getRec().setSm2("");
			}
			
			

			return true;
        }

        /**
        *   source:lttopn.@0006.script
        */
        @Rule(target="ltdgrp.rec.zrramm",order=100)
        public boolean ruleLtdgrpRecZrrammN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getLedgrp().getRec().getLcccur())||MdaUtils.isEmpty(this.getLedgrp().getRec().getLccamt()))
			{
			  ctx.setFieldError(this,"ltdgrp.rec.zrramm",MdaUtils.getI18NString("lttopn","CT000003"));
			  this.getLtdgrp().getRec().setZrramm(NULLSTR);
			}
			else
			{
			  this.getLtdgrp().getRec().setZrrcur(this.getLedgrp().getRec().getLcccur());
			  this.getLtdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());
			  if("3".equals(this.getLtdgrp().getRec().getZrramm()))
			  {
			    //Platform.enable($lztgrp\\rec\\zrcur);
			    //$lztgrp\\rec\\zrcur.setValue($lztgrp\\rec\\lzzcur.getValue());
			    
			    
			  }
			  else
			  {
			    //Platform.clear($lztgrp\\rec\\zrcur);
			    //Platform.clear($lztgrp\\rec\\zramt);
			    this.getLtdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());
			    
			    
			  }
			}
			
			
			

			return true;
        }

        /**
        *   source:lttopn.@0007.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","lttopn",stream,false );

			return true;
        }

        /**
        *   source:lttopn.@0008.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");
			if(!(ctx.checkAll(this.getLtdgrp())))
			{
			  log.warn("{}","页面校验未通过，退出");
			  return false;
			}
			if(MdaUtils.isEmpty(this.getLtdgrp().getRec().getIsrep())&&MdaUtils.isEmpty(this.getLtdgrp().getRec().getNotrep()))
			{
			  ctx.setFieldError(this,"ltdgrp.rec.isrep",MdaUtils.getI18NString("lttopn","CT000008"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getLtdgrp().getRec().getSm2())&&MdaUtils.isEmpty(this.getLtdgrp().getRec().getSm3()))
			{
			  ctx.setFieldError(this,"ltdgrp.rec.sm2",MdaUtils.getI18NString("lttopn","CT000009"));
			  return false;
			}
			//金额格式化
			BigDecimal zrramt = MdaUtils.parseDecimal(MdaUtils.format(this.getLtdgrp().getRec().getZrramt(),"#0.00"));
			BigDecimal lccamt= MdaUtils.parseDecimal(MdaUtils.format(this.getLedgrp().getRec().getLccamt(),"#0.00"));
			BigDecimal djjamt=MdaUtils.parseDecimal(MdaUtils.format(this.getLtdgrp().getRec().getDjjamt(),"#0.00"));
			this.getLtdgrp().getRec().setZrramt(zrramt);
			this.getLedgrp().getRec().setLccamt(lccamt);
			this.getLtdgrp().getRec().setDjjamt(djjamt);
			if(MdaUtils.isEmpty(this.getLtdgrp().getIsb().getPts().getNam()))
			{
			  String adrblk=this.getLtdgrp().getIsb().getPts().getAdrblk();
			  String adr[]=adrblk.split("\\n");
			  this.getLtdgrp().getIsb().getPts().setNam(adr[0]);
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getLtdgrp().getRec());
			}
			else
			{
			  /*
			    if(Platform.isEmpty($ledgrp\\rec\\inr))
			    {
			    Platform.dbRead($ledgrp\\rec,new Argument<String>("stlref",$ledgrp\\rec\\stlref.getValue()),new Argument<String>("lccref",$ledgrp\\rec\\lccref.getValue()));
			    }
			    if("1".equals($ledgrp\\rec\\convey.getValue()))
			    {
			    Platform.message(#CT000010,#CT000011);
			    return false;
			    }
			    else
			    {*/
			  this.getLtdgrp().getRec().setInr(Platform.sdbCounter("ltd"));
			  this.getLtdgrp().getRec().setObjinr(this.getLedgrp().getRec().getInr());
			  this.getLtdgrp().getRec().setOwnusr(this.getSysmod().getUsr().getInr());
			  ctx.getDaoSession().dbInsert(this.getLtdgrp().getRec());

			  this.getLedgrp().getRec().setConvey("1");
			  ctx.getDaoSession().dbUpdate(this.getLedgrp().getRec());
			  //}
			}

			if(!this.getTrnmod().trnSetFromContract())return false;
			String filename=this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:lttopn.@0009.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "不可撤销跟单信用证转让委托书";
			String tempfiles = "A:lttopn";

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:lttopn.@0011.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//$bedgrp\\rec\\docgrd.setValue($latp\\docgrdm.encode());
			//IStream stream=$mtabut\\apldoc.getValue();
			/*BigDecimal zrr=$ltdgrp\\rec\\zrramt.getValue();
			  long zrrs=(long)zrr;
			  BigDecimal zrra=Platform.parseDecimal(zrrs);
			  if(zrra==zrr)
			  {
			  String zrramt=zrr.toString()+".00";
			  $ltdgrp\\rec\\zrramt.setValue(Platform.parseDecimal(zrramt));
			  }
			  */
			BigDecimal zrramt=getVals(this.getLtdgrp().getRec().getZrramt());
			BigDecimal lccamt=getVals(this.getLedgrp().getRec().getLccamt());
			BigDecimal djjamt=getVals(this.getLtdgrp().getRec().getDjjamt());
			this.getLtdgrp().getRec().setZrramt(zrramt);
			this.getLedgrp().getRec().setLccamt(lccamt);
			this.getLtdgrp().getRec().setDjjamt(djjamt);
			
			
			

			if(MdaUtils.isEmpty(this.getLtdgrp().getIsb().getPts().getNam()))
			{
			  String adrblk=this.getLtdgrp().getIsb().getPts().getAdrblk();
			  String adr[]=adrblk.split("\\n");
			  this.getLtdgrp().getIsb().getPts().setNam(adr[0]);
			  
			}

			this.getLttp().getPdfviw().callPDFComponent("","lttopn","不可撤销跟单信用证转让委托书",1);

			return true;
        }


        /**
        *   source:lttopn.@0010.script
        */
        @Check(target="ltdgrp.rec.zrramt",order=100)
        public boolean checkLtdgrpRecZrramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("3".equals(this.getLtdgrp().getRec().getZrramm())&&MdaUtils.isEmpty(this.getLtdgrp().getRec().getZrramt()))
			{
			  ctx.setFieldError(this,"ltdgrp.rec.zrramt",MdaUtils.getI18NString("lttopn","CT000012"));
			  return true;
			}
			if("3".equals(this.getLtdgrp().getRec().getZrramm()))
			{
			  this.getSysmod().checkAmt(MdaDriver.getDatafield(this.getLtdgrp().getRec(),"zrramt"));
			}

			BigDecimal camt = this.getLedgrp().getRec().getLccamt();
			BigDecimal lamt = this.getLtdgrp().getRec().getZrramt();
			if(camt.compareTo(lamt)<0)
			{
			  ctx.setFieldError(this,"ltdgrp.rec.zrramt",MdaUtils.getI18NString("lttopn","CT000013"));
			}
			if(!MdaUtils.isEmpty(lamt))
			{
			  BigDecimal js=MdaUtils.parseDecimal(0.00);
			  if(lamt.compareTo(js)<0)
			  {
			    ctx.setFieldError(this,"ltdgrp.rec.zrramt",MdaUtils.getI18NString("lttopn","CT000020"));
			  }
			}
			

			return true;
        }

        /**
        *   source:lttopn.@0012.script
        */
        @Check(target="ltdgrp.rec.slnumb",order=100)
        public boolean checkLtdgrpRecSlnumbN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLtdgrp().getRec().getSlnumb()))
			{
			  String str=this.getLtdgrp().getRec().getSlnumb();
			  String js="\\d{0,}";
			  Pattern pattern=Pattern.compile(js);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"ltdgrp.rec.slnumb",MdaUtils.getI18NString("lttopn","CT000015"));
			    this.getLtdgrp().getRec().setSlnumb(NULLSTR);
			  }
			}
			

			return true;
        }

        /**
        *   source:lttopn.@0013.script
        */
        @Check(target="ltdgrp.rec.shpdat",order=100)
        public boolean checkLtdgrpRecShpdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Date cre=this.getLtdgrp().getRec().getCredat();
			Date shp=this.getLtdgrp().getRec().getShpdat();
			if(!MdaUtils.isEmpty(cre) && !MdaUtils.isEmpty(shp))
			{
			  if(MdaUtils.diff(shp,cre)>0)
			  {
			    ctx.setFieldError(this,"ltdgrp.rec.shpdat",MdaUtils.getI18NString("lttopn","CT000023"));
			    return true;
			  }
			}

			return true;
        }

        /**
        *   source:lttopn.@0015.script
        */
        @Check(target="ltdgrp.rec.prepers18",order=100)
        public boolean checkLtdgrpRecPrepers18N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getLtdgrp().getRec().getPrepers18()))
			{
			  String str=this.getLtdgrp().getRec().getPrepers18();
			  String js="\\d{0,3}";
			  Pattern pattern=Pattern.compile(js);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"ltdgrp.rec.prepers18",MdaUtils.getI18NString("lttopn","CT000032"));
			    this.getLtdgrp().getRec().setPrepers18(NULLSTR);
			  }
			}
			

			return true;
        }

        /**
        *   source:lttopn.@0017.script
        */
        @Check(target="lttp.ltdgrp.rec.zrramt",order=100)
        public boolean checkLttpLtdgrpRecZrramtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getLttp().getLtdgrp().getRec(),"zrramt"));

			return true;
        }


        /**
        *   source:lttopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    this.getTrnmod().getApldoc().loadApldocByOrdinr(this.getSysmod().getSpt().getOrdinr());
			  }
			  List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			  MdaUtils.setValues(this.getLtdgrp().getRec(),"bchcod",bchcod);
			  if(!MdaUtils.isEmpty(this.getLtdgrp().getRec().getBchcod()))
			  {
			    
			  }
			  
			  this.getLttp().disLzt();
			  if("3".equals(this.getLtdgrp().getRec().getZrramm()))
			  {
			    
			    
			  }
			  return true;
			}

			IModule led = (IModule)ctx.restoreData("com.brilliance.lttopn.ref");
			if(!MdaUtils.isEmpty(led))
			  this.getLedgrp().getRec().copyValue(led);

			//if(Platform.isEmpty($sysmod\\spt\\ordinr))
			//$trnmod.ordNew();
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getLtdgrp().getRec(),"bchcod",bchcod);
			this.getLtdgrp().getRec().setBchcod(this.getLedgrp().getRec().getBchcod()) ;
			if(!MdaUtils.isEmpty(this.getLtdgrp().getRec().getBchcod()))
			{
			  
			}
			

			this.getLtdgrp().setAplnam(this.getSysmod().getPty().getNam());

			//Platform.dbRead($lzdgrp\\apl\\pts,new Argument<String>("objinr",$ledgrp\\rec\\inr.getValue()),new Argument<String>("objtyp","led"),new Argument<String>("rol","apl"));
			ctx.getDaoSession().dbRead(this.getLtdgrp().getIsb().getPts(),new Argument<String>("objinr",this.getLedgrp().getRec().getInr()),new Argument<String>("objtyp","led"),new Argument<String>("rol","isb"));

			String lcrtyp="IRREVOCABLE TRANSFERABLE";
			String str=this.getLedgrp().getRec().getLcrtyp();
			log.info("{}","lcrtyp:  "+str);
			//Pattern pattern=Pattern.compile(lcrtyp);
			//Matcher matcher = pattern.matcher(str);
			// if(!($\\sysmod.sptIsLoaded("B")  ||  $\\sysmod.sptIsLoaded("P")  ||  $\\sysmod.sptIsLoaded("T")))
			//{
			if(!lcrtyp.equals(str))
			{
			  ctx.setMessage(MdaUtils.getI18NString("lttopn","CT000000"),MdaUtils.getI18NString("lttopn","CT000001"));
			  
			  return true;
			}

			this.getLtdgrp().getRec().setDjjamt(this.getLedgrp().getRec().getDjjamt());
			this.getLtdgrp().getRec().setSlnumb(this.getLedgrp().getRec().getSlnumb());
			this.getLtdgrp().getRec().setShpdat(this.getLedgrp().getRec().getShpdat());
			this.getLtdgrp().getRec().setExpdat(this.getLedgrp().getRec().getExpdat());
			this.getLtdgrp().getRec().setExpplc(this.getLedgrp().getRec().getExpplc());
			this.getLtdgrp().getRec().setPrepers18(this.getLedgrp().getRec().getPrepers18());
			this.getLtdgrp().getRec().setTbblmt(this.getLedgrp().getRec().getTbblmt());

			this.getLtdgrp().getRec().setZrrcur(this.getLedgrp().getRec().getLcccur());
			this.getLtdgrp().getRec().setZrramt(this.getLedgrp().getRec().getLccamt());

			this.getLttp().disLzt();
			this.getSysmod().setTrntiltle(ctx.getTransName());
			log.debug("{}","Trntiltle="+this.getSysmod().getTrntiltle());


			return true;
        }


        /**
        *   source:lttopn.@0016.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}









}