package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.LxtdavVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Afdgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Litmod;
import com.ceb.gjjs.mda.manager.module.Litp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 进口信用证协议生效通知
*/
@Transaction(vo= LxtdavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Lxtdav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Lxtdav.class);

		@BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Litmod litmod;

		@BDGetter
		private Litp litp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;


		public Lxtdav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getLitmod().setLidgrpHolder(()->this.getLidgrp());
           this.getLitmod().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setAfdgrpHolder(()->this.getAfdgrp());
           this.getLitp().setLidgrpHolder(()->this.getLidgrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.isscur");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setIsscur(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getIsscur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.issamt");}
 				public void setValue(BigDecimal arg){Lxtdav.this.getLidgrp().getRec().setIssamt(arg);}
 				public BigDecimal getValue(){return Lxtdav.this.getLidgrp().getRec().getIssamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Lxtdav.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Lxtdav.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Lxtdav.this.getLidgrp().getRec().getStlref();}}
			 );
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("LC"));
           this.getMtabut().setRecHolder(()->this.getLidgrp().getRec());
        }



        /**
        *   source:lxtdav.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();
			this.getTrnmod().noticeAck(this.getLitp().getLxtdav());
			if(MdaUtils.isEmpty(this.getLidgrp().getDap().getPts().getRef()))
			{
			  this.getLidgrp().getDap().getPts().setRef(this.getLidgrp().getRec().getStlref());
			  
			}
			

			return true;
        }










}