package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MakmodVO;

import com.ceb.gjjs.mda.manager.module.Makgrp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Makp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 面函模板
*/
@Transaction(vo= MakmodVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Makmod extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Makmod.class);

		@BDGetter
		private Makgrp makgrp;

		@BDGetter
		private Makp makp;

		@BDGetter
		private Sysmod sysmod;


		public Makmod()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMakp().setMakgrpHolder(()->this.getMakgrp());
        }

        /**
        *   source:makmod.@0000.script
        */
        @Rule(target="makp.sav",order=100)
        public boolean ruleMakpSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(this.getMakgrp().getCls().getInr()))
			{

			  this.getMakgrp().getCls().setOwnertyp("0");
			  this.getMakgrp().getCls().setDat(MdaUtils.today());
			  this.getMakgrp().getCls().setFlg("8");
			  this.getMakgrp().getCls().setPtyinr(this.getSysmod().getPty().getInr());
			  this.getMakgrp().getCls().setStatus("1");
			  this.getMakgrp().getCls().setEtyinr(this.getSysmod().getPty().getEtyinr());
			  this.getMakgrp().getCls().setEtginr(this.getSysmod().getEtg().getInr());
			  this.getMakgrp().getCls().setInr(Platform.sdbCounter("cls"));
			  ctx.getDaoSession().dbInsert(this.getMakgrp().getCls());
			  log.debug("{}","Insert cls inr value = "+this.getMakgrp().getCls().getInr());
			}
			else
			{
			  log.debug("{}","Update cls inr value = "+this.getMakgrp().getCls().getInr());
			  ctx.getDaoSession().dbUpdate(this.getMakgrp().getCls());
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("makmod","CT000046"),MdaUtils.getI18NString("makmod","CT000047"));
			
			this.getMakgrp().setDoctyp("0");
			iniClslst();

			return true;
        }

        /**
        *   source:makmod.@0002.script
        */
        @Rule(target="makp.edit",order=100)
        public boolean ruleMakpEditN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int size=this.getMakgrp().getClslst().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("makmod","CT000048"),MdaUtils.getI18NString("makmod","CT000049"));
			  return true;
			}
			MdaUtils.clear(this.getMakgrp().getCls());
			// $makgrp\\cls.copyValue($makgrp\\clslst[index]);
			ctx.getDaoSession().dbRead(this.getMakgrp().getCls(),new Argument<String>("inr",this.getMakgrp().getClslst().getElement(index).getInr()));
			//$clsp\\dbbdoctyp.setValue($clsgrp\\cls\\typ.getValue());
			

			return true;
        }

        /**
        *   source:makmod.@0003.script
        */
        @Rule(target="makp.del",order=100)
        public boolean ruleMakpDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getMakgrp().getClslst().fullSize();
			if( index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("makmod","CT000036"),MdaUtils.getI18NString("makmod","CT000037"));
			  return false;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("makmod","CT000038"),MdaUtils.getI18NString("makmod","CT000039")))
			  return false;
			ctx.getDaoSession().dbBegin();
			//String inr = $clsgrp\\clslst[index]\\inr.getValue();
			//$clsgrp\\cls.copyValue($clsgrp\\clslst[index]);
			ctx.getDaoSession().dbRead(this.getMakgrp().getCls(),new Argument<String>("inr",this.getMakgrp().getClslst().getElement(index).getInr()));
			ctx.getDaoSession().dbDelete(this.getMakgrp().getCls());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("makmod","CT000040"),MdaUtils.getI18NString("makmod","CT000041"));
			this.getMakgrp().setDoctyp("0");
			iniClslst();

			return true;
        }

        /**
        *   source:makmod.@0004.script
        */
        @Rule(target="makp.contral",order=100)
        public boolean ruleMakpContralN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMakgrp().getCls());
			//$clsp\\sta.setValue("");
			

			return true;
        }

        /**
        *   source:makmod.@0005.script
        */
        @Rule(target="makp.add",order=100)
        public boolean ruleMakpAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMakgrp().getCls());
			

			return true;
        }

        /**
        *   source:makmod.@0006.script
        */
        @Rule(target="makp.sel",order=100)
        public boolean ruleMakpSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			iniClslst();
			/*
			  String doctyp = $makgrp\\doctyp.getValue();
			  if("0".equals(doctyp))
			  iniClslst();
			  else
			  iniClslsts(doctyp);
			  Platform.setModified($makgrp\\clslst);
			  */

			return true;
        }

        /**
        *   source:makmod.@0010.script
        */
        @Rule(target="makp.setdefault",order=100)
        public boolean ruleMakpSetdefaultN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getMakgrp().getClslst().fullSize();
			if(index < 0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("makmod","CT000050"),MdaUtils.getI18NString("makmod","CT000051"));
			  return false;
			}
			ctx.getDaoSession().dbBegin();
			String inr = this.getMakgrp().getClslst().getElement(index).getInr();
			log.debug("{}","setDefault makmod inr = "+inr);
			log.debug("{}","setDefault makmod typ = "+this.getMakgrp().getClslst().getElement(index).getTyp());
			ctx.getDaoSession().dbReadset(this.getMakgrp().getSetdeft(),new Argument<String>("flg","8"),new Argument<String>("ptyinr",this.getSysmod().getPty().getInr()),new Argument<String>("typ",this.getMakgrp().getClslst().getElement(index).getTyp()));
			for(int i = 0; i < this.getMakgrp().getSetdeft().fullSize(); i++)
			{
			  MdaUtils.clear(this.getMakgrp().getCls());
			  //Platform.dbRead($makgrp\\cls,new Argument<String>("inr",$makgrp\\setdeft[i]\\inr));
			  this.getMakgrp().getCls().copyValue(this.getMakgrp().getSetdeft().getElement(i));
			  if("0".equals(this.getMakgrp().getCls().getStatus()))
			  {
			    log.debug("{}","原默认面函模板inr = "+this.getMakgrp().getCls().getInr());
			    this.getMakgrp().getCls().setStatus("1");
			    ctx.getDaoSession().dbUpdate(this.getMakgrp().getCls());
			  }
			}
			ctx.getDaoSession().dbRead(this.getMakgrp().getCls(),new Argument<String>("inr",inr));
			log.debug("{}","To Change inr = "+this.getMakgrp().getCls().getInr());
			this.getMakgrp().getCls().setStatus("0");
			ctx.getDaoSession().dbUpdate(this.getMakgrp().getCls());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("makmod","CT000055"),MdaUtils.getI18NString("makmod","CT000056")+MdaUtils.getCodetableLabel("moddoc",this.getMakgrp().getCls().getTyp())+MdaUtils.getI18NString("makmod","CT000057"));
			iniClslst();

			return true;
        }



        /**
        *   source:makmod.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getMakgrp().getCls(),"typ",MdaUtils.getCodetable("moddoc"));
			log.debug("{}","init makp1 cls inr = "+this.getMakgrp().getCls().getInr());
			if(MdaUtils.isEmpty(this.getMakgrp().getCls().getInr()))
			{
			  this.getMakgrp().getCls().setTyp("botdft");
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:makmod.@0009.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMakgrp().setDoctyp("0");
			iniClslst();

			return true;
        }


        /**
        *   source:makmod.@0008.script
        */
        public void iniClslst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbReadset($makgrp\\clslst,new Argument<String>("flg","8"));
			MdaUtils.clear(this.getMakgrp().getClslst());
			//String sql = "SELECT inr,typ,substr(clstxt,0,40) clstxt,status FROM cls WHERE flg = '8' AND ptyinr = '"+$sysmod\\pty\\inr+"'";
			String sql = "SELECT inr,typ,clstxt,status FROM cls WHERE flg = '8' AND ptyinr = '"+this.getSysmod().getPty().getInr()+"'";
			if(!"0".equals(this.getMakgrp().getDoctyp()))
			  sql +=" AND typ = '"+this.getMakgrp().getDoctyp()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> typ = new Argument<String>("typ");
			Argument<String> clstxt = new Argument<String>("clstxt");
			Argument<String> status = new Argument<String>("status");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,typ,clstxt,status);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {

			    if(clstxt.value.length()>40)
			      clstxt.value = clstxt.value.substring(0,40);
			    this.getMakgrp().getClslst().add(inr,typ,clstxt,status);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}




}