package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MarcfmVO;

import com.ceb.gjjs.mda.manager.module.Marp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行端保证金委托开户及扣划协议补充修改（综合）
*/
@Transaction(vo= MarcfmVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Marcfm extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Marcfm.class);

		@BDGetter
		private Margrp margrp;

		@BDGetter
		private Marp marp;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;


		public Marcfm()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMarp().setMargrpHolder(()->this.getMargrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Marcfm.this.getFieldPath("margrp.mar.ownref");}
 				public void setValue(String arg){Marcfm.this.getMargrp().getMar().setOwnref(arg);}
 				public String getValue(){return Marcfm.this.getMargrp().getMar().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Marcfm.this.getFieldPath("margrp.mar.bchcod");}
 				public void setValue(String arg){Marcfm.this.getMargrp().getMar().setBchcod(arg);}
 				public String getValue(){return Marcfm.this.getMargrp().getMar().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Marcfm.this.getFieldPath("margrp.mar.inr");}
 				public void setValue(String arg){Marcfm.this.getMargrp().getMar().setInr(arg);}
 				public String getValue(){return Marcfm.this.getMargrp().getMar().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Marcfm.this.getFieldPath("margrp.mar.ptyinr");}
 				public void setValue(String arg){Marcfm.this.getMargrp().getMar().setPtyinr(arg);}
 				public String getValue(){return Marcfm.this.getMargrp().getMar().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getMargrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:marcfm.@0001.script
        */
        @Rule(target="mtabut.bnkcfm",order=200)
        public boolean ruleMtabutBnkcfmN200(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbUpdate(this.getMargrp().getBxd());
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			//获得当前显示步骤条所对应的面板
			IPanel[] panels=this.getMarp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			//保存trn
			ctx.absGet(Trnmod.class).setTrnForSecondConfirm();

			return true;
        }

        /**
        *   source:marcfm.@0008.script
        */
        @Rule(target="margrp.bxd.cgyd",order=100)
        public boolean ruleMargrpBxdCgydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getMargrp().getBxd().getCgyd())||"贰".equals(this.getMargrp().getBxd().getCgyd()))
			{
			  
			  
			  
			}
			else
			{
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:marcfm.@0010.script
        */
        @Rule(target="margrp.bxd.jsyd",order=100)
        public boolean ruleMargrpBxdJsydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("5".equals(this.getMargrp().getBxd().getJsyd())||"伍".equals(this.getMargrp().getBxd().getJsyd()))
			{
			  
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:marcfm.@0009.script
        */
        @Rule(target="margrp.bxd.jxyd",order=100)
        public boolean ruleMargrpBxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getMargrp().getBxd().getJxyd())||"壹".equals(this.getMargrp().getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getMargrp().getBxd().getJxyd())||"贰".equals(this.getMargrp().getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getMargrp().getBxd().getJxyd())||"叁".equals(this.getMargrp().getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:marcfm.@0011.script
        */
        @Rule(target="margrp.bxd.zyjjfs",order=100)
        public boolean ruleMargrpBxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getMargrp().getBxd().getZyjjfs())||"贰".equals(this.getMargrp().getBxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getMargrp().getBxd().getZyjjfs())||"叁".equals(this.getMargrp().getBxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }


        /**
        *   source:marcfm.@0005.script
        */
        @Check(target="margrp.bxd.yfczhm",order=100)
        public boolean checkMargrpBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfsjhm()))
			  ctx.setFieldError(this,"margrp.bxd.yfczhm",MdaUtils.getI18NString("marcfm","CT000000"));

			return true;
        }

        /**
        *   source:marcfm.@0006.script
        */
        @Check(target="margrp.bxd.yfzrr",order=100)
        public boolean checkMargrpBxdYfzrrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getBxd().getYf())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfzrr()))
			{
			  ctx.setFieldError(this,"margrp.bxd.yf",MdaUtils.getI18NString("marcfm","CT000001"));
			}
			else
			{
			  //乙方(自然人)信息
			  
			  
			  
			  //乙方(自然人)收件信息
			  
			  
			  
			  
			  //乙方(自然人)代收人信息
			  
			  
			  
			  
			  //乙方（单位）信息
			  
			  
			  //乙方（单位）收件信息
			  
			  
			  
			  
			  
			  //乙方（单位）代收人信息
			  
			  
			  
			  
			}


			return true;
        }


        /**
        *   source:marcfm.@0000.script
        */
        @Init(order=102)
        public boolean	init102(){
            IContext ctx = MdaEnv.getContext();
            
			String  objinr=(String)ctx.restoreData("com.brilliance.marcfm.inr");
			if(!MdaUtils.isEmpty(objinr))
			{
			  ctx.getDaoSession().dbRead(this.getMargrp().getMar(),new Argument<String>("inr",objinr));
			  ctx.getDaoSession().dbRead(this.getMargrp().getBxd(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp","mar"));
			  //定义步骤条
			  this.getMarp().getStpmod().storePanel(this.getMarp().getMarcfm03());

			  String steps = "0:保证金协议";
			  this.getMarp().getStpmod().setPages(steps);
			  this.getMarp().getStpmod().calcSteps();

			}

			return true;
        }

        /**
        *   source:marcfm.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//设置界面描述
			this.getMarp().bxdDescription();
			this.getMarp().marDescription();
			//设置界面限制
			
			this.getMarp().marWtkhbzjDeal();
			this.getMarp().marWtklbzjzhDeal();

			return true;
        }









}