package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MardavVO;

import com.ceb.gjjs.mda.manager.module.Marp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sigtip;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保证金协议生效通知
*/
@Transaction(vo= MardavVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mardav extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Mardav.class);

		@BDGetter
		private Margrp margrp;

		@BDGetter
		private Marp marp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sigtip sigtip;


		public Mardav()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMarp().setMargrpHolder(()->this.getMargrp());
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Mardav.this.getFieldPath("margrp.mar.ownref");}
 				public void setValue(String arg){Mardav.this.getMargrp().getMar().setOwnref(arg);}
 				public String getValue(){return Mardav.this.getMargrp().getMar().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Mardav.this.getFieldPath("margrp.mar.ownref");}
 				public void setValue(String arg){Mardav.this.getMargrp().getMar().setOwnref(arg);}
 				public String getValue(){return Mardav.this.getMargrp().getMar().getOwnref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Mardav.this.getFieldPath("margrp.mar.inr");}
 				public void setValue(String arg){Mardav.this.getMargrp().getMar().setInr(arg);}
 				public String getValue(){return Mardav.this.getMargrp().getMar().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Mardav.this.getFieldPath("margrp.mar.ptyinr");}
 				public void setValue(String arg){Mardav.this.getMargrp().getMar().setPtyinr(arg);}
 				public String getValue(){return Mardav.this.getMargrp().getMar().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getMargrp().getMar());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }



        /**
        *   source:mardav.@0000.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in getImgRef");
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			ctx.absGet(Mtabut.class).getImgtp().setTrninr(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getTrninr());
			this.getMarp().setDztimgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			
			
			log.debug("{}","imgref=" + this.getMarp().getDztimgref());
			log.debug("{}","trninr=" + ctx.absGet(Mtabut.class).getImgtp().getTrninr());

			return true;
        }

        /**
        *   source:mardav.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.disable($zxdp\\zxdopn);
			//$scrtxt = $sysmod\\spt\\scrtxt;
			this.getTrnmod().noticeAck(this.getMarp().getMardav01());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getMargrp().getMar(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getMargrp().getMar().setBchcod(bchcod.get(0).getValue());

			return true;
        }

        /**
        *   source:mardav.@0002.script
        */
        @Init(order=150)
        public boolean	init150(){
            IContext ctx = MdaEnv.getContext();
            
			
			

			return true;
        }











}