package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MarmdlVO;

import com.ceb.gjjs.mda.manager.module.Marp;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sigtip;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 银行端保证金账户开立和扣划申请模板制作
*/
@Transaction(vo= MarmdlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Marmdl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Marmdl.class);

		@BDGetter
		private Margrp margrp;

		@BDGetter
		private Marp marp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Sigtip sigtip;


		public Marmdl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMarp().setMargrpHolder(()->this.getMargrp());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.cur");}
 				public void setValue(String arg){Marmdl.this.getMargrp().getMar().setCur(arg);}
 				public String getValue(){return Marmdl.this.getMargrp().getMar().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.amt");}
 				public void setValue(BigDecimal arg){Marmdl.this.getMargrp().getMar().setAmt(arg);}
 				public BigDecimal getValue(){return Marmdl.this.getMargrp().getMar().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.ownref");}
 				public void setValue(String arg){Marmdl.this.getMargrp().getMar().setOwnref(arg);}
 				public String getValue(){return Marmdl.this.getMargrp().getMar().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.bchcod");}
 				public void setValue(String arg){Marmdl.this.getMargrp().getMar().setBchcod(arg);}
 				public String getValue(){return Marmdl.this.getMargrp().getMar().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.objinr");}
 				public void setValue(String arg){Marmdl.this.getMargrp().getMar().setObjinr(arg);}
 				public String getValue(){return Marmdl.this.getMargrp().getMar().getObjinr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Marmdl.this.getFieldPath("margrp.mar.ptyinr");}
 				public void setValue(String arg){Marmdl.this.getMargrp().getMar().setPtyinr(arg);}
 				public String getValue(){return Marmdl.this.getMargrp().getMar().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("MZ"));
           this.getMtabut().setRecHolder(()->this.getMargrp().getMar());
        }

        /**
        *   source:marmdl.@0000.script
        */
        @Rule(target="marp.select",order=100)
        public boolean ruleMarpSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index<0||index>=this.getMarp().getCidmod().getClilst().fullSize())
			{
			  ctx.setMessage(MdaUtils.getI18NString("marmdl","CT000004"),MdaUtils.getI18NString("marmdl","CT000005"));
			  return true;
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getMarp().getCidmod().getClipty(),new Argument("cid",this.getMarp().getCidmod().getClilst().getElement(index).getCid()));
			  this.getMarp().getBummod().getWrkmdl().setCidinr(this.getMarp().getCidmod().getClipty().getCid());
			  
			}


			return true;
        }

        /**
        *   source:marmdl.@0009.script
        */
        @Rule(target="margrp.mar.wtkhbzj",order=100)
        public boolean ruleMargrpMarWtkhbzjN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			log.info("{}","execute 委托扣划保证金账户信息表 event  checkes  .......");
			//委托扣划保证金账户信息表
			if(!MdaUtils.isEmpty(this.getMargrp().getMar().getWtkhbzj()))
			{
			  
			  
			  
			  
			}
			else
			{
			  this.getMargrp().getMar().setCur(NULLSTR);
			  this.getMargrp().getMar().setAmt(new BigDecimal(0));
			  this.getMargrp().getMar().setNote(NULLSTR);

			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:marmdl.@0010.script
        */
        @Rule(target="margrp.mar.wtklbzjzh",order=100)
        public boolean ruleMargrpMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			log.info("{}","execute委托开立保证金账户信息表 event  checkes  .......");
			if(!MdaUtils.isEmpty(this.getMargrp().getMar().getWtklbzjzh()))
			{
			  //委托开立保证金账户信息表
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getMargrp().getMar().setAplnam(NULLSTR);
			  this.getMargrp().getMar().setDh(NULLSTR);
			  this.getMargrp().getMar().setDz(NULLSTR);
			  this.getMargrp().getMar().setCwlxr(NULLSTR);
			  this.getMargrp().getMar().setCzhm(NULLSTR);
			  this.getMargrp().getMar().setYb(NULLSTR);
			  this.getMargrp().getMar().setCkrlb(NULLSTR);
			  this.getMargrp().getMar().setZzjgdm(NULLSTR);
			  this.getMargrp().getMar().setFddbr(NULLSTR);
			  this.getMargrp().getMar().setNam(NULLSTR);
			  this.getMargrp().getMar().setZjzl(NULLSTR);
			  this.getMargrp().getMar().setZjhm(NULLSTR);
			  this.getMargrp().getMar().setKlzhbb(NULLSTR);

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			
			
			
			
			
			
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:marmdl.@0011.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getMar().getWtkhbzj()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("marmdl","CT000015"),MdaUtils.getI18NString("marmdl","CT000016"));
			  return false;
			}
			log.info("{}","账户列表开始");
			int size = this.getMargrp().getMxdlst().fullSize();
			if(size>=5)
			{
			  ctx.setMessage(MdaUtils.getI18NString("marmdl","CT000017"),MdaUtils.getI18NString("marmdl","CT000018"));
			  return false;
			}
			this.getMargrp().getMxdlst().add();
			
			log.info("{}","账户列表结束");

			return true;
        }

        /**
        *   source:marmdl.@0012.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            

			//加入标志字段  删除行数据    把删除的行数据插入另一张表
			int size=this.getMargrp().getMxdlst().fullSize();
			log.info("{}",MdaUtils.getI18NString("marmdl","CT000019")+size);
			if(size>0)
			{
			  boolean delflag=false;
			  for(int i=0;i<size;i++ )
			  {
			    if("X".equals(this.getMargrp().getMxdlst().getElement(i).getModflg()))
			    {
			      delflag=true;
			      if(!MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getInr()))
			      {
			        log.info("{}","src mxdbak inr:"+this.getMargrp().getMxdbak().size());
			        this.getMargrp().getMxdbak().add(this.getMargrp().getMxdlst().getElement(i));
			        log.info("{}","mxdbak inr:"+this.getMargrp().getMxdbak().size());
			      }
			      this.getMargrp().getMxdlst().remove(i);
			      size=this.getMargrp().getMxdlst().fullSize();
			      i--;
			    }
			  }
			  
			  if (!delflag)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("marmdl","CT000020"),MdaUtils.getI18NString("marmdl","CT000021"));
			  }
			}
			//int size = Platform.getSelectedRowIndex($margrp\\mxdlst);
			//if(size < 0)
			//{
			//  Platform.message(#CT000022,#CT000023);
			//}
			//else
			//{
			// if(!Platform.isEmpty($margrp\\mxdlst[size]\\inr))
			//  {
			//   log.info("src mxdbak inr:"+$margrp\\mxdbak.size());
			//    $margrp\\mxdbak.add($margrp\\mxdlst[size]);
			//    log.info("mxdbak inr:"+$margrp\\mxdbak.size());
			//  }
			//  $margrp\\mxdlst.remove(size);
			//}
			//Platform.setModified($margrp\\mxdlst);
			

			return true;
        }

        /**
        *   source:marmdl.@0013.script
        */
        @Rule(target="marp.cidmod.clilst",order=100)
        public boolean ruleMarpCidmodClilstN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"marp.select");

			return true;
        }


        /**
        *   source:marmdl.@0006.script
        */
        @Check(target="margrp.bxd.yfczhm",order=100)
        public boolean checkMargrpBxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getBxd().getYfczhm())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfdzyj())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfsjhm()))
			  ctx.setFieldError(this,"margrp.bxd.yfczhm",MdaUtils.getI18NString("marmdl","CT000007"));

			return true;
        }

        /**
        *   source:marmdl.@0007.script
        */
        @Check(target="margrp.mar.wtklbzjzh",order=100)
        public boolean checkMargrpMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getMar().getWtklbzjzh())&&MdaUtils.isEmpty(this.getMargrp().getMar().getWtkhbzj()))
			{
			  // Platform.error($margrp\\mar\\wtklbzjzh,#CT000012);
			  ctx.setMessage(MdaUtils.getI18NString("marmdl","CT000013"),MdaUtils.getI18NString("marmdl","CT000014"));
			}

			return true;
        }

        /**
        *   source:marmdl.@0008.script
        */
        @Check(target="margrp.bxd.yfzrr",order=100)
        public boolean checkMargrpBxdYfzrrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getMargrp().getBxd().getYf())&&MdaUtils.isEmpty(this.getMargrp().getBxd().getYfzrr()))
			{
			  ctx.setFieldError(this,"margrp.bxd.yf",MdaUtils.getI18NString("marmdl","CT000008"));

			}


			return true;
        }


        /**
        *   source:marmdl.@0001.script
        */
        @Init(order=102)
        public boolean	init102(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMarp().getBummod().setModtyp("maropn");
			//  定义步骤条
			//String steps = "0:出口押汇申请;1:签约提示";
			this.getMarp().getStpmod().storePanel(this.getMarp().getMarmdl08(),this.getMarp().getMarmdl04(),this.getMarp().getMarmdl06());
			String steps = "0:协议推送模板;1:开户及扣划申请;2:模板信息界面";
			this.getMarp().getStpmod().setPages(steps);
			this.getMarp().getStpmod().calcSteps();
			this.getMarp().getStpmod().setStepBtnSta();

			return true;
        }

        /**
        *   source:marmdl.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			
			
			

			
			
			
			

			

			//设置界面描述
			this.getMarp().bxdDescription();
			this.getMarp().marDescription();
			//设置部分界面栏位限制
			
			this.getMarp().marWtkhbzjDeal();
			this.getMarp().marWtklbzjzhDeal();


			return true;
        }










}