package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Maropn0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Marmod;
import com.ceb.gjjs.mda.manager.module.Margrp;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 保证金委托开户及扣划申请入口
*/
@Transaction(vo= Maropn0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Maropn0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Maropn0.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Marmod marmod;

		@BDGetter
		private Margrp margrp;


		public Maropn0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getMarmod().setMargrpHolder(()->this.getMargrp());
        }

        /**
        *   source:maropn0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			/***
			  *查询不同类型的保证金协议
			  *添加查询 出口押汇、进口代付、福费廷 交易类型查询
			  */
			String seltyp = this.getSelp().getSeltyp();
			String queryClause = null;
			if("1".equals(seltyp))
			{
			  //信用证记录
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref,rec.credat as dat,rec.issamt as amt,rec.isscur as cur, s.adrblk as bennam FROM lid rec,pts s WHERE s.objinr=rec.inr and s.objtyp='lid' and s.rol='ben'"
			    +ctx.absGet(Sysmod.class).getSelection();
			}
			else if("2".equals(seltyp))
			{
			  //保函记录
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.lgamt as amt,rec.lgcur as cur,s.adrblk as bennam FROM gid rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='gid' and s.rol='ben'  and ref not like '08101GA%'"
			    +ctx.absGet(Sysmod.class).getSelection();
			}
			else if("3".equals(seltyp))
			{
			  //出口押汇
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.fftamt as amt,rec.fftcur as cur,s.adrblk as bennam FROM bpd rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='bpd' and s.rol='ben' "
			    +ctx.absGet(Sysmod.class).getSelection();
			}
			else if("4".equals(seltyp))
			{
			  //进口代付
			  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.totamt as amt,rec.totcur as cur,s.adrblk as bennam FROM apd rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='apd' and s.rol='ben' "
			    +ctx.absGet(Sysmod.class).getSelection();
			}
			//else if("5".equals(seltyp))
			//{
			//福费廷
			//  queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.finamt as amt,rec.fincur as cur,s.adrblk as bennam FROM fsd rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='fsd' and s.rol='ben' "
			//    +$\\sysmod.getSelection();
			//}
			this.getSelp().queryList(queryClause);

			return true;
        }

        /**
        *   source:maropn0.@0004.script
        */
        @Rule(target="selp.newapply",order=100)
        public boolean ruleSelpNewapplyN100(){
            IContext ctx = MdaEnv.getContext();
            
			/***
			  *新建一个保证金协议
			  *
			  */
			ctx.storeData("com.brilliance.maropn.seltyp","0");
			

			return true;
        }

        /**
        *   source:maropn0.@0005.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			/***
			  *查询结果列表   选择双击一个结果 进入该交易开立保证金页面
			  *
			  */
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))//进口信用证
			{

			  this.getSelp().sureBtn("marmod\\lidgrp","maropn");
			}
			else if("2".equals(seltyp))//保函
			{
			  this.getSelp().sureBtn("marmod\\gidgrp","maropn");
			}
			else if("3".equals(seltyp))//出口押汇
			{
			  this.getSelp().sureBtn("marmod\\bpdgrp","maropn");
			}
			else if("4".equals(seltyp))//进口代付
			{
			  this.getSelp().sureBtn("marmod\\apdgrp","maropn");
			}
			else if("5".equals(seltyp))//福费廷
			{
			  this.getSelp().sureBtn("fsdgrp","maropn");
			}
			log.info("{}",seltyp);
			ctx.storeData("com.brilliance.maropn.seltyp",seltyp);

			return true;
        }

        /**
        *   source:maropn0.@0006.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			/***
			  *选择一个查询结果开立保证金协议
			  *marmod\\\\lidgrp 添加‘maropn\\\\’是因为 把所有的xxxgrp统一放在 marmod模块下
			  */
			String seltyp = this.getSelp().getSeltyp();
			if("1".equals(seltyp))//进口信用证
			{
			  this.getSelp().sureBtn("marmod\\lidgrp","maropn");
			}
			else if("2".equals(seltyp))//保函
			{
			  this.getSelp().sureBtn("marmod\\gidgrp","maropn");
			}
			else if("3".equals(seltyp))//出口押汇
			{
			  this.getSelp().sureBtn("marmod\\bpdgrp","maropn");
			}
			else if("4".equals(seltyp))//进口代付
			{
			  this.getSelp().sureBtn("marmod\\apdgrp","maropn");
			}
			else if("5".equals(seltyp))//福费廷
			{
			  this.getSelp().sureBtn("marmod\\fsdgrp","maropn");
			}

			ctx.storeData("com.brilliance.maropn.seltyp",seltyp);

			return true;
        }



        /**
        *   source:maropn0.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/***
			  *初始化页面 初始化码表 selcommar{1：信用证、2：保函、3：出口押汇、4：进口代付、5：福费廷}
			  *
			  */
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selcommar1"));
			this.getSelp().setSeltyp("1");
			String queryClause = "SELECT rec.inr as trsinr,rec.stlref as ref, rec.credat as dat ,rec.issamt as amt,rec.isscur as cur,s.adrblk as bennam FROM lid rec,pts s  WHERE s.objinr=rec.inr and s.objtyp='lid' and s.rol='ben' "
			  +ctx.absGet(Sysmod.class).getSelection();
			// WHERE ptyinr='"+$sysmod\\pty\\inr.getValue()+"'";
			this.getSelp().queryList(queryClause);

			return true;
        }







}