package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MgrtskVO;

import com.ceb.gjjs.mda.manager.module.Tcosvr;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Sptsvr;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.manager.module.Finsvr;
import com.ceb.gjjs.mda.manager.module.Mgrgrp;
import com.ceb.gjjs.mda.bo.Wfe;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Tsklst;
import com.ceb.gjjs.mda.manager.module.Smssvr;
import com.ceb.gjjs.mda.manager.module.Msgsvr;
import com.ceb.gjjs.mda.manager.module.Sigsvr;
import com.ceb.gjjs.mda.manager.module.Emlsvr;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bimenu;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 待运行服务
*/
@Transaction(vo= MgrtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mgrtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Mgrtsk.class);

        //执行
        private transient IControl doit = new ControlImpl("doit", "执行", this);
        //停止
        private transient IControl stop = new ControlImpl("stop", "停止", this);
        //执行标志
        private String strflg;
        //开始时间
        private Date strtim;
        //结束标志
        private String terflg;
        //重启时间间隔
        private int redotime;
        //开始
        private transient IControl start = new ControlImpl("start", "开始", this);
        //刷新
        private transient IControl update = new ControlImpl("update", "刷新", this);
        //
        private Object brhtime;
		@BDGetter
		private ModuleList<Wfe> wfelst;

		@BDGetter
		private Sptsvr sptsvr;

		@BDGetter
		private Sigsvr sigsvr;

		@BDGetter
		private Emlsvr emlsvr;

		@BDGetter
		private Smssvr smssvr;

		@BDGetter
		private Tcosvr tcosvr;

		@BDGetter
		private Finsvr finsvr;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Msg msg;

		@BDGetter
		private ModuleList<Tsklst> tsklst;

		@BDGetter
		private Bimenu bimenu;

		@BDGetter
		private Mgrgrp mgrgrp;

		@BDGetter
		private Msgsvr msgsvr;


		public Mgrtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSptsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getSptsvr().setTrnHolder(()->this.getTrnmod().getTrn());
           this.getSigsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getSigsvr().setWfsHolder(()->this.getTrnmod().getWfmmod().getWfs());
           this.getEmlsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getEmlsvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getEmlsvr().setMsgHolder(()->this.getMsg());
           this.getSmssvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getSmssvr().setMsgHolder(()->this.getMsg());
           this.getSmssvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getTcosvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getFinsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getFinsvr().setTrnHolder(()->this.getTrnmod().getTrn());
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getMsgsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getMsgsvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getMsgsvr().setTrnHolder(()->this.getTrnmod().getTrn());
        }

        /**
        *   source:mgrtsk.@0001.script
        */
        @Rule(target="doit",order=100)
        public boolean ruleDoitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrnmod().getTrn().getInr()))
			{
			  MdaUtils.clear(this.getTrnmod());
			}
			int cnt=this.getTsklst().fullSize();
			log.info("{}","in service cnt="+cnt);
			//while(cnt!=0)
			//
			//
			// {
			//$trnmod\\wfmmod\\wfe.copyValue($tsklst.get(0));
			String inr=this.getTsklst().getElement(0).getWfeinr();
			if(!MdaUtils.isEmpty(inr))
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("inr",inr));
			}
			else
			{
			  inr=this.getTsklst().getElement(1).getWfeinr();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("inr",inr));
			}
			log.info("{}","wfe is loaded! inr="+this.getTrnmod().getWfmmod().getWfe().getInr());
			String wfsinr=this.getTrnmod().getWfmmod().getWfe().getWfsinr();
			ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),new Argument<String>("inr",wfsinr));
			log.info("{}","wfs is loaded! inr="+this.getTrnmod().getWfmmod().getWfs().getInr());
			log.info("{}","wfs is loaded! objtyp="+this.getTrnmod().getWfmmod().getWfs().getObjtyp());
			if("trn".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			{
			  log.info("{}","trn is loading...");
			  String trninr=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",trninr));
			  log.info("{}","trn is loaded! inr="+this.getTrnmod().getTrn().getInr());
			  // String wfdinr=$trnmod\\trn\\wfdinr.getValue();
			  // log.info("wfdinr="+wfdinr);
			  // Platform.dbRead($trnmod\\wfmmod\\wfd,new Argument<String>("inr",wfdinr));
			}
			//loadWfd();
			loadWft();
			String svrname=this.getTrnmod().getWfmmod().getWfe().getSrv();
			log.info("{}","svrname="+this.getTrnmod().getWfmmod().getWfe().getSrv());
			if("S".equals(svrname))
			{
			  this.getSigsvr().doHandle();
			}
			if("P".equals(svrname))
			{
			  this.getSptsvr().doHandle();
			}
			if("E".equals(svrname))
			{
			  this.getEmlsvr().doHandle();
			}
			if("M".equals(svrname))
			{
			  this.getSmssvr().doHandle();
			}
			if("T".equals(svrname))
			{
			  this.getTcosvr().doHandle();
			}
			if("F".equals(svrname))
			{
			  this.getFinsvr().doHandle();
			}
			updateList();
			cnt=this.getTsklst().fullSize();
			log.info("{}", "after update, list size="+cnt);
			//
			// }
			
			return true;
        }



        /**
        *   source:mgrtsk.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","mgrtsk start...");
			//String[] sql=new String[]{"W","R"};
			//Platform.dbReadset($wfelst,new Argument("sta",IN,sql));e
			updateList();
			//service();
			
			return true;
        }


        /**
        *   source:mgrtsk.@0002.script
        */
        public void updateList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getTsklst());
			String sql="SELECT wfe.inr wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim "
			  +"FROM wfe,wfs WHERE (sta='W' or sta='R') AND wfsinr=wfs.inr AND ( wfs.wkftyp = '0' or wfs.wkftyp is null )";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errorcode=ctx.getErrorCode();
			Argument<String> wfeinr=new Argument<String>("wfeinr");
			Argument<String> wfsinr=new Argument<String>("wfsinr");
			Argument<String> objtyp=new Argument<String>("objtyp");
			Argument<String> objinr=new Argument<String>("objinr");
			Argument<String> srv=new Argument<String>("srv");
			Argument<String> sta=new Argument<String>("sta");
			Argument<String> rtycnt=new Argument<String>("rtycnt");
			Argument<Date> tardattim=new Argument<Date>("tardattim");
			while(true)
			{

			  ctx.getDaoSession().dbFetchFields(wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getTsklst().add(wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:mgrtsk.@0003.script
        */
        public void  loadWfd()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String transname=this.getTrnmod().getTrn().getInifrm();
			//或者通过在WFS表中增加一个字段记录WFT/INR，以免查表
			Argument<String> tinr=new Argument<String>("inr");
			int errorcode=1;
			//optptyinr
			String optptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptptyinr();
			if(!MdaUtils.isEmpty(optptyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+optptyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    log.info("{}","wfd is loaded!inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr());
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+optptyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode=ctx.getErrorCode();
			      if(ecode==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode==NO_MORE_ROW)
			      {
			        log.info("{}","not found in pty.go to ety...");
			      }
			    }
			    else
			    {
			      log.info("{}","hehe should be dumped... ");
			    }
			  }
			}
			//optetyinr
			String optetyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptetyinr();
			if (!MdaUtils.isEmpty(optetyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+optetyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+optetyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode1=ctx.getErrorCode();
			      if(ecode1==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode1==NO_MORE_ROW)
			      {
			        log.info("{}","not found in pty.go to etg...");
			      }
			    }
			    else
			    {
			      log.info("{}","hehe should be dumped... ");
			    }
			  }
			}
			//optetginr
			String optetginr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptetginr();
			if (!"".equals(optetginr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='etg' and objinr='"+optetginr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr,nam FROM wfd WHERE objtyp='etg' and objinr='"+optetginr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode2=ctx.getErrorCode();
			      if(ecode2==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode2==NO_MORE_ROW)
			      {
			        ctx.setMessage("",MdaUtils.getI18NString("mgrtsk","CT000030"));
			      }
			      if(!(ecode2==NO_MORE_ROW  ||  ecode2==NO_MORE_ROW))
			      {
			        log.info("{}","here should be dumped... ");
			      }
			    }
			    else
			    {
			      log.info("{}","here should be dumped... ");
			    }
			  }
			}
		}
        /**
        *   source:mgrtsk.@0004.script
        */
        public void loadWft()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","wft is loading...");
			String wfdinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr();
			if(MdaUtils.isEmpty(wfdinr))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("mgrtsk","CT000056"));
			  return;
			}
			//String transname=Platform.getTransName();
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("frm",transname));
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjtyp();
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjinr();
			String stp=null;
			String inifrm=this.getTrnmod().getTrn().getInifrm();
			if("bnkspt".equals(inifrm))
			{
			  stp="3";
			}
			else
			if("littrs".equals(inifrm)  ||  "gittrs".equals(inifrm))
			{
			  stp="2";
			}
			else
			{
			  //stp="2";
			  stp="1";
			}
			log.info("{}","wfdinr"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr()+",objtyp="+objtyp+",objinr="+objinr+",stp="+stp);
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("frm",transname));
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp),new Argument<String>("frm",inifrm));
			int errorcode=ctx.getErrorCode();
			if (errorcode==NO_ERROR)
			{
			  log.info("{}", "loadWft succeed");
			  return;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}", "loadWft NO_MORE_ROW,find next fix one");
			    //Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("stp","2"));
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp));
			    errorcode=ctx.getErrorCode();
			    if (errorcode==NO_ERROR)
			    {
			      log.info("{}", "find it ,loadWft succeed,inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft().getInr());
			      return;
			    }
			    else
			    {
			      ctx.setMessage("",MdaUtils.getI18NString("mgrtsk","CT000057"));
			      return;
			    }
			  }
			  else
			  {
			    ctx.setMessage("","Execute error!");
			  }
			}
		}
        /**
        *   source:mgrtsk.@0005.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  1.限制mgttsk只在一台服务器上运行，可在transaction.properties中配置服务ip
			  2.在配置文件中配置isServer判断是服务器上还是本地运行
			  3.本地测试暂时将此屏蔽掉,后面需要放开
			  */
			/*
			  //指定服务器处理后台服务
			  String proFilPth = Platform.catPath(Platform.getRootPath(),"/data/transaction.properties");
			  String isServer = Platform.getPropertyValue(proFilPth,"isServer");
			  log.debug("isServer=" + isServer);
			  if("1".equals(isServer))
			  {
			  String webserver = (String)java.lang.System.getProperty("weblogic.management.server");
			  log.info("weblogic.management.server："+webserver);
			  String workserver =Platform.getPropertyValue(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"transaction.properties"),"mgrtskworkserver");
			  if(Platform.isEmpty(workserver))
			  return;
			  if(!webserver.contains(workserver))
			  return;
			  }
			  */

			//判断是否在浮动IP的机器上执行
			Object obj = MdaUtils.invoke("com.cib.window.util.NetworkUtil","checkwork");
			if(!(boolean)obj)
			  return ;

			Thread current=Thread.currentThread();
			log.debug("{}","mgrtsk service 被执行...线程id:["+current.getId()+"]");

			updateList();
			//refreshBranch(2);
			refreshthreeth(30);
			Argument<String> inr=new Argument<String>("inr","");
			for(int i=0;i<this.getTsklst().fullSize();i++)
			{
			  MdaUtils.clear(this.getTrnmod().getWfmmod());
			  // Read WFE
			  inr.value=this.getTsklst().getElement(i).getWfeinr();
			  if(MdaUtils.isEmpty(inr.value))
			    continue;
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),inr);
			  // Read WFS
			  inr.value=this.getTrnmod().getWfmmod().getWfe().getWfsinr();
			  if(MdaUtils.isEmpty(inr.value))
			    continue;
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),inr);
			  // Read TRN or SPT
			  if("trn".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			  {
			    inr.value=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			    if(MdaUtils.isEmpty(inr.value))
			      continue;
			    ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),inr);
			  }
			  else if("spt".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			  {
			    inr.value=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			    if(MdaUtils.isEmpty(inr.value))
			      continue;
			    ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),inr);
			    if(ctx.getErrorCode()==NO_MORE_ROW)
			    {
			      this.getTrnmod().getWfmmod().getWfe().setSta("E");
			      ctx.getDaoSession().dbBegin();
			      ctx.getDaoSession().dbUpdate(this.getTrnmod().getWfmmod().getWfe());
			      ctx.getDaoSession().dbCommit();
			      continue;
			    }
			  }
			  String svrname=this.getTrnmod().getWfmmod().getWfe().getSrv();
			  log.info("{}","wfe inr wfsinr:"+this.getTrnmod().getWfmmod().getWfe().getInr()+"|"+this.getTrnmod().getWfmmod().getWfe().getWfsinr());
			  if("S".equals(svrname))
			    this.getSigsvr().doHandle();
			  else if("P".equals(svrname))
			    this.getSptsvr().doHandle();
			  else if("E".equals(svrname))
			    this.getEmlsvr().doHandle();
			  else if("M".equals(svrname))
			    this.getSmssvr().doHandle();
			  else if("N".equals(svrname))
			    this.getSmssvr().doHandleBank();
			  else if("T".equals(svrname))
			    this.getTcosvr().doHandle();
			  else if("F".equals(svrname))
			    this.getFinsvr().doHandle();
			  // else if("Z".equals(svrname))
			  //  $msgsvr.doHandle();
			}
			log.debug("{}","mgrtsk service 退出...线程id:["+current.getId()+"]");
		}
        /**
        *   source:mgrtsk.@0008.script
        */
        public void refreshBranch(int days)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Date today = MdaUtils.today();
			if(days<1)days=1;
			if(MdaUtils.isEmpty(this.getBrhtime()))
			  this.setBrhtime(MdaUtils.add(today,-days));
			Date exeDay = MdaUtils.add((Date)this.getBrhtime(),days);
			if(MdaUtils.diff(today,exeDay)<=0)
			  return;
			log.debug("{}","=====begin  refreshBranch========");
			log.debug("{}","last exec\t"+MdaUtils.format((Date)this.getBrhtime(),"yyyyMMdd-HH:mm:ss"));
			log.debug("{}","days    \t"+days);
			log.debug("{}","next exeDay\t"+MdaUtils.format(exeDay,"yyyyMMdd-HH:mm:ss"));
			log.debug("{}","today   \t"+MdaUtils.format(today,"yyyyMMdd-HH:mm:ss"));
			this.setBrhtime(MdaUtils.today());
			String cls = "com.brilliance.txn.service.Txn8010Service";
			//Object o = Platform.invoke(cls,"sendOrder");
			//log.debug("sendOrder "+o);
			//boolean flg = Boolean.valueOf(o.toString());
			//if(!flg)
			// return;
			//String fil = Platform.catPath(Platform.getRootPath(),"data/temp/BankBranchInf.txt");
			//Platform.invoke(cls,"getBranchInf",fil);
			log.debug("{}","before parseBranchFile");
			List<Map> data = (List<Map>)MdaUtils.invoke(cls,"parseBranchFile","BankBranchInf");
			log.debug("{}","after parseBranchFile");
			log.debug("{}","size"+data.size());
			if(data==null||data.size()==0)
			  return;
			ctx.getDaoSession().dbBegin();
			for(Map<String,String> brh:data)
			{
			  log.debug("{}","cid="+brh.get("cid"));
			  if(MdaUtils.isEmpty(brh.get("cid")))
			    continue;
			  MdaUtils.clear(this.getMgrgrp().getPty());
			  ctx.getDaoSession().dbRead(this.getMgrgrp().getPty(),new Argument("cid",brh.get("cid")));
			  log.debug("{}","readinr "+this.getMgrgrp().getPty().getInr());
			  if(!MdaUtils.isEmpty(this.getMgrgrp().getPty().getInr()))
			    continue;
			  this.getMgrgrp().getPty().setInr(Platform.sdbCounter("pty"));
			  this.getMgrgrp().getPty().setPtytyp("0");
			  this.getMgrgrp().getPty().setCid(brh.get("cid"));
			  this.getMgrgrp().getPty().setBrhlvl(brh.get("brhlvl"));
			  this.getMgrgrp().getPty().setNam(brh.get("nam"));
			  this.getMgrgrp().getPty().setPntinr(brh.get("pntinr"));
			  this.getMgrgrp().getPty().setBrhflg("0");
			  this.getMgrgrp().getPty().setLvl("3");
			  this.getMgrgrp().getPty().setStatus("0");
			  this.getMgrgrp().getPty().setEtyinr("00000000");
			  log.debug("{}","insert brh "+this.getMgrgrp().getPty().getInr());
			  ctx.getDaoSession().dbInsert(this.getMgrgrp().getPty());
			  if(MdaUtils.isEmpty(brh.get("tel")))
			    continue;
			  this.getMgrgrp().getAdr().setInr(Platform.sdbCounter("adr"));
			  this.getMgrgrp().getAdr().setTel(brh.get("tel"));
			  this.getMgrgrp().getPta().setInr(Platform.sdbCounter("pta"));
			  this.getMgrgrp().getPta().setPtytyp("0");
			  this.getMgrgrp().getPta().setObjinr(this.getMgrgrp().getAdr().getInr());
			  this.getMgrgrp().getPta().setPtyinr(this.getMgrgrp().getPty().getInr());
			  ctx.getDaoSession().dbInsert(this.getMgrgrp().getPta());
			  ctx.getDaoSession().dbInsert(this.getMgrgrp().getAdr());
			  log.debug("{}","insert pta "+this.getMgrgrp().getPta().getInr());
			  log.debug("{}","insert adr "+this.getMgrgrp().getAdr().getInr());
			}
			ctx.getDaoSession().dbCommit();
			log.debug("{}","=====end    refreshBranch========");
		}
        /**
        *   source:mgrtsk.@0011.script
        */
        public void refreshthreeth(int dat)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Date date=MdaUtils.today();
			//Date dats=Platform.parseDate(dat,"yyyyMMddHHmmss")
			if(MdaUtils.isEmpty(this.getBrhtime()))
			  this.setBrhtime(MdaUtils.add(date,DATE_SECOND,-dat));
			Date exeDay = MdaUtils.add((Date)this.getBrhtime(),dat);
			//if(Platform.diff(date,exeDay)<=0)
			//return;
			log.debug("{}","last exec\t"+MdaUtils.format((Date)this.getBrhtime(),"yyyyMMdd-HH:mm:ss"));
			log.debug("{}","date   \t"+MdaUtils.format(date,"yyyyMMdd-HH:mm:ss"));

			String cls="com.brilliance.eibs.main.Client";
			Object retSMS=MdaUtils.invoke(cls,"scall","clearecv","clearecv");
			boolean success= (Boolean)MdaUtils.invoke(retSMS,"isSuccess");
			log.debug("{}","success   ："+success);
			String retCode=(String)MdaUtils.invoke(retSMS,"getReturnCode");
			Object content = MdaUtils.invoke(retSMS,"getContent") ;
			String retss = (String)MdaUtils.invoke(retSMS,"getContent").toString() ;
			log.debug("{}","retss    =: "+retss);
			log.debug("{}","content    =: "+content);
			log.debug("{}","retCode    =:  "+retCode);
			//if("true".equals(retss.substring(0,5).trim()))
			if(success)
			{
			  log.debug("{}","接口调用成功！{success=: "+success+" }");
			  //return true;
			}
			else
			{
			  log.debug("{}","接口调用失败！{success=: "+success+" }"+"调用失败码  :"+retss.replaceFirst("false",""));
			  //return false;
			}
		}
























}