package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.MgwtskVO;

import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.manager.module.Xmlsvr;
import com.ceb.gjjs.mda.manager.module.Finsvr;
import com.ceb.gjjs.mda.manager.module.Mgrgrp;
import com.ceb.gjjs.mda.bo.Wfe;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Tsklst;
import com.ceb.gjjs.mda.manager.module.Smssvr;
import com.ceb.gjjs.mda.manager.module.Msgsvr;
import com.ceb.gjjs.mda.manager.module.Sigsvr;
import com.ceb.gjjs.mda.manager.module.Emlsvr;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bimenu;
import com.ceb.gjjs.mda.manager.module.Xmlmap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 工作流服务
*/
@Transaction(vo= MgwtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mgwtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Mgwtsk.class);

        //执行
        private transient IControl doit = new ControlImpl("doit", "执行", this);
        //停止
        private transient IControl stop = new ControlImpl("stop", "停止", this);
        //执行标志
        private String strflg;
        //开始时间
        private Date strtim;
        //结束标志
        private String terflg;
        //重启时间间隔
        private int redotime;
        //开始
        private transient IControl start = new ControlImpl("start", "开始", this);
        //刷新
        private transient IControl update = new ControlImpl("update", "刷新", this);
		@BDGetter
		private ModuleList<Tsklst> tsklst;

		@BDGetter
		private ModuleList<Wfe> wfelst;

		@BDGetter
		private Msg msg;

		@BDGetter
		private Sigsvr sigsvr;

		@BDGetter
		private Emlsvr emlsvr;

		@BDGetter
		private Smssvr smssvr;

		@BDGetter
		private Finsvr finsvr;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Mgrgrp mgrgrp;

		@BDGetter
		private Xmlsvr xmlsvr;

		@BDGetter
		private Xmlmap xmlmap;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Msgsvr msgsvr;

		@BDGetter
		private Bimenu bimenu;


		public Mgwtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSigsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getSigsvr().setWfsHolder(()->this.getTrnmod().getWfmmod().getWfs());
           this.getEmlsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getEmlsvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getEmlsvr().setMsgHolder(()->this.getMsg());
           this.getSmssvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getSmssvr().setMsgHolder(()->this.getMsg());
           this.getSmssvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getFinsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getFinsvr().setTrnHolder(()->this.getTrnmod().getTrn());
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>("0"));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getXmlsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
           this.getXmlmap().setHeadbchcodHolder(new FieldConstantHolder<>("08101"));
           this.getMtabut().setRecHolder(()->this.getMsg());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMsgsvr().setTrnHolder(()->this.getTrnmod().getTrn());
           this.getMsgsvr().setSptHolder(()->this.getSysmod().getSpt());
           this.getMsgsvr().setWfeHolder(()->this.getTrnmod().getWfmmod().getWfe());
        }

        /**
        *   source:mgwtsk.@0001.script
        */
        @Rule(target="doit",order=100)
        public boolean ruleDoitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrnmod().getTrn().getInr()))
			{
			  MdaUtils.clear(this.getTrnmod());
			}
			int cnt=this.getTsklst().fullSize();
			log.info("{}","in service cnt="+cnt);
			//$trnmod\\wfmmod\\wfe.copyValue($tsklst.get(0));
			String inr=this.getTsklst().getElement(0).getWfeinr();
			if(!MdaUtils.isEmpty(inr))
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("inr",inr));
			}
			else
			{
			  inr=this.getTsklst().getElement(1).getWfeinr();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),new Argument<String>("inr",inr));
			}
			log.info("{}","wfe is loaded! inr="+this.getTrnmod().getWfmmod().getWfe().getInr());
			String wfsinr=this.getTrnmod().getWfmmod().getWfe().getWfsinr();
			ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),new Argument<String>("inr",wfsinr));
			log.info("{}","wfs is loaded! inr="+this.getTrnmod().getWfmmod().getWfs().getInr());
			log.info("{}","wfs is loaded! objtyp="+this.getTrnmod().getWfmmod().getWfs().getObjtyp());
			if("trn".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			{

			  log.info("{}","trn is loading...");
			  String trninr=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",trninr));
			  log.info("{}","trn is loaded! inr="+this.getTrnmod().getTrn().getInr());
			}
			//loadWfd();
			loadWft();
			String svrname=this.getTrnmod().getWfmmod().getWfe().getSrv();
			log.info("{}","svrname="+this.getTrnmod().getWfmmod().getWfe().getSrv());
			if("S".equals(svrname))
			{
			  this.getSigsvr().doHandle();
			}
			if("E".equals(svrname))
			{
			  this.getEmlsvr().doHandle();
			}
			if("M".equals(svrname))
			{
			  this.getSmssvr().doHandle();
			}
			if("X".equals(svrname))
			{
			  this.getXmlsvr().doHandle(); //xml报文服务
			}
			if("F".equals(svrname))
			{
			  this.getFinsvr().doHandle();
			}
			updateList();
			cnt=this.getTsklst().fullSize();
			log.info("{}", "after update, list size="+cnt);

			return true;
        }



        /**
        *   source:mgwtsk.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//
			log.info("{}","mgwtsk start...");
			updateList();

			return true;
        }


        /**
        *   source:mgwtsk.@0002.script
        */
        public void updateList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：加载待处理的工作流列表
			  */

			MdaUtils.clear(this.getTsklst());
			String sql="SELECT wfe.inr wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim "
			  +"FROM wfe,wfs WHERE (sta='W' or sta='R') AND wfsinr=wfs.inr AND wfs.wkftyp ='1' ";
			ctx.getDaoSession().dbExecuteSQL(sql);
			int errorcode=ctx.getErrorCode();
			Argument<String> wfeinr=new Argument<String>("wfeinr");
			Argument<String> wfsinr=new Argument<String>("wfsinr");
			Argument<String> objtyp=new Argument<String>("objtyp");
			Argument<String> objinr=new Argument<String>("objinr");
			Argument<String> srv=new Argument<String>("srv");
			Argument<String> sta=new Argument<String>("sta");
			Argument<String> rtycnt=new Argument<String>("rtycnt");
			Argument<Date> tardattim=new Argument<Date>("tardattim");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim);
			  if(ctx.getErrorCode()==NO_ERROR)
			    this.getTsklst().add(wfeinr,wfsinr,objtyp,objinr,srv,sta,rtycnt,tardattim);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:mgwtsk.@0003.script
        */
        public void  loadWfd()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String transname=this.getTrnmod().getTrn().getInifrm();
			//或者通过在WFS表中增加一个字段记录WFT/INR，以免查表
			Argument<String> tinr=new Argument<String>("inr");
			int errorcode=1;
			//optptyinr
			String optptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptptyinr();
			if(!MdaUtils.isEmpty(optptyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+optptyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    log.info("{}","wfd is loaded!inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr());
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+optptyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode=ctx.getErrorCode();
			      if(ecode==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode==NO_MORE_ROW)
			      {
			        log.info("{}","not found in pty.go to ety...");
			      }
			    }
			    else
			    {
			      log.info("{}","hehe should be dumped... ");
			    }
			  }
			}
			//optetyinr
			String optetyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptetyinr();
			if (!MdaUtils.isEmpty(optetyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+optetyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+optetyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode1=ctx.getErrorCode();
			      if(ecode1==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode1==NO_MORE_ROW)
			      {
			        log.info("{}","not found in pty.go to etg...");
			      }
			    }
			    else
			    {
			      log.info("{}","hehe should be dumped... ");
			    }
			  }
			}
			//optetginr
			String optetginr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getOptetginr();
			if (!"".equals(optetginr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='etg' and objinr='"+optetginr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if(errorcode==NO_MORE_ROW)
			    {
			      sql="SELECT inr,nam FROM wfd WHERE objtyp='etg' and objinr='"+optetginr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      int ecode2=ctx.getErrorCode();
			      if(ecode2==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if(ecode2==NO_MORE_ROW)
			      {
			        ctx.setMessage("",MdaUtils.getI18NString("mgwtsk","CT000030"));
			      }
			      if(!(ecode2==NO_MORE_ROW  ||  ecode2==NO_MORE_ROW))
			      {
			        log.info("{}","here should be dumped... ");
			      }
			    }
			    else
			    {
			      log.info("{}","here should be dumped... ");
			    }
			  }
			}
		}
        /**
        *   source:mgwtsk.@0004.script
        */
        public void loadWft()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","wft is loading...");
			String wfdinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr();
			if(MdaUtils.isEmpty(wfdinr))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("mgwtsk","CT000056"));
			  return;
			}
			//String transname=Platform.getTransName();
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("frm",transname));
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjtyp();
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjinr();
			String stp=null;
			String inifrm=this.getTrnmod().getTrn().getInifrm();
			if("bnkspt".equals(inifrm))
			{
			  stp="3";
			}
			else
			if("littrs".equals(inifrm)  ||  "gittrs".equals(inifrm))
			{
			  stp="2";
			}
			else
			{
			  //stp="2";
			  stp="1";
			}
			log.info("{}","wfdinr"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr()+",objtyp="+objtyp+",objinr="+objinr+",stp="+stp);
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("frm",transname));
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp),new Argument<String>("frm",inifrm));
			int errorcode=ctx.getErrorCode();
			if (errorcode==NO_ERROR)
			{
			  log.info("{}", "loadWft succeed");
			  return;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}", "loadWft NO_MORE_ROW,find next fix one");
			    //Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("stp","2"));
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp));
			    errorcode=ctx.getErrorCode();
			    if (errorcode==NO_ERROR)
			    {
			      log.info("{}", "find it ,loadWft succeed,inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft().getInr());
			      return;
			    }
			    else
			    {
			      ctx.setMessage("",MdaUtils.getI18NString("mgwtsk","CT000057"));
			      return;
			    }
			  }
			  else
			  {
			    ctx.setMessage("","Execute error!");
			  }
			}
		}
        /**
        *   source:mgwtsk.@0005.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*String webserver = (String)java.lang.System.getProperty("weblogic.management.server");
			  //log.info("weblogic.management.server："+webserver);
			
			  String workserver =Platform.getPropertyValue(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"transaction.properties"),"mgrtskworkserver");
			  if(Platform.isEmpty(workserver))
			  return;
			  if(!webserver.contains(workserver))
			  return;
			
			  // log.debug("mgwtsk service 被执行...");
			  eDIPBatchTask(state);*/
			//判断是否在浮动IP的机器上执行
			Object obj = MdaUtils.invoke("com.cib.window.util.NetworkUtil","checkwork");
			if(!(boolean)obj)
			  return ;

			Thread current=Thread.currentThread();
			log.debug("{}","mgrtsk service 被执行...线程id:["+current.getId()+"]");

			updateList();
			Argument<String> inr=new Argument<String>("inr","");
			for(int i=0;i<this.getTsklst().fullSize();i++)
			{
			  MdaUtils.clear(this.getTrnmod().getWfmmod());
			  // Read WFE
			  inr.value=this.getTsklst().getElement(i).getWfeinr();
			  if(MdaUtils.isEmpty(inr.value))
			    continue;
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfe(),inr);
			  // Read WFS
			  inr.value=this.getTrnmod().getWfmmod().getWfe().getWfsinr();
			  if(MdaUtils.isEmpty(inr.value))
			    continue;
			  ctx.getDaoSession().dbRead(this.getTrnmod().getWfmmod().getWfs(),inr);
			  // Read TRN or SPT
			  if("trn".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			  {
			    inr.value=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			    if(MdaUtils.isEmpty(inr.value))
			      continue;
			    ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),inr);
			  }
			  else if("spt".equals(this.getTrnmod().getWfmmod().getWfs().getObjtyp()))
			  {
			    inr.value=this.getTrnmod().getWfmmod().getWfs().getObjinr();
			    if(MdaUtils.isEmpty(inr.value))
			      continue;
			    ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),inr);
			    if(ctx.getErrorCode()==NO_MORE_ROW)
			    {
			      this.getTrnmod().getWfmmod().getWfe().setSta("E");
			      ctx.getDaoSession().dbBegin();
			      ctx.getDaoSession().dbUpdate(this.getTrnmod().getWfmmod().getWfe());
			      ctx.getDaoSession().dbCommit();
			      continue;
			    }
			  }
			  String svrname=this.getTrnmod().getWfmmod().getWfe().getSrv();
			  log.info("{}","wfsinr =" + this.getTrnmod().getWfmmod().getWfe().getWfsinr() +", wfe.inr=" + this.getTrnmod().getWfmmod().getWfe().getInr()) ;
			  if("S".equals(svrname))
			    this.getSigsvr().doHandle(); //签名服务
			  else if("E".equals(svrname))
			    this.getEmlsvr().doHandle(); //邮件服务
			  else if("M".equals(svrname))
			    this.getSmssvr().doHandle(); //短信服务
			  else if("X".equals(svrname))
			    this.getXmlsvr().doHandle(); //xml报文服务
			  else if("F".equals(svrname))
			    this.getFinsvr().doHandle(); // 最终状态服务
			  else if("Z".equals(svrname))
			    this.getMsgsvr().doHandle(); // 最终状态服务
			}
		}
        /**
        *   source:mgwtsk.@0012.script
        */
        public void eDIPBatchTask(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *加载代理跨境每日EDIP批处理任务
			  */
			//log.debug("开始进行EDIP批量处理：" + Platform.today());
			String cls = "com.brilliance.eibs.server.manager.TaskManagerUtil";
			// 调用接口平台 2.0加载夜间批处理定时任务
			// 1.大额行号   2.代理人民币跨境汇款对账文件
			MdaUtils.invoke(cls,"task","batchservice",true,state,new Object[]{});
			//log.debug("EDIP批量处理完成：" + Platform.today());
					}
























}