package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.OfficeVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Notgrp;
import com.ceb.gjjs.mda.manager.module.Imgmod;
import com.ceb.gjjs.mda.manager.module.Offp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* OFFICE界面
*/
@Transaction(vo= OfficeVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Office extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Office.class);

        //通知文件夹
        private transient IControl adv = new ControlImpl("adv", "通知文件夹", this);
        //通知交易个数
        private String advsize;
        //授权文件夹
        private transient IControl auth = new ControlImpl("auth", "授权文件夹", this);
        //需要授权交易笔数
        private String autsize;
        //银行审核中
        private IStream bnk = new StreamImpl();
        //待办文件夹
        private transient IControl todolst = new ControlImpl("todolst", "待办文件夹", this);
        //待办交易笔数
        private String todosize;
        //银行审核中交易笔数
        private String bnksize;
        //暂存文件夹
        private transient IControl ped = new ControlImpl("ped", "暂存文件夹", this);
        //暂存交易笔数
        private String pedsize;
        //历史文件夹
        private transient IControl his = new ControlImpl("his", "历史文件夹", this);
        //历史交易笔数
        private String hissize;
        //退回文件夹
        private transient IControl back = new ControlImpl("back", "退回文件夹", this);
        //退回个数
        private String backzise;
        //待办文件夹项目Label
        private String tdolabel;
        //launch
        private transient IControl launch = new ControlImpl("launch", "launch", this);
        //交易代码
        private String trncod;
        //查阅
        private transient IControl watch = new ControlImpl("watch", "查阅", this);
        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);
        //单一窗口夹
        private transient IControl dicsel = new ControlImpl("dicsel", "单一窗口夹", this);
        //单一窗口业务数
        private String dicsize;
		@BDGetter
		private Notgrp notgrp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Offp offp;

		@BDGetter
		private Imgmod imgmod;


		public Office()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getOffp().setNotgrpHolder(()->this.getNotgrp());
        }

        /**
        *   source:office.@0001.script
        */
        @Rule(target="adv",order=0)
        public boolean ruleAdvN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0002.script
        */
        @Rule(target="auth",order=0)
        public boolean ruleAuthN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0003.script
        */
        @Rule(target="bnk",order=0)
        public boolean ruleBnkN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0004.script
        */
        @Rule(target="his",order=0)
        public boolean ruleHisN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0005.script
        */
        @Rule(target="ped",order=0)
        public boolean rulePedN0(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0006.script
        */
        @Rule(target="todolst",order=0)
        public boolean ruleTodolstN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:office.@0014.script
        */
        @Rule(target="back",order=100)
        public boolean ruleBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:office.@0017.script
        */
        @Rule(target="launch",order=100)
        public boolean ruleLaunchN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getTrncod()))
			{
			  
			}

			return true;
        }

        /**
        *   source:office.@0018.script
        */
        @Rule(target="watch",order=100)
        public boolean ruleWatchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getNotgrp().getStb());
			int index=0;
			int size=this.getNotgrp().getStblst().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("office","CT000049"),MdaUtils.getI18NString("office","CT000050"));
			  return true;
			}
			this.getNotgrp().getStb().copyValue(this.getNotgrp().getStblst().getElement(index));
			log.debug("{}","txt=" +this.getNotgrp().getStb().getTxt());
			
			

			return true;
        }

        /**
        *   source:office.@0019.script
        */
        @Rule(target="imgviw",order=100)
        public boolean ruleImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}","in imgScan ... ");
			String imgref = this.getNotgrp().getStb().getImgref();
			this.getImgmod().imgSscan(imgref);
			log.debug("{}"," out imgviw....");
			/*String imgref = $notgrp\\stb\\imgref.getValue();
			  log.debug("imgref=" +imgref);
			  String objtyp = "stb";
			  if(Platform.isEmpty(imgref))
			  {
			  Platform.message(#CT000053,#CT000054);
			  return false;
			  }
			  String imgPath =(Platform.catPath(Platform.getRootPath(),"img/") + "/" + Platform.format(Platform.today(),"yyyyMMdd"));
			  log.debug("imgPath=" +imgPath);
			  Map<String,Object> data1 = new HashMap<String,Object>();
			  data1.put("occurdate",Platform.format(Platform.today(),"yyyyMMdd"));
			  data1.put("downloadpath",imgPath);
			  data1.put("needannotation","0");
			  data1.put("needthumbnail","0");
			  List<Map<String,Object> > conditionList = new  ArrayList<Map<String,Object> >();
			  Map<String,Object> data2 = new HashMap<String,Object>();
			  Map<String,Object> data3 = new HashMap<String,Object>();
			  data2.put("propertyname","OwnRef");
			  data2.put("propertyvalue",imgref);
			  data3.put("propertyname","ImageRegID");
			  data3.put("propertyvalue",imgref);
			  conditionList.add(data2);
			  conditionList.add(data3);
			  List<String> propertylist = new  ArrayList<String>();
			  propertylist.add("FlowID");
			  propertylist.add("CibBranchID");
			  propertylist.add("CibOrgID");
			  propertylist.add("CibOperID");
			  data1.put("propertylist",propertylist);
			  data1.put("conditionList",conditionList);
			  String cls="com.brilliance.eibs.main.Client";
			  Object resMsg = Platform.invoke(cls,"scall","dzticmquery","dzticmquery", new Object[]{data1});
			  if((Boolean)Platform.invoke(resMsg,"isSuccess"))
			  {
			  Object content = (Object)Platform.invoke(resMsg,"getContent") ;
			  String isSuc = content.toString();
			  log.debug("isSuc= "+isSuc);
			  if("true".equals(isSuc.substring(0,5).trim()))
			  {
			  log.debug("查询影像成功 ... ");
			  //查询影像成功则调用影像控件
			  boolean result= $imgmod.callImageComponent("ImageScan",imgref,imgref,Platform.getTransName(),$\\sysmod\\usr\\lgnnam.getValue(),objtyp);
			  if(result)
			  {
			  return true;
			  }
			  else
			  return false;
			  }
			  else
			  {
			  log.debug("查询影像失败 ... ");
			  String errorcod=isSuc.substring(5,24).trim();
			  log.debug("errorcod=" +errorcod);
			  String errorcodname=Platform.catPath(Platform.getRootPath(),"cfg/icmapi.properties");
			  String errorvalue=Platform.getPropertyValue(errorcodname,errorcod.substring(errorcod.indexOf("-")+1,errorcod.indexOf("-")+8));
			  log.debug("errorvalue=" +errorvalue);
			  if("D".equals(errorcod.substring(0,1)))
			  {
			  Platform.message(#CT000055,#CT000056);
			  return false ;
			  }
			  else
			  {
			  Platform.message(#CT000057,errorvalue);
			  return false;
			  }
			  }
			  }*/

			return true;
        }

        /**
        *   source:office.@0020.script
        */
        @Rule(target="notgrp.stblst",order=100)
        public boolean ruleNotgrpStblstN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getNotgrp().getStb());
			int index=0;
			int size=this.getNotgrp().getStblst().fullSize();
			if(index<0   ||   index>=size)
			{
			  ctx.setMessage(MdaUtils.getI18NString("office","CT000059"),MdaUtils.getI18NString("office","CT000060"));
			  return true;
			}
			this.getNotgrp().getStb().copyValue(this.getNotgrp().getStblst().getElement(index));
			log.debug("{}","txt=" +this.getNotgrp().getStb().getTxt());
			
			

			return true;
        }

        /**
        *   source:office.@0021.script
        */
        @Rule(target="dicsel",order=100)
        public boolean ruleDicselN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:office.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			readNot();
			String ptyinr=this.getSysmod().getPty().getInr();
			String cid=this.getSysmod().getPty().getCid();
			String img="/locale/images/yhshz.gif";
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.info("{}","ptyinr="+ptyinr+",cid="+cid);
			if("0".equals(ptytyp))
			  img="/locale/images/ywclz.gif";
			((IStream)this.getBnk()).setValue(img);
			setPendingNum(ptyinr,cid);
			setReleaseNum(ptyinr,cid);
			setTodoNum(ptyinr,cid);
			setBnkNum(ptyinr,cid);
			setBackNum(ptyinr,cid);
			setNoticeNum(ptyinr,cid);
			setHisNum(ptyinr,cid);
			setDayNum(ptyinr,cid);
			this.setTdolabel(MdaUtils.getI18NString("office","CT000022"));

			this.getNotgrp().setTdoimg("images/x.gif");
			if("3".equals(ptytyp)  ||  "2".equals(ptytyp))
			{
			  
			  
			  
			  

			  
			  
			}


			return true;
        }


        /**
        *   source:office.@0007.script
        */
        public void setPendingNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="SELECT COUNT(*) cnt FROM spt WHERE sta='P' and  scr='I'";
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr = inr AND ptytyp='0' or oprogninr='"+ptyinr+"')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr = inr AND  ptytyp='0' AND pntinr='"+cid+"' or oprogninr='"+ptyinr+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr = inr AND  ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"'))";
			  }
			  else
			  {
			    sql=sql+" AND oprogninr='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+" AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",pening cells="+cnt.value);
			  this.setPedsize(cnt.value.toString());
			}
			else
			{
			  log.info("{}","ecode="+ecode+",pening cells="+cnt.value);
			  this.setPedsize("0");
			}

			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0008.script
        */
        public void setReleaseNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String sql="SELECT COUNT(*) cnt FROM trn WHERE (sta='W' or sta ='M') and ptytyp='"+ptytyp+"' ";
			if("0".equals(ptytyp))
			{
			  String lvl=this.getSysmod().getPty().getLvl();

			  /*if("0".equals(lvl))
			    {
			    sql=sql+" AND  EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND ptyinr=inr)";
			    }
			    else if("1".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND pntinr='"+cid+"' AND ptyinr=inr)";
			    }
			    else
			    {
			    sql=sql+" AND optptyinr='"+ptyinr+"'";
			    }*/

			  if("0".equals(lvl))
			  {
			    sql=sql+" AND  EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND optptyinr=inr or optptyinr='"+ptyinr+"')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND pntinr='"+cid+"' AND optptyinr=inr or optptyinr='"+ptyinr+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"') AND optptyinr=inr or optptyinr='"+ptyinr+"')";
			  }
			  else
			  {
			    sql=sql+" AND optptyinr='"+ptyinr+"'";
			  }

			}
			else
			{
			  sql=sql+" AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Release cells="+cnt.value);
			  this.setAutsize(cnt.value.toString());
			}
			else
			{
			  this.setAutsize("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0009.script
        */
        public void setTodoNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String sql="SELECT COUNT(*) cnt FROM spt WHERE sta='T' AND scr='S'";
			if("0".equals(ptytyp))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  /*
			    if("1".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0')";
			    }
			    else if("2".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			    }
			    else
			    {
			    sql=sql+" AND oprogninr='"+ptyinr+"'";
			    }
			    */
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND pntinr='"+cid+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"'))";

			  }
			  else
			  {
			    sql=sql+" AND oprogninr='"+ptyinr+"'";
			  }

			}
			else
			{
			  sql=sql+" AND oprogninr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Todoing cells="+cnt.value);
			  this.setTodosize(cnt.value.toString());
			}
			else
			{
			  log.info("{}","excute SQL error");
			  this.setTodosize("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0010.script
        */
        public void setNoticeNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbReadset($offgrp,new Argument<String>("oprogninr",ptyinr),new Argument<String>("scr","A"),new Argument<String>("sta","T"));
			String sql="SELECT COUNT(*) cnt FROM spt WHERE  scr='A' AND sta='T'";
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			if("0".equals(ptytyp))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  /*
			    if("1".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0')";
			    }
			    else if("2".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			    }
			    else
			    {
			    sql=sql+" AND oprogninr='"+ptyinr+"'";
			    }
			    */
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND pntinr='"+cid+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE oprogninr=inr AND ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"'))";
			  }
			  else
			  {
			    sql=sql+" AND oprogninr='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+" AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Notice cells="+cnt.value);
			  this.setAdvsize(cnt.value.toString());
			}
			else
			{
			  this.setAdvsize("0");
			}

			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0011.script
        */
        public void setBackNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String sql="SELECT COUNT(*) cnt FROM spt WHERE sta='B'";
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  /*
			    String lvl=$sysmod\\pty\\lvl.getValue();
			    if("1".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE scrpty=inr AND ptytyp='0')";
			    }
			    else if("2".equals(lvl))
			    {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE scrpty=inr AND  ptytyp='0' AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			    }
			    else
			    {
			    sql=sql+" AND scrpty='"+ptyinr+"'";
			    }
			    */
			  String lvl=this.getSysmod().getPty().getLvl();
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE scrpty=inr AND ptytyp='0')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE scrpty=inr AND  ptytyp='0' AND pntinr='"+cid+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE scrpty=inr AND  ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"'))";
			  }
			  else
			  {
			    sql=sql+" AND scrpty='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+" AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			//Argument<BigDecimal> cnt =new Argument<BigDecimal>("cnt");
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Back cells="+cnt.value);
			  this.setBackzise(cnt.value.toString());
			}
			else
			{
			  log.info("{}","excute SQL error");
			  this.setBackzise("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0012.script
        */
        public void setHisNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql=null;
			String typ=ctx.absGet(Sysmod.class).getPty().getPtytyp();
			if("0".equals(typ))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  /*
			    if("1".equals(lvl))
			    {
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' AND EXISTS (SELECT inr FROM pty WHERE ptytyp='0' AND optptyinr=inr) AND cfmdattim>?";
			    }
			    else if("2".equals(lvl))
			    {
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' AND EXISTS (SELECT inr FROM pty WHERE substr(cid,1,2)='"+cid.substring(0,2)+"' AND optptyinr=inr) AND cfmdattim>? ";
			    }
			    else
			    {
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' AND optptyinr='"+ptyinr+"' AND cfmdattim>?";
			    }
			    */

			  if("0".equals(lvl))
			  {
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' and (ptytyp=0 or modtyp=1) AND((optptyinr is null and wfm='D') or EXISTS (SELECT inr FROM pty WHERE  optptyinr=inr)) AND cfmdattim>?";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' AND EXISTS (SELECT inr FROM pty WHERE pntinr='"+cid+"' AND optptyinr=inr) AND cfmdattim>? ";
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' and (ptytyp=0 or modtyp=1) AND EXISTS (SELECT inr FROM pty WHERE ( pntinr='"+cid+"' or cid = '"+cid +"') AND optptyinr=inr) AND cfmdattim>? ";
			  }
			  else
			  {
			    sql="SELECT COUNT(*) cnt FROM trn WHERE  sta='A' and (ptytyp=0 or modtyp=1) AND optptyinr='"+ptyinr+"' AND cfmdattim>?";
			  }

			}
			else if("1".equals(typ))
			{
			  sql="SELECT COUNT(*) cnt FROM trn WHERE sta='A' AND optptyinr='"+ptyinr+"' AND cfmdattim>?";
			}
			else
			{
			  sql="SELECT COUNT(*) cnt FROM trn WHERE sta='A' AND ptytyp = 2 and ptyinr='"+ptyinr+"' AND cfmdattim>?";
			}
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(MdaUtils.add(MdaUtils.today(),-360),LT));
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",History cells="+cnt.value);
			  this.setHissize(cnt.value.toString());
			}
			else
			{
			  log.info("{}","excute SQL error");
			  this.setHissize("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0013.script
        */
        public void setBnkNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String sql="SELECT COUNT(*) cnt FROM trn WHERE sta='R'";
			String typ=ctx.absGet(Sysmod.class).getPty().getPtytyp();
			log.debug("{}","typ=  "+typ);
			if("0".equals(typ))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  sql=sql+" AND ptytyp='0'";
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE optptyinr=INR AND ptytyp='0')";
			  }
			  else if("1".equals(lvl))
			  {
			    //sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE optptyinr=INR AND  ptytyp='0' AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			    sql=sql+" AND EXISTS (SELECT inr FROM pty WHERE optptyinr=INR AND ptytyp='0' AND( pntinr='"+cid+"' or cid = '"+cid +"'))";
			  }
			  else
			  {
			    //String[] brhlist=$sysmod.getLowBch(cid);
			    //sql=sql+" AND optptyinr in(SELECT p.inr inr FROM pty p WHERE p.ptytyp='0' AND p.lvl >'"+lvl+"')";
			    sql=sql+" AND ptytyp='0' AND optptyinr='"+ptyinr+"'";
			  }
			}
			else
			{
			  /*String lvl=$sysmod\\pty\\lvl.getValue();
			    log.debug("lvl=  "+lvl);
			    if("0".equals(lvl))
			    {
			    sql=sql+" AND optptyinr in(SELECT p.inr inr FROM pty p WHERE p.ptytyp='0' AND p.lvl >'"+lvl+"')";
			    }
			    else*/
			  //sql=sql+" AND optptyinr='"+ptyinr+"'";
			  sql=sql+" AND ptytyp='2' AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Back cells="+cnt.value);
			  this.setBnksize(cnt.value.toString());
			}
			else
			{
			  log.info("{}","ecode="+ecode+",excute SQL error");
			  this.setBnksize("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:office.@0016.script
        */
        public void readNot()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  if("0".equals(ptytyp))
			  Platform.dbReadset($notgrp\\stblst,
			  new Argument<String>("tbl","BULLETIN"),new Argument<String>("cod","1"));
			  else if(!"3".equals(ptytyp))
			  Platform.dbReadset($notgrp\\stblst,
			  new Argument<String>("tbl","BULLETIN"),new Argument<String>("cod","2"));
			  */
			//$notgrp\\notlabel.setValue(#CT000032);
			//Platform.visible($notgrp\\notlabel);
			//$notgrp\\notimg.setValue("images/billboard.gif");
			String cod = null;
			String sql = "SELECT * FROM stb WHERE tbl = 'BULLETIN'";
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			log.debug("{}","readNot ptytyp = "+ptytyp);
			if("0".equals(ptytyp))
			  sql += " AND cod = '1'";
			else if(!"3".equals(ptytyp))
			  sql += " AND cod = '2'";
			else
			{
			  //Platform.clear($notgrp\\notimg);
			  //log.debug("公告图片 = "+$notgrp\\notimg);
			  
			  
			  return;
			}
			sql += " order by opndat desc";
			ctx.getDaoSession().dbExecuteSQL(sql);
			MdaUtils.clear(this.getNotgrp().getStblst());
			Argument<String> txt = new Argument<String>("txt");
			//201711
			Argument<String> themas = new Argument<String>("themas");
			Argument<String> cod1 = new Argument<String>("cod");
			Argument<String> lgnnam = new Argument<String>("lgnnam");
			Argument<String> opndat = new Argument<String>("opndat");
			Argument<String> imgref = new Argument<String>("imgref");
			/*  while(true)
			  {
			  Platform.dbFetchFields(txt);
			  if(Platform.errorCode() == NO_ERROR)
			  {
			  txt.value = txt.value.replaceAll("\\\\\\\\r|\\\\\\\\R","\\r");
			  txt.value = txt.value.replaceAll("\\\\\\\\n|\\\\\\\\N","\\n");
			  $notgrp\\stblst.add(txt);
			  }
			  else
			  break;
			  }
			  */
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(txt,themas,cod1,lgnnam,opndat,imgref);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    this.getNotgrp().getStblst().add(txt,themas,cod1,lgnnam,opndat,imgref);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","共有公告"+this.getNotgrp().getStblst().fullSize()+"条。");
			
		}
        /**
        *   source:office.@0022.script
        */
        public void setDayNum(String ptyinr,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String sql="SELECT COUNT(*) cnt FROM trn t WHERE sta='Y' AND wfm='D' ";
			String typ=ctx.absGet(Sysmod.class).getPty().getPtytyp();
			log.debug("{}","typ=  "+typ);
			if("0".equals(typ))
			{
			  String lvl=this.getSysmod().getPty().getLvl();
			  sql=sql+" AND ptytyp='0'";
			  if("0".equals(lvl))
			  {
			    sql=sql+" AND (optptyinr is null or (EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr or t.optptyinr='"+ptyinr+"')))";
			  }
			  else if("1".equals(lvl))
			  {
			    sql=sql+" AND EXISTS (SELECT inr FROM pty p WHERE t.optptyinr=p.inr and (p.inr='"+ptyinr+"' or pntinr='"+cid+"'))";
			  }
			  else
			  {
			    sql=sql+" AND optptyinr='"+ptyinr+"'";
			  }
			}
			else
			{
			  sql=sql+" AND ptytyp='2' AND ptyinr='"+ptyinr+"'";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<Integer> cnt =new Argument<Integer>("cnt");
			ctx.getDaoSession().dbFetchFields(cnt);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_ERROR)
			{
			  log.info("{}","ecode="+ecode+",Dac cells="+cnt.value);
			  this.setDicsize(cnt.value.toString());
			}
			else
			{
			  log.info("{}","ecode="+ecode+",excute SQL error");
			  this.setDicsize("0");
			}
			
			ctx.getDaoSession().dbCloseCursor();
		}


























}