package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.QuevlmVO;

import com.ceb.gjjs.mda.manager.module.Vlmp;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Vlmgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Vlmmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 单证通交易量查询
*/
@Transaction(vo= QuevlmVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Quevlm extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Quevlm.class);

		@BDGetter
		private Vlmgrp vlmgrp;

		@BDGetter
		private Vlmmod vlmmod;

		@BDGetter
		private Vlmp vlmp;

		@BDGetter
		private Sysmod sysmod;


		public Quevlm()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getVlmmod().setVlmgrpHolder(()->this.getVlmgrp());
           this.getVlmp().setVlmgrpHolder(()->this.getVlmgrp());
        }

        /**
        *   source:quevlm.@0002.script
        */
        @Rule(target="vlmp.orgnam",order=100)
        public boolean ruleVlmpOrgnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getVlmp().getOrgnam()))
			{
			  String ptyr=this.getVlmp().getOrgnam();
			  String cid=this.getSysmod().getCidByInr(ptyr);
			  String lvl=this.getSysmod().getTransLevel(cid);
			  if("0".equals(lvl) || "1".equals(lvl))
			  {
			    //获取下属机构
			    
			    MdaUtils.setValues(this.getVlmp(),"suborg",getXList(cid));
			    if(!MdaUtils.isEmpty(getXList(cid)))
			      this.getVlmp().setSuborg(getXList(cid).get(0).getValue());
			  }
			  else
			  {
			    
			  }
			  
			}

			/*
			  if("3".equals($sysmod\\pty\\brhlvl.getValue()))
			  return;
			  else
			  {
			  String pntcid=$vlmp\\orgnam.getValue();
			  log.info("the pntcid is --- "+pntcid);
			  if(!Platform.isEmpty(pntcid))
			  {
			  Platform.clear($vlmp\\suborg);
			  List<CodetableItem> bch=new ArrayList<CodetableItem>();
			  if( Platform.headBchcod().equals(pntcid))
			  bch=$sysmod\\bchmod.getBchcodByDZTLevel("2");
			  if("2".equals($sysmod\\bchmod.getBchlvl(pntcid)))
			  bch=$sysmod\\bchmod.getSubBchcod(pntcid);
			  Platform.setValues($vlmp\\suborg,bch);
			  Platform.setModified($vlmp\\suborg);
			  }
			  }
			  */

			return true;
        }

        /**
        *   source:quevlm.@0003.script
        */
        @Rule(target="vlmp.query",order=100)
        public boolean ruleVlmpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//
			if(!ctx.checkAll(this.getVlmp()))
			  return false;
			log.info("{}","--------enter root searching ---------");
			MdaUtils.clear(this.getVlmgrp().getVlmlst());
			//修改
			String usrlvl="";
			String cid="";
			String ptyinr="";
			if(MdaUtils.isEmpty(this.getVlmp().getSuborg()))
			{
			  if(MdaUtils.isEmpty(this.getVlmp().getOrgnam()))
			  {
			    usrlvl=this.getSysmod().getPty().getLvl();
			    cid=this.getSysmod().getPty().getCid();
			    ptyinr=this.getSysmod().getPty().getInr();
			  }
			  else
			  {
			    ptyinr=this.getVlmp().getOrgnam();
			    cid=this.getSysmod().getCidByInr(ptyinr);
			    usrlvl=this.getSysmod().getTransLevel(cid);
			  }
			}
			else
			{
			  ptyinr=this.getVlmp().getSuborg();
			  cid=this.getSysmod().getCidByInr(ptyinr);
			  usrlvl=this.getSysmod().getTransLevel(cid);
			}
			//查全行
			if("0".equals(usrlvl))
			{
			  sumAllTrn(cid);
			}
			//查分行
			else if("1".equals(usrlvl))
			{
			  sumBrhTrn(cid);
			}
			//查支行
			else
			{
			  sumTrn(ptyinr);
			}
			/*
			  String usrlvl=$sysmod\\pty\\brhlvl.getValue();
			  log.info("---usr level is = "+usrlvl);
			  if(Platform.isEmpty($vlmp\\orgnam))
			  {
			  Platform.error($vlmp\\orgnam,#CT000004);
			  return false;
			  }
			  else
			  {
			  if("1".equals(usrlvl) && !Platform.isEmpty($vlmp\\orgnam))
			  {
			  if(Platform.headBchcod().equals($vlmp\\orgnam.getValue()))
			  {
			  if(Platform.isEmpty($vlmp\\suborg))
			  {
			  //查询全行
			  sumAllBchTrn();
			  }
			  else
			  {
			  //查询分行
			  sumBrhBchTrn($vlmp\\suborg.getValue());
			  }
			  }
			  else
			  {
			  String bchlvl=$sysmod\\bchmod.getBchlvl($vlmp\\orgnam.getValue());
			  if("2".equals(bchlvl))
			  {
			  if(!Platform.isEmpty($vlmp\\suborg))
			  {
			  //查询支行
			  sumBchTrn($vlmp\\suborg.getValue());
			  }
			  else
			  {
			  //查询分行
			  sumBrhBchTrn($vlmp\\orgnam.getValue());
			  }
			  }
			  }
			  }
			  else if("2".equals(usrlvl))
			  {
			  if(Platform.isEmpty($vlmp\\suborg))
			  {
			  //查询分行及其下属支行
			  sumBrhBchTrn($vlmp\\orgnam.getValue());
			  }
			  else
			  {
			  //查询某一支行
			  sumBchTrn($vlmp\\suborg.getValue());
			  }
			  }
			  else if("3".equals(usrlvl))
			  {
			  if(!Platform.isEmpty($vlmp\\suborg))
			  {
			  //查询某一支行
			  sumBchTrn($vlmp\\suborg.getValue());
			  }
			  }
			  }
			  */
			
			if(this.getVlmgrp().getVlmlst().fullSize()==0)
			  ctx.setMessage(MdaUtils.getI18NString("quevlm","CT000007"),MdaUtils.getI18NString("quevlm","CT000008"));
			log.info("{}","-----exit root searching------");

			return true;
        }


        /**
        *   source:quevlm.@0000.script
        */
        @Check(target="vlmp.begdat",order=100)
        public boolean checkVlmpBegdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getVlmp().getBegdat()))
			  ctx.setFieldError(this,"vlmp.begdat",MdaUtils.getI18NString("quevlm","CT000001"));

			return true;
        }

        /**
        *   source:quevlm.@0001.script
        */
        @Check(target="vlmp.enddat",order=100)
        public boolean checkVlmpEnddatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getVlmp().getEnddat()))
			  ctx.setFieldError(this,"vlmp.enddat",MdaUtils.getI18NString("quevlm","CT000002"));
			else if(!MdaUtils.isEmpty(this.getVlmp().getBegdat()))
			{
			  if(MdaUtils.diff(this.getVlmp().getEnddat(),this.getVlmp().getBegdat())<0)
			    ctx.setFieldError(this,"vlmp.enddat",MdaUtils.getI18NString("quevlm","CT000003"));
			}

			return true;
        }


        /**
        *   source:quevlm.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  String ptyinr=this.getSysmod().getUsr().getPtyinr();
			  String usrlvl=this.getSysmod().getPty().getLvl();
			  List<CodetableItem> bchcod=this.getSysmod().getBranchList(this.getSysmod().getPty().getCid());
			  log.info("{}","bchcod-size  = " + bchcod.size());
			  MdaUtils.setValues(this.getVlmp(),"orgnam",bchcod);
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getVlmp().setOrgnam(bchcod.get(0).getValue());
			  if(!MdaUtils.isEmpty(bchcod))
			    this.getVlmp().setOrgnam(bchcod.get(0).getValue());
			  //总行
			  if("0".equals(usrlvl) || "1".equals(usrlvl))
			  {
			    //获取下属机构
			    MdaUtils.setValues(this.getVlmp(),"suborg",getXList(this.getSysmod().getCidByInr(this.getVlmp().getOrgnam())));
			  }
			  /*分行
			    else if("1".equals(usrlvl))
			    {
			    Platform.setValues($vlmp\\orgnam,$sysmod\\bchmod.getBrhBchcod(ptyinr));
			    Platform.setValues($vlmp\\suborg,$sysmod\\bchmod.getSubBchcod($sysmod\\pty\\cid.getValue()));
			    }
			    */
			  //支行柜员
			  if ("2".equals(usrlvl))
			  {
			    
			    
			    /*
			      String pntnam=$sysmod\\bchmod.getBrhNam($sysmod\\pty\\pntinr.getValue());
			      List<CodetableItem> pntbch=new ArrayList<CodetableItem>();
			      pntbch.add(new CodetableItem(pntnam,$sysmod\\pty\\ptytyp.getValue()));
			      Platform.setValues($vlmp\\orgnam,pntbch);
			      $vlmp\\orgnam.setValue(pntbch.get(0).getValue());
			      //
			      List<CodetableItem> bch=new ArrayList<CodetableItem>();
			      bch.add(new CodetableItem($sysmod\\pty\\nam.getValue(),$sysmod\\pty\\cid.getValue()));
			      Platform.setValues($vlmp\\suborg,bch);
			      $vlmp\\suborg.setValue(bch.get(0).getValue());
			      */
			  }
			  //Platform.invisible($vlmp\\suborg);
			  this.getVlmp().setBegdat(MdaUtils.add(MdaUtils.today(),-30));
			  this.getVlmp().setEnddat(MdaUtils.today());

			  
			  
			}

			return true;
        }


        /**
        *   source:quevlm.@0012.script
        */
        public void sumBchTrn(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询某一机构的交易数及金额
			log.info("{}","--===current branch cid is :---"+bchcod+"--====--");
			List<String> dcpty=getDirectClient(bchcod);
			Integer cntsum=new Integer(0);
			BigDecimal amtsum= new BigDecimal(0.00) ;
			int size=dcpty.size();
			if(size==0)
			  return;
			else
			{
			  for(int i=0;i<size;i++)
			  {
			    String ptyinr=dcpty.get(i);
			    //查TRN表的申请
			    Integer apltrncnt=new Integer(0);
			    BigDecimal apltrnamt=new BigDecimal(0.00);
			    String aplsql="SELECT COUNT(inr) sumtrn, TO_CHAR(SUM(relamt)) sumamt FROM trn WHERE optptyinr=? AND inidattim>=? AND inidattim<=? ";
			    ctx.getDaoSession().dbExecuteSQL(aplsql,ptyinr,MdaUtils.sqlDate(this.getVlmp().getBegdat(),GT),MdaUtils.sqlDate(this.getVlmp().getEnddat(),LT));
			    if(NO_ERROR==ctx.getErrorCode())
			    {
			      Argument<Integer> aplcnt=new Argument<Integer> ("sumtrn");
			      Argument<String> aplamt=new Argument<String>("sumamt");
			      ctx.getDaoSession().dbFetchFields(aplcnt,aplamt);
			      if(NO_ERROR==ctx.getErrorCode())
			      {
			        log.info("{}","-*-"+ptyinr+"'--APL Trn cnt is:"+aplcnt.value+",--and APL trnsumamt is:"+aplamt.value);
			        if(!MdaUtils.isEmpty(aplcnt.value))
			          apltrncnt= aplcnt.getValue();
			        if(!MdaUtils.isEmpty(aplamt.value))
			        {
			          log.debug("{}","aplamt.value = " + aplamt.value);
			          apltrnamt= new BigDecimal(aplamt.value);
			        }
			      }

			    }
			    ctx.getDaoSession().dbCloseCursor();

			    cntsum=cntsum + apltrncnt ;
			    amtsum=amtsum.add(apltrnamt);
			    //查SPT表的通知
			    Integer advsptcnt=new Integer(0);
			    String advsptsql="SELECT COUNT(inr) sumspt FROM spt WHERE scr='A' AND ptyinr=? AND dattim>=? AND dattim<=?";
			    ctx.getDaoSession().dbExecuteSQL(advsptsql,ptyinr,MdaUtils.sqlDate(this.getVlmp().getBegdat(),GT),MdaUtils.sqlDate(this.getVlmp().getEnddat(),LT));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      Argument<Integer> advspt=new Argument<Integer>("sumspt");
			      ctx.getDaoSession().dbFetchFields(advspt);
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        log.info("{}","-*"+ptyinr+",--ADV SPT cnt is:"+advspt.value+"...no adv amt....");
			        if(!MdaUtils.isEmpty(advspt.getValue()))
			          advsptcnt=advspt.value;
			      }
			    }

			    ctx.getDaoSession().dbCloseCursor();
			    cntsum=cntsum + advsptcnt ;
			    //查TRN表的通知
			
			    Integer advtrncnt=new Integer(0);
			    String advtrnsql="SELECT COUNT(inr) sumtrn FROM trn WHERE optptyinr=? AND cfmdattim>=? AND cfmdattim<=? AND inidattim IS NULL";
			    ctx.getDaoSession().dbExecuteSQL(advtrnsql,ptyinr,MdaUtils.sqlDate(this.getVlmp().getBegdat(),GT),MdaUtils.sqlDate(this.getVlmp().getEnddat(),LT));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      Argument<Integer> advcnt=new Argument<Integer>("sumtrn");
			      ctx.getDaoSession().dbFetchFields(advcnt);
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        log.info("{}","-**"+ptyinr+",--ADV part of trn cnt is:"+advcnt.value);
			        if(!MdaUtils.isEmpty(advcnt.value))
			          advtrncnt= advcnt.value;
			      }
			    }
			    ctx.getDaoSession().dbCloseCursor();
			    cntsum=cntsum + advtrncnt ;
			  }
			  //插入记录
			  if(cntsum.compareTo(new Integer(0))==1   ||   (amtsum.compareTo(new BigDecimal(0))==1))
			  {
			    String nam=this.getSysmod().getBchmod().getBrhNam(bchcod);
			    if(amtsum.compareTo(new BigDecimal(0))==1)
			      amtsum=amtsum.divide(new BigDecimal(10000),2,4);
			    this.getVlmgrp().getVlmlst().add(new Argument<String>("orgnam",nam),
			      new Argument<BigDecimal>("trnno",new BigDecimal(cntsum)),
			      new Argument<BigDecimal>("amt",amtsum));
			  }
			}
			log.info("{}","---===Exit the branch sum,total trn count is :"+cntsum+",-- and sum amt is:"+amtsum);
		}
        /**
        *   source:quevlm.@0013.script
        */
        public void sumBrhBchTrn(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//统计分行de交易数和金额
			log.info("{}","--==enter brh branch sum,--input cid is :"+bchcod);
			sumBchTrn(bchcod);
			//统计该分行的下属支行的交易数和金额
			List<CodetableItem> subbch=this.getSysmod().getBchmod().getSubBchcod(bchcod);
			int size=subbch.size();
			for(int idx=0;idx<size;idx++)
			{
			  String ptycid=subbch.get(idx).getValue();
			  sumBchTrn(ptycid);
			}
			log.info("{}","--==Exit brh branch sum,!!! ");
		}
        /**
        *   source:quevlm.@0014.script
        */
        public void sumAllBchTrn()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询兴业银行全行的交易数和金额
			log.info("{}","===Enter the sum all cib bank===== ");
			List<CodetableItem> allbch=this.getSysmod().getBchmod().getBchcodByDZTLevel("2");
			int size=allbch.size();
			for(int idx=0;idx<size;idx++)
			{
			  String cid=allbch.get(idx).getValue();
			  sumBrhBchTrn(cid);
			}
			log.info("{}","=== quit sum all cib bank,===");
		}
        /**
        *   source:quevlm.@0019.script
        */
        public List<String> getDirectClient(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据机构的CID来获取所属的一级企业客户（含商行）
			List<String> dcpty=new ArrayList<String>();
			String inr=getPtyInrByCID(cid);
			log.info("{}",".....current bch ptyinr is :"+inr+".....");
			if(!("".equals(inr)))
			{
			  String sql="SELECT DISTINCT(preptyinr) ptyinr FROM ptr WHERE nxtptyinr=? AND (ptrtyp='0' OR ptrtyp='1')";
			  ctx.getDaoSession().dbExecuteSQL(sql,inr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    Argument<String> ptyinr = new Argument<String> ("ptyinr");
			    while(true)
			    {
			      ctx.getDaoSession().dbFetchFields(ptyinr);
			      if(ctx.getErrorCode()==NO_ERROR)
			        dcpty.add(ptyinr.value);
			      else
			        break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			log.info("{}","....1st client,including comlbank,total found is:"+dcpty.size());
			return dcpty;
		}
        /**
        *   source:quevlm.@0020.script
        */
        public String getPtyInrByCID(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String inr="";
			String sql="SELECT inr ptyinr FROM pty WHERE cid='"+cid+ "'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> ptyinr=new Argument<String>("ptyinr");
			  ctx.getDaoSession().dbFetchFields(ptyinr);
			  if(NO_ERROR==ctx.getErrorCode())
			    inr=ptyinr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return inr;
		}
        /**
        *   source:quevlm.@0021.script
        */
        public List<String> getCommericalBank(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据机构的CID来获取所属的一级企业客户（不含商行）
			List<String> cbpty=new ArrayList<String>();
			String inr=getPtyInrByCID(cid);
			if(!("".equals(inr)))
			{
			  String sql="SELECT preptyinr ptyinr FROM ptr WHERE nxtptyinr=? AND ptrtyp='1' ";
			  ctx.getDaoSession().dbExecuteSQL(sql,inr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    Argument<String> ptyinr = new Argument<String> ("ptyinr");
			    while(true)
			    {
			      ctx.getDaoSession().dbFetchFields(ptyinr);
			      if(ctx.getErrorCode()==NO_ERROR)
			        cbpty.add(ptyinr.value);
			      else
			        break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			return cbpty;
		}
        /**
        *   source:quevlm.@0023.script
        */
        public List<CodetableItem> getXList(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bch=new ArrayList<CodetableItem>();
			log.debug("{}","[getBranchList()]bchcod="+bchcod);
			String trnlvl = this.getSysmod().getTransLevel(bchcod);
			String sql="";
			log.debug("{}","[getBranchList()]trnlvl="+trnlvl);
			/*
			  if("1".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='2' OR lvl='1') ORDER BY p.inr";
			  }
			  else if("2".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='2' OR lvl='3') ";
			  sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"' ORDER BY p.inr";
			  }
			  else if("3".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND cid='"+bchcod+"' ";
			  }
			  */
			if("0".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='1' or lvl='0') ORDER BY p.inr";
			}
			else if("1".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND lvl='2' ";
			  sql = sql+"AND pntinr = '"+bchcod+"' or cid = '" + bchcod + "' ORDER BY p.inr";
			  //sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"' ORDER BY p.inr";
			}
			else if("2".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND cid='"+bchcod+"' ";
			}

			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> inr = new Argument<String>("inr");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam);
			  if(ctx.getErrorCode()== NO_ERROR)
			  {
			    bch.add(new CodetableItem(nam.value,inr.value));
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return bch;
		}
        /**
        *   source:quevlm.@0024.script
        */
        public void sumAllTrn(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询兴业银行全行的交易数和金额
			log.info("{}","===Enter the sum all cib bank===== ");
			List<CodetableItem> bchall=this.getSysmod().getBranchList(cid);
			int size=bchall.size();
			//总行机构
			String ptyrs=bchall.get(0).getValue();
			sumTrn(ptyrs);
			for(int idx=1;idx<size;idx++)
			{
			  String cidAll=this.getSysmod().getCidByInr(bchall.get(idx).getValue());
			  sumBrhTrn(cidAll);
			}
			log.info("{}","=== quit sum all cib bank,===");
		}
        /**
        *   source:quevlm.@0025.script
        */
        public void sumBrhTrn(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","--==enter brh branch sum,--input cid is :"+ bchcod);
			//统计该分行及下属支行的交易数和金额
			List<CodetableItem> bchbrh=this.getSysmod().getBranchList(bchcod);
			int size=bchbrh.size();
			for(int idx=0;idx<size;idx++)
			{
			  String ptyinrs=bchbrh.get(idx).getValue();
			  sumTrn(ptyinrs);
			}
			log.info("{}","--==Exit brh branch sum,!!! ");
		}
        /**
        *   source:quevlm.@0026.script
        */
        public void sumTrn(String ptyinrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询某一机构的交易数及金额
			log.info("{}","--===current branch inr is :---"+ptyinrs+"--====--");
			//List<String> dcpty=getDirectClient(bchcod);
			Integer cntsum=new Integer(0);
			BigDecimal amtsum= new BigDecimal(0.00) ;
			//int size=dcpty.size();
			Integer apltrncnt=new Integer(0);
			BigDecimal apltrnamt=new BigDecimal(0.00);
			//查TRN表的申请
			String aplsql="SELECT COUNT(inr) sumtrn, TO_CHAR(SUM(reloriamt)) sumamt FROM trn WHERE optptyinr=? AND inidattim>=? AND inidattim<=? ";
			aplsql=aplsql+" and modtyp=1 and sta = 'A' and ptytyp='2' ";
			ctx.getDaoSession().dbExecuteSQL(aplsql,ptyinrs,MdaUtils.sqlDate(this.getVlmp().getBegdat(),GT),MdaUtils.sqlDate(this.getVlmp().getEnddat(),LT));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Argument<Integer> aplcnt=new Argument<Integer> ("sumtrn");
			  Argument<String> aplamt=new Argument<String>("sumamt");
			  ctx.getDaoSession().dbFetchFields(aplcnt,aplamt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.info("{}","-*-"+ptyinrs+"'--APL Trn cnt is:"+aplcnt.value+",--and APL trnsumamt is:"+aplamt.value);
			    if(!MdaUtils.isEmpty(aplcnt.value))
			      apltrncnt= aplcnt.getValue();
			    if(!MdaUtils.isEmpty(aplamt.value))
			    {
			      log.debug("{}","aplamt.value = " + aplamt.value);
			      apltrnamt= new BigDecimal(aplamt.value);
			    }
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			cntsum=cntsum + apltrncnt ;
			amtsum=amtsum.add(apltrnamt);

			//查SPT表的通知
			Integer advsptcnt=new Integer(0);
			BigDecimal advamtsum= new BigDecimal(0.00) ;
			String advsptsql="SELECT COUNT(inr) sumspt,TO_CHAR(SUM(trnamt)) sumsmt FROM spt WHERE scr='A' AND sta='T' AND ptyinr=? AND dattim>=? AND dattim<=?";
			ctx.getDaoSession().dbExecuteSQL(advsptsql,ptyinrs,MdaUtils.sqlDate(this.getVlmp().getBegdat(),GT),MdaUtils.sqlDate(this.getVlmp().getEnddat(),LT));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Argument<Integer> advspt=new Argument<Integer>("sumspt");
			  Argument<String> advamt=new Argument<String>("sumsmt");
			  ctx.getDaoSession().dbFetchFields(advspt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.info("{}","-*"+ptyinrs+",--ADV SPT cnt is:"+advspt.value+"... adv amt is :"+advamt.value);
			    if(!MdaUtils.isEmpty(advspt.getValue()))
			      advsptcnt=advspt.value;
			    if(!MdaUtils.isEmpty(advamt.value))
			    {
			      log.debug("{}","advamt.value = " + advamt.value);
			      advamtsum= new BigDecimal(advamt.value);
			    }
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			cntsum=cntsum + advsptcnt ;
			amtsum=amtsum.add(advamtsum);

			//插入记录
			if(cntsum.compareTo(new Integer(0))==1   ||   (amtsum.compareTo(new BigDecimal(0))==1))
			{
			  String cids=this.getSysmod().getCidByInr(ptyinrs);
			  String nam=this.getSysmod().getBchmod().getBrhNam(cids);
			  if(amtsum.compareTo(new BigDecimal(0))==1)
			    amtsum=amtsum.divide(new BigDecimal(10000),2,4);
			  this.getVlmgrp().getVlmlst().add(new Argument<String>("orgnam",nam),
			    new Argument<BigDecimal>("trnno",new BigDecimal(cntsum)),
			    new Argument<BigDecimal>("amt",amtsum));
			}
			log.info("{}","---===Exit the branch sum,total trn count is :"+cntsum+",-- and sum amt is:"+amtsum);
		}





}