package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.RptopnVO;

import com.ceb.gjjs.mda.manager.module.Ersmod;
import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Rptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rpdgrp;
import com.ceb.gjjs.mda.manager.module.Rptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 跨境人民币汇出汇款申请
*/
@Transaction(vo= RptopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rptopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Rptopn.class);

		@BDGetter
		private Rpdgrp rpdgrp;

		@BDGetter
		private Rptmod rptmod;

		@BDGetter
		private Rptp rptp;

		@BDGetter
		private Ersmod ersmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;


		public Rptopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRptmod().setRpdgrpHolder(()->this.getRpdgrp());
           this.getRptp().setRpdgrpHolder(()->this.getRpdgrp());
           this.getErsmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.bchcod");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getBchcod();}}
			 );
           this.getErsmod().setCredatHolder( new FieldHolder<Date>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.credat");}
 				public void setValue(Date arg){Rptopn.this.getRpdgrp().getRec().setCredat(arg);}
 				public Date getValue(){return Rptopn.this.getRpdgrp().getRec().getCredat();}}
			 );
           this.getErsmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.ownref");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getOwnref();}}
			 );
           this.getErsmod().setObjtypHolder(new FieldConstantHolder<>("rpd"));
           this.getErsmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.inr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getInr();}}
			 );
           this.getErsmod().setMsgtypHolder(new FieldConstantHolder<>("0401"));
           this.getErsmod().setRecstaHolder(new FieldConstantHolder<>("W"));
           this.getErsmod().setInftxtHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.beizhu");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setBeizhu(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getBeizhu();}}
			 );
           this.getErsmod().setTrninrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("trnmod.trn.inr");}
 				public void setValue(String arg){Rptopn.this.getTrnmod().getTrn().setInr(arg);}
 				public String getValue(){return Rptopn.this.getTrnmod().getTrn().getInr();}}
			 );
           this.getErsmod().setDirHolder(new FieldConstantHolder<>(">"));
           this.getErsmod().setMsgattHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.msgatr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setMsgatr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getMsgatr();}}
			 );
           this.getErsmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getPtyinr();}}
			 );
           this.getErsmod().setPrefixHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("mtabut.prefix");}
 				public void setValue(String arg){Rptopn.this.getMtabut().setPrefix(arg);}
 				public String getValue(){return Rptopn.this.getMtabut().getPrefix();}}
			 );
           this.getErsmod().setAgtactHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.agtact");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setAgtact(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getAgtact();}}
			 );
           this.getErsmod().setAgtextkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.agtextkey");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setAgtextkey(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getAgtextkey();}}
			 );
           this.getErsmod().setEtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.etyinr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setEtyinr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getEtyinr();}}
			 );
           this.getErsmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getRptcur();}}
			 );
           this.getErsmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.rptamt");}
 				public void setValue(BigDecimal arg){Rptopn.this.getRpdgrp().getRec().setRptamt(arg);}
 				public BigDecimal getValue(){return Rptopn.this.getRpdgrp().getRec().getRptamt();}}
			 );
           this.getMtabut().setRecHolder(()->this.getRpdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("WP"));
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getRptcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.rptamt");}
 				public void setValue(BigDecimal arg){Rptopn.this.getRpdgrp().getRec().setRptamt(arg);}
 				public BigDecimal getValue(){return Rptopn.this.getRpdgrp().getRec().getRptamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.ownref");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.bchcod");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.inr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptopn.this.getFieldPath("rpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Rptopn.this.getRpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Rptopn.this.getRpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:rptopn.@0000.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getRpdgrp()))
			  return false;
			//存打印申请书相关数据
			//获取汇款金额
			BigDecimal amt0 = this.getRpdgrp().getRec().getRptamt();
			BigDecimal amt1 = new BigDecimal("0.00");
			BigDecimal amt = amt0.add(amt1);
			this.getRptp().setAmt(amt);
			log.info("{}","amt =" + this.getRptp().getAmt());
			//获取申请日期，默认为当天日期并转化成String类型
			String credat = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getRptp().setDat(credat);
			log.info("{}","dat =" +this.getRptp().getDat());
			//获取起息日期，默认为当天日期并转化成String类型
			String valdat = MdaUtils.format(this.getRpdgrp().getRec().getValdat(),"yyyyMMdd");
			this.getRptp().setValdat(valdat);
			log.info("{}","valdat =" +this.getRptp().getValdat());
			//获取被代理行名称
			if (!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getPty().getNam()))
			{
			  this.getRptp().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			}
			//获取所属机构Value取对应的Label值
			List<CodetableItem> bchcod = this.getSysmod().getAndSetBchcodvals();
			String bch= this.getRpdgrp().getRec().getBchcod();
			log.info("{}","bchcod 前=" + this.getRpdgrp().getRec().getBchcod());
			String key ="" ;
			String nam ="" ;
			for(CodetableItem ct : bchcod)
			{
			  key = ct.getValue() ;
			  log.info("{}","key =" + key);
			  if( !MdaUtils.isEmpty(bch)&& bch.equals(key))
			  {
			    nam = ct.getLabel() ;
			    break;
			  }
			}
			this.getRptp().setBchcod( nam );
			log.info("{}","bchcod 后 =" + this.getRptp().getBchcod());
			//判断业务类型是否为空，如果为空则默认为汇出
			if(MdaUtils.isEmpty(this.getRpdgrp().getRec().getRpttyp()))
			{
			  this.getRpdgrp().getRec().setRpttyp("O");
			}
			log.info("{}","rpttyp  =" + this.getRpdgrp().getRec().getRpttyp());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  ctx.getDaoSession().dbUpdate(this.getRpdgrp().getRec());
			}
			else
			{
			  this.getRpdgrp().getRec().setInr(Platform.sdbCounter("rpd"));
			  this.getRpdgrp().getRec().setRpttyp("O");
			  ctx.getDaoSession().dbInsert(this.getRpdgrp().getRec());
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			if(!this.getErsmod().ersSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:rptopn.@0001.script
        */
        @Rule(target="mtabut.ped",order=200)
        public boolean ruleMtabutPedN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  String typ=ctx.getTransName().substring(0,2);
			  String ptyname=this.getTrnmod().getPtyName(ctx.absGet(Sysmod.class).getPty().getInr());
			  this.getSysmod().getSpt().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec")));
			  this.getSysmod().getSpt().setObjinr("");
			  this.getSysmod().getSpt().setObjnam(this.getRpdgrp().getRec().getRptcur()+this.getRpdgrp().getRec().getRptamt()+"/"+ptyname);
			  this.getSysmod().getSpt().setNam(this.getRpdgrp().getRec().getRptcur()+this.getRpdgrp().getRec().getRptamt()+"/"+ptyname);
			}

			return true;
        }

        /**
        *   source:rptopn.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			//获取汇款金额
			BigDecimal amt0 = this.getRpdgrp().getRec().getRptamt();
			BigDecimal amt1 = new BigDecimal("0.00");
			BigDecimal amt = amt0.add(amt1);
			this.getRptp().setAmt(amt);
			log.info("{}","amt =" + this.getRptp().getAmt());
			//获取申请日期，默认为当天日期并转化成String类型
			String credat = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getRptp().setDat(credat);
			log.info("{}","dat =" +this.getRptp().getDat());
			//获取起息日期，默认为当天日期并转化成String类型
			String valdat = MdaUtils.format(this.getRpdgrp().getRec().getValdat(),"yyyyMMdd");
			this.getRptp().setValdat(valdat);
			log.info("{}","valdat =" +this.getRptp().getValdat());
			//获取被代理行名称
			if (!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getPty().getNam()))
			{
			  this.getRptp().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			}
			//获取Value取对应的Label值
			//$rptp\\bchcod = valueToLabel( $rpdgrp\\rec\\bchcod.getValue() );
			List<CodetableItem> bchcod = this.getSysmod().getAndSetBchcodvals();
			String bch= this.getRpdgrp().getRec().getBchcod();
			log.info("{}","bchcod 前=" + this.getRpdgrp().getRec().getBchcod());
			String key ="" ;
			String nam ="" ;
			for(CodetableItem ct : bchcod)
			{
			  key = ct.getValue() ;
			  log.info("{}","key =" + key);
			  if( !MdaUtils.isEmpty(bch)&& bch.equals(key))
			  {
			    nam = ct.getLabel() ;
			    break;
			  }
			}
			this.getRptp().setBchcod( nam );
			log.info("{}","bchcod 后 =" + this.getRptp().getBchcod());

			//判断业务类型是否为空，如果为空则默认为汇出
			if(MdaUtils.isEmpty(this.getRpdgrp().getRec().getRpttyp()))
			{
			  this.getRpdgrp().getRec().setRpttyp("O");
			}
			log.info("{}","rpttyp  =" + this.getRpdgrp().getRec().getRpttyp());
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","rptopn",stream,false );

			return true;
        }

        /**
        *   source:rptopn.@0003.script
        */
        @Rule(target="mtabut.chk",order=100)
        public boolean ruleMtabutChkN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(ctx.checkAll(this.getRpdgrp()))
			  ctx.setMessage(MdaUtils.getI18NString("rptopn","CT000000"),MdaUtils.getI18NString("rptopn","CT000001"));

			return true;
        }

        /**
        *   source:rptopn.@0029.script
        */
        @Rule(target="mtabut.mail",order=200)
        public boolean ruleMtabutMailN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getMtabut().setAttnames(NULLSTR);
			String inr = Platform.sdbCounter("mailAtt");
			this.getMtabut().creatApplyPdfFile("rptopnApp"+inr,"rptopn");
			//$mtabut.creatTcoPdfFile("rptopnDra"+inr);
			//$mtabut\\attnames.setValue("rptopnApp"+inr+".pdf;rptopnDra"+inr+".pdf");
			
			return true;
        }

        /**
        *   source:rptopn.@0046.script
        */
        @Rule(target="mtabut.busmod.select",order=200)
        public boolean ruleMtabutBusmodSelectN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getRpdgrp().getRec().setOwnref(NULLSTR);
			

			return true;
        }

        /**
        *   source:rptopn.@0073.script
        */
        @Rule(target="mtabut.sav",order=1300)
        public boolean ruleMtabutSavN1300(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getRpdgrp().getRec());
			

			return true;
        }


        /**
        *   source:rptopn.@0036.script
        */
        @Check(target="rpdgrp.rec.orcact",order=100)
        public boolean checkRpdgrpRecOrcactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcact())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcextkey())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcadr())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcnam()))
			{
			  // Platform.error($rpdgrp\\rec\\orcact,#CT000011);
			}

			return true;
        }

        /**
        *   source:rptopn.@0037.script
        */
        @Check(target="rpdgrp.rec.oriact",order=100)
        public boolean checkRpdgrpRecOriactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getOriact())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getOriextkey())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrinam()))
			{
			  //  Platform.error($rpdgrp\\rec\\oriact,#CT000012);
			}

			return true;
        }

        /**
        *   source:rptopn.@0039.script
        */
        @Check(target="rpdgrp.rec.pyeact",order=100)
        public boolean checkRpdgrpRecPyeactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeact())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeextkey())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeadr())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyenam()))
			{
			  //  Platform.error($rpdgrp\\rec\\pyeact,#CT000014);
			}

			return true;
        }

        /**
        *   source:rptopn.@0040.script
        */
        @Check(target="rpdgrp.rec.awiact",order=100)
        public boolean checkRpdgrpRecAwiactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwiact())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwiextkey())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwinam()))
			{
			  // Platform.error($rpdgrp\\rec\\awiact,#CT000015);
			}

			return true;
        }

        /**
        *   source:rptopn.@0041.script
        */
        @Check(target="rpdgrp.rec.actin2",order=100)
        public boolean checkRpdgrpRecActin2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin2())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin2())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin2()))
			{
			  // Platform.error($rpdgrp\\rec\\actin2,#CT000016);
			}

			return true;
        }

        /**
        *   source:rptopn.@0042.script
        */
        @Check(target="rpdgrp.rec.actin3",order=100)
        public boolean checkRpdgrpRecActin3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin3())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin3())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin3()))
			{
			  // Platform.error($rpdgrp\\rec\\actin3,#CT000017);
			}

			return true;
        }

        /**
        *   source:rptopn.@0045.script
        */
        @Check(target="rpdgrp.rec.awiextkey",order=100)
        public boolean checkRpdgrpRecAwiextkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwiextkey()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwinam()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getAwiact()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.awiextkey",MdaUtils.getI18NString("rptopn","CT000018"));
			  }
			}

			if(BICchk(this.getRpdgrp().getRec().getAwiextkey())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.awiextkey",MdaUtils.getI18NString("rptopn","CT000034"));

			return true;
        }

        /**
        *   source:rptopn.@0048.script
        */
        @Check(target="rpdgrp.rec.actin1",order=100)
        public boolean checkRpdgrpRecActin1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin1()))
			{
			  String extkey = this.getRpdgrp().getRec().getExtkeyin1();
			  String act = this.getRpdgrp().getRec().getActin1();
			  if(extkey.matches("\\d{4,}"))
			  {
			    this.getRpdgrp().getRec().setActin1("//CN" + extkey) ;
			    
			    
			  }
			  else if (!extkey.matches("\\d{4,}") && !MdaUtils.isEmpty(act) && act.startsWith("//"))
			  {
			    this.getRpdgrp().getRec().setActin1(NULLSTR);
			    
			    
			  }
			  else
			  {
			    
			  }
			}
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin1())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin1())&&MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin1()))
			{
			  // Platform.error($rpdgrp\\rec\\actin1,#CT000019);
			}

			return true;
        }

        /**
        *   source:rptopn.@0049.script
        */
        @Check(target="rpdgrp.rec.agtact",order=100)
        public boolean checkRpdgrpRecAgtactN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getRptcur()) && !MdaUtils.isEmpty(this.getRpdgrp().getRec().getBchcod()))
			{
			  String act  = this.getRptmod().getDLHZH(ctx.absGet(Sysmod.class).getPty().getInr(),this.getRpdgrp().getRec().getBchcod(), this.getRpdgrp().getRec().getRptcur() );
			  this.getRpdgrp().getRec().setAgtact(act);
			  
			}
			else
			{
			  this.getRpdgrp().getRec().setAgtact(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:rptopn.@0052.script
        */
        @Check(target="rpdgrp.rec.orcnam",order=100)
        public boolean checkRpdgrpRecOrcnamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"orcnam"),438);

			return true;
        }

        /**
        *   source:rptopn.@0053.script
        */
        @Check(target="rpdgrp.rec.orcadr",order=100)
        public boolean checkRpdgrpRecOrcadrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"orcadr"),1470);

			return true;
        }

        /**
        *   source:rptopn.@0054.script
        */
        @Check(target="rpdgrp.rec.orinam",order=100)
        public boolean checkRpdgrpRecOrinamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"orinam"),438);

			return true;
        }

        /**
        *   source:rptopn.@0055.script
        */
        @Check(target="rpdgrp.rec.namin1",order=100)
        public boolean checkRpdgrpRecNamin1N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"namin1"),438);

			return true;
        }

        /**
        *   source:rptopn.@0056.script
        */
        @Check(target="rpdgrp.rec.namin2",order=100)
        public boolean checkRpdgrpRecNamin2N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"namin2"),438);

			return true;
        }

        /**
        *   source:rptopn.@0057.script
        */
        @Check(target="rpdgrp.rec.namin3",order=100)
        public boolean checkRpdgrpRecNamin3N100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"namin3"),438);

			return true;
        }

        /**
        *   source:rptopn.@0058.script
        */
        @Check(target="rpdgrp.rec.awinam",order=100)
        public boolean checkRpdgrpRecAwinamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"awinam"),438);

			return true;
        }

        /**
        *   source:rptopn.@0059.script
        */
        @Check(target="rpdgrp.rec.pyenam",order=100)
        public boolean checkRpdgrpRecPyenamN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"pyenam"),438);

			return true;
        }

        /**
        *   source:rptopn.@0060.script
        */
        @Check(target="rpdgrp.rec.pyeadr",order=100)
        public boolean checkRpdgrpRecPyeadrN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"pyeadr"),1470);

			return true;
        }

        /**
        *   source:rptopn.@0061.script
        */
        @Check(target="rpdgrp.rec.remcmt",order=100)
        public boolean checkRpdgrpRecRemcmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"remcmt"),438);

			return true;
        }

        /**
        *   source:rptopn.@0062.script
        */
        @Check(target="rpdgrp.rec.sedcmt",order=100)
        public boolean checkRpdgrpRecSedcmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"sedcmt"),1680);

			return true;
        }

        /**
        *   source:rptopn.@0063.script
        */
        @Check(target="rpdgrp.rec.covsedcmt",order=100)
        public boolean checkRpdgrpRecCovsedcmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"covsedcmt"),1680);

			return true;
        }

        /**
        *   source:rptopn.@0064.script
        */
        @Check(target="rpdgrp.rec.addmsg",order=100)
        public boolean checkRpdgrpRecAddmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"addmsg"),255);

			return true;
        }

        /**
        *   source:rptopn.@0065.script
        */
        @Check(target="rpdgrp.rec.beizhu",order=100)
        public boolean checkRpdgrpRecBeizhuN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkMaxTextField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"beizhu"),737);

			return true;
        }

        /**
        *   source:rptopn.@0066.script
        */
        @Check(target="rpdgrp.rec.rptamt",order=100)
        public boolean checkRpdgrpRecRptamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkNumericField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"rptamt"),2);
			//去除小数点后无效的零
			BigDecimal amt = this.getRpdgrp().getRec().getRptamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getRpdgrp().getRec().setRptamt(amt);

			return true;
        }

        /**
        *   source:rptopn.@0067.script
        */
        @Check(target="rpdgrp.rec.priamt",order=100)
        public boolean checkRpdgrpRecPriamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkNumericField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"priamt"),2);
			BigDecimal amt = this.getRpdgrp().getRec().getPriamt();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getRpdgrp().getRec().setPriamt(amt);
			if(this.getRpdgrp().getRec().getRptcur().equals(this.getRpdgrp().getRec().getPricur()) && this.getRpdgrp().getRec().getRptamt().doubleValue() > this.getRpdgrp().getRec().getPriamt().doubleValue())
			  ctx.setFieldError(this,"rpdgrp.rec.rptamt",MdaUtils.getI18NString("rptopn","CT000052"));

			return true;
        }

        /**
        *   source:rptopn.@0068.script
        */
        @Check(target="rpdgrp.rec.chgrat",order=100)
        public boolean checkRpdgrpRecChgratN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRpdgrp().getRec().getChgrat()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getRptcur()) && !MdaUtils.isEmpty(this.getRpdgrp().getRec().getPricur()) )
			  {
			    if (!this.getRpdgrp().getRec().getRptcur().equals(this.getRpdgrp().getRec().getPricur()))
			    {
			      ctx.setFieldError(this,"rpdgrp.rec.chgrat",MdaUtils.getI18NString("rptopn","CT000024"));
			    }
			  }
			}
			this.getSysmod().checkNumericField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"chgrat"),6);
			BigDecimal amt = this.getRpdgrp().getRec().getChgrat();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getRpdgrp().getRec().setChgrat(amt);

			return true;
        }

        /**
        *   source:rptopn.@0069.script
        */
        @Check(target="rpdgrp.rec.sedfee",order=100)
        public boolean checkRpdgrpRecSedfeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkNumericField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"sedfee"),2);
			BigDecimal amt = this.getRpdgrp().getRec().getSedfee();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getRpdgrp().getRec().setSedfee(amt);

			return true;
        }

        /**
        *   source:rptopn.@0070.script
        */
        @Check(target="rpdgrp.rec.rcvfee",order=100)
        public boolean checkRpdgrpRecRcvfeeN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkNumericField(MdaDriver.getDatafield(this.getRpdgrp().getRec(),"rcvfee"),2);
			BigDecimal amt = this.getRpdgrp().getRec().getRcvfee();
			amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			this.getRpdgrp().getRec().setRcvfee(amt);

			return true;
        }

        /**
        *   source:rptopn.@0072.script
        */
        @Check(target="rpdgrp.rec.feerol",order=100)
        public boolean checkRpdgrpRecFeerolN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getRpdgrp().getRec().getOrctyp()))
			{
			  this.getRpdgrp().getRec().setFeerol("1");
			  

			  
			  
			  this.getRpdgrp().getRec().setSedfeecur(NULLSTR);
			  this.getRpdgrp().getRec().setSedfee(new BigDecimal(0));
			  
			  

			  this.getRpdgrp().getRec().setRcvfeecur(NULLSTR);
			  this.getRpdgrp().getRec().setRcvfee(new BigDecimal(0));
			  
			  
			  
			  
			}
			if("1".equals(this.getRpdgrp().getRec().getFeerol()) && "1".equals(this.getRpdgrp().getRec().getOrctyp()))
			{
			  
			  
			  
			  
			  this.getRpdgrp().getRec().setSedfeecur(NULLSTR);
			  this.getRpdgrp().getRec().setSedfee(new BigDecimal(0));
			  
			  
			}
			else if(!"1".equals(this.getRpdgrp().getRec().getFeerol()) && "1".equals(this.getRpdgrp().getRec().getOrctyp()))
			{
			  
			  
			  this.getRpdgrp().getRec().setRcvfeecur(NULLSTR);
			  this.getRpdgrp().getRec().setRcvfee(new BigDecimal(0));
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:rptopn.@0075.script
        */
        @Check(target="rpdgrp.rec.extkeyin1",order=100)
        public boolean checkRpdgrpRecExtkeyin1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getExtkeyin1())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.extkeyin1",MdaUtils.getI18NString("rptopn","CT000027"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin1()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin1()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin1()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.extkeyin1",MdaUtils.getI18NString("rptopn","CT000045"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0076.script
        */
        @Check(target="rpdgrp.rec.extkeyin3",order=100)
        public boolean checkRpdgrpRecExtkeyin3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getExtkeyin3())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.extkeyin3",MdaUtils.getI18NString("rptopn","CT000028"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin3()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin3()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin3()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.extkeyin3",MdaUtils.getI18NString("rptopn","CT000047"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0077.script
        */
        @Check(target="rpdgrp.rec.extkeyin2",order=100)
        public boolean checkRpdgrpRecExtkeyin2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getExtkeyin2())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.extkeyin2",MdaUtils.getI18NString("rptopn","CT000029"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getExtkeyin2()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getNamin2()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getActin2()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.extkeyin2",MdaUtils.getI18NString("rptopn","CT000046"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0078.script
        */
        @Check(target="rpdgrp.rec.oriextkey",order=100)
        public boolean checkRpdgrpRecOriextkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getOriextkey())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.oriextkey",MdaUtils.getI18NString("rptopn","CT000030"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getOriextkey()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrinam()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getOriact()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.oriextkey",MdaUtils.getI18NString("rptopn","CT000044"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0080.script
        */
        @Check(target="rpdgrp.rec.pyeextkey",order=100)
        public boolean checkRpdgrpRecPyeextkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getPyeextkey())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.pyeextkey",MdaUtils.getI18NString("rptopn","CT000032"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeextkey()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyenam()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeadr()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getPyeact()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.pyeextkey",MdaUtils.getI18NString("rptopn","CT000043"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0081.script
        */
        @Check(target="rpdgrp.rec.orcextkey",order=100)
        public boolean checkRpdgrpRecOrcextkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(BICchk(this.getRpdgrp().getRec().getOrcextkey())==false)
			  ctx.setFieldError(this,"rpdgrp.rec.orcextkey",MdaUtils.getI18NString("rptopn","CT000033"));
			if( MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcextkey()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcnam()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcadr()))
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getOrcact()))
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.orcextkey",MdaUtils.getI18NString("rptopn","CT000048"));
			  }
			}


			return true;
        }

        /**
        *   source:rptopn.@0082.script
        */
        @Check(target="rpdgrp.rec.valdat",order=100)
        public boolean checkRpdgrpRecValdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getValdat()))
			{
			  Date enddat = MdaUtils.add(MdaUtils.today(),+30);
			  Date begdat = MdaUtils.add(MdaUtils.today(),-1);
			  if(MdaUtils.diff(this.getRpdgrp().getRec().getValdat(),enddat) > 0 || MdaUtils.diff(this.getRpdgrp().getRec().getValdat(),begdat) < 0 )
			  {
			    ctx.setFieldError(this,"rpdgrp.rec.valdat","起息日期只能为当日到当日之后的三十日之内");
			  }
			}

			return true;
        }

        /**
        *   source:rptopn.@0083.script
        */
        @Check(target="rpdgrp.rec.sedfeecur",order=100)
        public boolean checkRpdgrpRecSedfeecurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getSedfee()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getSedfeecur()))
			  ctx.setFieldError(this,"rpdgrp.rec.sedfeecur",MdaUtils.getI18NString("rptopn","CT000049"));

			return true;
        }

        /**
        *   source:rptopn.@0084.script
        */
        @Check(target="rpdgrp.rec.rcvfeecur",order=100)
        public boolean checkRpdgrpRecRcvfeecurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getRcvfee()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getRcvfeecur()))
			  ctx.setFieldError(this,"rpdgrp.rec.rcvfeecur",MdaUtils.getI18NString("rptopn","CT000050"));

			return true;
        }

        /**
        *   source:rptopn.@0085.script
        */
        @Check(target="rpdgrp.rec.bchcod",order=100)
        public boolean checkRpdgrpRecBchcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getRptcur()) && !MdaUtils.isEmpty(this.getRpdgrp().getRec().getBchcod()))
			{
			  String act  = this.getRptmod().getDLHZH(ctx.absGet(Sysmod.class).getPty().getInr(),this.getRpdgrp().getRec().getBchcod(), this.getRpdgrp().getRec().getRptcur() );
			  this.getRpdgrp().getRec().setAgtact(act);
			  
			}
			else
			{
			  this.getRpdgrp().getRec().setAgtact(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:rptopn.@0086.script
        */
        @Check(target="rpdgrp.rec.orctyp",order=100)
        public boolean checkRpdgrpRecOrctypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getRpdgrp().getRec().getFeerol()))
			{
			  
			  
			  this.getRpdgrp().getRec().setSedfeecur(NULLSTR);
			  this.getRpdgrp().getRec().setSedfee(new BigDecimal(0));
			  
			  
			}
			else
			{
			  
			  
			}

			return true;
        }

        /**
        *   source:rptopn.@0088.script
        */
        @Check(target="rpdgrp.rec.xgckha",order=100)
        public boolean checkRpdgrpRecXgckhaN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getRpdgrp().getRec().getOrctyp()) && MdaUtils.isEmpty(this.getRpdgrp().getRec().getXgckha()))
			  ctx.setFieldError(this,"rpdgrp.rec.xgckha",MdaUtils.getI18NString("rptopn","CT000055"));

			return true;
        }


        /**
        *   source:rptopn.@0014.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getRpdgrp().getRec(),"bchcod",bchcod);
			
			
			
			//从rptshw复制...
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.rptopn.ref");
			if(!MdaUtils.isEmpty(mdl))
			{
			  this.getRpdgrp().getRec().copyValue(mdl);
			  this.getRpdgrp().getRec().setOwnref(NULLSTR);
			  this.getRpdgrp().getRec().setCredat(MdaUtils.today());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getOwnref()) && this.getRpdgrp().getRec().getOwnref().startsWith("LP"))
			  {
			    
			    
			    
			    
			    
			    
			    return true;
			  }
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			    return true;
			  this.getRpdgrp().getRec().setAgtextkey(ctx.absGet(Sysmod.class).getPty().getBic());
			  this.getRpdgrp().getRec().setCredat(MdaUtils.today());
			  this.getRpdgrp().getRec().setValdat(MdaUtils.today());
			  this.getRpdgrp().getRec().setRptcur("CNY");
			  this.getRpdgrp().getRec().setPricur("CNY");
			  this.getRpdgrp().getRec().setMsgatr("2");
			  this.getRpdgrp().getRec().setProity("0");
			}

			return true;
        }


        /**
        *   source:rptopn.@0074.script
        */
        public boolean BICchk(String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(bic))
			{
			  if(bic.matches("\\d{12}"))
			    return true;
			  if(bic.length()==8 && !bic.matches("\\d{8}") )
			    return true;
			  if(bic.length()==11 && !bic.matches("\\d{11}"))
			    return true;
			  return false;
			}
			return true;
		}









}