package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.RptqurVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Rptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rpdgrp;
import com.ceb.gjjs.mda.manager.module.Rptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 跨境人民币业务查询登记薄
*/
@Transaction(vo= RptqurVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rptqur extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Rptqur.class);

		@BDGetter
		private Rpdgrp rpdgrp;

		@BDGetter
		private Rptmod rptmod;

		@BDGetter
		private Rptp rptp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;


		public Rptqur()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRptmod().setRpdgrpHolder(()->this.getRpdgrp());
           this.getRptp().setRpdgrpHolder(()->this.getRpdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getRpdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptqur.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptqur.this.getRpdgrp().getRec().getRptcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.rptamt");}
 				public void setValue(BigDecimal arg){Rptqur.this.getRpdgrp().getRec().setRptamt(arg);}
 				public BigDecimal getValue(){return Rptqur.this.getRpdgrp().getRec().getRptamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.ownref");}
 				public void setValue(String arg){Rptqur.this.getRpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Rptqur.this.getRpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.bchcod");}
 				public void setValue(String arg){Rptqur.this.getRpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Rptqur.this.getRpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.inr");}
 				public void setValue(String arg){Rptqur.this.getRpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Rptqur.this.getRpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptqur.this.getFieldPath("rpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Rptqur.this.getRpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Rptqur.this.getRpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:rptqur.@0001.script
        */
        @Rule(target="rptp.query",order=100)
        public boolean ruleRptpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this.getRptp()))
			  return true;
			query();

			return true;
        }

        /**
        *   source:rptqur.@0002.script
        */
        @Rule(target="rptp.take",order=100)
        public boolean ruleRptpTakeN100(){
            IContext ctx = MdaEnv.getContext();
            
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;

			log.info("{}","current line selected is ="+index );
			int length = this.getRptp().getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000001"),MdaUtils.getI18NString("rptqur","CT000002"));
			  return true;
			}

			String rpdinr =  this.getRptp().getTmplst().getElement(index).getInr() ;
			//取到选中记录的inr号，并传给跳转到的交易页面
			ctx.getDaoSession().dbRead(this.getRpdgrp().getRec(),new Argument<String>("inr",rpdinr));
			int errcod =  ctx.getErrorCode();
			log.debug("{}"," in  errcod = "  + errcod ) ;
			ctx.storeData("com.brilliance.rptshw.ref",this.getRpdgrp().getRec());
			

			return true;
        }

        /**
        *   source:rptqur.@0006.script
        */
        @Rule(target="rptp.dow",order=100)
        public boolean ruleRptpDowN100(){
            IContext ctx = MdaEnv.getContext();
            
			List<Object[]> lst = new ArrayList<Object[]>();
			String tit[] = new String[13];
			tit[0] = "交易参考号";
			tit[1] = "业务类型";
			tit[2] = "交易日期";
			tit[3] = "币种";
			tit[4] = "金额";
			tit[5] = "业务状态";
			tit[6] = "报文状态";
			tit[7] = "付款人";
			tit[8] = "付款人账号";
			tit[9] = "收款人";
			tit[10] = "收款人账号";
			tit[11] = "所属落地机构代码";
			tit[12] = "行内关联编号";
			lst.add(tit);
			int len = this.getRptp().getTmplst().fullSize();
			log.debug("{}","len="+len);
			for(int i=0;i<len;i++)
			{
			  log.debug("{}",""+i);
			  String[] line = new String[13];
			  line[0] = this.getRptp().getTmplst().getElement(i).getOwnref();
			  String rpttyp =this.getRptp().getTmplst().getElement(i).getRpttyp();
			  line[1] = MdaUtils.getCodetableLabel("rpttyp",rpttyp);
			  if(MdaUtils.isEmpty(this.getRptp().getTmplst().getElement(i).getTrndat()))
			    line[2] ="";
			  else
			    line[2] = MdaUtils.format(this.getRptp().getTmplst().getElement(i).getTrndat(),"yyyyMMdd HH:mm");
			  String cur= this.getRptp().getTmplst().getElement(i).getRptcur();
			  line[3]=MdaUtils.getCodetableLabel("cur",cur);
			  line[4] =this.getRptp().getTmplst().getElement(i).getRptamt().toString();
			  String rptsta = this.getRptp().getTmplst().getElement(i).getRptsta();
			  line[5] =MdaUtils.getCodetableLabel("trnsta",rptsta);
			  String erssta = this.getRptp().getTmplst().getElement(i).getErssta();
			  line[6] = MdaUtils.getCodetableLabel("recsta",erssta);
			  line[7] = this.getRptp().getTmplst().getElement(i).getOrcnam();
			  line[8] = this.getRptp().getTmplst().getElement(i).getOrcact();
			  line[9] = this.getRptp().getTmplst().getElement(i).getPyenam();
			  line[10] = this.getRptp().getTmplst().getElement(i).getPyeact();
			  line[11] = this.getRptp().getTmplst().getElement(i).getPtyinr();
			  line[12] = this.getRptp().getTmplst().getElement(i).getHnglbh();
			  lst.add(line);
			}
			log.debug("{}","lst "+lst.size());
			IStream is=this.getRptp().getDow();
			is.setType("xls");
			String today = MdaUtils.format(MdaUtils.today(),"yyyyMMdd-HH:mm:ss");
			String fileName = "登记簿"+today+".xls";
			is.setName(fileName);
			MdaUtils.unloadExcel(lst,is,false);

			return true;
        }

        /**
        *   source:rptqur.@0007.script
        */
        @Rule(target="rptp.chssel",order=100)
        public boolean ruleRptpChsselN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getRptp().getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000003"),MdaUtils.getI18NString("rptqur","CT000004"));
			  return true;
			}
			if("0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  if("1".equals(this.getSysmod().getPty().getLvl()))
			  {
			    ctx.getDaoSession().dbRead(this.getRpdgrp().getRec(),new Argument<String>("inr",this.getRptp().getTmplst().getElement(index).getInr()));
			    if(!Platform.headBchcod().equals(this.getRptp().getTmplst().getElement(index).getPtyinr()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000037"),MdaUtils.getI18NString("rptqur","CT000038"));
			      return true;
			    }
			    
			    
			    
			    ctx.getDaoSession().dbRead(this.getRptp().getErs(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			    if(this.getRpdgrp().getRec().getOwnref().startsWith("WP") )
			    {
			      
			    }
			    else
			    {
			      
			    }
			    
			  }
			  else
			    ctx.setFieldError(this,"rptp.chssel","无权限，请联系总行操作员！");
			}
			else
			  ctx.setFieldError(this,"rptp.chssel","无权限，请联系总行操作员！");

			return true;
        }

        /**
        *   source:rptqur.@0008.script
        */
        @Rule(target="rptp.return",order=100)
        public boolean ruleRptpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rptqur.@0009.script
        */
        @Rule(target="rptp.surbut",order=100)
        public boolean ruleRptpSurbutN100(){
            IContext ctx = MdaEnv.getContext();
            
			Argument<String> nam=new Argument<String>("nam");
			Argument<String> ptyinr=new Argument<String>("inr");
			Argument<String> etyinr=new Argument<String>("etyinr");
			Argument<String> act=new Argument<String>("act");
			Argument<String> cid=new Argument<String>("cid");
			Argument<String> bic=new Argument<String>("bic");
			String argnam=" ";
			String sql="select pty.nam,pty.inr,pty.etyinr,acc.act,opnpty.cid,pty.bic from acc,pty,pty opnpty where acc.ownptyinr=pty.inr and acc.opnptyinr= opnpty.inr and acc.cur= ? and acc.act=? ";
			ctx.getDaoSession().dbExecuteSQL(sql,this.getRpdgrp().getRec().getRptcur(),this.getRpdgrp().getRec().getAgtact());
			int index=1;
			log.info("{}","sql==================="+sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam,ptyinr,etyinr,act,cid,bic);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getRpdgrp().getRec().setAgtact(act.value);
			    this.getRpdgrp().getRec().setAgtextkey(bic.value);
			    this.getRpdgrp().getRec().setBchcod(cid.value);
			    this.getRpdgrp().getRec().setPtyinr(ptyinr.value);
			    this.getRpdgrp().getRec().setEtyinr(etyinr.value);
			    ctx.getDaoSession().dbRead(this.getRptp().getTrn(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			    this.getRptp().getTrn().setPtyinr(ptyinr.value);
			    this.getRptp().getTrn().setEtyinr(etyinr.value);
			    this.getRptp().getErs().setPtyinr(ptyinr.value);
			    this.getRptp().getErs().setEtyinr(etyinr.value);
			    this.getRptp().getErs().setBchcod(cid.value);
			    this.getRptp().getErs().setAgtact(act.value);
			    this.getRptp().getErs().setAgtextkey(bic.value);
			    //手工清分成功，更新mad对账文件表的相关数据
			    ctx.getDaoSession().dbRead(this.getRptp().getMad(),new Argument<String>("hnglbh",this.getRptp().getErs().getHnglbh()));
			    this.getRptp().getMad().setHadsta("1");
			    this.getRptp().getMad().setSigchk("C");
			    this.getRptp().getMad().setObjinr(this.getRptp().getErs().getObjinr());
			    this.getRptp().getMad().setTrninr(this.getRptp().getErs().getTrninr());
			    this.getRptp().getMad().setMsgref(this.getRptp().getErs().getMsgref());
			    this.getRptp().getMad().setOwnref(this.getRptp().getErs().getOwnref());
			    argnam=nam.value;
			    index++;
			    log.info("{}","index=========="+index);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			if(index==1)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000024"),MdaUtils.getI18NString("rptqur","CT000027"));
			  return true;
			}
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbUpdate(this.getRpdgrp().getRec());
			ctx.getDaoSession().dbUpdate(this.getRptp().getTrn());
			ctx.getDaoSession().dbUpdate(this.getRptp().getErs());
			ctx.getDaoSession().dbUpdate(this.getRptp().getMad());
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000028"),MdaUtils.getI18NString("rptqur","CT000033")+argnam);
			query();
			

			return true;
        }

        /**
        *   source:rptqur.@0010.script
        */
        @Rule(target="rptp.dowtxt",order=100)
        public boolean ruleRptpDowtxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			String tit[] = new String[13];
			tit[0] = "交易参考号：";
			tit[1] = "业务类型：";
			tit[2] = "交易日期：";
			tit[3] = "币种：";
			tit[4] = "金额：";
			tit[5] = "业务状态：";
			tit[6] = "报文状态：";
			tit[7] = "付款人：";
			tit[8] = "付款人账号：";
			tit[9] = "收款人：";
			tit[10] = "收款人账号：";
			tit[11] = "所属落地机构代码：";
			tit[12] = "行内关联编号：";
			int len = this.getRptp().getTmplst().fullSize();
			String line="";
			for(int i=0;i<len;i++)
			{
			  int m=i+1;
			  line = line+"第"+m+"条记录为：";
			  line = line+tit[0]+this.getRptp().getTmplst().getElement(i).getOwnref()+"    ";
			  String rpttyp =this.getRptp().getTmplst().getElement(i).getRpttyp();
			  line =line+tit[1]+ MdaUtils.getCodetableLabel("rpttyp",rpttyp)+"    ";
			  if(MdaUtils.isEmpty(this.getRptp().getTmplst().getElement(i).getTrndat()))
			    line =line+tit[2]+"    ";
			  else
			    line =line+tit[2]+ MdaUtils.format(this.getRptp().getTmplst().getElement(i).getTrndat(),"yyyyMMdd HH:mm")+"    ";
			  String cur= this.getRptp().getTmplst().getElement(i).getRptcur();
			  line=line+tit[3]+MdaUtils.getCodetableLabel("cur",cur)+"    ";
			  line =line+tit[4]+this.getRptp().getTmplst().getElement(i).getRptamt().toString()+"    ";
			  String rptsta = this.getRptp().getTmplst().getElement(i).getRptsta();
			  line =line+tit[5]+MdaUtils.getCodetableLabel("trnsta",rptsta)+"    ";
			  String erssta = this.getRptp().getTmplst().getElement(i).getErssta();
			  line = line+tit[6]+MdaUtils.getCodetableLabel("recsta",erssta)+"    ";
			  line = line+tit[7]+this.getRptp().getTmplst().getElement(i).getOrcnam()+"    ";
			  line = line+tit[8]+this.getRptp().getTmplst().getElement(i).getOrcact()+"    ";
			  line = line+tit[9]+this.getRptp().getTmplst().getElement(i).getPyenam()+"    ";
			  line = line+tit[10]+this.getRptp().getTmplst().getElement(i).getPyeact()+"    ";
			  line = line+tit[11]+this.getRptp().getTmplst().getElement(i).getPtyinr()+"    ";
			  line = line+tit[12]+this.getRptp().getTmplst().getElement(i).getHnglbh()+"；                  ";
			}
			String today = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");
			String fileName = "登记簿"+today+".txt";
			fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),fileName);
			MdaUtils.saveContent(line,fileName,"GBK");
			ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000025"),MdaUtils.getI18NString("rptqur","CT000026")+fileName);

			return true;
        }

        /**
        *   source:rptqur.@0011.script
        */
        @Rule(target="rptp.delete",order=100)
        public boolean ruleRptpDeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			this.getTrnmod().getTrn().setSta("X");
			ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			ctx.getDaoSession().dbRead(this.getRptp().getErs(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			this.getRptp().getErs().setRecsta("X");
			ctx.getDaoSession().dbUpdate(this.getRptp().getErs());
			ctx.getDaoSession().dbCommit();
			query();
			

			return true;
        }


        /**
        *   source:rptqur.@0013.script
        */
        @Check(target="rptp.begdat",order=100)
        public boolean checkRptpBegdatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRptp().getBegdat()))
			  ctx.setFieldError(this,"rptp.begdat",MdaUtils.getI18NString("rptqur","CT000019"));

			return true;
        }

        /**
        *   source:rptqur.@0014.script
        */
        @Check(target="rptp.enddat",order=100)
        public boolean checkRptpEnddatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRptp().getEnddat()))
			  ctx.setFieldError(this,"rptp.enddat",MdaUtils.getI18NString("rptqur","CT000022"));
			if (!MdaUtils.isEmpty(this.getRptp().getBegdat())&&!MdaUtils.isEmpty(this.getRptp().getEnddat()))
			{
			  Date cntDate = MdaUtils.add(this.getRptp().getEnddat(),-90);
			  if(MdaUtils.diff(this.getRptp().getEnddat(),this.getRptp().getBegdat())<0)
			  {
			    ctx.setFieldError(this,"rptp.enddat",MdaUtils.getI18NString("rptqur","CT000023"));
			  }
			  else if(MdaUtils.diff(cntDate,this.getRptp().getBegdat())>0)
			  {
			    ctx.setFieldError(this,"rptp.enddat","起止日期跨度不能超过三个月");
			  }
			}

			return true;
        }

        /**
        *   source:rptqur.@0017.script
        */
        @Check(target="rptp.endamt",order=100)
        public boolean checkRptpEndamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getRptp().getBegamt().doubleValue() > this.getRptp().getEndamt().doubleValue())
			  ctx.setFieldError(this,"rptp.endamt",MdaUtils.getI18NString("rptqur","CT000034"));

			return true;
        }


        /**
        *   source:rptqur.@0015.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getRptp().setBegdat(MdaUtils.today());
			this.getRptp().setEnddat(MdaUtils.today());
			
			
			//非兴业机构，手工清分灰显
			if(!"0".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			}

			return true;
        }


        /**
        *   source:rptqur.@0012.script
        */
        public void query()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","*******************************");
			MdaUtils.clear(this.getRptp().getTmplst());
			String ptyinr1=this.getSysmod().getPty().getInr();
			String lvl=this.getSysmod().getPty().getLvl();
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String cid=this.getSysmod().getPty().getCid();
			Argument<String> rpttyp =new Argument<String>("rpttyp");
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ptyinr =new Argument<String>("ptyinr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> rptsta =new Argument<String>("rptsta");
			Argument<String> erssta =new Argument<String>("erssta");
			Argument<BigDecimal> rptamt =new Argument<BigDecimal>("rptamt");
			Argument<Date> trndat =new Argument<Date>("trndat");
			Argument<String> rptcur =new Argument<String>("rptcur");
			Argument<String> pyenam =new Argument<String>("pyenam");
			Argument<String> pyeact =new Argument<String>("pyeact");
			Argument<String> orcnam =new Argument<String>("orcnam");
			Argument<String> orcact =new Argument<String>("orcact");
			Argument<String> hnglbh =new Argument<String>("hnglbh");
			String sql="SELECT rpd.inr,rpd.bchcod ptyinr,rpd.ownref,rpd.rpttyp,rpd.credat trndat,rpd.rptcur,rpd.rptamt,trn.sta rptsta,ers.recsta erssta,rpd.orcnam,rpd.orcact,rpd.pyenam,rpd.pyeact,ers.hnglbh FROM rpd,ers,trn WHERE rpd.inr=ers.objinr AND ers.objtyp='rpd' AND rpd.inr=trn.objinr AND trn.objtyp='rpd' AND rpd.credat >= ? AND rpd.credat <= ? ";
			String con=" ";
			if("0".equals(ptytyp))
			{
			  if("1".equals(lvl))
			  {
			    log.info("{}","-------------兴业总行登陆查询-------------");
			  }
			  else if("2".equals(lvl))
			  {
			    log.info("{}","---------------分行登陆查询---------------");
			    sql=sql+con+ "AND rpd.ptyinr in (SELECT inr from pty where ptytyp='0' AND pty.lvl in('2','3') AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			  }
			  else
			  {
			    log.info("{}","---------------支行登陆查询---------------");
			    sql=sql+con+ "AND rpd.ptyinr in (SELECT inr from pty where ptytyp='0' AND pty.lvl ='3' AND substr(cid,1,2)='"+cid.substring(0,2)+"')";
			  }
			}
			else
			{
			  sql=sql+con+ "AND rpd.ptyinr='"+ptyinr1+"'";
			}

			//业务参考号条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getOwnref()))
			{
			  sql=sql+con+" AND rpd.ownref LIKE '%" + this.getRptp().getOwnref() + "%'";
			}
			//行内关联编号条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getHnglbh()))
			{
			  sql=sql+con+" AND ers.hnglbh LIKE '%" + this.getRptp().getHnglbh() + "%'";
			}
			//币种条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getCur()))
			{
			  sql=sql+con+ " AND rpd.rptcur LIKE '%" + this.getRptp().getCur() + "%'";
			}
			//业务类型条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getOwntyp()))
			{
			  sql=sql+con + " AND rpd.rpttyp ='" + this.getRptp().getOwntyp() + "'";
			}
			//收款人条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getPyenam()))
			{
			  sql=sql+con+ " AND rpd.pyenam LIKE '%" + this.getRptp().getPyenam() + "%'";
			}
			//业务状态条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getSta()))
			{
			  sql=sql+con+ " AND trn.sta LIKE '%" + this.getRptp().getSta() + "%'";
			}
			//报文状态条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getErssta()))
			{
			  sql=sql+con + " AND ers.recsta LIKE '%" + this.getRptp().getErssta() + "%'";
			}
			//金额（起）条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getBegamt()))
			{
			  sql=sql+con + " AND rpd.rptamt >=" + this.getRptp().getBegamt();
			}
			//金额（止）条件判断
			if(!MdaUtils.isEmpty(this.getRptp().getEndamt()))
			{
			  sql=sql+con+ " AND rpd.rptamt <=" + this.getRptp().getEndamt();
			}

			sql=sql+con+"ORDER BY rpd.credat DESC";
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbExecuteSQL(sql,MdaUtils.sqlDate(this.getRptp().getBegdat(),GT),MdaUtils.sqlDate(this.getRptp().getEnddat(),LT));
			int errCod =  ctx.getErrorCode() ;
			log.info("{}","查询语句 ="+sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,rpttyp,trndat,rptcur,rptamt,rptsta,erssta,orcnam,orcact,pyenam,pyeact,ptyinr,hnglbh);
			  int errCod1 = ctx.getErrorCode();
			  if(errCod1==NO_ERROR)
			  {
			    if("X".equals(rptsta.value) && !"X".equals(erssta.value))
			    {
			      erssta.value="X";
			      ctx.getDaoSession().dbRead(this.getRptp().getErs(),new Argument<String>("objtyp","rpd"),new Argument<String>("objinr",inr));
			      this.getRptp().getErs().setRecsta("X");
			      ctx.getDaoSession().dbUpdate(this.getRptp().getErs());
			    }
			    this.getRptp().getTmplst().add(inr,ownref,rpttyp,trndat,rptcur,rptamt,rptsta,erssta,orcnam,orcact,pyenam,pyeact,ptyinr,hnglbh);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.getDaoSession().dbCommit();
			
			if(this.getRptp().getTmplst().fullSize() <= 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rptqur","CT000031"),MdaUtils.getI18NString("rptqur","CT000032"));
			  return;
			}
			log.info("{}","*******************************");
		}








}