package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.RptshwVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Rptmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rpdgrp;
import com.ceb.gjjs.mda.manager.module.Rptp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 跨境人民币业务详情展示
*/
@Transaction(vo= RptshwVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rptshw extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Rptshw.class);

		@BDGetter
		private Rpdgrp rpdgrp;

		@BDGetter
		private Rptmod rptmod;

		@BDGetter
		private Rptp rptp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Trnmod trnmod;


		public Rptshw()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getRptmod().setRpdgrpHolder(()->this.getRpdgrp());
           this.getRptp().setRpdgrpHolder(()->this.getRpdgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getMtabut().setRecHolder(()->this.getRpdgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptshw.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptshw.this.getRpdgrp().getRec().getRptcur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.rptamt");}
 				public void setValue(BigDecimal arg){Rptshw.this.getRpdgrp().getRec().setRptamt(arg);}
 				public BigDecimal getValue(){return Rptshw.this.getRpdgrp().getRec().getRptamt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.ownref");}
 				public void setValue(String arg){Rptshw.this.getRpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Rptshw.this.getRpdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.bchcod");}
 				public void setValue(String arg){Rptshw.this.getRpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Rptshw.this.getRpdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.inr");}
 				public void setValue(String arg){Rptshw.this.getRpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Rptshw.this.getRpdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptshw.this.getFieldPath("rpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Rptshw.this.getRpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Rptshw.this.getRpdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:rptshw.@0001.script
        */
        @Rule(target="rptp.return",order=100)
        public boolean ruleRptpReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rptshw.@0003.script
        */
        @Rule(target="rptp.inform",order=100)
        public boolean ruleRptpInformN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getRptp().getInform();
			ctx.absGet(Sysmod.class).generatorPdf("","rptshw",stream,false );

			return true;
        }

        /**
        *   source:rptshw.@0004.script
        */
        @Rule(target="rptp.coprpd",order=100)
        public boolean ruleRptpCoprpdN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.storeData("com.brilliance.rptopn.ref",this.getRpdgrp().getRec());
			

			return true;
        }



        /**
        *   source:rptshw.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getRpdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(this.getRpdgrp().getRec().getInr()))
			{
			  log.info("{}","非mdl读取！！！！！！！！");
			  ctx.getDaoSession().dbRead(this.getRptp().getErs(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			}
			IModule mdl = (IModule)ctx.restoreData("com.brilliance.rptshw.ref");
			if(!MdaUtils.isEmpty(mdl))
			{
			  this.getRpdgrp().getRec().copyValue(mdl);
			  //获取所属机构value对应的label值、被代理行名称
			  //实现金额精度、汇款日期转换，供打印界面展示使用
			  String bch= this.getRpdgrp().getRec().getBchcod();
			  String key ="" ;
			  String nam ="" ;
			  for(CodetableItem ct : bchcod)
			  {
			    key =  ct.getValue() ;
			    if( !MdaUtils.isEmpty(bch)&& bch.equals(key))
			    {
			      nam = ct.getLabel() ;
			      break;
			    }
			  }
			  this.getRptp().setBchcod( nam );
			  if (!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getPty().getNam()))
			  {
			    this.getRptp().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			  }
			  BigDecimal amt0 = this.getRpdgrp().getRec().getRptamt();
			  BigDecimal amt1 = new BigDecimal("0.00");
			  BigDecimal amt = amt0.add(amt1);
			  this.getRptp().setAmt(amt);
			  String credat = MdaUtils.format(this.getRpdgrp().getRec().getCredat(),"yyyyMMdd");
			  this.getRptp().setDat(credat);
			  String valdat = MdaUtils.format(this.getRpdgrp().getRec().getValdat(),"yyyyMMdd");
			  this.getRptp().setValdat(valdat);
			  MdaUtils.clear(this.getRptp().getErs());
			  ctx.getDaoSession().dbRead(this.getRptp().getErs(),new Argument<String>("objinr",this.getRpdgrp().getRec().getInr()),new Argument<String>("objtyp","rpd"));
			  if("A".equals(this.getRptp().getErs().getRecsta()))
			  {
			    
			    
			  }

			  if("N".equals(this.getRptp().getErs().getRecsta()) || "F".equals(this.getRptp().getErs().getRecsta()))
			  {
			    
			  }
			  if(!"1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  {
			    
			    
			  }
			}

			return true;
        }










}