package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SgtcanVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sgtmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Sgtp;
import com.ceb.gjjs.mda.manager.module.Sgdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 提货担保注销通知
*/
@Transaction(vo= SgtcanVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sgtcan extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Sgtcan.class);

		@BDGetter
		private Sgdgrp sgdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Sgtmod sgtmod;

		@BDGetter
		private Sgtp sgtp;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Sgtcan()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSgtmod().setLidgrpHolder(()->this.getLidgrp());
           this.getSgtmod().setSgdgrpHolder(()->this.getSgdgrp());
           this.getSgtp().setLidgrpHolder(()->this.getLidgrp());
           this.getSgtp().setSgdgrpHolder(()->this.getSgdgrp());
           this.getMtabut().setRecHolder(()->this.getSgdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.sgdamt");}
 				public void setValue(BigDecimal arg){Sgtcan.this.getSgdgrp().getRec().setSgdamt(arg);}
 				public BigDecimal getValue(){return Sgtcan.this.getSgdgrp().getRec().getSgdamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.bchcod");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.sgdcur");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setSgdcur(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getSgdcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.inr");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setInr(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.ownref");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.ptyinr");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtcan.this.getFieldPath("sgdgrp.rec.stlref");}
 				public void setValue(String arg){Sgtcan.this.getSgdgrp().getRec().setStlref(arg);}
 				public String getValue(){return Sgtcan.this.getSgdgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:sgtcan.@0000.script
        */
        @Rule(target="mtabut.edit",order=0)
        public boolean ruleMtabutEditN0(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getSysmod().getPty().getPtytyp()))
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:sgtcan.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			this.getTrnmod().noticeAck(this.getSgtp().getSgtp03());

			return true;
        }

        /**
        *   source:sgtcan.@0002.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Mtabut.class).getImgtp().getImgRef();

			return true;
        }











}