package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SgtopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sgtmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Sgtp;
import com.ceb.gjjs.mda.manager.module.Sgdgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 提货担保申请
*/
@Transaction(vo= SgtopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sgtopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Sgtopn.class);

		@BDGetter
		private Sgdgrp sgdgrp;

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Sgtmod sgtmod;

		@BDGetter
		private Sgtp sgtp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Sgtopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getSgtmod().setSgdgrpHolder(()->this.getSgdgrp());
           this.getSgtmod().setLidgrpHolder(()->this.getLidgrp());
           this.getSgtp().setSgdgrpHolder(()->this.getSgdgrp());
           this.getSgtp().setLidgrpHolder(()->this.getLidgrp());
           this.getMtabut().setRecHolder(()->this.getSgdgrp().getRec());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("SG"));
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.sgdamt");}
 				public void setValue(BigDecimal arg){Sgtopn.this.getSgdgrp().getRec().setSgdamt(arg);}
 				public BigDecimal getValue(){return Sgtopn.this.getSgdgrp().getRec().getSgdamt();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.bchcod");}
 				public void setValue(String arg){Sgtopn.this.getSgdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Sgtopn.this.getSgdgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.sgdcur");}
 				public void setValue(String arg){Sgtopn.this.getSgdgrp().getRec().setSgdcur(arg);}
 				public String getValue(){return Sgtopn.this.getSgdgrp().getRec().getSgdcur();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.inr");}
 				public void setValue(String arg){Sgtopn.this.getSgdgrp().getRec().setInr(arg);}
 				public String getValue(){return Sgtopn.this.getSgdgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.ownref");}
 				public void setValue(String arg){Sgtopn.this.getSgdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Sgtopn.this.getSgdgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("sgdgrp.rec.ptyinr");}
 				public void setValue(String arg){Sgtopn.this.getSgdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Sgtopn.this.getSgdgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Sgtopn.this.getFieldPath("lidgrp.rec.stlref");}
 				public void setValue(String arg){Sgtopn.this.getLidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Sgtopn.this.getLidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:sgtopn.@0001.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.checkAll($\\);
			//Platform.dbBegin();
			if(!(ctx.checkAll(this.getLidgrp()) && ctx.checkAll(this.getSgdgrp())))
			  return false;
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  ctx.getDaoSession().dbUpdate(this.getSgdgrp().getRec());
			else
			{
			  this.getSgdgrp().getRec().setInr(Platform.sdbCounter("sgd"));
			  this.getSgdgrp().getRec().setPnttyp("lid");
			  this.getSgdgrp().getRec().setPntinr(this.getLidgrp().getRec().getInr());
			  this.getSgdgrp().getRec().setPntref(this.getLidgrp().getRec().getStlref());
			  ctx.getDaoSession().dbInsert(this.getSgdgrp().getRec());
			  log.info("{}", "sav200入库结束================" );
			}
			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:sgtopn.@0002.script
        */
        @Rule(target="mtabut.apldoc",order=100)
        public boolean ruleMtabutApldocN100(){
            IContext ctx = MdaEnv.getContext();
            
			IStream stream=this.getMtabut().getApldoc();
			ctx.absGet(Sysmod.class).generatorPdf("","sgtopn",stream,false );

			return true;
        }



        /**
        *   source:sgtopn.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			{
			  this.getTrnmod().ordNew();
			}
			this.getSgdgrp().getRec().setCredat(MdaUtils.today());
			
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getSgdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getSgdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			  return true;
			IModule lid = (IModule)ctx.restoreData("com.brilliance.sgtopn.ref");
			if(!MdaUtils.isEmpty(lid))
			{
			  this.getLidgrp().getRec().copyValue(lid);
			  this.getLidgrp().getDap().initDap("lid");
			  //$lidgrp\\apl.copyValues($lidgrp\\dap);
			  this.getSgdgrp().getApl().copyValues(this.getLidgrp().getDap());
			  this.getSgdgrp().getApl().getPts().setNam(this.getLidgrp().getDap().getPty().getNam());
			  
			}
			else
			{
			  
			}
			
			this.getSgdgrp().getRec().setSgddat(MdaUtils.today());
			
			
			
			
			this.getSgdgrp().getRec().setSgdcur(this.getLidgrp().getRec().getIsscur());
			this.getSgdgrp().getRec().setEngcur("USD");
			if(!MdaUtils.isEmpty(bchcod))
			{
			  this.getSgdgrp().getRec().setBchcod((bchcod.get(0)).getValue());
			}
			log.info("{}","bchcod="+this.getSgdgrp().getRec().getBchcod());

			return true;
        }

        /**
        *   source:sgtopn.@0003.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","bchcod="+this.getLidgrp().getRec().getBchcod());
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getSgdgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  //$lidgrp\\rec\\bchcod.setValue(bchcod.get(0).getValue());
			{
			  if("3".equals(this.getSysmod().getPty().getPtytyp()))
			  {
			    if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getIbchcod()))
			      this.getSgdgrp().getRec().setBchcod(this.getLidgrp().getRec().getIbchcod());
			    else
			    {
			      this.getSgdgrp().getRec().setBchcod(bchcod.get(0).getValue());
			      this.getSgdgrp().getRec().setIbchcod(this.getLidgrp().getRec().getBchcod());
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getLidgrp().getRec().getDbchcod()))
			      this.getSgdgrp().getRec().setBchcod(this.getLidgrp().getRec().getDbchcod());
			    else
			      this.getSgdgrp().getRec().setBchcod(this.getLidgrp().getRec().getBchcod());
			    
			  }
			  log.info("{}","bchocd="+this.getSgdgrp().getRec().getBchcod()+",dbchocd="+this.getSgdgrp().getRec().getDbchcod()+",ibchcod="+this.getSgdgrp().getRec().getIbchcod());
			}
			
			
			
			

			return true;
        }











}