package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Sgtopn0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.manager.module.Lidgrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 提货担保选择
*/
@Transaction(vo= Sgtopn0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sgtopn0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Sgtopn0.class);

		@BDGetter
		private Lidgrp lidgrp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Sysmod sysmod;


		public Sgtopn0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sgtopn0.@0001.script
        */
        @Rule(target="selp.sure",order=0)
        public boolean ruleSelpSureN0(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("lidgrp","sgtopn");

			return true;
        }

        /**
        *   source:sgtopn0.@0002.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT l.inr trsinr,l.stlref ref,l.isscur cur,l.issamt amt,l.credat date,s.nam bennam,a.adr benadr,a.tel bentel,a.fax benfax FROM lid l,pts s,adr a,pta p WHERE l.flg = '2' AND s.rol = 'ben' AND s.objtyp = 'lid' AND s.objinr = l.inr AND p.inr = s.ptainr AND a.inr = p.objinr";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat,substr(s.adrblk,0,35) bennam FROM lid rec,pts s WHERE rec.stlref is not NULL and substr(rec.stlref,6,2) = 'LC' AND s.rol = 'ben' AND s.objtyp = 'lid' AND s.objinr = rec.inr"+ctx.absGet(Sysmod.class).getSelection();
			this.getSelp().queryBtn(queryClause);

			return true;
        }

        /**
        *   source:sgtopn0.@0003.script
        */
        @Rule(target="selp.tmplst",order=200)
        public boolean ruleSelpTmplstN200(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("lidgrp","sgtopn");

			return true;
        }



        /**
        *   source:sgtopn0.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.setValues(this.getSelp(),"seltyp",MdaUtils.getCodetable("selsgtopn"));
			this.getSelp().setSeltyp("1");
			//将查询语句输入selp层的Argument类型控件queryClause字段
			//String queryClause = "SELECT l.inr trsinr,l.stlref ref,l.isscur cur,l.issamt amt,l.credat dat,"
			//  +"s.nam bennam,a.adr benadr,a.tel bentel,a.fax benfax FROM lid l,pts s,adr a,pta p "
			//  +"WHERE l.flg = '2' AND s.rol = 'ben' AND s.objtyp = 'lid' AND s.objinr = l.inr "
			//  +"AND p.inr = s.ptainr AND a.inr = p.objinr";
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.isscur cur,rec.issamt amt,rec.opndat dat,substr(s.adrblk,0,35) bennam FROM lid rec,pts s WHERE rec.stlref is not NULL and substr(rec.stlref,6,2) = 'LC' AND s.rol = 'ben' AND s.objtyp = 'lid' AND s.objinr = rec.inr"
			  +ctx.absGet(Sysmod.class).getSelection();
			//"WHERE stlref is not null ";
			// +"and rec.ptyinr='"+$sysmod\\pty\\inr+"'";
			this.getSelp().queryBtn(queryClause);

			return true;
        }







}