package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.ShrtskVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Cpdgrp;
import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Wrnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Bsplst;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Cpd;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 经办复核自动服务
*/
@Transaction(vo= ShrtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Shrtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Shrtsk.class);

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private ModuleList<Spt> tdolst;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Cpdgrp cpdgrp;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Wrnmod wrnmod;

		@BDGetter
		private Trn wrktrn;

		@BDGetter
		private ModuleList<Bsplst> bsplst;

		@BDGetter
		private Spt wrkspt;

		@BDGetter
		private Trn dtrn;

		@BDGetter
		private Swmmod swmmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private Cpd chkcpd;


		public Shrtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }




        /**
        *   source:shrtsk.@0000.script
        */
        public void cpdhyfReviewed()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//海运费自动经办
			String ordinr=this.getSysmod().getSpt().getOrdinr(); // 订单号
			String objinr=this.getSysmod().getSpt().getInr();  // 业务表主键
			String ptyinr=this.getSysmod().getSpt().getPtyinr();   // 企业客户PTY主键
			String owninr=this.getSysmod().getUsr().getInr();    //操作员主键
			String frm=this.getSysmod().getSpt().getFrm();     // 交易代码
			
			// 业务流程处理
			this.getWrnmod().getWrn().setInr(Platform.sdbCounter("wrn"));
			this.getWrnmod().getWrn().setOwninr(owninr);
			this.getWrnmod().getWrn().setPtyinr(ptyinr);
			this.getWrnmod().getWrn().setSptinr(objinr);
			this.getWrnmod().getWrn().setSta("F");
			this.getWrnmod().getWrn().setFdodat(MdaUtils.today());
			this.getWrnmod().getWrn().setWrnfrm(frm);
			ctx.getDaoSession().dbInsert(this.getWrnmod().getWrn());

			// 更新待办记录
			int nxtlev=MdaUtils.parseInt(this.getSysmod().getSpt().getNxtlev())+ 1;
			this.getSysmod().getSpt().setWrninr(this.getWrnmod().getWrn().getInr());
			this.getSysmod().getSpt().setNxtlev(String.valueOf(nxtlev));

			ctx.getDaoSession().dbUpdate(this.getSysmod().getSpt());
			// 记录ORE操作信息
			this.getTrnmod().getOrdmod().updateOrd(this.getSysmod().getSpt().getOrdinr(),"E","11","海运费自动经办");

			// 更新交易备注信息
			String time=MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String userName = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName();
			String txt = this.getRmkmod().getRmk().getTxt() + CR +  userName + " " + time  + "  海运费自动经办" ;  // 处理历史备注信息
			this.getRmkmod().getRmk().setTxt(txt);
			this.getRmkmod().getRmk().setDattim(new Date());
			ctx.getDaoSession().dbUpdate(this.getRmkmod().getRmk());
			//$rmkmod.updateRmk("13");
			
			//log.info("sysmod.spt333end：");
			//log.info($sysmod\\spt);
					}
        /**
        *   source:shrtsk.@0001.script
        */
        public void cpdhyfTransction()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//海运费自动复核
			String ordinr=this.getSysmod().getSpt().getOrdinr(); // 订单号
			String objtyp=this.getSysmod().getSpt().getObjtyp(); 	 //  业务表名称
			String objinr=this.getSysmod().getSpt().getObjinr();  // 业务表主键
			String ptyinr=this.getSysmod().getSpt().getPtyinr();   // 企业客户PTY主键
			String ownref=this.getSysmod().getSpt().getOwnref();   // 单证通业务编号
			String trnname=this.getSysmod().getSpt().getFrm();  // 企业端交易名称
			String trninr=this.getSysmod().getSpt().getFrm();   // 企业端申请流水TRN主键
			String bankinr= this.getSysmod().getSpt().getOprogninr();  // 归属银行主键
			String frm=this.getSysmod().getSpt().getFrm();     // 交易代码
			String relreq = this.getSysmod().getSpt().getRelreq();  //交易签字信息
			String nxtreq ="O";
			String relres = "";

			log.info("{}","cpdhyfTransction start：");
			log.info("{}",this.getSysmod().getSpt());

			//判断该笔业务是否导入影像，如有则需上传影像到影像平台
			ctx.getDaoSession().dbRead(this.getSysmod().getPty(),new Argument<Object>("inr",this.getSysmod().getPty().getInr()));
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg(),new Argument("objinr",objinr),new Argument("objtyp", "cpd"));
			if(this.getSysmod().getPty().getCid()!=null && ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getOwnref()!=null)
			{
			  String cibBranchID = this.getSysmod().getPty().getCid().substring(0,2);
			  String cibOrgID = this.getSysmod().getPty().getCid().substring(2);
			  log.info("{}",this.getSysmod().getPty());
			  log.info("{}",ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod());
			  Boolean result=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().uploadImages(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getOwnref(),ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getImgref(),ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getGuid(),cibBranchID,cibOrgID);
			  log.info("{}","result=" +result);
			}

			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getRelres()))
			{
			  relres = this.getSysmod().getSpt().getRelres();
			}

			ctx.getDaoSession().dbRead(this.getWrktrn(),new Argument<Object>("objinr",this.getSysmod().getSpt().getObjinr()));
			log.info("{}","cpdhyfTransction trnSave：");
			log.info("{}",this.getWrktrn());
			trnSave();
			this.getTrnmod().sigWrite("O","0");
			this.getTrnmod().getOrdmod().updateOrd(ordinr,"E","12","海运费自动复核");

			setWorkFlow("trn",this.getTrnmod().getTrn().getInr());

			//$rmkmod\\otext= $rmkmod\\rmk\\txt.getValue() + CR + "海运费自动复核" ;
			// 处理历史备注信息
			// 加载 交易备注信息
			this.getRmkmod().loadRemarkByOrd(ordinr);
			log.info("{}",this.getRmkmod().getRmk());
			String time=MdaUtils.format(MdaUtils.today(),"yyyyMMdd HH:mm");
			String userName = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getLoginUserName();
			String txt = this.getRmkmod().getRmk().getTxt() + CR +  userName + " " + time  + "  海运费自动复核" ;  // 处理历史备注信息
			this.getRmkmod().getRmk().setTxt(txt);
			this.getRmkmod().getRmk().setDattim(new Date());
			ctx.getDaoSession().dbUpdate(this.getRmkmod().getRmk());
			//$rmkmod.updateRmk("14");
			log.info("{}","cpdhyfTransction delete：");
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			  ctx.getDaoSession().dbDelete(this.getSysmod().getSpt());
			if(!MdaUtils.isEmpty(this.getWrnmod().getWrn().getInr()))
			  ctx.getDaoSession().dbDelete(this.getWrnmod().getWrn());

			MdaUtils.clear(this.getSysmod().getSpt());
			MdaUtils.clear(this.getTrnmod().getTrn());

			MdaUtils.clear(this.getWrktrn());
		}
        /**
        *   source:shrtsk.@0002.script
        */
        public void loadTdolst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//抓取海运费自动经办/复核数据
			MdaUtils.clear(this.getTdolst());
			log.info("{}","抓取海运费自动经办/复核数据...");
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> objnam =new Argument<String>("objnam");
			Argument<String> frm=new Argument<String>("frm");
			Argument<String> nxtlev=new Argument<String>("nxtlev");
			Argument<String> wrninr = new Argument<String>("wrninr");
			Argument<Date> dattim =new Argument<Date>("dattim");
			Argument<String> ordinr =new Argument<String>("ordinr");
			Argument<String> scrtxt =new Argument<String>("scrtxt");
			Argument<String> trncur =new Argument<String>("trncur");
			Argument<BigDecimal> trnamt =new Argument<BigDecimal>("trnamt");
			Argument<String> inoutflg =new Argument<String>("inoutflg");
			Argument<String> nam =new Argument<String>("nam");
			Argument<String> relreq =new Argument<String>("relreq");
			Argument<String> relres =new Argument<String>("relres");
			Argument<String> objtyp = new Argument<String>("objtyp");
			Argument<String> objinr = new Argument<String>("objinr");

			String sql="SELECT s.inr,s.ownref,s.objnam,s.frm,s.nxtlev,s.wrninr,s.dattim,s.ordinr,s.scrtxt,p.inoutflg,"
			  +"s.trncur,s.trnamt,pty.nam,s.relreq,s.relres,s.objtyp,s.objinr"
			  +" FROM spt s left join pty on s.ptyinr=pty.inr left join cpd p on s.objinr=p.inr AND s.objtyp='cpd'"
			  +" WHERE s.scr='S' AND s.sta='T' AND s.frm='cpthyf' and p.autflg='1'"
			  +" AND NOT EXISTS (SELECT inr FROM wrn WHERE s.wrninr=wrn.inr  AND wrn.sta='F') and rownum<2"
			  +" UNION ALL"
			  +" SELECT s.inr,s.ownref,s.objnam,s.frm,s.nxtlev,s.wrninr,s.dattim,s.ordinr,s.scrtxt,p.inoutflg,"+
			  "s.trncur,s.trnamt,pty.nam,s.relreq,s.relres,s.objtyp,s.objinr"
			  +" FROM spt s left join pty on s.ptyinr=pty.inr left join cpd p on s.objinr=p.inr AND s.objtyp='cpd'"
			  +" WHERE s.scr='S' AND s.sta='T' AND s.frm='cpthyf' and p.autflg='1'"+
			  " AND EXISTS (SELECT inr FROM wrn WHERE s.wrninr=wrn.inr  AND wrn.sta='F') and  rownum<2"
			  +" ORDER BY dattim DESC";
			ctx.getDaoSession().dbExecuteSQL(sql);

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownref,objnam,frm,dattim,ordinr,nxtlev,wrninr,scrtxt,trncur,trnamt,inoutflg,nam,relreq,relres,objtyp,objinr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getTdolst().add(inr,ownref,objnam,frm,dattim,ordinr,nxtlev,wrninr,scrtxt,trncur,trnamt,inoutflg,nam,relreq,relres,objtyp,objinr);
			  }
			  else
			    break;
			}
			log.info("{}","抓取海运费自动经办/复核数据："+this.getTdolst().size()+" 条。");
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:shrtsk.@0003.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","自动经办复核开始...");
			ctx.getDaoSession().dbBegin();
			loadTdolst();
			int idx = -1;
			for(int i=0;i<this.getTdolst().fullSize();i++)
			{
			  log.info("{}","当前集合遍历..."+ i );
			  MdaUtils.clear(this.getSysmod().getSpt());
			  MdaUtils.clear(this.getWrnmod().getWrn());
			  this.getSysmod().getSpt().copyValue(this.getTdolst().get(i));
			  ctx.getDaoSession().dbRead(this.getSysmod().getSpt(),new Argument<Object>("inr",this.getSysmod().getSpt().getInr()));

			  String wrninr=this.getSysmod().getSpt().getWrninr();
			  ctx.getDaoSession().dbRead(this.getWrnmod().getWrn(),new Argument<Object>("inr",this.getSysmod().getSpt().getWrninr()));

			  if(MdaUtils.isEmpty(this.getWrnmod().getWrn().getInr())||!"F".equals(this.getWrnmod().getWrn().getSta()))
			  {
			    log.info("{}","cpdhyfReviewed...");
			    this.getRmkmod().setNtext(NULLSTR);
			    this.getRmkmod().setOtext(NULLSTR);
			    MdaUtils.clear(this.getRmkmod().getRmk());
			    ctx.getDaoSession().dbRead(this.getRmkmod().getRmk(),new Argument<String>("ordinr",this.getSysmod().getSpt().getOrdinr()));

			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().getOrd(),new Argument("inr",this.getSysmod().getSpt().getOrdinr()));
			    //log.debug("spt.ordinr=   :"+ $sysmod\\spt\\ordinr.getValue() );
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().setInr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().getOrd().getOptptyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().setInr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().getOrd().getOptetyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtg().setInr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().getOrd().getOptetginr());

			    log.info("{}","cpdhyfReviewed...");
			    cpdhyfReviewed();
			    log.info("{}","cpdhyfReviewed---end...");
			    if(ctx.getErrorCode()!=228)
			    {
			      idx = i;
			      break;
			    }
			  }
			  else
			  {
			    log.info("{}","cpdhyfTransction...");
			    cpdhyfTransction();
			    log.info("{}","cpdhyfTransction---end...");
			    if(ctx.getErrorCode()!=NO_ERROR)
			    {
			      idx = i;
			      break;
			    }

			  }
			}
			if(idx>-1)
			{
			  log.info("{}","idx----0...");
			  ctx.getDaoSession().dbRollback();
			  ctx.getDaoSession().dbBegin();
			  //出错 加入人工待办队列    cpd.autoflg=''
			  ctx.getDaoSession().dbRead(this.getChkcpd(),new Argument<String>("inr",this.getSysmod().getSpt().getObjinr()));
			  this.getChkcpd().setAutflg( "");
			  ctx.getDaoSession().dbUpdate(this.getChkcpd());
			  ctx.getDaoSession().dbCommit();
			}
			else
			{
			  ctx.getDaoSession().dbCommit();
			}
		}
        /**
        *   source:shrtsk.@0004.script
        */
        public void trnSave()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 银行端的业务流水
			  */
			log.info("{}","cpdhyfTransction start：");
			log.info("{}","wrktrn baksta："+this.getWrktrn().getBaksta());
			if("B".equals(this.getWrktrn().getBaksta()))   //国结退回业务走更新逻辑
			{
			  ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("oriinr",this.getWrktrn().getInr()));
			}
			this.getTrnmod().getTrn().setOwnref(this.getWrktrn().getOwnref());
			this.getTrnmod().getTrn().setInifrm(this.getWrktrn().getInifrm());
			this.getTrnmod().getTrn().setOrdinr(this.getWrktrn().getOrdinr());
			this.getTrnmod().getTrn().setOriinr(this.getWrktrn().getInr());
			this.getTrnmod().getTrn().setObjnam(this.getWrktrn().getObjnam());
			this.getTrnmod().getTrn().setObjtyp(this.getWrktrn().getObjtyp());
			this.getTrnmod().getTrn().setObjinr(this.getWrktrn().getObjinr());
			this.getTrnmod().getTrn().setReloricur(this.getWrktrn().getReloricur());
			this.getTrnmod().getTrn().setReloriamt(this.getWrktrn().getReloriamt());
			this.getTrnmod().getTrn().setRelcur(this.getWrktrn().getRelcur());
			this.getTrnmod().getTrn().setRelamt(this.getWrktrn().getRelamt());
			this.getTrnmod().getTrn().setNam(this.getWrktrn().getNam());
			this.getTrnmod().getTrn().setIniusr( this.getSysmod().getUsr().getInr());
			this.getTrnmod().getTrn().setPtyinr( this.getWrktrn().getPtyinr());
			this.getTrnmod().getTrn().setEtyinr( this.getWrktrn().getEtyinr());
			this.getTrnmod().getTrn().setEtginr(this.getWrktrn().getEtginr());
			this.getTrnmod().getTrn().setCpldattim(MdaUtils.today());
			this.getTrnmod().getTrn().setBchcod(this.getWrktrn().getBchcod());
			this.getTrnmod().getTrn().setOptptyinr(this.getWrktrn().getOptptyinr());
			this.getTrnmod().getTrn().setOptetyinr(this.getWrktrn().getOptetyinr());
			this.getTrnmod().getTrn().setOptetginr(this.getWrktrn().getOptetginr());
			this.getTrnmod().getTrn().setInidattim(this.getWrktrn().getInidattim());
			this.getTrnmod().getTrn().setModtyp( this.getWrktrn().getModtyp());
			this.getTrnmod().getTrn().setPtytyp( "0");
			log.info("{}","wrktrn wfm：");
			log.info("{}",this.getWrktrn().getWfm());
			if(!MdaUtils.isEmpty(this.getWrktrn().getWfm()))
			{
			  this.getTrnmod().getTrn().setWfm(this.getWrktrn().getWfm());
			}
			String inifrm=this.getWrktrn().getInifrm();
			log.info("{}","inifrm="+inifrm );
			this.getTrnmod().loadPtyaut(inifrm);
			//String relreq=$trnmod\\ptyaut\\flg.getValue();
			String relreq="O";
			log.info("{}","flag="+relreq);
			if(MdaUtils.isEmpty(relreq))
			{
			  relreq = "O";
			}
			this.getTrnmod().getTrn().setRelreq(relreq);
			this.getTrnmod().getTrn().setRelres(relreq.substring(0,1));
			int len=relreq.length();
			if(len==1)
			{
			  this.getTrnmod().getTrn().setNxtlev("");
			  this.getTrnmod().getTrn().setNxtreq("");
			  this.getTrnmod().getTrn().setSta("R");
			}
			if(len>=2)
			{
			  String nxtreq=relreq.substring(1,2);
			  if("B".equals(nxtreq))
			  {
			    this.getTrnmod().getTrn().setNxtlev("0");
			  }
			  else
			  {
			    this.getTrnmod().getTrn().setNxtlev("1");
			  }
			  this.getTrnmod().getTrn().setNxtreq(nxtreq);
			  this.getTrnmod().getTrn().setSta("W");
			}
			if(MdaUtils.isEmpty(this.getTrnmod().getTrn().getInr()))
			{
			  this.getTrnmod().getTrn().setInr(Platform.sdbCounter("trn"));
			  ctx.getDaoSession().dbInsert(this.getTrnmod().getTrn());
			  log.info("{}","dbInsert trn：");
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getTrnmod().getTrn());
			  log.info("{}","dbUpdate trn：");
			}

			String target=null;
			String rootpath=ctx.getEnvConfig().getRootPath();
			log.info("{}","rootpath：" + rootpath);
			if(true)
			{

			  String filename = this.getSysmod().createFilename(this.getWrktrn().getInr(),"zul");
			  log.info("{}","filename：" + filename);
			  target = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			  log.info("{}", "filename="+filename+",and target="+target);
			  MdaUtils.fileCopy(filename,target);

			  String sfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getWrktrn().getInr(),"dra");
			  String tfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"dra");
			  if(MdaUtils.fileExists(sfile))
			    MdaUtils.fileCopy(sfile,tfile);

			  String sappfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getWrktrn().getInr(),"app");
			  String tappfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getTrnmod().getTrn().getInr(),"app");
			  if(MdaUtils.fileExists(sappfile))
			    MdaUtils.fileCopy(sappfile,tappfile);
			}
		}
        /**
        *   source:shrtsk.@0006.script
        */
        public void addWfe(String argsvr,String argsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTrnmod().getWfmmod().getWfe().setWfsinr(this.getTrnmod().getWfmmod().getWfs().getInr());
			this.getTrnmod().getWfmmod().getWfe().setSrv(argsvr);
			this.getTrnmod().getWfmmod().getWfe().setSta(argsta);
			this.getTrnmod().getWfmmod().getWfe().setDattim(new Date());
			this.getTrnmod().getWfmmod().getWfe().setManflg("0");
			//for test
			//$wfe\\tardattim.setValue($wfe\\dattim.getValue());
			this.getTrnmod().getWfmmod().getWfe().setTardattim(new Date());
			String trnname=ctx.getTransName();
			String tvalue=null;

			if("P".equals(argsvr))
			{
			  String argpty=this.getTrnmod().getPtysFromCid(this.getTrnmod().getBchcod());
			  //String trncode=trnname+$wft\\dir.getValue()+"2";
			  String clityp=this.getSysmod().getPty().getPtytyp();
			  String clilev=null;
			  if("1".equals(clityp)  ||  "2".equals(clityp))
			  {
			    clilev="1";
			  }
			  if("3".equals(clityp))
			  {
			    clilev="2";
			  }
			  String trncode=trnname+"0"+clilev;
			  log.info("{}","trncod="+trncode);
			  String filename="transaction.properties";
			  filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			  log.info("{}", "properties filename="+filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("shrtsk","CT000003"));
			    return;
			  }
			  else
			  {
			    log.info("{}","trncode "+trncode);
			    tvalue=MdaUtils.getPropertyValue(filename,trncode);
			    log.info("{}","wfe.srvtxt="+tvalue);
			  }
			  this.getTrnmod().getWfmmod().getWfe().setSrvtxt(argpty);
			  this.getTrnmod().getWfmmod().getWfe().setTxt(tvalue);
			}
			if("T".equals(argsvr))
			{
			  if(!MdaUtils.isEmpty(this.getWrktrn().getInr()))
			  {
			    //String filename=this.getNewFilenameForBack($wrktrn\\inr.getValue());
			    //if(!Platform.isEmpty(filename))
			    //  $trnmod\\wfmmod\\wfe\\srvtxt.setValue(filename);
			    //else
			    this.getTrnmod().getWfmmod().getWfe().setSrvtxt(this.getWrktrn().getInr());
			  }
			}

			String inr=Platform.sdbCounter("wfe");
			log.debug("{}","wfe inr is "+inr);
			this.getTrnmod().getWfmmod().getWfe().setInr(inr);
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfe());
			MdaUtils.clear(this.getTrnmod().getWfmmod().getWfe());
		}
        /**
        *   source:shrtsk.@0007.script
        */
        public String getNewFilenameForBack(String wrktrninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *
			  *获取从银行端业务处理中退回后重新提交生成的新的报文文件
			  *
			  */
			String filename="";
			String sql = "SELECT srvtxt FROM wfe WHERE SRV='S' AND wfsinr=(SELECT max(inr)  FROM wfs WHERE objtyp='trn' AND objinr='"+wrktrninr+"' )";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> srvtxt = new Argument<String>("srvtxt");
			ctx.getDaoSession().dbFetchFields(srvtxt);
			int errorCode = ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			if(errorCode == NO_ERROR && !MdaUtils.isEmpty(srvtxt.value))
			  filename=srvtxt.value.trim();
			log.debug("{}","SQL===["+sql+"]\r\nNew XML File is "+filename);
			return filename;
		}
        /**
        *   source:shrtsk.@0008.script
        */
        public void setWorkFlow(String argtyp,String arginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}", "getTrnService="+ctx.getTransName());
			log.debug("{}","setWorkFlow：argtyp："+argtyp+"   :arginr："+arginr );
			this.getTrnmod().getWfmmod().getWfs().setObjtyp(argtyp);
			this.getTrnmod().getWfmmod().getWfs().setObjinr(arginr);
			this.getTrnmod().getWfmmod().getWfs().setWfstxt(this.getTrnmod().getTrnService(ctx.getTransName()));
			this.getTrnmod().getWfmmod().getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getTrnmod().getWfmmod().getWfs());
			String svrstr=this.getTrnmod().getWfmmod().getWfs().getWfstxt();
			log.info("{}","setBankWorkFlow  start："+arginr);
			log.info("{}","svrstr="+this.getTrnmod().getWfmmod().getWfs().getWfstxt());
			//for test svrstr="SPF";
			int len=svrstr.length();
			int i=0;
			while(i<len)
			{
			  String svr=svrstr.substring(i,i+1);
			  log.debug("{}","svr"+i+":"+svr );
			  //Platform.message("","in workflow :server is "+svr);
			  if("S".equals(svr))
			  {
			    String flg=this.getTrnmod().getTrn().getRelreq();
			    if(MdaUtils.isEmpty(flg))
			    {
			      log.warn("{}","relreq in trn is empty!");
			      flg=this.getTrnmod().getPtyaut().getFlg();
			    }
			    if("O".equals(flg))
			    {
			      //#CT000005
			      addWfe("S","W");
			      i++;
			    }
			    else
			    {
			      addWfe("S","W");
			      i++;
			    }
			  }
			  if("P".equals(svr))
			  {
			    addWfe("P","O");
			    i++;
			  }
			  if("E".equals(svr))
			  {
			    addWfe("E","O");
			    i++;
			  }
			  if("M".equals(svr))
			  {
			    addWfe("M","O");
			    i++;
			  }
			  if("T".equals(svr))
			  {
			    addWfe("T","O");
			    i++;
			  }
			  if("N".equals(svr))
			  {
			    addWfe("N","O");
			    i++;
			  }
			  if("F".equals(svr))
			  {
			    addWfe("F","O");
			    i++;
			  }
			  if("(".equals(svr)  ||  ")".equals(svr))
			  {
			    i++;
			  }
			}
			log.info("{}","OUT setworkflow ");
		}














}