package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SwitskVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Bimenu;
import com.ceb.gjjs.mda.manager.module.Fillst;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 消息处理(Messages Handle)
*/
@Transaction(vo= SwitskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Switsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Switsk.class);

        //message type
        private String mt;
        //a1
        private String a1;
        //data
        private IStream grpdata = new StreamImpl();
        //objtyp
        private String objtyp;
        //objinr
        private String objinr;
        //启动
        private transient IControl start = new ControlImpl("start", "启动", this);
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Smh smh;

		@BDGetter
		private ModuleList<Fillst> fillst;

		@BDGetter
		private Bimenu bimenu;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Msg msg;

		@BDGetter
		private Wfe wfe;

		@BDGetter
		private Wfs wfs;


		public Switsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:switsk.@0000.script
        */
        @Rule(target="start",order=0)
        public boolean ruleStartN0(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","switsk start...");
			/*
			  String path=Platform.catPath(Platform.getRootPath(),"data");
			  //receive message
			  Object d2 = Platform.invoke("com.brilliance.swift.SwitskUtils","receive",new ICallback(processIncoming).invoke(),path);
			  */

			return true;
        }




        /**
        *   source:switsk.@0001.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","switsk start...");
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			//receive message
			Object d2 = MdaUtils.invoke("com.brilliance.swift.SwitskUtils","receive",state,new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					processIncoming(paramVarArgs);
					return null;
				}
			},cfgpath,path);
		}
        /**
        *   source:switsk.@0002.script
        */
        public Object processIncoming(Object... obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","begin processIncoming");
			//handele head
			MdaUtils.clear(this.getBimenu());
			this.getBimenu().setCliptyinr(NULLSTR);
			this.getBimenu().setStlref(NULLSTR);
			this.getBimenu().setObjnam(NULLSTR);
			this.getBimenu().setObjinr(NULLSTR);
			this.getBimenu().setFrm(NULLSTR);
			this.getBimenu().setGrptyp(NULLSTR);
			this.getBimenu().setOwnref(NULLSTR);
			this.getBimenu().setOwnref(NULLSTR);
			this.getBimenu().setCid(NULLSTR);
			this.getBimenu().setA8(NULLSTR);
			this.getBimenu().setM8(NULLSTR);
			this.getBimenu().setM6(NULLSTR);
			this.getBimenu().setA1(NULLSTR);
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(ctx.absGet(Sysmod.class).getSpt());
			this.setA1(NULLSTR);
			this.setObjtyp(NULLSTR);
			this.setObjinr(NULLSTR);
			this.setMt(NULLSTR);
			//Platform.clear($grpdata);
			HashMap<String,Object> head = (HashMap<String,Object>)obj[0];
			if(head==null  ||  head.size()==0)
			{
			  log.info("{}","head is null");
			  return null;
			}
			else
			{
			  getTcoHeader((HashMap<String,Object>)obj[0]);
			}
			ctx.getDaoSession().dbBegin();
			Object mtvalue=head.get("MT");
			if(!MdaUtils.isEmpty(mtvalue))
			{
			  //Platform.clear($bimenu);
			  log.info("{}","determineMT="+"determineMT"+mtvalue);
			  if((Boolean)MdaUtils.invoke(this.getBimenu(),"determineMT"+mtvalue,(HashMap<String,Object>)obj[1]))
			  {
			    log.info("{}","determineMT"+mtvalue+" over...");
			  }
			  else
			  {
			    return null;
			  }
			}
			else
			{
			  log.info("{}","MT is empty!");
			  return null;
			}
			doFiles(obj[2]);
			if(!"T44".equals(mtvalue)  ||  ("T44".equals(mtvalue)&&"CTC".equals(this.getBimenu().getA1())))
			{
			  smhWrite();
			  createSpt();
			}
			//$trnmod.setWorkflow("spt",$sysmod\\spt\\inr.getValue());
			//turn to history;
			setTrnState();
			ctx.getDaoSession().dbCommit();
			log.info("{}","received the message successfully...");
			return null;
		}
        /**
        *   source:switsk.@0003.script
        */
        public void smhWrite()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","smhWrite...");
			if(!MdaUtils.isEmpty(this.getObjtyp()))
			  this.getSmh().setObjtyp(this.getObjtyp());
			else
			  this.getSmh().setObjtyp("");
			if(!MdaUtils.isEmpty(this.getObjinr()))
			  this.getSmh().setObjinr(this.getObjinr());
			else
			  this.getSmh().setObjinr("");
			this.getSmh().setMsgtyp("1");
			this.getSmh().setMsgsta("1");
			String docpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/swiftIn/arc");
			docpath=MdaUtils.catPath(docpath,MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			log.debug("{}","arc");
			this.getSmh().setDocpth(docpath);
			this.getSmh().setDir("I");
			this.getSmh().setCreusr("");
			this.getSmh().setCredattim(MdaUtils.today());
			this.getSmh().setInr(Platform.sdbCounter("smh"));
			this.getSysmod().sdbInsert(this.getSmh());
			log.info("{}","smhWrite...end");
		}
        /**
        *   source:switsk.@0004.script
        */
        public void createSpt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","createSpt...");
			if(!MdaUtils.isEmpty(this.getSysmod().getSpt().getInr()))
			{
			  this.getSysmod().getSpt().setInr(NULLSTR);
			}
			//create record SPT
			log.info("{}","grptyp="+ctx.absGet(Bimenu.class).getGrptyp());
			determineTargetOfSpt(ctx.absGet(Bimenu.class).getGrptyp());
			if(MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getM1()))
			{
			  bioOrdCreate();
			}
			//noticeBySMSAndEmail($sysmod\\spt\\ptyinr.getValue(),$sysmod\\spt\\frm.getValue(),$sysmod\\spt\\smhinr.getValue());
			log.info("{}","createSpt...End");
		}
        /**
        *   source:switsk.@0005.script
        */
        public void determineTargetOfSpt(String arggrp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","determineTargetOfSpt...");
			if(MdaUtils.isEmpty(arggrp))
			{
			  log.debug("{}","grp is null");
			}
			log.info("{}","bchcod="+ctx.absGet(Bimenu.class).getM6());
			String bch=null;
			String ptyinr=null;
			IDatafield field=null;
			IModule module=MdaDriver.getModule(this,ctx.absGet(Bimenu.class),arggrp);
			//client :ptyinr
			if(!MdaUtils.isEmpty(this.getBimenu().getM8()))
			{
			  log.info("{}","m8="+this.getBimenu().getM8());
			  ptyinr=ctx.absGet(Bimenu.class).getPtyFromCid(this.getBimenu().getM8(),new String[]{"1","2"});
			  log.info("{}", "client ptyinr="+ptyinr);
			  this.getSysmod().getSpt().setPtyinr(ptyinr);
			}
			else
			{
			  log.warn("{}","Error!Can not get the client id:M8="+this.getBimenu().getM8());
			}
			//branch bank:oprogninr
			if(!MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getM6()))
			{
			  //todo...
			  bch=ctx.absGet(Bimenu.class).getPtyFromCid(ctx.absGet(Bimenu.class).getM6(),new String[]{"0"});
			  log.info("{}","bchcod->ptyinr="+bch);
			  if(!MdaUtils.isEmpty(bch))
			  {
			    this.getSysmod().getSpt().setOprogninr(bch);
			  }
			  else
			  {
			    field=MdaDriver.getDatafield(module,"rec\\bchcod");
			    String branch=field.getValue().toString();
			    log.info("{}", "your bchcod="+branch);
			    this.getSysmod().getSpt().setOprogninr(branch);
			  }
			}

			this.getSysmod().getSpt().setOprusrinr("");
			saveSptEntry();
			//Platform.clear($sysmod\\spt);
			//direct client
			/*
			  //delete bu dg 090907
			  if(!Platform.isEmpty($bimenu\\m8))
			  {
			  log.info("m8="+$bimenu\\m8);
			  ptyinr=$\\bimenu.getPtyFromCid($bimenu\\m8.getValue());
			  log.info( "your ptyinr="+ptyinr);
			  $sysmod\\spt\\oprogninr.setValue(ptyinr);
			  }
			  else
			  {
			  field=Platform.getDatafield(module,"rec\\\\ptyinr");
			  ptyinr=field.getValue().toString();
			  ptyinr=$\\bimenu.getPtyFromExtkey(ptyinr);
			  log.info( "your ptyinr="+ptyinr);
			  $sysmod\\spt\\oprogninr.setValue(ptyinr);
			  }
			  $sysmod\\spt\\oprusrinr.setValue("");
			  saveSptEntry();
			  */
			/*
			  }
			  else
			  {
			  String modpath=null;
			  if(!Platform.isEmpty($\\bimenu\\grptyp))
			  {
			  modpath=$\\bimenu\\grptyp.getValue();
			  }
			  else
			  {
			  log.info("modpath is null");
			  }
			  log.info("modpath="+modpath);
			  }
			  */
			log.info("{}","determineTargetOfSpt... End");
		}
        /**
        *   source:switsk.@0006.script
        */
        public void bioOrdCreate()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 生成新的ORDER流水
			  */
			this.getTrnmod().getOrdmod().getOrd().setSta("C");
			this.getTrnmod().getOrdmod().getOrd().setStadattim(new Date());
			String transname=ctx.getTransName();
			this.getTrnmod().getOrdmod().getOrd().setFrm(transname);
			this.getTrnmod().getOrdmod().getOrd().setInr(Platform.sdbCounter("ord"));
			this.getSysmod().sdbInsert(this.getTrnmod().getOrdmod().getOrd());
			this.getTrnmod().getOrdmod().getOre().setOrdinr(this.getTrnmod().getOrdmod().getOrd().getInr());
			this.getTrnmod().getOrdmod().getOre().setObjtyp(this.getTrnmod().getOrdmod().getOrd().getObjtyp());
			this.getTrnmod().getOrdmod().getOre().setObjinr(this.getTrnmod().getOrdmod().getOrd().getObjinr());
			this.getTrnmod().getOrdmod().getOre().setTyp(this.getTrnmod().getOrdmod().getOrd().getSta());
			this.getTrnmod().getOrdmod().getOre().setFrm(transname);
			this.getTrnmod().getOrdmod().getOre().setUsrinr(this.getSysmod().getUsr().getInr());
			this.getTrnmod().getOrdmod().getOre().setPtyinr(this.getSysmod().getPty().getInr());
			this.getTrnmod().getOrdmod().getOre().setInr(Platform.sdbCounter("ore"));
			this.getSysmod().sdbInsert(this.getTrnmod().getOrdmod().getOre());
		}
        /**
        *   source:switsk.@0007.script
        */
        public void saveSptEntry()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","saveSptEntry...");
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  this.getSysmod().getSpt().setSmhinr(this.getSmh().getInr());
			}
			//spt.ownref
			log.info("{}","stlref = "+ctx.absGet(Bimenu.class).getStlref());
			if(!MdaUtils.isEmpty(this.getBimenu().getStlref()))
			{
			  this.getSysmod().getSpt().setOwnref(this.getBimenu().getStlref());
			}
			else if(!MdaUtils.isEmpty(this.getBimenu().getOwnref()))
			{
			  this.getSysmod().getSpt().setOwnref(this.getBimenu().getOwnref());
			}
			else
			{
			  this.getSysmod().getSpt().setOwnref("NOREF");
			}
			//
			if(!MdaUtils.isEmpty(this.getBimenu().getObjtyp()))
			{
			  this.getSysmod().getSpt().setObjtyp(this.getBimenu().getObjtyp());
			}
			else
			{
			  this.getSysmod().getSpt().setObjtyp("");
			}
			if(!MdaUtils.isEmpty(this.getBimenu().getObjinr()))
			{
			  this.getSysmod().getSpt().setObjinr(this.getBimenu().getObjinr());
			}
			//
			String objnam = "";
			if(!MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getObjnam()))
			  objnam = ctx.absGet(Bimenu.class).getObjnam();
			String nam = "";
			String ccy = "";
			String amt = "";
			// 读取sub
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),this.getBimenu().getFrm(),"SUB");
			if(!MdaUtils.isEmpty(data))
			{
			  if(!MdaUtils.isEmpty(data.get("nam")))
			    nam = data.get("nam").toString();
			  if(!MdaUtils.isEmpty(data.get("ccy")))
			    ccy = data.get("ccy").toString();
			  this.getSysmod().getSpt().setTrncur(ccy);
			  if(!MdaUtils.isEmpty(data.get("amt")))
			  {
			    amt = data.get("amt").toString();
			    this.getSysmod().getSpt().setTrnamt((BigDecimal)data.get("amt"));
			  }
			}
			String ptynam = ctx.absGet(Bimenu.class).getPtyFromCid(this.getBimenu().getM8(),null);
			this.getSysmod().getSpt().setNam(ptynam);
			//$sysmod\\spt\\objnam.setValue(objnam+nam+ptynam+ccy+amt);
			if(nam!=null&&nam.length()>35)
			  nam = nam.substring(0,35);
			this.getSysmod().getSpt().setObjnam(ccy+amt+"/"+nam);
			this.getSysmod().getSpt().setFrm(this.getBimenu().getFrm());
			this.getSysmod().getSpt().setSta("T");
			this.getSysmod().getSpt().setScr("A");
			//$sysmod\\spt\\dattim.setValue(new Date());
			log.debug("{}","now save spt dattim="+this.getBimenu().getM9()+!MdaUtils.isEmpty(this.getBimenu().getM9()));
			//if(!Platform.isEmpty($bimenu\\m9))
			//$sysmod\\spt\\dattim.setValue($bimenu\\m9.getValue());
			this.getSysmod().getSpt().setDattim(MdaUtils.today());
			//$sysmod\\spt\\ptyinr.setValue("");
			this.getSysmod().getSpt().setInr(Platform.sdbCounter(this.getSysmod().getSpt()));
			this.getSysmod().sdbInsert(this.getSysmod().getSpt());
			IStream os=this.getGrpdata();
			String modpath=null;
			if(!MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getGrptyp()))
			{
			  modpath=ctx.absGet(Bimenu.class).getGrptyp();
			}
			else
			{
			  log.info("{}","modpath is null");
			}
			log.info("{}","modpath="+modpath);
			//modpath="bimenu\\\\"+modpath;
			//log.info("afetr,modpath="+modpath);
			MdaUtils.saveData(MdaDriver.getModule(this,this.getBimenu(),modpath),os);
			//$sysmod.streamSaveInSubdir(os,$sysmod\\spt\\inr.getValue(),"bak");
			String filename = this.getSysmod().createFilename(this.getSysmod().getSpt().getInr(),"bak");
			MdaUtils.streamSave(os,filename);
			//notice the client
			
			String srv=this.getTrnmod().getTrnService(this.getBimenu().getFrm());
			log.info("{}","frm="+this.getBimenu().getFrm()+",srv="+srv);
			if(!MdaUtils.isEmpty(srv))
			{
			  log.info("{}","argument="+this.getSysmod().getSpt().getPtyinr()+","+this.getSysmod().getSpt().getFrm()+","+this.getSysmod().getSpt().getSmhinr());
			  setNoticeWorkflow(this.getSysmod().getSpt().getInr(),this.getSysmod().getSpt().getPtyinr(),this.getSysmod().getSpt().getFrm(),srv,this.getSysmod().getSpt().getSmhinr());
			}

		}
        /**
        *   source:switsk.@0008.script
        */
        public void getTcoHeader(HashMap<String,Object> head)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object mtvalue=head.get("MT");
			Object m1value=head.get("M1");
			Object m2value=head.get("M2");
			Object m3value=head.get("M3");
			Object m4value=head.get("M4");
			Object m5value=head.get("M5");
			Object m6value=head.get("M6");
			Object m7value=head.get("M7");
			Object m8value=head.get("M8");
			Object m9value=head.get("M9");
			Object a1value=head.get("A1");
			Object a2value=head.get("A2");
			Object a3value=head.get("A3");
			Object a4value=head.get("A4");
			Object a5value=head.get("A5");
			Object a6value=head.get("A6");
			Object a7value=head.get("A7");
			Object a8value=head.get("A8");
			Object a9value=head.get("A9");
			if(!MdaUtils.isEmpty(mtvalue))
			{
			  this.getBimenu().setMt(mtvalue.toString());
			  log.info("{}","message type(MT)="+this.getBimenu().getMt());
			}
			if(!MdaUtils.isEmpty(m1value))
			{
			  this.getBimenu().setM1(m1value.toString());
			  this.getBimenu().setOwnref(m1value.toString());
			  log.info("{}","message M1(ownref)="+this.getBimenu().getM1());
			}
			if(!MdaUtils.isEmpty(m2value))
			{
			  this.getBimenu().setM2(mtvalue.toString());
			  log.info("{}","message M2="+this.getBimenu().getM2());
			}
			if(!MdaUtils.isEmpty(m3value))
			{
			  this.getBimenu().setM3(mtvalue.toString());
			  log.info("{}","message M3="+this.getBimenu().getM3());
			}
			if(!MdaUtils.isEmpty(m4value))
			{
			  this.getBimenu().setM4(mtvalue.toString());
			  log.info("{}","message M4="+this.getBimenu().getM4());
			}
			if(!MdaUtils.isEmpty(m5value))
			{
			  this.getBimenu().setM5(m5value.toString());
			  log.info("{}","message M5="+this.getBimenu().getM5());
			}
			if(!MdaUtils.isEmpty(m6value))
			{
			  this.getBimenu().setM6(m6value.toString());
			  this.getBimenu().setBchcod(m6value.toString());
			  log.info("{}","message M6(bchcod)="+this.getBimenu().getM6());
			}
			if(!MdaUtils.isEmpty(m7value))
			{
			  this.getBimenu().setM7(m7value.toString());
			  log.info("{}","message M7="+this.getBimenu().getM7());
			}
			if(!MdaUtils.isEmpty(m8value))
			{
			  String m8=m8value.toString();
			  this.getBimenu().setM8(m8);
			  this.getBimenu().setCid(m8);
			  log.info("{}","message M8(cid)="+this.getBimenu().getM8());
			  String cliptyinr=this.getBimenu().getPtyFromCid(m8,new String[]{"1","2"});
			  if(!MdaUtils.isEmpty(cliptyinr))
			    this.getBimenu().setCliptyinr(cliptyinr);
			  else
			  {
			    cliptyinr=this.getBimenu().getPtyFromCid(m8,new String[]{"3"});
			    this.getBimenu().setCliptyinr(cliptyinr);
			  }
			  log.info("{}","ptyinr="+cliptyinr);
			  String etyinr = this.getBimenu().getEtyFromCid(m8);
			  if(!MdaUtils.isEmpty(etyinr))
			    this.getBimenu().setEtyinr(etyinr);
			}
			if(!MdaUtils.isEmpty(m9value))
			{
			  this.getBimenu().setM9((Date)m9value);
			  log.info("{}","message M9="+this.getBimenu().getM9());
			}
			if(!MdaUtils.isEmpty(a1value))
			{
			  this.getBimenu().setA1(a1value.toString());
			  log.info("{}","message A1="+this.getBimenu().getA1());
			}
			if(!MdaUtils.isEmpty(a2value))
			{
			  this.getBimenu().setA2(a2value.toString());
			  log.info("{}","message A2="+this.getBimenu().getA2());
			}
			if(!MdaUtils.isEmpty(a3value))
			{
			  this.getBimenu().setA3(a3value.toString());
			  log.info("{}","message A3="+this.getBimenu().getA3());
			}
			if(!MdaUtils.isEmpty(a4value))
			{
			  this.getBimenu().setA4(a4value.toString());
			  log.info("{}","message A4="+this.getBimenu().getA4());
			}
			if(!MdaUtils.isEmpty(a5value))
			{
			  this.getBimenu().setA5(a5value.toString());
			  log.info("{}","message A5="+this.getBimenu().getA5());
			}
			if(!MdaUtils.isEmpty(a6value))
			{
			  this.getBimenu().setA6(a6value.toString());
			  log.info("{}","message A6="+this.getBimenu().getA6());
			}
			if(!MdaUtils.isEmpty(a7value))
			{
			  this.getBimenu().setA7(a7value.toString());
			  log.info("{}","message A7="+this.getBimenu().getA7());
			}
			if(!MdaUtils.isEmpty(a8value))
			{
			  this.getBimenu().setA8(a8value.toString());
			  log.info("{}","message A8="+this.getBimenu().getA8());
			}
			if(!MdaUtils.isEmpty(a9value))
			{
			  this.getBimenu().setA9(a9value.toString());
			  log.info("{}","message A9="+this.getBimenu().getA9());
			}
			/*
			  for(String key:head.keySet())
			  {
			  if(!Platform.isEmpty(head.get(key)))
			  {
			  log.info("head:name=" +key+"  value=" +head.get(key));
			  }
			  }
			  */
			//return;
					}
        /**
        *   source:switsk.@0009.script
        */
        public void doFiles(Object obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//String[] fname=(String[])obj[2];
			Map<String,String> fnames=(Map<String,String>)obj;
			ArrayList<String> xmlfils = new ArrayList<String>(2);
			ArrayList<String> sw2fils = new ArrayList<String>(3);
			for(String fnam:fnames.keySet())
			{
			  log.info("{}",fnam);
			  if(fnam.indexOf(",")>=0  ||  fnam.indexOf(";")>=0)
			  {
			    log.info("{}","error file!can not handle");
			    continue;
			  }
			  if(fnam.endsWith(".lst"))
			    this.getSmh().setLstfil(fnam);
			  if(fnam.endsWith(".txt"))
			    this.getSmh().setTcofil(fnam);
			  if(fnam.endsWith(".sw2"))
			    sw2fils.add(fnam);
			  if(fnam.endsWith(".xml"))
			    xmlfils.add(fnam);
			}
			int sw2cnt = sw2fils.size();
			log.debug("{}","have "+sw2cnt+" sw2 files");
			if(sw2cnt==1)
			  this.getSmh().setSf2fil(sw2fils.get(0));
			else if(sw2cnt>1)
			{
			  StringBuffer sw2Val = new StringBuffer(40);
			  String split="";
			  for(String fnam:sw2fils)
			  {
			    sw2Val.append(split);
			    sw2Val.append(fnam);
			    split=";";
			  }
			  this.getSmh().setSf2fil(sw2Val.toString());
			}
			int xmlcnt = xmlfils.size();
			log.debug("{}","have "+xmlcnt+" xml files");
			if(xmlcnt==1)
			  this.getSmh().setXmlfil(xmlfils.get(0));
			else if(xmlcnt>1)
			{
			  //load attach.properties
			  String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			  if(!MdaUtils.fileExists(filepath))
			    return;
			  String desc=null;
			  String frm = this.getBimenu().getFrm();
			  StringBuffer xmlVal = new StringBuffer(30);
			  String split="";
			  // 读取附件按钮配置项个数
			  String attlenstr = MdaUtils.getPropertyValue(filepath,frm+".len");
			  int attlen = 4;
			  if(!MdaUtils.isEmpty(attlenstr))
			  {
			    attlen = Integer.valueOf(attlenstr);
			  }
			  log.debug("{}","配置项个数 "+attlen);
			  for(String fnam:xmlfils)
			  {
			    xmlVal.append(split);
			    String onexml = "";
			    log.debug("{}","fnam "+fnames.get(fnam));
			    for(int i=0;i<attlen;i++)
			    {
			      desc=MdaUtils.getPropertyValue(filepath,frm+"."+i);
			      log.debug("{}",i+"desc "+desc);
			      if(desc!=null&&desc.equals(fnames.get(fnam)))
			      {
			        onexml = fnam+","+i;
			        break;
			      }
			    }
			    if("".equals(onexml))
			      xmlVal.append(fnam);
			    else
			      xmlVal.append(onexml);
			    split=";";
			  }
			  this.getSmh().setXmlfil(xmlVal.toString());
			}
			log.debug("{}","smh.xmlfil="+this.getSmh().getXmlfil());
			log.debug("{}","smh.tcofil="+this.getSmh().getTcofil());
			log.debug("{}","smh.sf2fil="+this.getSmh().getSf2fil());
			log.debug("{}","smh.lstfil="+this.getSmh().getLstfil());
			log.debug("{}","handle file over...");
		}
        /**
        *   source:switsk.@0010.script
        */
        public boolean noticeBySMSAndEmail(String ptyinr,String frm,String smhinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","noticeBySMSAndEmail...");
			if(MdaUtils.isEmpty(ptyinr)) return false;
			Argument<String> inr=new Argument<String>("inr");
			Argument<String> msgflg=new Argument<String>("msgflg");
			Argument<String> emlflg=new Argument<String>("emlflg");
			Argument<String> mobile=new Argument<String>("mobile");
			Argument<String> eml=new Argument<String>("eml");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr,emlflg,msgflg,mobile,eml FROM msg WHERE ptyinr='"+ptyinr+"' and frm='"+frm+"'");
			ctx.getDaoSession().dbFetchFields(inr,emlflg,msgflg,mobile,eml);
			int e=ctx.getErrorCode();
			log.debug("{}","e="+e);
			log.info("{}",inr.value+","+emlflg.value+","+msgflg.value+","+mobile.value+",");
			if(e==NO_ERROR)
			{
			  log.info("{}","msginr="+inr.value);
			  if("X".equals(emlflg.value)&&!MdaUtils.isEmpty(eml.value))
			  {
			    //eml
			    log.info("{}","eml service...");
			    this.getWfe().setWfsinr(this.getWfs().getInr());
			    this.getWfe().setTardattim(new Date());
			    this.getWfe().setSta("W");
			    this.getWfe().setSrv("E");
			    this.getWfe().setManflg("0");
			    this.getWfe().setDattim(new Date());
			    //msgflag..
			    this.getWfe().setSrvtxt(inr.value);
			    this.getWfe().setTxt(smhinr);
			    this.getWfe().setInr(Platform.sdbCounter(this.getWfe()));
			    this.getSysmod().sdbInsert(this.getWfe());
			    MdaUtils.clear(this.getWfe());
			  }
			  if("X".equals(msgflg.value)&&!MdaUtils.isEmpty(mobile.value))
			  {
			    //sms,
			    log.info("{}","sms service...");
			    //String cphone=null;  // FIXME
			    String tels=mobile.value;
			    if(!MdaUtils.isEmpty(tels))
			    {
			      tels = tels.replaceAll(";",",");
			      String[] tel = tels.split(",");
			      for(String t:tel)
			      {
			        addSMSService(t,inr.value);
			      }
			      /*if(tels.indexOf(",")!=-1)
			        {
			        int dot=tels.indexOf(",");
			        cphone=tels.substring(0,dot);
			        addSMSService(cphone,inr.value);
			        cphone=tels.substring(dot+1);
			        addSMSService(cphone,inr.value);
			        }
			        else
			        {
			        cphone=tels;
			        addSMSService(cphone,inr.value);
			        }*/
			    }

			  }
			}
			log.debug("{}","noticeBySMSAndEmail...end");
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}
        /**
        *   source:switsk.@0011.script
        */
        public void addSMSService(String cellnumber,String msginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWfe().setWfsinr(this.getWfs().getInr());
			this.getWfe().setTardattim(new Date());
			this.getWfe().setSta("W");
			this.getWfe().setSrv("M");
			this.getWfe().setManflg("0");
			this.getWfe().setDattim(new Date());
			this.getWfe().setSrvtxt(msginr);
			this.getWfe().setTxt(cellnumber);
			this.getWfe().setInr(Platform.sdbCounter(this.getWfe()));
			this.getSysmod().sdbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());
		}
        /**
        *   source:switsk.@0012.script
        */
        public void setNoticeWorkflow(String sptinr,String ptyinr,String frm,String srv,String smhinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(sptinr))
			  return;
			if(MdaUtils.isEmpty(ptyinr))
			  return;
			this.getWfs().setObjtyp("spt");
			this.getWfs().setObjinr(sptinr);
			this.getWfs().setWfstxt(srv);
			this.getWfs().setInr(Platform.sdbCounter(this.getWfs()));
			ctx.getDaoSession().dbInsert(this.getWfs());
			String svrstr=this.getWfs().getWfstxt();
			log.info("{}","svr="+this.getWfs().getWfstxt());
			noticeBySMSAndEmail(ptyinr,frm,smhinr);
		}
        /**
        *   source:switsk.@0013.script
        */
        public void setTrnState()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String objinr=this.getBimenu().getObjinr();
			String objtyp=this.getBimenu().getObjtyp();
			String ptyinr=this.getSysmod().getSpt().getOprogninr();
			String cliptyinr=this.getSysmod().getSpt().getPtyinr();
			//String[] list=$\\sysmod.getAplTrn();
			String[] list=null;
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/relation.properties");
			String apltrn=MdaUtils.getPropertyValue(file,this.getBimenu().getFrm());
			if(MdaUtils.isEmpty(apltrn))
			  return;
			else
			  list=apltrn.split(",");
			log.info("{}","objinr="+objinr+",objtyp="+objtyp+",apltrn="+apltrn);
			/*
			  log.info("objinr="+objinr+",objtyp="+objtyp+",optptyinr="+ptyinr+"");
			  Platform.dbRead($\\trnmod\\trn,new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp),new Argument<String>("optptyinr",ptyinr),new Argument<Object>("inifrm",IN,list));
			  if(!Platform.isEmpty($\\trnmod\\trn\\inr))
			  {
			  log.info("trn to be updated inr="+$\\trnmod\\trn\\inr.getValue());
			  $\\trnmod\\trn\\sta.setValue("A");
			  Platform.dbUpdate($\\trnmod\\trn);
			  Platform.clear($\\trnmod\\trn);
			  }
			  log.info("objinr="+objinr+",objtyp="+objtyp+",optptyinr="+cliptyinr+"");
			  Platform.dbRead($\\trnmod\\trn,new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp),new Argument<String>("optptyinr",cliptyinr),new Argument<Object>("inifrm",IN,list));
			  if(!Platform.isEmpty($\\trnmod\\trn\\inr))
			  {
			  log.info("trn to be updated inr="+$\\trnmod\\trn\\inr.getValue());
			  $\\trnmod\\trn\\sta.setValue("A");
			  Platform.dbUpdate($\\trnmod\\trn);
			  Platform.clear($\\trnmod\\trn);
			  }
			  */
			String frms=this.getSysmod().toSqlString(list);
			Argument<String> inr=new Argument<String>("inr");
			String sql="SELECT inr FROM trn WHERE objinr='"+objinr+"' AND objtyp='"+objtyp+"' AND inifrm IN ("+frms+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbRead(this.getTrnmod().getTrn(),new Argument<String>("inr",inr.value));
			    if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrn().getInr()))
			      continue;
			    log.info("{}","trn to be updated inr="+ctx.absGet(Trnmod.class).getTrn().getInr());
			    ctx.absGet(Trnmod.class).getTrn().setSta("A");
			    ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			    MdaUtils.clear(ctx.absGet(Trnmod.class).getTrn());
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}















}