package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SwmctlVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Swlst;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.bo.Lebhsnd;
import com.ceb.gjjs.mda.bo.Swit;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ebhsnd;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* E结算管理
*/
@Transaction(vo= SwmctlVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Swmctl extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Swmctl.class);

        //报文类型：
        private String msgcod;
        //生成日期始：
        private Date date;
        //生成日期止：
        private Date date1;
        //处理状态：
        private String sta;
        //重新发送
        private transient IControl resend = new ControlImpl("resend", "重新发送", this);
        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);
        //业务参考号
        private String ownref;
        //查询结果
        private String sqlrst;
        //输入sql
        private String sqlin;
        //合作平台重发
        private transient IControl rebhsnd = new ControlImpl("rebhsnd", "合作平台重发", this);
        //合作平台查询
        private transient IControl selebh = new ControlImpl("selebh", "合作平台查询", this);
        //单一窗口
        private transient IControl goswp = new ControlImpl("goswp", "单一窗口", this);
        //电子保函界面
        private transient IControl goebhp = new ControlImpl("goebhp", "电子保函界面", this);
        //国结界面
        private transient IControl gogjjs = new ControlImpl("gogjjs", "国结界面", this);
        //返回
        private transient IControl ret = new ControlImpl("ret", "返回", this);
        //执行sql
        private transient IControl exesql = new ControlImpl("exesql", "执行sql", this);
        //下载结果文件
        private IStream downrst = new StreamImpl();
        //国结lst文件id
        private String lstid;
        //重新处理
        private transient IControl rerecv = new ControlImpl("rerecv", "重新处理", this);
        //报文接收日期
        private Date lstdate;
        //处理结果
        private String lstrst;
        //消息推送管理
        private transient IControl notswitch = new ControlImpl("notswitch", "消息推送管理", this);
        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);
        //保存
        private transient IControl submit = new ControlImpl("submit", "保存", this);
        //开关类型
        private String switchtyp;
        //生成记录时开关
        private String gsta;
        //客户cid
        private String cid;
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Swmmod swmmod;

		@BDGetter
		private ModuleList<Swlst> swlst;

		@BDGetter
		private Ebhsnd ebhsnd;

		@BDGetter
		private ModuleList<Lebhsnd> lebhsnd;

		@BDGetter
		private Swit swit;


		public Swmctl()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:swmctl.@0001.script
        */
        @Rule(target="search",order=100)
        public boolean ruleSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.refresh();

			return true;
        }

        /**
        *   source:swmctl.@0002.script
        */
        @Rule(target="resend",order=100)
        public boolean ruleResendN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index < 0 )
			{
			  ctx.setMessage("提醒","请选择一条记录！");
			  return false;
			}
			String inr =this.getSwlst().getElement(index).getInr();
			if(MdaUtils.isEmpty(inr))
			{
			  ctx.setMessage("提醒","请刷新重试！");
			  return false;
			}
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getSwmmod().getSwmsg());
			ctx.getDaoSession().dbRead(this.getSwmmod().getSwmsg(),new Argument<String>("inr",inr));
			if(MdaUtils.isEmpty(this.getSwmmod().getSwmsg().getInr()))
			{
			  ctx.setMessage("提醒","请刷新重试！");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			String sta = this.getSwmmod().getSwmsg().getSta();
			int cnt = this.getSwmmod().getSwmsg().getCnt();

			if(sta.equals("W")||sta.equals("D")||(sta.equals("E")&&cnt<3))
			{
			  ctx.setMessage("提醒","请等待系统自动处理！");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			this.getSwmmod().getSwmsg().setSta("W");
			this.getSwmmod().getSwmsg().setMuser(this.getSysmod().getUsr().getLgnnam());
			this.getSwmmod().getSwmsg().setMandate(MdaUtils.today());
			ctx.getDaoSession().dbUpdate(this.getSwmmod().getSwmsg());
			ctx.getDaoSession().dbCommit();
			this.refresh();


			return true;
        }

        /**
        *   source:swmctl.@0005.script
        */
        @Rule(target="selebh",order=100)
        public boolean ruleSelebhN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.selebhsnd();

			return true;
        }

        /**
        *   source:swmctl.@0006.script
        */
        @Rule(target="rebhsnd",order=100)
        public boolean ruleRebhsndN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index < 0 )
			{
			  ctx.setMessage("提醒","请选择一条记录！");
			  return false;
			}
			String inr =this.getLebhsnd().getElement(index).getInr();
			if(MdaUtils.isEmpty(inr))
			{
			  ctx.setMessage("提醒","请刷新重试！");
			  return false;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("swmctl","CT000032"),MdaUtils.getI18NString("swmctl","CT000033")))
			  return true;
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getEbhsnd());
			ctx.getDaoSession().dbRead(this.getEbhsnd(),new Argument<String>("inr",inr));
			if(MdaUtils.isEmpty(this.getEbhsnd().getInr()))
			{
			  ctx.setMessage("提醒","请刷新重试！");
			  ctx.getDaoSession().dbRollback();
			  return false;
			}
			String sta = this.getEbhsnd().getSta();
			this.getEbhsnd().setSta("W");
			this.getEbhsnd().setMandate(MdaUtils.today());
			ctx.getDaoSession().dbUpdate(this.getEbhsnd());
			ctx.getDaoSession().dbCommit();
			this.selebhsnd();

			return true;
        }

        /**
        *   source:swmctl.@0008.script
        */
        @Rule(target="exesql",order=100)
        public boolean ruleExesqlN100(){
            IContext ctx = MdaEnv.getContext();
            
			//1\\trim
			//2\\select和其他操作
			String sql = this.getSqlin();
			if(MdaUtils.isEmpty(sql))
			{
			  ctx.setMessage(MdaUtils.getI18NString("swmctl","CT000065"),MdaUtils.getI18NString("swmctl","CT000066"));
			  return false;
			}
			this.setSqlrst(NULLSTR);
			String uppersql = sql.toUpperCase();
			if(uppersql.matches("\\s*SELECT .*"))
			{
			  //使用java代码处理，写入文件供下载。
			  List<Map<String, Object> > rst = (List<Map<String, Object> >)MdaUtils.invoke("com.brilliance.gsn.JDBCUtil","queryForList",sql,new Object[]{});
			  com.google.gson.Gson gson = new com.google.gson.Gson();
			  this.setSqlrst(gson.toJson(rst));
			  
			}
			else
			{
			  if(MdaUtils.prompt(MdaUtils.getI18NString("swmctl","CT000067"),MdaUtils.getI18NString("swmctl","CT000068")))
			  {
			    return false;
			  }
			  else
			  {
			    boolean brst = (Boolean)MdaUtils.invoke("com.brilliance.gsn.JDBCUtil","execute",sql,new Object[]{});
			    if(brst)
			    {
			      this.setSqlrst("执行成功");
			    }
			    else
			    {
			      this.setSqlrst("执行失败");
			    }
			    
			  }
			}

			return true;
        }

        /**
        *   source:swmctl.@0009.script
        */
        @Rule(target="goswp",order=100)
        public boolean ruleGoswpN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:swmctl.@0010.script
        */
        @Rule(target="goebhp",order=100)
        public boolean ruleGoebhpN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:swmctl.@0011.script
        */
        @Rule(target="gogjjs",order=100)
        public boolean ruleGogjjsN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:swmctl.@0012.script
        */
        @Rule(target="ret",order=100)
        public boolean ruleRetN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.showMainPanel();

			return true;
        }

        /**
        *   source:swmctl.@0013.script
        */
        @Rule(target="rerecv",order=100)
        public boolean ruleRerecvN100(){
            IContext ctx = MdaEnv.getContext();
            
			String lstid = this.getLstid();
			if(MdaUtils.isEmpty(lstid)||MdaUtils.isEmpty(lstid.trim())||MdaUtils.isEmpty(this.getLstdate()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("swmctl","CT000078"),MdaUtils.getI18NString("swmctl","CT000079"));
			  return true;
			}
			String datestr = MdaUtils.format(this.getLstdate(),"yyyyMMdd");
			if(MdaUtils.isEmpty(datestr))
			{
			  ctx.setMessage(MdaUtils.getI18NString("swmctl","CT000080"),MdaUtils.getI18NString("swmctl","CT000081"));
			  return true;
			}
			String[] item = lstid.split(",");

			String TARDIR="/etrade/webapps/resource/data/backup/history/"+datestr;
			String ARCDIR="/etrade/webapps/resource/data/backup/arc/"+datestr;
			String ERRDIR="/etrade/webapps/resource/data/backup/error/"+datestr;
			String RCVDIR="/etrade/webapps/resource/data/rcvxml";
			StringBuffer bf = new StringBuffer();

			for(int i=0;i<item.length;i++){
			  String nam = item[i];
			String arcnam=ARCDIR+"/"+nam+".lst";
			String tarnam=TARDIR+"/"+nam+".tar";
			log.info("{}",tarnam);
			String oknam=TARDIR+"/"+nam+".ok";
			log.info("{}",oknam);
			String rcvtar = RCVDIR+"/"+nam+".tar";
			String rcvok = RCVDIR+"/"+nam+".ok";
			if(MdaUtils.fileExists(arcnam))
			{
			  continue;
			}
			else
			{
			  // 保存文件
			  try
			  {
			    java.io.File dest = new java.io.File(rcvtar);
			    if (!dest.exists())
			    {
			      try
			      {
			        dest.createNewFile();
			      }
			      catch (java.io.IOException e)
			      {
			        log.error("{}","***** tar 文件创建失败！");
			        log.error("{}",e.toString());
			        bf.append(nam+",");
			        continue;
			      }
			    }
			    org.apache.commons.io.FileUtils.copyFile(new java.io.File(tarnam),dest);
			    MdaUtils.sleep(1000);
			    dest = new java.io.File(rcvok);
			    //org.apache.commons.io.FileUtils.moveFile(new java.io.File(oknam),dest);
			    try
			    {
			      dest.createNewFile();
			    }
			    catch (java.io.IOException e)
			    {
			      log.error("{}","*****  ok文件创建失败！");
			      log.error("{}",e.toString());
			      bf.append(nam+",");
			      continue;
			    }
			  }
			  catch (java.io.IOException e)
			  {
			    // TODO Auto-generated catch block
			    e.printStackTrace();
			    log.error("{}","文件移动异常"+e.getMessage());
			    log.error("{}","文件移动异常"+e.toString());
			    bf.append(nam+",");
			  }
			}
			}
			this.setLstrst(NULLSTR);
			this.setLstrst("失败："+bf.toString());
			

			return true;
        }

        /**
        *   source:swmctl.@0014.script
        */
        @Rule(target="notswitch",order=100)
        public boolean ruleNotswitchN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setSwitchtyp(NULLSTR);
			this.setGsta(NULLSTR);
			this.setCid(NULLSTR);

			

			return true;
        }

        /**
        *   source:swmctl.@0015.script
        */
        @Rule(target="submit",order=100)
        public boolean ruleSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();

			//先根据开关类型判断是否总开关，总开关为修改，且不需要保存cid
			if("1".equals(this.getSwitchtyp()))
			{
			  MdaUtils.clear(this.getSwit());
			  ctx.getDaoSession().dbRead(this.getSwit(),new Argument<String>("switchtyp","1"));
			  if(MdaUtils.isEmpty(this.getSwit().getInr()))
			  {//保存
			    this.getSwit().setInr(Platform.sdbCounter("swit"));
			    this.getSwit().setSwitchtyp("1");
			    this.getSwit().setGsta(this.getGsta());
			    ctx.getDaoSession().dbInsert(this.getSwit());
			  }
			  else
			  {//修改
			    this.getSwit().setGsta(this.getGsta());
			    ctx.getDaoSession().dbUpdate(this.getSwit());
			  }
			}
			else
			{//客户开关
			  MdaUtils.clear(this.getSwit());
			  ctx.getDaoSession().dbRead(this.getSwit(),new Argument<String>("cid",this.getCid()));
			  if(MdaUtils.isEmpty(this.getSwit().getInr()))
			  {//保存
			    this.getSwit().setInr(Platform.sdbCounter("swit"));
			    this.getSwit().setSwitchtyp(this.getSwitchtyp());
			    this.getSwit().setGsta(this.getGsta());
			    this.getSwit().setCid(this.getCid());
			    ctx.getDaoSession().dbInsert(this.getSwit());
			  }
			  else
			  {//修改
			    this.getSwit().setGsta(this.getGsta());
			    ctx.getDaoSession().dbUpdate(this.getSwit());
			  }
			}
			ctx.getDaoSession().dbCommit();
			ctx.setMessage(MdaUtils.getI18NString("swmctl","CT000091"),MdaUtils.getI18NString("swmctl","CT000092"));
			

			return true;
        }

        /**
        *   source:swmctl.@0016.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setSwitchtyp(NULLSTR);
			this.setGsta(NULLSTR);
			this.setCid(NULLSTR);

			

			return true;
        }



        /**
        *   source:swmctl.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setDate(MdaUtils.add(MdaUtils.today(),-7));
			this.setDate(MdaUtils.today());
			this.refresh();

			return true;
        }


        /**
        *   source:swmctl.@0000.script
        */
        public void refresh()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getSwlst());

			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();

			List objs = new ArrayList();
			String sql="select s.inr inr,s.cnt cnt,s.credat credat,s.mandate mandate,s.msgcod msgcod,s.objinr objinr,s.objtyp objtyp,s.sta sta,s.muser muser,t.ownref ownref ,t.optptyinr optptyinr from swmsg s,trn t  where s.objinr=t.objinr and s.objtyp=t.objtyp ";

			Argument<String> inr =new Argument<String>("inr");
			Argument<String> sta =new Argument<String>("sta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<Date> credat =new Argument<Date>("credat");
			Argument<BigDecimal> cnt =new Argument<BigDecimal>("cnt");
			Argument<Date> mandate =new Argument<Date>("mandate");
			Argument<String> msgcod =new Argument<String>("msgcod");
			Argument<String> objinr =new Argument<String>("objinr");
			Argument<Date> objtyp =new Argument<Date>("objtyp");
			Argument<String> muser =new Argument<String>("muser");

			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql +" AND t.ownref = ? ";
			  objs.add(this.getOwnref());
			}
			if(!MdaUtils.isEmpty(this.getDate()))
			{
			  sql = sql +" AND s.credat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getDate(),GT));
			}
			if(!MdaUtils.isEmpty(this.getDate1()))
			{
			  sql = sql +" AND s.credat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getDate1(),LT));
			}
			if(!MdaUtils.isEmpty(this.getMsgcod()))
			{
			  sql = sql +" AND s.msgcod = ? ";
			  objs.add(this.getMsgcod());
			}
			if(!MdaUtils.isEmpty(this.getSta()))
			{
			  sql = sql +" AND s.sta = ? ";
			  objs.add(this.getSta());
			}
			//建议交易只开放给总行单证中心人员
			String modptytyp = null;
			if("0".equals(ptytyp))
			{
			  modptytyp = "'0','1','2'";
			  sql =  this.getSysmod().getBchmod().sdbGetBranchSql(ptyinr,"t.ptyinr",sql,objs,cid);
			}

			sql=sql+" ORDER BY s.credat  DESC ";
			log.debug("{}","after query trn=="+sql);
			if(objs.size()>0)
			{
			  ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());
			}
			else
			{
			  ctx.getDaoSession().dbExecuteSQL(sql);
			}
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cnt,credat,mandate,msgcod,objinr,objtyp,sta,muser,ownref);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getSwlst().add(inr,cnt,credat,mandate,msgcod,objinr,objtyp,sta,muser,ownref);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:swmctl.@0004.script
        */
        public void selebhsnd()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getLebhsnd());

			String ptytyp=this.getSysmod().getPty().getPtytyp();
			String ptyinr=this.getSysmod().getPty().getInr();
			String usrinr = this.getSysmod().getUsr().getInr();
			String cid = this.getSysmod().getPty().getCid();

			List objs = new ArrayList();
			String sql="select s.inr inr,s.credat credat,s.msgcod msgcod,s.sta sta,s.senddate senddate,t.ownref ownref from ebhsnd s, gid t where s.objinr = t.inr";
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> sta =new Argument<String>("sta");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<Date> credat =new Argument<Date>("credat");
			Argument<Date> senddate =new Argument<Date>("senddate");
			Argument<String> msgcod =new Argument<String>("msgcod");

			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  sql = sql +" AND t.ownref = ? ";
			  objs.add(this.getOwnref());
			}

			sql=sql+" ORDER BY s.credat  DESC ";
			log.debug("{}","after query trn=="+sql);
			if(objs.size()>0)
			{
			  ctx.getDaoSession().dbExecuteSQL(sql,objs.toArray());
			}
			else
			{
			  ctx.getDaoSession().dbExecuteSQL(sql);
			}
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,credat,senddate,msgcod,sta,ownref);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getLebhsnd().add(inr,credat,senddate,msgcod,sta,ownref);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}


































}