package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SwwtskVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tatp;
import com.ceb.gjjs.mda.manager.module.Eabp;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.manager.module.Swmmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Tasgrp;
import com.ceb.gjjs.mda.manager.module.Eabgrp;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 单一窗口自动服务
*/
@Transaction(vo= SwwtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Swwtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Swwtsk.class);

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Tasgrp tasgrp;

		@BDGetter
		private Tatp tatp;

		@BDGetter
		private Eabgrp eabgrp;

		@BDGetter
		private Eabp eabp;

		@BDGetter
		private ModuleList<Trn> trnlst;

		@BDGetter
		private Rmkmod rmkmod;

		@BDGetter
		private Swmmod swmmod;


		public Swwtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0")));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getTatp().setTasgrpHolder(()->this.getTasgrp());
           this.getEabp().setEabgrpHolder(()->this.getEabgrp());
        }




        /**
        *   source:swwtsk.@0000.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  1.限制mgttsk只在一台服务器上运行，可在transaction.properties中配置服务ip
			  2.在配置文件中配置isServer判断是服务器上还是本地运行
			  3.本地测试暂时将此屏蔽掉,后面需要放开
			  */
			/**
			  //指定服务器处理后台服务
			  String proFilPth = Platform.catPath(Platform.getRootPath(),"/data/transaction.properties");
			  String isServer = Platform.getPropertyValue(proFilPth,"isServer");
			  log.debug("isServer=" + isServer);
			  if("1".equals(isServer))
			  {
			  String webserver = (String)java.lang.System.getProperty("weblogic.management.server");
			  log.info("weblogic.management.server："+webserver);
			  String workserver =Platform.getPropertyValue(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"transaction.properties"),"mgrtskworkserver");
			  if(Platform.isEmpty(workserver))
			  return;
			  if(!webserver.contains(workserver))
			  return;
			  }
			  */
			//判断是否在浮动IP的机器上执行
			Object obj = MdaUtils.invoke("com.cib.window.util.NetworkUtil","checkwork");
			if(!(boolean)obj)
			  return ;

			Thread current=Thread.currentThread();
			log.debug("{}","mgrtsk service 被执行...线程id:["+current.getId()+"]");
			MdaUtils.clear(this.getTrnlst());
			ctx.getDaoSession().dbReadset(this.getTrnlst(),new Argument<String>("sta","J"));
			for(int j=0;j<this.getTrnlst().fullSize();j++)
			{
			  MdaUtils.clear(this.getTrnmod().getTrn());
			  MdaUtils.clear(this.getTrnmod().getBnktrn());
			  MdaUtils.clear(this.getTrnmod().getOrdmod().getOrd());
			  MdaUtils.clear(this.getTrnmod().getOrdmod().getOre());
			  MdaUtils.clear(this.getTasgrp().getRec());
			  MdaUtils.clear(this.getEabgrp().getRec());
			  MdaUtils.clear(this.getEabgrp().getPtylst());
			  MdaUtils.clear(this.getSwmmod().getSwmsg());
			  // Platform.clear($swmmod\\pty);
			  // Platform.clear($swmmod\\ptr);
			  // Platform.clear($swmmod\\ptrlst);
			  // Platform.clear($sysmod\\pty);
			  Map map = new HashMap();
			  this.getTrnmod().getTrn().copyValue(this.getTrnlst().getElement(j));
			  this.getTrnmod().getBnktrn().copyValue(this.getTrnlst().getElement(j));
			  String objtyp = this.getTrnmod().getTrn().getObjtyp();
			  String objinr = this.getTrnmod().getTrn().getObjinr();
			  MdaUtils.clear(this.getTrnmod().getApldoc().getPdfdoc());
			  ctx.getDaoSession().dbRead(this.getTrnmod().getApldoc().getPdfdoc(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp));
			  /*String bchcod = $trnmod\\trn\\bchcod.getValue();
			    String bchinr = $trnmod\\trn\\optptyinr.getValue();
			    Platform.dbRead($swmmod\\pty,new Argument<String>("inr","08350000"));// 总行单证中心
			    $trnmod\\bnktrn\\bchcod.setValue("08350000");
			    */
			  log.info("{}","swwtsk i|trninr|objtyp|objinr :"+j+"|"+this.getTrnmod().getTrn().getInr()+"|"+objtyp+"|"+objinr );
			  if("tas".equals(objtyp))
			  {
			    log.info("{}","begin auto sign contracts ");
			    ctx.getDaoSession().dbRead(this.getTasgrp().getRec(),new Argument<String>("inr",objinr));
			    //报文发送成功处理业务逻辑
			    ctx.getErrorCode();
			    ctx.getDaoSession().dbBegin();
			    //更新业务表
			    this.getTasgrp().getRec().setSta("D");
			    this.getTasgrp().getRec().setHandletyp("A");
			    this.getTasgrp().getRec().setTatdate(MdaUtils.today());
			    if(MdaUtils.isEmpty(this.getTasgrp().getRec().getInr()))
			    {
			      this.getTasgrp().getRec().setInr(Platform.sdbCounter("tas"));
			      ctx.getDaoSession().dbInsert(this.getTasgrp().getRec());
			    }
			    else
			    {
			      ctx.getDaoSession().dbUpdate(this.getTasgrp().getRec());
			    }
			    //处理swinfo表
			    ctx.getDaoSession().dbRead(this.getTasgrp().getSwinfo(),new Argument<String>("cifno",this.getTasgrp().getRec().getCifno()));
			    if(MdaUtils.isEmpty(this.getTasgrp().getSwinfo().getInr()))
			    {
			      this.getTasgrp().getSwinfo().setInr(Platform.sdbCounter("swinfo"));
			      this.getTasgrp().getSwinfo().setCifno(this.getTasgrp().getRec().getCifno());
			      this.getTasgrp().getSwinfo().setQysta("1");//签约状态
			      this.getTasgrp().getSwinfo().setQydate(MdaUtils.today());
			      this.getTasgrp().getSwinfo().setQyfunctions(this.getTasgrp().getRec().getFunctionts());
			      ctx.getDaoSession().dbInsert(this.getTasgrp().getSwinfo());
			    }
			    else
			    {
			      this.getTasgrp().getSwinfo().setQysta("1");//
			      this.getTasgrp().getSwinfo().setQydate(MdaUtils.today());
			      String srfunctions = this.getTasgrp().getSwinfo().getQyfunctions();
			      if(MdaUtils.isEmpty(srfunctions))srfunctions="";
			      String newFuncions = this.getTasgrp().getRec().getFunctionts();
			      StringBuffer sb = new StringBuffer(srfunctions);
			      if(!MdaUtils.isEmpty(newFuncions))
			      {
			        String[] funarr =newFuncions.split("#");
			        for(int i=0;i<funarr.length;i++)
			        {
			          if(srfunctions.contains(funarr[i]))
			            continue;
			          if(srfunctions.endsWith("#"))
			          {
			            sb.append(funarr[i]);
			          }
			          else
			          {
			            sb.append("#"+funarr[i]);
			          }
			        }
			      }
			      this.getTasgrp().getSwinfo().setQyfunctions(sb.toString());
			      ctx.getDaoSession().dbUpdate(this.getTasgrp().getSwinfo());
			    }
			    //转历史
			    String objinr1 = this.getTatp().getTasgrp().getRec().getInr();
			    String objtyp1 = "tas";
			    ctx.absGet(Trnmod.class).goHistoryA(objinr1,objtyp1,ctx.getTransName(),this.getTatp().getTatopn());
			    //上传影像
			    /*  String cibBranchID = $sysmod\\pty\\cid.getValue().substring(0,2);
			      String cibOrgID = $sysmod\\pty\\cid.getValue().substring(2);
			      Platform.dbRead($\\trnmod\\itfmod\\imgmod\\img,new Argument("trninr",$trnmod\\trn\\inr.getValue()));
			      Boolean result=$\\trnmod\\itfmod\\imgmod.uploadImages($\\trnmod\\itfmod\\imgmod\\img\\ownref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\imgref.getValue(),$\\trnmod\\itfmod\\imgmod\\img\\guid.getValue(),cibBranchID,cibOrgID);
			      log.info("upload result= " +result);
			      if(!result)
			      {
			      log.error("上传影像错误！");
			      Platform.dbRollback();
			      continue;
			      }
			      */
			    //发送业务报文给单一窗口
			    map.put("code","SFS122");
			    this.getSysmod().setSwHeaderMap("SFS122","",map,this.getTatp().getTasgrp().getRec().getMsgref());
			    map.put("FileName",this.getTrnmod().getApldoc().getPdfdoc().getPdffilnam());
			    map.put("FileType",this.getTasgrp().getRec().getDoctyp());
			    map.put("EntName",this.getTasgrp().getRec().getEntname());
			    map.put("CifNo",this.getTasgrp().getRec().getCifno());
			    map.put("ProtocolNo",this.getTasgrp().getRec().getProtocolno());
			    map.put("Functions",this.getTasgrp().getRec().getFunctionts());
			    this.getSwmmod().storeSWM("SFS122",this.getTasgrp().getRec().getInr(),"tas",map);

			    ctx.getDaoSession().dbCommit();
			    int  errCode = ctx.getErrorCode();
			    if(errCode!= NO_ERROR)
			    {
			      log.error("{}","数据库异常，请联系管理员");
			      continue;
			    }
			    log.info("{}","提交成功!");
			    //更新国结数据库状态。TODO
			  }
			  else if("eab".equals(objtyp))
			  {
			    //新增信息
			    ctx.getErrorCode();
			    ctx.getDaoSession().dbBegin();
			    log.info("{}","begin auto custum bing ");
			    ctx.getDaoSession().dbRead(this.getEabgrp().getRec(),new Argument<String>("inr",objinr));
			    String optptyinr = this.getTrnmod().getTrn().getOptptyinr();
			    //
			    String cifno = this.getEabgrp().getRec().getIdno();
			    if(!ctx.absGet(Sysmod.class).judgeSWFunctions("user_binding",cifno,""))
			    {
			      log.info("{}","该客户尚未签约或未签约该功能，请退回该笔业务!");
			      this.getEabgrp().getRec().setResult("02");
			      this.getEabgrp().getRec().setReason("该客户未签约该功能!");
			    }
			    else
			    {
			      //报文发送成功处理业务逻辑
			      ctx.getDaoSession().dbReadset(this.getEabgrp().getPtylst(),new Argument<String>("cifno",this.getEabgrp().getRec().getIdno()),new Argument<Date>("epcdat",ISNULL));
			      if(this.getEabgrp().getPtylst().size()<=0){
			        this.getEabgrp().getRec().setHandletyp("A");
			      this.getEabgrp().getRec().setResult("02");
			      this.getEabgrp().getRec().setReason("未开通阳光E结算，请联系我行核实是否签约阳光E结算!");
			    }
			    else
			    {
			      this.getEabgrp().getRec().setCredat(MdaUtils.today());
			      this.getEabgrp().getRec().setHandletyp("A");
			      this.getEabgrp().getRec().setResult("01");
			      if(MdaUtils.isEmpty(this.getEabgrp().getRec().getInr()))
			      {
			        this.getEabgrp().getRec().setInr(Platform.sdbCounter("eab"));
			        ctx.getDaoSession().dbInsert(this.getEabgrp().getRec());
			      }
			      else
			      {
			        ctx.getDaoSession().dbUpdate(this.getEabgrp().getRec());
			      }
			      //更新swinfo,不应出现没有swinfo的情况。
			      ctx.getDaoSession().dbRead(this.getEabgrp().getSwinfo(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));
			      ctx.getDaoSession().dbRead(this.getEabgrp().getPty(),new Argument<String>("cifno",EQ,this.getEabgrp().getRec().getIdno()));

			      this.getEabgrp().getSwinfo().setCid(this.getEabgrp().getPty().getCid());
			      this.getEabgrp().getSwinfo().setBdsta("1");
			      this.getEabgrp().getSwinfo().setBddate(MdaUtils.today());
			      this.getEabgrp().getSwinfo().setEsta("1");
			      this.getEabgrp().getSwinfo().setEdate(this.getEabgrp().getPty().getEpodat());
			      this.getEabgrp().getSwinfo().setCidptyinr(this.getEabgrp().getPty().getInr());
			      ctx.getDaoSession().dbUpdate(this.getEabgrp().getSwinfo());
			      //更新默认归属机构
			      MdaUtils.clear(this.getSwmmod().getPtr());
			      MdaUtils.clear(this.getSwmmod().getPtrlst());
			      ctx.getDaoSession().dbReadset(this.getSwmmod().getPtrlst(),new Argument<String>("preptyinr",this.getEabgrp().getPty().getInr()));
			      for(int i = 0; i < this.getSwmmod().getPtrlst().size(); i++)
			      {
			        if(optptyinr.equals(this.getSwmmod().getPtrlst().getElement(i).getNxtptyinr()))
			          this.getSwmmod().getPtrlst().getElement(i).setIssinglew("1");
			        else
			          this.getSwmmod().getPtrlst().getElement(i).setIssinglew("2");
			        ctx.getDaoSession().dbUpdate(this.getSwmmod().getPtrlst().getElement(i));
			      }
			    }
			  }

			  //Platform.dbRead($swmmod\\ptr,new Argument<String>("ptrtyp","0"),new Argument<String>("preptyinr",$eabgrp\\pty\\inr.getValue()),new Argument<String>("nxtptyinr",optptyinr));
			  // $swmmod\\ptr\\issinglew.setValue("1");
			  //Platform.dbUpdate($swmmod\\ptr);
			  String objinr2 = this.getEabgrp().getRec().getInr();
			  String objtyp2 = "eab";
			  this.getTrnmod().goHistoryA(objinr2,objtyp2,ctx.getTransName(),this.getEabp().getMainp());
			  map = new HashMap();
			  map.put("CusId",this.getEabgrp().getRec().getCusid());
			  map.put("Result",this.getEabgrp().getRec().getResult());
			  map.put("Reason",this.getEabgrp().getRec().getReason());
			  ctx.absGet(Sysmod.class).setSwHeaderMap("SFS102","",map,this.getEabgrp().getRec().getMsgref());
			  this.getSwmmod().storeSWM("SFS102",this.getEabgrp().getRec().getInr(),"eab",map);
			  ctx.getDaoSession().dbCommit();
			  int errCode1 = ctx.getErrorCode();
			  if(errCode1!= NO_ERROR)
			  {
			    log.error("{}","数据库异常，请联系管理员");
			    continue;
			  }
			  log.info("{}","绑定成功！");
			}
			}
			state.sleep();
			log.debug("{}","mgrtsk service 退出...线程id:["+current.getId()+"]");
		}










}