package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SysdbaVO;

import com.ceb.gjjs.mda.bo.Bcd;
import com.ceb.gjjs.mda.bo.Gid;
import com.ceb.gjjs.mda.bo.Gib;
import com.ceb.gjjs.mda.manager.module.Gidcxm;
import com.ceb.gjjs.mda.bo.Jsd;
import com.ceb.gjjs.mda.bo.Usrrol;
import com.ceb.gjjs.mda.bo.Bod;
import com.ceb.gjjs.mda.bo.Fsd;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Usrsig;
import com.ceb.gjjs.mda.bo.Git;
import com.ceb.gjjs.mda.bo.Dxd;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.bo.Rolpro;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Fcd;
import com.ceb.gjjs.mda.bo.Usraut;
import com.ceb.gjjs.mda.bo.Eab;
import com.ceb.gjjs.mda.bo.Ptyaut;
import com.ceb.gjjs.mda.bo.Stb;
import com.ceb.gjjs.mda.bo.Xptsam;
import com.ceb.gjjs.mda.bo.Xptinf;
import com.ceb.gjjs.mda.bo.Etg;
import com.ceb.gjjs.mda.bo.Cpd;
import com.ceb.gjjs.mda.bo.Lit;
import com.ceb.gjjs.mda.bo.Xptqna;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Currat;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Cty;
import com.ceb.gjjs.mda.bo.Sth;
import com.ceb.gjjs.mda.bo.Wft;
import com.ceb.gjjs.mda.bo.Fzgit;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.bo.Dztlog;
import com.ceb.gjjs.mda.bo.Bed;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.bo.Bilmdl;
import com.ceb.gjjs.mda.bo.Did;
import com.ceb.gjjs.mda.bo.Busmdl;
import com.ceb.gjjs.mda.bo.Wfe;
import com.ceb.gjjs.mda.bo.Apd;
import com.ceb.gjjs.mda.bo.Brd;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Sgd;
import com.ceb.gjjs.mda.bo.Dep;
import com.ceb.gjjs.mda.bo.Dit;
import com.ceb.gjjs.mda.bo.Lad;
import com.ceb.gjjs.mda.bo.Modlst;
import com.ceb.gjjs.mda.bo.Led;
import com.ceb.gjjs.mda.bo.Apyctm;
import com.ceb.gjjs.mda.bo.Lid;
import com.ceb.gjjs.mda.bo.Xptfaq;
import com.ceb.gjjs.mda.bo.Ore;
import com.ceb.gjjs.mda.bo.Ord;
import com.ceb.gjjs.mda.bo.Mat;
import com.ceb.gjjs.mda.bo.Afd;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.bo.Fpd;
import com.ceb.gjjs.mda.bo.Bpd;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Wfd;
import com.ceb.gjjs.mda.bo.Ptyref;
import com.ceb.gjjs.mda.bo.Wrn;
import com.ceb.gjjs.mda.bo.Pts;
import com.ceb.gjjs.mda.bo.Ptr;
import com.ceb.gjjs.mda.bo.Ers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 数据表索引
*/
@Transaction(vo= SysdbaVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sysdba extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Sysdba.class);

		@BDGetter
		private Adr adr;

		@BDGetter
		private Apd apd;

		@BDGetter
		private Apyctm apyctm;

		@BDGetter
		private Afd afd;

		@BDGetter
		private Bcd bcd;

		@BDGetter
		private Bed bed;

		@BDGetter
		private Bilmdl bilmdl;

		@BDGetter
		private Bod bod;

		@BDGetter
		private Bpd bpd;

		@BDGetter
		private Brd brd;

		@BDGetter
		private Busmdl busmdl;

		@BDGetter
		private Cls cls;

		@BDGetter
		private Cpd cpd;

		@BDGetter
		private Cty cty;

		@BDGetter
		private Currat currat;

		@BDGetter
		private Dep dep;

		@BDGetter
		private Etg etg;

		@BDGetter
		private Ety ety;

		@BDGetter
		private Fcd fcd;

		@BDGetter
		private Fsd fsd;

		@BDGetter
		private Gid gid;

		@BDGetter
		private Git git;

		@BDGetter
		private Led led;

		@BDGetter
		private Lid lid;

		@BDGetter
		private Lit lit;

		@BDGetter
		private Modlst modlst;

		@BDGetter
		private Msg msg;

		@BDGetter
		private Ord ord;

		@BDGetter
		private Ore ore;

		@BDGetter
		private Pta pta;

		@BDGetter
		private Pts pts;

		@BDGetter
		private Ptr ptr;

		@BDGetter
		private Pty pty;

		@BDGetter
		private Ptyaut ptyaut;

		@BDGetter
		private Ptyref ptyref;

		@BDGetter
		private Rol rol;

		@BDGetter
		private Rolpro rolpro;

		@BDGetter
		private Sgd sgd;

		@BDGetter
		private Smh smh;

		@BDGetter
		private Spt spt;

		@BDGetter
		private Stb stb;

		@BDGetter
		private Sth sth;

		@BDGetter
		private Trn trn;

		@BDGetter
		private Usr usr;

		@BDGetter
		private Usraut usraut;

		@BDGetter
		private Usrrol usrrol;

		@BDGetter
		private Usrsig usrsig;

		@BDGetter
		private Wfd wfd;

		@BDGetter
		private Wfe wfe;

		@BDGetter
		private Wfs wfs;

		@BDGetter
		private Wft wft;

		@BDGetter
		private Xptfaq xptfaq;

		@BDGetter
		private Xptinf xptinf;

		@BDGetter
		private Xptqna xptqna;

		@BDGetter
		private Xptsam xptsam;

		@BDGetter
		private Did did;

		@BDGetter
		private Dit dit;

		@BDGetter
		private Fpd fpd;

		@BDGetter
		private Gib gib;

		@BDGetter
		private Gidcxm gidcxm;

		@BDGetter
		private Wrn wrn;

		@BDGetter
		private Lad lad;

		@BDGetter
		private Mat mat;

		@BDGetter
		private Dxd dxd;

		@BDGetter
		private Dztlog dztlog;

		@BDGetter
		private Eab eab;

		@BDGetter
		private Ers ers;

		@BDGetter
		private Jsd jsd;

		@BDGetter
		private Fzgit fzgit;


		public Sysdba()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }










































































}