package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.SysixuVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Sysfil;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 系统管理-远程文件管理
*/
@Transaction(vo= SysixuVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sysixu extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Sysixu.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Sysfil sysfil1;


		public Sysixu()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sysixu.@0000.script
        */
        @Rule(target="sysfil1.delete",order=100)
        public boolean ruleSysfil1DeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			//获取备份目录
			String custom = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/sysixu.properties");
			String backup = MdaUtils.getPropertyValue(custom,"3.value");
			log.info("{}","backup ="+backup);
			//删除选中的文件
			List<String> filList = new ArrayList<String>();
			for(int i = 0; i < this.getSysfil1().getFillst().size(); i ++)
			{
			  if("X".equals(this.getSysfil1().getFillst().getElement(i).getFlg()))
			  {
			    filList.add(this.getSysfil1().getFillst().getElement(i).getAbspth());
			  }
			}
			if(filList.isEmpty())
			  return true;
			if(MdaUtils.prompt(MdaUtils.getI18NString("sysixu","CT000008"),MdaUtils.getI18NString("sysixu","CT000009")))
			  return false;
			for(int j=0;j<filList.size();j++)
			{
			  String filnam=filList.get(j);
			  log.info("{}","filename ="+filnam);
			  if(MdaUtils.fileMove(filnam,backup))
			  {
			    continue;
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sysixu","CT000010"),MdaUtils.getI18NString("sysixu","CT000011"));
			    break;
			  }
			}


			return true;
        }

        /**
        *   source:sysixu.@0001.script
        */
        @Rule(target="sysfil1.ok",order=100)
        public boolean ruleSysfil1OkN100(){
            IContext ctx = MdaEnv.getContext();
            
			int idx = 0;
			if(idx<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("sysixu","CT000012"),MdaUtils.getI18NString("sysixu","CT000013"));
			  return false;
			}
			this.getSysfil1().setFilpth( this.getSysfil1().getCfglst().getElement(idx).getVal());
			
			
			ctx.postRule(this,"sysfil1.opn");

			return true;
        }

        /**
        *   source:sysixu.@0002.script
        */
        @Rule(target="sysfil1.rtn1",order=100)
        public boolean ruleSysfil1Rtn1N100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:sysixu.@0003.script
        */
        @Rule(target="sysfil1.sel",order=100)
        public boolean ruleSysfil1SelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//查询默认路径
			String custom = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/sysixu.properties");
			List<String> tmplst =this.getSysfil1().getPropertiesWithCon("path","",true);
			this.getSysfil1().getCfglst().removeAll();
			for (int i=0;i<tmplst.size();i++ )
			{
			  this.getSysfil1().getCfglst().add();
			  this.getSysfil1().getCfglst().getElement(i).setRemark( "默认路径：");
			  this.getSysfil1().getCfglst().getElement(i).setVal( tmplst.get(i).toString());
			}

			
			

			return true;
        }



        /**
        *   source:sysixu.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysfil1().setFilpth(ctx.getEnvConfig().getRootPath());

			return true;
        }





}