package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.TrsadvVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 转通知交易
*/
@Transaction(vo= TrsadvVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trsadv extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Trsadv.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;

		@BDGetter
		private ModuleList<Spt> advlst;


		public Trsadv()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:trsadv.@0001.script
        */
        @Rule(target="btnmod.show",order=0)
        public boolean ruleBtnmodShowN0(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			if(index!=-1)
			{
			  // Platform.copyFromList($sptlst,$sysmod\\spt,index);
			  this.getSysmod().getSpt().copyValue(this.getAdvlst().get(index));
			  //Platform.dbLock(name,text);
			  String frm=this.getSysmod().getSpt().getFrm();
			  String inr=this.getSysmod().getSpt().getInr();
			  log.info("{}","your inr="+inr);
			  if(MdaUtils.isEmpty(frm))
			  {
			    log.info("{}","wrong!!!!");
			  }
			  //String filename=$sysmod\\spt\\inr.getValue()+".bak";
			  //String path=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"delete");
			  //filename=Platform.catPath(path,filename);
			  String filename=this.getSysmod().createFilename(this.getSysmod().getSpt().getInr(),"bak");
			  log.info("{}",filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    //show the data in db
			    ctx.setMessage("",MdaUtils.getI18NString("trsadv","CT000007"));
			    return true;
			  }
			  //Platform.clear($sptlst);
			  //Platform.storeData("sysmod",$sysmod);
			  
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("trsadv","CT000008"));
			}

			return true;
        }



        /**
        *   source:trsadv.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getAdvlst());
			//$sysmod.updateSptList("T","A");
			String ptyinr=this.getSysmod().getPty().getInr();
			ctx.getDaoSession().dbReadset(this.getAdvlst(),new Argument<String>("oprogninr",ptyinr),new Argument<String>("scr","A"),new Argument<String>("sta","T"));
			log.info("{}","list size="+this.getAdvlst().fullSize());
			

			return true;
        }






}