package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.WfddefVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.bo.Wfd;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 工序定义
*/
@Transaction(vo= WfddefVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Wfddef extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Wfddef.class);

        //提交
        private transient IControl submit = new ControlImpl("submit", "提交", this);
        //重置
        private transient IControl reset = new ControlImpl("reset", "重置", this);
		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Wfd wfd;

		@BDGetter
		private Ety ety;

		@BDGetter
		private ModuleList<Wfd> wfdlst;


		public Wfddef()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
        }

        /**
        *   source:wfddef.@0001.script
        */
        @Rule(target="submit",order=0)
        public boolean ruleSubmitN0(){
            IContext ctx = MdaEnv.getContext();
            
			 String inr=this.getTrnmod().getInr("wfd");
			 this.getWfd().setInr(inr);
			 ctx.getDaoSession().dbInsert(this.getWfd());

			return true;
        }

        /**
        *   source:wfddef.@0002.script
        */
        @Rule(target="reset",order=100)
        public boolean ruleResetN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }



        /**
        *   source:wfddef.@0000.script
        */
        @Init(order=0)
        public boolean	init0(){
            IContext ctx = MdaEnv.getContext();
            
			//#CT000010
			String ptytyp=this.getSysmod().getPty().getPtytyp();
			if("0".equals(ptytyp))
			{
			}
			if("1".equals(ptytyp)) 
			{
			  this.getWfd().setObjtyp("ety");
			  this.getWfd().setNam("all");
			  
			}

			return true;
        }










}