package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.WitameVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Witp;
import com.ceb.gjjs.mda.manager.module.Widgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* Unnamed transaction
*/
@Transaction(vo= WitameVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Witame extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Witame.class);

		@BDGetter
		private Widgrp widgrp;

		@BDGetter
		private Witp witp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Witame()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getWitp().setWidgrpHolder(()->this.getWidgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("WI"));
           this.getMtabut().setRecHolder(()->this.getWidgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.cur");}
 				public void setValue(String arg){Witame.this.getWidgrp().getRec().setCur(arg);}
 				public String getValue(){return Witame.this.getWidgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("witp.widgrp.rec.ownref");}
 				public void setValue(String arg){Witame.this.getWitp().getWidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Witame.this.getWitp().getWidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.bchcod");}
 				public void setValue(String arg){Witame.this.getWidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Witame.this.getWidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.stlref");}
 				public void setValue(String arg){Witame.this.getWidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Witame.this.getWidgrp().getRec().getStlref();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.inr");}
 				public void setValue(String arg){Witame.this.getWidgrp().getRec().setInr(arg);}
 				public String getValue(){return Witame.this.getWidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.ptyinr");}
 				public void setValue(String arg){Witame.this.getWidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Witame.this.getWidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Witame.this.getFieldPath("widgrp.rec.qqfamt");}
 				public void setValue(BigDecimal arg){Witame.this.getWidgrp().getRec().setQqfamt(arg);}
 				public BigDecimal getValue(){return Witame.this.getWidgrp().getRec().getQqfamt();}}
			 );
        }

        /**
        *   source:witame.@0002.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","bchcod Value===="+this.getWidgrp().getRec().getBchcod());
			if(!ctx.checkAll(this.getWidgrp()))
			  return false;
			if(!this.checkLst())
			{
			  ctx.setMessage(MdaUtils.getI18NString("witame","CT000014"),MdaUtils.getI18NString("witame","CT000015"));
			  return false;
			}

			if("0".equals(this.getWidgrp().getRec().getQqywlx())&&!this.checkxq())
			{
			  ctx.setMessage(MdaUtils.getI18NString("witame","CT000041"),MdaUtils.getI18NString("witame","CT000042"));
			  return false;
			}

			this.dealPdf();
			this.getWidgrp().getRec().setZxdate(this.getWidgrp().getZxdate());
			if(!MdaUtils.isEmpty(this.getWidgrp().getSfcejg1()))
			  this.getWidgrp().getRec().setSfcejg(this.getWidgrp().getSfcejg1());
			log.info("{}","入库交割方式  是否差额交割:" + this.getWidgrp().getRec().getSfcejg());
			this.getWidgrp().getRec().setCnyacc(this.getWidgrp().getCnyacc());
			this.getWidgrp().getRec().setCnybacc(this.getWidgrp().getCnybacc());
			this.getWidgrp().getRec().setFxacc(this.getWidgrp().getFxacc());
			this.getWidgrp().getRec().setFxbacc(this.getWidgrp().getFxbacc());
			this.getWidgrp().getRec().setSta("0");
			ctx.getDaoSession().dbUpdate(this.getWidgrp().getRec());

			if("0".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    this.getWidgrp().getWic().setInr(this.getWidgrp().getWiclst().getElement(0).getInr());
			    this.getWidgrp().getWic().setObjinr(this.getWidgrp().getRec().getInr());
			    this.getWidgrp().getWic().setObjtyp("wid");
			    this.getWidgrp().getWic().setJyfx(this.getWidgrp().getWiclst().getElement(i).getJyfx());
			    this.getWidgrp().getWic().setQqfx(this.getWidgrp().getWiclst().getElement(i).getQqfx());
			    this.getWidgrp().getWic().setJshfx(this.getWidgrp().getWiclst().getElement(i).getJshfx());
			    this.getWidgrp().getWic().setAmt(this.getWidgrp().getWiclst().getElement(i).getAmt());
			    this.getWidgrp().getWic().setZxamt(this.getWidgrp().getWiclst().getElement(i).getZxamt());
			    this.getWidgrp().getWic().setModflg("0");
			    this.getWidgrp().getWic().setSfxq(this.getWidgrp().getWiclst().getElement(0).getSfxq());
			    //$widgrp\\wic\\modflg.setValue("0");
			    ctx.getDaoSession().dbUpdate(this.getWidgrp().getWic());
			  }
			}

			if(!this.getTrnmod().trnSetFromContract()) return false;
			//String filename="/data/dsp/"+$trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.getRootPath(),filename);
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}", "sav200结束================" );

			return true;
        }

        /**
        *   source:witame.@0004.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "";
			String tempfiles = "";

			//判断业务类型，出示对应的申请书
			if("0".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  labels = "期权行权申请书";
			  tempfiles = "A:witame1";
			}
			else if("1".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  if(3 == this.getWidgrp().getWiclst().size())
			  {
			    labels = "期权平仓申请书";
			    tempfiles = "A:witame21";
			  }
			  else
			  {
			    labels = "期权平仓申请书";
			    tempfiles = "A:witame2";
			  }

			}
			else if("4".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  if(3 == this.getWidgrp().getWiclst().size())
			  {
			    labels = "期权交割方式修改申请书";
			    tempfiles = "A:witame31";
			  }
			  else
			  {
			    labels = "期权交割方式修改申请书";
			    tempfiles = "A:witame3";
			  }
			}
			else
			{
			  cnt = 0;
			  labels = "";
			  tempfiles = "";
			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:witame.@0005.script
        */
        @Rule(target="witp.widgrp.rec.qqywlx",order=100)
        public boolean ruleWitpWidgrpRecQqywlxN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("0".equals(this.getWidgrp().getRec().getQqywlx())&&"1".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  
			  this.getWidgrp().setZxdate(this.getWidgrp().getRec().getZxdate());
			}
			else
			{
			  
			  this.getWidgrp().setZxdate(this.getWidgrp().getRec().getZxdate());
			}
			

			//修改交割方式
			if("4".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  if("0".equals(this.getWidgrp().getSfcejg3()))
			  {
			    this.getWidgrp().setSfcejg1("1");
			    //Platform.error($widgrp\\sfcejg,#CT000001);
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg1("0");
			    //Platform.error($widgrp\\sfcejg,#CT000004);
			  }

			  this.getWidgrp().setCnyacc(this.getWidgrp().getRec().getCnyacc());
			  this.getWidgrp().setCnybacc(this.getWidgrp().getRec().getCnybacc());
			  this.getWidgrp().setFxacc(this.getWidgrp().getRec().getFxacc());
			  this.getWidgrp().setFxbacc(this.getWidgrp().getRec().getFxbacc());
			  
			  
			  
			  
			}
			else
			{
			  this.getWidgrp().setSfcejg1(this.getWidgrp().getSfcejg3());
			  
			  
			  
			  
			}
			
			
			
			
			

			if("2".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  ctx.setFieldError(this,"widgrp.rec.qqywlx",MdaUtils.getI18NString("witame","CT000008"));
			  this.getWidgrp().getRec().setQqywlx(NULLSTR);
			  
			}

			if("3".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  ctx.setFieldError(this,"widgrp.rec.qqywlx",MdaUtils.getI18NString("witame","CT000010"));
			  this.getWidgrp().getRec().setQqywlx(NULLSTR);
			  
			}

			//记录是否有买入期权
			boolean bool = false;
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    bool = true;
			  }
			}
			if("0".equals(this.getWidgrp().getRec().getQqywlx())&&!bool)
			{
			  ctx.setFieldError(this,"widgrp.rec.qqywlx",MdaUtils.getI18NString("witame","CT000011"));
			  this.getWidgrp().getRec().setQqywlx(NULLSTR);
			  
			}


			return true;
        }

        /**
        *   source:witame.@0006.script
        */
        @Rule(target="witp.widgrp.check",order=100)
        public boolean ruleWitpWidgrpCheckN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!this.checkLst())
			{
			  ctx.setFieldError(this,"widgrp.check","行权时，期权业务至少一条为行权");
			  return false;
			}

			return true;
        }

        /**
        *   source:witame.@0007.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.dealPdf();

			//判断业务类型，出示对应的申请书
			if("0".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  this.getWitp().getPdfviw().callPDFComponent("","witame1","期权行权申请书",1);
			}
			else if("1".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  if(3 == this.getWidgrp().getWiclst().size())
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witame21","期权平仓申请书",1);
			  }
			  else
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witame2","期权平仓申请书",1);
			  }

			}
			else if("4".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  if(3 == this.getWidgrp().getWiclst().size())
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witame31","期权交割方式修改申请书",1);
			  }
			  else
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witame3","期权交割方式修改申请书",1);
			  }
			}
			else
			{
			  ctx.setFieldError(this,"mtabut.apldocs",MdaUtils.getI18NString("witame","CT000002"));
			}


			return true;
        }

        /**
        *   source:witame.@0012.script
        */
        @Rule(target="witp.tukmod.pdfviw.agree",order=100)
        public boolean ruleWitpTukmodPdfviwAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getWitp().getTukmod().getPdfviw().getChk()))
			{
			  this.getWitp().getStpmod().nextStep();
			  this.getWitp().getStpmod().setStepBtnSta();
			}
			else
			{
			  ctx.setFieldError(this,"witp.tukmod.pdfviw.agree",MdaUtils.getI18NString("witame","CT000013"));
			}

			return true;
        }

        /**
        *   source:witame.@0013.script
        */
        @Rule(target="witp.tukmod.pdfviw.cancel",order=100)
        public boolean ruleWitpTukmodPdfviwCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:witame.@0014.script
        */
        @Rule(target="witp.widgrp.zxdate",order=100)
        public boolean ruleWitpWidgrpZxdateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getWidgrp().setDate1(this.getWidgrp().getRec().getZxdate());
			this.getWidgrp().setDate1(MdaUtils.add(this.getWidgrp().getDate1(),DATE_DAY,2));
			this.getWidgrp().setDate2(MdaUtils.add(this.getWidgrp().getRec().getZxdate(),DATE_DAY,-1));

			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZxdate()) && !MdaUtils.isEmpty(this.getWidgrp().getZxdate()) && (MdaUtils.diff(this.getWidgrp().getZxdate(),this.getWidgrp().getDate2())>0))
			{
			  log.info("{}","修改后的执行日期不得超过："+this.getWidgrp().getDate1());
			  if(MdaUtils.diff(this.getWidgrp().getZxdate(),this.getWidgrp().getDate1())>0)
			  {
			    //Platform.clear($widgrp\\zxdate);
			    
			    ctx.setFieldError(this,"widgrp.zxdate",MdaUtils.getI18NString("witame","CT000029"));
			  }
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZxdate()) && !MdaUtils.isEmpty(this.getWidgrp().getZxdate()))
			  {
			    this.getWidgrp().setZxdate(null);
			    
			    ctx.setFieldError(this,"widgrp.zxdate",MdaUtils.getI18NString("witame","CT000030"));
			  }
			}

			/*
			  SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			  Calendar c = Calendar.getInstance();
			  if(!Platform.isEmpty($widgrp\\rec\\zxdate) && !Platform.isEmpty($widgrp\\zxdate) && !(Platform.diff($widgrp\\zxdate.getValue(),$widgrp\\rec\\zxdate.getValue())<0))
			  {
			  c.setTime($widgrp\\rec\\zxdate.getValue());
			  c.add(Calendar.Date,15);
			  Date d = c.getTime();
			  if(Platform.diff($widgrp\\zxdate.getValue(),d)>0)
			  {
			  Platform.error($widgrp\\zxdate,#CT000035);
			  }
			  }
			  else
			  {
			  if(!Platform.isEmpty($widgrp\\rec\\zxdate) && !Platform.isEmpty($widgrp\\zxdate))
			  {
			  Platform.error($widgrp\\zxdate,#CT000036);
			  }
			  }
			  */

			return true;
        }



        /**
        *   source:witame.@0000.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","witame  init业务处理开始，ORDER编号:90");
			//0、期权声明   1、期权修改
			this.getWitp().getStpmod().storePanel(this.getWitp().getWitopn04(),this.getWitp().getWitame01());
			this.dealStpmod();

			return true;
        }

        /**
        *   source:witame.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","witame  init业务处理开始，ORDER编号:200");

			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			if(!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  IModule wid = (IModule)ctx.restoreData("com.brilliance.witame.ref");
			  if(!MdaUtils.isEmpty(wid))
			    this.getWidgrp().getRec().copyValue(wid);
			  log.info("{}","widinr = " + this.getWidgrp().getRec().getInr());
			  ctx.getDaoSession().dbReadset(this.getWidgrp().getWiclst(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()),new Argument<String>("modflg","0"));
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    this.getWidgrp().getWiclst().getElement(i).setNo(""+i);
			    this.getWidgrp().getWiclst().getElement(i).setModflg("");
			  }
			  

			  if("4".equals(this.getWidgrp().getRec().getQqywlx()))
			  {
			    if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			    {
			      this.getWidgrp().setSfcejg1("1");

			    }
			    else
			    {
			      this.getWidgrp().setSfcejg1("0");
			    }
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg1(this.getWidgrp().getRec().getSfcejg());
			  }
			  this.getWidgrp().setSfcejg3(this.getWidgrp().getRec().getSfcejg());
			  
			  

			  ctx.getDaoSession().dbRead(this.getWidgrp().getApl().getPts(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()),new Argument<String>("objtyp","wid"),new Argument<String>("rol","apl"));
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  ctx.postRule(this,"widgrp.rec.qqywlx");

			  //交割方式
			  if("4".equals(this.getWidgrp().getRec().getQqywlx()))
			  {
			    if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			    {
			      this.getWidgrp().setSfcejg3("1");

			    }
			    else
			    {
			      this.getWidgrp().setSfcejg3("0");
			    }
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg3(this.getWidgrp().getRec().getSfcejg());
			  }
			  this.getWidgrp().setSfcejg1(this.getWidgrp().getRec().getSfcejg());
			  
			  
			}

			//初始化机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getWidgrp().getRec(),"bchcod",bchcod);
			if(MdaUtils.isEmpty(this.getWidgrp().getRec().getBchcod())&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getWidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			}

			String time =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getWidgrp().getRec().setAmedat(MdaUtils.parseDate(time,"yyyyMMdd"));
			
			
			
			
			
			
			
			
			
			
			this.getWidgrp().setZxdate(this.getWidgrp().getRec().getZxdate());
			this.getWidgrp().setCnyacc(this.getWidgrp().getRec().getCnyacc());
			this.getWidgrp().setCnybacc(this.getWidgrp().getRec().getCnybacc());
			this.getWidgrp().setFxacc(this.getWidgrp().getRec().getFxacc());
			this.getWidgrp().setFxbacc(this.getWidgrp().getRec().getFxbacc());
			this.getWidgrp().getApl().getPty().setNam(ctx.absGet(Sysmod.class).getPty().getNam());

			/*
			  Platform.setModified($widgrp\\rec\\amedat);
			  Platform.setModified($widgrp\\zxdate);
			  Platform.setModified($widgrp\\sfcejg);
			  Platform.setModified($widgrp\\cnyacc);
			  Platform.setModified($widgrp\\cnybacc);
			  Platform.setModified($widgrp\\fxacc);
			  Platform.setModified($widgrp\\fxbacc);
			  */

			return true;
        }


        /**
        *   source:witame.@0003.script
        */
        public boolean checkLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("0".equals(this.getWidgrp().getRec().getQqywlx()))
			{
			  boolean xqbool = false;
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getSfxq()))
			    {
			      xqbool = true;
			    }
			  }
			  if(!xqbool)
			  {
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:witame.@0008.script
        */
        public void dealStpmod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String steps = "0:期权声明;1:期权签约";

			this.getWitp().getStpmod().setPages(steps);
			this.getWitp().getStpmod().calcSteps();
			this.getWitp().getStpmod().setStepBtnSta();
		}
        /**
        *   source:witame.@0009.script
        */
        public void dealPdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.dealPdfWiclst();

			//保证金账户（但不限于保证金账户）
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnybacc()))
			{
			  this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getCnybacc());
			}
			else if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getFxbacc()))
			{
			  this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getFxbacc());
			}
			else if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnyacc()))
			{
			  this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getCnyacc());
			}
			else
			{
			  this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getFxacc());
			}

			//交割方式       sfcejg1(界面现交割方式)sfcejg（pdf现交割方式）rec\\sfcejg(界面原交割方式)sfcejg2（申请书原交割方式）
			if("0".equals(this.getWidgrp().getSfcejg1()))
			{
			  this.getWidgrp().setSfcejg("1");
			}
			else if("1".equals(this.getWidgrp().getSfcejg1()))
			{
			  this.getWidgrp().setSfcejg("2");
			}
			else
			{
			  this.getWidgrp().setSfcejg("");
			}
			

			if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  this.getWidgrp().setSfcejg2("1");
			}
			else if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  this.getWidgrp().setSfcejg2("2");
			}
			else
			{
			  this.getWidgrp().setSfcejg2("");
			}
			

			//期权行权金额
			boolean bool = false;
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx())&&"0".equals(this.getWidgrp().getWiclst().getElement(i).getSfxq()))
			  {
			    this.getWidgrp().setXqamt(this.getWidgrp().getWiclst().getElement(i).getAmt());
			    this.getWidgrp().setZxamt(this.getWidgrp().getWiclst().getElement(i).getZxamt().toString());
			    this.getWidgrp().setSfxqpdf("1");
			    bool = true;
			  }
			}
			if(!bool)
			{
			  this.getWidgrp().setXqamt(new BigDecimal(0));
			  this.getWidgrp().setSfxqpdf("2");
			}
			

			//处理期权多条记录日期的显示
			if(this.getWidgrp().getWiclst().size() > 1)
			{
			  this.getWidgrp().setDate2(this.getWidgrp().getRec().getZxdate());
			}
			else
			{
			  this.getWidgrp().setDate2(null);
			}
			this.getWidgrp().setDate1(this.getWidgrp().getRec().getZxdate());

		}
        /**
        *   source:witame.@0010.script
        */
        public void dealPdfWiclst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWidgrp().setJyfx1(NULLSTR);
			this.getWidgrp().setJyfx2(NULLSTR);
			this.getWidgrp().setQqfx1(NULLSTR);
			this.getWidgrp().setQqfx2(NULLSTR);
			this.getWidgrp().setCur(NULLSTR);
			this.getWidgrp().setAmt(NULLSTR);
			this.getWidgrp().setZxamt(NULLSTR);
			this.getWidgrp().setDxjej(NULLSTR);
			this.getWidgrp().setSfxq(NULLSTR);

			int len = this.getWidgrp().getWiclst().fullSize();
			StringBuffer jyfx1=new StringBuffer();
			StringBuffer jyfx2=new StringBuffer();
			StringBuffer qqfx1=new StringBuffer();
			StringBuffer qqfx2=new StringBuffer();
			StringBuffer cur=new StringBuffer();
			StringBuffer amt=new StringBuffer();
			StringBuffer zxamt=new StringBuffer();
			StringBuffer dxjej=new StringBuffer();
			StringBuffer sfxq=new StringBuffer();
			String conn="";
			String cc = null;
			BigDecimal bd = null;
			for(int i=0;i<len;i++)
			{
			  //交易方向
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    cc="√";
			    jyfx1.append(conn).append(cc);
			    cc="";
			    jyfx2.append(conn).append(cc);
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    cc="";
			    jyfx1.append(conn).append(cc);
			    cc="√";
			    jyfx2.append(conn).append(cc);
			  }
			  else
			  {
			    cc="";
			    jyfx1.append(conn).append(cc);
			    jyfx2.append(conn).append(cc);
			  }

			  //期权方向
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			  {
			    cc="√";
			    qqfx1.append(conn).append(cc);
			    cc="";
			    qqfx2.append(conn).append(cc);
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			  {
			    cc="";
			    qqfx1.append(conn).append(cc);
			    cc="√";
			    qqfx2.append(conn).append(cc);
			  }
			  else
			  {
			    cc="";
			    qqfx1.append(conn).append(cc);
			    qqfx2.append(conn).append(cc);
			  }

			  //币种
			  cur.append(conn).append(this.getWidgrp().getRec().getCur().toString());

			  //交易金额
			  bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			  log.debug("{}","amt:"+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    amt.append(conn).append("");
			  else
			    amt.append(conn).append(bd.setScale(2,BigDecimal.ROUND_HALF_UP));

			  //执行价格
			  bd = this.getWidgrp().getWiclst().getElement(i).getZxamt();
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			  {
			    zxamt.append(conn).append("");
			  }
			  else
			  {
			    zxamt.append(conn).append(bd);
			  }

			  //大写金额
			  bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			  if(!(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)&&!MdaUtils.isEmpty(this.getWidgrp().getRec().getCur()))
			  {
			    cc = this.deslCovEnAmt(this.getWidgrp().getWiclst().getElement(i).getAmt(),this.getWidgrp().getRec().getCur());
			    dxjej.append(conn).append(cc);
			  }
			  else
			  {
			    cc = "";
			    dxjej.append(conn).append(cc);
			  }

			  //是否行权
			  cc = this.getWidgrp().getWiclst().getElement(i).getSfxq();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  sfxq.append(conn).append(cc);

			  conn = ",";
			}
			// log.info("atcnum:"+atcnum);
			// log.info("atccur:"+atccur);
			// log.info("atcamt:"+atcamt);
			// log.info("chkcur:"+chkcur);
			// log.info("chkamt:"+chkamt);
			this.getWidgrp().setJyfx1(jyfx1.toString());
			this.getWidgrp().setJyfx2(jyfx2.toString());
			this.getWidgrp().setQqfx1(qqfx1.toString());
			this.getWidgrp().setQqfx2(qqfx2.toString());
			this.getWidgrp().setCur(cur.toString());
			this.getWidgrp().setAmt(amt.toString());
			this.getWidgrp().setZxamt(zxamt.toString());
			this.getWidgrp().setDxjej(dxjej.toString());
			this.getWidgrp().setSfxq(sfxq.toString());
		}
        /**
        *   source:witame.@0011.script
        */
        public String deslCovEnAmt(BigDecimal amt ,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String maramt = this.getSysmod().covCnAmt(amt,cur);
			return  maramt;
		}
        /**
        *   source:witame.@0015.script
        */
        public boolean checkxq()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean bool = false;

			String time1 =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String time2 =MdaUtils.format(this.getWidgrp().getRec().getZxdate(),"yyyyMMdd");
			if(time1.equals(time2))
			{
			  bool = true;
			}
			return bool;
		}







}