package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.Witame0VO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Selmod;
import com.ceb.gjjs.mda.manager.module.Selp;
import com.ceb.gjjs.mda.manager.module.Widgrp;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* Unnamed transaction
*/
@Transaction(vo= Witame0VO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Witame0 extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Witame0.class);

		@BDGetter
		private Widgrp widgrp;

		@BDGetter
		private Selp selp;

		@BDGetter
		private Selmod selmod;

		@BDGetter
		private Sysmod sysmod;


		public Witame0()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:witame0.@0000.script
        */
        @Rule(target="selp.query",order=100)
        public boolean ruleSelpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//将查询语句输入selp层的Argument类型控件queryClause字段
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.cur cur,rec.qqfamt amt,rec.opndat dat,substr(s.adrblk,0,35)  aplnam FROM wid rec,pts s WHERE  rec.stlref is not NULL AND rec.qqywlx not in ('1') AND (substr(rec.stlref,0,3) = 'OPT' or substr(rec.stlref,0,3) = 'OPS')AND rec.qqywlx not IN ('1') AND rec.sta = '1' AND s.rol = 'apl' AND s.objtyp = 'wid' AND s.objinr = rec.inr"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.queryBtn(queryClause);

			return true;
        }

        /**
        *   source:witame0.@0002.script
        */
        @Rule(target="selp.sure",order=100)
        public boolean ruleSelpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSelp().sureBtn("widgrp","witame");

			return true;
        }

        /**
        *   source:witame0.@0004.script
        */
        @Rule(target="selp.tmplst",order=100)
        public boolean ruleSelpTmplstN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.sureBtn("widgrp","witame");

			return true;
        }



        /**
        *   source:witame0.@0005.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String queryClause = "SELECT rec.inr trsinr,rec.stlref ref,rec.cur cur,rec.qqfamt amt,rec.opndat dat,substr(s.adrblk,0,35)  aplnam FROM wid rec,pts s WHERE  rec.stlref is not NULL AND rec.qqywlx not in ('1') AND (substr(rec.stlref,0,3) = 'OPT' or substr(rec.stlref,0,3) = 'OPS')AND rec.qqywlx not IN ('1') AND rec.sta = '1' AND s.rol = 'apl' AND s.objtyp = 'wid' AND s.objinr = rec.inr"
			  +ctx.absGet(Sysmod.class).getSelection();
			this.queryBtn(queryClause);

			return true;
        }


        /**
        *   source:witame0.@0001.script
        */
        public void queryBtn(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getSelp().getTmplst());
			if(!MdaUtils.isEmpty(this.getSelp().getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getSelp().getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> aplnam = new Argument<String>("aplnam");

			/*
			  Argument<String> qqtyp = new Argument<String>("qqtyp");
			  Argument<String> jshfx = new Argument<String>("jshfx");
			  Argument<String> qqffx = new Argument<String>("qqffx");
			  Argument<BigDecimal> qqfamt = new Argument<BigDecimal>("qqfamt");
			  */

			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,cur,amt,dat,aplnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getSelp().getTmplst().add(trsinr,ref,cur,amt,dat,aplnam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:witame0.@0003.script
        */
        public void sureBtn(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getSelp().getTmplst().fullSize();
			log.info("{}","size of widlst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("witame0","CT000000"),MdaUtils.getI18NString("witame0","CT000001"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(this,ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getSelp().getTmplst().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}





}