package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.WitopnVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Mtabut;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Witp;
import com.ceb.gjjs.mda.manager.module.Widgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Rmkmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 人民币与外汇期权业务签约交易
*/
@Transaction(vo= WitopnVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Witopn extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Witopn.class);

		@BDGetter
		private Widgrp widgrp;

		@BDGetter
		private Witp witp;

		@BDGetter
		private Mtabut mtabut;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Rmkmod rmkmod;


		public Witopn()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getWitp().setWidgrpHolder(()->this.getWidgrp());
           this.getMtabut().setPrefixHolder(new FieldConstantHolder<>("WI"));
           this.getMtabut().setRecHolder(()->this.getWidgrp().getRec());
           this.getTrnmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.cur");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setCur(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getCur();}}
			 );
           this.getTrnmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.amt");}
 				public void setValue(BigDecimal arg){Witopn.this.getWidgrp().getRec().setAmt(arg);}
 				public BigDecimal getValue(){return Witopn.this.getWidgrp().getRec().getAmt();}}
			 );
           this.getTrnmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.ownref");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getOwnref();}}
			 );
           this.getTrnmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.bchcod");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getBchcod();}}
			 );
           this.getTrnmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.inr");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setInr(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getInr();}}
			 );
           this.getTrnmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.ptyinr");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getPtyinr();}}
			 );
           this.getTrnmod().setStlrefHolder( new FieldHolder<String>(){
				public String getPath(){return Witopn.this.getFieldPath("widgrp.rec.stlref");}
 				public void setValue(String arg){Witopn.this.getWidgrp().getRec().setStlref(arg);}
 				public String getValue(){return Witopn.this.getWidgrp().getRec().getStlref();}}
			 );
        }

        /**
        *   source:witopn.@0003.script
        */
        @Rule(target="witp.widgrp.rec.cur",order=100)
        public boolean ruleWitpWidgrpRecCurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("CNY".equals(this.getWidgrp().getRec().getCur()))
			{
			  ctx.setFieldError(this,"widgrp.rec.cur",MdaUtils.getI18NString("witopn","CT000000"));
			  this.getWidgrp().getRec().setCur(NULLSTR);
			  
			}

			if("USD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("美利坚合众国");
			}
			else if("HKD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("中华人民共和国香港特别行政区");
			}
			else if("JPY".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("日本");
			}
			else if("EUR".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("欧洲联盟");
			}
			else if("GBP".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("大不列颠及北爱尔兰联合王国");
			}
			else if("SGD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("新加坡共和国");
			}
			else if("NZD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("新西兰");
			}
			else if("SEK".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("瑞典王国");
			}
			else if("CHF".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("瑞士联邦");
			}
			else if("CAD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("加拿大");
			}
			else if("AUD".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("澳大利亚联邦");
			}
			else if("KRW".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("大韩民国");
			}
			else if("NOK".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("挪威王国");
			}
			else if("MOP".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("中华人民共和国澳门特别行政区");
			}
			else if("THB".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("泰王国");
			}
			else if("DKK".equals(this.getWidgrp().getRec().getCur()))
			{
			  this.getWidgrp().getRec().setWbqsg("丹麦王国");
			}
			else
			{
			  this.getWidgrp().getRec().setWbqsg(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:witopn.@0005.script
        */
        @Rule(target="witp.widgrp.rec.sfcejg",order=100)
        public boolean ruleWitpWidgrpRecSfcejgN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  
			}
			else
			{
			  
			}


			return true;
        }

        /**
        *   source:witopn.@0007.script
        */
        @Rule(target="witp.widgrp.rec.sfbzjxy",order=100)
        public boolean ruleWitpWidgrpRecSfbzjxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(("".equals(this.getWidgrp().getRec().getCnybacc())||MdaUtils.isEmpty(this.getWidgrp().getRec().getCnybacc()))&&("".equals(this.getWidgrp().getRec().getFxbacc())||MdaUtils.isEmpty(this.getWidgrp().getRec().getFxbacc())))
			{
			  ctx.setFieldError(this,"witp.widgrp.rec.sfbzjxy",MdaUtils.getI18NString("witopn","CT000012"));
			  this.getWitp().getWidgrp().getRec().setSfbzjxy(NULLSTR);
			  
			  return true;
			}

			if(TRUE.equals(this.getWitp().getWidgrp().getRec().getSfndbzjxy()))
			{
			  this.getWitp().getWidgrp().getRec().setSfbzjxy(NULLSTR);
			  
			  ctx.setFieldError(this,"witp.widgrp.rec.sfbzjxy",MdaUtils.getI18NString("witopn","CT000081"));
			  return true;
			}
			if(TRUE.equals(this.getWitp().getWidgrp().getRec().getSfbzjxy()))
			{
			  //3
			  this.getWidgrp().getRec().setIsreltrn(NULLSTR);
			  this.getWidgrp().getRec().setReltrnnam(NULLSTR);
			  this.getWidgrp().getRec().setReltrnref(NULLSTR);
			  this.getWidgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getWidgrp().getRec().setRelbzjacc(NULLSTR);
			  
			  
			  
			  

			  //4
			  this.getWidgrp().getRec().setIsbhorxyz(NULLSTR);
			  this.getWidgrp().getRec().setBhorxyzref(NULLSTR);
			  
			  this.getWidgrp().getRec().setDbhetongref(NULLSTR);
			  
			  

			  //按钮
			  this.getWidgrp().getRec().setIsbhorxyz(FALSE);
			  this.getWidgrp().getRec().setIsreltrn(FALSE);

			  
			  
			  
			  
			  
			  
			  
			  

			}
			else
			{
			  
			  
			  
			  //按钮
			  
			  
			  
			}

			this.dealStpmod();

			return true;
        }

        /**
        *   source:witopn.@0009.script
        */
        @Rule(target="mtabut.sav",order=210)
        public boolean ruleMtabutSavN210(){
            IContext ctx = MdaEnv.getContext();
            
			int cnt = 1;
			String labels = "期权签约申请";
			String tempfiles = "A:witopn1";
			if(this.getWidgrp().getWiclst().size()>2)
			{
			  tempfiles = "A:witopn2";
			}
			if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			{
			  cnt = 2;
			  labels = "期权签约申请,保证金质押协议";
			  tempfiles = "A:witopn1,A:zxjopn";
			  if(this.getWidgrp().getWiclst().size()>2)
			  {
			    tempfiles = "A:witopn2,A:zxjopn";
			  }
			}

			this.getTrnmod().getApldoc().setPDFInfo(cnt,labels,tempfiles);
			this.getTrnmod().getApldoc().generatorAllPDF();


			return true;
        }

        /**
        *   source:witopn.@0010.script
        */
        @Rule(target="mtabut.sav",order=200)
        public boolean ruleMtabutSavN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","业务处理开始，编号200");

			//Platform.postEventRule($widgrp\\check,onClick,null);
			if(0 != this.checkWit())
			{
			  ctx.setMessage(MdaUtils.getI18NString("witopn","CT000069"),MdaUtils.getI18NString("witopn","CT000070"));
			  return false;
			}
			if(!ctx.checkAll(this.getWidgrp()))
			{
			  log.warn("{}","1页面校验未通过，退出！");
			  return false;
			}
			if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy())&&(!ctx.checkAll(this.getWitp().getWidgrp().getZxj())))
			{
			  log.warn("{}","2页面校验未通过，退出！");
			  return false;
			}
			this.dealPDF();
			this.dealWiclst();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			  {
			    if("wid".equals(this.getWidgrp().getZxj().getObjtyp())&&!MdaUtils.isEmpty(this.getWidgrp().getZxj().getObjinr()))
			    {
			      ctx.getDaoSession().dbUpdate(this.getWidgrp().getZxj());
			    }
			  }
			  ctx.getDaoSession().dbUpdate(this.getWidgrp().getRec());
			  this.refleshDbModflg();
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++ )
			  {
			    log.info("{}","message: inr-" + this.getWidgrp().getWiclst().getElement(i).getInr() + "objinr-" +this.getWidgrp().getWiclst().getElement(i).getObjinr());
			    //if($widgrp\\wiclst[i]\\inr.getValue() == null  ||  Platform.isEmpty($widgrp\\wiclst[i]\\inr.getValue()) || "null".equals($widgrp\\wiclst[i]\\inr.getValue()))
			    //{
			    this.getWidgrp().getWic().setInr(Platform.sdbCounter("wic"));
			    this.getWidgrp().getWic().setObjinr(this.getWidgrp().getRec().getInr());
			    this.getWidgrp().getWic().setObjtyp("wid");
			    this.getWidgrp().getWic().setJyfx(this.getWidgrp().getWiclst().getElement(i).getJyfx());
			    this.getWidgrp().getWic().setQqfx(this.getWidgrp().getWiclst().getElement(i).getQqfx());
			    this.getWidgrp().getWic().setJshfx(this.getWidgrp().getWiclst().getElement(i).getJshfx());
			    this.getWidgrp().getWic().setAmt(this.getWidgrp().getWiclst().getElement(i).getAmt());
			    this.getWidgrp().getWic().setZxamt(this.getWidgrp().getWiclst().getElement(i).getZxamt());
			    this.getWidgrp().getWic().setModflg("0");
			    ctx.getDaoSession().dbInsert(this.getWidgrp().getWic());
			    //}
			    /*
			      else
			      {
			      $widgrp\\wic\\jyfx.setValue($widgrp\\wiclst[i]\\jyfx.getValue());
			      $widgrp\\wic\\qqfx.setValue($widgrp\\wiclst[i]\\qqfx.getValue());
			      $widgrp\\wic\\jshfx.setValue($widgrp\\wiclst[i]\\jshfx.getValue());
			      $widgrp\\wic\\amt.setValue($widgrp\\wiclst[i]\\amt.getValue());
			      $widgrp\\wic\\zxamt.setValue($widgrp\\wiclst[i]\\zxamt.getValue());
			      Platform.dbUpdate($widgrp\\wic);
			      }
			      */
			  }

			  String objinr=this.getWidgrp().getRec().getInr();
			  this.getMtabut().UpdatePtsForBack(this.getWidgrp().getApl().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getWidgrp().getIsb().getPts(),objinr);
			  this.getMtabut().UpdatePtsForBack(this.getWidgrp().getDap().getPts(),objinr);
			}
			else
			{
			  this.getWidgrp().getRec().setDbchcod(this.getWidgrp().getRec().getBchcod());
			  this.getWidgrp().getRec().setInr(Platform.sdbCounter("wid"));
			  //期权保证金信息
			  if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			  {
			    this.getWidgrp().getZxj().setObjtyp("wid");
			    this.getWidgrp().getZxj().setObjinr(this.getWidgrp().getRec().getInr());
			    this.getWitp().getZxjmod().getZxj().setInr(Platform.sdbCounter("zxj"));
			    ctx.getDaoSession().dbInsert(this.getWitp().getZxjmod().getZxj());
			  }
			  //期权业务信息
			  this.getWidgrp().getRec().setQqywlx("9");
			  ctx.getDaoSession().dbInsert(this.getWidgrp().getRec());
			  //期权记录信息
			  this.refleshDbModflg();
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++ )
			  {
			    this.getWidgrp().getWic().setInr(Platform.sdbCounter("wic"));
			    this.getWidgrp().getWic().setObjinr(this.getWidgrp().getRec().getInr());
			    this.getWidgrp().getWic().setObjtyp("wid");
			    this.getWidgrp().getWic().setJyfx(this.getWidgrp().getWiclst().getElement(i).getJyfx());
			    this.getWidgrp().getWic().setQqfx(this.getWidgrp().getWiclst().getElement(i).getQqfx());
			    this.getWidgrp().getWic().setJshfx(this.getWidgrp().getWiclst().getElement(i).getJshfx());
			    this.getWidgrp().getWic().setAmt(this.getWidgrp().getWiclst().getElement(i).getAmt());
			    this.getWidgrp().getWic().setZxamt(this.getWidgrp().getWiclst().getElement(i).getZxamt());
			    this.getWidgrp().getWic().setModflg("0");
			    ctx.getDaoSession().dbInsert(this.getWidgrp().getWic());
			  }

			  String objinr = this.getWidgrp().getRec().getInr();
			  String objtyp = "wid";
			  this.getWidgrp().getApl().savpts(objinr,objtyp);
			  this.getWidgrp().getIsb().savpts(objinr,objtyp);

			  this.getWidgrp().getDap().getPts().setInr(Platform.sdbCounter("pts"));
			  this.getWidgrp().getDap().getPts().setObjinr(objinr);
			  this.getWidgrp().getDap().getPts().setObjtyp("wid");
			  ctx.getDaoSession().dbInsert(this.getWidgrp().getDap().getPts());
			  log.info("{}", "sav200入库结束================" );
			}

			//将Module数据入库 End==========
			if(!this.getTrnmod().trnSetFromContract()) return false;
			String filename = this.getSysmod().createFilename(this.getTrnmod().getTrn().getInr(),"zul");
			log.info("{}","zul文件已经生成，文件名："+filename);
			IPanel[] panels=this.getWitp().getStpmod().getAllPanelsName();
			ctx.saveDisplay(filename);
			log.info("{}","业务处理结束，编号200");

			return true;
        }

        /**
        *   source:witopn.@0011.script
        */
        @Rule(target="witp.widgrp.rec.qqfx",order=100)
        public boolean ruleWitpWidgrpRecQqfxN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"widgrp.rec.jyfx");

			return true;
        }

        /**
        *   source:witopn.@0002.script
        */
        @Rule(target="witp.widgrp.wic.jyfx",order=100)
        public boolean ruleWitpWidgrpWicJyfxN100(){
            IContext ctx = MdaEnv.getContext();
            
			//结售汇方向
			if("0".equals(this.getWidgrp().getWic().getJyfx()))
			{
			  if("0".equals(this.getWidgrp().getWic().getQqfx()))
			  {
			    this.getWitp().getWidgrp().getWic().setJshfx("1");
			  }
			  else if("1".equals(this.getWidgrp().getWic().getQqfx()))
			  {
			    this.getWitp().getWidgrp().getWic().setJshfx("0");
			  }
			}
			else if("1".equals(this.getWidgrp().getWic().getJyfx()))
			{
			  if("0".equals(this.getWidgrp().getWic().getQqfx()))
			  {
			    this.getWitp().getWidgrp().getWic().setJshfx("0");
			  }
			  else if("1".equals(this.getWidgrp().getWic().getQqfx()))
			  {
			    this.getWitp().getWidgrp().getWic().setJshfx("1");
			  }
			}
			

			//人民币保证金账户
			if("1".equals(this.getWidgrp().getWic().getJyfx()))
			{
			  
			}
			else
			{
			  
			}

			/*
			  //期权费描述
			  if("0".equals($witp\\widgrp\\rec\\jyfx.getValue()))
			  {
			  $widgrp\\qqfms.setValue("客户期望付期权费");
			  Platform.setModified($widgrp\\qqfms);
			  }
			  else if("1".equals($witp\\widgrp\\rec\\jyfx.getValue()))
			  {
			  $widgrp\\qqfms.setValue("客户期望收期权费");
			  Platform.setModified($widgrp\\qqfms);
			  }
			  else
			  {
			  $widgrp\\qqfms.setValue("期权费");
			  Platform.setModified($widgrp\\qqfms);
			  }
			  */

			return true;
        }

        /**
        *   source:witopn.@0013.script
        */
        @Rule(target="witp.stpmod.next",order=100)
        public boolean ruleWitpStpmodNextN100(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getWitp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getWitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if(stepIdx == 2)
			{
			  ctx.getDaoSession().dbRead(this.getWidgrp().getIsb().getPty(),new Argument<String>("cid",this.getWidgrp().getRec().getBchcod()));
			  this.getWidgrp().getIsb().initIsb("wid",this.getWidgrp().getIsb().getPty().getInr());
			  this.getWidgrp().getIsb().getPts().setRol("isb");
			  this.getWidgrp().getZxj().setMrzcno(this.getWidgrp().getRec().getZhsxxy());
			  
			}

			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getWitp().getPdfviw().getChk()))
			    ctx.setFieldError(this,"witp.pdfviw.chk",MdaUtils.getI18NString("witopn","CT000015"));
			  return !MdaUtils.isEmpty(this.getWitp().getPdfviw().getChk());

			  case 1:
			  {
			    return ctx.checkAll(this.getWidgrp().getApl().getPty())&&ctx.checkAll(this.getWidgrp().getApl().getAdr())&&ctx.checkAll(this.getWidgrp().getRec());
			  }
			}
			log.debug("{}","next Order[50] 执行完毕");


			return true;
        }

        /**
        *   source:witopn.@0014.script
        */
        @Rule(target="witp.stpmod.gostep",order=100)
        public boolean ruleWitpStpmodGostepN100(){
            IContext ctx = MdaEnv.getContext();
            
			int curIdx=this.getWitp().getStpmod().getCuridx();
			log.debug("{}","当前界面初始化索引curIdx="+curIdx);

			int panelidx=this.getWitp().getStpmod().getPanelidx();
			log.debug("{}","当前面板索引panelidx="+panelidx);

			String stepIndex = (String)MdaUtils.getEventData();
			int stepIdx = MdaUtils.parseInt(stepIndex);
			log.debug("{}","目标面板索引stepIdx="+stepIdx);

			if(stepIdx == 2)
			{
			  ctx.getDaoSession().dbRead(this.getWidgrp().getIsb().getPty(),new Argument<String>("cid",this.getWidgrp().getRec().getBchcod()));
			  this.getWidgrp().getIsb().initIsb("wid",this.getWidgrp().getIsb().getPty().getInr());
			  this.getWidgrp().getIsb().getPts().setRol("isb");
			  this.getWidgrp().getZxj().setMrzcno(this.getWidgrp().getRec().getZhsxxy());
			  
			}

			switch(panelidx)
			{
			  case 0:
			  if(MdaUtils.isEmpty(this.getWitp().getPdfviw().getChk()))
			    ctx.setFieldError(this,"witp.pdfviw.chk",MdaUtils.getI18NString("witopn","CT000016"));
			  return !MdaUtils.isEmpty(this.getWitp().getPdfviw().getChk());

			  case 1:
			  {
			    return ctx.checkAll(this.getWidgrp().getApl().getPty())&&ctx.checkAll(this.getWidgrp().getApl().getAdr())&&ctx.checkAll(this.getWidgrp().getRec());
			  }
			}
			log.debug("{}","next Order[50] 执行完毕");

			return true;
        }

        /**
        *   source:witopn.@0015.script
        */
        @Rule(target="witp.tukmod.pdfviw.cancel",order=100)
        public boolean ruleWitpTukmodPdfviwCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:witopn.@0016.script
        */
        @Rule(target="witp.tukmod.pdfviw.agree",order=100)
        public boolean ruleWitpTukmodPdfviwAgreeN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getWitp().getTukmod().getPdfviw().getChk()))
			{
			  this.getWitp().getStpmod().nextStep();
			  this.getWitp().getStpmod().setStepBtnSta();
			}
			else
			{
			  ctx.setFieldError(this,"witp.tukmod.pdfviw.agree",MdaUtils.getI18NString("witopn","CT000018"));
			}

			return true;
        }

        /**
        *   source:witopn.@0017.script
        */
        @Rule(target="witp.widgrp.rec.cnybacc",order=100)
        public boolean ruleWitpWidgrpRecCnybaccN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnyacc())&&this.getWidgrp().getRec().getCnyacc().equals(this.getWidgrp().getRec().getCnybacc()))
			{
			  ctx.setFieldError(this,"witp.widgrp.rec.cnybacc",MdaUtils.getI18NString("witopn","CT000021"));
			  this.getWitp().getWidgrp().getRec().setCnybacc(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:witopn.@0018.script
        */
        @Rule(target="witp.widgrp.rec.cnyacc",order=100)
        public boolean ruleWitpWidgrpRecCnyaccN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"witp.widgrp.rec.cnybacc");

			return true;
        }

        /**
        *   source:witopn.@0019.script
        */
        @Rule(target="witp.widgrp.rec.fxbacc",order=100)
        public boolean ruleWitpWidgrpRecFxbaccN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getFxacc())&&this.getWidgrp().getRec().getFxacc().equals(this.getWidgrp().getRec().getFxbacc()))
			{
			  ctx.setFieldError(this,"witp.widgrp.rec.fxbacc",MdaUtils.getI18NString("witopn","CT000023"));
			  this.getWitp().getWidgrp().getRec().setFxbacc(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:witopn.@0020.script
        */
        @Rule(target="witp.widgrp.rec.fxacc",order=100)
        public boolean ruleWitpWidgrpRecFxaccN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.postRule(this,"witp.widgrp.rec.fxbacc");

			return true;
        }

        /**
        *   source:witopn.@0025.script
        */
        @Rule(target="witp.accbtn",order=100)
        public boolean ruleWitpAccbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getWitp().getActmod().setAct("CNY");

			return true;
        }

        /**
        *   source:witopn.@0026.script
        */
        @Rule(target="witp.actmod.actslt",order=100)
        public boolean ruleWitpActmodActsltN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=0;
			int le=this.getWitp().getActmod().getActlst().fullSize();
			if(index <0 ||index >= le)
			{
			  ctx.setMessage(MdaUtils.getI18NString("witopn","CT000029"),MdaUtils.getI18NString("witopn","CT000030"));
			  return false;
			}
			String rmbact=this.getWitp().getActmod().getActlst().getElement(index).getAct();
			this.getWidgrp().getRec().setCnyacc(rmbact);
			
			

			return true;
        }

        /**
        *   source:witopn.@0027.script
        */
        @Rule(target="mtabut.add",order=100)
        public boolean ruleMtabutAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","期权新增行开始");

			if("1".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  if(this.getWidgrp().getWiclst().fullSize()>=1)
			  {
			    ctx.setFieldError(this,"mtabut.add",MdaUtils.getI18NString("witopn","CT000038"));
			    return false;
			  }
			}
			else
			{
			  if(this.getWidgrp().getWiclst().fullSize()>=3)
			  {
			    ctx.setFieldError(this,"mtabut.add",MdaUtils.getI18NString("witopn","CT000039"));
			    return false;
			  }
			}

			this.getWidgrp().getWiclst().add();
			this.refleshListNo();
			
			log.info("{}","期权新增行结束");

			return true;
        }

        /**
        *   source:witopn.@0028.script
        */
        @Rule(target="mtabut.del",order=100)
        public boolean ruleMtabutDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int size=this.getWidgrp().getWiclst().fullSize();
			log.info("{}",MdaUtils.getI18NString("witopn","CT000031")+size);
			if(size>0)
			{
			  boolean delflag=false;
			  for(int i=0;i<size;i++ )
			  {
			    //组合期权至少保留两条记录，单一期权至少保留一条记录
			    if("2".equals(this.getWidgrp().getRec().getQqtyp()))
			    {
			      if(this.getWidgrp().getWiclst().size()==2)
			      {
			        ctx.setFieldError(this,"mtabut.del",MdaUtils.getI18NString("witopn","CT000032"));
			        return true;
			      }
			    }
			    else
			    {
			      if(this.getWidgrp().getWiclst().size()==1)
			      {
			        ctx.setFieldError(this,"mtabut.del",MdaUtils.getI18NString("witopn","CT000033"));
			        return true;
			      }
			    }

			    if("X".equals(this.getWidgrp().getWiclst().getElement(i).getModflg()))
			    {
			      delflag=true;
			      this.getWidgrp().getWiclst().remove(i);
			      size=this.getWidgrp().getWiclst().fullSize();
			      i--;
			    }
			    
			    this.refleshListNo();
			  }

			  if (!delflag)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("witopn","CT000046"),MdaUtils.getI18NString("witopn","CT000047"));
			  }
			}

			return true;
        }

        /**
        *   source:witopn.@0030.script
        */
        @Rule(target="widgrp.wiclst",order=100)
        public boolean ruleWidgrpWiclstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index < 0)
			{
			  return true;
			}
			//刷新列表的结售汇方向
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("1");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("0");
			    }
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("0");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("1");
			    }
			  }
			  

			  //列表执行汇率为空时，从界面对应结售汇率取值
			  if("0".equals(this.getWitp().getWidgrp().getWiclst().getElement(i).getJshfx())&&MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(i).getZxamt()))
			  {
			    this.getWitp().getWidgrp().getWiclst().getElement(i).setZxamt(this.getWidgrp().getRec().getJhzxhl());
			  }
			  else if("1".equals(this.getWitp().getWidgrp().getWiclst().getElement(i).getJshfx())&&MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(i).getZxamt()))
			  {
			    this.getWitp().getWidgrp().getWiclst().getElement(i).setZxamt(this.getWidgrp().getRec().getShzxhl());
			  }
			  log.error("{}","message---jshfx----" + this.getWitp().getWidgrp().getWiclst().getElement(i).getJshfx() );
			  
			}
			

			this.dealWitLst();


			return true;
        }

        /**
        *   source:witopn.@0031.script
        */
        @Rule(target="witp.widgrp.rec.qqtyp",order=100)
        public boolean ruleWitpWidgrpRecQqtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			//期权记录条数更新
			int b = 1;
			if("1".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  if(this.getWidgrp().getWiclst().size() > 1)
			  {
			    for(int i = this.getWidgrp().getWiclst().size(); i > 1; i--)
			    {
			      b = i - 1;
			      this.getWidgrp().getWiclst().remove(b);
			    }
			  }
			}
			else
			{
			  if(this.getWidgrp().getWiclst().size() < 2)
			  {
			    this.getWidgrp().getWiclst().add();
			  }
			}
			this.refleshListNo();
			

			//付费方式限制
			if("2".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  this.getWidgrp().getRec().setQqfsq("0");
			}
			

			return true;
        }

        /**
        *   source:witopn.@0032.script
        */
        @Rule(target="witp.widgrp.check",order=100)
        public boolean ruleWitpWidgrpCheckN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(1 == this.checkWit())
			{
			  ctx.setFieldError(this,"witp.widgrp.check","每笔期权交易金额不得超过交易背景金额！");
			  return false;
			}
			else if(2 == this.checkWit())
			{
			  ctx.setFieldError(this,"widgrp.check","组合期权时，买入卖出各最少一条记录！");
			}
			else if(3 == this.checkWit())
			{
			  ctx.setFieldError(this,"widgrp.check","组合期权时，多条期权记录交易金额必须一致！");
			}
			else if(4 == this.checkWit())
			{

			}
			else if(5 == this.checkWit())
			{
			  ctx.setFieldError(this,"widgrp.check","期权交易金额非法！");
			}
			else if(6 == this.checkWit())
			{
			  ctx.setFieldError(this,"widgrp.check","期权执行汇率非负！");
			}
			else
			{
			  ctx.setFieldError(this,"witp.widgrp.check","结售汇方向正确或已修正！");
			}

			return true;
        }

        /**
        *   source:witopn.@0038.script
        */
        @Rule(target="mtabut.apldocs",order=100)
        public boolean ruleMtabutApldocsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getWidgrp().getRec().getCur())||MdaUtils.isEmpty(this.getWidgrp().getRec().getAmt()))
			{
			  ctx.setFieldError(this,"widgrp.rec.cur",MdaUtils.getI18NString("witopn","CT000051"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getWidgrp().getRec().getQqtyp()))
			{
			  ctx.setFieldError(this,"widgrp.rec.qqtyp",MdaUtils.getI18NString("witopn","CT000075"));
			  return false;
			}

			this.dealPDF();
			if("1".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  this.getWitp().getPdfviw().callPDFComponent("","witopn1","单一期权申请",1);
			}
			else if("2".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  if(this.getWidgrp().getWiclst().size()>2)
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witopn2","组合期权申请",1);
			  }
			  else
			  {
			    this.getWitp().getPdfviw().callPDFComponent("","witopn1","组合期权申请",1);
			  }
			}


			return true;
        }

        /**
        *   source:witopn.@0039.script
        */
        @Rule(target="witp.zxjmod.zxjopp",order=100)
        public boolean ruleWitpZxjmodZxjoppN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getWitp().getPdfviw().callPDFComponent("","zxjopn","保证金质押协议",1);

			return true;
        }

        /**
        *   source:witopn.@0043.script
        */
        @Rule(target="witp.widgrp.rec.zxdate",order=100)
        public boolean ruleWitpWidgrpRecZxdateN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZxdate()) && !(MdaUtils.diff(this.getWidgrp().getRec().getZxdate(),MdaUtils.today())>0))
			{
			  this.getWidgrp().getRec().setZxdate(null);
			  
			  ctx.setFieldError(this,"widgrp.rec.zxdate",MdaUtils.getI18NString("witopn","CT000066"));
			}
			ctx.setFieldError(this,"witp.widgrp.rec.zxdate",MdaUtils.getI18NString("witopn","CT000067"));

			return true;
        }

        /**
        *   source:witopn.@0044.script
        */
        @Rule(target="witp.zxjmod.zxj.jshsty",order=100)
        public boolean ruleWitpZxjmodZxjJshstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getWitp().getZxjmod().getZxj().getJshsty()))
			{
			  this.getWidgrp().getZxj().setMrzcno(this.getWidgrp().getRec().getZhsxxy());
			  
			  this.getWitp().getZxjmod().setYsjyzxy1(this.getWidgrp().getRec().getYsjyzxy());
			  this.getWitp().getZxjmod().setZhsxxy(this.getWidgrp().getRec().getZhsxxy());
			  this.getWitp().getZxjmod().setYsjyzxy2(NULLSTR);
			}
			else
			{
			  this.getWidgrp().getZxj().setMrzcno(NULLSTR);
			  
			  this.getWitp().getZxjmod().setYsjyzxy2(this.getWidgrp().getRec().getYsjyzxy());
			  this.getWitp().getZxjmod().setZhsxxy(NULLSTR);
			  this.getWitp().getZxjmod().setYsjyzxy1(NULLSTR);
			}

			return true;
        }

        /**
        *   source:witopn.@0045.script
        */
        @Rule(target="witp.widgrp.rec.xmlx",order=100)
        public boolean ruleWitpWidgrpRecXmlxN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWitp().getWidgrp().getRec().getXmlx())&&!MdaUtils.isEmpty(this.getWitp().getWidgrp().getRec().getKhlb()))
			{
			  this.getWitp().getWidgrp().getRec().setWgjtjm(this.getWitp().getWidgrp().getRec().getXmlx()+this.getWitp().getWidgrp().getRec().getKhlb());
			}
			else
			{
			  this.getWitp().getWidgrp().getRec().setWgjtjm(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:witopn.@0046.script
        */
        @Rule(target="witp.widgrp.rec.khlb",order=100)
        public boolean ruleWitpWidgrpRecKhlbN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWitp().getWidgrp().getRec().getXmlx())&&!MdaUtils.isEmpty(this.getWitp().getWidgrp().getRec().getKhlb()))
			{
			  this.getWitp().getWidgrp().getRec().setWgjtjm(this.getWitp().getWidgrp().getRec().getXmlx()+this.getWitp().getWidgrp().getRec().getKhlb());
			}
			else
			{
			  this.getWitp().getWidgrp().getRec().setWgjtjm(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:witopn.@0047.script
        */
        @Rule(target="witp.widgrp.rec.qqfsq",order=100)
        public boolean ruleWitpWidgrpRecQqfsqN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getWidgrp().getRec().getQqtyp()) && "1".equals(this.getWidgrp().getRec().getQqfsq()))
			{
			  ctx.setFieldError(this,"widgrp.rec.qqfsq",MdaUtils.getI18NString("witopn","CT000075"));
			  this.getWidgrp().getRec().setQqfsq(NULLSTR);
			}
			

			return true;
        }

        /**
        *   source:witopn.@0048.script
        */
        @Rule(target="witp.widgrp.rec.sfndbzjxy",order=100)
        public boolean ruleWitpWidgrpRecSfndbzjxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getWitp().getWidgrp().getRec().getSfbzjxy()))
			{
			  this.getWitp().getWidgrp().getRec().setSfndbzjxy(NULLSTR);
			  
			  ctx.setFieldError(this,"witp.widgrp.rec.sfndbzjxy",MdaUtils.getI18NString("witopn","CT000080"));
			  
			  return true;
			}

			if(TRUE.equals(this.getWitp().getWidgrp().getRec().getSfndbzjxy()))
			{
			  
			  
			}
			else
			{
			  
			  this.getWitp().getWidgrp().getRec().setBzjzyxy(NULLSTR);
			  
			}
			

			return true;
        }

        /**
        *   source:witopn.@0054.script
        */
        @Rule(target="witp.widgrp.rec.fdqj",order=100)
        public boolean ruleWitpWidgrpRecFdqjN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getWitp().getWidgrp().getRec(),"fdqj"));


			return true;
        }

        /**
        *   source:witopn.@0059.script
        */
        @Rule(target="widgrp.rec.isreltrn",order=100)
        public boolean ruleWidgrpRecIsreltrnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getIsreltrn()))
			{
			  this.getWidgrp().getRec().setCnybacc(NULLSTR);
			  this.getWidgrp().getRec().setFxbacc(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			  
			  //其他方式不能选择
			  //2
			  this.getWidgrp().getRec().setZhsxxy(NULLSTR);

			  //1
			  this.getWidgrp().getRec().setSfbzjxy(NULLSTR);
			  this.getWidgrp().getRec().setCnybacc(NULLSTR);
			  this.getWidgrp().getRec().setFxbacc(NULLSTR);
			  this.getWidgrp().getRec().setBzjbl(new BigDecimal(0));
			  
			  
			  

			  //4
			  this.getWidgrp().getRec().setBhorxyzref(NULLSTR);
			  this.getWidgrp().getRec().setDbhetongref(NULLSTR);
			  
			  
			  
			  this.getWidgrp().getRec().setIsbhorxyz(NULLSTR);

			  //按钮
			  this.getWidgrp().getRec().setIsbhorxyz(FALSE);
			  this.getWidgrp().getRec().setZhsxxy(FALSE);
			  this.getWidgrp().getRec().setSfbzjxy(FALSE);
			}
			else
			{
			  
			  
			  this.getWidgrp().getRec().setReltrnnam(NULLSTR);
			  this.getWidgrp().getRec().setReltrnref(NULLSTR);
			  this.getWidgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getWidgrp().getRec().setRelbzjacc(NULLSTR);
			  
			  
			  
			  
			  
			  

			  
			  
			  

			  if(MdaUtils.isEmpty(this.getWidgrp().getRec().getIsbhorxyz()))
			  {
			    this.getWidgrp().getRec().setZhsxxy(this.getWitp().getAgrp().getCcl());
			  }
			}
			
			
			
			
			
			
			//2
			
			
			
			
			//1
			
			//4
			
			
			
			this.dealStpmod();

			return true;
        }

        /**
        *   source:witopn.@0064.script
        */
        @Rule(target="widgrp.rec.isbhorxyz",order=100)
        public boolean ruleWidgrpRecIsbhorxyzN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getIsbhorxyz()))
			{
			  this.getWidgrp().getRec().setBhorxyzref(NULLSTR);
			  this.getWidgrp().getRec().setDbhetongref(NULLSTR);
			  
			  
			  
			  
			  //2
			  this.getWidgrp().getRec().setZhsxxy(NULLSTR);
			  //1
			  this.getWidgrp().getRec().setSfbzjxy(NULLSTR);
			  this.getWidgrp().getRec().setCnybacc(NULLSTR);
			  this.getWidgrp().getRec().setFxbacc(NULLSTR);
			  this.getWidgrp().getRec().setBzjbl(new BigDecimal(0));
			  
			  
			  

			  //3
			  this.getWidgrp().getRec().setIsreltrn(NULLSTR);
			  this.getWidgrp().getRec().setReltrnnam(NULLSTR);
			  this.getWidgrp().getRec().setReltrnref(NULLSTR);
			  this.getWidgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getWidgrp().getRec().setRelbzjacc(NULLSTR);
			  
			  
			  
			  
			  
			  
			  //按钮
			  this.getWidgrp().getRec().setIsreltrn(FALSE);
			  this.getWidgrp().getRec().setZhsxxy(FALSE);
			  this.getWidgrp().getRec().setSfbzjxy(FALSE);
			}
			else
			{
			  this.getWidgrp().getRec().setBhorxyzref(NULLSTR);
			  this.getWidgrp().getRec().setDbhetongref(NULLSTR);
			  
			  
			  
			  
			  
			  
			  if(MdaUtils.isEmpty(this.getWidgrp().getRec().getIsreltrn()))
			  {
			    this.getWidgrp().getRec().setZhsxxy(this.getWitp().getAgrp().getCcl());
			  }

			}
			
			
			//3
			
			
			
			
			
			//2
			
			
			
			
			//1
			
			this.dealStpmod();

			return true;
        }

        /**
        *   source:witopn.@0065.script
        */
        @Rule(target="witp.widgrp.rec.zhsxxy",order=100)
        public boolean ruleWitpWidgrpRecZhsxxyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZhsxxy()))
			{
			  //3
			  this.getWidgrp().getRec().setIsreltrn(NULLSTR);
			  this.getWidgrp().getRec().setReltrnnam(NULLSTR);
			  this.getWidgrp().getRec().setReltrnref(NULLSTR);
			  this.getWidgrp().getRec().setRelzyxybh(NULLSTR);
			  this.getWidgrp().getRec().setRelbzjacc(NULLSTR);
			  
			  
			  
			  
			  //4
			  this.getWidgrp().getRec().setIsbhorxyz(NULLSTR);
			  this.getWidgrp().getRec().setBhorxyzref(NULLSTR);
			  
			  this.getWidgrp().getRec().setDbhetongref(NULLSTR);
			  
			  

			  //按钮
			  this.getWidgrp().getRec().setIsbhorxyz(FALSE);
			  this.getWidgrp().getRec().setIsreltrn(FALSE);

			}
			else
			{
			  
			  
			  
			  //按钮
			  
			  
			  
			}

			//3
			
			
			
			
			
			//4
			
			
			


			return true;
        }

        /**
        *   source:witopn.@0066.script
        */
        @Rule(target="witp.widgrp.rec.jshfx",order=100)
        public boolean ruleWitpWidgrpRecJshfxN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getWidgrp().getRec().setXmlx(NULLSTR);
			if("0".equals(this.getWidgrp().getRec().getJshfx()))
			  MdaUtils.setValues(this.getWidgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp1"));
			else
			  MdaUtils.setValues(this.getWidgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp"));

			return true;
        }


        /**
        *   source:witopn.@0004.script
        */
        @Check(target="witp.widgrp.rec.fdqj",order=100)
        public boolean checkWitpWidgrpRecFdqjN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal fdqj = this.getWitp().getWidgrp().getRec().getFdqj();
			int num = fdqj.signum();
			if(num<0)
			{
			  this.getWitp().getWidgrp().getRec().setFdqj(new BigDecimal(0));
			  
			  ctx.setFieldError(this,"widgrp.rec.fdqj",MdaUtils.getI18NString("witopn","CT000008"));
			  return true;
			}
			if(fdqj.compareTo(new BigDecimal(100)) > 0)
			{
			  this.getWitp().getWidgrp().getRec().setFdqj(new BigDecimal(0));
			  
			  ctx.setFieldError(this,"widgrp.rec.fdqj",MdaUtils.getI18NString("witopn","CT000009"));
			  return true;
			}

			return true;
        }

        /**
        *   source:witopn.@0022.script
        */
        @Check(target="witp.widgrp.rec.cur",order=100)
        public boolean checkWitpWidgrpRecCurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("JPY".equals(this.getWitp().getWidgrp().getRec().getCur()))
			{
			  BigDecimal engamt = this.getWitp().getWidgrp().getRec().getAmt();
			  String engamt1 = engamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  engamt = MdaUtils.parseDecimal(engamt1);
			  this.getWitp().getWidgrp().getRec().setAmt(engamt);
			  
			}

			return true;
        }

        /**
        *   source:witopn.@0023.script
        */
        @Check(target="witp.widgrp.rec.amt",order=100)
        public boolean checkWitpWidgrpRecAmtN100(){
            IContext ctx = MdaEnv.getContext();
            
			BigDecimal engamt = this.getWitp().getWidgrp().getRec().getAmt();
			int num = engamt.signum();
			if(num<0)
			{
			  ctx.setFieldError(this,"widgrp.rec.amt",MdaUtils.getI18NString("witopn","CT000024"));
			  this.getWitp().getWidgrp().getRec().setAmt(new BigDecimal(0));
			  
			  return true;
			}
			if("JPY".equals(this.getWitp().getWidgrp().getRec().getCur()))
			{
			  String engamt1 = engamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  engamt = MdaUtils.parseDecimal(engamt1);
			  this.getWitp().getWidgrp().getRec().setAmt(engamt);
			  
			}

			return true;
        }

        /**
        *   source:witopn.@0024.script
        */
        @Check(target="witp.widgrp.rec.zxamt",order=100)
        public boolean checkWitpWidgrpRecZxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if("JPY".equals($witp\\widgrp\\rec\\cur.getValue()))
			  {
			  BigDecimal engamt = $witp\\widgrp\\rec\\amt.getValue();
			  String engamt1 = engamt.setScale(0,BigDecimal.ROUND_DOWN).toString() + ".00";
			  engamt = Platform.parseDecimal(engamt1);
			  $witp\\widgrp\\rec\\zxamt.setValue(engamt);
			  Platform.setModified($witp\\widgrp\\rec\\zxamt);
			  }*/

			return true;
        }

        /**
        *   source:witopn.@0052.script
        */
        @Check(target="witp.widgrp.rec.amt",order=101)
        public boolean checkWitpWidgrpRecAmtN101(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getWitp().getWidgrp().getRec(),"amt"));

			return true;
        }

        /**
        *   source:witopn.@0053.script
        */
        @Check(target="witp.widgrp.rec.qqfamt",order=100)
        public boolean checkWitpWidgrpRecQqfamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checkIllegalAmt(MdaDriver.getDatafield(this.getWitp().getWidgrp().getRec(),"qqfamt"));

			return true;
        }

        /**
        *   source:witopn.@0055.script
        */
        @Check(target="witp.widgrp.rec.bzjbl",order=100)
        public boolean checkWitpWidgrpRecBzjblN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getWitp().getWidgrp().getRec(),"bzjbl"));

			return true;
        }

        /**
        *   source:witopn.@0058.script
        */
        @Check(target="witp.widgrp.rec.yqdkll",order=100)
        public boolean checkWitpWidgrpRecYqdkllN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getSysmod().checknotZ(MdaDriver.getDatafield(this.getWitp().getWidgrp().getRec(),"yqdkll"));

			return true;
        }

        /**
        *   source:witopn.@0060.script
        */
        @Check(target="widgrp.rec.relbzjacc",order=100)
        public boolean checkWidgrpRecRelbzjaccN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getIsreltrn()))
			{
			  if(MdaUtils.isEmpty(this.getWidgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getWidgrp().getRec().getRelzyxybh()))
			  {
			    ctx.setFieldError(this,"widgrp.rec.relbzjacc",MdaUtils.getI18NString("witopn","CT000082"));
			    return false;
			  }
			}


			return true;
        }

        /**
        *   source:witopn.@0061.script
        */
        @Check(target="widgrp.rec.relzyxybh",order=100)
        public boolean checkWidgrpRecRelzyxybhN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getIsreltrn()))
			{
			  if(MdaUtils.isEmpty(this.getWidgrp().getRec().getRelbzjacc())&&MdaUtils.isEmpty(this.getWidgrp().getRec().getRelzyxybh()))
			  {
			    ctx.setFieldError(this,"widgrp.rec.relzyxybh",MdaUtils.getI18NString("witopn","CT000083"));
			    return false;
			  }
			}


			return true;
        }

        /**
        *   source:witopn.@0067.script
        */
        @Check(target="witp.widgrp.rec.xmlx",order=100)
        public boolean checkWitpWidgrpRecXmlxN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getWidgrp().getRec().getXmlx()))
			{

			  ctx.setFieldError(this,"widgrp.rec.xmlx",MdaUtils.getI18NString("witopn","CT000124"));
			  return false;
			}
			String name1= MdaUtils.getCodetableLabel("xmlxtyp1",this.getWidgrp().getRec().getXmlx());
			String name= MdaUtils.getCodetableLabel("xmlxtyp",this.getWidgrp().getRec().getXmlx());
			log.info("{}","结汇码表值"+name1);
			log.info("{}","售汇码表值"+name);
			log.info("{}","结售汇方向"+this.getWidgrp().getRec().getJshfx());
			if("0".equals(this.getWidgrp().getRec().getJshfx()))
			{
			  if(MdaUtils.isEmpty(name1))
			  {

			    ctx.setFieldError(this,"widgrp.rec.xmlx",MdaUtils.getI18NString("witopn","CT000125"));
			    this.getWitp().getWidgrp().getRec().setXmlx(NULLSTR);
			    MdaUtils.setValues(this.getWidgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp1"));
			    
			    return false;
			  }
			}
			else
			{
			  if(MdaUtils.isEmpty(name))
			  {

			    ctx.setFieldError(this,"widgrp.rec.xmlx",MdaUtils.getI18NString("witopn","CT000126"));
			    this.getWitp().getWidgrp().getRec().setXmlx(NULLSTR);
			    MdaUtils.setValues(this.getWidgrp().getRec(),"xmlx",MdaUtils.getCodetable("xmlxtyp"));
			    
			    return false;
			  }
			}

			return true;
        }


        /**
        *   source:witopn.@0000.script
        */
        @Init(order=90)
        public boolean	init90(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","witopn  init业务处理开始，ORDER编号:90");
			//0、单一期权声明   1、单一期权签约  2、保证金质押协议
			this.getWitp().getStpmod().storePanel(this.getWitp().getWitopn04(),this.getWitp().getWitopn03(),this.getWitp().getWitopn06());
			this.dealStpmod();

			return true;
        }

        /**
        *   source:witopn.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","witopn  init业务处理开始，ORDER编号:200");

			if(MdaUtils.isEmpty(this.getSysmod().getSpt().getOrdinr()))
			  this.getTrnmod().ordNew();

			//初始化机构
			List<CodetableItem> bchcod =this.getSysmod().getAndSetBchcodvals();
			MdaUtils.setValues(this.getWidgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getWidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			}
			

			String time =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			this.getWidgrp().getRec().setCredat(MdaUtils.parseDate(time,"yyyyMMdd"));
			
			//Platform.disable($widgrp\\rec\\ownref);
			
			
			
			//Platform.disable($widgrp\\rec\\jshfx);
			
			
			
			
			
			
			//初始化时不可编辑
			
			
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  this.getWidgrp().getApl().initDap("wid");
			  this.getWidgrp().getApl().getPts().setRol("apl");
			  //log.info("message--------------"+$\\sysmod\\pty\\inr.getValue()+"-----------"+$widgrp\\apl\\pty\\inr.getValue()+"------"+$widgrp\\apl\\pta\\objinr.getValue());
			  ctx.getDaoSession().dbRead(this.getWidgrp().getIsb().getPty(),new Argument<String>("cid",this.getWidgrp().getRec().getBchcod()));
			  this.getWidgrp().getIsb().initIsb("wid",this.getWidgrp().getIsb().getPty().getInr());
			  //log.info("message--------------"+$\\sysmod\\pty\\inr.getValue()+"-----------"+$widgrp\\isb\\pty\\inr.getValue()+"------"+$widgrp\\isb\\pta\\objinr.getValue());
			  this.getWidgrp().getIsb().getPts().setRol("isb");
			  //onChangeOpntyp();
			  this.getWidgrp().getWiclst().add();
			  this.refleshListNo();
			  

			  //从维护的银行协议编号中取“衍生交易总协议”、“综合授信协议”
			  this.getWitp().getAgrp().qurAgrnum();
			  this.getWidgrp().getRec().setYsjyzxy(this.getWitp().getAgrp().getNma());
			  this.getWidgrp().getRec().setZhsxxy(this.getWitp().getAgrp().getCcl());
			  
			  
			}
			/*
			  if($\\sysmod.sptIsLoaded("P"))
			  {
			  Platform.clear($widgrp\\rec\\ownref);
			  Platform.setModified($widgrp\\rec\\ownref);
			  }
			  */

			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("T"))
			{
			  ctx.postRule(this,"widgrp.rec.jyfx");
			  ctx.postRule(this,"widgrp.rec.sfcejg");
			  Modules.postDefaultRule(this,"widgrp.dxqqje");
			}
			ctx.postRule(this,"widgrp.rec.sfndbzjxy");


			return true;
        }


        /**
        *   source:witopn.@0008.script
        */
        public void dealStpmod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String steps = "0:期权声明;1:期权签约";

			if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			{
			  steps = "0:期权声明;1:期权签约;2:保证金协议";
			}

			this.getWitp().getStpmod().setPages(steps);
			this.getWitp().getStpmod().calcSteps();
			this.getWitp().getStpmod().setStepBtnSta();
		}
        /**
        *   source:witopn.@0029.script
        */
        public void refleshListNo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(int i = 0; i < this.getWidgrp().getWiclst().fullSize(); i++)
			{
			  this.getWidgrp().getWiclst().getElement(i).setNo(""+i);
			}
			
		}
        /**
        *   source:witopn.@0033.script
        */
        public boolean checkLstRequired()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean boollst = true;
			for(int j = 0; j < this.getWidgrp().getWiclst().size(); j++)
			{
			  if(MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(j).getJyfx()))
			  {
			    boollst = false;
			  }
			  if(MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(j).getQqfx()))
			  {
			    boollst = false;
			  }
			  if(MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(j).getAmt()))
			  {
			    boollst = false;
			  }
			  if(MdaUtils.isEmpty(this.getWitp().getWidgrp().getWiclst().getElement(j).getZxamt()))
			  {
			    boollst = false;
			  }
			  if(!boollst)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("witopn","CT000049"),MdaUtils.getI18NString("witopn","CT000050"));
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:witopn.@0034.script
        */
        public void dealPDF()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.dealPdfWiclst();

			//交割方式
			if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  this.getWidgrp().setSfcejg("1");
			}
			else if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			{
			  this.getWidgrp().setSfcejg("2");
			}
			else
			{
			  this.getWidgrp().setSfcejg("");
			}
			

			//期权费支取方向0收1付
			if("0".equals(this.getWidgrp().getRec().getQqffx()))
			{
			  this.getWidgrp().setQqffx("2");
			}
			else if("1".equals(this.getWidgrp().getRec().getQqffx()))
			{
			  this.getWidgrp().setQqffx("1");
			}
			else
			{
			  this.getWidgrp().setQqffx("");
			}
			

			//期权费收取方式
			if("0".equals(this.getWidgrp().getRec().getQqfsq()))
			{
			  this.getWidgrp().setQqfsq("1");
			}
			else if("1".equals(this.getWidgrp().getRec().getQqfsq()))
			{
			  this.getWidgrp().setQqfsq("2");
			}
			else
			{
			  this.getWidgrp().setQqfsq("");
			}
			

			//保证金账户（但不限于保证金账户）
			if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnybacc()))
			{
			  this.getWidgrp().setBzjacc2(this.getWidgrp().getRec().getCnybacc());
			}
			else if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getFxbacc()))
			{
			  this.getWidgrp().setBzjacc2(this.getWidgrp().getRec().getFxbacc());
			}
			else if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnyacc()))
			{
			  this.getWidgrp().setBzjacc2(this.getWidgrp().getRec().getCnyacc());
			}
			else
			{
			  this.getWidgrp().setBzjacc2(this.getWidgrp().getRec().getFxacc());
			}

			//保证金条款选取
			if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			{
			  if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZhsxxy()))
			  {
			    this.getWidgrp().setBzjxqfs("1、2");
			  }
			  else
			  {
			    this.getWidgrp().setBzjxqfs("1");
			  }

			  //保证金账户
			  if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getCnybacc()))
			  {
			    this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getCnybacc());
			  }
			  else
			  {
			    this.getWidgrp().setBzjacc(this.getWidgrp().getRec().getFxbacc());
			  }
			  this.getWidgrp().setBzjblp(this.getWidgrp().getRec().getBzjbl());
			  this.getWidgrp().setZhsxxyp(NULLSTR);
			}
			else if(!MdaUtils.isEmpty(this.getWidgrp().getRec().getZhsxxy()))
			{
			  this.getWidgrp().setBzjxqfs("2");
			  this.getWidgrp().setBzjacc(NULLSTR);
			  this.getWidgrp().setBzjblp(new BigDecimal(0));
			  this.getWidgrp().setZhsxxyp(this.getWidgrp().getRec().getZhsxxy());
			}
			else if(TRUE.equals(this.getWidgrp().getRec().getIsreltrn()))
			{
			  this.getWidgrp().setBzjxqfs("3");
			}
			else if(TRUE.equals(this.getWidgrp().getRec().getIsbhorxyz()))
			{
			  this.getWidgrp().setBzjxqfs("4");
			}

			//处理期权多条记录日期的显示
			if(this.getWidgrp().getWiclst().size() > 1)
			{
			  this.getWidgrp().setDate2(this.getWidgrp().getRec().getZxdate());
			}
			else
			{
			  this.getWidgrp().setDate2(null);
			}
			this.getWidgrp().setDate1(this.getWidgrp().getRec().getZxdate());

			this.getBzjzyxy();
		}
        /**
        *   source:witopn.@0035.script
        */
        public void dealWiclst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWidgrp().setJyfx(NULLSTR);
			this.getWidgrp().setQqfx(NULLSTR);
			this.getWidgrp().setJshfx(NULLSTR);
			this.getWidgrp().setAmt(NULLSTR);
			this.getWidgrp().setZxamt(NULLSTR);
			int len = this.getWidgrp().getWiclst().fullSize();
			StringBuffer jyfx=new StringBuffer();
			StringBuffer qqfx=new StringBuffer();
			StringBuffer jshfx=new StringBuffer();
			StringBuffer amt=new StringBuffer();
			StringBuffer zxamt=new StringBuffer();
			String conn="";
			String cc = null;
			BigDecimal bd = null;
			for(int i=0;i<len;i++)
			{
			  cc = this.getWidgrp().getWiclst().getElement(i).getJyfx();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  jyfx.append(conn).append(cc);

			  cc = this.getWidgrp().getWiclst().getElement(i).getQqfx();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  qqfx.append(conn).append(cc);

			  cc = this.getWidgrp().getWiclst().getElement(i).getJshfx();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  jshfx.append(conn).append(cc);

			  bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(cc)&&bd.compareTo(new BigDecimal(0))==0)
			    amt.append(conn).append("");
			  else
			    amt.append(conn).append(bd.setScale(2,BigDecimal.ROUND_HALF_UP));

			  //执行价格
			  bd = this.getWidgrp().getWiclst().getElement(i).getZxamt();
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			  {
			    zxamt.append(conn).append("");
			  }
			  else
			  {
			    zxamt.append(conn).append(bd);
			  }

			  conn = ",";
			}
			// log.info("atcnum:"+atcnum);
			// log.info("atccur:"+atccur);
			// log.info("atcamt:"+atcamt);
			// log.info("chkcur:"+chkcur);
			// log.info("chkamt:"+chkamt);
			this.getWidgrp().setJyfx(jyfx.toString());
			this.getWidgrp().setQqfx(qqfx.toString());
			this.getWidgrp().setJshfx(jshfx.toString());
			this.getWidgrp().setAmt(amt.toString());
			this.getWidgrp().setZxamt(zxamt.toString());

		}
        /**
        *   source:witopn.@0036.script
        */
        public void dealPdfWiclst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWidgrp().setJyfx1(NULLSTR);
			this.getWidgrp().setJyfx2(NULLSTR);
			this.getWidgrp().setQqfx1(NULLSTR);
			this.getWidgrp().setQqfx2(NULLSTR);
			this.getWidgrp().setCur(NULLSTR);
			this.getWidgrp().setAmt(NULLSTR);
			this.getWidgrp().setZxamt(NULLSTR);
			this.getWidgrp().setDxjej(NULLSTR);

			int len = this.getWidgrp().getWiclst().fullSize();
			StringBuffer jyfx1=new StringBuffer();
			StringBuffer jyfx2=new StringBuffer();
			StringBuffer qqfx1=new StringBuffer();
			StringBuffer qqfx2=new StringBuffer();
			StringBuffer cur=new StringBuffer();
			StringBuffer amt=new StringBuffer();
			StringBuffer zxamt=new StringBuffer();
			StringBuffer dxjej=new StringBuffer();
			String conn="";
			String cc = null;
			BigDecimal bd = null;
			for(int i=0;i<len;i++)
			{
			  //交易方向
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    cc="√";
			    jyfx1.append(conn).append(cc);
			    cc="";
			    jyfx2.append(conn).append(cc);
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    cc="";
			    jyfx1.append(conn).append(cc);
			    cc="√";
			    jyfx2.append(conn).append(cc);
			  }
			  else
			  {
			    cc="";
			    jyfx1.append(conn).append(cc);
			    jyfx2.append(conn).append(cc);
			  }

			  //期权方向
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			  {
			    cc="√";
			    qqfx1.append(conn).append(cc);
			    cc="";
			    qqfx2.append(conn).append(cc);
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			  {
			    cc="";
			    qqfx1.append(conn).append(cc);
			    cc="√";
			    qqfx2.append(conn).append(cc);
			  }
			  else
			  {
			    cc="";
			    qqfx1.append(conn).append(cc);
			    qqfx2.append(conn).append(cc);
			  }

			  //币种
			  cur.append(conn).append(this.getWidgrp().getRec().getCur().toString());

			  bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			    amt.append(conn).append("");
			  else
			    amt.append(conn).append(bd.setScale(2,BigDecimal.ROUND_HALF_UP));

			  //执行价格
			  bd = this.getWidgrp().getWiclst().getElement(i).getZxamt();
			  if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			  {
			    zxamt.append(conn).append("");
			  }
			  else
			  {
			    zxamt.append(conn).append(bd);
			  }

			  //大写金额
			  bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			  if(!(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)&&!MdaUtils.isEmpty(this.getWidgrp().getRec().getCur()))
			  {
			    cc = this.deslCovEnAmt(this.getWidgrp().getWiclst().getElement(i).getAmt(),this.getWidgrp().getRec().getCur());
			    dxjej.append(conn).append(cc);
			  }
			  else
			  {
			    cc = "";
			    dxjej.append(conn).append(cc);
			  }
			  conn = ",";
			}
			// log.info("atcnum:"+atcnum);
			// log.info("atccur:"+atccur);
			// log.info("atcamt:"+atcamt);
			// log.info("chkcur:"+chkcur);
			// log.info("chkamt:"+chkamt);
			this.getWidgrp().setJyfx1(jyfx1.toString());
			this.getWidgrp().setJyfx2(jyfx2.toString());
			this.getWidgrp().setQqfx1(qqfx1.toString());
			this.getWidgrp().setQqfx2(qqfx2.toString());
			this.getWidgrp().setAmt(amt.toString());
			this.getWidgrp().setCur(cur.toString());
			this.getWidgrp().setZxamt(zxamt.toString());
			this.getWidgrp().setDxjej(dxjej.toString());

		}
        /**
        *   source:witopn.@0037.script
        */
        public String deslCovEnAmt(BigDecimal amt ,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String maramt = this.getSysmod().covCnAmt(amt,cur);
			return  maramt;
		}
        /**
        *   source:witopn.@0040.script
        */
        public int checkWit()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			int sta = 0;
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  //检查结售汇方向
			  if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("1");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("0");
			    }
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("0");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(i).getQqfx()))
			    {
			      this.getWitp().getWidgrp().getWiclst().getElement(i).setJshfx("1");
			    }
			  }

			  /*
			    //检查执行汇率
			    if("0".equals($witp\\widgrp\\wiclst[i]\\jshfx.getValue()))
			    {
			    if(Platform.isEmpty($witp\\widgrp\\wiclst[i]\\zxamt.getValue()))
			    {
			    $witp\\widgrp\\wiclst[i]\\zxamt.setValue($widgrp\\rec\\jhzxhl.getValue());
			    }
			    else if(!$witp\\widgrp\\wiclst[i]\\zxamt.getValue().equals($widgrp\\rec\\jhzxhl.getValue()))
			    {
			    Platform.error($witp\\widgrp\\check,#CT000063);
			    return false;
			    }
			    }
			    else if("1".equals($witp\\widgrp\\wiclst[i]\\jshfx.getValue()))
			    {
			    if(Platform.isEmpty($witp\\widgrp\\wiclst[i]\\zxamt.getValue()))
			    {
			    $witp\\widgrp\\wiclst[i]\\zxamt.setValue($widgrp\\rec\\shzxhl.getValue());
			    }
			    else if(!$witp\\widgrp\\wiclst[i]\\zxamt.getValue().equals($widgrp\\rec\\shzxhl.getValue()))
			    {
			    Platform.error($witp\\widgrp\\check,#CT000064);
			    return false;
			    }
			    }
			    else
			    {
			    Platform.clear($witp\\widgrp\\wiclst[i]\\zxamt);
			    }
			    Platform.setModified($witp\\widgrp\\wiclst[i]\\jshfx);
			    Platform.setModified($witp\\widgrp\\wiclst[i]\\zxamt);
			    */
			}

			//处理单一期权时，界面与期权列表 信息一致性，（结售汇方向、期权费方向）
			if("1".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  this.dealWitLst();
			}

			//期权列表必输检查
			if(!this.checkLstRequired())
			{
			  sta = 4;
			  return sta;
			}
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  if(!this.checkIllegalAmt(MdaDriver.getDatafield(this.getWitp().getWidgrp().getWiclst().getElement(i),"amt")))
			  {
			    sta = 5;
			    return sta;
			  }
			  if(!this.checknotZ(MdaDriver.getDatafield(this.getWitp().getWidgrp().getWiclst().getElement(i),"zxamt")))
			  {
			    sta = 6;
			    return sta;
			  }
			}

			

			//检查期权记录是否正常
			for(int j = 0; j < this.getWidgrp().getWiclst().size(); j++)
			{
			  if(this.getWitp().getWidgrp().getWiclst().getElement(j).getAmt().compareTo(this.getWidgrp().getRec().getAmt()) > 0)
			  {
			    sta = 1;
			    return sta;
			  }
			}

			//组合期权时，买入卖出各最少一条记录
			if("2".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  boolean bool1 = false;
			  boolean bool2 = false;
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			    {
			      bool1 = true;
			    }
			    if("1".equals(this.getWidgrp().getWiclst().getElement(i).getJyfx()))
			    {
			      bool2 = true;
			    }
			  }
			  if(!(bool1 && bool2))
			  {
			    sta = 2;
			    return sta;
			  }
			}

			//多条期权记录金额必须一致
			for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			{
			  if(this.getWidgrp().getWiclst().getElement(0).getAmt().compareTo(this.getWidgrp().getWiclst().getElement(i).getAmt()) != 0)
			  {
			    sta = 3;
			    return sta;
			  }
			}

			return sta;		}
        /**
        *   source:witopn.@0041.script
        */
        public void refleshDbModflg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将旧有记录的状态modflg字段置“1”（弃置状态），新加记录modflg会录入“0”(使用状态)
			//if(Platform.isEmpty($widgrp\\rec\\inr.getValue()))
			//{
			log.info("{}","witopn 200 刷新期权记录的状态   ");
			ctx.getDaoSession().dbReadset(this.getWidgrp().getWiclst1(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()));
			for(int i = 0; i < this.getWidgrp().getWiclst1().size(); i++)
			{
			  this.getWidgrp().getWic().copyValues(this.getWidgrp().getWiclst1().getElement(i));
			  /*
			    $widgrp\\wic\\inr.setValue($widgrp\\wiclst1[i]\\inr.getValue());
			    $widgrp\\wic\\objinr.setValue($widgrp\\wiclst1[i]\\objinr.getValue());
			    $widgrp\\wic\\objtyp.setValue($widgrp\\wiclst1[i]\\objtyp.getValue());
			    $widgrp\\wic\\jyfx.setValue($widgrp\\wiclst[i]\\jyfx.getValue());
			    $widgrp\\wic\\qqfx.setValue($widgrp\\wiclst[i]\\qqfx.getValue());
			    $widgrp\\wic\\jshfx.setValue($widgrp\\wiclst[i]\\jshfx.getValue());
			    $widgrp\\wic\\amt.setValue($widgrp\\wiclst[i]\\amt.getValue());
			    $widgrp\\wic\\zxamt.setValue($widgrp\\wiclst[i]\\zxamt.getValue());
			    $widgrp\\wic\\sfxq.setValue($widgrp\\wiclst[i]\\sfxq.getValue());
			    */
			  this.getWidgrp().getWic().setModflg("1");
			  ctx.getDaoSession().dbDelete(this.getWidgrp().getWic());
			}
			//}
			
		}
        /**
        *   source:witopn.@0042.script
        */
        public void dealWitLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//处理单一期权时，界面与期权列表 信息一致性，（结售汇方向、期权费方向）
			if("1".equals(this.getWidgrp().getRec().getQqtyp()))
			{
			  //单一期权时，列表结售汇方向跟总结售汇方向一致，卖出期权—客户收费，买入期权-客户付费
			  if("0".equals(this.getWidgrp().getWiclst().getElement(0).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(0).getQqfx()))
			    {
			      this.getWidgrp().getRec().setJshfx("1");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(0).getQqfx()))
			    {
			      this.getWidgrp().getRec().setJshfx("0");
			    }
			    this.getWidgrp().getRec().setQqffx("1");
			  }
			  else if("1".equals(this.getWidgrp().getWiclst().getElement(0).getJyfx()))
			  {
			    if("0".equals(this.getWidgrp().getWiclst().getElement(0).getQqfx()))
			    {
			      this.getWidgrp().getRec().setJshfx("0");
			    }
			    else if("1".equals(this.getWidgrp().getWiclst().getElement(0).getQqfx()))
			    {
			      this.getWidgrp().getRec().setJshfx("1");
			    }
			    this.getWidgrp().getRec().setQqffx("0");
			  }
			  
			  
			}

		}
        /**
        *   source:witopn.@0050.script
        */
        public void getBzjzyxy()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(TRUE.equals(this.getWidgrp().getRec().getSfndbzjxy()))
			{
			  this.getWitp().getWidgrp().setBzjzyxy(this.getWidgrp().getRec().getBzjzyxy());
			}
			if(TRUE.equals(this.getWidgrp().getRec().getSfbzjxy()))
			{
			  this.getWitp().getWidgrp().setBzjzyxy(this.getWidgrp().getZxj().getBzjxyt());
			}
			if(!TRUE.equals(this.getWidgrp().getRec().getSfndbzjxy())&&(!TRUE.equals(this.getWidgrp().getRec().getSfbzjxy())))
			{
			  this.getWitp().getWidgrp().setBzjzyxy(NULLSTR);
			}
		}
        /**
        *   source:witopn.@0056.script
        */
        public boolean checkIllegalAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（17，2）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,2})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  amt = field.getValue().toString();
			  log.info("{}","amt "+amt);
			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			return bool;
		}
        /**
        *   source:witopn.@0057.script
        */
        public boolean checknotZ(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（21，5）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,5})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  log.info("{}","amt "+amt);
			  amt = field.getValue().toString();
			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			return bool;
		}
        /**
        *   source:witopn.@0062.script
        */
        public void getCurValues(String cur )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String cls="com.brilliance.eibs.main.Client";
			BigDecimal  midrat = new BigDecimal(0);

			Object rtnVal = MdaUtils.invoke(cls,"scall","getcurHL","getcurHL",new Object[]{cur});    // 判断接口是否调用成功
			if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			{
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");
			  if("900000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("witopn","CT000084"),MdaUtils.getI18NString("witopn","CT000085"));
			  }
			  else if("999999".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("witopn","CT000086"),MdaUtils.getI18NString("witopn","CT000087"));
			  }
			  else
			  {
			    Object objm = retMsg.get("midrat");
			    midrat = (BigDecimal)objm;
			  }
			}
			else
			{
			  //提示调用错误
			  ctx.setMessage(MdaUtils.getI18NString("witopn","CT000088"),MdaUtils.getI18NString("witopn","CT000089"));
			}
			this.getWidgrp().getRec().setFyrate(midrat);
			
		}







}