package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XmltskVO;

import com.ceb.gjjs.mda.manager.module.Trnmod;
import com.ceb.gjjs.mda.manager.module.Xmlbod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Test;
import com.ceb.gjjs.mda.manager.module.Ptyset;
import com.ceb.gjjs.mda.manager.module.Busgrp;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xmlhad;
import com.ceb.gjjs.mda.manager.module.Fillst;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* XML来报消息处理(XML Messages Handle)
*/
@Transaction(vo= XmltskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xmltsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xmltsk.class);

        //启动
        private transient IControl start = new ControlImpl("start", "启动", this);
		@BDGetter
		private ModuleList<Fillst> fillst;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Trnmod trnmod;

		@BDGetter
		private Xmlhad xmlhad;

		@BDGetter
		private Xmlbod xmlbod;

		@BDGetter
		private Ptyset ptyset;

		@BDGetter
		private Busgrp busgrp;

		@BDGetter
		private Test test;


		public Xmltsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getTrnmod().setBchcodHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setCurHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setObjinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setOwnrefHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setPtyinrHolder(new FieldConstantHolder<>(""));
           this.getTrnmod().setAmtHolder(new FieldConstantHolder<>(new BigDecimal("0.00")));
           this.getTrnmod().setStlrefHolder(new FieldConstantHolder<>(""));
           this.getXmlhad().setPtysetHolder(()->this.getPtyset());
           this.getXmlhad().setBusgrpHolder(()->this.getBusgrp());
           this.getXmlbod().setPtysetHolder(()->this.getPtyset());
           this.getXmlbod().setBusgrpHolder(()->this.getBusgrp());
        }

        /**
        *   source:xmltsk.@0000.script
        */
        @Rule(target="start",order=100)
        public boolean ruleStartN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","xmltsk start...");

			return true;
        }




        /**
        *   source:xmltsk.@0001.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*
			  1.限制xmltsk只在一台服务器上运行，可在transaction.properties中配置服务ip
			  2.在配置文件中配置isServer判断是服务器上还是本地运行
			  3.本地测试暂时将此屏蔽掉,后面需要放开
			  */
			/**
			  //指定服务器处理后台服务
			  String proFilPth = Platform.catPath(Platform.getRootPath(),"/data/transaction.properties");
			  String isServer = Platform.getPropertyValue(proFilPth,"isServer");
			  log.debug("isServer=" + isServer);
			  if("1".equals(isServer))
			  {
			  String webserver = (String)java.lang.System.getProperty("weblogic.management.server");
			  log.info("weblogic.management.server："+webserver);
			  String workserver =Platform.getPropertyValue(Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"transaction.properties"),"mgrtskworkserver");
			  log.info("workserver："+workserver);
			  if(Platform.isEmpty(workserver))
			  {
			  log.info("here 1");
			  return;
			  }
			  if(!webserver.contains(workserver))
			  {
			  log.info("here 2");
			  return;
			  }
			  }
			  */
			/*
			  * 收报交易服务启动入口
			  - state -平台调用参数
			  @无返回值
			  */
			//判断是否在浮动IP的机器上执行
			Object obj1 = MdaUtils.invoke("com.cib.window.util.NetworkUtil","checkwork");
			if(!(boolean)obj1)
			  return ;

			log.debug("{}"," in xmltsk.service  start...");
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			log.debug("{}","path="+path+", \ncfgpath="+cfgpath);
			//receive message
			//ICallback  callback = new ICallback(processXmlIncoming).invoke();
			//Object resultMsg = Platform.invoke("com.brilliance.eibs.server.manager.ServerManagerUtil" ,"service","fileservice",true,state,new Object[]{callback});
			//log.debug(" out xmltsk.service - xmltsk ... ") ;
			
			ICallback  callback = new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					processXmlIncoming(paramVarArgs);
					return null;
				}
			};
			Map retMsg = new HashMap() ;
			try
			{
			  Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","fileservice","receive",new Object[]{callback});
			  // 判断接口是否调用成功
			  //Boolean success = (Boolean) Platform.invoke(obj,"isSuccess") ;
			  //log.debug("success=" + success);
			
			}

			catch(Exception e)
			{
			  ctx.getErrorCode();
			  log.error("{}","errormsg:" + e.getMessage());
			  Platform.setErrorInfo(retMsg,"11005","接口平台调用异常");
			}
			//return retMsg;
			
		}
        /**
        *   source:xmltsk.@0006.script
        */
        public void createOrdAndOre()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 保存ORD和ORE记录
			  */

			this.getTrnmod().getOrdmod().createOrdAndOre("xml收报","01");
			/**
			  $trnmod\\ord\\sta.setValue("C");
			  $trnmod\\ord\\stadattim.setValue(new Date());
			  String transname=Platform.getTransName();
			  $trnmod\\ord\\frm.setValue(transname);
			  $trnmod\\ord\\inr.setValue(Platform.sdbCounter("ord"));
			  $sysmod.sdbInsert($trnmod\\ord);
			  $trnmod\\ore\\ordinr.setValue($trnmod\\ord\\inr.getValue());
			  $trnmod\\ore\\objtyp.setValue($trnmod\\ord\\objtyp.getValue());
			  $trnmod\\ore\\objinr.setValue($trnmod\\ord\\objinr.getValue());
			  $trnmod\\ore\\typ.setValue($trnmod\\ord\\sta.getValue());
			  $trnmod\\ore\\frm.setValue(transname);
			  $trnmod\\ore\\usrinr.setValue($sysmod\\usr\\inr.getValue());
			  $trnmod\\ore\\ptyinr.setValue($sysmod\\pty\\inr.getValue());
			  $trnmod\\ore\\inr.setValue(Platform.sdbCounter("ore"));
			  $sysmod.sdbInsert($trnmod\\ore);
			  **/
		}
        /**
        *   source:xmltsk.@0015.script
        */
        public void preClearModuleData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *解析报文前初始化数据,避免前后报文的影响
			  */
			log.debug("{}","in xmltsk.preClearModuleData... ");
			this.clearModuleData();
			this.getXmlhad().preClearModuleData();
			this.getXmlbod().preClearModuleData();
			this.getPtyset().preClearModuleData();

		}
        /**
        *   source:xmltsk.@0016.script
        */
        public synchronized Map<String,Object> processXmlIncoming(Object... obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 定义报文接收接口服务回调函数
			  * 参数：obj[0]- 数据来源
			  *       obj[1]- 报文头
			  *       obj[2]- 报文体
			  * @返回值：处理应答信息
			  */
			log.debug("{}","in xmltsk.processXmlIncoming... ");
			Map<String,Object> response = new HashMap<String,Object>();
			if(MdaUtils.isEmpty(obj[0]))
			{
			  log.error("{}","系统编号为空。");
			  return null;
			}
			String sjly = ((String)obj[0]).toLowerCase();    // 数据来源
			Map<String,Object> headerMap = (Map<String,Object>) obj[1]; // 报文头
			Map<String,Object> bodyMap =   (Map<String,Object>) obj[2];   // 报文体
			// 清空数据
			preClearModuleData();
			//1.开启事务
			ctx.getDaoSession().dbBegin();
			// 解析报文头
			this.getXmlhad().parseHeader(headerMap,sjly,response);
			// 解析报文体
			if(Platform.isNoError(response) )
			{
			  this.getXmlbod().parseBody(bodyMap,sjly, this.getXmlhad().getMessageType(sjly), response);
			  if(Platform.isNoError(response) )
			  {
			    ctx.getErrorCode(); // 此处排除因为其他原因导致的错误码影响提交数据库操作的处理逻辑
			    ctx.getDaoSession().dbCommit();
			    if( ctx.getErrorCode() == NO_ERROR )
			    {
			      Platform.setErrorInfo(response,"00000","报文处理成功");
			      log.info("{}","received the message successfully...");
			    }
			    else
			    {
			      Platform.setErrorInfo(response,"11002","数据库提交失败");
			      ctx.getDaoSession().dbRollback();
			      log.error("{}"," 数据库提交失败...");
			    }
			  }
			  else
			  {
			    ctx.getDaoSession().dbRollback();
			    log.error("{}"," 报文体处理失败...");
			  }
			}
			else
			{
			  ctx.getDaoSession().dbRollback();
			  log.error("{}"," 报文头处理失败...");
			}
			return response;
		}
        /**
        *   source:xmltsk.@0017.script
        */
        public void clearModuleData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 接口用于清空 SMH、WFE、WFS 、TRN 等模块数据
			  */
			log.debug("{}"," in  xmltsk.clearModuleData ...   ");

		}










}