package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XpsfaqVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Xptp;
import com.ceb.gjjs.mda.manager.module.Xptbtn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xptgrp;
import com.ceb.gjjs.mda.manager.module.Xptmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 常见问题
*/
@Transaction(vo= XpsfaqVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xpsfaq extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xpsfaq.class);

		@BDGetter
		private Xptgrp xptgrp;

		@BDGetter
		private Xptmod xptmod;

		@BDGetter
		private Xptp xptp;

		@BDGetter
		private Xptbtn xptbtn;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;


		public Xpsfaq()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getXptmod().setXptgrpHolder(()->this.getXptgrp());
           this.getXptp().setXptgrpHolder(()->this.getXptgrp());
        }

        /**
        *   source:xpsfaq.@0000.script
        */
        @Rule(target="xptp.query",order=100)
        public boolean ruleXptpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			String queryClause = "SELECT x.inr,x.SUB,x.que,s.txt quetyp FROM XPTFAQ x,stb s  "
			  +"where x.QUETYP = s.cod and (s.tbl='quetyp' or s.tbl='QUETYP')";
			if(!MdaUtils.isEmpty(this.getXptp().getFaqtyp()))
			{
			  queryClause = queryClause + " AND s.cod = '" + this.getXptp().getFaqtyp() + "'";
			}
			query(queryClause);

			return true;
        }

        /**
        *   source:xpsfaq.@0003.script
        */
        @Rule(target="xptp.sure",order=100)
        public boolean ruleXptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptfaqlst().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("xpsfaq","CT000000"),MdaUtils.getI18NString("xpsfaq","CT000001"));
			  return true;
			}
			MdaUtils.clear(this.getXptgrp().getXptfaq());
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptfaq(),new Argument<String>("inr",this.getXptgrp().getXptfaqlst().getElement(index).getInr()));
			this.getXptp().setSamtyp(NULLSTR);
			ArrayList<CodetableItem> samtyp = new ArrayList<CodetableItem>();
			samtyp.add(new CodetableItem(this.getXptgrp().getXptfaqlst().getElement(index).getQuetyp()
			  ,this.getXptgrp().getXptfaqlst().getElement(index).getInr()));
			MdaUtils.setValues(this.getXptp(),"samtyp",samtyp);
			this.getXptp().setSamtyp((samtyp.get(0)).getValue());
			

			return true;
        }

        /**
        *   source:xpsfaq.@0005.script
        */
        @Rule(target="xptp.back",order=100)
        public boolean ruleXptpBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:xpsfaq.@0001.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String typSql = "SELECT s.cod,s.txt FROM stb s WHERE s.tbl='quetyp' or s.tbl='QUETYP'";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			ArrayList<CodetableItem> faqtyp = new ArrayList<CodetableItem>();
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> txt = new Argument<String>("txt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    faqtyp.add(new CodetableItem(txt.value,cod.value));
			  }
			  else break;
			}
			ctx.getDaoSession().dbCloseCursor();
			this.getXptp().setFaqtyp(NULLSTR);
			MdaUtils.setValues(this.getXptp(),"faqtyp",faqtyp);
			if(!MdaUtils.isEmpty(faqtyp))
			{
			  this.getXptp().setFaqtyp((faqtyp.get(0)).getValue());
			}
			String queryClause = "SELECT x.inr,x.SUB,x.que,s.txt quetyp FROM XPTFAQ x,stb s  "
			  +"where x.QUETYP = s.cod and (s.tbl='quetyp' or s.tbl='QUETYP')";
			query(queryClause);

			return true;
        }

        /**
        *   source:xpsfaq.@0004.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:xpsfaq.@0002.script
        */
        public void query(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","SELECT sql==" + queryClause);
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> quetyp = new Argument<String>("quetyp");
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> sub = new Argument<String>("sub");
			Argument<String> que = new Argument<String>("que");
			MdaUtils.clear(this.getXptgrp().getXptfaqlst());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(quetyp,inr,sub,que);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    if(sub.value==null  ||  "".equals(sub.value))
			    {
			      byte[] quesub = null;
			      if(que.value==null)
			        que.value="";
			      quesub = que.value.getBytes();
			      String queStr = que.value.substring(0,quesub.length>=101?50:
			      que.value.length());
			      if(que.value.length()>50)
			      {
			        queStr = queStr+"...";
			      }
			      sub.value=queStr;
			    }
			    this.getXptgrp().getXptfaqlst().add(quetyp,inr,sub);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}







}