package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XpssamVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Xptp;
import com.ceb.gjjs.mda.manager.module.Xptbtn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xptgrp;
import com.ceb.gjjs.mda.manager.module.Xptmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 经典案例
*/
@Transaction(vo= XpssamVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xpssam extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xpssam.class);

		@BDGetter
		private Xptgrp xptgrp;

		@BDGetter
		private Xptmod xptmod;

		@BDGetter
		private Xptp xptp;

		@BDGetter
		private Xptbtn xptbtn;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;


		public Xpssam()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getXptmod().setXptgrpHolder(()->this.getXptgrp());
           this.getXptp().setXptgrpHolder(()->this.getXptgrp());
        }

        /**
        *   source:xpssam.@0001.script
        */
        @Rule(target="xptp.query",order=100)
        public boolean ruleXptpQueryN100(){
            IContext ctx = MdaEnv.getContext();
            

			String queryClause = "SELECT x.inr,x.casque,s.txt castyp FROM XPTSAM x,stb s  "
			  +"where x.CASTYP = s.cod and (s.tbl='samtyp' or s.tbl='SAMTYP')";
			if(!MdaUtils.isEmpty(this.getXptp().getFaqtyp()))
			{
			  queryClause = queryClause + " AND s.cod = '" + this.getXptp().getFaqtyp() + "'";
			}
			query(queryClause);

			return true;
        }

        /**
        *   source:xpssam.@0003.script
        */
        @Rule(target="xptp.sure",order=100)
        public boolean ruleXptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptsamlst().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("xpssam","CT000000"),MdaUtils.getI18NString("xpssam","CT000001"));
			  return true;
			}
			MdaUtils.clear(this.getXptgrp().getXptsam());
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptsam(),new Argument<String>("inr",this.getXptgrp().getXptsamlst().getElement(index).getInr()));
			this.getXptp().setSamtyp(NULLSTR);
			ArrayList<CodetableItem> samtyp = new ArrayList<CodetableItem>();
			samtyp.add(new CodetableItem(this.getXptgrp().getXptsamlst().getElement(index).getCastyp()
			  ,this.getXptgrp().getXptsamlst().getElement(index).getInr()));
			MdaUtils.setValues(this.getXptp(),"samtyp",samtyp);
			this.getXptp().setSamtyp((samtyp.get(0)).getValue());
			

			return true;
        }

        /**
        *   source:xpssam.@0004.script
        */
        @Rule(target="xptp.back",order=100)
        public boolean ruleXptpBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:xpssam.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			String typSql = "SELECT s.cod,s.txt FROM stb s WHERE s.tbl='samtyp' or s.tbl='SAMTYP'";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			ArrayList<CodetableItem> samtyp = new ArrayList<CodetableItem>();
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> txt = new Argument<String>("txt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    samtyp.add(new CodetableItem(txt.value,cod.value));
			  }
			  else break;
			}
			ctx.getDaoSession().dbCloseCursor();
			this.getXptp().setFaqtyp(NULLSTR);
			MdaUtils.setValues(this.getXptp(),"faqtyp",samtyp);
			if(!MdaUtils.isEmpty(samtyp))
			{
			  this.getXptp().setFaqtyp((samtyp.get(0)).getValue());
			}
			String queryClause = "SELECT x.inr,x.casque,s.txt castyp FROM XPTSAM x,stb s  "
			  +"where x.CASTYP = s.cod and (s.tbl='samtyp' or s.tbl='SAMTYP')";
			query(queryClause);

			return true;
        }

        /**
        *   source:xpssam.@0005.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:xpssam.@0002.script
        */
        public void query(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","SELECT sql==" + queryClause);
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> castyp = new Argument<String>("castyp");
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> casque = new Argument<String>("casque");
			MdaUtils.clear(this.getXptgrp().getXptsamlst());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(castyp,inr,casque);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getXptgrp().getXptsamlst().add(castyp,inr,casque);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}







}