package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XpthisVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Xptp;
import com.ceb.gjjs.mda.manager.module.Xptbtn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xptgrp;
import com.ceb.gjjs.mda.manager.module.Xptmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 咨询列表
*/
@Transaction(vo= XpthisVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xpthis extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xpthis.class);

		@BDGetter
		private Xptgrp xptgrp;

		@BDGetter
		private Xptmod xptmod;

		@BDGetter
		private Xptp xptp;

		@BDGetter
		private Xptbtn xptbtn;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;


		public Xpthis()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getXptmod().setXptgrpHolder(()->this.getXptgrp());
           this.getXptp().setXptgrpHolder(()->this.getXptgrp());
        }

        /**
        *   source:xpthis.@0002.script
        */
        @Rule(target="xptp.advisory",order=100)
        public boolean ruleXptpAdvisoryN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptqnalst().fullSize();
			String sta = null;
			if( index>=0 && index <length)
			  sta=this.getXptgrp().getXptqnalst().getElement(index).getSta();
			log.info("{}","sta ="+sta);
			if(sta!=null&&!"G".equals(sta))
			{
			  ctx.getDaoSession().dbRead(this.getXptgrp().getXptqna(),new Argument("inr",this.getXptgrp().getXptqnalst().getElement(index).getInr()));
			  ctx.storeData("com.brilliance.xptlst.ref",this.getXptgrp().getXptqna());
			}
			
			

			return true;
        }

        /**
        *   source:xpthis.@0003.script
        */
        @Rule(target="xptp.delete",order=100)
        public boolean ruleXptpDeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptqnalst().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("xpthis","CT000002"),MdaUtils.getI18NString("xpthis","CT000003"));
			  return true;
			}
			String sta = this.getXptgrp().getXptqnalst().getElement(index).getSta();
			log.info("{}","sta ="+sta);
			if("C".equals(sta))
			{// 答复中
			  ctx.setMessage(MdaUtils.getI18NString("xpthis","CT000004"),MdaUtils.getI18NString("xpthis","CT000005"));
			  return true;
			}
			if(MdaUtils.prompt(MdaUtils.getI18NString("xpthis","CT000008"),MdaUtils.getI18NString("xpthis","CT000009")))
			  return true;
			ctx.getDaoSession().dbBegin();
			ctx.getDaoSession().dbDelete(this.getXptgrp().getXptqna(),new Argument("inr",this.getXptgrp().getXptqnalst().getElement(index).getInr()));
			ctx.getDaoSession().dbCommit();
			refreshQna();

			return true;
        }

        /**
        *   source:xpthis.@0004.script
        */
        @Rule(target="xptp.sure",order=100)
        public boolean ruleXptpSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptqnalst().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("xpthis","CT000002"),MdaUtils.getI18NString("xpthis","CT000003"));
			  return true;
			}
			String inr = this.getXptgrp().getXptqnalst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptqna(),new Argument<String>("inr",inr));
			String queryClause = "SELECT * FROM XPTQNA x WHERE inr='"+inr+"'";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> ans = new Argument<String>("ans");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> etnnam = new Argument<String>("etnnam");
			Argument<String> oprinr = new Argument<String>("oprinr");
			Argument<String> que = new Argument<String>("que");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> tel = new Argument<String>("tel");
			Argument<String> xptinr = new Argument<String>("xptinr");
			//新增影像批次号
			Argument<String> imgref = new Argument<String>("imgref");
			ctx.getDaoSession().dbFetchFields(ans,dat,etnnam,oprinr,que,ref,sta,tel,xptinr,imgref);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  MdaUtils.clear(this.getXptgrp().getXptqna());
			  this.getXptgrp().getXptqna().setInr(inr);
			  this.getXptgrp().getXptqna().setAns(ans.value);
			  this.getXptgrp().getXptqna().setDat(dat.value);
			  this.getXptgrp().getXptqna().setEtnnam(etnnam.value);
			  this.getXptgrp().getXptqna().setOprinr(oprinr.value);
			  this.getXptgrp().getXptqna().setQue(que.value);
			  this.getXptgrp().getXptqna().setRef(ref.value);
			  this.getXptgrp().getXptqna().setSta(sta.value);
			  this.getXptgrp().getXptqna().setTel(tel.value);
			  this.getXptgrp().getXptqna().setXptinr(xptinr.value);
			  this.getXptgrp().getXptqna().setImgref(imgref.value);
			}
			ctx.getDaoSession().dbCloseCursor();
			String stastr = this.getXptgrp().getXptqnalst().getElement(index).getSta();
			String xptinrstr = this.getXptgrp().getXptqnalst().getElement(index).getXptinr();
			if("G".equals(stastr))
			{
			  ctx.getDaoSession().dbRead(this.getXptgrp().getXptinf(),new Argument("oprinr",xptinrstr));
			  // 已答复
			}
			else
			{
			  ctx.storeData("com.brilliance.xptlst.ref",this.getXptgrp().getXptqna());
			  
			}

			return true;
        }

        /**
        *   source:xpthis.@0005.script
        */
        @Rule(target="xptp.refresh",order=100)
        public boolean ruleXptpRefreshN100(){
            IContext ctx = MdaEnv.getContext();
            
			refreshQna();

			return true;
        }

        /**
        *   source:xpthis.@0008.script
        */
        @Rule(target="xptp.xptgrp.xptqnalst",order=100)
        public boolean ruleXptpXptgrpXptqnalstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptqnalst().fullSize();
			if( index<0   ||   index >= length)
			  return true;
			String inr = this.getXptgrp().getXptqnalst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptqna(),new Argument<String>("inr",inr));
			String queryClause = "SELECT * FROM XPTQNA x WHERE inr='"+inr+"'";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> ans = new Argument<String>("ans");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> etnnam = new Argument<String>("etnnam");
			Argument<String> oprinr = new Argument<String>("oprinr");
			Argument<String> que = new Argument<String>("que");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> tel = new Argument<String>("tel");
			Argument<String> xptinr = new Argument<String>("xptinr");
			//新增影像批次号
			Argument<String> imgref = new Argument<String>("imgref");
			ctx.getDaoSession().dbFetchFields(ans,dat,etnnam,oprinr,que,ref,sta,tel,xptinr,imgref);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  MdaUtils.clear(this.getXptgrp().getXptqna());
			  this.getXptgrp().getXptqna().setInr(inr);
			  this.getXptgrp().getXptqna().setAns(ans.value);
			  this.getXptgrp().getXptqna().setDat(dat.value);
			  this.getXptgrp().getXptqna().setEtnnam(etnnam.value);
			  this.getXptgrp().getXptqna().setOprinr(oprinr.value);
			  this.getXptgrp().getXptqna().setQue(que.value);
			  this.getXptgrp().getXptqna().setRef(ref.value);
			  this.getXptgrp().getXptqna().setSta(sta.value);
			  this.getXptgrp().getXptqna().setTel(tel.value);
			  this.getXptgrp().getXptqna().setXptinr(xptinr.value);
			  this.getXptgrp().getXptqna().setImgref(imgref.value);
			}
			ctx.getDaoSession().dbCloseCursor();
			String stastr = this.getXptgrp().getXptqnalst().getElement(index).getSta();
			String xptinrstr = this.getXptgrp().getXptqnalst().getElement(index).getXptinr();
			if("G".equals(stastr))
			{
			  ctx.getDaoSession().dbRead(this.getXptgrp().getXptinf(),new Argument("oprinr",xptinrstr));
			  // 已答复
			}
			else
			{
			  ctx.storeData("com.brilliance.xptlst.ref",this.getXptgrp().getXptqna());
			  
			}

			return true;
        }



        /**
        *   source:xpthis.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }

        /**
        *   source:xpthis.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","init p");
			refreshQna();

			return true;
        }


        /**
        *   source:xpthis.@0001.script
        */
        public void refreshQna()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String queryClause = "SELECT x.inr,x.dat,x.que,x.sta,x.xptinr,x.ans FROM XPTQNA x WHERE 1=1 order by dat desc";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			Argument<String> dat = new Argument<String>("dat");
			Argument<String> que = new Argument<String>("que");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> xptinr = new Argument<String>("xptinr");
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> ans = new Argument<String>("ans");
			MdaUtils.clear(this.getXptgrp().getXptqnalst());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(dat,que,sta,xptinr,inr,ans);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getXptgrp().getXptqnalst().add(dat,que,sta,xptinr,inr,ans);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}







}