package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XptsltVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Xptp;
import com.ceb.gjjs.mda.manager.module.Xptbtn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xptgrp;
import com.ceb.gjjs.mda.manager.module.Xptmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 我要咨询
*/
@Transaction(vo= XptsltVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xptslt extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xptslt.class);

		@BDGetter
		private Xptgrp xptgrp;

		@BDGetter
		private Xptmod xptmod;

		@BDGetter
		private Xptp xptp;

		@BDGetter
		private Xptbtn xptbtn;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;


		public Xptslt()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getXptmod().setXptgrpHolder(()->this.getXptgrp());
           this.getXptp().setXptgrpHolder(()->this.getXptgrp());
        }

        /**
        *   source:xptslt.@0000.script
        */
        @Rule(target="xptp.seltel",order=100)
        public boolean ruleXptpSeltelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:xptslt.@0001.script
        */
        @Rule(target="xptbtn.ped",order=100)
        public boolean ruleXptbtnPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			boolean isNew = true;
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getInr()))
			  this.getXptgrp().getXptqna().setInr(Platform.sdbCounter("xptqna"));
			else isNew = false;
			this.getXptgrp().getXptqna().setDat(new Date());
			this.getXptgrp().getXptqna().setSta("F");
			this.getXptgrp().getXptqna().setXptinr(this.getXptgrp().getXptinf().getOprinr());
			ctx.getDaoSession().dbBegin();
			if(isNew)
			  ctx.getDaoSession().dbInsert(this.getXptgrp().getXptqna());
			else
			  ctx.getDaoSession().dbUpdate(this.getXptgrp().getXptqna());
			ctx.getDaoSession().dbCommit();
			

			return true;
        }

        /**
        *   source:xptslt.@0002.script
        */
        @Rule(target="xptbtn.reset",order=100)
        public boolean ruleXptbtnResetN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getXptgrp().getXptinf());
			this.getXptgrp().getXptqna().setQue(NULLSTR);
			
			
			
			
			

			return true;
        }

        /**
        *   source:xptslt.@0003.script
        */
        @Rule(target="xptbtn.submit",order=100)
        public boolean ruleXptbtnSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getXptgrp().getXptinf().getOprinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptslt","CT000002"),MdaUtils.getI18NString("xptslt","CT000003"));
			  return true;
			}
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getQue()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptslt","CT000004"),MdaUtils.getI18NString("xptslt","CT000005"));
			  return true;
			}
			boolean isNew = true;
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getInr()))
			  this.getXptgrp().getXptqna().setInr(Platform.sdbCounter("xptqna"));
			else
			  isNew = false;
			this.getXptgrp().getXptqna().setDat(new Date());
			this.getXptgrp().getXptqna().setOprinr(this.getSysmod().getUsr().getInr());
			this.getXptgrp().getXptqna().setSta("B");
			this.getXptgrp().getXptqna().setXptinr(this.getXptgrp().getXptinf().getOprinr());
			ctx.getDaoSession().dbBegin();
			if(isNew)
			{
			  ctx.getDaoSession().dbInsert(this.getXptgrp().getXptqna());
			  if(!MdaUtils.isEmpty(this.getXptgrp().getXptinf().getExpmbl()))
			  {
			    String moble = this.getXptgrp().getXptinf().getExpmbl();
			    log.debug("{}","sms="+moble);
			    this.getSysmod().sendSMS(moble,ctx.getTransName(),false);
			  }
			}
			else
			  ctx.getDaoSession().dbUpdate(this.getXptgrp().getXptqna());
			ctx.getDaoSession().dbCommit();
			

			return true;
        }

        /**
        *   source:xptslt.@0004.script
        */
        @Rule(target="xptp.quedoc",order=100)
        public boolean ruleXptpQuedocN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getRef()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptslt","CT000006"),MdaUtils.getI18NString("xptslt","CT000007"));
			  return true;
			}
			this.getXptp().loadDisplay(this.getXptgrp().getXptqna().getRef());

			return true;
        }

        /**
        *   source:xptslt.@0005.script
        */
        @Rule(target="xptp.back",order=100)
        public boolean ruleXptpBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:xptslt.@0008.script
        */
        @Rule(target="xptgrp.xptinflst",order=100)
        public boolean ruleXptgrpXptinflstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getXptgrp().getXptinflst().fullSize();
			if( index<0   ||   index >= length)
			{
			  return true;
			}
			MdaUtils.clear(this.getXptgrp().getXptinf());
			this.getXptgrp().getXptinf().copyValue(this.getXptgrp().getXptinflst().getElement(index));
			String logsta = this.getXptp().loadXptSta(this.getXptgrp().getXptinflst().getElement(index).getOprinr());
			if("1".equals(logsta))
			  this.getXptgrp().getXptinf().setXptsta("在线");
			else
			  this.getXptgrp().getXptinf().setXptsta("离线");
			
			log.info("{}","onclick xptinflst "+index+" oprinr="+this.getXptgrp().getXptinf().getOprinr());
			this.getXptp().setXptpho(NULLSTR);
			if(!MdaUtils.isEmpty(this.getXptgrp().getXptinf().getExppho()))
			{
			  this.getXptp().setXptpho("/resource/"+this.getXptgrp().getXptinf().getExppho());
			  
			}
			else
			  
			log.debug("{}","xptpho="+this.getXptp().getXptpho());
			

			return true;
        }



        /**
        *   source:xptslt.@0006.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in init  100  xptslt .... ");

			
			
			
			
			
			
			
			
			
			// Platform.disable($xptgrp\\xptqna\\que);
			
			
			String typSql = "SELECT i.inr,i.xptsta,i.expinf,i.exptel,i.expnam,i.exppho,i.oprinr,i.expmbl FROM xptinf i WHERE 1=1";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			Argument<String> inrA = new Argument<String>("inr");
			Argument<String> xptsta = new Argument<String>("xptsta");
			Argument<String> expnam = new Argument<String>("expnam");
			Argument<String> exptel = new Argument<String>("exptel");
			Argument<String> exppho = new Argument<String>("exppho");
			Argument<String> oprinr = new Argument<String>("oprinr");
			Argument<String> expinf = new Argument<String>("expinf");
			Argument<String> expmbl = new Argument<String>("expmbl");
			MdaUtils.clear(this.getXptgrp().getXptinflst());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inrA,xptsta,expnam,exptel,exppho,oprinr,expinf,expmbl);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getXptgrp().getXptinflst().add(inrA,xptsta,expnam,exptel,exppho,oprinr,expinf,expmbl);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			MdaUtils.clear(this.getXptgrp().getXptqna());
			MdaUtils.clear(this.getXptgrp().getXptinf());
			Object xptqna = ctx.restoreData("com.brilliance.xptlst.ref");
			if(!MdaUtils.isEmpty(xptqna))
			{
			  this.getXptgrp().getXptqna().copyValue((IModule)xptqna);
			  log.debug("{}","restore inr="+this.getXptgrp().getXptqna().getInr());
			}
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getEtnnam()))
			{
			  this.getXptgrp().getXptqna().setEtnnam(this.getSysmod().getPty().getNam());
			}
			if(MdaUtils.isEmpty(this.getXptgrp().getXptqna().getSta()))
			  //    return;
			{
			  log.debug("{}","sta = " +  this.getXptgrp().getXptqna().getSta()+ " = null " );
			  
			  return true;
			}
			else
			{
			  if("F".equals(this.getXptgrp().getXptqna().getSta()))
			  {
			    //若是提问暂存则可以继续导入影像
			    
			    
			  }
			  else
			  {
			    
			  }
			  if("B".equals(this.getXptgrp().getXptqna().getSta()))
			  {
			    // 待答复的业务
			    
			  }
			  else
			  {
			    
			  }

			}
			String inr = this.getXptgrp().getXptqna().getInr();
			String xptinr = this.getXptgrp().getXptqna().getXptinr();
			log.info("{}","inr="+inr+"\txptinr="+xptinr);
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptinf(),new Argument<String>("oprinr",xptinr));
			this.getXptp().setXptpho(NULLSTR);
			if(!MdaUtils.isEmpty(this.getXptgrp().getXptinf().getExppho()))
			{
			  this.getXptp().setXptpho("/resource/"+this.getXptgrp().getXptinf().getExppho());
			  
			}
			else
			{
			  
			}
			String sta = this.getXptgrp().getXptqna().getSta();
			log.info("{}","sta="+sta);
			if(!"F".equals(sta))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			}

			
			

			return true;
        }

        /**
        *   source:xptslt.@0007.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            

			String typSql = "SELECT p.nam orgnam,a.telloc tel FROM pty p,pta t,adr a WHERE p.ptytyp='0' and t.ptyinr=p.inr and t.objinr=a.inr  order by p.inr";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			Argument<String> orgnam = new Argument<String>("orgnam");
			Argument<String> tel = new Argument<String>("tel");
			MdaUtils.clear(this.getXptgrp().getTellst());
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(orgnam,tel);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    if(MdaUtils.isEmpty(tel)  ||  MdaUtils.isEmpty(tel.value))
			      continue;
			    this.getXptgrp().getTellst().add(orgnam,tel);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }









}