package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XptstaVO;

import com.ceb.gjjs.mda.manager.module.Btnmod;
import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Xptp;
import com.ceb.gjjs.mda.manager.module.Xptbtn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Xptgrp;
import com.ceb.gjjs.mda.manager.module.Xptmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 专家信息编辑
*/
@Transaction(vo= XptstaVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xptsta extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xptsta.class);

		@BDGetter
		private Xptgrp xptgrp;

		@BDGetter
		private Xptmod xptmod;

		@BDGetter
		private Xptp xptp;

		@BDGetter
		private Xptbtn xptbtn;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Btnmod btnmod;


		public Xptsta()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
           this.getXptmod().setXptgrpHolder(()->this.getXptgrp());
           this.getXptp().setXptgrpHolder(()->this.getXptgrp());
        }

        /**
        *   source:xptsta.@0001.script
        */
        @Rule(target="xptp.submit",order=100)
        public boolean ruleXptpSubmitN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(this.getXptgrp().getXptinf().getInr()))
			{
			  log.info("{}","insert");
			  this.getXptgrp().getXptinf().setInr(Platform.sdbCounter("xptinf"));
			  ctx.getDaoSession().dbInsert(this.getXptgrp().getXptinf());
			}
			else
			{
			  log.info("{}","update");
			  ctx.getDaoSession().dbUpdate(this.getXptgrp().getXptinf());
			}
			ctx.getDaoSession().dbCommit();

			return true;
        }

        /**
        *   source:xptsta.@0002.script
        */
        @Rule(target="xptp.exppho",order=100)
        public boolean ruleXptpExpphoN100(){
            IContext ctx = MdaEnv.getContext();
            
			Object[] obj=(Object[])MdaUtils.getEventData();
			IStream stream=this.getXptp().getExppho();
			String phonam = upload(stream,obj);
			if(phonam!=null)
			{
			  this.getXptgrp().getXptinf().setExppho(phonam);
			}
			

			return true;
        }

        /**
        *   source:xptsta.@0003.script
        */
        @Rule(target="xptp.seladm",order=100)
        public boolean ruleXptpSeladmN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:xptsta.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getXptgrp().getXptinf());
			ctx.getDaoSession().dbRead(this.getXptgrp().getXptinf(),new Argument("oprinr",this.getSysmod().getUsr().getInr()));
			if(MdaUtils.isEmpty(this.getXptgrp().getXptinf().getInr()))
			{
			  this.getXptgrp().getXptinf().setOprinr(this.getSysmod().getUsr().getInr());
			}
			log.info("{}","oprinr="+this.getXptgrp().getXptinf().getOprinr());

			return true;
        }


        /**
        *   source:xptsta.@0004.script
        */
        public String upload(IStream stream,Object[] obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String filename=  obj[1].toString();
			int index = filename.indexOf(".");
			log.info("{}","up nam="+filename.substring(index+1));
			String nam=filename.substring(index+1);
			String inr= this.getSysmod().getUsr().getInr();
			// jpg ,JPG, gif ,GIF ,png, PNG
			if(nam.equalsIgnoreCase("jpg")  ||  nam.equalsIgnoreCase("gif")  ||  nam.equalsIgnoreCase("png"))
			{
			  String filePath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/upimg/");
			  log.info("{}","filePath="+filePath);
			  MdaUtils.streamSave(stream,filePath+"/"+inr+".png");
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptsta","CT000000"),MdaUtils.getI18NString("xptsta","CT000001"));
			  return null;
			}
			ctx.setMessage(MdaUtils.getI18NString("xptsta","CT000002"),MdaUtils.getI18NString("xptsta","CT000003"));
			return inr+".png";
		}







}