package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Actp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Actp.class);

        //币种
        private String cur;

        //查看修改按钮
        private transient IControl infame = new ControlImpl("infame", "查看修改按钮", this);

        //新增按钮
        private transient IControl add = new ControlImpl("add", "新增按钮", this);

        //删除按钮
        private transient IControl del = new ControlImpl("del", "删除按钮", this);

        //确认
        private transient IControl cof = new ControlImpl("cof", "确认", this);

        //取消
        private transient IControl cel = new ControlImpl("cel", "取消", this);

        //查询
        private transient IControl select = new ControlImpl("select", "查询", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel actedi;

        @JsonIgnore
        @BDGetter
        private transient IPanel actpan;


		@BDGetter
		private ModuleList<Act> actlst;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Actgrp> actgrp;


		public Actp()
        {
            super();
            setArgument();
        }

        public Actp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:actp.@0000.script
        */
        @Rule(target="infame",order=100)
        public boolean ruleInfameN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			if(index<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("actp","CT000038"),MdaUtils.getI18NString("actp","CT000039"));
			  return false;
			}
			String inr = this.getActlst().getElement(index).getInr();
			ctx.getDaoSession().dbRead(this.getActgrp().getRec(),new Argument<String>("inr",inr));
			

			return true;
        }

        /**
        *   source:actp.@0001.script
        */
        @Rule(target="add",order=100)
        public boolean ruleAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:actp.@0002.script
        */
        @Rule(target="del",order=100)
        public boolean ruleDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			int idx = 0;
			if(idx<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("actp","CT000018"),MdaUtils.getI18NString("actp","CT000019"));
			  return false;
			}
			if(!MdaUtils.prompt(MdaUtils.getI18NString("actp","CT000022"),MdaUtils.getI18NString("actp","CT000023")))
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.getDaoSession().dbDelete(this.getActlst().getElement(idx));
			  ctx.getDaoSession().dbCommit();
			  this.getActlst().remove(idx);
			  
			  ctx.setMessage(MdaUtils.getI18NString("actp","CT000053"),MdaUtils.getI18NString("actp","CT000054"));
			}

			return true;
        }

        /**
        *   source:actp.@0003.script
        */
        @Rule(target="cof",order=100)
        public boolean ruleCofN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!ctx.checkAll(this))
			  return false;
			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(this.getActgrp().getRec().getInr()))
			{
			  String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			  log.debug("{}","message ptyinr = "+ptyinr);
			  this.getActgrp().getRec().setPtyinr( ptyinr);
			  this.getActgrp().getRec().setInr( Platform.sdbCounter("act"));
			  
			  log.info("{}","belbchinr="+this.getActgrp().getRec().getOpnbchinr());
			  String baknamsql = "select nam from pty where extkey = '"+this.getActgrp().getRec().getOpnbchinr()+"'";
			  Argument<String> nam = new Argument<String>("nam");
			  ctx.getDaoSession().dbExecuteSQL(baknamsql);
			  ctx.getDaoSession().dbFetchFields(nam);
			  ctx.getDaoSession().dbCloseCursor();
			  log.info("{}","nam="+nam.value);
			  String scnam = nam.value;
			  this.getActgrp().getRec().setOpnbchnam(scnam);
			  ctx.getDaoSession().dbInsert(this.getActgrp().getRec());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getActgrp().getRec());
			}
			ctx.getDaoSession().dbCommit();
			MdaUtils.clear(this.getActgrp().getRec());
			
			search();

			return true;
        }

        /**
        *   source:actp.@0004.script
        */
        @Rule(target="cel",order=100)
        public boolean ruleCelN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getActgrp().getRec());
			

			return true;
        }

        /**
        *   source:actp.@0007.script
        */
        @Rule(target="select",order=100)
        public boolean ruleSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			search();

			return true;
        }


        /**
        *   source:actp.@0010.script
        */
        @Check(target="actgrp.rec.act",order=100)
        public boolean checkActgrpRecActN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getActgrp().getRec().getAct().toString().length() > 21)
			{
			  ctx.setFieldError(this,"actgrp.rec.act",MdaUtils.getI18NString("actp","CT000065"));
			  return true;
			}

			return true;
        }



        /**
        *   source:actp.@0008.script
        */
        public List<CodetableItem> getCurrency()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> items = new ArrayList<CodetableItem>();
			CodetableItem cod = new CodetableItem("","");
			items.add(cod);
			String sql = "SELECT inr,cur FROM currat";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> cur = new Argument<String>("cur");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cur);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem codtle = new CodetableItem(cur.value,inr.value);
			    items.add(codtle);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","message items = "+items);
			return items;
		}
        /**
        *   source:actp.@0009.script
        */
        public void search()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActlst());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			if(MdaUtils.isEmpty(this.getCur()))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("ptyinr",ptyinr));
			  
			}
			else
			{
			  String cur = this.getCur();
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",cur),new Argument<String>("ptyinr",ptyinr));
			  MdaUtils.clear(this.getActgrp().getCurrat());
			  
			  
			}
		}



        public void setActgrpHolder(ModuleHolder<Actgrp> actgrp)
        {
           this.actgrp = actgrp;
        }

        public Actgrp getActgrp()
        {
           return this.actgrp.get();
        }















}