package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Agrlst;
import com.ceb.gjjs.mda.bo.Agr;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 银行协议编号
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Agrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Agrp.class);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //保存
        private transient IControl submit = new ControlImpl("submit", "保存", this);

        //修改
        private transient IControl modify = new ControlImpl("modify", "修改", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //贸易融资综合协议编号
        private String tfn;

        //衍生交易总协议编号
        private String nma;

        //综合授信协议编号
        private String ccl;


        @JsonIgnore
        @BDGetter
        private transient IPanel agrque;

        @JsonIgnore
        @BDGetter
        private transient IPanel agredt;


	    @BDGetter
		private Agr agrnum;

		@BDGetter
		private ModuleList<Agrlst> agrlst;

	    @BDGetter
		private Agr tfnnum;

	    @BDGetter
		private Agr nmanum;

	    @BDGetter
		private Agr cclnum;

	    @BDGetter
		private Pty clipty;


		public Agrp()
        {
            super();
            setArgument();
        }

        public Agrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:agrp.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if("2".equals($\\sysmod\\pty\\ptytyp.getValue()))
			  {
			  Platform.dbRead($tfnnum,new Argument<String>("agrtyp","TFN"),new Argument<String>("cid",$\\sysmod\\pty\\cid.getValue()));
			  Platform.dbRead($nmanum,new Argument<String>("agrtyp","NMA"),new Argument<String>("cid",$\\sysmod\\pty\\cid.getValue()));
			  Platform.dbRead($cclnum,new Argument<String>("agrtyp","CCL"),new Argument<String>("cid",$\\sysmod\\pty\\cid.getValue()));
			
			  $tfn.setValue($tfnnum\\agrnum.getValue());
			  $nma.setValue($nmanum\\agrnum.getValue());
			  $ccl.setValue($cclnum\\agrnum.getValue());
			
			  log.info("tfn = " + $tfn.getValue()+" ,nma = " + $nma.getValue() + " ,ccl = " + $ccl.getValue());
			  }*/

			return true;
        }


        /**
        *   source:agrp.@0001.script
        */
        public void qurAgrnum()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(this.getTfnnum(),new Argument<String>("agrtyp","TFN"),new Argument<String>("cid",ctx.absGet(Sysmod.class).getPty().getCid()));
			ctx.getDaoSession().dbRead(this.getNmanum(),new Argument<String>("agrtyp","NMA"),new Argument<String>("cid",ctx.absGet(Sysmod.class).getPty().getCid()));
			ctx.getDaoSession().dbRead(this.getCclnum(),new Argument<String>("agrtyp","CCL"),new Argument<String>("cid",ctx.absGet(Sysmod.class).getPty().getCid()));

			this.setTfn(this.getTfnnum().getAgrnum());
			this.setNma(this.getNmanum().getAgrnum());
			this.setCcl(this.getCclnum().getAgrnum());

			log.info("{}","tfn = " + this.getTfn()+" ,nma = " + this.getNma() + " ,ccl = " + this.getCcl());

		}





























}