package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Pdfdoc;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Apldoc extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Apldoc.class);

        //临时流字段
        private IStream tempstm = new StreamImpl();



	    @BDGetter
		private Pdfdoc pdfdoc;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;


		public Apldoc()
        {
            super();
            setArgument();
        }

        public Apldoc(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:apldoc.@0000.script
        */
        public void generatorAllPDF()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *生成所有的PDF，同时填充部分pdfdoc信息
			  */
			log.debug("{}","in generatorAllPDF...");
			int cnt = this.getPdfdoc().getDoccnt();
			if(MdaUtils.isEmpty(cnt))
			{
			  return ;
			}
			// pdf模板名称
			String pdfFile = null;
			Boolean flg = null;
			IStream stream = this.getTempstm();
			String filename = null;
			int index = -1;
			StringBuffer sb = new StringBuffer();
			StringBuffer md5s = new StringBuffer();
			int count = 0;
			int ass = 0;
			for(int i=0;i<cnt;i++)
			{
			  //文本名称
			  pdfFile = getTempfileByIndex(i);
			  log.debug("{}","pdfFile=="+ pdfFile);
			  flg = this.isApplicationsForm(i);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().setGenPdfOptions(false,flg,true,false);
			  MdaUtils.streamClear(stream);
			  if(!flg)
			  {
			    Platform.setContractFlg();
			  }
			  //文本类型:SABC
			  String form = this.getDocumentFormByIndex(i);
			  if("S".equals(form))
			  {
			    // TODO - 待扩充为 申请书 +Swift报文草稿+协议
			    //swift报文
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().generatorSwiftPdf(pdfFile,stream,false);
			  }
			  else if("A".equals(form))
			  {
			    //pdf文本
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).generatorPdf("",pdfFile,stream,false);
			  }
			  else if("B".equals(form))
			  {
			    //国结来报报文
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().generatorStlSwfPdf(count,pdfFile,stream,false);
			    count = count + 1;
			  }
			  else if("C".equals(form))
			  {
			    //国结来报面函
			    // String mnt = $\\sysmod\\pdfmod.getXmlFileCount(ass);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().generatorStlPdf(ass,"",pdfFile,stream,false);
			    ass = ass + 1;
			  }
			  filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().getPDFTempFile(),"pdf");
			  log.debug("{}","filename=" + filename);
			  MdaUtils.streamSave(stream,filename);
			  md5s.append(MdaUtils.fileMD5Value(filename));
			  index = filename.lastIndexOf(java.io.File.separator);
			  log.debug("{}","index="+index);
			  filename = filename.substring(index + 1);
			  sb.append(filename);
			  if(i != cnt - 1)
			  {
			    md5s.append(",");
			    sb.append(",");
			  }
			  log.debug("{}","md3s=" + md5s);
			  log.debug("{}","filename="+sb);
			}
			this.getPdfdoc().setMd5(md5s.toString());
			this.getPdfdoc().setPdffilnam(sb.toString());

		}
        /**
        *   source:apldoc.@0001.script
        */
        public String getFileByIndex(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in getFileByIndex ... ");
			String files = this.getPdfdoc().getPdffilnam();
			if(MdaUtils.isEmpty(files))
			{
			  return "";
			}
			String[] fileNames =  files.trim().split(",");
			if( index<0 || index>fileNames.length - 1)
			{
			  return "";
			}
			return  fileNames[index].trim();
		}
        /**
        *   source:apldoc.@0002.script
        */
        public String getLabelByIndex(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in getLabelByIndex ... ");
			String label = this.getPdfdoc().getLabel();
			if(MdaUtils.isEmpty(label))
			{
			  return "";
			}
			String[] labels =  label.trim().split(",");
			if( index<0 || index>labels.length - 1)
			{
			  return "";
			}
			return  labels[index].trim();
		}
        /**
        *   source:apldoc.@0003.script
        */
        public String getTempfileByIndex(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in getTempfileByIndex... ");
			String file = this.getPdfdoc().getTempfile();
			log.debug("{}","file===" + file);
			if(MdaUtils.isEmpty(file))
			{
			  return "";
			}
			String[] files =  file.trim().split(",");
			if( index<0 || index>files.length - 1)
			{
			  return "";
			}
			String[] pdfName = files[index].trim().split(":");
			return pdfName[1].trim();
		}
        /**
        *   source:apldoc.@0004.script
        */
        public Boolean isApplicationsForm(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 判断文本是否为申请书格式
			  */
			log.debug("{}","in isApplicationsForm... ");
			Boolean flg = false;
			String file = this.getPdfdoc().getTempfile();
			if(MdaUtils.isEmpty(file))
			{
			  return flg ;
			}
			String[] files =  file.trim().split(",");
			if( index<0 || index>files.length - 1)
			{
			  return flg;
			}
			String form = (files[index].trim().split(":"))[0];
			log.debug("{}","form="+ form);
			return "A".equalsIgnoreCase(form) ;
		}
        /**
        *   source:apldoc.@0005.script
        */
        public void loadApldocByOrdinr(String ordinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(this.getPdfdoc(),new Argument("ordinr",ordinr));
		}
        /**
        *   source:apldoc.@0006.script
        */
        public void setPDFFromContract(int cnt, String labels, String tempfiles)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getPdfdoc().setDoccnt( cnt);
			this.getPdfdoc().setLabel( labels);
			this.getPdfdoc().setTempfile( tempfiles);
		}
        /**
        *   source:apldoc.@0007.script
        */
        public void setPDFFromContract()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			this.getPdfdoc().setObjtyp( this.getTrn().getObjtyp());
			this.getPdfdoc().setObjinr( this.getTrn().getObjinr());
			this.getPdfdoc().setOwnref( this.getTrn().getOwnref());
			this.getPdfdoc().setOrdinr( this.getTrn().getOrdinr());
			this.getPdfdoc().setInifrm( this.getTrn().getInifrm());
			this.getPdfdoc().setSta( "W");
			this.getPdfdoc().setCredat( MdaUtils.today());
			if(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sptIsLoaded("B") || !MdaUtils.isEmpty(this.getPdfdoc().getInr()))
			  ctx.getDaoSession().dbUpdate(this.getPdfdoc());
			else
			{
			  this.getPdfdoc().setInr(Platform.sdbCounter("pdfdoc")) ;
			  ctx.getDaoSession().dbInsert(this.getPdfdoc());
			}
			log.debug("{}","PDFDOC inr =" + this.getPdfdoc().getInr());
			log.debug("{}","pdfdoc插表成功！！");
		}
        /**
        *   source:apldoc.@0008.script
        */
        public boolean transctionIsFinal()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return "D".equals( this.getPdfdoc().getSta());
		}
        /**
        *   source:apldoc.@0009.script
        */
        public void updateStatus(String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(sta))
			{
			  if("D".equals(sta))
			  {
			    this.getPdfdoc().setOpndat( MdaUtils.today());
			  }
			  if("E".equals(sta))
			  {
			    this.getPdfdoc().setLoseffdat( MdaUtils.today());
			  }
			}
			if(!MdaUtils.isEmpty(this.getPdfdoc().getInr()))
			{
			  ctx.getDaoSession().dbUpdate(this.getPdfdoc());
			}
		}
        /**
        *   source:apldoc.@0010.script
        */
        public void setGenPdfOptions(boolean flg,String flg1,boolean flg2,boolean flg3 )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 设置生成的PDF是否带章+打印时间+水印等信息
			  */

		}
        /**
        *   source:apldoc.@0012.script
        */
        public void generatorSwiftMessage(String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//$pdfmod.genePdfByTrn(Platform.getTransName(),filnam,pdfFile,stream,flg);
			
		}
        /**
        *   source:apldoc.@0013.script
        */
        public String getDocumentFormByIndex(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 返回文本文件的格式： A - 申请书格式 , C - 协议文本格式 , S - Swift 报文
			  */

			log.debug("{}","in isApplicationsForm... ");
			String form = null ;
			String file = this.getPdfdoc().getTempfile();
			if(MdaUtils.isEmpty(file))
			{
			  return "" ;
			}
			String[] files =  file.trim().split(",");
			if( index < 0 || index > files.length - 1)
			{

			  form = "";
			}
			else
			{
			  form = (files[index].trim().split(":"))[0];
			}
			return form;
		}
        /**
        *   source:apldoc.@0015.script
        */
        public void setPDFInfo(int cnt,String labels,String tempfiles)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getPdfdoc().setDoccnt(  cnt);
			this.getPdfdoc().setLabel( labels);
			this.getPdfdoc().setTempfile( tempfiles);
		}



        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }



}