package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 进口代收s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Aptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Aptp.class);

        //关联查询
        private transient IControl consel = new ControlImpl("consel", "关联查询", this);

        //查询
        private transient IControl queryref = new ControlImpl("queryref", "查询", this);

        //选择
        private transient IControl chance = new ControlImpl("chance", "选择", this);

        //融资类型
        private String fintyp;

        //父交易参号
        private String pntref;

        //所属落地机构
        private String bchcod;

        //获取协议编号
        private transient IControl getixdref = new ControlImpl("getixdref", "获取协议编号", this);

        //预览进口代付申请
        private transient IControl pdfapd = new ControlImpl("pdfapd", "预览进口代付申请", this);

        //预览进口代付协议
        private transient IControl pdfixd = new ControlImpl("pdfixd", "预览进口代付协议", this);

        //预览保证金协议
        private transient IControl pdfbxd = new ControlImpl("pdfbxd", "预览保证金协议", this);

        //预览保证金委托及扣划
        private transient IControl pdfmar = new ControlImpl("pdfmar", "预览保证金委托及扣划", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel aptp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn04;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapntop01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptopn06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnsub06;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep04;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep05;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdlstep06;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptmdltop;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptcfmstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptcfmstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptcfmtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptcfmstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel aptcfmsub01;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Apdgrp> apdgrp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Txmmod irfcnd;

		@BDGetter
		private ModuleList<Tmp> tmplst;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Bummod bummod;

	    @BDGetter
		private Bxdmod bxdmod;


		public Aptp()
        {
            super();
            setArgument();
        }

        public Aptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getDapp().setPtsptaHolder(()->this.getApdgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("apd"));
            this.getAplp().setPtsptaHolder(()->this.getApdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("apd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getIrfcnd().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getIrfcnd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Aptp.this.getFieldPath("apdgrp.rec.irfcnd");}
 				public void setValue(String arg){Aptp.this.getApdgrp().getRec().setIrfcnd(arg);}
 				public String getValue(){return Aptp.this.getApdgrp().getRec().getIrfcnd();}}
			 );
            this.getBxdmod().setBxdHolder(()->this.getApdgrp().getBxd());
            this.getBxdmod().setMarHolder(()->this.getApdgrp().getMar());
            this.getBxdmod().setObjtypHolder(new FieldConstantHolder<>("apd"));
            this.getBxdmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptp.this.getFieldPath("apdgrp.rec.inr");}
 				public void setValue(String arg){Aptp.this.getApdgrp().getRec().setInr(arg);}
 				public String getValue(){return Aptp.this.getApdgrp().getRec().getInr();}}
			 );
            this.getBxdmod().setRefHolder( new FieldHolder<String>(){
				public String getPath(){return Aptp.this.getFieldPath("apdgrp.rec.ownref");}
 				public void setValue(String arg){Aptp.this.getApdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Aptp.this.getApdgrp().getRec().getOwnref();}}
			 );
            this.getBxdmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Aptp.this.getFieldPath("apdgrp.rec.ptyinr");}
 				public void setValue(String arg){Aptp.this.getApdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Aptp.this.getApdgrp().getRec().getPtyinr();}}
			 );
            this.getBxdmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Aptp.this.getFieldPath("apdgrp.rec.bchcod");}
 				public void setValue(String arg){Aptp.this.getApdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Aptp.this.getApdgrp().getRec().getBchcod();}}
			 );
            this.getBxdmod().setBxdprefixHolder(new FieldConstantHolder<>("JX"));
            this.getBxdmod().setMarprefixHolder(new FieldConstantHolder<>("MZ"));
            this.getBxdmod().setMxdlstHolder(()->this.getApdgrp().getMxdlst());
        }





        public void setApdgrpHolder(ModuleHolder<Apdgrp> apdgrp)
        {
           this.apdgrp = apdgrp;
        }

        public Apdgrp getApdgrp()
        {
           return this.apdgrp.get();
        }











































}