package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Autp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Autp.class);

        //保存
        private transient IControl submit = new ControlImpl("submit", "保存", this);

        //金额设定查看
        private transient IControl amtshw = new ControlImpl("amtshw", "金额设定查看", this);

        //金额档1
        private BigDecimal amt1 = new BigDecimal("0.00");

        //金额档2
        private BigDecimal amt2 = new BigDecimal("0.00");

        //金额档3
        private BigDecimal amt3 = new BigDecimal("0.00");

        //金额档4
        private BigDecimal amt4 = new BigDecimal("0.00");

        //金额分级保存
        private transient IControl submitamt = new ControlImpl("submitamt", "金额分级保存", this);

        //金额5
        private BigDecimal amt5 = new BigDecimal("0.00");

        //添加交易
        private transient IControl add = new ControlImpl("add", "添加交易", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //金额6
        private BigDecimal amt6 = new BigDecimal("0.00");

        //金额7
        private BigDecimal amt7 = new BigDecimal("0.00");

        //金额8
        private BigDecimal amt8 = new BigDecimal("0.00");

        //金额9
        private BigDecimal amt9 = new BigDecimal("0.00");

        //已选择交易列表
        private transient IControl sel = new ControlImpl("sel", "已选择交易列表", this);

        //金额起点(默认为0)
        private BigDecimal amt0 = new BigDecimal("0.00");

        //授权类型
        private String auttyp;

        //数据流
        private IStream stream = new StreamImpl();

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //核心客户号
        private String cid;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //机构名称
        private String bchnam;

        //交易名称
        private String frmnam;

        //专业审核文件夹复核
        private String sptflg;

        //专业审核文件夹授权
        private String sptflg2;

        //客户经理夹复核
        private String mgrflg;

        //客户经理夹授权
        private String mgrflg2;

        //放款审核夹复核
        private String relflg;

        //放款审核夹授权
        private String relflg2;

        //归属机构
        private String ptynam;


        @JsonIgnore
        @BDGetter
        private transient IPanel shwamt;

        @JsonIgnore
        @BDGetter
        private transient IPanel client;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbmrel;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbmrel01;

        @JsonIgnore
        @BDGetter
        private transient IPanel dbmrel02;

        @JsonIgnore
        @BDGetter
        private transient IPanel btntp;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Autgrp> autgrp;

		@BDGetter
		private ModuleList<Pty> clilst;

	    @BDGetter
		private Pty clipty;


		public Autp()
        {
            super();
            setArgument();
        }

        public Autp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:autp.@0000.script
        */
        public String getReleaseFlg(String flg1, String flg2)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String flg ="O";
			if("0".equals(flg1))
			{
			  flg1="B";
			}
			else
			{
			  flg1="N";
			}
			if("0".equals(flg2))
			{
			  flg2="A";
			}
			else
			{
			  flg2="N";
			}
			flg = flg + flg1 + flg2;
			return flg ;
		}
        /**
        *   source:autp.@0002.script
        */
        public void clearAllFlg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","clear All Flg ... ");
			this.setSptflg(NULLSTR);
			this.setSptflg2(NULLSTR);
			this.setMgrflg(NULLSTR);
			this.setMgrflg2(NULLSTR);
			this.setRelflg(NULLSTR);
			this.setRelflg2(NULLSTR);
			
			
			
			
			
			
		}
        /**
        *   source:autp.@0003.script
        */
        public void setReleaseFlg(String flg,String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","flg =" + flg +",frm ="+frm);
			if(!MdaUtils.isEmpty(frm) && !MdaUtils.isEmpty(flg))
			{
			  String flgVal = flg.substring(1,2);
			  String flg2Val= flg.substring(2,3);
			  if(flgVal.equals("N"))
			  {
			    flgVal = "1";
			  }
			  else
			  {
			    flgVal = "0";
			  }
			  if(flg2Val.equals("N"))
			  {
			    flg2Val = "1";
			  }
			  else
			  {
			    flg2Val = "0";
			  }
			  frm=frm.substring(3,6);
			  log.debug("{}","frm=" + frm );
			  IDatafield<String> fld =(IDatafield<String>) MdaDriver.getDatafield(this,frm+"flg");
			  IDatafield<String> fld2 = (IDatafield<String>)MdaDriver.getDatafield(this,frm+"flg2");
			  fld.setValue(flgVal);
			  fld2.setValue(flg2Val);
			  if(flgVal.equals("1"))
			  {
			    
			  }
			  else
			  {
			    
			  }
			  
			  
			  log.debug("{}","flgVal =" +flgVal +",flg" + flg2Val );
			}

		}

        public void setAutgrpHolder(ModuleHolder<Autgrp> autgrp)
        {
           this.autgrp = autgrp;
        }

        public Autgrp getAutgrp()
        {
           return this.autgrp.get();
        }

































































}