package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 数据隔离公共模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bchmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bchmod.class);



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Pty> pty;


		public Bchmod()
        {
            super();
            setArgument();
        }

        public Bchmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:bchmod.@0000.script
        */
        public List<CodetableItem> getPntBchcod(String ptycid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*根据机构号来获取分行机构*/
			//ptytyp-0:兴业机构,brhlvl-1:总行,2:分行,3:支行
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			String querysql="SELECT cid,nam FROM pty WHERE ptytyp='0' AND cid='"+ptycid+"'";
			ctx.getDaoSession().dbExecuteSQL(querysql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> cid=new Argument<String>("cid");
			  Argument<String> nam=new Argument<String>("nam");
			  ctx.getDaoSession().dbFetchFields(cid,nam);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    bchcod.add(new CodetableItem(nam.value,cid.value));
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:bchmod.@0001.script
        */
        public List<CodetableItem> getAllBchcodofCIB()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/* 取兴业银行的总行和分行机构 */
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			//ptytyp-0:兴业机构,brhlvl-1:总行,2:分行,3:支行
			String querysql="SELECT cid,nam FROM pty WHERE ptytyp='0'  AND (lvl='1' OR lvl='2') ORDER BY cid ";
			//i -测试用字段，无误后可删除
			ctx.getDaoSession().dbExecuteSQL(querysql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> cid=new Argument<String>("cid");
			  Argument<String> nam=new Argument<String>("nam");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(cid,nam);
			    if(NO_ERROR==ctx.getErrorCode())
			      bchcod.add(new CodetableItem(nam.value,cid.value));
			    else
			      break;
			  }
			}
			//log.info("the size of bchcod---"+i);
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:bchmod.@0002.script
        */
        public String getBchlvl(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String level="";
			if(!MdaUtils.isEmpty(cid))
			{
			  String sql="SELECT brhlvl FROM pty WHERE cid='"+cid+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    Argument<String> brhlvl=new Argument<String>("brhlvl");
			    ctx.getDaoSession().dbFetchFields(brhlvl);
			    if(NO_ERROR==ctx.getErrorCode())
			      level=brhlvl.value;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			return level;
		}
        /**
        *   source:bchmod.@0003.script
        */
        public List<CodetableItem> getBrhBchcod(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*根据机构号来获取分行机构*/
			//ptytyp-0:兴业机构,brhlvl-1:总行,2:分行,3:支行
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			String querysql="SELECT cid,nam FROM pty WHERE ptytyp='0' AND inr='"+ptyinr+"'";
			ctx.getDaoSession().dbExecuteSQL(querysql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> cid=new Argument<String>("cid");
			  Argument<String> nam=new Argument<String>("nam");
			  ctx.getDaoSession().dbFetchFields(cid,nam);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    bchcod.add(new CodetableItem(nam.value,cid.value));
			  }
			}
			//log.info("the size of bchcod---"+i);
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:bchmod.@0004.script
        */
        public List<CodetableItem> getSubBchcod(String ptycid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*根据机构号来获取分行的下属机构*/
			//ptytyp-0:兴业机构,brhlvl-1:总行,2:分行,3:支行
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			String querysql="SELECT cid,nam FROM pty WHERE ptytyp='0' AND lvl='3'"
			  +" AND SUBSTR(cid,1,2)=SUBSTR("+ptycid+",1,2)";
			ctx.getDaoSession().dbExecuteSQL(querysql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> cid=new Argument<String>("cid");
			  Argument<String> nam=new Argument<String>("nam");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(cid,nam);
			    //log.info("after fetch, errorcode is ---"+Platform.errorCode());
			    if(NO_ERROR==ctx.getErrorCode())
			      bchcod.add(new CodetableItem(nam.value,cid.value));
			    else
			      break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:bchmod.@0005.script
        */
        public String getUsrlvlofCIB(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String usrlvl="";
			if(!MdaUtils.isEmpty(ptyinr))
			{
			  String sql="SELECT brhlvl FROM pty WHERE inr='"+ptyinr+ "' ";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    Argument<String> brhlvl=new Argument<String>("brhlvl");
			    ctx.getDaoSession().dbFetchFields(brhlvl);
			    if(NO_ERROR==ctx.getErrorCode())
			      usrlvl=brhlvl.value;
			  }
			  // log.info("the size of bchcod---"+i);
			  ctx.getDaoSession().dbCloseCursor();
			}
			log.info("{}","the usr level = "+usrlvl);
			return usrlvl;
		}
        /**
        *   source:bchmod.@0006.script
        */
        public String getBrhNam(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*根据机构号查询机构名称*/
			String bchnam="";
			String sql="SELECT nam ptynam FROM pty WHERE cid='"+cid+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> ptynam=new Argument<String>("ptynam");
			  ctx.getDaoSession().dbFetchFields(ptynam);
			  if(NO_ERROR==ctx.getErrorCode())
			    bchnam=ptynam.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchnam;
		}
        /**
        *   source:bchmod.@0007.script
        */
        public List<CodetableItem> getBchcodByDZTLevel(String level)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*根据机构号来获取分行的下属机构*/
			//ptytyp-0:兴业机构,brhlvl-1:总行,2:分行,3:支行
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			String querysql="SELECT cid,nam FROM pty WHERE ptytyp='0' AND lvl='"+level+"'";
			ctx.getDaoSession().dbExecuteSQL(querysql);
			if(NO_ERROR==ctx.getErrorCode())
			{
			  Argument<String> cid=new Argument<String>("cid");
			  Argument<String> nam=new Argument<String>("nam");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(cid,nam);
			    if(NO_ERROR==ctx.getErrorCode())
			      bchcod.add(new CodetableItem(nam.value,cid.value));
			    else
			      break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:bchmod.@0008.script
        */
        public String sdbGetBranchSql(String ptyinr,String column,String sql,List objs,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 返回机构隔离对应的SQL
			  */
			//String inr=$pty\\inr;
			//String lev=$pty\\lvl;
			//if(!inr.equals(ptyinr))
			//{
			//inr = ptyinr;
			String lev = this.getBranchLevelByInr(ptyinr);
			//String cid=$\\sysmod.getCidByInr(ptyinr);
			log.debug("{}","lev    值="+lev);
			//}
			sql=sql+" and (ptytyp=0 or modtyp = 1)";
			if("0".equals(lev))
			{
			  sql = sql + " AND(("+column+" is null and wfm='D') or EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr )) " ;
			  //sql = sql + " AND EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr or "+column+"= ?) " ;
			  //objs.add(ptyinr);
			}
			else if("1".equals(lev))
			{
			  sql = sql + " AND EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr and (bch.inr= ? or bch.pntinr= ? )  or "+column+"= ? ) " ;
			  objs.add(ptyinr);
			  objs.add(cid);
			  objs.add(ptyinr);
			}
			else if("2".equals(lev))
			{
			  sql = sql + " AND " + column + "= ? ";
			  objs.add(ptyinr);
			}
			return sql;
		}
        /**
        *   source:bchmod.@0009.script
        */
        public String getBranchLevelByInr(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String level="";
			if(!MdaUtils.isEmpty(inr))
			{
			  String sql="SELECT lvl FROM pty WHERE inr='"+inr+"'";
			  Argument<String> lvl=new Argument<String>("lvl");
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(lvl);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    level=lvl.getValue();
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			return level;

		}
        /**
        *   source:bchmod.@0010.script
        */
        public String getBranchLvlByInr(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String level="";
			if(!MdaUtils.isEmpty(inr))
			{
			  Argument<String> lvl=new Argument<String>("lvl");
			  String sql="SELECT lvl FROM pty WHERE inr='"+inr+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(lvl);
			  if(NO_ERROR==ctx.getErrorCode())
			  {
			    level=lvl.getValue();
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			return level;

		}
        /**
        *   source:bchmod.@0011.script
        */
        public String sdbGetBnkBranchSql(String ptyinr,String column,String sql,List objs,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 返回机构隔离对应的SQL
			  */
			//String inr=$pty\\inr;
			//String lev=$pty\\lvl;
			//if(!inr.equals(ptyinr))
			//{
			//inr = ptyinr;
			String lev = this.getBranchLevelByInr(ptyinr);
			//String cid=$\\sysmod.getCidByInr(ptyinr);
			log.debug("{}","lev    值="+lev);
			//}
			sql=sql+" and  modtyp = 9";
			if("0".equals(lev))
			{
			  sql = sql + " AND(("+column+" is null and wfm='D') or EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr )) " ;
			  //sql = sql + " AND EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr or "+column+"= ?) " ;
			  //objs.add(ptyinr);
			}
			else if("1".equals(lev))
			{
			  sql = sql + " AND EXISTS (SELECT inr FROM pty bch WHERE "+column+"= bch.inr and (bch.inr= ? or bch.pntinr= ? )  or "+column+"= ? ) " ;
			  objs.add(ptyinr);
			  objs.add(cid);
			  objs.add(ptyinr);
			}
			else if("2".equals(lev))
			{
			  sql = sql + " AND " + column + "= ? ";
			  objs.add(ptyinr);
			}
			return sql;
		}

        public void setPtyHolder(ModuleHolder<Pty> pty)
        {
           this.pty = pty;
        }

        public Pty getPty()
        {
           return this.pty.get();
        }

}