package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 进口代收s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bctp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bctp.class);

        //拒付结果：
        private String rejectlabel;

        //tempvar
        private String tempvar;

        //ok
        private transient IControl ok = new ControlImpl("ok", "ok", this);

        //add
        private transient IControl add = new ControlImpl("add", "add", this);

        //费用承担
        private String fycd;

        //活动界面
        private IPanel transpanel;

        //获取参号（押汇）
        private transient IControl getreftr = new ControlImpl("getreftr", "获取参号（押汇）", this);

        //获取参号（代付）
        private transient IControl getrefdf = new ControlImpl("getrefdf", "获取参号（代付）", this);

        //代付参号
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefixdf = new FieldConstantHolder<>("");


        //押汇参号
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefixtr = new FieldConstantHolder<>("");


        //预览进口押汇申请书
        private IStream pdftrd = new StreamImpl();

        //预览同业代付申请书
        private IStream pdfdfd = new StreamImpl();

        //现汇
        private String cur;

        //购汇
        private String cur1;

        //他汇
        private String cur2;

        //fx账户选择按钮
        private transient IControl fxbut = new ControlImpl("fxbut", "fx账户选择按钮", this);

        //pur账户选择按钮
        private transient IControl purbut = new ControlImpl("purbut", "pur账户选择按钮", this);

        //oth账户选择按钮
        private transient IControl othbut = new ControlImpl("othbut", "oth账户选择按钮", this);

        //账户选择按钮标记
        private String actchsflg;

        //账号
        private String acc;

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择
        private transient IControl actsurel = new ControlImpl("actsurel", "账户选择", this);

        //账户类型
        private String acttyp;

        //利息数值1
        private String arrnum1;

        //利息数值2
        private String arrnum2;

        //利息数值3
        private String arrnum3;

        //押汇期限
        private String subday;

        //大写
        private String word;

        //结息方式
        private String jxfs;


        @JsonIgnore
        @BDGetter
        private transient IPanel bctp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel othpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel nbctp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtptrans;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs2;

        @JsonIgnore
        @BDGetter
        private transient IPanel bcts0;

        @JsonIgnore
        @BDGetter
        private transient IPanel bcts1;

        @JsonIgnore
        @BDGetter
        private transient IPanel bcts2;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctp3;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bcdgrp> bcdgrp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp drrp;

	    @BDGetter
		private Ptsp rmip;

	    @BDGetter
		private Docgrdm docgrdm;

	    @BDGetter
		private Bnkrec bnkrec;

	    @BDGetter
		private Ptsp dapp;

		@BDGetter
		private ModuleList<Cls> clslst;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Apdgrp> apdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trdgrp> trdgrp;

		@BDGetter
		private ModuleList<Act> actlst;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Fpdgrp fpdgrp;

	    @BDGetter
		private Agrp agrp;


		public Bctp()
        {
            super();
            setArgument();
        }

        public Bctp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getDrep().setPtsptaHolder(()->this.getBcdgrp().getDre());
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("bcd"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrrp().setPtsptaHolder(()->this.getBcdgrp().getDrr());
            this.getDrrp().setBelongtoHolder(new FieldConstantHolder<>("bcd"));
            this.getDrrp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getDrrp().setRolHolder(new FieldConstantHolder<>("drr"));
            this.getRmip().setPtsptaHolder(()->this.getBcdgrp().getRmi());
            this.getRmip().setBelongtoHolder(new FieldConstantHolder<>("bcd"));
            this.getRmip().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getRmip().setRolHolder(new FieldConstantHolder<>("rmi"));
            this.getDocgrdm().setOthdocHolder( new FieldHolder<String>(){
				public String getPath(){return Bctp.this.getFieldPath("bcdgrp.bnkrecd.othdoc");}
 				public void setValue(String arg){Bctp.this.getBcdgrp().getBnkrecd().setOthdoc(arg);}
 				public String getValue(){return Bctp.this.getBcdgrp().getBnkrecd().getOthdoc();}}
			 );
            this.getBnkrec().setBnkrecdHolder(()->this.getBcdgrp().getBnkrecd());
            this.getBnkrec().setCmcrecdHolder(()->this.getBcdgrp().getCmcrecd());
            this.getDapp().setPtsptaHolder(()->this.getBcdgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bcd"));
        }

        /**
        *   source:bctp.@0000.script
        */
        @Rule(target="getrefdf",order=100)
        public boolean ruleGetrefdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("ZX".equals(this.getPrefixdf()))
			  return false;
			else
			  getRefdf();

			return true;
        }

        /**
        *   source:bctp.@0001.script
        */
        @Rule(target="getreftr",order=100)
        public boolean ruleGetreftrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("ZX".equals(this.getPrefixtr()))
			  return false;
			else
			  getReftr();

			return true;
        }




        /**
        *   source:bctp.@0002.script
        */
        public void getRefdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getApdgrp().getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getPrefixdf() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefixdf()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}
        /**
        *   source:bctp.@0003.script
        */
        public void getReftr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getTrdgrp().getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getPrefixtr() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefixtr()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}
        /**
        *   source:bctp.@0004.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"jrmb".equals(this.getActchsflg()))
			{
			  MdaUtils.clear(this.getActchs());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();

			  if("pur".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			  else if("oth".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("ptyinr",ptyinr));
			  else
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBcdgrp().getRec().getDoccur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}
			else
			{
			  MdaUtils.clear(this.getActchs2());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBcdgrp().getRec().getJacccur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}

		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setBcdgrpHolder(ModuleHolder<Bcdgrp> bcdgrp)
        {
           this.bcdgrp = bcdgrp;
        }

        public Bcdgrp getBcdgrp()
        {
           return this.bcdgrp.get();
        }















        public void setApdgrpHolder(ModuleHolder<Apdgrp> apdgrp)
        {
           this.apdgrp = apdgrp;
        }

        public Apdgrp getApdgrp()
        {
           return this.apdgrp.get();
        }

        public void setTrdgrpHolder(ModuleHolder<Trdgrp> trdgrp)
        {
           this.trdgrp = trdgrp;
        }

        public Trdgrp getTrdgrp()
        {
           return this.trdgrp.get();
        }





























        public void setPrefixdfHolder(FieldHolder<String> prefixdf)
        {
           this.prefixdf = (prefixdf);
        }

        public void setPrefixdf(String prefixdf)
        {
            this.prefixdf.setValue(prefixdf);
        }

        public String getPrefixdf()
        {
            return this.prefixdf.getValue();
        }



        public void setPrefixtrHolder(FieldHolder<String> prefixtr)
        {
           this.prefixtr = (prefixtr);
        }

        public void setPrefixtr(String prefixtr)
        {
            this.prefixtr.setValue(prefixtr);
        }

        public String getPrefixtr()
        {
            return this.prefixtr.getValue();
        }







































}