package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Bdd;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bdtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bdtp.class);

        //拒付结果：
        private String rejectlabel;

        //承兑确认书
        private IStream accdoc = new StreamImpl();

        //拒付通知书
        private IStream rejdoc = new StreamImpl();

        //金额大写
        private String advamt;

        //落地机构中文名
        private String bchcod;

        //申请日期
        private String credat;

        //承兑日期
        private String accdat;

        //单据信息获取
        private transient IControl getref = new ControlImpl("getref", "单据信息获取", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //申请人
        private String aplnam;


        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel bddinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtp10;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bddgrp> bddgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Didgrp> didgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp prbp;

	    @BDGetter
		private Ptsp bebp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

		@BDGetter
		private ModuleList<Bdd> bddlst;

	    @BDGetter
		private Pdfviw pdfviw;


		public Bdtp()
        {
            super();
            setArgument();
        }

        public Bdtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getBddgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getBenp().setPtsptaHolder(()->this.getBddgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getPrbp().setPtsptaHolder(()->this.getBddgrp().getPrb());
            this.getPrbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getPrbp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getPrbp().setRolHolder(new FieldConstantHolder<>("prb"));
            this.getBebp().setPtsptaHolder(()->this.getBddgrp().getBeb());
            this.getBebp().setRolHolder(new FieldConstantHolder<>("beb"));
            this.getBebp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getBebp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getDapp().setPtsptaHolder(()->this.getBddgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("bdd"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setPtsptaHolder(()->this.getBddgrp().getTrp());
        }





        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setBddgrpHolder(ModuleHolder<Bddgrp> bddgrp)
        {
           this.bddgrp = bddgrp;
        }

        public Bddgrp getBddgrp()
        {
           return this.bddgrp.get();
        }

        public void setDidgrpHolder(ModuleHolder<Didgrp> didgrp)
        {
           this.didgrp = didgrp;
        }

        public Didgrp getDidgrp()
        {
           return this.didgrp.get();
        }





































}