package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Led;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Betp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Betp.class);

        //获得出口信用证来证通知的信息
        private transient IControl getled = new ControlImpl("getled", "获得出口信用证来证通知的信息", this);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl del = new ControlImpl("del", "删除", this);

        //LOGO标志
        private String logo;

        //OK
        private transient IControl ok = new ControlImpl("ok", "OK", this);

        //tempvar
        private String tempvar;

        //专家咨询
        private transient IControl adv = new ControlImpl("adv", "专家咨询", this);

        //申请事项
        private String title;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //落地机构
        private String bchcod;

        //选择
        private transient IControl cho = new ControlImpl("cho", "选择", this);

        //退出
        private transient IControl ext = new ControlImpl("ext", "退出", this);

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel betp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp14;

        @JsonIgnore
        @BDGetter
        private transient IPanel othpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel betp15;

        @JsonIgnore
        @BDGetter
        private transient IPanel betcdvame;

        @JsonIgnore
        @BDGetter
        private transient IPanel betrgg;

        @JsonIgnore
        @BDGetter
        private transient IPanel betddv;

        @JsonIgnore
        @BDGetter
        private transient IPanel advsel;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ledgrp> ledgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bedgrp> bedgrp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Docgrdm docgrdm;

	    @BDGetter
		private Bnkrec bnkrec;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp bebp;

	    @BDGetter
		private Ptsp othp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp rmbp;

		@BDGetter
		private ModuleList<Cls> clslst;

		@BDGetter
		private ModuleList<Led> ledlst;

	    @BDGetter
		private Pdfviw pdfviw;


		public Betp()
        {
            super();
            setArgument();
        }

        public Betp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getIsbp().setPtsptaHolder(()->this.getLedgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBenp().setPtsptaHolder(()->this.getLedgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getDocgrdm().setOthdocHolder( new FieldHolder<String>(){
				public String getPath(){return Betp.this.getFieldPath("bedgrp.bnkrecd.othdoc");}
 				public void setValue(String arg){Betp.this.getBedgrp().getBnkrecd().setOthdoc(arg);}
 				public String getValue(){return Betp.this.getBedgrp().getBnkrecd().getOthdoc();}}
			 );
            this.getBnkrec().setBnkrecdHolder(()->this.getBedgrp().getBnkrecd());
            this.getBnkrec().setCmcrecdHolder(()->this.getBedgrp().getCmcrecd());
            this.getAplp().setPtsptaHolder(()->this.getBedgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBebp().setPtsptaHolder(()->this.getBedgrp().getBeb());
            this.getBebp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBebp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getBebp().setRolHolder(new FieldConstantHolder<>("beb"));
            this.getOthp().setPtsptaHolder(()->this.getBedgrp().getOth());
            this.getOthp().setRolHolder(new FieldConstantHolder<>("oth"));
            this.getOthp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getOthp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setPtsptaHolder(()->this.getBedgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getDapp().setPtsptaHolder(()->this.getBedgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getRmbp().setPtsptaHolder(()->this.getBedgrp().getRmb());
            this.getRmbp().setRolHolder(new FieldConstantHolder<>("rmb"));
            this.getRmbp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getRmbp().setFlgHolder(new FieldConstantHolder<>("agt"));
        }




        /**
        *   source:betp.@0000.script
        */
        public void encodeApl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getBedgrp().setDocnum(NULLSTR);
			this.getBedgrp().setDoccpy(NULLSTR);
			this.getBedgrp().setDoctyp(NULLSTR);
			int len = this.getDocgrdm().getDocgrd().fullSize();
			StringBuffer docnum=new StringBuffer();
			StringBuffer doccpy=new StringBuffer();
			StringBuffer doctyp=new StringBuffer();
			String conn="";
			String cc = null;
			for(int i=0;i<len;i++)
			{
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDocnum();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  docnum.append(conn).append(cc);
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDoccpy();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  doccpy.append(conn).append(cc);
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDoctyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  doctyp.append(conn).append(cc);
			  conn = ",";
			}
			log.info("{}","docnum:"+docnum);
			log.info("{}","doccpy:"+doccpy);
			log.info("{}","doctyp:"+doctyp);
			this.getBedgrp().setDocnum(docnum.toString());
			this.getBedgrp().setDoccpy(doccpy.toString());
			this.getBedgrp().setDoctyp(doctyp.toString());
		}
        /**
        *   source:betp.@0002.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setLedgrpHolder(ModuleHolder<Ledgrp> ledgrp)
        {
           this.ledgrp = ledgrp;
        }

        public Ledgrp getLedgrp()
        {
           return this.ledgrp.get();
        }

        public void setBedgrpHolder(ModuleHolder<Bedgrp> bedgrp)
        {
           this.bedgrp = bedgrp;
        }

        public Bedgrp getBedgrp()
        {
           return this.bedgrp.get();
        }





















































}