package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Brd;
import com.ceb.gjjs.mda.bo.Bdd;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ebhfat;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bimenu extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bimenu.class);

        //bchcod
        private String bchcod;

        //ownref
        private String ownref;

        //grptyp
        private String grptyp;

        //frm
        private String frm;

        //objtyp
        private String objtyp;

        //objnam
        private String objnam;

        //ptyinr
        private String ptyinr;

        //mt
        private String mt;

        //m1
        private String m1;

        //m2
        private String m2;

        //m3
        private String m3;

        //m4
        private String m4;

        //m5
        private String m5;

        //m6
        private String m6;

        //m7
        private String m7;

        //m8
        private String m8;

        //m9
        private Date m9;

        //a1
        private String a1;

        //a2
        private String a2;

        //a3
        private String a3;

        //a4
        private String a4;

        //a5
        private String a5;

        //a6
        private String a6;

        //a8
        private String a7;

        //a8
        private String a8;

        //a9
        private String a9;

        //objinr
        private String objinr;

        //stlref
        private String stlref;

        //cid
        private String cid;

        //cliptyinr
        private String cliptyinr;

        //所属实体
        private String etyinr;



	    @BDGetter
		private Lidgrp lidgrp;

	    @BDGetter
		private Brdgrp brdgrp;

	    @BDGetter
		private Ledgrp ledgrp;

	    @BDGetter
		private Bedgrp bedgrp;

	    @BDGetter
		private Bcdgrp bcdgrp;

	    @BDGetter
		private Bodgrp bodgrp;

	    @BDGetter
		private Bpdgrp bpdgrp;

	    @BDGetter
		private Fcdgrp fcdgrp;

	    @BDGetter
		private Gidgrp gidgrp;

	    @BDGetter
		private Sgdgrp sgdgrp;

	    @BDGetter
		private Cpdgrp cpdgrp;

	    @BDGetter
		private Comgrp comgrp;

	    @BDGetter
		private Fsdgrp fsdgrp;

	    @BDGetter
		private Afdgrp afdgrp;

		@BDGetter
		private ModuleList<Brd> brdlst;

	    @BDGetter
		private Didgrp didgrp;

	    @BDGetter
		private Dedgrp dedgrp;

	    @BDGetter
		private Bddgrp bddgrp;

	    @BDGetter
		private Bmdgrp bmdgrp;

		@BDGetter
		private ModuleList<Bdd> bddlst;

	    @BDGetter
		private Jsdgrp jsdgrp;

	    @BDGetter
		private Widgrp widgrp;

	    @BDGetter
		private Ebhfat ebhfat;


		public Bimenu()
        {
            super();
            setArgument();
        }

        public Bimenu(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:bimenu.@0000.script
        */
        public boolean determineMT700(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  //the first application,use ownref,after, use stlref
			  log.debug("{}","m1/ownref="+this.getM1());
			  lidinr=reloadData("lid",this.getM1());
			  if(!MdaUtils.isEmpty(lidinr))
			  {
			    ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    setModuleContent(data);
			    this.getLidgrp().getRec().setFlg("1");
			    this.getLidgrp().getRec().setDbchcod(this.getBchcod());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getLidgrp().getRec());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getLidgrp().getBlk());
			  }
			  else
			  {
			    log.debug("{}","reloadData error...");
			    return false;
			  }

			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getCliptyinr()))
			    this.getLidgrp().getRec().setPtyinr(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getLidgrp().getRec().setFlg("1");
			  this.getLidgrp().getRec().setDbchcod(this.getBchcod());
			  lidinr = Platform.sdbCounter("lid");
			  this.getLidgrp().getRec().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getLidgrp().getRec());
			  this.getLidgrp().getBlk().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getLidgrp().getBlk());
			}
			if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPts().getRef()))
			  this.getLidgrp().getApl().getPts().setRef(this.getLidgrp().getRec().getStlref());
			this.getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			//
			this.setGrptyp("lidgrp");
			this.setFrm("litdav");
			this.setObjtyp("lid");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000108"));
			return true;
		}
        /**
        *   source:bimenu.@0001.script
        */
        public String getPtyFromCid(String bchcod,String[] ptytyps)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="";
			if(MdaUtils.isEmpty(ptytyps))
			{
			  sql="SELECT nam as inr FROM pty WHERE cid='"+bchcod+"'";
			}
			else
			{
			  sql="SELECT inr FROM pty WHERE cid='"+bchcod+"' and (ptytyp=";
			  String conn="";
			  for(String ptytyp:ptytyps)
			  {
			    sql=sql+conn+"'"+ptytyp+"'";
			    conn=" or ptytyp=";
			  }
			  sql=sql+")";
			}
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  log.info("{}","in getPtyFromCid,ptyinr="+inr.value);
			  ret=inr.value;
			}
			else if(errorcode==NO_MORE_ROW)
			{
			  ret=null;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:bimenu.@0002.script
        */
        public boolean determineMT707(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getA1()))
			  return false;
			if(!MdaUtils.isEmpty(this.getEtyinr()))
			  this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			String a1=ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getA1();
			log.debug("{}","a1="+a1);
			//litame
			Object stlref = data.get("lidgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			{
			  log.info("{}","stlref is null!");
			  return false;
			}
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(reloadDataByStlref("lid",stlref.toString()))
			{
			  lidinr = this.getLidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  setModuleContent(data);
			  //$lidgrp\\blk\\inr.setValue(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  //$\\sysmod.sdbUpdate(Platform.getModule($\\bimenu,"lidgrp\\\\blk"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  //IDatafield blkinr=Platform.getDatafield($\\bimenu,"lidgrp\\\\blk\\\\inr");
			  //blkinr.setValue(inr.getValue().toString());
			  //$\\sysmod.sdbInsert(Platform.getModule($\\bimenu,"lidgrp\\\\blk"));
			}
			if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPts().getRef()))
			  this.getLidgrp().getApl().getPts().setRef(this.getLidgrp().getRec().getStlref());
			this.getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getLidgrp().getIsb().savRolPts(lidinr,"lid","isb");
			this.getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.setGrptyp("lidgrp");
			this.setFrm("litmav");
			this.setObjtyp("lid");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			if("AKA".equals(a1))
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000103"));
			if("CTC".equals(a1))
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000110"));
			return true;
		}
        /**
        *   source:bimenu.@0003.script
        */
        public boolean determineMTT50(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","into ...determineMTT50");
			log.debug("{}",ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getA1());
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getA1()))
			  return false;
			String a1=ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getA1();
			log.debug("{}","a1="+a1);
			if("AKA".equals(a1)  ||  "CTC".equals(a1))
			{
			  String brdinr = null;
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  log.debug("{}","stlref = "+stlref.toString());
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  this.setStlref(stlref.toString());
			  //handle the message
			  if(!reloadDataByArg("brd","stlref",stlref.toString()))
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    brdinr = Platform.sdbCounter("brd");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			    inr.setValue(brdinr);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("disadv");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			  }
			  else
			  {
			    brdinr= this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("disadv");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBrdgrp().getRec());
			  }
			  if(reloadDataByArg("lid","stlref",this.getBrdgrp().getRec().getPntstlref()))
			  {
			    if(MdaUtils.isEmpty(this.getBrdgrp().getRec().getConno()))
			      this.getBrdgrp().getRec().setConno(this.getLidgrp().getRec().getConno());
			    if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getAdrblk()))
			    {
			      String lidinr = this.getLidgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			      this.getBrdgrp().getApl().getPts().setAdrblk(this.getLidgrp().getApl().getPts().getAdrblk());
			    }
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  //update the flag
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setGrptyp("brdgrp");
			  log.debug("{}","determine :grp="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).getGrptyp());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setFrm("brtdra");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setObjtyp("brd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  if(!MdaUtils.isEmpty(inr))
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setObjinr(inr.getValue().toString());
			  if("AKA".equals(a1))
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setObjnam(MdaUtils.getI18NString("bimenu","CT000025"));
			  else
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class).setObjnam(MdaUtils.getI18NString("bimenu","CT000107"));
			}
			else if("EAB".equals(a1))
			{
			  //export
			  Object lcref=data.get("bedgrp\\rec\\stlref");
			  log.debug("{}","lcref="+lcref.toString());
			  if(MdaUtils.isEmpty(lcref))
			    return false;
			  this.setStlref(lcref.toString());
			  if(reloadDataByStlref("bed",lcref.toString()))
			  {
			    setModuleContent(data);
			    this.getBedgrp().getRec().setDocflg("disadv");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBedgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bed"));
			    this.getBedgrp().getRec().setDocflg("disadv");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec"));
			  }
			  //update the flag
			  this.setGrptyp("bedgrp");
			  this.setFrm("betdis");
			  this.setObjtyp("bed");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000148"));
			}
			return true;
		}
        /**
        *   source:bimenu.@0004.script
        */
        public boolean determineMTT52(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			{
			  log.debug("{}","stlref = "+stlref);
			  return false;
			}
			this.setStlref(stlref.toString());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("brd"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			  this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			this.setGrptyp("brdgrp");
			this.setFrm("brtset");
			this.setObjtyp("brd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			if(!MdaUtils.isEmpty(inr))
			{
			  this.setObjinr(inr.getValue().toString());
			}
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000109"));
			return true;
		}
        /**
        *   source:bimenu.@0005.script
        */
        public boolean determineMTT72 (HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			Object lcref=data.get("brdgrp\\rec\\pntstlref");
			log.debug("{}","lcref="+lcref);
			this.setStlref(stlref.toString());
			String brdinr = null;
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  brdinr = this.getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBrdgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			}
			else
			{
			  /*Platform.dbRead($lidgrp\\rec,new Argument<String>("stlref",lcref.toString()));
			    if(!Platform.isEmpty($lidgrp\\rec\\inr))
			    {
			    String lidinr = $lidgrp\\rec\\inr.getValue();
			    Platform.dbRead($brdgrp\\ben\\pts,new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    Platform.dbRead($brdgrp\\prb\\pts,new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    Platform.dbRead($brdgrp\\apl\\pts,new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    $brdgrp\\ben\\pts\\inr.setValue("");
			    $brdgrp\\prb\\pts\\inr.setValue("");
			    $brdgrp\\apl\\pts\\inr.setValue("");
			    }*/
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBrdgrp().getRec().setDbchcod(this.getBchcod());
			  brdinr=Platform.sdbCounter("brd");
			  this.getBrdgrp().getRec().setInr(brdinr);
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			  this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.getBrdgrp().getPrb().savRolPts(brdinr,"brd","prb");
			//update the flag
			//
			this.setGrptyp("brdgrp");
			this.setFrm("brtdck");
			this.setObjtyp("brd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000112"));
			return true;
		}
        /**
        *   source:bimenu.@0006.script
        */
        public boolean determineMTT76(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			{
			  return false;
			}
			this.setStlref(stlref.toString());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield brdinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  brdinr.setValue(Platform.sdbCounter("brd"));
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			  this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			//update the flag
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			this.setGrptyp("brdgrp");
			this.setFrm("brtdcr");
			this.setObjtyp("brd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000012"));
			return true;
		}
        /**
        *   source:bimenu.@0007.script
        */
        public boolean determineMTT74(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","lid stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(!reloadDataByArg("lid","stlref",stlref.toString()))
			  return false;
			lidinr = this.getLidgrp().getRec().getInr();
			setModuleContent(data);
			ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			ctx.getDaoSession().dbReadset(this.getBrdlst(),new Argument("pntstlref",stlref.toString()));
			for(int i=0;i<this.getBrdlst().fullSize();i++)
			{
			  this.getBrdlst().getElement(i).setClsdat(this.getLidgrp().getRec().getClsdat());
			  ctx.getDaoSession().dbUpdate(this.getBrdlst().getElement(i));
			}
			this.setGrptyp("lidgrp");
			this.setFrm("litcan");
			this.setObjtyp("lid");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000013"));
			return true;
		}
        /**
        *   source:bimenu.@0008.script
        */
        public boolean determineMTT44(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  T44_CTC=comcan
			  T44_AKA=comcan
			  T44_EAB=comcan
			  T44_EBB=comcan
			  T44_IIB=comcan
			  T44_EIB=comcan
			  T44_SGT=comcan
			  T44_BPT=comcan
			  T44_GIT=comcan
			  T44_GET=comcan
			  T44_CPT=comcan
			  T44_CPO=comcan
			  T44_FFT=comcan
			  */
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("AKA".equals(a1))
			{
			}
			else if("EAB".equals(a1))
			{
			  Object stlref = data.get("ledgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  if(reloadDataByStlref("led",stlref.toString()))
			  {
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getLedgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getLedgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\inr");
			    ledinr.setValue(Platform.sdbCounter("led"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getLedgrp().getRec());
			  }
			  this.setGrptyp("ledgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000034"));
			  this.setFrm("letcan");
			  this.setObjtyp("led");
			}
			else if("IIB".equals(a1))
			{
			  Object stlref = data.get("bcdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  if(reloadDataByStlref("bcd",stlref.toString()))
			  {
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBcdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			    ledinr.setValue(Platform.sdbCounter("bcd"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBcdgrp().getRec());
			  }
			  this.setGrptyp("bcdgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000131"));
			  this.setFrm("bctcan");
			  this.setObjtyp("bcd");
			}
			else if("SGT".equals(a1))
			{
			  Object stlref = data.get("sgdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  if(reloadDataByStlref("sgd",stlref.toString()))
			  {
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getSgdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getSgdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec\\inr");
			    ledinr.setValue(Platform.sdbCounter("sgd"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getSgdgrp().getRec());
			  }
			  this.setGrptyp("sgdgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000134"));
			  this.setFrm("sgtcan");
			  this.setObjtyp("sgd");
			}
			else if("GET".equals(a1))
			{
			  Object stlref = data.get("gidgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  if(reloadDataByStlref("gid",stlref.toString()))
			  {
			    log.debug("{}","gid inr="+this.getGidgrp().getRec().getInr());
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getGidgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getGidgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\inr");
			    ledinr.setValue(Platform.sdbCounter("gid"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getGidgrp().getRec());
			  }
			  this.setGrptyp("gidgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000136"));
			  this.setFrm("gitcan");
			  this.setObjtyp("gid");
			}
			else if("CTC".equals(a1))
			{
			  Object stlref = data.get("lidgrp\\rec\\stlref");
			  log.debug("{}","lid stlref = "+stlref);
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  this.setStlref(stlref.toString());
			  String lidinr = null;
			  if(reloadDataByArg("lid","stlref",stlref.toString()))
			  {
			    lidinr = this.getLidgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			    lidinr = Platform.sdbCounter("lid");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			    inr.setValue(lidinr);
			    ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  }
			  if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPts().getRef()))
			    this.getLidgrp().getApl().getPts().setRef(this.getLidgrp().getRec().getStlref());
			  this.getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			  this.getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			  this.getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			  this.setGrptyp("lidgrp");
			  this.setFrm("litcan");
			  this.setObjtyp("lid");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000137"));
			}
			/**
			  Object stlref = data.get("comgrp\\\\rec\\\\stlref");
			  if(!Platform.isEmpty(stlref))
			  {
			  $stlref.setValue(stlref.toString());
			  }
			  else
			  {
			  log.warn("stlref is empty!" );
			  }
			  setModuleContent(data);
			  $grptyp.setValue("comgrp");
			  $objnam.setValue(#CT000145);
			  $frm.setValue("comcan");
			  $objtyp.setValue("com");
			  */
			return true;
		}
        /**
        *   source:bimenu.@0009.script
        */
        public boolean determineMTT10(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Object bchcod=head.get("M6");
			//log.debug("i got you,bchcod="+bchcod);
			String bchcod=getPtyFromCid(this.getM6(),new String[]{"0"});
			if(!MdaUtils.isEmpty(bchcod))
			  this.setBchcod(bchcod);
			else
			{
			  log.info("{}","bchcod is null" );
			  return false;
			}
			Object stlref = data.get("ledgrp\\rec\\stlref");
			log.debug("{}","led stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getCliptyinr());
			if(!MdaUtils.isEmpty(this.getEtyinr()))
			  this.getLedgrp().getRec().setEtyinr(this.getEtyinr());
			this.setStlref(stlref.toString());
			//save the led data
			this.getLedgrp().getRec().setFlg("2");
			IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\inr");
			ledinr.setValue(Platform.sdbCounter("led"));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getLedgrp().getRec());
			//and the pts
			String inr = this.getLedgrp().getRec().getInr();
			this.getLedgrp().getBen().savRolPts(inr,"led","ben");
			this.getLedgrp().getIsb().savRolPts(inr,"led","isb");
			this.getLedgrp().getApl().savRolPts(inr,"led","apl");
			//$\\bimenu\\grptyp.setValue("ledgrp");
			this.setGrptyp("ledgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000106"));
			this.setFrm("letopn");
			this.setObjtyp("led");
			this.setObjinr(inr);
			return true;
		}
        /**
        *   source:bimenu.@0010.script
        */
        public boolean determineMTT07(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  String bchcod=getPtyFromCid($m6.getValue());
			  if(!Platform.isEmpty(bchcod))
			  {
			  $bchcod.setValue(bchcod);
			  }
			  */
			Object stlref = data.get("ledgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			{
			  log.debug("{}","stlref = "+stlref);
			  return false;
			}
			this.setStlref(stlref.toString());
			String ledinr = null;
			if(reloadDataByStlref("led",stlref.toString()))
			{
			  setModuleContent(data);
			  ledinr = this.getLedgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getLedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  ctx.getDaoSession().dbRead(this.getLedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  ctx.getDaoSession().dbRead(this.getLedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getLedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getLedgrp().getRec().setEtyinr(this.getEtyinr());
			  ledinr = Platform.sdbCounter("led");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"ledgrp\\rec\\inr");
			  inr.setValue(ledinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getLedgrp().getRec());
			}
			this.getLedgrp().getApl().savRolPts(ledinr,"led","apl");
			this.getLedgrp().getBen().savRolPts(ledinr,"led","ben");
			this.getLedgrp().getIsb().savRolPts(ledinr,"led","isb");
			//$\\bimenu\\grptyp.setValue("ledgrp");
			this.setGrptyp("ledgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000015"));
			this.setFrm("letame");
			this.setObjtyp("led");
			this.setObjinr(ledinr);
			return true;
		}
        /**
        *   source:bimenu.@0011.script
        */
        public boolean determineMTT12(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("AKA".equals(a1))
			{
			  //import
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  String brdinr = null;
			  if(reloadDataByStlref("brd",stlref.toString()))
			  {
			    brdinr = this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    this.getBrdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBrdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    brdinr= Platform.sdbCounter("brd");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			    inr.setValue(brdinr);
			    this.getBrdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  //update the flag
			  this.setGrptyp("brdgrp");
			  this.setFrm("brtudp");
			  this.setObjtyp("brd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  if(!MdaUtils.isEmpty(inr))
			    this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000004"));
			}
			else if("EAB".equals(a1))
			{
			  Object stlref = data.get("bedgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bed",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBedgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBedgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBedgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bed"));
			    this.getBedgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBedgrp().getRec());
			  }
			  this.setGrptyp("bedgrp");
			  this.setFrm("betacc");
			  this.setObjtyp("bed");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000031"));
			}
			else if("EIB".equals(a1))
			{
			  Object stlref = data.get("bodgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bod",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBodgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBodgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBodgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bod"));
			    this.getBodgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBodgrp().getRec());
			  }
			  //update the flag
			  this.setGrptyp("bodgrp");
			  this.setFrm("botacc");
			  this.setObjtyp("bod");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			  if(!MdaUtils.isEmpty(inr))
			  {
			    this.setObjinr(inr.getValue().toString());
			  }
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000067"));
			}
			return true;
		}
        /**
        *   source:bimenu.@0012.script
        */
        public boolean determineMTT32(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("EAB".equals(a1))
			{
			  Object stlref = data.get("bedgrp\\rec\\stlref");
			  Object pntref=data.get("bedgrp\\rec\\pntref");
			  this.setStlref(stlref.toString());
			  log.debug("{}","pntref="+pntref);
			  log.debug("{}","stlref = "+this.getStlref());
			  if(!MdaUtils.isEmpty(pntref))
			  {
			    String strpntref = pntref.toString();
			    ctx.getDaoSession().dbRead(this.getLedgrp().getRec(),new Argument<String>("stlref",strpntref));
			    if(!MdaUtils.isEmpty(this.getLedgrp().getRec().getInr()))
			    {
			      String ledinr = this.getLedgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getBedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      ctx.getDaoSession().dbRead(this.getBedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      ctx.getDaoSession().dbRead(this.getBedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      this.getBedgrp().getApl().getPts().setInr("");
			      this.getBedgrp().getBen().getPts().setInr("");
			      this.getBedgrp().getIsb().getPts().setInr("");
			      this.getBedgrp().getRec().setIsscur(this.getLedgrp().getRec().getLcccur());
			      this.getBedgrp().getRec().setIssamt(this.getLedgrp().getRec().getLccamt());
			    }
			  }
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBedgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBedgrp().getRec().setDbchcod(this.getBchcod());
			  String bedinr = Platform.sdbCounter("bed");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			  inr.setValue(bedinr);
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec"));
			  this.getBedgrp().getBen().savRolPts(bedinr,"bed","ben");
			  this.getBedgrp().getIsb().savRolPts(bedinr,"bed","isb");
			  this.getBedgrp().getApl().savRolPts(bedinr,"bed","apl");
			  //$\\sysmod.sdbUpdate(Platform.getModule($\\bimenu,"bedgrp\\\\rec"));
			  this.setGrptyp("bedgrp");
			  this.setFrm("betsnd");
			  this.setObjtyp("bed");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000017"));
			}
			else if("IIB".equals(a1))
			{
			  Object stlref = data.get("bcdgrp\\rec\\stlref");
			  log.debug("{}","stlref = "+ stlref);
			  this.setStlref(stlref.toString());
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bcd",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBcdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBcdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			    this.getBcdgrp().getRec().setDbchcod(this.getBchcod());
			    inr.setValue(Platform.sdbCounter("bcd"));
			    this.getBcdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBcdgrp().getRec());
			  }
			  this.setGrptyp("bcdgrp");
			  this.setFrm("bctacc");
			  this.setObjtyp("bcd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000061"));
			}
			return true;
		}
        /**
        *   source:bimenu.@0013.script
        */
        public boolean determineMTT34(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String a1=null;
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			a1=this.getA1();
			if("CTC".equals(a1))
			{
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  log.debug("{}","stlref = "+stlref);
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  this.setStlref(stlref.toString());
			  String brdinr = null;
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  if(reloadDataByArg("brd","stlref",stlref.toString()))
			  {
			    brdinr = this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    this.getBrdgrp().getRec().setDocflg("docadv");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    this.getBrdgrp().getRec().setDocflg("docadv");
			    brdinr= Platform.sdbCounter("brd");
			    this.getBrdgrp().getRec().setInr(brdinr);
			    ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec"));
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  this.getBrdgrp().getPrb().savRolPts(brdinr,"brd","prb");
			  //update the flag
			  this.setGrptyp("brdgrp");
			  this.setFrm("brtdck");
			  this.setObjtyp("brd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000036"));
			  return true;
			}
			else if("EAB".equals(a1))
			{
			  Object stlref = data.get("bedgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bed",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBedgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBedgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBedgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bed"));
			    this.getBedgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBedgrp().getRec());
			  }
			  this.setGrptyp("bedgrp");
			  this.setFrm("betdck");
			  this.setObjtyp("bed");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000120"));
			  return true;
			}
			return true;
		}
        /**
        *   source:bimenu.@0014.script
        */
        public boolean determineMTT54(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("AKA".equals(a1))
			{
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+stlref.toString());
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  String brdinr = null;
			  if(!reloadDataByArg("brd","stlref",stlref.toString()))
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			    brdinr = Platform.sdbCounter("brd");
			    inr.setValue(brdinr);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			  }
			  else
			  {
			    brdinr = this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBrdgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  this.getBrdgrp().getBeb().savRolPts(brdinr,"brd","beb");
			  //update the flag
			  this.setGrptyp("brdgrp");
			  this.setFrm("brtpay");
			  this.setObjtyp("brd");
			  this.setObjinr(brdinr);
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000007"));
			}
			else if("EAB".equals(a1))
			{
			  //export
			  Object lcref=data.get("bedgrp\\rec\\stlref");
			  log.debug("{}","lcref="+lcref.toString());
			  if(MdaUtils.isEmpty(lcref))
			    return false;
			  this.setStlref(lcref.toString());
			  if(reloadDataByStlref("bed",lcref.toString()))
			  {
			    setModuleContent(data);
			    //计算国外银费单据金额减去汇入金额
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getFncfee()))
			    {
			      BigDecimal b1 = this.getBedgrp().getRec().getDocamt();
			      BigDecimal b2 = this.getBedgrp().getRec().getDdamt();
			      this.getBedgrp().getRec().setFncfee(b1.subtract(b2));
			      this.getBedgrp().setFnccur(this.getBedgrp().getRec().getDoccur());
			    }
			    this.getBedgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    //计算国外银费单据金额减去汇入金额
			    if(MdaUtils.isEmpty(this.getBedgrp().getRec().getFncfee()))
			    {
			      BigDecimal b1 = this.getBedgrp().getRec().getDocamt();
			      BigDecimal b2 = this.getBedgrp().getRec().getDdamt();
			      this.getBedgrp().getRec().setFncfee(b1.subtract(b2));
			      this.getBedgrp().setFnccur(this.getBedgrp().getRec().getDoccur());
			    }
			    this.getBedgrp().getRec().setDocflg("payment");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bed"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec"));
			  }
			  this.setGrptyp("bedgrp");
			  this.setFrm("betset");
			  this.setObjtyp("bed");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bedgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000023"));
			}
			else if("IIB".equals(a1))
			{
			  //import collection
			  Object lcref=data.get("bcdgrp\\rec\\stlref");
			  log.debug("{}","stlref = "+lcref.toString());
			  if(MdaUtils.isEmpty(lcref))
			    return false;
			  this.setStlref(lcref.toString());
			  if(reloadDataByStlref("bcd",lcref.toString()))
			  {
			    setModuleContent(data);
			    this.getBcdgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bcd"));
			    this.getBcdgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			  }
			  this.setGrptyp("bcdgrp");
			  this.setFrm("bctset");
			  this.setObjtyp("bcd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000058"));
			}
			else if("EIB".equals(a1))
			{
			  //export collection
			  Object lcref=data.get("bodgrp\\rec\\stlref");
			  log.debug("{}","stlref = "+lcref.toString());
			  if(MdaUtils.isEmpty(lcref))
			    return false;
			  this.setStlref(lcref.toString());
			  if(reloadDataByStlref("bod",lcref.toString()))
			  {
			    setModuleContent(data);
			    this.getBodgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBodgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bod"));
			    this.getBodgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec"));
			  }
			  //update the flag
			  this.setGrptyp("bodgrp");
			  this.setFrm("botset");
			  this.setObjtyp("bod");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000059"));
			}
			return true;
		}
        /**
        *   source:bimenu.@0015.script
        */
        public boolean determineMTT45(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object lcref=data.get("bodgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			if(MdaUtils.isEmpty(lcref))
			  return false;
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bod",lcref.toString()))
			{
			  setModuleContent(data);
			  this.getBodgrp().getRec().setDocflg("retrej");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBodgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bod"));
			  this.getBodgrp().getRec().setDocflg("retrej");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec"));
			}
			//update the flag
			this.setGrptyp("bodgrp");
			this.setFrm("botdcr");
			this.setObjtyp("bod");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000070"));
			return true;
		}
        /**
        *   source:bimenu.@0016.script
        */
        public boolean determineMTT40(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//did they have a applicaion no. like lc0908210001 if they applied?
			Object lcref=data.get("bcdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			if(MdaUtils.isEmpty(lcref))
			  return false;
			this.setStlref(lcref.toString());
			String bcdinr=null;
			//if(reloadDataByStlref("bcd",lcref.toString()))
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  reloadData("bcd",this.getM1());
			  bcdinr = this.getBcdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBcdgrp().getRmi().getPts(),new Argument("rol","rmi"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  ctx.getDaoSession().dbRead(this.getBcdgrp().getDrr().getPts(),new Argument("rol","drr"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  ctx.getDaoSession().dbRead(this.getBcdgrp().getDre().getPts(),new Argument("rol","dre"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBcdgrp().getRec().setDbchcod(this.getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			  bcdinr = Platform.sdbCounter("bcd");
			  this.getBcdgrp().getRec().setInr(bcdinr);
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBcdgrp().getRec().setDbchcod(this.getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			}
			//IDatafield bcdinr=Platform.getDatafield($\\bimenu,"bcdgrp\\\\rec\\\\inr");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			this.getBcdgrp().getRmi().savRolPts(bcdinr,"bcd","rmi");
			this.getBcdgrp().getDrr().savRolPts(bcdinr,"bcd","drr");
			this.getBcdgrp().getDre().savRolPts(bcdinr,"bcd","dre");
			//
			this.setGrptyp("bcdgrp");
			this.setFrm("bctdav");
			this.setObjtyp("bcd");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000051"));
			return true;
		}
        /**
        *   source:bimenu.@0017.script
        */
        public boolean determineMTT46(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("bcdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("bcd",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBcdgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBcdgrp().getRec().setEtyinr(this.getEtyinr());
			    this.getBcdgrp().getRec().setInr(Platform.sdbCounter("bcd"));
			    this.getBcdgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec"));
			  }

			}
			else
			{
			  return false;
			}
			this.setGrptyp("bcdgrp");
			this.setFrm("bctdor");
			this.setObjtyp("bcd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bcdgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000064"));
			return true;
		}
        /**
        *   source:bimenu.@0018.script
        */
        public boolean determineMTT23(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// IDatafield cpdinr=Platform.getDatafield($\\bimenu\\,"cpdgrp\\\\rec\\\\inr");
			//cpdinr.setValue(Platform.sdbCounter("cpd"));
			Object stlref = data.get("cpdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getCliptyinr());
			if(!MdaUtils.isEmpty(this.getEtyinr()))
			  this.getCpdgrp().getRec().setEtyinr(this.getEtyinr());
			this.getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec"));
			//$\\bimenu\\grptyp.setValue("ledgrp");
			this.setGrptyp("cpdgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000075"));
			this.setFrm("cptsub");
			this.setObjtyp("cpd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			return true;
		}
        /**
        *   source:bimenu.@0019.script
        */
        public boolean determineMTT22(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","m1/ownref="+this.getM1());
			String inr=null;
			if(!MdaUtils.isEmpty(this.getA1()))
			  inr=reloadData("cpd",this.getM1());
			if(!MdaUtils.isEmpty(inr))
			{
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec"));
			}
			else if(!MdaUtils.isEmpty(this.getM8()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getCpdgrp().getRec().setEtyinr(this.getEtyinr());
			  inr=Platform.sdbCounter("cpd");
			  this.getCpdgrp().getRec().setInr(inr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"cpdgrp\\rec"));
			}
			else
			  return false;
			this.getCpdgrp().getBen().savRolPts(inr,"cpd","ben");
			this.getCpdgrp().getAcw().savRolPts(inr,"cpd","acw");
			this.getCpdgrp().getApl().savRolPts(inr,"cpd","apl");
			this.setStlref(this.getCpdgrp().getRec().getStlref());
			this.setGrptyp("cpdgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000080"));
			this.setObjinr(inr);
			this.setFrm("cptout");
			this.setObjtyp("cpd");
			return true;
		}
        /**
        *   source:bimenu.@0020.script
        */
        public boolean determineMTT25(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("sgdgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			  return false;
			this.setStlref(stlref.toString());
			Object ownref=data.get("sgdgrp\\rec\\ownref");
			log.debug("{}","stlref"+stlref);
			log.debug("{}","ownref"+ownref);
			if(!MdaUtils.isEmpty(ownref)&&reloadDataByArg("sgd","ownref",ownref.toString()))
			{
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec"));
			  this.setGrptyp("sgdgrp");
			  this.setFrm("sgtdav");
			  this.setObjtyp("sgd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000014"));
			  return true;
			}
			else if(!MdaUtils.isEmpty(this.getM8()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getSgdgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getSgdgrp().getRec().setInr(Platform.sdbCounter("sgd"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec"));
			  this.setGrptyp("sgdgrp");
			  this.setFrm("sgtdav");
			  this.setObjtyp("sgd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"sgdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000116"));
			  return true;
			}
			else
			{
			  return false;
			}
		}
        /**
        *   source:bimenu.@0021.script
        */
        public boolean determineMTT19(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Object stlref = data.get("bpdgrp\\\\rec\\\\stlref");
			//reloadDataByStlref("bpd",stlref.toString());
			Object stlref = data.get("bpdgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			  return false;
			this.setStlref(stlref.toString());
			Object pntref=data.get("bpdgrp\\rec\\pntref");
			if(!MdaUtils.isEmpty(pntref)&&reloadDataByArg("bpd","pntref",pntref.toString()))
			{
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec"));
			}
			else if(!MdaUtils.isEmpty(this.getM8()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBpdgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec"));
			}
			else
			  return false;
			this.setGrptyp("bpdgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000099"));
			this.setFrm("bptcrf");
			this.setObjtyp("bpd");
			return true;
		}
        /**
        *   source:bimenu.@0022.script
        */
        public boolean determineMTT18(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("bpdgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			  return false;
			this.setStlref(stlref.toString());
			String bpdinr = null;
			if(reloadDataByArg("bpd","stlref",stlref.toString()))
			{
			  bpdinr = this.getBpdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bpd"),new Argument("objinr",bpdinr));
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBpdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  bpdinr = Platform.sdbCounter("bpd");
			  this.getBpdgrp().getRec().setInr(bpdinr);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBpdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bpdgrp\\rec"));
			}
			this.getBpdgrp().getApl().savRolPts(bpdinr,"bpd","apl");
			this.setGrptyp("bpdgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000093"));
			this.setFrm("bptbps");
			this.setObjtyp("bpd");
			this.setObjinr(bpdinr);
			return true;
		}
        /**
        *   source:bimenu.@0023.script
        */
        public boolean determineMTT68(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("gidgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			String gidinr="";
			//Opening under a guarentee
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  //the first application,use ownref,after use stlref
			  log.debug("{}","i got you,ownref="+this.getM1());
			  reloadData("gid",this.getM1());
			  gidinr=this.getGidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			  ctx.getDaoSession().dbRead(this.getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			  setModuleContent(data);
			  this.getGidgrp().getRec().setFlg("2");
			  this.getGidgrp().getRec().setDbchcod(this.getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			}
			else
			{
			  //create a new record
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getGidgrp().getRec().setEtyinr(this.getEtyinr());
			  //IDatafield ledinr=Platform.getDatafield($\\bimenu\\,"gidgrp\\\\rec\\\\inr");
			  //ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getGidgrp().getRec().setDbchcod(this.getBchcod());
			  this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			  gidinr=this.getGidgrp().getRec().getInr();
			}
			this.getGidgrp().getApl().savRolPts(gidinr,"gid","apl");
			this.getGidgrp().getBen().savRolPts(gidinr,"gid","ben");
			this.setGrptyp("gidgrp");
			this.setFrm("gitdav");
			this.setObjtyp("gid");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000037"));
			return true;
		}
        /**
        *   source:bimenu.@0024.script
        */
        public boolean determineMTT67(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("gidgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("gid",stlref.toString()))
			  {
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getGidgrp().getRec().setEtyinr(this.getEtyinr());
			    this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			  }
			  //reloadDataByStlref("gid",stlref.toString());
			  this.setGrptyp("gidgrp");
			  this.setFrm("gitmav");
			  this.setObjtyp("gid");
			  //IDatafield inr=Platform.getDatafield($\\bimenu,"gidgrp\\\\rec\\\\inr");
			  this.setObjinr(this.getGidgrp().getRec().getInr());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000040"));
			  return true;
			}
			else
			{
			  return false;
			}
		}
        /**
        *   source:bimenu.@0025.script
        */
        public boolean determineMTT62(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			Object stlref = data.get("gidgrp\\rec\\advref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getCliptyinr());
			if(!MdaUtils.isEmpty(this.getEtyinr()))
			  this.getGidgrp().getRec().setEtyinr(this.getEtyinr());
			this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			this.setGrptyp("gidgrp");
			this.setFrm("gitrcv");
			this.setObjtyp("gid");
			//IDatafield inr=Platform.getDatafield($\\bimenu,"gidgrp\\\\rec\\\\inr");
			this.setObjinr(this.getGidgrp().getRec().getInr());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000042"));
			return true;
		}
        /**
        *   source:bimenu.@0026.script
        */
        public boolean determineMTT63(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("gidgrp\\rec\\advref");
			// $ownref.setValue(stlref.toString());
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("gid",stlref.toString()))
			  {
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getGidgrp().getRec().setEtyinr(this.getEtyinr());
			    this.getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"gidgrp\\rec"));
			  }
			  this.setGrptyp("gidgrp");
			  this.setFrm("gitmcv");
			  this.setObjtyp("gid");
			  //IDatafield inr=Platform.getDatafield($\\bimenu,"gidgrp\\\\rec\\\\inr");
			  this.setObjinr(this.getGidgrp().getRec().getInr());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000045"));
			}
			return true;
		}
        /**
        *   source:bimenu.@0027.script
        */
        public boolean determineMTT27(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("fsdgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stlref))
			  return false;
			//if(reloadDataByStlref("fsd",stlref.toString()))
			
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  reloadData("fsd",this.getM1());
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"fsdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getFsdgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"fsdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"fsdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getFsdgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getFsdgrp().getRec().setInr(Platform.sdbCounter("fsd"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"fsdgrp\\rec"));
			}
			this.setStlref(stlref.toString());
			this.setGrptyp("fsdgrp");
			this.setFrm("fftdav");
			this.setObjtyp("fsd");
			// IDatafield inr=Platform.getDatafield($\\bimenu,"ffdgrp\\\\rec\\\\inr");
			this.setObjinr(this.getFsdgrp().getRec().getInr());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000082"));
			return true;
		}
        /**
        *   source:bimenu.@0028.script
        */
        public boolean determineMTT99(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String a1=this.getA1();
			if(!MdaUtils.isEmpty(this.getA1())&&"CTC".equals(a1))
			{
			  //import
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			  String brdinr = null;
			  if(reloadDataByStlref("brd",stlref.toString()))
			  {
			    brdinr = this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    this.getBrdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBrdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    brdinr= Platform.sdbCounter("brd");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			    inr.setValue(brdinr);
			    this.getBrdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  //update the flag
			  this.setGrptyp("brdgrp");
			  this.setFrm("brtudp");
			  this.setObjtyp("brd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			  if(!MdaUtils.isEmpty(inr))
			    this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000122"));
			}
			else
			{

			  Object stlref = data.get("comgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			  {
			    this.setOwnref(stlref.toString());
			  }
			  else
			  {
			    log.warn("{}","stlref is empty!" );
			  }
			  setModuleContent(data);
			  this.setGrptyp("comgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000124"));
			  this.setFrm("comadv");
			  this.setObjtyp("com");
			}
			return true;
		}
        /**
        *   source:bimenu.@0029.script
        */
        public String reloadData1(String argtyp,String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  IDatafield field=null;
			  String retvalue=null;
			  IModule module=Platform.getModule($\\bimenu,argtyp+"grp\\\\rec");
			  Platform.dbRead(module,new Argument<String>("ownref",ownref));
			  int errorcode=Platform.errorCode();
			  if(errorcode==NO_ERROR)
			  {
			  //IDatafield field=Platform.getDatafield(module,"inr");
			  //log.info("reloadData succeed,and the inr="+field.getValue());
			  field=Platform.getDatafield(module,"inr");
			  log.info("reloadData succeed,and the inr="+field.getValue());
			  if("lid".equals(argtyp))
			  {
			  log.info("reload lit...");
			  Platform.dbRead(Platform.getModule($\\bimenu,argtyp+"grp\\\\blk"),new Argument<String>("inr",field.getValue().toString()));
			  int e=Platform.errorCode();
			  log.info(e);
			  }
			  retvalue=field.getValue().toString();
			  }
			  else if(errorcode==NO_MORE_ROW)
			  {
			  log.info("cannot find the corresponding reference in DZT !");
			  retvalue=null;
			  }
			  else
			  {
			  log.info("error in looking the ....");
			  retvalue=null;
			  }
			  Platform.dbCloseCursor();
			  return retvalue;
			  */
			return null;
		}
        /**
        *   source:bimenu.@0030.script
        */
        public String getPtyFromExtkey(String extkey)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="SELECT inr FROM pty WHERE extkey='"+extkey+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  ret=inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:bimenu.@0031.script
        */
        public boolean reloadDataByStlref(String argtyp,String stlref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","grptyp="+argtyp+",stlref = "+stlref);
			IModule module=MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),argtyp+"grp\\rec");
			ctx.getDaoSession().dbRead(module,new Argument("stlref",stlref));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  IDatafield field=MdaDriver.getDatafield(module,"inr");
			  log.info("{}","reloadData succeed,and the inr="+field.getValue());
			  if("lid".equals(argtyp))
			  {
			    log.info("{}","reload lit...");
			    ctx.getDaoSession().dbRead(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),argtyp+"grp\\blk"),new Argument<String>("inr",field.getValue().toString()));
			    log.info("{}",ctx.getErrorCode());
			  }
			  return true;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","cannot find the corresponding reference in DZT!");
			  }
			  else
			  {
			    log.info("{}","error in looking the ....");
			  }
			  return false;
			}
		}
        /**
        *   source:bimenu.@0032.script
        */
        public boolean reloadDataByArg(String argtyp,String arg,String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IModule module=MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),argtyp+"grp\\rec");
			ctx.getDaoSession().dbRead(module,new Argument<String>(arg,value));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  IDatafield field=MdaDriver.getDatafield(module,"inr");
			  log.info("{}","reloadData succeed,and the inr="+field.getValue());
			  return true;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","cannot find the corresponding reference in DZT!");
			  }
			  else
			  {
			    log.info("{}","error in looking the ....");
			  }
			  return false;
			}
		}
        /**
        *   source:bimenu.@0033.script
        */
        public boolean determineMTT14(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//export collection
			// Object lcref=data.get("bodgrp\\\\rec\\\\stlref");
			// reloadDataByStlref("bod",lcref.toString());
			//handle the message
			
			Object lcref=data.get("bodgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			if(MdaUtils.isEmpty(lcref))
			  return false;
			this.setStlref(lcref.toString());
			String inr=null;
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  inr=reloadData("bod",this.getM1());
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBodgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getBchcod()))
			    this.getBodgrp().getRec().setDbchcod(this.getBchcod());
			  if(MdaUtils.isEmpty(this.getBodgrp().getRec().getRcvdat()))
			    this.getBodgrp().getRec().setRcvdat(this.getBodgrp().getRec().getAdvdat());
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBodgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bodgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  String bodinr=Platform.sdbCounter("bod");
			  this.getBodgrp().getRec().setInr(bodinr);
			  this.getBodgrp().getDrr().savRolPts(bodinr,"bod","drr");
			  this.getBodgrp().getDre().savRolPts(bodinr,"bod","dre");
			  this.getBodgrp().getClb().savRolPts(bodinr,"bod","clb");
			  if(MdaUtils.isEmpty(this.getBodgrp().getRec().getRcvdat()))
			    this.getBodgrp().getRec().setRcvdat(this.getBodgrp().getRec().getAdvdat());
			  if(!MdaUtils.isEmpty(this.getBchcod()))
			    this.getBodgrp().getRec().setDbchcod(this.getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBodgrp().getRec());
			}
			this.setGrptyp("bodgrp");
			this.setFrm("botdav");
			this.setObjtyp("bod");
			this.setObjinr(this.getBodgrp().getRec().getInr());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000065"));
			return true;
		}
        /**
        *   source:bimenu.@0034.script
        */
        public boolean determineMT710(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stfref=data.get("lidgrp\\rec\\stlref");
			if(MdaUtils.isEmpty(stfref))
			  return false;
			String lidinr = null;
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  log.debug("{}","m1/ownref="+this.getM1());
			  lidinr=reloadData("lid",this.getM1());
			  if(MdaUtils.isEmpty(lidinr))
			  {
			    log.debug("{}","reloadData error...");
			    return false;
			  }
			  ctx.getDaoSession().dbRead(this.getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getLidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  setModuleContent(data);
			  this.getLidgrp().getRec().setFlg("1");
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\blk"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getLidgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getLidgrp().getRec().setFlg("1");
			  this.getLidgrp().getRec().setDbchcod(this.getBchcod());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec"));
			  IDatafield blkinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\blk\\inr");
			  blkinr.setValue(inr.getValue().toString());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\blk"));
			}
			if(MdaUtils.isEmpty(this.getLidgrp().getApl().getPts().getRef()))
			  this.getLidgrp().getApl().getPts().setRef(this.getLidgrp().getRec().getStlref());
			this.getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getLidgrp().getIsb().savRolPts(lidinr,"lid","isb");
			this.setStlref(stfref.toString());
			this.setGrptyp("lidgrp");
			this.setFrm("littdv");
			this.setObjtyp("lid");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000129"));
			return true;
		}
        /**
        *   source:bimenu.@0035.script
        */
        public boolean determineMTT59(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("comgrp\\rec\\stlref");
			this.setStlref(stlref.toString());
			log.debug("{}",stlref.toString());
			setModuleContent(data);
			this.setGrptyp("comgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000128"));
			this.setFrm("comadv");
			this.setObjtyp("com");
			return true;
		}
        /**
        *   source:bimenu.@0036.script
        */
        public boolean determineMTT56(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("CTC".equals(a1))
			{
			  Object stlref = data.get("brdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+stlref.toString());
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  String brdinr = null;
			  if(!reloadDataByArg("brd","stlref",stlref.toString()))
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\inr");
			    brdinr = Platform.sdbCounter("brd");
			    inr.setValue(brdinr);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBrdgrp().getRec());
			  }
			  else
			  {
			    brdinr = this.getBrdgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    ctx.getDaoSession().dbRead(this.getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			    setModuleContent(data);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"brdgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBrdgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBrdgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBrdgrp().getApl().getPts().getRef()))
			    this.getBrdgrp().getApl().getPts().setRef(this.getBrdgrp().getRec().getPntstlref());
			  this.getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			  this.getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			  this.getBrdgrp().getBeb().savRolPts(brdinr,"brd","beb");
			  //update the flag
			  this.setGrptyp("brdgrp");
			  this.setFrm("brtpay");
			  this.setObjtyp("brd");
			  this.setObjinr(brdinr);
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000127"));
			  return true;
			}
			return false;
		}
        /**
        *   source:bimenu.@0037.script
        */
        public boolean determineMTT85(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","into T85");
			log.debug("{}","m1/ownref="+this.getM1());
			String fcdinr =null;
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  fcdinr=reloadData("fcd",this.getM1());
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getFcdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"fcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getFcdgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getFcdgrp().getRec().setInr(Platform.sdbCounter("fcd"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getFcdgrp().getRec());
			}
			Object dir=data.get("fcdgrp\\rec\\trndir");
			log.debug("{}","dir==="+dir.toString());
			if(!MdaUtils.isEmpty(dir.toString()))
			{
			  log.debug("{}",dir.toString());
			  //结汇
			  if("0".equals(dir.toString().trim()))
			  {
			    log.info("{}","444444444444="+dir.toString());
			    this.setGrptyp("fcdgrp");
			    this.setFrm("fxisdv");
			    this.setObjtyp("fcd");
			    this.setObjinr(fcdinr);
			    this.setObjnam("即期结汇通知");
			  }
			  //售汇
			  if("1".equals(dir.toString().trim()))
			  {
			    this.setGrptyp("fcdgrp");
			    this.setFrm("fxibdv");
			    this.setObjtyp("fcd");
			    this.setObjinr(fcdinr);
			    this.setObjnam("即期购汇/套汇通知");
			  }
			  //套汇
			  if("2".equals(dir.toString().trim()))
			  {
			    this.setGrptyp("fcdgrp");
			    this.setFrm("fxibdv");
			    this.setObjtyp("fcd");
			    this.setObjinr(fcdinr);
			    this.setObjnam("即期购汇/套汇通知");
			  }
			}
			return true;
		}
        /**
        *   source:bimenu.@0038.script
        */
        public boolean getInrFromPts(String ref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","getInrFromPts...");
			Argument<String> objinr=new Argument<String>("objinr");
			ctx.getDaoSession().dbExecuteSQL("SELECT objinr FROM pts WHERE rol='apl' and objtyp='lid' and ref='"+ref+"'");
			ctx.getDaoSession().dbFetchFields(objinr);
			int error=ctx.getErrorCode();
			log.info("{}","objinr="+objinr.value);
			if(error==NO_ERROR)
			{
			  Argument<String> inr=new Argument<String>("inr",objinr.value);
			  IModule rec=MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\rec");
			  ctx.getDaoSession().dbRead(rec,inr);
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return Platform.closeCursor(false);
			  IModule blk=MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"lidgrp\\blk");
			  ctx.getDaoSession().dbRead(blk,inr);
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return Platform.closeCursor(false);
			  return Platform.closeCursor(true);
			}
			return Platform.closeCursor(false);
		}
        /**
        *   source:bimenu.@0039.script
        */
        public void setModuleContent(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(String key:data.keySet())
			{
			  log.debug("{}","name=" +key+"  value=" +data.get(key));
			  IDatafield datafield=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),key);
			  datafield.setValue(data.get(key));
			}
		}
        /**
        *   source:bimenu.@0041.script
        */
        public String getEtyFromCid(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="SELECT etyinr FROM pty WHERE cid='"+bchcod
			  +"' and (ptytyp='0' or ptytyp='1')";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> etyinr=new Argument<String>("etyinr");
			ctx.getDaoSession().dbFetchFields(etyinr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  ret=etyinr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:bimenu.@0042.script
        */
        public String reloadData(String objtyp,String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtinr=null;
			Argument<String> inr=new Argument<String>("objinr");
			String sql="SELECT objinr FROM trn WHERE objtyp='"+objtyp+"' AND ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(inr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  IModule mod=MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),objtyp+"grp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if("lid".equals(objtyp))
			    {
			      log.info("{}","reload lit...");
			      ctx.getDaoSession().dbRead(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),objtyp+"grp\\blk"),new Argument<String>("inr",inr.value.toString()));
			      int e=ctx.getErrorCode();
			    }
			  }
			  rtinr=inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return rtinr;
		}
        /**
        *   source:bimenu.@0045.script
        */
        public boolean determineMTD70(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("didgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(!MdaUtils.isEmpty(this.getM1()))
			{
			  //the first application,use ownref,after, use stlref
			  log.debug("{}","m1/ownref="+this.getM1());
			  lidinr=reloadData("did",this.getM1());
			  if(!MdaUtils.isEmpty(lidinr))
			  {
			    ctx.getDaoSession().dbRead(this.getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getDidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getDidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    setModuleContent(data);
			    this.getDidgrp().getRec().setFlg("1");
			    this.getDidgrp().getRec().setDbchcod(this.getBchcod());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getDidgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getDidgrp().getRec());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getDidgrp().getBlk());
			  }
			  else
			  {
			    log.debug("{}","reloadData error...");
			    return false;
			  }

			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getCliptyinr()))
			    this.getDidgrp().getRec().setPtyinr(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getDidgrp().getRec().setEtyinr(this.getEtyinr());
			  this.getDidgrp().getRec().setFlg("1");
			  this.getDidgrp().getRec().setDbchcod(this.getBchcod());
			  lidinr = Platform.sdbCounter("did");
			  this.getDidgrp().getRec().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getDidgrp().getRec());
			  this.getDidgrp().getBlk().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getDidgrp().getBlk());
			}
			if(MdaUtils.isEmpty(this.getDidgrp().getApl().getPts().getRef()))
			  this.getDidgrp().getApl().getPts().setRef(this.getDidgrp().getRec().getStlref());
			this.getDidgrp().getBen().savRolPts(lidinr,"did","ben");
			this.getDidgrp().getAdv().savRolPts(lidinr,"did","adv");
			this.getDidgrp().getApl().savRolPts(lidinr,"did","apl");
			//
			this.setGrptyp("didgrp");
			this.setFrm("ditdav");
			this.setObjtyp("did");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000152"));
			return true;
		}
        /**
        *   source:bimenu.@0046.script
        */
        public boolean determineMTD10(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String bchcod=getPtyFromCid(this.getM6(),new String[]{"0"});
			log.debug("{}","i got you,bchcod="+bchcod);
			if(!MdaUtils.isEmpty(bchcod))
			  this.setBchcod(bchcod);
			else
			{
			  log.info("{}","bchcod is null" );
			  return false;
			}
			Object stlref = data.get("dedgrp\\rec\\stlref");
			log.debug("{}","led stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"dedgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getCliptyinr());
			if(!MdaUtils.isEmpty(this.getEtyinr()))
			  this.getDedgrp().getRec().setEtyinr(this.getEtyinr());
			this.setStlref(stlref.toString());
			//save the led data
			this.getDedgrp().getRec().setFlg("2");
			IDatafield ledinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"dedgrp\\rec\\inr");
			ledinr.setValue(Platform.sdbCounter("ded"));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getDedgrp().getRec());
			//and the pts
			String inr = this.getDedgrp().getRec().getInr();
			this.getDedgrp().getBen().savRolPts(inr,"ded","ben");
			this.getDedgrp().getIsb().savRolPts(inr,"ded","isb");
			this.getDedgrp().getApl().savRolPts(inr,"ded","apl");
			//$\\bimenu\\grptyp.setValue("dedgrp");
			this.setGrptyp("dedgrp");
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000154"));
			this.setFrm("detopn");
			this.setObjtyp("ded");
			this.setObjinr(inr);
			return true;
		}
        /**
        *   source:bimenu.@0047.script
        */
        public boolean determineMTD07(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("EAB".equals(a1))
			{
			  Object stlref = data.get("dedgrp\\rec\\stlref");
			  if(MdaUtils.isEmpty(stlref))
			  {
			    log.debug("{}","stlref = "+stlref);
			    return false;
			  }
			  this.setStlref(stlref.toString());
			  String dedinr = null;
			  if(reloadDataByStlref("ded",stlref.toString()))
			  {
			    setModuleContent(data);
			    dedinr = this.getDedgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getDedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			    ctx.getDaoSession().dbRead(this.getDedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			    ctx.getDaoSession().dbRead(this.getDedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getDedgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"dedgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getDedgrp().getRec().setEtyinr(this.getEtyinr());
			    dedinr = Platform.sdbCounter("ded");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"dedgrp\\rec\\inr");
			    inr.setValue(dedinr);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getDedgrp().getRec());
			  }
			  this.getDedgrp().getApl().savRolPts(dedinr,"ded","apl");
			  this.getDedgrp().getBen().savRolPts(dedinr,"ded","ben");
			  this.getDedgrp().getIsb().savRolPts(dedinr,"ded","isb");
			  this.setGrptyp("dedgrp");
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000155"));
			  this.setFrm("detame");
			  this.setObjtyp("ded");
			  this.setObjinr(dedinr);
			}
			else if("AKA".equals(a1))
			{

			  //litame
			  Object stlref = data.get("didgrp\\rec\\stlref");
			  if(MdaUtils.isEmpty(stlref))
			  {
			    log.info("{}","stlref is null!");
			    return false;
			  }
			  this.setStlref(stlref.toString());
			  String didinr = null;
			  if(reloadDataByStlref("did",stlref.toString()))
			  {
			    didinr = this.getDidgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			    ctx.getDaoSession().dbRead(this.getDidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			    ctx.getDaoSession().dbRead(this.getDidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			    ctx.getDaoSession().dbRead(this.getDidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    didinr = Platform.sdbCounter("did");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec\\inr");
			    inr.setValue(didinr);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec"));
			  }
			  if(MdaUtils.isEmpty(this.getDidgrp().getApl().getPts().getRef()))
			    this.getDidgrp().getApl().getPts().setRef(this.getDidgrp().getRec().getStlref());
			  this.getDidgrp().getApl().savRolPts(didinr,"did","apl");
			  this.getDidgrp().getBen().savRolPts(didinr,"did","ben");
			  this.getDidgrp().getIsb().savRolPts(didinr,"did","isb");
			  this.getDidgrp().getAdv().savRolPts(didinr,"did","adv");
			  this.setGrptyp("didgrp");
			  this.setFrm("ditmav");
			  this.setObjtyp("did");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000159"));
			}

			return true;
		}
        /**
        *   source:bimenu.@0048.script
        */
        public boolean determineMTD12(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("AKA".equals(a1))
			{
			  //import
			  Object stlref = data.get("bddgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			  String bddinr = null;
			  if(reloadDataByStlref("bdd",stlref.toString()))
			  {
			    bddinr = this.getBddgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			    ctx.getDaoSession().dbRead(this.getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			    setModuleContent(data);
			    this.getBddgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBddgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    bddinr= Platform.sdbCounter("bdd");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			    inr.setValue(bddinr);
			    this.getBddgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBddgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBddgrp().getApl().getPts().getRef()))
			    this.getBddgrp().getApl().getPts().setRef(this.getBddgrp().getRec().getPntstlref());
			  this.getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			  this.getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			  //update the flag
			  this.setGrptyp("bddgrp");
			  this.setFrm("bdtudp");
			  this.setObjtyp("bdd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			  if(!MdaUtils.isEmpty(inr))
			    this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000156"));
			}
			else if("EAB".equals(a1))
			{
			  Object stlref = data.get("bmdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref)) this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bmd",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBmdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBmdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBmdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bmd"));
			    this.getBmdgrp().getRec().setDocflg("accept");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBmdgrp().getRec());
			  }
			  this.setGrptyp("bmdgrp");
			  this.setFrm("bmtacc");
			  this.setObjtyp("bmd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000157"));
			}

			return true;
		}
        /**
        *   source:bimenu.@0049.script
        */
        public boolean determineMTD72 (HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("bddgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			Object lcref=data.get("bddgrp\\rec\\pntstlref");
			log.debug("{}","lcref="+lcref);
			this.setStlref(stlref.toString());
			String bddinr = null;
			if(reloadDataByArg("bdd","stlref",stlref.toString()))
			{
			  bddinr = this.getBddgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBddgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec"));
			}
			else
			{

			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBddgrp().getRec().setDbchcod(this.getBchcod());
			  bddinr=Platform.sdbCounter("bdd");
			  this.getBddgrp().getRec().setInr(bddinr);
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBddgrp().getApl().getPts().getRef()))
			  this.getBddgrp().getApl().getPts().setRef(this.getBddgrp().getRec().getPntstlref());
			this.getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			this.getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			this.getBddgrp().getPrb().savRolPts(bddinr,"bdd","prb");
			//update the flag
			//
			this.setGrptyp("bddgrp");
			this.setFrm("bdtdck");
			this.setObjtyp("bdd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000160"));
			return true;
		}
        /**
        *   source:bimenu.@0050.script
        */
        public boolean determineMTD54(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("AKA".equals(a1))
			{
			  Object stlref = data.get("bddgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+stlref.toString());
			  if(MdaUtils.isEmpty(stlref))
			    return false;
			  String bddinr = null;
			  if(!reloadDataByArg("bdd","stlref",stlref.toString()))
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			    bddinr = Platform.sdbCounter("bdd");
			    inr.setValue(bddinr);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBddgrp().getRec());
			  }
			  else
			  {
			    bddinr = this.getBddgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			    ctx.getDaoSession().dbRead(this.getBddgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			    ctx.getDaoSession().dbRead(this.getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			    setModuleContent(data);
			    IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\docflg");
			    docflg.setValue("payment");
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBddgrp().getRec());
			  }
			  if(MdaUtils.isEmpty(this.getBddgrp().getApl().getPts().getRef()))
			    this.getBddgrp().getApl().getPts().setRef(this.getBddgrp().getRec().getPntstlref());
			  this.getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			  this.getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			  this.getBddgrp().getBeb().savRolPts(bddinr,"bdd","beb");
			  //update the flag
			  this.setGrptyp("bddgrp");
			  this.setFrm("bdtpay");
			  this.setObjtyp("bdd");
			  this.setObjinr(bddinr);
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000161"));
			}
			else if("EAB".equals(a1))
			{
			  //export
			  Object lcref=data.get("bmdgrp\\rec\\stlref");
			  log.debug("{}","lcref="+lcref.toString());
			  if(MdaUtils.isEmpty(lcref))
			    return false;
			  this.setStlref(lcref.toString());
			  if(reloadDataByStlref("bmd",lcref.toString()))
			  {
			    setModuleContent(data);
			    this.getBmdgrp().getRec().setDocflg("payment");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    this.getBmdgrp().getRec().setDocflg("payment");
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bmd"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec"));
			  }
			  this.setGrptyp("bmdgrp");
			  this.setFrm("bmtset");
			  this.setObjtyp("bmd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000162"));
			}

			return true;
		}
        /**
        *   source:bimenu.@0051.script
        */
        public boolean determineMTD76(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("bddgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			{
			  return false;
			}
			this.setStlref(stlref.toString());
			if(reloadDataByArg("bdd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBddgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield bddinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			  bddinr.setValue(Platform.sdbCounter("bdd"));
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBddgrp().getApl().getPts().getRef()))
			  this.getBddgrp().getApl().getPts().setRef(this.getBddgrp().getRec().getPntstlref());
			//update the flag
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec"));
			this.setGrptyp("bddgrp");
			this.setFrm("bdtdcr");
			this.setObjtyp("bdd");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bddgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000163"));
			return true;
		}
        /**
        *   source:bimenu.@0052.script
        */
        public boolean determineMTD32(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			String a1=this.getA1();
			if("EAB".equals(a1))
			{
			  Object stlref = data.get("bmdgrp\\rec\\stlref");
			  Object pntref=data.get("bmdgrp\\rec\\pntref");
			  this.setStlref(stlref.toString());
			  log.debug("{}","pntref="+pntref);
			  log.debug("{}","stlref = "+this.getStlref());
			  if(!MdaUtils.isEmpty(pntref))
			  {
			    String strpntref = pntref.toString();
			    ctx.getDaoSession().dbRead(this.getDedgrp().getRec(),new Argument<String>("stlref",strpntref));
			    if(!MdaUtils.isEmpty(this.getDedgrp().getRec().getInr()))
			    {
			      String ledinr = this.getDedgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getBmdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      ctx.getDaoSession().dbRead(this.getBmdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      ctx.getDaoSession().dbRead(this.getBmdgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			      this.getBmdgrp().getApl().getPts().setInr("");
			      this.getBmdgrp().getBen().getPts().setInr("");
			      this.getBmdgrp().getIsb().getPts().setInr("");
			      this.getBmdgrp().getRec().setIsscur(this.getDedgrp().getRec().getLcccur());
			      this.getBmdgrp().getRec().setIssamt(this.getDedgrp().getRec().getLccamt());
			    }
			  }
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getCliptyinr());
			  if(!MdaUtils.isEmpty(this.getEtyinr()))
			    this.getBmdgrp().getRec().setEtyinr(this.getEtyinr());
			  IDatafield docflg=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBmdgrp().getRec().setDbchcod(this.getBchcod());
			  String bmdinr = Platform.sdbCounter("bmd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			  inr.setValue(bmdinr);
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec"));
			  this.getBmdgrp().getBen().savRolPts(bmdinr,"bmd","ben");
			  this.getBmdgrp().getIsb().savRolPts(bmdinr,"bmd","isb");
			  this.getBmdgrp().getApl().savRolPts(bmdinr,"bmd","apl");
			  //$\\sysmod.sdbUpdate(Platform.getModule($\\bimenu,"bmdgrp\\\\rec"));
			  this.setGrptyp("bmdgrp");
			  this.setFrm("bmtsnd");
			  this.setObjtyp("bmd");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000165"));
			}

			return true;
		}
        /**
        *   source:bimenu.@0053.script
        */
        public boolean determineMTD34(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String a1=null;
			if(MdaUtils.isEmpty(this.getA1()))
			  return false;
			a1=this.getA1();
			if("EAB".equals(a1))
			{
			  Object stlref = data.get("bmdgrp\\rec\\stlref");
			  if(!MdaUtils.isEmpty(stlref))
			    this.setStlref(stlref.toString());
			  log.debug("{}","stlref = "+ stlref);
			  if(MdaUtils.isEmpty(stlref))
			  {
			    return false;
			  }
			  if(reloadDataByStlref("bmd",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBmdgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBmdgrp().getRec());
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getCliptyinr());
			    if(!MdaUtils.isEmpty(this.getEtyinr()))
			      this.getBmdgrp().getRec().setEtyinr(this.getEtyinr());
			    IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			    inr.setValue(Platform.sdbCounter("bmd"));
			    this.getBmdgrp().getRec().setDocflg("retrej");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBmdgrp().getRec());
			  }
			  this.setGrptyp("bmdgrp");
			  this.setFrm("bmtdck");
			  this.setObjtyp("bmd");
			  IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"bmdgrp\\rec\\inr");
			  this.setObjinr(inr.getValue().toString());
			  this.setObjnam(MdaUtils.getI18NString("bimenu","CT000166"));
			  return true;
			}
			return true;
		}
        /**
        *   source:bimenu.@0054.script
        */
        public boolean determineMTD74(HashMap<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object stlref = data.get("didgrp\\rec\\stlref");
			log.debug("{}","did stlref = "+stlref);
			if(MdaUtils.isEmpty(stlref))
			  return false;
			this.setStlref(stlref.toString());
			String didinr = null;
			if(!reloadDataByArg("did","stlref",stlref.toString()))
			  return false;
			didinr = this.getDidgrp().getRec().getInr();
			setModuleContent(data);
			ctx.getDaoSession().dbRead(this.getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec"));
			ctx.getDaoSession().dbReadset(this.getBddlst(),new Argument("pntstlref",stlref.toString()));
			for(int i=0;i<this.getBddlst().fullSize();i++)
			{

			  this.getBddlst().getElement(i).setClsdat(this.getDidgrp().getRec().getClsdat());
			  ctx.getDaoSession().dbUpdate(this.getBddlst().getElement(i));
			}
			this.setGrptyp("didgrp");
			this.setFrm("ditcan");
			this.setObjtyp("did");
			IDatafield inr=MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Bimenu.class),"didgrp\\rec\\inr");
			this.setObjinr(inr.getValue().toString());
			this.setObjnam(MdaUtils.getI18NString("bimenu","CT000168"));
			return true;
		}













































































































}