package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bmtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bmtp.class);

        //获得卖方信用证来证通知的信息
        private transient IControl getbed = new ControlImpl("getbed", "获得卖方信用证来证通知的信息", this);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl del = new ControlImpl("del", "删除", this);

        //LOGO标志
        private String logo;

        //OK
        private transient IControl ok = new ControlImpl("ok", "OK", this);

        //tempvar
        private String tempvar;


        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp14;

        @JsonIgnore
        @BDGetter
        private transient IPanel othpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel bmtp15;

        @JsonIgnore
        @BDGetter
        private transient IPanel betcdvame;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Dedgrp> dedgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bmdgrp> bmdgrp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Docgrdm docgrdm;

	    @BDGetter
		private Bnkrec bnkrec;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp bebp;

	    @BDGetter
		private Ptsp othp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp rmbp;

		@BDGetter
		private ModuleList<Cls> clslst;

	    @BDGetter
		private Pdfviw pdfviw;


		public Bmtp()
        {
            super();
            setArgument();
        }

        public Bmtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getIsbp().setPtsptaHolder(()->this.getDedgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBenp().setPtsptaHolder(()->this.getDedgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getDocgrdm().setOthdocHolder( new FieldHolder<String>(){
				public String getPath(){return Bmtp.this.getFieldPath("bmdgrp.bnkrecd.othdoc");}
 				public void setValue(String arg){Bmtp.this.getBmdgrp().getBnkrecd().setOthdoc(arg);}
 				public String getValue(){return Bmtp.this.getBmdgrp().getBnkrecd().getOthdoc();}}
			 );
            this.getBnkrec().setBnkrecdHolder(()->this.getBmdgrp().getBnkrecd());
            this.getBnkrec().setCmcrecdHolder(()->this.getBmdgrp().getCmcrecd());
            this.getAplp().setPtsptaHolder(()->this.getBmdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBebp().setPtsptaHolder(()->this.getBmdgrp().getBeb());
            this.getBebp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBebp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getBebp().setRolHolder(new FieldConstantHolder<>("beb"));
            this.getOthp().setPtsptaHolder(()->this.getBmdgrp().getOth());
            this.getOthp().setRolHolder(new FieldConstantHolder<>("oth"));
            this.getOthp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getOthp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setPtsptaHolder(()->this.getBmdgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getDapp().setPtsptaHolder(()->this.getBmdgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getRmbp().setPtsptaHolder(()->this.getBmdgrp().getRmb());
            this.getRmbp().setRolHolder(new FieldConstantHolder<>("rmb"));
            this.getRmbp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getRmbp().setFlgHolder(new FieldConstantHolder<>("agt"));
        }




        /**
        *   source:bmtp.@0000.script
        */
        public void encodeApl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getBmdgrp().setDocnum(NULLSTR);
			this.getBmdgrp().setDoccpy(NULLSTR);
			this.getBmdgrp().setDoctyp(NULLSTR);
			int len = this.getDocgrdm().getDocgrd().fullSize();
			StringBuffer docnum=new StringBuffer();
			StringBuffer doccpy=new StringBuffer();
			StringBuffer doctyp=new StringBuffer();
			String conn="";
			String cc = null;
			for(int i=0;i<len;i++)
			{
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDocnum();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  docnum.append(conn).append(cc);
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDoccpy();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  doccpy.append(conn).append(cc);
			  cc = this.getDocgrdm().getDocgrd().getElement(i).getDoctyp();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  doctyp.append(conn).append(cc);
			  conn = ",";
			}
			log.info("{}","docnum:"+docnum);
			log.info("{}","doccpy:"+doccpy);
			log.info("{}","doctyp:"+doctyp);
			this.getBmdgrp().setDocnum(docnum.toString());
			this.getBmdgrp().setDoccpy(doccpy.toString());
			this.getBmdgrp().setDoctyp(doctyp.toString());
		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setDedgrpHolder(ModuleHolder<Dedgrp> dedgrp)
        {
           this.dedgrp = dedgrp;
        }

        public Dedgrp getDedgrp()
        {
           return this.dedgrp.get();
        }

        public void setBmdgrpHolder(ModuleHolder<Bmdgrp> bmdgrp)
        {
           this.bmdgrp = bmdgrp;
        }

        public Bmdgrp getBmdgrp()
        {
           return this.bmdgrp.get();
        }





































}