package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Botp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Botp.class);

        //(杂项申请)修改后币种
        @Module(getter = false, setter = false)
		private FieldHolder<String> cur = new FieldConstantHolder<>("");


        //(杂项申请)修改后金额
        @Module(getter = false, setter = false)
		private FieldHolder<BigDecimal> amt = new FieldConstantHolder<>();


        //(杂项申请)修改交单条件期限
        @Module(getter = false, setter = false)
		private FieldHolder<String> modtenor = new FieldConstantHolder<>("");


        //(杂项申请)修改交单条件天数
        @Module(getter = false, setter = false)
		private FieldHolder<String> modtenorday = new FieldConstantHolder<>("");


        //(杂项申请)变更后到期日
        @Module(getter = false, setter = false)
		private FieldHolder<Date> dat = new FieldConstantHolder<>();


        //tempvar
        private String tempvar;

        //qita
        private transient IControl qita = new ControlImpl("qita", "qita", this);

        //ok
        private transient IControl ok = new ControlImpl("ok", "ok", this);

        //账号选择1
        private transient IControl yslact = new ControlImpl("yslact", "账号选择1", this);

        //账号选择2
        private transient IControl jslact = new ControlImpl("jslact", "账号选择2", this);

        //日期数字
        private String dayss;


        @JsonIgnore
        @BDGetter
        private transient IPanel botp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel botp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel othpnl;

        @JsonIgnore
        @BDGetter
        private transient IPanel anniu;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bodgrp> bodgrp;

	    @BDGetter
		private Docgrdm docgrdm;

	    @BDGetter
		private Bnkrec bnkrec;

	    @BDGetter
		private Ptsp drrp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp clbp;

	    @BDGetter
		private Ptsp dapp;

		@BDGetter
		private ModuleList<Cls> clslst;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Actmod actmod;


		public Botp()
        {
            super();
            setArgument();
        }

        public Botp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getDocgrdm().setOthdocHolder( new FieldHolder<String>(){
				public String getPath(){return Botp.this.getFieldPath("bodgrp.bnkrecd.othdoc");}
 				public void setValue(String arg){Botp.this.getBodgrp().getBnkrecd().setOthdoc(arg);}
 				public String getValue(){return Botp.this.getBodgrp().getBnkrecd().getOthdoc();}}
			 );
            this.getBnkrec().setBnkrecdHolder(()->this.getBodgrp().getBnkrecd());
            this.getBnkrec().setCmcrecdHolder(()->this.getBodgrp().getCmcrecd());
            this.getDrrp().setPtsptaHolder(()->this.getBodgrp().getDrr());
            this.getDrrp().setRolHolder(new FieldConstantHolder<>("drr"));
            this.getDrrp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getDrrp().setBelongtoHolder(new FieldConstantHolder<>("bod"));
            this.getDrep().setPtsptaHolder(()->this.getBodgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("bod"));
            this.getClbp().setPtsptaHolder(()->this.getBodgrp().getClb());
            this.getClbp().setBelongtoHolder(new FieldConstantHolder<>("bod"));
            this.getClbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getClbp().setRolHolder(new FieldConstantHolder<>("clb"));
            this.getDapp().setPtsptaHolder(()->this.getBodgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bod"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
        }




        /**
        *   source:botp.@0001.script
        */
        public void changeDoctypcod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String doctypcod = this.getBodgrp().getRec().getDoctypcod();
			log.debug("{}","doctypcod=="+doctypcod);
			if("2".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBodgrp().getRec().setMatpercnt(0);
			  this.getBodgrp().getRec().setMatpertyp(NULLSTR);
			  
			  this.getBodgrp().setMixdet(NULLSTR);
			}
			else if("1".equals(doctypcod)  ||  "3".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBodgrp().getRec().setMatpertyp("1");
			  
			  this.getBodgrp().setMixdet(NULLSTR);
			}
			else if("4".equals(doctypcod))
			{
			  
			  
			  
			  
			  this.getBodgrp().getRec().setMatpercnt(0);
			  this.getBodgrp().getRec().setMatpertyp(NULLSTR);
			  
			}
			
			
			
		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setBodgrpHolder(ModuleHolder<Bodgrp> bodgrp)
        {
           this.bodgrp = bodgrp;
        }

        public Bodgrp getBodgrp()
        {
           return this.bodgrp.get();
        }





















        public void setCurHolder(FieldHolder<String> cur)
        {
           this.cur = (cur);
        }

        public void setCur(String cur)
        {
            this.cur.setValue(cur);
        }

        public String getCur()
        {
            return this.cur.getValue();
        }



        public void setAmtHolder(FieldHolder<BigDecimal> amt)
        {
           this.amt = (amt);
        }

        public void setAmt(BigDecimal amt)
        {
            this.amt.setValue(amt);
        }

        public BigDecimal getAmt()
        {
            return this.amt.getValue();
        }



        public void setModtenorHolder(FieldHolder<String> modtenor)
        {
           this.modtenor = (modtenor);
        }

        public void setModtenor(String modtenor)
        {
            this.modtenor.setValue(modtenor);
        }

        public String getModtenor()
        {
            return this.modtenor.getValue();
        }



        public void setModtenordayHolder(FieldHolder<String> modtenorday)
        {
           this.modtenorday = (modtenorday);
        }

        public void setModtenorday(String modtenorday)
        {
            this.modtenorday.setValue(modtenorday);
        }

        public String getModtenorday()
        {
            return this.modtenorday.getValue();
        }



        public void setDatHolder(FieldHolder<Date> dat)
        {
           this.dat = (dat);
        }

        public void setDat(Date dat)
        {
            this.dat.setValue(dat);
        }

        public Date getDat()
        {
            return this.dat.getValue();
        }













}