package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 转议付/出口押汇s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bptp.class);

        //人民币账号：
        private String rmblabel;

        //原币账号：
        private String reblabel;

        //合同号
        private String contracttxt;

        //关联查询合同号
        private transient IControl contquery = new ControlImpl("contquery", "关联查询合同号", this);

        //确定
        private transient IControl ensure = new ControlImpl("ensure", "确定", this);

        //融资类型
        private String ptytyp;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //机构中文名称
        private String bchcod;

        //入人民币账号
        private String rmbact;

        //申请日期
        private String credat;

        //入账号
        private String rmaact;

        //合同号
        private String contracttxt1;

        //获取参号
        private transient IControl getref = new ControlImpl("getref", "获取参号", this);

        //预览出口押汇协议PDF
        private transient IControl pdfpxd = new ControlImpl("pdfpxd", "预览出口押汇协议PDF", this);

        //临时流，用来存储PDF数据
        private IStream tempstream = new StreamImpl();

        //预览保证金协议PDF
        private transient IControl pdfbxd = new ControlImpl("pdfbxd", "预览保证金协议PDF", this);

        //预览保证金委托开户及扣划申请PDF
        private transient IControl pdfmar = new ControlImpl("pdfmar", "预览保证金委托开户及扣划申请PDF", this);

        //预览出口押汇申请PDF
        private transient IControl pdfbpd = new ControlImpl("pdfbpd", "预览出口押汇申请PDF", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //单证通影像批次号
        private String dztimgref;

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择
        private transient IControl actsure = new ControlImpl("actsure", "账户选择", this);

        //常用账户选择
        private transient IControl actselect = new ControlImpl("actselect", "常用账户选择", this);

        //出口押汇申请书
        private String checked1;

        //出口押汇协议
        private String checked2;

        //保证金协议、保证金委托开户及扣划申请
        private String checked3;

        //同意
        private String agree;

        //影像资料
        private String checked4;

        //融资，付息，利率查看
        private transient IControl lokrat = new ControlImpl("lokrat", "融资，付息，利率查看", this);

        //返回
        private transient IControl returns = new ControlImpl("returns", "返回", this);

        //还款提示
        private String huktis;


        @JsonIgnore
        @BDGetter
        private transient IPanel bptbasinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptopncom;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn07;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn08;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn09;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn10;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapn11;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdltop;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdlstep06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfmstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfmstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfmtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel bxtdavstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bxtdav01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bxtdavtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfmstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfm03;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptll;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bedgrp> bedgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bodgrp> bodgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bpdgrp> bpdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ledgrp> ledgrp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp cblp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Txmmod rgtclu;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Bummod bummod;

	    @BDGetter
		private Bxdmod bxdmod;

		@BDGetter
		private ModuleList<Act> actlst;


		public Bptp()
        {
            super();
            setArgument();
        }

        public Bptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getIsbp().setPtsptaHolder(()->this.getBpdgrp().getIsb());
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getAplp().setPtsptaHolder(()->this.getBpdgrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getCblp().setPtsptaHolder(()->this.getBpdgrp().getCbl());
            this.getCblp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getCblp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getCblp().setRolHolder(new FieldConstantHolder<>("cbl"));
            this.getDapp().setPtsptaHolder(()->this.getBpdgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getRgtclu().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Bptp.this.getFieldPath("bpdgrp.rec.rgtclu");}
 				public void setValue(String arg){Bptp.this.getBpdgrp().getRec().setRgtclu(arg);}
 				public String getValue(){return Bptp.this.getBpdgrp().getRec().getRgtclu();}}
			 );
            this.getRgtclu().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getBxdmod().setBxdHolder(()->this.getBpdgrp().getBxd());
            this.getBxdmod().setMarHolder(()->this.getBpdgrp().getMar());
            this.getBxdmod().setObjtypHolder(new FieldConstantHolder<>("bpd"));
            this.getBxdmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptp.this.getFieldPath("bpdgrp.rec.inr");}
 				public void setValue(String arg){Bptp.this.getBpdgrp().getRec().setInr(arg);}
 				public String getValue(){return Bptp.this.getBpdgrp().getRec().getInr();}}
			 );
            this.getBxdmod().setRefHolder( new FieldHolder<String>(){
				public String getPath(){return Bptp.this.getFieldPath("bpdgrp.rec.ownref");}
 				public void setValue(String arg){Bptp.this.getBpdgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Bptp.this.getBpdgrp().getRec().getOwnref();}}
			 );
            this.getBxdmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Bptp.this.getFieldPath("bpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Bptp.this.getBpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Bptp.this.getBpdgrp().getRec().getPtyinr();}}
			 );
            this.getBxdmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Bptp.this.getFieldPath("bpdgrp.rec.bchcod");}
 				public void setValue(String arg){Bptp.this.getBpdgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Bptp.this.getBpdgrp().getRec().getBchcod();}}
			 );
            this.getBxdmod().setBxdprefixHolder(new FieldConstantHolder<>("JX"));
            this.getBxdmod().setMarprefixHolder(new FieldConstantHolder<>("MZ"));
            this.getBxdmod().setMxdlstHolder(()->this.getBpdgrp().getMxdlst());
        }

        /**
        *   source:bptp.@0000.script
        */
        @Rule(target="bpdgrp.rec.paytyp",order=100)
        public boolean ruleBpdgrpRecPaytypN100(){
            IContext ctx = MdaEnv.getContext();
            
			changePaytyp();

			return true;
        }

        /**
        *   source:bptp.@0011.script
        */
        @Rule(target="getref",order=100)
        public boolean ruleGetrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getBpdgrp().getPxd(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "YX");
			if(TRUE.equals(this.getChecked3()))
			{
			  this.getBpdgrp().getBxd().setHtbh(this.getBpdgrp().getPxd().getOwnref());
			  
			  
			}

			return true;
        }

        /**
        *   source:bptp.@0013.script
        */
        @Rule(target="pdfpxd",order=100)
        public boolean rulePdfpxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","bptapl2","出口押汇协议",1);

			return true;
        }

        /**
        *   source:bptp.@0014.script
        */
        @Rule(target="pdfbxd",order=100)
        public boolean rulePdfbxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","bptapl3","保证金协议",1);

			return true;
        }

        /**
        *   source:bptp.@0015.script
        */
        @Rule(target="pdfbpd",order=100)
        public boolean rulePdfbpdN100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptytyp=this.getPtytyp();
			log.debug("{}","申请业务种类，ptytyp="+ptytyp);
			if("BOD".equals(ptytyp))
			{
			  this.getPdfviw().callPDFComponent("","bptapn","出口押汇申请",1);
			}
			else if("BED".equals(ptytyp)||"CPD".equals(ptytyp))
			{
			  this.getPdfviw().callPDFComponent("","bptapl","出口押汇申请",1);
			}

			return true;
        }

        /**
        *   source:bptp.@0016.script
        */
        @Rule(target="pdfmar",order=100)
        public boolean rulePdfmarN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","marpdf","保证金委托开户及扣划",1);

			return true;
        }

        /**
        *   source:bptp.@0022.script
        */
        @Rule(target="bpdgrp.pxd.fkfs",order=100)
        public boolean ruleBpdgrpPxdFkfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String fkfs =this.getBpdgrp().getPxd().getFkfs();
			log.debug("{}","order[100],付款方式"+fkfs);
			if("1".equals(fkfs)||"2".equals(fkfs))
			{

			  if(!MdaUtils.isEmpty(this.getBpdgrp().getIsb().getPts().getAdrblk()))
			  {
			    log.debug("{}","开证行"+MdaUtils.getLine(this.getBpdgrp().getIsb().getPts().getAdrblk(),0));
			    this.getBpdgrp().getPxd().setKzh(MdaUtils.getLine(this.getBpdgrp().getIsb().getPts().getAdrblk(),0));
			    
			  }
			  if(!MdaUtils.isEmpty(this.getBpdgrp().getIsb().getPts().getRef()))
			  {
			    this.getBpdgrp().getPxd().setXyzh(this.getBpdgrp().getIsb().getPts().getRef());
			    
			    
			  }
			}
			else if("3".equals(fkfs)||"4".equals(fkfs))
			{
			  if(!MdaUtils.isEmpty(this.getBpdgrp().getCbl().getPts().getAdrblk()))
			  {
			    log.debug("{}","代收行"+MdaUtils.getLine(this.getBpdgrp().getCbl().getPts().getAdrblk(),0));
			    this.getBpdgrp().getPxd().setKzh(MdaUtils.getLine(this.getBpdgrp().getCbl().getPts().getAdrblk(),0));
			    
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0023.script
        */
        @Rule(target="bpdgrp.pxd.syqk",order=100)
        public boolean ruleBpdgrpPxdSyqkN100(){
            IContext ctx = MdaEnv.getContext();
            
			String syqk=this.getBpdgrp().getPxd().getSyqk();
			log.debug("{}","融资属于情况:"+syqk);
			if("1".equals(syqk))
			{
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			else if("2".equals(syqk))
			{
			  this.getBpdgrp().getPxd().setSxhtbh(NULLSTR);
			  this.getBpdgrp().getPxd().setSxhtmc(NULLSTR);
			  this.getBpdgrp().getPxd().setSxhtje(new BigDecimal(0));
			  this.getBpdgrp().getPxd().setXqqs(null);
			  this.getBpdgrp().getPxd().setXqzz(null);
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			}
			
			
			
			
			

			return true;
        }

        /**
        *   source:bptp.@0024.script
        */
        @Rule(target="bpdgrp.pxd.jxyd",order=100)
        public boolean ruleBpdgrpPxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jxyd=this.getBpdgrp().getPxd().getJxyd();
			if("2".equals(jxyd))
			{
			  
			  
			  
			}
			else if("1".equals(jxyd))
			{
			  this.getBpdgrp().getPxd().setJxqtfs(NULLSTR);
			  
			  
			}

			return true;
        }

        /**
        *   source:bptp.@0025.script
        */
        @Rule(target="bpdgrp.pxd.zyjjfs",order=100)
        public boolean ruleBpdgrpPxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            

			String zyjjfs=this.getBpdgrp().getPxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getBpdgrp().getPxd().setZcwyh(NULLSTR);
			  this.getBpdgrp().getPxd().setKtdd(NULLSTR);
			  this.getBpdgrp().getPxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  
			  

			  this.getBpdgrp().getPxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getBpdgrp().getPxd().setZcwyh(NULLSTR);
			  this.getBpdgrp().getPxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:bptp.@0026.script
        */
        @Rule(target="bpdgrp.bxd.cgyd",order=100)
        public boolean ruleBpdgrpBxdCgydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cgyd=this.getBpdgrp().getBxd().getCgyd();
			if("1".equals(cgyd))
			{
			  this.getBpdgrp().getBxd().setYs(0);
			  this.getBpdgrp().getBxd().setBzjqcrq(null);
			  this.getBpdgrp().getBxd().setBzjdqr(null);
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(cgyd))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:bptp.@0027.script
        */
        @Rule(target="bpdgrp.bxd.jsyd",order=100)
        public boolean ruleBpdgrpBxdJsydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jsyd=this.getBpdgrp().getBxd().getJsyd();
			if(!MdaUtils.isEmpty(jsyd))
			{
			  if("5".equals(jsyd))
			  {
			    
			    
			    
			  }
			  else
			  {
			    this.getBpdgrp().getBxd().setJsydqt(NULLSTR);
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0028.script
        */
        @Rule(target="bpdgrp.bxd.jxyd",order=100)
        public boolean ruleBpdgrpBxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			String jxyd=this.getBpdgrp().getBxd().getJxyd();
			log.debug("{}","计息约定："+jxyd);
			if("1".equals(jxyd))
			{//月利率
			  this.getBpdgrp().getBxd().setNll(new BigDecimal(0));
			  this.getBpdgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(jxyd))
			{//年利率
			  this.getBpdgrp().getBxd().setYll(new BigDecimal(0));
			  this.getBpdgrp().getBxd().setJxydqt(NULLSTR);
			  
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(jxyd))
			{//其他约定
			  this.getBpdgrp().getBxd().setNll(new BigDecimal(0));
			  this.getBpdgrp().getBxd().setYll(new BigDecimal(0));
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:bptp.@0029.script
        */
        @Rule(target="bpdgrp.bxd.zyjjfs",order=100)
        public boolean ruleBpdgrpBxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			String zyjjfs=this.getBpdgrp().getBxd().getZyjjfs();
			log.debug("{}","争议解决方式："+zyjjfs);
			if("1".equals(zyjjfs))
			{
			  this.getBpdgrp().getBxd().setZcwyh(NULLSTR);
			  this.getBpdgrp().getBxd().setKtdd(NULLSTR);
			  this.getBpdgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			  
			  
			  
			  

			}
			else if("2".equals(zyjjfs))
			{
			  
			  
			  
			  
			  
			  

			  this.getBpdgrp().getBxd().setQtfs(NULLSTR);
			  
			  
			}
			else if("3".equals(zyjjfs))
			{
			  this.getBpdgrp().getBxd().setZcwyh(NULLSTR);
			  this.getBpdgrp().getBxd().setKtdd(NULLSTR);
			  
			  
			  
			  
			  
			  
			  

			}
			
			
			

			return true;
        }

        /**
        *   source:bptp.@0045.script
        */
        @Rule(target="lokrat",order=100)
        public boolean ruleLokratN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:bptp.@0048.script
        */
        @Rule(target="bpdgrp.rec.isagr",order=100)
        public boolean ruleBpdgrpRecIsagrN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(TRUE.equals($bpdgrp\\rec\\isagr.getValue()))
			  {
			  if(Platform.isEmpty($bpdgrp\\rec\\llsty)||(Platform.isEmpty($bpdgrp\\rec\\xdrat)&&Platform.isEmpty($bpdgrp\\rec\\gbrat)
			  &&Platform.isEmpty($bpdgrp\\rec\\jdrat))||Platform.isEmpty($bpdgrp\\rec\\jssty)||("4".equals($bpdgrp\\rec\\jssty.getValue())
			  &&Platform.isEmpty($bpdgrp\\rec\\qtnote))||Platform.isEmpty($bpdgrp\\rec\\yqrat))
			  {
			  Platform.error($bpdgrp\\rec\\isagr,#CT000965);
			  Platform.clear($bpdgrp\\rec\\isagr);
			  //Platform.prompt(#CT000988,#CT000989);
			  //Platform.popup($bptll);
			  if(Platform.isEmpty($bpdgrp\\rec\\llsty))
			  Platform.error($bpdgrp\\rec\\llsty,#CT000990);
			  if("4".equals($bpdgrp\\rec\\jssty.getValue())&&Platform.isEmpty($bpdgrp\\rec\\qtnote))
			  Platform.error($bpdgrp\\rec\\qtnote,#CT000991);
			  if(Platform.isEmpty($bpdgrp\\rec\\jssty))
			  Platform.error($bpdgrp\\rec\\jssty,#CT000992);
			  if(Platform.isEmpty($bpdgrp\\rec\\yqrat))
			  Platform.error($bpdgrp\\rec\\yqrat,#CT000993);
			  if(!Platform.isEmpty($bpdgrp\\rec\\llsty))
			  {
			  if("1".equals($bpdgrp\\rec\\llsty.getValue())&&Platform.isEmpty($bpdgrp\\rec\\xdrat))
			  Platform.error($bpdgrp\\rec\\xdrat,#CT000994);
			  if("2".equals($bpdgrp\\rec\\llsty.getValue())&&Platform.isEmpty($bpdgrp\\rec\\gbrat))
			  Platform.error($bpdgrp\\rec\\gbrat,#CT001001);
			  if("3".equals($bpdgrp\\rec\\llsty.getValue())&&Platform.isEmpty($bpdgrp\\rec\\jdrat))
			  Platform.error($bpdgrp\\rec\\jdrat,#CT001002);
			  }
			
			  }
			  }*/
			

			return true;
        }

        /**
        *   source:bptp.@0050.script
        */
        @Rule(target="contquery",order=100)
        public boolean ruleContqueryN100(){
            IContext ctx = MdaEnv.getContext();
            

			IDatafield<String> ownref= MdaDriver.getDatafield(this.getBpdgrp().getRec(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "YX");
			if(TRUE.equals(this.getChecked2()))
			{
			  this.getBpdgrp().getRec().setConref(this.getBpdgrp().getRec().getOwnref());
			  
			  
			}

			return true;
        }


        /**
        *   source:bptp.@0008.script
        */
        @Check(target="bpdgrp.rec.matdat",order=100)
        public boolean checkBpdgrpRecMatdatN100(){
            IContext ctx = MdaEnv.getContext();
            

			if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getMatdat()) && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftvaldat()) && MdaUtils.diff(this.getBpdgrp().getRec().getMatdat(),this.getBpdgrp().getRec().getFftvaldat())<0)
			  ctx.setFieldError(this,"bpdgrp.rec.matdat",MdaUtils.getI18NString("bptp","CT000266"));


			return true;
        }

        /**
        *   source:bptp.@0009.script
        */
        @Check(target="bpdgrp.rec.conref",order=100)
        public boolean checkBpdgrpRecConrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if( Platform.isEmpty( $bpdgrp\\rec\\conref))
			  Platform.error($bpdgrp\\rec\\conref,#CT000280);
			  */


			return true;
        }

        /**
        *   source:bptp.@0030.script
        */
        @Check(target="bpdgrp.pxd.yfczhm",order=100)
        public boolean checkBpdgrpPxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfczhm())&&MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfdzyj())&&MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfsjhm())&&MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfwxhm())&&MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfqqhm()))
			  ctx.setFieldError(this,"bpdgrp.pxd.yfczhm",MdaUtils.getI18NString("bptp","CT000727"));
			if(!MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfczhm()))
			{
			  String str=this.getBpdgrp().getPxd().getYfczhm();
			  String regEX="(0?\\d{2,3}\\-)?[1-9]\\d{6,7}(\\-\\d{1,4})?";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.pxd.yfczhm",MdaUtils.getI18NString("bptp","CT000863"));
			  }
			}


			return true;
        }

        /**
        *   source:bptp.@0041.script
        */
        @Check(target="bpdgrp.pxd.yfqqhm",order=100)
        public boolean checkBpdgrpPxdYfqqhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfqqhm()) )
			{
			  String str=this.getBpdgrp().getPxd().getYfqqhm();
			  String regEX="[1-9][0-9]{4,9}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.pxd.yfqqhm",MdaUtils.getI18NString("bptp","CT000865"));
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0042.script
        */
        @Check(target="bpdgrp.pxd.yfsjhm",order=100)
        public boolean checkBpdgrpPxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfsjhm()))
			{
			  String str=this.getBpdgrp().getPxd().getYfsjhm();
			  String regEX="[1][3,4,5,7,8][0-9]{9}";
			  Pattern pattern = Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.pxd.yfsjhm",MdaUtils.getI18NString("bptp","CT000867"));
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0043.script
        */
        @Check(target="bpdgrp.pxd.yfyzbm",order=100)
        public boolean checkBpdgrpPxdYfyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getPxd().getYfyzbm()))
			{
			  String str=this.getBpdgrp().getPxd().getYfyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.pxd.yfyzbm",MdaUtils.getI18NString("bptp","CT000869"));
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0044.script
        */
        @Check(target="bpdgrp.pxd.dsyzbm",order=100)
        public boolean checkBpdgrpPxdDsyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getPxd().getDsyzbm()))
			{
			  String str=this.getBpdgrp().getPxd().getDsyzbm();
			  String regEX="^[0-9]{6}";
			  Pattern pattern=Pattern.compile(regEX);
			  Matcher matcher = pattern.matcher(str);
			  if(!matcher.matches())
			  {
			    ctx.setFieldError(this,"bpdgrp.pxd.dsyzbm",MdaUtils.getI18NString("bptp","CT000870"));
			  }
			}

			return true;
        }

        /**
        *   source:bptp.@0051.script
        */
        @Check(target="bpdgrp.rec.fftvaldat",order=100)
        public boolean checkBpdgrpRecFftvaldatN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getFftvaldat()) && !MdaUtils.isEmpty(this.getBpdgrp().getRec().getCredat()))
			{
			  Date ffdat = this.getBpdgrp().getRec().getFftvaldat();
			  Date credat = this.getBpdgrp().getRec().getCredat();
			  String fdat=MdaUtils.format(ffdat,"yyyyMMdd");
			  String cdat=MdaUtils.format(credat,"yyyyMMdd");
			  if(!fdat.equals(cdat))
			  {
			    if(MdaUtils.diff(ffdat,credat)<0)  //方法出现bug
			    {
			      ctx.setFieldError(this,"bpdgrp.rec.fftvaldat",MdaUtils.getI18NString("bptp","CT001018"));
			      return false;
			    }
			  }
			}

			return true;
        }



        /**
        *   source:bptp.@0001.script
        */
        public void onChangePayTyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ = this.getBpdgrp().getRec().getPaytyp();
			if("1".equals(typ))
			{// rmb
			  
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(typ))
			{
			  
			  
			  
			  
			  
			  
			  
			}
			
			
			
			
		}
        /**
        *   source:bptp.@0031.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActchs());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			if("1".equals(this.getBpdgrp().getRec().getPaytyp()))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			}
			else if("2".equals(this.getBpdgrp().getRec().getPaytyp()))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBpdgrp().getRec().getFftcur()),new Argument<String>("ptyinr",ptyinr));
			}
			
			
		}
        /**
        *   source:bptp.@0032.script
        */
        public void  changePaytyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ = this.getBpdgrp().getRec().getPaytyp();
			if("2".equals(typ))
			{
			  this.getBpdgrp().getRec().setJhrzbills(NULLSTR);
			  this.getBpdgrp().getRec().setBilreason(NULLSTR);
			  
			  
			}
			else if("1".equals(typ))
			{
			  
			  
			}
			
			
		}
        /**
        *   source:bptp.@0037.script
        */
        public List<CodetableItem> getYhfkfsCodeTable(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in bptp.getYhfkfsCodeTable ...") ;
			List<CodetableItem> items =  new ArrayList<CodetableItem>();
			if("BED".equals(typ))
			{
			  items.add(new CodetableItem("即期信用证","1"));
			  items.add(new CodetableItem("远期信用证","2"));

			}
			else
			  if("BOD".equals(typ))
			{
			  items.add(new CodetableItem("付款交单方式下托收","3"));
			  items.add(new CodetableItem("承兑交单方式下托收","4"));
			}
			else
			  if("CPD".equals(typ))
			{
			  items.add(new CodetableItem("汇入汇款","5"));

			}
			return items;
		}
        /**
        *   source:bptp.@0038.script
        */
        public void popupActchs2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActchs());
			String ptyinr =this.getCidmod().getClipty().getInr();
			if("1".equals(this.getBpdgrp().getRec().getPaytyp()))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			}
			else if("2".equals(this.getBpdgrp().getRec().getPaytyp()))
			{
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBpdgrp().getRec().getFftcur()),new Argument<String>("ptyinr",ptyinr));
			}
			
			
		}
        /**
        *   source:bptp.@0039.script
        */
        public void initPaytyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String typ = this.getBpdgrp().getRec().getPaytyp();
			if("1".equals(typ))
			{
			  if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getJhrzbills()))
			  {
			    this.getBpdgrp().getRec().setBilreason(NULLSTR);
			    

			  }
			  else if(!MdaUtils.isEmpty(this.getBpdgrp().getRec().getBilreason()))
			  {
			    this.getBpdgrp().getRec().setJhrzbills(NULLSTR);
			    

			  }

			}
			else if("2".equals(typ))
			{
			  
			  
			}
			
			
		}
        /**
        *   source:bptp.@0040.script
        */
        public void loadTips()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getBpdgrp().getTips()))
			{
			  String tips="Tips:操作指引";
			  tips+=CR+"一、业务发起流程";
			  tips+=CR+"1、贵司应至少提交“出口押汇申请书”和“出口押汇协议”，并根据实际需要选择是否提交“保证金协议、保证金委托开户及扣划申请”及影像资料。";
			  tips+=CR+"2、客户可以通过手工输入或调用历史模板快速编辑并提交业务申请；";
			  tips+=CR+"二、申请书与合同/协议的修改流程 ";
			  tips+=CR+"1、贵司提交的申请书有任何不妥均须由贵司自行修改。届时银行将把申请交易退回单证通“退回文件夹”，由贵司进行修改；";
			  tips+=CR+"2、贵司提交的合同/协议若需要修改，银行客户经理可代为修改，修改完毕将修改结果返回单证通“二次确认夹”供贵司确认后再行提交。";
			  this.getBpdgrp().setTips(tips);
			}

		}
        /**
        *   source:bptp.@0052.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}

        public void setBedgrpHolder(ModuleHolder<Bedgrp> bedgrp)
        {
           this.bedgrp = bedgrp;
        }

        public Bedgrp getBedgrp()
        {
           return this.bedgrp.get();
        }

        public void setBodgrpHolder(ModuleHolder<Bodgrp> bodgrp)
        {
           this.bodgrp = bodgrp;
        }

        public Bodgrp getBodgrp()
        {
           return this.bodgrp.get();
        }

        public void setBpdgrpHolder(ModuleHolder<Bpdgrp> bpdgrp)
        {
           this.bpdgrp = bpdgrp;
        }

        public Bpdgrp getBpdgrp()
        {
           return this.bpdgrp.get();
        }

        public void setLedgrpHolder(ModuleHolder<Ledgrp> ledgrp)
        {
           this.ledgrp = ledgrp;
        }

        public Ledgrp getLedgrp()
        {
           return this.ledgrp.get();
        }





















































































}