package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Tbllst;
import com.ceb.gjjs.mda.bo.Brdc;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Brtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Brtp.class);

        //拒付结果
        private String rejectlabel;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //付款界面
        private transient IControl topay = new ControlImpl("topay", "付款界面", this);

        //点我付款
        private transient IControl clicktopay = new ControlImpl("clicktopay", "点我付款", this);

        //活动界面
        private IPanel transpanel;

        //现汇
        private String cur;

        //购汇
        private String cur1;

        //他汇
        private String cur2;

        //fx账户选择按钮
        private transient IControl fxbut = new ControlImpl("fxbut", "fx账户选择按钮", this);

        //pur账户选择按钮
        private transient IControl purbut = new ControlImpl("purbut", "pur账户选择按钮", this);

        //oth账户选择按钮
        private transient IControl othbut = new ControlImpl("othbut", "oth账户选择按钮", this);

        //账户选择按钮标记
        private String actchsflg;

        //账号
        private String acc;

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择
        private transient IControl actsurel = new ControlImpl("actsurel", "账户选择", this);

        //账户类型
        private String acttyp;

        //是否付汇
        private String fhflg;

        //是否代付
        private String dfflg;

        //获取参号（押汇）
        private transient IControl getreftr = new ControlImpl("getreftr", "获取参号（押汇）", this);

        //获取参号（代付）
        private transient IControl getrefdf = new ControlImpl("getrefdf", "获取参号（代付）", this);

        //代付参号
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefixdf = new FieldConstantHolder<>("");


        //押汇参号
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefixtr = new FieldConstantHolder<>("");


        //预览进口押汇申请书
        private IStream pdftrd = new StreamImpl();

        //预览同业代付申请书
        private IStream pdfdfd = new StreamImpl();

        //押汇期限
        private String subday;

        //大写
        private String word;

        //利息数值1
        private String arrnum1;

        //利息数值2
        private String arrnum2;

        //利息数值3
        private String arrnum3;

        //结息方式
        private String jxfs;

        //预览项下到单面函
        private transient IControl viwusdoc = new ControlImpl("viwusdoc", "预览项下到单面函", this);

        //进口信用证项下到单通知书
        private IStream pdfbrd = new StreamImpl();


        @JsonIgnore
        @BDGetter
        private transient IPanel brtp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtptrans;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel nbrtp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtpayp;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs2;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtpmp;

        @JsonIgnore
        @BDGetter
        private transient IPanel brds2;

        @JsonIgnore
        @BDGetter
        private transient IPanel brds3;

        @JsonIgnore
        @BDGetter
        private transient IPanel brts0;

        @JsonIgnore
        @BDGetter
        private transient IPanel brts4;

        @JsonIgnore
        @BDGetter
        private transient IPanel brts5;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Brdgrp> brdgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp prbp;

	    @BDGetter
		private Ptsp bebp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Lidgrp> lidgrp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

	    @BDGetter
		private Stpmod stpmod;

		@BDGetter
		private ModuleList<Act> actlst;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Apdgrp> apdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trdgrp> trdgrp;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Ptsp rmip;

	    @BDGetter
		private Fpdgrp fpdgrp;

	    @BDGetter
		private Agrp agrp;

		@BDGetter
		private ModuleList<Tbllst> tbllst;

		@BDGetter
		private ModuleList<Brdc> brdclst;


		public Brtp()
        {
            super();
            setArgument();
        }

        public Brtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getBrdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getBenp().setPtsptaHolder(()->this.getBrdgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getPrbp().setPtsptaHolder(()->this.getBrdgrp().getPrb());
            this.getPrbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getPrbp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getPrbp().setRolHolder(new FieldConstantHolder<>("prb"));
            this.getBebp().setPtsptaHolder(()->this.getBrdgrp().getBeb());
            this.getBebp().setRolHolder(new FieldConstantHolder<>("beb"));
            this.getBebp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getBebp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getDapp().setPtsptaHolder(()->this.getBrdgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setPtsptaHolder(()->this.getBrdgrp().getTrp());
            this.getRmip().setPtsptaHolder(()->this.getBrdgrp().getRmi());
            this.getRmip().setRolHolder(new FieldConstantHolder<>("rmi"));
            this.getRmip().setBelongtoHolder(new FieldConstantHolder<>("brd"));
            this.getRmip().setFlgHolder(new FieldConstantHolder<>("agt"));
        }

        /**
        *   source:brtp.@0005.script
        */
        @Rule(target="getrefdf",order=100)
        public boolean ruleGetrefdfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("ZX".equals(this.getPrefixdf()))
			  return false;
			else
			  getRefdf();

			return true;
        }

        /**
        *   source:brtp.@0006.script
        */
        @Rule(target="getreftr",order=100)
        public boolean ruleGetreftrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("ZX".equals(this.getPrefixtr()))
			  return false;
			else
			  getReftr();

			return true;
        }




        /**
        *   source:brtp.@0004.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"jrmb".equals(this.getActchsflg()))
			{
			  MdaUtils.clear(this.getActchs());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();

			  if("pur".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			  else if("oth".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("ptyinr",ptyinr));
			  else
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBrdgrp().getRec().getRelcur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}
			else
			{
			  MdaUtils.clear(this.getActchs2());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getBrdgrp().getRec().getJacccur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}

		}
        /**
        *   source:brtp.@0007.script
        */
        public void getRefdf()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getApdgrp().getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getPrefixdf() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefixdf()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}
        /**
        *   source:brtp.@0008.script
        */
        public void getReftr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getTrdgrp().getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getPrefixtr() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefixtr()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setBrdgrpHolder(ModuleHolder<Brdgrp> brdgrp)
        {
           this.brdgrp = brdgrp;
        }

        public Brdgrp getBrdgrp()
        {
           return this.brdgrp.get();
        }









        public void setLidgrpHolder(ModuleHolder<Lidgrp> lidgrp)
        {
           this.lidgrp = lidgrp;
        }

        public Lidgrp getLidgrp()
        {
           return this.lidgrp.get();
        }









        public void setApdgrpHolder(ModuleHolder<Apdgrp> apdgrp)
        {
           this.apdgrp = apdgrp;
        }

        public Apdgrp getApdgrp()
        {
           return this.apdgrp.get();
        }

        public void setTrdgrpHolder(ModuleHolder<Trdgrp> trdgrp)
        {
           this.trdgrp = trdgrp;
        }

        public Trdgrp getTrdgrp()
        {
           return this.trdgrp.get();
        }























































        public void setPrefixdfHolder(FieldHolder<String> prefixdf)
        {
           this.prefixdf = (prefixdf);
        }

        public void setPrefixdf(String prefixdf)
        {
            this.prefixdf.setValue(prefixdf);
        }

        public String getPrefixdf()
        {
            return this.prefixdf.getValue();
        }



        public void setPrefixtrHolder(FieldHolder<String> prefixtr)
        {
           this.prefixtr = (prefixtr);
        }

        public void setPrefixtr(String prefixtr)
        {
            this.prefixtr.setValue(prefixtr);
        }

        public String getPrefixtr()
        {
            return this.prefixtr.getValue();
        }





















}