package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Btnmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Btnmod.class);

        //开始日期
        private Date begdat;

        //截止日期
        private Date enddat;

        //交易类型
        private String trntyp;

        //机构编号
        private String ptycod;

        //机构名称
        private String ptynam;

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //提交
        private transient IControl submit = new ControlImpl("submit", "提交", this);

        //退回更正
        private transient IControl back = new ControlImpl("back", "退回更正", this);

        //转为历史
        private transient IControl history = new ControlImpl("history", "转为历史", this);

        //申请书
        private IStream apldoc = new StreamImpl();

        //报文草稿
        private transient IControl temtco = new ControlImpl("temtco", "报文草稿", this);

        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);

        //刷新
        private transient IControl fresh = new ControlImpl("fresh", "刷新", this);

        //附件
        private transient IControl attach = new ControlImpl("attach", "附件", this);

        //转通知
        private transient IControl trsfer = new ControlImpl("trsfer", "转通知", this);

        //删除
        private transient IControl cancel = new ControlImpl("cancel", "删除", this);

        //消息
        private IStream msg = new StreamImpl();

        //报文2
        private IStream sw2 = new StreamImpl();

        //暂存
        private transient IControl pend = new ControlImpl("pend", "暂存", this);

        //确定
        private transient IControl ok = new ControlImpl("ok", "确定", this);

        //查询
        private String query;

        //机构编号
        private String ptycod1;

        //机构名称
        private String ptynam1;

        //交易类型
        private String trntyp1;

        //开始日期
        private String begdat1;

        //结束日期
        private String enddat1;

        //审单表
        private IStream table = new StreamImpl();

        //普打申请书
        private IStream pdapldoc = new StreamImpl();

        //套打申请书
        private IStream tdapldoc = new StreamImpl();

        //报关单
        private IStream bot = new StreamImpl();

        //添加
        private transient IControl newitem = new ControlImpl("newitem", "添加", this);

        //报文0
        private IStream sw0 = new StreamImpl();

        //报文1
        private IStream sw1 = new StreamImpl();

        //报文3
        private IStream sw3 = new StreamImpl();

        //报文4
        private IStream sw4 = new StreamImpl();

        //面函0
        private IStream notice0 = new StreamImpl();

        //面函1
        private IStream notice1 = new StreamImpl();

        //面函2
        private IStream notice2 = new StreamImpl();

        //面函3
        private IStream notice3 = new StreamImpl();

        //文件路径
        private String docpth;

        //报文名称
        private String xmlfil;

        //Swift报文名称
        private String sf2fil;

        //交易代码
        private String detfrm;

        //主页
        private transient IControl bakoffice = new ControlImpl("bakoffice", "主页", this);

        //发件人邮箱
        private String sender;

        //收件人邮箱
        private String recver;

        //邮件主题
        private String title;

        //邮件内容
        private String content;

        //发送
        private transient IControl sndmail = new ControlImpl("sndmail", "发送", this);

        //邮件附件名称
        private String athnam;

        //remb table
        private IStream rembtbl = new StreamImpl();

        //打印
        private IStream print = new StreamImpl();

        //下载
        private IStream download = new StreamImpl();

        //币种
        private String cur;

        //最小金额
        private BigDecimal minamt = new BigDecimal("0.00");

        //最大金额
        private BigDecimal maxamt = new BigDecimal("0.00");

        //单笔提交
        private transient IControl submit1 = new ControlImpl("submit1", "单笔提交", this);

        //国业参考号
        private String stlref;

        //参号
        private String ownref;

        //国业参考号
        private String stlref1;

        //参号
        private String ownref1;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //文本
        private transient IControl docbtn0 = new ControlImpl("docbtn0", "文本", this);

        //文本一
        private transient IControl docbtn1 = new ControlImpl("docbtn1", "文本一", this);

        //文本二
        private transient IControl docbtn2 = new ControlImpl("docbtn2", "文本二", this);

        //文本三
        private transient IControl docbtn3 = new ControlImpl("docbtn3", "文本三", this);

        //文本四
        private transient IControl docbtn4 = new ControlImpl("docbtn4", "文本四", this);

        //pdfname
        private Map pdfname;

        //文件名称（即交易流水）
        private String appfilename;

        //交易名称
        private String trncod;

        //提交
        private transient IControl submit02 = new ControlImpl("submit02", "提交", this);

        //退回专业审核
        private transient IControl backkyc = new ControlImpl("backkyc", "退回专业审核", this);

        //文本五
        private transient IControl docbtn5 = new ControlImpl("docbtn5", "文本五", this);

        //文本六
        private transient IControl docbtn6 = new ControlImpl("docbtn6", "文本六", this);

        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);

        //交易状态
        private String sptlev;

        //交易状态
        private String sptlev1;

        //详情界面单笔提交
        private transient IControl submat = new ControlImpl("submat", "详情界面单笔提交", this);

        //银行授权退回留言
        private String thly;

        //退回单一窗口
        private transient IControl dyckth = new ControlImpl("dyckth", "退回单一窗口", this);

        //取消
        private transient IControl quxiao = new ControlImpl("quxiao", "取消", this);

        //业务来源
        private String ywwtyp;

        //业务来源
        private String ywwlab;

        //汇入已确认
        private transient IControl reback = new ControlImpl("reback", "汇入已确认", this);

        //交易名称
        private String nohtyp;

        //交易名称
        private String nohtyp1;

        //发票详情
        private transient IControl invdetail = new ControlImpl("invdetail", "发票详情", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel qurp;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel qurp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnp2;

        @JsonIgnore
        @BDGetter
        private transient IPanel backt;

        @JsonIgnore
        @BDGetter
        private transient IPanel attachp;

        @JsonIgnore
        @BDGetter
        private transient IPanel baktooffice;

        @JsonIgnore
        @BDGetter
        private transient IPanel apldocp;

        @JsonIgnore
        @BDGetter
        private transient IPanel pntp;

        @JsonIgnore
        @BDGetter
        private transient IPanel qamt;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnp1;

        @JsonIgnore
        @BDGetter
        private transient IPanel docbtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel notselp;

        @JsonIgnore
        @BDGetter
        private transient IPanel bnksptselp;

        @JsonIgnore
        @BDGetter
        private transient IPanel trnmgrselp;

        @JsonIgnore
        @BDGetter
        private transient IPanel bnksptbtns01;

        @JsonIgnore
        @BDGetter
        private transient IPanel officebtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel trncfmselp;

        @JsonIgnore
        @BDGetter
        private transient IPanel trncfmdocbtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel docbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel bnksptbtp;

        @JsonIgnore
        @BDGetter
        private transient IPanel bakbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel annl;

        @JsonIgnore
        @BDGetter
        private transient IPanel notbutton;

        @JsonIgnore
        @BDGetter
        private transient IPanel textbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel dyckmain;


	    @BDGetter
		private Pdfviw pdfviw;


		public Btnmod()
        {
            super();
            setArgument();
        }

        public Btnmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:btnmod.@0016.script
        */
        @Rule(target="sw0",order=100)
        public boolean ruleSw0N100(){
            IContext ctx = MdaEnv.getContext();
            
			showSwift(0);

			return true;
        }

        /**
        *   source:btnmod.@0017.script
        */
        @Rule(target="sw1",order=100)
        public boolean ruleSw1N100(){
            IContext ctx = MdaEnv.getContext();
            
			showSwift(1);

			return true;
        }

        /**
        *   source:btnmod.@0018.script
        */
        @Rule(target="sw2",order=100)
        public boolean ruleSw2N100(){
            IContext ctx = MdaEnv.getContext();
            
			showSwift(2);

			return true;
        }

        /**
        *   source:btnmod.@0019.script
        */
        @Rule(target="sw3",order=100)
        public boolean ruleSw3N100(){
            IContext ctx = MdaEnv.getContext();
            
			showSwift(3);

			return true;
        }

        /**
        *   source:btnmod.@0020.script
        */
        @Rule(target="sw4",order=100)
        public boolean ruleSw4N100(){
            IContext ctx = MdaEnv.getContext();
            
			showSwift(4);

			return true;
        }

        /**
        *   source:btnmod.@0021.script
        */
        @Rule(target="notice0",order=100)
        public boolean ruleNotice0N100(){
            IContext ctx = MdaEnv.getContext();
            
			showXML("0");

			return true;
        }

        /**
        *   source:btnmod.@0022.script
        */
        @Rule(target="notice1",order=100)
        public boolean ruleNotice1N100(){
            IContext ctx = MdaEnv.getContext();
            
			showXML("1");

			return true;
        }

        /**
        *   source:btnmod.@0023.script
        */
        @Rule(target="notice2",order=100)
        public boolean ruleNotice2N100(){
            IContext ctx = MdaEnv.getContext();
            
			showXML("2");

			return true;
        }

        /**
        *   source:btnmod.@0024.script
        */
        @Rule(target="notice3",order=100)
        public boolean ruleNotice3N100(){
            IContext ctx = MdaEnv.getContext();
            
			showXML("3");

			return true;
        }

        /**
        *   source:btnmod.@0025.script
        */
        @Rule(target="bakoffice",order=100)
        public boolean ruleBakofficeN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:btnmod.@0035.script
        */
        @Rule(target="docbtn0",order=100)
        public boolean ruleDocbtn0N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			String objtyp = ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getObjtyp();
			if("tas".equals(objtyp))
			{
			  showDocument("docbtn0",0,"1");
			}
			else
			{
			  showDocument("docbtn0",0,"2");
			}

			return true;
        }

        /**
        *   source:btnmod.@0041.script
        */
        @Rule(target="docbtn1",order=100)
        public boolean ruleDocbtn1N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn1",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0042.script
        */
        @Rule(target="docbtn2",order=100)
        public boolean ruleDocbtn2N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn2",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0043.script
        */
        @Rule(target="docbtn3",order=100)
        public boolean ruleDocbtn3N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn3",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0044.script
        */
        @Rule(target="docbtn4",order=100)
        public boolean ruleDocbtn4N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn4",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0050.script
        */
        @Rule(target="docbtn5",order=100)
        public boolean ruleDocbtn5N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn5",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0051.script
        */
        @Rule(target="docbtn6",order=100)
        public boolean ruleDocbtn6N100(){
            IContext ctx = MdaEnv.getContext();
            
			// 查看PDF
			showDocument("docbtn6",0,"2");

			return true;
        }

        /**
        *   source:btnmod.@0053.script
        */
        @Rule(target="return",order=100)
        public boolean ruleReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.showMainPanel();

			return true;
        }


        /**
        *   source:btnmod.@0026.script
        */
        @Check(target="minamt",order=100)
        public boolean checkMinamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!(MdaUtils.isEmpty(this.getMinamt()) && MdaUtils.isEmpty(this.getMaxamt())))
			{
			  BigDecimal minamt = this.getMinamt();
			  BigDecimal maxamt = this.getMaxamt();
			  if(minamt.compareTo(maxamt) > 0)
			    ctx.setFieldError(this,"minamt",MdaUtils.getI18NString("btnmod","CT000110"));
			}

			return true;
        }



        /**
        *   source:btnmod.@0002.script
        */
        public void initQurtPanel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
		}
        /**
        *   source:btnmod.@0003.script
        */
        public void setPanel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setQuery(MdaUtils.getI18NString("btnmod","CT000066"));
			this.setTrntyp1(MdaUtils.getI18NString("btnmod","CT000067"));
			this.setBegdat1(MdaUtils.getI18NString("btnmod","CT000068"));
			this.setEnddat1(MdaUtils.getI18NString("btnmod","CT000069"));
			this.setPtycod1(MdaUtils.getI18NString("btnmod","CT000070"));
			this.setPtynam1(MdaUtils.getI18NString("btnmod","CT000071"));
			this.setBegdat(MdaUtils.add(MdaUtils.today(),-15));
			this.setEnddat(MdaUtils.today());
			
			
		}
        /**
        *   source:btnmod.@0004.script
        */
        public void setCleintPanel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setQuery(MdaUtils.getI18NString("btnmod","CT000072"));
			this.setTrntyp1(MdaUtils.getI18NString("btnmod","CT000073"));
			this.setBegdat1(MdaUtils.getI18NString("btnmod","CT000074"));
			this.setEnddat1(MdaUtils.getI18NString("btnmod","CT000075"));
			this.setBegdat(MdaUtils.today());
			this.setEnddat(MdaUtils.today());
			
			
			
			
			this.setNohtyp1(MdaUtils.getI18NString("btnmod","CT000290"));
		}
        /**
        *   source:btnmod.@0005.script
        */
        public void setQuryPanel(String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:btnmod.@0007.script
        */
        public String getAppPdfName(String trnnam,String btnnam,Map data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			String pdfnam = MdaUtils.getPropertyValue(filepath,trnnam+"."+btnnam);
			if(!MdaUtils.isEmpty(pdfnam))
			  return pdfnam;
			String flg = MdaUtils.getPropertyValue(filepath,trnnam+"."+btnnam+".flg");
			if(MdaUtils.isEmpty(flg))
			{
			  log.info("{}","flg 空");
			  return trnnam;
			}
			log.info("{}","flg="+flg);
			Object o = data.get(flg);
			if(MdaUtils.isEmpty(o))
			{
			  log.info("{}","Object 空");
			  return trnnam;
			}
			log.info("{}","Object="+o.toString());
			pdfnam = MdaUtils.getPropertyValue(filepath,trnnam+"."+btnnam+"."+o.toString());
			if(MdaUtils.isEmpty(pdfnam))
			{
			  log.info("{}","pdfnam 空");
			  return trnnam;
			}
			log.debug("{}",trnnam+" 's "+btnnam+"'s pdfnam="+pdfnam);
			return pdfnam;
		}
        /**
        *   source:btnmod.@0008.script
        */
        public void showAppPdfFile(String appnam,String trnname,String btnnam,IStream stream)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//if(Platform.isEmpty(appnam)||Platform.isEmpty(trnname)||Platform.isEmpty(stream))
			if(MdaUtils.isEmpty(appnam)||MdaUtils.isEmpty(trnname))
			  return;
			//mod by dg 20130312
			String mpath=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),appnam.substring(0,4));
			String mfile=appnam+".app";
			log.debug("{}", mpath+mfile);
			log.debug("{}",trnname+" 's "+btnnam);
			if(!MdaUtils.fileExists(MdaUtils.catPath(mpath,mfile)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("btnmod","CT000076"),MdaUtils.getI18NString("btnmod","CT000077"));
			  return;
			}
			log.debug("{}","to show the file..." );
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",mpath,mfile);
			Map mdata  = (Map) data;
			Object oprbchcod = mdata.get("OPRBCHCOD");
			String logofile = null;
			String signFile = null;
			if(!MdaUtils.isEmpty(oprbchcod))
			{
			  logofile = ctx.absGet(Sysmod.class).getEtyLgnUrl(oprbchcod.toString());
			  signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(oprbchcod.toString());
			}
			else
			{
			  logofile = ctx.absGet(Sysmod.class).getEtyLgnUrl(null);
			  signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(null);
			}
			mdata.put("signfile",signFile);
			log.debug("{}","logo="+logofile);
			String pdfnam = getAppPdfName(trnname,btnnam,mdata);
			if("tcptopn".equals(pdfnam)||"tcptopn1".equals(pdfnam))
			{
			  logofile="";
			}
			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfnam+".pdf");
			log.info("{}","pdf="+pdffile);
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,logofile,stream);
		}
        /**
        *   source:btnmod.@0009.script
        */
        public void initAppButton(String trnNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			if(MdaUtils.isEmpty(trnNam))
			  return;
			log.debug("{}","trnnam="+trnNam);
			if("cptimp".equalsIgnoreCase(trnNam))
			{
			  
			  
			}
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			int cnt = 0;
			String btnnam = null;
			String img = null;
			String appCnt = MdaUtils.getPropertyValue(filepath,trnNam+".count");
			if(appCnt==null  ||  "".equals(appCnt))
			{
			  img = MdaUtils.getPropertyValue(filepath,"DefaultAplImage");
			  btnnam = MdaUtils.getPropertyValue(filepath,"DefaultAplButton");
			  IDatafield id = MdaDriver.getDatafield(ctx.absGet(Trnmod.class).getBtnmod(),btnnam);
			  ((IStream)id.getValue()).setValue(img);
			  
			  
			  
			  return;
			}
			cnt = Integer.parseInt(appCnt);
			for(int i=0;i<cnt;i++)
			{
			  img = MdaUtils.getPropertyValue(filepath,trnNam+"."+i+".img");
			  if(img==null  ||  "".equals(img))
			    img = MdaUtils.getPropertyValue(filepath,"DefaultAplImage");
			  btnnam = MdaUtils.getPropertyValue(filepath,trnNam+"."+i+".button");
			  if(btnnam==null  ||  "".equals(btnnam))
			    btnnam = MdaUtils.getPropertyValue(filepath,"DefaultAplButton");
			  log.debug("{}","btnnam="+btnnam+"\timg="+img);
			  IDatafield id = MdaDriver.getDatafield(ctx.absGet(Trnmod.class).getBtnmod(),btnnam);
			  ((IStream)id.getValue()).setValue(img);
			  
			  
			  
			}
		}
        /**
        *   source:btnmod.@0011.script
        */
        public void initAdvButton(String trnInr,String trnNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			this.setDocpth(NULLSTR);
			this.setXmlfil(NULLSTR);
			this.setSf2fil(NULLSTR);
			this.setDetfrm(trnNam);
			Argument<String> inr=new Argument<String>("inr");
			Argument<String> xmlfil=new Argument<String>("xmlfil");
			Argument<String> sf2fil=new Argument<String>("sf2fil");
			Argument<String> docpth=new Argument<String>("docpth");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr,xmlfil,sf2fil,docpth FROM smh WHERE objtyp='trn' and objinr='"+trnInr+"'");
			ctx.getDaoSession().dbFetchFields(inr,xmlfil,sf2fil,docpth);
			int error=ctx.getErrorCode();
			if(error==NO_ERROR&&!MdaUtils.isEmpty(docpth.value))
			{
			  this.setDocpth(docpth.value);
			  log.debug("{}","sw2fil="+sf2fil.value);
			  if(!MdaUtils.isEmpty(sf2fil.value))
			  {
			    this.setSf2fil(sf2fil.value);
			    String sw2fils = sf2fil.value;
			    String[] sw2fil = sw2fils.split(";");
			    for(int i=0;i<sw2fil.length;i++)
			    {
			      IDatafield id = MdaDriver.getDatafield(ctx.absGet(Btnmod.class),"sw"+i);
			      
			      
			    }
			  }
			  log.debug("{}","xmlfils="+xmlfil.value);
			  if(!MdaUtils.isEmpty(xmlfil.value))
			  {
			    this.setXmlfil(xmlfil.value);
			    String xmlfils =xmlfil.value;
			    String xmlNbm = null;
			    String img = null;
			    String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			    for(String xmlVal:xmlfils.split(";"))
			    {
			      if(xmlVal.indexOf(",")>0)
			        xmlNbm = xmlVal.substring(xmlVal.indexOf(",")+1);
			      if(xmlNbm==null)
			        xmlNbm="0";
			      img = MdaUtils.getPropertyValue(filepath,trnNam+"."+xmlNbm+".img");
			      if(img==null  ||  "".equals(img))
			        img = MdaUtils.getPropertyValue(filepath,trnNam+".img");
			      if(img==null  ||  "".equals(img))
			        img = MdaUtils.getPropertyValue(filepath,"DefaultAdvImage");
			      log.debug("{}","img="+img);
			      IDatafield id = MdaDriver.getDatafield(ctx.absGet(Btnmod.class),"notice"+xmlNbm);
			      ((IStream)id.getValue()).setValue(img);
			      
			      
			    }
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:btnmod.@0012.script
        */
        public String getXmlFile(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=this.getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			if(type==null  ||  "".equals(type))
			  type="0";
			String[] files = filename.split(";");
			for(String file:files)
			{
			  if(file.indexOf(","+type)>0)
			  {
			    filename = file.substring(0,file.indexOf(","+type));
			    break;
			  }
			  else
			    filename = file;
			}
			log.debug("{}",filename);
			return filename;
		}
        /**
        *   source:btnmod.@0013.script
        */
        public String getSw2File(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=this.getSf2fil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			if(index<0  ||  index>=files.length)
			  index=0;
			return files[index];
		}
        /**
        *   source:btnmod.@0014.script
        */
        public void showSwift(int type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(type<0  ||  type>4)
			  type=0;
			log.info("{}","show sw2 "+type+" file...");
			String filePath=this.getDocpth();
			String fileName=getSw2File(type);
			IDatafield id = MdaDriver.getDatafield(ctx.absGet(Btnmod.class),"sw"+type);
			
			
			IStream stream=(IStream)id.getValue();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			if(MdaUtils.isEmpty(dmap)  ||  dmap.size()==0)
			  return;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,this.getDetfrm(),waterfilePath,true);
		}
        /**
        *   source:btnmod.@0015.script
        */
        public void showXML(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			log.info("{}","show xml "+type+" file ...");
			IDatafield id = MdaDriver.getDatafield(ctx.absGet(Btnmod.class),"notice"+type);
			
			
			IStream is=(IStream)id.getValue();
			String filepath=this.getDocpth();
			String filename=getXmlFile(type);
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
		}
        /**
        *   source:btnmod.@0029.script
        */
        public void initFinancingDocBtn(String trnNam,String flags)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in initFinancingDocBtn ... trncod =" + trnNam +",flags =" + flags  );
			MdaUtils.clear(this.getPdfname());
			
			
			
			
			
			
			

			if(MdaUtils.isEmpty(trnNam))
			  return;

			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/docbtn.properties");
			int cnt = 0;
			String btnnam = "";
			String label = "";
			String pdfName ="";
			cnt = this.getDocCntByFlags(flags);
			Map<String,String> map = new HashMap<String,String>();
			for(int i=0;i<cnt;i++)
			{
			  String key = trnNam+"."+i+".";
			  label = MdaUtils.getPropertyValue(filepath,key+"label");
			  btnnam = MdaUtils.getPropertyValue(filepath,key +"docButton");
			  log.debug("{}","btnnam="+btnnam+" , label="+label );
			  map.put(btnnam,label);
			  IDatafield docField = MdaDriver.getDatafield(this,btnnam);
			  docField.setValue(label);
			  
			  
			  
			}
			this.setPdfname(map);
		}
        /**
        *   source:btnmod.@0030.script
        */
        public String getFinanceTransFlags(String objtyp ,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> flags = new Argument<String>("flags");
			String sql  = " SELECT flags FROM "+objtyp +" WHERE INR = ? ";
			ctx.getDaoSession().dbExecuteSQL(sql,objinr);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(flags);
			}
			ctx.getDaoSession().dbCloseCursor();
			return flags.getValue() ;

		}
        /**
        *   source:btnmod.@0031.script
        */
        public int getDocCntByFlags(String flags)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in getDocCntByFlags ... flags =" + flags );
			int docCnt = 0;
			if("0111".equals(flags))
			{
			  docCnt = 4 ;
			}
			else if("0011".equals(flags))
			{
			  docCnt = 2;
			}
			return docCnt ;

		}
        /**
        *   source:btnmod.@0032.script
        */
        public void callPDFComponentWithData(String appnam,String index, String frmcod,int action,IStream stream)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in callPDFComponentWithData ... appnam"+ appnam + ",index = docbtn" + index +",frmcod="+ frmcod);
			if(MdaUtils.isEmpty(appnam) ||  MdaUtils.isEmpty(index))
			  return;
			String mpath=  MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),appnam.substring(0,4));
			String mfile=appnam+".app";
			log.debug("{}","PDF File SRC = " +  mpath+mfile);
			if(!MdaUtils.fileExists(MdaUtils.catPath(mpath,mfile)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("btnmod","CT000223"),MdaUtils.getI18NString("btnmod","CT000224"));
			  return;
			}
			Map mdata= (Map)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",mpath,mfile);
			Object oprbchcod = mdata.get("OPRBCHCOD");
			String logofile = null;
			String signFile = null;
			if(!MdaUtils.isEmpty(oprbchcod))
			{
			  logofile = ctx.absGet(Sysmod.class).getEtyLgnUrl(oprbchcod.toString());
			  signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(oprbchcod.toString());
			}
			else
			{
			  logofile = ctx.absGet(Sysmod.class).getEtyLgnUrl(null);
			  signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(null);
			}
			mdata.put("signfile",signFile);
			log.debug("{}","logo="+logofile);
			String  pdfFile = this.getDocumentPDFName(index,frmcod,mdata);
			String  pdfTitle = ((Map<String,String>)this.getPdfname()).get("docbtn"+index);
			String tmpfile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfFile+".pdf");
			log.info("{}","pdf 模板文件 = "+tmpfile);
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",tmpfile,mdata,logofile,stream);
			this.getPdfviw().callPDFComponentWithData(stream,pdfTitle,action);
		}
        /**
        *   source:btnmod.@0036.script
        */
        public String getDocumentPDFName(String index,String frmcod,Map data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 根据交易代码|按钮名称|数据
			  */

			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/docbtn.properties");
			String  nameKey = frmcod +"."+index+".PDFName";
			log.debug("{}","in getDocumentPDFName ...  namekey = " + nameKey );
			String fileName = "" ;
			fileName = MdaUtils.getPropertyValue(filepath,nameKey);
			if(!MdaUtils.isEmpty(fileName))
			  return fileName;
			String flg = MdaUtils.getPropertyValue(filepath,nameKey + ".flg");
			log.debug("{}","flg = " + flg +", flgkey =" + nameKey+".flg");
			if(MdaUtils.isEmpty(flg))
			{
			  return frmcod;
			}
			fileName =(String) data.get(flg);
			if(MdaUtils.isEmpty(nameKey))
			{
			  return frmcod;
			}
			fileName = MdaUtils.getPropertyValue(filepath,nameKey+"."+fileName);
			log.debug("{}","pdfName =" + fileName);
			return fileName ;
		}
        /**
        *   source:btnmod.@0037.script
        */
        public void setAppFileAndTrncod(String trninr, String trncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in setAppFileAndTrncod ... trninr="+ trninr +",trncod=" + trncod );
			this.clearAppFileAndTrncod();
			this.setAppfilename(trninr);
			this.setTrncod(trncod);
		}
        /**
        *   source:btnmod.@0038.script
        */
        public void clearAppFileAndTrncod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setAppfilename(NULLSTR);
			this.setTrncod(NULLSTR);
			
			
		}
        /**
        *   source:btnmod.@0040.script
        */
        public void showDocument(String index,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.callPDFComponentWithData( this.getAppfilename(),index,this.getTrncod(),0,this.getPdfviw().getTempstream());
		}
        /**
        *   source:btnmod.@0045.script
        */
        public void initDocumentButton(String ordinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in initDocumentButton ... ordinr =" + ordinr );
			MdaUtils.clear(this.getPdfname());
			
			
			
			
			
			
			
			if(MdaUtils.isEmpty(ordinr))
			{
			  return ;
			}
			ctx.absGet(Trnmod.class).getApldoc().loadApldocByOrdinr(ordinr);
			if("E".equals(ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getSta()))
			{
			  ctx.storeData("btnmod.isApp","3");
			}
			int cnt = ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getDoccnt();
			String btnnam = "";
			String label = "";
			String pdfName ="";
			String file ="";
			String isApp = "1";
			String sign = this.getSign();
			Map<String,String> map = new HashMap<String,String>();
			for(int i=0;i<cnt;i++)
			{
			  btnnam ="docbtn"+i;
			  label = ctx.absGet(Trnmod.class).getApldoc().getLabelByIndex(i);
			  pdfName = ctx.absGet(Trnmod.class).getApldoc().getTempfileByIndex(i);
			  file = ctx.absGet(Trnmod.class).getApldoc().getFileByIndex(i);
			  if(ctx.absGet(Trnmod.class).getApldoc().isApplicationsForm(i))
			    isApp ="2";
			  else
			    isApp ="1";

			  if(!MdaUtils.isEmpty(sign) && ctx.absGet(Trnmod.class).getApldoc().transctionIsFinal())
			  {
			    isApp = sign;
			  }
			  if("1".equals(isApp) && "3".equals(sign) )
			  {
			    isApp = sign;
			  }
			  map.put(btnnam+"-label",label);
			  map.put(btnnam+"-pdfName",pdfName);
			  map.put(btnnam+"-isApplaction",isApp);
			  if(!MdaUtils.isEmpty(file))
			    map.put(btnnam+"-file",file);
			  log.debug("{}","label="+label+",pdfName="+pdfName+",file="+file+",isApp="+isApp);
			  IDatafield btnfld = MdaDriver.getDatafield(this,btnnam);
			  btnfld.setValue(label);
			  
			  
			  
			}
			this.setPdfname(map);
		}
        /**
        *   source:btnmod.@0046.script
        */
        public String getSign()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return (String)ctx.restoreData("btnmod.isApp");
		}
        /**
        *   source:btnmod.@0047.script
        */
        public void showDocument(String btnName,int action ,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 文本展示公共按钮
			  * btnName：文本按钮名称 ，action:是否是查看或添加意见eg, 0-仅查看  1-添加意见
			  * flg：1-不带印章  2-带印章。 默认情况下：申请书带章，合同不带章
			  */
			this.callPDFComponentWithFile(btnName,action,this.getPdfviw().getTempstream(),flg);
		}
        /**
        *   source:btnmod.@0048.script
        */
        public void callPDFComponentWithFile(String btnName,int action,IStream stream ,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * flg - PDF是否代签章  1- 不带章 + 打印日期   2-带签章 + 打印日期
			  */
			log.debug("{}","btnName="+btnName+",flg="+flg);
			if(MdaUtils.isEmpty(btnName))
			{
			  return;
			}
			Map pdfName = this.getPdfname();
			String pdfFile =(String) pdfName.get(btnName+"-pdfName");
			String label =(String) pdfName.get(btnName+"-label");
			String file =(String) pdfName.get(btnName+"-file");
			if(MdaUtils.isEmpty(flg))
			{
			  flg =(String) pdfName.get(btnName + "-isApplication");
			}
			log.debug("{}","pdfFile="+pdfFile +",label="+label+",file="+file);
			if(MdaUtils.isEmpty(file))
			{
			  log.debug("{}","错误：未找到合同文本文件");
			  return;
			}
			else
			{
			  file = file.substring(0,file.indexOf(".pdf"));
			}
			String srcFile = ctx.absGet(Sysmod.class).createFilename(file,"pdf");
			String desPdfPath = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Sysmod.class).getPdfmod().getPDFTempFile(),"attach");
			log.debug("{}","srcFile="+srcFile+",desFile=" + desPdfPath);
			if("1".equals(flg))
			{
			  ctx.absGet(Sysmod.class).getPdfmod().attachPrint(srcFile,desPdfPath);
			}
			else if("2".equals(flg))
			{
			  ctx.absGet(Sysmod.class).getPdfmod().attachPrintWithSign(srcFile,desPdfPath);
			}
			else if("3".equals(flg))
			{
			  ctx.absGet(Sysmod.class).getPdfmod().attachPrintWithLostEffectSign(srcFile,desPdfPath);
			}
			desPdfPath = ctx.absGet(Sysmod.class).getPdfmod().dealPDFPath(desPdfPath);
			log.info("{}","pdf 模板文件="+desPdfPath+",pdf label=" + label);
			this.getPdfviw().showPDF(desPdfPath,label,action);

		}
        /**
        *   source:btnmod.@0049.script
        */
        public void showDocument(String btnName,String flg,String fldPath,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getPdfviw().setPathAndFlgidx(fldPath,index);
			this.callPDFComponentWithFile(btnName,1,this.getPdfviw().getTempstream(),flg);
		}

















































































































































































}