package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Brd;
import com.ceb.gjjs.mda.bo.Bdd;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Busgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Busgrp.class);



	    @BDGetter
		private Lidgrp lidgrp;

	    @BDGetter
		private Rpdgrp rpdgrp;

	    @BDGetter
		private Ersgrp ersgrp;

	    @BDGetter
		private Businf businf;

	    @BDGetter
		private Madgrp madgrp;

	    @BDGetter
		private Ersgrp oldersgrp;

	    @BDGetter
		private Brdgrp brdgrp;

	    @BDGetter
		private Bedgrp bedgrp;

	    @BDGetter
		private Bodgrp bodgrp;

	    @BDGetter
		private Comgrp comgrp;

	    @BDGetter
		private Dedgrp dedgrp;

	    @BDGetter
		private Didgrp didgrp;

	    @BDGetter
		private Bddgrp bddgrp;

	    @BDGetter
		private Bmdgrp bmdgrp;

	    @BDGetter
		private Ledgrp ledgrp;

		@BDGetter
		private ModuleList<Bdd> bddlst;

	    @BDGetter
		private Bpdgrp bpdgrp;

	    @BDGetter
		private Cpdgrp cpdgrp;

	    @BDGetter
		private Sgdgrp sgdgrp;

	    @BDGetter
		private Fsdgrp fsdgrp;

	    @BDGetter
		private Bcdgrp bcdgrp;

	    @BDGetter
		private Gidgrp gidgrp;

		@BDGetter
		private ModuleList<Brd> brdlst;

	    @BDGetter
		private Fcdgrp fcdgrp;

	    @BDGetter
		private Apdgrp apdgrp;

	    @BDGetter
		private Ltdgrp ltdgrp;

	    @BDGetter
		private Jsdgrp jsdgrp;

	    @BDGetter
		private Widgrp widgrp;

	    @BDGetter
		private Notmod notmod;


		public Busgrp()
        {
            super();
            setArgument();
        }

        public Busgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:busgrp.@0000.script
        */
        public String setNotmsgData1(String frm,String objinr,Date date)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//添加待发送消息
			if(MdaUtils.isEmpty(objinr)||MdaUtils.isEmpty(frm))
			{
			  return "";
			}
			MdaUtils.clear(this.getNotmod().getNotmsg());
			this.getNotmod().getNotmsg().setInr(Platform.sdbCounter("notmsg"));
			String notmsginr=this.getNotmod().getNotmsg().getInr();
			if("cptyub".equals(frm))
			{
			  //消息类型（通知）
			  this.getNotmod().getNotmsg().setMsgtype("5");
			  //模板编号
			  this.getNotmod().getNotmsg().setModnum("5390");
			  //币种
			  this.getNotmod().getNotmsg().setDesc1(this.getCpdgrp().getRec().getRemcur());
			  //金额
			  this.getNotmod().getNotmsg().setDesc2(MdaUtils.format(this.getCpdgrp().getRec().getRemamt(),"#0.00"));
			  // 交易时间
			  this.getNotmod().getNotmsg().setDesc3(this.getCpdgrp().getRec().getAdvdat());
			  //付款人
			  this.getNotmod().getNotmsg().setDesc4(this.getCpdgrp().getApl().getPts().getAdrblk());
			}
			else
			{
			  //消息类型（通知）
			  this.getNotmod().getNotmsg().setMsgtype("5");
			  //模板编号
			  this.getNotmod().getNotmsg().setModnum("5394");
			  // 交易时间
			  this.getNotmod().getNotmsg().setDesc3(date);
			  //币种
			  this.getNotmod().getNotmsg().setDesc4(this.getCpdgrp().getRec().getRemcur());
			  //金额
			  this.getNotmod().getNotmsg().setDesc5(MdaUtils.format(this.getCpdgrp().getRec().getRemamt(),"#0.00"));
			  //业务编号
			  this.getNotmod().getNotmsg().setDesc8(this.getCpdgrp().getRec().getOwnref());
			  //收款人名称或付款人名称
			
			  if("cptout".equals(frm))
			  {
			    //交易名称
			    this.getNotmod().getNotmsg().setDesc1("汇出汇款");
			    //业务状态
			    this.getNotmod().getNotmsg().setDesc2("已汇出");
			    //收款人
			    this.getNotmod().getNotmsg().setDesc6("收款人");
			    this.getNotmod().getNotmsg().setDesc7(this.getCpdgrp().getBen().getPts().getAdrblk());

			  }
			  if("cptsub".equals(frm))
			  {
			    //交易名称
			    this.getNotmod().getNotmsg().setDesc1("汇入汇款");
			    //业务状态
			    this.getNotmod().getNotmsg().setDesc2("已入账");
			    //收款人
			    this.getNotmod().getNotmsg().setDesc6("付款人");
			    this.getNotmod().getNotmsg().setDesc7(this.getCpdgrp().getApl().getPts().getAdrblk());
			  }
			}
			//主键
			ctx.getDaoSession().dbInsert(this.getNotmod().getNotmsg());
			log.info("{}","notmsg :"+this.getNotmod().getNotmsg().getInr()+" desc4:"+this.getNotmod().getNotmsg().getDesc4()+" desc7:"+this.getNotmod().getNotmsg().getDesc7());
			return  notmsginr;
		}



























































}