package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Busmdl;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Busmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Busmod.class);

        //保存模板
        private transient IControl savetemplate = new ControlImpl("savetemplate", "保存模板", this);

        //查询模板
        private transient IControl seltemplate = new ControlImpl("seltemplate", "查询模板", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //保存
        private transient IControl save = new ControlImpl("save", "保存", this);

        //确定
        private transient IControl select = new ControlImpl("select", "确定", this);

        //变量
        private IStream temstm = new StreamImpl();

        //历史交易数据
        private transient IControl query = new ControlImpl("query", "历史交易数据", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //按条件查询模板
        private transient IControl search = new ControlImpl("search", "按条件查询模板", this);

        //历史交易参号
        private String hisref;

        //历史查询
        private transient IControl searchhis = new ControlImpl("searchhis", "历史查询", this);

        //模板字段
        private Map data;

        //是否删除
        private String isdel;

        //临时变量
        private String tmpinr;

        //临时文件名
        private String tmpfilnam;

        //临时是否信用证
        private String tmplr;


        @JsonIgnore
        @BDGetter
        private transient IPanel tplpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel selpanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel module;

        @JsonIgnore
        @BDGetter
        private transient IPanel oldlist;


		@BDGetter
		private ModuleList<Busmdl> mdllst;

	    @BDGetter
		private Busmdl wrkmdl;

		@BDGetter
		private ModuleList<Trn> modlst;


		public Busmod()
        {
            super();
            setArgument();
        }

        public Busmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:busmod.@0000.script
        */
        @Rule(target="seltemplate",order=100)
        public boolean ruleSeltemplateN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getWrkmdl().setMdldcb(NULLSTR);
			
			
			updateList("");

			return true;
        }

        /**
        *   source:busmod.@0001.script
        */
        @Rule(target="savetemplate",order=100)
        public boolean ruleSavetemplateN100(){
            IContext ctx = MdaEnv.getContext();
            
			


			return true;
        }

        /**
        *   source:busmod.@0002.script
        */
        @Rule(target="save",order=100)
        public boolean ruleSaveN100(){
            IContext ctx = MdaEnv.getContext();
            
			String str=this.getWrkmdl().getMdldcb();
			String nam=this.getWrkmdl().getBusdcb();
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			String cidinr= ctx.absGet(Sysmod.class).getPty().getCid();
			String trnname=ctx.getTransName();
			String islr="";
			if("fftapn".equals(trnname))
			{
			  islr=this.getTmplr();
			  log.info("{}","islr=================="+islr);
			}
			if(MdaUtils.isEmpty(nam))
			{
			  ctx.setMessage(MdaUtils.getI18NString("busmod","CT000011"),MdaUtils.getI18NString("busmod","CT000012"));
			  return false;
			}
			if(MdaUtils.isEmpty(str))
			{
			  ctx.setMessage(MdaUtils.getI18NString("busmod","CT000013"),MdaUtils.getI18NString("busmod","CT000014"));
			  return false;
			}
			if(nam.length()>200)
			{
			  ctx.setMessage(MdaUtils.getI18NString("busmod","CT000015"),MdaUtils.getI18NString("busmod","CT000016"));
			  return false;
			}
			if(str.length()>200)
			{
			  ctx.setMessage(MdaUtils.getI18NString("busmod","CT000017"),MdaUtils.getI18NString("busmod","CT000044"));
			  return false;
			}
			//Platform.dbRead($wrkmdl,new Argument<String>("mdldcb",nam),new Argument<String>("ptyinr",ptyinr));
			Argument<String> tinr=new Argument<String>("inr");
			// Platform.dbExecuteSQL("SELECT inr FROM busmdl WHERE busdcb='"+nam+"' AND ptyinr='"+ptyinr+"' AND modtyp='"+trnname.toLowerCase()+"'");
			// 修复模板查询时，应该以模板名称来查询
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM busmdl WHERE mdldcb='"+nam+"' AND ptyinr='"+ptyinr+"' AND modtyp='"+trnname.toLowerCase()+"'");
			ctx.getDaoSession().dbFetchFields(tinr);
			int e=ctx.getErrorCode();
			// 修复模板保存时,如果出现重复模板导致游标未关闭的问题    20170531
			ctx.getDaoSession().dbCloseCursor();
			if(e!=NO_MORE_ROW)
			{

			  ctx.setMessage(MdaUtils.getI18NString("busmod","CT000045"),MdaUtils.getI18NString("busmod","CT000050"));
			  return false;
			}
			ctx.getDaoSession().dbBegin();
			this.getWrkmdl().setPtyinr(ptyinr);
			this.getWrkmdl().setModtyp(trnname.toLowerCase());
			this.getWrkmdl().setMdldcb(nam);
			this.getWrkmdl().setCredattim(new Date());
			this.getWrkmdl().setBusdcb(str);
			String inr=Platform.sdbCounter("busmdl");
			this.getWrkmdl().setInr(inr);
			this.getWrkmdl().setCidinr(cidinr);
			this.getWrkmdl().setIssend("N");
			this.getWrkmdl().setIslr(islr);
			log.info("{}",this.getWrkmdl().getInr());
			ctx.getDaoSession().dbInsert(this.getWrkmdl());
			ctx.getDaoSession().dbCommit();
			String path=ctx.getEnvConfig().getRootPath();
			path=MdaUtils.catPath(MdaUtils.catPath(path,"data"),"busmdl");
			String filename=this.getWrkmdl().getInr()+".mdl";
			filename=MdaUtils.catPath(path,filename);
			log.info("{}",filename);
			//clearDatafield(trnname);
			String modpath=null;
			modpath=MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec())+"grp";
			log.info("{}","modpath="+modpath);
			IModule mod=MdaDriver.getModule(this,ctx.getRoot(),modpath);
			IStream os=this.getTemstm();
			//modpath=Platform.getTransName();
			//modpath=modpath.substring(0,2).toLowerCase();
			//IModule mod=Platform.getModule($\\,modpath+"dgrp");
			MdaUtils.saveData(mod,os);
			//如果需要保存多个grp
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/grpcfg.properties");
			String grp2=MdaUtils.getPropertyValue(name,ctx.getTransName()+".A");
			if(!MdaUtils.isEmpty(grp2))
			{
			  log.info("{}","saveData---grp2="+grp2);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp2),os);
			}
			String grp3=MdaUtils.getPropertyValue(name,ctx.getTransName()+".B");
			if(!MdaUtils.isEmpty(grp3))
			{
			  log.info("{}","saveData---grp3="+grp3);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp3),os);
			}

			MdaUtils.streamSave(os,filename);
			MdaUtils.clear(this.getWrkmdl());
			
			ctx.setMessage("",MdaUtils.getI18NString("busmod","CT000051"));
			//  Platform.dbCloseCursor();
			
			return true;
        }

        /**
        *   source:busmod.@0003.script
        */
        @Rule(target="select",order=100)
        public boolean ruleSelectN100(){
            IContext ctx = MdaEnv.getContext();
            
			//int index=$mdllst.getSelectedRowIndex();
			int index=-1;

			index=0;
			log.info("{}","index="+index);
			if(index!=-1)
			{
			  String tmp ="";
			  if("Y".equals(this.getMdllst().getElement(index).getIssend()))
			  {
			    tmp="bummdl";
			  }
			  else if("N".equals(this.getMdllst().getElement(index).getIssend()))
			  {
			    tmp="busmdl";

			  }

			  log.info("{}","SELECT module...");
			  String trnname=ctx.getTransName();
			  String modpath=null;
			  //$wrkmdl.copyValue($mdllst.get(index));
			  String filename=this.getMdllst().getElement(index).getInr()+".mdl";
			  String path=ctx.getEnvConfig().getRootPath();
			  path=MdaUtils.catPath(MdaUtils.catPath(path,"data"),"busmdl");
			  filename=MdaUtils.catPath(path,filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("busmod","CT000018"));
			    return true;
			  }
			  //modpath=Platform.getTransName();
			  //modpath=modpath.substring(0,2).toLowerCase();
			  //modpath=Platform.getModule($\\,Platform.getModuleType($\\mtabut\\rec)+"grp");
			  //IModule mod=Platform.getModule($\\,modpath+"dgrp");
			  // 初始化原始的模块数据
			  getIgnoreDatafield(trnname,tmp);
			  modpath=MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec())+"grp";
			  log.info("{}","modpath="+modpath);
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),modpath);
			  IStream is=this.getTemstm();
			  log.info("{}",filename);
			  MdaUtils.streamLoad(is,filename);
			  MdaUtils.loadData(mod,is);
			  //如果有多个grp
			  String grpcfg=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/grpcfg.properties");
			  log.debug("{}","grpcfg="+grpcfg);
			  String grp1=MdaUtils.getPropertyValue(grpcfg,ctx.getTransName()+".A");
			  log.debug("{}","grp1="+grp1);
			  if(!MdaUtils.isEmpty(grp1))
			  {
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp1),is);
			  }
			  String grp2=MdaUtils.getPropertyValue(grpcfg,ctx.getTransName()+".B");
			  log.debug("{}","grp2="+grp2);
			  if(!MdaUtils.isEmpty(grp2))
			  {
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp2),is);
			  }
			  clearDatafield(trnname,tmp);
			  //请开发人员严格规范，创建模块操作，避免后续处理为某个交易进行单独处理
			  IDatafield credat=null;
			  if("margrp".equals(modpath))
			  {
			    credat=MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\mar\\credat");
			  }
			  else
			  {
			    credat=MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\rec\\credat");
			  }
			  //credat.setValue(Platform.today());
			  String time =MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  credat.setValue(MdaUtils.parseDate(time,"yyyyMMdd"));
			  // 原始模块中的数据赋值
			  setIgnoreDatafield();
			  
			  //Platform.clear($wrkmdl);
			  if("Y".equals(this.getMdllst().getElement(index).getIssend()))
			  {
			    this.setIsdel("0000");
			    this.setTmpinr(this.getMdllst().getElement(index).getInr());
			    this.setTmpfilnam(filename);
			  }
			  
			  
			  Modules.postDefaultRule(mod);
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("busmod","CT000030"));
			}

			return true;
        }

        /**
        *   source:busmod.@0004.script
        */
        @Rule(target="delete",order=100)
        public boolean ruleDeleteN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=-1;
			index=0;
			log.info("{}","index="+index);
			if(index!=-1)
			{
			  if(MdaUtils.prompt("提示",MdaUtils.getI18NString("busmod","CT000019")))
			  {
			    return true;
			  }
			  else
			  {
			    //Platform.copyFromList($mdllst,$wrkmdl,index);
			    //$wrkmdl.copyValue($mdllst.get(index));
			    //String filename=$mdllst[index]\\inr.getValue()+".mdl";
			    String filename=this.getMdllst().getElement(index).getInr()+".mdl";
			    ctx.getDaoSession().dbBegin();
			    //String mdlinr=$wrkmdl\\inr.getValue();
			    log.info("{}","to delete module ,inr="+this.getMdllst().getElement(index).getInr());
			    ctx.getDaoSession().dbRead(this.getWrkmdl(),new Argument("inr",this.getMdllst().getElement(index).getInr()));
			    ctx.getDaoSession().dbDelete(this.getWrkmdl());
			    ctx.getDaoSession().dbCommit();
			    log.info("{}","delete commit OK!");
			    //String path=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"busmdl");
			    //filename=Platform.catPath(path,filename);
			    /*
			      if(!Platform.fileExists(filename))
			      {
			      Platform.message("",#CT000020);
			      return;
			      }
			      Platform.fileDelete(filename);
			      */
			    //Platform.clear($wrkmdl);
			    updateList("");
			    ctx.setMessage("",MdaUtils.getI18NString("busmod","CT000031"));
			  }
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("busmod","CT000068"));
			}

			return true;
        }

        /**
        *   source:busmod.@0008.script
        */
        @Rule(target="query",order=100)
        public boolean ruleQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			this.setHisref(NULLSTR);
			
			//String optptyinr =$\\sysmod\\pty\\inr.getValue();
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			log.debug("{}","ptyinr=" + ptyinr);
			log.debug("{}","inifrm = " + ctx.getTransName());
			//改为用交易代码和经办机构查询历史数据   --2019.1.8
			//Platform.dbReadset($modlst,new Argument<String>("optptyinr",optptyinr),new Argument<String>("inifrm",Platform.getTransName()),new Argument<Object>("inidattim",DESC));
			ctx.getDaoSession().dbReadset(this.getModlst(),new Argument<String>("ptyinr",ptyinr),new Argument<String>("inifrm",ctx.getTransName()),new Argument<Object>("inidattim",DESC));
			
			

			return true;
        }

        /**
        *   source:busmod.@0009.script
        */
        @Rule(target="sure",order=100)
        public boolean ruleSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index=-1;
			index=0;
			log.info("{}","index="+index);
			if(index!=-1)
			{
			  log.info("{}","SELECT module...");
			  String trnname=ctx.getTransName();
			  String modpath=null;
			  //$wrkmdl.copyValue($mdllst.get(index));
			  //20150311 MOD BY DG
			  //String filename=$modlst[index]\\inr.getValue()+".dat";
			  //String path=Platform.getRootPath();
			  //path=Platform.catPath(Platform.catPath(path,"data"),"trndata");
			  //filename=Platform.catPath(path,filename);
			  String filename = ctx.absGet(Sysmod.class).createFilename(this.getModlst().getElement(index).getInr(),"dat");
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("busmod","CT000065"));
			    return true;
			  }
			  //modpath=Platform.getTransName();
			  //modpath=modpath.substring(0,2).toLowerCase();
			  //modpath=Platform.getModule($\\,Platform.getModuleType($\\mtabut\\rec)+"grp");
			  //IModule mod=Platform.getModule($\\,modpath+"dgrp");
			  // 初始化原始的模块数据
			  getIgnoreDatafield(trnname);
			  modpath=MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec())+"grp";
			  log.info("{}","modpath="+modpath);
			  IModule mod=MdaDriver.getModule(this,ctx.getRoot(),modpath);
			  IStream is=this.getTemstm();
			  log.info("{}",filename);
			  MdaUtils.streamClear(is);
			  MdaUtils.streamLoad(is,filename);
			  MdaUtils.loadData(mod,is);
			  clearDatafield(trnname);
			  IDatafield credat=MdaDriver.getDatafield(ctx.getRoot(),modpath+"\\rec\\credat");
			  credat.setValue(MdaUtils.today());
			  // 原始模块中的数据赋值
			  setIgnoreDatafield();

			  
			  //Platform.clear($wrkmdl);
			  
			  
			  Modules.postDefaultRule(mod);
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("busmod","CT000066"));
			}

			return true;
        }

        /**
        *   source:busmod.@0010.script
        */
        @Rule(target="search",order=100)
        public boolean ruleSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			String queryClause = null;
			if(!MdaUtils.isEmpty(this.getWrkmdl().getMdldcb()))
			  queryClause = " AND mdldcb LIKE '%"+this.getWrkmdl().getMdldcb()+"%'";
			updateList(queryClause);

			return true;
        }

        /**
        *   source:busmod.@0011.script
        */
        @Rule(target="searchhis",order=100)
        public boolean ruleSearchhisN100(){
            IContext ctx = MdaEnv.getContext();
            
			String optptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			MdaUtils.clear(this.getModlst());
			Argument<String> inr=new Argument<String>("inr");
			Argument<Object> inidattim=new Argument<Object>("inidattim");
			Argument<String> ownref=new Argument<String>("ownref");
			Argument<String> objnam=new Argument<String>("objnam");
			String sql="SELECT inr,inidattim,ownref,objnam FROM trn WHERE ";
			sql = sql+"optptyinr='"+optptyinr+"' AND inifrm='"
			  +ctx.getTransName()+"'";
			if(!MdaUtils.isEmpty(this.getHisref()))
			{
			  sql = sql+" AND ownref like '%"+this.getHisref()+"%'";
			}
			sql = sql+" ORDER BY inidattim";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,inidattim,ownref,objnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			    this.getModlst().add(inr,inidattim,ownref,objnam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:busmod.@0012.script
        */
        @Rule(target="seltemplate",order=50)
        public boolean ruleSeltemplateN50(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  应业务人员要求暂时屏蔽掉这段代码，若后续遇见问题则恢复
			  IDatafield<String> ownrefField = Platform.getDatafield($\\mtabut\\rec,"ownref");
			  String ownref = ownrefField.getValue();
			  if(!Platform.isEmpty(ownref))
			  {
			  Platform.message(#CT000072,#CT000073);
			  Platform.exitEvent();
			  }
			  */

			return true;
        }




        /**
        *   source:busmod.@0005.script
        */
        public void updateList(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			MdaUtils.clear(this.getMdllst());
			String trnname=ctx.getTransName();
			String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			String cidinr=ctx.absGet(Sysmod.class).getPty().getCid();
			//Platform.dbReadset($mdllst,new Argument("modtyp",trnname),new Argument("ptyinr",ptyinr));
			//Platform.dbReadset($mdllst,new Argument<String>("modtyp",trnname),new Argument<String>("ptyinr",ptyinr));
			String sql = "SELECT inr,mdldcb,busdcb,islr,issend FROM busmdl WHERE modtyp = '"+trnname+"' AND  cidinr='"+cidinr+"'";
			if(!MdaUtils.isEmpty(queryClause))
			  sql = sql+queryClause;
			sql = sql+" ORDER BY mdldcb";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> mdldcb = new Argument<String>("mdldcb");
			Argument<String> busdcb = new Argument<String>("busdcb");
			Argument<String> islr = new Argument<String>("islr");
			Argument<String> issend = new Argument<String>("issend");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,mdldcb,busdcb,islr,issend);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getMdllst().add(inr,mdldcb,busdcb,islr,issend);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:busmod.@0006.script
        */
        public void clearDatafield(String trsnam,String tmp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trsnam))
			  return;
			//String filename=Platform.catPath(Platform.getRootPath(),"/cfg/busmdl.properties");
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/"+tmp+".properties");
			String keys=MdaUtils.getPropertyValue(filename,trsnam.toUpperCase());
			//Map<String,Object> values=new HashMap<String,Object>();
			if(MdaUtils.isEmpty(keys))
			  return ;
			for(String key:keys.split(","))
			{
			  String path=MdaUtils.getPropertyValue(filename,key);
			  log.info("{}","path="+path);
			  if(!MdaUtils.isEmpty(path))
			  {
			    if(path.endsWith(",l"))
			    {
			      String modlstpath=path.substring(0,path.indexOf(","));
			      log.info("{}","modlstpath="+modlstpath);
			      IModuleList modlst=(IModuleList)MdaDriver.getBaseObject(ctx.getRoot(),modlstpath);
			      MdaUtils.clear(modlst);
			    }
			    else
			    {
			      log.info("{}",Platform.getDatafieldValue(ctx.getRoot(),path));
			      MdaUtils.clear(MdaDriver.getDatafield(ctx.getRoot(),path));
			      
			    }
			  }
			}
		}
        /**
        *   source:busmod.@0013.script
        */
        public void getIgnoreDatafield(String trsnam,String tmp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," trnnam =" + trsnam );
			MdaUtils.clear(this.getData());
			if(MdaUtils.isEmpty(trsnam))
			  return;
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/"+tmp+".properties");
			String keys=MdaUtils.getPropertyValue(filename,trsnam.toUpperCase());
			Map<String,Object> m = new HashMap<String,Object>();
			if(MdaUtils.isEmpty(keys))
			  return ;
			for(String key:keys.split(","))
			{
			  String path=MdaUtils.getPropertyValue(filename,key);
			  log.info("{}","path="+path);
			  if(!MdaUtils.isEmpty(path) && !path.endsWith(",l") )
			  {
			    log.debug("{}","字段路径"+path+"="+Platform.getDatafieldValue(ctx.getRoot(),path));
			    m.put(path, Platform.getDatafieldValue(ctx.getRoot(),path));
			  }
			}
			this.setData(m);
		}
        /**
        *   source:busmod.@0014.script
        */
        public void setIgnoreDatafield()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> map =(Map<String,Object>) this.getData();
			for(String key : map.keySet())
			{
			  IDatafield fld =MdaDriver.getDatafield(ctx.getRoot(),key);
			  fld.setValue( map.get(key));
			  log.debug("{}","key =" + key +", value =" + map.get(key));
			}
			MdaUtils.clear(this.getData());
		}
        /**
        *   source:busmod.@0015.script
        */
        public void getIgnoreDatafield(String trsnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," trnnam =" + trsnam );
			MdaUtils.clear(this.getData());
			if(MdaUtils.isEmpty(trsnam))
			  return;
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/busmdl.properties");
			String keys=MdaUtils.getPropertyValue(filename,trsnam.toUpperCase());
			Map<String,Object> m = new HashMap<String,Object>();
			if(MdaUtils.isEmpty(keys))
			  return ;
			for(String key:keys.split(","))
			{
			  String path=MdaUtils.getPropertyValue(filename,key);
			  log.info("{}","path="+path);
			  if(!MdaUtils.isEmpty(path) && !path.endsWith(",l") )
			  {
			    m.put(path, Platform.getDatafieldValue(ctx.getRoot(),path));
			  }
			}
			this.setData(m);
		}
        /**
        *   source:busmod.@0016.script
        */
        public void clearDatafield(String trsnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(trsnam))
			  return;
			//String filename=Platform.catPath(Platform.getRootPath(),"/cfg/busmdl.properties");
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/busmdl.properties");
			String keys=MdaUtils.getPropertyValue(filename,trsnam.toUpperCase());
			//Map<String,Object> values=new HashMap<String,Object>();
			if(MdaUtils.isEmpty(keys))
			  return ;
			for(String key:keys.split(","))
			{
			  String path=MdaUtils.getPropertyValue(filename,key);
			  log.info("{}","path="+path);
			  if(!MdaUtils.isEmpty(path))
			  {
			    if(path.endsWith(",l"))
			    {
			      String modlstpath=path.substring(0,path.indexOf(","));
			      log.info("{}","modlstpath="+modlstpath);
			      IModuleList modlst=(IModuleList)MdaDriver.getBaseObject(ctx.getRoot(),modlstpath);
			      MdaUtils.clear(modlst);
			    }
			    else
			    {
			      log.info("{}","这里是空的吗：" + Platform.getDatafieldValue(ctx.getRoot(),path));
			      MdaUtils.clear(MdaDriver.getDatafield(ctx.getRoot(),path));
			      
			    }
			  }
			}
		}
        /**
        *   source:busmod.@0017.script
        */
        public void dealFile()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(this.getIsdel()))
			{
			  ctx.getDaoSession().dbDelete(this.getWrkmdl(),new Argument<String>("inr",this.getTmpinr()));
			  /* 根据项目经理意见不在代码中删除文件，在服务器上定期清理
			    if(Platform.fileExists($tmpfilnam.getValue()))
			    {
			    Platform.fileDelete($tmpfilnam.getValue());
			    }
			    */
			}
		}







































}