package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Bxd;
import com.ceb.gjjs.mda.bo.Mar;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Mxd;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Bxdmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Bxdmod.class);

        //获取保证金协议参号
        private transient IControl getbxdref = new ControlImpl("getbxdref", "获取保证金协议参号", this);

        //业务表名
        @Module(getter = false, setter = false)
		private FieldHolder<String> objtyp = new FieldConstantHolder<>("");


        //业务表主键
        @Module(getter = false, setter = false)
		private FieldHolder<String> objinr = new FieldConstantHolder<>("");


        //申请业务编号
        @Module(getter = false, setter = false)
		private FieldHolder<String> ref = new FieldConstantHolder<>("");


        //客户主键
        @Module(getter = false, setter = false)
		private FieldHolder<String> ptyinr = new FieldConstantHolder<>("");


        //业务归属机构
        @Module(getter = false, setter = false)
		private FieldHolder<String> bchcod = new FieldConstantHolder<>("");


        //保证金参号
        private transient IControl getmarref = new ControlImpl("getmarref", "保证金参号", this);

        //保证金协议参号前缀
        @Module(getter = false, setter = false)
		private FieldHolder<String> bxdprefix = new FieldConstantHolder<>("");


        //保证金申请参号前缀
        @Module(getter = false, setter = false)
		private FieldHolder<String> marprefix = new FieldConstantHolder<>("");


        //账号
        private String acc;

        //户名
        private String accnam;

        //开户行
        private String opnd;

        //保证金币种
        private String bzjbz;

        //保证金金额
        private String bzjje;

        //保证金大写金额
        private String dxje;


        @JsonIgnore
        @BDGetter
        private transient IPanel bxdp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel marp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel mxd01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bxdp02;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bxd> bxd;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Mar> mar;

	    @BDGetter
		private Mxd mxd;

		@Module(getter = false, setter = false)
		private transient ModuleListHolder<Mxd> mxdlst;

		@BDGetter
		private ModuleList<Mxd> mxdbak;


		public Bxdmod()
        {
            super();
            setArgument();
        }

        public Bxdmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:bxdmod.@0002.script
        */
        @Rule(target="getbxdref",order=100)
        public boolean ruleGetbxdrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 获取保证金协议参号
			  */

			ctx.absGet(Mtabut.class).getRefrence(MdaDriver.getDatafield( this.getBxd(),"ownref"),  this.getBxdprefix());

			return true;
        }

        /**
        *   source:bxdmod.@0003.script
        */
        @Rule(target="getmarref",order=100)
        public boolean ruleGetmarrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 获取保证金委托开会及扣划参号
			  */

			ctx.absGet(Mtabut.class).getRefrence(MdaDriver.getDatafield( this.getMar(),"ownref"),  this.getMarprefix());

			return true;
        }

        /**
        *   source:bxdmod.@0009.script
        */
        @Rule(target="mar.wtkhbzj",order=100)
        public boolean ruleMarWtkhbzjN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			log.info("{}","execute 委托扣划保证金账户信息表 event  checkes  .......");
			//委托扣划保证金账户信息表
			if(!MdaUtils.isEmpty(this.getMar().getWtkhbzj()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getMar().setCur(NULLSTR);
			  this.getMar().setAmt(new BigDecimal(0));
			  this.getMar().setNote(NULLSTR);
			  
			  
			  
			  
			  
			  

			  int size=this.getMxdlst().fullSize();
			  if(size>0)
			  {
			    log.info("{}","!!!!size = " + size);
			    for(int i=0;i<size;i++ )
			    {
			      this.getMxdlst().remove(i);
			      size=this.getMxdlst().fullSize();
			      i--;
			    }
			  }
			  
			}

			
			
			

			return true;
        }

        /**
        *   source:bxdmod.@0010.script
        */
        @Rule(target="mar.wtklbzjzh",order=100)
        public boolean ruleMarWtklbzjzhN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			log.info("{}","execute委托开立保证金账户信息表 event  checkes  .......");
			if(!MdaUtils.isEmpty(this.getMar().getWtklbzjzh()))
			{
			  //委托开立保证金账户信息表
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  //Platform.setRequired($margrp\\mar\\ckrlb);
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getMar().setAplnam(NULLSTR);
			  this.getMar().setDh(NULLSTR);
			  this.getMar().setDz(NULLSTR);
			  this.getMar().setCwlxr(NULLSTR);
			  this.getMar().setCzhm(NULLSTR);
			  this.getMar().setYb(NULLSTR);
			  this.getMar().setCkrlb(NULLSTR);
			  this.getMar().setZzjgdm(NULLSTR);
			  this.getMar().setFddbr(NULLSTR);
			  this.getMar().setNam(NULLSTR);
			  this.getMar().setZjzl(NULLSTR);
			  this.getMar().setZjhm(NULLSTR);
			  this.getMar().setKlzhbb(NULLSTR);

			  
			  
			  
			  
			  
			  
			  //Platform.setNotRequired($mar\\ckrlb);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			
			
			
			
			
			
			
			
			
			
			
			
			


			return true;
        }

        /**
        *   source:bxdmod.@0022.script
        */
        @Rule(target="bxd.cgyd",order=100)
        public boolean ruleBxdCgydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getBxd().getCgyd())||"贰".equals(this.getBxd().getCgyd()))
			{
			  
			  
			  
			}
			else
			{
			  
			  
			  
			}
			
			
			

			return true;
        }

        /**
        *   source:bxdmod.@0023.script
        */
        @Rule(target="bxd.jsyd",order=100)
        public boolean ruleBxdJsydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("5".equals(this.getBxd().getJsyd())||"伍".equals(this.getBxd().getJsyd()))
			{
			  
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:bxdmod.@0024.script
        */
        @Rule(target="bxd.jxyd",order=100)
        public boolean ruleBxdJxydN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getBxd().getJxyd())||"壹".equals(this.getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getBxd().getJxyd())||"贰".equals(this.getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getBxd().getJxyd())||"叁".equals(this.getBxd().getJxyd()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:bxdmod.@0025.script
        */
        @Rule(target="bxd.zyjjfs",order=100)
        public boolean ruleBxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getBxd().getZyjjfs())||"贰".equals(this.getBxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getBxd().getZyjjfs())||"叁".equals(this.getBxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }



        /**
        *   source:bxdmod.@0020.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.marDescription();
			this.bxdDescription();

			return true;
        }


        /**
        *   source:bxdmod.@0001.script
        */
        public void saveBxdAndMar()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 保存保证金协议及保证金委托开户及扣划交易
			  */
			this.getBxd().setRef( this.getRef());
			this.getBxd().setPtyinr( this.getPtyinr());
			this.getBxd().setObjtyp( this.getObjtyp());
			this.getBxd().setObjinr( this.getObjinr());
			this.getBxd().setBchcod( this.getBchcod());
			this.getBxd().setInr(Platform.sdbCounter("bxd"));
			ctx.getDaoSession().dbInsert(this.getBxd());

			this.getMar().setRef( this.getRef());
			this.getMar().setPtyinr( this.getPtyinr());
			this.getMar().setObjtyp( this.getObjtyp());
			this.getMar().setObjinr( this.getObjinr());
			this.getMar().setBchcod( this.getBchcod());
			this.getMar().setInr(Platform.sdbCounter("mar"));
			ctx.getDaoSession().dbInsert(this.getMar());
			String marinr = this.getMar().getInr();
			String acc = "";
			String bz = "";
			// 保存保证金关联账号信息
			for(int i=0 ;i<this.getMxdlst().fullSize();i++)
			{
			  acc = this.getMxdlst().getElement(i).getAcc();
			  bz = this.getMxdlst().getElement(i).getBzjbz();
			  if(!MdaUtils.isEmpty(acc + bz))
			  {
			    MdaUtils.clear(this.getMxd());
			    this.getMxd().copyValue(this.getMxdlst().getElement(i));
			    this.getMxd().setObjtyp( "mar");
			    this.getMxd().setObjinr( marinr);
			    this.getMxd().setInr(Platform.sdbCounter("mxd"));
			    ctx.getDaoSession().dbInsert(this.getMxd());
			  }
			}
		}
        /**
        *   source:bxdmod.@0005.script
        */
        public void updBxdAndMar()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 更新保证金协议及保证金委托开户及扣划交易
			  */

			ctx.getDaoSession().dbUpdate(this.getBxd());
			ctx.getDaoSession().dbUpdate(this.getMar());
			String marinr = this.getMar().getInr();
			String acc=null;
			String bz=null;
			for(int i=0;i<this.getMxdlst().fullSize();i++)
			{
			  acc = this.getMxdlst().getElement(i).getAcc();
			  bz = this.getMxdlst().getElement(i).getBzjbz();
			  if(MdaUtils.isEmpty(this.getMxdlst().getElement(i).getInr())&&!MdaUtils.isEmpty(acc + bz))
			  {
			    log.info("{}","new mxd");
			    String inr = Platform.sdbCounter("mxd");
			    this.getMxdlst().getElement(i).setInr(inr );
			    this.getMxdlst().getElement(i).setObjinr(marinr);
			    this.getMxdlst().getElement(i).setObjtyp("mar");
			    ctx.getDaoSession().dbInsert(this.getMxdlst().getElement(i));
			  }
			  else
			  {
			    log.info("{}","update mxd");
			    ctx.getDaoSession().dbUpdate(this.getMxdlst().getElement(i));
			  }
			}
			//删除移除的合同条款
			for(int i = 0;i<this.getMxdbak().size();i++)
			{
			  ctx.getDaoSession().dbDelete(this.getMxdbak().getElement(i));
			}
		}
        /**
        *   source:bxdmod.@0006.script
        */
        public void dealMxdlst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setAcc(NULLSTR);
			this.setAccnam(NULLSTR);
			this.setOpnd(NULLSTR);
			this.setBzjbz(NULLSTR);
			this.setBzjje(NULLSTR);

			int len = this.getMxdlst().fullSize();
			StringBuffer acc=new StringBuffer();
			StringBuffer accnam=new StringBuffer();
			StringBuffer opnd=new StringBuffer();
			StringBuffer bzjbz=new StringBuffer();
			StringBuffer bzjje=new StringBuffer();

			String conn="";
			String cc = null;
			BigDecimal bd = null;
			for(int i=0;i<len;i++)
			{
			  cc = this.getMxdlst().getElement(i).getAcc();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  acc.append(conn).append(cc);
			  cc = this.getMxdlst().getElement(i).getAccnam();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  accnam.append(conn).append(cc);
			  cc = this.getMxdlst().getElement(i).getOpnd();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  opnd.append(conn).append(cc);
			  cc = this.getMxdlst().getElement(i).getBzjbz();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bzjbz.append(conn).append(cc);
			  //金额是Bigdecimal类型
			  bd = this.getMxdlst().getElement(i).getBzjje();
			  if(MdaUtils.isEmpty(bd))
			    cc="";
			  bzjje.append(conn).append(bd.toString());
			  conn = ",";
			}
			log.debug("{}","acc:"+acc);
			log.debug("{}","accnam:"+accnam);
			log.debug("{}","opnd:"+opnd);
			log.debug("{}","bzjbz:"+bzjbz);
			log.debug("{}","bzjje:"+bzjje);
			this.setAcc(acc.toString());
			this.setAccnam(accnam.toString());
			this.setOpnd(opnd.toString());
			this.setBzjbz(bzjbz.toString());
			this.setBzjje(bzjje.toString());
		}
        /**
        *   source:bxdmod.@0007.script
        */
        public boolean checkMxdlst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(this.getMxdlst().fullSize() > 5)
			{
			  ctx.setMessage(MdaUtils.getI18NString("bxdmod","CT000146"),MdaUtils.getI18NString("bxdmod","CT000147"));
			  return false;
			}
			String acc=null;
			String bz=null;
			for(int i=0;i<this.getMxdlst().size();i++)
			{
			  acc= this.getMxdlst().getElement(i).getAcc();
			  bz= this.getMxdlst().getElement(i).getBzjbz();
			  if(MdaUtils.isEmpty(acc+bz))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("bxdmod","CT000148"),MdaUtils.getI18NString("bxdmod","CT000149"));
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:bxdmod.@0017.script
        */
        public void bzjDisable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getMar().getWtkhbzj()))
			{
			  //委托开立保证金账户信息表(灰显)
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if(MdaUtils.isEmpty(this.getMar().getWtklbzjzh()))
			{
			  //委托扣划保证金账户信息表(灰显)
			  
			  
			  
			}
			else
			{
			  
			  
			  
			}
		}
        /**
        *   source:bxdmod.@0018.script
        */
        public void bxdDescription()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			//甲方
			
			
			//乙方（单位）
			
			
			//乙方（单位）收件信息
			
			
			
			
			
			//乙方（单位）代收人信息可输
			
			
			
			
			//乙方(自然人)信息不可输
			
			
			
			//乙方(自然人)收件信息不可输
			
			
			
			
			//乙方(自然人)代收人信息
			
			
			
			

			
			
			

			
			
			
			
			
			
			
		}
        /**
        *   source:bxdmod.@0019.script
        */
        public void marDescription()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			

			
			
			
			
			
			
			
			
			
			
			
			
			

			
			
			
		}

        public void setBxdHolder(ModuleHolder<Bxd> bxd)
        {
           this.bxd = bxd;
        }

        public Bxd getBxd()
        {
           return this.bxd.get();
        }

        public void setMarHolder(ModuleHolder<Mar> mar)
        {
           this.mar = mar;
        }

        public Mar getMar()
        {
           return this.mar.get();
        }



        public void setMxdlstHolder(ModuleListHolder<Mxd> mxdlst)
        {
            this.mxdlst = mxdlst;
        }

        public ModuleList<Mxd> getMxdlst()
        {
           return this.mxdlst.get();
        }







        public void setObjtypHolder(FieldHolder<String> objtyp)
        {
           this.objtyp = (objtyp);
        }

        public void setObjtyp(String objtyp)
        {
            this.objtyp.setValue(objtyp);
        }

        public String getObjtyp()
        {
            return this.objtyp.getValue();
        }



        public void setObjinrHolder(FieldHolder<String> objinr)
        {
           this.objinr = (objinr);
        }

        public void setObjinr(String objinr)
        {
            this.objinr.setValue(objinr);
        }

        public String getObjinr()
        {
            return this.objinr.getValue();
        }



        public void setRefHolder(FieldHolder<String> ref)
        {
           this.ref = (ref);
        }

        public void setRef(String ref)
        {
            this.ref.setValue(ref);
        }

        public String getRef()
        {
            return this.ref.getValue();
        }



        public void setPtyinrHolder(FieldHolder<String> ptyinr)
        {
           this.ptyinr = (ptyinr);
        }

        public void setPtyinr(String ptyinr)
        {
            this.ptyinr.setValue(ptyinr);
        }

        public String getPtyinr()
        {
            return this.ptyinr.getValue();
        }



        public void setBchcodHolder(FieldHolder<String> bchcod)
        {
           this.bchcod = (bchcod);
        }

        public void setBchcod(String bchcod)
        {
            this.bchcod.setValue(bchcod);
        }

        public String getBchcod()
        {
            return this.bchcod.getValue();
        }





        public void setBxdprefixHolder(FieldHolder<String> bxdprefix)
        {
           this.bxdprefix = (bxdprefix);
        }

        public void setBxdprefix(String bxdprefix)
        {
            this.bxdprefix.setValue(bxdprefix);
        }

        public String getBxdprefix()
        {
            return this.bxdprefix.getValue();
        }



        public void setMarprefixHolder(FieldHolder<String> marprefix)
        {
           this.marprefix = (marprefix);
        }

        public void setMarprefix(String marprefix)
        {
            this.marprefix.setValue(marprefix);
        }

        public String getMarprefix()
        {
            return this.marprefix.getValue();
        }













}