package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Chkmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Chkmod.class);

        //人民币账号
        private String rmbcno;

        //交割方式
        private String jivstt;



	    @BDGetter
		private Jsdgrp jsdgrp;

	    @BDGetter
		private Widgrp widgrp;

	    @BDGetter
		private Ptsp apl1;

	    @BDGetter
		private Ptsp apl2;


		public Chkmod()
        {
            super();
            setArgument();
        }

        public Chkmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getApl1().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getApl1().setBelongtoHolder(new FieldConstantHolder<>("jsd"));
            this.getApl1().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getApl1().setPtsptaHolder(()->this.getJsdgrp().getApl());
            this.getApl2().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getApl2().setBelongtoHolder(new FieldConstantHolder<>("wid"));
            this.getApl2().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getApl2().setPtsptaHolder(()->this.getWidgrp().getApl());
        }




        /**
        *   source:chkmod.@0000.script
        */
        public void loadMessage(String objtyp,String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("jsd".equals(objtyp))
			{
			  String nam=ctx.absGet(Sysmod.class).getPty().getNam();
			  this.getJsdgrp().setNam(nam);

			  MdaUtils.clear(this.getJsdgrp().getRec());
			  ctx.getDaoSession().dbRead(this.getJsdgrp().getRec(),new Argument<Object>("inr",ctx.absGet(Sysmod.class).getSpt().getObjinr()),new Argument<Object>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			  String ptynam=ctx.absGet(Trnmod.class).getPtyName(this.getJsdgrp().getRec().getPtyinr());
			  this.getJsdgrp().setPtynam(ptynam);

			  MdaUtils.clear(this.getJsdgrp().getApl().getPts());
			  ctx.getDaoSession().dbRead(this.getJsdgrp().getApl().getPts(),new Argument<String>("objinr",this.getJsdgrp().getRec().getInr()),new Argument<String>("objtyp","jsd"),new Argument<String>("rol","apl"));
			  
			  
			  log.debug("{}","pts 值"+this.getApl1().getPtspta().getPts().getInr());

			  if("F".equals(sta) || "1".equals(this.getJsdgrp().getRec().getNewgivsty()))
			  {
			    
			    
			  }
			  
			  
			  

			  if(!"F".equals(sta))
			  {
			    this.getJsdgrp().getRec().setGetslt(NULLSTR);
			    this.getJsdgrp().getRec().setGivslt(NULLSTR);
			    this.getJsdgrp().getRec().setGivamt(new BigDecimal(0));
			    this.getJsdgrp().getRec().setGetamt(new BigDecimal(0));
			    this.getJsdgrp().getRec().setGetdat(null);
			  }

			  
			  
			  
			  
			  

			  this.getJsdgrp().getRec().setChkdat(MdaUtils.today());
			  
			}
			else
			{
			  String nam=ctx.absGet(Sysmod.class).getPty().getNam();
			  this.getWidgrp().setNam(nam);

			  MdaUtils.clear(this.getWidgrp().getApl().getPts());
			  MdaUtils.clear(this.getWidgrp().getRec());
			  ctx.getDaoSession().dbRead(this.getWidgrp().getRec(),new Argument<Object>("inr",ctx.absGet(Sysmod.class).getSpt().getObjinr()),new Argument<Object>("ownref",ctx.absGet(Sysmod.class).getSpt().getOwnref()));
			  ctx.getDaoSession().dbRead(this.getWidgrp().getApl().getPts(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()),new Argument<String>("objtyp","wid"),new Argument<String>("rol","apl"));
			  
			  
			  ctx.getDaoSession().dbRead(this.getWidgrp().getIsb().getPts(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()),new Argument<String>("objtyp","wid"),new Argument<String>("rol","isb"));
			  ctx.getDaoSession().dbRead(this.getWidgrp().getIsb().getPty(),new Argument<String>("inr",this.getWidgrp().getIsb().getPts().getPtyinr()));

			  String ptynam=ctx.absGet(Trnmod.class).getPtyName(this.getWidgrp().getRec().getPtyinr());
			  this.getWidgrp().setPtynam(ptynam);

			  ctx.getDaoSession().dbReadset(this.getWidgrp().getWiclst(),new Argument<String>("objinr",this.getWidgrp().getRec().getInr()),new Argument<String>("modflg","0"));
			  for(int i = 0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    this.getWidgrp().getWiclst().getElement(i).setNo(""+i);

			  }
			  
			  

			  if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			  {
			    
			    
			  }
			  else
			  {
			    
			    
			    this.getWidgrp().getRec().setYktyp(NULLSTR);
			    this.getWidgrp().getRec().setYkje(new BigDecimal(0));
			  }
			  
			  

			  this.getWidgrp().setSfcejg(this.getWidgrp().getRec().getSfcejg());
			  if("0".equals(this.getWidgrp().getRec().getSfcejg()))
			  {
			    this.getWidgrp().setSfcejg1("1");
			  }
			  else if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			  {
			    this.getWidgrp().setSfcejg1("0");
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg1("");
			  }
			  
			  

			  this.getWidgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getWidgrp().setChkdat(MdaUtils.today());
			  

			}
		}
        /**
        *   source:chkmod.@0001.script
        */
        public void pdfValue(String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("jsd".equals(objtyp))
			{
			  BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			  amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			  this.getJsdgrp().getRec().setAmt(amt);
			  

			  BigDecimal amt1 = this.getJsdgrp().getRec().getGivamt();
			  amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			  this.getJsdgrp().getRec().setGivamt(amt1);
			  

			  BigDecimal amt2 = this.getJsdgrp().getRec().getGetamt();
			  amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			  this.getJsdgrp().getRec().setGetamt(amt2);
			  

			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getNewgivsty()))//交割方式转换
			  {
			    String giv=this.getJsdgrp().getRec().getNewgivsty();
			    if("0".equals(giv))
			      this.getJsdgrp().setSjgsty("2");
			    else
			      this.getJsdgrp().setSjgsty(giv);
			  }
			  

			  if(TRUE.equals(this.getJsdgrp().getRec().getGetslt()))
			  {
			    if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			      this.getJsdgrp().setBuycnn(this.getJsdgrp().getRec().getSelcno());
			    else
			      this.getJsdgrp().setBuycnn(this.getJsdgrp().getRec().getBuycno());
			    
			  }
			}
			else
			{
			  BigDecimal qqfamt = this.getWidgrp().getRec().getQqfamt();
			  qqfamt = MdaUtils.parseDecimal(MdaUtils.format(qqfamt,"#0.00"));
			  this.getWidgrp().getRec().setQqfamt(qqfamt);
			  

			  BigDecimal ykje = this.getWidgrp().getRec().getYkje();
			  ykje = MdaUtils.parseDecimal(MdaUtils.format(ykje,"#0.00"));
			  this.getWidgrp().getRec().setYkje(ykje);
			  

			  if("0".equals(this.getWidgrp().getRec().getSfcejg()))//交割方式转换
			  {
			    this.getWidgrp().setSfcejg2("1");
			  }
			  else if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			  {
			    this.getWidgrp().setSfcejg2("2");
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg2("");
			  }

			  //盈亏及盈亏金额
			  if("1".equals(this.getWidgrp().getRec().getYktyp()))
			  {
			    this.getWidgrp().setYlje(this.getWidgrp().getRec().getYkje());
			    this.getWidgrp().setKsje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(this.getWidgrp().getRec().getCnybacc());
			    this.getWidgrp().setDate1(this.getWidgrp().getRec().getZxdate());
			    this.getWidgrp().setDate2(null);
			  }
			  else if("2".equals(this.getWidgrp().getRec().getYktyp()))
			  {
			    this.getWidgrp().setKsje(this.getWidgrp().getRec().getYkje());
			    this.getWidgrp().setYlje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(NULLSTR);
			    this.getWidgrp().setDate2(this.getWidgrp().getRec().getZxdate());
			    this.getWidgrp().setDate1(null);
			  }
			  else
			  {
			    this.getWidgrp().setYlje(new BigDecimal(0));
			    this.getWidgrp().setKsje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(NULLSTR);
			    this.getWidgrp().setDate1(null);
			    this.getWidgrp().setDate2(null);
			  }

			  //期权每笔记录金额集合
			  this.getWidgrp().setAmt(NULLSTR);
			  StringBuffer amt=new StringBuffer();
			  String conn="";
			  BigDecimal bd = null;
			  for(int i=0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			    if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			      amt.append(conn).append("");
			    else
			      amt.append(conn).append(bd.setScale(2));
			    conn = ",";
			  }
			  this.getWidgrp().setAmt(amt.toString());

			}
		}
        /**
        *   source:chkmod.@0002.script
        */
        public void pdfValueS(String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("jsd".equals(objtyp))
			{
			  BigDecimal amt = this.getJsdgrp().getRec().getAmt();
			  amt = MdaUtils.parseDecimal(MdaUtils.format(amt,"#0.00"));
			  this.getJsdgrp().getRec().setAmt(amt);

			  BigDecimal amt1 = this.getJsdgrp().getRec().getGivamt();
			  amt1 = MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00"));
			  this.getJsdgrp().getRec().setGivamt(amt1);

			  BigDecimal amt2 = this.getJsdgrp().getRec().getGetamt();
			  amt2 = MdaUtils.parseDecimal(MdaUtils.format(amt2,"#0.00"));
			  this.getJsdgrp().getRec().setGetamt(amt2);

			  if(!MdaUtils.isEmpty(this.getJsdgrp().getRec().getNewgivsty()))//交割方式转换
			  {
			    String giv=this.getJsdgrp().getRec().getNewgivsty();
			    if("0".equals(giv))
			      this.getJsdgrp().setSjgsty("2");
			    else
			      this.getJsdgrp().setSjgsty(giv);
			  }

			  if(TRUE.equals(this.getJsdgrp().getRec().getGetslt()))
			  {
			    if("1".equals(this.getJsdgrp().getRec().getSfltyp()))
			      this.getJsdgrp().setBuycnn(this.getJsdgrp().getRec().getSelcno());
			    else
			      this.getJsdgrp().setBuycnn(this.getJsdgrp().getRec().getBuycno());
			  }
			}
			else
			{
			  BigDecimal qqfamt = this.getWidgrp().getRec().getQqfamt();
			  qqfamt = MdaUtils.parseDecimal(MdaUtils.format(qqfamt,"#0.00"));
			  this.getWidgrp().getRec().setQqfamt(qqfamt);

			  BigDecimal ykje = this.getWidgrp().getRec().getYkje();
			  ykje = MdaUtils.parseDecimal(MdaUtils.format(ykje,"#0.00"));
			  this.getWidgrp().getRec().setYkje(ykje);

			  if("0".equals(this.getWidgrp().getRec().getSfcejg()))//交割方式转换
			  {
			    this.getWidgrp().setSfcejg("1");
			  }
			  else if("1".equals(this.getWidgrp().getRec().getSfcejg()))
			  {
			    this.getWidgrp().setSfcejg("2");
			  }
			  else
			  {
			    this.getWidgrp().setSfcejg("");
			  }

			  //盈亏及盈亏金额
			  if("1".equals(this.getWidgrp().getRec().getYktyp()))
			  {
			    this.getWidgrp().setYlje(this.getWidgrp().getRec().getYkje());
			    this.getWidgrp().setKsje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(this.getWidgrp().getRec().getCnybacc());
			    this.getWidgrp().setDate1(this.getWidgrp().getRec().getZxdate());
			    this.getWidgrp().setDate2(null);
			  }
			  else if("2".equals(this.getWidgrp().getRec().getYktyp()))
			  {
			    this.getWidgrp().setKsje(this.getWidgrp().getRec().getYkje());
			    this.getWidgrp().setYlje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(NULLSTR);
			    this.getWidgrp().setDate2(this.getWidgrp().getRec().getZxdate());
			    this.getWidgrp().setDate1(null);
			  }
			  else
			  {
			    this.getWidgrp().setYlje(new BigDecimal(0));
			    this.getWidgrp().setKsje(new BigDecimal(0));
			    this.getWidgrp().setCnyacc(NULLSTR);
			    this.getWidgrp().setDate1(null);
			    this.getWidgrp().setDate2(null);
			  }

			  //期权每笔记录金额集合
			  this.getWidgrp().setAmt(NULLSTR);
			  StringBuffer amt=new StringBuffer();
			  String conn="";
			  BigDecimal bd = null;
			  for(int i=0; i < this.getWidgrp().getWiclst().size(); i++)
			  {
			    bd = this.getWidgrp().getWiclst().getElement(i).getAmt();
			    if(MdaUtils.isEmpty(bd)||bd.compareTo(new BigDecimal(0))==0)
			      amt.append(conn).append("");
			    else
			      amt.append(conn).append(bd.setScale(2));
			    conn = ",";
			  }
			  this.getWidgrp().setAmt(amt.toString());
			}
		}













}