package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cidmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Cidmod.class);

        //核心客户号
        private String cid;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel client;


	    @BDGetter
		private Pty clipty;

		@BDGetter
		private ModuleList<Pty> clilst;


		public Cidmod()
        {
            super();
            setArgument();
        }

        public Cidmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:cidmod.@0001.script
        */
        @Rule(target="search",order=100)
        public boolean ruleSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.qur();

			return true;
        }



        /**
        *   source:cidmod.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			this.qur();

			return true;
        }


        /**
        *   source:cidmod.@0000.script
        */
        public void qur()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","******业务权限模式定制 - 搜索*******");
			MdaUtils.clear(this.getClilst());
			String sql = "SELECT distinct clipty.cid cid,clipty.nam nam,clipty.engnam engnam ,bchpty.inr inr FROM pty bchpty,pty clipty,ptr WHERE bchpty.inr = ptr.nxtptyinr and ptr.ptrtyp in ('0','1') and ptr.preptyinr=clipty.inr and bchpty.ptytyp='0' ";
			if("1".equals(ctx.absGet(Sysmod.class).getPty().getBrhlvl()))
			  log.info("{}","read all clientPty:"+sql );
			else if("2".equals(ctx.absGet(Sysmod.class).getPty().getBrhlvl()))
			{
			  sql=sql+" and substr(bchpty.cid,1,2) = '"+ctx.absGet(Sysmod.class).getPty().getCid().substring(0,2)+"' ";
			  log.info("{}","read 分行 clientPty:"+sql );
			}
			else if("3".equals(ctx.absGet(Sysmod.class).getPty().getBrhlvl()) || "4".equals(ctx.absGet(Sysmod.class).getPty().getBrhlvl()) )
			{
			  sql=sql+" and bchpty.inr='"+ctx.absGet(Sysmod.class).getPty().getInr()+"' ";
			  log.info("{}","read  clientPty:"+sql );
			}
			if(!MdaUtils.isEmpty(this.getCid()))
			  sql=sql+" and clipty.cid='"+this.getCid()+"'";
			log.info("{}","finally sql:"+sql );
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> cid = new Argument<String>("cid");
			Argument<String> engnam = new Argument<String>("engnam");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> inr = new Argument<String>("inr");
			int cnt=0;
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cid,nam,engnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getClilst().add(cid,nam,engnam,inr);
			    cnt++;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			if(cnt==0)
			  ctx.setMessage(MdaUtils.getI18NString("cidmod","CT000007"),MdaUtils.getI18NString("cidmod","CT000008"));
		}









}