package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Climod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Climod.class);

        //ref
        private String reference;

        //ok
        private transient IControl ok = new ControlImpl("ok", "ok", this);

        //new notice
        private IStream newnt = new StreamImpl();

        //adr
        private String adr;

        //sel
        private transient IControl sel = new ControlImpl("sel", "sel", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //ptyinr
        private String ptyinr;

        //newxmlfil
        private String newxmlfil;

        //兴业logopath
        private String logo;

        //nam
        private String nam;

        //tel
        private String tel;

        //fax
        private String fax;

        //newxmlfil1
        private String newxmlfil1;

        //ok1
        private transient IControl ok1 = new ControlImpl("ok1", "ok1", this);

        //new notice1
        private IStream newnt1 = new StreamImpl();


        @JsonIgnore
        @BDGetter
        private transient IPanel edit;

        @JsonIgnore
        @BDGetter
        private transient IPanel clientp;

        @JsonIgnore
        @BDGetter
        private transient IPanel edit1;


	    @BDGetter
		private Ptspta cli;

	    @BDGetter
		private Ptslst clip;

		@BDGetter
		private ModuleList<Ptsplst> clilst;

	    @BDGetter
		private Smh tclsmh;


		public Climod()
        {
            super();
            setArgument();
        }

        public Climod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:climod.@0000.script
        */
        @Rule(target="sel",order=100)
        public boolean ruleSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.popup($clientp);
			  Platform.clear($clilst);
			  String selClause = "SELECT pta.inr ptainr,pty.inr ptyinr,pty.extkey extkey,pty.nam nam,pty.engnam engnam,adr.adr adr,adr.tel tel,adr.fax fax FROM pty,adr,pta,ptr WHERE pta.ptyinr = pty.inr AND adr.inr = pta.objinr AND ptr.ptrtyp = '2' AND pty.inr = ptr.preptyinr AND ptr.nxtptyinr = '"+ $\\sysmod\\pty\\inr.getValue() +"'";
			  Platform.dbExecuteSQL(selClause);
			  Platform.errorCode();
			  log.info(#CT000008 + selClause);
			  Argument<String> ptainr = new Argument<String>("ptainr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> extkey = new Argument<String>("extkey");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> tel = new Argument<String>("tel");
			  Argument<String> fax = new Argument<String>("fax");
			  while(true)
			  {
			  Platform.dbFetchFields(ptainr,ptyinr,extkey,nam,engnam,adr,tel,fax);
			  int errorCode  = Platform.errorCode();
			  if(errorCode == NO_ERROR)
			  {
			  $clilst.add(ptainr,ptyinr,extkey,nam,engnam,adr,tel,fax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			  log.info(#CT000009);
			  break;
			  }
			  else
			  {
			  log.info(#CT000010);
			  break;
			  }
			  }
			  Platform.dbCloseCursor();
			  if($clilst.fullSize() == 0)
			  {
			  Platform.message(#CT000011,#CT000012);
			  return;
			  }
			  Platform.setModified($clilst);
			  */
			
			MdaUtils.clear(this.getClilst());
			String selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.nam nam,b.engnam engnam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE a.ptyinr = b.inr AND c.inr = a.objinr AND d.ptrtyp = '2' AND b.inr = d.preptyinr AND d.nxtptyinr = '"+ ctx.absGet(Sysmod.class).getPty().getInr() +"'";
			if(!MdaUtils.isEmpty(this.getCli().getPts().getExtkey()))
			{
			  String extkey = this.getCli().getPts().getExtkey();
			  selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			}
			ctx.getDaoSession().dbExecuteSQL(selClause);
			ctx.getErrorCode();
			log.info("{}","seletp的sql===================" + selClause);
			Argument<String> ptainr = new Argument<String>("ptainr");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> engnam = new Argument<String>("engnam");
			Argument<String> ptyinr = new Argument<String>("ptyinr");
			Argument<String> extkey = new Argument<String>("extkey");
			Argument<String> adr = new Argument<String>("adr");
			Argument<String> tel = new Argument<String>("tel");
			Argument<String> fax = new Argument<String>("fax");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey,nam,engnam,adr,tel,fax);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getClilst().add(ptainr,ptyinr,extkey,nam,engnam,adr,tel,fax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			if(this.getClilst().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("climod","CT000052"),MdaUtils.getI18NString("climod","CT000053"));
			  return true;
			}
			

			return true;
        }

        /**
        *   source:climod.@0001.script
        */
        @Rule(target="ok",order=100)
        public boolean ruleOkN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:climod.@0002.script
        */
        @Rule(target="sure",order=100)
        public boolean ruleSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getClilst().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("climod","CT000028"),MdaUtils.getI18NString("climod","CT000029"));
			  return false;
			}
			String adr=this.getClilst().getElement(index).getAdr();
			String nam=this.getClilst().getElement(index).getNam();
			String tel=this.getClilst().getElement(index).getTel();
			String fax=this.getClilst().getElement(index).getFax();
			//$client.setValue(nam+$nam+add+"\\r\\n"+tel+"\\r\\n"+fax);
			this.setNam(nam);
			this.setAdr(adr);
			this.setTel(tel);
			this.setFax(fax);
			this.setPtyinr(this.getClilst().getElement(index).getPtyinr());
			log.info("{}","client adr="+this.getNam()+"\r\n"+this.getAdr()+"\r\n"+this.getTel()+"\r\n"+this.getFax());
			
			
			
			
			

			return true;
        }

        /**
        *   source:climod.@0003.script
        */
        @Rule(target="newnt",order=100)
        public boolean ruleNewntN100(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }

        /**
        *   source:climod.@0004.script
        */
        @Rule(target="ok1",order=100)
        public boolean ruleOk1N100(){
            IContext ctx = MdaEnv.getContext();
            
			;

			return true;
        }

        /**
        *   source:climod.@0005.script
        */
        @Rule(target="newnt1",order=100)
        public boolean ruleNewnt1N100(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }




        /**
        *   source:climod.@0006.script
        */
        public String changeXMLFile(String filepath,String xmlNbm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(filepath))
			  return null;
			String filename=ctx.absGet(Mtabut.class).getXmlFile(xmlNbm);
			if(MdaUtils.isEmpty(filename)  ||  !filename.toLowerCase().endsWith("xml"))
			  return null;
			String newfilename="N"+filename;
			HashMap<String,Object> map = new HashMap<String,Object>();
			map.put("trnname", ctx.getTransName());
			if(TRUE.equals(this.getLogo()))
			{
			  log.debug("{}",this.getLogo()+"and"+TRUE);
			  String cov = ctx.absGet(Sysmod.class).getEty().getCovurl();
			  if(!MdaUtils.isEmpty(cov))
			    cov = cov.substring(cov.lastIndexOf("/")+1,cov.length());
			  else
			    cov="";
			  map.put("logo",cov);
			}
			map.put("ownref",ctx.absGet(Mtabut.class).getClimod().getReference());
			map.put("nam",ctx.absGet(Mtabut.class).getClimod().getNam());
			map.put("adr",ctx.absGet(Mtabut.class).getClimod().getAdr());
			map.put("tel",ctx.absGet(Mtabut.class).getClimod().getTel());
			map.put("fax",ctx.absGet(Mtabut.class).getClimod().getFax());
			log.info("{}","filepath="+filepath );
			log.info("{}","newfilename="+newfilename );
			this.setNewxmlfil(newfilename);
			//change
			MdaUtils.invoke("com.brilliance.doc.DocPacker","changXmlField",filepath,filename,newfilename,map);
			return newfilename;
		}
        /**
        *   source:climod.@0007.script
        */
        public String changeAppFile(String filepath,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(filepath))
			  return null;
			String filename=ctx.absGet(Mtabut.class).getXmlFile(type);
			if(MdaUtils.isEmpty(filename)  ||  !filename.toLowerCase().endsWith("app"))
			  return null;
			String newfilename="N"+filename;
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			Map mdata  = (Map) data;
			mdata.put("ben",ctx.absGet(Mtabut.class).getClimod().getAdr());
			mdata.put("bennam",ctx.absGet(Mtabut.class).getClimod().getNam());
			//change
			
			String clsNam = "com.brilliance.swift.SwiftPacker";
			MdaUtils.invoke(clsNam,"saveDataToFile",mdata,filepath,newfilename);
			return newfilename;
		}







































}