package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 公共申请s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Comp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Comp.class);


        @JsonIgnore
        @BDGetter
        private transient IPanel comp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel comp02;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Comgrp> comgrp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Pdfviw pdfviw;


		public Comp()
        {
            super();
            setArgument();
        }

        public Comp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getDapp().setPtsptaHolder(()->this.getComgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("com"));
            this.getAplp().setPtsptaHolder(()->this.getComgrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("com"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
        }





        public void setComgrpHolder(ModuleHolder<Comgrp> comgrp)
        {
           this.comgrp = comgrp;
        }

        public Comgrp getComgrp()
        {
           return this.comgrp.get();
        }







}