package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Hyimp;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Cptp.class);

        //汇出汇款申请人电话
        private String tel;

        //申请人名称
        private String aplnam;

        //显示页面
        private String display;

        //申请书
        private IStream apldoc = new StreamImpl();

        //search
        private transient IControl search = new ControlImpl("search", "search", this);

        //确定
        private transient IControl sure = new ControlImpl("sure", "确定", this);

        //下载
        private IStream download = new StreamImpl();

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //选择
        private transient IControl sure1 = new ControlImpl("sure1", "选择", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //fx账户选择按钮
        private transient IControl fxbut = new ControlImpl("fxbut", "fx账户选择按钮", this);

        //pur账户选择按钮
        private transient IControl purbut = new ControlImpl("purbut", "pur账户选择按钮", this);

        //oth账户选择按钮
        private transient IControl othbut = new ControlImpl("othbut", "oth账户选择按钮", this);

        //账户选择
        private transient IControl actsurel = new ControlImpl("actsurel", "账户选择", this);

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择按钮标记
        private String actchsflg;

        //影像
        private transient IControl imgbtn = new ControlImpl("imgbtn", "影像", this);

        //申请书
        private IStream apldocbtn = new StreamImpl();

        //代理行名称地址
        private String intbic;

        //收款行名称地址
        private String benbic;

        //收款人账号地址
        private String benacc;

        //Others (其他) 
        private String others;

        //附言
        private String message;

        //选项
        private String retflg;

        //账号
        private String acc;

        //选项2
        private String retflg2;

        //查询事项
        private String inftxt;

        //动态面板字段
        private IPanel fresubtp;

        //附言
        private String oprtxt;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //账号类型
        private String acttyp;

        //cur
        private String cur;

        //cur1
        private String cur1;

        //cur2
        private String cur2;

        //付款性质
        private String paytyptxt;

        //对公
        private String topub;

        //对私
        private String toper;

        //人民币账户选择
        private transient IControl rmbbut = new ControlImpl("rmbbut", "人民币账户选择", this);

        //资金性质标志
        private String funchas;

        //预览申请书
        private transient IControl apldocs = new ControlImpl("apldocs", "预览申请书", this);

        //切换面板
        private IPanel chagepan;

        //时间
        private String dassy;

        //购汇人民币账户选择
        private transient IControl accbtn = new ControlImpl("accbtn", "购汇人民币账户选择", this);

        //按钮选择
        private IPanel cptbut;

        //交易名称
        private String cptlab;

        //申请人名址
        private IPanel changeapl;

        //即期结汇申请书（普打）
        private transient IControl pdspdpdf = new ControlImpl("pdspdpdf", "即期结汇申请书（普打）", this);

        //即期结汇申请书（套打）
        private transient IControl tdspdpdf = new ControlImpl("tdspdpdf", "即期结汇申请书（套打）", this);

        //境内收入申报单（普打）
        private transient IControl pddecinpdf = new ControlImpl("pddecinpdf", "境内收入申报单（普打）", this);

        //境内收入申报单（套打）
        private transient IControl tddecinpdf = new ControlImpl("tddecinpdf", "境内收入申报单（套打）", this);

        //涉外收入申报单（普打）
        private transient IControl pddecoutpdf = new ControlImpl("pddecoutpdf", "涉外收入申报单（普打）", this);

        //涉外收入申报单（套打）
        private transient IControl tddecoutpdf = new ControlImpl("tddecoutpdf", "涉外收入申报单（套打）", this);

        //查询
        private transient IControl hycsel = new ControlImpl("hycsel", "查询", this);

        //经办
        private transient IControl hyccom = new ControlImpl("hyccom", "经办", this);

        //批量导入
        private IStream hyimpt = new StreamImpl();

        //模板下载
        private IStream hydload = new StreamImpl();

        //确认
        private transient IControl hysure = new ControlImpl("hysure", "确认", this);

        //hystm
        private IStream hystm = new StreamImpl();

        //海运费编号
        private String hyno;

        //海运费批次号
        private String hyimpno;

        //跨境业务人民币结算收款说明申请书
        private transient IControl fksmsqs = new ControlImpl("fksmsqs", "跨境业务人民币结算收款说明申请书", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel cptp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel country;

        @JsonIgnore
        @BDGetter
        private transient IPanel codp;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel detail;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel apllist;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre02;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre03;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre00;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre08;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre04;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs2;

        @JsonIgnore
        @BDGetter
        private transient IPanel ps;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapl00;

        @JsonIgnore
        @BDGetter
        private transient IPanel cachnadr;

        @JsonIgnore
        @BDGetter
        private transient IPanel chnadr;

        @JsonIgnore
        @BDGetter
        private transient IPanel enadr;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt01;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt00;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt02;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt03;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptyub;

        @JsonIgnore
        @BDGetter
        private transient IPanel cachnadr2;

        @JsonIgnore
        @BDGetter
        private transient IPanel aplenptap;

        @JsonIgnore
        @BDGetter
        private transient IPanel aplcnptap;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapitop;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapiopn;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapi1;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapi3;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapi2;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapi4;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapipdf;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpthyf;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpthyf01;

        @JsonIgnore
        @BDGetter
        private transient IPanel hyfdb;

        @JsonIgnore
        @BDGetter
        private transient IPanel hyfimp;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapi5;

        @JsonIgnore
        @BDGetter
        private transient IPanel tdepanel;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt04;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpt05;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Cpdgrp> cpdgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp acwp;

	    @BDGetter
		private Cusp cusp;

	    @BDGetter
		private Ptsp rcpp;

	    @BDGetter
		private Ptsp payp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

		@BDGetter
		private ModuleList<Act> actlst;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Fpdgrp fpdgrp;

	    @BDGetter
		private Actmod actmod;

	    @BDGetter
		private Spdgrp spdgrp;

	    @BDGetter
		private Decgrp decgrp;

	    @BDGetter
		private Invl invl;

		@BDGetter
		private ModuleList<Hyimp> hyimp;


		public Cptp()
        {
            super();
            setArgument();
        }

        public Cptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getCpdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getBenp().setPtsptaHolder(()->this.getCpdgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getAcwp().setPtsptaHolder(()->this.getCpdgrp().getAcw());
            this.getAcwp().setRolHolder(new FieldConstantHolder<>("acw"));
            this.getAcwp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAcwp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getRcpp().setPtsptaHolder(()->this.getCpdgrp().getRcp());
            this.getRcpp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getRcpp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getRcpp().setRolHolder(new FieldConstantHolder<>("rcp"));
            this.getPayp().setPtsptaHolder(()->this.getCpdgrp().getPay());
            this.getPayp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getPayp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getPayp().setRolHolder(new FieldConstantHolder<>("pay"));
            this.getDapp().setPtsptaHolder(()->this.getCpdgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
            this.getTrpp().setPtsptaHolder(()->this.getCpdgrp().getTrp());
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("cpd"));
        }




        /**
        *   source:cptp.@0000.script
        */
        public void encode()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getCpdgrp().setAtcnum(NULLSTR);
			this.getCpdgrp().setAtccur(NULLSTR);
			this.getCpdgrp().setAtcamt(NULLSTR);
			this.getCpdgrp().setChkcur(NULLSTR);
			this.getCpdgrp().setChkamt(NULLSTR);
			int len = this.getCpdgrp().getApyctmlst().fullSize();
			StringBuffer atcnum=new StringBuffer();
			StringBuffer atccur=new StringBuffer();
			StringBuffer atcamt=new StringBuffer();
			StringBuffer chkcur=new StringBuffer();
			StringBuffer chkamt=new StringBuffer();
			String conn="";
			String cc = null;
			BigDecimal bd = null;
			/*
			  for(int i=0;i<len;i++)
			  {
			  cc = $cpdgrp\\apyctmlst[i]\\atcnum.getValue();
			  if(Platform.isEmpty(cc))
			  cc="";
			  atcnum.append(conn).append(cc);
			  cc = $cpdgrp\\apyctmlst[i]\\atccur.getValue();
			  if(Platform.isEmpty(cc))
			  cc="";
			  atccur.append(conn).append(cc);
			  bd = $cpdgrp\\apyctmlst[i]\\atcamt.getValue();
			  log.debug(""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(Platform.isEmpty(cc)&&bd.compareTo(new BigDecimal(0))==0)
			  atcamt.append(conn).append("");
			  else
			  atcamt.append(conn).append(bd.setScale(2));
			  cc = $cpdgrp\\apyctmlst[i]\\chkcur.getValue();
			  if(Platform.isEmpty(cc))
			  cc="";
			  chkcur.append(conn).append(cc);
			  bd = $cpdgrp\\apyctmlst[i]\\chkamt.getValue();
			  log.debug(""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(Platform.isEmpty(cc)&&bd.compareTo(new BigDecimal(0))==0)
			  chkamt.append(conn).append("");
			  else
			  chkamt.append(conn).append(bd.setScale(2));
			  conn = ",";
			  }
			  */
			// log.info("atcnum:"+atcnum);
			// log.info("atccur:"+atccur);
			// log.info("atcamt:"+atcamt);
			// log.info("chkcur:"+chkcur);
			// log.info("chkamt:"+chkamt);
			conn = ",";
			bd = this.getCpdgrp().getRec().getFxamt();
			cc = this.getCur();
			if(MdaUtils.isEmpty(bd)||MdaUtils.isEmpty(cc))
			  cc="";
			atccur.append(cc).append(conn);

			bd = this.getCpdgrp().getRec().getPuramt();
			cc = this.getCur1();
			if(MdaUtils.isEmpty(bd)||MdaUtils.isEmpty(cc))
			  cc="";
			atccur.append(cc).append(conn);

			bd = this.getCpdgrp().getRec().getOthamt();
			cc = this.getCur2();
			if(MdaUtils.isEmpty(bd)||MdaUtils.isEmpty(cc))
			  cc="";
			atccur.append(cc).append(conn);

			bd = this.getCpdgrp().getRec().getBopamt1();
			cc = this.getCpdgrp().getRec().getBopcur1();
			if(MdaUtils.isEmpty(bd)||MdaUtils.isEmpty(cc))
			  cc="";
			atccur.append(cc).append(conn);

			bd = this.getCpdgrp().getRec().getBopamt2();
			cc = this.getCpdgrp().getRec().getBopcur2();
			if(MdaUtils.isEmpty(bd)||MdaUtils.isEmpty(cc))
			  cc="";
			atccur.append(cc).append(conn);

			this.getCpdgrp().setAtcnum(atcnum.toString());
			this.getCpdgrp().setAtccur(atccur.toString());
			this.getCpdgrp().setAtcamt(atcamt.toString());
			this.getCpdgrp().setChkcur(chkcur.toString());
			this.getCpdgrp().setChkamt(chkamt.toString());

		}
        /**
        *   source:cptp.@0002.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"jrmb".equals(this.getActchsflg()))
			{
			  MdaUtils.clear(this.getActchs());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();

			  if("pur".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			  else if("oth".equals(this.getActchsflg()))
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("ptyinr",ptyinr));
			  else
			    ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getCpdgrp().getRec().getRemcur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}
			else
			{
			  MdaUtils.clear(this.getActchs2());
			  String ptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			  ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getCpdgrp().getRec().getJacccur()),new Argument<String>("ptyinr",ptyinr));
			  
			  
			}

		}
        /**
        *   source:cptp.@0003.script
        */
        public void setCpdFromCimp(com.ceb.gjjs.mda.bo.Cimp cimp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	将表格中导入的数据保存到CPD模型中
			  */
			log.debug("{}","in cptp.setCpdFromCimp... ");
			String priority=this.getCpdgrp().getRec().getPriority();
			MdaUtils.clear(this.getCpdgrp().getRec());
			MdaUtils.clear(this.getCpdgrp().getBen().getPts());
			MdaUtils.clear(this.getCpdgrp().getAcw().getPts());
			MdaUtils.clear(this.getCpdgrp().getRcp().getPts());
			MdaUtils.clear(this.getCpdgrp().getPay().getPts());
			this.getCpdgrp().setCtydes(NULLSTR);
			
			
			
			log.debug("{}","rcpnam = " + cimp.getRcpnam() + ",acwnam = " + cimp.getAcwnam());
			if(!MdaUtils.isEmpty(cimp.getFxact()))
			{
			  this.getCpdgrp().getRec().setFxflg(TRUE);
			  this.getCpdgrp().getRec().setFxact(cimp.getFxact());
			  this.getCpdgrp().getRec().setFxamt(cimp.getRemamt());
			}
			else if(!MdaUtils.isEmpty(cimp.getPuract()))
			{
			  this.getCpdgrp().getRec().setPurflg(TRUE);
			  this.getCpdgrp().getRec().setPuract(cimp.getPuract());
			  this.getCpdgrp().getRec().setPuramt(cimp.getRemamt());
			}
			// TODO 导入的表格中仅有其他账号，对应的金额和币种没有
			else if(!MdaUtils.isEmpty(cimp.getOthact()))
			{
			  this.getCpdgrp().getRec().setOthflg(TRUE);
			  this.getCpdgrp().getRec().setOthact(cimp.getOthact());
			  this.getCpdgrp().getRec().setOthamt(new BigDecimal(0.00));
			}

			// 设置公组织代码和报关单代码
			this.getCpdgrp().getRec().setAtccod(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getAtccod());
			this.getCpdgrp().getRec().setBopcod(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getBopcod());
			this.setTopub(NULLSTR);
			this.setToper(NULLSTR);
			this.setTopub("√");
			this.getCpdgrp().getRec().setRmttyp("0");
			this.getCpdgrp().getRec().setPriority(priority);
			this.getCpdgrp().getRec().setRemcur(cimp.getRemcur());
			this.getCpdgrp().getRec().setRemamt(cimp.getRemamt());
			String amt = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).covCnAmt(this.getCpdgrp().getRec().getRemamt(),this.getCpdgrp().getRec().getRemcur());
			this.getCpdgrp().getRec().setWord(amt);
			this.getCpdgrp().getBen().getPts().setNam(cimp.getPyenam());
			this.getCpdgrp().getBen().getPts().setAdrblk(cimp.getPyenam());
			this.getCpdgrp().getBen().getPts().setRol("ben");

			this.getCpdgrp().getAcw().getPts().setNam(cimp.getAcwnam());
			this.getCpdgrp().getAcw().getPts().setAdrblk(cimp.getAcwnam());
			this.getCpdgrp().getAcw().getPts().setExtkey(cimp.getSwtcod());
			this.getCpdgrp().getAcw().getPts().setRol("acw");
			this.getCpdgrp().getRec().setPyeact(cimp.getPyeact());
			this.getCpdgrp().getRec().setPyecry(cimp.getPyecry());
			// 设置收款银行代理行信息
			this.getCpdgrp().getRcp().getPts().setRol("rcp");
			this.getCpdgrp().getRcp().getPts().setNam(cimp.getRcpnam());
			this.getCpdgrp().getRcp().getPts().setAdrblk(cimp.getRcpnam());
			this.getCpdgrp().getRcp().getPts().setExtkey(cimp.getRcpswtcod());
			this.getCpdgrp().getRcp().getPts().setRef(cimp.getRcpact());

			String cty = this.getCpdgrp().getRec().getPyecry();
			for(int k=0;k<this.getCpdgrp().getCtylst().fullSize();k++)
			{
			  log.debug("{}"," setCpdFromCimp. ctylst[" + k + "].alpcod =" + this.getCpdgrp().getCtylst().getElement(k).getAlpcod());
			  if(cty.equals(this.getCpdgrp().getCtylst().getElement(k).getAlpcod()))
			  {
			    this.getCpdgrp().setCtydes(this.getCpdgrp().getCtylst().getElement(k).getChnnam());
			    this.getCpdgrp().setCod(this.getCpdgrp().getCtylst().getElement(k).getCod());
			    break;
			  }
			}
			this.getCpdgrp().getRec().setInoutflg(cimp.getInoutflg());
			this.getCpdgrp().getRec().setInvno(cimp.getInvno());
			this.getCpdgrp().getRec().setConno(cimp.getConno());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).setNtext("供应商编号："+cimp.getSupno());
			String det = cimp.getDetchgcod();
			if("BEN".equalsIgnoreCase(det))
			{
			  this.getCpdgrp().getRec().setDetchgcod("BENEFICIARY");
			}
			else if("OUR".equalsIgnoreCase(det))
			{
			  this.getCpdgrp().getRec().setDetchgcod("APPLICANT");
			}
			else
			  this.getCpdgrp().getRec().setDetchgcod(det);
			//  设置对应的新增字段值
			if(!MdaUtils.isEmpty(cimp.getPaytyp()))
			{
			  String paytyptmp = cimp.getPaytyp().substring(0,1);
			  if("A".equals(paytyptmp))
			    paytyptmp="Advance Payment";
			  else if("P".equals(paytyptmp))
			    paytyptmp="Payment Against Delivery";
			  else if("R".equals(paytyptmp))
			    paytyptmp="Refund";
			  else if("O".equals(paytyptmp))
			    paytyptmp="Others";
			  this.getCpdgrp().getRec().setPaytyp(paytyptmp);
			}
			else
			{
			  this.getCpdgrp().getRec().setPaytyp("Others");
			}
			if(!MdaUtils.isEmpty(cimp.getPaytyptxt()))
			{
			  String paytxt = cimp.getPaytyptxt().substring(0,1);
			  this.getCpdgrp().getRec().setPaytyptxt(paytxt);
			}

			this.getCpdgrp().getRec().setReminf(cimp.getReminf());
			if(!MdaUtils.isEmpty(cimp.getCavpayflg()))
			{
			  String cavpayflg = cimp.getCavpayflg().substring(0,1);
			  this.getCpdgrp().getRec().setCavpayflg(cimp.getCavpayflg());
			}
			this.getCpdgrp().getRec().setFmdno(cimp.getFmdno());
			this.getCpdgrp().getRec().setBopcod1(cimp.getBopcod1());
			this.getCpdgrp().getRec().setBopamt1(cimp.getBopamt1());
			this.getCpdgrp().getRec().setBopcur1(cimp.getBopcur1());
			this.getCpdgrp().getRec().setBopinf1(cimp.getBopinf1());
			

		}
        /**
        *   source:cptp.@0004.script
        */
        public void setDataForSPT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getCpdgrp().setIntbic(this.getIntbic());
			this.getCpdgrp().setBenbic(this.getBenbic());
			this.getCpdgrp().setBenacc(this.getBenacc());
			this.getCpdgrp().setOthers(this.getOthers());
			this.getCpdgrp().setMessage(this.getMessage());
			this.getCpdgrp().setAcc(this.getAcc());
			this.getCpdgrp().setRetflg(this.getRetflg());
			this.getCpdgrp().setRetflg2(this.getRetflg2());
			this.getCpdgrp().setInftxt(this.getInftxt());
			this.getCpdgrp().setOprtxt(this.getOprtxt());
		}
        /**
        *   source:cptp.@0005.script
        */
        public void getDataForSPT()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setIntbic(this.getCpdgrp().getIntbic());
			this.setBenbic(this.getCpdgrp().getBenbic());
			this.setBenacc(this.getCpdgrp().getBenacc());
			this.setOthers(this.getCpdgrp().getOthers());
			this.setMessage(this.getCpdgrp().getMessage());
			this.setAcc(this.getCpdgrp().getAcc());
			this.setRetflg(this.getCpdgrp().getRetflg());
			this.setRetflg2(this.getCpdgrp().getRetflg2());
			this.setInftxt(this.getCpdgrp().getInftxt());
			this.setOprtxt(this.getCpdgrp().getOprtxt());
		}
        /**
        *   source:cptp.@0008.script
        */
        public boolean checkIllegalAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（17，2）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,2})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  amt = field.getValue().toString();
			  log.info("{}","amt "+amt);
			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			return bool;
		}

        public void setCpdgrpHolder(ModuleHolder<Cpdgrp> cpdgrp)
        {
           this.cpdgrp = cpdgrp;
        }

        public Cpdgrp getCpdgrp()
        {
           return this.cpdgrp.get();
        }



















        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }











































































































































}