package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 国内信用证s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ditp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ditp.class);

        //信用证办理落地机构
        private String bchcod;

        //申请人机构中文名称
        private String aplnam;

        //落地机构2
        private String bchcods;

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //付款期限
        private String payflg;

        //最迟装运日
        private String shpdat;

        //有效日
        private String expdat;

        //开证日期
        private String credat;

        //修改日期
        private String creamedat;

        //修改点
        private String details;

        //申请人开户行行号
        private String issbaninf;

        //NewField
        private String ametxt;

        //议付
        private String negflg;

        //转让
        private String adtflg;

        //承兑
        private String conflg;

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择
        private transient IControl actsurel = new ControlImpl("actsurel", "账户选择", this);

        //申请人账号选择按钮
        private transient IControl aplbut = new ControlImpl("aplbut", "申请人账号选择按钮", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel comlit;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel ttrcom01;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel comlit2;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp14;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditp15;

        @JsonIgnore
        @BDGetter
        private transient IPanel nditp;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Didgrp> didgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp advp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp mbenp;

	    @BDGetter
		private Ptsp aplbp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp rmbp;

	    @BDGetter
		private Ptsp tdbp;

	    @BDGetter
		private Ptsp avbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

	    @BDGetter
		private Txmmod lcrdoc;

	    @BDGetter
		private Txmmod adlcnd;

	    @BDGetter
		private Txmmod trstxt;

	    @BDGetter
		private Txmmod opncls;

	    @BDGetter
		private Txmmod swfd;

	    @BDGetter
		private Ptsp negp;

	    @BDGetter
		private Ptsp conp;

	    @BDGetter
		private Ptsp adtp;

	    @BDGetter
		private Pdfviw pdfviw;

		@BDGetter
		private ModuleList<Act> actlst;


		public Ditp()
        {
            super();
            setArgument();
        }

        public Ditp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getDidgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getBenp().setPtsptaHolder(()->this.getDidgrp().getBen());
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getAdvp().setPtsptaHolder(()->this.getDidgrp().getAdv());
            this.getAdvp().setRolHolder(new FieldConstantHolder<>("adv"));
            this.getAdvp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getAdvp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setPtsptaHolder(()->this.getDidgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getMbenp().setPtsptaHolder(()->this.getDidgrp().getMben());
            this.getMbenp().setRolHolder(new FieldConstantHolder<>("mben"));
            this.getMbenp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getMbenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getAplbp().setPtsptaHolder(()->this.getDidgrp().getAplb());
            this.getAplbp().setRolHolder(new FieldConstantHolder<>("aplb"));
            this.getAplbp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getAplbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setPtsptaHolder(()->this.getDidgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getRmbp().setPtsptaHolder(()->this.getDidgrp().getRmb());
            this.getRmbp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getRmbp().setRolHolder(new FieldConstantHolder<>("rmb"));
            this.getRmbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getTdbp().setPtsptaHolder(()->this.getDidgrp().getTdb());
            this.getTdbp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getTdbp().setRolHolder(new FieldConstantHolder<>("tdb"));
            this.getTdbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAvbp().setPtsptaHolder(()->this.getDidgrp().getAvb());
            this.getAvbp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getAvbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAvbp().setRolHolder(new FieldConstantHolder<>("avb"));
            this.getDapp().setPtsptaHolder(()->this.getDidgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTrpp().setPtsptaHolder(()->this.getDidgrp().getTrp());
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getLcrdoc().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Ditp.this.getFieldPath("didgrp.blk.lcrdoc");}
 				public void setValue(String arg){Ditp.this.getDidgrp().getBlk().setLcrdoc(arg);}
 				public String getValue(){return Ditp.this.getDidgrp().getBlk().getLcrdoc();}}
			 );
            this.getLcrdoc().setTxmgrpHolder(new FieldConstantHolder<>("lcrdoc"));
            this.getAdlcnd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Ditp.this.getFieldPath("didgrp.blk.adlcnd");}
 				public void setValue(String arg){Ditp.this.getDidgrp().getBlk().setAdlcnd(arg);}
 				public String getValue(){return Ditp.this.getDidgrp().getBlk().getAdlcnd();}}
			 );
            this.getAdlcnd().setTxmgrpHolder(new FieldConstantHolder<>("adlcnd"));
            this.getTrstxt().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getTrstxt().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Ditp.this.getFieldPath("didgrp.blk.trstxt");}
 				public void setValue(String arg){Ditp.this.getDidgrp().getBlk().setTrstxt(arg);}
 				public String getValue(){return Ditp.this.getDidgrp().getBlk().getTrstxt();}}
			 );
            this.getOpncls().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Ditp.this.getFieldPath("didgrp.blk.rgtcls");}
 				public void setValue(String arg){Ditp.this.getDidgrp().getBlk().setRgtcls(arg);}
 				public String getValue(){return Ditp.this.getDidgrp().getBlk().getRgtcls();}}
			 );
            this.getOpncls().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getSwfd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Ditp.this.getFieldPath("didgrp.swfd");}
 				public void setValue(String arg){Ditp.this.getDidgrp().setSwfd(arg);}
 				public String getValue(){return Ditp.this.getDidgrp().getSwfd();}}
			 );
            this.getSwfd().setTxmgrpHolder(new FieldConstantHolder<>("adlcnd"));
            this.getNegp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getNegp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getNegp().setRolHolder(new FieldConstantHolder<>("neg"));
            this.getNegp().setPtsptaHolder(()->this.getDidgrp().getNeg());
            this.getConp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getConp().setRolHolder(new FieldConstantHolder<>("con"));
            this.getConp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getConp().setPtsptaHolder(()->this.getDidgrp().getCon());
            this.getAdtp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAdtp().setRolHolder(new FieldConstantHolder<>("adt"));
            this.getAdtp().setBelongtoHolder(new FieldConstantHolder<>("did"));
            this.getAdtp().setPtsptaHolder(()->this.getDidgrp().getAdt());
        }

        /**
        *   source:ditp.@0008.script
        */
        @Rule(target="didgrp.rec.shppar",order=100)
        public boolean ruleDidgrpRecShpparN100(){
            IContext ctx = MdaEnv.getContext();
            
			//当“分批装运货物/分次提供服务”是“允许”选项的情况下，“分期装运/提供服务”的下拉框选项才是可选的
			if("2".equals(this.getDidgrp().getRec().getShppar()))
			{
			  //下拉框不可选  ,不可选此处的默认值有没有要求？
			  this.getDidgrp().getRec().setShipment(NULLSTR);
			  
			}
			else
			{
			  

			}
			

			return true;
        }

        /**
        *   source:ditp.@0009.script
        */
        @Rule(target="didgrp.rec.avbby",order=100)
        public boolean ruleDidgrpRecAvbbyN100(){
            IContext ctx = MdaEnv.getContext();
            
			//当“付款方式”为“即期付款 ”时值为0，且不可以输入；最大值为366
			//if("1".equals($didgrp\\rec\\avbby.getValue()))
			// {
			//即期付款
			//  $didgrp\\rec\\prompt.setValue(0);
			// Platform.setModified($didgrp\\rec\\prompt);
			// Platform.disable($didgrp\\rec\\prompt);
			
			// }
			// else
			//{
			//  Platform.enable($didgrp\\rec\\prompt);
			
			//}
			
			return true;
        }




        /**
        *   source:ditp.@0001.script
        */
        public void avbbyChange(String avbby)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("1".equals(avbby))
			{
			  //By Acceptance
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  this.getDidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  
			  
			  //  Platform.enable($didgrp\\dre\\pts\\extkey);
			  //  Platform.enable($didgrp\\dre\\pts\\adrblk);
			}
			else if("2".equals(avbby))
			{
			  //By Def Payment
			  
			  this.getDidgrp().getBlk().setMixdet(NULLSTR);
			  this.getDidgrp().getBlk().setDftat(NULLSTR);
			  
			  
			  
			  // Platform.clear($didgrp\\dre\\pts\\extkey);
			  // Platform.clear($didgrp\\dre\\pts\\adrblk);
			  
			  
			  // Platform.disable($didgrp\\dre\\pts\\extkey);
			  // Platform.disable($didgrp\\dre\\pts\\adrblk);
			}
			else if("3".equals(avbby))
			{
			  //By Mixed Pymt
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  this.getDidgrp().getBlk().setDftat(NULLSTR);
			  // Platform.clear($didgrp\\dre\\pts\\extkey);
			  // Platform.clear($didgrp\\dre\\pts\\adrblk);
			  
			  
			  
			  
			  // Platform.disable($didgrp\\dre\\pts\\extkey);
			  //  Platform.disable($didgrp\\dre\\pts\\adrblk);
			}
			else if("4".equals(avbby))
			{
			  //By Negotiation
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  this.getDidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  // Platform.enable($didgrp\\dre\\pts\\extkey);
			  // Platform.enable($didgrp\\dre\\pts\\adrblk);
			  
			  
			  
			}
			else if("5".equals(avbby))
			{
			  //By Payment
			  this.getDidgrp().getBlk().setDefdet(NULLSTR);
			  this.getDidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  // Platform.enable($didgrp\\dre\\pts\\extkey);
			  // Platform.enable($didgrp\\dre\\pts\\adrblk);
			  
			  
			  
			}
			//Platform.setModified($didgrp\\rec\\avbwths);
			//Platform.setModified($didgrp\\rec\\avbwth);
			// Platform.setModified($didgrp\\avb\\pts\\extkey);
			// Platform.setModified($didgrp\\avb\\pts\\adrblk);
			
			
			
			// Platform.setModified($didgrp\\dre\\pts\\extkey);
			// Platform.setModified($didgrp\\dre\\pts\\adrblk);
					}
        /**
        *   source:ditp.@0003.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActchs());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();

			ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur","CNY"),new Argument<String>("ptyinr",ptyinr));
			
			
		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setDidgrpHolder(ModuleHolder<Didgrp> didgrp)
        {
           this.didgrp = didgrp;
        }

        public Didgrp getDidgrp()
        {
           return this.didgrp.get();
        }

















































































}