package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 托收业务单据与份数
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Docgrdm extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Docgrdm.class);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl del = new ControlImpl("del", "删除", this);

        //其他单据
        @Module(getter = false, setter = false)
		private FieldHolder<String> othdoc = new FieldConstantHolder<>("");



        @JsonIgnore
        @BDGetter
        private transient IPanel docgrdp;


		@BDGetter
		private ModuleList<Docgrd> docgrd;


		public Docgrdm()
        {
            super();
            setArgument();
        }

        public Docgrdm(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:docgrdm.@0000.script
        */
        @Rule(target="add",order=100)
        public boolean ruleAddN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getDocgrd().add();
			

			return true;
        }

        /**
        *   source:docgrdm.@0002.script
        */
        @Rule(target="del",order=100)
        public boolean ruleDelN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(this.getDocgrd().fullSize()==0)
			  return true;
			boolean found=false;
			int size=-1+this.getDocgrd().fullSize();
			for(int i=size;i>=0;i--)
			{
			  if(TRUE.equals(this.getDocgrd().getElement(i).getModflg()))
			  {
			    found=true;
			    this.getDocgrd().remove(i);
			  }
			}
			if (!found)
			{
			  ctx.setMessage(MdaUtils.getI18NString("docgrdm","CT000011"),MdaUtils.getI18NString("docgrdm","CT000012"));
			}
			else
			{
			  
			}

			return true;
        }




        /**
        *   source:docgrdm.@0003.script
        */
        public String encode()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer sb=new StringBuffer();
			String conn="";
			for(int i=0;i<this.getDocgrd().fullSize();i++)
			{
			  if(MdaUtils.isEmpty(this.getDocgrd().getElement(i).getDoctyp()))
			    this.getDocgrd().getElement(i).setDoctyp("");
			  if(MdaUtils.isEmpty(this.getDocgrd().getElement(i).getDocnum()))
			    this.getDocgrd().getElement(i).setDocnum("");
			  sb.append(conn).append(this.getDocgrd().getElement(i).getDoctyp());
			  conn = ",";
			  sb.append(conn).append(this.getDocgrd().getElement(i).getDocnum());
			}
			log.info("{}","encode:"+sb);
			return sb.toString();
		}
        /**
        *   source:docgrdm.@0004.script
        */
        public void decode(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","decode:"+value);
			if(MdaUtils.isEmpty(value))
			  return;
			String[] values=value.split(",");
			int size=values.length/2;
			for(int i=this.getDocgrd().fullSize();i<size;i++)
			  this.getDocgrd().add();
			for(int i=0;i<size;i++)
			{
			  this.getDocgrd().getElement(i).setDoctyp(values[i*2]);
			  this.getDocgrd().getElement(i).setDocnum(values[i*2+1]);
			}
		}
        /**
        *   source:docgrdm.@0005.script
        */
        public String encodeTco()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer sb=new StringBuffer();
			String conn="";
			for(int i=0;i<this.getDocgrd().fullSize();i++)
			{
			  if(MdaUtils.isEmpty(this.getDocgrd().getElement(i).getDoctyp()))
			    continue;
			  if(MdaUtils.isEmpty(this.getDocgrd().getElement(i).getDocnum()))
			    this.getDocgrd().getElement(i).setDocnum("");
			  String doctyp = this.getDocgrd().getElement(i).getDoctyp();
			  String doclab = MdaUtils.getCodetableLabel("betchkdoc1",doctyp);
			  sb.append(conn).append(doclab);
			  sb.append(conn).append(doctyp);
			  conn = "/";
			}
			log.debug("{}","docgrd tco:"+sb);
			return sb.toString();
		}
        /**
        *   source:docgrdm.@0007.script
        */
        public void decode1(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","decode:"+value);
			if(MdaUtils.isEmpty(value))
			  return;
			String[] values=value.split(",");
			int size=values.length/2;
			for(int i=this.getDocgrd().fullSize();i<size;i++)
			  this.getDocgrd().add();
			for(int i=0;i<size;i++)
			{
			  this.getDocgrd().getElement(i).setDoctyp(values[i*2]);
			  
			  this.getDocgrd().getElement(i).setDocnum(values[i*2+1]);
			  
			}
			
			
			
		}









        public void setOthdocHolder(FieldHolder<String> othdoc)
        {
           this.othdoc = (othdoc);
        }

        public void setOthdoc(String othdoc)
        {
            this.othdoc.setValue(othdoc);
        }

        public String getOthdoc()
        {
            return this.othdoc.getValue();
        }

}