package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Docp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Docp.class);

        //面函类型
        private String doctyp;

        //保存
        private transient IControl sav = new ControlImpl("sav", "保存", this);

        //暂存
        private transient IControl ped = new ControlImpl("ped", "暂存", this);

        //面函
        private transient IControl schedule = new ControlImpl("schedule", "面函", this);

        //申请书
        private transient IControl apldoc = new ControlImpl("apldoc", "申请书", this);

        //本通知基本内容
        private String advinf;

        //往来报文信息
        private String swiftinf;


        @JsonIgnore
        @BDGetter
        private transient IPanel docp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel btn;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Docgrp> docgrp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp isbp;


		public Docp()
        {
            super();
            setArgument();
        }

        public Docp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getBenp().setPtsptaHolder(()->this.getDocgrp().getBen());
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("doc"));
            this.getIsbp().setPtsptaHolder(()->this.getDocgrp().getIsb());
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("doc"));
        }





        public void setDocgrpHolder(ModuleHolder<Docgrp> docgrp)
        {
           this.docgrp = docgrp;
        }

        public Docgrp getDocgrp()
        {
           return this.docgrp.get();
        }



















}