package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 发送邮件工作流
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Emlsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Emlsvr.class);

        //bakstm
        private IStream bakstm = new StreamImpl();



	    @BDGetter
		private Smh smh;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Spt> spt;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Msg> msg;


		public Emlsvr()
        {
            super();
            setArgument();
        }

        public Emlsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:emlsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//EML
			if(MdaUtils.isEmpty(this.getSpt().getInr()))
			  return Platform.errorHandle(this.getWfe(),"SPT is null");
			String grptyp=this.getSpt().getObjtyp();
			if(MdaUtils.isEmpty(grptyp))
			  return Platform.errorHandle(this.getWfe(),"module is null");
			IModule mod = null;
			if(! ignoreEmailAttach(grptyp))
			{
			  mod=MdaDriver.getModule(this,ctx.getRoot(),"bimenu\\"+grptyp+"grp");
			}
			else
			{
			  int errcod = ctx.getErrorCode();
			  log.debug("{}","errcod = " + errcod );
			  log.debug("{}","获取模块 bimenu失败， ErrorCode = " + errcod) ;
			  mod = MdaDriver.getModule(this,ctx.getRoot(),"xmlmap\\"+grptyp+"grp");
			}
			MdaUtils.clear(mod);
			//String path=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"delete");
			//String filename=Platform.catPath(path,$spt\\inr.getValue()+".bak");
			String filename=ctx.absGet(Sysmod.class).createFilename(this.getSpt().getInr(),"bak");
			if(!MdaUtils.fileExists(filename))
			  return Platform.errorHandle(this.getWfe(),"File is not exists");
			IStream is=this.getBakstm();
			MdaUtils.streamClear(is);
			MdaUtils.streamLoad(is,filename);
			MdaUtils.loadData(mod,is);
			IDatafield inr=MdaDriver.getDatafield(mod,"rec\\inr");
			log.info("{}","Sending email:objtyp="+grptyp+",objinr="+inr.getValue());
			String trnname=this.getSpt().getFrm();
			//
			ctx.getDaoSession().dbRead(this.getMsg(),new Argument<String>("inr",this.getWfe().getSrvtxt()));
			if(ctx.getErrorCode()!=NO_ERROR)
			  return Platform.errorHandle(this.getWfe(),"MSG record not found.");
			String mailValue=this.getMsg().getEml();
			//单一窗口业务
			if("cpd".equals(this.getSpt().getObjtyp()))
			  ctx.getDaoSession().dbRead(ctx.absGet(Bimenu.class).getCpdgrp().getRec(),new Argument<String>("ownref",this.getSpt().getOwnref()));
			if(ctx.getErrorCode()==NO_ERROR && "D".equals(ctx.absGet(Bimenu.class).getCpdgrp().getRec().getCpdres()) && MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getCpdgrp().getRec().getNoticeemail()))
			  mailValue=ctx.absGet(Bimenu.class).getCpdgrp().getRec().getNoticeemail();
			log.info("{}","mailaddress="+mailValue);
			if(MdaUtils.isEmpty(mailValue))
			  return Platform.errorHandle(this.getWfe(),"Email setting is empty.");
			String[] mailadrs=mailValue.split("[,;]");
			List<String> attachs=new ArrayList<String>();
			//
			String date=MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String apath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/backup/arc/"+date);
			//apath=Platform.catPath(apath,date);
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			String pdfpath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade/pdf");
			if(!MdaUtils.fileExists(pdfpath))
			  MdaUtils.fileMkdirs(pdfpath);
			//
			if(!MdaUtils.isEmpty(this.getWfe().getTxt()))
			{
			  ctx.getDaoSession().dbRead(this.getSmh(),new Argument<String>("inr",this.getWfe().getTxt()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    // 跨境汇款业务相关的通知，邮件内容不包含附件信息
			    String objtyp = this.getSmh().getObjtyp();
			    if(! ignoreEmailAttach(objtyp))
			    {
			      log.debug("{}","in  ignoreEmailAttach ");
			      if(!MdaUtils.isEmpty(this.getSmh().getSf2fil()))
			      {
			        String swname=this.getSmh().getSf2fil();
			        log.info("{}","sw2 file="+swname);
			        String[] swfiles=swname.split(";");
			        for(String file:swfiles)
			        {
			          if(file.endsWith(".sw2"))
			          {
			            String swfile=sw2Pdf(apath,file,pdfpath,file.substring(0,file.indexOf(".")),cfgpath,trnname);
			            log.info("{}","sw2 attachments="+swfile);
			            log.info("{}",MdaUtils.catPath(pdfpath,swfile));
			            if(MdaUtils.fileExists(MdaUtils.catPath(pdfpath,swfile)))
			              attachs.add(swfile);
			          }
			          else if(file.endsWith(".pdf"))
			          {
			            String pdffilename= MdaUtils.catPath(apath,file);
			            if(MdaUtils.fileExists(pdffilename))
			            {
			              MdaUtils.fileCopy(pdffilename,MdaUtils.catPath(pdfpath,file));
			              attachs.add(file);
			            }
			          }
			        }
			      }
			      if(!MdaUtils.isEmpty(this.getSmh().getXmlfil()))
			      {
			        //attachs.add($smh\\xmlfil.getValue());
			        String str=this.getSmh().getXmlfil();
			        String[] files = str.split(";");
			        for(String file:files)
			        {
			          String xmlname=null;
			          if(file.indexOf(",")>0)
			          {
			            xmlname = file.substring(0,file.indexOf(","));
			          }
			          else
			            xmlname = file;
			          String pdfname=attaches2Pdf(apath,xmlname,pdfpath,xmlname.substring(0,file.indexOf("."))+".pdf",cfgpath);
			          log.info("{}","the pdf file name="+pdfname);
			          attachs.add(pdfname);
			        }
			      }
			    }
			  }
			}

			if(ctx.absGet(Sysmod.class).sendMail(mailadrs,attachs.toArray(new String[]{}),pdfpath,this.getMsg().getFrm()))
			{
			  ctx.getDaoSession().dbBegin();
			  this.getWfe().setSta("D");
			  ctx.getDaoSession().dbUpdate(this.getWfe());
			  ctx.getDaoSession().dbCommit();
			  MdaUtils.clear(mod);
			  for(String afile:attachs)
			  {
			    if(!MdaUtils.isEmpty(afile))
			    {
			      String attfile=MdaUtils.catPath(pdfpath,afile);
			      if(MdaUtils.fileExists(attfile))
			      {
			        MdaUtils.fileDelete(attfile);
			      }
			    }
			  }
			  return true;
			}
			return Platform.errorHandle(this.getWfe(),"Call send mail error.");
		}
        /**
        *   source:emlsvr.@0002.script
        */
        public String attaches2Pdf(String apath,String aname,String pdfpath,String pdfname,String cfgpath)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  @@apath:attaches path
			  @@aname:attaches name
			  @@pafpath:the pdf file path after genetated
			  @@afgpath:the config file path
			  */
			MdaUtils.invoke("com.brilliance.doc.DocPacker","createXmlPdfFile",pdfpath,pdfname,apath,aname,cfgpath,"","");
			/*
			  createXmlPdfFile(String pdfpath,String pdfname,String xmlpath, String xmlfileName, String configPath, String logoPath,String signfileName)
			  */
			if(MdaUtils.fileExists(MdaUtils.catPath(pdfpath,pdfname)))
			  return pdfname;
			else return null;
		}
        /**
        *   source:emlsvr.@0003.script
        */
        public String sw2Pdf(String swpath,String swname,String pdfpath,String pdfname,String cfgpath,String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  @@apath:attaches path
			  @@aname:attaches name
			  @@pafpath:the pdf file path after genetated
			  @@afgpath:the config file path
			  */
			String waterfile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			Map<String,String[]> map  = (Map<String,String[]>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",swpath,swname);
			//
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","createTcoPdfFile",map,trnname,waterfile,pdfpath,pdfname);
			/*
			  createXmlPdfFile(String pdfpath,String pdfname,String xmlpath, String xmlfileName, String configPath, String logoPath,String signfileName)
			  */
			log.info("{}","pdfpath="+pdfpath);
			log.info("{}","pdfname="+pdfname);
			if(!pdfname.endsWith(".pdf"))
			  pdfname=pdfname+".pdf";
			//if(Platform.fileExists(Platform.catPath(pdfpath,pdfname)))
			return pdfname;
			//else return null;
					}
        /**
        *   source:emlsvr.@0004.script
        */
        public boolean ignoreEmailAttach(String grptyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean ignore = false ;
			if(!MdaUtils.isEmpty(grptyp) && ("rpd".equals(grptyp) || "ers".equals(grptyp)) )
			{
			  ignore = true ;
			}
			return ignore;
		}



        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setSptHolder(ModuleHolder<Spt> spt)
        {
           this.spt = spt;
        }

        public Spt getSpt()
        {
           return this.spt.get();
        }

        public void setMsgHolder(ModuleHolder<Msg> msg)
        {
           this.msg = msg;
        }

        public Msg getMsg()
        {
           return this.msg.get();
        }



}