package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Modlst;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Epc;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Eptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Eptp.class);

        //Excel导出
        private IStream dowexc = new StreamImpl();

        //修改
        private transient IControl editep = new ControlImpl("editep", "修改", this);

        //下一步
        private transient IControl nxt = new ControlImpl("nxt", "下一步", this);

        //全部开通
        private transient IControl allopn = new ControlImpl("allopn", "全部开通", this);

        //全部关闭
        private transient IControl allcls = new ControlImpl("allcls", "全部关闭", this);

        //搜索
        private transient IControl selusr = new ControlImpl("selusr", "搜索", this);

        //交易开通标志
        private String trnopnflg;

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //核心编号
        private String cid;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //提交
        private transient IControl sav = new ControlImpl("sav", "提交", this);

        //是否关户
        private String clsflg;

        //归属机构
        private String ptynam;


        @JsonIgnore
        @BDGetter
        private transient IPanel cltsel;

        @JsonIgnore
        @BDGetter
        private transient IPanel addmdf;

        @JsonIgnore
        @BDGetter
        private transient IPanel apltra;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Epdgrp> epdgrp;

		@BDGetter
		private ModuleList<Epc> epclst;

	    @BDGetter
		private Epc tmp;

		@BDGetter
		private ModuleList<Epc> alllst;

		@BDGetter
		private ModuleList<Modlst> modlst;


		public Eptp()
        {
            super();
            setArgument();
        }

        public Eptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:eptp.@0000.script
        */
        public void getAvailableTrnList(String cid, String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// Load  transaction list
			// 初始化客户已经配置的  EPC记录
			MdaUtils.clear(this.getAlllst());
			ctx.getDaoSession().dbReadset(this.getAlllst(),new Argument("cid", cid ),new Argument("ptybch",bchcod));
			log.debug("{}","alllst:" + this.getAlllst().fullSize() );
			for(int k=0;k<this.getAlllst().fullSize();k++)
			{
			  String  flg = this.getAlllst().getElement(k).getTrnopnflg();
			  if("O".equals(flg))
			  {
			    this.getAlllst().getElement(k).setTrnopnflg(NULLSTR);
			  }

			}

			// 初始化客户开通的所有交易 -- TODO 此处需要优化 -未和企业交易开通关联查询
			String ptytyp = "" ;
			if("S".equals(this.getEpdgrp().getRec().getTyp()))
			  ptytyp="1";
			else if("Q".equals(this.getEpdgrp().getRec().getTyp()))
			{
			  ptytyp="2";
			}
			MdaUtils.clear(this.getModlst());
			ctx.getDaoSession().dbReadset(this.getModlst(),new Argument("modtyp","0"),new Argument("ptytyp", ptytyp));
			ArrayList<String> newTrans = new ArrayList<String>();
			for(int i =0 ;i < this.getModlst().fullSize();i++)
			{
			  String frm = this.getModlst().getElement(i).getFrm();
			  String nam = this.getModlst().getElement(i).getNam();
			  log.debug("{}","modlst["+i+"] frm= " + frm + ",nam=" + nam ) ;
			  boolean find = false ;
			  for (int j=0 ; j< this.getAlllst().fullSize(); j++)
			  {
			    String trncod= this.getAlllst().getElement(j).getTrncod();
			    log.debug("{}","trncod=" +trncod +",modlst.frm=" + frm) ;
			    if(!MdaUtils.isEmpty(frm) && !MdaUtils.isEmpty(trncod)  && frm.equals(trncod))
			    {
			      find = true ;
			      break ;
			    }
			  }
			  if (!find)
			  {
			    newTrans.add( frm  +"|" + nam );
			  }
			}
			for(int k=0;k<this.getAlllst().fullSize();k++)
			{
			  log.debug("{}","alllst["+k+"]: frm =" + this.getAlllst().getElement(k).getTrncod() +",trnnam=" + this.getAlllst().getElement(k).getTrnnam());
			}

			for(int i=0 ; i<newTrans.size();i++)
			{
			  log.debug("{}","newtrans = " + newTrans.get(i)) ;
			  String[] trninf= newTrans.get(i).split("\\|");
			  String frm = trninf[0];
			  String nam =  trninf[1];
			  log.debug("{}","frm["+i+"] :" + frm +"," + nam );
			  Argument<String> cidArg = new Argument<String>("cid", cid);
			  Argument<String> namArg = new Argument<String>("nam", this.getEpdgrp().getRec().getNam());
			  Argument<String> opnflg = new Argument<String>("opnflg", "X");
			  Argument<String> ptybchArg = new Argument<String>("ptybch", bchcod);
			  Argument<String> typ =new Argument<String>("typ", this.getEpdgrp().getRec().getTyp());
			  Argument<String> trnnamArg =new Argument<String>("trnnam",nam);
			  Argument<String> trncodArg =new Argument<String>("trncod",frm);

			  this.getAlllst().add(cidArg,namArg,opnflg,ptybchArg,typ,trnnamArg,trncodArg);
			  log.debug("{}","cid="+ cid +", nam =" + nam );
			}
			log.debug("{}","in getAvailableTrnList：" +" trncod=" + bchcod +", cid =" + cid +", alllst.size ="+ this.getAlllst().size()  );

		}

        public void setEpdgrpHolder(ModuleHolder<Epdgrp> epdgrp)
        {
           this.epdgrp = epdgrp;
        }

        public Epdgrp getEpdgrp()
        {
           return this.epdgrp.get();
        }





































}