package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ersmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ersmod.class);

        //Branch Extkey
        @Module(getter = false, setter = false)
		private FieldHolder<String> bchcod = new FieldConstantHolder<>("");


        //Create Date
        @Module(getter = false, setter = false)
		private FieldHolder<Date> credat = new FieldConstantHolder<>();


        //交易参考号
        @Module(getter = false, setter = false)
		private FieldHolder<String> ownref = new FieldConstantHolder<>("");


        //Object Type of Associated Contract (Optional)
        @Module(getter = false, setter = false)
		private FieldHolder<String> objtyp = new FieldConstantHolder<>("");


        //Object INR of Associated Contract (Optional)
        @Module(getter = false, setter = false)
		private FieldHolder<String> objinr = new FieldConstantHolder<>("");


        //报文类型
        @Module(getter = false, setter = false)
		private FieldHolder<String> msgtyp = new FieldConstantHolder<>("");


        //回执状态
        @Module(getter = false, setter = false)
		private FieldHolder<String> recsta = new FieldConstantHolder<>("");


        //备注
        @Module(getter = false, setter = false)
		private FieldHolder<String> inftxt = new FieldConstantHolder<>("");


        //报文属性
        @Module(getter = false, setter = false)
		private FieldHolder<String> msgatt = new FieldConstantHolder<>("");


        //TRN INR
        @Module(getter = false, setter = false)
		private FieldHolder<String> trninr = new FieldConstantHolder<>("");


        //Direction ('>'=Outgoing, '<'/'['=Incoming)
        @Module(getter = false, setter = false)
		private FieldHolder<String> dir = new FieldConstantHolder<>("");


        //所属机构客户编号
        @Module(getter = false, setter = false)
		private FieldHolder<String> ptyinr = new FieldConstantHolder<>("");


        //代理行账号
        @Module(getter = false, setter = false)
		private FieldHolder<String> agtact = new FieldConstantHolder<>("");


        //业务编号前缀
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefix = new FieldConstantHolder<>("");


        //代理行行号
        @Module(getter = false, setter = false)
		private FieldHolder<String> agtextkey = new FieldConstantHolder<>("");


        //实体主键
        @Module(getter = false, setter = false)
		private FieldHolder<String> etyinr = new FieldConstantHolder<>("");


        //币种
        @Module(getter = false, setter = false)
		private FieldHolder<String> cur = new FieldConstantHolder<>("");


        //金额
        @Module(getter = false, setter = false)
		private FieldHolder<BigDecimal> amt = new FieldConstantHolder<>();




	    @BDGetter
		private Ers ers;


		public Ersmod()
        {
            super();
            setArgument();
        }

        public Ersmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ersmod.@0000.script
        */
        public boolean ersSetFromContract()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//IDatafield ownref=Platform.getDatafield($rec,"ownref");
			//log.inr.getValue();
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  log.info("{}","load the back ers ,trninr="+ctx.absGet(Sysmod.class).getSpt().getScrtxt());
			  ctx.getDaoSession().dbRead(this.getErs(),new Argument<String>("trninr",ctx.absGet(Sysmod.class).getSpt().getScrtxt()));
			}
			this.getErs().setBchcod(this.getBchcod());
			this.getErs().setCredat(this.getCredat());
			this.getErs().setOwnref(this.getOwnref());
			this.getErs().setObjtyp(this.getObjtyp());
			this.getErs().setObjinr(this.getObjinr());
			this.getErs().setMsgtyp(this.getMsgtyp());
			this.getErs().setCur(this.getCur());
			this.getErs().setAmt(this.getAmt());
			if(">".equals(this.getDir()))
			{
			  this.getErs().setHnglbh(ctx.absGet(Sysmod.class).getErsHNGLBH(this.getPrefix(),this.getBchcod()));
			}
			this.getErs().setRecsta(this.getRecsta());
			this.getErs().setInftxt(this.getInftxt());
			this.getErs().setMsgatt(this.getMsgatt());
			this.getErs().setTrninr(this.getTrninr());
			this.getErs().setDir(this.getDir());
			this.getErs().setPtyinr(this.getPtyinr());
			this.getErs().setAgtact(this.getAgtact());
			this.getErs().setAgtextkey(this.getAgtextkey());
			this.getErs().setEtyinr(this.getEtyinr());
			if(!ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			{
			  this.getErs().setInr(Platform.sdbCounter("ers"));
			  ctx.getDaoSession().dbInsert(this.getErs());
			}
			else
			{
			  ctx.getDaoSession().dbUpdate(this.getErs());
			}
			log.info("{}","out ersSetFromContract");
			return true;
		}





        public void setBchcodHolder(FieldHolder<String> bchcod)
        {
           this.bchcod = (bchcod);
        }

        public void setBchcod(String bchcod)
        {
            this.bchcod.setValue(bchcod);
        }

        public String getBchcod()
        {
            return this.bchcod.getValue();
        }



        public void setCredatHolder(FieldHolder<Date> credat)
        {
           this.credat = (credat);
        }

        public void setCredat(Date credat)
        {
            this.credat.setValue(credat);
        }

        public Date getCredat()
        {
            return this.credat.getValue();
        }



        public void setOwnrefHolder(FieldHolder<String> ownref)
        {
           this.ownref = (ownref);
        }

        public void setOwnref(String ownref)
        {
            this.ownref.setValue(ownref);
        }

        public String getOwnref()
        {
            return this.ownref.getValue();
        }



        public void setObjtypHolder(FieldHolder<String> objtyp)
        {
           this.objtyp = (objtyp);
        }

        public void setObjtyp(String objtyp)
        {
            this.objtyp.setValue(objtyp);
        }

        public String getObjtyp()
        {
            return this.objtyp.getValue();
        }



        public void setObjinrHolder(FieldHolder<String> objinr)
        {
           this.objinr = (objinr);
        }

        public void setObjinr(String objinr)
        {
            this.objinr.setValue(objinr);
        }

        public String getObjinr()
        {
            return this.objinr.getValue();
        }



        public void setMsgtypHolder(FieldHolder<String> msgtyp)
        {
           this.msgtyp = (msgtyp);
        }

        public void setMsgtyp(String msgtyp)
        {
            this.msgtyp.setValue(msgtyp);
        }

        public String getMsgtyp()
        {
            return this.msgtyp.getValue();
        }



        public void setRecstaHolder(FieldHolder<String> recsta)
        {
           this.recsta = (recsta);
        }

        public void setRecsta(String recsta)
        {
            this.recsta.setValue(recsta);
        }

        public String getRecsta()
        {
            return this.recsta.getValue();
        }



        public void setInftxtHolder(FieldHolder<String> inftxt)
        {
           this.inftxt = (inftxt);
        }

        public void setInftxt(String inftxt)
        {
            this.inftxt.setValue(inftxt);
        }

        public String getInftxt()
        {
            return this.inftxt.getValue();
        }



        public void setMsgattHolder(FieldHolder<String> msgatt)
        {
           this.msgatt = (msgatt);
        }

        public void setMsgatt(String msgatt)
        {
            this.msgatt.setValue(msgatt);
        }

        public String getMsgatt()
        {
            return this.msgatt.getValue();
        }



        public void setTrninrHolder(FieldHolder<String> trninr)
        {
           this.trninr = (trninr);
        }

        public void setTrninr(String trninr)
        {
            this.trninr.setValue(trninr);
        }

        public String getTrninr()
        {
            return this.trninr.getValue();
        }



        public void setDirHolder(FieldHolder<String> dir)
        {
           this.dir = (dir);
        }

        public void setDir(String dir)
        {
            this.dir.setValue(dir);
        }

        public String getDir()
        {
            return this.dir.getValue();
        }



        public void setPtyinrHolder(FieldHolder<String> ptyinr)
        {
           this.ptyinr = (ptyinr);
        }

        public void setPtyinr(String ptyinr)
        {
            this.ptyinr.setValue(ptyinr);
        }

        public String getPtyinr()
        {
            return this.ptyinr.getValue();
        }



        public void setAgtactHolder(FieldHolder<String> agtact)
        {
           this.agtact = (agtact);
        }

        public void setAgtact(String agtact)
        {
            this.agtact.setValue(agtact);
        }

        public String getAgtact()
        {
            return this.agtact.getValue();
        }



        public void setPrefixHolder(FieldHolder<String> prefix)
        {
           this.prefix = (prefix);
        }

        public void setPrefix(String prefix)
        {
            this.prefix.setValue(prefix);
        }

        public String getPrefix()
        {
            return this.prefix.getValue();
        }



        public void setAgtextkeyHolder(FieldHolder<String> agtextkey)
        {
           this.agtextkey = (agtextkey);
        }

        public void setAgtextkey(String agtextkey)
        {
            this.agtextkey.setValue(agtextkey);
        }

        public String getAgtextkey()
        {
            return this.agtextkey.getValue();
        }



        public void setEtyinrHolder(FieldHolder<String> etyinr)
        {
           this.etyinr = (etyinr);
        }

        public void setEtyinr(String etyinr)
        {
            this.etyinr.setValue(etyinr);
        }

        public String getEtyinr()
        {
            return this.etyinr.getValue();
        }



        public void setCurHolder(FieldHolder<String> cur)
        {
           this.cur = (cur);
        }

        public void setCur(String cur)
        {
            this.cur.setValue(cur);
        }

        public String getCur()
        {
            return this.cur.getValue();
        }



        public void setAmtHolder(FieldHolder<BigDecimal> amt)
        {
           this.amt = (amt);
        }

        public void setAmt(BigDecimal amt)
        {
            this.amt.setValue(amt);
        }

        public BigDecimal getAmt()
        {
            return this.amt.getValue();
        }

}