package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ersp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ersp.class);

        //创建日期
        private Date credat;

        //截止日期
        private Date enddat;

        //来往报
        private String dir;

        //报文类型
        private String msgtyp;

        //报文状态
        private String recsta;

        //收报行代码
        private String recbnkcod;

        //行内关联编号
        private String hnglbh;

        //相关参考号
        private String relref;

        //业务编号
        private String ownref;

        //搜索
        private transient IControl sel = new ControlImpl("sel", "搜索", this);

        //发起查询
        private transient IControl dosrch = new ControlImpl("dosrch", "发起查询", this);

        //发起答复
        private transient IControl doans = new ControlImpl("doans", "发起答复", this);

        //显示报文
        private transient IControl detmsg = new ControlImpl("detmsg", "显示报文", this);

        //退出
        private transient IControl exi = new ControlImpl("exi", "退出", this);

        //自由格式
        private transient IControl dofree = new ControlImpl("dofree", "自由格式", this);

        //Branch Extkey
        private String bchcod;

        //事务类型
        private String mattyp;


        @JsonIgnore
        @BDGetter
        private transient IPanel msg;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgshw;

        @JsonIgnore
        @BDGetter
        private transient IPanel ersshw;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ers> ers;

		@BDGetter
		private ModuleList<Ers> erslst;

	    @BDGetter
		private Ers shw;


		public Ersp()
        {
            super();
            setArgument();
        }

        public Ersp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ersp.@0000.script
        */
        public void sureBtn(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getErslst().fullSize();
			log.info("{}","size of erslst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ersp","CT000035"),MdaUtils.getI18NString("ersp","CT000036"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(this,ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getErslst().getElement(index).getInr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:ersp.@0003.script
        */
        public void showBtn(String grpNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getErslst().fullSize();
			log.info("{}","size of erslst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ersp","CT000064"),MdaUtils.getI18NString("ersp","CT000065"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(this,ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getErslst().getElement(index).getInr()));
			ctx.getErrorCode();
			if(!MdaUtils.isEmpty(grp))
			{
			  MdaUtils.clear(this.getShw());
			  this.getShw().copyValue(grp);
			  ctx.storeData("com.brilliance.ersshw.ref",this.getShw());
			  
			}
		}

        public void setErsHolder(ModuleHolder<Ers> ers)
        {
           this.ers = ers;
        }

        public Ers getErs()
        {
           return this.ers.get();
        }







































}