package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 外汇买卖
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fctp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fctp.class);

        //外汇局核准件标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> chkdocflg = new FieldConstantHolder<>("");


        //申请维护条款展示
        @Module(getter = false, setter = false)
		private FieldHolder<String> fxcls = new FieldConstantHolder<>("");


        //至
        @Module(getter = false, setter = false)
		private FieldHolder<String> to = new FieldConstantHolder<>("");


        //用途 - 进口商品标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> impdflg = new FieldConstantHolder<>("");


        //用途 - 从属费用标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> belgfee = new FieldConstantHolder<>("");


        //用途 - 偿还贷款本息标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> trnits = new FieldConstantHolder<>("");


        //用途 - 其他标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> puroth = new FieldConstantHolder<>("");


        //支付方式 - 信用证标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybylc = new FieldConstantHolder<>("");


        //支付方式 - 信用证号码
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybylcref = new FieldConstantHolder<>("");


        //支付方式 - 托收
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybycol = new FieldConstantHolder<>("");


        //支付方式 - 转入外汇账户
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybyforact = new FieldConstantHolder<>("");


        //支付方式 - 汇款
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybyrem = new FieldConstantHolder<>("");


        //支付方式 - 汇款方式
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybyremtyp = new FieldConstantHolder<>("");


        //支付方式 - 汇款方式其他
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybyremtypoth = new FieldConstantHolder<>("");


        //支付方式 - 其他标志
        @Module(getter = false, setter = false)
		private FieldHolder<String> paybyothflg = new FieldConstantHolder<>("");


        //批文类型
        @Module(getter = false, setter = false)
		private FieldHolder<String> pwtyp = new FieldConstantHolder<>("");


        //外币账户选择按钮
        private transient IControl forbut = new ControlImpl("forbut", "外币账户选择按钮", this);

        //人民币账户选择按钮
        private transient IControl rmbbut = new ControlImpl("rmbbut", "人民币账户选择按钮", this);

        //确认
        private transient IControl sursel = new ControlImpl("sursel", "确认", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //账户选择标记
        private String actchsflg;

        //风险提示声明
        private String risk;

        //下一步
        private transient IControl next = new ControlImpl("next", "下一步", this);

        //我同意
        private String iagree;


        @JsonIgnore
        @BDGetter
        private transient IPanel fctp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp14;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp15;

        @JsonIgnore
        @BDGetter
        private transient IPanel fctp16;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxsll;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxbuy;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxaplinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxadvinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxcaplinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxcadvinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxdaplinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxdadvinf;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxcaplinfd;

        @JsonIgnore
        @BDGetter
        private transient IPanel fxcadvinfd;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel riskstatement;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Fcdgrp> fcdgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

	    @BDGetter
		private Txmmod aplcnd;

		@BDGetter
		private ModuleList<Act> actlst;


		public Fctp()
        {
            super();
            setArgument();
        }

        public Fctp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getFcdgrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("fcd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getDapp().setPtsptaHolder(()->this.getFcdgrp().getDap());
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("fcd"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getTrpp().setPtsptaHolder(()->this.getFcdgrp().getTrp());
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("fcd"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getAplcnd().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getAplcnd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Fctp.this.getFieldPath("fcdgrp.rec.aplcnd");}
 				public void setValue(String arg){Fctp.this.getFcdgrp().getRec().setAplcnd(arg);}
 				public String getValue(){return Fctp.this.getFcdgrp().getRec().getAplcnd();}}
			 );
        }




        /**
        *   source:fctp.@0000.script
        */
        public void popupActchs(String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActchs());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",cur),new Argument<String>("ptyinr",ptyinr));
			
			
		}

        public void setFcdgrpHolder(ModuleHolder<Fcdgrp> fcdgrp)
        {
           this.fcdgrp = fcdgrp;
        }

        public Fcdgrp getFcdgrp()
        {
           return this.fcdgrp.get();
        }













        public void setChkdocflgHolder(FieldHolder<String> chkdocflg)
        {
           this.chkdocflg = (chkdocflg);
        }

        public void setChkdocflg(String chkdocflg)
        {
            this.chkdocflg.setValue(chkdocflg);
        }

        public String getChkdocflg()
        {
            return this.chkdocflg.getValue();
        }



        public void setFxclsHolder(FieldHolder<String> fxcls)
        {
           this.fxcls = (fxcls);
        }

        public void setFxcls(String fxcls)
        {
            this.fxcls.setValue(fxcls);
        }

        public String getFxcls()
        {
            return this.fxcls.getValue();
        }



        public void setToHolder(FieldHolder<String> to)
        {
           this.to = (to);
        }

        public void setTo(String to)
        {
            this.to.setValue(to);
        }

        public String getTo()
        {
            return this.to.getValue();
        }



        public void setImpdflgHolder(FieldHolder<String> impdflg)
        {
           this.impdflg = (impdflg);
        }

        public void setImpdflg(String impdflg)
        {
            this.impdflg.setValue(impdflg);
        }

        public String getImpdflg()
        {
            return this.impdflg.getValue();
        }



        public void setBelgfeeHolder(FieldHolder<String> belgfee)
        {
           this.belgfee = (belgfee);
        }

        public void setBelgfee(String belgfee)
        {
            this.belgfee.setValue(belgfee);
        }

        public String getBelgfee()
        {
            return this.belgfee.getValue();
        }



        public void setTrnitsHolder(FieldHolder<String> trnits)
        {
           this.trnits = (trnits);
        }

        public void setTrnits(String trnits)
        {
            this.trnits.setValue(trnits);
        }

        public String getTrnits()
        {
            return this.trnits.getValue();
        }



        public void setPurothHolder(FieldHolder<String> puroth)
        {
           this.puroth = (puroth);
        }

        public void setPuroth(String puroth)
        {
            this.puroth.setValue(puroth);
        }

        public String getPuroth()
        {
            return this.puroth.getValue();
        }



        public void setPaybylcHolder(FieldHolder<String> paybylc)
        {
           this.paybylc = (paybylc);
        }

        public void setPaybylc(String paybylc)
        {
            this.paybylc.setValue(paybylc);
        }

        public String getPaybylc()
        {
            return this.paybylc.getValue();
        }



        public void setPaybylcrefHolder(FieldHolder<String> paybylcref)
        {
           this.paybylcref = (paybylcref);
        }

        public void setPaybylcref(String paybylcref)
        {
            this.paybylcref.setValue(paybylcref);
        }

        public String getPaybylcref()
        {
            return this.paybylcref.getValue();
        }



        public void setPaybycolHolder(FieldHolder<String> paybycol)
        {
           this.paybycol = (paybycol);
        }

        public void setPaybycol(String paybycol)
        {
            this.paybycol.setValue(paybycol);
        }

        public String getPaybycol()
        {
            return this.paybycol.getValue();
        }



        public void setPaybyforactHolder(FieldHolder<String> paybyforact)
        {
           this.paybyforact = (paybyforact);
        }

        public void setPaybyforact(String paybyforact)
        {
            this.paybyforact.setValue(paybyforact);
        }

        public String getPaybyforact()
        {
            return this.paybyforact.getValue();
        }



        public void setPaybyremHolder(FieldHolder<String> paybyrem)
        {
           this.paybyrem = (paybyrem);
        }

        public void setPaybyrem(String paybyrem)
        {
            this.paybyrem.setValue(paybyrem);
        }

        public String getPaybyrem()
        {
            return this.paybyrem.getValue();
        }



        public void setPaybyremtypHolder(FieldHolder<String> paybyremtyp)
        {
           this.paybyremtyp = (paybyremtyp);
        }

        public void setPaybyremtyp(String paybyremtyp)
        {
            this.paybyremtyp.setValue(paybyremtyp);
        }

        public String getPaybyremtyp()
        {
            return this.paybyremtyp.getValue();
        }



        public void setPaybyremtypothHolder(FieldHolder<String> paybyremtypoth)
        {
           this.paybyremtypoth = (paybyremtypoth);
        }

        public void setPaybyremtypoth(String paybyremtypoth)
        {
            this.paybyremtypoth.setValue(paybyremtypoth);
        }

        public String getPaybyremtypoth()
        {
            return this.paybyremtypoth.getValue();
        }



        public void setPaybyothflgHolder(FieldHolder<String> paybyothflg)
        {
           this.paybyothflg = (paybyothflg);
        }

        public void setPaybyothflg(String paybyothflg)
        {
            this.paybyothflg.setValue(paybyothflg);
        }

        public String getPaybyothflg()
        {
            return this.paybyothflg.getValue();
        }



        public void setPwtypHolder(FieldHolder<String> pwtyp)
        {
           this.pwtyp = (pwtyp);
        }

        public void setPwtyp(String pwtyp)
        {
            this.pwtyp.setValue(pwtyp);
        }

        public String getPwtyp()
        {
            return this.pwtyp.getValue();
        }

















}