package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ghm;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Feqtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Feqtp.class);

        //退回更正
        private transient IControl fback = new ControlImpl("fback", "退回更正", this);

        //申请日期起
        private Date sqbegdat;

        //申请日期止
        private Date sqendbat;

        //最迟购汇日期起
        private Date zcghbegdat;

        //最迟购汇日期止
        private Date zcghenddat;

        //查询
        private transient IControl fsearch = new ControlImpl("fsearch", "查询", this);

        //申请状态
        private String applystatus;

        //币种
        private String cur;

        //机构名称
        private String orgname;

        //落地机构
        private String bhname;

        //提交
        private transient IControl submit = new ControlImpl("submit", "提交", this);

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //结汇申请书
        private transient IControl appbook = new ControlImpl("appbook", "结汇申请书", this);

        //机构名称
        private String ptynam;

        //明细查询
        private transient IControl detail = new ControlImpl("detail", "明细查询", this);

        //交易类型
        private String jytyp;

        //搜索
        private transient IControl mxsearch = new ControlImpl("mxsearch", "搜索", this);

        //查看
        private transient IControl view = new ControlImpl("view", "查看", this);

        //额度编号
        private String businessno;

        //返回上一级
        private transient IControl viewback = new ControlImpl("viewback", "返回上一级", this);

        //历史单据
        private transient IControl hisview = new ControlImpl("hisview", "历史单据", this);

        //申请事项
        private String oprtyp;

        //查证
        private transient IControl czview = new ControlImpl("czview", "查证", this);

        //申请类型
        private String bustyp;

        //业务状态
        private String sta;

        //申请方式
        private String applytyp;

        //购汇业务编号
        private String busino;


        @JsonIgnore
        @BDGetter
        private transient IPanel feqtp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel billls;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtp;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtplst;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtpbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtpf;

        @JsonIgnore
        @BDGetter
        private transient IPanel feqtpfm;

        @JsonIgnore
        @BDGetter
        private transient IPanel detaillst;

        @JsonIgnore
        @BDGetter
        private transient IPanel djbviw;

        @JsonIgnore
        @BDGetter
        private transient IPanel jhviw;

        @JsonIgnore
        @BDGetter
        private transient IPanel ghviw;

        @JsonIgnore
        @BDGetter
        private transient IPanel fhviw;

        @JsonIgnore
        @BDGetter
        private transient IPanel billhis;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtsndview;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctacpview;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Feqgrp> feqgrp;

	    @BDGetter
		private Btnmod btnmod;

	    @BDGetter
		private Mtabut mtabut;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Pdfviw pdfviw;

		@BDGetter
		private ModuleList<Ghm> ghmlst;

		@BDGetter
		private ModuleList<His> hislst;


		public Feqtp()
        {
            super();
            setArgument();
        }

        public Feqtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getMtabut().setRecHolder(()->this.getFeqgrp().getRec());
            this.getMtabut().setPrefixHolder(new FieldConstantHolder<>(""));
        }





        public void setFeqgrpHolder(ModuleHolder<Feqgrp> feqgrp)
        {
           this.feqgrp = feqgrp;
        }

        public Feqgrp getFeqgrp()
        {
           return this.feqgrp.get();
        }



































































}