package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Finsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Finsvr.class);



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;


		public Finsvr()
        {
            super();
            setArgument();
        }

        public Finsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:finsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//应检查前手服务是否完成... FIXME
			ctx.getDaoSession().dbBegin();
			this.getWfe().setSta("D");
			ctx.getDaoSession().dbUpdate(this.getWfe());
			//update next step svr state form 'O' to 'W'
			ctx.getDaoSession().dbCommit();
			return true;
		}

        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }

}