package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 融资杂项申请
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fncp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fncp.class);


        @JsonIgnore
        @BDGetter
        private transient IPanel fncp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fncp02;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bpdgrp> bpdgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Txmmod rgtclu;

	    @BDGetter
		private Pdfviw pdfviw;


		public Fncp()
        {
            super();
            setArgument();
        }

        public Fncp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getBpdgrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getDapp().setPtsptaHolder(()->this.getAfdgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bpd"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getRgtclu().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Fncp.this.getFieldPath("afdgrp.rgtclu");}
 				public void setValue(String arg){Fncp.this.getAfdgrp().setRgtclu(arg);}
 				public String getValue(){return Fncp.this.getAfdgrp().getRgtclu();}}
			 );
            this.getRgtclu().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
        }





        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setBpdgrpHolder(ModuleHolder<Bpdgrp> bpdgrp)
        {
           this.bpdgrp = bpdgrp;
        }

        public Bpdgrp getBpdgrp()
        {
           return this.bpdgrp.get();
        }









}