package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Fpd;
import com.ceb.gjjs.mda.bo.Bopcod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fpdgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fpdgrp.class);

        //购汇申请书
        private transient IControl fpdpdf = new ControlImpl("fpdpdf", "购汇申请书", this);

        //获取参号
        private transient IControl fpdref = new ControlImpl("fpdref", "获取参号", this);

        //等值人民币提示
        private String retell;

        //外币币种
        private String cur;

        //外币金额
        private BigDecimal amt = new BigDecimal("0.00");

        //现汇购汇标志
        private String xhghchk;

        //售汇单位主体
        private String shbody;


        @JsonIgnore
        @BDGetter
        private transient IPanel fpdsa;


	    @BDGetter
		private Fpd rec;

	    @BDGetter
		private Adr adr;

	    @BDGetter
		private Pta pta;

		@BDGetter
		private ModuleList<Bopcod> bopcodlst;


		public Fpdgrp()
        {
            super();
            setArgument();
        }

        public Fpdgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:fpdgrp.@0000.script
        */
        @Rule(target="fpdref",order=100)
        public boolean ruleFpdrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield ownref = MdaDriver.getDatafield(this.getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = "FP" + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("FP"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}

			return true;
        }

        /**
        *   source:fpdgrp.@0001.script
        */
        @Rule(target="rec.shbody",order=100)
        public boolean ruleRecShbodyN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($rec\\shbody.getValue())&&!Platform.isEmpty($rec\\xmlx.getValue()))
			  {
			  $rec\\trscno.setValue($rec\\xmlx.getValue().toString()+$rec\\shbody.getValue().toString());
			  }
			  else
			  {
			  Platform.clear($rec\\trscno);
			  }
			  Platform.setModified($rec\\trscno);
			
			  //售汇单位主体  PDF展示转换
			  $shbody.setValue($rec\\shbody.getValue().substring(1));
			  */
			/*
			  if("5".equals($rec\\shbody.getValue()))
			  {
			  Platform.enable($rec\\othcno);
			  Platform.setRequired($rec\\othcno);
			  }
			  else
			  {
			  Platform.disable($rec\\othcno);
			  Platform.setNotRequired($rec\\othcno);
			  }
			  Platform.setModified($rec\\othcno);
			  Platform.setModified($rec\\shbody);
			  */

			return true;
        }

        /**
        *   source:fpdgrp.@0002.script
        */
        @Rule(target="rec.cnnsel",order=100)
        public boolean ruleRecCnnselN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getRec().getCnnsel()))
			{
			  this.getRec().setOutsel(NULLSTR);
			  //$rec\\outcur.setValue("CNY");
			  
			  //Platform.clear($rec\\outamt);
			  getCurValues(this.getCur());
			  
			  
			  this.setRetell("因卖出价变动,折算金额可能存在误差,以最终结果为准,购汇金额："+this.getCur()+" "+this.getAmt()+",卖出价："+this.getRec().getMidrat());

			}
			else
			{
			  this.setRetell(NULLSTR);
			  
			  
			  // $rec\\outcur.setValue($cur.getValue());
			  this.getRec().setOutamt(this.getAmt());
			  
			  this.getRec().setMidrat(new BigDecimal(0));
			}
			this.getRec().setOutcur(this.getCur());

			
			
			
			
			
			

			return true;
        }

        /**
        *   source:fpdgrp.@0003.script
        */
        @Rule(target="rec.outsel",order=100)
        public boolean ruleRecOutselN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getRec().getOutsel()))
			{
			  this.getRec().setCnnsel(NULLSTR);
			  this.setRetell(NULLSTR);
			  
			  
			  this.getRec().setOutcur(this.getCur());
			  this.getRec().setOutamt(this.getAmt());
			  
			  this.getRec().setMidrat(new BigDecimal(0));
			}
			if("cptopn".equals(ctx.getTransName())&&TRUE.equals(this.getXhghchk()))
			{
			  
			}
			
			
			
			
			
			

			return true;
        }

        /**
        *   source:fpdgrp.@0008.script
        */
        @Rule(target="rec.outamt",order=100)
        public boolean ruleRecOutamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getRec().getCnnsel()))
			{
			  BigDecimal amt=this.getAmt();
			  BigDecimal midrat=this.getRec().getMidrat();
			  BigDecimal amt1=amt.multiply(midrat);
			  BigDecimal amt3=new BigDecimal(0.95);
			  BigDecimal amt4=new BigDecimal(1.05);
			  BigDecimal amt2=this.getRec().getOutamt();
			  if(amt2.compareTo(amt1.multiply(amt3))<0 || amt2.compareTo(amt1.multiply(amt4))>0)
			  {
			    if(amt2.compareTo(amt1.multiply(amt3))<0)
			      ctx.setMessage(MdaUtils.getI18NString("fpdgrp","CT000125"),MdaUtils.getI18NString("fpdgrp","CT000126"));
			    else
			    {
			      this.getRec().setOutamt(MdaUtils.parseDecimal(MdaUtils.format(amt1,"#0.00")));
			      ctx.setMessage(MdaUtils.getI18NString("fpdgrp","CT000127"),MdaUtils.getI18NString("fpdgrp","CT000128"));
			    }
			  }
			  
			}

			return true;
        }

        /**
        *   source:fpdgrp.@0010.script
        */
        @Rule(target="rec.trstxt",order=100)
        public boolean ruleRecTrstxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if($rec\\trstxt.getValue().length() > 256)
			  {
			  $rec\\trstxt.setValue($rec\\trstxt.getValue().substring(0,256));
			  Platform.setModified($rec\\trstxt);
			  }*/

			return true;
        }

        /**
        *   source:fpdgrp.@0011.script
        */
        @Rule(target="rec.xmlx",order=100)
        public boolean ruleRecXmlxN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($rec\\xmlx.getValue())&&!Platform.isEmpty($rec\\shbody.getValue()))
			  {
			  $rec\\trscno.setValue($rec\\xmlx.getValue().toString()+$rec\\shbody.getValue().toString());
			  }
			  else
			  {
			  Platform.clear($rec\\trscno);
			  }
			  Platform.setModified($rec\\trscno);
			  */

			return true;
        }


        /**
        *   source:fpdgrp.@0004.script
        */
        @Check(target="rec.outsel",order=100)
        public boolean checkRecOutselN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getOutsel()) && MdaUtils.isEmpty(this.getRec().getCnnsel()))
			{
			  ctx.setFieldError(this,"rec.cnnsel",MdaUtils.getI18NString("fpdgrp","CT000033"));
			  return false;
			}

			return true;
        }

        /**
        *   source:fpdgrp.@0009.script
        */
        @Check(target="rec.trstxt",order=100)
        public boolean checkRecTrstxtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!$\\sysmod.checkMaxTextField($rec\\trstxt,384))
			  {
			  Platform.error($rec\\trstxt,#CT000129);
			  }*/

			return true;
        }

        /**
        *   source:fpdgrp.@0012.script
        */
        @Check(target="rec.ownref",order=100)
        public boolean checkRecOwnrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getRec().getOwnref()))
			{
			  log.info("{}","message555555");
			  //Platform.message(#CT000134,#CT000135);
			  if(!"fpdsll".equals(ctx.getTransName()))
			    ctx.setMessage("E9999","请完成购汇界面的输入！");
			  ctx.setFieldError(this,"rec.ownref",MdaUtils.getI18NString("fpdgrp","CT000136"));
			  return false;
			}

			return true;
        }

        /**
        *   source:fpdgrp.@0019.script
        */
        @Check(target="rec.outamt",order=100)
        public boolean checkRecOutamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.checkIllegalAmt(MdaDriver.getDatafield(this.getRec(),"outamt"));

			return true;
        }


        /**
        *   source:fpdgrp.@0013.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  List<CodetableItem> codeitem1=this.getBopCod("I");
			  MdaUtils.setValues(this.getRec(),"trscno",codeitem1);
			}

			return true;
        }


        /**
        *   source:fpdgrp.@0006.script
        */
        public void setMessage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//初始化售汇界面
			
			if(MdaUtils.isEmpty(this.getRec().getGivnam()))
			  this.getRec().setGivnam(ctx.absGet(Sysmod.class).getPty().getNam());

			if(MdaUtils.isEmpty(this.getRec().getOprnam()))
			  this.getRec().setOprnam(ctx.absGet(Sysmod.class).getUsr().getOprnam());

			if(MdaUtils.isEmpty(this.getRec().getTel()))
			{
			  ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",ctx.absGet(Sysmod.class).getPty().getInr()));
			  ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			  this.getRec().setTel(this.getAdr().getTel());
			}

			
			
			

			if(!TRUE.equals(this.getRec().getCnnsel()))
			{
			  this.getRec().setOutsel("X");
			  
			  this.getRec().setOutcur(this.getCur());
			  this.getRec().setOutamt(this.getAmt());
			  
			  
			  
			}
			if(TRUE.equals(this.getXhghchk()))
			{
			  this.getRec().setOutcur(this.getCur());
			  this.getRec().setOutamt(this.getAmt());
			}
			
			

			this.getRec().setCredat(MdaUtils.today());
			if(!MdaUtils.isEmpty(this.getRec().getCredat()))
			{
			  
			  
			}

			this.getRec().setOthcno(ctx.absGet(Sysmod.class).getPty().getAtccod());
			
			//Platform.disable($rec\\trscno);
			
			/*
			  if("5".equals($rec\\shbody.getValue()))
			  {
			  Platform.enable($rec\\othcno);
			  Platform.setRequired($rec\\othcno);
			  }
			  else
			  {
			  Platform.disable($rec\\othcno);
			  Platform.setNotRequired($rec\\othcno);
			  }
			  Platform.setModified($rec\\othcno);
			  Platform.setModified($rec\\shbody);
			  */
		}
        /**
        *   source:fpdgrp.@0007.script
        */
        public void getCurValues(String cur )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String cls="com.brilliance.eibs.main.Client";
			BigDecimal  midrat = new BigDecimal(0);

			Object rtnVal = MdaUtils.invoke(cls,"scall","getcurHL","getcurHL",new Object[]{cur});    // 判断接口是否调用成功
			if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			{
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");
			  if("900000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("fpdgrp","CT000077"),MdaUtils.getI18NString("fpdgrp","CT000078"));
			  }
			  else if("999999".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("fpdgrp","CT000079"),MdaUtils.getI18NString("fpdgrp","CT000080"));
			  }
			  else
			  {
			    Object objm = retMsg.get("midrat");
			    midrat = (BigDecimal)objm;
			  }
			}
			else
			{
			  //提示调用错误
			  ctx.setMessage(MdaUtils.getI18NString("fpdgrp","CT000091"),MdaUtils.getI18NString("fpdgrp","CT000092"));
			}
			this.getRec().setMidrat(midrat);

			BigDecimal amt=this.getAmt();
			//BigDecimal amt=$rec\\outamt.getValue();
			//double amt=$amt.getValue().doubleValue();
			//double rat=Double.parseDouble(midrat);
			//String outamt=String.valueOf(amts);
			BigDecimal outamt=amt.multiply(midrat);
			this.getRec().setOutamt(MdaUtils.parseDecimal(MdaUtils.format(outamt,"#0.00")));
		}
        /**
        *   source:fpdgrp.@0014.script
        */
        public List<CodetableItem> getBopCod(String direction)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//交易编码下拉
			List<CodetableItem> items = new ArrayList<CodetableItem>();
			ctx.getDaoSession().dbReadset(this.getBopcodlst(),new Argument("dir","I"));
			for(int i = 0; i < this.getBopcodlst().size(); i++ )
			{
			  CodetableItem c = new CodetableItem(this.getBopcodlst().getElement(i).getCod().trim() + "-" + this.getBopcodlst().getElement(i).getTxt().trim(),this.getBopcodlst().getElement(i).getCod().trim());
			  items.add(c);
			}
			return items;
		}
        /**
        *   source:fpdgrp.@0016.script
        */
        public void checkAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = field.getValue();
			int num = amt.signum();
			if(num<0)
			{
			  MdaUtils.clear(field);
			  
			  ctx.setFieldError(field,MdaUtils.getI18NString("fpdgrp","CT000137"));
			  return;
			}
		}
        /**
        *   source:fpdgrp.@0017.script
        */
        public boolean checkIllegalAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（17，2）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,2})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  amt = field.getValue().toString();
			  bool = amt.matches(str);
			}
			return bool;
		}























}