package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Shd;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fqtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fqtp.class);

        //保存
        private transient IControl save = new ControlImpl("save", "保存", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel feqpnl;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Feqgrp> feqgrp;

		@BDGetter
		private ModuleList<Shd> shlst;


		public Fqtp()
        {
            super();
            setArgument();
        }

        public Fqtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:fqtp.@0002.script
        */
        @Rule(target="save",order=30)
        public boolean ruleSaveN30(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","order30......开始");
			//给接口传入网银影像guid，由接口去进行判断并插入tblbil表
			//$feqgrp\\rec\\guid
			String guid=this.getFeqgrp().getRec().getGuid();
			String objtyp = MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec());
			String ownref = this.getFeqgrp().getRec().getBusinessno();
			log.debug("{}","ownref="+  ownref );
			String imgref = ownref;
			//img表保存
			String uuidtoken = UUID.randomUUID().toString().replace("-", "").toUpperCase();
			String logname=ctx.absGet(Sysmod.class).getUsr().getLgnnam();
			MdaUtils.clear(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg());
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg(),new Argument("imgref",imgref ),new Argument("ownref",ownref));
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getInr()))
			{
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setOwnref( ownref);
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setImgref( imgref);
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setCredat( MdaUtils.today());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setInifrm( ctx.getTransName());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setLgnnam( logname);
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setCnt(1);
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setOptdattim( MdaUtils.today());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setObjtyp( objtyp);
			  //$\\trnmod\\itfmod\\imgmod\\img\\ftysuc.setValue("Z00238");影像来源
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setTrninr(ctx.absGet(Trnmod.class).getTrn().getInr());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setObjinr(ctx.absGet(Trnmod.class).getTrn().getObjinr());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setGuid(uuidtoken);
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().setInr(MdaUtils.format(ctx.getDaoSession().dbCounter("img"),"00000000"));
			  ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			  log.debug("{}","保存影像操作记录成功，img.inr="+ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getInr() +",img.ownref="+ ownref+",img.imgref="+imgref);
			}

			if(!MdaUtils.isEmpty(guid))
			{
			  String cls="com.brilliance.eibs.main.Client";
			  Object rtnVal = MdaUtils.invoke(cls,"scall","ENTMBdownload","ENTMBdownload",new Object[]{ownref,imgref,"1001","GJ01",guid,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp,MdaUtils.format(new Date(),"yyyyMMdd")});
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  Boolean errcod = (Boolean)retMsg.get("issuccess");
			  if(!errcod)
			  {
			    log.error("{}","APP img down error！");
			    ctx.setMessage("E9999","影像下载失败");
			    return false;
			  }
			  log.debug("{}","order30......结束");
			}


			return true;
        }

        /**
        *   source:fqtp.@0003.script
        */
        @Rule(target="save",order=40)
        public boolean ruleSaveN40(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","order40开始............"+ctx.getErrorCode());
			//交易结果
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E9999","数据库异常，请联系管理员！");
			  return false;
			}
			else
			{
			  //购汇额度申请成功
			  ctx.setMessage("00000","购汇额度申请提交成功");
			}
			log.debug("{}","order40结束............");

			return true;
        }

        /**
        *   source:fqtp.@0004.script
        */
        @Rule(target="save",order=20)
        public boolean ruleSaveN20(){
            IContext ctx = MdaEnv.getContext();
            
			  log.debug("{}","order20开始..........");
			  //校验参数，最迟购汇日期
			  String time = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  if(MdaUtils.diff(MdaUtils.parseDate(time,"yyyyMMdd"),this.getFeqgrp().getRec().getZcghdat())>0)
			  {
			    ctx.setMessage("E9999","最迟购汇日期不能小于系统当前时间");
			    return false;
			  }
			  //最迟购汇日期<=单据中的最迟付汇日期中的最大值
			  Date date=MdaUtils.parseDate(time,"yyyyMMdd");
			  for(int i = 0; i < this.getFeqgrp().getShdlst().size(); i++){
			    if(MdaUtils.diff(this.getFeqgrp().getShdlst().getElement(i).getZcfhdat(),date)>0)
			  {
			    date=this.getFeqgrp().getShdlst().getElement(i).getZcfhdat();
			  }
			  else
			  {
			    date=date;
			  }
			}
			if(MdaUtils.diff(this.getFeqgrp().getRec().getZcghdat(),date)>0)
			{
			  ctx.setMessage("E9999","最迟购汇日期不能大于单据信息中最晚的最迟付汇日期");
			  return false;
			}
			//开启事务
			ctx.getDaoSession().dbBegin();
			//非首次提交，查询到trn,ord
			if(!MdaUtils.isEmpty(this.getFeqgrp().getRec().getBusinessno()))
			{
			  MdaUtils.clear(ctx.absGet(Trnmod.class).getTrn());
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getTrn(),new Argument<String>("ownref",this.getFeqgrp().getRec().getBusinessno()));
			  if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrn().getInr()))
			  {
			    ctx.setMessage("E9999","无此业务信息，请核实相关信息");
			    return false;
			  }
			  MdaUtils.clear(ctx.absGet(Trnmod.class).getOrdmod().getOrd());
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getOrdmod().getOrd(),new Argument<String>("objinr",this.getFeqgrp().getRec().getInr()),new Argument<String>("objtyp","shs"));
			  if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr()))
			  {
			    ctx.setMessage("E9999","无此订单信息，请核实相关信息");
			    return false;
			  }
			  ctx.getErrorCode();
			}
			String code=this.getFeqgrp().getRec().getOrgcode();
			//加载pty表,查看银行机构信息
			MdaUtils.clear(this.getFeqgrp().getPty());
			//如果机构是3500，做特殊处理。
			if("3500".equals(code))
			{
			  ctx.getDaoSession().dbRead(this.getFeqgrp().getPty(),new Argument<String>("ptytyp","0"),new Argument<String>("idc",code),new Argument<String>("cid","08350012"));
			}
			else
			{
			  ctx.getDaoSession().dbRead(this.getFeqgrp().getPty(),new Argument<String>("ptytyp","0"),new Argument<String>("idc",code));
			}

			ctx.getErrorCode();
			log.debug("{}","pty表数据"+this.getFeqgrp().getPty().getBrhlvl());
			if(MdaUtils.isEmpty(this.getFeqgrp().getPty().getInr()))
			{
			  ctx.setMessage("E9999","请联系银行工作人员维护机构信息");
			  return false;
			}
			else
			{
			  //brhlvl:机构层级 0：总行  1：分行   2：支行
			  //判读是支行的话：取pntinr。判断是分行的取cid。
			  if("2".equals(this.getFeqgrp().getPty().getBrhlvl()))
			  {
			    this.getFeqgrp().getRec().setBchcod(this.getFeqgrp().getPty().getPntinr());
			  }
			  else
			    //if("1".equals($feqgrp\\pty\\brhlvl.getValue()))支行取pntinr，分行与总行取cid
			  {
			    this.getFeqgrp().getRec().setBchcod(this.getFeqgrp().getPty().getCid());
			  }
			}
			log.debug("{}","bchcod:"+this.getFeqgrp().getRec().getBchcod()+"1111");
			//业务所属机构银行的主键
			this.getFeqgrp().getRec().setOrginr(this.getFeqgrp().getPty().getInr());
			log.debug("{}","orginr数据"+this.getFeqgrp().getRec().getOrginr());
			log.debug("{}","inr数据"+this.getFeqgrp().getPty().getInr());
			//加载pty表,查看企业信息
			MdaUtils.clear(this.getFeqgrp().getPty());
			ctx.getDaoSession().dbRead(this.getFeqgrp().getPty(),new Argument<String>("cid",this.getFeqgrp().getRec().getEcifno()));
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(this.getFeqgrp().getPty().getInr()))
			{
			  //查询客户号，pty表是否存在，不存在存入一条企业数据
			  this.getFeqgrp().getPty().setInr(Platform.sdbCounter("pty"));
			  this.getFeqgrp().getPty().setCid(this.getFeqgrp().getRec().getEcifno());
			  this.getFeqgrp().getPty().setExtkey(this.getFeqgrp().getRec().getEcifno());
			  this.getFeqgrp().getPty().setPtytyp("2");
			  this.getFeqgrp().getPty().setStatus("0");
			  //客户名称（中文或者英文）
			  this.getFeqgrp().getPty().setNam(this.getFeqgrp().getRec().getEcifname());
			  this.getFeqgrp().getPty().setEngnam(this.getFeqgrp().getRec().getEcifname());
			  this.getFeqgrp().getPty().setEtyinr("00000000");
			  ctx.getDaoSession().dbInsert(this.getFeqgrp().getPty());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			}
			//shs
			this.getFeqgrp().getRec().setPtyinr(this.getFeqgrp().getPty().getInr());
			log.info("{}","机构类型:ptytyp=["+this.getFeqgrp().getPty().getPtytyp()+"],机构编号：ptyinr=["+this.getFeqgrp().getRec().getPtyinr()+"]");
			this.getFeqgrp().getRec().setEtyinr("00000000");
			log.debug("{}","order20查询数据开始..........");
			String bnkptyinr =ctx.absGet(Trnmod.class).sdbGetPtyByBchcod( this.getFeqgrp().getRec().getBchcod());
			String bnketyinr=ctx.absGet(Trnmod.class).sdbGetEtyByPtyinr( this.getFeqgrp().getRec().getBchcod());
			String bnketginr=ctx.absGet(Trnmod.class).sdbGetEtg(bnketyinr);
			//结售汇统计代码截取前三位，为交易性质jshno
			String jieshtjno=this.getFeqgrp().getRec().getJieshtjno();
			String jshno=jieshtjno.substring(0,3);
			this.getFeqgrp().getRec().setJshno(jshno);
			//状态
			this.getFeqgrp().getRec().setApplystatus("1");
			//可购汇额度=金额
			this.getFeqgrp().getRec().setCansaleed(this.getFeqgrp().getRec().getPaysum());
			//是否结汇
			this.getFeqgrp().getRec().setJiehsign("0");
			//20230420
			this.getFeqgrp().getRec().setApplytyp("0");
			//是否删除
			this.getFeqgrp().getRec().setDeleted("0");
			//最迟购汇日期（新）=最迟购汇日期
			this.getFeqgrp().getRec().setZcghnewdat(this.getFeqgrp().getRec().getZcghdat());
			//国际收支申报交易编码=国际收支申报交易编码(新)
			this.getFeqgrp().getRec().setGjszsbnewno(this.getFeqgrp().getRec().getGjszsbno());
			//20230420 购汇性质
			this.getFeqgrp().getRec().setSalexzl(this.getFeqgrp().getRec().getSalexz());
			this.getFeqgrp().getRec().setJieshtjnol(this.getFeqgrp().getRec().getJieshtjno());
			this.getFeqgrp().getRec().setWhjnol(this.getFeqgrp().getRec().getWhjno());
			this.getFeqgrp().getRec().setPaytypel(this.getFeqgrp().getRec().getPaytype());
			//ord
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setObjtyp("shs");
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setBchcod(this.getFeqgrp().getRec().getBchcod());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setFrm(ctx.getTransName());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setInidattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setNam("购汇额度申请");
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setStadattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setOptptyinr( bnkptyinr);
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setOptetyinr( bnketyinr);
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setOptetginr( bnketginr);
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setSta("C");
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setPtyinr(this.getFeqgrp().getRec().getPtyinr());
			ctx.absGet(Trnmod.class).getOrdmod().getOrd().setInifrm(ctx.getTransName());
			//trn
			ctx.absGet(Trnmod.class).getTrn().setSta("w");
			//交易创建时间
			ctx.absGet(Trnmod.class).getTrn().setInidattim(MdaUtils.today());
			//币种和金额
			ctx.absGet(Trnmod.class).getTrn().setReloricur(this.getFeqgrp().getRec().getCurrency());
			ctx.absGet(Trnmod.class).getTrn().setReloriamt(this.getFeqgrp().getRec().getPaysum());
			//经办复核流程
			ctx.absGet(Trnmod.class).getTrn().setRelreq("OB");
			ctx.absGet(Trnmod.class).getTrn().setNxtreq("O");
			ctx.absGet(Trnmod.class).getTrn().setRelres("");
			ctx.absGet(Trnmod.class).getTrn().setNxtlev("");
			//交易
			ctx.absGet(Trnmod.class).getTrn().setObjtyp("shs");
			ctx.absGet(Trnmod.class).getTrn().setInifrm(ctx.getTransName());
			//机构
			ctx.absGet(Trnmod.class).getTrn().setBchcod(this.getFeqgrp().getRec().getBchcod());
			ctx.absGet(Trnmod.class).getTrn().setNam(this.getFeqgrp().getRec().getEcifname());
			//业务归属机构主键
			ctx.absGet(Trnmod.class).getTrn().setOptptyinr( bnkptyinr);
			ctx.absGet(Trnmod.class).getTrn().setOptetyinr( bnketyinr);
			ctx.absGet(Trnmod.class).getTrn().setOptetginr( bnketginr);
			//企业客户主键
			ctx.absGet(Trnmod.class).getTrn().setPtyinr(this.getFeqgrp().getRec().getPtyinr());
			ctx.absGet(Trnmod.class).getTrn().setEtyinr(this.getFeqgrp().getRec().getEtyinr());
			//操作流程计数器
			ctx.absGet(Trnmod.class).getTrn().setRelstp(0);
			//0 - 申请类1 - 通知类
			ctx.absGet(Trnmod.class).getTrn().setModtyp("0");
			//交易流水对应机构类型（0银行端 2企业端）
			ctx.absGet(Trnmod.class).getTrn().setPtytyp("0");
			//第一次提交
			if(MdaUtils.isEmpty(this.getFeqgrp().getRec().getBusinessno()))
			{
			  //参考号生成规则
			  String prefix = ctx.absGet(Mtabut.class).getPrefix() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(ctx.absGet(Mtabut.class).getPrefix()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  this.getFeqgrp().getRec().setBusinessno(prefix);
			  //创建时间
			  this.getFeqgrp().getRec().setCredat(MdaUtils.today());
			  log.debug("{}","ownref="+  prefix );
			  //ord,ore,trn,shs的主键生成
			  //ord,ore,trn,shs主键相互的存储关系
			  this.getFeqgrp().getRec().setInr(Platform.sdbCounter("shs"));
			  //ord
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setInr(Platform.sdbCounter("ord"));
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setObjinr( this.getFeqgrp().getRec().getInr());
			  //ore
			  ctx.absGet(Trnmod.class).getOrdmod().getOre().setTxt("订单创建");
			  //trn
			  ctx.absGet(Trnmod.class).getTrn().setInr(Platform.sdbCounter("trn"));
			  //业务表inr
			  ctx.absGet(Trnmod.class).getTrn().setObjinr(this.getFeqgrp().getRec().getInr());
			  //ord主键
			  ctx.absGet(Trnmod.class).getTrn().setOrdinr(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr());
			  //业务参考号
			  ctx.absGet(Trnmod.class).getTrn().setOwnref(this.getFeqgrp().getRec().getBusinessno());
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setDatfilnam( ctx.absGet(Trnmod.class).getTrn().getInr());
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setXmlfilnam(ctx.absGet(Trnmod.class).getTrn().getInr());
			  ctx.getDaoSession().dbInsert(this.getFeqgrp().getRec());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			  ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getOrdmod().getOrd());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			  ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getTrn());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			}
			else
			{
			  //20230420 增加操作历史
			  /*Platform.dbRead($feqgrp\\old,new Argument<String>("inr",$feqgrp\\rec\\inr.getValue()));
			    $feqgrp\\old\\businessno.setValue($feqgrp\\rec\\inr.getValue());
			    $feqgrp\\old\\inr=Platform.sdbCounter("shs");
			    $feqgrp\\old\\upddat.setValue(null);
			    $feqgrp\\old\\applytyp.setValue("0");
			    $feqgrp\\old\\deleted.setValue("1");
			    $feqgrp\\old\\credat.setValue(Platform.today());
			    Platform.dbInsert($feqgrp\\old);
			    if(Platform.errorCode()!= NO_ERROR)
			    {
			    Platform.dbRollback();
			    Platform.message("E9999","数据库处理异常");
			    return false;
			    }*/

			  this.getFeqgrp().getRec().setUpddat(MdaUtils.today());
			  ctx.getDaoSession().dbUpdate(this.getFeqgrp().getRec());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			  //单据信息，修改时原单据信息进行逻辑删除
			  MdaUtils.clear(this.getShlst());
			  ctx.getDaoSession().dbReadset(this.getShlst(),new Argument<String>("edbusno",this.getFeqgrp().getRec().getBusinessno()),new Argument<String>("deleted","0"));
			  ctx.getErrorCode();
			  for(int i=0;i<this.getShlst().fullSize();i++)
			  {
			    /*Platform.clear($feqgrp\\shd);
			      $feqgrp\\shd\\inr=$shlst[i]\\inr;
			      $feqgrp\\shd\\deleted.setValue("1");
			      $feqgrp\\shd\\edbusno.setValue($shlst[i]\\edbusno.getValue());
			      $feqgrp\\shd\\upddat.setValue(Platform.today());
			      $feqgrp\\shd\\billtype.setValue($shlst[i]\\billtype.getValue());
			      $feqgrp\\shd\\billnewno.setValue($shlst[i]\\billnewno.getValue());
			      $feqgrp\\shd\\billno.setValue($shlst[i]\\billno.getValue());
			      $feqgrp\\shd\\billsum.setValue($shlst[i]\\billsum.getValue());
			      $feqgrp\\shd\\zcfhdat.setValue($shlst[i]\\zcfhdat.getValue());
			      $feqgrp\\shd\\zcfhnewdat.setValue($shlst[i]\\zcfhnewdat.getValue());
			      $feqgrp\\shd\\credat.setValue($shlst[i]\\credat.getValue());*/
			    this.getShlst().getElement(i).setDeleted("1");
			    ctx.getDaoSession().dbUpdate(this.getShlst().getElement(i));
			    if(ctx.getErrorCode()!= NO_ERROR)
			    {
			      ctx.getDaoSession().dbRollback();
			      ctx.setMessage("E9999","数据库处理异常");
			      return false;
			    }
			  }
			  //iniusr清空，再次提交
			  ctx.absGet(Trnmod.class).getTrn().setIniusr("");
			  ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			  //ord状态为交易中
			  ctx.absGet(Trnmod.class).getOrdmod().getOrd().setSta("E");
			  ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getOrdmod().getOrd());
			  ctx.absGet(Trnmod.class).getOrdmod().getOre().setTxt("重新提交");
			  if(ctx.getErrorCode()!= NO_ERROR)
			  {
			    ctx.getDaoSession().dbRollback();
			    ctx.setMessage("E9999","数据库处理异常");
			    return false;
			  }
			}
			//插入ore表
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setInr(Platform.sdbCounter("ore"));
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setBegdattim(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getStadattim());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setEnddattim(MdaUtils.today());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setWaitim((long)0);
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setObjtyp("shs");
			//待定
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setAction("11");
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setPtyinr(ctx.absGet(Trnmod.class).getTrn().getPtyinr());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setObjinr(this.getFeqgrp().getRec().getInr());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setOrdinr(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setTyp(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getSta());
			ctx.absGet(Trnmod.class).getOrdmod().getOre().setFrm(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getFrm());
			ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getOrdmod().getOre());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E9999","数据库处理异常");
			  return false;
			}
			//单据信息表
			for(int i = 0; i < this.getFeqgrp().getShdlst().size(); i++){
			  this.getFeqgrp().getShd().setEdbusno(this.getFeqgrp().getRec().getBusinessno());
			//单据信息
			this.getFeqgrp().getShd().setInr(Platform.sdbCounter("shd"));
			this.getFeqgrp().getShd().setBilltype(this.getFeqgrp().getShdlst().getElement(i).getBilltype());
			this.getFeqgrp().getShd().setBillnewno(this.getFeqgrp().getShdlst().getElement(i).getBillno());
			this.getFeqgrp().getShd().setBillno(this.getFeqgrp().getShdlst().getElement(i).getBillno());
			this.getFeqgrp().getShd().setBillsum(this.getFeqgrp().getShdlst().getElement(i).getBillsum());
			this.getFeqgrp().getShd().setZcfhdat(this.getFeqgrp().getShdlst().getElement(i).getZcfhdat());
			this.getFeqgrp().getShd().setZcfhnewdat(this.getFeqgrp().getShdlst().getElement(i).getZcfhdat());
			this.getFeqgrp().getShd().setDeleted("0");
			this.getFeqgrp().getShd().setCredat(MdaUtils.today());
			//20230420
			this.getFeqgrp().getShd().setSerialnum(this.getFeqgrp().getRec().getSerialnum());
			this.getFeqgrp().getShd().setEnterdat(this.getFeqgrp().getRec().getEnterdat());
			ctx.getDaoSession().dbInsert(this.getFeqgrp().getShd());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage("E9999","数据库处理异常");
			  return false;
			}
			log.debug("{}","order20结束..........");
			}

			return true;
        }





        public void setFeqgrpHolder(ModuleHolder<Feqgrp> feqgrp)
        {
           this.feqgrp = feqgrp;
        }

        public Feqgrp getFeqgrp()
        {
           return this.feqgrp.get();
        }





}