package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Modlst;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 交易公共处理模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Frmmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Frmmod.class);



	    @BDGetter
		private Modlst modlst;


		public Frmmod()
        {
            super();
            setArgument();
        }

        public Frmmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:frmmod.@0000.script
        */
        public String sdbGenTrntypSql(String trntyp,String ptytyp,String sql,List objs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：对业务分类查询进行SQL拼接：trntyp：使用trnsort码表进行大类选择
			  *   - ptytyp：关联modlst表的ptytyp
			  */
			if(MdaUtils.isEmpty(trntyp) || "ALL".equals(trntyp))
			{
			  sql = sql + " AND (( ptytyp = ? AND modtyp = '0' ) or modtyp ='1' ) ";
			  objs.add(ptytyp);
			}
			else
			{
			  if("AP".equals(trntyp))
			  {
			    //申请类
			    sql = sql +" AND ptytyp=? AND modtyp = '0' " ;
			    objs.add(ptytyp);
			  }
			  else if("AD".equals(trntyp))
			  {
			    //通知类
			    sql = sql +" AND  modtyp = '1' " ;
			  }
			  else
			  {
			    //业务类型查询
			
			    sql = sql +" AND EXISTS (SELECT inr FROM modlst mod WHERE inifrm = mod.frm AND mod.ptytyp in ( " +ptytyp+ ") AND mod.bus= ? ) ";
			    objs.add(trntyp);
			  }
			}
			return sql ;
		}
        /**
        *   source:frmmod.@0001.script
        */
        public String getOpenedNotification()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 获取已开通通知的交易代码
			  */
			String notcod = "" ;
			String sql="select trncod from tsc where notflg = 'X'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> trncod = new Argument<String> ("trncod");
			List codes = new ArrayList();
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trncod);
			  if(ctx.getErrorCode()==NO_ERROR && !MdaUtils.isEmpty(trncod.getValue()))
			    codes.add("'"+trncod.getValue() + "'");
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			notcod = codes.toString();
			log.info("{}","Notification="+ notcod );
			return notcod.substring(1,notcod.length() - 1) ;
		}



}