package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Fstp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Fstp.class);

        //业务类型
        private String ywlx;

        //合同号
        private String contracttxt;

        //合同查询
        private transient IControl contquery = new ControlImpl("contquery", "合同查询", this);

        //所属落地机构
        private String bchcod;

        //入账账号1
        private String accno1;

        //入账账号2
        private String accno2;

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //申请书
        private transient IControl sqspdf = new ControlImpl("sqspdf", "申请书", this);

        //确认书
        private transient IControl qrspdf = new ControlImpl("qrspdf", "确认书", this);

        //报价表
        private transient IControl bjbpdf = new ControlImpl("bjbpdf", "报价表", this);

        //款项让渡函
        private transient IControl rdhpdf = new ControlImpl("rdhpdf", "款项让渡函", this);

        //常用账户选择
        private transient IControl actselect = new ControlImpl("actselect", "常用账户选择", this);

        //账户取消
        private transient IControl actcancel = new ControlImpl("actcancel", "账户取消", this);

        //账户选择
        private transient IControl actsure = new ControlImpl("actsure", "账户选择", this);

        //客户选择1
        private transient IControl actselect1 = new ControlImpl("actselect1", "客户选择1", this);

        //结汇申请书
        private transient IControl jhsqspdf = new ControlImpl("jhsqspdf", "结汇申请书", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel fftp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftapn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftapn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftapn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftcfm01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel fstmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel sqspan;

        @JsonIgnore
        @BDGetter
        private transient IPanel qrspan;

        @JsonIgnore
        @BDGetter
        private transient IPanel bjbpan;

        @JsonIgnore
        @BDGetter
        private transient IPanel kxrdpan;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftcfm02;

        @JsonIgnore
        @BDGetter
        private transient IPanel actchs;

        @JsonIgnore
        @BDGetter
        private transient IPanel jhsqspan;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftcpn;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Fsdgrp> fsdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bedgrp> bedgrp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp acbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Txmmod rgtclu;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp conp;

	    @BDGetter
		private Ptsp payp;

	    @BDGetter
		private Ptsp accp;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Bummod bummod;

		@BDGetter
		private ModuleList<Act> actlst;


		public Fstp()
        {
            super();
            setArgument();
        }

        public Fstp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getIsbp().setPtsptaHolder(()->this.getFsdgrp().getIsb());
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getAcbp().setPtsptaHolder(()->this.getFsdgrp().getAcb());
            this.getAcbp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getAcbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAcbp().setRolHolder(new FieldConstantHolder<>("acb"));
            this.getDapp().setPtsptaHolder(()->this.getFsdgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getRgtclu().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Fstp.this.getFieldPath("fsdgrp.rec.rgtclu");}
 				public void setValue(String arg){Fstp.this.getFsdgrp().getRec().setRgtclu(arg);}
 				public String getValue(){return Fstp.this.getFsdgrp().getRec().getRgtclu();}}
			 );
            this.getRgtclu().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getAplp().setPtsptaHolder(()->this.getFsdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getConp().setPtsptaHolder(()->this.getFsdgrp().getCon());
            this.getConp().setRolHolder(new FieldConstantHolder<>("con"));
            this.getConp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getConp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getPayp().setPtsptaHolder(()->this.getFsdgrp().getPay());
            this.getPayp().setRolHolder(new FieldConstantHolder<>("pay"));
            this.getPayp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getPayp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAccp().setPtsptaHolder(()->this.getFsdgrp().getAcc());
            this.getAccp().setRolHolder(new FieldConstantHolder<>("acc"));
            this.getAccp().setBelongtoHolder(new FieldConstantHolder<>("fsd"));
            this.getAccp().setFlgHolder(new FieldConstantHolder<>("agt"));
        }

        /**
        *   source:fstp.@0000.script
        */
        @Rule(target="contquery",order=100)
        public boolean ruleContqueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			//合同查询
			String conNo =this.getFsdgrp().getRec().getConref();
			Date conDay =MdaUtils.today();
			String queryClause = " select rec.ownref from fxy rec  where rec.credat　<= ? ";
			if(!MdaUtils.isEmpty(conNo))
			{
			  queryClause=queryClause+ "and rec.ownref like '%"+conNo+"%' ";
			}

			String ptytyp = ctx.absGet(Sysmod.class).getPty().getPtytyp();
			String selSql="";
			if("0".equals(ptytyp))
			{// 兴业机构
			  selSql = " AND rec.etyinr='"+ctx.absGet(Sysmod.class).getEty().getInr()+"'";
			}
			else if("1".equals(ptytyp))
			{// 商行机构
			  selSql = " AND rec.etyinr='"+ctx.absGet(Sysmod.class).getEty().getInr()+"'";
			}
			else if("2".equals(ptytyp))
			{// 本行企业
			  selSql = " AND rec.ptyinr='"+ctx.absGet(Sysmod.class).getPty().getInr()+"'";
			}
			else if("3".equals(ptytyp))
			{// 商行下属企业
			  selSql = " AND rec.ptyinr='"+ctx.absGet(Sysmod.class).getPty().getInr()+"'";
			}
			else
			  selSql="";
			queryClause=queryClause+selSql;
			queryClause=queryClause + " order by rec.inr desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause,MdaUtils.sqlDate(conDay,LT));
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> ownref = new Argument<String>("ownref");

			ctx.getDaoSession().dbFetchFields(ownref);
			ctx.getDaoSession().dbCloseCursor();
			int errorCode = ctx.getErrorCode();
			if(errorCode == NO_ERROR)
			{
			  this.getFsdgrp().getRec().setConref(ownref.getValue());
			  
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("fstp","CT000138"));
			  // Platform.chain("office");
			}


			return true;
        }




        /**
        *   source:fstp.@0002.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getActchs());
			String ptyinr = ctx.absGet(Sysmod.class).getPty().getInr();
			ctx.getDaoSession().dbReadset(this.getActlst(),new Argument<String>("cur",this.getFsdgrp().getRec().getBrkcur()),new Argument<String>("ptyinr",ptyinr));
			
			
		}

        public void setFsdgrpHolder(ModuleHolder<Fsdgrp> fsdgrp)
        {
           this.fsdgrp = fsdgrp;
        }

        public Fsdgrp getFsdgrp()
        {
           return this.fsdgrp.get();
        }

        public void setBedgrpHolder(ModuleHolder<Bedgrp> bedgrp)
        {
           this.bedgrp = bedgrp;
        }

        public Bedgrp getBedgrp()
        {
           return this.bedgrp.get();
        }



























































}