package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Fzgit;
import com.ceb.gjjs.mda.bo.Spb;
import com.ceb.gjjs.mda.bo.Gid;
import com.ceb.gjjs.mda.bo.Gib;
import com.ceb.gjjs.mda.bo.Mar;
import com.ceb.gjjs.mda.bo.Sxb;
import com.ceb.gjjs.mda.bo.Szgit;
import com.ceb.gjjs.mda.bo.Mxd;
import com.ceb.gjjs.mda.bo.Gxd;
import com.ceb.gjjs.mda.bo.Git;
import com.ceb.gjjs.mda.bo.Gitpush;
import com.ceb.gjjs.mda.bo.Bxd;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 保函数据模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gidgrp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Gidgrp.class);

        //typ
        private String typ;

        //我同意
        private String agree;

        //是否签订保证金协议
        private String checked;

        //申请人名称
        private String aplnam;

        //保函申请勾选
        private String baohanchk;

        //协议界面勾选
        private String xieyichk;

        //保证金及扣划界面勾选
        private String bzjchk;

        //影像界面勾选
        private String yxchk;

        //业务提示
        private String tips;

        //是否生成保函保证金质押协议文本
        private String bzjzyxy;

        //是否需要保证金
        private String nedbzj;

        //保函大写金额
        private String dxje;

        //申请人承诺书勾选
        private String bhcnschk;

        //敞口日期
        private String ckrq;

        //保函格式1
        private String chkbhgs1;

        //保函格式2
        private String chkbhgs2;

        //开出方式1
        private String chkkcfs11;

        //开出方式1
        private String chkkcfs12;

        //开出方式2
        private String chkkcfs21;

        //开出方式2
        private String chkkcfs22;

        //开出方式2
        private String chkkcfs23;

        //出具方式1
        private String chkcjfs1;

        //出具方式2
        private String chkcjfs2;

        //保证金条款适用
        private String bzjsy1;

        //保证金条款不适用
        private String bzjbsy1;

        //质押协议适用
        private String zyxysy1;

        //质押协议不适用
        private String zyxybsy1;

        //银行信贷协议适用
        private String yhxdxysy1;

        //银行信贷协议不适用
        private String yhxdxybsy1;

        //质押协议主合同
        private String zht1;

        //质押协议主合同
        private String zht2;

        //质押协议主合同
        private String zht3;

        //原保函正本是否退回
        private String zbth;

        //保函费用承担人
        private String chiclgamefee;

        //保函草稿修改
        private String lgtxtc;

        //保证金大写金额
        private String bzjdxje;

        //保函未出具赔付
        private String wcjdxje;

        //大写日期
        private String dxqi;

        //大写日期
        private String dxzhi;

        //保证金占保函金额比例（大写）
        private String dxbl;

        //保函使用规则
        private String dapprul;

        //保函开立方式2
        private String dopntyp2;

        //保函类型
        private String lgtyp;

        //保函结束日期
        private Date enddat;

        //是否分离式保函
        private String bhxz;

        //保函语种
        private String wbtyp;

        //保函使用规则2
        private String fapprul;

        //保函原本金额
        private BigDecimal bhybje = new BigDecimal("0.00");

        //大写收费费率
        private String dxsffl;

        //海关税款担保保函
        private String hzzsbh;

        //是否生成保函查询码
        private String bhcxsf1;

        //是否生成保函查询码
        private String bhcxsf2;

        //接口测试
        private transient IControl test = new ControlImpl("test", "接口测试", this);

        //落地机构
        private String bchcod;

        //支行审批意见
        private String shenp;

        //保函增减额类型
        private String bhzjetyp;

        //保函增减额
        private BigDecimal bhzje = new BigDecimal("0.00");

        //保函收费账户1
        private String count1;

        //保函收费账户2
        private String count2;

        //包含手续费金额1
        private BigDecimal bhsxamt1 = new BigDecimal("0.00");

        //保函手续费金额2
        private BigDecimal bhsxamt2 = new BigDecimal("0.00");

        //客户号
        private String cid;

        //授信业务类型ztb
        private String type;

        //涉及xx且未完成信贷情况
        private String shiyong;

        //经营单位
        private String jysel;

        //分行部门
        private String fhbmsel;

        //分行领导
        private String fhldsel;

        //客户情况
        private String kehuqk;

        //批复
        private String pifu;

        //信贷
        private String xindai;

        //融资贷款
        private String rzdk;

        //关联企业
        private String glqy;

        //f51批复
        private String f51pf;

        //担保黑名单
        private String dbhmd;

        //借款黑名单
        private String jkhmd;

        //担保灰名单
        private String dbhui;

        //借款预警
        private String jkyj;

        //担保交易
        private String dbyj;



	    @BDGetter
		private Gid rec;

	    @BDGetter
		private Ptspta apl;

	    @BDGetter
		private Ptspta adv;

	    @BDGetter
		private Ptspta ben;

	    @BDGetter
		private Ptspta isb;

	    @BDGetter
		private Ptspta dap;

	    @BDGetter
		private Ptspta trp;

	    @BDGetter
		private Ptspta ctr;

	    @BDGetter
		private Ptspta sec;

	    @BDGetter
		private Git git;

	    @BDGetter
		private Cls trscls;

	    @BDGetter
		private Gxd gxd;

	    @BDGetter
		private Bxd bxd;

	    @BDGetter
		private Mar mar;

		@BDGetter
		private ModuleList<Mxd> mxdlst;

	    @BDGetter
		private Gib gib;

		@BDGetter
		private ModuleList<Gid> gidlst;

	    @BDGetter
		private Fzgit fzgit;

	    @BDGetter
		private Szgit szgit;

	    @BDGetter
		private Spb spb;

	    @BDGetter
		private Gitpush gitpush;

	    @BDGetter
		private Sxb sxb;


		public Gidgrp()
        {
            super();
            setArgument();
        }

        public Gidgrp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }













































































































































































































}