package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Secinf;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ebhfat;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gitp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Gitp.class);

        //落地机构
        private String epsbchcod;

        //落地机构转码表
        private String bchcod;

        //预览保函开立申请PDF
        private transient IControl pdfgid = new ControlImpl("pdfgid", "预览保函开立申请PDF", this);

        //预览保函合同开立PDF
        private transient IControl pdfgxd = new ControlImpl("pdfgxd", "预览保函合同开立PDF", this);

        //预览保证金协议PDF
        private transient IControl pdfbxd = new ControlImpl("pdfbxd", "预览保证金协议PDF", this);

        //预览保证金委托开户及扣划申请PDF
        private transient IControl pdfmar = new ControlImpl("pdfmar", "预览保证金委托开户及扣划申请PDF", this);

        //获取参号
        private transient IControl getref = new ControlImpl("getref", "获取参号", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //单证通影像批次号
        private String dztimgref;

        //保函开立申请PDF
        private transient IControl pdfbhkl = new ControlImpl("pdfbhkl", "保函开立申请PDF", this);

        //保证金质押协议PDF
        private transient IControl pdfzyxy = new ControlImpl("pdfzyxy", "保证金质押协议PDF", this);

        //信贷证明申请PDF
        private transient IControl pdfxdzm = new ControlImpl("pdfxdzm", "信贷证明申请PDF", this);

        //出具信贷证明协议PDF
        private transient IControl pdfxdxy = new ControlImpl("pdfxdxy", "出具信贷证明协议PDF", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //保函修改申请PDF
        private transient IControl pdfbhxg = new ControlImpl("pdfbhxg", "保函修改申请PDF", this);

        //合同对比结果
        private transient IControl compar = new ControlImpl("compar", "合同对比结果", this);

        //保函开立审批表
        private transient IControl pdfbhklspb = new ControlImpl("pdfbhklspb", "保函开立审批表", this);

        //真实性情况表
        private transient IControl pdfzsxqkb = new ControlImpl("pdfzsxqkb", "真实性情况表", this);

        //开立审批表（修改申请）
        private transient IControl gitasminf = new ControlImpl("gitasminf", "开立审批表（修改申请）", this);

        //保函格式文本查看
        private transient IControl stafortxt = new ControlImpl("stafortxt", "保函格式文本查看", this);

        //保函标准格式文本
        private transient IControl stawebtext = new ControlImpl("stawebtext", "保函标准格式文本", this);

        //合作平台格式文本
        private transient IControl gxtwebtxt = new ControlImpl("gxtwebtxt", "合作平台格式文本", this);

        //电子保函文本下载
        private IStream dzbhwb = new StreamImpl();

        //开立真实性表
        private transient IControl gitasreal = new ControlImpl("gitasreal", "开立真实性表", this);

        //贸易金融业务真实性情况表
        private transient IControl gitaztbreal = new ControlImpl("gitaztbreal", "贸易金融业务真实性情况表", this);

        //授信使用审批意见表
        private transient IControl gitaztbspb = new ControlImpl("gitaztbspb", "授信使用审批意见表", this);

        //上传pdf
        private IStream selpdf = new StreamImpl();


        @JsonIgnore
        @BDGetter
        private transient IPanel gitp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn;

        @JsonIgnore
        @BDGetter
        private transient IPanel gxtdav;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapntopbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn08;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn09;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep07;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdlstep06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdltop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gxtdavstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gxtdav01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gxtdavtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitcfmstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitcfmstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitcfmtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapn10;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd07;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst04;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst05;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst06;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst07;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd08;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitame01;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitame02;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapntop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitame03;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnd09;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst09;

        @JsonIgnore
        @BDGetter
        private transient IPanel gibsel;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitosztop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst11;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst12;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp13;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnst13;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitasz2;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitasztop;

        @JsonIgnore
        @BDGetter
        private transient IPanel wbshow;

        @JsonIgnore
        @BDGetter
        private transient IPanel dzbhwbxz;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitshouxin;

        @JsonIgnore
        @BDGetter
        private transient IPanel ztbgitp;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitaszz;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitasz1;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitaztbapp;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitp14;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitaztbtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitasz;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Gidgrp> gidgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp advp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

	    @BDGetter
		private Ptsp ctrp;

	    @BDGetter
		private Ptsp secp;

	    @BDGetter
		private Txmmod rgtclu;

	    @BDGetter
		private Bxdmod bxdmod;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Bummod bummod;

	    @BDGetter
		private Sigtip sigtip;

	    @BDGetter
		private Sztmod sztmod;

	    @BDGetter
		private Agrp agrp;

	    @BDGetter
		private Gsdgrp gsdgrp;

	    @BDGetter
		private Ebhfat ebhfat;

	    @BDGetter
		private Secinf secinf;


		public Gitp()
        {
            super();
            setArgument();
        }

        public Gitp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getGidgrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAdvp().setPtsptaHolder(()->this.getGidgrp().getAdv());
            this.getAdvp().setRolHolder(new FieldConstantHolder<>("adv"));
            this.getAdvp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getAdvp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getBenp().setPtsptaHolder(()->this.getGidgrp().getBen());
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getIsbp().setPtsptaHolder(()->this.getGidgrp().getIsb());
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDapp().setPtsptaHolder(()->this.getGidgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTrpp().setPtsptaHolder(()->this.getGidgrp().getTrp());
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getCtrp().setRolHolder(new FieldConstantHolder<>("ctr"));
            this.getCtrp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getCtrp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getCtrp().setPtsptaHolder(()->this.getGidgrp().getCtr());
            this.getSecp().setRolHolder(new FieldConstantHolder<>("sec"));
            this.getSecp().setBelongtoHolder(new FieldConstantHolder<>("gid"));
            this.getSecp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getSecp().setPtsptaHolder(()->this.getGidgrp().getSec());
            this.getRgtclu().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.gittrstxt");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setGittrstxt(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getGittrstxt();}}
			 );
            this.getRgtclu().setTxmgrpHolder(new FieldConstantHolder<>(""));
            this.getBxdmod().setBxdHolder(()->this.getGidgrp().getBxd());
            this.getBxdmod().setMarHolder(()->this.getGidgrp().getMar());
            this.getBxdmod().setObjtypHolder(new FieldConstantHolder<>("gid"));
            this.getBxdmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.inr");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setInr(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getInr();}}
			 );
            this.getBxdmod().setRefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getOwnref();}}
			 );
            this.getBxdmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.ptyinr");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getPtyinr();}}
			 );
            this.getBxdmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.bchcod");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getBchcod();}}
			 );
            this.getBxdmod().setBxdprefixHolder(new FieldConstantHolder<>("JX"));
            this.getBxdmod().setMarprefixHolder(new FieldConstantHolder<>("MZ"));
            this.getBxdmod().setMxdlstHolder(()->this.getGidgrp().getMxdlst());
            this.getSztmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Gitp.this.getFieldPath("gidgrp.rec.ownref");}
 				public void setValue(String arg){Gitp.this.getGidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Gitp.this.getGidgrp().getRec().getOwnref();}}
			 );
        }

        /**
        *   source:gitp.@0001.script
        */
        @Rule(target="pdfgid",order=100)
        public boolean rulePdfgidN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:gitp.@0002.script
        */
        @Rule(target="pdfgxd",order=100)
        public boolean rulePdfgxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","gitapn01","保函协议",1);

			return true;
        }

        /**
        *   source:gitp.@0003.script
        */
        @Rule(target="pdfbxd",order=100)
        public boolean rulePdfbxdN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","bxdpdf","保证金协议",1);

			return true;
        }

        /**
        *   source:gitp.@0004.script
        */
        @Rule(target="pdfmar",order=100)
        public boolean rulePdfmarN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getPdfviw().callPDFComponent("","marpdf","保证金委托开户及扣划",1);

			return true;
        }

        /**
        *   source:gitp.@0005.script
        */
        @Rule(target="getref",order=100)
        public boolean ruleGetrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getGidgrp().getGxd(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "HX");

			return true;
        }

        /**
        *   source:gitp.@0024.script
        */
        @Rule(target="gidgrp.rec.apladrcn",order=100)
        public boolean ruleGidgrpRecApladrcnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getApladrcn()))
			{
			  this.getGidgrp().getGxd().setYfzs(this.getGidgrp().getRec().getApladrcn());
			  
			  this.getGidgrp().getGxd().setYfdwdz(this.getGidgrp().getRec().getApladrcn());
			  
			  this.getGidgrp().getGxd().setBdbrfddz(this.getGidgrp().getRec().getApladrcn());
			  
			  this.getGidgrp().getBxd().setYfdwdz(this.getGidgrp().getRec().getApladrcn());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setYfzs(NULLSTR);
			  
			  this.getGidgrp().getGxd().setYfdwdz(NULLSTR);
			  
			  this.getGidgrp().getGxd().setBdbrfddz(NULLSTR);
			  
			  this.getGidgrp().getBxd().setYfdwdz(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0025.script
        */
        @Rule(target="gidgrp.rec.benadrcn",order=100)
        public boolean ruleGidgrpRecBenadrcnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBenadrcn()))
			{
			  this.getGidgrp().getGxd().setSyrfddz(this.getGidgrp().getRec().getBenadrcn());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setSyrfddz(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0026.script
        */
        @Rule(target="gidgrp.rec.aplnamcn",order=100)
        public boolean ruleGidgrpRecAplnamcnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getAplnamcn()))
			{
			  this.getGidgrp().getGxd().setYf(this.getGidgrp().getRec().getAplnamcn());
			  
			  this.getGidgrp().getGxd().setYfdwmc(this.getGidgrp().getRec().getAplnamcn());
			  
			  this.getGidgrp().getGxd().setBdbr(this.getGidgrp().getRec().getAplnamcn());
			  
			  this.getGidgrp().getBxd().setYf(this.getGidgrp().getRec().getAplnamcn());
			  
			  this.getGidgrp().getBxd().setYfdwmc(this.getGidgrp().getRec().getAplnamcn());
			  
			  this.getGidgrp().getBxd().setZwr(this.getGidgrp().getRec().getAplnamcn());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setYf(NULLSTR);
			  
			  this.getGidgrp().getGxd().setYfdwmc(NULLSTR);
			  
			  this.getGidgrp().getGxd().setBdbr(NULLSTR);
			  
			  this.getGidgrp().getBxd().setYf(NULLSTR);
			  
			  this.getGidgrp().getBxd().setYfdwmc(NULLSTR);
			  
			  this.getGidgrp().getBxd().setZwr(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0029.script
        */
        @Rule(target="gidgrp.rec.bennamcn",order=100)
        public boolean ruleGidgrpRecBennamcnN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getBennamcn()))
			{
			  String bennamcn= this.getGidgrp().getRec().getBennamcn();
			  this.getGidgrp().getGxd().setSyr(bennamcn);
			  
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setSyr(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0035.script
        */
        @Rule(target="gidgrp.rec.lgcur",order=100)
        public boolean ruleGidgrpRecLgcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\rec\\lgcur))
			  {
			  String lgcur= $gidgrp\\rec\\lgcur.getValue();
			  $gidgrp\\gxd\\dbcur.setValue(lgcur);
			  Platform.setModified($gidgrp\\gxd\\dbcur);
			  Platform.disable($gidgrp\\gxd\\dbcur);
			  }
			  else
			  {
			  Platform.clear($gidgrp\\gxd\\dbcur);
			  Platform.enable($gidgrp\\gxd\\dbcur);
			  }
			  */

			return true;
        }

        /**
        *   source:gitp.@0036.script
        */
        @Rule(target="gidgrp.rec.lgamt",order=100)
        public boolean ruleGidgrpRecLgamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\rec\\lgamt))
			  {
			  BigDecimal lgamt= $gidgrp\\rec\\lgamt.getValue();
			  $gidgrp\\gxd\\dbamt.setValue(lgamt);
			  Platform.setModified($gidgrp\\gxd\\dbamt);
			  Platform.disable($gidgrp\\gxd\\dbamt);
			  }
			  else
			  {
			  Platform.clear($gidgrp\\gxd\\dbamt);
			  Platform.enable($gidgrp\\gxd\\dbamt);
			  }
			  */

			return true;
        }

        /**
        *   source:gitp.@0037.script
        */
        @Rule(target="gidgrp.rec.opntyp",order=100)
        public boolean ruleGidgrpRecOpntypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("1".equals(this.getGidgrp().getRec().getOpntyp()))  //1、信开2、电开（信开就只有直开、转开）
			{
			  this.getGidgrp().getRec().setIssuetxt(NULLSTR);
			  
			  
			  if("3".equals(this.getGidgrp().getRec().getOpntyp2()))
			  {
			    ctx.setFieldError(this,"gidgrp.rec.opntyp",MdaUtils.getI18NString("gitp","CT001271"));
			    this.getGidgrp().getRec().setOpntyp(NULLSTR);
			    
			  }
			}
			else
			{
			  this.getGidgrp().getRec().setCjfs(NULLSTR);
			  
			  
			}
			/*
			  if("1".equals($gidgrp\\rec\\opntyp.getValue()))  //1、信开2、电开（信开就只有直开、转开）
			  {
			  if("1".equals($gidgrp\\rec\\opntyp2.getValue()))  //直开
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			  }else if("2".equals($gidgrp\\rec\\opntyp2.getValue()))  //转开
			  {
			  Platform.enable($gidgrp\\rec\\zkzdhmc);
			  Platform.setRequired($gidgrp\\rec\\zkzdhmc);
			  }else if ("3".equals($gidgrp\\rec\\opntyp2.getValue()))  //转递
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			
			  Platform.error($gidgrp\\rec\\opntyp2,#CT001272);
			  Platform.clear($gidgrp\\rec\\opntyp2);
			  Platform.setModified($gidgrp\\rec\\opntyp2);
			  }else
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			  }
			  Platform.enable($gidgrp\\rec\\cjfs);
			  }else if("2".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  if("1".equals($gidgrp\\rec\\opntyp2.getValue()))	//直开
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			
			  }else if("2".equals($gidgrp\\rec\\opntyp2.getValue()))	//转开
			  {
			  Platform.enable($gidgrp\\rec\\zkzdhmc);
			  Platform.setRequired($gidgrp\\rec\\zkzdhmc);
			  }else if ("3".equals($gidgrp\\rec\\opntyp2.getValue()))		//转递
			  {
			  Platform.enable($gidgrp\\rec\\zkzdhmc);
			  Platform.setRequired($gidgrp\\rec\\zkzdhmc);
			  }
			  else
			  {
			  Platform.clear($gidgrp\\rec\\zkzdhmc);
			  Platform.setModified($gidgrp\\rec\\zkzdhmc);
			  Platform.disable($gidgrp\\rec\\zkzdhmc);
			  Platform.setNotRequired($gidgrp\\rec\\zkzdhmc);
			  }
			  Platform.clear($gidgrp\\rec\\cjfs);
			  Platform.setModified($gidgrp\\rec\\cjfs);
			  Platform.disable($gidgrp\\rec\\cjfs);
			  }
			  */

			//向国结传TCO报文转值--保函开立方式2
			/*
			  if(Platform.isEmpty($gidgrp\\rec\\opntyp2))
			  {
			  return;
			  }
			  if("2".equals($gidgrp\\rec\\opntyp2.getValue()))
			  {
			  $gidgrp\\dopntyp2.setValue("REQUEST");
			  }
			  else
			  {
			  $gidgrp\\dopntyp2.setValue("ISSUE");
			  }
			  */
			/*
			  if("1".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			  cjfs.add(new CodetableItem("由你行经本申请人交受益人","1"));
			  cjfs.add(new CodetableItem("由你行直接邮寄受益人","2"));
			  Platform.setValues($gidgrp\\rec\\cjfs,cjfs);
			  Platform.setModified($gidgrp\\rec\\cjfs);
			  }
			  else if("2".equals($gidgrp\\rec\\opntyp.getValue()))
			  {
			  List<CodetableItem> cjfs =  new ArrayList<CodetableItem>();
			  cjfs.add(new CodetableItem("由你行委托XX银行通知受益人","3"));
			  cjfs.add(new CodetableItem("由你行委托XX银行开出反担保","4"));
			  Platform.setValues($gidgrp\\rec\\cjfs,cjfs);
			  Platform.setModified($gidgrp\\rec\\cjfs);
			  }*/

			return true;
        }

        /**
        *   source:gitp.@0038.script
        */
        @Rule(target="gidgrp.rec.cjfs",order=100)
        public boolean ruleGidgrpRecCjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  //出具方式
			  if("2".equals($gidgrp\\rec\\cjfs.getValue()))  //出具方式选2
			  {
			  Platform.setRequired($gidgrp\\rec\\syrsjdz); //受益人收件地址
			  Platform.setRequired($gidgrp\\rec\\syrlxrxx);//受益人联系人信息
			  Platform.setNotRequired($gidgrp\\rec\\bhdqdat);//保函到期日
			
			  //反担保行编号和地址
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setModified($ctrp\\ptspta\\pts\\extkey);
			  Platform.setModified($ctrp\\ptspta\\pts\\adrblk);
			  Platform.disable($ctrp\\ptspta\\pts\\extkey);
			  Platform.disable($ctrp\\ptspta\\pts\\adrblk);
			
			  //通知行编号和地址
			  Platform.setNotRequired($advp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\adrblk);
			  Platform.setModified($advp\\ptspta\\pts\\extkey);
			  Platform.setModified($advp\\ptspta\\pts\\adrblk);
			  Platform.disable($advp\\ptspta\\pts\\extkey);
			  Platform.disable($advp\\ptspta\\pts\\adrblk);
			
			  Platform.clear($gidgrp\\rec\\fdbdqdat);   //反担保到期日
			  Platform.setModified($gidgrp\\rec\\fdbdqdat);
			  Platform.disable($gidgrp\\rec\\fdbdqdat);
			  Platform.setNotRequired($gidgrp\\rec\\fdbdqdat);
			
			  }
			  else if("3".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  Platform.setNotRequired($gidgrp\\rec\\bhdqdat);//保函到期日
			
			  Platform.clear($gidgrp\\rec\\syrsjdz);   //受益人收件地址
			  Platform.setModified($gidgrp\\rec\\syrsjdz);
			  Platform.disable($gidgrp\\rec\\syrsjdz);
			  Platform.setNotRequired($gidgrp\\rec\\syrsjdz);
			  Platform.clear($gidgrp\\rec\\syrlxrxx);   //受益人联系人信息
			  Platform.setModified($gidgrp\\rec\\syrlxrxx);
			  Platform.disable($gidgrp\\rec\\syrlxrxx);
			  Platform.setNotRequired($gidgrp\\rec\\syrlxrxx);
			
			  //通知行编号和地址
			  Platform.enable($advp\\ptspta\\pts\\extkey);
			  Platform.enable($advp\\ptspta\\pts\\adrblk);
			  Platform.setRequired($advp\\ptspta\\pts\\extkey);
			  Platform.setRequired($advp\\ptspta\\pts\\adrblk);
			
			  //反担保行编号和地址
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setModified($ctrp\\ptspta\\pts\\extkey);
			  Platform.setModified($ctrp\\ptspta\\pts\\adrblk);
			  Platform.disable($ctrp\\ptspta\\pts\\extkey);
			  Platform.disable($ctrp\\ptspta\\pts\\adrblk);
			
			  Platform.clear($gidgrp\\rec\\fdbdqdat);  //反担保到期日
			  Platform.setModified($gidgrp\\rec\\fdbdqdat);
			  Platform.disable($gidgrp\\rec\\fdbdqdat);
			  Platform.setNotRequired($gidgrp\\rec\\fdbdqdat);
			
			  }
			  else if("4".equals($gidgrp\\rec\\cjfs.getValue()))
			  {
			  Platform.setRequired($gidgrp\\rec\\bhdqdat);//保函到期日
			  Platform.setRequired($gidgrp\\rec\\fdbdqdat);//反担保到期日
			  Platform.enable($gidgrp\\rec\\bhdqdat);//保函到期日
			  Platform.enable($gidgrp\\rec\\fdbdqdat);//反担保到期日
			
			  //反担保行编号和地址
			  Platform.setRequired($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setRequired($ctrp\\ptspta\\pts\\extkey);
			  Platform.enable($ctrp\\ptspta\\pts\\extkey);
			  Platform.enable($ctrp\\ptspta\\pts\\adrblk);
			
			  //通知行编号和地址
			  Platform.setNotRequired($advp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\adrblk);
			  Platform.setModified($advp\\ptspta\\pts\\extkey);
			  Platform.setModified($advp\\ptspta\\pts\\adrblk);
			  Platform.disable($advp\\ptspta\\pts\\extkey);
			  Platform.disable($advp\\ptspta\\pts\\adrblk);
			
			  Platform.clear($gidgrp\\rec\\syrsjdz);   //受益人收件地址
			  Platform.setModified($gidgrp\\rec\\syrsjdz);
			  Platform.disable($gidgrp\\rec\\syrsjdz);
			  Platform.setNotRequired($gidgrp\\rec\\syrsjdz);
			  Platform.clear($gidgrp\\rec\\syrlxrxx);   //受益人联系人信息
			  Platform.setModified($gidgrp\\rec\\syrlxrxx);
			  Platform.disable($gidgrp\\rec\\syrlxrxx);
			  Platform.setNotRequired($gidgrp\\rec\\syrlxrxx);
			
			  Platform.dbRead($gidgrp\\git,new Argument("guatyp","10"));
			  $gidgrp\\rec\\lgtxt.setValue($gidgrp\\git\\guatxt.getValue());
			  Platform.setModified($gidgrp\\rec\\lgtxt);
			  Platform.disable($gidgrp\\rec\\lgtxt);
			  }
			  else
			  {
			  Platform.clear($gidgrp\\rec\\syrsjdz);   //受益人收件地址
			  Platform.setModified($gidgrp\\rec\\syrsjdz);
			  Platform.disable($gidgrp\\rec\\syrsjdz);
			  Platform.setNotRequired($gidgrp\\rec\\syrsjdz);
			  Platform.clear($gidgrp\\rec\\syrlxrxx);   //受益人联系人信息
			  Platform.setModified($gidgrp\\rec\\syrlxrxx);
			  Platform.disable($gidgrp\\rec\\syrlxrxx);
			  Platform.setNotRequired($gidgrp\\rec\\syrlxrxx);
			
			  Platform.setNotRequired($gidgrp\\rec\\bhdqdat);//保函到期日
			
			  //反担保行编号和地址
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\extkey);
			  Platform.clear($ctrp\\ptspta\\pts\\adrblk);
			  Platform.setModified($ctrp\\ptspta\\pts\\extkey);
			  Platform.setModified($ctrp\\ptspta\\pts\\adrblk);
			  Platform.disable($ctrp\\ptspta\\pts\\extkey);
			  Platform.disable($ctrp\\ptspta\\pts\\adrblk);
			
			  //通知行编号和地址
			  Platform.setNotRequired($advp\\ptspta\\pts\\adrblk);
			  Platform.setNotRequired($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\extkey);
			  Platform.clear($advp\\ptspta\\pts\\adrblk);
			  Platform.setModified($advp\\ptspta\\pts\\extkey);
			  Platform.setModified($advp\\ptspta\\pts\\adrblk);
			  Platform.disable($advp\\ptspta\\pts\\extkey);
			  Platform.disable($advp\\ptspta\\pts\\adrblk);
			
			  Platform.clear($gidgrp\\rec\\fdbdqdat);   //反担保到期日
			  Platform.setModified($gidgrp\\rec\\fdbdqdat);
			  Platform.disable($gidgrp\\rec\\fdbdqdat);
			  Platform.setNotRequired($gidgrp\\rec\\fdbdqdat);
			  }*/

			return true;
        }

        /**
        *   source:gitp.@0039.script
        */
        @Rule(target="gidgrp.rec.dbqxtyp",order=100)
        public boolean ruleGidgrpRecDbqxtypN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxtyp()))
			{
			  
			  
			  this.getGidgrp().getRec().setDbqxsjq(null);
			  this.getGidgrp().getRec().setDbqxsjz(null);
			  
			  
			  
			  

			  
			  
			  this.getGidgrp().getRec().setDbqxshjq(NULLSTR);
			  this.getGidgrp().getRec().setDbqxshjz(NULLSTR);
			  
			  
			  
			  
			}
			else
			{
			  if("1".equals(this.getGidgrp().getRec().getDbqxtyp()))
			  {
			    
			    
			    
			    

			    
			    
			    this.getGidgrp().getRec().setDbqxshjq(NULLSTR);
			    this.getGidgrp().getRec().setDbqxshjz(NULLSTR);
			    
			    
			    
			    
			  }
			  else if("2".equals(this.getGidgrp().getRec().getDbqxtyp()))
			  {
			    
			    
			    
			    

			    
			    
			    this.getGidgrp().getRec().setDbqxsjq(null);
			    this.getGidgrp().getRec().setDbqxsjz(null);
			    
			    
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:gitp.@0040.script
        */
        @Rule(target="gidgrp.rec.bzjcur",order=100)
        public boolean ruleGidgrpRecBzjcurN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:gitp.@0041.script
        */
        @Rule(target="gidgrp.rec.bzjamt",order=100)
        public boolean ruleGidgrpRecBzjamtN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:gitp.@0042.script
        */
        @Rule(target="gidgrp.rec.dbqxsjq",order=100)
        public boolean ruleGidgrpRecDbqxsjqN100(){
            IContext ctx = MdaEnv.getContext();
            
			//保函申请担保期限起
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjq()) && !MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjz()) && MdaUtils.diff(this.getGidgrp().getRec().getDbqxsjz(),this.getGidgrp().getRec().getDbqxsjq())<0)
			{
			  this.getGidgrp().getRec().setDbqxsjq(null);
			  
			  ctx.setFieldError(this,"gidgrp.rec.dbqxsjq",MdaUtils.getI18NString("gitp","CT000879"));
			}

			/*
			  //if(!Platform.isEmpty($gidgrp\\rec\\dbqxsjq))
			  //{
			  //Date dbqxsjq= $gidgrp\\rec\\dbqxsjq.getValue();
			  //$gidgrp\\gxd\\bzqjq.setValue(dbqxsjq);
			  //Platform.setModified($gidgrp\\gxd\\bzqjq);
			  //Platform.disable($gidgrp\\gxd\\bzqjq);
			  //}
			  //else
			  //{
			  // Platform.clear($gidgrp\\gxd\\bzqjq);
			  //Platform.enable($gidgrp\\gxd\\bzqjq);
			  //}
			  */

			return true;
        }

        /**
        *   source:gitp.@0043.script
        */
        @Rule(target="gidgrp.rec.dbqxsjz",order=100)
        public boolean ruleGidgrpRecDbqxsjzN100(){
            IContext ctx = MdaEnv.getContext();
            
			//保函申请担保期限止
			if(!MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjq()) && !MdaUtils.isEmpty(this.getGidgrp().getRec().getDbqxsjz()) && MdaUtils.diff(this.getGidgrp().getRec().getDbqxsjz(),this.getGidgrp().getRec().getDbqxsjq())<0)
			{
			  this.getGidgrp().getRec().setDbqxsjz(null);
			  
			  ctx.setFieldError(this,"gidgrp.rec.dbqxsjz",MdaUtils.getI18NString("gitp","CT000878"));
			}

			/*
			  //if(!Platform.isEmpty($gidgrp\\rec\\dbqxsjz))
			  //{
			  //Date dbqxsjz= $gidgrp\\rec\\dbqxsjz.getValue();
			  //$gidgrp\\gxd\\bzqjz.setValue(dbqxsjz);
			  //Platform.setModified($gidgrp\\gxd\\bzqjz);
			  //Platform.disable($gidgrp\\gxd\\bzqjz);
			  //}
			  //else
			  //{
			  //Platform.clear($gidgrp\\gxd\\bzqjz);
			  //Platform.enable($gidgrp\\gxd\\bzqjz);
			  //}
			  */

			return true;
        }

        /**
        *   source:gitp.@0044.script
        */
        @Rule(target="gidgrp.gxd.jffrdb",order=100)
        public boolean ruleGidgrpGxdJffrdbN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getJffrdb()))
			{
			  this.getGidgrp().getBxd().setJffrdb(this.getGidgrp().getGxd().getJffrdb());
			  
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setJffrdb(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0045.script
        */
        @Rule(target="gidgrp.gxd.yf",order=100)
        public boolean ruleGidgrpGxdYfN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYf()))
			{
			  this.getGidgrp().getGxd().setYfdwmc(this.getGidgrp().getGxd().getYf());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setYfdwmc(NULLSTR);
			}

			return true;
        }

        /**
        *   source:gitp.@0046.script
        */
        @Rule(target="gidgrp.gxd.yfzs",order=100)
        public boolean ruleGidgrpGxdYfzsN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYfzs()))
			{
			  this.getGidgrp().getGxd().setYfdwdz(this.getGidgrp().getGxd().getYfzs());
			  
			}
			else
			{
			  this.getGidgrp().getGxd().setYfdwdz(NULLSTR);
			}

			return true;
        }

        /**
        *   source:gitp.@0047.script
        */
        @Rule(target="gidgrp.gxd.yffrdb",order=100)
        public boolean ruleGidgrpGxdYffrdbN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYffrdb()))
			{
			  this.getGidgrp().getGxd().setYffrdb(this.getGidgrp().getGxd().getYffrdb());
			  

			}
			else
			{
			  this.getGidgrp().getGxd().setYffrdb(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0048.script
        */
        @Rule(target="gidgrp.gxd.yfyzbm",order=100)
        public boolean ruleGidgrpGxdYfyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYfyzbm()))
			{
			  this.getGidgrp().getBxd().setYfyzbm(this.getGidgrp().getGxd().getYfyzbm());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYfyzbm(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0049.script
        */
        @Rule(target="gidgrp.gxd.yflxdh",order=100)
        public boolean ruleGidgrpGxdYflxdhN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYflxdh()))
			{
			  this.getGidgrp().getBxd().setYflxdh(this.getGidgrp().getGxd().getYflxdh());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYflxdh(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0050.script
        */
        @Rule(target="gidgrp.gxd.yflxr",order=100)
        public boolean ruleGidgrpGxdYflxrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYflxr()))
			{
			  this.getGidgrp().getBxd().setYflxr(this.getGidgrp().getGxd().getYflxr());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYflxr(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0051.script
        */
        @Rule(target="gidgrp.gxd.dsr",order=100)
        public boolean ruleGidgrpGxdDsrN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getDsr()))
			{
			  this.getGidgrp().getBxd().setDsr(this.getGidgrp().getGxd().getDsr());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setDsr(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0052.script
        */
        @Rule(target="gidgrp.gxd.dsdz",order=100)
        public boolean ruleGidgrpGxdDsdzN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getDsdz()))
			{
			  this.getGidgrp().getBxd().setDsdz(this.getGidgrp().getGxd().getDsdz());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setDsdz(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0053.script
        */
        @Rule(target="gidgrp.gxd.dsyzbm",order=100)
        public boolean ruleGidgrpGxdDsyzbmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getDsyzbm()))
			{
			  this.getGidgrp().getBxd().setDsyzbm(this.getGidgrp().getGxd().getDsyzbm());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setDsyzbm(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0054.script
        */
        @Rule(target="gidgrp.gxd.yfczhm",order=100)
        public boolean ruleGidgrpGxdYfczhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYfczhm()))
			{
			  this.getGidgrp().getBxd().setYfczhm(this.getGidgrp().getGxd().getYfczhm());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYfczhm(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0055.script
        */
        @Rule(target="gidgrp.gxd.yfdzyj",order=100)
        public boolean ruleGidgrpGxdYfdzyjN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYfdzyj()))
			{
			  this.getGidgrp().getBxd().setYfdzyj(this.getGidgrp().getGxd().getYfdzyj());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYfdzyj(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0056.script
        */
        @Rule(target="gidgrp.gxd.yfsjhm",order=100)
        public boolean ruleGidgrpGxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYfsjhm()))
			{
			  this.getGidgrp().getBxd().setYfsjhm(this.getGidgrp().getGxd().getYfsjhm());
			  
			}
			else
			{
			  this.getGidgrp().getBxd().setYfsjhm(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0057.script
        */
        @Rule(target="gidgrp.gxd.bzqjz",order=100)
        public boolean ruleGidgrpGxdBzqjzN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:gitp.@0058.script
        */
        @Rule(target="gidgrp.gxd.jffs",order=100)
        public boolean ruleGidgrpGxdJffsN100(){
            IContext ctx = MdaEnv.getContext();
            
			//计费方式
			if("1".equals(this.getGidgrp().getGxd().getJffs()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getGidgrp().getGxd().getJffs()))
			{
			  this.getGidgrp().getGxd().setYcxcur(NULLSTR);
			  this.getGidgrp().getGxd().setYcxamt(new BigDecimal(0));
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0059.script
        */
        @Rule(target="gidgrp.gxd.ycxcur",order=100)
        public boolean ruleGidgrpGxdYcxcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYcxcur()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0060.script
        */
        @Rule(target="gidgrp.gxd.ycxamt",order=100)
        public boolean ruleGidgrpGxdYcxamtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getGxd().getYcxamt()))
			{
			  
			}
			else
			{
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0061.script
        */
        @Rule(target="gidgrp.gxd.zyjjfs",order=100)
        public boolean ruleGidgrpGxdZyjjfsN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.getGidgrp().getGxd().setZcwyh(NULLSTR);
			this.getGidgrp().getGxd().setKtdd(NULLSTR);
			this.getGidgrp().getGxd().setQtfs(NULLSTR);
			
			
			
			//争议解决方式
			if("1".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{

			  
			  
			  
			  
			  
			  
			}
			else if("2".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}
			else if("3".equals(this.getGidgrp().getGxd().getZyjjfs()))
			{
			  
			  
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0067.script
        */
        @Rule(target="dzbhwb",order=100)
        public boolean ruleDzbhwbN100(){
            IContext ctx = MdaEnv.getContext();
            
			String hth = this.getGidgrp().getGitpush().getContractid();
			String pdfFile = this.getGidgrp().getGitpush().getInr();
			if(MdaUtils.isEmpty(hth)||MdaUtils.isEmpty(pdfFile))
			{

			  ctx.setMessage(MdaUtils.getI18NString("gitp","CT001521"),MdaUtils.getI18NString("gitp","CT001522"));
			  return false;
			}
			String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/szdzbh/pdf/"+pdfFile.substring(0,5)+"/"+pdfFile+".pdf");
			if(!MdaUtils.fileExists(pdffile))
			{
			  //调用接口下载
			  Object rtnVal = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","msg2cfca","msg2cfca",new Object[]{ pdfFile,hth});
			  if (rtnVal == null)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitp","CT001580"),MdaUtils.getI18NString("gitp","CT001581"));
			    return false;
			  }
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");//000000
			  if(!"000000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("gitp","CT001582"),MdaUtils.getI18NString("gitp","CT001589"));
			    return false;
			  }
			}
			MdaUtils.streamClear(this.getDzbhwb());
			IStream stream=this.getDzbhwb();
			log.info("{}","pdffile===="+pdffile);
			MdaUtils.streamLoad(stream,pdffile);
			stream.setType("pdf");
			String pdfnam = org.apache.commons.io.FilenameUtils.getName(pdffile);
			stream.setName(pdfnam);

			return true;
        }

        /**
        *   source:gitp.@0072.script
        */
        @Rule(target="gidgrp.sxb.pifu0",order=100)
        public boolean ruleGidgrpSxbPifu0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getPifu0()))
			{
			  this.getGidgrp().getSxb().setPifu1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0073.script
        */
        @Rule(target="gidgrp.sxb.pifu1",order=100)
        public boolean ruleGidgrpSxbPifu1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getPifu1()))
			{
			  this.getGidgrp().getSxb().setPifu0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0074.script
        */
        @Rule(target="gidgrp.sxb.xindai0",order=100)
        public boolean ruleGidgrpSxbXindai0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getXindai0()))
			{
			  this.getGidgrp().getSxb().setXindai1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0075.script
        */
        @Rule(target="gidgrp.sxb.xindai1",order=100)
        public boolean ruleGidgrpSxbXindai1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getXindai1()))
			{
			  this.getGidgrp().getSxb().setXindai0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0076.script
        */
        @Rule(target="gidgrp.sxb.shiyong1",order=100)
        public boolean ruleGidgrpSxbShiyong1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong1()))
			{
			  this.getGidgrp().getSxb().setShiyong2("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0077.script
        */
        @Rule(target="gidgrp.sxb.shiyong2",order=100)
        public boolean ruleGidgrpSxbShiyong2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong2()))
			{
			  this.getGidgrp().getSxb().setShiyong1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0078.script
        */
        @Rule(target="gidgrp.sxb.shiyong3",order=100)
        public boolean ruleGidgrpSxbShiyong3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong3()))
			{
			  this.getGidgrp().getSxb().setShiyong4("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0079.script
        */
        @Rule(target="gidgrp.sxb.shiyong4",order=100)
        public boolean ruleGidgrpSxbShiyong4N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong4()))
			{
			  this.getGidgrp().getSxb().setShiyong3("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0080.script
        */
        @Rule(target="gidgrp.sxb.shiyong5",order=100)
        public boolean ruleGidgrpSxbShiyong5N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong5()))
			{
			  this.getGidgrp().getSxb().setShiyong6("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0081.script
        */
        @Rule(target="gidgrp.sxb.shiyong6",order=100)
        public boolean ruleGidgrpSxbShiyong6N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong6()))
			{
			  this.getGidgrp().getSxb().setShiyong5("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0082.script
        */
        @Rule(target="gidgrp.sxb.shiyong7",order=100)
        public boolean ruleGidgrpSxbShiyong7N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong7()))
			{
			  this.getGidgrp().getSxb().setShiyong8("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0083.script
        */
        @Rule(target="gidgrp.sxb.shiyong8",order=100)
        public boolean ruleGidgrpSxbShiyong8N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getShiyong8()))
			{
			  this.getGidgrp().getSxb().setShiyong7("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0084.script
        */
        @Rule(target="gidgrp.sxb.rzdk0",order=100)
        public boolean ruleGidgrpSxbRzdk0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getRzdk0()))
			{
			  this.getGidgrp().getSxb().setRzdk1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0085.script
        */
        @Rule(target="gidgrp.sxb.rzdk1",order=100)
        public boolean ruleGidgrpSxbRzdk1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getRzdk1()))
			{
			  this.getGidgrp().getSxb().setRzdk0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0086.script
        */
        @Rule(target="gidgrp.sxb.glqy0",order=100)
        public boolean ruleGidgrpSxbGlqy0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getGlqy0()))
			{
			  this.getGidgrp().getSxb().setGlqy1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0087.script
        */
        @Rule(target="gidgrp.sxb.glqy1",order=100)
        public boolean ruleGidgrpSxbGlqy1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getGlqy1()))
			{
			  this.getGidgrp().getSxb().setGlqy0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0088.script
        */
        @Rule(target="gidgrp.sxb.f51pf0",order=100)
        public boolean ruleGidgrpSxbF51pf0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getF51pf0()))
			{
			  this.getGidgrp().getSxb().setF51pf1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0089.script
        */
        @Rule(target="gidgrp.sxb.f51pf1",order=100)
        public boolean ruleGidgrpSxbF51pf1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getF51pf1()))
			{
			  this.getGidgrp().getSxb().setF51pf0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0090.script
        */
        @Rule(target="gidgrp.sxb.dbhmd0",order=100)
        public boolean ruleGidgrpSxbDbhmd0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbhmd0()))
			{
			  this.getGidgrp().getSxb().setDbhmd1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0091.script
        */
        @Rule(target="gidgrp.sxb.dbhmd1",order=100)
        public boolean ruleGidgrpSxbDbhmd1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbhmd1()))
			{
			  this.getGidgrp().getSxb().setDbhmd0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0092.script
        */
        @Rule(target="gidgrp.sxb.jkhmd0",order=100)
        public boolean ruleGidgrpSxbJkhmd0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJkhmd0()))
			{
			  this.getGidgrp().getSxb().setJkhmd1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0093.script
        */
        @Rule(target="gidgrp.sxb.jkhmd1",order=100)
        public boolean ruleGidgrpSxbJkhmd1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJkhmd1()))
			{
			  this.getGidgrp().getSxb().setJkhmd0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0094.script
        */
        @Rule(target="gidgrp.sxb.dbhui0",order=100)
        public boolean ruleGidgrpSxbDbhui0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbhui0()))
			{
			  this.getGidgrp().getSxb().setDbhui1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0095.script
        */
        @Rule(target="gidgrp.sxb.dbhui1",order=100)
        public boolean ruleGidgrpSxbDbhui1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbhui1()))
			{
			  this.getGidgrp().getSxb().setDbhui0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0096.script
        */
        @Rule(target="gidgrp.sxb.jkyj0",order=100)
        public boolean ruleGidgrpSxbJkyj0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJkyj0()))
			{
			  this.getGidgrp().getSxb().setJkyj1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0097.script
        */
        @Rule(target="gidgrp.sxb.jkyj1",order=100)
        public boolean ruleGidgrpSxbJkyj1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJkyj1()))
			{
			  this.getGidgrp().getSxb().setJkyj0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0098.script
        */
        @Rule(target="gidgrp.sxb.dbyj0",order=100)
        public boolean ruleGidgrpSxbDbyj0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbyj0()))
			{
			  this.getGidgrp().getSxb().setDbyj1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0099.script
        */
        @Rule(target="gidgrp.sxb.dbyj1",order=100)
        public boolean ruleGidgrpSxbDbyj1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getDbyj1()))
			{
			  this.getGidgrp().getSxb().setDbyj0("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0100.script
        */
        @Rule(target="gidgrp.sxb.jysel1",order=100)
        public boolean ruleGidgrpSxbJysel1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJysel1()))
			{
			  this.getGidgrp().getSxb().setJysel2("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0101.script
        */
        @Rule(target="gidgrp.sxb.jysel2",order=100)
        public boolean ruleGidgrpSxbJysel2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if("X".equals(this.getGidgrp().getSxb().getJysel2()))
			{
			  this.getGidgrp().getSxb().setJysel1("");
			  
			}

			return true;
        }

        /**
        *   source:gitp.@0102.script
        */
        @Rule(target="gidgrp.sxb.ptynam",order=100)
        public boolean ruleGidgrpSxbPtynamN100(){
            IContext ctx = MdaEnv.getContext();
            


			return true;
        }

        /**
        *   source:gitp.@0103.script
        */
        @Rule(target="gidgrp.sxb.kehunam1",order=100)
        public boolean ruleGidgrpSxbKehunam1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!MdaUtils.isEmpty(this.getGidgrp().getSxb().getPtynam()))
			{
			  this.getGidgrp().getSxb().setKehunam1(this.getGidgrp().getSxb().getPtynam());
			  
			}

			return true;
        }


        /**
        *   source:gitp.@0006.script
        */
        @Check(target="gidgrp.gxd.yfsjhm",order=100)
        public boolean checkGidgrpGxdYfsjhmN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			
			  if(Platform.isEmpty($gidgrp\\gxd\\yflxdh)&&Platform.isEmpty($gidgrp\\gxd\\yfsjhm)&&Platform.isEmpty($gidgrp\\gxd\\yfczhm)&&Platform.isEmpty($gidgrp\\gxd\\yfdzyj)&&Platform.isEmpty($gidgrp\\gxd\\yfwxhm)&&Platform.isEmpty($gidgrp\\gxd\\yfqqhm))
			  {
			
			  if("gitapn".equals(Platform.getTransName()))
			  {
			  Platform.error($gidgrp\\gxd\\yfsjhm,#CT000437);
			  }
			  }*/

			return true;
        }

        /**
        *   source:gitp.@0008.script
        */
        @Check(target="gidgrp.rec.lmudat",order=100)
        public boolean checkGidgrpRecLmudatN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*if(!Platform.isEmpty($gidgrp\\rec\\lmudat) && !Platform.isEmpty($gidgrp\\rec\\apldat) && Platform.diff($gidgrp\\rec\\lmudat.getValue(),$gidgrp\\rec\\apldat.getValue())<0)
			  Platform.error($gidgrp\\rec\\lmudat,#CT000522);
			  */

			return true;
        }

        /**
        *   source:gitp.@0009.script
        */
        @Check(target="gidgrp.gxd.bzqjz",order=100)
        public boolean checkGidgrpGxdBzqjzN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\gxd\\bzqjq) && !Platform.isEmpty($gidgrp\\gxd\\bzqjz) && Platform.diff($gidgrp\\gxd\\bzqjz.getValue(),$gidgrp\\gxd\\bzqjq.getValue())<0)
			  Platform.error($gidgrp\\gxd\\bzqjz,#CT000524);
			  */

			return true;
        }

        /**
        *   source:gitp.@0020.script
        */
        @Check(target="gidgrp.rec.dbqxsjq",order=50)
        public boolean checkGidgrpRecDbqxsjqN50(){
            IContext ctx = MdaEnv.getContext();
            
			/* if(!Platform.isEmpty($gidgrp\\rec\\dbqxsjq) && !Platform.isEmpty($gidgrp\\rec\\dbqxsjz) && Platform.diff($gidgrp\\rec\\dbqxsjz.getValue(),$gidgrp\\rec\\dbqxsjq.getValue())<0)
			  Platform.error($gidgrp\\rec\\dbqxsjq,#CT000598);
			  */

			return true;
        }

        /**
        *   source:gitp.@0021.script
        */
        @Check(target="gidgrp.rec.dbqxsjz",order=50)
        public boolean checkGidgrpRecDbqxsjzN50(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  if(!Platform.isEmpty($gidgrp\\rec\\dbqxsjq) && !Platform.isEmpty($gidgrp\\rec\\dbqxsjz) && Platform.diff($gidgrp\\rec\\dbqxsjz.getValue(),$gidgrp\\rec\\dbqxsjq.getValue())<0)
			  Platform.error($gidgrp\\rec\\dbqxsjz,#CT000599);
			  */

			return true;
        }



        /**
        *   source:gitp.@0027.script
        */
        public void loadTips()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getGidgrp().getTips()))
			{
			  log.debug("{}","---------------loadTips开始初始化tips");
			  String tips="Tips:操作指引";
			  tips+=CR+"一、业务发起流程";
			  tips+=CR+"1、贵司应至少提交“开立银行保函申请书”和“保函合同协议”等影像资料，并根据实际是否签订年度保函承诺书情况选择是否提交“申请人承诺书”，根据业务是否需要保证金选择是否提交“保函保证金质押协议、保函保证金质押登记协议”。";
			  tips+=CR+"2、贵司可以通过手工输入或调用模板快速编辑并提交业务申请。";
			  tips+=CR+"3、保函受益人信息可经阳光e结算企业端管理员维护后于列表选择。";
			  tips+=CR+"二、申请书与合同/协议的修改流程 ";
			  tips+=CR+"1、贵司提交的申请书有任何不妥均须由贵司自行修改。届时银行将把申请交易退回阳光e结算“退回文件夹”，由贵司进行修改；";
			  this.getGidgrp().setTips(tips);
			  
			  
			}

		}
        /**
        *   source:gitp.@0062.script
        */
        public String covTime(String time ,String format)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map cnTime =(Map<String,String>)MdaUtils.invoke("com.brilliance.base.utils.CovTime","covTime",time,format);
			log.info("{}","Map  time  -----------------" + (String)cnTime.get("YEAR")+"年");
			String s = (String)cnTime.get("YEAR")+"年"+(String)cnTime.get("MONTH")+"月"+(String)cnTime.get("DATE")+"日";
			return s;
		}
        /**
        *   source:gitp.@0063.script
        */
        public String makeCompareWord(String inr, String source, String target)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String out = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(inr,"html");

			/*
			  String dspfilePath=Platform.catPath(Platform.getRootPath(),"/data/"+mdDir+"/"+inrStr);
			  log.info("dspfilePath:" + dspfilePath);
			
			  String out = Platform.catPath(Platform.getRootPath(),fileName);
			  */
			log.info("{}","out:" + out);
			MdaUtils.invoke("com.brilliance.utils.WordCompareUtil","compare",source,target,out);
			return out;
		}
        /**
        *   source:gitp.@0065.script
        */
        public boolean secupdat(String cifno)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean bool = false;
			ctx.getDaoSession().dbRead(this.getSecinf(),new Argument<String>("cifno",cifno));
			if(!MdaUtils.isEmpty(this.getSecinf().getUpddat()))
			{
			  //String todaydat =Platform.parseDate(time, "yyyyMMddHHmmss"); Platform.fromat(Platform.today(),"yyyyMMdd");
			  //String secupdat = Platform.fromat($secinf\\upddat.getValue(),"yyyyMMdd");
			  Long days = (MdaUtils.today().getTime() - this.getSecinf().getUpddat().getTime())/(1000*3600*24);
			  if(days < 366 )
			  {
			    bool = true;
			  }
			}
			return bool;
		}
        /**
        *   source:gitp.@0066.script
        */
        public String covFCnPermillage(BigDecimal per)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将数字转化为大写
			if (per == null)
			{
			  return "";
			}
			String strPer = per.toString();
			String[] number = { "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖" };
			String[] radices = { "仟", "", "拾", "佰" };
			String[] bigRadices = { "", "万", "亿", "万亿", "亿亿" };
			int idx = strPer.indexOf(".");
			String sInt = "";
			String sFlt = "";
			if(-1 == idx)
			{
			  sInt = strPer;
			  sFlt = "0000";
			}
			else
			{
			  sInt = strPer.substring(0, idx);
			  sFlt = strPer.substring(idx + 1);
			  if( 1 == sFlt.length())
			  {
			    sFlt = sFlt + "000";
			  }
			  else if( 2 == sFlt.length())
			  {
			    sFlt = sFlt + "00";
			  }
			  else if( 3 == sFlt.length())
			  {
			    sFlt = sFlt + "0";
			  }

			}

			String cn = "千分之";
			int zeroC = 0;
			int len = sInt.length();
			for (int i = 0; i < len; i++) {
			  if (sInt.charAt(i) == '0')
			{
			  zeroC++;
			}
			else
			{
			  if (zeroC > 0)
			  {
			    cn = cn + "零";
			    zeroC = 0;
			  }
			  cn = cn + number[(sInt.charAt(i) - '1')];
			  cn = cn + radices[((len - i) % 4)];
			}
			if (((len - i) % 4 == 1) && (zeroC < 4))
			  cn = cn + bigRadices[((len - i) / 4)];
			}
			if (sFlt.equals("0000"))
			{
			cn = cn + "整";
			}
			else
			{
			cn = cn + "点";
			if (!sFlt.substring(0, 1).equals("0"))
			  cn = cn + number[(sFlt.charAt(0) - '1')];
			else
			  cn = cn + "零";
			if (!sFlt.substring(1, 2).equals("0"))
			  cn = cn + number[(sFlt.charAt(1) - '1')];
			if (!sFlt.substring(2, 3).equals("0"))
			  cn = cn + number[(sFlt.charAt(2) - '1')];
			if (!sFlt.substring(3, 4).equals("0"))
			  cn = cn + number[(sFlt.charAt(3) - '1')];
			}
			return cn;
		}

        public void setGidgrpHolder(ModuleHolder<Gidgrp> gidgrp)
        {
           this.gidgrp = gidgrp;
        }

        public Gidgrp getGidgrp()
        {
           return this.gidgrp.get();
        }



































































































}