package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 海运费查询面板
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Hyfp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Hyfp.class);

        //开始日期
        private Date stadat;

        //结束日期
        private Date enddat;

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //导出
        private IStream download = new StreamImpl();

        //机构名称
        private String orgnam;

        //机构类型
        private String brhtyp;

        //NewField
        private String brhnam;


        @JsonIgnore
        @BDGetter
        private transient IPanel hyfque;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Hyfgrp> hyfgrp;


		public Hyfp()
        {
            super();
            setArgument();
        }

        public Hyfp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }





        public void setHyfgrpHolder(ModuleHolder<Hyfgrp> hyfgrp)
        {
           this.hyfgrp = hyfgrp;
        }

        public Hyfgrp getHyfgrp()
        {
           return this.hyfgrp.get();
        }















}