package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Imgtp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Imgtp.class);

        //影像导入
        private transient IControl images = new ControlImpl("images", "影像导入", this);

        //国结影像查阅
        private transient IControl stlimgviw = new ControlImpl("stlimgviw", "国结影像查阅", this);

        //国结影像批次号
        private String stlimgref;

        //e结算影像批次编号
        private String dztimgref;

        //e结算影像查阅
        private transient IControl dztimgviw = new ControlImpl("dztimgviw", "e结算影像查阅", this);

        //影像唯一编号
        private String imginr;

        //e结算业务流水编号
        private String trninr;

        //承付/拒付通知书
        private transient IControl cjviw = new ControlImpl("cjviw", "承付/拒付通知书", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel image;

        @JsonIgnore
        @BDGetter
        private transient IPanel imgviw;

        @JsonIgnore
        @BDGetter
        private transient IPanel dztimgview;

        @JsonIgnore
        @BDGetter
        private transient IPanel dztviw;



		public Imgtp()
        {
            super();
            setArgument();
        }

        public Imgtp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:imgtp.@0000.script
        */
        @Rule(target="images",order=100)
        public boolean ruleImagesN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in images ... ");
			//判断影像功能是否开通
			String cid =ctx.absGet(Sysmod.class).getPty().getCid();
			String frm =ctx.getTransName();
			IDatafield<String> bchField = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"bchcod");
			String bch = bchField.getValue();
			log.debug("{}","bch=" +bchField.getValue());
			if(MdaUtils.isEmpty(bch))
			{
			  ctx.setMessage(MdaUtils.getI18NString("imgtp","CT000056"),MdaUtils.getI18NString("imgtp","CT000057"));
			  return true;
			}
			boolean result = ctx.absGet(Trnmod.class).getItfmod().getImgmod().judgingImageOpen(cid,frm,bch);
			if(!result)
			{
			  return true;
			}
			IDatafield<String> ownrefField = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"ownref");
			if(MdaUtils.isEmpty(ownrefField.getValue()))
			{
			  ctx.absGet(Mtabut.class).getRef();
			}
			String ownref = ownrefField.getValue();
			log.debug("{}","ownref="+  ownref );
			String imgref = this.getDztimgref();
			if(MdaUtils.isEmpty(imgref))
			{
			  imgref = ownref;
			  this.setDztimgref(ownref);
			}
			log.debug("{}","ownref="+  ownref +", imgref=" + imgref);
			String objtyp = MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec());
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().callImageComponent("ImageUpload",ownref,imgref,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp);
			log.debug("{}","out images ... ");

			return true;
        }

        /**
        *   source:imgtp.@0004.script
        */
        @Rule(target="dztimgviw",order=100)
        public boolean ruleDztimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查阅控制
			if(!"0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  String sql="select tsc.imgflg imgflg from tsc,img where tsc.trncod=img.inifrm and img.inr='"+this.getImginr()+"'";
			  Argument<String> imgflg=new Argument<String>("imgflg");
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  int err1=ctx.getErrorCode();
			  log.info("{}","err1======="+err1);
			  ctx.getDaoSession().dbFetchFields(imgflg);
			  int err2=ctx.getErrorCode();
			  log.info("{}","err2======="+err2);
			  if(err2 == NO_ERROR)
			  {
			    if(!"X".equals(imgflg.value))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("imgtp","CT000064"),MdaUtils.getI18NString("imgtp","CT000065"));
			      ctx.getDaoSession().dbCloseCursor();
			      return false;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().imgScan(this.getTrninr());

			return true;
        }

        /**
        *   source:imgtp.@0005.script
        */
        @Rule(target="stlimgviw",order=100)
        public boolean ruleStlimgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in stlimgviw....");
			log.debug("{}","stlimgref=" + this.getStlimgref());
			//影像查阅控制
			if(!"0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  String sql="select tsc.imgflg imgflg from tsc,img where tsc.trncod=img.inifrm and img.inr='"+this.getImginr()+"'";
			  Argument<String> imgflg=new Argument<String>("imgflg");
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  int err1=ctx.getErrorCode();
			  log.info("{}","err1======="+err1);
			  ctx.getDaoSession().dbFetchFields(imgflg);
			  int err2=ctx.getErrorCode();
			  log.info("{}","err2======="+err2);
			  if(err2 == NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(imgflg);
			    if(!"X".equals(imgflg.value))
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      ctx.setMessage(MdaUtils.getI18NString("imgtp","CT000048"),MdaUtils.getI18NString("imgtp","CT000049"));

			      return true;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}

			if(MdaUtils.isEmpty(this.getStlimgref()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("imgtp","CT000058"),MdaUtils.getI18NString("imgtp","CT000059"));
			  return true;
			}
			else
			{
			  /*
			    需求编号：R22081176
			    投产日期：20230525
			    修改人：w42375
			    描述：1.判断交易，如果交易是brtdck，则调用另外的方法。
			    */
			  String transName = ctx.getTransName();
			  if(!MdaUtils.isEmpty(transName) && "brtdck".equals(transName.toLowerCase()))
			  {
			    log.debug("{}","进入查询影像的方法============================================"+transName);
			    this.viewImage(this.getImginr());
			  }
			  else
			  {
			    log.debug("{}","进入老方法============================================"+transName);
			    ctx.absGet(Trnmod.class).getItfmod().getImgmod().stlImgScan(this.getImginr());
			  }

			}
			log.debug("{}","out stlimgviw....");

			return true;
        }



        /**
        *   source:imgtp.@0009.script
        */
        @Init(order=55)
        public boolean	init55(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","init  images 55 ... "+this.getDztimgref());

			if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getImgref()) && MdaUtils.isEmpty(this.getDztimgref()))
			{
			  this.setDztimgref(ctx.absGet(Sysmod.class).getSpt().getImgref());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().setImgref(ctx.absGet(Sysmod.class).getSpt().getImgref());
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().setOwnref(ctx.absGet(Sysmod.class).getSpt().getOwnref());
			  
			  
			  log.debug("{}","从spt加载的影像批次号为：" + this.getDztimgref()+"参考号为："+ctx.absGet(Trnmod.class).getItfmod().getImgmod().getOwnref());
			}


			return true;
        }


        /**
        *   source:imgtp.@0003.script
        */
        public String getImageReference()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String prefix = ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class).getPrefix();
			prefix = "IMG" + prefix + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			// 默认同类交易当天不会有10000条
			prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("IMG" + ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class).getPrefix()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			this.setDztimgref(prefix);
			
			return  this.getDztimgref();
		}
        /**
        *   source:imgtp.@0006.script
        */
        public void getImgRef()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in getImgRef");
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()));
			//获取STL影像批次号
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getCreusr()));
			//修改为ownref by mkz 19.03.05   原imgref在表中存的是国结业务的流水号，ownref存的是国结的参考号。
			this.setStlimgref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getOwnref());
			this.setImginr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getCreusr());
			log.debug("{}","stlimgref=" +this.getStlimgref());
			log.debug("{}","imginr=" + this.getImginr());
			//获取DZT影像批次号
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg(),new Argument<String>("trninr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getResnum()));
			this.setDztimgref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			this.setTrninr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getResnum());
			log.debug("{}","trninr=" + this.getTrninr());
			log.debug("{}","dztimgref=" +this.getDztimgref());
			
			
			
			
			log.debug("{}","out getImgRef");
		}
        /**
        *   source:imgtp.@0010.script
        */
        public boolean viewImage(String imginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			/*
			  需求编号：R22081176
			  投产日期：20230525
			  修改人：w42375
			  描述：1.判断交易，如果交易是brtdck并且是线上交易，才执行此逻辑。
			  2.增加按钮：承付/拒付通知书
			  3.判断是否已经下载影像
			  4.如果没有下载则下载影像，并且增加水印.
			  */
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg(),new Argument("inr",imginr));
			//String ownref = $\\sysmod\\itfmod\\imgmod\\img\\ownref.getValue();
			String imgref = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getImgref();
			String objtyp = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getObjtyp();
			String ownref = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getOwnref();
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getImgref()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("imgtp","CT000071"),MdaUtils.getI18NString("imgtp","CT000072"));
			  return false;
			}

			Date date = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getCredat();
			String trncod = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getInifrm();
			String yngyjg = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getBchcod();
			String nam = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().getImg().getLgnnam();
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/img.properties");
			String appId = MdaUtils.getPropertyValue(fileName,"appId");
			String netId = MdaUtils.getPropertyValue(fileName,"netId");
			String gdate = MdaUtils.format(date,"yyyyMMdd");
			String operId = nam;
			//1.判断是否已经下载影像
			String sql="select count(*) count from tblbil where djcod='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			Argument<Integer> count = new Argument<Integer>("count");
			ctx.getDaoSession().dbFetchFields(count);
			ctx.getDaoSession().dbCloseCursor();
			//2.没有下载影像则调用接口下载影像
			boolean result =false;
			if(count.value==0)
			{
			  //3.下载影像
			  String cls="com.brilliance.eibs.main.Client";
			  Object resMsg = MdaUtils.invoke(cls,"scall","download","download",new Object[]{netId,appId,gdate,operId,imgref,trncod,ownref,yngyjg});
			  //4.影像下载成功后添加水印
			  if(!(Boolean)MdaUtils.invoke(resMsg,"isSuccess"))
			  {
			    ctx.setMessage("提示","影像下载失败，请联系管理员！");
			    return false;
			  }
			  //5.给影像pdf加水印
			  if(this.addWater(ownref))
			  {
			    //6.添加水印后查询影像
			    result= ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().callImageComponent("ImageScan",ownref,ownref,ctx.getTransName(),ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getLgnnam(),objtyp);
			  }
			}
			else
			{
			  result= ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().callImageComponent("ImageScan",ownref,ownref,ctx.getTransName(),ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getLgnnam(),objtyp);
			}

			if(result)
			{
			  return true;
			}
			else
			{
			  return false;
			}
		}
        /**
        *   source:imgtp.@0012.script
        */
        public boolean addWater(String stlref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查tblbil表获取文件名。
			String sql = "SELECT filpth from tblbil where djcod ='"+stlref+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getErrorCode();
			Argument<String> filpth = new Argument<String>("filpth");
			Map<String,String>  dmap = new HashMap<String,String>();
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(filpth);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    String fileName = filpth.value;
			    int index = fileName.lastIndexOf("/");
			    String pdfPath = fileName.substring(0,index);
			    String pdfName = fileName.substring(index+1);
			    //如果文件存在，并且是pdf\\PDF
			    if(MdaUtils.fileExists(MdaUtils.catPath(pdfPath,pdfName)) && (pdfName.endsWith(".pdf") || pdfName.endsWith(".PDF")))
			    {
			      log.info("{}","to show the file..." );
			      dmap.put(filpth.value,filpth.value);
			    }
			  }
			  else
			  {
			    break;

			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			//调用加水印方法
			if(dmap.size()>0)
			{
			  MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","PDFAddWatermark",dmap,"copy",300,600,60,0.2);
			}
			return true;
		}

















}