package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Invdet;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Invlst;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Invl extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Invl.class);

        //刷新
        private transient IControl invref = new ControlImpl("invref", "刷新", this);

        //查看详情
        private transient IControl detailview = new ControlImpl("detailview", "查看详情", this);

        //删除
        private transient IControl invdel = new ControlImpl("invdel", "删除", this);

        //替换发票
        private transient IControl replace = new ControlImpl("replace", "替换发票", this);

        //上传发票
        private IStream upinv = new StreamImpl();

        //替换发票上传发票
        private IStream replaceup = new StreamImpl();

        //保存
        private transient IControl invsav = new ControlImpl("invsav", "保存", this);

        //取消
        private transient IControl invcancel = new ControlImpl("invcancel", "取消", this);

        //取消
        private transient IControl invlcancel = new ControlImpl("invlcancel", "取消", this);

        //刷新反显信息
        private transient IControl refdisplay = new ControlImpl("refdisplay", "刷新反显信息", this);

        //全选
        private transient IControl selall = new ControlImpl("selall", "全选", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel invl;

        @JsonIgnore
        @BDGetter
        private transient IPanel invdetail;

        @JsonIgnore
        @BDGetter
        private transient IPanel invlpopup;


		@BDGetter
		private ModuleList<Invlst> invlst;

	    @BDGetter
		private Invdet invdet;


		public Invl()
        {
            super();
            setArgument();
        }

        public Invl(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:invl.@0001.script
        */
        @Rule(target="invdet.gfrcur",order=100)
        public boolean ruleInvdetGfrcurN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("CNY".equals(this.getInvdet().getGfrcur()))
			{
			  ctx.setFieldError(this,"invdet.gfrcur","外币币种不能选择 人民币");
			  this.getInvdet().setGfrcur(NULLSTR);
			  
			}

			return true;
        }

        /**
        *   source:invl.@0004.script
        */
        @Rule(target="invcancel",order=100)
        public boolean ruleInvcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:invl.@0006.script
        */
        @Rule(target="invlcancel",order=100)
        public boolean ruleInvlcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }




        /**
        *   source:invl.@0003.script
        */
        public void invDetail(String indinr, boolean invedit)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 发票详情
			Argument<String> inr =new Argument<String>("inr");
			Argument<String> invoicecode =new Argument<String>("invoicecode");
			Argument<String> invoicenumber =new Argument<String>("invoicenumber");
			Argument<Date> billingdate =new Argument<Date>("billingdate");
			Argument<String> checkresult =new Argument<String>("checkresult");
			Argument<BigDecimal> invamt =new Argument<BigDecimal>("invamt");
			Argument<String> checkcode =new Argument<String>("checkcode");
			Argument<BigDecimal> gframt =new Argument<BigDecimal>("gframt");
			Argument<String> gfrcur =new Argument<String>("gfrcur");
			Argument<String> remarks =new Argument<String>("remarks");
			Argument<String> purchasername =new Argument<String>("purchasername");
			Argument<String> purchasertaxno =new Argument<String>("purchasertaxno");
			Argument<String> salesname =new Argument<String>("salesname");
			Argument<String> salestaxno =new Argument<String>("salestaxno");
			Argument<String> state =new Argument<String>("state");
			//查询发票信息
			String sql="SELECT inv.inr,inv.invoicecode,inv.invoicenumber,inv.billingdate,inv.checkresult,inv.invamt,inv.checkcode,isp.gframt,isp.gfrcur,"
			  +"isp.remarks,isp.purchasername,isp.purchasertaxno,isp.salesname,isp.state,isp.salestaxno from inv inv LEFT JOIN invsup isp ON isp.invinr=inv.inr where inv.inr='"+indinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(inr,invoicecode,invoicenumber,billingdate,invamt,checkcode,gframt,gfrcur,remarks,purchasername,purchasertaxno,salesname,state,salestaxno);
			int errorCode = ctx.getErrorCode();
			if(errorCode != NO_ERROR)
			{
			  ctx.setMessage("提示","查询数据失败");
			  ctx.getDaoSession().dbCloseCursor();
			  return;
			}
			ctx.getDaoSession().dbCloseCursor();
			MdaUtils.clear(this.getInvdet());
			//if (invedit)
			//{
			
			//}
			//else
			//{
			//  Platform.popup($invview);
			//}
			this.getInvdet().setCheckcode(checkcode.value);
			

			this.getInvdet().setInvoicecode(invoicecode.value);
			

			this.getInvdet().setInvoicenumber(invoicenumber.value);
			

			this.getInvdet().setBillingdate(billingdate.value);
			
			this.getInvdet().setInvamt(invamt.value);
			
			this.getInvdet().setGframt(gframt.value);
			
			this.getInvdet().setGfrcur(gfrcur.value);
			

			this.getInvdet().setRemarks(remarks.value);
			

			this.getInvdet().setPurchasername(purchasername.value);
			

			this.getInvdet().setPurchasertaxno(purchasertaxno.value);
			

			this.getInvdet().setSalesname(salesname.value);
			
			this.getInvdet().setSalestaxno(salestaxno.value);
			
			// 发票状态
			String stateval=state.value;
			if ("0".equals(stateval))
			{
			  stateval="正常";
			}
			else if ("1".equals(stateval))
			{
			  stateval="失控";
			}
			else if ("2".equals(stateval))
			{
			  stateval="作废";
			}
			else if ("3".equals(stateval))
			{
			  stateval="红冲";
			}
			else if ("4".equals(stateval))
			{
			  stateval="异常";
			}
			this.getInvdet().setState(stateval);
			

			if (!invedit)
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  
			}

		}
        /**
        *   source:invl.@0005.script
        */
        public void qureyInvlst(String ownrefbus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getInvlst());

			Argument<String> inr =new Argument<String>("inr");
			Argument<String> invoicecode =new Argument<String>("invoicecode");
			Argument<String> invoicenumber =new Argument<String>("invoicenumber");
			Argument<Date> billingdate =new Argument<Date>("billingdate");
			Argument<String> checkcode =new Argument<String>("checkcode");
			Argument<String> checkresult =new Argument<String>("checkresult");
			Argument<BigDecimal> invamt =new Argument<BigDecimal>("invamt");
			Argument<String> alsnam =new Argument<String>("alsnam");
			// ocrres为2是发票识别中
			Argument<String> ocrres =new Argument<String>("ocrres");
			Argument<String> ownref =new Argument<String>("ownref");
			Argument<String> tblbilinr =new Argument<String>("tblbilinr");
			Argument<BigDecimal> gframt =new Argument<BigDecimal>("gframt");
			Argument<BigDecimal> gfrcur =new Argument<BigDecimal>("gfrcur");

			//查询发票信息
			String sql="SELECT i.inr,i.invoicecode,i.invoicenumber,i.billingdate,i.checkresult,i.invamt,i.alsnam,i.checkcode,i.ocrres,i.tblbilinr,i.ownref,su.gframt,su.gfrcur from inv i";
			sql += " left join invsup su on i.inr=su.invinr";
			sql += " where i.ownref='"+ownrefbus+"' ORDER BY i.inr ASC";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,invoicecode,invoicenumber,billingdate,checkresult,invamt,alsnam,checkcode,ownref,ocrres,tblbilinr,gframt,gfrcur);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    this.getInvlst().add(inr,invoicecode,invoicenumber,billingdate,invamt,checkresult,alsnam,checkcode,ownref,ocrres,tblbilinr,gframt,gfrcur);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			int lstsize = this.getInvlst().fullSize();
			if (lstsize>0)
			{
			  for (int i=0;i<lstsize;i++)
			  {
			    if ("核验成功".equals(this.getInvlst().getElement(i).getCheckresult())||"识别完成".equals(this.getInvlst().getElement(i).getCheckresult()))
			    {
			      
			    }
			  }
			}
			
		}



























}