package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 接口平台公共函数模块(InterfaceModule)
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Itfmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Itfmod.class);



	    @BDGetter
		private Imgmod imgmod;

	    @BDGetter
		private Xmlmod xmlmod;


		public Itfmod()
        {
            super();
            setArgument();
        }

        public Itfmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:itfmod.@0000.script
        */
        public Map scallInterface(String interfaceName,String transName, Object[] args )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *功能: 调用单证通接口平台2.0公共函数
			  * 返回值: 错误信息
			  *参数:
			  *      interfaceName - 接口名称
			  *      transName - 交易名称
			  *      args - 接口参数
			  */
			Map retMsg = new HashMap() ;
			try
			{
			  Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall",interfaceName,transName,args);
			  // 判断接口是否调用成功
			  Boolean success = (Boolean) MdaUtils.invoke(obj,"isSuccess") ;
			  log.debug("{}","success=" + success);
			  if (!success )
			  {
			    String retCode = (String) MdaUtils.invoke(obj,"getReturnCode");
			    Object content = MdaUtils.invoke(obj,"getContent") ;
			    retMsg.put("ERRORCODE", retCode);
			    retMsg.put("ERRORMSG", content);
			    log.error("{}","ResultMsg.content = "  + content ) ;
			    log.debug("{}","调用接口平台调用失败。 { isSuccess = " +success ) ;
			  }
			  else
			  {
			    String content = MdaUtils.invoke(obj,"getContent").toString() ;
			    if("true".equals(content.substring(0,5).trim()))
			    {
			      retMsg.put("ERRORCODE","00000");
			      retMsg.put("ERRORMSG", "");
			      log.debug("{}","调用接口平台成功。 { isSuccess = " +success ) ;
			      log.debug("{}","content =" + content);
			    }
			    else
			    {
			      retMsg.put("ERRORCODE",content.substring(5,10).trim());
			      retMsg.put("ERRORMSG",content);
			      log.error("{}","ResultMsg.content = "  + content ) ;
			      log.debug("{}","接口调用返回失败。 { 错误码： " +content.substring(5,10) +"，错误 原因：" + content.substring(10).trim() ) ;
			    }

			  }
			}

			catch(Exception e)
			{
			  ctx.getErrorCode();
			  log.error("{}","errormsg:" + e.getMessage());
			  Platform.setErrorInfo(retMsg,"11005","接口平台调用异常");
			}
			return retMsg;

		}
        /**
        *   source:itfmod.@0001.script
        */
        public boolean packXmlFile(String trnname,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 组装 XML报文
			  */
			log.debug("{}"," in sysmod.packXmlFile ...") ;
			boolean success = false ;
			Map<String,Object> head = this.getXmlmod().getXmlHeader();
			Map<String,Object> body = Platform.getValueMap(ctx.getRoot(),trnname,"DATA");
			Object[] args = null;
			// Map<String,Object> data = Platform.convertContentToMap($\\, trnname,"DATA");
			String interfaceName = "" ;
			String transactinName ="" ;
			String sysnum = this.getXmlmod().getDestSystemNumber();
			if(MdaUtils.isEmpty(sysnum))
			{
			  log.debug("{}","获取目标系统编号失败");
			  return  false;
			}
			else
			{
			  if("z00001".equalsIgnoreCase(sysnum))
			  {
			    interfaceName = "dztstlxmlpack" ;
			    transactinName ="dztstlxmlpack" ;
			    args = new Object[]{trnname,filename,head,body};
			  }
			  else
			    if("z00074".equalsIgnoreCase(sysnum))
			  {
			    interfaceName = "dztxmlpack" ;
			    transactinName ="dztxmlpack" ;
			    body.putAll(head);
			    args = new Object[]{trnname,filename,body};
			  }
			  else
			  {
			    log.error("{}","组装报文失败，对方系统编号不存在");
			    return false;
			  }
			  Map<String,Object> retMsg = this.scallInterface(interfaceName,transactinName,args);
			  if(Platform.isNoError(retMsg))
			  {
			    return true;
			  }
			  else
			  {
			    return false ;
			  }
			}
		}





}