package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 大额结售汇签约申请
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Jstp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Jstp.class);

        //中国光大银行人民币与外汇衍生产品业务风险揭示声明
        private String readtxt1;

        //申请人
        private String nam;

        //卖出金额大写
        private String selmax;

        //买入金额大写
        private String buymax;

        //近端买入账号按钮
        private transient IControl jbycno = new ControlImpl("jbycno", "近端买入账号按钮", this);

        //远端外币账号按钮
        private transient IControl ybycno = new ControlImpl("ybycno", "远端外币账号按钮", this);

        //近端卖出账号按钮
        private transient IControl jslcno = new ControlImpl("jslcno", "近端卖出账号按钮", this);

        //远端人民币账号按钮
        private transient IControl rmbcno = new ControlImpl("rmbcno", "远端人民币账号按钮", this);

        //提前部分交割日期
        private Date paydat;

        //未交割结售汇账号修改申请日期
        private Date ammdat;

        //大写金额
        private String maxs;

        //外币清算国家或地区
        private String curcty;

        //外币账号
        private String dybcno;

        //人民币账号
        private String drmcno;

        //掉期人民币账号
        private String dqrcno;

        //掉期外币账号
        private String dqycno;

        //是否有保证金
        private String dbzj;

        //交易种类输出转换
        private String dselty;

        //交易方向pdf输出
        private String dsflty;

        //交割方式pdf输出
        private String dgivty;

        //是否择期pdf输出
        private String dzqnty;

        //新交割方式输出
        private String dnewgivty;

        //扣除账号
        private String kctcno;

        //展示交割次数
        private String payttm;

        //交割日提醒
        private String yddat;

        //相关提示
        private String tstxt;

        //保证金协议编号
        private String bzjcno;

        //交割方式
        private String selsta;

        //交割币种
        private String jspaycur;

        //交割金额
        private BigDecimal jspayamt = new BigDecimal("0.00");

        //客户类型
        private String jspkhlb;

        //活动界面
        private IPanel transpanel;

        //条款显示
        private IPanel jstjytk;


        @JsonIgnore
        @BDGetter
        private transient IPanel jstbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstapn;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstopn1;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstopn2;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstopn3;

        @JsonIgnore
        @BDGetter
        private transient IPanel tkmain;

        @JsonIgnore
        @BDGetter
        private transient IPanel allbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel bztbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstda;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstam;

        @JsonIgnore
        @BDGetter
        private transient IPanel amebut;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstset1;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstpay1;

        @JsonIgnore
        @BDGetter
        private transient IPanel allmain;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstame1;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstpav1;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstsev0;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstptrns;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstjsh;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstjsh2;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Jsdgrp> jsdgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Tukmod tukmod;

	    @BDGetter
		private Zxjmod zxjmod;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Actmod actmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Agrp agrp;


		public Jstp()
        {
            super();
            setArgument();
        }

        public Jstp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getJsdgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("jsd"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getIsbp().setPtsptaHolder(()->this.getJsdgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("jsd"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDapp().setPtsptaHolder(()->this.getJsdgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("jsd"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTukmod().setPdfviwHolder(()->this.getPdfviw());
            this.getZxjmod().setAplHolder(()->this.getJsdgrp().getApl());
            this.getZxjmod().setIsbHolder(()->this.getJsdgrp().getIsb());
            this.getZxjmod().setPrefixsHolder(new FieldConstantHolder<>("BZ"));
            this.getZxjmod().setZxjHolder(()->this.getJsdgrp().getZxj());
        }





        public void setJsdgrpHolder(ModuleHolder<Jsdgrp> jsdgrp)
        {
           this.jsdgrp = jsdgrp;
        }

        public Jsdgrp getJsdgrp()
        {
           return this.jsdgrp.get();
        }





















































































}