package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 跨境支付清算系统报文头
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Kjshad extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Kjshad.class);

        //接口编号
        private String jkbh;

        //报文标准
        private String bwbz;

        //地区代号
        private String dqdh;

        //机构代号
        private String jgdh;

        //前台交易流水编号
        private String qtjylsbh;

        //发报日期
        private Date fbrq;




		public Kjshad()
        {
            super();
            setArgument();
        }

        public Kjshad(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:kjshad.@0000.script
        */
        public void parseHeader(Map<String,Object> data, Map<String,Object> retMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *初始化报文头
			  */
			log.debug("{}","in kjshad.parseHeader ... ");
			this.setJkbh((String)data.get("CROOT.MsgHead.JKBH"));
			this.setBwbz((String)data.get("CROOT.MsgHead.BWBZ"));
			this.setDqdh((String)data.get("CROOT.MsgHead.DQDH"));
			this.setJgdh((String)data.get("CROOT.MsgHead.JGDH"));
			this.setQtjylsbh((String)data.get("CROOT.MsgHead.QTJYLSBH"));
			this.setFbrq((Date)data.get("DROOT.MsgHead.FBRQ"));
		}
        /**
        *   source:kjshad.@0001.script
        */
        public String  getMessageType()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文头模块接口，返回报文的报文类型/报文编号
			  */
			String msgTyp = "";
			if(!MdaUtils.isEmpty(this.getJkbh()))
			{
			  msgTyp = this.getJkbh();
			}
			return msgTyp;
		}













}