package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Latp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Latp.class);

        //提交
        private transient IControl savse = new ControlImpl("savse", "提交", this);

        //电提不符点
        private IPanel bfdset;

        //To:
        private String to;

        //账号选择1
        private transient IControl yslact = new ControlImpl("yslact", "账号选择1", this);

        //账号选择2
        private transient IControl jslact = new ControlImpl("jslact", "账号选择2", this);

        //影像查阅
        private transient IControl dztlyx = new ControlImpl("dztlyx", "影像查阅", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel latp1;

        @JsonIgnore
        @BDGetter
        private transient IPanel latps;

        @JsonIgnore
        @BDGetter
        private transient IPanel letatd0;

        @JsonIgnore
        @BDGetter
        private transient IPanel letate1;

        @JsonIgnore
        @BDGetter
        private transient IPanel letate;

        @JsonIgnore
        @BDGetter
        private transient IPanel letats;

        @JsonIgnore
        @BDGetter
        private transient IPanel bfdsure;

        @JsonIgnore
        @BDGetter
        private transient IPanel bfdse;

        @JsonIgnore
        @BDGetter
        private transient IPanel rmks;

        @JsonIgnore
        @BDGetter
        private transient IPanel anniud;

        @JsonIgnore
        @BDGetter
        private transient IPanel anniue;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ledgrp> ledgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Bedgrp> bedgrp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Docgrdm docgrdm;

	    @BDGetter
		private Bnkrec bnkrec;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Actmod actmod;


		public Latp()
        {
            super();
            setArgument();
        }

        public Latp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getIsbp().setPtsptaHolder(()->this.getBedgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setPtsptaHolder(()->this.getBedgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getDapp().setPtsptaHolder(()->this.getBedgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDocgrdm().setOthdocHolder( new FieldHolder<String>(){
				public String getPath(){return Latp.this.getFieldPath("bedgrp.bnkrecd.othdoc");}
 				public void setValue(String arg){Latp.this.getBedgrp().getBnkrecd().setOthdoc(arg);}
 				public String getValue(){return Latp.this.getBedgrp().getBnkrecd().getOthdoc();}}
			 );
            this.getBnkrec().setBnkrecdHolder(()->this.getBedgrp().getBnkrecd());
            this.getBnkrec().setCmcrecdHolder(()->this.getBedgrp().getCmcrecd());
            this.getBenp().setPtsptaHolder(()->this.getBedgrp().getBen());
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getAplp().setPtsptaHolder(()->this.getBedgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("bed"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
        }




        /**
        *   source:latp.@0002.script
        */
        public void latdis()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			//Platform.disable($bedgrp\\rec\\isadd);
			//Platform.disable($bedgrp\\rec\\bfdnote);
			
			
			
		}
        /**
        *   source:latp.@0003.script
        */
        public void getBchcod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bchcod =ctx.absGet(Sysmod.class).getAndSetBchcodvals();
			MdaUtils.setValues(this.getBedgrp().getRec(),"bchcod",bchcod);
			if(!MdaUtils.isEmpty(this.getBedgrp().getRec().getBchcod()))
			{
			  
			}
			
		}
        /**
        *   source:latp.@0004.script
        */
        public BigDecimal getVals(BigDecimal vals)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","vals    值："+vals);
			long vall=vals.longValue();
			String vals1=vals.toString();
			String vall1=String.valueOf(vall);
			//BigDecimal valss=Platform.parseDecimal(vall);
			//if(valss.compareTo(vals)==0)
			if(vals1.equals(vall1))
			{
			  String valsue=vals1+".00";
			  return MdaUtils.parseDecimal(valsue);
			}
			else
			{
			  return vals;
			}
		}

        public void setLedgrpHolder(ModuleHolder<Ledgrp> ledgrp)
        {
           this.ledgrp = ledgrp;
        }

        public Ledgrp getLedgrp()
        {
           return this.ledgrp.get();
        }

        public void setBedgrpHolder(ModuleHolder<Bedgrp> bedgrp)
        {
           this.bedgrp = bedgrp;
        }

        public Bedgrp getBedgrp()
        {
           return this.bedgrp.get();
        }































}