package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 进口信用证s
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Litp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Litp.class);

        //信用证办理落地机构
        private String bchcod;

        //申请人机构中文名称
        private String aplnam;

        //落地机构2
        private String bchcods;

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //远期天数
        private int tedays;

        //远期天数
        private String usapro;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //不需要汇票
        private String nodra;

        //落地机构pdf显示值
        private String bchcodpdf;

        //PDF预览
        private transient IControl pdfshw = new ControlImpl("pdfshw", "PDF预览", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //开立过信用证草稿
        private String lcflg;

        //信用证草稿编号
        private String pegref;

        //获取信用证合同协议编号
        private transient IControl getlxdref = new ControlImpl("getlxdref", "获取信用证合同协议编号", this);

        //信用证申请预览
        private transient IControl pdflid = new ControlImpl("pdflid", "信用证申请预览", this);

        //信用证合同预览
        private transient IControl pdflxd = new ControlImpl("pdflxd", "信用证合同预览", this);

        //保证金协议预览
        private transient IControl pdfbxd = new ControlImpl("pdfbxd", "保证金协议预览", this);

        //委托开户及扣划预览
        private transient IControl pdfmar = new ControlImpl("pdfmar", "委托开户及扣划预览", this);

        //修改汇票信息
        private String moddraft;

        //增加后的金额
        private BigDecimal tepaam = new BigDecimal("0.00");

        //增运货物
        private String addgod;

        //预览测试
        private transient IControl pdfviwtest = new ControlImpl("pdfviwtest", "预览测试", this);

        //是否输入最迟装货期
        private String shpdatflg;

        //是否输入装运期
        private String shppodflg;

        //是否修改日期
        private String ameshpflg;

        //是否增加信用证金额
        private String ameincflg;

        //是否减少信用证金额
        private String amedecflg;

        //是否增装货物
        private String amegodflg;

        //其他修改内容
        private String ametxt;

        //人民币常用账户
        private transient IControl accbtn = new ControlImpl("accbtn", "人民币常用账户", this);

        //tips
        private transient IControl tipurl = new ControlImpl("tipurl", "tips", this);

        //测试
        private transient IControl testbtn = new ControlImpl("testbtn", "测试", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel comlit;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp06;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp07;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp08;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp09;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp10;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp11;

        @JsonIgnore
        @BDGetter
        private transient IPanel ttrcom01;

        @JsonIgnore
        @BDGetter
        private transient IPanel litp12;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpav;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpre;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpeg;

        @JsonIgnore
        @BDGetter
        private transient IPanel litfav;

        @JsonIgnore
        @BDGetter
        private transient IPanel litapn;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtdav;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp1edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp2edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp3edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp4edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp1bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstpbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp2bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp3bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp4bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpre01;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpre02;

        @JsonIgnore
        @BDGetter
        private transient IPanel litpeg02;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel litapn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp5edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp5bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp6edt;

        @JsonIgnore
        @BDGetter
        private transient IPanel litstp6bd;

        @JsonIgnore
        @BDGetter
        private transient IPanel litapn00;

        @JsonIgnore
        @BDGetter
        private transient IPanel litapn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdltop;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl07;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl08;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl09;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl10;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl11;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl12;

        @JsonIgnore
        @BDGetter
        private transient IPanel litmdl13;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfm01;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfm02;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfmtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfmstep01;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfmstep02;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtdav01;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtdavtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfm03;

        @JsonIgnore
        @BDGetter
        private transient IPanel lxtcfmstep03;

        @JsonIgnore
        @BDGetter
        private transient IPanel nlitp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel nlitp;

        @JsonIgnore
        @BDGetter
        private transient IPanel littopbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel litopn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fpdopn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel fpdopn;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Afdgrp> afdgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Lidgrp> lidgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp benp;

	    @BDGetter
		private Ptsp advp;

	    @BDGetter
		private Ptsp drep;

	    @BDGetter
		private Ptsp mbenp;

	    @BDGetter
		private Ptsp aplbp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp rmbp;

	    @BDGetter
		private Ptsp tdbp;

	    @BDGetter
		private Ptsp avbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Ptsp trpp;

	    @BDGetter
		private Txmmod lcrdoc;

	    @BDGetter
		private Txmmod adlcnd;

	    @BDGetter
		private Txmmod trstxt;

	    @BDGetter
		private Txmmod opncls;

	    @BDGetter
		private Txmmod swfd;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Bummod bummod;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Bxdmod bxdmod;

	    @BDGetter
		private Ptsp conp;

	    @BDGetter
		private Fpdgrp fpdgrp;

	    @BDGetter
		private Actmod actmod;

	    @BDGetter
		private Agrp agrp;


		public Litp()
        {
            super();
            setArgument();
        }

        public Litp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getLidgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getBenp().setPtsptaHolder(()->this.getLidgrp().getBen());
            this.getBenp().setRolHolder(new FieldConstantHolder<>("ben"));
            this.getBenp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getBenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getAdvp().setPtsptaHolder(()->this.getLidgrp().getAdv());
            this.getAdvp().setRolHolder(new FieldConstantHolder<>("adv"));
            this.getAdvp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getAdvp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getDrep().setPtsptaHolder(()->this.getLidgrp().getDre());
            this.getDrep().setRolHolder(new FieldConstantHolder<>("dre"));
            this.getDrep().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getDrep().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getMbenp().setPtsptaHolder(()->this.getLidgrp().getMben());
            this.getMbenp().setRolHolder(new FieldConstantHolder<>("mben"));
            this.getMbenp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getMbenp().setFlgHolder(new FieldConstantHolder<>("ben"));
            this.getAplbp().setPtsptaHolder(()->this.getLidgrp().getAplb());
            this.getAplbp().setRolHolder(new FieldConstantHolder<>("aplb"));
            this.getAplbp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getAplbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getIsbp().setPtsptaHolder(()->this.getLidgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getRmbp().setPtsptaHolder(()->this.getLidgrp().getRmb());
            this.getRmbp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getRmbp().setRolHolder(new FieldConstantHolder<>("rmb"));
            this.getRmbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getTdbp().setPtsptaHolder(()->this.getLidgrp().getTdb());
            this.getTdbp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getTdbp().setRolHolder(new FieldConstantHolder<>("tdb"));
            this.getTdbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAvbp().setPtsptaHolder(()->this.getLidgrp().getAvb());
            this.getAvbp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getAvbp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getAvbp().setRolHolder(new FieldConstantHolder<>("avb"));
            this.getDapp().setPtsptaHolder(()->this.getLidgrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getTrpp().setPtsptaHolder(()->this.getLidgrp().getTrp());
            this.getTrpp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getTrpp().setRolHolder(new FieldConstantHolder<>("trp"));
            this.getTrpp().setFlgHolder(new FieldConstantHolder<>("trp"));
            this.getLcrdoc().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.blk.lcrdoc");}
 				public void setValue(String arg){Litp.this.getLidgrp().getBlk().setLcrdoc(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getBlk().getLcrdoc();}}
			 );
            this.getLcrdoc().setTxmgrpHolder(new FieldConstantHolder<>("lcrdoc"));
            this.getAdlcnd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.blk.adlcnd");}
 				public void setValue(String arg){Litp.this.getLidgrp().getBlk().setAdlcnd(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getBlk().getAdlcnd();}}
			 );
            this.getAdlcnd().setTxmgrpHolder(new FieldConstantHolder<>("adlcnd"));
            this.getTrstxt().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getTrstxt().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.blk.trstxt");}
 				public void setValue(String arg){Litp.this.getLidgrp().getBlk().setTrstxt(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getBlk().getTrstxt();}}
			 );
            this.getOpncls().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.blk.rgtcls");}
 				public void setValue(String arg){Litp.this.getLidgrp().getBlk().setRgtcls(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getBlk().getRgtcls();}}
			 );
            this.getOpncls().setTxmgrpHolder(new FieldConstantHolder<>("rgtclu"));
            this.getSwfd().setTxmblockHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.swfd");}
 				public void setValue(String arg){Litp.this.getLidgrp().setSwfd(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getSwfd();}}
			 );
            this.getSwfd().setTxmgrpHolder(new FieldConstantHolder<>("adlcnd"));
            this.getBxdmod().setBxdHolder(()->this.getLidgrp().getBxd());
            this.getBxdmod().setMarHolder(()->this.getLidgrp().getMar());
            this.getBxdmod().setObjtypHolder(new FieldConstantHolder<>("lid"));
            this.getBxdmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.rec.inr");}
 				public void setValue(String arg){Litp.this.getLidgrp().getRec().setInr(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getRec().getInr();}}
			 );
            this.getBxdmod().setRefHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.rec.ownref");}
 				public void setValue(String arg){Litp.this.getLidgrp().getRec().setOwnref(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getRec().getOwnref();}}
			 );
            this.getBxdmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.rec.ptyinr");}
 				public void setValue(String arg){Litp.this.getLidgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getRec().getPtyinr();}}
			 );
            this.getBxdmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Litp.this.getFieldPath("lidgrp.rec.bchcod");}
 				public void setValue(String arg){Litp.this.getLidgrp().getRec().setBchcod(arg);}
 				public String getValue(){return Litp.this.getLidgrp().getRec().getBchcod();}}
			 );
            this.getBxdmod().setBxdprefixHolder(new FieldConstantHolder<>("JX"));
            this.getBxdmod().setMarprefixHolder(new FieldConstantHolder<>("MZ"));
            this.getBxdmod().setMxdlstHolder(()->this.getLidgrp().getMxdlst());
            this.getConp().setRolHolder(new FieldConstantHolder<>("con"));
            this.getConp().setBelongtoHolder(new FieldConstantHolder<>("lid"));
            this.getConp().setFlgHolder(new FieldConstantHolder<>("agt"));
            this.getConp().setPtsptaHolder(()->this.getLidgrp().getCon());
        }

        /**
        *   source:litp.@0012.script
        */
        @Rule(target="getlxdref",order=100)
        public boolean ruleGetlxdrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getLidgrp().getLxd(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "LX");
			if(TRUE.equals(this.getLidgrp().getChecked3()))
			{
			  this.getLidgrp().getBxd().setHtbh(this.getLidgrp().getLxd().getOwnref());
			  
			  
			}

			return true;
        }



        /**
        *   source:litp.@0003.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//灰显部分输入域
			//Platform.disable($lidgrp\\rec\\ownref);
			
			return true;
        }


        /**
        *   source:litp.@0000.script
        */
        public void initTrscom(String trsnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getOrdinr()))
			  ctx.absGet(Trnmod.class).ordNew();
			List<CodetableItem> bchcod =ctx.absGet(Sysmod.class).getAndSetBchcodvals();
			MdaUtils.setValues(this.getLidgrp().getRec(),"bchcod",bchcod);
			
			
			//设置必输项
			
			
			
			
			
			
			//Platform.dbRead($trstxt\\cls,new Argument<String>("flg","3"),new Argument<String>("typ",trsnam),new Argument<String>("status","0"));
			this.getTrstxt().setClstyp(trsnam);
			if(MdaUtils.isEmpty(this.getLidgrp().getBlk().getTrstxt()))
			{
			  ctx.getDaoSession().dbRead(this.getTrstxt().getCls(),new Argument<String>("inr",this.getTrstxt().readDefaultClsInr(trsnam)));
			  this.getLidgrp().getBlk().setTrstxt(this.getTrstxt().getCls().getClstxt());
			}
			if(!MdaUtils.isEmpty(bchcod)&&!ctx.absGet(Sysmod.class).sptIsLoaded("B")&&!ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  this.getLidgrp().getRec().setBchcod(bchcod.get(0).getValue());
			if(ctx.absGet(Sysmod.class).sptIsLoaded("B")  ||  ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			  return;
			this.getLidgrp().getDap().initDap("lid");
			//$lidgrp\\apl\\pts.copyValue($lidgrp\\dap\\pts);
			this.getLidgrp().getApl().getPts().setRol("apl");
			//申请人银行赋初值
			ctx.getDaoSession().dbRead(this.getLidgrp().getAplb().getPty(),new Argument<String>("inr",ctx.absGet(Sysmod.class).getPty().getInr()));
			ctx.getDaoSession().dbRead(this.getLidgrp().getAplb().getPta(),new Argument<String>("ptyinr",this.getLidgrp().getAplb().getPty().getInr()));
			ctx.getDaoSession().dbRead(this.getLidgrp().getAplb().getAdr(),new Argument<String>("inr",this.getLidgrp().getAplb().getPta().getObjinr()));
			this.getLidgrp().getAplb().getPts().setRol("aplb");
			this.getLidgrp().getAplb().getPts().setPtyinr(this.getLidgrp().getAplb().getPty().getInr());
			this.getLidgrp().getAplb().getPts().setObjtyp("lid");
			this.getLidgrp().getAplb().getPts().setNam(this.getLidgrp().getAplb().getPty().getEngnam());
			String adrblk = this.getLidgrp().getAplb().getPty().getEngnam()+CR+this.getLidgrp().getAplb().getAdr().getAdr();
			this.getLidgrp().getAplb().getPts().setAdrblk(adrblk);
			this.getLidgrp().getAplb().getPts().setExtkey(this.getLidgrp().getAplb().getPty().getExtkey());
			this.getLidgrp().getAplb().getPts().setRef("");
			this.getLidgrp().getAplb().getPts().setPtainr(this.getLidgrp().getAplb().getPta().getInr());
			this.getLidgrp().getRec().setConcur("USD");
			this.getLidgrp().getRec().setCredat(MdaUtils.today());
			this.getLidgrp().getRec().setTrfflg("1");
			this.getLidgrp().getRec().setApprul("1");
			this.getLidgrp().getRec().setApprultxt("UCP LATEST VERSION");
			//$lidgrp\\rec\\expdat.setValue(Platform.today());
			this.getLidgrp().getRec().setIsscur("USD");
			//$lidgrp\\rec\\avbwth.setValue("ANY BANK");
			//Platform.disable($lidgrp\\rec\\avbwth);
			this.getLidgrp().getRec().setAvbwths("1");
			this.getLidgrp().getRec().setAvbwth("ANY BANK");
			this.getLidgrp().getRec().setAvbby("4");
			this.getLidgrp().getRec().setShppar("2");
			this.getLidgrp().getRec().setShptrs("2");
			//Platform.disable($lidgrp\\blk\\defdet);
			//Platform.disable($lidgrp\\blk\\mixdet);
			//条款初始化
			this.getLidgrp().getBlk().setFeetxt("+ALL CHARGES AND COMMISSIONS OUTSIDE ISSUING BANK AND REIMBURSEMENT CHARGES,HANDLING CHARGES ARE FOR BENEFICIARY'S ACCOUNT.");
			// $lidgrp\\blk\\prepod.setValue("+Documents to be presented within 21 days after date of shipment but within the validity of this credit.");
			this.getLidgrp().getBlk().setNegins("+THE AMOUNT AND DATE OF EACH NEGOTIATION MUST BE ENDORSED ON THE BACK OF THE CREDIT.");
			this.getLidgrp().getRec().setPreper("Documents To Be Presented Within 21 Days After The Date Of SHIPMENT ,But Within The Validity Of The Credit.");
			this.getLidgrp().getRec().setCnfflg("3");
		}
        /**
        *   source:litp.@0001.script
        */
        public void avbbyChange(String avbby)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("1".equals(avbby))
			{
			  //By Acceptance
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  
			  
			  
			  //  Platform.enable($lidgrp\\dre\\pts\\extkey);
			  //  Platform.enable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("2".equals(avbby))
			{
			  //By Def Payment
			  
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  this.getLidgrp().getBlk().setDftat(NULLSTR);
			  
			  
			  
			  // Platform.clear($lidgrp\\dre\\pts\\extkey);
			  // Platform.clear($lidgrp\\dre\\pts\\adrblk);
			  
			  
			  // Platform.disable($lidgrp\\dre\\pts\\extkey);
			  // Platform.disable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("3".equals(avbby))
			{
			  //By Mixed Pymt
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  
			  
			  this.getLidgrp().getBlk().setDftat(NULLSTR);
			  // Platform.clear($lidgrp\\dre\\pts\\extkey);
			  // Platform.clear($lidgrp\\dre\\pts\\adrblk);
			  
			  
			  
			  
			  // Platform.disable($lidgrp\\dre\\pts\\extkey);
			  //  Platform.disable($lidgrp\\dre\\pts\\adrblk);
			}
			else if("4".equals(avbby))
			{
			  //By Negotiation
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  // Platform.enable($lidgrp\\dre\\pts\\extkey);
			  // Platform.enable($lidgrp\\dre\\pts\\adrblk);
			  
			  
			  
			}
			else if("5".equals(avbby))
			{
			  //By Payment
			  this.getLidgrp().getBlk().setDefdet(NULLSTR);
			  this.getLidgrp().getBlk().setMixdet(NULLSTR);
			  
			  
			  
			  // Platform.enable($lidgrp\\dre\\pts\\extkey);
			  // Platform.enable($lidgrp\\dre\\pts\\adrblk);
			  
			  
			  
			}
			//Platform.setModified($lidgrp\\rec\\avbwths);
			//Platform.setModified($lidgrp\\rec\\avbwth);
			// Platform.setModified($lidgrp\\avb\\pts\\extkey);
			// Platform.setModified($lidgrp\\avb\\pts\\adrblk);
			
			
			
			// Platform.setModified($lidgrp\\dre\\pts\\extkey);
			// Platform.setModified($lidgrp\\dre\\pts\\adrblk);
					}
        /**
        *   source:litp.@0002.script
        */
        public List<CodetableItem> getAvbbyCodeTable(String tenor)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in litp.getAvbbyCodetable ...") ;
			List<CodetableItem> items =  new ArrayList<CodetableItem>();
			if("U".equals(tenor))
			{
			  items.add(new CodetableItem("BY ACCEPTANCE","1"));
			  items.add(new CodetableItem("By DEF PAYMENT","2"));
			  items.add(new CodetableItem("BY MIXED PYMT","3"));
			  items.add(new CodetableItem("BY NEGOTIATION","4"));
			}
			else
			  if("S".equals(tenor))
			{
			  items.add(new CodetableItem("BY PAYMENT","5"));
			  items.add(new CodetableItem("BY NEGOTIATION","4"));
			}
			return items;
		}
        /**
        *   source:litp.@0015.script
        */
        public void loadTips()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getLidgrp().getTips()))
			{
			  String tips="Tips:操作指引";
			  tips+=CR+"一、业务发起流程";
			  tips+=CR+"1、贵司应至少提交“进口信用证开立申请书”和“信用证合同”，并根据实际需要选择是否提交“保证金协议、保证金委托开户及扣划申请”。";
			  tips+=CR+"2、客户可以通过手工输入或调用历史模板快速编辑并提交业务申请； ";
			  tips+=CR+"二、申请书与合同/协议的修改流程 ";
			  tips+=CR+"1、贵司提交的申请书有任何不妥均须由贵司自行修改。届时银行将把申请交易退回单证通“退回文件夹”，由贵司进行修改； ";
			  tips+=CR+"2、贵司提交的合同/协议若需要修改，银行客户经理可代为修改，修改完毕将修改结果返回单证通“二次确认夹”供贵司确认后再行提交。";
			  this.getLidgrp().setTips(tips);
			}

		}

        public void setAfdgrpHolder(ModuleHolder<Afdgrp> afdgrp)
        {
           this.afdgrp = afdgrp;
        }

        public Afdgrp getAfdgrp()
        {
           return this.afdgrp.get();
        }

        public void setLidgrpHolder(ModuleHolder<Lidgrp> lidgrp)
        {
           this.lidgrp = lidgrp;
        }

        public Lidgrp getLidgrp()
        {
           return this.lidgrp.get();
        }





















































































































}