package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Marp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Marp.class);

        //获取参号
        private transient IControl getref = new ControlImpl("getref", "获取参号", this);

        //选择
        private transient IControl select = new ControlImpl("select", "选择", this);

        //保证金协议pdf
        private transient IControl bzjpdf = new ControlImpl("bzjpdf", "保证金协议pdf", this);

        //开户及扣划pdf
        private transient IControl khkhpdf = new ControlImpl("khkhpdf", "开户及扣划pdf", this);

        //单证通影像编号
        private String dztimgref;


        @JsonIgnore
        @BDGetter
        private transient IPanel marp;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn00;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn04;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn05;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl01;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl02;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl03;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl04;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl05;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl06;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl07;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl08;

        @JsonIgnore
        @BDGetter
        private transient IPanel marmdl00;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn06;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn07;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn09;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn08;

        @JsonIgnore
        @BDGetter
        private transient IPanel maropn10;

        @JsonIgnore
        @BDGetter
        private transient IPanel marcfm00;

        @JsonIgnore
        @BDGetter
        private transient IPanel marcfm01;

        @JsonIgnore
        @BDGetter
        private transient IPanel marcfm02;

        @JsonIgnore
        @BDGetter
        private transient IPanel marcfm03;

        @JsonIgnore
        @BDGetter
        private transient IPanel mardav01;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Margrp> margrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Cidmod cidmod;

	    @BDGetter
		private Bummod bummod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Sigtip sigtip;


		public Marp()
        {
            super();
            setArgument();
        }

        public Marp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getMargrp().getApl());
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("mar"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getDapp().setPtsptaHolder(()->this.getMargrp().getDap());
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("mar"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("cmc"));
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
        }

        /**
        *   source:marp.@0000.script
        */
        @Rule(target="getref",order=100)
        public boolean ruleGetrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			IDatafield<String> ownref= MdaDriver.getDatafield(this.getMargrp().getBxd(),"ownref");
			ctx.absGet(Mtabut.class).getRefrence( ownref,  "JX");

			return true;
        }




        /**
        *   source:marp.@0002.script
        */
        public void encode()     //处理账户信息列表数据集
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getMargrp().setAcc(NULLSTR);
			this.getMargrp().setAccnam(NULLSTR);
			this.getMargrp().setOpnd(NULLSTR);
			this.getMargrp().setBzjbz(NULLSTR);
			this.getMargrp().setBzjje(NULLSTR);
			int len = this.getMargrp().getMxdlst().fullSize();
			StringBuffer acc=new StringBuffer();
			StringBuffer accnam=new StringBuffer();
			StringBuffer opnd=new StringBuffer();
			StringBuffer bzjbz=new StringBuffer();
			StringBuffer bzjje=new StringBuffer();
			String conn="";
			String cc = null;
			BigDecimal bd = null;
			for(int i=0;i<len;i++)
			{
			  cc = this.getMargrp().getMxdlst().getElement(i).getAcc();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  acc.append(conn).append(cc);

			  cc = this.getMargrp().getMxdlst().getElement(i).getAccnam();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  accnam.append(conn).append(cc);

			  cc = this.getMargrp().getMxdlst().getElement(i).getOpnd();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  opnd.append(conn).append(cc);

			  cc = this.getMargrp().getMxdlst().getElement(i).getBzjbz();
			  if(MdaUtils.isEmpty(cc))
			    cc="";
			  bzjbz.append(conn).append(cc);

			  bd = this.getMargrp().getMxdlst().getElement(i).getBzjje();
			  log.debug("{}",""+bd+(bd.compareTo(new BigDecimal(0))!=0));
			  if(MdaUtils.isEmpty(cc)&&bd.compareTo(new BigDecimal(0))==0)
			    bzjje.append(conn).append("");
			  else
			    bzjje.append(conn).append(bd.setScale(2));

			  conn = ",";
			}
			// log.info("atcnum:"+atcnum);
			// log.info("atccur:"+atccur);
			// log.info("atcamt:"+atcamt);
			// log.info("chkcur:"+chkcur);
			// log.info("chkamt:"+chkamt);
			this.getMargrp().setAcc(acc.toString());
			this.getMargrp().setAccnam(accnam.toString());
			this.getMargrp().setOpnd(opnd.toString());
			this.getMargrp().setBzjbz(bzjbz.toString());
			this.getMargrp().setBzjje(bzjje.toString());

		}
        /**
        *   source:marp.@0003.script
        */
        public boolean checkMxdlist()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(this.getMargrp().getMxdlst().fullSize() > 5)
			{
			  ctx.setMessage(MdaUtils.getI18NString("marp","CT000299"),MdaUtils.getI18NString("marp","CT000300"));
			  return false;
			}
			for(int i=0;i<this.getMargrp().getMxdlst().fullSize();i++)
			{
			  if(MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getAcc()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("marp","CT000301")+(i+1)+MdaUtils.getI18NString("marp","CT000302"),MdaUtils.getI18NString("marp","CT000304"));
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getOpnd()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("marp","CT000305")+(i+1)+MdaUtils.getI18NString("marp","CT000306"),MdaUtils.getI18NString("marp","CT000307"));
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getBzjbz()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("marp","CT000308")+(i+1)+MdaUtils.getI18NString("marp","CT000309"),MdaUtils.getI18NString("marp","CT000310"));
			    return false;
			  }
			  if(MdaUtils.isEmpty(this.getMargrp().getMxdlst().getElement(i).getBzjje()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("marp","CT000311")+(i+1)+MdaUtils.getI18NString("marp","CT000312"),MdaUtils.getI18NString("marp","CT000313"));
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:marp.@0007.script
        */
        public void bxdDescription()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			//甲方
			
			
			//乙方（单位）
			
			
			//乙方（单位）收件信息
			
			
			
			
			
			//乙方（单位）代收人信息可输
			
			
			
			
			//乙方(自然人)信息不可输
			
			
			
			//乙方(自然人)收件信息不可输
			
			
			
			
			//乙方(自然人)代收人信息
			
			
			
			

			
			
			

			
			
			
			
			
			
			
		}
        /**
        *   source:marp.@0008.script
        */
        public void marDescription()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			
			
			

			
			
			
			
			
			
			
			
			
			
			
			
			

			
			
			
		}
        /**
        *   source:marp.@0013.script
        */
        public void marWtkhbzjDeal()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","execute 委托扣划保证金账户信息表 event  checkes  .......");
			//委托扣划保证金账户信息表
			if(!MdaUtils.isEmpty(this.getMargrp().getMar().getWtkhbzj()))
			{
			  
			  
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getMargrp().getMar().setCur(NULLSTR);
			  this.getMargrp().getMar().setAmt(new BigDecimal(0));
			  this.getMargrp().getMar().setNote(NULLSTR);
			  
			  
			  
			  
			  
			  

			  int size=this.getMargrp().getMxdlst().fullSize();
			  if(size>0)
			  {
			    log.info("{}","!!!!size = " + size);
			    for(int i=0;i<size;i++ )
			    {
			      this.getMargrp().getMxdlst().remove(i);
			      size=this.getMargrp().getMxdlst().fullSize();
			      i--;
			    }
			  }
			  

			}
			
			
			
			
			
		}
        /**
        *   source:marp.@0014.script
        */
        public void marWtklbzjzhDeal()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			log.info("{}","execute委托开立保证金账户信息表 event  checkes  .......");
			if(!MdaUtils.isEmpty(this.getMargrp().getMar().getWtklbzjzh()))
			{
			  //委托开立保证金账户信息表
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  //Platform.setRequired($margrp\\mar\\ckrlb);
			  
			  
			  
			  
			  
			  
			}
			else
			{
			  this.getMargrp().getMar().setAplnam(NULLSTR);
			  this.getMargrp().getMar().setDh(NULLSTR);
			  this.getMargrp().getMar().setDz(NULLSTR);
			  this.getMargrp().getMar().setCwlxr(NULLSTR);
			  this.getMargrp().getMar().setCzhm(NULLSTR);
			  this.getMargrp().getMar().setYb(NULLSTR);
			  this.getMargrp().getMar().setCkrlb(NULLSTR);
			  this.getMargrp().getMar().setZzjgdm(NULLSTR);
			  this.getMargrp().getMar().setFddbr(NULLSTR);
			  this.getMargrp().getMar().setNam(NULLSTR);
			  this.getMargrp().getMar().setZjzl(NULLSTR);
			  this.getMargrp().getMar().setZjhm(NULLSTR);
			  this.getMargrp().getMar().setKlzhbb(NULLSTR);

			  
			  
			  
			  
			  
			  
			  //Platform.setNotRequired($margrp\\mar\\ckrlb);
			  
			  
			  
			  
			  
			  

			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}

			
			
			
			
			
			
			
			
			
			
			
			
			

		}

        public void setMargrpHolder(ModuleHolder<Margrp> margrp)
        {
           this.margrp = margrp;
        }

        public Margrp getMargrp()
        {
           return this.margrp.get();
        }

























}