package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msgp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Msgp.class);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //保存
        private transient IControl submit = new ControlImpl("submit", "保存", this);

        //...
        private transient IControl scantrs = new ControlImpl("scantrs", "...", this);

        //确定
        private transient IControl sure = new ControlImpl("sure", "确定", this);

        //更新
        private transient IControl update = new ControlImpl("update", "更新", this);

        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel selmsg;

        @JsonIgnore
        @BDGetter
        private transient IPanel addmsg;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwmsg;

        @JsonIgnore
        @BDGetter
        private transient IPanel trslst;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Msggrp> msggrp;


		public Msgp()
        {
            super();
            setArgument();
        }

        public Msgp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:msgp.@0000.script
        */
        public void loadMsgList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除数据列表
			MdaUtils.clear(this.getMsggrp().getMsglst());
			//String sql = "SELECT * FROM msg";
			ctx.getDaoSession().dbReadset(this.getMsggrp().getMsglst(),new Argument<String>("ptyinr",ctx.absGet(Sysmod.class).getUsr().getPtyinr()));
			
		}
        /**
        *   source:msgp.@0001.script
        */
        public void loadModList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getMsggrp().getModlst());
			//Platform.dbReadset($msggrp\\modlst);
			//modtyp-1,通知类
			ctx.getDaoSession().dbReadset(this.getMsggrp().getModlst(),new Argument<String>("modtyp","1"));
		}

        public void setMsggrpHolder(ModuleHolder<Msggrp> msggrp)
        {
           this.msggrp = msggrp;
        }

        public Msggrp getMsggrp()
        {
           return this.msggrp.get();
        }















}