package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Notmsg;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Msgsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Msgsvr.class);



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

	    @BDGetter
		private Notmsg notmsg;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Spt> spt;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Usr usr;

	    @BDGetter
		private Notmod notmod;


		public Msgsvr()
        {
            super();
            setArgument();
        }

        public Msgsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:msgsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*判断开关是否打开*/
			log.info("{}","......msgsvr doHandle ......");
			boolean flag=false;
			String ptyinr =this.getWfe().getPtyinr();
			String oid=this.getWfe().getRol();
			MdaUtils.clear(this.getPty());
			MdaUtils.clear(this.getUsr());
			ctx.getDaoSession().dbRead(this.getPty(),new Argument("inr",ptyinr));
			if(!MdaUtils.isEmpty(this.getPty().getInr()))
			{
			  flag= this.getNotmod().checkSwitch(this.getPty().getCid());
			}
			if(flag)
			{
			  /*获取待发送信息*/
			  MdaUtils.clear(this.getNotmsg());
			  ctx.getDaoSession().dbRead(this.getNotmsg(),new Argument<String>("inr",this.getWfe().getSrvtxt()));
			  if(MdaUtils.isEmpty(this.getNotmsg().getInr()))
			  {
			    log.info("{}","......msgsvr notmsg error ......");
			    return Platform.errorHandle(this.getWfe(),"Msg load error");
			  }
			  log.info("{}","errorcode :"+ctx.getErrorCode());
			  /*更具待发送信息模板编号获取用户信息*/
			  Object modnum=this.getNotmsg().getModnum();
			  Object msgtype=this.getNotmsg().getMsgtype();
			  Object desc1=this.getNotmsg().getDesc1();
			  Object desc2=this.getNotmsg().getDesc2();
			  Object desc3=this.getNotmsg().getDesc3();
			  Object desc4=this.getNotmsg().getDesc4();
			  Object desc5=this.getNotmsg().getDesc5();
			  Object desc6=this.getNotmsg().getDesc6();
			  Object desc7=this.getNotmsg().getDesc7();
			  Object desc8=this.getNotmsg().getDesc8();
			  /*获取idc*/
			  String cid = this.getPty().getCid();
			  String ptynam = this.getPty().getNam();
			  Object tmputno=getidc(cid);

			  /*调用5082接口*/
			  Object usremid=  u5082(cid,oid,ptynam);
			  if(!MdaUtils.isEmpty(usremid))
			  {
			    /*调消息推送接口*/
			    boolean t=  pushmsg(modnum,desc1,desc2,desc3,desc4,desc5,desc6,desc7,desc8,tmputno,usremid);
			    if(t)
			    {
			      log.info("{}","短信发送成功！");
			      ctx.getDaoSession().dbBegin();
			      this.getWfe().setSta("D");
			      ctx.getDaoSession().dbUpdate(this.getWfe());
			      ctx.getDaoSession().dbCommit();
			      return true;
			    }
			    else
			    {
			      log.error("{}","发送失败");
			      return Platform.errorHandle(this.getWfe(),"发送失败！");

			    }
			  }
			  else
			  {
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    this.getWfe().setTxt("usremid is empty");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    return true;
			  }
			}
			else
			{
			  ctx.getDaoSession().dbBegin();
			  this.getWfe().setSta("E");
			  this.getWfe().setTxt("switch is closed");
			  ctx.getDaoSession().dbUpdate(this.getWfe());
			  ctx.getDaoSession().dbCommit();
			  return true;
			}
		}
        /**
        *   source:msgsvr.@0001.script
        */
        public Boolean checkSwitch(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean flag = false;
			//通过客户号查询开关表
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> switchtyp = new Argument<String>("switchtyp");
			Argument<String> gsta = new Argument<String>("gsta");
			String sql="select inr,switchtyp,gsta from swit where cid = '"+cid+"' ";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(inr,switchtyp,gsta);
			if(MdaUtils.isEmpty(switchtyp.value) || "1".equals(switchtyp.value))
			{
			  if("1".equals(gsta.value))
			  {
			    flag = true;
			  }
			}
			if("2".equals(switchtyp.value) && "1".equals(gsta.value))
			{
			  flag = true;
			}
			ctx.getDaoSession().dbCloseCursor();
			return flag;
		}
        /**
        *   source:msgsvr.@0002.script
        */
        public Object u5082(String cid ,String oid,String nam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object vv0a04=cid;
			Object vv0a03=nam;
			Object vv0a12=oid;
			String cls="com.brilliance.eibs.main.Client";
			Object rtnVal = MdaUtils.invoke(cls,"scall","WY_5082EMID","WY_5082EMID",new Object[]{vv0a04,vv0a03,vv0a12});
			Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			String errcod = (String)retMsg.get("errorCode");
			if("00000".equals(errcod))
			{
			  Object objm = retMsg.get("em_usr_id");
			  log.info("{}","em_usr_id"+objm);
			  if(!MdaUtils.isEmpty(objm))
			  {
			    return objm;
			  }
			}
			if(!"00000".equals(errcod))
			  log.error("{}",retMsg.get("errorDesp"));
			return null;
		}
        /**
        *   source:msgsvr.@0003.script
        */
        public boolean pushmsg(Object modnum,Object desc1,Object desc2,Object desc3,Object desc4,Object desc5,Object desc6,Object desc7,Object desc8,Object tmputno,Object usremid )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String cls="com.brilliance.eibs.main.Client";
			Object rtnVal = MdaUtils.invoke(cls,"scall","msgpush","msgpush",new Object[]{modnum,desc1,desc2,desc3,desc4,desc5,desc6,desc7,desc8,tmputno,usremid});
			Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			String errcod = (String)retMsg.get("errorCode");
			if("00000".equals(errcod))
			{
			  log.debug("{}","接口调用成功！");

			  return true;
			}
			if(!"00000".equals(errcod))
			  log.error("{}","push msg error:"+retMsg.get("errorDesp"));
			return false;
		}
        /**
        *   source:msgsvr.@0004.script
        */
        public String  getidc(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> idc = new Argument<String>("idc");
			String sql = "SELECT distinct idc FROM pty WHERE cid='"+cid+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(idc);
			ctx.getDaoSession().dbCloseCursor();
			return idc.value;
		}

        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }



        public void setSptHolder(ModuleHolder<Spt> spt)
        {
           this.spt = spt;
        }

        public Spt getSpt()
        {
           return this.spt.get();
        }

        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }







}