package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Xptqna;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 公共按钮模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mtabut extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Mtabut.class);

        //提交
        private transient IControl sav = new ControlImpl("sav", "提交", this);

        //自动校验
        private transient IControl chk = new ControlImpl("chk", "自动校验", this);

        //申请书
        private IStream apldoc = new StreamImpl();

        //暂存
        private transient IControl ped = new ControlImpl("ped", "暂存", this);

        //报文草稿
        private transient IControl sftdra = new ControlImpl("sftdra", "报文草稿", this);

        //邮件
        private transient IControl mail = new ControlImpl("mail", "邮件", this);

        //交易数据
        private IStream trnstm = new StreamImpl();

        //退回更正
        private transient IControl back = new ControlImpl("back", "退回更正", this);

        //发送
        private transient IControl sendmail = new ControlImpl("sendmail", "发送", this);

        //excel导出
        private transient IControl excel = new ControlImpl("excel", "excel导出", this);

        //通知客户
        private transient IControl advise = new ControlImpl("advise", "通知客户", this);

        //编辑
        private transient IControl edit = new ControlImpl("edit", "编辑", this);

        //导入附件
        private transient IControl attachment = new ControlImpl("attachment", "导入附件", this);

        //收件确认
        private transient IControl confirm = new ControlImpl("confirm", "收件确认", this);

        //取消
        private transient IControl cansel = new ControlImpl("cansel", "取消", this);

        //发件人邮箱
        private String sender;

        //收件人邮箱
        private String recver;

        //邮件主题
        private String title;

        //邮件内容
        private String content;

        //begin date
        private Date begdat;

        //end date
        private Date enddat;

        //交易类型
        private String trntyp;

        //企业代号
        private String ptycod;

        //机构名称
        private String ptynam;

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //提交
        private transient IControl submit = new ControlImpl("submit", "提交", this);

        //转为历史
        private transient IControl history = new ControlImpl("history", "转为历史", this);

        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //套打申请书
        private IStream tdapldoc = new StreamImpl();

        //报关单
        private IStream bot = new StreamImpl();

        //普打申请书
        private IStream pdapldoc = new StreamImpl();

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //删除
        private transient IControl del = new ControlImpl("del", "删除", this);

        //查询
        private transient IControl sel1 = new ControlImpl("sel1", "查询", this);

        //批量提交
        private transient IControl sav1 = new ControlImpl("sav1", "批量提交", this);

        //报文
        private IStream tco = new StreamImpl();

        //面函
        private IStream notice = new StreamImpl();

        //新面函0
        private IStream newnot = new StreamImpl();

        //获得参号
        private transient IControl getref = new ControlImpl("getref", "获得参号", this);

        //参号前缀
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefix = new FieldConstantHolder<>("");


        //批量提交完成
        private transient IControl done = new ControlImpl("done", "批量提交完成", this);

        //汇票
        private IStream dft = new StreamImpl();

        //面函0
        private IStream notice0 = new StreamImpl();

        //面函1
        private IStream notice1 = new StreamImpl();

        //汇票1
        private IStream docdft = new StreamImpl();

        //
        private String notice00;

        //
        private String notice11;

        //
        private String tco0;

        //新面函1
        private IStream newnot1 = new StreamImpl();

        //chkck table
        private IStream table = new StreamImpl();

        //编辑1
        private transient IControl edit1 = new ControlImpl("edit1", "编辑1", this);

        //edit0
        private transient IControl edit0 = new ControlImpl("edit0", "edit0", this);

        //报文0
        private IStream sw0 = new StreamImpl();

        //报文1
        private IStream sw1 = new StreamImpl();

        //报文2
        private IStream sw2 = new StreamImpl();

        //面函2
        private IStream notice2 = new StreamImpl();

        //面函3
        private IStream notice3 = new StreamImpl();

        //报文3
        private IStream sw3 = new StreamImpl();

        //报文4
        private IStream sw4 = new StreamImpl();

        //邮件附件名称
        private String attnames;

        //修改2
        private transient IControl edit2 = new ControlImpl("edit2", "修改2", this);

        //修改3
        private transient IControl edit3 = new ControlImpl("edit3", "修改3", this);

        //
        private String notice22;

        //
        private String notice33;

        //新面函2
        private IStream newnot2 = new StreamImpl();

        //新面函3
        private IStream newnot3 = new StreamImpl();

        //面函文件索引
        private String xmlidx;

        //暂不转通知
        private transient IControl delay = new ControlImpl("delay", "暂不转通知", this);

        //不转通知
        private transient IControl quit = new ControlImpl("quit", "不转通知", this);

        //NewField
        private Object panel;

        //
        private String flg0;

        //
        private String flg1;

        //
        private String flg2;

        //
        private String flg3;

        //
        private String tco1;

        //
        private String tco2;

        //
        private String tco3;

        //
        private String tco4;

        //风险评估与咨询
        private transient IControl xptslt = new ControlImpl("xptslt", "风险评估与咨询", this);

        //reimbursment claim table 
        private IStream rembtbl = new StreamImpl();

        //其他面函模板调用
        private transient IControl othcover = new ControlImpl("othcover", "其他面函模板调用", this);

        //批量导入
        private IStream batimp = new StreamImpl();

        //合同协议文本
        private IStream htxywb = new StreamImpl();

        //申请单号
        private String sqdh;

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //银行端修改合同信息
        private String htdisplay;

        //保证金协议文本
        private IStream cdtext = new StreamImpl();

        //委托开户申请书
        private IStream apldoc01 = new StreamImpl();

        //回到顶部
        private transient IControl returntop = new ControlImpl("returntop", "回到顶部", this);

        //协议补充修改
        private transient IControl bnkcfm = new ControlImpl("bnkcfm", "协议补充修改", this);

        //报文草稿
        private transient IControl swfbtn = new ControlImpl("swfbtn", "报文草稿", this);

        //报关单
        private transient IControl bots = new ControlImpl("bots", "报关单", this);

        //普打申请书
        private transient IControl pdapldocs = new ControlImpl("pdapldocs", "普打申请书", this);

        //套打申请书
        private transient IControl tdapldocs = new ControlImpl("tdapldocs", "套打申请书", this);

        //申请书
        private transient IControl apldocs = new ControlImpl("apldocs", "申请书", this);

        //面函
        private transient IControl csche = new ControlImpl("csche", "面函", this);

        //报文草稿
        private transient IControl draftmsg = new ControlImpl("draftmsg", "报文草稿", this);

        //保函修改申请申请书
        private transient IControl gitameapl = new ControlImpl("gitameapl", "保函修改申请申请书", this);

        //退回单一窗口
        private transient IControl returnd = new ControlImpl("returnd", "退回单一窗口", this);

        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);

        //单一窗口退回留言
        private String thly;

        //业务参考号
        private String ownref;

        //sw报文参考号
        private String msgref;

        //退回单一窗口
        private transient IControl backswi = new ControlImpl("backswi", "退回单一窗口", this);

        //回执map
        private Map swimap;

        //发票核验
        private transient IControl invchk = new ControlImpl("invchk", "发票核验", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel trabut;

        @JsonIgnore
        @BDGetter
        private transient IPanel trabut3;

        @JsonIgnore
        @BDGetter
        private transient IPanel email;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel combtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel aplbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel qryp;

        @JsonIgnore
        @BDGetter
        private transient IPanel rebbtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptopn;

        @JsonIgnore
        @BDGetter
        private transient IPanel sels;

        @JsonIgnore
        @BDGetter
        private transient IPanel che;

        @JsonIgnore
        @BDGetter
        private transient IPanel combtn1;

        @JsonIgnore
        @BDGetter
        private transient IPanel tstadvedit;

        @JsonIgnore
        @BDGetter
        private transient IPanel tarbut1;

        @JsonIgnore
        @BDGetter
        private transient IPanel eidtack;

        @JsonIgnore
        @BDGetter
        private transient IPanel attach;

        @JsonIgnore
        @BDGetter
        private transient IPanel getreference;

        @JsonIgnore
        @BDGetter
        private transient IPanel muchsav;

        @JsonIgnore
        @BDGetter
        private transient IPanel mushsav1;

        @JsonIgnore
        @BDGetter
        private transient IPanel makdocbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel dftbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel littribtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel mt103;

        @JsonIgnore
        @BDGetter
        private transient IPanel bilchkbt;

        @JsonIgnore
        @BDGetter
        private transient IPanel xptsltbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel advcustom;

        @JsonIgnore
        @BDGetter
        private transient IPanel othcov;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptimp;

        @JsonIgnore
        @BDGetter
        private transient IPanel aplbtn2;

        @JsonIgnore
        @BDGetter
        private transient IPanel batimpbnt;

        @JsonIgnore
        @BDGetter
        private transient IPanel tarbut2;

        @JsonIgnore
        @BDGetter
        private transient IPanel dfrbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel xybut;

        @JsonIgnore
        @BDGetter
        private transient IPanel xyrel;

        @JsonIgnore
        @BDGetter
        private transient IPanel return0;

        @JsonIgnore
        @BDGetter
        private transient IPanel htmodp;

        @JsonIgnore
        @BDGetter
        private transient IPanel mailbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel bzjtextp;

        @JsonIgnore
        @BDGetter
        private transient IPanel prebtn1;

        @JsonIgnore
        @BDGetter
        private transient IPanel marbtn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptapnbtn1;

        @JsonIgnore
        @BDGetter
        private transient IPanel fytopn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel rtntopbtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftapntop;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftcfmtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptcfmtopbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel bzjtop;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitapnbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel marcfmtopbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel litapntop;

        @JsonIgnore
        @BDGetter
        private transient IPanel letdoc;

        @JsonIgnore
        @BDGetter
        private transient IPanel apldocbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel litbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel litamebut;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtsndbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel ditopnbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel ltto1;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitamebut;

        @JsonIgnore
        @BDGetter
        private transient IPanel gst01;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopntop;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapls;

        @JsonIgnore
        @BDGetter
        private transient IPanel swiback;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptapitop;

        @JsonIgnore
        @BDGetter
        private transient IPanel cpthyf;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<IModule> rec;

	    @BDGetter
		private Busmod busmod;

	    @BDGetter
		private Climod climod;

	    @BDGetter
		private Xptqna xptqna;

	    @BDGetter
		private Imgtp imgtp;

	    @BDGetter
		private Notmod notmod;


		public Mtabut()
        {
            super();
            setArgument();
        }

        public Mtabut(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:mtabut.@0003.script
        */
        @Rule(target="sav",order=1000)
        public boolean ruleSavN1000(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[sav]order 1000  SPT:inr=["+ctx.absGet(Sysmod.class).getSpt().getInr()+"]"+",sta=["+ctx.absGet(Sysmod.class).getSpt().getSta()+"]");
			/*if(!$\\sysmod.sptIsLoaded("B"))
			  Platform.dbInsert($\\trnmod\\trn);
			  */
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrninr()))  //单一窗口
			{
			  ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			  log.debug("{}","sta    2值："+ctx.absGet(Trnmod.class).getTrn().getSta());
			}
			else
			{
			  if(!ctx.absGet(Sysmod.class).sptIsLoaded("B") && MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getScrtxt()))
			  {
			    ctx.getDaoSession().dbInsert(ctx.absGet(Trnmod.class).getTrn());
			    log.debug("{}","sta    1值："+ctx.absGet(Trnmod.class).getTrn().getSta());
			  }
			  else
			  {
			    ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			    log.debug("{}","sta    2值："+ctx.absGet(Trnmod.class).getTrn().getSta());
			  }
			}

			if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  log.debug("{}","开始删除 spt 记录...");
			  String filename=ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Sysmod.class).getSpt().getInr(),"bak");
			  ctx.getDaoSession().dbDelete(ctx.absGet(Sysmod.class).getSpt());
			  if(MdaUtils.fileExists(filename))
			    MdaUtils.fileDelete(filename);
			  MdaUtils.clear(ctx.absGet(Sysmod.class).getSpt());
			}
			ctx.absGet(Sysmod.class).setOwnflg(NULLSTR);

			String modpath=MdaDriver.getModuleType(this.getRec())+"grp";
			IStream os=this.getTrnstm();
			MdaUtils.streamClear(os);
			MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),modpath),os);
			//部分业务需要报文另外一个XXDGRP中的数据到dat文件
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			if(!MdaUtils.isEmpty(grp))
			{
			  //log.debug("saveData---2nd xxdgrp="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp),os);
			}
			//20190416 新增grp2,grp3,grp4应对其他交易数据丢失的情况
			String grp2=MdaUtils.getPropertyValue(name,ctx.getTransName()+".2");
			if(!MdaUtils.isEmpty(grp2))
			{
			  //log.debug("saveData---3nd xxdgrp="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp2),os);
			}
			String grp3=MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			if(!MdaUtils.isEmpty(grp3))
			{
			  //log.debug("saveData---4nd xxdgrp="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp3),os);
			}
			String grp4=MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			if(!MdaUtils.isEmpty(grp4))
			{
			  //log.debug("saveData---5nd xxdgrp="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp4),os);
			}
			if(MdaUtils.isEmpty(os))
			  return false;

			ctx.absGet(Sysmod.class).streamSaveInSubdir(os,"trndata/"+ctx.absGet(Trnmod.class).getTrn().getInr().substring(0,4),ctx.absGet(Trnmod.class).getTrn().getInr()+".dat");
			log.debug("{}","开始载入数据");
			ctx.restoreData("com.brilliance." + ctx.getTransName() + ".ref");

			log.info("{}","提交成功!业务处理结束，编号 1000");

			return true;
        }

        /**
        *   source:mtabut.@0004.script
        */
        @Rule(target="ped",order=800)
        public boolean rulePedN800(){
            IContext ctx = MdaEnv.getContext();
            
			String trnname=ctx.getTransName();
			//检查是否有经办权限
			if(!ctx.absGet(Sysmod.class).checkSubmitRight(trnname))
			  return true;
			ctx.absGet(Sysmod.class).setPedflg(NULLSTR);
			if(MdaUtils.prompt(MdaUtils.getI18NString("mtabut","CT000472"),MdaUtils.getI18NString("mtabut","CT000473")))
			{
			  ctx.absGet(Sysmod.class).setPedflg("false");
			  return true;
			}

			String sptinr=ctx.absGet(Sysmod.class).getSpt().getInr();
			IModule mod=MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\rec");
			String typ=MdaDriver.getModuleType(mod);
			log.info("{}","current group is ---"+typ );
			IDatafield<String> istlref = MdaDriver.getDatafield(mod,"stlref");
			IDatafield<String> iownref=MdaDriver.getDatafield(mod,"ownref");
			String ownref=iownref.getValue();
			log.info("{}","the returned ownref is ---"+ownref);
			if(MdaUtils.isEmpty(ownref))
			{
			  ownref="NOREF";
			}
			String inr="";
			String ptyname=ctx.absGet(Sysmod.class).getPty().getNam();
			ctx.absGet(Sysmod.class).getSpt().setObjnam(ctx.absGet(Trnmod.class).getCur()+ctx.absGet(Trnmod.class).getAmt()+"/"+ptyname);
			ctx.absGet(Sysmod.class).getSpt().setNam(ptyname);
			//存spt表trncur及trnamt,以便退回夹取值
			ctx.absGet(Sysmod.class).getSpt().setTrncur(ctx.absGet(Trnmod.class).getCur());
			ctx.absGet(Sysmod.class).getSpt().setTrnamt(ctx.absGet(Trnmod.class).getAmt());
			//如果有影像批次号，存批次号
			ctx.absGet(Sysmod.class).getSpt().setImgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImg().getImgref());
			log.debug("{}","imgref from img =" + ctx.absGet(Sysmod.class).getSpt().getImgref());
			//20190715,解决多次暂存影像无法查看问题。
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getImgref()))
			{
			  ctx.absGet(Sysmod.class).getSpt().setImgref(ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImgref());
			  log.debug("{}","imgref from imgmod=" + ctx.absGet(Sysmod.class).getSpt().getImgref());
			}
			ctx.getDaoSession().dbBegin();
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  ctx.absGet(Sysmod.class).getSpt().setObjtyp(typ);
			  ctx.absGet(Sysmod.class).getSpt().setObjinr(inr);
			  ctx.absGet(Sysmod.class).getSpt().setSta("P");
			  if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSmh().getInr()))
			  {
			    ctx.absGet(Sysmod.class).getSpt().setSmhinr(ctx.absGet(Trnmod.class).getSmh().getInr());
			  }
			  ctx.absGet(Sysmod.class).getSpt().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			  ctx.absGet(Sysmod.class).getSpt().setOprogninr(ctx.absGet(Sysmod.class).getPty().getInr());
			  ctx.absGet(Sysmod.class).getSpt().setScr("I");
			  ctx.absGet(Sysmod.class).getSpt().setDattim(new Date());
			  ctx.absGet(Sysmod.class).getSpt().setFrm(trnname);
			  ctx.absGet(Sysmod.class).getSpt().setOwnref(ownref);
			  if("fncfre".equals(ctx.getTransName()))
			  {
			    IDatafield ref=MdaDriver.getDatafield(ctx.getRoot(),"afdgrp\\rec\\ownref");
			    if(!MdaUtils.isEmpty(ref.getValue()))
			      ctx.absGet(Sysmod.class).getSpt().setOwnref(ref.getValue().toString());
			  }
			  ctx.absGet(Sysmod.class).getSpt().setInr(Platform.sdbCounter("spt"));
			  ctx.getDaoSession().dbInsert(ctx.absGet(Sysmod.class).getSpt());
			}
			else
			{
			  ctx.absGet(Sysmod.class).getSpt().setObjtyp(typ);
			  ctx.absGet(Sysmod.class).getSpt().setObjinr(inr);
			  ctx.absGet(Sysmod.class).getSpt().setSta("P");
			  if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSmh().getInr()))
			  {
			    ctx.absGet(Sysmod.class).getSpt().setSmhinr(ctx.absGet(Trnmod.class).getSmh().getInr());
			  }
			  ctx.absGet(Sysmod.class).getSpt().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			  ctx.absGet(Sysmod.class).getSpt().setOprogninr(ctx.absGet(Sysmod.class).getPty().getInr());
			  if("bilchk".equals(ctx.getTransName())||"letate".equals(ctx.getTransName())||"letats".equals(ctx.getTransName()))
			  {
			    ctx.absGet(Sysmod.class).getSpt().setScr("I");
			  }
			  ctx.absGet(Sysmod.class).getSpt().setDattim(new Date());
			  ctx.absGet(Sysmod.class).getSpt().setFrm(ctx.getTransName());
			  ctx.absGet(Sysmod.class).getSpt().setOwnref(ownref);
			  if("fncfre".equals(ctx.getTransName()))
			  {
			    IDatafield ref=MdaDriver.getDatafield(ctx.getRoot(),"afdgrp\\rec\\ownref");
			    if(!MdaUtils.isEmpty(ref.getValue()))
			      ctx.absGet(Sysmod.class).getSpt().setOwnref(ref.getValue().toString());
			  }
			  ctx.getDaoSession().dbUpdate(ctx.absGet(Sysmod.class).getSpt());
			}
			ctx.absGet(Trnmod.class).getOrdmod().ordUpdate("P");
			ctx.getDaoSession().dbCommit();
			IStream os=this.getTrnstm();
			MdaUtils.streamClear(os);
			String modpath=MdaDriver.getModuleType(this.getRec())+"grp";
			log.info("{}","saveData---grp1="+modpath);
			MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),modpath),os);
			//save another group
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			if(!MdaUtils.isEmpty(grp))
			{
			  log.info("{}","saveData---grp2="+grp);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp),os);
			}

			String grp2=MdaUtils.getPropertyValue(name,ctx.getTransName()+".2");
			if(!MdaUtils.isEmpty(grp2))
			{
			  log.info("{}","saveData---grp2="+grp2);
			  MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp2),os);
			}

			if("brtsnd".equals(ctx.getTransName())||"bctacp".equals(ctx.getTransName()))
			{
			  if("brtsnd".equals(ctx.getTransName()))
			  {
			    String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			    if(!MdaUtils.isEmpty(grp3))
			    {
			      log.info("{}","saveData---grp3 = "+grp3);
			      MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp3),os);
			    }

			    String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			    if(!MdaUtils.isEmpty(grp4))
			    {
			      log.info("{}","saveData---grp4 = "+grp4);
			      MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp4),os);
			    }
			  }
			  if("bctacp".equals(ctx.getTransName()))
			  {
			    String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			    if(!MdaUtils.isEmpty(grp3))
			    {
			      log.info("{}","saveData---grp3 = "+grp3);
			      MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp3),os);
			    }
			    String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			    if(!MdaUtils.isEmpty(grp4))
			    {
			      log.info("{}","saveData---grp4 = "+grp4);
			      MdaUtils.saveData(MdaDriver.getModule(this,ctx.getRoot(),grp4),os);
			    }
			  }

			}

			String filename = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Sysmod.class).getSpt().getInr(),"bak");
			MdaUtils.streamSave(os,filename);
			MdaUtils.clear(ctx.absGet(Sysmod.class).getSpt());
			

			return true;
        }

        /**
        *   source:mtabut.@0005.script
        */
        @Rule(target="back",order=0)
        public boolean ruleBackN0(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			}
			else
			{
			  if("R".equals(ctx.absGet(Sysmod.class).getSpt().getSta())&&"I".equals(ctx.absGet(Sysmod.class).getSpt().getScr()))
			  {
			    //#CT000022
			    ctx.absGet(Sysmod.class).getSpt().setSta("B");
			    ctx.getDaoSession().dbUpdate(ctx.absGet(Sysmod.class).getSpt());
			    createBackSpt();
			  }
			  if("S".equals(ctx.absGet(Sysmod.class).getSpt().getScr())&&"T".equals(ctx.absGet(Sysmod.class).getSpt().getSta()))
			  {
			    //#CT000023
			    ctx.absGet(Sysmod.class).getSpt().setSta("B");
			    ctx.getDaoSession().dbUpdate(ctx.absGet(Sysmod.class).getSpt());
			    createBackSpt();
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0006.script
        */
        @Rule(target="mail",order=100)
        public boolean ruleMailN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*String bchcod = $\\cpdgrp\\rec\\bchcod.getValue();
			  String sql = "select eml from adr a where a.inr in ( select objinr from pta a where a.ptyinr  in (select inr from pty p where cid = '"+bchcod+"'));";
			  Platform.dbBegin();
			  Platform.dbExecuteSQL(sql);
			  log.info("执行的SQL为："+ sql);
			  Argument<String> eml = new Argument<String>("eml");
			  Platform.dbFetchFields(eml);
			  int error = Platform.errorCode();
			  if(error == NO_ERROR)
			  {
			  $sender.setValue(eml.value);
			  }*/
			this.setSender("e-trade@cebbank.com");
			ctx.getDaoSession().dbCommit();
			ctx.getDaoSession().dbCloseCursor();
			if("yxyopn-fxyopn-zxdopn-dxdopn-lxyopn-bxyopn-yxyame-fxyame-zxdame-dxdame-lxyame-bxyame".contains(ctx.getTransName()))
			{
			  
			  
			}
			
			

			return true;
        }

        /**
        *   source:mtabut.@0007.script
        */
        @Rule(target="chk",order=0)
        public boolean ruleChkN0(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  String trnname=Platform.getTransName();
			  String modpath=trnnamesubstring(0,2);
			  Platform.checkAll(Platform.getModule($\\,modpath+"dgrp"));
			  */
			//String modtyp=Platform.getModuleType($rec);
			//log.info(modtyp);
			//
			
			return true;
        }

        /**
        *   source:mtabut.@0008.script
        */
        @Rule(target="sendmail",order=200)
        public boolean ruleSendmailN200(){
            IContext ctx = MdaEnv.getContext();
            

			String mailadr=this.getRecver();
			if(MdaUtils.isEmpty(mailadr))
			  return false;
			String[] mailadrs=mailadr.split("[,;]");
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			//  String date=Platform.format(Platform.today(),"yyyyMMdd");
			//filepath=Platform.catPath(filepath,date);
			String attnames = this.getAttnames();
			log.debug("{}","send mail attnam="+attnames);
			if(ctx.absGet(Sysmod.class).aplSendMail(mailadrs,attnames.split(";"),filepath,this.getTitle(),this.getContent()))
			{
			  
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000220"),MdaUtils.getI18NString("mtabut","CT000221"));
			}

			return true;
        }

        /**
        *   source:mtabut.@0009.script
        */
        @Rule(target="sav",order=800)
        public boolean ruleSavN800(){
            IContext ctx = MdaEnv.getContext();
            
			// search oprogninr
			log.info("{}","业务处理开始，编号800");

			// 更新影像信息表
			String imgref = ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImageReferences();
			if (!MdaUtils.isEmpty(imgref))
			{
			  log.debug("{}","开始更新影像操作记录表");
			  ctx.absGet(Trnmod.class).getItfmod().getImgmod().updateImageByIDs(imgref ,ctx.absGet(Trnmod.class).getObjinr(),ctx.absGet(Trnmod.class).getTrn().getInr());
			  log.debug("{}","更新影像操作记录表成功");
			}
			String bchcod = ctx.absGet(Trnmod.class).getBchcod();
			String trnname=ctx.getTransName().toLowerCase();
			String oprcid = ctx.absGet(Sysmod.class).getOprogncid(bchcod,trnname);
			log.info("{}","归属银行：bchcod="+ ctx.absGet(Trnmod.class).getBchcod()+",cid="+oprcid);
			ctx.absGet(Trnmod.class).setOprogninr(oprcid);
			//generate tco msg
			//log.debug("trn inr="+$\\trnmod\\trn\\inr);
			String ptytyp=ctx.absGet(Sysmod.class).getPty().getPtytyp();
			//if(!"3".equals(ptytyp)&&!("fxtopn".equals(trnname)||"fxropn".equals(trnname)||"fxfsll".equals(trnname)||"commar".equals(trnname)||"fncfre".equals(trnname)||"irfopn".equals(trnname)||"bpttrs".equals(trnname)||"fxfbuy".equals(trnname)))
			String msgname = ctx.absGet(Trnmod.class).getTcoMsgName(trnname);
			//log.debug(trnname+"'s msgname="+msgname);
			
			if(!isTcoIgnore(trnname))
			{
			  log.info("{}","开始组装XML报文：ptytyp="+ptytyp+",msgname:"+msgname);

			  if(ctx.absGet(Sysmod.class).backFromBnkchk() || "B".equals(ctx.absGet(Trnmod.class).getTrn().getBaksta())) //国结退回之后企业再退回
			  {
			    String newsubnam = MdaUtils.format(MdaUtils.today(),"HHmmss");
			    ctx.absGet(Trnmod.class).getTrn().setSrcinr(newsubnam);
			    String filename=ctx.absGet(Trnmod.class).getTrn().getInr()+newsubnam;
			    if(ctx.absGet(Trnmod.class).getItfmod().packXmlFile(msgname,filename))
			      ctx.absGet(Trnmod.class).getWfmmod().setFilename(filename);
			    else
			      log.error("{}","银行审核中退回重新提交生成报文错误");
			  }
			  else
			  {
			    boolean success = ctx.absGet(Trnmod.class).getItfmod().packXmlFile(msgname,ctx.absGet(Trnmod.class).getTrn().getInr());
			  }
			}
			// save apply file
			
			log.info("{}","开始保存申请文件");
			String pdfConPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/messageconfig/"+trnname);
			//Map<String,String> paths= (Map<String,String>)Platform.invoke("com.brilliance.etrade.message.MessageConfig","getPdfList",pdfConPath);
			
			//2018.12.25注释
			/*if($\\trnmod.isFinancingTransaction(Platform.getTransName(),$\\sysmod\\pty\\ptytyp.getValue()))
			  {
			  Platform.invoke($\\,"dealGlblist");
			  log.info("glblist dealed");
			  }*/
			//需要保存一下担保信息
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			//log.info("data0 size" +data.size());
			if(MdaUtils.isEmpty(data.get("OPRBCHCOD")))
			  data.put("OPRBCHCOD",ctx.absGet(Trnmod.class).getBchcod());

			log.info("{}","trn inr="+ctx.absGet(Trnmod.class).getTrn().getInr());

			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),ctx.absGet(Trnmod.class).getTrn().getInr().substring(0,4));
			log.info("{}","path="+path);
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");

			String clsNam = "com.brilliance.swift.SwiftPacker";
			MdaUtils.invoke(clsNam,"saveDataToFile",data,path,ctx.absGet(Trnmod.class).getTrn().getInr()+".app");
			// save draft file
			if(!isTcoIgnore(trnname))
			{
			  Map<String,Object> dat=Platform.getValueMap(ctx.getRoot(),msgname,"DATA");
			  MdaUtils.invoke(clsNam,"packDataToFile",msgname,dat,cfgpath,path,ctx.absGet(Trnmod.class).getTrn().getInr()+".dra");
			}
			log.info("{}","业务处理结束，编号800");

			return true;
        }

        /**
        *   source:mtabut.@0010.script
        */
        @Rule(target="sav",order=100)
        public boolean ruleSavN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[sav]Order 100 业务提交处理开始");
			IDatafield<String> ownref = MdaDriver.getDatafield(this.getRec(),"ownref");

			if(!MdaUtils.isEmpty(this.getPrefix()))
			{
			  //$getref.invokeEventRules(evt);
			  getRef();
			  log.info("{}","获取业务参号:"+ownref.getValue());
			}
			//  1 2级客户时 ptyinr照存 商行时先读ptyinr 如果没有 存商行自己的ptyinr 如果有不改变
			IDatafield ptyinr = MdaDriver.getDatafield(this.getRec(),"ptyinr");
			if(!"1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp())   ||   MdaUtils.isEmpty(ptyinr.getValue()))
			  ptyinr.setValue(ctx.absGet(Sysmod.class).getPty().getInr());
			log.info("{}","机构类型:ptytyp=["+ctx.absGet(Sysmod.class).getPty().getPtytyp()+"],机构编号：ptyinr=["+ptyinr.getValue()+"]");
			//String etinr=$\\sysmod.sdbGetEty($\\trnmod\\bchcod.getValue());
			//etyinr 如果是企业客户 从其自己的ptyinr找到etyinr  如果是商行就直接存他pty表的etyinr
			String etinr = ctx.absGet(Sysmod.class).getBelongEty();
			log.debug("{}","机构所属实体：etyinr="+etinr );
			IDatafield etyinr = MdaDriver.getDatafield(this.getRec(),"etyinr");
			etyinr.setValue(etinr);
			log.info("{}","业务提交编号100处理结束");

			return true;
        }

        /**
        *   source:mtabut.@0011.script
        */
        @Rule(target="sftdra",order=100)
        public boolean ruleSftdraN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*IStream stream =$sftdra.getValue();
			  $\\sysmod\\pdfmod.generatorSwiftPdf("",stream,false);
			  */


			return true;
        }

        /**
        *   source:mtabut.@0012.script
        */
        @Rule(target="notice",order=100)
        public boolean ruleNoticeN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml file ...");
			IStream is=this.getNotice();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=ctx.absGet(Trnmod.class).getSmh().getXmlfil();
			String[] files = filename.split(";");
			int cnt = files.length;
			for(int i=0;i<cnt;i =i+cnt )
			{
			  if(files[i].indexOf(",")>0)
			    filename = files[i].substring(0,files[i].indexOf(","));
			  else filename= files[i];
			}
			log.debug("{}",filename);
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0013.script
        */
        @Rule(target="confirm",order=1000)
        public boolean ruleConfirmN1000(){
            IContext ctx = MdaEnv.getContext();
            

			if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  ctx.getDaoSession().dbBegin();
			  if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			    ctx.getDaoSession().dbDelete(ctx.absGet(Sysmod.class).getSpt());
			  ctx.getDaoSession().dbCommit();
			}

			

			return true;
        }

        /**
        *   source:mtabut.@0014.script
        */
        @Rule(target="tco",order=200)
        public boolean ruleTcoN200(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 file...");
			//String filePath="D:\\\\apache-tomcat-6.0.18\\\\webapps\\\\eIBS\\\\data\\\\swiftIn\\\\arr\\\\20090911";
			//String fileName="00930390.txt";
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=ctx.absGet(Trnmod.class).getSmh().getSf2fil();
			IStream stream=this.getTco();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0015.script
        */
        @Rule(target="confirm",order=100)
        public boolean ruleConfirmN100(){
            IContext ctx = MdaEnv.getContext();
            
			// Platform.dbBegin();
			
			return true;
        }

        /**
        *   source:mtabut.@0016.script
        */
        @Rule(target="ped",order=200)
        public boolean rulePedN200(){
            IContext ctx = MdaEnv.getContext();
            
			 /*
			  String typ=$\\sysmod\\trntiltle.getValue().substring(0,2);
			  String ptyname=$\\trnmod.getPtyName($\\sysmod\\pty\\inr.getValue());
			  $\\sysmod\\spt\\objtyp.setValue(Platform.getModuleType(Platform.getModule($\\,"mtabut\\\\rec")));
			  $\\sysmod\\spt\\objinr.setValue("");
			  String=Platform.getModuleType($rec);
			  //$\\sysmod\\spt\\objnam.setValue($lidgrp\\rec\\isscur.getValue()+$lidgrp\\rec\\issamt.getValue()+"/"+ptyname);
			  //$\\sysmod\\spt\\nam.setValue($lidgrp\\rec\\isscur.getValue()+$lidgrp\\rec\\issamt.getValue()+"/"+ptyname);
			  */

			return true;
        }

        /**
        *   source:mtabut.@0017.script
        */
        @Rule(target="advise",order=200)
        public boolean ruleAdviseN200(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getClimod().getPtyinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000132"),MdaUtils.getI18NString("mtabut","CT000133"));
			  return false;
			}

			ctx.absGet(Trnmod.class).noticeAckByBank((IPanel)ctx.absGet(Trnmod.class).getPanel());
			log.info("{}","advise...");
			ctx.getDaoSession().dbBegin();
			StringBuffer allfile = new StringBuffer(60);
			String split = "";
			for(int i=0;i<4;i++)
			{
			  IDatafield flg = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"flg"+i);
			  if(TRUE.equals(flg.getValue()))
			  {
			    allfile.append(split);
			    allfile.append(getXmlFileInfo(String.valueOf(i)));
			    split=";";
			  }
			  flg = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"notice"+i+""+i);
			  if(TRUE.equals(flg.getValue()))
			  {
			    allfile.append(split);
			    allfile.append("N"+getXmlFileInfo(String.valueOf(i)));
			    split=";";
			  }
			}
			log.debug("{}","adv xml="+allfile);
			this.getClimod().getTclsmh().setXmlfil(allfile.toString());
			//if(TRUE.equals())
			StringBuffer sw2fil = new StringBuffer(60);
			split = "";
			for(int i=0;i<5;i++)
			{
			  IDatafield tco = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"tco"+i);
			  if(TRUE.equals(tco.getValue()))
			  {
			    sw2fil.append(split);
			    sw2fil.append(getSw2File(i));
			    split=";";
			  }
			}
			log.debug("{}","adv sw2="+sw2fil);
			this.getClimod().getTclsmh().setSf2fil(sw2fil.toString());
			this.getClimod().getTclsmh().setOutdattim(ctx.absGet(Trnmod.class).getSmh().getOutdattim());
			this.getClimod().getTclsmh().setOrdinr(ctx.absGet(Trnmod.class).getSmh().getOrdinr());
			this.getClimod().getTclsmh().setObjtyp(ctx.absGet(Trnmod.class).getSmh().getObjtyp());
			this.getClimod().getTclsmh().setObjinr(ctx.absGet(Trnmod.class).getSmh().getObjinr());
			this.getClimod().getTclsmh().setMsgtyp(ctx.absGet(Trnmod.class).getSmh().getMsgtyp());
			this.getClimod().getTclsmh().setMsgsta(ctx.absGet(Trnmod.class).getSmh().getMsgsta());
			this.getClimod().getTclsmh().setLstfil(ctx.absGet(Trnmod.class).getSmh().getLstfil());
			this.getClimod().getTclsmh().setDir(ctx.absGet(Trnmod.class).getSmh().getDir());
			this.getClimod().getTclsmh().setCreusr(ctx.absGet(Trnmod.class).getSmh().getCreusr());
			this.getClimod().getTclsmh().setCredattim(ctx.absGet(Trnmod.class).getSmh().getCredattim());
			this.getClimod().getTclsmh().setDocpth(ctx.absGet(Trnmod.class).getSmh().getDocpth());
			this.getClimod().getTclsmh().setInr(Platform.sdbCounter("smh"));
			ctx.absGet(Sysmod.class).sdbInsert(this.getClimod().getTclsmh());
			//spt...record
			if(!MdaUtils.isEmpty(this.getClimod().getTclsmh().getInr()))
			{
			  ctx.absGet(Trnmod.class).getSptchk().setSmhinr(this.getClimod().getTclsmh().getInr());
			}
			String ptyinr=this.getClimod().getPtyinr();
			ctx.absGet(Trnmod.class).getSptchk().setPtyinr(ptyinr);
			log.info("{}","advise to "+ptyinr);
			ctx.absGet(Trnmod.class).getSptchk().setSta("T");
			ctx.absGet(Trnmod.class).getSptchk().setScr("A");
			ctx.absGet(Trnmod.class).getSptchk().setOprogninr(ctx.absGet(Sysmod.class).getPty().getInr());
			ctx.absGet(Trnmod.class).getSptchk().setDattim(MdaUtils.today());
			String sptinr=ctx.absGet(Trnmod.class).getSptchk().getInr();
			ctx.absGet(Trnmod.class).getSptchk().setInr(Platform.sdbCounter("spt"));
			ctx.absGet(Sysmod.class).sdbInsert(ctx.absGet(Trnmod.class).getSptchk());
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSptchk().getInr()))
			{
			  String grptyp=ctx.absGet(Trnmod.class).getSptchk().getObjtyp();
			  String inr=ctx.absGet(Trnmod.class).getSptchk().getObjinr();
			  log.info("{}","objtyp="+grptyp+",objinr="+inr);
			  if(!"com".equals(grptyp)&&!MdaUtils.isEmpty(inr))
			  {
			    IModule mod=MdaDriver.getModule(this,ctx.getRoot(),grptyp+"grp\\rec");
			    ctx.absGet(Sysmod.class).sdbRead(mod,inr);
			    IDatafield pty=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\ptyinr");
			    pty.setValue(ptyinr);
			    IDatafield etyinr=MdaDriver.getDatafield(ctx.getRoot(),grptyp+"grp\\rec\\etyinr");
			    etyinr.setValue(ctx.absGet(Sysmod.class).getEty().getInr());
			    ctx.getDaoSession().dbUpdate(mod);
			  }
			}
			if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			{
			  ctx.getDaoSession().dbDelete(ctx.absGet(Sysmod.class).getSpt());
			}

			//$\\sysmod.streamSaveInSubdir();
			ctx.getDaoSession().dbCommit();
			//String sfile=Platform.catPath(Platform.getRootPath(),"data/delete/"+sptinr+".bak");
			String sfile=ctx.absGet(Sysmod.class).createFilename(sptinr,"bak");
			//String tfile=Platform.catPath(Platform.getRootPath(),"data/delete/"+$\\trnmod\\sptchk\\inr.getValue()+".bak");
			String tfile=ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Trnmod.class).getSptchk().getInr(),"bak");
			if(MdaUtils.fileExists(sfile))
			  MdaUtils.fileCopy(sfile,tfile);
			MdaUtils.clear(this.getTrnstm());
			ctx.setMessage("OK",MdaUtils.getI18NString("mtabut","CT000134"));
			

			return true;
        }

        /**
        *   source:mtabut.@0018.script
        */
        @Rule(target="edit",order=100)
        public boolean ruleEditN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("A".equals(ctx.absGet(Sysmod.class).getSpt().getScr())&&MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSmh().getXmlfil()))
			{
			  //Platform.invisible($\\mtabut\\climod\\newnt);
			  
			}
			this.getClimod().setLogo(TRUE);
			

			return true;
        }

        /**
        *   source:mtabut.@0024.script
        */
        @Rule(target="newnot",order=100)
        public boolean ruleNewnotN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml file ...");
			IStream is=this.getNewnot();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("0");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,"N"+filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,"N"+filename);
			    Map mdata  = (Map) data;
			    String signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(ctx.absGet(Sysmod.class).getPty().getNcid());
			    mdata.put("signfile",signFile);
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0026.script
        */
        @Rule(target="sav",order=300)
        public boolean ruleSavN300(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","save 300..." );
			//申请书存影像
			IDatafield<String> ownrefField = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"ownref");
			if(MdaUtils.isEmpty(ownrefField.getValue()))
			{
			  ctx.absGet(Mtabut.class).getRef();
			}
			String ownref = ownrefField.getValue();
			log.debug("{}","ownref="+  ownref );
			String imgref = "";
			if("cptimp".equals(ctx.getTransName()))
			  imgref = ctx.absGet(Trnmod.class).getItfmod().getImgmod().getImgref();
			else
			  imgref = this.getImgtp().getDztimgref();
			if(MdaUtils.isEmpty(imgref))
			{
			  imgref = this.getImgtp().getImageReference();
			}
			String objtyp = MdaDriver.getModuleType(ctx.absGet(Mtabut.class).getRec());

			//插入E结算申请书
			if(!MdaUtils.isEmpty(ownref))
			{
			  ctx.absGet(Trnmod.class).pdfdocToImg(ownref,imgref,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp);
			}
			//手机银行获取影像
			//针对手机银行的处理
			//给接口传入网银影像guid，由接口去进行判断并插入tblbil表
			if(Platform.isFromApp())
			{
			  IDatafield<String> guid = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"guid");
			  if(!MdaUtils.isEmpty(guid.getValue()))
			  {
			    String guidval = guid.getValue();
			    log.info("{}","guidval "+guidval);
			    String cls="com.brilliance.eibs.main.Client";
			    Object rtnVal = MdaUtils.invoke(cls,"scall","ENTMBdownload","ENTMBdownload",new Object[]{ownref,imgref,"1001","GJ01",guid,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp,MdaUtils.format(new Date(),"yyyyMMdd")});
			    Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			    Boolean errcod = (Boolean)retMsg.get("issuccess");
			    if(!errcod)
			    {
			      log.error("{}","APP img down error！");
			      String lockName = ctx.absGet(Sysmod.class).getUsr().getCid()+ctx.absGet(Sysmod.class).getUsr().getOid();
			      ctx.setMessage("E9999","影像下载失败");
			      return false;
			    }

			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0029.script
        */
        @Rule(target="getref",order=100)
        public boolean ruleGetrefN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("ZX".equals(this.getPrefix()))
			  return false;
			else
			  getRef();

			return true;
        }

        /**
        *   source:mtabut.@0033.script
        */
        @Rule(target="notice0",order=100)
        public boolean ruleNotice0N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 0 file ...");
			IStream is=this.getNotice0();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("0");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName();
			  log.info("{}",trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    //String logofile = $\\sysmod.getEtyLgnUrl("08101");
			    String signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(null);
			    mdata.put("signfile",signFile);
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0034.script
        */
        @Rule(target="notice1",order=100)
        public boolean ruleNotice1N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 1 file ...");
			IStream is=this.getNotice1();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("1");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName()+"1";
			  log.info("{}","2th app coinifg="+trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(null);
			    mdata.put("signfile",signFile);
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0036.script
        */
        @Rule(target="edit0",order=100)
        public boolean ruleEdit0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getClimod().getPtyinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000238"),MdaUtils.getI18NString("mtabut","CT000239"));
			  return true;
			}
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String newfilename = null;
			if(getXmlFile("0").endsWith("app"))
			  newfilename = this.getClimod().changeAppFile(filepath,"0");
			else
			  newfilename = this.getClimod().changeXMLFile(filepath,"0");
			if(MdaUtils.isEmpty(newfilename))
			  return true;
			
			
			this.setNotice00(TRUE);
			this.setFlg0(FALSE);
			
			
			
			
			

			return true;
        }

        /**
        *   source:mtabut.@0037.script
        */
        @Rule(target="edit1",order=100)
        public boolean ruleEdit1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getClimod().getPtyinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000240"),MdaUtils.getI18NString("mtabut","CT000241"));
			  return true;
			}
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String newfilename = this.getClimod().changeXMLFile(filepath,"1");
			if(MdaUtils.isEmpty(newfilename))
			  return true;
			
			
			this.setNotice11(TRUE);
			this.setFlg1(FALSE);
			
			
			
			
			

			return true;
        }

        /**
        *   source:mtabut.@0039.script
        */
        @Rule(target="sw0",order=100)
        public boolean ruleSw0N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 0 file...");
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=getSw2File(0);
			IStream stream=this.getSw0();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0040.script
        */
        @Rule(target="sw1",order=100)
        public boolean ruleSw1N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 1 file...");
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=getSw2File(1);
			IStream stream=this.getSw1();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0041.script
        */
        @Rule(target="sw2",order=100)
        public boolean ruleSw2N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 2 file...");
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=getSw2File(2);
			IStream stream=this.getSw2();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0042.script
        */
        @Rule(target="notice2",order=100)
        public boolean ruleNotice2N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 2 file ...");
			IStream is=this.getNotice2();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("2");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName()+"2";
			  log.info("{}","2th app coinifg="+trnname );
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(null);
			    mdata.put("signfile",signFile);
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+".pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0043.script
        */
        @Rule(target="notice3",order=100)
        public boolean ruleNotice3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml 3 file ...");
			IStream is=this.getNotice3();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("3");
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);

			return true;
        }

        /**
        *   source:mtabut.@0044.script
        */
        @Rule(target="sw4",order=100)
        public boolean ruleSw4N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 4 file...");
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=getSw2File(4);
			IStream stream=this.getSw4();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0045.script
        */
        @Rule(target="sw3",order=100)
        public boolean ruleSw3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show sw2 3 file...");
			String filePath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String fileName=getSw2File(3);
			IStream stream=this.getSw3();
			Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filePath,fileName);
			log.info("{}","filenam="+fileName);
			Map<String,String[]> dmap  = (Map<String,String[]>) data;
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,stream,ctx.getTransName(),waterfilePath,true);

			return true;
        }

        /**
        *   source:mtabut.@0048.script
        */
        @Rule(target="edit2",order=100)
        public boolean ruleEdit2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getClimod().getPtyinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000242"),MdaUtils.getI18NString("mtabut","CT000243"));
			  return true;
			}
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String newfilename = this.getClimod().changeXMLFile(filepath,"2");
			if(MdaUtils.isEmpty(newfilename))
			  return true;
			
			
			this.setNotice22(TRUE);
			this.setFlg2(FALSE);
			
			
			
			
			

			return true;
        }

        /**
        *   source:mtabut.@0049.script
        */
        @Rule(target="edit3",order=100)
        public boolean ruleEdit3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getClimod().getPtyinr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000244"),MdaUtils.getI18NString("mtabut","CT000245"));
			  return true;
			}
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String newfilename = this.getClimod().changeXMLFile(filepath,"3");
			if(MdaUtils.isEmpty(newfilename))
			  return true;
			
			
			this.setNotice33(TRUE);
			this.setFlg3(FALSE);
			
			
			
			
			

			return true;
        }

        /**
        *   source:mtabut.@0050.script
        */
        @Rule(target="newnot2",order=100)
        public boolean ruleNewnot2N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml n2 file ...");
			IStream is=this.getNewnot2();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename="N"+getXmlFile("2");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}

			return true;
        }

        /**
        *   source:mtabut.@0051.script
        */
        @Rule(target="newnot3",order=100)
        public boolean ruleNewnot3N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml n3 file ...");
			IStream is=this.getNewnot3();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename="N"+getXmlFile("3");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,filename,cfgpath,is);
			}

			return true;
        }

        /**
        *   source:mtabut.@0052.script
        */
        @Rule(target="newnot1",order=100)
        public boolean ruleNewnot1N100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","show xml n1 file ...");
			IStream is=this.getNewnot1();
			String filepath=ctx.absGet(Trnmod.class).getSmh().getDocpth();
			String filename=getXmlFile("1");
			if(filename.endsWith("xml"))
			{
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"etrade");
			  ctx.absGet(Sysmod.class).showNotice(filepath,"N"+filename,cfgpath,is);
			}
			else if(filename.endsWith("app"))
			{
			  String trnname=ctx.getTransName();
			  filename=getXmlFile("1");
			  log.info("{}","transaction="+trnname+"file="+MdaUtils.catPath(filepath,filename));
			  if(MdaUtils.fileExists(MdaUtils.catPath(filepath,filename)))
			  {
			    log.info("{}","to show the  app file..." );
			    Object data=MdaUtils.invoke("com.brilliance.swift.SwiftPacker","loadApplyDataFromFile",filepath,filename);
			    Map mdata  = (Map) data;
			    String signFile = ctx.absGet(Sysmod.class).getEtySeaUrl(ctx.absGet(Sysmod.class).getPty().getNcid());
			    mdata.put("signfile",signFile);
			    String pdffile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+trnname+"1.pdf");
			    log.info("{}","pdffile="+pdffile);
			    MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateApplyDocument",pdffile,mdata,"",is);
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0054.script
        */
        @Rule(target="quit",order=200)
        public boolean ruleQuitN200(){
            IContext ctx = MdaEnv.getContext();
            
			//不转通知
			ctx.absGet(Trnmod.class).noticeAckByBank((IPanel)ctx.absGet(Trnmod.class).getPanel());
			

			return true;
        }

        /**
        *   source:mtabut.@0055.script
        */
        @Rule(target="delay",order=200)
        public boolean ruleDelayN200(){
            IContext ctx = MdaEnv.getContext();
            
			//暂时不转通知
			ctx.getLocker().unlock(ctx.absGet(Sysmod.class).getUsr().getLgnnam());
			

			return true;
        }

        /**
        *   source:mtabut.@0056.script
        */
        @Rule(target="flg0",order=100)
        public boolean ruleFlg0N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getFlg0()))
			  this.setNotice00(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0057.script
        */
        @Rule(target="flg1",order=100)
        public boolean ruleFlg1N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getFlg1()))
			  this.setNotice11(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0058.script
        */
        @Rule(target="flg2",order=100)
        public boolean ruleFlg2N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getFlg2()))
			  this.setNotice22(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0059.script
        */
        @Rule(target="flg3",order=100)
        public boolean ruleFlg3N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getFlg3()))
			  this.setNotice33(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0060.script
        */
        @Rule(target="notice00",order=100)
        public boolean ruleNotice00N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getNotice00()))
			  this.setFlg0(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0061.script
        */
        @Rule(target="notice11",order=100)
        public boolean ruleNotice11N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getNotice11()))
			  this.setFlg1(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0062.script
        */
        @Rule(target="notice22",order=100)
        public boolean ruleNotice22N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getNotice22()))
			  this.setFlg2(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0063.script
        */
        @Rule(target="notice33",order=100)
        public boolean ruleNotice33N100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getNotice33()))
			  this.setFlg3(FALSE);
			
			

			return true;
        }

        /**
        *   source:mtabut.@0067.script
        */
        @Rule(target="sav",order=50)
        public boolean ruleSavN50(){
            IContext ctx = MdaEnv.getContext();
            
			if(!Platform.isFromApp())
			{
			  if(MdaUtils.prompt(MdaUtils.getI18NString("mtabut","CT000462"),MdaUtils.getI18NString("mtabut","CT000463")))
			  {
			    return false;
			  }
			}
			log.info("{}","业务处理开始，ORDER编号:50");
			log.info("{}","客户名称["+ctx.absGet(Sysmod.class).getPty().getNam()+"],客户号["+ctx.absGet(Sysmod.class).getPty().getNcid()+"]");
			log.info("{}","操作员ID["+ctx.absGet(Sysmod.class).getUsr().getOid()+"],操作员登陆名["+ctx.absGet(Sysmod.class).getUsr().getLgnnam()+"]");

			//检查是否有经办权限
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrninr()))
			{
			  if(!ctx.absGet(Sysmod.class).checkRight(ctx.getTransName()))
			  {
			    log.warn("{}","当前用户没有复核单一窗口业务权限，退出！");
			    return false;
			  }
			}
			else
			{
			  if(!ctx.absGet(Sysmod.class).checkSubmitRight(ctx.getTransName()))
			  {
			    if(Platform.isFromApp())
			      ctx.setMessage("E9999","无经办权限，请到阳光E结算配置");
			    log.warn("{}","当前用户没有经办权限，退出！");
			    return false;
			  }
			}
			//合同类教育弹出提示信息
			//if(Platform.isEmpty($rec))
			//{
			//  return false;
			//}
			ctx.getDaoSession().dbBegin();

			return true;
        }

        /**
        *   source:mtabut.@0068.script
        */
        @Rule(target="sav",order=900)
        public boolean ruleSavN900(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","[Sav order 900]业务处理中...");
			ctx.absGet(Trnmod.class).setReleaseMethod();

			if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getPtyaut().getFlg()))
			  return false;

			ctx.absGet(Trnmod.class).sigWrite("O","0");
			ctx.absGet(Trnmod.class).getTrn().setRelres("O");
			ctx.absGet(Trnmod.class).setWorkflow("trn",ctx.absGet(Trnmod.class).getTrn().getInr());
			log.info("{}","trnmod trninr :"+ctx.absGet(Trnmod.class).getTrninr());
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getTrninr()))  //单一窗口
			{
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getOrdmod().getOrd(),new Argument<String>("inr",ctx.absGet(Trnmod.class).getTrn().getOrdinr()));
			  ctx.absGet(Trnmod.class).getOrdmod().ordUpdate("E");
			  ctx.absGet(Rmkmod.class).createRemark(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr(),ctx.absGet(Trnmod.class).getTrn().getInr());
			}
			else
			{
			  if("NEW".equals(ctx.absGet(Trnmod.class).getWfmmod().getOrdinr()))
			  {
			    ctx.absGet(Trnmod.class).getOrdmod().createOrdAndOre("订单创建","01");
			    ctx.absGet(Rmkmod.class).createRemark(ctx.absGet(Trnmod.class).getOrdmod().getOrd().getInr(),ctx.absGet(Trnmod.class).getTrn().getInr());
			  }
			  else
			  {
			    ctx.absGet(Trnmod.class).getOrdmod().ordUpdate("E");
			    ctx.absGet(Rmkmod.class).updateRmk("6");
			  }
			}
			log.info("{}","当前业务状态trn:sta="+ctx.absGet(Trnmod.class).getTrn().getSta());

			return true;
        }

        /**
        *   source:mtabut.@0069.script
        */
        @Rule(target="sav",order=950)
        public boolean ruleSavN950(){
            IContext ctx = MdaEnv.getContext();
            
			String needSign = (String)Platform.getLoginData("needSign");
			log.info("{}","needSign "+needSign);//数字签名放开
			if(!MdaUtils.isEmpty(needSign) &&"yes".equals(needSign))
			{
			  if("R".equals(ctx.absGet(Trnmod.class).getTrn().getSta()))
			  {
			    // 如果批量授权不在这里执行签字
			    if(!"X".equals(ctx.absGet(Sysmod.class).getAuthflg()))
			    {
			      ctx.absGet(Trnmod.class).signature();
			      if("Y".equals(ctx.absGet(Trnmod.class).getSigmod().getFlg()))
			      {
			        log.info("{}","证书签名退回！");
			        ctx.getDaoSession().dbRollback();
			        return false;
			      }
			    }
			    else
			    {
			      // 批量数字签名
			    }
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0070.script
        */
        @Rule(target="sav",order=1200)
        public boolean ruleSavN1200(){
            IContext ctx = MdaEnv.getContext();
            
			int error = ctx.getErrorCode();
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000273"),MdaUtils.getI18NString("mtabut","CT000274"));
			  return false;
			}

			if(!"X".equals(ctx.absGet(Sysmod.class).getFlg()))
			{
			  log.debug("{}","提交成功。返回主页面:"+ctx.absGet(Sysmod.class).getFlg());
			  if (!"cpthyf".equals(ctx.getTransName()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000275"),MdaUtils.getI18NString("mtabut","CT000276"));
			    
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0078.script
        */
        @Rule(target="return",order=100)
        public boolean ruleReturnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:mtabut.@0085.script
        */
        @Rule(target="bnkcfm",order=50)
        public boolean ruleBnkcfmN50(){
            IContext ctx = MdaEnv.getContext();
            
			// 银行端协议补充修改
			ctx.getDaoSession().dbBegin();

			return true;
        }

        /**
        *   source:mtabut.@0086.script
        */
        @Rule(target="bnkcfm",order=1200)
        public boolean ruleBnkcfmN1200(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode()==ERROR_SQL)
			{
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000371"),MdaUtils.getI18NString("mtabut","CT000372"));
			  return false;
			}
			log.debug("{}","提交成功。返回主页面:"+ctx.absGet(Sysmod.class).getFlg());
			ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000373"),MdaUtils.getI18NString("mtabut","CT000374"));
			

			return true;
        }

        /**
        *   source:mtabut.@0087.script
        */
        @Rule(target="bnkcfm",order=800)
        public boolean ruleBnkcfmN800(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  *	保存业最新的务申请书、报文草稿(原有的报文草稿+申请书保留)
			  */
			String fileName = ctx.absGet(Trnmod.class).getTrn().getInr();
			// 保存交易申请书/协议等 PDF文本
			ctx.absGet(Trnmod.class).saveApplicationDataFile(fileName,"app");
			// 保存交易草稿等数据
			ctx.absGet(Trnmod.class).savePackDataFile(fileName,"dra");


			return true;
        }

        /**
        *   source:mtabut.@0091.script
        */
        @Rule(target="bnkcfm",order=900)
        public boolean ruleBnkcfmN900(){
            IContext ctx = MdaEnv.getContext();
            
			/**
			  * 注册服务及交易复核信息
			  */
			log.debug("{}","[bnkcfm order 900]业务处理中...");
			// 更新原业务的工作流
			String trnnam = ctx.getTransName();
			String srv = (String)ctx.restoreData("com.brilliance."+trnnam+".trnsrv");
			// 银行端KYC/单证岗转的业务
			if(!"P".equals(srv))
			{
			  ctx.absGet(Trnmod.class).getWfmmod().updateWorkflow(ctx.absGet(Trnmod.class).getBnktrn().getInr(),"trn",srv,"W","D");
			}
			ctx.absGet(Trnmod.class).getWfmmod().updateWorkflow(ctx.absGet(Trnmod.class).getBnktrn().getInr(),"trn",srv,"W","D");
			// 注册新业务工作流
			String wfsinr = ctx.absGet(Trnmod.class).getWfmmod().setWorkflow(ctx.absGet(Trnmod.class).getTrn(),"D");
			ctx.absGet(Trnmod.class).getWfmmod().addWfe(ctx.absGet(Trnmod.class).getTrn(),wfsinr,"W","D","P","","",ctx.absGet(Sysmod.class).getPty().getInr(),ctx.absGet(Sysmod.class).getRol().getRolnam());
			ctx.absGet(Trnmod.class).getOrdmod().updateOrd(ctx.absGet(Trnmod.class).getTrn().getOrdinr(),"E","26",ctx.absGet(Rmkmod.class).getNtext());
			ctx.absGet(Rmkmod.class).updateRmk("11");

			log.info("{}","当前业务状态trn:sta="+ctx.absGet(Trnmod.class).getTrn().getSta());


			return true;
        }

        /**
        *   source:mtabut.@0092.script
        */
        @Rule(target="sav",order=1100)
        public boolean ruleSavN1100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","sav order[1100]: 临时pdf存表");
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getDoccnt()))
			{
			  ctx.absGet(Trnmod.class).getApldoc().setPDFFromContract();
			}
			log.debug("{}","sav order[1100] 结束");

			return true;
        }

        /**
        *   source:mtabut.@0094.script
        */
        @Rule(target="sav",order=1105)
        public boolean ruleSavN1105(){
            IContext ctx = MdaEnv.getContext();
            
			//添加操作日志记录
			IDatafield<String> ownref = MdaDriver.getDatafield(this.getRec(),"ownref");
			log.info("{}","ownref:" + ownref);
			ctx.absGet(Sysmod.class).setLog(ownref.getValue());

			//经办
			// 判断交易为汇入汇出
			if("cptopn".equals(ctx.getTransName()) || "cptapi".equals(ctx.getTransName()))
			{
			  log.debug("{}","sav消息推送企业业务编号："+ctx.absGet(Trnmod.class).getTrn().getOwnref());
			  String cid = ctx.absGet(Sysmod.class).getPty().getCid();
			  log.debug("{}","cid:"+cid);
			  // 判断开关
			  boolean flg=this.getNotmod().checkSwitch(cid);
			  log.debug("{}","cid:"+cid+"flg:"+flg);
			  if(flg)
			  {
			    String treq = ctx.absGet(Trnmod.class).getTrn().getRelreq();
			    if(!MdaUtils.isEmpty(treq) && treq.length() > 1)
			    {
			      String str = treq.substring(0, 2);
			      if("OB".equals(str))
			      {
			        this.getNotmod().msgtask(cid,ctx.absGet(Trnmod.class).getTrn(),"2","5391","F",null,"Q");
			      }
			      else if("OA".equals(str))
			      {
			        this.getNotmod().msgtask(cid,ctx.absGet(Trnmod.class).getTrn(),"2","5391","F","1","Q");
			      }
			    }
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0095.script
        */
        @Rule(target="sav",order=980)
        public boolean ruleSavN980(){
            IContext ctx = MdaEnv.getContext();
            
			String needSign = (String)Platform.getLoginData("needSign");
			log.info("{}","needSign "+needSign);
			if(!MdaUtils.isEmpty(needSign) && "yes".equals(needSign))
			{
			  Object signresult = ctx.restoreData("sigresult");
			  if(!MdaUtils.isEmpty(signresult))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000429"),MdaUtils.getI18NString("mtabut","CT000430"));
			    ctx.getDaoSession().dbRollback();
			    return false;
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0097.script
        */
        @Rule(target="backswi",order=100)
        public boolean ruleBackswiN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  Platform.message(#CT000473,#CT000474);
			  log.info("backswi order 100 start ....");
			  String ptytyp = $\\sysmod\\pty\\ptytyp.getValue();
			  String ownref =$\\dtrn\\ownref.getValue();
			  String thly = $thly.getValue();
			  String msgref = "";
			  sendMap.put("TransId",ownref);
			  sendMap.put("OutBankStatus","");
			  sendMap.put("Reason",thly);
			  sendMap.put("SendTime",Platform.format(Platform.today(),"yyyyMMddHHmmss"));
			  sendMap.put("ImgStatusAll","");
			  sendMap.put("buscod",ownref);
			  sendMap.put("djcod",ownref);
			  $\\sysmod.setImageMapSwi(sendMap);
			  //企业退回
			
			  sendMap.put("TransStatus","02");
			  if("cptapl".equals($\\dtrn\\inifrm.getValue()))
			  {
			  sendMap.put("MsgNo","SFS118");
			  sendMap.put("inr",inr);
			  sendMap.put("code","SFS118");
			  sendMap.put(" EntMarkNo",$\\dtrn\\stlref.getValue());
			  $\\swmmod.storeSWM("SFS118",$\\dtrn\\objinr.getValue(),$\\dtrn\\objtyp.getValue(),sendMap);
			  }
			  else
			  {
			  sendMap.put("MsgNo","SFS113");
			  sendMap.put("inr",inr);
			  sendMap.put("code","SFS113");
			  sendMap.put("OutBankStatus","");
			  $\\swmmod.storeSWM("SFS113",$\\dtrn\\objinr.getValue(),$\\dtrn\\objtyp.getValue(),sendMap);
			  }
			
			  /*String ownref ="";
			  String thly = "";
			  String msgref = "";
			
			  if(!Platform.isEmpty($msgref))
			  {
			  msgref = $msgref.getValue();
			  }
			  if(!Platform.isEmpty($ownref))
			  {
			  ownref = $ownref.getValue();
			  }
			  if(!Platform.isEmpty($thly))
			  {
			  thly = $thly.getValue();
			  }
			  log.info("backswi order 100 ptytyp ...."+ptytyp);
			  log.info("backswi order 100 ownref ...."+ownref);
			  log.info("backswi order 100 msgref ...."+msgref);
			  Map sendMap = (Map)$swimap.getValue();
			  sendMap.put("TransId",ownref);
			  sendMap.put("OutBankStatus","");
			  sendMap.put("Reason",thly);
			  sendMap.put("SendTime",Platform.format(Platform.today(),"yyyyMMddHHmmss"));
			  sendMap.put("ImgStatusAll","");
			  sendMap.put("buscod",ownref);
			  sendMap.put("djcod",ownref);
			  $\\sysmod.setImageMapSwi(sendMap);
			  //银行退回
			  if("0".equals(ptytyp))
			  {
			  sendMap.put("TransStatus","05");
			  $\\sysmod.setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);
			  }
			  //企业退回
			  if("2".equals(ptytyp))
			  {
			  String frm=Platform.getTransName();
			  sendMap.put("TransStatus","02");
			  $\\sysmod.setSwHeaderMap((String)sendMap.get("MsgNo"),"", sendMap,msgref);
			  }
			  //调用外部接口
			  Map rst = $\\sysmod.retSW((String)sendMap.get("MsgNo"),sendMap,null);
			  String code = (String) rst.get("code");
			  if(Platform.isEmpty(code))
			  {
			  Platform.message(#CT000475,#CT000480);
			  return false;
			  }
			  else
			  {
			  if("999999".equals(code))
			  {
			  String des = (String) rst.get("des");
			  Platform.message(#CT000481,des);
			  return false;
			  }
			  }
			  */

			return true;
        }



        /**
        *   source:mtabut.@0000.script
        */
        @Init(order=20)
        public boolean	init20(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.absGet(Sysmod.class).setTrntiltle(ctx.getTransName());
			ctx.absGet(Sysmod.class).setOprstadat(new Date());
			if(Platform.isFromApp())
			{
			  if(ctx.absGet(Sysmod.class).sptIsLoaded("B"))
			  {
			    ctx.absGet(Sysmod.class).setOrdinr(ctx.absGet(Sysmod.class).getSpt().getOrdinr());
			    //退回的话查询一下历史备注
			    ctx.absGet(Rmkmod.class).loadRemarkByOrd(ctx.absGet(Sysmod.class).getOrdinr());
			  }
			}
			if(!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getOrdinr()))
			{
			  log.info("{}","init 20:ordinr="+ctx.absGet(Sysmod.class).getOrdinr());
			  ctx.absGet(Sysmod.class).sdbRead(ctx.absGet(Trnmod.class).getOrdmod().getOrd(),ctx.absGet(Sysmod.class).getOrdinr());
			  //解决pdf带出旧值问题。
			  //$\\sysmod.sdbRead($\\trnmod\\apldoc\\pdfdoc,$\\sysmod\\ordinr.getValue());
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getApldoc().getPdfdoc(),new Argument("ordinr",ctx.absGet(Sysmod.class).getOrdinr()));
			  ctx.getDaoSession().dbRead(ctx.absGet(Rmkmod.class).getRmk(),new Argument<String>("ordinr",ctx.absGet(Sysmod.class).getOrdinr()));
			  ctx.absGet(Rmkmod.class).setOtext(ctx.absGet(Rmkmod.class).getRmk().getTxt());
			  ctx.absGet(Sysmod.class).setOrdinr(NULLSTR);
			}
			if("S".equals(ctx.absGet(Sysmod.class).getSpt().getScr()))
			{
			  ctx.absGet(Trnmod.class).setOwnflg("Y");
			  log.info("{}","trnmod.flg===="+ctx.absGet(Trnmod.class).getOwnflg());
			}


			return true;
        }

        /**
        *   source:mtabut.@0001.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			//enter the transaction FROM sptsel
			log.info("{}","init load spt inr="+ctx.absGet(Sysmod.class).getSpt().getInr());
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr()))
			  return true;
			//String frm=$\\sysmod\\spt\\frm.getValue();
			//the trnname==frm,or it's wrong
			// use bak data
			//String filename=Platform.catPath(Platform.getRootPath(),"data/delete/" +$\\sysmod\\spt\\inr.getValue()+".bak");
			String filename=ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Sysmod.class).getSpt().getInr(),"bak");
			if("A".equals(ctx.absGet(Sysmod.class).getSpt().getScr())&&!MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getSmhinr()))
			  ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getSmh(),new Argument<String>("inr",ctx.absGet(Sysmod.class).getSpt().getSmhinr()));
			log.info("{}","filename="+filename +" , objtyp = " +ctx.absGet(Sysmod.class).getSpt().getObjtyp());
			String objtyp=ctx.absGet(Sysmod.class).getSpt().getObjtyp();
			if(!MdaUtils.fileExists(filename)||MdaUtils.isEmpty(objtyp))
			  return true;
			IStream is=this.getTrnstm();
			String grppath=objtyp+"grp";
			MdaUtils.streamLoad(is,filename);
			//load another group 10.09
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			//
			log.info("{}","grp0="+grppath);
			MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grppath),is);
			if(!MdaUtils.isEmpty(grp))
			{
			  MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp),is);
			}

			String grp1=MdaUtils.getPropertyValue(name,ctx.getTransName()+".2");
			log.info("{}","grp1="+grp1);
			if(!MdaUtils.isEmpty(grp1))
			{
			  MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp1),is);
			}

			if("brtsnd".equals(ctx.getTransName())||"bctacp".equals(ctx.getTransName())||"cptapi".equals(ctx.getTransName()))
			{
			  if("bctacp".equals(ctx.getTransName()))
			  {
			    String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			    if(!MdaUtils.isEmpty(grp3))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			    }
			    String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			    if(!MdaUtils.isEmpty(grp4))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			    }
			  }
			  if("brtsnd".equals(ctx.getTransName()))
			  {
			    String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			    if(!MdaUtils.isEmpty(grp3))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			    }

			    String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			    if(!MdaUtils.isEmpty(grp4))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			    }
			  }
			  if("cptapi".equals(ctx.getTransName()))
			  {
			    String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			    if(!MdaUtils.isEmpty(grp3))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			    }
			    String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			    if(!MdaUtils.isEmpty(grp4))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			    }
			  }
			}

			if(ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			{
			  IDatafield credat=MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\credat");
			  //credat.setValue(Platform.today());
			  credat.setValue(MdaUtils.sqlDate(MdaUtils.today(),GE));
			}
			MdaUtils.streamClear(is);
			if(Platform.isFromApp())
			{
			  //org.sss.presentation.noui.util.NoUiPresentationUtil.handleInput();
			}

			return true;
        }

        /**
        *   source:mtabut.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
                //201712
			
			
			
			log.debug("{}","enable  stlimgviw,dztimgviw");
			
			
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getInr())  ||  !"A".equals(ctx.absGet(Sysmod.class).getSpt().getScr()))
			  return true;
			if("Z".equals(ctx.absGet(Sysmod.class).getSpt().getSta()))
			  return true;
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			log.info("{}","init 100 after isEmpty or NE 'A'.");
			
			if(!"1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if(MdaUtils.isEmpty(ctx.absGet(Sysmod.class).getSpt().getSmhinr()))
			  return true;
			log.debug("{}","sw2fil="+ctx.absGet(Trnmod.class).getSmh().getSf2fil());
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSmh().getSf2fil()))
			{
			  String sw2fils = ctx.absGet(Trnmod.class).getSmh().getSf2fil();
			  String[] sw2fil = sw2fils.split(";");
			  for(int i=0;i<sw2fil.length;i++)
			  {
			    IDatafield id = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"sw"+i);
			    
			    
			    if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			    {
			      IDatafield tco = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"tco"+i);
			      
			      
			    }
			  }
			}
			if(MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getSmh().getXmlfil()))
			  return true;
			String trnNam = ctx.getTransName();
			String xmlfils =ctx.absGet(Trnmod.class).getSmh().getXmlfil();
			log.debug("{}","trnnam="+trnNam);
			log.debug("{}","xmlfils="+xmlfils);
			String xmlNbm = null;
			String img = null;
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			for(String xmlVal:xmlfils.split(";"))
			{
			  if(xmlVal.indexOf(",")>0)
			    xmlNbm = xmlVal.substring(xmlVal.indexOf(",")+1);
			  if(xmlNbm==null)
			    xmlNbm="0";
			  img = MdaUtils.getPropertyValue(filepath,trnNam+"."+xmlNbm+".img");
			  if(img==null  ||  "".equals(img))
			    img = MdaUtils.getPropertyValue(filepath,trnNam+".img");
			  if(img==null  ||  "".equals(img))
			    img = MdaUtils.getPropertyValue(filepath,"DefaultAdvImage");
			  log.debug("{}","img="+img);
			  IDatafield id = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"notice"+xmlNbm);
			  ((IStream)id.getValue()).setValue(img);
			  
			  
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  {
			    IDatafield flg = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"flg"+xmlNbm);
			    
			    
			    if("betcdv".equals(trnNam)&&!"0".equals(xmlNbm))
			      continue;// 只替换审单表
			    IDatafield edit = MdaDriver.getDatafield(ctx.absGet(Mtabut.class),"edit"+xmlNbm);
			    
			    
			  }
			}

			return true;
        }

        /**
        *   source:mtabut.@0083.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			//退回重新修改的业务，获取之前的影像编号 bilflg 删除标志：0未删除
			if(ctx.absGet(Sysmod.class).backFromBnkchk())
			{

			  String objtyp=ctx.absGet(Sysmod.class).getSpt().getObjtyp();
			  IDatafield ownref=MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\ownref");
			  log.debug("{}","backFromBnkchk Imgref Ownref="+ownref.getValue());
			  Argument<String> djcod=new Argument<String>("djcod");
			  ctx.getDaoSession().dbExecuteSQL("SELECT djcod FROM tblbil WHERE trncod = ? AND buscod = ? AND bilflg = 0 AND rownum=1 ",ctx.getTransName(),ownref.getValue());
			  ctx.getDaoSession().dbFetchFields(djcod);
			  int errorcode=ctx.getErrorCode();
			  ctx.getDaoSession().dbCloseCursor();
			  if(errorcode==NO_ERROR)
			  {
			    ctx.absGet(Trnmod.class).getItfmod().getImgmod().setImgref(djcod.value);
			  }
			  else
			  {
			    log.error("{}","找不到业务申请时的影像批次号");
			  }

			}

			return true;
        }

        /**
        *   source:mtabut.@0098.script
        */
        @Init(order=10)
        public boolean	init10(){
            IContext ctx = MdaEnv.getContext();
            
			if(Platform.isFromApp())
			{
			  String trninr = (String)ctx.restoreData("trninr");
			  if(!MdaUtils.isEmpty(trninr)&&!"trnrel".equals(ctx.getTransName()))
			  {
			    String dir = "data/trndata/"+trninr.substring(0,4)+"/"+trninr+".dat";
			    String filename= MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),dir);
			    String ptyinr=ctx.absGet(Sysmod.class).getPty().getInr();
			    log.info("{}","filename="+filename );
			    ctx.getErrorCode();
			    MdaUtils.clear(ctx.absGet(Trnmod.class).getBnktrn());
			    ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getBnktrn(),new Argument("inr",trninr),new Argument("ptyinr",ptyinr));
			    if(ctx.getErrorCode()!=NO_ERROR||MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getBnktrn().getInr()))
			    {
			      ctx.setMessage("E9999","未找到对应的交易信息或您无权访问该笔交易");
			      return false;
			    }
			    String ordinr = ctx.absGet(Trnmod.class).getBnktrn().getOrdinr();
			    String iniusr = ctx.absGet(Trnmod.class).getBnktrn().getIniusr();
			    //加载提交用户
			    MdaUtils.clear(ctx.absGet(Trnmod.class).getUsrtmp());
			    ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getUsrtmp(),new Argument("inr",iniusr));
			    // 加载ORD
			    ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getOrdmod().getOrd(),new Argument("inr",ordinr));
			    // 加载RMK
			    ctx.absGet(Rmkmod.class).loadRemarkByOrd(ordinr);
			    String objtyp=ctx.absGet(Trnmod.class).getBnktrn().getObjtyp();
			    if(!MdaUtils.fileExists(filename)||MdaUtils.isEmpty(objtyp))
			      return true;
			    IStream is=this.getTrnstm();
			    String grppath=objtyp+"grp";
			    MdaUtils.streamLoad(is,filename);
			    //load another group 10.09
			    String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/grpcfg.properties");
			    String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			    //
			    log.info("{}","grp0="+grppath);
			    MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grppath),is);
			    
			    if(!MdaUtils.isEmpty(grp))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp),is);
			      
			    }

			    String grp1=MdaUtils.getPropertyValue(name,ctx.getTransName()+".2");
			    log.info("{}","grp1="+grp1);
			    if(!MdaUtils.isEmpty(grp1))
			    {
			      MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp1),is);
			      
			    }

			    if("brtsnd".equals(ctx.getTransName())||"bctacp".equals(ctx.getTransName())||"cptapi".equals(ctx.getTransName()))
			    {
			      if("bctacp".equals(ctx.getTransName()))
			      {
			        String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			        if(!MdaUtils.isEmpty(grp3))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			          
			        }
			        String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			        if(!MdaUtils.isEmpty(grp4))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			          
			        }
			      }
			      if("brtsnd".equals(ctx.getTransName()))
			      {
			        String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			        if(!MdaUtils.isEmpty(grp3))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			          
			        }

			        String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			        if(!MdaUtils.isEmpty(grp4))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			          
			        }
			      }
			      if("cptapi".equals(ctx.getTransName()))
			      {
			        String grp3 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".3");
			        if(!MdaUtils.isEmpty(grp3))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp3),is);
			          
			        }
			        String grp4 = MdaUtils.getPropertyValue(name,ctx.getTransName()+".4");
			        if(!MdaUtils.isEmpty(grp4))
			        {
			          MdaUtils.loadData(MdaDriver.getModule(this,ctx.getRoot(),grp4),is);
			          
			        }
			      }
			    }
			    //返回码表
			    List<CodetableItem> bchcod =ctx.absGet(Sysmod.class).getAndSetBchcodvals();
			    IDatafield<String> idbchcod = MdaDriver.getDatafield(ctx.absGet(Mtabut.class).getRec(),"bchcod");
			    if(!MdaUtils.isEmpty(idbchcod))
			    {
			      MdaUtils.setValues(idbchcod,bchcod);
			      
			    }

			    if(ctx.absGet(Sysmod.class).sptIsLoaded("P"))
			    {
			      IDatafield credat=MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\credat");
			      //credat.setValue(Platform.today());
			      credat.setValue(MdaUtils.sqlDate(MdaUtils.today(),GE));
			    }

			    if("cpd".equals(objtyp))
			    {
			      if("cptopn".equals(ctx.getTransName()))
			      {
			        IDatafield remcur=MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\remcur");
			        IDatafield cptpcur= MdaDriver.getDatafield(ctx.getRoot(),"cptp\\cur");
			        IDatafield cptpcur1= MdaDriver.getDatafield(ctx.getRoot(),"cptp\\cur1");
			        IDatafield cptpcur2= MdaDriver.getDatafield(ctx.getRoot(),"cptp\\cur2");
			        cptpcur.setValue(remcur.getValue());
			        cptpcur1.setValue(remcur.getValue());
			        cptpcur2.setValue(remcur.getValue());
			        
			        
			        
			        log.info("{}","详情remcur"+remcur);
			        log.info("{}","详情cptpcur"+cptpcur.getValue());
			      }
			    }

			    MdaUtils.streamClear(is);
			    //详情直接返回
			    return false;
			  }
			}


			return true;
        }


        /**
        *   source:mtabut.@0019.script
        */
        public void loadWfd()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","I am in loadWfd...!");
			//NOTFOUND 1
			//OTHERERROR 2,3,4...
			String transname=ctx.getTransName();
			Argument<String> tinr=new Argument<String>("inr");
			//pty
			String ptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			if (!MdaUtils.isEmpty(ptyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+ptyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  int errorcode=ctx.getErrorCode();
			  log.info("{}",errorcode);
			  if (errorcode==NO_ERROR)
			  {
			    log.info("{}","NO_ERROR");
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if (errorcode==NO_MORE_ROW)
			    {
			      // all transactions one rule
			      log.info("{}","NO_MORE_ROW");
			      sql="SELECT inr FROM wfd WHERE objtyp='pty' and objinr='"+ptyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      if (ctx.getErrorCode()==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if (ctx.getErrorCode()==2)
			      {
			        ctx.setMessage("","Error:");
			        return;
			      }
			    }
			    if (ctx.getErrorCode()==2)
			    {
			      ctx.setMessage("","Error:");
			      return;
			    }
			  }
			}
			//ety
			String etyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr();
			if (!MdaUtils.isEmpty(etyinr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+etyinr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  if (ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if (ctx.getErrorCode()==1)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='ety' and objinr='"+etyinr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      if (ctx.getErrorCode()==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if (ctx.getErrorCode()==2)
			      {
			        ctx.setMessage("","Error:");
			        return;
			      }
			    }
			    if (ctx.getErrorCode()==2)
			    {
			      ctx.setMessage("","Error:");
			      return;
			    }
			  }
			}
			//etg
			String etginr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtg().getInr();
			if (!MdaUtils.isEmpty(etginr))
			{
			  String sql="SELECT inr FROM wfd WHERE objtyp='etg' and objinr='"+etginr+"' and nam='"+transname+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  if (ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(tinr);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    if (ctx.getErrorCode()==1)
			    {
			      sql="SELECT inr FROM wfd WHERE objtyp='etg' and objinr='"+etginr+"' and nam=''";
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      if (ctx.getErrorCode()==NO_ERROR)
			      {
			        ctx.getDaoSession().dbFetchFields(tinr);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			      if (ctx.getErrorCode()==2)
			      {
			        ctx.setMessage("",MdaUtils.getI18NString("mtabut","CT000020"));
			        return;
			      }
			      if (ctx.getErrorCode()==2)
			      {
			        ctx.setMessage("","Error:");
			        return;
			      }
			    }
			    if (ctx.getErrorCode()==2)
			    {
			      ctx.setMessage("","Error:");
			      return;
			    }
			  }
			}
		}
        /**
        *   source:mtabut.@0020.script
        */
        public void loadWft()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String wfdinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr();
			if(MdaUtils.isEmpty(wfdinr))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("mtabut","CT000039"));
			  return;
			}
			String transname=ctx.getTransName();
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("frm",transname));
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjtyp();
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjinr();
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("frm",transname));
			int errorcode=ctx.getErrorCode();
			if (errorcode==NO_ERROR)
			{
			  return;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("stp","2"));
			    ctx.setMessage("",MdaUtils.getI18NString("mtabut","CT000096"));
			  }
			  else
			  {
			    ctx.setMessage("","Execute error!");
			  }
			}
		}
        /**
        *   source:mtabut.@0021.script
        */
        public void createBackSpt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000035
			String ptytyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp();
			if(!"0".equals(ptytyp)||"1".equals(ptytyp))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("mtabut","CT000036"));
			  return;
			}
			String ptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			if(ptyinr.equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrpty()))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("mtabut","CT000042"));
			  return;
			}
			Argument<String> trninr=new Argument<String>("inr");
			Argument<String> inifrm=new Argument<String>("inifrm");
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().setInr(NULLSTR);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().setOprogninr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrpty());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().setDattim(new Date());
			String ordinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrtxt();
			String optptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrpty();
			String sql="SELECT inr,inifrm FROM trn WHERE ordinr='"+ordinr+"' and optptyinr='"+optptyinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			//if errorCode()==0
			ctx.getDaoSession().dbFetchFields(trninr,inifrm);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().setFrm(inifrm.value);
			ctx.getDaoSession().dbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			//String sptinr=$\\sysmod\\spt\\inr.getValue();
			//String tarfile=sptinr+".bak";
			//String tarpath=Platform.getRootPath();
			//tarpath=Platform.catPath(Platform.catPath(tarpath,"data"),"delete");
			//tarfile=Platform.catPath(tarpath,tarfile);
			String tarfile=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr(),"bak");
			if(MdaUtils.fileExists(tarfile))
			{
			  MdaUtils.fileDelete(tarfile);
			}
			// 20150311 MOD BY DG
			//String filename=trninr.value+".dat";
			//String path=Platform.getRootPath();
			//path=Platform.catPath(Platform.catPath(path,"data"),"trndata");
			//filename=Platform.catPath(path,filename);
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr.value,"dat");
			if(MdaUtils.fileExists(filename))
			{
			  IStream os=this.getTrnstm();
			  MdaUtils.streamLoad(os,filename);
			  MdaUtils.streamSave(os,tarfile);
			}
			//cancel the trn records and wfs/wfes records
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfs(),new Argument<String>("objinr",trninr.value),new Argument<String>("objtyp","trn"));
			String wfsinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfs().getInr();
			//Platform.dbDelete($\\trnmod\\wfmmod\\wfe,new Argument("wfsinr",wfsinr));
			//Platform.dbDelete($\\trnmod\\wfmmod\\wfs,new Argument("inr",wfsinr));
			//Platform.dbDelete($\\trnmod\\trn,new Argument("inr",trninr));
			ctx.getDaoSession().dbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr));
			//delete trn file
			// 20150311 MOD BY DG
			//String trnfilename=trninr.value+".dat";
			//String datpath=Platform.getRootPath();
			//datpath=Platform.catPath(Platform.catPath(datpath,"data"),"trndata");
			//trnfilename=Platform.catPath(datpath,trnfilename);
			String trnfilename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr.value,"dat");
			if(MdaUtils.fileExists(trnfilename))
			{
			  MdaUtils.fileDelete(trnfilename);
			}
			//delete disPlay file
			
			//String disname=trninr.value+".zul";
			//getFile("dsp",disname);
			/*
			  String dispath=Platform.getRootPath();
			  dispath=Platform.catPath(Platform.catPath(dispath,"data"),"dsp");
			  disname=Platform.catPath(dispath,disname);
			  */
			String disname = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr.value,"zul");
			if(MdaUtils.fileExists(disname))
			{
			  MdaUtils.fileDelete(disname);
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:mtabut.@0023.script
        */
        public void UpdatePtsForBack(IModule ptsrol,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//退回时更新交易对手，包括新增，修改和删除
			
			IDatafield inr=MdaDriver.getDatafield(ptsrol,"inr");
			IDatafield extkey=MdaDriver.getDatafield(ptsrol,"extkey");
			IDatafield adrblk=MdaDriver.getDatafield(ptsrol,"adrblk");
			IDatafield oinr=MdaDriver.getDatafield(ptsrol,"objinr");
			log.info("{}","更新账户信息："+"inr:"+inr.getValue()+"extkey:"+extkey.getValue()+"adrblk"+adrblk.getValue());
			if(!MdaUtils.isEmpty(inr) && MdaUtils.isEmpty(extkey) && MdaUtils.isEmpty(adrblk))
			{
			  //Platform.dbDelete(ptsrol);
			  ctx.getDaoSession().dbDelete(ptsrol,new Argument("inr",inr.getValue()));
			}
			else if((!MdaUtils.isEmpty(adrblk)|| !MdaUtils.isEmpty(extkey))&& MdaUtils.isEmpty(inr))
			{
			  inr.setValue(Platform.sdbCounter("pts"));
			  (MdaDriver.getDatafield(ptsrol,"objinr")).setValue(objinr);
			  ctx.getDaoSession().dbInsert(ptsrol);
			}
			else if(!MdaUtils.isEmpty(inr)&& (!MdaUtils.isEmpty(extkey)|| !MdaUtils.isEmpty(adrblk)))
			{
			  log.debug("{}","[Update->Pts]inr="+inr.getValue()+",extkey="+extkey.getValue());
			  log.info("{}","oinr信息"+oinr.getValue());
			  //Platform.errorCode(); //BUG
			  //Platform.dbRead(ptsrol,new Argument("inr",inr.getValue()));
			  //if(Platform.errorCode()==NO_ERROR)
			  ctx.getDaoSession().dbUpdate(ptsrol);
			  //log.debug("errorCode="+Platform.errorCode());
			}
		}
        /**
        *   source:mtabut.@0027.script
        */
        public boolean isTcoIgnore(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String filename=MdaUtils.catPath(path,"msg.properties");
			String tvalue=null;
			if(MdaUtils.fileExists(filename))
			{
			  tvalue=MdaUtils.getPropertyValue(filename,trnname);
			  if("y".equals(tvalue))
			    return true;
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000149"),MdaUtils.getI18NString("mtabut","CT000150"));
			return false;
		}
        /**
        *   source:mtabut.@0032.script
        */
        public void getRef()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			IDatafield ownref = MdaDriver.getDatafield(this.getRec(),"ownref");
			if(MdaUtils.isEmpty(ownref))
			{
			  //不判空会有什么影响
			  String prefix = this.getPrefix() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefix()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  ownref.setValue(prefix);
			  
			}
		}
        /**
        *   source:mtabut.@0035.script
        */
        public String getXmlFile(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			if(type==null  ||  "".equals(type))
			  type="0";
			String[] files = filename.split(";");
			for(String file:files)
			{
			  if(file.indexOf(","+type)>0)
			  {
			    filename = file.substring(0,file.indexOf(","+type));
			    break;
			  }
			  else
			    filename = file;
			}
			log.debug("{}",filename);
			return filename;
		}
        /**
        *   source:mtabut.@0038.script
        */
        public String getSw2File(int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getSf2fil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			String[] files = filename.split(";");
			if(index<0  ||  index>=files.length)
			  index=0;
			return files[index];
		}
        /**
        *   source:mtabut.@0046.script
        */
        public void creatApplyPdfFile(String filnam,String pdfTpl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//String trsnam=Platform.getValues(transName,name);
			
			Map<String,Object> data = new HashMap<String,Object>();
			data=Platform.getValueMap(ctx.getRoot(),ctx.getTransName(),"PDF");
			String tplfile =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/attachment/"+pdfTpl+".pdf");
			String logofile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtyLgnUrl(null);
			log.info("{}","logofile="+logofile +"\ttplfile="+tplfile);
			String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			log.info("{}","path="+pdfPath);
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","createApplyPdfFile",filnam,pdfPath,tplfile,data,logofile);
		}
        /**
        *   source:mtabut.@0047.script
        */
        public void creatTcoPdfFile(String pdfName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String trsnam = ctx.getTransName();
			Map<String,Object> data=Platform.getValueMap(ctx.getRoot(),trsnam,"DATA");
			String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			Map<String,String[]> dmap  = (Map<String,String[]>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraft",trsnam,data,cfgpath);
			log.info("{}","Draft data.size===="+dmap.size() );
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/");
			String pdfPath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/etrade/pdf/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","createTcoPdfFile",dmap,trsnam,waterfilePath,pdfPath,pdfName);
		}
        /**
        *   source:mtabut.@0064.script
        */
        public String getXmlFileInfo(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			if(filename==null  ||  "".equals(filename))
			  return "";
			if(type==null  ||  "".equals(type))
			  type="0";
			String[] files = filename.split(";");
			for(String file:files)
			{
			  if(file.indexOf(","+type)>0)
			    return file;
			}
			return filename;
		}
        /**
        *   source:mtabut.@0071.script
        */
        public void loadNoticeData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *处理通知附件逻辑等同与init 50 和100 通知文件夹批量转历史使用的方法
			  */
			log.info("{}","init load spt inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr());
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr())||!"A".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScr()))
			  return;
			//String frm=$\\sysmod\\spt\\frm.getValue();
			//the trnname==frm,or it's wrong
			// use bak data
			
			//String filename=Platform.catPath(Platform.getRootPath(),"data/delete/" +$\\sysmod\\spt\\inr.getValue()+".bak");
			String filename=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr(),"bak");
			if("A".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScr())&&!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()))
			  ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()));
			log.info("{}","filename="+filename);
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjtyp();
			if(!MdaUtils.fileExists(filename)||MdaUtils.isEmpty(objtyp))
			  return;
			IStream is=this.getTrnstm();
			String grppath=objtyp+"grp";
			MdaUtils.streamLoad(is,filename);
			//load another group 10.09
			String name=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/grpcfg.properties");
			String grp=MdaUtils.getPropertyValue(name,ctx.getTransName()+".1");
			//
			log.info("{}","grp0="+grppath);
			MdaUtils.loadData(MdaDriver.getModule(ctx.getRoot(),grppath),is);
			if(!MdaUtils.isEmpty(grp))
			{
			  log.info("{}","grp1="+grp);
			  MdaUtils.loadData(MdaDriver.getModule(ctx.getRoot(),grp),is);
			}
			if(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sptIsLoaded("P"))
			{
			  IDatafield credat=MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\credat");
			  credat.setValue(MdaUtils.today());
			}
			MdaUtils.streamClear(is);
			if("Z".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSta()))
			  return;
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			log.info("{}","init 100 after isEmpty or NE 'A'.");
			
			if(!"1".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp()))
			{
			  
			  
			}
			else
			{
			  
			  
			  
			  
			  
			  
			  
			  
			  
			}
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()))
			  return ;
			log.debug("{}","sw2fil="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getSf2fil());
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getSf2fil()))
			{
			  String sw2fils = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getSf2fil();
			  String[] sw2fil = sw2fils.split(";");
			  for(int i=0;i<sw2fil.length;i++)
			  {
			    IDatafield id = MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class),"sw"+i);
			    
			    
			    if("1".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp()))
			    {
			      IDatafield tco = MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class),"tco"+i);
			      
			      
			    }
			  }
			}
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil()))
			  return;
			String trnNam = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getFrm();
			String xmlfils =ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getXmlfil();
			log.debug("{}","trnnam="+trnNam);
			log.debug("{}","xmlfils="+xmlfils);
			String xmlNbm = null;
			String img = null;
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			for(String xmlVal:xmlfils.split(";"))
			{
			  if(xmlVal.indexOf(",")>0)
			    xmlNbm = xmlVal.substring(xmlVal.indexOf(",")+1);
			  if(xmlNbm==null)
			    xmlNbm="0";
			  img = MdaUtils.getPropertyValue(filepath,trnNam+"."+xmlNbm+".img");
			  if(img==null||"".equals(img))
			    img = MdaUtils.getPropertyValue(filepath,trnNam+".img");
			  if(img==null||"".equals(img))
			    img = MdaUtils.getPropertyValue(filepath,"DefaultAdvImage");
			  log.debug("{}","img="+img);
			  IDatafield id = MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class),"notice"+xmlNbm);
			  ((IStream)id.getValue()).setValue(img);
			  
			  
			  if("1".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp()))
			  {
			    IDatafield flg = MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class),"flg"+xmlNbm);
			    
			    
			    if("betcdv".equals(trnNam)&&!"0".equals(xmlNbm))
			      continue;// 只替换审单表
			    IDatafield edit = MdaDriver.getDatafield(ctx.absGet(com.ceb.gjjs.mda.manager.module.Mtabut.class),"edit"+xmlNbm);
			    
			    
			  }
			}
		}
        /**
        *   source:mtabut.@0072.script
        */
        public boolean isXmlTransaction(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String filename=MdaUtils.catPath(path,"msg.properties");
			String tvalue=null;
			if(MdaUtils.fileExists(filename))
			{
			  tvalue=MdaUtils.getPropertyValue(filename,"xml."+trnname);
			  if("y".equals(tvalue))
			    return true;
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("mtabut","CT000281"),MdaUtils.getI18NString("mtabut","CT000282"));
			return false;
		}
        /**
        *   source:mtabut.@0084.script
        */
        public String getRefrence(IDatafield<String> fld, String prefix)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 融资类交易的相关参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			String ownref = "";
			String pre = prefix ;
			if(MdaUtils.isEmpty(fld))
			{
			  prefix = prefix + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(pre+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  fld.setValue(prefix);
			  
			}
			else
			{
			  ownref = fld.getValue();
			}
			return ownref ;
		}

        public void setRecHolder(ModuleHolder<IModule> rec)
        {
           this.rec = rec;
        }

        public IModule getRec()
        {
           return this.rec.get();
        }





























































































        public void setPrefixHolder(FieldHolder<String> prefix)
        {
           this.prefix = (prefix);
        }

        public void setPrefix(String prefix)
        {
            this.prefix.setValue(prefix);
        }

        public String getPrefix()
        {
            return this.prefix.getValue();
        }





































































































































}