package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.bo.Notmsg;
import com.ceb.gjjs.mda.bo.Modlst;
import com.ceb.gjjs.mda.bo.Swit;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Usraut;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 消息推送
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Notmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Notmod.class);



	    @BDGetter
		private Msg msg;

	    @BDGetter
		private Msg msglst;

	    @BDGetter
		private Modlst modlst;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Notmsg notmsg;

	    @BDGetter
		private Usraut usraut;

	    @BDGetter
		private Usr usr;

	    @BDGetter
		private Wfe wfe;

	    @BDGetter
		private Swit swit;

	    @BDGetter
		private Wfs wfs;

		@BDGetter
		private ModuleList<Usr> usrlst;

		@BDGetter
		private ModuleList<Usraut> usrautlst;


		public Notmod()
        {
            super();
            setArgument();
        }

        public Notmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:notmod.@0000.script
        */
        public Boolean checkSwitch(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Boolean flag = false;
			//判断版本协议号
			if(MdaUtils.isEmpty(this.getPty().getInr())||!cid.equals(this.getPty().getCid()))
			{
			  MdaUtils.clear(this.getPty());
			  ctx.getDaoSession().dbRead(this.getPty(),new Argument<String>("cid",cid),new Argument<String>("ptytyp","2"));
			  ctx.getErrorCode();
			}
			String ver = this.getPty().getVer();
			log.debug("{}","协议号：" + ver);
			if(MdaUtils.isEmpty(ver)||Integer.parseInt(ver) < 2)
			{
			  return false;
			}
			//通过客户号查询开关表
			//先查询总开关
			MdaUtils.clear(this.getSwit());
			ctx.getDaoSession().dbRead(this.getSwit(),new Argument<String>("switchtyp","1"));
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(this.getSwit().getInr()))//为空默认开着的
			{
			  flag = true;
			}
			else
			{
			  //总开关类型是为空或者为”1“，都默认打开
			  if(MdaUtils.isEmpty(this.getSwit().getGsta()) || "1".equals(this.getSwit().getGsta()))
			  {
			    flag = true;
			  }
			  else
			  {
			    flag = false;
			  }
			}
			MdaUtils.clear(this.getSwit());
			if(flag)//总开关打开，查客户开关
			{
			  ctx.getDaoSession().dbRead(this.getSwit(),new Argument<String>("cid",cid));
			  ctx.getErrorCode();
			  log.debug("{}","开关查询结果：inr,switchtyp,gsta"+this.getSwit().getInr()+","+this.getSwit().getSwitchtyp()+","+this.getSwit().getGsta());
			  if(MdaUtils.isEmpty(this.getSwit().getInr()))
			  {
			    flag = true;
			  }
			  else
			  {
			    if(MdaUtils.isEmpty(this.getSwit().getGsta()) || "1".equals(this.getSwit().getGsta()))
			    {
			      flag = true;
			    }
			    else
			    {
			      flag = false;
			    }
			  }
			}
			return flag;
		}
        /**
        *   source:notmod.@0001.script
        */
        public Boolean checkVer()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询协议号
			boolean flag = false;
			String ver =	ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getVer();
			log.debug("{}","协议号：" + ver);
			if(Integer.parseInt(ver) >= 2)
			{
			  flag = true;
			}
			return flag;
		}
        /**
        *   source:notmod.@0002.script
        */
        public List<String> getUsr(String cid,String jiaoyi,String flag,String lvl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<String> list = new ArrayList<String>();
			//查询拥有经办、复核权限  flag J:经办、F:复核
			List objs = new ArrayList();
			String sql=" from m1 ";
			sql = sql + " left join m2 with m1.inr = m2.objinr ";
			if("J".equals(flag))
			{
			  sql = sql + " and m2.flg1 = '0' ";
			}
			if("F".equals(flag))
			{
			  sql = sql + " and m2.flg2 = '0' ";
			}
			if("JF".equals(flag))
			{
			  sql = sql + " and m2.flg1 = '0' and m2.flg2 = '0' ";
			}
			sql = sql + " where m1.cid = ? ";
			objs.add(cid);
			sql = sql + " and m2.frm = ? ";
			objs.add(jiaoyi);
			if(!MdaUtils.isEmpty(lvl))
			{
			  sql = sql + " and m2.lvl = ? ";
			  objs.add(lvl);
			}

			log.debug("{}","sql==="+sql);
			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getUsrlst(),this.getUsrautlst()},new CacheOption(0, true),sql,objs.toArray());
			log.info("{}","size :"+this.getUsrlst().size());
			Argument<String> oid = new Argument<String>("oid");
			for(int i = 0; i<this.getUsrlst().size(); i++){
			  list.add(this.getUsrlst().getElement(i).getOid());
			}
			return list;
		}
        /**
        *   source:notmod.@0003.script
        */
        public String saveNotmsg(String msgtype,String modnum,String desc1,String desc2,Date desc3,String desc4,String desc5,String desc6,String desc7,String desc8)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//保存待发送消息信息表，返回inr
			String inr = Platform.sdbCounter("notmsg");
			this.getNotmsg().setInr(inr);
			//消息类型
			this.getNotmsg().setMsgtype(msgtype);
			//模板编号
			this.getNotmsg().setModnum(modnum);
			this.getNotmsg().setDesc1(desc1);
			this.getNotmsg().setDesc2(desc2);
			this.getNotmsg().setDesc3(desc3);
			this.getNotmsg().setDesc4(desc4);
			this.getNotmsg().setDesc5(desc5);
			this.getNotmsg().setDesc6(desc6);
			this.getNotmsg().setDesc7(desc7);
			if(!MdaUtils.isEmpty(desc8))
			{
			  this.getNotmsg().setDesc8(desc8);
			}
			ctx.getDaoSession().dbInsert(this.getNotmsg());
			return inr;
		}
        /**
        *   source:notmod.@0004.script
        */
        public void addWfe(String wfsinr,String ptyinr,String notmsginr,String oid,String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWfe().setWfsinr(wfsinr);
			this.getWfe().setSrv("Z");
			this.getWfe().setSta("W");
			this.getWfe().setDattim(MdaUtils.today());
			this.getWfe().setManflg("0");
			this.getWfe().setTardattim(MdaUtils.today());
			this.getWfe().setSrvtxt(notmsginr);
			this.getWfe().setTxt(frm);
			String inr = Platform.sdbCounter("wfe");
			log.debug("{}","保存wfe记录表信息wfe inr is "+ inr);
			this.getWfe().setPtyinr(ptyinr);
			this.getWfe().setInr(inr);
			this.getWfe().setRol(oid);
			ctx.getDaoSession().dbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());
		}
        /**
        *   source:notmod.@0005.script
        */
        public String setWfsFromXmlbod(String objinr,String objtyp,String srv,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in setWfsFromXmlbod ... ");
			MdaUtils.clear(this.getWfs());
			if(MdaUtils.isEmpty(objinr))
			{
			  return null;
			}
			this.getWfs().setObjinr(objinr);
			this.getWfs().setObjtyp(objtyp);
			this.getWfs().setWfstxt(srv);
			this.getWfs().setWkftyp(typ);
			this.getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getWfs());
			log.debug("{}"," SAVE WFS{inr=" + this.getWfs().getInr() + "}");
			log.debug("{}","out setWfsFromXmlbod ... ");
			return this.getWfs().getInr();
		}
        /**
        *   source:notmod.@0006.script
        */
        public String msgtask(String cid,com.ceb.gjjs.mda.bo.Trn trn,String msgtype,String modnum,String flag,String lvl,String pingtai)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//判断是否是汇入、汇出交易
			//判断开关
			String trncod = trn.getInifrm();
			String srv = "Z";
			log.info("{}","工作流注册交易：" + trncod +" ,注册工作流类型："+ srv);
			//存储wfs
			String objInr = trn.getObjinr();
			String objtyp = trn.getObjtyp();
			String wfsinr = setWfsFromXmlbod(objInr,objtyp,srv,"1");
			log.debug("{}","保存wfs表inr"+wfsinr);
			//存储 wfe
			if(!MdaUtils.isEmpty(wfsinr))
			{
			  // 存储待发送信息表
			  //String msgtype = "4";//消息类型
			  //String modnum = "5391";//退回模板编号
			  String desc1 = null;
			  String desc2 = null;
			  String desc6 = null;
			  String desc7 = null;
			  String desc8 = null;
			  Date desc3 = trn.getInidattim();//交易时间
			  String desc4 = trn.getReloricur();//币种
			  String desc5 = MdaUtils.format(trn.getReloriamt(),"#0.00");//金额
			  Argument<String> adrblk = new Argument<String>("adrblk");
			  Argument<String> paynam = new Argument<String>("paynam");
			  Argument<String> oid = new Argument<String>("oid");
			  String sql="SELECT s.adrblk adrblk,c.paynam paynam,u.oid oid FROM trn t ";
			  sql=sql+" LEFT JOIN  pts s on s.objinr=t.objinr and s.objtyp=t.objtyp and s.rol='ben' ";
			  sql=sql+" LEFT JOIN  cpd c on t.objinr = c.inr AND t.objtyp='cpd' ";
			  sql=sql+" LEFT JOIN  usr u on u.inr=t.iniusr ";
			  sql=sql+" WHERE t.ptytyp = '2' and t.objinr='"+trn.getObjinr()+"' and t.inifrm='"+trn.getInifrm()+"' ";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getErrorCode();
			  ctx.getDaoSession().dbFetchFields(adrblk,paynam,oid);
			  ctx.getDaoSession().dbCloseCursor();
			  log.debug("{}","adrblk:"+adrblk.value+","+paynam.value+","+oid.value);
			  if("cptopn".equals(trn.getInifrm()))
			  {
			    desc1 = "汇出汇款";//交易名称
			    desc6 = "收款人";//收款人
			    desc7 = adrblk.value;
			  }
			  if("cptapi".equals(trn.getInifrm()))
			  {
			    desc1 = "汇入汇款";//交易名称
			    desc6 = "付款人";//付款人
			    desc7 = paynam.value;
			  }

			  String oidJ = oid.value;//经办人员
			
			  if("5391".equals(modnum))//待审核
			  {
			    desc2 = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getOid();//申请人
			    if("cptopn".equals(trn.getInifrm()))
			    {
			      IModule mod=MdaDriver.getModule(ctx.getRoot(),"cpdgrp\\ben\\pts");
			      if(!MdaUtils.isEmpty(mod))
			      {
			        IDatafield<String> adrblkfld = MdaDriver.getDatafield(mod,"adrblk");
			        desc7 = adrblkfld.getValue(); //收款人
			      }
			    }
			    if("cptapi".equals(trn.getInifrm()))
			    {
			      IModule mod1=MdaDriver.getModule(ctx.getRoot(),"cpdgrp\\rec");
			      if(!MdaUtils.isEmpty(mod1))
			      {
			        IDatafield<String> paynam1 = MdaDriver.getDatafield(mod1,"paynam");
			        desc7 = paynam1.getValue(); //收款人
			      }
			    }
			  }
			  else if("5392".equals(modnum))//退回待处理
			  {
			    if("Y".equals(pingtai))
			    {
			      desc2 ="银行审批拒绝";
			    }
			    if("Q".equals(pingtai))
			    {
			      desc2 ="企业授权退回";
			    }
			  }
			  else if("5393".equals(modnum))//审核完成
			  {
			    desc2 = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getOid();//复核人
			    desc8 = trn.getOwnref();//业务编号
			  }

			  log.debug("{}","notmsg值："+ msgtype+","+modnum+","+desc1+","+desc2+","+desc3+","+desc4+","+desc5+","+desc6+","+desc7+","+desc8);
			  String notmsginr = saveNotmsg(msgtype,modnum,desc1,desc2,desc3,desc4,desc5,desc6,desc7,desc8);
			  log.debug("{}","保存notmsg表inr"+notmsginr);
			  log.debug("{}","授权等级：" + lvl);

			  String ptyinr = trn.getPtyinr();
			  if("5391".equals(modnum))
			  {
			    String oidj = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getOid();
			    List<String> oids = getUsr(cid,trncod,flag,lvl);
			    for(int j = 0; j<oids.size(); j++){
			      if(!oidj.equals(oids.get(j)))//过滤经办人员
			    {
			      addWfe(wfsinr,ptyinr,notmsginr,oids.get(j),trncod);
			    }
			  }
			}
			if("5392".equals(modnum) || "5393".equals(modnum))
			{//只需要发给经办人
			  addWfe(wfsinr,ptyinr,notmsginr,oidJ,trncod);
			}
			}
			return null;
		}
        /**
        *   source:notmod.@0007.script
        */
        public String checklv1(String res)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if("OB".equals(res))
			{
			  return "1";
			}
			if(res.contains("OB"))
			{
			  String str = res.substring(res.indexOf("OB") + 2);
			  int lv1 = str.length() + 1;
			  return lv1 + "";
			}
			return null;
		}
        /**
        *   source:notmod.@0008.script
        */
        public void test()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}

























}