package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Oprp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Oprp.class);

        //保存
        private transient IControl submit = new ControlImpl("submit", "保存", this);

        //选择
        private transient IControl sel = new ControlImpl("sel", "选择", this);

        //返回
        private transient IControl rtn = new ControlImpl("rtn", "返回", this);

        //stream
        private IStream stream = new StreamImpl();

        //授权
        private transient IControl grant = new ControlImpl("grant", "授权", this);

        //同步操作员
        private transient IControl getuser = new ControlImpl("getuser", "同步操作员", this);

        //操作员登录名称
        private String usrnam;

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //重置操作员
        private transient IControl reset = new ControlImpl("reset", "重置操作员", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel selusr;

        @JsonIgnore
        @BDGetter
        private transient IPanel usrautlst;

        @JsonIgnore
        @BDGetter
        private transient IPanel sigaut;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Oprgrp> oprgrp;


		public Oprp()
        {
            super();
            setArgument();
        }

        public Oprp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:oprp.@0000.script
        */
        public void loadModLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//清除数据列表
			MdaUtils.clear(this.getOprgrp().getModlstlst());
			//数据库中仅保存没有权限的交易，所以此处采用左连接后，应该判断ptyinr为空。
			String sql = "SELECT m.inr,m.frm,m.nam,m.trntyp FROM modlst m";
			sql+=" LEFT OUTER JOIN";
			sql+=" (SELECT * FROM ptymod WHERE ptyinr='"+ctx.absGet(Sysmod.class).getPty().getInr()+"') p ON m.frm=p.frm";
			sql+=" WHERE m.modtyp in('0','1') AND m.ptytyp='"+ctx.absGet(Sysmod.class).getPty().getPtytyp()+"' AND p.ptyinr IS NULL";
			sql+=" ORDER BY m.trntyp";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> frm = new Argument<String>("frm");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,frm,nam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getOprgrp().getModlstlst().add(inr,frm,nam);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:oprp.@0003.script
        */
        public boolean savUsraut(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in savUsraut ... frm =  " + frm );
			boolean result = true;
			ctx.getDaoSession().dbBegin();
			MdaUtils.clear(this.getOprgrp().getUsraut());
			ctx.getDaoSession().dbRead(this.getOprgrp().getUsraut(),new Argument<String>("frm",frm),new Argument<String>("objtyp","usr"),new Argument<String>("objinr",this.getOprgrp().getUsr().getInr()));
			int errorCode=ctx.getErrorCode();
			log.debug("{}","errorCode = " + errorCode );
			if(errorCode==NO_MORE_ROW)
			  log.info("{}","no usraut record found!");
			else if(errorCode!=NO_ERROR)
			  return false;
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getOflg()))
			  this.getOprgrp().getOpraut().setOflg("1");
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getBflg()))
			  this.getOprgrp().getOpraut().setBflg("1");
			if(MdaUtils.isEmpty(this.getOprgrp().getOpraut().getAflg()))
			  this.getOprgrp().getOpraut().setAflg("0");
			if(MdaUtils.isEmpty(this.getOprgrp().getUsraut().getInr()))
			{
			  this.getOprgrp().getUsraut().setInr(Platform.sdbCounter("usraut"));
			  this.getOprgrp().getUsraut().setObjtyp("usr");
			  this.getOprgrp().getUsraut().setFrm(frm);
			  this.getOprgrp().getUsraut().setObjinr(this.getOprgrp().getUsr().getInr());
			  this.getOprgrp().getUsraut().setPtyinr(this.getOprgrp().getUsr().getPtyinr());
			  this.getOprgrp().getUsraut().setFlg1(this.getOprgrp().getOpraut().getOflg());
			  this.getOprgrp().getUsraut().setFlg2(this.getOprgrp().getOpraut().getBflg());
			  this.getOprgrp().getUsraut().setLvl(this.getOprgrp().getOpraut().getAflg());
			  ctx.getDaoSession().dbInsert(this.getOprgrp().getUsraut());
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return false;
			  log.debug("{}","Insert usraut inr = "+this.getOprgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getOprgrp().getUsr().getInr());
			}
			else
			{
			  this.getOprgrp().getUsraut().setFlg1(this.getOprgrp().getOpraut().getOflg());
			  this.getOprgrp().getUsraut().setFlg2(this.getOprgrp().getOpraut().getBflg());
			  this.getOprgrp().getUsraut().setLvl(this.getOprgrp().getOpraut().getAflg());
			  ctx.getDaoSession().dbUpdate(this.getOprgrp().getUsraut());
			  if(ctx.getErrorCode()!=NO_ERROR)
			    return false;
			  log.debug("{}","Update usraut inr = "+this.getOprgrp().getUsraut().getInr()+", frm = "+frm+",usrinr = "+this.getOprgrp().getUsr().getInr());
			}
			ctx.getDaoSession().dbCommit();
			return result;
		}
        /**
        *   source:oprp.@0005.script
        */
        public void readLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getOprgrp().getOprautlst());
			String sql ="";
			//根据此机构所具有的交易权限，读取操作员的权限信息
			for(int i=0;i<this.getOprgrp().getModlstlst().fullSize();i++)
			{
			  //sql = "SELECT case flg1 when '1' then '' else 'X' end oflg, case flg2 when '1' then '' else 'X' end bflg,lvl aflg,amt ";
			  sql = "SELECT u.flg1 oflg,u.flg2 bflg,u.lvl aflg,u.amt amt";
			  sql += " FROM usraut u";
			  sql += " WHERE u.objinr='"+this.getOprgrp().getUsr().getInr()+"' AND u.objtyp='usr' AND ptyinr='"+this.getOprgrp().getUsr().getPtyinr()+"' AND frm='"+this.getOprgrp().getModlstlst().getElement(i).getFrm()+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<String> oflg = new Argument<String>("oflg");
			  Argument<String> bflg = new Argument<String>("bflg");
			  Argument<String> aflg = new Argument<String>("aflg");
			  Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			  //Argument<String> trsnam = new Argument<String>("trsnam",$oprgrp\\modlstlst[i]\\nam.getValue());
			  //Argument<String> trsinr = new Argument<String>("trsinr",$oprgrp\\modlstlst[i]\\frm.getValue());
			  Argument<String> trsnam = new Argument<String>("trsnam");
			  Argument<String> trsinr = new Argument<String>("trsinr");
			  ctx.getDaoSession().dbFetchFields(trsinr,trsnam,oflg,bflg,aflg,amt);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode != NO_ERROR)
			  {
			    oflg.value = null;
			    bflg.value = null;
			    aflg.value = null;
			  }
			  trsinr.value = this.getOprgrp().getModlstlst().getElement(i).getFrm();
			  trsnam.value = this.getOprgrp().getModlstlst().getElement(i).getNam();
			  this.getOprgrp().getOprautlst().add(trsinr,trsnam,oflg,bflg,aflg,amt);
			  ctx.getDaoSession().dbCloseCursor();
			}
			
		}

        public void setOprgrpHolder(ModuleHolder<Oprgrp> oprgrp)
        {
           this.oprgrp = oprgrp;
        }

        public Oprgrp getOprgrp()
        {
           return this.oprgrp.get();
        }



















}