package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Ore;
import com.ceb.gjjs.mda.bo.Ord;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ordmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ordmod.class);

        //订单主键
        private String ordinr;



	    @BDGetter
		private Ord ord;

	    @BDGetter
		private Ore ore;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;


		public Ordmod()
        {
            super();
            setArgument();
        }

        public Ordmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ordmod.@0001.script
        */
        public void ordUpdate(String newstate)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getOrd().setSta( newstate );
			this.getOrd().setStadattim( MdaUtils.today());
			this.getOrd().setFrm( ctx.getTransName());
			Date predattim = this.getOrd().getStadattim();
			if("NEW".equals(this.getOrdinr()))
			{
			  this.getOrd().setObjtyp( this.getTrn().getObjtyp());
			  this.getOrd().setObjinr( this.getTrn().getObjinr());
			  this.getOrd().setInifrm( this.getTrn().getInifrm());
			  this.getOrd().setDatfilnam( this.getTrn().getInr());
			  this.getOrd().setXmlfilnam( this.getTrn().getInr());
			  this.getOrd().setInidattim( MdaUtils.today());
			  //企业信息
			  this.getOrd().setEtyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			  this.getOrd().setEtginr(ctx.absGet(Sysmod.class).getEtg().getInr());
			  this.getOrd().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			  //业务归属机构
			  this.getOrd().setBchcod( this.getTrn().getBchcod());
			  this.getOrd().setOptptyinr( this.getTrn().getOptptyinr());
			  this.getOrd().setOptetyinr( this.getTrn().getOptetyinr());
			  this.getOrd().setOptetginr( this.getTrn().getOptetginr());
			  this.getOrd().setInr( Platform.sdbCounter("ord"));
			  ctx.getDaoSession().dbInsert(this.getOrd());

			  log.info("{}","ordUpdate：insert ord . ordinr="+this.getOrd().getInr());
			}
			else
			{
			  if(!MdaUtils.isEmpty(this.getOrd().getInr()))
			    ctx.getDaoSession().dbUpdate(this.getOrd());
			  else
			    log.info("{}","ERROR:MISSING ORDER INFORMATION!");
			}
			this.getTrn().setOrdinr( this.getOrd().getInr());
			this.getOre().setWaitim(MdaUtils.today().getTime() - predattim.getTime());
			this.getOre().setUsrinr( ctx.absGet(Sysmod.class).getUsr().getInr());
			this.getOre().setTyp( this.getOrd().getSta());
			this.getOre().setPtyinr( ctx.absGet(Sysmod.class).getUsr().getPtyinr());
			this.getOre().setOrdinr( this.getOrd().getInr());
			this.getOre().setFrm( this.getOrd().getFrm());
			this.getOre().setBegdattim(predattim);
			this.getOre().setEnddattim(MdaUtils.today());
			this.getOre().setObjinr( this.getOrd().getObjinr());
			this.getOre().setObjtyp( this.getOrd().getObjtyp());
			this.getOre().setOprnam( ctx.absGet(Sysmod.class).getUsr().getOprnam());
			this.getOre().setTyp( this.getOrd().getSta());
			this.getOre().setUsrinr( ctx.absGet(Sysmod.class).getUsr().getInr());
			this.getOre().setPtyinr( ctx.absGet(Sysmod.class).getPty().getInr());
			this.getOre().setInr( Platform.sdbCounter("ore"));
			ctx.getDaoSession().dbInsert(this.getOre());
			log.info("{}","ordUpdate：insert ore . oreinr="+ this.getOre().getInr());
		}
        /**
        *   source:ordmod.@0002.script
        */
        public void createOrdAndOre(String remark,String action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 新增一笔订单业务，保存ORD和ORE信息
			  */
			// 新增ORD
			this.getOrd().setSta( "C" );
			this.getOrd().setStadattim( MdaUtils.today());
			this.getOrd().setFrm( ctx.getTransName());
			this.getOrd().setObjtyp( this.getTrn().getObjtyp());
			this.getOrd().setObjinr( this.getTrn().getObjinr());
			this.getOrd().setInifrm( this.getTrn().getInifrm());
			this.getOrd().setDatfilnam( this.getTrn().getInr());
			this.getOrd().setXmlfilnam( this.getTrn().getInr());
			this.getOrd().setInidattim( MdaUtils.today());
			//企业信息
			this.getOrd().setEtyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			this.getOrd().setEtginr(ctx.absGet(Sysmod.class).getEtg().getInr());
			this.getOrd().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			//业务归属机构
			this.getOrd().setBchcod( this.getTrn().getBchcod());
			this.getOrd().setOptptyinr( this.getTrn().getOptptyinr());
			this.getOrd().setOptetyinr( this.getTrn().getOptetyinr());
			this.getOrd().setOptetginr( this.getTrn().getOptetginr());
			this.getOrd().setInr( Platform.sdbCounter("ord"));
			ctx.getDaoSession().dbInsert(this.getOrd());
			this.getTrn().setOrdinr( this.getOrd().getInr());
			log.info("{}","ordUpdate：insert ord . ordinr="+this.getOrd().getInr());

			// 新增ORE
			this.getOre().setWaitim( (long)0 );
			this.getOre().setUsrinr( ctx.absGet(Sysmod.class).getUsr().getInr());
			this.getOre().setTyp( this.getOrd().getSta());
			this.getOre().setTxt( remark);
			this.getOre().setPtyinr( this.getTrn().getPtyinr());
			this.getOre().setOrdinr( this.getOrd().getInr());
			this.getOre().setFrm( this.getOrd().getFrm());
			this.getOre().setBegdattim( this.getOrd().getStadattim());
			this.getOre().setEnddattim( MdaUtils.today());
			this.getOre().setObjinr( this.getOrd().getObjinr());
			this.getOre().setObjtyp( this.getOrd().getObjtyp());
			this.getOre().setOprnam( ctx.absGet(Sysmod.class).getLoginUserName());
			this.getOre().setAction( action );
			this.getOre().setInr( Platform.sdbCounter("ore"));
			ctx.getDaoSession().dbInsert(this.getOre());
			log.info("{}","ordUpdate：insert ore . oreinr="+ this.getOre().getInr());
		}
        /**
        *   source:ordmod.@0003.script
        */
        public void updateOrd(String ordinr,String ordsta,String action,String remark)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：更新ORD状态并新增ORE
			  * 参数：ordinr - 订单主键
			  *       ordsta - 订单更新状态
			  *       action - 更新订单状态变更的操作
			  *       remark - 操作员备注
			  */
			log.debug("{}","in updateOrd ...ordinr="+ordinr+",ordsta="+ordsta +",action="+ action+",remark="+ remark);
			ctx.getDaoSession().dbRead(this.getOrd(),new Argument("inr",ordinr));
			Date predattim = this.getOrd().getStadattim();
			String transname=ctx.getTransName();
			this.getOrd().setStadattim(new Date());
			this.getOrd().setSta(ordsta);
			this.getOrd().setFrm(transname);
			this.getOrd().setOptptyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			this.getOrd().setOptetyinr(ctx.absGet(Sysmod.class).getEty().getInr());
			this.getOrd().setOptetginr(ctx.absGet(Sysmod.class).getEtg().getInr());
			if("D".equals(ordsta))
			{
			  this.getOrd().setCpldattim(MdaUtils.today());
			}
			ctx.getDaoSession().dbUpdate(this.getOrd());
			log.info("{}","update ord OK!");
			this.getOre().setWaitim(MdaUtils.today().getTime() - predattim.getTime());
			this.getOre().setUsrinr( ctx.absGet(Sysmod.class).getUsr().getInr());
			this.getOre().setTyp( this.getOrd().getSta());
			this.getOre().setTxt(remark);
			this.getOre().setPtyinr( ctx.absGet(Sysmod.class).getUsr().getPtyinr());
			this.getOre().setOrdinr( this.getOrd().getInr());
			this.getOre().setFrm(transname);
			this.getOre().setBegdattim(predattim);
			this.getOre().setEnddattim(MdaUtils.today());
			this.getOre().setObjinr( this.getOrd().getObjinr());
			this.getOre().setObjtyp( this.getOrd().getObjtyp());
			this.getOre().setOprnam( ctx.absGet(Sysmod.class).getUsr().getOprnam());
			this.getOre().setAction(action);
			String oreinr=Platform.sdbCounter("ore");
			log.info("{}"," Insert ore! oreinr = " + oreinr);
			this.getOre().setInr(oreinr);
			ctx.getDaoSession().dbInsert(this.getOre());

		}





        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }



}