package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Parcon;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Parmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Parmod.class);



	    @BDGetter
		private Parcon parcon;


		public Parmod()
        {
            super();
            setArgument();
        }

        public Parmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:parmod.@0000.script
        */
        public String hyfTimeControl()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> parvalue =new Argument<String>("parvalue");
			Argument<String> parcod =new Argument<String>("parcod");
			String starttime = "";
			String endtime = "";
			String parsql="SELECT parvalue,parcod FROM parcon WHERE parcod='hyfstarttime' or parcod='hyfendtime'";
			ctx.getDaoSession().dbExecuteSQL(parsql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(parvalue,parcod);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if ("hyfstarttime".equals(parcod.value))
			    {
			      starttime = parvalue.value;
			    }
			    else
			    {
			      endtime = parvalue.value;
			    }
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			if (MdaUtils.isEmpty(starttime) || MdaUtils.isEmpty(endtime))
			{
			  return "";
			}
			Date starttimedate = MdaUtils.parseDate(starttime,"HH:mm");
			Date endtimedate = MdaUtils.parseDate(endtime,"HH:mm");
			log.info("{}","message"+starttime+"-"+endtime);
			if (!this.isEffectiveTime(starttimedate,endtimedate))
			{
			  return starttime+"-"+endtime;
			}
			return "";
		}
        /**
        *   source:parmod.@0001.script
        */
        public boolean isEffectiveTime(Date startTime, Date endTime)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 判断当前时间在不在时间区间内
			String nowtime = MdaUtils.format(MdaUtils.today(),"HH:mm");
			Date nowtimedate = MdaUtils.parseDate(nowtime,"HH:mm");
			if (nowtimedate.getTime()==startTime.getTime()||nowtimedate.getTime()==endTime.getTime())
			{
			  return true;
			}
			Calendar currDate =  Calendar.getInstance();
			currDate.setTime(nowtimedate);
			Calendar startDate =  Calendar.getInstance();
			startDate.setTime(startTime);
			Calendar endDate =  Calendar.getInstance();
			endDate.setTime(endTime);
			if (currDate.after(startDate) && currDate.before(endDate))
			{
			  return true;
			}
			return false;
		}



}