package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Pdfviw extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Pdfviw.class);

        //同意
        private transient IControl agree = new ControlImpl("agree", "同意", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //PDF JS URL
        private String pdfjsurl;

        //PDF预览地址
        private String pdfjsurl2;

        //标题
        private String title;

        //内容知晓复选框
        private String chk;

        //临时流
        private IStream tempstream = new StreamImpl();

        //延迟毫秒数
        private int delay;

        //标志位字段路径
        private String path;

        //当前标志位的序号
        private int flgidx;

        //延迟毫秒数
        private String delaystr;

        //跳过
        private transient IControl jump = new ControlImpl("jump", "跳过", this);

        //是否跳过
        private String chk1;


        @JsonIgnore
        @BDGetter
        private transient IPanel pdfvp;

        @JsonIgnore
        @BDGetter
        private transient IPanel pdfagreep;

        @JsonIgnore
        @BDGetter
        private transient IPanel agreebtnp;

        @JsonIgnore
        @BDGetter
        private transient IPanel pdfwthbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnbdp;



		public Pdfviw()
        {
            super();
            setArgument();
        }

        public Pdfviw(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:pdfviw.@0005.script
        */
        @Rule(target="timer",order=100)
        public boolean ruleTimerN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(TRUE.equals(this.getChk()))
			  return true;
			log.debug("{}","in timer ontimer ... "  + this.getDelay());
			if(this.getDelay() != 0)
			  this.setDelay(this.getDelay() - 1);

			if(this.getDelay() == 0)
			{
			  log.debug("{}","in delay enable =" + this.getDelay() );
			  
			  
			}
			else
			{
			  
			  
			  log.debug("{}","in delay disable =" + this.getDelay() );
			}
			
			
			

			return true;
        }



        /**
        *   source:pdfviw.@0002.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			if("jstjsh".equals(ctx.getTransName()))
			{
			  this.setDelay(0);
			  
			}
			else
			{

			  this.setDelay(10);
			  /* if(!"jstopn".equals(Platform.getTransName()))
			    {
			    Platform.invisible($chk1);
			    Platform.invisible($jump);
			    }
			    else
			    {
			    Platform.disable($jump);
			    }
			    */
			}

			
			
			this.setPdfjsurl("pdfjs/pdfview.html?file=");

			return true;
        }


        /**
        *   source:pdfviw.@0000.script
        */
        public void showPDF(String pdfpath,String title,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *action:0   只是预览
			  *1  同意/取消
			  */
			//写入会话，用作校验
			//String uuidtoken = UUID.randomUUID().toString().replace("-", "");
			Platform.writeToSession("pdffile",pdfpath);//token，用来判断请求唯一性
			log.info("{}","session pdffile :"+Platform.readFromSession("pdffile"));
			pdfpath = pdfpath.substring(4);
			//$pdfjsurl2 = $pdfjsurl.getValue() +"../"+ pdfpath;
			this.setPdfjsurl2( this.getPdfjsurl() + pdfpath);
			this.setTitle( title);
			switch(action)
			{
			  case 0:
			  
			  break;
			  case 1:
			  this.setDelay(5);
			  this.setDelaystr("(5 s)");
			  
			  
			  
			  
			  
			  break;
			}
			
			
		}
        /**
        *   source:pdfviw.@0003.script
        */
        public void callPDFComponent(String filnam,String pdfFile,String pdfTitle,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *功能：预览PDF
			  */
			log.debug("{}","执行"+pdfFile+"PDF标题="+pdfTitle+"order[100]");
			MdaUtils.clear(this.getTempstream());
			IStream stream=this.getTempstream();
			MdaUtils.streamClear(stream);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).generatorPdf(filnam,pdfFile,stream,false);
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPDFTmpfile(),"attach");
			log.debug("{}","filename="+filename);
			MdaUtils.streamSave(stream,filename);
			int index=filename.indexOf("pdf");
			if(index>0)
			  filename=filename.substring(index);
			log.debug("{}","filename="+filename);
			index=filename.indexOf("\\");
			if(index>0)
			{
			  filename=filename.replace("\\", "/");
			}
			log.debug("{}","filename="+filename);
			showPDF(filename,pdfTitle,action);
			log.debug("{}","执行"+pdfFile+"完毕，PDF标题="+pdfTitle+"order[100]");
		}
        /**
        *   source:pdfviw.@0004.script
        */
        public void callPDFComponentWithData(IStream stream ,String pdfTitle,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 文件夹查看PDF文件
			  */
			log.debug("{}","in callPDFComponentWithData ... pdfTitle="+pdfTitle +",action ="+ action);
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPDFTmpfile(),"attach");
			log.debug("{}","filename="+filename);
			MdaUtils.streamSave(stream,filename);
			int index=filename.indexOf("pdf");
			if(index>0)
			  filename=filename.substring(index);
			log.debug("{}","filename="+filename);
			index=filename.indexOf("\\");
			if(index>0)
			{
			  filename=filename.replace("\\", "/");
			}
			log.debug("{}","filename="+filename);
			showPDF(filename,pdfTitle,action);
			log.debug("{}","out  callPDFComponentWithData ...");

		}
        /**
        *   source:pdfviw.@0006.script
        */
        public void setPathAndFlgidx(String path,int index)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setPath( path);
			this.setFlgidx(index);
			IDatafield<String> fld= (IDatafield<String>) MdaDriver.getDatafield(ctx.getRoot(),path);
			String flgValue=fld.getValue();
			log.debug("{}","flgValue="+ flgValue);
			if(MdaUtils.isEmpty(flgValue))
			{
			  flgValue="0000";
			}
			String chk = flgValue.substring(index - 1, index);
			chk = "1".equals(chk)? TRUE:
			FALSE;
			this.setChk(chk);
			
		}
        /**
        *   source:pdfviw.@0007.script
        */
        public void callSwiftPDFComponent(String filnam,String pdfFile,String pdfTitle,int action)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *功能：预览PDF
			  */
			log.debug("{}","执行"+pdfFile+"PDF标题="+pdfTitle+"order[100]");
			MdaUtils.clear(this.getTempstream());
			IStream stream=this.getTempstream();
			MdaUtils.streamClear(stream);
			// $\\sysmod.generatorPdf(filnam,pdfFile,stream,false);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPdfmod().generatorSwiftPdf("",stream,false);
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPDFTmpfile(),"attach");
			log.debug("{}","filename="+filename);
			MdaUtils.streamSave(stream,filename);
			int index=filename.indexOf("pdf");
			if(index>0)
			  filename=filename.substring(index);
			log.debug("{}","filename="+filename);
			index=filename.indexOf("\\");
			if(index>0)
			{
			  filename=filename.replace("\\", "/");
			}
			log.debug("{}","filename="+filename);
			showPDF(filename,pdfTitle,action);
			log.debug("{}","执行"+pdfFile+"完毕，PDF标题="+pdfTitle+"order[100]");
		}



























}