package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames For 制单模版
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Prep extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Prep.class);

        //模板分类
        private String modtyp;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //新增模板
        private transient IControl add = new ControlImpl("add", "新增模板", this);

        //修改
        private transient IControl modify = new ControlImpl("modify", "修改", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //下一步
        private transient IControl nxt = new ControlImpl("nxt", "下一步", this);

        //模板预览
        private IStream previewmdl = new StreamImpl();

        //选择模板
        private IStream selmdl = new StreamImpl();

        //提交
        private transient IControl sav = new ControlImpl("sav", "提交", this);

        //模板编号
        private String mdlinr;


        @JsonIgnore
        @BDGetter
        private transient IPanel pre01;

        @JsonIgnore
        @BDGetter
        private transient IPanel pre02;

        @JsonIgnore
        @BDGetter
        private transient IPanel pre03;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Pregrp> pregrp;


		public Prep()
        {
            super();
            setArgument();
        }

        public Prep(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:prep.@0000.script
        */
        public void loadMdlLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getPregrp().getMdllst());
			String sql = "SELECT * FROM bilmdl WHERE typ = '0'";
			if(!"0".equals(this.getModtyp()))
			  sql += " AND modtyp = '" + this.getModtyp() + "'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> owned = new Argument<String>("owned");
			Argument<String> modtyp = new Argument<String>("modtyp");
			Argument<String> ptyinr = new Argument<String>("ptyinr");
			Argument<String> ptynam = new Argument<String>("ptynam");
			Argument<Date> credattim = new Argument<Date>("credattim");
			Argument<String> status = new Argument<String>("status");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			    this.getPregrp().getMdllst().add(inr,nam,owned,modtyp,ptyinr,ptynam,credattim,status);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:prep.@0001.script
        */
        public String getInr()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","bilmdl inr ==========");
			String year = MdaUtils.format(MdaUtils.today(),"yy");
			return MdaUtils.format(ctx.getDaoSession().dbCounter("bilmdl"+year),"00000000");
		}

        public void setPregrpHolder(ModuleHolder<Pregrp> pregrp)
        {
           this.pregrp = pregrp;
        }

        public Pregrp getPregrp()
        {
           return this.pregrp.get();
        }

























}