package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Frames for 贸易参与方
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptsp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptsp.class);

        //查询
        private transient IControl sel = new ControlImpl("sel", "查询", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //角色名称
        @Module(getter = false, setter = false)
		private FieldHolder<String> rol = new FieldConstantHolder<>("");


        //grp前缀(如lid - grp)
        @Module(getter = false, setter = false)
		private FieldHolder<String> belongto = new FieldConstantHolder<>("");


        //供选择类型
        @Module(getter = false, setter = false)
		private FieldHolder<String> flg = new FieldConstantHolder<>("");


        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //地址块
        private String adrblk;

        //外部键值
        private String extkey;

        //当前申请客户Label
        private String curcus;

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //代理行SWIFT CODE条数
        private int cnt;

        //可切换地址块
        private IPanel chageadr;

        //名址域语言类型
        private String language;

        //查询联号
        private transient IControl que = new ControlImpl("que", "查询联号", this);

        //查询国结开户行
        private transient IControl selsstf = new ControlImpl("selsstf", "查询国结开户行", this);

        //选择
        private transient IControl suresstf = new ControlImpl("suresstf", "选择", this);

        //交易对手名称
        private String nam;

        //地址
        private String adr;

        //取消
        private transient IControl sstfcancel = new ControlImpl("sstfcancel", "取消", this);

        //搜索
        private transient IControl sstfser = new ControlImpl("sstfser", "搜索", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel ptap5;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap6;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap1;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap11;

        @JsonIgnore
        @BDGetter
        private transient IPanel selapl;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap12;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap13;

        @JsonIgnore
        @BDGetter
        private transient IPanel selben;

        @JsonIgnore
        @BDGetter
        private transient IPanel selagt;

        @JsonIgnore
        @BDGetter
        private transient IPanel seletp;

        @JsonIgnore
        @BDGetter
        private transient IPanel editpty;

        @JsonIgnore
        @BDGetter
        private transient IPanel selbens;

        @JsonIgnore
        @BDGetter
        private transient IPanel selbenc;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap8;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap7;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptap9;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptapsstf;

        @JsonIgnore
        @BDGetter
        private transient IPanel selopnbank;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptapdisable;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptspta> ptspta;

	    @BDGetter
		private Ptsplst ptsp;

		@BDGetter
		private ModuleList<Ptsplst> ptslst;

		@BDGetter
		private ModuleList<Ptsplst> ptslstp;


		public Ptsp()
        {
            super();
            setArgument();
        }

        public Ptsp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:ptsp.@0004.script
        */
        @Rule(target="sel",order=100)
        public boolean ruleSelN100(){
            IContext ctx = MdaEnv.getContext();
            
			//201712 如果角色是agt或者cmc，只有一条记录就直接读取，不弹查询框
			log.debug("{}","ptspta pts extkey=" + this.getPtspta().getPts().getExtkey());
			log.debug("{}","in sel flg =" + this.getFlg());
			String extkey = this.getPtspta().getPts().getExtkey();
			String flg = this.getFlg();
			if((!MdaUtils.isEmpty(extkey) && "agt".equals(this.getFlg()))|| "cmc".equals(this.getFlg()))
			{
			  String sql = "";
			  if("agt".equals(flg))
			    sql = "SELECT COUNT(*) cnt FROM pty WHERE ncid Like '%" + this.getPtspta().getPts().getExtkey().toUpperCase() + "%'";
			  /*
			    else if("apl".equals(flg))
			    {
			    if("0".equals($\\sysmod\\pty\\ptytyp.getValue()) || "1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			    sql = "SELECT COUNT(*) cnt FROM pty WHERE ncid Like '%" + $ptspta\\pts\\extkey.getValue().toUpperCase() + "%'";
			    else
			    sql = "SELECT COUNT(*) cnt FROM pty WHERE extkey Like '%" + $ptspta\\pts\\extkey.getValue().toUpperCase() + "%' AND inr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			    }
			    else if("ben".equals(flg))
			    {
			    sql = " SELECT COUNT(y.inr) cnt FROM pty y,ptr r where extkey Like '%" + $ptspta\\pts\\extkey.getValue().toUpperCase() + "%'  AND r.ptrtyp = '3' AND y.inr = r.preptyinr AND r.nxtptyinr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			    }
			    */
			  else if("cmc".equals(flg))
			  {
			    sql = "SELECT COUNT(*) cnt FROM pty b,adr c,pta a,ptr d WHERE a.ptyinr = b.inr AND c.inr = a.objinr AND d.ptrtyp = '2' AND b.inr = d.preptyinr AND d.nxtptyinr = '"+ ctx.absGet(Sysmod.class).getPty().getInr() +"'";
			  }
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<BigDecimal> cnt = new Argument<BigDecimal>("cnt");
			  ctx.getDaoSession().dbFetchFields(cnt);
			  ctx.getDaoSession().dbCloseCursor();
			  Object tmp = cnt.value;
			  log.debug("{}","tmp=========="+cnt.value);
			  String selClause = "";
			  if("1".equals(tmp.toString()))
			  {
			    //如果搜到的pty记录只有一条，再判断pta记录（申请人一条pty，可能维护了多条pta）如果只有一条则直接展示，不弹框
			    //1.agt
			    if("agt".equals(flg))
			    {
			      if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			        selClause = "SELECT b.engnam,b.extkey extkey,c.adr adr FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			      else
			        selClause = "SELECT b.engnam,b.extkey extkey,c.adr adr FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			      extkey = extkey.toUpperCase();
			      selClause = selClause + " AND (b.ncid LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      sel();
			    }
			    /*   //2.apl
			      else if("apl".equals(flg))
			      {
			      if("0".equals($\\sysmod\\pty\\ptytyp.getValue()) || "1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			      {
			      selClause = "SELECT COUNT(*) cnt FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr ";
			      selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      }
			      else
			      {
			      selClause = "SELECT COUNT(*) cnt FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr AND b.inr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			      selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      }
			      Platform.dbExecuteSQL(selClause);
			      Argument<BigDecimal> cnt1 = new Argument<BigDecimal>("cnt");
			      Platform.dbFetchFields(cnt1);
			      Platform.dbCloseCursor();
			      Object tmp1 = cnt1.value;
			      log.debug("cnt1 =" +cnt1.value);
			      if(!"1".equals(tmp1.toString()))
			      {
			      sel();
			      return;
			      }
			      else
			      {
			      if("0".equals($\\sysmod\\pty\\ptytyp.getValue()) || "1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			      {
			      selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr ";
			      selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      }
			      else
			      {
			      selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr AND b.inr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			      selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      }
			      }
			      }
			      //3.ben
			      else if("ben".equals(flg))
			      {
			      selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '3' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr ";
			      if("1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			      {
			
			      String typ = $belongto.getValue();
			      String ptyinr = null;
			      IDatafield inr = Platform.getDatafield($\\,typ+"grp\\\\dap\\\\pty\\\\inr");
			      if(!Platform.isEmpty(inr))
			      ptyinr = inr.getValue().toString();
			      else
			      ptyinr = "";
			      selClause = selClause+"= '"+ptyinr;
			      log.debug("bnk'ptyinr="+ptyinr);
			      }
			      else
			      {
			      selClause = selClause + "= '"+$\\sysmod\\pty\\inr.getValue();
			      selClause = selClause + "'";
			      selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			      }
			      }
			      */
			    //4.cmc
			    else if("cmc".equals(flg))
			    {
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.nam nam,b.engnam engnam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE a.ptyinr = b.inr AND c.inr = a.objinr AND d.ptrtyp = '2' AND b.inr = d.preptyinr AND d.nxtptyinr = '"+ ctx.absGet(Sysmod.class).getPty().getInr() +"'";
			    }
			    ctx.getDaoSession().dbExecuteSQL(selClause);
			    ctx.getErrorCode();
			    log.debug("{}","sql===================" + selClause);
			    Argument<String> engnam = new Argument<String>("engnam");
			    Argument<String> extkey1 = new Argument<String>("extkey");
			    Argument<String> adr = new Argument<String>("adr");
			    ctx.getDaoSession().dbFetchFields(engnam,extkey1,adr);
			    ctx.getDaoSession().dbCloseCursor();
			    String adrblk = "";
			    if(!MdaUtils.isEmpty(adr.value) && !MdaUtils.isEmpty(engnam.value))
			    {
			      adrblk = engnam.value + CR + adr.value ;
			    }
			    else if(MdaUtils.isEmpty(adr.value) && !MdaUtils.isEmpty(engnam.value))
			    {
			      adrblk = engnam.value ;
			    }
			    else
			    {
			      adrblk = adr.value ;
			    }
			    this.getPtspta().getPts().setExtkey(extkey1.value);
			    this.getPtspta().getPts().setAdrblk(adrblk);
			    //若是cmc
			    if("cmc".equals(this.getFlg()))
			    {
			      this.getPtspta().getPts().setNam(engnam.value);
			      
			      log.debug("{}","nam =" +this.getPtspta().getPts().getNam());
			    }
			    
			    
			    log.debug("{}","extkey =" +this.getPtspta().getPts().getExtkey());
			    log.debug("{}","adrblk = " +this.getPtspta().getPts().getAdrblk());
			  }
			  else if("0".equals(tmp.toString()))
			  {
			    //如果没有搜索结果则不弹搜索框
			    log.debug("{}","no record...");

			  }
			  else
			  {
			    //如果搜到的记录不止一条，则弹出搜索框供其选择
			    sel();
			  }
			}
			else
			{
			  sel();
			}

			return true;
        }

        /**
        *   source:ptsp.@0005.script
        */
        @Rule(target="sure",order=100)
        public boolean ruleSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in sure...");
			int index = 0;
			int length = this.getPtslst().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000290"),MdaUtils.getI18NString("ptsp","CT000291"));
			  return true;
			}
			MdaUtils.clear(this.getPtspta().getPta());
			MdaUtils.clear(this.getPtspta().getPty());
			MdaUtils.clear(this.getPtspta().getAdr());
			String ptsinr = this.getPtspta().getPts().getInr();
			//log.debug("sel "+$rol.getValue()+" inr="+ptsinr);
			String ref = null;
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getRef()))
			  ref = this.getPtspta().getPts().getRef();
			log.info("{}","ptsObjinr1"+this.getPtspta().getPts().getObjinr());
			String ptsobjinr= this.getPtspta().getPts().getObjinr();
			String ptsobjtyp= this.getPtspta().getPts().getObjtyp();
			MdaUtils.clear(this.getPtspta().getPts());
			log.info("{}","ptsObjinr2"+this.getPtspta().getPts().getObjinr());
			ctx.getDaoSession().dbRead(this.getPtspta().getPta(),new Argument<String>("inr",this.getPtsp().getPtainr()));
			ctx.getDaoSession().dbRead(this.getPtspta().getPty(),new Argument<String>("inr",this.getPtspta().getPta().getPtyinr()));
			ctx.getDaoSession().dbRead(this.getPtspta().getAdr(),new Argument<String>("inr",this.getPtspta().getPta().getObjinr()));
			//objtyp：交易名
			//交易参号即ownref
			//belongtogrp:取到根下的grp名称，如lidgrp
			//sav200时赋值（objinr:业务表inr；objtyp:业务表名）
			//$ptspta\\pts\\objtyp.setValue($belongto.getValue());
			//ref：个性化编号；如商行带入的信用证号,个别交易有，sav200时赋值
			this.getPtspta().getPts().setRol(this.getRol());
			this.getPtspta().getPts().setPtainr(this.getPtspta().getPta().getInr());
			this.getPtspta().getPts().setPtyinr(this.getPtspta().getPta().getPtyinr());
			this.getPtspta().getPts().setRef(ref);
			if(!MdaUtils.isEmpty(ptsobjinr))
			{
			  this.getPtspta().getPts().setObjinr(ptsobjinr);
			}
			if(!MdaUtils.isEmpty(ptsobjtyp))
			{
			  this.getPtspta().getPts().setObjtyp(ptsobjtyp);
			}
			if(!MdaUtils.isEmpty(this.getAdrblk()))
			{
			  String adrblk = this.getAdrblk();
			  adrblk = adrblk.replaceAll("\\\\R|\\\\r", "\r");
			  adrblk = adrblk.replaceAll("\\\\N|\\\\n", "\n");
			  this.getPtspta().getPts().setAdrblk(adrblk);
			}
			else
			{
			  this.getPtspta().getPts().setAdrblk(this.getPtspta().getPty().getNam() + CR + this.getPtspta().getAdr().getAdr());
			  //if("apl".equals($flg.getValue())&&("litopn".equals(Platform.getTransName())||"cptopn".equals(Platform.getTransName())))
			  if(("apl".equals(this.getFlg())&&"litopn".equals(ctx.getTransName()))||("cptopn".equals(ctx.getTransName()))&&("apl".equals(this.getFlg())||"ben".equals(this.getFlg())))
			  {
			    this.getPtspta().getPts().setAdrblk(this.getPtspta().getPty().getEngnam() + CR + this.getPtspta().getAdr().getEnadr());
			  }
			}
			this.getPtspta().getPts().setNam(this.getNam());
			this.getPtspta().getPts().setAdr(this.getAdr());
			this.getPtspta().getPts().setExtkey(this.getExtkey());

			//补充：显示信用证界面的名称  、地址
			if("ditopn".equals(ctx.getTransName())|| "ditame".equals(ctx.getTransName()))
			{
			  this.getPtspta().getPts().setNam(this.getPtspta().getPty().getNam());
			  this.getPtspta().getPts().setAdr(this.getPtspta().getAdr().getAdr());
			  
			  
			}

			//-----
			
			
			
			
			
			
			/*
			  if(!"agt".equals($flg.getValue()))
			  Platform.disable($ptspta\\pts\\adrblk);
			  else
			  Platform.enable($ptspta\\pts\\adrblk);
			  */
			if(!MdaUtils.isEmpty(ptsinr))
			  this.getPtspta().getPts().setInr(ptsinr);
			this.setExtkey(this.getPtspta().getPts().getExtkey());
			log.info("{}","ptspta-rol-nam-extkey="+this.getRol()+"  "+this.getPtspta().getPts().getExtkey()+"  "+this.getPtspta().getPts().getNam());
			if("dap".equals(this.getRol()))
			{
			  log.debug("{}","in dap...");
			  IModule belongGrp = MdaDriver.getModule(this,ctx.getRoot(),this.getBelongto()+"grp");
			  refreshApl(belongGrp);
			}
			log.debug("{}","ptspta pts extkey in sure =" +this.getPtspta().getPts().getExtkey());
			log.debug("{}","ptspta pts adrblk in sure=" +this.getPtspta().getPts().getAdrblk());
			log.info("{}","ptsObjinr3"+this.getPtspta().getPts().getObjinr());
			closePanel();
			log.debug("{}","out sure...");

			return true;
        }

        /**
        *   source:ptsp.@0006.script
        */
        @Rule(target="ptspta.pts.extkey",order=100)
        public boolean rulePtsptaPtsExtkeyN100(){
            IContext ctx = MdaEnv.getContext();
            
			String flg = this.getFlg();
			String trnname=ctx.getTransName();
			log.info("{}","transname="+trnname);
			// 查询国结开户行信息
			if ("cpthyf".equals(trnname) && "acw".equals(this.getRol()))
			{
			  this.setExtkey(this.getPtspta().getPts().getExtkey());
			  
			  this.refreshAcw("change");
			}
			else
			{
			  String sql1 = "select count(*) adtmp from tsc where trncod = '"+trnname + "'";
			  ctx.getDaoSession().dbExecuteSQL(sql1);
			  Argument<BigDecimal> adtmp = new Argument<BigDecimal> ("adtmp");
			  ctx.getDaoSession().dbFetchFields(adtmp);
			  ctx.getDaoSession().dbCloseCursor();
			  log.info("{}","是否搜寻到对应通知交易="+adtmp.value);
			  log.debug("{}","onChange ptspta pts extkey");
			  log.debug("{}","flg  =" +this.getFlg());
			  /*if(((Platform.isEmpty($ptspta\\pts\\extkey)  ||  $ptspta\\pts\\extkey.getValue() == null)) && "0".equals(adtmp.value) )
			    {
			    Platform.clear($ptspta\\pts\\extkey);
			    Platform.clear($extkey);
			    Platform.clear($adrblk);
			    Platform.clear($ptspta\\pts\\adrblk);
			    Platform.enable($ptspta\\pts\\adrblk);
			    Platform.setModified($ptspta\\pts\\extkey);
			    Platform.setModified($extkey);
			    Platform.setModified($adrblk);
			    Platform.setModified($ptspta\\pts\\adrblk);
			    return;
			    }*/
			  log.debug("{}","搜索变更内容："+this.getPtspta().getPts().getExtkey()+";"+this.getExtkey());
			  if(!this.getPtspta().getPts().getExtkey().equals(this.getExtkey()))
			  {
			    String sql = "";
			    if("agt".equals(flg))
			      sql = "SELECT COUNT(*) cnt FROM pty WHERE ncid Like '%" + this.getPtspta().getPts().getExtkey().toUpperCase() + "%'";
			    else if("apl".equals(flg))
			    {
			      //if("1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			      if("0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()) || "1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			        sql = "SELECT COUNT(*) cnt FROM pty WHERE ncid Like '%" + this.getPtspta().getPts().getExtkey().toUpperCase() + "%'";
			      else
			        sql = "SELECT COUNT(*) cnt FROM pty WHERE extkey Like '%" + this.getPtspta().getPts().getExtkey().toUpperCase() + "%' AND inr = '" + ctx.absGet(Sysmod.class).getPty().getInr() + "'";
			    }
			    else if("ben".equals(flg))
			      sql = " SELECT COUNT(y.inr) cnt FROM pty y,ptr r where extkey Like '%" + this.getPtspta().getPts().getExtkey().toUpperCase() + "%'  AND r.ptrtyp = '3' AND y.inr = r.preptyinr AND r.nxtptyinr = '" + ctx.absGet(Sysmod.class).getPty().getInr() + "'";
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    Argument<BigDecimal> cnt = new Argument<BigDecimal>("cnt");
			    ctx.getDaoSession().dbFetchFields(cnt);
			    ctx.getDaoSession().dbCloseCursor();
			    Object tmp = cnt.value;
			    log.debug("{}","tmp=========="+cnt.value);
			    log.debug("{}",tmp);
			    //if(!"0".equals(tmp.toString()))
			    //201712（控制只支持代理行角色）
			    //1.若触发右侧箭头按钮后，无检索结果，则不进入检索子界面，并返回提示"无搜索结果"
			    //2.若触发右侧箭头按钮后，检索结果仅有一条时，则不进入检索子界面，自动在下方栏位反显唯一检索结果；
			    //3.若触发右侧箭头按钮后，检索结果不止一条时，进入检索子界面，并自动触发子界面中的搜索按钮，
			    if("0".equals(tmp.toString()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000144"),MdaUtils.getI18NString("ptsp","CT000145"));
			      this.getPtspta().getPts().setExtkey(NULLSTR);
			      this.getPtspta().getPts().setAdrblk(NULLSTR);
			      this.setAdrblk(NULLSTR);
			      this.setExtkey(NULLSTR);
			      
			      
			    }
			    else
			    {
			      //如果为代理行则判断是否只有一条记录（如果只有一条直接带出，不弹框），其他的角色有记录就会弹框。
			      if(!"agt".equals(flg))
			      {
			        //如果有记录则不能弹框,否则点击查询按钮是会弹框两次，出现错误
			        //sel();
			        log.debug("{}","more than one record...");
			      }
			      else
			      {
			        log.info("{}","HAS RECORD==========");
			        //201712
			        String selClause = "";
			        String extkey = this.getPtspta().getPts().getExtkey();
			        log.debug("{}","ptspta pts extkey=" +this.getPtspta().getPts().getExtkey());
			        if("1".equals(tmp.toString()))
			        {
			          //1.agt
			          //         if("agt".equals(flg))
			          //         {
			          if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			            selClause = "SELECT b.engnam,b.extkey extkey,c.adr adr FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			          else
			            selClause = "SELECT b.engnam,b.extkey extkey,c.adr adr FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			          extkey = extkey.toUpperCase();
			          selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			          //          }
			          /*      //2.apl
			            else if("apl".equals(flg))
			            {
			            if("0".equals($\\sysmod\\pty\\ptytyp.getValue()) || "1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			            {
			            selClause = "SELECT COUNT(*) cnt FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr ";
			            selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			            }
			            else
			            {
			            selClause = "SELECT COUNT(*) cnt FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr AND b.inr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			            selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			            }
			            Platform.dbExecuteSQL(selClause);
			            Argument<BigDecimal> cnt1 = new Argument<BigDecimal>("cnt");
			            Platform.dbFetchFields(cnt1);
			            Platform.dbCloseCursor();
			            Object tmp1 = cnt1.value;
			            log.debug("cnt1 =" +cnt1.value);
			            if(!"1".equals(tmp1.toString()))
			            {
			            // sel();
			            //return;
			            log.debug("more than one record...");
			            }
			            else
			            {
			            if("0".equals($\\sysmod\\pty\\ptytyp.getValue()) || "1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			            {
			            selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr ";
			            selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			            }
			            else
			            {
			            selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr AND b.inr = '" + $\\sysmod\\pty\\inr.getValue() + "'";
			            selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			            }
			            }
			            }
			            //3.ben
			            else if("ben".equals(flg))
			            {
			            if("1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			            {
			            String typ = $belongto.getValue();
			            IDatafield ptytyp = Platform.getDatafield($\\,typ+"grp\\\\dap\\\\pty\\\\ptytyp");
			            if(!Platform.isEmpty(ptytyp)&&!"3".equals(ptytyp.getValue()))
			            {
			            Platform.message(#CT000195,#CT000196);
			            return;
			            }
			            }
			            else
			            {
			            selClause = "SELECT b.extkey extkey,b.engnam engnam,c.adr adr FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '3' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr ";
			            if("1".equals($\\sysmod\\pty\\ptytyp.getValue()))
			            {
			
			            String typ = $belongto.getValue();
			            String ptyinr = null;
			            IDatafield inr = Platform.getDatafield($\\,typ+"grp\\\\dap\\\\pty\\\\inr");
			            if(!Platform.isEmpty(inr))
			            ptyinr = inr.getValue().toString();
			            else
			            ptyinr = "";
			            selClause = selClause+"= '"+ptyinr;
			            log.debug("bnk'ptyinr="+ptyinr);
			            }
			            else
			            selClause = selClause + "= '"+$\\sysmod\\pty\\inr.getValue();
			            selClause = selClause + "'";
			            selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			            }
			            }
			            */
			          ctx.getDaoSession().dbExecuteSQL(selClause);
			          ctx.getErrorCode();
			          log.debug("{}","sql===================" + selClause);
			          Argument<String> engnam = new Argument<String>("engnam");
			          Argument<String> extkey1 = new Argument<String>("extkey");
			          Argument<String> adr = new Argument<String>("adr");
			          ctx.getDaoSession().dbFetchFields(engnam,extkey1,adr);
			          ctx.getDaoSession().dbCloseCursor();
			          String adrblk = "";
			          if(!MdaUtils.isEmpty(adr.value) && !MdaUtils.isEmpty(engnam.value))
			          {
			            adrblk = engnam.value + CR + adr.value ;
			          }
			          else if(MdaUtils.isEmpty(adr.value) && !MdaUtils.isEmpty(engnam.value))
			          {
			            adrblk = engnam.value ;
			          }
			          else
			          {
			            adrblk = adr.value ;
			          }
			          this.getPtspta().getPts().setExtkey(extkey1.value);
			          this.getPtspta().getPts().setAdrblk(adrblk);
			          log.debug("{}","搜索变更内容3："+this.getPtspta().getPts().getExtkey()+";"+this.getExtkey());
			        }
			        else
			        {
			          //如果有记录则不能弹框,否则点击查询按钮是会弹框两次，出现错误
			          //sel();
			          log.debug("{}","more than one record...");
			        }
			      }
			    }
			    log.debug("{}","搜索变更内容2："+this.getPtspta().getPts().getExtkey()+";"+this.getExtkey());
			  }
			  else
			  {
			    ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000274"),MdaUtils.getI18NString("ptsp","CT000275"));
			    this.getPtspta().getPts().setExtkey(NULLSTR);
			    this.getPtspta().getPts().setAdrblk(NULLSTR);
			    this.setAdrblk(NULLSTR);
			    this.setExtkey(NULLSTR);
			    
			    
			  }
			  
			  
			  
			  
			}

			return true;
        }

        /**
        *   source:ptsp.@0007.script
        */
        @Rule(target="ptslst",order=100)
        public boolean rulePtslstN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in ptslst");
			int index = 0;
			int length = this.getPtslst().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000136"),MdaUtils.getI18NString("ptsp","CT000137"));
			  return true;
			}
			MdaUtils.clear(this.getPtsp());
			this.getPtsp().copyValue(this.getPtslst().getElement(index));
			String adrblk = "";
			//信用证申请人or汇款申请人or汇款受益人
			if(("apl".equals(this.getFlg())&&"litopn".equals(ctx.getTransName()))||("cptopn".equals(ctx.getTransName()))&&("apl".equals(this.getFlg())||"ben".equals(this.getFlg())))
			{
			  if("0".equals(this.getLanguage()))
			  {
			    if(MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			      adrblk = "";
			    else if(!MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			      adrblk = this.getPtsp().getNam();
			    else if(MdaUtils.isEmpty(this.getPtsp().getNam())&&!MdaUtils.isEmpty(this.getPtsp().getAdr()))
			      adrblk = this.getPtsp().getAdr();
			    else
			      adrblk = this.getPtsp().getNam() + CR + this.getPtsp().getAdr();
			  }
			  else
			  {
			    if(MdaUtils.isEmpty(this.getPtsp().getEngnam())&&MdaUtils.isEmpty(this.getPtsp().getEnadr()))
			      adrblk = "";
			    else if(!MdaUtils.isEmpty(this.getPtsp().getEngnam())&&MdaUtils.isEmpty(this.getPtsp().getEnadr()))
			      adrblk = this.getPtsp().getEngnam();
			    else if(MdaUtils.isEmpty(this.getPtsp().getEngnam())&&!MdaUtils.isEmpty(this.getPtsp().getEnadr()))
			      adrblk = this.getPtsp().getEnadr();
			    else
			      adrblk = this.getPtsp().getEngnam() + CR + this.getPtsp().getEnadr();
			  }
			}
			else
			{
			  if(MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			    adrblk = "";
			  else if(!MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			    adrblk = this.getPtsp().getNam();
			  else if(MdaUtils.isEmpty(this.getPtsp().getNam())&&!MdaUtils.isEmpty(this.getPtsp().getAdr()))
			    adrblk = this.getPtsp().getAdr();
			  else
			    adrblk = this.getPtsp().getNam() + CR + this.getPtsp().getAdr();

			}
			this.setAdrblk(adrblk);
			this.setNam(this.getPtsp().getNam());
			this.setAdr(this.getPtsp().getAdr());
			String extkey = "";
			if("agt".equals(this.getFlg()) || "bak".equals(this.getFlg()))
			{
			  extkey = this.getPtsp().getNcid();
			}
			else
			  extkey = this.getPtsp().getExtkey();
			this.setExtkey(extkey);
			
			
			
			
			log.debug("{}","extkey =" +this.getExtkey());
			log.debug("{}","adrblk =" +this.getAdrblk());

			return true;
        }

        /**
        *   source:ptsp.@0008.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			cancel();

			return true;
        }

        /**
        *   source:ptsp.@0010.script
        */
        @Rule(target="selapl",order=100)
        public boolean ruleSelaplN100(){
            IContext ctx = MdaEnv.getContext();
            
			cancel();

			return true;
        }

        /**
        *   source:ptsp.@0011.script
        */
        @Rule(target="selben",order=100)
        public boolean ruleSelbenN100(){
            IContext ctx = MdaEnv.getContext();
            
			cancel();

			return true;
        }

        /**
        *   source:ptsp.@0012.script
        */
        @Rule(target="selagt",order=100)
        public boolean ruleSelagtN100(){
            IContext ctx = MdaEnv.getContext();
            
			cancel();

			return true;
        }

        /**
        *   source:ptsp.@0013.script
        */
        @Rule(target="seletp",order=100)
        public boolean ruleSeletpN100(){
            IContext ctx = MdaEnv.getContext();
            
			cancel();

			return true;
        }

        /**
        *   source:ptsp.@0022.script
        */
        @Rule(target="search",order=100)
        public boolean ruleSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			//String selClause = "SELECT pta.inr ptainr,pty.inr ptyinr,pty.extkey extkey,pty.ncid ncid,pty.engnam engnam,pty.nam nam,adr.adr adr,adr.tel tel,adr.fax fax FROM pty,adr,pta,ptr WHERE ptr.ptrtyp = '4' AND pty.inr in ( SELECT pty.inr FROM pty,ptr WHERE (ptr.ptrtyp = '0' OR ptr.ptrtyp = '1' OR ptr.ptrtyp = '2') AND pty.inr = ptr.nxtptyinr AND ptr.preptyinr = '" + $\\sysmod\\pty\\inr.getValue() + "')";
			String tmpsql="";
			if(!MdaUtils.isEmpty(this.getExtkey()))
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			  else
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"') ";
			  String extkey = this.getExtkey();
			  extkey = extkey.toUpperCase();
			  tmpsql = tmpsql + " AND (b.ncid LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			}
			else
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			  else
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"') ";
			}
			ctx.getDaoSession().dbExecuteSQL(tmpsql);
			Argument<Integer> count = new Argument<Integer>("count");
			ctx.getDaoSession().dbFetchFields(count);
			ctx.getDaoSession().dbCloseCursor();
			log.info("{}","count============"+count.value);
			String selClause ="";
			this.setCnt(count.value);
			
			if(count.value<=100)
			{
			  if(!MdaUtils.isEmpty(this.getExtkey()))
			  {
			    if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			    else
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			    String extkey = this.getExtkey();
			    extkey = extkey.toUpperCase();
			    selClause = selClause + " AND (b.ncid LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			  }
			  else
			  {
			    if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			    else
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			  }
			  ctx.getDaoSession().dbExecuteSQL(selClause);
			  ctx.getErrorCode();
			  log.debug("{}","selagt的sql===================" + selClause);
			  Argument<String> ptainr = new Argument<String>("ptainr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> ncid = new Argument<String>("ncid");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> extkey = new Argument<String>("extkey");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> tel = new Argument<String>("tel");
			  Argument<String> fax = new Argument<String>("fax");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey,nam,engnam,ncid,adr,tel,fax);
			    int errorCode  = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			    {
			      this.getPtslst().add(ptainr,ptyinr,extkey,nam,engnam,ncid,adr,tel,fax);
			    }
			    else if(errorCode == ERROR_SQL)
			    {
			      break;
			    }
			    else
			    {
			      break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  /*
			    if($ptslst.fullSize() == 0)
			    {
			    Platform.message(#CT000172,#CT000173);
			    return;
			    }
			    */
			  
			}
			else
			{
			  
			  ctx.setFieldError(this,"extkey",MdaUtils.getI18NString("ptsp","CT000172"));
			  return true;
			}

			return true;
        }

        /**
        *   source:ptsp.@0032.script
        */
        @Rule(target="que",order=100)
        public boolean ruleQueN100(){
            IContext ctx = MdaEnv.getContext();
            
			String cls="com.brilliance.eibs.main.Client";
			String bnlnam = "";
			String fqcyjg = this.getPtspta().getPts().getBakcode();

			Object rtnVal = MdaUtils.invoke(cls,"scall","getbnlnam","getbnlnam",new Object[]{fqcyjg});    // 判断接口是否调用成功
			if((Boolean)MdaUtils.invoke(rtnVal,"isSuccess"))
			{
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");
			  if("900000".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000345"),MdaUtils.getI18NString("ptsp","CT000346"));
			  }
			  else if("999999".equals(errcod))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000347"),MdaUtils.getI18NString("ptsp","CT000348"));
			  }
			  else
			  {
			    Object objm = retMsg.get("fukrhm");
			    bnlnam = (String)objm;

			  }
			}
			else
			{
			  //提示调用错误
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000349"),MdaUtils.getI18NString("ptsp","CT000350"));
			}
			log.info("{}","联行行号 bakcode :" + this.getPtspta().getPts().getBakcode()+ ",bnlnam:" +bnlnam);
			this.getPtspta().getPts().setNam(bnlnam);
			

			return true;
        }

        /**
        *   source:ptsp.@0035.script
        */
        @Rule(target="selsstf",order=100)
        public boolean ruleSelsstfN100(){
            IContext ctx = MdaEnv.getContext();
            
			refreshAcw("");
			

			return true;
        }

        /**
        *   source:ptsp.@0036.script
        */
        @Rule(target="suresstf",order=100)
        public boolean ruleSuresstfN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in sure...");
			int index = 0;
			int length = this.getPtslstp().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000378"),MdaUtils.getI18NString("ptsp","CT000379"));
			  return true;
			}
			MdaUtils.clear(this.getPtspta().getPta());
			MdaUtils.clear(this.getPtspta().getPty());
			MdaUtils.clear(this.getPtspta().getAdr());
			String ptsinr = this.getPtspta().getPts().getInr();
			//log.debug("sel "+$rol.getValue()+" inr="+ptsinr);
			String ref = null;
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getRef()))
			  ref = this.getPtspta().getPts().getRef();
			log.info("{}","ptsObjinr1"+this.getPtspta().getPts().getObjinr());
			String ptsobjinr= this.getPtspta().getPts().getObjinr();
			String ptsobjtyp= this.getPtspta().getPts().getObjtyp();
			MdaUtils.clear(this.getPtspta().getPts());
			log.info("{}","ptsObjinr2"+this.getPtspta().getPts().getObjinr());
			ctx.getDaoSession().dbRead(this.getPtspta().getPta(),new Argument<String>("inr",this.getPtsp().getPtainr()));
			ctx.getDaoSession().dbRead(this.getPtspta().getPty(),new Argument<String>("inr",this.getPtspta().getPta().getPtyinr()));
			ctx.getDaoSession().dbRead(this.getPtspta().getAdr(),new Argument<String>("inr",this.getPtspta().getPta().getObjinr()));
			//objtyp：交易名
			//交易参号即ownref
			//belongtogrp:取到根下的grp名称，如lidgrp
			//sav200时赋值（objinr:业务表inr；objtyp:业务表名）
			//$ptspta\\pts\\objtyp.setValue($belongto.getValue());
			//ref：个性化编号；如商行带入的信用证号,个别交易有，sav200时赋值
			this.getPtspta().getPts().setRol(this.getRol());
			this.getPtspta().getPts().setPtainr(this.getPtspta().getPta().getInr());
			this.getPtspta().getPts().setPtyinr(this.getPtspta().getPta().getPtyinr());
			this.getPtspta().getPts().setRef(ref);
			if(!MdaUtils.isEmpty(ptsobjinr))
			{
			  this.getPtspta().getPts().setObjinr(ptsobjinr);
			}
			if(!MdaUtils.isEmpty(ptsobjtyp))
			{
			  this.getPtspta().getPts().setObjtyp(ptsobjtyp);
			}
			if(!MdaUtils.isEmpty(this.getAdrblk()))
			{
			  String adrblk = this.getAdrblk();
			  adrblk = adrblk.replaceAll("\\\\R|\\\\r", "\r");
			  adrblk = adrblk.replaceAll("\\\\N|\\\\n", "\n");
			  this.getPtspta().getPts().setAdrblk(adrblk);
			}
			else
			{
			  this.getPtspta().getPts().setAdrblk(this.getPtspta().getPty().getNam() + CR + this.getPtspta().getAdr().getAdr());
			}
			this.getPtspta().getPts().setExtkey(this.getExtkey());
			this.getPtspta().getPts().setNam(this.getNam());
			this.getPtspta().getPts().setAdr(this.getAdr());
			
			
			
			
			

			if(!MdaUtils.isEmpty(ptsinr))
			  this.getPtspta().getPts().setInr(ptsinr);
			this.setExtkey(this.getPtspta().getPts().getExtkey());

			//国结开户行
			


			return true;
        }

        /**
        *   source:ptsp.@0037.script
        */
        @Rule(target="ptslstp",order=100)
        public boolean rulePtslstpN100(){
            IContext ctx = MdaEnv.getContext();
            
			refreshAcw("");

			return true;
        }

        /**
        *   source:ptsp.@0038.script
        */
        @Rule(target="sstfcancel",order=100)
        public boolean ruleSstfcancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setAdrblk(NULLSTR);
			this.setAdr(NULLSTR);
			this.setExtkey(NULLSTR);
			this.setNam(NULLSTR);
			
			
			
			
			//国结收款人开户行
			

			return true;
        }

        /**
        *   source:ptsp.@0039.script
        */
        @Rule(target="ptslstp",order=100)
        public boolean rulePtslstpN100R1(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in ptslstp");
			int index = 0;
			int length = this.getPtslstp().fullSize();
			if(index<0   ||   index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000398"),MdaUtils.getI18NString("ptsp","CT000399"));
			  return true;
			}
			MdaUtils.clear(this.getPtsp());
			this.getPtsp().copyValue(this.getPtslstp().getElement(index));
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPtsp().getNam())&&MdaUtils.isEmpty(this.getPtsp().getAdr()))
			  adrblk = this.getPtsp().getNam();
			else if(MdaUtils.isEmpty(this.getPtsp().getNam())&&!MdaUtils.isEmpty(this.getPtsp().getAdr()))
			  adrblk = this.getPtsp().getAdr();
			else
			  adrblk = this.getPtsp().getNam() + CR + this.getPtsp().getAdr();

			this.setAdrblk(adrblk);
			this.setNam(this.getPtsp().getNam());
			this.setAdr(this.getPtsp().getAdr());
			this.setExtkey(this.getPtsp().getNcid());
			
			
			
			

			return true;
        }

        /**
        *   source:ptsp.@0040.script
        */
        @Rule(target="sstfser",order=100)
        public boolean ruleSstfserN100(){
            IContext ctx = MdaEnv.getContext();
            
			refreshAcw("query");

			return true;
        }



        /**
        *   source:ptsp.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			String selClause = "";
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getExtkey()))
			{
			  //201712
			  if("0".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()) || "1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  {
			    selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.nam nam,b.engnam engnam,c.enadr enadr,c.adr adr,c.tel tel,c.fax fax FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr ";
			  }
			  else
			  {

			    selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.nam nam,b.engnam engnam,c.enadr enadr,c.adr adr,c.tel tel,c.fax fax FROM pta a,pty b,adr c WHERE c.inr = a.objinr AND a.ptyinr = b.inr AND b.inr = '" + ctx.absGet(Sysmod.class).getPty().getInr() + "'";
			  }
			  String extkey = this.getPtspta().getPts().getExtkey();
			  //201712
			  selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			  ctx.getDaoSession().dbExecuteSQL(selClause);
			  ctx.getErrorCode();
			  log.debug("{}","selapl的sql===================" + selClause);
			  Argument<String> ptainr = new Argument<String>("ptainr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> extkey_Arg = new Argument<String>("extkey");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> enadr = new Argument<String>("enadr");
			  Argument<String> tel = new Argument<String>("tel");
			  Argument<String> fax = new Argument<String>("fax");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey_Arg,nam,engnam,enadr,adr,tel,fax);
			    int errorCode  = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			    {
			      this.getPtslst().add(ptainr,ptyinr,extkey_Arg,nam,engnam,enadr,adr,tel,fax);
			    }
			    else if(errorCode == ERROR_SQL)
			    {
			      break;
			    }
			    else
			    {
			      break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			/*
			  if($ptslst.fullSize() == 0)
			  {
			  Platform.message(#CT000068,#CT000069);
			  return;
			  }
			  */
			

			return true;
        }

        /**
        *   source:ptsp.@0002.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			String selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.engnam engnam,b.nam nam,c.enadr enadr,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '3' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr ";
			if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			{

			  String typ = this.getBelongto();
			  String ptyinr = null;
			  Argument<String> _ptyinrBox = Argument.box(ptyinr);
			  IDatafield inr = MdaDriver.getDatafield(ctx.getRoot(),typ+"grp\\dap\\pty\\inr");
			  if(!MdaUtils.isEmpty(inr))
			    ptyinr = inr.getValue().toString();
			  else
			    ptyinr = "";
			  selClause = selClause+"= '"+ptyinr;
			  log.debug("{}","bnk'ptyinr="+ptyinr);
			}
			else
			  selClause = selClause+"= '"+ctx.absGet(Sysmod.class).getPty().getInr();
			selClause = selClause+"'";
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getExtkey()))
			{
			  String extkey = this.getPtspta().getPts().getExtkey();
			  selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			}
			ctx.getDaoSession().dbExecuteSQL(selClause);
			ctx.getErrorCode();
			log.info("{}","selben的sql===================" + selClause);
			Argument<String> ptainr = new Argument<String>("ptainr");
			Argument<String> engnam = new Argument<String>("engnam");
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> ptyinr = new Argument<String>("ptyinr");
			Argument<String> extkey = new Argument<String>("extkey");
			Argument<String> enadr = new Argument<String>("enadr");
			Argument<String> adr = new Argument<String>("adr");
			Argument<String> tel = new Argument<String>("tel");
			Argument<String> fax = new Argument<String>("fax");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey,engnam,nam,enadr,adr,tel,fax);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getPtslst().add(ptainr,ptyinr,extkey,engnam,nam,enadr,adr,tel,fax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if($ptslst.fullSize() == 0)
			  {
			  Platform.message(#CT000097,#CT000098);
			  return;
			  }
			  */
			

			return true;
        }

        /**
        *   source:ptsp.@0003.script
        */
        @Init(order=100)
        public boolean	init100R2(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			String selClause = " ";
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getExtkey()))
			{
			  selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.nam nam,b.engnam engnam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE a.ptyinr = b.inr AND c.inr = a.objinr AND d.ptrtyp = '2' AND b.inr = d.preptyinr AND d.nxtptyinr = '"+ ctx.absGet(Sysmod.class).getPty().getInr() +"'";
			  String extkey = this.getPtspta().getPts().getExtkey();
			  //selClause = selClause + " AND (b.extkey LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			
			  ctx.getDaoSession().dbExecuteSQL(selClause);
			  ctx.getErrorCode();
			  log.info("{}","seletp的sql===================" + selClause);
			  Argument<String> ptainr = new Argument<String>("ptainr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> extkey_Arg = new Argument<String>("extkey");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> tel = new Argument<String>("tel");
			  Argument<String> fax = new Argument<String>("fax");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey_Arg,nam,engnam,adr,tel,fax);
			    int errorCode  = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			    {
			      this.getPtslst().add(ptainr,ptyinr,extkey_Arg,nam,engnam,adr,tel,fax);
			    }
			    else if(errorCode == ERROR_SQL)
			    {
			      break;
			    }
			    else
			    {
			      break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			if(this.getPtslst().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000122"),MdaUtils.getI18NString("ptsp","CT000123"));
			  return true;
			}
			

			return true;
        }

        /**
        *   source:ptsp.@0015.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			String rol = this.getRol();
			this.getPtspta().getPts().setRol(rol);
			this.setCurcus(MdaUtils.getI18NString("ptsp","CT000153"));
			if("dap".equals(rol))
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  {
			    //如果是商行
			    
			    
			    
			    
			  }
			  else
			  {
			    //如果不是商行
			    
			    
			    
			  }
			  log.debug("{}","Init dap !!!!!!!");
			}

			return true;
        }

        /**
        *   source:ptsp.@0027.script
        */
        @Init(order=100)
        public boolean	init100R3(){
            IContext ctx = MdaEnv.getContext();
            
			//跳进来自动搜索
			this.setCnt(0);
			MdaUtils.clear(this.getPtslst());
			//String selClause = "SELECT pta.inr ptainr,pty.inr ptyinr,pty.extkey extkey,pty.ncid ncid,pty.engnam engnam,pty.nam nam,adr.adr adr,adr.tel tel,adr.fax fax FROM pty,adr,pta,ptr WHERE ptr.ptrtyp = '4' AND pty.inr in ( SELECT pty.inr FROM pty,ptr WHERE (ptr.ptrtyp = '0' OR ptr.ptrtyp = '1' OR ptr.ptrtyp = '2') AND pty.inr = ptr.nxtptyinr AND ptr.preptyinr = '" + $\\sysmod\\pty\\inr.getValue() + "')";
			String tmpsql="";
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getExtkey()))
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			  else
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"') ";
			  String extkey = this.getPtspta().getPts().getExtkey();
			  extkey = extkey.toUpperCase();
			  tmpsql = tmpsql + " AND (b.ncid LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			}
			else
			{
			  if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			  else
			    tmpsql= "select count(*) count FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"') ";
			}
			ctx.getDaoSession().dbExecuteSQL(tmpsql);
			Argument<Integer> count = new Argument<Integer>("count");
			ctx.getDaoSession().dbFetchFields(count);
			ctx.getDaoSession().dbCloseCursor();
			log.info("{}","count============"+count.value);
			String selClause ="";
			if(count.value>100)
			{
			  this.setCnt(0);
			}
			else
			{
			  this.setCnt(count.value);
			}
			
			if(count.value<=100)
			{
			  if(!MdaUtils.isEmpty(this.getExtkey()))
			  {
			    if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			    else
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			    String extkey = this.getExtkey();
			    extkey = extkey.toUpperCase();
			    selClause = selClause + " AND (b.ncid LIKE '%"+ extkey +"%' OR c.extkey LIKE '%"+ extkey +"%')";
			  }
			  else
			  {
			    if("1".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a WHERE a.ptyinr = b.inr AND c.inr = a.objinr ";
			    else
			      selClause = "SELECT a.inr ptainr,b.inr ptyinr,b.extkey extkey,b.ncid ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.inr = d.preptyinr AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN ( SELECT inr FROM pty WHERE cid = '"+Platform.headBchcod()+"')";
			  }
			  ctx.getDaoSession().dbExecuteSQL(selClause);
			  ctx.getErrorCode();
			  log.debug("{}","selagt的sql===================" + selClause);
			  Argument<String> ptainr = new Argument<String>("ptainr");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> engnam = new Argument<String>("engnam");
			  Argument<String> ncid = new Argument<String>("ncid");
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> extkey = new Argument<String>("extkey");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> tel = new Argument<String>("tel");
			  Argument<String> fax = new Argument<String>("fax");
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,extkey,nam,engnam,ncid,adr,tel,fax);
			    int errorCode  = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			    {
			      this.getPtslst().add(ptainr,ptyinr,extkey,nam,engnam,ncid,adr,tel,fax);
			    }
			    else if(errorCode == ERROR_SQL)
			    {
			      break;
			    }
			    else
			    {
			      break;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			else
			{
			  ctx.setFieldError(this,"extkey",MdaUtils.getI18NString("ptsp","CT000235"));
			  return true;
			}

			return true;
        }


        /**
        *   source:ptsp.@0014.script
        */
        public void cancel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "";
			if(!MdaUtils.isEmpty(this.getPtspta().getPts().getExtkey()))
			{
			  if("agt".equals(this.getFlg()))
			  {
			    sql = "SELECT count(*) count FROM pty WHERE ncid = '" + this.getPtspta().getPts().getExtkey().toUpperCase() + "'";
			  }
			  else
			  {
			    sql = "SELECT count(*) count FROM pty WHERE extkey = '" + this.getPtspta().getPts().getExtkey().toUpperCase()  + "'";
			  }
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  Argument<BigDecimal> count = new Argument<BigDecimal>("count");
			  ctx.getDaoSession().dbFetchFields(count);
			  ctx.getDaoSession().dbCloseCursor();
			  Object tmp = count.value;
			  log.debug("{}","tmp==========");
			  log.debug("{}",tmp);
			  if("0".equals(tmp.toString()))
			  {
			    this.getPtspta().getPts().setExtkey(NULLSTR);
			    this.getPtspta().getPts().setAdrblk(NULLSTR);
			    this.setAdrblk(NULLSTR);
			    this.setExtkey(NULLSTR);
			    
			    
			    
			    
			    
			    
			  }
			}

			closePanel();
		}
        /**
        *   source:ptsp.@0016.script
        */
        public void sel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			
			MdaUtils.clear(this.getPtsp());
			this.setExtkey(NULLSTR);
			this.setAdrblk(NULLSTR);
			String flg = this.getFlg();
			if("apl".equals(flg))
			{
			  //申请人信息
			  
			}
			else if("agt".equals(flg))
			{
			  //兴业推荐代理行信息
			  this.setExtkey(this.getPtspta().getPts().getExtkey());
			  
			  
			  MdaUtils.clear(this.getPtslst());
			  
			}
			else if("ben".equals(flg))
			{
			  if("1".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp()))
			  {
			    String typ = this.getBelongto();
			    IDatafield ptytyp = MdaDriver.getDatafield(ctx.getRoot(),typ+"grp\\dap\\pty\\ptytyp");
			    if(!MdaUtils.isEmpty(ptytyp)&&!"3".equals(ptytyp.getValue()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000192"),MdaUtils.getI18NString("ptsp","CT000193"));
			      return;
			    }
			  }
			  //企业受益人信息
			  
			}
			else if("cmc".equals(flg))
			{
			  //商行下属企业
			  
			}
		}
        /**
        *   source:ptsp.@0017.script
        */
        public void refreshApl(IModule belongGrp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//dap变化时，相应调整申请人
			log.debug("{}","in refreshApl...");
			IModule apl = MdaDriver.getModule(belongGrp,"apl");
			//201712 若dap不为空，则将值赋给申请人
			//if(Platform.isEmpty(apl))
			//  return;
			log.debug("{}","not return...");
			IModule dap = MdaDriver.getModule(belongGrp,"dap");
			IModule pts = MdaDriver.getModule(apl,"pts");
			IDatafield aplRef = MdaDriver.getDatafield(pts,"ref");
			String ref = String.valueOf(aplRef.getValue());
			apl.copyValues(dap);
			if(!MdaUtils.isEmpty(aplRef))
			  aplRef.setValue(ref);
			
			
			
			
			
			log.info("{}","dap-apl-extkey-adrblk = "+ref+"  "+MdaDriver.getDatafield(pts,"extkey")+"  "+MdaDriver.getDatafield(pts,"adrblk"));
		}
        /**
        *   source:ptsp.@0018.script
        */
        public void closePanel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String flg = this.getFlg();
			log.debug("{}","flg  =" +flg);
			if("apl".equals(flg))
			{
			  //申请人
			  
			}
			else if("agt".equals(flg))
			{
			  //代理行
			  
			}
			else if("ben".equals(flg))
			{
			  //受益人
			  
			}
			else if("cmc".equals(flg))
			{
			  //商行下属企业
			  
			}
		}
        /**
        *   source:ptsp.@0033.script
        */
        public void cutField(IDatafield field,String groupfield1,String groupfield2,String groupfield3)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String groupfield="";
			//非空判断
			if(groupfield1==null && groupfield2==null && groupfield3==null)
			{
			  field.setValue(groupfield);
			  
			  return;
			}
			else if(groupfield1==null && groupfield2!=null && groupfield3!=null)
			{
			  groupfield=groupfield2+"、"+groupfield3;
			}
			else if(groupfield1==null && groupfield2==null && groupfield3!=null)
			{
			  groupfield=groupfield3;
			}
			else if(groupfield1==null && groupfield2!=null && groupfield3==null)
			{
			  groupfield=groupfield2;
			}
			else if(groupfield1!=null && groupfield2==null && groupfield3!=null)
			{
			  groupfield=groupfield1+"、"+groupfield3;
			}
			else if(groupfield1!=null && groupfield2==null && groupfield3==null)
			{
			  groupfield=groupfield1;
			}
			else if(groupfield1!=null && groupfield2!=null && groupfield3==null)
			{
			  groupfield=groupfield1+"、"+groupfield2;
			}
			else if(groupfield1!=null && groupfield2!=null && groupfield3!=null)
			{
			  groupfield=groupfield1+"、"+groupfield2+"、"+groupfield3;
			}
			//进行截取
			if(groupfield.length()>140)
			{
			  log.info("{}","adrblk的长度大于140，需要截取");
			  field.setValue(groupfield.substring(0,140));
			}
			else
			{
			  field.setValue(groupfield);
			}
			
		}
        /**
        *   source:ptsp.@0034.script
        */
        public void refreshAcw(String optype)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String extkey = this.getExtkey();
			log.info("{}","开户行搜索："+extkey);
			if (MdaUtils.isEmpty(extkey))
			{
			  extkey = "";
			}
			this.getPtslstp().setPaging(true);
			int currpage = this.getPtslstp().getPage();
			if (currpage == 0)
			{
			  this.getPtslstp().setPage(1);
			  currpage = 1;
			}
			// 点击搜索
			if ("query".equals(optype))
			{
			  currpage = 1;
			}
			this.getPtslstp().setPageSize(15);
			String tranname = ctx.getTransName();
			StringBuffer args=new StringBuffer();
			args.append("|");
			args.append("|");
			args.append(extkey);
			args.append("|");
			args.append(currpage);
			args.append("|");
			args.append(15);
			// 调用查询开户行接口
			Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","gjjgcx","gjjgcx",new Object[]{args.toString()});
			Map retMsg = (Map)MdaUtils.invoke(obj,"getContent");
			String errcod = (String)retMsg.get("ERRCOD");
			log.info("{}","查询开户行信息："+(String)retMsg.get("ERRCOD")+(String)retMsg.get("ERRMSG")+";"+retMsg.get("total"));
			if (!"0000000".equals(errcod))
			{
			  ctx.setMessage("提示","查询接收行信息失败");
			  return;
			}
			int fullsize = ((Double)retMsg.get("total")).intValue();
			MdaUtils.clear(this.getPtslstp());
			this.getPtslstp().setFullSize(fullsize);
			this.getPtslstp().setPage(currpage);
			this.getPtspta().getPts().setExtkey(NULLSTR);
			this.getPtspta().getPts().setAdr(NULLSTR);
			this.getPtspta().getPts().setNam(NULLSTR);
			this.getPtspta().getPts().setAdrblk(NULLSTR);
			this.setAdrblk(NULLSTR);
			this.setAdr(NULLSTR);
			this.setNam(NULLSTR);
			if ("change".equals(optype) || "init".equals(optype))
			{
			  if (fullsize == 0)
			  {
			    this.setExtkey(NULLSTR);
			    this.getPtspta().getPts().setExtkey("");
			    if ("change".equals(optype))
			      ctx.setMessage(MdaUtils.getI18NString("ptsp","CT000388"),MdaUtils.getI18NString("ptsp","CT000389"));
			  }
			  else if (fullsize == 1)
			  {
			    ArrayList<com.google.gson.internal.LinkedTreeMap> reslist = (ArrayList<com.google.gson.internal.LinkedTreeMap>)retMsg.get("result");
			    String adrblk = "";
			    String chnnam = "";
			    if (null != reslist.get(0).get("chnnam"))
			    {
			      chnnam = (String)reslist.get(0).get("chnnam");
			    }
			    String adr = "";
			    if (null != reslist.get(0).get("chnnam"))
			    {
			      adr = (String)reslist.get(0).get("addrss");
			    }
			    if(!MdaUtils.isEmpty(chnnam) && !MdaUtils.isEmpty(adr))
			    {
			      adrblk = chnnam + CR + adr ;
			    }
			    else if(MdaUtils.isEmpty(adr) && !MdaUtils.isEmpty(chnnam))
			    {
			      adrblk = chnnam ;
			    }
			    else
			    {
			      adrblk = adr ;
			    }
			    if (null != reslist.get(0).get("biccod"))
			    {
			      this.getPtspta().getPts().setExtkey((String)reslist.get(0).get("biccod"));
			    }
			    this.getPtspta().getPts().setAdrblk(adrblk);
			    this.getPtspta().getPts().setAdr(adr);
			    this.getPtspta().getPts().setNam(chnnam);
			  }
			  else
			  {
			    if ("init".equals(optype))
			    {
			      this.setExtkey(NULLSTR);
			      this.getPtspta().getPts().setExtkey("");
			    }
			  }
			}
			else
			{
			  ArrayList<com.google.gson.internal.LinkedTreeMap> reslist = (ArrayList<com.google.gson.internal.LinkedTreeMap>)retMsg.get("result");
			  Argument<String> nam = new Argument<String>("nam");
			  Argument<String> adr = new Argument<String>("adr");
			  Argument<String> ncid = new Argument<String>("ncid");
			  for(int i=0; i<reslist.size(); i++)
			  {
			    if (null != reslist.get(i).get("chnnam"))
			    {
			      nam.value = (String)reslist.get(i).get("chnnam");
			    }
			    else
			    {
			      nam.value = "";
			    }
			    if (null != reslist.get(i).get("addrss"))
			    {
			      adr.value = (String)reslist.get(i).get("addrss");
			    }
			    else
			    {
			      adr.value = "";
			    }
			    if (null != reslist.get(i).get("biccod"))
			    {
			      ncid.value = (String)reslist.get(i).get("biccod");
			    }
			    else
			    {
			      ncid.value = "";
			    }
			    this.getPtslstp().add(ncid,nam,adr);
			  }
			  
			}

			
			
			
			
			
			
			
			
		}

        public void setPtsptaHolder(ModuleHolder<Ptspta> ptspta)
        {
           this.ptspta = ptspta;
        }

        public Ptspta getPtspta()
        {
           return this.ptspta.get();
        }













        public void setRolHolder(FieldHolder<String> rol)
        {
           this.rol = (rol);
        }

        public void setRol(String rol)
        {
            this.rol.setValue(rol);
        }

        public String getRol()
        {
            return this.rol.getValue();
        }



        public void setBelongtoHolder(FieldHolder<String> belongto)
        {
           this.belongto = (belongto);
        }

        public void setBelongto(String belongto)
        {
            this.belongto.setValue(belongto);
        }

        public String getBelongto()
        {
            return this.belongto.getValue();
        }



        public void setFlgHolder(FieldHolder<String> flg)
        {
           this.flg = (flg);
        }

        public void setFlg(String flg)
        {
            this.flg.setValue(flg);
        }

        public String getFlg()
        {
            return this.flg.getValue();
        }































}