package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Pts;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptspta extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptspta.class);



	    @BDGetter
		private Pts pts;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Adr adr;


		public Ptspta()
        {
            super();
            setArgument();
        }

        public Ptspta(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ptspta.@0000.script
        */
        public void initDap(String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(this.getPty(),new Argument<String>("inr",ctx.absGet(Sysmod.class).getPty().getInr()));
			ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",this.getPty().getInr()));
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			this.getPts().setRol("dap");
			this.getPts().setPtyinr(this.getPty().getInr());
			this.getPts().setObjtyp(objtyp);
			this.getPts().setNam(this.getPty().getNam());
			//$pts\\adrblk.setValue($adr\\adr.getValue());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPty().getNam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPty().getNam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getPty().getNam();
			else if(MdaUtils.isEmpty(this.getPty().getNam())&&!MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getAdr().getAdr();
			else
			  adrblk = this.getPty().getNam() + CR + this.getAdr().getAdr();
			this.getPts().setAdrblk(adrblk);
			this.getPts().setExtkey(this.getPty().getExtkey());
			this.getPts().setRef("");
			this.getPts().setPtainr(this.getPta().getInr());
			this.getPts().setAdr(this.getAdr().getAdr());
		}
        /**
        *   source:ptspta.@0001.script
        */
        public void savTrp(String objtyp ,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getPts().setInr(Platform.sdbCounter("pts"));
			this.getPts().setObjinr(objinr);
			this.getPts().setObjtyp(objtyp);
			this.getPts().setRol("trp");
			this.getPts().setPtyinr(ctx.absGet(Sysmod.class).getPty().getInr());
			this.getPts().setNam(ctx.absGet(Sysmod.class).getPty().getNam());
			ctx.getDaoSession().dbInsert(this.getPts());
		}
        /**
        *   source:ptspta.@0002.script
        */
        public void savpts(String objinr,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//objinr：业务数据inr
			//objtyp:业务表名
			if(!MdaUtils.isEmpty(this.getPts().getAdrblk()))
			{
			  this.getPts().setInr(Platform.sdbCounter("pts"));
			  this.getPts().setObjinr(objinr);
			  this.getPts().setObjtyp(objtyp);
			  ctx.getDaoSession().dbInsert(this.getPts());
			  log.info("{}","pts inr========================"+this.getPts().getInr());
			}
		}
        /**
        *   source:ptspta.@0007.script
        */
        public void savRolPts(String objinr,String objtyp,String rol)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getPts()))
			  return;
			if(MdaUtils.isEmpty(this.getPts().getPtyinr())&&MdaUtils.isEmpty(this.getPts().getNam())&&MdaUtils.isEmpty(this.getPts().getAdrblk())
			  &&MdaUtils.isEmpty(this.getPts().getExtkey())&&MdaUtils.isEmpty(this.getPts().getRef())&&MdaUtils.isEmpty(this.getPts().getPtainr()))
			{
			  return;
			}
			if(MdaUtils.isEmpty(this.getPts().getInr()))
			{
			  this.getPts().setRol(rol);
			  this.getPts().setObjtyp(objtyp);
			  this.getPts().setObjinr(objinr);
			  this.getPts().setInr(Platform.sdbCounter("pts"));
			  ctx.getDaoSession().dbInsert(this.getPts());
			}
			else
			  ctx.getDaoSession().dbUpdate(this.getPts());
		}
        /**
        *   source:ptspta.@0008.script
        */
        public void initDapByPtyinr(String objtyp,String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","initDapByPtyinr "+ptyinr);
			if(MdaUtils.isEmpty(ptyinr))
			  return;
			ctx.getDaoSession().dbRead(this.getPty(),new Argument<String>("inr",ptyinr));
			ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",this.getPty().getInr()));
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			this.getPts().setRol("dap");
			this.getPts().setPtyinr(this.getPty().getInr());
			this.getPts().setObjtyp(objtyp);
			this.getPts().setNam(this.getPty().getEngnam());
			//$pts\\adrblk.setValue($adr\\adr.getValue());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getPty().getEngnam();
			else if(MdaUtils.isEmpty(this.getPty().getEngnam())&&!MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getAdr().getAdr();
			else
			  adrblk = this.getPty().getEngnam() + CR + this.getAdr().getAdr();
			this.getPts().setAdrblk(adrblk);
			this.getPts().setExtkey(this.getPty().getExtkey());
			this.getPts().setRef("");
			this.getPts().setPtainr(this.getPta().getInr());
		}
        /**
        *   source:ptspta.@0010.script
        */
        public void initIsb(String objtyp, String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbRead($pty,new Argument<String>("inr",$\\sysmod\\pty\\inr.getValue()));
			//Platform.dbRead($pta,new Argument<String>("ptyinr",$pty\\inr.getValue()));
			ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",ptyinr));
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			this.getPts().setRol("isb");
			this.getPts().setPtyinr(this.getPty().getInr());
			this.getPts().setObjtyp(objtyp);
			this.getPts().setNam(this.getPty().getEngnam());
			//$pts\\adrblk.setValue($adr\\adr.getValue());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getPty().getEngnam();
			else if(MdaUtils.isEmpty(this.getPty().getEngnam())&&!MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getAdr().getAdr();
			else
			  adrblk = this.getPty().getEngnam() + CR + this.getAdr().getAdr();
			this.getPts().setAdrblk(adrblk);
			this.getPts().setExtkey(this.getPty().getExtkey());
			this.getPts().setRef("");
			this.getPts().setPtainr(this.getPta().getInr());
		}
        /**
        *   source:ptspta.@0011.script
        */
        public void initPtyRole(String objtyp, String ptyinr, String ptyrole)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbRead($pty,new Argument<String>("inr",$\\sysmod\\pty\\inr.getValue()));
			//Platform.dbRead($pta,new Argument<String>("ptyinr",$pty\\inr.getValue()));
			ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",ptyinr));
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			this.getPts().setRol(ptyrole);
			this.getPts().setPtyinr(this.getPty().getInr());
			this.getPts().setObjtyp(objtyp);
			this.getPts().setNam(this.getPty().getEngnam());
			//$pts\\adrblk.setValue($adr\\adr.getValue());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getPty().getEngnam();
			else if(MdaUtils.isEmpty(this.getPty().getEngnam())&&!MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getAdr().getAdr();
			else
			  adrblk = this.getPty().getEngnam() + CR + this.getAdr().getAdr();
			this.getPts().setAdrblk(adrblk);
			this.getPts().setExtkey(this.getPty().getExtkey());
			this.getPts().setRef("");
			this.getPts().setPtainr(this.getPta().getInr());
		}
        /**
        *   source:ptspta.@0012.script
        */
        public void initBen(String objtyp, String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbRead($pty,new Argument<String>("inr",$\\sysmod\\pty\\inr.getValue()));
			//Platform.dbRead($pta,new Argument<String>("ptyinr",$pty\\inr.getValue()));
			ctx.getDaoSession().dbRead(this.getPta(),new Argument<String>("ptyinr",ptyinr));
			ctx.getDaoSession().dbRead(this.getAdr(),new Argument<String>("inr",this.getPta().getObjinr()));
			this.getPts().setRol("ben");
			this.getPts().setPtyinr(this.getPty().getInr());
			this.getPts().setObjtyp(objtyp);
			this.getPts().setNam(this.getPty().getEngnam());
			//$pts\\adrblk.setValue($adr\\adr.getValue());
			String adrblk = "";
			if(MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = "";
			else if(!MdaUtils.isEmpty(this.getPty().getEngnam())&&MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getPty().getEngnam();
			else if(MdaUtils.isEmpty(this.getPty().getEngnam())&&!MdaUtils.isEmpty(this.getAdr().getAdr()))
			  adrblk = this.getAdr().getAdr();
			else
			  adrblk = this.getPty().getEngnam() + CR + this.getAdr().getAdr();
			this.getPts().setAdrblk(adrblk);
			this.getPts().setExtkey(this.getPty().getExtkey());
			this.getPts().setRef("");
			this.getPts().setPtainr(this.getPta().getInr());
		}
        /**
        *   source:ptspta.@0014.script
        */
        public void cutField2(IDatafield field,String groupfield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//组合后的字段长度大于140进行截取
			
			if(groupfield!=null && groupfield.length()>140)
			{
			  log.info("{}","adrblk的长度大于140，需要截取");
			  field.setValue(groupfield.substring(0,140));
			}
			else
			{
			  field.setValue(groupfield);
			}
		}









}