package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Acc;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Etg;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 设置交易角色
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Ptyset extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Ptyset.class);

        //商行/企业客户
        private String cliptyinr;

        //我行业务归属机构
        private String bnkptyinr;

        //商行客户
        private String bnk2clptyinr;

        //商行/企业客户名称
        private String cliptynam;

        //我行机构名称
        private String bnkptynam;

        //商行二级客户名称
        private String bnk2clptynam;

        //落地机构代码
        private String bnkbchcod;



	    @BDGetter
		private Pty bnk;

	    @BDGetter
		private Pty cli;

	    @BDGetter
		private Pty bnk2cl;

	    @BDGetter
		private Acc acc;

	    @BDGetter
		private Etg etg;

	    @BDGetter
		private Ety ety;


		public Ptyset()
        {
            super();
            setArgument();
        }

        public Ptyset(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:ptyset.@0000.script
        */
        public String setBnkByBchcod(String argBchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据 机构号设置我行机构 bnk信息
			  *@返回值:返回我行机构 ptyinr
			  */
			log.debug("{}"," in ptyset.setBnkByBchcod ... argBchcod = " +argBchcod );
			int errcod = ctx.getErrorCode() ;
			String ptyinr = "" ;
			if(MdaUtils.isEmpty(argBchcod))
			{
			  log.error("{}","业务归属机构代码参数为空 。") ;
			  return ptyinr ;
			}
			MdaUtils.clear(this.getBnk());
			ctx.getDaoSession().dbRead(this.getBnk(),new Argument<String>("cid",argBchcod),new Argument<String>("ptytyp","0"));
			errcod = ctx.getErrorCode();
			if(errcod == NO_ERROR)
			{
			  ptyinr =  this.getBnk().getInr();
			  this.setBnkptyinr( this.getBnk().getInr());
			  this.setBnkptynam( this.getBnk().getNam());
			  this.setBnkbchcod(this.getBnk().getCid());
			  log.debug("{}","业务归属机构设置成成功。 机构号："+argBchcod+"，ptyinr：" + ptyinr +"。");
			}
			else
			{
			  log.error("{}","未正确匹配我行机构信息。 错误码："+ errcod + "，机构号："+argBchcod+" 。" );
			}
			return ptyinr ;

		}
        /**
        *   source:ptyset.@0001.script
        */
        public String setCliByBic(String argBic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 设置商行 cli信息
			  *@返回值：商行ptyinr
			  */
			log.debug("{}"," in ptyset.setPtyBic ...  argBic = " +argBic );
			String cliptyinr = "";
			int errcod = ctx.getErrorCode() ;
			if(MdaUtils.isEmpty(argBic))
			{
			  log.error("{}"," 商行BIC参数为空。 ") ;
			  return cliptyinr ;
			}
			MdaUtils.clear(this.getCli());
			ctx.getDaoSession().dbRead(this.getCli(),new Argument<String>("bic",argBic),new Argument<String>("ptytyp","1"));
			errcod = ctx.getErrorCode();
			if(errcod == NO_ERROR)
			{
			  cliptyinr = this.getCli().getInr();
			  this.setCliptyinr(cliptyinr);
			  this.setCliptynam(this.getCli().getNam());
			  log.debug("{}"," 代理商行信息设置成功。cliptyinr："+this.getCliptyinr()+"，cliptynam：" + this.getCliptynam() +"。");
			}
			else
			{
			  log.error("{}"," 代理商行信息设置失败。商行BIC："+argBic+"错误码：" + errcod +"。");
			}
			return cliptyinr ;
		}
        /**
        *   source:ptyset.@0002.script
        */
        public boolean setAccByAgentAccount(String argAct)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *根据代理行账号设置代理商行及我行机构信息
			  */
			log.debug("{}"," in  ptyset.setAccByAgentAccount ... argAct：" + argAct +"。");
			MdaUtils.clear(this.getAcc());
			ctx.getDaoSession().dbRead(this.getAcc(),new Argument<String>("act",argAct),new Argument<String>("delflg",NE,"X"));
			int errcod = ctx.getErrorCode();
			if( errcod == NO_ERROR)
			{
			  this.setCliptyinr( this.getAcc().getOwnptyinr());  // 代理商行 ptyinr
			  this.setBnkptyinr( this.getAcc().getOpnptyinr());  // 我行机构 ptyinr
			  log.debug("{}","代理行账号信息设置成功。");
			  return true ;
			}
			else
			{
			  log.error("{}","代理行账号参数表配置错误，账号所属机构为空。代理行账号：" + argAct + "。" );
			  return false;
			}
		}
        /**
        *   source:ptyset.@0003.script
        */
        public void preClearModuleData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 清空交易角色模块数据
			  */
			log.debug("{}","in ptyset.preClearModuleData ...  ");
			MdaUtils.clear(this.getCli());
			MdaUtils.clear(this.getBnk());
			MdaUtils.clear(this.getBnk2cl());
			MdaUtils.clear(this.getAcc());
			MdaUtils.clear(this.getEtg());
			MdaUtils.clear(this.getEty());
			this.setCliptyinr(NULLSTR);
			this.setBnkptyinr(NULLSTR);
			this.setBnk2clptyinr(NULLSTR);
			this.setCliptynam(NULLSTR);
			this.setBnkptynam(NULLSTR);
			this.setBnk2clptynam(NULLSTR);
		}
        /**
        *   source:ptyset.@0006.script
        */
        public boolean setBnkByPtyinr(String argInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			MdaUtils.clear(this.getBnk());
			ctx.getDaoSession().dbRead(this.getBnk(),new Argument<String>("inr",argInr),new Argument<String>("ptytyp","0"));
			int errcod = ctx.getErrorCode();
			if( errcod == NO_ERROR)
			{
			  this.setBnkptynam( this.getBnk().getNam());
			  log.debug("{}","我行机构信息设置成功。机构编号：" + this.getBnk().getCid() +",机构 INR:" + this.getBnk().getInr()+",机构名称：" + this.getBnkptynam() +"。");
			  return true ;
			}
			else
			{
			  log.error("{}","代理行账号无法确定机构信息。bnk.ptyinr:"+ argInr+",错误码：" + errcod +"。" );
			  return false;
			}
		}
        /**
        *   source:ptyset.@0007.script
        */
        public void setPartiesByAccount(String argAct)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:ptyset.@0008.script
        */
        public void setCliByPtyinr(String argInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(argInr))
			{
			  log.error("{}","代理商行ptyinr为空。" );
			  return ;
			}
			MdaUtils.clear(this.getCli());
			ctx.getDaoSession().dbRead(this.getCli(),new Argument<String>("inr",this.getCliptyinr()));
			int errcod = ctx.getErrorCode();
			if( errcod==NO_ERROR)
			{
			  this.setCliptynam(this.getCli().getNam());
			  log.debug("{}","代理商行信息设置成功。商行名称：" + this.getCli().getNam() +",商行 ptyinr=" + this.getCli().getInr());
			}
			else
			{
			  log.warn("{}","无法确定代理商行信息。cli.ptyinr:"+ argInr+",错误码：" + errcod +"。" );
			}
		}
        /**
        *   source:ptyset.@0009.script
        */
        public String getPtyEtginr(String etyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *查询 ETGINR
			  */
			String etginr = "";
			if(!MdaUtils.isEmpty(etginr))
			{
			  MdaUtils.clear(this.getEty());
			  ctx.getDaoSession().dbRead(this.getEty(),new Argument<String>("inr",etyinr));
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    etginr = this.getEty().getEtginr();
			  }
			}
			return etginr;
		}
        /**
        *   source:ptyset.@0010.script
        */
        public String setCliByClientID(String argClientId)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 设置商行 cli信息
			  *@返回值：商行ptyinr
			  */
			log.debug("{}"," in ptyset.setPtyBic ...  argClientId = " +argClientId );
			String cliptyinr = "";
			int errcod = ctx.getErrorCode() ;
			if(MdaUtils.isEmpty(argClientId))
			{
			  log.error("{}"," 核心客户号参数为空。 ") ;
			  return cliptyinr ;
			}
			MdaUtils.clear(this.getCli());
			//Platform.dbRead($cli,new Argument<String>("cid",argClientId), new Argument<String>("ptytyp","2"));
			ctx.getDaoSession().dbRead(this.getCli(),new Argument<String>("cid",argClientId));
			errcod = ctx.getErrorCode();
			if(errcod == NO_ERROR)
			{
			  cliptyinr = this.getCli().getInr();
			  this.setCliptyinr(cliptyinr);
			  this.setCliptynam(this.getCli().getNam());
			  log.debug("{}"," 客户信息设置成功。cliptyinr："+this.getCliptyinr()+"，cliptynam：" + this.getCliptynam() +"。");
			}
			else
			{
			  log.error("{}"," 客户信息设置失败。核心客户号："+argClientId+"，错误码：" + errcod +"。");
			}
			return cliptyinr ;
		}



























}