package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Acc;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rolchs extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rolchs.class);

        //账号
        @Module(getter = false, setter = false)
		private FieldHolder<String> act = new FieldConstantHolder<>("");


        //行号
        @Module(getter = false, setter = false)
		private FieldHolder<String> extkey = new FieldConstantHolder<>("");


        //名称
        @Module(getter = false, setter = false)
		private FieldHolder<String> nam = new FieldConstantHolder<>("");


        //地址
        @Module(getter = false, setter = false)
		private FieldHolder<String> adr = new FieldConstantHolder<>("");


        //币种
        @Module(getter = false, setter = false)
		private FieldHolder<String> cur = new FieldConstantHolder<>("");


        //账户选择
        private transient IControl actchs = new ControlImpl("actchs", "账户选择", this);

        //行号选择
        private transient IControl extkeychs = new ControlImpl("extkeychs", "行号选择", this);

        //退出
        private transient IControl cancel = new ControlImpl("cancel", "退出", this);

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //网银编号
        private String cid;

        //账号选择跳转
        private transient IControl chaact = new ControlImpl("chaact", "账号选择跳转", this);

        //行号选择跳转
        private transient IControl chaext = new ControlImpl("chaext", "行号选择跳转", this);

        //全行号选择跳转
        private transient IControl ptychs = new ControlImpl("ptychs", "全行号选择跳转", this);

        //行号选择
        private transient IControl allextchs = new ControlImpl("allextchs", "行号选择", this);

        //查询
        private transient IControl allextsel = new ControlImpl("allextsel", "查询", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel actsel;

        @JsonIgnore
        @BDGetter
        private transient IPanel extsel;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptyextchs;


		@BDGetter
		private ModuleList<Ptsplst> ptslst;

		@BDGetter
		private ModuleList<Acc> acclst;


		public Rolchs()
        {
            super();
            setArgument();
        }

        public Rolchs(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:rolchs.@0000.script
        */
        @Rule(target="cancel",order=100)
        public boolean ruleCancelN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			

			return true;
        }

        /**
        *   source:rolchs.@0001.script
        */
        @Rule(target="actchs",order=100)
        public boolean ruleActchsN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getAcclst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rolchs","CT000016"),MdaUtils.getI18NString("rolchs","CT000017"));
			  return true;
			}

			this.setAct(this.getAcclst().getElement(index).getAct());
			

			

			return true;
        }

        /**
        *   source:rolchs.@0002.script
        */
        @Rule(target="extkeychs",order=100)
        public boolean ruleExtkeychsN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getPtslst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rolchs","CT000018"),MdaUtils.getI18NString("rolchs","CT000019"));
			  return true;
			}

			this.setExtkey(this.getPtslst().getElement(index).getNcid());
			
			this.setNam(this.getPtslst().getElement(index).getNam());
			
			this.setAdr(this.getPtslst().getElement(index).getAdr());
			

			MdaUtils.clear(this.getPtslst());
			this.setCid(NULLSTR);
			

			return true;
        }

        /**
        *   source:rolchs.@0003.script
        */
        @Rule(target="search",order=100)
        public boolean ruleSearchN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			String cid=this.getCid();
			String tmpsql="";
			Argument<Integer> num = new Argument<Integer>("num");

			if(MdaUtils.isEmpty(cid) || cid.length()<4)
			{
			  ctx.setFieldError(this,"cid",MdaUtils.getI18NString("rolchs","CT000038"));
			  return true;
			}

			if(!MdaUtils.isEmpty(cid))
			{
			  if(cid.matches("\\d{4,}"))
			  {
			    tmpsql="select count(*) num from hx_zfxthhb where cyjghh like ? ";
			    ctx.getDaoSession().dbExecuteSQL(tmpsql,"%" + cid + "%");
			    MdaUtils.clear(num);
			    ctx.getDaoSession().dbFetchFields(num);
			    log.info("{}","num=========="+num.value);
			    ctx.getDaoSession().dbCloseCursor();
			    if(num.value<100)
			    {
			      String sql="select trim(cyjghh) as ncid,cyjgqc as nam from hx_zfxthhb where cyjghh like ? ";
			      Argument<String> ncid = new Argument<String>("ncid");
			      Argument<String> nam = new Argument<String>("nam");
			      ctx.getDaoSession().dbExecuteSQL(sql,"%" + cid + "%");
			      ctx.getErrorCode();
			      log.debug("{}","sql===================" + sql);
			      while(true)
			      {
			        ctx.getDaoSession().dbFetchFields(ncid,nam);
			        int errorCode  = ctx.getErrorCode();
			        if(errorCode == NO_ERROR)
			        {
			          this.getPtslst().add(ncid,nam);
			        }
			        else
			        {
			          break;
			        }
			      }
			    }
			    else
			    {
			      ctx.setFieldError(this,"cid",MdaUtils.getI18NString("rolchs","CT000039"));
			      return true;
			    }
			  }
			  else
			  {
			    String sql = "SELECT distinct a.inr ptainr,b.inr ptyinr,b.extkey ncid,b.engnam engnam,b.nam nam,c.adr adr,c.tel tel,c.fax fax FROM pty b,adr c,pta a,ptr d WHERE d.ptrtyp = '4' AND b.extkey like ? AND a.ptyinr = b.inr AND c.inr = a.objinr AND d.nxtptyinr IN (SELECT inr FROM pty WHERE cid = '08101') ";
			    ctx.getDaoSession().dbExecuteSQL(sql,"%"+cid +"%");
			    ctx.getErrorCode();
			    log.debug("{}","sql===================" + sql);
			    Argument<String> ptainr = new Argument<String>("ptainr");
			    Argument<String> nam = new Argument<String>("nam");
			    Argument<String> engnam = new Argument<String>("engnam");
			    Argument<String> ncid = new Argument<String>("ncid");
			    Argument<String> ptyinr = new Argument<String>("ptyinr");
			    Argument<String> adr = new Argument<String>("adr");
			    Argument<String> tel = new Argument<String>("tel");
			    Argument<String> fax = new Argument<String>("fax");
			    while(true)
			    {
			      ctx.getDaoSession().dbFetchFields(ptainr,ptyinr,nam,engnam,ncid,adr,tel,fax);
			      int errorCode  = ctx.getErrorCode();
			      if(errorCode == NO_ERROR)
			      {
			        this.getPtslst().add(ptainr,ptyinr,nam,engnam,ncid,adr,tel,fax);
			      }
			      else
			      {
			        break;
			      }
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  
			}
			else
			  ctx.setFieldError(this,"search",MdaUtils.getI18NString("rolchs","CT000049"));

			return true;
        }

        /**
        *   source:rolchs.@0004.script
        */
        @Rule(target="chaext",order=100)
        public boolean ruleChaextN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rolchs.@0005.script
        */
        @Rule(target="chaact",order=100)
        public boolean ruleChaactN100(){
            IContext ctx = MdaEnv.getContext();
            
			popupActchs();

			return true;
        }

        /**
        *   source:rolchs.@0007.script
        */
        @Rule(target="ptychs",order=100)
        public boolean rulePtychsN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:rolchs.@0008.script
        */
        @Rule(target="allextsel",order=100)
        public boolean ruleAllextselN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getPtslst());
			String bic=this.getCid();
			String sql = "SELECT inr as ptyinr,bic as ncid,nam FROM pty where bic like ?";
			ctx.getDaoSession().dbExecuteSQL(sql,"%"+bic+"%");
			ctx.getErrorCode();
			log.debug("{}","sql===================" + sql);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> ptyinr = new Argument<String>("ptyinr");
			Argument<String> ncid = new Argument<String>("ncid");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(ptyinr,ncid,nam);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getPtslst().add(ptyinr,ncid,nam);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			

			return true;
        }

        /**
        *   source:rolchs.@0009.script
        */
        @Rule(target="allextchs",order=100)
        public boolean ruleAllextchsN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int len = this.getPtslst().fullSize();
			if(index < 0  ||  index >= len)
			{
			  ctx.setMessage(MdaUtils.getI18NString("rolchs","CT000036"),MdaUtils.getI18NString("rolchs","CT000037"));
			  return true;
			}

			this.setExtkey(this.getPtslst().getElement(index).getNcid());
			
			this.setNam(this.getPtslst().getElement(index).getNam());
			

			MdaUtils.clear(this.getPtslst());
			this.setCid(NULLSTR);
			

			return true;
        }




        /**
        *   source:rolchs.@0006.script
        */
        public void popupActchs()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getAcclst());
			String cur1 = this.getCur();
			String ptyinr1 = ctx.absGet(Sysmod.class).getPty().getInr();
			String sql = "SELECT acc.cur cur,acc.act act FROM acc , ptr  WHERE acc.ownptyinr= ? and acc.cur= ? and ptr.preptyinr= ? and acc.opnptyinr = ptr.nxtptyinr " ;
			ctx.getDaoSession().dbExecuteSQL(sql,ptyinr1,cur1,ptyinr1);
			ctx.getErrorCode();
			log.debug("{}","sql===================" + sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> act = new Argument<String>("act");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cur,act);
			  int errorCode  = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getAcclst().add(cur,act);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
			
		}







        public void setActHolder(FieldHolder<String> act)
        {
           this.act = (act);
        }

        public void setAct(String act)
        {
            this.act.setValue(act);
        }

        public String getAct()
        {
            return this.act.getValue();
        }



        public void setExtkeyHolder(FieldHolder<String> extkey)
        {
           this.extkey = (extkey);
        }

        public void setExtkey(String extkey)
        {
            this.extkey.setValue(extkey);
        }

        public String getExtkey()
        {
            return this.extkey.getValue();
        }



        public void setNamHolder(FieldHolder<String> nam)
        {
           this.nam = (nam);
        }

        public void setNam(String nam)
        {
            this.nam.setValue(nam);
        }

        public String getNam()
        {
            return this.nam.getValue();
        }



        public void setAdrHolder(FieldHolder<String> adr)
        {
           this.adr = (adr);
        }

        public void setAdr(String adr)
        {
            this.adr.setValue(adr);
        }

        public String getAdr()
        {
            return this.adr.getValue();
        }



        public void setCurHolder(FieldHolder<String> cur)
        {
           this.cur = (cur);
        }

        public void setCur(String cur)
        {
            this.cur.setValue(cur);
        }

        public String getCur()
        {
            return this.cur.getValue();
        }





















}