package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Mad;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Rptp.class);

        //业务参考号
        private String ownref;

        //开始日期
        private Date begdat;

        //结束日期
        private Date enddat;

        //业务类型
        private String owntyp;

        //收款人
        private String pyenam;

        //币种
        private String cur;

        //业务状态
        private String sta;

        //报文状态
        private String erssta;

        //查询
        private transient IControl query = new ControlImpl("query", "查询", this);

        //导出
        private IStream dow = new StreamImpl();

        //选择
        private transient IControl take = new ControlImpl("take", "选择", this);

        //金额（起）
        private BigDecimal begamt = new BigDecimal("0.00");

        //金额（止）
        private BigDecimal endamt = new BigDecimal("0.00");

        //返回
        private transient IControl _return = new ControlImpl("return", "返回", this);

        //打印通知
        private IStream inform = new StreamImpl();

        //复制
        private transient IControl coprpd = new ControlImpl("coprpd", "复制", this);

        //行内关联编号
        private String hnglbh;

        //手工清分
        private transient IControl chssel = new ControlImpl("chssel", "手工清分", this);

        //机构分配
        private String ptyinr;

        //确认
        private transient IControl surbut = new ControlImpl("surbut", "确认", this);

        //导出TXT
        private transient IControl dowtxt = new ControlImpl("dowtxt", "导出TXT", this);

        //废除
        private transient IControl delete = new ControlImpl("delete", "废除", this);

        //机构名称
        private String nam;

        //汇款金额
        private BigDecimal amt = new BigDecimal("0.00");

        //申请日期
        private String dat;

        //所属落地机构
        private String bchcod;

        //起息日期
        private String valdat;


        @JsonIgnore
        @BDGetter
        private transient IPanel opnpan;

        @JsonIgnore
        @BDGetter
        private transient IPanel qurpan;

        @JsonIgnore
        @BDGetter
        private transient IPanel rptmsg;

        @JsonIgnore
        @BDGetter
        private transient IPanel ptysel;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Rpdgrp> rpdgrp;

		@BDGetter
		private ModuleList<Rpdtmp> tmplst;

	    @BDGetter
		private Ers ers;

	    @BDGetter
		private Trn trn;

	    @BDGetter
		private Mad mad;

	    @BDGetter
		private Rolchs orip;

	    @BDGetter
		private Rolchs awip;

	    @BDGetter
		private Rolchs orcp;

	    @BDGetter
		private Rolchs pyep;

	    @BDGetter
		private Rolchs in1p;

	    @BDGetter
		private Rolchs in2p;

	    @BDGetter
		private Rolchs in3p;


		public Rptp()
        {
            super();
            setArgument();
        }

        public Rptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getOrip().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.oriact");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOriact(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOriact();}}
			 );
            this.getOrip().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.oriextkey");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOriextkey(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOriextkey();}}
			 );
            this.getOrip().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.orinam");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOrinam(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOrinam();}}
			 );
            this.getOrip().setAdrHolder(new FieldConstantHolder<>(""));
            this.getOrip().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getAwip().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getAwip().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.awiact");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setAwiact(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getAwiact();}}
			 );
            this.getAwip().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.awiextkey");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setAwiextkey(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getAwiextkey();}}
			 );
            this.getAwip().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.awinam");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setAwinam(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getAwinam();}}
			 );
            this.getAwip().setAdrHolder(new FieldConstantHolder<>(""));
            this.getOrcp().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.orcact");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOrcact(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOrcact();}}
			 );
            this.getOrcp().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.orcextkey");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOrcextkey(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOrcextkey();}}
			 );
            this.getOrcp().setAdrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.orcadr");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOrcadr(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOrcadr();}}
			 );
            this.getOrcp().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getOrcp().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.orcnam");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setOrcnam(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getOrcnam();}}
			 );
            this.getPyep().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.pyeact");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setPyeact(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getPyeact();}}
			 );
            this.getPyep().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.pyeextkey");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setPyeextkey(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getPyeextkey();}}
			 );
            this.getPyep().setAdrHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.pyeadr");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setPyeadr(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getPyeadr();}}
			 );
            this.getPyep().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getPyep().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.pyenam");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setPyenam(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getPyenam();}}
			 );
            this.getIn1p().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.actin1");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setActin1(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getActin1();}}
			 );
            this.getIn1p().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.extkeyin1");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setExtkeyin1(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getExtkeyin1();}}
			 );
            this.getIn1p().setAdrHolder(new FieldConstantHolder<>(""));
            this.getIn1p().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getIn1p().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.namin1");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setNamin1(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getNamin1();}}
			 );
            this.getIn2p().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.actin2");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setActin2(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getActin2();}}
			 );
            this.getIn2p().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.extkeyin2");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setExtkeyin2(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getExtkeyin2();}}
			 );
            this.getIn2p().setAdrHolder(new FieldConstantHolder<>(""));
            this.getIn2p().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getIn2p().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.namin2");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setNamin2(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getNamin2();}}
			 );
            this.getIn3p().setActHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.actin3");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setActin3(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getActin3();}}
			 );
            this.getIn3p().setExtkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.extkeyin3");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setExtkeyin3(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getExtkeyin3();}}
			 );
            this.getIn3p().setAdrHolder(new FieldConstantHolder<>(""));
            this.getIn3p().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getIn3p().setNamHolder( new FieldHolder<String>(){
				public String getPath(){return Rptp.this.getFieldPath("rpdgrp.rec.namin3");}
 				public void setValue(String arg){Rptp.this.getRpdgrp().getRec().setNamin3(arg);}
 				public String getValue(){return Rptp.this.getRpdgrp().getRec().getNamin3();}}
			 );
        }





        public void setRpdgrpHolder(ModuleHolder<Rpdgrp> rpdgrp)
        {
           this.rpdgrp = rpdgrp;
        }

        public Rpdgrp getRpdgrp()
        {
           return this.rpdgrp.get();
        }













































































}