package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pts;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cpd;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 查询类交易模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Selp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Selp.class);

        //业务参考号
        private String ref;

        //查询类型
        private String seltyp;

        //搜索
        private transient IControl query = new ControlImpl("query", "搜索", this);

        //新建
        private transient IControl newapply = new ControlImpl("newapply", "新建", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //机构名称
        private String ptynam;

        //业务状态
        private String jsdtyp;

        //开始日期
        private Date begdat;

        //结束日期
        private Date enddat;

        //排序方式
        private String order;


        @JsonIgnore
        @BDGetter
        private transient IPanel quickQuery;

        @JsonIgnore
        @BDGetter
        private transient IPanel sellc;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtsnd;

        @JsonIgnore
        @BDGetter
        private transient IPanel brtfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel letfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftopn;

        @JsonIgnore
        @BDGetter
        private transient IPanel selic;

        @JsonIgnore
        @BDGetter
        private transient IPanel botfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel sellg;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptrpn;

        @JsonIgnore
        @BDGetter
        private transient IPanel sellgapl;

        @JsonIgnore
        @BDGetter
        private transient IPanel bptopn;

        @JsonIgnore
        @BDGetter
        private transient IPanel sellc1;

        @JsonIgnore
        @BDGetter
        private transient IPanel bctacp;

        @JsonIgnore
        @BDGetter
        private transient IPanel selcom;

        @JsonIgnore
        @BDGetter
        private transient IPanel seldc;

        @JsonIgnore
        @BDGetter
        private transient IPanel detfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel bdtsnd;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptfre;

        @JsonIgnore
        @BDGetter
        private transient IPanel fftapn;

        @JsonIgnore
        @BDGetter
        private transient IPanel letzre;

        @JsonIgnore
        @BDGetter
        private transient IPanel letatt;

        @JsonIgnore
        @BDGetter
        private transient IPanel letatr;

        @JsonIgnore
        @BDGetter
        private transient IPanel jstame;

        @JsonIgnore
        @BDGetter
        private transient IPanel witame;

        @JsonIgnore
        @BDGetter
        private transient IPanel sellg1;

        @JsonIgnore
        @BDGetter
        private transient IPanel cptopi;


	    @BDGetter
		private Tmp tmp;

		@BDGetter
		private ModuleList<Tmp> tmplst;

		@BDGetter
		private ModuleList<Tmp> tmplst1;

		@BDGetter
		private ModuleList<Tmp> tmplst2;

		@BDGetter
		private ModuleList<Tmp> tmplst3;

		@BDGetter
		private ModuleList<Cpd> cpdlst;

		@BDGetter
		private ModuleList<Pts> ptslst;


		public Selp()
        {
            super();
            setArgument();
        }

        public Selp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:selp.@0000.script
        */
        public void queryBtn(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			//Argument<String> pinr = new Argument<String>("pinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			//Argument<String> lcref = new Argument<String>("lcref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> kjhkflg = new Argument<String>("kjhkflg");
			/*
			  Argument<String> benadr = new Argument<String>("benadr");
			  Argument<String> bentel = new Argument<String>("bentel");
			  Argument<String> benfax = new Argument<String>("benfax");
			  */
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,dat,cur,amt,bennam,aplnam,kjhkflg);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst().add(trsinr,ref,dat,cur,amt,bennam,aplnam,kjhkflg);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if($tmplst.fullSize() == 0)
			  {
			  return;
			  }
			  */
			
		}
        /**
        *   source:selp.@0001.script
        */
        public void sureBtn(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getTmplst().fullSize();
			log.info("{}","size of tmplst is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000129"),MdaUtils.getI18NString("selp","CT000130"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0002.script
        */
        public void queryBtn1(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000192
			MdaUtils.clear(this.getTmplst1());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}",MdaUtils.getI18NString("selp","CT000193") + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<Date> dat = new Argument<Date>("dat");
			/*
			  Argument<String> lcref = new Argument<String>("lcref");
			  Argument<String> aplnam = new Argument<String>("aplnam");
			  Argument<String> apladr = new Argument<String>("apladr");
			  Argument<String> apltel = new Argument<String>("apltel");
			  Argument<String> aplfax = new Argument<String>("aplfax");
			  */
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> benadr = new Argument<String>("benadr");
			Argument<String> bentel = new Argument<String>("bentel");
			Argument<String> benfax = new Argument<String>("benfax");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst1().add(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			if(this.getTmplst1().fullSize() == 0)
			{
			  //Platform.message(#CT000194,#CT000195);
			  return;
			}
			
		}
        /**
        *   source:selp.@0003.script
        */
        public void sureBtn1(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			int length = this.getTmplst1().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000202"),MdaUtils.getI18NString("selp","CT000203"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst1().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0004.script
        */
        public void sureBtn2(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getTmplst2().fullSize();
			log.info("{}","size of tmplst2 is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000318"),MdaUtils.getI18NString("selp","CT000319"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst2().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0005.script
        */
        public void queryBtn2(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst2());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  if("2".equals(this.getSeltyp()))
			    queryClause = queryClause + " AND ownref LIKE '%" + this.getRef() + "%'";
			  else
			    queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			if(!MdaUtils.isEmpty(this.getSeltyp()))
			{
			  if("2".equals(this.getSeltyp()))
			    queryClause = queryClause + " AND cretyp='Z' ";
			  else if("1".equals(this.getSeltyp()))
			    queryClause = queryClause + " AND (cretyp='W' OR cretyp is null ) ";
			}
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			//Argument<String> lcref = new Argument<String>("lcref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> cretyp = new Argument<String>("cretyp");
			/*
			  Argument<String> benadr = new Argument<String>("benadr");
			  Argument<String> bentel = new Argument<String>("bentel");
			  Argument<String> benfax = new Argument<String>("benfax");
			  */
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,dat,cur,amt,bennam,aplnam,cretyp);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst2().add(trsinr,ref,dat,cur,amt,bennam,aplnam,cretyp);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if($tmplst.fullSize() == 0)
			  {
			  return;
			  }
			  */
			
		}
        /**
        *   source:selp.@0006.script
        */
        public void queryBtn3(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000325
			MdaUtils.clear(this.getTmplst2());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND rec.ownref LIKE '%" + this.getRef() + "%'";
			}
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			int tmp = ctx.getErrorCode();
			log.info("{}",MdaUtils.getI18NString("selp","CT000326") + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<Date> dat = new Argument<Date>("dat");
			/*
			  Argument<String> lcref = new Argument<String>("lcref");
			  Argument<String> aplnam = new Argument<String>("aplnam");
			  Argument<String> apladr = new Argument<String>("apladr");
			  Argument<String> apltel = new Argument<String>("apltel");
			  Argument<String> aplfax = new Argument<String>("aplfax");
			  */
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> benadr = new Argument<String>("benadr");
			Argument<String> bentel = new Argument<String>("bentel");
			Argument<String> benfax = new Argument<String>("benfax");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst2().add(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			if(this.getTmplst2().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000327"),MdaUtils.getI18NString("selp","CT000328"));
			  return;
			}
			
		}
        /**
        *   source:selp.@0007.script
        */
        public void sureBtn3(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getTmplst2().fullSize();
			log.info("{}","size of tmplst2 is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000329"),MdaUtils.getI18NString("selp","CT000330"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst2().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0008.script
        */
        public void queryBtn4(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000351
			MdaUtils.clear(this.getTmplst3());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND rec.stlref LIKE '%" + this.getRef() + "%'";
			}
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}",MdaUtils.getI18NString("selp","CT000352") + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<Date> dat = new Argument<Date>("dat");
			/*
			  Argument<String> lcref = new Argument<String>("lcref");
			  Argument<String> aplnam = new Argument<String>("aplnam");
			  Argument<String> apladr = new Argument<String>("apladr");
			  Argument<String> apltel = new Argument<String>("apltel");
			  Argument<String> aplfax = new Argument<String>("aplfax");
			  */
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> benadr = new Argument<String>("benadr");
			Argument<String> bentel = new Argument<String>("bentel");
			Argument<String> benfax = new Argument<String>("benfax");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst3().add(trsinr,ref,cur,amt,dat,bennam,benadr,bentel,benfax,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			if(this.getTmplst3().fullSize() == 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000353"),MdaUtils.getI18NString("selp","CT000354"));
			  return;
			}
			
		}
        /**
        *   source:selp.@0009.script
        */
        public void sureBtn4(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			log.info("{}","current line selected is ="+index );
			int length = this.getTmplst3().fullSize();
			log.info("{}","size of tmplst3 is ="+length);
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000355"),MdaUtils.getI18NString("selp","CT000356"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst3().getElement(index).getTrsinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0010.script
        */
        public void queryList(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//查询List列表数据 tmplst
			MdaUtils.clear(this.getTmplst());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,dat,cur,amt,bennam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst().add(trsinr,ref,dat,cur,amt,bennam);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:selp.@0011.script
        */
        public void queryBtn5(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> aplnam = new Argument<String>("aplnam");
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,dat,cur,amt,aplnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst().add(trsinr,ref,dat,cur,amt,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:selp.@0012.script
        */
        public void queryBtn6(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst1());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> aplnam = new Argument<String>("aplnam");
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,ref,dat,cur,amt,aplnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst1().add(trsinr,ref,dat,cur,amt,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			
		}
        /**
        *   source:selp.@0013.script
        */
        public void sureBtn00(String grpNam, String toTrs)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  @return 跳转到下一交易
			  @param grpNam 要传入数据的Module名称，如brdgrp，lidgrp
			  @param toTrs 要跳转到的交易名称，如brtsnd，litame
			  */
			//选中list一条记录中与之相关的表的记录，然后将参号传给chain到的页面，并将信息回填。
			int index = 0;
			int length = this.getTmplst().fullSize();
			if( index<0   ||   index >= length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000403"),MdaUtils.getI18NString("selp","CT000404"));
			  return;
			}
			//取到选中记录的inr号，并传给跳转到的交易页面
			IModule grp = MdaDriver.getModule(ctx.getRoot(),grpNam+"\\rec");
			ctx.getDaoSession().dbRead(grp,new Argument<String>("inr",this.getTmplst().getElement(index).getPinr()));
			ctx.getErrorCode();
			ctx.storeData("com.brilliance."+ toTrs +".ref",grp);
			
		}
        /**
        *   source:selp.@0014.script
        */
        public void queryBtn00(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> pinr = new Argument<String>("pinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			//Argument<String> lcref = new Argument<String>("lcref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> aplnam = new Argument<String>("aplnam");
			/*
			  Argument<String> benadr = new Argument<String>("benadr");
			  Argument<String> bentel = new Argument<String>("bentel");
			  Argument<String> benfax = new Argument<String>("benfax");
			  */
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,pinr,ref,dat,cur,amt,bennam,aplnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst().add(trsinr,pinr,ref,dat,cur,amt,bennam,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if($tmplst.fullSize() == 0)
			  {
			  return;
			  }
			  */
			
		}
        /**
        *   source:selp.@0015.script
        */
        public void queryBtn01(String queryClause)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//"二期增加参号、申请人信息两个栏位，并且信用证编号展示的是Stlref或商行信用证号"
			MdaUtils.clear(this.getTmplst1());
			if(!MdaUtils.isEmpty(this.getRef()))
			{
			  queryClause = queryClause + " AND stlref LIKE '%" + this.getRef() + "%'";
			}
			//按时间排序
			if(queryClause.contains("rec.opndat"))
			  queryClause = queryClause + " order by rec.opndat desc ";
			else if(queryClause.contains("rec.rcvdat"))
			  queryClause = queryClause + " order by rec.rcvdat desc ";
			else if(queryClause.contains("rec.credat"))
			  queryClause = queryClause + " order by rec.credat desc ";
			else if(queryClause.contains("rec.disdat"))
			  queryClause = queryClause + " order by rec.disdat desc ";
			else if(queryClause.contains("rec.advdat"))
			  queryClause = queryClause + " order by rec.advdat desc ";
			ctx.getDaoSession().dbExecuteSQL(queryClause);
			int tmp = ctx.getErrorCode();
			log.info("{}","最终执行的queryClause语句==========" + queryClause);
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> pinr = new Argument<String>("pinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			//Argument<String> lcref = new Argument<String>("lcref");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> bennam = new Argument<String>("bennam");
			Argument<String> aplnam = new Argument<String>("aplnam");
			/*
			  Argument<String> benadr = new Argument<String>("benadr");
			  Argument<String> bentel = new Argument<String>("bentel");
			  Argument<String> benfax = new Argument<String>("benfax");
			  */
			while(true)
			{
			  //Platform.dbFetchFields(trsinr,ref,lcref,cur,amt,dat,bennam,benadr,bentel,benfax);
			  ctx.getDaoSession().dbFetchFields(trsinr,pinr,ref,dat,cur,amt,bennam,aplnam);
			  int errorCode = ctx.getErrorCode();
			  if(errorCode == NO_ERROR)
			  {
			    this.getTmplst1().add(trsinr,pinr,ref,dat,cur,amt,bennam,aplnam);
			    //$tmplst.add(trsinr,ref,lcref,cur,amt,dat,aplnam,apladr,apltel,aplfax,bennam,benadr,bentel,benfax);
			  }
			  else if(errorCode == ERROR_SQL)
			  {
			    break;
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if($tmplst.fullSize() == 0)
			  {
			  return;
			  }
			  */
			
		}
        /**
        *   source:selp.@0018.script
        */
        public boolean queryBtnApp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getErrorCode();
			MdaUtils.clear(this.getTmplst());

			//String queryClause = "select rec.inr as trsinr,rec.stlref ref,rec.remcur cur,rec.remamt amt,rec.advdat dat,p.adrblk aplnam FROM cpd rec,pts p  "
			// +" where rec.dty = 'O' AND p.rol = 'apl' AND p.objtyp = 'cpd' AND p.objinr = rec.inr "
			// + $\\sysmod.getSelection();
			
			String queryClause = "WHERE m1.dty = 'O' AND m2.rol = 'apl' AND m2.objtyp = 'cpd' AND m2.objinr = m1.inr   AND m1.ptyinr=?";

			MdaUtils.clear(this.getTmplst());
			List objs = new ArrayList();
			objs.add(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr());
			if(!MdaUtils.isEmpty(this.getBegdat()))
			{
			  queryClause = queryClause +" AND m1.advdat >= ? ";
			  objs.add(MdaUtils.sqlDate(this.getBegdat(),GT));
			  log.info("{}","开始日期："+this.getBegdat());
			}
			if(!MdaUtils.isEmpty(this.getEnddat()))
			{
			  queryClause = queryClause +" AND m1.advdat <= ? ";
			  objs.add(MdaUtils.sqlDate(this.getEnddat(),LT));
			  log.info("{}","结束日期："+this.getEnddat());
			}
			if(!MdaUtils.isEmpty(this.getOrder())&&"1".equals(this.getOrder()))
			{
			  queryClause = queryClause +" ORDER BY m1.advdat ASC ";
			}
			else
			{
			  queryClause = queryClause +"ORDER BY m1.advdat DESC ";
			}

			ctx.getDaoSession().dbReadset(new IModuleList[]{this.getCpdlst(),this.getPtslst()},new CacheOption(0, true),queryClause,objs.toArray());
			if(ctx.getErrorCode()!=NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("selp","CT000458"),MdaUtils.getI18NString("selp","CT000459"));
			  return false;
			}
			int size=this.getCpdlst().size();
			this.getTmplst().setFullSize(this.getCpdlst().fullSize());
			log.info("{}","size :"+this.getCpdlst().size());
			Argument<String> trsinr = new Argument<String>("trsinr");
			Argument<String> ref = new Argument<String>("ref");
			Argument<Date> dat = new Argument<Date>("dat");
			Argument<String> cur = new Argument<String>("cur");
			Argument<BigDecimal> amt = new Argument<BigDecimal>("amt");
			Argument<String> aplnam = new Argument<String>("aplnam");
			Argument<String> ownref = new Argument<String>("ownref");
			Argument<String> kjhkflg = new Argument<String>("kjhkflg");
			for(int i=0; i<this.getCpdlst().size(); i++)
			{
			  trsinr.setValue(this.getCpdlst().getElement(i).getInr());
			  ref.setValue(this.getCpdlst().getElement(i).getStlref());
			  dat.setValue(this.getCpdlst().getElement(i).getAdvdat());
			  cur.setValue(this.getCpdlst().getElement(i).getRemcur());
			  amt.setValue(this.getCpdlst().getElement(i).getRemamt());
			  aplnam.setValue(this.getPtslst().getElement(i).getAdrblk());
			  ownref.setValue(this.getCpdlst().getElement(i).getOwnref());
			  kjhkflg.setValue(this.getCpdlst().getElement(i).getKjhkflg());
			  log.info("{}","ownref :"+ownref.value);
			  this.getTmplst().add(trsinr,ref,dat,cur,amt,aplnam,ownref,kjhkflg);
			}

			
			return true;
		}



































}