package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 数字签名工作流
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sigsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sigsvr.class);



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfs> wfs;


		public Sigsvr()
        {
            super();
            setArgument();
        }

        public Sigsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:sigsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," in... signature check...");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM trn WHERE relreq=relres AND inr='"
			  +this.getWfs().getObjinr()+"'");
			ctx.getDaoSession().dbFetchFields(new Argument<String>("inr"));
			int retcode=ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			if(retcode==NO_ERROR)
			{
			  ctx.getDaoSession().dbBegin();
			  this.getWfe().setSta("D");
			  ctx.getDaoSession().dbUpdate(this.getWfe());
			  //update next step svr state form 'O' to 'W'
			  ctx.getDaoSession().dbCommit();
			  ctx.absGet(Trnmod.class).updateNextSvrState("S");
			  log.debug("{}","Execute sig succeed!");
			  return true;
			}
			else
			{
			  log.debug("{}","Signature is not match.trn.inr="+this.getWfs().getObjinr());
			  return false;
			}
		}

        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setWfsHolder(ModuleHolder<Wfs> wfs)
        {
           this.wfs = wfs;
        }

        public Wfs getWfs()
        {
           return this.wfs.get();
        }

}