package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Msg;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 发送短信通知工作流
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Smssvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Smssvr.class);

        //temp stream
        private IStream temstm = new StreamImpl();



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Msg> msg;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Spt> spt;


		public Smssvr()
        {
            super();
            setArgument();
        }

        public Smssvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:smssvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," in smssvr.doHandle ... ") ;
			if(MdaUtils.isEmpty(this.getSpt().getInr()))
			  return Platform.errorHandle(this.getWfe(),"SPT is null");
			String grptyp=this.getSpt().getObjtyp();
			if(MdaUtils.isEmpty(grptyp))
			  return Platform.errorHandle(this.getWfe(),"module is null");
			//考虑到 XML和TCO报文， mgrtsk使用 bimenu模块映射，mgwtsk使用 xmlmap模块映射
			IModule mod = null;
			if(! ignoreSMSServerice(grptyp))
			{
			  mod=MdaDriver.getModule(this,ctx.getRoot(),"bimenu\\"+grptyp+"grp");
			}
			else
			{
			  int errcod = ctx.getErrorCode();
			  log.debug("{}","errcod = " + errcod );
			  log.debug("{}","获取模块 bimenu失败， ErrorCode = " + errcod) ;
			  mod = MdaDriver.getModule(this,ctx.getRoot(),"xmlmap\\"+grptyp+"grp");
			}
			MdaUtils.clear(mod);
			//String path=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"delete");
			//String filename=Platform.catPath(path,$spt\\inr.getValue()+".bak");
			String filename=ctx.absGet(Sysmod.class).createFilename(this.getSpt().getInr(),"bak");
			log.debug("{}"," filename = " + filename);
			if(!MdaUtils.fileExists(filename))
			  return Platform.errorHandle(this.getWfe(),"File is not exists");
			IStream is=this.getTemstm();
			MdaUtils.streamLoad(is,filename);
			MdaUtils.loadData(mod,is);
			ctx.getDaoSession().dbRead(this.getMsg(),new Argument<String>("inr",this.getWfe().getSrvtxt()));
			if(ctx.getErrorCode()!=NO_ERROR)
			  return Platform.errorHandle(this.getWfe(),"Msg load error");  // FIXME
			String phoneNo=this.getWfe().getTxt();
			//单一窗口业务
			if("cpd".equals(this.getSpt().getObjtyp()))
			  ctx.getDaoSession().dbRead(ctx.absGet(Bimenu.class).getCpdgrp().getRec(),new Argument<String>("ownref",this.getSpt().getOwnref()));
			if(ctx.getErrorCode()==NO_ERROR && "D".equals(ctx.absGet(Bimenu.class).getCpdgrp().getRec().getCpdres()) && MdaUtils.isEmpty(ctx.absGet(Bimenu.class).getCpdgrp().getRec().getNoticephone()))
			  phoneNo=ctx.absGet(Bimenu.class).getCpdgrp().getRec().getNoticephone();

			if(MdaUtils.isEmpty(phoneNo))
			  return Platform.errorHandle(this.getWfe(),"手机号码不能为空！");  // FIXME
			log.info("{}","phone no="+phoneNo+",frm="+this.getMsg().getFrm());
			if(phoneNo.contains(","))
			{
			  String[] phone=phoneNo.split(",");
			  if(ctx.absGet(Sysmod.class).sendSMSP(phone[0],this.getMsg().getFrm(),true) && ctx.absGet(Sysmod.class).sendSMSP(phone[1],this.getMsg().getFrm(),true))
			  {
			    log.debug("{}","短信发送成功！");
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    //$\\trnmod.updateNextSvrState("M");
			    log.debug("{}"," end eps2 smssvr.doHandleBank ... ") ;
			    return true;
			  }
			}
			else
			{
			  if(ctx.absGet(Sysmod.class).sendSMSP(phoneNo,this.getMsg().getFrm(),true))
			  {
			    log.debug("{}","短信发送成功！");
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    //$\\trnmod.updateNextSvrState("M");
			    log.debug("{}"," end eps smssvr.doHandleBank ... ") ;
			    return true;
			  }
			}
			//if($\\sysmod.sendSMS(phoneNo,$msg\\frm.getValue(),true))
			/*if($\\sysmod.sendSMSP(phoneNo,$msg\\frm.getValue(),true))
			  {
			  log.debug("短信发送成功！");
			  Platform.dbBegin();
			  $wfe\\sta.setValue("D");
			  Platform.dbUpdate($wfe);
			  Platform.dbCommit();
			  log.debug(" end 1 smssvr.doHandle ... ") ;
			  return true;
			  }*/
			return Platform.errorHandle(this.getWfe(),"发送失败！");  // FIXME
					}
        /**
        *   source:smssvr.@0002.script
        */
        public boolean ignoreSMSServerice(String grptyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean ignore = false ;
			if(!MdaUtils.isEmpty(grptyp) && ("rpd".equals(grptyp) || "ers".equals(grptyp)) )
			{
			  ignore = true ;
			}
			return ignore;
		}
        /**
        *   source:smssvr.@0003.script
        */
        public boolean doHandleBank()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," in smssvr.doHandleBank ... ") ;
			ctx.getDaoSession().dbRead(this.getMsg(),new Argument<String>("ptyinr",this.getWfe().getSrvtxt()),new Argument<String>("frm",this.getWfe().getTxt()));
			if(ctx.getErrorCode()!=NO_ERROR)
			  return Platform.errorHandle(this.getWfe(),"Msg load error");  // FIXME
			String phoneNo=this.getMsg().getMobile();
			if(MdaUtils.isEmpty(phoneNo))
			  return Platform.errorHandle(this.getWfe(),"手机号码不能为空！");  // FIXME
			log.info("{}","phone no="+phoneNo+",frm="+this.getMsg().getFrm());
			if(phoneNo.contains(";"))
			{
			  String[] phone=phoneNo.split(";");
			  if(ctx.absGet(Sysmod.class).sendSMSP(phone[0],this.getMsg().getFrm(),true) && ctx.absGet(Sysmod.class).sendSMSP(phone[1],this.getMsg().getFrm(),true))
			  {
			    log.debug("{}","短信发送成功！");
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    ctx.absGet(Trnmod.class).updateNextSvrState("N");
			    log.debug("{}"," end 2 smssvr.doHandleBank ... ") ;
			    return true;
			  }
			}
			else
			{
			  if(ctx.absGet(Sysmod.class).sendSMSP(phoneNo,this.getMsg().getFrm(),true))
			  {
			    log.debug("{}","短信发送成功！");
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    ctx.absGet(Trnmod.class).updateNextSvrState("N");
			    log.debug("{}"," end smssvr.doHandleBank ... ") ;
			    return true;
			  }
			}
			/*if(phoneNo.contains(";"))
			  {
			  String[] phone=phoneNo.split(";");
			  if($\\sysmod.sendSMS(phone[0],$msg\\frm.getValue(),true) && $\\sysmod.sendSMS(phone[1],$msg\\frm.getValue(),true))
			  {
			  Platform.dbBegin();
			  $wfe\\sta.setValue("D");
			  Platform.dbUpdate($wfe);
			  Platform.dbCommit();
			  $\\trnmod.updateNextSvrState("N");
			  log.debug(" end 2 smssvr.doHandleBank ... ") ;
			  return true;
			  }
			  }
			  else
			  {
			  if($\\sysmod.sendSMS(phoneNo,$msg\\frm.getValue(),true))
			  {
			  Platform.dbBegin();
			  $wfe\\sta.setValue("D");
			  Platform.dbUpdate($wfe);
			  Platform.dbCommit();
			  $\\trnmod.updateNextSvrState("N");
			  log.debug(" end smssvr.doHandleBank ... ") ;
			  return true;
			  }
			  }*/
			return Platform.errorHandle(this.getWfe(),"发送失败！");  // FIXME
					}

        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setMsgHolder(ModuleHolder<Msg> msg)
        {
           this.msg = msg;
        }

        public Msg getMsg()
        {
           return this.msg.get();
        }

        public void setSptHolder(ModuleHolder<Spt> spt)
        {
           this.spt = spt;
        }

        public Spt getSpt()
        {
           return this.spt.get();
        }



}