package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sptsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sptsvr.class);

        //temp stream
        private IStream tepstm = new StreamImpl();



	    @BDGetter
		private Spt wrkspt;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;


		public Sptsvr()
        {
            super();
            setArgument();
        }

        public Sptsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:sptsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","I am in spt service...");
			//#CT000000
			Argument<String> typ=new Argument<String>("ptytyp");
			if(MdaUtils.isEmpty(this.getWfe().getSrvtxt()))
			  return Platform.errorHandle(this.getWfe(),"Argument of service is empty.");
			if(MdaUtils.isEmpty(this.getWfe().getTxt()))
			  return Platform.errorHandle(this.getWfe(),"Argument of service is invalid.");

			this.getWrkspt().setFrm(this.getWfe().getTxt());
			this.getWrkspt().setOprogninr(this.getWfe().getSrvtxt());
			this.getWrkspt().setObjnam(this.getTrn().getObjnam());
			this.getWrkspt().setObjtyp(this.getTrn().getObjtyp());
			this.getWrkspt().setObjinr(this.getTrn().getObjinr());
			this.getWrkspt().setOwnref(this.getTrn().getOwnref());
			this.getWrkspt().setDattim(new Date());
			this.getWrkspt().setScr("S");
			this.getWrkspt().setScrtxt(this.getTrn().getInr());
			this.getWrkspt().setScrpty(this.getTrn().getOptptyinr());
			this.getWrkspt().setPtyinr(this.getTrn().getPtyinr());
			this.getWrkspt().setOrdinr(this.getTrn().getOrdinr());
			this.getWrkspt().setTrncur(this.getTrn().getReloricur());
			this.getWrkspt().setTrnamt(this.getTrn().getReloriamt());
			//String oprogn=getNextOprogn();
			String oprogn=this.getWrkspt().getOprogninr();
			if(MdaUtils.isEmpty(oprogn))
			  return Platform.errorHandle(this.getWfe(),"Organization inform is empty.");
			ctx.getDaoSession().dbExecuteSQL("SELECT ptytyp FROM pty WHERE inr='"+oprogn+"'");
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbFetchFields(typ);
			  ctx.getDaoSession().dbCloseCursor();
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return Platform.errorHandle(this.getWfe(),"Read organization error.");
			}
			String ogntyp=typ.value;

			ctx.getDaoSession().dbBegin();

			if("jstset".equals(this.getWrkspt().getFrm()) || "witame".equals(this.getWrkspt().getFrm()))
			{
			  if("jstset".equals(this.getWrkspt().getFrm()))
			  {
			    ctx.getDaoSession().dbRead(ctx.absGet(Bimenu.class).getJsdgrp().getRec(),new Argument<String>("inr",this.getWrkspt().getObjinr()));
			    if("3".equals(ctx.absGet(Bimenu.class).getJsdgrp().getRec().getJsdtyp()))
			      this.getWrkspt().setSta("M");
			    else
			      this.getWrkspt().setSta("T");
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(ctx.absGet(Bimenu.class).getWidgrp().getRec(),new Argument<String>("inr",this.getWrkspt().getObjinr()));
			    if("4".equals(ctx.absGet(Bimenu.class).getWidgrp().getRec().getQqywlx()))
			      this.getWrkspt().setSta("M");
			    else
			      this.getWrkspt().setSta("T");
			  }
			}
			else
			  this.getWrkspt().setSta("T");

			this.getWrkspt().setNxtlev("0");          //银行端初始授权状态
			log.debug("{}","值 nxtlev  =  "+this.getWrkspt().getNxtlev());
			this.getWrkspt().setOprusrinr("");
			this.getWrkspt().setSmhinr("");
			this.getWrkspt().setInr(Platform.sdbCounter("spt"));
			// 存储银行端复核级别
			String transName = this.getWrkspt().getFrm();
			if(ctx.absGet(Trnmod.class).isFinancingTransaction(this.getWrkspt().getFrm(),"2"))
			{
			  this.getWrkspt().setNxtfrm( ctx.absGet(Trnmod.class).getNextFrameToBank(this.getWrkspt().getFrm()));
			  this.getWrkspt().setRelreq( ctx.absGet(Trnmod.class).getReleaseMethodForBank(this.getWrkspt().getFrm(),this.getWfe().getSrvtxt(),this.getWrkspt().getNxtfrm()));
			  this.getWrkspt().setNxtreq( "O");
			}
			ctx.getDaoSession().dbInsert(this.getWrkspt());
			log.debug("{}","insert spt  成功！");
			if("0".equals(ogntyp))
			{
			  log.debug("{}","ognpty typ="+ogntyp+",copyZulData()");
			  copyZulData();
			}
			else
			{
			  log.debug("{}","ognpty typ="+ogntyp+",transTrnData()");
			  transTrnData();
			}
			this.getWfe().setSta("D");
			ctx.getDaoSession().dbUpdate(this.getWfe());
			log.info("{}","sta="+this.getWfe().getSta());
			//update next svr state
			
			//放锁
			/*if(!Platform.isEmpty($wfe\\inr))
			  {
			  Platform.dbUnlock(Platform.getLoginUser());
			  }*/

			ctx.getDaoSession().dbCommit();
			ctx.absGet(Trnmod.class).updateNextSvrState("P");
			log.info("{}","new sta="+this.getWfe().getSta());
			log.info("{}","Commit SPT OK!");
			return true;
		}
        /**
        *   source:sptsvr.@0001.script
        */
        public String getNextOprogn1()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  String bnkinr=$\\trnmod\\trn\\bnkinr.getValue();
			  String dir=$\\trnmod\\wfmmod\\wft\\dir.getValue();
			  if("0".equals(dir))
			  {
			  String req=$\\trnmod\\wfmmod\\wfd\\req.getValue();
			  if(!Platform.isEmpty(req))
			  {
			  int len=req.length();
			  if(len==2 && "13".equals(req))
			  {
			  return bnkinr;
			  }
			  if(len==3 && "123".equals(req))
			  {
			  String stp=$\\trnmod\\wfmmod\\wft\\stp.getValue();
			  if("1".equals(stp))
			  {
			  Argument<String> ogninr=new Argument<String>("inr");
			  String etyinr=$\\trnmod\\trn\\optetyinr.getValue();
			  Platform.dbExecuteSQL("SELECT inr FROM pty WHERE etyinr='"+etyinr+"'");
			  int errorcode=Platform.errorCode();
			  if(errorcode==NO_ERROR)
			  {
			  log.debug("ErrorCode:"+errorcode);
			  Platform.dbFetchFields(ogninr);
			  errorcode=Platform.errorCode();
			  if(errorcode==NO_ERROR)
			  {
			  Platform.dbCloseCursor();
			  return ogninr.value.toString();
			  }
			  else
			  {
			  Platform.dbCloseCursor();
			  log.debug("dbFetchFields(ogninr) wrong!");
			  return null;
			  }
			  }
			  else
			  {
			  log.info("dbExecuteSQL wrong");
			  return null;
			  }
			  }
			  else
			  {
			  if("2".equals(stp))
			  {
			  return bnkinr;
			  }
			  else
			  {
			  return null;
			  }
			  }
			  }
			  }
			  else
			  {
			  log.info("the wfd.req is null,can't continue...");
			  return null;
			  }
			  }
			  else
			  {
			  String rpl=$\\trnmod\\wfmmod\\wfd\\rpl.getValue();
			  int len=rpl.length();
			  //if(len==2 && rpl="" )
			  return null;
			  }
			  */
			return null;
		}
        /**
        *   source:sptsvr.@0002.script
        */
        public String getNextFrm()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String frm=ctx.absGet(Trnmod.class).getTrn().getInifrm();
			String dir=ctx.absGet(Trnmod.class).getWfmmod().getWft().getDir();
			String stp=ctx.absGet(Trnmod.class).getWfmmod().getWft().getStp();
			int index=0;
			String next="";
			String sfrm="";
			String nextfrm="";
			if("0".equals(dir))
			{
			  String flow=ctx.absGet(Trnmod.class).getWfmmod().getWfd().getReq();
			  if("1".equals(stp))
			  {
			    ctx.setMessage("","what should i do as a bank?");
			  }
			  if("2".equals(stp))
			  {
			    index=flow.indexOf("2");
			    next=flow.substring(index+1,index+2);
			    sfrm=frm+"0"+next;
			    nextfrm=MdaUtils.getPropertyValue("transaction.properties",sfrm);

			  }
			  if("3".equals(stp))
			  {
			    index=flow.indexOf("3");
			    next=flow.substring(index+1,index+2);
			    sfrm=frm+"0"+next;
			    nextfrm=MdaUtils.getPropertyValue("transaction.properties",sfrm);
			    return nextfrm;
			  }
			}
			else
			{
			  String flow=ctx.absGet(Trnmod.class).getWfmmod().getWfd().getRpl();
			  if("1".equals(stp))
			  {
			  }
			  if("2".equals(stp))
			  {
			  }
			  if("3".equals(stp))
			  {
			  }
			}
			return nextfrm;
		}
        /**
        *   source:sptsvr.@0003.script
        */
        public void transTrnData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 20150311 MOD BY DG
			//String filename=$\\trnmod\\trn\\inr.getValue()+".dat";
			//String trnpath=null;
			//trnpath=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"trndata");
			//filename=Platform.catPath(trnpath,filename);
			String filename=ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Trnmod.class).getTrn().getInr(),"dat");
			log.info("{}",filename);
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("sptsvr","CT000004"));
			  ctx.getDaoSession().dbRollback();
			  return;
			}
			//String tarfile=$wrkspt\\inr.getValue()+".bak";
			//String sptpath=null;
			//sptpath=Platform.catPath(Platform.catPath(Platform.getRootPath(),"data"),"delete");
			//tarfile=Platform.catPath(sptpath,tarfile);
			String tarfile=ctx.absGet(Sysmod.class).createFilename(this.getWrkspt().getInr(),"bak");
			log.info("{}","tarfile path="+tarfile);
			IStream ts=this.getTepstm();
			MdaUtils.streamLoad(ts,filename);
			MdaUtils.streamSave(ts,tarfile);
		}
        /**
        *   source:sptsvr.@0004.script
        */
        public void copyZulData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String target=null;
			String rootpath=ctx.getEnvConfig().getRootPath();
			//String filename=$\\trnmod\\trn\\inr.getValue()+".zul";
			//filename=Platform.catPath(Platform.catPath(Platform.catPath(rootpath,"data"),"dsp"),filename);
			String filename = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Trnmod.class).getTrn().getInr(),"zul");
			if(!MdaUtils.fileExists(filename))
			{
			  log.info("{}","file no exist!");
			  return;
			}
			//target=Platform.catPath(Platform.catPath(Platform.catPath(Platform.catPath(rootpath,"data"),"dsp"),"release"),$wrkspt\\inr.getValue()+".zul");
			target=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(rootpath,"data"),"dsp"),"release"),this.getWrkspt().getInr().substring(0,4)),this.getWrkspt().getInr()+".zul");
			MdaUtils.fileCopy(filename,target);
		}
        /**
        *   source:sptsvr.@0005.script
        */
        public boolean isTcoIgnore(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String filename=MdaUtils.catPath(path,"msg.properties");
			String tvalue=null;
			if(MdaUtils.fileExists(filename))
			{
			  tvalue=MdaUtils.getPropertyValue(filename,trnname);
			  if("y".equals(tvalue))
			    return true;
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("sptsvr","CT000005"),MdaUtils.getI18NString("sptsvr","CT000006"));
			return false;
		}



        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }



}