package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Ptr;
import com.ceb.gjjs.mda.bo.Swmsg;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Swmmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Swmmod.class);



	    @BDGetter
		private Swmsg swmsg;

	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Ptr ptr;

		@BDGetter
		private ModuleList<Ptr> ptrlst;


		public Swmmod()
        {
            super();
            setArgument();
        }

        public Swmmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:swmmod.@0000.script
        */
        public void storeSWM(String msgcod,String srcinr,String objtyp,Map msgcontent)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//msgcod :SFSXXX
			//srcinr:原业务 inr
			//msgcontent:实际报文内容
			String msgid = (String)msgcontent.get("MsgID");
			msgid = msgcod+msgid;
			log.info("{}","msg filename :"+msgid);
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(msgcontent);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"swmsg"),datstr);
			String inr = Platform.sdbCounter("swmsg");
			path = MdaUtils.catPath(path,msgid+".dat");
			java.io.File file = new java.io.File(path);
			if (!file.getParentFile().exists())
			{
			  file.getParentFile().mkdirs();
			}
			if (!file.exists())
			{
			  try
			  {
			    file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			    log.error("{}","*****  文件创建失败！");
			    log.error("{}",e.toString());
			  }
			}
			MdaUtils.saveContent(sendContent,path,"utf-8");
			log.info("{}","path="+path);
			log.info("{}","swmsg :"+sendContent);
			MdaUtils.clear(this.getSwmsg());
			this.getSwmsg().setInr(inr);
			this.getSwmsg().setMsgpath(path);
			this.getSwmsg().setCnt(0);
			this.getSwmsg().setSta("W");
			this.getSwmsg().setMsgcod(msgcod);
			this.getSwmsg().setCredat(MdaUtils.today());
			this.getSwmsg().setTrans(ctx.getTransName());
			this.getSwmsg().setObjinr(srcinr);
			this.getSwmsg().setObjtyp(objtyp);
			ctx.getDaoSession().dbInsert(this.getSwmsg());

			log.debug("{}","swmsg inr is"+this.getSwmsg().getInr());
		}









}