package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sysfil extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sysfil.class);

        //路径
        private String filpth;

        //上传
        private IStream upl = new StreamImpl();

        //下载
        private IStream dwn = new StreamImpl();

        //返回
        private transient IControl rtn1 = new ControlImpl("rtn1", "返回", this);

        //打开路径
        private transient IControl opn = new ControlImpl("opn", "打开路径", this);

        //上一层
        private transient IControl up = new ControlImpl("up", "上一层", this);

        //确定
        private transient IControl ok = new ControlImpl("ok", "确定", this);

        //返回
        private transient IControl rtn2 = new ControlImpl("rtn2", "返回", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //选择
        private transient IControl sel = new ControlImpl("sel", "选择", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel mainp;

        @JsonIgnore
        @BDGetter
        private transient IPanel head;

        @JsonIgnore
        @BDGetter
        private transient IPanel center;

        @JsonIgnore
        @BDGetter
        private transient IPanel pthp;

        @JsonIgnore
        @BDGetter
        private transient IPanel btnp;


		@BDGetter
		private ModuleList<Fil> fillst;

		@BDGetter
		private ModuleList<Cfg> cfglst;


		public Sysfil()
        {
            super();
            setArgument();
        }

        public Sysfil(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sysfil.@0005.script
        */
        @Rule(target="dwn",order=100)
        public boolean ruleDwnN100(){
            IContext ctx = MdaEnv.getContext();
            
			List<String> filList = new ArrayList<String>();
			for(int i = 0; i < this.getFillst().size(); i ++)
			{
			  if("X".equals(this.getFillst().getElement(i).getFlg()))
			  {
			    filList.add(this.getFillst().getElement(i).getAbspth());
			  }
			}
			if(filList.isEmpty())
			  return true;
			IStream os = this.getDwn();
			java.io.OutputStream out = null;
			try
			{
			  out = os.getOutputStream();

			}
			catch(Exception ex)
			{
			  log.error("{}",ex);
			  return false;
			}
			if(filList.size() == 1)
			{
			  String dwnFileName = filList.get(0);
			  log.debug("{}","Downloading single file:" + dwnFileName);
			  java.io.File theFile = new java.io.File(dwnFileName);
			  if(theFile.isFile())
			  {
			    os.setName(theFile.getName());
			    os.setType(MdaUtils.fileExtension(dwnFileName));
			    MdaUtils.streamLoad(os,dwnFileName);
			  }
			}
			else
			{
			  log.debug("{}","Ziping...");
			  try
			  {
			    java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(out);
			    os.setName("download" + Platform.formatDateTime(MdaUtils.today(),"yyyy-MM-dd"));
			    os.setType(".zip");
			    for(String fileName: filList)
			    {
			      log.debug("{}","=>Add Entry :" + fileName);
			      this.zip(new java.io.File(fileName), zos, "");
			    }
			    zos.flush();
			    zos.close();

			  }
			  catch(Exception exx)
			  {
			    log.error("{}",exx);
			  }
			  finally
			  {

			  }
			}


			return true;
        }

        /**
        *   source:sysfil.@0006.script
        */
        @Rule(target="fillst",order=100)
        public boolean ruleFillstN100(){
            IContext ctx = MdaEnv.getContext();
            
			int idx = 0;
			if(idx < 0)
			  return false;
			if(!"Folder".equals(this.getFillst().getElement(idx).getFiltyp()))
			  return false;
			String url = MdaUtils.catPath(this.getFilpth(),this.getFillst().getElement(idx).getFilnam());
			if(dirAuthorCheck(url))
			{
			  if(this.openUrl(url))
			  {
			    this.setFilpth( url);
			    
			  }
			}

			return true;
        }

        /**
        *   source:sysfil.@0007.script
        */
        @Rule(target="opn",order=100)
        public boolean ruleOpnN100(){
            IContext ctx = MdaEnv.getContext();
            
			///打开路径
			if(MdaUtils.isEmpty(this.getFilpth()))
			  return false;
			String url = this.getFilpth();
			if(dirAuthorCheck(url))
			  openUrl(url);

			return true;
        }

        /**
        *   source:sysfil.@0008.script
        */
        @Rule(target="up",order=100)
        public boolean ruleUpN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getFilpth()))
			  return false;
			String url = this.getFilpth();
			if(!MdaUtils.fileExists(url))
			  return false;
			java.io.File file = new java.io.File(url);
			java.io.File    parFile = file.getParentFile();
			if(parFile == null)
			  return false;
			url = parFile. getAbsolutePath();
			if(dirAuthorCheck(url))
			{
			  this.setFilpth( url);
			  
			  this.openUrl(url);
			}

			return true;
        }

        /**
        *   source:sysfil.@0009.script
        */
        @Rule(target="upl",order=100)
        public boolean ruleUplN100(){
            IContext ctx = MdaEnv.getContext();
            
			///上传文件
			if(MdaUtils.isEmpty(this.getFilpth()))
			  return false;
			String url = this.getFilpth();
			if(!MdaUtils.fileExists(url))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sysfil","CT000007"),MdaUtils.getI18NString("sysfil","CT000008"));
			  return false;
			}
			IStream is = this.getUpl();
			String nam=is.getName();
			//String custom = Platform.catPath(Platform.getRootPath(), "cfg/sysixu.properties");
			//判断黑白名单开关
			if(dirAuthorCheck(url))
			{
			  //检索配置中是否存在当前路径,否则提示
			  if(MdaUtils.isEmpty(getPropertiesWithCon("path",url,true)))
			  {
			    if(MdaUtils.prompt(MdaUtils.getI18NString("sysfil","CT000009"),MdaUtils.getI18NString("sysfil","CT000010")))
			      return false;
			  }
			}
			else
			{
			  return false;
			}

			String targetFile = MdaUtils.catPath(url,nam);
			log.debug("{}","Uploading :" + targetFile);
			log.error("{}","Uploading :" + targetFile);
			MdaUtils.streamSave(is,targetFile);

			return true;
        }




        /**
        *   source:sysfil.@0000.script
        */
        public void copyStream(java.io.InputStream is, java.io.OutputStream os)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//从is向os复制
			try
			{
			  org.apache.commons.io.IOUtils.copy(is, os);
			}
			catch(Exception ex)
			{
			  log.error("{}",ex);
			}
			//无条件关闭stream
			finally
			{
			  org.apache.commons.io.IOUtils.closeQuietly(is);
			  org.apache.commons.io.IOUtils.closeQuietly(os);
			}
		}
        /**
        *   source:sysfil.@0001.script
        */
        public boolean openUrl(String url)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///浏览一个文件路径
			
			if(!MdaUtils.fileExists(url))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sysfil","CT000005"),MdaUtils.getI18NString("sysfil","CT000006"));
			  return false;
			}
			java.io.File openFile = new java.io.File(url);
			java.io.File[] files = openFile.listFiles();
			log.debug("{}","url " + url);
			log.debug("{}","files:" + files);
			this.getFillst().removeAll();
			for(java.io.File file:files)
			{
			  com.ceb.gjjs.mda.manager.module.Fil fil1 = 	this.getFillst().add();
			  fil1.setFilnam( file.getName());
			  fil1.setAbspth( file.getAbsolutePath());
			  //String icon = "";
			  if(file.isFile())
			  {
			    fil1.setFiltyp( "File");
			    fil1.setSize( file.length());
			    
			    fil1.setIcon( null);
			  }
			  else if(file.isDirectory())
			  {
			    fil1.setFiltyp( "Folder");
			    
			  }
			  long lastModified = file.lastModified();
			  fil1.setAmedat( new Date(lastModified));
			}
			
			return true;
		}
        /**
        *   source:sysfil.@0002.script
        */
        public void zip(java.io.File file,  java.util.zip.ZipOutputStream out, String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//zip格式压缩文件/文件夹
			if (file.isDirectory())
			{
			  this.zipFolder(file, out, path);
			}
			else
			{
			  this.zipFile(file, out, path);
			}
		}
        /**
        *   source:sysfil.@0003.script
        */
        public void zipFile(java.io.File file,  java.util.zip.ZipOutputStream out, String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if (!file.exists())
			  return;
			try
			{
			  java.io.BufferedInputStream bis = new java.io.BufferedInputStream(
			    new java.io.FileInputStream(file));
			  java.util.zip.ZipEntry entry = new java.util.zip.ZipEntry(path + file.getName());
			  out.putNextEntry(entry);
			  int count;
			  byte data[] = new byte[1024];
			  while ((count = bis.read(data, 0, 1024)) != -1)
			  {
			    out.write(data, 0, count);
			  }
			  bis.close();
			}
			catch (Exception ex)
			{
			  log.error("{}",ex);
			}
		}
        /**
        *   source:sysfil.@0004.script
        */
        public void zipFolder(java.io.File dir,  java.util.zip.ZipOutputStream out, String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if (!dir.exists())
			  return;
			java.io.File[] files = dir.listFiles();
			for (int i = 0; i < files.length; i++)
			  zipFile(files[i], out, path + dir.getName() + "/");
		}
        /**
        *   source:sysfil.@0010.script
        */
        public List getPropertiesWithCon(String pthtype,String content,Boolean fullsize)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据条件sysixu.properties配置列表
			//pthtype = "path","whitePath","blackPath",etc,properties文件节点名
			//content 非空按照内容筛选，为空取全量
			//sizetype = true 全列表,false 只获取第一条用于校验
			String custom = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/sysixu.properties");
			int i = 1;
			content = content.replaceAll("\\\\","/");
			boolean flg= true;
			List<String> valuelst =new ArrayList<String>();
			while(true)
			{
			  String cfgvalue = MdaUtils.getPropertyValue(custom,i + "."+pthtype);
			  if(cfgvalue.equals("+end+")||i>=100)
			  {
			    break;
			  }
			  else
			  {
			    if(MdaUtils.isEmpty(content))
			    {
			      valuelst.add(cfgvalue);
			      if (fullsize == false)
			        break;
			    }
			    else
			    {
			      log.error("{}","message");
			      //带*采用模糊查询
			      if(cfgvalue.contains("*")&&content.contains(cfgvalue.replaceAll("\\*",""))||content.equals(cfgvalue))
			      {
			        valuelst.add(cfgvalue);
			        if (fullsize == false)
			          break;
			      }
			    }
			  }
			  i++;
			}
			return valuelst;
		}
        /**
        *   source:sysfil.@0011.script
        */
        public boolean dirAuthorCheck(String url)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//===linuxx需判断系统类型区分大小写todo
			url = url.toUpperCase();
			if(!MdaUtils.isEmpty(getPropertiesWithCon("whitePathSwitch","on",false)))
			{
			  //判断是否在白名单中
			  if(MdaUtils.isEmpty(getPropertiesWithCon("whitePath",url,false)))
			  {
			    MdaUtils.prompt(MdaUtils.getI18NString("sysfil","CT000083"),MdaUtils.getI18NString("sysfil","CT000084"));
			    return false;
			  }
			}
			//判断黑名单开关是否开启
			if(!MdaUtils.isEmpty(getPropertiesWithCon("blackPathSwitch","on",false)))
			{
			  //判断是否在黑名单中
			  if(!MdaUtils.isEmpty(getPropertiesWithCon("blackPath",url,false)))
			  {
			    MdaUtils.prompt(MdaUtils.getI18NString("sysfil","CT000085"),MdaUtils.getI18NString("sysfil","CT000086"));
			    return false;
			  }
			}
			return true;
		}

























}