package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Dztlog;
import com.ceb.gjjs.mda.bo.Pta;
import com.ceb.gjjs.mda.bo.Etg;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.bo.Dep;
import com.ceb.gjjs.mda.bo.Adr;
import com.ceb.gjjs.mda.bo.Ptr;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Pdfmod;
import com.ceb.gjjs.mda.bo.Usraut;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sysmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sysmod.class);

        //trn title
        private String trntiltle;

        //data ro pass pending data to storage
        private String sptdata;

        //ordinr
        private String ordinr;

        //是否是批量提交
        private String flg;

        //
        private Object bchcodvals;

        //是否自己提交的业务
        private String ownflg;

        //flg
        private String sig;

        //lastlogtim
        private Date lastlogtim;

        //是否批量授权
        private String authflg;

        //经办机构级别设置
        private Object oprbchlvl;

        //错误信息
        private String errtxt;

        //首页
        private transient IControl index = new ControlImpl("index", "首页", this);

        //退出
        private transient IControl logout = new ControlImpl("logout", "退出", this);

        //总行机构号
        private String headbchcod;

        //操作开始时间
        private Date oprstadat;

        //交易名称
        private String trdnam;

        //tmpdata
        private String tmpdata;

        //是否暂存
        private String pedflg;

        //平台类型
        private String cpno;



	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Usr usr;

	    @BDGetter
		private Rol rol;

	    @BDGetter
		private Ety ety;

	    @BDGetter
		private Etg etg;

	    @BDGetter
		private Dep dep;

	    @BDGetter
		private Spt spt;

	    @BDGetter
		private Usraut usraut;

	    @BDGetter
		private Ptr ptr;

	    @BDGetter
		private Bchmod bchmod;

	    @BDGetter
		private Pdfmod pdfmod;

	    @BDGetter
		private Frmmod frmmod;

	    @BDGetter
		private Itfmod itfmod;

	    @BDGetter
		private Dztlog dztlog;

	    @BDGetter
		private Pty bch;

	    @BDGetter
		private Pta pta;

	    @BDGetter
		private Adr adr;


		public Sysmod()
        {
            super();
            setArgument();
        }

        public Sysmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getBchmod().setPtyHolder(()->this.getPty());
            this.getPdfmod().setCidHolder( new FieldHolder<String>(){
				public String getPath(){return Sysmod.this.getFieldPath("pty.cid");}
 				public void setValue(String arg){Sysmod.this.getPty().setCid(arg);}
 				public String getValue(){return Sysmod.this.getPty().getCid();}}
			 );
        }

        /**
        *   source:sysmod.@0100.script
        */
        @Rule(target="logout",order=100)
        public boolean ruleLogoutN100(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.logout();

			return true;
        }

        /**
        *   source:sysmod.@0101.script
        */
        @Rule(target="index",order=100)
        public boolean ruleIndexN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }



        /**
        *   source:sysmod.@0001.script
        */
        @Init(order=1)
        public boolean	init1(){
            IContext ctx = MdaEnv.getContext();
            
			// 读取错误信息
			String errtxt = (String)Platform.getLoginData("errorText");
			log.debug("{}","errorText="+errtxt);
			if(!MdaUtils.isEmpty(errtxt))
			{
			  this.setErrtxt(errtxt);
			  
			}
			log.debug("{}",ctx.getTransName()+",usr.inr="+this.getUsr().getInr());
			if(MdaUtils.isEmpty(this.getUsr().getInr()))
			{
			  log.debug("{}","load usr and party info...");
			  //String usr=Platform.getLoginUser();
			  String usrinr=(String)Platform.getLoginData("usrinr");
			  loadUsrInfo(usrinr);
			  getAndSetBchcodvals();
			  //$bchcodvals.setValue(getBchcod($pty\\inr.getValue(),$pty\\ptytyp.getValue()));
			  // 初始化时从数据库获得经办机构级别设置
			  loadOprLvlSet();
			}
			else
			{
			  /*
			    log.info("list the bchcod values...");
			    Object object = $bchcodvals.getValue();
			    if(object!=null)
			    {
			    for(CodetableItem item:( List<CodetableItem>)object)
			    log.info(item.getValue());
			    }
			    */
			}

			return true;
        }


        /**
        *   source:sysmod.@0002.script
        */
        public String recGetObj(IModule rec)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return rec.getName();
		}
        /**
        *   source:sysmod.@0003.script
        */
        public String recGetInr(IModule rec)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return ((IDatafield<String>)rec.get("inr")).getValue();
		}
        /**
        *   source:sysmod.@0005.script
        */
        public void getEty(String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//load ety
			String etyinr=null;
			String sql=null;
			String ptyinr=this.getUsr().getPtyinr();
			;
			if("0".equals(ptytyp))
			{
			  //#CT000092
			  etyinr=this.getPty().getEtyinr();
			  if(MdaUtils.isEmpty(etyinr))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000093"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(this.getEty(),new Argument<String>("inr",etyinr));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			}
			if("1".equals(ptytyp))
			{
			  //#CT000094
			  //etyinr=$pty\\etyinr.getValue();
			  //if("".equals(etyinr))
			  //  Platform.showMessage("",#CT000095);
			  //  return;
			  //else
			  //  Platform.dbRead($ety,new Argument("inr",etyint));
			  ctx.getDaoSession().dbRead(this.getPtr(),new Argument<String>("preptyinr",ptyinr),new Argument<String>("ptrtyp","1"));
			  //if Platform.errorCode==0 or 2 ,error and cannot  continue
			  if(MdaUtils.isEmpty(this.getPtr().getInr()))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000096"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  ptyinr=this.getPtr().getNxtptyinr();
			  sql="SELECT etyinr FROM pty WHERE inr='"+ptyinr+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(new Argument<String>("etyinr",etyinr));
			  if(MdaUtils.isEmpty(etyinr))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000097"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(this.getEty(),new Argument<String>("inr",etyinr));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			}
			if("2".equals(ptytyp))
			{
			  //#CT000098
			  ctx.getDaoSession().dbRead(this.getPtr(),new Argument<String>("preptyinr",ptyinr),new Argument<String>("ptrtyp","0"));
			  //#CT000099
			  //if Platform.errorCode==0 or 2 ,error and cannot  continue
			  if(MdaUtils.isEmpty(this.getPtr().getInr()))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000100"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  ptyinr=this.getPtr().getNxtptyinr();
			  sql="SELECT etyinr FROM pty WHERE inr='"+ptyinr+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(new Argument<String>("etyinr",etyinr));
			  if(MdaUtils.isEmpty(etyinr))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000101"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(this.getEty(),new Argument<String>("inr",etyinr));
			    ctx.getDaoSession().dbCloseCursor();
			    return ;
			  }
			}
			if("3".equals(ptytyp))
			{
			  //#CT000102
			  ctx.getDaoSession().dbRead(this.getPtr(),new Argument<String>("preptyinr",ptyinr),new Argument<String>("ptrtyp","2"));
			  //if Platform.errorCode==0 or 2 ,error and cannot  continue
			  if(MdaUtils.isEmpty(this.getPtr().getInr()))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000103"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  ptyinr=this.getPtr().getNxtptyinr();
			  sql="SELECT etyinr FROM pty WHERE inr='"+ptyinr+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(new Argument<String>("etyinr",etyinr));
			  if(MdaUtils.isEmpty(etyinr))
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("sysmod","CT000107"));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else
			  {
			    ctx.getDaoSession().dbRead(this.getEty(),new Argument<String>("inr",etyinr));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			}
		}
        /**
        *   source:sysmod.@0006.script
        */
        public void streamSaveInSubdir(IStream stream,String dir,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String file= MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/"+dir+"/"+filename);
			MdaUtils.streamSave(stream,file);
		}
        /**
        *   source:sysmod.@0007.script
        */
        public void streamLoadInSubdir(IStream stream,String dir,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/"+dir+"/"+filename);
			MdaUtils.streamLoad(stream,file);
		}
        /**
        *   source:sysmod.@0009.script
        */
        public void saveDisplayFiles(IPanel[] panels ,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/dsp/"+filename);
			  ctx.saveDisplay(filepath);
		}
        /**
        *   source:sysmod.@0010.script
        */
        public void saveDisplayFile(IPanel panel ,String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/dsp/"+filename);
			  ctx.saveDisplay(filepath);
		}
        /**
        *   source:sysmod.@0011.script
        */
        public String getRefrence(String prefix)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 申请类交易的参号(格式：业务种类+申请时间+单证通系统的流水号，如LC-090817-0001)。
			  * @param prefx 前缀，详见需求说明书v1.2的3.8.4节。
			  */
			prefix = prefix + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			// 默认同类交易当天不会有10000条
			return prefix + MdaUtils.format(ctx.getDaoSession().dbCounter(prefix),"0000");
		}
        /**
        *   source:sysmod.@0012.script
        */
        public List<CodetableItem> getBchcod(String ptyinr,String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bchcod=new ArrayList<CodetableItem>();
			// 生成码表bchcod
			if(MdaUtils.isEmpty(ptytyp)  ||  MdaUtils.isEmpty(ptyinr))
			{
			  log.info("{}","party infomation is empty,return directly...");
			  return bchcod;
			}
			// pty表ptytyp字段标识1：商行机构2：本行企业；(3：商行下属企业，但只能提交给商行)
			String query="SELECT pty.cid cid,pty.nam nam FROM ptr,pty WHERE preptyinr='"
			  +ptyinr+"'  AND pty.inr = ptr.nxtptyinr AND pty.cid IS NOT NULL";
			// ptr表ptrtyp字段标识0：企业 兴业银行 落地机构；1：商行 兴业银行 落地机构；2:企业 商行 客户
			if("1".equals(ptytyp))
			  query = query + " AND ptrtyp = '1'"; //商行机构
			else if("2".equals(ptytyp))
			  query = query + " AND ptrtyp = '0'"; //本行企业落地机构
			else if("3".equals(ptytyp))
			  query = query + " AND ptrtyp = '2'";   //商行下属企业
			log.info("{}", "最后执行的query语句===========" + query);
			ctx.getDaoSession().dbExecuteSQL(query);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> cid = new Argument<String>("cid");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(nam,cid);
			  if(ctx.getErrorCode()==NO_ERROR)
			    bchcod.add(new CodetableItem(nam.value,cid.value));
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			return bchcod;
		}
        /**
        *   source:sysmod.@0013.script
        */
        public boolean sendSMS(String moble,String trsnam,boolean needdata)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String smsPath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			Map<String,Object> data= new HashMap<String,Object>();
			if(needdata)
			{
			  return (Boolean)MdaUtils.invoke("com.brilliance.etrade.message.SendMessage","sendSMS",MdaUtils.getI18nValue("message",trsnam+".SMS"),Platform.getValues(ctx.getRoot(),trsnam,"SMS"),moble);
			}
			else
			{
			  return (Boolean)MdaUtils.invoke("com.brilliance.etrade.message.SendMessage","sendSMS",MdaUtils.getI18nValue("message",trsnam+".SMS"),moble);
			}
		}
        /**
        *   source:sysmod.@0014.script
        */
        public String covCnAmt(BigDecimal amt ,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object cnAmt =MdaUtils.invoke("com.brilliance.etrade.covCnAndEnAmt.covAmt","covCnAmt",amt,cur);
			return cnAmt.toString();
		}
        /**
        *   source:sysmod.@0015.script
        */
        public String covEnAmt(BigDecimal amt ,String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Object enAmt =MdaUtils.invoke("com.brilliance.etrade.covCnAndEnAmt.covAmt","covEnAmt",amt,cur);
			return enAmt.toString();
		}
        /**
        *   source:sysmod.@0017.script
        */
        public boolean sendMail(String[] mailAdr ,String[] mailfile,String filepath,String trsnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String mailConPath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg")+"/";
			String mailPath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg")+"/";
			String subject=MdaUtils.getI18nValue("message",trsnam+".SUBJECT");
			String text=MdaUtils.getI18nValue("message",trsnam+".MAIL");
			return (Boolean)MdaUtils.invoke("com.brilliance.etrade.message.SendMessage","sendMailMessage",subject,text,Platform.getValues(ctx.getRoot(),trsnam,"MAIL"),mailAdr,mailfile,filepath);
		}
        /**
        *   source:sysmod.@0019.script
        */
        public void sdbUpdate(IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbLock("","");
			ctx.getDaoSession().dbUpdate(mod);
		}
        /**
        *   source:sysmod.@0020.script
        */
        public void sdbInsert(IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//Platform.dbLock("","");
			ctx.getDaoSession().dbInsert(mod);
		}
        /**
        *   source:sysmod.@0023.script
        */
        public void savORUPdateUserList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  //String ptyinr= $pty\\inr.getValue();
			  String ncid =$usr\\ncid.getValue();
			  String oid=$usr\\oid.getValue();
			  String ptyinr =$pty\\inr.getValue();
			  log.info( "oid=="+oid);
			  log.info( "ncid=="+ncid);
			  if(!"0".equals($usr\\otype.getValue()))
			  Platform.message(#CT000204,#CT000205);
			  String sessionId= (String)Platform.getLoginData("sessionId");
			  // String sessionId= (String)logCon.getValue("sessionId");
			  log.info( "sessionId=="+sessionId);
			  ArrayList<HashMap> list= (ArrayList<HashMap>)Platform.invoke("com.brilliance.etrade.auth.enterprise.webserviceclient.WebserviceUtils","getUserList",ncid,oid,sessionId);
			  if(list==null  ||  list.size()==0)
			  return;
			  Platform.dbBegin();
			  for (HashMap user:list)
			  {
			  Platform.dbRead($usrgrp,new Argument<String>("oid",user.get("Id").toString()));
			  if(user.get("Id")!=null)
			  {
			  $usrgrp\\oid.setValue(user.get("Id").toString());
			  }
			  if(user.get("Ncid")!=null)
			  {
			  $usrgrp\\ncid.setValue(user.get("Ncid").toString());
			  }
			  if(user.get("Name")!=null)
			  {
			  $usrgrp\\oprnam.setValue(user.get("Name").toString());
			  }
			  if(user.get("LoginName")!=null)
			  {
			  $usrgrp\\lgnnam.setValue(user.get("LoginName").toString());
			  }
			  if(user.get("Type")!=null)
			  {
			  $usrgrp\\otype.setValue(String.valueOf(user.get("Type")));
			  //log.info("type=="+type );
			  }
			  if(user.get("DepartMent")!=null)
			  {
			  $usrgrp\\depnam.setValue(user.get("DepartMent").toString());
			  }
			  if(user.get("CreateDate")!=null)
			  {
			  Date createDate = (Date)user.get("CreateDate");
			  //log.info("createDate=="+createDate );
			  }
			  if(user.get("Email")!=null)
			  {
			  $usrgrp\\eml.setValue(user.get("Email").toString());
			  }
			  Date updateTime=null;
			  if(user.get("UpdateTime")!=null)
			  {
			  updateTime = (Date)user.get("UpdateTime");
			  //$usrgrp\\logtim.setValue(updateTime);
			  }
			  if(user.get("Status")!=null)
			  {
			  String status = String.valueOf(user.get("Status"));
			  $usrgrp\\usrflg.setValue(status);
			  }
			  if(user.get("Tel")!=null)
			  {
			  String tel = user.get("Tel").toString();
			  }
			  if(ptyinr!=null)
			  {
			  $usrgrp\\ptyinr.setValue(ptyinr);
			  }
			  int rt = Platform.errorCode();
			  if(rt==NO_ERROR)
			  {
			  //DATE1在DATE2之前
			  if(!Platform.isEmpty(updateTime) && !Platform.isEmpty($usrgrp\\updtim) &&Platform.diff($usrgrp\\updtim.getValue(),updateTime)<0)
			  {
			  //return not null value
			  $usrgrp\\updtim.setValue(updateTime);
			  Platform.dbUpdate($usrgrp);
			  log.info("user"+$usrgrp\\lgnnam.getValue()+"updated!");
			  }
			  }
			  else if(rt==NO_MORE_ROW)
			  {
			  //return null
			  $usrgrp\\inr.setValue(Platform.sdbCounter("usr"));
			  $usrgrp\\updtim.setValue(updateTime);
			  Platform.dbInsert($usrgrp);
			  log.info("new user inserted:"+$usrgrp\\lgnnam.getValue()+"!");
			  }
			  else
			  {
			  //return Exception
			  log.info("sql Exception.");
			  }
			  log.info("oid==="+ $usrgrp\\oid.getValue());
			  log.info("inr==="+ $usrgrp\\inr.getValue());
			  }
			  Platform.dbCommit();
			  */
		}
        /**
        *   source:sysmod.@0024.script
        */
        public boolean loadUsrInfo(String usrinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","usrinr="+usrinr);
			ctx.getDaoSession().dbRead(this.getUsr(),new Argument<String>("inr",usrinr));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(this.getUsr().getLogtim()))
			    this.setLastlogtim(this.getUsr().getLogtim());
			  ctx.getDaoSession().dbBegin();
			  this.getUsr().setLogtim(MdaUtils.today());
			  ctx.getDaoSession().dbUpdate(this.getUsr());
			  ctx.getDaoSession().dbCommit();
			  ctx.getLocker().unlock(MdaEnv.getLoginUser());
			  log.info("{}","load usr OK! inr="+this.getUsr().getInr()+",ptyinr="+this.getUsr().getPtyinr());
			  ctx.getDaoSession().dbRead(this.getPty(),new Argument<String>("inr",this.getUsr().getPtyinr()));
			  errorcode=ctx.getErrorCode();
			  if(errorcode!=NO_ERROR)
			    return Platform.errorCloseCursor(MdaUtils.getI18NString("sysmod","CT000202"));
			}
			else if(errorcode==NO_MORE_ROW)
			  return Platform.errorCloseCursor(MdaUtils.getI18NString("sysmod","CT000205"));
			else
			  return Platform.errorCloseCursor(MdaUtils.getI18NString("sysmod","CT000206"));
			//
			if(!MdaUtils.isEmpty(this.getPty().getEtyinr()))
			{
			  sdbRead(this.getEty(),this.getPty().getEtyinr());
			  if(!MdaUtils.isEmpty(this.getEty().getInr()))
			    sdbRead(this.getEtg(),this.getEty().getEtginr());
			}
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}
        /**
        *   source:sysmod.@0025.script
        */
        public void sdbRead(IModule mod,String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr));
			int errorcode=ctx.getErrorCode();
			return;
		}
        /**
        *   source:sysmod.@0026.script
        */
        public boolean sptIsLoaded(String sptsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getSpt().getInr()))
			  return false;
			return sptsta.equals(this.getSpt().getSta());
		}
        /**
        *   source:sysmod.@0027.script
        */
        public void showNotice(String filepath,String filename,String cfgpath,IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String etyinr = null;
			log.debug("{}","filename="+filename);
			if(!MdaUtils.isEmpty(filename)&&filename.startsWith("N"))
			  etyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getBelongEty();
			else
			  etyinr="00000000";
			log.debug("{}","pty inr="+this.getPty().getInr()+"\tptytyp="+this.getPty().getPtytyp());
			log.debug("{}","ety inr="+this.getEty().getInr());
			log.debug("{}","etyinr="+etyinr);
			showNoticeFromEty(filepath,filename,cfgpath,is,etyinr);
		}
        /**
        *   source:sysmod.@0028.script
        */
        public void showSw2(String filepath,String filename,String cfgpath,IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//to fix
			//show sw2 file
			//Platform.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",map,stream,Platform.getTransName(),"");
			Map<String,String[]> dmap  = (Map<String,String[]>)MdaUtils.invoke("com.brilliance.swift.SwiftPacker","packDraftFromFile",filepath,filename);
			log.info("{}","show sw2===");
			String waterfilePath =MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/loginfile/");
			MdaUtils.invoke("com.brilliance.etrade.document.PDFDocumentGenerator","generateSwiftDocument",dmap,is,ctx.getTransName(),waterfilePath,true);
		}
        /**
        *   source:sysmod.@0031.script
        */
        public void sdbReadByType(IModule rec,String objtyp,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(rec,new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr));
		}
        /**
        *   source:sysmod.@0033.script
        */
        public String getSelection()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String selSql = null;
			String ptytyp = this.getPty().getPtytyp();
			if("0".equals(ptytyp))
			{// 兴业机构
			  selSql = " AND rec.etyinr='"+this.getEty().getInr()+"'";
			}
			else if("1".equals(ptytyp))
			{// 商行机构
			  selSql = " AND rec.etyinr='"+this.getEty().getInr()+"'";
			}
			else if("2".equals(ptytyp))
			{// 本行企业
			  selSql = " AND rec.ptyinr='"+this.getPty().getInr()+"'";
			}
			else if("3".equals(ptytyp))
			{// 商行下属企业
			  selSql = " AND rec.ptyinr='"+this.getPty().getInr()+"'";
			}
			else
			  selSql="";
			return selSql+" AND  rec.clsdat is  null  AND rec.stlref IS NOT NULL";
			//return " AND rec.stlref IS NOT NULL";
					}
        /**
        *   source:sysmod.@0034.script
        */
        public String getCidByInr(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(inr))
			{
			  return null;
			}
			Argument<String> cid=new Argument<String>("cid");
			ctx.getDaoSession().dbExecuteSQL("SELECT cid FROM pty WHERE inr='"+inr+"'");
			ctx.getDaoSession().dbFetchFields(cid);
			int e=ctx.getErrorCode();
			if(e==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(cid.value))
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    return cid.value;
			  }
			  else
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    return null;
			  }
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return null;
			}
		}
        /**
        *   source:sysmod.@0039.script
        */
        public BigDecimal getCurRate(String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal rt=new BigDecimal("0");
			Date curdat=MdaUtils.sqlDate(new Date(),EQ);
			Argument<BigDecimal> midrat=new Argument<BigDecimal>("midrat");
			String sql="SELECT midrat FROM currat WHERE cur= ? AND begdat<=? AND enddat>=? ";
			ctx.getDaoSession().dbExecuteSQL(sql,cur,curdat,curdat);
			ctx.getDaoSession().dbFetchFields(midrat);
			ctx.getDaoSession().dbCloseCursor();
			int erorCode = ctx.getErrorCode();
			if(erorCode==NO_ERROR)
			{
			  rt=midrat.value;
			}
			else if(erorCode==NO_MORE_ROW)
			{
			  log.error("{}","找不到有效的统计汇率信息，币种["+cur+"]，交易无法提交!");
			  rt = null ;
			  ctx.setMessage("无汇率信息","找不到币种["+cur+"]的有效汇率信息,请通知管理员进行统计汇率维护。");
			}
			return rt ;
		}
        /**
        *   source:sysmod.@0040.script
        */
        public String getOprogncid(String bchcod,String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 首先从数据库STB表查找交易配置如果为空才从配置文件中读取设定
			
			Map<String,String>  lvllst = new HashMap<String,String>();
			String sql = "SELECT * FROM STB WHERE tbl='cid"+bchcod+"' ORDER BY txt";
			Argument<String> txt = new Argument<String>("txt");
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    lvllst.put(txt.value,cod.value);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","lvllst size="+lvllst.size());
			String bchlvl = null;
			if(lvllst.size()>0)
			{
			  bchlvl = lvllst.get(trnname);
			  if(MdaUtils.isEmpty(bchlvl))
			    bchlvl = lvllst.get("DefaultFrm");
			  log.debug("{}",trnname+"stb lvl="+bchlvl);
			}
			else
			{
			  // 从配置文件读取
			  String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			  String filename=MdaUtils.catPath(path,"oprogn.properties");
			  if(!MdaUtils.fileExists(filename))
			    return bchcod;
			  bchlvl = MdaUtils.getPropertyValue(filename,trnname);
			  if(MdaUtils.isEmpty(bchlvl))
			    bchlvl = MdaUtils.getPropertyValue(filename,"DefaultFrm");
			  log.debug("{}",trnname+"properties lvl="+bchlvl);
			}
			// 如果查询的结果是 0 按照机构配置处理，则查询机构配置
			if("0".equals(bchlvl))
			{
			  bchlvl = lvllst.get(bchcod);
			  if(MdaUtils.isEmpty(bchlvl))
			    bchlvl = "2";//如果没有配置默认是2 分行处理
			  log.debug("{}","load brh set lvl="+bchlvl);
			}

			String toplvlbch = bchcod;
			// 单证级别1表示必须总行处理
			sql = null;
			Argument<String> cid=new Argument<String>("cid");
			if("1".equals(bchlvl))
			{
			  toplvlbch = Platform.headBchcod();
			  sql = "SELECT cid FROM pty p WHERE p.ptytyp='0' AND p.lvl='1' ORDER BY p.cid";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(cid);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(cid.value))
			    {
			      toplvlbch = cid.value;
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  log.debug("{}","lvl 1 bch="+toplvlbch);
			  return toplvlbch;
			}
			// 单证级别2表示所属分行处理
			else if("2".equals(bchlvl))
			{
			  sql = "SELECT cid FROM pty p WHERE p.ptytyp='0' AND p.lvl='2'";
			  sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"'    ORDER BY p.cid";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  cid=new Argument<String>("cid");
			  ctx.getDaoSession().dbFetchFields(cid);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(cid.value))
			      toplvlbch = cid.value;
			  }
			  ctx.getDaoSession().dbCloseCursor();
			  log.debug("{}","lvl 2 bch="+toplvlbch);
			  return toplvlbch;
			}
			// 单证级别3表示本机构处理
			else
			  return bchcod;
		}
        /**
        *   source:sysmod.@0041.script
        */
        public String getTransLevel(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(bchcod))
			  return null;
			String trnlvl = null;
			String sql = "SELECT lvl FROM pty p WHERE p.ptytyp='0' AND p.cid='"+bchcod+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> lvl=new Argument<String>("lvl");
			ctx.getDaoSession().dbFetchFields(lvl);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(!MdaUtils.isEmpty(lvl.value))
			  {
			    trnlvl = lvl.value;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			log.info("{}","getTransLevel-trnlvl  = " + trnlvl);
			return trnlvl;
		}
        /**
        *   source:sysmod.@0042.script
        */
        public String[] getLowBch(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","[getLowBch()]bchcod="+bchcod);
			String trnlvl = getTransLevel(bchcod);
			log.debug("{}","[getLowBch()]trnlvl="+trnlvl);
			Argument<String> cid = new Argument<String>("inr");
			List<String> cidLst = new ArrayList<String>();
			if("0".equals(trnlvl))
			{
			  String sql = "SELECT p.inr inr FROM pty p WHERE p.ptytyp='0' AND p.lvl >='1'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(cid);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      cidLst.add(cid.value);
			    else
			      break;
			  }
			}
			else if("1".equals(trnlvl))
			{
			  String sql = "SELECT p.inr inr FROM pty p WHERE p.ptytyp='0' ";
			  //sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"'";
			  sql = sql+"AND pntinr = '"+bchcod+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  while(true)
			  {
			    ctx.getDaoSession().dbFetchFields(cid);
			    int errorCode = ctx.getErrorCode();
			    if(errorCode == NO_ERROR)
			      cidLst.add(cid.value);
			    else
			      break;
			  }
			}
			else if("2".equals(trnlvl))
			  cidLst.add(this.getPty().getInr());
			ctx.getDaoSession().dbCloseCursor();
			return cidLst.toArray(new String[]{});
		}
        /**
        *   source:sysmod.@0043.script
        */
        public String[] getTrnSortlist(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/trnsort.properties");
			String value=MdaUtils.getPropertyValue(file,typ);
			String[] rt=value.split(",");
			return rt;
		}
        /**
        *   source:sysmod.@0044.script
        */
        public String getEtyLgnUrl(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String url="";
			String sql = null;
			if(MdaUtils.isEmpty(bchcod))
			{
			  String etyinr = null;
			  String ptytyp = this.getPty().getPtytyp();
			  if(!"1".equals(ptytyp))
			    etyinr = getBelongEty();
			  if(MdaUtils.isEmpty(etyinr))
			    etyinr="00000000";
			  sql = "SELECT covurl FROM ety  WHERE inr='"+etyinr+"'";
			}
			else
			  sql = "SELECT e.covurl covurl FROM ety e,pty p WHERE p.cid='"+bchcod+"' AND p.etyinr=e.inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> covurl = new Argument<String>("covurl");
			ctx.getDaoSession().dbFetchFields(covurl);
			if(ctx.getErrorCode() == NO_ERROR)
			  url = covurl.value;
			ctx.getDaoSession().dbCloseCursor();
			if(url==null)url="";
			url=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),url);
			return url;
		}
        /**
        *   source:sysmod.@0045.script
        */
        public String getTrnSort(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/trnsort.properties");
			return MdaUtils.getPropertyValue(file,typ);
		}
        /**
        *   source:sysmod.@0046.script
        */
        public List<CodetableItem> getBranchList(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> bch=new ArrayList<CodetableItem>();
			log.debug("{}","[getBranchList()]bchcod="+bchcod);
			String trnlvl = getTransLevel(bchcod);
			String sql="";
			log.debug("{}","[getBranchList()]trnlvl="+trnlvl);
			/*
			  if("1".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='2' OR lvl='1') ORDER BY p.inr";
			  }
			  else if("2".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='2' OR lvl='3') ";
			  sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"' ORDER BY p.inr";
			  }
			  else if("3".equals(trnlvl))
			  {
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND cid='"+bchcod+"' ";
			  }
			  */
			if("0".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='0' OR lvl='1') ORDER BY p.inr";
			}
			else if("1".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND (lvl='2' OR lvl='1') ";
			  sql = sql+"AND pntinr = '"+bchcod+"' or cid = '" + bchcod + "' ORDER BY p.inr";
			  //sql = sql+"AND substr(p.cid, 1, 2) = '"+bchcod.substring(0,2)+"' ORDER BY p.inr";
			}
			else if("2".equals(trnlvl))
			{
			  sql = "SELECT p.inr inr,p.nam nam FROM pty p WHERE p.ptytyp='0' AND cid='"+bchcod+"' ";
			}

			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> nam = new Argument<String>("nam");
			Argument<String> inr = new Argument<String>("inr");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,nam);
			  if(ctx.getErrorCode()== NO_ERROR)
			  {
			    bch.add(new CodetableItem(nam.value,inr.value));
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return bch;
		}
        /**
        *   source:sysmod.@0047.script
        */
        public String toSqlString(String[] arr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(arr==null)
			  return "";
			String blist="";
			String conn="";
			for(int j=0;j<arr.length;j++)
			{
			  blist=blist+conn+"'"+arr[j]+"'";
			  conn=",";
			}
			return blist;
		}
        /**
        *   source:sysmod.@0048.script
        */
        public String getOrdCreatePty(String ordinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Argument<String> ptyinr=new Argument<String>("ptyinr");
			String sql="SELECT ptyinr FROM ord WHERE inr='"+ordinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(ptyinr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return ptyinr.value;
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return null;
			}
		}
        /**
        *   source:sysmod.@0050.script
        */
        public String getBelongEty()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//获取所属实体inr
			String belongEtyinr = null;
			String ptytyp = this.getPty().getPtytyp();
			String ptrtyp = null;
			if("1".equals(ptytyp)  ||  "0".equals(ptytyp))
			{
			  //如果是银行就直接存他pty表的etyinr
			  belongEtyinr  = this.getPty().getEtyinr();
			}
			else
			{
			  //本行企业、商行企业
			  //etyinr 如果是企业客户 从其自己的ptyinr找到etyinr
			  if("2".equals(ptytyp))
			    ptrtyp = "0";
			  else if("3".equals(ptytyp))
			    ptrtyp ="2";
			  ctx.getDaoSession().dbRead(this.getPtr(),new Argument<String>("preptyinr",this.getPty().getInr()),new Argument<String>("ptrtyp",ptrtyp));
			  ctx.getDaoSession().dbExecuteSQL("SELECT etyinr FROM pty WHERE inr = '"+this.getPtr().getNxtptyinr()+"'");
			  Argument<String> etyinr = new Argument<String>("etyinr");
			  ctx.getDaoSession().dbFetchFields(etyinr);
			  belongEtyinr = etyinr.value;
			  ctx.getDaoSession().dbCloseCursor();
			}
			return belongEtyinr;
		}
        /**
        *   source:sysmod.@0051.script
        */
        public boolean aplSendMail(String[] mailAdr ,String[] mailfile,String filepath,String subject ,String contxt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return(Boolean)MdaUtils.invoke("com.brilliance.etrade.message.SendMessage","sendMailMessage",subject,contxt,mailAdr,mailfile,filepath);
		}
        /**
        *   source:sysmod.@0052.script
        */
        public String[] getAplTrn(String advtrn)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(advtrn))
			  return null;
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/relation.properties");
			String apltrn=MdaUtils.getPropertyValue(file,advtrn);
			if(MdaUtils.isEmpty(apltrn))
			  return null;
			else
			{
			  String[] rt=apltrn.split(",");
			  return rt;
			}
			//return rt;
					}
        /**
        *   source:sysmod.@0054.script
        */
        public boolean checkSubmitRight(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String logusrinr=this.getUsr().getInr();
			//check the usr's rights for submiting this transaction
			//String frm=Platform.getTransName();
			if("letfrc".equals(frm)  ||  "letfrd".equals(frm))
			  frm="letfre";
			if("brtfrd".equals(frm)  ||  "brtfrc".equals(frm))
			  frm="brtfre";
			if("bptopl".equals(frm)  ||  "bptopc".equals(frm))
			  frm="bptopn";
			boolean rtvalue=true;
			ctx.getDaoSession().dbRead(this.getUsraut(),new Argument<String>("objinr",logusrinr),new Argument<String>("objtyp","usr"),new Argument<String>("frm",frm));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  if("1".equals(this.getUsraut().getFlg1()))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000235"),MdaUtils.getI18NString("sysmod","CT000236"));
			    rtvalue=false;
			  }
			}
			else if(errorcode==NO_MORE_ROW)
			{
			  ctx.getDaoSession().dbRead(this.getUsraut(),new Argument<String>("objinr",logusrinr),new Argument<String>("objtyp","usr"),new Argument<String>("frm",frm+"0"));
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    if("1".equals(this.getUsraut().getFlg1()))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000253"),MdaUtils.getI18NString("sysmod","CT000254"));
			      rtvalue=false;
			    }
			  }
			  else if(errorcode==NO_ERROR)
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000255"),MdaUtils.getI18NString("sysmod","CT000256"));
			    rtvalue=false;
			  }
			}
			MdaUtils.clear(this.getUsraut());
			return rtvalue;
		}
        /**
        *   source:sysmod.@0055.script
        */
        public void showNoticeFromEty(String filepath,String filename,String cfgpath,IStream is,String etyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String file=MdaUtils.catPath(filepath,filename);
			if(!MdaUtils.fileExists(file))
			{
			  log.info("{}","file="+file+" not exist!,cfgpath="+cfgpath);
			  return;
			}
			else
			{
			  log.info("{}","file="+file+",cfgpath="+cfgpath);
			}
			if(MdaUtils.isEmpty(etyinr))
			  etyinr="00000000";
			String url="";
			String sql = "SELECT sealrl FROM ety  WHERE inr='"+etyinr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> sealrl = new Argument<String>("sealrl");
			ctx.getDaoSession().dbFetchFields(sealrl);
			if(ctx.getErrorCode() == NO_ERROR)
			  url = sealrl.value;
			ctx.getDaoSession().dbCloseCursor();
			if(url!=null)
			  url = url.substring(url.lastIndexOf("/")+1,url.length());
			else
			  url="";
			log.debug("{}","sea="+url);
			String logoPath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/loginfile");
			MdaUtils.invoke("com.brilliance.doc.DocPacker","generateDoccsDocument",filepath,filename,cfgpath,logoPath,is,url);
		}
        /**
        *   source:sysmod.@0056.script
        */
        public String getEtySeaUrl(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String url=null;
			String sql =null;
			if(MdaUtils.isEmpty(bchcod))
			{
			  String etyinr = null;
			  String ptytyp = this.getPty().getPtytyp();
			  if(!"1".equals(ptytyp))
			    etyinr = getBelongEty();
			  if(MdaUtils.isEmpty(etyinr))
			    etyinr="00000000";
			  sql = "SELECT sealrl FROM ety  WHERE inr='"+etyinr+"'";
			}
			else
			  sql = "SELECT e.sealrl sealrl FROM ety e,pty p WHERE p.cid='"+bchcod+"' AND p.etyinr=e.inr";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> sealrl = new Argument<String>("sealrl");
			ctx.getDaoSession().dbFetchFields(sealrl);
			if(ctx.getErrorCode() == NO_ERROR)
			  url = sealrl.value;
			ctx.getDaoSession().dbCloseCursor();
			if(url==null)url="";
			url=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),url);
			return url;
		}
        /**
        *   source:sysmod.@0059.script
        */
        public String getOrderOwnnerTyp(String orderinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(orderinr))
			  return null;
			String ptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getOrdCreatePty(orderinr);
			String ptysql="SELECT ptytyp FROM pty WHERE inr='"+ptyinr+"'";
			Argument<String> ptytyp=new Argument<String>("ptytyp");
			ctx.getDaoSession().dbExecuteSQL(ptysql);
			ctx.getDaoSession().dbFetchFields(ptytyp);
			ctx.getDaoSession().dbCloseCursor();
			return ptytyp.value;
		}
        /**
        *   source:sysmod.@0060.script
        */
        public void fileMove(String sfile,String tfile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *服务器资源文件,主要指报文的复制
			  */
			String source=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),sfile);
			String target=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),tfile);
			if(!MdaUtils.fileExists(source))
			  return;
			MdaUtils.fileCopy(source,target);
			MdaUtils.fileDelete(source);
		}
        /**
        *   source:sysmod.@0061.script
        */
        public void loadOprLvlSet()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,String>  lvllst = new HashMap<String,String>();
			String sql = "SELECT * FROM STB WHERE tbl='oprbchlvl' OR tbl='oprbchset'";
			Argument<String> txt = new Argument<String>("txt");
			Argument<String> cod = new Argument<String>("cod");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    lvllst.put(txt.value,cod.value);
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			this.setOprbchlvl(lvllst);
		}
        /**
        *   source:sysmod.@0062.script
        */
        public List<CodetableItem> getAndSetBchcodvals()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *检查机构列表是否存在，不存在就重新读取
			  */
			boolean needReload = false;
			List<CodetableItem> items = null;
			if(MdaUtils.isEmpty(this.getBchcodvals()))
			  needReload = true;
			Object object = this.getBchcodvals();
			if(object==null)
			  needReload = true;
			else
			{
			  items = (List<CodetableItem>)object;
			  if(items==null   ||   items.size()==0)
			    needReload = true;
			}

			if(needReload)
			{
			  items = getBchcod(this.getPty().getInr(),this.getPty().getPtytyp());
			  this.setBchcodvals(items);
			}
			return items;
		}
        /**
        *   source:sysmod.@0071.script
        */
        public boolean checkMaxTextField(IDatafield<String> field,  int maxlenth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean res = false ;
			String content = field.getValue();
			if(!MdaUtils.isEmpty(content))
			{
			  try
			  {
			    int len =  content.getBytes("UTF-8").length;
			    log.info("{}","字段输入长度=========="+len);
			    if(len > maxlenth)
			    {
			      //Platform.error(field,#CT000263+maxlenth);
			      res = false ;
			    }
			    else
			    {
			      res = true  ;
			    }
			  }
			  catch(Exception e)
			  {
			    log.error("{}",	e.getMessage());
			    e.printStackTrace();
			  }
			}
			else
			{
			  log.debug("{}","该 filed 字段值为空");
			  res = true ;
			}
			return res ;
		}
        /**
        *   source:sysmod.@0072.script
        */
        public boolean checkNumericField(IDatafield<BigDecimal> field, int maxScale)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean res = false;
			BigDecimal content = field.getValue();
			if(!MdaUtils.isEmpty(content))
			{
			  String decimalStr = Double.toString(content.doubleValue());
			  int strScale =decimalStr.length() - decimalStr.indexOf(".") - 1;
			  if(decimalStr.matches("\\d+.?\\d*"))
			  {
			    if(strScale > maxScale)
			    {
			      res = false;
			      ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000266"));
			    }
			  }
			  else
			  {
			    strScale=decimalStr.indexOf('E') - Integer.parseInt(decimalStr.substring(decimalStr.indexOf('E') + 1 )) - 2;
			    if(strScale > maxScale)
			    {
			      res = false;
			      ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000268"));
			    }
			  }
			}
			else
			{
			  res = true ;
			}
			return true ;
		}
        /**
        *   source:sysmod.@0076.script
        */
        public Map<String,Object> getStlXmlHeader( String trnnam )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *XML改造后报文头为：交易名称，报文类型，数据来源，数据目的地，客户代号，关联系统编号，地区机构号，
			  *操作员，银行业务编号，业务创建日期，单证通申请编号。
			  */

			log.debug("{}","in sysmod.getStlXmlHeader ...  ");
			ctx.getErrorCode() ;
			String khdh=this.getPty().getNcid();
			String glxtbh="glxtbh";
			String dqjgh="";
			Map<String,Object> header =  new HashMap<String,Object>();
			IDatafield dqjghField =  MdaDriver.getDatafield(ctx.getRoot(),"trnmod\\bchcod");
			if( dqjghField==null )
			{
			  log.error("{}","获取所属机构失败");
			  return header;
			}
			dqjgh =(String)dqjghField.getValue() ;

			String czy =this.getUsr().getOprnam();

			String yhywbh="";
			IDatafield yhywbhField =  MdaDriver.getDatafield(ctx.getRoot(),"trnmod\\ownref");
			yhywbh =(String) yhywbhField.getValue() ;

			Date ywcjrq=MdaUtils.today();

			String yxpch="yxpch";

			header.put("KHDH",khdh);
			header.put("GLXTBH",glxtbh);
			header.put("DQJGH",dqjgh);
			header.put("CZY",czy);
			header.put("YHYWBH",yhywbh);
			header.put("YWCJRQ",ywcjrq);
			header.put("YXPCH",yxpch);
			log.debug("{}","out  sysmod.getStlXmlHeader ....  ");
			return header ;

		}
        /**
        *   source:sysmod.@0081.script
        */
        public boolean judgingImageOpen(String cid,String frm,String bch)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//判断影像功能是否开通
			String sql="select trnopnflg from epc where cid='"+cid+"' and trncod='"+frm+"' and ptybch='"+bch+"'";
			Argument<String> flg = new Argument<String>("trnopnflg");
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(flg);
			ctx.getDaoSession().dbCloseCursor();
			if( ctx.getErrorCode() == NO_ERROR)
			{
			  if(!"1".equals(flg.value))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000269"),MdaUtils.getI18NString("sysmod","CT000270"));
			    return false;
			  }
			}
			return true;
		}
        /**
        *   source:sysmod.@0082.script
        */
        public String valueToLabel( String value )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//eg:value = $rpdgrp\\rec\\bchcod.getValue();
			log.debug("{}","sysmod.valueToLabel start:");
			log.info("{}","value=" + value);

			List<CodetableItem> cti = getAndSetBchcodvals();

			String key ="" ;
			String label ="" ;
			for(CodetableItem ct : cti)
			{
			  key = ct.getValue() ;
			  log.info("{}","key =" + key);
			  if( !MdaUtils.isEmpty(value)&& value.equals(key))
			  {
			    label = ct.getLabel() ;
			    break;
			  }
			}

			log.info("{}","label=" + label);
			log.debug("{}","sysmod.valueToLabel end!");
			return label;
		}
        /**
        *   source:sysmod.@0083.script
        */
        public String createFilename(String inr,String fileType,String directory)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String mdDir = "";
			fileType = fileType.toLowerCase();
			if(MdaUtils.isEmpty(directory))
			  mdDir=directory;
			else
			{
			  if("bak".equals(fileType))
			  {
			    mdDir = "delete";
			  }
			  else if("zul".equals(fileType))
			  {
			    mdDir = "dsp";
			  }
			  else if("dra".equals(fileType))
			  {
			    mdDir = "temp";
			  }
			  else if("app".equals(fileType))
			  {
			    mdDir = "temp";
			  }
			  else if("dat".equals(fileType))
			  {
			    mdDir = "trndata";
			  }
			  else if("pdf".equals(fileType))
			  {
			    mdDir ="pdf";
			  }
			  else if("html".equals(fileType))
			  {
			    mdDir ="pdf/html";
			  }
			}
			String inrStr = inr.substring(0,4);
			String fileName = inr+"."+fileType;
			if("pdf".equals(fileType))
			{
			  fileName ="/data/"+mdDir+"/"+fileName;
			}
			else
			{
			  fileName = "/data/"+mdDir+"/"+inrStr+"/"+fileName;
			}
			if ("zul".equals(fileType))
			{
			  //Platform.saveDisplay不能自动创建目录
			  String dspfilePath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/dsp/"+inrStr);
			  if(!"dsp".equals(mdDir))
			    dspfilePath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/dsp/"+mdDir+"/"+inrStr);
			  if (!MdaUtils.fileExists(dspfilePath))
			  {
			    java.io.File f = null;
			    f = new java.io.File(dspfilePath);
			    boolean bool = f.mkdir();
			    if(!bool)
			    {
			      MdaUtils.prompt(MdaUtils.getI18NString("sysmod","CT000286"),MdaUtils.getI18NString("sysmod","CT000287")+dspfilePath+MdaUtils.getI18NString("sysmod","CT000288"));
			      log.debug("{}",dspfilePath+" crtead Failed!");
			    }
			  }
			}

			fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),fileName);
			return fileName;
		}
        /**
        *   source:sysmod.@0084.script
        */
        public String getoldtrn(String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="select trn.inr oldtrn from trn,pty where trn.optptyinr=pty.inr and pty.ptytyp!='0' and trn.ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> oldtrn =new Argument<String>("oldtrn");
			ctx.getDaoSession().dbFetchFields(oldtrn);
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","ownref - oldtrn ="+ownref+" | "+oldtrn.value);
			return oldtrn.value;
		}
        /**
        *   source:sysmod.@0085.script
        */
        public String parseDate(Date dat)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(dat))
			  return null;
			String year = MdaUtils.format(dat,"yyyy");
			String month = MdaUtils.format(dat,"MM");
			String day = MdaUtils.format(dat,"dd");
			StringBuilder build = new StringBuilder();
			build.append(year);
			build.append("年");
			build.append(month);
			build.append("月");
			build.append(day);
			build.append("日");
			return build.toString();
		}
        /**
        *   source:sysmod.@0089.script
        */
        public boolean backFromBnkchk()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *判断是否是从银行端银行审核中退回的记录
			  *银行端银行审核中退回后重新提交的业务，由于原设计导致生成的报文名和之前重名，发送到STL无法处理
			  *因此增加此方法。用于生产新的文件名条件
			  */
			if(this.sptIsLoaded("B") && "0".equals(this.getSpt().getOprusrinr()) )
			  return true;
			else
			  return false;
		}
        /**
        *   source:sysmod.@0091.script
        */
        public String  getPDFTmpfile()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 生成临时的PDF文件名称
			  */
			return UUID.randomUUID().toString().replace("-", "");
		}
        /**
        *   source:sysmod.@0095.script
        */
        public String getLoginUserName()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 获取当前柜员的名称,备注：其中平台获取user名称未实现时，取lgnnam字段
			  */
			if(Platform.isFromApp())
			  return this.getUsr().getOid();
			String userName = MdaEnv.getLoginUser();
			if(MdaUtils.isEmpty(userName) && !MdaUtils.isEmpty(this.getUsr().getLgnnam()))
			{
			  userName = this.getUsr().getLgnnam();
			}
			return userName ;
		}
        /**
        *   source:sysmod.@0096.script
        */
        public String createFilename(String inr,String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String mdDir = "";
			fileType = fileType.toLowerCase();
			if("bak".equals(fileType))
			{
			  mdDir = "delete";
			}
			else if("zul".equals(fileType))
			{
			  mdDir = "dsp";
			}
			else if("dra".equals(fileType))
			{
			  mdDir = "temp";
			}
			else if("app".equals(fileType))
			{
			  mdDir = "temp";
			}
			else if("dat".equals(fileType))
			{
			  mdDir = "trndata";
			}
			else if("pdf".equals(fileType))
			{
			  mdDir ="pdf";
			}
			else if("html".equals(fileType))
			{
			  mdDir ="pdf/html";
			}
			else if("attach".equals(fileType))
			{
			  //解决pdf申请书目录过大问题。存放到历史的attach目录，供后需清理
			  mdDir ="pdf/attach";
			  fileType="pdf";
			}

			/*
			  else if("mdl".equals(fileType))
			  {
			  mdDir = "busmdl";
			  }
			  */
			String inrStr = inr.substring(0,4);
			String fileName = inr+"."+fileType;

			if("pdf".equals(fileType))
			{
			  fileName ="/data/"+mdDir+"/"+fileName;
			}
			else
			{
			  fileName = "/data/"+mdDir+"/"+inrStr+"/"+fileName;
			}

			if ("zul".equals(fileType))
			{
			  //Platform.saveDisplay不能自动创建目录
			  String dspfilePath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/dsp/"+inrStr);
			  if (!MdaUtils.fileExists(dspfilePath))
			  {
			    java.io.File f = null;
			    f = new java.io.File(dspfilePath);
			    boolean bool = f.mkdir();
			    if(!bool)
			    {
			      MdaUtils.prompt(MdaUtils.getI18NString("sysmod","CT000311"),MdaUtils.getI18NString("sysmod","CT000312")+dspfilePath+MdaUtils.getI18NString("sysmod","CT000313"));
			      log.debug("{}",dspfilePath+" crtead Failed!");
			    }
			  }
			}

			fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),fileName);

			return fileName;
		}
        /**
        *   source:sysmod.@0097.script
        */
        public void generatorPdf(String filnam,String pdfFile,IStream stream,boolean flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getPdfmod().genePdfByTrn(ctx.getTransName(),filnam,pdfFile,stream,flg);
		}
        /**
        *   source:sysmod.@0099.script
        */
        public String getErsHNGLBH(String prefix, String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 产生跨境报文中行内关联编号,规则: 业务类型(2位)+ 机构编码(5位)+ 日期(6位) + 关联编号流水(3位)
			  */
			String glbh = "" ;
			if(MdaUtils.isEmpty(prefix) || MdaUtils.isEmpty(bchcod))
			{
			  log.error("{}","传入的业务编号 和 机构号错误          ");
			  return glbh ;
			}
			String key =  prefix + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			glbh = prefix + bchcod +MdaUtils.format(MdaUtils.today(),"yyMMdd")  +  MdaUtils.format(ctx.getDaoSession().dbCounter(key),"000") ;
			return glbh ;
		}
        /**
        *   source:sysmod.@0104.script
        */
        public boolean setLog(String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///Sav提交时保存LOG信息操作
			this.getDztlog().setInr( Platform.sdbCounter("dztlog"));
			this.getDztlog().setOprbegdat( this.getOprstadat());//操作开始日期
			this.getDztlog().setOprenddat( new Date());//操作结束日期
			this.getDztlog().setOprusrinr( this.getUsr().getInr());//操作员inr
			this.getDztlog().setOprusr( this.getUsr().getLgnnam());//操作员登录名称
			this.getDztlog().setOprusrnam( this.getUsr().getOprnam());//操作员名称
			this.getDztlog().setOprbchinr( this.getPty().getInr());//员工机构inr
			this.getDztlog().setOprbchnam( this.getPty().getNam());//机构名称
			this.getDztlog().setOprbch( this.getPty().getCid());//员工机构号
			this.getDztlog().setObjtyp( "");//交易类型
			this.getDztlog().setOwnref( ownref);//业务申请号
			this.getDztlog().setLsh( "");
			this.getDztlog().setSta( "0");//状态
			this.getDztlog().setOprdet( MdaUtils.getServerName());

			if (MdaUtils.isEmpty(this.getDztlog().getOwnref()))
			{
			  return false;
			}
			this.getDztlog().setObjnam( ctx.getTransName().toLowerCase());//交易名称
			String logStr = "objtyp: " + this.getDztlog().getObjtyp()+ ",objnam: " + this.getDztlog().getObjnam()+ ",oprbegdat: " + this.getDztlog().getOprbegdat();
			logStr += ",oprenddat: " + this.getDztlog().getOprenddat()+ ",oprusrinr: " + this.getDztlog().getOprusrinr()+ ",oprusr: " + this.getDztlog().getOprusr();
			logStr += ",oprusrnam: " + this.getDztlog().getOprusrnam()+ ",oprbchinr: " + this.getDztlog().getOprbchinr()+ ",oprbchnam: " + this.getDztlog().getOprbchnam();
			logStr += ",oprbch: " + this.getDztlog().getOprbch()+ ",rptno: " + this.getDztlog().getOwnref();
			logStr += ",oprdet: " + this.getDztlog().getOprdet() + ",sta: " + this.getDztlog().getSta();
			logStr += ",lsh: " + this.getDztlog().getLsh();
			//为非功能添加交易日志
			log.info("{}",logStr);
			ctx.getDaoSession().dbInsert(this.getDztlog());
			return true;
		}
        /**
        *   source:sysmod.@0105.script
        */
        public boolean sendSMSP(String moble,String trsnam,boolean needdata)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String smsPath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			Map<String,Object> data= new HashMap<String,Object>();
			Object[] rps=Platform.getValueSM(ctx.getRoot(),trsnam,"SMS");
			String cls="com.brilliance.eibs.main.Client";
			Object modnub=rps[4];
			Object bkref=rps[0];
			Object trnname=rps[5];
			Object lccy=rps[1];
			Object lcamt=rps[2];
			Object bennam=rps[3];
			Object val01="";
			Object idc=rps[6];
			if(MdaUtils.isEmpty(idc))
			{
			  log.debug("{}","获取所属机构号不存在！");
			  return false;
			}

			log.debug("{}","cls  rps[] 值="+modnub+","+bkref+","+trnname+","+val01+","+lccy+","+lcamt+","+bennam+","+moble+","+idc);
			if(needdata)
			{

			  Object retSMS=MdaUtils.invoke(cls,"scall","message","message",new Object[]{modnub,trnname,val01,bkref,lccy,lcamt,bennam,moble,idc});
			  boolean success= (Boolean)MdaUtils.invoke(retSMS,"isSuccess");
			  log.debug("{}","success   ："+success);
			  String retCode=(String)MdaUtils.invoke(retSMS,"getReturnCode");
			  Object content = MdaUtils.invoke(retSMS,"getContent") ;
			  String retss = (String)MdaUtils.invoke(retSMS,"getContent").toString() ;
			  log.debug("{}","retss    =: "+retss);
			  log.debug("{}","content    =: "+content);
			  log.debug("{}","retCode    =:  "+retCode);
			  //if("true".equals(retss.substring(0,5).trim()))
			  if( success && retss.contains("true") )
			  {
			    log.debug("{}","短信平台接口调用成功！{success=: "+success+" }");
			    log.debug("{}","阳光e结算提示：贵司收到一笔"+trnname+"；交易参考号:"+bkref+"；金额:"+lccy+" "+lcamt+"，请及时处理。[光大银行]");
			    return true;
			  }
			  else
			  {
			    log.debug("{}","短信平台接口调用失败！{success=: "+success+" }"+"调用失败码  :"+retss.replaceFirst("false",""));
			    return false;
			  }
			  /*if(!success)
			    {
			    String retCode=Platform.invoke(retSMS,"getReturnCode");
			    Object content = (Object)Platform.invoke(retSMS,"getContent") ;
			    log.debug("content    =: "+content);
			    log.debug("retCode    =:  "+retCode);
			    log.debug("短信平台接口调用失败！{success=: "+success+" }");
			    return false;
			    }
			    else
			    {
			    String retss = (Object)Platform.invoke(retSMS,"getContent").toString() ;
			    if(true.equals(retss.substring(0,5).trim()))
			    {
			    log.debug("retss    =: "+retss);
			    log.debug("短信平台接口调用成功！{success=: "+success+" }");
			    return true;
			    }
			    }*/
			}
			else
			{
			  return false;
			}
		}
        /**
        *   source:sysmod.@0108.script
        */
        public void checkAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = field.getValue();
			int num = amt.signum();
			if(num<0)
			{
			  MdaUtils.clear(field);
			  
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000315"));
			  return;
			}
		}
        /**
        *   source:sysmod.@0109.script
        */
        public void checkAmtAndClear(IDatafield<BigDecimal> field,IDatafield<String> covfield)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = field.getValue();
			int num = amt.signum();
			if(num<0)
			{
			  MdaUtils.clear(field);
			  
			  MdaUtils.clear(covfield);
			  
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000319"));
			  return;
			}
		}
        /**
        *   source:sysmod.@0111.script
        */
        public List<CodetableItem> getAndSetBchcod(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *检查机构列表是否存在，不存在就重新读取
			  */
			boolean needReload = false;
			List<CodetableItem> items = null;
			if(MdaUtils.isEmpty(this.getBchcodvals()))
			  needReload = true;
			Object object = this.getBchcodvals();
			if(object==null)
			  needReload = true;
			else
			{
			  items = (List<CodetableItem>)object;
			  if(items==null   ||   items.size()==0)
			    needReload = true;
			}

			if(needReload)
			{
			  items = getBchcod(inr,"2");
			  this.setBchcodvals(items);
			}
			return items;
		}
        /**
        *   source:sysmod.@0112.script
        */
        public Map retSW(String tranName,Map tranData,ICallback callback)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * tranName 交易码，比如SFS102
			  * tranData 回执数据，需要返回的数据
			  * callback 回调方法，根据需要传入，接口会回调该方法执行需要处理的逻辑
			  * 返回：处理结果，调用者需根据返回code给出提示:000000:成功，其他失败；des：具体失败原因
			
			  */
			//开始接口调用逻辑
			Map map = new HashMap();
			if(MdaUtils.isEmpty(tranName) || MdaUtils.isEmpty(tranData))
			{
			  log.info("{}","*********参数错误********");
			  map.put("code","999999");
			  map.put("des","交易码或回执数据不能为空!");
			  return map;
			}
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(tranData);
			Object resMsg = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","sgnwinclient","sgnwinclient",new Object[]{tranName,sendContent,callback});
			if((Boolean)MdaUtils.invoke(resMsg,"isSuccess"))
			{
			  map =  (Map)MdaUtils.invoke(resMsg,"getContent");
			}
			else
			{
			  map.put("code","999999");
			  map.put("des","接口调用异常，请重试!");
			}
			return map;

		}
        /**
        *   source:sysmod.@0113.script
        */
        public void setImageMapSwi(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//原业务ownref
			String buscod = (String)map.get("buscod");
			String djcod = (String)map.get("djcod");
			String sql = "select ttl imageID,decode(tratyp,'UPLOAD','2','4') imageStatus "+
			  "from tblbil where buscod=? and djcod=? and usr='dyck' and ver is not null order by inr,ttl desc";
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL(sql,buscod,djcod);
			log.debug("{}","setImageMapSwi");
			List imgList = new ArrayList();
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  Argument<String> imageID = new Argument<String>("imageID");
			  Argument<String> imageStatus = new Argument<String>("imageStatus");
			  while(true)
			  {
			    Map imageMap = new HashMap();
			    ctx.getDaoSession().dbFetchFields(imageID,imageStatus);
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      imageMap.put("imageID",imageID.value);
			      imageMap.put("imageStatus",imageStatus.value);
			      imgList.add(imageMap);
			    }
			    else
			      break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			map.put("imgList",imgList);
			log.debug("{}","setImageMapSwi");
		}
        /**
        *   source:sysmod.@0114.script
        */
        public void setSwHeaderMap(String msgno,String temp,Map sendMap,String msgref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sw =MdaUtils.format(ctx.getDaoSession().dbCounter("WindowsLSH"),"000000000");
			String msgid = "CEB"+MdaUtils.format(MdaUtils.today(),"yyyyMMdd"+sw);
			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");
			if("SFS116".equals(msgno)&&MdaUtils.isEmpty(msgref))
			{
			  msgref = msgid;
			}
			sendMap.put("VER","1.0");
			sendMap.put("SRC","CEB");
			sendMap.put("DES","SW");
			sendMap.put("MsgNo",msgno);
			sendMap.put("WorkDate",date);
			sendMap.put("MsgID",msgid);
			sendMap.put("MsgRef",msgref);
			sendMap.put("Reserve",temp);
			sendMap.put("code",msgno);
		}
        /**
        *   source:sysmod.@0116.script
        */
        public boolean checkRight(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String logusrinr=this.getUsr().getInr();
			String ptyinr=this.getPty().getInr();
			boolean chk=true;
			ctx.getDaoSession().dbRead(this.getUsraut(),new Argument<String>("objinr",logusrinr),new Argument<String>("objtyp","usr"),new Argument<String>("frm",frm),new Argument<String>("ptyinr",ptyinr));
			int errorcode=ctx.getErrorCode();
			log.debug("{}","objinr is :"+logusrinr+"  frm is :"+frm+"  inr is: "+this.getUsraut().getInr());
			//if(errorcode==NO_MORE_ROW)
			if(errorcode==NO_ERROR)
			{
			  if(MdaUtils.isEmpty(this.getUsraut().getInr()))
			  {
			    ctx.getDaoSession().dbRead(this.getUsraut(),new Argument<String>("objinr",logusrinr),new Argument<String>("objtyp","usr"),new Argument<String>("frm",frm+"0"),new Argument<String>("ptyinr",ptyinr));
			    errorcode=ctx.getErrorCode();
			    if(errorcode==NO_ERROR)
			    {
			      if(MdaUtils.isEmpty(this.getUsraut().getInr()))
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000373"),MdaUtils.getI18NString("sysmod","CT000374"));
			        chk=false;
			      }
			    }
			  }
			}
			String oflg=this.getUsraut().getFlg1();
			String bflg=this.getUsraut().getFlg2();
			String aflg=this.getUsraut().getLvl();
			if("1".equals(bflg)&&("0".equals(aflg)  ||  MdaUtils.isEmpty(aflg)))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000375"),MdaUtils.getI18NString("sysmod","CT000376"));
			  chk=false;
			}
			MdaUtils.clear(this.getUsraut());
			return chk;
		}
        /**
        *   source:sysmod.@0117.script
        */
        public boolean judgeSWFunctions(String func,String cifno,String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//是否已签约
			String sql="select qysta,qyfunctions from swinfo where cifno= ? ";
			Argument<String> qysta = new Argument<String>("qysta");
			Argument<String> qyfunctions = new Argument<String>("qyfunctions");
			ctx.getDaoSession().dbExecuteSQL(sql,cifno);
			ctx.getDaoSession().dbFetchFields(qysta,qyfunctions);
			ctx.getDaoSession().dbCloseCursor();
			if( ctx.getErrorCode() == NO_ERROR)
			{
			  if(!"1".equals(qysta.value))
			  {
			    log.info("{}","cifno 尚未签约："+cifno);
			    return false;
			  }
			}
			String functions= qyfunctions.value;
			if(MdaUtils.isEmpty(functions)||MdaUtils.isEmpty(func))
			  return false;

			log.debug("{}"," func  :"+functions.contains(func));
			return functions.contains(func);
			//是否包含该功能
					}
        /**
        *   source:sysmod.@0118.script
        */
        public List<CodetableItem> getAndSetBchcodFlg(String inr,String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *检查机构列表是否存在，不存在就重新读取
			  */
			List<CodetableItem> items = null;
			boolean needReload = false;
			if(MdaUtils.isEmpty(this.getBchcodvals()))
			  needReload = true;
			Object object = this.getBchcodvals();
			if(object==null)
			  needReload = true;
			else
			{
			  items = (List<CodetableItem>)object;
			  if(items==null   ||   items.size()==0)
			    needReload = true;
			}
			if(needReload)
			{
			  items = getBchcod(inr,"2");
			  this.setBchcodvals(items);
			}
			if(!MdaUtils.isEmpty(bchcod)&&"08350000".equals(bchcod))
			{
			  List<CodetableItem> newitems = new ArrayList<CodetableItem>();
			  String cod1 = "";
			  String desp1="";
			  CodetableItem it;
			  for(int i = 0; i < items.size(); i++)
			  {
			    cod1 = items.get(i).getValue();
			    desp1 = items.get(i).getLabel();
			    it = new CodetableItem(desp1,cod1);
			    newitems.add(it);
			  }
			  newitems.add(new CodetableItem("总行单证中心","08350000"));
			  return newitems;
			}
			else
			{
			  return items;
			}
		}
        /**
        *   source:sysmod.@0119.script
        */
        public void setSzHeaderMap(String msgno,String temp,Map sendMap,String msgref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sw =MdaUtils.format(ctx.getDaoSession().dbCounter("SZEBHLSH"),"000000000");
			String msgid = "CEB"+MdaUtils.format(MdaUtils.today(),"yyyyMMdd"+sw);
			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");

			String sql = "select src from ebhmsg where msgref = '" + msgref + "'";
			Argument<String> src = new Argument<String>("src");
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(src);
			  if(ctx.getErrorCode() != NO_ERROR)
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			if("HTI".equals(src.getValue()))
			{
			  sendMap.put("des","HTI");
			}
			else
			{
			  sendMap.put("des","ZTB");
			}
			sendMap.put("ver","1.0");
			sendMap.put("src","CEB");
			sendMap.put("msgno",msgno);
			sendMap.put("msgid",msgid);
			sendMap.put("msgref",msgref);
			sendMap.put("workdate",date);
			sendMap.put("reserve",temp);
			//sendMap.put("code",msgno);
					}
        /**
        *   source:sysmod.@0121.script
        */
        public boolean checkIllegalAmt(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验金额是否合法，number（17，2）的校验，非负的校验，
			boolean bool= true;
			String amt = "";
			String str = "^(([1-9]{1}\\d{0,14})|([0]{1}))(\\.(\\d){1,2})?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  amt = field.getValue().toString();
			  log.info("{}","amt "+amt);

			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			if(!bool)
			{
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000398"));
			}

			/*
			  boolean bool1= true;
			  boolean bool2= true;
			  boolean bool3= true;
			  String str1 = "(([1-9]{1}[0-9]{0,14})|([0-9]{1})).[0-9]{2}";
			  String str2 = "(([1-9]{1}?[0-9]{0,14}?)|([0-9]{1}?)).[0-9]{2}?";
			  String str3 = "(([1-9]{1}+[0-9]{0,14}+)|([0-9]{1}+)).[0-9]{2}+";
			  amt = "123456789012345.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("1-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "1234567890123456.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("2-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "123456789012345.010";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("3-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			  //
			  amt = "0.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("4-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "1.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("5-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "00.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("6-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "0.010";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("7-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "-23456789012345.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("8-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = ".01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("9-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			
			  amt = "1234567890.01";
			  bool1 = amt.matches(str1);
			  bool2 = amt.matches(str2);
			  bool3 = amt.matches(str3);
			  log.info("10-bool:" + bool1 + "-" + bool2 + "-"  + bool3);
			  */
			return bool;
		}
        /**
        *   source:sysmod.@0122.script
        */
        public void checknotZ(IDatafield<BigDecimal> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			BigDecimal amt = field.getValue();
			int num = amt.signum();
			if(num<0)
			{
			  MdaUtils.clear(field);
			  
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000401"));
			  return;
			}
		}
        /**
        *   source:sysmod.@0123.script
        */
        public boolean checkIllegalSAmt(IDatafield<String> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检验数值是否合法，非负的校验，
			boolean bool= true;
			String amt = field.getValue();
			String str = "^0?\u0024|^([1-9][0-9]*)?\u0024";

			if(!MdaUtils.isEmpty(field))
			{
			  int pos = amt.indexOf(".");
			  if(pos>=0)
			  {
			    String pad = amt.substring(pos+1);
			    String pre = amt.substring(0, pos+1);
			    if(pad.length()>2)
			    {
			      pad=pad.substring(0, 2);
			      amt = pre+ pad;
			    }
			  }
			  bool = amt.matches(str);
			}
			if(!bool)
			{
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000407"));
			}

			return bool;
		}
        /**
        *   source:sysmod.@0124.script
        */
        public void checkInotZ(IDatafield<Integer> field)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Integer  amt= field.getValue();
			if(amt < 0)
			{
			  MdaUtils.clear(field);
			  
			  ctx.setFieldError(field,MdaUtils.getI18NString("sysmod","CT000409"));
			  return;
			}
		}
        /**
        *   source:sysmod.@0129.script
        */
        public String  creatHyFileName(String sptinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String inr = sptinr.substring(0,4);
			String hyFileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/data/hyfspt/"+inr+"/"+sptinr+".dat");
			return hyFileName;
		}
        /**
        *   source:sysmod.@0130.script
        */
        public String checkNam(String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			//查基础表
			String cpno1 = "";
			Argument<String> cpno =new Argument<String>("cpno");
			cpno.setValue("");
			String sql = " select c.cpno,c.cid from gid g ,pty p,cprt c where p.CID = c.cid and g.PTYINR = p.inr and g.ownref = '"+ownref+"' ";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{

			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbFetchFields(cpno);
			    cpno1 = cpno.value;
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setCpno(cpno1);
			  }
			  else
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			return cpno1;
		}









































































}