package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Grn;
import com.ceb.gjjs.mda.bo.Gitpush;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Szusraut;
import com.ceb.gjjs.mda.bo.Ebhmsg;
import com.ceb.gjjs.mda.bo.Gidattach;
import com.ceb.gjjs.mda.bo.Szgit;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ebhsnd;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sztmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sztmod.class);

        //提交
        private transient IControl save = new ControlImpl("save", "提交", this);

        //同意
        private transient IControl agree = new ControlImpl("agree", "同意", this);

        //退回合作平台
        private transient IControl returngjt = new ControlImpl("returngjt", "退回合作平台", this);

        //退回支行经办
        private transient IControl returnzjb = new ControlImpl("returnzjb", "退回支行经办", this);

        //退回分行经办
        private transient IControl returnfjb = new ControlImpl("returnfjb", "退回分行经办", this);

        //开始日期
        private Date begdat;

        //截止日期
        private Date enddat;

        //查询
        private transient IControl search = new ControlImpl("search", "查询", this);

        //机构名称
        private String ptynam;

        //交易名称
        private String frmtyp;

        //业务状态
        private String gidsta;

        //被退回业务
        private String isreturn;

        //查看
        private transient IControl show = new ControlImpl("show", "查看", this);

        //导出
        private IStream download = new StreamImpl();

        //主页
        private transient IControl retoff = new ControlImpl("retoff", "主页", this);

        //刷新
        private transient IControl refush = new ControlImpl("refush", "刷新", this);

        //参与办理业务
        private String hissav;

        //退回合作平台留言
        private String gidtxt;

        //取消
        private transient IControl back = new ControlImpl("back", "取消", this);

        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);

        //返回上层
        private transient IControl returnsel = new ControlImpl("returnsel", "返回上层", this);

        //拒绝
        private transient IControl disagree = new ControlImpl("disagree", "拒绝", this);

        //业务流水inr
        private String trninr;

        //业务参号
        @Module(getter = false, setter = false)
		private FieldHolder<String> ownref = new FieldConstantHolder<>("");


        //平台参号
        private String ptbusino;

        //关联流水号
        private String msgref;

        //提交
        private transient IControl savadd = new ControlImpl("savadd", "提交", this);

        //补充资料通知
        private transient IControl addimg = new ControlImpl("addimg", "补充资料通知", this);

        //返回
        private transient IControl ret = new ControlImpl("ret", "返回", this);

        //用户主键
        private String usrinr;


        @JsonIgnore
        @BDGetter
        private transient IPanel selbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel funbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel returntxt;

        @JsonIgnore
        @BDGetter
        private transient IPanel gitoszbut;

        @JsonIgnore
        @BDGetter
        private transient IPanel attachpnl;


	    @BDGetter
		private Grn grn;

	    @BDGetter
		private Trn gidtrn;

	    @BDGetter
		private Szusraut szusraut;

	    @BDGetter
		private Ebhmsg ebhmsg;

	    @BDGetter
		private Ebhsnd ebhsnd;

	    @BDGetter
		private Gidattach gidattach;

	    @BDGetter
		private Gitpush gitpush;

	    @BDGetter
		private Szgit szgit;


		public Sztmod()
        {
            super();
            setArgument();
        }

        public Sztmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sztmod.@0000.script
        */
        @Rule(target="back",order=100)
        public boolean ruleBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:sztmod.@0001.script
        */
        @Rule(target="save",order=50)
        public boolean ruleSaveN50(){
            IContext ctx = MdaEnv.getContext();
            
			//相关权限检验
			if(MdaUtils.prompt(MdaUtils.getI18NString("sztmod","CT000324"),MdaUtils.getI18NString("sztmod","CT000325")))
			{
			  return false;
			}
			log.debug("{}","save 50 start,cheak Business authority!");

			if(MdaUtils.isEmpty(this.getTrninr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000372"),MdaUtils.getI18NString("sztmod","CT000373"));
			  return false;
			}
			MdaUtils.clear(this.getGidtrn());
			MdaUtils.clear(this.getGrn());
			ctx.getDaoSession().dbRead(this.getGidtrn(),new Argument<String>("inr",this.getTrninr()));
			ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objinr",this.getTrninr()),new Argument<String>("objtyp","trn"));
			if(MdaUtils.isEmpty(this.getGrn().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000374"),MdaUtils.getI18NString("sztmod","CT000375"));
			  return false;
			}

			if(!this.chkAuthority(ctx.absGet(Sysmod.class).getUsr().getInr(),ctx.absGet(Sysmod.class).getPty().getLvl(),this.getGrn().getGidsta()))
			{
			  log.warn("{}","当前用户没有处理该笔业务的权限，退出！");
			  return false;
			}

			ctx.getDaoSession().dbBegin();

			return true;
        }

        /**
        *   source:sztmod.@0002.script
        */
        @Rule(target="imgviw",order=100)
        public boolean ruleImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}"," in imgviw....");
			ctx.getDaoSession().dbRead(ctx.absGet(Trnmod.class).getBnktrn(),new Argument("ownref",this.getOwnref()),new Argument("inifrm","gitosz"));
			log.info("{}","trninr = " + ctx.absGet(Trnmod.class).getBnktrn().getInr() + ",ownref = " + this.getOwnref());
			ctx.absGet(Trnmod.class).getItfmod().getImgmod().imgScans(ctx.absGet(Trnmod.class).getBnktrn().getInr());

			return true;
        }

        /**
        *   source:sztmod.@0003.script
        */
        @Rule(target="disagree",order=1000)
        public boolean ruleDisagreeN1000(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getGrn().getInr()))
			{
			  ctx.getDaoSession().dbRead(this.getGidtrn(),new Argument<String>("inr",this.getTrninr()));
			  ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objinr",this.getTrninr()),new Argument<String>("objtyp","trn"));
			}

			if("OO".equals(this.getGrn().getGidsta()))
			{
			  

			  
			  
			}
			else if("OA".equals(this.getGrn().getGidsta()))
			{
			  

			  
			  
			}
			else if("OB".equals(this.getGrn().getGidsta()))
			{
			  
			  

			  
			}
			else if("OE".equals(this.getGrn().getGidsta()))
			{
			  
			  

			  
			}
			else
			{
			  

			  
			  
			}
			
			
			

			

			return true;
        }

        /**
        *   source:sztmod.@0008.script
        */
        @Rule(target="save",order=1000)
        public boolean ruleSaveN1000(){
            IContext ctx = MdaEnv.getContext();
            
			ctx.getDaoSession().dbCommit();
			int error = ctx.getErrorCode();
			if(error!= NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000350"),MdaUtils.getI18NString("sztmod","CT000351"));
			  return false;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000352"),MdaUtils.getI18NString("sztmod","CT000353"));
			  
			  log.debug("{}","业务处理成功！");
			}

			return true;
        }

        /**
        *   source:sztmod.@0009.script
        */
        @Rule(target="save",order=800)
        public boolean ruleSaveN800(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","save 800 start");

			String rettyp=this.getGrn().getRettyp();
			log.info("{}","save 800 rettyp" + rettyp);
			//更新历史备注
			if("O".equals(rettyp))
			{
			  ctx.absGet(Rmkmod.class).setRmkMseeage(this.getGidtrn().getOrdinr(),this.getGidtrn().getInr(),"","01","NEW");
			}
			else
			{
			  ctx.absGet(Rmkmod.class).setRmkMseeage(this.getGidtrn().getOrdinr(),this.getGidtrn().getInr(),"","01","OLD");
			}

			//更新trn ,grn
			this.updateMessage("OA",rettyp,"G",true,ctx.absGet(Sysmod.class).getUsr().getInr());

			//更新ord
			ctx.absGet(Trnmod.class).getOrdmod().updateOrd(this.getGidtrn().getOrdinr(),"E","27","");

			//pdf存入
			if(!MdaUtils.isEmpty(ctx.absGet(Trnmod.class).getApldoc().getPdfdoc().getDoccnt()))
			{
			  ctx.absGet(Trnmod.class).getApldoc().setPDFFromContract();
			}

			//添加操作日志记录
			log.info("{}","ownref:" + this.getOwnref());
			ctx.absGet(Sysmod.class).setLog(this.getOwnref());

			log.debug("{}","save 800 结束");

			return true;
        }

        /**
        *   source:sztmod.@0011.script
        */
        @Rule(target="returngjt",order=100)
        public boolean ruleReturngjtN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(!this.chkAuthority(ctx.absGet(Sysmod.class).getUsr().getInr(),ctx.absGet(Sysmod.class).getPty().getLvl(),this.getGrn().getGidsta()))
			{
			  log.warn("{}","当前用户没有处理该笔业务的权限，退出！");
			  return false;
			}

			if(MdaUtils.isEmpty(this.getGidtxt()))
			{
			  ctx.setFieldError(this,"gidtxt",MdaUtils.getI18NString("sztmod","CT000390"));
			  return true;
			}

			ctx.getDaoSession().dbBegin();
			String frm=this.getGidtrn().getInifrm();
			String gidtxt=this.getGidtxt();
			String msgref= this.getMsgref();
			log.info("{}","msgref" + msgref);
			String msgno="";
			Map sendMap = new HashMap();
			sendMap.put("ptbusino",this.getPtbusino());
			sendMap.put("bkbusino",this.getGidtrn().getOwnref());

			sendMap.put("lgstatus","1");
			sendMap.put("describe",gidtxt);

			if("gitosz".equals(frm))
			{
			  msgno="EBH102";
			  sendMap.put("opendate","");
			}
			else if("gitasz".equals(frm))
			{
			  msgno="EBH104";
			}
			else
			{
			}
			ctx.absGet(Sysmod.class).setSzHeaderMap(msgno,"",sendMap,msgref);
			this.insertEbhmsg(msgno,this.getGidtrn().getObjinr(),this.getGidtrn().getObjtyp(),frm,sendMap);

			String ordinr=this.getGidtrn().getOrdinr();
			String trninr=this.getGidtrn().getInr();
			String rettyp=this.getRettyp(true,this.getGrn().getGidsta());
			String rvl=this.getRvl(false,"",rettyp);
			if(!"O".equals(this.getGrn().getRettyp()))
			{
			  rettyp=this.getGrn().getRettyp()+rettyp;
			}

			String flg="OLD";
			if("OO".equals(this.getGrn().getGidsta()))
			{
			  if(!this.setAllPanels(frm,trninr))
			  {
			    log.debug("{}","相关快照存入失败！");
			    ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000407"),MdaUtils.getI18NString("sztmod","CT000408"));
			    return false;
			  }

			  if(!"O".equals(this.getGrn().getRettyp()))
			  {
			    flg="new";
			  }
			}

			//Platform.clear($\\rmkmod\\ntext);
			log.info("{}","errorcode1 = " + ctx.getErrorCode());
			this.updateMessage("OE",rettyp,"R",false,"");   //更新grn,trn
			log.info("{}","errorcode2 = " + ctx.getErrorCode());
			ctx.absGet(Rmkmod.class).setRmkMseeage(ordinr,trninr,gidtxt,rvl,flg);   //更新rmk
			log.info("{}","errorcode3 = " + ctx.getErrorCode());
			String txt=ctx.absGet(Rmkmod.class).getRmk().getTxt();
			ctx.absGet(Trnmod.class).getOrdmod().updateOrd(ordinr,"B","33","");
			log.info("{}","errorcode4 = " + ctx.getErrorCode());

			//Platform.clear($grn);
			//Platform.clear($gidtrn);
			//Platform.clear($gidtxt);
			//Platform.clear($\\rmkmod\\rmk);
			
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000409"),MdaUtils.getI18NString("sztmod","CT000410"));
			  return false;
			}

			ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000411"),MdaUtils.getI18NString("sztmod","CT000412"));
			
			
			log.debug("{}","业务退回成功！");

			return true;
        }

        /**
        *   source:sztmod.@0013.script
        */
        @Rule(target="savadd",order=100)
        public boolean ruleSavaddN100(){
            IContext ctx = MdaEnv.getContext();
            
			//校验界面输入
			if(MdaUtils.isEmpty(this.getGidattach().getAttachno()))
			{
			  ctx.setFieldError(this,"gidattach.attachno",MdaUtils.getI18NString("sztmod","CT000424"));
			  return false;
			}
			if(MdaUtils.isEmpty(this.getGidattach().getAttachinfo()))
			{
			  ctx.setFieldError(this,"gidattach.attachinfo",MdaUtils.getI18NString("sztmod","CT000425"));
			  return false;
			}
			//生成业务报文
			ctx.getErrorCode();
			ctx.getDaoSession().dbBegin();
			String msgref= this.getMsgref();
			log.info("{}","msgref：" + msgref);
			log.info("{}","ptbusino：" + this.getGidattach().getPtbusino());
			String msgno="EBH114";
			Map sendMap = new HashMap();
			String inifrm = this.getGidattach().getInifrm();
			if("gitosz".equals(inifrm))
			{
			  sendMap.put("ptbusino",this.getGidattach().getPtbusino());
			  sendMap.put("trans","O");
			}
			else if("gitasz".equals(inifrm))
			{
			  sendMap.put("ptbusino",this.getGidattach().getOwnref());
			  sendMap.put("trans","A");
			}
			sendMap.put("noticeno",this.getGidattach().getAttachno());
			sendMap.put("filedesp",this.getGidattach().getAttachinfo());
			ctx.absGet(Sysmod.class).setSzHeaderMap(msgno,"",sendMap,msgref);
			this.insertEbhmsg(msgno,this.getGidtrn().getObjinr(),this.getGidtrn().getObjtyp(),inifrm,sendMap);
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000474"),MdaUtils.getI18NString("sztmod","CT000475"));
			  return false;
			}
			//信息入库
			this.getGidattach().setMuser(MdaEnv.getLoginUser());

			this.getGidattach().setCredat(MdaUtils.today());
			this.getGidattach().setSta("A");

			this.getGidattach().setInr(Platform.sdbCounter("gidattach"));
			ctx.getDaoSession().dbInsert(this.getGidattach());
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000476"),MdaUtils.getI18NString("sztmod","CT000477"));
			  return false;
			}
			ctx.getDaoSession().dbCommit();
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.getDaoSession().dbRollback();
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000496"),MdaUtils.getI18NString("sztmod","CT000497"));
			  return false;
			}

			ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000498"),MdaUtils.getI18NString("sztmod","CT000499"));
			
			MdaUtils.showMainPanel();
			log.debug("{}","业务退回成功！");

			return true;
        }

        /**
        *   source:sztmod.@0014.script
        */
        @Rule(target="addimg",order=100)
        public boolean ruleAddimgN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getGidtrn());
			MdaUtils.clear(this.getGrn());
			String inrs = this.getTrninr();
			if(MdaUtils.isEmpty(inrs))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000482"),MdaUtils.getI18NString("sztmod","CT000483"));
			  return false;
			}
			ctx.getDaoSession().dbRead(this.getGidtrn(),new Argument<String>("inr",inrs));
			ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objtyp","trn"),new Argument<String>("objinr",inrs));
			log.info("{}","init grn-inr:"+this.getGrn().getInr()+", gidtrn-inr : " + this.getGidtrn().getInr());
			if("OC|OD|OB|OA|OO".indexOf(this.getGrn().getGidsta())<0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000486"),MdaUtils.getI18NString("sztmod","CT000487"));
			  return false;
			}
			//为界面赋值回显业务信息
			MdaUtils.clear(this.getGidattach());
			this.getGidattach().setOwnref(this.getGidtrn().getOwnref());
			this.getGidattach().setPtbusino(this.getPtbusino());
			if(MdaUtils.isEmpty(this.getGidattach().getPtbusino()))
			{
			  MdaUtils.clear(this.getSzgit());
			  ctx.getDaoSession().dbRead(this.getSzgit(),new Argument<String>("inr",this.getGidtrn().getObjinr()));
			  this.getGidattach().setPtbusino(this.getSzgit().getPtbusino());
			}
			this.getGidattach().setGidsta(this.getGrn().getGidsta());
			this.getGidattach().setInifrm(this.getGidtrn().getInifrm());
			this.getGidattach().setUserinr(this.getUsrinr());
			this.getGidattach().setObjinr(this.getGidtrn().getObjinr());
			this.getGidattach().setObjtyp("gid");
			//生成退回参号
			String prefix = "AD" + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			// 默认同类交易当天不会有10000条
			prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("AD"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			this.getGidattach().setAttachno(prefix);
			//弹出补充信息界面
			

			return true;
        }

        /**
        *   source:sztmod.@0015.script
        */
        @Rule(target="ret",order=100)
        public boolean ruleRetN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }




        /**
        *   source:sztmod.@0004.script
        */
        public void updateMessage(String gidsta,String rettyp,String sta,boolean isSave,String usrinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getGrn().setCredat(MdaUtils.today());
			this.getGrn().setGidsta(gidsta);
			if(MdaUtils.isEmpty(rettyp))
			  rettyp = "O";
			this.getGrn().setRettyp(rettyp);

			if(isSave)
			{
			  if("OA".equals(gidsta))
			    this.getGrn().setZjbinr(usrinr);
			  else if("OB".equals(gidsta))
			    this.getGrn().setZfhinr(usrinr);
			  else if("OC".equals(gidsta))
			    this.getGrn().setFjbinr(usrinr);
			  else if("OD".equals(gidsta))
			    this.getGrn().setFfhinr(usrinr);
			}
			ctx.getDaoSession().dbUpdate(this.getGrn());     //更新grn处理流程表;
			
			this.getGidtrn().setSta(sta);
			ctx.getDaoSession().dbUpdate(this.getGidtrn());    //更新trn交易流水表
			
		}
        /**
        *   source:sztmod.@0005.script
        */
        public String getRettyp(boolean disagreeLv,String gidsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  disagreeLv  TRUE 经办退回高新投  ，false 退回下级经办
			  gidsta    业务当前进度 都为大写字母组合，从grn中获取值
			  */
			String ret="O";
			if("OO".equals(gidsta))
			{
			  ret="A";      //支行经办只能将业务退回高新投(disagreeLv=ture)
			}
			else if("OA".equals(gidsta))
			{
			  ret="B";     //支行复核只能将业务退回支行经办(disagreeLv=false)
			}
			else if("OB".equals(gidsta))
			{
			  if(disagreeLv)     //分行经办将业务退回高新投(disagreeLv=ture)
			  {
			    ret="D";
			  }
			  else             //分行经办将业务退回支行经办(disagreeLv=false)
			  {
			    ret="C";
			  }
			}
			else if("OC".equals(gidsta))
			{
			  ret="E";         //分行复核只能将业务退回分行经办(disagreeLv=false)
			}
			else if("OD".equals(gidsta))
			{
			  ret="F";         //国结处理中业务只能首先退回分行经办(disagreeLv=false)
			}
			else
			{
			  log.debug("{}","数据错误！");
			}

			log.debug("{}","退回阶段为："+ret);
			return ret;
		}
        /**
        *   source:sztmod.@0006.script
        */
        public String getRvl(boolean isSave,String gidsta,String rettyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  isSave: true 提交 ；false 退回
			  gidsta：退回参数为空
			  rettyp:    提交参数为空
			  A:支行经办退回高新投
			  B:支行复核退回支行经办
			  C:分行经办退回支行经办
			  D:分行经办退回高新投
			  E:分行复核退回分行经办
			  F:国结退回分行经办
			  */
			String rvl="00";   //零零
			if(isSave)
			{
			  if("OA".equals(gidsta))
			  {
			    rvl="01";
			  }
			  else if("OB".equals(gidsta))
			  {
			    rvl="02";
			  }
			  else if("OC".equals(gidsta))
			  {
			    rvl="03";
			  }
			  else
			  {
			    rvl="04";
			  }
			}
			else
			{
			  if("A".equals(rettyp))
			    rvl="05";
			  else if("B".equals(rettyp))
			    rvl="06";
			  else if("C".equals(rettyp))
			    rvl="07";
			  else if("D".equals(rettyp))
			    rvl="08";
			  else if("E".equals(rettyp))
			    rvl="09";
			  else if("F".equals(rettyp))
			    rvl="10";
			  else
			  {
			    log.debug("{}","参数错误！");
			  }
			}

			return rvl;
		}
        /**
        *   source:sztmod.@0007.script
        */
        public boolean chkAuthority(String usrinr,String lvl,String gidsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean chk=false;
			ctx.getDaoSession().dbRead(this.getSzusraut(),new Argument<String>("usrinr",usrinr));
			String cpno = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpno();
			log.debug("{}","平台类型："+cpno);
			if(MdaUtils.isEmpty(this.getSzusraut().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000284"),MdaUtils.getI18NString("sztmod","CT000285"));
			  chk=false;
			}
			else
			{
			  if("OO".equals(gidsta))
			  {
			    if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			    {
			      if("1".equals(this.getSzusraut().getAflg()) && "0".equals(this.getSzusraut().getBflg()))
			      {
			        chk=true;
			      }
			      else
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000286"),MdaUtils.getI18NString("sztmod","CT000287"));
			        chk=false;
			      }
			    }
			    else
			    {
			      if(!"2".equals(lvl))
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000288"),MdaUtils.getI18NString("sztmod","CT000289"));
			        chk=false;
			      }
			      else
			      {
			        if("1".equals(this.getSzusraut().getAflg()) && "0".equals(this.getSzusraut().getBflg()))
			        {
			          chk=true;
			        }
			        else
			        {
			          ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000290"),MdaUtils.getI18NString("sztmod","CT000291"));
			          chk=false;
			        }
			      }
			    }

			  }
			  else if("OA".equals(gidsta))
			  {
			    if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			    {
			      if("0".equals(this.getSzusraut().getAflg()) && "1".equals(this.getSzusraut().getBflg()))
			      {
			        chk=true;
			      }
			      else
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000292"),MdaUtils.getI18NString("sztmod","CT000293"));
			        chk=false;
			      }
			    }
			    else
			    {
			      if(!"2".equals(lvl))
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000294"),MdaUtils.getI18NString("sztmod","CT000295"));
			        chk=false;
			      }
			      else
			      {
			        if("0".equals(this.getSzusraut().getAflg()) && "1".equals(this.getSzusraut().getBflg()))
			        {
			          chk=true;
			        }
			        else
			        {
			          ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000296"),MdaUtils.getI18NString("sztmod","CT000297"));
			          chk=false;
			        }
			      }
			    }
			  }
			  else if("OB".equals(gidsta))
			  {
			    if(!"1".equals(lvl))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000298"),MdaUtils.getI18NString("sztmod","CT000299"));
			      chk=false;
			    }
			    else
			    {
			      if("1".equals(this.getSzusraut().getAflg()) && "0".equals(this.getSzusraut().getBflg()))
			      {
			        chk=true;
			      }
			      else
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000300"),MdaUtils.getI18NString("sztmod","CT000301"));
			        chk=false;
			      }
			    }
			  }
			  else if("OC".equals(gidsta))
			  {
			    if(!"1".equals(lvl))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000302"),MdaUtils.getI18NString("sztmod","CT000303"));
			      chk=false;
			    }
			    else
			    {
			      if("0".equals(this.getSzusraut().getAflg()) && "1".equals(this.getSzusraut().getBflg()))
			      {
			        chk=true;
			      }
			      else
			      {
			        ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000304"),MdaUtils.getI18NString("sztmod","CT000305"));
			        chk=false;
			      }
			    }
			  }
			  else if("OD".equals(gidsta))
			  {
			    ctx.setMessage(MdaUtils.getI18NString("sztmod","CT000306"),MdaUtils.getI18NString("sztmod","CT000307"));
			    chk=false;
			    /*if(!"1".equals(lvl))
			      {
			      Platform.message(#CT000556,#CT000557);
			      chk=false;
			      }
			      else
			      {
			      if("1".equals($szusraut\\aflg.getValue()) && "0".equals($szusraut\\bflg.getValue()))
			      {
			      chk=true;
			      }
			      else
			      {
			      Platform.message(#CT000558,#CT000559);
			      chk=false;
			      }
			      }*/
			  }
			}
			return chk;
		}
        /**
        *   source:sztmod.@0010.script
        */
        public void insertEbhmsg(String msgcod,String srcinr,String objtyp,String frm,Map msgcontent)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//msgcod :SFSXXX
			//srcinr:原业务 inr
			//msgcontent:实际报文内容
			//EBH102
			String msgid = (String)msgcontent.get("msgid");
			msgid = msgcod+msgid;
			log.info("{}","msg filename :"+msgid);
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(msgcontent);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"ebhmsg"),datstr);
			String inr = Platform.sdbCounter("ebhsnd");
			path = MdaUtils.catPath(path,msgid+".dat");
			java.io.File file = new java.io.File(path);
			if (!file.getParentFile().exists())
			{
			  file.getParentFile().mkdirs();
			}
			if (!file.exists())
			{
			  try
			  {
			    file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			    log.error("{}","*****  文件创建失败！");
			    log.error("{}",e.toString());
			  }
			}
			MdaUtils.saveContent(sendContent,path,"utf-8");
			log.info("{}","path="+path);
			log.info("{}","ebhsnd :"+sendContent);
			MdaUtils.clear(this.getEbhsnd());
			this.getEbhsnd().setInr(inr);
			//$ebhsnd\\cnt.setValue();
			this.getEbhsnd().setCredat(MdaUtils.today());
			//$ebhsnd\\mandate.setValue();
			this.getEbhsnd().setMsgcod(msgcod);
			this.getEbhsnd().setObjinr(srcinr);
			this.getEbhsnd().setObjtyp(objtyp);
			this.getEbhsnd().setMsgpath(path);
			//$ebhsnd\\senddate.setValue();
			this.getEbhsnd().setSta("W");
			this.getEbhsnd().setTrans(frm);
			//$ebhsnd\\muser.setValue();
			ctx.getDaoSession().dbInsert(this.getEbhsnd());
			log.debug("{}","ebhsnd inr is"+this.getEbhsnd().getInr());

			/*
			  String inr1 = Platform.sdbCounter("ebhmsg");
			  Platform.clear($ebhmsg);
			  $ebhmsg\\inr.setValue(inr1);
			  $ebhmsg\\msgpath.setValue(path);
			  $ebhmsg\\cnt.setValue(0);
			  $ebhmsg\\sta.setValue("W");
			  $ebhmsg\\msgcod.setValue(msgcod);
			  $ebhmsg\\credat.setValue(Platform.today());
			  $ebhmsg\\trans.setValue(Platform.getTransName());
			  $ebhmsg\\objinr.setValue(srcinr);
			  $ebhmsg\\objtyp.setValue(objtyp);
			  Platform.dbInsert($ebhmsg);
			  log.debug("ebhmsg inr is"+$ebhmsg\\inr.getValue());
			  */
		}
        /**
        *   source:sztmod.@0012.script
        */
        public boolean setAllPanels(String frm,String trninr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *获取快照面板
			  */
			log.debug("{}","存快照面板值");

			boolean result =false;
			//保存这几个界面的快照
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/trnsel.properties");
			String cpno = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCpno();
			log.debug("{}","保存快照时包含类型："+cpno);
			if(!MdaUtils.isEmpty(cpno) && "ZTB".equals(cpno))
			{
			  if("gitosz".equals(frm))
			  {
			    frm = "gitobj";
			  }
			  else if("gitasz".equals(frm))
			  {
			    //中投保修改，判断是增额还是减额
			    String sql = " select g.lgameamt,g.lgamt from gid g ,trn t where g.ownref = t.ownref and t.inr = '"+trninr+"' ";
			    Argument<BigDecimal> lgameamt = new Argument<BigDecimal>("lgameamt");
			    Argument<BigDecimal> lgamt = new Argument<BigDecimal>("lgamt");
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    ctx.getDaoSession().dbFetchFields(lgameamt,lgamt);
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      if((lgameamt.value).compareTo(lgamt.value)>0)
			      {
			        frm = "gitabj";
			      }
			      else
			      {//减额
			        frm = "gitabjj";
			      }
			    }
			    ctx.getDaoSession().dbCloseCursor();
			  }
			}
			log.debug("{}","保存快照时交易名称："+frm);
			String panelpaths= MdaUtils.getPropertyValue(file,frm);
			if(MdaUtils.isEmpty(panelpaths))
			{
			  log.debug("{}","未获取到相关面板值");
			  result=false;
			}
			else
			{
			  String[] panelpath =  panelpaths.split(",");
			  IPanel[] panels=new IPanel[panelpath.length];
			  for(int i=0;i < panelpath.length;i++)
			  {
			    IPanel panel = (IPanel)MdaDriver.getBaseObject(ctx.getRoot(),panelpath[i]);
			    panels[i]=panel;
			  }

			  //快照存在先删除
			  String disname="/data/dsp/"+trninr.substring(0,4)+"/"+trninr+".zul";
			  if(MdaUtils.fileExists(disname))
			  {
			    MdaUtils.fileDelete(disname);
			  }
			  log.debug("{}","panelpath.length is"+panelpath.length);
			  String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(trninr,"zul");
			  log.debug("{}","filename is "+filename);
			  ctx.saveDisplay(filename);
			  result =true;
			}
			return result;
		}

































































        public void setOwnrefHolder(FieldHolder<String> ownref)
        {
           this.ownref = (ownref);
        }

        public void setOwnref(String ownref)
        {
            this.ownref.setValue(ownref);
        }

        public String getOwnref()
        {
            return this.ownref.getValue();
        }













}