package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Tcosvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Tcosvr.class);



	    @BDGetter
		private Smh smh;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;


		public Tcosvr()
        {
            super();
            setArgument();
        }

        public Tcosvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:tcosvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  TCO - eTrade报文发送服务,srv为T时将生成的报文从sndxmltmp文件夹下移到sndxml文件夹下，并生成相应的就绪文件
			  */
			if(MdaUtils.isEmpty(this.getWfe().getSrvtxt()))
			  return Platform.errorHandle(this.getWfe(),"发报参数不能为空");  // FIXME
			// if((Boolean)Platform.invoke("com.brilliance.swift.SwitskUtils","send",$wfe\\srvtxt.getValue()+".txt"))
			
			/*
			  //CEB 报文不通过接口发送，由IFT发送 ,无链路测试
			  Thread current=Thread.currentThread();
			  // log.debug("current thread is="+current.getId());
			  Date date1=Platform.today();
			  //增加链路测试功能
			  //判断之前是否有发送失败过，及失败原因
			  if(!Platform.isEmpty($wfe\\rtycnt))
			  {
			  if("3".equals($wfe\\manflg.getValue()))
			  {
			  $wfe\\dattim.setValue(date1);
			  boolean flg= $this.linkTest();
			  if(flg==false)
			  {
			  return flg;
			  }
			  }
			  if("1".equals($wfe\\manflg.getValue()))
			  {
			  Date date2=$wfe\\dattim.getValue();
			  log.info("now time："+date1);
			  log.info("table dattim ：" +  date2);
			  Calendar compareTime = Calendar.getInstance();
			  compareTime.setTime(date2);
			  compareTime.add(Calendar.MINUTE,5);
			  Date compareDate=compareTime.getTime();
			  int compareNum = date1.compareTo(compareDate);
			  if(compareNum==0||compareNum==1 )
			  {
			  $wfe\\dattim.setValue(date1);
			  boolean flg= $this.linkTest();
			  if(flg==false)
			  {
			  return flg;
			  }
			  }
			  else
			  {
			  log.debug("链路测试等待时间未超过5分钟...");
			  return false ;
			  }
			  }
			  }
			
			  log.debug("发送业务报文...INR="+$wfe\\srvtxt.getValue()+".报文:"+$wfe\\srvtxt.getValue()+".xml");
			  */
			//CEB 报文不通过接口发送，由IFT发送
			//Map<String,String> msg = (Map<String,String>)$\\trnmod\\itfmod.scallInterface("dztstlsend","dztstlsend",new Object[]{$wfe\\srvtxt.getValue()+".xml"});
			//String errcod = msg.get("ERRORCODE");
			//判断文件是否存在
			String errcod = "";
			boolean isSuccess = false;
			String srvtxt = this.getWfe().getSrvtxt();
			log.info("{}","srvtxt :"+srvtxt);
			//在propertier文件中读取文件路径
			String profileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/dztpath.properties");
			log.debug("{}","文件路径配置文件：" + profileName);
			String localPath = MdaUtils.getPropertyValue(profileName,"DZTDZJDOUTPATH");
			String targetPath = MdaUtils.getPropertyValue(profileName,"DZTDZJDFINPATH");
			if(srvtxt.contains(","))
			{
			  String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  targetPath = MdaUtils.catPath(targetPath,datstr);

			  String[] farr = srvtxt.split(",");
			  String fileName = farr[0];
			  String bhdocName = "";
			  String docpath = "";
			  if(farr.length>1)
			  {
			    bhdocName = farr[1];
			    //docpath = targetPath+"/"+bhdocName+".docx";
			    ctx.getDaoSession().dbRead(ctx.absGet(Bimenu.class).getEbhfat(),new Argument<String>("inr",bhdocName));
			    docpath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),("/data/szdzbh/fatdir/" + ctx.absGet(Bimenu.class).getEbhfat().getCredat() )) + "/" + ctx.absGet(Bimenu.class).getEbhfat().getFilnam();
			    bhdocName = ctx.absGet(Bimenu.class).getEbhfat().getFilnam();
			  }
			  log.debug("{}","报文源路径:"+localPath );
			  //lst ok tar
			
			  //String okpath = targetPath+"/"+$wfe\\srvtxt.getValue()+".ok";
			  //String lstpath = targetPath+"/"+$wfe\\srvtxt.getValue()+".lst";
			  //String tarpath = targetPath+"/"+$wfe\\srvtxt.getValue()+".tar";
			  //String msgpath = localPath+"/"+fileName+".xml";
			
			  String okpath = targetPath+"/"+ fileName +".ok";
			  String lstpath = targetPath+"/"+ fileName +".lst";
			  String tarpath = targetPath+"/"+ fileName +".tar";
			  String msgpath = localPath+"/"+ fileName +".xml";

			  Map inmap = new HashMap();
			  inmap.put("okpath",okpath);
			  inmap.put("lstpath",lstpath);
			  inmap.put("tarpath",tarpath);
			  inmap.put("docpath",docpath);
			  inmap.put("msgpath",msgpath);
			  inmap.put("docfile",bhdocName);
			  inmap.put("msgfile",fileName);
			  //调用接口返回处理结果
			  try
			  {
			    Object obj = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","sztarfile","sztarfile",new Object[]{inmap});
			    // 判断接口是否调用成功
			    Boolean success = (Boolean) MdaUtils.invoke(obj,"isSuccess") ;
			    log.debug("{}","success=" + success);
			    if (!success )
			    {
			      String retCode = (String) MdaUtils.invoke(obj,"getReturnCode");
			      Object content = MdaUtils.invoke(obj,"getContent") ;
			      log.error("{}","ResultMsg.content = "  + content ) ;
			      log.debug("{}","调用接口平台调用失败。 { isSuccess = " +success ) ;
			    }
			    else
			    {
			      String content = MdaUtils.invoke(obj,"getContent").toString() ;
			      if("true".equals(content.substring(0,5).trim()))
			      {
			        log.debug("{}","调用接口平台成功。 { isSuccess = " +success ) ;
			        //启事务更新fzgit状态。
			        ctx.getDaoSession().dbBegin();
			        this.getWfe().setSta("D");
			        this.getWfe().setManflg("2");//状态更新
			        ctx.getDaoSession().dbUpdate(this.getWfe());
			        ctx.getDaoSession().dbCommit();
			        if("D".equals(this.getWfe().getSta()))
			          ctx.absGet(Trnmod.class).updateNextSvrState("T");
			        return true;
			      }
			      else
			      {
			        log.error("{}","ResultMsg.content = "  + content ) ;
			        log.debug("{}","接口调用返回失败。 { 错误码： " +content.substring(5,10) +"，错误 原因：" + content.substring(10).trim() ) ;
			      }
			    }
			  }
			  catch(Exception e)
			  {
			    ctx.getErrorCode();
			    log.error("{}","errormsg:" + e.getMessage());
			  }
			}
			else
			{
			  String fileName = this.getWfe().getSrvtxt()+".xml";
			  String locFilNam = localPath+"/"+fileName;
			  log.debug("{}","报文源路径:"+locFilNam );
			  String tarFilNam = targetPath+"/"+this.getWfe().getSrvtxt()+".ok";
			  log.debug("{}","报文目标路径:" + targetPath);
			  java.io.File f = new java.io.File(tarFilNam);
			  if(MdaUtils.fileExists(locFilNam))
			  {
			    isSuccess = MdaUtils.fileMove(locFilNam,targetPath);
			    log.debug("{}","isSuccess:" + isSuccess);
			    if(isSuccess)
			    {
			      try
			      {
			        f.createNewFile();
			        if(MdaUtils.fileExists(tarFilNam))
			        {
			          errcod = "00000";
			        }
			      }
			      catch(Exception e)
			      {
			        errcod = "0";
			        e.printStackTrace();
			      }
			    }
			    else
			    {
			      errcod = "0";
			      log.debug("{}","移动文件失败！");
			    }
			  }
			  else
			  {
			    errcod = "0";
			    log.debug("{}","报文不存在！");
			  }
			  // String errcod="00000";
			  log.debug("{}","errcod = " + errcod );
			  if("00000".equals(errcod))
			  {
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    this.getWfe().setManflg("2");//状态更新
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    ctx.getDaoSession().dbCommit();
			    if("D".equals(this.getWfe().getSta()))
			      ctx.absGet(Trnmod.class).updateNextSvrState("T");
			    return true;
			  }
			}
			// 发报错误 插入第一次发起链路测试的标志3
			if(MdaUtils.isEmpty(this.getWfe().getRtycnt())) this.getWfe().setManflg("3");
			return Platform.errorHandle(this.getWfe(),"发送失败，请联系管理员！");  // FIXME
					}
        /**
        *   source:tcosvr.@0002.script
        */
        public boolean linkTest()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//CEB20181115  暂时不需要链路测试
			//Map<String,String> msg =new HashMap<String,String>();
			//msg.put("ERRORCODE","00000");
			return true;
			/*
			  //1发送链路测试报文
			  log.debug("执行报文链路测试===================================...");
			  Map<String,String> msg = (Map<String,String>)$\\sysmod\\itfmod.scallInterface("dztlinktest","dztlinktest",new Object[]{"000000.xml"});
			  String errcod = msg.get("ERRORCODE");
			  if(!"00000".equals(errcod))
			  {
			  //链路测试失败,更新链路失败状态manflg
			  Platform.dbBegin();
			  $wfe\\manflg.setValue("1");
			  Platform.dbUpdate($wfe);
			  Platform.dbCommit();
			  log.info("链路测试失败(开始等待)...");
			  return false ;
			  }
			  return true;
			  */
		}



        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

}