package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Test extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Test.class);




		public Test()
        {
            super();
            setArgument();
        }

        public Test(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:test.@0004.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			/*
			  // Test Transaction: xmltsk'
			  log.debug("in test 单元测试模块 ... ");
			  List msg = $this.TestGet0401Msg();
			  Platform.invoke($\\,"processXmlIncoming", new Object[]{"Z00074",msg.get(0),msg.get(1)});
			  log.debug("out test 单元测试模块 ... ");
			  */

			return true;
        }


        /**
        *   source:test.@0000.script
        */
        public List<Map> TestGet0401Msg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<Map> list = new ArrayList<Map>();
			Map<String,Object> head = this.TestGetHeader("0401");
			Map<String,Object> body = this.TestGetMsgBody0401();
			list.add(0,head);
			list.add(1,body);
			return list;
		}
        /**
        *   source:test.@0001.script
        */
        public Map<String,Object> TestGetHeader(String jkbh)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> head = new HashMap<String,Object>();
			head.put("CROOT.MsgHead.JKBH",jkbh);
			head.put("CROOT.MsgHead.DQDH","08");
			head.put("CROOT.MsgHead.JGDH","101");
			head.put("CROOT.MsgHead.QTJYLSBH","");
			head.put("DROOT.MsgHead.FBRQ","Z00074201706270000000000456023");
			head.put("DROOT.MsgHead.FBRQ",MdaUtils.today());
			return head;
		}
        /**
        *   source:test.@0002.script
        */
        public Map<String,Object> TestGetMsgBody0401()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> body = new HashMap<String,Object>();
			body.put("XMLFIL","ou0000000000392384.xml");
			body.put("VROOT.MsgBody.HNGLBH","170627040019");
			body.put("CROOT.MsgBody.HKLX","2");
			body.put("CROOT.MsgBody.BWSX","2");
			body.put("VROOT.MsgBody.DLHDM","SICPZAJ1XXX");
			body.put("CROOT.MsgBody.DLHZHDH","081010100100000624");
			body.put("VROOT.MsgBody.JYCKH","170627040019");
			body.put("VROOT.MsgBody.XGCKH","2017062705740009");
			// body.put("VROOT.MsgBody.ZFBWBSH","08");
			// body.put("VROOT.MsgBody.ZFXGCKH","");
			body.put("DROOT.MsgBody.QXRQ",new Date());
			body.put("CROOT.MsgBody.JYHBFH","CNY");
			body.put("NROOT.MsgBody.JYJE",new BigDecimal(26.00));
			body.put("VROOT.MsgBody.FKRZH","321");
			body.put("VROOT.MsgBody.FKRHH","CIBKCNBJXXX");
			body.put("VROOT.MsgBody.FKRMC","vbb");
			body.put("VROOT.MsgBody.FKRDZ","cvbv");
			body.put("VROOT.MsgBody.FKRKHHZH","123");
			body.put("VROOT.MsgBody.FKRKHHHH","ICBKCNBJXXX");
			body.put("VROOT.MsgBody.FKRKHHMC","DASD");
			/*
			  body.put("VROOT.MsgBody.ZJQSH1ZH","");
			  body.put("VROOT.MsgBody.ZJQSH1HH","");
			  body.put("VROOT.MsgBody.ZJQSH1MC","");
			  body.put("VROOT.MsgBody.ZJQSH2ZH","");
			  body.put("VROOT.MsgBody.ZJQSH2HH","");
			  body.put("VROOT.MsgBody.ZJQSH2MC","");
			  body.put("VROOT.MsgBody.ZJQSH3ZH","");
			  body.put("VROOT.MsgBody.ZJQSH3HH","");
			  body.put("VROOT.MsgBody.ZJQSH3MC","");
			  */
			body.put("VROOT.MsgBody.SKRKHHZH","123321");
			body.put("VROOT.MsgBody.SKRKHHHH","CITICNSXXXX");
			body.put("VROOT.MsgBody.SKRKHHMC","2342424");
			body.put("VROOT.MsgBody.SKRZH","123");
			body.put("VROOT.MsgBody.SKRHH","ABOCCNBJXXX");
			body.put("VROOT.MsgBody.SKRMC","sdfs");
			body.put("VROOT.MsgBody.SKRDZ","adsd");
			/*
			  body.put("VROOT.MsgBody.HKFY","");
			  body.put("VROOT.MsgBody.FBHFY","");
			  body.put("VROOT.MsgBody.COVFBHFY","08");
			  body.put("VROOT.MsgBody.FJXX","");
			  body.put("CROOT.MsgBody.YSHBFH","");
			  body.put("NROOT.MsgBody.YSJE","");
			  body.put("NROOT.MsgBody.HL","");
			  */
			body.put("CROOT.MsgBody.FYCDF","1");
			/*
			  body.put("CROOT.MsgBody.FBHSFHBFH","");
			  body.put("NROOT.MsgBody.FBHSFJE","");
			  body.put("CROOT.MsgBody.SBHSFHBFH","");
			  body.put("NROOT.MsgBody.SBHSFJE","");
			  body.put("VROOT.MsgBody.XXDFBHDM","");
			  */
			body.put("CROOT.MsgBody.YWYXJ","0");
			body.put("CROOT.MsgBody.YWZLBM","99");
			//  body.put("VROOT.MsgBody.BZ","");
			
			return body;
		}

}