package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 代客制单
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Tplp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Tplp.class);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //单据预览
        private IStream preview = new StreamImpl();

        //提交
        private transient IControl sav = new ControlImpl("sav", "提交", this);

        //搜索
        private transient IControl search = new ControlImpl("search", "搜索", this);

        //取消
        private transient IControl cancel = new ControlImpl("cancel", "取消", this);

        //选择
        private transient IControl sure = new ControlImpl("sure", "选择", this);

        //发票
        private String ivnflg;

        //选择发票模板
        private transient IControl ivnsel = new ControlImpl("ivnsel", "选择发票模板", this);

        //选中发票模板inr
        private String ivninr;

        //提单
        private String tdflg;

        //选择提单模板
        private transient IControl tdsel = new ControlImpl("tdsel", "选择提单模板", this);

        //选中保单模板inr
        private String tdinr;

        //空运单
        private String kydflg;

        //选择空运单模板
        private transient IControl kydsel = new ControlImpl("kydsel", "选择空运单模板", this);

        //选中空运单模板inr
        private String kydinr;

        //快邮收据
        private String kysjflg;

        //选择快邮收据模板
        private transient IControl kysjsel = new ControlImpl("kysjsel", "选择快邮收据模板", this);

        //选中快邮收据模板inr
        private String kysjinr;

        //其他运输单据
        private String qtysdjflg;

        //选择其他运输单据模板
        private transient IControl qtysdjsel = new ControlImpl("qtysdjsel", "选择其他运输单据模板", this);

        //选中其他运输单据模板inr
        private String qtysdjinr;

        //保单
        private String bdflg;

        //选择保单模板
        private transient IControl bdsel = new ControlImpl("bdsel", "选择保单模板", this);

        //选中保单模板inr
        private String bdinr;

        //装箱单
        private String zxdflg;

        //选择装箱单模板
        private transient IControl zxdsel = new ControlImpl("zxdsel", "选择装箱单模板", this);

        //选中装箱单模板inr
        private String zxdinr;

        //装船通知
        private String zctzflg;

        //选择装船通知模板
        private transient IControl zctzsel = new ControlImpl("zctzsel", "选择装船通知模板", this);

        //选中装船通知模板inr
        private String zctzinr;

        //数量证
        private String slzflg;

        //选择数量证模板
        private transient IControl slzsel = new ControlImpl("slzsel", "选择数量证模板", this);

        //选中数量证模板inr
        private String slzinr;

        //产地证
        private String cdzflg;

        //选择产地证模板
        private transient IControl cdzsel = new ControlImpl("cdzsel", "选择产地证模板", this);

        //选中产地证模板inr
        private String cdzinr;

        //受益人证明
        private String syrzmflg;

        //选择受益人证明模板
        private transient IControl syrzmsel = new ControlImpl("syrzmsel", "选择受益人证明模板", this);

        //选中受益人证明模板inr
        private String syrzminr;

        //其他单据
        private String qtdjflg;

        //选择其他单据模板
        private transient IControl qtdjsel = new ControlImpl("qtdjsel", "选择其他单据模板", this);

        //选中其他单据模板inr
        private String qtdjinr;

        //下一步
        private transient IControl nxt = new ControlImpl("nxt", "下一步", this);

        //所有单据名称
        private String alldocnam;

        //选择类型
        private String seltyp;

        //单据inr数组
        private Object selinrs;

        //查询码表
        private Object seltbl;

        //客户编号
        private String ptyncid;

        //客户名称
        private String ptynam;


        @JsonIgnore
        @BDGetter
        private transient IPanel tplp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel tplp02;

        @JsonIgnore
        @BDGetter
        private transient IPanel tplp03;

        @JsonIgnore
        @BDGetter
        private transient IPanel tplp04;

        @JsonIgnore
        @BDGetter
        private transient IPanel tplp05;

        @JsonIgnore
        @BDGetter
        private transient IPanel tplp06;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Tplgrp> tplgrp;


		public Tplp()
        {
            super();
            setArgument();
        }

        public Tplp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }





        public void setTplgrpHolder(ModuleHolder<Tplgrp> tplgrp)
        {
           this.tplgrp = tplgrp;
        }

        public Tplgrp getTplgrp()
        {
           return this.tplgrp.get();
        }



































































































}