package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Ptyaut;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Modlst;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Usrsig;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Trnmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Trnmod.class);

        //币种
        @Module(getter = false, setter = false)
		private FieldHolder<String> cur = new FieldConstantHolder<>("");


        //金额
        @Module(getter = false, setter = false)
		private FieldHolder<BigDecimal> amt = new FieldConstantHolder<>();


        //参考号
        @Module(getter = false, setter = false)
		private FieldHolder<String> ownref = new FieldConstantHolder<>("");


        //归属银行
        @Module(getter = false, setter = false)
		private FieldHolder<String> bchcod = new FieldConstantHolder<>("");


        //业务表主键
        @Module(getter = false, setter = false)
		private FieldHolder<String> objinr = new FieldConstantHolder<>("");


        //业务所属机构
        @Module(getter = false, setter = false)
		private FieldHolder<String> ptyinr = new FieldConstantHolder<>("");


        //兴业经办机构
        private String oprogninr;

        //关联系统业务编号
        @Module(getter = false, setter = false)
		private FieldHolder<String> stlref = new FieldConstantHolder<>("");


        //ref sysmod.ownflg
        private String ownflg;

        //动态面板
        private IPanel panel;

        //流水号
        private String trninr;

        //通知生成的trninr
        private String advtrninr;



	    @BDGetter
		private Trn trn;

	    @BDGetter
		private Smh smh;

	    @BDGetter
		private Ptyaut ptyaut;

	    @BDGetter
		private Usrsig usrsig;

	    @BDGetter
		private Sigmod sigmod;

	    @BDGetter
		private Modlst modlst;

	    @BDGetter
		private Trn bnktrn;

	    @BDGetter
		private Ordmod ordmod;

	    @BDGetter
		private Wfmmod wfmmod;

	    @BDGetter
		private Itfmod itfmod;

	    @BDGetter
		private Spt sptchk;

	    @BDGetter
		private Apldoc apldoc;

	    @BDGetter
		private Btnmod btnmod;

	    @BDGetter
		private Usr usrtmp;


		public Trnmod()
        {
            super();
            setArgument();
        }

        public Trnmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getSigmod().setTrnHolder(()->this.getTrn());
            this.getOrdmod().setTrnHolder(()->this.getTrn());
            this.getApldoc().setTrnHolder(()->this.getTrn());
        }




        /**
        *   source:trnmod.@0000.script
        */
        public void sigWrite(String argsig,String argsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getUsrsig().setDattim(new Date());
			this.getUsrsig().setFrm(ctx.getTransName());
			this.getUsrsig().setSta(argsta);
			this.getUsrsig().setSig(argsig);
			this.getUsrsig().setOwnref(this.getTrn().getOwnref());
			this.getUsrsig().setTrninr(this.getTrn().getInr());
			this.getUsrsig().setUsrinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			this.getUsrsig().setLvl(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsraut().getLvl());
			Platform.sdbCounter(this.getUsrsig());
			ctx.getDaoSession().dbInsert(this.getUsrsig());
		}
        /**
        *   source:trnmod.@0001.script
        */
        public void setReleaseMethod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(this.getTrninr()))
			{
			  this.getPtyaut().setFlg("O");
			  this.getTrn().setNxtlev("");
			  this.getTrn().setRelreq("O");
			  this.getTrn().setNxtreq("O");
			}
			else
			{
			  log.info("{}","I am in setReleaseMethod....");
			  if(!MdaUtils.isEmpty(this.getPtyaut().getInr()))
			  {
			    log.info("{}","ptyaut.flg="+this.getPtyaut().getFlg());
			    MdaUtils.clear(this.getPtyaut());
			  }
			  log.info("{}","ownflg="+this.getOwnflg());
			  if(!"Y".equals(this.getOwnflg()))
			  {//for shanghang
			    String trnname=ctx.getTransName();
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).loadPtyaut(trnname);
			  }
			  else
			  {
			    this.getPtyaut().setFlg("O");
			  }
			  log.info("{}","I am out loadPtyaut....ptyaut.flg="+this.getPtyaut().getFlg()+",ownflg="+this.getOwnflg());
			  String flg=this.getPtyaut().getFlg();
			  log.info("{}","flg="+flg);
			  if(MdaUtils.isEmpty(flg))
			  {
			    flg="O";
			  }
			  this.getTrn().setRelreq(flg);
			  if(flg.length()==1)
			  {
			    //#CT000001
			    this.getTrn().setNxtlev("");
			    this.getTrn().setNxtreq("");
			    //...somgthing else to do
			    //$trn\\sta.setValue("");
			    return;
			  }
			  if(flg.length()>=2)
			  {
			    this.getTrn().setNxtreq(flg.substring(1,2));
			  }
			  //
			  if("B".equals(flg.substring(1,2)))
			  {
			    this.getTrn().setNxtlev("0");
			  }
			  else
			  {
			    //String lev=$ptyaut\\lvl.getValue();
			    this.getTrn().setNxtlev("1");
			  }
			}
			//log.info(" out setReleaseMethod(IN trnmod)....trn.relreq="+$trn\\relreq+",trn.relres="+$trn\\relres);
					}
        /**
        *   source:trnmod.@0002.script
        */
        public void setWorkflow(String argtyp,String arginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *功能：保存交易工作流
			  */
			this.getWfmmod().getWfs().setObjtyp(argtyp);
			this.getWfmmod().getWfs().setObjinr(arginr);
			this.getWfmmod().getWfs().setWfstxt(getTrnService(ctx.getTransName()));
			this.getWfmmod().getWfs().setInr(Platform.sdbCounter("wfs"));
			// 设置交易的工作流类型 -
			this.getWfmmod().getWfs().setWkftyp(this.getWfmmod().getWorkflowType(ctx.getTransName()));
			ctx.getDaoSession().dbInsert(this.getWfmmod().getWfs());

			String svrstr=this.getWfmmod().getWfs().getWfstxt();
			log.info("{}","[setWorkflow]交易要执行的工作流服务svr:["+this.getWfmmod().getWfs().getWfstxt()+"],交易需要的签字流程:["+this.getTrn().getRelreq()+"]");
			int len=svrstr.length();
			int i=0;
			while(i<len)
			{
			  String svr=svrstr.substring(i,i+1);
			  log.debug("{}","执行工作流服务配置 srv["+i+"]:"+svr );

			  if("S".equals(svr))
			  {
			    String flg=this.getTrn().getRelreq();
			    if(flg.length()==1)
			    {
			      log.info("{}","交易需要的授权签字流程为[O]:只需经办，不需要复合授权。");
			      this.getWfmmod().addWfe("S","W");
			      this.getTrn().setSta("R");
			      i++;
			    }
			    else
			    {
			      this.getWfmmod().addWfe("S","O");
			      i++;
			    }
			  }
			  if("P".equals(svr))
			  {
			    this.getWfmmod().addWfe("P","O");
			    i++;
			  }
			  if("E".equals(svr))
			  {
			    this.getWfmmod().addWfe("E","O");
			    i++;
			  }
			  if("M".equals(svr))
			  {
			    this.getWfmmod().addWfe("M","O");
			    i++;
			  }
			  if("T".equals(svr))
			  {
			    this.getWfmmod().addWfe("T","O");
			    i++;
			  }
			  //添加生成 XML报文工作流
			  if("X".equals(svr))
			  {
			    this.getWfmmod().addWfe("X","O");
			    i++;
			  }
			  if("N".equals(svr))
			  {
			    this.getWfmmod().addWfe("N","O");
			    i++;
			  }
			  if("F".equals(svr))
			  {
			    this.getWfmmod().addWfe("F","O");
			    i++;
			  }
			  if("(".equals(svr)  ||  ")".equals(svr))
			  {
			    i++;
			  }
			}
			log.info("{}","[setWorkflow]工作流服务设置完成。 ");
		}
        /**
        *   source:trnmod.@0004.script
        */
        public void ordNew()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","init--->ordNew()!");
			if(!MdaUtils.isEmpty(this.getWfmmod().getOrdinr()))
			{
			  if(!"NEW".equals(this.getWfmmod().getOrdinr()))
			  {
			  }
			}
			MdaUtils.clear(this.getOrdmod().getOrd());
			MdaUtils.clear(this.getOrdmod().getOre());
			this.getWfmmod().setOrdinr("NEW");
			log.info("{}","wfmmod\\ordinr is "+this.getWfmmod().getOrdinr());
		}
        /**
        *   source:trnmod.@0005.script
        */
        public void loadPtyaut(String transname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//1 NOTFOUND 2 OTHERERROR
			//#CT000005
			if("letfrc".equals(transname)  ||  "letfrd".equals(transname))
			  transname="letfre";
			if("brtfrc".equals(transname)  ||  "brtfrd".equals(transname))
			  transname="brtfre";
			if("bptopl".equals(transname)  ||  "bptopc".equals(transname))
			  transname="bptopn";
			//出口交单和审单确认
			//if("letatd".equals(transname)  ||  "letats".equals(transname))
			//transname="letatt";
			
			BigDecimal relamt=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getRelamt();
			log.info("{}"," in loadptyaut,relamt="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getRelamt());
			Argument<String> tinr=new Argument<String>("inr");
			int errorcode=-1;
			String ptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			String sql=null;
			log.info("{}","current party is "+ptyinr);
			if(!MdaUtils.isEmpty(ptyinr))
			{
			  sql=sdbGenSql("pty",ptyinr,transname,relamt);
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(tinr);
			  errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    log.info("{}","errorcode="+errorcode+",tinr="+tinr.value);
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","NO_MORE_ROW");
			    ctx.getDaoSession().dbCloseCursor();
			    sql=sdbGenSql("pty",ptyinr,transname+"0",relamt);
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    ctx.getDaoSession().dbFetchFields(tinr);
			    int ecode=ctx.getErrorCode();
			    if(ecode==NO_ERROR)
			    {
			      log.info("{}","tinr.value="+tinr.value);
			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			      ctx.getDaoSession().dbCloseCursor();
			      return;
			    }
			    else if (ecode==NO_MORE_ROW)
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      sql=sdbGenSql("pty",ptyinr,null,relamt);
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      ctx.getDaoSession().dbFetchFields(tinr);
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        log.info("{}","tinr.value="+tinr.value);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			    }
			    ctx.getDaoSession().dbCloseCursor();
			  }
			}
			//ety
			String etyinr= ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr();
			if (!MdaUtils.isEmpty(etyinr))
			{
			  sql=sdbGenSql("ety",etyinr,transname,relamt);
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(tinr);
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else if (errorcode==NO_MORE_ROW)
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    sql=sdbGenSql("ety",etyinr,transname+"0",relamt);
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    ctx.getDaoSession().dbFetchFields(tinr);
			    int ecode2=ctx.getErrorCode();
			    if (ecode2==NO_ERROR)
			    {

			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			      ctx.getDaoSession().dbCloseCursor();
			      return;
			    }
			    if (ecode2==NO_MORE_ROW)
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      sql=sdbGenSql("ety",etyinr,null,relamt);
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      ctx.getDaoSession().dbFetchFields(tinr);
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        log.info("{}","tinr.value="+tinr.value);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			    }
			    ctx.getDaoSession().dbCloseCursor();
			  }
			}
			//etg
			String etginr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEty().getInr();
			if (!MdaUtils.isEmpty(etginr))
			{
			  sql=sdbGenSql("etg",etginr,transname,relamt);
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  ctx.getDaoSession().dbFetchFields(tinr);
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {

			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			    ctx.getDaoSession().dbCloseCursor();
			    return;
			  }
			  else if (errorcode==NO_MORE_ROW)
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    sql=sdbGenSql("etg",etginr,transname+"0",relamt);
			    ctx.getDaoSession().dbExecuteSQL(sql);
			    ctx.getDaoSession().dbFetchFields(tinr);
			    int code3=ctx.getErrorCode();
			    if (code3==NO_ERROR)
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			      return;
			    }
			    else if (code3==NO_MORE_ROW)
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      sql=sdbGenSql("etg",etginr,null,relamt);
			      ctx.getDaoSession().dbExecuteSQL(sql);
			      ctx.getDaoSession().dbFetchFields(tinr);
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        log.info("{}","tinr.value="+tinr.value);
			        ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtyaut(),new Argument<String>("inr",tinr.value));
			        ctx.getDaoSession().dbCloseCursor();
			        return;
			      }
			    }
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}

			if(MdaUtils.isEmpty(this.getPtyaut().getFlg()))
			{
			  this.getPtyaut().setFlg("O");
			}
		}
        /**
        *   source:trnmod.@0006.script
        */
        public boolean trnSetFromContract()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 企业端经办保存业务流水TRN
			  *加载trn并判断
			  */
			/*if($\\sysmod.sptIsLoaded("B"))
			  {
			  log.info("trnSetFromContract... 加载退回业务的流水TRN.inr=" + $\\sysmod\\spt\\scrtxt );
			  Platform.dbRead($trn,new Argument<String>("inr",$\\sysmod\\spt\\scrtxt.getValue()));
			  }
			  */

			log.info("{}","trnSetFromContract... 加载退回业务的流水TRN.inr=" + ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrtxt());
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrninr()))  //单一窗口
			{
			  ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrninr()));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setWfm("D");
			}
			else
			{
			  log.info("{}","here 1:"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrtxt());
			  if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrtxt()))
			  {
			    ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScrtxt()));
			    log.info("{}","here 2:"+this.getTrn().getOrdinr());
			    if(!ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sptIsLoaded("B") && !"B".equals(this.getTrn().getSta()))
			    {
			      log.debug("{}","不是退回流程！");
			      MdaUtils.clear(this.getTrn());
			    }
			  }
			}
			String ptytyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp();
			String bnkptyinr =sdbGetPtyByBchcod(this.getBchcod());
			String bnketyinr=sdbGetEtyByPtyinr(this.getBchcod());
			String bnketginr=sdbGetEtg(bnketyinr);

			this.getTrn().setObjtyp( MdaDriver.getModuleType(MdaDriver.getModule(ctx.getRoot(),"mtabut\\rec")));

			this.getTrn().setObjinr(this.getObjinr());
			this.getTrn().setOwnref( this.getOwnref());
			log.info("{}","业务提交经办: pty="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr()+", ptytyp="+ptytyp +",cid="+ ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getCid());
			log.info("{}","业务归属机构：机构编号= "+this.getBchcod()+",实体="+bnketyinr+",实体组=" + bnketginr);
			log.info("{}","业务表名称="+this.getTrn().getObjtyp()+",业务表主键="+this.getTrn().getObjinr());
			if("3".equals(ptytyp))
			{
			  this.getTrn().setBchcod("");
			}
			else
			{
			  this.getTrn().setBchcod(this.getBchcod());
			}
			log.info("{}","cur="+this.getCur()+",amt="+this.getAmt());
			this.getTrn().setReloricur(this.getCur());
			this.getTrn().setReloriamt(this.getAmt());
			this.getTrn().setRelcur("USD");
			if(!setReleaseAmout())
			{
			  if(Platform.isFromApp())
			  {
			    ctx.setMessage("E9999","找不到该币种有效汇率信息,请通知管理员进行统计汇率维护。");
			  }
			  return false;
			}
			String ptyname=getPtyName(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr());
			this.getTrn().setNam(ptyname);
			if(!MdaUtils.isEmpty(ptyname))
			{
			  this.getTrn().setObjnam( this.getTrn().getReloricur()+""+this.getTrn().getReloriamt()+"/"+ptyname);
			}
			else
			{
			  this.getTrn().setObjnam(this.getTrn().getReloricur()+""+this.getTrn().getReloriamt());
			}
			this.getTrn().setInidattim(MdaUtils.today());
			this.getTrn().setInifrm(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getTrntiltle());
			this.getTrn().setIniusr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			this.getTrn().setSta("W");
			log.debug("{}","sta    值："+this.getTrn().getSta());
			if("NEW".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getOrdinr()))
			{
			  this.getTrn().setPtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr());
			  this.getTrn().setEtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getEtyinr());
			  this.getTrn().setEtginr(sdbGetEtg(this.getTrn().getEtyinr()));
			}
			// TODO ... 银行端业务处理待确定
			else
			{
			  this.getTrn().setPtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr());
			  if("0".equals(ptytyp) ||"1".equals(ptytyp) )
			  {
			    this.getTrn().setEtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getEtyinr());
			    this.getTrn().setEtginr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getEtg().getInr());
			  }
			}
			this.getTrn().setOptptyinr( bnkptyinr);
			this.getTrn().setOptetyinr( bnketyinr);
			this.getTrn().setOptetginr( bnketginr);
			this.getTrn().setModtyp( "0");
			this.getTrn().setPtytyp( ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp());
			//if(!$\\sysmod.sptIsLoaded("B"))
			if(MdaUtils.isEmpty(this.getTrn().getInr())&&Platform.isFromApp())
			  this.getTrn().setWfm("M");
			if(MdaUtils.isEmpty(this.getTrn().getInr()))
			  this.getTrn().setInr(Platform.sdbCounter("trn"));
			log.info("{}"," trnSetFromContract ... inr="+this.getTrn().getInr());
			return true;
		}
        /**
        *   source:trnmod.@0007.script
        */
        public String getInr(String table)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			int inr=(int)ctx.getDaoSession().dbCounter(table);
			int size=8;
			int temp=1;
			for(int i=0;i<size;i++)
			{
			  temp=temp*10;
			}
			temp=inr%temp;
			String tempStr=""+temp;
			int len=tempStr.length();
			if(len<size)
			{
			  int j=size-len;
			  for(int i=0;i<j;i++)
			  {
			    tempStr="0"+tempStr;
			  }
			}
			return tempStr;
		}
        /**
        *   source:trnmod.@0008.script
        */
        public void updateNextSvrState(String currentState)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","updateNextSvrState...currentState="+currentState);
			MdaUtils.clear(this.getWfmmod().getWfe());
			//  Platform.dbBegin();
			String svr=this.getWfmmod().getWfs().getWfstxt();
			log.info("{}","srv="+svr);
			if(MdaUtils.isEmpty(svr))
			{
			  log.error("{}","svr=null,and the nullpointer ...");
			  return;
			}
			int index=svr.indexOf(currentState);
			int bracketBegIndex=svr.indexOf("(");
			String nxtsvr=null;
			String wfsinr=this.getWfmmod().getWfs().getInr();
			ctx.getDaoSession().dbBegin();
			if(bracketBegIndex!=-1)
			{
			  int bracketEndIndex=svr.indexOf(")");
			  if(bracketBegIndex-index==1)
			  {
			    String svrlst=svr.substring(bracketBegIndex+1,bracketEndIndex);
			    int len=svrlst.length();
			    int i=0;
			    for(i=0;i<len;i++)
			    {
			      nxtsvr=svrlst.substring(i,i+1);
			      ctx.getDaoSession().dbRead(this.getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr),new Argument<String>("srv",nxtsvr));
			      this.getWfmmod().getWfe().setSta("W");
			      ctx.getDaoSession().dbUpdate(this.getWfmmod().getWfe());
			    }
			  }
			  else
			  {
			    nxtsvr=svr.substring(index+1,index+2);
			    ctx.getDaoSession().dbRead(this.getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr),new Argument<String>("srv",nxtsvr));
			    this.getWfmmod().getWfe().setSta("W");
			    ctx.getDaoSession().dbUpdate(this.getWfmmod().getWfe());
			  }
			}
			else
			{
			  log.debug("{}","index="+index);
			  nxtsvr=svr.substring(index+1,index+2);
			  log.info("{}","next svr="+nxtsvr);
			  ctx.getDaoSession().dbRead(this.getWfmmod().getWfe(),new Argument<String>("wfsinr",wfsinr),new Argument<String>("srv",nxtsvr));
			  this.getWfmmod().getWfe().setSta("W");
			  ctx.getDaoSession().dbUpdate(this.getWfmmod().getWfe());
			}
			ctx.getDaoSession().dbCommit();
			log.info("{}","update the service "+nxtsvr+" succeed!");
			log.info("{}","the new state is "+this.getWfmmod().getWfe().getSta());
		}
        /**
        *   source:trnmod.@0009.script
        */
        public String getWfd(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(inr))
			{
			  String sql="SELECT wfdinr FROM trn WHERE inr='"+inr+"'";
			  ctx.getDaoSession().dbExecuteSQL(sql);
			  int errorcode=ctx.getErrorCode();
			  if(errorcode==NO_ERROR)
			  {
			    Argument<String> wfdinr=new Argument<String>("wfdinr");
			    ctx.getDaoSession().dbFetchFields(wfdinr);
			    errorcode=ctx.getErrorCode();
			    if(errorcode==NO_ERROR)
			    {
			      ctx.getDaoSession().dbCloseCursor();
			      return wfdinr.value.toString();
			    }
			    else
			    {

			      ctx.setMessage("","Execute Error!");
			      ctx.getDaoSession().dbCloseCursor();
			      return null;
			    }
			  }
			  else
			  {
			    ctx.getDaoSession().dbCloseCursor();
			    return null;
			  }
			}
			else
			{
			  ctx.getDaoSession().dbCloseCursor();
			  return null;
			}
		}
        /**
        *   source:trnmod.@0011.script
        */
        public String sdbGetEty(String cid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ety = "" ;
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL("SELECT etyinr FROM pty WHERE cid= ? ",cid);
			Argument<String> etyinr=new Argument<String>("etyinr");
			ctx.getDaoSession().dbFetchFields(etyinr);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ety = etyinr.getValue();
			}
			return ety;
		}
        /**
        *   source:trnmod.@0012.script
        */
        public String sdbGetEtg(String etyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			if(MdaUtils.isEmpty(etyinr))
			{
			  return "";
			}
			String etg ="" ;
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL("SELECT etginr FROM ety WHERE inr= ? ",etyinr);
			Argument<String> etginr=new Argument<String>("etginr");
			ctx.getDaoSession().dbFetchFields(etginr);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  etg = etginr.getValue();
			}
			return etg;
		}
        /**
        *   source:trnmod.@0013.script
        */
        public void sdbRead(IModule mod,String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr));
			int errorcode=ctx.getErrorCode();
			return;
		}
        /**
        *   source:trnmod.@0014.script
        */
        public String getPtyName(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(inr))
			{
			  return null;
			}
			String ptyName = "" ;
			Argument<String> nam=new Argument<String>("nam");
			ctx.getDaoSession().dbExecuteSQL("SELECT nam FROM pty WHERE inr= ? ",inr);
			ctx.getDaoSession().dbFetchFields(nam);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ptyName = nam.getValue();
			}
			return ptyName;
		}
        /**
        *   source:trnmod.@0015.script
        */
        public void loadWfd()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","I am in loadWfd...!");
			//NOTFOUND 1
			//OTHERERROR 2,3,4...
			String transname=ctx.getTransName();
			Argument<String> tinr=new Argument<String>("inr");
			Argument<String> inr=new Argument<String>("inr");
			int errorcode=-1;
			//pty
			//String ptyinr=$\\sysmod\\pty\\inr.getValue();
			String ptyinr=null;
			String bchcod=this.getBchcod();
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM pty WHERE cid='"+bchcod+"'");
			ctx.getDaoSession().dbFetchFields(inr);
			errorcode=ctx.getErrorCode();
			if (errorcode==NO_ERROR)
			{
			  ptyinr=inr.value.toString();
			}
			else
			{
			  ctx.setMessage("",MdaUtils.getI18NString("trnmod","CT000013"));
			}
			ctx.getDaoSession().dbCloseCursor();
			/*
			  if("0".equals($\\sysmod\\pty\\ptytyp.getValue()))
			  {
			  if(!Platform.isEmpty($\\sysmod\\spt\\inr)&&!Platform.isEmpty($\\sysmod\\spt\\scrpty))
			  {
			  ptyinr=$\\sysmod\\spt\\scrpty.getValue();
			  }
			  }
			  else
			  {
			  ptyinr=$\\sysmod\\pty\\inr.getValue();
			  }
			  */
			log.info("{}","ptyinr="+ptyinr );
			if (!MdaUtils.isEmpty(ptyinr))
			{
			  ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","pty"),new Argument<String>("objinr",ptyinr),new Argument<String>("nam",transname));
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    return;
			  }
			  else
			  {
			    if (errorcode==NO_MORE_ROW)
			    {
			      log.info("{}","NO_MORE_ROW");
			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","pty"),new Argument<String>("objinr",ptyinr),new Argument<String>("nam",""));
			      errorcode=ctx.getErrorCode();
			      if (errorcode==NO_ERROR)
			      {
			        log.info("{}","wfdinr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr());
			        return;
			      }
			    }
			  }
			}
			//ety
			//String etyinr=$\\sysmod\\ety\\inr.getValue();
			String etyinr=sdbGetEty(bchcod);
			log.info("{}","etyinr="+etyinr );
			if (!MdaUtils.isEmpty(etyinr))
			{
			  ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","ety"),new Argument<String>("objinr",etyinr),new Argument<String>("nam",transname));
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    return;
			  }
			  else
			  {
			    if (errorcode==NO_MORE_ROW)
			    {
			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","ety"),new Argument<String>("objinr",etyinr),new Argument<String>("nam",""));
			      int ecode1=ctx.getErrorCode();
			      if (ecode1==NO_ERROR)
			      {
			        return;
			      }
			    }
			  }
			}
			//etg
			//String etginr=$\\sysmod\\etg\\inr.getValue();
			String etginr=sdbGetEtg(etyinr);
			log.info("{}","etginr="+etginr );
			if (!MdaUtils.isEmpty(etginr))
			{
			  ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","etg"),new Argument<String>("objinr",etginr),new Argument<String>("nam",transname));
			  errorcode=ctx.getErrorCode();
			  if (errorcode==NO_ERROR)
			  {
			    return;
			  }
			  else
			  {
			    if (errorcode==NO_MORE_ROW)
			    {
			      ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd(),new Argument<String>("objtyp","etg"),new Argument<String>("objinr",etginr),new Argument<String>("nam",""));
			      errorcode=ctx.getErrorCode();
			      if (errorcode==NO_ERROR)
			      {
			        return;
			      }
			      if (errorcode==NO_MORE_ROW)
			      {
			        ctx.setMessage("",MdaUtils.getI18NString("trnmod","CT000022"));
			        return;
			      }
			    }
			    else
			    {
			      ctx.setMessage("","Execute Error!");
			      return;
			    }
			  }
			}
		}
        /**
        *   source:trnmod.@0016.script
        */
        public void loadWft()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String wfdinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr();
			if(MdaUtils.isEmpty(wfdinr))
			{
			  ctx.setMessage("",MdaUtils.getI18NString("trnmod","CT000015"));
			  return;
			}
			String transname=ctx.getTransName();
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("frm",transname));
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjtyp();
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getObjinr();
			String stp=null;
			String inifrm=ctx.getTransName().toLowerCase();
			if("bnkspt".equals(inifrm))
			{
			  stp="3";
			}
			else if("littrs".equals(inifrm)  ||  "gittrs".equals(inifrm))
			{
			  stp="2";
			}
			else
			{
			  //stp="2";
			  stp="1";
			}
			log.info("{}","wfdinr"+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfd().getInr()+",objtyp="+objtyp+",objinr="+objinr+",stp="+stp);
			//Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("frm",transname));
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp),new Argument<String>("frm",transname));
			int errorcode=ctx.getErrorCode();
			if (errorcode==NO_ERROR)
			{
			  log.info("{}", "loadWft succeed");
			  return;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}", "loadWft NO_MORE_ROW,find next fix one");
			    //Platform.dbRead($\\trnmod\\wfmmod\\wft,new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("stp","2"));
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft(),new Argument<String>("wfdinr",wfdinr),new Argument<String>("objtyp",objtyp),new Argument<String>("objinr",objinr),new Argument<String>("dir","0"),new Argument<String>("stp",stp));
			    errorcode=ctx.getErrorCode();
			    if (errorcode==NO_ERROR)
			    {
			      log.info("{}", "find it ,loadWft succeed,inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWft().getInr());
			      return;
			    }
			    else
			    {
			      ctx.setMessage("",MdaUtils.getI18NString("trnmod","CT000016"));
			      return;
			    }
			  }
			  else
			  {
			    ctx.setMessage("","Execute error!");
			  }
			}
		}
        /**
        *   source:trnmod.@0019.script
        */
        public void deleteWfes(String wfsinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM wfe WHERE wfsinr='"+wfsinr+"'");
			Argument<String> inr = new Argument<String>("inr");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr);
			  int errorCode = ctx.getErrorCode();
			  log.info("{}",errorCode);
			  if(errorCode==NO_ERROR)
			  {
			    ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfe(),new Argument("inr",inr.value));
			    ctx.getDaoSession().dbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getWfe());
			  }
			  else if(errorCode==NO_MORE_ROW)
			  {
			    break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:trnmod.@0020.script
        */
        public String getPtysFromCid(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="SELECT inr FROM pty WHERE cid='"+bchcod+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  ret=inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:trnmod.@0021.script
        */
        public void noticeAck(IPanel panel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","ack being....");
			String ptytyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp();
			if("1".equals(ptytyp))
			{
			  this.setPanel(panel);
			  this.getSptchk().copyValue(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			  log.info("{}","after copy ,sptinr="+this.getSptchk().getInr()+",objtyp="+this.getSptchk().getObjtyp()+",objinr="+this.getSptchk().getObjinr());
			  return;
			}
			if(!"0".equals(ptytyp))
			{
			  ctx.getDaoSession().dbBegin();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setPtytyp(ptytyp);//
			  String frm=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getFrm();//
			  String modtyp=sdbGetModtyp(frm);//
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setModtyp(modtyp);//
			  log.debug("{}","modtyp=  "+modtyp);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setPtyinr( ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getPtyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setOptptyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr());
			  if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr()))
			  {
			    String bchcod=sdbGetBchcod(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setBchcod(bchcod);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setEtyinr(sdbGetEty(bchcod));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setEtginr(sdbGetEtg(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getEtyinr()));
			  }
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setStlref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getStlref());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setIniusr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setIniusr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(ctx.getRoot(),"mtabut\\rec")));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjnam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjnam());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setCfmdattim(new Date());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setInidattim(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getDattim());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setInifrm(ctx.getTransName());

			  if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getNam()))         //
			  {
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setNam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getNam());
			  }
			  else                                              //
			  {
			    String ptyname=getPtyName(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setNam(ptyname);
			  }                                                //
			
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setOwnref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOwnref());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setReloricur(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getTrncur());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setReloriamt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getTrnamt());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setSta("A");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setInr(Platform.sdbCounter("trn"));
			  ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setOriinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getResnum());
			  //获取STL影像批次号
			  log.debug("{}","imgref:" + ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getCreusr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setImgref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getCreusr());
			  // restore bus table
			  if("tran".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjinr()))
			    restoreBus();
			  //先存ord再存trn
			  this.getOrdmod().createOrdAndOre("订单通知","01");
			  ctx.getDaoSession().dbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn());
			  this.setAdvtrninr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr());
			  if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getInr()))
			  {
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().setObjtyp("trn");
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().setObjinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr());
			    ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh());
			  }
			  //save adv data
			  String trnname = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInifrm();
			  if("litdav".equals(trnname)||"cptsub".equals(trnname)||"letopn".equals(trnname))
			  {
			    Map<String,Object> data = new HashMap<String,Object>();
			    data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			    log.info("{}","adv 's size" +data.size());
			    String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr().substring(0,4));
			    String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			    String clsNam = "com.brilliance.swift.SwiftPacker";
			    MdaUtils.invoke(clsNam,"saveDataToFile",data,path,ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr()+".app");
			  }
			  String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr(),"zul");
			  log.info("{}","filename is "+filename);
			  ctx.saveDisplay(filename);
			  log.info("{}","Notice Ack by "+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr()+"!....end");
			  //转历史前将pdf，面函和报文信息存库
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getApldoc().generatorAllPDF();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getApldoc().setPDFFromContract();

			  MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn());
			  // 申请转历史
			  application2History();

			  if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr()))
			  {
			    ctx.getLocker().unlock(MdaEnv.getLoginUser());
			    log.debug("{}","del spt="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr());
			    ctx.getDaoSession().dbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			  }
			  MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			  // 处理gitpush
			  ctx.getDaoSession().dbCommit();
			}
			//加载按钮及pdf数据
			String ordinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().getOrd().getInr();
			log.debug("{}","ordinr:" + ordinr);
			ctx.getDaoSession().dbRead(this.getApldoc().getPdfdoc(),new Argument<String>("ordinr",ordinr));
			this.getBtnmod().initDocumentButton(ordinr);
		}
        /**
        *   source:trnmod.@0022.script
        */
        public String getCidFromInr(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rt=null;
			Argument<String> cid=new Argument<String>("cid");
			ctx.getDaoSession().dbExecuteSQL("SELECT cid FROM pty WHERE inr='"+inr+"'");
			ctx.getDaoSession().dbFetchFields(cid);
			int e=ctx.getErrorCode();
			if(e==NO_ERROR)
			{
			  rt=cid.value.toString();
			}
			else
			{
			  rt=null;
			}
			log.info("{}","return cid="+rt);
			ctx.getDaoSession().dbCloseCursor();
			return rt;
		}
        /**
        *   source:trnmod.@0023.script
        */
        public String getTrnService(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String trncode=trnname+".srv";
			String filename="transaction.properties";
			String tvalue=null;
			filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			log.info("{}", "properties filename="+filename);
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("Error",MdaUtils.getI18NString("trnmod","CT000028"));
			  return null;
			}
			else
			{
			  tvalue=MdaUtils.getPropertyValue(filename,trncode);
			  if(MdaUtils.isEmpty(tvalue))
			  {
			    log.info("{}","service is empty...");
			  }
			}
			return tvalue;
		}
        /**
        *   source:trnmod.@0024.script
        */
        public String sdbGetBchcod(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rt=null;
			Argument<String> cid=new Argument<String>("cid");
			ctx.getDaoSession().dbExecuteSQL("SELECT cid FROM pty WHERE inr=? ",inr);
			ctx.getDaoSession().dbFetchFields(cid);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  rt= cid.getValue();
			}
			return rt;
		}
        /**
        *   source:trnmod.@0028.script
        */
        public void signature()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// to fixme...
			log.info("{}","invoke signature...");
			String frame=this.getTrn().getInifrm();
			String ownref=this.getTrn().getOwnref();
			String camt=null;
			if(!MdaUtils.isEmpty(this.getTrn().getReloriamt()))
			{
			  camt=this.getTrn().getReloricur()+this.getTrn().getReloriamt().toString();
			}
			else
			{
			  camt=this.getTrn().getRelcur()+this.getTrn().getRelamt().toString();
			}
			String usr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getOprnam();
			frame=MdaUtils.getCodetableLabel("trans",frame);
			this.getSigmod().getSig().setSig("交易名称："+frame+"\r\n参考号："+ownref+"\r\n币种金额："+camt+"\r\n操作员："+usr);
			log.debug("{}","sig="+this.getSigmod().getSig().getSig());
			this.getSigmod().setFlg(NULLSTR);
			
			
			
			
			
			//log.info("该签名了，你为什么没弹出来呢？");
			this.getSigmod().setFlg("Y");
			
			//Platform.popup($sigmod\\sigp);
					}
        /**
        *   source:trnmod.@0029.script
        */
        public String sdbGenSql(String objtyp,String objinr,String trsnam,BigDecimal relamt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql=null;
			if("pty".equals(objtyp))
			{
			  if(!MdaUtils.isEmpty(trsnam))
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND frm='"+trsnam+"' AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			  else
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND (frm='' OR frm is null) AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			}
			else if("ety".equals(objtyp))
			{
			  if(!MdaUtils.isEmpty(trsnam))
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND frm='"+trsnam+"' AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			  else
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND (frm='' OR frm is null) AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			}
			else if("etg".equals(objtyp))
			{
			  if(!MdaUtils.isEmpty(trsnam))
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND frm='"+trsnam+"' AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			  else
			    sql="SELECT inr FROM ptyaut WHERE objtyp='"+objtyp+"' AND objinr='"+objinr+"' AND (frm='' OR frm is null) AND (lvl>'0' AND lowamt<="+relamt+" AND uppamt>"+relamt+" or lvl='0')";
			}
			return sql;
		}
        /**
        *   source:trnmod.@0031.script
        */
        public boolean isTcoIgnore(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			String filename=MdaUtils.catPath(path,"msg.properties");
			String tvalue=null;
			if(MdaUtils.fileExists(filename))
			{
			  tvalue=MdaUtils.getPropertyValue(filename,trnname);
			  if("y".equals(tvalue))
			    return true;
			}
			else
			  ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000032"),MdaUtils.getI18NString("trnmod","CT000033"));
			return false;
		}
        /**
        *   source:trnmod.@0032.script
        */
        public String getTcoMsgName(String trnname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String filename=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/msg.properties");
			if(!MdaUtils.fileExists(filename))
			  return trnname;
			String flgPath=null;
			flgPath=MdaUtils.getPropertyValue(filename,trnname+"_flg");
			if(MdaUtils.isEmpty(flgPath))
			  return trnname;
			IDatafield idFlg=MdaDriver.getDatafield(ctx.getRoot(),flgPath);
			if(MdaUtils.isEmpty(idFlg)  ||  MdaUtils.isEmpty(idFlg.getValue()))
			  return trnname;
			String flgValue = idFlg.getValue().toString();
			log.debug("{}","getmsg flgValue="+flgValue);
			String msgName = MdaUtils.getPropertyValue(filename,trnname+"_flg."+flgValue);
			if(!MdaUtils.isEmpty(msgName))
			  return msgName;
			return trnname;
		}
        /**
        *   source:trnmod.@0033.script
        */
        public void application2History()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：申请业务转为历史,在通知文件夹调用
			  */
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjinr();
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjtyp();
			String ptyinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr();
			//String[] list=$\\sysmod.getAplTrn();
			String[] list=null;
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/relation.properties");
			String apltrn=MdaUtils.getPropertyValue(file,ctx.getTransName());
			if(MdaUtils.isEmpty(apltrn))
			  return ;
			else
			  list=apltrn.split(",");
			log.info("{}","objinr="+objinr+",objtyp="+objtyp+",optptyinr="+ptyinr+",app frm=");
			ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp),new Argument<String>("optptyinr",ptyinr),new Argument<Object>("inifrm",IN,list));
			if(!MdaUtils.isEmpty(this.getTrn().getInr()))
			{
			  log.info("{}","trn inr="+this.getTrn().getInr());
			  this.getTrn().setSta("A");
			  ctx.getDaoSession().dbUpdate(this.getTrn());
			  MdaUtils.clear(this.getTrn());
			}
		}
        /**
        *   source:trnmod.@0034.script
        */
        public void noticeAckByBank(IPanel panel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			ctx.getDaoSession().dbBegin();
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setPtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getPtyinr());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setOptptyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr());
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr()))
			{
			  String bchcod=sdbGetBchcod(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setBchcod(bchcod);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setEtyinr(sdbGetEty(bchcod));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setEtginr(sdbGetEtg(bchcod));
			}
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setIniusr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjtyp(MdaDriver.getModuleType(MdaDriver.getModule(ctx.getRoot(),"mtabut\\rec")));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjnam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjnam());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setCfmdattim(new Date());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setInifrm(ctx.getTransName());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setNam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getNam());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setOwnref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOwnref());
			//notice ack
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setSta("A");
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setInr(Platform.sdbCounter("trn"));
			ctx.getDaoSession().dbInsert(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn());
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().getInr()))
			{
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().setObjtyp("trn");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh().setObjinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr());
			  ctx.getDaoSession().dbUpdate(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getSmh());
			}

			//savedisplay
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.info("{}","Notice Ack by "+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr()+"!....end");
			MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn());
			//bnkchk->annals
			application2History();
			//...here to delete spt...
			
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr()))
			{
			  ctx.getLocker().unlock(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getLgnnam());
			  ctx.getDaoSession().dbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			}

			MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			ctx.getDaoSession().dbCommit();
		}
        /**
        *   source:trnmod.@0035.script
        */
        public String getPtynamFromCid(String bchcod,String[] ptytyps)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="SELECT nam FROM pty WHERE cid='"+bchcod+"' and (ptytyp=";
			String conn="";
			for(String ptytyp:ptytyps)
			{
			  sql=sql+conn+"'"+ptytyp+"'";
			  conn=" or ptytyp=";
			}
			sql=sql+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> nam=new Argument<String>("nam");
			ctx.getDaoSession().dbFetchFields(nam);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  log.info("{}","in getPtyFromCid,ptynamr="+nam.value);
			  ret=nam.value;
			}
			else if(errorcode==NO_MORE_ROW)
			{
			  ret=null;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:trnmod.@0036.script
        */
        public String getPtyFromCid(String bchcod,String[] ptytyps)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ret=null;
			String sql="SELECT inr FROM pty WHERE cid='"+bchcod+"' and (ptytyp=";
			String conn="";
			for(String ptytyp:ptytyps)
			{
			  sql=sql+conn+"'"+ptytyp+"'";
			  conn=" or ptytyp=";
			}
			sql=sql+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  log.info("{}","in getPtyFromCid,ptyinr="+inr.value);
			  ret=inr.value;
			}
			else if(errorcode==NO_MORE_ROW)
			{
			  ret=null;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ret;
		}
        /**
        *   source:trnmod.@0037.script
        */
        public void restoreBus()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","tsf stlref = "+this.getStlref());
			if(MdaUtils.isEmpty(this.getStlref()))
			  return;
			String objtyp = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjtyp();
			String frm = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getFrm();
			log.debug("{}","type="+objtyp+" frm="+frm);
			if("com".equals(objtyp))
			  return;
			IModule module=MdaDriver.getModule(ctx.getRoot(),objtyp+"grp\\rec");
			if(MdaUtils.isEmpty(module))
			  return;
			String inr = reloadDataByArg(objtyp,"stlref",this.getStlref());
			IDatafield id = MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\rec\\inr");
			if(!MdaUtils.isEmpty(inr))
			{
			  id.setValue(inr);
			  ctx.getDaoSession().dbUpdate(module);
			  log.debug("{}","update "+objtyp+"inr="+id.getValue());
			}
			else
			{
			  inr = Platform.sdbCounter(objtyp);
			  id.setValue(inr);
			  ctx.getDaoSession().dbInsert(module);
			  log.debug("{}","insert "+objtyp+"inr="+id.getValue());
			  String[] ptsnams = getPtsnams(frm);
			  // TODO
			  IModule ptsmd = null;
			  IDatafield ptsarg = null;
			  String ptsinr=null;
			  for(String pts:ptsnams)
			  {
			    ptsmd=MdaDriver.getModule(ctx.getRoot(),objtyp+"grp\\"+pts+"\\pts");
			    ptsarg = MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\"+pts+"\\pts\\inr");
			    ptsinr = Platform.sdbCounter("pts");
			    ptsarg.setValue(ptsinr);
			    ptsarg = MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\"+pts+"\\pts\\objinr");
			    ptsarg.setValue(id.getValue());
			    ptsarg = MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\"+pts+"\\pts\\objtyp");
			    ptsarg.setValue(objtyp);
			    ptsarg = MdaDriver.getDatafield(ctx.getRoot(),objtyp+"grp\\"+pts+"\\pts\\rol");
			    ptsarg.setValue(pts);
			    log.debug("{}","inst "+pts+" inr="+ptsinr);
			    ctx.getDaoSession().dbInsert(ptsmd);
			  }
			}
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().setObjinr(inr);
		}
        /**
        *   source:trnmod.@0038.script
        */
        public String reloadDataByArg(String argtyp,String arg,String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT inr FROM "+argtyp+" WHERE "+arg+"='"+value+"' AND clsdat IS NULL";
			String inr = null;
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> objinr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(objinr);
			int errorCode = ctx.getErrorCode();
			if(errorCode == NO_ERROR)
			  inr = objinr.value;
			else
			  inr="";
			ctx.getDaoSession().dbCloseCursor();
			return inr;
		}
        /**
        *   source:trnmod.@0039.script
        */
        public String[] getPtsnams(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String[] ptsnams = {};
			if(MdaUtils.isEmpty(frm))
			  return ptsnams;
			if(frm.startsWith("le"))
			{
			  return new String[]{"apl","ben","isb"};
			}
			else if(frm.startsWith("li"))
			{
			  return new String[]{"apl","adv","ben"};
			}
			else if(frm.startsWith("bc"))
			{
			  return new String[]{"drr","dre","rmi"};
			}
			else if(frm.startsWith("bc"))
			{
			  return new String[]{"drr","dre","rmi"};
			}
			else if(frm.startsWith("be"))
			{
			  return new String[]{"isb","ben"};
			}
			else if(frm.startsWith("bo"))
			{
			  return new String[]{"drr","dre","clb"};
			}
			else if(frm.startsWith("bp"))
			{
			  return new String[]{"apl"};
			}
			else if(frm.startsWith("br"))
			{
			  return new String[]{"prb","ben","beb"};
			}
			else if(frm.startsWith("gi"))
			{
			  return new String[]{"apl","adv","isb","ben"};
			}
			return ptsnams;
		}
        /**
        *   source:trnmod.@0040.script
        */
        public void notselToAck(IPanel panel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *通知文件夹下批量转历史
			  */
			if(!"2".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp()))
			{
			  log.debug("{}","非企业客户无权批量转为历史.");
			  return ;
			}
			String objtyp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjtyp();
			String objinr=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjinr();
			String bnkptyinr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr();
			String strRef = getStlRef(objtyp,objinr);
			ctx.getDaoSession().dbBegin();
			this.getTrn().setPtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getPtyinr());
			this.getTrn().setEtyinr( this.sdbGetEtyByPtyinr(this.getTrn().getEtyinr()));
			this.getTrn().setEtginr( sdbGetEtg(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getEtyinr()));
			this.getTrn().setOptptyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr());
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOprogninr()))
			{
			  this.getTrn().setBchcod(sdbGetBchcod(bnkptyinr));
			  this.getTrn().setOptetyinr( sdbGetEty(this.getTrn().getBchcod()));
			  this.getTrn().setOptetginr( this.sdbGetEtg(this.getTrn().getOptetyinr()));
			}
			this.getTrn().setIniusr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			this.getTrn().setObjtyp(objtyp);
			this.getTrn().setObjnam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjnam());
			this.getTrn().setObjinr(objinr);
			this.getTrn().setCfmdattim(new Date());
			this.getTrn().setInidattim(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getDattim());
			this.getTrn().setInifrm(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getFrm());
			this.getTrn().setNam(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getNam());
			this.getTrn().setOwnref(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getOwnref());
			this.getTrn().setStlref(strRef);
			this.getTrn().setReloricur(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getTrncur());
			this.getTrn().setReloriamt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getTrnamt());
			//notice ack
			this.getTrn().setSta("A");
			this.getTrn().setInr(Platform.sdbCounter("trn"));
			log.debug("{}","trn inr="+this.getTrn().getInr());
			if("tran".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getObjinr()))
			  restoreBus();
			log.debug("{}","restoreBus");
			ctx.getDaoSession().dbInsert(this.getTrn());
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  this.getSmh().setObjtyp("trn");
			  this.getSmh().setObjinr(this.getTrn().getInr());
			  ctx.getDaoSession().dbUpdate(this.getSmh());
			}
			//save adv data
			String trnname = this.getTrn().getInifrm();
			if("litdav".equals(trnname)||"cptsub".equals(trnname)||"letopn".equals(trnname))
			{
			  Map<String,Object> data = new HashMap<String,Object>();
			  data=Platform.getValueMap(ctx.getRoot(),trnname,"PDF");
			  log.info("{}","adv 's size" +data.size());
			  String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr().substring(0,4));
			  String cfgpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			  String clsNam = "com.brilliance.swift.SwiftPacker";
			  MdaUtils.invoke(clsNam,"saveDataToFile",data,path,this.getTrn().getInr()+".app");
			}
			//savedisplay
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getTrn().getInr(),"zul");
			log.debug("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.debug("{}","Notice Ack by "+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getInr()+"!....end");
			MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn());
			application2History();
			//...here to delete spt...
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr()))
			{
			  ctx.getLocker().unlock(MdaEnv.getLoginUser());
			  log.debug("{}","del spt="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr());
			  ctx.getDaoSession().dbDelete(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			}

			MdaUtils.clear(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt());
			ctx.getDaoSession().dbCommit();
		}
        /**
        *   source:trnmod.@0041.script
        */
        public void setWorkflow(String argtyp,String arginr, String trnname )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *功能：保存交易工作流
			  */
			this.getWfmmod().getWfs().setObjtyp(argtyp);
			this.getWfmmod().getWfs().setObjinr(arginr);
			this.getWfmmod().getWfs().setWfstxt(getTrnService(trnname));
			this.getWfmmod().getWfs().setInr(Platform.sdbCounter("wfs"));
			// 设置交易的工作流类型
			this.getWfmmod().getWfs().setWkftyp(this.getWfmmod().getWorkflowType(trnname));
			ctx.getDaoSession().dbInsert(this.getWfmmod().getWfs());
			/*
			  String svrstr=$wfmmod\\wft\\srv.getValue();
			  log.info("svrstr="+$wfmmod\\wft\\srv);
			  */
			String svrstr=this.getWfmmod().getWfs().getWfstxt();
			log.info("{}","[setWorkflow]交易要执行的工作流服务svr:["+this.getWfmmod().getWfs().getWfstxt()+"],交易需要的签字流程:["+this.getTrn().getRelreq()+"]");

			if(MdaUtils.isEmpty(svrstr))
			{
			  log.debug("{}","当前交易未配置工作流。");
			  return ;
			}
			int len=svrstr.length();
			int i=0;
			while(i<len)
			{
			  String svr=svrstr.substring(i,i+1);
			  log.debug("{}","执行工作流服务配置 srv["+i+"]:"+svr );

			  if("S".equals(svr))
			  {
			    String flg=this.getTrn().getRelreq();
			    if(flg.length()==1)
			    {
			      log.info("{}","交易需要的授权签字流程为[O]:只需经办，不需要复合授权。");
			      this.getWfmmod().addWfe("S","W", trnname);
			      this.getTrn().setSta("R");
			      i++;
			    }
			    else
			    {
			      this.getWfmmod().addWfe("S","O", trnname);
			      i++;
			    }
			  }
			  if("P".equals(svr))
			  {
			    this.getWfmmod().addWfe("P","O",trnname);
			    i++;
			  }
			  if("E".equals(svr))
			  {
			    this.getWfmmod().addWfe("E","O", trnname);
			    i++;
			  }
			  if("M".equals(svr))
			  {
			    this.getWfmmod().addWfe("M","O",trnname);
			    i++;
			  }
			  if("N".equals(svr))
			  {
			    this.getWfmmod().addWfe("N","O",trnname);
			    i++;
			  }
			  if("T".equals(svr))
			  {
			    this.getWfmmod().addWfe("T","O",trnname);
			    i++;
			  }
			  //添加生成 XML报文工作流
			  if("X".equals(svr))
			  {
			    this.getWfmmod().addWfe("X","O",trnname);
			    i++;
			  }

			  if("F".equals(svr))
			  {
			    this.getWfmmod().addWfe("F","O",trnname);
			    i++;
			  }
			  if("(".equals(svr)  ||  ")".equals(svr))
			  {
			    i++;
			  }
			}
			log.info("{}","[setWorkflow]工作流服务设置完成。 ");
		}
        /**
        *   source:trnmod.@0043.script
        */
        public String getStlRef(String rec,String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","query stlrf :"+ rec);
			String ref =" ";
			Argument<String> stlref =new Argument<String>("stlref");
			String sql="SELECT stlref from "+rec+" where inr = '"+inr+"' ";
			log.debug("{}","===sql："+ sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(stlref);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  ref = stlref.value.toString();
			}
			else
			{
			  ref=null;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ref;
		}
        /**
        *   source:trnmod.@0045.script
        */
        public boolean accessRight( String usrinr ,String frmcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String frminr = "" ;
			if("-lxy-dxd-fxy-bxy-yxy-zxd-".indexOf(frmcod.substring(0,3)) > 0)
			{
			  frminr = "conbus" ; // 合同协议经办权限
			}
			else
			{
			  frminr = "combus" ; // 公共交易经办权限
			}
			Argument<String> trn =new Argument<String>("trn");
			String query="SELECT d.frminr trn FROM usr a,usrrol b,rol c,rolpro d WHERE b.usrinr=a.inr AND b.rolinr=c.inr AND b.rolinr=d.rolinr AND a.inr= ? AND trim(d.frminr)= ? ";
			log.debug("{}","query = " +query +  ", usrinr ="+usrinr+", frmcod =" + frmcod +",frminr= " + frminr );
			ctx.getDaoSession().dbExecuteSQL(query,usrinr,frminr);
			ctx.getDaoSession().dbFetchFields(trn);
			int ecode=ctx.getErrorCode();
			log.debug("{}","errorcode = " + ecode) ;
			if(ecode==NO_MORE_ROW)
			{
			  log.debug("{}","提示: 无权限访问该交易" );
			  ctx.setMessage(MdaUtils.getI18NString("trnmod","CT000058"),MdaUtils.getI18NString("trnmod","CT000059"));
			  ctx.getDaoSession().dbCloseCursor();
			  return false;
			}
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}
        /**
        *   source:trnmod.@0047.script
        */
        public void loadPtyautForBank(String transname,String ptyinr,String bnkfrm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：根据交易代码及和机构信息，返回交易授权签字信息 ，例如：OBA、OBAA 等
			  **/
			log.debug("{}","in loadPtyautForBank  :transname=" + transname +", ptyinr="+ ptyinr +",bnkfrm=" + bnkfrm);
			ctx.getErrorCode();
			MdaUtils.clear(this.getPtyaut());
			ctx.getDaoSession().dbRead(this.getPtyaut(),new Argument("objtyp","pty"),new Argument("objinr",ptyinr),new Argument("frm", transname),new Argument("bnkfrm",bnkfrm),new Argument("ptytyp","0"));
			int errorCode = ctx.getErrorCode();
			if(errorCode != NO_ERROR)
			{
			  ctx.getDaoSession().dbRead(this.getPtyaut(),new Argument("objtyp","pty"),new Argument("objinr",ptyinr),new Argument("frm", transname+"0"),new Argument("bnkfrm",bnkfrm),new Argument("ptytyp","0"));
			}
			errorCode =  ctx.getErrorCode();
			log.debug("{}","out loadPtyautForBank :ptyaut.flg = " + this.getPtyaut().getFlg());

		}
        /**
        *   source:trnmod.@0048.script
        */
        public boolean checkRight(String usrinr, String roleName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 检查用户是否是指定的角色
			  */
			boolean  havRight = false ;
			Argument<String> frm =new Argument<String>("frm");
			String query="SELECT d.frminr frm FROM usr a,usrrol b,rolpro d WHERE b.usrinr=a.inr AND b.rolinr=d.rolinr AND a.inr= ? AND trim(d.frminr)= ? ";
			ctx.getDaoSession().dbExecuteSQL(query,usrinr,roleName);
			ctx.getDaoSession().dbFetchFields(frm);
			int ecode=ctx.getErrorCode();
			if(ecode==NO_MORE_ROW)
			{
			  havRight = false ;
			}
			else
			{
			  havRight = true ;
			}
			return  havRight;
		}
        /**
        *   source:trnmod.@0049.script
        */
        public boolean haveSign(String user, String trn)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 检查当前用户是否已经签字
			  */
			boolean haveSign = false;
			Argument usrinr=new Argument("usrinr");
			String sql="SELECT usrinr FROM usrsig WHERE usrinr= ? and trninr= ? ";
			ctx.getDaoSession().dbExecuteSQL(sql,user,trn);
			ctx.getDaoSession().dbFetchFields(usrinr);
			int errCod =ctx.getErrorCode();
			ctx.getDaoSession().dbCloseCursor();
			if(errCod ==NO_ERROR)
			{
			  haveSign = true ;
			}
			return haveSign ;
		}
        /**
        *   source:trnmod.@0050.script
        */
        public boolean signCompleted(String relreq , String relres , int step)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 判断当前流程是否完成签字:主要用于银行端贸融业务的审核流程使用
			  * 参数 -  relreq：需要完成的签字列表
			  *	    -  relres：当前的签字列表（包含当前用户的签字）
			  *     -  step  ： 1 待办文件夹    2 客户经理文件夹   3 授权审核文件夹
			  */
			log.debug("{}","in signCompleted... relreq=" + relreq +",relres =" + relres +",step="+step);
			boolean completed = false ;
			int startIdx =  3 * (step - 1) ;
			relreq = relreq.substring(startIdx,startIdx + 3 );
			relres = relres.substring(startIdx);
			int len = relreq.indexOf("N");
			if(len > 0)
			{
			  relreq = relreq.substring(0,len);
			}
			log.debug("{}","in signCompleted...  return= " + relreq.equals(relres));
			return  relreq.equals(relres);

		}
        /**
        *   source:trnmod.@0051.script
        */
        public String getNxtreq(String relreq, String relres)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String nxtreq = "" ;
			if( relreq.equals(relres))
			{
			  return nxtreq ;
			}
			nxtreq = relreq.substring( relres.length(), relres.length() + 1 );
			if("N".equals(nxtreq))
			{
			  nxtreq = "O";
			}
			return nxtreq ;
		}
        /**
        *   source:trnmod.@0053.script
        */
        public boolean isFinancingTransaction(String transName, String ptytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 判断交易是否是融资类交易
			  */
			boolean isFin = false ;
			ctx.getErrorCode();
			MdaUtils.clear(this.getModlst());
			ctx.getDaoSession().dbRead(this.getModlst(),new Argument("frm", transName),new Argument("ptytyp", ptytyp));
			if(ctx.getErrorCode()== NO_ERROR && "F".equals(this.getModlst().getFintyp()))
			{
			  isFin = true ;
			}
			return isFin ;
		}
        /**
        *   source:trnmod.@0054.script
        */
        public String getReleaseMethodForBank(String transName, String ptyinr,String bnkfrm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 根据交易代码和银行机构Ptyinr获取交易在银行端的授权签字信息
			  */
			loadPtyautForBank(transName,ptyinr,bnkfrm);
			String relreq = this.getPtyaut().getFlg();
			if(MdaUtils.isEmpty(relreq))
			{
			  relreq ="ONN";
			}
			return relreq ;
		}
        /**
        *   source:trnmod.@0055.script
        */
        public void copyTransctionFiles(String srcName, String desName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String target=null;
			String rootpath=ctx.getEnvConfig().getRootPath();
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(srcName,"zul");
			target = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(desName,"zul");
			log.info("{}", "filename="+filename+",and target="+target);
			MdaUtils.fileCopy(filename,target);

			String sfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(srcName,"dra");
			String tfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(desName,"dra");
			if(MdaUtils.fileExists(sfile))
			  MdaUtils.fileCopy(sfile,tfile);

			String sappfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(srcName,"app");
			String tappfile = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(desName,"app");
			if(MdaUtils.fileExists(sappfile))
			  MdaUtils.fileCopy(sappfile,tappfile);
		}
        /**
        *   source:trnmod.@0056.script
        */
        public void sigWrite(String ownref, String trninr ,String argsig,String argsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getUsrsig().setDattim(new Date());
			this.getUsrsig().setFrm(ctx.getTransName());
			this.getUsrsig().setSta(argsta);
			this.getUsrsig().setSig(argsig);
			this.getUsrsig().setOwnref(ownref);
			this.getUsrsig().setTrninr(trninr);
			this.getUsrsig().setUsrinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsr().getInr());
			this.getUsrsig().setLvl(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getUsraut().getLvl());
			Platform.sdbCounter(this.getUsrsig());
			ctx.getDaoSession().dbInsert(this.getUsrsig());
		}
        /**
        *   source:trnmod.@0058.script
        */
        public String getTransactionFileName(String fileName,String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 返回交易产生的系统文件相对路径
			  */
			log.debug("{}","in getTransactionFileName ... ");
			if(MdaUtils.isEmpty(fileName) || MdaUtils.isEmpty(fileType))
			{
			  return "";
			}
			String file = "" ;
			String dir = "/data/" ;
			String inrStr = fileName.substring(0,4)+"/";
			String subDir= "" ;
			if("zul".equals(fileType))
			{
			  subDir =  "dsp/";
			}
			else  if("bak".equals(fileType))
			{
			  subDir = "delete/" ;
			}
			else  if("dra".equals(fileType) || "app".equals(fileType))
			{
			  subDir = "temp/" ;
			}
			else  if("dat".equals(fileType))
			{
			  subDir = "trndata/" ;
			}
			Platform.writeToSession("dspfile",fileName);//token，用来判断请求唯一性
			log.info("{}","session dspfile :"+Platform.readFromSession("dspfile"));
			file = dir+subDir+inrStr+fileName + "." + fileType;
			log.debug("{}","file=" + file );
			return file ;
		}
        /**
        *   source:trnmod.@0059.script
        */
        public String getNextFrameToBank(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 根据企业端的业务代码获取银行端的处理交易代码:例如，常规申请均提交到银行端待办文件（bnkspt）
			  *   福费廷总协议交易和保证金委托扣划交易，提交到银行端客户经理文件夹（trnmgr）
			  */
			// TODO 银行端处理交易-具体交易在处理
			
			return "bnkspt";
		}
        /**
        *   source:trnmod.@0060.script
        */
        public String getBankConfirmTrnnamByFrm(String inifrm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 获取银行端二次确认/协议补充修改交易代码
			  */

			String cfmtrn = "" ;
			if(!MdaUtils.isEmpty(inifrm))
			{
			  cfmtrn = inifrm.substring(0,3) +"cfm";
			}
			if("litapn".equals(inifrm))
			{
			  cfmtrn ="lxtcfm";
			}
			return cfmtrn;

		}
        /**
        *   source:trnmod.@0061.script
        */
        public void saveApplicationDataFile(String filename,String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 保存申请书PDF数据文件
			  */
			log.info("{}","开始保存申请文件");
			String clsNam = "com.brilliance.swift.SwiftPacker";
			String method = "saveDataToFile" ;
			// 数据集合
			Map<String,Object> data = Platform.getValueMap(ctx.getRoot(),ctx.getTransName(),"PDF");
			if(MdaUtils.isEmpty(data.get("OPRBCHCOD")))
			  data.put("OPRBCHCOD",ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getBchcod());
			// 文件路径
			String path = this.getSystemTempPath(filename);
			MdaUtils.invoke(clsNam,method,data,path,filename+"."+fileType);

		}
        /**
        *   source:trnmod.@0062.script
        */
        public String  getSystemTempPath(String filename)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			return MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"temp"),filename.substring(0,4));

		}
        /**
        *   source:trnmod.@0063.script
        */
        public void savePackDataFile(String filename,String fileType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 保存报文草稿数据文件
			  */
			log.info("{}","开始保存报文草稿文件");
			String clsNam = "com.brilliance.swift.SwiftPacker";
			String method = "packDataToFile" ;
			String trnname = ctx.getTransName();

			// 数据集合
			Map<String,Object> data=Platform.getValueMap(ctx.getRoot(),ctx.getTransName(),"DATA");
			// 文件路径
			String path = getSystemTempPath(filename);
			String configPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			MdaUtils.invoke(clsNam,method,getTcoMsgName(trnname),data,configPath,path,filename+"."+fileType);
		}
        /**
        *   source:trnmod.@0064.script
        */
        public void setTrnForSecondConfirm()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 设置企业端二次确认流水 -- TODO :后续整个二次确认流程流水的处理建议重新设计
			  */
			// 加载原业务TRN
			loadBankTrn();
			// 保存新的TRN
			this.getTrn().setRelreq( this.getReleaseMethodForBank(this.getBnktrn().getInifrm(),this.getBnktrn().getPtyinr(),"trncfm"));
			this.getTrn().setReloricur( this.getBnktrn().getReloricur());
			this.getTrn().setReloriamt( this.getBnktrn().getReloriamt());
			this.getTrn().setCpldattim( this.getBnktrn().getCpldattim());
			this.getTrn().setCfmdattim( this.getBnktrn().getCfmdattim());
			this.getTrn().setOptptyinr( this.getBnktrn().getOptptyinr());
			this.getTrn().setRelcur( this.getBnktrn().getRelcur());
			this.getTrn().setRelamt( this.getBnktrn().getRelamt());
			this.getTrn().setPtyinr( this.getBnktrn().getPtyinr());
			this.getTrn().setOwnref( this.getBnktrn().getOwnref());
			this.getTrn().setOrdinr( this.getBnktrn().getOrdinr());
			this.getTrn().setOptetyinr( this.getBnktrn().getOptetyinr());
			this.getTrn().setOptetginr( this.getBnktrn().getOptetginr());
			this.getTrn().setObjtyp( this.getBnktrn().getObjtyp());
			this.getTrn().setObjinr( this.getBnktrn().getObjinr());
			this.getTrn().setObjnam( this.getBnktrn().getObjnam());
			this.getTrn().setNxtreq( "O");
			this.getTrn().setNxtlev("0");
			this.getTrn().setNam( this.getBnktrn().getNam());
			this.getTrn().setIniusr( this.getBnktrn().getIniusr());
			this.getTrn().setInifrm( this.getBnktrn().getInifrm());
			this.getTrn().setInidattim( MdaUtils.today());
			this.getTrn().setEtyinr( this.getBnktrn().getEtyinr());
			this.getTrn().setEtginr(this.getBnktrn().getEtginr());
			this.getTrn().setBchcod( this.getBnktrn().getBchcod());
			this.getTrn().setSta("W");
			this.getTrn().setImgref( this.getBnktrn().getImgref());
			this.getTrn().setOriinr( this.getBnktrn().getOriinr());
			this.getTrn().setStlref( this.getStlref());
			this.getTrn().setInr(Platform.sdbCounter("trn"));
			ctx.getDaoSession().dbInsert(this.getTrn());
		}
        /**
        *   source:trnmod.@0065.script
        */
        public void loadBankTrn()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 加载原客户经理文件夹的TRN
			  */
			String trnnam = ctx.getTransName();
			String banktrn =(String) ctx.restoreData("com.brilliance."+trnnam+".bnktrn");
			if(!MdaUtils.isEmpty(banktrn))
			{
			  ctx.getDaoSession().dbRead(this.getBnktrn(),new Argument("inr", banktrn));
			}
		}
        /**
        *   source:trnmod.@0067.script
        */
        public boolean setReleaseAmout()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 设置业务复核金额
			  */
			boolean setflg = true;
			if("USD".equals(this.getTrn().getReloricur()))
			{
			  this.getTrn().setRelamt( this.getTrn().getReloriamt());
			}
			else if(!MdaUtils.isEmpty(this.getCur()))
			{
			  BigDecimal rate=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getCurRate(this.getCur());
			  if(rate != null)
			  {
			    BigDecimal relamt=this.getAmt().divide(rate,2,BigDecimal.ROUND_HALF_UP);
			    this.getTrn().setRelamt(relamt);
			  }
			  else
			    setflg = false ;
			}
			return setflg;
		}
        /**
        *   source:trnmod.@0068.script
        */
        public String sdbGetPtyByBchcod(String bchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rt=null;
			Argument<String> ptyinr=new Argument<String>("inr");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr FROM pty WHERE cid= ? and ptytyp='0' ",bchcod);
			ctx.getDaoSession().dbFetchFields(ptyinr);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  rt=ptyinr.getValue();
			}
			return rt;
		}
        /**
        *   source:trnmod.@0069.script
        */
        public String sdbGetEtyByPtyinr(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rt=null;
			Argument<String> etyinr=new Argument<String>("etyinr");
			ctx.getDaoSession().dbExecuteSQL("SELECT etyinr FROM pty WHERE inr=? ",inr);
			ctx.getDaoSession().dbFetchFields(etyinr);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  rt= etyinr.getValue();
			}
			return rt;
		}
        /**
        *   source:trnmod.@0070.script
        */
        public String sdbGetModtyp(String frm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rt=null;
			Argument<String> modtyp=new Argument<String>("modtyp");
			ctx.getDaoSession().dbExecuteSQL("SELECT distinct modtyp FROM modlst WHERE frm='"+frm+"'");
			ctx.getDaoSession().dbFetchFields(modtyp);
			ctx.getDaoSession().dbCloseCursor();
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  rt= modtyp.getValue();
			  log.debug("{}","rt=  "+rt);
			}
			return rt;
		}
        /**
        *   source:trnmod.@0071.script
        */
        public Map<String,String> getPDFInfo()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  从smh表中获取未解析报文和面函文件名，将其分类后存入表中。
			  主要存tempfile（标识及英文），label（中文名）
			  B：国结来报报文
			  C：国结来报面函
			  @return：包含tempfile和label的Map
			  */
			Map<String,String> cntLabel = new HashMap<String,String>();
			String label = "";
			String tempfile = "";
			log.info("{}","init load spt inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr());
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr()))
			{
			  cntLabel.put("label",",");
			  cntLabel.put("tempfile",",");
			  return cntLabel;
			}
			if("A".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScr())&&!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()))
			  ctx.getDaoSession().dbRead(this.getSmh(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()));
			log.debug("{}","sw2fils:"+ this.getSmh().getSf2fil());
			if(!MdaUtils.isEmpty(this.getSmh().getSf2fil()))
			{
			  String sw2fils = this.getSmh().getSf2fil();
			  String[] sw2fil = sw2fils.split(";");
			  log.debug("{}","sw2fils:"+ sw2fils);
			  log.debug("{}","sw2files.length=" + sw2fil.length );
			  for(int i=0;i<sw2fil.length;i++)
			  {
			    label = label+"报文"+i+",";
			    tempfile = tempfile+"B:sw"+i+",";
			  }
			}
			log.debug("{}","xmlfil====" + this.getSmh().getXmlfil());
			if(!MdaUtils.isEmpty(this.getSmh().getXmlfil()) && !MdaUtils.isEmpty(this.getSmh().getLabels()))
			{
			  String xmlfils =this.getSmh().getXmlfil();
			  String[] xmlfil = xmlfils.split(";");
			  String labfils = this.getSmh().getLabels();
			  String[] labfil = labfils.split(";");
			  log.debug("{}","xmlfils:" + xmlfils);
			  log.debug("{}","xmlfils:" + xmlfil.length);
			  log.debug("{}","labels:" + labfils);
			  for(int i=0;i<xmlfil.length;i++)
			  {
			    label = label+labfil[i]+",";
			    tempfile = tempfile+"C:notice"+i+",";
			  }
			}
			log.debug("{}","label:" + label);
			log.debug("{}","tempfile:" + tempfile);
			if(MdaUtils.isEmpty(label)&&MdaUtils.isEmpty(tempfile))
			{
			  label = ",";
			  tempfile = ",";
			}
			cntLabel.put("label",label);
			cntLabel.put("tempfile",tempfile);

			return cntLabel;
		}
        /**
        *   source:trnmod.@0072.script
        */
        public Map<String,String> getPDFInfo1()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  从smh表中获取未解析报文和面函文件名，将其分类后存入表中。
			  主要存tempfile（标识及英文），label（中文名）
			  B：国结来报报文
			  C：国结来报面函
			  @return：包含tempfile和label的Map
			  */
			Map<String,String> cntLabel = new HashMap<String,String>();
			String label = "";
			String tempfile = "";
			log.info("{}","init load spt inr="+ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr());
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getInr()))
			{
			  //cntLabel.put("label",",");
			  //cntLabel.put("tempfile",",");
			  return cntLabel;
			}
			if("A".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getScr())&&!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()))
			  ctx.getDaoSession().dbRead(this.getSmh(),new Argument<String>("inr",ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getSpt().getSmhinr()));
			log.debug("{}","sw2fils:"+ this.getSmh().getSf2fil());
			if(!MdaUtils.isEmpty(this.getSmh().getSf2fil()))
			{
			  String sw2fils = this.getSmh().getSf2fil();
			  String[] sw2fil = sw2fils.split(";");
			  log.debug("{}","sw2fils:"+ sw2fils);
			  log.debug("{}","sw2files.length=" + sw2fil.length );
			  for(int i=0;i<sw2fil.length;i++)
			  {
			    label = label+"报文"+i+",";
			    tempfile = tempfile+"B:sw"+i+",";
			  }
			}
			log.debug("{}","xmlfil====" + this.getSmh().getXmlfil());
			if(!MdaUtils.isEmpty(this.getSmh().getXmlfil()) && !MdaUtils.isEmpty(this.getSmh().getLabels()))
			{
			  String xmlfils =this.getSmh().getXmlfil();
			  String[] xmlfil = xmlfils.split(";");
			  String labfils = this.getSmh().getLabels();
			  String[] labfil = labfils.split(";");
			  log.debug("{}","xmlfils:" + xmlfils);
			  log.debug("{}","xmlfils:" + xmlfil.length);
			  log.debug("{}","labels:" + labfils);
			  for(int i=0;i<xmlfil.length;i++)
			  {
			    label = label+labfil[i]+",";
			    tempfile = tempfile+"C:notice"+i+",";
			  }
			}
			log.debug("{}","label:" + label);
			log.debug("{}","tempfile:" + tempfile);
			/*if(Platform.isEmpty(label)&&Platform.isEmpty(tempfile))
			  {
			  label = ",";
			  tempfile = ",";
			  }*/
			cntLabel.put("label",label);
			cntLabel.put("tempfile",tempfile);

			return cntLabel;
		}
        /**
        *   source:trnmod.@0073.script
        */
        public void goHistory(String objinr,String objtyp,String trans,IPanel page,String txt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","objinr objtyp:"+objinr+"  "+objtyp );
			if(MdaUtils.isEmpty(this.getBnktrn().getInr()))
			{
			  ctx.getDaoSession().dbRead(this.getBnktrn(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp));
			}
			if(!MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getBch().getInr()))
			{
			  this.getBnktrn().setPtyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getBch().getInr());
			  this.getBnktrn().setOptptyinr(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getBch().getInr());
			}
			this.getBnktrn().setSta("A");
			// $bnktrn\\etyinr.setValue($\\sysmod\\ety\\inr.getValue());
			//  $bnktrn\\etginr.setValue($\\sysmod\\etg\\inr.getValue());
			//  $bnktrn\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			
			// $bnktrn\\optetyinr.setValue($\\sysmod\\ety\\inr.getValue());
			// $bnktrn\\optetginr.setValue($\\sysmod\\etg\\inr.getValue());
			
			this.getBnktrn().setCpldattim( MdaUtils.today());
			this.getBnktrn().setNxtreq("");
			this.getBnktrn().setOriinr(this.getBnktrn().getInr());
			ctx.getDaoSession().dbUpdate(this.getBnktrn());
			//更新ord表、新增ore
			String ordinr = this.getOrdmod().getOrd().getInr();
			if(MdaUtils.isEmpty(this.getOrdmod().getOrd().getInr()))
			{
			  ordinr = this.getBnktrn().getOrdinr();
			  ctx.getDaoSession().dbRead(this.getOrdmod().getOrd(),new Argument<String>("inr",ordinr));
			}
			this.getOrdmod().getOrd().setSta("D");
			ctx.getDaoSession().dbUpdate(this.getOrdmod().getOrd());
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).getRmk(),new Argument<String>("ordinr",ordinr));

			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).getRmk().getInr()))
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).createDRemark(ordinr,this.getBnktrn().getInr(),txt);

			this.getOrdmod().getOre().setInr(Platform.sdbCounter("ore"));
			this.getOrdmod().getOre().setBegdattim(MdaUtils.today());
			this.getOrdmod().getOre().setEnddattim(MdaUtils.today());
			this.getOrdmod().getOre().setFrm(trans);
			this.getOrdmod().getOre().setObjinr(objinr);
			this.getOrdmod().getOre().setObjtyp(objtyp);
			this.getOrdmod().getOre().setOrdinr(ordinr);
			this.getOrdmod().getOre().setTxt("订单完成");
			this.getOrdmod().getOre().setTyp("D");
			this.getOrdmod().getOre().setAction("21");
			ctx.getDaoSession().dbInsert(this.getOrdmod().getOre());
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getBnktrn().getInr(),"zul");
			log.info("{}","filename :"+filename);
			ctx.saveDisplay(filename);
			ctx.getErrorCode();
		}
        /**
        *   source:trnmod.@0074.script
        */
        public void goHistoryA(String objinr,String objtyp,String trans,IPanel page)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","objinr objtyp:"+objinr+"  "+objtyp );
			if(MdaUtils.isEmpty(this.getBnktrn().getInr()))
			{
			  ctx.getDaoSession().dbRead(this.getBnktrn(),new Argument<String>("objinr",objinr),new Argument<String>("objtyp",objtyp));
			}
			this.getBnktrn().setSta("A");
			/*$bnktrn\\etyinr.setValue($\\sysmod\\ety\\inr.getValue());
			  $bnktrn\\etginr.setValue($\\sysmod\\etg\\inr.getValue());
			  $bnktrn\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $bnktrn\\ptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $bnktrn\\optptyinr.setValue($\\sysmod\\pty\\inr.getValue());
			  $bnktrn\\optetyinr.setValue($\\sysmod\\ety\\inr.getValue());
			  $bnktrn\\optetginr.setValue($\\sysmod\\etg\\inr.getValue());
			  */
			this.getBnktrn().setCpldattim( MdaUtils.today());
			this.getBnktrn().setNxtreq("");
			this.getBnktrn().setOriinr(this.getBnktrn().getInr());
			ctx.getDaoSession().dbUpdate(this.getBnktrn());
			//更新ord表、新增ore
			String ordinr = this.getOrdmod().getOrd().getInr();
			if(MdaUtils.isEmpty(this.getOrdmod().getOrd().getInr()))
			{
			  ordinr = this.getBnktrn().getOrdinr();
			  ctx.getDaoSession().dbRead(this.getOrdmod().getOrd(),new Argument<String>("inr",ordinr));
			}
			this.getOrdmod().getOrd().setSta("D");
			ctx.getDaoSession().dbUpdate(this.getOrdmod().getOrd());
			ctx.getDaoSession().dbRead(ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).getRmk(),new Argument<String>("ordinr",ordinr));
			if(MdaUtils.isEmpty(ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).getRmk().getInr()))
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Rmkmod.class).createRemark(ordinr,this.getBnktrn().getInr());
			this.getOrdmod().getOre().setInr(Platform.sdbCounter("ore"));
			this.getOrdmod().getOre().setBegdattim(MdaUtils.today());
			this.getOrdmod().getOre().setEnddattim(MdaUtils.today());
			this.getOrdmod().getOre().setFrm(trans);
			this.getOrdmod().getOre().setObjinr(objinr);
			this.getOrdmod().getOre().setObjtyp(objtyp);
			this.getOrdmod().getOre().setOrdinr(ordinr);
			this.getOrdmod().getOre().setTxt("订单完成");
			this.getOrdmod().getOre().setTyp("D");
			this.getOrdmod().getOre().setAction("21");
			ctx.getDaoSession().dbInsert(this.getOrdmod().getOre());
			String filename = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getBnktrn().getInr(),"zul");
			log.info("{}","filename :"+filename);
			ctx.saveDisplay(filename);
			ctx.getErrorCode();
		}
        /**
        *   source:trnmod.@0076.script
        */
        public void pdfdocToImg(String ownref,String imgref,String trncod,String logname,String objtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","ownref = " + this.getOwnref());
			log.info("{}","pdffilnam = " + this.getApldoc().getPdfdoc().getPdffilnam());
			if(MdaUtils.isEmpty(this.getApldoc().getPdfdoc().getPdffilnam())||MdaUtils.isEmpty(this.getApldoc().getPdfdoc().getLabel()))
			{
			  return;
			}
			String[] pdffilles = this.getApldoc().getPdfdoc().getPdffilnam().split(",");
			String[] alsfilles = this.getApldoc().getPdfdoc().getLabel().split(",");
			String uuidtoken = UUID.randomUUID().toString().replace("-", "").toUpperCase();
			//Platform.dbRead($itfmod\\imgmod\\img,new Argument("ownref",$ownref.getValue()));
			ctx.getDaoSession().dbRead(this.getItfmod().getImgmod().getImg(),new Argument("imgref",imgref ),new Argument("ownref",ownref));
			if(MdaUtils.isEmpty(this.getItfmod().getImgmod().getImg().getInr()))
			{
			  this.getItfmod().getImgmod().getImg().setOwnref( ownref);
			  this.getItfmod().getImgmod().getImg().setImgref( imgref);
			  this.getItfmod().getImgmod().getImg().setCredat( MdaUtils.today());
			  this.getItfmod().getImgmod().getImg().setInifrm( trncod);
			  this.getItfmod().getImgmod().getImg().setLgnnam( logname);
			  this.getItfmod().getImgmod().getImg().setCnt(1);
			  this.getItfmod().getImgmod().getImg().setOptdattim( MdaUtils.today());
			  this.getItfmod().getImgmod().getImg().setObjtyp( objtyp);
			  this.getItfmod().getImgmod().getImg().setFtysuc("Z00238");
			  this.getItfmod().getImgmod().getImg().setTrninr(this.getTrn().getInr());
			  this.getItfmod().getImgmod().getImg().setObjinr(this.getTrn().getObjinr());
			  this.getItfmod().getImgmod().getImg().setGuid(uuidtoken);
			  this.getItfmod().getImgmod().getImg().setInr(MdaUtils.format(ctx.getDaoSession().dbCounter("img"),"00000000"));
			  ctx.getDaoSession().dbInsert(this.getItfmod().getImgmod().getImg());
			  log.debug("{}","保存影像操作记录成功，img.inr="+this.getItfmod().getImgmod().getImg().getInr() +",img.ownref="+ ownref+",img.imgref="+imgref);
			}

			String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String srcPath = "";
			String destPath = "";
			int tblcnt = 0;

			//int tblcnt = $itfmod\\imgmod.getTblcntVal("tblbills",pdffilles.length);
			if(pdffilles.length > 0)
			{
			  String cls="com.brilliance.eibs.main.Client";
			  Object rtnVal = MdaUtils.invoke(cls,"scall","gettblinr","gettblinr",new Object[]{pdffilles.length});
			  Map retMsg = (Map)MdaUtils.invoke(rtnVal,"getContent");
			  String errcod = (String)retMsg.get("errorCode");
			  if("00000".equals(errcod))
			  {
			    Object objm = retMsg.get("tblcnt");
			    tblcnt = Integer.parseInt(objm.toString());
			  }
			  if(!"00000".equals(errcod)||tblcnt<=0)
			    return;
			}
			for(int i = 0; i < pdffilles.length; i++)
			{
			  if (i<alsfilles.length)
			  {
			    srcPath = MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"pdf"),pdffilles[i]);
			    destPath = MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img"),date),pdffilles[i]);
			    log.info("{}", "trans file filename ="+srcPath);
			    MdaUtils.invoke("com.cib.window.util.WindowsFileUtil","copyFileToOtherFile",srcPath,destPath);

			    this.getItfmod().getImgmod().insertTblbil(pdffilles[i], alsfilles[i], ownref, imgref, trncod, logname, objtyp, tblcnt);
			    tblcnt = tblcnt + 1;
			  }
			}
		}































        public void setCurHolder(FieldHolder<String> cur)
        {
           this.cur = (cur);
        }

        public void setCur(String cur)
        {
            this.cur.setValue(cur);
        }

        public String getCur()
        {
            return this.cur.getValue();
        }



        public void setAmtHolder(FieldHolder<BigDecimal> amt)
        {
           this.amt = (amt);
        }

        public void setAmt(BigDecimal amt)
        {
            this.amt.setValue(amt);
        }

        public BigDecimal getAmt()
        {
            return this.amt.getValue();
        }



        public void setOwnrefHolder(FieldHolder<String> ownref)
        {
           this.ownref = (ownref);
        }

        public void setOwnref(String ownref)
        {
            this.ownref.setValue(ownref);
        }

        public String getOwnref()
        {
            return this.ownref.getValue();
        }



        public void setBchcodHolder(FieldHolder<String> bchcod)
        {
           this.bchcod = (bchcod);
        }

        public void setBchcod(String bchcod)
        {
            this.bchcod.setValue(bchcod);
        }

        public String getBchcod()
        {
            return this.bchcod.getValue();
        }



        public void setObjinrHolder(FieldHolder<String> objinr)
        {
           this.objinr = (objinr);
        }

        public void setObjinr(String objinr)
        {
            this.objinr.setValue(objinr);
        }

        public String getObjinr()
        {
            return this.objinr.getValue();
        }



        public void setPtyinrHolder(FieldHolder<String> ptyinr)
        {
           this.ptyinr = (ptyinr);
        }

        public void setPtyinr(String ptyinr)
        {
            this.ptyinr.setValue(ptyinr);
        }

        public String getPtyinr()
        {
            return this.ptyinr.getValue();
        }





        public void setStlrefHolder(FieldHolder<String> stlref)
        {
           this.stlref = (stlref);
        }

        public void setStlref(String stlref)
        {
            this.stlref.setValue(stlref);
        }

        public String getStlref()
        {
            return this.stlref.getValue();
        }









}