package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Tukmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Tukmod.class);

        //中国光大银行人民币与外汇衍生产品业务风险揭示声明
        private String readtxt1;

        //中国光大银行人民币与外汇衍生产品业务风险确认函
        private String readtxt2;

        //标题1
        private String title1;

        //标题2
        private String title2;


        @JsonIgnore
        @BDGetter
        private transient IPanel readtk;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Pdfviw> pdfviw;


		public Tukmod()
        {
            super();
            setArgument();
        }

        public Tukmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:tukmod.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String readtxt1="";
			String readtxt2="";
			if("jstjsh".equals(ctx.getTransName()))
			{
			  //设置标题
			  this.setTitle1("中国光大银行T+1/T+2即期结售汇风险揭示");
			  this.setTitle2("中国光大银行T+1/T+2即期结售汇风险确认");
			  //中国光大银行T+1/T+2即期结售汇风险揭示
			  readtxt1="    市场风险：是指交易的价值将会受到一个或更多市场的价格、比率、指数或其它市场因素的波动性、相关性或其它关系变化的不利影响，或者受所进行交易市场以及其它与交易相关市场的流动性变化所造成的不利影响。对于一个特定的包含了杠杆作用的交易将会承担更高水平的风险，由于微小的市场变化所引起的损失将会被成倍放大。本交易的市值基于一系列的事实，包括（但不限于）市场外汇汇率、外汇汇率的波动性、利率、收益率、收益率曲线、使用的估价模型和标准以及本行在计算市值时认为适当的其他市场数据。该等数值在交易的期间将会不断变化。如果交易市值的亏损程度超出了我行给予您的授信或现有保证金的范围，您可能很快会被告知要求提供足够的保证金以应对您的债务。如果您未能及时补足保证金将会导致我行根据法律、法规的规定以及有关协议的约定，将您的市场头寸进行平盘清算，您将自行承担所有损失。";
			  readtxt1=readtxt1+CR+"    信用风险：是指交易双方可能在特定的情况下，未能按照事先约定的条款履行交易合同项下义务的风险。";
			  readtxt1=readtxt1+CR+"    资金风险：是指在进行交易或与交易相关的交割、对冲及结构调整时出现的在指定时间应有的现金流入或者现金流出的延迟或者不统一的风险，而导致您可能没有足够的资金来履行您现有的债务。";
			  readtxt1=readtxt1+CR+"    流动性风险：是指由于现有的市场条件未能达成交易、不允许对您的交易进行反向平盘或者不能为您所持有的头寸提供一个公平的价值而引发的风险。此外，反向平盘的价格将反映市场的流动性条件，并受交易金额大小及成本的影响。";
			  readtxt1=readtxt1+CR+"    操作风险：是指由于您的内部程序控制，对因交易而产生的风险和负债进行监控或者评估失效而给您造成损失的风险。";
			  //中国光大银行T+1/T+2即期结售汇风险确认
			  readtxt2="    我司已仔细阅读上述风险揭示内容，我司理解并接受上述风险揭示披露的所有风险。在交易过程中，我司理解中国光大银行股份有限公司（以下简称“贵行”）只作为该交易中我们的受托人，我们将根据自身情况，预测和判断与交易相关的风险和相关事项，独立作出是否进行交易的指令，并承担贵行依据指令所进行的全部交易的结果。我们理解与交易的条款和条件相关的材料和说明不应被视为投资建议或进入交易的建议。贵行提供的交易相关的方案、意见或者任何信息（书面或口头）都不被视为对于交易预期结果的承诺与保证。贵行也不对交易结果承担任何风险和责任。";

			}
			else
			{
			  //设置标题
			  this.setTitle1("中国光大银行人民币与外汇衍生产品业务风险揭示声明");
			  this.setTitle2("中国光大银行人民币与外汇衍生产品业务风险确认函");

			  //中国光大银行人民币与外汇衍生产品业务风险揭示声明
			  readtxt1="尊敬的委托客户：";
			  readtxt1=readtxt1+CR+"    我行提供本风险揭示声明的目的是为了使您对于发生在中国光大银行股份有限公司（以下简称“我行”）与您之间的人民币与外汇衍生产品交易相关的主要风险引起足够充分的重视，以及确认在上述交易背景下我行与委托客户之间关系的性质。";
			  readtxt1=readtxt1+CR+"    在与我行完成交易以前，您应该确保您已经完全理解并接受全部的交易条款、相关的风险要素、因风险可能造成损失的性质和程度以及您所要签订的合同关系的性质。同时您应该根据您的经验、目标、财力以及其它相关的详细情况仔细严谨地评估该交易是否适合您，以及您是否具有足够的资格和能力在整个交易的存续期内履行相关的合同。";
			  readtxt1=readtxt1+CR+"    除非我行已经清楚地通过书面的形式同意就某一项特定交易作为您的顾问，否则我行只是作为该交易中您的受托人，根据您独立作出是否进行交易的决定帮助您完成交易。您需要根据自己的判断做出决策。您不应该将任何交易相关的方案、意见或其它从我行得到的书面、口头或其它形式的信息作为该交易的推荐和建议，且您理解与交易的条款和条件相关的资料和说明不应被视为投资建议或进入交易的建议。我行提供的任何信息（书面或口头）都不应被视为对于交易预期结果的承诺和保证。我行也不对交易结果承担任何风险和责任。如果您认为需要对该交易未来潜在的收益和风险进行评估，您需要在进行交易前咨询除我行以外其它您认为适合的金融顾问。";
			  readtxt1=readtxt1+CR+"    和所有金融交易一样，人民币与外汇衍生产品交易具有多种必然和显著的风险。每一笔交易所呈现其特有的风险取决于交易条款和交易的具体情况，交易包括但不仅限于下列某些风险或风险的组合：";
			  readtxt1=readtxt1+CR+"    市场风险：是指交易的价值将会受到一个或更多市场的价格、比率、指数或其它市场因素的波动性、相关性或其它关系变化的不利影响，或者受所进行交易市场以及其它与交易相关市场的流动性变化所造成的不利影响。对于一个特定的包含了杠杆作用的交易将会承担更高水平的风险，由于微小的市场变化所引起的损失将会被成倍放大。本交易的市值基于一系列的事实，包括（但不限于）市场外汇汇率、外汇汇率的波动性、利率、收益率、收益率曲线、使用的估价模型和标准以及本行在计算市值时认为适当的其他市场数据。该等数值在交易的期间将会不断变化。如果交易市值的亏损程度超出了我行给予您的授信或现有保证金的范围，您可能很快会被告知要求提供足够的保证金以应对您的债务。如果您未能及时补足保证金将会导致我行根据法律、法规的规定以及有关协议的约定，将您的市场头寸进行平盘清算，您将自行承担所有损失。";
			  readtxt1=readtxt1+CR+"    信用风险：是指交易双方可能在特定的情况下，未能按照事先约定的条款履行交易合同项下义务的风险。";
			  readtxt1=readtxt1+CR+"    资金风险：是指在进行交易或与交易相关的交割、对冲及结构调整时出现的在指定时间应有的现金流入或者现金流出的延迟或者不统一的风险，而导致您可能没有足够的资金来履行您现有的债务。";
			  readtxt1=readtxt1+CR+"    流动性风险：是指由于现有的市场条件未能达成交易、不允许对您的交易进行反向平盘或者不能为您所持有的头寸提供一个公平的价值而引发的风险。此外，反向平盘的价格将反映市场的流动性条件，并受交易金额大小及成本的影响。";
			  readtxt1=readtxt1+CR+"    操作风险：是指由于您的内部程序控制，对因交易而产生的风险和负债进行监控或者评估失效而给您造成损失的风险。";
			  readtxt1=readtxt1+CR+"    期权风险：期权交易有可能具有相对高水平的风险。期权的买方可能执行期权或者持有到期，如果到期日期权因没有价值而未被执行，那么您将会发生期权费和交易成本的损失。与买入期权相比，卖出期权则要承担相对较大的风险，尽管您可以因为卖出期权而收到固定的期权费，但是如果您不进行任何对冲的话，您同时有可能由于买入期权的一方执行期权而承担一个超过期权费金额的损失。";
			  readtxt1=readtxt1+CR+"    汇率风险：如果您需要将本交易中所使用的计量货币转换成另一种货币，那么以该货币计量的交易盈亏将有可能受到汇率波动的影响。";
			  readtxt1=readtxt1+CR+"    汇率风险压力测试：";
			  readtxt1=readtxt1+CR+"    假定当前即期价格为6.5，一年期远期价格为6.66，近年来即期价格年化波动率为6%，一年内汇率波动维持6%不变，一年以后汇率波动区间为【6.11，6.89】，如您按照6.66价格锁定100万美元一年期远期购汇，按照到期日汇率区间估算，您的损益区间为人民币【-55万，23万】，如您按照6.66价格锁定100万美元一年期远期结汇，按照到期日汇率区间估算，您的损益区间为人民币【-23万，55万】。";
			  readtxt1=readtxt1+CR+"    同理推算EUR/JPY/HKD场景如下：";
			  readtxt1=readtxt1+CR+"    币种|方向	  |金额	     |即期价格|远期价格|波动率|波动区间	          |损益区间(人民币万元)";
			  readtxt1=readtxt1+CR+"    EUR |远期结汇|100万EUR  |7.6038 |7.8522 |7.92% |[7.001724,8.205876]|[-35.37,85.05]";
			  readtxt1=readtxt1+CR+"    EUR |远期购汇|100万EUR  |7.6038 |7.8522 |7.92% |[7.001724,8.205876]|[-85.05,35.37]";
			  readtxt1=readtxt1+CR+"    JPY |远期结汇|10000万JPY|0.05867|0.06033|9.65% |[0.053011,0.064329]|[-39.99,73.19]";
			  readtxt1=readtxt1+CR+"    JPY |远期购汇|10000万JPY|0.05867|0.06033|9.65% |[0.053011,0.064329]|[-73.19,39.99]";
			  readtxt1=readtxt1+CR+"    HKD |远期结汇|1000万HKD |0.83249|0.85293|4.21% |[0.797411,0.867569]|[-14.64,55.52]";
			  readtxt1=readtxt1+CR+"    HKD |远期购汇|1000万HKD |0.83249|0.85293|4.21% |[0.797411,0.867569]|[-55.52,14.64]";
			  readtxt1=readtxt1+CR+"    外汇掉期远端压力测试与远期案例相同。";
			  readtxt1=readtxt1+CR+"    期权买入方支付期权费后获得决定是否行权的权利，若期权买入方决定不行权，则期权买入方所承担的最大损失为支付的期权费；期权卖出方收到期权费后承担到期可能被行权的义务，理论上期权卖出方可能面临的损失是无上限的。";
			  readtxt1=readtxt1+CR+"    由于外汇期权涉及组合形式较多，您应根据自身业务需求合理确定签约行权价及支付期权费，此处以卖出期权业务举例：客户卖出一年期100万美元看涨期权（结汇方向），收到期权费收入16万元，执行价6.66，到期后损益区间为人民币【-39万,39万】。";
			  readtxt1=readtxt1+CR+"    一般情况下，汇率市场将在一定的范围内双向波动，但不排除在极端或特殊情况下汇率出现剧烈波动的情况，上述案例是以近年来市场波动率为基础进行测算，但同实际业务当中的具体情况仍会存在一定的差距，仅供您参考，实际办理衍生品业务前您仍需结合实际汇率及市场情况充分评估风险承受能力。";
			  readtxt1=readtxt1+CR+"    汇率类业务现金流分析：";
			  readtxt1=readtxt1+CR+"    在进行远期结售汇差额交割、平仓及卖出期权业务差额行权或平仓等操作时，如您产生亏损，现金流为支付亏损部分人民币差额，如您产生收益，现金流为收到收益部分人民币差额。";
			  readtxt1=readtxt1+CR+"    在进行远期结售汇全额交割，期权全额行权，外汇掉期近端、远端本金交换等操作时，现金流情况为按照签约汇率和签约本金以等额本币换入外币或以外币换入本币。";
			  readtxt1=readtxt1+CR+"    上述声明并不意味着揭示所有与交易相关的风险和其它需要考虑的事项。您应根据自身情况，预测和判断与交易相关的风险和有关事项，并在不依赖于我行任何建议和风险提示的情况下，独立作出交易指令，并承担我行依据指令所进行的全部交易的结果。";

			  //中国光大银行人民币与外汇衍生产品业务风险确认函
			  readtxt2="    我们已经仔细阅读了《中国光大银行人民币与外汇衍生产品业务风险揭示声明》(以下简称“《揭示声明》”)。我们完全理解并接受《揭示声明》所披露的所有风险。《揭示声明》构成本确认函不可分割的一部分。";
			  readtxt2=readtxt2+CR+"    我们申请办理本笔人民币与外汇衍生产品业务的目的是防范风险（或保值），对应基础资产（或基础负债）的信息真实、正确、完整、合法，无相关的未结清衍生产品交易敞口。";
			  readtxt2=readtxt2+CR+"    在人民币与外汇衍生产品交易过程中，我们理解中国光大银行股份有限公司（以下简称“贵行”）只作为该交易中我们的受托人，我们将根据自身情况，预测和判断与交易相关的风险和相关事项，独立作出是否进行交易的指令，并承担贵行依据指令所进行的全部交易的结果。我们理解与交易的条款和条件相关的材料和说明不应被视为投资建议或进入交易的建议。贵行提供的交易相关的方案、意见或者任何信息（书面或口头）都不被视为对于交易预期结果的承诺与保证。贵行也不对交易结果承担任何风险和责任。";

			}
			this.setReadtxt1(readtxt1);
			
			this.setReadtxt2(readtxt2);
			
			
			

			return true;
        }


        /**
        *   source:tukmod.@0001.script
        */
        public void setTk()  //读取条款
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//中国光大银行人民币与外汇衍生产品业务风险揭示声明
			String readtxt1="尊敬的委托客户：";
			readtxt1=readtxt1+CR+"    我行提供本风险揭示声明的目的是为了使您对于发生在中国光大银行股份有限公司（以下简称“我行”）与您之间的人民币与外汇衍生产品交易相关的主要风险引起足够充分的重视，以及确认在上述交易背景下我行与委托客户之间关系的性质。";
			readtxt1=readtxt1+CR+"    在与我行完成交易以前，您应该确保您已经完全理解并接受全部的交易条款、相关的风险要素、因风险可能造成损失的性质和程度以及您所要签订的合同关系的性质。同时您应该根据您的经验、目标、财力以及其它相关的详细情况仔细严谨地评估该交易是否适合您，以及您是否具有足够的资格和能力在整个交易的存续期内履行相关的合同。";
			readtxt1=readtxt1+CR+"    除非我行已经清楚地通过书面的形式同意就某一项特定交易作为您的顾问，否则我行只是作为该交易中您的受托人，根据您独立作出是否进行交易的决定帮助您完成交易。您需要根据自己的判断做出决策。您不应该将任何交易相关的方案、意见或其它从我行得到的书面、口头或其它形式的信息作为该交易的推荐和建议，且您理解与交易的条款和条件相关的资料和说明不应被视为投资建议或进入交易的建议。我行提供的任何信息（书面或口头）都不应被视为对于交易预期结果的承诺和保证。我行也不对交易结果承担任何风险和责任。如果您认为需要对该交易未来潜在的收益和风险进行评估，您需要在进行交易前咨询除我行以外其它您认为适合的金融顾问。";
			readtxt1=readtxt1+CR+"    和所有金融交易一样，人民币与外汇衍生产品交易具有多种必然和显著的风险。每一笔交易所呈现其特有的风险取决于交易条款和交易的具体情况，交易包括但不仅限于下列某些风险或风险的组合：";
			readtxt1=readtxt1+CR+"    市场风险：是指交易的价值将会受到一个或更多市场的价格、比率、指数或其它市场因素的波动性、相关性或其它关系变化的不利影响，或者受所进行交易市场以及其它与交易相关市场的流动性变化所造成的不利影响。对于一个特定的包含了杠杆作用的交易将会承担更高水平的风险，由于微小的市场变化所引起的损失将会被成倍放大。本交易的市值基于一系列的事实，包括（但不限于）市场外汇汇率、外汇汇率的波动性、利率、收益率、收益率曲线、使用的估价模型和标准以及本行在计算市值时认为适当的其他市场数据。该等数值在交易的期间将会不断变化。如果交易市值的亏损程度超出了我行给予您的授信或现有保证金的范围，您可能很快会被告知要求提供足够的保证金以应对您的债务。如果您未能及时补足保证金将会导致我行根据法律、法规的规定以及有关协议的约定，将您的市场头寸进行平盘清算，您将自行承担所有损失。";
			readtxt1=readtxt1+CR+"    信用风险：是指交易双方可能在特定的情况下，未能按照事先约定的条款履行交易合同项下义务的风险。";
			readtxt1=readtxt1+CR+"    资金风险：是指在进行交易或与交易相关的交割、对冲及结构调整时出现的在指定时间应有的现金流入或者现金流出的延迟或者不统一的风险，而导致您可能没有足够的资金来履行您现有的债务。";
			readtxt1=readtxt1+CR+"    流动性风险：是指由于现有的市场条件未能达成交易、不允许对您的交易进行反向平盘或者不能为您所持有的头寸提供一个公平的价值而引发的风险。此外，反向平盘的价格将反映市场的流动性条件，并受交易金额大小及成本的影响。";
			readtxt1=readtxt1+CR+"    操作风险：是指由于您的内部程序控制，对因交易而产生的风险和负债进行监控或者评估失效而给您造成损失的风险。";
			readtxt1=readtxt1+CR+"    期权风险：期权交易有可能具有相对高水平的风险。期权的买方可能执行期权或者持有到期，如果到期日期权因没有价值而未被执行，那么您将会发生期权费和交易成本的损失。与买入期权相比，卖出期权则要承担相对较大的风险，尽管您可以因为卖出期权而收到固定的期权费，但是如果您不进行任何对冲的话，您同时有可能由于买入期权的一方执行期权而承担一个超过期权费金额的损失。汇率风险：如果您需要将交易中所使用的人民币转换成外汇，那么该交易盈亏将有可能受到汇率波动的影响。";
			readtxt1=readtxt1+CR+"    汇率风险：如果您需要将本交易中所使用的计量货币转换成另一种货币，那么以该货币计量的交易盈亏将有可能受到汇率波动的影响。";
			readtxt1=readtxt1+CR+"    上述声明并不意味着揭示所有与交易相关的风险和其它需要考虑的事项。您应根据自身情况，预测和判断与交易相关的风险和有关事项，并在不依赖于我行任何建议和风险提示的情况下，独立作出交易指令，并承担我行依据指令所进行的全部交易的结果。";
			this.setReadtxt1(readtxt1);
			

			//中国光大银行人民币与外汇衍生产品业务风险确认函
			String readtxt2="    我们已经仔细阅读了《中国光大银行人民币与外汇衍生产品业务风险揭示声明》(以下简称“《揭示声明》”)。我们完全理解并接受《揭示声明》所披露的所有风险。《揭示声明》构成本确认函不可分割的一部分。";
			readtxt2=readtxt2+CR+"    我们申请办理本笔人民币与外汇衍生产品业务的目的是防范风险（或保值），对应基础资产（或基础负债）的信息真实、正确、完整、合法，无相关的未结清衍生产品交易敞口。";
			readtxt2=readtxt2+CR+"    在人民币与外汇衍生产品交易过程中，我们理解中国光大银行股份有限公司（以下简称“贵行”）只作为该交易中我们的受托人，我们将根据自身情况，预测和判断与交易相关的风险和相关事项，独立作出是否进行交易的指令，并承担贵行依据指令所进行的全部交易的结果。我们理解与交易的条款和条件相关的材料和说明不应被视为投资建议或进入交易的建议。贵行提供的交易相关的方案、意见或者任何信息（书面或口头）都不被视为对于交易预期结果的承诺与保证。贵行也不对交易结果承担任何风险和责任。";
			this.setReadtxt2(readtxt2);
			
		}

        public void setPdfviwHolder(ModuleHolder<Pdfviw> pdfviw)
        {
           this.pdfviw = pdfviw;
        }

        public Pdfviw getPdfviw()
        {
           return this.pdfviw.get();
        }









}