package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Cls;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 条款模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Txmmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Txmmod.class);

        //条款类型
        private String clstyp;

        //查询
        private transient IControl query = new ControlImpl("query", "查询", this);

        //调出条款页面
        private transient IControl buttxmsel = new ControlImpl("buttxmsel", "调出条款页面", this);

        //条款文本
        @Module(getter = false, setter = false)
		private FieldHolder<String> txmblock = new FieldConstantHolder<>("");


        //条款域名
        @Module(getter = false, setter = false)
		private FieldHolder<String> txmgrp = new FieldConstantHolder<>("");


        //选择
        private transient IControl seltxm = new ControlImpl("seltxm", "选择", this);

        //确定
        private transient IControl sure = new ControlImpl("sure", "确定", this);

        //选择其他单据条款
        private transient IControl selswfd = new ControlImpl("selswfd", "选择其他单据条款", this);

        //初始条款文本
        private String tmptxt;

        //协议文本
        private String txmblk;


        @JsonIgnore
        @BDGetter
        private transient IPanel lcrdoctp;

        @JsonIgnore
        @BDGetter
        private transient IPanel adlcnd;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgtclu;

        @JsonIgnore
        @BDGetter
        private transient IPanel swfd;

        @JsonIgnore
        @BDGetter
        private transient IPanel lcrdoc;

        @JsonIgnore
        @BDGetter
        private transient IPanel btn1;

        @JsonIgnore
        @BDGetter
        private transient IPanel btns;


	    @BDGetter
		private Cls cls;

		@BDGetter
		private ModuleList<Cls> clslst;


		public Txmmod()
        {
            super();
            setArgument();
        }

        public Txmmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:txmmod.@0002.script
        */
        @Rule(target="query",order=100)
        public boolean ruleQueryN100(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getClslst());
			String txmtyp = this.getTxmgrp();
			//String etninr = $\\sysmod\\usr\\ptyinr.getValue();
			//String bnkinr = "";
			//查出的条款为表中所有条款，未按照企业及所属机构查询（ptyinr、ptyinr->bchcod）
			if("lcrdoc".equals(txmtyp))
			  readCls();
			/*{
			  Platform.dbReadset( $clslst , new Argument<String>("flg","1") , new Argument<String>("typ",$clstyp.getValue()) );
			  Platform.setModified($clslst);
			  }
			  */

			return true;
        }

        /**
        *   source:txmmod.@0003.script
        */
        @Rule(target="seltxm",order=100)
        public boolean ruleSeltxmN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getClslst().fullSize();
			if(index<0  ||  index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("txmmod","CT000036"),MdaUtils.getI18NString("txmmod","CT000037"));
			  return false;
			}
			this.getCls().copyValue(this.getClslst().getElement(index));
			String clstxt = this.getCls().getClstxt();
			if(MdaUtils.isEmpty(this.getTxmblock()))
			{
			  this.setTxmblk(clstxt);
			  this.setTxmblock(clstxt);

			}
			else
			{
			  this.setTxmblk(this.getTxmblock() + "\r\n" + clstxt);
			  this.setTxmblock(this.getTxmblock() + "\r\n" + clstxt);
			}
			
			
			closePanel();
			//Platform.showMainPanel();
			

			return true;
        }

        /**
        *   source:txmmod.@0004.script
        */
        @Rule(target="sure",order=100)
        public boolean ruleSureN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			if("lcrdoc".equals(this.getTxmgrp()))
			{
			  
			}
			else if("rgtclu".equals(this.getTxmgrp()))
			{
			  
			}
			else if("cfmclu".equals(this.getTxmgrp()))
			{
			  
			}
			

			return true;
        }

        /**
        *   source:txmmod.@0005.script
        */
        @Rule(target="buttxmsel",order=100)
        public boolean ruleButtxmselN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","message===="+this.getTxmgrp());
			this.setTmptxt(this.getTxmblock());
			if("lcrdoc".equals(this.getTxmgrp()))
			{
			  
			}
			else if("adlcnd".equals(this.getTxmgrp()))
			{
			  
			}
			else if("rgtclu".equals(this.getTxmgrp()))
			{
			  
			}
			/*
			  else if("swfd".equals($txmgrp.getValue()))
			  Platform.popup($swfd);
			  */

			return true;
        }

        /**
        *   source:txmmod.@0010.script
        */
        @Rule(target="selswfd",order=100)
        public boolean ruleSelswfdN100(){
            IContext ctx = MdaEnv.getContext();
            
			int index = 0;
			int length = this.getClslst().fullSize();
			if(index<0  ||  index>=length)
			{
			  ctx.setMessage(MdaUtils.getI18NString("txmmod","CT000044"),MdaUtils.getI18NString("txmmod","CT000045"));
			  return false;
			}
			this.getCls().copyValue(this.getClslst().getElement(index));
			String clstxt = this.getCls().getClstxt();
			if(MdaUtils.isEmpty(this.getTxmblock()))
			{
			  this.setTxmblock(clstxt);
			}
			else
			{
			  this.setTxmblock(this.getTxmblock() + "\r\n" + clstxt);
			}
			log.debug("{}","txmblock=="+ this.getTxmblock());
			
			if("swfd".equals(this.getTxmgrp()))
			{
			  
			}

			return true;
        }

        /**
        *   source:txmmod.@0012.script
        */
        @Rule(target="lcrdoc",order=100)
        public boolean ruleLcrdocN100(){
            IContext ctx = MdaEnv.getContext();
            
			// cancel();
			
			return true;
        }

        /**
        *   source:txmmod.@0013.script
        */
        @Rule(target="adlcnd",order=100)
        public boolean ruleAdlcndN100(){
            IContext ctx = MdaEnv.getContext();
            
			// cancel();
			
			return true;
        }

        /**
        *   source:txmmod.@0014.script
        */
        @Rule(target="rgtclu",order=100)
        public boolean ruleRgtcluN100(){
            IContext ctx = MdaEnv.getContext();
            
			// cancel();
			
			return true;
        }

        /**
        *   source:txmmod.@0015.script
        */
        @Rule(target="swfd",order=100)
        public boolean ruleSwfdN100(){
            IContext ctx = MdaEnv.getContext();
            
			// cancel();
			
			return true;
        }



        /**
        *   source:txmmod.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.clear( $clslst );
			//Platform.dbReadset($clslst,new Argument<String>("flg","2"));
			//Platform.setModified($clslst);
			readCls();

			return true;
        }

        /**
        *   source:txmmod.@0001.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.clear( $clslst );
			//Platform.dbReadset($clslst,new Argument<String>("flg","1"));
			//Platform.setModified($clslst);
			MdaUtils.setValues(this,"clstyp",MdaUtils.getCodetable("docclstypall"));
			this.setClstyp("0");
			readCls();

			return true;
        }

        /**
        *   source:txmmod.@0006.script
        */
        @Init(order=100)
        public boolean	init100R2(){
            IContext ctx = MdaEnv.getContext();
            
			if("rgtclu".equals(this.getTxmgrp()))
			  readRgtCls();
			//Platform.dbReadset($clslst,new Argument<String>("flg","3"),new Argument<String>("typ",$clstyp));
			else if("cfmclu".equals(this.getTxmgrp()))
			{
			  ctx.getDaoSession().dbReadset(this.getClslst(),new Argument<String>("flg","5"),new Argument<String>("typ",this.getClstyp()));
			  
			}

			return true;
        }

        /**
        *   source:txmmod.@0009.script
        */
        @Init(order=100)
        public boolean	init100R3(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getClslst());
			ctx.getDaoSession().dbReadset(this.getClslst(),new Argument<String>("flg","2"));
			

			return true;
        }


        /**
        *   source:txmmod.@0007.script
        */
        public String readDefaultClsInr(String clstyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = null;
			//商行客户读的是商行维护的条款;本行企业、商行读的是兴业维护的条款
			if("3".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  sql = "SELECT inr FROM cls WHERE ptyinr IN(SELECT nxtptyinr FROM ptr WHERE preptyinr = '"+ctx.absGet(Sysmod.class).getPty().getInr()+"' AND ptrtyp = '2')";
			else
			  sql = "SELECT inr FROM cls WHERE ptyinr IN(SELECT inr FROM pty WHERE ptytyp = '0')";
			sql = sql + " AND status = '0' AND flg = '3' AND typ = '"+clstyp+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			String clsInr = inr.value;
			ctx.getDaoSession().dbCloseCursor();
			log.debug("{}","readDefaultClsInr = "+clsInr);
			return clsInr;
		}
        /**
        *   source:txmmod.@0008.script
        */
        public void readRgtCls()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getClslst());
			String sql = null;
			//商行客户读的是商行维护的条款;本行企业、商行读的是兴业维护的条款
			if("3".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  sql = "SELECT * FROM cls WHERE ptyinr IN(SELECT nxtptyinr FROM ptr WHERE preptyinr = '"+ctx.absGet(Sysmod.class).getPty().getInr()+"' AND ptrtyp = '2')";
			else
			  sql = "SELECT * FROM cls WHERE ptyinr IN(SELECT inr FROM pty WHERE ptytyp = '0')";
			sql = sql + " AND flg = '3' AND typ = '"+this.getClstyp()+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> clstxt = new Argument<String>("clstxt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,clstxt);
			  if(ctx.getErrorCode() == NO_ERROR)
			    this.getClslst().add(inr,clstxt);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			log.debug("{}","rgtclu size = "+this.getClslst().fullSize());
		}
        /**
        *   source:txmmod.@0011.script
        */
        public void readCls()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//clsFlg:1单据条款2附加条款
			String txmgrp = this.getTxmgrp();
			String clsFlg = null;
			if("lcrdoc".equals(txmgrp))
			  clsFlg = "1";
			else if("adlcnd".equals(txmgrp))
			  clsFlg = "2";
			MdaUtils.clear(this.getClslst());
			String sql = "SELECT inr , ownertyp , typ ,clstxt FROM cls WHERE (ptyinr = ";
			//本行客户、商行：兴业+自身；商行客户：商行+兴业
			if("3".equals(ctx.absGet(Sysmod.class).getPty().getPtytyp()))
			  sql += "(SELECT nxtptyinr FROM ptr WHERE preptyinr = '"+ctx.absGet(Sysmod.class).getPty().getInr()+"' AND ptrtyp = '2')";
			else
			  sql += "'"+ctx.absGet(Sysmod.class).getPty().getInr()+"'";
			sql += " OR ptyinr IN(SELECT inr FROM pty WHERE ptytyp = '0')) AND flg = '"+clsFlg+"'";
			if(!"0".equals(this.getClstyp())&&"1".equals(clsFlg))
			  sql += " AND typ = '"+this.getClstyp()+"'";
			log.info("{}","最终执行的sql语句==========" + sql);
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> ownertyp = new Argument<String>("ownertyp");
			Argument<String> typ = new Argument<String>("typ");
			Argument<String> clstxt = new Argument<String>("clstxt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr,ownertyp,typ,clstxt);
			  if(ctx.getErrorCode() == NO_ERROR)
			    this.getClslst().add(inr,ownertyp,typ,clstxt);
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
			
			log.debug("{}","rgtclu size = "+this.getClslst().fullSize());
		}
        /**
        *   source:txmmod.@0016.script
        */
        public void cancel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.setTxmblock(this.getTmptxt());
		}
        /**
        *   source:txmmod.@0017.script
        */
        public void closePanel()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String flg = this.getTxmgrp();
			log.debug("{}","flg  =" +flg);
			if("lcrdoc".equals(flg))
			{
			  //单据条款
			  
			}
			else if("adlcnd".equals(flg))
			{
			  //附加条款
			  
			}
			else if("rgtclu".equals(flg))
			{
			  //权责条款
			  
			}
		}













        public void setTxmblockHolder(FieldHolder<String> txmblock)
        {
           this.txmblock = (txmblock);
        }

        public void setTxmblock(String txmblock)
        {
            this.txmblock.setValue(txmblock);
        }

        public String getTxmblock()
        {
            return this.txmblock.getValue();
        }



        public void setTxmgrpHolder(FieldHolder<String> txmgrp)
        {
           this.txmgrp = (txmgrp);
        }

        public void setTxmgrp(String txmgrp)
        {
            this.txmgrp.setValue(txmgrp);
        }

        public String getTxmgrp()
        {
            return this.txmgrp.getValue();
        }











}