package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Wfd;
import com.ceb.gjjs.mda.bo.Wft;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Wfmmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Wfmmod.class);

        //ordinr
        private String ordinr;

        //filename
        private String filename;



	    @BDGetter
		private Wfd wfd;

	    @BDGetter
		private Wft wft;

	    @BDGetter
		private Wfs wfs;

	    @BDGetter
		private Wfe wfe;


		public Wfmmod()
        {
            super();
            setArgument();
        }

        public Wfmmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:wfmmod.@0000.script
        */
        public void addWfe(String argsvr,String argsta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getWfe().setWfsinr(this.getWfs().getInr());
			this.getWfe().setSrv(argsvr);
			this.getWfe().setSta(argsta);
			this.getWfe().setDattim(new Date());
			this.getWfe().setManflg("0");
			//for test
			//$wfe\\tardattim.setValue($wfe\\dattim.getValue());
			this.getWfe().setTardattim(new Date());
			String trnname=ctx.getTransName();
			String tvalue=null;
			if("P".equals(argsvr))
			{
			  String argpty=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtysFromCid(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getBchcod());
			  //String trncode=trnname+$wft\\dir.getValue()+"2";
			  String clityp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp();
			  String clilev=null;
			  // clityp为0的时候是银行端代做批量汇款，视为一级客户
			  if("1".equals(clityp)  ||  "2".equals(clityp)  ||  "0".equals(clityp))
			  {
			    clilev="1";
			  }
			  else if("3".equals(clityp))
			  {
			    clilev="2";
			  }
			  String trncode=trnname+"0"+clilev;
			  String filename="transaction.properties";
			  filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			  log.info("{}","trncod="+trncode+",properties filename="+filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("wfmmod","CT000000"));
			    log.error("{}","无法找到配置文件:transaction.properties");
			    return;
			  }
			  else
			  {
			    log.info("{}","trncode "+trncode);
			    tvalue=MdaUtils.getPropertyValue(filename,trncode);
			  }
			  this.getWfe().setSrvtxt(argpty);
			  this.getWfe().setTxt(tvalue);
			}
			if("T".equals(argsvr))
			{
			  //to fixme
			}

			if("X".equals(argsvr))
			{
			  // 设置 WFE中文件名称
			  this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr());
			}
			if("N".equals(argsvr))
			{
			  this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtysFromCid(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getBchcod()));
			  this.getWfe().setTxt(trnname);
			}
			if("S".equals(argsvr))
			{ //
			  if(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).backFromBnkchk() || "B".equals(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getBaksta()))
			    this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getFilename());
			  log.debug("{}","[addWfe]WFE:srv=[S],srvtxt=["+this.getWfe().getSrvtxt()+"]");

			}
			String inr=Platform.sdbCounter("wfe");
			log.debug("{}","[addWfe]WFE inr=["+inr+"],srv=["+this.getWfe().getSrv()+"],sta=["+this.getWfe().getSta()+"]");
			this.getWfe().setInr(inr);
			ctx.getDaoSession().dbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());
			log.debug("{}","[addWfe]退出工作流任务["+argsvr+"]设置...");
		}
        /**
        *   source:wfmmod.@0001.script
        */
        public String getNextTrnCode()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000003
			String nextstp=null;
			if(MdaUtils.isEmpty(this.getWft().getInr()))
			{
			  ctx.setMessage("Error",MdaUtils.getI18NString("wfmmod","CT000004"));
			  nextstp=null;
			}
			String dir=this.getWft().getDir();
			String stp=this.getWft().getStp();
			log.info("{}","current dir="+dir);
			log.info("{}","current stp="+stp);
			if("0".equals(dir))
			{
			  //#CT000005
			  String reqtxt=this.getWfd().getReq();
			  int len=reqtxt.length();
			  if(len==0)
			  {
			    nextstp=null;
			  }
			  int index=reqtxt.indexOf(stp);
			  if(index+1==len)
			  {
			    ctx.setMessage("",MdaUtils.getI18NString("wfmmod","CT000006"));
			    nextstp=null;
			  }
			  else
			  {
			    //String nxtstp=$wfd\\req.getValue().charAt(index+1).toString();
			    nextstp=reqtxt.substring(index+1,index+2);
			  }
			  log.info("{}","next stp ="+nextstp);
			}
			else
			{
			  if("1".equals(dir))
			  {
			    //#CT000007
			    String rpltxt=this.getWfd().getRpl();
			    int len=rpltxt.length();
			    if("".equals(rpltxt))
			    {
			      nextstp=null;
			    }
			    int index=rpltxt.indexOf(stp);
			    if(index+1==len)
			    {
			      ctx.setMessage("",MdaUtils.getI18NString("wfmmod","CT000011"));
			      nextstp=null;
			    }
			    else
			    {
			      //String nxtstp=$wfd\\rpl.getValue().charAt(index+1).toString();
			      nextstp=rpltxt.substring(index+1,index+2);
			    }
			  }
			}
			log.info("{}","nextstp="+nextstp );
			return nextstp;
		}
        /**
        *   source:wfmmod.@0003.script
        */
        public String getWorkflowType(String argTrncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取工作流类型
			  */
			String type = "0";
			String filename="transaction.properties";
			String workFlowType="workflowtype";
			filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			log.info("{}", "properties filename="+filename);
			if(!MdaUtils.fileExists(filename))
			{
			  ctx.setMessage("Error",MdaUtils.getI18NString("wfmmod","CT000033"));
			  return null;
			}
			else
			{
			  String trnnames ="-"+MdaUtils.getPropertyValue(filename,workFlowType);
			  if(!MdaUtils.isEmpty(trnnames) && trnnames.indexOf(argTrncod)>0 )
			  {
			    type = "1";
			  }
			}
			return type;
		}
        /**
        *   source:wfmmod.@0004.script
        */
        public void addWfe(String argsvr,String argsta, String trnnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," [addWfe]进入工作流任务[ "+argsvr+" ]设置... ");
			this.getWfe().setWfsinr(this.getWfs().getInr());
			this.getWfe().setSrv(argsvr);
			this.getWfe().setSta(argsta);
			this.getWfe().setDattim(new Date());
			this.getWfe().setManflg("0");

			this.getWfe().setTardattim(new Date());
			String trnname=trnnam;
			String tvalue=null;
			if("P".equals(argsvr))
			{
			  String argpty=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtysFromCid(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getBchcod());

			  String clityp=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).getPty().getPtytyp();
			  String clilev=null;
			  // clityp为0的时候是银行端代做批量汇款，视为一级客户
			  if("1".equals(clityp)  ||  "2".equals(clityp)  ||  "0".equals(clityp))
			  {
			    clilev="1";
			  }
			  else if("3".equals(clityp))
			  {
			    clilev="2";
			  }
			  String trncode=trnname+"0"+clilev;
			  String filename="transaction.properties";
			  filename=MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),filename);
			  log.info("{}","trncod="+trncode+",properties filename="+filename);
			  if(!MdaUtils.fileExists(filename))
			  {
			    ctx.setMessage("Error",MdaUtils.getI18NString("wfmmod","CT000035"));
			    log.error("{}","无法找到配置文件:transaction.properties");
			    return;
			  }
			  else
			  {
			    log.info("{}","trncode "+trncode);
			    tvalue=MdaUtils.getPropertyValue(filename,trncode);
			  }
			  this.getWfe().setSrvtxt(argpty);
			  this.getWfe().setTxt(tvalue);
			}
			if("T".equals(argsvr))
			{
			  //to fixme
			}
			if("X".equals(argsvr))
			{
			  // 设置 WFE中文件名称
			  this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrn().getInr());
			}
			if("N".equals(argsvr))
			{
			  this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtysFromCid(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getBchcod()));
			  this.getWfe().setTxt(trnname);
			}
			if("S".equals(argsvr))
			{ //
			  if(ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).backFromBnkchk())
			    this.getWfe().setSrvtxt(ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getWfmmod().getFilename());
			  log.debug("{}","[addWfe]WFE :srv=[S],srvtxt=["+this.getWfe().getSrvtxt()+"]");

			}
			String inr=Platform.sdbCounter("wfe");
			log.debug("{}","[addWfe]WFE inr=["+inr+"],srv=["+this.getWfe().getSrv()+"],sta=["+this.getWfe().getSta()+"]");
			this.getWfe().setInr(inr);
			ctx.getDaoSession().dbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());
			log.debug("{}","[addWfe]退出工作流任务["+argsvr+"]设置...");
		}
        /**
        *   source:wfmmod.@0005.script
        */
        public void updateWorkflow(String objinr,String objtyp, String name, String srcSta, String desSta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 功能：更新指定交易的工作流记录.
			  * 参数 ： objinr- 业务操作流水 ; objtype - 操作流水表名（trn或spt）
			  *        name - 工作流类型（例如：T、S等）; srcSta - 工作流目前状态
			  *        desSta - 需要更新的工作流状态
			  */
			log.debug("{}","in updateWorkflw ... objinr="+ objinr+",objtyp="+objtyp+",name=" + name +",srcSta="+srcSta + ",desSta="+desSta );
			MdaUtils.clear(this.getWfe());
			MdaUtils.clear(this.getWfs());
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getWfs(),new Argument("objtyp",objtyp),new Argument("objinr",objinr));
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ctx.getDaoSession().dbRead(this.getWfe(),new Argument("wfsinr", this.getWfs().getInr()),new Argument("srv",name),new Argument("sta",srcSta));
			  if( ctx.getErrorCode() == NO_ERROR && !MdaUtils.isEmpty(this.getWfe().getInr()))
			  {
			    this.getWfe().setSta( desSta);
			    log.debug("{}"," set sta = " + desSta );
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			  }
			}
			log.debug("{}","out updateWorkflw ... ");
		}
        /**
        *   source:wfmmod.@0006.script
        */
        public String setWorkflow(com.ceb.gjjs.mda.bo.Trn trn, String serviceName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 保存工作流服务，WFS记录, 返回对应的WFS主键
			  */
			log.debug("{}","in setWorkflow ... ");
			this.getWfs().setObjtyp( "trn");
			this.getWfs().setObjinr( trn.getInr());
			this.getWfs().setWfstxt( serviceName);
			this.getWfs().setWkftyp("0");
			this.getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getWfs());
			log.debug("{}","out setWorkflow ... wfsinr=" + this.getWfs().getInr());
			return this.getWfs().getInr();

		}
        /**
        *   source:wfmmod.@0007.script
        */
        public String addWfe(com.ceb.gjjs.mda.bo.Trn trn,String wfsinr,String sta,String wfesrv,String exttyp,String srvtxt,String txt,String ptyinr, String rol)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 根据参数注册工作流，包括前台工作流和后台工作流均可
			  */
			log.debug("{}","in addwfe ...  ");
			this.getWfe().setWfsinr(wfsinr);
			this.getWfe().setSta(sta);
			this.getWfe().setSrv(wfesrv);
			if("D".equals(sta))
			{
			  this.getWfe().setDattim( MdaUtils.today());
			  this.getWfe().setExttrn( ctx.getTransName());
			}
			this.getWfe().setSrvtxt(srvtxt);
			this.getWfe().setTxt(txt);
			this.getWfe().setExttyp(exttyp);
			this.getWfe().setPtyinr(ptyinr);
			this.getWfe().setRol(rol);
			this.getWfe().setInr(Platform.sdbCounter("wfe"));
			ctx.getDaoSession().dbInsert(this.getWfe());
			log.debug("{}","out addwfe ... inr=" + this.getWfe().getInr());
			return this.getWfe().getInr();
		}
        /**
        *   source:wfmmod.@0008.script
        */
        public String wfsAddServcie(String trninr, String srv)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *更加和追加指定的工作流
			  */
			log.debug("{}","in wfsAddServcie ... trninr="+trninr+",srv="+srv );
			ctx.getErrorCode();
			ctx.getDaoSession().dbRead(this.getWfs(),new Argument("objtyp","trn"),new Argument("objinr",trninr));
			if(ctx.getErrorCode() ==NO_ERROR && !MdaUtils.isEmpty(this.getWfs().getInr()))
			{
			  this.getWfs().setWfstxt(this.getWfs().getWfstxt() +srv);
			  ctx.getDaoSession().dbUpdate(this.getWfs());
			}
			return this.getWfs().getInr();
		}













}