package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Witp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Witp.class);

        //人民币常用账户
        private transient IControl accbtn = new ControlImpl("accbtn", "人民币常用账户", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel witopn01;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopn02;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopn03;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopn04;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopn05;

        @JsonIgnore
        @BDGetter
        private transient IPanel witopn06;

        @JsonIgnore
        @BDGetter
        private transient IPanel witbtns;

        @JsonIgnore
        @BDGetter
        private transient IPanel wits;

        @JsonIgnore
        @BDGetter
        private transient IPanel witame;

        @JsonIgnore
        @BDGetter
        private transient IPanel witamebtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel witame01;

        @JsonIgnore
        @BDGetter
        private transient IPanel witdav;

        @JsonIgnore
        @BDGetter
        private transient IPanel witmav;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Widgrp> widgrp;

	    @BDGetter
		private Ptsp aplp;

	    @BDGetter
		private Ptsp isbp;

	    @BDGetter
		private Ptsp dapp;

	    @BDGetter
		private Stpmod stpmod;

	    @BDGetter
		private Zxjmod zxjmod;

	    @BDGetter
		private Tukmod tukmod;

	    @BDGetter
		private Pdfviw pdfviw;

	    @BDGetter
		private Actmod actmod;

	    @BDGetter
		private Agrp agrp;


		public Witp()
        {
            super();
            setArgument();
        }

        public Witp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getAplp().setPtsptaHolder(()->this.getWidgrp().getApl());
            this.getAplp().setRolHolder(new FieldConstantHolder<>("apl"));
            this.getAplp().setBelongtoHolder(new FieldConstantHolder<>("wid"));
            this.getAplp().setFlgHolder(new FieldConstantHolder<>("apl"));
            this.getIsbp().setPtsptaHolder(()->this.getWidgrp().getIsb());
            this.getIsbp().setRolHolder(new FieldConstantHolder<>("isb"));
            this.getIsbp().setBelongtoHolder(new FieldConstantHolder<>("wid"));
            this.getIsbp().setFlgHolder(new FieldConstantHolder<>("isb"));
            this.getDapp().setPtsptaHolder(()->this.getWidgrp().getDap());
            this.getDapp().setRolHolder(new FieldConstantHolder<>("dap"));
            this.getDapp().setBelongtoHolder(new FieldConstantHolder<>("wid"));
            this.getDapp().setFlgHolder(new FieldConstantHolder<>("dap"));
            this.getZxjmod().setAplHolder(()->this.getWidgrp().getApl());
            this.getZxjmod().setIsbHolder(()->this.getWidgrp().getIsb());
            this.getZxjmod().setZxjHolder(()->this.getWidgrp().getZxj());
            this.getZxjmod().setPrefixsHolder(new FieldConstantHolder<>("BZ"));
            this.getTukmod().setPdfviwHolder(()->this.getPdfviw());
        }





        public void setWidgrpHolder(ModuleHolder<Widgrp> widgrp)
        {
           this.widgrp = widgrp;
        }

        public Widgrp getWidgrp()
        {
           return this.widgrp.get();
        }





















}