package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xmlbod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Xmlbod.class);

        //报文处理应答
        private Map response;



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Busgrp> busgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptyset> ptyset;

	    @BDGetter
		private Kjsbod z00074;

	    @BDGetter
		private Stlbod z00001;

	    @BDGetter
		private Trn trn;

	    @BDGetter
		private Smh smh;

	    @BDGetter
		private Spt spt;

	    @BDGetter
		private Wfs wfs;

	    @BDGetter
		private Wfe wfe;

	    @BDGetter
		private Trn apltrn;


		public Xmlbod()
        {
            super();
            setArgument();
        }

        public Xmlbod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getZ00074().setBusgrpHolder(()->this.getBusgrp());
            this.getZ00074().setPtysetHolder(()->this.getPtyset());
            this.getZ00074().setTrnHolder(()->this.getTrn());
            this.getZ00074().setSmhHolder(()->this.getSmh());
            this.getZ00074().setSptHolder(()->this.getSpt());
            this.getZ00074().setApltrnHolder(()->this.getApltrn());
            this.getZ00001().setBusgrpHolder(()->this.getBusgrp());
            this.getZ00001().setPtysetHolder(()->this.getPtyset());
            this.getZ00001().setTrnHolder(()->this.getTrn());
            this.getZ00001().setSmhHolder(()->this.getSmh());
            this.getZ00001().setSptHolder(()->this.getSpt());
            this.getZ00001().setWfsHolder(()->this.getWfs());
            this.getZ00001().setWfeHolder(()->this.getWfe());
            this.getZ00001().setApltrnHolder(()->this.getApltrn());
        }




        /**
        *   source:xmlbod.@0000.script
        */
        public void parseBody(Map<String,Object> bodyMap,String sjly,String msgTyp,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析报文体信息
			  */
			IModule bodyMod = MdaDriver.getModule(this,sjly);
			MdaUtils.invoke(bodyMod,"parseMessage",msgTyp,bodyMap,resMsg);
		}
        /**
        *   source:xmlbod.@0001.script
        */
        public void preClearModuleData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 清空报文体处理模块数据
			  */
			log.debug("{}","in xmlbod.preClearModuleData ... ");
			MdaUtils.clear(this.getResponse());
			MdaUtils.clear(this.getTrn());
			MdaUtils.clear(this.getBusgrp());
			MdaUtils.clear(this.getZ00074());
			MdaUtils.clear(this.getZ00001());
			MdaUtils.clear(this.getTrn());
			MdaUtils.clear(this.getSmh());
			MdaUtils.clear(this.getSpt());
			MdaUtils.clear(this.getWfs());
			MdaUtils.clear(this.getWfe());
			MdaUtils.clear(this.getApltrn());
		}
        /**
        *   source:xmlbod.@0002.script
        */
        public Map<String,String> getResponseMsg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(this.getResponse().isEmpty())
			{
			  // 定义错误码信息
			}
			return this.getResponse();
		}
        /**
        *   source:xmlbod.@0008.script
        */
        public void setNoticeWorkflow(com.ceb.gjjs.mda.bo.Spt spt,String frm,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in  xmlbod setNoticeWorkflow ");
			if(MdaUtils.isEmpty(spt.getInr()))
			  return;
			if(MdaUtils.isEmpty(spt.getPtyinr()))
			  return;
			String trncod = frm;
			if(MdaUtils.isEmpty(frm))
			{
			  trncod  = spt.getFrm();
			}
			String srv = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getTrnService(trncod);
			log.info("{}","工作流注册交易：" + trncod +" ,注册工作流类型："+ srv);
			if(!MdaUtils.isEmpty(srv))
			{
			  // 1.存储 wfs
			  String wfsinr = setWfsFromXmlbod(spt,srv,typ);
			  // 2.存储 wfe
			  if(!MdaUtils.isEmpty(wfsinr))
			    noticeBySMSAndEmail(wfsinr,spt.getPtyinr(),trncod, spt.getSmhinr(),spt.getObjinr());
			}
		}
        /**
        *   source:xmlbod.@0009.script
        */
        public String setWfsFromXmlbod(IModule mod, String srv,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in setWfsFromXmlbod ... ");
			MdaUtils.clear(this.getWfs());
			IDatafield<String> fld =(IDatafield<String>) MdaDriver.getDatafield(mod,"inr");
			String objinr = fld.getValue();
			if(MdaUtils.isEmpty(objinr))
			{
			  return null;
			}
			this.getWfs().setObjinr(objinr);
			this.getWfs().setObjtyp(MdaDriver.getModuleType(mod));
			this.getWfs().setWfstxt(srv);
			this.getWfs().setWkftyp(typ);
			this.getWfs().setInr(Platform.sdbCounter("wfs"));
			ctx.getDaoSession().dbInsert(this.getWfs());
			log.debug("{}"," SAVE WFS{inr=" + this.getWfs().getInr() + "}");
			log.debug("{}","out setWfsFromXmlbod ... ");
			return this.getWfs().getInr();
		}
        /**
        *   source:xmlbod.@0010.script
        */
        public boolean noticeBySMSAndEmail(String wfsinr,String ptyinr,String frm,String smhinr,String objinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","noticeBySMSAndEmail...");
			if(MdaUtils.isEmpty(ptyinr)) return false;
			/*判断是否汇出汇款通知,汇入预通知，汇入汇款通知，*/
			if("cptout".equals(frm)||"cptyub".equals(frm)||"cptsub".equals(frm))
			{
			  String clicid = this.getPtyset().getCli().getCid();
			  boolean flg=false;
			  /*判断是否打开消息推送开关    */
			  flg = (boolean)MdaUtils.invoke(this.getBusgrp().getNotmod(),"checkSwitch",clicid);
			  if(flg)
			  {
			    ctx.getErrorCode();
			    if("cptout".equals(frm)||"cptsub".equals(frm))
			    {
			      Argument<String> inr = new Argument<String>("inr");
			      Argument<Date> inidattim = new Argument<Date>("inidattim");
			      String selTRN = "select inr, inidattim  from trn where objinr = '"+objinr+"' and objtyp='cpd' and inifrm in ('cptopn','cptapi') and ptytyp = '2' and  ptyinr='"+ptyinr+"'";
			      ctx.getDaoSession().dbExecuteSQL(selTRN);
			      ctx.getDaoSession().dbFetchFields(inr,inidattim);
			      int e=ctx.getErrorCode();
			      log.debug("{}","errorcode="+e);
			      if(e==NO_ERROR&&!MdaUtils.isEmpty(inr.value))
			      {
			        ctx.getDaoSession().dbCloseCursor();
			        log.debug("{}","...........e结算发起业务才推送...........");
			        log.info("{}","workflow clicid :"+clicid+"  and msgfswitch open");
			        addMessageService(wfsinr,frm,objinr,ptyinr,clicid,inidattim.value);

			      }
			      else
			        ctx.getDaoSession().dbCloseCursor();
			    }
			    else
			    {
			      log.info("{}","workflow clicid :"+clicid+"  and msgfswitch open");
			      addMessageService(wfsinr,frm,objinr,ptyinr,clicid,MdaUtils.today());
			    }
			  }

			}
			Argument<String> inr=new Argument<String>("inr");
			Argument<String> msgflg=new Argument<String>("msgflg");
			Argument<String> emlflg=new Argument<String>("emlflg");
			Argument<String> mobile=new Argument<String>("mobile");
			Argument<String> eml=new Argument<String>("eml");
			ctx.getDaoSession().dbExecuteSQL("SELECT inr,emlflg,msgflg,mobile,eml FROM msg WHERE ptyinr='"+ptyinr+"' and frm='"+frm+"'");
			ctx.getDaoSession().dbFetchFields(inr,emlflg,msgflg,mobile,eml);
			int e=ctx.getErrorCode();
			log.debug("{}","errorcode="+e);
			log.info("{}",inr.value+","+emlflg.value+","+msgflg.value+","+mobile.value+",");
			if(e==NO_ERROR)
			{
			  log.info("{}","msginr="+inr.value);
			  if("X".equals(emlflg.value)&&!MdaUtils.isEmpty(eml.value))
			  {
			    addEmailService(wfsinr,smhinr,inr.value);
			  }
			  if("X".equals(msgflg.value)&&!MdaUtils.isEmpty(mobile.value))
			  {
			    log.info("{}","sms service...");
			    String tels=mobile.value;
			    if(!MdaUtils.isEmpty(tels))
			    {
			      tels = tels.replaceAll(";",",");
			      String[] tel = tels.split(",");
			      for(String t:tel)
			      {
			        addSMSService(wfsinr,t,inr.value);
			      }
			    }

			  }
			}
			log.debug("{}","noticeBySMSAndEmail...end");
			ctx.getDaoSession().dbCloseCursor();
			return true;
		}
        /**
        *   source:xmlbod.@0011.script
        */
        public void addSMSService(String wfsinr,String cellnumber,String msginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 注册新增短信服务
			  */
			log.debug("{}","in xmlbod.addSMSService... ");

			this.getWfe().setWfsinr(wfsinr);
			this.getWfe().setTardattim(MdaUtils.today());
			this.getWfe().setSta("W");
			this.getWfe().setSrv("M");
			this.getWfe().setManflg("0");
			this.getWfe().setDattim(MdaUtils.today());
			this.getWfe().setSrvtxt(msginr);
			this.getWfe().setTxt(cellnumber);
			this.getWfe().setInr(Platform.sdbCounter("wfe"));
			ctx.getDaoSession().dbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());
		}
        /**
        *   source:xmlbod.@0012.script
        */
        public void addEmailService(String wfsinr,String smhinr,String msginr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			log.info("{}","in xmlbod addEmailService ...");
			this.getWfe().setWfsinr(wfsinr);
			this.getWfe().setTardattim(MdaUtils.today());
			this.getWfe().setSta("W");
			this.getWfe().setSrv("E");
			this.getWfe().setManflg("0");
			this.getWfe().setDattim(MdaUtils.today());
			this.getWfe().setSrvtxt(msginr);
			this.getWfe().setTxt(smhinr);
			this.getWfe().setInr(Platform.sdbCounter("wfe"));
			ctx.getDaoSession().dbInsert(this.getWfe());
			MdaUtils.clear(this.getWfe());

		}
        /**
        *   source:xmlbod.@0013.script
        */
        public void updateAplTrn(IModule mod, String[] frmlist)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," in  xmlbod.updateAplTrn... ");
			IDatafield<String> fldInr=(IDatafield<String>)MdaDriver.getDatafield(mod,"inr");
			String objinr = fldInr.getValue();
			String objtyp= MdaDriver.getModuleType(mod);
			String frms ="" ;
			if(MdaUtils.isEmpty(frmlist))
			  return;
			else
			  frms=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).toSqlString(frmlist);
			log.info("{}","objinr="+objinr+",objtyp="+objtyp+",apltrn="+ Arrays.toString(frmlist));
			Argument<String> inr=new Argument<String>("inr");
			String sql="SELECT inr FROM trn WHERE objinr='"+objinr+"' AND objtyp='"+objtyp+"' AND inifrm IN ("+frms+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbRead(this.getApltrn(),new Argument<String>("inr",inr.value));
			    if(MdaUtils.isEmpty(this.getApltrn().getInr()))
			      continue;
			    log.info("{}","trn to be updated inr="+this.getApltrn().getInr());
			    this.getApltrn().setSta("A");
			    ctx.getDaoSession().dbUpdate(this.getApltrn());
			    MdaUtils.clear(this.getApltrn());
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:xmlbod.@0014.script
        */
        public void setOrdOreFromXmlbod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *新增ORD和ORE记录  TODO 此处调用的方法对于ORE和ORD赋值并不全面，但仍延续以往交易的做法
			  */
			MdaUtils.invoke(ctx.getRoot(),"createOrdAndOre");

		}
        /**
        *   source:xmlbod.@0016.script
        */
        public void addMessageService(String wfsinr,String frm,String objinr,String ptyinr,String cid,Date credat)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*手机银行短信服务*/
			log.info("{}","in xmlbod addMobileNoticeService ...");
			//存储待发送消息
			String notmsginr=this.getBusgrp().setNotmsgData1(frm,objinr,credat);
			if(!MdaUtils.isEmpty(notmsginr))
			{
			  if("cptyub".equals(frm))
			  {
			    //获取复核经办权限的人员
			    List <String>list=this.getBusgrp().getNotmod().getUsr(cid,"cptapi","J",null);
			    if(!MdaUtils.isEmpty(list))
			    {
			      for(int i=0;i<list.size();i++){
			        this.getWfe().setWfsinr(wfsinr);
			      this.getWfe().setTardattim(MdaUtils.today());
			      this.getWfe().setSta("W");
			      this.getWfe().setSrv("Z");
			      this.getWfe().setManflg("0");
			      this.getWfe().setDattim(MdaUtils.today());
			      this.getWfe().setSrvtxt(notmsginr);
			      this.getWfe().setTxt(frm);
			      this.getWfe().setPtyinr(ptyinr);
			      this.getWfe().setInr(Platform.sdbCounter("wfe"));
			      this.getWfe().setRol(list.get(i));
			      ctx.getDaoSession().dbInsert(this.getWfe());
			      log.info("{}","cptyub msg wfe:"+this.getWfe().getInr());
			    }
			  }
			}
			else
			{
			  //获取该笔业务的经办人员
			  Argument<String> oid=new Argument<String>("oid");
			  log.info("{}","objinr :"+objinr);
			  //Platform.dbExecuteSQL("select u.oid from usr u left join trn t on t.objinr='"+objinr and t.inifrm='"+frm+"' where t.iniusr=u.inr");
			  String seluser ="select t.inr,u.oid  from trn t  left join usr u  on t.iniusr = u.inr where t.objinr= '"+objinr
			    +"' and t.objtyp='cpd'  and t.inifrm in ( 'cptopn','cptapi')  and t.ptytyp = '2'";
			  ctx.getDaoSession().dbExecuteSQL(seluser);
			  ctx.getDaoSession().dbFetchFields(oid);
			  if(ctx.getErrorCode()==NO_ERROR&&!MdaUtils.isEmpty(oid.value))
			  {
			    this.getWfe().setWfsinr(wfsinr);
			    this.getWfe().setTardattim(MdaUtils.today());
			    this.getWfe().setSta("W");
			    this.getWfe().setSrv("Z");
			    this.getWfe().setManflg("0");
			    this.getWfe().setDattim(MdaUtils.today());
			    this.getWfe().setSrvtxt(notmsginr);
			    this.getWfe().setTxt(frm);
			    this.getWfe().setPtyinr(ptyinr);
			    this.getWfe().setRol(oid.value);
			    this.getWfe().setInr(Platform.sdbCounter("wfe"));
			    ctx.getDaoSession().dbInsert(this.getWfe());
			    log.info("{}",frm+" msg wfe:"+this.getWfe().getInr());
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			}
			MdaUtils.clear(this.getWfe());
		}

        public void setBusgrpHolder(ModuleHolder<Busgrp> busgrp)
        {
           this.busgrp = busgrp;
        }

        public Busgrp getBusgrp()
        {
           return this.busgrp.get();
        }

        public void setPtysetHolder(ModuleHolder<Ptyset> ptyset)
        {
           this.ptyset = ptyset;
        }

        public Ptyset getPtyset()
        {
           return this.ptyset.get();
        }



















}