package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 定义报文头
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xmlhad extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Xmlhad.class);

        //数据来源
        private String sjly;

        //报文头处理返回信息
        private Map response;



	    @BDGetter
		private Stlhad z00001;

	    @BDGetter
		private Kjshad z00074;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptyset> ptyset;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Busgrp> busgrp;


		public Xmlhad()
        {
            super();
            setArgument();
        }

        public Xmlhad(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getZ00001().setPtysetHolder(()->this.getPtyset());
            this.getZ00001().setBusgrpHolder(()->this.getBusgrp());
        }




        /**
        *   source:xmlhad.@0000.script
        */
        public void parseHeader(Map<String,Object> data, String sourceSystem,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析报文头
			  */
			log.debug("{}"," in xmlhad.parseHeader ...  ");
			if(!MdaUtils.isEmpty(sourceSystem))
			{
			  this.setSjly(sourceSystem.toLowerCase());
			  IModule headerMod = MdaDriver.getModule(this,this,this.getSjly());
			  MdaUtils.invoke(headerMod,"parseHeader",data,resMsg);
			}
		}
        /**
        *   source:xmlhad.@0001.script
        */
        public void preClearModuleData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 清空报文头处理模块数据
			  */
			this.setSjly(NULLSTR);
			MdaUtils.clear(this.getResponse());
			MdaUtils.clear(this.getZ00001());
			MdaUtils.clear(this.getZ00074());
		}
        /**
        *   source:xmlhad.@0002.script
        */
        public Map<String,String> getResponseMsg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(this.getResponse().isEmpty())
			{
			  // 定义错误码信息
			}
			return this.getResponse();
		}
        /**
        *   source:xmlhad.@0003.script
        */
        public String getSourceSystem()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *  返回来报系统编号
			  */
			return this.getSjly();
		}
        /**
        *   source:xmlhad.@0004.script
        */
        public String getMessageType(String sjly)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文头模块接口，返回报文的报文类型/报文编号
			  */

			String msgTyp ="";
			if(MdaUtils.isEmpty(sjly))
			{
			  log.error("{}","报文来源系统编号为空");
			  msgTyp =  "";
			}
			else
			{
			  IModule headerMod = MdaDriver.getModule(this,this,sjly);
			  msgTyp = (String)MdaUtils.invoke(headerMod,"getMessageType");
			}
			return msgTyp;
		}
        /**
        *   source:xmlhad.@0005.script
        */
        public void updateTrnFromXmlbod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}





        public void setPtysetHolder(ModuleHolder<Ptyset> ptyset)
        {
           this.ptyset = ptyset;
        }

        public Ptyset getPtyset()
        {
           return this.ptyset.get();
        }

        public void setBusgrpHolder(ModuleHolder<Busgrp> busgrp)
        {
           this.busgrp = busgrp;
        }

        public Busgrp getBusgrp()
        {
           return this.busgrp.get();
        }





}