package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Acc;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Mad;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* XML报文字段解析映射公共模块
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xmlmap extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Xmlmap.class);

        //报文类型
        private String msgtyp;

        //业务归属机构号
        private String bchcod;

        //业务模型组类型
        private String grptyp;

        //业务参考号
        private String ownref;

        //报文接收或发送时间
        private Date xmldat;

        //报文来源系统编号
        private String srcsys;

        //银行端业务归属
        private String bnkptyinr;

        //商行端业务归属
        private String cliptyinr;

        //原系统报文编号
        private String srcmsgnum;

        //原报文ID
        private String srcfilid;

        //交易名称
        private String frm;

        //工作流服务
        private String srvfrm;

        //业务描述
        private String objnam;

        //参考号前缀
        private String prefix;

        //业务表索引
        private String objinr;

        //业务表名
        private String objtyp;

        //实体索引
        private String etyinr;

        //业务相关参考号
        private String srcownref;

        //总行机构代码
        @Module(getter = false, setter = false)
		private FieldHolder<String> headbchcod = new FieldConstantHolder<>("");


        //商行端客户名称
        private String cliptynam;

        //银行端机构名称
        private String bnkptynam;

        //业务币种
        private String cur;

        //业务金额
        private BigDecimal amt = new BigDecimal("0.00");

        //更新TRN状态标记
        private String trnupdflg;

        //报文信息映射
        private Map datamap;



	    @BDGetter
		private Rpdgrp rpdgrp;

	    @BDGetter
		private Ersmod ersmod;

	    @BDGetter
		private Ersgrp ersgrp;

	    @BDGetter
		private Pty bnk;

	    @BDGetter
		private Pty cli;

	    @BDGetter
		private Acc acc;

	    @BDGetter
		private Trn trn;

	    @BDGetter
		private Mad mad;

	    @BDGetter
		private Rptp rptp;

	    @BDGetter
		private Ersp ersp;


		public Xmlmap()
        {
            super();
            setArgument();
        }

        public Xmlmap(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
            this.getErsmod().setBchcodHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("bchcod");}
 				public void setValue(String arg){Xmlmap.this.setBchcod(arg);}
 				public String getValue(){return Xmlmap.this.getBchcod();}}
			 );
            this.getErsmod().setCredatHolder( new FieldHolder<Date>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.credat");}
 				public void setValue(Date arg){Xmlmap.this.getRpdgrp().getRec().setCredat(arg);}
 				public Date getValue(){return Xmlmap.this.getRpdgrp().getRec().getCredat();}}
			 );
            this.getErsmod().setOwnrefHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("ownref");}
 				public void setValue(String arg){Xmlmap.this.setOwnref(arg);}
 				public String getValue(){return Xmlmap.this.getOwnref();}}
			 );
            this.getErsmod().setObjtypHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("objtyp");}
 				public void setValue(String arg){Xmlmap.this.setObjtyp(arg);}
 				public String getValue(){return Xmlmap.this.getObjtyp();}}
			 );
            this.getErsmod().setObjinrHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("objinr");}
 				public void setValue(String arg){Xmlmap.this.setObjinr(arg);}
 				public String getValue(){return Xmlmap.this.getObjinr();}}
			 );
            this.getErsmod().setMsgtypHolder(new FieldConstantHolder<>("0401"));
            this.getErsmod().setRecstaHolder(new FieldConstantHolder<>("A"));
            this.getErsmod().setDirHolder(new FieldConstantHolder<>("<"));
            this.getErsmod().setInftxtHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.beizhu");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setBeizhu(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getBeizhu();}}
			 );
            this.getErsmod().setMsgattHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.msgatr");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setMsgatr(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getMsgatr();}}
			 );
            this.getErsmod().setPtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.ptyinr");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setPtyinr(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getPtyinr();}}
			 );
            this.getErsmod().setTrninrHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("trn.inr");}
 				public void setValue(String arg){Xmlmap.this.getTrn().setInr(arg);}
 				public String getValue(){return Xmlmap.this.getTrn().getInr();}}
			 );
            this.getErsmod().setAgtactHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.agtact");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setAgtact(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getAgtact();}}
			 );
            this.getErsmod().setAgtextkeyHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.agtextkey");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setAgtextkey(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getAgtextkey();}}
			 );
            this.getErsmod().setPrefixHolder(new FieldConstantHolder<>("GLBH"));
            this.getErsmod().setEtyinrHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.etyinr");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setEtyinr(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getEtyinr();}}
			 );
            this.getErsmod().setCurHolder( new FieldHolder<String>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.rptcur");}
 				public void setValue(String arg){Xmlmap.this.getRpdgrp().getRec().setRptcur(arg);}
 				public String getValue(){return Xmlmap.this.getRpdgrp().getRec().getRptcur();}}
			 );
            this.getErsmod().setAmtHolder( new FieldHolder<BigDecimal>(){
				public String getPath(){return Xmlmap.this.getFieldPath("rpdgrp.rec.rptamt");}
 				public void setValue(BigDecimal arg){Xmlmap.this.getRpdgrp().getRec().setRptamt(arg);}
 				public BigDecimal getValue(){return Xmlmap.this.getRpdgrp().getRec().getRptamt();}}
			 );
            this.getRptp().setRpdgrpHolder(()->this.getRpdgrp());
            this.getErsp().setErsHolder(()->this.getErsmod().getErs());
        }



        /**
        *   source:xmlmap.@0017.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			//进行初始化
			this.setHeadbchcod( "08101");
			// TODO 各个交易配置文件可以在初始化时读入对应的MAP中
			

			return true;
        }


        /**
        *   source:xmlmap.@0000.script
        */
        public void clearXmlmap()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 每一笔报文处理前先执行该函数对业务数据，清空初始化数据
			  */
			this.setMsgtyp(NULLSTR);
			this.setBchcod(NULLSTR);
			this.setGrptyp(NULLSTR);
			this.setOwnref(NULLSTR);
			this.setXmldat(null);
			this.setSrcsys(NULLSTR);
			this.setBnkptyinr(NULLSTR);
			this.setCliptyinr(NULLSTR);
			this.setSrcmsgnum(NULLSTR);
			this.setSrcfilid(NULLSTR);
			this.setFrm(NULLSTR);
			this.setSrvfrm(NULLSTR);
			this.setObjnam(NULLSTR);
			this.setPrefix(NULLSTR);
			this.setObjinr(NULLSTR);
			this.setObjtyp(NULLSTR);
			this.setEtyinr(NULLSTR);
			this.setSrcownref(NULLSTR);
			this.setCliptynam(NULLSTR);
			this.setBnkptynam(NULLSTR);
			this.setCur(NULLSTR);
			this.setAmt(new BigDecimal(0));
			this.setTrnupdflg(NULLSTR);
		}
        /**
        *   source:xmlmap.@0001.script
        */
        public Boolean  determineXml0401 (Map<String,Object> data,Map<String,String> resultMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 0401-XML报文信息
			  @ 返回解析是否成功 (TODO 返回默认为成功 )
			  */
			log.debug("{}"," in xmlmap.determineXml0401 .... ") ;
			Boolean rstMsg  = true  ;  // 定义返回值
			// 1.设置公共参数
			String msgtyp = this.getMsgtyp();
			this.setGrptyp( "rpdgrp" );
			this.setObjtyp("rpd");
			this.setPrefix("LP");
			this.setFrm("rptshw");
			// $srvfrm = "rptshw";
			//initXmlmapDatafeild(msgtyp);
			String hnglbh =(String)data.get("VROOT.MsgBody.HNGLBH");
			String cliacc =(String)data.get("CROOT.MsgBody.DLHZHDH"); // 代理行账号
			String clibic =(String)data.get("VROOT.MsgBody.DLHDM");  // 代理行行号
			log.debug("{}"," clibic ="+ clibic + ",cliacc=" + cliacc  );
			if(MdaUtils.isEmpty(cliacc) || MdaUtils.isEmpty(clibic) )
			{
			  if(resultMap == null )
			  {
			    resultMap = new HashMap<String,String>();
			  }
			  resultMap.put("ERRORMSG", "报文中未获取到对应的代理行账号或行号信息" );
			  log.error("{}"," 报文中未找到对应的代理行账号或行号信息 ");
			  return false;
			}
			if(!MdaUtils.isEmpty(cliacc))
			{
			  setCliAndBnkByAcc(cliacc);
			}
			if(MdaUtils.isEmpty(this.getBnkptyinr()) &&  !MdaUtils.isEmpty(this.getBchcod()))
			{
			  String bnkptyinr = setBnkPtyFromBchcod(this.getBchcod());
			}
			if(MdaUtils.isEmpty(this.getCliptyinr()) && !MdaUtils.isEmpty(clibic) )
			{
			  String cliptyinr = setCliPtyFromBic(clibic);
			}
			if(MdaUtils.isEmpty(this.getBchcod()) && MdaUtils.isEmpty(this.getBnkptyinr()))
			{
			  setBnkPtyFromBchcod(this.getHeadbchcod());
			}

			// 2.按照公共函数进行数据映射
			// 清除模块中的数据
			MdaUtils.clear(this.getRpdgrp().getRec());
			MdaUtils.clear(this.getErsmod().getErs());
			setModuleContent(data);
			// 3. 当前交易下 GRP字段赋值
			if(!MdaUtils.isEmpty(this.getCliptyinr()))
			{
			  this.getRpdgrp().getRec().setPtyinr( this.getCliptyinr());
			}
			if( !MdaUtils.isEmpty(this.getEtyinr()))
			{

			  this.getRpdgrp().getRec().setEtyinr( this.getEtyinr());
			}

			if(MdaUtils.isEmpty(this.getRpdgrp().getRec().getBchcod()))
			{
			  this.getRpdgrp().getRec().setBchcod( this.getBchcod());
			}
			this.getRpdgrp().getRec().setRpttyp("I" );
			this.getRpdgrp().getRec().setCredat( MdaUtils.today());
			String jyckh=this.getRpdgrp().getRec().getOwnref();
			this.setOwnref(getRef(this.getPrefix()));
			this.getRpdgrp().getRec().setOwnref(  this.getOwnref());
			this.getRpdgrp().getRec().setInr(Platform.sdbCounter("rpd"));
			ctx.absGet(Sysmod.class).sdbInsert(this.getRpdgrp().getRec()) ;
			this.setObjinr( this.getRpdgrp().getRec().getInr());
			this.setAmt( this.getRpdgrp().getRec().getRptamt());
			this.setCur( this.getRpdgrp().getRec().getRptcur());

			if(!MdaUtils.isEmpty(this.getCliptynam()))
			{
			  this.setObjnam( this.getCur()+"/"+this.getAmt()+this.getCliptynam());
			}
			else
			{
			  this.setObjnam( this.getCur()+"/"+this.getAmt());
			}
			log.debug("{}"," save  RPD { INR = " + this.getObjinr() +" , ownref = " + this.getOwnref()+ " } ") ;

			// 4.存储TRN报文
			xmlmapSetTrnFromContract(this.getRpdgrp().getRec(),"A");
			// 5.存储 ERS
			// 来报业务需要处理一下对账中发起的来账文件重新下载的报文信息
			// MAD.hnglbh - 日期  ERS.outdat = MAD.outdat   更新  mad.sigchk= C
			Date outdat = MdaUtils.today();
			MdaUtils.clear(this.getMad());
			ctx.getDaoSession().dbRead(this.getMad(),new Argument("hnglbh",hnglbh));
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  // 此表业务为对账后发起的下载业务
			  log.debug("{}"," 对账后收到原业务报文 hnglbh = " + hnglbh ) ;
			  outdat = this.getMad().getOutdat();
			  BigDecimal amt = this.getRpdgrp().getRec().getRptamt();
			  BigDecimal madamt= this.getMad().getRptamt();
			  String cur = this.getRpdgrp().getRec().getRptcur();
			  String madcur = this.getMad().getRptcur();
			  if(!MdaUtils.isEmpty(amt) && !MdaUtils.isEmpty(cur))
			  {
			    if( amt.compareTo(madamt) == 0 && cur.equals(madcur))
			    {
			      this.getMad().setOwnref( this.getOwnref());
			      this.getMad().setSigchk( "C" );
			      this.getMad().setHadsta( "1" );
			    }
			    else
			    {
			      this.getMad().setOwnref( this.getOwnref());
			      this.getMad().setSigchk( "Y" );
			      this.getMad().setHadsta( "0" );
			    }
			    ctx.getDaoSession().dbUpdate(this.getMad());
			  }
			  else
			  {
			    log.debug("{}"," 找到对账信息，但是原业务报文中金额或币种为空  ");
			  }
			}
			this.getErsmod().getErs().setDeldat( MdaUtils.today());
			this.getErsmod().getErs().setOutdat(outdat);
			this.getErsmod().getErs().setMsgref( jyckh );
			this.getErsmod().ersSetFromContract();

			// 6.存储界面文件
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			
			ctx.saveDisplay(filename);
			log.debug("{}"," out xmlmap.determineXml0401 .... ") ;
			return  rstMsg;

		}
        /**
        *   source:xmlmap.@0002.script
        */
        public Boolean  determineXml0402 (Map<String,Object> data,Map<String,String> resultMap )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 0402-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in xmlmap.determineXml0402 .... ") ;
			Boolean rstMsg  = true  ;  // 定义返回值
			// 1.设置公共参数
			String msgtyp = this.getMsgtyp();
			this.setGrptyp( "ersgrp" );
			this.setObjtyp("ers");
			this.setFrm("ersshw");
			String clibic =(String)data.get("VROOT.MsgBody.DLHDM");  // 代理行行号
			String cliacc =(String)data.get("CROOT.MsgBody.DLHZHDH"); // 代理行账号
			String yhnglbh =(String)data.get("VROOT.MsgBody.YHNGLBH"); // 原行内关联编号
			log.debug("{}"," clibic ="+ clibic + ",cliacc=" + cliacc +",yhnglbh=" +yhnglbh );
			MdaUtils.clear(this.getErsgrp().getRec());
			// 1.1判断落地机构
			if(!MdaUtils.isEmpty(cliacc))
			{
			  String ptyinr =setCliAndBnkByAcc(cliacc);
			  if(MdaUtils.isEmpty(ptyinr))
			  {
			    resultMap.put("ERRORMSG", "代理行账号:"+cliacc + " 未在系统中维护，请先完善代理行信息. " );
			    log.error("{}"," 报文中未找到对应的代理行账号或行号信息 ");
			    return false;
			  }
			}
			else
			{
			  resultMap.put("ERRORMSG", "代理行账号不能为空 . " );
			  log.error("{}"," 报文中未找到对应的代理行账号信息 ");
			  return false;
			}

			if(MdaUtils.isEmpty(this.getCliptyinr()) && !MdaUtils.isEmpty(clibic) )
			{
			  String cliptyinr = setCliPtyFromBic(clibic);
			}
			if(MdaUtils.isEmpty(this.getBnkptyinr()) &&  !MdaUtils.isEmpty(this.getBchcod()))
			{
			  String bnkptyinr = setBnkPtyFromBchcod(this.getBchcod());
			}

			if(MdaUtils.isEmpty(this.getBchcod()) && MdaUtils.isEmpty(this.getBnkptyinr()))
			{
			  setBnkPtyFromBchcod(this.getHeadbchcod());
			}

			// 2.按照公共函数进行数据映射
			setModuleContent(data);

			// 3. 当前交易下 GRP字段赋值
			if(!MdaUtils.isEmpty(this.getCliptyinr()))
			{
			  this.getErsgrp().getRec().setPtyinr( this.getCliptyinr());
			}
			if( !MdaUtils.isEmpty(this.getEtyinr()))
			{
			  this.getErsgrp().getRec().setEtyinr( this.getEtyinr());
			}
			if(MdaUtils.isEmpty(this.getErsgrp().getRec().getBchcod()))
			{
			  this.getErsgrp().getRec().setBchcod( this.getBchcod());
			}
			this.getErsgrp().getRec().setCredat( MdaUtils.today());
			this.getErsgrp().getRec().setOutdat( MdaUtils.today());
			this.getErsgrp().getRec().setDeldat( MdaUtils.today());
			this.getErsgrp().getRec().setBchcod(this.getBchcod());
			this.getErsgrp().getRec().setObjtyp(this.getObjtyp());
			this.getErsgrp().getRec().setMsgtyp(this.getMsgtyp());
			this.getErsgrp().getRec().setDir( "<");
			this.getErsgrp().getRec().setRecsta( "A");
			if(!MdaUtils.isEmpty(yhnglbh))
			{
			  MdaUtils.clear(this.getErsmod().getErs());
			  ctx.getDaoSession().dbRead(this.getErsmod().getErs(),new Argument<String>("hnglbh",EQ,yhnglbh));
			  //业务可 关联 一笔已有报文
			  int errcod = ctx.getErrorCode();
			  if(errcod == NO_ERROR )
			  {
			    log.debug("{}"," 匹配上一笔原报文.. ");
			    this.getErsgrp().getRec().setAgtextkey(this.getErsmod().getErs().getAgtextkey());
			    this.getErsgrp().getRec().setBusref(this.getErsmod().getErs().getOwnref());
			    // $ersgrp\\rec\\cur.setValue($ersmod\\ers\\cur.getValue());
			    // $ersgrp\\rec\\amt.setValue($ersmod\\ers\\amt.getValue());
			    this.setEtyinr( this.getErsmod().getErs().getEtyinr());
			    this.setCliptyinr( this.getErsmod().getErs().getPtyinr());
			    if(!MdaUtils.isEmpty(this.getErsmod().getErs().getBchcod()))
			    {
			      setBnkPtyFromBchcod(this.getErsmod().getErs().getBchcod());
			      this.setBchcod( this.getErsmod().getErs().getBchcod());
			    }
			    this.getErsgrp().getRec().setObjtyp( "ers");
			    this.getErsgrp().getRec().setObjinr( this.getErsmod().getErs().getInr());
			    this.getErsgrp().getRec().setPtyinr( this.getCliptyinr());
			    this.getErsgrp().getRec().setEtyinr( this.getEtyinr());
			    this.getErsgrp().getRec().setBchcod( this.getBchcod());
			  }
			  else
			  {
			    log.debug("{}"," 未匹配上一笔原报文.. hnglbh=" + yhnglbh);
			  }
			}
			this.getErsgrp().getRec().setOwnref(getRef("EQ"));
			this.setOwnref( this.getErsgrp().getRec().getOwnref());
			this.getErsgrp().getRec().setInr(Platform.sdbCounter("ers"));  // 4.存储 ERS报文表
			ctx.getDaoSession().dbInsert(this.getErsgrp().getRec());
			log.debug("{}"," save  ers { INR = " +  this.getErsgrp().getRec().getInr() +" , ownref = " + this.getOwnref()+ " } ") ;
			this.setObjinr( this.getErsgrp().getRec().getInr());
			this.setCur("CNY");
			this.setAmt(new BigDecimal(0.00));
			if(!MdaUtils.isEmpty(this.getCliptynam()))
			{
			  this.setObjnam( this.getCur()+"/" +this.getAmt()+this.getCliptynam());
			}
			else
			{
			  this.setObjnam( this.getCur()+"/"+this.getAmt());
			}

			// 5.存储TRN报文
			xmlmapSetTrnFromContract(this.getErsgrp().getRec(),"A");

			// 6.存储界面文件
			String filename = ctx.absGet(Sysmod.class).createFilename(this.getTrn().getInr(),"zul");
			log.info("{}","filename is "+filename);
			ctx.saveDisplay(filename);
			log.debug("{}"," out xmlmap.determineXml0402 .... ") ;
			return  rstMsg;
		}
        /**
        *   source:xmlmap.@0003.script
        */
        public Boolean  determineXml0403 (Map<String,Object> data,Map<String,String> resultMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 0403-XML报文信息-回执
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in xmlmap.determineXml0403 .... ") ;
			Boolean rstMsg  = true  ;  // 定义返回值
			// 1.设置公共参数
			String msgtyp = this.getMsgtyp();
			this.setGrptyp( "rpdgrp" );
			this.setObjtyp("rpd");
			this.setPrefix("WP");
			this.setFrm("rptdav");
			this.setTrnupdflg( "X"); // 需要更新原业务TRN
			String yhnglbh= (String)data.get("VROOT.MsgBody.YHNGLBH"); // 原行内关联编号
			log.debug("{}","yhnglbh=" +yhnglbh );
			if(resultMap == null )
			{
			  resultMap = new HashMap<String,String>();
			}
			if(MdaUtils.isEmpty(yhnglbh))
			{
			  rstMsg = false;
			  resultMap.put("ERRORMSG", "报文中未获取原行内关联编号" );
			  log.error("{}","接口数据错误，原行内关联编号为空 ...  ");
			  return rstMsg;
			}
			MdaUtils.clear(this.getErsmod().getErs());
			ctx.getDaoSession().dbRead(this.getErsmod().getErs(),new Argument<String>("hnglbh",yhnglbh));
			if(ctx.getErrorCode() != NO_ERROR )
			{
			  rstMsg = false;
			  resultMap.put("ERRORMSG", "原行内关联编号:"+yhnglbh +"无法关联原始业务" );
			  log.error("{}","接口数据错误，原行内关联编号无法关联原业务...         ");
			  return rstMsg;
			}
			this.setObjtyp(this.getErsmod().getErs().getObjtyp());
			this.setObjinr(this.getErsmod().getErs().getObjinr());
			// 2.按照公共函数进行数据映射
			setModuleContent(data);
			String hzzt ="";
			if(!MdaUtils.isEmpty(this.getErsmod().getErs().getRecsta()))
			{
			  hzzt = convertState(this.getErsmod().getErs().getRecsta());
			  this.getErsmod().getErs().setRecsta(hzzt);
			}
			this.getErsmod().getErs().setDeldat(MdaUtils.today());

			// 3.更新ers表数据状态
			ctx.absGet(Sysmod.class).sdbUpdate(this.getErsmod().getErs()) ;
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  rstMsg = false;
			  resultMap.put("ERRORMSG", "数据库更新ERS表错误" );
			  log.error("{}","更新业务ERS表信息失败         ");
			}
			log.debug("{}"," update  Ers { INR = " + this.getErsmod().getErs().getInr() +" , objinr = " + this.getObjtyp()+ ", objtyp=" +this.getObjinr()+" } ") ;
			// 4.此笔业务为隔日收到往账业务回执报文
			MdaUtils.clear(this.getMad());
			ctx.getDaoSession().dbRead(this.getMad(),new Argument("hnglbh",yhnglbh));
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.debug("{}"," 隔日收到原业务报文回执 yhnglbh = " + yhnglbh ) ;
			  this.getMad().setSigchk( "C" );
			  this.getMad().setHadsta( "1" );
			  this.getMad().setRecsta( hzzt);
			  ctx.getDaoSession().dbUpdate(this.getMad());
			}
			return  rstMsg;

		}
        /**
        *   source:xmlmap.@0004.script
        */
        public Boolean  determineXml0404 (Map<String,Object> data,Map<String,String> resultMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 0404-XML报文信息-回执
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in xmlmap.determineXml0404 .... ") ;
			Boolean rstMsg  = true  ;  // 定义返回值
			// 1.设置公共参数
			String msgtyp = this.getMsgtyp();
			this.setGrptyp( "ersgrp" );
			this.setFrm( "ersdav" );
			this.setTrnupdflg("X"); // 需要更新原业务TRN
			String yhnglbh= (String)data.get("VROOT.MsgBody.YHNGLBH"); // 原行内关联编号
			log.debug("{}","yhnglbh=" +yhnglbh );
			if(resultMap == null )
			{
			  resultMap = new HashMap<String,String>();
			}
			if(MdaUtils.isEmpty(yhnglbh))
			{
			  rstMsg = false;
			  resultMap.put("ERRORMSG", "报文中未获取原行内关联编号" );
			  log.error("{}","接口数据错误，原行内关联编号为空 ...  ");
			  return rstMsg;
			}
			MdaUtils.clear(this.getErsmod().getErs());
			ctx.getDaoSession().dbRead(this.getErsmod().getErs(),new Argument<String>("hnglbh",yhnglbh));
			if(ctx.getErrorCode() != NO_ERROR )
			{
			  rstMsg = false;
			  resultMap.put("ERRORMSG", "原行内关联编号:"+yhnglbh +"无法关联原始业务" );
			  log.error("{}","接口数据错误，原行内关联编号无法关联原业务...         ");
			  return rstMsg;
			}
			this.setObjtyp("ers");
			this.setObjinr(this.getErsmod().getErs().getInr());
			log.debug("{}"," ers: { ers.inr = " + this.getErsmod().getErs().getInr() +" , objtyp = " + this.getObjtyp()+ ", objinr=" +this.getObjinr()+" } ") ;

			// 2.按照公共函数进行数据映射
			setModuleContent(data);
			if(!MdaUtils.isEmpty(this.getErsmod().getErs().getRecsta()))
			{
			  String hzzt = convertState(this.getErsmod().getErs().getRecsta());
			  this.getErsmod().getErs().setRecsta(hzzt);
			}
			this.getErsmod().getErs().setDeldat(MdaUtils.today());
			// 3.更新ers表数据状态
			ctx.absGet(Sysmod.class).sdbUpdate(this.getErsmod().getErs()) ;
			log.debug("{}"," update  Ers { INR = " + this.getErsmod().getErs().getInr() +" , sta = " + this.getErsmod().getErs().getRecsta() +" } ") ;
			return  rstMsg;
		}
        /**
        *   source:xmlmap.@0005.script
        */
        public Boolean  determineXml0405 (Map<String,Object> msgMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 0405-XML报文信息 - 暂时未使用
			  @ 返回解析是否成功
			  */
			Boolean rstMsg  = false  ;  // 定义返回值
			String grptyp = "rpt" ;

			return rstMsg ;

		}
        /**
        *   source:xmlmap.@0008.script
        */
        public boolean  setCommonInfo (Map<String,Object> data, Map<String,String> resultMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析Map获取公共的报文头信息
			  * data - 外部获取的数据Map
			  @- 解析成功或失败
			  */
			log.debug("{}"," in xmlmap.setCommonInfo .... ") ;
			boolean rstmsg = true ;
			if (MdaUtils.isEmpty(data))
			{
			  resultMap.put("ERRORMSG","传入的报文内容为空 ") ;
			  return false ;
			}
			// 报文类型
			String msgtyp = (String) data.get("msgtyp") ;
			// 业务归属机构
			String bchcod = (String) data.get("bchcod") ;
			// 业务模型组类型 - 无
			String  grptyp = (String) data.get("grptyp") ;
			// 发报时间
			this.setXmldat(  MdaUtils.today());
			// 报文来源系统编号
			String srcsys = (String) data.get("srcsys") ;
			// TODO
			// 此可能需要进一步进行确认:  报文中代理行代码
			String bnkptyinr = "" ;
			String cliptyinr = "" ;
			String clietyinr = "" ;
			/**
			  // TODO 跨境系统报文头中的落地机构不准确，暂时不可用
			  if( !Platform.isEmpty(bchcod) )
			  {
			  bnkptyinr = setBnkPtyFromBchcod(bchcod);
			  }
			  */
			if (!MdaUtils.isEmpty(msgtyp))
			{
			  this.setMsgtyp( msgtyp );
			}
			/*
			  if (!Platform.isEmpty(bchcod))
			  {
			  $bchcod = bchcod ;
			  }
			  */
			if (!MdaUtils.isEmpty(grptyp))
			{
			  this.setGrptyp( grptyp );
			}
			this.setXmldat( MdaUtils.today());
			if(!MdaUtils.isEmpty(srcsys))
			{
			  this.setSrcsys( srcsys );
			}
			if (!MdaUtils.isEmpty(bnkptyinr))
			{
			  this.setBnkptyinr( bnkptyinr );
			}
			if(!MdaUtils.isEmpty(cliptyinr))
			{
			  this.setCliptyinr( cliptyinr);
			}

			// 检查报文公共信息
			if( MdaUtils.isEmpty(this.getBnkptyinr()))
			{
			  // TODO  此处可检查 bnkptyinr 和  cliptyinr 是否已经开户  ...
			  log.error("{}","报文头中无法确定落地机构信息");
			}
			log.debug("{}"," out xmlmap.setCommonInfo ... ") ;
			return rstmsg ;
		}
        /**
        *   source:xmlmap.@0009.script
        */
        public String getPtyFromBic(String argBic , String ... argPtytyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据Bic 或 账号 查询对应的Party的 PTY.INR  TODO
			  */
			log.debug("{}","  in xmlmap.getPtyFromBic ...  ") ;
			String ptyinr = "";
			if(MdaUtils.isEmpty(argBic))
			{
			  log.warn("{}"," 传入BIC 参数为 空 ");
			  return ptyinr ;
			}
			String sql="SELECT inr FROM pty WHERE BIC='"+argBic+"' and (ptytyp=";
			String conn="";
			for(String ptytyp:argPtytyp)
			{
			  sql=sql+conn+"'"+ptytyp+"'";
			  conn=" or ptytyp=";
			}
			sql=sql+")";

			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr=new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  log.info("{}","in getPtyFromBic,ptyinr="+inr.value);
			  ptyinr=inr.value;
			}
			else if(errorcode==NO_MORE_ROW)
			{
			  ptyinr=null;
			}
			ctx.getDaoSession().dbCloseCursor();
			return ptyinr ;
		}
        /**
        *   source:xmlmap.@0010.script
        */
        public void setModuleContent(Map<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 将data中的值按照配置映射到对应的模块字段中
			  */
			log.debug("{}","in xmlmap.setModuleContent  ... ") ;
			Map<String,String> fieldsMap = null;
			// IDatafield mapDatafield = Platform.getDatafield($this, $frm+"map") ;
			// 1.初始化 mapDatafield映射配置,提高效率 (后续优化可在  init 中对所有的 mapping初始化 )
			Map<String,Map> datamap = (HashMap<String,Map>) this.getDatamap();
			if(MdaUtils.isEmpty(datamap))
			{
			  log.debug("{}","初始化字段：datamap ");
			  datamap = new HashMap<String,Map>();
			  this.setDatamap(datamap);
			}
			if(!datamap.containsKey(this.getFrm()))
			{
			  log.debug("{}","初始化交易: " + this.getFrm() +"的字段映射关系");
			  fieldsMap = getDatafieldMapping(this.getFrm(), "DATA") ;
			  if(!MdaUtils.isEmpty(fieldsMap))
			  {
			    datamap.put(this.getFrm() ,fieldsMap);
			  }
			}
			else
			{
			  fieldsMap = datamap.get(this.getFrm());
			}

			// 2. 根据映射文件将 data的值映射,设置模型的字段值
			for(String key:data.keySet())
			{
			  // log.debug("name=" +key+"  value=" +data.get(key));
			  // Map<String,String> map =(Map<String,String>) fieldsMap.getValue();
			  if ( fieldsMap != null && fieldsMap.containsKey(key) )
			  {
			    IDatafield datafield = MdaDriver.getDatafield(this,fieldsMap.get(key));
			    //   log.debug("set datafield value = " +datafield.getName() + ", value=" +data.get(key));
			    if(ctx.getErrorCode()== NO_ERROR)
			    {
			      datafield.setValue(data.get(key));
			    }
			  }
			}
			log.debug("{}","out xmlmap.setModuleContent  ... ") ;
		}
        /**
        *   source:xmlmap.@0011.script
        */
        public Map<String,String> getDatafieldMapping(String transName, String keyType )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 功能：将配置文件中的映射关系初始化为map
			  */
			log.debug("{}"," in xmlmap.getDatafieldMapping ...  ") ;
			//  log.debug(" trnname=" + transName + ", keyType=" + keyType) ;
			Map<String,String> map = new HashMap<String,String> () ;
			String fileName=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"/cfg/"+transName+".properties");
			if (MdaUtils.fileExists(fileName))
			{
			  String keys=MdaUtils.getPropertyValue(fileName,keyType);
			  if(MdaUtils.isEmpty(keys))
			  {
			    log.error("{}","未配置  " + transName + ".properties 中的  " + keyType + " 数据项 "  ) ;
			    return map ;
			  }
			  for(String key:keys.split(","))
			  {

			    String path=MdaUtils.getPropertyValue(fileName,key);
			    log.debug("{}", "key="+ key +", path=" + path );
			    if(!MdaUtils.isEmpty(path))
			      map.put(key,path);
			  }
			}
			log.debug("{}"," out xmlmap.getDatafieldMapping  ...  ")  ;
			return map ;

		}
        /**
        *   source:xmlmap.@0012.script
        */
        public void initXmlmapDatafeild(String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据报文类型初始化XMLMAP模块的关键 Datafield
			  */
			log.debug("{}"," in  initXmlmapDatafeild ... ") ;
			// 清空数据以免受上一条数据影响
			
			log.debug("{}"," out initXmlmapDatafeild ") ;
		}
        /**
        *   source:xmlmap.@0013.script
        */
        public String  getRef(String prefix)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * 返回业务参考号，如LC-090817-0001)。
			  */
			String ownref = "" ;
			if(!MdaUtils.isEmpty(prefix))
			{
			  String seq = prefix + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  ownref = seq + MdaUtils.format(ctx.getDaoSession().dbCounter(prefix+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			}
			return ownref ;
		}
        /**
        *   source:xmlmap.@0014.script
        */
        public void initErsmod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 设置ERSMOD记录
			  */
			MdaUtils.clear(this.getErsmod().getErs()) ;
			// Platform.clear($ersmod);
			
		}
        /**
        *   source:xmlmap.@0016.script
        */
        public String setBnkPtyFromBchcod(String argBchcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 根据 Bchcod查询我行机构对应的 PTYINR
			  */
			log.debug("{}"," in xmlmap.getPtyFromBchcod ... argBchcod = " +argBchcod );
			int errcod = ctx.getErrorCode() ;
			String ptyinr = "" ;
			if(MdaUtils.isEmpty(argBchcod))
			{
			  log.error("{}"," 业务归属机构代码参数为空 ") ;
			  return "" ;
			}
			MdaUtils.clear(this.getBnk());
			ctx.getDaoSession().dbRead(this.getBnk(),new Argument<String>("cid",argBchcod),new Argument<String>("ptytyp","0"));
			errcod = ctx.getErrorCode();
			if(errcod == NO_ERROR)
			{
			  ptyinr =  this.getBnk().getInr();
			  this.setBnkptyinr( this.getBnk().getInr());
			  this.setBchcod( this.getBnk().getCid());
			  this.setBnkptynam( this.getBnk().getNam());
			  log.debug("{}"," 业务归属机构：argBchcod="+argBchcod+";ptyinr=" + ptyinr);
			}
			else
			{
			  log.error("{}"," 获取业务归属机构错误:argBchcod="+argBchcod+";errorcod=" + errcod);
			}
			return ptyinr ;

		}
        /**
        *   source:xmlmap.@0019.script
        */
        public boolean xmlmapSetTrnFromContract(IModule mod,String sta )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 收报交易存储交易流水
			  */
			log.debug("{}","in xmlmapSetTrnFromContract ... ");
			MdaUtils.clear(this.getTrn());
			log.debug("{}"," cliptyinr="+this.getCliptyinr()+",cliptynam=" + this.getCliptynam());
			log.debug("{}"," bnkptyinr="+this.getBnkptyinr()+",bnkptynam=" + this.getBnkptynam());
			log.debug("{}"," bchcod="+this.getBchcod() );
			log.debug("{}","cur="+this.getCur()+",amt="+this.getAmt());
			log.debug("{}"," objtyp= " + this.getObjtyp()+",objinr=" + this.getObjinr()+",objnam="+this.getObjnam());
			String etginr= ""  ;
			String etyinr=this.getEtyinr();
			if(!MdaUtils.isEmpty(etyinr) )
			{
			  etginr=ctx.absGet(Trnmod.class).sdbGetEtg(etyinr);
			  log.debug("{}","etginr="+etginr );
			}
			this.getTrn().setEtginr(etginr);
			this.getTrn().setObjtyp(this.getObjtyp());
			this.getTrn().setObjinr(this.getObjinr());
			this.getTrn().setOwnref(this.getOwnref());
			this.getTrn().setBchcod(this.getBchcod());
			this.getTrn().setReloricur(this.getCur());
			this.getTrn().setReloriamt(this.getAmt());
			this.getTrn().setRelcur("USD");
			if("USD".equals(this.getTrn().getReloricur()))
			{
			  this.getTrn().setRelamt(this.getTrn().getReloriamt());
			}
			else if(!MdaUtils.isEmpty(this.getCur())&&!"USD".equals(this.getCur()))
			{
			  BigDecimal rate=ctx.absGet(Sysmod.class).getCurRate(this.getCur());
			  if(rate.compareTo(new BigDecimal("0"))!=0)
			  {
			    BigDecimal relamt=this.getAmt().divide(rate,2,BigDecimal.ROUND_HALF_UP);
			    this.getTrn().setRelamt(relamt);
			  }
			  else
			  {
			    log.error("{}","trn 转换 relamt 金额失败 ");
			    // return false;
			  }
			}
			this.getTrn().setObjnam(this.getObjnam());
			this.getTrn().setInidattim(MdaUtils.today());

			this.getTrn().setInifrm(this.getFrm());
			this.getTrn().setIniusr(ctx.absGet(Sysmod.class).getUsr().getInr());
			//follow 2 not quite sure
			this.getTrn().setCpldattim(new Date());
			this.getTrn().setCfmdattim(new Date());
			if(!MdaUtils.isEmpty(sta))
			{
			  this.getTrn().setSta(sta);
			}
			else
			{
			  this.getTrn().setSta("W");
			}
			this.getTrn().setPtyinr(this.getCliptyinr());
			this.getTrn().setEtyinr(this.getEtyinr());
			this.getTrn().setEtginr(etginr);
			this.getTrn().setOptptyinr(this.getCliptyinr());
			this.getTrn().setOptetyinr(this.getEtyinr());
			this.getTrn().setOptetginr(etginr);
			this.getTrn().setPtyinr(this.getCliptyinr());
			this.getTrn().setInr(Platform.sdbCounter("trn"));
			ctx.absGet(Sysmod.class).sdbInsert(this.getTrn());
			log.info("{}","out xmlmapSetTrnFromContract... ");
			return true;

		}
        /**
        *   source:xmlmap.@0020.script
        */
        public String setCliAndBnkByAcc(String argAct)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String ptyinr = "" ;
			log.debug("{}"," in  xmlmap.setCliAndBnkByAcc ...");
			if(!MdaUtils.isEmpty(argAct))
			{
			  MdaUtils.clear(this.getAcc());
			  ctx.getDaoSession().dbRead(this.getAcc(),new Argument<String>("act",argAct),new Argument<String>("delflg",NE,"X"));
			  int errcod = ctx.getErrorCode();
			  if( errcod == NO_ERROR)
			  {
			    ptyinr = this.getAcc().getOwnptyinr();
			    this.setCliptyinr( this.getAcc().getOwnptyinr());  // 合作行 ptyinr
			    this.setBnkptyinr( this.getAcc().getOpnptyinr());  // 我行机构ptyinr
			    if(!MdaUtils.isEmpty(this.getBnkptyinr()))
			    {
			      MdaUtils.clear(this.getBnk());
			      ctx.getDaoSession().dbRead(this.getBnk(),new Argument<String>("inr",this.getBnkptyinr()),new Argument<String>("ptytyp","0"));
			      if(ctx.getErrorCode()== NO_ERROR)
			      {
			        this.setBchcod( this.getBnk().getCid());
			        this.setBnkptynam( this.getBnk().getNam());
			        log.debug("{}","bnk.bchcod = " + this.getBchcod()+",bnk.ptyinr=" + this.getBnk().getInr());
			      }
			    }
			    if(!MdaUtils.isEmpty(this.getCliptyinr()))
			    {
			      MdaUtils.clear(this.getCli());
			      ctx.getDaoSession().dbRead(this.getCli(),new Argument<String>("inr",this.getCliptyinr()),new Argument<String>("ptytyp","1"));
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        // $objnam = $rpdgrp\\rec\\rptcur+"/"+$rpdgrp\\rec\\rptamt+$cli\\nam;
			        this.setCliptynam(this.getCli().getNam());
			        this.setEtyinr( this.getCli().getEtyinr());
			        log.debug("{}","cli.nam = " + this.getCli().getNam() +",cli.ptyinr=" + this.getCli().getInr());
			      }
			    }
			    log.debug("{}"," in setCliAndBnkByAcc 匹配机构信息及商行信息：bchcod = " + this.getBchcod()+", bnkptyinr =" +  this.getBnkptyinr()+",cliptyinr=" + this.getCliptyinr());
			  }
			  else
			  {
			    log.error("{}",argAct + " 代理行账号无法确定对应的机构信息和代理行信息 ");
			  }
			}
			return ptyinr ;
		}
        /**
        *   source:xmlmap.@0021.script
        */
        public String setCliPtyFromBic(String argBic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 设置代理行的信息
			log.debug("{}"," in xmlmap.setCliPtyFromBic ... argBic = " +argBic );
			String cliptyinr = "";
			int errcod = ctx.getErrorCode() ;
			if(MdaUtils.isEmpty(argBic))
			{
			  log.error("{}"," 商行BIC参数为空 ") ;
			  return "" ;
			}
			MdaUtils.clear(this.getCli());
			ctx.getDaoSession().dbRead(this.getCli(),new Argument<String>("bic",argBic),new Argument<String>("ptytyp","1"));
			errcod = ctx.getErrorCode();
			if(errcod == NO_ERROR)
			{
			  cliptyinr = this.getCli().getInr();
			  this.setCliptyinr(cliptyinr);
			  this.setCliptynam(this.getCli().getNam());
			  this.setEtyinr(this.getCli().getEtyinr());
			  log.debug("{}"," 业务落地商行匹配成功：cliptyinr="+this.getCliptyinr()+";cliptynam=" + this.getCliptynam());
			}
			else
			{
			  log.error("{}"," 业务落地商行匹配失败:argBic="+argBic+";errorcod=" + errcod);
			}
			return cliptyinr ;

		}
        /**
        *   source:xmlmap.@0022.script
        */
        public String convertState(String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sta ="";
			if("10".equals(state))
			{
			  sta ="A";
			}
			else
			  if("11".equals(state))
			{
			  sta ="N";
			}
			else
			  if("99".equals(state))
			{
			  sta ="F";
			}
			return sta ;
		}



























































        public void setHeadbchcodHolder(FieldHolder<String> headbchcod)
        {
           this.headbchcod = (headbchcod);
        }

        public void setHeadbchcod(String headbchcod)
        {
            this.headbchcod.setValue(headbchcod);
        }

        public String getHeadbchcod()
        {
            return this.headbchcod.getValue();
        }













}