package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Wfe;
import com.ceb.gjjs.mda.bo.Ers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* XML格式报文服务
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xmlsvr extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Xmlsvr.class);



	    @BDGetter
		private Smh smh;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

	    @BDGetter
		private Ers ers;

	    @BDGetter
		private Spt spt;


		public Xmlsvr()
        {
            super();
            setArgument();
        }

        public Xmlsvr(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:xmlsvr.@0000.script
        */
        public boolean doHandle()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," in  xmlsvr.doHandle  ...... ") ;
			if(MdaUtils.isEmpty(this.getWfe().getSrvtxt()))
			{
			  return Platform.errorHandle(this.getWfe(),"发报参数不能为空");
			}
			//调用接口发XML报
			String cls="com.brilliance.eibs.main.Client";
			Object resMsg =  MdaUtils.invoke(cls,"scall","yyptsend","yyptsend",new Object[]{this.getWfe().getSrvtxt()+".xml"}) ;
			if((Boolean) MdaUtils.invoke(resMsg,"isSuccess"))
			{
			  Object content =  (Object)MdaUtils.invoke(resMsg,"getContent") ;
			  String isSuc = content.toString();
			  log.debug("{}","(content:" + content + ",isSuc:" + isSuc +")");

			  if("true ".equals(isSuc))
			  {
			    //业务发送成功
			    ctx.getDaoSession().dbBegin();
			    this.getWfe().setSta("D");
			    ctx.getDaoSession().dbUpdate(this.getWfe());
			    // 更新 ERS记录
			    updateERSState("S");
			    ctx.getDaoSession().dbCommit();
			    if("D".equals(this.getWfe().getSta()))
			      ctx.absGet(Trnmod.class).updateNextSvrState("X");
			    log.debug("{}","  out  xmlsvr.doHandle ...... ") ;
			    return true;
			  }
			  else
			  {
			    //业务发送失败,业务需要退回到退回文件夹
			    String rtycnt = this.getWfe().getRtycnt();
			    String trninr = ctx.absGet(Trnmod.class).getTrn().getInr();
			    if(!MdaUtils.isEmpty(rtycnt) && Integer.valueOf(rtycnt) >=2)
			    {
			      ctx.getDaoSession().dbBegin();
			      createSpt();
			      log.info("{}","trninr = " +trninr);
			      ctx.getDaoSession().dbDelete(ctx.absGet(Trnmod.class).getUsrsig(),new Argument("ownref",ctx.absGet(Trnmod.class).getTrn().getOwnref()),new Argument("trninr",trninr));
			      // 更新TRN 字段 STA = 'B'
			      ctx.absGet(Trnmod.class).getTrn().setCpldattim(new Date());
			      ctx.absGet(Trnmod.class).getTrn().setSta("B");
			      ctx.getDaoSession().dbUpdate(ctx.absGet(Trnmod.class).getTrn());
			      //delete dat file
			      String ordinr = ctx.absGet(Trnmod.class).getTrn().getOrdinr();
			      log.info("{}","ordinr =" +ordinr);
			      ctx.absGet(Trnmod.class).getOrdmod().updateOrd(ordinr,"B","","退回");
			      //delete disPlay file
			      String disname = "/data/dsp/"+trninr.substring(0,4)+"/"+trninr+".zul";
			      if(MdaUtils.fileExists(disname))
			      {
			        MdaUtils.fileDelete(disname);
			      }
			      updateERSState("E");
			      ctx.getDaoSession().dbCommit();
			    }
			  }
			}
			else
			{
			  // 发报失败业务退回退回夹重新进行经办
			  String rtycnt = this.getWfe().getRtycnt();
			  if(!MdaUtils.isEmpty(rtycnt) && Integer.valueOf(rtycnt) >=2)
			  {
			    ctx.getDaoSession().dbBegin();
			    updateERSState("E");
			    ctx.getDaoSession().dbCommit();
			  }
			}

			return Platform.errorHandle(this.getWfe(),"XML:"+ this.getWfe().getSrvtxt()+ " 报文发送失败，请联系管理员！");  // FIXME
					}
        /**
        *   source:xmlsvr.@0001.script
        */
        public void updateERSState(String state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in xmlsvr.updateERSState  state = " +state ) ;
			String frm =ctx.absGet(Trnmod.class).getTrn().getInifrm();
			String objtyp = ctx.absGet(Trnmod.class).getTrn().getObjtyp();
			String objinr = ctx.absGet(Trnmod.class).getTrn().getObjinr();
			if("-rptopn-ersfre-".indexOf(frm)>0 && !MdaUtils.isEmpty(objtyp) && !MdaUtils.isEmpty(objinr) )
			{
			  MdaUtils.clear(this.getErs());
			  Argument arg = null;
			  if( "rpd".equals(objtyp))
			  {
			    arg = new Argument<String>("trninr",ctx.absGet(Trnmod.class).getTrn().getInr());
			  }
			  else if("ers".equals(objtyp))
			  {
			    arg =new Argument<String>("inr",objinr);
			  }
			  if( arg != null )
			  {
			    ctx.getDaoSession().dbRead(this.getErs(),arg);
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      this.getErs().setOutdat( MdaUtils.today());
			      this.getErs().setRecsta( state );
			      ctx.getDaoSession().dbUpdate(this.getErs());
			    }
			  }
			}
			log.debug("{}"," out xmlsvr.updateERSState  state = " +state ) ;
		}
        /**
        *   source:xmlsvr.@0002.script
        */
        public void createSpt()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//#CT000000
			if(!MdaUtils.isEmpty(this.getSpt().getInr()))
			  return;
			MdaUtils.clear(this.getSpt());
			this.getSpt().setSta("B");
			this.getSpt().setSmhinr("");
			this.getSpt().setOrdinr(ctx.absGet(Trnmod.class).getTrn().getOrdinr());
			this.getSpt().setObjtyp(ctx.absGet(Trnmod.class).getTrn().getObjtyp());
			this.getSpt().setObjinr(ctx.absGet(Trnmod.class).getTrn().getObjinr());
			this.getSpt().setObjnam(ctx.absGet(Trnmod.class).getTrn().getObjnam());
			this.getSpt().setOprusrinr("");
			this.getSpt().setOprogninr(ctx.absGet(Trnmod.class).getTrn().getOptptyinr());
			this.getSpt().setPtyinr(ctx.absGet(Trnmod.class).getTrn().getPtyinr());
			this.getSpt().setOwnref(ctx.absGet(Trnmod.class).getTrn().getOwnref());
			this.getSpt().setFrm(ctx.absGet(Trnmod.class).getTrn().getInifrm());
			this.getSpt().setDattim(new Date());
			this.getSpt().setScr("I");
			this.getSpt().setScrtxt(ctx.absGet(Trnmod.class).getTrn().getInr());
			String subptyinr = ctx.absGet(Trnmod.class).getTrn().getPtyinr();
			if(!MdaUtils.isEmpty(subptyinr))
			{
			  this.getSpt().setScrpty(ctx.absGet(Trnmod.class).getTrn().getPtyinr());
			}
			this.getSpt().setInr(Platform.sdbCounter("spt"));
			ctx.getDaoSession().dbInsert(this.getSpt());
			log.info("{}","sptinr =" +this.getSpt().getInr());
			String tarfile = ctx.absGet(Sysmod.class).createFilename(this.getSpt().getInr(),"bak");
			if(MdaUtils.fileExists(tarfile))
			  MdaUtils.fileDelete(tarfile);
			String filename = ctx.absGet(Sysmod.class).createFilename(ctx.absGet(Trnmod.class).getTrn().getInr(),"dat");
			log.info("{}","message"+filename);
			if(MdaUtils.fileExists(filename))
			  MdaUtils.fileCopy(filename,tarfile);
			else
			  ctx.setMessage("",MdaUtils.getI18NString("xmlsvr","CT000001"));
		}



        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }





}