package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xptp extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Xptp.class);

        //新增
        private transient IControl add = new ControlImpl("add", "新增", this);

        //删除
        private transient IControl delete = new ControlImpl("delete", "删除", this);

        //确定
        private transient IControl submit = new ControlImpl("submit", "确定", this);

        //专家头像导入
        private IStream exppho = new StreamImpl();

        //选择上级主管
        private transient IControl seladm = new ControlImpl("seladm", "选择上级主管", this);

        //确定
        private transient IControl sure = new ControlImpl("sure", "确定", this);

        //问题分类
        private String faqtyp;

        //搜索
        private transient IControl query = new ControlImpl("query", "搜索", this);

        //客户名称
        private String etnnam;

        //问题状态
        private String questa;

        //调用文件
        private transient IControl quedoc = new ControlImpl("quedoc", "调用文件", this);

        //电话列表
        private transient IControl seltel = new ControlImpl("seltel", "电话列表", this);

        //刷新
        private transient IControl refresh = new ControlImpl("refresh", "刷新", this);

        //案例分类
        private String samtyp;

        //返回
        private transient IControl back = new ControlImpl("back", "返回", this);

        //编辑
        private transient IControl edit = new ControlImpl("edit", "编辑", this);

        //我要咨询
        private transient IControl advisory = new ControlImpl("advisory", "我要咨询", this);

        //选择操作员
        private transient IControl seluser = new ControlImpl("seluser", "选择操作员", this);

        //确定
        private transient IControl sure1 = new ControlImpl("sure1", "确定", this);

        //提交1
        private transient IControl submit1 = new ControlImpl("submit1", "提交1", this);

        //返回1
        private transient IControl back1 = new ControlImpl("back1", "返回1", this);

        //专家头像
        private String xptpho;

        //专家信息
        private Object xptinf;

        //
        private String display;

        //影像导入
        private transient IControl images = new ControlImpl("images", "影像导入", this);

        //影像查阅
        private transient IControl imgviw = new ControlImpl("imgviw", "影像查阅", this);


        @JsonIgnore
        @BDGetter
        private transient IPanel xptins;

        @JsonIgnore
        @BDGetter
        private transient IPanel xptrul;

        @JsonIgnore
        @BDGetter
        private transient IPanel selxpt;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwxpt;

        @JsonIgnore
        @BDGetter
        private transient IPanel seladmp;

        @JsonIgnore
        @BDGetter
        private transient IPanel seyfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel selfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel setfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel semfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel faqdet;

        @JsonIgnore
        @BDGetter
        private transient IPanel etnfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel bnkfaq;

        @JsonIgnore
        @BDGetter
        private transient IPanel seysam;

        @JsonIgnore
        @BDGetter
        private transient IPanel selsam;

        @JsonIgnore
        @BDGetter
        private transient IPanel setsam;

        @JsonIgnore
        @BDGetter
        private transient IPanel semsam;

        @JsonIgnore
        @BDGetter
        private transient IPanel samdet;

        @JsonIgnore
        @BDGetter
        private transient IPanel etnsam;

        @JsonIgnore
        @BDGetter
        private transient IPanel bnksam;

        @JsonIgnore
        @BDGetter
        private transient IPanel selhis;

        @JsonIgnore
        @BDGetter
        private transient IPanel quedet;

        @JsonIgnore
        @BDGetter
        private transient IPanel selrpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel shwrpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel xptrpl;

        @JsonIgnore
        @BDGetter
        private transient IPanel xptslt;

        @JsonIgnore
        @BDGetter
        private transient IPanel tellst;

        @JsonIgnore
        @BDGetter
        private transient IPanel selusr;

        @JsonIgnore
        @BDGetter
        private transient IPanel selque;

        @JsonIgnore
        @BDGetter
        private transient IPanel detail;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Xptgrp> xptgrp;

	    @BDGetter
		private Imgmod imgmod;


		public Xptp()
        {
            super();
            setArgument();
        }

        public Xptp(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:xptp.@0010.script
        */
        @Rule(target="imgviw",order=100)
        public boolean ruleImgviwN100(){
            IContext ctx = MdaEnv.getContext();
            
			//影像查询
			log.debug("{}","in imgScan ... ");
			String imgref = this.getXptgrp().getXptqna().getImgref();
			log.debug("{}","imgref=" +imgref);
			String objtyp = "xptqna";
			if(MdaUtils.isEmpty(imgref))
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptp","CT000284"),MdaUtils.getI18NString("xptp","CT000285"));
			  return false;
			}
			String imgPath =(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"img/") + "/" + MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			log.debug("{}","imgPath=" +imgPath);
			Map<String,Object> data1 = new HashMap<String,Object>();
			data1.put("occurdate",MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			data1.put("downloadpath",imgPath);
			data1.put("needannotation","0");
			data1.put("needthumbnail","0");
			List<Map<String,Object> > conditionList = new  ArrayList<Map<String,Object> >();
			Map<String,Object> data2 = new HashMap<String,Object>();
			Map<String,Object> data3 = new HashMap<String,Object>();
			data2.put("propertyname","OwnRef");
			data2.put("propertyvalue",imgref);
			data3.put("propertyname","ImageRegID");
			data3.put("propertyvalue",imgref);
			conditionList.add(data2);
			conditionList.add(data3);
			List<String> propertylist = new  ArrayList<String>();
			propertylist.add("FlowID");
			propertylist.add("CibBranchID");
			propertylist.add("CibOrgID");
			propertylist.add("CibOperID");
			data1.put("propertylist",propertylist);
			data1.put("conditionList",conditionList);
			String cls="com.brilliance.eibs.main.Client";
			Object resMsg = MdaUtils.invoke(cls,"scall","dzticmquery","dzticmquery",new Object[]{data1});
			if((Boolean)MdaUtils.invoke(resMsg,"isSuccess"))
			{
			  Object content = (Object)MdaUtils.invoke(resMsg,"getContent") ;
			  String isSuc = content.toString();
			  log.debug("{}","isSuc= "+isSuc);
			  if("true".equals(isSuc.substring(0,5).trim()))
			  {
			    log.debug("{}","查询影像成功 ... ");
			    //查询影像成功则调用影像控件
			    boolean result= this.getImgmod().callImageComponent("ImageScan",imgref,imgref,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp);
			    if(result)
			    {
			      return true;
			    }
			    else
			      return false;
			  }
			  else
			  {
			    log.debug("{}","查询影像失败 ... ");
			    String errorcod=isSuc.substring(5,24).trim();
			    log.debug("{}","errorcod=" +errorcod);
			    String errorcodname=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/icmapi.properties");
			    String errorvalue=MdaUtils.getPropertyValue(errorcodname,errorcod.substring(errorcod.indexOf("-")+1,errorcod.indexOf("-")+8));
			    log.debug("{}","errorvalue=" +errorvalue);
			    if("D".equals(errorcod.substring(0,1)))
			    {
			      ctx.setMessage(MdaUtils.getI18NString("xptp","CT000286"),MdaUtils.getI18NString("xptp","CT000287"));
			      return false ;
			    }
			    else
			    {
			      ctx.setMessage(MdaUtils.getI18NString("xptp","CT000288"),errorvalue);
			      return false;
			    }
			  }
			}

			return true;
        }

        /**
        *   source:xptp.@0011.script
        */
        @Rule(target="images",order=100)
        public boolean ruleImagesN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","in images ... ");
			String objtyp = "xptqna";
			String imgref = this.getXptgrp().getXptqna().getImgref();
			if(MdaUtils.isEmpty(imgref))
			{
			  imgref = getRef();
			  this.getXptgrp().getXptqna().setImgref(imgref);
			  log.info("{}","影像批次号:" + imgref);
			}
			String ownref = imgref;
			//调用影像控件
			this.getImgmod().callImageComponent("ImageUpload",ownref,imgref,ctx.getTransName(),ctx.absGet(Sysmod.class).getUsr().getLgnnam(),objtyp);
			log.debug("{}","out images ... ");

			return true;
        }




        /**
        *   source:xptp.@0001.script
        */
        public void loadDisplay(String ref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql ="SELECT t.inr,t.inifrm FROM trn t WHERE t.ownref='"+ref+"'";
			//sql = sql+" AND sta='A' AND relreq IS NULL";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> inifrm = new Argument<String>("inifrm");
			ctx.getDaoSession().dbFetchFields(inr,inifrm);
			log.debug("{}","inr="+inr.value);
			if(ctx.getErrorCode() != NO_ERROR)
			{
			  ctx.setMessage(MdaUtils.getI18NString("xptp","CT000229"),MdaUtils.getI18NString("xptp","CT000274"));
			  ctx.getDaoSession().dbCloseCursor();
			  return;
			}
			ctx.getDaoSession().dbCloseCursor();
			ctx.absGet(Btnmod.class).initAdvButton(inr.value,inifrm.value);
			//String filename="/data/dsp/"+inr.value+".zul";
			Platform.writeToSession("dspfile",inr.value);//token，用来判断请求唯一性
			log.info("{}","session dspfile :"+Platform.readFromSession("dspfile"));

			String filename="/data/dsp/"+inr.value.substring(0,4)+"/"+inr.value+".zul";
			this.setDisplay("/dsp"+filename);
			
		}
        /**
        *   source:xptp.@0002.script
        */
        public List loadFaqTyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String typSql = "SELECT s.cod,s.txt FROM stb s WHERE s.tbl='quetyp' or s.tbl='QUETYP'";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			List<CodetableItem> faqtyp = new ArrayList<CodetableItem>();
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> txt = new Argument<String>("txt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    faqtyp.add(new CodetableItem(txt.value,cod.value));
			    log.info("{}","txt "+txt.value);
			    log.info("{}","cod "+cod.value);
			  }
			  else break;
			}
			ctx.getDaoSession().dbCloseCursor();
			return faqtyp;
		}
        /**
        *   source:xptp.@0003.script
        */
        public List loadSamTyp()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

			String typSql = "SELECT s.cod,s.txt FROM stb s WHERE s.tbl='samtyp' or s.tbl='SAMTYP'";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			List<CodetableItem> samtyp = new ArrayList<CodetableItem>();
			Argument<String> cod = new Argument<String>("cod");
			Argument<String> txt = new Argument<String>("txt");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(cod,txt);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    samtyp.add(new CodetableItem(txt.value,cod.value));
			    log.info("{}","txt "+txt.value);
			    log.info("{}","cod "+cod.value);
			  }
			  else break;
			}
			ctx.getDaoSession().dbCloseCursor();
			return samtyp;
		}
        /**
        *   source:xptp.@0004.script
        */
        public void loadXptNam()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","load xptnam");
			String typSql = "SELECT oprinr,expnam FROM xptinf";
			ctx.getDaoSession().dbExecuteSQL(typSql);
			Map<String,String> xptinf = new HashMap<String,String>();
			Argument<String> oprinr = new Argument<String>("oprinr");
			Argument<String> expnam = new Argument<String>("expnam");
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(oprinr,expnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(MdaUtils.isEmpty(expnam.value))
			      expnam.value="";
			    xptinf.put(oprinr.value,expnam.value);
			    //log.info("expnam "+expnam.value+"|");
			    //log.info("oprinr "+oprinr.value+"|");
			  }
			  else break;
			}
			ctx.getDaoSession().dbCloseCursor();
			this.setXptinf(xptinf) ;
		}
        /**
        *   source:xptp.@0007.script
        */
        public String loadXptSta(String inr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String logsta = null;
			String sql = "SELECT logsta FROM usr where inr='"+inr+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			Argument<String> sta = new Argument<String>("logsta");
			ctx.getDaoSession().dbFetchFields(sta);
			if(ctx.getErrorCode()==NO_ERROR)
			  logsta = sta.value;
			if(logsta==null)
			  logsta="";
			ctx.getDaoSession().dbCloseCursor();
			return logsta;
		}
        /**
        *   source:xptp.@0009.script
        */
        public String getRef()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  * @return 影像批次号(格式：业务类型（GD）+年月日（6位）+序号（4位），如GD-090817-0001)。
			  */
			String imgref = "";
			String prefix = "GD" + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			// 默认同类交易当天不会有10000条
			prefix = prefix + MdaUtils.format(ctx.getDaoSession().dbCounter("GD"+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			imgref = prefix ;
			return imgref;
		}

        public void setXptgrpHolder(ModuleHolder<Xptgrp> xptgrp)
        {
           this.xptgrp = xptgrp;
        }

        public Xptgrp getXptgrp()
        {
           return this.xptgrp.get();
        }























































}