package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Zxj;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Zxjmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Zxjmod.class);

        //获取保证金参号
        private transient IControl getzxj = new ControlImpl("getzxj", "获取保证金参号", this);

        //获取参号前缀
        @Module(getter = false, setter = false)
		private FieldHolder<String> prefixs = new FieldConstantHolder<>("");


        //保证金申请书按钮
        private transient IControl zxjopp = new ControlImpl("zxjopp", "保证金申请书按钮", this);

        //衍生交易总协议编号
        private String ysjyzxy1;

        //衍生交易总协议
        private String ysjyzxy2;

        //综合授信协议编号
        private String zhsxxy;


        @JsonIgnore
        @BDGetter
        private transient IPanel bzjzy;


		@Module(getter = false, setter = false)
        private transient ModuleHolder<Zxj> zxj;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptspta> apl;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptspta> isb;


		public Zxjmod()
        {
            super();
            setArgument();
        }

        public Zxjmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:zxjmod.@0000.script
        */
        @Rule(target="getzxj",order=100)
        public boolean ruleGetzxjN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getZxj().getBzjxyt()))
			{
			  //不判空会有什么影响
			  String prefixs = this.getPrefixs() + MdaUtils.format(MdaUtils.today(),"yyMMdd");
			  // 默认同类交易当天不会有10000条
			  prefixs = prefixs + MdaUtils.format(ctx.getDaoSession().dbCounter(this.getPrefixs()+MdaUtils.format(MdaUtils.today(),"yy")),"0000");
			  this.getZxj().setBzjxyt(prefixs);
			  
			}


			return true;
        }

        /**
        *   source:zxjmod.@0001.script
        */
        @Rule(target="zxj.zyjsty",order=100)
        public boolean ruleZxjZyjstyN100(){
            IContext ctx = MdaEnv.getContext();
            
			if("2".equals(this.getZxj().getZyjsty()))
			{
			  
			  
			  
			  
			}
			else
			{
			  
			  
			  this.getZxj().setZcwnam(NULLSTR);
			  this.getZxj().setZcwadr(NULLSTR);
			  
			  
			}
			
			


			return true;
        }





        public void setZxjHolder(ModuleHolder<Zxj> zxj)
        {
           this.zxj = zxj;
        }

        public Zxj getZxj()
        {
           return this.zxj.get();
        }

        public void setAplHolder(ModuleHolder<Ptspta> apl)
        {
           this.apl = apl;
        }

        public Ptspta getApl()
        {
           return this.apl.get();
        }

        public void setIsbHolder(ModuleHolder<Ptspta> isb)
        {
           this.isb = isb;
        }

        public Ptspta getIsb()
        {
           return this.isb.get();
        }





        public void setPrefixsHolder(FieldHolder<String> prefixs)
        {
           this.prefixs = (prefixs);
        }

        public void setPrefixs(String prefixs)
        {
            this.prefixs.setValue(prefixs);
        }

        public String getPrefixs()
        {
            return this.prefixs.getValue();
        }









}