package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AcbopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="acbgrp.rec.bchcod",dir=DirType.BOTH)
    private String acbgrp_rec_bchcod;

    @RelPath(value="acbgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acbgrp_rec_credat;

    @RelPath(value="acbgrp.rec.cusid",dir=DirType.BOTH)
    private String acbgrp_rec_cusid;

    @RelPath(value="acbgrp.rec.inwardacct",dir=DirType.BOTH)
    private String acbgrp_rec_inwardacct;

    @RelPath(value="acbgrp.rec.opttype",dir=DirType.BOTH)
    private String acbgrp_rec_opttype;

    @RelPath(value="acbgrp.rec.ownref",dir=DirType.BOTH)
    private String acbgrp_rec_ownref;

    @RelPath(value="acbgrp.rec.reason",dir=DirType.BOTH)
    private String acbgrp_rec_reason;

    @RelPath(value="acbgrp.rec.remark",dir=DirType.BOTH)
    private String acbgrp_rec_remark;

    @RelPath(value="acbgrp.rec.socialcrdtcd",dir=DirType.BOTH)
    private String acbgrp_rec_socialcrdtcd;

    @RelPath(value="acbgrp.pty.nam",dir=DirType.BOTH)
    private String acbgrp_pty_nam;


}