package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AcdopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="acdgrp.rec.account",dir=DirType.BOTH)
    private String acdgrp_rec_account;

    @RelPath(value="acdgrp.rec.accounttype",dir=DirType.BOTH)
    private String acdgrp_rec_accounttype;

    @RelPath(value="acdgrp.rec.acdno",dir=DirType.BOTH)
    private String acdgrp_rec_acdno;

    @RelPath(value="acdgrp.rec.appointmentdate",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acdgrp_rec_appointmentdate;

    @RelPath(value="acdgrp.rec.bchcod",dir=DirType.BOTH)
    private String acdgrp_rec_bchcod;

    @RelPath(value="acdgrp.rec.busiscope",dir=DirType.BOTH)
    private String acdgrp_rec_busiscope;

    @RelPath(value="acdgrp.rec.busistatus",dir=DirType.BOTH)
    private String acdgrp_rec_busistatus;

    @RelPath(value="acdgrp.rec.contactaddress",dir=DirType.BOTH)
    private String acdgrp_rec_contactaddress;

    @RelPath(value="acdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acdgrp_rec_credat;

    @RelPath(value="acdgrp.rec.entname",dir=DirType.BOTH)
    private String acdgrp_rec_entname;

    @RelPath(value="acdgrp.rec.enttel",dir=DirType.BOTH)
    private String acdgrp_rec_enttel;

    @RelPath(value="acdgrp.rec.enttype",dir=DirType.BOTH)
    private String acdgrp_rec_enttype;

    @RelPath(value="acdgrp.rec.financialadmin",dir=DirType.BOTH)
    private String acdgrp_rec_financialadmin;

    @RelPath(value="acdgrp.rec.industry",dir=DirType.BOTH)
    private String acdgrp_rec_industry;

    @RelPath(value="acdgrp.rec.industrycode",dir=DirType.BOTH)
    private String acdgrp_rec_industrycode;

    @RelPath(value="acdgrp.rec.legalname",dir=DirType.BOTH)
    private String acdgrp_rec_legalname;

    @RelPath(value="acdgrp.rec.legalrepresentative",dir=DirType.BOTH)
    private String acdgrp_rec_legalrepresentative;

    @RelPath(value="acdgrp.rec.ncid",dir=DirType.BOTH)
    private String acdgrp_rec_ncid;

    @RelPath(value="acdgrp.rec.opendate",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acdgrp_rec_opendate;

    @RelPath(value="acdgrp.rec.openfea",dir=DirType.BOTH)
    private String acdgrp_rec_openfea;

    @RelPath(value="acdgrp.rec.openoutletibk",dir=DirType.BOTH)
    private String acdgrp_rec_openoutletibk;

    @RelPath(value="acdgrp.rec.operateend",dir=DirType.BOTH)
    private String acdgrp_rec_operateend;

    @RelPath(value="acdgrp.rec.operatefrom",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acdgrp_rec_operatefrom;

    @RelPath(value="acdgrp.rec.producttype",dir=DirType.BOTH)
    private String acdgrp_rec_producttype;

    @RelPath(value="acdgrp.rec.reason",dir=DirType.BOTH)
    private String acdgrp_rec_reason;

    @RelPath(value="acdgrp.rec.regaddr",dir=DirType.BOTH)
    private String acdgrp_rec_regaddr;

    @RelPath(value="acdgrp.rec.registercurrency",dir=DirType.BOTH)
    private String acdgrp_rec_registercurrency;

    @RelPath(value="acdgrp.rec.registerfund",dir=DirType.BOTH)
    private String acdgrp_rec_registerfund;

    @RelPath(value="acdgrp.rec.senddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date acdgrp_rec_senddat;

    @RelPath(value="acdgrp.rec.socialcrdtcd",dir=DirType.BOTH)
    private String acdgrp_rec_socialcrdtcd;

    @RelPath(value="acdgrp.rec.status",dir=DirType.BOTH)
    private String acdgrp_rec_status;

    @RelPath(value="acdgrp.rec.transactor",dir=DirType.BOTH)
    private String acdgrp_rec_transactor;

    @RelPath(value="acdgrp.rec.transid",dir=DirType.BOTH)
    private String acdgrp_rec_transid;

    @RelPath(value="acdgrp.rec.transverifier1",dir=DirType.BOTH)
    private String acdgrp_rec_transverifier1;

    @RelPath(value="acdgrp.rec.transverifier2",dir=DirType.BOTH)
    private String acdgrp_rec_transverifier2;


}