package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Trn;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AnnalsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="btnmod.begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_begdat;

    @RelPath(value="btnmod.begdat1",dir=DirType.BOTH)
    private String btnmod_begdat1;

    @RelPath(value="btnmod.cur",dir=DirType.BOTH)
    private String btnmod_cur;

    @RelPath(value="btnmod.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_enddat;

    @RelPath(value="btnmod.enddat1",dir=DirType.BOTH)
    private String btnmod_enddat1;

    @RelPath(value="btnmod.maxamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal btnmod_maxamt;

    @RelPath(value="btnmod.minamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal btnmod_minamt;

    @RelPath(value="btnmod.nohtyp",dir=DirType.BOTH)
    private String btnmod_nohtyp;

    @RelPath(value="btnmod.nohtyp1",dir=DirType.BOTH)
    private String btnmod_nohtyp1;

    @RelPath(value="btnmod.ownref",dir=DirType.BOTH)
    private String btnmod_ownref;

    @RelPath(value="btnmod.ptycod",dir=DirType.BOTH)
    private String btnmod_ptycod;

    @RelPath(value="btnmod.ptycod1",dir=DirType.BOTH)
    private String btnmod_ptycod1;

    @RelPath(value="btnmod.ptynam",dir=DirType.BOTH)
    private String btnmod_ptynam;

    @RelPath(value="btnmod.ptynam1",dir=DirType.BOTH)
    private String btnmod_ptynam1;

    @RelPath(value="btnmod.query",dir=DirType.BOTH)
    private String btnmod_query;

    @RelPath(value="btnmod.stlref",dir=DirType.BOTH)
    private String btnmod_stlref;

    @RelPath(value="btnmod.trntyp",dir=DirType.BOTH)
    private String btnmod_trntyp;

    @RelPath(value="btnmod.trntyp1",dir=DirType.BOTH)
    private String btnmod_trntyp1;

    @RelPath(value="btnmod.ywwtyp",dir=DirType.BOTH)
    private String btnmod_ywwtyp;

    @RelPath(value="histodo",dir=DirType.BOTH)
    private String histodo;

    @RelPath(value="trnlst",dir=DirType.OUT)
    private ModuleList<Trn> trnlst;


}