package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AptcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="apdgrp.checked",dir=DirType.BOTH)
    private String apdgrp_checked;

    @RelPath(value="apdgrp.ixd.bctk",dir=DirType.BOTH)
    private String apdgrp_ixd_bctk;

    @RelPath(value="apdgrp.ixd.bjchfs",dir=DirType.BOTH)
    private String apdgrp_ixd_bjchfs;

    @RelPath(value="apdgrp.ixd.bjchqtfs",dir=DirType.BOTH)
    private String apdgrp_ixd_bjchqtfs;

    @RelPath(value="apdgrp.ixd.cgdk",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_cgdk;

    @RelPath(value="apdgrp.ixd.cgfz",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_cgfz;

    @RelPath(value="apdgrp.ixd.cgjk",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_cgjk;

    @RelPath(value="apdgrp.ixd.cgzwdb",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_cgzwdb;

    @RelPath(value="apdgrp.ixd.dbfs1",dir=DirType.BOTH)
    private String apdgrp_ixd_dbfs1;

    @RelPath(value="apdgrp.ixd.dbfs2",dir=DirType.BOTH)
    private String apdgrp_ixd_dbfs2;

    @RelPath(value="apdgrp.ixd.dbfs3",dir=DirType.BOTH)
    private String apdgrp_ixd_dbfs3;

    @RelPath(value="apdgrp.ixd.dbr1",dir=DirType.BOTH)
    private String apdgrp_ixd_dbr1;

    @RelPath(value="apdgrp.ixd.dbr2",dir=DirType.BOTH)
    private String apdgrp_ixd_dbr2;

    @RelPath(value="apdgrp.ixd.dbr3",dir=DirType.BOTH)
    private String apdgrp_ixd_dbr3;

    @RelPath(value="apdgrp.ixd.dfqttj",dir=DirType.BOTH)
    private String apdgrp_ixd_dfqttj;

    @RelPath(value="apdgrp.ixd.dsdz",dir=DirType.BOTH)
    private String apdgrp_ixd_dsdz;

    @RelPath(value="apdgrp.ixd.dslxdh",dir=DirType.BOTH)
    private String apdgrp_ixd_dslxdh;

    @RelPath(value="apdgrp.ixd.dsr",dir=DirType.BOTH)
    private String apdgrp_ixd_dsr;

    @RelPath(value="apdgrp.ixd.dsyzbm",dir=DirType.BOTH)
    private String apdgrp_ixd_dsyzbm;

    @RelPath(value="apdgrp.ixd.htbh1",dir=DirType.BOTH)
    private String apdgrp_ixd_htbh1;

    @RelPath(value="apdgrp.ixd.htbh2",dir=DirType.BOTH)
    private String apdgrp_ixd_htbh2;

    @RelPath(value="apdgrp.ixd.htbh3",dir=DirType.BOTH)
    private String apdgrp_ixd_htbh3;

    @RelPath(value="apdgrp.ixd.htmc1",dir=DirType.BOTH)
    private String apdgrp_ixd_htmc1;

    @RelPath(value="apdgrp.ixd.htmc2",dir=DirType.BOTH)
    private String apdgrp_ixd_htmc2;

    @RelPath(value="apdgrp.ixd.htmc3",dir=DirType.BOTH)
    private String apdgrp_ixd_htmc3;

    @RelPath(value="apdgrp.ixd.jf",dir=DirType.BOTH)
    private String apdgrp_ixd_jf;

    @RelPath(value="apdgrp.ixd.jffrdb",dir=DirType.BOTH)
    private String apdgrp_ixd_jffrdb;

    @RelPath(value="apdgrp.ixd.jfyqdcwzkfw",dir=DirType.BOTH)
    private String apdgrp_ixd_jfyqdcwzkfw;

    @RelPath(value="apdgrp.ixd.jfzs",dir=DirType.BOTH)
    private String apdgrp_ixd_jfzs;

    @RelPath(value="apdgrp.ixd.ktdd",dir=DirType.BOTH)
    private String apdgrp_ixd_ktdd;

    @RelPath(value="apdgrp.ixd.ldzcjzbl",dir=DirType.BOTH)
    private String apdgrp_ixd_ldzcjzbl;

    @RelPath(value="apdgrp.ixd.lxchfs",dir=DirType.BOTH)
    private String apdgrp_ixd_lxchfs;

    @RelPath(value="apdgrp.ixd.lxchqtfs",dir=DirType.BOTH)
    private String apdgrp_ixd_lxchqtfs;

    @RelPath(value="apdgrp.ixd.qtfs",dir=DirType.BOTH)
    private String apdgrp_ixd_qtfs;

    @RelPath(value="apdgrp.ixd.rzdqr",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_ixd_rzdqr;

    @RelPath(value="apdgrp.ixd.rzlv",dir=DirType.BOTH)
    private long apdgrp_ixd_rzlv;

    @RelPath(value="apdgrp.ixd.rzqsr",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_ixd_rzqsr;

    @RelPath(value="apdgrp.ixd.rzsy",dir=DirType.BOTH)
    private String apdgrp_ixd_rzsy;

    @RelPath(value="apdgrp.ixd.sxedrmbje",dir=DirType.BOTH)
    private long apdgrp_ixd_sxedrmbje;

    @RelPath(value="apdgrp.ixd.sxhtbh",dir=DirType.BOTH)
    private String apdgrp_ixd_sxhtbh;

    @RelPath(value="apdgrp.ixd.sxhtmc",dir=DirType.BOTH)
    private String apdgrp_ixd_sxhtmc;

    @RelPath(value="apdgrp.ixd.sxxqjzr",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_ixd_sxxqjzr;

    @RelPath(value="apdgrp.ixd.sxxqqsr",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_ixd_sxxqqsr;

    @RelPath(value="apdgrp.ixd.wyjbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_wyjbl;

    @RelPath(value="apdgrp.ixd.yf",dir=DirType.BOTH)
    private String apdgrp_ixd_yf;

    @RelPath(value="apdgrp.ixd.yfczhm",dir=DirType.BOTH)
    private String apdgrp_ixd_yfczhm;

    @RelPath(value="apdgrp.ixd.yfdwdz",dir=DirType.BOTH)
    private String apdgrp_ixd_yfdwdz;

    @RelPath(value="apdgrp.ixd.yfdwmc",dir=DirType.BOTH)
    private String apdgrp_ixd_yfdwmc;

    @RelPath(value="apdgrp.ixd.yfdzyj",dir=DirType.BOTH)
    private String apdgrp_ixd_yfdzyj;

    @RelPath(value="apdgrp.ixd.yffrdb",dir=DirType.BOTH)
    private String apdgrp_ixd_yffrdb;

    @RelPath(value="apdgrp.ixd.yfgqbg",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_yfgqbg;

    @RelPath(value="apdgrp.ixd.yflxdh",dir=DirType.BOTH)
    private String apdgrp_ixd_yflxdh;

    @RelPath(value="apdgrp.ixd.yflxr",dir=DirType.BOTH)
    private String apdgrp_ixd_yflxr;

    @RelPath(value="apdgrp.ixd.yfqqhm",dir=DirType.BOTH)
    private String apdgrp_ixd_yfqqhm;

    @RelPath(value="apdgrp.ixd.yfsjhm",dir=DirType.BOTH)
    private String apdgrp_ixd_yfsjhm;

    @RelPath(value="apdgrp.ixd.yfwxhm",dir=DirType.BOTH)
    private String apdgrp_ixd_yfwxhm;

    @RelPath(value="apdgrp.ixd.yfyzbm",dir=DirType.BOTH)
    private String apdgrp_ixd_yfyzbm;

    @RelPath(value="apdgrp.ixd.yfzs",dir=DirType.BOTH)
    private String apdgrp_ixd_yfzs;

    @RelPath(value="apdgrp.ixd.yqdkrll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_yqdkrll;

    @RelPath(value="apdgrp.ixd.zcfzbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_zcfzbl;

    @RelPath(value="apdgrp.ixd.zcldbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal apdgrp_ixd_zcldbl;

    @RelPath(value="apdgrp.ixd.zcwyh",dir=DirType.BOTH)
    private String apdgrp_ixd_zcwyh;

    @RelPath(value="apdgrp.ixd.zyjjfs",dir=DirType.BOTH)
    private String apdgrp_ixd_zyjjfs;


}