package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Ptyaut;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AutcfgVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="accredit",dir=DirType.BOTH)
    private String accredit;

    @RelPath(value="check",dir=DirType.BOTH)
    private String check;

    @RelPath(value="counter",dir=DirType.BOTH)
    private String counter;

    @RelPath(value="entity",dir=DirType.BOTH)
    private String entity;

    @RelPath(value="lst",dir=DirType.OUT)
    private ModuleList<Ptyaut> lst;

    @RelPath(value="organ",dir=DirType.BOTH)
    private String organ;

    @RelPath(value="ptyaut.flg1",dir=DirType.BOTH)
    private String ptyaut_flg1;

    @RelPath(value="ptyaut.flg2",dir=DirType.BOTH)
    private String ptyaut_flg2;

    @RelPath(value="ptyaut.frm",dir=DirType.BOTH)
    private String ptyaut_frm;

    @RelPath(value="ptyaut.lowamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ptyaut_lowamt;

    @RelPath(value="ptyaut.lvl",dir=DirType.BOTH)
    private String ptyaut_lvl;

    @RelPath(value="ptyaut.uppamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ptyaut_uppamt;


}