package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class AuthenVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="audgrp.aud.clientid",dir=DirType.BOTH)
    private String audgrp_aud_clientid;

    @RelPath(value="audgrp.aud.clientnam",dir=DirType.BOTH)
    private String audgrp_aud_clientnam;

    @RelPath(value="audgrp.aud.content",dir=DirType.BOTH)
    private String audgrp_aud_content;

    @RelPath(value="audgrp.aud.date",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date audgrp_aud_date;

    @RelPath(value="audgrp.aud.ownref",dir=DirType.BOTH)
    private String audgrp_aud_ownref;

    @RelPath(value="audgrp.aud.typ",dir=DirType.BOTH)
    private String audgrp_aud_typ;


}