package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BctdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bcdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bcdgrp_rec_advdat;

    @RelPath(value="bcdgrp.rec.conno",dir=DirType.BOTH)
    private String bcdgrp_rec_conno;

    @RelPath(value="bcdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bcdgrp_rec_docamt;

    @RelPath(value="bcdgrp.rec.doccur",dir=DirType.BOTH)
    private String bcdgrp_rec_doccur;

    @RelPath(value="bcdgrp.rec.doctypcod",dir=DirType.BOTH)
    private String bcdgrp_rec_doctypcod;

    @RelPath(value="bcdgrp.rec.rcvdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bcdgrp_rec_rcvdat;

    @RelPath(value="bcdgrp.rec.stlref",dir=DirType.BOTH)
    private String bcdgrp_rec_stlref;

    @RelPath(value="bcdgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_dre_pts_adrblk;

    @RelPath(value="bcdgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_dre_pts_extkey;

    @RelPath(value="bcdgrp.drr.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_drr_pts_adrblk;

    @RelPath(value="bcdgrp.drr.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_drr_pts_extkey;

    @RelPath(value="bcdgrp.rmi.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_rmi_pts_adrblk;

    @RelPath(value="bcdgrp.rmi.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_rmi_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}