package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BctopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bcdgrp.rec.bchcod",dir=DirType.BOTH)
    private String bcdgrp_rec_bchcod;

    @RelPath(value="bcdgrp.rec.conno",dir=DirType.BOTH)
    private String bcdgrp_rec_conno;

    @RelPath(value="bcdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bcdgrp_rec_credat;

    @RelPath(value="bcdgrp.rec.doctypcod",dir=DirType.BOTH)
    private String bcdgrp_rec_doctypcod;

    @RelPath(value="bcdgrp.rec.invno",dir=DirType.BOTH)
    private String bcdgrp_rec_invno;

    @RelPath(value="bcdgrp.rec.matpercnt",dir=DirType.BOTH)
    private String bcdgrp_rec_matpercnt;

    @RelPath(value="bcdgrp.rec.matpertyp",dir=DirType.BOTH)
    private String bcdgrp_rec_matpertyp;

    @RelPath(value="bcdgrp.rec.occamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bcdgrp_rec_occamt;

    @RelPath(value="bcdgrp.rec.occcur",dir=DirType.BOTH)
    private String bcdgrp_rec_occcur;

    @RelPath(value="bcdgrp.rec.ownref",dir=DirType.BOTH)
    private String bcdgrp_rec_ownref;

    @RelPath(value="bcdgrp.bnkrecd.agbchrgby",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_agbchrgby;

    @RelPath(value="bcdgrp.bnkrecd.doctyp",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_doctyp;

    @RelPath(value="bcdgrp.bnkrecd.othdoc",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_othdoc;

    @RelPath(value="bcdgrp.bnkrecd.othins",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_othins;

    @RelPath(value="bcdgrp.bnkrecd.rcvdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bcdgrp_bnkrecd_rcvdat;

    @RelPath(value="bcdgrp.bnkrecd.rmichrgby",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_rmichrgby;

    @RelPath(value="bcdgrp.bnkrecd.splcnd",dir=DirType.BOTH)
    private String bcdgrp_bnkrecd_splcnd;

    @RelPath(value="bcdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String bcdgrp_dap_pts_nam;

    @RelPath(value="bcdgrp.doctxt",dir=DirType.BOTH)
    private String bcdgrp_doctxt;

    @RelPath(value="bcdgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_dre_pts_adrblk;

    @RelPath(value="bcdgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_dre_pts_extkey;

    @RelPath(value="bcdgrp.drr.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_drr_pts_adrblk;

    @RelPath(value="bcdgrp.drr.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_drr_pts_extkey;

    @RelPath(value="bcdgrp.rmi.pts.adrblk",dir=DirType.BOTH)
    private String bcdgrp_rmi_pts_adrblk;

    @RelPath(value="bcdgrp.rmi.pts.extkey",dir=DirType.BOTH)
    private String bcdgrp_rmi_pts_extkey;

    @RelPath(value="bcdgrp.rmi.pts.ref",dir=DirType.BOTH)
    private String bcdgrp_rmi_pts_ref;

    @RelPath(value="bctp.dapp.curcus",dir=DirType.BOTH)
    private String bctp_dapp_curcus;

    @RelPath(value="bctp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> bctp_docgrdm_docgrd;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}