package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BdtfrcVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="afdgrp.rec.bchcod",dir=DirType.BOTH)
    private String afdgrp_rec_bchcod;

    @RelPath(value="afdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date afdgrp_rec_credat;

    @RelPath(value="afdgrp.rec.oprtxt",dir=DirType.BOTH)
    private String afdgrp_rec_oprtxt;

    @RelPath(value="didgrp.rec.conno",dir=DirType.BOTH)
    private String didgrp_rec_conno;

    @RelPath(value="didgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_issamt;

    @RelPath(value="didgrp.rec.isscur",dir=DirType.BOTH)
    private String didgrp_rec_isscur;

    @RelPath(value="didgrp.rec.stlref",dir=DirType.BOTH)
    private String didgrp_rec_stlref;

    @RelPath(value="didgrp.apl.pts.ref",dir=DirType.BOTH)
    private String didgrp_apl_pts_ref;

    @RelPath(value="didgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_ben_pts_adrblk;

    @RelPath(value="didgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String didgrp_ben_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}