package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BdtudpVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bddgrp.rec.accdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bddgrp_rec_accdat;

    @RelPath(value="bddgrp.rec.acpamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bddgrp_rec_acpamt;

    @RelPath(value="bddgrp.rec.acpcur",dir=DirType.BOTH)
    private String bddgrp_rec_acpcur;

    @RelPath(value="bddgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bddgrp_rec_advdat;

    @RelPath(value="bddgrp.rec.stlref",dir=DirType.BOTH)
    private String bddgrp_rec_stlref;

    @RelPath(value="bddgrp.rec.valdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bddgrp_rec_valdat;

    @RelPath(value="bddgrp.apl.pts.ref",dir=DirType.BOTH)
    private String bddgrp_apl_pts_ref;

    @RelPath(value="bddgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String bddgrp_ben_pts_adrblk;

    @RelPath(value="bddgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String bddgrp_ben_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}