package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BetchkVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.balamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_balamt;

    @RelPath(value="bedgrp.rec.balcur",dir=DirType.BOTH)
    private String bedgrp_rec_balcur;

    @RelPath(value="bedgrp.rec.bchcod",dir=DirType.BOTH)
    private String bedgrp_rec_bchcod;

    @RelPath(value="bedgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_credat;

    @RelPath(value="bedgrp.rec.emsnam",dir=DirType.BOTH)
    private String bedgrp_rec_emsnam;

    @RelPath(value="bedgrp.rec.emsnum",dir=DirType.BOTH)
    private String bedgrp_rec_emsnum;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.opnamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_opnamt;

    @RelPath(value="bedgrp.rec.opncur",dir=DirType.BOTH)
    private String bedgrp_rec_opncur;

    @RelPath(value="bedgrp.rec.ownref",dir=DirType.BOTH)
    private String bedgrp_rec_ownref;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="ledgrp.rec.tenmaxday",dir=DirType.BOTH)
    private String ledgrp_rec_tenmaxday;

    @RelPath(value="ledgrp.rec.tenor",dir=DirType.BOTH)
    private String ledgrp_rec_tenor;

    @RelPath(value="ledgrp.rec.usapro",dir=DirType.BOTH)
    private String ledgrp_rec_usapro;

    @RelPath(value="bedgrp.bnkrecd.othdoc",dir=DirType.BOTH)
    private String bedgrp_bnkrecd_othdoc;

    @RelPath(value="bedgrp.cmcrecd.cmcrmk",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_cmcrmk;

    @RelPath(value="bedgrp.cmcrecd.doctyp",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_doctyp;

    @RelPath(value="bedgrp.cmcrecd.dsgretxt",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_dsgretxt;

    @RelPath(value="bedgrp.cmcrecd.lccnum",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_lccnum;

    @RelPath(value="bedgrp.cmcrecd.note",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_note;

    @RelPath(value="bedgrp.cmcrecd.prsnton",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_cmcrecd_prsnton;

    @RelPath(value="bedgrp.cmcrecd.sndins",dir=DirType.BOTH)
    private String bedgrp_cmcrecd_sndins;

    @RelPath(value="bedgrp.dap.pts.nam",dir=DirType.BOTH)
    private String bedgrp_dap_pts_nam;

    @RelPath(value="betp.dapp.curcus",dir=DirType.BOTH)
    private String betp_dapp_curcus;

    @RelPath(value="betp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> betp_docgrdm_docgrd;

    @RelPath(value="ledgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_ben_pts_adrblk;

    @RelPath(value="ledgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_ben_pts_extkey;

    @RelPath(value="ledgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_isb_pts_adrblk;

    @RelPath(value="ledgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_isb_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}