package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BetrggVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.bchcod",dir=DirType.BOTH)
    private String bedgrp_rec_bchcod;

    @RelPath(value="bedgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_credat;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.ownref",dir=DirType.BOTH)
    private String bedgrp_rec_ownref;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="ledgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_isb_pts_adrblk;

    @RelPath(value="ledgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_isb_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}