package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BetsetVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_accamt;

    @RelPath(value="bedgrp.rec.accno",dir=DirType.BOTH)
    private String bedgrp_rec_accno;

    @RelPath(value="bedgrp.rec.bkcfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_bkcfee;

    @RelPath(value="bedgrp.rec.ddamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_ddamt;

    @RelPath(value="bedgrp.rec.ddcur",dir=DirType.BOTH)
    private String bedgrp_rec_ddcur;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.fncfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_fncfee;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_opndat;

    @RelPath(value="bedgrp.rec.pntstlref",dir=DirType.BOTH)
    private String bedgrp_rec_pntstlref;

    @RelPath(value="bedgrp.rec.predat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_predat;

    @RelPath(value="bedgrp.rec.ptcfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_ptcfee;

    @RelPath(value="bedgrp.rec.stlref",dir=DirType.BOTH)
    private String bedgrp_rec_stlref;

    @RelPath(value="bedgrp.acccur",dir=DirType.BOTH)
    private String bedgrp_acccur;

    @RelPath(value="bedgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_ben_pts_adrblk;

    @RelPath(value="bedgrp.bkccur",dir=DirType.BOTH)
    private String bedgrp_bkccur;

    @RelPath(value="bedgrp.fnccur",dir=DirType.BOTH)
    private String bedgrp_fnccur;

    @RelPath(value="bedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_isb_pts_adrblk;

    @RelPath(value="bedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_isb_pts_extkey;

    @RelPath(value="bedgrp.ptccur",dir=DirType.BOTH)
    private String bedgrp_ptccur;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}