package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BetsndVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_advdat;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.emsnam",dir=DirType.BOTH)
    private String bedgrp_rec_emsnam;

    @RelPath(value="bedgrp.rec.emsnum",dir=DirType.BOTH)
    private String bedgrp_rec_emsnum;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_matdat;

    @RelPath(value="bedgrp.rec.sndto",dir=DirType.BOTH)
    private String bedgrp_rec_sndto;

    @RelPath(value="bedgrp.rec.stlref",dir=DirType.BOTH)
    private String bedgrp_rec_stlref;

    @RelPath(value="bedgrp.rec.tenor",dir=DirType.BOTH)
    private String bedgrp_rec_tenor;

    @RelPath(value="bedgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_ben_pts_adrblk;

    @RelPath(value="bedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_isb_pts_adrblk;

    @RelPath(value="bedgrp.isb.pts.ref",dir=DirType.BOTH)
    private String bedgrp_isb_pts_ref;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}