package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BilchkVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.addamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_addamt;

    @RelPath(value="bedgrp.rec.addphr",dir=DirType.BOTH)
    private String bedgrp_rec_addphr;

    @RelPath(value="bedgrp.rec.balamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_balamt;

    @RelPath(value="bedgrp.rec.balcur",dir=DirType.BOTH)
    private String bedgrp_rec_balcur;

    @RelPath(value="bedgrp.rec.clmamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_clmamt;

    @RelPath(value="bedgrp.rec.decamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_decamt;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.emsnam",dir=DirType.BOTH)
    private String bedgrp_rec_emsnam;

    @RelPath(value="bedgrp.rec.emsnum",dir=DirType.BOTH)
    private String bedgrp_rec_emsnum;

    @RelPath(value="bedgrp.rec.interdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_interdat;

    @RelPath(value="bedgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_matdat;

    @RelPath(value="bedgrp.rec.modcur",dir=DirType.BOTH)
    private String bedgrp_rec_modcur;

    @RelPath(value="bedgrp.rec.opinion",dir=DirType.BOTH)
    private String bedgrp_rec_opinion;

    @RelPath(value="bedgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_opndat;

    @RelPath(value="bedgrp.rec.othdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_othdat;

    @RelPath(value="bedgrp.rec.ownref",dir=DirType.BOTH)
    private String bedgrp_rec_ownref;

    @RelPath(value="bedgrp.rec.payinstxt",dir=DirType.BOTH)
    private String bedgrp_rec_payinstxt;

    @RelPath(value="bedgrp.rec.predat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_predat;

    @RelPath(value="bedgrp.rec.rcvdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_rcvdat;

    @RelPath(value="bedgrp.rec.remark",dir=DirType.BOTH)
    private String bedgrp_rec_remark;

    @RelPath(value="bedgrp.rec.rembtxt",dir=DirType.BOTH)
    private String bedgrp_rec_rembtxt;

    @RelPath(value="bedgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_shpdat;

    @RelPath(value="bedgrp.rec.usadet",dir=DirType.BOTH)
    private String bedgrp_rec_usadet;

    @RelPath(value="ledgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_credat;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="ledgrp.rec.tenmaxday",dir=DirType.BOTH)
    private String ledgrp_rec_tenmaxday;

    @RelPath(value="ledgrp.rec.tenor",dir=DirType.BOTH)
    private String ledgrp_rec_tenor;

    @RelPath(value="ledgrp.rec.usapro",dir=DirType.BOTH)
    private String ledgrp_rec_usapro;

    @RelPath(value="bedgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_apl_pts_adrblk;

    @RelPath(value="bedgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_apl_pts_extkey;

    @RelPath(value="bedgrp.beb.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_beb_pts_adrblk;

    @RelPath(value="bedgrp.beb.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_beb_pts_extkey;

    @RelPath(value="bedgrp.bnkrecd.othdoc",dir=DirType.BOTH)
    private String bedgrp_bnkrecd_othdoc;

    @RelPath(value="bedgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_dre_pts_adrblk;

    @RelPath(value="bedgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_dre_pts_extkey;

    @RelPath(value="bedgrp.oth.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_oth_pts_adrblk;

    @RelPath(value="bedgrp.oth.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_oth_pts_extkey;

    @RelPath(value="bedgrp.oth.pts.ref",dir=DirType.BOTH)
    private String bedgrp_oth_pts_ref;

    @RelPath(value="bedgrp.rmb.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_rmb_pts_adrblk;

    @RelPath(value="bedgrp.rmb.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_rmb_pts_extkey;

    @RelPath(value="bedgrp.send",dir=DirType.BOTH)
    private String bedgrp_send;

    @RelPath(value="betp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> betp_docgrdm_docgrd;

    @RelPath(value="ledgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_ben_pts_adrblk;

    @RelPath(value="ledgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_ben_pts_extkey;

    @RelPath(value="ledgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_isb_pts_adrblk;

    @RelPath(value="ledgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_isb_pts_extkey;


}