package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BmtaccVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bmdgrp.rec.acpamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_acpamt;

    @RelPath(value="bmdgrp.rec.acpcur",dir=DirType.BOTH)
    private String bmdgrp_rec_acpcur;

    @RelPath(value="bmdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_docamt;

    @RelPath(value="bmdgrp.rec.doccur",dir=DirType.BOTH)
    private String bmdgrp_rec_doccur;

    @RelPath(value="bmdgrp.rec.docdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_docdat;

    @RelPath(value="bmdgrp.rec.invno",dir=DirType.BOTH)
    private String bmdgrp_rec_invno;

    @RelPath(value="bmdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_matdat;

    @RelPath(value="bmdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_opndat;

    @RelPath(value="bmdgrp.rec.pntref",dir=DirType.BOTH)
    private String bmdgrp_rec_pntref;

    @RelPath(value="bmdgrp.rec.stlref",dir=DirType.BOTH)
    private String bmdgrp_rec_stlref;

    @RelPath(value="bmdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_ben_pts_adrblk;

    @RelPath(value="bmdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_isb_pts_adrblk;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}