package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BmtameVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bmdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_advdat;

    @RelPath(value="bmdgrp.rec.clmamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_clmamt;

    @RelPath(value="bmdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_credat;

    @RelPath(value="bmdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_docamt;

    @RelPath(value="bmdgrp.rec.doccur",dir=DirType.BOTH)
    private String bmdgrp_rec_doccur;

    @RelPath(value="bmdgrp.rec.docdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_docdat;

    @RelPath(value="bmdgrp.rec.modcur",dir=DirType.BOTH)
    private String bmdgrp_rec_modcur;

    @RelPath(value="bmdgrp.rec.ownref",dir=DirType.BOTH)
    private String bmdgrp_rec_ownref;

    @RelPath(value="dedgrp.rec.lccref",dir=DirType.BOTH)
    private String dedgrp_rec_lccref;

    @RelPath(value="dedgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_ben_pts_adrblk;

    @RelPath(value="dedgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_ben_pts_extkey;

    @RelPath(value="dedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_isb_pts_adrblk;

    @RelPath(value="dedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_isb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}