package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BmtdisVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bmdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_credat;

    @RelPath(value="bmdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_docamt;

    @RelPath(value="bmdgrp.rec.doccur",dir=DirType.BOTH)
    private String bmdgrp_rec_doccur;

    @RelPath(value="bmdgrp.rec.invno",dir=DirType.BOTH)
    private String bmdgrp_rec_invno;

    @RelPath(value="bmdgrp.rec.pntref",dir=DirType.BOTH)
    private String bmdgrp_rec_pntref;

    @RelPath(value="bmdgrp.rec.stlref",dir=DirType.BOTH)
    private String bmdgrp_rec_stlref;

    @RelPath(value="bmdgrp.dap.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_dap_pts_adrblk;

    @RelPath(value="bmdgrp.dap.pts.extkey",dir=DirType.BOTH)
    private String bmdgrp_dap_pts_extkey;

    @RelPath(value="bmdgrp.docdft.advinf",dir=DirType.BOTH)
    private String bmdgrp_docdft_advinf;

    @RelPath(value="bmdgrp.docdft.cls",dir=DirType.BOTH)
    private String bmdgrp_docdft_cls;

    @RelPath(value="bmdgrp.docdft.sdutyp",dir=DirType.BOTH)
    private String bmdgrp_docdft_sdutyp;

    @RelPath(value="bmdgrp.docdft.swiftinf",dir=DirType.BOTH)
    private String bmdgrp_docdft_swiftinf;

    @RelPath(value="bmtp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> bmtp_docgrdm_docgrd;

    @RelPath(value="dedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_isb_pts_adrblk;

    @RelPath(value="dedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_isb_pts_extkey;


}