package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BmtsetVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bmdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_accamt;

    @RelPath(value="bmdgrp.rec.acccur",dir=DirType.BOTH)
    private String bmdgrp_rec_acccur;

    @RelPath(value="bmdgrp.rec.accno",dir=DirType.BOTH)
    private String bmdgrp_rec_accno;

    @RelPath(value="bmdgrp.rec.bkcfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_bkcfee;

    @RelPath(value="bmdgrp.rec.ddamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_ddamt;

    @RelPath(value="bmdgrp.rec.ddcur",dir=DirType.BOTH)
    private String bmdgrp_rec_ddcur;

    @RelPath(value="bmdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_docamt;

    @RelPath(value="bmdgrp.rec.doccur",dir=DirType.BOTH)
    private String bmdgrp_rec_doccur;

    @RelPath(value="bmdgrp.rec.exrate",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bmdgrp_rec_exrate;

    @RelPath(value="bmdgrp.rec.invno",dir=DirType.BOTH)
    private String bmdgrp_rec_invno;

    @RelPath(value="bmdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_opndat;

    @RelPath(value="bmdgrp.rec.pntstlref",dir=DirType.BOTH)
    private String bmdgrp_rec_pntstlref;

    @RelPath(value="bmdgrp.rec.predat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bmdgrp_rec_predat;

    @RelPath(value="bmdgrp.rec.stlref",dir=DirType.BOTH)
    private String bmdgrp_rec_stlref;

    @RelPath(value="bmdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_ben_pts_adrblk;

    @RelPath(value="bmdgrp.bkccur",dir=DirType.BOTH)
    private String bmdgrp_bkccur;

    @RelPath(value="bmdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_isb_pts_adrblk;

    @RelPath(value="bmdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String bmdgrp_isb_pts_extkey;

    @RelPath(value="bmdgrp.ptcfee",dir=DirType.BOTH)
    private String bmdgrp_ptcfee;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}