package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BotfreVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="afdgrp.rec.bchcod",dir=DirType.BOTH)
    private String afdgrp_rec_bchcod;

    @RelPath(value="afdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date afdgrp_rec_credat;

    @RelPath(value="afdgrp.rec.oprtxt",dir=DirType.BOTH)
    private String afdgrp_rec_oprtxt;

    @RelPath(value="afdgrp.rec.oprtyp",dir=DirType.BOTH)
    private String afdgrp_rec_oprtyp;

    @RelPath(value="bodgrp.rec.invno",dir=DirType.BOTH)
    private String bodgrp_rec_invno;

    @RelPath(value="bodgrp.rec.occamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_occamt;

    @RelPath(value="bodgrp.rec.occcur",dir=DirType.BOTH)
    private String bodgrp_rec_occcur;

    @RelPath(value="bodgrp.rec.stlref",dir=DirType.BOTH)
    private String bodgrp_rec_stlref;

    @RelPath(value="bodgrp.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_amt;

    @RelPath(value="bodgrp.clb.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_clb_pts_adrblk;

    @RelPath(value="bodgrp.clb.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_clb_pts_extkey;

    @RelPath(value="bodgrp.comlab",dir=DirType.BOTH)
    private String bodgrp_comlab;

    @RelPath(value="bodgrp.cur",dir=DirType.BOTH)
    private String bodgrp_cur;

    @RelPath(value="bodgrp.dat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bodgrp_dat;

    @RelPath(value="bodgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_dre_pts_adrblk;

    @RelPath(value="bodgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_dre_pts_extkey;

    @RelPath(value="bodgrp.modtenor",dir=DirType.BOTH)
    private String bodgrp_modtenor;

    @RelPath(value="bodgrp.modtenorday",dir=DirType.BOTH)
    private String bodgrp_modtenorday;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}