package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import com.ceb.gjjs.mda.bo.Bod;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BotopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bodgrp.rec.bchcod",dir=DirType.BOTH)
    private String bodgrp_rec_bchcod;

    @RelPath(value="bodgrp.rec.bopno",dir=DirType.BOTH)
    private String bodgrp_rec_bopno;

    @RelPath(value="bodgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bodgrp_rec_credat;

    @RelPath(value="bodgrp.rec.doctypcod",dir=DirType.BOTH)
    private String bodgrp_rec_doctypcod;

    @RelPath(value="bodgrp.rec.givamt",dir=DirType.BOTH)
    private String bodgrp_rec_givamt;

    @RelPath(value="bodgrp.rec.invno",dir=DirType.BOTH)
    private String bodgrp_rec_invno;

    @RelPath(value="bodgrp.rec.isjrc",dir=DirType.BOTH)
    private String bodgrp_rec_isjrc;

    @RelPath(value="bodgrp.rec.isyrc",dir=DirType.BOTH)
    private String bodgrp_rec_isyrc;

    @RelPath(value="bodgrp.rec.jrcno",dir=DirType.BOTH)
    private String bodgrp_rec_jrcno;

    @RelPath(value="bodgrp.rec.matpercnt",dir=DirType.BOTH)
    private int bodgrp_rec_matpercnt;

    @RelPath(value="bodgrp.rec.matpertyp",dir=DirType.BOTH)
    private String bodgrp_rec_matpertyp;

    @RelPath(value="bodgrp.rec.notlce",dir=DirType.BOTH)
    private String bodgrp_rec_notlce;

    @RelPath(value="bodgrp.rec.occamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_occamt;

    @RelPath(value="bodgrp.rec.occcur",dir=DirType.BOTH)
    private String bodgrp_rec_occcur;

    @RelPath(value="bodgrp.rec.ownref",dir=DirType.BOTH)
    private String bodgrp_rec_ownref;

    @RelPath(value="bodgrp.rec.yrcno",dir=DirType.BOTH)
    private String bodgrp_rec_yrcno;

    @RelPath(value="bodgrp.apl.pty.nam",dir=DirType.BOTH)
    private String bodgrp_apl_pty_nam;

    @RelPath(value="bodgrp.bnkrecd.othdoc",dir=DirType.BOTH)
    private String bodgrp_bnkrecd_othdoc;

    @RelPath(value="bodgrp.bodlst",dir=DirType.OUT)
    private ModuleList<Bod> bodgrp_bodlst;

    @RelPath(value="bodgrp.clb.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_clb_pts_adrblk;

    @RelPath(value="bodgrp.clb.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_clb_pts_extkey;

    @RelPath(value="bodgrp.dap.pts.nam",dir=DirType.BOTH)
    private String bodgrp_dap_pts_nam;

    @RelPath(value="bodgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_dre_pts_adrblk;

    @RelPath(value="bodgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_dre_pts_extkey;

    @RelPath(value="bodgrp.drr.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_drr_pts_adrblk;

    @RelPath(value="bodgrp.drr.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_drr_pts_extkey;

    @RelPath(value="bodgrp.mixdet",dir=DirType.BOTH)
    private String bodgrp_mixdet;

    @RelPath(value="botp.dapp.curcus",dir=DirType.BOTH)
    private String botp_dapp_curcus;

    @RelPath(value="botp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> botp_docgrdm_docgrd;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}