package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BotsetVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bodgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_accamt;

    @RelPath(value="bodgrp.rec.acccur",dir=DirType.BOTH)
    private String bodgrp_rec_acccur;

    @RelPath(value="bodgrp.rec.accno",dir=DirType.BOTH)
    private String bodgrp_rec_accno;

    @RelPath(value="bodgrp.rec.accnotwo",dir=DirType.BOTH)
    private String bodgrp_rec_accnotwo;

    @RelPath(value="bodgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bodgrp_rec_advdat;

    @RelPath(value="bodgrp.rec.bakfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_bakfee;

    @RelPath(value="bodgrp.rec.excrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bodgrp_rec_excrat;

    @RelPath(value="bodgrp.rec.fbkfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_fbkfee;

    @RelPath(value="bodgrp.rec.invno",dir=DirType.BOTH)
    private String bodgrp_rec_invno;

    @RelPath(value="bodgrp.rec.occamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_occamt;

    @RelPath(value="bodgrp.rec.occcur",dir=DirType.BOTH)
    private String bodgrp_rec_occcur;

    @RelPath(value="bodgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bodgrp_rec_opndat;

    @RelPath(value="bodgrp.rec.pstfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_pstfee;

    @RelPath(value="bodgrp.rec.setamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bodgrp_rec_setamt;

    @RelPath(value="bodgrp.rec.setcur",dir=DirType.BOTH)
    private String bodgrp_rec_setcur;

    @RelPath(value="bodgrp.rec.stlref",dir=DirType.BOTH)
    private String bodgrp_rec_stlref;

    @RelPath(value="bodgrp.bakcur",dir=DirType.BOTH)
    private String bodgrp_bakcur;

    @RelPath(value="bodgrp.clb.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_clb_pts_adrblk;

    @RelPath(value="bodgrp.clb.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_clb_pts_extkey;

    @RelPath(value="bodgrp.dre.pts.adrblk",dir=DirType.BOTH)
    private String bodgrp_dre_pts_adrblk;

    @RelPath(value="bodgrp.dre.pts.extkey",dir=DirType.BOTH)
    private String bodgrp_dre_pts_extkey;

    @RelPath(value="bodgrp.fbkcur",dir=DirType.BOTH)
    private String bodgrp_fbkcur;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}