package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BptbpsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bpdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_advdat;

    @RelPath(value="bpdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_docamt;

    @RelPath(value="bpdgrp.rec.doccur",dir=DirType.BOTH)
    private String bpdgrp_rec_doccur;

    @RelPath(value="bpdgrp.rec.exerat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_exerat;

    @RelPath(value="bpdgrp.rec.fftamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_fftamt;

    @RelPath(value="bpdgrp.rec.fftcur",dir=DirType.BOTH)
    private String bpdgrp_rec_fftcur;

    @RelPath(value="bpdgrp.rec.invno",dir=DirType.BOTH)
    private String bpdgrp_rec_invno;

    @RelPath(value="bpdgrp.rec.lcref",dir=DirType.BOTH)
    private String bpdgrp_rec_lcref;

    @RelPath(value="bpdgrp.rec.pntref",dir=DirType.BOTH)
    private String bpdgrp_rec_pntref;

    @RelPath(value="bpdgrp.rec.stlref",dir=DirType.BOTH)
    private String bpdgrp_rec_stlref;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}