package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BptcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bpdgrp.rec.days",dir=DirType.BOTH)
    private int bpdgrp_rec_days;

    @RelPath(value="bpdgrp.rec.fftvaldat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_fftvaldat;

    @RelPath(value="bpdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_matdat;

    @RelPath(value="bpdgrp.amt",dir=DirType.BOTH)
    private String bpdgrp_amt;

    @RelPath(value="bpdgrp.checked",dir=DirType.BOTH)
    private String bpdgrp_checked;

    @RelPath(value="bpdgrp.pxd.bctk",dir=DirType.BOTH)
    private String bpdgrp_pxd_bctk;

    @RelPath(value="bpdgrp.pxd.cwbdfw",dir=DirType.BOTH)
    private String bpdgrp_pxd_cwbdfw;

    @RelPath(value="bpdgrp.pxd.dbfs1",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbfs1;

    @RelPath(value="bpdgrp.pxd.dbfs2",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbfs2;

    @RelPath(value="bpdgrp.pxd.dbfs3",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbfs3;

    @RelPath(value="bpdgrp.pxd.dbr1",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbr1;

    @RelPath(value="bpdgrp.pxd.dbr2",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbr2;

    @RelPath(value="bpdgrp.pxd.dbr3",dir=DirType.BOTH)
    private String bpdgrp_pxd_dbr3;

    @RelPath(value="bpdgrp.pxd.dsdz",dir=DirType.BOTH)
    private String bpdgrp_pxd_dsdz;

    @RelPath(value="bpdgrp.pxd.dslxdh",dir=DirType.BOTH)
    private String bpdgrp_pxd_dslxdh;

    @RelPath(value="bpdgrp.pxd.dsr",dir=DirType.BOTH)
    private String bpdgrp_pxd_dsr;

    @RelPath(value="bpdgrp.pxd.dsyzbm",dir=DirType.BOTH)
    private String bpdgrp_pxd_dsyzbm;

    @RelPath(value="bpdgrp.pxd.fkfs",dir=DirType.BOTH)
    private String bpdgrp_pxd_fkfs;

    @RelPath(value="bpdgrp.pxd.fxl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal bpdgrp_pxd_fxl;

    @RelPath(value="bpdgrp.pxd.gqbgbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal bpdgrp_pxd_gqbgbl;

    @RelPath(value="bpdgrp.pxd.htbh1",dir=DirType.BOTH)
    private String bpdgrp_pxd_htbh1;

    @RelPath(value="bpdgrp.pxd.htbh2",dir=DirType.BOTH)
    private String bpdgrp_pxd_htbh2;

    @RelPath(value="bpdgrp.pxd.htbh3",dir=DirType.BOTH)
    private String bpdgrp_pxd_htbh3;

    @RelPath(value="bpdgrp.pxd.htmc1",dir=DirType.BOTH)
    private String bpdgrp_pxd_htmc1;

    @RelPath(value="bpdgrp.pxd.htmc2",dir=DirType.BOTH)
    private String bpdgrp_pxd_htmc2;

    @RelPath(value="bpdgrp.pxd.htmc3",dir=DirType.BOTH)
    private String bpdgrp_pxd_htmc3;

    @RelPath(value="bpdgrp.pxd.jf",dir=DirType.BOTH)
    private String bpdgrp_pxd_jf;

    @RelPath(value="bpdgrp.pxd.jffrdb",dir=DirType.BOTH)
    private String bpdgrp_pxd_jffrdb;

    @RelPath(value="bpdgrp.pxd.jfzs",dir=DirType.BOTH)
    private String bpdgrp_pxd_jfzs;

    @RelPath(value="bpdgrp.pxd.jxqtfs",dir=DirType.BOTH)
    private String bpdgrp_pxd_jxqtfs;

    @RelPath(value="bpdgrp.pxd.jxyd",dir=DirType.BOTH)
    private String bpdgrp_pxd_jxyd;

    @RelPath(value="bpdgrp.pxd.ktdd",dir=DirType.BOTH)
    private String bpdgrp_pxd_ktdd;

    @RelPath(value="bpdgrp.pxd.kzh",dir=DirType.BOTH)
    private String bpdgrp_pxd_kzh;

    @RelPath(value="bpdgrp.pxd.qtfs",dir=DirType.BOTH)
    private String bpdgrp_pxd_qtfs;

    @RelPath(value="bpdgrp.pxd.sxhtbh",dir=DirType.BOTH)
    private String bpdgrp_pxd_sxhtbh;

    @RelPath(value="bpdgrp.pxd.sxhtje",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_pxd_sxhtje;

    @RelPath(value="bpdgrp.pxd.sxhtmc",dir=DirType.BOTH)
    private String bpdgrp_pxd_sxhtmc;

    @RelPath(value="bpdgrp.pxd.syqk",dir=DirType.BOTH)
    private String bpdgrp_pxd_syqk;

    @RelPath(value="bpdgrp.pxd.xqqs",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_pxd_xqqs;

    @RelPath(value="bpdgrp.pxd.xqzz",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_pxd_xqzz;

    @RelPath(value="bpdgrp.pxd.xyzh",dir=DirType.BOTH)
    private String bpdgrp_pxd_xyzh;

    @RelPath(value="bpdgrp.pxd.yf",dir=DirType.BOTH)
    private String bpdgrp_pxd_yf;

    @RelPath(value="bpdgrp.pxd.yfczhm",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfczhm;

    @RelPath(value="bpdgrp.pxd.yfdwdz",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfdwdz;

    @RelPath(value="bpdgrp.pxd.yfdwmc",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfdwmc;

    @RelPath(value="bpdgrp.pxd.yfdzyj",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfdzyj;

    @RelPath(value="bpdgrp.pxd.yffrdb",dir=DirType.BOTH)
    private String bpdgrp_pxd_yffrdb;

    @RelPath(value="bpdgrp.pxd.yflxdh",dir=DirType.BOTH)
    private String bpdgrp_pxd_yflxdh;

    @RelPath(value="bpdgrp.pxd.yflxr",dir=DirType.BOTH)
    private String bpdgrp_pxd_yflxr;

    @RelPath(value="bpdgrp.pxd.yfqqhm",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfqqhm;

    @RelPath(value="bpdgrp.pxd.yfqtsx",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfqtsx;

    @RelPath(value="bpdgrp.pxd.yfsjhm",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfsjhm;

    @RelPath(value="bpdgrp.pxd.yfwxhm",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfwxhm;

    @RelPath(value="bpdgrp.pxd.yfyzbm",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfyzbm;

    @RelPath(value="bpdgrp.pxd.yfzs",dir=DirType.BOTH)
    private String bpdgrp_pxd_yfzs;

    @RelPath(value="bpdgrp.pxd.yhnll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(5)
    private BigDecimal bpdgrp_pxd_yhnll;

    @RelPath(value="bpdgrp.pxd.yt",dir=DirType.BOTH)
    private String bpdgrp_pxd_yt;

    @RelPath(value="bpdgrp.pxd.zcwyh",dir=DirType.BOTH)
    private String bpdgrp_pxd_zcwyh;

    @RelPath(value="bpdgrp.pxd.zyjjfs",dir=DirType.BOTH)
    private String bpdgrp_pxd_zyjjfs;


}