package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BptoplVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.stlref",dir=DirType.BOTH)
    private String bedgrp_rec_stlref;

    @RelPath(value="bedgrp.rec.tenor",dir=DirType.BOTH)
    private String bedgrp_rec_tenor;

    @RelPath(value="bpdgrp.rec.basnum",dir=DirType.BOTH)
    private int bpdgrp_rec_basnum;

    @RelPath(value="bpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String bpdgrp_rec_bchcod;

    @RelPath(value="bpdgrp.rec.bpsas",dir=DirType.BOTH)
    private String bpdgrp_rec_bpsas;

    @RelPath(value="bpdgrp.rec.bpsnum",dir=DirType.BOTH)
    private int bpdgrp_rec_bpsnum;

    @RelPath(value="bpdgrp.rec.cntdocnum",dir=DirType.BOTH)
    private String bpdgrp_rec_cntdocnum;

    @RelPath(value="bpdgrp.rec.cnyltyp",dir=DirType.BOTH)
    private String bpdgrp_rec_cnyltyp;

    @RelPath(value="bpdgrp.rec.conref",dir=DirType.BOTH)
    private String bpdgrp_rec_conref;

    @RelPath(value="bpdgrp.rec.consrate",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_consrate;

    @RelPath(value="bpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_credat;

    @RelPath(value="bpdgrp.rec.days",dir=DirType.BOTH)
    private int bpdgrp_rec_days;

    @RelPath(value="bpdgrp.rec.dftamt",dir=DirType.BOTH)
    private String bpdgrp_rec_dftamt;

    @RelPath(value="bpdgrp.rec.disrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_disrat;

    @RelPath(value="bpdgrp.rec.fcnytyp",dir=DirType.BOTH)
    private String bpdgrp_rec_fcnytyp;

    @RelPath(value="bpdgrp.rec.fftamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_fftamt;

    @RelPath(value="bpdgrp.rec.fftcur",dir=DirType.BOTH)
    private String bpdgrp_rec_fftcur;

    @RelPath(value="bpdgrp.rec.fftvaldat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_fftvaldat;

    @RelPath(value="bpdgrp.rec.fkfs",dir=DirType.BOTH)
    private String bpdgrp_rec_fkfs;

    @RelPath(value="bpdgrp.rec.intrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_intrat;

    @RelPath(value="bpdgrp.rec.isagr",dir=DirType.BOTH)
    private String bpdgrp_rec_isagr;

    @RelPath(value="bpdgrp.rec.jssty",dir=DirType.BOTH)
    private String bpdgrp_rec_jssty;

    @RelPath(value="bpdgrp.rec.lihibor",dir=DirType.BOTH)
    private String bpdgrp_rec_lihibor;

    @RelPath(value="bpdgrp.rec.lrldat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_lrldat;

    @RelPath(value="bpdgrp.rec.lrlrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_lrlrat;

    @RelPath(value="bpdgrp.rec.lrltyp",dir=DirType.BOTH)
    private String bpdgrp_rec_lrltyp;

    @RelPath(value="bpdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_matdat;

    @RelPath(value="bpdgrp.rec.othrat",dir=DirType.BOTH)
    private String bpdgrp_rec_othrat;

    @RelPath(value="bpdgrp.rec.ownref",dir=DirType.BOTH)
    private String bpdgrp_rec_ownref;

    @RelPath(value="bpdgrp.rec.paytyp",dir=DirType.BOTH)
    private String bpdgrp_rec_paytyp;

    @RelPath(value="bpdgrp.rec.postedrate",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_postedrate;

    @RelPath(value="bpdgrp.rec.qtnote",dir=DirType.BOTH)
    private String bpdgrp_rec_qtnote;

    @RelPath(value="bpdgrp.rec.ratcycle",dir=DirType.BOTH)
    private String bpdgrp_rec_ratcycle;

    @RelPath(value="bpdgrp.rec.ratday",dir=DirType.BOTH)
    private String bpdgrp_rec_ratday;

    @RelPath(value="bpdgrp.rec.rgtclu",dir=DirType.BOTH)
    private String bpdgrp_rec_rgtclu;

    @RelPath(value="bpdgrp.rec.rmbact",dir=DirType.BOTH)
    private String bpdgrp_rec_rmbact;

    @RelPath(value="bpdgrp.rec.trunll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal bpdgrp_rec_trunll;

    @RelPath(value="bedgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_apl_pts_adrblk;

    @RelPath(value="bpdgrp.aplnam",dir=DirType.BOTH)
    private String bpdgrp_aplnam;

    @RelPath(value="bpdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_adrblk;

    @RelPath(value="bpdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_extkey;

    @RelPath(value="bpdgrp.isb.pts.ref",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_ref;

    @RelPath(value="bptp.ptytyp",dir=DirType.BOTH)
    private String bptp_ptytyp;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}