package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BptrpnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String bpdgrp_rec_bchcod;

    @RelPath(value="bpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_credat;

    @RelPath(value="bpdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_docamt;

    @RelPath(value="bpdgrp.rec.doccur",dir=DirType.BOTH)
    private String bpdgrp_rec_doccur;

    @RelPath(value="bpdgrp.rec.fftamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_fftamt;

    @RelPath(value="bpdgrp.rec.fftcur",dir=DirType.BOTH)
    private String bpdgrp_rec_fftcur;

    @RelPath(value="bpdgrp.rec.invno",dir=DirType.BOTH)
    private String bpdgrp_rec_invno;

    @RelPath(value="bpdgrp.rec.lcref",dir=DirType.BOTH)
    private String bpdgrp_rec_lcref;

    @RelPath(value="bpdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_matdat;

    @RelPath(value="bpdgrp.rec.note",dir=DirType.BOTH)
    private String bpdgrp_rec_note;

    @RelPath(value="bpdgrp.rec.nret",dir=DirType.BOTH)
    private String bpdgrp_rec_nret;

    @RelPath(value="bpdgrp.rec.pntref",dir=DirType.BOTH)
    private String bpdgrp_rec_pntref;

    @RelPath(value="bpdgrp.rec.retamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_retamt;

    @RelPath(value="bpdgrp.rec.retcur",dir=DirType.BOTH)
    private String bpdgrp_rec_retcur;

    @RelPath(value="bpdgrp.rec.retdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_retdat;

    @RelPath(value="bpdgrp.rec.rettyp",dir=DirType.BOTH)
    private String bpdgrp_rec_rettyp;

    @RelPath(value="bpdgrp.rec.rgtclu",dir=DirType.BOTH)
    private String bpdgrp_rec_rgtclu;

    @RelPath(value="bpdgrp.rec.rmbact",dir=DirType.BOTH)
    private String bpdgrp_rec_rmbact;

    @RelPath(value="bpdgrp.rec.stlref",dir=DirType.BOTH)
    private String bpdgrp_rec_stlref;

    @RelPath(value="bpdgrp.rec.yret",dir=DirType.BOTH)
    private String bpdgrp_rec_yret;

    @RelPath(value="bpdgrp.aplnam",dir=DirType.BOTH)
    private String bpdgrp_aplnam;

    @RelPath(value="bptp.huktis",dir=DirType.BOTH)
    private String bptp_huktis;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}