package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BpttrsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bpdgrp.rec.accact",dir=DirType.BOTH)
    private String bpdgrp_rec_accact;

    @RelPath(value="bpdgrp.rec.advagrnum",dir=DirType.BOTH)
    private String bpdgrp_rec_advagrnum;

    @RelPath(value="bpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String bpdgrp_rec_bchcod;

    @RelPath(value="bpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_credat;

    @RelPath(value="bpdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_expdat;

    @RelPath(value="bpdgrp.rec.fftamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_fftamt;

    @RelPath(value="bpdgrp.rec.fftcur",dir=DirType.BOTH)
    private String bpdgrp_rec_fftcur;

    @RelPath(value="bpdgrp.rec.fintyp",dir=DirType.BOTH)
    private String bpdgrp_rec_fintyp;

    @RelPath(value="bpdgrp.rec.invamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_invamt;

    @RelPath(value="bpdgrp.rec.invcur",dir=DirType.BOTH)
    private String bpdgrp_rec_invcur;

    @RelPath(value="bpdgrp.rec.invno",dir=DirType.BOTH)
    private String bpdgrp_rec_invno;

    @RelPath(value="bpdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_matdat;

    @RelPath(value="bpdgrp.rec.ownref",dir=DirType.BOTH)
    private String bpdgrp_rec_ownref;

    @RelPath(value="bpdgrp.rec.paytyp",dir=DirType.BOTH)
    private String bpdgrp_rec_paytyp;

    @RelPath(value="bpdgrp.rec.rmbact",dir=DirType.BOTH)
    private String bpdgrp_rec_rmbact;

    @RelPath(value="bpdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String bpdgrp_apl_pts_adrblk;

    @RelPath(value="bpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String bpdgrp_apl_pts_extkey;

    @RelPath(value="bpdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_adrblk;

    @RelPath(value="bpdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_extkey;

    @RelPath(value="bpdgrp.isb.pts.ref",dir=DirType.BOTH)
    private String bpdgrp_isb_pts_ref;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}