package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BrtpayVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="brdgrp.rec.advamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal brdgrp_rec_advamt;

    @RelPath(value="brdgrp.rec.advcur",dir=DirType.BOTH)
    private String brdgrp_rec_advcur;

    @RelPath(value="brdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date brdgrp_rec_advdat;

    @RelPath(value="brdgrp.rec.ddamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal brdgrp_rec_ddamt;

    @RelPath(value="brdgrp.rec.ddcur",dir=DirType.BOTH)
    private String brdgrp_rec_ddcur;

    @RelPath(value="brdgrp.rec.stlref",dir=DirType.BOTH)
    private String brdgrp_rec_stlref;

    @RelPath(value="brdgrp.rec.valdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date brdgrp_rec_valdat;

    @RelPath(value="brdgrp.apl.pts.ref",dir=DirType.BOTH)
    private String brdgrp_apl_pts_ref;

    @RelPath(value="brdgrp.beb.pts.adrblk",dir=DirType.BOTH)
    private String brdgrp_beb_pts_adrblk;

    @RelPath(value="brdgrp.beb.pts.extkey",dir=DirType.BOTH)
    private String brdgrp_beb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}