package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class BrtsndVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="afdgrp.rec.bchcod",dir=DirType.BOTH)
    private String afdgrp_rec_bchcod;

    @RelPath(value="afdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date afdgrp_rec_credat;

    @RelPath(value="afdgrp.rec.oprtyp",dir=DirType.BOTH)
    private String afdgrp_rec_oprtyp;

    @RelPath(value="brdgrp.rec.advamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal brdgrp_rec_advamt;

    @RelPath(value="brdgrp.rec.advcur",dir=DirType.BOTH)
    private String brdgrp_rec_advcur;

    @RelPath(value="brdgrp.rec.relamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal brdgrp_rec_relamt;

    @RelPath(value="brdgrp.rec.relcur",dir=DirType.BOTH)
    private String brdgrp_rec_relcur;

    @RelPath(value="brdgrp.rec.stlref",dir=DirType.BOTH)
    private String brdgrp_rec_stlref;

    @RelPath(value="lidgrp.rec.conno",dir=DirType.BOTH)
    private String lidgrp_rec_conno;

    @RelPath(value="lidgrp.rec.stlref",dir=DirType.BOTH)
    private String lidgrp_rec_stlref;

    @RelPath(value="afdgrp.title",dir=DirType.BOTH)
    private String afdgrp_title;

    @RelPath(value="brdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String brdgrp_apl_pts_adrblk;

    @RelPath(value="brdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String brdgrp_apl_pts_extkey;

    @RelPath(value="brdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String brdgrp_ben_pts_adrblk;

    @RelPath(value="brdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String brdgrp_ben_pts_extkey;

    @RelPath(value="brdgrp.rmi.pts.adrblk",dir=DirType.BOTH)
    private String brdgrp_rmi_pts_adrblk;

    @RelPath(value="brdgrp.rmi.pts.extkey",dir=DirType.BOTH)
    private String brdgrp_rmi_pts_extkey;


}