package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Bsplst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChkameVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bnkchk",dir=DirType.BOTH)
    private String bnkchk;

    @RelPath(value="bsplst",dir=DirType.OUT)
    private ModuleList<Bsplst> bsplst;

    @RelPath(value="btnmod.begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_begdat;

    @RelPath(value="btnmod.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_enddat;

    @RelPath(value="btnmod.ptynam",dir=DirType.BOTH)
    private String btnmod_ptynam;

    @RelPath(value="btnmod.sptlev",dir=DirType.BOTH)
    private String btnmod_sptlev;

    @RelPath(value="btnmod.sptlev1",dir=DirType.BOTH)
    private String btnmod_sptlev1;

    @RelPath(value="btnmod.trntyp",dir=DirType.BOTH)
    private String btnmod_trntyp;

    @RelPath(value="btnmod.ywwtyp",dir=DirType.BOTH)
    private String btnmod_ywwtyp;


}