package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ComadvVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="comgrp.rec.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal comgrp_rec_amt;

    @RelPath(value="comgrp.rec.bnk",dir=DirType.BOTH)
    private String comgrp_rec_bnk;

    @RelPath(value="comgrp.rec.bnktxt",dir=DirType.BOTH)
    private String comgrp_rec_bnktxt;

    @RelPath(value="comgrp.rec.cur",dir=DirType.BOTH)
    private String comgrp_rec_cur;

    @RelPath(value="comgrp.rec.custom",dir=DirType.BOTH)
    private String comgrp_rec_custom;

    @RelPath(value="comgrp.rec.invno",dir=DirType.BOTH)
    private String comgrp_rec_invno;

    @RelPath(value="comgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date comgrp_rec_opndat;

    @RelPath(value="comgrp.rec.stlref",dir=DirType.BOTH)
    private String comgrp_rec_stlref;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}