package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Mxd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CommarVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="margrp.dap.pts.nam",dir=DirType.BOTH)
    private String margrp_dap_pts_nam;

    @RelPath(value="margrp.mar.bchcod",dir=DirType.BOTH)
    private String margrp_mar_bchcod;

    @RelPath(value="margrp.mar.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date margrp_mar_credat;

    @RelPath(value="margrp.mar.note",dir=DirType.BOTH)
    private String margrp_mar_note;

    @RelPath(value="margrp.mar.ref",dir=DirType.BOTH)
    private String margrp_mar_ref;

    @RelPath(value="margrp.mxdlst",dir=DirType.OUT)
    private ModuleList<Mxd> margrp_mxdlst;

    @RelPath(value="marp.dapp.curcus",dir=DirType.BOTH)
    private String marp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}