package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Act;
import com.ceb.gjjs.mda.manager.module.Trncpd;
import com.ceb.gjjs.mda.manager.module.Benpage;
import com.ceb.gjjs.mda.manager.module.Sptall;
import com.ceb.gjjs.mda.manager.module.Rellst;
import com.ceb.gjjs.mda.bo.Bopcod;
import com.ceb.gjjs.mda.manager.module.Ptsplst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ComselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="actlst",dir=DirType.OUT)
    private ModuleList<Act> actlst;

    @RelPath(value="begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date begdat;

    @RelPath(value="bendat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bendat;

    @RelPath(value="benpage",dir=DirType.OUT)
    private ModuleList<Benpage> benpage;

    @RelPath(value="bopcod",dir=DirType.OUT)
    private ModuleList<Bopcod> bopcod;

    @RelPath(value="cur",dir=DirType.BOTH)
    private String cur;

    @RelPath(value="enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date enddat;

    @RelPath(value="extkey",dir=DirType.BOTH)
    private String extkey;

    @RelPath(value="frmcod",dir=DirType.BOTH)
    private String frmcod;

    @RelPath(value="gidsta",dir=DirType.BOTH)
    private String gidsta;

    @RelPath(value="lgtyp",dir=DirType.BOTH)
    private String lgtyp;

    @RelPath(value="nam",dir=DirType.BOTH)
    private String nam;

    @RelPath(value="obendat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date obendat;

    @RelPath(value="oenddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date oenddat;

    @RelPath(value="order",dir=DirType.BOTH)
    private String order;

    @RelPath(value="ownref",dir=DirType.BOTH)
    private String ownref;

    @RelPath(value="ptsplst",dir=DirType.OUT)
    private ModuleList<Ptsplst> ptsplst;

    @RelPath(value="pyeact",dir=DirType.BOTH)
    private String pyeact;

    @RelPath(value="rellst",dir=DirType.OUT)
    private ModuleList<Rellst> rellst;

    @RelPath(value="sptall",dir=DirType.OUT)
    private ModuleList<Sptall> sptall;

    @RelPath(value="stlref",dir=DirType.BOTH)
    private String stlref;

    @RelPath(value="trnhis",dir=DirType.OUT)
    private ModuleList<Trncpd> trnhis;


}