package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptapiVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.countryname",dir=DirType.BOTH)
    private String cpdgrp_rec_countryname;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.dstlref",dir=DirType.BOTH)
    private String cpdgrp_rec_dstlref;

    @RelPath(value="cpdgrp.rec.fmdno",dir=DirType.BOTH)
    private String cpdgrp_rec_fmdno;

    @RelPath(value="cpdgrp.rec.fundpurposedescp",dir=DirType.BOTH)
    private String cpdgrp_rec_fundpurposedescp;

    @RelPath(value="cpdgrp.rec.inoutflg",dir=DirType.BOTH)
    private String cpdgrp_rec_inoutflg;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.payeenameapp",dir=DirType.BOTH)
    private String cpdgrp_rec_payeenameapp;

    @RelPath(value="cpdgrp.rec.payeract",dir=DirType.BOTH)
    private String cpdgrp_rec_payeract;

    @RelPath(value="cpdgrp.rec.paynam",dir=DirType.BOTH)
    private String cpdgrp_rec_paynam;

    @RelPath(value="cpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String cpdgrp_rec_pyeact;

    @RelPath(value="cpdgrp.rec.pyecry",dir=DirType.BOTH)
    private String cpdgrp_rec_pyecry;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.remittype",dir=DirType.BOTH)
    private String cpdgrp_rec_remittype;


}