package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptaplVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.accfs",dir=DirType.BOTH)
    private String cpdgrp_rec_accfs;

    @RelPath(value="cpdgrp.rec.acctflag",dir=DirType.BOTH)
    private String cpdgrp_rec_acctflag;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.bopamt1",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_bopamt1;

    @RelPath(value="cpdgrp.rec.bopamt2",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_bopamt2;

    @RelPath(value="cpdgrp.rec.bopcod1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod1;

    @RelPath(value="cpdgrp.rec.bopcod2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod2;

    @RelPath(value="cpdgrp.rec.bopcur1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur1;

    @RelPath(value="cpdgrp.rec.bopcur2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur2;

    @RelPath(value="cpdgrp.rec.bopinf1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf1;

    @RelPath(value="cpdgrp.rec.bopinf2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf2;

    @RelPath(value="cpdgrp.rec.branchnameapp",dir=DirType.BOTH)
    private String cpdgrp_rec_branchnameapp;

    @RelPath(value="cpdgrp.rec.cnapscodeapp",dir=DirType.BOTH)
    private String cpdgrp_rec_cnapscodeapp;

    @RelPath(value="cpdgrp.rec.countryname",dir=DirType.BOTH)
    private String cpdgrp_rec_countryname;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.cusseq",dir=DirType.BOTH)
    private String cpdgrp_rec_cusseq;

    @RelPath(value="cpdgrp.rec.doclst",dir=DirType.BOTH)
    private String cpdgrp_rec_doclst;

    @RelPath(value="cpdgrp.rec.doctxt",dir=DirType.BOTH)
    private String cpdgrp_rec_doctxt;

    @RelPath(value="cpdgrp.rec.dstlref",dir=DirType.BOTH)
    private String cpdgrp_rec_dstlref;

    @RelPath(value="cpdgrp.rec.fmdno",dir=DirType.BOTH)
    private String cpdgrp_rec_fmdno;

    @RelPath(value="cpdgrp.rec.fundpurposedescp",dir=DirType.BOTH)
    private String cpdgrp_rec_fundpurposedescp;

    @RelPath(value="cpdgrp.rec.inoutflg",dir=DirType.BOTH)
    private String cpdgrp_rec_inoutflg;

    @RelPath(value="cpdgrp.rec.isapply",dir=DirType.BOTH)
    private String cpdgrp_rec_isapply;

    @RelPath(value="cpdgrp.rec.jaccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_jaccamt;

    @RelPath(value="cpdgrp.rec.jacccur",dir=DirType.BOTH)
    private String cpdgrp_rec_jacccur;

    @RelPath(value="cpdgrp.rec.msgref",dir=DirType.BOTH)
    private String cpdgrp_rec_msgref;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.payeenameapp",dir=DirType.BOTH)
    private String cpdgrp_rec_payeenameapp;

    @RelPath(value="cpdgrp.rec.payeetrantype",dir=DirType.BOTH)
    private String cpdgrp_rec_payeetrantype;

    @RelPath(value="cpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String cpdgrp_rec_pyeact;

    @RelPath(value="cpdgrp.rec.pyecry",dir=DirType.BOTH)
    private String cpdgrp_rec_pyecry;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.remittype",dir=DirType.BOTH)
    private String cpdgrp_rec_remittype;

    @RelPath(value="cpdgrp.rec.rmbact",dir=DirType.BOTH)
    private String cpdgrp_rec_rmbact;

    @RelPath(value="cpdgrp.rec.transid",dir=DirType.BOTH)
    private String cpdgrp_rec_transid;

    @RelPath(value="cpdgrp.aplnam",dir=DirType.BOTH)
    private String cpdgrp_aplnam;

    @RelPath(value="cpdgrp.apltel",dir=DirType.BOTH)
    private String cpdgrp_apltel;

    @RelPath(value="cpdgrp.oprnam",dir=DirType.BOTH)
    private String cpdgrp_oprnam;


}