package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Hyimp;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CpthydVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.priority",dir=DirType.BOTH)
    private String cpdgrp_rec_priority;

    @RelPath(value="cpdgrp.rec.rmttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_rmttyp;

    @RelPath(value="cpdgrp.aplnam",dir=DirType.BOTH)
    private String cpdgrp_aplnam;

    @RelPath(value="cpdgrp.apltel",dir=DirType.BOTH)
    private String cpdgrp_apltel;

    @RelPath(value="cptp.hyimp",dir=DirType.OUT)
    private ModuleList<Hyimp> cptp_hyimp;


}