package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Invlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CpthyfVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.atccod",dir=DirType.BOTH)
    private String cpdgrp_rec_atccod;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.bopamt1",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_bopamt1;

    @RelPath(value="cpdgrp.rec.bopcur1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur1;

    @RelPath(value="cpdgrp.rec.bopinf1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf1;

    @RelPath(value="cpdgrp.rec.cavpayflg",dir=DirType.BOTH)
    private String cpdgrp_rec_cavpayflg;

    @RelPath(value="cpdgrp.rec.conno",dir=DirType.BOTH)
    private String cpdgrp_rec_conno;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.detchgcod",dir=DirType.BOTH)
    private String cpdgrp_rec_detchgcod;

    @RelPath(value="cpdgrp.rec.fxact",dir=DirType.BOTH)
    private String cpdgrp_rec_fxact;

    @RelPath(value="cpdgrp.rec.fxamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_fxamt;

    @RelPath(value="cpdgrp.rec.fxflg",dir=DirType.BOTH)
    private String cpdgrp_rec_fxflg;

    @RelPath(value="cpdgrp.rec.invno",dir=DirType.BOTH)
    private String cpdgrp_rec_invno;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.paytyp",dir=DirType.BOTH)
    private String cpdgrp_rec_paytyp;

    @RelPath(value="cpdgrp.rec.paytyptxt",dir=DirType.BOTH)
    private String cpdgrp_rec_paytyptxt;

    @RelPath(value="cpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String cpdgrp_rec_pyeact;

    @RelPath(value="cpdgrp.rec.pyecry",dir=DirType.BOTH)
    private String cpdgrp_rec_pyecry;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.rmttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_rmttyp;

    @RelPath(value="cpdgrp.acw.pts.adr",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_adr;

    @RelPath(value="cpdgrp.acw.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_extkey;

    @RelPath(value="cpdgrp.acw.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_nam;

    @RelPath(value="cpdgrp.apl.pts.adr",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_adr;

    @RelPath(value="cpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_extkey;

    @RelPath(value="cpdgrp.apl.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_nam;

    @RelPath(value="cpdgrp.aplnam",dir=DirType.BOTH)
    private String cpdgrp_aplnam;

    @RelPath(value="cpdgrp.apltel",dir=DirType.BOTH)
    private String cpdgrp_apltel;

    @RelPath(value="cpdgrp.ben.pts.adr",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_adr;

    @RelPath(value="cpdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_extkey;

    @RelPath(value="cpdgrp.ben.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_nam;

    @RelPath(value="cpdgrp.bopcod",dir=DirType.BOTH)
    private String cpdgrp_bopcod;

    @RelPath(value="cpdgrp.ctydes",dir=DirType.BOTH)
    private String cpdgrp_ctydes;

    @RelPath(value="cpdgrp.oprnam",dir=DirType.BOTH)
    private String cpdgrp_oprnam;

    @RelPath(value="cpdgrp.rcp.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_nam;

    @RelPath(value="cptp.cptlab",dir=DirType.BOTH)
    private String cptp_cptlab;

    @RelPath(value="cptp.cur",dir=DirType.BOTH)
    private String cptp_cur;

    @RelPath(value="cptp.invl.invlst",dir=DirType.OUT)
    private ModuleList<Invlst> cptp_invl_invlst;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}