package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Cimp;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptimpVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.atccod",dir=DirType.BOTH)
    private String cpdgrp_rec_atccod;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.bopcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.priority",dir=DirType.BOTH)
    private String cpdgrp_rec_priority;

    @RelPath(value="cpdgrp.rec.rmttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_rmttyp;

    @RelPath(value="cpdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_adrblk;

    @RelPath(value="cpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_extkey;

    @RelPath(value="cpdgrp.aplnam",dir=DirType.BOTH)
    private String cpdgrp_aplnam;

    @RelPath(value="cpdgrp.apltel",dir=DirType.BOTH)
    private String cpdgrp_apltel;

    @RelPath(value="cpdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_dap_pts_nam;

    @RelPath(value="cpdgrp.epsptynam",dir=DirType.BOTH)
    private String cpdgrp_epsptynam;

    @RelPath(value="cpdgrp.implst",dir=DirType.OUT)
    private ModuleList<Cimp> cpdgrp_implst;

    @RelPath(value="cpdgrp.label",dir=DirType.BOTH)
    private String cpdgrp_label;

    @RelPath(value="cptp.dapp.curcus",dir=DirType.BOTH)
    private String cptp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}