package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Apyctm;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.acttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_acttyp;

    @RelPath(value="cpdgrp.rec.atccod",dir=DirType.BOTH)
    private String cpdgrp_rec_atccod;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.bopamt1",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_bopamt1;

    @RelPath(value="cpdgrp.rec.bopamt2",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_bopamt2;

    @RelPath(value="cpdgrp.rec.bopcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod;

    @RelPath(value="cpdgrp.rec.bopcod1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod1;

    @RelPath(value="cpdgrp.rec.bopcod2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcod2;

    @RelPath(value="cpdgrp.rec.bopcur1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur1;

    @RelPath(value="cpdgrp.rec.bopcur2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur2;

    @RelPath(value="cpdgrp.rec.bopinf1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf1;

    @RelPath(value="cpdgrp.rec.bopinf2",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf2;

    @RelPath(value="cpdgrp.rec.bopno",dir=DirType.BOTH)
    private String cpdgrp_rec_bopno;

    @RelPath(value="cpdgrp.rec.cavpayflg",dir=DirType.BOTH)
    private String cpdgrp_rec_cavpayflg;

    @RelPath(value="cpdgrp.rec.conno",dir=DirType.BOTH)
    private String cpdgrp_rec_conno;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.cusseq",dir=DirType.BOTH)
    private String cpdgrp_rec_cusseq;

    @RelPath(value="cpdgrp.rec.detchgcod",dir=DirType.BOTH)
    private String cpdgrp_rec_detchgcod;

    @RelPath(value="cpdgrp.rec.feeactno",dir=DirType.BOTH)
    private String cpdgrp_rec_feeactno;

    @RelPath(value="cpdgrp.rec.fmdno",dir=DirType.BOTH)
    private String cpdgrp_rec_fmdno;

    @RelPath(value="cpdgrp.rec.fxact",dir=DirType.BOTH)
    private String cpdgrp_rec_fxact;

    @RelPath(value="cpdgrp.rec.fxamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_fxamt;

    @RelPath(value="cpdgrp.rec.fxflg",dir=DirType.BOTH)
    private String cpdgrp_rec_fxflg;

    @RelPath(value="cpdgrp.rec.inoutflg",dir=DirType.BOTH)
    private String cpdgrp_rec_inoutflg;

    @RelPath(value="cpdgrp.rec.invno",dir=DirType.BOTH)
    private String cpdgrp_rec_invno;

    @RelPath(value="cpdgrp.rec.msgref",dir=DirType.BOTH)
    private String cpdgrp_rec_msgref;

    @RelPath(value="cpdgrp.rec.othact",dir=DirType.BOTH)
    private String cpdgrp_rec_othact;

    @RelPath(value="cpdgrp.rec.othamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_othamt;

    @RelPath(value="cpdgrp.rec.othflg",dir=DirType.BOTH)
    private String cpdgrp_rec_othflg;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.paytyp",dir=DirType.BOTH)
    private String cpdgrp_rec_paytyp;

    @RelPath(value="cpdgrp.rec.paytyptxt",dir=DirType.BOTH)
    private String cpdgrp_rec_paytyptxt;

    @RelPath(value="cpdgrp.rec.priority",dir=DirType.BOTH)
    private String cpdgrp_rec_priority;

    @RelPath(value="cpdgrp.rec.puract",dir=DirType.BOTH)
    private String cpdgrp_rec_puract;

    @RelPath(value="cpdgrp.rec.puramt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_puramt;

    @RelPath(value="cpdgrp.rec.purflg",dir=DirType.BOTH)
    private String cpdgrp_rec_purflg;

    @RelPath(value="cpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String cpdgrp_rec_pyeact;

    @RelPath(value="cpdgrp.rec.pyecry",dir=DirType.BOTH)
    private String cpdgrp_rec_pyecry;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.reminf",dir=DirType.BOTH)
    private String cpdgrp_rec_reminf;

    @RelPath(value="cpdgrp.rec.remitpaymentdate",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_remitpaymentdate;

    @RelPath(value="cpdgrp.rec.rmttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_rmttyp;

    @RelPath(value="cpdgrp.rec.socialcrdtcd",dir=DirType.BOTH)
    private String cpdgrp_rec_socialcrdtcd;

    @RelPath(value="cpdgrp.rec.word",dir=DirType.BOTH)
    private String cpdgrp_rec_word;

    @RelPath(value="cpdgrp.rec.wyghedno",dir=DirType.BOTH)
    private String cpdgrp_rec_wyghedno;

    @RelPath(value="cpdgrp.rec.xhghchk",dir=DirType.BOTH)
    private String cpdgrp_rec_xhghchk;

    @RelPath(value="cpdgrp.rec.zjly",dir=DirType.BOTH)
    private String cpdgrp_rec_zjly;

    @RelPath(value="cpdgrp.acw.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_adrblk;

    @RelPath(value="cpdgrp.acw.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_extkey;

    @RelPath(value="cpdgrp.aplnam",dir=DirType.BOTH)
    private String cpdgrp_aplnam;

    @RelPath(value="cpdgrp.apltel",dir=DirType.BOTH)
    private String cpdgrp_apltel;

    @RelPath(value="cpdgrp.apyctmlst",dir=DirType.OUT)
    private ModuleList<Apyctm> cpdgrp_apyctmlst;

    @RelPath(value="cpdgrp.ctydes",dir=DirType.BOTH)
    private String cpdgrp_ctydes;

    @RelPath(value="cpdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_dap_pts_nam;

    @RelPath(value="cpdgrp.oprnam",dir=DirType.BOTH)
    private String cpdgrp_oprnam;

    @RelPath(value="cpdgrp.pay.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_pay_pts_adrblk;

    @RelPath(value="cpdgrp.pay.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_pay_pts_extkey;

    @RelPath(value="cpdgrp.rcp.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_adrblk;

    @RelPath(value="cpdgrp.rcp.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_extkey;

    @RelPath(value="cpdgrp.rcp.pts.ref",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_ref;

    @RelPath(value="cptp.cptlab",dir=DirType.BOTH)
    private String cptp_cptlab;

    @RelPath(value="cptp.cur",dir=DirType.BOTH)
    private String cptp_cur;

    @RelPath(value="cptp.cur1",dir=DirType.BOTH)
    private String cptp_cur1;

    @RelPath(value="cptp.cur2",dir=DirType.BOTH)
    private String cptp_cur2;

    @RelPath(value="cptp.dapp.curcus",dir=DirType.BOTH)
    private String cptp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}