package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Cpd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptopsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_accamt;

    @RelPath(value="cpdgrp.rec.acccur",dir=DirType.BOTH)
    private String cpdgrp_rec_acccur;

    @RelPath(value="cpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String cpdgrp_rec_bchcod;

    @RelPath(value="cpdgrp.rec.bopinf1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopinf1;

    @RelPath(value="cpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_credat;

    @RelPath(value="cpdgrp.rec.detchgcod",dir=DirType.BOTH)
    private String cpdgrp_rec_detchgcod;

    @RelPath(value="cpdgrp.rec.freamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_freamt;

    @RelPath(value="cpdgrp.rec.frecur",dir=DirType.BOTH)
    private String cpdgrp_rec_frecur;

    @RelPath(value="cpdgrp.rec.gframt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_gframt;

    @RelPath(value="cpdgrp.rec.gfrcur",dir=DirType.BOTH)
    private String cpdgrp_rec_gfrcur;

    @RelPath(value="cpdgrp.rec.lnkman",dir=DirType.BOTH)
    private String cpdgrp_rec_lnkman;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.rat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal cpdgrp_rec_rat;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.reminf",dir=DirType.BOTH)
    private String cpdgrp_rec_reminf;

    @RelPath(value="cpdgrp.rec.swifttyp",dir=DirType.BOTH)
    private String cpdgrp_rec_swifttyp;

    @RelPath(value="cpdgrp.acw.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_adrblk;

    @RelPath(value="cpdgrp.acw.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_extkey;

    @RelPath(value="cpdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_adrblk;

    @RelPath(value="cpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_extkey;

    @RelPath(value="cpdgrp.apl.pts.ref",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_ref;

    @RelPath(value="cpdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_adrblk;

    @RelPath(value="cpdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_extkey;

    @RelPath(value="cpdgrp.cpdlst",dir=DirType.OUT)
    private ModuleList<Cpd> cpdgrp_cpdlst;

    @RelPath(value="cpdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_dap_pts_nam;

    @RelPath(value="cpdgrp.pay.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_pay_pts_adrblk;

    @RelPath(value="cpdgrp.pay.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_pay_pts_extkey;

    @RelPath(value="cpdgrp.rcp.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_adrblk;

    @RelPath(value="cpdgrp.rcp.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_rcp_pts_extkey;

    @RelPath(value="cpdgrp.tel",dir=DirType.BOTH)
    private String cpdgrp_tel;

    @RelPath(value="cptp.dapp.curcus",dir=DirType.BOTH)
    private String cptp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}