package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptoutVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_advdat;

    @RelPath(value="cpdgrp.rec.detchgcod",dir=DirType.BOTH)
    private String cpdgrp_rec_detchgcod;

    @RelPath(value="cpdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_opndat;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.stlref",dir=DirType.BOTH)
    private String cpdgrp_rec_stlref;

    @RelPath(value="cpdgrp.rec.trsmak",dir=DirType.BOTH)
    private String cpdgrp_rec_trsmak;

    @RelPath(value="cpdgrp.acw.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_adrblk;

    @RelPath(value="cpdgrp.acw.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_acw_pts_extkey;

    @RelPath(value="cpdgrp.ben.pts.nam",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_nam;

    @RelPath(value="cpdgrp.ben.pts.ref",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_ref;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}