package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptsubVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_accamt;

    @RelPath(value="cpdgrp.rec.acccur",dir=DirType.BOTH)
    private String cpdgrp_rec_acccur;

    @RelPath(value="cpdgrp.rec.accno",dir=DirType.BOTH)
    private String cpdgrp_rec_accno;

    @RelPath(value="cpdgrp.rec.bopcur1",dir=DirType.BOTH)
    private String cpdgrp_rec_bopcur1;

    @RelPath(value="cpdgrp.rec.detchgcod",dir=DirType.BOTH)
    private String cpdgrp_rec_detchgcod;

    @RelPath(value="cpdgrp.rec.dstlref",dir=DirType.BOTH)
    private String cpdgrp_rec_dstlref;

    @RelPath(value="cpdgrp.rec.fxact",dir=DirType.BOTH)
    private String cpdgrp_rec_fxact;

    @RelPath(value="cpdgrp.rec.fxamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_fxamt;

    @RelPath(value="cpdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_opndat;

    @RelPath(value="cpdgrp.rec.ownref",dir=DirType.BOTH)
    private String cpdgrp_rec_ownref;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="cpdgrp.rec.reminf",dir=DirType.BOTH)
    private String cpdgrp_rec_reminf;

    @RelPath(value="cpdgrp.rec.stlref",dir=DirType.BOTH)
    private String cpdgrp_rec_stlref;

    @RelPath(value="cpdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_adrblk;

    @RelPath(value="cpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_apl_pts_extkey;

    @RelPath(value="cpdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_adrblk;

    @RelPath(value="cpdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String cpdgrp_ben_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}