package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class CptyubVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cpdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cpdgrp_rec_advdat;

    @RelPath(value="cpdgrp.rec.dstlref",dir=DirType.BOTH)
    private String cpdgrp_rec_dstlref;

    @RelPath(value="cpdgrp.rec.isexist",dir=DirType.BOTH)
    private String cpdgrp_rec_isexist;

    @RelPath(value="cpdgrp.rec.payeeentmarkno",dir=DirType.BOTH)
    private String cpdgrp_rec_payeeentmarkno;

    @RelPath(value="cpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String cpdgrp_rec_pyeact;

    @RelPath(value="cpdgrp.rec.remamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal cpdgrp_rec_remamt;

    @RelPath(value="cpdgrp.rec.remcur",dir=DirType.BOTH)
    private String cpdgrp_rec_remcur;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}