package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Ptyaut;
import com.ceb.gjjs.mda.bo.Modlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DbmrelVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="autgrp.modlstlst",dir=DirType.OUT)
    private ModuleList<Modlst> autgrp_modlstlst;

    @RelPath(value="autgrp.shwaut",dir=DirType.OUT)
    private ModuleList<Ptyaut> autgrp_shwaut;

    @RelPath(value="autp.bchnam",dir=DirType.BOTH)
    private String autp_bchnam;

    @RelPath(value="autp.frmnam",dir=DirType.BOTH)
    private String autp_frmnam;

    @RelPath(value="autp.mgrflg",dir=DirType.BOTH)
    private String autp_mgrflg;

    @RelPath(value="autp.mgrflg2",dir=DirType.BOTH)
    private String autp_mgrflg2;

    @RelPath(value="autp.relflg",dir=DirType.BOTH)
    private String autp_relflg;

    @RelPath(value="autp.relflg2",dir=DirType.BOTH)
    private String autp_relflg2;

    @RelPath(value="autp.sptflg",dir=DirType.BOTH)
    private String autp_sptflg;

    @RelPath(value="autp.sptflg2",dir=DirType.BOTH)
    private String autp_sptflg2;


}