package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DetameVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="dedgrp.rec.amedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_amedat;

    @RelPath(value="dedgrp.rec.amenbr",dir=DirType.BOTH)
    private int dedgrp_rec_amenbr;

    @RelPath(value="dedgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_credat;

    @RelPath(value="dedgrp.rec.expamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_expamedat;

    @RelPath(value="dedgrp.rec.lccameamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal dedgrp_rec_lccameamt;

    @RelPath(value="dedgrp.rec.lcccur",dir=DirType.BOTH)
    private String dedgrp_rec_lcccur;

    @RelPath(value="dedgrp.rec.shpamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_shpamedat;

    @RelPath(value="dedgrp.rec.stlref",dir=DirType.BOTH)
    private String dedgrp_rec_stlref;

    @RelPath(value="dedgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_apl_pts_adrblk;

    @RelPath(value="dedgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_apl_pts_extkey;

    @RelPath(value="dedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_isb_pts_adrblk;

    @RelPath(value="dedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_isb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}