package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DetcanVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="dedgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_advdat;

    @RelPath(value="dedgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date dedgrp_rec_expdat;

    @RelPath(value="dedgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal dedgrp_rec_lccamt;

    @RelPath(value="dedgrp.rec.lcccur",dir=DirType.BOTH)
    private String dedgrp_rec_lcccur;

    @RelPath(value="dedgrp.rec.stlref",dir=DirType.BOTH)
    private String dedgrp_rec_stlref;

    @RelPath(value="dedgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_apl_pts_adrblk;

    @RelPath(value="dedgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_apl_pts_extkey;

    @RelPath(value="dedgrp.apl.pts.ref",dir=DirType.BOTH)
    private String dedgrp_apl_pts_ref;

    @RelPath(value="dedgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_ben_pts_adrblk;

    @RelPath(value="dedgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_ben_pts_extkey;

    @RelPath(value="dedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String dedgrp_isb_pts_adrblk;

    @RelPath(value="dedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String dedgrp_isb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}