package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DetfrdVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="afdgrp.rec.bchcod",dir=DirType.BOTH)
    private String afdgrp_rec_bchcod;

    @RelPath(value="afdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date afdgrp_rec_credat;

    @RelPath(value="afdgrp.rec.oprtxt",dir=DirType.BOTH)
    private String afdgrp_rec_oprtxt;

    @RelPath(value="afdgrp.rec.oprtyp",dir=DirType.BOTH)
    private String afdgrp_rec_oprtyp;

    @RelPath(value="bmdgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bmdgrp_rec_docamt;

    @RelPath(value="bmdgrp.rec.doccur",dir=DirType.BOTH)
    private String bmdgrp_rec_doccur;

    @RelPath(value="bmdgrp.rec.invno",dir=DirType.BOTH)
    private String bmdgrp_rec_invno;

    @RelPath(value="bmdgrp.rec.pntref",dir=DirType.BOTH)
    private String bmdgrp_rec_pntref;

    @RelPath(value="bmdgrp.rec.stlref",dir=DirType.BOTH)
    private String bmdgrp_rec_stlref;

    @RelPath(value="bmdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String bmdgrp_apl_pts_adrblk;

    @RelPath(value="bmdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String bmdgrp_apl_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}