package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DitdamVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="didgrp.rec.amenbr",dir=DirType.BOTH)
    private int didgrp_rec_amenbr;

    @RelPath(value="didgrp.rec.bchcod",dir=DirType.BOTH)
    private String didgrp_rec_bchcod;

    @RelPath(value="didgrp.rec.chrgameby",dir=DirType.BOTH)
    private String didgrp_rec_chrgameby;

    @RelPath(value="didgrp.rec.creamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_creamedat;

    @RelPath(value="didgrp.rec.decamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_decamt;

    @RelPath(value="didgrp.rec.details",dir=DirType.BOTH)
    private String didgrp_rec_details;

    @RelPath(value="didgrp.rec.expamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_expamedat;

    @RelPath(value="didgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_expdat;

    @RelPath(value="didgrp.rec.incamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_incamt;

    @RelPath(value="didgrp.rec.issameamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_issameamt;

    @RelPath(value="didgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_issamt;

    @RelPath(value="didgrp.rec.isscur",dir=DirType.BOTH)
    private String didgrp_rec_isscur;

    @RelPath(value="didgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_opndat;

    @RelPath(value="didgrp.rec.ownref",dir=DirType.BOTH)
    private String didgrp_rec_ownref;

    @RelPath(value="didgrp.rec.shpamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_shpamedat;

    @RelPath(value="didgrp.rec.shpamefro",dir=DirType.BOTH)
    private String didgrp_rec_shpamefro;

    @RelPath(value="didgrp.rec.shpameto",dir=DirType.BOTH)
    private String didgrp_rec_shpameto;

    @RelPath(value="didgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_shpdat;

    @RelPath(value="didgrp.rec.shpfro",dir=DirType.BOTH)
    private String didgrp_rec_shpfro;

    @RelPath(value="didgrp.rec.shpto",dir=DirType.BOTH)
    private String didgrp_rec_shpto;

    @RelPath(value="didgrp.rec.sndtyp",dir=DirType.BOTH)
    private String didgrp_rec_sndtyp;

    @RelPath(value="didgrp.rec.stlref",dir=DirType.BOTH)
    private String didgrp_rec_stlref;

    @RelPath(value="didgrp.apl.pty.nam",dir=DirType.BOTH)
    private String didgrp_apl_pty_nam;

    @RelPath(value="didgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_ben_pts_adrblk;

    @RelPath(value="didgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String didgrp_ben_pts_extkey;

    @RelPath(value="didgrp.mben.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_mben_pts_adrblk;

    @RelPath(value="didgrp.mben.pts.extkey",dir=DirType.BOTH)
    private String didgrp_mben_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}