package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DitdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="didgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_advdat;

    @RelPath(value="didgrp.rec.conno",dir=DirType.BOTH)
    private String didgrp_rec_conno;

    @RelPath(value="didgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_expdat;

    @RelPath(value="didgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_issamt;

    @RelPath(value="didgrp.rec.isscur",dir=DirType.BOTH)
    private String didgrp_rec_isscur;

    @RelPath(value="didgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_opndat;

    @RelPath(value="didgrp.rec.tenor",dir=DirType.BOTH)
    private String didgrp_rec_tenor;

    @RelPath(value="didgrp.adv.pts.adr",dir=DirType.BOTH)
    private String didgrp_adv_pts_adr;

    @RelPath(value="didgrp.adv.pts.bakcode",dir=DirType.BOTH)
    private String didgrp_adv_pts_bakcode;

    @RelPath(value="didgrp.adv.pts.nam",dir=DirType.BOTH)
    private String didgrp_adv_pts_nam;

    @RelPath(value="didgrp.apl.pts.ref",dir=DirType.BOTH)
    private String didgrp_apl_pts_ref;

    @RelPath(value="didgrp.ben.pts.adr",dir=DirType.BOTH)
    private String didgrp_ben_pts_adr;

    @RelPath(value="didgrp.ben.pts.nam",dir=DirType.BOTH)
    private String didgrp_ben_pts_nam;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}