package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class DitdopVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="didgrp.rec.avbby",dir=DirType.BOTH)
    private String didgrp_rec_avbby;

    @RelPath(value="didgrp.rec.bchcod",dir=DirType.BOTH)
    private String didgrp_rec_bchcod;

    @RelPath(value="didgrp.rec.cnfdet",dir=DirType.BOTH)
    private String didgrp_rec_cnfdet;

    @RelPath(value="didgrp.rec.conno",dir=DirType.BOTH)
    private String didgrp_rec_conno;

    @RelPath(value="didgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_credat;

    @RelPath(value="didgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_expdat;

    @RelPath(value="didgrp.rec.expplc",dir=DirType.BOTH)
    private String didgrp_rec_expplc;

    @RelPath(value="didgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal didgrp_rec_issamt;

    @RelPath(value="didgrp.rec.isscur",dir=DirType.BOTH)
    private String didgrp_rec_isscur;

    @RelPath(value="didgrp.rec.issinf",dir=DirType.BOTH)
    private String didgrp_rec_issinf;

    @RelPath(value="didgrp.rec.lcrtyp",dir=DirType.BOTH)
    private String didgrp_rec_lcrtyp;

    @RelPath(value="didgrp.rec.nomflg",dir=DirType.BOTH)
    private String didgrp_rec_nomflg;

    @RelPath(value="didgrp.rec.nomton",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(5)
    private BigDecimal didgrp_rec_nomton;

    @RelPath(value="didgrp.rec.nomtop",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(5)
    private BigDecimal didgrp_rec_nomtop;

    @RelPath(value="didgrp.rec.ownref",dir=DirType.BOTH)
    private String didgrp_rec_ownref;

    @RelPath(value="didgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date didgrp_rec_shpdat;

    @RelPath(value="didgrp.rec.shpfro",dir=DirType.BOTH)
    private String didgrp_rec_shpfro;

    @RelPath(value="didgrp.rec.shppar",dir=DirType.BOTH)
    private String didgrp_rec_shppar;

    @RelPath(value="didgrp.rec.shpto",dir=DirType.BOTH)
    private String didgrp_rec_shpto;

    @RelPath(value="didgrp.rec.shptrs",dir=DirType.BOTH)
    private String didgrp_rec_shptrs;

    @RelPath(value="didgrp.rec.tratyp",dir=DirType.BOTH)
    private String didgrp_rec_tratyp;

    @RelPath(value="didgrp.rec.trndet",dir=DirType.BOTH)
    private String didgrp_rec_trndet;

    @RelPath(value="didgrp.adt.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_adt_pts_adrblk;

    @RelPath(value="didgrp.adt.pts.extkey",dir=DirType.BOTH)
    private String didgrp_adt_pts_extkey;

    @RelPath(value="didgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_adv_pts_adrblk;

    @RelPath(value="didgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String didgrp_adv_pts_extkey;

    @RelPath(value="didgrp.agree",dir=DirType.BOTH)
    private String didgrp_agree;

    @RelPath(value="didgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_apl_pts_adrblk;

    @RelPath(value="didgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String didgrp_apl_pts_extkey;

    @RelPath(value="didgrp.apl.pts.nam",dir=DirType.BOTH)
    private String didgrp_apl_pts_nam;

    @RelPath(value="didgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_ben_pts_adrblk;

    @RelPath(value="didgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String didgrp_ben_pts_extkey;

    @RelPath(value="didgrp.blk.adlcnd",dir=DirType.BOTH)
    private String didgrp_blk_adlcnd;

    @RelPath(value="didgrp.blk.defdet",dir=DirType.BOTH)
    private String didgrp_blk_defdet;

    @RelPath(value="didgrp.blk.lcrdoc",dir=DirType.BOTH)
    private String didgrp_blk_lcrdoc;

    @RelPath(value="didgrp.blk.lcrgod",dir=DirType.BOTH)
    private String didgrp_blk_lcrgod;

    @RelPath(value="didgrp.blk.preper",dir=DirType.BOTH)
    private String didgrp_blk_preper;

    @RelPath(value="didgrp.blk.rgtcls",dir=DirType.BOTH)
    private String didgrp_blk_rgtcls;

    @RelPath(value="didgrp.blk.word",dir=DirType.BOTH)
    private String didgrp_blk_word;

    @RelPath(value="didgrp.con.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_con_pts_adrblk;

    @RelPath(value="didgrp.con.pts.extkey",dir=DirType.BOTH)
    private String didgrp_con_pts_extkey;

    @RelPath(value="didgrp.dap.pts.nam",dir=DirType.BOTH)
    private String didgrp_dap_pts_nam;

    @RelPath(value="didgrp.neg.pts.adrblk",dir=DirType.BOTH)
    private String didgrp_neg_pts_adrblk;

    @RelPath(value="didgrp.neg.pts.extkey",dir=DirType.BOTH)
    private String didgrp_neg_pts_extkey;

    @RelPath(value="ditp.dapp.curcus",dir=DirType.BOTH)
    private String ditp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}