package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Ers;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ErsselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ersp.bchcod",dir=DirType.BOTH)
    private String ersp_bchcod;

    @RelPath(value="ersp.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ersp_credat;

    @RelPath(value="ersp.dir",dir=DirType.BOTH)
    private String ersp_dir;

    @RelPath(value="ersp.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ersp_enddat;

    @RelPath(value="ersp.erslst",dir=DirType.OUT)
    private ModuleList<Ers> ersp_erslst;

    @RelPath(value="ersp.hnglbh",dir=DirType.BOTH)
    private String ersp_hnglbh;

    @RelPath(value="ersp.mattyp",dir=DirType.BOTH)
    private String ersp_mattyp;

    @RelPath(value="ersp.msgtyp",dir=DirType.BOTH)
    private String ersp_msgtyp;

    @RelPath(value="ersp.ownref",dir=DirType.BOTH)
    private String ersp_ownref;

    @RelPath(value="ersp.recsta",dir=DirType.BOTH)
    private String ersp_recsta;

    @RelPath(value="ersp.relref",dir=DirType.BOTH)
    private String ersp_relref;


}