package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Fsq;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FeqapiVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="feqgrp.fsqlst",dir=DirType.OUT)
    private ModuleList<Fsq> feqgrp_fsqlst;

    @RelPath(value="feqtp.applystatus",dir=DirType.BOTH)
    private String feqtp_applystatus;

    @RelPath(value="feqtp.applytyp",dir=DirType.BOTH)
    private String feqtp_applytyp;

    @RelPath(value="feqtp.busino",dir=DirType.BOTH)
    private String feqtp_busino;

    @RelPath(value="feqtp.cur",dir=DirType.BOTH)
    private String feqtp_cur;

    @RelPath(value="feqtp.ptynam",dir=DirType.BOTH)
    private String feqtp_ptynam;

    @RelPath(value="feqtp.sqbegdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqtp_sqbegdat;

    @RelPath(value="feqtp.sqendbat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqtp_sqendbat;

    @RelPath(value="feqtp.zcghbegdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqtp_zcghbegdat;

    @RelPath(value="feqtp.zcghenddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqtp_zcghenddat;


}