package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Shd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FeqcxsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="cxsgrp.shdlst",dir=DirType.OUT)
    private ModuleList<Shd> cxsgrp_shdlst;

    @RelPath(value="cxstp.businessno",dir=DirType.BOTH)
    private String cxstp_businessno;

    @RelPath(value="cxstp.ecifno",dir=DirType.BOTH)
    private String cxstp_ecifno;

    @RelPath(value="cxstp.eduflag",dir=DirType.BOTH)
    private String cxstp_eduflag;

    @RelPath(value="cxstp.enterdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cxstp_enterdat;

    @RelPath(value="cxstp.guid",dir=DirType.BOTH)
    private String cxstp_guid;

    @RelPath(value="cxstp.jiehsign",dir=DirType.BOTH)
    private String cxstp_jiehsign;

    @RelPath(value="cxstp.reores",dir=DirType.BOTH)
    private String cxstp_reores;

    @RelPath(value="cxstp.serialnum",dir=DirType.BOTH)
    private String cxstp_serialnum;

    @RelPath(value="cxstp.zcghdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date cxstp_zcghdat;


}