package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Shd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FeqopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="feqgrp.rec.appid",dir=DirType.BOTH)
    private String feqgrp_rec_appid;

    @RelPath(value="feqgrp.rec.applydat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqgrp_rec_applydat;

    @RelPath(value="feqgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqgrp_rec_credat;

    @RelPath(value="feqgrp.rec.currency",dir=DirType.BOTH)
    private String feqgrp_rec_currency;

    @RelPath(value="feqgrp.rec.cuswbzh",dir=DirType.BOTH)
    private String feqgrp_rec_cuswbzh;

    @RelPath(value="feqgrp.rec.cuswbzhname",dir=DirType.BOTH)
    private String feqgrp_rec_cuswbzhname;

    @RelPath(value="feqgrp.rec.ecifname",dir=DirType.BOTH)
    private String feqgrp_rec_ecifname;

    @RelPath(value="feqgrp.rec.ecifno",dir=DirType.BOTH)
    private String feqgrp_rec_ecifno;

    @RelPath(value="feqgrp.rec.enterdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqgrp_rec_enterdat;

    @RelPath(value="feqgrp.rec.gjszsbno",dir=DirType.BOTH)
    private String feqgrp_rec_gjszsbno;

    @RelPath(value="feqgrp.rec.guid",dir=DirType.BOTH)
    private String feqgrp_rec_guid;

    @RelPath(value="feqgrp.rec.inr",dir=DirType.BOTH)
    private String feqgrp_rec_inr;

    @RelPath(value="feqgrp.rec.jieshtjno",dir=DirType.BOTH)
    private String feqgrp_rec_jieshtjno;

    @RelPath(value="feqgrp.rec.operatorname",dir=DirType.BOTH)
    private String feqgrp_rec_operatorname;

    @RelPath(value="feqgrp.rec.operatortel",dir=DirType.BOTH)
    private String feqgrp_rec_operatortel;

    @RelPath(value="feqgrp.rec.orgcode",dir=DirType.BOTH)
    private String feqgrp_rec_orgcode;

    @RelPath(value="feqgrp.rec.orgname",dir=DirType.BOTH)
    private String feqgrp_rec_orgname;

    @RelPath(value="feqgrp.rec.paysum",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal feqgrp_rec_paysum;

    @RelPath(value="feqgrp.rec.paytype",dir=DirType.BOTH)
    private String feqgrp_rec_paytype;

    @RelPath(value="feqgrp.rec.postscript",dir=DirType.BOTH)
    private String feqgrp_rec_postscript;

    @RelPath(value="feqgrp.rec.remark",dir=DirType.BOTH)
    private String feqgrp_rec_remark;

    @RelPath(value="feqgrp.rec.salexz",dir=DirType.BOTH)
    private String feqgrp_rec_salexz;

    @RelPath(value="feqgrp.rec.serialnum",dir=DirType.BOTH)
    private String feqgrp_rec_serialnum;

    @RelPath(value="feqgrp.rec.whjno",dir=DirType.BOTH)
    private String feqgrp_rec_whjno;

    @RelPath(value="feqgrp.rec.zcghdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date feqgrp_rec_zcghdat;

    @RelPath(value="feqgrp.shdlst",dir=DirType.OUT)
    private ModuleList<Shd> feqgrp_shdlst;


}