package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FftapnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.acpamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_acpamt;

    @RelPath(value="bedgrp.rec.acpcur",dir=DirType.BOTH)
    private String bedgrp_rec_acpcur;

    @RelPath(value="bedgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_issamt;

    @RelPath(value="bedgrp.rec.isscur",dir=DirType.BOTH)
    private String bedgrp_rec_isscur;

    @RelPath(value="bedgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_matdat;

    @RelPath(value="bedgrp.rec.stlref",dir=DirType.BOTH)
    private String bedgrp_rec_stlref;

    @RelPath(value="fsdgrp.rec.acdamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_acdamt;

    @RelPath(value="fsdgrp.rec.acdcur",dir=DirType.BOTH)
    private String fsdgrp_rec_acdcur;

    @RelPath(value="fsdgrp.rec.agrmntno",dir=DirType.BOTH)
    private String fsdgrp_rec_agrmntno;

    @RelPath(value="fsdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fsdgrp_rec_bchcod;

    @RelPath(value="fsdgrp.rec.billno",dir=DirType.BOTH)
    private String fsdgrp_rec_billno;

    @RelPath(value="fsdgrp.rec.brkamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_brkamt;

    @RelPath(value="fsdgrp.rec.brkcur",dir=DirType.BOTH)
    private String fsdgrp_rec_brkcur;

    @RelPath(value="fsdgrp.rec.conamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_conamt;

    @RelPath(value="fsdgrp.rec.concur",dir=DirType.BOTH)
    private String fsdgrp_rec_concur;

    @RelPath(value="fsdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_credat;

    @RelPath(value="fsdgrp.rec.enttyp",dir=DirType.BOTH)
    private String fsdgrp_rec_enttyp;

    @RelPath(value="fsdgrp.rec.lctyp",dir=DirType.BOTH)
    private String fsdgrp_rec_lctyp;

    @RelPath(value="fsdgrp.rec.lrsamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_lrsamt;

    @RelPath(value="fsdgrp.rec.lrscur",dir=DirType.BOTH)
    private String fsdgrp_rec_lrscur;

    @RelPath(value="fsdgrp.rec.origno",dir=DirType.BOTH)
    private String fsdgrp_rec_origno;

    @RelPath(value="fsdgrp.rec.ownref",dir=DirType.BOTH)
    private String fsdgrp_rec_ownref;

    @RelPath(value="fsdgrp.rec.payamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_payamt;

    @RelPath(value="fsdgrp.rec.paycur",dir=DirType.BOTH)
    private String fsdgrp_rec_paycur;

    @RelPath(value="fsdgrp.rec.reason",dir=DirType.BOTH)
    private String fsdgrp_rec_reason;

    @RelPath(value="fsdgrp.rec.slepes",dir=DirType.BOTH)
    private String fsdgrp_rec_slepes;

    @RelPath(value="fsdgrp.rec.soedoc",dir=DirType.BOTH)
    private String fsdgrp_rec_soedoc;

    @RelPath(value="fsdgrp.rec.soexno",dir=DirType.BOTH)
    private String fsdgrp_rec_soexno;

    @RelPath(value="fsdgrp.acb.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_acb_pts_adrblk;

    @RelPath(value="fsdgrp.acb.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_acb_pts_extkey;

    @RelPath(value="fsdgrp.acc.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_acc_pts_adrblk;

    @RelPath(value="fsdgrp.acc.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_acc_pts_extkey;

    @RelPath(value="fsdgrp.apl.pts.nam",dir=DirType.BOTH)
    private String fsdgrp_apl_pts_nam;

    @RelPath(value="fsdgrp.con.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_con_pts_adrblk;

    @RelPath(value="fsdgrp.con.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_con_pts_extkey;

    @RelPath(value="fsdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_adrblk;

    @RelPath(value="fsdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_extkey;

    @RelPath(value="fsdgrp.isb.pts.ref",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_ref;

    @RelPath(value="fsdgrp.pay.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_pay_pts_adrblk;

    @RelPath(value="fsdgrp.pay.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_pay_pts_extkey;


}