package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FftcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fsdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fsdgrp_rec_bchcod;

    @RelPath(value="fsdgrp.rec.brkamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_brkamt;

    @RelPath(value="fsdgrp.rec.brkcur",dir=DirType.BOTH)
    private String fsdgrp_rec_brkcur;

    @RelPath(value="fsdgrp.rec.cornam",dir=DirType.BOTH)
    private String fsdgrp_rec_cornam;

    @RelPath(value="fsdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_credat;

    @RelPath(value="fsdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_expdat;

    @RelPath(value="fsdgrp.rec.othins",dir=DirType.BOTH)
    private int fsdgrp_rec_othins;

    @RelPath(value="fsdgrp.rec.ownref",dir=DirType.BOTH)
    private String fsdgrp_rec_ownref;

    @RelPath(value="fsdgrp.rec.pouamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_pouamt;

    @RelPath(value="fsdgrp.rec.poucur",dir=DirType.BOTH)
    private String fsdgrp_rec_poucur;

    @RelPath(value="fsdgrp.rec.ratcal",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal fsdgrp_rec_ratcal;

    @RelPath(value="fsdgrp.rec.totamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_totamt;

    @RelPath(value="fsdgrp.rec.totcur",dir=DirType.BOTH)
    private String fsdgrp_rec_totcur;

    @RelPath(value="fsdgrp.rec.turamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_turamt;

    @RelPath(value="fsdgrp.rec.turcur",dir=DirType.BOTH)
    private String fsdgrp_rec_turcur;


}