package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FftdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fsdgrp.rec.accno",dir=DirType.BOTH)
    private String fsdgrp_rec_accno;

    @RelPath(value="fsdgrp.rec.corref",dir=DirType.BOTH)
    private String fsdgrp_rec_corref;

    @RelPath(value="fsdgrp.rec.disper",dir=DirType.BOTH)
    private String fsdgrp_rec_disper;

    @RelPath(value="fsdgrp.rec.finamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_finamt;

    @RelPath(value="fsdgrp.rec.fincur",dir=DirType.BOTH)
    private String fsdgrp_rec_fincur;

    @RelPath(value="fsdgrp.rec.invamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_invamt;

    @RelPath(value="fsdgrp.rec.invcur",dir=DirType.BOTH)
    private String fsdgrp_rec_invcur;

    @RelPath(value="fsdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_opndat;

    @RelPath(value="fsdgrp.rec.perint",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal fsdgrp_rec_perint;

    @RelPath(value="fsdgrp.rec.pntref",dir=DirType.BOTH)
    private String fsdgrp_rec_pntref;

    @RelPath(value="fsdgrp.rec.stlref",dir=DirType.BOTH)
    private String fsdgrp_rec_stlref;

    @RelPath(value="fsdgrp.rec.valdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_valdat;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}