package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FftopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.acpamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_acpamt;

    @RelPath(value="bedgrp.rec.acpcur",dir=DirType.BOTH)
    private String bedgrp_rec_acpcur;

    @RelPath(value="bedgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_issamt;

    @RelPath(value="bedgrp.rec.isscur",dir=DirType.BOTH)
    private String bedgrp_rec_isscur;

    @RelPath(value="bedgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_matdat;

    @RelPath(value="bedgrp.rec.stlref",dir=DirType.BOTH)
    private String bedgrp_rec_stlref;

    @RelPath(value="fsdgrp.rec.accno",dir=DirType.BOTH)
    private String fsdgrp_rec_accno;

    @RelPath(value="fsdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fsdgrp_rec_bchcod;

    @RelPath(value="fsdgrp.rec.bearper",dir=DirType.BOTH)
    private String fsdgrp_rec_bearper;

    @RelPath(value="fsdgrp.rec.billno",dir=DirType.BOTH)
    private String fsdgrp_rec_billno;

    @RelPath(value="fsdgrp.rec.conref",dir=DirType.BOTH)
    private String fsdgrp_rec_conref;

    @RelPath(value="fsdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_credat;

    @RelPath(value="fsdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fsdgrp_rec_expdat;

    @RelPath(value="fsdgrp.rec.fax",dir=DirType.BOTH)
    private String fsdgrp_rec_fax;

    @RelPath(value="fsdgrp.rec.fintyp",dir=DirType.BOTH)
    private String fsdgrp_rec_fintyp;

    @RelPath(value="fsdgrp.rec.invamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fsdgrp_rec_invamt;

    @RelPath(value="fsdgrp.rec.invcur",dir=DirType.BOTH)
    private String fsdgrp_rec_invcur;

    @RelPath(value="fsdgrp.rec.lctyp",dir=DirType.BOTH)
    private String fsdgrp_rec_lctyp;

    @RelPath(value="fsdgrp.rec.linkman",dir=DirType.BOTH)
    private String fsdgrp_rec_linkman;

    @RelPath(value="fsdgrp.rec.othins",dir=DirType.BOTH)
    private int fsdgrp_rec_othins;

    @RelPath(value="fsdgrp.rec.ownref",dir=DirType.BOTH)
    private String fsdgrp_rec_ownref;

    @RelPath(value="fsdgrp.rec.ratcal",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal fsdgrp_rec_ratcal;

    @RelPath(value="fsdgrp.rec.rgtclu",dir=DirType.BOTH)
    private String fsdgrp_rec_rgtclu;

    @RelPath(value="fsdgrp.rec.tel",dir=DirType.BOTH)
    private String fsdgrp_rec_tel;

    @RelPath(value="bedgrp.aplnam",dir=DirType.BOTH)
    private String bedgrp_aplnam;

    @RelPath(value="fsdgrp.acb.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_acb_pts_adrblk;

    @RelPath(value="fsdgrp.acb.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_acb_pts_extkey;

    @RelPath(value="fsdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String fsdgrp_dap_pts_nam;

    @RelPath(value="fsdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_adrblk;

    @RelPath(value="fsdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_extkey;

    @RelPath(value="fsdgrp.isb.pts.ref",dir=DirType.BOTH)
    private String fsdgrp_isb_pts_ref;

    @RelPath(value="fstp.dapp.curcus",dir=DirType.BOTH)
    private String fstp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}