package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FncadvVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="afdgrp.rec.oprtxt",dir=DirType.BOTH)
    private String afdgrp_rec_oprtxt;

    @RelPath(value="afdgrp.rec.oprtyp",dir=DirType.BOTH)
    private String afdgrp_rec_oprtyp;

    @RelPath(value="afdgrp.rec.ownref",dir=DirType.BOTH)
    private String afdgrp_rec_ownref;

    @RelPath(value="bpdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bpdgrp_rec_advdat;

    @RelPath(value="bpdgrp.rec.fftamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bpdgrp_rec_fftamt;

    @RelPath(value="bpdgrp.rec.fftcur",dir=DirType.BOTH)
    private String bpdgrp_rec_fftcur;

    @RelPath(value="bpdgrp.rec.stlref",dir=DirType.BOTH)
    private String bpdgrp_rec_stlref;

    @RelPath(value="bpdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String bpdgrp_apl_pts_adrblk;

    @RelPath(value="bpdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String bpdgrp_apl_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}