package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FpdsllVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fpdgrp_rec_bchcod;

    @RelPath(value="fpdgrp.rec.cnycno",dir=DirType.BOTH)
    private String fpdgrp_rec_cnycno;

    @RelPath(value="fpdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fpdgrp_rec_credat;

    @RelPath(value="fpdgrp.rec.obycno",dir=DirType.BOTH)
    private String fpdgrp_rec_obycno;

    @RelPath(value="fpdgrp.rec.oprnam",dir=DirType.BOTH)
    private String fpdgrp_rec_oprnam;

    @RelPath(value="fpdgrp.rec.othcno",dir=DirType.BOTH)
    private String fpdgrp_rec_othcno;

    @RelPath(value="fpdgrp.rec.outamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fpdgrp_rec_outamt;

    @RelPath(value="fpdgrp.rec.outcno",dir=DirType.BOTH)
    private String fpdgrp_rec_outcno;

    @RelPath(value="fpdgrp.rec.outcur",dir=DirType.BOTH)
    private String fpdgrp_rec_outcur;

    @RelPath(value="fpdgrp.rec.ownref",dir=DirType.BOTH)
    private String fpdgrp_rec_ownref;

    @RelPath(value="fpdgrp.rec.payeebank",dir=DirType.BOTH)
    private String fpdgrp_rec_payeebank;

    @RelPath(value="fpdgrp.rec.payeename",dir=DirType.BOTH)
    private String fpdgrp_rec_payeename;

    @RelPath(value="fpdgrp.rec.shbody",dir=DirType.BOTH)
    private String fpdgrp_rec_shbody;

    @RelPath(value="fpdgrp.rec.sttacttyp",dir=DirType.BOTH)
    private String fpdgrp_rec_sttacttyp;

    @RelPath(value="fpdgrp.rec.stttyp",dir=DirType.BOTH)
    private String fpdgrp_rec_stttyp;

    @RelPath(value="fpdgrp.rec.tel",dir=DirType.BOTH)
    private String fpdgrp_rec_tel;

    @RelPath(value="fpdgrp.rec.trscno",dir=DirType.BOTH)
    private String fpdgrp_rec_trscno;

    @RelPath(value="fpdgrp.rec.trstxt",dir=DirType.BOTH)
    private String fpdgrp_rec_trstxt;

    @RelPath(value="fpdgrp.rec.usage",dir=DirType.BOTH)
    private String fpdgrp_rec_usage;

    @RelPath(value="fpdgrp.rec.usageinfo",dir=DirType.BOTH)
    private String fpdgrp_rec_usageinfo;


}