package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FqtopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ghtp.fqdgrp.rec.amount",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal ghtp_fqdgrp_rec_amount;

    @RelPath(value="ghtp.fqdgrp.rec.appid",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_appid;

    @RelPath(value="ghtp.fqdgrp.rec.bangdh",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_bangdh;

    @RelPath(value="ghtp.fqdgrp.rec.bankmcje",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal ghtp_fqdgrp_rec_bankmcje;

    @RelPath(value="ghtp.fqdgrp.rec.bchcod",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_bchcod;

    @RelPath(value="ghtp.fqdgrp.rec.businessno",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_businessno;

    @RelPath(value="ghtp.fqdgrp.rec.cjiohl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal ghtp_fqdgrp_rec_cjiohl;

    @RelPath(value="ghtp.fqdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ghtp_fqdgrp_rec_credat;

    @RelPath(value="ghtp.fqdgrp.rec.currency",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_currency;

    @RelPath(value="ghtp.fqdgrp.rec.dihdig",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_dihdig;

    @RelPath(value="ghtp.fqdgrp.rec.duifzh",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_duifzh;

    @RelPath(value="ghtp.fqdgrp.rec.ecifno",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_ecifno;

    @RelPath(value="ghtp.fqdgrp.rec.edbusno",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_edbusno;

    @RelPath(value="ghtp.fqdgrp.rec.etyinr",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_etyinr;

    @RelPath(value="ghtp.fqdgrp.rec.gjszsbno",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_gjszsbno;

    @RelPath(value="ghtp.fqdgrp.rec.inr",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_inr;

    @RelPath(value="ghtp.fqdgrp.rec.jio1gy",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_jio1gy;

    @RelPath(value="ghtp.fqdgrp.rec.jioyje",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal ghtp_fqdgrp_rec_jioyje;

    @RelPath(value="ghtp.fqdgrp.rec.joy1rq",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_joy1rq;

    @RelPath(value="ghtp.fqdgrp.rec.maicj",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal ghtp_fqdgrp_rec_maicj;

    @RelPath(value="ghtp.fqdgrp.rec.mairj",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal ghtp_fqdgrp_rec_mairj;

    @RelPath(value="ghtp.fqdgrp.rec.mcbiz",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_mcbiz;

    @RelPath(value="ghtp.fqdgrp.rec.orgcode",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_orgcode;

    @RelPath(value="ghtp.fqdgrp.rec.orgname",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_orgname;

    @RelPath(value="ghtp.fqdgrp.rec.ppanmcj",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal ghtp_fqdgrp_rec_ppanmcj;

    @RelPath(value="ghtp.fqdgrp.rec.ppanmrj",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal ghtp_fqdgrp_rec_ppanmrj;

    @RelPath(value="ghtp.fqdgrp.rec.ptyinr",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_ptyinr;

    @RelPath(value="ghtp.fqdgrp.rec.qantls",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_qantls;

    @RelPath(value="ghtp.fqdgrp.rec.rmbjz",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal ghtp_fqdgrp_rec_rmbjz;

    @RelPath(value="ghtp.fqdgrp.rec.rmzhlx",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_rmzhlx;

    @RelPath(value="ghtp.fqdgrp.rec.salejyrq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ghtp_fqdgrp_rec_salejyrq;

    @RelPath(value="ghtp.fqdgrp.rec.shibyy",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_shibyy;

    @RelPath(value="ghtp.fqdgrp.rec.shjiayjg",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_shjiayjg;

    @RelPath(value="ghtp.fqdgrp.rec.sjjy01",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_sjjy01;

    @RelPath(value="ghtp.fqdgrp.rec.sjjy02",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_sjjy02;

    @RelPath(value="ghtp.fqdgrp.rec.sjjy03",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_sjjy03;

    @RelPath(value="ghtp.fqdgrp.rec.sjjy04",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_sjjy04;

    @RelPath(value="ghtp.fqdgrp.rec.upddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ghtp_fqdgrp_rec_upddat;

    @RelPath(value="ghtp.fqdgrp.rec.wbskno",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_wbskno;

    @RelPath(value="ghtp.fqdgrp.rec.whzhkhjgh",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_whzhkhjgh;

    @RelPath(value="ghtp.fqdgrp.rec.ynjyrq",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_ynjyrq;

    @RelPath(value="ghtp.fqdgrp.rec.yyedzh",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_yyedzh;

    @RelPath(value="ghtp.fqdgrp.rec.zhjnmc",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_zhjnmc;

    @RelPath(value="ghtp.fqdgrp.rec.zhyomd",dir=DirType.BOTH)
    private String ghtp_fqdgrp_rec_zhyomd;


}