package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FxisllVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fcdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_accamt;

    @RelPath(value="fcdgrp.rec.acccur",dir=DirType.BOTH)
    private String fcdgrp_rec_acccur;

    @RelPath(value="fcdgrp.rec.aplcnd",dir=DirType.BOTH)
    private String fcdgrp_rec_aplcnd;

    @RelPath(value="fcdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fcdgrp_rec_bchcod;

    @RelPath(value="fcdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fcdgrp_rec_credat;

    @RelPath(value="fcdgrp.rec.doclst",dir=DirType.BOTH)
    private String fcdgrp_rec_doclst;

    @RelPath(value="fcdgrp.rec.doctxt",dir=DirType.BOTH)
    private String fcdgrp_rec_doctxt;

    @RelPath(value="fcdgrp.rec.foract",dir=DirType.BOTH)
    private String fcdgrp_rec_foract;

    @RelPath(value="fcdgrp.rec.ownref",dir=DirType.BOTH)
    private String fcdgrp_rec_ownref;

    @RelPath(value="fcdgrp.rec.rmbact",dir=DirType.BOTH)
    private String fcdgrp_rec_rmbact;

    @RelPath(value="fcdgrp.apl.pty.nam",dir=DirType.BOTH)
    private String fcdgrp_apl_pty_nam;

    @RelPath(value="fcdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String fcdgrp_dap_pts_nam;

    @RelPath(value="fcdgrp.fxicnd.chkdocflg",dir=DirType.BOTH)
    private String fcdgrp_fxicnd_chkdocflg;

    @RelPath(value="fctp.dapp.curcus",dir=DirType.BOTH)
    private String fctp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}