package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FxropnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fcdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_accamt;

    @RelPath(value="fcdgrp.rec.accamtd",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_accamtd;

    @RelPath(value="fcdgrp.rec.acccur",dir=DirType.BOTH)
    private String fcdgrp_rec_acccur;

    @RelPath(value="fcdgrp.rec.acccurd",dir=DirType.BOTH)
    private String fcdgrp_rec_acccurd;

    @RelPath(value="fcdgrp.rec.actdatd",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fcdgrp_rec_actdatd;

    @RelPath(value="fcdgrp.rec.agrprc",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(7)
    private BigDecimal fcdgrp_rec_agrprc;

    @RelPath(value="fcdgrp.rec.agrprcd",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_agrprcd;

    @RelPath(value="fcdgrp.rec.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_amt;

    @RelPath(value="fcdgrp.rec.amtd",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_amtd;

    @RelPath(value="fcdgrp.rec.aplcnd",dir=DirType.BOTH)
    private String fcdgrp_rec_aplcnd;

    @RelPath(value="fcdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fcdgrp_rec_bchcod;

    @RelPath(value="fcdgrp.rec.begactday",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fcdgrp_rec_begactday;

    @RelPath(value="fcdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fcdgrp_rec_credat;

    @RelPath(value="fcdgrp.rec.cur",dir=DirType.BOTH)
    private String fcdgrp_rec_cur;

    @RelPath(value="fcdgrp.rec.curd",dir=DirType.BOTH)
    private String fcdgrp_rec_curd;

    @RelPath(value="fcdgrp.rec.lmudat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    private Date fcdgrp_rec_lmudat;

    @RelPath(value="fcdgrp.rec.ownref",dir=DirType.BOTH)
    private String fcdgrp_rec_ownref;

    @RelPath(value="fcdgrp.apl.pts.nam",dir=DirType.BOTH)
    private String fcdgrp_apl_pts_nam;

    @RelPath(value="fcdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String fcdgrp_dap_pts_nam;

    @RelPath(value="fctp.dapp.curcus",dir=DirType.BOTH)
    private String fctp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}