package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FxtfreVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fcdgrp.rec.accamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal fcdgrp_rec_accamt;

    @RelPath(value="fcdgrp.rec.acccur",dir=DirType.BOTH)
    private String fcdgrp_rec_acccur;

    @RelPath(value="fcdgrp.rec.aplcnd",dir=DirType.BOTH)
    private String fcdgrp_rec_aplcnd;

    @RelPath(value="fcdgrp.rec.aplinf",dir=DirType.BOTH)
    private String fcdgrp_rec_aplinf;

    @RelPath(value="fcdgrp.rec.bchcod",dir=DirType.BOTH)
    private String fcdgrp_rec_bchcod;

    @RelPath(value="fcdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fcdgrp_rec_credat;

    @RelPath(value="fcdgrp.rec.fxttyp",dir=DirType.BOTH)
    private String fcdgrp_rec_fxttyp;

    @RelPath(value="fcdgrp.rec.stlref",dir=DirType.BOTH)
    private String fcdgrp_rec_stlref;

    @RelPath(value="fcdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String fcdgrp_apl_pts_adrblk;

    @RelPath(value="fcdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String fcdgrp_apl_pts_extkey;

    @RelPath(value="fcdgrp.apl.pty.nam",dir=DirType.BOTH)
    private String fcdgrp_apl_pty_nam;

    @RelPath(value="fcdgrp.dap.pts.nam",dir=DirType.BOTH)
    private String fcdgrp_dap_pts_nam;

    @RelPath(value="fctp.dapp.curcus",dir=DirType.BOTH)
    private String fctp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}