package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class FytcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="fydgrp.rec.addcla",dir=DirType.BOTH)
    private String fydgrp_rec_addcla;

    @RelPath(value="fydgrp.rec.arbadr",dir=DirType.BOTH)
    private String fydgrp_rec_arbadr;

    @RelPath(value="fydgrp.rec.arbnam",dir=DirType.BOTH)
    private String fydgrp_rec_arbnam;

    @RelPath(value="fydgrp.rec.calnum",dir=DirType.BOTH)
    private String fydgrp_rec_calnum;

    @RelPath(value="fydgrp.rec.coladr",dir=DirType.BOTH)
    private String fydgrp_rec_coladr;

    @RelPath(value="fydgrp.rec.colcod",dir=DirType.BOTH)
    private String fydgrp_rec_colcod;

    @RelPath(value="fydgrp.rec.colnam",dir=DirType.BOTH)
    private String fydgrp_rec_colnam;

    @RelPath(value="fydgrp.rec.comadr",dir=DirType.BOTH)
    private String fydgrp_rec_comadr;

    @RelPath(value="fydgrp.rec.comnam",dir=DirType.BOTH)
    private String fydgrp_rec_comnam;

    @RelPath(value="fydgrp.rec.effdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fydgrp_rec_effdat;

    @RelPath(value="fydgrp.rec.emails",dir=DirType.BOTH)
    private String fydgrp_rec_emails;

    @RelPath(value="fydgrp.rec.faxnum",dir=DirType.BOTH)
    private String fydgrp_rec_faxnum;

    @RelPath(value="fydgrp.rec.fhouse",dir=DirType.BOTH)
    private String fydgrp_rec_fhouse;

    @RelPath(value="fydgrp.rec.flepes",dir=DirType.BOTH)
    private String fydgrp_rec_flepes;

    @RelPath(value="fydgrp.rec.frspty",dir=DirType.BOTH)
    private String fydgrp_rec_frspty;

    @RelPath(value="fydgrp.rec.hanway",dir=DirType.BOTH)
    private String fydgrp_rec_hanway;

    @RelPath(value="fydgrp.rec.losdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date fydgrp_rec_losdat;

    @RelPath(value="fydgrp.rec.othway",dir=DirType.BOTH)
    private String fydgrp_rec_othway;

    @RelPath(value="fydgrp.rec.qqsnum",dir=DirType.BOTH)
    private String fydgrp_rec_qqsnum;

    @RelPath(value="fydgrp.rec.rcvnum",dir=DirType.BOTH)
    private String fydgrp_rec_rcvnum;

    @RelPath(value="fydgrp.rec.scaper",dir=DirType.BOTH)
    private String fydgrp_rec_scaper;

    @RelPath(value="fydgrp.rec.sedpty",dir=DirType.BOTH)
    private String fydgrp_rec_sedpty;

    @RelPath(value="fydgrp.rec.shouse",dir=DirType.BOTH)
    private String fydgrp_rec_shouse;

    @RelPath(value="fydgrp.rec.slepes",dir=DirType.BOTH)
    private String fydgrp_rec_slepes;

    @RelPath(value="fydgrp.rec.sphnum",dir=DirType.BOTH)
    private String fydgrp_rec_sphnum;

    @RelPath(value="fydgrp.rec.wecnum",dir=DirType.BOTH)
    private String fydgrp_rec_wecnum;

    @RelPath(value="fydgrp.rec.wyfxll",dir=DirType.BOTH)
    private String fydgrp_rec_wyfxll;

    @RelPath(value="fydgrp.rec.yqfxll",dir=DirType.BOTH)
    private String fydgrp_rec_yqfxll;

    @RelPath(value="fydgrp.rec.zipcod",dir=DirType.BOTH)
    private String fydgrp_rec_zipcod;


}