package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GitaszVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.agrnam",dir=DirType.BOTH)
    private String gidgrp_rec_agrnam;

    @RelPath(value="gidgrp.rec.amedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_amedat;

    @RelPath(value="gidgrp.rec.ametxt",dir=DirType.BOTH)
    private String gidgrp_rec_ametxt;

    @RelPath(value="gidgrp.rec.lgameamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgameamt;

    @RelPath(value="gidgrp.rec.lgamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgamt;

    @RelPath(value="gidgrp.rec.lgcur",dir=DirType.BOTH)
    private String gidgrp_rec_lgcur;

    @RelPath(value="gidgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_opndat;

    @RelPath(value="gidgrp.rec.stlref",dir=DirType.BOTH)
    private String gidgrp_rec_stlref;

    @RelPath(value="gidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_apl_pts_adrblk;

    @RelPath(value="gidgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_apl_pts_extkey;

    @RelPath(value="gidgrp.bchcod",dir=DirType.BOTH)
    private String gidgrp_bchcod;

    @RelPath(value="gidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_ben_pts_adrblk;

    @RelPath(value="gidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_ben_pts_extkey;

    @RelPath(value="gidgrp.szgit.esig",dir=DirType.BOTH)
    private String gidgrp_szgit_esig;


}