package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GitcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.checked",dir=DirType.BOTH)
    private String gidgrp_checked;

    @RelPath(value="gidgrp.gxd.bctk",dir=DirType.BOTH)
    private String gidgrp_gxd_bctk;

    @RelPath(value="gidgrp.gxd.bdbr",dir=DirType.BOTH)
    private String gidgrp_gxd_bdbr;

    @RelPath(value="gidgrp.gxd.bdbrfddz",dir=DirType.BOTH)
    private String gidgrp_gxd_bdbrfddz;

    @RelPath(value="gidgrp.gxd.bzjamtcn",dir=DirType.BOTH)
    private String gidgrp_gxd_bzjamtcn;

    @RelPath(value="gidgrp.gxd.bzjcur",dir=DirType.BOTH)
    private String gidgrp_gxd_bzjcur;

    @RelPath(value="gidgrp.gxd.bzjxybh",dir=DirType.BOTH)
    private String gidgrp_gxd_bzjxybh;

    @RelPath(value="gidgrp.gxd.bzjxymc",dir=DirType.BOTH)
    private String gidgrp_gxd_bzjxymc;

    @RelPath(value="gidgrp.gxd.bzqjq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_gxd_bzqjq;

    @RelPath(value="gidgrp.gxd.bzqjz",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_gxd_bzqjz;

    @RelPath(value="gidgrp.gxd.dbamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_gxd_dbamt;

    @RelPath(value="gidgrp.gxd.dbcur",dir=DirType.BOTH)
    private String gidgrp_gxd_dbcur;

    @RelPath(value="gidgrp.gxd.deqamtcn",dir=DirType.BOTH)
    private String gidgrp_gxd_deqamtcn;

    @RelPath(value="gidgrp.gxd.deqcur",dir=DirType.BOTH)
    private String gidgrp_gxd_deqcur;

    @RelPath(value="gidgrp.gxd.deqre",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_gxd_deqre;

    @RelPath(value="gidgrp.gxd.dsdz",dir=DirType.BOTH)
    private String gidgrp_gxd_dsdz;

    @RelPath(value="gidgrp.gxd.dsr",dir=DirType.BOTH)
    private String gidgrp_gxd_dsr;

    @RelPath(value="gidgrp.gxd.dsyzbm",dir=DirType.BOTH)
    private String gidgrp_gxd_dsyzbm;

    @RelPath(value="gidgrp.gxd.dyqamtcn",dir=DirType.BOTH)
    private String gidgrp_gxd_dyqamtcn;

    @RelPath(value="gidgrp.gxd.dyqcur",dir=DirType.BOTH)
    private String gidgrp_gxd_dyqcur;

    @RelPath(value="gidgrp.gxd.dyqrq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_gxd_dyqrq;

    @RelPath(value="gidgrp.gxd.fdbfs1",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbfs1;

    @RelPath(value="gidgrp.gxd.fdbfs2",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbfs2;

    @RelPath(value="gidgrp.gxd.fdbhtbh1",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbhtbh1;

    @RelPath(value="gidgrp.gxd.fdbhtbh2",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbhtbh2;

    @RelPath(value="gidgrp.gxd.fdbhtmc1",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbhtmc1;

    @RelPath(value="gidgrp.gxd.fdbhtmc2",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbhtmc2;

    @RelPath(value="gidgrp.gxd.fdbr1",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbr1;

    @RelPath(value="gidgrp.gxd.fdbr2",dir=DirType.BOTH)
    private String gidgrp_gxd_fdbr2;

    @RelPath(value="gidgrp.gxd.jf",dir=DirType.BOTH)
    private String gidgrp_gxd_jf;

    @RelPath(value="gidgrp.gxd.jffrdb",dir=DirType.BOTH)
    private String gidgrp_gxd_jffrdb;

    @RelPath(value="gidgrp.gxd.jffs",dir=DirType.BOTH)
    private String gidgrp_gxd_jffs;

    @RelPath(value="gidgrp.gxd.jfzs",dir=DirType.BOTH)
    private String gidgrp_gxd_jfzs;

    @RelPath(value="gidgrp.gxd.ktdd",dir=DirType.BOTH)
    private String gidgrp_gxd_ktdd;

    @RelPath(value="gidgrp.gxd.qt",dir=DirType.BOTH)
    private String gidgrp_gxd_qt;

    @RelPath(value="gidgrp.gxd.qtfs",dir=DirType.BOTH)
    private String gidgrp_gxd_qtfs;

    @RelPath(value="gidgrp.gxd.syr",dir=DirType.BOTH)
    private String gidgrp_gxd_syr;

    @RelPath(value="gidgrp.gxd.syrfddz",dir=DirType.BOTH)
    private String gidgrp_gxd_syrfddz;

    @RelPath(value="gidgrp.gxd.wyjbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_gxd_wyjbl;

    @RelPath(value="gidgrp.gxd.ycxamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_gxd_ycxamt;

    @RelPath(value="gidgrp.gxd.ycxcur",dir=DirType.BOTH)
    private String gidgrp_gxd_ycxcur;

    @RelPath(value="gidgrp.gxd.yf",dir=DirType.BOTH)
    private String gidgrp_gxd_yf;

    @RelPath(value="gidgrp.gxd.yfcp",dir=DirType.BOTH)
    private String gidgrp_gxd_yfcp;

    @RelPath(value="gidgrp.gxd.yfczhm",dir=DirType.BOTH)
    private String gidgrp_gxd_yfczhm;

    @RelPath(value="gidgrp.gxd.yfdwdz",dir=DirType.BOTH)
    private String gidgrp_gxd_yfdwdz;

    @RelPath(value="gidgrp.gxd.yfdwmc",dir=DirType.BOTH)
    private String gidgrp_gxd_yfdwmc;

    @RelPath(value="gidgrp.gxd.yfdzyj",dir=DirType.BOTH)
    private String gidgrp_gxd_yfdzyj;

    @RelPath(value="gidgrp.gxd.yffrdb",dir=DirType.BOTH)
    private String gidgrp_gxd_yffrdb;

    @RelPath(value="gidgrp.gxd.yflxdh",dir=DirType.BOTH)
    private String gidgrp_gxd_yflxdh;

    @RelPath(value="gidgrp.gxd.yflxr",dir=DirType.BOTH)
    private String gidgrp_gxd_yflxr;

    @RelPath(value="gidgrp.gxd.yfqdhtrq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_gxd_yfqdhtrq;

    @RelPath(value="gidgrp.gxd.yfqqhm",dir=DirType.BOTH)
    private String gidgrp_gxd_yfqqhm;

    @RelPath(value="gidgrp.gxd.yfsjhm",dir=DirType.BOTH)
    private String gidgrp_gxd_yfsjhm;

    @RelPath(value="gidgrp.gxd.yfwxhm",dir=DirType.BOTH)
    private String gidgrp_gxd_yfwxhm;

    @RelPath(value="gidgrp.gxd.yfyzbm",dir=DirType.BOTH)
    private String gidgrp_gxd_yfyzbm;

    @RelPath(value="gidgrp.gxd.yfzs",dir=DirType.BOTH)
    private String gidgrp_gxd_yfzs;

    @RelPath(value="gidgrp.gxd.yqdkll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal gidgrp_gxd_yqdkll;

    @RelPath(value="gidgrp.gxd.zcwyh",dir=DirType.BOTH)
    private String gidgrp_gxd_zcwyh;

    @RelPath(value="gidgrp.gxd.zyjjfs",dir=DirType.BOTH)
    private String gidgrp_gxd_zyjjfs;


}