package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GitmavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.amedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_amedat;

    @RelPath(value="gidgrp.rec.amenbr",dir=DirType.BOTH)
    private int gidgrp_rec_amenbr;

    @RelPath(value="gidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_credat;

    @RelPath(value="gidgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_opndat;

    @RelPath(value="gidgrp.rec.stlref",dir=DirType.BOTH)
    private String gidgrp_rec_stlref;

    @RelPath(value="gidgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_adv_pts_adrblk;

    @RelPath(value="gidgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_adv_pts_extkey;

    @RelPath(value="gidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_ben_pts_adrblk;

    @RelPath(value="gidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_ben_pts_extkey;

    @RelPath(value="gidgrp.gitpush.contractid",dir=DirType.BOTH)
    private String gidgrp_gitpush_contractid;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}