package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GitoszVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.bhcxsf",dir=DirType.BOTH)
    private String gidgrp_rec_bhcxsf;

    @RelPath(value="gidgrp.rec.cjfs",dir=DirType.BOTH)
    private String gidgrp_rec_cjfs;

    @RelPath(value="gidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_credat;

    @RelPath(value="gidgrp.rec.dbqxsjq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_dbqxsjq;

    @RelPath(value="gidgrp.rec.dbqxsjz",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_dbqxsjz;

    @RelPath(value="gidgrp.rec.lgamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgamt;

    @RelPath(value="gidgrp.rec.lgcur",dir=DirType.BOTH)
    private String gidgrp_rec_lgcur;

    @RelPath(value="gidgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_matdat;

    @RelPath(value="gidgrp.rec.myrzbh",dir=DirType.BOTH)
    private String gidgrp_rec_myrzbh;

    @RelPath(value="gidgrp.rec.opntyp",dir=DirType.BOTH)
    private String gidgrp_rec_opntyp;

    @RelPath(value="gidgrp.rec.ownref",dir=DirType.BOTH)
    private String gidgrp_rec_ownref;

    @RelPath(value="gidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_apl_pts_adrblk;

    @RelPath(value="gidgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_apl_pts_extkey;

    @RelPath(value="gidgrp.bchcod",dir=DirType.BOTH)
    private String gidgrp_bchcod;

    @RelPath(value="gidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_ben_pts_adrblk;

    @RelPath(value="gidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_ben_pts_extkey;

    @RelPath(value="gidgrp.sec.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_sec_pts_adrblk;

    @RelPath(value="gidgrp.sec.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_sec_pts_extkey;

    @RelPath(value="gidgrp.szgit.esig",dir=DirType.BOTH)
    private String gidgrp_szgit_esig;

    @RelPath(value="gidgrp.szgit.feeaccount",dir=DirType.BOTH)
    private String gidgrp_szgit_feeaccount;

    @RelPath(value="gidgrp.szgit.hopeopentime",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_szgit_hopeopentime;

    @RelPath(value="gidgrp.szgit.isdiscreted",dir=DirType.BOTH)
    private String gidgrp_szgit_isdiscreted;

    @RelPath(value="gidgrp.szgit.isfinancee",dir=DirType.BOTH)
    private String gidgrp_szgit_isfinancee;

    @RelPath(value="gidgrp.szgit.isstandardtext",dir=DirType.BOTH)
    private String gidgrp_szgit_isstandardtext;

    @RelPath(value="gidgrp.szgit.istrasopen",dir=DirType.BOTH)
    private String gidgrp_szgit_istrasopen;

    @RelPath(value="gidgrp.szgit.language",dir=DirType.BOTH)
    private String gidgrp_szgit_language;

    @RelPath(value="gidgrp.szgit.lettertype",dir=DirType.BOTH)
    private String gidgrp_szgit_lettertype;

    @RelPath(value="gidgrp.szgit.poundageamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_szgit_poundageamt;

    @RelPath(value="gidgrp.szgit.poundagecur",dir=DirType.BOTH)
    private String gidgrp_szgit_poundagecur;

    @RelPath(value="gidgrp.szgit.projectnam",dir=DirType.BOTH)
    private String gidgrp_szgit_projectnam;

    @RelPath(value="gidgrp.szgit.ptbusino",dir=DirType.BOTH)
    private String gidgrp_szgit_ptbusino;

    @RelPath(value="gidgrp.szgit.textcode",dir=DirType.BOTH)
    private String gidgrp_szgit_textcode;


}