package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GitrcvVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.advref",dir=DirType.BOTH)
    private String gidgrp_rec_advref;

    @RelPath(value="gidgrp.rec.apldat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_apldat;

    @RelPath(value="gidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_credat;

    @RelPath(value="gidgrp.rec.lgamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgamt;

    @RelPath(value="gidgrp.rec.lgcur",dir=DirType.BOTH)
    private String gidgrp_rec_lgcur;

    @RelPath(value="gidgrp.rec.lmudat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_lmudat;

    @RelPath(value="gidgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_opndat;

    @RelPath(value="gidgrp.rec.stlref",dir=DirType.BOTH)
    private String gidgrp_rec_stlref;

    @RelPath(value="gidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_apl_pts_adrblk;

    @RelPath(value="gidgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_apl_pts_extkey;

    @RelPath(value="gidgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_isb_pts_adrblk;

    @RelPath(value="gidgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_isb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}