package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GittrsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.agrnam",dir=DirType.BOTH)
    private String gidgrp_rec_agrnam;

    @RelPath(value="gidgrp.rec.apldat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_apldat;

    @RelPath(value="gidgrp.rec.apprul",dir=DirType.BOTH)
    private String gidgrp_rec_apprul;

    @RelPath(value="gidgrp.rec.apprultxt",dir=DirType.BOTH)
    private String gidgrp_rec_apprultxt;

    @RelPath(value="gidgrp.rec.bchcod",dir=DirType.BOTH)
    private String gidgrp_rec_bchcod;

    @RelPath(value="gidgrp.rec.conno",dir=DirType.BOTH)
    private String gidgrp_rec_conno;

    @RelPath(value="gidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_credat;

    @RelPath(value="gidgrp.rec.furtyp",dir=DirType.BOTH)
    private String gidgrp_rec_furtyp;

    @RelPath(value="gidgrp.rec.gittrstxt",dir=DirType.BOTH)
    private String gidgrp_rec_gittrstxt;

    @RelPath(value="gidgrp.rec.lgamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgamt;

    @RelPath(value="gidgrp.rec.lgcur",dir=DirType.BOTH)
    private String gidgrp_rec_lgcur;

    @RelPath(value="gidgrp.rec.lgtxt",dir=DirType.BOTH)
    private String gidgrp_rec_lgtxt;

    @RelPath(value="gidgrp.rec.lgtyp",dir=DirType.BOTH)
    private String gidgrp_rec_lgtyp;

    @RelPath(value="gidgrp.rec.lmudat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date gidgrp_rec_lmudat;

    @RelPath(value="gidgrp.rec.opntyp",dir=DirType.BOTH)
    private String gidgrp_rec_opntyp;

    @RelPath(value="gidgrp.rec.ownref",dir=DirType.BOTH)
    private String gidgrp_rec_ownref;

    @RelPath(value="gidgrp.rec.stlref",dir=DirType.BOTH)
    private String gidgrp_rec_stlref;

    @RelPath(value="gidgrp.rec.trstyp",dir=DirType.BOTH)
    private String gidgrp_rec_trstyp;

    @RelPath(value="gidgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_adv_pts_adrblk;

    @RelPath(value="gidgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_adv_pts_extkey;

    @RelPath(value="gidgrp.agree",dir=DirType.BOTH)
    private String gidgrp_agree;

    @RelPath(value="gidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_apl_pts_adrblk;

    @RelPath(value="gidgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_apl_pts_extkey;

    @RelPath(value="gidgrp.apl.pty.nam",dir=DirType.BOTH)
    private String gidgrp_apl_pty_nam;

    @RelPath(value="gidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String gidgrp_ben_pts_adrblk;

    @RelPath(value="gidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String gidgrp_ben_pts_extkey;

    @RelPath(value="gidgrp.dap.pts.nam",dir=DirType.BOTH)
    private String gidgrp_dap_pts_nam;

    @RelPath(value="gidgrp.trp.pts.nam",dir=DirType.BOTH)
    private String gidgrp_trp_pts_nam;

    @RelPath(value="gitp.dapp.curcus",dir=DirType.BOTH)
    private String gitp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}