package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class GxtdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="gidgrp.rec.lgamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_rec_lgamt;

    @RelPath(value="gidgrp.rec.lgcur",dir=DirType.BOTH)
    private String gidgrp_rec_lgcur;

    @RelPath(value="gidgrp.bxd.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal gidgrp_bxd_amt;

    @RelPath(value="gidgrp.bxd.cur",dir=DirType.BOTH)
    private String gidgrp_bxd_cur;

    @RelPath(value="gidgrp.bxd.ownref",dir=DirType.BOTH)
    private String gidgrp_bxd_ownref;

    @RelPath(value="gidgrp.gxd.ownref",dir=DirType.BOTH)
    private String gidgrp_gxd_ownref;

    @RelPath(value="gitp.dztimgref",dir=DirType.BOTH)
    private String gitp_dztimgref;


}