package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class IrfadvVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="apdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_rec_advdat;

    @RelPath(value="apdgrp.rec.connum",dir=DirType.BOTH)
    private String apdgrp_rec_connum;

    @RelPath(value="apdgrp.rec.finrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(7)
    private BigDecimal apdgrp_rec_finrat;

    @RelPath(value="apdgrp.rec.fintyp",dir=DirType.BOTH)
    private String apdgrp_rec_fintyp;

    @RelPath(value="apdgrp.rec.matdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_rec_matdat;

    @RelPath(value="apdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_rec_opndat;

    @RelPath(value="apdgrp.rec.payamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal apdgrp_rec_payamt;

    @RelPath(value="apdgrp.rec.paycur",dir=DirType.BOTH)
    private String apdgrp_rec_paycur;

    @RelPath(value="apdgrp.rec.payexpdat",dir=DirType.BOTH)
    private int apdgrp_rec_payexpdat;

    @RelPath(value="apdgrp.rec.pntref",dir=DirType.BOTH)
    private String apdgrp_rec_pntref;

    @RelPath(value="apdgrp.rec.stlref",dir=DirType.BOTH)
    private String apdgrp_rec_stlref;

    @RelPath(value="apdgrp.dap.pts.adrblk",dir=DirType.BOTH)
    private String apdgrp_dap_pts_adrblk;

    @RelPath(value="apdgrp.dap.pts.extkey",dir=DirType.BOTH)
    private String apdgrp_dap_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}