package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class Irfopn1VO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="apdgrp.rec.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal apdgrp_rec_amt;

    @RelPath(value="apdgrp.rec.bchcod",dir=DirType.BOTH)
    private String apdgrp_rec_bchcod;

    @RelPath(value="apdgrp.rec.connum",dir=DirType.BOTH)
    private String apdgrp_rec_connum;

    @RelPath(value="apdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_rec_credat;

    @RelPath(value="apdgrp.rec.cur",dir=DirType.BOTH)
    private String apdgrp_rec_cur;

    @RelPath(value="apdgrp.rec.disrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(7)
    private BigDecimal apdgrp_rec_disrat;

    @RelPath(value="apdgrp.rec.doctypcod",dir=DirType.BOTH)
    private String apdgrp_rec_doctypcod;

    @RelPath(value="apdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date apdgrp_rec_expdat;

    @RelPath(value="apdgrp.rec.finrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(7)
    private BigDecimal apdgrp_rec_finrat;

    @RelPath(value="apdgrp.rec.fintyp",dir=DirType.BOTH)
    private String apdgrp_rec_fintyp;

    @RelPath(value="apdgrp.rec.irfcnd",dir=DirType.BOTH)
    private String apdgrp_rec_irfcnd;

    @RelPath(value="apdgrp.rec.ownref",dir=DirType.BOTH)
    private String apdgrp_rec_ownref;

    @RelPath(value="apdgrp.rec.payamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal apdgrp_rec_payamt;

    @RelPath(value="apdgrp.rec.paycur",dir=DirType.BOTH)
    private String apdgrp_rec_paycur;

    @RelPath(value="apdgrp.rec.payexpdat",dir=DirType.BOTH)
    private int apdgrp_rec_payexpdat;

    @RelPath(value="apdgrp.rec.ref",dir=DirType.BOTH)
    private String apdgrp_rec_ref;


}