package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class JstameVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="jsdgrp.rec.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_amt;

    @RelPath(value="jsdgrp.rec.bchcod",dir=DirType.BOTH)
    private String jsdgrp_rec_bchcod;

    @RelPath(value="jsdgrp.rec.buycno",dir=DirType.BOTH)
    private String jsdgrp_rec_buycno;

    @RelPath(value="jsdgrp.rec.buycur",dir=DirType.BOTH)
    private String jsdgrp_rec_buycur;

    @RelPath(value="jsdgrp.rec.cur",dir=DirType.BOTH)
    private String jsdgrp_rec_cur;

    @RelPath(value="jsdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_opndat;

    @RelPath(value="jsdgrp.rec.ownref",dir=DirType.BOTH)
    private String jsdgrp_rec_ownref;

    @RelPath(value="jsdgrp.rec.selcno",dir=DirType.BOTH)
    private String jsdgrp_rec_selcno;

    @RelPath(value="jsdgrp.rec.selcur",dir=DirType.BOTH)
    private String jsdgrp_rec_selcur;

    @RelPath(value="jsdgrp.rec.seltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_seltyp;

    @RelPath(value="jsdgrp.rec.sfltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_sfltyp;

    @RelPath(value="jsdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_adrblk;

    @RelPath(value="jsdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_extkey;

    @RelPath(value="jsdgrp.buycnn",dir=DirType.BOTH)
    private String jsdgrp_buycnn;

    @RelPath(value="jsdgrp.selcnn",dir=DirType.BOTH)
    private String jsdgrp_selcnn;

    @RelPath(value="jstp.ammdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jstp_ammdat;

    @RelPath(value="jstp.nam",dir=DirType.BOTH)
    private String jstp_nam;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}