package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class JstdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="jsdgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_advdat;

    @RelPath(value="jsdgrp.rec.buyamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_buyamt;

    @RelPath(value="jsdgrp.rec.buycno",dir=DirType.BOTH)
    private String jsdgrp_rec_buycno;

    @RelPath(value="jsdgrp.rec.buycur",dir=DirType.BOTH)
    private String jsdgrp_rec_buycur;

    @RelPath(value="jsdgrp.rec.deprat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal jsdgrp_rec_deprat;

    @RelPath(value="jsdgrp.rec.givdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_givdat;

    @RelPath(value="jsdgrp.rec.givsty",dir=DirType.BOTH)
    private String jsdgrp_rec_givsty;

    @RelPath(value="jsdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_opndat;

    @RelPath(value="jsdgrp.rec.ownref",dir=DirType.BOTH)
    private String jsdgrp_rec_ownref;

    @RelPath(value="jsdgrp.rec.selamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_selamt;

    @RelPath(value="jsdgrp.rec.selcno",dir=DirType.BOTH)
    private String jsdgrp_rec_selcno;

    @RelPath(value="jsdgrp.rec.selcur",dir=DirType.BOTH)
    private String jsdgrp_rec_selcur;

    @RelPath(value="jsdgrp.rec.seltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_seltyp;

    @RelPath(value="jsdgrp.rec.sfltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_sfltyp;

    @RelPath(value="jsdgrp.rec.zqndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_zqndat;

    @RelPath(value="jsdgrp.rec.zqnsty",dir=DirType.BOTH)
    private String jsdgrp_rec_zqnsty;

    @RelPath(value="jsdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_adrblk;

    @RelPath(value="jsdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}