package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class JstsevVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="jsdgrp.rec.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_amt;

    @RelPath(value="jsdgrp.rec.chkdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_chkdat;

    @RelPath(value="jsdgrp.rec.cur",dir=DirType.BOTH)
    private String jsdgrp_rec_cur;

    @RelPath(value="jsdgrp.rec.getamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_getamt;

    @RelPath(value="jsdgrp.rec.getdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_getdat;

    @RelPath(value="jsdgrp.rec.givamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal jsdgrp_rec_givamt;

    @RelPath(value="jsdgrp.rec.jsdtyp",dir=DirType.BOTH)
    private String jsdgrp_rec_jsdtyp;

    @RelPath(value="jsdgrp.rec.newgivsty",dir=DirType.BOTH)
    private String jsdgrp_rec_newgivsty;

    @RelPath(value="jsdgrp.rec.njgdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_njgdat;

    @RelPath(value="jsdgrp.rec.nzqdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date jsdgrp_rec_nzqdat;

    @RelPath(value="jsdgrp.rec.ownref",dir=DirType.BOTH)
    private String jsdgrp_rec_ownref;

    @RelPath(value="jsdgrp.rec.seltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_seltyp;

    @RelPath(value="jsdgrp.rec.sfltyp",dir=DirType.BOTH)
    private String jsdgrp_rec_sfltyp;

    @RelPath(value="jsdgrp.rec.stlref",dir=DirType.BOTH)
    private String jsdgrp_rec_stlref;

    @RelPath(value="jsdgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_adrblk;

    @RelPath(value="jsdgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String jsdgrp_apl_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}