package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Docgrd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LetatsVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="bedgrp.rec.bchcod",dir=DirType.BOTH)
    private String bedgrp_rec_bchcod;

    @RelPath(value="bedgrp.rec.bfdnote",dir=DirType.BOTH)
    private String bedgrp_rec_bfdnote;

    @RelPath(value="bedgrp.rec.bfds1",dir=DirType.BOTH)
    private String bedgrp_rec_bfds1;

    @RelPath(value="bedgrp.rec.bfds2",dir=DirType.BOTH)
    private String bedgrp_rec_bfds2;

    @RelPath(value="bedgrp.rec.bopno",dir=DirType.BOTH)
    private String bedgrp_rec_bopno;

    @RelPath(value="bedgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_credat;

    @RelPath(value="bedgrp.rec.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal bedgrp_rec_docamt;

    @RelPath(value="bedgrp.rec.doccur",dir=DirType.BOTH)
    private String bedgrp_rec_doccur;

    @RelPath(value="bedgrp.rec.invno",dir=DirType.BOTH)
    private String bedgrp_rec_invno;

    @RelPath(value="bedgrp.rec.isadd",dir=DirType.BOTH)
    private String bedgrp_rec_isadd;

    @RelPath(value="bedgrp.rec.isjrc",dir=DirType.BOTH)
    private String bedgrp_rec_isjrc;

    @RelPath(value="bedgrp.rec.isrep",dir=DirType.BOTH)
    private String bedgrp_rec_isrep;

    @RelPath(value="bedgrp.rec.isyrc",dir=DirType.BOTH)
    private String bedgrp_rec_isyrc;

    @RelPath(value="bedgrp.rec.jrcno",dir=DirType.BOTH)
    private String bedgrp_rec_jrcno;

    @RelPath(value="bedgrp.rec.lfsno",dir=DirType.BOTH)
    private String bedgrp_rec_lfsno;

    @RelPath(value="bedgrp.rec.lzydat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date bedgrp_rec_lzydat;

    @RelPath(value="bedgrp.rec.ownref",dir=DirType.BOTH)
    private String bedgrp_rec_ownref;

    @RelPath(value="bedgrp.rec.yrcno",dir=DirType.BOTH)
    private String bedgrp_rec_yrcno;

    @RelPath(value="ledgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_expdat;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.prepers18",dir=DirType.BOTH)
    private String ledgrp_rec_prepers18;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="bedgrp.bnkrecd.othdoc",dir=DirType.BOTH)
    private String bedgrp_bnkrecd_othdoc;

    @RelPath(value="bedgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String bedgrp_isb_pts_adrblk;

    @RelPath(value="bedgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String bedgrp_isb_pts_extkey;

    @RelPath(value="latp.docgrdm.docgrd",dir=DirType.OUT)
    private ModuleList<Docgrd> latp_docgrdm_docgrd;

    @RelPath(value="latp.to",dir=DirType.BOTH)
    private String latp_to;


}