package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LetopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ledgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_advdat;

    @RelPath(value="ledgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_expdat;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_opndat;

    @RelPath(value="ledgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ledgrp_rec_shpdat;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="ledgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_apl_pts_adrblk;

    @RelPath(value="ledgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_apl_pts_extkey;

    @RelPath(value="ledgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String ledgrp_isb_pts_adrblk;

    @RelPath(value="ledgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String ledgrp_isb_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}