package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LetzrnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="lzdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lzdgrp_rec_credat;

    @RelPath(value="lzdgrp.rec.feenam",dir=DirType.BOTH)
    private String lzdgrp_rec_feenam;

    @RelPath(value="lzdgrp.rec.zrramm",dir=DirType.BOTH)
    private String lzdgrp_rec_zrramm;

    @RelPath(value="lzdgrp.rec.zrramt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lzdgrp_rec_zrramt;

    @RelPath(value="lzdgrp.rec.zrrcur",dir=DirType.BOTH)
    private String lzdgrp_rec_zrrcur;

    @RelPath(value="lzdgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String lzdgrp_adv_pts_adrblk;

    @RelPath(value="lzdgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String lzdgrp_adv_pts_extkey;

    @RelPath(value="lzdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String lzdgrp_ben_pts_adrblk;

    @RelPath(value="lzdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String lzdgrp_ben_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}