package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LitameVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="lidgrp.rec.addfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_addfee;

    @RelPath(value="lidgrp.rec.amefee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_amefee;

    @RelPath(value="lidgrp.rec.amenbr",dir=DirType.BOTH)
    private int lidgrp_rec_amenbr;

    @RelPath(value="lidgrp.rec.bchcod",dir=DirType.BOTH)
    private String lidgrp_rec_bchcod;

    @RelPath(value="lidgrp.rec.chrgameby",dir=DirType.BOTH)
    private String lidgrp_rec_chrgameby;

    @RelPath(value="lidgrp.rec.creamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_creamedat;

    @RelPath(value="lidgrp.rec.decamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_decamt;

    @RelPath(value="lidgrp.rec.expamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_expamedat;

    @RelPath(value="lidgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_expdat;

    @RelPath(value="lidgrp.rec.incamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_incamt;

    @RelPath(value="lidgrp.rec.issameamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_issameamt;

    @RelPath(value="lidgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_issamt;

    @RelPath(value="lidgrp.rec.isscur",dir=DirType.BOTH)
    private String lidgrp_rec_isscur;

    @RelPath(value="lidgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_opndat;

    @RelPath(value="lidgrp.rec.poramedis",dir=DirType.BOTH)
    private String lidgrp_rec_poramedis;

    @RelPath(value="lidgrp.rec.porameloa",dir=DirType.BOTH)
    private String lidgrp_rec_porameloa;

    @RelPath(value="lidgrp.rec.pordis",dir=DirType.BOTH)
    private String lidgrp_rec_pordis;

    @RelPath(value="lidgrp.rec.porloa",dir=DirType.BOTH)
    private String lidgrp_rec_porloa;

    @RelPath(value="lidgrp.rec.shpamedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_shpamedat;

    @RelPath(value="lidgrp.rec.shpamefro",dir=DirType.BOTH)
    private String lidgrp_rec_shpamefro;

    @RelPath(value="lidgrp.rec.shpameto",dir=DirType.BOTH)
    private String lidgrp_rec_shpameto;

    @RelPath(value="lidgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_shpdat;

    @RelPath(value="lidgrp.rec.shpfro",dir=DirType.BOTH)
    private String lidgrp_rec_shpfro;

    @RelPath(value="lidgrp.rec.shpto",dir=DirType.BOTH)
    private String lidgrp_rec_shpto;

    @RelPath(value="lidgrp.rec.sndtyp",dir=DirType.BOTH)
    private String lidgrp_rec_sndtyp;

    @RelPath(value="lidgrp.rec.stlref",dir=DirType.BOTH)
    private String lidgrp_rec_stlref;

    @RelPath(value="lidgrp.apl.pty.nam",dir=DirType.BOTH)
    private String lidgrp_apl_pty_nam;

    @RelPath(value="lidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_ben_pts_adrblk;

    @RelPath(value="lidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_ben_pts_extkey;

    @RelPath(value="lidgrp.blk.addgod",dir=DirType.BOTH)
    private String lidgrp_blk_addgod;

    @RelPath(value="lidgrp.blk.ametxt",dir=DirType.BOTH)
    private String lidgrp_blk_ametxt;

    @RelPath(value="lidgrp.flbz",dir=DirType.BOTH)
    private String lidgrp_flbz;

    @RelPath(value="lidgrp.mben.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_mben_pts_adrblk;

    @RelPath(value="lidgrp.mben.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_mben_pts_extkey;

    @RelPath(value="lidgrp.sxf",dir=DirType.BOTH)
    private String lidgrp_sxf;

    @RelPath(value="litp.tepaam",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal litp_tepaam;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}