package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LitcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="lidgrp.rec.bchcod",dir=DirType.BOTH)
    private String lidgrp_rec_bchcod;

    @RelPath(value="lidgrp.rec.cfmamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_cfmamt;

    @RelPath(value="lidgrp.rec.cfmcur",dir=DirType.BOTH)
    private String lidgrp_rec_cfmcur;

    @RelPath(value="lidgrp.rec.cfmflg",dir=DirType.BOTH)
    private String lidgrp_rec_cfmflg;

    @RelPath(value="lidgrp.rec.conamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_conamt;

    @RelPath(value="lidgrp.rec.concur",dir=DirType.BOTH)
    private String lidgrp_rec_concur;

    @RelPath(value="lidgrp.rec.conno",dir=DirType.BOTH)
    private String lidgrp_rec_conno;

    @RelPath(value="lidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_credat;

    @RelPath(value="lidgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_issamt;

    @RelPath(value="lidgrp.rec.isscur",dir=DirType.BOTH)
    private String lidgrp_rec_isscur;

    @RelPath(value="lidgrp.rec.likman",dir=DirType.BOTH)
    private String lidgrp_rec_likman;

    @RelPath(value="lidgrp.rec.moble",dir=DirType.BOTH)
    private String lidgrp_rec_moble;

    @RelPath(value="lidgrp.rec.nomton",dir=DirType.BOTH)
    private int lidgrp_rec_nomton;

    @RelPath(value="lidgrp.rec.nomtop",dir=DirType.BOTH)
    private int lidgrp_rec_nomtop;

    @RelPath(value="lidgrp.rec.stlref",dir=DirType.BOTH)
    private String lidgrp_rec_stlref;

    @RelPath(value="lidgrp.apl.pts.ref",dir=DirType.BOTH)
    private String lidgrp_apl_pts_ref;

    @RelPath(value="lidgrp.blk.lctxt",dir=DirType.BOTH)
    private String lidgrp_blk_lctxt;

    @RelPath(value="lidgrp.blk.trstxt",dir=DirType.BOTH)
    private String lidgrp_blk_trstxt;

    @RelPath(value="lidgrp.isb.pts.nam",dir=DirType.BOTH)
    private String lidgrp_isb_pts_nam;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}