package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LitmavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="lidgrp.rec.advdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_advdat;

    @RelPath(value="lidgrp.rec.amedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_amedat;

    @RelPath(value="lidgrp.rec.amenbr",dir=DirType.BOTH)
    private int lidgrp_rec_amenbr;

    @RelPath(value="lidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_credat;

    @RelPath(value="lidgrp.rec.stlref",dir=DirType.BOTH)
    private String lidgrp_rec_stlref;

    @RelPath(value="lidgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_adv_pts_adrblk;

    @RelPath(value="lidgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_adv_pts_extkey;

    @RelPath(value="lidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_apl_pts_adrblk;

    @RelPath(value="lidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_ben_pts_adrblk;

    @RelPath(value="lidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_ben_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}