package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LittriVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="lidgrp.rec.apprul",dir=DirType.BOTH)
    private String lidgrp_rec_apprul;

    @RelPath(value="lidgrp.rec.apprultxt",dir=DirType.BOTH)
    private String lidgrp_rec_apprultxt;

    @RelPath(value="lidgrp.rec.avbby",dir=DirType.BOTH)
    private String lidgrp_rec_avbby;

    @RelPath(value="lidgrp.rec.avbwth",dir=DirType.BOTH)
    private String lidgrp_rec_avbwth;

    @RelPath(value="lidgrp.rec.avbwths",dir=DirType.BOTH)
    private String lidgrp_rec_avbwths;

    @RelPath(value="lidgrp.rec.bchcod",dir=DirType.BOTH)
    private String lidgrp_rec_bchcod;

    @RelPath(value="lidgrp.rec.cnfflg",dir=DirType.BOTH)
    private String lidgrp_rec_cnfflg;

    @RelPath(value="lidgrp.rec.conamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_conamt;

    @RelPath(value="lidgrp.rec.concur",dir=DirType.BOTH)
    private String lidgrp_rec_concur;

    @RelPath(value="lidgrp.rec.conno",dir=DirType.BOTH)
    private String lidgrp_rec_conno;

    @RelPath(value="lidgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_credat;

    @RelPath(value="lidgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_expdat;

    @RelPath(value="lidgrp.rec.expplc",dir=DirType.BOTH)
    private String lidgrp_rec_expplc;

    @RelPath(value="lidgrp.rec.issamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal lidgrp_rec_issamt;

    @RelPath(value="lidgrp.rec.isscur",dir=DirType.BOTH)
    private String lidgrp_rec_isscur;

    @RelPath(value="lidgrp.rec.likman",dir=DirType.BOTH)
    private String lidgrp_rec_likman;

    @RelPath(value="lidgrp.rec.moble",dir=DirType.BOTH)
    private String lidgrp_rec_moble;

    @RelPath(value="lidgrp.rec.nomton",dir=DirType.BOTH)
    private int lidgrp_rec_nomton;

    @RelPath(value="lidgrp.rec.nomtop",dir=DirType.BOTH)
    private int lidgrp_rec_nomtop;

    @RelPath(value="lidgrp.rec.ownref",dir=DirType.BOTH)
    private String lidgrp_rec_ownref;

    @RelPath(value="lidgrp.rec.pordis",dir=DirType.BOTH)
    private String lidgrp_rec_pordis;

    @RelPath(value="lidgrp.rec.porloa",dir=DirType.BOTH)
    private String lidgrp_rec_porloa;

    @RelPath(value="lidgrp.rec.preper",dir=DirType.BOTH)
    private String lidgrp_rec_preper;

    @RelPath(value="lidgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_rec_shpdat;

    @RelPath(value="lidgrp.rec.shpfro",dir=DirType.BOTH)
    private String lidgrp_rec_shpfro;

    @RelPath(value="lidgrp.rec.shppar",dir=DirType.BOTH)
    private String lidgrp_rec_shppar;

    @RelPath(value="lidgrp.rec.shpto",dir=DirType.BOTH)
    private String lidgrp_rec_shpto;

    @RelPath(value="lidgrp.rec.shptrs",dir=DirType.BOTH)
    private String lidgrp_rec_shptrs;

    @RelPath(value="lidgrp.rec.trfflg",dir=DirType.BOTH)
    private String lidgrp_rec_trfflg;

    @RelPath(value="lidgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_adv_pts_adrblk;

    @RelPath(value="lidgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_adv_pts_extkey;

    @RelPath(value="lidgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_apl_pts_adrblk;

    @RelPath(value="lidgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_apl_pts_extkey;

    @RelPath(value="lidgrp.aplb.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_aplb_pts_adrblk;

    @RelPath(value="lidgrp.aplb.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_aplb_pts_extkey;

    @RelPath(value="lidgrp.aplb.pty.nam",dir=DirType.BOTH)
    private String lidgrp_aplb_pty_nam;

    @RelPath(value="lidgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String lidgrp_ben_pts_adrblk;

    @RelPath(value="lidgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String lidgrp_ben_pts_extkey;

    @RelPath(value="lidgrp.blk.defdet",dir=DirType.BOTH)
    private String lidgrp_blk_defdet;

    @RelPath(value="lidgrp.blk.dftat",dir=DirType.BOTH)
    private String lidgrp_blk_dftat;

    @RelPath(value="lidgrp.blk.feetxt",dir=DirType.BOTH)
    private String lidgrp_blk_feetxt;

    @RelPath(value="lidgrp.blk.lcrdoc",dir=DirType.BOTH)
    private String lidgrp_blk_lcrdoc;

    @RelPath(value="lidgrp.blk.mixdet",dir=DirType.BOTH)
    private String lidgrp_blk_mixdet;

    @RelPath(value="lidgrp.blk.negins",dir=DirType.BOTH)
    private String lidgrp_blk_negins;

    @RelPath(value="lidgrp.blk.trstxt",dir=DirType.BOTH)
    private String lidgrp_blk_trstxt;

    @RelPath(value="lidgrp.dap.pts.nam",dir=DirType.BOTH)
    private String lidgrp_dap_pts_nam;

    @RelPath(value="lidgrp.swfa",dir=DirType.BOTH)
    private String lidgrp_swfa;

    @RelPath(value="lidgrp.swfd",dir=DirType.BOTH)
    private String lidgrp_swfd;

    @RelPath(value="litp.dapp.curcus",dir=DirType.BOTH)
    private String litp_dapp_curcus;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}