package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LttdavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ltdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_expdat;

    @RelPath(value="ltdgrp.rec.lccref",dir=DirType.BOTH)
    private String ltdgrp_rec_lccref;

    @RelPath(value="ltdgrp.rec.opndat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_opndat;

    @RelPath(value="ltdgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_shpdat;

    @RelPath(value="ltdgrp.rec.stlref",dir=DirType.BOTH)
    private String ltdgrp_rec_stlref;

    @RelPath(value="ltdgrp.rec.zrramt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ltdgrp_rec_zrramt;

    @RelPath(value="ltdgrp.rec.zrrcur",dir=DirType.BOTH)
    private String ltdgrp_rec_zrrcur;

    @RelPath(value="ltdgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String ltdgrp_adv_pts_adrblk;

    @RelPath(value="ltdgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String ltdgrp_adv_pts_extkey;

    @RelPath(value="ltdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String ltdgrp_ben_pts_adrblk;

    @RelPath(value="ltdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String ltdgrp_ben_pts_extkey;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;


}