package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LttopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="ledgrp.rec.lccamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ledgrp_rec_lccamt;

    @RelPath(value="ledgrp.rec.lcccur",dir=DirType.BOTH)
    private String ledgrp_rec_lcccur;

    @RelPath(value="ledgrp.rec.lccref",dir=DirType.BOTH)
    private String ledgrp_rec_lccref;

    @RelPath(value="ledgrp.rec.stlref",dir=DirType.BOTH)
    private String ledgrp_rec_stlref;

    @RelPath(value="ltdgrp.rec.bchcod",dir=DirType.BOTH)
    private String ltdgrp_rec_bchcod;

    @RelPath(value="ltdgrp.rec.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_credat;

    @RelPath(value="ltdgrp.rec.djjamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ltdgrp_rec_djjamt;

    @RelPath(value="ltdgrp.rec.expdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_expdat;

    @RelPath(value="ltdgrp.rec.expplc",dir=DirType.BOTH)
    private String ltdgrp_rec_expplc;

    @RelPath(value="ltdgrp.rec.feenam",dir=DirType.BOTH)
    private String ltdgrp_rec_feenam;

    @RelPath(value="ltdgrp.rec.isalt",dir=DirType.BOTH)
    private String ltdgrp_rec_isalt;

    @RelPath(value="ltdgrp.rec.isrep",dir=DirType.BOTH)
    private String ltdgrp_rec_isrep;

    @RelPath(value="ltdgrp.rec.notrep",dir=DirType.BOTH)
    private String ltdgrp_rec_notrep;

    @RelPath(value="ltdgrp.rec.ownref",dir=DirType.BOTH)
    private String ltdgrp_rec_ownref;

    @RelPath(value="ltdgrp.rec.prepers18",dir=DirType.BOTH)
    private String ltdgrp_rec_prepers18;

    @RelPath(value="ltdgrp.rec.qtdata",dir=DirType.BOTH)
    private String ltdgrp_rec_qtdata;

    @RelPath(value="ltdgrp.rec.shpdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date ltdgrp_rec_shpdat;

    @RelPath(value="ltdgrp.rec.slnumb",dir=DirType.BOTH)
    private String ltdgrp_rec_slnumb;

    @RelPath(value="ltdgrp.rec.sm1",dir=DirType.BOTH)
    private String ltdgrp_rec_sm1;

    @RelPath(value="ltdgrp.rec.sm2",dir=DirType.BOTH)
    private String ltdgrp_rec_sm2;

    @RelPath(value="ltdgrp.rec.sm3",dir=DirType.BOTH)
    private String ltdgrp_rec_sm3;

    @RelPath(value="ltdgrp.rec.tbblmt",dir=DirType.BOTH)
    private String ltdgrp_rec_tbblmt;

    @RelPath(value="ltdgrp.rec.zrramm",dir=DirType.BOTH)
    private String ltdgrp_rec_zrramm;

    @RelPath(value="ltdgrp.rec.zrramt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal ltdgrp_rec_zrramt;

    @RelPath(value="ltdgrp.rec.zrrcur",dir=DirType.BOTH)
    private String ltdgrp_rec_zrrcur;

    @RelPath(value="ltdgrp.rec.zrsty",dir=DirType.BOTH)
    private String ltdgrp_rec_zrsty;

    @RelPath(value="ltdgrp.adv.pts.adrblk",dir=DirType.BOTH)
    private String ltdgrp_adv_pts_adrblk;

    @RelPath(value="ltdgrp.adv.pts.extkey",dir=DirType.BOTH)
    private String ltdgrp_adv_pts_extkey;

    @RelPath(value="ltdgrp.aplnam",dir=DirType.BOTH)
    private String ltdgrp_aplnam;

    @RelPath(value="ltdgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String ltdgrp_ben_pts_adrblk;

    @RelPath(value="ltdgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String ltdgrp_ben_pts_extkey;

    @RelPath(value="ltdgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String ltdgrp_isb_pts_adrblk;

    @RelPath(value="ltdgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String ltdgrp_isb_pts_extkey;

    @RelPath(value="rmkmod.ntext",dir=DirType.BOTH)
    private String rmkmod_ntext;

    @RelPath(value="rmkmod.otext",dir=DirType.BOTH)
    private String rmkmod_otext;


}