package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class LxtcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="lidgrp.checked",dir=DirType.BOTH)
    private String lidgrp_checked;

    @RelPath(value="lidgrp.lxd.bctk",dir=DirType.BOTH)
    private String lidgrp_lxd_bctk;

    @RelPath(value="lidgrp.lxd.czwyh",dir=DirType.BOTH)
    private String lidgrp_lxd_czwyh;

    @RelPath(value="lidgrp.lxd.dbfs1",dir=DirType.BOTH)
    private String lidgrp_lxd_dbfs1;

    @RelPath(value="lidgrp.lxd.dbfs2",dir=DirType.BOTH)
    private String lidgrp_lxd_dbfs2;

    @RelPath(value="lidgrp.lxd.dbfs3",dir=DirType.BOTH)
    private String lidgrp_lxd_dbfs3;

    @RelPath(value="lidgrp.lxd.dbr1",dir=DirType.BOTH)
    private String lidgrp_lxd_dbr1;

    @RelPath(value="lidgrp.lxd.dbr2",dir=DirType.BOTH)
    private String lidgrp_lxd_dbr2;

    @RelPath(value="lidgrp.lxd.dbr3",dir=DirType.BOTH)
    private String lidgrp_lxd_dbr3;

    @RelPath(value="lidgrp.lxd.dsdz",dir=DirType.BOTH)
    private String lidgrp_lxd_dsdz;

    @RelPath(value="lidgrp.lxd.dslxdh",dir=DirType.BOTH)
    private String lidgrp_lxd_dslxdh;

    @RelPath(value="lidgrp.lxd.dsr",dir=DirType.BOTH)
    private String lidgrp_lxd_dsr;

    @RelPath(value="lidgrp.lxd.dsyzbm",dir=DirType.BOTH)
    private String lidgrp_lxd_dsyzbm;

    @RelPath(value="lidgrp.lxd.fxl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal lidgrp_lxd_fxl;

    @RelPath(value="lidgrp.lxd.fymx",dir=DirType.BOTH)
    private String lidgrp_lxd_fymx;

    @RelPath(value="lidgrp.lxd.htbh1",dir=DirType.BOTH)
    private String lidgrp_lxd_htbh1;

    @RelPath(value="lidgrp.lxd.htbh2",dir=DirType.BOTH)
    private String lidgrp_lxd_htbh2;

    @RelPath(value="lidgrp.lxd.htbh3",dir=DirType.BOTH)
    private String lidgrp_lxd_htbh3;

    @RelPath(value="lidgrp.lxd.htmc1",dir=DirType.BOTH)
    private String lidgrp_lxd_htmc1;

    @RelPath(value="lidgrp.lxd.htmc2",dir=DirType.BOTH)
    private String lidgrp_lxd_htmc2;

    @RelPath(value="lidgrp.lxd.htmc3",dir=DirType.BOTH)
    private String lidgrp_lxd_htmc3;

    @RelPath(value="lidgrp.lxd.jf",dir=DirType.BOTH)
    private String lidgrp_lxd_jf;

    @RelPath(value="lidgrp.lxd.jffr",dir=DirType.BOTH)
    private String lidgrp_lxd_jffr;

    @RelPath(value="lidgrp.lxd.jfzs",dir=DirType.BOTH)
    private String lidgrp_lxd_jfzs;

    @RelPath(value="lidgrp.lxd.ktdd",dir=DirType.BOTH)
    private String lidgrp_lxd_ktdd;

    @RelPath(value="lidgrp.lxd.qtfs",dir=DirType.BOTH)
    private String lidgrp_lxd_qtfs;

    @RelPath(value="lidgrp.lxd.shhtbh",dir=DirType.BOTH)
    private String lidgrp_lxd_shhtbh;

    @RelPath(value="lidgrp.lxd.shhtje",dir=DirType.BOTH)
    private String lidgrp_lxd_shhtje;

    @RelPath(value="lidgrp.lxd.sxhtmc",dir=DirType.BOTH)
    private String lidgrp_lxd_sxhtmc;

    @RelPath(value="lidgrp.lxd.xqqs",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_lxd_xqqs;

    @RelPath(value="lidgrp.lxd.xqzz",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lidgrp_lxd_xqzz;

    @RelPath(value="lidgrp.lxd.xyzqk",dir=DirType.BOTH)
    private String lidgrp_lxd_xyzqk;

    @RelPath(value="lidgrp.lxd.yf",dir=DirType.BOTH)
    private String lidgrp_lxd_yf;

    @RelPath(value="lidgrp.lxd.yfczhm",dir=DirType.BOTH)
    private String lidgrp_lxd_yfczhm;

    @RelPath(value="lidgrp.lxd.yfdwdz",dir=DirType.BOTH)
    private String lidgrp_lxd_yfdwdz;

    @RelPath(value="lidgrp.lxd.yfdwmc",dir=DirType.BOTH)
    private String lidgrp_lxd_yfdwmc;

    @RelPath(value="lidgrp.lxd.yfdzyj",dir=DirType.BOTH)
    private String lidgrp_lxd_yfdzyj;

    @RelPath(value="lidgrp.lxd.yffr",dir=DirType.BOTH)
    private String lidgrp_lxd_yffr;

    @RelPath(value="lidgrp.lxd.yflxdh",dir=DirType.BOTH)
    private String lidgrp_lxd_yflxdh;

    @RelPath(value="lidgrp.lxd.yflxr",dir=DirType.BOTH)
    private String lidgrp_lxd_yflxr;

    @RelPath(value="lidgrp.lxd.yfqqhm",dir=DirType.BOTH)
    private String lidgrp_lxd_yfqqhm;

    @RelPath(value="lidgrp.lxd.yfqtqttj",dir=DirType.BOTH)
    private String lidgrp_lxd_yfqtqttj;

    @RelPath(value="lidgrp.lxd.yfsjhm",dir=DirType.BOTH)
    private String lidgrp_lxd_yfsjhm;

    @RelPath(value="lidgrp.lxd.yfwxhm",dir=DirType.BOTH)
    private String lidgrp_lxd_yfwxhm;

    @RelPath(value="lidgrp.lxd.yfyzbm",dir=DirType.BOTH)
    private String lidgrp_lxd_yfyzbm;

    @RelPath(value="lidgrp.lxd.yfzs",dir=DirType.BOTH)
    private String lidgrp_lxd_yfzs;

    @RelPath(value="lidgrp.lxd.zcfzb",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal lidgrp_lxd_zcfzb;

    @RelPath(value="lidgrp.lxd.zcjz",dir=DirType.BOTH)
    private String lidgrp_lxd_zcjz;

    @RelPath(value="lidgrp.lxd.zcldbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal lidgrp_lxd_zcldbl;

    @RelPath(value="lidgrp.lxd.zyjjfs",dir=DirType.BOTH)
    private String lidgrp_lxd_zyjjfs;


}