package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class MakdocVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="docgrp.bed.credat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date docgrp_bed_credat;

    @RelPath(value="docgrp.bed.docamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal docgrp_bed_docamt;

    @RelPath(value="docgrp.bed.doccur",dir=DirType.BOTH)
    private String docgrp_bed_doccur;

    @RelPath(value="docgrp.bed.invno",dir=DirType.BOTH)
    private String docgrp_bed_invno;

    @RelPath(value="docgrp.bed.ownref",dir=DirType.BOTH)
    private String docgrp_bed_ownref;

    @RelPath(value="docgrp.bed.pntref",dir=DirType.BOTH)
    private String docgrp_bed_pntref;

    @RelPath(value="docgrp.ben.pts.adrblk",dir=DirType.BOTH)
    private String docgrp_ben_pts_adrblk;

    @RelPath(value="docgrp.ben.pts.extkey",dir=DirType.BOTH)
    private String docgrp_ben_pts_extkey;

    @RelPath(value="docgrp.isb.pts.adrblk",dir=DirType.BOTH)
    private String docgrp_isb_pts_adrblk;

    @RelPath(value="docgrp.isb.pts.extkey",dir=DirType.BOTH)
    private String docgrp_isb_pts_extkey;

    @RelPath(value="docp.advinf",dir=DirType.BOTH)
    private String docp_advinf;

    @RelPath(value="docp.doctyp",dir=DirType.BOTH)
    private String docp_doctyp;

    @RelPath(value="docp.swiftinf",dir=DirType.BOTH)
    private String docp_swiftinf;


}