package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class MarcfmVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="margrp.bxd.amt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal margrp_bxd_amt;

    @RelPath(value="margrp.bxd.bctk",dir=DirType.BOTH)
    private String margrp_bxd_bctk;

    @RelPath(value="margrp.bxd.bzbzjts",dir=DirType.BOTH)
    private int margrp_bxd_bzbzjts;

    @RelPath(value="margrp.bxd.bzjbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal margrp_bxd_bzjbl;

    @RelPath(value="margrp.bxd.bzjdqr",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date margrp_bxd_bzjdqr;

    @RelPath(value="margrp.bxd.bzjqcrq",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date margrp_bxd_bzjqcrq;

    @RelPath(value="margrp.bxd.bzjzh",dir=DirType.BOTH)
    private String margrp_bxd_bzjzh;

    @RelPath(value="margrp.bxd.cgyd",dir=DirType.BOTH)
    private String margrp_bxd_cgyd;

    @RelPath(value="margrp.bxd.cur",dir=DirType.BOTH)
    private String margrp_bxd_cur;

    @RelPath(value="margrp.bxd.dsdz",dir=DirType.BOTH)
    private String margrp_bxd_dsdz;

    @RelPath(value="margrp.bxd.dslxdh",dir=DirType.BOTH)
    private String margrp_bxd_dslxdh;

    @RelPath(value="margrp.bxd.dsr",dir=DirType.BOTH)
    private String margrp_bxd_dsr;

    @RelPath(value="margrp.bxd.dsrdh2",dir=DirType.BOTH)
    private String margrp_bxd_dsrdh2;

    @RelPath(value="margrp.bxd.dsrdz2",dir=DirType.BOTH)
    private String margrp_bxd_dsrdz2;

    @RelPath(value="margrp.bxd.dsryb2",dir=DirType.BOTH)
    private String margrp_bxd_dsryb2;

    @RelPath(value="margrp.bxd.dsyzbm",dir=DirType.BOTH)
    private String margrp_bxd_dsyzbm;

    @RelPath(value="margrp.bxd.htbh",dir=DirType.BOTH)
    private String margrp_bxd_htbh;

    @RelPath(value="margrp.bxd.htmc",dir=DirType.BOTH)
    private String margrp_bxd_htmc;

    @RelPath(value="margrp.bxd.jf",dir=DirType.BOTH)
    private String margrp_bxd_jf;

    @RelPath(value="margrp.bxd.jffrdb",dir=DirType.BOTH)
    private String margrp_bxd_jffrdb;

    @RelPath(value="margrp.bxd.jsyd",dir=DirType.BOTH)
    private String margrp_bxd_jsyd;

    @RelPath(value="margrp.bxd.jsydqt",dir=DirType.BOTH)
    private String margrp_bxd_jsydqt;

    @RelPath(value="margrp.bxd.jxyd",dir=DirType.BOTH)
    private String margrp_bxd_jxyd;

    @RelPath(value="margrp.bxd.jxydqt",dir=DirType.BOTH)
    private String margrp_bxd_jxydqt;

    @RelPath(value="margrp.bxd.ktdd",dir=DirType.BOTH)
    private String margrp_bxd_ktdd;

    @RelPath(value="margrp.bxd.nll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(5)
    private BigDecimal margrp_bxd_nll;

    @RelPath(value="margrp.bxd.qtfs",dir=DirType.BOTH)
    private String margrp_bxd_qtfs;

    @RelPath(value="margrp.bxd.ts",dir=DirType.BOTH)
    private int margrp_bxd_ts;

    @RelPath(value="margrp.bxd.wyjbl",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal margrp_bxd_wyjbl;

    @RelPath(value="margrp.bxd.yf",dir=DirType.BOTH)
    private String margrp_bxd_yf;

    @RelPath(value="margrp.bxd.yfczhm",dir=DirType.BOTH)
    private String margrp_bxd_yfczhm;

    @RelPath(value="margrp.bxd.yfdwdz",dir=DirType.BOTH)
    private String margrp_bxd_yfdwdz;

    @RelPath(value="margrp.bxd.yfdwmc",dir=DirType.BOTH)
    private String margrp_bxd_yfdwmc;

    @RelPath(value="margrp.bxd.yfdzyj",dir=DirType.BOTH)
    private String margrp_bxd_yfdzyj;

    @RelPath(value="margrp.bxd.yffrdb",dir=DirType.BOTH)
    private String margrp_bxd_yffrdb;

    @RelPath(value="margrp.bxd.yflxdh",dir=DirType.BOTH)
    private String margrp_bxd_yflxdh;

    @RelPath(value="margrp.bxd.yflxdh2",dir=DirType.BOTH)
    private String margrp_bxd_yflxdh2;

    @RelPath(value="margrp.bxd.yflxr",dir=DirType.BOTH)
    private String margrp_bxd_yflxr;

    @RelPath(value="margrp.bxd.yfsjhm",dir=DirType.BOTH)
    private String margrp_bxd_yfsjhm;

    @RelPath(value="margrp.bxd.yfsjrdz",dir=DirType.BOTH)
    private String margrp_bxd_yfsjrdz;

    @RelPath(value="margrp.bxd.yfsjrmc",dir=DirType.BOTH)
    private String margrp_bxd_yfsjrmc;

    @RelPath(value="margrp.bxd.yfyzbm",dir=DirType.BOTH)
    private String margrp_bxd_yfyzbm;

    @RelPath(value="margrp.bxd.yfyzbm2",dir=DirType.BOTH)
    private String margrp_bxd_yfyzbm2;

    @RelPath(value="margrp.bxd.yfzjhm",dir=DirType.BOTH)
    private String margrp_bxd_yfzjhm;

    @RelPath(value="margrp.bxd.yfzjlx",dir=DirType.BOTH)
    private String margrp_bxd_yfzjlx;

    @RelPath(value="margrp.bxd.yfzrr",dir=DirType.BOTH)
    private String margrp_bxd_yfzrr;

    @RelPath(value="margrp.bxd.yll",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(5)
    private BigDecimal margrp_bxd_yll;

    @RelPath(value="margrp.bxd.ys",dir=DirType.BOTH)
    private int margrp_bxd_ys;

    @RelPath(value="margrp.bxd.ywzl",dir=DirType.BOTH)
    private String margrp_bxd_ywzl;

    @RelPath(value="margrp.bxd.zcwyh",dir=DirType.BOTH)
    private String margrp_bxd_zcwyh;

    @RelPath(value="margrp.bxd.zddsrmc2",dir=DirType.BOTH)
    private String margrp_bxd_zddsrmc2;

    @RelPath(value="margrp.bxd.zwr",dir=DirType.BOTH)
    private String margrp_bxd_zwr;

    @RelPath(value="margrp.bxd.zyjjfs",dir=DirType.BOTH)
    private String margrp_bxd_zyjjfs;


}