package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Stb;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class OfficeVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="advsize",dir=DirType.BOTH)
    private String advsize;

    @RelPath(value="autsize",dir=DirType.BOTH)
    private String autsize;

    @RelPath(value="backzise",dir=DirType.BOTH)
    private String backzise;

    @RelPath(value="bnksize",dir=DirType.BOTH)
    private String bnksize;

    @RelPath(value="dicsize",dir=DirType.BOTH)
    private String dicsize;

    @RelPath(value="hissize",dir=DirType.BOTH)
    private String hissize;

    @RelPath(value="notgrp.stblst",dir=DirType.OUT)
    private ModuleList<Stb> notgrp_stblst;

    @RelPath(value="notgrp.tdoimg",dir=DirType.BOTH)
    private String notgrp_tdoimg;

    @RelPath(value="pedsize",dir=DirType.BOTH)
    private String pedsize;

    @RelPath(value="tdolabel",dir=DirType.BOTH)
    private String tdolabel;

    @RelPath(value="todosize",dir=DirType.BOTH)
    private String todosize;


}