package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Rpdtmp;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class RptqurVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="rptp.begamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rptp_begamt;

    @RelPath(value="rptp.begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rptp_begdat;

    @RelPath(value="rptp.cur",dir=DirType.BOTH)
    private String rptp_cur;

    @RelPath(value="rptp.endamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rptp_endamt;

    @RelPath(value="rptp.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rptp_enddat;

    @RelPath(value="rptp.erssta",dir=DirType.BOTH)
    private String rptp_erssta;

    @RelPath(value="rptp.hnglbh",dir=DirType.BOTH)
    private String rptp_hnglbh;

    @RelPath(value="rptp.ownref",dir=DirType.BOTH)
    private String rptp_ownref;

    @RelPath(value="rptp.owntyp",dir=DirType.BOTH)
    private String rptp_owntyp;

    @RelPath(value="rptp.pyenam",dir=DirType.BOTH)
    private String rptp_pyenam;

    @RelPath(value="rptp.sta",dir=DirType.BOTH)
    private String rptp_sta;

    @RelPath(value="rptp.tmplst",dir=DirType.OUT)
    private ModuleList<Rpdtmp> rptp_tmplst;


}