package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class RptshwVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="rpdgrp.rec.actin1",dir=DirType.BOTH)
    private String rpdgrp_rec_actin1;

    @RelPath(value="rpdgrp.rec.actin2",dir=DirType.BOTH)
    private String rpdgrp_rec_actin2;

    @RelPath(value="rpdgrp.rec.actin3",dir=DirType.BOTH)
    private String rpdgrp_rec_actin3;

    @RelPath(value="rpdgrp.rec.addmsg",dir=DirType.BOTH)
    private String rpdgrp_rec_addmsg;

    @RelPath(value="rpdgrp.rec.agtact",dir=DirType.BOTH)
    private String rpdgrp_rec_agtact;

    @RelPath(value="rpdgrp.rec.agtextkey",dir=DirType.BOTH)
    private String rpdgrp_rec_agtextkey;

    @RelPath(value="rpdgrp.rec.awiact",dir=DirType.BOTH)
    private String rpdgrp_rec_awiact;

    @RelPath(value="rpdgrp.rec.awiextkey",dir=DirType.BOTH)
    private String rpdgrp_rec_awiextkey;

    @RelPath(value="rpdgrp.rec.awinam",dir=DirType.BOTH)
    private String rpdgrp_rec_awinam;

    @RelPath(value="rpdgrp.rec.bchcod",dir=DirType.BOTH)
    private String rpdgrp_rec_bchcod;

    @RelPath(value="rpdgrp.rec.beizhu",dir=DirType.BOTH)
    private String rpdgrp_rec_beizhu;

    @RelPath(value="rpdgrp.rec.chgrat",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(6)
    private BigDecimal rpdgrp_rec_chgrat;

    @RelPath(value="rpdgrp.rec.covsedcmt",dir=DirType.BOTH)
    private String rpdgrp_rec_covsedcmt;

    @RelPath(value="rpdgrp.rec.extkeyin1",dir=DirType.BOTH)
    private String rpdgrp_rec_extkeyin1;

    @RelPath(value="rpdgrp.rec.extkeyin2",dir=DirType.BOTH)
    private String rpdgrp_rec_extkeyin2;

    @RelPath(value="rpdgrp.rec.extkeyin3",dir=DirType.BOTH)
    private String rpdgrp_rec_extkeyin3;

    @RelPath(value="rpdgrp.rec.feerol",dir=DirType.BOTH)
    private String rpdgrp_rec_feerol;

    @RelPath(value="rpdgrp.rec.msgatr",dir=DirType.BOTH)
    private String rpdgrp_rec_msgatr;

    @RelPath(value="rpdgrp.rec.namin1",dir=DirType.BOTH)
    private String rpdgrp_rec_namin1;

    @RelPath(value="rpdgrp.rec.namin2",dir=DirType.BOTH)
    private String rpdgrp_rec_namin2;

    @RelPath(value="rpdgrp.rec.namin3",dir=DirType.BOTH)
    private String rpdgrp_rec_namin3;

    @RelPath(value="rpdgrp.rec.orcact",dir=DirType.BOTH)
    private String rpdgrp_rec_orcact;

    @RelPath(value="rpdgrp.rec.orcadr",dir=DirType.BOTH)
    private String rpdgrp_rec_orcadr;

    @RelPath(value="rpdgrp.rec.orcextkey",dir=DirType.BOTH)
    private String rpdgrp_rec_orcextkey;

    @RelPath(value="rpdgrp.rec.orcnam",dir=DirType.BOTH)
    private String rpdgrp_rec_orcnam;

    @RelPath(value="rpdgrp.rec.orctyp",dir=DirType.BOTH)
    private String rpdgrp_rec_orctyp;

    @RelPath(value="rpdgrp.rec.oriact",dir=DirType.BOTH)
    private String rpdgrp_rec_oriact;

    @RelPath(value="rpdgrp.rec.oriextkey",dir=DirType.BOTH)
    private String rpdgrp_rec_oriextkey;

    @RelPath(value="rpdgrp.rec.orinam",dir=DirType.BOTH)
    private String rpdgrp_rec_orinam;

    @RelPath(value="rpdgrp.rec.ownref",dir=DirType.BOTH)
    private String rpdgrp_rec_ownref;

    @RelPath(value="rpdgrp.rec.priamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rpdgrp_rec_priamt;

    @RelPath(value="rpdgrp.rec.pricur",dir=DirType.BOTH)
    private String rpdgrp_rec_pricur;

    @RelPath(value="rpdgrp.rec.pyeact",dir=DirType.BOTH)
    private String rpdgrp_rec_pyeact;

    @RelPath(value="rpdgrp.rec.pyeadr",dir=DirType.BOTH)
    private String rpdgrp_rec_pyeadr;

    @RelPath(value="rpdgrp.rec.pyeextkey",dir=DirType.BOTH)
    private String rpdgrp_rec_pyeextkey;

    @RelPath(value="rpdgrp.rec.pyenam",dir=DirType.BOTH)
    private String rpdgrp_rec_pyenam;

    @RelPath(value="rpdgrp.rec.rcvfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rpdgrp_rec_rcvfee;

    @RelPath(value="rpdgrp.rec.rcvfeecur",dir=DirType.BOTH)
    private String rpdgrp_rec_rcvfeecur;

    @RelPath(value="rpdgrp.rec.remcmt",dir=DirType.BOTH)
    private String rpdgrp_rec_remcmt;

    @RelPath(value="rpdgrp.rec.rptamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rpdgrp_rec_rptamt;

    @RelPath(value="rpdgrp.rec.rptcur",dir=DirType.BOTH)
    private String rpdgrp_rec_rptcur;

    @RelPath(value="rpdgrp.rec.sedcmt",dir=DirType.BOTH)
    private String rpdgrp_rec_sedcmt;

    @RelPath(value="rpdgrp.rec.sedfee",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rpdgrp_rec_sedfee;

    @RelPath(value="rpdgrp.rec.sedfeecur",dir=DirType.BOTH)
    private String rpdgrp_rec_sedfeecur;

    @RelPath(value="rpdgrp.rec.typcod",dir=DirType.BOTH)
    private String rpdgrp_rec_typcod;

    @RelPath(value="rpdgrp.rec.valdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rpdgrp_rec_valdat;

    @RelPath(value="rpdgrp.rec.xgckha",dir=DirType.BOTH)
    private String rpdgrp_rec_xgckha;

    @RelPath(value="rptp.ers.errdsc",dir=DirType.BOTH)
    private String rptp_ers_errdsc;

    @RelPath(value="rptp.ers.hnglbh",dir=DirType.BOTH)
    private String rptp_ers_hnglbh;


}