package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class TatopnVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="tasgrp.rec.bchcod",dir=DirType.BOTH)
    private String tasgrp_rec_bchcod;

    @RelPath(value="tasgrp.rec.cifno",dir=DirType.BOTH)
    private String tasgrp_rec_cifno;

    @RelPath(value="tasgrp.rec.entname",dir=DirType.BOTH)
    private String tasgrp_rec_entname;

    @RelPath(value="tasgrp.rec.ownref",dir=DirType.BOTH)
    private String tasgrp_rec_ownref;

    @RelPath(value="tasgrp.rec.protocolno",dir=DirType.BOTH)
    private String tasgrp_rec_protocolno;

    @RelPath(value="tasgrp.rec.reason",dir=DirType.BOTH)
    private String tasgrp_rec_reason;

    @RelPath(value="tasgrp.rec.tatdate",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date tasgrp_rec_tatdate;

    @RelPath(value="tasgrp.financeapplication",dir=DirType.BOTH)
    private String tasgrp_financeapplication;

    @RelPath(value="tasgrp.inwardremit",dir=DirType.BOTH)
    private String tasgrp_inwardremit;

    @RelPath(value="tasgrp.openaccount",dir=DirType.BOTH)
    private String tasgrp_openaccount;

    @RelPath(value="tasgrp.openguaraletter",dir=DirType.BOTH)
    private String tasgrp_openguaraletter;

    @RelPath(value="tasgrp.outwardremit",dir=DirType.BOTH)
    private String tasgrp_outwardremit;

    @RelPath(value="tasgrp.userbinding",dir=DirType.BOTH)
    private String tasgrp_userbinding;


}