package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Spt;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class TrsadvVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="advlst",dir=DirType.OUT)
    private ModuleList<Spt> advlst;

    @RelPath(value="btnmod.begdat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_begdat;

    @RelPath(value="btnmod.begdat1",dir=DirType.BOTH)
    private String btnmod_begdat1;

    @RelPath(value="btnmod.enddat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date btnmod_enddat;

    @RelPath(value="btnmod.enddat1",dir=DirType.BOTH)
    private String btnmod_enddat1;

    @RelPath(value="btnmod.query",dir=DirType.BOTH)
    private String btnmod_query;

    @RelPath(value="btnmod.trntyp",dir=DirType.BOTH)
    private String btnmod_trntyp;

    @RelPath(value="btnmod.trntyp1",dir=DirType.BOTH)
    private String btnmod_trntyp1;


}