package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.bo.Wfd;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class WfddefVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="wfd.nam",dir=DirType.BOTH)
    private String wfd_nam;

    @RelPath(value="wfd.objtyp",dir=DirType.BOTH)
    private String wfd_objtyp;

    @RelPath(value="wfd.req",dir=DirType.BOTH)
    private String wfd_req;

    @RelPath(value="wfd.rpl",dir=DirType.BOTH)
    private String wfd_rpl;

    @RelPath(value="wfd.txt",dir=DirType.BOTH)
    private String wfd_txt;

    @RelPath(value="wfdlst",dir=DirType.OUT)
    private ModuleList<Wfd> wfdlst;


}