package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class WitmavVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="widgrp.rec.amedat",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date widgrp_rec_amedat;

    @RelPath(value="widgrp.rec.cnyacc",dir=DirType.BOTH)
    private String widgrp_rec_cnyacc;

    @RelPath(value="widgrp.rec.cnybacc",dir=DirType.BOTH)
    private String widgrp_rec_cnybacc;

    @RelPath(value="widgrp.rec.fxacc",dir=DirType.BOTH)
    private String widgrp_rec_fxacc;

    @RelPath(value="widgrp.rec.fxbacc",dir=DirType.BOTH)
    private String widgrp_rec_fxbacc;

    @RelPath(value="widgrp.rec.jshfx",dir=DirType.BOTH)
    private String widgrp_rec_jshfx;

    @RelPath(value="widgrp.rec.qqfamt",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(3)
    private BigDecimal widgrp_rec_qqfamt;

    @RelPath(value="widgrp.rec.qqffx",dir=DirType.BOTH)
    private String widgrp_rec_qqffx;

    @RelPath(value="widgrp.rec.qqtyp",dir=DirType.BOTH)
    private String widgrp_rec_qqtyp;

    @RelPath(value="widgrp.rec.qqywlx",dir=DirType.BOTH)
    private String widgrp_rec_qqywlx;

    @RelPath(value="widgrp.rec.sfcejg",dir=DirType.BOTH)
    private String widgrp_rec_sfcejg;

    @RelPath(value="widgrp.rec.stlref",dir=DirType.BOTH)
    private String widgrp_rec_stlref;

    @RelPath(value="widgrp.rec.zxdate",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date widgrp_rec_zxdate;

    @RelPath(value="mtabut.imgtp.dztimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_dztimgref;

    @RelPath(value="mtabut.imgtp.stlimgref",dir=DirType.BOTH)
    private String mtabut_imgtp_stlimgref;

    @RelPath(value="widgrp.apl.pts.adrblk",dir=DirType.BOTH)
    private String widgrp_apl_pts_adrblk;

    @RelPath(value="widgrp.apl.pts.extkey",dir=DirType.BOTH)
    private String widgrp_apl_pts_extkey;


}