package com.ceb.gjjs.mda.web;

import com.brilliance.mda.runtime.mda.IContext;
import com.brilliance.mda.runtime.mda.driver.MdaEnv;
import com.brilliance.mda.runtime.request.BaseVO;
import com.brilliance.mda.support.cache.ICache;
import com.brilliance.mda.support.mybatis.DynamicDataSourceContextHolder;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerResponseContext;
import javax.ws.rs.container.ContainerResponseFilter;
import javax.ws.rs.ext.Provider;

/**
 * @Description
 * @Author s_guodong
 * @Date 2023/6/21
 */
@Provider
public class ResponseFilter implements ContainerResponseFilter {
    @Qualifier(ICache.CTX_CACHE)
    @Autowired
    private ICache<String, IContext> contextICache;

    @Override
    public void filter(ContainerRequestContext requestContext, ContainerResponseContext responseContext) {
        IContext context = MdaEnv.getContext();
        if (context != null) {
            BaseVO baseVO = context.getVo();
            String pageId = baseVO.getPageId();
            if (StringUtils.isNotBlank(pageId)) {
                contextICache.store(pageId, context);
            }
        }
        MdaEnv.removeAuthInfo();
        MdaEnv.removeAttrs();
        MdaEnv.clearContext();
        MdaEnv.removeGridData();

        // 资源释放
        DynamicDataSourceContextHolder.clearDataSourceType();
    }

}
