package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AcbameService;
import com.ceb.gjjs.mda.vo.AcbameVO;

public class AcbameServiceTest extends BaseTest{

    @Autowired
    private AcbameService acbame;

    @Test
    public void initTest() throws IOException {
        AcbameVO req = null;
        File file = Paths.get(testJsonDir, "acbame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbameVO> response = acbame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AcbameVO req = null;
        File file = Paths.get(testJsonDir, "acbame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbameVO> response = acbame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AcbameVO req = null;
        File file = Paths.get(testJsonDir, "acbame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbameVO> response = acbame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AcbameVO req = null;
        File file = Paths.get(testJsonDir, "acbame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbameVO> response = acbame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AcbameVO req = new AcbameVO();
        // 参数设置
        ResponseSet<AcbameVO> response = acbame.executeDefault(req,rule);
    }

}
