package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AcbopnService;
import com.ceb.gjjs.mda.vo.AcbopnVO;

public class AcbopnServiceTest extends BaseTest{

    @Autowired
    private AcbopnService acbopn;

    @Test
    public void initTest() throws IOException {
        AcbopnVO req = null;
        File file = Paths.get(testJsonDir, "acbopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbopnVO> response = acbopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AcbopnVO req = null;
        File file = Paths.get(testJsonDir, "acbopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbopnVO> response = acbopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AcbopnVO req = null;
        File file = Paths.get(testJsonDir, "acbopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbopnVO> response = acbopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AcbopnVO req = null;
        File file = Paths.get(testJsonDir, "acbopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbopnVO> response = acbopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AcbopnVO req = new AcbopnVO();
        // 参数设置
        ResponseSet<AcbopnVO> response = acbopn.executeDefault(req,rule);
    }

}
