package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AcbselService;
import com.ceb.gjjs.mda.vo.AcbselVO;

public class AcbselServiceTest extends BaseTest{

    @Autowired
    private AcbselService acbsel;

    @Test
    public void initTest() throws IOException {
        AcbselVO req = null;
        File file = Paths.get(testJsonDir, "acbsel").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbselVO> response = acbsel.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AcbselVO req = null;
        File file = Paths.get(testJsonDir, "acbsel").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbselVO> response = acbsel.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AcbselVO req = null;
        File file = Paths.get(testJsonDir, "acbsel").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbselVO> response = acbsel.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AcbselVO req = null;
        File file = Paths.get(testJsonDir, "acbsel").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcbselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcbselVO> response = acbsel.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AcbselVO req = new AcbselVO();
        // 参数设置
        ResponseSet<AcbselVO> response = acbsel.executeDefault(req,rule);
    }

}
