package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AcdopnService;
import com.ceb.gjjs.mda.vo.AcdopnVO;

public class AcdopnServiceTest extends BaseTest{

    @Autowired
    private AcdopnService acdopn;

    @Test
    public void initTest() throws IOException {
        AcdopnVO req = null;
        File file = Paths.get(testJsonDir, "acdopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdopnVO> response = acdopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AcdopnVO req = null;
        File file = Paths.get(testJsonDir, "acdopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdopnVO> response = acdopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AcdopnVO req = null;
        File file = Paths.get(testJsonDir, "acdopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdopnVO> response = acdopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AcdopnVO req = null;
        File file = Paths.get(testJsonDir, "acdopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdopnVO> response = acdopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AcdopnVO req = new AcdopnVO();
        // 参数设置
        ResponseSet<AcdopnVO> response = acdopn.executeDefault(req,rule);
    }

}
