package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AcdselService;
import com.ceb.gjjs.mda.vo.AcdselVO;

public class AcdselServiceTest extends BaseTest{

    @Autowired
    private AcdselService acdsel;

    @Test
    public void initTest() throws IOException {
        AcdselVO req = null;
        File file = Paths.get(testJsonDir, "acdsel").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdselVO> response = acdsel.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AcdselVO req = null;
        File file = Paths.get(testJsonDir, "acdsel").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdselVO> response = acdsel.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AcdselVO req = null;
        File file = Paths.get(testJsonDir, "acdsel").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdselVO> response = acdsel.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AcdselVO req = null;
        File file = Paths.get(testJsonDir, "acdsel").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AcdselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AcdselVO> response = acdsel.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AcdselVO req = new AcdselVO();
        // 参数设置
        ResponseSet<AcdselVO> response = acdsel.executeDefault(req,rule);
    }

}
