package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AnnalsService;
import com.ceb.gjjs.mda.vo.AnnalsVO;

public class AnnalsServiceTest extends BaseTest{

    @Autowired
    private AnnalsService annals;

    @Test
    public void initTest() throws IOException {
        AnnalsVO req = null;
        File file = Paths.get(testJsonDir, "annals").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AnnalsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AnnalsVO> response = annals.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AnnalsVO req = null;
        File file = Paths.get(testJsonDir, "annals").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AnnalsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AnnalsVO> response = annals.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AnnalsVO req = null;
        File file = Paths.get(testJsonDir, "annals").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AnnalsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AnnalsVO> response = annals.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AnnalsVO req = null;
        File file = Paths.get(testJsonDir, "annals").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AnnalsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AnnalsVO> response = annals.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AnnalsVO req = new AnnalsVO();
        // 参数设置
        ResponseSet<AnnalsVO> response = annals.executeDefault(req,rule);
    }

}
