package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AptcfmService;
import com.ceb.gjjs.mda.vo.AptcfmVO;

public class AptcfmServiceTest extends BaseTest{

    @Autowired
    private AptcfmService aptcfm;

    @Test
    public void initTest() throws IOException {
        AptcfmVO req = null;
        File file = Paths.get(testJsonDir, "aptcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptcfmVO> response = aptcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AptcfmVO req = null;
        File file = Paths.get(testJsonDir, "aptcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptcfmVO> response = aptcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AptcfmVO req = null;
        File file = Paths.get(testJsonDir, "aptcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptcfmVO> response = aptcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AptcfmVO req = null;
        File file = Paths.get(testJsonDir, "aptcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptcfmVO> response = aptcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AptcfmVO req = new AptcfmVO();
        // 参数设置
        ResponseSet<AptcfmVO> response = aptcfm.executeDefault(req,rule);
    }

}
