package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AptmdlService;
import com.ceb.gjjs.mda.vo.AptmdlVO;

public class AptmdlServiceTest extends BaseTest{

    @Autowired
    private AptmdlService aptmdl;

    @Test
    public void initTest() throws IOException {
        AptmdlVO req = null;
        File file = Paths.get(testJsonDir, "aptmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptmdlVO> response = aptmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AptmdlVO req = null;
        File file = Paths.get(testJsonDir, "aptmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptmdlVO> response = aptmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AptmdlVO req = null;
        File file = Paths.get(testJsonDir, "aptmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptmdlVO> response = aptmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AptmdlVO req = null;
        File file = Paths.get(testJsonDir, "aptmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptmdlVO> response = aptmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AptmdlVO req = new AptmdlVO();
        // 参数设置
        ResponseSet<AptmdlVO> response = aptmdl.executeDefault(req,rule);
    }

}
