package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AptopnService;
import com.ceb.gjjs.mda.vo.AptopnVO;

public class AptopnServiceTest extends BaseTest{

    @Autowired
    private AptopnService aptopn;

    @Test
    public void initTest() throws IOException {
        AptopnVO req = null;
        File file = Paths.get(testJsonDir, "aptopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptopnVO> response = aptopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AptopnVO req = null;
        File file = Paths.get(testJsonDir, "aptopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptopnVO> response = aptopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AptopnVO req = null;
        File file = Paths.get(testJsonDir, "aptopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptopnVO> response = aptopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AptopnVO req = null;
        File file = Paths.get(testJsonDir, "aptopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AptopnVO> response = aptopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AptopnVO req = new AptopnVO();
        // 参数设置
        ResponseSet<AptopnVO> response = aptopn.executeDefault(req,rule);
    }

}
