package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AutcfgService;
import com.ceb.gjjs.mda.vo.AutcfgVO;

public class AutcfgServiceTest extends BaseTest{

    @Autowired
    private AutcfgService autcfg;

    @Test
    public void initTest() throws IOException {
        AutcfgVO req = null;
        File file = Paths.get(testJsonDir, "autcfg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcfgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcfgVO> response = autcfg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AutcfgVO req = null;
        File file = Paths.get(testJsonDir, "autcfg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcfgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcfgVO> response = autcfg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AutcfgVO req = null;
        File file = Paths.get(testJsonDir, "autcfg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcfgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcfgVO> response = autcfg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AutcfgVO req = null;
        File file = Paths.get(testJsonDir, "autcfg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcfgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcfgVO> response = autcfg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AutcfgVO req = new AutcfgVO();
        // 参数设置
        ResponseSet<AutcfgVO> response = autcfg.executeDefault(req,rule);
    }

}
