package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AutcntService;
import com.ceb.gjjs.mda.vo.AutcntVO;

public class AutcntServiceTest extends BaseTest{

    @Autowired
    private AutcntService autcnt;

    @Test
    public void initTest() throws IOException {
        AutcntVO req = null;
        File file = Paths.get(testJsonDir, "autcnt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcntVO> response = autcnt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AutcntVO req = null;
        File file = Paths.get(testJsonDir, "autcnt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcntVO> response = autcnt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AutcntVO req = null;
        File file = Paths.get(testJsonDir, "autcnt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcntVO> response = autcnt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AutcntVO req = null;
        File file = Paths.get(testJsonDir, "autcnt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutcntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutcntVO> response = autcnt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AutcntVO req = new AutcntVO();
        // 参数设置
        ResponseSet<AutcntVO> response = autcnt.executeDefault(req,rule);
    }

}
