package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AuthenService;
import com.ceb.gjjs.mda.vo.AuthenVO;

public class AuthenServiceTest extends BaseTest{

    @Autowired
    private AuthenService authen;

    @Test
    public void initTest() throws IOException {
        AuthenVO req = null;
        File file = Paths.get(testJsonDir, "authen").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AuthenVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AuthenVO> response = authen.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AuthenVO req = null;
        File file = Paths.get(testJsonDir, "authen").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AuthenVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AuthenVO> response = authen.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AuthenVO req = null;
        File file = Paths.get(testJsonDir, "authen").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AuthenVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AuthenVO> response = authen.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AuthenVO req = null;
        File file = Paths.get(testJsonDir, "authen").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AuthenVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AuthenVO> response = authen.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AuthenVO req = new AuthenVO();
        // 参数设置
        ResponseSet<AuthenVO> response = authen.executeDefault(req,rule);
    }

}
