package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.AutqryService;
import com.ceb.gjjs.mda.vo.AutqryVO;

public class AutqryServiceTest extends BaseTest{

    @Autowired
    private AutqryService autqry;

    @Test
    public void initTest() throws IOException {
        AutqryVO req = null;
        File file = Paths.get(testJsonDir, "autqry").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutqryVO> response = autqry.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        AutqryVO req = null;
        File file = Paths.get(testJsonDir, "autqry").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutqryVO> response = autqry.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        AutqryVO req = null;
        File file = Paths.get(testJsonDir, "autqry").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutqryVO> response = autqry.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        AutqryVO req = null;
        File file = Paths.get(testJsonDir, "autqry").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<AutqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<AutqryVO> response = autqry.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        AutqryVO req = new AutqryVO();
        // 参数设置
        ResponseSet<AutqryVO> response = autqry.executeDefault(req,rule);
    }

}
