package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctaccService;
import com.ceb.gjjs.mda.vo.BctaccVO;

public class BctaccServiceTest extends BaseTest{

    @Autowired
    private BctaccService bctacc;

    @Test
    public void initTest() throws IOException {
        BctaccVO req = null;
        File file = Paths.get(testJsonDir, "bctacc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctaccVO> response = bctacc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctaccVO req = null;
        File file = Paths.get(testJsonDir, "bctacc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctaccVO> response = bctacc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctaccVO req = null;
        File file = Paths.get(testJsonDir, "bctacc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctaccVO> response = bctacc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctaccVO req = null;
        File file = Paths.get(testJsonDir, "bctacc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctaccVO> response = bctacc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctaccVO req = new BctaccVO();
        // 参数设置
        ResponseSet<BctaccVO> response = bctacc.executeDefault(req,rule);
    }

}
