package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bctacp0Service;
import com.ceb.gjjs.mda.vo.Bctacp0VO;

public class Bctacp0ServiceTest extends BaseTest{

    @Autowired
    private Bctacp0Service bctacp0;

    @Test
    public void initTest() throws IOException {
        Bctacp0VO req = null;
        File file = Paths.get(testJsonDir, "bctacp0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctacp0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctacp0VO> response = bctacp0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bctacp0VO req = null;
        File file = Paths.get(testJsonDir, "bctacp0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctacp0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctacp0VO> response = bctacp0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bctacp0VO req = null;
        File file = Paths.get(testJsonDir, "bctacp0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctacp0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctacp0VO> response = bctacp0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bctacp0VO req = null;
        File file = Paths.get(testJsonDir, "bctacp0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctacp0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctacp0VO> response = bctacp0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bctacp0VO req = new Bctacp0VO();
        // 参数设置
        ResponseSet<Bctacp0VO> response = bctacp0.executeDefault(req,rule);
    }

}
