package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctacpService;
import com.ceb.gjjs.mda.vo.BctacpVO;

public class BctacpServiceTest extends BaseTest{

    @Autowired
    private BctacpService bctacp;

    @Test
    public void initTest() throws IOException {
        BctacpVO req = null;
        File file = Paths.get(testJsonDir, "bctacp").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctacpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctacpVO> response = bctacp.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctacpVO req = null;
        File file = Paths.get(testJsonDir, "bctacp").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctacpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctacpVO> response = bctacp.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctacpVO req = null;
        File file = Paths.get(testJsonDir, "bctacp").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctacpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctacpVO> response = bctacp.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctacpVO req = null;
        File file = Paths.get(testJsonDir, "bctacp").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctacpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctacpVO> response = bctacp.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctacpVO req = new BctacpVO();
        // 参数设置
        ResponseSet<BctacpVO> response = bctacp.executeDefault(req,rule);
    }

}
