package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctcanService;
import com.ceb.gjjs.mda.vo.BctcanVO;

public class BctcanServiceTest extends BaseTest{

    @Autowired
    private BctcanService bctcan;

    @Test
    public void initTest() throws IOException {
        BctcanVO req = null;
        File file = Paths.get(testJsonDir, "bctcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctcanVO> response = bctcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctcanVO req = null;
        File file = Paths.get(testJsonDir, "bctcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctcanVO> response = bctcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctcanVO req = null;
        File file = Paths.get(testJsonDir, "bctcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctcanVO> response = bctcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctcanVO req = null;
        File file = Paths.get(testJsonDir, "bctcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctcanVO> response = bctcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctcanVO req = new BctcanVO();
        // 参数设置
        ResponseSet<BctcanVO> response = bctcan.executeDefault(req,rule);
    }

}
