package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctdavService;
import com.ceb.gjjs.mda.vo.BctdavVO;

public class BctdavServiceTest extends BaseTest{

    @Autowired
    private BctdavService bctdav;

    @Test
    public void initTest() throws IOException {
        BctdavVO req = null;
        File file = Paths.get(testJsonDir, "bctdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdavVO> response = bctdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctdavVO req = null;
        File file = Paths.get(testJsonDir, "bctdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdavVO> response = bctdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctdavVO req = null;
        File file = Paths.get(testJsonDir, "bctdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdavVO> response = bctdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctdavVO req = null;
        File file = Paths.get(testJsonDir, "bctdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdavVO> response = bctdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctdavVO req = new BctdavVO();
        // 参数设置
        ResponseSet<BctdavVO> response = bctdav.executeDefault(req,rule);
    }

}
