package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctdocService;
import com.ceb.gjjs.mda.vo.BctdocVO;

public class BctdocServiceTest extends BaseTest{

    @Autowired
    private BctdocService bctdoc;

    @Test
    public void initTest() throws IOException {
        BctdocVO req = null;
        File file = Paths.get(testJsonDir, "bctdoc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdocVO> response = bctdoc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctdocVO req = null;
        File file = Paths.get(testJsonDir, "bctdoc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdocVO> response = bctdoc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctdocVO req = null;
        File file = Paths.get(testJsonDir, "bctdoc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdocVO> response = bctdoc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctdocVO req = null;
        File file = Paths.get(testJsonDir, "bctdoc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctdocVO> response = bctdoc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctdocVO req = new BctdocVO();
        // 参数设置
        ResponseSet<BctdocVO> response = bctdoc.executeDefault(req,rule);
    }

}
