package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bctfre0Service;
import com.ceb.gjjs.mda.vo.Bctfre0VO;

public class Bctfre0ServiceTest extends BaseTest{

    @Autowired
    private Bctfre0Service bctfre0;

    @Test
    public void initTest() throws IOException {
        Bctfre0VO req = null;
        File file = Paths.get(testJsonDir, "bctfre0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctfre0VO> response = bctfre0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bctfre0VO req = null;
        File file = Paths.get(testJsonDir, "bctfre0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctfre0VO> response = bctfre0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bctfre0VO req = null;
        File file = Paths.get(testJsonDir, "bctfre0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctfre0VO> response = bctfre0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bctfre0VO req = null;
        File file = Paths.get(testJsonDir, "bctfre0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bctfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bctfre0VO> response = bctfre0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bctfre0VO req = new Bctfre0VO();
        // 参数设置
        ResponseSet<Bctfre0VO> response = bctfre0.executeDefault(req,rule);
    }

}
