package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctfreService;
import com.ceb.gjjs.mda.vo.BctfreVO;

public class BctfreServiceTest extends BaseTest{

    @Autowired
    private BctfreService bctfre;

    @Test
    public void initTest() throws IOException {
        BctfreVO req = null;
        File file = Paths.get(testJsonDir, "bctfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctfreVO> response = bctfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctfreVO req = null;
        File file = Paths.get(testJsonDir, "bctfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctfreVO> response = bctfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctfreVO req = null;
        File file = Paths.get(testJsonDir, "bctfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctfreVO> response = bctfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctfreVO req = null;
        File file = Paths.get(testJsonDir, "bctfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctfreVO> response = bctfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctfreVO req = new BctfreVO();
        // 参数设置
        ResponseSet<BctfreVO> response = bctfre.executeDefault(req,rule);
    }

}
