package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctopnService;
import com.ceb.gjjs.mda.vo.BctopnVO;

public class BctopnServiceTest extends BaseTest{

    @Autowired
    private BctopnService bctopn;

    @Test
    public void initTest() throws IOException {
        BctopnVO req = null;
        File file = Paths.get(testJsonDir, "bctopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctopnVO> response = bctopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctopnVO req = null;
        File file = Paths.get(testJsonDir, "bctopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctopnVO> response = bctopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctopnVO req = null;
        File file = Paths.get(testJsonDir, "bctopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctopnVO> response = bctopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctopnVO req = null;
        File file = Paths.get(testJsonDir, "bctopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctopnVO> response = bctopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctopnVO req = new BctopnVO();
        // 参数设置
        ResponseSet<BctopnVO> response = bctopn.executeDefault(req,rule);
    }

}
