package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BctsetService;
import com.ceb.gjjs.mda.vo.BctsetVO;

public class BctsetServiceTest extends BaseTest{

    @Autowired
    private BctsetService bctset;

    @Test
    public void initTest() throws IOException {
        BctsetVO req = null;
        File file = Paths.get(testJsonDir, "bctset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctsetVO> response = bctset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BctsetVO req = null;
        File file = Paths.get(testJsonDir, "bctset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctsetVO> response = bctset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BctsetVO req = null;
        File file = Paths.get(testJsonDir, "bctset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctsetVO> response = bctset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BctsetVO req = null;
        File file = Paths.get(testJsonDir, "bctset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BctsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BctsetVO> response = bctset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BctsetVO req = new BctsetVO();
        // 参数设置
        ResponseSet<BctsetVO> response = bctset.executeDefault(req,rule);
    }

}
