package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtdckService;
import com.ceb.gjjs.mda.vo.BdtdckVO;

public class BdtdckServiceTest extends BaseTest{

    @Autowired
    private BdtdckService bdtdck;

    @Test
    public void initTest() throws IOException {
        BdtdckVO req = null;
        File file = Paths.get(testJsonDir, "bdtdck").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdckVO> response = bdtdck.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtdckVO req = null;
        File file = Paths.get(testJsonDir, "bdtdck").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdckVO> response = bdtdck.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtdckVO req = null;
        File file = Paths.get(testJsonDir, "bdtdck").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdckVO> response = bdtdck.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtdckVO req = null;
        File file = Paths.get(testJsonDir, "bdtdck").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdckVO> response = bdtdck.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtdckVO req = new BdtdckVO();
        // 参数设置
        ResponseSet<BdtdckVO> response = bdtdck.executeDefault(req,rule);
    }

}
