package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtdfdService;
import com.ceb.gjjs.mda.vo.BdtdfdVO;

public class BdtdfdServiceTest extends BaseTest{

    @Autowired
    private BdtdfdService bdtdfd;

    @Test
    public void initTest() throws IOException {
        BdtdfdVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfdVO> response = bdtdfd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtdfdVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfdVO> response = bdtdfd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtdfdVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfdVO> response = bdtdfd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtdfdVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfdVO> response = bdtdfd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtdfdVO req = new BdtdfdVO();
        // 参数设置
        ResponseSet<BdtdfdVO> response = bdtdfd.executeDefault(req,rule);
    }

}
