package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtdfrService;
import com.ceb.gjjs.mda.vo.BdtdfrVO;

public class BdtdfrServiceTest extends BaseTest{

    @Autowired
    private BdtdfrService bdtdfr;

    @Test
    public void initTest() throws IOException {
        BdtdfrVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfrVO> response = bdtdfr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtdfrVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfrVO> response = bdtdfr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtdfrVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfrVO> response = bdtdfr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtdfrVO req = null;
        File file = Paths.get(testJsonDir, "bdtdfr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdfrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdfrVO> response = bdtdfr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtdfrVO req = new BdtdfrVO();
        // 参数设置
        ResponseSet<BdtdfrVO> response = bdtdfr.executeDefault(req,rule);
    }

}
