package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtdraService;
import com.ceb.gjjs.mda.vo.BdtdraVO;

public class BdtdraServiceTest extends BaseTest{

    @Autowired
    private BdtdraService bdtdra;

    @Test
    public void initTest() throws IOException {
        BdtdraVO req = null;
        File file = Paths.get(testJsonDir, "bdtdra").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdraVO> response = bdtdra.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtdraVO req = null;
        File file = Paths.get(testJsonDir, "bdtdra").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdraVO> response = bdtdra.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtdraVO req = null;
        File file = Paths.get(testJsonDir, "bdtdra").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdraVO> response = bdtdra.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtdraVO req = null;
        File file = Paths.get(testJsonDir, "bdtdra").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdraVO> response = bdtdra.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtdraVO req = new BdtdraVO();
        // 参数设置
        ResponseSet<BdtdraVO> response = bdtdra.executeDefault(req,rule);
    }

}
