package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtdsnService;
import com.ceb.gjjs.mda.vo.BdtdsnVO;

public class BdtdsnServiceTest extends BaseTest{

    @Autowired
    private BdtdsnService bdtdsn;

    @Test
    public void initTest() throws IOException {
        BdtdsnVO req = null;
        File file = Paths.get(testJsonDir, "bdtdsn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdsnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdsnVO> response = bdtdsn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtdsnVO req = null;
        File file = Paths.get(testJsonDir, "bdtdsn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdsnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdsnVO> response = bdtdsn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtdsnVO req = null;
        File file = Paths.get(testJsonDir, "bdtdsn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdsnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdsnVO> response = bdtdsn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtdsnVO req = null;
        File file = Paths.get(testJsonDir, "bdtdsn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtdsnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtdsnVO> response = bdtdsn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtdsnVO req = new BdtdsnVO();
        // 参数设置
        ResponseSet<BdtdsnVO> response = bdtdsn.executeDefault(req,rule);
    }

}
