package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtfrcService;
import com.ceb.gjjs.mda.vo.BdtfrcVO;

public class BdtfrcServiceTest extends BaseTest{

    @Autowired
    private BdtfrcService bdtfrc;

    @Test
    public void initTest() throws IOException {
        BdtfrcVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrcVO> response = bdtfrc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtfrcVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrcVO> response = bdtfrc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtfrcVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrcVO> response = bdtfrc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtfrcVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrcVO> response = bdtfrc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtfrcVO req = new BdtfrcVO();
        // 参数设置
        ResponseSet<BdtfrcVO> response = bdtfrc.executeDefault(req,rule);
    }

}
