package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtfrdService;
import com.ceb.gjjs.mda.vo.BdtfrdVO;

public class BdtfrdServiceTest extends BaseTest{

    @Autowired
    private BdtfrdService bdtfrd;

    @Test
    public void initTest() throws IOException {
        BdtfrdVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrdVO> response = bdtfrd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtfrdVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrdVO> response = bdtfrd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtfrdVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrdVO> response = bdtfrd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtfrdVO req = null;
        File file = Paths.get(testJsonDir, "bdtfrd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfrdVO> response = bdtfrd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtfrdVO req = new BdtfrdVO();
        // 参数设置
        ResponseSet<BdtfrdVO> response = bdtfrd.executeDefault(req,rule);
    }

}
