package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtfreService;
import com.ceb.gjjs.mda.vo.BdtfreVO;

public class BdtfreServiceTest extends BaseTest{

    @Autowired
    private BdtfreService bdtfre;

    @Test
    public void initTest() throws IOException {
        BdtfreVO req = null;
        File file = Paths.get(testJsonDir, "bdtfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfreVO> response = bdtfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtfreVO req = null;
        File file = Paths.get(testJsonDir, "bdtfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfreVO> response = bdtfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtfreVO req = null;
        File file = Paths.get(testJsonDir, "bdtfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfreVO> response = bdtfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtfreVO req = null;
        File file = Paths.get(testJsonDir, "bdtfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtfreVO> response = bdtfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtfreVO req = new BdtfreVO();
        // 参数设置
        ResponseSet<BdtfreVO> response = bdtfre.executeDefault(req,rule);
    }

}
