package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtpayService;
import com.ceb.gjjs.mda.vo.BdtpayVO;

public class BdtpayServiceTest extends BaseTest{

    @Autowired
    private BdtpayService bdtpay;

    @Test
    public void initTest() throws IOException {
        BdtpayVO req = null;
        File file = Paths.get(testJsonDir, "bdtpay").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtpayVO> response = bdtpay.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtpayVO req = null;
        File file = Paths.get(testJsonDir, "bdtpay").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtpayVO> response = bdtpay.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtpayVO req = null;
        File file = Paths.get(testJsonDir, "bdtpay").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtpayVO> response = bdtpay.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtpayVO req = null;
        File file = Paths.get(testJsonDir, "bdtpay").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtpayVO> response = bdtpay.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtpayVO req = new BdtpayVO();
        // 参数设置
        ResponseSet<BdtpayVO> response = bdtpay.executeDefault(req,rule);
    }

}
