package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtsetService;
import com.ceb.gjjs.mda.vo.BdtsetVO;

public class BdtsetServiceTest extends BaseTest{

    @Autowired
    private BdtsetService bdtset;

    @Test
    public void initTest() throws IOException {
        BdtsetVO req = null;
        File file = Paths.get(testJsonDir, "bdtset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsetVO> response = bdtset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtsetVO req = null;
        File file = Paths.get(testJsonDir, "bdtset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsetVO> response = bdtset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtsetVO req = null;
        File file = Paths.get(testJsonDir, "bdtset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsetVO> response = bdtset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtsetVO req = null;
        File file = Paths.get(testJsonDir, "bdtset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsetVO> response = bdtset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtsetVO req = new BdtsetVO();
        // 参数设置
        ResponseSet<BdtsetVO> response = bdtset.executeDefault(req,rule);
    }

}
