package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bdtsnd0Service;
import com.ceb.gjjs.mda.vo.Bdtsnd0VO;

public class Bdtsnd0ServiceTest extends BaseTest{

    @Autowired
    private Bdtsnd0Service bdtsnd0;

    @Test
    public void initTest() throws IOException {
        Bdtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bdtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bdtsnd0VO> response = bdtsnd0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bdtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bdtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bdtsnd0VO> response = bdtsnd0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bdtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bdtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bdtsnd0VO> response = bdtsnd0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bdtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bdtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bdtsnd0VO> response = bdtsnd0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bdtsnd0VO req = new Bdtsnd0VO();
        // 参数设置
        ResponseSet<Bdtsnd0VO> response = bdtsnd0.executeDefault(req,rule);
    }

}
