package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtsndService;
import com.ceb.gjjs.mda.vo.BdtsndVO;

public class BdtsndServiceTest extends BaseTest{

    @Autowired
    private BdtsndService bdtsnd;

    @Test
    public void initTest() throws IOException {
        BdtsndVO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsndVO> response = bdtsnd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtsndVO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsndVO> response = bdtsnd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtsndVO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsndVO> response = bdtsnd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtsndVO req = null;
        File file = Paths.get(testJsonDir, "bdtsnd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtsndVO> response = bdtsnd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtsndVO req = new BdtsndVO();
        // 参数设置
        ResponseSet<BdtsndVO> response = bdtsnd.executeDefault(req,rule);
    }

}
