package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BdtudpService;
import com.ceb.gjjs.mda.vo.BdtudpVO;

public class BdtudpServiceTest extends BaseTest{

    @Autowired
    private BdtudpService bdtudp;

    @Test
    public void initTest() throws IOException {
        BdtudpVO req = null;
        File file = Paths.get(testJsonDir, "bdtudp").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtudpVO> response = bdtudp.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BdtudpVO req = null;
        File file = Paths.get(testJsonDir, "bdtudp").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtudpVO> response = bdtudp.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BdtudpVO req = null;
        File file = Paths.get(testJsonDir, "bdtudp").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtudpVO> response = bdtudp.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BdtudpVO req = null;
        File file = Paths.get(testJsonDir, "bdtudp").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BdtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BdtudpVO> response = bdtudp.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BdtudpVO req = new BdtudpVO();
        // 参数设置
        ResponseSet<BdtudpVO> response = bdtudp.executeDefault(req,rule);
    }

}
