package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetameService;
import com.ceb.gjjs.mda.vo.BetameVO;

public class BetameServiceTest extends BaseTest{

    @Autowired
    private BetameService betame;

    @Test
    public void initTest() throws IOException {
        BetameVO req = null;
        File file = Paths.get(testJsonDir, "betame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetameVO> response = betame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetameVO req = null;
        File file = Paths.get(testJsonDir, "betame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetameVO> response = betame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetameVO req = null;
        File file = Paths.get(testJsonDir, "betame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetameVO> response = betame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetameVO req = null;
        File file = Paths.get(testJsonDir, "betame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetameVO> response = betame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetameVO req = new BetameVO();
        // 参数设置
        ResponseSet<BetameVO> response = betame.executeDefault(req,rule);
    }

}
