package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetcdvService;
import com.ceb.gjjs.mda.vo.BetcdvVO;

public class BetcdvServiceTest extends BaseTest{

    @Autowired
    private BetcdvService betcdv;

    @Test
    public void initTest() throws IOException {
        BetcdvVO req = null;
        File file = Paths.get(testJsonDir, "betcdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetcdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetcdvVO> response = betcdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetcdvVO req = null;
        File file = Paths.get(testJsonDir, "betcdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetcdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetcdvVO> response = betcdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetcdvVO req = null;
        File file = Paths.get(testJsonDir, "betcdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetcdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetcdvVO> response = betcdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetcdvVO req = null;
        File file = Paths.get(testJsonDir, "betcdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetcdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetcdvVO> response = betcdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetcdvVO req = new BetcdvVO();
        // 参数设置
        ResponseSet<BetcdvVO> response = betcdv.executeDefault(req,rule);
    }

}
