package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetchkService;
import com.ceb.gjjs.mda.vo.BetchkVO;

public class BetchkServiceTest extends BaseTest{

    @Autowired
    private BetchkService betchk;

    @Test
    public void initTest() throws IOException {
        BetchkVO req = null;
        File file = Paths.get(testJsonDir, "betchk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetchkVO> response = betchk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetchkVO req = null;
        File file = Paths.get(testJsonDir, "betchk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetchkVO> response = betchk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetchkVO req = null;
        File file = Paths.get(testJsonDir, "betchk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetchkVO> response = betchk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetchkVO req = null;
        File file = Paths.get(testJsonDir, "betchk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetchkVO> response = betchk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetchkVO req = new BetchkVO();
        // 参数设置
        ResponseSet<BetchkVO> response = betchk.executeDefault(req,rule);
    }

}
