package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetdckService;
import com.ceb.gjjs.mda.vo.BetdckVO;

public class BetdckServiceTest extends BaseTest{

    @Autowired
    private BetdckService betdck;

    @Test
    public void initTest() throws IOException {
        BetdckVO req = null;
        File file = Paths.get(testJsonDir, "betdck").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdckVO> response = betdck.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetdckVO req = null;
        File file = Paths.get(testJsonDir, "betdck").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdckVO> response = betdck.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetdckVO req = null;
        File file = Paths.get(testJsonDir, "betdck").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdckVO> response = betdck.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetdckVO req = null;
        File file = Paths.get(testJsonDir, "betdck").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdckVO> response = betdck.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetdckVO req = new BetdckVO();
        // 参数设置
        ResponseSet<BetdckVO> response = betdck.executeDefault(req,rule);
    }

}
