package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetddvService;
import com.ceb.gjjs.mda.vo.BetddvVO;

public class BetddvServiceTest extends BaseTest{

    @Autowired
    private BetddvService betddv;

    @Test
    public void initTest() throws IOException {
        BetddvVO req = null;
        File file = Paths.get(testJsonDir, "betddv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetddvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetddvVO> response = betddv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetddvVO req = null;
        File file = Paths.get(testJsonDir, "betddv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetddvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetddvVO> response = betddv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetddvVO req = null;
        File file = Paths.get(testJsonDir, "betddv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetddvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetddvVO> response = betddv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetddvVO req = null;
        File file = Paths.get(testJsonDir, "betddv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetddvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetddvVO> response = betddv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetddvVO req = new BetddvVO();
        // 参数设置
        ResponseSet<BetddvVO> response = betddv.executeDefault(req,rule);
    }

}
