package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetdftService;
import com.ceb.gjjs.mda.vo.BetdftVO;

public class BetdftServiceTest extends BaseTest{

    @Autowired
    private BetdftService betdft;

    @Test
    public void initTest() throws IOException {
        BetdftVO req = null;
        File file = Paths.get(testJsonDir, "betdft").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdftVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdftVO> response = betdft.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetdftVO req = null;
        File file = Paths.get(testJsonDir, "betdft").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdftVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdftVO> response = betdft.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetdftVO req = null;
        File file = Paths.get(testJsonDir, "betdft").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdftVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdftVO> response = betdft.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetdftVO req = null;
        File file = Paths.get(testJsonDir, "betdft").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdftVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdftVO> response = betdft.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetdftVO req = new BetdftVO();
        // 参数设置
        ResponseSet<BetdftVO> response = betdft.executeDefault(req,rule);
    }

}
