package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetdocService;
import com.ceb.gjjs.mda.vo.BetdocVO;

public class BetdocServiceTest extends BaseTest{

    @Autowired
    private BetdocService betdoc;

    @Test
    public void initTest() throws IOException {
        BetdocVO req = null;
        File file = Paths.get(testJsonDir, "betdoc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdocVO> response = betdoc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetdocVO req = null;
        File file = Paths.get(testJsonDir, "betdoc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdocVO> response = betdoc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetdocVO req = null;
        File file = Paths.get(testJsonDir, "betdoc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdocVO> response = betdoc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetdocVO req = null;
        File file = Paths.get(testJsonDir, "betdoc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetdocVO> response = betdoc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetdocVO req = new BetdocVO();
        // 参数设置
        ResponseSet<BetdocVO> response = betdoc.executeDefault(req,rule);
    }

}
