package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Betpre1Service;
import com.ceb.gjjs.mda.vo.Betpre1VO;

public class Betpre1ServiceTest extends BaseTest{

    @Autowired
    private Betpre1Service betpre1;

    @Test
    public void initTest() throws IOException {
        Betpre1VO req = null;
        File file = Paths.get(testJsonDir, "betpre1").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre1VO> response = betpre1.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Betpre1VO req = null;
        File file = Paths.get(testJsonDir, "betpre1").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre1VO> response = betpre1.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Betpre1VO req = null;
        File file = Paths.get(testJsonDir, "betpre1").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre1VO> response = betpre1.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Betpre1VO req = null;
        File file = Paths.get(testJsonDir, "betpre1").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre1VO> response = betpre1.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Betpre1VO req = new Betpre1VO();
        // 参数设置
        ResponseSet<Betpre1VO> response = betpre1.executeDefault(req,rule);
    }

}
