package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Betpre2Service;
import com.ceb.gjjs.mda.vo.Betpre2VO;

public class Betpre2ServiceTest extends BaseTest{

    @Autowired
    private Betpre2Service betpre2;

    @Test
    public void initTest() throws IOException {
        Betpre2VO req = null;
        File file = Paths.get(testJsonDir, "betpre2").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre2VO> response = betpre2.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Betpre2VO req = null;
        File file = Paths.get(testJsonDir, "betpre2").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre2VO> response = betpre2.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Betpre2VO req = null;
        File file = Paths.get(testJsonDir, "betpre2").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre2VO> response = betpre2.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Betpre2VO req = null;
        File file = Paths.get(testJsonDir, "betpre2").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Betpre2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Betpre2VO> response = betpre2.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Betpre2VO req = new Betpre2VO();
        // 参数设置
        ResponseSet<Betpre2VO> response = betpre2.executeDefault(req,rule);
    }

}
