package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetpreService;
import com.ceb.gjjs.mda.vo.BetpreVO;

public class BetpreServiceTest extends BaseTest{

    @Autowired
    private BetpreService betpre;

    @Test
    public void initTest() throws IOException {
        BetpreVO req = null;
        File file = Paths.get(testJsonDir, "betpre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetpreVO> response = betpre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetpreVO req = null;
        File file = Paths.get(testJsonDir, "betpre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetpreVO> response = betpre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetpreVO req = null;
        File file = Paths.get(testJsonDir, "betpre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetpreVO> response = betpre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetpreVO req = null;
        File file = Paths.get(testJsonDir, "betpre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetpreVO> response = betpre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetpreVO req = new BetpreVO();
        // 参数设置
        ResponseSet<BetpreVO> response = betpre.executeDefault(req,rule);
    }

}
