package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetrgfService;
import com.ceb.gjjs.mda.vo.BetrgfVO;

public class BetrgfServiceTest extends BaseTest{

    @Autowired
    private BetrgfService betrgf;

    @Test
    public void initTest() throws IOException {
        BetrgfVO req = null;
        File file = Paths.get(testJsonDir, "betrgf").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrgfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrgfVO> response = betrgf.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetrgfVO req = null;
        File file = Paths.get(testJsonDir, "betrgf").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrgfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrgfVO> response = betrgf.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetrgfVO req = null;
        File file = Paths.get(testJsonDir, "betrgf").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrgfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrgfVO> response = betrgf.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetrgfVO req = null;
        File file = Paths.get(testJsonDir, "betrgf").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrgfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrgfVO> response = betrgf.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetrgfVO req = new BetrgfVO();
        // 参数设置
        ResponseSet<BetrgfVO> response = betrgf.executeDefault(req,rule);
    }

}
