package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetrggService;
import com.ceb.gjjs.mda.vo.BetrggVO;

public class BetrggServiceTest extends BaseTest{

    @Autowired
    private BetrggService betrgg;

    @Test
    public void initTest() throws IOException {
        BetrggVO req = null;
        File file = Paths.get(testJsonDir, "betrgg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrggVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrggVO> response = betrgg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetrggVO req = null;
        File file = Paths.get(testJsonDir, "betrgg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrggVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrggVO> response = betrgg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetrggVO req = null;
        File file = Paths.get(testJsonDir, "betrgg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrggVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrggVO> response = betrgg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetrggVO req = null;
        File file = Paths.get(testJsonDir, "betrgg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetrggVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetrggVO> response = betrgg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetrggVO req = new BetrggVO();
        // 参数设置
        ResponseSet<BetrggVO> response = betrgg.executeDefault(req,rule);
    }

}
