package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetsetService;
import com.ceb.gjjs.mda.vo.BetsetVO;

public class BetsetServiceTest extends BaseTest{

    @Autowired
    private BetsetService betset;

    @Test
    public void initTest() throws IOException {
        BetsetVO req = null;
        File file = Paths.get(testJsonDir, "betset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsetVO> response = betset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetsetVO req = null;
        File file = Paths.get(testJsonDir, "betset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsetVO> response = betset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetsetVO req = null;
        File file = Paths.get(testJsonDir, "betset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsetVO> response = betset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetsetVO req = null;
        File file = Paths.get(testJsonDir, "betset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsetVO> response = betset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetsetVO req = new BetsetVO();
        // 参数设置
        ResponseSet<BetsetVO> response = betset.executeDefault(req,rule);
    }

}
