package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BetsndService;
import com.ceb.gjjs.mda.vo.BetsndVO;

public class BetsndServiceTest extends BaseTest{

    @Autowired
    private BetsndService betsnd;

    @Test
    public void initTest() throws IOException {
        BetsndVO req = null;
        File file = Paths.get(testJsonDir, "betsnd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsndVO> response = betsnd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BetsndVO req = null;
        File file = Paths.get(testJsonDir, "betsnd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsndVO> response = betsnd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BetsndVO req = null;
        File file = Paths.get(testJsonDir, "betsnd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsndVO> response = betsnd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BetsndVO req = null;
        File file = Paths.get(testJsonDir, "betsnd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BetsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BetsndVO> response = betsnd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BetsndVO req = new BetsndVO();
        // 参数设置
        ResponseSet<BetsndVO> response = betsnd.executeDefault(req,rule);
    }

}
