package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bettpl1Service;
import com.ceb.gjjs.mda.vo.Bettpl1VO;

public class Bettpl1ServiceTest extends BaseTest{

    @Autowired
    private Bettpl1Service bettpl1;

    @Test
    public void initTest() throws IOException {
        Bettpl1VO req = null;
        File file = Paths.get(testJsonDir, "bettpl1").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl1VO> response = bettpl1.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bettpl1VO req = null;
        File file = Paths.get(testJsonDir, "bettpl1").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl1VO> response = bettpl1.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bettpl1VO req = null;
        File file = Paths.get(testJsonDir, "bettpl1").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl1VO> response = bettpl1.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bettpl1VO req = null;
        File file = Paths.get(testJsonDir, "bettpl1").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl1VO> response = bettpl1.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bettpl1VO req = new Bettpl1VO();
        // 参数设置
        ResponseSet<Bettpl1VO> response = bettpl1.executeDefault(req,rule);
    }

}
