package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bettpl2Service;
import com.ceb.gjjs.mda.vo.Bettpl2VO;

public class Bettpl2ServiceTest extends BaseTest{

    @Autowired
    private Bettpl2Service bettpl2;

    @Test
    public void initTest() throws IOException {
        Bettpl2VO req = null;
        File file = Paths.get(testJsonDir, "bettpl2").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl2VO> response = bettpl2.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bettpl2VO req = null;
        File file = Paths.get(testJsonDir, "bettpl2").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl2VO> response = bettpl2.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bettpl2VO req = null;
        File file = Paths.get(testJsonDir, "bettpl2").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl2VO> response = bettpl2.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bettpl2VO req = null;
        File file = Paths.get(testJsonDir, "bettpl2").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl2VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl2VO> response = bettpl2.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bettpl2VO req = new Bettpl2VO();
        // 参数设置
        ResponseSet<Bettpl2VO> response = bettpl2.executeDefault(req,rule);
    }

}
