package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bettpl3Service;
import com.ceb.gjjs.mda.vo.Bettpl3VO;

public class Bettpl3ServiceTest extends BaseTest{

    @Autowired
    private Bettpl3Service bettpl3;

    @Test
    public void initTest() throws IOException {
        Bettpl3VO req = null;
        File file = Paths.get(testJsonDir, "bettpl3").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl3VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl3VO> response = bettpl3.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bettpl3VO req = null;
        File file = Paths.get(testJsonDir, "bettpl3").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl3VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl3VO> response = bettpl3.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bettpl3VO req = null;
        File file = Paths.get(testJsonDir, "bettpl3").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl3VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl3VO> response = bettpl3.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bettpl3VO req = null;
        File file = Paths.get(testJsonDir, "bettpl3").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl3VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl3VO> response = bettpl3.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bettpl3VO req = new Bettpl3VO();
        // 参数设置
        ResponseSet<Bettpl3VO> response = bettpl3.executeDefault(req,rule);
    }

}
