package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bettpl4Service;
import com.ceb.gjjs.mda.vo.Bettpl4VO;

public class Bettpl4ServiceTest extends BaseTest{

    @Autowired
    private Bettpl4Service bettpl4;

    @Test
    public void initTest() throws IOException {
        Bettpl4VO req = null;
        File file = Paths.get(testJsonDir, "bettpl4").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl4VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl4VO> response = bettpl4.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bettpl4VO req = null;
        File file = Paths.get(testJsonDir, "bettpl4").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl4VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl4VO> response = bettpl4.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bettpl4VO req = null;
        File file = Paths.get(testJsonDir, "bettpl4").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl4VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl4VO> response = bettpl4.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bettpl4VO req = null;
        File file = Paths.get(testJsonDir, "bettpl4").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bettpl4VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bettpl4VO> response = bettpl4.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bettpl4VO req = new Bettpl4VO();
        // 参数设置
        ResponseSet<Bettpl4VO> response = bettpl4.executeDefault(req,rule);
    }

}
