package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BettplService;
import com.ceb.gjjs.mda.vo.BettplVO;

public class BettplServiceTest extends BaseTest{

    @Autowired
    private BettplService bettpl;

    @Test
    public void initTest() throws IOException {
        BettplVO req = null;
        File file = Paths.get(testJsonDir, "bettpl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BettplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BettplVO> response = bettpl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BettplVO req = null;
        File file = Paths.get(testJsonDir, "bettpl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BettplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BettplVO> response = bettpl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BettplVO req = null;
        File file = Paths.get(testJsonDir, "bettpl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BettplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BettplVO> response = bettpl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BettplVO req = null;
        File file = Paths.get(testJsonDir, "bettpl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BettplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BettplVO> response = bettpl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BettplVO req = new BettplVO();
        // 参数设置
        ResponseSet<BettplVO> response = bettpl.executeDefault(req,rule);
    }

}
