package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BhgsadService;
import com.ceb.gjjs.mda.vo.BhgsadVO;

public class BhgsadServiceTest extends BaseTest{

    @Autowired
    private BhgsadService bhgsad;

    @Test
    public void initTest() throws IOException {
        BhgsadVO req = null;
        File file = Paths.get(testJsonDir, "bhgsad").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsadVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsadVO> response = bhgsad.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BhgsadVO req = null;
        File file = Paths.get(testJsonDir, "bhgsad").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsadVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsadVO> response = bhgsad.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BhgsadVO req = null;
        File file = Paths.get(testJsonDir, "bhgsad").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsadVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsadVO> response = bhgsad.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BhgsadVO req = null;
        File file = Paths.get(testJsonDir, "bhgsad").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsadVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsadVO> response = bhgsad.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BhgsadVO req = new BhgsadVO();
        // 参数设置
        ResponseSet<BhgsadVO> response = bhgsad.executeDefault(req,rule);
    }

}
