package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BhgsrkService;
import com.ceb.gjjs.mda.vo.BhgsrkVO;

public class BhgsrkServiceTest extends BaseTest{

    @Autowired
    private BhgsrkService bhgsrk;

    @Test
    public void initTest() throws IOException {
        BhgsrkVO req = null;
        File file = Paths.get(testJsonDir, "bhgsrk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsrkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsrkVO> response = bhgsrk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BhgsrkVO req = null;
        File file = Paths.get(testJsonDir, "bhgsrk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsrkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsrkVO> response = bhgsrk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BhgsrkVO req = null;
        File file = Paths.get(testJsonDir, "bhgsrk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsrkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsrkVO> response = bhgsrk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BhgsrkVO req = null;
        File file = Paths.get(testJsonDir, "bhgsrk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsrkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsrkVO> response = bhgsrk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BhgsrkVO req = new BhgsrkVO();
        // 参数设置
        ResponseSet<BhgsrkVO> response = bhgsrk.executeDefault(req,rule);
    }

}
