package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BhgsupService;
import com.ceb.gjjs.mda.vo.BhgsupVO;

public class BhgsupServiceTest extends BaseTest{

    @Autowired
    private BhgsupService bhgsup;

    @Test
    public void initTest() throws IOException {
        BhgsupVO req = null;
        File file = Paths.get(testJsonDir, "bhgsup").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsupVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsupVO> response = bhgsup.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BhgsupVO req = null;
        File file = Paths.get(testJsonDir, "bhgsup").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsupVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsupVO> response = bhgsup.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BhgsupVO req = null;
        File file = Paths.get(testJsonDir, "bhgsup").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsupVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsupVO> response = bhgsup.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BhgsupVO req = null;
        File file = Paths.get(testJsonDir, "bhgsup").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhgsupVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhgsupVO> response = bhgsup.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BhgsupVO req = new BhgsupVO();
        // 参数设置
        ResponseSet<BhgsupVO> response = bhgsup.executeDefault(req,rule);
    }

}
