package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BhlogsService;
import com.ceb.gjjs.mda.vo.BhlogsVO;

public class BhlogsServiceTest extends BaseTest{

    @Autowired
    private BhlogsService bhlogs;

    @Test
    public void initTest() throws IOException {
        BhlogsVO req = null;
        File file = Paths.get(testJsonDir, "bhlogs").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhlogsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhlogsVO> response = bhlogs.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BhlogsVO req = null;
        File file = Paths.get(testJsonDir, "bhlogs").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhlogsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhlogsVO> response = bhlogs.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BhlogsVO req = null;
        File file = Paths.get(testJsonDir, "bhlogs").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhlogsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhlogsVO> response = bhlogs.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BhlogsVO req = null;
        File file = Paths.get(testJsonDir, "bhlogs").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BhlogsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BhlogsVO> response = bhlogs.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BhlogsVO req = new BhlogsVO();
        // 参数设置
        ResponseSet<BhlogsVO> response = bhlogs.executeDefault(req,rule);
    }

}
