package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bilchk0Service;
import com.ceb.gjjs.mda.vo.Bilchk0VO;

public class Bilchk0ServiceTest extends BaseTest{

    @Autowired
    private Bilchk0Service bilchk0;

    @Test
    public void initTest() throws IOException {
        Bilchk0VO req = null;
        File file = Paths.get(testJsonDir, "bilchk0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bilchk0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bilchk0VO> response = bilchk0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bilchk0VO req = null;
        File file = Paths.get(testJsonDir, "bilchk0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bilchk0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bilchk0VO> response = bilchk0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bilchk0VO req = null;
        File file = Paths.get(testJsonDir, "bilchk0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bilchk0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bilchk0VO> response = bilchk0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bilchk0VO req = null;
        File file = Paths.get(testJsonDir, "bilchk0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bilchk0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bilchk0VO> response = bilchk0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bilchk0VO req = new Bilchk0VO();
        // 参数设置
        ResponseSet<Bilchk0VO> response = bilchk0.executeDefault(req,rule);
    }

}
