package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BilchkService;
import com.ceb.gjjs.mda.vo.BilchkVO;

public class BilchkServiceTest extends BaseTest{

    @Autowired
    private BilchkService bilchk;

    @Test
    public void initTest() throws IOException {
        BilchkVO req = null;
        File file = Paths.get(testJsonDir, "bilchk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BilchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BilchkVO> response = bilchk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BilchkVO req = null;
        File file = Paths.get(testJsonDir, "bilchk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BilchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BilchkVO> response = bilchk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BilchkVO req = null;
        File file = Paths.get(testJsonDir, "bilchk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BilchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BilchkVO> response = bilchk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BilchkVO req = null;
        File file = Paths.get(testJsonDir, "bilchk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BilchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BilchkVO> response = bilchk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BilchkVO req = new BilchkVO();
        // 参数设置
        ResponseSet<BilchkVO> response = bilchk.executeDefault(req,rule);
    }

}
