package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BmtaccService;
import com.ceb.gjjs.mda.vo.BmtaccVO;

public class BmtaccServiceTest extends BaseTest{

    @Autowired
    private BmtaccService bmtacc;

    @Test
    public void initTest() throws IOException {
        BmtaccVO req = null;
        File file = Paths.get(testJsonDir, "bmtacc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtaccVO> response = bmtacc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BmtaccVO req = null;
        File file = Paths.get(testJsonDir, "bmtacc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtaccVO> response = bmtacc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BmtaccVO req = null;
        File file = Paths.get(testJsonDir, "bmtacc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtaccVO> response = bmtacc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BmtaccVO req = null;
        File file = Paths.get(testJsonDir, "bmtacc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtaccVO> response = bmtacc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BmtaccVO req = new BmtaccVO();
        // 参数设置
        ResponseSet<BmtaccVO> response = bmtacc.executeDefault(req,rule);
    }

}
