package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BmtdckService;
import com.ceb.gjjs.mda.vo.BmtdckVO;

public class BmtdckServiceTest extends BaseTest{

    @Autowired
    private BmtdckService bmtdck;

    @Test
    public void initTest() throws IOException {
        BmtdckVO req = null;
        File file = Paths.get(testJsonDir, "bmtdck").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdckVO> response = bmtdck.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BmtdckVO req = null;
        File file = Paths.get(testJsonDir, "bmtdck").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdckVO> response = bmtdck.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BmtdckVO req = null;
        File file = Paths.get(testJsonDir, "bmtdck").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdckVO> response = bmtdck.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BmtdckVO req = null;
        File file = Paths.get(testJsonDir, "bmtdck").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdckVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdckVO> response = bmtdck.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BmtdckVO req = new BmtdckVO();
        // 参数设置
        ResponseSet<BmtdckVO> response = bmtdck.executeDefault(req,rule);
    }

}
