package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BmtdisService;
import com.ceb.gjjs.mda.vo.BmtdisVO;

public class BmtdisServiceTest extends BaseTest{

    @Autowired
    private BmtdisService bmtdis;

    @Test
    public void initTest() throws IOException {
        BmtdisVO req = null;
        File file = Paths.get(testJsonDir, "bmtdis").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdisVO> response = bmtdis.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BmtdisVO req = null;
        File file = Paths.get(testJsonDir, "bmtdis").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdisVO> response = bmtdis.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BmtdisVO req = null;
        File file = Paths.get(testJsonDir, "bmtdis").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdisVO> response = bmtdis.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BmtdisVO req = null;
        File file = Paths.get(testJsonDir, "bmtdis").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtdisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtdisVO> response = bmtdis.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BmtdisVO req = new BmtdisVO();
        // 参数设置
        ResponseSet<BmtdisVO> response = bmtdis.executeDefault(req,rule);
    }

}
