package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BmtsetService;
import com.ceb.gjjs.mda.vo.BmtsetVO;

public class BmtsetServiceTest extends BaseTest{

    @Autowired
    private BmtsetService bmtset;

    @Test
    public void initTest() throws IOException {
        BmtsetVO req = null;
        File file = Paths.get(testJsonDir, "bmtset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsetVO> response = bmtset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BmtsetVO req = null;
        File file = Paths.get(testJsonDir, "bmtset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsetVO> response = bmtset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BmtsetVO req = null;
        File file = Paths.get(testJsonDir, "bmtset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsetVO> response = bmtset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BmtsetVO req = null;
        File file = Paths.get(testJsonDir, "bmtset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsetVO> response = bmtset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BmtsetVO req = new BmtsetVO();
        // 参数设置
        ResponseSet<BmtsetVO> response = bmtset.executeDefault(req,rule);
    }

}
