package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BmtsndService;
import com.ceb.gjjs.mda.vo.BmtsndVO;

public class BmtsndServiceTest extends BaseTest{

    @Autowired
    private BmtsndService bmtsnd;

    @Test
    public void initTest() throws IOException {
        BmtsndVO req = null;
        File file = Paths.get(testJsonDir, "bmtsnd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsndVO> response = bmtsnd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BmtsndVO req = null;
        File file = Paths.get(testJsonDir, "bmtsnd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsndVO> response = bmtsnd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BmtsndVO req = null;
        File file = Paths.get(testJsonDir, "bmtsnd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsndVO> response = bmtsnd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BmtsndVO req = null;
        File file = Paths.get(testJsonDir, "bmtsnd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BmtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BmtsndVO> response = bmtsnd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BmtsndVO req = new BmtsndVO();
        // 参数设置
        ResponseSet<BmtsndVO> response = bmtsnd.executeDefault(req,rule);
    }

}
