package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BnkchkService;
import com.ceb.gjjs.mda.vo.BnkchkVO;

public class BnkchkServiceTest extends BaseTest{

    @Autowired
    private BnkchkService bnkchk;

    @Test
    public void initTest() throws IOException {
        BnkchkVO req = null;
        File file = Paths.get(testJsonDir, "bnkchk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BnkchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BnkchkVO> response = bnkchk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BnkchkVO req = null;
        File file = Paths.get(testJsonDir, "bnkchk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BnkchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BnkchkVO> response = bnkchk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BnkchkVO req = null;
        File file = Paths.get(testJsonDir, "bnkchk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BnkchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BnkchkVO> response = bnkchk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BnkchkVO req = null;
        File file = Paths.get(testJsonDir, "bnkchk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BnkchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BnkchkVO> response = bnkchk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BnkchkVO req = new BnkchkVO();
        // 参数设置
        ResponseSet<BnkchkVO> response = bnkchk.executeDefault(req,rule);
    }

}
