package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotaccService;
import com.ceb.gjjs.mda.vo.BotaccVO;

public class BotaccServiceTest extends BaseTest{

    @Autowired
    private BotaccService botacc;

    @Test
    public void initTest() throws IOException {
        BotaccVO req = null;
        File file = Paths.get(testJsonDir, "botacc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotaccVO> response = botacc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotaccVO req = null;
        File file = Paths.get(testJsonDir, "botacc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotaccVO> response = botacc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotaccVO req = null;
        File file = Paths.get(testJsonDir, "botacc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotaccVO> response = botacc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotaccVO req = null;
        File file = Paths.get(testJsonDir, "botacc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotaccVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotaccVO> response = botacc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotaccVO req = new BotaccVO();
        // 参数设置
        ResponseSet<BotaccVO> response = botacc.executeDefault(req,rule);
    }

}
