package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotdcrService;
import com.ceb.gjjs.mda.vo.BotdcrVO;

public class BotdcrServiceTest extends BaseTest{

    @Autowired
    private BotdcrService botdcr;

    @Test
    public void initTest() throws IOException {
        BotdcrVO req = null;
        File file = Paths.get(testJsonDir, "botdcr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotdcrVO> response = botdcr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotdcrVO req = null;
        File file = Paths.get(testJsonDir, "botdcr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotdcrVO> response = botdcr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotdcrVO req = null;
        File file = Paths.get(testJsonDir, "botdcr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotdcrVO> response = botdcr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotdcrVO req = null;
        File file = Paths.get(testJsonDir, "botdcr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotdcrVO> response = botdcr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotdcrVO req = new BotdcrVO();
        // 参数设置
        ResponseSet<BotdcrVO> response = botdcr.executeDefault(req,rule);
    }

}
