package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Botfre0Service;
import com.ceb.gjjs.mda.vo.Botfre0VO;

public class Botfre0ServiceTest extends BaseTest{

    @Autowired
    private Botfre0Service botfre0;

    @Test
    public void initTest() throws IOException {
        Botfre0VO req = null;
        File file = Paths.get(testJsonDir, "botfre0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Botfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Botfre0VO> response = botfre0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Botfre0VO req = null;
        File file = Paths.get(testJsonDir, "botfre0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Botfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Botfre0VO> response = botfre0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Botfre0VO req = null;
        File file = Paths.get(testJsonDir, "botfre0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Botfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Botfre0VO> response = botfre0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Botfre0VO req = null;
        File file = Paths.get(testJsonDir, "botfre0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Botfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Botfre0VO> response = botfre0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Botfre0VO req = new Botfre0VO();
        // 参数设置
        ResponseSet<Botfre0VO> response = botfre0.executeDefault(req,rule);
    }

}
