package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotfreService;
import com.ceb.gjjs.mda.vo.BotfreVO;

public class BotfreServiceTest extends BaseTest{

    @Autowired
    private BotfreService botfre;

    @Test
    public void initTest() throws IOException {
        BotfreVO req = null;
        File file = Paths.get(testJsonDir, "botfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotfreVO> response = botfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotfreVO req = null;
        File file = Paths.get(testJsonDir, "botfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotfreVO> response = botfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotfreVO req = null;
        File file = Paths.get(testJsonDir, "botfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotfreVO> response = botfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotfreVO req = null;
        File file = Paths.get(testJsonDir, "botfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotfreVO> response = botfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotfreVO req = new BotfreVO();
        // 参数设置
        ResponseSet<BotfreVO> response = botfre.executeDefault(req,rule);
    }

}
