package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotopnService;
import com.ceb.gjjs.mda.vo.BotopnVO;

public class BotopnServiceTest extends BaseTest{

    @Autowired
    private BotopnService botopn;

    @Test
    public void initTest() throws IOException {
        BotopnVO req = null;
        File file = Paths.get(testJsonDir, "botopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopnVO> response = botopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotopnVO req = null;
        File file = Paths.get(testJsonDir, "botopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopnVO> response = botopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotopnVO req = null;
        File file = Paths.get(testJsonDir, "botopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopnVO> response = botopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotopnVO req = null;
        File file = Paths.get(testJsonDir, "botopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopnVO> response = botopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotopnVO req = new BotopnVO();
        // 参数设置
        ResponseSet<BotopnVO> response = botopn.executeDefault(req,rule);
    }

}
