package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotopsService;
import com.ceb.gjjs.mda.vo.BotopsVO;

public class BotopsServiceTest extends BaseTest{

    @Autowired
    private BotopsService botops;

    @Test
    public void initTest() throws IOException {
        BotopsVO req = null;
        File file = Paths.get(testJsonDir, "botops").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopsVO> response = botops.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotopsVO req = null;
        File file = Paths.get(testJsonDir, "botops").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopsVO> response = botops.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotopsVO req = null;
        File file = Paths.get(testJsonDir, "botops").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopsVO> response = botops.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotopsVO req = null;
        File file = Paths.get(testJsonDir, "botops").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotopsVO> response = botops.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotopsVO req = new BotopsVO();
        // 参数设置
        ResponseSet<BotopsVO> response = botops.executeDefault(req,rule);
    }

}
