package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotrplService;
import com.ceb.gjjs.mda.vo.BotrplVO;

public class BotrplServiceTest extends BaseTest{

    @Autowired
    private BotrplService botrpl;

    @Test
    public void initTest() throws IOException {
        BotrplVO req = null;
        File file = Paths.get(testJsonDir, "botrpl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotrplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotrplVO> response = botrpl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotrplVO req = null;
        File file = Paths.get(testJsonDir, "botrpl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotrplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotrplVO> response = botrpl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotrplVO req = null;
        File file = Paths.get(testJsonDir, "botrpl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotrplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotrplVO> response = botrpl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotrplVO req = null;
        File file = Paths.get(testJsonDir, "botrpl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotrplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotrplVO> response = botrpl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotrplVO req = new BotrplVO();
        // 参数设置
        ResponseSet<BotrplVO> response = botrpl.executeDefault(req,rule);
    }

}
