package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BotsetService;
import com.ceb.gjjs.mda.vo.BotsetVO;

public class BotsetServiceTest extends BaseTest{

    @Autowired
    private BotsetService botset;

    @Test
    public void initTest() throws IOException {
        BotsetVO req = null;
        File file = Paths.get(testJsonDir, "botset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotsetVO> response = botset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BotsetVO req = null;
        File file = Paths.get(testJsonDir, "botset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotsetVO> response = botset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BotsetVO req = null;
        File file = Paths.get(testJsonDir, "botset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotsetVO> response = botset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BotsetVO req = null;
        File file = Paths.get(testJsonDir, "botset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BotsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BotsetVO> response = botset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BotsetVO req = new BotsetVO();
        // 参数设置
        ResponseSet<BotsetVO> response = botset.executeDefault(req,rule);
    }

}
