package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptaplService;
import com.ceb.gjjs.mda.vo.BptaplVO;

public class BptaplServiceTest extends BaseTest{

    @Autowired
    private BptaplService bptapl;

    @Test
    public void initTest() throws IOException {
        BptaplVO req = null;
        File file = Paths.get(testJsonDir, "bptapl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptaplVO> response = bptapl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptaplVO req = null;
        File file = Paths.get(testJsonDir, "bptapl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptaplVO> response = bptapl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptaplVO req = null;
        File file = Paths.get(testJsonDir, "bptapl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptaplVO> response = bptapl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptaplVO req = null;
        File file = Paths.get(testJsonDir, "bptapl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptaplVO> response = bptapl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptaplVO req = new BptaplVO();
        // 参数设置
        ResponseSet<BptaplVO> response = bptapl.executeDefault(req,rule);
    }

}
