package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bptapn0Service;
import com.ceb.gjjs.mda.vo.Bptapn0VO;

public class Bptapn0ServiceTest extends BaseTest{

    @Autowired
    private Bptapn0Service bptapn0;

    @Test
    public void initTest() throws IOException {
        Bptapn0VO req = null;
        File file = Paths.get(testJsonDir, "bptapn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptapn0VO> response = bptapn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bptapn0VO req = null;
        File file = Paths.get(testJsonDir, "bptapn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptapn0VO> response = bptapn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bptapn0VO req = null;
        File file = Paths.get(testJsonDir, "bptapn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptapn0VO> response = bptapn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bptapn0VO req = null;
        File file = Paths.get(testJsonDir, "bptapn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptapn0VO> response = bptapn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bptapn0VO req = new Bptapn0VO();
        // 参数设置
        ResponseSet<Bptapn0VO> response = bptapn0.executeDefault(req,rule);
    }

}
