package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptapnService;
import com.ceb.gjjs.mda.vo.BptapnVO;

public class BptapnServiceTest extends BaseTest{

    @Autowired
    private BptapnService bptapn;

    @Test
    public void initTest() throws IOException {
        BptapnVO req = null;
        File file = Paths.get(testJsonDir, "bptapn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptapnVO> response = bptapn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptapnVO req = null;
        File file = Paths.get(testJsonDir, "bptapn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptapnVO> response = bptapn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptapnVO req = null;
        File file = Paths.get(testJsonDir, "bptapn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptapnVO> response = bptapn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptapnVO req = null;
        File file = Paths.get(testJsonDir, "bptapn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptapnVO> response = bptapn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptapnVO req = new BptapnVO();
        // 参数设置
        ResponseSet<BptapnVO> response = bptapn.executeDefault(req,rule);
    }

}
