package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptbpsService;
import com.ceb.gjjs.mda.vo.BptbpsVO;

public class BptbpsServiceTest extends BaseTest{

    @Autowired
    private BptbpsService bptbps;

    @Test
    public void initTest() throws IOException {
        BptbpsVO req = null;
        File file = Paths.get(testJsonDir, "bptbps").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptbpsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptbpsVO> response = bptbps.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptbpsVO req = null;
        File file = Paths.get(testJsonDir, "bptbps").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptbpsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptbpsVO> response = bptbps.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptbpsVO req = null;
        File file = Paths.get(testJsonDir, "bptbps").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptbpsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptbpsVO> response = bptbps.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptbpsVO req = null;
        File file = Paths.get(testJsonDir, "bptbps").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptbpsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptbpsVO> response = bptbps.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptbpsVO req = new BptbpsVO();
        // 参数设置
        ResponseSet<BptbpsVO> response = bptbps.executeDefault(req,rule);
    }

}
