package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptcfmService;
import com.ceb.gjjs.mda.vo.BptcfmVO;

public class BptcfmServiceTest extends BaseTest{

    @Autowired
    private BptcfmService bptcfm;

    @Test
    public void initTest() throws IOException {
        BptcfmVO req = null;
        File file = Paths.get(testJsonDir, "bptcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcfmVO> response = bptcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptcfmVO req = null;
        File file = Paths.get(testJsonDir, "bptcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcfmVO> response = bptcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptcfmVO req = null;
        File file = Paths.get(testJsonDir, "bptcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcfmVO> response = bptcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptcfmVO req = null;
        File file = Paths.get(testJsonDir, "bptcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcfmVO> response = bptcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptcfmVO req = new BptcfmVO();
        // 参数设置
        ResponseSet<BptcfmVO> response = bptcfm.executeDefault(req,rule);
    }

}
