package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptcrfService;
import com.ceb.gjjs.mda.vo.BptcrfVO;

public class BptcrfServiceTest extends BaseTest{

    @Autowired
    private BptcrfService bptcrf;

    @Test
    public void initTest() throws IOException {
        BptcrfVO req = null;
        File file = Paths.get(testJsonDir, "bptcrf").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcrfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcrfVO> response = bptcrf.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptcrfVO req = null;
        File file = Paths.get(testJsonDir, "bptcrf").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcrfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcrfVO> response = bptcrf.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptcrfVO req = null;
        File file = Paths.get(testJsonDir, "bptcrf").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcrfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcrfVO> response = bptcrf.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptcrfVO req = null;
        File file = Paths.get(testJsonDir, "bptcrf").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptcrfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptcrfVO> response = bptcrf.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptcrfVO req = new BptcrfVO();
        // 参数设置
        ResponseSet<BptcrfVO> response = bptcrf.executeDefault(req,rule);
    }

}
