package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptmdlService;
import com.ceb.gjjs.mda.vo.BptmdlVO;

public class BptmdlServiceTest extends BaseTest{

    @Autowired
    private BptmdlService bptmdl;

    @Test
    public void initTest() throws IOException {
        BptmdlVO req = null;
        File file = Paths.get(testJsonDir, "bptmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptmdlVO> response = bptmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptmdlVO req = null;
        File file = Paths.get(testJsonDir, "bptmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptmdlVO> response = bptmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptmdlVO req = null;
        File file = Paths.get(testJsonDir, "bptmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptmdlVO> response = bptmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptmdlVO req = null;
        File file = Paths.get(testJsonDir, "bptmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptmdlVO> response = bptmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptmdlVO req = new BptmdlVO();
        // 参数设置
        ResponseSet<BptmdlVO> response = bptmdl.executeDefault(req,rule);
    }

}
