package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptoplService;
import com.ceb.gjjs.mda.vo.BptoplVO;

public class BptoplServiceTest extends BaseTest{

    @Autowired
    private BptoplService bptopl;

    @Test
    public void initTest() throws IOException {
        BptoplVO req = null;
        File file = Paths.get(testJsonDir, "bptopl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptoplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptoplVO> response = bptopl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptoplVO req = null;
        File file = Paths.get(testJsonDir, "bptopl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptoplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptoplVO> response = bptopl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptoplVO req = null;
        File file = Paths.get(testJsonDir, "bptopl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptoplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptoplVO> response = bptopl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptoplVO req = null;
        File file = Paths.get(testJsonDir, "bptopl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptoplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptoplVO> response = bptopl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptoplVO req = new BptoplVO();
        // 参数设置
        ResponseSet<BptoplVO> response = bptopl.executeDefault(req,rule);
    }

}
