package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptopnService;
import com.ceb.gjjs.mda.vo.BptopnVO;

public class BptopnServiceTest extends BaseTest{

    @Autowired
    private BptopnService bptopn;

    @Test
    public void initTest() throws IOException {
        BptopnVO req = null;
        File file = Paths.get(testJsonDir, "bptopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptopnVO> response = bptopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptopnVO req = null;
        File file = Paths.get(testJsonDir, "bptopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptopnVO> response = bptopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptopnVO req = null;
        File file = Paths.get(testJsonDir, "bptopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptopnVO> response = bptopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptopnVO req = null;
        File file = Paths.get(testJsonDir, "bptopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptopnVO> response = bptopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptopnVO req = new BptopnVO();
        // 参数设置
        ResponseSet<BptopnVO> response = bptopn.executeDefault(req,rule);
    }

}
