package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Bptrpn0Service;
import com.ceb.gjjs.mda.vo.Bptrpn0VO;

public class Bptrpn0ServiceTest extends BaseTest{

    @Autowired
    private Bptrpn0Service bptrpn0;

    @Test
    public void initTest() throws IOException {
        Bptrpn0VO req = null;
        File file = Paths.get(testJsonDir, "bptrpn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptrpn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptrpn0VO> response = bptrpn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Bptrpn0VO req = null;
        File file = Paths.get(testJsonDir, "bptrpn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptrpn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptrpn0VO> response = bptrpn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Bptrpn0VO req = null;
        File file = Paths.get(testJsonDir, "bptrpn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptrpn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptrpn0VO> response = bptrpn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Bptrpn0VO req = null;
        File file = Paths.get(testJsonDir, "bptrpn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Bptrpn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Bptrpn0VO> response = bptrpn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Bptrpn0VO req = new Bptrpn0VO();
        // 参数设置
        ResponseSet<Bptrpn0VO> response = bptrpn0.executeDefault(req,rule);
    }

}
