package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BptrpnService;
import com.ceb.gjjs.mda.vo.BptrpnVO;

public class BptrpnServiceTest extends BaseTest{

    @Autowired
    private BptrpnService bptrpn;

    @Test
    public void initTest() throws IOException {
        BptrpnVO req = null;
        File file = Paths.get(testJsonDir, "bptrpn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptrpnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptrpnVO> response = bptrpn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BptrpnVO req = null;
        File file = Paths.get(testJsonDir, "bptrpn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptrpnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptrpnVO> response = bptrpn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BptrpnVO req = null;
        File file = Paths.get(testJsonDir, "bptrpn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptrpnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptrpnVO> response = bptrpn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BptrpnVO req = null;
        File file = Paths.get(testJsonDir, "bptrpn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BptrpnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BptrpnVO> response = bptrpn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BptrpnVO req = new BptrpnVO();
        // 参数设置
        ResponseSet<BptrpnVO> response = bptrpn.executeDefault(req,rule);
    }

}
