package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BpttrsService;
import com.ceb.gjjs.mda.vo.BpttrsVO;

public class BpttrsServiceTest extends BaseTest{

    @Autowired
    private BpttrsService bpttrs;

    @Test
    public void initTest() throws IOException {
        BpttrsVO req = null;
        File file = Paths.get(testJsonDir, "bpttrs").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BpttrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BpttrsVO> response = bpttrs.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BpttrsVO req = null;
        File file = Paths.get(testJsonDir, "bpttrs").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BpttrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BpttrsVO> response = bpttrs.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BpttrsVO req = null;
        File file = Paths.get(testJsonDir, "bpttrs").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BpttrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BpttrsVO> response = bpttrs.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BpttrsVO req = null;
        File file = Paths.get(testJsonDir, "bpttrs").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BpttrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BpttrsVO> response = bpttrs.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BpttrsVO req = new BpttrsVO();
        // 参数设置
        ResponseSet<BpttrsVO> response = bpttrs.executeDefault(req,rule);
    }

}
