package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtdcrService;
import com.ceb.gjjs.mda.vo.BrtdcrVO;

public class BrtdcrServiceTest extends BaseTest{

    @Autowired
    private BrtdcrService brtdcr;

    @Test
    public void initTest() throws IOException {
        BrtdcrVO req = null;
        File file = Paths.get(testJsonDir, "brtdcr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdcrVO> response = brtdcr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtdcrVO req = null;
        File file = Paths.get(testJsonDir, "brtdcr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdcrVO> response = brtdcr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtdcrVO req = null;
        File file = Paths.get(testJsonDir, "brtdcr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdcrVO> response = brtdcr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtdcrVO req = null;
        File file = Paths.get(testJsonDir, "brtdcr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdcrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdcrVO> response = brtdcr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtdcrVO req = new BrtdcrVO();
        // 参数设置
        ResponseSet<BrtdcrVO> response = brtdcr.executeDefault(req,rule);
    }

}
