package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtdraService;
import com.ceb.gjjs.mda.vo.BrtdraVO;

public class BrtdraServiceTest extends BaseTest{

    @Autowired
    private BrtdraService brtdra;

    @Test
    public void initTest() throws IOException {
        BrtdraVO req = null;
        File file = Paths.get(testJsonDir, "brtdra").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdraVO> response = brtdra.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtdraVO req = null;
        File file = Paths.get(testJsonDir, "brtdra").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdraVO> response = brtdra.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtdraVO req = null;
        File file = Paths.get(testJsonDir, "brtdra").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdraVO> response = brtdra.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtdraVO req = null;
        File file = Paths.get(testJsonDir, "brtdra").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtdraVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtdraVO> response = brtdra.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtdraVO req = new BrtdraVO();
        // 参数设置
        ResponseSet<BrtdraVO> response = brtdra.executeDefault(req,rule);
    }

}
