package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtfrdService;
import com.ceb.gjjs.mda.vo.BrtfrdVO;

public class BrtfrdServiceTest extends BaseTest{

    @Autowired
    private BrtfrdService brtfrd;

    @Test
    public void initTest() throws IOException {
        BrtfrdVO req = null;
        File file = Paths.get(testJsonDir, "brtfrd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfrdVO> response = brtfrd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtfrdVO req = null;
        File file = Paths.get(testJsonDir, "brtfrd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfrdVO> response = brtfrd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtfrdVO req = null;
        File file = Paths.get(testJsonDir, "brtfrd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfrdVO> response = brtfrd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtfrdVO req = null;
        File file = Paths.get(testJsonDir, "brtfrd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfrdVO> response = brtfrd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtfrdVO req = new BrtfrdVO();
        // 参数设置
        ResponseSet<BrtfrdVO> response = brtfrd.executeDefault(req,rule);
    }

}
