package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtfreService;
import com.ceb.gjjs.mda.vo.BrtfreVO;

public class BrtfreServiceTest extends BaseTest{

    @Autowired
    private BrtfreService brtfre;

    @Test
    public void initTest() throws IOException {
        BrtfreVO req = null;
        File file = Paths.get(testJsonDir, "brtfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfreVO> response = brtfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtfreVO req = null;
        File file = Paths.get(testJsonDir, "brtfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfreVO> response = brtfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtfreVO req = null;
        File file = Paths.get(testJsonDir, "brtfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfreVO> response = brtfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtfreVO req = null;
        File file = Paths.get(testJsonDir, "brtfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtfreVO> response = brtfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtfreVO req = new BrtfreVO();
        // 参数设置
        ResponseSet<BrtfreVO> response = brtfre.executeDefault(req,rule);
    }

}
