package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtpayService;
import com.ceb.gjjs.mda.vo.BrtpayVO;

public class BrtpayServiceTest extends BaseTest{

    @Autowired
    private BrtpayService brtpay;

    @Test
    public void initTest() throws IOException {
        BrtpayVO req = null;
        File file = Paths.get(testJsonDir, "brtpay").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtpayVO> response = brtpay.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtpayVO req = null;
        File file = Paths.get(testJsonDir, "brtpay").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtpayVO> response = brtpay.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtpayVO req = null;
        File file = Paths.get(testJsonDir, "brtpay").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtpayVO> response = brtpay.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtpayVO req = null;
        File file = Paths.get(testJsonDir, "brtpay").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtpayVO> response = brtpay.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtpayVO req = new BrtpayVO();
        // 参数设置
        ResponseSet<BrtpayVO> response = brtpay.executeDefault(req,rule);
    }

}
