package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtsetService;
import com.ceb.gjjs.mda.vo.BrtsetVO;

public class BrtsetServiceTest extends BaseTest{

    @Autowired
    private BrtsetService brtset;

    @Test
    public void initTest() throws IOException {
        BrtsetVO req = null;
        File file = Paths.get(testJsonDir, "brtset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsetVO> response = brtset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtsetVO req = null;
        File file = Paths.get(testJsonDir, "brtset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsetVO> response = brtset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtsetVO req = null;
        File file = Paths.get(testJsonDir, "brtset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsetVO> response = brtset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtsetVO req = null;
        File file = Paths.get(testJsonDir, "brtset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsetVO> response = brtset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtsetVO req = new BrtsetVO();
        // 参数设置
        ResponseSet<BrtsetVO> response = brtset.executeDefault(req,rule);
    }

}
