package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Brtsnd0Service;
import com.ceb.gjjs.mda.vo.Brtsnd0VO;

public class Brtsnd0ServiceTest extends BaseTest{

    @Autowired
    private Brtsnd0Service brtsnd0;

    @Test
    public void initTest() throws IOException {
        Brtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "brtsnd0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Brtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Brtsnd0VO> response = brtsnd0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Brtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "brtsnd0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Brtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Brtsnd0VO> response = brtsnd0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Brtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "brtsnd0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Brtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Brtsnd0VO> response = brtsnd0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Brtsnd0VO req = null;
        File file = Paths.get(testJsonDir, "brtsnd0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Brtsnd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Brtsnd0VO> response = brtsnd0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Brtsnd0VO req = new Brtsnd0VO();
        // 参数设置
        ResponseSet<Brtsnd0VO> response = brtsnd0.executeDefault(req,rule);
    }

}
