package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtsndService;
import com.ceb.gjjs.mda.vo.BrtsndVO;

public class BrtsndServiceTest extends BaseTest{

    @Autowired
    private BrtsndService brtsnd;

    @Test
    public void initTest() throws IOException {
        BrtsndVO req = null;
        File file = Paths.get(testJsonDir, "brtsnd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsndVO> response = brtsnd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtsndVO req = null;
        File file = Paths.get(testJsonDir, "brtsnd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsndVO> response = brtsnd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtsndVO req = null;
        File file = Paths.get(testJsonDir, "brtsnd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsndVO> response = brtsnd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtsndVO req = null;
        File file = Paths.get(testJsonDir, "brtsnd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtsndVO> response = brtsnd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtsndVO req = new BrtsndVO();
        // 参数设置
        ResponseSet<BrtsndVO> response = brtsnd.executeDefault(req,rule);
    }

}
