package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BrtudpService;
import com.ceb.gjjs.mda.vo.BrtudpVO;

public class BrtudpServiceTest extends BaseTest{

    @Autowired
    private BrtudpService brtudp;

    @Test
    public void initTest() throws IOException {
        BrtudpVO req = null;
        File file = Paths.get(testJsonDir, "brtudp").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtudpVO> response = brtudp.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BrtudpVO req = null;
        File file = Paths.get(testJsonDir, "brtudp").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtudpVO> response = brtudp.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BrtudpVO req = null;
        File file = Paths.get(testJsonDir, "brtudp").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtudpVO> response = brtudp.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BrtudpVO req = null;
        File file = Paths.get(testJsonDir, "brtudp").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BrtudpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BrtudpVO> response = brtudp.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BrtudpVO req = new BrtudpVO();
        // 参数设置
        ResponseSet<BrtudpVO> response = brtudp.executeDefault(req,rule);
    }

}
