package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.BxtsduService;
import com.ceb.gjjs.mda.vo.BxtsduVO;

public class BxtsduServiceTest extends BaseTest{

    @Autowired
    private BxtsduService bxtsdu;

    @Test
    public void initTest() throws IOException {
        BxtsduVO req = null;
        File file = Paths.get(testJsonDir, "bxtsdu").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BxtsduVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BxtsduVO> response = bxtsdu.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        BxtsduVO req = null;
        File file = Paths.get(testJsonDir, "bxtsdu").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BxtsduVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BxtsduVO> response = bxtsdu.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        BxtsduVO req = null;
        File file = Paths.get(testJsonDir, "bxtsdu").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BxtsduVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BxtsduVO> response = bxtsdu.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        BxtsduVO req = null;
        File file = Paths.get(testJsonDir, "bxtsdu").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<BxtsduVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<BxtsduVO> response = bxtsdu.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        BxtsduVO req = new BxtsduVO();
        // 参数设置
        ResponseSet<BxtsduVO> response = bxtsdu.executeDefault(req,rule);
    }

}
