package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ComadvService;
import com.ceb.gjjs.mda.vo.ComadvVO;

public class ComadvServiceTest extends BaseTest{

    @Autowired
    private ComadvService comadv;

    @Test
    public void initTest() throws IOException {
        ComadvVO req = null;
        File file = Paths.get(testJsonDir, "comadv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComadvVO> response = comadv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ComadvVO req = null;
        File file = Paths.get(testJsonDir, "comadv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComadvVO> response = comadv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ComadvVO req = null;
        File file = Paths.get(testJsonDir, "comadv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComadvVO> response = comadv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ComadvVO req = null;
        File file = Paths.get(testJsonDir, "comadv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComadvVO> response = comadv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ComadvVO req = new ComadvVO();
        // 参数设置
        ResponseSet<ComadvVO> response = comadv.executeDefault(req,rule);
    }

}
