package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ComaplService;
import com.ceb.gjjs.mda.vo.ComaplVO;

public class ComaplServiceTest extends BaseTest{

    @Autowired
    private ComaplService comapl;

    @Test
    public void initTest() throws IOException {
        ComaplVO req = null;
        File file = Paths.get(testJsonDir, "comapl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComaplVO> response = comapl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ComaplVO req = null;
        File file = Paths.get(testJsonDir, "comapl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComaplVO> response = comapl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ComaplVO req = null;
        File file = Paths.get(testJsonDir, "comapl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComaplVO> response = comapl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ComaplVO req = null;
        File file = Paths.get(testJsonDir, "comapl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComaplVO> response = comapl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ComaplVO req = new ComaplVO();
        // 参数设置
        ResponseSet<ComaplVO> response = comapl.executeDefault(req,rule);
    }

}
