package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ComcfmService;
import com.ceb.gjjs.mda.vo.ComcfmVO;

public class ComcfmServiceTest extends BaseTest{

    @Autowired
    private ComcfmService comcfm;

    @Test
    public void initTest() throws IOException {
        ComcfmVO req = null;
        File file = Paths.get(testJsonDir, "comcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComcfmVO> response = comcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ComcfmVO req = null;
        File file = Paths.get(testJsonDir, "comcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComcfmVO> response = comcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ComcfmVO req = null;
        File file = Paths.get(testJsonDir, "comcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComcfmVO> response = comcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ComcfmVO req = null;
        File file = Paths.get(testJsonDir, "comcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComcfmVO> response = comcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ComcfmVO req = new ComcfmVO();
        // 参数设置
        ResponseSet<ComcfmVO> response = comcfm.executeDefault(req,rule);
    }

}
