package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Commar0Service;
import com.ceb.gjjs.mda.vo.Commar0VO;

public class Commar0ServiceTest extends BaseTest{

    @Autowired
    private Commar0Service commar0;

    @Test
    public void initTest() throws IOException {
        Commar0VO req = null;
        File file = Paths.get(testJsonDir, "commar0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Commar0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Commar0VO> response = commar0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Commar0VO req = null;
        File file = Paths.get(testJsonDir, "commar0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Commar0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Commar0VO> response = commar0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Commar0VO req = null;
        File file = Paths.get(testJsonDir, "commar0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Commar0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Commar0VO> response = commar0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Commar0VO req = null;
        File file = Paths.get(testJsonDir, "commar0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Commar0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Commar0VO> response = commar0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Commar0VO req = new Commar0VO();
        // 参数设置
        ResponseSet<Commar0VO> response = commar0.executeDefault(req,rule);
    }

}
