package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CommarService;
import com.ceb.gjjs.mda.vo.CommarVO;

public class CommarServiceTest extends BaseTest{

    @Autowired
    private CommarService commar;

    @Test
    public void initTest() throws IOException {
        CommarVO req = null;
        File file = Paths.get(testJsonDir, "commar").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CommarVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CommarVO> response = commar.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CommarVO req = null;
        File file = Paths.get(testJsonDir, "commar").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CommarVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CommarVO> response = commar.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CommarVO req = null;
        File file = Paths.get(testJsonDir, "commar").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CommarVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CommarVO> response = commar.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CommarVO req = null;
        File file = Paths.get(testJsonDir, "commar").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CommarVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CommarVO> response = commar.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CommarVO req = new CommarVO();
        // 参数设置
        ResponseSet<CommarVO> response = commar.executeDefault(req,rule);
    }

}
