package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ComselService;
import com.ceb.gjjs.mda.vo.ComselVO;

public class ComselServiceTest extends BaseTest{

    @Autowired
    private ComselService comsel;

    @Test
    public void initTest() throws IOException {
        ComselVO req = null;
        File file = Paths.get(testJsonDir, "comsel").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComselVO> response = comsel.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ComselVO req = null;
        File file = Paths.get(testJsonDir, "comsel").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComselVO> response = comsel.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ComselVO req = null;
        File file = Paths.get(testJsonDir, "comsel").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComselVO> response = comsel.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ComselVO req = null;
        File file = Paths.get(testJsonDir, "comsel").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ComselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ComselVO> response = comsel.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ComselVO req = new ComselVO();
        // 参数设置
        ResponseSet<ComselVO> response = comsel.executeDefault(req,rule);
    }

}
