package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Cptapi0Service;
import com.ceb.gjjs.mda.vo.Cptapi0VO;

public class Cptapi0ServiceTest extends BaseTest{

    @Autowired
    private Cptapi0Service cptapi0;

    @Test
    public void initTest() throws IOException {
        Cptapi0VO req = null;
        File file = Paths.get(testJsonDir, "cptapi0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Cptapi0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Cptapi0VO> response = cptapi0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Cptapi0VO req = null;
        File file = Paths.get(testJsonDir, "cptapi0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Cptapi0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Cptapi0VO> response = cptapi0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Cptapi0VO req = null;
        File file = Paths.get(testJsonDir, "cptapi0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Cptapi0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Cptapi0VO> response = cptapi0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Cptapi0VO req = null;
        File file = Paths.get(testJsonDir, "cptapi0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Cptapi0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Cptapi0VO> response = cptapi0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Cptapi0VO req = new Cptapi0VO();
        // 参数设置
        ResponseSet<Cptapi0VO> response = cptapi0.executeDefault(req,rule);
    }

}
