package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptapiService;
import com.ceb.gjjs.mda.vo.CptapiVO;

public class CptapiServiceTest extends BaseTest{

    @Autowired
    private CptapiService cptapi;

    @Test
    public void initTest() throws IOException {
        CptapiVO req = null;
        File file = Paths.get(testJsonDir, "cptapi").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptapiVO> response = cptapi.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptapiVO req = null;
        File file = Paths.get(testJsonDir, "cptapi").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptapiVO> response = cptapi.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptapiVO req = null;
        File file = Paths.get(testJsonDir, "cptapi").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptapiVO> response = cptapi.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptapiVO req = null;
        File file = Paths.get(testJsonDir, "cptapi").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptapiVO> response = cptapi.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptapiVO req = new CptapiVO();
        // 参数设置
        ResponseSet<CptapiVO> response = cptapi.executeDefault(req,rule);
    }

}
