package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptaplService;
import com.ceb.gjjs.mda.vo.CptaplVO;

public class CptaplServiceTest extends BaseTest{

    @Autowired
    private CptaplService cptapl;

    @Test
    public void initTest() throws IOException {
        CptaplVO req = null;
        File file = Paths.get(testJsonDir, "cptapl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptaplVO> response = cptapl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptaplVO req = null;
        File file = Paths.get(testJsonDir, "cptapl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptaplVO> response = cptapl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptaplVO req = null;
        File file = Paths.get(testJsonDir, "cptapl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptaplVO> response = cptapl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptaplVO req = null;
        File file = Paths.get(testJsonDir, "cptapl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptaplVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptaplVO> response = cptapl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptaplVO req = new CptaplVO();
        // 参数设置
        ResponseSet<CptaplVO> response = cptapl.executeDefault(req,rule);
    }

}
