package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptfreService;
import com.ceb.gjjs.mda.vo.CptfreVO;

public class CptfreServiceTest extends BaseTest{

    @Autowired
    private CptfreService cptfre;

    @Test
    public void initTest() throws IOException {
        CptfreVO req = null;
        File file = Paths.get(testJsonDir, "cptfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptfreVO> response = cptfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptfreVO req = null;
        File file = Paths.get(testJsonDir, "cptfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptfreVO> response = cptfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptfreVO req = null;
        File file = Paths.get(testJsonDir, "cptfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptfreVO> response = cptfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptfreVO req = null;
        File file = Paths.get(testJsonDir, "cptfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptfreVO> response = cptfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptfreVO req = new CptfreVO();
        // 参数设置
        ResponseSet<CptfreVO> response = cptfre.executeDefault(req,rule);
    }

}
