package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptgpiService;
import com.ceb.gjjs.mda.vo.CptgpiVO;

public class CptgpiServiceTest extends BaseTest{

    @Autowired
    private CptgpiService cptgpi;

    @Test
    public void initTest() throws IOException {
        CptgpiVO req = null;
        File file = Paths.get(testJsonDir, "cptgpi").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptgpiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptgpiVO> response = cptgpi.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptgpiVO req = null;
        File file = Paths.get(testJsonDir, "cptgpi").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptgpiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptgpiVO> response = cptgpi.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptgpiVO req = null;
        File file = Paths.get(testJsonDir, "cptgpi").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptgpiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptgpiVO> response = cptgpi.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptgpiVO req = null;
        File file = Paths.get(testJsonDir, "cptgpi").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptgpiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptgpiVO> response = cptgpi.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptgpiVO req = new CptgpiVO();
        // 参数设置
        ResponseSet<CptgpiVO> response = cptgpi.executeDefault(req,rule);
    }

}
