package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CpthycService;
import com.ceb.gjjs.mda.vo.CpthycVO;

public class CpthycServiceTest extends BaseTest{

    @Autowired
    private CpthycService cpthyc;

    @Test
    public void initTest() throws IOException {
        CpthycVO req = null;
        File file = Paths.get(testJsonDir, "cpthyc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthycVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthycVO> response = cpthyc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CpthycVO req = null;
        File file = Paths.get(testJsonDir, "cpthyc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthycVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthycVO> response = cpthyc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CpthycVO req = null;
        File file = Paths.get(testJsonDir, "cpthyc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthycVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthycVO> response = cpthyc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CpthycVO req = null;
        File file = Paths.get(testJsonDir, "cpthyc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthycVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthycVO> response = cpthyc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CpthycVO req = new CpthycVO();
        // 参数设置
        ResponseSet<CpthycVO> response = cpthyc.executeDefault(req,rule);
    }

}
