package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CpthydService;
import com.ceb.gjjs.mda.vo.CpthydVO;

public class CpthydServiceTest extends BaseTest{

    @Autowired
    private CpthydService cpthyd;

    @Test
    public void initTest() throws IOException {
        CpthydVO req = null;
        File file = Paths.get(testJsonDir, "cpthyd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthydVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthydVO> response = cpthyd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CpthydVO req = null;
        File file = Paths.get(testJsonDir, "cpthyd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthydVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthydVO> response = cpthyd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CpthydVO req = null;
        File file = Paths.get(testJsonDir, "cpthyd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthydVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthydVO> response = cpthyd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CpthydVO req = null;
        File file = Paths.get(testJsonDir, "cpthyd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthydVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthydVO> response = cpthyd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CpthydVO req = new CpthydVO();
        // 参数设置
        ResponseSet<CpthydVO> response = cpthyd.executeDefault(req,rule);
    }

}
