package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CpthyfService;
import com.ceb.gjjs.mda.vo.CpthyfVO;

public class CpthyfServiceTest extends BaseTest{

    @Autowired
    private CpthyfService cpthyf;

    @Test
    public void initTest() throws IOException {
        CpthyfVO req = null;
        File file = Paths.get(testJsonDir, "cpthyf").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthyfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthyfVO> response = cpthyf.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CpthyfVO req = null;
        File file = Paths.get(testJsonDir, "cpthyf").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthyfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthyfVO> response = cpthyf.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CpthyfVO req = null;
        File file = Paths.get(testJsonDir, "cpthyf").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthyfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthyfVO> response = cpthyf.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CpthyfVO req = null;
        File file = Paths.get(testJsonDir, "cpthyf").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CpthyfVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CpthyfVO> response = cpthyf.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CpthyfVO req = new CpthyfVO();
        // 参数设置
        ResponseSet<CpthyfVO> response = cpthyf.executeDefault(req,rule);
    }

}
