package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptimpService;
import com.ceb.gjjs.mda.vo.CptimpVO;

public class CptimpServiceTest extends BaseTest{

    @Autowired
    private CptimpService cptimp;

    @Test
    public void initTest() throws IOException {
        CptimpVO req = null;
        File file = Paths.get(testJsonDir, "cptimp").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptimpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptimpVO> response = cptimp.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptimpVO req = null;
        File file = Paths.get(testJsonDir, "cptimp").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptimpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptimpVO> response = cptimp.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptimpVO req = null;
        File file = Paths.get(testJsonDir, "cptimp").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptimpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptimpVO> response = cptimp.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptimpVO req = null;
        File file = Paths.get(testJsonDir, "cptimp").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptimpVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptimpVO> response = cptimp.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptimpVO req = new CptimpVO();
        // 参数设置
        ResponseSet<CptimpVO> response = cptimp.executeDefault(req,rule);
    }

}
