package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptopnService;
import com.ceb.gjjs.mda.vo.CptopnVO;

public class CptopnServiceTest extends BaseTest{

    @Autowired
    private CptopnService cptopn;

    @Test
    public void initTest() throws IOException {
        CptopnVO req = null;
        File file = Paths.get(testJsonDir, "cptopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopnVO> response = cptopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptopnVO req = null;
        File file = Paths.get(testJsonDir, "cptopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopnVO> response = cptopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptopnVO req = null;
        File file = Paths.get(testJsonDir, "cptopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopnVO> response = cptopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptopnVO req = null;
        File file = Paths.get(testJsonDir, "cptopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopnVO> response = cptopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptopnVO req = new CptopnVO();
        // 参数设置
        ResponseSet<CptopnVO> response = cptopn.executeDefault(req,rule);
    }

}
