package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptopsService;
import com.ceb.gjjs.mda.vo.CptopsVO;

public class CptopsServiceTest extends BaseTest{

    @Autowired
    private CptopsService cptops;

    @Test
    public void initTest() throws IOException {
        CptopsVO req = null;
        File file = Paths.get(testJsonDir, "cptops").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopsVO> response = cptops.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptopsVO req = null;
        File file = Paths.get(testJsonDir, "cptops").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopsVO> response = cptops.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptopsVO req = null;
        File file = Paths.get(testJsonDir, "cptops").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopsVO> response = cptops.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptopsVO req = null;
        File file = Paths.get(testJsonDir, "cptops").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptopsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptopsVO> response = cptops.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptopsVO req = new CptopsVO();
        // 参数设置
        ResponseSet<CptopsVO> response = cptops.executeDefault(req,rule);
    }

}
