package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptoutService;
import com.ceb.gjjs.mda.vo.CptoutVO;

public class CptoutServiceTest extends BaseTest{

    @Autowired
    private CptoutService cptout;

    @Test
    public void initTest() throws IOException {
        CptoutVO req = null;
        File file = Paths.get(testJsonDir, "cptout").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptoutVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptoutVO> response = cptout.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptoutVO req = null;
        File file = Paths.get(testJsonDir, "cptout").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptoutVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptoutVO> response = cptout.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptoutVO req = null;
        File file = Paths.get(testJsonDir, "cptout").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptoutVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptoutVO> response = cptout.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptoutVO req = null;
        File file = Paths.get(testJsonDir, "cptout").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptoutVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptoutVO> response = cptout.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptoutVO req = new CptoutVO();
        // 参数设置
        ResponseSet<CptoutVO> response = cptout.executeDefault(req,rule);
    }

}
