package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptsubService;
import com.ceb.gjjs.mda.vo.CptsubVO;

public class CptsubServiceTest extends BaseTest{

    @Autowired
    private CptsubService cptsub;

    @Test
    public void initTest() throws IOException {
        CptsubVO req = null;
        File file = Paths.get(testJsonDir, "cptsub").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptsubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptsubVO> response = cptsub.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptsubVO req = null;
        File file = Paths.get(testJsonDir, "cptsub").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptsubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptsubVO> response = cptsub.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptsubVO req = null;
        File file = Paths.get(testJsonDir, "cptsub").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptsubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptsubVO> response = cptsub.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptsubVO req = null;
        File file = Paths.get(testJsonDir, "cptsub").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptsubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptsubVO> response = cptsub.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptsubVO req = new CptsubVO();
        // 参数设置
        ResponseSet<CptsubVO> response = cptsub.executeDefault(req,rule);
    }

}
