package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.CptyubService;
import com.ceb.gjjs.mda.vo.CptyubVO;

public class CptyubServiceTest extends BaseTest{

    @Autowired
    private CptyubService cptyub;

    @Test
    public void initTest() throws IOException {
        CptyubVO req = null;
        File file = Paths.get(testJsonDir, "cptyub").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptyubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptyubVO> response = cptyub.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        CptyubVO req = null;
        File file = Paths.get(testJsonDir, "cptyub").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptyubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptyubVO> response = cptyub.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        CptyubVO req = null;
        File file = Paths.get(testJsonDir, "cptyub").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptyubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptyubVO> response = cptyub.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        CptyubVO req = null;
        File file = Paths.get(testJsonDir, "cptyub").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<CptyubVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<CptyubVO> response = cptyub.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        CptyubVO req = new CptyubVO();
        // 参数设置
        ResponseSet<CptyubVO> response = cptyub.executeDefault(req,rule);
    }

}
