package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Db2usr0Service;
import com.ceb.gjjs.mda.vo.Db2usr0VO;

public class Db2usr0ServiceTest extends BaseTest{

    @Autowired
    private Db2usr0Service db2usr0;

    @Test
    public void initTest() throws IOException {
        Db2usr0VO req = null;
        File file = Paths.get(testJsonDir, "db2usr0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Db2usr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Db2usr0VO> response = db2usr0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Db2usr0VO req = null;
        File file = Paths.get(testJsonDir, "db2usr0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Db2usr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Db2usr0VO> response = db2usr0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Db2usr0VO req = null;
        File file = Paths.get(testJsonDir, "db2usr0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Db2usr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Db2usr0VO> response = db2usr0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Db2usr0VO req = null;
        File file = Paths.get(testJsonDir, "db2usr0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Db2usr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Db2usr0VO> response = db2usr0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Db2usr0VO req = new Db2usr0VO();
        // 参数设置
        ResponseSet<Db2usr0VO> response = db2usr0.executeDefault(req,rule);
    }

}
