package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbbagtService;
import com.ceb.gjjs.mda.vo.DbbagtVO;

public class DbbagtServiceTest extends BaseTest{

    @Autowired
    private DbbagtService dbbagt;

    @Test
    public void initTest() throws IOException {
        DbbagtVO req = null;
        File file = Paths.get(testJsonDir, "dbbagt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbagtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbagtVO> response = dbbagt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbbagtVO req = null;
        File file = Paths.get(testJsonDir, "dbbagt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbagtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbagtVO> response = dbbagt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbbagtVO req = null;
        File file = Paths.get(testJsonDir, "dbbagt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbagtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbagtVO> response = dbbagt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbbagtVO req = null;
        File file = Paths.get(testJsonDir, "dbbagt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbagtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbagtVO> response = dbbagt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbbagtVO req = new DbbagtVO();
        // 参数设置
        ResponseSet<DbbagtVO> response = dbbagt.executeDefault(req,rule);
    }

}
