package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbbautService;
import com.ceb.gjjs.mda.vo.DbbautVO;

public class DbbautServiceTest extends BaseTest{

    @Autowired
    private DbbautService dbbaut;

    @Test
    public void initTest() throws IOException {
        DbbautVO req = null;
        File file = Paths.get(testJsonDir, "dbbaut").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbautVO> response = dbbaut.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbbautVO req = null;
        File file = Paths.get(testJsonDir, "dbbaut").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbautVO> response = dbbaut.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbbautVO req = null;
        File file = Paths.get(testJsonDir, "dbbaut").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbautVO> response = dbbaut.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbbautVO req = null;
        File file = Paths.get(testJsonDir, "dbbaut").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbautVO> response = dbbaut.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbbautVO req = new DbbautVO();
        // 参数设置
        ResponseSet<DbbautVO> response = dbbaut.executeDefault(req,rule);
    }

}
