package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbblvlService;
import com.ceb.gjjs.mda.vo.DbblvlVO;

public class DbblvlServiceTest extends BaseTest{

    @Autowired
    private DbblvlService dbblvl;

    @Test
    public void initTest() throws IOException {
        DbblvlVO req = null;
        File file = Paths.get(testJsonDir, "dbblvl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbblvlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbblvlVO> response = dbblvl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbblvlVO req = null;
        File file = Paths.get(testJsonDir, "dbblvl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbblvlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbblvlVO> response = dbblvl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbblvlVO req = null;
        File file = Paths.get(testJsonDir, "dbblvl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbblvlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbblvlVO> response = dbblvl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbblvlVO req = null;
        File file = Paths.get(testJsonDir, "dbblvl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbblvlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbblvlVO> response = dbblvl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbblvlVO req = new DbblvlVO();
        // 参数设置
        ResponseSet<DbblvlVO> response = dbblvl.executeDefault(req,rule);
    }

}
