package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbbmsgService;
import com.ceb.gjjs.mda.vo.DbbmsgVO;

public class DbbmsgServiceTest extends BaseTest{

    @Autowired
    private DbbmsgService dbbmsg;

    @Test
    public void initTest() throws IOException {
        DbbmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbbmsg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbmsgVO> response = dbbmsg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbbmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbbmsg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbmsgVO> response = dbbmsg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbbmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbbmsg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbmsgVO> response = dbbmsg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbbmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbbmsg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbmsgVO> response = dbbmsg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbbmsgVO req = new DbbmsgVO();
        // 参数设置
        ResponseSet<DbbmsgVO> response = dbbmsg.executeDefault(req,rule);
    }

}
