package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbbplaService;
import com.ceb.gjjs.mda.vo.DbbplaVO;

public class DbbplaServiceTest extends BaseTest{

    @Autowired
    private DbbplaService dbbpla;

    @Test
    public void initTest() throws IOException {
        DbbplaVO req = null;
        File file = Paths.get(testJsonDir, "dbbpla").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbplaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbplaVO> response = dbbpla.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbbplaVO req = null;
        File file = Paths.get(testJsonDir, "dbbpla").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbplaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbplaVO> response = dbbpla.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbbplaVO req = null;
        File file = Paths.get(testJsonDir, "dbbpla").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbplaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbplaVO> response = dbbpla.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbbplaVO req = null;
        File file = Paths.get(testJsonDir, "dbbpla").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbbplaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbbplaVO> response = dbbpla.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbbplaVO req = new DbbplaVO();
        // 参数设置
        ResponseSet<DbbplaVO> response = dbbpla.executeDefault(req,rule);
    }

}
