package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbcactService;
import com.ceb.gjjs.mda.vo.DbcactVO;

public class DbcactServiceTest extends BaseTest{

    @Autowired
    private DbcactService dbcact;

    @Test
    public void initTest() throws IOException {
        DbcactVO req = null;
        File file = Paths.get(testJsonDir, "dbcact").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcactVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcactVO> response = dbcact.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbcactVO req = null;
        File file = Paths.get(testJsonDir, "dbcact").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcactVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcactVO> response = dbcact.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbcactVO req = null;
        File file = Paths.get(testJsonDir, "dbcact").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcactVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcactVO> response = dbcact.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbcactVO req = null;
        File file = Paths.get(testJsonDir, "dbcact").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcactVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcactVO> response = dbcact.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbcactVO req = new DbcactVO();
        // 参数设置
        ResponseSet<DbcactVO> response = dbcact.executeDefault(req,rule);
    }

}
