package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbcmsgService;
import com.ceb.gjjs.mda.vo.DbcmsgVO;

public class DbcmsgServiceTest extends BaseTest{

    @Autowired
    private DbcmsgService dbcmsg;

    @Test
    public void initTest() throws IOException {
        DbcmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbcmsg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcmsgVO> response = dbcmsg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbcmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbcmsg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcmsgVO> response = dbcmsg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbcmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbcmsg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcmsgVO> response = dbcmsg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbcmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbcmsg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcmsgVO> response = dbcmsg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbcmsgVO req = new DbcmsgVO();
        // 参数设置
        ResponseSet<DbcmsgVO> response = dbcmsg.executeDefault(req,rule);
    }

}
