package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbcsacService;
import com.ceb.gjjs.mda.vo.DbcsacVO;

public class DbcsacServiceTest extends BaseTest{

    @Autowired
    private DbcsacService dbcsac;

    @Test
    public void initTest() throws IOException {
        DbcsacVO req = null;
        File file = Paths.get(testJsonDir, "dbcsac").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcsacVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcsacVO> response = dbcsac.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbcsacVO req = null;
        File file = Paths.get(testJsonDir, "dbcsac").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcsacVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcsacVO> response = dbcsac.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbcsacVO req = null;
        File file = Paths.get(testJsonDir, "dbcsac").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcsacVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcsacVO> response = dbcsac.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbcsacVO req = null;
        File file = Paths.get(testJsonDir, "dbcsac").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbcsacVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbcsacVO> response = dbcsac.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbcsacVO req = new DbcsacVO();
        // 参数设置
        ResponseSet<DbcsacVO> response = dbcsac.executeDefault(req,rule);
    }

}
