package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbipswService;
import com.ceb.gjjs.mda.vo.DbipswVO;

public class DbipswServiceTest extends BaseTest{

    @Autowired
    private DbipswService dbipsw;

    @Test
    public void initTest() throws IOException {
        DbipswVO req = null;
        File file = Paths.get(testJsonDir, "dbipsw").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbipswVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbipswVO> response = dbipsw.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbipswVO req = null;
        File file = Paths.get(testJsonDir, "dbipsw").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbipswVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbipswVO> response = dbipsw.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbipswVO req = null;
        File file = Paths.get(testJsonDir, "dbipsw").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbipswVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbipswVO> response = dbipsw.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbipswVO req = null;
        File file = Paths.get(testJsonDir, "dbipsw").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbipswVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbipswVO> response = dbipsw.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbipswVO req = new DbipswVO();
        // 参数设置
        ResponseSet<DbipswVO> response = dbipsw.executeDefault(req,rule);
    }

}
