package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmautService;
import com.ceb.gjjs.mda.vo.DbmautVO;

public class DbmautServiceTest extends BaseTest{

    @Autowired
    private DbmautService dbmaut;

    @Test
    public void initTest() throws IOException {
        DbmautVO req = null;
        File file = Paths.get(testJsonDir, "dbmaut").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmautVO> response = dbmaut.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmautVO req = null;
        File file = Paths.get(testJsonDir, "dbmaut").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmautVO> response = dbmaut.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmautVO req = null;
        File file = Paths.get(testJsonDir, "dbmaut").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmautVO> response = dbmaut.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmautVO req = null;
        File file = Paths.get(testJsonDir, "dbmaut").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmautVO> response = dbmaut.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmautVO req = new DbmautVO();
        // 参数设置
        ResponseSet<DbmautVO> response = dbmaut.executeDefault(req,rule);
    }

}
