package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmbepService;
import com.ceb.gjjs.mda.vo.DbmbepVO;

public class DbmbepServiceTest extends BaseTest{

    @Autowired
    private DbmbepService dbmbep;

    @Test
    public void initTest() throws IOException {
        DbmbepVO req = null;
        File file = Paths.get(testJsonDir, "dbmbep").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbepVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbepVO> response = dbmbep.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmbepVO req = null;
        File file = Paths.get(testJsonDir, "dbmbep").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbepVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbepVO> response = dbmbep.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmbepVO req = null;
        File file = Paths.get(testJsonDir, "dbmbep").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbepVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbepVO> response = dbmbep.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmbepVO req = null;
        File file = Paths.get(testJsonDir, "dbmbep").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbepVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbepVO> response = dbmbep.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmbepVO req = new DbmbepVO();
        // 参数设置
        ResponseSet<DbmbepVO> response = dbmbep.executeDefault(req,rule);
    }

}
