package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmbntService;
import com.ceb.gjjs.mda.vo.DbmbntVO;

public class DbmbntServiceTest extends BaseTest{

    @Autowired
    private DbmbntService dbmbnt;

    @Test
    public void initTest() throws IOException {
        DbmbntVO req = null;
        File file = Paths.get(testJsonDir, "dbmbnt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbntVO> response = dbmbnt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmbntVO req = null;
        File file = Paths.get(testJsonDir, "dbmbnt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbntVO> response = dbmbnt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmbntVO req = null;
        File file = Paths.get(testJsonDir, "dbmbnt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbntVO> response = dbmbnt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmbntVO req = null;
        File file = Paths.get(testJsonDir, "dbmbnt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmbntVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmbntVO> response = dbmbnt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmbntVO req = new DbmbntVO();
        // 参数设置
        ResponseSet<DbmbntVO> response = dbmbnt.executeDefault(req,rule);
    }

}
