package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Dbmbpr0Service;
import com.ceb.gjjs.mda.vo.Dbmbpr0VO;

public class Dbmbpr0ServiceTest extends BaseTest{

    @Autowired
    private Dbmbpr0Service dbmbpr0;

    @Test
    public void initTest() throws IOException {
        Dbmbpr0VO req = null;
        File file = Paths.get(testJsonDir, "dbmbpr0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Dbmbpr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Dbmbpr0VO> response = dbmbpr0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Dbmbpr0VO req = null;
        File file = Paths.get(testJsonDir, "dbmbpr0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Dbmbpr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Dbmbpr0VO> response = dbmbpr0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Dbmbpr0VO req = null;
        File file = Paths.get(testJsonDir, "dbmbpr0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Dbmbpr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Dbmbpr0VO> response = dbmbpr0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Dbmbpr0VO req = null;
        File file = Paths.get(testJsonDir, "dbmbpr0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Dbmbpr0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Dbmbpr0VO> response = dbmbpr0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Dbmbpr0VO req = new Dbmbpr0VO();
        // 参数设置
        ResponseSet<Dbmbpr0VO> response = dbmbpr0.executeDefault(req,rule);
    }

}
