package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmmsgService;
import com.ceb.gjjs.mda.vo.DbmmsgVO;

public class DbmmsgServiceTest extends BaseTest{

    @Autowired
    private DbmmsgService dbmmsg;

    @Test
    public void initTest() throws IOException {
        DbmmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbmmsg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmmsgVO> response = dbmmsg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbmmsg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmmsgVO> response = dbmmsg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbmmsg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmmsgVO> response = dbmmsg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmmsgVO req = null;
        File file = Paths.get(testJsonDir, "dbmmsg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmmsgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmmsgVO> response = dbmmsg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmmsgVO req = new DbmmsgVO();
        // 参数设置
        ResponseSet<DbmmsgVO> response = dbmmsg.executeDefault(req,rule);
    }

}
