package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmoprService;
import com.ceb.gjjs.mda.vo.DbmoprVO;

public class DbmoprServiceTest extends BaseTest{

    @Autowired
    private DbmoprService dbmopr;

    @Test
    public void initTest() throws IOException {
        DbmoprVO req = null;
        File file = Paths.get(testJsonDir, "dbmopr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmoprVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmoprVO> response = dbmopr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmoprVO req = null;
        File file = Paths.get(testJsonDir, "dbmopr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmoprVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmoprVO> response = dbmopr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmoprVO req = null;
        File file = Paths.get(testJsonDir, "dbmopr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmoprVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmoprVO> response = dbmopr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmoprVO req = null;
        File file = Paths.get(testJsonDir, "dbmopr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmoprVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmoprVO> response = dbmopr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmoprVO req = new DbmoprVO();
        // 参数设置
        ResponseSet<DbmoprVO> response = dbmopr.executeDefault(req,rule);
    }

}
