package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DbmrelService;
import com.ceb.gjjs.mda.vo.DbmrelVO;

public class DbmrelServiceTest extends BaseTest{

    @Autowired
    private DbmrelService dbmrel;

    @Test
    public void initTest() throws IOException {
        DbmrelVO req = null;
        File file = Paths.get(testJsonDir, "dbmrel").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmrelVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmrelVO> response = dbmrel.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DbmrelVO req = null;
        File file = Paths.get(testJsonDir, "dbmrel").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmrelVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmrelVO> response = dbmrel.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DbmrelVO req = null;
        File file = Paths.get(testJsonDir, "dbmrel").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmrelVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmrelVO> response = dbmrel.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DbmrelVO req = null;
        File file = Paths.get(testJsonDir, "dbmrel").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DbmrelVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DbmrelVO> response = dbmrel.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DbmrelVO req = new DbmrelVO();
        // 参数设置
        ResponseSet<DbmrelVO> response = dbmrel.executeDefault(req,rule);
    }

}
