package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetameService;
import com.ceb.gjjs.mda.vo.DetameVO;

public class DetameServiceTest extends BaseTest{

    @Autowired
    private DetameService detame;

    @Test
    public void initTest() throws IOException {
        DetameVO req = null;
        File file = Paths.get(testJsonDir, "detame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetameVO> response = detame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetameVO req = null;
        File file = Paths.get(testJsonDir, "detame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetameVO> response = detame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetameVO req = null;
        File file = Paths.get(testJsonDir, "detame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetameVO> response = detame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetameVO req = null;
        File file = Paths.get(testJsonDir, "detame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetameVO> response = detame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetameVO req = new DetameVO();
        // 参数设置
        ResponseSet<DetameVO> response = detame.executeDefault(req,rule);
    }

}
