package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetcanService;
import com.ceb.gjjs.mda.vo.DetcanVO;

public class DetcanServiceTest extends BaseTest{

    @Autowired
    private DetcanService detcan;

    @Test
    public void initTest() throws IOException {
        DetcanVO req = null;
        File file = Paths.get(testJsonDir, "detcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetcanVO> response = detcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetcanVO req = null;
        File file = Paths.get(testJsonDir, "detcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetcanVO> response = detcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetcanVO req = null;
        File file = Paths.get(testJsonDir, "detcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetcanVO> response = detcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetcanVO req = null;
        File file = Paths.get(testJsonDir, "detcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetcanVO> response = detcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetcanVO req = new DetcanVO();
        // 参数设置
        ResponseSet<DetcanVO> response = detcan.executeDefault(req,rule);
    }

}
