package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetfrcService;
import com.ceb.gjjs.mda.vo.DetfrcVO;

public class DetfrcServiceTest extends BaseTest{

    @Autowired
    private DetfrcService detfrc;

    @Test
    public void initTest() throws IOException {
        DetfrcVO req = null;
        File file = Paths.get(testJsonDir, "detfrc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrcVO> response = detfrc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetfrcVO req = null;
        File file = Paths.get(testJsonDir, "detfrc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrcVO> response = detfrc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetfrcVO req = null;
        File file = Paths.get(testJsonDir, "detfrc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrcVO> response = detfrc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetfrcVO req = null;
        File file = Paths.get(testJsonDir, "detfrc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrcVO> response = detfrc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetfrcVO req = new DetfrcVO();
        // 参数设置
        ResponseSet<DetfrcVO> response = detfrc.executeDefault(req,rule);
    }

}
