package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetfrdService;
import com.ceb.gjjs.mda.vo.DetfrdVO;

public class DetfrdServiceTest extends BaseTest{

    @Autowired
    private DetfrdService detfrd;

    @Test
    public void initTest() throws IOException {
        DetfrdVO req = null;
        File file = Paths.get(testJsonDir, "detfrd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrdVO> response = detfrd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetfrdVO req = null;
        File file = Paths.get(testJsonDir, "detfrd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrdVO> response = detfrd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetfrdVO req = null;
        File file = Paths.get(testJsonDir, "detfrd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrdVO> response = detfrd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetfrdVO req = null;
        File file = Paths.get(testJsonDir, "detfrd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfrdVO> response = detfrd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetfrdVO req = new DetfrdVO();
        // 参数设置
        ResponseSet<DetfrdVO> response = detfrd.executeDefault(req,rule);
    }

}
