package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetfreService;
import com.ceb.gjjs.mda.vo.DetfreVO;

public class DetfreServiceTest extends BaseTest{

    @Autowired
    private DetfreService detfre;

    @Test
    public void initTest() throws IOException {
        DetfreVO req = null;
        File file = Paths.get(testJsonDir, "detfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfreVO> response = detfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetfreVO req = null;
        File file = Paths.get(testJsonDir, "detfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfreVO> response = detfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetfreVO req = null;
        File file = Paths.get(testJsonDir, "detfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfreVO> response = detfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetfreVO req = null;
        File file = Paths.get(testJsonDir, "detfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetfreVO> response = detfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetfreVO req = new DetfreVO();
        // 参数设置
        ResponseSet<DetfreVO> response = detfre.executeDefault(req,rule);
    }

}
