package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DetopnService;
import com.ceb.gjjs.mda.vo.DetopnVO;

public class DetopnServiceTest extends BaseTest{

    @Autowired
    private DetopnService detopn;

    @Test
    public void initTest() throws IOException {
        DetopnVO req = null;
        File file = Paths.get(testJsonDir, "detopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetopnVO> response = detopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DetopnVO req = null;
        File file = Paths.get(testJsonDir, "detopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetopnVO> response = detopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DetopnVO req = null;
        File file = Paths.get(testJsonDir, "detopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetopnVO> response = detopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DetopnVO req = null;
        File file = Paths.get(testJsonDir, "detopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DetopnVO> response = detopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DetopnVO req = new DetopnVO();
        // 参数设置
        ResponseSet<DetopnVO> response = detopn.executeDefault(req,rule);
    }

}
