package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Ditame0Service;
import com.ceb.gjjs.mda.vo.Ditame0VO;

public class Ditame0ServiceTest extends BaseTest{

    @Autowired
    private Ditame0Service ditame0;

    @Test
    public void initTest() throws IOException {
        Ditame0VO req = null;
        File file = Paths.get(testJsonDir, "ditame0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Ditame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Ditame0VO> response = ditame0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Ditame0VO req = null;
        File file = Paths.get(testJsonDir, "ditame0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Ditame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Ditame0VO> response = ditame0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Ditame0VO req = null;
        File file = Paths.get(testJsonDir, "ditame0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Ditame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Ditame0VO> response = ditame0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Ditame0VO req = null;
        File file = Paths.get(testJsonDir, "ditame0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Ditame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Ditame0VO> response = ditame0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Ditame0VO req = new Ditame0VO();
        // 参数设置
        ResponseSet<Ditame0VO> response = ditame0.executeDefault(req,rule);
    }

}
