package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitameService;
import com.ceb.gjjs.mda.vo.DitameVO;

public class DitameServiceTest extends BaseTest{

    @Autowired
    private DitameService ditame;

    @Test
    public void initTest() throws IOException {
        DitameVO req = null;
        File file = Paths.get(testJsonDir, "ditame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitameVO> response = ditame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitameVO req = null;
        File file = Paths.get(testJsonDir, "ditame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitameVO> response = ditame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitameVO req = null;
        File file = Paths.get(testJsonDir, "ditame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitameVO> response = ditame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitameVO req = null;
        File file = Paths.get(testJsonDir, "ditame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitameVO> response = ditame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitameVO req = new DitameVO();
        // 参数设置
        ResponseSet<DitameVO> response = ditame.executeDefault(req,rule);
    }

}
