package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitcanService;
import com.ceb.gjjs.mda.vo.DitcanVO;

public class DitcanServiceTest extends BaseTest{

    @Autowired
    private DitcanService ditcan;

    @Test
    public void initTest() throws IOException {
        DitcanVO req = null;
        File file = Paths.get(testJsonDir, "ditcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitcanVO> response = ditcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitcanVO req = null;
        File file = Paths.get(testJsonDir, "ditcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitcanVO> response = ditcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitcanVO req = null;
        File file = Paths.get(testJsonDir, "ditcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitcanVO> response = ditcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitcanVO req = null;
        File file = Paths.get(testJsonDir, "ditcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitcanVO> response = ditcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitcanVO req = new DitcanVO();
        // 参数设置
        ResponseSet<DitcanVO> response = ditcan.executeDefault(req,rule);
    }

}
