package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitdamService;
import com.ceb.gjjs.mda.vo.DitdamVO;

public class DitdamServiceTest extends BaseTest{

    @Autowired
    private DitdamService ditdam;

    @Test
    public void initTest() throws IOException {
        DitdamVO req = null;
        File file = Paths.get(testJsonDir, "ditdam").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdamVO> response = ditdam.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitdamVO req = null;
        File file = Paths.get(testJsonDir, "ditdam").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdamVO> response = ditdam.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitdamVO req = null;
        File file = Paths.get(testJsonDir, "ditdam").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdamVO> response = ditdam.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitdamVO req = null;
        File file = Paths.get(testJsonDir, "ditdam").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdamVO> response = ditdam.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitdamVO req = new DitdamVO();
        // 参数设置
        ResponseSet<DitdamVO> response = ditdam.executeDefault(req,rule);
    }

}
