package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitdavService;
import com.ceb.gjjs.mda.vo.DitdavVO;

public class DitdavServiceTest extends BaseTest{

    @Autowired
    private DitdavService ditdav;

    @Test
    public void initTest() throws IOException {
        DitdavVO req = null;
        File file = Paths.get(testJsonDir, "ditdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdavVO> response = ditdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitdavVO req = null;
        File file = Paths.get(testJsonDir, "ditdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdavVO> response = ditdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitdavVO req = null;
        File file = Paths.get(testJsonDir, "ditdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdavVO> response = ditdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitdavVO req = null;
        File file = Paths.get(testJsonDir, "ditdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdavVO> response = ditdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitdavVO req = new DitdavVO();
        // 参数设置
        ResponseSet<DitdavVO> response = ditdav.executeDefault(req,rule);
    }

}
