package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitdopService;
import com.ceb.gjjs.mda.vo.DitdopVO;

public class DitdopServiceTest extends BaseTest{

    @Autowired
    private DitdopService ditdop;

    @Test
    public void initTest() throws IOException {
        DitdopVO req = null;
        File file = Paths.get(testJsonDir, "ditdop").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdopVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdopVO> response = ditdop.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitdopVO req = null;
        File file = Paths.get(testJsonDir, "ditdop").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdopVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdopVO> response = ditdop.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitdopVO req = null;
        File file = Paths.get(testJsonDir, "ditdop").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdopVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdopVO> response = ditdop.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitdopVO req = null;
        File file = Paths.get(testJsonDir, "ditdop").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitdopVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitdopVO> response = ditdop.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitdopVO req = new DitdopVO();
        // 参数设置
        ResponseSet<DitdopVO> response = ditdop.executeDefault(req,rule);
    }

}
