package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitmavService;
import com.ceb.gjjs.mda.vo.DitmavVO;

public class DitmavServiceTest extends BaseTest{

    @Autowired
    private DitmavService ditmav;

    @Test
    public void initTest() throws IOException {
        DitmavVO req = null;
        File file = Paths.get(testJsonDir, "ditmav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitmavVO> response = ditmav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitmavVO req = null;
        File file = Paths.get(testJsonDir, "ditmav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitmavVO> response = ditmav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitmavVO req = null;
        File file = Paths.get(testJsonDir, "ditmav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitmavVO> response = ditmav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitmavVO req = null;
        File file = Paths.get(testJsonDir, "ditmav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitmavVO> response = ditmav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitmavVO req = new DitmavVO();
        // 参数设置
        ResponseSet<DitmavVO> response = ditmav.executeDefault(req,rule);
    }

}
