package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.DitopnService;
import com.ceb.gjjs.mda.vo.DitopnVO;

public class DitopnServiceTest extends BaseTest{

    @Autowired
    private DitopnService ditopn;

    @Test
    public void initTest() throws IOException {
        DitopnVO req = null;
        File file = Paths.get(testJsonDir, "ditopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitopnVO> response = ditopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        DitopnVO req = null;
        File file = Paths.get(testJsonDir, "ditopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitopnVO> response = ditopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        DitopnVO req = null;
        File file = Paths.get(testJsonDir, "ditopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitopnVO> response = ditopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        DitopnVO req = null;
        File file = Paths.get(testJsonDir, "ditopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<DitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<DitopnVO> response = ditopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        DitopnVO req = new DitopnVO();
        // 参数设置
        ResponseSet<DitopnVO> response = ditopn.executeDefault(req,rule);
    }

}
