package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.EabopnService;
import com.ceb.gjjs.mda.vo.EabopnVO;

public class EabopnServiceTest extends BaseTest{

    @Autowired
    private EabopnService eabopn;

    @Test
    public void initTest() throws IOException {
        EabopnVO req = null;
        File file = Paths.get(testJsonDir, "eabopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<EabopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<EabopnVO> response = eabopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        EabopnVO req = null;
        File file = Paths.get(testJsonDir, "eabopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<EabopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<EabopnVO> response = eabopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        EabopnVO req = null;
        File file = Paths.get(testJsonDir, "eabopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<EabopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<EabopnVO> response = eabopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        EabopnVO req = null;
        File file = Paths.get(testJsonDir, "eabopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<EabopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<EabopnVO> response = eabopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        EabopnVO req = new EabopnVO();
        // 参数设置
        ResponseSet<EabopnVO> response = eabopn.executeDefault(req,rule);
    }

}
