package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ErsselService;
import com.ceb.gjjs.mda.vo.ErsselVO;

public class ErsselServiceTest extends BaseTest{

    @Autowired
    private ErsselService erssel;

    @Test
    public void initTest() throws IOException {
        ErsselVO req = null;
        File file = Paths.get(testJsonDir, "erssel").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsselVO> response = erssel.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ErsselVO req = null;
        File file = Paths.get(testJsonDir, "erssel").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsselVO> response = erssel.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ErsselVO req = null;
        File file = Paths.get(testJsonDir, "erssel").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsselVO> response = erssel.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ErsselVO req = null;
        File file = Paths.get(testJsonDir, "erssel").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsselVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsselVO> response = erssel.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ErsselVO req = new ErsselVO();
        // 参数设置
        ResponseSet<ErsselVO> response = erssel.executeDefault(req,rule);
    }

}
