package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ErsshwService;
import com.ceb.gjjs.mda.vo.ErsshwVO;

public class ErsshwServiceTest extends BaseTest{

    @Autowired
    private ErsshwService ersshw;

    @Test
    public void initTest() throws IOException {
        ErsshwVO req = null;
        File file = Paths.get(testJsonDir, "ersshw").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsshwVO> response = ersshw.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ErsshwVO req = null;
        File file = Paths.get(testJsonDir, "ersshw").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsshwVO> response = ersshw.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ErsshwVO req = null;
        File file = Paths.get(testJsonDir, "ersshw").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsshwVO> response = ersshw.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ErsshwVO req = null;
        File file = Paths.get(testJsonDir, "ersshw").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ErsshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ErsshwVO> response = ersshw.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ErsshwVO req = new ErsshwVO();
        // 参数设置
        ResponseSet<ErsshwVO> response = ersshw.executeDefault(req,rule);
    }

}
