package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FeqapiService;
import com.ceb.gjjs.mda.vo.FeqapiVO;

public class FeqapiServiceTest extends BaseTest{

    @Autowired
    private FeqapiService feqapi;

    @Test
    public void initTest() throws IOException {
        FeqapiVO req = null;
        File file = Paths.get(testJsonDir, "feqapi").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqapiVO> response = feqapi.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FeqapiVO req = null;
        File file = Paths.get(testJsonDir, "feqapi").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqapiVO> response = feqapi.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FeqapiVO req = null;
        File file = Paths.get(testJsonDir, "feqapi").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqapiVO> response = feqapi.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FeqapiVO req = null;
        File file = Paths.get(testJsonDir, "feqapi").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqapiVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqapiVO> response = feqapi.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FeqapiVO req = new FeqapiVO();
        // 参数设置
        ResponseSet<FeqapiVO> response = feqapi.executeDefault(req,rule);
    }

}
