package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FeqcxsService;
import com.ceb.gjjs.mda.vo.FeqcxsVO;

public class FeqcxsServiceTest extends BaseTest{

    @Autowired
    private FeqcxsService feqcxs;

    @Test
    public void initTest() throws IOException {
        FeqcxsVO req = null;
        File file = Paths.get(testJsonDir, "feqcxs").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqcxsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqcxsVO> response = feqcxs.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FeqcxsVO req = null;
        File file = Paths.get(testJsonDir, "feqcxs").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqcxsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqcxsVO> response = feqcxs.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FeqcxsVO req = null;
        File file = Paths.get(testJsonDir, "feqcxs").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqcxsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqcxsVO> response = feqcxs.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FeqcxsVO req = null;
        File file = Paths.get(testJsonDir, "feqcxs").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqcxsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqcxsVO> response = feqcxs.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FeqcxsVO req = new FeqcxsVO();
        // 参数设置
        ResponseSet<FeqcxsVO> response = feqcxs.executeDefault(req,rule);
    }

}
