package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FeqopnService;
import com.ceb.gjjs.mda.vo.FeqopnVO;

public class FeqopnServiceTest extends BaseTest{

    @Autowired
    private FeqopnService feqopn;

    @Test
    public void initTest() throws IOException {
        FeqopnVO req = null;
        File file = Paths.get(testJsonDir, "feqopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqopnVO> response = feqopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FeqopnVO req = null;
        File file = Paths.get(testJsonDir, "feqopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqopnVO> response = feqopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FeqopnVO req = null;
        File file = Paths.get(testJsonDir, "feqopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqopnVO> response = feqopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FeqopnVO req = null;
        File file = Paths.get(testJsonDir, "feqopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FeqopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FeqopnVO> response = feqopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FeqopnVO req = new FeqopnVO();
        // 参数设置
        ResponseSet<FeqopnVO> response = feqopn.executeDefault(req,rule);
    }

}
