package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Fftapn0Service;
import com.ceb.gjjs.mda.vo.Fftapn0VO;

public class Fftapn0ServiceTest extends BaseTest{

    @Autowired
    private Fftapn0Service fftapn0;

    @Test
    public void initTest() throws IOException {
        Fftapn0VO req = null;
        File file = Paths.get(testJsonDir, "fftapn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftapn0VO> response = fftapn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Fftapn0VO req = null;
        File file = Paths.get(testJsonDir, "fftapn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftapn0VO> response = fftapn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Fftapn0VO req = null;
        File file = Paths.get(testJsonDir, "fftapn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftapn0VO> response = fftapn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Fftapn0VO req = null;
        File file = Paths.get(testJsonDir, "fftapn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftapn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftapn0VO> response = fftapn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Fftapn0VO req = new Fftapn0VO();
        // 参数设置
        ResponseSet<Fftapn0VO> response = fftapn0.executeDefault(req,rule);
    }

}
