package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FftcfmService;
import com.ceb.gjjs.mda.vo.FftcfmVO;

public class FftcfmServiceTest extends BaseTest{

    @Autowired
    private FftcfmService fftcfm;

    @Test
    public void initTest() throws IOException {
        FftcfmVO req = null;
        File file = Paths.get(testJsonDir, "fftcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftcfmVO> response = fftcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FftcfmVO req = null;
        File file = Paths.get(testJsonDir, "fftcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftcfmVO> response = fftcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FftcfmVO req = null;
        File file = Paths.get(testJsonDir, "fftcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftcfmVO> response = fftcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FftcfmVO req = null;
        File file = Paths.get(testJsonDir, "fftcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftcfmVO> response = fftcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FftcfmVO req = new FftcfmVO();
        // 参数设置
        ResponseSet<FftcfmVO> response = fftcfm.executeDefault(req,rule);
    }

}
