package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FftdavService;
import com.ceb.gjjs.mda.vo.FftdavVO;

public class FftdavServiceTest extends BaseTest{

    @Autowired
    private FftdavService fftdav;

    @Test
    public void initTest() throws IOException {
        FftdavVO req = null;
        File file = Paths.get(testJsonDir, "fftdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftdavVO> response = fftdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FftdavVO req = null;
        File file = Paths.get(testJsonDir, "fftdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftdavVO> response = fftdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FftdavVO req = null;
        File file = Paths.get(testJsonDir, "fftdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftdavVO> response = fftdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FftdavVO req = null;
        File file = Paths.get(testJsonDir, "fftdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftdavVO> response = fftdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FftdavVO req = new FftdavVO();
        // 参数设置
        ResponseSet<FftdavVO> response = fftdav.executeDefault(req,rule);
    }

}
