package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Fftopn0Service;
import com.ceb.gjjs.mda.vo.Fftopn0VO;

public class Fftopn0ServiceTest extends BaseTest{

    @Autowired
    private Fftopn0Service fftopn0;

    @Test
    public void initTest() throws IOException {
        Fftopn0VO req = null;
        File file = Paths.get(testJsonDir, "fftopn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftopn0VO> response = fftopn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Fftopn0VO req = null;
        File file = Paths.get(testJsonDir, "fftopn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftopn0VO> response = fftopn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Fftopn0VO req = null;
        File file = Paths.get(testJsonDir, "fftopn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftopn0VO> response = fftopn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Fftopn0VO req = null;
        File file = Paths.get(testJsonDir, "fftopn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fftopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fftopn0VO> response = fftopn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Fftopn0VO req = new Fftopn0VO();
        // 参数设置
        ResponseSet<Fftopn0VO> response = fftopn0.executeDefault(req,rule);
    }

}
