package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FftopnService;
import com.ceb.gjjs.mda.vo.FftopnVO;

public class FftopnServiceTest extends BaseTest{

    @Autowired
    private FftopnService fftopn;

    @Test
    public void initTest() throws IOException {
        FftopnVO req = null;
        File file = Paths.get(testJsonDir, "fftopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftopnVO> response = fftopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FftopnVO req = null;
        File file = Paths.get(testJsonDir, "fftopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftopnVO> response = fftopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FftopnVO req = null;
        File file = Paths.get(testJsonDir, "fftopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftopnVO> response = fftopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FftopnVO req = null;
        File file = Paths.get(testJsonDir, "fftopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FftopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FftopnVO> response = fftopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FftopnVO req = new FftopnVO();
        // 参数设置
        ResponseSet<FftopnVO> response = fftopn.executeDefault(req,rule);
    }

}
