package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FncadvService;
import com.ceb.gjjs.mda.vo.FncadvVO;

public class FncadvServiceTest extends BaseTest{

    @Autowired
    private FncadvService fncadv;

    @Test
    public void initTest() throws IOException {
        FncadvVO req = null;
        File file = Paths.get(testJsonDir, "fncadv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncadvVO> response = fncadv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FncadvVO req = null;
        File file = Paths.get(testJsonDir, "fncadv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncadvVO> response = fncadv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FncadvVO req = null;
        File file = Paths.get(testJsonDir, "fncadv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncadvVO> response = fncadv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FncadvVO req = null;
        File file = Paths.get(testJsonDir, "fncadv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncadvVO> response = fncadv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FncadvVO req = new FncadvVO();
        // 参数设置
        ResponseSet<FncadvVO> response = fncadv.executeDefault(req,rule);
    }

}
