package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Fncfre0Service;
import com.ceb.gjjs.mda.vo.Fncfre0VO;

public class Fncfre0ServiceTest extends BaseTest{

    @Autowired
    private Fncfre0Service fncfre0;

    @Test
    public void initTest() throws IOException {
        Fncfre0VO req = null;
        File file = Paths.get(testJsonDir, "fncfre0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fncfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fncfre0VO> response = fncfre0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Fncfre0VO req = null;
        File file = Paths.get(testJsonDir, "fncfre0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fncfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fncfre0VO> response = fncfre0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Fncfre0VO req = null;
        File file = Paths.get(testJsonDir, "fncfre0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fncfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fncfre0VO> response = fncfre0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Fncfre0VO req = null;
        File file = Paths.get(testJsonDir, "fncfre0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Fncfre0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Fncfre0VO> response = fncfre0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Fncfre0VO req = new Fncfre0VO();
        // 参数设置
        ResponseSet<Fncfre0VO> response = fncfre0.executeDefault(req,rule);
    }

}
