package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FncfreService;
import com.ceb.gjjs.mda.vo.FncfreVO;

public class FncfreServiceTest extends BaseTest{

    @Autowired
    private FncfreService fncfre;

    @Test
    public void initTest() throws IOException {
        FncfreVO req = null;
        File file = Paths.get(testJsonDir, "fncfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncfreVO> response = fncfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FncfreVO req = null;
        File file = Paths.get(testJsonDir, "fncfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncfreVO> response = fncfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FncfreVO req = null;
        File file = Paths.get(testJsonDir, "fncfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncfreVO> response = fncfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FncfreVO req = null;
        File file = Paths.get(testJsonDir, "fncfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FncfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FncfreVO> response = fncfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FncfreVO req = new FncfreVO();
        // 参数设置
        ResponseSet<FncfreVO> response = fncfre.executeDefault(req,rule);
    }

}
