package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FpdsllService;
import com.ceb.gjjs.mda.vo.FpdsllVO;

public class FpdsllServiceTest extends BaseTest{

    @Autowired
    private FpdsllService fpdsll;

    @Test
    public void initTest() throws IOException {
        FpdsllVO req = null;
        File file = Paths.get(testJsonDir, "fpdsll").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FpdsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FpdsllVO> response = fpdsll.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FpdsllVO req = null;
        File file = Paths.get(testJsonDir, "fpdsll").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FpdsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FpdsllVO> response = fpdsll.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FpdsllVO req = null;
        File file = Paths.get(testJsonDir, "fpdsll").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FpdsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FpdsllVO> response = fpdsll.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FpdsllVO req = null;
        File file = Paths.get(testJsonDir, "fpdsll").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FpdsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FpdsllVO> response = fpdsll.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FpdsllVO req = new FpdsllVO();
        // 参数设置
        ResponseSet<FpdsllVO> response = fpdsll.executeDefault(req,rule);
    }

}
