package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FqtopnService;
import com.ceb.gjjs.mda.vo.FqtopnVO;

public class FqtopnServiceTest extends BaseTest{

    @Autowired
    private FqtopnService fqtopn;

    @Test
    public void initTest() throws IOException {
        FqtopnVO req = null;
        File file = Paths.get(testJsonDir, "fqtopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FqtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FqtopnVO> response = fqtopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FqtopnVO req = null;
        File file = Paths.get(testJsonDir, "fqtopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FqtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FqtopnVO> response = fqtopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FqtopnVO req = null;
        File file = Paths.get(testJsonDir, "fqtopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FqtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FqtopnVO> response = fqtopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FqtopnVO req = null;
        File file = Paths.get(testJsonDir, "fqtopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FqtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FqtopnVO> response = fqtopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FqtopnVO req = new FqtopnVO();
        // 参数设置
        ResponseSet<FqtopnVO> response = fqtopn.executeDefault(req,rule);
    }

}
