package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FstmdlService;
import com.ceb.gjjs.mda.vo.FstmdlVO;

public class FstmdlServiceTest extends BaseTest{

    @Autowired
    private FstmdlService fstmdl;

    @Test
    public void initTest() throws IOException {
        FstmdlVO req = null;
        File file = Paths.get(testJsonDir, "fstmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FstmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FstmdlVO> response = fstmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FstmdlVO req = null;
        File file = Paths.get(testJsonDir, "fstmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FstmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FstmdlVO> response = fstmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FstmdlVO req = null;
        File file = Paths.get(testJsonDir, "fstmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FstmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FstmdlVO> response = fstmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FstmdlVO req = null;
        File file = Paths.get(testJsonDir, "fstmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FstmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FstmdlVO> response = fstmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FstmdlVO req = new FstmdlVO();
        // 参数设置
        ResponseSet<FstmdlVO> response = fstmdl.executeDefault(req,rule);
    }

}
