package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfbdsService;
import com.ceb.gjjs.mda.vo.FxfbdsVO;

public class FxfbdsServiceTest extends BaseTest{

    @Autowired
    private FxfbdsService fxfbds;

    @Test
    public void initTest() throws IOException {
        FxfbdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfbds").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdsVO> response = fxfbds.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfbdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfbds").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdsVO> response = fxfbds.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfbdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfbds").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdsVO> response = fxfbds.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfbdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfbds").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdsVO> response = fxfbds.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfbdsVO req = new FxfbdsVO();
        // 参数设置
        ResponseSet<FxfbdsVO> response = fxfbds.executeDefault(req,rule);
    }

}
