package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfbdvService;
import com.ceb.gjjs.mda.vo.FxfbdvVO;

public class FxfbdvServiceTest extends BaseTest{

    @Autowired
    private FxfbdvService fxfbdv;

    @Test
    public void initTest() throws IOException {
        FxfbdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfbdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdvVO> response = fxfbdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfbdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfbdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdvVO> response = fxfbdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfbdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfbdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdvVO> response = fxfbdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfbdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfbdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbdvVO> response = fxfbdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfbdvVO req = new FxfbdvVO();
        // 参数设置
        ResponseSet<FxfbdvVO> response = fxfbdv.executeDefault(req,rule);
    }

}
