package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfbuyService;
import com.ceb.gjjs.mda.vo.FxfbuyVO;

public class FxfbuyServiceTest extends BaseTest{

    @Autowired
    private FxfbuyService fxfbuy;

    @Test
    public void initTest() throws IOException {
        FxfbuyVO req = null;
        File file = Paths.get(testJsonDir, "fxfbuy").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbuyVO> response = fxfbuy.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfbuyVO req = null;
        File file = Paths.get(testJsonDir, "fxfbuy").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbuyVO> response = fxfbuy.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfbuyVO req = null;
        File file = Paths.get(testJsonDir, "fxfbuy").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbuyVO> response = fxfbuy.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfbuyVO req = null;
        File file = Paths.get(testJsonDir, "fxfbuy").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfbuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfbuyVO> response = fxfbuy.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfbuyVO req = new FxfbuyVO();
        // 参数设置
        ResponseSet<FxfbuyVO> response = fxfbuy.executeDefault(req,rule);
    }

}
