package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxffdvService;
import com.ceb.gjjs.mda.vo.FxffdvVO;

public class FxffdvServiceTest extends BaseTest{

    @Autowired
    private FxffdvService fxffdv;

    @Test
    public void initTest() throws IOException {
        FxffdvVO req = null;
        File file = Paths.get(testJsonDir, "fxffdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxffdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxffdvVO> response = fxffdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxffdvVO req = null;
        File file = Paths.get(testJsonDir, "fxffdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxffdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxffdvVO> response = fxffdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxffdvVO req = null;
        File file = Paths.get(testJsonDir, "fxffdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxffdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxffdvVO> response = fxffdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxffdvVO req = null;
        File file = Paths.get(testJsonDir, "fxffdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxffdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxffdvVO> response = fxffdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxffdvVO req = new FxffdvVO();
        // 参数设置
        ResponseSet<FxffdvVO> response = fxffdv.executeDefault(req,rule);
    }

}
