package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfsdsService;
import com.ceb.gjjs.mda.vo.FxfsdsVO;

public class FxfsdsServiceTest extends BaseTest{

    @Autowired
    private FxfsdsService fxfsds;

    @Test
    public void initTest() throws IOException {
        FxfsdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfsds").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdsVO> response = fxfsds.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfsdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfsds").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdsVO> response = fxfsds.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfsdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfsds").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdsVO> response = fxfsds.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfsdsVO req = null;
        File file = Paths.get(testJsonDir, "fxfsds").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdsVO> response = fxfsds.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfsdsVO req = new FxfsdsVO();
        // 参数设置
        ResponseSet<FxfsdsVO> response = fxfsds.executeDefault(req,rule);
    }

}
