package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfsdvService;
import com.ceb.gjjs.mda.vo.FxfsdvVO;

public class FxfsdvServiceTest extends BaseTest{

    @Autowired
    private FxfsdvService fxfsdv;

    @Test
    public void initTest() throws IOException {
        FxfsdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfsdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdvVO> response = fxfsdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfsdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfsdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdvVO> response = fxfsdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfsdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfsdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdvVO> response = fxfsdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfsdvVO req = null;
        File file = Paths.get(testJsonDir, "fxfsdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsdvVO> response = fxfsdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfsdvVO req = new FxfsdvVO();
        // 参数设置
        ResponseSet<FxfsdvVO> response = fxfsdv.executeDefault(req,rule);
    }

}
