package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxfsllService;
import com.ceb.gjjs.mda.vo.FxfsllVO;

public class FxfsllServiceTest extends BaseTest{

    @Autowired
    private FxfsllService fxfsll;

    @Test
    public void initTest() throws IOException {
        FxfsllVO req = null;
        File file = Paths.get(testJsonDir, "fxfsll").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsllVO> response = fxfsll.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxfsllVO req = null;
        File file = Paths.get(testJsonDir, "fxfsll").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsllVO> response = fxfsll.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxfsllVO req = null;
        File file = Paths.get(testJsonDir, "fxfsll").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsllVO> response = fxfsll.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxfsllVO req = null;
        File file = Paths.get(testJsonDir, "fxfsll").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxfsllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxfsllVO> response = fxfsll.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxfsllVO req = new FxfsllVO();
        // 参数设置
        ResponseSet<FxfsllVO> response = fxfsll.executeDefault(req,rule);
    }

}
