package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxibdvService;
import com.ceb.gjjs.mda.vo.FxibdvVO;

public class FxibdvServiceTest extends BaseTest{

    @Autowired
    private FxibdvService fxibdv;

    @Test
    public void initTest() throws IOException {
        FxibdvVO req = null;
        File file = Paths.get(testJsonDir, "fxibdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibdvVO> response = fxibdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxibdvVO req = null;
        File file = Paths.get(testJsonDir, "fxibdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibdvVO> response = fxibdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxibdvVO req = null;
        File file = Paths.get(testJsonDir, "fxibdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibdvVO> response = fxibdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxibdvVO req = null;
        File file = Paths.get(testJsonDir, "fxibdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibdvVO> response = fxibdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxibdvVO req = new FxibdvVO();
        // 参数设置
        ResponseSet<FxibdvVO> response = fxibdv.executeDefault(req,rule);
    }

}
