package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxibuyService;
import com.ceb.gjjs.mda.vo.FxibuyVO;

public class FxibuyServiceTest extends BaseTest{

    @Autowired
    private FxibuyService fxibuy;

    @Test
    public void initTest() throws IOException {
        FxibuyVO req = null;
        File file = Paths.get(testJsonDir, "fxibuy").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibuyVO> response = fxibuy.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxibuyVO req = null;
        File file = Paths.get(testJsonDir, "fxibuy").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibuyVO> response = fxibuy.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxibuyVO req = null;
        File file = Paths.get(testJsonDir, "fxibuy").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibuyVO> response = fxibuy.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxibuyVO req = null;
        File file = Paths.get(testJsonDir, "fxibuy").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxibuyVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxibuyVO> response = fxibuy.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxibuyVO req = new FxibuyVO();
        // 参数设置
        ResponseSet<FxibuyVO> response = fxibuy.executeDefault(req,rule);
    }

}
