package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxisdvService;
import com.ceb.gjjs.mda.vo.FxisdvVO;

public class FxisdvServiceTest extends BaseTest{

    @Autowired
    private FxisdvService fxisdv;

    @Test
    public void initTest() throws IOException {
        FxisdvVO req = null;
        File file = Paths.get(testJsonDir, "fxisdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisdvVO> response = fxisdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxisdvVO req = null;
        File file = Paths.get(testJsonDir, "fxisdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisdvVO> response = fxisdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxisdvVO req = null;
        File file = Paths.get(testJsonDir, "fxisdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisdvVO> response = fxisdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxisdvVO req = null;
        File file = Paths.get(testJsonDir, "fxisdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisdvVO> response = fxisdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxisdvVO req = new FxisdvVO();
        // 参数设置
        ResponseSet<FxisdvVO> response = fxisdv.executeDefault(req,rule);
    }

}
