package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxisllService;
import com.ceb.gjjs.mda.vo.FxisllVO;

public class FxisllServiceTest extends BaseTest{

    @Autowired
    private FxisllService fxisll;

    @Test
    public void initTest() throws IOException {
        FxisllVO req = null;
        File file = Paths.get(testJsonDir, "fxisll").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisllVO> response = fxisll.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxisllVO req = null;
        File file = Paths.get(testJsonDir, "fxisll").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisllVO> response = fxisll.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxisllVO req = null;
        File file = Paths.get(testJsonDir, "fxisll").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisllVO> response = fxisll.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxisllVO req = null;
        File file = Paths.get(testJsonDir, "fxisll").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxisllVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxisllVO> response = fxisll.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxisllVO req = new FxisllVO();
        // 参数设置
        ResponseSet<FxisllVO> response = fxisll.executeDefault(req,rule);
    }

}
