package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxradvService;
import com.ceb.gjjs.mda.vo.FxradvVO;

public class FxradvServiceTest extends BaseTest{

    @Autowired
    private FxradvService fxradv;

    @Test
    public void initTest() throws IOException {
        FxradvVO req = null;
        File file = Paths.get(testJsonDir, "fxradv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxradvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxradvVO> response = fxradv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxradvVO req = null;
        File file = Paths.get(testJsonDir, "fxradv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxradvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxradvVO> response = fxradv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxradvVO req = null;
        File file = Paths.get(testJsonDir, "fxradv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxradvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxradvVO> response = fxradv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxradvVO req = null;
        File file = Paths.get(testJsonDir, "fxradv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxradvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxradvVO> response = fxradv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxradvVO req = new FxradvVO();
        // 参数设置
        ResponseSet<FxradvVO> response = fxradv.executeDefault(req,rule);
    }

}
