package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxtadvService;
import com.ceb.gjjs.mda.vo.FxtadvVO;

public class FxtadvServiceTest extends BaseTest{

    @Autowired
    private FxtadvService fxtadv;

    @Test
    public void initTest() throws IOException {
        FxtadvVO req = null;
        File file = Paths.get(testJsonDir, "fxtadv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtadvVO> response = fxtadv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxtadvVO req = null;
        File file = Paths.get(testJsonDir, "fxtadv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtadvVO> response = fxtadv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxtadvVO req = null;
        File file = Paths.get(testJsonDir, "fxtadv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtadvVO> response = fxtadv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxtadvVO req = null;
        File file = Paths.get(testJsonDir, "fxtadv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtadvVO> response = fxtadv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxtadvVO req = new FxtadvVO();
        // 参数设置
        ResponseSet<FxtadvVO> response = fxtadv.executeDefault(req,rule);
    }

}
