package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxtfreService;
import com.ceb.gjjs.mda.vo.FxtfreVO;

public class FxtfreServiceTest extends BaseTest{

    @Autowired
    private FxtfreService fxtfre;

    @Test
    public void initTest() throws IOException {
        FxtfreVO req = null;
        File file = Paths.get(testJsonDir, "fxtfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtfreVO> response = fxtfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxtfreVO req = null;
        File file = Paths.get(testJsonDir, "fxtfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtfreVO> response = fxtfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxtfreVO req = null;
        File file = Paths.get(testJsonDir, "fxtfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtfreVO> response = fxtfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxtfreVO req = null;
        File file = Paths.get(testJsonDir, "fxtfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtfreVO> response = fxtfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxtfreVO req = new FxtfreVO();
        // 参数设置
        ResponseSet<FxtfreVO> response = fxtfre.executeDefault(req,rule);
    }

}
