package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FxtopnService;
import com.ceb.gjjs.mda.vo.FxtopnVO;

public class FxtopnServiceTest extends BaseTest{

    @Autowired
    private FxtopnService fxtopn;

    @Test
    public void initTest() throws IOException {
        FxtopnVO req = null;
        File file = Paths.get(testJsonDir, "fxtopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtopnVO> response = fxtopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FxtopnVO req = null;
        File file = Paths.get(testJsonDir, "fxtopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtopnVO> response = fxtopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FxtopnVO req = null;
        File file = Paths.get(testJsonDir, "fxtopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtopnVO> response = fxtopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FxtopnVO req = null;
        File file = Paths.get(testJsonDir, "fxtopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FxtopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FxtopnVO> response = fxtopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FxtopnVO req = new FxtopnVO();
        // 参数设置
        ResponseSet<FxtopnVO> response = fxtopn.executeDefault(req,rule);
    }

}
