package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FytcfmService;
import com.ceb.gjjs.mda.vo.FytcfmVO;

public class FytcfmServiceTest extends BaseTest{

    @Autowired
    private FytcfmService fytcfm;

    @Test
    public void initTest() throws IOException {
        FytcfmVO req = null;
        File file = Paths.get(testJsonDir, "fytcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytcfmVO> response = fytcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FytcfmVO req = null;
        File file = Paths.get(testJsonDir, "fytcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytcfmVO> response = fytcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FytcfmVO req = null;
        File file = Paths.get(testJsonDir, "fytcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytcfmVO> response = fytcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FytcfmVO req = null;
        File file = Paths.get(testJsonDir, "fytcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytcfmVO> response = fytcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FytcfmVO req = new FytcfmVO();
        // 参数设置
        ResponseSet<FytcfmVO> response = fytcfm.executeDefault(req,rule);
    }

}
