package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FytdavService;
import com.ceb.gjjs.mda.vo.FytdavVO;

public class FytdavServiceTest extends BaseTest{

    @Autowired
    private FytdavService fytdav;

    @Test
    public void initTest() throws IOException {
        FytdavVO req = null;
        File file = Paths.get(testJsonDir, "fytdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytdavVO> response = fytdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FytdavVO req = null;
        File file = Paths.get(testJsonDir, "fytdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytdavVO> response = fytdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FytdavVO req = null;
        File file = Paths.get(testJsonDir, "fytdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytdavVO> response = fytdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FytdavVO req = null;
        File file = Paths.get(testJsonDir, "fytdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytdavVO> response = fytdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FytdavVO req = new FytdavVO();
        // 参数设置
        ResponseSet<FytdavVO> response = fytdav.executeDefault(req,rule);
    }

}
