package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FytmdlService;
import com.ceb.gjjs.mda.vo.FytmdlVO;

public class FytmdlServiceTest extends BaseTest{

    @Autowired
    private FytmdlService fytmdl;

    @Test
    public void initTest() throws IOException {
        FytmdlVO req = null;
        File file = Paths.get(testJsonDir, "fytmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytmdlVO> response = fytmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FytmdlVO req = null;
        File file = Paths.get(testJsonDir, "fytmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytmdlVO> response = fytmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FytmdlVO req = null;
        File file = Paths.get(testJsonDir, "fytmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytmdlVO> response = fytmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FytmdlVO req = null;
        File file = Paths.get(testJsonDir, "fytmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytmdlVO> response = fytmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FytmdlVO req = new FytmdlVO();
        // 参数设置
        ResponseSet<FytmdlVO> response = fytmdl.executeDefault(req,rule);
    }

}
