package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.FytopnService;
import com.ceb.gjjs.mda.vo.FytopnVO;

public class FytopnServiceTest extends BaseTest{

    @Autowired
    private FytopnService fytopn;

    @Test
    public void initTest() throws IOException {
        FytopnVO req = null;
        File file = Paths.get(testJsonDir, "fytopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytopnVO> response = fytopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        FytopnVO req = null;
        File file = Paths.get(testJsonDir, "fytopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytopnVO> response = fytopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        FytopnVO req = null;
        File file = Paths.get(testJsonDir, "fytopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytopnVO> response = fytopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        FytopnVO req = null;
        File file = Paths.get(testJsonDir, "fytopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<FytopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<FytopnVO> response = fytopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        FytopnVO req = new FytopnVO();
        // 参数设置
        ResponseSet<FytopnVO> response = fytopn.executeDefault(req,rule);
    }

}
