package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Gitame0Service;
import com.ceb.gjjs.mda.vo.Gitame0VO;

public class Gitame0ServiceTest extends BaseTest{

    @Autowired
    private Gitame0Service gitame0;

    @Test
    public void initTest() throws IOException {
        Gitame0VO req = null;
        File file = Paths.get(testJsonDir, "gitame0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Gitame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Gitame0VO> response = gitame0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Gitame0VO req = null;
        File file = Paths.get(testJsonDir, "gitame0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Gitame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Gitame0VO> response = gitame0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Gitame0VO req = null;
        File file = Paths.get(testJsonDir, "gitame0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Gitame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Gitame0VO> response = gitame0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Gitame0VO req = null;
        File file = Paths.get(testJsonDir, "gitame0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Gitame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Gitame0VO> response = gitame0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Gitame0VO req = new Gitame0VO();
        // 参数设置
        ResponseSet<Gitame0VO> response = gitame0.executeDefault(req,rule);
    }

}
