package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitameService;
import com.ceb.gjjs.mda.vo.GitameVO;

public class GitameServiceTest extends BaseTest{

    @Autowired
    private GitameService gitame;

    @Test
    public void initTest() throws IOException {
        GitameVO req = null;
        File file = Paths.get(testJsonDir, "gitame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitameVO> response = gitame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitameVO req = null;
        File file = Paths.get(testJsonDir, "gitame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitameVO> response = gitame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitameVO req = null;
        File file = Paths.get(testJsonDir, "gitame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitameVO> response = gitame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitameVO req = null;
        File file = Paths.get(testJsonDir, "gitame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitameVO> response = gitame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitameVO req = new GitameVO();
        // 参数设置
        ResponseSet<GitameVO> response = gitame.executeDefault(req,rule);
    }

}
