package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitapnService;
import com.ceb.gjjs.mda.vo.GitapnVO;

public class GitapnServiceTest extends BaseTest{

    @Autowired
    private GitapnService gitapn;

    @Test
    public void initTest() throws IOException {
        GitapnVO req = null;
        File file = Paths.get(testJsonDir, "gitapn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitapnVO> response = gitapn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitapnVO req = null;
        File file = Paths.get(testJsonDir, "gitapn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitapnVO> response = gitapn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitapnVO req = null;
        File file = Paths.get(testJsonDir, "gitapn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitapnVO> response = gitapn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitapnVO req = null;
        File file = Paths.get(testJsonDir, "gitapn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitapnVO> response = gitapn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitapnVO req = new GitapnVO();
        // 参数设置
        ResponseSet<GitapnVO> response = gitapn.executeDefault(req,rule);
    }

}
