package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitaszService;
import com.ceb.gjjs.mda.vo.GitaszVO;

public class GitaszServiceTest extends BaseTest{

    @Autowired
    private GitaszService gitasz;

    @Test
    public void initTest() throws IOException {
        GitaszVO req = null;
        File file = Paths.get(testJsonDir, "gitasz").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitaszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitaszVO> response = gitasz.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitaszVO req = null;
        File file = Paths.get(testJsonDir, "gitasz").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitaszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitaszVO> response = gitasz.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitaszVO req = null;
        File file = Paths.get(testJsonDir, "gitasz").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitaszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitaszVO> response = gitasz.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitaszVO req = null;
        File file = Paths.get(testJsonDir, "gitasz").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitaszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitaszVO> response = gitasz.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitaszVO req = new GitaszVO();
        // 参数设置
        ResponseSet<GitaszVO> response = gitasz.executeDefault(req,rule);
    }

}
