package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitcanService;
import com.ceb.gjjs.mda.vo.GitcanVO;

public class GitcanServiceTest extends BaseTest{

    @Autowired
    private GitcanService gitcan;

    @Test
    public void initTest() throws IOException {
        GitcanVO req = null;
        File file = Paths.get(testJsonDir, "gitcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcanVO> response = gitcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitcanVO req = null;
        File file = Paths.get(testJsonDir, "gitcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcanVO> response = gitcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitcanVO req = null;
        File file = Paths.get(testJsonDir, "gitcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcanVO> response = gitcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitcanVO req = null;
        File file = Paths.get(testJsonDir, "gitcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcanVO> response = gitcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitcanVO req = new GitcanVO();
        // 参数设置
        ResponseSet<GitcanVO> response = gitcan.executeDefault(req,rule);
    }

}
