package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitcfmService;
import com.ceb.gjjs.mda.vo.GitcfmVO;

public class GitcfmServiceTest extends BaseTest{

    @Autowired
    private GitcfmService gitcfm;

    @Test
    public void initTest() throws IOException {
        GitcfmVO req = null;
        File file = Paths.get(testJsonDir, "gitcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcfmVO> response = gitcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitcfmVO req = null;
        File file = Paths.get(testJsonDir, "gitcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcfmVO> response = gitcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitcfmVO req = null;
        File file = Paths.get(testJsonDir, "gitcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcfmVO> response = gitcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitcfmVO req = null;
        File file = Paths.get(testJsonDir, "gitcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcfmVO> response = gitcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitcfmVO req = new GitcfmVO();
        // 参数设置
        ResponseSet<GitcfmVO> response = gitcfm.executeDefault(req,rule);
    }

}
