package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitcxmService;
import com.ceb.gjjs.mda.vo.GitcxmVO;

public class GitcxmServiceTest extends BaseTest{

    @Autowired
    private GitcxmService gitcxm;

    @Test
    public void initTest() throws IOException {
        GitcxmVO req = null;
        File file = Paths.get(testJsonDir, "gitcxm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcxmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcxmVO> response = gitcxm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitcxmVO req = null;
        File file = Paths.get(testJsonDir, "gitcxm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcxmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcxmVO> response = gitcxm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitcxmVO req = null;
        File file = Paths.get(testJsonDir, "gitcxm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcxmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcxmVO> response = gitcxm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitcxmVO req = null;
        File file = Paths.get(testJsonDir, "gitcxm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitcxmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitcxmVO> response = gitcxm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitcxmVO req = new GitcxmVO();
        // 参数设置
        ResponseSet<GitcxmVO> response = gitcxm.executeDefault(req,rule);
    }

}
