package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitdavService;
import com.ceb.gjjs.mda.vo.GitdavVO;

public class GitdavServiceTest extends BaseTest{

    @Autowired
    private GitdavService gitdav;

    @Test
    public void initTest() throws IOException {
        GitdavVO req = null;
        File file = Paths.get(testJsonDir, "gitdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitdavVO> response = gitdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitdavVO req = null;
        File file = Paths.get(testJsonDir, "gitdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitdavVO> response = gitdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitdavVO req = null;
        File file = Paths.get(testJsonDir, "gitdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitdavVO> response = gitdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitdavVO req = null;
        File file = Paths.get(testJsonDir, "gitdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitdavVO> response = gitdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitdavVO req = new GitdavVO();
        // 参数设置
        ResponseSet<GitdavVO> response = gitdav.executeDefault(req,rule);
    }

}
