package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitimgService;
import com.ceb.gjjs.mda.vo.GitimgVO;

public class GitimgServiceTest extends BaseTest{

    @Autowired
    private GitimgService gitimg;

    @Test
    public void initTest() throws IOException {
        GitimgVO req = null;
        File file = Paths.get(testJsonDir, "gitimg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitimgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitimgVO> response = gitimg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitimgVO req = null;
        File file = Paths.get(testJsonDir, "gitimg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitimgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitimgVO> response = gitimg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitimgVO req = null;
        File file = Paths.get(testJsonDir, "gitimg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitimgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitimgVO> response = gitimg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitimgVO req = null;
        File file = Paths.get(testJsonDir, "gitimg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitimgVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitimgVO> response = gitimg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitimgVO req = new GitimgVO();
        // 参数设置
        ResponseSet<GitimgVO> response = gitimg.executeDefault(req,rule);
    }

}
