package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitmavService;
import com.ceb.gjjs.mda.vo.GitmavVO;

public class GitmavServiceTest extends BaseTest{

    @Autowired
    private GitmavService gitmav;

    @Test
    public void initTest() throws IOException {
        GitmavVO req = null;
        File file = Paths.get(testJsonDir, "gitmav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmavVO> response = gitmav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitmavVO req = null;
        File file = Paths.get(testJsonDir, "gitmav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmavVO> response = gitmav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitmavVO req = null;
        File file = Paths.get(testJsonDir, "gitmav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmavVO> response = gitmav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitmavVO req = null;
        File file = Paths.get(testJsonDir, "gitmav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmavVO> response = gitmav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitmavVO req = new GitmavVO();
        // 参数设置
        ResponseSet<GitmavVO> response = gitmav.executeDefault(req,rule);
    }

}
