package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitmcvService;
import com.ceb.gjjs.mda.vo.GitmcvVO;

public class GitmcvServiceTest extends BaseTest{

    @Autowired
    private GitmcvService gitmcv;

    @Test
    public void initTest() throws IOException {
        GitmcvVO req = null;
        File file = Paths.get(testJsonDir, "gitmcv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmcvVO> response = gitmcv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitmcvVO req = null;
        File file = Paths.get(testJsonDir, "gitmcv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmcvVO> response = gitmcv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitmcvVO req = null;
        File file = Paths.get(testJsonDir, "gitmcv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmcvVO> response = gitmcv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitmcvVO req = null;
        File file = Paths.get(testJsonDir, "gitmcv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmcvVO> response = gitmcv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitmcvVO req = new GitmcvVO();
        // 参数设置
        ResponseSet<GitmcvVO> response = gitmcv.executeDefault(req,rule);
    }

}
