package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitmdlService;
import com.ceb.gjjs.mda.vo.GitmdlVO;

public class GitmdlServiceTest extends BaseTest{

    @Autowired
    private GitmdlService gitmdl;

    @Test
    public void initTest() throws IOException {
        GitmdlVO req = null;
        File file = Paths.get(testJsonDir, "gitmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmdlVO> response = gitmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitmdlVO req = null;
        File file = Paths.get(testJsonDir, "gitmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmdlVO> response = gitmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitmdlVO req = null;
        File file = Paths.get(testJsonDir, "gitmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmdlVO> response = gitmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitmdlVO req = null;
        File file = Paths.get(testJsonDir, "gitmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitmdlVO> response = gitmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitmdlVO req = new GitmdlVO();
        // 参数设置
        ResponseSet<GitmdlVO> response = gitmdl.executeDefault(req,rule);
    }

}
