package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitopnService;
import com.ceb.gjjs.mda.vo.GitopnVO;

public class GitopnServiceTest extends BaseTest{

    @Autowired
    private GitopnService gitopn;

    @Test
    public void initTest() throws IOException {
        GitopnVO req = null;
        File file = Paths.get(testJsonDir, "gitopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitopnVO> response = gitopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitopnVO req = null;
        File file = Paths.get(testJsonDir, "gitopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitopnVO> response = gitopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitopnVO req = null;
        File file = Paths.get(testJsonDir, "gitopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitopnVO> response = gitopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitopnVO req = null;
        File file = Paths.get(testJsonDir, "gitopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitopnVO> response = gitopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitopnVO req = new GitopnVO();
        // 参数设置
        ResponseSet<GitopnVO> response = gitopn.executeDefault(req,rule);
    }

}
