package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitoszService;
import com.ceb.gjjs.mda.vo.GitoszVO;

public class GitoszServiceTest extends BaseTest{

    @Autowired
    private GitoszService gitosz;

    @Test
    public void initTest() throws IOException {
        GitoszVO req = null;
        File file = Paths.get(testJsonDir, "gitosz").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitoszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitoszVO> response = gitosz.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitoszVO req = null;
        File file = Paths.get(testJsonDir, "gitosz").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitoszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitoszVO> response = gitosz.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitoszVO req = null;
        File file = Paths.get(testJsonDir, "gitosz").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitoszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitoszVO> response = gitosz.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitoszVO req = null;
        File file = Paths.get(testJsonDir, "gitosz").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitoszVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitoszVO> response = gitosz.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitoszVO req = new GitoszVO();
        // 参数设置
        ResponseSet<GitoszVO> response = gitosz.executeDefault(req,rule);
    }

}
