package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitrcvService;
import com.ceb.gjjs.mda.vo.GitrcvVO;

public class GitrcvServiceTest extends BaseTest{

    @Autowired
    private GitrcvService gitrcv;

    @Test
    public void initTest() throws IOException {
        GitrcvVO req = null;
        File file = Paths.get(testJsonDir, "gitrcv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitrcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitrcvVO> response = gitrcv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitrcvVO req = null;
        File file = Paths.get(testJsonDir, "gitrcv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitrcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitrcvVO> response = gitrcv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitrcvVO req = null;
        File file = Paths.get(testJsonDir, "gitrcv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitrcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitrcvVO> response = gitrcv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitrcvVO req = null;
        File file = Paths.get(testJsonDir, "gitrcv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitrcvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitrcvVO> response = gitrcv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitrcvVO req = new GitrcvVO();
        // 参数设置
        ResponseSet<GitrcvVO> response = gitrcv.executeDefault(req,rule);
    }

}
