package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GitsndService;
import com.ceb.gjjs.mda.vo.GitsndVO;

public class GitsndServiceTest extends BaseTest{

    @Autowired
    private GitsndService gitsnd;

    @Test
    public void initTest() throws IOException {
        GitsndVO req = null;
        File file = Paths.get(testJsonDir, "gitsnd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitsndVO> response = gitsnd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GitsndVO req = null;
        File file = Paths.get(testJsonDir, "gitsnd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitsndVO> response = gitsnd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GitsndVO req = null;
        File file = Paths.get(testJsonDir, "gitsnd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitsndVO> response = gitsnd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GitsndVO req = null;
        File file = Paths.get(testJsonDir, "gitsnd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GitsndVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GitsndVO> response = gitsnd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GitsndVO req = new GitsndVO();
        // 参数设置
        ResponseSet<GitsndVO> response = gitsnd.executeDefault(req,rule);
    }

}
