package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GittrsService;
import com.ceb.gjjs.mda.vo.GittrsVO;

public class GittrsServiceTest extends BaseTest{

    @Autowired
    private GittrsService gittrs;

    @Test
    public void initTest() throws IOException {
        GittrsVO req = null;
        File file = Paths.get(testJsonDir, "gittrs").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittrsVO> response = gittrs.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GittrsVO req = null;
        File file = Paths.get(testJsonDir, "gittrs").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittrsVO> response = gittrs.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GittrsVO req = null;
        File file = Paths.get(testJsonDir, "gittrs").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittrsVO> response = gittrs.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GittrsVO req = null;
        File file = Paths.get(testJsonDir, "gittrs").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittrsVO> response = gittrs.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GittrsVO req = new GittrsVO();
        // 参数设置
        ResponseSet<GittrsVO> response = gittrs.executeDefault(req,rule);
    }

}
