package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.GittskService;
import com.ceb.gjjs.mda.vo.GittskVO;

public class GittskServiceTest extends BaseTest{

    @Autowired
    private GittskService gittsk;

    @Test
    public void initTest() throws IOException {
        GittskVO req = null;
        File file = Paths.get(testJsonDir, "gittsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittskVO> response = gittsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        GittskVO req = null;
        File file = Paths.get(testJsonDir, "gittsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittskVO> response = gittsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        GittskVO req = null;
        File file = Paths.get(testJsonDir, "gittsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittskVO> response = gittsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        GittskVO req = null;
        File file = Paths.get(testJsonDir, "gittsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<GittskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<GittskVO> response = gittsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        GittskVO req = new GittskVO();
        // 参数设置
        ResponseSet<GittskVO> response = gittsk.executeDefault(req,rule);
    }

}
