package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.HyfqueService;
import com.ceb.gjjs.mda.vo.HyfqueVO;

public class HyfqueServiceTest extends BaseTest{

    @Autowired
    private HyfqueService hyfque;

    @Test
    public void initTest() throws IOException {
        HyfqueVO req = null;
        File file = Paths.get(testJsonDir, "hyfque").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<HyfqueVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<HyfqueVO> response = hyfque.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        HyfqueVO req = null;
        File file = Paths.get(testJsonDir, "hyfque").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<HyfqueVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<HyfqueVO> response = hyfque.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        HyfqueVO req = null;
        File file = Paths.get(testJsonDir, "hyfque").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<HyfqueVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<HyfqueVO> response = hyfque.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        HyfqueVO req = null;
        File file = Paths.get(testJsonDir, "hyfque").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<HyfqueVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<HyfqueVO> response = hyfque.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        HyfqueVO req = new HyfqueVO();
        // 参数设置
        ResponseSet<HyfqueVO> response = hyfque.executeDefault(req,rule);
    }

}
