package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.IrfadvService;
import com.ceb.gjjs.mda.vo.IrfadvVO;

public class IrfadvServiceTest extends BaseTest{

    @Autowired
    private IrfadvService irfadv;

    @Test
    public void initTest() throws IOException {
        IrfadvVO req = null;
        File file = Paths.get(testJsonDir, "irfadv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfadvVO> response = irfadv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        IrfadvVO req = null;
        File file = Paths.get(testJsonDir, "irfadv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfadvVO> response = irfadv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        IrfadvVO req = null;
        File file = Paths.get(testJsonDir, "irfadv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfadvVO> response = irfadv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        IrfadvVO req = null;
        File file = Paths.get(testJsonDir, "irfadv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfadvVO> response = irfadv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        IrfadvVO req = new IrfadvVO();
        // 参数设置
        ResponseSet<IrfadvVO> response = irfadv.executeDefault(req,rule);
    }

}
