package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Irfopn1Service;
import com.ceb.gjjs.mda.vo.Irfopn1VO;

public class Irfopn1ServiceTest extends BaseTest{

    @Autowired
    private Irfopn1Service irfopn1;

    @Test
    public void initTest() throws IOException {
        Irfopn1VO req = null;
        File file = Paths.get(testJsonDir, "irfopn1").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Irfopn1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Irfopn1VO> response = irfopn1.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Irfopn1VO req = null;
        File file = Paths.get(testJsonDir, "irfopn1").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Irfopn1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Irfopn1VO> response = irfopn1.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Irfopn1VO req = null;
        File file = Paths.get(testJsonDir, "irfopn1").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Irfopn1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Irfopn1VO> response = irfopn1.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Irfopn1VO req = null;
        File file = Paths.get(testJsonDir, "irfopn1").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Irfopn1VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Irfopn1VO> response = irfopn1.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Irfopn1VO req = new Irfopn1VO();
        // 参数设置
        ResponseSet<Irfopn1VO> response = irfopn1.executeDefault(req,rule);
    }

}
