package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.IrfopnService;
import com.ceb.gjjs.mda.vo.IrfopnVO;

public class IrfopnServiceTest extends BaseTest{

    @Autowired
    private IrfopnService irfopn;

    @Test
    public void initTest() throws IOException {
        IrfopnVO req = null;
        File file = Paths.get(testJsonDir, "irfopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfopnVO> response = irfopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        IrfopnVO req = null;
        File file = Paths.get(testJsonDir, "irfopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfopnVO> response = irfopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        IrfopnVO req = null;
        File file = Paths.get(testJsonDir, "irfopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfopnVO> response = irfopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        IrfopnVO req = null;
        File file = Paths.get(testJsonDir, "irfopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<IrfopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<IrfopnVO> response = irfopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        IrfopnVO req = new IrfopnVO();
        // 参数设置
        ResponseSet<IrfopnVO> response = irfopn.executeDefault(req,rule);
    }

}
