package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Jstame0Service;
import com.ceb.gjjs.mda.vo.Jstame0VO;

public class Jstame0ServiceTest extends BaseTest{

    @Autowired
    private Jstame0Service jstame0;

    @Test
    public void initTest() throws IOException {
        Jstame0VO req = null;
        File file = Paths.get(testJsonDir, "jstame0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstame0VO> response = jstame0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Jstame0VO req = null;
        File file = Paths.get(testJsonDir, "jstame0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstame0VO> response = jstame0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Jstame0VO req = null;
        File file = Paths.get(testJsonDir, "jstame0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstame0VO> response = jstame0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Jstame0VO req = null;
        File file = Paths.get(testJsonDir, "jstame0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstame0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstame0VO> response = jstame0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Jstame0VO req = new Jstame0VO();
        // 参数设置
        ResponseSet<Jstame0VO> response = jstame0.executeDefault(req,rule);
    }

}
