package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstameService;
import com.ceb.gjjs.mda.vo.JstameVO;

public class JstameServiceTest extends BaseTest{

    @Autowired
    private JstameService jstame;

    @Test
    public void initTest() throws IOException {
        JstameVO req = null;
        File file = Paths.get(testJsonDir, "jstame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstameVO> response = jstame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstameVO req = null;
        File file = Paths.get(testJsonDir, "jstame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstameVO> response = jstame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstameVO req = null;
        File file = Paths.get(testJsonDir, "jstame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstameVO> response = jstame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstameVO req = null;
        File file = Paths.get(testJsonDir, "jstame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstameVO> response = jstame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstameVO req = new JstameVO();
        // 参数设置
        ResponseSet<JstameVO> response = jstame.executeDefault(req,rule);
    }

}
