package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstamvService;
import com.ceb.gjjs.mda.vo.JstamvVO;

public class JstamvServiceTest extends BaseTest{

    @Autowired
    private JstamvService jstamv;

    @Test
    public void initTest() throws IOException {
        JstamvVO req = null;
        File file = Paths.get(testJsonDir, "jstamv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstamvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstamvVO> response = jstamv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstamvVO req = null;
        File file = Paths.get(testJsonDir, "jstamv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstamvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstamvVO> response = jstamv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstamvVO req = null;
        File file = Paths.get(testJsonDir, "jstamv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstamvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstamvVO> response = jstamv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstamvVO req = null;
        File file = Paths.get(testJsonDir, "jstamv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstamvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstamvVO> response = jstamv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstamvVO req = new JstamvVO();
        // 参数设置
        ResponseSet<JstamvVO> response = jstamv.executeDefault(req,rule);
    }

}
