package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstdavService;
import com.ceb.gjjs.mda.vo.JstdavVO;

public class JstdavServiceTest extends BaseTest{

    @Autowired
    private JstdavService jstdav;

    @Test
    public void initTest() throws IOException {
        JstdavVO req = null;
        File file = Paths.get(testJsonDir, "jstdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstdavVO> response = jstdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstdavVO req = null;
        File file = Paths.get(testJsonDir, "jstdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstdavVO> response = jstdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstdavVO req = null;
        File file = Paths.get(testJsonDir, "jstdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstdavVO> response = jstdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstdavVO req = null;
        File file = Paths.get(testJsonDir, "jstdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstdavVO> response = jstdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstdavVO req = new JstdavVO();
        // 参数设置
        ResponseSet<JstdavVO> response = jstdav.executeDefault(req,rule);
    }

}
