package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstjshService;
import com.ceb.gjjs.mda.vo.JstjshVO;

public class JstjshServiceTest extends BaseTest{

    @Autowired
    private JstjshService jstjsh;

    @Test
    public void initTest() throws IOException {
        JstjshVO req = null;
        File file = Paths.get(testJsonDir, "jstjsh").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstjshVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstjshVO> response = jstjsh.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstjshVO req = null;
        File file = Paths.get(testJsonDir, "jstjsh").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstjshVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstjshVO> response = jstjsh.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstjshVO req = null;
        File file = Paths.get(testJsonDir, "jstjsh").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstjshVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstjshVO> response = jstjsh.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstjshVO req = null;
        File file = Paths.get(testJsonDir, "jstjsh").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstjshVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstjshVO> response = jstjsh.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstjshVO req = new JstjshVO();
        // 参数设置
        ResponseSet<JstjshVO> response = jstjsh.executeDefault(req,rule);
    }

}
