package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstopnService;
import com.ceb.gjjs.mda.vo.JstopnVO;

public class JstopnServiceTest extends BaseTest{

    @Autowired
    private JstopnService jstopn;

    @Test
    public void initTest() throws IOException {
        JstopnVO req = null;
        File file = Paths.get(testJsonDir, "jstopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstopnVO> response = jstopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstopnVO req = null;
        File file = Paths.get(testJsonDir, "jstopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstopnVO> response = jstopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstopnVO req = null;
        File file = Paths.get(testJsonDir, "jstopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstopnVO> response = jstopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstopnVO req = null;
        File file = Paths.get(testJsonDir, "jstopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstopnVO> response = jstopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstopnVO req = new JstopnVO();
        // 参数设置
        ResponseSet<JstopnVO> response = jstopn.executeDefault(req,rule);
    }

}
