package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstpavService;
import com.ceb.gjjs.mda.vo.JstpavVO;

public class JstpavServiceTest extends BaseTest{

    @Autowired
    private JstpavService jstpav;

    @Test
    public void initTest() throws IOException {
        JstpavVO req = null;
        File file = Paths.get(testJsonDir, "jstpav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpavVO> response = jstpav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstpavVO req = null;
        File file = Paths.get(testJsonDir, "jstpav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpavVO> response = jstpav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstpavVO req = null;
        File file = Paths.get(testJsonDir, "jstpav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpavVO> response = jstpav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstpavVO req = null;
        File file = Paths.get(testJsonDir, "jstpav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpavVO> response = jstpav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstpavVO req = new JstpavVO();
        // 参数设置
        ResponseSet<JstpavVO> response = jstpav.executeDefault(req,rule);
    }

}
