package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstpayService;
import com.ceb.gjjs.mda.vo.JstpayVO;

public class JstpayServiceTest extends BaseTest{

    @Autowired
    private JstpayService jstpay;

    @Test
    public void initTest() throws IOException {
        JstpayVO req = null;
        File file = Paths.get(testJsonDir, "jstpay").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpayVO> response = jstpay.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstpayVO req = null;
        File file = Paths.get(testJsonDir, "jstpay").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpayVO> response = jstpay.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstpayVO req = null;
        File file = Paths.get(testJsonDir, "jstpay").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpayVO> response = jstpay.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstpayVO req = null;
        File file = Paths.get(testJsonDir, "jstpay").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstpayVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstpayVO> response = jstpay.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstpayVO req = new JstpayVO();
        // 参数设置
        ResponseSet<JstpayVO> response = jstpay.executeDefault(req,rule);
    }

}
