package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Jstset0Service;
import com.ceb.gjjs.mda.vo.Jstset0VO;

public class Jstset0ServiceTest extends BaseTest{

    @Autowired
    private Jstset0Service jstset0;

    @Test
    public void initTest() throws IOException {
        Jstset0VO req = null;
        File file = Paths.get(testJsonDir, "jstset0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstset0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstset0VO> response = jstset0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Jstset0VO req = null;
        File file = Paths.get(testJsonDir, "jstset0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstset0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstset0VO> response = jstset0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Jstset0VO req = null;
        File file = Paths.get(testJsonDir, "jstset0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstset0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstset0VO> response = jstset0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Jstset0VO req = null;
        File file = Paths.get(testJsonDir, "jstset0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Jstset0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Jstset0VO> response = jstset0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Jstset0VO req = new Jstset0VO();
        // 参数设置
        ResponseSet<Jstset0VO> response = jstset0.executeDefault(req,rule);
    }

}
