package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstsetService;
import com.ceb.gjjs.mda.vo.JstsetVO;

public class JstsetServiceTest extends BaseTest{

    @Autowired
    private JstsetService jstset;

    @Test
    public void initTest() throws IOException {
        JstsetVO req = null;
        File file = Paths.get(testJsonDir, "jstset").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsetVO> response = jstset.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstsetVO req = null;
        File file = Paths.get(testJsonDir, "jstset").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsetVO> response = jstset.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstsetVO req = null;
        File file = Paths.get(testJsonDir, "jstset").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsetVO> response = jstset.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstsetVO req = null;
        File file = Paths.get(testJsonDir, "jstset").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsetVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsetVO> response = jstset.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstsetVO req = new JstsetVO();
        // 参数设置
        ResponseSet<JstsetVO> response = jstset.executeDefault(req,rule);
    }

}
