package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.JstsevService;
import com.ceb.gjjs.mda.vo.JstsevVO;

public class JstsevServiceTest extends BaseTest{

    @Autowired
    private JstsevService jstsev;

    @Test
    public void initTest() throws IOException {
        JstsevVO req = null;
        File file = Paths.get(testJsonDir, "jstsev").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsevVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsevVO> response = jstsev.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        JstsevVO req = null;
        File file = Paths.get(testJsonDir, "jstsev").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsevVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsevVO> response = jstsev.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        JstsevVO req = null;
        File file = Paths.get(testJsonDir, "jstsev").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsevVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsevVO> response = jstsev.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        JstsevVO req = null;
        File file = Paths.get(testJsonDir, "jstsev").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<JstsevVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<JstsevVO> response = jstsev.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        JstsevVO req = new JstsevVO();
        // 参数设置
        ResponseSet<JstsevVO> response = jstsev.executeDefault(req,rule);
    }

}
