package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetameService;
import com.ceb.gjjs.mda.vo.LetameVO;

public class LetameServiceTest extends BaseTest{

    @Autowired
    private LetameService letame;

    @Test
    public void initTest() throws IOException {
        LetameVO req = null;
        File file = Paths.get(testJsonDir, "letame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetameVO> response = letame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetameVO req = null;
        File file = Paths.get(testJsonDir, "letame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetameVO> response = letame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetameVO req = null;
        File file = Paths.get(testJsonDir, "letame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetameVO> response = letame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetameVO req = null;
        File file = Paths.get(testJsonDir, "letame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetameVO> response = letame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetameVO req = new LetameVO();
        // 参数设置
        ResponseSet<LetameVO> response = letame.executeDefault(req,rule);
    }

}
