package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Letatd0Service;
import com.ceb.gjjs.mda.vo.Letatd0VO;

public class Letatd0ServiceTest extends BaseTest{

    @Autowired
    private Letatd0Service letatd0;

    @Test
    public void initTest() throws IOException {
        Letatd0VO req = null;
        File file = Paths.get(testJsonDir, "letatd0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Letatd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Letatd0VO> response = letatd0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Letatd0VO req = null;
        File file = Paths.get(testJsonDir, "letatd0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Letatd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Letatd0VO> response = letatd0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Letatd0VO req = null;
        File file = Paths.get(testJsonDir, "letatd0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Letatd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Letatd0VO> response = letatd0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Letatd0VO req = null;
        File file = Paths.get(testJsonDir, "letatd0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Letatd0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Letatd0VO> response = letatd0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Letatd0VO req = new Letatd0VO();
        // 参数设置
        ResponseSet<Letatd0VO> response = letatd0.executeDefault(req,rule);
    }

}
