package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetatdService;
import com.ceb.gjjs.mda.vo.LetatdVO;

public class LetatdServiceTest extends BaseTest{

    @Autowired
    private LetatdService letatd;

    @Test
    public void initTest() throws IOException {
        LetatdVO req = null;
        File file = Paths.get(testJsonDir, "letatd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatdVO> response = letatd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetatdVO req = null;
        File file = Paths.get(testJsonDir, "letatd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatdVO> response = letatd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetatdVO req = null;
        File file = Paths.get(testJsonDir, "letatd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatdVO> response = letatd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetatdVO req = null;
        File file = Paths.get(testJsonDir, "letatd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatdVO> response = letatd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetatdVO req = new LetatdVO();
        // 参数设置
        ResponseSet<LetatdVO> response = letatd.executeDefault(req,rule);
    }

}
