package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetateService;
import com.ceb.gjjs.mda.vo.LetateVO;

public class LetateServiceTest extends BaseTest{

    @Autowired
    private LetateService letate;

    @Test
    public void initTest() throws IOException {
        LetateVO req = null;
        File file = Paths.get(testJsonDir, "letate").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetateVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetateVO> response = letate.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetateVO req = null;
        File file = Paths.get(testJsonDir, "letate").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetateVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetateVO> response = letate.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetateVO req = null;
        File file = Paths.get(testJsonDir, "letate").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetateVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetateVO> response = letate.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetateVO req = null;
        File file = Paths.get(testJsonDir, "letate").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetateVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetateVO> response = letate.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetateVO req = new LetateVO();
        // 参数设置
        ResponseSet<LetateVO> response = letate.executeDefault(req,rule);
    }

}
