package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetatrService;
import com.ceb.gjjs.mda.vo.LetatrVO;

public class LetatrServiceTest extends BaseTest{

    @Autowired
    private LetatrService letatr;

    @Test
    public void initTest() throws IOException {
        LetatrVO req = null;
        File file = Paths.get(testJsonDir, "letatr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatrVO> response = letatr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetatrVO req = null;
        File file = Paths.get(testJsonDir, "letatr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatrVO> response = letatr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetatrVO req = null;
        File file = Paths.get(testJsonDir, "letatr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatrVO> response = letatr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetatrVO req = null;
        File file = Paths.get(testJsonDir, "letatr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatrVO> response = letatr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetatrVO req = new LetatrVO();
        // 参数设置
        ResponseSet<LetatrVO> response = letatr.executeDefault(req,rule);
    }

}
