package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetatsService;
import com.ceb.gjjs.mda.vo.LetatsVO;

public class LetatsServiceTest extends BaseTest{

    @Autowired
    private LetatsService letats;

    @Test
    public void initTest() throws IOException {
        LetatsVO req = null;
        File file = Paths.get(testJsonDir, "letats").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatsVO> response = letats.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetatsVO req = null;
        File file = Paths.get(testJsonDir, "letats").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatsVO> response = letats.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetatsVO req = null;
        File file = Paths.get(testJsonDir, "letats").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatsVO> response = letats.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetatsVO req = null;
        File file = Paths.get(testJsonDir, "letats").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetatsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetatsVO> response = letats.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetatsVO req = new LetatsVO();
        // 参数设置
        ResponseSet<LetatsVO> response = letats.executeDefault(req,rule);
    }

}
