package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetattService;
import com.ceb.gjjs.mda.vo.LetattVO;

public class LetattServiceTest extends BaseTest{

    @Autowired
    private LetattService letatt;

    @Test
    public void initTest() throws IOException {
        LetattVO req = null;
        File file = Paths.get(testJsonDir, "letatt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetattVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetattVO> response = letatt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetattVO req = null;
        File file = Paths.get(testJsonDir, "letatt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetattVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetattVO> response = letatt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetattVO req = null;
        File file = Paths.get(testJsonDir, "letatt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetattVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetattVO> response = letatt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetattVO req = null;
        File file = Paths.get(testJsonDir, "letatt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetattVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetattVO> response = letatt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetattVO req = new LetattVO();
        // 参数设置
        ResponseSet<LetattVO> response = letatt.executeDefault(req,rule);
    }

}
