package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetcanService;
import com.ceb.gjjs.mda.vo.LetcanVO;

public class LetcanServiceTest extends BaseTest{

    @Autowired
    private LetcanService letcan;

    @Test
    public void initTest() throws IOException {
        LetcanVO req = null;
        File file = Paths.get(testJsonDir, "letcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetcanVO> response = letcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetcanVO req = null;
        File file = Paths.get(testJsonDir, "letcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetcanVO> response = letcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetcanVO req = null;
        File file = Paths.get(testJsonDir, "letcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetcanVO> response = letcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetcanVO req = null;
        File file = Paths.get(testJsonDir, "letcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetcanVO> response = letcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetcanVO req = new LetcanVO();
        // 参数设置
        ResponseSet<LetcanVO> response = letcan.executeDefault(req,rule);
    }

}
