package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetfrcService;
import com.ceb.gjjs.mda.vo.LetfrcVO;

public class LetfrcServiceTest extends BaseTest{

    @Autowired
    private LetfrcService letfrc;

    @Test
    public void initTest() throws IOException {
        LetfrcVO req = null;
        File file = Paths.get(testJsonDir, "letfrc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrcVO> response = letfrc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetfrcVO req = null;
        File file = Paths.get(testJsonDir, "letfrc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrcVO> response = letfrc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetfrcVO req = null;
        File file = Paths.get(testJsonDir, "letfrc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrcVO> response = letfrc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetfrcVO req = null;
        File file = Paths.get(testJsonDir, "letfrc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrcVO> response = letfrc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetfrcVO req = new LetfrcVO();
        // 参数设置
        ResponseSet<LetfrcVO> response = letfrc.executeDefault(req,rule);
    }

}
