package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetfrdService;
import com.ceb.gjjs.mda.vo.LetfrdVO;

public class LetfrdServiceTest extends BaseTest{

    @Autowired
    private LetfrdService letfrd;

    @Test
    public void initTest() throws IOException {
        LetfrdVO req = null;
        File file = Paths.get(testJsonDir, "letfrd").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrdVO> response = letfrd.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetfrdVO req = null;
        File file = Paths.get(testJsonDir, "letfrd").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrdVO> response = letfrd.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetfrdVO req = null;
        File file = Paths.get(testJsonDir, "letfrd").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrdVO> response = letfrd.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetfrdVO req = null;
        File file = Paths.get(testJsonDir, "letfrd").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfrdVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfrdVO> response = letfrd.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetfrdVO req = new LetfrdVO();
        // 参数设置
        ResponseSet<LetfrdVO> response = letfrd.executeDefault(req,rule);
    }

}
