package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetfreService;
import com.ceb.gjjs.mda.vo.LetfreVO;

public class LetfreServiceTest extends BaseTest{

    @Autowired
    private LetfreService letfre;

    @Test
    public void initTest() throws IOException {
        LetfreVO req = null;
        File file = Paths.get(testJsonDir, "letfre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfreVO> response = letfre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetfreVO req = null;
        File file = Paths.get(testJsonDir, "letfre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfreVO> response = letfre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetfreVO req = null;
        File file = Paths.get(testJsonDir, "letfre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfreVO> response = letfre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetfreVO req = null;
        File file = Paths.get(testJsonDir, "letfre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetfreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetfreVO> response = letfre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetfreVO req = new LetfreVO();
        // 参数设置
        ResponseSet<LetfreVO> response = letfre.executeDefault(req,rule);
    }

}
