package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetopnService;
import com.ceb.gjjs.mda.vo.LetopnVO;

public class LetopnServiceTest extends BaseTest{

    @Autowired
    private LetopnService letopn;

    @Test
    public void initTest() throws IOException {
        LetopnVO req = null;
        File file = Paths.get(testJsonDir, "letopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetopnVO> response = letopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetopnVO req = null;
        File file = Paths.get(testJsonDir, "letopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetopnVO> response = letopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetopnVO req = null;
        File file = Paths.get(testJsonDir, "letopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetopnVO> response = letopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetopnVO req = null;
        File file = Paths.get(testJsonDir, "letopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetopnVO> response = letopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetopnVO req = new LetopnVO();
        // 参数设置
        ResponseSet<LetopnVO> response = letopn.executeDefault(req,rule);
    }

}
