package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetzreService;
import com.ceb.gjjs.mda.vo.LetzreVO;

public class LetzreServiceTest extends BaseTest{

    @Autowired
    private LetzreService letzre;

    @Test
    public void initTest() throws IOException {
        LetzreVO req = null;
        File file = Paths.get(testJsonDir, "letzre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzreVO> response = letzre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetzreVO req = null;
        File file = Paths.get(testJsonDir, "letzre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzreVO> response = letzre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetzreVO req = null;
        File file = Paths.get(testJsonDir, "letzre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzreVO> response = letzre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetzreVO req = null;
        File file = Paths.get(testJsonDir, "letzre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzreVO> response = letzre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetzreVO req = new LetzreVO();
        // 参数设置
        ResponseSet<LetzreVO> response = letzre.executeDefault(req,rule);
    }

}
