package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetzrnService;
import com.ceb.gjjs.mda.vo.LetzrnVO;

public class LetzrnServiceTest extends BaseTest{

    @Autowired
    private LetzrnService letzrn;

    @Test
    public void initTest() throws IOException {
        LetzrnVO req = null;
        File file = Paths.get(testJsonDir, "letzrn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrnVO> response = letzrn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetzrnVO req = null;
        File file = Paths.get(testJsonDir, "letzrn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrnVO> response = letzrn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetzrnVO req = null;
        File file = Paths.get(testJsonDir, "letzrn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrnVO> response = letzrn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetzrnVO req = null;
        File file = Paths.get(testJsonDir, "letzrn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrnVO> response = letzrn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetzrnVO req = new LetzrnVO();
        // 参数设置
        ResponseSet<LetzrnVO> response = letzrn.executeDefault(req,rule);
    }

}
