package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LetzrrService;
import com.ceb.gjjs.mda.vo.LetzrrVO;

public class LetzrrServiceTest extends BaseTest{

    @Autowired
    private LetzrrService letzrr;

    @Test
    public void initTest() throws IOException {
        LetzrrVO req = null;
        File file = Paths.get(testJsonDir, "letzrr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrrVO> response = letzrr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LetzrrVO req = null;
        File file = Paths.get(testJsonDir, "letzrr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrrVO> response = letzrr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LetzrrVO req = null;
        File file = Paths.get(testJsonDir, "letzrr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrrVO> response = letzrr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LetzrrVO req = null;
        File file = Paths.get(testJsonDir, "letzrr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LetzrrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LetzrrVO> response = letzrr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LetzrrVO req = new LetzrrVO();
        // 参数设置
        ResponseSet<LetzrrVO> response = letzrr.executeDefault(req,rule);
    }

}
