package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitameService;
import com.ceb.gjjs.mda.vo.LitameVO;

public class LitameServiceTest extends BaseTest{

    @Autowired
    private LitameService litame;

    @Test
    public void initTest() throws IOException {
        LitameVO req = null;
        File file = Paths.get(testJsonDir, "litame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitameVO> response = litame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitameVO req = null;
        File file = Paths.get(testJsonDir, "litame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitameVO> response = litame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitameVO req = null;
        File file = Paths.get(testJsonDir, "litame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitameVO> response = litame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitameVO req = null;
        File file = Paths.get(testJsonDir, "litame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitameVO> response = litame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitameVO req = new LitameVO();
        // 参数设置
        ResponseSet<LitameVO> response = litame.executeDefault(req,rule);
    }

}
