package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitapnService;
import com.ceb.gjjs.mda.vo.LitapnVO;

public class LitapnServiceTest extends BaseTest{

    @Autowired
    private LitapnService litapn;

    @Test
    public void initTest() throws IOException {
        LitapnVO req = null;
        File file = Paths.get(testJsonDir, "litapn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitapnVO> response = litapn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitapnVO req = null;
        File file = Paths.get(testJsonDir, "litapn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitapnVO> response = litapn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitapnVO req = null;
        File file = Paths.get(testJsonDir, "litapn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitapnVO> response = litapn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitapnVO req = null;
        File file = Paths.get(testJsonDir, "litapn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitapnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitapnVO> response = litapn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitapnVO req = new LitapnVO();
        // 参数设置
        ResponseSet<LitapnVO> response = litapn.executeDefault(req,rule);
    }

}
