package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitcanService;
import com.ceb.gjjs.mda.vo.LitcanVO;

public class LitcanServiceTest extends BaseTest{

    @Autowired
    private LitcanService litcan;

    @Test
    public void initTest() throws IOException {
        LitcanVO req = null;
        File file = Paths.get(testJsonDir, "litcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcanVO> response = litcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitcanVO req = null;
        File file = Paths.get(testJsonDir, "litcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcanVO> response = litcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitcanVO req = null;
        File file = Paths.get(testJsonDir, "litcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcanVO> response = litcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitcanVO req = null;
        File file = Paths.get(testJsonDir, "litcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcanVO> response = litcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitcanVO req = new LitcanVO();
        // 参数设置
        ResponseSet<LitcanVO> response = litcan.executeDefault(req,rule);
    }

}
