package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitcfmService;
import com.ceb.gjjs.mda.vo.LitcfmVO;

public class LitcfmServiceTest extends BaseTest{

    @Autowired
    private LitcfmService litcfm;

    @Test
    public void initTest() throws IOException {
        LitcfmVO req = null;
        File file = Paths.get(testJsonDir, "litcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcfmVO> response = litcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitcfmVO req = null;
        File file = Paths.get(testJsonDir, "litcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcfmVO> response = litcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitcfmVO req = null;
        File file = Paths.get(testJsonDir, "litcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcfmVO> response = litcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitcfmVO req = null;
        File file = Paths.get(testJsonDir, "litcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitcfmVO> response = litcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitcfmVO req = new LitcfmVO();
        // 参数设置
        ResponseSet<LitcfmVO> response = litcfm.executeDefault(req,rule);
    }

}
