package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitdavService;
import com.ceb.gjjs.mda.vo.LitdavVO;

public class LitdavServiceTest extends BaseTest{

    @Autowired
    private LitdavService litdav;

    @Test
    public void initTest() throws IOException {
        LitdavVO req = null;
        File file = Paths.get(testJsonDir, "litdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitdavVO> response = litdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitdavVO req = null;
        File file = Paths.get(testJsonDir, "litdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitdavVO> response = litdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitdavVO req = null;
        File file = Paths.get(testJsonDir, "litdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitdavVO> response = litdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitdavVO req = null;
        File file = Paths.get(testJsonDir, "litdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitdavVO> response = litdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitdavVO req = new LitdavVO();
        // 参数设置
        ResponseSet<LitdavVO> response = litdav.executeDefault(req,rule);
    }

}
