package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitfavService;
import com.ceb.gjjs.mda.vo.LitfavVO;

public class LitfavServiceTest extends BaseTest{

    @Autowired
    private LitfavService litfav;

    @Test
    public void initTest() throws IOException {
        LitfavVO req = null;
        File file = Paths.get(testJsonDir, "litfav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitfavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitfavVO> response = litfav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitfavVO req = null;
        File file = Paths.get(testJsonDir, "litfav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitfavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitfavVO> response = litfav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitfavVO req = null;
        File file = Paths.get(testJsonDir, "litfav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitfavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitfavVO> response = litfav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitfavVO req = null;
        File file = Paths.get(testJsonDir, "litfav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitfavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitfavVO> response = litfav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitfavVO req = new LitfavVO();
        // 参数设置
        ResponseSet<LitfavVO> response = litfav.executeDefault(req,rule);
    }

}
