package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitmavService;
import com.ceb.gjjs.mda.vo.LitmavVO;

public class LitmavServiceTest extends BaseTest{

    @Autowired
    private LitmavService litmav;

    @Test
    public void initTest() throws IOException {
        LitmavVO req = null;
        File file = Paths.get(testJsonDir, "litmav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmavVO> response = litmav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitmavVO req = null;
        File file = Paths.get(testJsonDir, "litmav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmavVO> response = litmav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitmavVO req = null;
        File file = Paths.get(testJsonDir, "litmav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmavVO> response = litmav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitmavVO req = null;
        File file = Paths.get(testJsonDir, "litmav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmavVO> response = litmav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitmavVO req = new LitmavVO();
        // 参数设置
        ResponseSet<LitmavVO> response = litmav.executeDefault(req,rule);
    }

}
