package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitmdlService;
import com.ceb.gjjs.mda.vo.LitmdlVO;

public class LitmdlServiceTest extends BaseTest{

    @Autowired
    private LitmdlService litmdl;

    @Test
    public void initTest() throws IOException {
        LitmdlVO req = null;
        File file = Paths.get(testJsonDir, "litmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmdlVO> response = litmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitmdlVO req = null;
        File file = Paths.get(testJsonDir, "litmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmdlVO> response = litmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitmdlVO req = null;
        File file = Paths.get(testJsonDir, "litmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmdlVO> response = litmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitmdlVO req = null;
        File file = Paths.get(testJsonDir, "litmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitmdlVO> response = litmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitmdlVO req = new LitmdlVO();
        // 参数设置
        ResponseSet<LitmdlVO> response = litmdl.executeDefault(req,rule);
    }

}
