package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitopnService;
import com.ceb.gjjs.mda.vo.LitopnVO;

public class LitopnServiceTest extends BaseTest{

    @Autowired
    private LitopnService litopn;

    @Test
    public void initTest() throws IOException {
        LitopnVO req = null;
        File file = Paths.get(testJsonDir, "litopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitopnVO> response = litopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitopnVO req = null;
        File file = Paths.get(testJsonDir, "litopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitopnVO> response = litopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitopnVO req = null;
        File file = Paths.get(testJsonDir, "litopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitopnVO> response = litopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitopnVO req = null;
        File file = Paths.get(testJsonDir, "litopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitopnVO> response = litopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitopnVO req = new LitopnVO();
        // 参数设置
        ResponseSet<LitopnVO> response = litopn.executeDefault(req,rule);
    }

}
