package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitpavService;
import com.ceb.gjjs.mda.vo.LitpavVO;

public class LitpavServiceTest extends BaseTest{

    @Autowired
    private LitpavService litpav;

    @Test
    public void initTest() throws IOException {
        LitpavVO req = null;
        File file = Paths.get(testJsonDir, "litpav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpavVO> response = litpav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitpavVO req = null;
        File file = Paths.get(testJsonDir, "litpav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpavVO> response = litpav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitpavVO req = null;
        File file = Paths.get(testJsonDir, "litpav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpavVO> response = litpav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitpavVO req = null;
        File file = Paths.get(testJsonDir, "litpav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpavVO> response = litpav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitpavVO req = new LitpavVO();
        // 参数设置
        ResponseSet<LitpavVO> response = litpav.executeDefault(req,rule);
    }

}
