package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitpegService;
import com.ceb.gjjs.mda.vo.LitpegVO;

public class LitpegServiceTest extends BaseTest{

    @Autowired
    private LitpegService litpeg;

    @Test
    public void initTest() throws IOException {
        LitpegVO req = null;
        File file = Paths.get(testJsonDir, "litpeg").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpegVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpegVO> response = litpeg.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitpegVO req = null;
        File file = Paths.get(testJsonDir, "litpeg").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpegVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpegVO> response = litpeg.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitpegVO req = null;
        File file = Paths.get(testJsonDir, "litpeg").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpegVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpegVO> response = litpeg.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitpegVO req = null;
        File file = Paths.get(testJsonDir, "litpeg").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpegVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpegVO> response = litpeg.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitpegVO req = new LitpegVO();
        // 参数设置
        ResponseSet<LitpegVO> response = litpeg.executeDefault(req,rule);
    }

}
