package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LitpreService;
import com.ceb.gjjs.mda.vo.LitpreVO;

public class LitpreServiceTest extends BaseTest{

    @Autowired
    private LitpreService litpre;

    @Test
    public void initTest() throws IOException {
        LitpreVO req = null;
        File file = Paths.get(testJsonDir, "litpre").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpreVO> response = litpre.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LitpreVO req = null;
        File file = Paths.get(testJsonDir, "litpre").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpreVO> response = litpre.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LitpreVO req = null;
        File file = Paths.get(testJsonDir, "litpre").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpreVO> response = litpre.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LitpreVO req = null;
        File file = Paths.get(testJsonDir, "litpre").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LitpreVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LitpreVO> response = litpre.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LitpreVO req = new LitpreVO();
        // 参数设置
        ResponseSet<LitpreVO> response = litpre.executeDefault(req,rule);
    }

}
