package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LittdvService;
import com.ceb.gjjs.mda.vo.LittdvVO;

public class LittdvServiceTest extends BaseTest{

    @Autowired
    private LittdvService littdv;

    @Test
    public void initTest() throws IOException {
        LittdvVO req = null;
        File file = Paths.get(testJsonDir, "littdv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittdvVO> response = littdv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LittdvVO req = null;
        File file = Paths.get(testJsonDir, "littdv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittdvVO> response = littdv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LittdvVO req = null;
        File file = Paths.get(testJsonDir, "littdv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittdvVO> response = littdv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LittdvVO req = null;
        File file = Paths.get(testJsonDir, "littdv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittdvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittdvVO> response = littdv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LittdvVO req = new LittdvVO();
        // 参数设置
        ResponseSet<LittdvVO> response = littdv.executeDefault(req,rule);
    }

}
