package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LittrcService;
import com.ceb.gjjs.mda.vo.LittrcVO;

public class LittrcServiceTest extends BaseTest{

    @Autowired
    private LittrcService littrc;

    @Test
    public void initTest() throws IOException {
        LittrcVO req = null;
        File file = Paths.get(testJsonDir, "littrc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrcVO> response = littrc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LittrcVO req = null;
        File file = Paths.get(testJsonDir, "littrc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrcVO> response = littrc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LittrcVO req = null;
        File file = Paths.get(testJsonDir, "littrc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrcVO> response = littrc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LittrcVO req = null;
        File file = Paths.get(testJsonDir, "littrc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrcVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrcVO> response = littrc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LittrcVO req = new LittrcVO();
        // 参数设置
        ResponseSet<LittrcVO> response = littrc.executeDefault(req,rule);
    }

}
