package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LittriService;
import com.ceb.gjjs.mda.vo.LittriVO;

public class LittriServiceTest extends BaseTest{

    @Autowired
    private LittriService littri;

    @Test
    public void initTest() throws IOException {
        LittriVO req = null;
        File file = Paths.get(testJsonDir, "littri").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittriVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittriVO> response = littri.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LittriVO req = null;
        File file = Paths.get(testJsonDir, "littri").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittriVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittriVO> response = littri.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LittriVO req = null;
        File file = Paths.get(testJsonDir, "littri").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittriVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittriVO> response = littri.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LittriVO req = null;
        File file = Paths.get(testJsonDir, "littri").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittriVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittriVO> response = littri.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LittriVO req = new LittriVO();
        // 参数设置
        ResponseSet<LittriVO> response = littri.executeDefault(req,rule);
    }

}
