package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LittrsService;
import com.ceb.gjjs.mda.vo.LittrsVO;

public class LittrsServiceTest extends BaseTest{

    @Autowired
    private LittrsService littrs;

    @Test
    public void initTest() throws IOException {
        LittrsVO req = null;
        File file = Paths.get(testJsonDir, "littrs").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrsVO> response = littrs.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LittrsVO req = null;
        File file = Paths.get(testJsonDir, "littrs").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrsVO> response = littrs.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LittrsVO req = null;
        File file = Paths.get(testJsonDir, "littrs").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrsVO> response = littrs.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LittrsVO req = null;
        File file = Paths.get(testJsonDir, "littrs").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrsVO> response = littrs.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LittrsVO req = new LittrsVO();
        // 参数设置
        ResponseSet<LittrsVO> response = littrs.executeDefault(req,rule);
    }

}
