package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LittrtService;
import com.ceb.gjjs.mda.vo.LittrtVO;

public class LittrtServiceTest extends BaseTest{

    @Autowired
    private LittrtService littrt;

    @Test
    public void initTest() throws IOException {
        LittrtVO req = null;
        File file = Paths.get(testJsonDir, "littrt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrtVO> response = littrt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LittrtVO req = null;
        File file = Paths.get(testJsonDir, "littrt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrtVO> response = littrt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LittrtVO req = null;
        File file = Paths.get(testJsonDir, "littrt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrtVO> response = littrt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LittrtVO req = null;
        File file = Paths.get(testJsonDir, "littrt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LittrtVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LittrtVO> response = littrt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LittrtVO req = new LittrtVO();
        // 参数设置
        ResponseSet<LittrtVO> response = littrt.executeDefault(req,rule);
    }

}
