package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LoddspService;
import com.ceb.gjjs.mda.vo.LoddspVO;

public class LoddspServiceTest extends BaseTest{

    @Autowired
    private LoddspService loddsp;

    @Test
    public void initTest() throws IOException {
        LoddspVO req = null;
        File file = Paths.get(testJsonDir, "loddsp").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LoddspVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LoddspVO> response = loddsp.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LoddspVO req = null;
        File file = Paths.get(testJsonDir, "loddsp").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LoddspVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LoddspVO> response = loddsp.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LoddspVO req = null;
        File file = Paths.get(testJsonDir, "loddsp").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LoddspVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LoddspVO> response = loddsp.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LoddspVO req = null;
        File file = Paths.get(testJsonDir, "loddsp").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LoddspVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LoddspVO> response = loddsp.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LoddspVO req = new LoddspVO();
        // 参数设置
        ResponseSet<LoddspVO> response = loddsp.executeDefault(req,rule);
    }

}
