package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LttdavService;
import com.ceb.gjjs.mda.vo.LttdavVO;

public class LttdavServiceTest extends BaseTest{

    @Autowired
    private LttdavService lttdav;

    @Test
    public void initTest() throws IOException {
        LttdavVO req = null;
        File file = Paths.get(testJsonDir, "lttdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttdavVO> response = lttdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LttdavVO req = null;
        File file = Paths.get(testJsonDir, "lttdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttdavVO> response = lttdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LttdavVO req = null;
        File file = Paths.get(testJsonDir, "lttdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttdavVO> response = lttdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LttdavVO req = null;
        File file = Paths.get(testJsonDir, "lttdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttdavVO> response = lttdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LttdavVO req = new LttdavVO();
        // 参数设置
        ResponseSet<LttdavVO> response = lttdav.executeDefault(req,rule);
    }

}
