package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Lttopn0Service;
import com.ceb.gjjs.mda.vo.Lttopn0VO;

public class Lttopn0ServiceTest extends BaseTest{

    @Autowired
    private Lttopn0Service lttopn0;

    @Test
    public void initTest() throws IOException {
        Lttopn0VO req = null;
        File file = Paths.get(testJsonDir, "lttopn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Lttopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Lttopn0VO> response = lttopn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Lttopn0VO req = null;
        File file = Paths.get(testJsonDir, "lttopn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Lttopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Lttopn0VO> response = lttopn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Lttopn0VO req = null;
        File file = Paths.get(testJsonDir, "lttopn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Lttopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Lttopn0VO> response = lttopn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Lttopn0VO req = null;
        File file = Paths.get(testJsonDir, "lttopn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Lttopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Lttopn0VO> response = lttopn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Lttopn0VO req = new Lttopn0VO();
        // 参数设置
        ResponseSet<Lttopn0VO> response = lttopn0.executeDefault(req,rule);
    }

}
