package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LttopnService;
import com.ceb.gjjs.mda.vo.LttopnVO;

public class LttopnServiceTest extends BaseTest{

    @Autowired
    private LttopnService lttopn;

    @Test
    public void initTest() throws IOException {
        LttopnVO req = null;
        File file = Paths.get(testJsonDir, "lttopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttopnVO> response = lttopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LttopnVO req = null;
        File file = Paths.get(testJsonDir, "lttopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttopnVO> response = lttopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LttopnVO req = null;
        File file = Paths.get(testJsonDir, "lttopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttopnVO> response = lttopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LttopnVO req = null;
        File file = Paths.get(testJsonDir, "lttopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LttopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LttopnVO> response = lttopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LttopnVO req = new LttopnVO();
        // 参数设置
        ResponseSet<LttopnVO> response = lttopn.executeDefault(req,rule);
    }

}
