package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LxtcfmService;
import com.ceb.gjjs.mda.vo.LxtcfmVO;

public class LxtcfmServiceTest extends BaseTest{

    @Autowired
    private LxtcfmService lxtcfm;

    @Test
    public void initTest() throws IOException {
        LxtcfmVO req = null;
        File file = Paths.get(testJsonDir, "lxtcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtcfmVO> response = lxtcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LxtcfmVO req = null;
        File file = Paths.get(testJsonDir, "lxtcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtcfmVO> response = lxtcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LxtcfmVO req = null;
        File file = Paths.get(testJsonDir, "lxtcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtcfmVO> response = lxtcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LxtcfmVO req = null;
        File file = Paths.get(testJsonDir, "lxtcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtcfmVO> response = lxtcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LxtcfmVO req = new LxtcfmVO();
        // 参数设置
        ResponseSet<LxtcfmVO> response = lxtcfm.executeDefault(req,rule);
    }

}
