package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.LxtdavService;
import com.ceb.gjjs.mda.vo.LxtdavVO;

public class LxtdavServiceTest extends BaseTest{

    @Autowired
    private LxtdavService lxtdav;

    @Test
    public void initTest() throws IOException {
        LxtdavVO req = null;
        File file = Paths.get(testJsonDir, "lxtdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtdavVO> response = lxtdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        LxtdavVO req = null;
        File file = Paths.get(testJsonDir, "lxtdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtdavVO> response = lxtdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        LxtdavVO req = null;
        File file = Paths.get(testJsonDir, "lxtdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtdavVO> response = lxtdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        LxtdavVO req = null;
        File file = Paths.get(testJsonDir, "lxtdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<LxtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<LxtdavVO> response = lxtdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        LxtdavVO req = new LxtdavVO();
        // 参数设置
        ResponseSet<LxtdavVO> response = lxtdav.executeDefault(req,rule);
    }

}
