package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MakdocService;
import com.ceb.gjjs.mda.vo.MakdocVO;

public class MakdocServiceTest extends BaseTest{

    @Autowired
    private MakdocService makdoc;

    @Test
    public void initTest() throws IOException {
        MakdocVO req = null;
        File file = Paths.get(testJsonDir, "makdoc").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakdocVO> response = makdoc.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MakdocVO req = null;
        File file = Paths.get(testJsonDir, "makdoc").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakdocVO> response = makdoc.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MakdocVO req = null;
        File file = Paths.get(testJsonDir, "makdoc").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakdocVO> response = makdoc.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MakdocVO req = null;
        File file = Paths.get(testJsonDir, "makdoc").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakdocVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakdocVO> response = makdoc.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MakdocVO req = new MakdocVO();
        // 参数设置
        ResponseSet<MakdocVO> response = makdoc.executeDefault(req,rule);
    }

}
