package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MakmodService;
import com.ceb.gjjs.mda.vo.MakmodVO;

public class MakmodServiceTest extends BaseTest{

    @Autowired
    private MakmodService makmod;

    @Test
    public void initTest() throws IOException {
        MakmodVO req = null;
        File file = Paths.get(testJsonDir, "makmod").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakmodVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakmodVO> response = makmod.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MakmodVO req = null;
        File file = Paths.get(testJsonDir, "makmod").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakmodVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakmodVO> response = makmod.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MakmodVO req = null;
        File file = Paths.get(testJsonDir, "makmod").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakmodVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakmodVO> response = makmod.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MakmodVO req = null;
        File file = Paths.get(testJsonDir, "makmod").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MakmodVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MakmodVO> response = makmod.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MakmodVO req = new MakmodVO();
        // 参数设置
        ResponseSet<MakmodVO> response = makmod.executeDefault(req,rule);
    }

}
