package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MarcfmService;
import com.ceb.gjjs.mda.vo.MarcfmVO;

public class MarcfmServiceTest extends BaseTest{

    @Autowired
    private MarcfmService marcfm;

    @Test
    public void initTest() throws IOException {
        MarcfmVO req = null;
        File file = Paths.get(testJsonDir, "marcfm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarcfmVO> response = marcfm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MarcfmVO req = null;
        File file = Paths.get(testJsonDir, "marcfm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarcfmVO> response = marcfm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MarcfmVO req = null;
        File file = Paths.get(testJsonDir, "marcfm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarcfmVO> response = marcfm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MarcfmVO req = null;
        File file = Paths.get(testJsonDir, "marcfm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarcfmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarcfmVO> response = marcfm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MarcfmVO req = new MarcfmVO();
        // 参数设置
        ResponseSet<MarcfmVO> response = marcfm.executeDefault(req,rule);
    }

}
