package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MardavService;
import com.ceb.gjjs.mda.vo.MardavVO;

public class MardavServiceTest extends BaseTest{

    @Autowired
    private MardavService mardav;

    @Test
    public void initTest() throws IOException {
        MardavVO req = null;
        File file = Paths.get(testJsonDir, "mardav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MardavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MardavVO> response = mardav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MardavVO req = null;
        File file = Paths.get(testJsonDir, "mardav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MardavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MardavVO> response = mardav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MardavVO req = null;
        File file = Paths.get(testJsonDir, "mardav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MardavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MardavVO> response = mardav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MardavVO req = null;
        File file = Paths.get(testJsonDir, "mardav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MardavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MardavVO> response = mardav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MardavVO req = new MardavVO();
        // 参数设置
        ResponseSet<MardavVO> response = mardav.executeDefault(req,rule);
    }

}
