package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MarmdlService;
import com.ceb.gjjs.mda.vo.MarmdlVO;

public class MarmdlServiceTest extends BaseTest{

    @Autowired
    private MarmdlService marmdl;

    @Test
    public void initTest() throws IOException {
        MarmdlVO req = null;
        File file = Paths.get(testJsonDir, "marmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarmdlVO> response = marmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MarmdlVO req = null;
        File file = Paths.get(testJsonDir, "marmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarmdlVO> response = marmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MarmdlVO req = null;
        File file = Paths.get(testJsonDir, "marmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarmdlVO> response = marmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MarmdlVO req = null;
        File file = Paths.get(testJsonDir, "marmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MarmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MarmdlVO> response = marmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MarmdlVO req = new MarmdlVO();
        // 参数设置
        ResponseSet<MarmdlVO> response = marmdl.executeDefault(req,rule);
    }

}
