package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Maropn0Service;
import com.ceb.gjjs.mda.vo.Maropn0VO;

public class Maropn0ServiceTest extends BaseTest{

    @Autowired
    private Maropn0Service maropn0;

    @Test
    public void initTest() throws IOException {
        Maropn0VO req = null;
        File file = Paths.get(testJsonDir, "maropn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Maropn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Maropn0VO> response = maropn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Maropn0VO req = null;
        File file = Paths.get(testJsonDir, "maropn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Maropn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Maropn0VO> response = maropn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Maropn0VO req = null;
        File file = Paths.get(testJsonDir, "maropn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Maropn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Maropn0VO> response = maropn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Maropn0VO req = null;
        File file = Paths.get(testJsonDir, "maropn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Maropn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Maropn0VO> response = maropn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Maropn0VO req = new Maropn0VO();
        // 参数设置
        ResponseSet<Maropn0VO> response = maropn0.executeDefault(req,rule);
    }

}
