package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MaropnService;
import com.ceb.gjjs.mda.vo.MaropnVO;

public class MaropnServiceTest extends BaseTest{

    @Autowired
    private MaropnService maropn;

    @Test
    public void initTest() throws IOException {
        MaropnVO req = null;
        File file = Paths.get(testJsonDir, "maropn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MaropnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MaropnVO> response = maropn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MaropnVO req = null;
        File file = Paths.get(testJsonDir, "maropn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MaropnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MaropnVO> response = maropn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MaropnVO req = null;
        File file = Paths.get(testJsonDir, "maropn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MaropnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MaropnVO> response = maropn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MaropnVO req = null;
        File file = Paths.get(testJsonDir, "maropn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MaropnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MaropnVO> response = maropn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MaropnVO req = new MaropnVO();
        // 参数设置
        ResponseSet<MaropnVO> response = maropn.executeDefault(req,rule);
    }

}
