package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MatchkService;
import com.ceb.gjjs.mda.vo.MatchkVO;

public class MatchkServiceTest extends BaseTest{

    @Autowired
    private MatchkService matchk;

    @Test
    public void initTest() throws IOException {
        MatchkVO req = null;
        File file = Paths.get(testJsonDir, "matchk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatchkVO> response = matchk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MatchkVO req = null;
        File file = Paths.get(testJsonDir, "matchk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatchkVO> response = matchk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MatchkVO req = null;
        File file = Paths.get(testJsonDir, "matchk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatchkVO> response = matchk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MatchkVO req = null;
        File file = Paths.get(testJsonDir, "matchk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatchkVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatchkVO> response = matchk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MatchkVO req = new MatchkVO();
        // 参数设置
        ResponseSet<MatchkVO> response = matchk.executeDefault(req,rule);
    }

}
