package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MatmdlService;
import com.ceb.gjjs.mda.vo.MatmdlVO;

public class MatmdlServiceTest extends BaseTest{

    @Autowired
    private MatmdlService matmdl;

    @Test
    public void initTest() throws IOException {
        MatmdlVO req = null;
        File file = Paths.get(testJsonDir, "matmdl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatmdlVO> response = matmdl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MatmdlVO req = null;
        File file = Paths.get(testJsonDir, "matmdl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatmdlVO> response = matmdl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MatmdlVO req = null;
        File file = Paths.get(testJsonDir, "matmdl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatmdlVO> response = matmdl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MatmdlVO req = null;
        File file = Paths.get(testJsonDir, "matmdl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MatmdlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MatmdlVO> response = matmdl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MatmdlVO req = new MatmdlVO();
        // 参数设置
        ResponseSet<MatmdlVO> response = matmdl.executeDefault(req,rule);
    }

}
