package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MgrtskService;
import com.ceb.gjjs.mda.vo.MgrtskVO;

public class MgrtskServiceTest extends BaseTest{

    @Autowired
    private MgrtskService mgrtsk;

    @Test
    public void initTest() throws IOException {
        MgrtskVO req = null;
        File file = Paths.get(testJsonDir, "mgrtsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgrtskVO> response = mgrtsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MgrtskVO req = null;
        File file = Paths.get(testJsonDir, "mgrtsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgrtskVO> response = mgrtsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MgrtskVO req = null;
        File file = Paths.get(testJsonDir, "mgrtsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgrtskVO> response = mgrtsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MgrtskVO req = null;
        File file = Paths.get(testJsonDir, "mgrtsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgrtskVO> response = mgrtsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MgrtskVO req = new MgrtskVO();
        // 参数设置
        ResponseSet<MgrtskVO> response = mgrtsk.executeDefault(req,rule);
    }

}
