package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.MgwtskService;
import com.ceb.gjjs.mda.vo.MgwtskVO;

public class MgwtskServiceTest extends BaseTest{

    @Autowired
    private MgwtskService mgwtsk;

    @Test
    public void initTest() throws IOException {
        MgwtskVO req = null;
        File file = Paths.get(testJsonDir, "mgwtsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgwtskVO> response = mgwtsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        MgwtskVO req = null;
        File file = Paths.get(testJsonDir, "mgwtsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgwtskVO> response = mgwtsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        MgwtskVO req = null;
        File file = Paths.get(testJsonDir, "mgwtsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgwtskVO> response = mgwtsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        MgwtskVO req = null;
        File file = Paths.get(testJsonDir, "mgwtsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<MgwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<MgwtskVO> response = mgwtsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        MgwtskVO req = new MgwtskVO();
        // 参数设置
        ResponseSet<MgwtskVO> response = mgwtsk.executeDefault(req,rule);
    }

}
