package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.QueusrService;
import com.ceb.gjjs.mda.vo.QueusrVO;

public class QueusrServiceTest extends BaseTest{

    @Autowired
    private QueusrService queusr;

    @Test
    public void initTest() throws IOException {
        QueusrVO req = null;
        File file = Paths.get(testJsonDir, "queusr").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QueusrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QueusrVO> response = queusr.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        QueusrVO req = null;
        File file = Paths.get(testJsonDir, "queusr").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QueusrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QueusrVO> response = queusr.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        QueusrVO req = null;
        File file = Paths.get(testJsonDir, "queusr").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QueusrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QueusrVO> response = queusr.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        QueusrVO req = null;
        File file = Paths.get(testJsonDir, "queusr").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QueusrVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QueusrVO> response = queusr.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        QueusrVO req = new QueusrVO();
        // 参数设置
        ResponseSet<QueusrVO> response = queusr.executeDefault(req,rule);
    }

}
