package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.QuevlmService;
import com.ceb.gjjs.mda.vo.QuevlmVO;

public class QuevlmServiceTest extends BaseTest{

    @Autowired
    private QuevlmService quevlm;

    @Test
    public void initTest() throws IOException {
        QuevlmVO req = null;
        File file = Paths.get(testJsonDir, "quevlm").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QuevlmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QuevlmVO> response = quevlm.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        QuevlmVO req = null;
        File file = Paths.get(testJsonDir, "quevlm").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QuevlmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QuevlmVO> response = quevlm.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        QuevlmVO req = null;
        File file = Paths.get(testJsonDir, "quevlm").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QuevlmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QuevlmVO> response = quevlm.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        QuevlmVO req = null;
        File file = Paths.get(testJsonDir, "quevlm").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<QuevlmVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<QuevlmVO> response = quevlm.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        QuevlmVO req = new QuevlmVO();
        // 参数设置
        ResponseSet<QuevlmVO> response = quevlm.executeDefault(req,rule);
    }

}
