package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.RptopnService;
import com.ceb.gjjs.mda.vo.RptopnVO;

public class RptopnServiceTest extends BaseTest{

    @Autowired
    private RptopnService rptopn;

    @Test
    public void initTest() throws IOException {
        RptopnVO req = null;
        File file = Paths.get(testJsonDir, "rptopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptopnVO> response = rptopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        RptopnVO req = null;
        File file = Paths.get(testJsonDir, "rptopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptopnVO> response = rptopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        RptopnVO req = null;
        File file = Paths.get(testJsonDir, "rptopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptopnVO> response = rptopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        RptopnVO req = null;
        File file = Paths.get(testJsonDir, "rptopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptopnVO> response = rptopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        RptopnVO req = new RptopnVO();
        // 参数设置
        ResponseSet<RptopnVO> response = rptopn.executeDefault(req,rule);
    }

}
