package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.RptqurService;
import com.ceb.gjjs.mda.vo.RptqurVO;

public class RptqurServiceTest extends BaseTest{

    @Autowired
    private RptqurService rptqur;

    @Test
    public void initTest() throws IOException {
        RptqurVO req = null;
        File file = Paths.get(testJsonDir, "rptqur").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptqurVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptqurVO> response = rptqur.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        RptqurVO req = null;
        File file = Paths.get(testJsonDir, "rptqur").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptqurVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptqurVO> response = rptqur.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        RptqurVO req = null;
        File file = Paths.get(testJsonDir, "rptqur").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptqurVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptqurVO> response = rptqur.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        RptqurVO req = null;
        File file = Paths.get(testJsonDir, "rptqur").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptqurVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptqurVO> response = rptqur.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        RptqurVO req = new RptqurVO();
        // 参数设置
        ResponseSet<RptqurVO> response = rptqur.executeDefault(req,rule);
    }

}
