package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.RptshwService;
import com.ceb.gjjs.mda.vo.RptshwVO;

public class RptshwServiceTest extends BaseTest{

    @Autowired
    private RptshwService rptshw;

    @Test
    public void initTest() throws IOException {
        RptshwVO req = null;
        File file = Paths.get(testJsonDir, "rptshw").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptshwVO> response = rptshw.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        RptshwVO req = null;
        File file = Paths.get(testJsonDir, "rptshw").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptshwVO> response = rptshw.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        RptshwVO req = null;
        File file = Paths.get(testJsonDir, "rptshw").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptshwVO> response = rptshw.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        RptshwVO req = null;
        File file = Paths.get(testJsonDir, "rptshw").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<RptshwVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<RptshwVO> response = rptshw.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        RptshwVO req = new RptshwVO();
        // 参数设置
        ResponseSet<RptshwVO> response = rptshw.executeDefault(req,rule);
    }

}
