package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SgtcanService;
import com.ceb.gjjs.mda.vo.SgtcanVO;

public class SgtcanServiceTest extends BaseTest{

    @Autowired
    private SgtcanService sgtcan;

    @Test
    public void initTest() throws IOException {
        SgtcanVO req = null;
        File file = Paths.get(testJsonDir, "sgtcan").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtcanVO> response = sgtcan.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SgtcanVO req = null;
        File file = Paths.get(testJsonDir, "sgtcan").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtcanVO> response = sgtcan.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SgtcanVO req = null;
        File file = Paths.get(testJsonDir, "sgtcan").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtcanVO> response = sgtcan.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SgtcanVO req = null;
        File file = Paths.get(testJsonDir, "sgtcan").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtcanVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtcanVO> response = sgtcan.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SgtcanVO req = new SgtcanVO();
        // 参数设置
        ResponseSet<SgtcanVO> response = sgtcan.executeDefault(req,rule);
    }

}
