package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SgtdavService;
import com.ceb.gjjs.mda.vo.SgtdavVO;

public class SgtdavServiceTest extends BaseTest{

    @Autowired
    private SgtdavService sgtdav;

    @Test
    public void initTest() throws IOException {
        SgtdavVO req = null;
        File file = Paths.get(testJsonDir, "sgtdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtdavVO> response = sgtdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SgtdavVO req = null;
        File file = Paths.get(testJsonDir, "sgtdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtdavVO> response = sgtdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SgtdavVO req = null;
        File file = Paths.get(testJsonDir, "sgtdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtdavVO> response = sgtdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SgtdavVO req = null;
        File file = Paths.get(testJsonDir, "sgtdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SgtdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SgtdavVO> response = sgtdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SgtdavVO req = new SgtdavVO();
        // 参数设置
        ResponseSet<SgtdavVO> response = sgtdav.executeDefault(req,rule);
    }

}
