package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Sgtopn0Service;
import com.ceb.gjjs.mda.vo.Sgtopn0VO;

public class Sgtopn0ServiceTest extends BaseTest{

    @Autowired
    private Sgtopn0Service sgtopn0;

    @Test
    public void initTest() throws IOException {
        Sgtopn0VO req = null;
        File file = Paths.get(testJsonDir, "sgtopn0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sgtopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sgtopn0VO> response = sgtopn0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Sgtopn0VO req = null;
        File file = Paths.get(testJsonDir, "sgtopn0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sgtopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sgtopn0VO> response = sgtopn0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Sgtopn0VO req = null;
        File file = Paths.get(testJsonDir, "sgtopn0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sgtopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sgtopn0VO> response = sgtopn0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Sgtopn0VO req = null;
        File file = Paths.get(testJsonDir, "sgtopn0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sgtopn0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sgtopn0VO> response = sgtopn0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Sgtopn0VO req = new Sgtopn0VO();
        // 参数设置
        ResponseSet<Sgtopn0VO> response = sgtopn0.executeDefault(req,rule);
    }

}
