package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.ShrtskService;
import com.ceb.gjjs.mda.vo.ShrtskVO;

public class ShrtskServiceTest extends BaseTest{

    @Autowired
    private ShrtskService shrtsk;

    @Test
    public void initTest() throws IOException {
        ShrtskVO req = null;
        File file = Paths.get(testJsonDir, "shrtsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ShrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ShrtskVO> response = shrtsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        ShrtskVO req = null;
        File file = Paths.get(testJsonDir, "shrtsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ShrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ShrtskVO> response = shrtsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        ShrtskVO req = null;
        File file = Paths.get(testJsonDir, "shrtsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ShrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ShrtskVO> response = shrtsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        ShrtskVO req = null;
        File file = Paths.get(testJsonDir, "shrtsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<ShrtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<ShrtskVO> response = shrtsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        ShrtskVO req = new ShrtskVO();
        // 参数设置
        ResponseSet<ShrtskVO> response = shrtsk.executeDefault(req,rule);
    }

}
