package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SwitskService;
import com.ceb.gjjs.mda.vo.SwitskVO;

public class SwitskServiceTest extends BaseTest{

    @Autowired
    private SwitskService switsk;

    @Test
    public void initTest() throws IOException {
        SwitskVO req = null;
        File file = Paths.get(testJsonDir, "switsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwitskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwitskVO> response = switsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SwitskVO req = null;
        File file = Paths.get(testJsonDir, "switsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwitskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwitskVO> response = switsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SwitskVO req = null;
        File file = Paths.get(testJsonDir, "switsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwitskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwitskVO> response = switsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SwitskVO req = null;
        File file = Paths.get(testJsonDir, "switsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwitskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwitskVO> response = switsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SwitskVO req = new SwitskVO();
        // 参数设置
        ResponseSet<SwitskVO> response = switsk.executeDefault(req,rule);
    }

}
