package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SwmctlService;
import com.ceb.gjjs.mda.vo.SwmctlVO;

public class SwmctlServiceTest extends BaseTest{

    @Autowired
    private SwmctlService swmctl;

    @Test
    public void initTest() throws IOException {
        SwmctlVO req = null;
        File file = Paths.get(testJsonDir, "swmctl").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwmctlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwmctlVO> response = swmctl.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SwmctlVO req = null;
        File file = Paths.get(testJsonDir, "swmctl").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwmctlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwmctlVO> response = swmctl.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SwmctlVO req = null;
        File file = Paths.get(testJsonDir, "swmctl").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwmctlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwmctlVO> response = swmctl.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SwmctlVO req = null;
        File file = Paths.get(testJsonDir, "swmctl").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwmctlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwmctlVO> response = swmctl.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SwmctlVO req = new SwmctlVO();
        // 参数设置
        ResponseSet<SwmctlVO> response = swmctl.executeDefault(req,rule);
    }

}
