package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SwwtskService;
import com.ceb.gjjs.mda.vo.SwwtskVO;

public class SwwtskServiceTest extends BaseTest{

    @Autowired
    private SwwtskService swwtsk;

    @Test
    public void initTest() throws IOException {
        SwwtskVO req = null;
        File file = Paths.get(testJsonDir, "swwtsk").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwwtskVO> response = swwtsk.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SwwtskVO req = null;
        File file = Paths.get(testJsonDir, "swwtsk").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwwtskVO> response = swwtsk.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SwwtskVO req = null;
        File file = Paths.get(testJsonDir, "swwtsk").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwwtskVO> response = swwtsk.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SwwtskVO req = null;
        File file = Paths.get(testJsonDir, "swwtsk").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SwwtskVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SwwtskVO> response = swwtsk.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SwwtskVO req = new SwwtskVO();
        // 参数设置
        ResponseSet<SwwtskVO> response = swwtsk.executeDefault(req,rule);
    }

}
