package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.Sysaut0Service;
import com.ceb.gjjs.mda.vo.Sysaut0VO;

public class Sysaut0ServiceTest extends BaseTest{

    @Autowired
    private Sysaut0Service sysaut0;

    @Test
    public void initTest() throws IOException {
        Sysaut0VO req = null;
        File file = Paths.get(testJsonDir, "sysaut0").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sysaut0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sysaut0VO> response = sysaut0.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        Sysaut0VO req = null;
        File file = Paths.get(testJsonDir, "sysaut0").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sysaut0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sysaut0VO> response = sysaut0.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        Sysaut0VO req = null;
        File file = Paths.get(testJsonDir, "sysaut0").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sysaut0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sysaut0VO> response = sysaut0.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        Sysaut0VO req = null;
        File file = Paths.get(testJsonDir, "sysaut0").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<Sysaut0VO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<Sysaut0VO> response = sysaut0.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        Sysaut0VO req = new Sysaut0VO();
        // 参数设置
        ResponseSet<Sysaut0VO> response = sysaut0.executeDefault(req,rule);
    }

}
