package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SysautService;
import com.ceb.gjjs.mda.vo.SysautVO;

public class SysautServiceTest extends BaseTest{

    @Autowired
    private SysautService sysaut;

    @Test
    public void initTest() throws IOException {
        SysautVO req = null;
        File file = Paths.get(testJsonDir, "sysaut").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysautVO> response = sysaut.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SysautVO req = null;
        File file = Paths.get(testJsonDir, "sysaut").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysautVO> response = sysaut.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SysautVO req = null;
        File file = Paths.get(testJsonDir, "sysaut").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysautVO> response = sysaut.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SysautVO req = null;
        File file = Paths.get(testJsonDir, "sysaut").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysautVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysautVO> response = sysaut.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SysautVO req = new SysautVO();
        // 参数设置
        ResponseSet<SysautVO> response = sysaut.executeDefault(req,rule);
    }

}
