package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SysixuService;
import com.ceb.gjjs.mda.vo.SysixuVO;

public class SysixuServiceTest extends BaseTest{

    @Autowired
    private SysixuService sysixu;

    @Test
    public void initTest() throws IOException {
        SysixuVO req = null;
        File file = Paths.get(testJsonDir, "sysixu").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysixuVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysixuVO> response = sysixu.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SysixuVO req = null;
        File file = Paths.get(testJsonDir, "sysixu").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysixuVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysixuVO> response = sysixu.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SysixuVO req = null;
        File file = Paths.get(testJsonDir, "sysixu").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysixuVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysixuVO> response = sysixu.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SysixuVO req = null;
        File file = Paths.get(testJsonDir, "sysixu").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SysixuVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SysixuVO> response = sysixu.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SysixuVO req = new SysixuVO();
        // 参数设置
        ResponseSet<SysixuVO> response = sysixu.executeDefault(req,rule);
    }

}
