package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.SyssqlService;
import com.ceb.gjjs.mda.vo.SyssqlVO;

public class SyssqlServiceTest extends BaseTest{

    @Autowired
    private SyssqlService syssql;

    @Test
    public void initTest() throws IOException {
        SyssqlVO req = null;
        File file = Paths.get(testJsonDir, "syssql").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SyssqlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SyssqlVO> response = syssql.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        SyssqlVO req = null;
        File file = Paths.get(testJsonDir, "syssql").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SyssqlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SyssqlVO> response = syssql.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        SyssqlVO req = null;
        File file = Paths.get(testJsonDir, "syssql").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SyssqlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SyssqlVO> response = syssql.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        SyssqlVO req = null;
        File file = Paths.get(testJsonDir, "syssql").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<SyssqlVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<SyssqlVO> response = syssql.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        SyssqlVO req = new SyssqlVO();
        // 参数设置
        ResponseSet<SyssqlVO> response = syssql.executeDefault(req,rule);
    }

}
