package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.TatopnService;
import com.ceb.gjjs.mda.vo.TatopnVO;

public class TatopnServiceTest extends BaseTest{

    @Autowired
    private TatopnService tatopn;

    @Test
    public void initTest() throws IOException {
        TatopnVO req = null;
        File file = Paths.get(testJsonDir, "tatopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TatopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TatopnVO> response = tatopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        TatopnVO req = null;
        File file = Paths.get(testJsonDir, "tatopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TatopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TatopnVO> response = tatopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        TatopnVO req = null;
        File file = Paths.get(testJsonDir, "tatopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TatopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TatopnVO> response = tatopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        TatopnVO req = null;
        File file = Paths.get(testJsonDir, "tatopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TatopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TatopnVO> response = tatopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        TatopnVO req = new TatopnVO();
        // 参数设置
        ResponseSet<TatopnVO> response = tatopn.executeDefault(req,rule);
    }

}
