package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.TrntstService;
import com.ceb.gjjs.mda.vo.TrntstVO;

public class TrntstServiceTest extends BaseTest{

    @Autowired
    private TrntstService trntst;

    @Test
    public void initTest() throws IOException {
        TrntstVO req = null;
        File file = Paths.get(testJsonDir, "trntst").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrntstVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrntstVO> response = trntst.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        TrntstVO req = null;
        File file = Paths.get(testJsonDir, "trntst").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrntstVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrntstVO> response = trntst.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        TrntstVO req = null;
        File file = Paths.get(testJsonDir, "trntst").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrntstVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrntstVO> response = trntst.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        TrntstVO req = null;
        File file = Paths.get(testJsonDir, "trntst").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrntstVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrntstVO> response = trntst.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        TrntstVO req = new TrntstVO();
        // 参数设置
        ResponseSet<TrntstVO> response = trntst.executeDefault(req,rule);
    }

}
