package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.TrsadvService;
import com.ceb.gjjs.mda.vo.TrsadvVO;

public class TrsadvServiceTest extends BaseTest{

    @Autowired
    private TrsadvService trsadv;

    @Test
    public void initTest() throws IOException {
        TrsadvVO req = null;
        File file = Paths.get(testJsonDir, "trsadv").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrsadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrsadvVO> response = trsadv.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        TrsadvVO req = null;
        File file = Paths.get(testJsonDir, "trsadv").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrsadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrsadvVO> response = trsadv.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        TrsadvVO req = null;
        File file = Paths.get(testJsonDir, "trsadv").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrsadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrsadvVO> response = trsadv.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        TrsadvVO req = null;
        File file = Paths.get(testJsonDir, "trsadv").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<TrsadvVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<TrsadvVO> response = trsadv.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        TrsadvVO req = new TrsadvVO();
        // 参数设置
        ResponseSet<TrsadvVO> response = trsadv.executeDefault(req,rule);
    }

}
