package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.WfddefService;
import com.ceb.gjjs.mda.vo.WfddefVO;

public class WfddefServiceTest extends BaseTest{

    @Autowired
    private WfddefService wfddef;

    @Test
    public void initTest() throws IOException {
        WfddefVO req = null;
        File file = Paths.get(testJsonDir, "wfddef").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WfddefVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WfddefVO> response = wfddef.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        WfddefVO req = null;
        File file = Paths.get(testJsonDir, "wfddef").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WfddefVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WfddefVO> response = wfddef.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        WfddefVO req = null;
        File file = Paths.get(testJsonDir, "wfddef").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WfddefVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WfddefVO> response = wfddef.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        WfddefVO req = null;
        File file = Paths.get(testJsonDir, "wfddef").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WfddefVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WfddefVO> response = wfddef.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        WfddefVO req = new WfddefVO();
        // 参数设置
        ResponseSet<WfddefVO> response = wfddef.executeDefault(req,rule);
    }

}
