package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.WitameService;
import com.ceb.gjjs.mda.vo.WitameVO;

public class WitameServiceTest extends BaseTest{

    @Autowired
    private WitameService witame;

    @Test
    public void initTest() throws IOException {
        WitameVO req = null;
        File file = Paths.get(testJsonDir, "witame").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitameVO> response = witame.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        WitameVO req = null;
        File file = Paths.get(testJsonDir, "witame").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitameVO> response = witame.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        WitameVO req = null;
        File file = Paths.get(testJsonDir, "witame").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitameVO> response = witame.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        WitameVO req = null;
        File file = Paths.get(testJsonDir, "witame").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitameVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitameVO> response = witame.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        WitameVO req = new WitameVO();
        // 参数设置
        ResponseSet<WitameVO> response = witame.executeDefault(req,rule);
    }

}
