package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.WitdavService;
import com.ceb.gjjs.mda.vo.WitdavVO;

public class WitdavServiceTest extends BaseTest{

    @Autowired
    private WitdavService witdav;

    @Test
    public void initTest() throws IOException {
        WitdavVO req = null;
        File file = Paths.get(testJsonDir, "witdav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitdavVO> response = witdav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        WitdavVO req = null;
        File file = Paths.get(testJsonDir, "witdav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitdavVO> response = witdav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        WitdavVO req = null;
        File file = Paths.get(testJsonDir, "witdav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitdavVO> response = witdav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        WitdavVO req = null;
        File file = Paths.get(testJsonDir, "witdav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitdavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitdavVO> response = witdav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        WitdavVO req = new WitdavVO();
        // 参数设置
        ResponseSet<WitdavVO> response = witdav.executeDefault(req,rule);
    }

}
