package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.WitmavService;
import com.ceb.gjjs.mda.vo.WitmavVO;

public class WitmavServiceTest extends BaseTest{

    @Autowired
    private WitmavService witmav;

    @Test
    public void initTest() throws IOException {
        WitmavVO req = null;
        File file = Paths.get(testJsonDir, "witmav").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitmavVO> response = witmav.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        WitmavVO req = null;
        File file = Paths.get(testJsonDir, "witmav").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitmavVO> response = witmav.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        WitmavVO req = null;
        File file = Paths.get(testJsonDir, "witmav").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitmavVO> response = witmav.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        WitmavVO req = null;
        File file = Paths.get(testJsonDir, "witmav").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitmavVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitmavVO> response = witmav.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        WitmavVO req = new WitmavVO();
        // 参数设置
        ResponseSet<WitmavVO> response = witmav.executeDefault(req,rule);
    }

}
