package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.WitopnService;
import com.ceb.gjjs.mda.vo.WitopnVO;

public class WitopnServiceTest extends BaseTest{

    @Autowired
    private WitopnService witopn;

    @Test
    public void initTest() throws IOException {
        WitopnVO req = null;
        File file = Paths.get(testJsonDir, "witopn").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitopnVO> response = witopn.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        WitopnVO req = null;
        File file = Paths.get(testJsonDir, "witopn").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitopnVO> response = witopn.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        WitopnVO req = null;
        File file = Paths.get(testJsonDir, "witopn").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitopnVO> response = witopn.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        WitopnVO req = null;
        File file = Paths.get(testJsonDir, "witopn").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<WitopnVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<WitopnVO> response = witopn.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        WitopnVO req = new WitopnVO();
        // 参数设置
        ResponseSet<WitopnVO> response = witopn.executeDefault(req,rule);
    }

}
