package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XpsfaqService;
import com.ceb.gjjs.mda.vo.XpsfaqVO;

public class XpsfaqServiceTest extends BaseTest{

    @Autowired
    private XpsfaqService xpsfaq;

    @Test
    public void initTest() throws IOException {
        XpsfaqVO req = null;
        File file = Paths.get(testJsonDir, "xpsfaq").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpsfaqVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpsfaqVO> response = xpsfaq.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XpsfaqVO req = null;
        File file = Paths.get(testJsonDir, "xpsfaq").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpsfaqVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpsfaqVO> response = xpsfaq.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XpsfaqVO req = null;
        File file = Paths.get(testJsonDir, "xpsfaq").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpsfaqVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpsfaqVO> response = xpsfaq.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XpsfaqVO req = null;
        File file = Paths.get(testJsonDir, "xpsfaq").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpsfaqVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpsfaqVO> response = xpsfaq.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XpsfaqVO req = new XpsfaqVO();
        // 参数设置
        ResponseSet<XpsfaqVO> response = xpsfaq.executeDefault(req,rule);
    }

}
