package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XpssamService;
import com.ceb.gjjs.mda.vo.XpssamVO;

public class XpssamServiceTest extends BaseTest{

    @Autowired
    private XpssamService xpssam;

    @Test
    public void initTest() throws IOException {
        XpssamVO req = null;
        File file = Paths.get(testJsonDir, "xpssam").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpssamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpssamVO> response = xpssam.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XpssamVO req = null;
        File file = Paths.get(testJsonDir, "xpssam").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpssamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpssamVO> response = xpssam.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XpssamVO req = null;
        File file = Paths.get(testJsonDir, "xpssam").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpssamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpssamVO> response = xpssam.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XpssamVO req = null;
        File file = Paths.get(testJsonDir, "xpssam").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpssamVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpssamVO> response = xpssam.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XpssamVO req = new XpssamVO();
        // 参数设置
        ResponseSet<XpssamVO> response = xpssam.executeDefault(req,rule);
    }

}
