package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptansService;
import com.ceb.gjjs.mda.vo.XptansVO;

public class XptansServiceTest extends BaseTest{

    @Autowired
    private XptansService xptans;

    @Test
    public void initTest() throws IOException {
        XptansVO req = null;
        File file = Paths.get(testJsonDir, "xptans").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptansVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptansVO> response = xptans.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptansVO req = null;
        File file = Paths.get(testJsonDir, "xptans").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptansVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptansVO> response = xptans.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptansVO req = null;
        File file = Paths.get(testJsonDir, "xptans").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptansVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptansVO> response = xptans.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptansVO req = null;
        File file = Paths.get(testJsonDir, "xptans").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptansVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptansVO> response = xptans.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptansVO req = new XptansVO();
        // 参数设置
        ResponseSet<XptansVO> response = xptans.executeDefault(req,rule);
    }

}
