package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XpthisService;
import com.ceb.gjjs.mda.vo.XpthisVO;

public class XpthisServiceTest extends BaseTest{

    @Autowired
    private XpthisService xpthis;

    @Test
    public void initTest() throws IOException {
        XpthisVO req = null;
        File file = Paths.get(testJsonDir, "xpthis").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpthisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpthisVO> response = xpthis.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XpthisVO req = null;
        File file = Paths.get(testJsonDir, "xpthis").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpthisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpthisVO> response = xpthis.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XpthisVO req = null;
        File file = Paths.get(testJsonDir, "xpthis").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpthisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpthisVO> response = xpthis.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XpthisVO req = null;
        File file = Paths.get(testJsonDir, "xpthis").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XpthisVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XpthisVO> response = xpthis.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XpthisVO req = new XpthisVO();
        // 参数设置
        ResponseSet<XpthisVO> response = xpthis.executeDefault(req,rule);
    }

}
