package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptinsService;
import com.ceb.gjjs.mda.vo.XptinsVO;

public class XptinsServiceTest extends BaseTest{

    @Autowired
    private XptinsService xptins;

    @Test
    public void initTest() throws IOException {
        XptinsVO req = null;
        File file = Paths.get(testJsonDir, "xptins").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptinsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptinsVO> response = xptins.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptinsVO req = null;
        File file = Paths.get(testJsonDir, "xptins").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptinsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptinsVO> response = xptins.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptinsVO req = null;
        File file = Paths.get(testJsonDir, "xptins").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptinsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptinsVO> response = xptins.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptinsVO req = null;
        File file = Paths.get(testJsonDir, "xptins").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptinsVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptinsVO> response = xptins.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptinsVO req = new XptinsVO();
        // 参数设置
        ResponseSet<XptinsVO> response = xptins.executeDefault(req,rule);
    }

}
