package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptqryService;
import com.ceb.gjjs.mda.vo.XptqryVO;

public class XptqryServiceTest extends BaseTest{

    @Autowired
    private XptqryService xptqry;

    @Test
    public void initTest() throws IOException {
        XptqryVO req = null;
        File file = Paths.get(testJsonDir, "xptqry").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptqryVO> response = xptqry.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptqryVO req = null;
        File file = Paths.get(testJsonDir, "xptqry").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptqryVO> response = xptqry.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptqryVO req = null;
        File file = Paths.get(testJsonDir, "xptqry").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptqryVO> response = xptqry.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptqryVO req = null;
        File file = Paths.get(testJsonDir, "xptqry").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptqryVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptqryVO> response = xptqry.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptqryVO req = new XptqryVO();
        // 参数设置
        ResponseSet<XptqryVO> response = xptqry.executeDefault(req,rule);
    }

}
