package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptrulService;
import com.ceb.gjjs.mda.vo.XptrulVO;

public class XptrulServiceTest extends BaseTest{

    @Autowired
    private XptrulService xptrul;

    @Test
    public void initTest() throws IOException {
        XptrulVO req = null;
        File file = Paths.get(testJsonDir, "xptrul").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptrulVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptrulVO> response = xptrul.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptrulVO req = null;
        File file = Paths.get(testJsonDir, "xptrul").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptrulVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptrulVO> response = xptrul.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptrulVO req = null;
        File file = Paths.get(testJsonDir, "xptrul").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptrulVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptrulVO> response = xptrul.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptrulVO req = null;
        File file = Paths.get(testJsonDir, "xptrul").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptrulVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptrulVO> response = xptrul.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptrulVO req = new XptrulVO();
        // 参数设置
        ResponseSet<XptrulVO> response = xptrul.executeDefault(req,rule);
    }

}
