package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptsltService;
import com.ceb.gjjs.mda.vo.XptsltVO;

public class XptsltServiceTest extends BaseTest{

    @Autowired
    private XptsltService xptslt;

    @Test
    public void initTest() throws IOException {
        XptsltVO req = null;
        File file = Paths.get(testJsonDir, "xptslt").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptsltVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptsltVO> response = xptslt.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptsltVO req = null;
        File file = Paths.get(testJsonDir, "xptslt").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptsltVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptsltVO> response = xptslt.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptsltVO req = null;
        File file = Paths.get(testJsonDir, "xptslt").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptsltVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptsltVO> response = xptslt.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptsltVO req = null;
        File file = Paths.get(testJsonDir, "xptslt").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptsltVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptsltVO> response = xptslt.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptsltVO req = new XptsltVO();
        // 参数设置
        ResponseSet<XptsltVO> response = xptslt.executeDefault(req,rule);
    }

}
