package com.ceb.gjjs.mda.junitTest;

import com.brilliance.mda.runtime.request.RequestSet;
import com.brilliance.mda.runtime.response.ResponseSet;
import com.fasterxml.jackson.core.type.TypeReference;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

import java.io.File;
import java.io.IOException;
import java.nio.file.Paths;

import com.ceb.gjjs.mda.service.XptstaService;
import com.ceb.gjjs.mda.vo.XptstaVO;

public class XptstaServiceTest extends BaseTest{

    @Autowired
    private XptstaService xptsta;

    @Test
    public void initTest() throws IOException {
        XptstaVO req = null;
        File file = Paths.get(testJsonDir, "xptsta").resolve("init.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptstaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptstaVO> response = xptsta.init(req);
    }
    @Test
    public void checkAllTest() throws IOException {
        XptstaVO req = null;
        File file = Paths.get(testJsonDir, "xptsta").resolve("checkAll.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptstaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptstaVO> response = xptsta.checkAll(req);
    }
    @Test
    public void saveDataTest() throws IOException {
        XptstaVO req = null;
        File file = Paths.get(testJsonDir, "xptsta").resolve("saveData.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptstaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptstaVO> response = xptsta.saveData(req);
    }
    @Test
    public void pendingTest() throws IOException {
        XptstaVO req = null;
        File file = Paths.get(testJsonDir, "xptsta").resolve("pending.json").toFile();
        if (file.exists()) {
            req = om.readValue(file, new TypeReference<XptstaVO>() { });
        }
        Assert.notNull(req, "调用参数不能为空！");
        ResponseSet<XptstaVO> response = xptsta.pending(req);
    }

    @Test
    public void executeDefault() {
        String rule = "";
        XptstaVO req = new XptstaVO();
        // 参数设置
        ResponseSet<XptstaVO> response = xptsta.executeDefault(req,rule);
    }

}
