package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Wfs;
import com.ceb.gjjs.mda.bo.Grn;
import com.ceb.gjjs.mda.bo.Gitpush;
import com.ceb.gjjs.mda.bo.Trn;
import com.ceb.gjjs.mda.bo.Ebhmsg;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Swmsg;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Ebhsnd;
import com.ceb.gjjs.mda.bo.Wfe;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Stlbod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Stlbod.class);

        //报文处理结果
        private Map response;

        //相关系统业务编号
        private String stlref;

        //落地交易代码
        private String frmcod;

        //业务参考号
        private String ownref;

        //业务数据流
        private IStream grpdata = new StreamImpl();

        //影像记录主键
        private String imginr;



		@Module(getter = false, setter = false)
        private transient ModuleHolder<Busgrp> busgrp;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Ptyset> ptyset;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> trn;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Smh> smh;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Spt> spt;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfs> wfs;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Wfe> wfe;

		@Module(getter = false, setter = false)
        private transient ModuleHolder<Trn> apltrn;

	    @BDGetter
		private Swmsg swmsg;

	    @BDGetter
		private Ebhmsg ebhmsg;

	    @BDGetter
		private Grn grn;

	    @BDGetter
		private Ebhsnd ebhsnd;

	    @BDGetter
		private Gitpush gitpush;

		@BDGetter
		private ModuleList<Spt> sptlst;


		public Stlbod()
        {
            super();
            setArgument();
        }

        public Stlbod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:stlbod.@0000.script
        */
        public void parseMessage(String msgTyp, Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in parseMessage method = " + "parseSTL" +msgTyp );
			MdaUtils.invoke(this,"parseSTL"+msgTyp,data,resMsg) ;
			//存储影像信息
			if(Platform.isNoError(resMsg))
			{
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getImgref()))
			  {
			    String bchcod = this.getBusgrp().getBusinf().getBchcod();
			    String imginr = ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getItfmod().getImgmod().saveSTLImage(this.getStlref(),this.getBusgrp().getBusinf().getImgref(),this.getBusgrp().getBusinf().getObjtyp(),this.getBusgrp().getBusinf().getObjinr(),"",this.getFrmcod(),"",bchcod);
			    this.setImginr(imginr);
			  }
			  if(!"D10_EBB".equals(msgTyp))
			  {
			    Map fileMap =(Map)data.get("fileMap");
			    smhWrite(fileMap);  //存储smh表
			    String contractid = (String)data.get("HTICONTRACT");
			    setSptFromStlbod(this.getFrmcod(),contractid);  //存spt表
			    if("T69_GIT".equals(msgTyp))
			    {
			      setFzgitFromStlbod();  //存待发送福州分行spt表
			    }
			    addNoticeWorkflow(this.getSpt(),this.getFrmcod());//增加工作流
			    bioOrdCreate(); // 保存ORD和ORE记录
			    setTrnState();
			  }
			}

			log.info("{}","received the message successfully...");
		}
        /**
        *   source:stlbod.@0001.script
        */
        public void  parseSTL700_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT700-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTL700 .... ") ;
			//  $stlref.setValue((String)data.get("lidgrp\\\\rec\\\\stlref"));
			this.setOwnref((String)data.get("lidgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("lidgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			// 1. 存储报文信息
			String lidinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  lidinr=reloadData("lid",this.getOwnref());
			  if(!MdaUtils.isEmpty(lidinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    setModuleContent(data);
			    this.getBusgrp().getLidgrp().getRec().setFlg("1");
			    if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getDbchcod()))
			      this.getBusgrp().getLidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLidgrp().getRec());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLidgrp().getBlk());
			  }
			  else
			  {
			    Platform.setErrorInfo(resMsg,"110","");
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getLidgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getLidgrp().getRec().setFlg("1");
			  this.getBusgrp().getLidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getBchcod()))
			    this.getBusgrp().getLidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  lidinr = Platform.sdbCounter("lid");
			  this.getBusgrp().getLidgrp().getRec().setInr(lidinr);
			  this.getBusgrp().getLidgrp().getRec().setOwnref(Platform.getRef("LC"));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLidgrp().getRec());
			  this.getBusgrp().getLidgrp().getBlk().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLidgrp().getBlk());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getLidgrp().getApl().getPts().setRef(this.getBusgrp().getLidgrp().getRec().getStlref());
			this.getBusgrp().getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getBusgrp().getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.getBusgrp().getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			//2.设置 BUSINF字段值
			this.setFrmcod("litdav");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"进口信用证开立通知");

		}
        /**
        *   source:stlbod.@0002.script
        */
        public void  parseSTL707_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT707_AKA-XML报文信息
			  @ 返回解析是否成功
			  */
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());

			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","stlref="+stlref);
			if(MdaUtils.isEmpty(stlref))
			{
			  log.info("{}","stlref is null!");
			  return ;
			}
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(reloadDataByStlref("lid",stlref.toString()))
			{
			  lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getBchcod()))
			    this.getBusgrp().getLidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLidgrp().getRec().setOwnref(Platform.getRef("LC"));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getLidgrp().getApl().getPts().setRef(this.getBusgrp().getLidgrp().getRec().getStlref());
			this.getBusgrp().getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getBusgrp().getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getBusgrp().getLidgrp().getIsb().savRolPts(lidinr,"lid","isb");
			this.getBusgrp().getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			this.setFrmcod("litmav");
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"进口信用证修改通知");
			return ;
		}
        /**
        *   source:stlbod.@0003.script
        */
        public void  parseSTL707_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT707_CTC-XML报文信息
			  @ 返回解析是否成功
			  */
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());

			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","stlref="+stlref);
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(reloadDataByStlref("lid",stlref.toString()))
			{
			  lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getBchcod()))
			    this.getBusgrp().getLidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLidgrp().getRec().setOwnref(Platform.getRef("LR"));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getLidgrp().getApl().getPts().setRef(this.getBusgrp().getLidgrp().getRec().getStlref());
			this.getBusgrp().getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getBusgrp().getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getBusgrp().getLidgrp().getIsb().savRolPts(lidinr,"lid","isb");
			this.getBusgrp().getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			this.setFrmcod("litmav");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"进口信用证转开/转递修改通知");
		}
        /**
        *   source:stlbod.@0004.script
        */
        public void  parseSTL710_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT710_CTC-XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String stlref =(String) data.get("lidgrp\\rec\\stlref");
			String ownref = (String)data.get("lidgrp\\rec\\ownref");
			// $stlref.setValue(stlref);
			this.setOwnref(ownref);
			log.debug("{}","stlref = " + stlref +",ownref=" + ownref);
			String lidinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  log.debug("{}","m1/ownref="+this.getOwnref());
			  lidinr=reloadData("lid",this.getOwnref());
			  if(MdaUtils.isEmpty(lidinr))
			  {
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  setModuleContent(data);
			  this.getBusgrp().getLidgrp().getRec().setFlg("1");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\blk"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getLidgrp().getRec().setFlg("1");
			  this.getBusgrp().getLidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getBchcod()))
			    this.getBusgrp().getLidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			  IDatafield blkinr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\blk\\inr");
			  blkinr.setValue(inr.getValue().toString());
			  this.getBusgrp().getLidgrp().getRec().setOwnref(Platform.getRef("LR"));
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\blk"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getLidgrp().getApl().getPts().setRef(this.getBusgrp().getLidgrp().getRec().getStlref());
			this.getBusgrp().getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getBusgrp().getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.getBusgrp().getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getBusgrp().getLidgrp().getIsb().savRolPts(lidinr,"lid","isb");
			this.setFrmcod("littdv");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"进口信用证转递/保兑通知");
			return ;
		}
        /**
        *   source:stlbod.@0005.script
        */
        public void  parseSTLT34_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT34_CTC-XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("brdgrp\\rec\\stlref");
			String pntstlref = (String) data.get("brdgrp\\rec\\pntstlref");
			log.debug("{}","stlref = "+stlref);
			//$stlref.setValue(stlref.toString());
			String brdinr = null;
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("docadv");
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  // 加载信用证信息
			  String pntinr = "" ;
			  if(!MdaUtils.isEmpty(pntstlref))
			  {
			    if(reloadDataByArg("lid","stlref",pntstlref))
			    {
			      pntinr = this.getBusgrp().getLidgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",pntinr));
			    }
			  }
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("docadv");
			  brdinr= Platform.sdbCounter("brd");
			  this.getBusgrp().getBrdgrp().getRec().setPnttyp("lid");
			  this.getBusgrp().getBrdgrp().getRec().setPntinr( pntinr );
			  this.getBusgrp().getBrdgrp().getRec().setBchcod( this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setEtyinr( this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setInr(brdinr);
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("BX"));
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			  // 保存申请人信息
			  if(!MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getInr()))
			  {
			    log.debug("{}","apl.ptsinr = " +this.getBusgrp().getBrdgrp().getApl().getPts().getInr() );
			    this.getBusgrp().getBrdgrp().getApl().savpts(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd");
			    log.debug("{}","apl.ptsinr = " +this.getBusgrp().getBrdgrp().getApl().getPts().getInr() );

			  }
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.getBusgrp().getBrdgrp().getPrb().savRolPts(brdinr,"brd","prb");

			this.setFrmcod("brtdck");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证项下到单通知");
		}
        /**
        *   source:stlbod.@0006.script
        */
        public void  parseSTLT76_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT76_CTC-XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			String brdinr1 = null;
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  brdinr1 = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr1));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr1));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr1));
			  setModuleContent(data);
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield brdinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  brdinr.setValue(Platform.sdbCounter("brd"));
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("BX"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr1,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr1,"brd","ben");
			this.getBusgrp().getBrdgrp().getBeb().savRolPts(brdinr1,"brd","beb");
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			this.setFrmcod("brtdcr");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"转递/保兑进口信用证提示不符点与拒付");
		}
        /**
        *   source:stlbod.@0007.script
        */
        public void  parseSTLT99_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT99_CTC-XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			String brdinr = null;
			if(reloadDataByStlref("brd",stlref.toString()))
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  brdinr= Platform.sdbCounter("brd");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(brdinr);
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("BX"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.setFrmcod("brtudp");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证远期承兑通知");
		}
        /**
        *   source:stlbod.@0008.script
        */
        public void  parseSTLT59_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT99_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("comgrp\\rec\\stlref");
			this.setStlref(stlref.toString());
			log.debug("{}",stlref.toString());
			setModuleContent(data);
			this.setFrmcod("comadv");
			setBusinfFromStlbod(this.getBusgrp().getComgrp().getRec().getInr(),"com",this.getOwnref(),"公共报文通知");

		}
        /**
        *   source:stlbod.@0009.script
        */
        public void  parseSTLT52_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT52_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("brd"));
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("BX"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.setFrmcod("brtset");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"转递/保兑进口信用证授权议付与承兑");

		}
        /**
        *   source:stlbod.@0010.script
        */
        public void  parseSTLT56_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT56_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref.toString());
			String brdinr = null;
			if(!reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  brdinr = Platform.sdbCounter("brd");
			  inr.setValue(brdinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("BX"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.getBusgrp().getBrdgrp().getBeb().savRolPts(brdinr,"brd","beb");
			this.setFrmcod("brtpay");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"转递/保兑进口信用证即期付款与无偿放单");
		}
        /**
        *   source:stlbod.@0012.script
        */
        public void  parseSTLT50_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT50_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */
			String brdinr = null;
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref.toString());
			//$stlref.setValue(stlref.toString());
			if(!reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  brdinr = Platform.sdbCounter("brd");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(brdinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("disadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  brdinr= this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("disadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			if(reloadDataByArg("lid","stlref",this.getBusgrp().getBrdgrp().getRec().getPntstlref()))
			{
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getConno()))
			    this.getBusgrp().getBrdgrp().getRec().setConno(this.getBusgrp().getLidgrp().getRec().getConno());
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getAdrblk()))
			  {
			    String lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    this.getBusgrp().getBrdgrp().getApl().getPts().setAdrblk(this.getBusgrp().getLidgrp().getApl().getPts().getAdrblk());
			  }
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.setFrmcod("brtdra");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证下电提不符点通知");
		}
        /**
        *   source:stlbod.@0013.script
        */
        public void  parseSTLT52_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT52_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("brd"));
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.setFrmcod("brtset");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证项下授权议付/承兑/付款通知");

		}
        /**
        *   source:stlbod.@0014.script
        */
        public void  parseSTLT72_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT72_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */

			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("brdgrp\\rec\\stlref");
			String pntstlref = (String) data.get("brdgrp\\rec\\pntstlref");
			log.debug("{}","stlref = "+stlref);
			Object lcref=data.get("brdgrp\\rec\\pntstlref");
			log.debug("{}","lcref="+lcref);
			//$stlref.setValue(stlref.toString());
			String brdinr = null;
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  String pntinr = "" ;
			  if(!MdaUtils.isEmpty(pntstlref))
			  {
			    if(reloadDataByArg("lid","stlref",pntstlref))
			    {
			      pntinr = this.getBusgrp().getLidgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",pntinr));
			      this.getBusgrp().getBrdgrp().getApl().getPts().setInr(NULLSTR);
			    }
			  }

			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBrdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  brdinr=Platform.sdbCounter("brd");
			  this.getBusgrp().getBrdgrp().getRec().setInr(brdinr);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			  /*
			    需求编号：R22081176
			    投产日期：20230525
			    修改人：w42375
			    描述：1.解析报文信息中的合同号
			    2.将合同号入库。
			    */

			  if(!MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getAdvtyp()) && "Y".equals(this.getBusgrp().getBrdgrp().getRec().getAdvtyp()))
			  {
			    this.getBusgrp().getBrdgrp().getBrdc().setInr(Platform.sdbCounter("brdc"));
			    this.getBusgrp().getBrdgrp().getBrdc().setPntinr(this.getBusgrp().getBrdgrp().getRec().getInr());
			    this.getBusgrp().getBrdgrp().getBrdc().setStlref(this.getBusgrp().getBrdgrp().getRec().getStlref());
			    this.getBusgrp().getBrdgrp().getBrdc().setFilename("进口信用证项下到单通知书");
			    this.getBusgrp().getBrdgrp().getBrdc().setSource("1");
			    this.getBusgrp().getBrdgrp().getBrdc().setCredat(MdaUtils.today());
			    ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\brdc"));
			  }

			  //保存申请人信息
			  /*
			    if(!Platform.isEmpty($busgrp\\brdgrp\\apl\\pts\\inr))
			    {
			    log.debug("apl.ptsinr = " +$busgrp\\brdgrp\\apl\\pts\\inr.getValue() );
			    $busgrp\\brdgrp\\apl.savpts($busgrp\\brdgrp\\rec\\inr.getValue(),"brd");
			    log.debug("apl.ptsinr = " +$busgrp\\brdgrp\\apl\\pts\\inr.getValue() );
			    }
			    */
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.getBusgrp().getBrdgrp().getPrb().savRolPts(brdinr,"brd","prb");
			this.setFrmcod("brtdck");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证下到单通知");
		}
        /**
        *   source:stlbod.@0015.script
        */
        public void  parseSTLT12_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT12_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref="+stlref);
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			String brdinr = null;
			if(reloadDataByStlref("brd",stlref.toString()))
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  brdinr= Platform.sdbCounter("brd");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(brdinr);
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  this.getBusgrp().getBrdgrp().getRec().setDocflg("accept");
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.setFrmcod("brtudp");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证远期承兑通知");
		}
        /**
        *   source:stlbod.@0016.script
        */
        public String reloadData(String objtyp,String ownref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String rtinr=null;
			Argument<String> inr=new Argument<String>("objinr");
			String sql="SELECT objinr FROM trn WHERE objtyp='"+objtyp+"' AND ownref='"+ownref+"'";
			ctx.getDaoSession().dbExecuteSQL(sql);
			ctx.getDaoSession().dbFetchFields(inr);
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  IModule mod=MdaDriver.getModule(this.getBusgrp(),objtyp+"grp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if("lid".equals(objtyp) || "did".equals(objtyp))
			    {
			      log.info("{}","reload lit or did...");
			      ctx.getDaoSession().dbRead(MdaDriver.getModule(this.getBusgrp(),objtyp+"grp\\blk"),new Argument<String>("inr",inr.value.toString()));
			      int e=ctx.getErrorCode();
			    }
			  }
			  rtinr=inr.value;
			}
			ctx.getDaoSession().dbCloseCursor();
			return rtinr;
		}
        /**
        *   source:stlbod.@0017.script
        */
        public void setModuleContent(Map<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			for(String key:data.keySet())
			{
			  log.debug("{}","name=" +key+"  value=" +data.get(key));
			  if((!"fileMap".equals(key))&&(!"swinfo".equals(key))&&(!"HTICONTRACT".equals(key)))
			  {
			    IDatafield datafield=MdaDriver.getDatafield(this.getBusgrp(),key);
			    datafield.setValue(data.get(key));
			  }
			}
		}
        /**
        *   source:stlbod.@0018.script
        */
        public void setBusinfFromStlbod(String objinr, String objtyp,String ownref, String objname)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","in stlbod.setBusinfFromStlbod... ");
			this.getBusgrp().getBusinf().setObjtyp(objtyp);
			this.getBusgrp().getBusinf().setObjinr(objinr);
			this.getBusgrp().getBusinf().setOwnref(ownref);
			Map<String,Object> submap = Platform.getValueMap(this.getBusgrp(),this.getFrmcod(),"SUB");
			if(!MdaUtils.isEmpty(submap))
			{
			  if(!MdaUtils.isEmpty(submap.get("nam")))
			    this.getBusgrp().getBusinf().setObjnam(submap.get("nam").toString());
			  if(!MdaUtils.isEmpty(submap.get("ccy")))
			    this.getBusgrp().getBusinf().setCur(submap.get("ccy").toString()) ;
			  if(!MdaUtils.isEmpty(submap.get("amt")))
			    this.getBusgrp().getBusinf().setAmt((BigDecimal)submap.get("amt"));
			}
		}
        /**
        *   source:stlbod.@0019.script
        */
        public boolean reloadDataByStlref(String argtyp,String stlref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}"," errocode 1 =  "  + ctx.getErrorCode() );
			log.debug("{}","grptyp="+argtyp+",stlref = "+stlref);
			IModule module=MdaDriver.getModule(this.getBusgrp(),argtyp+"grp\\rec");
			ctx.getDaoSession().dbRead(module,new Argument("stlref",stlref));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  IDatafield field=MdaDriver.getDatafield(module,"inr");
			  log.info("{}","reloadData succeed,and the inr="+field.getValue());
			  if("lid".equals(argtyp))
			  {
			    log.info("{}","reload lit...");
			    ctx.getDaoSession().dbRead(MdaDriver.getModule(this.getBusgrp(),argtyp+"grp\\blk"),new Argument<String>("inr",field.getValue().toString()));
			    log.info("{}",ctx.getErrorCode());
			  }
			  return true;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","cannot find the corresponding reference in DZT!");
			  }
			  else
			  {
			    log.info("{}","error in looking the ....");
			  }
			  return false;
			}
		}
        /**
        *   source:stlbod.@0020.script
        */
        public void  parseSTLT12_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT12_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bedgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(reloadDataByStlref("bed",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBedgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bed"));
			  this.getBusgrp().getBedgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			    this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBedgrp().getRec());
			}
			this.setFrmcod("betacc");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"出口信用证下单据承兑通知");
		}
        /**
        *   source:stlbod.@0021.script
        */
        public void  parseSTLT12_EIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT12_EIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bodgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(reloadDataByStlref("bod",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBodgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBodgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBodgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBodgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bod"));
			  this.getBusgrp().getBodgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBodgrp().getRec().setOwnref(Platform.getRef("OC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBodgrp().getRec());
			}
			this.setFrmcod("botacc");
			this.setOwnref(this.getBusgrp().getBodgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBodgrp().getRec().getInr(),"bod",this.getOwnref(),"出口托收项下单据承兑通知");
		}
        /**
        *   source:stlbod.@0022.script
        */
        public boolean reloadDataByArg(String argtyp,String arg,String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IModule module=MdaDriver.getModule(this.getBusgrp(),argtyp+"grp\\rec");
			ctx.getDaoSession().dbRead(module,new Argument<String>(arg,value));
			int errorcode=ctx.getErrorCode();
			if(errorcode==NO_ERROR)
			{
			  IDatafield field=MdaDriver.getDatafield(module,"inr");
			  log.info("{}","reloadData succeed,and the inr="+field.getValue());
			  return true;
			}
			else
			{
			  if(errorcode==NO_MORE_ROW)
			  {
			    log.info("{}","cannot find the corresponding reference in DZT!");
			  }
			  else
			  {
			    log.info("{}","error in looking the ....");
			  }
			  return false;
			}
		}
        /**
        *   source:stlbod.@0023.script
        */
        public void  parseSTLT34_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT34_EAB-XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bedgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(reloadDataByStlref("bed",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBedgrp().getRec().setDocflg("retrej");
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bed"));
			  this.getBusgrp().getBedgrp().getRec().setDocflg("retrej");
			  this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			    this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBedgrp().getRec());
			}
			this.setFrmcod("betdck");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"出口信用证下单据遭拒付通知");
		}
        /**
        *   source:stlbod.@0024.script
        */
        public void  parseSTLT50_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT50_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object lcref=data.get("bedgrp\\rec\\stlref");
			log.debug("{}","lcref="+lcref.toString());
			//$stlref.setValue(lcref.toString());
			if(reloadDataByStlref("bed",lcref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBedgrp().getRec().setDocflg("disadv");
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bed"));
			  this.getBusgrp().getBedgrp().getRec().setDocflg("disadv");
			  this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			    this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));
			}
			this.setFrmcod("betdis");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"出口信用证通知不符点");
		}
        /**
        *   source:stlbod.@0025.script
        */
        public void  parseSTLT50_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT50_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */

			String brdinr = null;
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref.toString());
			// $stlref.setValue(stlref.toString());
			if(!reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  brdinr = Platform.sdbCounter("brd");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  inr.setValue(brdinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("disadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  brdinr= this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("disadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			if(reloadDataByArg("lid","stlref",this.getBusgrp().getBrdgrp().getRec().getPntstlref()))
			{
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getConno()))
			    this.getBusgrp().getBrdgrp().getRec().setConno(this.getBusgrp().getLidgrp().getRec().getConno());
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getAdrblk()))
			  {
			    String lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			    this.getBusgrp().getBrdgrp().getApl().getPts().setAdrblk(this.getBusgrp().getLidgrp().getApl().getPts().getAdrblk());
			  }
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.setFrmcod("brtdra");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"转递/保兑进口信用不符点通知");

		}
        /**
        *   source:stlbod.@0026.script
        */
        public void  parseSTLT54_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT54_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			log.debug("{}","stlref = "+ this.getStlref());
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref.toString());
			String brdinr = null;
			if(!reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  brdinr = Platform.sdbCounter("brd");
			  inr.setValue(brdinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBrdgrp().getRec());
			}
			else
			{
			  brdinr = this.getBusgrp().getBrdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBrdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","brd"),new Argument("objinr",brdinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBrdgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			this.getBusgrp().getBrdgrp().getApl().savRolPts(brdinr,"brd","apl");
			this.getBusgrp().getBrdgrp().getBen().savRolPts(brdinr,"brd","ben");
			this.getBusgrp().getBrdgrp().getBeb().savRolPts(brdinr,"brd","beb");
			this.setFrmcod("brtpay");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证来单付款通知");
		}
        /**
        *   source:stlbod.@0027.script
        */
        public void  parseSTLT76_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT76_AKA-XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("brdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			if(reloadDataByArg("brd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBrdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield brdinr=MdaDriver.getDatafield(this.getBusgrp(),"brdgrp\\rec\\inr");
			  brdinr.setValue(Platform.sdbCounter("brd"));
			  this.getBusgrp().getBrdgrp().getRec().setOwnref(Platform.getRef("IB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBrdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBrdgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBrdgrp().getApl().getPts().setRef(this.getBusgrp().getBrdgrp().getRec().getPntstlref());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"brdgrp\\rec"));
			this.setFrmcod("brtdcr");
			this.setOwnref(this.getBusgrp().getBrdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBrdgrp().getRec().getInr(),"brd",this.getOwnref(),"进口信用证项下提示不符点/拒付退单通知");
		}
        /**
        *   source:stlbod.@0028.script
        */
        public void  parseSTLT99_COM(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT99_COM-XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("comgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setOwnref(stlref.toString());
			}
			else
			{
			  log.warn("{}","stlref is empty!" );
			}
			setModuleContent(data);
			this.setFrmcod("comadv");
			setBusinfFromStlbod(this.getBusgrp().getComgrp().getRec().getInr(),"com",this.getOwnref(),"自由报文通知");
		}
        /**
        *   source:stlbod.@0029.script
        */
        public void  parseSTLD07_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD07_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("dedgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			String dedinr = null;
			if(reloadDataByStlref("ded",stlref.toString()))
			{
			  dedinr = this.getBusgrp().getDedgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","ded"),new Argument("objinr",dedinr));
			  setModuleContent(data);
			  this.getBusgrp().getDedgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getDedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"dedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getDedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  dedinr = Platform.sdbCounter("ded");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"dedgrp\\rec\\inr");
			  inr.setValue(dedinr);
			  this.getBusgrp().getDedgrp().getRec().setOwnref(Platform.getRef("DA"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getDedgrp().getRec().getBchcod()))
			    this.getBusgrp().getDedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getDedgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getDedgrp().getRec());
			}
			this.getBusgrp().getDedgrp().getApl().savRolPts(dedinr,"ded","apl");
			this.getBusgrp().getDedgrp().getBen().savRolPts(dedinr,"ded","ben");
			this.getBusgrp().getDedgrp().getIsb().savRolPts(dedinr,"ded","isb");
			this.setFrmcod("detame");
			this.setOwnref(this.getBusgrp().getDedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getDedgrp().getRec().getInr(),"ded",this.getOwnref(),"卖方证修改通知");
		}
        /**
        *   source:stlbod.@0030.script
        */
        public void  parseSTLD07_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD07_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("didgrp\\rec\\stlref");
			//$stlref.setValue(stlref.toString());
			String didinr = null;
			if(reloadDataByStlref("did",stlref.toString()))
			{
			  didinr = this.getBusgrp().getDidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			  this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"didgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"didgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  didinr = Platform.sdbCounter("did");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"didgrp\\rec\\inr");
			  inr.setValue(didinr);
			  this.getBusgrp().getDidgrp().getRec().setOwnref(Platform.getRef("DC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getDidgrp().getRec().getBchcod()))
			    this.getBusgrp().getDidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"didgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getDidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getDidgrp().getApl().getPts().setRef(this.getBusgrp().getDidgrp().getRec().getStlref());
			//补充
			this.getBusgrp().getDidgrp().getBen().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getBen().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getBen().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getBen().getPts().getAdr());
			this.getBusgrp().getDidgrp().getAdv().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getAdv().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getAdv().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getAdv().getPts().getAdr());
			this.getBusgrp().getDidgrp().getApl().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getApl().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getApl().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getApl().getPts().getAdr());
			this.getBusgrp().getDidgrp().getIsb().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getIsb().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getIsb().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getIsb().getPts().getAdr());
			//----
			this.getBusgrp().getDidgrp().getApl().savRolPts(didinr,"did","apl");
			this.getBusgrp().getDidgrp().getBen().savRolPts(didinr,"did","ben");
			this.getBusgrp().getDidgrp().getIsb().savRolPts(didinr,"did","isb");
			this.getBusgrp().getDidgrp().getAdv().savRolPts(didinr,"did","adv");
			this.setFrmcod("ditmav");
			this.setOwnref(this.getBusgrp().getDidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getDidgrp().getRec().getInr(),"did",this.getOwnref(),"买方证修改通知");		}
        /**
        *   source:stlbod.@0031.script
        */
        public void  parseSTLD10_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD10_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String stlref = (String)data.get("dedgrp\\rec\\stlref");
			String ownref = (String)data.get("dedgrp\\rec\\ownref");
			if(!MdaUtils.isEmpty(ownref))
			{
			  String inr= reloadData( "did", ownref);
			  log.debug("{}","ownref=" +ownref +", did.inr=" +  inr  );
			  if(!MdaUtils.isEmpty(inr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getRec(),new Argument<String>("inr",inr));
			    if(ctx.getErrorCode()== NO_ERROR)
			    {
			      this.getBusgrp().getDidgrp().getRec().setStlref(stlref);
			      this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			      ctx.getDaoSession().dbUpdate(this.getBusgrp().getDidgrp().getRec());
			    }
			  }
			}

			log.debug("{}","led stlref = "+stlref);
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"dedgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getDedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			// $stlref.setValue(stlref.toString());
			this.getBusgrp().getDedgrp().getRec().setFlg("2");
			IDatafield ledinr=MdaDriver.getDatafield(this.getBusgrp(),"dedgrp\\rec\\inr");
			ledinr.setValue(Platform.sdbCounter("ded"));
			this.getBusgrp().getDedgrp().getRec().setOwnref(Platform.getRef("DA"));
			if(MdaUtils.isEmpty(this.getBusgrp().getDedgrp().getRec().getBchcod()))
			  this.getBusgrp().getDedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			this.getBusgrp().getDedgrp().getRec().setAdvdat(MdaUtils.today());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getDedgrp().getRec());
			String inr = this.getBusgrp().getDedgrp().getRec().getInr();
			this.getBusgrp().getDedgrp().getBen().savRolPts(inr,"ded","ben");
			this.getBusgrp().getDedgrp().getIsb().savRolPts(inr,"ded","isb");
			this.getBusgrp().getDedgrp().getApl().savRolPts(inr,"ded","apl");
			this.setFrmcod("detopn");
			this.setOwnref(this.getBusgrp().getDedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getDedgrp().getRec().getInr(),"ded",this.getOwnref(),"卖方国内证开立通知");
		}
        /**
        *   source:stlbod.@0032.script
        */
        public void  parseSTLD12_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD12_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bddgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			String bddinr = null;
			if(reloadDataByStlref("bdd",stlref.toString()))
			{
			  bddinr = this.getBusgrp().getBddgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  setModuleContent(data);
			  this.getBusgrp().getBddgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBddgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  bddinr= Platform.sdbCounter("bdd");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\inr");
			  inr.setValue(bddinr);
			  this.getBusgrp().getBddgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBddgrp().getRec().setOwnref(Platform.getRef("DB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getRec().getBchcod()))
			    this.getBusgrp().getBddgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBddgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBddgrp().getApl().getPts().setRef(this.getBusgrp().getBddgrp().getRec().getPntstlref());
			this.getBusgrp().getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			this.getBusgrp().getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			this.setFrmcod("bdtudp");
			this.setOwnref(this.getBusgrp().getBddgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBddgrp().getRec().getInr(),"bdd",this.getOwnref(),"买方证远期承兑通知");
		}
        /**
        *   source:stlbod.@0033.script
        */
        public void  parseSTLD12_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD12_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bmdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(reloadDataByStlref("bmd",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBmdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBmdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bmd"));
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBmdgrp().getRec().setOwnref(Platform.getRef("DA"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBmdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBmdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBmdgrp().getRec());
			}
			this.setFrmcod("bmtacc");
			this.setOwnref(this.getBusgrp().getBmdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBmdgrp().getRec().getInr(),"bmd",this.getOwnref(),"卖方证下单据承兑通知");
		}
        /**
        *   source:stlbod.@0034.script
        */
        public void  parseSTLD32_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD32_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("bmdgrp\\rec\\stlref");
			Object pntref=data.get("bmdgrp\\rec\\pntref");
			// $stlref.setValue(stlref.toString());
			log.debug("{}","pntref="+pntref);
			log.debug("{}","stlref = "+this.getStlref());
			if(!MdaUtils.isEmpty(pntref))
			{
			  String strpntref = pntref.toString();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getDedgrp().getRec(),new Argument<String>("stlref",strpntref));
			  if(!MdaUtils.isEmpty(this.getBusgrp().getDedgrp().getRec().getInr()))
			  {
			    String ledinr = this.getBusgrp().getDedgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBmdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","ded"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBmdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","ded"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBmdgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","ded"),new Argument("objinr",ledinr));
			    this.getBusgrp().getBmdgrp().getApl().getPts().setInr("");
			    this.getBusgrp().getBmdgrp().getBen().getPts().setInr("");
			    this.getBusgrp().getBmdgrp().getIsb().getPts().setInr("");
			    this.getBusgrp().getBmdgrp().getRec().setIsscur(this.getBusgrp().getDedgrp().getRec().getLcccur());
			    this.getBusgrp().getBmdgrp().getRec().setIssamt(this.getBusgrp().getDedgrp().getRec().getLccamt());
			  }
			}
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBmdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\docflg");
			docflg.setValue("docadv");
			this.getBusgrp().getBmdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			String bmdinr = Platform.sdbCounter("bmd");
			IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\inr");
			inr.setValue(bmdinr);
			this.getBusgrp().getBmdgrp().getRec().setOwnref(Platform.getRef("DA"));
			if(MdaUtils.isEmpty(this.getBusgrp().getBmdgrp().getRec().getBchcod()))
			  this.getBusgrp().getBmdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			this.getBusgrp().getBmdgrp().getRec().setAdvdat(MdaUtils.today());
			ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"bmdgrp\\rec"));
			this.getBusgrp().getBmdgrp().getBen().savRolPts(bmdinr,"bmd","ben");
			this.getBusgrp().getBmdgrp().getIsb().savRolPts(bmdinr,"bmd","isb");
			this.getBusgrp().getBmdgrp().getApl().savRolPts(bmdinr,"bmd","apl");
			this.setFrmcod("bmtsnd");
			this.setOwnref(this.getBusgrp().getBmdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBmdgrp().getRec().getInr(),"bmd",this.getOwnref(),"卖方证下寄单通知");
		}
        /**
        *   source:stlbod.@0035.script
        */
        public void  parseSTLD34_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD34_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bmdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+ stlref);
			if(reloadDataByStlref("bmd",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("retrej");
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBmdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBmdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bmd"));
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("retrej");
			  this.getBusgrp().getBmdgrp().getRec().setOwnref(Platform.getRef("DA"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBmdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBmdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBmdgrp().getRec());
			}
			this.setFrmcod("bmtdck");
			this.setOwnref(this.getBusgrp().getBmdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBmdgrp().getRec().getInr(),"bmd",this.getOwnref(),"卖方证下单据遭拒付通知");
		}
        /**
        *   source:stlbod.@0036.script
        */
        public void  parseSTLD54_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD54_EAB_XML报文信息
			  @ 返回解析是否成功
			  */
			Object lcref=data.get("bmdgrp\\rec\\stlref");
			log.debug("{}","lcref="+lcref.toString());
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bmd",lcref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bmdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  this.getBusgrp().getBmdgrp().getRec().setDocflg("payment");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bmdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bmd"));
			  this.getBusgrp().getBmdgrp().getRec().setOwnref(Platform.getRef("DA"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBmdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBmdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBmdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bmdgrp\\rec"));
			}
			this.setFrmcod("bmtset");
			this.setOwnref(this.getBusgrp().getBmdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBmdgrp().getRec().getInr(),"bmd",this.getOwnref(),"卖方证项下收汇通知");
		}
        /**
        *   source:stlbod.@0037.script
        */
        public void  parseSTLD54_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD54_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bddgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			log.debug("{}","stlref = "+stlref.toString());
			String bddinr = null;
			if(!reloadDataByArg("bdd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\inr");
			  bddinr = Platform.sdbCounter("bdd");
			  inr.setValue(bddinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBddgrp().getRec().setOwnref(Platform.getRef("DB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getRec().getBchcod()))
			    this.getBusgrp().getBddgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBddgrp().getRec());
			}
			else
			{
			  bddinr = this.getBusgrp().getBddgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getBeb().getPts(),new Argument("rol","beb"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\docflg");
			  docflg.setValue("payment");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBddgrp().getRec());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBddgrp().getApl().getPts().setRef(this.getBusgrp().getBddgrp().getRec().getPntstlref());
			this.getBusgrp().getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			this.getBusgrp().getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			this.getBusgrp().getBddgrp().getBeb().savRolPts(bddinr,"bdd","beb");
			this.setFrmcod("bdtpay");
			this.setOwnref(this.getBusgrp().getBddgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBddgrp().getRec().getInr(),"bdd",this.getOwnref(),"买方证来单付款通知");
		}
        /**
        *   source:stlbod.@0038.script
        */
        public void  parseSTLD70_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD70_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref=data.get("didgrp\\rec\\stlref");
			//$stlref.setValue((String) data.get("didgrp\\\\rec\\\\stlref"));
			this.setOwnref((String) data.get("didgrp\\rec\\ownref"));
			String lidinr = null;
			log.debug("{}","ownref="+this.getOwnref()+",stlref="+this.getStlref());
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  lidinr=reloadData("did",this.getOwnref());
			  if(!MdaUtils.isEmpty(lidinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","did"),new Argument("objinr",lidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","did"),new Argument("objinr",lidinr));
			    setModuleContent(data);
			    this.getBusgrp().getDidgrp().getRec().setFlg("1");
			    this.getBusgrp().getDidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getDidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getDidgrp().getRec());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getDidgrp().getBlk());
			  }
			  else
			    log.debug("{}","reloadData error...");

			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getDidgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getDidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getDidgrp().getRec().setFlg("1");
			  this.getBusgrp().getDidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  lidinr = Platform.sdbCounter("did");
			  this.getBusgrp().getDidgrp().getRec().setOwnref(Platform.getRef("DC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getDidgrp().getRec().getBchcod()))
			    this.getBusgrp().getDidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getDidgrp().getRec().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getDidgrp().getRec());
			  this.getBusgrp().getDidgrp().getBlk().setInr(lidinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getDidgrp().getBlk());
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getDidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getDidgrp().getApl().getPts().setRef(this.getBusgrp().getDidgrp().getRec().getStlref());

			//补充
			this.getBusgrp().getDidgrp().getBen().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getBen().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getBen().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getBen().getPts().getAdr());
			this.getBusgrp().getDidgrp().getAdv().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getAdv().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getAdv().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getAdv().getPts().getAdr());
			this.getBusgrp().getDidgrp().getApl().cutField2(MdaDriver.getDatafield(this.getBusgrp().getDidgrp().getApl().getPts(),"adrblk"),this.getBusgrp().getDidgrp().getApl().getPts().getNam()+CR+this.getBusgrp().getDidgrp().getApl().getPts().getAdr());
			//----
			this.getBusgrp().getDidgrp().getBen().savRolPts(lidinr,"did","ben");
			this.getBusgrp().getDidgrp().getAdv().savRolPts(lidinr,"did","adv");
			this.getBusgrp().getDidgrp().getApl().savRolPts(lidinr,"did","apl");
			this.setFrmcod("ditdav");
			this.setOwnref(this.getBusgrp().getDidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getDidgrp().getRec().getInr(),"did",this.getOwnref(),"国内证开立通知");		}
        /**
        *   source:stlbod.@0039.script
        */
        public void  parseSTLD72_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD72_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object lcref=data.get("bddgrp\\rec\\pntstlref");
			String pntstlref = (String) data.get("bddgrp\\rec\\pntstlref");
			Object stlref = data.get("bddgrp\\rec\\stlref");
			log.debug("{}","stlref = "+this.getStlref()+",llcref="+lcref);
			String bddinr = null;
			if(reloadDataByArg("bdd","stlref",this.getStlref()))
			{
			  bddinr = this.getBusgrp().getBddgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getPrb().getPts(),new Argument("rol","prb"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bdd"),new Argument("objinr",bddinr));
			  setModuleContent(data);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bddgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  String pntinr = "" ;
			  if(!MdaUtils.isEmpty(pntstlref))
			  {
			    if(reloadDataByArg("did","stlref",pntstlref))
			    {
			      pntinr = this.getBusgrp().getDidgrp().getRec().getInr();
			      ctx.getDaoSession().dbRead(this.getBusgrp().getBddgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",pntinr));
			    }
			  }
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBddgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  bddinr=Platform.sdbCounter("bdd");
			  this.getBusgrp().getBddgrp().getRec().setInr(bddinr);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBddgrp().getRec().setOwnref(Platform.getRef("DB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getRec().getBchcod()))
			    this.getBusgrp().getBddgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"bddgrp\\rec"));
			  //保存申请人信息
			
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBddgrp().getApl().getPts().setRef(this.getBusgrp().getBddgrp().getRec().getPntstlref());
			this.getBusgrp().getBddgrp().getApl().savRolPts(bddinr,"bdd","apl");
			this.getBusgrp().getBddgrp().getBen().savRolPts(bddinr,"bdd","ben");
			this.getBusgrp().getBddgrp().getPrb().savRolPts(bddinr,"bdd","prb");
			this.setFrmcod("bdtdck");
			this.setOwnref(this.getBusgrp().getBddgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBddgrp().getRec().getInr(),"bdd",this.getOwnref(),"买方证下到单通知");
		}
        /**
        *   source:stlbod.@0040.script
        */
        public void  parseSTLD74_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD74_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("didgrp\\rec\\stlref");
			log.debug("{}","did stlref = "+stlref);
			this.setStlref(stlref.toString());
			String didinr = null;
			if(!reloadDataByArg("did","stlref",stlref.toString()))
			{
			  Platform.setErrorInfo(resMsg,"10001","cannot find the corresponding reference");
			  return ;
			}
			didinr = this.getBusgrp().getDidgrp().getRec().getInr();
			this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			setModuleContent(data);
			ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","did"),new Argument("objinr",didinr));
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"didgrp\\rec"));
			this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			ctx.getDaoSession().dbReadset(this.getBusgrp().getBddlst(),new Argument("pntstlref",stlref.toString()));
			for(int i=0;i<this.getBusgrp().getBddlst().fullSize();i++)
			{
			  this.getBusgrp().getBddlst().getElement(i).setClsdat(this.getBusgrp().getDidgrp().getRec().getClsdat());
			  ctx.getDaoSession().dbUpdate(this.getBusgrp().getBddlst().getElement(i));
			}
			this.setOwnref(this.getBusgrp().getDidgrp().getRec().getOwnref());
			this.setFrmcod("ditcan");
			setBusinfFromStlbod(this.getBusgrp().getDidgrp().getRec().getInr(),"did",this.getOwnref(),"买方证撤销通知");
		}
        /**
        *   source:stlbod.@0041.script
        */
        public void  parseSTLD76_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD76_AKA_XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bddgrp\\rec\\stlref");
			log.debug("{}","stlref = "+stlref);
			this.setStlref(stlref.toString());
			if(reloadDataByArg("bdd","stlref",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bddgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBddgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield bddinr=MdaDriver.getDatafield(this.getBusgrp(),"bddgrp\\rec\\inr");
			  bddinr.setValue(Platform.sdbCounter("bdd"));
			  this.getBusgrp().getBddgrp().getRec().setOwnref(Platform.getRef("DB"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getRec().getBchcod()))
			    this.getBusgrp().getBddgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBddgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"bddgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getBddgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getBddgrp().getApl().getPts().setRef(this.getBusgrp().getBddgrp().getRec().getPntstlref());
			//update the flag
			this.setFrmcod("bdtdcr");
			this.setOwnref(this.getBusgrp().getBddgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBddgrp().getRec().getInr(),"bdd",this.getOwnref(),"买方证项下提示不符点/拒付退单通知");
		}
        /**
        *   source:stlbod.@0042.script
        */
        public void  parseSTLT07_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT07_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("ledgrp\\rec\\stlref");
			this.setStlref(stlref.toString());
			String ledinr = null;
			if(reloadDataByStlref("led",stlref.toString()))
			{
			  ledinr = this.getBusgrp().getLedgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			  setModuleContent(data);
			  this.getBusgrp().getLedgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"ledgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  ledinr = Platform.sdbCounter("led");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"ledgrp\\rec\\inr");
			  this.getBusgrp().getLedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getLedgrp().getRec().getBchcod()))
			    this.getBusgrp().getLedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  inr.setValue(ledinr);
			  this.getBusgrp().getLedgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLedgrp().getRec());
			}
			this.getBusgrp().getLedgrp().getApl().savRolPts(ledinr,"led","apl");
			this.getBusgrp().getLedgrp().getBen().savRolPts(ledinr,"led","ben");
			this.getBusgrp().getLedgrp().getIsb().savRolPts(ledinr,"led","isb");
			//$\\bimenu\\grptyp.setValue("ledgrp");
			this.setFrmcod("letame");
			this.setOwnref(this.getBusgrp().getLedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLedgrp().getRec().getInr(),"led",this.getOwnref(),"出口来证修改通知");
		}
        /**
        *   source:stlbod.@0043.script
        */
        public void  parseSTLT10_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT10_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("ledgrp\\rec\\stlref");
			log.debug("{}","led stlref = "+stlref);
			if(reloadDataByStlref("led",stlref.toString()))
			{

			  setModuleContent(data);
			  this.getBusgrp().getLedgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLedgrp().getRec());

			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"ledgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  //$stlref.setValue(stlref.toString());
			  //save the led data
			  this.getBusgrp().getLedgrp().getRec().setFlg("2");
			  IDatafield ledinr=MdaDriver.getDatafield(this.getBusgrp(),"ledgrp\\rec\\inr");
			  ledinr.setValue(Platform.sdbCounter("led"));
			  this.getBusgrp().getLedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getLedgrp().getRec().getBchcod()))
			    this.getBusgrp().getLedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLedgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLedgrp().getRec());
			}
			//and the pts
			String inr = this.getBusgrp().getLedgrp().getRec().getInr();

			this.getBusgrp().getLedgrp().getBen().savRolPts(inr,"led","ben");
			this.getBusgrp().getLedgrp().getIsb().savRolPts(inr,"led","isb");
			this.getBusgrp().getLedgrp().getApl().savRolPts(inr,"led","apl");
			this.setFrmcod("letopn");
			this.setOwnref(this.getBusgrp().getLedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLedgrp().getRec().getInr(),"led",this.getOwnref(),"出口来证通知");
		}
        /**
        *   source:stlbod.@0044.script
        */
        public void  parseSTLT14_EIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT14_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref=data.get("bodgrp\\rec\\stlref");
			// $stlref.setValue(lcref.toString());
			Object ownref =(String) data.get("bodgrp\\rec\\ownref");
			log.debug("{}","stlref = "+stlref + ",ownref = "+ownref);
			String inr=null;
			if( (!MdaUtils.isEmpty(ownref) && !MdaUtils.isEmpty(reloadData("bod",this.getOwnref())) )|| (!MdaUtils.isEmpty(stlref) && reloadDataByStlref("bod",stlref.toString())) )
			{
			  // $ownref.setValue(ownref.toString());
			  this.setOwnref(this.getBusgrp().getBodgrp().getRec().getOwnref());
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBodgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBodgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getRcvdat()))
			    this.getBusgrp().getBodgrp().getRec().setRcvdat(this.getBusgrp().getBodgrp().getRec().getAdvdat());
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"bodgrp\\rec"));
			}

			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBodgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  String bodinr=Platform.sdbCounter("bod");
			  this.getBusgrp().getBodgrp().getRec().setInr(bodinr);
			  this.getBusgrp().getBodgrp().getDrr().savRolPts(bodinr,"bod","drr");
			  this.getBusgrp().getBodgrp().getDre().savRolPts(bodinr,"bod","dre");
			  this.getBusgrp().getBodgrp().getClb().savRolPts(bodinr,"bod","clb");
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getRcvdat()))
			    this.getBusgrp().getBodgrp().getRec().setRcvdat(this.getBusgrp().getBodgrp().getRec().getAdvdat());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBodgrp().getRec().setOwnref(Platform.getRef("OC"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBodgrp().getRec());
			}
			this.setFrmcod("botdav");
			this.setOwnref(this.getBusgrp().getBodgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBodgrp().getRec().getInr(),"bod",this.getOwnref(),"出口托收项下寄单通知");
		}
        /**
        *   source:stlbod.@0045.script
        */
        public void  parseSTLT18_BPC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT18_BPC-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("bpdgrp\\rec\\stlref");
			//$stlref.setValue(stlref.toString());
			String bpdinr = null;
			if(reloadDataByArg("bpd","stlref",stlref.toString()))
			{
			  bpdinr = this.getBusgrp().getBpdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bpd"),new Argument("objinr",bpdinr));
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBpdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bpdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  bpdinr = Platform.sdbCounter("bpd");
			  this.getBusgrp().getBpdgrp().getRec().setInr(bpdinr);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBpdgrp().getRec().setOwnref(Platform.getRef("PD"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBpdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bpdgrp\\rec"));
			}
			this.getBusgrp().getBpdgrp().getApl().savRolPts(bpdinr,"bpd","apl");
			this.setFrmcod("bptbps");
			this.setOwnref(this.getBusgrp().getBpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBpdgrp().getRec().getInr(),"bpd",this.getOwnref(),"出口押汇入账通知");

		}
        /**
        *   source:stlbod.@0046.script
        */
        public void  parseSTLT19_BPC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT19_BPC-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("bpdgrp\\rec\\stlref");
			//$stlref.setValue(stlref.toString());
			Object pntref=data.get("bpdgrp\\rec\\pntref");
			Object retamt=data.get("bpdgrp\\rec\\retamt");
			if(!MdaUtils.isEmpty(pntref)&&reloadDataByArg("bpd","pntref",pntref.toString()))
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBpdgrp().getRec().getDoccur()))
			  {
			    this.getBusgrp().getBpdgrp().getRec().setRetcur( this.getBusgrp().getBpdgrp().getRec().getDoccur());
			    this.getBusgrp().getBpdgrp().getRec().setFftcur( this.getBusgrp().getBpdgrp().getRec().getDoccur());
			  }
			  this.getBusgrp().getBpdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bpdgrp\\rec"));
			}

			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClientid()))
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBpdgrp().getRec().getDoccur()))
			  {
			    this.getBusgrp().getBpdgrp().getRec().setRetcur( this.getBusgrp().getBpdgrp().getRec().getDoccur());
			    this.getBusgrp().getBpdgrp().getRec().setFftcur( this.getBusgrp().getBpdgrp().getRec().getDoccur());
			  }
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBpdgrp().getRec().setInr(Platform.sdbCounter("bpd"));
			  this.getBusgrp().getBpdgrp().getRec().setOwnref(Platform.getRef("PD"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBpdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bpdgrp\\rec"));
			}
			this.setFrmcod("bptcrf");
			this.setOwnref(this.getBusgrp().getBpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBpdgrp().getRec().getInr(),"bpd",this.getOwnref(),"偿还出口押汇通知");

		}
        /**
        *   source:stlbod.@0047.script
        */
        public void  parseSTLT22_CPO(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT22_CPO-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("cpdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			/*
			  if(!Platform.isEmpty(stlref))
			  $stlref.setValue(stlref.toString());
			  */
			this.setOwnref((String) data.get("cpdgrp\\rec\\ownref"));
			log.debug("{}","stlref="+this.getStlref()+",ownref=" + this.getOwnref());
			String inr=null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			  inr=reloadData("cpd",this.getOwnref());
			if(!MdaUtils.isEmpty(inr))
			{
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClientid()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"cpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  inr=Platform.sdbCounter("cpd");
			  this.getBusgrp().getCpdgrp().getRec().setInr(inr);
			  this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("OR"));
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			this.getBusgrp().getCpdgrp().getBen().savRolPts(inr,"cpd","ben");
			this.getBusgrp().getCpdgrp().getAcw().savRolPts(inr,"cpd","acw");
			this.getBusgrp().getCpdgrp().getApl().savRolPts(inr,"cpd","apl");

			/**
			  单一窗口：根据cpd表cpdres判断
			  */
			String cid = this.getBusgrp().getBusinf().getClientid();
			String payact = this.getBusgrp().getCpdgrp().getRec().getPyeact();//汇入账号这个可能需要调整
			String cpdres = this.getBusgrp().getCpdgrp().getRec().getCpdres();
			if(!MdaUtils.isEmpty(cpdres)&&"D".equals(cpdres))
			{
			  Map map = new HashMap();
			  map.put("inr",this.getBusgrp().getCpdgrp().getRec().getInr());
			  map.put("OutBankStatus","");
			  map.put("TransId",this.getBusgrp().getCpdgrp().getRec().getTransid());
			  map.put("OutBankStatus","");
			  map.put("Reason","");
			  map.put("SendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss"));
			  map.put("ImgStatusAll","");
			  map.put("TransStatus","06");
			  String imgrefs = this.getBusgrp().getCpdgrp().getRec().getOwnref();
			  map.put("buscod",imgrefs);
			  map.put("djcod",imgrefs);
			  String sfs = "SFS113";
			  setMapSW(sfs,inr,"cpd",map,this.getBusgrp().getCpdgrp().getRec().getMsgref());
			}

			this.setFrmcod("cptout");
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇出汇款通知");
		}
        /**
        *   source:stlbod.@0048.script
        */
        public void  parseSTLT23_CPI(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT23_CPI-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("cpdgrp\\rec\\stlref");
			this.getBusgrp().getBusinf().setDstlref( (String)data.get("cpdgrp\\rec\\dstlref"));
			String dstlref = this.getBusgrp().getBusinf().getDstlref();
			Argument<String> inr = new Argument<String>("inr");
			List sptObjs=new ArrayList();
			if(!MdaUtils.isEmpty(dstlref))
			{
			  String sqll = "select max(inr) inr from cpd where dstlref='"+dstlref.toString()+"'";
			  ctx.getErrorCode();
			  ctx.getDaoSession().dbExecuteSQL(sqll);
			  ctx.getDaoSession().dbFetchFields(inr);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    log.info("{}","stlbod T2A CPT inr = "+inr.value);
			  }
			  ctx.getDaoSession().dbCloseCursor();
			}
			if(!MdaUtils.isEmpty(inr))
			{
			  IModule mod=MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  //汇入已确认标志
			  this.getBusgrp().getCpdgrp().getRec().setDty("A");
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			  //删除spt记录
			  MdaUtils.clear(this.getSptlst());
			  log.info("{}","ownref编号"+this.getBusgrp().getCpdgrp().getRec().getOwnref());
			  String sptOwnref=this.getBusgrp().getCpdgrp().getRec().getOwnref();
			  String sptselsql = "WHERE ((m1.sta='T' and m1.scr='S') or m1.sta='B') and m1.ownref= ?0 ";
			  if(!MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOwnref()))
			  {
			    sptObjs.add(sptOwnref);
			  }
			  ctx.getDaoSession().dbReadset(this.getSptlst(),sptselsql,sptObjs.toArray());
			  log.info("{}","spt条数"+this.getSptlst().size());
			  if(this.getSptlst().size()>0)
			  {
			    for(int i=0;i<this.getSptlst().size();i++){
			      ctx.getDaoSession().dbDelete(this.getSptlst().get(i));
			  }
			}
			}
			else
			{
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"cpdgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			this.getBusgrp().getCpdgrp().getRec().setInr(Platform.sdbCounter("cpd"));
			this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("IR"));
			this.getBusgrp().getCpdgrp().getRec().setStlref(this.getStlref());
			if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			  this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			this.getBusgrp().getCpdgrp().getRec().setDty("A");
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			this.setFrmcod("cptsub");
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇入汇款通知");
		}
        /**
        *   source:stlbod.@0049.script
        */
        public void  parseSTLT25_SGT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT25_SGT-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String stlref = (String)data.get("sgdgrp\\rec\\stlref");
			//$stlref.setValue((String )data.get("sgdgrp\\\\rec\\\\stlref"));
			this.setOwnref((String)data.get("sgdgrp\\rec\\ownref"));
			log.debug("{}","stlref="+this.getStlref()+",ownref=" + this.getOwnref());
			if(!MdaUtils.isEmpty(this.getOwnref())&&reloadDataByArg("sgd","ownref",this.getOwnref()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getSgdgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"sgdgrp\\rec"));
			  this.setFrmcod("sgtdav");
			  setBusinfFromStlbod(this.getBusgrp().getSgdgrp().getRec().getInr(),"sgd",this.getOwnref(),"提货担保通知");
			}
			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"sgdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getSgdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getSgdgrp().getRec().setInr(Platform.sdbCounter("sgd"));
			  this.getBusgrp().getSgdgrp().getRec().setOwnref(Platform.getRef("SG"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getSgdgrp().getRec().getBchcod()))
			    this.getBusgrp().getSgdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getSgdgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"sgdgrp\\rec"));
			  this.setFrmcod("sgtdav");
			  this.setOwnref(this.getBusgrp().getSgdgrp().getRec().getOwnref());
			  setBusinfFromStlbod(this.getBusgrp().getSgdgrp().getRec().getInr(),"sgd",this.getOwnref(),"提货担保通知");
			}
		}
        /**
        *   source:stlbod.@0050.script
        */
        public void  parseSTLT27_FFT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT27_FFT-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("fsdgrp\\rec\\stlref");
			//if(reloadDataByStlref("fsd",stlref.toString()))
			this.setOwnref((String)data.get("sfdgrp\\rec\\ownref"));
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  if(!MdaUtils.isEmpty(reloadData("fsd",this.getOwnref())))
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"fsdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getFsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getFsdgrp().getRec().setOpndat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"fsdgrp\\rec"));
			  }
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"fsdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getFsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getFsdgrp().getRec().setInr(Platform.sdbCounter("fsd"));
			  this.getBusgrp().getFsdgrp().getRec().setOwnref(Platform.getRef("FF"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getFsdgrp().getRec().getBchcod()))
			    this.getBusgrp().getFsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getFsdgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"fsdgrp\\rec"));
			}
			this.setFrmcod("fftdav");
			this.setOwnref(this.getBusgrp().getFsdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getFsdgrp().getRec().getInr(),"fsd",this.getOwnref(),"福费廷通知");
		}
        /**
        *   source:stlbod.@0051.script
        */
        public void  parseSTLT32_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT32_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object pntref=data.get("bedgrp\\rec\\pntref");
			Object stlref=data.get("bedgrp\\rec\\stlref");
			// $stlref.setValue((String)data.get("bedgrp\\\\rec\\\\stlref"));
			log.debug("{}","pntref="+pntref);
			log.debug("{}","stlref = "+this.getStlref());
			String bedinr = null;

			if(!MdaUtils.isEmpty(pntref))
			{

			  String strpntref = pntref.toString();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLedgrp().getRec(),new Argument<String>("stlref",strpntref));
			  if(!MdaUtils.isEmpty(this.getBusgrp().getLedgrp().getRec().getInr()))
			  {
			    String ledinr = this.getBusgrp().getLedgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    this.getBusgrp().getBedgrp().getApl().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getBen().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getIsb().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getRec().setIsscur(this.getBusgrp().getLedgrp().getRec().getLcccur());
			    this.getBusgrp().getBedgrp().getRec().setIssamt(this.getBusgrp().getLedgrp().getRec().getLccamt());
			  }
			}

			if(!MdaUtils.isEmpty(stlref) &&  reloadDataByStlref("bed",stlref.toString()))
			{
			  bedinr = this.getBusgrp().getBedgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","bed"),new Argument("objinr",bedinr ));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","bed"),new Argument("objinr",bedinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","bed"),new Argument("objinr",bedinr));
			  setModuleContent(data);
			  this.getBusgrp().getBedgrp().getRec().setAdvdat(MdaUtils.today());
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBedgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());

			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBcdgrp().getRec());

			}
			else
			{

			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBedgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  bedinr = Platform.sdbCounter("bed");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			  inr.setValue(bedinr);
			  this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			    this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBedgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));

			}
			this.getBusgrp().getBedgrp().getBen().savRolPts(bedinr,"bed","ben");
			this.getBusgrp().getBedgrp().getIsb().savRolPts(bedinr,"bed","isb");
			this.getBusgrp().getBedgrp().getApl().savRolPts(bedinr,"bed","apl");
			this.setFrmcod("betsnd");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"出口信用证下寄单通知");
		}
        /**
        *   source:stlbod.@0052.script
        */
        public void  parseSTLT32_IIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT32_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bcdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+ stlref);
			this.setStlref(stlref.toString());
			if(reloadDataByStlref("bcd",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBcdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getBcdgrp().getRec().setAcpcur(this.getBusgrp().getBcdgrp().getRec().getDoccur());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBcdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBcdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setInr(Platform.sdbCounter("bcd"));
			  this.getBusgrp().getBcdgrp().getRec().setDocflg("accept");
			  this.getBusgrp().getBcdgrp().getRec().setOwnref(Platform.getRef("IC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBcdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getBcdgrp().getRec().setAcpcur(this.getBusgrp().getBcdgrp().getRec().getDoccur());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBcdgrp().getRec());
			}
			this.setFrmcod("bctacc");
			this.setOwnref(this.getBusgrp().getBcdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBcdgrp().getRec().getInr(),"bcd",this.getOwnref(),"进口代收远期承兑通知");
		}
        /**
        *   source:stlbod.@0053.script
        */
        public void  parseSTLT40_IIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT40_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setOwnref((String)data.get("bcdgrp\\rec\\ownref"));
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("bcdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref = "+this.getStlref()+",ownref=" + this.getOwnref());
			String bcdinr=null;
			// if(!Platform.isEmpty($ownref))
			if((!MdaUtils.isEmpty(stlref)&& reloadDataByStlref("bcd",stlref) ) || (!MdaUtils.isEmpty(this.getOwnref()) && reloadDataByArg("bcd","ownref",this.getOwnref())) )
			{
			  // reloadData("bcd",$ownref.getValue());
			  bcdinr = this.getBusgrp().getBcdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBcdgrp().getRmi().getPts(),new Argument("rol","rmi"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBcdgrp().getDrr().getPts(),new Argument("rol","drr"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getBcdgrp().getDre().getPts(),new Argument("rol","dre"),new Argument("objtyp","bcd"),new Argument("objinr",bcdinr));
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBcdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setRcvdat(MdaUtils.today());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  bcdinr = Platform.sdbCounter("bcd");
			  this.getBusgrp().getBcdgrp().getRec().setInr(bcdinr);
			  IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\docflg");
			  docflg.setValue("docadv");
			  this.getBusgrp().getBcdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setOwnref(Platform.getRef("IC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBcdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			}
			//IDatafield bcdinr=Platform.getDatafield($\\bimenu,"bcdgrp\\\\rec\\\\inr");
			IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\inr");
			this.getBusgrp().getBcdgrp().getRmi().savRolPts(bcdinr,"bcd","rmi");
			this.getBusgrp().getBcdgrp().getDrr().savRolPts(bcdinr,"bcd","drr");
			this.getBusgrp().getBcdgrp().getDre().savRolPts(bcdinr,"bcd","dre");
			this.setFrmcod("bctdav");
			this.setOwnref(this.getBusgrp().getBcdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBcdgrp().getRec().getInr(),"bcd",this.getOwnref(),"进口代收项下到单通知");
		}
        /**
        *   source:stlbod.@0055.script
        */
        public void  parseSTLT44_GET(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_GET-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("gidgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			if(reloadDataByStlref("gid",stlref.toString()))
			{
			  log.debug("{}","gid inr="+this.getBusgrp().getGidgrp().getRec().getInr());
			  setModuleContent(data);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield ledinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\inr");
			  ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("GA"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getRec());
			}

			this.setFrmcod("gitcan");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"保函注销通知");
		}
        /**
        *   source:stlbod.@0058.script
        */
        public void  parseSTLT44_CTC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_CTC-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","lid stlref = "+stlref);
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(reloadDataByArg("lid","stlref",stlref.toString()))
			{
			  lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			  setModuleContent(data);
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  lidinr = Platform.sdbCounter("lid");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"lidgrp\\rec\\inr");
			  inr.setValue(lidinr);
			  this.getBusgrp().getLidgrp().getRec().setOwnref(Platform.getRef("LR"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getRec().getBchcod()))
			    this.getBusgrp().getLidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLidgrp().getApl().getPts().getRef()))
			  this.getBusgrp().getLidgrp().getApl().getPts().setRef(this.getBusgrp().getLidgrp().getRec().getStlref());
			this.getBusgrp().getLidgrp().getApl().savRolPts(lidinr,"lid","apl");
			this.getBusgrp().getLidgrp().getBen().savRolPts(lidinr,"lid","ben");
			this.getBusgrp().getLidgrp().getAdv().savRolPts(lidinr,"lid","adv");
			this.setFrmcod("litcan");
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"转递/保兑进口信用证注销通知");
		}
        /**
        *   source:stlbod.@0059.script
        */
        public void  setSptFromStlbod(String frmcod,String contractid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * create record SPT, ORD, ORE
			  */

			log.info("{}","in stlbody.createSpt...");
			this.getSpt().setInr(NULLSTR);
			//create record SPT
			log.info("{}","objtyp="+this.getBusgrp().getBusinf().getObjtyp());
			this.getSpt().setPtyinr(this.getPtyset().getCli().getInr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBnkinr()))
			  this.getSpt().setOprogninr(this.getBusgrp().getBusinf().getBnkinr());

			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  this.getSpt().setSmhinr(this.getSmh().getInr());
			}
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getOwnref()))
			{
			  this.getSpt().setOwnref( this.getBusgrp().getBusinf().getOwnref());
			}
			else
			{
			  this.getSpt().setOwnref("NOREF");
			}

			this.getSpt().setObjtyp( this.getBusgrp().getBusinf().getObjtyp());
			this.getSpt().setObjinr( this.getBusgrp().getBusinf().getObjinr());
			this.getSpt().setTrnamt( this.getBusgrp().getBusinf().getAmt());
			this.getSpt().setTrncur( this.getBusgrp().getBusinf().getCur());
			this.getSpt().setNam( this.getBusgrp().getBusinf().getClinam());
			if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClinam()))
			{
			  this.getTrn().setNam(this.getSpt().getTrncur()+"/" + this.getSpt().getTrnamt());
			}
			else
			{
			  String clinam = this.getBusgrp().getBusinf().getClinam();
			  if(clinam.length()>35)
			  {
			    clinam = clinam.substring(0,35);
			  }
			  this.getSpt().setNam(clinam);
			}
			this.getSpt().setFrm(frmcod);
			this.getSpt().setSta("T");
			this.getSpt().setScr("A");
			this.getSpt().setDattim(MdaUtils.today());
			this.getSpt().setInr(Platform.sdbCounter("spt"));
			ctx.getDaoSession().dbInsert(this.getSpt());
			log.debug("{}","SAV SPT {inr:" + this.getSpt().getInr() +",objinr:" + this.getSpt().getObjinr() + ",objtyp:"+ this.getSpt().getObjtyp() + ",smhinr:"+ this.getSpt().getSmhinr() + "}") ;
			if(!MdaUtils.isEmpty(contractid)&&!MdaUtils.isEmpty(frmcod)&&("gitdav".equals(frmcod)||"gitmav".equals(frmcod)))
			{
			  storeGitpushSpt(contractid);
			}
			// 保存 数据文件
			MdaUtils.clear(this.getGrpdata());
			IStream os = this.getGrpdata();
			String objtyp = this.getBusgrp().getBusinf().getObjtyp();
			IModule mod= MdaDriver.getModule(this.getBusgrp(),objtyp+"grp");
			MdaUtils.saveData(mod,os);
			String fileName = ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).createFilename(this.getSpt().getInr(),"bak");
			MdaUtils.streamSave(os,fileName);

			//noticeBySMSAndEmail($sysmod\\spt\\ptyinr.getValue(),$sysmod\\spt\\frm.getValue(),$sysmod\\spt\\smhinr.getValue());
			log.debug("{}","out stlbod.setSptFromStlbod ... ");
		}
        /**
        *   source:stlbod.@0060.script
        */
        public void  parseSTLT45_EIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT45_EIB-XML报文信息
			  @ 返回解析是否成功
			  */
			Object lcref=data.get("bodgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bod",lcref.toString()))
			{
			  //setModuleContent(data);
			  setBotdcrModuleContent(data);
			  this.getBusgrp().getBodgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bodgrp\\rec"));
			}
			else
			{
			  //setModuleContent(data);
			  setBotdcrModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBodgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bod"));
			  this.getBusgrp().getBodgrp().getRec().setOwnref(Platform.getRef("OC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bodgrp\\rec"));
			}
			//update the flag
			this.setFrmcod("botdcr");
			this.setOwnref(this.getBusgrp().getBodgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBodgrp().getRec().getInr(),"bod",this.getOwnref(),"出口托收项下单据拒付通知");
		}
        /**
        *   source:stlbod.@0061.script
        */
        public void  parseSTLT46_IIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT46_IIB-XML报文信息
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("bcdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("bcd",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBusgrp().getBcdgrp().getRec().setDocflg("retrej");
			    this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getBcdgrp().getRec().setInr(Platform.sdbCounter("bcd"));
			    this.getBusgrp().getBcdgrp().getRec().setDocflg("retrej");
			    this.getBusgrp().getBcdgrp().getRec().setOwnref(Platform.getRef("IC"));
			    if(MdaUtils.isEmpty(this.getBusgrp().getBcdgrp().getRec().getBchcod()))
			      this.getBusgrp().getBcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			  }

			}

			this.setFrmcod("bctdor");
			this.setOwnref(this.getBusgrp().getBcdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBcdgrp().getRec().getInr(),"bcd",this.getOwnref(),"进口代收项下拒付/退单通知");
		}
        /**
        *   source:stlbod.@0062.script
        */
        public void  parseSTLT54_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT54_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object lcref=data.get("bedgrp\\rec\\stlref");
			log.debug("{}","lcref="+lcref.toString());
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bed",lcref.toString()))
			{
			  setModuleContent(data);
			  //计算国外银费单据金额减去汇入金额
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getFncfee()))
			  {
			    BigDecimal b1 = this.getBusgrp().getBedgrp().getRec().getDocamt();
			    BigDecimal b2 = this.getBusgrp().getBedgrp().getRec().getDdamt();
			    this.getBusgrp().getBedgrp().getRec().setFncfee(b1.subtract(b2));
			    this.getBusgrp().getBedgrp().setFnccur(this.getBusgrp().getBedgrp().getRec().getDoccur());
			  }
			  this.getBusgrp().getBedgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  //计算国外银费单据金额减去汇入金额
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getFncfee()))
			  {
			    BigDecimal b1 = this.getBusgrp().getBedgrp().getRec().getDocamt();
			    BigDecimal b2 = this.getBusgrp().getBedgrp().getRec().getDdamt();
			    this.getBusgrp().getBedgrp().getRec().setFncfee(b1.subtract(b2));
			    this.getBusgrp().getBedgrp().setFnccur(this.getBusgrp().getBedgrp().getRec().getDoccur());
			  }
			  this.getBusgrp().getBedgrp().getRec().setDocflg("payment");
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bed"));
			  this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			    this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBedgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));
			}
			this.setFrmcod("betset");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"出口信用证项下收汇通知");
		}
        /**
        *   source:stlbod.@0063.script
        */
        public void  parseSTLT54_IIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT54_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object lcref=data.get("bcdgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bcd",lcref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBcdgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bcdgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bcd"));
			  this.getBusgrp().getBcdgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBcdgrp().getRec().setOwnref(Platform.getRef("IC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBcdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bcdgrp\\rec"));
			}
			this.setFrmcod("bctset");
			this.setOwnref(this.getBusgrp().getBcdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBcdgrp().getRec().getInr(),"bcd",this.getOwnref(),"进口代收付款通知");
		}
        /**
        *   source:stlbod.@0064.script
        */
        public void  parseSTLT54_EIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT54_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object lcref=data.get("bodgrp\\rec\\stlref");
			log.debug("{}","stlref = "+lcref.toString());
			this.setStlref(lcref.toString());
			if(reloadDataByStlref("bod",lcref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBodgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBrdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"bodgrp\\rec"));
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBodgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bodgrp\\rec\\inr");
			  inr.setValue(Platform.sdbCounter("bod"));
			  this.getBusgrp().getBodgrp().getRec().setDocflg("payment");
			  this.getBusgrp().getBodgrp().getRec().setOwnref(Platform.getRef("OC"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBodgrp().getRec().getBchcod()))
			    this.getBusgrp().getBodgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBodgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"bodgrp\\rec"));
			}

			this.setFrmcod("botset");
			this.setOwnref(this.getBusgrp().getBodgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBodgrp().getRec().getInr(),"bod",this.getOwnref(),"出口托收项下单据收汇通知");
		}
        /**
        *   source:stlbod.@0065.script
        */
        public void  parseSTLT62_GET(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT62_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			Object stlref = data.get("gidgrp\\rec\\advref");
			/* if(!Platform.isEmpty(stlref))
			  $stlref.setValue(stlref.toString()); */
			String gidinr=null;
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			this.getBusgrp().getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			  this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			this.getBusgrp().getGidgrp().getApl().savRolPts(gidinr,"gid","apl");
			this.getBusgrp().getGidgrp().getIsb().savRolPts(gidinr,"gid","isb");
			this.getBusgrp().getGidgrp().getBen().savRolPts(gidinr,"gid","ben");
			this.setFrmcod("gitrcv");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"收到保函通知");
		}
        /**
        *   source:stlbod.@0066.script
        */
        public void  parseSTLT63_GET(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT63_GET-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("gidgrp\\rec\\stlref");
			String gidinr= null;
			// $ownref.setValue(stlref.toString());
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("gid",stlref.toString()))
			  {
			    gidinr = this.getBusgrp().getGidgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			    setModuleContent(data);
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			    this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			    if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			      this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  }
			  this.setFrmcod("gitmcv");
			  this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			  setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"收到保函修改通知");
			}

		}
        /**
        *   source:stlbod.@0067.script
        */
        public void  parseSTLT67_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT67_GIT-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("gidgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			{
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("gid",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  }
			  else
			  {
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			    this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			    if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			      this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  }

			  this.setFrmcod("gitmav");
			  this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			  setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"保函修改通知");

			}

		}
        /**
        *   source:stlbod.@0068.script
        */
        public void  parseSTLT68_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT68_GIT-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("gidgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			/*if(!Platform.isEmpty(stlref))
			  $stlref.setValue(stlref.toString());*/
			this.setOwnref((String)data.get("gidgrp\\rec\\ownref"));
			log.debug("{}","stlref="+ this.getStlref() +",ownref=" + this.getOwnref());
			String gidinr="";

			//Opening under a guarentee
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  //the first application,use ownref,after use stlref
			  log.debug("{}","i got you,ownref="+this.getOwnref());
			  reloadData("gid",this.getOwnref());
			  gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			  /*
			    String etyinr = $busgrp\\gidgrp\\rec\\etyinr.getValue();
			    String opntyp = $busgrp\\gidgrp\\rec\\opntyp.getValue();
			    String ptyinr = $busgrp\\gidgrp\\rec\\ptyinr.getValue();
			    String opntyp2 = $busgrp\\gidgrp\\rec\\opntyp2.getValue();
			    String wbtyp = $busgrp\\gidgrp\\rec\\wbtyp.getValue();
			    log.debug("etyinr = " + etyinr + "; opntyp = " + opntyp + "; ptyinr = " + ptyinr+ "; opntyp2 = " + opntyp2+ "; wbtyp = " + wbtyp );
			    */
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));

			  this.getBusgrp().getGidgrp().getGib().setInr(gidinr);
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getGib(),new Argument("inr",this.getBusgrp().getGidgrp().getGib().getInr()));
			  /*
			    String gibptyinr = $busgrp\\gidgrp\\gib\\ptyinr.getValue();
			    String gibwbtyp = $busgrp\\gidgrp\\gib\\wbtyp.getValue();
			    String giblgtyp = $busgrp\\gidgrp\\gib\\lgtyp.getValue();
			    $busgrp\\gidgrp\\gib\\ptyinr.setValue(gibptyinr);
			    $busgrp\\gidgrp\\gib\\wbtyp.setValue(gibwbtyp);
			    $busgrp\\gidgrp\\gib\\lgtyp.setValue(giblgtyp);
			
			    Platform.dbRead($busgrp\\gidgrp\\rec,new Argument("inr",gidinr));
			    Platform.dbRead($busgrp\\gidgrp\\gib,new Argument("inr",gidinr));
			    String gidetyinr = $busgrp\\gidgrp\\rec\\etyinr.getValue();
			    String gidopntyp = $busgrp\\gidgrp\\rec\\opntyp.getValue();
			    String gidptyinr = $busgrp\\gidgrp\\rec\\ptyinr.getValue();
			    String gidopntyp2 = $busgrp\\gidgrp\\rec\\opntyp2.getValue();
			    String gidwbtyp = $busgrp\\gidgrp\\rec\\wbtyp.getValue();
			    String lgtxt = $busgrp\\gidgrp\\gib\\lgtxt.getValue();
			    log.debug("etyinr = " + gidetyinr + "; opntyp = " + gidopntyp + "; ptyinr = " + gidptyinr+ "; opntyp2 = " + gidopntyp2+ "; wbtyp = " + gidwbtyp );
			    log.debug("lgtxt" + $busgrp\\gidgrp\\gib\\lgtxt.getValue());
			    */
			  setModuleContent(data);
			  this.getBusgrp().getGidgrp().getRec().setFlg("2");
			  this.getBusgrp().getGidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  /*
			    $busgrp\\gidgrp\\rec\\etyinr.setValue(gidetyinr);
			    $busgrp\\gidgrp\\rec\\opntyp.setValue(gidopntyp);
			    $busgrp\\gidgrp\\rec\\ptyinr.setValue(gidptyinr);
			    $busgrp\\gidgrp\\rec\\opntyp2.setValue(gidopntyp2);
			    $busgrp\\gidgrp\\rec\\wbtyp.setValue(gidwbtyp);
			    */
			  log.debug("{}","etyinr = " + this.getBusgrp().getGidgrp().getRec().getEtyinr() + "; opntyp = " + this.getBusgrp().getGidgrp().getRec().getOpntyp() + "; ptyinr = " + this.getBusgrp().getGidgrp().getRec().getPtyinr()+ "; opntyp2 = " + this.getBusgrp().getGidgrp().getRec().getOpntyp2()+ "; wbtyp = " + this.getBusgrp().getGidgrp().getRec().getWbtyp() );
			  log.debug("{}","lgtxt" + this.getBusgrp().getGidgrp().getGib().getLgtxt());
			  //Platform.dbUpdate($busgrp\\gidgrp\\gib);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\gib"));

			}
			else
			{
			  //create a new record
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  //IDatafield ledinr=Platform.getDatafield($\\bimenu\\,"gidgrp\\\\rec\\\\inr");
			  //ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));

			  gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			}
			this.getBusgrp().getGidgrp().getApl().savRolPts(gidinr,"gid","apl");
			this.getBusgrp().getGidgrp().getBen().savRolPts(gidinr,"gid","ben");
			this.setFrmcod("gitdav");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"保函开立通知");

		}
        /**
        *   source:stlbod.@0069.script
        */
        public void  parseSTLT74_AKA(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT74_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("lidgrp\\rec\\stlref");
			log.debug("{}","lid stlref = "+stlref);
			this.setStlref(stlref.toString());
			String lidinr = null;
			if(!reloadDataByArg("lid","stlref",stlref.toString()))
			{
			  Platform.setErrorInfo(resMsg,"10001","cannot find the corresponding reference");
			  return ;
			}
			lidinr = this.getBusgrp().getLidgrp().getRec().getInr();
			setModuleContent(data);
			ctx.getDaoSession().dbRead(this.getBusgrp().getLidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","lid"),new Argument("objinr",lidinr));
			this.getBusgrp().getLidgrp().getRec().setAdvdat(MdaUtils.today());
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"lidgrp\\rec"));
			ctx.getDaoSession().dbReadset(this.getBusgrp().getBrdlst(),new Argument("pntstlref",stlref.toString()));
			for(int i=0;i<this.getBusgrp().getBrdlst().fullSize();i++)
			{
			  this.getBusgrp().getBrdlst().getElement(i).setClsdat(this.getBusgrp().getLidgrp().getRec().getClsdat());
			  ctx.getDaoSession().dbUpdate(this.getBusgrp().getBrdlst().getElement(i));
			}
			this.setOwnref(this.getBusgrp().getLidgrp().getRec().getOwnref());
			this.setFrmcod("litcan");
			setBusinfFromStlbod(this.getBusgrp().getLidgrp().getRec().getInr(),"lid",this.getOwnref(),"开证撤销通知");

		}
        /**
        *   source:stlbod.@0070.script
        */
        public void  parseSTLT85_FBT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT85_FBT-XML报文信息-
			  @ 返回解析是否成功
			  */
			log.debug("{}","into T85");
			this.setOwnref((String)data.get("fcdgrp\\rec\\ownref"));
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			log.debug("{}","m1/ownref="+this.getOwnref());
			String fcdinr =null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  fcdinr=reloadData("fcd",this.getOwnref());
			  setModuleContent(data);
			  this.getBusgrp().getFcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getFcdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"fcdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getFcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getFcdgrp().getRec().setInr(Platform.sdbCounter("fcd"));
			  this.getBusgrp().getFcdgrp().getRec().setOwnref(Platform.getRef("FS"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getFcdgrp().getRec().getBchcod()))
			    this.getBusgrp().getFcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getFcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getFcdgrp().getRec());
			}
			Object dir=data.get("fcdgrp\\rec\\fxflg");
			this.setOwnref(this.getBusgrp().getFcdgrp().getRec().getOwnref());
			log.debug("{}","dir==="+dir.toString());
			if(!MdaUtils.isEmpty(dir.toString()))
			{
			  log.debug("{}",dir.toString());

			  //结汇
			  if("0".equals(dir.toString().trim()))
			  {
			    log.info("{}","444444444444="+dir.toString());
			    this.setFrmcod("fxisdv");
			    setBusinfFromStlbod(this.getBusgrp().getFcdgrp().getRec().getInr(),"fcd",this.getOwnref(),"即期结汇通知");
			  }
			  //售汇
			  if("1".equals(dir.toString().trim()) || "3".equals(dir.toString().trim()))
			  {
			    this.setFrmcod("fxibdv");
			    setBusinfFromStlbod(this.getBusgrp().getFcdgrp().getRec().getInr(),"fcd",this.getOwnref(),"即期购汇/套汇/转账通知");
			  }
			  //套汇
			  if("2".equals(dir.toString().trim()))
			  {
			    this.setFrmcod("fxibdv");
			    setBusinfFromStlbod(this.getBusgrp().getFcdgrp().getRec().getInr(),"fcd",this.getOwnref(),"即期购汇/套汇/转账通知");
			  }
			}

		}
        /**
        *   source:stlbod.@0071.script
        */
        public void  doFiles(Map obj)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  将xmlfil（面函）、tcofil（报文）、sw2fil（报文草稿）三类文件存入smh表
			  其中，面函需要在attach.properties中找到对的配置项才能入库，不然会被过滤
			  */
			Map<String,String> fnames=(Map<String,String>)obj;
			ArrayList<String> xmlfils = new ArrayList<String>(2);
			ArrayList<String> sw2fils = new ArrayList<String>(3);
			//fnames中键值为文件名（例：15083232.xml），value为面函名（例：进口信用证项下到单通知书）
			for(String fnam:fnames.keySet())
			{
			  log.info("{}",fnam);
			  if(fnam.indexOf(",")>=0  ||  fnam.indexOf(";")>=0)
			  {
			    log.info("{}","error file!can not handle");
			    continue;
			  }
			  if(fnam.endsWith(".lst"))
			  {
			    this.getSmh().setLstfil(fnam);
			    String filename =fnam.substring(0,fnam.indexOf("."));
			    this.getSmh().setTcofil(filename+".xml");
			  }
			  /*
			    * 日期：20230525
			    * 需求号：R22081176
			    * 描述：解析报文时，如果文件是pdf格式，并且是承付/拒付通知书，则存smh表;
			    */
			  if(fnam.endsWith(".sw2")|| ((fnam.endsWith(".pdf")||fnam.endsWith(".PDF")) && !("承付/拒付通知书".equals((String)fnames.get(fnam)))))
			    sw2fils.add(fnam);
			  if(fnam.endsWith(".xml") || ((fnam.endsWith(".pdf")||fnam.endsWith(".PDF")) && ("承付/拒付通知书".equals((String)fnames.get(fnam)))))
			    xmlfils.add(fnam);
			}
			int sw2cnt = sw2fils.size();
			log.debug("{}","have "+sw2cnt+" sw2 files");
			//sw2文件名称保存
			StringBuffer sw2Val = new StringBuffer(40);
			String split="";
			for(String fnam:sw2fils)
			{
			  sw2Val.append(split);
			  sw2Val.append(fnam);
			  split=";";
			}
			this.getSmh().setSf2fil(sw2Val.toString());
			//xml文件名称保存
			int xmlcnt = xmlfils.size();
			log.debug("{}","have "+xmlcnt+" xml files");
			//load attach.properties
			String filepath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/attach.properties");
			log.debug("{}","filepath:" + filepath);
			if(!MdaUtils.fileExists(filepath))
			{
			  log.debug("{}","stlbod.0071:找不到配置文件！");
			  return;
			}
			String desc=null; //配置文件中取出的面函名称
			String frm = this.getFrmcod();
			StringBuffer xmlVal = new StringBuffer(30);
			StringBuffer labelVal = new StringBuffer(30);
			split="";//xmlfil、labels分隔符
			int attlen = 4; //文件中配置的面函个数
			log.debug("{}","attlen:" + attlen);
			for(String fnam:xmlfils)
			{
			  log.debug("{}","fnam："+fnames.get(fnam));
			  for(int i=0;i<attlen;i++)
			  {
			    desc=MdaUtils.getPropertyValue(filepath,frm+"."+i);
			    log.debug("{}",i+"desc "+desc);
			    //若文件中配置有，且和国结传来的面函名称相同则入库(确认国结的面函名称)
			    if(desc!=null&&desc.equals(fnames.get(fnam)))
			    {
			      desc=MdaUtils.getPropertyValue(filepath,frm+"."+i+".img");
			      if(desc==null || MdaUtils.isEmpty(desc))
			      {
			        desc=MdaUtils.getPropertyValue(filepath,"DefaultAdvImage");
			      }
			      log.debug("{}",i+"desc:"+desc);
			      xmlVal.append(split);
			      xmlVal.append(fnam);
			      labelVal.append(split);
			      labelVal.append(desc);
			      split=";";
			    }
			  }

			  this.getSmh().setXmlfil(xmlVal.toString());
			  this.getSmh().setLabels(labelVal.toString());
			}
			log.debug("{}","smh.xmlfil="+this.getSmh().getXmlfil());
			log.debug("{}","smh.tcofil="+this.getSmh().getTcofil());
			log.debug("{}","smh.sf2fil="+this.getSmh().getSf2fil());
			log.debug("{}","smh.lstfil="+this.getSmh().getLstfil());
			log.debug("{}","handle file over...");
		}
        /**
        *   source:stlbod.@0072.script
        */
        public void  smhWrite(Map fileMap)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 存储SMH记录
			  */
			log.info("{}","smhWrite...");

			doFiles(fileMap); // smh报文文件名赋值
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getObjtyp()))
			  this.getSmh().setObjtyp(this.getBusgrp().getBusinf().getObjtyp());
			else
			  this.getSmh().setObjtyp("");
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getObjinr()))
			  this.getSmh().setObjinr(this.getBusgrp().getBusinf().getObjinr());
			else
			  this.getSmh().setObjinr("");
			this.getSmh().setMsgtyp("1");
			this.getSmh().setMsgsta("1");
			String docpath=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data/backup/arc");
			docpath=MdaUtils.catPath(docpath,MdaUtils.format(MdaUtils.today(),"yyyyMMdd"));
			log.debug("{}","arc");
			this.getSmh().setDocpth(docpath);
			this.getSmh().setDir("I");
			this.getSmh().setCreusr(this.getImginr());
			this.getSmh().setResnum(this.getBusgrp().getBusinf().getResnum());
			this.getSmh().setCredattim(MdaUtils.today());
			this.getSmh().setInr(Platform.sdbCounter("smh"));
			this.getSmh().setF20(this.getBusgrp().getBusinf().getOwnref());
			this.getSmh().setF21(this.getBusgrp().getBusinf().getStlref());
			log.debug("{}","f20==============="+this.getBusgrp().getBusinf().getOwnref());
			log.debug("{}","f21==============="+this.getBusgrp().getBusinf().getStlref());
			ctx.getDaoSession().dbInsert(this.getSmh());
			log.info("{}","smhWrite...end");

		}
        /**
        *   source:stlbod.@0073.script
        */
        public void bioOrdCreate()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getOrdmod().createOrdAndOre("银行端收报","01");
		}
        /**
        *   source:stlbod.@0079.script
        */
        public void setTrnState()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String objinr=this.getBusgrp().getBusinf().getObjinr();
			String objtyp=this.getBusgrp().getBusinf().getObjtyp();
			String stlref=this.getBusgrp().getBusinf().getStlref();
			String ptyinr=this.getSpt().getOprogninr();
			String cliptyinr=this.getSpt().getPtyinr();
			String[] list=null;
			String file=MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg/relation.properties");
			String apltrn=MdaUtils.getPropertyValue(file,this.getFrmcod());
			if(MdaUtils.isEmpty(apltrn))
			  return;
			else
			  list=apltrn.split(",");
			log.info("{}","objinr="+objinr+",objtyp="+objtyp+",apltrn="+apltrn);
			String frms=ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).toSqlString(list);
			Argument<String> inr=new Argument<String>("inr");
			String sql="SELECT inr FROM trn WHERE objinr='"+objinr+"' AND objtyp='"+objtyp+"' AND inifrm IN ("+frms+")";
			ctx.getDaoSession().dbExecuteSQL(sql);
			while(true)
			{
			  ctx.getDaoSession().dbFetchFields(inr);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    ctx.getDaoSession().dbRead(this.getTrn(),new Argument<String>("inr",inr.value));
			    if(MdaUtils.isEmpty(this.getTrn().getInr()))
			      continue;
			    log.info("{}","trn to be updated inr="+this.getTrn().getInr());
			    this.getTrn().setStlref(stlref);
			    this.getTrn().setSta("A");
			    ctx.getDaoSession().dbUpdate(this.getTrn());
			    if("G".equals(this.getTrn().getWfm()))
			    {
			      ctx.getDaoSession().dbRead(this.getGrn(),new Argument<String>("objinr",this.getTrn().getInr()),new Argument<String>("gidsta","OD"));
			      if(!MdaUtils.isEmpty(this.getGrn().getInr()))
			      {
			        if(MdaUtils.isEmpty(this.getGitpush().getInr()))
			          this.getGrn().setGidsta("OF");
			        else
			          this.getGrn().setGidsta("OS");
			        ctx.getDaoSession().dbUpdate(this.getGrn());
			      }
			      MdaUtils.clear(this.getGrn());
			    }
			    MdaUtils.clear(this.getTrn());
			  }
			  else
			    break;
			}
			ctx.getDaoSession().dbCloseCursor();
		}
        /**
        *   source:stlbod.@0080.script
        */
        public void addNoticeWorkflow(com.ceb.gjjs.mda.bo.Spt spt ,String frmcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 注册工作流接口：可调用共用函数或者客户化实现
			IModule mod= MdaDriver.getModule(ctx.getRoot(),"xmlbod");
			//Platform.invoke(mod,"setNoticeWorkflow",$$spt, frmcod,"0");
			MdaUtils.invoke(mod,"setNoticeWorkflow",spt,frmcod,"1");//短信邮件手机使用新工作流
					}
        /**
        *   source:stlbod.@0081.script
        */
        public void  parseSTLT08_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT32_EAB-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("bedgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			Object pntref=data.get("bedgrp\\rec\\pntstlref");

			log.debug("{}","pntref="+pntref);

			if(!MdaUtils.isEmpty(pntref))
			{
			  String strpntref = pntref.toString();
			  this.getBusgrp().getLedgrp().getRec().setCredat(MdaUtils.today());
			  ctx.getDaoSession().dbRead(this.getBusgrp().getLedgrp().getRec(),new Argument<String>("stlref",strpntref));
			  if(!MdaUtils.isEmpty(this.getBusgrp().getLedgrp().getRec().getInr()))
			  {
			    String ledinr = this.getBusgrp().getLedgrp().getRec().getInr();
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getBedgrp().getIsb().getPts(),new Argument("rol","isb"),new Argument("objtyp","led"),new Argument("objinr",ledinr));
			    this.getBusgrp().getBedgrp().getApl().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getBen().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getIsb().getPts().setInr("");
			    this.getBusgrp().getBedgrp().getRec().setIsscur(this.getBusgrp().getLedgrp().getRec().getLcccur());
			    this.getBusgrp().getBedgrp().getRec().setIssamt(this.getBusgrp().getLedgrp().getRec().getLccamt());
			  }
			}
			setModuleContent(data);
			IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\ptyinr");
			ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			  this.getBusgrp().getBedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			IDatafield docflg=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\docflg");
			docflg.setValue("docadv");
			this.getBusgrp().getBedgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			String bedinr = Platform.sdbCounter("bed");
			IDatafield inr=MdaDriver.getDatafield(this.getBusgrp(),"bedgrp\\rec\\inr");
			inr.setValue(bedinr);
			this.getBusgrp().getBedgrp().getRec().setOwnref(Platform.getRef("BP"));
			if(MdaUtils.isEmpty(this.getBusgrp().getBedgrp().getRec().getBchcod()))
			  this.getBusgrp().getBedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			this.getBusgrp().getBedgrp().getRec().setCredat(MdaUtils.today());
			ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"bedgrp\\rec"));
			this.getBusgrp().getBedgrp().getBen().savRolPts(bedinr,"bed","ben");
			this.getBusgrp().getBedgrp().getIsb().savRolPts(bedinr,"bed","isb");
			this.getBusgrp().getBedgrp().getApl().savRolPts(bedinr,"bed","apl");
			this.setFrmcod("betddv");
			this.setOwnref(this.getBusgrp().getBedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBedgrp().getRec().getInr(),"bed",this.getOwnref(),"预审单通知");
		}
        /**
        *   source:stlbod.@0082.script
        */
        public void  parseSTLT44_EAB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_EAB-XML报文信息
			  @ 返回解析是否成功
			  */

			Object stlref = data.get("ledgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			if(reloadDataByStlref("led",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getLedgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLedgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  this.getBusgrp().getLedgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLedgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getLedgrp().getRec().setInr(Platform.sdbCounter("led"));
			  this.getBusgrp().getLedgrp().getRec().setOwnref(Platform.getRef("BP"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getLedgrp().getRec().getBchcod()))
			    this.getBusgrp().getLedgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getLedgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLedgrp().getRec());
			}
			this.setFrmcod("letcan");
			this.setOwnref(this.getBusgrp().getLedgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLedgrp().getRec().getInr(),"led",this.getOwnref(),"出口信用证注销通知");

		}
        /**
        *   source:stlbod.@0083.script
        */
        public void  parseSTLT44_SGT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_SGT-XML报文信息-
			  @ 返回解析是否成功
			  */

			Object stlref = data.get("sgdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			if(reloadDataByStlref("sgd",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getSgdgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getSgdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  this.getBusgrp().getSgdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getSgdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getSgdgrp().getRec().setInr(Platform.sdbCounter("sgd"));
			  this.getBusgrp().getSgdgrp().getRec().setOwnref(Platform.getRef("SG"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getSgdgrp().getRec().getBchcod()))
			    this.getBusgrp().getSgdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getSgdgrp().getRec().setCredat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getSgdgrp().getRec());
			}
			this.setFrmcod("sgtcan");
			this.setOwnref(this.getBusgrp().getSgdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getSgdgrp().getRec().getInr(),"sgd",this.getOwnref(),"提货担保注销通知");

		}
        /**
        *   source:stlbod.@0084.script
        */
        public void  parseSTLT44_IIB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_IIB-XML报文信息-
			  @ 返回解析是否成功
			  */

			Object stlref = data.get("bcdgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			if(reloadDataByStlref("bcd",stlref.toString()))
			{
			  setModuleContent(data);
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getBcdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  this.getBusgrp().getBcdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getBcdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getBcdgrp().getRec().setOwnref(Platform.getRef("IC"));
			  this.getBusgrp().getBcdgrp().getRec().setInr(Platform.sdbCounter("bcd"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getBcdgrp().getRec().getBchcod()))
			    this.getBusgrp().getBcdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getBcdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getBcdgrp().getRec());
			}
			this.setFrmcod("bctcan");
			this.setOwnref(this.getBusgrp().getBcdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getBcdgrp().getRec().getInr(),"bcd",this.getOwnref(),"进口代收注销通知");
		}
        /**
        *   source:stlbod.@0085.script
        */
        public void  parseSTLD10_EBB(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTD10_EBB_XML报文信息 - 针对商行发起的自主开证业务，需要更新STLREF
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String ownref = (String)data.get("dedgrp\\rec\\ownref");
			String stlref = (String)data.get("dedgrp\\rec\\stlref");
			log.debug("{}","ownref=" + ownref + ",stlref=" + stlref);
			if(!MdaUtils.isEmpty(ownref))
			{
			  String inr= reloadData( "did", ownref);
			  if(!MdaUtils.isEmpty(inr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getDidgrp().getRec(),new Argument<String>("inr",inr));
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      log.trace("{}","update did stlref =" + stlref );
			      this.getBusgrp().getDidgrp().getRec().setStlref(stlref);
			      this.getBusgrp().getDidgrp().getRec().setAdvdat(MdaUtils.today());
			      ctx.getDaoSession().dbUpdate(this.getBusgrp().getDidgrp().getRec());
			    }
			  }
			  else
			  {
			    if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    {
			      Platform.setErrorInfo(resMsg,"11001","非单证通发起的业务");
			    }
			  }
			}

		}
        /**
        *   source:stlbod.@0086.script
        */
        public void  parseSTLT44_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT44_GET-XML报文信息-
			  @ 返回解析是否成功
			  */
			Object stlref = data.get("gidgrp\\rec\\stlref");
			if(!MdaUtils.isEmpty(stlref))
			  this.setStlref(stlref.toString());
			if(reloadDataByStlref("gid",stlref.toString()))
			{
			  log.debug("{}","gid inr="+this.getBusgrp().getGidgrp().getRec().getInr());
			  setModuleContent(data);
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  IDatafield ledinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\inr");
			  ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getRec());
			}

			this.setFrmcod("gitcan");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"保函注销通知");
		}
        /**
        *   source:stlbod.@0087.script
        */
        public String checkAndSubDocflg(String docflg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 如果拒付原因长度大于60，截取前60个字节
			int count = 0;
			for (int i = 0; i < docflg.length(); i++)
			{
			  String temp = docflg.substring(i, i + 1);
			  if (temp.matches("[\\u4E00-\\u9FFF]"))
			    count += 3;
			  else
			    count += 1;
			  if (count > 60)
			  {
			    docflg = docflg.substring(0, i);
			    log.debug("{}","docflg after substring:" + docflg);
			    return docflg;
			  }
			}
			return docflg;
		}
        /**
        *   source:stlbod.@0088.script
        */
        public void setDocflgContent(Map<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","the stlbod.setDocflgContent method!");
			for(String key:data.keySet())
			{
			  if("bodgrp\\rec\\docflg".equals(key))
			  {
			    String docflg = (String)data.get(key);
			    docflg = checkAndSubDocflg(docflg);
			    log.debug("{}","docflg**********" + docflg);
			    this.getBusgrp().getBodgrp().getRec().setDocflg(docflg);
			    break;
			  }
			}
		}
        /**
        *   source:stlbod.@0089.script
        */
        public void setBotdcrModuleContent(Map<String,Object> data)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","the stlbod.setBotdcrModuleContent method!");
			for(String key:data.keySet())
			{
			  log.debug("{}","name=" +key+"  value=" +data.get(key));
			  if(!"fileMap".equals(key))
			  {
			    if("bodgrp\\rec\\docflg".equals(key))
			    {
			      String docflg = (String)data.get(key);
			      docflg = checkAndSubDocflg(docflg);
			      log.debug("{}","the value of $docflg before setVale():" + docflg);
			      this.getBusgrp().getBodgrp().getRec().setDocflg(docflg);
			      log.debug("{}","the value of $docflg after setVale():" + this.getBusgrp().getBodgrp().getRec().getDocflg());
			    }
			    else
			    {
			      IDatafield datafield=MdaDriver.getDatafield(this.getBusgrp(),key);
			      datafield.setValue(data.get(key));
			    }
			  }
			}
		}
        /**
        *   source:stlbod.@0090.script
        */
        public void  parseSTLT15_BPC(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT15-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTLT15_BPC .... ") ;
			//  $stlref.setValue((String)data.get("lidgrp\\\\rec\\\\stlref"));
			this.setOwnref((String)data.get("apdgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("apdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			// 1. 存储报文信息
			String apdinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  apdinr=reloadData("apd",this.getOwnref());
			  if(!MdaUtils.isEmpty(apdinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getApdgrp().getDap().getPts(),new Argument("rol","dap"),new Argument("objtyp","apd"),new Argument("objinr",apdinr));
			    setModuleContent(data);
			    if(MdaUtils.isEmpty(this.getBusgrp().getApdgrp().getRec().getDbchcod()))
			      this.getBusgrp().getApdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getApdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getApdgrp().getRec().setAdvdat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getApdgrp().getRec());
			  }
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getApdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getApdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getApdgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  apdinr = Platform.sdbCounter("apd");
			  this.getBusgrp().getApdgrp().getRec().setInr(apdinr);
			  this.getBusgrp().getApdgrp().getRec().setOwnref(Platform.getRef("IF"));
			  this.getBusgrp().getApdgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getApdgrp().getRec());
			}
			this.getBusgrp().getApdgrp().getDap().savRolPts(apdinr,"apd","dap");
			//2.设置 BUSINF字段值
			this.setFrmcod("irfadv");
			this.setOwnref(this.getBusgrp().getApdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getApdgrp().getRec().getInr(),"apd",this.getOwnref(),"进口代付通知");

		}
        /**
        *   source:stlbod.@0091.script
        */
        public void  parseSTL720_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT700-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTL720 .... ") ;
			//  $stlref.setValue((String)data.get("lidgrp\\\\rec\\\\stlref"));
			this.setOwnref((String)data.get("ltdgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("ltdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			// 1. 存储报文信息
			String ltdinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  ltdinr=reloadData("ltd",this.getOwnref());
			  if(!MdaUtils.isEmpty(ltdinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLtdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","ltd"),new Argument("objinr",ltdinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLtdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","ltd"),new Argument("objinr",ltdinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getLtdgrp().getAdv().getPts(),new Argument("rol","adv"),new Argument("objtyp","ltd"),new Argument("objinr",ltdinr));
			    setModuleContent(data);

			    if(MdaUtils.isEmpty(this.getBusgrp().getLtdgrp().getRec().getBchcod()))
			      this.getBusgrp().getLtdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getLtdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getLtdgrp().getRec());
			    //$\\sysmod.sdbUpdate($busgrp\\lidgrp\\blk);
			  }
			  else
			  {
			    Platform.setErrorInfo(resMsg,"110","");
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getLtdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getLtdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getLtdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  ltdinr = Platform.sdbCounter("ltd");
			  this.getBusgrp().getLtdgrp().getRec().setInr(ltdinr);
			  this.getBusgrp().getLtdgrp().getRec().setOwnref(Platform.getRef("LT"));
			  //$busgrp\\ltdgrp\\rec\\advdat=Platform.today();
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getLtdgrp().getRec());

			}
			if(MdaUtils.isEmpty(this.getBusgrp().getLtdgrp().getApl().getPts().getRef()))
			  //$busgrp\\ltdgrp\\apl\\pts\\ref.setValue($busgrp\\ltdgrp\\rec\\stlref.getValue());
			this.getBusgrp().getLtdgrp().getBen().savRolPts(ltdinr,"ltd","ben");
			this.getBusgrp().getLtdgrp().getAdv().savRolPts(ltdinr,"ltd","adv");
			this.getBusgrp().getLtdgrp().getApl().savRolPts(ltdinr,"ltd","apl");
			//2.设置 BUSINF字段值
			this.setFrmcod("lttdav");
			this.setOwnref(this.getBusgrp().getLtdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getLtdgrp().getRec().getInr(),"ltd",this.getOwnref(),"转让信用证开立通知");

		}
        /**
        *   source:stlbod.@0093.script
        */
        public void  parseSTLJ21_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT700-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTLJ21 .... ") ;
			this.setOwnref((String)data.get("jsdgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("jsdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			// 1. 存储报文信息
			String jsdinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  jsdinr=reloadData("jsd",this.getOwnref());
			  if(!MdaUtils.isEmpty(jsdinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getJsdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","jsd"),new Argument("objinr",jsdinr));
			    setModuleContent(data);
			    if(MdaUtils.isEmpty(this.getBusgrp().getJsdgrp().getRec().getBchcod()))
			      this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getJsdgrp().getRec().setAdvdat(MdaUtils.today());
			    this.getBusgrp().getJsdgrp().getRec().setPaysta("0");

			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getJsdgrp().getRec());
			  }
			  else
			  {
			    Platform.setErrorInfo(resMsg,"110","");
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getJsdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());

			  if(MdaUtils.isEmpty(this.getBusgrp().getJsdgrp().getRec().getAmt()))
			  {
			    if("CNY".equals(this.getBusgrp().getJsdgrp().getRec().getSelcur()))
			    {
			      this.getBusgrp().getJsdgrp().getRec().setCur(this.getBusgrp().getJsdgrp().getRec().getBuycur());
			      this.getBusgrp().getJsdgrp().getRec().setAmt(this.getBusgrp().getJsdgrp().getRec().getBuyamt());
			    }
			    else
			    {
			      this.getBusgrp().getJsdgrp().getRec().setCur(this.getBusgrp().getJsdgrp().getRec().getSelcur());
			      this.getBusgrp().getJsdgrp().getRec().setAmt(this.getBusgrp().getJsdgrp().getRec().getSelamt());
			    }
			  }

			  jsdinr = Platform.sdbCounter("jsd");
			  this.getBusgrp().getJsdgrp().getRec().setInr(jsdinr);
			  this.getBusgrp().getJsdgrp().getRec().setOwnref(Platform.getRef("JS"));
			  this.getBusgrp().getJsdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getJsdgrp().getRec().setPaysta("0");
			  this.getBusgrp().getJsdgrp().getRec().setPaytim("0");

			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getJsdgrp().getRec());
			}
			this.getBusgrp().getJsdgrp().getApl().savRolPts(jsdinr,"jsd","apl");
			//2.设置 BUSINF字段值
			this.setFrmcod("jstdav");
			this.setOwnref(this.getBusgrp().getJsdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getJsdgrp().getRec().getInr(),"jsd",this.getOwnref(),"大额结售汇签约申请通知");

		}
        /**
        *   source:stlbod.@0094.script
        */
        public void  parseSTLJ23_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT700-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTLJ23 .... ") ;
			this.setOwnref((String)data.get("jsdgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("jsdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());
			log.debug("{}","stlref   11="+stlref);
			// 1. 存储报文信息
			String jsdinr = null;
			if(reloadDataByStlref("jsd",this.getStlref()))
			{
			  jsdinr=this.getBusgrp().getJsdgrp().getRec().getInr();

			  ctx.getDaoSession().dbRead(this.getBusgrp().getJsdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","jsd"),new Argument("objinr",jsdinr));
			  setModuleContent(data);
			  if(MdaUtils.isEmpty(this.getBusgrp().getJsdgrp().getRec().getBchcod()))
			    this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  //$busgrp\\jsdgrp\\rec\\advdat=Platform.today();
			  this.getBusgrp().getJsdgrp().getRec().setPaysta("0");

			  if("0".equals(this.getBusgrp().getJsdgrp().getRec().getJsdtyp()))
			  {
			    this.getBusgrp().getJsdgrp().getRec().setYwztls("5");
			  }
			  else if("1".equals(this.getBusgrp().getJsdgrp().getRec().getJsdtyp()))
			  {
			    log.debug("{}","givdat is: "+this.getBusgrp().getJsdgrp().getRec().getGivdat());
			    log.debug("{}","njgdat is: "+this.getBusgrp().getJsdgrp().getRec().getNjgdat());
			    this.getBusgrp().getJsdgrp().getRec().setGivdat(this.getBusgrp().getJsdgrp().getRec().getNjgdat());
			    this.getBusgrp().getJsdgrp().getRec().setZqndat(this.getBusgrp().getJsdgrp().getRec().getNzqdat());
			  }
			  else if("2".equals(this.getBusgrp().getJsdgrp().getRec().getJsdtyp()))
			  {
			    this.getBusgrp().getJsdgrp().getRec().setYwztls("7");
			  }
			  else
			  {
			  }

			  this.getBusgrp().getJsdgrp().getRec().setChkdat(MdaUtils.today());

			  if("0".equals(this.getBusgrp().getJsdgrp().getRec().getJsdtyp()))
			  {
			    this.getBusgrp().getJsdgrp().getRec().setYwztls("5");
			  }

			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getJsdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getJsdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());

			  jsdinr = Platform.sdbCounter("jsd");
			  this.getBusgrp().getJsdgrp().getRec().setInr(jsdinr);
			  this.getBusgrp().getJsdgrp().getRec().setOwnref(Platform.getRef("JS"));
			  //$busgrp\\jsdgrp\\rec\\advdat=Platform.today();
			
			  this.getBusgrp().getJsdgrp().getRec().setChkdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getJsdgrp().getRec());
			}
			this.getBusgrp().getJsdgrp().getApl().savRolPts(jsdinr,"jsd","apl");
			//2.设置 BUSINF字段值
			this.setFrmcod("jstsev");
			this.setOwnref(this.getBusgrp().getJsdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getJsdgrp().getRec().getInr(),"jsd",this.getOwnref(),"人民币与外汇期权业务交易后处理通知");

		}
        /**
        *   source:stlbod.@0095.script
        */
        public void  parseSTLJ25_AKA (Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MT700-XML报文信息
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTLJ21 .... ") ;
			this.setOwnref((String)data.get("jsdgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("jsdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			log.debug("{}","stlref   11="+stlref);
			// 1. 存储报文信息
			String jsdinr = null;
			if(reloadDataByStlref("jsd",this.getStlref()))
			{
			  jsdinr=this.getBusgrp().getJsdgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getJsdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","jsd"),new Argument("objinr",jsdinr));
			  setModuleContent(data);
			  if(MdaUtils.isEmpty(this.getBusgrp().getJsdgrp().getRec().getBchcod()))
			    this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getJsdgrp().getRec().setAdvdat(MdaUtils.today());

			  if("1".equals(this.getBusgrp().getJsdgrp().getRec().getSfltyp()))
			  {
			    BigDecimal ame=this.getBusgrp().getJsdgrp().getRec().getBuyamt();
			    BigDecimal ame1=this.getBusgrp().getJsdgrp().getRec().getAmt();
			    BigDecimal ame2=this.getBusgrp().getJsdgrp().getRec().getSombuyamt();
			    BigDecimal ame3=this.getBusgrp().getJsdgrp().getRec().getPayamt();
			    this.getBusgrp().getJsdgrp().getRec().setBuyamt(ame.subtract(ame2));
			    this.getBusgrp().getJsdgrp().getRec().setAmt(ame1.subtract(ame2));
			    this.getBusgrp().getJsdgrp().getRec().setPayamt(ame3.add(ame2));

			    this.getBusgrp().getJsdgrp().getRec().setSompayamt(ame2);
			  }
			  else
			  {
			    BigDecimal ame=this.getBusgrp().getJsdgrp().getRec().getSelamt();
			    BigDecimal ame1=this.getBusgrp().getJsdgrp().getRec().getAmt();
			    BigDecimal ame2=this.getBusgrp().getJsdgrp().getRec().getSomselamt();
			    BigDecimal ame3=this.getBusgrp().getJsdgrp().getRec().getPayamt();
			    this.getBusgrp().getJsdgrp().getRec().setSelamt(ame.subtract(ame2));
			    this.getBusgrp().getJsdgrp().getRec().setAmt(ame1.subtract(ame2));
			    this.getBusgrp().getJsdgrp().getRec().setPayamt(ame3.add(ame2));

			    this.getBusgrp().getJsdgrp().getRec().setSompayamt(ame2);
			  }

			  this.getBusgrp().getJsdgrp().getRec().setPaysta("0");
			  String paytim=this.getBusgrp().getJsdgrp().getRec().getPaytim().trim();
			  if(MdaUtils.isEmpty(paytim) || "0".equals(paytim))
			  {
			    this.getBusgrp().getJsdgrp().getRec().setPaytim("1");
			  }
			  else
			  {
			    int ptim=MdaUtils.parseInt(this.getBusgrp().getJsdgrp().getRec().getPaytim().trim());
			    this.getBusgrp().getJsdgrp().getRec().setPaytim(String.valueOf(ptim+1));
			  }

			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getJsdgrp().getRec());
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getJsdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getJsdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getJsdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());

			  jsdinr = Platform.sdbCounter("jsd");
			  this.getBusgrp().getJsdgrp().getRec().setInr(jsdinr);
			  this.getBusgrp().getJsdgrp().getRec().setOwnref(Platform.getRef("JS"));
			  //$busgrp\\jsdgrp\\rec\\advdat=Platform.today();
			  if("1".equals(this.getBusgrp().getJsdgrp().getRec().getSfltyp()))
			  {
			    this.getBusgrp().getJsdgrp().getRec().setCur(this.getBusgrp().getJsdgrp().getRec().getBuycur());
			    this.getBusgrp().getJsdgrp().getRec().setSompayamt(this.getBusgrp().getJsdgrp().getRec().getSombuyamt());
			  }
			  else
			  {
			    this.getBusgrp().getJsdgrp().getRec().setCur(this.getBusgrp().getJsdgrp().getRec().getSelcur());
			    this.getBusgrp().getJsdgrp().getRec().setSompayamt(this.getBusgrp().getJsdgrp().getRec().getSomselamt());
			  }

			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getJsdgrp().getRec());
			}
			this.getBusgrp().getJsdgrp().getApl().savRolPts(jsdinr,"jsd","apl");
			//2.设置 BUSINF字段值
			this.setFrmcod("jstpav");
			this.setOwnref(this.getBusgrp().getJsdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getJsdgrp().getRec().getInr(),"jsd",this.getOwnref(),"远期结售汇提前部分交割通知");

		}
        /**
        *   source:stlbod.@0096.script
        */
        public void  parseSTLW22_WIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 期权签约申请_WIT-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("widgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			String adrblk = (String)data.get("widgrp\\apl\\pts\\adrblk");

			this.setOwnref((String)data.get("widgrp\\rec\\ownref"));
			log.debug("{}","stlref="+ this.getStlref() +",ownref=" + this.getOwnref()+",adrblk="+adrblk);
			String widinr="";

			//Opening under a guarentee
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  //the first application,use ownref,after use stlref
			  log.debug("{}","i got you,ownref="+this.getOwnref());
			  reloadData("wid",this.getOwnref());
			  widinr=this.getBusgrp().getWidgrp().getRec().getInr();

			  ctx.getDaoSession().dbRead(this.getBusgrp().getWidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","wid"),new Argument("objinr",widinr));
			  setModuleContent(data);
			  this.getBusgrp().getWidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getWidgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getWidgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getWidgrp().getRec().setSta("1");

			  log.debug("{}","etyinr = " + this.getBusgrp().getWidgrp().getRec().getEtyinr() + "; qqtyp = " + this.getBusgrp().getWidgrp().getRec().getQqtyp() + "; ptyinr = " + this.getBusgrp().getWidgrp().getRec().getPtyinr()+ "; amt = " + this.getBusgrp().getWidgrp().getRec().getAmt()+ "; jshfx = " + this.getBusgrp().getWidgrp().getRec().getJshfx() );
			  log.info("{}","widgrp-apl-pts:" + this.getBusgrp().getWidgrp().getApl().getPts().getAdrblk());

			  //$busgrp\\widgrp\\apl\\pts\\adrblk.setValue(adrblk);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"widgrp\\rec"));
			  //$\\sysmod.sdbUpdate(Platform.getModule($busgrp,"widgrp\\\\apl\\\\pts"));
			}
			else
			{
			  //create a new record
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"widgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getWidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  //IDatafield ledinr=Platform.getDatafield($\\bimenu\\,"gidgrp\\\\rec\\\\inr");
			  //ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getBusgrp().getWidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getWidgrp().getRec().setInr(Platform.sdbCounter("wid"));
			  this.getBusgrp().getWidgrp().getRec().setOwnref(Platform.getRef("WI"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getWidgrp().getRec().getBchcod()))
			    this.getBusgrp().getWidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getWidgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getWidgrp().getRec().setSta("1");
			  this.getBusgrp().getWidgrp().getRec().setAdvdat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getWidgrp().getRec());
			  //$\\sysmod.sdbInsert(Platform.getModule($busgrp,"widgrp\\\\rec"));
			
			  //处理由国结返回的期权记录的信息
			  String [] jyfx =  this.getBusgrp().getWidgrp().getJyfx().toString().split(",");
			  String [] qqfx = this.getBusgrp().getWidgrp().getQqfx().toString().split(",");
			  String [] amt = this.getBusgrp().getWidgrp().getAmt().toString().split(",");
			  String [] zxamt = this.getBusgrp().getWidgrp().getZxamt().toString().split(",");
			  log.info("{}","国结发起期权交易记录数 ：" + this.getBusgrp().getWidgrp().getJyfx().toString().split(",").length );
			  for(int i = 0; i < this.getBusgrp().getWidgrp().getJyfx().toString().split(",").length; i++)
			  {
			    this.getBusgrp().getWidgrp().getWic().setInr(Platform.sdbCounter("wic"));
			    this.getBusgrp().getWidgrp().getWic().setObjinr(this.getBusgrp().getWidgrp().getRec().getInr());
			    this.getBusgrp().getWidgrp().getWic().setObjtyp("wid");
			    this.getBusgrp().getWidgrp().getWic().setJyfx(jyfx[i]);
			    this.getBusgrp().getWidgrp().getWic().setQqfx(qqfx[i]);
			    if("0".equals(jyfx[i]))
			    {
			      if("0".equals(qqfx[i]))
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("1");
			      }
			      else if("1".equals(qqfx[i]))
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("0");
			      }
			      else
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("");
			      }
			    }
			    else if("1".equals(jyfx[i]))
			    {
			      if("0".equals(qqfx[i]))
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("0");
			      }
			      else if("1".equals(qqfx[i]))
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("1");
			      }
			      else
			      {
			        this.getBusgrp().getWidgrp().getWic().setJshfx("");
			      }
			    }
			    this.getBusgrp().getWidgrp().getWic().setAmt(MdaUtils.parseDecimal(amt[i]));
			    this.getBusgrp().getWidgrp().getWic().setZxamt(MdaUtils.parseDecimal(zxamt[i]));
			    this.getBusgrp().getWidgrp().getWic().setModflg("0");
			    ctx.getDaoSession().dbInsert(MdaDriver.getModule(this.getBusgrp(),"widgrp\\wic"));
			  }

			  widinr=this.getBusgrp().getWidgrp().getRec().getInr();
			}
			this.getBusgrp().getWidgrp().getApl().savRolPts(widinr,"wid","apl");
			this.getBusgrp().getWidgrp().getIsb().savRolPts(widinr,"wid","isb");
			this.setFrmcod("witdav");
			this.setOwnref(this.getBusgrp().getWidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getWidgrp().getRec().getInr(),"wid",this.getOwnref(),"期权签约证实");

		}
        /**
        *   source:stlbod.@0097.script
        */
        public void  parseSTLW23_WIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 期权交易后处理_WIT-XML报文信息-
			  @ 返回解析是否成功
			  */
			log.debug("{}","parseSTLW23_WIT START ...");

			this.setOwnref((String)data.get("widgrp\\rec\\ownref"));               // 单证通业务编号
			this.setStlref(this.getBusgrp().getBusinf().getStlref());											 // STL系统业务编号
			//$busgrp\\businf\\stlref  = (String)data.get("widgrp\\\\rec\\\\stlref");
			String stlref=this.getBusgrp().getBusinf().getStlref();
			String qqywlx = (String)data.get("widgrp\\rec\\qqywlx");
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref()+",qqywlx="+qqywlx);

			//如果收到交割通知，则闭卷
			
			if(!MdaUtils.isEmpty(this.getStlref()))
			{
			  log.debug("{}","reloadDataByStlref");
			  this.setStlref(stlref.toString());
			  if(reloadDataByStlref("wid",stlref.toString()))
			  {
			    setModuleContent(data);
			    this.getBusgrp().getWidgrp().getRec().setAmedat(MdaUtils.today());
			    this.getBusgrp().getWidgrp().getRec().setSta("1");
			    if("3".equals(qqywlx.trim()))
			    {
			      //$busgrp\\widgrp\\rec\\clsdat.setValue((Date)data.get("widgrp\\\\zxdate"));
			      this.getBusgrp().getWidgrp().getRec().setClsdat(MdaUtils.today());
			    }
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"widgrp\\rec"));
			  }
			  else
			  {
			    log.debug("{}","sdbInsert DataByStlref");
			    setModuleContent(data);
			    IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"widgrp\\rec\\ptyinr");
			    ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getWidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getWidgrp().getRec().setInr(Platform.sdbCounter("wid"));
			    this.getBusgrp().getWidgrp().getRec().setOwnref(Platform.getRef("WI"));
			    if(MdaUtils.isEmpty(this.getBusgrp().getWidgrp().getRec().getBchcod()))
			      this.getBusgrp().getWidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    this.getBusgrp().getWidgrp().getRec().setAmedat(MdaUtils.today());
			    this.getBusgrp().getWidgrp().getRec().setSta("1");
			    if("3".equals(qqywlx.trim()))
			    {
			      this.getBusgrp().getWidgrp().getRec().setClsdat((Date)data.get("widgrp\\zxdate"));
			    }
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"widgrp\\rec"));
			  }

			  this.setFrmcod("witmav");
			  this.setOwnref(this.getBusgrp().getWidgrp().getRec().getOwnref());
			  setBusinfFromStlbod(this.getBusgrp().getWidgrp().getRec().getInr(),"wid",this.getOwnref(),"期权交易后处理通知");

			}

		}
        /**
        *   source:stlbod.@0098.script
        */
        public void  parseSTLT2A_CPI(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT2A_CPI-XML报文信息-汇入预通知
			  @ 返回解析是否成功
			  */
			// Object stlref = data.get("cpdgrp\\\\rec\\\\stlref");
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("cpdgrp\\rec\\dstlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref is:    "+stlref);

			String cinr = null;
			// log.info("stlbod T2A RPT stlref = "+stlref.toString());
			String rtinr = null;
			String sqll = "select max(inr) inr from cpd where stlref='"+stlref.toString()+"'";
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL(sqll);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","stlbod T2A CPT inr = "+inr.value);
			  if(MdaUtils.isEmpty(inr.value))
			  {
			    rtinr = inr.value;
			    cinr = inr.value;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();

			if(!MdaUtils.isEmpty(inr))
			{
			  IModule mod=MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClientid()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"cpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  cinr=Platform.sdbCounter("cpd");
			  this.getBusgrp().getCpdgrp().getRec().setInr(cinr);
			  this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("LP"));
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			this.getBusgrp().getCpdgrp().getBen().savRolPts(cinr,"cpd","ben");
			this.getBusgrp().getCpdgrp().getAcw().savRolPts(cinr,"cpd","acw");
			this.getBusgrp().getCpdgrp().getApl().savRolPts(cinr,"cpd","apl");
			/**
			  单一窗口
			  */
			String cid = this.getBusgrp().getBusinf().getClientid();
			String payact = this.getBusgrp().getCpdgrp().getRec().getPyeact();//汇入账号这个可能需要调整
			log.info("{}","stlbod cid = "+cid);
			log.info("{}","stlbod payact = "+payact);
			/*String sqlsw = "select count(inr) num from acb where cusid=? and result ='01' and opttype='A' and inwardacct=?";
			  Platform.errorCode();
			  Platform.dbExecuteSQL(sqlsw,cid,payact);
			  Argument<Integer> num = new Argument<Integer>("num");
			  Platform.dbFetchFields(num);
			  Platform.dbCloseCursor();
			  if(Platform.errorCode() == NO_ERROR)
			  {
			  log.info("num acb= "+num.value);
			  if(num.value != 0)
			  {
			  */
			Map map = new HashMap();
			map.put("CUSID",cid);
			map.put("EntMarkNo",stlref);
			map.put("TransDate",MdaUtils.format(this.getBusgrp().getCpdgrp().getRec().getOpndat(),"yyyyMMdd"));
			map.put("PayeeAcctNum",payact);
			map.put("PayeeEntMarkNo",this.getBusgrp().getCpdgrp().getRec().getPayeeentmarkno()); //对方行业务编号，参数待定
			map.put("TransAmount",MdaUtils.toString(this.getBusgrp().getCpdgrp().getRec().getRemamt()));  //金额转换成字符串传入
			map.put("Currency",this.getBusgrp().getCpdgrp().getRec().getRemcur());
			map.put("IsExist",this.getBusgrp().getCpdgrp().getRec().getIsexist());  //是否被退回过待定
			log.info("{}","swinof :"+(String)data.get("swinfo"));
			map.put("swinfo",(String)data.get("swinfo"));
			String sfs = "SFS116";
			setMapSW(sfs,cinr,"cpd",map,"");
			//}
			// }
			if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBnkinr()))
			{
			  String ptys=ctx.absGet(com.ceb.gjjs.mda.manager.module.Trnmod.class).getPtysFromCid("08350000");
			  if(!MdaUtils.isEmpty(ptys))
			    this.getBusgrp().getBusinf().setBnkinr(ptys);
			}
			this.setFrmcod("cptyub");//暂定
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇入汇款预通知");
		}
        /**
        *   source:stlbod.@0099.script
        */
        public void setMapSW(String sfs,String inr,String objtyp,Map map,String msgref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//原业务ownref
			String buscod = (String)map.get("buscod");
			String djcod = (String)map.get("djcod");
			String sql = "select ttl imageID,decode(tratyp,'UPLOAD','2','4') imageStatus "+
			  "from tblbil where buscod=? and djcod=? and usr='dyck' order by ttl asc";
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL(sql,buscod,djcod);
			log.debug("{}","xml_cpt sql "+sql);
			List imgList = new ArrayList();
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  Argument<String> imageID = new Argument<String>("imageID");
			  Argument<String> imageStatus = new Argument<String>("imageStatus");
			  while(true)
			  {
			    Map imageMap = new HashMap();
			    ctx.getDaoSession().dbFetchFields(imageID,imageStatus);
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      imageMap.put("imageID",imageID.value);
			      imageMap.put("imageStatus",imageStatus.value);
			      imgList.add(imageMap);
			    }
			    else
			      break;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();
			map.put("imgList",imgList);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setSwHeaderMap(sfs,"",map,msgref);
			this.storeSWM(sfs,inr,objtyp,map);
			log.debug("{}","swmsg is saved ......"+inr);
			/*Map rst = (Map)$\\sysmod.retSW(sfs,map,null);
			  String code = (String)rst.get("code");
			  String des = (String)rst.get("des");
			  log.info("ret sw errorcode and des :"+code +"****"+des);
			  */
		}
        /**
        *   source:stlbod.@0100.script
        */
        public void  parseSTLT2B_CPI(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT2B_CPO-XML报文信息-汇入性质确认回执
			  @ 返回解析是否成功
			  */
			log.debug("{}","in parseSTLT2B_CPI working");
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("cpdgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			String dstlref=(String)data.get("cpdgrp\\rec\\dstlref");

			this.setOwnref((String) data.get("cpdgrp\\rec\\ownref"));
			log.debug("{}","stlref="+stlref+",ownref=" + this.getOwnref()+",dstlref= "+dstlref);
			String inr=null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  inr=reloadData("cpd",this.getOwnref());
			  if(!MdaUtils.isEmpty(inr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			    setModuleContent(data);
			    this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			    this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			    this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			    ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			  }
			  else
			  {
			    Platform.setErrorInfo(resMsg,"110","");
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			}
			else
			{
			  log.debug("{}","dstlref is  :"+dstlref);
			  if(!MdaUtils.isEmpty(dstlref))
			    ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getRec(),new Argument("dstlref",dstlref));

			  // if("A".equals($busgrp\\cpdgrp\\rec\\dty.getValue()))
			
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getCpdgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());

			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");

			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getInr()))
			  {
			    inr=Platform.sdbCounter("cpd");
			    this.getBusgrp().getCpdgrp().getRec().setInr(inr);
			    this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("LP"));
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			  }
			  else
			  {
			    inr=this.getBusgrp().getCpdgrp().getRec().getInr();
			    this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			    ctx.getDaoSession().dbUpdate(this.getBusgrp().getCpdgrp().getRec());
			  }
			}
			this.getBusgrp().getCpdgrp().getBen().savRolPts(inr,"cpd","ben");
			this.getBusgrp().getCpdgrp().getAcw().savRolPts(inr,"cpd","acw");
			this.getBusgrp().getCpdgrp().getApl().savRolPts(inr,"cpd","apl");

			/**
			  单一窗口：根据cpd表cpdres判断
			  */
			String cid = this.getBusgrp().getBusinf().getClientid();
			String payact = this.getBusgrp().getCpdgrp().getRec().getPyeact();//汇入账号这个可能需要调整
			String cpdres = this.getBusgrp().getCpdgrp().getRec().getCpdres();
			if(!MdaUtils.isEmpty(cpdres)&&"D".equals(cpdres))
			{
			  Map map = new HashMap();
			  map.put("inr",this.getBusgrp().getCpdgrp().getRec().getInr());
			  map.put("EntMarkNo",stlref);
			  map.put("TransId",this.getBusgrp().getCpdgrp().getRec().getTransid());
			  map.put("OutBankStatus","");
			  map.put("Reason","");
			  map.put("SendTime",MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss"));
			  map.put("ImgStatusAll","");
			  map.put("TransStatus","06");
			  String imgrefs = this.getBusgrp().getCpdgrp().getRec().getOwnref();
			  map.put("buscod",imgrefs);
			  map.put("djcod",imgrefs);
			  String sfs = "SFS118";
			  setMapSW(sfs,inr,"cpd",map,this.getBusgrp().getCpdgrp().getRec().getMsgref());
			}

			this.setFrmcod("cptsub");
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇入性质确认回执");
		}
        /**
        *   source:stlbod.@0101.script
        */
        public void storeSWM(String msgcod,String srcinr,String objtyp,Map msgcontent)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//msgcod :SFSXXX
			//srcinr:原业务 inr
			//msgcontent:实际报文内容
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(msgcontent);
			String msgid = (String)msgcontent.get("MsgID");
			msgid = msgcod+msgid;
			log.info("{}","msg filename :"+msgid);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"swmsg"),datstr);
			String inr = Platform.sdbCounter("swmsg");
			path = MdaUtils.catPath(path,msgid+".dat");
			java.io.File file = new java.io.File(path);
			if (!file.getParentFile().exists())
			{
			  file.getParentFile().mkdirs();
			}
			if (!file.exists())
			{
			  try
			  {
			    file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			    log.error("{}","*****  文件创建失败！");
			    log.error("{}",e.toString());
			  }
			}
			MdaUtils.saveContent(sendContent,path,"utf-8");
			log.info("{}","path="+path);
			MdaUtils.clear(this.getSwmsg());
			this.getSwmsg().setInr(inr);
			this.getSwmsg().setMsgpath(path);
			this.getSwmsg().setCnt(0);
			this.getSwmsg().setSta("W");
			this.getSwmsg().setMsgcod(msgcod);
			this.getSwmsg().setCredat(MdaUtils.today());
			this.getSwmsg().setTrans(ctx.getTransName());
			this.getSwmsg().setObjinr(srcinr);
			this.getSwmsg().setObjtyp(objtyp);
			ctx.getDaoSession().dbInsert(this.getSwmsg());

		}
        /**
        *   source:stlbod.@0103.script
        */
        public void  parseSTLT69_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT68_GIT-XML报文信息-
			  @ 返回解析是否成功
			  */
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("gidgrp\\rec\\stlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			/*if(!Platform.isEmpty(stlref))
			  $stlref.setValue(stlref.toString());*/
			this.setOwnref((String)data.get("gidgrp\\rec\\ownref"));
			log.debug("{}","stlref="+ this.getStlref() +",ownref=" + this.getOwnref());
			String gidinr="";

			//Opening under a guarentee
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  //the first application,use ownref,after use stlref
			  log.debug("{}","i got you,ownref="+this.getOwnref());
			  reloadData("gid",this.getOwnref());
			  gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			  /*
			    String etyinr = $busgrp\\gidgrp\\rec\\etyinr.getValue();
			    String opntyp = $busgrp\\gidgrp\\rec\\opntyp.getValue();
			    String ptyinr = $busgrp\\gidgrp\\rec\\ptyinr.getValue();
			    String opntyp2 = $busgrp\\gidgrp\\rec\\opntyp2.getValue();
			    String wbtyp = $busgrp\\gidgrp\\rec\\wbtyp.getValue();
			    log.debug("etyinr = " + etyinr + "; opntyp = " + opntyp + "; ptyinr = " + ptyinr+ "; opntyp2 = " + opntyp2+ "; wbtyp = " + wbtyp );
			    */
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));

			  //$busgrp\\gidgrp\\gib\\inr.setValue(gidinr);
			  // Platform.dbRead($busgrp\\gidgrp\\gib,new Argument("inr",$busgrp\\gidgrp\\gib\\inr.getValue()));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getFzgit(),new Argument("inr",this.getBusgrp().getGidgrp().getRec().getInr()));

			  /*
			    String gibptyinr = $busgrp\\gidgrp\\gib\\ptyinr.getValue();
			    String gibwbtyp = $busgrp\\gidgrp\\gib\\wbtyp.getValue();
			    String giblgtyp = $busgrp\\gidgrp\\gib\\lgtyp.getValue();
			    $busgrp\\gidgrp\\gib\\ptyinr.setValue(gibptyinr);
			    $busgrp\\gidgrp\\gib\\wbtyp.setValue(gibwbtyp);
			    $busgrp\\gidgrp\\gib\\lgtyp.setValue(giblgtyp);
			
			    Platform.dbRead($busgrp\\gidgrp\\rec,new Argument("inr",gidinr));
			    Platform.dbRead($busgrp\\gidgrp\\gib,new Argument("inr",gidinr));
			    String gidetyinr = $busgrp\\gidgrp\\rec\\etyinr.getValue();
			    String gidopntyp = $busgrp\\gidgrp\\rec\\opntyp.getValue();
			    String gidptyinr = $busgrp\\gidgrp\\rec\\ptyinr.getValue();
			    String gidopntyp2 = $busgrp\\gidgrp\\rec\\opntyp2.getValue();
			    String gidwbtyp = $busgrp\\gidgrp\\rec\\wbtyp.getValue();
			    String lgtxt = $busgrp\\gidgrp\\gib\\lgtxt.getValue();
			    log.debug("etyinr = " + gidetyinr + "; opntyp = " + gidopntyp + "; ptyinr = " + gidptyinr+ "; opntyp2 = " + gidopntyp2+ "; wbtyp = " + gidwbtyp );
			    log.debug("lgtxt" + $busgrp\\gidgrp\\gib\\lgtxt.getValue());
			    */
			  setModuleContent(data);
			  this.getBusgrp().getGidgrp().getRec().setFlg("2");
			  this.getBusgrp().getGidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  /*
			    $busgrp\\gidgrp\\rec\\etyinr.setValue(gidetyinr);
			    $busgrp\\gidgrp\\rec\\opntyp.setValue(gidopntyp);
			    $busgrp\\gidgrp\\rec\\ptyinr.setValue(gidptyinr);
			    $busgrp\\gidgrp\\rec\\opntyp2.setValue(gidopntyp2);
			    $busgrp\\gidgrp\\rec\\wbtyp.setValue(gidwbtyp);
			    */
			  log.debug("{}","etyinr = " + this.getBusgrp().getGidgrp().getRec().getEtyinr() + "; opntyp = " + this.getBusgrp().getGidgrp().getRec().getOpntyp() + "; ptyinr = " + this.getBusgrp().getGidgrp().getRec().getPtyinr()+ "; opntyp2 = " + this.getBusgrp().getGidgrp().getRec().getOpntyp2()+ "; wbtyp = " + this.getBusgrp().getGidgrp().getRec().getWbtyp() );
			  log.debug("{}","lgtxt" + this.getBusgrp().getGidgrp().getGib().getLgtxt());
			  //Platform.dbUpdate($busgrp\\gidgrp\\gib);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\fzgit"));

			}
			else
			{
			  //create a new record
			  log.error("{}","new fzgid,never come in here !");
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"gidgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  //IDatafield ledinr=Platform.getDatafield($\\bimenu\\,"gidgrp\\\\rec\\\\inr");
			  //ledinr.setValue(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setDbchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setInr(Platform.sdbCounter("gid"));
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			  if(MdaUtils.isEmpty(this.getBusgrp().getGidgrp().getRec().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"gidgrp\\rec"));

			  gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			}
			this.getBusgrp().getGidgrp().getApl().savRolPts(gidinr,"gid","apl");
			this.getBusgrp().getGidgrp().getBen().savRolPts(gidinr,"gid","ben");
			this.setFrmcod("gitdfz");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"福州保函开立通知");

		}
        /**
        *   source:stlbod.@0104.script
        */
        public void  setFzgitFromStlbod()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * create record SPT, ORD, ORE
			  */

			log.info("{}","in stlbody.update fzgit for fuzhou fenhang...");
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  this.getBusgrp().getGidgrp().getFzgit().setSmhinr(this.getSmh().getInr());
			}
			this.getBusgrp().getGidgrp().getFzgit().setSta("T");
			log.info("{}","fzgit smhinr sta "+this.getBusgrp().getGidgrp().getFzgit().getSmhinr() +"   "+this.getBusgrp().getGidgrp().getFzgit().getSta() );
			ctx.getDaoSession().dbUpdate(this.getBusgrp().getGidgrp().getFzgit());
			log.debug("{}","out stlbod.fggit fuzhou... ");
		}
        /**
        *   source:stlbod.@0105.script
        */
        public void insertEbhmsg(String msgcod,String srcinr,String objtyp,Map msgcontent)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//msgcod :SFSXXX
			//srcinr:原业务 inr
			//msgcontent:实际报文内容
			//EBH102
			String msgid = (String)msgcontent.get("msgid");
			msgid = msgcod+msgid;
			log.info("{}","msg filename :"+msgid);
			com.google.gson.Gson gson = new com.google.gson.Gson();
			String sendContent = gson.toJson(msgcontent);
			//保存到本地
			String datstr = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String path=MdaUtils.catPath(MdaUtils.catPath(MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data"),"ebhmsg"),datstr);
			String inr = Platform.sdbCounter("ebhsnd");
			path = MdaUtils.catPath(path,msgid+".dat");
			java.io.File file = new java.io.File(path);
			if (!file.getParentFile().exists())
			{
			  file.getParentFile().mkdirs();
			}
			if (!file.exists())
			{
			  try
			  {
			    file.createNewFile();
			  }
			  catch (java.io.IOException e)
			  {
			    log.error("{}","*****  文件创建失败！");
			    log.error("{}",e.toString());
			  }
			}
			MdaUtils.saveContent(sendContent,path,"utf-8");
			log.info("{}","path="+path);
			log.info("{}","ebhsnd :"+sendContent);
			MdaUtils.clear(this.getEbhsnd());
			this.getEbhsnd().setInr(inr);
			//$ebhsnd\\cnt.setValue();
			this.getEbhsnd().setCredat(MdaUtils.today());
			//$ebhsnd\\mandate.setValue();
			this.getEbhsnd().setMsgcod(msgcod);
			this.getEbhsnd().setObjinr(srcinr);
			this.getEbhsnd().setObjtyp(objtyp);
			this.getEbhsnd().setMsgpath(path);
			//$ebhsnd\\senddate.setValue();
			this.getEbhsnd().setSta("W");
			this.getEbhsnd().setTrans("gitdav");
			//$ebhsnd\\muser.setValue();
			ctx.getDaoSession().dbInsert(this.getEbhsnd());
			log.debug("{}","ebhsnd inr is"+this.getEbhsnd().getInr());
			/*
			  Platform.saveContent(sendContent, path, "utf-8");
			  log.info("path="+path);
			  log.info("ebhmsg :"+sendContent);
			  Platform.clear($ebhmsg);
			  $ebhmsg\\inr.setValue(inr);
			  $ebhmsg\\msgpath.setValue(path);
			  $ebhmsg\\cnt.setValue(0);
			  $ebhmsg\\sta.setValue("W");
			  $ebhmsg\\msgcod.setValue(msgcod);
			  $ebhmsg\\credat.setValue(Platform.today());
			  $ebhmsg\\trans.setValue(Platform.getTransName());
			  $ebhmsg\\objinr.setValue(srcinr);
			  $ebhmsg\\objtyp.setValue(objtyp);
			  Platform.dbInsert($ebhmsg);
			  log.debug("ebhmsg inr is"+$ebhmsg\\inr.getValue());
			  */
		}
        /**
        *   source:stlbod.@0106.script
        */
        public void  parseSTLS65_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 S62_AKA-XML报文信息-电子保函开立通知
			  @ 返回解析是否成功
			  */

			log.debug("{}"," in stlbod.parseSTLS62 .... ") ;
			this.setOwnref((String)data.get("gidgrp\\rec\\ownref"));               // 单证通业务编号									 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("gidgrp\\rec\\stlref"));
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			// 1. 存储报文信息
			String gidinr = null;
			if(!MdaUtils.isEmpty(this.getOwnref()))
			{
			  gidinr=reloadData("gid",this.getOwnref());
			  if(!MdaUtils.isEmpty(gidinr))
			  {
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getSzgit(),new Argument("inr",gidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getSec().getPts(),new Argument("rol","sec"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			    ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			    setModuleContent(data);

			    if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			      this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			    if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			      this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			    this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getRec());
			    ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getSzgit());
			  }
			  else
			  {
			    Platform.setErrorInfo(resMsg,"110","");
			    log.debug("{}","reloadData error...");
			    return ;
			  }
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getGidgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());

			  if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  gidinr = Platform.sdbCounter("gid");
			  this.getBusgrp().getGidgrp().getRec().setInr(gidinr);
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getRec());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getSzgit());

			}

			this.getBusgrp().getGidgrp().getBen().savRolPts(gidinr,"gid","ben");
			this.getBusgrp().getGidgrp().getSec().savRolPts(gidinr,"gid","sec");
			this.getBusgrp().getGidgrp().getApl().savRolPts(gidinr,"gid","apl");

			//电子保函回执
			Map sendMap = new HashMap();
			sendMap.put("ptbusino",this.getBusgrp().getGidgrp().getSzgit().getPtbusino());
			sendMap.put("bkbusino",this.getBusgrp().getGidgrp().getRec().getOwnref());

			sendMap.put("lgstatus","0");
			sendMap.put("describe","保函开立成功通知");
			String msgno="EBH102";
			String msgref = this.getBusgrp().getGidgrp().getSzgit().getMsgref();
			String opndat = MdaUtils.format(this.getBusgrp().getGidgrp().getRec().getOpndat(),"yyyyMMdd");
			sendMap.put("opendate",opndat);
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setSzHeaderMap(msgno,"",sendMap,msgref);  //msgref 暂时未加
			this.insertEbhmsg(msgno,gidinr,"gid",sendMap);
			String contractid = (String)data.get("HTICONTRACT");
			if(!MdaUtils.isEmpty(contractid))
			{
			  this.storeGitpush(contractid,"gitosz");
			}
			//2.设置 BUSINF字段值
			this.setFrmcod("gitdav");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"电子保函开立通知");
		}
        /**
        *   source:stlbod.@0107.script
        */
        public void  parseSTLS66_GIT(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTS67_AKA-XML报文信息-
			  @ 返回解析是否成功
			  */
			log.debug("{}"," in stlbod.parseSTLS67 .... ") ;
			this.setOwnref((String)data.get("gidgrp\\rec\\ownref"));               // 单证通业务编号									 // STL系统业务编号
			this.getBusgrp().getBusinf().setStlref( (String)data.get("gidgrp\\rec\\stlref"));
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref="+this.getStlref()+",ownref="+this.getOwnref());

			String gidinr=null;
			if(reloadDataByStlref("gid",this.getStlref()))
			{
			  gidinr=this.getBusgrp().getGidgrp().getRec().getInr();
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getSzgit(),new Argument("inr",gidinr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getGidgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","gid"),new Argument("objinr",gidinr));
			  setModuleContent(data);

			  if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getRec());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbUpdate(this.getBusgrp().getGidgrp().getSzgit());
			  log.debug("{}","update success!");
			}
			else
			{
			  setModuleContent(data);
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getCliinr()))
			    this.getBusgrp().getGidgrp().getRec().setPtyinr(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getGidgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());

			  if(MdaUtils.isEmpty(this.getBusgrp().getBusinf().getBchcod()))
			    this.getBusgrp().getGidgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  gidinr = Platform.sdbCounter("gid");
			  this.getBusgrp().getGidgrp().getRec().setInr(gidinr);
			  this.getBusgrp().getGidgrp().getRec().setOwnref(Platform.getRef("LG"));
			  this.getBusgrp().getGidgrp().getRec().setOpndat(MdaUtils.today());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getRec());
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(this.getBusgrp().getGidgrp().getSzgit());

			  log.debug("{}","insert success!");
			}
			this.getBusgrp().getGidgrp().getBen().savRolPts(gidinr,"gid","ben");

			//电子保函回执
			Map sendMap = new HashMap();
			sendMap.put("ptbusino",this.getBusgrp().getGidgrp().getSzgit().getPtbusino());
			sendMap.put("bkbusino",this.getBusgrp().getGidgrp().getRec().getOwnref());
			sendMap.put("projectcode",this.getBusgrp().getGidgrp().getRec().getConno());
			sendMap.put("lgstatus","0");
			sendMap.put("describe","保函修改成功通知");
			String msgno="EBH104";
			String msgref = this.getBusgrp().getGidgrp().getSzgit().getMsgref();
			ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).setSzHeaderMap(msgno,"",sendMap,msgref);  //msgref 暂时未加
			this.insertEbhmsg(msgno,gidinr,"gid",sendMap);
			String contractid = (String)data.get("HTICONTRACT");
			if(!MdaUtils.isEmpty(contractid))
			{
			  this.storeGitpush(contractid,"gitasz");
			}
			this.setFrmcod("gitmav");
			this.setOwnref(this.getBusgrp().getGidgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getGidgrp().getRec().getInr(),"gid",this.getOwnref(),"收到保函通知");
		}
        /**
        *   source:stlbod.@0108.script
        */
        public void  parseSTLT2C_CPI(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT2A_CPI-XML报文信息-汇入预通知
			  @ 返回解析是否成功
			  */
			// Object stlref = data.get("cpdgrp\\\\rec\\\\stlref");
			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("cpdgrp\\rec\\dstlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref is:    "+stlref);

			String cinr = null;
			// log.info("stlbod T2A RPT stlref = "+stlref.toString());
			String rtinr = null;
			String sqll = "select max(inr) inr from cpd where stlref='"+stlref.toString()+"'";
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL(sqll);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","stlbod T2A CPT inr = "+inr.value);
			  if(MdaUtils.isEmpty(inr.value))
			  {
			    rtinr = inr.value;
			    cinr = inr.value;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();

			if(!MdaUtils.isEmpty(inr))
			{
			  IModule mod=MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClientid()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"cpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  cinr=Platform.sdbCounter("cpd");
			  this.getBusgrp().getCpdgrp().getRec().setInr(cinr);
			  this.getBusgrp().getCpdgrp().getRec().setDty("O");
			  this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("LP"));
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			}
			this.getBusgrp().getCpdgrp().getApl().getPts().setAdrblk(this.getBusgrp().getCpdgrp().getRec().getPaynam());
			this.getBusgrp().getCpdgrp().getBen().getPts().setAdrblk(this.getBusgrp().getCpdgrp().getRec().getPayeenameapp());
			if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getBen().getPts().getAdrblk()))
			{
			  this.getBusgrp().getCpdgrp().getBen().getPts().setAdrblk("临时名址");
			}
			this.getBusgrp().getCpdgrp().getBen().savRolPts(cinr,"cpd","ben");
			this.getBusgrp().getCpdgrp().getAcw().savRolPts(cinr,"cpd","acw");
			this.getBusgrp().getCpdgrp().getApl().savRolPts(cinr,"cpd","apl");

			this.setFrmcod("cptyub");
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇入汇款预通知");
		}
        /**
        *   source:stlbod.@0109.script
        */
        public void storeGitpush(String contractid,String inifrm)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getGitpush());

			this.getGitpush().setInr(Platform.sdbCounter("gitpush"));
			this.getGitpush().setContractid(contractid);
			this.getGitpush().setCredat(MdaUtils.today());
			this.getGitpush().setSta("W");
			this.getGitpush().setObjinr(this.getBusgrp().getGidgrp().getRec().getInr());
			this.getGitpush().setObjtyp("gid");
			this.getGitpush().setOwnref(this.getOwnref());
			this.getGitpush().setStlref(this.getStlref());
			this.getGitpush().setCnt(0);
			this.getGitpush().setMsgref(this.getBusgrp().getGidgrp().getSzgit().getMsgref());
			this.getGitpush().setTrans(inifrm);
			ctx.getDaoSession().dbInsert(this.getGitpush());
			log.debug("{}","HTICONTRACT:"+contractid +"  gitpush:"+this.getGitpush().getInr());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  log.error("{}","insert gitpush error: "+contractid + " ,ownref "+this.getOwnref());
			}
		}
        /**
        *   source:stlbod.@0110.script
        */
        public void storeGitpushSpt(String contractid)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getBusgrp().getGidgrp().getGitpush());

			this.getBusgrp().getGidgrp().getGitpush().setInr(Platform.sdbCounter("gitpush"));
			this.getBusgrp().getGidgrp().getGitpush().setContractid(contractid);
			this.getBusgrp().getGidgrp().getGitpush().setCredat(MdaUtils.today());
			this.getBusgrp().getGidgrp().getGitpush().setSta("D");
			this.getBusgrp().getGidgrp().getGitpush().setObjinr(this.getSpt().getInr());
			this.getBusgrp().getGidgrp().getGitpush().setObjtyp("spt");
			this.getBusgrp().getGidgrp().getGitpush().setOwnref(this.getOwnref());
			this.getBusgrp().getGidgrp().getGitpush().setStlref(this.getStlref());
			this.getBusgrp().getGidgrp().getGitpush().setCnt(0);
			this.getBusgrp().getGidgrp().getGitpush().setMsgref("");
			this.getBusgrp().getGidgrp().getGitpush().setTrans(this.getFrmcod());
			ctx.getDaoSession().dbInsert(this.getBusgrp().getGidgrp().getGitpush());
			log.debug("{}","HTICONTRACT:"+contractid +"  gitpush:"+this.getBusgrp().getGidgrp().getGitpush().getInr());
			if(ctx.getErrorCode()!= NO_ERROR)
			{
			  log.error("{}","insert gitpush error: "+contractid + " ,ownref "+this.getOwnref());
			}
		}
        /**
        *   source:stlbod.@0111.script
        */
        public void  parseSTLT2Z_CPI(Map<String,Object> data,Map<String,Object> resMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 解析 MTT2A_CPI-XML报文信息-汇入预通知
			  @ 返回解析是否成功
			  */

			this.setStlref(this.getBusgrp().getBusinf().getStlref());
			this.getBusgrp().getBusinf().setStlref( (String)data.get("cpdgrp\\rec\\dstlref"));
			String stlref=this.getBusgrp().getBusinf().getStlref();
			log.debug("{}","stlref is:    "+stlref);

			String cinr = null;

			String rtinr = null;
			String sqll = "select max(inr) inr from cpd where stlref='"+stlref.toString()+"'";
			ctx.getErrorCode();
			ctx.getDaoSession().dbExecuteSQL(sqll);
			Argument<String> inr = new Argument<String>("inr");
			ctx.getDaoSession().dbFetchFields(inr);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","stlbod T2A CPT inr = "+inr.value);
			  if(MdaUtils.isEmpty(inr.value))
			  {
			    rtinr = inr.value;
			    cinr = inr.value;
			  }
			}
			ctx.getDaoSession().dbCloseCursor();

			if(!MdaUtils.isEmpty(inr))
			{
			  IModule mod=MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec");
			  ctx.getDaoSession().dbRead(mod,new Argument<String>("inr",inr.value));
			  IModule mod1=MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rpd");
			  ctx.getDaoSession().dbRead(mod1,new Argument<String>("objinr",inr.value));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getBen().getPts(),new Argument("rol","ben"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getAcw().getPts(),new Argument("rol","acw"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getApl().getPts(),new Argument("rol","apl"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  ctx.getDaoSession().dbRead(this.getBusgrp().getCpdgrp().getPay().getPts(),new Argument("rol","pay"),new Argument("objtyp","cpd"),new Argument("objinr",inr));
			  setModuleContent(data);
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			  ctx.getDaoSession().dbUpdate(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rpd"));
			}
			else if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClientid()))
			{
			  setModuleContent(data);
			  IDatafield ptyinr=MdaDriver.getDatafield(this.getBusgrp(),"cpdgrp\\rec\\ptyinr");
			  ptyinr.setValue(this.getBusgrp().getBusinf().getCliinr());
			  if(!MdaUtils.isEmpty(this.getBusgrp().getBusinf().getClietyinr()))
			    this.getBusgrp().getCpdgrp().getRec().setEtyinr(this.getBusgrp().getBusinf().getClietyinr());
			  cinr=Platform.sdbCounter("cpd");
			  this.getBusgrp().getCpdgrp().getRec().setInr(cinr);
			  this.getBusgrp().getCpdgrp().getRec().setDty("O");
			  this.getBusgrp().getCpdgrp().getRec().setOwnref(Platform.getRef("LP"));
			  this.getBusgrp().getCpdgrp().getRec().setStlref(this.getBusgrp().getBusinf().getStlref());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getBchcod()))
			    this.getBusgrp().getCpdgrp().getRec().setBchcod(this.getBusgrp().getBusinf().getBchcod());
			  this.getBusgrp().getCpdgrp().getRec().setAdvdat(MdaUtils.today());
			  if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getRec().getOpndat()))
			    this.getBusgrp().getCpdgrp().getRec().setOpndat(MdaUtils.today());
			  this.getBusgrp().getCpdgrp().getPay().getPts().setExtkey("EVERCNBJXXX");
			  this.getBusgrp().getCpdgrp().getRec().setKjhkflg("Z");
			  String  rinr=Platform.sdbCounter("rpd");
			  this.getBusgrp().getCpdgrp().getRpd().setInr(rinr);
			  this.getBusgrp().getCpdgrp().getRpd().setObjtyp("cpd");
			  this.getBusgrp().getCpdgrp().getRpd().setObjinr(cinr);
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rec"));
			  ctx.absGet(com.ceb.gjjs.mda.manager.module.Sysmod.class).sdbInsert(MdaDriver.getModule(this.getBusgrp(),"cpdgrp\\rpd"));
			}
			this.getBusgrp().getCpdgrp().getApl().getPts().setAdrblk(this.getBusgrp().getCpdgrp().getRec().getPaynam());
			this.getBusgrp().getCpdgrp().getBen().getPts().setAdrblk(this.getBusgrp().getCpdgrp().getRec().getPayeenameapp());
			if(MdaUtils.isEmpty(this.getBusgrp().getCpdgrp().getBen().getPts().getAdrblk()))
			{
			  this.getBusgrp().getCpdgrp().getBen().getPts().setAdrblk("临时名址");
			}
			this.getBusgrp().getCpdgrp().getBen().savRolPts(cinr,"cpd","ben");
			this.getBusgrp().getCpdgrp().getAcw().savRolPts(cinr,"cpd","acw");
			this.getBusgrp().getCpdgrp().getApl().savRolPts(cinr,"cpd","apl");

			this.setFrmcod("cptyub");
			this.setOwnref(this.getBusgrp().getCpdgrp().getRec().getOwnref());
			setBusinfFromStlbod(this.getBusgrp().getCpdgrp().getRec().getInr(),"cpd",this.getOwnref(),"汇入汇款预通知");
		}

        public void setBusgrpHolder(ModuleHolder<Busgrp> busgrp)
        {
           this.busgrp = busgrp;
        }

        public Busgrp getBusgrp()
        {
           return this.busgrp.get();
        }

        public void setPtysetHolder(ModuleHolder<Ptyset> ptyset)
        {
           this.ptyset = ptyset;
        }

        public Ptyset getPtyset()
        {
           return this.ptyset.get();
        }

        public void setTrnHolder(ModuleHolder<Trn> trn)
        {
           this.trn = trn;
        }

        public Trn getTrn()
        {
           return this.trn.get();
        }

        public void setSmhHolder(ModuleHolder<Smh> smh)
        {
           this.smh = smh;
        }

        public Smh getSmh()
        {
           return this.smh.get();
        }

        public void setSptHolder(ModuleHolder<Spt> spt)
        {
           this.spt = spt;
        }

        public Spt getSpt()
        {
           return this.spt.get();
        }

        public void setWfsHolder(ModuleHolder<Wfs> wfs)
        {
           this.wfs = wfs;
        }

        public Wfs getWfs()
        {
           return this.wfs.get();
        }

        public void setWfeHolder(ModuleHolder<Wfe> wfe)
        {
           this.wfe = wfe;
        }

        public Wfe getWfe()
        {
           return this.wfe.get();
        }

        public void setApltrnHolder(ModuleHolder<Trn> apltrn)
        {
           this.apltrn = apltrn;
        }

        public Trn getApltrn()
        {
           return this.apltrn.get();
        }

























}